--# -path=.:../romance:../common:../abstract:../../prelude

concrete LexiconSpa of Lexicon = CatSpa ** open 
  (M=MorphoSpa), ParadigmsSpa, BeschSpa in {

flags 
  optimize=values ;

lin
   airplane_N = regN "aeroplano" ;	-- avin  is masculine
   answer_V2S = mkV2S (regV "responder") dative ;
   apartment_N = regN "apartamento" ;
   apple_N = regN "manzana" ;
   art_N = regN "arte" ;	
   ask_V2Q = mkV2Q (regV "preguntar") dative ;
   baby_N = regN "beb" ;		-- can be used for both fem. & masc.
   bad_A = prefA (mkADeg (regA "malo") (regA "peor")) ;
   bank_N = regN "banco" ;
   beautiful_A = prefA (regADeg "bello") ;	-- bella
   become_VA = reflV (regV "convertir") ;  --- convertirse en, volverse, ponerse
   beer_N = regN "cerveza" ;
   beg_V2V = mkV2V (regV "rogar") accusative dative ;   -- pedir
   big_A = prefA (regADeg "grande") ;
   bike_N = regN "bicicleta" ;
   bird_N = regN "pjaro" ;
   black_A = regADeg "negro" ;	-- negra
   blue_A = regADeg "azul" ;
   boat_N = regN "bote" ;
   book_N = regN "libro" ;
   boot_N = regN "bota" ;
   boss_N = regN "jefe" ;
   boy_N = regN "nio" ;
   bread_N = regN "pan" ;
   break_V2 = dirV2 (special_ppV (regV "romper") "roto") ;
   broad_A = regADeg "ancho" ;
   brother_N2 = deN2 (regN "hermano") ;
   brown_A = regADeg "marrn" ; --- *
   butter_N = regN "manteca" ;
   buy_V2 = dirV2 (regV "comprar") ;
   camera_N = regN "cmara" ; -- ["mquina fotogrfica"]
   cap_N = regN "gorra" ;
   car_N = regN "auto" ;
   carpet_N = regN "alfombra" ;
   cat_N = regN "gato" ;		-- gata
   ceiling_N = regN "techo" ;
   chair_N = regN "silla" ;
   cheese_N = regN "queso" ;
   child_N = regN "nio" ;		-- nia
   church_N = regN "iglesia" ;
   city_N = femN (regN "ciudad") ;		-- fem
   clean_A = regADeg "limpio" ;
   clever_A = regADeg "inteligente" ;
   close_V2 = dirV2 (regV "cerrar") ;
   coat_N = regN "abrigo" ;
   cold_A = regADeg "fro" ;		-- fra
   come_V = verboV (venir_82 "venir") ;
   computer_N = regN "computadora" ;		-- also computador, ordenador in Spain
   country_N = regN "pas" ;		-- masc
   cousin_N = regN "primo" ;
   cow_N = regN "vaca" ;
   die_V = verboV (morir_35b "morir") ;
   dirty_A = regADeg "sucio" ;
   distance_N3 = mkN3 (regN "distancia") genitive dative ;
   doctor_N = regN "mdico" ;		-- mdica
   dog_N = regN "perro" ;		-- perra
   door_N = regN "puerta" ;
   drink_V2 = dirV2 (regV "tomar") ;     -- beber
   easy_A2V = mkA2V (regA "fcil") dative genitive ;
   eat_V2 = dirV2 (regV "comer") ;
   empty_A = regADeg "vaco" ;
   enemy_N = regN "enemigo" ;		-- enemiga
   factory_N = regN "fbrica" ;	
   father_N2 = deN2 (regN "padre") ;
   fear_VS = mkVS (regV "temer") ;
   find_V2 = dirV2 (verboV (encontrar_38 "encontrar")) ;
   fish_N = mascN (regN "pez") ;
   floor_N = regN "suelo" ;		-- piso
   forget_V2 = dirV2 (regV "olvidar") ;
   fridge_N = regN "heladera" ;
   friend_N = regN "amigo" ;		-- amiga
   fruit_N = regN "fruta" ;
   fun_AV = mkAV (regA "divertido") genitive ;		-- entretenido
   garden_N = regN "jardn" ;
   girl_N = regN "nia" ;
   glove_N = regN "guante" ;
   gold_N = regN "oro" ;
   good_A = prefA (mkADeg (regA "bueno") (regA "mejor")) ; ---- adv?
   go_V = (verboV (ir_46 "ir")) ;
   green_A = regADeg "verde" ;
   harbour_N = regN "puerto" ;
   hate_V2 = dirV2 (regV "odiar") ;
   hat_N = regN "sombrero" ;
   have_V2 = dirV2 (verboV (tener_4 "tener")) ;
   hear_V2 = mkV2 (regV "escuchar") dative ; -- or_51 
   hill_N = regN "colina" ;
   hope_VS = mkVS (regV "esperar") ;
   horse_N = regN "caballo" ;
   hot_A = regADeg "caliente" ;
   house_N = regN "casa" ;
   important_A = regADeg "importante" ;
   industry_N = regN "industria" ;
   iron_N = regN "fierro" ;
   king_N = regN "rey" ;
   know_V2 = dirV2 (verboV (saber_71 "saber")) ; --   conocer
   lake_N = regN "lago" ;
   lamp_N = regN "lmpara" ;
   learn_V2 = dirV2 (regV "aprender") ;
   leather_N = regN "cuero" ;
   leave_V2 = dirV2 (regV "partir") ;	-- irse, dejar
   like_V2 = dirV2 (regV "gustar") ;
   listen_V2 = dirV2 (regV "escuchar") ;
   live_V = verboV (vivir_7 "vivir") ;
   long_A = regADeg "largo" ;
   lose_V2 = dirV2 (verboV (defender_29 "perder")) ;
   love_N = regN "amor" ;
   love_V2 = dirV2 (regV "amar") ;
   man_N = regN "hombre" ;		-- masc
   married_A2 = mkA2 (regA "casado") dative ;
   meat_N = femN (regN "carne") ;
   milk_N = femN (regN "leche") ;
   moon_N = regN "luna" ;
   mother_N2 = deN2 (femN (regN "madre")) ;	-- fem
   mountain_N = regN "montaa" ;
   music_N = regN "msica" ;
   narrow_A = regADeg "estrecho" ;
   new_A = prefA (regADeg "nuevo") ;
   newspaper_N = regN "peridico" ;		-- diario  
   oil_N = regN "aceite" ;
   old_A =  prefA (regADeg "viejo") ;
   open_V2 = dirV2 (special_ppV (regV "abrir") "abierto") ;
   paint_V2A = mkV2A (regV "pintar") accusative (mkPrep "en") ;
   paper_N = regN "papel" ;
   paris_PN = mkPN "Paris" masculine ;
   peace_N = femN (regN "paz") ;
   pen_N = regN "lapicera" ;
   planet_N = mascN (regN "planeta") ;
   plastic_N = regN "plstico" ;
   play_V2 = dirV2 (verboV (jugar_47 "jugar")) ;
   policeman_N = mascN (regN "polica") ;	-- fem refers to the institution
   priest_N = mascN (regN "cura") ;		-- masc
   probable_AS = mkAS (regA "probable") ;	
   queen_N = regN "reina" ;
   radio_N = femN (regN "radio") ;
   rain_V0 = mkV0 (verboV (llover_89 "llover")) ;
   read_V2 = dirV2 (verboV (creer_26 "leer")) ;
   red_A = regADeg "rojo" ;
   religion_N = mkN "religin" "religiones" feminine ;
   restaurant_N = regN "restaurante" ;		-- restorn, restaurn, masc
   river_N = regN "ro" ;
   rock_N = regN "roca" ;
   roof_N = regN "techo" ;
   rubber_N = regN "goma" ;
   run_V = regV "correr" ;
   say_VS = mkVS (verboV (decir_28 "decir")) ;
   school_N = regN "escuela" ;
   science_N = regN "ciencia" ;
   sea_N = regN "mar" ;			-- masc & fem 
   seek_V2 = dirV2 (regV "buscar") ;
   see_V2 = dirV2 (verboV (ver_83 "ver")) ;
   sell_V3 = dirV3 (regV "vender") dative ;
   send_V3 = dirV3 (regV "mandar") dative ;
   sheep_N = regN "oveja" ;
   ship_N = femN (regN "nave") ;
   shirt_N = regN "camisa" ;
   shoe_N = regN "zapato" ;
   shop_N = regN "negocio" ;
   short_A = regADeg "corto" ; --- breve
   silver_N = regN "plata" ;
   sister_N = regN "hermana" ;
   sleep_V = verboV (dormir_35 "dormir") ;
   small_A = prefA (regADeg "pequeo") ;
   snake_N = femN (regN "serpiente") ;		-- fem
   sock_N = regN "media" ;
   speak_V2 = dirV2 (regV "hablar") ;
   star_N = regN "estrella" ;
   steel_N = regN "acero" ;
   stone_N = regN "piedra" ;
   stove_N = regN "horno" ;		-- estufa
   student_N = regN "estudiante" ;	-- used both for fem & masc
   stupid_A = regADeg "estpido" ;
   sun_N = regN "sol" ;	
   switch8off_V2 = dirV2 (regV "apagar") ;
   switch8on_V2 = dirV2 (regV "prender") ;
   table_N = regN "mesa" ; 
   talk_V3 = mkV3 (regV "hablar") dative genitive ;
   teacher_N = regN "maestro" ;		-- maestra
   teach_V2 = dirV2 (regV "ensear") ;
   television_N = mkN "televisin" "televisiones" feminine ;	-- televisor masc
   thick_A = regADeg "grueso" ;
   thin_A = regADeg "fino" ;			-- delgado
   train_N = regN "tren" ;
   travel_V = regV "viajar" ;
   tree_N = regN "rbol" ;
  --- trousers_N = regN "pantaln" ;	-- masc
   ugly_A = regADeg "feo" ;
   understand_V2 = dirV2 (regV "entender") ;
   university_N = femN (regN "universidad") ;
   village_N = regN "pueblo" ;
   wait_V2 = mkV2 (regV "esperar") dative ;
   walk_V = regV "caminar" ;
   warm_A = regADeg "tibio" ;
   war_N = regN "guerra" ;
   watch_V2 = dirV2 (regV "mirar") ;		-- ver
   water_N = mascN (regN "agua") ;
   white_A = compADeg (regA "blanco") ;
   window_N = regN "ventana" ;
   wine_N = regN "vino" ;
   win_V2 = dirV2 (regV "ganar") ;
   woman_N = femN (regN "mujer") ;
   wonder_VQ = mkVQ (reflV (regV "preguntar")) ;
   wood_N = regN "madera" ;
   write_V2 = dirV2 (special_ppV (regV "escribir") "escrito") ;
   yellow_A = regADeg "amarillo" ;
   young_A = prefA (regADeg "joven") ;

   do_V2 =  dirV2 (verboV (hacer_44 "hacer")) ;
   now_Adv = mkAdv "ahora" ;
   already_Adv = mkAdv "ya" ;
   song_N = mkN "cancin" "canciones" feminine ;
   add_V3 = dirV3 (regV "sumar") dative ;
   number_N = regN "nmero" ;
   put_V2 = dirV2 (verboV (poner_60 "poner")) ;
   stop_V = regV "parar" ; 
   jump_V = regV "saltar" ;

  left_Ord = M.mkOrd (regA "izquierda") ;
  right_Ord = M.mkOrd (regA "derecha") ;
  far_Adv = mkAdv "lejos" ; ----?
   correct_A = regA "correcto" ;
   dry_A = regA "seco" ;
   dull_A = regA "desafilado" ;
   full_A = regA "lleno" ;
   heavy_A = regA "pesado" ;
   near_A = regA "cerca" ;
   rotten_A = regA "podrido" ;
   round_A = regA "redondo" ;
   sharp_A = regA "filoso" ; -- afilado, puntiagudo
   smooth_A = regA "liso" ;     -- suave
   straight_A = regA "directo" ;
   wet_A = regA "mojado" ;
   wide_A = regA "ancho" ;      -- extenso
   animal_N = regN "animal" ;           -- masc (sometimes fem when adj)
   ashes_N = regN "ceniza" ;
   back_N = regN "espalda" ;
   bark_N = regN "corteza" ;
   belly_N = regN "panza" ;             -- barriga
   blood_N = femN (regN "sangre") ;
   bone_N = regN "hueso" ;
   breast_N = regN "seno" ;             -- pecho
   cloud_N = femN (regN "nube") ;
   day_N = mascN (regN "da") ;
   dust_N = regN "polvo" ;
   ear_N = regN "oreja" ;
   earth_N = regN "tierra" ;
   egg_N = regN "huevo" ;
   eye_N = regN "ojo" ;
   fat_N = regN "grasa" ;
   feather_N = regN "pluma" ;
   fingernail_N = regN "ua" ;
   fire_N = regN "fuego" ;
   flower_N = femN (regN "flor") ;
   fog_N = regN "niebla" ;
   foot_N = regN "pie" ;
   forest_N = regN "bosque" ;
   grass_N = regN "pasto" ;             -- hierba, csped (masc)
   guts_N = regN "tripa" ;              -- gut=intestino ---- pl.t. tripas
   hair_N = regN "cabello" ;            -- pelo
   hand_N = femN (regN "mano") ;
   head_N = regN "cabeza" ;
   heart_N = mkN "corazn" "corazones" masculine ;
   horn_N = regN "cuerno" ;
   husband_N = regN "marido" ;  -- esposo
   ice_N = regN "hielo" ;
   knee_N = regN "rodilla" ;
   leaf_N = regN "hoja" ;
   leg_N = regN "pierna" ;
   liver_N = regN "hgado" ;
   louse_N = regN "piojo" ;
   mouth_N = regN "boca" ;
   name_N = regN "nombre" ;
   neck_N = regN "cuello" ;
   night_N = femN (regN "noche") ;
   nose_N = femN (regN "nariz") ;
   person_N = regN "persona" ;
   rain_N = regN "lluvia" ;
   road_N = femN (regN "calle") ;               -- camino
   root_N = femN (regN "raz") ;
   rope_N = regN "cuerda" ;
   salt_N = femN (regN "sal") ;
   sand_N = regN "arena" ;
   seed_N = regN "semilla" ;
   skin_N = femN (regN "piel") ;        -- fem
   sky_N = regN "cielo" ;
   smoke_N = regN "humo" ;
   snow_N = femN (regN "nieve") ;       -- fem
   stick_N = mkN "bastn" "bastones" masculine ;                -- palo
   tail_N = regN "cola" ;
   tongue_N = regN "lengua" ;
   tooth_N = regN "diente" ;
   wife_N = regN "esposa" ;
   wind_N = regN "viento" ;
   wing_N = regN "ala" ;
   worm_N = regN "gusano" ;             -- lombriz (fem)
   year_N = regN "ao" ;
  bite_V2 = dirV2 (verboV (morder_50b "morder")) ;
   blow_V = regV "soplar" ;
   burn_V = regV "quemar" ;
  count_V2 = dirV2 (verboV (contar_38b "contar")) ;
  cut_V2 = dirV2 (regV "cortar") ;
   dig_V = regV "escarbar" ;
   fall_V = verboV (caer_20 "caer") ;
  fear_V2 = dirV2 (regV "temer") ;
  fight_V2 = dirV2 (regV "pelear") ;
   float_V = regV "flotar" ;
   flow_V = verboV (influir_45 "fluir") ;             -- circular
   fly_V = regV "volar" ;
   freeze_V = regV "congelar" ;
   give_V3 = dirdirV3 (verboV (dar_27 "dar")) ;
  hit_V2 = dirV2 (regV "golpear") ;
  hold_V2 = dirV2 (verboV (tener_4 "tener")) ;
  hunt_V2 = dirV2 (regV "cazar") ;
  kill_V2 = dirV2 (regV "matar") ;
   laugh_V = regV "reir" ; ----V rer_67
   lie_V = reflV (regV "acostar") ; --  "acostarse"
   play_V = regV "jugar" ;
  pull_V2 = dirV2 (regV "tirar") ;
  push_V2 = dirV2 (regV "empujar") ;
  rub_V2 = dirV2 (regV "resfregar") ;
  scratch_V2 = dirV2 (regV "rascar") ;
   sew_V = regV "coser" ;
   sing_V = regV "cantar" ;
   sit_V = reflV (regV "sentar") ;
  smell_V = verboV (oler_52 "oler") ;
   spit_V = regV "escupir" ;
  split_V2 = dirV2 (regV "separar") ; -- dividir,) ;
  squeeze_V2 = dirV2 (regV "exprimir") ;
  stab_V2 = dirV2 (regV "apualar") ;
   stand_V = verboV (estar_2 "estar") ; ---- "estar de pie" ;
  suck_V2 = dirV2 (regV "chupar") ;
   swell_V = regV "tragar" ;
   swim_V = regV "nadar" ;
   think_V = regV "pensar" ;
  throw_V2 = dirV2 (regV "tirar") ;
  tie_V2 = dirV2 (regV "atar") ;
   turn_V = regV "doblar" ;
   vomit_V = regV "vomitar" ;
  wash_V2 = dirV2 (regV "lavar") ;
  wipe_V2 = dirV2 (regV "secar") ;
    breathe_V = (regV "respirar") ;

  john_PN = mkPN "Juan" masculine ;
  today_Adv = mkAdv "hoy" ;

  grammar_N = regN "gramtica" ;
  language_N = regN "lengua" ;
  rule_N = regN "regla" ;


} ;
