--# -path=.:../scandinavian:../common:../abstract:../../prelude

concrete LexiconSwe of Lexicon = CatSwe ** 
  open Prelude, ParadigmsSwe, IrregSwe in {

flags 
  optimize=values ;

lin
  airplane_N = regGenN "flygplan" neutrum ;
  answer_V2S = mkV2S (regV "svarar") (mkPrep "till") ;
  apartment_N = mk2N "lgenhet" "lgenheter" ;
  apple_N = regGenN "pple" neutrum ;
  art_N = mk2N "konst" "konster" ;
  ask_V2Q = mkV2Q (regV "frgar") noPrep ;
  baby_N = regGenN "bebis" utrum ;
  bad_A = irregA "dlig" "smre" "smst";
  bank_N = mk2N "bank" "banker" ;
  beautiful_A = mk3A "vacker" "vackert" "vackra" ;
  become_VA = mkVA (mkV "bli" "blir""bli" "blev" "blivit" "bliven") ;
  beer_N = regGenN "l" neutrum ;
  beg_V2V = mkV2V (mkV "be" "ber""be" "bad" "bett" "bedd") noPrep (mkPrep "att") ;
  big_A = irregA "stor" "strre" "strst";
  bike_N = mk2N "cykel" "cyklar" ;
  bird_N = mk2N "fgel" "fglar" ;
  black_A = mk2A "svart" "svart" ;
  blue_A = mk2A "bl" "bltt";
  boat_N = regGenN "bt" utrum ;
  book_N = mkN "bok" "boken" "bcker" "bckerna" ;
  boot_N = mk2N "stvel" "stvlar" ;
  boss_N = mk2N "chef" "chefer" ;
  boy_N = regGenN "pojke" utrum ;
  bread_N = regGenN "brd" neutrum ;
  break_V2 = dirV2 (partV (mkV "sl" "slr" "sl" "slog" "slagit" "slagen") "snder") ;
  broad_A = mk2A "bred" "brett" ;
  brother_N2 = mkN2 ((mkN "bror" "brodern" "brder" "brderna")) (mkPrep "till") ;
  brown_A = regA "brun" ;
  butter_N = regGenN "smr" neutrum ;
  buy_V2 = dirV2 (mk2V "kpa" "kpte") ;
  camera_N = regGenN "kamera" utrum ;
  cap_N = regGenN "mssa" utrum ;
  car_N = regGenN "bil" utrum ;
  carpet_N = regGenN "matta" utrum ;
  cat_N = mk2N "katt" "katter" ;
  ceiling_N = regGenN "tak" neutrum ;
  chair_N = regGenN "stol" utrum ;
  cheese_N = regGenN "ost" utrum ;
  child_N = regGenN "barn" neutrum ;
  church_N = regGenN "kyrka" utrum ;
  city_N = mkN "stad" "staden" "stder" "stderna" ;
  clean_A = regA "ren" ;
  clever_A = regA "klok" ;
  close_V2 = dirV2 (mk2V "stnga" "stngde") ;
  coat_N = regGenN "rock" utrum ;
  cold_A = regA "kall" ;
  come_V = komma_V ;
  computer_N = mk2N "dator" "datorer" ;
  country_N = mkN "land" "landet" "lnder" "lnderna" ;
  cousin_N = mk2N "kusin" "kusiner" ;
  cow_N = mk2N "ko" "kor" ;
  die_V = (mkV "d" "dr" "d" "dog" "dtt" "ddd") ; ----
  distance_N3 = mkN3 (mk2N "avstnd" "avstnd") (mkPrep "frn") (mkPrep "till") ;
  dirty_A = regA "smutsig" ;
  doctor_N = mk2N "lkare" "lkare" ;
  dog_N = regGenN "hund" utrum ;
  door_N = regGenN "drr" utrum ;
  drink_V2 = dirV2 (irregV "dricka" "drack" "druckit") ;
  easy_A2V = mkA2V (mk2A "ltt" "ltt") (mkPrep "fr") ;
  eat_V2 = dirV2 (irregV "ta" "t" "tit") ;
  empty_A = mkA "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ;
  enemy_N = regGenN "fiende" neutrum ;
  factory_N = mk2N "fabrik" "fabriker" ;
  father_N2 = mkN2 ((mkN "far" "fadern" "fder" "fderna")) (mkPrep "till") ;
  fear_VS = mkVS (regV "fruktar") ;
  find_V2 = dirV2 (irregV "finna" "fann" "funnit") ;
  fish_N = mk2N "fisk" "fiskar" ;
  floor_N = regGenN "golv" neutrum ;
  forget_V2 = dirV2 (mkV "glmma" "glmmer" "glm" "glmde" "glmt" "glmd") ;
  fridge_N = regGenN "kylskp" neutrum ;
  friend_N = mkN "vn" "vnnen" "vnner" "vnnerna" ;
  fruit_N = mk2N "frukt" "frukter" ;
  fun_AV = mkAV (regA "rolig") ;
  garden_N = regGenN "trdgrd" utrum ;
  girl_N = regGenN "flicka" utrum ;
  glove_N = regGenN "handske" utrum ;
  gold_N = regGenN "guld" neutrum ;
  good_A = mkA "god" "gott" "goda" "goda" "bttre" "bst" "bsta" ;
  go_V = (mkV "g" "gr" "g" "gick" "gtt" "gngen") ;
  green_A = regA "grn" ;
  harbour_N = regGenN "hamn" utrum;
  hate_V2 = dirV2 (regV "hatar") ;
  hat_N = regGenN "hatt" utrum ;
  hear_V2 = dirV2 (mkV "hra" "hr" "hr" "hrde" "hrt" "hrd") ;
  hill_N = regGenN "kulle" utrum ;
--  hope_VS = mkVS ((regV "nskar")) ;
  hope_VS = mkVS (depV (regV "hoppar")) ;
  horse_N = regGenN "hst" utrum ;
  hot_A = regA "het" ;
  house_N = regGenN "hus" neutrum ;
  important_A = regA "viktig" ;
  industry_N = mk2N "industri" "industrier" ; ---- "ien" ??
  iron_N = regGenN "jrn" neutrum ;
  king_N = (regGenN "kung" utrum) ;
  know_V2 = mkV2 (mkV "knner") ;
  know_VS = mkVS (mkV "veta" "vet" "vet" "visste" "vetat" "visst") ;
  lake_N = mkN "sj" "sjn" "sjar" "sjarna" ;
  lamp_N = regGenN "lampa" utrum;
  learn_V2 = dirV2 (reflV (mkV "lra" "lr" "lr" "lrde" "lrt" "lrd")) ;
  leather_N = mkN "lder" "ldret" "lder" "ldren" ;
  leave_V2 = dirV2 (regV "lmnar") ;
  like_V2 = mkV2 (mk2V "tycka" "tyckte") (mkPrep "om") ;
  listen_V2 = mkV2 (regV "lyssnar") (mkPrep "p") ;
  live_V = (irregV "leva" "levde" "levt") ; ---- ?
  long_A = irregA "lng" "lngre" "lngst" ;
  lose_V2 = dirV2 (regV "frlora") ;
  love_N = regGenN "krlek" utrum ;
  love_V2 = dirV2 (regV "lska") ;
  man_N = (mkN "man" "mannen" "mn" "mnnen") ;
  married_A2 = mkA2 (mk2A "gift" "gift") (mkPrep "med") ;
  meat_N = regGenN "ktt" neutrum ;
  milk_N = regGenN "mjlk" utrum ; ---- -ar?
  moon_N = regGenN "mne" utrum ;
  mother_N2 = mkN2 (mkN "mor" "modern" "mdrar" "mdrarna") (mkPrep "till") ;
  mountain_N = regGenN "berg" neutrum ;
  music_N = mk2N "musik" "musiker" ; ---- er ?
  narrow_A = regA "smal" ;
  new_A = mkA "ny" "nytt" "nya" "nya" "nyare" "nyast" "nyaste" ;
  newspaper_N = regGenN "tidning" utrum ;
  oil_N = regGenN "olja" utrum ;
  old_A = mkA "gammal" "gammalt" "gamla" "gamla" "ldre" "ldst" "ldsta" ;
  open_V2 = dirV2 (regV "ppna") ;
  paint_V2A = mkV2A (regV "mla") noPrep ;
  paper_N = mkN "papper" "pappret" "papper" "pappren" ;
  paris_PN = regGenPN "Paris" neutrum ;
  peace_N = regGenN "fred" utrum ; ---- ar?
  pen_N = regGenN "penna" utrum ;
  planet_N = mk2N "planet" "planeter" ;
  plastic_N = mk2N "plast" "plaster" ;
  play_V2 = dirV2 (regV "spela") ;
  policeman_N = mk2N "polis" "poliser" ;
  priest_N = mk2N "prst" "prster" ;
  probable_AS = mkAS (regA "sannolik") ;
  queen_N = regGenN "drottning" utrum ;
  radio_N = mkN "radio" "radion" "radioapparater" "radioapparaterna" ; -- SAOL
  rain_V0 = mkV0 (regV "regna") ;
  read_V2 = dirV2 (mk2V "lsa" "lste") ;
  red_A = mk2A "rd" "rtt" ;
  religion_N = mk2N "religion" "religioner" ;
  restaurant_N = mk2N "restaurang" "restauranger" ;
  river_N = mkN "" "n" "ar" "arna" ;
  rock_N = mkN "sten" "stenen" "stenar" "stenarna" ;
  roof_N = regGenN "tak" neutrum ;
  rubber_N = mkN "gummi" "gummit" "gummin" "gummina" ;
  run_V = (irregV "springa" "sprang" "sprungit") ;
  say_VS = mkVS (mkV "sga" "sger" "sg" "sade" "sagt" "sagd") ;
  school_N = regGenN "skola" utrum;
  science_N = mk2N "vetenskap" "vetenskaper" ;
  sea_N = mkN "hav" "hav" ;
  seek_V2 = dirV2 (mk2V "ska" "skte") ;
  see_V2 = dirV2 (mkV "se" "ser" "se" "sg" "sett" "sedd") ;
  sell_V3 = dirV3 (irregV "slja" "slde" "slt") (mkPrep "till") ;
  send_V3 = dirV3 (regV "skicka") (mkPrep "till") ;
  sheep_N = mk2N "fr" "fr" ;
  ship_N = regGenN "skepp" neutrum ;
  shirt_N = regGenN "skjorta" utrum ;
  shoe_N = mk2N "sko" "skor" ;
  shop_N = mk2N "affr" "affren" ;
  short_A = regA "kort" ;
  silver_N = mkN "silver" "silvret" "silver" "silvren" ;
  sister_N = mk2N "syster" "systrar" ;
  sleep_V = (irregV "sova" "sov" "sovit") ;
  small_A = mkA "liten" "litet" "lilla" "sm" "mindre" "minst" "minsta" ;
  snake_N = regGenN "orm" utrum ;
  sock_N = regGenN "strumpa" utrum ;
  speak_V2 = dirV2 (regV "tala") ;
  star_N = regGenN "stjrna" utrum ;
  steel_N = regGenN "stl" utrum ;
  stone_N = mkN "sten" "stenen" "stenar" "stenarna" ;
  stove_N = regGenN "spis" utrum ;
  student_N = mk2N "student" "studenter" ;
  stupid_A = mk3A "dum" "dumt" "dumma" ;
  sun_N = regGenN "sol" utrum ;
  switch8off_V2 = dirV2 (partV (irregV "stnga" "stngde" "stngt") "av") ;
  switch8on_V2 = dirV2 (partV (irregV "sl" "slog" "slagit") "p") ;
  table_N = regGenN "bord" neutrum ;
  talk_V3 = mkV3 (regV "prata") (mkPrep "till") (mkPrep "om") ;
  teacher_N = mk2N "lrare" "lrare" ;
  teach_V2 = dirV2 (regV "undervisa") ;
  television_N = mk2N "television" "televisioner" ;
  thick_A = regA "tjock" ;
  thin_A = mk2A "tunn" "tunt" ;
  train_N = regGenN "tg" neutrum ;
  travel_V = mk2V "resa" "reste" ;
  tree_N = regGenN "trd" neutrum ;
  ----  trousers_N = regGenN "trousers" ; ---- pl t !
  ugly_A = regA "ful" ;
  understand_V2 = dirV2 (mkV "frst" "frstr" "frst" "frstod" "frsttt" "frstdd") ;
  university_N = regGenN "universitet" neutrum ;
  village_N = mkN "by" "byn" "byar" "byarna" ;
  wait_V2 = mkV2 (regV "vnta") (mkPrep "p") ;
  walk_V = (mkV "g" "gr" "g" "gick" "gtt" "gngen") ;
  warm_A = regA "varm" ;
  war_N = regGenN "krig" neutrum ;
  watch_V2 = mkV2 (regV "titta") (mkPrep "p") ;
  water_N = mkN "vatten" "vattnet" "vatten" "vattnen" ;
  white_A = regA "vit" ;
  window_N = mkN "fnster" "fnstret" "fnster" "fnstren" ;
  wine_N = mkN "vin" "vinet" "viner" "vinerna" ; ----
  win_V2 = dirV2 (irregV "vinna" "vann" "vunnit") ;
  woman_N = regGenN "kvinna" utrum ;
  wonder_VQ = mkVQ (regV "undra") ;
  wood_N = mkN "tr" "tret" "tren" "trena" ; ---- ?
  write_V2 = dirV2 (irregV "skriva" "skrev" "skrivit") ;
  yellow_A = regA "gul" ;
  young_A = irregA "ung" "yngre" "yngst" ;

  do_V2 = dirV2 gra_V ;
  now_Adv = mkAdv "nu" ;
  already_Adv = mkAdv "redan" ;
  song_N = mk2N "sng" "snger" ;
  add_V3 = mkV3 (partV (irregV "lgga" "lade" "lagt") "till") noPrep (mkPrep "till") ;
  number_N = mkN "nummer" "numret" "numren" "numren" ;
  put_V2 = mkV2 (mkV "stta" "stter" "stt" "satte" "satt" "satt") noPrep ;
  stop_V = regV "stanna" ;
  jump_V = regV "hoppa" ;

  left_Ord = {s = "vnstra" ; isDet = True} ;
  right_Ord = {s = "hgra" ; isDet = True} ;
  far_Adv = mkAdv "lngt" ;
  correct_A = regA "riktig" ;
  dry_A = regA "torr" ;
  dull_A = mk2A "sl" "sltt";
  full_A = regA "full" ;
  heavy_A = irregA "tung" "tyngre" "tyngst" ;
  near_A = mkA "nra" "nra" "nra" "nra" "nrmare" "nrmast" "nrmaste" ;
  rotten_A = mk3A "rutten" "ruttet" "ruttna" ;
  round_A = regA "rund" ;
  sharp_A = regA "vass" ;
  smooth_A = regA "slt" ;
  straight_A = regA "rak" ;
  wet_A = regA "vt" ;
  wide_A = mk2A "bred" "brett" ;
  animal_N = mk2N "djur" "djur" ;
  ashes_N = mk2N "aska" "askor" ;
  back_N = mk2N "rygg" "ryggar" ;
  bark_N = mk2N "bark" "barkar" ;
  belly_N = mk2N "mage" "magar" ;
  blood_N = mk2N "blod" "blod" ;
  bone_N = mk2N "ben" "ben" ;
  breast_N = mk2N "brst" "brst" ;
  cloud_N = mk2N "moln" "moln" ;
  day_N = mk2N "dag" "dagar" ;
  dust_N = mk2N "damm" "damm" ;
  ear_N = mkN "ra" "rat" "ron" "ronen" ;
  earth_N = mk2N "jord" "jordar" ;
  egg_N = mk2N "gg" "gg" ;
  eye_N = mkN "ga" "gat" "gon" "gonen" ;
  fat_N = mk2N "fett" "fett" ;
  feather_N = mk2N "fjder" "fjdrar" ;
  fingernail_N = mkN "nagel" "nageln" "naglar" "naglarna";
  fire_N = mk2N "eld" "eldar" ;
  flower_N = mk2N "blomma" "blommor" ;
  fog_N = mk2N "dimma" "dimmor" ;
  foot_N = mk2N "fot" "ftter" ;
  forest_N = mk2N "skog" "skogar" ;
  grass_N = mk2N "grs" "grs" ;
  guts_N = mk2N "inlva" "inlvor" ;
  hair_N = mk2N "hr" "hr" ;
  hand_N = mk2N "hand" "hnder" ;
  head_N = mkN "huvud" "huvudet" "huvuden" "huvudena" ;
  heart_N = mkN "hjrta" "hjrtat" "hjrtan" "hjrtana" ;
  horn_N = mk2N "horn" "horn" ;
  husband_N = (mk2N "make" "makar") ;
  ice_N = mk2N "is" "isar" ;
  knee_N = mkN "kn" "knet" "knn" "knna" ;
  leaf_N = mk2N "lv" "lv" ;
  leg_N = mk2N "ben" "ben" ;
  liver_N = mkN "lever" "levern" "levrar" "levrarna";
  louse_N = mkN "lus" "lusen" "lss" "lssen" ;
  mouth_N = mkN "mun" "munnen" "munnar" "munnarna" ;
  name_N = mk2N "namn" "namn" ;
  neck_N = mk2N "nacke" "nackar" ;
  night_N = mk2N "natt" "ntter" ;
  nose_N = mk2N "nsa" "nsor" ;
  person_N = mk2N "person" "personer" ;
  rain_N = mk2N "regn" "regn" ;
  road_N = mk2N "vg" "vgar" ;
  root_N = mk2N "rot" "rtter" ;
  rope_N = mk2N "rep" "rep" ;
  salt_N = mkN "salt" "saltet" "salter" "salterna";
  sand_N = mk2N "sand" "sander" ;
  seed_N = mkN "fr" "fret" "frn" "frna" ;
  skin_N = mk2N "skinn" "skinn" ;
  sky_N = mk2N "himmel" "himlar" ;
  smoke_N = mk2N "rk" "rkar" ;
  snow_N = mkN "sn" "snn" "sner" "snerna" ;
  stick_N = mk2N "pinne" "pinnar" ;
  tail_N = mk2N "svans" "svansar" ;
  tongue_N = mk2N "tunga" "tungor" ;
  tooth_N = mk2N "tand" "tnder" ;
  wife_N = mk2N "fru" "fruar" ;
  wind_N = mk2N "vind" "vindar" ;
  wing_N = mk2N "vinge" "vingar" ;
  worm_N = mk2N "mask" "maskar" ;
  year_N = mk2N "r" "r" ;
  bite_V2 = dirV2 (bita_V) ;
  blow_V = mk2V "blsa" "blste" ;
  burn_V = brinna_V ; -- FIXME: brnna?
  count_V2 = dirV2 (regV "rkna") ;
  cut_V2 = dirV2 (skra_V) ;
  dig_V = mk2V "grva" "grvde" ;
  fall_V = falla_V ;
  fear_V2 = dirV2 (regV "frukta") ;
  float_V = flyta_V ;
  flow_V = rinna_V ;
  fly_V = flyga_V ;
  freeze_V = frysa_V ;
  give_V3 = dirV3 giva_V (mkPrep "till");
  hit_V2 = dirV2 (sl_V) ;
  hold_V2 = dirV2 (hlla_V) ;
  hunt_V2 = dirV2 (regV "jaga") ;
  kill_V2 = dirV2 (regV "dda") ;
  laugh_V = regV "skratta" ;
  lie_V = ligga_V ;
  play_V = mk2V "leka" "lekte" ;
  pull_V2 = dirV2 (draga_V) ;
  push_V2 = dirV2 (mk2V "trycka" "tryckte") ;
  rub_V2 = dirV2 (gnida_V) ;
  scratch_V2 = dirV2 (regV "klia") ;
  sew_V = sy_V ;
  sing_V = sjunga_V ;
  sit_V = sitta_V ;
  smell_V = regV "lukta" ;
  spit_V = regV "spotta" ;
  split_V2 = dirV2 (klyva_V) ;
  squeeze_V2 = dirV2 (klmma_V) ;
  stab_V2 = dirV2 (sticka_V) ;
  stand_V = st_V ;
  suck_V2 = dirV2 (suga_V) ;
  swell_V = svlla_V ;
  swim_V = regV "simma" ;
  think_V = mk2V "tnka" "tnkte" ;
  throw_V2 = dirV2 (regV "kasta") ;
  tie_V2 = dirV2 (knyta_V) ;
  turn_V = vnda_V ;
  vomit_V = mk2V "spy" "spydde" ;
  wash_V2 = dirV2 (regV "tvtta") ;
  wipe_V2 = dirV2 (regV "torka") ;

  breathe_V = depV (regV "anda") ;
  fight_V2 = 
    mkV2 (mkV "slss" "slss" "slss" "slogs" "slagits" "slagen") (mkPrep "med") ;

  grammar_N = mk1N "grammatikerna" ;
  language_N = mk2N "sprk" "sprk" ;
  rule_N = mkN "regel" "regeln" "regler" "reglerna" ;

    john_PN = regPN "Johan" ;
    question_N = regN "frga" ;
    ready_A = regA "frdig" ;
    reason_N = regN "anledning" ;
    today_Adv = mkAdv "idag" ;
    uncertain_A = mk3A "osker" "oskert" "oskra" ;


} ;
