--# -path=.:../prelude:../abstract:../common:../scandinavian

-- This dictionary is derived from SALDO, see:
--
--   Borin, Lars, Markus Forsberg and Lennart Lönngren 2008.
--   The hunting of the BLARK - SALDO, a freely available lexical database for 
--   Swedish language technology. Resourceful language technology.
--   Festschrift in honor of Anna Sågvall Hein, ed. by Joakim Nivre, 
--   Mats Dahllöf and Beáta Megyesi. 
--   Acta Universitatis Upsaliensis: Studia Linguistica Upsaliensia 7. 21-32.
--   <http://spraakbanken.gu.se/personal/lars/pblctns/ash-fs-080605.pdf>
--
-- Imported in GF by Krasimir Angelov
--
-- This resource is distributed under the free software license LGPL 3.0 or 
-- Creative Commons Attribution-Share Alike 2.5 Generic. 

concrete DictSwe of DictSweAbs = CatSwe ** open ParadigmsSwe in {

flags
  optimize=values ; coding=utf8 ;

lin
  A_vitamin_nn_1 = mkN "A-vitamin" "A-vitaminet" "A-vitaminer" "A-vitaminerna" ;
  A_vitaminbrist_nn_1 = mkN "A-vitaminbrist" "A-vitaminbrister" ;
  Antarktisfoerdrag_nn_1 = mkN "Antarktisfцrdrag" neutrum ;
  Antarktisprojekt_nn_1 = mkN "Antarktisprojekt" neutrum ;
  Arianeraket_nn_1 = mkN "Arianeraket" "Arianeraketer" ;
  B_vitamin_nn_1 = mkN "B-vitamin" "B-vitaminet" "B-vitaminer" "B-vitaminerna" ;
  B_vitaminbrist_nn_1 = mkN "B-vitaminbrist" "B-vitaminbrister" ;
  C_vitamin_nn_1 = mkN "C-vitamin" "C-vitaminet" "C-vitaminer" "C-vitaminerna" ;
  Celsius_ab_1 = mkAdv "Celsius" ;
  DNA_kedja_nn_1 = mkN "DNA-kedja" ;
  DNA_molekyl_nn_1 = mkN "DNA-molekyl" "DNA-molekyler" ;
  DNA_uppsaettning_nn_1 = mkN "DNA-uppsдttning" ;
  Efta_land_nn_1 = mkN "Efta-land" "Efta-landet" "Efta-lдnder" "Efta-lдnderna" ;
  Gudi_ab_1 = mkAdv "Gudi" ;
  Hiroshimabomb_nn_1 = mkN "Hiroshimabomb" "Hiroshimabomber" ;
  ID_kort_nn_1 = mkN "ID-kort" neutrum ;
  I_land_nn_1 = mkN "I-land" "I-landet" "I-lдnder" "I-lдnderna" ;
  Jantelag_nn_1 = mkN "Jantelag" ;
  Jupitermaane_nn_1 = mkN "Jupitermеne" utrum ;
  Koechelnummer_nn_1 = mkN "Kцchelnummer" neutrum ;
  Kubakris_nn_1 = mkN "Kubakris" "Kubakriser" ;
  LO_chef_nn_1 = mkN "LO-chef" "LO-chefer" ;
  LO_ordfoerande_nn_1 = mkN "LO-ordfцrande" "LO-ordfцranden" "LO-ordfцrande" "LO-ordfцrandena" ;
  Linkoepingsbo_nn_1 = mkN "Linkцpingsbo" "Linkцpingsbor" ;
  MAO_aktivitet_nn_1 = mkN "MAO-aktivitet" "MAO-aktiviteter" ;
  MAO_enzym_nn_1 = mkN "MAO-enzym" neutrum ;
  Medelhavsland_nn_1 = mkN "Medelhavsland" "Medelhavslandet" "Medelhavslдnder" "Medelhavslдnderna" ;
  Mosebok_nn_1 = mkN "Mosebok" "Mosebцcker" ;
  OECD_land_nn_1 = mkN "OECD-land" "OECD-landet" "OECD-lдnder" "OECD-lдnderna" ;
  PCB_foerbud_nn_1 = mkN "PCB-fцrbud" neutrum ;
  PCB_foerening_nn_1 = mkN "PCB-fцrening" ;
  PCB_foergiftning_nn_1 = mkN "PCB-fцrgiftning" ;
  PCB_halt_nn_1 = mkN "PCB-halt" "PCB-halter" ;
  PCB_olja_nn_1 = mkN "PCB-olja" ;
  PR_man_nn_1 = mkN "PR-man" "PR-mannen" "PR-mдn" "PR-mдnnen" ;
  Papyrusaktie_nn_1 = mkN "Papyrusaktie" "Papyrusaktier" ;
  SAP_program_nn_1 = mkN "SAP-program" "SAP-programmet" "SAP-program" "SAP-programmen" ;
  SAS_chef_nn_1 = mkN "SAS-chef" "SAS-chefer" ;
  SCOPE_rapport_nn_1 = mkN "SCOPE-rapport" "SCOPE-rapporter" ;
  Salazar_regim_nn_1 = mkN "Salazar-regim" "Salazar-regimer" ;
  TV_antenn_nn_1 = mkN "TV-antenn" "TV-antenner" ;
  TV_apparat_nn_1 = mkN "TV-apparat" "TV-apparater" ;
  TV_bild_nn_1 = mkN "TV-bild" "TV-bilder" ;
  TV_chef_nn_1 = mkN "TV-chef" "TV-chefer" ;
  TV_kamera_nn_1 = mkN "TV-kamera" ;
  TV_kanal_nn_1 = mkN "TV-kanal" "TV-kanaler" ;
  TV_konferens_nn_1 = mkN "TV-konferens" "TV-konferenser" ;
  TV_mottagare_nn_1 = mkN "TV-mottagare" "TV-mottagare" ;
  TV_producent_nn_1 = mkN "TV-producent" "TV-producenter" ;
  TV_program_nn_1 = mkN "TV-program" "TV-programmet" "TV-program" "TV-programmen" ;
  TV_reparatoer_nn_1 = mkN "TV-reparatцr" "TV-reparatцrer" ;
  TV_saendning_nn_1 = mkN "TV-sдndning" ;
  TV_serie_nn_1 = mkN "TV-serie" "TV-serier" ;
  TV_skaerm_nn_1 = mkN "TV-skдrm" ;
  TV_studio_nn_1 = mkN "TV-studio" "TV-studior" ;
  TV_tittare_nn_1 = mkN "TV-tittare" "TV-tittare" ;
  Tjernobylnedfall_nn_1 = mkN "Tjernobylnedfall" neutrum ;
  U_land_nn_1 = mkN "U-land" "U-landet" "U-lдnder" "U-lдnderna" ;
  Vietnamkrig_nn_1 = mkN "Vietnamkrig" neutrum ;
  Z_partikel_nn_1 = mkN "Z-partikel" ;
  aa_nn_2 = mkN "е" ;
  aabaekig_av_1 = mkA "еbдkig" ;
  aabo_nn_1 = mkN "еbo" "еbor" ;
  aadaga_ab_1 = mkAdv "еdaga" ;
  aader_nn_1 = mkN "еder" "еdern" "еdror" "еdrorna" ;
  aaderbraack_nn_1 = mkN "еderbrеck" neutrum ;
  aaderhinna_nn_1 = mkN "еderhinna" ;
  aaderlaata_vb_1 = mkV "еderlеta" "еderlдt" "еderlеtit" ;
  aadra_nn_1 = mkN "еdra" ;
  aadra_vb_1 = mkV "еdra" "еdrar" "еdra" "еdrog" "еdragit" "еdragen" ;
  aadrig_av_1 = mkA "еdrig" ;
  aadring_nn_1 = mkN "еdring" ;
  aahoerardag_nn_1 = mkN "еhцrardag" ;
  aahoerare_nn_1 = mkN "еhцrare" "еhцrare" ;
  aahoerarplats_nn_1 = mkN "еhцrarplats" "еhцrarplatser" ;
  aak_nn_1 = mkN "еk" neutrum ;
  aakare_nn_1 = mkN "еkare" "еkare" ;
  aakarkamp_nn_1 = mkN "еkarkamp" ;
  aakdon_nn_1 = mkN "еkdon" neutrum ;
  aaker_nn_1 = mkN "еker" ;
  aakeraert_nn_1 = mkN "еkerдrt" "еkerдrter" ;
  aakerbaer_nn_1 = mkN "еkerbдr" neutrum ;
  aakerbit_nn_1 = mkN "еkerbit" ;
  aakerbruk_nn_1 = mkN "еkerbruk" neutrum ;
  aakerbrukare_nn_1 = mkN "еkerbrukare" "еkerbrukare" ;
  aakerfaelt_nn_1 = mkN "еkerfдlt" neutrum ;
  aakerfraeken_nn_1 = mkN "еkerfrдken" "еkerfrдkenn" "еkerfrдknar" "еkerfrдknarna" ;
  aakergaerde_nn_1 = mkN "еkergдrde" ;
  aakeri_nn_1 = mkN "еkeri" "еkerit" "еkerier" "еkerierna" ;
  aakerjord_nn_1 = mkN "еkerjord" ;
  aakerlapp_nn_1 = mkN "еkerlapp" ;
  aakermark_nn_1 = mkN "еkermark" "еkermarker" ;
  aakerren_nn_1 = mkN "еkerren" "еkerrenen" "еkerrenar" "еkerrenarna" ;
  aakersork_nn_1 = mkN "еkersork" ;
  aakerspergel_nn_1 = mkN "еkerspergel" ;
  aakerteg_nn_1 = mkN "еkerteg" ;
  aakertistel_nn_1 = mkN "еkertistel" ;
  aakervaext_nn_1 = mkN "еkervдxt" "еkervдxter" ;
  aakervall_nn_1 = mkN "еkervall" ;
  aaklagare_nn_1 = mkN "еklagare" "еklagare" ;
  aaklagarmyndighet_nn_1 = mkN "еklagarmyndighet" "еklagarmyndigheter" ;
  aakning_nn_1 = mkN "еkning" ;
  aakpaase_nn_1 = mkN "еkpеse" utrum ;
  aakroek_nn_1 = mkN "еkrцk" ;
  aaksjuk_av_1 = mkA "еksjuk" ;
  aaktur_nn_1 = mkN "еktur" "еkturer" ;
  aal_nn_1 = mkN "еl" ;
  aalaendsk_av_1 = mkA "еlдndsk" ;
  aalaendska_nn_2 = mkN "еlдndska" ;
  aalaenning_nn_1 = mkN "еlдnning" ;
  aalandsrot_nn_1 = mkN "еlandsrot" "еlandsrцtter" ;
  aalder_nn_1 = mkN "еlder" ;
  aalderdom_nn_1 = mkN "еlderdom" ;
  aalderdomlig_av_1 = mkA "еlderdomlig" ;
  aalderdomsfoersaekring_nn_1 = mkN "еlderdomsfцrsдkring" ;
  aalderdomshem_nn_1 = mkN "еlderdomshem" "еlderdomshemmet" "еlderdomshem" "еlderdomshemmen" ;
  aalderdomspension_nn_1 = mkN "еlderdomspension" "еlderdomspensioner" ;
  aalderdomssvag_av_1 = mkA "еlderdomssvag" ;
  aalderman_nn_1 = mkN "еlderman" "еldermannen" "еldermдn" "еldermдnnen" ;
  aaldersbestaemning_nn_1 = mkN "еldersbestдmning" ;
  aaldersbetyg_nn_1 = mkN "еldersbetyg" neutrum ;
  aaldersfoeraendring_nn_1 = mkN "еldersfцrдndring" ;
  aaldersfoerdelning_nn_1 = mkN "еldersfцrdelning" ;
  aaldersgraens_nn_1 = mkN "еldersgrдns" "еldersgrдnser" ;
  aaldersgrupp_nn_1 = mkN "еldersgrupp" "еldersgrupper" ;
  aaldersklass_nn_1 = mkN "еldersklass" "еldersklasser" ;
  aalderslaangsynthet_nn_1 = mkN "еlderslеngsynthet" "еlderslеngsyntheter" ;
  aalderspension_nn_1 = mkN "еlderspension" "еlderspensioner" ;
  aalderspresident_nn_1 = mkN "еlderspresident" "еlderspresidenter" ;
  aaldersskael_nn_1 = mkN "еldersskдl" neutrum ;
  aaldersskillnad_nn_1 = mkN "еldersskillnad" "еldersskillnader" ;
  aaldersspaerr_nn_1 = mkN "еldersspдrr" ;
  aaldersstadium_nn_1 = mkN "еldersstadium" "еldersstadiet" "еldersstadier" "еldersstadierna" ;
  aaldersstruktur_nn_1 = mkN "еldersstruktur" "еldersstrukturer" ;
  aalderssvag_av_1 = mkA "еlderssvag" ;
  aalderstecken_nn_1 = mkN "еlderstecken" "еlderstecknet" "еlderstecken" "еlderstecknen" ;
  aalderstigen_av_1 = mkA "еlderstigen" "еlderstiget" ;
  aalderstillaegg_nn_1 = mkN "еlderstillдgg" neutrum ;
  aalderstyngd_av_1 = mkA "еlderstyngd" "еlderstyngt" ;
  aaldfru_nn_1 = mkN "еldfru" ;
  aaldrig_av_1 = mkA "еldrig" ;
  aaldring_nn_1 = mkN "еldring" ;
  aalfiskare_nn_1 = mkN "еlfiskare" "еlfiskare" ;
  aaliggande_nn_1 = mkN "еliggande" ;
  aalskinn_nn_1 = mkN "еlskinn" neutrum ;
  aam_nn_1 = mkN "еm" ;
  aamig_av_1 = mkA "еmig" ;
  aamning_nn_1 = mkN "еmning" ;
  aamynning_nn_1 = mkN "еmynning" ;
  aangackumulator_nn_1 = mkN "еngackumulator" "еngackumulatorer" ;
  aanganlaeggning_nn_1 = mkN "еnganlдggning" ;
  aangare_nn_1 = mkN "еngare" "еngare" ;
  aangbaat_nn_1 = mkN "еngbеt" ;
  aangbageri_nn_1 = mkN "еngbageri" "еngbagerit" "еngbagerier" "еngbagerierna" ;
  aangblaester_nn_1 = mkN "еngblдster" ;
  aangcentral_nn_1 = mkN "еngcentral" "еngcentraler" ;
  aangdriven_av_1 = mkA "еngdriven" "еngdrivet" ;
  aangerfull_av_1 = mkA "еngerfull" ;
  aangerkoept_av_1 = mkA "еngerkцpt" "еngerkцpt" ;
  aangermanlaendsk_av_1 = mkA "еngermanlдndsk" ;
  aangermanlaenning_nn_1 = mkN "еngermanlдnning" ;
  aangervecka_nn_1 = mkN "еngervecka" ;
  aangestfull_av_1 = mkA "еngestfull" ;
  aangestfylld_av_1 = mkA "еngestfylld" "еngestfyllt" ;
  aangestneuros_nn_1 = mkN "еngestneuros" "еngestneuroser" ;
  aangfartyg_nn_1 = mkN "еngfartyg" neutrum ;
  aanggenerator_nn_1 = mkN "еnggenerator" "еnggeneratorer" ;
  aangkoek_nn_1 = mkN "еngkцk" neutrum ;
  aangkokare_nn_1 = mkN "еngkokare" "еngkokare" ;
  aangkol_nn_1 = mkN "еngkol" neutrum ;
  aangkraftverk_nn_1 = mkN "еngkraftverk" neutrum ;
  aanglok_nn_1 = mkN "еnglok" neutrum ;
  aanglokomotiv_nn_1 = mkN "еnglokomotiv" neutrum ;
  aangmaskin_nn_1 = mkN "еngmaskin" "еngmaskiner" ;
  aangning_nn_1 = mkN "еngning" ;
  aangslup_nn_1 = mkN "еngslup" ;
  aangstroem_nn_1 = mkN "еngstrцm" "еngstrцmen" "еngstrцm" "еngstrцmen" ;
  aangstrykjaern_nn_1 = mkN "еngstrykjдrn" neutrum ;
  aangtryck_nn_1 = mkN "еngtryck" neutrum ;
  aangturbin_nn_1 = mkN "еngturbin" "еngturbiner" ;
  aangvaelt_nn_1 = mkN "еngvдlt" ;
  aangvinsch_nn_1 = mkN "еngvinsch" ;
  aangvissla_nn_1 = mkN "еngvissla" ;
  aanyo_ab_1 = mkAdv "еnyo" ;
  aapen_av_1 = mkA "еpen" "еpet" ;
  aar_nn_1 = mkN "еr" neutrum ;
  aarblad_nn_1 = mkN "еrblad" neutrum ;
  aarbraeckt_av_1 = mkA "еrbrдckt" "еrbrдckt" ;
  aarder_nn_1 = mkN "еrder" neutrum ;
  aaretruntbostad_nn_1 = mkN "еretruntbostad" "еretruntbostдder" ;
  aarfot_nn_1 = mkN "еrfot" "еrfцtter" ;
  aargaang_nn_1 = mkN "еrgеng" ;
  aargaangsvin_nn_1 = mkN "еrgеngsvin" "еrgеngsvinet" "еrgеngsviner" "еrgеngsvinerna" ;
  aaring_nn_1 = mkN "еring" ;
  aarlig_av_1 = mkA "еrlig" ;
  aarligen_ab_1 = mkAdv "еrligen" ;
  aarlom_nn_1 = mkN "еrlom" "еrlommen" "еrlommar" "еrlommarna" ;
  aarmiljon_nn_1 = mkN "еrmiljon" "еrmiljoner" ;
  aarpinne_nn_1 = mkN "еrpinne" utrum ;
  aarsavgift_nn_1 = mkN "еrsavgift" "еrsavgifter" ;
  aarsbaesta_av_1 = mkA "еrsbдsta" ;
  aarsbarn_nn_1 = mkN "еrsbarn" neutrum ;
  aarsberaettelse_nn_1 = mkN "еrsberдttelse" "еrsberдttelser" ;
  aarsbok_nn_1 = mkN "еrsbok" "еrsbцcker" ;
  aarsbokstav_nn_1 = mkN "еrsbokstav" "еrsbokstдver" ;
  aarscykel_nn_1 = mkN "еrscykel" ;
  aarsdag_nn_1 = mkN "еrsdag" ;
  aarsdos_nn_1 = mkN "еrsdos" "еrsdoser" ;
  aarsinkomst_nn_1 = mkN "еrsinkomst" "еrsinkomster" ;
  aarsklass_nn_1 = mkN "еrsklass" "еrsklasser" ;
  aarskull_nn_1 = mkN "еrskull" ;
  aarskurs_nn_1 = mkN "еrskurs" "еrskurser" ;
  aarsmedeltemperatur_nn_1 = mkN "еrsmedeltemperatur" "еrsmedeltemperaturer" ;
  aarsmodell_nn_1 = mkN "еrsmodell" "еrsmodeller" ;
  aarsmoete_nn_1 = mkN "еrsmцte" ;
  aarsredovisning_nn_1 = mkN "еrsredovisning" ;
  aarsring_nn_1 = mkN "еrsring" ;
  aarstid_nn_1 = mkN "еrstid" "еrstider" ;
  aarstidsvind_nn_1 = mkN "еrstidsvind" ;
  aarstryck_nn_1 = mkN "еrstryck" neutrum ;
  aartag_nn_1 = mkN "еrtag" neutrum ;
  aartal_nn_1 = mkN "еrtal" "еrtalet" "еrtalen" "еrtalena" ;
  aartionde_nn_1 = mkN "еrtionde" ;
  aartull_nn_1 = mkN "еrtull" ;
  aartusende_nn_1 = mkN "еrtusende" ;
  aas_nn_1 = mkN "еs" ;
  aasido_ab_1 = mkAdv "еsido" ;
  aasikt_nn_1 = mkN "еsikt" "еsikter" ;
  aasiktsfoerfoeljelse_nn_1 = mkN "еsiktsfцrfцljelse" "еsiktsfцrfцljelser" ;
  aasiktsfrihet_nn_1 = mkN "еsiktsfrihet" "еsiktsfriheter" ;
  aasiktsmaessig_av_1 = mkA "еsiktsmдssig" ;
  aasiktsriktning_nn_1 = mkN "еsiktsriktning" ;
  aasiktsutbyte_nn_1 = mkN "еsiktsutbyte" ;
  aaskaadare_nn_1 = mkN "еskеdare" "еskеdare" ;
  aaskaadarlaektare_nn_1 = mkN "еskеdarlдktare" "еskеdarlдktare" ;
  aaskaadlig_av_1 = mkA "еskеdlig" ;
  aaskaadning_nn_1 = mkN "еskеdning" ;
  aaskby_nn_1 = mkN "еskby" "еskbyn" "еskbyar" "еskbyarna" ;
  aaskdiger_av_1 = mkA "еskdiger" "еskdigert" "еskdigra" "еskdigra" "еskdigrare" "еskdigrast" "еskdigraste" ;
  aaskfront_nn_1 = mkN "еskfront" "еskfronter" ;
  aaskledare_nn_1 = mkN "еskledare" "еskledare" ;
  aaskmoln_nn_1 = mkN "еskmoln" neutrum ;
  aaskregn_nn_1 = mkN "еskregn" neutrum ;
  aaskvaeder_nn_1 = mkN "еskvдder" neutrum ;
  aasna_nn_1 = mkN "еsna" ;
  aasnedrivare_nn_1 = mkN "еsnedrivare" "еsnedrivare" ;
  aasneskri_nn_1 = mkN "еsneskri" "еsneskrit" "еsneskrin" "еsneskrien" ;
  aasnespark_nn_1 = mkN "еsnespark" ;
  aasstaang_nn_1 = mkN "еsstеng" "еsstдnger" ;
  aastad_ab_1 = mkAdv "еstad" ;
  aastadkomma_vb_1 = mkV "еstadkomma" "еstadkom" "еstadkommit" ;
  aat_ab_1 = mkAdv "еt" ;
  aata_vb_1 = mkV "еta" "еtar" "еta" "еtog" "еtagit" "еtagen" ;
  aatagande_nn_1 = mkN "еtagande" ;
  aatal_nn_1 = mkN "еtal" "еtalet" "еtalen" "еtalena" ;
  aatboerd_nn_1 = mkN "еtbцrd" "еtbцrder" ;
  aatel_nn_1 = mkN "еtel" ;
  aater_ab_1 = mkAdv "еter" ;
  aateranvaendning_nn_1 = mkN "еteranvдndning" ;
  aaterbaering_nn_1 = mkN "еterbдring" ;
  aaterbesoek_nn_1 = mkN "еterbesцk" neutrum ;
  aaterbetalning_nn_1 = mkN "еterbetalning" ;
  aaterblick_nn_1 = mkN "еterblick" ;
  aaterbud_nn_1 = mkN "еterbud" neutrum ;
  aaterfall_nn_1 = mkN "еterfall" neutrum ;
  aaterfalla_vb_1 = mkV "еterfalla" "еterfцll" "еterfallit" ;
  aaterfinna_vb_1 = mkV "еterfinna" "еterfann" "еterfunnit" ;
  aaterflyttning_nn_1 = mkN "еterflyttning" ;
  aaterfoederska_nn_1 = mkN "еterfцderska" ;
  aaterfoerening_nn_1 = mkN "еterfцrening" ;
  aaterfoersaekring_nn_1 = mkN "еterfцrsдkring" ;
  aaterfoersaeljare_nn_1 = mkN "еterfцrsдljare" "еterfцrsдljare" ;
  aatergaa_vb_1 = mkV "еtergе" "еtergеr" "еtergе" "еtergick" "еtergеtt" "еtergеngen" ;
  aaterge_vb_1 = mkV "еterge" "еterger" "еterge" "еtergav" "еtergett" "еtergiven" ;
  aatergivande_nn_1 = mkN "еtergivande" ;
  aatergivning_nn_1 = mkN "еtergivning" ;
  aaterhaalla_vb_1 = mkV "еterhеlla" "еterhцll" "еterhеllit" ;
  aaterhaallsam_av_1 = mkA "еterhеllsam" "еterhеllsamt" "еterhеllsamma" "еterhеllsamma" "еterhеllsammare" "еterhеllsammast" "еterhеllsammaste" ;
  aaterigen_ab_1 = mkAdv "еterigen" ;
  aaterkallelse_nn_1 = mkN "еterkallelse" "еterkallelser" ;
  aaterknyta_vb_1 = mkV "еterknyta" "еterknцt" "еterknutit" ;
  aaterkoep_nn_1 = mkN "еterkцp" neutrum ;
  aaterkomma_vb_1 = mkV "еterkomma" "еterkom" "еterkommit" ;
  aaterkoppling_nn_1 = mkN "еterkoppling" ;
  aaterrop_nn_1 = mkN "еterrop" neutrum ;
  aatersamling_nn_1 = mkN "еtersamling" ;
  aaterspegling_nn_1 = mkN "еterspegling" ;
  aaterstaellare_nn_1 = mkN "еterstдllare" "еterstдllare" ;
  aaterstaellningstecken_nn_1 = mkN "еterstдllningstecken" "еterstдllningstecknet" "еterstдllningstecken" "еterstдllningstecknen" ;
  aaterstod_nn_1 = mkN "еterstod" "еterstoder" ;
  aaterta_vb_1 = mkV "еterta" "еtertar" "еterta" "еtertog" "еtertagit" "еtertagen" ;
  aatertaag_nn_1 = mkN "еtertеg" neutrum ;
  aatertjaenst_nn_1 = mkN "еtertjдnst" "еtertjдnster" ;
  aateruppstaandelse_nn_1 = mkN "еteruppstеndelse" "еteruppstеndelser" ;
  aateruppta_vb_1 = mkV "еteruppta" "еterupptar" "еteruppta" "еterupptog" "еterupptagit" "еterupptagen" ;
  aatervaendsgraend_nn_1 = mkN "еtervдndsgrдnd" "еtervдndsgrдnder" ;
  aaterval_nn_1 = mkN "еterval" neutrum ;
  aaterverkning_nn_1 = mkN "еterverkning" ;
  aatervinna_vb_1 = mkV "еtervinna" "еtervann" "еtervunnit" ;
  aatgaa_vb_1 = mkV "еtgе" "еtgеr" "еtgе" "еtgick" "еtgеtt" "еtgеngen" ;
  aatgaangen_av_1 = mkA "еtgеngen" "еtgеnget" ;
  aatgaerd_nn_1 = mkN "еtgдrd" "еtgдrder" ;
  aathutning_nn_1 = mkN "еthutning" ;
  aatkomlig_av_1 = mkA "еtkomlig" ;
  aatlyda_vb_1 = mkV "еtlyda" "еtlydde" "еtlytt" ;
  aatlydnad_nn_1 = mkN "еtlydnad" "еtlydnader" ;
  aatminstone_ab_1 = mkAdv "еtminstone" ;
  aatnjuta_vb_1 = mkV "еtnjuta" "еtnjцt" "еtnjutit" ;
  aatraavaerd_av_1 = mkA "еtrеvдrd" "еtrеvдrt" ;
  aatsida_nn_1 = mkN "еtsida" ;
  aatsittande_av_1 = mkA "еtsittande" ;
  aatskillig_av_1 = mkA "еtskillig" ;
  aatskillnad_nn_1 = mkN "еtskillnad" "еtskillnader" ;
  aatskils_ab_1 = mkAdv "еtskils" ;
  aatsmitande_av_1 = mkA "еtsmitande" ;
  aatstramning_nn_1 = mkN "еtstramning" ;
  aattahoernig_av_1 = mkA "еttahцrnig" ;
  aattatimmarsdag_nn_1 = mkN "еttatimmarsdag" ;
  aattiondel_nn_1 = mkN "еttiondel" "еttiondelen" "еttiondelar" "еttiondelarna" ;
  aattiotalist_nn_1 = mkN "еttiotalist" "еttiotalister" ;
  aattitalism_nn_1 = mkN "еttitalism" "еttitalismer" ;
  aattitalist_nn_1 = mkN "еttitalist" "еttitalister" ;
  aattondel_nn_1 = mkN "еttondel" "еttondelen" "еttondelar" "еttondelarna" ;
  abakus_nn_1 = mkN "abakus" "abakuser" ;
  abbe_nn_1 = mkN "abbй" "abbйer" ;
  abborre_nn_1 = mkN "abborre" utrum ;
  abborrfisk_nn_1 = mkN "abborrfisk" ;
  abborrpinne_nn_1 = mkN "abborrpinne" utrum ;
  abbot_nn_1 = mkN "abbot" ;
  abbreviation_nn_1 = mkN "abbreviation" "abbreviationer" ;
  abbreviatur_nn_1 = mkN "abbreviatur" "abbreviaturer" ;
  abc_bok_nn_1 = mkN "abc-bok" "abc-bцcker" ;
  abderitisk_av_1 = mkA "abderitisk" ;
  abdikation_nn_1 = mkN "abdikation" "abdikationer" ;
  abdomen_nn_1 = mkN "abdomen" "abdomen" "abdomina" "abdomina" ;
  aber_nn_1 = mkN "aber" neutrum ;
  aberration_nn_1 = mkN "aberration" "aberrationer" ;
  abessinier_nn_1 = mkN "abessinier" "abessiniern" "abessinier" "abessinierna" ;
  abessinsk_av_1 = mkA "abessinsk" ;
  abilitet_nn_1 = mkN "abilitet" "abiliteter" ;
  abiturient_nn_1 = mkN "abiturient" "abiturienter" ;
  abiturientexamen_nn_1 = mkN "abiturientexamen" "abiturientexamen" "abiturientexamina" "abiturientexamina" ;
  ablation_nn_1 = mkN "ablation" "ablationer" ;
  ablativ_nn_1 = mkN "ablativ" "ablativer" ;
  abnorm_av_1 = mkA "abnorm" ;
  abnormitet_nn_1 = mkN "abnormitet" "abnormiteter" ;
  abolition_nn_1 = mkN "abolition" "abolitioner" ;
  abonnemang_nn_1 = mkN "abonnemang" neutrum ;
  abonnent_nn_1 = mkN "abonnent" "abonnenter" ;
  aboriginer_nn_1 = mkN "aboriginer" "aboriginern" "aboriginer" "aboriginerna" ;
  abort_nn_1 = mkN "abort" "aborter" ;
  abortiv_av_1 = mkA "abortiv" ;
  abortoer_nn_1 = mkN "abortцr" "abortцrer" ;
  abrupt_av_1 = mkA "abrupt" "abrupt" ;
  abscess_nn_1 = mkN "abscess" "abscesser" ;
  absens_nn_1 = mkN "absens" "absenser" ;
  absid_nn_1 = mkN "absid" "absider" ;
  absint_nn_1 = mkN "absint" "absinter" ;
  absolut_av_1 = mkA "absolut" "absolut" ;
  absolutbelopp_nn_1 = mkN "absolutbelopp" neutrum ;
  absolutist_nn_1 = mkN "absolutist" "absolutister" ;
  absolutistisk_av_1 = mkA "absolutistisk" ;
  absorptionslinje_nn_1 = mkN "absorptionslinje" "absorptionslinjer" ;
  abstrakt_av_1 = mkA "abstrakt" "abstrakt" ;
  abstrakt_nn_1 = mkN "abstrakt" "abstraktet" "abstrakter" "abstrakterna" ;
  abstraktion_nn_1 = mkN "abstraktion" "abstraktioner" ;
  abstrus_av_1 = mkA "abstrus" ;
  absurd_av_1 = mkA "absurd" "absurt" ;
  absurditet_nn_1 = mkN "absurditet" "absurditeter" ;
  abundant_av_1 = mkA "abundant" "abundant" ;
  abyssal_av_1 = mkA "abyssal" ;
  acceleration_nn_1 = mkN "acceleration" "accelerationer" ;
  accelerator_nn_1 = mkN "accelerator" "acceleratorer" ;
  acceleratormaskin_nn_1 = mkN "acceleratormaskin" "acceleratormaskiner" ;
  acceleratorsystem_nn_1 = mkN "acceleratorsystem" neutrum ;
  accent_nn_1 = mkN "accent" "accenter" ;
  accentfoerskjutning_nn_1 = mkN "accentfцrskjutning" ;
  accenttecken_nn_1 = mkN "accenttecken" "accenttecknet" "accenttecken" "accenttecknen" ;
  accept_nn_1 = mkN "accept" "accepter" ;
  acceptabel_av_1 = mkA "acceptabel" "acceptabelt" "acceptabla" "acceptabla" "acceptablare" "acceptablast" "acceptablaste" ;
  acceptant_nn_1 = mkN "acceptant" "acceptanter" ;
  accepterande_nn_1 = mkN "accepterande" ;
  acceptkredit_nn_1 = mkN "acceptkredit" "acceptkrediter" ;
  access_nn_1 = mkN "access" "accesser" ;
  accession_nn_1 = mkN "accession" "accessioner" ;
  accessionskatalog_nn_1 = mkN "accessionskatalog" "accessionskataloger" ;
  accessoar_nn_1 = mkN "accessoar" "accessoarer" ;
  accessorisk_av_1 = mkA "accessorisk" ;
  accesstid_nn_1 = mkN "accesstid" "accesstider" ;
  accidens_nn_1 = mkN "accidens" "accidenser" ;
  accidenstryck_nn_1 = mkN "accidenstryck" neutrum ;
  accidentell_av_1 = mkA "accidentell" ;
  accis_nn_1 = mkN "accis" "acciser" ;
  acetaldehyd_nn_1 = mkN "acetaldehyd" "acetaldehyder" ;
  acetat_nn_1 = mkN "acetat" neutrum ;
  aciditet_nn_1 = mkN "aciditet" "aciditeter" ;
  ackja_nn_1 = mkN "ackja" ;
  acklamation_nn_1 = mkN "acklamation" "acklamationer" ;
  ackommodation_nn_1 = mkN "ackommodation" "ackommodationer" ;
  ackommodationsvaexel_nn_1 = mkN "ackommodationsvдxel" ;
  ackompanjatoer_nn_1 = mkN "ackompanjatцr" "ackompanjatцrer" ;
  ackompanjemang_nn_1 = mkN "ackompanjemang" neutrum ;
  ackord_nn_1 = mkN "ackord" neutrum ;
  ackordion_nn_1 = mkN "ackordion" "ackordionet" "ackordion" "ackordierna" ;
  ackordsloen_nn_1 = mkN "ackordslцn" "ackordslцner" ;
  ackordssaettning_nn_1 = mkN "ackordssдttning" ;
  ackumulation_nn_1 = mkN "ackumulation" "ackumulationer" ;
  ackumulator_nn_1 = mkN "ackumulator" "ackumulatorer" ;
  ackurat_ab_1 = mkAdv "ackurat" ;
  ackurat_av_1 = mkA "ackurat" "ackurat" ;
  ackusativ_nn_1 = mkN "ackusativ" "ackusativer" ;
  ackusativobjekt_nn_1 = mkN "ackusativobjekt" neutrum ;
  ackusatorisk_av_1 = mkA "ackusatorisk" ;
  ackuschoer_nn_1 = mkN "ackuschцr" "ackuschцrer" ;
  ackuschoerska_nn_1 = mkN "ackuschцrska" ;
  ackvisition_nn_1 = mkN "ackvisition" "ackvisitioner" ;
  ackvisitoer_nn_1 = mkN "ackvisitцr" "ackvisitцrer" ;
  actionfilm_nn_1 = mkN "actionfilm" "actionfilmer" ;
  adagio_ab_1 = mkAdv "adagio" ;
  adagio_nn_1 = mkN "adagio" "adagiot" "adagion" "adagiona" ;
  adaptation_nn_1 = mkN "adaptation" "adaptationer" ;
  adapter_nn_1 = mkN "adapter" ;
  adaption_nn_1 = mkN "adaption" "adaptioner" ;
  adaptiv_av_1 = mkA "adaptiv" ;
  addend_nn_1 = mkN "addend" "addender" ;
  addenda_nn_1 = mkN "addenda" "addendan" "addenda" "addendana" ;
  addiktion_nn_1 = mkN "addiktion" "addiktioner" ;
  additament_nn_1 = mkN "additament" "additamentet" "additamenten" "additamentena" ;
  addition_nn_1 = mkN "addition" "additioner" ;
  additionstecken_nn_1 = mkN "additionstecken" "additionstecknet" "additionstecken" "additionstecknen" ;
  additiv_av_1 = mkA "additiv" ;
  additiv_nn_1 = mkN "additiv" neutrum ;
  adduktion_nn_1 = mkN "adduktion" "adduktioner" ;
  adekvat_av_1 = mkA "adekvat" "adekvat" ;
  adelsaett_nn_1 = mkN "adelsдtt" "adelsдtter" ;
  adelsbrev_nn_1 = mkN "adelsbrev" neutrum ;
  adelsgods_nn_1 = mkN "adelsgods" neutrum ;
  adelshem_nn_1 = mkN "adelshem" "adelshemmet" "adelshem" "adelshemmen" ;
  adelskalender_nn_1 = mkN "adelskalender" ;
  adelsmaerke_nn_1 = mkN "adelsmдrke" ;
  adelsman_nn_1 = mkN "adelsman" "adelsmannen" "adelsmдn" "adelsmдnnen" ;
  adelsprivilegium_nn_1 = mkN "adelsprivilegium" "adelsprivilegiet" "adelsprivilegier" "adelsprivilegierna" ;
  adenit_nn_1 = mkN "adenit" "adeniter" ;
  adept_nn_1 = mkN "adept" "adepter" ;
  adhesiv_av_1 = mkA "adhesiv" ;
  adiabatisk_av_1 = mkA "adiabatisk" ;
  adiafora_nn_1 = mkN "adiafora" "adiaforan" "adiafora" "adiaforana" ;
  adjektiv_nn_1 = mkN "adjektiv" neutrum ;
  adjektivattribut_nn_1 = mkN "adjektivattribut" neutrum ;
  adjektivisk_av_1 = mkA "adjektivisk" ;
  adjoe_nn_1 = mkN "adjц" "adjцt" "adjцn" "adjцna" ;
  adjunkt_nn_1 = mkN "adjunkt" "adjunkter" ;
  adjunktion_nn_1 = mkN "adjunktion" "adjunktioner" ;
  adjunktur_nn_1 = mkN "adjunktur" "adjunkturer" ;
  adjutant_nn_1 = mkN "adjutant" "adjutanter" ;
  adlig_av_1 = mkA "adlig" ;
  administration_nn_1 = mkN "administration" "administrationer" ;
  administrativ_av_1 = mkA "administrativ" ;
  administratoer_nn_1 = mkN "administratцr" "administratцrer" ;
  admonition_nn_1 = mkN "admonition" "admonitioner" ;
  adonis_nn_1 = mkN "adonis" ;
  adoptant_nn_1 = mkN "adoptant" "adoptanter" ;
  adoption_nn_1 = mkN "adoption" "adoptioner" ;
  adoptiv_av_1 = mkA "adoptiv" ;
  adoptivbarn_nn_1 = mkN "adoptivbarn" neutrum ;
  adoptivfoeraelder_nn_1 = mkN "adoptivfцrдlder" ;
  adoratoer_nn_1 = mkN "adoratцr" "adoratцrer" ;
  adrenalin_nn_1 = mkN "adrenalin" "adrenaliner" ;
  adress_nn_1 = mkN "adress" "adresser" ;
  adressat_nn_1 = mkN "adressat" "adressater" ;
  adresskort_nn_1 = mkN "adresskort" neutrum ;
  adresslapp_nn_1 = mkN "adresslapp" ;
  adstringerande_av_1 = mkA "adstringerande" ;
  adventist_nn_1 = mkN "adventist" "adventister" ;
  adventiv_av_1 = mkA "adventiv" ;
  adventsstake_nn_1 = mkN "adventsstake" utrum ;
  adverb_nn_1 = mkN "adverb" neutrum ;
  adverbial_nn_1 = mkN "adverbial" neutrum ;
  adverbiell_av_1 = mkA "adverbiell" ;
  advers_nn_1 = mkN "advers" "adverser" ;
  adversativ_av_1 = mkA "adversativ" ;
  advokat_nn_1 = mkN "advokat" "advokater" ;
  advokatfiskal_nn_1 = mkN "advokatfiskal" "advokatfiskaler" ;
  advokatorisk_av_1 = mkA "advokatorisk" ;
  advokatyr_nn_1 = mkN "advokatyr" "advokatyrer" ;
  aeckel_nn_1 = mkN "дckel" neutrum ;
  aecklig_av_1 = mkA "дcklig" ;
  aecklo_nn_1 = mkN "дcklo" "дcklot" "дcklon" "дcklona" ;
  aedel_av_1 = mkA "дdel" "дdelt" "дdla" "дdla" "дdlare" "дdlast" "дdlaste" ;
  aedelfasan_nn_1 = mkN "дdelfasan" "дdelfasaner" ;
  aedelgas_nn_1 = mkN "дdelgas" "дdelgaser" ;
  aedelgran_nn_1 = mkN "дdelgran" ;
  aedelloevtraed_nn_1 = mkN "дdellцvtrдd" neutrum ;
  aedelmetall_nn_1 = mkN "дdelmetall" "дdelmetaller" ;
  aedelmodig_av_1 = mkA "дdelmodig" ;
  aedelost_nn_1 = mkN "дdelost" ;
  aedelpekoral_nn_1 = mkN "дdelpekoral" neutrum ;
  aedelsmed_nn_1 = mkN "дdelsmed" "дdelsmeder" ;
  aedelsten_nn_1 = mkN "дdelsten" "дdelstenen" "дdelstenar" "дdelstenarna" ;
  aedling_nn_1 = mkN "дdling" ;
  aefsing_nn_1 = mkN "дfsing" ;
  aega_nn_1 = mkN "дga" ;
  aegande_nn_1 = mkN "дgande" ;
  aegare_nn_1 = mkN "дgare" "дgare" ;
  aegarform_nn_1 = mkN "дgarform" "дgarformer" ;
  aegg_nn_1 = mkN "дgg" neutrum ;
  aeggcell_nn_1 = mkN "дggcell" "дggceller" ;
  aegghinna_nn_1 = mkN "дgghinna" ;
  aeggklaeckningsmaskin_nn_1 = mkN "дggklдckningsmaskin" "дggklдckningsmaskiner" ;
  aeggkokare_nn_1 = mkN "дggkokare" "дggkokare" ;
  aeggkokning_nn_1 = mkN "дggkokning" ;
  aeggkopp_nn_1 = mkN "дggkopp" ;
  aegglaeggningsroer_nn_1 = mkN "дgglдggningsrцr" neutrum ;
  aeggledare_nn_1 = mkN "дggledare" "дggledare" ;
  aeggledartratt_nn_1 = mkN "дggledartratt" ;
  aeggliknande_av_1 = mkA "дggliknande" ;
  aegglossning_nn_1 = mkN "дgglossning" ;
  aeggost_nn_1 = mkN "дggost" ;
  aeggprickare_nn_1 = mkN "дggprickare" "дggprickare" ;
  aeggsaeck_nn_1 = mkN "дggsдck" ;
  aeggsjuk_av_1 = mkA "дggsjuk" ;
  aeggskal_nn_1 = mkN "дggskal" neutrum ;
  aeggsked_nn_1 = mkN "дggsked" ;
  aeggsnodd_nn_1 = mkN "дggsnodd" ;
  aeggstanning_nn_1 = mkN "дggstanning" ;
  aeggstav_nn_1 = mkN "дggstav" ;
  aeggstock_nn_1 = mkN "дggstock" ;
  aeggstocksinflammation_nn_1 = mkN "дggstocksinflammation" "дggstocksinflammationer" ;
  aeggsvamp_nn_1 = mkN "дggsvamp" ;
  aeggtoddy_nn_1 = mkN "дggtoddy" "дggtoddyn" "дggtoddyar" "дggtoddyarna" ;
  aeggvaermare_nn_1 = mkN "дggvдrmare" "дggvдrmare" ;
  aeggviteaemne_nn_1 = mkN "дggviteдmne" ;
  aeggviteprov_nn_1 = mkN "дggviteprov" neutrum ;
  aegiljett_nn_1 = mkN "дgiljett" "дgiljetter" ;
  aegodel_nn_1 = mkN "дgodel" "дgodelen" "дgodelar" "дgodelarna" ;
  aegodelning_nn_1 = mkN "дgodelning" ;
  aegotecken_nn_1 = mkN "дgotecken" "дgotecknet" "дgotecken" "дgotecknen" ;
  aegrett_nn_1 = mkN "дgrett" "дgretter" ;
  aegretthaeger_nn_1 = mkN "дgretthдger" ;
  aekta_av_1 = mkA "дkta" ;
  aektamakekuvert_nn_1 = mkN "дktamakekuvert" neutrum ;
  aektenskap_nn_1 = mkN "дktenskap" "дktenskapet" "дktenskapen" "дktenskapena" ;
  aektenskaplig_av_1 = mkA "дktenskaplig" ;
  aektenskapsbetyg_nn_1 = mkN "дktenskapsbetyg" neutrum ;
  aektenskapsbrott_nn_1 = mkN "дktenskapsbrott" neutrum ;
  aektenskapsbrytare_nn_1 = mkN "дktenskapsbrytare" "дktenskapsbrytare" ;
  aektenskapsbyraa_nn_1 = mkN "дktenskapsbyrе" "дktenskapsbyrеer" ;
  aektenskapscertifikat_nn_1 = mkN "дktenskapscertifikat" neutrum ;
  aektenskapsfoerord_nn_1 = mkN "дktenskapsfцrord" neutrum ;
  aektenskapshinder_nn_1 = mkN "дktenskapshinder" neutrum ;
  aektenskapsloefte_nn_1 = mkN "дktenskapslцfte" ;
  aektenskapsmaeklare_nn_1 = mkN "дktenskapsmдklare" "дktenskapsmдklare" ;
  aektenskapsskillnad_nn_1 = mkN "дktenskapsskillnad" "дktenskapsskillnader" ;
  aekthet_nn_1 = mkN "дkthet" "дktheter" ;
  aektsvensk_av_1 = mkA "дktsvensk" ;
  aelg_nn_1 = mkN "дlg" ;
  aelgjaegare_nn_1 = mkN "дlgjдgare" "дlgjдgare" ;
  aelgjakt_nn_1 = mkN "дlgjakt" "дlgjakter" ;
  aelgstudsare_nn_1 = mkN "дlgstudsare" "дlgstudsare" ;
  aelling_nn_1 = mkN "дlling" ;
  aelskare_nn_1 = mkN "дlskare" "дlskare" ;
  aelskarinna_nn_1 = mkN "дlskarinna" ;
  aelsklig_av_1 = mkA "дlsklig" ;
  aelskling_nn_1 = mkN "дlskling" ;
  aelsklingsraett_nn_1 = mkN "дlsklingsrдtt" "дlsklingsrдtter" ;
  aelskogskrank_av_1 = mkA "дlskogskrank" ;
  aelskvaerd_av_1 = mkA "дlskvдrd" "дlskvдrt" ;
  aelv_nn_1 = mkN "дlv" ;
  aelvbaedd_nn_1 = mkN "дlvbдdd" ;
  aelvbrink_nn_1 = mkN "дlvbrink" ;
  aelvdaling_nn_1 = mkN "дlvdaling" ;
  aelvkvarn_nn_1 = mkN "дlvkvarn" ;
  aelvstrand_nn_1 = mkN "дlvstrand" "дlvstrдnder" ;
  aemabel_av_1 = mkA "дmabel" "дmabelt" "дmabla" "дmabla" "дmablare" "дmablast" "дmablaste" ;
  aembar_nn_1 = mkN "дmbar" neutrum ;
  aembetsaaliggande_nn_1 = mkN "дmbetsеliggande" ;
  aembetsbrott_nn_1 = mkN "дmbetsbrott" neutrum ;
  aembetsexamen_nn_1 = mkN "дmbetsexamen" "дmbetsexamen" "дmbetsexamina" "дmbetsexamina" ;
  aembetsman_nn_1 = mkN "дmbetsman" "дmbetsmannen" "дmbetsmдn" "дmbetsmдnnen" ;
  aembetsmannaregering_nn_1 = mkN "дmbetsmannaregering" ;
  aembetsperiod_nn_1 = mkN "дmbetsperiod" "дmbetsperioder" ;
  aembetsskrud_nn_1 = mkN "дmbetsskrud" ;
  aembetstitel_nn_1 = mkN "дmbetstitel" ;
  aembetsverk_nn_1 = mkN "дmbetsverk" neutrum ;
  aemne_nn_1 = mkN "дmne" ;
  aemnesblock_nn_1 = mkN "дmnesblock" neutrum ;
  aemnesfoeretraedare_nn_1 = mkN "дmnesfцretrдdare" "дmnesfцretrдdare" ;
  aemnesgrupp_nn_1 = mkN "дmnesgrupp" "дmnesgrupper" ;
  aemnesjaern_nn_1 = mkN "дmnesjдrn" neutrum ;
  aemneskombination_nn_1 = mkN "дmneskombination" "дmneskombinationer" ;
  aemneskonferens_nn_1 = mkN "дmneskonferens" "дmneskonferenser" ;
  aemneslaerare_nn_1 = mkN "дmneslдrare" "дmneslдrare" ;
  aemnesnamn_nn_1 = mkN "дmnesnamn" neutrum ;
  aemnesomraade_nn_1 = mkN "дmnesomrеde" ;
  aen_ab_1 = mkAdv "дn" ;
  aenda_ab_1 = mkAdv "дnda" ;
  aenda_nn_1 = mkN "дnda" "дndan" "дndar" "дndarna" ;
  aendaa_ab_1 = mkAdv "дndе" ;
  aendamaal_nn_1 = mkN "дndamеl" neutrum ;
  aendamaalsenlig_av_1 = mkA "дndamеlsenlig" ;
  aendamaalsenlighet_nn_1 = mkN "дndamеlsenlighet" "дndamеlsenligheter" ;
  aendamaalsloes_av_1 = mkA "дndamеlslцs" ;
  aende_nn_1 = mkN "дnde" utrum ;
  aendelse_nn_1 = mkN "дndelse" "дndelser" ;
  aendlig_av_1 = mkA "дndlig" ;
  aendloes_av_1 = mkA "дndlцs" ;
  aendmoraen_nn_1 = mkN "дndmorдn" "дndmorдner" ;
  aendock_ab_1 = mkAdv "дndock" ;
  aendpunkt_nn_1 = mkN "дndpunkt" "дndpunkter" ;
  aendrim_nn_1 = mkN "дndrim" "дndrimmet" "дndrim" "дndrimmen" ;
  aendring_nn_1 = mkN "дndring" ;
  aendstation_nn_1 = mkN "дndstation" "дndstationer" ;
  aendtarm_nn_1 = mkN "дndtarm" ;
  aeng_ljud_nn_1 = mkN "дng-ljud" neutrum ;
  aeng_nn_1 = mkN "дng" ;
  aengd_nn_1 = mkN "дngd" "дngder" ;
  aengel_nn_1 = mkN "дngel" ;
  aenger_nn_1 = mkN "дnger" ;
  aenglakoer_nn_1 = mkN "дnglakцr" "дnglakцrer" ;
  aenglalik_av_1 = mkA "дnglalik" ;
  aenglamakerska_nn_1 = mkN "дnglamakerska" ;
  aengsknarr_nn_1 = mkN "дngsknarr" ;
  aengslig_av_1 = mkA "дngslig" ;
  aengsmark_nn_1 = mkN "дngsmark" "дngsmarker" ;
  aengsvial_nn_1 = mkN "дngsvial" "дngsvialer" ;
  aenkeaar_nn_1 = mkN "дnkeеr" neutrum ;
  aenkedok_nn_1 = mkN "дnkedok" neutrum ;
  aenkedrottning_nn_1 = mkN "дnkedrottning" ;
  aenkefru_nn_1 = mkN "дnkefru" ;
  aenkeman_nn_1 = mkN "дnkeman" "дnkemannen" "дnkemдn" "дnkemдnnen" ;
  aenkenaad_nn_1 = mkN "дnkenеd" "дnkenеder" ;
  aenkepension_nn_1 = mkN "дnkepension" "дnkepensioner" ;
  aenkestoet_nn_1 = mkN "дnkestцt" ;
  aenkling_nn_1 = mkN "дnkling" ;
  aennu_ab_1 = mkAdv "дnnu" ;
  aenterhake_nn_1 = mkN "дnterhake" utrum ;
  aenterpik_nn_1 = mkN "дnterpik" ;
  aentligen_ab_1 = mkAdv "дntligen" ;
  aentring_nn_1 = mkN "дntring" ;
  aentringsstrid_nn_1 = mkN "дntringsstrid" "дntringsstrider" ;
  aeppelkart_nn_1 = mkN "дppelkart" ;
  aeppelpraektig_av_1 = mkA "дppelprдktig" ;
  aeppelskrott_nn_1 = mkN "дppelskrott" ;
  aeppeltraed_nn_1 = mkN "дppeltrдd" neutrum ;
  aeppelvecklare_nn_1 = mkN "дppelvecklare" "дppelvecklare" ;
  aepplekart_nn_1 = mkN "дpplekart" ;
  aeppleliknande_av_1 = mkA "дppleliknande" ;
  aeppleskrott_nn_1 = mkN "дppleskrott" ;
  aeppletraed_nn_1 = mkN "дppletrдd" neutrum ;
  aerbar_av_1 = mkA "дrbar" ;
  aerebetygelse_nn_1 = mkN "дrebetygelse" "дrebetygelser" ;
  aerefoergaeten_av_1 = mkA "дrefцrgдten" "дrefцrgдtet" ;
  aeregirig_av_1 = mkA "дregirig" ;
  aereloes_av_1 = mkA "дrelцs" ;
  aerelysten_av_1 = mkA "дrelysten" "дrelystet" ;
  aerelystnad_nn_1 = mkN "дrelystnad" "дrelystnader" ;
  aereminne_nn_1 = mkN "дreminne" ;
  aerende_nn_1 = mkN "дrende" ;
  aereport_nn_1 = mkN "дreport" ;
  aereroerig_av_1 = mkA "дrerцrig" ;
  aeresak_nn_1 = mkN "дresak" "дresaker" ;
  aerevarv_nn_1 = mkN "дrevarv" neutrum ;
  aerevoerdig_av_1 = mkA "дrevцrdig" ;
  aerftlig_av_1 = mkA "дrftlig" ;
  aerftlighet_nn_1 = mkN "дrftlighet" "дrftligheter" ;
  aerftlighetsforskare_nn_1 = mkN "дrftlighetsforskare" "дrftlighetsforskare" ;
  aerftlighetslag_nn_1 = mkN "дrftlighetslag" ;
  aerggroen_av_1 = mkA "дrggrцn" ;
  aergig_av_1 = mkA "дrgig" ;
  aeril_nn_1 = mkN "дril" ;
  aerjkrok_nn_1 = mkN "дrjkrok" ;
  aerkeaengel_nn_1 = mkN "дrkeдngel" ;
  aerkebiskop_nn_1 = mkN "дrkebiskop" ;
  aerkefiende_nn_1 = mkN "дrkefiende" "дrkefiender" ;
  aerkehertig_nn_1 = mkN "дrkehertig" ;
  aerkenoet_nn_1 = mkN "дrkenцt" neutrum ;
  aerkestift_nn_1 = mkN "дrkestift" neutrum ;
  aerlig_av_1 = mkA "дrlig" ;
  aerligen_ab_1 = mkAdv "дrligen" ;
  aerlighet_nn_1 = mkN "дrlighet" "дrligheter" ;
  aerm_nn_1 = mkN "дrm" ;
  aermbraede_nn_1 = mkN "дrmbrдde" ;
  aermhaal_nn_1 = mkN "дrmhеl" neutrum ;
  aermhaallare_nn_1 = mkN "дrmhеllare" "дrmhеllare" ;
  aermlinning_nn_1 = mkN "дrmlinning" ;
  aermloes_av_1 = mkA "дrmlцs" ;
  aerob_av_1 = mkA "aerob" ;
  aerobisk_av_1 = mkA "aerobisk" ;
  aerodrom_nn_1 = mkN "aerodrom" "aerodromer" ;
  aerodynamisk_av_1 = mkA "aerodynamisk" ;
  aerofull_av_1 = mkA "дrofull" ;
  aerofylld_av_1 = mkA "дrofylld" "дrofyllt" ;
  aerogram_nn_1 = mkN "aerogram" "aerogrammet" "aerogram" "aerogrammen" ;
  aeronaut_nn_1 = mkN "aeronaut" "aeronauter" ;
  aeroplan_nn_1 = mkN "aeroplan" neutrum ;
  aerorik_av_1 = mkA "дrorik" ;
  aerosol_nn_1 = mkN "aerosol" "aerosoler" ;
  aerr_nn_1 = mkN "дrr" neutrum ;
  aerrbildning_nn_1 = mkN "дrrbildning" ;
  aerrig_av_1 = mkA "дrrig" ;
  aerrtatuering_nn_1 = mkN "дrrtatuering" ;
  aert_nn_1 = mkN "дrt" "дrter" ;
  aerta_nn_1 = mkN "дrta" ;
  aertig_av_1 = mkA "дrtig" ;
  aertvaext_nn_1 = mkN "дrtvдxt" "дrtvдxter" ;
  aertvecklare_nn_1 = mkN "дrtvecklare" "дrtvecklare" ;
  aeskande_nn_1 = mkN "дskande" ;
  aesping_nn_1 = mkN "дsping" ;
  aess_nn_1 = mkN "дss" neutrum ;
  aeta_vb_1 = mkV "дta" "еt" "дtit" ;
  aetbar_av_1 = mkA "дtbar" ;
  aetlig_av_1 = mkA "дtlig" ;
  aetpinne_nn_1 = mkN "дtpinne" utrum ;
  aett_nn_1 = mkN "дtt" "дtter" ;
  aettartavla_nn_1 = mkN "дttartavla" ;
  aettefader_nn_1 = mkN "дttefader" "дttefadern" "дttefдder" "дttefдderna" ;
  aettelaegg_nn_1 = mkN "дttelдgg" ;
  aetteled_nn_1 = mkN "дtteled" neutrum ;
  aettetal_nn_1 = mkN "дttetal" "дttetalet" "дttetalen" "дttetalena" ;
  aettetavla_nn_1 = mkN "дttetavla" ;
  aettiksinlaeggning_nn_1 = mkN "дttiksinlдggning" ;
  aettlaengd_nn_1 = mkN "дttlдngd" "дttlдngder" ;
  aettled_nn_1 = mkN "дttled" neutrum ;
  aettling_nn_1 = mkN "дttling" ;
  aettnummer_nn_1 = mkN "дttnummer" neutrum ;
  aeven_ab_1 = mkAdv "дven" ;
  aevenledes_ab_1 = mkAdv "дvenledes" ;
  aevensaa_ab_1 = mkAdv "дvensе" ;
  aeventyr_nn_1 = mkN "дventyr" neutrum ;
  aeventyrare_nn_1 = mkN "дventyrare" "дventyrare" ;
  aeventyrlig_av_1 = mkA "дventyrlig" ;
  aeventyrsbok_nn_1 = mkN "дventyrsbok" "дventyrsbцcker" ;
  aeventyrsfilm_nn_1 = mkN "дventyrsfilm" "дventyrsfilmer" ;
  aeventyrsroman_nn_1 = mkN "дventyrsroman" "дventyrsromaner" ;
  aexing_nn_1 = mkN "дxing" ;
  afasi_nn_1 = mkN "afasi" "afasier" ;
  afasisk_av_1 = mkA "afasisk" ;
  afatiker_nn_1 = mkN "afatiker" "afatikern" "afatiker" "afatikerna" ;
  afatisk_av_1 = mkA "afatisk" ;
  afelium_nn_1 = mkN "afelium" "afeliet" "afelier" "afelierna" ;
  affaer_nn_1 = mkN "affдr" "affдrer" ;
  affaersavtal_nn_1 = mkN "affдrsavtal" "affдrsavtalet" "affдrsavtalen" "affдrsavtalena" ;
  affaersbank_nn_1 = mkN "affдrsbank" "affдrsbanker" ;
  affaersbegaavning_nn_1 = mkN "affдrsbegеvning" ;
  affaersbitraede_nn_1 = mkN "affдrsbitrдde" ;
  affaersbrev_nn_1 = mkN "affдrsbrev" neutrum ;
  affaerscentrum_nn_1 = mkN "affдrscentrum" neutrum ;
  affaersdrivande_av_1 = mkA "affдrsdrivande" ;
  affaerskedja_nn_1 = mkN "affдrskedja" ;
  affaersliv_nn_1 = mkN "affдrsliv" neutrum ;
  affaersmaessig_av_1 = mkA "affдrsmдssig" ;
  affaersman_nn_1 = mkN "affдrsman" "affдrsmannen" "affдrsmдn" "affдrsmдnnen" ;
  affaerstid_nn_1 = mkN "affдrstid" "affдrstider" ;
  affaersverk_nn_1 = mkN "affдrsverk" neutrum ;
  affekt_nn_1 = mkN "affekt" "affekter" ;
  affektion_nn_1 = mkN "affektion" "affektioner" ;
  affektionsvaerde_nn_1 = mkN "affektionsvдrde" ;
  affektiv_av_1 = mkA "affektiv" ;
  affidavit_nn_1 = mkN "affidavit" neutrum ;
  affin_av_1 = mkA "affin" ;
  affinage_nn_1 = mkN "affinage" "affinaget" "affinage" "affinagen" ;
  affinitet_nn_1 = mkN "affinitet" "affiniteter" ;
  affirmativ_av_1 = mkA "affirmativ" ;
  affisch_nn_1 = mkN "affisch" "affischer" ;
  affischering_nn_1 = mkN "affischering" ;
  affischnamn_nn_1 = mkN "affischnamn" neutrum ;
  affischoer_nn_1 = mkN "affischцr" "affischцrer" ;
  affischpelare_nn_1 = mkN "affischpelare" "affischpelare" ;
  affix_nn_1 = mkN "affix" neutrum ;
  afghan_nn_1 = mkN "afghan" "afghaner" ;
  afghansk_av_1 = mkA "afghansk" ;
  aforism_nn_1 = mkN "aforism" "aforismer" ;
  aforistiker_nn_1 = mkN "aforistiker" "aforistikern" "aforistiker" "aforistikerna" ;
  aforistisk_av_1 = mkA "aforistisk" ;
  afrikan_nn_1 = mkN "afrikan" "afrikaner" ;
  afrikansk_av_1 = mkA "afrikansk" ;
  afro_asiatisk_av_1 = mkA "afro-asiatisk" ;
  afroamerikan_nn_1 = mkN "afroamerikan" "afroamerikaner" ;
  afroasiatisk_av_1 = mkA "afroasiatisk" ;
  afrodisiakum_nn_1 = mkN "afrodisiakum" "afrodisiakum" "afrodisiaka" "afrodisiakana" ;
  afrofrisyr_nn_1 = mkN "afrofrisyr" "afrofrisyrer" ;
  afse_nn_1 = mkN "afse" utrum ;
  afton_nn_1 = mkN "afton" "aftonen" "aftnar" "aftnarna" ;
  aftonboen_nn_1 = mkN "aftonbцn" "aftonbцner" ;
  aftondraekt_nn_1 = mkN "aftondrдkt" "aftondrдkter" ;
  aftongudstjaenst_nn_1 = mkN "aftongudstjдnst" "aftongudstjдnster" ;
  aftonklaenning_nn_1 = mkN "aftonklдnning" ;
  aftonrodnad_nn_1 = mkN "aftonrodnad" "aftonrodnader" ;
  aftonsaang_nn_1 = mkN "aftonsеng" "aftonsеnger" ;
  aftonvard_nn_1 = mkN "aftonvard" "aftonvarder" ;
  agat_nn_1 = mkN "agat" "agater" ;
  agave_nn_1 = mkN "agave" "agaver" ;
  agent_nn_1 = mkN "agent" "agenter" ;
  agentfilm_nn_1 = mkN "agentfilm" "agentfilmer" ;
  agentur_nn_1 = mkN "agentur" "agenturer" ;
  agerande_nn_1 = mkN "agerande" ;
  aggande_av_1 = mkA "aggande" ;
  agglomerat_nn_1 = mkN "agglomerat" neutrum ;
  agglomeration_nn_1 = mkN "agglomeration" "agglomerationer" ;
  agglutination_nn_1 = mkN "agglutination" "agglutinationer" ;
  aggregat_nn_1 = mkN "aggregat" neutrum ;
  aggregation_nn_1 = mkN "aggregation" "aggregationer" ;
  aggregationstillstaand_nn_1 = mkN "aggregationstillstеnd" neutrum ;
  aggression_nn_1 = mkN "aggression" "aggressioner" ;
  aggressionshaemning_nn_1 = mkN "aggressionshдmning" ;
  aggressiv_av_1 = mkA "aggressiv" ;
  aggressivitet_nn_1 = mkN "aggressivitet" "aggressiviteter" ;
  agitation_nn_1 = mkN "agitation" "agitationer" ;
  agitator_nn_1 = mkN "agitator" "agitatorer" ;
  agitatorisk_av_1 = mkA "agitatorisk" ;
  agn_nn_1 = mkN "agn" neutrum ;
  agnat_nn_1 = mkN "agnat" "agnater" ;
  agnatisk_av_1 = mkA "agnatisk" ;
  agnblommig_av_1 = mkA "agnblommig" ;
  agnborst_nn_1 = mkN "agnborst" neutrum ;
  agnosi_nn_1 = mkN "agnosi" "agnosier" ;
  agnostiker_nn_1 = mkN "agnostiker" "agnostikern" "agnostiker" "agnostikerna" ;
  agnostisk_av_1 = mkA "agnostisk" ;
  agoni_nn_1 = mkN "agoni" "agonier" ;
  agraff_nn_1 = mkN "agraff" "agraffer" ;
  agrar_av_1 = mkA "agrar" ;
  agrar_nn_1 = mkN "agrar" "agrarer" ;
  agreabel_av_1 = mkA "agreabel" "agreabelt" "agreabla" "agreabla" "agreablare" "agreablast" "agreablaste" ;
  agremang_nn_1 = mkN "agremang" neutrum ;
  agrikulturell_av_1 = mkA "agrikulturell" ;
  agronom_nn_1 = mkN "agronom" "agronomer" ;
  agronomisk_av_1 = mkA "agronomisk" ;
  aha_upplevelse_nn_1 = mkN "aha-upplevelse" "aha-upplevelser" ;
  air_nn_1 = mkN "air" "airer" ;
  airdaleterrier_nn_1 = mkN "airdaleterrier" "airdaleterriern" "airdaleterrier" "airdaleterrierna" ;
  akademi_nn_1 = mkN "akademi" "akademier" ;
  akademiker_nn_1 = mkN "akademiker" "akademikern" "akademiker" "akademikerna" ;
  akademisk_av_1 = mkA "akademisk" ;
  akademist_nn_1 = mkN "akademist" "akademister" ;
  akant_nn_1 = mkN "akant" "akanter" ;
  akantus_nn_1 = mkN "akantus" ;
  akatalektisk_av_1 = mkA "akatalektisk" ;
  akilleshael_nn_1 = mkN "akilleshдl" ;
  akrobat_nn_1 = mkN "akrobat" "akrobater" ;
  akrobatisk_av_1 = mkA "akrobatisk" ;
  akromatisk_av_1 = mkA "akromatisk" ;
  akromegali_nn_1 = mkN "akromegali" "akromegalier" ;
  akronym_nn_1 = mkN "akronym" "akronymer" ;
  akropol_nn_1 = mkN "akropol" "akropoler" ;
  akrostikon_nn_1 = mkN "akrostikon" neutrum ;
  akt_nn_1 = mkN "akt" "akter" ;
  akter_ab_1 = mkAdv "akter" ;
  akter_nn_1 = mkN "akter" ;
  akterdaeck_nn_1 = mkN "akterdдck" neutrum ;
  akterdel_nn_1 = mkN "akterdel" "akterdelen" "akterdelar" "akterdelarna" ;
  akterlig_av_1 = mkA "akterlig" ;
  akterskepp_nn_1 = mkN "akterskepp" neutrum ;
  akterspegel_nn_1 = mkN "akterspegel" ;
  aktie_nn_1 = mkN "aktie" "aktier" ;
  aktieaegande_nn_1 = mkN "aktieдgande" ;
  aktieaegare_nn_1 = mkN "aktieдgare" "aktieдgare" ;
  aktieboers_nn_1 = mkN "aktiebцrs" "aktiebцrser" ;
  aktiebolag_nn_1 = mkN "aktiebolag" neutrum ;
  aktiebrev_nn_1 = mkN "aktiebrev" neutrum ;
  aktieemission_nn_1 = mkN "aktieemission" "aktieemissioner" ;
  aktiekapital_nn_1 = mkN "aktiekapital" neutrum ;
  aktiekupong_nn_1 = mkN "aktiekupong" "aktiekuponger" ;
  aktiekurs_nn_1 = mkN "aktiekurs" "aktiekurser" ;
  aktiemajoritet_nn_1 = mkN "aktiemajoritet" "aktiemajoriteter" ;
  aktieportfoelj_nn_1 = mkN "aktieportfцlj" "aktieportfцljer" ;
  aktiepost_nn_1 = mkN "aktiepost" "aktieposter" ;
  aktiesparklubb_nn_1 = mkN "aktiesparklubb" ;
  aktiestock_nn_1 = mkN "aktiestock" ;
  aktieutdelning_nn_1 = mkN "aktieutdelning" ;
  aktievinst_nn_1 = mkN "aktievinst" "aktievinster" ;
  aktion_nn_1 = mkN "aktion" "aktioner" ;
  aktionsart_nn_1 = mkN "aktionsart" "aktionsarter" ;
  aktionsgrupp_nn_1 = mkN "aktionsgrupp" "aktionsgrupper" ;
  aktionsradie_nn_1 = mkN "aktionsradie" "aktionsradier" ;
  aktionssaett_nn_1 = mkN "aktionssдtt" neutrum ;
  aktionsstroem_nn_1 = mkN "aktionsstrцm" "aktionsstrцmmen" "aktionsstrцmmar" "aktionsstrцmmarna" ;
  aktionsturbin_nn_1 = mkN "aktionsturbin" "aktionsturbiner" ;
  aktiv_av_1 = mkA "aktiv" ;
  aktiva_nn_1 = mkN "aktiva" "aktivan" "aktiva" "aktivana" ;
  aktivist_nn_1 = mkN "aktivist" "aktivister" ;
  aktivitet_nn_1 = mkN "aktivitet" "aktiviteter" ;
  aktivum_nn_1 = mkN "aktivum" "aktivet" "aktiver" "aktiverna" ;
  aktningsfull_av_1 = mkA "aktningsfull" ;
  aktningsvaerd_av_1 = mkA "aktningsvдrd" "aktningsvдrt" ;
  aktoer_nn_1 = mkN "aktцr" "aktцrer" ;
  aktor_nn_1 = mkN "aktor" "aktorer" ;
  aktris_nn_1 = mkN "aktris" "aktriser" ;
  aktsam_av_1 = mkA "aktsam" "aktsamt" "aktsamma" "aktsamma" "aktsammare" "aktsammast" "aktsammaste" ;
  aktstycke_nn_1 = mkN "aktstycke" ;
  aktualitet_nn_1 = mkN "aktualitet" "aktualiteter" ;
  aktuarie_nn_1 = mkN "aktuarie" "aktuarier" ;
  aktuell_av_1 = mkA "aktuell" ;
  akustisk_av_1 = mkA "akustisk" ;
  akut_ab_1 = mkAdv "akut" ;
  akut_av_1 = mkA "akut" "akut" ;
  akut_nn_1 = mkN "akut" "akuter" ;
  akutavdelning_nn_1 = mkN "akutavdelning" ;
  akutfall_nn_1 = mkN "akutfall" neutrum ;
  akutmottagning_nn_1 = mkN "akutmottagning" ;
  akvakultur_nn_1 = mkN "akvakultur" "akvakulturer" ;
  akvamarin_nn_1 = mkN "akvamarin" "akvamariner" ;
  akvanaut_nn_1 = mkN "akvanaut" "akvanauter" ;
  akvaplaning_nn_1 = mkN "akvaplaning" ;
  akvarell_nn_1 = mkN "akvarell" "akvareller" ;
  akvarellfaerg_nn_1 = mkN "akvarellfдrg" "akvarellfдrger" ;
  akvarellist_nn_1 = mkN "akvarellist" "akvarellister" ;
  akvariefisk_nn_1 = mkN "akvariefisk" ;
  akvarium_nn_1 = mkN "akvarium" "akvariet" "akvarier" "akvarierna" ;
  akvatint_nn_1 = mkN "akvatint" "akvatinter" ;
  akvatisk_av_1 = mkA "akvatisk" ;
  akvavit_nn_1 = mkN "akvavit" "akvaviter" ;
  akvedukt_nn_1 = mkN "akvedukt" "akvedukter" ;
  al_nn_1 = mkN "al" ;
  aladaab_nn_1 = mkN "aladеb" "aladеber" ;
  alagreck_nn_1 = mkN "alagreck" "alagrecker" ;
  alan_nn_1 = mkN "alan" "alaner" ;
  alanin_nn_1 = mkN "alanin" neutrum ;
  alant_nn_1 = mkN "alant" "alanter" ;
  alarm_nn_1 = mkN "alarm" neutrum ;
  alarmerande_av_1 = mkA "alarmerande" ;
  alban_nn_1 = mkN "alban" "albaner" ;
  albansk_av_1 = mkA "albansk" ;
  albanska_nn_2 = mkN "albanska" ;
  albatross_nn_1 = mkN "albatross" "albatrosser" ;
  albigenser_nn_1 = mkN "albigenser" "albigensern" "albigenser" "albigenserna" ;
  albino_nn_1 = mkN "albino" "albinon" "albiner" "albinerna" ;
  album_nn_1 = mkN "album" neutrum ;
  albumin_nn_1 = mkN "albumin" "albuminer" ;
  albyl_nn_1 = mkN "albyl" "albylen" "albyl" "albylen" ;
  aldehyd_nn_1 = mkN "aldehyd" "aldehyder" ;
  aldrig_ab_1 = mkAdv "aldrig" ;
  alemann_nn_1 = mkN "alemann" "alemanner" ;
  alert_av_1 = mkA "alert" "alert" ;
  alexandrin_nn_1 = mkN "alexandrin" "alexandriner" ;
  alexandrinsk_av_1 = mkA "alexandrinsk" ;
  alexi_nn_1 = mkN "alexi" "alexier" ;
  alf_nn_1 = mkN "alf" "alfer" ;
  alfa_nn_1 = mkN "alfa" "alfat" "alfan" "alfana" ;
  alfaagel_nn_1 = mkN "alfеgel" ;
  alfabet_nn_1 = mkN "alfabet" neutrum ;
  alfabetisk_av_1 = mkA "alfabetisk" ;
  alfametyltyrosin_nn_1 = mkN "alfametyltyrosin" "alfametyltyrosiner" ;
  alfanumerisk_av_1 = mkA "alfanumerisk" ;
  alfapartikel_nn_1 = mkN "alfapartikel" ;
  alfastraalning_nn_1 = mkN "alfastrеlning" ;
  alfkors_nn_1 = mkN "alfkors" neutrum ;
  alfoerraedare_nn_1 = mkN "alfцrrдdare" "alfцrrдdare" ;
  alfons_nn_1 = mkN "alfons" "alfonser" ;
  alfresko_ab_1 = mkAdv "alfresko" ;
  alg_nn_1 = mkN "alg" "alger" ;
  algebraisk_av_1 = mkA "algebraisk" ;
  algerier_nn_1 = mkN "algerier" "algeriern" "algerier" "algerierna" ;
  algerisk_av_1 = mkA "algerisk" ;
  algolog_nn_1 = mkN "algolog" "algologer" ;
  algonk_nn_1 = mkN "algonk" "algonker" ;
  algoritm_nn_1 = mkN "algoritm" "algoritmer" ;
  alias_ab_1 = mkAdv "alias" ;
  alibi_nn_1 = mkN "alibi" "alibit" "alibin" "alibina" ;
  alienation_nn_1 = mkN "alienation" "alienationer" ;
  alifatisk_av_1 = mkA "alifatisk" ;
  alimentaer_av_1 = mkA "alimentдr" ;
  alkaisk_av_1 = mkA "alkaisk" ;
  alkali_nn_1 = mkN "alkali" "alkalit" "alkalier" "alkalierna" ;
  alkalimetall_nn_1 = mkN "alkalimetall" "alkalimetaller" ;
  alkalisk_av_1 = mkA "alkalisk" ;
  alkaloid_nn_1 = mkN "alkaloid" "alkaloider" ;
  alkan_nn_1 = mkN "alkan" "alkaner" ;
  alkanol_nn_1 = mkN "alkanol" "alkanoler" ;
  alkekung_nn_1 = mkN "alkekung" ;
  alkemist_nn_1 = mkN "alkemist" "alkemister" ;
  alkfaagel_nn_1 = mkN "alkfеgel" ;
  alkohol_nn_1 = mkN "alkohol" "alkoholer" ;
  alkoholhalt_nn_1 = mkN "alkoholhalt" "alkoholhalter" ;
  alkoholhaltig_av_1 = mkA "alkoholhaltig" ;
  alkoholisk_av_1 = mkA "alkoholisk" ;
  alkoholist_nn_1 = mkN "alkoholist" "alkoholister" ;
  alkoholistanstalt_nn_1 = mkN "alkoholistanstalt" "alkoholistanstalter" ;
  alkoholmissbrukare_nn_1 = mkN "alkoholmissbrukare" "alkoholmissbrukare" ;
  alkoholometer_nn_1 = mkN "alkoholometer" ;
  alkoholpsykos_nn_1 = mkN "alkoholpsykos" "alkoholpsykoser" ;
  alkoholsvag_av_1 = mkA "alkoholsvag" ;
  alkoholtest_nn_1 = mkN "alkoholtest" neutrum ;
  alkotest_nn_1 = mkN "alkotest" neutrum ;
  alkotte_nn_1 = mkN "alkotte" utrum ;
  alkov_nn_1 = mkN "alkov" "alkover" ;
  alkyd_nn_1 = mkN "alkyd" "alkyder" ;
  alkyl_nn_1 = mkN "alkyl" "alkyler" ;
  alkyn_nn_1 = mkN "alkyn" "alkyner" ;
  allaetare_nn_1 = mkN "allдtare" "allдtare" ;
  allan_ab_1 = mkAdv "allan" ;
  allaredan_ab_1 = mkAdv "allaredan" ;
  allbekant_av_1 = mkA "allbekant" "allbekant" ;
  alldaglig_av_1 = mkA "alldaglig" ;
  alldeles_ab_1 = mkAdv "alldeles" ;
  alle_nn_1 = mkN "allй" "allйer" ;
  allegat_nn_1 = mkN "allegat" neutrum ;
  allegori_nn_1 = mkN "allegori" "allegorier" ;
  allegorisk_av_1 = mkA "allegorisk" ;
  allegretto_ab_1 = mkAdv "allegretto" ;
  allegretto_nn_1 = mkN "allegretto" "allegrettot" "allegretton" "allegrettona" ;
  allegro_ab_1 = mkAdv "allegro" ;
  allegro_nn_1 = mkN "allegro" "allegrot" "allegron" "allegrona" ;
  allehanda_av_1 = mkA "allehanda" ;
  allemansfond_nn_1 = mkN "allemansfond" "allemansfonder" ;
  allena_av_1 = mkA "allena" ;
  allenaraadande_av_1 = mkA "allenarеdande" ;
  allenast_ab_1 = mkAdv "allenast" ;
  allergen_av_1 = mkA "allergen" ;
  allergen_nn_1 = mkN "allergen" neutrum ;
  allergi_nn_1 = mkN "allergi" "allergier" ;
  allergiker_nn_1 = mkN "allergiker" "allergikern" "allergiker" "allergikerna" ;
  allergisk_av_1 = mkA "allergisk" ;
  allergolog_nn_1 = mkN "allergolog" "allergologer" ;
  allestaedes_ab_1 = mkAdv "allestдdes" ;
  allfarvaeg_nn_1 = mkN "allfarvдg" ;
  allhelgonadag_nn_1 = mkN "allhelgonadag" ;
  allians_nn_1 = mkN "allians" "allianser" ;
  alliansfri_av_1 = mkA "alliansfri" "alliansfritt" ;
  alliansring_nn_1 = mkN "alliansring" ;
  alligator_nn_1 = mkN "alligator" "alligatorer" ;
  allitteration_nn_1 = mkN "allitteration" "allitterationer" ;
  allkonstverk_nn_1 = mkN "allkonstverk" neutrum ;
  allmaen_av_1 = mkA "allmдn" "allmдnt" "allmдnna" "allmдnna" "allmдnnare" "allmдnnast" "allmдnnaste" ;
  allmaenbegaavning_nn_1 = mkN "allmдnbegеvning" ;
  allmaenbegrepp_nn_1 = mkN "allmдnbegrepp" neutrum ;
  allmaenfarlig_av_1 = mkA "allmдnfarlig" ;
  allmaengiltig_av_1 = mkA "allmдngiltig" ;
  allmaengiltighet_nn_1 = mkN "allmдngiltighet" "allmдngiltigheter" ;
  allmaenhet_nn_1 = mkN "allmдnhet" "allmдnheter" ;
  allmaenmaensklig_av_1 = mkA "allmдnmдnsklig" ;
  allmaennelig_av_1 = mkA "allmдnnelig" ;
  allmaenning_nn_1 = mkN "allmдnning" ;
  allmaennyttig_av_1 = mkA "allmдnnyttig" ;
  allmaenpolitisk_av_1 = mkA "allmдnpolitisk" ;
  allmaenpraktiker_nn_1 = mkN "allmдnpraktiker" "allmдnpraktikern" "allmдnpraktiker" "allmдnpraktikerna" ;
  allmaenpraktiserande_av_1 = mkA "allmдnpraktiserande" ;
  allmaenpreventiv_av_1 = mkA "allmдnpreventiv" ;
  allmogeblaa_av_1 = mkA "allmogeblе" "allmogeblеtt" ;
  allmogedraekt_nn_1 = mkN "allmogedrдkt" "allmogedrдkter" ;
  allmogekultur_nn_1 = mkN "allmogekultur" "allmogekulturer" ;
  allmogevaevnad_nn_1 = mkN "allmogevдvnad" "allmogevдvnader" ;
  allod_nn_1 = mkN "allod" "allodet" "alloder" "alloderna" ;
  allodial_av_1 = mkA "allodial" ;
  allodium_nn_1 = mkN "allodium" "allodiet" "allodier" "allodierna" ;
  allofon_nn_1 = mkN "allofon" "allofoner" ;
  allograf_nn_1 = mkN "allograf" "allografer" ;
  allokton_av_1 = mkA "allokton" ;
  allokution_nn_1 = mkN "allokution" "allokutioner" ;
  allomfattande_av_1 = mkA "allomfattande" ;
  allomorf_av_1 = mkA "allomorf" ;
  allomorf_nn_1 = mkN "allomorf" "allomorfer" ;
  allongeperuk_nn_1 = mkN "allongeperuk" "allongeperuker" ;
  allra_ab_1 = mkAdv "allra" ;
  allraheligaste_av_1 = mkA "allraheligaste" ;
  allriskfoersaekring_nn_1 = mkN "allriskfцrsдkring" ;
  allround_av_1 = mkA "allround" ;
  allrum_nn_1 = mkN "allrum" "allrummet" "allrum" "allrummen" ;
  alls_ab_1 = mkAdv "alls" ;
  allsaang_nn_1 = mkN "allsеng" "allsеnger" ;
  allseende_av_1 = mkA "allseende" ;
  allshaerjarting_nn_1 = mkN "allshдrjarting" neutrum ;
  allsidig_av_1 = mkA "allsidig" ;
  allskoens_av_1 = mkA "allskцns" ;
  allsmaektig_av_1 = mkA "allsmдktig" ;
  allstroemsapparat_nn_1 = mkN "allstrцmsapparat" "allstrцmsapparater" ;
  allsvaaldig_av_1 = mkA "allsvеldig" ;
  allsvensk_av_1 = mkA "allsvensk" ;
  allt_ab_1 = mkAdv "allt" ;
  alltemellanaat_ab_1 = mkAdv "alltemellanеt" ;
  alltfoer_ab_1 = mkAdv "alltfцr" ;
  alltfort_ab_1 = mkAdv "alltfort" ;
  alltiallo_nn_1 = mkN "alltiallo" "alltiallor" ;
  alltid_ab_1 = mkAdv "alltid" ;
  alltigenom_ab_1 = mkAdv "alltigenom" ;
  allting_nn_1 = mkN "allting" neutrum ;
  alltjaemt_ab_1 = mkAdv "alltjдmt" ;
  alltmer_ab_1 = mkAdv "alltmer" ;
  alltmera_ab_1 = mkAdv "alltmera" ;
  alltnog_ab_1 = mkAdv "alltnog" ;
  alltomfattande_av_1 = mkA "alltomfattande" ;
  alltsaa_ab_1 = mkAdv "alltsе" ;
  alltsomoftast_ab_1 = mkAdv "alltsomoftast" ;
  allusion_nn_1 = mkN "allusion" "allusioner" ;
  alluvial_av_1 = mkA "alluvial" ;
  alluvium_nn_1 = mkN "alluvium" "alluviumet" "alluvier" "alluvierna" ;
  allvaedersstoevel_nn_1 = mkN "allvдdersstцvel" ;
  allvarlig_av_1 = mkA "allvarlig" ;
  allvarligen_ab_1 = mkAdv "allvarligen" ;
  allvarsam_av_1 = mkA "allvarsam" "allvarsamt" "allvarsamma" "allvarsamma" "allvarsammare" "allvarsammast" "allvarsammaste" ;
  allvarsord_nn_1 = mkN "allvarsord" neutrum ;
  allvarstyngd_av_1 = mkA "allvarstyngd" "allvarstyngt" ;
  allvetande_av_1 = mkA "allvetande" ;
  allvetare_nn_1 = mkN "allvetare" "allvetare" ;
  allvis_av_1 = mkA "allvis" ;
  alm_nn_1 = mkN "alm" ;
  almanacksblad_nn_1 = mkN "almanacksblad" neutrum ;
  aln_nn_1 = mkN "aln" ;
  aloe_nn_1 = mkN "aloe" "aloer" ;
  alp_nn_1 = mkN "alp" "alper" ;
  alpari_ab_1 = mkAdv "alpari" ;
  alpget_nn_1 = mkN "alpget" "alpgetter" ;
  alpin_av_1 = mkA "alpin" ;
  alpinist_nn_1 = mkN "alpinist" "alpinister" ;
  alpinsk_av_1 = mkA "alpinsk" ;
  alpjaegare_nn_1 = mkN "alpjдgare" "alpjдgare" ;
  alpviol_nn_1 = mkN "alpviol" "alpvioler" ;
  alster_nn_1 = mkN "alster" neutrum ;
  alstring_nn_1 = mkN "alstring" ;
  alt_nn_1 = mkN "alt" ;
  altan_nn_1 = mkN "altan" "altaner" ;
  altarbrun_nn_1 = mkN "altarbrun" neutrum ;
  altare_nn_1 = mkN "altare" "altaret" "altaren" "altarna" ;
  altargaang_nn_1 = mkN "altargеng" ;
  altarprydnad_nn_1 = mkN "altarprydnad" "altarprydnader" ;
  altarring_nn_1 = mkN "altarring" ;
  altarrund_nn_1 = mkN "altarrund" "altarrunder" ;
  altarskaap_nn_1 = mkN "altarskеp" neutrum ;
  altartavla_nn_1 = mkN "altartavla" ;
  altartjaenst_nn_1 = mkN "altartjдnst" "altartjдnster" ;
  alteration_nn_1 = mkN "alteration" "alterationer" ;
  alternativ_av_1 = mkA "alternativ" ;
  alternativ_nn_1 = mkN "alternativ" neutrum ;
  alternativfraaga_nn_1 = mkN "alternativfrеga" ;
  alternativkurs_nn_1 = mkN "alternativkurs" "alternativkurser" ;
  alternatvinkel_nn_1 = mkN "alternatvinkel" ;
  altfiol_nn_1 = mkN "altfiol" "altfioler" ;
  altitud_nn_1 = mkN "altitud" "altituder" ;
  altruist_nn_1 = mkN "altruist" "altruister" ;
  altruistisk_av_1 = mkA "altruistisk" ;
  altstaemma_nn_1 = mkN "altstдmma" ;
  altviolin_nn_1 = mkN "altviolin" "altvioliner" ;
  aluminiumjon_nn_1 = mkN "aluminiumjon" "aluminiumjoner" ;
  aluminiumpulver_nn_1 = mkN "aluminiumpulver" neutrum ;
  alumn_nn_1 = mkN "alumn" "alumner" ;
  alunskiffer_nn_1 = mkN "alunskiffer" ;
  alv_nn_2 = mkN "alv" "alver" ;
  alvarsmark_nn_1 = mkN "alvarsmark" "alvarsmarker" ;
  alveol_nn_1 = mkN "alveol" "alveoler" ;
  alveolar_av_1 = mkA "alveolar" ;
  alveolar_nn_1 = mkN "alveolar" "alveolarer" ;
  alvplog_nn_1 = mkN "alvplog" ;
  amalgam_nn_1 = mkN "amalgam" neutrum ;
  amanuens_nn_1 = mkN "amanuens" "amanuenser" ;
  amarant_nn_1 = mkN "amarant" "amaranter" ;
  amaryllis_nn_1 = mkN "amaryllis" ;
  amason_nn_1 = mkN "amason" "amasoner" ;
  amatoer_nn_1 = mkN "amatцr" "amatцrer" ;
  amatoerbestaemmelse_nn_1 = mkN "amatцrbestдmmelse" "amatцrbestдmmelser" ;
  amatoerforskare_nn_1 = mkN "amatцrforskare" "amatцrforskare" ;
  amatoeridrott_nn_1 = mkN "amatцridrott" "amatцridrotter" ;
  amatoermaessig_av_1 = mkA "amatцrmдssig" ;
  amatoerregel_nn_1 = mkN "amatцrregel" "amatцrregeln" "amatцrregler" "amatцrreglerna" ;
  amatoersaendare_nn_1 = mkN "amatцrsдndare" "amatцrsдndare" ;
  amatoerteleskop_nn_1 = mkN "amatцrteleskop" neutrum ;
  ambassad_nn_1 = mkN "ambassad" "ambassader" ;
  ambassadoer_nn_1 = mkN "ambassadцr" "ambassadцrer" ;
  ambassadraad_nn_1 = mkN "ambassadrеd" neutrum ;
  ambiguitet_nn_1 = mkN "ambiguitet" "ambiguiteter" ;
  ambitioes_av_1 = mkA "ambitiцs" ;
  ambition_nn_1 = mkN "ambition" "ambitioner" ;
  ambitionssak_nn_1 = mkN "ambitionssak" "ambitionssaker" ;
  ambivalent_av_1 = mkA "ambivalent" "ambivalent" ;
  ambrosisk_av_1 = mkA "ambrosisk" ;
  ambulans_nn_1 = mkN "ambulans" "ambulanser" ;
  ambulatorisk_av_1 = mkA "ambulatorisk" ;
  amendemang_nn_1 = mkN "amendemang" neutrum ;
  amerikan_nn_1 = mkN "amerikan" "amerikaner" ;
  amerikanare_nn_1 = mkN "amerikanare" "amerikanare" ;
  amerikanism_nn_1 = mkN "amerikanism" "amerikanismer" ;
  amerikansk_av_1 = mkA "amerikansk" ;
  amerikanska_nn_2 = mkN "amerikanska" ;
  ametist_nn_1 = mkN "ametist" "ametister" ;
  amfetamin_nn_1 = mkN "amfetamin" "amfetaminer" ;
  amfibie_nn_1 = mkN "amfibie" "amfibier" ;
  amfibisk_av_1 = mkA "amfibisk" ;
  amfibolit_nn_1 = mkN "amfibolit" "amfiboliter" ;
  amfiteater_nn_1 = mkN "amfiteater" ;
  amfiteatralisk_av_1 = mkA "amfiteatralisk" ;
  ami_nn_1 = mkN "ami" "amier" ;
  amid_nn_1 = mkN "amid" "amider" ;
  amin_nn_1 = mkN "amin" "aminer" ;
  amiral_nn_1 = mkN "amiral" "amiraler" ;
  amiralsperson_nn_1 = mkN "amiralsperson" "amiralspersoner" ;
  ammonit_nn_1 = mkN "ammonit" "ammoniter" ;
  ammoniumnitrat_nn_1 = mkN "ammoniumnitrat" "ammoniumnitrater" ;
  ammoniumnitratloesning_nn_1 = mkN "ammoniumnitratlцsning" ;
  amnesi_nn_1 = mkN "amnesi" "amnesier" ;
  amnesti_nn_1 = mkN "amnesti" "amnestier" ;
  amoralisk_av_1 = mkA "amoralisk" ;
  amoralitet_nn_1 = mkN "amoralitet" "amoraliteter" ;
  amorbaage_nn_1 = mkN "amorbеge" utrum ;
  amorf_av_1 = mkA "amorf" ;
  amorfism_nn_1 = mkN "amorfism" "amorfismer" ;
  amorin_nn_1 = mkN "amorin" "amoriner" ;
  amoroes_av_1 = mkA "amorцs" ;
  amortering_nn_1 = mkN "amortering" ;
  amorteringsfri_av_1 = mkA "amorteringsfri" "amorteringsfritt" ;
  amorteringsplan_nn_1 = mkN "amorteringsplan" "amorteringsplaner" ;
  ampel_av_1 = mkA "ampel" "ampelt" "ampla" "ampla" "amplare" "amplast" "amplaste" ;
  ampel_nn_1 = mkN "ampel" ;
  amper_av_1 = mkA "amper" "ampert" "ampra" "ampra" "amprare" "amprast" "ampraste" ;
  ampere_nn_1 = mkN "ampere" "amperen" "ampere" "amperena" ;
  amperemeter_nn_1 = mkN "amperemeter" ;
  amperesekund_nn_1 = mkN "amperesekund" "amperesekunder" ;
  amperevarv_nn_1 = mkN "amperevarv" neutrum ;
  amplitud_nn_1 = mkN "amplitud" "amplituder" ;
  amplitudmodulering_nn_1 = mkN "amplitudmodulering" ;
  ampull_nn_1 = mkN "ampull" "ampuller" ;
  amputation_nn_1 = mkN "amputation" "amputationer" ;
  amsaga_nn_1 = mkN "amsaga" ;
  amt_nn_1 = mkN "amt" neutrum ;
  amulett_nn_1 = mkN "amulett" "amuletter" ;
  amylas_nn_1 = mkN "amylas" "amylaser" ;
  amyotrofi_nn_1 = mkN "amyotrofi" "amyotrofier" ;
  an_ab_1 = mkAdv "an" ;
  anabaptist_nn_1 = mkN "anabaptist" "anabaptister" ;
  anabatisk_av_1 = mkA "anabatisk" ;
  anabol_nn_1 = mkN "anabol" "anaboler" ;
  anaerob_av_1 = mkA "anaerob" ;
  anafor_nn_1 = mkN "anafor" "anaforen" "anaforer" "anaforerna" ;
  anaforisk_av_1 = mkA "anaforisk" ;
  anagram_nn_1 = mkN "anagram" "anagrammet" "anagram" "anagrammen" ;
  anakolut_nn_1 = mkN "anakolut" "anakoluter" ;
  anakoret_nn_1 = mkN "anakoret" "anakoreter" ;
  anakreontisk_av_1 = mkA "anakreontisk" ;
  anakronism_nn_1 = mkN "anakronism" "anakronismer" ;
  anal_av_1 = mkA "anal" ;
  analfabet_nn_1 = mkN "analfabet" "analfabeter" ;
  analgetika_nn_1 = mkN "analgetika" "analgetikan" "analgetika" "analgetikana" ;
  analoeppning_nn_1 = mkN "analцppning" ;
  analog_av_1 = mkA "analog" ;
  analogi_nn_1 = mkN "analogi" "analogier" ;
  analogibevis_nn_1 = mkN "analogibevis" neutrum ;
  analogibildning_nn_1 = mkN "analogibildning" ;
  analogisk_av_1 = mkA "analogisk" ;
  analogislut_nn_1 = mkN "analogislut" neutrum ;
  analys_nn_1 = mkN "analys" "analyser" ;
  analytiker_nn_1 = mkN "analytiker" "analytikern" "analytiker" "analytikerna" ;
  analytisk_av_1 = mkA "analytisk" ;
  anamnes_nn_1 = mkN "anamnes" "anamneser" ;
  ananas_nn_1 = mkN "ananas" ;
  anapest_nn_1 = mkN "anapest" "anapester" ;
  anarkisk_av_1 = mkA "anarkisk" ;
  anarkist_nn_1 = mkN "anarkist" "anarkister" ;
  anarkistisk_av_1 = mkA "anarkistisk" ;
  anastas_nn_1 = mkN "anastas" "anastaser" ;
  anastatisk_av_1 = mkA "anastatisk" ;
  anastigmatisk_av_1 = mkA "anastigmatisk" ;
  anatema_nn_1 = mkN "anatema" "anatemat" "anateman" "anatemana" ;
  anatom_nn_1 = mkN "anatom" "anatomer" ;
  anatomisk_av_1 = mkA "anatomisk" ;
  anblick_nn_1 = mkN "anblick" ;
  anbrott_nn_1 = mkN "anbrott" neutrum ;
  anbud_nn_1 = mkN "anbud" neutrum ;
  anciennitet_nn_1 = mkN "anciennitet" "ancienniteter" ;
  and_nn_1 = mkN "and" "дnder" ;
  andaektig_av_1 = mkA "andдktig" ;
  andakt_nn_1 = mkN "andakt" "andakter" ;
  andaktsbok_nn_1 = mkN "andaktsbok" "andaktsbцcker" ;
  andaktsfull_av_1 = mkA "andaktsfull" ;
  andante_ab_1 = mkAdv "andante" ;
  andante_nn_1 = mkN "andante" ;
  ande_nn_1 = mkN "ande" utrum ;
  andebesvaerjare_nn_1 = mkN "andebesvдrjare" "andebesvдrjare" ;
  andebesvaerjelse_nn_1 = mkN "andebesvдrjelse" "andebesvдrjelser" ;
  andedrag_nn_1 = mkN "andedrag" neutrum ;
  andefattig_av_1 = mkA "andefattig" ;
  andefattigdom_nn_1 = mkN "andefattigdom" ;
  andel_nn_1 = mkN "andel" "andelen" "andelar" "andelarna" ;
  andelsfoerening_nn_1 = mkN "andelsfцrening" ;
  andemening_nn_1 = mkN "andemening" ;
  andeskaadare_nn_1 = mkN "andeskеdare" "andeskеdare" ;
  andetag_nn_1 = mkN "andetag" neutrum ;
  andevaesen_nn_1 = mkN "andevдsen" "andevдsendet" "andevдsen" "andevдsena" ;
  andfaadd_av_1 = mkA "andfеdd" ;
  andfaagel_nn_1 = mkN "andfеgel" ;
  andlig_av_1 = mkA "andlig" ;
  andligen_ab_1 = mkAdv "andligen" ;
  andloes_av_1 = mkA "andlцs" ;
  andning_nn_1 = mkN "andning" ;
  andningsapparat_nn_1 = mkN "andningsapparat" "andningsapparater" ;
  andningsenzym_nn_1 = mkN "andningsenzym" neutrum ;
  andningshaal_nn_1 = mkN "andningshеl" neutrum ;
  andningsorgan_nn_1 = mkN "andningsorgan" neutrum ;
  andningspaus_nn_1 = mkN "andningspaus" "andningspauser" ;
  andningsreaktion_nn_1 = mkN "andningsreaktion" "andningsreaktioner" ;
  andningsroer_nn_1 = mkN "andningsrцr" neutrum ;
  andorran_nn_1 = mkN "andorran" "andorraner" ;
  andorransk_av_1 = mkA "andorransk" ;
  andra_vb_1 = mkV "andra" "andrar" "andra" "androg" "andragit" "andragen" ;
  andrabas_nn_1 = mkN "andrabas" ;
  andrabil_nn_1 = mkN "andrabil" ;
  andrag_nn_1 = mkN "andrag" neutrum ;
  andragradsekvation_nn_1 = mkN "andragradsekvation" "andragradsekvationer" ;
  andrahandsbutik_nn_1 = mkN "andrahandsbutik" "andrahandsbutiker" ;
  andrahandsvaerde_nn_1 = mkN "andrahandsvдrde" ;
  andrake_nn_1 = mkN "andrake" utrum ;
  andraklassbiljett_nn_1 = mkN "andraklassbiljett" "andraklassbiljetter" ;
  andranamn_nn_1 = mkN "andranamn" neutrum ;
  andraplacering_nn_1 = mkN "andraplacering" ;
  andraplats_nn_1 = mkN "andraplats" "andraplatser" ;
  andratenor_nn_1 = mkN "andratenor" "andratenoren" "andratenorer" "andratenorerna" ;
  andratidning_nn_1 = mkN "andratidning" ;
  andreaskors_nn_1 = mkN "andreaskors" neutrum ;
  andrebas_nn_1 = mkN "andrebas" ;
  andretenor_nn_1 = mkN "andretenor" "andretenoren" "andretenorer" "andretenorerna" ;
  androgyn_av_1 = mkA "androgyn" ;
  androgyn_nn_1 = mkN "androgyn" "androgyner" ;
  andryg_av_1 = mkA "andryg" ;
  andstraeck_nn_1 = mkN "andstrдck" neutrum ;
  andtaeppt_av_1 = mkA "andtдppt" "andtдppt" ;
  andtruten_av_1 = mkA "andtruten" "andtrutet" ;
  andur_nn_1 = mkN "andur" "anduren" "andrar" "andrarna" ;
  anekdot_nn_1 = mkN "anekdot" "anekdoter" ;
  anekdotisk_av_1 = mkA "anekdotisk" ;
  anemi_nn_1 = mkN "anemi" "anemier" ;
  anemisk_av_1 = mkA "anemisk" ;
  anemometer_nn_1 = mkN "anemometer" ;
  anemon_nn_1 = mkN "anemon" "anemoner" ;
  aneroidbarometer_nn_1 = mkN "aneroidbarometer" ;
  anestesi_nn_1 = mkN "anestesi" "anestesier" ;
  anestesiolog_nn_1 = mkN "anestesiolog" "anestesiologer" ;
  anestetika_nn_1 = mkN "anestetika" "anestetikan" "anestetika" "anestetikana" ;
  anestetisk_av_1 = mkA "anestetisk" ;
  anfader_nn_1 = mkN "anfader" "anfadern" "anfдder" "anfдderna" ;
  anfaektelse_nn_1 = mkN "anfдktelse" "anfдktelser" ;
  anfall_nn_1 = mkN "anfall" neutrum ;
  anfalla_vb_1 = mkV "anfalla" "anfцll" "anfallit" ;
  anfallare_nn_1 = mkN "anfallare" "anfallare" ;
  anfallsbas_nn_1 = mkN "anfallsbas" "anfallsbaser" ;
  anfallsfront_nn_1 = mkN "anfallsfront" "anfallsfronter" ;
  anfallskrig_nn_1 = mkN "anfallskrig" neutrum ;
  anfallslinje_nn_1 = mkN "anfallslinje" "anfallslinjer" ;
  anfallsspel_nn_1 = mkN "anfallsspel" "anfallsspelet" "anfallsspel" "anfallsspelen" ;
  anfallsspelare_nn_1 = mkN "anfallsspelare" "anfallsspelare" ;
  anfallsvinkel_nn_1 = mkN "anfallsvinkel" ;
  anfang_nn_1 = mkN "anfang" "anfanger" ;
  anfart_nn_1 = mkN "anfart" "anfarter" ;
  anflog_nn_1 = mkN "anflog" neutrum ;
  anflygning_nn_1 = mkN "anflygning" ;
  anfoerande_nn_1 = mkN "anfцrande" ;
  anfoerare_nn_1 = mkN "anfцrare" "anfцrare" ;
  anfoering_nn_1 = mkN "anfцring" ;
  anfoeringstecken_nn_1 = mkN "anfцringstecken" "anfцringstecknet" "anfцringstecken" "anfцringstecknen" ;
  anfoeringsverb_nn_1 = mkN "anfцringsverb" neutrum ;
  anfoervant_nn_1 = mkN "anfцrvant" "anfцrvanter" ;
  ange_vb_1 = mkV "ange" "anger" "ange" "angav" "angett" "angiven" ;
  angel_nn_1 = mkN "angel" ;
  angelaegen_av_1 = mkA "angelдgen" "angelдget" ;
  angelaegenhet_nn_1 = mkN "angelдgenhet" "angelдgenheter" ;
  angelsachsare_nn_1 = mkN "angelsachsare" "angelsachsare" ;
  angelsaxare_nn_1 = mkN "angelsaxare" "angelsaxare" ;
  angenaem_av_1 = mkA "angenдm" ;
  angiosperm_nn_1 = mkN "angiosperm" "angiospermer" ;
  angivare_nn_1 = mkN "angivare" "angivare" ;
  angivelse_nn_1 = mkN "angivelse" "angivelser" ;
  angivelsebrott_nn_1 = mkN "angivelsebrott" neutrum ;
  angiveri_nn_1 = mkN "angiveri" "angiverit" "angiverier" "angiverierna" ;
  anglaes_nn_1 = mkN "anglдs" "anglдser" ;
  anglicism_nn_1 = mkN "anglicism" "anglicismer" ;
  anglikansk_av_1 = mkA "anglikansk" ;
  anglist_nn_1 = mkN "anglist" "anglister" ;
  anglosaxare_nn_1 = mkN "anglosaxare" "anglosaxare" ;
  anglosaxisk_av_1 = mkA "anglosaxisk" ;
  angolan_nn_1 = mkN "angolan" "angolaner" ;
  angolansk_av_1 = mkA "angolansk" ;
  angoraget_nn_1 = mkN "angoraget" "angoragetter" ;
  angorakatt_nn_1 = mkN "angorakatt" "angorakatter" ;
  angraensande_av_1 = mkA "angrдnsande" ;
  angrepp_nn_1 = mkN "angrepp" neutrum ;
  angreppspunkt_nn_1 = mkN "angreppspunkt" "angreppspunkter" ;
  angreppssaett_nn_1 = mkN "angreppssдtt" neutrum ;
  angripa_vb_1 = mkV "angripa" "angrep" "angripit" ;
  angripare_nn_1 = mkN "angripare" "angripare" ;
  anhaalla_vb_1 = mkV "anhеlla" "anhцll" "anhеllit" ;
  anhaallan_nn_1 = mkN "anhеllan" "anhеllan" "anhеllanden" "anhеllandena" ;
  anhaallande_nn_1 = mkN "anhеllande" ;
  anhaengare_nn_1 = mkN "anhдngare" "anhдngare" ;
  anhaengig_av_1 = mkA "anhдngig" ;
  anhalt_nn_1 = mkN "anhalt" "anhalter" ;
  anhang_nn_1 = mkN "anhang" neutrum ;
  anhoerig_av_1 = mkA "anhцrig" ;
  anhopning_nn_1 = mkN "anhopning" ;
  anilinfaerg_nn_1 = mkN "anilinfдrg" "anilinfдrger" ;
  animal_av_1 = mkA "animal" ;
  animalisk_av_1 = mkA "animalisk" ;
  animatoer_nn_1 = mkN "animatцr" "animatцrer" ;
  animistisk_av_1 = mkA "animistisk" ;
  animositet_nn_1 = mkN "animositet" "animositeter" ;
  aning_nn_1 = mkN "aning" ;
  aningsloes_av_1 = mkA "aningslцs" ;
  anisett_nn_1 = mkN "anisett" "anisetter" ;
  anjon_nn_1 = mkN "anjon" "anjoner" ;
  ankarboj_nn_1 = mkN "ankarboj" ;
  ankare_nn_1 = mkN "ankare" "ankaret" "ankare" "ankarna" ;
  ankarfly_nn_1 = mkN "ankarfly" "ankarflyt" "ankarflyn" "ankarflyen" ;
  ankargrund_nn_1 = mkN "ankargrund" "ankargrunder" ;
  ankarkabel_nn_1 = mkN "ankarkabel" ;
  ankarkaetting_nn_1 = mkN "ankarkдtting" ;
  ankarlindning_nn_1 = mkN "ankarlindning" ;
  ankarspel_nn_1 = mkN "ankarspel" "ankarspelet" "ankarspel" "ankarspelen" ;
  ankarstock_nn_1 = mkN "ankarstock" ;
  ankbonde_nn_1 = mkN "ankbonde" "ankbцnder" ;
  ankdamm_nn_1 = mkN "ankdamm" ;
  ankel_nn_1 = mkN "ankel" ;
  ankellaang_av_1 = mkA "ankellеng" ;
  anklagelse_nn_1 = mkN "anklagelse" "anklagelser" ;
  anklagelseakt_nn_1 = mkN "anklagelseakt" "anklagelseakter" ;
  anklagelsepunkt_nn_1 = mkN "anklagelsepunkt" "anklagelsepunkter" ;
  anklang_nn_1 = mkN "anklang" "anklanger" ;
  anknyta_vb_1 = mkV "anknyta" "anknцt" "anknutit" ;
  anknytning_nn_1 = mkN "anknytning" ;
  ankomma_vb_1 = mkV "ankomma" "ankom" "ankommit" ;
  ankommen_av_1 = mkA "ankommen" "ankommet" "ankomna" "ankomna" "ankomnare" "ankomnast" "ankomnaste" ;
  ankomst_nn_1 = mkN "ankomst" "ankomster" ;
  ankring_nn_1 = mkN "ankring" ;
  ankunge_nn_1 = mkN "ankunge" utrum ;
  anlaeggare_nn_1 = mkN "anlдggare" "anlдggare" ;
  anlaeggning_nn_1 = mkN "anlдggning" ;
  anlaeggningsarbetare_nn_1 = mkN "anlдggningsarbetare" "anlдggningsarbetare" ;
  anlaeggningskostnad_nn_1 = mkN "anlдggningskostnad" "anlдggningskostnader" ;
  anlaeggningsplats_nn_1 = mkN "anlдggningsplats" "anlдggningsplatser" ;
  anlaeggningstillgaang_nn_1 = mkN "anlдggningstillgеng" ;
  anlag_nn_1 = mkN "anlag" neutrum ;
  anlagsbaerare_nn_1 = mkN "anlagsbдrare" "anlagsbдrare" ;
  anlagstest_nn_1 = mkN "anlagstest" neutrum ;
  anledning_nn_1 = mkN "anledning" ;
  anletsdrag_nn_1 = mkN "anletsdrag" neutrum ;
  anlopp_nn_1 = mkN "anlopp" neutrum ;
  anloppshamn_nn_1 = mkN "anloppshamn" ;
  anlupen_av_1 = mkA "anlupen" "anlupet" ;
  anmaelan_nn_2 = mkN "anmдlan" "anmдlan" "anmдlningar" "anmдlningarna" ;
  anmaelare_nn_1 = mkN "anmдlare" "anmдlare" ;
  anmaelning_nn_1 = mkN "anmдlning" ;
  anmaelningstid_nn_1 = mkN "anmдlningstid" "anmдlningstider" ;
  anmaerkning_nn_1 = mkN "anmдrkning" ;
  anmaerkningsvaerd_av_1 = mkA "anmдrkningsvдrd" "anmдrkningsvдrt" ;
  anmodande_nn_1 = mkN "anmodande" ;
  anmoder_nn_1 = mkN "anmoder" "anmodern" "anmцdrar" "anmцdrarna" ;
  annalist_nn_1 = mkN "annalist" "annalister" ;
  annalkande_av_1 = mkA "annalkande" ;
  annandag_nn_1 = mkN "annandag" ;
  annanstans_ab_1 = mkAdv "annanstans" ;
  annars_ab_1 = mkAdv "annars" ;
  annektion_nn_1 = mkN "annektion" "annektioner" ;
  annex_nn_1 = mkN "annex" neutrum ;
  annexfoersamling_nn_1 = mkN "annexfцrsamling" ;
  annexion_nn_1 = mkN "annexion" "annexioner" ;
  annihilation_nn_1 = mkN "annihilation" "annihilationer" ;
  annons_nn_1 = mkN "annons" "annonser" ;
  annonsbyraa_nn_1 = mkN "annonsbyrе" "annonsbyrеer" ;
  annonskampanj_nn_1 = mkN "annonskampanj" "annonskampanjer" ;
  annonsoer_nn_1 = mkN "annonsцr" "annonsцrer" ;
  annonspelare_nn_1 = mkN "annonspelare" "annonspelare" ;
  annonsplats_nn_1 = mkN "annonsplats" "annonsplatser" ;
  annonssvar_nn_1 = mkN "annonssvar" neutrum ;
  annorlunda_ab_1 = mkAdv "annorlunda" ;
  annorlunda_av_1 = mkA "annorlunda" ;
  annorstaedes_ab_1 = mkAdv "annorstдdes" ;
  annotation_nn_1 = mkN "annotation" "annotationer" ;
  annuell_av_1 = mkA "annuell" ;
  annuitet_nn_1 = mkN "annuitet" "annuiteter" ;
  annuitetslaan_nn_1 = mkN "annuitetslеn" neutrum ;
  anod_nn_1 = mkN "anod" "anoder" ;
  anomali_nn_1 = mkN "anomali" "anomalier" ;
  anomi_nn_1 = mkN "anomi" "anomier" ;
  anonym_av_1 = mkA "anonym" ;
  anonymitet_nn_1 = mkN "anonymitet" "anonymiteter" ;
  anorak_nn_1 = mkN "anorak" "anoraker" ;
  anordning_nn_1 = mkN "anordning" ;
  anorexi_nn_1 = mkN "anorexi" "anorexier" ;
  anormal_av_1 = mkA "anormal" ;
  anpassbar_av_1 = mkA "anpassbar" ;
  anpasslig_av_1 = mkA "anpasslig" ;
  anpassling_nn_1 = mkN "anpassling" ;
  anpassning_nn_1 = mkN "anpassning" ;
  anpassningsgrupp_nn_1 = mkN "anpassningsgrupp" "anpassningsgrupper" ;
  anpassningsklinik_nn_1 = mkN "anpassningsklinik" "anpassningskliniker" ;
  anraettning_nn_1 = mkN "anrдttning" ;
  anrik_av_1 = mkA "anrik" ;
  anrikning_nn_1 = mkN "anrikning" ;
  anrop_nn_1 = mkN "anrop" neutrum ;
  ansaettningsskruv_nn_1 = mkN "ansдttningsskruv" ;
  ansamling_nn_1 = mkN "ansamling" ;
  ansats_nn_1 = mkN "ansats" "ansatser" ;
  ansedd_av_1 = mkA "ansedd" "ansedtt" ;
  ansenlig_av_1 = mkA "ansenlig" ;
  ansiktsbjudning_nn_1 = mkN "ansiktsbjudning" ;
  ansiktsdrag_nn_1 = mkN "ansiktsdrag" neutrum ;
  ansiktsfaerg_nn_1 = mkN "ansiktsfдrg" "ansiktsfдrger" ;
  ansiktskraem_nn_1 = mkN "ansiktskrдm" "ansiktskrдmer" ;
  ansiktslyftning_nn_1 = mkN "ansiktslyftning" ;
  ansiktsmask_nn_1 = mkN "ansiktsmask" "ansiktsmasker" ;
  ansiktsmuskel_nn_1 = mkN "ansiktsmuskel" "ansiktsmuskeln" "ansiktsmuskler" "ansiktsmusklerna" ;
  ansiktsnerv_nn_1 = mkN "ansiktsnerv" "ansiktsnerver" ;
  ansiktsskydd_nn_1 = mkN "ansiktsskydd" neutrum ;
  ansiktsuttryck_nn_1 = mkN "ansiktsuttryck" neutrum ;
  ansjovis_nn_1 = mkN "ansjovis" ;
  anskaffning_nn_1 = mkN "anskaffning" ;
  anskraemlig_av_1 = mkA "anskrдmlig" ;
  anskri_nn_1 = mkN "anskri" "anskrit" "anskrin" "anskrien" ;
  anskriven_av_1 = mkA "anskriven" "anskrivet" ;
  anslaaende_av_1 = mkA "anslеende" ;
  anslag_nn_1 = mkN "anslag" neutrum ;
  anslagsaeskande_nn_1 = mkN "anslagsдskande" ;
  anslagsbeviljande_av_1 = mkA "anslagsbeviljande" ;
  anslagsframstaellning_nn_1 = mkN "anslagsframstдllning" ;
  anslagstavla_nn_1 = mkN "anslagstavla" ;
  ansluta_vb_1 = mkV "ansluta" "anslцt" "anslutit" ;
  anslutning_nn_1 = mkN "anslutning" ;
  ansoekning_nn_1 = mkN "ansцkning" ;
  ansoekningshandling_nn_1 = mkN "ansцkningshandling" ;
  ansoekningstid_nn_1 = mkN "ansцkningstid" "ansцkningstider" ;
  anspaend_av_1 = mkA "anspдnd" ;
  anspann_nn_1 = mkN "anspann" neutrum ;
  anspelning_nn_1 = mkN "anspelning" ;
  anspraak_nn_1 = mkN "ansprеk" neutrum ;
  anspraaksfull_av_1 = mkA "ansprеksfull" ;
  anspraaksloes_av_1 = mkA "ansprеkslцs" ;
  anspraaksloeshet_nn_1 = mkN "ansprеkslцshet" "ansprеkslцsheter" ;
  anstaand_nn_1 = mkN "anstеnd" neutrum ;
  anstaellning_nn_1 = mkN "anstдllning" ;
  anstaellningsavtal_nn_1 = mkN "anstдllningsavtal" "anstдllningsavtalet" "anstдllningsavtalen" "anstдllningsavtalena" ;
  anstaellningsskydd_nn_1 = mkN "anstдllningsskydd" neutrum ;
  anstaendig_av_1 = mkA "anstдndig" ;
  anstaendighet_nn_1 = mkN "anstдndighet" "anstдndigheter" ;
  anstaendigtvis_ab_1 = mkAdv "anstдndigtvis" ;
  anstalt_nn_1 = mkN "anstalt" "anstalter" ;
  anstiftare_nn_1 = mkN "anstiftare" "anstiftare" ;
  anstoetlig_av_1 = mkA "anstцtlig" ;
  anstormning_nn_1 = mkN "anstormning" ;
  anstraengande_av_1 = mkA "anstrдngande" ;
  anstraengd_av_1 = mkA "anstrдngd" "anstrдngt" ;
  anstraengning_nn_1 = mkN "anstrдngning" ;
  anstruken_av_1 = mkA "anstruken" "anstruket" ;
  anstryka_vb_1 = mkV "anstryka" "anstrцk" "anstrukit" ;
  anstrykare_nn_1 = mkN "anstrykare" "anstrykare" ;
  anstrykning_nn_1 = mkN "anstrykning" ;
  anstucken_av_1 = mkA "anstucken" "anstucket" ;
  ansvaelld_av_1 = mkA "ansvдlld" "ansvдllt" ;
  ansvaellning_nn_1 = mkN "ansvдllning" ;
  ansvarig_av_1 = mkA "ansvarig" ;
  ansvarighetsfoersaekring_nn_1 = mkN "ansvarighetsfцrsдkring" ;
  ansvaring_nn_1 = mkN "ansvaring" ;
  ansvarsfoersaekring_nn_1 = mkN "ansvarsfцrsдkring" ;
  ansvarsfrihet_nn_1 = mkN "ansvarsfrihet" "ansvarsfriheter" ;
  ansvarsfull_av_1 = mkA "ansvarsfull" ;
  ansvarskaennande_av_1 = mkA "ansvarskдnnande" ;
  ansvarsloes_av_1 = mkA "ansvarslцs" ;
  ansvarsnaemnd_nn_1 = mkN "ansvarsnдmnd" "ansvarsnдmnder" ;
  anta_vb_1 = mkV "anta" "antar" "anta" "antog" "antagit" "antagen" ;
  antaag_nn_1 = mkN "antеg" neutrum ;
  antaendning_nn_1 = mkN "antдndning" ;
  antagande_nn_1 = mkN "antagande" ;
  antaglig_av_1 = mkA "antaglig" ;
  antagligen_ab_1 = mkAdv "antagligen" ;
  antagning_nn_1 = mkN "antagning" ;
  antagonist_nn_1 = mkN "antagonist" "antagonister" ;
  antagonistisk_av_1 = mkA "antagonistisk" ;
  antal_nn_1 = mkN "antal" "antalet" "antalen" "antalena" ;
  antarktisk_av_1 = mkA "antarktisk" ;
  antecedentia_nn_1 = mkN "antecedentia" "antecedentian" "antecedentia" "antecedentiana" ;
  antecipation_nn_1 = mkN "antecipation" "antecipationer" ;
  antecipativ_av_1 = mkA "antecipativ" ;
  anteckning_nn_1 = mkN "anteckning" ;
  anteckningsblock_nn_1 = mkN "anteckningsblock" neutrum ;
  anteckningsbok_nn_1 = mkN "anteckningsbok" "anteckningsbцcker" ;
  antediluviansk_av_1 = mkA "antediluviansk" ;
  antenn_nn_1 = mkN "antenn" "antenner" ;
  antependium_nn_1 = mkN "antependium" "antependiet" "antependier" "antependierna" ;
  antepenultima_nn_1 = mkN "antepenultima" ;
  antibarbarus_nn_1 = mkN "antibarbarus" ;
  antibiotika_nn_1 = mkN "antibiotika" ;
  antibiotikum_nn_1 = mkN "antibiotikum" "antibiotikum" "antibiotika" "antibiotikana" ;
  antibiotisk_av_1 = mkA "antibiotisk" ;
  anticyklon_nn_1 = mkN "anticyklon" "anticykloner" ;
  antidepressiv_av_1 = mkA "antidepressiv" ;
  antidot_nn_1 = mkN "antidot" "antidotet" "antidoter" "antidoterna" ;
  antifoni_nn_1 = mkN "antifoni" "antifonier" ;
  antigen_nn_1 = mkN "antigen" "antigener" ;
  antihistamin_nn_1 = mkN "antihistamin" "antihistaminet" "antihistaminer" "antihistaminerna" ;
  antihjaelte_nn_1 = mkN "antihjдlte" utrum ;
  antiintellektuell_av_1 = mkA "antiintellektuell" ;
  antik_av_1 = mkA "antik" ;
  antiklerikal_av_1 = mkA "antiklerikal" ;
  antiklimax_nn_1 = mkN "antiklimax" ;
  antiklinal_nn_1 = mkN "antiklinal" "antiklinaler" ;
  antikljus_nn_1 = mkN "antikljus" neutrum ;
  antikonceptionell_av_1 = mkA "antikonceptionell" ;
  antikropp_nn_1 = mkN "antikropp" ;
  antikvariat_nn_1 = mkN "antikvariat" neutrum ;
  antikvarie_nn_1 = mkN "antikvarie" "antikvarier" ;
  antikvarisk_av_1 = mkA "antikvarisk" ;
  antikvitet_nn_1 = mkN "antikvitet" "antikviteter" ;
  antilop_nn_1 = mkN "antilop" "antiloper" ;
  antimakass_nn_1 = mkN "antimakass" "antimakasser" ;
  antimilitarist_nn_1 = mkN "antimilitarist" "antimilitarister" ;
  antimilitaristisk_av_1 = mkA "antimilitaristisk" ;
  antingen_ab_1 = mkAdv "antingen" ;
  antinomi_nn_1 = mkN "antinomi" "antinomier" ;
  antipartikel_nn_1 = mkN "antipartikel" ;
  antipassad_nn_1 = mkN "antipassad" "antipassader" ;
  antipati_nn_1 = mkN "antipati" "antipatier" ;
  antipod_nn_1 = mkN "antipod" "antipoder" ;
  antisemit_nn_1 = mkN "antisemit" "antisemiter" ;
  antisemitisk_av_1 = mkA "antisemitisk" ;
  antiseptika_nn_1 = mkN "antiseptika" "antiseptikan" "antiseptika" "antiseptikana" ;
  antiseptisk_av_1 = mkA "antiseptisk" ;
  antisionistisk_av_1 = mkA "antisionistisk" ;
  antistatisk_av_1 = mkA "antistatisk" ;
  antistatmedel_nn_1 = mkN "antistatmedel" neutrum ;
  antites_nn_1 = mkN "antites" "antiteser" ;
  antitetisk_av_1 = mkA "antitetisk" ;
  antitoxin_nn_1 = mkN "antitoxin" "antitoxiner" ;
  antologi_nn_1 = mkN "antologi" "antologier" ;
  antonym_nn_1 = mkN "antonym" "antonymer" ;
  antraeffbar_av_1 = mkA "antrдffbar" ;
  antropisk_av_1 = mkA "antropisk" ;
  antropocentrisk_av_1 = mkA "antropocentrisk" ;
  antropofag_nn_1 = mkN "antropofag" "antropofager" ;
  antropoid_nn_1 = mkN "antropoid" "antropoider" ;
  antropolog_nn_1 = mkN "antropolog" "antropologer" ;
  antropomorf_av_1 = mkA "antropomorf" ;
  antroposof_nn_1 = mkN "antroposof" "antroposofer" ;
  antroposofisk_av_1 = mkA "antroposofisk" ;
  antydning_nn_1 = mkN "antydning" ;
  antydningsvis_ab_1 = mkAdv "antydningsvis" ;
  anvaendande_nn_1 = mkN "anvдndande" ;
  anvaendare_nn_1 = mkN "anvдndare" "anvдndare" ;
  anvaendbar_av_1 = mkA "anvдndbar" ;
  anvaendbarhet_nn_1 = mkN "anvдndbarhet" "anvдndbarheter" ;
  anvaendning_nn_1 = mkN "anvдndning" ;
  anvaendningsomraade_nn_1 = mkN "anvдndningsomrеde" ;
  anvisning_nn_1 = mkN "anvisning" ;
  anvisningslaekare_nn_1 = mkN "anvisningslдkare" "anvisningslдkare" ;
  aorist_nn_1 = mkN "aorist" "aorister" ;
  apache_nn_1 = mkN "apache" "apacher" ;
  apanage_nn_1 = mkN "apanage" "apanaget" "apanage" "apanagen" ;
  apart_av_1 = mkA "apart" "apart" ;
  apart_nn_1 = mkN "apart" "aparter" ;
  apati_nn_1 = mkN "apati" "apatier" ;
  apatisk_av_1 = mkA "apatisk" ;
  apbroedstraed_nn_1 = mkN "apbrцdstrдd" neutrum ;
  apekatt_nn_1 = mkN "apekatt" "apekatter" ;
  apel_nn_1 = mkN "apel" ;
  apelgraa_av_1 = mkA "apelgrе" "apelgrеtt" ;
  apelsin_nn_1 = mkN "apelsin" "apelsiner" ;
  aperitif_nn_1 = mkN "aperitif" "aperitifer" ;
  apertur_nn_1 = mkN "apertur" "aperturer" ;
  apetidin_nn_1 = mkN "apetidin" "apetidiner" ;
  aphelium_nn_1 = mkN "aphelium" "apheliet" "aphelier" "aphelierna" ;
  apmaenniska_nn_1 = mkN "apmдnniska" ;
  apodiktisk_av_1 = mkA "apodiktisk" ;
  apokalyps_nn_1 = mkN "apokalyps" "apokalypser" ;
  apokalyptisk_av_1 = mkA "apokalyptisk" ;
  apokryfisk_av_1 = mkA "apokryfisk" ;
  apollinisk_av_1 = mkA "apollinisk" ;
  apollofjaeril_nn_1 = mkN "apollofjдril" ;
  apologet_nn_1 = mkN "apologet" "apologeter" ;
  apologetisk_av_1 = mkA "apologetisk" ;
  apologi_nn_1 = mkN "apologi" "apologier" ;
  apoplektisk_av_1 = mkA "apoplektisk" ;
  apoplexi_nn_1 = mkN "apoplexi" "apoplexier" ;
  apostel_nn_1 = mkN "apostel" ;
  aposteriorisk_av_1 = mkA "aposteriorisk" ;
  apostolisk_av_1 = mkA "apostolisk" ;
  apostrof_nn_1 = mkN "apostrof" "apostrofer" ;
  apotek_nn_1 = mkN "apotek" neutrum ;
  apotekare_nn_1 = mkN "apotekare" "apotekare" ;
  apoteksvaext_nn_1 = mkN "apoteksvдxt" "apoteksvдxter" ;
  apoteos_nn_1 = mkN "apoteos" "apoteoser" ;
  apparans_nn_1 = mkN "apparans" "apparanser" ;
  apparat_nn_1 = mkN "apparat" "apparater" ;
  apparatur_nn_1 = mkN "apparatur" "apparaturer" ;
  apparition_nn_1 = mkN "apparition" "apparitioner" ;
  appell_nn_1 = mkN "appell" "appeller" ;
  appellant_nn_1 = mkN "appellant" "appellanter" ;
  appellationsdomstol_nn_1 = mkN "appellationsdomstol" ;
  appellativ_nn_1 = mkN "appellativ" neutrum ;
  appendicit_nn_1 = mkN "appendicit" "appendiciter" ;
  appendix_nn_1 = mkN "appendix" neutrum ;
  apperception_nn_1 = mkN "apperception" "apperceptioner" ;
  applaad_nn_1 = mkN "applеd" "applеder" ;
  applikation_nn_1 = mkN "applikation" "applikationer" ;
  applikatorisk_av_1 = mkA "applikatorisk" ;
  applikatur_nn_1 = mkN "applikatur" "applikaturer" ;
  apposition_nn_1 = mkN "apposition" "appositioner" ;
  appreciering_nn_1 = mkN "appreciering" ;
  appretyr_nn_1 = mkN "appretyr" "appretyrer" ;
  approach_nn_1 = mkN "approach" "approacher" ;
  approbabel_av_1 = mkA "approbabel" "approbabelt" "approbabla" "approbabla" "approbablare" "approbablast" "approbablaste" ;
  approbatur_nn_1 = mkN "approbatur" neutrum ;
  approximation_nn_1 = mkN "approximation" "approximationer" ;
  approximationsteori_nn_1 = mkN "approximationsteori" "approximationsteorier" ;
  approximativ_av_1 = mkA "approximativ" ;
  aprikos_nn_1 = mkN "aprikos" "aprikoser" ;
  aprildag_nn_1 = mkN "aprildag" ;
  aprilskaemt_nn_1 = mkN "aprilskдmt" neutrum ;
  apriorisk_av_1 = mkA "apriorisk" ;
  apropaa_ab_1 = mkAdv "apropе" ;
  apropaa_nn_1 = mkN "apropе" "apropеt" "apropеn" "apropеna" ;
  apsort_nn_1 = mkN "apsort" "apsorter" ;
  apspel_nn_1 = mkN "apspel" "apspelet" "apspel" "apspelen" ;
  aptitlig_av_1 = mkA "aptitlig" ;
  aptitloeshet_nn_1 = mkN "aptitlцshet" "aptitlцsheter" ;
  aptitretande_av_1 = mkA "aptitretande" ;
  aptitretare_nn_1 = mkN "aptitretare" "aptitretare" ;
  ar_nn_1 = mkN "ar" neutrum ;
  arab_nn_1 = mkN "arab" "araber" ;
  arabesk_nn_1 = mkN "arabesk" "arabesker" ;
  arabisk_av_1 = mkA "arabisk" ;
  arabiska_nn_2 = mkN "arabiska" ;
  arabist_nn_1 = mkN "arabist" "arabister" ;
  arbetare_nn_1 = mkN "arbetare" "arbetare" ;
  arbetarfoerening_nn_1 = mkN "arbetarfцrening" ;
  arbetargrupp_nn_1 = mkN "arbetargrupp" "arbetargrupper" ;
  arbetarklass_nn_1 = mkN "arbetarklass" "arbetarklasser" ;
  arbetarkommun_nn_1 = mkN "arbetarkommun" "arbetarkommuner" ;
  arbetarparti_nn_1 = mkN "arbetarparti" "arbetarpartit" "arbetarpartier" "arbetarpartierna" ;
  arbetarraad_nn_1 = mkN "arbetarrеd" neutrum ;
  arbetarregering_nn_1 = mkN "arbetarregering" ;
  arbetarroerelse_nn_1 = mkN "arbetarrцrelse" "arbetarrцrelser" ;
  arbetarsaang_nn_1 = mkN "arbetarsеng" "arbetarsеnger" ;
  arbetsaar_nn_1 = mkN "arbetsеr" neutrum ;
  arbetsam_av_1 = mkA "arbetsam" "arbetsamt" "arbetsamma" "arbetsamma" "arbetsammare" "arbetsammast" "arbetsammaste" ;
  arbetsanstalt_nn_1 = mkN "arbetsanstalt" "arbetsanstalter" ;
  arbetsavtal_nn_1 = mkN "arbetsavtal" "arbetsavtalet" "arbetsavtalen" "arbetsavtalena" ;
  arbetsbeskrivning_nn_1 = mkN "arbetsbeskrivning" ;
  arbetsbesparande_av_1 = mkA "arbetsbesparande" ;
  arbetsbi_nn_1 = mkN "arbetsbi" "arbetsbit" "arbetsbin" "arbetsbien" ;
  arbetsboerda_nn_1 = mkN "arbetsbцrda" ;
  arbetsbok_nn_1 = mkN "arbetsbok" "arbetsbцcker" ;
  arbetsbord_nn_1 = mkN "arbetsbord" neutrum ;
  arbetsbyte_nn_1 = mkN "arbetsbyte" ;
  arbetsdag_nn_1 = mkN "arbetsdag" ;
  arbetsdelning_nn_1 = mkN "arbetsdelning" ;
  arbetsdomstol_nn_1 = mkN "arbetsdomstol" ;
  arbetsduglig_av_1 = mkA "arbetsduglig" ;
  arbetsfaelt_nn_1 = mkN "arbetsfдlt" neutrum ;
  arbetsfoer_av_1 = mkA "arbetsfцr" ;
  arbetsfoermedling_nn_1 = mkN "arbetsfцrmedling" ;
  arbetsfoertjaenst_nn_1 = mkN "arbetsfцrtjдnst" "arbetsfцrtjдnster" ;
  arbetsform_nn_1 = mkN "arbetsform" "arbetsformer" ;
  arbetsfri_av_1 = mkA "arbetsfri" "arbetsfritt" ;
  arbetsgivaravgift_nn_1 = mkN "arbetsgivaravgift" "arbetsgivaravgifter" ;
  arbetsgivare_nn_1 = mkN "arbetsgivare" "arbetsgivare" ;
  arbetsgivarfoerening_nn_1 = mkN "arbetsgivarfцrening" ;
  arbetsgivarintraede_nn_1 = mkN "arbetsgivarintrдde" ;
  arbetsgrupp_nn_1 = mkN "arbetsgrupp" "arbetsgrupper" ;
  arbetshypotes_nn_1 = mkN "arbetshypotes" "arbetshypoteser" ;
  arbetsinkomst_nn_1 = mkN "arbetsinkomst" "arbetsinkomster" ;
  arbetsinsats_nn_1 = mkN "arbetsinsats" "arbetsinsatser" ;
  arbetsinstaellelse_nn_1 = mkN "arbetsinstдllelse" "arbetsinstдllelser" ;
  arbetsintensiv_av_1 = mkA "arbetsintensiv" ;
  arbetskamrat_nn_1 = mkN "arbetskamrat" "arbetskamrater" ;
  arbetskoepare_nn_1 = mkN "arbetskцpare" "arbetskцpare" ;
  arbetskonflikt_nn_1 = mkN "arbetskonflikt" "arbetskonflikter" ;
  arbetslaeger_nn_1 = mkN "arbetslдger" neutrum ;
  arbetsledare_nn_1 = mkN "arbetsledare" "arbetsledare" ;
  arbetslivserfarenhet_nn_1 = mkN "arbetslivserfarenhet" "arbetslivserfarenheter" ;
  arbetsloes_av_1 = mkA "arbetslцs" ;
  arbetsloeshet_nn_1 = mkN "arbetslцshet" "arbetslцsheter" ;
  arbetsmaengd_nn_1 = mkN "arbetsmдngd" "arbetsmдngder" ;
  arbetsmaetning_nn_1 = mkN "arbetsmдtning" ;
  arbetsmarknad_nn_1 = mkN "arbetsmarknad" "arbetsmarknader" ;
  arbetsmarknadspolitik_nn_1 = mkN "arbetsmarknadspolitik" "arbetsmarknadspolitiker" ;
  arbetsmarknadspolitisk_av_1 = mkA "arbetsmarknadspolitisk" ;
  arbetsmarknadsutbildning_nn_1 = mkN "arbetsmarknadsutbildning" ;
  arbetsmaskin_nn_1 = mkN "arbetsmaskin" "arbetsmaskiner" ;
  arbetsmaterial_nn_1 = mkN "arbetsmaterial" neutrum ;
  arbetsmiljoe_nn_1 = mkN "arbetsmiljц" "arbetsmiljцn" "arbetsmiljцer" "arbetsmiljцerna" ;
  arbetsmoment_nn_1 = mkN "arbetsmoment" "arbetsmomentet" "arbetsmomenten" "arbetsmomentena" ;
  arbetsmoral_nn_1 = mkN "arbetsmoral" "arbetsmoraler" ;
  arbetsnaemnd_nn_1 = mkN "arbetsnдmnd" "arbetsnдmnder" ;
  arbetsnamn_nn_1 = mkN "arbetsnamn" neutrum ;
  arbetsnarkoman_nn_1 = mkN "arbetsnarkoman" "arbetsnarkomaner" ;
  arbetsnedlaeggelse_nn_1 = mkN "arbetsnedlдggelse" "arbetsnedlдggelser" ;
  arbetsomraade_nn_1 = mkN "arbetsomrеde" ;
  arbetsordning_nn_1 = mkN "arbetsordning" ;
  arbetspass_nn_1 = mkN "arbetspass" neutrum ;
  arbetsplats_nn_1 = mkN "arbetsplats" "arbetsplatser" ;
  arbetsplenum_nn_1 = mkN "arbetsplenum" neutrum ;
  arbetsprov_nn_1 = mkN "arbetsprov" neutrum ;
  arbetsredskap_nn_1 = mkN "arbetsredskap" "arbetsredskapet" "arbetsredskapen" "arbetsredskapena" ;
  arbetsrum_nn_1 = mkN "arbetsrum" "arbetsrummet" "arbetsrum" "arbetsrummen" ;
  arbetssaang_nn_1 = mkN "arbetssеng" "arbetssеnger" ;
  arbetssaett_nn_1 = mkN "arbetssдtt" neutrum ;
  arbetsseger_nn_1 = mkN "arbetsseger" ;
  arbetsskygg_av_1 = mkA "arbetsskygg" ;
  arbetssoekande_nn_1 = mkN "arbetssцkande" "arbetssцkanden" "arbetssцkande" "arbetssцkandena" ;
  arbetsstudieman_nn_1 = mkN "arbetsstudieman" "arbetsstudiemannen" "arbetsstudiemдn" "arbetsstudiemдnnen" ;
  arbetstagare_nn_1 = mkN "arbetstagare" "arbetstagare" ;
  arbetstemperatur_nn_1 = mkN "arbetstemperatur" "arbetstemperaturer" ;
  arbetsterapeut_nn_1 = mkN "arbetsterapeut" "arbetsterapeuter" ;
  arbetstid_nn_1 = mkN "arbetstid" "arbetstider" ;
  arbetstillfaelle_nn_1 = mkN "arbetstillfдlle" ;
  arbetstillstaand_nn_1 = mkN "arbetstillstеnd" neutrum ;
  arbetstvist_nn_1 = mkN "arbetstvist" "arbetstvister" ;
  arbetsuppgift_nn_1 = mkN "arbetsuppgift" "arbetsuppgifter" ;
  arbetsutskott_nn_1 = mkN "arbetsutskott" neutrum ;
  arbetsvaerdering_nn_1 = mkN "arbetsvдrdering" ;
  arbetsvecka_nn_1 = mkN "arbetsvecka" ;
  arbetsvilja_nn_1 = mkN "arbetsvilja" ;
  arbetsvillig_av_1 = mkA "arbetsvillig" ;
  arbitraer_av_1 = mkA "arbitrдr" ;
  arboretum_nn_1 = mkN "arboretum" neutrum ;
  arborr_nn_1 = mkN "arborr" ;
  ardenner_nn_1 = mkN "ardenner" "ardennern" "ardenner" "ardennerna" ;
  areal_nn_1 = mkN "areal" "arealer" ;
  arena_nn_1 = mkN "arena" ;
  arenateater_nn_1 = mkN "arenateater" ;
  areometer_nn_1 = mkN "areometer" ;
  areopag_nn_1 = mkN "areopag" "areopager" ;
  arg_av_1 = mkA "arg" ;
  argentinare_nn_1 = mkN "argentinare" "argentinare" ;
  argentinsk_av_1 = mkA "argentinsk" ;
  argentinska_nn_1 = mkN "argentinska" ;
  argsint_av_1 = mkA "argsint" "argsint" ;
  argument_nn_1 = mkN "argument" neutrum ;
  argumentation_nn_1 = mkN "argumentation" "argumentationer" ;
  argumentering_nn_1 = mkN "argumentering" ;
  argusoega_nn_1 = mkN "argusцga" "argusцgat" "argusцgon" "argusцgonen" ;
  ariadnetraad_nn_1 = mkN "ariadnetrеd" ;
  arian_nn_1 = mkN "arian" "arianer" ;
  ariansk_av_1 = mkA "ariansk" ;
  arier_nn_1 = mkN "arier" "ariern" "arier" "arierna" ;
  arioso_nn_1 = mkN "arioso" "ariosot" "arioson" "ariosona" ;
  arisk_av_1 = mkA "arisk" ;
  aristokrat_nn_1 = mkN "aristokrat" "aristokrater" ;
  aristokrati_nn_1 = mkN "aristokrati" "aristokratier" ;
  aristokratisk_av_1 = mkA "aristokratisk" ;
  aritmetisk_av_1 = mkA "aritmetisk" ;
  ark_nn_1 = mkN "ark" neutrum ;
  arkad_nn_1 = mkN "arkad" "arkader" ;
  arkadisk_av_1 = mkA "arkadisk" ;
  arkadspel_nn_1 = mkN "arkadspel" "arkadspelet" "arkadspel" "arkadspelen" ;
  arkaisk_av_1 = mkA "arkaisk" ;
  arkaism_nn_1 = mkN "arkaism" "arkaismer" ;
  arkaistisk_av_1 = mkA "arkaistisk" ;
  arkebusering_nn_1 = mkN "arkebusering" ;
  arkeolog_nn_1 = mkN "arkeolog" "arkeologer" ;
  arkeologisk_av_1 = mkA "arkeologisk" ;
  arketyp_nn_1 = mkN "arketyp" "arketyper" ;
  arketypisk_av_1 = mkA "arketypisk" ;
  arkiater_nn_1 = mkN "arkiater" "arkiatern" "arkiatrer" "arkiatrerna" ;
  arkipelag_nn_1 = mkN "arkipelag" "arkipelager" ;
  arkitekt_nn_1 = mkN "arkitekt" "arkitekter" ;
  arkitektonisk_av_1 = mkA "arkitektonisk" ;
  arkitektur_nn_1 = mkN "arkitektur" "arkitekturer" ;
  arkitrav_nn_1 = mkN "arkitrav" "arkitraver" ;
  arkiv_nn_1 = mkN "arkiv" neutrum ;
  arkivalisk_av_1 = mkA "arkivalisk" ;
  arkivarbetare_nn_1 = mkN "arkivarbetare" "arkivarbetare" ;
  arkivarie_nn_1 = mkN "arkivarie" "arkivarier" ;
  arkivexemplar_nn_1 = mkN "arkivexemplar" neutrum ;
  arksignatur_nn_1 = mkN "arksignatur" "arksignaturer" ;
  arktisk_av_1 = mkA "arktisk" ;
  arla_ab_1 = mkAdv "arla" ;
  arm_av_1 = mkA "arm" ;
  arm_nn_1 = mkN "arm" ;
  armatur_nn_1 = mkN "armatur" "armaturer" ;
  armbaage_nn_1 = mkN "armbеge" utrum ;
  armbaagsben_nn_1 = mkN "armbеgsben" neutrum ;
  armbaagsled_nn_1 = mkN "armbеgsled" "armbеgsleder" ;
  armband_nn_1 = mkN "armband" neutrum ;
  armbandsur_nn_1 = mkN "armbandsur" neutrum ;
  armbindel_nn_1 = mkN "armbindel" ;
  armboejning_nn_1 = mkN "armbцjning" ;
  armborst_nn_1 = mkN "armborst" neutrum ;
  armborstpil_nn_1 = mkN "armborstpil" ;
  armbrott_nn_1 = mkN "armbrott" neutrum ;
  armbrytning_nn_1 = mkN "armbrytning" ;
  arme_nn_1 = mkN "armй" "armйer" ;
  armechef_nn_1 = mkN "armйchef" "armйchefer" ;
  armefoerband_nn_1 = mkN "armйfцrband" neutrum ;
  armegevaer_nn_1 = mkN "armйgevдr" neutrum ;
  armehaest_nn_1 = mkN "armйhдst" ;
  armekaar_nn_1 = mkN "armйkеr" "armйkеrer" ;
  armenier_nn_1 = mkN "armenier" "armeniern" "armenier" "armenierna" ;
  armenisk_av_1 = mkA "armenisk" ;
  armeniska_nn_2 = mkN "armeniska" ;
  armering_nn_1 = mkN "armering" ;
  armeringsjaern_nn_1 = mkN "armeringsjдrn" neutrum ;
  armfoering_nn_1 = mkN "armfцring" ;
  armfoting_nn_1 = mkN "armfoting" ;
  armhaevning_nn_1 = mkN "armhдvning" ;
  armkrok_nn_1 = mkN "armkrok" ;
  armlaengd_nn_1 = mkN "armlдngd" "armlдngder" ;
  armled_nn_1 = mkN "armled" "armleder" ;
  armmuskel_nn_1 = mkN "armmuskel" "armmuskeln" "armmuskler" "armmusklerna" ;
  armpolyp_nn_1 = mkN "armpolyp" "armpolyper" ;
  armstoed_nn_1 = mkN "armstцd" neutrum ;
  armstyrka_nn_1 = mkN "armstyrka" ;
  armveck_nn_1 = mkN "armveck" neutrum ;
  arom_nn_1 = mkN "arom" "aromer" ;
  aromatisk_av_1 = mkA "aromatisk" ;
  aromglas_nn_1 = mkN "aromglas" neutrum ;
  arpeggio_nn_1 = mkN "arpeggio" "arpeggiot" "arpeggion" "arpeggiona" ;
  arr_nn_1 = mkN "arr" neutrum ;
  arrangemang_nn_1 = mkN "arrangemang" neutrum ;
  arrangoer_nn_1 = mkN "arrangцr" "arrangцrer" ;
  arrendator_nn_1 = mkN "arrendator" "arrendatorer" ;
  arrende_nn_1 = mkN "arrende" ;
  arrest_nn_1 = mkN "arrest" "arrester" ;
  arrestant_nn_1 = mkN "arrestant" "arrestanter" ;
  arrestering_nn_1 = mkN "arrestering" ;
  arriaergarde_nn_1 = mkN "arriдrgarde" ;
  arrivist_nn_1 = mkN "arrivist" "arrivister" ;
  arrogant_av_1 = mkA "arrogant" "arrogant" ;
  arrowrot_nn_1 = mkN "arrowrot" "arrowrцtter" ;
  arsel_nn_1 = mkN "arsel" neutrum ;
  arsenal_nn_1 = mkN "arsenal" "arsenaler" ;
  arsenikhalt_nn_1 = mkN "arsenikhalt" "arsenikhalter" ;
  arsenikhaltig_av_1 = mkA "arsenikhaltig" ;
  arsenikkis_nn_1 = mkN "arsenikkis" "arsenikkiser" ;
  art_nn_1 = mkN "art" "arter" ;
  artaer_nn_1 = mkN "artдr" "artдrer" ;
  artbildning_nn_1 = mkN "artbildning" ;
  artbildningsteori_nn_1 = mkN "artbildningsteori" "artbildningsteorier" ;
  artefakt_nn_1 = mkN "artefakt" "artefakter" ;
  artegen_av_1 = mkA "artegen" "arteget" ;
  arteriell_av_1 = mkA "arteriell" ;
  artesisk_av_1 = mkA "artesisk" ;
  artfraemmande_av_1 = mkA "artfrдmmande" ;
  artificiell_av_1 = mkA "artificiell" ;
  artig_av_1 = mkA "artig" ;
  artighet_nn_1 = mkN "artighet" "artigheter" ;
  artighetsbetygelse_nn_1 = mkN "artighetsbetygelse" "artighetsbetygelser" ;
  artighetsfras_nn_1 = mkN "artighetsfras" "artighetsfraser" ;
  artighetsvisit_nn_1 = mkN "artighetsvisit" "artighetsvisiter" ;
  artikel_nn_1 = mkN "artikel" ;
  artikelfoerfattare_nn_1 = mkN "artikelfцrfattare" "artikelfцrfattare" ;
  artikelserie_nn_1 = mkN "artikelserie" "artikelserier" ;
  artikulation_nn_1 = mkN "artikulation" "artikulationer" ;
  artikulationsbas_nn_1 = mkN "artikulationsbas" "artikulationsbaser" ;
  artikulationsstaelle_nn_1 = mkN "artikulationsstдlle" ;
  artilleribeskjutning_nn_1 = mkN "artilleribeskjutning" ;
  artillerield_nn_1 = mkN "artillerield" ;
  artillerigranat_nn_1 = mkN "artillerigranat" "artillerigranater" ;
  artilleripjaes_nn_1 = mkN "artilleripjдs" "artilleripjдser" ;
  artillerist_nn_1 = mkN "artillerist" "artillerister" ;
  artillerivapen_nn_1 = mkN "artillerivapen" "artillerivapnet" "artillerivapen" "artillerivapnen" ;
  artist_nn_1 = mkN "artist" "artister" ;
  artistframtraedande_nn_1 = mkN "artistframtrдdande" ;
  artistisk_av_1 = mkA "artistisk" ;
  artistnamn_nn_1 = mkN "artistnamn" neutrum ;
  artnamn_nn_1 = mkN "artnamn" neutrum ;
  artotek_nn_1 = mkN "artotek" neutrum ;
  artrik_av_1 = mkA "artrik" ;
  artrit_nn_1 = mkN "artrit" "artriter" ;
  artros_nn_1 = mkN "artros" "artroser" ;
  artskild_av_1 = mkA "artskild" "artskilt" ;
  artskillnad_nn_1 = mkN "artskillnad" "artskillnader" ;
  arv_nn_1 = mkN "arv" neutrum ;
  arvedel_nn_1 = mkN "arvedel" "arvedelen" "arvedelar" "arvedelarna" ;
  arvfiende_nn_1 = mkN "arvfiende" "arvfiender" ;
  arvfoeljd_nn_1 = mkN "arvfцljd" "arvfцljder" ;
  arvfurste_nn_1 = mkN "arvfurste" utrum ;
  arvinge_nn_1 = mkN "arvinge" utrum ;
  arvlaatare_nn_1 = mkN "arvlеtare" "arvlеtare" ;
  arvloes_av_1 = mkA "arvlцs" ;
  arvode_nn_1 = mkN "arvode" ;
  arvord_nn_1 = mkN "arvord" neutrum ;
  arvsanlag_nn_1 = mkN "arvsanlag" neutrum ;
  arvsfaktor_nn_1 = mkN "arvsfaktor" "arvsfaktorer" ;
  arvsfoeljd_nn_1 = mkN "arvsfцljd" "arvsfцljder" ;
  arvsfond_nn_1 = mkN "arvsfond" "arvsfonder" ;
  arvskatt_nn_1 = mkN "arvskatt" "arvskatter" ;
  arvskifte_nn_1 = mkN "arvskifte" ;
  arvslott_nn_1 = mkN "arvslott" "arvslotter" ;
  arvsmolekyl_nn_1 = mkN "arvsmolekyl" "arvsmolekyler" ;
  arvsraett_nn_1 = mkN "arvsrдtt" "arvsrдtter" ;
  arvsskatt_nn_1 = mkN "arvsskatt" "arvsskatter" ;
  arvsynd_nn_1 = mkN "arvsynd" "arvsynder" ;
  arvtagare_nn_1 = mkN "arvtagare" "arvtagare" ;
  arvtant_nn_1 = mkN "arvtant" "arvtanter" ;
  arytmi_nn_1 = mkN "arytmi" "arytmier" ;
  as_nn_1 = mkN "as" neutrum ;
  as_nn_2 = mkN "as" ;
  asaetare_nn_1 = mkN "asдtare" "asдtare" ;
  asbagge_nn_1 = mkN "asbagge" utrum ;
  aseptisk_av_1 = mkA "aseptisk" ;
  asexuell_av_1 = mkA "asexuell" ;
  asfalt_nn_1 = mkN "asfalt" "asfalter" ;
  asfaltemulsion_nn_1 = mkN "asfaltemulsion" "asfaltemulsioner" ;
  asfaltlack_nn_1 = mkN "asfaltlack" "asfaltlacker" ;
  asfaltmoped_nn_1 = mkN "asfaltmoped" "asfaltmopeder" ;
  asgam_nn_1 = mkN "asgam" ;
  asiat_nn_1 = mkN "asiat" "asiater" ;
  asiatisk_av_1 = mkA "asiatisk" ;
  asimut_nn_1 = mkN "asimut" "asimuter" ;
  ask_nn_1 = mkN "ask" ;
  askblond_av_1 = mkA "askblond" ;
  askenas_nn_1 = mkN "askenas" "askenaser" ;
  asket_nn_1 = mkN "asket" "asketer" ;
  asketisk_av_1 = mkA "asketisk" ;
  askfat_nn_1 = mkN "askfat" neutrum ;
  askgraa_av_1 = mkA "askgrе" "askgrеtt" ;
  askkopp_nn_1 = mkN "askkopp" ;
  askonsdag_nn_1 = mkN "askonsdag" ;
  askunge_nn_1 = mkN "askunge" utrum ;
  asocial_av_1 = mkA "asocial" ;
  asocialitet_nn_1 = mkN "asocialitet" "asocialiteter" ;
  asp_nn_1 = mkN "asp" ;
  aspdunge_nn_1 = mkN "aspdunge" utrum ;
  aspekt_nn_1 = mkN "aspekt" "aspekter" ;
  aspirant_nn_1 = mkN "aspirant" "aspiranter" ;
  aspiration_nn_1 = mkN "aspiration" "aspirationer" ;
  aspirin_nn_1 = mkN "aspirin" "aspiriner" ;
  asploev_nn_1 = mkN "asplцv" neutrum ;
  ass_nn_1 = mkN "ass" neutrum ;
  assegaj_nn_1 = mkN "assegaj" "assegajer" ;
  assessor_nn_1 = mkN "assessor" "assessorer" ;
  assiett_nn_1 = mkN "assiett" "assietter" ;
  assignant_nn_1 = mkN "assignant" "assignanter" ;
  assignation_nn_1 = mkN "assignation" "assignationer" ;
  assimilation_nn_1 = mkN "assimilation" "assimilationer" ;
  assist_nn_1 = mkN "assist" "assister" ;
  assistans_nn_1 = mkN "assistans" "assistanser" ;
  assistent_nn_1 = mkN "assistent" "assistenter" ;
  association_nn_1 = mkN "association" "associationer" ;
  associationskedja_nn_1 = mkN "associationskedja" ;
  associationslexikon_nn_1 = mkN "associationslexikon" neutrum ;
  associativ_av_1 = mkA "associativ" ;
  assonans_nn_1 = mkN "assonans" "assonanser" ;
  assuradoer_nn_1 = mkN "assuradцr" "assuradцrer" ;
  assurans_nn_1 = mkN "assurans" "assuranser" ;
  assyrier_nn_1 = mkN "assyrier" "assyriern" "assyrier" "assyrierna" ;
  assyrisk_av_1 = mkA "assyrisk" ;
  asteni_nn_1 = mkN "asteni" "astenier" ;
  asteniker_nn_1 = mkN "asteniker" "astenikern" "asteniker" "astenikerna" ;
  astenisk_av_1 = mkA "astenisk" ;
  aster_nn_1 = mkN "aster" ;
  asterisk_nn_1 = mkN "asterisk" "asterisker" ;
  asteroid_nn_1 = mkN "asteroid" "asteroider" ;
  astigmatiker_nn_1 = mkN "astigmatiker" "astigmatikern" "astigmatiker" "astigmatikerna" ;
  astigmatisk_av_1 = mkA "astigmatisk" ;
  astmatiker_nn_1 = mkN "astmatiker" "astmatikern" "astmatiker" "astmatikerna" ;
  astmatisk_av_1 = mkA "astmatisk" ;
  astrakan_nn_1 = mkN "astrakan" "astrakaner" ;
  astrakan_nn_2 = mkN "astrakan" "astrakaner" ;
  astral_av_1 = mkA "astral" ;
  astralkropp_nn_1 = mkN "astralkropp" ;
  astrofysiker_nn_1 = mkN "astrofysiker" "astrofysikern" "astrofysiker" "astrofysikerna" ;
  astrolog_nn_1 = mkN "astrolog" "astrologer" ;
  astronaut_nn_1 = mkN "astronaut" "astronauter" ;
  astronautik_nn_1 = mkN "astronautik" "astronautiker" ;
  astronom_nn_1 = mkN "astronom" "astronomer" ;
  astronomisk_av_1 = mkA "astronomisk" ;
  asyl_nn_1 = mkN "asyl" "asyler" ;
  asymmetri_nn_1 = mkN "asymmetri" "asymmetrier" ;
  asymmetrisk_av_1 = mkA "asymmetrisk" ;
  asymptot_nn_1 = mkN "asymptot" "asymptoter" ;
  asyndes_nn_1 = mkN "asyndes" "asyndeser" ;
  asyndetisk_av_1 = mkA "asyndetisk" ;
  asyndeton_nn_1 = mkN "asyndeton" "asyndeton" "asyndeton" "asyndetonen" ;
  asynja_nn_1 = mkN "asynja" ;
  asynkron_av_1 = mkA "asynkron" ;
  ataktisk_av_1 = mkA "ataktisk" ;
  ataraktika_nn_1 = mkN "ataraktika" "ataraktikan" "ataraktika" "ataraktikana" ;
  atavism_nn_1 = mkN "atavism" "atavismer" ;
  atavistisk_av_1 = mkA "atavistisk" ;
  ataxi_nn_1 = mkN "ataxi" "ataxier" ;
  ateist_nn_1 = mkN "ateist" "ateister" ;
  ateistisk_av_1 = mkA "ateistisk" ;
  atelje_nn_1 = mkN "ateljй" "ateljйer" ;
  ateljefoenster_nn_1 = mkN "ateljйfцnster" neutrum ;
  atenienn_nn_1 = mkN "atenienn" "atenienner" ;
  atlantisk_av_1 = mkA "atlantisk" ;
  atlas_nn_1 = mkN "atlas" "atlaser" ;
  atlasbindning_nn_1 = mkN "atlasbindning" ;
  atlasspinnare_nn_1 = mkN "atlasspinnare" "atlasspinnare" ;
  atlet_nn_1 = mkN "atlet" "atleter" ;
  atletisk_av_1 = mkA "atletisk" ;
  atmosfaer_nn_1 = mkN "atmosfдr" "atmosfдrer" ;
  atmosfaerforskare_nn_1 = mkN "atmosfдrforskare" "atmosfдrforskare" ;
  atmosfaerisk_av_1 = mkA "atmosfдrisk" ;
  atmosfaerkemist_nn_1 = mkN "atmosfдrkemist" "atmosfдrkemister" ;
  atmosfaerstryck_nn_1 = mkN "atmosfдrstryck" neutrum ;
  atoll_nn_1 = mkN "atoll" "atoller" ;
  atom_nn_1 = mkN "atom" "atomer" ;
  atomaer_av_1 = mkA "atomдr" ;
  atombomb_nn_1 = mkN "atombomb" "atombomber" ;
  atomdriven_av_1 = mkA "atomdriven" "atomdrivet" ;
  atomenergiorganisation_nn_1 = mkN "atomenergiorganisation" "atomenergiorganisationer" ;
  atomgrupp_nn_1 = mkN "atomgrupp" "atomgrupper" ;
  atomistisk_av_1 = mkA "atomistisk" ;
  atomjon_nn_1 = mkN "atomjon" "atomjoner" ;
  atommodell_nn_1 = mkN "atommodell" "atommodeller" ;
  atomnummer_nn_1 = mkN "atomnummer" neutrum ;
  atomreaktor_nn_1 = mkN "atomreaktor" "atomreaktorer" ;
  atomspektrum_nn_1 = mkN "atomspektrum" neutrum ;
  atomubaat_nn_1 = mkN "atomubеt" ;
  atomur_nn_1 = mkN "atomur" neutrum ;
  atomvapen_nn_1 = mkN "atomvapen" "atomvapnet" "atomvapen" "atomvapnen" ;
  atomvikt_nn_1 = mkN "atomvikt" "atomvikter" ;
  atomvinter_nn_1 = mkN "atomvinter" ;
  atonal_av_1 = mkA "atonal" ;
  atoni_nn_1 = mkN "atoni" "atonier" ;
  atrium_nn_1 = mkN "atrium" "atriet" "atrier" "atrierna" ;
  atrofi_nn_1 = mkN "atrofi" "atrofier" ;
  atrofisk_av_1 = mkA "atrofisk" ;
  att_sats_nn_1 = mkN "att-sats" "att-satser" ;
  attache_nn_1 = mkN "attachй" "attachйer" ;
  attack_nn_1 = mkN "attack" "attacker" ;
  attackdykare_nn_1 = mkN "attackdykare" "attackdykare" ;
  attackplan_nn_1 = mkN "attackplan" neutrum ;
  attentat_nn_1 = mkN "attentat" neutrum ;
  attentator_nn_1 = mkN "attentator" "attentatorer" ;
  attentatsman_nn_1 = mkN "attentatsman" "attentatsmannen" "attentatsmдn" "attentatsmдnnen" ;
  attest_nn_1 = mkN "attest" "attester" ;
  attiralj_nn_1 = mkN "attiralj" "attiraljer" ;
  attisk_av_1 = mkA "attisk" ;
  attityd_nn_1 = mkN "attityd" "attityder" ;
  attitydundersoekning_nn_1 = mkN "attitydundersцkning" ;
  attraktion_nn_1 = mkN "attraktion" "attraktioner" ;
  attraktiv_av_1 = mkA "attraktiv" ;
  attrapp_nn_1 = mkN "attrapp" "attrapper" ;
  attribut_nn_1 = mkN "attribut" neutrum ;
  attribution_nn_1 = mkN "attribution" "attributioner" ;
  attributiv_av_1 = mkA "attributiv" ;
  atypi_nn_1 = mkN "atypi" "atypier" ;
  atypisk_av_1 = mkA "atypisk" ;
  aubergine_nn_1 = mkN "aubergine" "auberginer" ;
  audiens_nn_1 = mkN "audiens" "audienser" ;
  audiogram_nn_1 = mkN "audiogram" "audiogrammet" "audiogram" "audiogrammen" ;
  audiometer_nn_1 = mkN "audiometer" ;
  audiovisuell_av_1 = mkA "audiovisuell" ;
  auditiv_av_1 = mkA "auditiv" ;
  auditoer_nn_1 = mkN "auditцr" "auditцrer" ;
  auditorium_nn_1 = mkN "auditorium" "auditoriet" "auditorier" "auditorierna" ;
  audivisuell_av_1 = mkA "audivisuell" ;
  augiasstall_nn_1 = mkN "augiasstall" neutrum ;
  augment_nn_1 = mkN "augment" neutrum ;
  augur_nn_1 = mkN "augur" "augurer" ;
  augustipaeron_nn_1 = mkN "augustipдron" neutrum ;
  auktion_nn_1 = mkN "auktion" "auktioner" ;
  auktionist_nn_1 = mkN "auktionist" "auktionister" ;
  auktionsfoerraettare_nn_1 = mkN "auktionsfцrrдttare" "auktionsfцrrдttare" ;
  auktionskammare_nn_1 = mkN "auktionskammare" "auktionskammaren" "auktionskamrar" "auktionskamrarna" ;
  auktionsutropare_nn_1 = mkN "auktionsutropare" "auktionsutropare" ;
  auktionsverk_nn_1 = mkN "auktionsverk" neutrum ;
  auktor_nn_1 = mkN "auktor" "auktorer" ;
  auktorisation_nn_1 = mkN "auktorisation" "auktorisationer" ;
  auktoritaer_av_1 = mkA "auktoritдr" ;
  auktoritativ_av_1 = mkA "auktoritativ" ;
  auktoritet_nn_1 = mkN "auktoritet" "auktoriteter" ;
  auktoritetsbunden_av_1 = mkA "auktoritetsbunden" "auktoritetsbundet" ;
  auskultant_nn_1 = mkN "auskultant" "auskultanter" ;
  auskultation_nn_1 = mkN "auskultation" "auskultationer" ;
  australiensare_nn_1 = mkN "australiensare" "australiensare" ;
  australier_nn_1 = mkN "australier" "australiern" "australier" "australierna" ;
  australisk_av_1 = mkA "australisk" ;
  autarki_nn_1 = mkN "autarki" "autarkier" ;
  autencitet_nn_1 = mkN "autencitet" "autenciteter" ;
  autenticitet_nn_1 = mkN "autenticitet" "autenticiteter" ;
  autentisk_av_1 = mkA "autentisk" ;
  auteur_nn_1 = mkN "auteur" "auteurer" ;
  autistisk_av_1 = mkA "autistisk" ;
  autodafe_nn_1 = mkN "autodafй" "autodafйer" ;
  autodidakt_nn_1 = mkN "autodidakt" "autodidakter" ;
  autodrom_nn_1 = mkN "autodrom" "autodromer" ;
  autograf_nn_1 = mkN "autograf" "autografer" ;
  autoklav_nn_1 = mkN "autoklav" "autoklaver" ;
  autokrat_nn_1 = mkN "autokrat" "autokrater" ;
  autokton_av_1 = mkA "autokton" ;
  automat_nn_1 = mkN "automat" "automater" ;
  automatgevaer_nn_1 = mkN "automatgevдr" neutrum ;
  automatisk_av_1 = mkA "automatisk" ;
  automatkarbin_nn_1 = mkN "automatkarbin" "automatkarbiner" ;
  automatvapen_nn_1 = mkN "automatvapen" "automatvapnet" "automatvapen" "automatvapnen" ;
  automobil_nn_1 = mkN "automobil" "automobiler" ;
  autonom_av_1 = mkA "autonom" ;
  autopilot_nn_1 = mkN "autopilot" "autopiloter" ;
  autopsi_nn_1 = mkN "autopsi" "autopsier" ;
  autotypi_nn_1 = mkN "autotypi" "autotypier" ;
  av_ab_1 = mkAdv "av" ;
  avaeta_vb_1 = mkV "avдta" "avеt" "avдtit" ;
  avancemang_nn_1 = mkN "avancemang" neutrum ;
  avannons_nn_1 = mkN "avannons" "avannonser" ;
  avans_nn_1 = mkN "avans" "avanser" ;
  avantgardist_nn_1 = mkN "avantgardist" "avantgardister" ;
  avantgardistisk_av_1 = mkA "avantgardistisk" ;
  avantloge_nn_1 = mkN "avantloge" "avantloger" ;
  avantscen_nn_1 = mkN "avantscen" "avantscener" ;
  avart_nn_1 = mkN "avart" "avarter" ;
  avbaerning_nn_1 = mkN "avbдrning" ;
  avbalkning_nn_1 = mkN "avbalkning" ;
  avbasning_nn_1 = mkN "avbasning" ;
  avbetalning_nn_1 = mkN "avbetalning" ;
  avbetingning_nn_1 = mkN "avbetingning" ;
  avbild_nn_1 = mkN "avbild" "avbilder" ;
  avbildning_nn_1 = mkN "avbildning" ;
  avbildningsfel_nn_1 = mkN "avbildningsfel" "avbildningsfelet" "avbildningsfel" "avbildningsfelen" ;
  avbitare_nn_1 = mkN "avbitare" "avbitare" ;
  avbitartaang_nn_1 = mkN "avbitartеng" "avbitartдnger" ;
  avblaasning_nn_1 = mkN "avblеsning" ;
  avboejning_nn_1 = mkN "avbцjning" ;
  avboen_nn_1 = mkN "avbцn" "avbцner" ;
  avbraeck_nn_1 = mkN "avbrдck" neutrum ;
  avbraenning_nn_1 = mkN "avbrдnning" ;
  avbroestning_nn_1 = mkN "avbrцstning" ;
  avbrott_nn_1 = mkN "avbrott" neutrum ;
  avbryta_vb_1 = mkV "avbryta" "avbrцt" "avbrutit" ;
  avbrytare_nn_1 = mkN "avbrytare" "avbrytare" ;
  avbytare_nn_1 = mkN "avbytare" "avbytare" ;
  avdagata_vb_1 = mkV "avdagata" "avdagatar" "avdagata" "avdagatog" "avdagatagit" "avdagatagen" ;
  avdelning_nn_1 = mkN "avdelning" ;
  avdelningschef_nn_1 = mkN "avdelningschef" "avdelningschefer" ;
  avdelningsdirektoer_nn_1 = mkN "avdelningsdirektцr" "avdelningsdirektцrer" ;
  avdelningsskoeterska_nn_1 = mkN "avdelningsskцterska" ;
  avdoed_av_1 = mkA "avdцd" ;
  avdrag_nn_1 = mkN "avdrag" neutrum ;
  avdragsgill_av_1 = mkA "avdragsgill" ;
  avdragsmoejlighet_nn_1 = mkN "avdragsmцjlighet" "avdragsmцjligheter" ;
  avdriva_vb_1 = mkV "avdriva" "avdrev" "avdrivit" ;
  avdunstning_nn_1 = mkN "avdunstning" ;
  ave_nn_1 = mkN "ave" ;
  avec_nn_1 = mkN "avec" "avecer" ;
  avelsdjur_nn_1 = mkN "avelsdjur" neutrum ;
  avelshingst_nn_1 = mkN "avelshingst" ;
  avenbok_nn_1 = mkN "avenbok" ;
  aveny_nn_1 = mkN "aveny" "avenyer" ;
  avers_nn_1 = mkN "avers" "averser" ;
  aversion_nn_1 = mkN "aversion" "aversioner" ;
  avfaellig_av_1 = mkA "avfдllig" ;
  avfaelling_nn_1 = mkN "avfдlling" ;
  avfaerd_nn_1 = mkN "avfдrd" "avfдrder" ;
  avfall_nn_1 = mkN "avfall" "avfallet" "avfallen" "avfallena" ;
  avfalla_vb_1 = mkV "avfalla" "avfцll" "avfallit" ;
  avfallen_av_1 = mkA "avfallen" "avfallet" ;
  avfallskvarn_nn_1 = mkN "avfallskvarn" ;
  avfallsupplag_nn_1 = mkN "avfallsupplag" neutrum ;
  avfart_nn_1 = mkN "avfart" "avfarter" ;
  avfattning_nn_1 = mkN "avfattning" ;
  avfloede_nn_1 = mkN "avflцde" ;
  avflyttningsfoerbud_nn_1 = mkN "avflyttningsfцrbud" neutrum ;
  avfoering_nn_1 = mkN "avfцring" ;
  avfoeringsmedel_nn_1 = mkN "avfцringsmedel" neutrum ;
  avfrostning_nn_1 = mkN "avfrostning" ;
  avgaa_vb_1 = mkV "avgе" "avgеr" "avgе" "avgick" "avgеtt" "avgеngen" ;
  avgaang_nn_1 = mkN "avgеng" ;
  avgaangsbetyg_nn_1 = mkN "avgеngsbetyg" neutrum ;
  avgaangsbidrag_nn_1 = mkN "avgеngsbidrag" neutrum ;
  avgaangsklass_nn_1 = mkN "avgеngsklass" "avgеngsklasser" ;
  avgaeld_nn_1 = mkN "avgдld" "avgдlder" ;
  avgasroer_nn_1 = mkN "avgasrцr" neutrum ;
  avge_vb_1 = mkV "avge" "avger" "avge" "avgav" "avgett" "avgiven" ;
  avgift_nn_1 = mkN "avgift" "avgifter" ;
  avgjord_av_1 = mkA "avgjord" "avgjort" ;
  avgjutning_nn_1 = mkN "avgjutning" ;
  avgoerande_av_1 = mkA "avgцrande" ;
  avgoerande_nn_1 = mkN "avgцrande" ;
  avgrund_nn_1 = mkN "avgrund" "avgrunder" ;
  avgrundsande_nn_1 = mkN "avgrundsande" utrum ;
  avgrundsdjup_av_1 = mkA "avgrundsdjup" ;
  avgud_nn_1 = mkN "avgud" ;
  avgudabild_nn_1 = mkN "avgudabild" "avgudabilder" ;
  avhaall_nn_1 = mkN "avhеll" neutrum ;
  avhaalla_vb_1 = mkV "avhеlla" "avhцll" "avhеllit" ;
  avhaallen_av_1 = mkA "avhеllen" "avhеllet" ;
  avhaallsam_av_1 = mkA "avhеllsam" "avhеllsamt" "avhеllsamma" "avhеllsamma" "avhеllsammare" "avhеllsammast" "avhеllsammaste" ;
  avhaengd_av_1 = mkA "avhдngd" "avhдngt" ;
  avhaengig_av_1 = mkA "avhдngig" ;
  avhandling_nn_1 = mkN "avhandling" ;
  avhopp_nn_1 = mkN "avhopp" neutrum ;
  avhoppare_nn_1 = mkN "avhoppare" "avhoppare" ;
  avhyvling_nn_1 = mkN "avhyvling" ;
  avi_nn_1 = mkN "avi" "avier" ;
  aviarium_nn_1 = mkN "aviarium" "aviariet" "aviarier" "aviarierna" ;
  aviatisk_av_1 = mkA "aviatisk" ;
  aviatoer_nn_1 = mkN "aviatцr" "aviatцrer" ;
  avig_av_1 = mkA "avig" ;
  avigsida_nn_1 = mkN "avigsida" ;
  avisering_nn_1 = mkN "avisering" ;
  aviseringsperiod_nn_1 = mkN "aviseringsperiod" "aviseringsperioder" ;
  avisofartyg_nn_1 = mkN "avisofartyg" neutrum ;
  avista_ab_1 = mkAdv "avista" ;
  avitaminos_nn_1 = mkN "avitaminos" "avitaminoser" ;
  avkaennare_nn_1 = mkN "avkдnnare" "avkдnnare" ;
  avklaedning_nn_1 = mkN "avklдdning" ;
  avklappning_nn_1 = mkN "avklappning" ;
  avkoerningsramp_nn_1 = mkN "avkцrningsramp" "avkцrningsramper" ;
  avkok_nn_1 = mkN "avkok" neutrum ;
  avkomling_nn_1 = mkN "avkomling" ;
  avkoppling_nn_1 = mkN "avkoppling" ;
  avkortning_nn_1 = mkN "avkortning" ;
  avkrok_nn_1 = mkN "avkrok" ;
  avkylning_nn_1 = mkN "avkylning" ;
  avlaang_av_1 = mkA "avlеng" ;
  avlaata_vb_1 = mkV "avlеta" "avlдt" "avlеtit" ;
  avlaeggare_nn_1 = mkN "avlдggare" "avlдggare" ;
  avlaegsen_av_1 = mkA "avlдgsen" "avlдgset" ;
  avlaemning_nn_1 = mkN "avlдmning" ;
  avlaesare_nn_1 = mkN "avlдsare" "avlдsare" ;
  avlaesbar_av_1 = mkA "avlдsbar" ;
  avlaesning_nn_1 = mkN "avlдsning" ;
  avlagd_av_1 = mkA "avlagd" "avlagt" ;
  avlagring_nn_1 = mkN "avlagring" ;
  avlastare_nn_1 = mkN "avlastare" "avlastare" ;
  avlastning_nn_1 = mkN "avlastning" ;
  avlastningsplats_nn_1 = mkN "avlastningsplats" "avlastningsplatser" ;
  avlatsbrev_nn_1 = mkN "avlatsbrev" neutrum ;
  avledning_nn_1 = mkN "avledning" ;
  avledningsaendelse_nn_1 = mkN "avledningsдndelse" "avledningsдndelser" ;
  avlida_vb_1 = mkV "avlida" "avled" "avlidit" ;
  avliden_av_1 = mkA "avliden" "avlidet" ;
  avlinge_nn_1 = mkN "avlinge" ;
  avljud_nn_1 = mkN "avljud" neutrum ;
  avloening_nn_1 = mkN "avlцning" ;
  avloepning_nn_1 = mkN "avlцpning" ;
  avloesning_nn_1 = mkN "avlцsning" ;
  avlopp_nn_1 = mkN "avlopp" neutrum ;
  avloppsdike_nn_1 = mkN "avloppsdike" ;
  avloppsledning_nn_1 = mkN "avloppsledning" ;
  avloppsvatten_nn_1 = mkN "avloppsvatten" "avloppsvattnet" "avloppsvatten" "avloppsvattnen" ;
  avlyssning_nn_1 = mkN "avlyssning" ;
  avlyssningsapparatur_nn_1 = mkN "avlyssningsapparatur" "avlyssningsapparaturer" ;
  avmaetning_nn_1 = mkN "avmдtning" ;
  avmaett_av_1 = mkA "avmдtt" ;
  avmagring_nn_1 = mkN "avmagring" ;
  avmarsch_nn_1 = mkN "avmarsch" "avmarscher" ;
  avmattning_nn_1 = mkN "avmattning" ;
  avnaemare_nn_1 = mkN "avnдmare" "avnдmare" ;
  avnjuta_vb_1 = mkV "avnjuta" "avnjцt" "avnjutit" ;
  avog_av_1 = mkA "avog" ;
  avokado_nn_1 = mkN "avokado" "avokador" ;
  avraadande_nn_1 = mkN "avrеdande" ;
  avraekning_nn_1 = mkN "avrдkning" ;
  avraettning_nn_1 = mkN "avrдttning" ;
  avredning_nn_1 = mkN "avredning" ;
  avringning_nn_1 = mkN "avringning" ;
  avrinna_vb_1 = mkV "avrinna" "avrann" "avrunnit" ;
  avrinning_nn_1 = mkN "avrinning" ;
  avrivning_nn_1 = mkN "avrivning" ;
  avrop_nn_1 = mkN "avrop" neutrum ;
  avsaegelse_nn_1 = mkN "avsдgelse" "avsдgelser" ;
  avsaendare_nn_1 = mkN "avsдndare" "avsдndare" ;
  avsaettlig_av_1 = mkA "avsдttlig" ;
  avsaettning_nn_1 = mkN "avsдttning" ;
  avsaettningsbassaeng_nn_1 = mkN "avsдttningsbassдng" "avsдttningsbassдnger" ;
  avsaknad_nn_1 = mkN "avsaknad" "avsaknader" ;
  avsats_nn_1 = mkN "avsats" "avsatser" ;
  avseende_nn_1 = mkN "avseende" ;
  avsegling_nn_1 = mkN "avsegling" ;
  avsevaerd_av_1 = mkA "avsevдrd" "avsevдrt" ;
  avsides_ab_1 = mkAdv "avsides" ;
  avsides_av_1 = mkA "avsides" ;
  avsigkommen_av_1 = mkA "avsigkommen" "avsigkommet" "avsigkomna" "avsigkomna" "avsigkomnare" "avsigkomnast" "avsigkomnaste" ;
  avsikt_nn_1 = mkN "avsikt" "avsikter" ;
  avsiktlig_av_1 = mkA "avsiktlig" ;
  avsittning_nn_1 = mkN "avsittning" ;
  avsjunga_vb_1 = mkV "avsjunga" "avsjцng" "avsjungit" ;
  avskaera_vb_1 = mkV "avskдra" "avskar" "avskurit" ;
  avskaerning_nn_1 = mkN "avskдrning" ;
  avskaffande_nn_1 = mkN "avskaffande" ;
  avsked_nn_1 = mkN "avsked" neutrum ;
  avskedsdikt_nn_1 = mkN "avskedsdikt" "avskedsdikter" ;
  avskild_av_1 = mkA "avskild" "avskilt" ;
  avskildhet_nn_1 = mkN "avskildhet" "avskildheter" ;
  avskjuta_vb_1 = mkV "avskjuta" "avskцt" "avskjutit" ;
  avskjutning_nn_1 = mkN "avskjutning" ;
  avskraeckning_nn_1 = mkN "avskrдckning" ;
  avskraede_nn_1 = mkN "avskrдde" ;
  avskraedeshoeg_nn_1 = mkN "avskrдdeshцg" ;
  avskrift_nn_1 = mkN "avskrift" "avskrifter" ;
  avskriva_vb_1 = mkV "avskriva" "avskrev" "avskrivit" ;
  avskrivning_nn_1 = mkN "avskrivning" ;
  avskrot_nn_1 = mkN "avskrot" ;
  avskyvaerd_av_1 = mkA "avskyvдrd" "avskyvдrt" ;
  avslag_nn_1 = mkN "avslag" neutrum ;
  avslagen_av_1 = mkA "avslagen" "avslaget" ;
  avslappning_nn_1 = mkN "avslappning" ;
  avslappningsoevning_nn_1 = mkN "avslappningsцvning" ;
  avslita_vb_1 = mkV "avslita" "avslet" "avslitit" ;
  avsloejande_nn_1 = mkN "avslцjande" ;
  avslut_nn_1 = mkN "avslut" neutrum ;
  avslutning_nn_1 = mkN "avslutning" ;
  avslutningsfest_nn_1 = mkN "avslutningsfest" "avslutningsfester" ;
  avslutningsvis_ab_1 = mkAdv "avslutningsvis" ;
  avsmaeltning_nn_1 = mkN "avsmдltning" ;
  avsnitt_nn_1 = mkN "avsnitt" neutrum ;
  avsnoerning_nn_1 = mkN "avsnцrning" ;
  avsnoerningsteori_nn_1 = mkN "avsnцrningsteori" "avsnцrningsteorier" ;
  avsoekare_nn_1 = mkN "avsцkare" "avsцkare" ;
  avsoendring_nn_1 = mkN "avsцndring" ;
  avspaend_av_1 = mkA "avspдnd" ;
  avspaenning_nn_1 = mkN "avspдnning" ;
  avspaerrning_nn_1 = mkN "avspдrrning" ;
  avspark_nn_1 = mkN "avspark" ;
  avspegling_nn_1 = mkN "avspegling" ;
  avspelning_nn_1 = mkN "avspelning" ;
  avspraang_nn_1 = mkN "avsprеng" neutrum ;
  avstaand_nn_1 = mkN "avstеnd" neutrum ;
  avstaandsinformation_nn_1 = mkN "avstеndsinformation" "avstеndsinformationer" ;
  avstaandskraft_nn_1 = mkN "avstеndskraft" "avstеndskrafter" ;
  avstaandsmaetning_nn_1 = mkN "avstеndsmдtning" ;
  avstaandstagande_nn_1 = mkN "avstеndstagande" ;
  avstaellning_nn_1 = mkN "avstдllning" ;
  avstaempling_nn_1 = mkN "avstдmpling" ;
  avstaengning_nn_1 = mkN "avstдngning" ;
  avstamp_nn_1 = mkN "avstamp" neutrum ;
  avstavning_nn_1 = mkN "avstavning" ;
  avsteg_nn_1 = mkN "avsteg" neutrum ;
  avstickare_nn_1 = mkN "avstickare" "avstickare" ;
  avstickning_nn_1 = mkN "avstickning" ;
  avstigning_nn_1 = mkN "avstigning" ;
  avstjaelpningsplats_nn_1 = mkN "avstjдlpningsplats" "avstjдlpningsplatser" ;
  avsutten_av_1 = mkA "avsutten" "avsuttet" ;
  avsvaerja_vb_1 = mkV "avsvдrja" "avsvдrj" "avsvдrj" "avsvorj" "avsvurjit" "avsvurjen" ;
  avsvalkning_nn_1 = mkN "avsvalkning" ;
  avsynare_nn_1 = mkN "avsynare" "avsynare" ;
  avta_vb_1 = mkV "avta" "avtar" "avta" "avtog" "avtagit" "avtagen" ;
  avtaag_nn_1 = mkN "avtеg" neutrum ;
  avtaerd_av_1 = mkA "avtдrd" "avtдrt" ;
  avtagande_av_1 = mkA "avtagande" ;
  avtagbar_av_1 = mkA "avtagbar" ;
  avtagsvaeg_nn_1 = mkN "avtagsvдg" ;
  avtal_nn_1 = mkN "avtal" "avtalet" "avtalen" "avtalena" ;
  avtalsenlig_av_1 = mkA "avtalsenlig" ;
  avtalsfrihet_nn_1 = mkN "avtalsfrihet" "avtalsfriheter" ;
  avtalsperiod_nn_1 = mkN "avtalsperiod" "avtalsperioder" ;
  avtalsroerelse_nn_1 = mkN "avtalsrцrelse" "avtalsrцrelser" ;
  avtalsstridig_av_1 = mkA "avtalsstridig" ;
  avtappning_nn_1 = mkN "avtappning" ;
  avtoning_nn_1 = mkN "avtoning" ;
  avtraede_nn_1 = mkN "avtrдde" ;
  avtraedelse_nn_1 = mkN "avtrдdelse" "avtrдdelser" ;
  avtryck_nn_1 = mkN "avtryck" neutrum ;
  avtryckare_nn_1 = mkN "avtryckare" "avtryckare" ;
  avtvagning_nn_1 = mkN "avtvagning" ;
  avtvinga_vb_1 = mkV "avtvinga" ;
  avundsam_av_1 = mkA "avundsam" "avundsamt" "avundsamma" "avundsamma" "avundsammare" "avundsammast" "avundsammaste" ;
  avundsjuk_av_1 = mkA "avundsjuk" ;
  avundsman_nn_1 = mkN "avundsman" "avundsmannen" "avundsmдn" "avundsmдnnen" ;
  avundsvaerd_av_1 = mkA "avundsvдrd" "avundsvдrt" ;
  avvaeg_nn_1 = mkN "avvдg" ;
  avvaegning_nn_1 = mkN "avvдgning" ;
  avvaegningsinstrument_nn_1 = mkN "avvдgningsinstrument" neutrum ;
  avvaenjning_nn_1 = mkN "avvдnjning" ;
  avvaenjningstid_nn_1 = mkN "avvдnjningstid" "avvдnjningstider" ;
  avvaepnande_av_1 = mkA "avvдpnande" ;
  avveckling_nn_1 = mkN "avveckling" ;
  avverkning_nn_1 = mkN "avverkning" ;
  avvika_vb_1 = mkV "avvika" "avvek" "avvikit" ;
  avvikande_av_1 = mkA "avvikande" ;
  avvikare_nn_1 = mkN "avvikare" "avvikare" ;
  avvikelse_nn_1 = mkN "avvikelse" "avvikelser" ;
  avvinna_vb_1 = mkV "avvinna" "avvann" "avvunnit" ;
  avvisare_nn_1 = mkN "avvisare" "avvisare" ;
  avvisning_nn_1 = mkN "avvisning" ;
  avytterlig_av_1 = mkA "avytterlig" ;
  ax_nn_1 = mkN "ax" neutrum ;
  axblommig_av_1 = mkA "axblommig" ;
  axel_nn_1 = mkN "axel" ;
  axelband_nn_1 = mkN "axelband" neutrum ;
  axelbred_av_1 = mkA "axelbred" ;
  axelgehaeng_nn_1 = mkN "axelgehдng" neutrum ;
  axelhoelster_nn_1 = mkN "axelhцlster" neutrum ;
  axelklaff_nn_1 = mkN "axelklaff" ;
  axelkoppling_nn_1 = mkN "axelkoppling" ;
  axellager_nn_1 = mkN "axellager" neutrum ;
  axelmuff_nn_1 = mkN "axelmuff" ;
  axelrem_nn_1 = mkN "axelrem" "axelremmen" "axelremmar" "axelremmarna" ;
  axelriktning_nn_1 = mkN "axelriktning" ;
  axelryckning_nn_1 = mkN "axelryckning" ;
  axial_av_1 = mkA "axial" ;
  axiom_nn_1 = mkN "axiom" neutrum ;
  axiomatisk_av_1 = mkA "axiomatisk" ;
  axion_nn_1 = mkN "axion" "axioner" ;
  axionfoertaetning_nn_1 = mkN "axionfцrtдtning" ;
  axplock_nn_1 = mkN "axplock" neutrum ;
  aztek_nn_1 = mkN "aztek" "azteker" ;
  aztekisk_av_1 = mkA "aztekisk" ;
  azurblaa_av_1 = mkA "azurblе" "azurblеtt" ;
  baade_ab_1 = mkAdv "bеde" ;
  baade_nn_1 = mkN "bеde" utrum ;
  baagbro_nn_1 = mkN "bеgbro" ;
  baage_nn_1 = mkN "bеge" utrum ;
  baagfaelt_nn_1 = mkN "bеgfдlt" neutrum ;
  baagfil_nn_1 = mkN "bеgfil" ;
  baagfoenster_nn_1 = mkN "bеgfцnster" neutrum ;
  baagformig_av_1 = mkA "bеgformig" ;
  baagfris_nn_1 = mkN "bеgfris" "bеgfriser" ;
  baaggaang_nn_1 = mkN "bеggеng" ;
  baagig_av_1 = mkA "bеgig" ;
  baagminut_nn_1 = mkN "bеgminut" "bеgminuter" ;
  baagsaag_nn_1 = mkN "bеgsеg" ;
  baagsekund_nn_1 = mkN "bеgsekund" "bеgsekunder" ;
  baagskytt_nn_1 = mkN "bеgskytt" ;
  baak_nn_1 = mkN "bеk" ;
  baal_nn_1 = mkN "bеl" ;
  baal_nn_2 = mkN "bеl" neutrum ;
  baald_av_1 = mkA "bеld" "bеlt" ;
  baalgeting_nn_1 = mkN "bеlgeting" ;
  baalrullning_nn_1 = mkN "bеlrullning" ;
  baalvaext_nn_1 = mkN "bеlvдxt" "bеlvдxter" ;
  baalverk_nn_1 = mkN "bеlverk" neutrum ;
  baangstyrig_av_1 = mkA "bеngstyrig" ;
  baar_nn_1 = mkN "bеr" ;
  baarbaerare_nn_1 = mkN "bеrbдrare" "bеrbдrare" ;
  baard_nn_1 = mkN "bеrd" "bеrder" ;
  baarhus_nn_1 = mkN "bеrhus" neutrum ;
  baas_nn_1 = mkN "bеs" neutrum ;
  baat_nn_1 = mkN "bеt" ;
  baatben_nn_1 = mkN "bеtben" neutrum ;
  baatbyggare_nn_1 = mkN "bеtbyggare" "bеtbyggare" ;
  baatbyggeri_nn_1 = mkN "bеtbyggeri" "bеtbyggerit" "bеtbyggerier" "bеtbyggerierna" ;
  baatformig_av_1 = mkA "bеtformig" ;
  baatgrav_nn_1 = mkN "bеtgrav" ;
  baathus_nn_1 = mkN "bеthus" neutrum ;
  baatliknande_av_1 = mkA "bеtliknande" ;
  baatmotor_nn_1 = mkN "bеtmotor" "bеtmotorer" ;
  baatnad_nn_1 = mkN "bеtnad" "bеtnader" ;
  baatplats_nn_1 = mkN "bеtplats" "bеtplatser" ;
  baatshake_nn_1 = mkN "bеtshake" utrum ;
  baatskjul_nn_1 = mkN "bеtskjul" neutrum ;
  baatskraa_nn_1 = mkN "bеtskrе" "bеtskrеt" "bеtskrеn" "bеtskrеen" ;
  baatsman_nn_1 = mkN "bеtsman" "bеtsmannen" "bеtsmдn" "bеtsmдnnen" ;
  baatsmansstol_nn_1 = mkN "bеtsmansstol" ;
  baattaevling_nn_1 = mkN "bеttдvling" ;
  babblan_ab_1 = mkAdv "babblan" ;
  babian_nn_1 = mkN "babian" "babianer" ;
  babordsvakt_nn_1 = mkN "babordsvakt" "babordsvakter" ;
  baby_nn_1 = mkN "baby" "babyn" "babyar" "babyarna" ;
  babydraekt_nn_1 = mkN "babydrдkt" "babydrдkter" ;
  babylonier_nn_1 = mkN "babylonier" "babyloniern" "babylonier" "babylonierna" ;
  babylonisk_av_1 = mkA "babylonisk" ;
  babysitter_nn_1 = mkN "babysitter" ;
  bacill_nn_1 = mkN "bacill" "baciller" ;
  bacillbaerare_nn_1 = mkN "bacillbдrare" "bacillbдrare" ;
  back_nn_1 = mkN "back" ;
  backanal_nn_1 = mkN "backanal" "backanaler" ;
  backant_nn_1 = mkN "backant" "backanter" ;
  backe_nn_1 = mkN "backe" utrum ;
  backfisch_nn_1 = mkN "backfisch" ;
  backhammer_nn_1 = mkN "backhammer" "backhammern" "backhammrar" "backhammrarna" ;
  backhoppare_nn_1 = mkN "backhoppare" "backhoppare" ;
  backhoppning_nn_1 = mkN "backhoppning" ;
  backig_av_1 = mkA "backig" ;
  backkroen_nn_1 = mkN "backkrцn" neutrum ;
  backlandskap_nn_1 = mkN "backlandskap" "backlandskapet" "backlandskapen" "backlandskapena" ;
  backslag_nn_1 = mkN "backslag" neutrum ;
  backspegel_nn_1 = mkN "backspegel" ;
  backstag_nn_1 = mkN "backstag" neutrum ;
  backstroem_nn_1 = mkN "backstrцm" "backstrцmmen" "backstrцmmar" "backstrцmmarna" ;
  backstuga_nn_1 = mkN "backstuga" ;
  backstugusittare_nn_1 = mkN "backstugusittare" "backstugusittare" ;
  backvial_nn_1 = mkN "backvial" "backvialer" ;
  bad_nn_1 = mkN "bad" neutrum ;
  badanlaeggning_nn_1 = mkN "badanlдggning" ;
  badbassaeng_nn_1 = mkN "badbassдng" "badbassдnger" ;
  badborste_nn_1 = mkN "badborste" utrum ;
  baddare_nn_1 = mkN "baddare" "baddare" ;
  baddjaevel_nn_1 = mkN "baddjдvel" ;
  baddraekt_nn_1 = mkN "baddrдkt" "baddrдkter" ;
  badensare_nn_1 = mkN "badensare" "badensare" ;
  badensisk_av_1 = mkA "badensisk" ;
  badgaest_nn_1 = mkN "badgдst" "badgдster" ;
  badhandduk_nn_1 = mkN "badhandduk" ;
  badhus_nn_1 = mkN "badhus" neutrum ;
  badhytt_nn_1 = mkN "badhytt" "badhytter" ;
  badkar_nn_1 = mkN "badkar" neutrum ;
  badkarseffekt_nn_1 = mkN "badkarseffekt" "badkarseffekter" ;
  badkarskant_nn_1 = mkN "badkarskant" "badkarskanter" ;
  badlakan_nn_1 = mkN "badlakan" neutrum ;
  badmintonboll_nn_1 = mkN "badmintonboll" ;
  badort_nn_1 = mkN "badort" "badorter" ;
  badrum_nn_1 = mkN "badrum" "badrummet" "badrum" "badrummen" ;
  badsalt_nn_1 = mkN "badsalt" "badsaltet" "badsalter" "badsalterna" ;
  badstaelle_nn_1 = mkN "badstдlle" ;
  badstrand_nn_1 = mkN "badstrand" "badstrдnder" ;
  badturist_nn_1 = mkN "badturist" "badturister" ;
  badvatten_nn_1 = mkN "badvatten" "badvattnet" "badvatten" "badvattnen" ;
  baebis_nn_1 = mkN "bдbis" ;
  baeck_nn_1 = mkN "bдck" ;
  baeckahaest_nn_1 = mkN "bдckahдst" ;
  baecken_nn_1 = mkN "bдcken" neutrum ;
  baeckenben_nn_1 = mkN "bдckenben" neutrum ;
  baeckenfoertraengning_nn_1 = mkN "bдckenfцrtrдngning" ;
  baeckforell_nn_1 = mkN "bдckforell" "bдckforeller" ;
  baeckoering_nn_1 = mkN "bдckцring" ;
  baeckravin_nn_1 = mkN "bдckravin" "bдckraviner" ;
  baeckroeding_nn_1 = mkN "bдckrцding" ;
  baedd_nn_1 = mkN "bдdd" ;
  baeddutrustning_nn_1 = mkN "bдddutrustning" ;
  baegare_nn_1 = mkN "bдgare" "bдgare" ;
  baegarkorall_nn_1 = mkN "bдgarkorall" "bдgarkoraller" ;
  baegarmanet_nn_1 = mkN "bдgarmanet" "bдgarmaneter" ;
  baegarsvamp_nn_1 = mkN "bдgarsvamp" ;
  baelg_nn_1 = mkN "bдlg" ;
  baelgkamera_nn_1 = mkN "bдlgkamera" ;
  baelgliknande_av_1 = mkA "bдlgliknande" ;
  baelgvante_nn_1 = mkN "bдlgvante" utrum ;
  baeltdjur_nn_1 = mkN "bдltdjur" neutrum ;
  baeltespaennare_nn_1 = mkN "bдltespдnnare" "bдltespдnnare" ;
  baendelband_nn_1 = mkN "bдndelband" neutrum ;
  baendjaern_nn_1 = mkN "bдndjдrn" neutrum ;
  baendsel_nn_1 = mkN "bдndsel" ;
  baengel_nn_1 = mkN "bдngel" ;
  baenk_nn_1 = mkN "bдnk" ;
  baenkgranne_nn_1 = mkN "bдnkgranne" utrum ;
  baenkkamrat_nn_1 = mkN "bдnkkamrat" "bдnkkamrater" ;
  baenknummer_nn_1 = mkN "bдnknummer" neutrum ;
  baenkrad_nn_1 = mkN "bдnkrad" "bдnkrader" ;
  baenkspis_nn_1 = mkN "bдnkspis" ;
  baensel_nn_1 = mkN "bдnsel" ;
  baer_nn_1 = mkN "bдr" neutrum ;
  baera_vb_1 = mkV "bдra" "bar" "burit" ;
  baerande_av_1 = mkA "bдrande" ;
  baerare_nn_1 = mkN "bдrare" "bдrare" ;
  baerbar_av_1 = mkA "bдrbar" ;
  baerbjaelke_nn_1 = mkN "bдrbjдlke" utrum ;
  baerbuske_nn_1 = mkN "bдrbuske" utrum ;
  baerfis_nn_1 = mkN "bдrfis" ;
  baerfrekvens_nn_1 = mkN "bдrfrekvens" "bдrfrekvenser" ;
  baergning_nn_1 = mkN "bдrgning" ;
  baergningsbil_nn_1 = mkN "bдrgningsbil" ;
  baerig_av_1 = mkA "bдrig" ;
  baering_nn_1 = mkN "bдring" ;
  baerkasse_nn_1 = mkN "bдrkasse" utrum ;
  baerkotte_nn_1 = mkN "bдrkotte" utrum ;
  baerkraftig_av_1 = mkA "bдrkraftig" ;
  baerlager_nn_1 = mkN "bдrlager" neutrum ;
  baerm_nn_1 = mkN "bдrm" "bдrmer" ;
  baermark_nn_1 = mkN "bдrmark" "bдrmarker" ;
  baerpaase_nn_1 = mkN "bдrpеse" utrum ;
  baerplan_nn_1 = mkN "bдrplan" neutrum ;
  baerplansbaat_nn_1 = mkN "bдrplansbеt" ;
  baerplockare_nn_1 = mkN "bдrplockare" "bдrplockare" ;
  baers_nn_1 = mkN "bдrs" "bдrsen" "bдrs" "bдrsen" ;
  baersaerk_nn_1 = mkN "bдrsдrk" ;
  baerstol_nn_1 = mkN "bдrstol" ;
  baervidd_nn_1 = mkN "bдrvidd" "bдrvidder" ;
  baesteman_nn_1 = mkN "bдsteman" "bдstemannen" "bдstemдn" "bдstemдnnen" ;
  baestis_nn_1 = mkN "bдstis" ;
  baestsaeljare_nn_1 = mkN "bдstsдljare" "bдstsдljare" ;
  baettring_nn_1 = mkN "bдttring" ;
  baever_nn_1 = mkN "bдver" ;
  baevning_nn_1 = mkN "bдvning" ;
  bag_nn_1 = mkN "bag" ;
  bagageinlaemning_nn_1 = mkN "bagageinlдmning" ;
  bagageutrymme_nn_1 = mkN "bagageutrymme" ;
  bagarbarn_nn_1 = mkN "bagarbarn" neutrum ;
  bagarbod_nn_1 = mkN "bagarbod" ;
  bagare_nn_1 = mkN "bagare" "bagare" ;
  bagatell_nn_1 = mkN "bagatell" "bagateller" ;
  bagatellmaal_nn_1 = mkN "bagatellmеl" neutrum ;
  bagel_nn_1 = mkN "bagel" "bageln" "bagels" "bagelsen" ;
  bageri_nn_1 = mkN "bageri" "bagerit" "bagerier" "bagerierna" ;
  bagerimargarin_nn_1 = mkN "bagerimargarin" "bagerimargarinet" "bagerimargariner" "bagerimargarinerna" ;
  bagg_nn_1 = mkN "bagg" ;
  bagge_nn_1 = mkN "bagge" utrum ;
  bagis_nn_1 = mkN "bagis" ;
  baguette_nn_1 = mkN "baguette" "baguetter" ;
  bahaman_nn_1 = mkN "bahaman" "bahamaner" ;
  bahamansk_av_1 = mkA "bahamansk" ;
  bahrainare_nn_1 = mkN "bahrainare" "bahrainare" ;
  bahrainsk_av_1 = mkA "bahrainsk" ;
  bahytt_nn_1 = mkN "bahytt" "bahytter" ;
  baisse_nn_1 = mkN "baisse" "baisser" ;
  bajadaer_nn_1 = mkN "bajadдr" "bajadдrer" ;
  bajersk_av_1 = mkA "bajersk" ;
  bajonett_nn_1 = mkN "bajonett" "bajonetter" ;
  bajonettbalja_nn_1 = mkN "bajonettbalja" ;
  bajonettfattning_nn_1 = mkN "bajonettfattning" ;
  bajrare_nn_1 = mkN "bajrare" "bajrare" ;
  bajsnoedig_av_1 = mkA "bajsnцdig" ;
  bak_ab_1 = mkAdv "bak" ;
  bak_nn_1 = mkN "bak" ;
  bak_nn_2 = mkN "bak" neutrum ;
  bakaat_ab_1 = mkAdv "bakеt" ;
  bakaatraeknande_av_1 = mkA "bakеtrдknande" ;
  bakaatstraevande_av_1 = mkA "bakеtstrдvande" ;
  bakaatstraevare_nn_1 = mkN "bakеtstrдvare" "bakеtstrдvare" ;
  bakarv_nn_1 = mkN "bakarv" neutrum ;
  bakarvinge_nn_1 = mkN "bakarvinge" utrum ;
  bakaxel_nn_1 = mkN "bakaxel" ;
  bakaxelvaexel_nn_1 = mkN "bakaxelvдxel" ;
  bakben_nn_1 = mkN "bakben" neutrum ;
  bakbinda_vb_1 = mkV "bakbinda" "bakband" "bakbundit" ;
  bakblaasare_nn_1 = mkN "bakblеsare" "bakblеsare" ;
  bakdaeck_nn_1 = mkN "bakdдck" neutrum ;
  bakdel_nn_1 = mkN "bakdel" "bakdelen" "bakdelar" "bakdelarna" ;
  bakdoerr_nn_1 = mkN "bakdцrr" ;
  bakefter_ab_1 = mkAdv "bakefter" ;
  bakelse_nn_1 = mkN "bakelse" "bakelser" ;
  bakfot_nn_1 = mkN "bakfot" "bakfцtter" ;
  bakfram_ab_1 = mkAdv "bakfram" ;
  bakfull_av_1 = mkA "bakfull" ;
  bakgaard_nn_1 = mkN "bakgеrd" ;
  bakgrund_nn_1 = mkN "bakgrund" "bakgrunder" ;
  bakgrundsfigur_nn_1 = mkN "bakgrundsfigur" "bakgrundsfigurer" ;
  bakgrundsstraalning_nn_1 = mkN "bakgrundsstrеlning" ;
  bakgrundsvariabel_nn_1 = mkN "bakgrundsvariabel" "bakgrundsvariabeln" "bakgrundsvariabler" "bakgrundsvariablerna" ;
  bakhaall_nn_1 = mkN "bakhеll" neutrum ;
  bakhal_av_1 = mkA "bakhal" ;
  bakhas_nn_1 = mkN "bakhas" ;
  bakhjul_nn_1 = mkN "bakhjul" neutrum ;
  bakhuvud_nn_1 = mkN "bakhuvud" "bakhuvudet" "bakhuvuden" "bakhuvudena" ;
  baki_ab_1 = mkAdv "baki" ;
  bakifraan_ab_1 = mkAdv "bakifrеn" ;
  bakjour_nn_1 = mkN "bakjour" "bakjourer" ;
  bakkropp_nn_1 = mkN "bakkropp" ;
  bakladdare_nn_1 = mkN "bakladdare" "bakladdare" ;
  bakladdning_nn_1 = mkN "bakladdning" ;
  baklaenges_ab_1 = mkAdv "baklдnges" ;
  baklaengesordbok_nn_1 = mkN "baklдngesordbok" "baklдngesordbцcker" ;
  bakoever_ab_1 = mkAdv "bakцver" ;
  bakom_ab_1 = mkAdv "bakom" ;
  bakpaa_ab_1 = mkAdv "bakpе" ;
  bakplaat_nn_1 = mkN "bakplеt" ;
  bakplaatspapper_nn_1 = mkN "bakplеtspapper" neutrum ;
  bakprojektion_nn_1 = mkN "bakprojektion" "bakprojektioner" ;
  bakpulver_nn_1 = mkN "bakpulver" neutrum ;
  bakrus_nn_1 = mkN "bakrus" neutrum ;
  baksaete_nn_1 = mkN "baksдte" ;
  baksida_nn_1 = mkN "baksida" ;
  bakslag_nn_1 = mkN "bakslag" neutrum ;
  bakslagsventil_nn_1 = mkN "bakslagsventil" "bakslagsventiler" ;
  bakslug_av_1 = mkA "bakslug" ;
  bakspaar_nn_1 = mkN "bakspеr" neutrum ;
  bakstraevare_nn_1 = mkN "bakstrдvare" "bakstrдvare" ;
  bakstroem_nn_1 = mkN "bakstrцm" "bakstrцmmen" "bakstrцmmar" "bakstrцmmarna" ;
  baktanke_nn_1 = mkN "baktanke" utrum ;
  baktericid_nn_1 = mkN "baktericid" "baktericider" ;
  bakterie_nn_1 = mkN "bakterie" "bakterier" ;
  bakterieart_nn_1 = mkN "bakterieart" "bakteriearter" ;
  bakteriedoedande_av_1 = mkA "bakteriedцdande" ;
  bakteriehaerd_nn_1 = mkN "bakteriehдrd" ;
  bakteriekultur_nn_1 = mkN "bakteriekultur" "bakteriekulturer" ;
  bakteriofag_nn_1 = mkN "bakteriofag" "bakteriofager" ;
  bakteriolog_nn_1 = mkN "bakteriolog" "bakteriologer" ;
  bakteriologisk_av_1 = mkA "bakteriologisk" ;
  baktill_ab_1 = mkAdv "baktill" ;
  baktung_av_1 = mkA "baktung" ;
  bakugn_nn_1 = mkN "bakugn" ;
  bakut_ab_1 = mkAdv "bakut" ;
  bakvaeg_nn_1 = mkN "bakvдg" ;
  bakvaend_av_1 = mkA "bakvдnd" ;
  bakvatten_nn_1 = mkN "bakvatten" "bakvattnet" "bakvatten" "bakvattnen" ;
  bakverk_nn_1 = mkN "bakverk" neutrum ;
  bakvid_ab_1 = mkAdv "bakvid" ;
  bakvikt_nn_1 = mkN "bakvikt" "bakvikter" ;
  bal_nn_1 = mkN "bal" ;
  bal_nn_2 = mkN "bal" "baler" ;
  balans_nn_1 = mkN "balans" "balanser" ;
  balansakt_nn_1 = mkN "balansakt" "balansakter" ;
  balansering_nn_1 = mkN "balansering" ;
  balanserstaang_nn_1 = mkN "balanserstеng" "balanserstдnger" ;
  balanshjul_nn_1 = mkN "balanshjul" neutrum ;
  balanskonstnaer_nn_1 = mkN "balanskonstnдr" "balanskonstnдrer" ;
  balanskonto_nn_1 = mkN "balanskonto" "balanskontot" "balanskonton" "balanskontona" ;
  balansplog_nn_1 = mkN "balansplog" ;
  balansraekning_nn_1 = mkN "balansrдkning" ;
  balansroder_nn_1 = mkN "balansroder" neutrum ;
  balansrubbning_nn_1 = mkN "balansrubbning" ;
  balansvaag_nn_1 = mkN "balansvеg" ;
  baldakin_nn_1 = mkN "baldakin" "baldakiner" ;
  baldersbraa_nn_1 = mkN "baldersbrе" "baldersbrеn" "baldersbrеr" "baldersbrеrna" ;
  bale_nn_1 = mkN "bale" utrum ;
  balett_nn_1 = mkN "balett" "baletter" ;
  balettdans_nn_1 = mkN "balettdans" "balettdanser" ;
  balettdansoes_nn_1 = mkN "balettdansцs" "balettdansцser" ;
  balettmaestare_nn_1 = mkN "balettmдstare" "balettmдstare" ;
  baljvaext_nn_1 = mkN "baljvдxt" "baljvдxter" ;
  balk_nn_1 = mkN "balk" ;
  balkanfolk_nn_1 = mkN "balkanfolk" neutrum ;
  balkanisering_nn_1 = mkN "balkanisering" ;
  balkknae_nn_1 = mkN "balkknд" "balkknдet" "balkknдn" "balkknдna" ;
  balkong_nn_1 = mkN "balkong" "balkonger" ;
  balkvaegare_nn_1 = mkN "balkvдgare" "balkvдgare" ;
  balkverk_nn_1 = mkN "balkverk" neutrum ;
  ball_av_1 = mkA "ball" ;
  ballad_nn_1 = mkN "ballad" "ballader" ;
  ballast_nn_1 = mkN "ballast" "ballaster" ;
  ballong_nn_1 = mkN "ballong" "ballonger" ;
  ballongboll_nn_1 = mkN "ballongboll" ;
  ballongdaeck_nn_1 = mkN "ballongdдck" neutrum ;
  ballonggas_nn_1 = mkN "ballonggas" "ballonggaser" ;
  ballongprick_nn_1 = mkN "ballongprick" ;
  ballongsegel_nn_1 = mkN "ballongsegel" neutrum ;
  balloptikon_nn_1 = mkN "balloptikon" neutrum ;
  balneolog_nn_1 = mkN "balneolog" "balneologer" ;
  balsam_nn_1 = mkN "balsam" "balsamer" ;
  balsamdoftande_av_1 = mkA "balsamdoftande" ;
  balsamin_nn_1 = mkN "balsamin" "balsaminer" ;
  balsamisk_av_1 = mkA "balsamisk" ;
  balt_nn_1 = mkN "balt" "balter" ;
  baltisk_av_1 = mkA "baltisk" ;
  baluns_nn_1 = mkN "baluns" "balunser" ;
  baluster_nn_1 = mkN "baluster" ;
  balustrad_nn_1 = mkN "balustrad" "balustrader" ;
  bamburoer_nn_1 = mkN "bamburцr" neutrum ;
  ban_nn_1 = mkN "ban" ;
  banal_av_1 = mkA "banal" ;
  banalitet_nn_1 = mkN "banalitet" "banaliteter" ;
  banan_nn_1 = mkN "banan" "bananer" ;
  banankontakt_nn_1 = mkN "banankontakt" "banankontakter" ;
  bananrepublik_nn_1 = mkN "bananrepublik" "bananrepubliker" ;
  bananstock_nn_1 = mkN "bananstock" ;
  banbrytande_av_1 = mkA "banbrytande" ;
  banbrytare_nn_1 = mkN "banbrytare" "banbrytare" ;
  band_nn_1 = mkN "band" neutrum ;
  bandage_nn_1 = mkN "bandage" "bandaget" "bandage" "bandagen" ;
  banderoll_nn_1 = mkN "banderoll" "banderoller" ;
  bandfordon_nn_1 = mkN "bandfordon" neutrum ;
  bandgenerator_nn_1 = mkN "bandgenerator" "bandgeneratorer" ;
  bandhund_nn_1 = mkN "bandhund" ;
  bandit_nn_1 = mkN "bandit" "banditer" ;
  bandolaer_nn_1 = mkN "bandolдr" neutrum ;
  bandotek_nn_1 = mkN "bandotek" neutrum ;
  bandspektrum_nn_1 = mkN "bandspektrum" neutrum ;
  bandspelare_nn_1 = mkN "bandspelare" "bandspelare" ;
  bandstation_nn_1 = mkN "bandstation" "bandstationer" ;
  bandtraktor_nn_1 = mkN "bandtraktor" "bandtraktorer" ;
  bandyroer_nn_1 = mkN "bandyrцr" neutrum ;
  bandyslag_nn_1 = mkN "bandyslag" neutrum ;
  baneman_nn_1 = mkN "baneman" "banemannen" "banemдn" "banemдnnen" ;
  baner_nn_1 = mkN "baner" "baneret" "baner" "baneren" ;
  banerfoerare_nn_1 = mkN "banerfцrare" "banerfцrare" ;
  banesaar_nn_1 = mkN "banesеr" neutrum ;
  bang_av_1 = mkA "bang" ;
  bang_nn_1 = mkN "bang" ;
  bangaard_nn_1 = mkN "bangеrd" ;
  bangladeshare_nn_1 = mkN "bangladeshare" "bangladeshare" ;
  bangladeshisk_av_1 = mkA "bangladeshisk" ;
  banhall_nn_1 = mkN "banhall" ;
  baning_nn_1 = mkN "baning" ;
  banjo_nn_1 = mkN "banjo" "banjor" ;
  bank_nn_1 = mkN "bank" ;
  bank_nn_2 = mkN "bank" "banker" ;
  bankbok_nn_1 = mkN "bankbok" "bankbцcker" ;
  bankett_nn_1 = mkN "bankett" "banketter" ;
  bankfack_nn_1 = mkN "bankfack" neutrum ;
  bankgiro_nn_1 = mkN "bankgiro" "bankgirot" "bankgiron" "bankgirona" ;
  bankinspektion_nn_1 = mkN "bankinspektion" "bankinspektioner" ;
  bankir_nn_1 = mkN "bankir" "bankirer" ;
  bankkamrer_nn_1 = mkN "bankkamrer" "bankkamrerer" ;
  bankkonto_nn_1 = mkN "bankkonto" "bankkontot" "bankkonton" "bankkontona" ;
  banklaan_nn_1 = mkN "banklеn" neutrum ;
  bankofullmaektig_nn_1 = mkN "bankofullmдktig" "bankofullmдktigen" "bankofullmдktige" "bankofullmдktigena" ;
  bankomat_nn_1 = mkN "bankomat" "bankomater" ;
  bankroerelse_nn_1 = mkN "bankrцrelse" "bankrцrelser" ;
  bankrutt_av_1 = mkA "bankrutt" ;
  bankrutt_nn_1 = mkN "bankrutt" "bankrutter" ;
  bankruttoer_nn_1 = mkN "bankruttцr" "bankruttцrer" ;
  banksparande_nn_1 = mkN "banksparande" ;
  bankvaexel_nn_1 = mkN "bankvдxel" ;
  banloepning_nn_1 = mkN "banlцpning" ;
  bann_nn_1 = mkN "bann" neutrum ;
  bannstraale_nn_1 = mkN "bannstrеle" utrum ;
  banrekord_nn_1 = mkN "banrekord" neutrum ;
  banroerelse_nn_1 = mkN "banrцrelse" "banrцrelser" ;
  bantlaer_nn_1 = mkN "bantlдr" neutrum ;
  bantufolk_nn_1 = mkN "bantufolk" neutrum ;
  bantuspraak_nn_1 = mkN "bantusprеk" neutrum ;
  banvagn_nn_1 = mkN "banvagn" ;
  banvall_nn_1 = mkN "banvall" ;
  baptist_nn_1 = mkN "baptist" "baptister" ;
  baptisterium_nn_1 = mkN "baptisterium" "baptisteriet" "baptisterier" "baptisterierna" ;
  bar_av_1 = mkA "bar" ;
  bar_nn_1 = mkN "bar" "barer" ;
  bar_nn_2 = mkN "bar" "baren" "bar" "baren" ;
  bara_ab_1 = mkAdv "bara" ;
  barack_nn_1 = mkN "barack" "baracker" ;
  barbacka_ab_1 = mkAdv "barbacka" ;
  barbadier_nn_1 = mkN "barbadier" "barbadiern" "barbadier" "barbadierna" ;
  barbadisk_av_1 = mkA "barbadisk" ;
  barbar_nn_1 = mkN "barbar" "barbarer" ;
  barbarisk_av_1 = mkA "barbarisk" ;
  barbarism_nn_1 = mkN "barbarism" "barbarismer" ;
  barbent_av_1 = mkA "barbent" "barbent" ;
  barberare_nn_1 = mkN "barberare" "barberare" ;
  barbiturat_nn_1 = mkN "barbiturat" neutrum ;
  bard_nn_1 = mkN "bard" "barder" ;
  bardisan_nn_1 = mkN "bardisan" "bardisaner" ;
  bardisk_nn_1 = mkN "bardisk" ;
  bardun_nn_1 = mkN "bardun" "barduner" ;
  bardval_nn_1 = mkN "bardval" ;
  barett_nn_1 = mkN "barett" "baretter" ;
  barfota_av_1 = mkA "barfota" ;
  barfotalaekare_nn_1 = mkN "barfotalдkare" "barfotalдkare" ;
  barfotalasse_nn_1 = mkN "barfotalasse" utrum ;
  barfotamunk_nn_1 = mkN "barfotamunk" ;
  bariton_nn_1 = mkN "bariton" "baritoner" ;
  bariumfoerening_nn_1 = mkN "bariumfцrening" ;
  bariumsalt_nn_1 = mkN "bariumsalt" "bariumsaltet" "bariumsalter" "bariumsalterna" ;
  bariumsulfat_nn_1 = mkN "bariumsulfat" neutrum ;
  bark_nn_2 = mkN "bark" ;
  barkaroll_nn_1 = mkN "barkaroll" "barkaroller" ;
  barkass_nn_1 = mkN "barkass" "barkasser" ;
  barkbaat_nn_1 = mkN "barkbеt" ;
  barkborre_nn_1 = mkN "barkborre" utrum ;
  barkbroed_nn_1 = mkN "barkbrцd" neutrum ;
  barkis_nn_1 = mkN "barkis" ;
  barkspade_nn_1 = mkN "barkspade" utrum ;
  barktaekt_nn_1 = mkN "barktдkt" "barktдkter" ;
  barlast_nn_1 = mkN "barlast" "barlaster" ;
  barlastkoel_nn_1 = mkN "barlastkцl" ;
  barm_nn_1 = mkN "barm" ;
  barmark_nn_1 = mkN "barmark" "barmarker" ;
  barmhaertig_av_1 = mkA "barmhдrtig" ;
  barmhaertighet_nn_1 = mkN "barmhдrtighet" "barmhдrtigheter" ;
  barmhaertighetsmord_nn_1 = mkN "barmhдrtighetsmord" neutrum ;
  barn_nn_1 = mkN "barn" neutrum ;
  barnadoedlighet_nn_1 = mkN "barnadцdlighet" "barnadцdligheter" ;
  barnafader_nn_1 = mkN "barnafader" "barnafadern" "barnafдder" "barnafдderna" ;
  barnafoederska_nn_1 = mkN "barnafцderska" ;
  barnarov_nn_1 = mkN "barnarov" neutrum ;
  barnasinne_nn_1 = mkN "barnasinne" ;
  barnavaard_nn_1 = mkN "barnavеrd" ;
  barnavaardscentral_nn_1 = mkN "barnavеrdscentral" "barnavеrdscentraler" ;
  barnavaardsman_nn_1 = mkN "barnavеrdsman" "barnavеrdsmannen" "barnavеrdsmдn" "barnavеrdsmдnnen" ;
  barnavaardsnaemnd_nn_1 = mkN "barnavеrdsnдmnd" "barnavеrdsnдmnder" ;
  barnbarn_nn_1 = mkN "barnbarn" neutrum ;
  barnbarnsbarn_nn_1 = mkN "barnbarnsbarn" neutrum ;
  barnbegraensning_nn_1 = mkN "barnbegrдnsning" ;
  barnbespisning_nn_1 = mkN "barnbespisning" ;
  barnbidrag_nn_1 = mkN "barnbidrag" neutrum ;
  barnboerdshus_nn_1 = mkN "barnbцrdshus" neutrum ;
  barnbok_nn_1 = mkN "barnbok" "barnbцcker" ;
  barncykel_nn_1 = mkN "barncykel" ;
  barndaghem_nn_1 = mkN "barndaghem" "barndaghemmet" "barndaghem" "barndaghemmen" ;
  barndom_nn_1 = mkN "barndom" ;
  barndop_nn_1 = mkN "barndop" neutrum ;
  barnfamilj_nn_1 = mkN "barnfamilj" "barnfamiljer" ;
  barnfoedd_av_1 = mkA "barnfцdd" ;
  barnfoerbjuden_av_1 = mkA "barnfцrbjuden" "barnfцrbjudet" ;
  barngrupp_nn_1 = mkN "barngrupp" "barngrupper" ;
  barnhem_nn_1 = mkN "barnhem" "barnhemmet" "barnhem" "barnhemmen" ;
  barnhuvud_nn_1 = mkN "barnhuvud" "barnhuvudet" "barnhuvuden" "barnhuvudena" ;
  barnkaer_av_1 = mkA "barnkдr" ;
  barnkalas_nn_1 = mkN "barnkalas" neutrum ;
  barnkoloni_nn_1 = mkN "barnkoloni" "barnkolonier" ;
  barnledig_av_1 = mkA "barnledig" ;
  barnlek_nn_1 = mkN "barnlek" ;
  barnloes_av_1 = mkA "barnlцs" ;
  barnmorska_nn_1 = mkN "barnmorska" ;
  barnomsorgskostnad_nn_1 = mkN "barnomsorgskostnad" "barnomsorgskostnader" ;
  barnparkering_nn_1 = mkN "barnparkering" ;
  barnpassning_nn_1 = mkN "barnpassning" ;
  barnsaeker_av_1 = mkA "barnsдker" "barnsдkert" "barnsдkra" "barnsдkra" "barnsдkrare" "barnsдkrast" "barnsдkraste" ;
  barnsaeng_nn_1 = mkN "barnsдng" ;
  barnsak_nn_1 = mkN "barnsak" "barnsaker" ;
  barnsboerd_nn_1 = mkN "barnsbцrd" "barnsbцrder" ;
  barnsjukdom_nn_1 = mkN "barnsjukdom" ;
  barnsko_nn_1 = mkN "barnsko" "barnskor" ;
  barnskoeterska_nn_1 = mkN "barnskцterska" ;
  barnslig_av_1 = mkA "barnslig" ;
  barnslighet_nn_1 = mkN "barnslighet" "barnsligheter" ;
  barnstuga_nn_1 = mkN "barnstuga" ;
  barntillaaten_av_1 = mkA "barntillеten" "barntillеtet" ;
  barnunge_nn_1 = mkN "barnunge" utrum ;
  barnvagn_nn_1 = mkN "barnvagn" ;
  barnvakt_nn_1 = mkN "barnvakt" "barnvakter" ;
  barock_av_1 = mkA "barock" ;
  barockstil_nn_1 = mkN "barockstil" ;
  barograf_nn_1 = mkN "barograf" "barografer" ;
  barogram_nn_1 = mkN "barogram" "barogrammet" "barogram" "barogrammen" ;
  barometer_nn_1 = mkN "barometer" ;
  barometerfall_nn_1 = mkN "barometerfall" neutrum ;
  barometerstaand_nn_1 = mkN "barometerstеnd" neutrum ;
  barometrisk_av_1 = mkA "barometrisk" ;
  baron_nn_1 = mkN "baron" "baroner" ;
  barospirator_nn_1 = mkN "barospirator" "barospiratorer" ;
  barr_nn_1 = mkN "barr" neutrum ;
  barr_nn_2 = mkN "barr" "barrer" ;
  barriaer_nn_1 = mkN "barriдr" "barriдrer" ;
  barrikad_nn_1 = mkN "barrikad" "barrikader" ;
  barrikadkaempe_nn_1 = mkN "barrikadkдmpe" utrum ;
  barrikadstrid_nn_1 = mkN "barrikadstrid" "barrikadstrider" ;
  barrskog_nn_1 = mkN "barrskog" ;
  barrskogsgraens_nn_1 = mkN "barrskogsgrдns" "barrskogsgrдnser" ;
  barrskogsregion_nn_1 = mkN "barrskogsregion" "barrskogsregioner" ;
  barrtraed_nn_1 = mkN "barrtrдd" neutrum ;
  barrtraedskotte_nn_1 = mkN "barrtrдdskotte" utrum ;
  barrtraedssort_nn_1 = mkN "barrtrдdssort" "barrtrдdssorter" ;
  barservering_nn_1 = mkN "barservering" ;
  barsk_av_1 = mkA "barsk" ;
  barskaap_nn_1 = mkN "barskеp" neutrum ;
  barstol_nn_1 = mkN "barstol" ;
  bartender_nn_1 = mkN "bartender" ;
  barvinter_nn_1 = mkN "barvinter" ;
  barysfaer_nn_1 = mkN "barysfдr" "barysfдrer" ;
  baryton_nn_1 = mkN "baryton" "barytoner" ;
  bas_nn_1 = mkN "bas" ;
  bas_nn_2 = mkN "bas" "baser" ;
  basaar_nn_1 = mkN "basеr" neutrum ;
  basal_av_1 = mkA "basal" ;
  basar_nn_1 = mkN "basar" "basarer" ;
  basbelopp_nn_1 = mkN "basbelopp" neutrum ;
  basenhet_nn_1 = mkN "basenhet" "basenheter" ;
  basfaerdighet_nn_1 = mkN "basfдrdighet" "basfдrdigheter" ;
  basfiol_nn_1 = mkN "basfiol" "basfioler" ;
  basilisk_nn_1 = mkN "basilisk" "basilisker" ;
  basisk_av_1 = mkA "basisk" ;
  basist_nn_1 = mkN "basist" "basister" ;
  bask_nn_1 = mkN "bask" "basker" ;
  basker_nn_1 = mkN "basker" ;
  basketboll_nn_1 = mkN "basketboll" ;
  baskisk_av_1 = mkA "baskisk" ;
  baskiska_nn_2 = mkN "baskiska" ;
  baslinje_nn_1 = mkN "baslinje" "baslinjer" ;
  basning_nn_1 = mkN "basning" ;
  basorganisation_nn_1 = mkN "basorganisation" "basorganisationer" ;
  basrelief_nn_1 = mkN "basrelief" "basreliefer" ;
  bassaeng_nn_1 = mkN "bassдng" "bassдnger" ;
  basse_nn_1 = mkN "basse" utrum ;
  basset_nn_1 = mkN "basset" ;
  bast_nn_2 = mkN "bast" neutrum ;
  bastant_av_1 = mkA "bastant" "bastant" ;
  bastard_nn_1 = mkN "bastard" "bastarder" ;
  bastardform_nn_1 = mkN "bastardform" "bastardformer" ;
  bastardnaektergal_nn_1 = mkN "bastardnдktergal" ;
  bastcell_nn_1 = mkN "bastcell" "bastceller" ;
  bastfiber_nn_1 = mkN "bastfiber" "bastfibern" "bastfibrer" "bastfibrerna" ;
  bastingering_nn_1 = mkN "bastingering" ;
  bastion_nn_1 = mkN "bastion" "bastioner" ;
  bastonad_nn_1 = mkN "bastonad" "bastonader" ;
  bastu_nn_1 = mkN "bastu" "bastun" "bastur" "basturna" ;
  bastubad_nn_1 = mkN "bastubad" neutrum ;
  basun_nn_1 = mkN "basun" "basuner" ;
  basunstoet_nn_1 = mkN "basunstцt" ;
  basvaeg_nn_1 = mkN "basvдg" ;
  basvinkel_nn_1 = mkN "basvinkel" ;
  batalj_nn_1 = mkN "batalj" "bataljer" ;
  bataljmaalare_nn_1 = mkN "bataljmеlare" "bataljmеlare" ;
  bataljmaalning_nn_1 = mkN "bataljmеlning" ;
  bataljon_nn_1 = mkN "bataljon" "bataljoner" ;
  bataljonschef_nn_1 = mkN "bataljonschef" "bataljonschefer" ;
  batat_nn_1 = mkN "batat" "batater" ;
  batist_nn_1 = mkN "batist" "batister" ;
  batong_nn_1 = mkN "batong" "batonger" ;
  batteri_nn_1 = mkN "batteri" "batterit" "batterier" "batterierna" ;
  batteridriven_av_1 = mkA "batteridriven" "batteridrivet" ;
  batteriprovare_nn_1 = mkN "batteriprovare" "batteriprovare" ;
  batterist_nn_1 = mkN "batterist" "batterister" ;
  batteritaendning_nn_1 = mkN "batteritдndning" ;
  batting_nn_1 = mkN "batting" ;
  batysfaer_nn_1 = mkN "batysfдr" "batysfдrer" ;
  baud_nn_1 = mkN "baud" "bauden" "baud" "bauden" ;
  bautasten_nn_1 = mkN "bautasten" "bautastenen" "bautastenar" "bautastenarna" ;
  be_vb_1 = mkV "be" "bad" "bett" ;
  beagle_nn_1 = mkN "beagle" utrum ;
  beaktansvaerd_av_1 = mkA "beaktansvдrd" "beaktansvдrt" ;
  bearbetning_nn_1 = mkN "bearbetning" ;
  bearnaisesaas_nn_1 = mkN "bearnaisesеs" "bearnaisesеser" ;
  beatnik_nn_1 = mkN "beatnik" ;
  bebaadelse_nn_1 = mkN "bebеdelse" "bebеdelser" ;
  bebis_nn_1 = mkN "bebis" ;
  bebodd_av_1 = mkA "bebodd" "bebodtt" ;
  beboelig_av_1 = mkA "beboelig" ;
  bebyggelse_nn_1 = mkN "bebyggelse" "bebyggelser" ;
  bebyggelsenamn_nn_1 = mkN "bebyggelsenamn" neutrum ;
  beckasin_nn_1 = mkN "beckasin" "beckasiner" ;
  beckig_av_1 = mkA "beckig" ;
  beckmoerk_av_1 = mkA "beckmцrk" ;
  becquerel_nn_1 = mkN "becquerel" "becquerelen" "becquerel" "becquerelen" ;
  bedaarande_av_1 = mkA "bedеrande" ;
  bedja_vb_1 = mkV "bedja" "bedjar" "bedja" "bedjad" "bedjatt" "bedjadd" ;
  bedjande_av_1 = mkA "bedjande" ;
  bedoemande_nn_1 = mkN "bedцmande" ;
  bedoemare_nn_1 = mkN "bedцmare" "bedцmare" ;
  bedoemning_nn_1 = mkN "bedцmning" ;
  bedoevning_nn_1 = mkN "bedцvning" ;
  bedoevningsmedel_nn_1 = mkN "bedцvningsmedel" neutrum ;
  bedra_vb_1 = mkV "bedra" "bedrar" "bedra" "bedrog" "bedragit" "bedragen" ;
  bedraegeri_nn_1 = mkN "bedrдgeri" "bedrдgerit" "bedrдgerier" "bedrдgerierna" ;
  bedraeglig_av_1 = mkA "bedrдglig" ;
  bedragare_nn_1 = mkN "bedragare" "bedragare" ;
  bedrift_nn_1 = mkN "bedrift" "bedrifter" ;
  bedriva_vb_1 = mkV "bedriva" "bedrev" "bedrivit" ;
  bedroevelse_nn_1 = mkN "bedrцvelse" "bedrцvelser" ;
  bedroevlig_av_1 = mkA "bedrцvlig" ;
  beduin_nn_1 = mkN "beduin" "beduiner" ;
  befael_nn_1 = mkN "befдl" neutrum ;
  befaelhavande_av_1 = mkA "befдlhavande" ;
  befaelhavare_nn_1 = mkN "befдlhavare" "befдlhavare" ;
  befaelselev_nn_1 = mkN "befдlselev" "befдlselever" ;
  befaelsfoering_nn_1 = mkN "befдlsfцring" ;
  befaelsgrad_nn_1 = mkN "befдlsgrad" "befдlsgrader" ;
  befaelsstaellning_nn_1 = mkN "befдlsstдllning" ;
  befaelstecken_nn_1 = mkN "befдlstecken" "befдlstecknet" "befдlstecken" "befдlstecknen" ;
  befaengd_av_1 = mkA "befдngd" "befдngt" ;
  befaestning_nn_1 = mkN "befдstning" ;
  befaestningsgrav_nn_1 = mkN "befдstningsgrav" ;
  befaestningslinje_nn_1 = mkN "befдstningslinje" "befдstningslinjer" ;
  befaestningsskydd_nn_1 = mkN "befдstningsskydd" neutrum ;
  befaestningsverk_nn_1 = mkN "befдstningsverk" neutrum ;
  befallande_av_1 = mkA "befallande" ;
  befallning_nn_1 = mkN "befallning" ;
  befallningshavande_nn_1 = mkN "befallningshavande" "befallningshavanden" "befallningshavande" "befallningshavandena" ;
  befallningsman_nn_1 = mkN "befallningsman" "befallningsmannen" "befallningsmдn" "befallningsmдnnen" ;
  befara_vb_2 = mkV "befara" "befor" "befarit" ;
  befaren_av_1 = mkA "befaren" "befaret" ;
  befattning_nn_1 = mkN "befattning" ;
  befattningshavare_nn_1 = mkN "befattningshavare" "befattningshavare" ;
  befinna_vb_1 = mkV "befinna" "befann" "befunnit" ;
  befintlig_av_1 = mkA "befintlig" ;
  befintlighet_nn_1 = mkN "befintlighet" "befintligheter" ;
  befjaedring_nn_1 = mkN "befjдdring" ;
  befogenhet_nn_1 = mkN "befogenhet" "befogenheter" ;
  befolkning_nn_1 = mkN "befolkning" ;
  befolkningsexplosion_nn_1 = mkN "befolkningsexplosion" "befolkningsexplosioner" ;
  befolkningsgrupp_nn_1 = mkN "befolkningsgrupp" "befolkningsgrupper" ;
  befolkningsoekning_nn_1 = mkN "befolkningsцkning" ;
  befolkningspyramid_nn_1 = mkN "befolkningspyramid" "befolkningspyramider" ;
  befolkningsstatistik_nn_1 = mkN "befolkningsstatistik" "befolkningsstatistiker" ;
  befordran_nn_1 = mkN "befordran" "befordran" "befordringar" "befordringarna" ;
  befordring_nn_1 = mkN "befordring" ;
  befordringsgaang_nn_1 = mkN "befordringsgеng" ;
  befordringsgrund_nn_1 = mkN "befordringsgrund" "befordringsgrunder" ;
  befraemjare_nn_1 = mkN "befrдmjare" "befrдmjare" ;
  befraktare_nn_1 = mkN "befraktare" "befraktare" ;
  befraktning_nn_1 = mkN "befraktning" ;
  befriande_av_1 = mkA "befriande" ;
  befrielse_nn_1 = mkN "befrielse" "befrielser" ;
  befrielsefront_nn_1 = mkN "befrielsefront" "befrielsefronter" ;
  befrielsekamp_nn_1 = mkN "befrielsekamp" "befrielsekamper" ;
  befrielsekrig_nn_1 = mkN "befrielsekrig" neutrum ;
  befrielseroerelse_nn_1 = mkN "befrielserцrelse" "befrielserцrelser" ;
  befruktning_nn_1 = mkN "befruktning" ;
  begaa_vb_1 = mkV "begе" "begеr" "begе" "begick" "begеtt" "begеngen" ;
  begaavning_nn_1 = mkN "begеvning" ;
  begaavningsreserv_nn_1 = mkN "begеvningsreserv" "begеvningsreserver" ;
  begaer_nn_1 = mkN "begдr" neutrum ;
  begaerelse_nn_1 = mkN "begдrelse" "begдrelser" ;
  begaerlig_av_1 = mkA "begдrlig" ;
  bege_vb_1 = mkV "bege" "beger" "bege" "begav" "begett" "begiven" ;
  begeistring_nn_1 = mkN "begeistring" ;
  begineraa_nn_1 = mkN "beginerе" "beginerеn" "beginerеr" "beginerеrna" ;
  begivande_nn_1 = mkN "begivande" ;
  begiven_av_1 = mkA "begiven" "begivet" ;
  begivenhet_nn_1 = mkN "begivenhet" "begivenheter" ;
  begjuta_vb_1 = mkV "begjuta" "begцt" "begjutit" ;
  begraata_vb_1 = mkV "begrеta" "begrдt" "begrеtit" ;
  begraensning_nn_1 = mkN "begrдnsning" ;
  begraensningslinje_nn_1 = mkN "begrдnsningslinje" "begrдnsningslinjer" ;
  begrava_vb_1 = mkV "begraver" ;
  begravning_nn_1 = mkN "begravning" ;
  begravningsakt_nn_1 = mkN "begravningsakt" "begravningsakter" ;
  begravningsbok_nn_1 = mkN "begravningsbok" "begravningsbцcker" ;
  begravningsbyraa_nn_1 = mkN "begravningsbyrе" "begravningsbyrеer" ;
  begravningsentreprenoer_nn_1 = mkN "begravningsentreprenцr" "begravningsentreprenцrer" ;
  begravningsgaest_nn_1 = mkN "begravningsgдst" "begravningsgдster" ;
  begravningskassa_nn_1 = mkN "begravningskassa" ;
  begravningskrans_nn_1 = mkN "begravningskrans" ;
  begravningsmarsch_nn_1 = mkN "begravningsmarsch" "begravningsmarscher" ;
  begravningsmin_nn_1 = mkN "begravningsmin" "begravningsminer" ;
  begravningsplats_nn_1 = mkN "begravningsplats" "begravningsplatser" ;
  begravningsprocession_nn_1 = mkN "begravningsprocession" "begravningsprocessioner" ;
  begravningstaag_nn_1 = mkN "begravningstеg" neutrum ;
  begrepp_nn_1 = mkN "begrepp" neutrum ;
  begreppsanalys_nn_1 = mkN "begreppsanalys" "begreppsanalyser" ;
  begreppsanalytisk_av_1 = mkA "begreppsanalytisk" ;
  begreppsbestaemning_nn_1 = mkN "begreppsbestдmning" ;
  begreppsfoervirring_nn_1 = mkN "begreppsfцrvirring" ;
  begreppslig_av_1 = mkA "begreppslig" ;
  begripa_vb_1 = mkV "begripa" "begrep" "begripit" ;
  begriplig_av_1 = mkA "begriplig" ;
  begriplighet_nn_1 = mkN "begriplighet" "begripligheter" ;
  begynnelse_nn_1 = mkN "begynnelse" "begynnelser" ;
  begynnelsebokstav_nn_1 = mkN "begynnelsebokstav" "begynnelsebokstдver" ;
  begynnelsehastighet_nn_1 = mkN "begynnelsehastighet" "begynnelsehastigheter" ;
  begynnelseloen_nn_1 = mkN "begynnelselцn" "begynnelselцner" ;
  begynnelserim_nn_1 = mkN "begynnelserim" "begynnelserimmet" "begynnelserim" "begynnelserimmen" ;
  begynnelseskede_nn_1 = mkN "begynnelseskede" ;
  begynnelsespraak_nn_1 = mkN "begynnelsesprеk" neutrum ;
  begynnelsestadium_nn_1 = mkN "begynnelsestadium" "begynnelsestadiet" "begynnelsestadier" "begynnelsestadierna" ;
  behaa_nn_1 = mkN "behе" ;
  behaalla_vb_1 = mkV "behеlla" "behцll" "behеllit" ;
  behaallare_nn_1 = mkN "behеllare" "behеllare" ;
  behaallning_nn_1 = mkN "behеllning" ;
  behaaring_nn_1 = mkN "behеring" ;
  behaendig_av_1 = mkA "behдndig" ;
  behag_nn_1 = mkN "behag" neutrum ;
  behagfull_av_1 = mkA "behagfull" ;
  behaglig_av_1 = mkA "behaglig" ;
  behagsjuk_av_1 = mkA "behagsjuk" ;
  behandling_nn_1 = mkN "behandling" ;
  behandlingsbar_av_1 = mkA "behandlingsbar" ;
  behandlingsenhet_nn_1 = mkN "behandlingsenhet" "behandlingsenheter" ;
  behandlingsrum_nn_1 = mkN "behandlingsrum" "behandlingsrummet" "behandlingsrum" "behandlingsrummen" ;
  behaviorist_nn_1 = mkN "behaviorist" "behaviorister" ;
  behjaelplig_av_1 = mkA "behjдlplig" ;
  behjaertansvaerd_av_1 = mkA "behjдrtansvдrd" "behjдrtansvдrt" ;
  behjaertenhet_nn_1 = mkN "behjдrtenhet" "behjдrtenheter" ;
  behoerig_av_1 = mkA "behцrig" ;
  behoerigen_ab_1 = mkAdv "behцrigen" ;
  behoerighet_nn_1 = mkN "behцrighet" "behцrigheter" ;
  behoerighetsbevis_nn_1 = mkN "behцrighetsbevis" neutrum ;
  behoevande_av_1 = mkA "behцvande" ;
  behoevlig_av_1 = mkA "behцvlig" ;
  behov_nn_1 = mkN "behov" neutrum ;
  behovloes_av_1 = mkA "behovlцs" ;
  behovloeshet_nn_1 = mkN "behovlцshet" "behovlцsheter" ;
  behovsprincip_nn_1 = mkN "behovsprincip" "behovsprinciper" ;
  behovsproevning_nn_1 = mkN "behovsprцvning" ;
  beige_av_1 = mkA "beige" ;
  beivrande_nn_1 = mkN "beivrande" ;
  bej_nn_1 = mkN "bej" "bejer" ;
  bekaempning_nn_1 = mkN "bekдmpning" ;
  bekaempningsmedel_nn_1 = mkN "bekдmpningsmedel" neutrum ;
  bekaennare_nn_1 = mkN "bekдnnare" "bekдnnare" ;
  bekaennelse_nn_1 = mkN "bekдnnelse" "bekдnnelser" ;
  bekaennelsefrihet_nn_1 = mkN "bekдnnelsefrihet" "bekдnnelsefriheter" ;
  bekaennelseroman_nn_1 = mkN "bekдnnelseroman" "bekдnnelseromaner" ;
  bekaennelseskrift_nn_1 = mkN "bekдnnelseskrift" "bekдnnelseskrifter" ;
  bekant_av_1 = mkA "bekant" "bekant" ;
  bekant_nn_1 = mkN "bekant" "bekanter" ;
  bekanting_nn_1 = mkN "bekanting" ;
  bekantskap_nn_1 = mkN "bekantskap" "bekantskaper" ;
  bekantskapskrets_nn_1 = mkN "bekantskapskrets" ;
  beklaednad_nn_1 = mkN "beklдdnad" "beklдdnader" ;
  beklaemd_av_1 = mkA "beklдmd" "beklдmt" ;
  beklaemmande_av_1 = mkA "beklдmmande" ;
  beklagande_nn_1 = mkN "beklagande" ;
  beklagansvaerd_av_1 = mkA "beklagansvдrd" "beklagansvдrt" ;
  beklaglig_av_1 = mkA "beklaglig" ;
  beklagligen_ab_1 = mkAdv "beklagligen" ;
  beklagligtvis_ab_1 = mkAdv "beklagligtvis" ;
  beknipa_vb_1 = mkV "beknipa" "beknep" "beknipit" ;
  bekostnad_nn_1 = mkN "bekostnad" "bekostnader" ;
  bekraeftelse_nn_1 = mkN "bekrдftelse" "bekrдftelser" ;
  bekroening_nn_1 = mkN "bekrцning" ;
  bekvaem_av_1 = mkA "bekvдm" ;
  bekvaemlighet_nn_1 = mkN "bekvдmlighet" "bekvдmligheter" ;
  bekvaemlighetsinraettning_nn_1 = mkN "bekvдmlighetsinrдttning" ;
  bekymmer_nn_1 = mkN "bekymmer" neutrum ;
  bekymmerfri_av_1 = mkA "bekymmerfri" "bekymmerfritt" ;
  bekymmersam_av_1 = mkA "bekymmersam" "bekymmersamt" "bekymmersamma" "bekymmersamma" "bekymmersammare" "bekymmersammast" "bekymmersammaste" ;
  bekymmersfri_av_1 = mkA "bekymmersfri" "bekymmersfritt" ;
  bekymmersloes_av_1 = mkA "bekymmerslцs" ;
  belaaning_nn_1 = mkN "belеning" ;
  belaaten_av_1 = mkA "belеten" "belеtet" ;
  belaatenhet_nn_1 = mkN "belеtenhet" "belеtenheter" ;
  belackare_nn_1 = mkN "belackare" "belackare" ;
  belaegen_av_1 = mkA "belдgen" "belдget" ;
  belaegenhet_nn_1 = mkN "belдgenhet" "belдgenheter" ;
  belaegg_nn_1 = mkN "belдgg" neutrum ;
  belaeggning_nn_1 = mkN "belдggning" ;
  belaeggningsring_nn_1 = mkN "belдggningsring" ;
  belaeggningssnoere_nn_1 = mkN "belдggningssnцre" ;
  belaeggningsstaempel_nn_1 = mkN "belдggningsstдmpel" ;
  belaegring_nn_1 = mkN "belдgring" ;
  belaegringstillstaand_nn_1 = mkN "belдgringstillstеnd" neutrum ;
  belaesenhet_nn_1 = mkN "belдsenhet" "belдsenheter" ;
  belaest_av_1 = mkA "belдst" "belдst" ;
  belaesthet_nn_1 = mkN "belдsthet" "belдstheter" ;
  belag_nn_1 = mkN "belag" neutrum ;
  belastning_nn_1 = mkN "belastning" ;
  belemnit_nn_1 = mkN "belemnit" "belemniter" ;
  belevenhet_nn_1 = mkN "belevenhet" "belevenheter" ;
  belgare_nn_1 = mkN "belgare" "belgare" ;
  belgier_nn_1 = mkN "belgier" "belgiern" "belgier" "belgierna" ;
  belgisk_av_1 = mkA "belgisk" ;
  belgiska_nn_1 = mkN "belgiska" ;
  belizier_nn_1 = mkN "belizier" "beliziern" "belizier" "belizierna" ;
  belizisk_av_1 = mkA "belizisk" ;
  beljuga_vb_1 = mkV "beljuga" "beljцg" "beljugit" ;
  belletrist_nn_1 = mkN "belletrist" "belletrister" ;
  belletristisk_av_1 = mkA "belletristisk" ;
  bellis_nn_1 = mkN "bellis" ;
  beloening_nn_1 = mkN "belцning" ;
  beloeningssystem_nn_1 = mkN "belцningssystem" neutrum ;
  belopp_nn_1 = mkN "belopp" neutrum ;
  belysande_av_1 = mkA "belysande" ;
  belysning_nn_1 = mkN "belysning" ;
  belysningsarmatur_nn_1 = mkN "belysningsarmatur" "belysningsarmaturer" ;
  belysningsstroem_nn_1 = mkN "belysningsstrцm" "belysningsstrцmmen" "belysningsstrцmmar" "belysningsstrцmmarna" ;
  belysningsstyrka_nn_1 = mkN "belysningsstyrka" ;
  bemaelde_av_1 = mkA "bemдlde" ;
  bemaerkelse_nn_1 = mkN "bemдrkelse" "bemдrkelser" ;
  bemaerkelsedag_nn_1 = mkN "bemдrkelsedag" ;
  bemaerkt_av_1 = mkA "bemдrkt" "bemдrkt" ;
  bemanning_nn_1 = mkN "bemanning" ;
  bemoedande_nn_1 = mkN "bemцdande" ;
  bemyndigande_nn_1 = mkN "bemyndigande" ;
  ben_nn_1 = mkN "ben" neutrum ;
  benaadning_nn_1 = mkN "benеdning" ;
  benaegen_av_1 = mkA "benдgen" "benдget" ;
  benaegenhet_nn_1 = mkN "benдgenhet" "benдgenheter" ;
  benaemning_nn_1 = mkN "benдmning" ;
  benbildning_nn_1 = mkN "benbildning" ;
  benbrosk_nn_1 = mkN "benbrosk" neutrum ;
  benbrott_nn_1 = mkN "benbrott" neutrum ;
  benediktin_nn_1 = mkN "benediktin" "benediktiner" ;
  benediktinerkloster_nn_1 = mkN "benediktinerkloster" neutrum ;
  benediktinermunk_nn_1 = mkN "benediktinermunk" ;
  benediktinerorden_nn_1 = mkN "benediktinerorden" ;
  beneficium_nn_1 = mkN "beneficium" "beneficiet" "beneficier" "beneficierna" ;
  benefik_av_1 = mkA "benefik" ;
  benfisk_nn_1 = mkN "benfisk" ;
  benfri_av_1 = mkA "benfri" "benfritt" ;
  bengalisk_av_1 = mkA "bengalisk" ;
  benget_nn_1 = mkN "benget" "bengetter" ;
  benhaard_av_1 = mkA "benhеrd" "benhеrt" ;
  benhinna_nn_1 = mkN "benhinna" ;
  benhinneinflammation_nn_1 = mkN "benhinneinflammation" "benhinneinflammationer" ;
  benig_av_1 = mkA "benig" ;
  benign_av_1 = mkA "benign" ;
  beninier_nn_1 = mkN "beninier" "beniniern" "beninier" "beninierna" ;
  beninsk_av_1 = mkA "beninsk" ;
  benling_nn_1 = mkN "benling" ;
  benmuskel_nn_1 = mkN "benmuskel" "benmuskeln" "benmuskler" "benmusklerna" ;
  benporslin_nn_1 = mkN "benporslin" "benporslinet" "benporsliner" "benporslinerna" ;
  benprotes_nn_1 = mkN "benprotes" "benproteser" ;
  benrangel_nn_1 = mkN "benrangel" neutrum ;
  benrest_nn_1 = mkN "benrest" "benrester" ;
  bensaar_nn_1 = mkN "bensеr" neutrum ;
  bensinautomat_nn_1 = mkN "bensinautomat" "bensinautomater" ;
  bensinbolag_nn_1 = mkN "bensinbolag" neutrum ;
  bensindriven_av_1 = mkA "bensindriven" "bensindrivet" ;
  bensindunk_nn_1 = mkN "bensindunk" ;
  bensinfoerbrukning_nn_1 = mkN "bensinfцrbrukning" ;
  bensinmack_nn_1 = mkN "bensinmack" ;
  bensinmotor_nn_1 = mkN "bensinmotor" "bensinmotorer" ;
  bensinpump_nn_1 = mkN "bensinpump" ;
  bensinskatt_nn_1 = mkN "bensinskatt" "bensinskatter" ;
  bensinsnaal_av_1 = mkA "bensinsnеl" ;
  bensinstation_nn_1 = mkN "bensinstation" "bensinstationer" ;
  bensintank_nn_1 = mkN "bensintank" ;
  bensintillsats_nn_1 = mkN "bensintillsats" "bensintillsatser" ;
  benskoer_av_1 = mkA "benskцr" ;
  benskoerhet_nn_1 = mkN "benskцrhet" "benskцrheter" ;
  benskydd_nn_1 = mkN "benskydd" neutrum ;
  benspets_nn_1 = mkN "benspets" ;
  benstamp_nn_1 = mkN "benstamp" ;
  benstomme_nn_1 = mkN "benstomme" utrum ;
  benstraale_nn_1 = mkN "benstrеle" utrum ;
  bensubstans_nn_1 = mkN "bensubstans" "bensubstanser" ;
  bensvulst_nn_1 = mkN "bensvulst" "bensvulster" ;
  bentonit_nn_1 = mkN "bentonit" "bentoniter" ;
  benutskott_nn_1 = mkN "benutskott" neutrum ;
  benvaevnad_nn_1 = mkN "benvдvnad" "benvдvnader" ;
  benvit_av_1 = mkA "benvit" ;
  bepansring_nn_1 = mkN "bepansring" ;
  beraeknande_av_1 = mkA "berдknande" ;
  beraeknelig_av_1 = mkA "berдknelig" ;
  beraekning_nn_1 = mkN "berдkning" ;
  beraekningsgrund_nn_1 = mkN "berдkningsgrund" "berдkningsgrunder" ;
  beraekningsmetod_nn_1 = mkN "berдkningsmetod" "berдkningsmetoder" ;
  beraekningssaett_nn_1 = mkN "berдkningssдtt" neutrum ;
  beraettande_av_1 = mkA "berдttande" ;
  beraettare_nn_1 = mkN "berдttare" "berдttare" ;
  beraettarjag_nn_1 = mkN "berдttarjag" neutrum ;
  beraettarkonst_nn_1 = mkN "berдttarkonst" "berдttarkonster" ;
  beraettartalang_nn_1 = mkN "berдttartalang" "berдttartalanger" ;
  beraettarteknik_nn_1 = mkN "berдttarteknik" "berдttartekniker" ;
  beraettelse_nn_1 = mkN "berдttelse" "berдttelser" ;
  berber_nn_1 = mkN "berber" "berbern" "berber" "berberna" ;
  berceuse_nn_1 = mkN "berceuse" "berceuser" ;
  beredare_nn_1 = mkN "beredare" "beredare" ;
  beredd_av_1 = mkA "beredd" ;
  beredelse_nn_1 = mkN "beredelse" "beredelser" ;
  beredning_nn_1 = mkN "beredning" ;
  beredningsnaemnd_nn_1 = mkN "beredningsnдmnd" "beredningsnдmnder" ;
  beredskap_nn_1 = mkN "beredskap" "beredskaper" ;
  beredskapslager_nn_1 = mkN "beredskapslager" neutrum ;
  beredskapslagring_nn_1 = mkN "beredskapslagring" ;
  beredskapsplan_nn_1 = mkN "beredskapsplan" neutrum ;
  beredskapsstat_nn_1 = mkN "beredskapsstat" "beredskapsstater" ;
  beredskapstjaenst_nn_1 = mkN "beredskapstjдnst" "beredskapstjдnster" ;
  beredvillig_av_1 = mkA "beredvillig" ;
  beredvillighet_nn_1 = mkN "beredvillighet" "beredvilligheter" ;
  berest_av_1 = mkA "berest" "berest" ;
  berg_nn_1 = mkN "berg" neutrum ;
  bergakung_nn_1 = mkN "bergakung" ;
  bergamott_nn_1 = mkN "bergamott" "bergamotter" ;
  bergart_nn_1 = mkN "bergart" "bergarter" ;
  bergartslager_nn_1 = mkN "bergartslager" neutrum ;
  bergbestigare_nn_1 = mkN "bergbestigare" "bergbestigare" ;
  bergbestigning_nn_1 = mkN "bergbestigning" ;
  bergborr_nn_1 = mkN "bergborr" ;
  bergborrning_nn_1 = mkN "bergborrning" ;
  bergfast_av_1 = mkA "bergfast" "bergfast" ;
  bergfin_av_1 = mkA "bergfin" ;
  bergfink_nn_1 = mkN "bergfink" ;
  berggrund_nn_1 = mkN "berggrund" "berggrunder" ;
  berghaell_nn_1 = mkN "berghдll" ;
  bergig_av_1 = mkA "bergig" ;
  bergis_av_1 = mkA "bergis" ;
  bergis_nn_1 = mkN "bergis" ;
  bergkam_nn_1 = mkN "bergkam" "bergkammen" "bergkammar" "bergkammarna" ;
  bergklack_nn_1 = mkN "bergklack" ;
  bergknalle_nn_1 = mkN "bergknalle" utrum ;
  bergkristall_nn_1 = mkN "bergkristall" "bergkristaller" ;
  bergkulle_nn_1 = mkN "bergkulle" utrum ;
  bergnymf_nn_1 = mkN "bergnymf" "bergnymfer" ;
  bergolja_nn_1 = mkN "bergolja" ;
  bergrum_nn_1 = mkN "bergrum" "bergrummet" "bergrum" "bergrummen" ;
  bergrygg_nn_1 = mkN "bergrygg" ;
  bergsaeker_av_1 = mkA "bergsдker" "bergsдkert" "bergsдkra" "bergsдkra" "bergsдkrare" "bergsдkrast" "bergsдkraste" ;
  bergsbestigare_nn_1 = mkN "bergsbestigare" "bergsbestigare" ;
  bergsbestigning_nn_1 = mkN "bergsbestigning" ;
  bergsformation_nn_1 = mkN "bergsformation" "bergsformationer" ;
  bergskedja_nn_1 = mkN "bergskedja" ;
  bergskedjebildning_nn_1 = mkN "bergskedjebildning" ;
  bergsklaettrare_nn_1 = mkN "bergsklдttrare" "bergsklдttrare" ;
  bergsklaettring_nn_1 = mkN "bergsklдttring" ;
  bergskred_nn_1 = mkN "bergskred" neutrum ;
  bergslag_nn_1 = mkN "bergslag" "bergslager" ;
  bergslager_nn_1 = mkN "bergslager" neutrum ;
  bergsman_nn_1 = mkN "bergsman" "bergsmannen" "bergsmдn" "bergsmдnnen" ;
  bergsmassiv_nn_1 = mkN "bergsmassiv" neutrum ;
  bergsomraade_nn_1 = mkN "bergsomrеde" ;
  bergsrygg_nn_1 = mkN "bergsrygg" ;
  bergssida_nn_1 = mkN "bergssida" ;
  bergstopp_nn_1 = mkN "bergstopp" ;
  bergstrakt_nn_1 = mkN "bergstrakt" "bergstrakter" ;
  bergstup_nn_1 = mkN "bergstup" neutrum ;
  bergtagen_av_1 = mkA "bergtagen" "bergtaget" ;
  bergtall_nn_1 = mkN "bergtall" ;
  bergtopp_nn_1 = mkN "bergtopp" ;
  bergtroll_nn_1 = mkN "bergtroll" neutrum ;
  berguv_nn_1 = mkN "berguv" ;
  bergvaegg_nn_1 = mkN "bergvдgg" ;
  bergvind_nn_1 = mkN "bergvind" ;
  beridare_nn_1 = mkN "beridare" "beridare" ;
  beriden_av_1 = mkA "beriden" "beridet" ;
  beriktigande_nn_1 = mkN "beriktigande" ;
  berkis_nn_1 = mkN "berkis" ;
  berlock_nn_1 = mkN "berlock" "berlocker" ;
  bermudarigg_nn_1 = mkN "bermudarigg" ;
  beroemd_av_1 = mkA "berцmd" "berцmt" ;
  beroemdhet_nn_1 = mkN "berцmdhet" "berцmdheter" ;
  beroemlig_av_1 = mkA "berцmlig" ;
  beroemvaerd_av_1 = mkA "berцmvдrd" "berцmvдrt" ;
  beroende_av_1 = mkA "beroende" ;
  beroendeframkallande_av_1 = mkA "beroendeframkallande" ;
  beroerd_av_1 = mkA "berцrd" "berцrt" ;
  beroering_nn_1 = mkN "berцring" ;
  beroeringsassociation_nn_1 = mkN "berцringsassociation" "berцringsassociationer" ;
  beroeringselektricitet_nn_1 = mkN "berцringselektricitet" "berцringselektriciteter" ;
  beroeringspunkt_nn_1 = mkN "berцringspunkt" "berцringspunkter" ;
  bersaa_nn_1 = mkN "bersе" "bersеer" ;
  bertel_nn_1 = mkN "bertel" ;
  berusande_av_1 = mkA "berusande" ;
  berusning_nn_1 = mkN "berusning" ;
  beryll_nn_1 = mkN "beryll" "beryller" ;
  besaettning_nn_1 = mkN "besдttning" ;
  besaettningsband_nn_1 = mkN "besдttningsband" neutrum ;
  besaettningsman_nn_1 = mkN "besдttningsman" "besдttningsmannen" "besдttningsmдn" "besдttningsmдnnen" ;
  besatt_av_1 = mkA "besatt" ;
  besegrare_nn_1 = mkN "besegrare" "besegrare" ;
  besiffring_nn_1 = mkN "besiffring" ;
  besiktning_nn_1 = mkN "besiktning" ;
  besiktningsinstrument_nn_1 = mkN "besiktningsinstrument" neutrum ;
  besiktningsman_nn_1 = mkN "besiktningsman" "besiktningsmannen" "besiktningsmдn" "besiktningsmдnnen" ;
  besinningsfull_av_1 = mkA "besinningsfull" ;
  besinningsloes_av_1 = mkA "besinningslцs" ;
  besitta_vb_1 = mkV "besitta" "besatt" "besuttit" ;
  besittning_nn_1 = mkN "besittning" ;
  besittningshavare_nn_1 = mkN "besittningshavare" "besittningshavare" ;
  besittningsraett_nn_1 = mkN "besittningsrдtt" "besittningsrдtter" ;
  besittningsskydd_nn_1 = mkN "besittningsskydd" neutrum ;
  besjunga_vb_1 = mkV "besjunga" "besjцng" "besjungit" ;
  besk_av_1 = mkA "besk" ;
  besk_nn_1 = mkN "besk" ;
  beskaeftig_av_1 = mkA "beskдftig" ;
  beskaellare_nn_1 = mkN "beskдllare" "beskдllare" ;
  beskaenkt_av_1 = mkA "beskдnkt" "beskдnkt" ;
  beskaera_vb_2 = mkV "beskдra" "beskar" "beskurit" ;
  beskaerd_av_1 = mkA "beskдrd" "beskдrt" ;
  beskaermelse_nn_1 = mkN "beskдrmelse" "beskдrmelser" ;
  beskaerning_nn_1 = mkN "beskдrning" ;
  beskaffenhet_nn_1 = mkN "beskaffenhet" "beskaffenheter" ;
  beskattning_nn_1 = mkN "beskattning" ;
  beskattningsaar_nn_1 = mkN "beskattningsеr" neutrum ;
  beskattningsbar_av_1 = mkA "beskattningsbar" ;
  beskattningsgrund_nn_1 = mkN "beskattningsgrund" "beskattningsgrunder" ;
  beskattningsnaemnd_nn_1 = mkN "beskattningsnдmnd" "beskattningsnдmnder" ;
  beskattningsprincip_nn_1 = mkN "beskattningsprincip" "beskattningsprinciper" ;
  besked_nn_1 = mkN "besked" neutrum ;
  beskedlig_av_1 = mkA "beskedlig" ;
  beskhet_nn_1 = mkN "beskhet" "beskheter" ;
  beskickning_nn_1 = mkN "beskickning" ;
  beskickningschef_nn_1 = mkN "beskickningschef" "beskickningschefer" ;
  beskjuta_vb_1 = mkV "beskjuta" "beskцt" "beskjutit" ;
  beskjutning_nn_1 = mkN "beskjutning" ;
  beskriva_vb_1 = mkV "beskriva" "beskrev" "beskrivit" ;
  beskrivande_av_1 = mkA "beskrivande" ;
  beskrivbar_av_1 = mkA "beskrivbar" ;
  beskrivning_nn_1 = mkN "beskrivning" ;
  beskyddare_nn_1 = mkN "beskyddare" "beskyddare" ;
  beskyllning_nn_1 = mkN "beskyllning" ;
  beslag_nn_1 = mkN "beslag" neutrum ;
  beslagare_nn_1 = mkN "beslagare" "beslagare" ;
  beslagsband_nn_1 = mkN "beslagsband" neutrum ;
  beslagssmed_nn_1 = mkN "beslagssmed" "beslagssmeder" ;
  beslagssmide_nn_1 = mkN "beslagssmide" ;
  beslagta_vb_1 = mkV "beslagta" "beslagtar" "beslagta" "beslagtog" "beslagtagit" "beslagtagen" ;
  beslut_nn_1 = mkN "beslut" neutrum ;
  besluta_vb_1 = mkV "besluta" ;
  besluten_av_1 = mkA "besluten" "beslutet" ;
  beslutenlig_av_1 = mkA "beslutenlig" ;
  beslutfattare_nn_1 = mkN "beslutfattare" "beslutfattare" ;
  beslutfoer_av_1 = mkA "beslutfцr" ;
  beslutmaessig_av_1 = mkA "beslutmдssig" ;
  beslutnivaa_nn_1 = mkN "beslutnivе" "beslutnivеer" ;
  beslutsam_av_1 = mkA "beslutsam" "beslutsamt" "beslutsamma" "beslutsamma" "beslutsammare" "beslutsammast" "beslutsammaste" ;
  beslutsamhet_nn_1 = mkN "beslutsamhet" "beslutsamheter" ;
  beslutsfattande_av_1 = mkA "beslutsfattande" ;
  beslutsfattare_nn_1 = mkN "beslutsfattare" "beslutsfattare" ;
  beslutsfoer_av_1 = mkA "beslutsfцr" ;
  beslutshierarki_nn_1 = mkN "beslutshierarki" "beslutshierarkier" ;
  beslutsmaessig_av_1 = mkA "beslutsmдssig" ;
  beslutsnivaa_nn_1 = mkN "beslutsnivе" "beslutsnivеer" ;
  besman_nn_1 = mkN "besman" neutrum ;
  besmanskrok_nn_1 = mkN "besmanskrok" ;
  besmittelse_nn_1 = mkN "besmittelse" "besmittelser" ;
  besoek_nn_1 = mkN "besцk" neutrum ;
  besoekande_nn_1 = mkN "besцkande" "besцkanden" "besцkande" "besцkandena" ;
  besoekare_nn_1 = mkN "besцkare" "besцkare" ;
  besoeksadress_nn_1 = mkN "besцksadress" "besцksadresser" ;
  besoeksbok_nn_1 = mkN "besцksbok" "besцksbцcker" ;
  besoeksdag_nn_1 = mkN "besцksdag" ;
  besoekstid_nn_1 = mkN "besцkstid" "besцkstider" ;
  besparing_nn_1 = mkN "besparing" ;
  besparingsskog_nn_1 = mkN "besparingsskog" ;
  bespisning_nn_1 = mkN "bespisning" ;
  bespottelse_nn_1 = mkN "bespottelse" "bespottelser" ;
  besprutning_nn_1 = mkN "besprutning" ;
  besprutningsmedel_nn_1 = mkN "besprutningsmedel" neutrum ;
  besprutningsvaetska_nn_1 = mkN "besprutningsvдtska" ;
  bessemerblaasning_nn_1 = mkN "bessemerblеsning" ;
  bessemerstaal_nn_1 = mkN "bessemerstеl" neutrum ;
  bessemerugn_nn_1 = mkN "bessemerugn" ;
  besserwisser_nn_1 = mkN "besserwisser" ;
  best_nn_1 = mkN "best" ;
  bestaaende_av_1 = mkA "bestеende" ;
  bestaand_nn_1 = mkN "bestеnd" neutrum ;
  bestaandande_av_1 = mkA "bestеndande" ;
  bestaandsbildande_av_1 = mkA "bestеndsbildande" ;
  bestaandsdel_nn_1 = mkN "bestеndsdel" "bestеndsdelen" "bestеndsdelar" "bestеndsdelarna" ;
  bestaellare_nn_1 = mkN "bestдllare" "bestдllare" ;
  bestaellning_nn_1 = mkN "bestдllning" ;
  bestaellningsavgift_nn_1 = mkN "bestдllningsavgift" "bestдllningsavgifter" ;
  bestaellningsverk_nn_1 = mkN "bestдllningsverk" neutrum ;
  bestaellsam_av_1 = mkA "bestдllsam" "bestдllsamt" "bestдllsamma" "bestдllsamma" "bestдllsammare" "bestдllsammast" "bestдllsammaste" ;
  bestaellt_av_1 = mkA "bestдllt" ;
  bestaembar_av_1 = mkA "bestдmbar" ;
  bestaemd_av_1 = mkA "bestдmd" "bestдmt" ;
  bestaemmelse_nn_1 = mkN "bestдmmelse" "bestдmmelser" ;
  bestaemmelseort_nn_1 = mkN "bestдmmelseort" "bestдmmelseorter" ;
  bestaemning_nn_1 = mkN "bestдmning" ;
  bestaemningsord_nn_1 = mkN "bestдmningsord" neutrum ;
  bestaendig_av_1 = mkA "bestдndig" ;
  bestaendighet_nn_1 = mkN "bestдndighet" "bestдndigheter" ;
  bestialisk_av_1 = mkA "bestialisk" ;
  bestick_nn_1 = mkN "bestick" neutrum ;
  besticka_vb_1 = mkV "besticka" "bestack" "bestuckit" ;
  bestickande_av_1 = mkA "bestickande" ;
  bestickfoering_nn_1 = mkN "bestickfцring" ;
  besticklig_av_1 = mkA "besticklig" ;
  bestickning_nn_1 = mkN "bestickning" ;
  bestiga_vb_1 = mkV "bestiga" "besteg" "bestigit" ;
  bestigning_nn_1 = mkN "bestigning" ;
  bestjaela_vb_1 = mkV "bestjдla" "bestjдl" "bestjдl" "bestal" "bestulit" "bestulen" ;
  bestoert_av_1 = mkA "bestцrt" "bestцrt" ;
  bestraalning_nn_1 = mkN "bestrеlning" ;
  bestraffning_nn_1 = mkN "bestraffning" ;
  bestrida_vb_1 = mkV "bestrida" "bestred" "bestritt" ;
  bestryka_vb_1 = mkV "bestryka" "bestrцk" "bestrukit" ;
  bestrykning_nn_1 = mkN "bestrykning" ;
  bestseller_nn_1 = mkN "bestseller" ;
  bestsellerfoerfattare_nn_1 = mkN "bestsellerfцrfattare" "bestsellerfцrfattare" ;
  bestyckning_nn_1 = mkN "bestyckning" ;
  bestyr_nn_1 = mkN "bestyr" neutrum ;
  besutten_av_1 = mkA "besutten" "besuttet" ;
  besvaer_nn_1 = mkN "besvдr" neutrum ;
  besvaerja_vb_1 = mkV "besvдrja" "besvдrjer" "besvдrj" "besvor" "besvurit" "besvдrjd" ;
  besvaerjelse_nn_1 = mkN "besvдrjelse" "besvдrjelser" ;
  besvaerjelseformel_nn_1 = mkN "besvдrjelseformel" "besvдrjelseformeln" "besvдrjelseformler" "besvдrjelseformlerna" ;
  besvaerlig_av_1 = mkA "besvдrlig" ;
  besvaerlighet_nn_1 = mkN "besvдrlighet" "besvдrligheter" ;
  besvaersgrund_nn_1 = mkN "besvдrsgrund" "besvдrsgrunder" ;
  besvaershaenvisning_nn_1 = mkN "besvдrshдnvisning" ;
  besvaershandling_nn_1 = mkN "besvдrshandling" ;
  besvaersinstans_nn_1 = mkN "besvдrsinstans" "besvдrsinstanser" ;
  besvaersmaal_nn_1 = mkN "besvдrsmеl" neutrum ;
  besvaersmyndighet_nn_1 = mkN "besvдrsmyndighet" "besvдrsmyndigheter" ;
  besvaersskrift_nn_1 = mkN "besvдrsskrift" "besvдrsskrifter" ;
  besvaerssubjekt_nn_1 = mkN "besvдrssubjekt" neutrum ;
  besvaerstid_nn_1 = mkN "besvдrstid" "besvдrstider" ;
  besvikelse_nn_1 = mkN "besvikelse" "besvikelser" ;
  besviken_av_1 = mkA "besviken" "besviket" ;
  besynnerlig_av_1 = mkA "besynnerlig" ;
  besynnerlighet_nn_1 = mkN "besynnerlighet" "besynnerligheter" ;
  bet_ab_1 = mkAdv "bet" ;
  bet_nn_1 = mkN "bet" ;
  beta_nn_2 = mkN "beta" "betat" "betan" "betana" ;
  beta_vb_2 = mkV "beta" "betar" "beta" "betog" "betagit" "betagen" ;
  betablockerare_nn_1 = mkN "betablockerare" "betablockerare" ;
  betaeckning_ab_1 = mkAdv "betдckning" ;
  betaeckning_nn_1 = mkN "betдckning" ;
  betaenkande_nn_1 = mkN "betдnkande" ;
  betaenketid_nn_1 = mkN "betдnketid" "betдnketider" ;
  betaenklig_av_1 = mkA "betдnklig" ;
  betaenklighet_nn_1 = mkN "betдnklighet" "betдnkligheter" ;
  betaenksam_av_1 = mkA "betдnksam" "betдnksamt" "betдnksamma" "betдnksamma" "betдnksammare" "betдnksammast" "betдnksammaste" ;
  betaenkt_av_1 = mkA "betдnkt" "betдnkt" ;
  betagande_av_1 = mkA "betagande" ;
  betagen_av_1 = mkA "betagen" "betaget" ;
  betalbar_av_1 = mkA "betalbar" ;
  betalkurs_nn_1 = mkN "betalkurs" "betalkurser" ;
  betalning_nn_1 = mkN "betalning" ;
  betalningsanstaand_nn_1 = mkN "betalningsanstеnd" neutrum ;
  betalningsavtal_nn_1 = mkN "betalningsavtal" "betalningsavtalet" "betalningsavtalen" "betalningsavtalena" ;
  betalningsbalans_nn_1 = mkN "betalningsbalans" "betalningsbalanser" ;
  betalningsbevis_nn_1 = mkN "betalningsbevis" neutrum ;
  betalningsfoerelaeggande_nn_1 = mkN "betalningsfцrelдggande" ;
  betalningsfri_av_1 = mkA "betalningsfri" "betalningsfritt" ;
  betalningsfrist_nn_1 = mkN "betalningsfrist" "betalningsfrister" ;
  betalningsgill_av_1 = mkA "betalningsgill" ;
  betalningsinstaellelse_nn_1 = mkN "betalningsinstдllelse" "betalningsinstдllelser" ;
  betalningsmedel_nn_1 = mkN "betalningsmedel" neutrum ;
  betalningsskyldig_av_1 = mkA "betalningsskyldig" ;
  betalningstermin_nn_1 = mkN "betalningstermin" "betalningsterminer" ;
  betalningstid_nn_1 = mkN "betalningstid" "betalningstider" ;
  betalningsvillkor_nn_1 = mkN "betalningsvillkor" neutrum ;
  betapartikel_nn_1 = mkN "betapartikel" ;
  betastraalande_av_1 = mkA "betastrеlande" ;
  betastraalning_nn_1 = mkN "betastrеlning" ;
  betatron_nn_1 = mkN "betatron" "betatroner" ;
  bete_nn_1 = mkN "bete" ;
  bete_nn_2 = mkN "bete" utrum ;
  betecknande_av_1 = mkA "betecknande" ;
  beteckning_nn_1 = mkN "beteckning" ;
  beteende_nn_1 = mkN "beteende" ;
  beteendeforskning_nn_1 = mkN "beteendeforskning" ;
  beteendemoenster_nn_1 = mkN "beteendemцnster" neutrum ;
  beteenderubbning_nn_1 = mkN "beteenderubbning" ;
  beteendevetare_nn_1 = mkN "beteendevetare" "beteendevetare" ;
  beteendevetenskap_nn_1 = mkN "beteendevetenskap" "beteendevetenskaper" ;
  betelblad_nn_1 = mkN "betelblad" neutrum ;
  betelnoet_nn_1 = mkN "betelnцt" "betelnцtter" ;
  betelpalm_nn_1 = mkN "betelpalm" "betelpalmer" ;
  beteltuggare_nn_1 = mkN "beteltuggare" "beteltuggare" ;
  betesgaang_nn_1 = mkN "betesgеng" ;
  betesland_nn_1 = mkN "betesland" neutrum ;
  betesmark_nn_1 = mkN "betesmark" "betesmarker" ;
  betesomraade_nn_1 = mkN "betesomrеde" ;
  betesplats_nn_1 = mkN "betesplats" "betesplatser" ;
  beting_nn_1 = mkN "beting" neutrum ;
  beting_nn_2 = mkN "beting" ;
  betingelse_nn_1 = mkN "betingelse" "betingelser" ;
  betingning_nn_1 = mkN "betingning" ;
  betingslaesning_nn_1 = mkN "betingslдsning" ;
  betjaening_nn_1 = mkN "betjдning" ;
  betjaeningsavgift_nn_1 = mkN "betjдningsavgift" "betjдningsavgifter" ;
  betjaent_av_1 = mkA "betjдnt" "betjдnt" ;
  betjaent_nn_1 = mkN "betjдnt" "betjдnter" ;
  betkampanj_nn_1 = mkN "betkampanj" "betkampanjer" ;
  betmedel_nn_1 = mkN "betmedel" neutrum ;
  betning_nn_1 = mkN "betning" ;
  betongbaedd_nn_1 = mkN "betongbдdd" ;
  betongblandare_nn_1 = mkN "betongblandare" "betongblandare" ;
  betongpaale_nn_1 = mkN "betongpеle" utrum ;
  betoning_nn_1 = mkN "betoning" ;
  betraengd_av_1 = mkA "betrдngd" "betrдngt" ;
  betraktare_nn_1 = mkN "betraktare" "betraktare" ;
  betraktelse_nn_1 = mkN "betraktelse" "betraktelser" ;
  betraktelsesaett_nn_1 = mkN "betraktelsesдtt" neutrum ;
  betrodd_av_1 = mkA "betrodd" "betrodtt" ;
  betryckt_av_1 = mkA "betryckt" "betryckt" ;
  betryggande_av_1 = mkA "betryggande" ;
  bets_nn_1 = mkN "bets" "betser" ;
  betsel_nn_1 = mkN "betsel" neutrum ;
  betsmedel_nn_1 = mkN "betsmedel" neutrum ;
  betsning_nn_1 = mkN "betsning" ;
  bett_nn_1 = mkN "bett" neutrum ;
  bettel_nn_1 = mkN "bettel" ;
  bettlare_nn_1 = mkN "bettlare" "bettlare" ;
  betungande_av_1 = mkA "betungande" ;
  betvinga_vb_1 = mkV "betvinga" ;
  betvingande_av_1 = mkA "betvingande" ;
  betydande_av_1 = mkA "betydande" ;
  betydelse_nn_1 = mkN "betydelse" "betydelser" ;
  betydelsebaerande_av_1 = mkA "betydelsebдrande" ;
  betydelsefattig_av_1 = mkA "betydelsefattig" ;
  betydelsefoeraendring_nn_1 = mkN "betydelsefцrдndring" ;
  betydelsefoerskjutning_nn_1 = mkN "betydelsefцrskjutning" ;
  betydelsefull_av_1 = mkA "betydelsefull" ;
  betydelselaera_nn_1 = mkN "betydelselдra" ;
  betydelseloes_av_1 = mkA "betydelselцs" ;
  betydelsenyans_nn_1 = mkN "betydelsenyans" "betydelsenyanser" ;
  betydelseutveckling_nn_1 = mkN "betydelseutveckling" ;
  betydenhet_nn_1 = mkN "betydenhet" "betydenheter" ;
  betydlig_av_1 = mkA "betydlig" ;
  betyg_nn_1 = mkN "betyg" neutrum ;
  betygelse_nn_1 = mkN "betygelse" "betygelser" ;
  betygsaettning_nn_1 = mkN "betygsдttning" ;
  betygsavskrift_nn_1 = mkN "betygsavskrift" "betygsavskrifter" ;
  betygsfri_av_1 = mkA "betygsfri" "betygsfritt" ;
  betygsgrad_nn_1 = mkN "betygsgrad" "betygsgrader" ;
  betygskatalog_nn_1 = mkN "betygskatalog" "betygskataloger" ;
  betygsnaemnd_nn_1 = mkN "betygsnдmnd" "betygsnдmnder" ;
  beundransvaerd_av_1 = mkA "beundransvдrd" "beundransvдrt" ;
  beundrare_nn_1 = mkN "beundrare" "beundrare" ;
  beundrarinna_nn_1 = mkN "beundrarinna" ;
  bevaagen_av_1 = mkA "bevеgen" "bevеget" ;
  bevaagenhet_nn_1 = mkN "bevеgenhet" "bevеgenheter" ;
  bevaepning_nn_1 = mkN "bevдpning" ;
  bevaering_nn_1 = mkN "bevдring" ;
  bevaext_av_1 = mkA "bevдxt" "bevдxt" ;
  bevakning_nn_1 = mkN "bevakning" ;
  bevakningskedja_nn_1 = mkN "bevakningskedja" ;
  bevakningsomraade_nn_1 = mkN "bevakningsomrеde" ;
  bevattning_nn_1 = mkN "bevattning" ;
  bevekande_av_1 = mkA "bevekande" ;
  bevekelse_nn_1 = mkN "bevekelse" "bevekelser" ;
  bevekelsegrund_nn_1 = mkN "bevekelsegrund" "bevekelsegrunder" ;
  bevillning_nn_1 = mkN "bevillning" ;
  bevillningsavgift_nn_1 = mkN "bevillningsavgift" "bevillningsavgifter" ;
  bevillningsutskott_nn_1 = mkN "bevillningsutskott" neutrum ;
  bevis_nn_1 = mkN "bevis" neutrum ;
  bevisbar_av_1 = mkA "bevisbar" ;
  bevisboerda_nn_1 = mkN "bevisbцrda" ;
  bevisfoering_nn_1 = mkN "bevisfцring" ;
  bevisfoervanskning_nn_1 = mkN "bevisfцrvanskning" ;
  beviskedja_nn_1 = mkN "beviskedja" ;
  beviskraft_nn_1 = mkN "beviskraft" "beviskrafter" ;
  beviskraftig_av_1 = mkA "beviskraftig" ;
  beviskrav_nn_1 = mkN "beviskrav" neutrum ;
  bevislig_av_1 = mkA "bevislig" ;
  bevisligen_ab_1 = mkAdv "bevisligen" ;
  bevismaterial_nn_1 = mkN "bevismaterial" neutrum ;
  bevismedel_nn_1 = mkN "bevismedel" neutrum ;
  bevisning_nn_1 = mkN "bevisning" ;
  bevisproevning_nn_1 = mkN "bevisprцvning" ;
  bevissaekring_nn_1 = mkN "bevissдkring" ;
  bevisskyldig_av_1 = mkA "bevisskyldig" ;
  bevisvaerde_nn_1 = mkN "bevisvдrde" ;
  bevisvaerdering_nn_1 = mkN "bevisvдrdering" ;
  bevuxen_av_1 = mkA "bevuxen" "bevuxet" ;
  bhutanes_nn_1 = mkN "bhutanes" "bhutaneser" ;
  bhutanesisk_av_1 = mkA "bhutanesisk" ;
  bi_ab_1 = mkAdv "bi" ;
  bi_nn_1 = mkN "bi" "bit" "bin" "bien" ;
  biaccent_nn_1 = mkN "biaccent" "biaccenter" ;
  biaemne_nn_1 = mkN "biдmne" ;
  biaetare_nn_1 = mkN "biдtare" "biдtare" ;
  bias_nn_1 = mkN "bias" "biaser" ;
  biavsikt_nn_1 = mkN "biavsikt" "biavsikter" ;
  bibehaalla_vb_1 = mkV "bibehеlla" "bibehцll" "bibehеllit" ;
  bibehaallen_av_1 = mkA "bibehеllen" "bibehеllet" ;
  bibel_nn_1 = mkN "bibel" ;
  bibelcitat_nn_1 = mkN "bibelcitat" neutrum ;
  bibelfoerklaring_nn_1 = mkN "bibelfцrklaring" ;
  bibelhandskrift_nn_1 = mkN "bibelhandskrift" "bibelhandskrifter" ;
  bibelkanon_nn_1 = mkN "bibelkanon" "bibelkanon" "bibelkanoner" "bibelkanonerna" ;
  bibelkommission_nn_1 = mkN "bibelkommission" "bibelkommissioner" ;
  bibelkonkordans_nn_1 = mkN "bibelkonkordans" "bibelkonkordanser" ;
  bibelkristen_av_1 = mkA "bibelkristen" "bibelkristet" ;
  bibeloeversaettning_nn_1 = mkN "bibelцversдttning" ;
  bibelord_nn_1 = mkN "bibelord" neutrum ;
  bibelsaellskap_nn_1 = mkN "bibelsдllskap" "bibelsдllskapet" "bibelsдllskapen" "bibelsдllskapena" ;
  bibelsamtal_nn_1 = mkN "bibelsamtal" "bibelsamtalet" "bibelsamtalen" "bibelsamtalena" ;
  bibelspraak_nn_1 = mkN "bibelsprеk" neutrum ;
  bibelspraengd_av_1 = mkA "bibelsprдngd" "bibelsprдngt" ;
  bibeltext_nn_1 = mkN "bibeltext" "bibeltexter" ;
  bibeltrogen_av_1 = mkA "bibeltrogen" "bibeltroget" ;
  bibelvers_nn_1 = mkN "bibelvers" ;
  bibetydelse_nn_1 = mkN "bibetydelse" "bibetydelser" ;
  biblicism_nn_1 = mkN "biblicism" "biblicismer" ;
  bibliofil_nn_1 = mkN "bibliofil" "bibliofiler" ;
  bibliofilupplaga_nn_1 = mkN "bibliofilupplaga" ;
  bibliograf_nn_1 = mkN "bibliograf" "bibliografer" ;
  bibliografi_nn_1 = mkN "bibliografi" "bibliografier" ;
  bibliografisk_av_1 = mkA "bibliografisk" ;
  biblioman_nn_1 = mkN "biblioman" "bibliomaner" ;
  bibliotek_nn_1 = mkN "bibliotek" neutrum ;
  bibliotekarie_nn_1 = mkN "bibliotekarie" "bibliotekarier" ;
  biblioteksavgift_nn_1 = mkN "biblioteksavgift" "biblioteksavgifter" ;
  biblioteksband_nn_1 = mkN "biblioteksband" neutrum ;
  biblioteksbord_nn_1 = mkN "biblioteksbord" neutrum ;
  bibliotekskatalog_nn_1 = mkN "bibliotekskatalog" "bibliotekskataloger" ;
  bibliotekslaan_nn_1 = mkN "bibliotekslеn" neutrum ;
  biblisk_av_1 = mkA "biblisk" ;
  bibroed_nn_1 = mkN "bibrцd" neutrum ;
  biceps_nn_1 = mkN "biceps" ;
  bicepsmuskel_nn_1 = mkN "bicepsmuskel" "bicepsmuskeln" "bicepsmuskler" "bicepsmusklerna" ;
  bide_nn_1 = mkN "bidй" "bidйer" ;
  bidevind_ab_1 = mkAdv "bidevind" ;
  bidevindare_nn_1 = mkN "bidevindare" "bidevindare" ;
  bidevindsegel_nn_1 = mkN "bidevindsegel" neutrum ;
  bidevindseglare_nn_1 = mkN "bidevindseglare" "bidevindseglare" ;
  bidra_vb_1 = mkV "bidra" "bidrar" "bidra" "bidrog" "bidragit" "bidragen" ;
  bidrag_nn_1 = mkN "bidrag" neutrum ;
  bidragande_av_1 = mkA "bidragande" ;
  bidragsdel_nn_1 = mkN "bidragsdel" "bidragsdelen" "bidragsdelar" "bidragsdelarna" ;
  bidragsfoerskott_nn_1 = mkN "bidragsfцrskott" neutrum ;
  bidragsgivare_nn_1 = mkN "bidragsgivare" "bidragsgivare" ;
  bidragsskyldighet_nn_1 = mkN "bidragsskyldighet" "bidragsskyldigheter" ;
  bidrottning_nn_1 = mkN "bidrottning" ;
  biedermeierstil_nn_1 = mkN "biedermeierstil" ;
  bieffekt_nn_1 = mkN "bieffekt" "bieffekter" ;
  bienn_av_1 = mkA "bienn" "bient" ;
  biennal_nn_1 = mkN "biennal" "biennaler" ;
  bifall_nn_1 = mkN "bifall" neutrum ;
  bifalla_vb_1 = mkV "bifalla" "bifцll" "bifallit" ;
  bifallsrop_nn_1 = mkN "bifallsrop" neutrum ;
  bifallsstorm_nn_1 = mkN "bifallsstorm" ;
  bifenyl_nn_1 = mkN "bifenyl" "bifenyler" ;
  biff_nn_1 = mkN "biff" ;
  biffdjur_nn_1 = mkN "biffdjur" neutrum ;
  biffen_ab_1 = mkAdv "biffen" ;
  biffko_nn_1 = mkN "biffko" "biffkor" ;
  biffrad_nn_1 = mkN "biffrad" "biffrader" ;
  biffstek_nn_1 = mkN "biffstek" ;
  bifigur_nn_1 = mkN "bifigur" "bifigurer" ;
  bifilaer_av_1 = mkA "bifilдr" ;
  biflod_nn_1 = mkN "biflod" "bifloder" ;
  bifloede_nn_1 = mkN "biflцde" ;
  bifokalglas_nn_1 = mkN "bifokalglas" neutrum ;
  bifurkation_nn_1 = mkN "bifurkation" "bifurkationer" ;
  bigaard_nn_1 = mkN "bigеrd" ;
  bigamist_nn_1 = mkN "bigamist" "bigamister" ;
  bigarraa_nn_1 = mkN "bigarrе" "bigarrеer" ;
  bigift_nn_1 = mkN "bigift" "bigiftet" "bigifter" "bigifterna" ;
  bigott_av_1 = mkA "bigott" ;
  bigotteri_nn_1 = mkN "bigotteri" "bigotterit" "bigotterier" "bigotterierna" ;
  bihaaleinflammation_nn_1 = mkN "bihеleinflammation" "bihеleinflammationer" ;
  bihandling_nn_1 = mkN "bihandling" ;
  bihang_nn_1 = mkN "bihang" neutrum ;
  bihus_nn_1 = mkN "bihus" neutrum ;
  bihustru_nn_1 = mkN "bihustru" "bihustrun" "bihustrur" "bihustrurna" ;
  biinkomst_nn_1 = mkN "biinkomst" "biinkomster" ;
  bikini_nn_1 = mkN "bikini" "bikinin" "bikini" "bikinina" ;
  bikloev_nn_1 = mkN "biklцv" ;
  bikonkav_av_1 = mkA "bikonkav" ;
  bikonvex_av_1 = mkA "bikonvex" ;
  bikt_nn_1 = mkN "bikt" "bikter" ;
  biktbarn_nn_1 = mkN "biktbarn" neutrum ;
  biktfader_nn_1 = mkN "biktfader" "biktfadern" "biktfдder" "biktfдderna" ;
  biktstol_nn_1 = mkN "biktstol" ;
  bikvadrat_nn_1 = mkN "bikvadrat" "bikvadrater" ;
  bil_nn_1 = mkN "bil" ;
  bilaakning_nn_1 = mkN "bilеkning" ;
  bilabial_av_1 = mkA "bilabial" ;
  bilaccis_nn_1 = mkN "bilaccis" "bilacciser" ;
  bilaegare_nn_1 = mkN "bilдgare" "bilдgare" ;
  bilaeger_nn_1 = mkN "bilдger" neutrum ;
  bilateral_av_1 = mkA "bilateral" ;
  bilbaelte_nn_1 = mkN "bilbдlte" ;
  bilbatteri_nn_1 = mkN "bilbatteri" "bilbatterit" "bilbatterier" "bilbatterierna" ;
  bilbesiktning_nn_1 = mkN "bilbesiktning" ;
  bilboke_nn_1 = mkN "bilbokй" "bilbokйer" ;
  bilburen_av_1 = mkA "bilburen" "bilburet" ;
  bild_nn_1 = mkN "bild" "bilder" ;
  bildaeck_nn_1 = mkN "bildдck" neutrum ;
  bildande_av_1 = mkA "bildande" ;
  bildband_nn_1 = mkN "bildband" neutrum ;
  bildbar_av_1 = mkA "bildbar" ;
  bilderbok_nn_1 = mkN "bilderbok" "bilderbцcker" ;
  bildhaallning_nn_1 = mkN "bildhеllning" ;
  bildhuggare_nn_1 = mkN "bildhuggare" "bildhuggare" ;
  bildhuggeri_nn_1 = mkN "bildhuggeri" "bildhuggerit" "bildhuggerier" "bildhuggerierna" ;
  bildkonst_nn_1 = mkN "bildkonst" "bildkonster" ;
  bildkryss_nn_1 = mkN "bildkryss" neutrum ;
  bildlig_av_1 = mkA "bildlig" ;
  bildmaessig_av_1 = mkA "bildmдssig" ;
  bildmaterial_nn_1 = mkN "bildmaterial" neutrum ;
  bildmonitor_nn_1 = mkN "bildmonitor" "bildmonitorer" ;
  bildning_nn_1 = mkN "bildning" ;
  bildningsaristokrat_nn_1 = mkN "bildningsaristokrat" "bildningsaristokrater" ;
  bildningsfel_nn_1 = mkN "bildningsfel" "bildningsfelet" "bildningsfel" "bildningsfelen" ;
  bildningsfoerbund_nn_1 = mkN "bildningsfцrbund" neutrum ;
  bildningsnivaa_nn_1 = mkN "bildningsnivе" "bildningsnivеer" ;
  bildningsorganisation_nn_1 = mkN "bildningsorganisation" "bildningsorganisationer" ;
  bildningsroman_nn_1 = mkN "bildningsroman" "bildningsromaner" ;
  bildningsverksamhet_nn_1 = mkN "bildningsverksamhet" "bildningsverksamheter" ;
  bildoeverfoering_nn_1 = mkN "bildцverfцring" ;
  bildredaktoer_nn_1 = mkN "bildredaktцr" "bildredaktцrer" ;
  bildreportage_nn_1 = mkN "bildreportage" "bildreportaget" "bildreportage" "bildreportagen" ;
  bildroer_nn_1 = mkN "bildrцr" neutrum ;
  bildrulle_1_nn_1 = mkN "bildrulle" utrum ;
  bildrulle_2_nn_1 = mkN "bildrulle" utrum ;
  bildsignal_nn_1 = mkN "bildsignal" "bildsignaler" ;
  bildskaerm_nn_1 = mkN "bildskдrm" ;
  bildskoen_av_1 = mkA "bildskцn" ;
  bildskrift_nn_1 = mkN "bildskrift" "bildskrifter" ;
  bildsnidare_nn_1 = mkN "bildsnidare" "bildsnidare" ;
  bildsnideri_nn_1 = mkN "bildsnideri" "bildsniderit" "bildsniderier" "bildsniderierna" ;
  bildspraak_nn_1 = mkN "bildsprеk" neutrum ;
  bildsten_nn_1 = mkN "bildsten" "bildstenen" "bildstenar" "bildstenarna" ;
  bildstod_nn_1 = mkN "bildstod" "bildstoder" ;
  bildstormare_nn_1 = mkN "bildstormare" "bildstormare" ;
  bildstrid_nn_1 = mkN "bildstrid" "bildstrider" ;
  bildsvit_nn_1 = mkN "bildsvit" "bildsviter" ;
  bildtelefon_nn_1 = mkN "bildtelefon" "bildtelefoner" ;
  bildtext_nn_1 = mkN "bildtext" "bildtexter" ;
  bildtolkning_nn_1 = mkN "bildtolkning" ;
  bildvaevnad_nn_1 = mkN "bildvдvnad" "bildvдvnader" ;
  bilfaerja_nn_1 = mkN "bilfдrja" ;
  bilfoerare_nn_1 = mkN "bilfцrare" "bilfцrare" ;
  bilfoersaekring_nn_1 = mkN "bilfцrsдkring" ;
  bilfri_av_1 = mkA "bilfri" "bilfritt" ;
  bilgolv_nn_1 = mkN "bilgolv" neutrum ;
  bilindustri_nn_1 = mkN "bilindustri" "bilindustrier" ;
  bilingual_av_1 = mkA "bilingual" ;
  bilist_nn_1 = mkN "bilist" "bilister" ;
  biljard_nn_1 = mkN "biljard" "biljarder" ;
  biljardboll_nn_1 = mkN "biljardboll" ;
  biljardbord_nn_1 = mkN "biljardbord" neutrum ;
  biljardkaepp_nn_1 = mkN "biljardkдpp" ;
  biljardkoe_nn_1 = mkN "biljardkц" "biljardkцn" "biljardkцer" "biljardkцerna" ;
  biljardsalong_nn_1 = mkN "biljardsalong" "biljardsalonger" ;
  biljardspel_nn_1 = mkN "biljardspel" "biljardspelet" "biljardspel" "biljardspelen" ;
  biljett_nn_1 = mkN "biljett" "biljetter" ;
  biljettaang_nn_1 = mkN "biljettеng" "biljettдnger" ;
  biljettautomat_nn_1 = mkN "biljettautomat" "biljettautomater" ;
  biljettbok_nn_1 = mkN "biljettbok" "biljettbцcker" ;
  biljettexpedition_nn_1 = mkN "biljettexpedition" "biljettexpeditioner" ;
  biljettfoersaeljare_nn_1 = mkN "biljettfцrsдljare" "biljettfцrsдljare" ;
  biljettfoersaeljning_nn_1 = mkN "biljettfцrsдljning" ;
  biljetthaefte_nn_1 = mkN "biljetthдfte" ;
  biljettinkomst_nn_1 = mkN "biljettinkomst" "biljettinkomster" ;
  biljettkontor_nn_1 = mkN "biljettkontor" neutrum ;
  biljettkontroll_nn_1 = mkN "biljettkontroll" "biljettkontroller" ;
  biljettmaskin_nn_1 = mkN "biljettmaskin" "biljettmaskiner" ;
  biljon_nn_1 = mkN "biljon" "biljoner" ;
  biljud_nn_1 = mkN "biljud" neutrum ;
  bilkaar_nn_1 = mkN "bilkеr" "bilkеrer" ;
  bilkaarist_nn_1 = mkN "bilkеrist" "bilkеrister" ;
  bilkoe_nn_1 = mkN "bilkц" "bilkцn" "bilkцer" "bilkцerna" ;
  bilkoep_nn_1 = mkN "bilkцp" neutrum ;
  bilkoerning_nn_1 = mkN "bilkцrning" ;
  bilkrock_nn_1 = mkN "bilkrock" ;
  bilkupe_nn_1 = mkN "bilkupй" "bilkupйer" ;
  bill_nn_1 = mkN "bill" ;
  bill_nn_2 = mkN "bill" ;
  billaan_nn_1 = mkN "billеn" neutrum ;
  billast_nn_1 = mkN "billast" "billaster" ;
  billig_av_1 = mkA "billig" ;
  billighet_nn_1 = mkN "billighet" "billigheter" ;
  billighetsupplaga_nn_1 = mkN "billighetsupplaga" ;
  billjus_nn_1 = mkN "billjus" neutrum ;
  billots_nn_1 = mkN "billots" ;
  bilmaerke_nn_1 = mkN "bilmдrke" ;
  bilmekaniker_nn_1 = mkN "bilmekaniker" "bilmekanikern" "bilmekaniker" "bilmekanikerna" ;
  bilmotor_nn_1 = mkN "bilmotor" "bilmotorer" ;
  bilnummer_nn_1 = mkN "bilnummer" neutrum ;
  bilnyckel_nn_1 = mkN "bilnyckel" ;
  bilpark_nn_1 = mkN "bilpark" "bilparker" ;
  bilparkering_nn_1 = mkN "bilparkering" ;
  bilplaat_nn_1 = mkN "bilplеt" ;
  bilprovning_nn_1 = mkN "bilprovning" ;
  bilrally_nn_1 = mkN "bilrally" "bilrallyt" "bilrallyn" "bilrallyna" ;
  bilratt_nn_1 = mkN "bilratt" ;
  bilregister_nn_1 = mkN "bilregister" neutrum ;
  bilring_nn_1 = mkN "bilring" ;
  bilsaete_nn_1 = mkN "bilsдte" ;
  bilsjuk_av_1 = mkA "bilsjuk" ;
  bilskatt_nn_1 = mkN "bilskatt" "bilskatter" ;
  bilstoeld_nn_1 = mkN "bilstцld" "bilstцlder" ;
  biltaevling_nn_1 = mkN "biltдvling" ;
  biltak_nn_1 = mkN "biltak" neutrum ;
  biltelefon_nn_1 = mkN "biltelefon" "biltelefoner" ;
  biltog_av_1 = mkA "biltog" ;
  biltunnel_nn_1 = mkN "biltunnel" ;
  bilvaeg_nn_1 = mkN "bilvдg" ;
  bilverkstad_nn_1 = mkN "bilverkstad" "bilverkstдder" ;
  bimaane_nn_1 = mkN "bimеne" utrum ;
  bimetall_nn_1 = mkN "bimetall" "bimetaller" ;
  binaer_av_1 = mkA "binдr" ;
  binaering_nn_1 = mkN "binдring" ;
  binamn_nn_1 = mkN "binamn" neutrum ;
  bind_nn_1 = mkN "bind" neutrum ;
  binda_vb_1 = mkV "binda" "band" "bundit" ;
  bindaemne_nn_1 = mkN "bindдmne" ;
  bindande_av_1 = mkA "bindande" ;
  bindare_nn_1 = mkN "bindare" "bindare" ;
  bindbjaelke_nn_1 = mkN "bindbjдlke" utrum ;
  bindehinna_nn_1 = mkN "bindehinna" ;
  bindehinneinflammation_nn_1 = mkN "bindehinneinflammation" "bindehinneinflammationer" ;
  bindel_nn_1 = mkN "bindel" ;
  bindemedel_nn_1 = mkN "bindemedel" neutrum ;
  bindenyckel_nn_1 = mkN "bindenyckel" ;
  bindeord_nn_1 = mkN "bindeord" neutrum ;
  binderi_nn_1 = mkN "binderi" "binderit" "binderier" "binderierna" ;
  bindesaeck_nn_1 = mkN "bindesдck" ;
  bindestreck_nn_1 = mkN "bindestreck" neutrum ;
  bindesubstans_nn_1 = mkN "bindesubstans" "bindesubstanser" ;
  bindevokal_nn_1 = mkN "bindevokal" "bindevokaler" ;
  bindgalen_av_1 = mkA "bindgalen" "bindgalet" ;
  bindgarn_nn_1 = mkN "bindgarn" neutrum ;
  bindnaal_nn_1 = mkN "bindnеl" ;
  bindning_nn_1 = mkN "bindning" ;
  bindsten_nn_1 = mkN "bindsten" "bindstenen" "bindstenar" "bindstenarna" ;
  bindvaev_nn_1 = mkN "bindvдv" ;
  bindvaevshinna_nn_1 = mkN "bindvдvshinna" ;
  bindvaevskapsel_nn_1 = mkN "bindvдvskapsel" ;
  bindvaevssaeck_nn_1 = mkN "bindvдvssдck" ;
  bindvaevstraad_nn_1 = mkN "bindvдvstrеd" ;
  binge_nn_1 = mkN "binge" utrum ;
  bingel_nn_1 = mkN "bingel" ;
  binjure_nn_1 = mkN "binjure" utrum ;
  binnikemask_nn_1 = mkN "binnikemask" ;
  binokel_nn_1 = mkN "binokel" ;
  binokulaer_av_1 = mkA "binokulдr" ;
  binom_nn_1 = mkN "binom" neutrum ;
  biobesoek_nn_1 = mkN "biobesцk" neutrum ;
  biobiljett_nn_1 = mkN "biobiljett" "biobiljetter" ;
  biobraensle_nn_1 = mkN "biobrдnsle" ;
  biocid_nn_1 = mkN "biocid" "biocider" ;
  biodlare_nn_1 = mkN "biodlare" "biodlare" ;
  biodling_nn_1 = mkN "biodling" ;
  bioduk_nn_1 = mkN "bioduk" ;
  biodynamisk_av_1 = mkA "biodynamisk" ;
  biofoerestaellning_nn_1 = mkN "biofцrestдllning" ;
  biofysisk_av_1 = mkA "biofysisk" ;
  biogen_av_1 = mkA "biogen" ;
  biogenetisk_av_1 = mkA "biogenetisk" ;
  biograf_nn_1 = mkN "biograf" "biografer" ;
  biografbyraa_nn_1 = mkN "biografbyrе" "biografbyrеer" ;
  biografi_nn_1 = mkN "biografi" "biografier" ;
  biografisk_av_1 = mkA "biografisk" ;
  biograforgel_nn_1 = mkN "biograforgel" ;
  biografteater_nn_1 = mkN "biografteater" ;
  biokemisk_av_1 = mkA "biokemisk" ;
  biokemist_nn_1 = mkN "biokemist" "biokemister" ;
  biolog_nn_1 = mkN "biolog" "biologer" ;
  biologisk_av_1 = mkA "biologisk" ;
  biomstaendighet_nn_1 = mkN "biomstдndighet" "biomstдndigheter" ;
  biosfaer_nn_1 = mkN "biosfдr" "biosfдrer" ;
  bioteknik_nn_1 = mkN "bioteknik" "biotekniker" ;
  bioteknisk_av_1 = mkA "bioteknisk" ;
  biotisk_av_1 = mkA "biotisk" ;
  biotop_nn_1 = mkN "biotop" "biotoper" ;
  biotyp_nn_1 = mkN "biotyp" "biotyper" ;
  biperson_nn_1 = mkN "biperson" "bipersoner" ;
  biplan_nn_1 = mkN "biplan" neutrum ;
  biplanet_nn_1 = mkN "biplanet" "biplaneter" ;
  bipolaer_av_1 = mkA "bipolдr" ;
  bipolaritet_nn_1 = mkN "bipolaritet" "bipolariteter" ;
  biprodukt_nn_1 = mkN "biprodukt" "biprodukter" ;
  birem_nn_1 = mkN "birem" "biremer" ;
  birfilare_nn_1 = mkN "birfilare" "birfilare" ;
  biroll_nn_1 = mkN "biroll" "biroller" ;
  birot_nn_1 = mkN "birot" "birцtter" ;
  bisaettning_nn_1 = mkN "bisдttning" ;
  bisak_nn_1 = mkN "bisak" "bisaker" ;
  bisamhaelle_nn_1 = mkN "bisamhдlle" ;
  bisamoxe_nn_1 = mkN "bisamoxe" utrum ;
  bisamsvin_nn_1 = mkN "bisamsvin" neutrum ;
  bisarr_av_1 = mkA "bisarr" ;
  bisarreri_nn_1 = mkN "bisarreri" "bisarrerit" "bisarrerier" "bisarrerierna" ;
  bisats_nn_1 = mkN "bisats" "bisatser" ;
  bisatsordfoeljd_nn_1 = mkN "bisatsordfцljd" "bisatsordfцljder" ;
  bisektris_nn_1 = mkN "bisektris" "bisektriser" ;
  bisexualitet_nn_1 = mkN "bisexualitet" "bisexualiteter" ;
  bisexuell_av_1 = mkA "bisexuell" ;
  bisittare_nn_1 = mkN "bisittare" "bisittare" ;
  biskoeldkoertel_nn_1 = mkN "biskцldkцrtel" ;
  biskop_nn_1 = mkN "biskop" ;
  biskoplig_av_1 = mkA "biskoplig" ;
  biskopsdoeme_nn_1 = mkN "biskopsdцme" ;
  biskopskors_nn_1 = mkN "biskopskors" neutrum ;
  biskopsmoete_nn_1 = mkN "biskopsmцte" ;
  biskopsskrud_nn_1 = mkN "biskopsskrud" ;
  biskopsstav_nn_1 = mkN "biskopsstav" ;
  biskopsvisitation_nn_1 = mkN "biskopsvisitation" "biskopsvisitationer" ;
  biskvi_nn_1 = mkN "biskvi" "biskvier" ;
  bismak_nn_1 = mkN "bismak" "bismaker" ;
  bisol_nn_1 = mkN "bisol" ;
  bisonoxe_nn_1 = mkN "bisonoxe" utrum ;
  bisp_nn_1 = mkN "bisp" ;
  bispringa_vb_1 = mkV "bispringa" "bisprang" "bisprungit" ;
  bistaandsland_nn_1 = mkN "bistеndsland" "bistеndslandet" "bistеndslдnder" "bistеndslдnderna" ;
  bistaandsorgan_nn_1 = mkN "bistеndsorgan" neutrum ;
  bistaandsprogram_nn_1 = mkN "bistеndsprogram" "bistеndsprogrammet" "bistеndsprogram" "bistеndsprogrammen" ;
  bister_av_1 = mkA "bister" "bistert" "bistra" "bistra" "bistrare" "bistrast" "bistraste" ;
  bistick_nn_1 = mkN "bistick" neutrum ;
  bisting_nn_1 = mkN "bisting" neutrum ;
  bistock_nn_1 = mkN "bistock" ;
  bistro_nn_1 = mkN "bistro" "bistron" "bistroer" "bistroerna" ;
  bisturi_nn_1 = mkN "bisturi" "bisturier" ;
  bistyng_nn_1 = mkN "bistyng" neutrum ;
  bisvaerm_nn_1 = mkN "bisvдrm" ;
  bisyssla_nn_1 = mkN "bisyssla" ;
  bit_nn_1 = mkN "bit" ;
  bit_nn_2 = mkN "bit" ;
  bita_vb_1 = mkV "bita" "bet" "bitit" ;
  bitande_av_1 = mkA "bitande" ;
  bitanke_nn_1 = mkN "bitanke" utrum ;
  bitecken_nn_1 = mkN "bitecken" "bitecknet" "bitecken" "bitecknen" ;
  biten_av_1 = mkA "biten" "bitet" ;
  bitestikel_nn_1 = mkN "bitestikel" ;
  biton_nn_1 = mkN "biton" "bitoner" ;
  bitraedande_av_1 = mkA "bitrдdande" ;
  bitraede_nn_1 = mkN "bitrдde" ;
  bitsk_av_1 = mkA "bitsk" ;
  bitter_av_1 = mkA "bitter" "bittert" "bittra" "bittra" "bittrare" "bittrast" "bittraste" ;
  bitterhet_nn_1 = mkN "bitterhet" "bitterheter" ;
  bitterkall_av_1 = mkA "bitterkall" ;
  bitterligen_ab_1 = mkAdv "bitterligen" ;
  bitterljuv_av_1 = mkA "bitterljuv" ;
  bittermandel_nn_1 = mkN "bittermandel" ;
  bittersalt_av_1 = mkA "bittersalt" "bittersalt" ;
  bittersoet_av_1 = mkA "bittersцt" ;
  bittersta_av_1 = mkA "bittersta" ;
  bittida_ab_1 = mkAdv "bittida" ;
  bituminoes_av_1 = mkA "bituminцs" ;
  bitvarg_nn_1 = mkN "bitvarg" ;
  bitvis_ab_1 = mkAdv "bitvis" ;
  bivack_nn_1 = mkN "bivack" "bivacker" ;
  bivaeg_nn_1 = mkN "bivдg" ;
  bivax_nn_1 = mkN "bivax" "bivaxet" "bivaxer" "bivaxerna" ;
  biverkning_nn_1 = mkN "biverkning" ;
  bivraak_nn_1 = mkN "bivrеk" ;
  biyngel_nn_1 = mkN "biyngel" neutrum ;
  bjaebbig_av_1 = mkA "bjдbbig" ;
  bjaebbighet_nn_1 = mkN "bjдbbighet" "bjдbbigheter" ;
  bjaelke_nn_1 = mkN "bjдlke" utrum ;
  bjaelkhuvud_nn_1 = mkN "bjдlkhuvud" "bjдlkhuvudet" "bjдlkhuvuden" "bjдlkhuvudena" ;
  bjaelklag_nn_1 = mkN "bjдlklag" neutrum ;
  bjaelkverk_nn_1 = mkN "bjдlkverk" neutrum ;
  bjaellko_nn_1 = mkN "bjдllko" "bjдllkor" ;
  bjaert_av_1 = mkA "bjдrt" "bjдrt" ;
  bjaesse_nn_1 = mkN "bjдsse" utrum ;
  bjoerk_nn_1 = mkN "bjцrk" ;
  bjoerkblad_nn_1 = mkN "bjцrkblad" neutrum ;
  bjoerkloev_nn_1 = mkN "bjцrklцv" neutrum ;
  bjoerknaever_nn_1 = mkN "bjцrknдver" ;
  bjoerkregion_nn_1 = mkN "bjцrkregion" "bjцrkregioner" ;
  bjoerkris_nn_1 = mkN "bjцrkris" neutrum ;
  bjoerksopp_nn_1 = mkN "bjцrksopp" ;
  bjoerktrast_nn_1 = mkN "bjцrktrast" ;
  bjoern_nn_1 = mkN "bjцrn" ;
  bjoernbaer_nn_1 = mkN "bjцrnbдr" neutrum ;
  bjoernbaersbuske_nn_1 = mkN "bjцrnbдrsbuske" utrum ;
  bjoernbindsle_nn_1 = mkN "bjцrnbindsle" ;
  bjoernhallon_nn_1 = mkN "bjцrnhallon" neutrum ;
  bjoernhund_nn_1 = mkN "bjцrnhund" ;
  bjoerninna_nn_1 = mkN "bjцrninna" ;
  bjoernjakt_nn_1 = mkN "bjцrnjakt" "bjцrnjakter" ;
  bjoernliknande_av_1 = mkA "bjцrnliknande" ;
  bjoernram_nn_1 = mkN "bjцrnram" ;
  bjoernskall_nn_1 = mkN "bjцrnskall" neutrum ;
  bjoernskinn_nn_1 = mkN "bjцrnskinn" neutrum ;
  bjoerntjaenst_nn_1 = mkN "bjцrntjдnst" "bjцrntjдnster" ;
  bjuda_vb_1 = mkV "bjuda" "bjцd" "bjudit" ;
  bjudcigarr_nn_1 = mkN "bjudcigarr" "bjudcigarrer" ;
  bjudning_nn_1 = mkN "bjudning" ;
  blaa_av_1 = mkA "blе" "blеtt" ;
  blaaaktig_av_1 = mkA "blеaktig" ;
  blaaanlupen_av_1 = mkA "blеanlupen" "blеanlupet" ;
  blaabaer_nn_1 = mkN "blеbдr" neutrum ;
  blaabaersris_nn_1 = mkN "blеbдrsris" neutrum ;
  blaablodig_av_1 = mkA "blеblodig" ;
  blaadaare_nn_1 = mkN "blеdеre" utrum ;
  blaafoerskjutning_nn_1 = mkN "blеfцrskjutning" ;
  blaafrusen_av_1 = mkA "blеfrusen" "blеfruset" ;
  blaagroen_av_1 = mkA "blеgrцn" ;
  blaagroenalg_nn_1 = mkN "blеgrцnalg" "blеgrцnalger" ;
  blaagul_av_1 = mkA "blеgul" ;
  blaahaj_nn_1 = mkN "blеhaj" ;
  blaahake_nn_1 = mkN "blеhake" utrum ;
  blaahallon_nn_1 = mkN "blеhallon" neutrum ;
  blaahjon_nn_1 = mkN "blеhjon" neutrum ;
  blaaklint_nn_1 = mkN "blеklint" ;
  blaakopia_nn_1 = mkN "blеkopia" ;
  blaalusern_nn_1 = mkN "blеlusern" "blеluserner" ;
  blaamaerke_nn_1 = mkN "blеmдrke" ;
  blaames_nn_1 = mkN "blеmes" ;
  blaamusseron_nn_1 = mkN "blеmusseron" "blеmusseroner" ;
  blaamussla_nn_1 = mkN "blеmussla" ;
  blaanad_nn_1 = mkN "blеnad" "blеnader" ;
  blaaoegd_av_1 = mkA "blецgd" "blецgt" ;
  blaaraev_nn_1 = mkN "blеrдv" ;
  blaaroed_av_1 = mkA "blеrцd" ;
  blaasare_nn_1 = mkN "blеsare" "blеsare" ;
  blaasbaelg_nn_1 = mkN "blеsbдlg" ;
  blaasfoting_nn_1 = mkN "blеsfoting" ;
  blaashaal_nn_1 = mkN "blеshеl" neutrum ;
  blaashals_nn_1 = mkN "blеshals" ;
  blaasig_av_1 = mkA "blеsig" ;
  blaasinstrument_nn_1 = mkN "blеsinstrument" neutrum ;
  blaaskatarr_nn_1 = mkN "blеskatarr" "blеskatarrer" ;
  blaasljud_nn_1 = mkN "blеsljud" neutrum ;
  blaasmask_nn_1 = mkN "blеsmask" ;
  blaasning_nn_1 = mkN "blеsning" ;
  blaasorkester_nn_1 = mkN "blеsorkester" ;
  blaasroer_nn_1 = mkN "blеsrцr" neutrum ;
  blaassten_nn_1 = mkN "blеssten" "blеsstenen" "blеsstenar" "blеsstenarna" ;
  blaastaell_nn_1 = mkN "blеstдll" neutrum ;
  blaasur_av_1 = mkA "blеsur" ;
  blaaval_nn_1 = mkN "blеval" ;
  blaavinge_nn_1 = mkN "blеvinge" utrum ;
  blaaviolett_av_1 = mkA "blеviolett" ;
  blaavit_av_1 = mkA "blеvit" ;
  blaavitling_nn_1 = mkN "blеvitling" ;
  black_av_1 = mkA "black" ;
  black_nn_1 = mkN "black" ;
  blackig_av_1 = mkA "blackig" ;
  blackout_nn_1 = mkN "blackout" "blackouter" ;
  blad_nn_1 = mkN "blad" neutrum ;
  bladbagge_nn_1 = mkN "bladbagge" utrum ;
  bladfot_nn_1 = mkN "bladfot" "bladfцtter" ;
  bladfoting_nn_1 = mkN "bladfoting" ;
  bladkrans_nn_1 = mkN "bladkrans" ;
  bladlus_nn_1 = mkN "bladlus" "bladlusen" "bladlцss" "bladlцssen" ;
  bladmage_nn_1 = mkN "bladmage" utrum ;
  bladminerare_nn_1 = mkN "bladminerare" "bladminerare" ;
  bladstaellning_nn_1 = mkN "bladstдllning" ;
  bladstekel_nn_1 = mkN "bladstekel" ;
  blaeckfisk_nn_1 = mkN "blдckfisk" ;
  blaeckhorn_nn_1 = mkN "blдckhorn" neutrum ;
  blaeckkoertel_nn_1 = mkN "blдckkцrtel" ;
  blaeckplump_nn_1 = mkN "blдckplump" ;
  blaecksaeck_nn_1 = mkN "blдcksдck" ;
  blaecksuddare_nn_1 = mkN "blдcksuddare" "blдcksuddare" ;
  blaecksvamp_nn_1 = mkN "blдcksvamp" ;
  blaedderblock_nn_1 = mkN "blдdderblock" neutrum ;
  blaedderbok_nn_1 = mkN "blдdderbok" "blдdderbцcker" ;
  blaendare_nn_1 = mkN "blдndare" "blдndare" ;
  blaende_nn_1 = mkN "blдnde" ;
  blaendfri_av_1 = mkA "blдndfri" "blдndfritt" ;
  blaendning_nn_1 = mkN "blдndning" ;
  blaendskydd_nn_1 = mkN "blдndskydd" neutrum ;
  blaendverk_nn_1 = mkN "blдndverk" neutrum ;
  blaendvit_av_1 = mkA "blдndvit" ;
  blaeng_nn_1 = mkN "blдng" ;
  blaenk_nn_1 = mkN "blдnk" ;
  blaenkare_nn_1 = mkN "blдnkare" "blдnkare" ;
  blaenkfyr_nn_1 = mkN "blдnkfyr" ;
  blaes_nn_1 = mkN "blдs" ;
  blaesand_nn_1 = mkN "blдsand" "blдsдnder" ;
  blaesbock_nn_1 = mkN "blдsbock" ;
  blaesgaas_nn_1 = mkN "blдsgеs" "blдsgеsen" "blдsgдss" "blдsgдssen" ;
  blaester_nn_1 = mkN "blдster" ;
  blaesterroer_nn_1 = mkN "blдsterrцr" neutrum ;
  blaesterugn_nn_1 = mkN "blдsterugn" ;
  blam_nn_1 = mkN "blam" "blamer" ;
  blamage_nn_1 = mkN "blamage" "blamager" ;
  blamant_av_1 = mkA "blamant" "blamant" ;
  blancmange_nn_1 = mkN "blancmangй" "blancmangйer" ;
  blandaektenskap_nn_1 = mkN "blandдktenskap" "blandдktenskapet" "blandдktenskapen" "blandдktenskapena" ;
  blandare_nn_1 = mkN "blandare" "blandare" ;
  blandekonomi_nn_1 = mkN "blandekonomi" "blandekonomier" ;
  blandfaerg_nn_1 = mkN "blandfдrg" "blandfдrger" ;
  blandform_nn_1 = mkN "blandform" "blandformer" ;
  blandning_nn_1 = mkN "blandning" ;
  blandningsfoerhaallande_nn_1 = mkN "blandningsfцrhеllande" ;
  blandningskran_nn_1 = mkN "blandningskran" ;
  blandras_nn_1 = mkN "blandras" "blandraser" ;
  blandskog_nn_1 = mkN "blandskog" ;
  blandspraak_nn_1 = mkN "blandsprеk" neutrum ;
  blandtyp_nn_1 = mkN "blandtyp" "blandtyper" ;
  blank_av_1 = mkA "blank" ;
  blankaal_nn_1 = mkN "blankеl" ;
  blankborste_nn_1 = mkN "blankborste" utrum ;
  blankett_nn_1 = mkN "blankett" "blanketter" ;
  blankettskaap_nn_1 = mkN "blankettskеp" neutrum ;
  blanklax_nn_1 = mkN "blanklax" ;
  blankoaccept_nn_1 = mkN "blankoaccept" "blankoaccepter" ;
  blankocheck_nn_1 = mkN "blankocheck" ;
  blankofoersaeljning_nn_1 = mkN "blankofцrsдljning" ;
  blankofullmakt_nn_1 = mkN "blankofullmakt" "blankofullmakter" ;
  blankokredit_nn_1 = mkN "blankokredit" "blankokrediter" ;
  blankotransport_nn_1 = mkN "blankotransport" "blankotransporter" ;
  blankovaexel_nn_1 = mkN "blankovдxel" ;
  blanksej_nn_1 = mkN "blanksej" ;
  blanksliten_av_1 = mkA "blanksliten" "blankslitet" ;
  blanksmoerja_nn_1 = mkN "blanksmцrja" ;
  blankvatten_nn_1 = mkN "blankvatten" "blankvattnet" "blankvatten" "blankvattnen" ;
  blase_av_1 = mkA "blasй" ;
  blasfemi_nn_1 = mkN "blasfemi" "blasfemier" ;
  blasfemisk_av_1 = mkA "blasfemisk" ;
  blaskig_av_1 = mkA "blaskig" ;
  blasonering_nn_1 = mkN "blasonering" ;
  blatte_nn_1 = mkN "blatte" utrum ;
  blazer_nn_1 = mkN "blazer" ;
  bleck_nn_1 = mkN "bleck" neutrum ;
  bleckblaasinstrument_nn_1 = mkN "bleckblеsinstrument" neutrum ;
  bleckburk_nn_1 = mkN "bleckburk" ;
  bleckplaat_nn_1 = mkN "bleckplеt" ;
  bleckslagare_nn_1 = mkN "bleckslagare" "bleckslagare" ;
  bleckslageri_nn_1 = mkN "bleckslageri" "bleckslagerit" "bleckslagerier" "bleckslagerierna" ;
  blek_av_1 = mkA "blek" ;
  blekeri_nn_1 = mkN "blekeri" "blekerit" "blekerier" "blekerierna" ;
  blekfet_av_1 = mkA "blekfet" ;
  blekhet_nn_1 = mkN "blekhet" "blekheter" ;
  bleking_nn_1 = mkN "bleking" ;
  blekingsk_av_1 = mkA "blekingsk" ;
  bleklagd_av_1 = mkA "bleklagd" "bleklagt" ;
  blekmedel_nn_1 = mkN "blekmedel" neutrum ;
  bleknos_nn_1 = mkN "bleknos" ;
  bleksiktig_av_1 = mkA "bleksiktig" ;
  blekvaetska_nn_1 = mkN "blekvдtska" ;
  blessyr_nn_1 = mkN "blessyr" "blessyrer" ;
  blick_nn_1 = mkN "blick" ;
  blickfaang_nn_1 = mkN "blickfеng" neutrum ;
  blickfaelt_nn_1 = mkN "blickfдlt" neutrum ;
  blickstilla_av_1 = mkA "blickstilla" ;
  blid_av_1 = mkA "blid" ;
  blidgrad_nn_1 = mkN "blidgrad" "blidgrader" ;
  blidvinter_nn_1 = mkN "blidvinter" ;
  blind_av_1 = mkA "blind" ;
  blindalfabet_nn_1 = mkN "blindalfabet" neutrum ;
  blindbock_nn_1 = mkN "blindbock" ;
  blindbotten_nn_1 = mkN "blindbotten" ;
  blindbroms_nn_1 = mkN "blindbroms" ;
  blinddoerr_nn_1 = mkN "blinddцrr" ;
  blindering_nn_1 = mkN "blindering" ;
  blindfoenster_nn_1 = mkN "blindfцnster" neutrum ;
  blindgaangare_nn_1 = mkN "blindgеngare" "blindgеngare" ;
  blindhund_nn_1 = mkN "blindhund" ;
  blindlandning_nn_1 = mkN "blindlandning" ;
  blindnaessla_nn_1 = mkN "blindnдssla" ;
  blindparti_nn_1 = mkN "blindparti" "blindpartit" "blindpartier" "blindpartierna" ;
  blindpassagerare_nn_1 = mkN "blindpassagerare" "blindpassagerare" ;
  blindpatron_nn_1 = mkN "blindpatron" "blindpatroner" ;
  blindpressning_nn_1 = mkN "blindpressning" ;
  blindraa_nn_1 = mkN "blindrе" "blindrеn" "blindrеr" "blindrеrna" ;
  blindrote_nn_1 = mkN "blindrote" utrum ;
  blindskaer_nn_1 = mkN "blindskдr" neutrum ;
  blindspaar_nn_1 = mkN "blindspеr" neutrum ;
  blindstyre_nn_1 = mkN "blindstyre" ;
  blindtarm_nn_1 = mkN "blindtarm" ;
  blindtarmsinflammation_nn_1 = mkN "blindtarmsinflammation" "blindtarmsinflammationer" ;
  blindtryck_nn_1 = mkN "blindtryck" neutrum ;
  blini_nn_1 = mkN "blini" "blinier" ;
  blink_nn_1 = mkN "blink" ;
  blinker_nn_1 = mkN "blinker" ;
  blinkfyr_nn_1 = mkN "blinkfyr" ;
  blinkhinna_nn_1 = mkN "blinkhinna" ;
  blinkljus_nn_1 = mkN "blinkljus" neutrum ;
  blinning_nn_1 = mkN "blinning" ;
  blip_nn_1 = mkN "blip" ;
  blivande_av_1 = mkA "blivande" ;
  blixt_nn_1 = mkN "blixt" ;
  blixtanfall_nn_1 = mkN "blixtanfall" neutrum ;
  blixtbesoek_nn_1 = mkN "blixtbesцk" neutrum ;
  blixtfoto_nn_1 = mkN "blixtfoto" "blixtfotot" "blixtfoton" "blixtfotona" ;
  blixtfyr_nn_1 = mkN "blixtfyr" ;
  blixtkrig_nn_1 = mkN "blixtkrig" neutrum ;
  blixtlaas_nn_1 = mkN "blixtlеs" neutrum ;
  blixtnedslag_nn_1 = mkN "blixtnedslag" neutrum ;
  blixtpatron_nn_1 = mkN "blixtpatron" "blixtpatroner" ;
  blixtrande_av_1 = mkA "blixtrande" ;
  blixtsamtal_nn_1 = mkN "blixtsamtal" "blixtsamtalet" "blixtsamtalen" "blixtsamtalena" ;
  blixtsnabb_av_1 = mkA "blixtsnabb" ;
  blixtvisit_nn_1 = mkN "blixtvisit" "blixtvisiter" ;
  block_nn_1 = mkN "block" neutrum ;
  blockad_nn_1 = mkN "blockad" "blockader" ;
  blockadbrott_nn_1 = mkN "blockadbrott" neutrum ;
  blockadbrytare_nn_1 = mkN "blockadbrytare" "blockadbrytare" ;
  blockaemne_nn_1 = mkN "blockдmne" ;
  blockbildning_nn_1 = mkN "blockbildning" ;
  blockdiagram_nn_1 = mkN "blockdiagram" "blockdiagrammet" "blockdiagram" "blockdiagrammen" ;
  blockering_nn_1 = mkN "blockering" ;
  blockfloejt_nn_1 = mkN "blockflцjt" "blockflцjter" ;
  blockgraens_nn_1 = mkN "blockgrдns" "blockgrдnser" ;
  blockhus_nn_1 = mkN "blockhus" neutrum ;
  blockig_av_1 = mkA "blockig" ;
  blocksignal_nn_1 = mkN "blocksignal" "blocksignaler" ;
  blocksystem_nn_1 = mkN "blocksystem" neutrum ;
  blocktalja_nn_1 = mkN "blocktalja" ;
  blocktyg_nn_1 = mkN "blocktyg" neutrum ;
  blockvagn_nn_1 = mkN "blockvagn" ;
  blodaader_nn_1 = mkN "blodеder" "blodеdern" "blodеdror" "blodеdrorna" ;
  blodapelsin_nn_1 = mkN "blodapelsin" "blodapelsiner" ;
  blodbad_nn_1 = mkN "blodbad" neutrum ;
  blodbank_nn_1 = mkN "blodbank" "blodbanker" ;
  blodbok_nn_1 = mkN "blodbok" ;
  blodcell_nn_1 = mkN "blodcell" "blodceller" ;
  bloddrypande_av_1 = mkA "bloddrypande" ;
  blodfaergaemne_nn_1 = mkN "blodfдrgдmne" ;
  blodfattig_av_1 = mkA "blodfattig" ;
  blodflaeck_nn_1 = mkN "blodflдck" ;
  blodfloede_nn_1 = mkN "blodflцde" ;
  blodfoergiftning_nn_1 = mkN "blodfцrgiftning" ;
  blodfull_av_1 = mkA "blodfull" ;
  blodgivare_nn_1 = mkN "blodgivare" "blodgivare" ;
  blodgrupp_nn_1 = mkN "blodgrupp" "blodgrupper" ;
  blodhund_nn_1 = mkN "blodhund" ;
  blodig_av_1 = mkA "blodig" ;
  blodigel_nn_1 = mkN "blodigel" ;
  blodkaerl_nn_1 = mkN "blodkдrl" neutrum ;
  blodkorv_nn_1 = mkN "blodkorv" ;
  blodkraekning_nn_1 = mkN "blodkrдkning" ;
  blodkropp_nn_1 = mkN "blodkropp" ;
  blodledare_nn_1 = mkN "blodledare" "blodledare" ;
  blodloes_av_1 = mkA "blodlцs" ;
  blodoern_ab_1 = mkAdv "blodцrn" ;
  blodoeverfoering_nn_1 = mkN "blodцverfцring" ;
  blodoeverfyllnad_nn_1 = mkN "blodцverfyllnad" "blodцverfyllnader" ;
  blodpalt_nn_1 = mkN "blodpalt" ;
  blodplaett_nn_1 = mkN "blodplдtt" ;
  blodpropp_nn_1 = mkN "blodpropp" ;
  blodprotein_nn_1 = mkN "blodprotein" "blodproteinet" "blodproteiner" "blodproteinerna" ;
  blodprov_nn_1 = mkN "blodprov" neutrum ;
  blodpudding_nn_1 = mkN "blodpudding" ;
  blodrand_nn_1 = mkN "blodrand" "blodrдnder" ;
  blodroed_av_1 = mkA "blodrцd" ;
  blodsband_nn_1 = mkN "blodsband" neutrum ;
  blodsdaad_nn_1 = mkN "blodsdеd" neutrum ;
  blodsdroppe_nn_1 = mkN "blodsdroppe" utrum ;
  blodsjukdom_nn_1 = mkN "blodsjukdom" ;
  blodspenning_nn_1 = mkN "blodspenning" ;
  blodspottning_nn_1 = mkN "blodspottning" ;
  blodspraengd_av_1 = mkA "blodsprдngd" "blodsprдngt" ;
  blodstaenkt_av_1 = mkA "blodstдnkt" "blodstдnkt" ;
  blodstillande_av_1 = mkA "blodstillande" ;
  blodstinn_av_1 = mkA "blodstinn" "blodstint" ;
  blodstoertning_nn_1 = mkN "blodstцrtning" ;
  blodsugande_av_1 = mkA "blodsugande" ;
  blodsugare_nn_1 = mkN "blodsugare" "blodsugare" ;
  blodsutgjutelse_nn_1 = mkN "blodsutgjutelse" "blodsutgjutelser" ;
  blodsvulst_nn_1 = mkN "blodsvulst" "blodsvulster" ;
  blodsystem_nn_1 = mkN "blodsystem" neutrum ;
  blodtappning_nn_1 = mkN "blodtappning" ;
  blodtoerstig_av_1 = mkA "blodtцrstig" ;
  blodtransfusion_nn_1 = mkN "blodtransfusion" "blodtransfusioner" ;
  blodtryck_nn_1 = mkN "blodtryck" neutrum ;
  blodtyp_nn_1 = mkN "blodtyp" "blodtyper" ;
  blodvaerde_nn_1 = mkN "blodvдrde" ;
  blodvallning_nn_1 = mkN "blodvallning" ;
  blodvite_nn_1 = mkN "blodvite" ;
  bloedare_nn_1 = mkN "blцdare" "blцdare" ;
  bloedig_av_1 = mkA "blцdig" ;
  bloedighet_nn_1 = mkN "blцdighet" "blцdigheter" ;
  bloedning_nn_1 = mkN "blцdning" ;
  bloejbyte_nn_1 = mkN "blцjbyte" ;
  bloet_av_1 = mkA "blцt" ;
  bloetdjur_nn_1 = mkN "blцtdjur" neutrum ;
  bloetlaeggningsmedel_nn_1 = mkN "blцtlдggningsmedel" neutrum ;
  blogg_nn_1 = mkN "blogg" ;
  bloggare_nn_1 = mkN "bloggare" "bloggare" ;
  blomaxel_nn_1 = mkN "blomaxel" ;
  blombefruktning_nn_1 = mkN "blombefruktning" ;
  blomblad_nn_1 = mkN "blomblad" neutrum ;
  blombord_nn_1 = mkN "blombord" neutrum ;
  blombotten_nn_1 = mkN "blombotten" ;
  blombukett_nn_1 = mkN "blombukett" "blombuketter" ;
  blomdoft_nn_1 = mkN "blomdoft" "blomdofter" ;
  blomfat_nn_1 = mkN "blomfat" neutrum ;
  blomfjaell_nn_1 = mkN "blomfjдll" neutrum ;
  blomflock_nn_1 = mkN "blomflock" ;
  blomfoder_nn_1 = mkN "blomfoder" neutrum ;
  blomhoelster_nn_1 = mkN "blomhцlster" neutrum ;
  blomholk_nn_1 = mkN "blomholk" ;
  blomhuvud_nn_1 = mkN "blomhuvud" "blomhuvudet" "blomhuvuden" "blomhuvudena" ;
  blomkaalshuvud_nn_1 = mkN "blomkеlshuvud" "blomkеlshuvudet" "blomkеlshuvuden" "blomkеlshuvudena" ;
  blomkaalsoera_nn_1 = mkN "blomkеlsцra" "blomkеlsцrat" "blomkеlsцron" "blomkеlsцronen" ;
  blomkaalssvamp_nn_1 = mkN "blomkеlssvamp" ;
  blomkaepp_nn_1 = mkN "blomkдpp" ;
  blomkalk_nn_1 = mkN "blomkalk" ;
  blomklaedd_av_1 = mkA "blomklдdd" ;
  blomklase_nn_1 = mkN "blomklase" utrum ;
  blomknopp_nn_1 = mkN "blomknopp" ;
  blomkolv_nn_1 = mkN "blomkolv" ;
  blomkorg_nn_1 = mkN "blomkorg" ;
  blomkrans_nn_1 = mkN "blomkrans" ;
  blomkvast_nn_1 = mkN "blomkvast" ;
  blommig_av_1 = mkA "blommig" ;
  blommogram_nn_1 = mkN "blommogram" "blommogrammet" "blommogram" "blommogrammen" ;
  blomning_nn_1 = mkN "blomning" ;
  blomningstid_nn_1 = mkN "blomningstid" "blomningstider" ;
  blomskaft_nn_1 = mkN "blomskaft" neutrum ;
  blomstaellning_nn_1 = mkN "blomstдllning" ;
  blomster_nn_1 = mkN "blomster" neutrum ;
  blomsteraeng_nn_1 = mkN "blomsterдng" ;
  blomsteraffaer_nn_1 = mkN "blomsteraffдr" "blomsteraffдrer" ;
  blomsterbord_nn_1 = mkN "blomsterbord" neutrum ;
  blomsterfoermedling_nn_1 = mkN "blomsterfцrmedling" ;
  blomsterhandel_nn_1 = mkN "blomsterhandel" ;
  blomsterhandlare_nn_1 = mkN "blomsterhandlare" "blomsterhandlare" ;
  blomsterklaedd_av_1 = mkA "blomsterklдdd" ;
  blomsterkvast_nn_1 = mkN "blomsterkvast" ;
  blomsterloek_nn_1 = mkN "blomsterlцk" ;
  blomstermaanad_nn_1 = mkN "blomstermеnad" "blomstermеnader" ;
  blomstertraedgaard_nn_1 = mkN "blomstertrдdgеrd" ;
  blomsteruppsats_nn_1 = mkN "blomsteruppsats" "blomsteruppsatser" ;
  blomstervas_nn_1 = mkN "blomstervas" "blomstervaser" ;
  blomstjaelk_nn_1 = mkN "blomstjдlk" ;
  blomstringstid_nn_1 = mkN "blomstringstid" "blomstringstider" ;
  blomvaext_nn_1 = mkN "blomvдxt" "blomvдxter" ;
  blomvas_nn_1 = mkN "blomvas" "blomvaser" ;
  blond_av_1 = mkA "blond" ;
  blond_nn_1 = mkN "blond" "blonder" ;
  blondin_nn_1 = mkN "blondin" "blondiner" ;
  bloss_nn_1 = mkN "bloss" neutrum ;
  blot_nn_1 = mkN "blot" neutrum ;
  blott_ab_1 = mkAdv "blott" ;
  blottare_nn_1 = mkN "blottare" "blottare" ;
  blottstaelld_av_1 = mkA "blottstдlld" "blottstдllt" ;
  bluff_nn_1 = mkN "bluff" ;
  bluffmakare_nn_1 = mkN "bluffmakare" "bluffmakare" ;
  blunder_nn_1 = mkN "blunder" ;
  blus_nn_1 = mkN "blus" ;
  blyacetat_nn_1 = mkN "blyacetat" neutrum ;
  blyackumulator_nn_1 = mkN "blyackumulator" "blyackumulatorer" ;
  blyazid_nn_1 = mkN "blyazid" "blyazider" ;
  blybatteri_nn_1 = mkN "blybatteri" "blybatterit" "blybatterier" "blybatterierna" ;
  blydagg_nn_1 = mkN "blydagg" ;
  blyerts_nn_1 = mkN "blyerts" ;
  blyfaerg_nn_1 = mkN "blyfдrg" "blyfдrger" ;
  blyfoerening_nn_1 = mkN "blyfцrening" ;
  blyfoergiftning_nn_1 = mkN "blyfцrgiftning" ;
  blyfolie_nn_1 = mkN "blyfolie" "blyfolier" ;
  blyg_av_1 = mkA "blyg" ;
  blygdben_nn_1 = mkN "blygdben" neutrum ;
  blygdlaepp_nn_1 = mkN "blygdlдpp" ;
  blyghet_nn_1 = mkN "blyghet" "blygheter" ;
  blygraa_av_1 = mkA "blygrе" "blygrеtt" ;
  blygsam_av_1 = mkA "blygsam" "blygsamt" "blygsamma" "blygsamma" "blygsammare" "blygsammast" "blygsammaste" ;
  blygsamhet_nn_1 = mkN "blygsamhet" "blygsamheter" ;
  blyhalt_nn_1 = mkN "blyhalt" "blyhalter" ;
  blyhaltig_av_1 = mkA "blyhaltig" ;
  blykoel_nn_1 = mkN "blykцl" ;
  blymantel_nn_1 = mkN "blymantel" ;
  blyoxid_nn_1 = mkN "blyoxid" "blyoxider" ;
  blytung_av_1 = mkA "blytung" ;
  bo_nn_1 = mkN "bo" "bot" "bon" "boen" ;
  boaegg_nn_1 = mkN "boдgg" neutrum ;
  boaorm_nn_1 = mkN "boaorm" ;
  boardingcard_nn_1 = mkN "boardingcard" neutrum ;
  bob_nn_1 = mkN "bob" "bobben" "bobbar" "bobbarna" ;
  bobin_nn_1 = mkN "bobin" "bobiner" ;
  bobsleigh_nn_1 = mkN "bobsleigh" ;
  bock_nn_1 = mkN "bock" ;
  bockbent_av_1 = mkA "bockbent" "bockbent" ;
  bockblad_nn_1 = mkN "bockblad" neutrum ;
  bockbro_nn_1 = mkN "bockbro" ;
  bockfot_nn_1 = mkN "bockfot" "bockfцtter" ;
  bockhorn_nn_1 = mkN "bockhorn" neutrum ;
  bockning_nn_1 = mkN "bockning" ;
  bockprov_nn_1 = mkN "bockprov" neutrum ;
  bockskaegg_nn_1 = mkN "bockskдgg" neutrum ;
  bod_nn_1 = mkN "bod" ;
  bodbetjaent_nn_1 = mkN "bodbetjдnt" "bodbetjдnter" ;
  bodelning_nn_1 = mkN "bodelning" ;
  bodknodd_nn_1 = mkN "bodknodd" ;
  bodmeri_nn_1 = mkN "bodmeri" "bodmerit" "bodmerier" "bodmerierna" ;
  boeckling_nn_1 = mkN "bцckling" ;
  boedel_nn_1 = mkN "bцdel" ;
  boedelsdraeng_nn_1 = mkN "bцdelsdrдng" ;
  boeg_nn_1 = mkN "bцg" ;
  boehmare_nn_1 = mkN "bцhmare" "bцhmare" ;
  boehmisk_av_1 = mkA "bцhmisk" ;
  boej_nn_1 = mkN "bцj" ;
  boejare_nn_1 = mkN "bцjare" "bцjare" ;
  boejarmuskel_nn_1 = mkN "bцjarmuskel" "bцjarmuskeln" "bцjarmuskler" "bцjarmusklerna" ;
  boejbar_av_1 = mkA "bцjbar" ;
  boejd_av_1 = mkA "bцjd" "bцjt" ;
  boejelse_nn_1 = mkN "bцjelse" "bцjelser" ;
  boejhaallfasthet_nn_1 = mkN "bцjhеllfasthet" "bцjhеllfastheter" ;
  boejlig_av_1 = mkA "bцjlig" ;
  boejmuskel_nn_1 = mkN "bцjmuskel" "bцjmuskeln" "bцjmuskler" "bцjmusklerna" ;
  boejning_nn_1 = mkN "bцjning" ;
  boejningsaendelse_nn_1 = mkN "bцjningsдndelse" "bцjningsдndelser" ;
  boejningsform_nn_1 = mkN "bцjningsform" "bцjningsformer" ;
  boejningsmoenster_nn_1 = mkN "bцjningsmцnster" neutrum ;
  boejprov_nn_1 = mkN "bцjprov" neutrum ;
  boekig_av_1 = mkA "bцkig" ;
  boeld_nn_1 = mkN "bцld" "bцlder" ;
  boelja_nn_1 = mkN "bцlja" ;
  boeljegaang_nn_1 = mkN "bцljegеng" ;
  boeljeslag_nn_1 = mkN "bцljeslag" neutrum ;
  boeljeslagsmaerke_nn_1 = mkN "bцljeslagsmдrke" ;
  boen_nn_1 = mkN "bцn" "bцner" ;
  boenbok_nn_1 = mkN "bцnbok" "bцnbцcker" ;
  boendag_nn_1 = mkN "bцndag" ;
  boende_nn_1 = mkN "boende" ;
  boende_nn_2 = mkN "boende" "boenden" "boende" "boendena" ;
  boendeform_nn_1 = mkN "boendeform" "boendeformer" ;
  boendekostnad_nn_1 = mkN "boendekostnad" "boendekostnader" ;
  boenegudstjaenst_nn_1 = mkN "bцnegudstjдnst" "bцnegudstjдnster" ;
  boenehus_nn_1 = mkN "bцnehus" neutrum ;
  boeneman_nn_1 = mkN "bцneman" "bцnemannen" "bцnemдn" "bцnemдnnen" ;
  boenemoete_nn_1 = mkN "bцnemцte" ;
  boeneskrift_nn_1 = mkN "bцneskrift" "bцneskrifter" ;
  boenfalla_vb_1 = mkV "bцnfalla" "bцnfцll" "bцnfallit" ;
  boenformig_av_1 = mkA "bцnformig" ;
  boenhas_nn_1 = mkN "bцnhas" ;
  boenhoerelse_nn_1 = mkN "bцnhцrelse" "bцnhцrelser" ;
  boenpall_nn_1 = mkN "bцnpall" ;
  boenvaext_nn_1 = mkN "bцnvдxt" "bцnvдxter" ;
  boer_nn_1 = mkN "boer" "boern" "boer" "boerna" ;
  boerda_nn_1 = mkN "bцrda" ;
  boerdig_av_1 = mkA "bцrdig" ;
  boerdsstolt_av_1 = mkA "bцrdsstolt" "bцrdsstolt" ;
  boers_nn_1 = mkN "bцrs" ;
  boers_nn_2 = mkN "bцrs" "bцrser" ;
  boersjobbare_nn_1 = mkN "bцrsjobbare" "bцrsjobbare" ;
  boerskurs_nn_1 = mkN "bцrskurs" "bцrskurser" ;
  boersmaeklare_nn_1 = mkN "bцrsmдklare" "bцrsmдklare" ;
  boersnotering_nn_1 = mkN "bцrsnotering" ;
  boersspekulant_nn_1 = mkN "bцrsspekulant" "bцrsspekulanter" ;
  boersspekulation_nn_1 = mkN "bцrsspekulation" "bцrsspekulationer" ;
  boerting_nn_1 = mkN "bцrting" ;
  boesshaall_nn_1 = mkN "bцsshеll" neutrum ;
  boessinsamling_nn_1 = mkN "bцssinsamling" ;
  boett_nn_1 = mkN "boett" "boetter" ;
  boevel_nn_1 = mkN "bцvel" ;
  bofaellig_av_1 = mkA "bofдllig" ;
  bofast_av_1 = mkA "bofast" "bofast" ;
  bofink_nn_1 = mkN "bofink" ;
  bog_nn_1 = mkN "bog" ;
  bogankare_nn_1 = mkN "bogankare" "bogankaret" "bogankare" "bogankarna" ;
  bogblad_nn_1 = mkN "bogblad" neutrum ;
  bogbruten_av_1 = mkA "bogbruten" "bogbrutet" ;
  boggi_nn_1 = mkN "boggi" "boggin" "boggier" "boggierna" ;
  boghalt_av_1 = mkA "boghalt" "boghalt" ;
  boghoejd_nn_1 = mkN "boghцjd" "boghцjder" ;
  bogserare_nn_1 = mkN "bogserare" "bogserare" ;
  bogserbaat_nn_1 = mkN "bogserbеt" ;
  bogsergalge_nn_1 = mkN "bogsergalge" utrum ;
  bogsering_nn_1 = mkN "bogsering" ;
  bogserslaep_nn_1 = mkN "bogserslдp" neutrum ;
  bogsertross_nn_1 = mkN "bogsertross" ;
  bogsproet_nn_1 = mkN "bogsprцt" neutrum ;
  bohag_nn_1 = mkN "bohag" neutrum ;
  bohem_nn_1 = mkN "bohem" "bohemer" ;
  bohemisk_av_1 = mkA "bohemisk" ;
  bohuslaenning_nn_1 = mkN "bohuslдnning" ;
  bohuslaensk_av_1 = mkA "bohuslдnsk" ;
  boj_nn_1 = mkN "boj" ;
  boj_nn_2 = mkN "boj" "bojer" ;
  bojar_nn_1 = mkN "bojar" "bojarer" ;
  bojkott_nn_1 = mkN "bojkott" "bojkotter" ;
  bok_nn_1 = mkN "bok" "bцcker" ;
  bok_nn_2 = mkN "bok" ;
  bokanmaelan_nn_1 = mkN "bokanmдlan" "bokanmдlan" "bokanmдlningar" "bokanmдlningarna" ;
  bokauktion_nn_1 = mkN "bokauktion" "bokauktioner" ;
  bokband_nn_1 = mkN "bokband" neutrum ;
  bokbindare_nn_1 = mkN "bokbindare" "bokbindare" ;
  bokbinderi_nn_1 = mkN "bokbinderi" "bokbinderit" "bokbinderier" "bokbinderierna" ;
  bokbindning_nn_1 = mkN "bokbindning" ;
  bokbuss_nn_1 = mkN "bokbuss" ;
  boken_av_1 = mkA "boken" "boket" ;
  bokfilm_nn_1 = mkN "bokfilm" "bokfilmer" ;
  bokflod_nn_1 = mkN "bokflod" "bokfloder" ;
  bokfoering_nn_1 = mkN "bokfцring" ;
  bokfoeringsaar_nn_1 = mkN "bokfцringsеr" neutrum ;
  bokfoeringsmaessig_av_1 = mkA "bokfцringsmдssig" ;
  bokfoeringsskyldig_av_1 = mkA "bokfцringsskyldig" ;
  bokfoeringsskyldighet_nn_1 = mkN "bokfцringsskyldighet" "bokfцringsskyldigheter" ;
  bokfoerlaeggare_nn_1 = mkN "bokfцrlдggare" "bokfцrlдggare" ;
  bokfoerlag_nn_1 = mkN "bokfцrlag" neutrum ;
  bokformat_nn_1 = mkN "bokformat" neutrum ;
  bokhaallare_nn_1 = mkN "bokhеllare" "bokhеllare" ;
  bokhandel_nn_1 = mkN "bokhandel" ;
  bokhandlare_nn_1 = mkN "bokhandlare" "bokhandlare" ;
  bokklubb_nn_1 = mkN "bokklubb" ;
  boklaan_nn_1 = mkN "boklеn" neutrum ;
  boklaerd_av_1 = mkA "boklдrd" "boklдrt" ;
  boklig_av_1 = mkA "boklig" ;
  bokmaerke_nn_1 = mkN "bokmдrke" ;
  bokmagasin_nn_1 = mkN "bokmagasin" neutrum ;
  bokmal_nn_1 = mkN "bokmal" ;
  bokmarknad_nn_1 = mkN "bokmarknad" "bokmarknader" ;
  bokollon_nn_1 = mkN "bokollon" neutrum ;
  bokomslag_nn_1 = mkN "bokomslag" neutrum ;
  bokrulle_nn_1 = mkN "bokrulle" utrum ;
  bokrygg_nn_1 = mkN "bokrygg" ;
  boksamlare_nn_1 = mkN "boksamlare" "boksamlare" ;
  boksamling_nn_1 = mkN "boksamling" ;
  boksida_nn_1 = mkN "boksida" ;
  bokskog_nn_1 = mkN "bokskog" ;
  bokslut_nn_1 = mkN "bokslut" neutrum ;
  bokstav_nn_1 = mkN "bokstav" "bokstдver" ;
  bokstavlig_av_1 = mkA "bokstavlig" ;
  bokstavligen_ab_1 = mkAdv "bokstavligen" ;
  bokstavsbeteckning_nn_1 = mkN "bokstavsbeteckning" ;
  bokstavsfoeljd_nn_1 = mkN "bokstavsfцljd" "bokstavsfцljder" ;
  bokstavsordning_nn_1 = mkN "bokstavsordning" ;
  bokstavsrim_nn_1 = mkN "bokstavsrim" "bokstavsrimmet" "bokstavsrim" "bokstavsrimmen" ;
  bokstavstecken_nn_1 = mkN "bokstavstecken" "bokstavstecknet" "bokstavstecken" "bokstavstecknen" ;
  bokstavstrael_nn_1 = mkN "bokstavstrдl" ;
  bokstavstrogen_av_1 = mkA "bokstavstrogen" "bokstavstroget" ;
  bokstipendium_nn_1 = mkN "bokstipendium" "bokstipendiet" "bokstipendier" "bokstipendierna" ;
  bokstoed_nn_1 = mkN "bokstцd" neutrum ;
  boksynt_av_1 = mkA "boksynt" "boksynt" ;
  boktitel_nn_1 = mkN "boktitel" ;
  boktorn_nn_1 = mkN "boktorn" neutrum ;
  boktryckare_nn_1 = mkN "boktryckare" "boktryckare" ;
  boktryckeri_nn_1 = mkN "boktryckeri" "boktryckerit" "boktryckerier" "boktryckerierna" ;
  boktrycksstil_nn_1 = mkN "boktrycksstil" ;
  bokverk_nn_1 = mkN "bokverk" neutrum ;
  bol_nn_1 = mkN "bol" neutrum ;
  bolag_nn_1 = mkN "bolag" neutrum ;
  bolagsman_nn_1 = mkN "bolagsman" "bolagsmannen" "bolagsmдn" "bolagsmдnnen" ;
  bolagsordning_nn_1 = mkN "bolagsordning" ;
  bolagsskog_nn_1 = mkN "bolagsskog" ;
  bolagsstaemma_nn_1 = mkN "bolagsstдmma" ;
  bolagsstyrelse_nn_1 = mkN "bolagsstyrelse" "bolagsstyrelser" ;
  bolare_nn_1 = mkN "bolare" "bolare" ;
  bolero_nn_1 = mkN "bolero" "boleror" ;
  bolin_nn_1 = mkN "bolin" "boliner" ;
  bolivian_nn_1 = mkN "bolivian" "bolivianer" ;
  boliviansk_av_1 = mkA "boliviansk" ;
  boll_nn_1 = mkN "boll" ;
  bollkalle_nn_1 = mkN "bollkalle" utrum ;
  bollning_nn_1 = mkN "bollning" ;
  bollplan_nn_1 = mkN "bollplan" "bollplaner" ;
  bollpojke_nn_1 = mkN "bollpojke" utrum ;
  bollspel_nn_1 = mkN "bollspel" "bollspelet" "bollspel" "bollspelen" ;
  bollspelare_nn_1 = mkN "bollspelare" "bollspelare" ;
  bolltrae_nn_1 = mkN "bolltrд" "bolltrдet" "bolltrдn" "bolltrдna" ;
  bolmoertsskivling_nn_1 = mkN "bolmцrtsskivling" ;
  bolsjevik_nn_1 = mkN "bolsjevik" "bolsjeviker" ;
  bolsjevistisk_av_1 = mkA "bolsjevistisk" ;
  bolster_nn_1 = mkN "bolster" ;
  bolsterstock_nn_1 = mkN "bolsterstock" ;
  bolstervagn_nn_1 = mkN "bolstervagn" ;
  bolstervar_nn_1 = mkN "bolstervar" neutrum ;
  bom_nn_1 = mkN "bom" "bommen" "bommar" "bommarna" ;
  bomaerke_nn_1 = mkN "bomдrke" ;
  bomaterial_nn_1 = mkN "bomaterial" neutrum ;
  bomb_nn_1 = mkN "bomb" "bomber" ;
  bombanfall_nn_1 = mkN "bombanfall" neutrum ;
  bombardemang_nn_1 = mkN "bombardemang" neutrum ;
  bombare_nn_1 = mkN "bombare" "bombare" ;
  bombasm_nn_1 = mkN "bombasm" "bombasmer" ;
  bombastisk_av_1 = mkA "bombastisk" ;
  bombattentat_nn_1 = mkN "bombattentat" neutrum ;
  bombering_nn_1 = mkN "bombering" ;
  bombfast_av_1 = mkA "bombfast" "bombfast" ;
  bombkrater_nn_1 = mkN "bombkrater" ;
  bombnedslag_nn_1 = mkN "bombnedslag" neutrum ;
  bombning_nn_1 = mkN "bombning" ;
  bomboffer_nn_1 = mkN "bomboffer" neutrum ;
  bombplan_nn_1 = mkN "bombplan" neutrum ;
  bombraed_nn_1 = mkN "bombrдd" "bombrдder" ;
  bombsaeker_av_1 = mkA "bombsдker" "bombsдkert" "bombsдkra" "bombsдkra" "bombsдkrare" "bombsдkrast" "bombsдkraste" ;
  bomsadel_nn_1 = mkN "bomsadel" ;
  bomsegel_nn_1 = mkN "bomsegel" neutrum ;
  bomullsbal_nn_1 = mkN "bomullsbal" ;
  bomullsband_nn_1 = mkN "bomullsband" neutrum ;
  bomullsbuske_nn_1 = mkN "bomullsbuske" utrum ;
  bomullsflanell_nn_1 = mkN "bomullsflanell" "bomullsflaneller" ;
  bomullsfroe_nn_1 = mkN "bomullsfrц" "bomullsfrцt" "bomullsfrцn" "bomullsfrцen" ;
  bomullsplantage_nn_1 = mkN "bomullsplantage" "bomullsplantager" ;
  bomullstyg_nn_1 = mkN "bomullstyg" neutrum ;
  bomullsvaevnad_nn_1 = mkN "bomullsvдvnad" "bomullsvдvnader" ;
  bomullsvaext_nn_1 = mkN "bomullsvдxt" "bomullsvдxter" ;
  bonad_nn_1 = mkN "bonad" "bonader" ;
  bonbonjaer_nn_1 = mkN "bonbonjдr" "bonbonjдrer" ;
  bonddraeng_nn_1 = mkN "bonddrдng" ;
  bonddryg_av_1 = mkA "bonddryg" ;
  bonde_nn_1 = mkN "bonde" "bцnder" ;
  bondearme_nn_1 = mkN "bondearmй" "bondearmйer" ;
  bondebefolkning_nn_1 = mkN "bondebefolkning" ;
  bondefred_nn_1 = mkN "bondefred" "bondefreder" ;
  bondehaer_nn_1 = mkN "bondehдr" ;
  bondehemman_nn_1 = mkN "bondehemman" neutrum ;
  bondekultur_nn_1 = mkN "bondekultur" "bondekulturer" ;
  bondeskog_nn_1 = mkN "bondeskog" ;
  bondetaag_nn_1 = mkN "bondetеg" neutrum ;
  bondfaangare_nn_1 = mkN "bondfеngare" "bondfеngare" ;
  bondfamilj_nn_1 = mkN "bondfamilj" "bondfamiljer" ;
  bondfoersoek_nn_1 = mkN "bondfцrsцk" neutrum ;
  bondgaard_nn_1 = mkN "bondgеrd" ;
  bondhustru_nn_1 = mkN "bondhustru" "bondhustrun" "bondhustrur" "bondhustrurna" ;
  bondkomiker_nn_1 = mkN "bondkomiker" "bondkomikern" "bondkomiker" "bondkomikerna" ;
  bondpermission_nn_1 = mkN "bondpermission" "bondpermissioner" ;
  bondsk_av_1 = mkA "bondsk" ;
  bondslug_av_1 = mkA "bondslug" ;
  bong_nn_1 = mkN "bong" ;
  boning_nn_1 = mkN "boning" ;
  boningshus_nn_1 = mkN "boningshus" neutrum ;
  bonitering_nn_1 = mkN "bonitering" ;
  bonitet_nn_1 = mkN "bonitet" "boniteter" ;
  bonjour_nn_1 = mkN "bonjour" "bonjourer" ;
  bonmot_nn_1 = mkN "bonmot" neutrum ;
  bonnett_nn_1 = mkN "bonnett" "bonnetter" ;
  bonus_nn_1 = mkN "bonus" ;
  bonusklass_nn_1 = mkN "bonusklass" "bonusklasser" ;
  bookmaker_nn_1 = mkN "bookmaker" "bookmakern" "bookmaker" "bookmakerna" ;
  boom_nn_1 = mkN "boom" "boomer" ;
  boplats_nn_1 = mkN "boplats" "boplatser" ;
  boplatsgraevning_nn_1 = mkN "boplatsgrдvning" ;
  bord_nn_1 = mkN "bord" neutrum ;
  borddans_nn_1 = mkN "borddans" "borddanser" ;
  bordduk_nn_1 = mkN "bordduk" ;
  bordeaux_nn_1 = mkN "bordeaux" "bordeauxer" ;
  bordell_nn_1 = mkN "bordell" "bordeller" ;
  bordhyvel_nn_1 = mkN "bordhyvel" ;
  bordlaeggning_nn_1 = mkN "bordlдggning" ;
  bordlaeggningsplenum_nn_1 = mkN "bordlдggningsplenum" neutrum ;
  bordloepare_nn_1 = mkN "bordlцpare" "bordlцpare" ;
  bordsamtal_nn_1 = mkN "bordsamtal" "bordsamtalet" "bordsamtalen" "bordsamtalena" ;
  bordsben_nn_1 = mkN "bordsben" neutrum ;
  bordsbestaellning_nn_1 = mkN "bordsbestдllning" ;
  bordsboen_nn_1 = mkN "bordsbцn" "bordsbцner" ;
  bordsdam_nn_1 = mkN "bordsdam" "bordsdamer" ;
  bordsdryck_nn_1 = mkN "bordsdryck" "bordsdrycker" ;
  bordservis_nn_1 = mkN "bordservis" "bordserviser" ;
  bordsfilt_nn_1 = mkN "bordsfilt" ;
  bordskant_nn_1 = mkN "bordskant" "bordskanter" ;
  bordskavaljer_nn_1 = mkN "bordskavaljer" "bordskavaljerer" ;
  bordskick_nn_1 = mkN "bordskick" neutrum ;
  bordskniv_nn_1 = mkN "bordskniv" ;
  bordsmargarin_nn_1 = mkN "bordsmargarin" "bordsmargarinet" "bordsmargariner" "bordsmargarinerna" ;
  bordssamtal_nn_1 = mkN "bordssamtal" "bordssamtalet" "bordssamtalen" "bordssamtalena" ;
  bordsservis_nn_1 = mkN "bordsservis" "bordsserviser" ;
  bordsskick_nn_1 = mkN "bordsskick" neutrum ;
  bordsstaell_nn_1 = mkN "bordsstдll" neutrum ;
  bordsstudsare_nn_1 = mkN "bordsstudsare" "bordsstudsare" ;
  bordstudsare_nn_1 = mkN "bordstudsare" "bordstudsare" ;
  bordsuppsats_nn_1 = mkN "bordsuppsats" "bordsuppsatser" ;
  bordsvatten_nn_1 = mkN "bordsvatten" "bordsvattnet" "bordsvatten" "bordsvattnen" ;
  bordtennisracket_nn_1 = mkN "bordtennisracket" ;
  bordvarts_ab_1 = mkAdv "bordvarts" ;
  boreal_av_1 = mkA "boreal" ;
  boren_av_1 = mkA "boren" "boret" ;
  borg_nn_1 = mkN "borg" ;
  borgarbevaepning_nn_1 = mkN "borgarbevдpning" ;
  borgarbrev_nn_1 = mkN "borgarbrev" neutrum ;
  borgardoeme_nn_1 = mkN "borgardцme" ;
  borgare_nn_1 = mkN "borgare" "borgare" ;
  borgargarde_nn_1 = mkN "borgargarde" ;
  borgarklass_nn_1 = mkN "borgarklass" "borgarklasser" ;
  borgarraad_nn_1 = mkN "borgarrеd" neutrum ;
  borgenaer_nn_1 = mkN "borgenдr" "borgenдrer" ;
  borgenaersed_nn_1 = mkN "borgenдrsed" "borgenдrseder" ;
  borgensaatagande_nn_1 = mkN "borgensеtagande" ;
  borgensfoerbindelse_nn_1 = mkN "borgensfцrbindelse" "borgensfцrbindelser" ;
  borgenslaan_nn_1 = mkN "borgenslеn" neutrum ;
  borgensman_nn_1 = mkN "borgensman" "borgensmannen" "borgensmдn" "borgensmдnnen" ;
  borgenssumma_nn_1 = mkN "borgenssumma" ;
  borgerlig_av_1 = mkA "borgerlig" ;
  borgerlighet_nn_1 = mkN "borgerlighet" "borgerligheter" ;
  borgerskap_nn_1 = mkN "borgerskap" "borgerskapet" "borgerskapen" "borgerskapena" ;
  borgfred_nn_1 = mkN "borgfred" "borgfreder" ;
  borggaard_nn_1 = mkN "borggеrd" ;
  borgmaestare_nn_1 = mkN "borgmдstare" "borgmдstare" ;
  borkarbid_nn_1 = mkN "borkarbid" "borkarbider" ;
  borr_nn_1 = mkN "borr" ;
  borrchuck_nn_1 = mkN "borrchuck" ;
  borrhaal_nn_1 = mkN "borrhеl" neutrum ;
  borrhaalsvaegg_nn_1 = mkN "borrhеlsvдgg" ;
  borrjigg_nn_1 = mkN "borrjigg" ;
  borrmaskin_nn_1 = mkN "borrmaskin" "borrmaskiner" ;
  borrmussla_nn_1 = mkN "borrmussla" ;
  borrning_nn_1 = mkN "borrning" ;
  borrplattform_nn_1 = mkN "borrplattform" ;
  borrspaan_nn_1 = mkN "borrspеn" neutrum ;
  borrspindel_nn_1 = mkN "borrspindel" ;
  borrstaal_nn_1 = mkN "borrstеl" neutrum ;
  borrsvaeng_nn_1 = mkN "borrsvдng" ;
  borrtorn_nn_1 = mkN "borrtorn" neutrum ;
  borst_nn_1 = mkN "borst" neutrum ;
  borstbindare_nn_1 = mkN "borstbindare" "borstbindare" ;
  borstbinderi_nn_1 = mkN "borstbinderi" "borstbinderit" "borstbinderier" "borstbinderierna" ;
  borste_nn_1 = mkN "borste" utrum ;
  borstgarnityr_nn_1 = mkN "borstgarnityr" neutrum ;
  borstgraes_nn_1 = mkN "borstgrдs" neutrum ;
  borstig_av_1 = mkA "borstig" ;
  borstmask_nn_1 = mkN "borstmask" ;
  borstsvans_nn_1 = mkN "borstsvans" ;
  borstviskare_nn_1 = mkN "borstviskare" "borstviskare" ;
  bort_ab_1 = mkAdv "bort" ;
  borta_ab_1 = mkAdv "borta" ;
  bortaat_ab_1 = mkAdv "bortеt" ;
  bortafoersaekring_nn_1 = mkN "bortafцrsдkring" ;
  bortalag_nn_1 = mkN "bortalag" neutrum ;
  bortamatch_nn_1 = mkN "bortamatch" "bortamatcher" ;
  bortanfoer_ab_1 = mkAdv "bortanfцr" ;
  bortaplan_nn_1 = mkN "bortaplan" "bortaplaner" ;
  bortaseger_nn_1 = mkN "bortaseger" ;
  bortbjuden_av_1 = mkA "bortbjuden" "bortbjudet" ;
  bortblaast_av_1 = mkA "bortblеst" "bortblеst" ;
  bortbyting_nn_1 = mkN "bortbyting" ;
  bortdoeende_av_1 = mkA "bortdцende" ;
  bortdoemning_nn_1 = mkN "bortdцmning" ;
  bortdriva_vb_1 = mkV "bortdriva" "bortdrev" "bortdrivit" ;
  bortemot_ab_1 = mkAdv "bortemot" ;
  bortfall_nn_1 = mkN "bortfall" neutrum ;
  bortfalla_vb_1 = mkV "bortfalla" "bortfцll" "bortfallit" ;
  bortfoerklaring_nn_1 = mkN "bortfцrklaring" ;
  bortgaa_vb_1 = mkV "bortgе" "bortgеr" "bortgе" "bortgick" "bortgеtt" "bortgеngen" ;
  bortgloemd_av_1 = mkA "bortglцmd" "bortglцmt" ;
  bortifraan_ab_1 = mkAdv "bortifrеn" ;
  bortigenom_ab_1 = mkAdv "bortigenom" ;
  bortkommen_av_1 = mkA "bortkommen" "bortkommet" "bortkomna" "bortkomna" "bortkomnare" "bortkomnast" "bortkomnaste" ;
  bortoever_ab_1 = mkAdv "bortцver" ;
  bortom_ab_1 = mkAdv "bortom" ;
  bortrationalisering_nn_1 = mkN "bortrationalisering" ;
  bortrest_av_1 = mkA "bortrest" "bortrest" ;
  bortrinna_vb_1 = mkV "bortrinna" "bortrann" "bortrunnit" ;
  bortsaettning_nn_1 = mkN "bortsдttning" ;
  bortskaemd_av_1 = mkA "bortskдmd" "bortskдmt" ;
  bortskrivning_nn_1 = mkN "bortskrivning" ;
  bortsluta_vb_1 = mkV "bortsluta" "bortslцt" "bortslutit" ;
  bortsprungen_av_1 = mkA "bortsprungen" "bortsprunget" ;
  bortstoetning_nn_1 = mkN "bortstцtning" ;
  bortta_vb_1 = mkV "bortta" "borttar" "bortta" "borttog" "borttagit" "borttagen" ;
  borttraengning_nn_1 = mkN "borttrдngning" ;
  bosaettning_nn_1 = mkN "bosдttning" ;
  bosaettningsaffaer_nn_1 = mkN "bosдttningsaffдr" "bosдttningsaffдrer" ;
  bosaettningslaan_nn_1 = mkN "bosдttningslеn" neutrum ;
  bosaettningsort_nn_1 = mkN "bosдttningsort" "bosдttningsorter" ;
  bosatt_av_1 = mkA "bosatt" ;
  boskapshjord_nn_1 = mkN "boskapshjord" ;
  boskapsskoetande_av_1 = mkA "boskapsskцtande" ;
  boskapsskoetare_nn_1 = mkN "boskapsskцtare" "boskapsskцtare" ;
  boskapsstaengsel_nn_1 = mkN "boskapsstдngsel" neutrum ;
  boskapsstock_nn_1 = mkN "boskapsstock" ;
  boskifte_nn_1 = mkN "boskifte" ;
  boskillnad_nn_1 = mkN "boskillnad" "boskillnader" ;
  bosnier_nn_1 = mkN "bosnier" "bosniern" "bosnier" "bosnierna" ;
  bosnisk_av_1 = mkA "bosnisk" ;
  boss_nn_1 = mkN "boss" ;
  bossig_av_1 = mkA "bossig" ;
  bostad_nn_1 = mkN "bostad" "bostдder" ;
  bostadsadress_nn_1 = mkN "bostadsadress" "bostadsadresser" ;
  bostadsband_nn_1 = mkN "bostadsband" neutrum ;
  bostadsbidrag_nn_1 = mkN "bostadsbidrag" neutrum ;
  bostadsbyggande_nn_1 = mkN "bostadsbyggande" ;
  bostadsfoerbaettringslaan_nn_1 = mkN "bostadsfцrbдttringslеn" neutrum ;
  bostadsfoeretag_nn_1 = mkN "bostadsfцretag" neutrum ;
  bostadsfoermedling_nn_1 = mkN "bostadsfцrmedling" ;
  bostadshus_nn_1 = mkN "bostadshus" neutrum ;
  bostadskoe_nn_1 = mkN "bostadskц" "bostadskцn" "bostadskцer" "bostadskцerna" ;
  bostadskooperation_nn_1 = mkN "bostadskooperation" "bostadskooperationer" ;
  bostadskredit_nn_1 = mkN "bostadskredit" "bostadskrediter" ;
  bostadslaan_nn_1 = mkN "bostadslеn" neutrum ;
  bostadslaegenhet_nn_1 = mkN "bostadslдgenhet" "bostadslдgenheter" ;
  bostadsloes_av_1 = mkA "bostadslцs" ;
  bostadsmarknad_nn_1 = mkN "bostadsmarknad" "bostadsmarknader" ;
  bostadsmiljoe_nn_1 = mkN "bostadsmiljц" "bostadsmiljцn" "bostadsmiljцer" "bostadsmiljцerna" ;
  bostadsnaemnd_nn_1 = mkN "bostadsnдmnd" "bostadsnдmnder" ;
  bostadsomraade_nn_1 = mkN "bostadsomrеde" ;
  bostadspolitisk_av_1 = mkA "bostadspolitisk" ;
  bostadsraett_nn_1 = mkN "bostadsrдtt" "bostadsrдtter" ;
  bostadsraettsfoerening_nn_1 = mkN "bostadsrдttsfцrening" ;
  bostadssoekande_nn_1 = mkN "bostadssцkande" "bostadssцkanden" "bostadssцkande" "bostadssцkandena" ;
  bostadsstyrelse_nn_1 = mkN "bostadsstyrelse" "bostadsstyrelser" ;
  bostadstillaegg_nn_1 = mkN "bostadstillдgg" neutrum ;
  bostonvals_nn_1 = mkN "bostonvals" "bostonvalser" ;
  bot_nn_2 = mkN "bot" "bцter" ;
  botaniker_nn_1 = mkN "botaniker" "botanikern" "botaniker" "botanikerna" ;
  botanikspade_nn_1 = mkN "botanikspade" utrum ;
  botanisk_av_1 = mkA "botanisk" ;
  botanist_nn_1 = mkN "botanist" "botanister" ;
  botanistspade_nn_1 = mkN "botanistspade" utrum ;
  botdag_nn_1 = mkN "botdag" ;
  botemedel_nn_1 = mkN "botemedel" neutrum ;
  botfaerdig_av_1 = mkA "botfдrdig" ;
  botgoerare_nn_1 = mkN "botgцrare" "botgцrare" ;
  botgoerelse_nn_1 = mkN "botgцrelse" "botgцrelser" ;
  botgoering_nn_1 = mkN "botgцring" ;
  botlig_av_1 = mkA "botlig" ;
  botswanier_nn_1 = mkN "botswanier" "botswaniern" "botswanier" "botswanierna" ;
  botswansk_av_1 = mkA "botswansk" ;
  botten_nn_1 = mkN "botten" ;
  bottenavlagring_nn_1 = mkN "bottenavlagring" ;
  bottenbjaelke_nn_1 = mkN "bottenbjдlke" utrum ;
  bottendaalig_av_1 = mkA "bottendеlig" ;
  bottendjur_nn_1 = mkN "bottendjur" neutrum ;
  bottenfaellning_nn_1 = mkN "bottenfдllning" ;
  bottenfaerg_nn_1 = mkN "bottenfдrg" "bottenfдrger" ;
  bottenfast_av_1 = mkA "bottenfast" "bottenfast" ;
  bottenfock_nn_1 = mkN "bottenfock" ;
  bottengarn_nn_1 = mkN "bottengarn" neutrum ;
  bottenhederlig_av_1 = mkA "bottenhederlig" ;
  bottenkaenning_nn_1 = mkN "bottenkдnning" ;
  bottenkran_nn_1 = mkN "bottenkran" ;
  bottenkurs_nn_1 = mkN "bottenkurs" "bottenkurser" ;
  bottenlaan_nn_1 = mkN "bottenlеn" neutrum ;
  bottenlaege_nn_1 = mkN "bottenlдge" ;
  bottenlag_nn_1 = mkN "bottenlag" neutrum ;
  bottenlevande_av_1 = mkA "bottenlevande" ;
  bottenloes_av_1 = mkA "bottenlцs" ;
  bottennapp_nn_1 = mkN "bottennapp" neutrum ;
  bottenplan_nn_1 = mkN "bottenplan" neutrum ;
  bottenrekord_nn_1 = mkN "bottenrekord" neutrum ;
  bottenrev_nn_1 = mkN "bottenrev" neutrum ;
  bottensats_nn_1 = mkN "bottensats" "bottensatser" ;
  bottensediment_nn_1 = mkN "bottensediment" neutrum ;
  bottenskikt_nn_1 = mkN "bottenskikt" neutrum ;
  bottenskvaett_nn_1 = mkN "bottenskvдtt" ;
  bottenstock_nn_1 = mkN "bottenstock" ;
  bottenvaaning_nn_1 = mkN "bottenvеning" ;
  bottenvatten_nn_1 = mkN "bottenvatten" "bottenvattnet" "bottenvatten" "bottenvattnen" ;
  bottenventil_nn_1 = mkN "bottenventil" "bottenventiler" ;
  bottin_nn_1 = mkN "bottin" "bottiner" ;
  bottnisk_av_1 = mkA "bottnisk" ;
  boudoir_nn_1 = mkN "boudoir" "boudoirer" ;
  boulevard_nn_1 = mkN "boulevard" "boulevarder" ;
  bouppteckning_nn_1 = mkN "bouppteckning" ;
  bouquet_nn_1 = mkN "bouquet" "bouqueter" ;
  bourgogne_nn_1 = mkN "bourgogne" "bourgogner" ;
  boutique_nn_1 = mkN "boutique" "boutiquer" ;
  boutredning_nn_1 = mkN "boutredning" ;
  bouzouki_nn_1 = mkN "bouzouki" "bouzoukin" "bouzouki" "bouzoukina" ;
  bov_nn_1 = mkN "bov" ;
  bovaktig_av_1 = mkA "bovaktig" ;
  boveteplaett_nn_1 = mkN "boveteplдtt" ;
  bovfysionomi_nn_1 = mkN "bovfysionomi" "bovfysionomier" ;
  bovstreck_nn_1 = mkN "bovstreck" neutrum ;
  bowlare_nn_1 = mkN "bowlare" "bowlare" ;
  bowlinghall_nn_1 = mkN "bowlinghall" ;
  bowlingklot_nn_1 = mkN "bowlingklot" neutrum ;
  box_nn_1 = mkN "box" ;
  boxare_nn_1 = mkN "boxare" "boxare" ;
  boxboll_nn_1 = mkN "boxboll" ;
  boxer_nn_1 = mkN "boxer" ;
  boxhandske_nn_1 = mkN "boxhandske" utrum ;
  boxning_nn_1 = mkN "boxning" ;
  boxningsmatch_nn_1 = mkN "boxningsmatch" "boxningsmatcher" ;
  boxningsring_nn_1 = mkN "boxningsring" ;
  boxningstraening_nn_1 = mkN "boxningstrдning" ;
  boyscout_nn_1 = mkN "boyscout" "boyscouter" ;
  bra_ab_1 = mkAdv "bra" ;
  bra_av_1 = mkA "bra" "bra" "bra" "bдttre" "bдst" ;
  braack_nn_1 = mkN "brеck" neutrum ;
  braackband_nn_1 = mkN "brеckband" neutrum ;
  braad_av_1 = mkA "brеd" ;
  braaddjup_av_1 = mkA "brеddjup" ;
  braadis_ab_1 = mkAdv "brеdis" ;
  braadmogen_av_1 = mkA "brеdmogen" "brеdmoget" ;
  braadskande_av_1 = mkA "brеdskande" ;
  braak_nn_1 = mkN "brеk" neutrum ;
  braakdel_nn_1 = mkN "brеkdel" "brеkdelen" "brеkdelar" "brеkdelarna" ;
  braakig_av_1 = mkA "brеkig" ;
  braakmakare_nn_1 = mkN "brеkmakare" "brеkmakare" ;
  braakstake_nn_1 = mkN "brеkstake" utrum ;
  braakstreck_nn_1 = mkN "brеkstreck" neutrum ;
  braaktal_nn_1 = mkN "brеktal" "brеktalet" "brеktalen" "brеktalena" ;
  braanad_nn_1 = mkN "brеnad" "brеnader" ;
  braattom_ab_1 = mkAdv "brеttom" ;
  brackig_av_1 = mkA "brackig" ;
  braeckhammare_nn_1 = mkN "brдckhammare" "brдckhammaren" "brдckhamrar" "brдckhamrarna" ;
  braeckjaern_nn_1 = mkN "brдckjдrn" neutrum ;
  braeckkorv_nn_1 = mkN "brдckkorv" ;
  braecklig_av_1 = mkA "brдcklig" ;
  braeckt_av_1 = mkA "brдckt" "brдckt" ;
  braeckvatten_nn_1 = mkN "brдckvatten" "brдckvattnet" "brдckvatten" "brдckvattnen" ;
  braeda_nn_1 = mkN "brдda" ;
  braedd_nn_1 = mkN "brдdd" ;
  braeddavlopp_nn_1 = mkN "brдddavlopp" neutrum ;
  braeddfull_av_1 = mkA "brдddfull" ;
  braeddfylld_av_1 = mkA "brдddfylld" "brдddfyllt" ;
  braedgaang_nn_1 = mkN "brдdgеng" ;
  braedgaard_nn_1 = mkN "brдdgеrd" ;
  braedspel_nn_1 = mkN "brдdspel" "brдdspelet" "brдdspel" "brдdspelen" ;
  braekande_nn_1 = mkN "brдkande" ;
  braeken_nn_1 = mkN "brдken" ;
  braem_nn_1 = mkN "brдm" neutrum ;
  braennaessla_nn_1 = mkN "brдnnдssla" ;
  braennande_av_1 = mkA "brдnnande" ;
  braennare_nn_1 = mkN "brдnnare" "brдnnare" ;
  braennbar_av_1 = mkA "brдnnbar" ;
  braenneri_nn_1 = mkN "brдnneri" "brдnnerit" "brдnnerier" "brдnnerierna" ;
  braennglas_nn_1 = mkN "brдnnglas" neutrum ;
  braennhaar_nn_1 = mkN "brдnnhеr" neutrum ;
  braennhet_av_1 = mkA "brдnnhet" ;
  braenning_nn_1 = mkN "brдnning" ;
  braennjaern_nn_1 = mkN "brдnnjдrn" neutrum ;
  braennkammare_nn_1 = mkN "brдnnkammare" "brдnnkammare" ;
  braennmaerke_nn_1 = mkN "brдnnmдrke" ;
  braennmanet_nn_1 = mkN "brдnnmanet" "brдnnmaneter" ;
  braennoffer_nn_1 = mkN "brдnnoffer" neutrum ;
  braennpunkt_nn_1 = mkN "brдnnpunkt" "brдnnpunkter" ;
  braennsaar_nn_1 = mkN "brдnnsеr" neutrum ;
  braennvidd_nn_1 = mkN "brдnnvidd" "brдnnvidder" ;
  braennvin_nn_1 = mkN "brдnnvin" "brдnnvinet" "brдnnviner" "brдnnvinerna" ;
  braennvinsadvokat_nn_1 = mkN "brдnnvinsadvokat" "brдnnvinsadvokater" ;
  braennvinsbas_nn_1 = mkN "brдnnvinsbas" ;
  braennvinsbraenneri_nn_1 = mkN "brдnnvinsbrдnneri" "brдnnvinsbrдnnerit" "brдnnvinsbrдnnerier" "brдnnvinsbrдnnerierna" ;
  braennvinsglas_nn_1 = mkN "brдnnvinsglas" neutrum ;
  braennvinsprovare_nn_1 = mkN "brдnnvinsprovare" "brдnnvinsprovare" ;
  braenslecell_nn_1 = mkN "brдnslecell" "brдnsleceller" ;
  braenslecellsdriven_av_1 = mkA "brдnslecellsdriven" "brдnslecellsdrivet" ;
  braenslecellskonstruktion_nn_1 = mkN "brдnslecellskonstruktion" "brдnslecellskonstruktioner" ;
  braenslecellskraftverk_nn_1 = mkN "brдnslecellskraftverk" neutrum ;
  braenslecellstyp_nn_1 = mkN "brдnslecellstyp" "brдnslecellstyper" ;
  braensleelement_nn_1 = mkN "brдnsleelement" neutrum ;
  braenslefaelt_nn_1 = mkN "brдnslefдlt" neutrum ;
  braenslefoerraad_nn_1 = mkN "brдnslefцrrеd" neutrum ;
  braenslegas_nn_1 = mkN "brдnslegas" "brдnslegaser" ;
  braenslekanal_nn_1 = mkN "brдnslekanal" "brдnslekanaler" ;
  braenslemaetare_nn_1 = mkN "brдnslemдtare" "brдnslemдtare" ;
  braensleomvandlare_nn_1 = mkN "brдnsleomvandlare" "brдnsleomvandlaren" "brдnsleomvandrar" "brдnsleomvandrarna" ;
  braenslesnaal_av_1 = mkA "brдnslesnеl" ;
  braenslestav_nn_1 = mkN "brдnslestav" ;
  braensletank_nn_1 = mkN "brдnsletank" ;
  braensletillaegg_nn_1 = mkN "brдnsletillдgg" neutrum ;
  braesch_nn_1 = mkN "brдsch" "brдscher" ;
  bragd_nn_1 = mkN "bragd" "bragder" ;
  brageloefte_nn_1 = mkN "bragelцfte" ;
  brakfest_nn_1 = mkN "brakfest" "brakfester" ;
  brakmiddag_nn_1 = mkN "brakmiddag" ;
  brakskit_nn_1 = mkN "brakskit" ;
  braksucce_nn_1 = mkN "braksuccй" "braksuccйer" ;
  brakteat_nn_1 = mkN "brakteat" "brakteater" ;
  brakycefal_av_1 = mkA "brakycefal" ;
  brallis_nn_1 = mkN "brallis" ;
  braman_nn_1 = mkN "braman" "bramaner" ;
  bramansk_av_1 = mkA "bramansk" ;
  bramin_nn_1 = mkN "bramin" "braminer" ;
  bramsegel_nn_1 = mkN "bramsegel" neutrum ;
  bramstaang_nn_1 = mkN "bramstеng" "bramstдnger" ;
  brand_nn_1 = mkN "brand" "brдnder" ;
  brandalarm_nn_1 = mkN "brandalarm" neutrum ;
  brandartikel_nn_1 = mkN "brandartikel" ;
  brandbefael_nn_1 = mkN "brandbefдl" neutrum ;
  brandbil_nn_1 = mkN "brandbil" ;
  brandbomb_nn_1 = mkN "brandbomb" "brandbomber" ;
  brandbotten_nn_1 = mkN "brandbotten" ;
  brandchef_nn_1 = mkN "brandchef" "brandchefer" ;
  branddike_nn_1 = mkN "branddike" ;
  branddoerr_nn_1 = mkN "branddцrr" ;
  brandfackla_nn_1 = mkN "brandfackla" ;
  brandfarlig_av_1 = mkA "brandfarlig" ;
  brandfoersaekringsbolag_nn_1 = mkN "brandfцrsдkringsbolag" neutrum ;
  brandgavel_nn_1 = mkN "brandgavel" ;
  brandgrav_nn_1 = mkN "brandgrav" ;
  brandgul_av_1 = mkA "brandgul" ;
  brandhaerd_nn_1 = mkN "brandhдrd" ;
  brandhaerdig_av_1 = mkA "brandhдrdig" ;
  brandingenjoer_nn_1 = mkN "brandingenjцr" "brandingenjцrer" ;
  brandinspektion_nn_1 = mkN "brandinspektion" "brandinspektioner" ;
  brandinspektoer_nn_1 = mkN "brandinspektцr" "brandinspektцrer" ;
  brandkaar_nn_1 = mkN "brandkеr" "brandkеrer" ;
  brandkaarsutryckning_nn_1 = mkN "brandkеrsutryckning" ;
  brandkapten_nn_1 = mkN "brandkapten" "brandkaptener" ;
  brandlager_nn_1 = mkN "brandlager" neutrum ;
  brandlarm_nn_1 = mkN "brandlarm" neutrum ;
  brandman_nn_1 = mkN "brandman" "brandmannen" "brandmдn" "brandmдnnen" ;
  brandmur_nn_1 = mkN "brandmur" ;
  brandorsak_nn_1 = mkN "brandorsak" "brandorsaker" ;
  brandpost_nn_1 = mkN "brandpost" "brandposter" ;
  brandredskap_nn_1 = mkN "brandredskap" "brandredskapet" "brandredskapen" "brandredskapena" ;
  brandrest_nn_1 = mkN "brandrest" "brandrester" ;
  brandroer_nn_1 = mkN "brandrцr" neutrum ;
  brandsaeker_av_1 = mkA "brandsдker" "brandsдkert" "brandsдkra" "brandsдkra" "brandsдkrare" "brandsдkrast" "brandsдkraste" ;
  brandsegel_nn_1 = mkN "brandsegel" neutrum ;
  brandskaap_nn_1 = mkN "brandskеp" neutrum ;
  brandslaeckare_nn_1 = mkN "brandslдckare" "brandslдckare" ;
  brandslang_nn_1 = mkN "brandslang" ;
  brandsoldat_nn_1 = mkN "brandsoldat" "brandsoldater" ;
  brandstation_nn_1 = mkN "brandstation" "brandstationer" ;
  brandstege_nn_1 = mkN "brandstege" utrum ;
  brandstodsbolag_nn_1 = mkN "brandstodsbolag" neutrum ;
  brandstyrka_nn_1 = mkN "brandstyrka" ;
  brandsvamp_nn_1 = mkN "brandsvamp" ;
  brandsyn_nn_1 = mkN "brandsyn" "brandsyner" ;
  brandtal_nn_1 = mkN "brandtal" "brandtalet" "brandtalen" "brandtalena" ;
  brandtorn_nn_1 = mkN "brandtorn" neutrum ;
  brandvakt_ab_1 = mkAdv "brandvakt" ;
  brandvakt_nn_1 = mkN "brandvakt" "brandvakter" ;
  brandvarnare_nn_1 = mkN "brandvarnare" "brandvarnare" ;
  bransch_nn_1 = mkN "bransch" "branscher" ;
  branschfoerening_nn_1 = mkN "branschfцrening" ;
  branschraad_nn_1 = mkN "branschrеd" neutrum ;
  brant_av_1 = mkA "brant" "brant" ;
  brant_nn_1 = mkN "brant" "branter" ;
  brasilian_nn_1 = mkN "brasilian" "brasilianer" ;
  brasilianare_nn_1 = mkN "brasilianare" "brasilianare" ;
  brasiliansk_av_1 = mkA "brasiliansk" ;
  braskande_av_1 = mkA "braskande" ;
  brasklapp_nn_1 = mkN "brasklapp" ;
  brastaendare_nn_1 = mkN "brastдndare" "brastдndare" ;
  bravad_nn_1 = mkN "bravad" "bravader" ;
  bravurnummer_nn_1 = mkN "bravurnummer" neutrum ;
  bravurroll_nn_1 = mkN "bravurroll" "bravurroller" ;
  braxen_nn_1 = mkN "braxen" ;
  break_nn_1 = mkN "break" neutrum ;
  bred_av_1 = mkA "bred" ;
  bredbar_av_1 = mkA "bredbar" ;
  bredbent_av_1 = mkA "bredbent" "bredbent" ;
  bredbladig_av_1 = mkA "bredbladig" ;
  bredbraettig_av_1 = mkA "bredbrдttig" ;
  bredd_nn_1 = mkN "bredd" "bredder" ;
  breddgrad_nn_1 = mkN "breddgrad" "breddgrader" ;
  breddidrott_nn_1 = mkN "breddidrott" "breddidrotter" ;
  breddning_nn_1 = mkN "breddning" ;
  bredmun_nn_1 = mkN "bredmun" "bredmunnen" "bredmunnar" "bredmunnarna" ;
  bredmynt_av_1 = mkA "bredmynt" "bredmynt" ;
  bredrandig_av_1 = mkA "bredrandig" ;
  bredsida_nn_1 = mkN "bredsida" ;
  bredskyggig_av_1 = mkA "bredskyggig" ;
  bredspaarig_av_1 = mkA "bredspеrig" ;
  bredvid_ab_1 = mkAdv "bredvid" ;
  bretagnare_nn_1 = mkN "bretagnare" "bretagnare" ;
  bretagnisk_av_1 = mkA "bretagnisk" ;
  bretagniska_nn_2 = mkN "bretagniska" ;
  breton_nn_1 = mkN "breton" "bretoner" ;
  bretonsk_av_1 = mkA "bretonsk" ;
  bretonska_nn_2 = mkN "bretonska" ;
  brev_nn_1 = mkN "brev" neutrum ;
  brevbaerare_nn_1 = mkN "brevbдrare" "brevbдrare" ;
  brevbomb_nn_1 = mkN "brevbomb" "brevbomber" ;
  brevfack_nn_1 = mkN "brevfack" neutrum ;
  brevfoersaendelse_nn_1 = mkN "brevfцrsдndelse" "brevfцrsдndelser" ;
  brevfraaga_nn_1 = mkN "brevfrеga" ;
  brevhemlighet_nn_1 = mkN "brevhemlighet" "brevhemligheter" ;
  brevhuvud_nn_1 = mkN "brevhuvud" "brevhuvudet" "brevhuvuden" "brevhuvudena" ;
  breviarium_nn_1 = mkN "breviarium" "breviariet" "breviarier" "breviarierna" ;
  brevinkast_nn_1 = mkN "brevinkast" neutrum ;
  brevkort_nn_1 = mkN "brevkort" neutrum ;
  brevlaadefoeretag_nn_1 = mkN "brevlеdefцretag" neutrum ;
  brevledes_ab_1 = mkAdv "brevledes" ;
  brevoeppnare_nn_1 = mkN "brevцppnare" "brevцppnare" ;
  brevpapper_nn_1 = mkN "brevpapper" neutrum ;
  brevporto_nn_1 = mkN "brevporto" "brevportot" "brevporton" "brevportona" ;
  brevpress_nn_1 = mkN "brevpress" ;
  brevroman_nn_1 = mkN "brevroman" "brevromaner" ;
  brevskoerd_nn_1 = mkN "brevskцrd" ;
  brevskrivare_nn_1 = mkN "brevskrivare" "brevskrivare" ;
  brevstaell_nn_1 = mkN "brevstдll" neutrum ;
  brevstaellare_nn_1 = mkN "brevstдllare" "brevstдllare" ;
  brevsvar_nn_1 = mkN "brevsvar" neutrum ;
  brevtelegram_nn_1 = mkN "brevtelegram" "brevtelegrammet" "brevtelegram" "brevtelegrammen" ;
  brevvaag_nn_1 = mkN "brevvеg" ;
  brevvaen_nn_1 = mkN "brevvдn" "brevvдnnen" "brevvдnner" "brevvдnnerna" ;
  brevvaexling_nn_1 = mkN "brevvдxling" ;
  brickband_nn_1 = mkN "brickband" neutrum ;
  brickbord_nn_1 = mkN "brickbord" neutrum ;
  brickduk_nn_1 = mkN "brickduk" ;
  bricklunch_nn_1 = mkN "bricklunch" "brickluncher" ;
  brickplockare_nn_1 = mkN "brickplockare" "brickplockare" ;
  brickvaevd_av_1 = mkA "brickvдvd" "brickvдvt" ;
  bridgebord_nn_1 = mkN "bridgebord" neutrum ;
  bridong_nn_1 = mkN "bridong" "bridonger" ;
  bridreaktor_nn_1 = mkN "bridreaktor" "bridreaktorer" ;
  brigad_nn_1 = mkN "brigad" "brigader" ;
  brigadgeneral_nn_1 = mkN "brigadgeneral" "brigadgeneraler" ;
  brigadoer_nn_1 = mkN "brigadцr" "brigadцrer" ;
  brigantin_nn_1 = mkN "brigantin" "brigantiner" ;
  brigg_nn_1 = mkN "brigg" ;
  briggsegel_nn_1 = mkN "briggsegel" neutrum ;
  brikett_nn_1 = mkN "brikett" "briketter" ;
  brikettpress_nn_1 = mkN "brikettpress" ;
  brikollstoet_nn_1 = mkN "brikollstцt" ;
  briljant_av_1 = mkA "briljant" "briljant" ;
  briljant_nn_1 = mkN "briljant" "briljanter" ;
  brink_nn_1 = mkN "brink" ;
  brinna_vb_1 = mkV "brinna" "brann" "brunnit" ;
  brinnande_av_1 = mkA "brinnande" ;
  bris_nn_1 = mkN "bris" ;
  brisad_nn_1 = mkN "brisad" "brisader" ;
  brisans_nn_1 = mkN "brisans" "brisanser" ;
  brisansgranat_nn_1 = mkN "brisansgranat" "brisansgranater" ;
  brisant_av_1 = mkA "brisant" "brisant" ;
  brisant_nn_1 = mkN "brisant" "brisanter" ;
  brisken_av_1 = mkA "brisken" "brisket" ;
  brissling_nn_1 = mkN "brissling" ;
  brist_nn_1 = mkN "brist" "brister" ;
  brista_vb_1 = mkV "brista" "brast" "brustit" ;
  bristande_av_1 = mkA "bristande" ;
  bristfaellig_av_1 = mkA "bristfдllig" ;
  bristlaege_nn_1 = mkN "bristlдge" ;
  bristning_nn_1 = mkN "bristning" ;
  bristsituation_nn_1 = mkN "bristsituation" "bristsituationer" ;
  bristsjukdom_nn_1 = mkN "bristsjukdom" ;
  bristyrke_nn_1 = mkN "bristyrke" ;
  britannisk_av_1 = mkA "britannisk" ;
  brits_nn_1 = mkN "brits" ;
  britt_nn_1 = mkN "britt" "britter" ;
  brittisk_av_1 = mkA "brittisk" ;
  brittsommar_nn_1 = mkN "brittsommar" "brittsommarn" "brittsommrar" "brittsommrarna" ;
  bro_nn_1 = mkN "bro" ;
  broavgift_nn_1 = mkN "broavgift" "broavgifter" ;
  brobaenk_nn_1 = mkN "brobдnk" ;
  brobelastning_nn_1 = mkN "brobelastning" ;
  brock_nn_1 = mkN "brock" ;
  brock_nn_2 = mkN "brock" neutrum ;
  brockband_nn_1 = mkN "brockband" neutrum ;
  brockfaagel_nn_1 = mkN "brockfеgel" ;
  brodd_nn_1 = mkN "brodd" ;
  broder_nn_1 = mkN "broder" "brodern" "brцder" "brцderna" ;
  broderbaage_nn_1 = mkN "broderbеge" utrum ;
  broderbok_nn_1 = mkN "broderbok" "broderbцcker" ;
  broderfolk_nn_1 = mkN "broderfolk" neutrum ;
  broderi_nn_1 = mkN "broderi" "broderit" "broderier" "broderierna" ;
  brodering_nn_1 = mkN "brodering" ;
  broderlig_av_1 = mkA "broderlig" ;
  brodernaal_nn_1 = mkN "brodernеl" ;
  brodersax_nn_1 = mkN "brodersax" ;
  broderskaerlek_nn_1 = mkN "broderskдrlek" ;
  broderskap_nn_1 = mkN "broderskap" "broderskapet" "broderskapen" "broderskapena" ;
  brodersoem_nn_1 = mkN "brodersцm" "brodersцmmen" "brodersцmmar" "brodersцmmarna" ;
  brodyr_nn_1 = mkN "brodyr" "brodyrer" ;
  broed_nn_1 = mkN "brцd" neutrum ;
  broedbagge_nn_1 = mkN "brцdbagge" utrum ;
  broedbak_nn_1 = mkN "brцdbak" neutrum ;
  broedbit_nn_1 = mkN "brцdbit" ;
  broedburk_nn_1 = mkN "brцdburk" ;
  broedfat_nn_1 = mkN "brцdfat" neutrum ;
  broedfrukt_nn_1 = mkN "brцdfrukt" "brцdfrukter" ;
  broeding_nn_1 = mkN "brцding" ;
  broedkant_nn_1 = mkN "brцdkant" "brцdkanter" ;
  broedkavel_nn_1 = mkN "brцdkavel" ;
  broedkniv_nn_1 = mkN "brцdkniv" ;
  broedkorg_nn_1 = mkN "brцdkorg" ;
  broedloes_av_1 = mkA "brцdlцs" ;
  broednagg_nn_1 = mkN "brцdnagg" ;
  broedpudding_nn_1 = mkN "brцdpudding" ;
  broedrafolk_nn_1 = mkN "brцdrafolk" neutrum ;
  broedrapar_nn_1 = mkN "brцdrapar" neutrum ;
  broedraskap_nn_1 = mkN "brцdraskap" "brцdraskapet" "brцdraskapen" "brцdraskapena" ;
  broedrost_nn_1 = mkN "brцdrost" ;
  broedsbrytelse_nn_1 = mkN "brцdsbrytelse" "brцdsbrytelser" ;
  broedskriveri_nn_1 = mkN "brцdskriveri" "brцdskriverit" "brцdskriverier" "brцdskriverierna" ;
  broedspade_nn_1 = mkN "brцdspade" utrum ;
  broel_nn_1 = mkN "brцl" neutrum ;
  broellop_nn_1 = mkN "brцllop" neutrum ;
  broellopsdag_nn_1 = mkN "brцllopsdag" ;
  broellopsfoto_nn_1 = mkN "brцllopsfoto" "brцllopsfotot" "brцllopsfoton" "brцllopsfotona" ;
  broellopsgaest_nn_1 = mkN "brцllopsgдst" "brцllopsgдster" ;
  broellopsmarsch_nn_1 = mkN "brцllopsmarsch" "brцllopsmarscher" ;
  broellopsnatt_nn_1 = mkN "brцllopsnatt" "brцllopsnдtter" ;
  broellopspar_nn_1 = mkN "brцllopspar" neutrum ;
  broellopsvittne_nn_1 = mkN "brцllopsvittne" ;
  broest_nn_1 = mkN "brцst" neutrum ;
  broestarv_nn_1 = mkN "brцstarv" neutrum ;
  broestarvinge_nn_1 = mkN "brцstarvinge" utrum ;
  broestbarn_nn_1 = mkN "brцstbarn" neutrum ;
  broestben_nn_1 = mkN "brцstben" neutrum ;
  broestbild_nn_1 = mkN "brцstbild" "brцstbilder" ;
  broestboeld_nn_1 = mkN "brцstbцld" "brцstbцlder" ;
  broestcancer_nn_1 = mkN "brцstcancer" ;
  broestgaang_nn_1 = mkN "brцstgеng" ;
  broestgaenges_ab_1 = mkAdv "brцstgдnges" ;
  broestkaramell_nn_1 = mkN "brцstkaramell" "brцstkarameller" ;
  broestkatarr_nn_1 = mkN "brцstkatarr" "brцstkatarrer" ;
  broestkoertel_nn_1 = mkN "brцstkцrtel" ;
  broestkorg_nn_1 = mkN "brцstkorg" ;
  broestlapp_nn_1 = mkN "brцstlapp" ;
  broestmaatt_nn_1 = mkN "brцstmеtt" neutrum ;
  broestmur_nn_1 = mkN "brцstmur" ;
  broestmuskel_nn_1 = mkN "brцstmuskel" "brцstmuskeln" "brцstmuskler" "brцstmusklerna" ;
  broestning_nn_1 = mkN "brцstning" ;
  broestparti_nn_1 = mkN "brцstparti" "brцstpartit" "brцstpartier" "brцstpartierna" ;
  broestpump_nn_1 = mkN "brцstpump" ;
  broestregister_nn_1 = mkN "brцstregister" neutrum ;
  broestsimmare_nn_1 = mkN "brцstsimmare" "brцstsimmare" ;
  broestskydd_nn_1 = mkN "brцstskydd" neutrum ;
  broestton_nn_1 = mkN "brцstton" "brцsttoner" ;
  broestvaern_nn_1 = mkN "brцstvдrn" neutrum ;
  broestvidd_nn_1 = mkN "brцstvidd" "brцstvidder" ;
  broet_nn_1 = mkN "brцt" ;
  broethake_nn_1 = mkN "brцthake" utrum ;
  broetling_nn_1 = mkN "brцtling" ;
  brohuvud_nn_1 = mkN "brohuvud" "brohuvudet" "brohuvuden" "brohuvudena" ;
  broiler_nn_1 = mkN "broiler" ;
  brok_nn_1 = mkN "brok" ;
  brokad_nn_1 = mkN "brokad" "brokader" ;
  brokanal_nn_1 = mkN "brokanal" "brokanaler" ;
  brokar_nn_1 = mkN "brokar" neutrum ;
  brokbladig_av_1 = mkA "brokbladig" ;
  brokblommig_av_1 = mkA "brokblommig" ;
  brokig_av_1 = mkA "brokig" ;
  brokspett_nn_1 = mkN "brokspett" ;
  bromfoergiftning_nn_1 = mkN "bromfцrgiftning" ;
  bromid_nn_1 = mkN "bromid" "bromider" ;
  broms_nn_1 = mkN "broms" ;
  bromsare_nn_1 = mkN "bromsare" "bromsare" ;
  bromsback_nn_1 = mkN "bromsback" ;
  bromsband_nn_1 = mkN "bromsband" neutrum ;
  bromsbelaegg_nn_1 = mkN "bromsbelдgg" neutrum ;
  bromsblock_nn_1 = mkN "bromsblock" neutrum ;
  bromscylinder_nn_1 = mkN "bromscylinder" ;
  bromsgaller_nn_1 = mkN "bromsgaller" neutrum ;
  bromsilverpapper_nn_1 = mkN "bromsilverpapper" neutrum ;
  bromsklaff_nn_1 = mkN "bromsklaff" ;
  bromskloss_nn_1 = mkN "bromskloss" ;
  bromsljus_nn_1 = mkN "bromsljus" neutrum ;
  bromsning_nn_1 = mkN "bromsning" ;
  bromsolja_nn_1 = mkN "bromsolja" ;
  bromspedal_nn_1 = mkN "bromspedal" "bromspedaler" ;
  bromsraket_nn_1 = mkN "bromsraket" "bromsraketer" ;
  bromsskaerm_nn_1 = mkN "bromsskдrm" ;
  bromssko_nn_1 = mkN "bromssko" "bromsskor" ;
  bromsspaar_nn_1 = mkN "bromsspеr" neutrum ;
  bromssystem_nn_1 = mkN "bromssystem" neutrum ;
  bromsvaetska_nn_1 = mkN "bromsvдtska" ;
  bromsvagn_nn_1 = mkN "bromsvagn" ;
  bronkit_nn_1 = mkN "bronkit" "bronkiter" ;
  bronkografi_nn_1 = mkN "bronkografi" "bronkografier" ;
  bronkoskop_nn_1 = mkN "bronkoskop" neutrum ;
  bronkoskopi_nn_1 = mkN "bronkoskopi" "bronkoskopier" ;
  brons_nn_1 = mkN "brons" "bronser" ;
  brons_nn_2 = mkN "brons" neutrum ;
  bronsaaldersfynd_nn_1 = mkN "bronsеldersfynd" neutrum ;
  bronsmaerke_nn_1 = mkN "bronsmдrke" ;
  bronsmedalj_nn_1 = mkN "bronsmedalj" "bronsmedaljer" ;
  bropelare_nn_1 = mkN "bropelare" "bropelare" ;
  bropeng_nn_1 = mkN "bropeng" ;
  bropenning_nn_1 = mkN "bropenning" ;
  brorsarv_nn_1 = mkN "brorsarv" neutrum ;
  brorsbarn_nn_1 = mkN "brorsbarn" neutrum ;
  brorsdotter_nn_1 = mkN "brorsdotter" "brorsdottern" "brorsdцttrar" "brorsdцttrarna" ;
  brorskaal_nn_1 = mkN "brorskеl" ;
  brorslott_nn_1 = mkN "brorslott" "brorslotter" ;
  brorson_nn_1 = mkN "brorson" "brorsцner" ;
  brorsskaal_nn_1 = mkN "brorsskеl" ;
  brosch_nn_1 = mkN "brosch" "broscher" ;
  broschyr_nn_1 = mkN "broschyr" "broschyrer" ;
  brosk_nn_1 = mkN "brosk" neutrum ;
  broskfisk_nn_1 = mkN "broskfisk" ;
  broskhinna_nn_1 = mkN "broskhinna" ;
  broskskivling_nn_1 = mkN "broskskivling" ;
  brosksvamp_nn_1 = mkN "brosksvamp" ;
  broskvaevnad_nn_1 = mkN "broskvдvnad" "broskvдvnader" ;
  broskverk_nn_1 = mkN "broskverk" neutrum ;
  broslagning_nn_1 = mkN "broslagning" ;
  brosme_nn_1 = mkN "brosme" utrum ;
  brospann_nn_1 = mkN "brospann" neutrum ;
  brotsch_nn_1 = mkN "brotsch" ;
  brott_nn_1 = mkN "brott" neutrum ;
  brottare_nn_1 = mkN "brottare" "brottare" ;
  brottmaal_nn_1 = mkN "brottmеl" neutrum ;
  brottning_nn_1 = mkN "brottning" ;
  brottningsgrepp_nn_1 = mkN "brottningsgrepp" neutrum ;
  brottningsmatch_nn_1 = mkN "brottningsmatch" "brottningsmatcher" ;
  brottsfoerebyggande_av_1 = mkA "brottsfцrebyggande" ;
  brottsjoe_nn_1 = mkN "brottsjц" ;
  brottslig_av_1 = mkA "brottslig" ;
  brottslighet_nn_1 = mkN "brottslighet" "brottsligheter" ;
  brottsling_nn_1 = mkN "brottsling" ;
  brottsplats_nn_1 = mkN "brottsplats" "brottsplatser" ;
  brottsrekvisit_nn_1 = mkN "brottsrekvisit" neutrum ;
  brottsrubricering_nn_1 = mkN "brottsrubricering" ;
  brottstillfaelle_nn_1 = mkN "brottstillfдlle" ;
  brottsutredning_nn_1 = mkN "brottsutredning" ;
  brovalv_nn_1 = mkN "brovalv" neutrum ;
  browning_nn_1 = mkN "browning" ;
  bruckel_nn_1 = mkN "bruckel" neutrum ;
  brud_nn_1 = mkN "brud" ;
  brudand_nn_1 = mkN "brudand" "brudдnder" ;
  brudbukett_nn_1 = mkN "brudbukett" "brudbuketter" ;
  brudfoto_nn_1 = mkN "brudfoto" "brudfotot" "brudfoton" "brudfotona" ;
  brudgum_nn_1 = mkN "brudgum" "brudgummen" "brudgummar" "brudgummarna" ;
  brudklaenning_nn_1 = mkN "brudklдnning" ;
  brudkoep_nn_1 = mkN "brudkцp" neutrum ;
  brudnaebb_nn_1 = mkN "brudnдbb" ;
  brudpaell_nn_1 = mkN "brudpдll" ;
  brudpall_nn_1 = mkN "brudpall" ;
  brudpar_nn_1 = mkN "brudpar" neutrum ;
  brudrov_nn_1 = mkN "brudrov" neutrum ;
  brudsaeng_nn_1 = mkN "brudsдng" ;
  brudsloeja_nn_1 = mkN "brudslцja" ;
  brudsporre_nn_1 = mkN "brudsporre" utrum ;
  brudstol_nn_1 = mkN "brudstol" ;
  brugd_nn_1 = mkN "brugd" "brugder" ;
  bruk_nn_1 = mkN "bruk" neutrum ;
  brukare_nn_1 = mkN "brukare" "brukare" ;
  brukbar_av_1 = mkA "brukbar" ;
  bruklig_av_1 = mkA "bruklig" ;
  bruklighet_nn_1 = mkN "bruklighet" "brukligheter" ;
  brukningsenhet_nn_1 = mkN "brukningsenhet" "brukningsenheter" ;
  bruksanvisning_nn_1 = mkN "bruksanvisning" ;
  bruksartikel_nn_1 = mkN "bruksartikel" ;
  bruksdisponent_nn_1 = mkN "bruksdisponent" "bruksdisponenter" ;
  bruksdjur_nn_1 = mkN "bruksdjur" neutrum ;
  bruksfoeremaal_nn_1 = mkN "bruksfцremеl" neutrum ;
  brukshund_nn_1 = mkN "brukshund" ;
  brukslagare_nn_1 = mkN "brukslagare" "brukslagare" ;
  brukspatron_nn_1 = mkN "brukspatron" "brukspatroner" ;
  bruksvaerde_nn_1 = mkN "bruksvдrde" ;
  brulepudding_nn_1 = mkN "brulйpudding" ;
  brumbas_nn_1 = mkN "brumbas" ;
  brumbjoern_nn_1 = mkN "brumbjцrn" ;
  brumkoer_nn_1 = mkN "brumkцr" "brumkцrer" ;
  brummare_nn_1 = mkN "brummare" "brummare" ;
  brun_av_1 = mkA "brun" ;
  brunaktig_av_1 = mkA "brunaktig" ;
  brunalg_nn_1 = mkN "brunalg" "brunalger" ;
  brunbaer_nn_1 = mkN "brunbдr" neutrum ;
  brunbraend_av_1 = mkA "brunbrдnd" ;
  brunch_nn_1 = mkN "brunch" "bruncher" ;
  brunett_av_1 = mkA "brunett" ;
  brunhaarig_av_1 = mkA "brunhеrig" ;
  brunkol_nn_1 = mkN "brunkol" neutrum ;
  brunn_nn_1 = mkN "brunn" ;
  brunnshus_nn_1 = mkN "brunnshus" neutrum ;
  brunnskar_nn_1 = mkN "brunnskar" neutrum ;
  brunnskur_nn_1 = mkN "brunnskur" "brunnskurer" ;
  brunnsort_nn_1 = mkN "brunnsort" "brunnsorter" ;
  brunnssvaengel_nn_1 = mkN "brunnssvдngel" ;
  brunnsvatten_nn_1 = mkN "brunnsvatten" "brunnsvattnet" "brunnsvatten" "brunnsvattnen" ;
  brunoegd_av_1 = mkA "brunцgd" "brunцgt" ;
  brunoert_nn_1 = mkN "brunцrt" "brunцrter" ;
  brunroed_av_1 = mkA "brunrцd" ;
  brunstig_av_1 = mkA "brunstig" ;
  brunsvart_av_1 = mkA "brunsvart" "brunsvart" ;
  brunte_nn_1 = mkN "brunte" utrum ;
  brushane_nn_1 = mkN "brushane" utrum ;
  brushuvud_nn_1 = mkN "brushuvud" "brushuvudet" "brushuvuden" "brushuvudena" ;
  brustablett_nn_1 = mkN "brustablett" "brustabletter" ;
  brusten_av_1 = mkA "brusten" "brustet" ;
  brutal_av_1 = mkA "brutal" ;
  brutalitet_nn_1 = mkN "brutalitet" "brutaliteter" ;
  brutto_ab_1 = mkAdv "brutto" ;
  brutto_nn_1 = mkN "brutto" "bruttot" "brutton" "bruttona" ;
  bruttobehaallning_nn_1 = mkN "bruttobehеllning" ;
  bruttodraektighet_nn_1 = mkN "bruttodrдktighet" "bruttodrдktigheter" ;
  bruttoformel_nn_1 = mkN "bruttoformel" "bruttoformeln" "bruttoformler" "bruttoformlerna" ;
  bruttoinkomst_nn_1 = mkN "bruttoinkomst" "bruttoinkomster" ;
  bruttoloen_nn_1 = mkN "bruttolцn" "bruttolцner" ;
  bruttonationalprodukt_nn_1 = mkN "bruttonationalprodukt" "bruttonationalprodukter" ;
  bruttopris_nn_1 = mkN "bruttopris" neutrum ;
  bruttoregisterton_nn_1 = mkN "bruttoregisterton" "bruttoregistertonnet" "bruttoregisterton" "bruttoregistertonnen" ;
  brydd_av_1 = mkA "brydd" ;
  bryderi_nn_1 = mkN "bryderi" "bryderit" "bryderier" "bryderierna" ;
  brydsam_av_1 = mkA "brydsam" "brydsamt" "brydsamma" "brydsamma" "brydsammare" "brydsammast" "brydsammaste" ;
  brygd_nn_1 = mkN "brygd" "brygder" ;
  bryggare_nn_1 = mkN "bryggare" "bryggare" ;
  bryggeri_nn_1 = mkN "bryggeri" "bryggerit" "bryggerier" "bryggerierna" ;
  brygghus_nn_1 = mkN "brygghus" neutrum ;
  bryggmald_av_1 = mkA "bryggmald" "bryggmalt" ;
  bryggmalen_av_1 = mkA "bryggmalen" "bryggmalet" ;
  bryggvaag_nn_1 = mkN "bryggvеg" ;
  brylaa_nn_1 = mkN "brylе" "brylеer" ;
  brylepudding_nn_1 = mkN "brylйpudding" ;
  brylling_nn_1 = mkN "brylling" ;
  bryn_nn_1 = mkN "bryn" neutrum ;
  brynja_nn_1 = mkN "brynja" ;
  brynstaal_nn_1 = mkN "brynstеl" neutrum ;
  brynsten_nn_1 = mkN "brynsten" "brynstenen" "brynstenar" "brynstenarna" ;
  bryolog_nn_1 = mkN "bryolog" "bryologer" ;
  brysk_av_1 = mkA "brysk" ;
  brysselspets_nn_1 = mkN "brysselspets" ;
  bryta_vb_1 = mkV "bryta" "brцt" "brutit" ;
  bryte_nn_1 = mkN "bryte" utrum ;
  brytning_nn_1 = mkN "brytning" ;
  brytningsaar_nn_1 = mkN "brytningsеr" neutrum ;
  brytningsexponent_nn_1 = mkN "brytningsexponent" "brytningsexponenter" ;
  brytningsfel_nn_1 = mkN "brytningsfel" "brytningsfelet" "brytningsfel" "brytningsfelen" ;
  brytningsindex_nn_1 = mkN "brytningsindex" neutrum ;
  brytningspunkt_nn_1 = mkN "brytningspunkt" "brytningspunkter" ;
  brytningstid_nn_1 = mkN "brytningstid" "brytningstider" ;
  brytningsvinkel_nn_1 = mkN "brytningsvinkel" ;
  brytpunkt_nn_1 = mkN "brytpunkt" "brytpunkter" ;
  brytvapen_nn_1 = mkN "brytvapen" "brytvapnet" "brytvapen" "brytvapnen" ;
  bubbelgum_nn_1 = mkN "bubbelgum" "bubbelgummet" "bubbelgum" "bubbelgummen" ;
  bubbelkammare_nn_1 = mkN "bubbelkammare" "bubbelkammaren" "bubbelkamrar" "bubbelkamrarna" ;
  bubbelpool_nn_1 = mkN "bubbelpool" "bubbelpooler" ;
  bubbla_nn_1 = mkN "bubbla" ;
  bubblig_av_1 = mkA "bubblig" ;
  bubon_nn_1 = mkN "bubon" "buboner" ;
  buckla_nn_1 = mkN "buckla" ;
  bucklig_av_1 = mkA "bucklig" ;
  bud_nn_1 = mkN "bud" neutrum ;
  budbaerare_nn_1 = mkN "budbдrare" "budbдrare" ;
  budbyraa_nn_1 = mkN "budbyrе" "budbyrеer" ;
  buddist_nn_1 = mkN "buddist" "buddister" ;
  buddistisk_av_1 = mkA "buddistisk" ;
  budget_nn_1 = mkN "budget" ;
  budgetaar_nn_1 = mkN "budgetеr" neutrum ;
  budgetaer_av_1 = mkA "budgetдr" ;
  budgetoeverskott_nn_1 = mkN "budgetцverskott" neutrum ;
  budgetproposition_nn_1 = mkN "budgetproposition" "budgetpropositioner" ;
  budgetunderskott_nn_1 = mkN "budgetunderskott" neutrum ;
  budgivning_nn_1 = mkN "budgivning" ;
  budkavel_nn_1 = mkN "budkavel" ;
  budkavle_nn_1 = mkN "budkavle" utrum ;
  budoar_nn_1 = mkN "budoar" "budoarer" ;
  budord_nn_1 = mkN "budord" neutrum ;
  budskap_nn_1 = mkN "budskap" "budskapet" "budskapen" "budskapena" ;
  buff_nn_1 = mkN "buff" ;
  buffaopera_nn_1 = mkN "buffaopera" ;
  buffe_nn_1 = mkN "buffй" "buffйer" ;
  buffel_nn_1 = mkN "buffel" ;
  buffelaktig_av_1 = mkA "buffelaktig" ;
  buffelhjord_nn_1 = mkN "buffelhjord" ;
  buffert_nn_1 = mkN "buffert" ;
  buffertkapacitet_nn_1 = mkN "buffertkapacitet" "buffertkapaciteter" ;
  buffertlager_nn_1 = mkN "buffertlager" neutrum ;
  buffertloesning_nn_1 = mkN "buffertlцsning" ;
  buffertstat_nn_1 = mkN "buffertstat" "buffertstater" ;
  bufflig_av_1 = mkA "bufflig" ;
  bugning_nn_1 = mkN "bugning" ;
  buk_nn_1 = mkN "buk" ;
  bukett_nn_1 = mkN "bukett" "buketter" ;
  bukformig_av_1 = mkA "bukformig" ;
  bukgjord_nn_1 = mkN "bukgjord" ;
  bukhinna_nn_1 = mkN "bukhinna" ;
  bukhinneinflammation_nn_1 = mkN "bukhinneinflammation" "bukhinneinflammationer" ;
  bukig_av_1 = mkA "bukig" ;
  bukmuskel_nn_1 = mkN "bukmuskel" "bukmuskeln" "bukmuskler" "bukmusklerna" ;
  bukolisk_av_1 = mkA "bukolisk" ;
  bukspottkoertel_nn_1 = mkN "bukspottkцrtel" ;
  bukstinn_av_1 = mkA "bukstinn" "bukstint" ;
  buksvaager_nn_1 = mkN "buksvеger" ;
  bukt_ab_1 = mkAdv "bukt" ;
  bukt_nn_1 = mkN "bukt" "bukter" ;
  buktalare_nn_1 = mkN "buktalare" "buktalare" ;
  buktig_av_1 = mkA "buktig" ;
  bukvaegg_nn_1 = mkN "bukvдgg" ;
  bulb_nn_1 = mkN "bulb" "bulber" ;
  bulbjaern_nn_1 = mkN "bulbjдrn" neutrum ;
  bulevard_nn_1 = mkN "bulevard" "bulevarder" ;
  bulgar_nn_1 = mkN "bulgar" "bulgarer" ;
  bulgarisk_av_1 = mkA "bulgarisk" ;
  bulgariska_nn_2 = mkN "bulgariska" ;
  buljong_nn_1 = mkN "buljong" "buljonger" ;
  buljongben_nn_1 = mkN "buljongben" neutrum ;
  buljongtaerning_nn_1 = mkN "buljongtдrning" ;
  bulkfartyg_nn_1 = mkN "bulkfartyg" neutrum ;
  bulklast_nn_1 = mkN "bulklast" "bulklaster" ;
  bulklastare_nn_1 = mkN "bulklastare" "bulklastare" ;
  bulkmedel_nn_1 = mkN "bulkmedel" neutrum ;
  bulldogg_nn_1 = mkN "bulldogg" ;
  bulldozer_nn_1 = mkN "bulldozer" ;
  bulle_nn_1 = mkN "bulle" utrum ;
  buller_nn_1 = mkN "buller" neutrum ;
  bullerbas_nn_1 = mkN "bullerbas" ;
  bullerblomster_nn_1 = mkN "bullerblomster" neutrum ;
  bullersam_av_1 = mkA "bullersam" "bullersamt" "bullersamma" "bullersamma" "bullersammare" "bullersammast" "bullersammaste" ;
  bullersten_nn_1 = mkN "bullersten" "bullerstenen" "bullerstenar" "bullerstenarna" ;
  bulletin_nn_1 = mkN "bulletin" "bulletiner" ;
  bullig_av_1 = mkA "bullig" ;
  bullrig_av_1 = mkA "bullrig" ;
  bulnad_nn_1 = mkN "bulnad" "bulnader" ;
  bulsig_av_1 = mkA "bulsig" ;
  bult_nn_1 = mkN "bult" ;
  bultpistol_nn_1 = mkN "bultpistol" "bultpistoler" ;
  bultsax_nn_1 = mkN "bultsax" ;
  bulvan_nn_1 = mkN "bulvan" "bulvaner" ;
  bumerang_nn_1 = mkN "bumerang" "bumeranger" ;
  bumling_nn_1 = mkN "bumling" ;
  bums_ab_1 = mkAdv "bums" ;
  bunden_av_1 = mkA "bunden" "bundet" ;
  bundsfoervant_nn_1 = mkN "bundsfцrvant" "bundsfцrvanter" ;
  bungalow_nn_1 = mkN "bungalow" "bungalower" ;
  bunke_nn_1 = mkN "bunke" utrum ;
  bunker_nn_1 = mkN "bunker" ;
  bunsenbraennare_nn_1 = mkN "bunsenbrдnnare" "bunsenbrдnnare" ;
  bunt_nn_1 = mkN "bunt" ;
  buntmakare_nn_1 = mkN "buntmakare" "buntmakare" ;
  bur_nn_1 = mkN "bur" ;
  burbrev_nn_1 = mkN "burbrev" neutrum ;
  burdus_av_1 = mkA "burdus" ;
  burfaagel_nn_1 = mkN "burfеgel" ;
  burgare_nn_1 = mkN "burgare" "burgare" ;
  burgen_av_1 = mkA "burgen" "burget" ;
  burgunder_nn_1 = mkN "burgunder" "burgundern" "burgunder" "burgunderna" ;
  burk_nn_1 = mkN "burk" ;
  burkoel_nn_1 = mkN "burkцl" neutrum ;
  burkoeppnare_nn_1 = mkN "burkцppnare" "burkцppnare" ;
  burlesk_av_1 = mkA "burlesk" ;
  burlesk_nn_1 = mkN "burlesk" "burlesker" ;
  burleskeri_nn_1 = mkN "burleskeri" "burleskerit" "burleskerier" "burleskerierna" ;
  burman_nn_1 = mkN "burman" "burmaner" ;
  burmanska_nn_2 = mkN "burmanska" ;
  burmes_nn_1 = mkN "burmes" "burmeser" ;
  burnus_nn_1 = mkN "burnus" ;
  burr_nn_1 = mkN "burr" neutrum ;
  burrig_av_1 = mkA "burrig" ;
  burschikos_av_1 = mkA "burschikos" ;
  burspraak_nn_1 = mkN "bursprеk" neutrum ;
  burundier_nn_1 = mkN "burundier" "burundiern" "burundier" "burundierna" ;
  burundisk_av_1 = mkA "burundisk" ;
  buse_nn_1 = mkN "buse" utrum ;
  busfason_nn_1 = mkN "busfason" "busfasoner" ;
  busfroe_nn_1 = mkN "busfrц" "busfrцt" "busfrцn" "busfrцen" ;
  bushman_nn_1 = mkN "bushman" "bushmannen" "bushmдn" "bushmдnnen" ;
  busig_av_1 = mkA "busig" ;
  business_nn_1 = mkN "business" ;
  buskablyg_av_1 = mkA "buskablyg" ;
  buskage_nn_1 = mkN "buskage" "buskaget" "buskage" "buskagen" ;
  buske_nn_1 = mkN "buske" utrum ;
  buskig_av_1 = mkA "buskig" ;
  buskliknande_av_1 = mkA "buskliknande" ;
  buskoerning_nn_1 = mkN "buskцrning" ;
  busksly_nn_1 = mkN "busksly" "buskslyet" "buskslyn" "buskslyna" ;
  buss_nn_1 = mkN "buss" ;
  bussarong_nn_1 = mkN "bussarong" "bussaronger" ;
  busschauffoer_nn_1 = mkN "busschauffцr" "busschauffцrer" ;
  bussfoerbindelse_nn_1 = mkN "bussfцrbindelse" "bussfцrbindelser" ;
  busshaallplats_nn_1 = mkN "busshеllplats" "busshеllplatser" ;
  bussig_av_1 = mkA "bussig" ;
  busskort_nn_1 = mkN "busskort" neutrum ;
  busslast_nn_1 = mkN "busslast" "busslaster" ;
  busslinje_nn_1 = mkN "busslinje" "busslinjer" ;
  bussning_nn_1 = mkN "bussning" ;
  busunge_nn_1 = mkN "busunge" utrum ;
  busvissling_nn_1 = mkN "busvissling" ;
  butan_nn_1 = mkN "butan" "butaner" ;
  butelj_nn_1 = mkN "butelj" "buteljer" ;
  buteljborste_nn_1 = mkN "buteljborste" utrum ;
  buteljbotten_nn_1 = mkN "buteljbotten" ;
  buteljering_nn_1 = mkN "buteljering" ;
  buteljgroen_av_1 = mkA "buteljgrцn" ;
  butik_nn_1 = mkN "butik" "butiker" ;
  butiksbitraede_nn_1 = mkN "butiksbitrдde" ;
  butikskedja_nn_1 = mkN "butikskedja" ;
  butiksstaengningslag_nn_1 = mkN "butiksstдngningslag" ;
  butler_nn_1 = mkN "butler" "butlern" "butlers" "butlersen" ;
  butter_av_1 = mkA "butter" "buttert" "buttra" "buttra" "buttrare" "buttrast" "buttraste" ;
  butyl_nn_1 = mkN "butyl" "butyler" ;
  buxbom_nn_1 = mkN "buxbom" ;
  by_nn_1 = mkN "by" "byn" "byar" "byarna" ;
  byaeldste_nn_1 = mkN "byдldste" utrum ;
  byalag_nn_1 = mkN "byalag" neutrum ;
  byamaal_nn_1 = mkN "byamеl" neutrum ;
  byfaane_nn_1 = mkN "byfеne" utrum ;
  byffe_nn_1 = mkN "byffй" "byffйer" ;
  byfogde_nn_1 = mkN "byfogde" utrum ;
  bygd_nn_1 = mkN "bygd" "bygder" ;
  bygdeborg_nn_1 = mkN "bygdeborg" ;
  bygdegaard_nn_1 = mkN "bygdegеrd" ;
  bygdemaal_nn_1 = mkN "bygdemеl" neutrum ;
  bygel_nn_1 = mkN "bygel" ;
  bygelhaest_nn_1 = mkN "bygelhдst" ;
  bygelhorn_nn_1 = mkN "bygelhorn" neutrum ;
  bygellaas_nn_1 = mkN "bygellеs" neutrum ;
  byggarbetare_nn_1 = mkN "byggarbetare" "byggarbetare" ;
  byggare_nn_1 = mkN "byggare" "byggare" ;
  byggelement_nn_1 = mkN "byggelement" neutrum ;
  byggherre_nn_1 = mkN "byggherre" utrum ;
  byggkloss_nn_1 = mkN "byggkloss" ;
  bygglag_nn_1 = mkN "bygglag" ;
  bygglekplats_nn_1 = mkN "bygglekplats" "bygglekplatser" ;
  bygglov_nn_1 = mkN "bygglov" neutrum ;
  byggmaestare_nn_1 = mkN "byggmдstare" "byggmдstare" ;
  byggmaterial_nn_1 = mkN "byggmaterial" neutrum ;
  byggnad_nn_1 = mkN "byggnad" "byggnader" ;
  byggnadsarbetare_nn_1 = mkN "byggnadsarbetare" "byggnadsarbetare" ;
  byggnadsindustri_nn_1 = mkN "byggnadsindustri" "byggnadsindustrier" ;
  byggnadskonstruktion_nn_1 = mkN "byggnadskonstruktion" "byggnadskonstruktioner" ;
  byggnadskontor_nn_1 = mkN "byggnadskontor" neutrum ;
  byggnadskredit_nn_1 = mkN "byggnadskredit" "byggnadskrediter" ;
  byggnadskreditiv_nn_1 = mkN "byggnadskreditiv" neutrum ;
  byggnadslaan_nn_1 = mkN "byggnadslеn" neutrum ;
  byggnadslov_nn_1 = mkN "byggnadslov" neutrum ;
  byggnadsmaterial_nn_1 = mkN "byggnadsmaterial" neutrum ;
  byggnadsminne_nn_1 = mkN "byggnadsminne" ;
  byggnadsnaemnd_nn_1 = mkN "byggnadsnдmnd" "byggnadsnдmnder" ;
  byggnadsplan_nn_1 = mkN "byggnadsplan" "byggnadsplaner" ;
  byggnadssnickare_nn_1 = mkN "byggnadssnickare" "byggnadssnickare" ;
  byggnadsstaellning_nn_1 = mkN "byggnadsstдllning" ;
  byggnadssten_nn_1 = mkN "byggnadssten" "byggnadsstenen" "byggnadsstenar" "byggnadsstenarna" ;
  byggnadsstil_nn_1 = mkN "byggnadsstil" ;
  byggnadsstyrelse_nn_1 = mkN "byggnadsstyrelse" "byggnadsstyrelser" ;
  byggnadstillstaand_nn_1 = mkN "byggnadstillstеnd" neutrum ;
  byggnadsverk_nn_1 = mkN "byggnadsverk" neutrum ;
  byggning_nn_1 = mkN "byggning" ;
  byggsats_nn_1 = mkN "byggsats" "byggsatser" ;
  byggstart_nn_1 = mkN "byggstart" "byggstarter" ;
  byggsten_nn_1 = mkN "byggsten" "byggstenen" "byggstenar" "byggstenarna" ;
  byggstopp_nn_1 = mkN "byggstopp" neutrum ;
  byggtork_nn_1 = mkN "byggtork" ;
  byhus_nn_1 = mkN "byhus" neutrum ;
  byig_av_1 = mkA "byig" ;
  byk_nn_1 = mkN "byk" ;
  byling_nn_1 = mkN "byling" ;
  bylsig_av_1 = mkA "bylsig" ;
  bymoln_nn_1 = mkN "bymoln" neutrum ;
  byomraade_nn_1 = mkN "byomrеde" ;
  byordning_nn_1 = mkN "byordning" ;
  byraa_nn_1 = mkN "byrе" ;
  byraa_nn_2 = mkN "byrе" "byrеer" ;
  byraaassistent_nn_1 = mkN "byrеassistent" "byrеassistenter" ;
  byraachef_nn_1 = mkN "byrеchef" "byrеchefer" ;
  byraadirektoer_nn_1 = mkN "byrеdirektцr" "byrеdirektцrer" ;
  byraakrat_nn_1 = mkN "byrеkrat" "byrеkrater" ;
  byraakrati_nn_1 = mkN "byrеkrati" "byrеkratier" ;
  byraakratisk_av_1 = mkA "byrеkratisk" ;
  byraasekreterare_nn_1 = mkN "byrеsekreterare" "byrеsekreterare" ;
  byrett_nn_1 = mkN "byrett" "byretter" ;
  bysamfaellighet_nn_1 = mkN "bysamfдllighet" "bysamfдlligheter" ;
  bysantin_nn_1 = mkN "bysantin" "bysantiner" ;
  bysantinsk_av_1 = mkA "bysantinsk" ;
  byssja_nn_1 = mkN "byssja" ;
  byst_nn_1 = mkN "byst" "byster" ;
  bystaemma_nn_1 = mkN "bystдmma" ;
  bystdrottning_nn_1 = mkN "bystdrottning" ;
  bysthaallare_nn_1 = mkN "bysthеllare" "bysthеllare" ;
  bystmaatt_nn_1 = mkN "bystmеtt" neutrum ;
  byte_nn_1 = mkN "byte" ;
  byte_nn_2 = mkN "byte" "byten" "byte" "bytena" ;
  bytesaffaer_nn_1 = mkN "bytesaffдr" "bytesaffдrer" ;
  bytesdjur_nn_1 = mkN "bytesdjur" neutrum ;
  byteslaegenhet_nn_1 = mkN "byteslдgenhet" "byteslдgenheter" ;
  bytesmedel_nn_1 = mkN "bytesmedel" neutrum ;
  bytesobjekt_nn_1 = mkN "bytesobjekt" neutrum ;
  bytesvaerde_nn_1 = mkN "bytesvдrde" ;
  byting_nn_1 = mkN "byting" ;
  byx_nn_1 = mkN "byx" ;
  byxbak_nn_1 = mkN "byxbak" ;
  byxben_nn_1 = mkN "byxben" neutrum ;
  byxdraekt_nn_1 = mkN "byxdrдkt" "byxdrдkter" ;
  byxdress_nn_1 = mkN "byxdress" ;
  byxholk_nn_1 = mkN "byxholk" ;
  byxis_av_1 = mkA "byxis" ;
  byxkjol_nn_1 = mkN "byxkjol" ;
  cab_nn_1 = mkN "cab" ;
  cabb_nn_1 = mkN "cabb" ;
  cabriolet_nn_1 = mkN "cabriolet" "cabrioleter" ;
  caddie_nn_1 = mkN "caddie" "caddien" "caddies" "caddiesen" ;
  cafe_nn_1 = mkN "cafй" "cafйt" "cafйer" "cafйerna" ;
  callgirl_nn_1 = mkN "callgirl" "callgirlen" "callgirls" "callgirlsen" ;
  calmettevaccinering_nn_1 = mkN "calmettevaccinering" ;
  camouflage_nn_1 = mkN "camouflage" "camouflaget" "camouflage" "camouflagen" ;
  camp_av_1 = mkA "camp" "camp" ;
  campare_nn_1 = mkN "campare" "campare" ;
  camping_nn_1 = mkN "camping" ;
  campingplats_nn_1 = mkN "campingplats" "campingplatser" ;
  campus_nn_1 = mkN "campus" neutrum ;
  cancer_nn_1 = mkN "cancer" ;
  cancerfall_nn_1 = mkN "cancerfall" neutrum ;
  cancerfara_nn_1 = mkN "cancerfara" ;
  cancerform_nn_1 = mkN "cancerform" "cancerformer" ;
  cancerforskare_nn_1 = mkN "cancerforskare" "cancerforskare" ;
  cancerforskning_nn_1 = mkN "cancerforskning" ;
  cancerframkallande_av_1 = mkA "cancerframkallande" ;
  cancerogen_av_1 = mkA "cancerogen" ;
  cancerrisk_nn_1 = mkN "cancerrisk" "cancerrisker" ;
  cancersvulst_nn_1 = mkN "cancersvulst" "cancersvulster" ;
  candela_nn_1 = mkN "candela" "candelan" "candela" "candelana" ;
  cape_nn_1 = mkN "cape" "caper" ;
  cappuccino_nn_1 = mkN "cappuccino" "cappuccinon" "cappuccino" "cappuccinona" ;
  carcinogen_nn_1 = mkN "carcinogen" "carcinogener" ;
  cardigan_nn_1 = mkN "cardigan" "cardiganen" "cardigans" "cardigansen" ;
  cash_ab_1 = mkAdv "cash" ;
  cash_nn_1 = mkN "cash" neutrum ;
  caterpillar_nn_1 = mkN "caterpillar" "caterpillarn" "caterpillars" "caterpillarsen" ;
  ceder_nn_1 = mkN "ceder" ;
  cedilj_nn_1 = mkN "cedilj" "cediljer" ;
  celeber_av_1 = mkA "celeber" "celebert" "celebra" "celebra" "celebrare" "celebrast" "celebraste" ;
  celebritet_nn_1 = mkN "celebritet" "celebriteter" ;
  celest_av_1 = mkA "celest" "celest" ;
  celibat_nn_1 = mkN "celibat" neutrum ;
  cell_nn_1 = mkN "cell" "celler" ;
  celldelning_nn_1 = mkN "celldelning" ;
  cellfaengelse_nn_1 = mkN "cellfдngelse" "cellfдngelset" "cellfдngelser" "cellfдngelserna" ;
  cellgift_nn_1 = mkN "cellgift" "cellgiftet" "cellgifter" "cellgifterna" ;
  cellgranne_nn_1 = mkN "cellgranne" utrum ;
  cellist_nn_1 = mkN "cellist" "cellister" ;
  cellkamrat_nn_1 = mkN "cellkamrat" "cellkamrater" ;
  cellmembran_nn_1 = mkN "cellmembran" neutrum ;
  cello_nn_1 = mkN "cello" "cellor" ;
  cellplasma_nn_1 = mkN "cellplasma" "cellplasmat" "cellplasmer" "cellplasmerna" ;
  cellsjok_nn_1 = mkN "cellsjok" neutrum ;
  cellskikt_nn_1 = mkN "cellskikt" neutrum ;
  cellspaenning_nn_1 = mkN "cellspдnning" ;
  cellstraff_nn_1 = mkN "cellstraff" neutrum ;
  cellstruktur_nn_1 = mkN "cellstruktur" "cellstrukturer" ;
  celltraad_nn_1 = mkN "celltrеd" ;
  celltyp_nn_1 = mkN "celltyp" "celltyper" ;
  cellulaer_av_1 = mkA "cellulдr" ;
  cellulosaindustri_nn_1 = mkN "cellulosaindustri" "cellulosaindustrier" ;
  cellulosalack_nn_1 = mkN "cellulosalack" neutrum ;
  cellulosamolekyl_nn_1 = mkN "cellulosamolekyl" "cellulosamolekyler" ;
  cellulosanitrat_nn_1 = mkN "cellulosanitrat" neutrum ;
  cellulosaplast_nn_1 = mkN "cellulosaplast" "cellulosaplaster" ;
  cellvaegg_nn_1 = mkN "cellvдgg" ;
  celsiusgrad_nn_1 = mkN "celsiusgrad" "celsiusgrader" ;
  celsiustermometer_nn_1 = mkN "celsiustermometer" ;
  celt_nn_1 = mkN "celt" "celter" ;
  cembalist_nn_1 = mkN "cembalist" "cembalister" ;
  cembalo_nn_1 = mkN "cembalo" "cembalor" ;
  cementblandare_nn_1 = mkN "cementblandare" "cementblandare" ;
  cementering_nn_1 = mkN "cementering" ;
  cenakel_nn_1 = mkN "cenakel" neutrum ;
  cendre_av_1 = mkA "cendrй" ;
  censor_nn_1 = mkN "censor" "censorer" ;
  census_nn_1 = mkN "census" ;
  cent_nn_1 = mkN "cent" "centen" "cent" "centen" ;
  centaur_nn_1 = mkN "centaur" "centaurer" ;
  center_nn_1 = mkN "center" ;
  center_nn_2 = mkN "center" "centret" "centrer" "centrerna" ;
  centerback_nn_1 = mkN "centerback" ;
  centerbord_nn_1 = mkN "centerbord" neutrum ;
  centerforward_nn_1 = mkN "centerforward" ;
  centerhalv_nn_1 = mkN "centerhalv" ;
  centerparti_nn_1 = mkN "centerparti" "centerpartit" "centerpartier" "centerpartierna" ;
  centerpartist_nn_1 = mkN "centerpartist" "centerpartister" ;
  centiliter_nn_1 = mkN "centiliter" "centilitern" "centiliter" "centiliterna" ;
  centilong_nn_1 = mkN "centilong" "centilongen" "centilong" "centilongen" ;
  centimeter_nn_1 = mkN "centimeter" ;
  centner_nn_1 = mkN "centner" "centnern" "centner" "centnerna" ;
  central_av_1 = mkA "central" ;
  centralafrikan_nn_1 = mkN "centralafrikan" "centralafrikaner" ;
  centralafrikansk_av_1 = mkA "centralafrikansk" ;
  centralamerikansk_av_1 = mkA "centralamerikansk" ;
  centralanstalt_nn_1 = mkN "centralanstalt" "centralanstalter" ;
  centralantenn_nn_1 = mkN "centralantenn" "centralantenner" ;
  centralbank_nn_1 = mkN "centralbank" "centralbanker" ;
  centralbyggnad_nn_1 = mkN "centralbyggnad" "centralbyggnader" ;
  centralbyraa_nn_1 = mkN "centralbyrе" "centralbyrеer" ;
  centralenhet_nn_1 = mkN "centralenhet" "centralenheter" ;
  centraleuropeisk_av_1 = mkA "centraleuropeisk" ;
  centralfoerbund_nn_1 = mkN "centralfцrbund" neutrum ;
  centralfoervaltning_nn_1 = mkN "centralfцrvaltning" ;
  centralgestalt_nn_1 = mkN "centralgestalt" "centralgestalter" ;
  centralisering_nn_1 = mkN "centralisering" ;
  centralistisk_av_1 = mkA "centralistisk" ;
  centralkommitte_nn_1 = mkN "centralkommittй" "centralkommittйer" ;
  centralkontor_nn_1 = mkN "centralkontor" neutrum ;
  centralkyrka_nn_1 = mkN "centralkyrka" ;
  centrallasarett_nn_1 = mkN "centrallasarett" neutrum ;
  centrallyrisk_av_1 = mkA "centrallyrisk" ;
  centralmakt_nn_1 = mkN "centralmakt" "centralmakter" ;
  centralnaemnd_nn_1 = mkN "centralnдmnd" "centralnдmnder" ;
  centralorganisation_nn_1 = mkN "centralorganisation" "centralorganisationer" ;
  centralort_nn_1 = mkN "centralort" "centralorter" ;
  centralregering_nn_1 = mkN "centralregering" ;
  centralroerelse_nn_1 = mkN "centralrцrelse" "centralrцrelser" ;
  centralstation_nn_1 = mkN "centralstation" "centralstationer" ;
  centralstimulantia_nn_1 = mkN "centralstimulantia" "centralstimulantian" "centralstimulantia" "centralstimulantiana" ;
  centralstimulerande_av_1 = mkA "centralstimulerande" ;
  centralstyrd_av_1 = mkA "centralstyrd" "centralstyrt" ;
  centralstyrelse_nn_1 = mkN "centralstyrelse" "centralstyrelser" ;
  centrifug_nn_1 = mkN "centrifug" "centrifuger" ;
  centrifugal_av_1 = mkA "centrifugal" ;
  centrifugalpump_nn_1 = mkN "centrifugalpump" ;
  centripetal_av_1 = mkA "centripetal" ;
  centrisk_av_1 = mkA "centrisk" ;
  centrum_nn_1 = mkN "centrum" neutrum ;
  centumspraak_nn_1 = mkN "centumsprеk" neutrum ;
  cerat_nn_1 = mkN "cerat" neutrum ;
  cerebral_av_1 = mkA "cerebral" ;
  cerebrospinal_av_1 = mkA "cerebrospinal" ;
  ceremoni_nn_1 = mkN "ceremoni" "ceremonier" ;
  ceremoniel_nn_1 = mkN "ceremoniel" "ceremonielet" "ceremoniel" "ceremonielen" ;
  ceremoniell_av_1 = mkA "ceremoniell" ;
  ceremonimaestare_nn_1 = mkN "ceremonimдstare" "ceremonimдstare" ;
  ceremonioes_av_1 = mkA "ceremoniцs" ;
  cerise_av_1 = mkA "cerise" ;
  cerise_nn_1 = mkN "cerise" "ceriser" ;
  cernering_nn_1 = mkN "cernering" ;
  cert_nn_1 = mkN "cert" "certer" ;
  certeparti_nn_1 = mkN "certeparti" "certepartit" "certepartier" "certepartierna" ;
  certifikat_nn_1 = mkN "certifikat" neutrum ;
  cesarisk_av_1 = mkA "cesarisk" ;
  cession_nn_1 = mkN "cession" "cessioner" ;
  cesur_nn_1 = mkN "cesur" "cesurer" ;
  champagneglas_nn_1 = mkN "champagneglas" neutrum ;
  champagnekork_nn_1 = mkN "champagnekork" ;
  champinjon_nn_1 = mkN "champinjon" "champinjoner" ;
  champinjonbaedd_nn_1 = mkN "champinjonbдdd" ;
  champion_nn_1 = mkN "champion" "championen" "champions" "championsen" ;
  championat_nn_1 = mkN "championat" neutrum ;
  changemang_nn_1 = mkN "changemang" neutrum ;
  chans_nn_1 = mkN "chans" "chanser" ;
  chansloes_av_1 = mkA "chanslцs" ;
  chansning_nn_1 = mkN "chansning" ;
  chanson_nn_1 = mkN "chanson" "chansoner" ;
  chansonett_nn_1 = mkN "chansonett" "chansonetter" ;
  chanstagare_nn_1 = mkN "chanstagare" "chanstagare" ;
  chanstagning_nn_1 = mkN "chanstagning" ;
  chapeau_claque_nn_1 = mkN "chapeau-claque" "chapeau-claquer" ;
  char_nn_1 = mkN "char" "charer" ;
  charabang_nn_1 = mkN "charabang" "charabanger" ;
  charad_nn_1 = mkN "charad" "charader" ;
  charge_d'27affaires_nn_1 = mkN "chargй-d'affaires" "chargй-d'affaireser" ;
  charge_nn_1 = mkN "charge" "charger" ;
  charkuteri_nn_1 = mkN "charkuteri" "charkuterit" "charkuterier" "charkuterierna" ;
  charkuterist_nn_1 = mkN "charkuterist" "charkuterister" ;
  charlatan_nn_1 = mkN "charlatan" "charlataner" ;
  charmant_av_1 = mkA "charmant" "charmant" ;
  charmfull_av_1 = mkA "charmfull" ;
  charmig_av_1 = mkA "charmig" ;
  charmkurs_nn_1 = mkN "charmkurs" "charmkurser" ;
  charmloes_av_1 = mkA "charmlцs" ;
  charmoer_nn_1 = mkN "charmцr" "charmцrer" ;
  charmoffensiv_nn_1 = mkN "charmoffensiv" "charmoffensiver" ;
  charmtroll_nn_1 = mkN "charmtroll" neutrum ;
  charner_nn_1 = mkN "charner" "charneret" "charner" "charneren" ;
  chartreuse_nn_1 = mkN "chartreuse" "chartreuser" ;
  chassi_nn_1 = mkN "chassi" "chassit" "chassier" "chassierna" ;
  chateaubriand_nn_1 = mkN "chateaubriand" "chateaubriander" ;
  chauffoer_nn_1 = mkN "chauffцr" "chauffцrer" ;
  chausse_nn_1 = mkN "chaussй" "chaussйer" ;
  chauvinist_nn_1 = mkN "chauvinist" "chauvinister" ;
  chauvinistisk_av_1 = mkA "chauvinistisk" ;
  check_nn_1 = mkN "check" ;
  checkhaefte_nn_1 = mkN "checkhдfte" ;
  checkkonto_nn_1 = mkN "checkkonto" "checkkontot" "checkkonton" "checkkontona" ;
  checkkredit_nn_1 = mkN "checkkredit" "checkkrediter" ;
  checkraekning_nn_1 = mkN "checkrдkning" ;
  cheddarost_nn_1 = mkN "cheddarost" ;
  chef_nn_1 = mkN "chef" "chefer" ;
  chefredaktoer_nn_1 = mkN "chefredaktцr" "chefredaktцrer" ;
  chefsideolog_nn_1 = mkN "chefsideolog" "chefsideologer" ;
  chefstjaensteman_nn_1 = mkN "chefstjдnsteman" "chefstjдnstemannen" "chefstjдnstemдn" "chefstjдnstemдnnen" ;
  chemis_nn_1 = mkN "chemis" "chemiser" ;
  chemisett_nn_1 = mkN "chemisett" "chemisetter" ;
  chevaleresk_av_1 = mkA "chevaleresk" ;
  chevelyr_nn_1 = mkN "chevelyr" "chevelyrer" ;
  cheviot_nn_1 = mkN "cheviot" "chevioter" ;
  chic_av_1 = mkA "chic" ;
  chiffer_nn_1 = mkN "chiffer" neutrum ;
  chiffernyckel_nn_1 = mkN "chiffernyckel" ;
  chiffong_nn_1 = mkN "chiffong" "chiffonger" ;
  chiffonje_nn_1 = mkN "chiffonjй" "chiffonjйer" ;
  chikan_nn_1 = mkN "chikan" "chikaner" ;
  chilen_nn_1 = mkN "chilen" "chilener" ;
  chilenare_nn_1 = mkN "chilenare" "chilenare" ;
  chilensk_av_1 = mkA "chilensk" ;
  chimaer_nn_1 = mkN "chimдr" "chimдrer" ;
  chinjong_nn_1 = mkN "chinjong" "chinjonger" ;
  chips_nn_1 = mkN "chips" neutrum ;
  chock_nn_1 = mkN "chock" "chocker" ;
  chockbehandling_nn_1 = mkN "chockbehandling" ;
  chockrosa_av_1 = mkA "chockrosa" ;
  choke_nn_1 = mkN "choke" utrum ;
  choklad_nn_1 = mkN "choklad" "choklader" ;
  chokladbit_nn_1 = mkN "chokladbit" ;
  chokladpudding_nn_1 = mkN "chokladpudding" ;
  chosefri_av_1 = mkA "chosefri" "chosefritt" ;
  chosig_av_1 = mkA "chosig" ;
  chuck_nn_1 = mkN "chuck" ;
  ciceron_nn_1 = mkN "ciceron" "ciceroner" ;
  cif_ab_1 = mkAdv "cif" ;
  cigarett_nn_1 = mkN "cigarett" "cigaretter" ;
  cigarettaendare_nn_1 = mkN "cigarettдndare" "cigarettдndare" ;
  cigarettfimp_nn_1 = mkN "cigarettfimp" ;
  cigarettpaket_nn_1 = mkN "cigarettpaket" neutrum ;
  cigarettroek_nn_1 = mkN "cigarettrцk" ;
  cigarill_nn_1 = mkN "cigarill" "cigariller" ;
  cigarr_nn_1 = mkN "cigarr" "cigarrer" ;
  cigarrcigarett_nn_1 = mkN "cigarrcigarett" "cigarrcigaretter" ;
  cigarrett_nn_1 = mkN "cigarrett" "cigarretter" ;
  cigarrettaendare_nn_1 = mkN "cigarrettдndare" "cigarrettдndare" ;
  cigarrettfimp_nn_1 = mkN "cigarrettfimp" ;
  cigarrettpaket_nn_1 = mkN "cigarrettpaket" neutrum ;
  ciklidfisk_nn_1 = mkN "ciklidfisk" ;
  ciliarkropp_nn_1 = mkN "ciliarkropp" ;
  ciliarmuskel_nn_1 = mkN "ciliarmuskel" "ciliarmuskeln" "ciliarmuskler" "ciliarmusklerna" ;
  cilie_nn_1 = mkN "cilie" "cilier" ;
  cineast_nn_1 = mkN "cineast" "cineaster" ;
  cinematek_nn_1 = mkN "cinematek" neutrum ;
  cirka_ab_1 = mkAdv "cirka" ;
  cirkapris_nn_1 = mkN "cirkapris" neutrum ;
  cirkel_nn_1 = mkN "cirkel" ;
  cirkelbaage_nn_1 = mkN "cirkelbеge" utrum ;
  cirkelben_nn_1 = mkN "cirkelben" neutrum ;
  cirkelbevis_nn_1 = mkN "cirkelbevis" neutrum ;
  cirkeldefinition_nn_1 = mkN "cirkeldefinition" "cirkeldefinitioner" ;
  cirkelledare_nn_1 = mkN "cirkelledare" "cirkelledare" ;
  cirkelperiferi_nn_1 = mkN "cirkelperiferi" "cirkelperiferier" ;
  cirkelprocess_nn_1 = mkN "cirkelprocess" "cirkelprocesser" ;
  cirkelroerelse_nn_1 = mkN "cirkelrцrelse" "cirkelrцrelser" ;
  cirkelrund_av_1 = mkA "cirkelrund" ;
  cirkelsaag_nn_1 = mkN "cirkelsеg" ;
  cirkelsegment_nn_1 = mkN "cirkelsegment" neutrum ;
  cirkelsektor_nn_1 = mkN "cirkelsektor" "cirkelsektorer" ;
  cirkelslut_nn_1 = mkN "cirkelslut" neutrum ;
  cirkulaer_av_1 = mkA "cirkulдr" ;
  cirkulaer_nn_1 = mkN "cirkulдr" neutrum ;
  cirkulaerledare_nn_1 = mkN "cirkulдrledare" "cirkulдrledare" ;
  cirkulationsplats_nn_1 = mkN "cirkulationsplats" "cirkulationsplatser" ;
  cirkulationspump_nn_1 = mkN "cirkulationspump" ;
  cirkulationsrubbning_nn_1 = mkN "cirkulationsrubbning" ;
  cirkumflex_nn_1 = mkN "cirkumflex" "cirkumflexer" ;
  cirkumpolaer_av_1 = mkA "cirkumpolдr" ;
  cirkumpolar_av_1 = mkA "cirkumpolar" ;
  cirkus_nn_1 = mkN "cirkus" ;
  cirkusarena_nn_1 = mkN "cirkusarena" ;
  cirkusartist_nn_1 = mkN "cirkusartist" "cirkusartister" ;
  cirkusdjur_nn_1 = mkN "cirkusdjur" neutrum ;
  cirkusmanege_nn_1 = mkN "cirkusmanege" "cirkusmaneger" ;
  cirkusnummer_nn_1 = mkN "cirkusnummer" neutrum ;
  cirrusmoln_nn_1 = mkN "cirrusmoln" neutrum ;
  cisalpinsk_av_1 = mkA "cisalpinsk" ;
  ciseloer_nn_1 = mkN "ciselцr" "ciselцrer" ;
  ciss_nn_1 = mkN "ciss" neutrum ;
  cissus_nn_1 = mkN "cissus" ;
  cisterciens_nn_1 = mkN "cisterciens" "cistercienser" ;
  cisterciensorden_nn_1 = mkN "cisterciensorden" ;
  cistern_nn_1 = mkN "cistern" "cisterner" ;
  citadell_nn_1 = mkN "citadell" neutrum ;
  citat_nn_1 = mkN "citat" neutrum ;
  citation_nn_1 = mkN "citation" "citationer" ;
  citationstecken_nn_1 = mkN "citationstecken" "citationstecknet" "citationstecken" "citationstecknen" ;
  citatord_nn_1 = mkN "citatord" neutrum ;
  citrin_nn_1 = mkN "citrin" "citriner" ;
  citron_nn_1 = mkN "citron" "citroner" ;
  citronfjaeril_nn_1 = mkN "citronfjдril" ;
  citrongul_av_1 = mkA "citrongul" ;
  citronlaesk_nn_1 = mkN "citronlдsk" "citronlдsken" "citronlдsk" "citronlдsken" ;
  citronskal_nn_1 = mkN "citronskal" neutrum ;
  citrus_nn_1 = mkN "citrus" ;
  citrusfrukt_nn_1 = mkN "citrusfrukt" "citrusfrukter" ;
  cittra_nn_1 = mkN "cittra" ;
  city_nn_1 = mkN "city" "cityt" "cityn" "cityna" ;
  citydress_nn_1 = mkN "citydress" ;
  civil_av_1 = mkA "civil" ;
  civilaektenskap_nn_1 = mkN "civilдktenskap" "civilдktenskapet" "civilдktenskapen" "civilдktenskapena" ;
  civilbegravning_nn_1 = mkN "civilbegravning" ;
  civilekonom_nn_1 = mkN "civilekonom" "civilekonomer" ;
  civilingenjoer_nn_1 = mkN "civilingenjцr" "civilingenjцrer" ;
  civilisation_nn_1 = mkN "civilisation" "civilisationer" ;
  civilisatorisk_av_1 = mkA "civilisatorisk" ;
  civilist_nn_1 = mkN "civilist" "civilister" ;
  civilklaedd_av_1 = mkA "civilklдdd" "civilklдdtt" ;
  civillag_nn_1 = mkN "civillag" ;
  civilmaal_nn_1 = mkN "civilmеl" neutrum ;
  civilmilitaer_av_1 = mkA "civilmilitдr" ;
  civilmilitaer_nn_1 = mkN "civilmilitдr" "civilmilitдrer" ;
  civilprocess_nn_1 = mkN "civilprocess" "civilprocesser" ;
  civilstaand_nn_1 = mkN "civilstеnd" neutrum ;
  civilstat_nn_1 = mkN "civilstat" "civilstater" ;
  clairobscur_nn_1 = mkN "clairobscur" "clairobscurer" ;
  clairvoyance_nn_1 = mkN "clairvoyance" "clairvoyancer" ;
  clairvoyant_av_1 = mkA "clairvoyant" "clairvoyant" ;
  clematis_nn_1 = mkN "clematis" ;
  clementin_nn_1 = mkN "clementin" "clementiner" ;
  clips_nn_1 = mkN "clips" neutrum ;
  clitoris_nn_1 = mkN "clitoris" ;
  cloisonvaegg_nn_1 = mkN "cloisonvдgg" ;
  cloque_nn_1 = mkN "cloquй" "cloquйer" ;
  clown_nn_1 = mkN "clown" "clowner" ;
  clowneri_nn_1 = mkN "clowneri" "clownerit" "clownerier" "clownerierna" ;
  club_blazer_nn_1 = mkN "club-blazer" ;
  clubstek_nn_1 = mkN "clubstek" ;
  coach_nn_1 = mkN "coach" "coacher" ;
  cockerspaniel_nn_1 = mkN "cockerspaniel" "cockerspanieln" "cockerspanielar" "cockerspanielarna" ;
  cockpit_nn_1 = mkN "cockpit" ;
  cocktail_nn_1 = mkN "cocktail" ;
  cocktailbaer_nn_1 = mkN "cocktailbдr" neutrum ;
  cocktailparty_nn_1 = mkN "cocktailparty" "cocktailpartyt" "cocktailpartyn" "cocktailpartyna" ;
  codex_nn_1 = mkN "codex" ;
  collage_nn_1 = mkN "collage" "collaget" "collage" "collagen" ;
  college_nn_1 = mkN "college" "colleget" "college" "collegen" ;
  collie_nn_1 = mkN "collie" "collien" "collies" "colliesen" ;
  collier_nn_1 = mkN "collier" "collierer" ;
  colombian_nn_1 = mkN "colombian" "colombianer" ;
  colombiansk_av_1 = mkA "colombiansk" ;
  colombianska_nn_1 = mkN "colombianska" ;
  come_back_nn_1 = mkN "come-back" "come-backer" ;
  comeback_nn_1 = mkN "comeback" "comebacker" ;
  commando_nn_1 = mkN "commando" "commandon" "commandos" "commandosen" ;
  commandotrupp_nn_1 = mkN "commandotrupp" "commandotrupper" ;
  comme_il_faut_ab_1 = mkAdv "comme-il-faut" ;
  comorier_nn_1 = mkN "comorier" "comoriern" "comorier" "comorierna" ;
  comorisk_av_1 = mkA "comorisk" ;
  conferencier_nn_1 = mkN "confйrencier" "confйrencierer" ;
  consomme_nn_1 = mkN "consommй" "consommйer" ;
  container_nn_1 = mkN "container" ;
  contortatall_nn_1 = mkN "contortatall" ;
  cool_av_1 = mkA "cool" ;
  copywriter_nn_1 = mkN "copywriter" "copywritern" "copywriters" "copywritersen" ;
  cornichon_nn_1 = mkN "cornichon" "cornichoner" ;
  coronacell_nn_1 = mkN "coronacell" "coronaceller" ;
  corps_de_logi_nn_1 = mkN "corps-de-logi" "corps-de-logit" "corps-de-logier" "corps-de-logierna" ;
  corpus_nn_1 = mkN "corpus" ;
  cortege_nn_1 = mkN "cortиge" "cortиger" ;
  cortical_av_1 = mkA "cortical" ;
  cortison_nn_1 = mkN "cortison" "cortisoner" ;
  cosinus_nn_1 = mkN "cosinus" ;
  costarican_nn_1 = mkN "costarican" "costaricaner" ;
  costaricansk_av_1 = mkA "costaricansk" ;
  cotangent_nn_1 = mkN "cotangent" "cotangenter" ;
  coulomb_nn_1 = mkN "coulomb" "coulomben" "coulomb" "coulomben" ;
  coupe_nn_1 = mkN "coupe" "couper" ;
  cowboy_nn_1 = mkN "cowboy" "cowboyen" "cowboyer" "cowboyerna" ;
  crazy_av_1 = mkA "crazy" ;
  credo_nn_1 = mkN "credo" "credot" "credon" "credona" ;
  creme_nn_1 = mkN "crиme" "crиmer" ;
  crepe_nn_1 = mkN "crepe" "crepen" "crepes" "crepesen" ;
  crescendo_ab_1 = mkAdv "crescendo" ;
  crescendo_nn_1 = mkN "crescendo" "crescendot" "crescendon" "crescendona" ;
  croissant_nn_1 = mkN "croissant" "croissanter" ;
  croquis_nn_1 = mkN "croquis" "croquiser" ;
  crosschecking_nn_1 = mkN "crosschecking" ;
  croupier_nn_1 = mkN "croupier" "croupierer" ;
  cuban_nn_1 = mkN "cuban" "cubaner" ;
  cubansk_av_1 = mkA "cubansk" ;
  cumulus_nn_1 = mkN "cumulus" ;
  cumuluscell_nn_1 = mkN "cumuluscell" "cumulusceller" ;
  cumulusmoln_nn_1 = mkN "cumulusmoln" neutrum ;
  cup_nn_1 = mkN "cup" "cuper" ;
  curie_nn_1 = mkN "curie" "curien" "curie" "curiena" ;
  cyanblaa_av_1 = mkA "cyanblе" "cyanblеtt" ;
  cyanid_nn_1 = mkN "cyanid" "cyanider" ;
  cyanobakterie_nn_1 = mkN "cyanobakterie" "cyanobakterier" ;
  cybernetisk_av_1 = mkA "cybernetisk" ;
  cykel_nn_1 = mkN "cykel" ;
  cykel_nn_2 = mkN "cykel" ;
  cykeldaeck_nn_1 = mkN "cykeldдck" neutrum ;
  cykelergometer_nn_1 = mkN "cykelergometer" ;
  cykelkedja_nn_1 = mkN "cykelkedja" ;
  cykelpump_nn_1 = mkN "cykelpump" ;
  cykelsadel_nn_1 = mkN "cykelsadel" ;
  cykelslang_nn_1 = mkN "cykelslang" ;
  cykelstaell_nn_1 = mkN "cykelstдll" neutrum ;
  cykelstyre_nn_1 = mkN "cykelstyre" ;
  cykeltaevling_nn_1 = mkN "cykeltдvling" ;
  cykeltrupp_nn_1 = mkN "cykeltrupp" "cykeltrupper" ;
  cykelventil_nn_1 = mkN "cykelventil" "cykelventiler" ;
  cyklamen_nn_1 = mkN "cyklamen" "cyklamen" "cyklamen" "cyklamena" ;
  cyklisk_av_1 = mkA "cyklisk" ;
  cyklist_nn_1 = mkN "cyklist" "cyklister" ;
  cykloid_nn_1 = mkN "cykloid" "cykloider" ;
  cyklometer_nn_1 = mkN "cyklometer" ;
  cyklon_nn_1 = mkN "cyklon" "cykloner" ;
  cyklonfamilj_nn_1 = mkN "cyklonfamilj" "cyklonfamiljer" ;
  cyklop_nn_1 = mkN "cyklop" "cykloper" ;
  cyklop_nn_2 = mkN "cyklop" neutrum ;
  cyklopoega_nn_1 = mkN "cyklopцga" "cyklopцgat" "cyklopцgon" "cyklopцgonen" ;
  cyklotron_nn_1 = mkN "cyklotron" "cyklotroner" ;
  cyklotym_av_1 = mkA "cyklotym" ;
  cylinder_nn_1 = mkN "cylinder" ;
  cylinderblock_nn_1 = mkN "cylinderblock" neutrum ;
  cylinderhatt_nn_1 = mkN "cylinderhatt" ;
  cylinderlaas_nn_1 = mkN "cylinderlеs" neutrum ;
  cylinderpress_nn_1 = mkN "cylinderpress" ;
  cylindrisk_av_1 = mkA "cylindrisk" ;
  cymbal_nn_1 = mkN "cymbal" "cymbaler" ;
  cyniker_nn_1 = mkN "cyniker" "cynikern" "cyniker" "cynikerna" ;
  cynisk_av_1 = mkA "cynisk" ;
  cynism_nn_1 = mkN "cynism" "cynismer" ;
  cypress_nn_1 = mkN "cypress" "cypresser" ;
  cypriot_nn_1 = mkN "cypriot" "cyprioter" ;
  cypriotisk_av_1 = mkA "cypriotisk" ;
  cystoskop_nn_1 = mkN "cystoskop" neutrum ;
  cystoskopi_nn_1 = mkN "cystoskopi" "cystoskopier" ;
  cytologisk_av_1 = mkA "cytologisk" ;
  daa_ab_1 = mkAdv "dе" ;
  daad_nn_1 = mkN "dеd" neutrum ;
  daadrafroe_nn_1 = mkN "dеdrafrц" "dеdrafrцet" "dеdrafrцer" "dеdrafrцerna" ;
  daafoertiden_ab_1 = mkAdv "dеfцrtiden" ;
  daalig_av_1 = mkA "dеlig" ;
  daalighet_nn_1 = mkN "dеlighet" "dеligheter" ;
  daamera_ab_1 = mkAdv "dеmera" ;
  daan_nn_1 = mkN "dеn" neutrum ;
  daandimpen_ab_1 = mkAdv "dеndimpen" ;
  daaraktig_av_1 = mkA "dеraktig" ;
  daare_nn_1 = mkN "dеre" utrum ;
  daarfink_nn_1 = mkN "dеrfink" ;
  daarhus_nn_1 = mkN "dеrhus" neutrum ;
  daarskap_nn_1 = mkN "dеrskap" "dеrskaper" ;
  daasig_av_1 = mkA "dеsig" ;
  daasighet_nn_1 = mkN "dеsighet" "dеsigheter" ;
  daatida_av_1 = mkA "dеtida" ;
  daavarande_av_1 = mkA "dеvarande" ;
  dadaist_nn_1 = mkN "dadaist" "dadaister" ;
  dadaistisk_av_1 = mkA "dadaistisk" ;
  dadel_nn_1 = mkN "dadel" ;
  dadelpalm_nn_1 = mkN "dadelpalm" "dadelpalmer" ;
  daeck_nn_1 = mkN "dдck" neutrum ;
  daeckel_nn_1 = mkN "dдckel" ;
  daecker_nn_1 = mkN "dдcker" neutrum ;
  daeckslast_nn_1 = mkN "dдckslast" "dдckslaster" ;
  daecksmanskap_nn_1 = mkN "dдcksmanskap" "dдcksmanskapet" "dдcksmanskapen" "dдcksmanskapena" ;
  daedan_ab_1 = mkAdv "dдdan" ;
  daeggdjur_nn_1 = mkN "dдggdjur" neutrum ;
  daeggdjursgrupp_nn_1 = mkN "dдggdjursgrupp" "dдggdjursgrupper" ;
  daeggdjurstand_nn_1 = mkN "dдggdjurstand" "dдggdjurstдnder" ;
  daeggdjurstyp_nn_1 = mkN "dдggdjurstyp" "dдggdjurstyper" ;
  daeggdjursunge_nn_1 = mkN "dдggdjursunge" utrum ;
  daeld_nn_1 = mkN "dдld" "dдlder" ;
  daemmare_nn_1 = mkN "dдmmare" "dдmmare" ;
  daemme_nn_1 = mkN "dдmme" ;
  daemning_nn_1 = mkN "dдmning" ;
  daempare_nn_1 = mkN "dдmpare" "dдmpare" ;
  daempbox_nn_1 = mkN "dдmpbox" ;
  daempning_nn_1 = mkN "dдmpning" ;
  daen_ab_1 = mkAdv "dдn" ;
  daer_ab_1 = mkAdv "dдr" ;
  daeraat_ab_1 = mkAdv "dдrеt" ;
  daerav_ab_1 = mkAdv "dдrav" ;
  daerborta_ab_1 = mkAdv "dдrborta" ;
  daerefter_ab_1 = mkAdv "dдrefter" ;
  daeremellan_ab_1 = mkAdv "dдremellan" ;
  daeremot_ab_1 = mkAdv "dдremot" ;
  daerfoer_ab_1 = mkAdv "dдrfцr" ;
  daerfoere_ab_1 = mkAdv "dдrfцre" ;
  daerfoerinnan_ab_1 = mkAdv "dдrfцrinnan" ;
  daerfoerutan_ab_1 = mkAdv "dдrfцrutan" ;
  daerhaen_ab_1 = mkAdv "dдrhдn" ;
  daerhemma_ab_1 = mkAdv "dдrhemma" ;
  daeri_ab_1 = mkAdv "dдri" ;
  daeribland_ab_1 = mkAdv "dдribland" ;
  daerifraan_ab_1 = mkAdv "dдrifrеn" ;
  daerigenom_ab_1 = mkAdv "dдrigenom" ;
  daerinne_ab_1 = mkAdv "dдrinne" ;
  daerjaemte_ab_1 = mkAdv "dдrjдmte" ;
  daermed_ab_1 = mkAdv "dдrmed" ;
  daernaest_ab_1 = mkAdv "dдrnдst" ;
  daernedanfoer_ab_1 = mkAdv "dдrnedanfцr" ;
  daernere_ab_1 = mkAdv "dдrnere" ;
  daeroever_ab_1 = mkAdv "dдrцver" ;
  daerom_ab_1 = mkAdv "dдrom" ;
  daerpaa_ab_1 = mkAdv "dдrpе" ;
  daerstaedes_ab_1 = mkAdv "dдrstдdes" ;
  daertill_ab_1 = mkAdv "dдrtill" ;
  daerunder_ab_1 = mkAdv "dдrunder" ;
  daeruppe_ab_1 = mkAdv "dдruppe" ;
  daerutav_ab_1 = mkAdv "dдrutav" ;
  daerute_ab_1 = mkAdv "dдrute" ;
  daerutinnan_ab_1 = mkAdv "dдrutinnan" ;
  daerutoever_ab_1 = mkAdv "dдrutцver" ;
  daervid_ab_1 = mkAdv "dдrvid" ;
  daervidlag_ab_1 = mkAdv "dдrvidlag" ;
  daest_av_1 = mkA "dдst" "dдst" ;
  daeven_av_1 = mkA "dдven" "dдvet" ;
  daevert_nn_1 = mkN "dдvert" ;
  daexel_nn_1 = mkN "dдxel" ;
  dag_nn_1 = mkN "dag" ;
  dagakarl_nn_1 = mkN "dagakarl" ;
  dagaktiv_av_1 = mkA "dagaktiv" ;
  dagavdelning_nn_1 = mkN "dagavdelning" ;
  dagbarn_nn_1 = mkN "dagbarn" neutrum ;
  dagbarnvaardare_nn_1 = mkN "dagbarnvеrdare" "dagbarnvеrdare" ;
  dagbefael_nn_1 = mkN "dagbefдl" neutrum ;
  dagblad_nn_1 = mkN "dagblad" neutrum ;
  dagblind_av_1 = mkA "dagblind" ;
  dagbok_nn_1 = mkN "dagbok" "dagbцcker" ;
  dagbraeckning_nn_1 = mkN "dagbrдckning" ;
  dagbrott_nn_1 = mkN "dagbrott" neutrum ;
  dagbrytning_nn_1 = mkN "dagbrytning" ;
  dagcentral_nn_1 = mkN "dagcentral" "dagcentraler" ;
  dagcentrum_nn_1 = mkN "dagcentrum" neutrum ;
  dagdjur_nn_1 = mkN "dagdjur" neutrum ;
  dagdrivare_nn_1 = mkN "dagdrivare" "dagdrivare" ;
  dagdroem_nn_1 = mkN "dagdrцm" "dagdrцmmen" "dagdrцmmar" "dagdrцmmarna" ;
  dagdroemmare_nn_1 = mkN "dagdrцmmare" "dagdrцmmare" ;
  dagdroemmeri_nn_1 = mkN "dagdrцmmeri" "dagdrцmmerit" "dagdrцmmerier" "dagdrцmmerierna" ;
  dagenefterstaemning_nn_1 = mkN "dagenefterstдmning" ;
  dager_nn_1 = mkN "dager" ;
  dagerrotyp_nn_1 = mkN "dagerrotyp" "dagerrotyper" ;
  dagerrotypi_nn_1 = mkN "dagerrotypi" "dagerrotypier" ;
  dagfjaeril_nn_1 = mkN "dagfjдril" ;
  dagg_nn_2 = mkN "dagg" ;
  daggdroppe_nn_1 = mkN "daggdroppe" utrum ;
  daggert_nn_1 = mkN "daggert" ;
  daggfrisk_av_1 = mkA "daggfrisk" ;
  daggig_av_1 = mkA "daggig" ;
  daggmask_nn_1 = mkN "daggmask" ;
  daggpunkt_nn_1 = mkN "daggpunkt" "daggpunkter" ;
  daghavande_av_1 = mkA "daghavande" ;
  daghavande_nn_1 = mkN "daghavande" "daghavanden" "daghavande" "daghavandena" ;
  daghem_nn_1 = mkN "daghem" "daghemmet" "daghem" "daghemmen" ;
  dagis_nn_1 = mkN "dagis" neutrum ;
  dagkarl_nn_1 = mkN "dagkarl" ;
  daglig_av_1 = mkA "daglig" ;
  dagligdags_ab_1 = mkAdv "dagligdags" ;
  dagligen_ab_1 = mkAdv "dagligen" ;
  dagligstuga_nn_1 = mkN "dagligstuga" ;
  dagloen_nn_1 = mkN "daglцn" "daglцner" ;
  dagloenare_nn_1 = mkN "daglцnare" "daglцnare" ;
  dagmamma_nn_1 = mkN "dagmamma" ;
  dago_nn_1 = mkN "dago" "dagon" "dagos" "dagosen" ;
  dagoeppning_nn_1 = mkN "dagцppning" ;
  dagofficer_nn_1 = mkN "dagofficer" "dagofficern" "dagofficerare" "dagofficerarna" ;
  dagorder_nn_1 = mkN "dagorder" ;
  dagordning_nn_1 = mkN "dagordning" ;
  dagort_nn_1 = mkN "dagort" "dagorter" ;
  dagpenning_nn_1 = mkN "dagpenning" ;
  dagrum_nn_1 = mkN "dagrum" "dagrummet" "dagrum" "dagrummen" ;
  dags_ab_1 = mkAdv "dags" ;
  dagsaktuell_av_1 = mkA "dagsaktuell" ;
  dagsbehov_nn_1 = mkN "dagsbehov" neutrum ;
  dagsbot_nn_1 = mkN "dagsbot" "dagsbцter" ;
  dagsedel_nn_1 = mkN "dagsedel" ;
  dagsens_av_1 = mkA "dagsens" ;
  dagskassa_nn_1 = mkN "dagskassa" ;
  dagsled_nn_1 = mkN "dagsled" "dagsleder" ;
  dagsmarsch_nn_1 = mkN "dagsmarsch" "dagsmarscher" ;
  dagsranson_nn_1 = mkN "dagsranson" "dagsransoner" ;
  dagstemperatur_nn_1 = mkN "dagstemperatur" "dagstemperaturer" ;
  dagstidning_nn_1 = mkN "dagstidning" ;
  dagsverkare_nn_1 = mkN "dagsverkare" "dagsverkare" ;
  dagtid_nn_1 = mkN "dagtid" "dagtider" ;
  dagtraktamente_nn_1 = mkN "dagtraktamente" ;
  dagvatten_nn_1 = mkN "dagvatten" "dagvattnet" "dagvatten" "dagvattnen" ;
  dakapo_ab_1 = mkAdv "dakapo" ;
  dakapo_nn_1 = mkN "dakapo" "dakapot" "dakapon" "dakapona" ;
  daktyl_nn_1 = mkN "daktyl" "daktyler" ;
  daktylisk_av_1 = mkA "daktylisk" ;
  dal_nn_1 = mkN "dal" ;
  dalahaest_nn_1 = mkN "dalahдst" ;
  dalbo_nn_1 = mkN "dalbo" "dalbor" ;
  dalbotten_nn_1 = mkN "dalbotten" ;
  daldans_nn_1 = mkN "daldans" "daldanser" ;
  daler_nn_1 = mkN "daler" "dalern" "daler" "dalerna" ;
  dalgaang_nn_1 = mkN "dalgеng" ;
  dalkarl_nn_1 = mkN "dalkarl" ;
  dallring_nn_1 = mkN "dallring" ;
  dalmaal_nn_1 = mkN "dalmеl" neutrum ;
  dalmaalning_nn_1 = mkN "dalmеlning" ;
  dalmas_nn_1 = mkN "dalmas" ;
  dalmatiner_nn_1 = mkN "dalmatiner" "dalmatinern" "dalmatiner" "dalmatinerna" ;
  dalprofil_nn_1 = mkN "dalprofil" "dalprofiler" ;
  dalsk_av_1 = mkA "dalsk" ;
  dalslaendsk_av_1 = mkA "dalslдndsk" ;
  dalslaenning_nn_1 = mkN "dalslдnning" ;
  dalsluttning_nn_1 = mkN "dalsluttning" ;
  dalvind_nn_1 = mkN "dalvind" ;
  dam_nn_1 = mkN "dam" "damer" ;
  damask_nn_1 = mkN "damask" "damasker" ;
  damast_nn_1 = mkN "damast" "damaster" ;
  dambesoek_nn_1 = mkN "dambesцk" neutrum ;
  dambjudning_nn_1 = mkN "dambjudning" ;
  damcykel_nn_1 = mkN "damcykel" ;
  damejeanne_nn_1 = mkN "damejeanne" "damejeanner" ;
  damfrisering_nn_1 = mkN "damfrisering" ;
  damfrisoer_nn_1 = mkN "damfrisцr" "damfrisцrer" ;
  damfrisoerska_nn_1 = mkN "damfrisцrska" ;
  damgambit_nn_1 = mkN "damgambit" ;
  damhatt_nn_1 = mkN "damhatt" ;
  damig_av_1 = mkA "damig" ;
  damkoer_nn_1 = mkN "damkцr" "damkцrer" ;
  damm_nn_1 = mkN "damm" ;
  dammanlaeggning_nn_1 = mkN "dammanlдggning" ;
  dammbindningsmedel_nn_1 = mkN "dammbindningsmedel" neutrum ;
  dammfoersoek_nn_1 = mkN "dammfцrsцk" neutrum ;
  dammig_av_1 = mkA "dammig" ;
  dammkorn_nn_1 = mkN "dammkorn" neutrum ;
  dammoln_nn_1 = mkN "dammoln" neutrum ;
  dammport_nn_1 = mkN "dammport" ;
  dammsuga_vb_1 = mkV "dammsuga" "dammsцg" "dammsugit" ;
  dammsugare_nn_1 = mkN "dammsugare" "dammsugare" ;
  dammussla_nn_1 = mkN "dammussla" ;
  damoklessvaerd_nn_1 = mkN "damoklessvдrd" neutrum ;
  damrum_nn_1 = mkN "damrum" "damrummet" "damrum" "damrummen" ;
  damsida_nn_1 = mkN "damsida" ;
  damspel_nn_1 = mkN "damspel" "damspelet" "damspel" "damspelen" ;
  damtidning_nn_1 = mkN "damtidning" ;
  dan_av_1 = mkA "dan" ;
  danaarv_nn_1 = mkN "danaarv" neutrum ;
  dandy_nn_1 = mkN "dandy" "dandyn" "dandies" "dandyerna" ;
  daning_nn_1 = mkN "daning" ;
  danism_nn_1 = mkN "danism" "danismer" ;
  dank_ab_1 = mkAdv "dank" ;
  dank_nn_1 = mkN "dank" ;
  danneman_nn_1 = mkN "danneman" "dannemannen" "dannemдn" "dannemдnnen" ;
  dans_nn_1 = mkN "dans" "danser" ;
  dansant_av_1 = mkA "dansant" "dansant" ;
  dansare_nn_1 = mkN "dansare" "dansare" ;
  dansgolv_nn_1 = mkN "dansgolv" neutrum ;
  danshak_nn_1 = mkN "danshak" neutrum ;
  dansk_av_1 = mkA "dansk" ;
  dansk_nn_1 = mkN "dansk" ;
  danska_nn_2 = mkN "danska" ;
  danskonst_nn_1 = mkN "danskonst" "danskonster" ;
  danslek_nn_1 = mkN "danslek" ;
  dansoer_nn_1 = mkN "dansцr" "dansцrer" ;
  dansoes_nn_1 = mkN "dansцs" "dansцser" ;
  dansrestaurang_nn_1 = mkN "dansrestaurang" "dansrestauranger" ;
  dansstaelle_nn_1 = mkN "dansstдlle" ;
  danssteg_nn_1 = mkN "danssteg" neutrum ;
  danstillstaellning_nn_1 = mkN "danstillstдllning" ;
  darraal_nn_1 = mkN "darrеl" ;
  darrhaent_av_1 = mkA "darrhдnt" "darrhдnt" ;
  darrig_av_1 = mkA "darrig" ;
  darrning_nn_1 = mkN "darrning" ;
  darwinfink_nn_1 = mkN "darwinfink" ;
  darwinist_nn_1 = mkN "darwinist" "darwinister" ;
  darwinistisk_av_1 = mkA "darwinistisk" ;
  daskig_av_1 = mkA "daskig" ;
  dass_nn_1 = mkN "dass" neutrum ;
  dassig_av_1 = mkA "dassig" ;
  dat_nn_1 = mkN "dat" "dater" ;
  data_nn_1 = mkN "data" "datan" "data" "datana" ;
  dataanlaeggning_nn_1 = mkN "dataanlдggning" ;
  databank_nn_1 = mkN "databank" "databanker" ;
  databas_nn_1 = mkN "databas" "databaser" ;
  databehandling_nn_1 = mkN "databehandling" ;
  datacentral_nn_1 = mkN "datacentral" "datacentraler" ;
  datafil_nn_1 = mkN "datafil" "datafiler" ;
  datakoerning_nn_1 = mkN "datakцrning" ;
  datakommunikation_nn_1 = mkN "datakommunikation" "datakommunikationer" ;
  datamaengd_nn_1 = mkN "datamдngd" "datamдngder" ;
  datamaskin_nn_1 = mkN "datamaskin" "datamaskiner" ;
  datamaskinell_av_1 = mkA "datamaskinell" ;
  dataminne_nn_1 = mkN "dataminne" ;
  dataprogram_nn_1 = mkN "dataprogram" "dataprogrammet" "dataprogram" "dataprogrammen" ;
  dataregister_nn_1 = mkN "dataregister" neutrum ;
  dataskaerm_nn_1 = mkN "dataskдrm" ;
  dataspel_nn_1 = mkN "dataspel" "dataspelet" "dataspel" "dataspelen" ;
  datering_nn_1 = mkN "datering" ;
  dativ_nn_1 = mkN "dativ" "dativer" ;
  dativobjekt_nn_1 = mkN "dativobjekt" neutrum ;
  dator_nn_1 = mkN "dator" "datorer" ;
  datoranlaeggning_nn_1 = mkN "datoranlдggning" ;
  datorbehandling_nn_1 = mkN "datorbehandling" ;
  datorberaekning_nn_1 = mkN "datorberдkning" ;
  datorminne_nn_1 = mkN "datorminne" ;
  datormodell_nn_1 = mkN "datormodell" "datormodeller" ;
  datorprogrammerare_nn_1 = mkN "datorprogrammerare" "datorprogrammerare" ;
  datovaexel_nn_1 = mkN "datovдxel" ;
  datum_nn_1 = mkN "datum" ;
  datumgraens_nn_1 = mkN "datumgrдns" "datumgrдnser" ;
  datumparkering_nn_1 = mkN "datumparkering" ;
  debacle_nn_1 = mkN "debacle" "debaclet" "debacle" "debaclen" ;
  debatt_nn_1 = mkN "debatt" "debatter" ;
  debattinlaegg_nn_1 = mkN "debattinlдgg" neutrum ;
  debattoer_nn_1 = mkN "debattцr" "debattцrer" ;
  debetsedel_nn_1 = mkN "debetsedel" ;
  debetsida_nn_1 = mkN "debetsida" ;
  debil_av_1 = mkA "debil" ;
  debilitet_nn_1 = mkN "debilitet" "debiliteter" ;
  debit_nn_1 = mkN "debit" "debiter" ;
  debitering_nn_1 = mkN "debitering" ;
  debut_nn_1 = mkN "debut" "debuter" ;
  debutant_nn_1 = mkN "debutant" "debutanter" ;
  debutbok_nn_1 = mkN "debutbok" "debutbцcker" ;
  debutroman_nn_1 = mkN "debutroman" "debutromaner" ;
  decennium_nn_1 = mkN "decennium" "decenniet" "decennier" "decennierna" ;
  decentralisation_nn_1 = mkN "decentralisation" "decentralisationer" ;
  decentralisering_nn_1 = mkN "decentralisering" ;
  decharge_nn_1 = mkN "decharge" "decharger" ;
  dechargedebatt_nn_1 = mkN "dechargedebatt" "dechargedebatter" ;
  decibel_nn_1 = mkN "decibel" "decibelen" "decibel" "decibelen" ;
  deciliter_nn_1 = mkN "deciliter" "decilitern" "deciliter" "deciliterna" ;
  decilitermaatt_nn_1 = mkN "decilitermеtt" neutrum ;
  decimal_nn_1 = mkN "decimal" "decimaler" ;
  decimalbraak_nn_1 = mkN "decimalbrеk" neutrum ;
  decimalkomma_nn_1 = mkN "decimalkomma" "decimalkommat" "decimalkomman" "decimalkommana" ;
  decimalsystem_nn_1 = mkN "decimalsystem" neutrum ;
  decimaltal_nn_1 = mkN "decimaltal" "decimaltalet" "decimaltalen" "decimaltalena" ;
  decimeter_nn_1 = mkN "decimeter" ;
  deckare_nn_1 = mkN "deckare" "deckare" ;
  dedikation_nn_1 = mkN "dedikation" "dedikationer" ;
  dedikationsexemplar_nn_1 = mkN "dedikationsexemplar" neutrum ;
  deduktion_nn_1 = mkN "deduktion" "deduktioner" ;
  deduktiv_av_1 = mkA "deduktiv" ;
  defaitist_nn_1 = mkN "defaitist" "defaitister" ;
  defaitistisk_av_1 = mkA "defaitistisk" ;
  defekt_av_1 = mkA "defekt" "defekt" ;
  defekt_nn_1 = mkN "defekt" "defekter" ;
  defensiv_av_1 = mkA "defensiv" ;
  deficit_nn_1 = mkN "deficit" neutrum ;
  defile_nn_1 = mkN "defilй" "defilйer" ;
  defilering_nn_1 = mkN "defilering" ;
  definierbar_av_1 = mkA "definierbar" ;
  definit_av_1 = mkA "definit" "definit" ;
  definition_nn_1 = mkN "definition" "definitioner" ;
  definitionsmaengd_nn_1 = mkN "definitionsmдngd" "definitionsmдngder" ;
  definitionsmaessig_av_1 = mkA "definitionsmдssig" ;
  definitiv_av_1 = mkA "definitiv" ;
  deflagration_nn_1 = mkN "deflagration" "deflagrationer" ;
  defloration_nn_1 = mkN "defloration" "deflorationer" ;
  deformation_nn_1 = mkN "deformation" "deformationer" ;
  deformering_nn_1 = mkN "deformering" ;
  deformitet_nn_1 = mkN "deformitet" "deformiteter" ;
  defroster_nn_1 = mkN "defroster" ;
  deg_nn_1 = mkN "deg" ;
  degel_nn_1 = mkN "degel" ;
  degenerativ_av_1 = mkA "degenerativ" ;
  degig_av_1 = mkA "degig" ;
  dego_nn_1 = mkN "dego" "degon" "degos" "degosen" ;
  degradation_nn_1 = mkN "degradation" "degradationer" ;
  degrand_nn_1 = mkN "degrand" "degrдnder" ;
  degression_nn_1 = mkN "degression" "degressioner" ;
  deiktisk_av_1 = mkA "deiktisk" ;
  deist_nn_1 = mkN "deist" "deister" ;
  deistisk_av_1 = mkA "deistisk" ;
  dejlig_av_1 = mkA "dejlig" ;
  dekad_nn_1 = mkN "dekad" "dekader" ;
  dekadent_av_1 = mkA "dekadent" "dekadent" ;
  dekadisk_av_1 = mkA "dekadisk" ;
  dekal_nn_1 = mkN "dekal" "dekaler" ;
  dekan_nn_1 = mkN "dekan" "dekaner" ;
  deklamation_nn_1 = mkN "deklamation" "deklamationer" ;
  deklamatoer_nn_1 = mkN "deklamatцr" "deklamatцrer" ;
  deklamatorisk_av_1 = mkA "deklamatorisk" ;
  deklarant_nn_1 = mkN "deklarant" "deklaranter" ;
  deklaration_nn_1 = mkN "deklaration" "deklarationer" ;
  deklarationsblankett_nn_1 = mkN "deklarationsblankett" "deklarationsblanketter" ;
  deklination_nn_1 = mkN "deklination" "deklinationer" ;
  deklinationsnaal_nn_1 = mkN "deklinationsnеl" ;
  dekokt_nn_1 = mkN "dekokt" "dekokter" ;
  dekolletage_nn_1 = mkN "dekolletage" "dekolletaget" "dekolletage" "dekolletagen" ;
  dekolletering_nn_1 = mkN "dekolletering" ;
  dekor_nn_1 = mkN "dekor" "dekoren" "dekorer" "dekorerna" ;
  dekoration_nn_1 = mkN "dekoration" "dekorationer" ;
  dekorationslist_nn_1 = mkN "dekorationslist" "dekorationslister" ;
  dekorativ_av_1 = mkA "dekorativ" ;
  dekoratoer_nn_1 = mkN "dekoratцr" "dekoratцrer" ;
  dekret_nn_1 = mkN "dekret" neutrum ;
  del_nn_1 = mkN "del" "delen" "delar" "delarna" ;
  delaegare_nn_1 = mkN "delдgare" "delдgare" ;
  delaktig_av_1 = mkA "delaktig" ;
  delaktighet_nn_1 = mkN "delaktighet" "delaktigheter" ;
  delbar_av_1 = mkA "delbar" ;
  delbetalning_nn_1 = mkN "delbetalning" ;
  delegat_nn_1 = mkN "delegat" "delegater" ;
  delegation_nn_1 = mkN "delegation" "delegationer" ;
  delegering_nn_1 = mkN "delegering" ;
  delfin_nn_1 = mkN "delfin" "delfiner" ;
  delge_vb_1 = mkV "delge" "delger" "delge" "delgav" "delgett" "delgiven" ;
  delgivning_nn_1 = mkN "delgivning" ;
  delicioes_av_1 = mkA "deliciцs" ;
  delikat_av_1 = mkA "delikat" "delikat" ;
  delikatess_nn_1 = mkN "delikatess" "delikatesser" ;
  delikt_nn_1 = mkN "delikt" neutrum ;
  delinkvent_nn_1 = mkN "delinkvent" "delinkventer" ;
  delirant_nn_1 = mkN "delirant" "deliranter" ;
  dellikvid_nn_1 = mkN "dellikvid" "dellikvider" ;
  delmaengd_nn_1 = mkN "delmдngd" "delmдngder" ;
  delning_nn_1 = mkN "delning" ;
  delperiod_nn_1 = mkN "delperiod" "delperioder" ;
  delprojekt_nn_1 = mkN "delprojekt" neutrum ;
  delrepublik_nn_1 = mkN "delrepublik" "delrepubliker" ;
  dels_ab_1 = mkAdv "dels" ;
  delstat_nn_1 = mkN "delstat" "delstater" ;
  delstreck_nn_1 = mkN "delstreck" neutrum ;
  delta_nn_1 = mkN "delta" "deltat" "deltan" "deltana" ;
  delta_vb_1 = mkV "delta" "deltar" "delta" "deltog" "deltagit" "deltagen" ;
  deltagande_av_1 = mkA "deltagande" ;
  deltagare_nn_1 = mkN "deltagare" "deltagare" ;
  deltamuskel_nn_1 = mkN "deltamuskel" "deltamuskeln" "deltamuskler" "deltamusklerna" ;
  deltavinge_nn_1 = mkN "deltavinge" utrum ;
  deltid_nn_1 = mkN "deltid" "deltider" ;
  deltidare_nn_1 = mkN "deltidare" "deltidare" ;
  deltidsanstaelld_av_1 = mkA "deltidsanstдlld" "deltidsanstдllt" ;
  delvis_ab_1 = mkAdv "delvis" ;
  delvis_av_1 = mkA "delvis" ;
  demagog_nn_1 = mkN "demagog" "demagoger" ;
  demagogisk_av_1 = mkA "demagogisk" ;
  demarkationslinje_nn_1 = mkN "demarkationslinje" "demarkationslinjer" ;
  demarsch_nn_1 = mkN "demarsch" "demarscher" ;
  dementi_nn_1 = mkN "dementi" "dementier" ;
  demeriterande_av_1 = mkA "demeriterande" ;
  demimond_nn_1 = mkN "demimond" "demimonder" ;
  demission_nn_1 = mkN "demission" "demissioner" ;
  demiurg_nn_1 = mkN "demiurg" "demiurger" ;
  demografisk_av_1 = mkA "demografisk" ;
  demoinspelning_nn_1 = mkN "demoinspelning" ;
  demokrat_nn_1 = mkN "demokrat" "demokrater" ;
  demokrati_nn_1 = mkN "demokrati" "demokratier" ;
  demokratisk_av_1 = mkA "demokratisk" ;
  demon_nn_1 = mkN "demon" "demoner" ;
  demonisk_av_1 = mkA "demonisk" ;
  demonregissoer_nn_1 = mkN "demonregissцr" "demonregissцrer" ;
  demonstrant_nn_1 = mkN "demonstrant" "demonstranter" ;
  demonstration_nn_1 = mkN "demonstration" "demonstrationer" ;
  demonstrationsfrihet_nn_1 = mkN "demonstrationsfrihet" "demonstrationsfriheter" ;
  demonstrationstaag_nn_1 = mkN "demonstrationstеg" neutrum ;
  demonstrativ_av_1 = mkA "demonstrativ" ;
  demonstratoer_nn_1 = mkN "demonstratцr" "demonstratцrer" ;
  demonstratris_nn_1 = mkN "demonstratris" "demonstratriser" ;
  demontering_nn_1 = mkN "demontering" ;
  demotape_nn_1 = mkN "demotape" "demotaper" ;
  denar_nn_1 = mkN "denar" "denarer" ;
  dendrit_nn_1 = mkN "dendrit" "dendriter" ;
  dendrolog_nn_1 = mkN "dendrolog" "dendrologer" ;
  denier_nn_1 = mkN "denier" "denieren" "denier" "denieren" ;
  dennes_ab_1 = mkAdv "dennes" ;
  denotation_nn_1 = mkN "denotation" "denotationer" ;
  denotativ_av_1 = mkA "denotativ" ;
  densitet_nn_1 = mkN "densitet" "densiteter" ;
  densitometer_nn_1 = mkN "densitometer" ;
  densometer_nn_1 = mkN "densometer" ;
  dental_av_1 = mkA "dental" ;
  dental_nn_1 = mkN "dental" "dentaler" ;
  dentist_nn_1 = mkN "dentist" "dentister" ;
  denudation_nn_1 = mkN "denudation" "denudationer" ;
  denuklearisering_nn_1 = mkN "denuklearisering" ;
  deodorant_nn_1 = mkN "deodorant" "deodoranter" ;
  depaa_nn_1 = mkN "depе" "depеer" ;
  depaafynd_nn_1 = mkN "depеfynd" neutrum ;
  departement_nn_1 = mkN "departement" "departementet" "departementen" "departementena" ;
  departemental_av_1 = mkA "departemental" ;
  departementsaerende_nn_1 = mkN "departementsдrende" ;
  departementschef_nn_1 = mkN "departementschef" "departementschefer" ;
  depens_nn_1 = mkN "depens" "depenser" ;
  depesch_nn_1 = mkN "depesch" "depescher" ;
  depeschbyraa_nn_1 = mkN "depeschbyrе" "depeschbyrеer" ;
  depolarisator_nn_1 = mkN "depolarisator" "depolarisatorer" ;
  deponens_nn_1 = mkN "deponens" "deponens" "deponens" "deponensen" ;
  deponent_nn_1 = mkN "deponent" "deponenter" ;
  deponentiell_av_1 = mkA "deponentiell" ;
  deportation_nn_1 = mkN "deportation" "deportationer" ;
  deportationsort_nn_1 = mkN "deportationsort" "deportationsorter" ;
  deposition_nn_1 = mkN "deposition" "depositioner" ;
  depositionsbevis_nn_1 = mkN "depositionsbevis" neutrum ;
  depositum_nn_1 = mkN "depositum" "depositum" "deposita" "depositana" ;
  deppig_av_1 = mkA "deppig" ;
  depression_nn_1 = mkN "depression" "depressioner" ;
  depressiv_av_1 = mkA "depressiv" ;
  deprimerande_av_1 = mkA "deprimerande" ;
  deprivation_nn_1 = mkN "deprivation" "deprivationer" ;
  deputation_nn_1 = mkN "deputation" "deputationer" ;
  deputerad_nn_1 = mkN "deputerad" "deputeraden" "deputerade" "deputeradena" ;
  derby_nn_1 = mkN "derby" "derbyt" "derbyn" "derbyna" ;
  derivat_nn_1 = mkN "derivat" neutrum ;
  derivation_nn_1 = mkN "derivation" "derivationer" ;
  dermatit_nn_1 = mkN "dermatit" "dermatiter" ;
  dermatolog_nn_1 = mkN "dermatolog" "dermatologer" ;
  dermatologisk_av_1 = mkA "dermatologisk" ;
  dervisch_nn_1 = mkN "dervisch" "dervischer" ;
  descendent_nn_1 = mkN "descendent" "descendenter" ;
  desegregation_nn_1 = mkN "desegregation" "desegregationer" ;
  desertoer_nn_1 = mkN "desertцr" "desertцrer" ;
  deshabille_nn_1 = mkN "deshabillй" "deshabillйer" ;
  designer_nn_1 = mkN "designer" "designern" "designer" "designerna" ;
  desillusion_nn_1 = mkN "desillusion" "desillusioner" ;
  desinfektion_nn_1 = mkN "desinfektion" "desinfektioner" ;
  desinfektoer_nn_1 = mkN "desinfektцr" "desinfektцrer" ;
  desinformation_nn_1 = mkN "desinformation" "desinformationer" ;
  desintegration_nn_1 = mkN "desintegration" "desintegrationer" ;
  deskription_nn_1 = mkN "deskription" "deskriptioner" ;
  deskriptiv_av_1 = mkA "deskriptiv" ;
  desperado_nn_1 = mkN "desperado" "desperadon" "desperados" "desperadosen" ;
  desperat_av_1 = mkA "desperat" "desperat" ;
  despot_nn_1 = mkN "despot" "despoter" ;
  despoti_nn_1 = mkN "despoti" "despotier" ;
  despotisk_av_1 = mkA "despotisk" ;
  dess_ab_1 = mkAdv "dess" ;
  dessaeng_nn_1 = mkN "dessдng" "dessдnger" ;
  dessbaettre_ab_1 = mkAdv "dessbдttre" ;
  dessemellan_ab_1 = mkAdv "dessemellan" ;
  dessert_nn_1 = mkN "dessert" "desserter" ;
  dessertgaffel_nn_1 = mkN "dessertgaffel" ;
  dessertkniv_nn_1 = mkN "dessertkniv" ;
  dessertost_nn_1 = mkN "dessertost" ;
  dessertsaas_nn_1 = mkN "dessertsеs" "dessertsеser" ;
  dessertsked_nn_1 = mkN "dessertsked" ;
  desserttallrik_nn_1 = mkN "desserttallrik" ;
  dessertvin_nn_1 = mkN "dessertvin" "dessertvinet" "dessertviner" "dessertvinerna" ;
  dessfoerinnan_ab_1 = mkAdv "dessfцrinnan" ;
  dessfoerutan_ab_1 = mkAdv "dessfцrutan" ;
  dessinatoer_nn_1 = mkN "dessinatцr" "dessinatцrer" ;
  desslikes_ab_1 = mkAdv "desslikes" ;
  dessutom_ab_1 = mkAdv "dessutom" ;
  dessvaerre_ab_1 = mkAdv "dessvдrre" ;
  destabiliserande_av_1 = mkA "destabiliserande" ;
  destillat_nn_1 = mkN "destillat" neutrum ;
  destillation_nn_1 = mkN "destillation" "destillationer" ;
  destillationsapparat_nn_1 = mkN "destillationsapparat" "destillationsapparater" ;
  destillering_nn_1 = mkN "destillering" ;
  destinataer_nn_1 = mkN "destinatдr" "destinatдrer" ;
  destination_nn_1 = mkN "destination" "destinationer" ;
  destinationsort_nn_1 = mkN "destinationsort" "destinationsorter" ;
  destinatoer_nn_1 = mkN "destinatцr" "destinatцrer" ;
  desto_ab_1 = mkAdv "desto" ;
  destruent_nn_1 = mkN "destruent" "destruenter" ;
  destruktionsanlaeggning_nn_1 = mkN "destruktionsanlдggning" ;
  destruktiv_av_1 = mkA "destruktiv" ;
  detachement_nn_1 = mkN "detachement" "detachementet" "detachementen" "detachementena" ;
  detachoer_nn_1 = mkN "detachцr" "detachцrer" ;
  detalj_nn_1 = mkN "detalj" "detaljer" ;
  detaljanmaerkning_nn_1 = mkN "detaljanmдrkning" ;
  detaljfraaga_nn_1 = mkN "detaljfrеga" ;
  detaljhandlare_nn_1 = mkN "detaljhandlare" "detaljhandlare" ;
  detaljist_nn_1 = mkN "detaljist" "detaljister" ;
  detaljkaennedom_nn_1 = mkN "detaljkдnnedom" ;
  detaljpris_nn_1 = mkN "detaljpris" neutrum ;
  detaljrik_av_1 = mkA "detaljrik" ;
  detaljstudium_nn_1 = mkN "detaljstudium" "detaljstudiet" "detaljstudier" "detaljstudierna" ;
  detaljutfoerande_nn_1 = mkN "detaljutfцrande" ;
  detektiv_av_1 = mkA "detektiv" ;
  detektiv_nn_1 = mkN "detektiv" "detektiver" ;
  detektivroman_nn_1 = mkN "detektivroman" "detektivromaner" ;
  detektor_nn_1 = mkN "detektor" "detektorer" ;
  detergent_nn_1 = mkN "detergent" "detergenter" ;
  determination_nn_1 = mkN "determination" "determinationer" ;
  determinativ_av_1 = mkA "determinativ" ;
  determinist_nn_1 = mkN "determinist" "determinister" ;
  deterministisk_av_1 = mkA "deterministisk" ;
  detonation_nn_1 = mkN "detonation" "detonationer" ;
  detonationshastighet_nn_1 = mkN "detonationshastighet" "detonationshastigheter" ;
  detonationstryck_nn_1 = mkN "detonationstryck" neutrum ;
  detonationszon_nn_1 = mkN "detonationszon" "detonationszoner" ;
  detonator_nn_1 = mkN "detonator" "detonatorer" ;
  deuce_ab_1 = mkAdv "deuce" ;
  deuteron_nn_1 = mkN "deuteron" "deuteroner" ;
  deutron_nn_1 = mkN "deutron" "deutroner" ;
  deviation_nn_1 = mkN "deviation" "deviationer" ;
  devis_nn_1 = mkN "devis" "deviser" ;
  devot_av_1 = mkA "devot" "devot" ;
  dextran_nn_1 = mkN "dextran" "dextraner" ;
  dextrin_nn_1 = mkN "dextrin" "dextriner" ;
  diabas_nn_1 = mkN "diabas" "diabaser" ;
  diabetiker_nn_1 = mkN "diabetiker" "diabetikern" "diabetiker" "diabetikerna" ;
  diabild_nn_1 = mkN "diabild" "diabilder" ;
  diabolisk_av_1 = mkA "diabolisk" ;
  diadem_nn_1 = mkN "diadem" neutrum ;
  diafilm_nn_1 = mkN "diafilm" "diafilmer" ;
  diafragma_nn_1 = mkN "diafragma" ;
  diagnos_nn_1 = mkN "diagnos" "diagnoser" ;
  diagnostiker_nn_1 = mkN "diagnostiker" "diagnostikern" "diagnostiker" "diagnostikerna" ;
  diagnostisk_av_1 = mkA "diagnostisk" ;
  diagonal_av_1 = mkA "diagonal" ;
  diagonal_nn_1 = mkN "diagonal" "diagonaler" ;
  diagram_nn_1 = mkN "diagram" "diagrammet" "diagram" "diagrammen" ;
  diakon_nn_1 = mkN "diakon" "diakoner" ;
  diakonistyrelse_nn_1 = mkN "diakonistyrelse" "diakonistyrelser" ;
  diakritisk_av_1 = mkA "diakritisk" ;
  diakron_av_1 = mkA "diakron" ;
  diakronisk_av_1 = mkA "diakronisk" ;
  dialekt_nn_1 = mkN "dialekt" "dialekter" ;
  dialektal_av_1 = mkA "dialektal" ;
  dialektgeografisk_av_1 = mkA "dialektgeografisk" ;
  dialektiker_nn_1 = mkN "dialektiker" "dialektikern" "dialektiker" "dialektikerna" ;
  dialektisk_av_1 = mkA "dialektisk" ;
  dialektolog_nn_1 = mkN "dialektolog" "dialektologer" ;
  dialektologisk_av_1 = mkA "dialektologisk" ;
  dialog_nn_1 = mkN "dialog" "dialoger" ;
  dialys_nn_1 = mkN "dialys" "dialyser" ;
  dialytisk_av_1 = mkA "dialytisk" ;
  diamant_nn_1 = mkN "diamant" "diamanter" ;
  diamantborr_nn_1 = mkN "diamantborr" ;
  diamantbroellop_nn_1 = mkN "diamantbrцllop" neutrum ;
  diameter_nn_1 = mkN "diameter" ;
  diametral_av_1 = mkA "diametral" ;
  diapositiv_nn_1 = mkN "diapositiv" neutrum ;
  diarienummer_nn_1 = mkN "diarienummer" neutrum ;
  diarium_nn_1 = mkN "diarium" "diariet" "diarier" "diarierna" ;
  diarre_nn_1 = mkN "diarrй" "diarrйer" ;
  diastas_nn_1 = mkN "diastas" "diastaser" ;
  diastolisk_av_1 = mkA "diastolisk" ;
  diatonisk_av_1 = mkA "diatonisk" ;
  diatrib_nn_1 = mkN "diatrib" "diatriber" ;
  dibarn_nn_1 = mkN "dibarn" neutrum ;
  didaktiker_nn_1 = mkN "didaktiker" "didaktikern" "didaktiker" "didaktikerna" ;
  didaktisk_av_1 = mkA "didaktisk" ;
  diesel_nn_1 = mkN "diesel" ;
  dieselmotor_nn_1 = mkN "dieselmotor" "dieselmotorer" ;
  dieselolja_nn_1 = mkN "dieselolja" ;
  diet_nn_1 = mkN "diet" "dieter" ;
  dietetisk_av_1 = mkA "dietetisk" ;
  dietisk_av_1 = mkA "dietisk" ;
  dietist_nn_1 = mkN "dietist" "dietister" ;
  differens_nn_1 = mkN "differens" "differenser" ;
  different_av_1 = mkA "different" "different" ;
  differential_nn_1 = mkN "differential" "differentialer" ;
  differentialekvation_nn_1 = mkN "differentialekvation" "differentialekvationer" ;
  differentialkalkyl_nn_1 = mkN "differentialkalkyl" "differentialkalkyler" ;
  differentialspaerr_nn_1 = mkN "differentialspдrr" ;
  differentialvaexel_nn_1 = mkN "differentialvдxel" ;
  differentiell_av_1 = mkA "differentiell" ;
  differentiering_nn_1 = mkN "differentiering" ;
  diffraktion_nn_1 = mkN "diffraktion" "diffraktioner" ;
  diffraktionsspektrum_nn_1 = mkN "diffraktionsspektrum" neutrum ;
  diffus_av_1 = mkA "diffus" ;
  diftong_nn_1 = mkN "diftong" "diftonger" ;
  digel_nn_1 = mkN "digel" ;
  digelpress_nn_1 = mkN "digelpress" ;
  diger_av_1 = mkA "diger" "digert" "digra" "digra" "digrare" "digrast" "digraste" ;
  digital_av_1 = mkA "digital" ;
  digivning_nn_1 = mkN "digivning" ;
  dignitaer_nn_1 = mkN "dignitдr" "dignitдrer" ;
  dignitet_nn_1 = mkN "dignitet" "digniteter" ;
  digression_nn_1 = mkN "digression" "digressioner" ;
  dike_nn_1 = mkN "dike" ;
  dikeskoerning_nn_1 = mkN "dikeskцrning" ;
  dikesren_nn_1 = mkN "dikesren" "dikesrenen" "dikesrenar" "dikesrenarna" ;
  diklin_av_1 = mkA "diklin" ;
  diklin_nn_1 = mkN "diklin" "dikliner" ;
  dikotomi_nn_1 = mkN "dikotomi" "dikotomier" ;
  dikotyledon_av_1 = mkA "dikotyledon" ;
  dikotyledon_nn_1 = mkN "dikotyledon" "dikotyledoner" ;
  dikt_ab_1 = mkAdv "dikt" ;
  dikt_nn_1 = mkN "dikt" "dikter" ;
  diktafon_nn_1 = mkN "diktafon" "diktafoner" ;
  diktamen_nn_1 = mkN "diktamen" "diktamen" "diktamina" "diktamina" ;
  diktarbegaavning_nn_1 = mkN "diktarbegеvning" ;
  diktare_nn_1 = mkN "diktare" "diktare" ;
  diktargrupp_nn_1 = mkN "diktargrupp" "diktargrupper" ;
  diktat_nn_1 = mkN "diktat" neutrum ;
  diktator_nn_1 = mkN "diktator" "diktatorer" ;
  diktatorisk_av_1 = mkA "diktatorisk" ;
  diktatur_nn_1 = mkN "diktatur" "diktaturer" ;
  diktcykel_nn_1 = mkN "diktcykel" ;
  dikteringsmaskin_nn_1 = mkN "dikteringsmaskin" "dikteringsmaskiner" ;
  diktning_nn_1 = mkN "diktning" ;
  diktsamling_nn_1 = mkN "diktsamling" ;
  diktverk_nn_1 = mkN "diktverk" neutrum ;
  dilatation_nn_1 = mkN "dilatation" "dilatationer" ;
  dilatationsfog_nn_1 = mkN "dilatationsfog" ;
  dildo_nn_1 = mkN "dildo" ;
  dilemma_nn_1 = mkN "dilemma" "dilemmat" "dilemman" "dilemmana" ;
  dilettant_nn_1 = mkN "dilettant" "dilettanter" ;
  dilettantisk_av_1 = mkA "dilettantisk" ;
  dilettantmaessig_av_1 = mkA "dilettantmдssig" ;
  diligens_nn_1 = mkN "diligens" "diligenser" ;
  dilleri_nn_1 = mkN "dilleri" "dillerit" "dillerier" "dillerierna" ;
  dillsaas_nn_1 = mkN "dillsеs" "dillsеser" ;
  dimbaage_nn_1 = mkN "dimbеge" utrum ;
  dimbank_nn_1 = mkN "dimbank" ;
  dimbildning_nn_1 = mkN "dimbildning" ;
  dimblaa_av_1 = mkA "dimblе" "dimblеtt" ;
  dimension_nn_1 = mkN "dimension" "dimensioner" ;
  dimensionering_nn_1 = mkN "dimensionering" ;
  dimensionsavverkning_nn_1 = mkN "dimensionsavverkning" ;
  dimhoeljd_av_1 = mkA "dimhцljd" "dimhцljt" ;
  diminuendo_ab_1 = mkAdv "diminuendo" ;
  diminuendo_nn_1 = mkN "diminuendo" "diminuendot" "diminuendon" "diminuendona" ;
  diminutiv_av_1 = mkA "diminutiv" ;
  diminutiv_nn_1 = mkN "diminutiv" "diminutiver" ;
  dimkammare_nn_1 = mkN "dimkammare" "dimkammaren" "dimkamrar" "dimkamrarna" ;
  dimljus_nn_1 = mkN "dimljus" neutrum ;
  dimmig_av_1 = mkA "dimmig" ;
  dimmoln_nn_1 = mkN "dimmoln" neutrum ;
  dimorf_av_1 = mkA "dimorf" ;
  dimorfi_nn_1 = mkN "dimorfi" "dimorfier" ;
  dimridaa_nn_1 = mkN "dimridе" "dimridеer" ;
  dinar_nn_1 = mkN "dinar" "dinarer" ;
  dinatriumvaetefosfat_nn_1 = mkN "dinatriumvдtefosfat" neutrum ;
  dine_nn_1 = mkN "dinй" "dinйer" ;
  dinge_nn_1 = mkN "dinge" utrum ;
  dingo_nn_1 = mkN "dingo" "dingor" ;
  dinosaur_nn_1 = mkN "dinosaur" "dinosaurer" ;
  dinosaurie_nn_1 = mkN "dinosaurie" "dinosaurier" ;
  dinosaurieart_nn_1 = mkN "dinosaurieart" "dinosauriearter" ;
  diod_nn_1 = mkN "diod" "dioder" ;
  dionysisk_av_1 = mkA "dionysisk" ;
  diopter_nn_1 = mkN "diopter" ;
  dioptri_nn_1 = mkN "dioptri" "dioptrier" ;
  dioptrisk_av_1 = mkA "dioptrisk" ;
  diorama_nn_1 = mkN "diorama" "dioramat" "dioraman" "dioramana" ;
  diorit_nn_1 = mkN "diorit" "dioriter" ;
  dioskur_nn_1 = mkN "dioskur" "dioskurer" ;
  dioxin_nn_1 = mkN "dioxin" "dioxinet" "dioxiner" "dioxinerna" ;
  diperiod_nn_1 = mkN "diperiod" "diperioder" ;
  diplom_nn_1 = mkN "diplom" neutrum ;
  diplomat_nn_1 = mkN "diplomat" "diplomater" ;
  diplomatarisk_av_1 = mkA "diplomatarisk" ;
  diplomatarium_nn_1 = mkN "diplomatarium" "diplomatariet" "diplomatarier" "diplomatarierna" ;
  diplomatisk_av_1 = mkA "diplomatisk" ;
  diplomingenjoer_nn_1 = mkN "diplomingenjцr" "diplomingenjцrer" ;
  dipol_nn_1 = mkN "dipol" "dipoler" ;
  dipsoman_nn_1 = mkN "dipsoman" "dipsomaner" ;
  diptyk_nn_1 = mkN "diptyk" "diptyker" ;
  direkt_av_1 = mkA "direkt" "direkt" ;
  direkthet_nn_1 = mkN "direkthet" "direktheter" ;
  direktinflytande_nn_1 = mkN "direktinflytande" ;
  direktinsprutning_nn_1 = mkN "direktinsprutning" ;
  direktion_nn_1 = mkN "direktion" "direktioner" ;
  direktiv_nn_1 = mkN "direktiv" neutrum ;
  direktkontakt_nn_1 = mkN "direktkontakt" "direktkontakter" ;
  direktlinje_nn_1 = mkN "direktlinje" "direktlinjer" ;
  direktmetod_nn_1 = mkN "direktmetod" "direktmetoder" ;
  direktoer_nn_1 = mkN "direktцr" "direktцrer" ;
  direktor_nn_1 = mkN "direktor" "direktorer" ;
  direktreferat_nn_1 = mkN "direktreferat" neutrum ;
  direktris_nn_1 = mkN "direktris" "direktriser" ;
  direktsaendning_nn_1 = mkN "direktsдndning" ;
  direktskott_nn_1 = mkN "direktskott" neutrum ;
  direktvaexel_nn_1 = mkN "direktvдxel" ;
  dirigent_nn_1 = mkN "dirigent" "dirigenter" ;
  dirk_nn_1 = mkN "dirk" ;
  dis_nn_2 = mkN "dis" "diser" ;
  disackarid_nn_1 = mkN "disackarid" "disackarider" ;
  discipel_nn_1 = mkN "discipel" ;
  disciplin_nn_1 = mkN "disciplin" "discipliner" ;
  disciplinaer_av_1 = mkA "disciplinдr" ;
  disciplinbot_nn_1 = mkN "disciplinbot" "disciplinbцter" ;
  disciplinmaal_nn_1 = mkN "disciplinmеl" neutrum ;
  disciplinstraff_nn_1 = mkN "disciplinstraff" neutrum ;
  discjockey_nn_1 = mkN "discjockey" "discjockeyer" ;
  disco_nn_1 = mkN "disco" "discot" "discon" "discona" ;
  disharmoni_nn_1 = mkN "disharmoni" "disharmonier" ;
  disharmonisk_av_1 = mkA "disharmonisk" ;
  disig_av_1 = mkA "disig" ;
  disjunkt_av_1 = mkA "disjunkt" "disjunkt" ;
  disjunktion_nn_1 = mkN "disjunktion" "disjunktioner" ;
  disjunktiv_av_1 = mkA "disjunktiv" ;
  disk_nn_1 = mkN "disk" ;
  diskant_nn_1 = mkN "diskant" "diskanter" ;
  diskantklav_nn_1 = mkN "diskantklav" "diskantklaver" ;
  diskare_nn_1 = mkN "diskare" "diskare" ;
  diskbaenk_nn_1 = mkN "diskbдnk" ;
  diskbraack_nn_1 = mkN "diskbrеck" neutrum ;
  diskett_nn_1 = mkN "diskett" "disketter" ;
  diskho_nn_1 = mkN "diskho" ;
  diskjockey_nn_1 = mkN "diskjockey" ;
  diskmaskin_nn_1 = mkN "diskmaskin" "diskmaskiner" ;
  diskmedel_nn_1 = mkN "diskmedel" neutrum ;
  disko_nn_1 = mkN "disko" "diskot" "diskon" "diskona" ;
  diskofil_nn_1 = mkN "diskofil" "diskofiler" ;
  diskontinuerlig_av_1 = mkA "diskontinuerlig" ;
  diskontinuitet_nn_1 = mkN "diskontinuitet" "diskontinuiteter" ;
  diskonto_nn_1 = mkN "diskonto" "diskontot" "diskonton" "diskontona" ;
  diskontoer_nn_1 = mkN "diskontцr" "diskontцrer" ;
  diskordans_nn_1 = mkN "diskordans" "diskordanser" ;
  diskordant_av_1 = mkA "diskordant" "diskordant" ;
  diskotek_nn_1 = mkN "diskotek" neutrum ;
  diskplockare_nn_1 = mkN "diskplockare" "diskplockare" ;
  diskrepans_nn_1 = mkN "diskrepans" "diskrepanser" ;
  diskret_av_1 = mkA "diskret" "diskret" ;
  diskriminering_nn_1 = mkN "diskriminering" ;
  diskstaell_nn_1 = mkN "diskstдll" neutrum ;
  disktorkning_nn_1 = mkN "disktorkning" ;
  diskurs_nn_1 = mkN "diskurs" "diskurser" ;
  diskursiv_av_1 = mkA "diskursiv" ;
  diskus_nn_1 = mkN "diskus" ;
  diskuskastning_nn_1 = mkN "diskuskastning" ;
  diskussion_nn_1 = mkN "diskussion" "diskussioner" ;
  diskussionsprotokoll_nn_1 = mkN "diskussionsprotokoll" neutrum ;
  diskutabel_av_1 = mkA "diskutabel" "diskutabelt" "diskutabla" "diskutabla" "diskutablare" "diskutablast" "diskutablaste" ;
  diskvalificering_nn_1 = mkN "diskvalificering" ;
  diskvalifikation_nn_1 = mkN "diskvalifikation" "diskvalifikationer" ;
  dislokation_nn_1 = mkN "dislokation" "dislokationer" ;
  disoes_nn_1 = mkN "disцs" "disцser" ;
  disparat_av_1 = mkA "disparat" "disparat" ;
  dispasch_nn_1 = mkN "dispasch" "dispascher" ;
  dispaschoer_nn_1 = mkN "dispaschцr" "dispaschцrer" ;
  dispens_nn_1 = mkN "dispens" "dispenser" ;
  dispensaer_nn_1 = mkN "dispensдr" "dispensдrer" ;
  dispers_av_1 = mkA "dispers" ;
  display_nn_1 = mkN "display" "displayen" "displayer" "displayerna" ;
  disponent_nn_1 = mkN "disponent" "disponenter" ;
  disponibel_av_1 = mkA "disponibel" "disponibelt" "disponibla" "disponibla" "disponiblare" "disponiblast" "disponiblaste" ;
  disponibilitet_nn_1 = mkN "disponibilitet" "disponibiliteter" ;
  disposition_nn_1 = mkN "disposition" "dispositioner" ;
  dispositionsfond_nn_1 = mkN "dispositionsfond" "dispositionsfonder" ;
  dispositiv_av_1 = mkA "dispositiv" ;
  disproportion_nn_1 = mkN "disproportion" "disproportioner" ;
  disproportionerlig_av_1 = mkA "disproportionerlig" ;
  disputation_nn_1 = mkN "disputation" "disputationer" ;
  dispyt_nn_1 = mkN "dispyt" "dispyter" ;
  dissektion_nn_1 = mkN "dissektion" "dissektioner" ;
  dissenter_nn_1 = mkN "dissenter" "dissentern" "dissenter" "dissenterna" ;
  dissertation_nn_1 = mkN "dissertation" "dissertationer" ;
  dissident_nn_1 = mkN "dissident" "dissidenter" ;
  dissimilation_nn_1 = mkN "dissimilation" "dissimilationer" ;
  dissociation_nn_1 = mkN "dissociation" "dissociationer" ;
  dissonans_nn_1 = mkN "dissonans" "dissonanser" ;
  dissonant_av_1 = mkA "dissonant" "dissonant" ;
  dissonant_nn_1 = mkN "dissonant" "dissonanter" ;
  distans_nn_1 = mkN "distans" "distanser" ;
  distansflygning_nn_1 = mkN "distansflygning" ;
  distansminut_nn_1 = mkN "distansminut" "distansminuter" ;
  distikon_nn_1 = mkN "distikon" neutrum ;
  distinkt_av_1 = mkA "distinkt" "distinkt" ;
  distinktion_nn_1 = mkN "distinktion" "distinktioner" ;
  distorsion_nn_1 = mkN "distorsion" "distorsioner" ;
  distraktion_nn_1 = mkN "distraktion" "distraktioner" ;
  distraktor_nn_1 = mkN "distraktor" "distraktorer" ;
  distribuent_nn_1 = mkN "distribuent" "distribuenter" ;
  distribunal_nn_1 = mkN "distribunal" "distribunaler" ;
  distribution_nn_1 = mkN "distribution" "distributioner" ;
  distributionscentral_nn_1 = mkN "distributionscentral" "distributionscentraler" ;
  distributiv_av_1 = mkA "distributiv" ;
  distributoer_nn_1 = mkN "distributцr" "distributцrer" ;
  distrikt_nn_1 = mkN "distrikt" neutrum ;
  distriktslaekare_nn_1 = mkN "distriktslдkare" "distriktslдkare" ;
  distriktsmaestare_nn_1 = mkN "distriktsmдstare" "distriktsmдstare" ;
  distriktsmaesterskap_nn_1 = mkN "distriktsmдsterskap" "distriktsmдsterskapet" "distriktsmдsterskapen" "distriktsmдsterskapena" ;
  dit_ab_1 = mkAdv "dit" ;
  ditaat_ab_1 = mkAdv "ditеt" ;
  dithaen_ab_1 = mkAdv "dithдn" ;
  dithoerande_av_1 = mkA "dithцrande" ;
  ditintills_ab_1 = mkAdv "ditintills" ;
  dito_av_1 = mkA "dito" ;
  dittills_ab_1 = mkAdv "dittills" ;
  dittillsvarande_av_1 = mkA "dittillsvarande" ;
  dityramb_nn_1 = mkN "dityramb" "dityramber" ;
  dityrambisk_av_1 = mkA "dityrambisk" ;
  divan_nn_1 = mkN "divan" "divaner" ;
  divergens_nn_1 = mkN "divergens" "divergenser" ;
  divergent_av_1 = mkA "divergent" "divergent" ;
  diverse_av_1 = mkA "diverse" ;
  diversearbetare_nn_1 = mkN "diversearbetare" "diversearbetare" ;
  diversehandel_nn_1 = mkN "diversehandel" ;
  diversion_nn_1 = mkN "diversion" "diversioner" ;
  divertissemang_nn_1 = mkN "divertissemang" neutrum ;
  dividend_nn_1 = mkN "dividend" "dividender" ;
  divig_av_1 = mkA "divig" ;
  divinatorisk_av_1 = mkA "divinatorisk" ;
  divis_nn_1 = mkN "divis" "diviser" ;
  division_nn_1 = mkN "division" "divisioner" ;
  divisor_nn_1 = mkN "divisor" "divisorer" ;
  djaekne_nn_1 = mkN "djдkne" utrum ;
  djaerv_av_1 = mkA "djдrv" ;
  djaervhet_nn_1 = mkN "djдrvhet" "djдrvheter" ;
  djaevel_nn_1 = mkN "djдvel" ;
  djaevla_av_1 = mkA "djдvla" ;
  djaevlig_av_1 = mkA "djдvlig" ;
  djaevul_nn_1 = mkN "djдvul" "djдvulen" "djдvlar" "djдvlarna" ;
  djaevulsk_av_1 = mkA "djдvulsk" ;
  djaevulskap_nn_1 = mkN "djдvulskap" "djдvulskaper" ;
  djaevulstyg_nn_1 = mkN "djдvulstyg" neutrum ;
  djiboutier_nn_1 = mkN "djiboutier" "djiboutiern" "djiboutier" "djiboutierna" ;
  djiboutisk_av_1 = mkA "djiboutisk" ;
  djonk_nn_1 = mkN "djonk" "djonker" ;
  djungel_nn_1 = mkN "djungel" "djungeln" "djungler" "djunglerna" ;
  djup_av_1 = mkA "djup" ;
  djup_nn_1 = mkN "djup" neutrum ;
  djupbergart_nn_1 = mkN "djupbergart" "djupbergarter" ;
  djupbild_nn_1 = mkN "djupbild" "djupbilder" ;
  djupblaa_av_1 = mkA "djupblе" "djupblеtt" ;
  djupborrande_av_1 = mkA "djupborrande" ;
  djupborrning_nn_1 = mkN "djupborrning" ;
  djupbrytning_nn_1 = mkN "djupbrytning" ;
  djupdimension_nn_1 = mkN "djupdimension" "djupdimensioner" ;
  djupdykning_nn_1 = mkN "djupdykning" ;
  djupgaaende_av_1 = mkA "djupgеende" ;
  djuphavsbotten_nn_1 = mkN "djuphavsbotten" ;
  djuphavsfisk_nn_1 = mkN "djuphavsfisk" ;
  djuphavsvatten_nn_1 = mkN "djuphavsvatten" "djuphavsvattnet" "djuphavsvatten" "djuphavsvattnen" ;
  djuping_nn_1 = mkN "djuping" ;
  djupintervju_nn_1 = mkN "djupintervju" "djupintervjun" "djupintervjuer" "djupintervjuerna" ;
  djuplek_nn_1 = mkN "djuplek" ;
  djuplod_nn_1 = mkN "djuplod" neutrum ;
  djuplodande_av_1 = mkA "djuplodande" ;
  djupmask_nn_1 = mkN "djupmask" ;
  djuproed_av_1 = mkA "djuprцd" ;
  djupsinnig_av_1 = mkA "djupsinnig" ;
  djupsinnighet_nn_1 = mkN "djupsinnighet" "djupsinnigheter" ;
  djupstruktur_nn_1 = mkN "djupstruktur" "djupstrukturer" ;
  djuptaenkt_av_1 = mkA "djuptдnkt" "djuptдnkt" ;
  djuptryck_nn_1 = mkN "djuptryck" neutrum ;
  djupvatten_nn_1 = mkN "djupvatten" "djupvattnet" "djupvatten" "djupvattnen" ;
  djur_nn_1 = mkN "djur" neutrum ;
  djurangrepp_nn_1 = mkN "djurangrepp" neutrum ;
  djurart_nn_1 = mkN "djurart" "djurarter" ;
  djurben_nn_1 = mkN "djurben" neutrum ;
  djurdel_nn_1 = mkN "djurdel" "djurdelen" "djurdelar" "djurdelarna" ;
  djurfabel_nn_1 = mkN "djurfabel" "djurfabeln" "djurfabler" "djurfablerna" ;
  djurfoder_nn_1 = mkN "djurfoder" neutrum ;
  djurfoersoek_nn_1 = mkN "djurfцrsцk" neutrum ;
  djurgaard_nn_1 = mkN "djurgеrd" ;
  djurgrupp_nn_1 = mkN "djurgrupp" "djurgrupper" ;
  djurhud_nn_1 = mkN "djurhud" ;
  djurisk_av_1 = mkA "djurisk" ;
  djurkropp_nn_1 = mkN "djurkropp" ;
  djurlaekare_nn_1 = mkN "djurlдkare" "djurlдkare" ;
  djurpark_nn_1 = mkN "djurpark" "djurparker" ;
  djurplaagare_nn_1 = mkN "djurplеgare" "djurplеgare" ;
  djurplankton_nn_1 = mkN "djurplankton" neutrum ;
  djursjukhus_nn_1 = mkN "djursjukhus" neutrum ;
  djurskinn_nn_1 = mkN "djurskinn" neutrum ;
  djurskoetare_nn_1 = mkN "djurskцtare" "djurskцtare" ;
  djurslag_nn_1 = mkN "djurslag" neutrum ;
  djurtarm_nn_1 = mkN "djurtarm" ;
  djurutstaellning_nn_1 = mkN "djurutstдllning" ;
  djurvaen_nn_1 = mkN "djurvдn" "djurvдnnen" "djurvдnner" "djurvдnnerna" ;
  djurvaenlig_av_1 = mkA "djurvдnlig" ;
  doakoer_nn_1 = mkN "doakцr" "doakцrer" ;
  docent_nn_1 = mkN "docent" "docenter" ;
  docentur_nn_1 = mkN "docentur" "docenturer" ;
  dock_ab_1 = mkAdv "dock" ;
  dockskaap_nn_1 = mkN "dockskеp" neutrum ;
  docksoet_av_1 = mkA "docksцt" ;
  dockteater_nn_1 = mkN "dockteater" ;
  dodekaeder_nn_1 = mkN "dodekaeder" ;
  doebattang_nn_1 = mkN "dцbattang" "dцbattanger" ;
  doed_av_1 = mkA "dцd" ;
  doed_nn_1 = mkN "dцd" ;
  doedande_av_1 = mkA "dцdande" ;
  doedbraend_av_1 = mkA "dцdbrдnd" ;
  doeddansare_nn_1 = mkN "dцddansare" "dцddansare" ;
  doedfoedd_av_1 = mkA "dцdfцdd" ;
  doedfull_av_1 = mkA "dцdfull" ;
  doedgraevare_nn_1 = mkN "dцdgrдvare" "dцdgrдvare" ;
  doeding_nn_1 = mkN "dцding" ;
  doedlaege_nn_1 = mkN "dцdlдge" ;
  doedlig_av_1 = mkA "dцdlig" ;
  doedlighet_nn_1 = mkN "dцdlighet" "dцdligheter" ;
  doedperiod_nn_1 = mkN "dцdperiod" "dцdperioder" ;
  doedsannons_nn_1 = mkN "dцdsannons" "dцdsannonser" ;
  doedsattest_nn_1 = mkN "dцdsattest" "dцdsattester" ;
  doedsbaedd_nn_1 = mkN "dцdsbдdd" ;
  doedsbevis_nn_1 = mkN "dцdsbevis" neutrum ;
  doedsblek_av_1 = mkA "dцdsblek" ;
  doedsbo_nn_1 = mkN "dцdsbo" "dцdsbot" "dцdsbon" "dцdsboen" ;
  doedsdans_nn_1 = mkN "dцdsdans" "dцdsdanser" ;
  doedsdoemd_av_1 = mkA "dцdsdцmd" "dцdsdцmt" ;
  doedsdom_nn_1 = mkN "dцdsdom" ;
  doedsfall_nn_1 = mkN "dцdsfall" neutrum ;
  doedsfara_nn_1 = mkN "dцdsfara" ;
  doedsfas_nn_1 = mkN "dцdsfas" "dцdsfaser" ;
  doedsfiende_nn_1 = mkN "dцdsfiende" "dцdsfiender" ;
  doedsfoeraktande_av_1 = mkA "dцdsfцraktande" ;
  doedsfoerskraeckt_av_1 = mkA "dцdsfцrskrдckt" "dцdsfцrskrдckt" ;
  doedskalle_nn_1 = mkN "dцdskalle" utrum ;
  doedskallefjaeril_nn_1 = mkN "dцdskallefjдril" ;
  doedskamp_nn_1 = mkN "dцdskamp" "dцdskamper" ;
  doedsmaerkt_av_1 = mkA "dцdsmдrkt" "dцdsmдrkt" ;
  doedsmask_nn_1 = mkN "dцdsmask" "dцdsmasker" ;
  doedsoffer_nn_1 = mkN "dцdsoffer" neutrum ;
  doedsorsak_nn_1 = mkN "dцdsorsak" "dцdsorsaker" ;
  doedspatrull_nn_1 = mkN "dцdspatrull" "dцdspatruller" ;
  doedsrike_nn_1 = mkN "dцdsrike" ;
  doedssjuk_av_1 = mkA "dцdssjuk" ;
  doedsstelhet_nn_1 = mkN "dцdsstelhet" "dцdsstelheter" ;
  doedsstoet_nn_1 = mkN "dцdsstцt" ;
  doedsstraff_nn_1 = mkN "dцdsstraff" neutrum ;
  doedssynd_nn_1 = mkN "dцdssynd" "dцdssynder" ;
  doedstroett_av_1 = mkA "dцdstrцtt" ;
  doedstyst_av_1 = mkA "dцdstyst" "dцdstyst" ;
  doedsur_nn_1 = mkN "dцdsur" neutrum ;
  doegling_nn_1 = mkN "dцgling" ;
  doeing_nn_1 = mkN "dцing" ;
  doerj_nn_1 = mkN "dцrj" ;
  doerr_nn_1 = mkN "dцrr" ;
  doerrfoerhaenge_nn_1 = mkN "dцrrfцrhдnge" ;
  doerrfoersaeljare_nn_1 = mkN "dцrrfцrsдljare" "dцrrfцrsдljare" ;
  doerrhandtag_nn_1 = mkN "dцrrhandtag" neutrum ;
  doerrkarm_nn_1 = mkN "dцrrkarm" ;
  doerrkedja_nn_1 = mkN "dцrrkedja" ;
  doerrknackare_nn_1 = mkN "dцrrknackare" "dцrrknackare" ;
  doerroeppning_nn_1 = mkN "dцrrцppning" ;
  doerrpost_nn_1 = mkN "dцrrpost" "dцrrposter" ;
  doerrspegel_nn_1 = mkN "dцrrspegel" ;
  doerrstaengare_nn_1 = mkN "dцrrstдngare" "dцrrstдngare" ;
  does_nn_1 = mkN "dцs" ;
  doeskraj_av_1 = mkA "dцskraj" ;
  doev_av_1 = mkA "dцv" ;
  doevhet_nn_1 = mkN "dцvhet" "dцvheter" ;
  doevstum_av_1 = mkA "dцvstum" "dцvstumt" "dцvstumma" "dцvstumma" "dцvstummare" "dцvstummast" "dцvstummaste" ;
  doft_nn_1 = mkN "doft" "dofter" ;
  doftaemne_nn_1 = mkN "doftдmne" ;
  doftloes_av_1 = mkA "doftlцs" ;
  doftmarkering_nn_1 = mkN "doftmarkering" ;
  dogcart_nn_1 = mkN "dogcart" "dogcarter" ;
  doge_nn_1 = mkN "doge" "doger" ;
  dogg_nn_1 = mkN "dogg" ;
  dogm_nn_1 = mkN "dogm" "dogmer" ;
  dogmatiker_nn_1 = mkN "dogmatiker" "dogmatikern" "dogmatiker" "dogmatikerna" ;
  dogmatisk_av_1 = mkA "dogmatisk" ;
  dok_nn_1 = mkN "dok" neutrum ;
  doktor_nn_1 = mkN "doktor" "doktorer" ;
  doktorand_nn_1 = mkN "doktorand" "doktorander" ;
  doktorsavhandling_nn_1 = mkN "doktorsavhandling" ;
  doktorsdisputation_nn_1 = mkN "doktorsdisputation" "doktorsdisputationer" ;
  doktorsexamen_nn_1 = mkN "doktorsexamen" "doktorsexamen" "doktorsexamina" "doktorsexamina" ;
  doktorsgrad_nn_1 = mkN "doktorsgrad" "doktorsgrader" ;
  doktorshatt_nn_1 = mkN "doktorshatt" ;
  doktorspromotion_nn_1 = mkN "doktorspromotion" "doktorspromotioner" ;
  doktrin_nn_1 = mkN "doktrin" "doktriner" ;
  doktrinaer_av_1 = mkA "doktrinдr" ;
  dokument_nn_1 = mkN "dokument" neutrum ;
  dokumentaer_av_1 = mkA "dokumentдr" ;
  dokumentaer_nn_1 = mkN "dokumentдr" "dokumentдrer" ;
  dokumentaerfilm_nn_1 = mkN "dokumentдrfilm" "dokumentдrfilmer" ;
  dokumentaerprogram_nn_1 = mkN "dokumentдrprogram" "dokumentдrprogrammet" "dokumentдrprogram" "dokumentдrprogrammen" ;
  dokumentaerroman_nn_1 = mkN "dokumentдrroman" "dokumentдrromaner" ;
  dokumentalist_nn_1 = mkN "dokumentalist" "dokumentalister" ;
  dokumentarisk_av_1 = mkA "dokumentarisk" ;
  dokumentation_nn_1 = mkN "dokumentation" "dokumentationer" ;
  dokumentkreditiv_nn_1 = mkN "dokumentkreditiv" neutrum ;
  dokumentportfoelj_nn_1 = mkN "dokumentportfцlj" "dokumentportfцljer" ;
  dokumentsamling_nn_1 = mkN "dokumentsamling" ;
  dold_av_1 = mkA "dold" "dolt" ;
  doldis_nn_1 = mkN "doldis" ;
  dolikocefal_av_1 = mkA "dolikocefal" ;
  dolikocefal_nn_1 = mkN "dolikocefal" "dolikocefaler" ;
  dolikocefali_nn_1 = mkN "dolikocefali" "dolikocefalier" ;
  dolk_nn_1 = mkN "dolk" ;
  dolkstoet_nn_1 = mkN "dolkstцt" ;
  dollar_nn_1 = mkN "dollar" "dollarn" "dollar" "dollarna" ;
  dollargrin_nn_1 = mkN "dollargrin" neutrum ;
  dollarturist_nn_1 = mkN "dollarturist" "dollarturister" ;
  dolma_nn_1 = mkN "dolma" "dolman" "dolmar" "dolmarna" ;
  dolomit_nn_1 = mkN "dolomit" "dolomiter" ;
  dolsk_av_1 = mkA "dolsk" ;
  dom_nn_1 = mkN "dom" ;
  dom_nn_2 = mkN "dom" "domer" ;
  domaen_nn_1 = mkN "domдn" "domдner" ;
  domaenverk_nn_1 = mkN "domдnverk" neutrum ;
  domare_nn_1 = mkN "domare" "domare" ;
  domared_nn_1 = mkN "domared" "domareder" ;
  domaredans_nn_1 = mkN "domaredans" "domaredanser" ;
  domarring_nn_1 = mkN "domarring" ;
  dombok_nn_1 = mkN "dombok" "dombцcker" ;
  domedagspredikning_nn_1 = mkN "domedagspredikning" ;
  domedagsprofet_nn_1 = mkN "domedagsprofet" "domedagsprofeter" ;
  domestik_nn_1 = mkN "domestik" "domestiker" ;
  domfoer_av_1 = mkA "domfцr" ;
  domhavande_av_1 = mkA "domhavande" ;
  domherre_nn_1 = mkN "domherre" utrum ;
  domicil_nn_1 = mkN "domicil" neutrum ;
  dominant_av_1 = mkA "dominant" "dominant" ;
  dominant_nn_1 = mkN "dominant" "dominanter" ;
  dominerande_av_1 = mkA "dominerande" ;
  dominikan_nn_1 = mkN "dominikan" "dominikaner" ;
  dominikanerorden_nn_1 = mkN "dominikanerorden" ;
  dominikanmunk_nn_1 = mkN "dominikanmunk" ;
  dominikansk_av_1 = mkA "dominikansk" ;
  dominiker_nn_1 = mkN "dominiker" "dominikern" "dominiker" "dominikerna" ;
  dominikisk_av_1 = mkA "dominikisk" ;
  dominion_nn_1 = mkN "dominion" "dominion" "dominier" "dominierna" ;
  domino_nn_1 = mkN "domino" "dominor" ;
  dominoteori_nn_1 = mkN "dominoteori" "dominoteorier" ;
  domkapitel_nn_1 = mkN "domkapitel" neutrum ;
  domkraft_nn_1 = mkN "domkraft" "domkrafter" ;
  domkval_nn_1 = mkN "domkval" neutrum ;
  domkyrka_nn_1 = mkN "domkyrka" ;
  domprost_nn_1 = mkN "domprost" ;
  domptoer_nn_1 = mkN "domptцr" "domptцrer" ;
  domsaga_nn_1 = mkN "domsaga" ;
  domskael_nn_1 = mkN "domskдl" neutrum ;
  domslut_nn_1 = mkN "domslut" neutrum ;
  domsoendag_nn_1 = mkN "domsцndag" ;
  domssoendag_nn_1 = mkN "domssцndag" ;
  domstol_nn_1 = mkN "domstol" ;
  domstolsmaal_nn_1 = mkN "domstolsmеl" neutrum ;
  domstolsprotokoll_nn_1 = mkN "domstolsprotokoll" neutrum ;
  domstolsverk_nn_1 = mkN "domstolsverk" neutrum ;
  don_nn_1 = mkN "don" neutrum ;
  donation_nn_1 = mkN "donation" "donationer" ;
  donationsbrev_nn_1 = mkN "donationsbrev" neutrum ;
  donator_nn_1 = mkN "donator" "donatorer" ;
  doning_nn_1 = mkN "doning" ;
  donjuan_nn_1 = mkN "donjuan" "donjuan" "donjuaner" "donjuanerna" ;
  donlaege_nn_1 = mkN "donlдge" ;
  dop_nn_1 = mkN "dop" neutrum ;
  dopamin_nn_1 = mkN "dopamin" "dopaminer" ;
  dopaminkaenslig_av_1 = mkA "dopaminkдnslig" ;
  dopattest_nn_1 = mkN "dopattest" "dopattester" ;
  dopbassaeng_nn_1 = mkN "dopbassдng" "dopbassдnger" ;
  dopfunt_nn_1 = mkN "dopfunt" ;
  dopnamn_nn_1 = mkN "dopnamn" neutrum ;
  dopp_nn_1 = mkN "dopp" neutrum ;
  dopping_nn_1 = mkN "dopping" ;
  doppsko_nn_1 = mkN "doppsko" "doppskor" ;
  doppvaermare_nn_1 = mkN "doppvдrmare" "doppvдrmare" ;
  dopvittne_nn_1 = mkN "dopvittne" ;
  dorer_nn_1 = mkN "dorer" "dorern" "dorer" "dorerna" ;
  dorisk_av_1 = mkA "dorisk" ;
  dormitorium_nn_1 = mkN "dormitorium" "dormitoriet" "dormitorier" "dormitorierna" ;
  dorn_nn_1 = mkN "dorn" ;
  dorsal_av_1 = mkA "dorsal" ;
  dorsal_nn_1 = mkN "dorsal" "dorsaler" ;
  dorsk_av_1 = mkA "dorsk" ;
  dos_nn_1 = mkN "dos" "doser" ;
  dosbarometer_nn_1 = mkN "dosbarometer" ;
  dosekvivalent_nn_1 = mkN "dosekvivalent" "dosekvivalenter" ;
  dosering_nn_1 = mkN "dosering" ;
  dosimeter_nn_1 = mkN "dosimeter" ;
  doslibell_nn_1 = mkN "doslibell" "doslibeller" ;
  dosmaetare_nn_1 = mkN "dosmдtare" "dosmдtare" ;
  dossering_nn_1 = mkN "dossering" ;
  dossier_nn_1 = mkN "dossier" "dossiern" "dossierer" "dossiererna" ;
  dotation_nn_1 = mkN "dotation" "dotationer" ;
  dotter_nn_1 = mkN "dotter" "dottern" "dцttrar" "dцttrarna" ;
  dotterbolag_nn_1 = mkN "dotterbolag" neutrum ;
  dottercell_nn_1 = mkN "dottercell" "dotterceller" ;
  dotterdotter_nn_1 = mkN "dotterdotter" "dotterdottern" "dotterdцttrar" "dotterdцttrarna" ;
  dotterfoeretag_nn_1 = mkN "dotterfцretag" neutrum ;
  dotterfoersamling_nn_1 = mkN "dotterfцrsamling" ;
  dotterlig_av_1 = mkA "dotterlig" ;
  dotterson_nn_1 = mkN "dotterson" "dottersцner" ;
  dotterspraak_nn_1 = mkN "dottersprеk" neutrum ;
  dottersvulst_nn_1 = mkN "dottersvulst" "dottersvulster" ;
  dottertumoer_nn_1 = mkN "dottertumцr" "dottertumцrer" ;
  double_nn_2 = mkN "doublй" "doublйer" ;
  dov_av_1 = mkA "dov" ;
  dovhjort_nn_1 = mkN "dovhjort" ;
  downperiod_nn_1 = mkN "downperiod" "downperioder" ;
  doyen_nn_1 = mkN "doyen" "doyener" ;
  dra_vb_1 = mkV "dra" "drar" "dra" "drog" "dragit" "dragen" ;
  draap_nn_1 = mkN "drеp" neutrum ;
  draapare_nn_1 = mkN "drеpare" "drеpare" ;
  draaplig_av_1 = mkA "drеplig" ;
  draapslag_nn_1 = mkN "drеpslag" neutrum ;
  draase_nn_1 = mkN "drеse" utrum ;
  drabant_nn_1 = mkN "drabant" "drabanter" ;
  drabantstat_nn_1 = mkN "drabantstat" "drabantstater" ;
  drabbning_nn_1 = mkN "drabbning" ;
  draeglig_av_1 = mkA "drдglig" ;
  draekt_nn_1 = mkN "drдkt" "drдkter" ;
  draektig_av_1 = mkA "drдktig" ;
  draektighet_nn_1 = mkN "drдktighet" "drдktigheter" ;
  draen_nn_1 = mkN "drдn" "drдner" ;
  draenering_nn_1 = mkN "drдnering" ;
  draeneringsdike_nn_1 = mkN "drдneringsdike" ;
  draeneringsomraade_nn_1 = mkN "drдneringsomrеde" ;
  draeng_nn_1 = mkN "drдng" ;
  draengtjaenst_nn_1 = mkN "drдngtjдnst" "drдngtjдnster" ;
  draepande_av_1 = mkA "drдpande" ;
  draetselkammare_nn_1 = mkN "drдtselkammare" "drдtselkammaren" "drдtselkamrar" "drдtselkamrarna" ;
  draett_nn_1 = mkN "drдtt" ;
  drag_nn_1 = mkN "drag" neutrum ;
  dragare_nn_1 = mkN "dragare" "dragare" ;
  dragbaenk_nn_1 = mkN "dragbдnk" ;
  dragband_nn_1 = mkN "dragband" neutrum ;
  dragbasun_nn_1 = mkN "dragbasun" "dragbasuner" ;
  dragbil_nn_1 = mkN "dragbil" ;
  dragdjur_nn_1 = mkN "dragdjur" neutrum ;
  drage_nn_1 = mkN "dragй" "dragйer" ;
  dragen_av_1 = mkA "dragen" "draget" ;
  dragg_nn_1 = mkN "dragg" ;
  draghaallfasthet_nn_1 = mkN "draghеllfasthet" "draghеllfastheter" ;
  dragig_av_1 = mkA "dragig" ;
  dragkamp_nn_1 = mkN "dragkamp" "dragkamper" ;
  dragkedja_nn_1 = mkN "dragkedja" ;
  dragkrok_nn_1 = mkN "dragkrok" ;
  dragnagel_nn_1 = mkN "dragnagel" ;
  dragning_nn_1 = mkN "dragning" ;
  dragoman_nn_1 = mkN "dragoman" "dragomaner" ;
  dragon_nn_1 = mkN "dragon" "dragoner" ;
  dragplaaster_nn_1 = mkN "dragplеster" neutrum ;
  dragpress_nn_1 = mkN "dragpress" ;
  dragprov_nn_1 = mkN "dragprov" neutrum ;
  dragshow_nn_1 = mkN "dragshow" "dragshower" ;
  dragskaap_nn_1 = mkN "dragskеp" neutrum ;
  dragsko_nn_1 = mkN "dragsko" "dragskor" ;
  dragspel_nn_1 = mkN "dragspel" "dragspelet" "dragspel" "dragspelen" ;
  dragstift_nn_1 = mkN "dragstift" neutrum ;
  drakblodstraed_nn_1 = mkN "drakblodstrдd" neutrum ;
  drake_nn_1 = mkN "drake" utrum ;
  drakflygare_nn_1 = mkN "drakflygare" "drakflygare" ;
  drakhuvudfisk_nn_1 = mkN "drakhuvudfisk" ;
  drakma_nn_1 = mkN "drakma" "drakman" "drakmer" "drakmerna" ;
  drakonisk_av_1 = mkA "drakonisk" ;
  draksaadd_nn_1 = mkN "draksеdd" "draksеdder" ;
  drakskepp_nn_1 = mkN "drakskepp" neutrum ;
  dram_nn_1 = mkN "dram" "dramer" ;
  drama_nn_1 = mkN "drama" "dramat" "draman" "dramana" ;
  dramatiker_nn_1 = mkN "dramatiker" "dramatikern" "dramatiker" "dramatikerna" ;
  dramatisering_nn_1 = mkN "dramatisering" ;
  dramatisk_av_1 = mkA "dramatisk" ;
  dramaturg_nn_1 = mkN "dramaturg" "dramaturger" ;
  draperi_nn_1 = mkN "draperi" "draperit" "draperier" "draperierna" ;
  drapering_nn_1 = mkN "drapering" ;
  drastisk_av_1 = mkA "drastisk" ;
  drasut_nn_1 = mkN "drasut" "drasuter" ;
  dress_nn_1 = mkN "dress" ;
  dressin_nn_1 = mkN "dressin" "dressiner" ;
  dressing_nn_1 = mkN "dressing" ;
  dressoer_nn_1 = mkN "dressцr" "dressцrer" ;
  dressyr_nn_1 = mkN "dressyr" "dressyrer" ;
  dressyrridning_nn_1 = mkN "dressyrridning" ;
  drev_nn_1 = mkN "drev" neutrum ;
  drever_nn_1 = mkN "drever" ;
  drevhund_nn_1 = mkN "drevhund" ;
  drevjakt_nn_1 = mkN "drevjakt" "drevjakter" ;
  drevkarl_nn_1 = mkN "drevkarl" ;
  dribbler_nn_1 = mkN "dribbler" "dribblern" "dribbler" "dribblerna" ;
  dribbling_nn_1 = mkN "dribbling" ;
  dricka_vb_1 = mkV "dricka" "drack" "druckit" ;
  drickankare_nn_1 = mkN "drickankare" "drickankaret" "drickankare" "drickankarna" ;
  drickbar_av_1 = mkA "drickbar" ;
  dricksglas_nn_1 = mkN "dricksglas" neutrum ;
  drickspeng_nn_1 = mkN "drickspeng" ;
  dricksvatten_nn_1 = mkN "dricksvatten" "dricksvattnet" "dricksvatten" "dricksvattnen" ;
  drift_nn_2 = mkN "drift" "drifter" ;
  driftbudget_nn_1 = mkN "driftbudget" ;
  driftig_av_1 = mkA "driftig" ;
  driftkostnad_nn_1 = mkN "driftkostnad" "driftkostnader" ;
  driftkucku_nn_1 = mkN "driftkucku" ;
  driftsaeker_av_1 = mkA "driftsдker" "driftsдkert" "driftsдkra" "driftsдkra" "driftsдkrare" "driftsдkrast" "driftsдkraste" ;
  driftskostnad_nn_1 = mkN "driftskostnad" "driftskostnader" ;
  driftstopp_nn_1 = mkN "driftstopp" neutrum ;
  drill_nn_1 = mkN "drill" ;
  drillborr_nn_1 = mkN "drillborr" ;
  drilling_nn_1 = mkN "drilling" ;
  drink_nn_1 = mkN "drink" ;
  drinkare_nn_1 = mkN "drinkare" "drinkare" ;
  dristig_av_1 = mkA "dristig" ;
  drittel_nn_1 = mkN "drittel" ;
  driv_nn_1 = mkN "driv" ;
  driva_vb_1 = mkV "driva" "drev" "drivit" ;
  drivande_av_1 = mkA "drivande" ;
  drivankare_nn_1 = mkN "drivankare" "drivankaret" "drivankare" "drivankarna" ;
  drivaxel_nn_1 = mkN "drivaxel" ;
  drivbaenk_nn_1 = mkN "drivbдnk" ;
  drivband_nn_1 = mkN "drivband" neutrum ;
  drive_nn_1 = mkN "drive" utrum ;
  driven_av_1 = mkA "driven" "drivet" ;
  drivfjaeder_nn_1 = mkN "drivfjдder" ;
  drivgarn_nn_1 = mkN "drivgarn" neutrum ;
  drivhjul_nn_1 = mkN "drivhjul" neutrum ;
  drivhus_nn_1 = mkN "drivhus" neutrum ;
  drivkedja_nn_1 = mkN "drivkedja" ;
  drivkraft_nn_1 = mkN "drivkraft" "drivkrafter" ;
  drivmedel_nn_1 = mkN "drivmedel" neutrum ;
  droeg_nn_1 = mkN "drцg" ;
  droeglapp_nn_1 = mkN "drцglapp" ;
  droejsmaal_nn_1 = mkN "drцjsmеl" neutrum ;
  droem_nn_1 = mkN "drцm" "drцmmen" "drцmmar" "drцmmarna" ;
  droembok_nn_1 = mkN "drцmbok" "drцmbцcker" ;
  droemmare_nn_1 = mkN "drцmmare" "drцmmare" ;
  droemmeri_nn_1 = mkN "drцmmeri" "drцmmerit" "drцmmerier" "drцmmerierna" ;
  droemsk_av_1 = mkA "drцmsk" ;
  droemslott_nn_1 = mkN "drцmslott" neutrum ;
  droemtydning_nn_1 = mkN "drцmtydning" ;
  droemvaerld_nn_1 = mkN "drцmvдrld" ;
  droenare_nn_1 = mkN "drцnare" "drцnare" ;
  droes_nn_1 = mkN "drцs" ;
  droese_nn_1 = mkN "drцse" utrum ;
  drog_nn_1 = mkN "drog" "droger" ;
  drogeri_nn_1 = mkN "drogeri" "drogerit" "drogerier" "drogerierna" ;
  droghandel_nn_1 = mkN "droghandel" ;
  drogmissbruk_nn_1 = mkN "drogmissbruk" neutrum ;
  drogmissbrukare_nn_1 = mkN "drogmissbrukare" "drogmissbrukare" ;
  dromedar_nn_1 = mkN "dromedar" "dromedarer" ;
  dront_nn_1 = mkN "dront" "dronter" ;
  droppe_nn_1 = mkN "droppe" utrum ;
  droppglas_nn_1 = mkN "droppglas" neutrum ;
  droppinfektion_nn_1 = mkN "droppinfektion" "droppinfektioner" ;
  droppkork_nn_1 = mkN "droppkork" ;
  droppspets_nn_1 = mkN "droppspets" ;
  droppsten_nn_1 = mkN "droppsten" "droppstenen" "droppstenar" "droppstenarna" ;
  droppvis_ab_1 = mkAdv "droppvis" ;
  droskfoerare_nn_1 = mkN "droskfцrare" "droskfцrare" ;
  drossel_nn_1 = mkN "drossel" ;
  drots_nn_1 = mkN "drots" ;
  drott_nn_1 = mkN "drott" ;
  drottning_nn_1 = mkN "drottning" ;
  drucken_av_1 = mkA "drucken" "drucket" ;
  drufs_nn_1 = mkN "drufs" ;
  druid_nn_1 = mkN "druid" "druider" ;
  drul_nn_1 = mkN "drul" ;
  drulle_nn_1 = mkN "drulle" utrum ;
  drullefoersaekring_nn_1 = mkN "drullefцrsдkring" ;
  drullig_av_1 = mkA "drullig" ;
  drullputt_nn_1 = mkN "drullputt" ;
  drumlig_av_1 = mkA "drumlig" ;
  drummel_nn_1 = mkN "drummel" "drummeln" "drummlar" "drummlarna" ;
  drummelaktig_av_1 = mkA "drummelaktig" ;
  drunkning_nn_1 = mkN "drunkning" ;
  drus_nn_1 = mkN "drus" "druser" ;
  druvblaa_av_1 = mkA "druvblе" "druvblеtt" ;
  druvboerd_nn_1 = mkN "druvbцrd" "druvbцrder" ;
  druvflaeder_nn_1 = mkN "druvflдder" ;
  druvhagel_nn_1 = mkN "druvhagel" neutrum ;
  druvklase_nn_1 = mkN "druvklase" utrum ;
  druvrussin_nn_1 = mkN "druvrussin" neutrum ;
  dryad_nn_1 = mkN "dryad" "dryader" ;
  dryck_nn_1 = mkN "dryck" "drycker" ;
  dryckesbroder_nn_1 = mkN "dryckesbroder" "dryckesbrodern" "dryckesbrцder" "dryckesbrцderna" ;
  dryckeshorn_nn_1 = mkN "dryckeshorn" neutrum ;
  dryckeskaerl_nn_1 = mkN "dryckeskдrl" neutrum ;
  dryckeslag_nn_1 = mkN "dryckeslag" neutrum ;
  dryckesoffer_nn_1 = mkN "dryckesoffer" neutrum ;
  dryckesservis_nn_1 = mkN "dryckesservis" "dryckesserviser" ;
  dryg_av_1 = mkA "dryg" ;
  dryghet_nn_1 = mkN "dryghet" "drygheter" ;
  dualist_nn_1 = mkN "dualist" "dualister" ;
  dualistisk_av_1 = mkA "dualistisk" ;
  dubb_nn_1 = mkN "dubb" ;
  dubbdaeck_nn_1 = mkN "dubbdдck" neutrum ;
  dubbel_av_1 = mkA "dubbel" "dubbelt" "dubbla" "dubbla" "dubblare" "dubblast" "dubblaste" ;
  dubbelagent_nn_1 = mkN "dubbelagent" "dubbelagenter" ;
  dubbelarbetande_av_1 = mkA "dubbelarbetande" ;
  dubbelbeckasin_nn_1 = mkN "dubbelbeckasin" "dubbelbeckasiner" ;
  dubbelbiff_nn_1 = mkN "dubbelbiff" ;
  dubbelbindning_nn_1 = mkN "dubbelbindning" ;
  dubbelbluff_nn_1 = mkN "dubbelbluff" ;
  dubbelbotten_nn_1 = mkN "dubbelbotten" ;
  dubbelbredd_nn_1 = mkN "dubbelbredd" "dubbelbredder" ;
  dubbelbroellop_nn_1 = mkN "dubbelbrцllop" neutrum ;
  dubbelbrytning_nn_1 = mkN "dubbelbrytning" ;
  dubbeldaeckare_nn_1 = mkN "dubbeldдckare" "dubbeldдckare" ;
  dubbeldoerr_nn_1 = mkN "dubbeldцrr" ;
  dubbelfel_nn_1 = mkN "dubbelfel" "dubbelfelet" "dubbelfel" "dubbelfelen" ;
  dubbelfoenster_nn_1 = mkN "dubbelfцnster" neutrum ;
  dubbelgaangare_nn_1 = mkN "dubbelgеngare" "dubbelgеngare" ;
  dubbelgrepp_nn_1 = mkN "dubbelgrepp" neutrum ;
  dubbelhet_nn_1 = mkN "dubbelhet" "dubbelheter" ;
  dubbelhytt_nn_1 = mkN "dubbelhytt" "dubbelhytter" ;
  dubbelkommando_nn_1 = mkN "dubbelkommando" "dubbelkommandot" "dubbelkommandon" "dubbelkommandona" ;
  dubbelkontakt_nn_1 = mkN "dubbelkontakt" "dubbelkontakter" ;
  dubbelmening_nn_1 = mkN "dubbelmening" ;
  dubbelmord_nn_1 = mkN "dubbelmord" neutrum ;
  dubbelnamn_nn_1 = mkN "dubbelnamn" neutrum ;
  dubbelnatur_nn_1 = mkN "dubbelnatur" "dubbelnaturer" ;
  dubbelnoet_nn_1 = mkN "dubbelnцt" "dubbelnцtter" ;
  dubbelpipig_av_1 = mkA "dubbelpipig" ;
  dubbelrevolution_nn_1 = mkN "dubbelrevolution" "dubbelrevolutioner" ;
  dubbelroer_nn_1 = mkN "dubbelrцr" neutrum ;
  dubbelroll_nn_1 = mkN "dubbelroll" "dubbelroller" ;
  dubbelrum_nn_1 = mkN "dubbelrum" "dubbelrummet" "dubbelrum" "dubbelrummen" ;
  dubbelsaeng_nn_1 = mkN "dubbelsдng" ;
  dubbelsalt_nn_1 = mkN "dubbelsalt" "dubbelsaltet" "dubbelsalter" "dubbelsalterna" ;
  dubbelsidig_av_1 = mkA "dubbelsidig" ;
  dubbelspel_nn_1 = mkN "dubbelspel" "dubbelspelet" "dubbelspel" "dubbelspelen" ;
  dubbelstjaernsystem_nn_1 = mkN "dubbelstjдrnsystem" neutrum ;
  dubbeltimme_nn_1 = mkN "dubbeltimme" utrum ;
  dubbeltraadig_av_1 = mkA "dubbeltrеdig" ;
  dubbeltraeff_nn_1 = mkN "dubbeltrдff" ;
  dubbeltydig_av_1 = mkA "dubbeltydig" ;
  dubble_nn_2 = mkN "dubblй" "dubblйer" ;
  dubblett_nn_1 = mkN "dubblett" "dubbletter" ;
  dubioes_av_1 = mkA "dubiцs" ;
  dublett_nn_1 = mkN "dublett" "dubletter" ;
  duchatel_nn_1 = mkN "duchatel" "duchateler" ;
  duell_nn_1 = mkN "duell" "dueller" ;
  duellant_nn_1 = mkN "duellant" "duellanter" ;
  duett_nn_1 = mkN "duett" "duetter" ;
  duffel_nn_1 = mkN "duffel" ;
  dugande_av_1 = mkA "dugande" ;
  duggregn_nn_1 = mkN "duggregn" neutrum ;
  duglig_av_1 = mkA "duglig" ;
  duglighet_nn_1 = mkN "duglighet" "dugligheter" ;
  duk_nn_1 = mkN "duk" ;
  dukagaang_nn_1 = mkN "dukagеng" ;
  dukat_nn_1 = mkN "dukat" "dukater" ;
  dukning_nn_1 = mkN "dukning" ;
  dukt_nn_1 = mkN "dukt" "dukter" ;
  duktig_av_1 = mkA "duktig" ;
  dulcian_nn_1 = mkN "dulcian" "dulcianer" ;
  dum_av_1 = mkA "dum" "dumt" "dumma" "dumma" "dummare" "dummast" "dummaste" ;
  dumbom_nn_1 = mkN "dumbom" "dumbommen" "dumbommar" "dumbommarna" ;
  dumdristig_av_1 = mkA "dumdristig" ;
  dumdryg_av_1 = mkA "dumdryg" ;
  dumhet_nn_1 = mkN "dumhet" "dumheter" ;
  dumhuvud_nn_1 = mkN "dumhuvud" "dumhuvudet" "dumhuvuden" "dumhuvudena" ;
  dummerjoens_nn_1 = mkN "dummerjцns" ;
  dumming_nn_1 = mkN "dumming" ;
  dummy_nn_1 = mkN "dummy" "dummyn" "dummies" "dummyerna" ;
  dumper_nn_1 = mkN "dumper" ;
  dumskalle_nn_1 = mkN "dumskalle" utrum ;
  dumsnut_nn_1 = mkN "dumsnut" ;
  dun_nn_1 = mkN "dun" neutrum ;
  dunboll_nn_1 = mkN "dunboll" ;
  dunder_nn_1 = mkN "dunder" neutrum ;
  dunge_nn_1 = mkN "dunge" utrum ;
  dunig_av_1 = mkA "dunig" ;
  dunk_nn_1 = mkN "dunk" ;
  dunkel_av_1 = mkA "dunkel" "dunkelt" "dunkla" "dunkla" "dunklare" "dunklast" "dunklaste" ;
  dunkelblaa_av_1 = mkA "dunkelblе" "dunkelblеtt" ;
  dunlaett_av_1 = mkA "dunlдtt" ;
  duns_nn_1 = mkN "duns" ;
  dunst_nn_1 = mkN "dunst" "dunster" ;
  dunstig_av_1 = mkA "dunstig" ;
  dununge_nn_1 = mkN "dununge" utrum ;
  duo_nn_1 = mkN "duo" "duon" "duos" "duosen" ;
  duodecimalsystem_nn_1 = mkN "duodecimalsystem" neutrum ;
  duodes_nn_1 = mkN "duodes" "duodeser" ;
  duplett_nn_1 = mkN "duplett" "dupletter" ;
  duplexfaerg_nn_1 = mkN "duplexfдrg" "duplexfдrger" ;
  duplicering_nn_1 = mkN "duplicering" ;
  duplik_nn_1 = mkN "duplik" "dupliker" ;
  duplikat_nn_1 = mkN "duplikat" neutrum ;
  duplikator_nn_1 = mkN "duplikator" "duplikatorer" ;
  durabel_av_1 = mkA "durabel" ;
  duralexglas_nn_1 = mkN "duralexglas" neutrum ;
  durativ_av_1 = mkA "durativ" ;
  dureform_nn_1 = mkN "dureform" "dureformer" ;
  durk_nn_1 = mkN "durk" ;
  durkdriven_av_1 = mkA "durkdriven" "durkdrivet" ;
  durkslag_nn_1 = mkN "durkslag" neutrum ;
  duroplast_nn_1 = mkN "duroplast" "duroplaster" ;
  dus_nn_1 = mkN "dus" "duser" ;
  dusch_nn_1 = mkN "dusch" ;
  duskaal_nn_1 = mkN "duskеl" ;
  dusoer_nn_1 = mkN "dusцr" "dusцrer" ;
  dussin_nn_1 = mkN "dussin" neutrum ;
  dussinmaenniska_nn_1 = mkN "dussinmдnniska" ;
  dussinroman_nn_1 = mkN "dussinroman" "dussinromaner" ;
  dussintal_nn_1 = mkN "dussintal" "dussintalet" "dussintalen" "dussintalena" ;
  dussintals_ab_1 = mkAdv "dussintals" ;
  dussinvis_ab_1 = mkAdv "dussinvis" ;
  dust_nn_1 = mkN "dust" "duster" ;
  duvblaa_av_1 = mkA "duvblе" "duvblеtt" ;
  duven_av_1 = mkA "duven" "duvet" ;
  duvfaagel_nn_1 = mkN "duvfеgel" ;
  duvhoek_nn_1 = mkN "duvhцk" ;
  duvning_nn_1 = mkN "duvning" ;
  duvslag_nn_1 = mkN "duvslag" neutrum ;
  duvunge_nn_1 = mkN "duvunge" utrum ;
  dvaerg_nn_1 = mkN "dvдrg" ;
  dvaergbjoerk_nn_1 = mkN "dvдrgbjцrk" ;
  dvaergbrytare_nn_1 = mkN "dvдrgbrytare" "dvдrgbrytare" ;
  dvaergbuske_nn_1 = mkN "dvдrgbuske" utrum ;
  dvaerggalax_nn_1 = mkN "dvдrggalax" "dvдrggalaxer" ;
  dvaerghamster_nn_1 = mkN "dvдrghamster" ;
  dvaerghund_nn_1 = mkN "dvдrghund" ;
  dyblad_nn_1 = mkN "dyblad" neutrum ;
  dybloet_av_1 = mkA "dyblцt" ;
  dyborre_nn_1 = mkN "dyborre" utrum ;
  dyckert_nn_1 = mkN "dyckert" ;
  dygd_nn_1 = mkN "dygd" "dygder" ;
  dygdemoenster_nn_1 = mkN "dygdemцnster" neutrum ;
  dygdig_av_1 = mkA "dygdig" ;
  dygn_nn_1 = mkN "dygn" neutrum ;
  dygnsring_nn_1 = mkN "dygnsring" ;
  dygnsrytm_nn_1 = mkN "dygnsrytm" "dygnsrytmer" ;
  dyig_av_1 = mkA "dyig" ;
  dykand_nn_1 = mkN "dykand" "dykдnder" ;
  dykarbagge_nn_1 = mkN "dykarbagge" utrum ;
  dykardraekt_nn_1 = mkN "dykardrдkt" "dykardrдkter" ;
  dykare_nn_1 = mkN "dykare" "dykare" ;
  dykarutrustning_nn_1 = mkN "dykarutrustning" ;
  dykdalb_nn_1 = mkN "dykdalb" "dykdalber" ;
  dykning_nn_1 = mkN "dykning" ;
  dymedelst_ab_1 = mkAdv "dymedelst" ;
  dymling_nn_1 = mkN "dymling" ;
  dymmelonsdag_nn_1 = mkN "dymmelonsdag" ;
  dymmelvecka_nn_1 = mkN "dymmelvecka" ;
  dyn_nn_1 = mkN "dyn" "dyner" ;
  dyn_nn_2 = mkN "dyn" neutrum ;
  dynamisk_av_1 = mkA "dynamisk" ;
  dynamitard_nn_1 = mkN "dynamitard" "dynamitarder" ;
  dynamitgubbe_nn_1 = mkN "dynamitgubbe" utrum ;
  dynamo_nn_1 = mkN "dynamo" "dynamor" ;
  dynamometer_nn_1 = mkN "dynamometer" ;
  dynasti_nn_1 = mkN "dynasti" "dynastier" ;
  dynastisk_av_1 = mkA "dynastisk" ;
  dyngbagge_nn_1 = mkN "dyngbagge" utrum ;
  dyning_nn_1 = mkN "dyning" ;
  dyr_av_1 = mkA "dyr" ;
  dyrbar_av_1 = mkA "dyrbar" ;
  dyrbarhet_nn_1 = mkN "dyrbarhet" "dyrbarheter" ;
  dyrgrip_nn_1 = mkN "dyrgrip" ;
  dyrk_nn_1 = mkN "dyrk" ;
  dyrkansvaerd_av_1 = mkA "dyrkansvдrd" "dyrkansvдrt" ;
  dyrkare_nn_1 = mkN "dyrkare" "dyrkare" ;
  dyrkfri_av_1 = mkA "dyrkfri" "dyrkfritt" ;
  dyrkoept_av_1 = mkA "dyrkцpt" "dyrkцpt" ;
  dyrort_nn_1 = mkN "dyrort" "dyrorter" ;
  dyrortsgrupp_nn_1 = mkN "dyrortsgrupp" "dyrortsgrupper" ;
  dyrortsgruppering_nn_1 = mkN "dyrortsgruppering" ;
  dyrtid_nn_1 = mkN "dyrtid" "dyrtider" ;
  dys_nn_1 = mkN "dys" "dyser" ;
  dyschatell_nn_1 = mkN "dyschatell" "dyschateller" ;
  dysenteri_nn_1 = mkN "dysenteri" "dysenterier" ;
  dysfori_nn_1 = mkN "dysfori" "dysforier" ;
  dyslexi_nn_1 = mkN "dyslexi" "dyslexier" ;
  dyspepsi_nn_1 = mkN "dyspepsi" "dyspepsier" ;
  dyster_av_1 = mkA "dyster" "dystert" "dystra" "dystra" "dystrare" "dystrast" "dystraste" ;
  dystopi_nn_1 = mkN "dystopi" "dystopier" ;
  dystrof_av_1 = mkA "dystrof" ;
  dystrofi_nn_1 = mkN "dystrofi" "dystrofier" ;
  dyvaat_av_1 = mkA "dyvеt" ;
  e_brev_nn_1 = mkN "e-brev" neutrum ;
  e_mail_nn_2 = mkN "e-mail" neutrum ;
  ebenist_nn_1 = mkN "ebenist" "ebenister" ;
  ebonitstav_nn_1 = mkN "ebonitstav" ;
  echelong_nn_1 = mkN "echelong" "echelonger" ;
  ecklesiastik_av_1 = mkA "ecklesiastik" ;
  ecklesiastikdepartement_nn_1 = mkN "ecklesiastikdepartement" "ecklesiastikdepartementet" "ecklesiastikdepartementen" "ecklesiastikdepartementena" ;
  ecklesiastikminister_nn_1 = mkN "ecklesiastikminister" ;
  ecklesiastisk_av_1 = mkA "ecklesiastisk" ;
  ecuadorian_nn_1 = mkN "ecuadorian" "ecuadorianer" ;
  ecuadoriansk_av_1 = mkA "ecuadoriansk" ;
  ecuadorianska_nn_1 = mkN "ecuadorianska" ;
  ed_ab_1 = mkAdv "ed" ;
  ed_nn_1 = mkN "ed" "eder" ;
  ed_nn_2 = mkN "ed" neutrum ;
  edamerost_nn_1 = mkN "edamerost" ;
  edgaang_nn_1 = mkN "edgеng" ;
  edikt_nn_1 = mkN "edikt" neutrum ;
  edil_nn_1 = mkN "edil" "ediler" ;
  edition_nn_1 = mkN "edition" "editioner" ;
  edlig_av_1 = mkA "edlig" ;
  edligen_ab_1 = mkAdv "edligen" ;
  edsbrott_nn_1 = mkN "edsbrott" neutrum ;
  edsvuren_av_1 = mkA "edsvuren" "edsvuret" ;
  efedrin_nn_1 = mkN "efedrin" "efedriner" ;
  efemaer_av_1 = mkA "efemдr" ;
  efemerid_nn_1 = mkN "efemerid" "efemerider" ;
  effekt_nn_1 = mkN "effekt" "effekter" ;
  effektfaktor_nn_1 = mkN "effektfaktor" "effektfaktorer" ;
  effektfoerstaerkare_nn_1 = mkN "effektfцrstдrkare" "effektfцrstдrkare" ;
  effektfraanskiljare_nn_1 = mkN "effektfrеnskiljare" "effektfrеnskiljare" ;
  effektfull_av_1 = mkA "effektfull" ;
  effektiv_av_1 = mkA "effektiv" ;
  effektivitet_nn_1 = mkN "effektivitet" "effektiviteter" ;
  effektoekning_nn_1 = mkN "effektцkning" ;
  effektsoekeri_nn_1 = mkN "effektsцkeri" "effektsцkerit" "effektsцkerier" "effektsцkerierna" ;
  efor_nn_1 = mkN "efor" "eforen" "eforer" "eforerna" ;
  eforus_nn_1 = mkN "eforus" "eforus" "eforer" "eforerna" ;
  efter_ab_1 = mkAdv "efter" ;
  efter_av_1 = mkA "efter" ;
  efteraat_ab_1 = mkAdv "efterеt" ;
  efteraccept_nn_1 = mkN "efteraccept" neutrum ;
  efterbesiktning_nn_1 = mkN "efterbesiktning" ;
  efterbeskattning_nn_1 = mkN "efterbeskattning" ;
  efterbestaellning_nn_1 = mkN "efterbestдllning" ;
  efterbild_nn_1 = mkN "efterbild" "efterbilder" ;
  efterbildning_nn_1 = mkN "efterbildning" ;
  efterbliven_av_1 = mkA "efterbliven" "efterblivet" ;
  efterbloedning_nn_1 = mkN "efterblцdning" ;
  efterboerd_nn_1 = mkN "efterbцrd" "efterbцrder" ;
  efterboers_nn_1 = mkN "efterbцrs" "efterbцrser" ;
  efterbraennare_nn_1 = mkN "efterbrдnnare" "efterbrдnnare" ;
  efterbraennkammare_nn_1 = mkN "efterbrдnnkammare" "efterbrдnnkammaren" "efterbrдnnkamrar" "efterbrдnnkamrarna" ;
  efterdoeme_nn_1 = mkN "efterdцme" ;
  efterdoemlig_av_1 = mkA "efterdцmlig" ;
  efterdyning_nn_1 = mkN "efterdyning" ;
  efterfoeljansvaerd_av_1 = mkA "efterfцljansvдrd" "efterfцljansvдrt" ;
  efterfoeljare_nn_1 = mkN "efterfцljare" "efterfцljare" ;
  efterfoeljelse_nn_1 = mkN "efterfцljelse" "efterfцljelser" ;
  efterforskning_nn_1 = mkN "efterforskning" ;
  efterfraagning_nn_1 = mkN "efterfrеgning" ;
  efterge_vb_1 = mkV "efterge" "efterger" "efterge" "eftergav" "eftergett" "eftergiven" ;
  eftergift_nn_1 = mkN "eftergift" "eftergifter" ;
  eftergiven_av_1 = mkA "eftergiven" "eftergivet" ;
  eftergivenhet_nn_1 = mkN "eftergivenhet" "eftergivenheter" ;
  eftergivlig_av_1 = mkA "eftergivlig" ;
  eftergjord_av_1 = mkA "eftergjord" "eftergjort" ;
  eftergranskning_nn_1 = mkN "eftergranskning" ;
  eftergymnasial_av_1 = mkA "eftergymnasial" ;
  efterhaalla_vb_1 = mkV "efterhеlla" "efterhцll" "efterhеllit" ;
  efterhaengsen_av_1 = mkA "efterhдngsen" "efterhдngset" ;
  efterhaermning_nn_1 = mkN "efterhдrmning" ;
  efterhand_ab_1 = mkAdv "efterhand" ;
  efterhandskonstruktion_nn_1 = mkN "efterhandskonstruktion" "efterhandskonstruktioner" ;
  efterhoest_nn_1 = mkN "efterhцst" ;
  efterkaenning_nn_1 = mkN "efterkдnning" ;
  efterklang_nn_1 = mkN "efterklang" "efterklanger" ;
  efterklok_av_1 = mkA "efterklok" ;
  efterkokning_nn_1 = mkN "efterkokning" ;
  efterkomma_vb_1 = mkV "efterkomma" "efterkom" "efterkommit" ;
  efterkommande_nn_1 = mkN "efterkommande" "efterkommanden" "efterkommande" "efterkommandena" ;
  efterkonstruktion_nn_1 = mkN "efterkonstruktion" "efterkonstruktioner" ;
  efterkontroll_nn_1 = mkN "efterkontroll" "efterkontroller" ;
  efterkrav_nn_1 = mkN "efterkrav" neutrum ;
  efterkrigstid_nn_1 = mkN "efterkrigstid" "efterkrigstider" ;
  efterlaata_vb_1 = mkV "efterlеta" "efterlдt" "efterlеtit" ;
  efterlaaten_av_1 = mkA "efterlеten" "efterlеtet" ;
  efterled_nn_1 = mkN "efterled" neutrum ;
  efterlevande_av_1 = mkA "efterlevande" ;
  efterleverska_nn_1 = mkN "efterleverska" ;
  efterlevnad_nn_1 = mkN "efterlevnad" "efterlevnader" ;
  efterliggande_av_1 = mkA "efterliggande" ;
  efterlysning_nn_1 = mkN "efterlysning" ;
  eftermaele_nn_1 = mkN "eftermдle" ;
  eftermiddag_nn_1 = mkN "eftermiddag" ;
  efternamn_nn_1 = mkN "efternamn" neutrum ;
  efterproevning_nn_1 = mkN "efterprцvning" ;
  efterraekning_nn_1 = mkN "efterrдkning" ;
  efterraett_nn_1 = mkN "efterrдtt" "efterrдtter" ;
  efterrationalisering_nn_1 = mkN "efterrationalisering" ;
  eftersaegare_nn_1 = mkN "eftersдgare" "eftersдgare" ;
  eftersaettsblad_nn_1 = mkN "eftersдttsblad" neutrum ;
  eftersats_nn_1 = mkN "eftersats" "eftersatser" ;
  eftersinnande_av_1 = mkA "eftersinnande" ;
  eftersits_nn_1 = mkN "eftersits" ;
  efterskott_nn_1 = mkN "efterskott" neutrum ;
  efterskrift_nn_1 = mkN "efterskrift" "efterskrifter" ;
  efterslaeng_nn_1 = mkN "efterslдng" ;
  efterslaentrare_nn_1 = mkN "efterslдntrare" "efterslдntrare" ;
  efterslag_nn_1 = mkN "efterslag" neutrum ;
  eftersoekt_av_1 = mkA "eftersцkt" "eftersцkt" ;
  eftersommar_nn_1 = mkN "eftersommar" "eftersommarn" "eftersommrar" "eftersommrarna" ;
  efterspaning_nn_1 = mkN "efterspaning" ;
  efterspel_nn_1 = mkN "efterspel" "efterspelet" "efterspel" "efterspelen" ;
  efterst_ab_1 = mkAdv "efterst" ;
  efterstaelld_av_1 = mkA "efterstдlld" "efterstдllt" ;
  efterstraevansvaerd_av_1 = mkA "efterstrдvansvдrd" "efterstrдvansvдrt" ;
  efterstygn_nn_1 = mkN "efterstygn" neutrum ;
  eftertaenksam_av_1 = mkA "eftertдnksam" "eftertдnksamt" "eftertдnksamma" "eftertдnksamma" "eftertдnksammare" "eftertдnksammast" "eftertдnksammaste" ;
  eftertaxering_nn_1 = mkN "eftertaxering" ;
  eftertextnot_nn_1 = mkN "eftertextnot" "eftertextnoter" ;
  eftertraedare_nn_1 = mkN "eftertrдdare" "eftertrдdare" ;
  eftertraktansvaerd_av_1 = mkA "eftertraktansvдrd" "eftertraktansvдrt" ;
  eftertrupp_nn_1 = mkN "eftertrupp" "eftertrupper" ;
  eftertryck_nn_1 = mkN "eftertryck" neutrum ;
  eftertrycklig_av_1 = mkA "eftertrycklig" ;
  eftertryckligen_ab_1 = mkAdv "eftertryckligen" ;
  efterundersoekning_nn_1 = mkN "efterundersцkning" ;
  efterutbildning_nn_1 = mkN "efterutbildning" ;
  efterverkning_nn_1 = mkN "efterverkning" ;
  eftervinter_nn_1 = mkN "eftervinter" ;
  eftervis_av_1 = mkA "eftervis" ;
  egal_av_1 = mkA "egal" ;
  egalitaer_av_1 = mkA "egalitдr" ;
  egalitet_nn_1 = mkN "egalitet" "egaliteter" ;
  egeisk_av_1 = mkA "egeisk" ;
  egen_av_1 = mkA "egen" "eget" ;
  egendom_nn_1 = mkN "egendom" ;
  egendomlig_av_1 = mkA "egendomlig" ;
  egendomlighet_nn_1 = mkN "egendomlighet" "egendomligheter" ;
  egendomsaffaer_nn_1 = mkN "egendomsaffдr" "egendomsaffдrer" ;
  egendomsbrott_nn_1 = mkN "egendomsbrott" neutrum ;
  egendomsfoersaeljning_nn_1 = mkN "egendomsfцrsдljning" ;
  egendomsloes_av_1 = mkA "egendomslцs" ;
  egenfrekvens_nn_1 = mkN "egenfrekvens" "egenfrekvenser" ;
  egenhaendig_av_1 = mkA "egenhдndig" ;
  egenhet_nn_1 = mkN "egenhet" "egenheter" ;
  egenkaer_av_1 = mkA "egenkдr" ;
  egenkaerlek_nn_1 = mkN "egenkдrlek" ;
  egenmaektig_av_1 = mkA "egenmдktig" ;
  egennamn_nn_1 = mkN "egennamn" neutrum ;
  egennytta_nn_1 = mkN "egennytta" ;
  egennyttig_av_1 = mkA "egennyttig" ;
  egenraadig_av_1 = mkA "egenrеdig" ;
  egenraettfaerdig_av_1 = mkA "egenrдttfдrdig" ;
  egensinnig_av_1 = mkA "egensinnig" ;
  egenskap_nn_1 = mkN "egenskap" "egenskaper" ;
  egenskapsgenitiv_nn_1 = mkN "egenskapsgenitiv" "egenskapsgenitiver" ;
  egenskapsord_nn_1 = mkN "egenskapsord" neutrum ;
  egentlig_av_1 = mkA "egentlig" ;
  egentligen_ab_1 = mkAdv "egentligen" ;
  egenvarm_av_1 = mkA "egenvarm" ;
  egg_nn_1 = mkN "egg" ;
  eggelse_nn_1 = mkN "eggelse" "eggelser" ;
  eggjaern_nn_1 = mkN "eggjдrn" neutrum ;
  eggvass_av_1 = mkA "eggvass" ;
  eggverktyg_nn_1 = mkN "eggverktyg" neutrum ;
  egnahem_nn_1 = mkN "egnahem" "egnahemmet" "egnahem" "egnahemmen" ;
  egocentricitet_nn_1 = mkN "egocentricitet" "egocentriciteter" ;
  egocentriker_nn_1 = mkN "egocentriker" "egocentrikern" "egocentriker" "egocentrikerna" ;
  egocentrisk_av_1 = mkA "egocentrisk" ;
  egoist_nn_1 = mkN "egoist" "egoister" ;
  egoistisk_av_1 = mkA "egoistisk" ;
  egotripp_nn_1 = mkN "egotripp" ;
  egypter_nn_1 = mkN "egypter" "egyptern" "egypter" "egypterna" ;
  egyptier_nn_1 = mkN "egyptier" "egyptiern" "egyptier" "egyptierna" ;
  egyptisk_av_1 = mkA "egyptisk" ;
  egyptiska_nn_2 = mkN "egyptiska" ;
  egyptolog_nn_1 = mkN "egyptolog" "egyptologer" ;
  eidetisk_av_1 = mkA "eidetisk" ;
  einsteinsk_av_1 = mkA "einsteinsk" ;
  ej_ab_1 = mkAdv "ej" ;
  ejakulat_nn_1 = mkN "ejakulat" neutrum ;
  ejakulation_nn_1 = mkN "ejakulation" "ejakulationer" ;
  ejder_nn_1 = mkN "ejder" ;
  ejderunge_nn_1 = mkN "ejderunge" utrum ;
  ejektor_nn_1 = mkN "ejektor" "ejektorer" ;
  ek_nn_1 = mkN "ek" ;
  ekbock_nn_1 = mkN "ekbock" ;
  eker_nn_1 = mkN "eker" ;
  ekipage_nn_1 = mkN "ekipage" "ekipaget" "ekipage" "ekipagen" ;
  ekipering_nn_1 = mkN "ekipering" ;
  ekiperingsaffaer_nn_1 = mkN "ekiperingsaffдr" "ekiperingsaffдrer" ;
  ekivok_av_1 = mkA "ekivok" ;
  eklaerering_nn_1 = mkN "eklдrering" ;
  eklampsi_nn_1 = mkN "eklampsi" "eklampsier" ;
  eklatant_av_1 = mkA "eklatant" "eklatant" ;
  eklatt_av_1 = mkA "eklatt" ;
  eklektiker_nn_1 = mkN "eklektiker" "eklektikern" "eklektiker" "eklektikerna" ;
  eklektisk_av_1 = mkA "eklektisk" ;
  eklips_nn_1 = mkN "eklips" "eklipser" ;
  eklog_nn_1 = mkN "eklog" "ekloger" ;
  eko_nn_1 = mkN "eko" "ekot" "ekon" "ekona" ;
  ekollon_nn_1 = mkN "ekollon" neutrum ;
  ekolod_nn_1 = mkN "ekolod" neutrum ;
  ekolog_nn_1 = mkN "ekolog" "ekologer" ;
  ekologisk_av_1 = mkA "ekologisk" ;
  ekonom_nn_1 = mkN "ekonom" "ekonomer" ;
  ekonomexamen_nn_1 = mkN "ekonomexamen" "ekonomexamen" "ekonomexamina" "ekonomexamina" ;
  ekonomi_nn_1 = mkN "ekonomi" "ekonomier" ;
  ekonomibitraede_nn_1 = mkN "ekonomibitrдde" ;
  ekonomibrev_nn_1 = mkN "ekonomibrev" neutrum ;
  ekonomibyggnad_nn_1 = mkN "ekonomibyggnad" "ekonomibyggnader" ;
  ekonomie_av_1 = mkA "ekonomie" ;
  ekonomifoerestaandare_nn_1 = mkN "ekonomifцrestеndare" "ekonomifцrestеndare" ;
  ekonomifoerpackning_nn_1 = mkN "ekonomifцrpackning" ;
  ekonomilaera_nn_1 = mkN "ekonomilдra" ;
  ekonomipaket_nn_1 = mkN "ekonomipaket" neutrum ;
  ekonomisk_av_1 = mkA "ekonomisk" ;
  ekoradio_nn_1 = mkN "ekoradio" "ekoradior" ;
  ekorrbaer_nn_1 = mkN "ekorrbдr" neutrum ;
  ekorrdjur_nn_1 = mkN "ekorrdjur" neutrum ;
  ekorre_nn_1 = mkN "ekorre" utrum ;
  ekorrliknande_av_1 = mkA "ekorrliknande" ;
  ekosystem_nn_1 = mkN "ekosystem" neutrum ;
  ekotyp_nn_1 = mkN "ekotyp" "ekotyper" ;
  ekoxe_nn_1 = mkN "ekoxe" utrum ;
  eksem_nn_1 = mkN "eksem" neutrum ;
  ekskog_nn_1 = mkN "ekskog" ;
  ekspinnare_nn_1 = mkN "ekspinnare" "ekspinnare" ;
  ekstock_nn_1 = mkN "ekstock" ;
  ektomi_nn_1 = mkN "ektomi" "ektomier" ;
  ekumenisk_av_1 = mkA "ekumenisk" ;
  ekvation_nn_1 = mkN "ekvation" "ekvationer" ;
  ekvatorial_av_1 = mkA "ekvatorial" ;
  ekvatorialbaelte_nn_1 = mkN "ekvatorialbдlte" ;
  ekvatorialguinean_nn_1 = mkN "ekvatorialguinean" "ekvatorialguineaner" ;
  ekvatorialguineansk_av_1 = mkA "ekvatorialguineansk" ;
  ekvatorialstroem_nn_1 = mkN "ekvatorialstrцm" "ekvatorialstrцmmen" "ekvatorialstrцmmar" "ekvatorialstrцmmarna" ;
  ekvatorialzon_nn_1 = mkN "ekvatorialzon" "ekvatorialzoner" ;
  ekvatoriell_av_1 = mkA "ekvatoriell" ;
  ekvatorsplan_nn_1 = mkN "ekvatorsplan" neutrum ;
  ekvecklare_nn_1 = mkN "ekvecklare" "ekvecklare" ;
  ekvidistant_av_1 = mkA "ekvidistant" "ekvidistant" ;
  ekvilibrist_nn_1 = mkN "ekvilibrist" "ekvilibrister" ;
  ekvilibristisk_av_1 = mkA "ekvilibristisk" ;
  ekvipotentiallinje_nn_1 = mkN "ekvipotentiallinje" "ekvipotentiallinjer" ;
  ekvivalent_av_1 = mkA "ekvivalent" "ekvivalent" ;
  ekvivalentvikt_nn_1 = mkN "ekvivalentvikt" "ekvivalentvikter" ;
  elaenda_av_1 = mkA "elдnda" ;
  elaende_nn_1 = mkN "elдnde" ;
  elaendig_av_1 = mkA "elдndig" ;
  elak_av_1 = mkA "elak" ;
  elakhet_nn_1 = mkN "elakhet" "elakheter" ;
  elaking_nn_1 = mkN "elaking" ;
  eland_nn_1 = mkN "eland" "elander" ;
  elasticitet_nn_1 = mkN "elasticitet" "elasticiteter" ;
  elasticitetsgraens_nn_1 = mkN "elasticitetsgrдns" "elasticitetsgrдnser" ;
  elastisk_av_1 = mkA "elastisk" ;
  elbil_nn_1 = mkN "elbil" ;
  elborste_nn_1 = mkN "elborste" utrum ;
  elchock_nn_1 = mkN "elchock" "elchocker" ;
  eld_nn_1 = mkN "eld" ;
  eldare_nn_1 = mkN "eldare" "eldare" ;
  eldavstaand_nn_1 = mkN "eldavstеnd" neutrum ;
  eldbegaengelse_nn_1 = mkN "eldbegдngelse" "eldbegдngelser" ;
  eldbrand_nn_1 = mkN "eldbrand" "eldbrдnder" ;
  elddon_nn_1 = mkN "elddon" neutrum ;
  elddop_nn_1 = mkN "elddop" neutrum ;
  eldfaengd_av_1 = mkA "eldfдngd" "eldfдngt" ;
  eldfarlig_av_1 = mkA "eldfarlig" ;
  eldfast_av_1 = mkA "eldfast" "eldfast" ;
  eldgaffel_nn_1 = mkN "eldgaffel" ;
  eldhaerd_nn_1 = mkN "eldhдrd" ;
  eldhaerdig_av_1 = mkA "eldhдrdig" ;
  eldhandvapen_nn_1 = mkN "eldhandvapen" "eldhandvapnet" "eldhandvapen" "eldhandvapnen" ;
  eldhastighet_nn_1 = mkN "eldhastighet" "eldhastigheter" ;
  eldhund_nn_1 = mkN "eldhund" ;
  eldhus_nn_1 = mkN "eldhus" neutrum ;
  eldig_av_1 = mkA "eldig" ;
  eldkanal_nn_1 = mkN "eldkanal" "eldkanaler" ;
  eldkastare_nn_1 = mkN "eldkastare" "eldkastare" ;
  eldkommando_nn_1 = mkN "eldkommando" "eldkommandot" "eldkommandon" "eldkommandona" ;
  eldledare_nn_1 = mkN "eldledare" "eldledare" ;
  eldlinje_nn_1 = mkN "eldlinje" "eldlinjer" ;
  eldningsolja_nn_1 = mkN "eldningsolja" ;
  eldoeverfall_nn_1 = mkN "eldцverfall" neutrum ;
  eldorado_nn_1 = mkN "eldorado" "eldoradot" "eldoradon" "eldoradona" ;
  eldprov_nn_1 = mkN "eldprov" neutrum ;
  eldriven_av_1 = mkA "eldriven" "eldrivet" ;
  eldroed_av_1 = mkA "eldrцd" ;
  eldroer_nn_1 = mkN "eldrцr" neutrum ;
  eldsaeker_av_1 = mkA "eldsдker" "eldsдkert" "eldsдkra" "eldsдkra" "eldsдkrare" "eldsдkrast" "eldsдkraste" ;
  eldsalamander_nn_1 = mkN "eldsalamander" ;
  eldsats_nn_1 = mkN "eldsats" "eldsatser" ;
  eldsignal_nn_1 = mkN "eldsignal" "eldsignaler" ;
  eldsignalering_nn_1 = mkN "eldsignalering" ;
  eldsjael_nn_1 = mkN "eldsjдl" ;
  eldsken_nn_1 = mkN "eldsken" neutrum ;
  eldskur_nn_1 = mkN "eldskur" ;
  eldslaeckare_nn_1 = mkN "eldslдckare" "eldslдckare" ;
  eldslaeckning_nn_1 = mkN "eldslдckning" ;
  eldslaendare_nn_1 = mkN "eldslдndare" "eldslдndare" ;
  eldsljus_nn_1 = mkN "eldsljus" neutrum ;
  eldslukare_nn_1 = mkN "eldslukare" "eldslukare" ;
  eldsmaerke_nn_1 = mkN "eldsmдrke" ;
  eldstaal_nn_1 = mkN "eldstеl" neutrum ;
  eldstad_nn_1 = mkN "eldstad" "eldstдder" ;
  eldstaellning_nn_1 = mkN "eldstдllning" ;
  eldstod_nn_1 = mkN "eldstod" "eldstoder" ;
  eldstorm_nn_1 = mkN "eldstorm" ;
  eldstrid_nn_1 = mkN "eldstrid" "eldstrider" ;
  eldsvaada_nn_1 = mkN "eldsvеda" ;
  eldsvaadeunge_nn_1 = mkN "eldsvеdeunge" utrum ;
  eldupphoer_nn_1 = mkN "eldupphцr" neutrum ;
  eldupphoerorder_nn_1 = mkN "eldupphцrorder" ;
  eldvapen_nn_1 = mkN "eldvapen" "eldvapnet" "eldvapen" "eldvapnen" ;
  elefant_nn_1 = mkN "elefant" "elefanter" ;
  elefantbete_nn_1 = mkN "elefantbete" utrum ;
  elefantinhopp_nn_1 = mkN "elefantinhopp" neutrum ;
  elefantnaebbmus_nn_1 = mkN "elefantnдbbmus" "elefantnдbbmusen" "elefantnдbbmцss" "elefantnдbbmцssen" ;
  elegant_av_1 = mkA "elegant" "elegant" ;
  elegi_nn_1 = mkN "elegi" "elegier" ;
  elegisk_av_1 = mkA "elegisk" ;
  elektor_nn_1 = mkN "elektor" "elektorer" ;
  elektricitet_nn_1 = mkN "elektricitet" "elektriciteter" ;
  elektricitetsmaengd_nn_1 = mkN "elektricitetsmдngd" "elektricitetsmдngder" ;
  elektricitetsverk_nn_1 = mkN "elektricitetsverk" neutrum ;
  elektriker_nn_1 = mkN "elektriker" "elektrikern" "elektriker" "elektrikerna" ;
  elektrisk_av_1 = mkA "elektrisk" ;
  elektrochock_nn_1 = mkN "elektrochock" "elektrochocker" ;
  elektrod_nn_1 = mkN "elektrod" "elektroder" ;
  elektroencefalografi_nn_1 = mkN "elektroencefalografi" "elektroencefalografier" ;
  elektroencefalogram_nn_1 = mkN "elektroencefalogram" "elektroencefalogrammet" "elektroencefalogram" "elektroencefalogrammen" ;
  elektrofilter_nn_1 = mkN "elektrofilter" neutrum ;
  elektrofor_nn_1 = mkN "elektrofor" "elektroforen" "elektroforer" "elektroforerna" ;
  elektroingenjoer_nn_1 = mkN "elektroingenjцr" "elektroingenjцrer" ;
  elektrokardiografi_nn_1 = mkN "elektrokardiografi" "elektrokardiografier" ;
  elektrokardiogram_nn_1 = mkN "elektrokardiogram" "elektrokardiogrammet" "elektrokardiogram" "elektrokardiogrammen" ;
  elektrolys_nn_1 = mkN "elektrolys" "elektrolyser" ;
  elektrolyt_nn_1 = mkN "elektrolyt" "elektrolyter" ;
  elektrolytisk_av_1 = mkA "elektrolytisk" ;
  elektromagnet_nn_1 = mkN "elektromagnet" "elektromagneter" ;
  elektromagnetisk_av_1 = mkA "elektromagnetisk" ;
  elektromekanisk_av_1 = mkA "elektromekanisk" ;
  elektrometer_nn_1 = mkN "elektrometer" ;
  elektromotor_nn_1 = mkN "elektromotor" "elektromotorer" ;
  elektromotorisk_av_1 = mkA "elektromotorisk" ;
  elektron_nn_1 = mkN "elektron" "elektroner" ;
  elektronblixt_nn_1 = mkN "elektronblixt" ;
  elektronegativitet_nn_1 = mkN "elektronegativitet" "elektronegativiteter" ;
  elektronisk_av_1 = mkA "elektronisk" ;
  elektronkamera_nn_1 = mkN "elektronkamera" ;
  elektronmikroskop_nn_1 = mkN "elektronmikroskop" neutrum ;
  elektronmikroskopbild_nn_1 = mkN "elektronmikroskopbild" "elektronmikroskopbilder" ;
  elektronmikroskopi_nn_1 = mkN "elektronmikroskopi" "elektronmikroskopier" ;
  elektronmoln_nn_1 = mkN "elektronmoln" neutrum ;
  elektronpar_nn_1 = mkN "elektronpar" neutrum ;
  elektronparbindning_nn_1 = mkN "elektronparbindning" ;
  elektronroer_nn_1 = mkN "elektronrцr" neutrum ;
  elektronroersdiod_nn_1 = mkN "elektronrцrsdiod" "elektronrцrsdioder" ;
  elektronskal_nn_1 = mkN "elektronskal" neutrum ;
  elektronstraale_nn_1 = mkN "elektronstrеle" utrum ;
  elektronugn_nn_1 = mkN "elektronugn" ;
  elektronvolt_nn_1 = mkN "elektronvolt" "elektronvolten" "elektronvolt" "elektronvolten" ;
  elektroskop_nn_1 = mkN "elektroskop" neutrum ;
  elektrostatisk_av_1 = mkA "elektrostatisk" ;
  elektrosvag_av_1 = mkA "elektrosvag" ;
  elektrotekniker_nn_1 = mkN "elektrotekniker" "elektroteknikern" "elektrotekniker" "elektroteknikerna" ;
  elektroteknisk_av_1 = mkA "elektroteknisk" ;
  elektrotyp_nn_1 = mkN "elektrotyp" "elektrotyper" ;
  element_nn_1 = mkN "element" neutrum ;
  elementa_nn_1 = mkN "elementa" "elementan" "elementa" "elementana" ;
  elementaer_av_1 = mkA "elementдr" ;
  elementarande_nn_1 = mkN "elementarande" utrum ;
  elementarbok_nn_1 = mkN "elementarbok" "elementarbцcker" ;
  elementarpartikel_nn_1 = mkN "elementarpartikel" ;
  elev_nn_1 = mkN "elev" "elever" ;
  elevation_nn_1 = mkN "elevation" "elevationer" ;
  elevator_nn_1 = mkN "elevator" "elevatorer" ;
  elevfartyg_nn_1 = mkN "elevfartyg" neutrum ;
  elevhem_nn_1 = mkN "elevhem" "elevhemmet" "elevhem" "elevhemmen" ;
  elevraad_nn_1 = mkN "elevrеd" neutrum ;
  elevunderlag_nn_1 = mkN "elevunderlag" neutrum ;
  elfenbenspalm_nn_1 = mkN "elfenbenspalm" "elfenbenspalmer" ;
  elfenbenstorn_nn_1 = mkN "elfenbenstorn" "elfenbenstornet" "elfenbenstornen" "elfenbenstornena" ;
  elgenerator_nn_1 = mkN "elgenerator" "elgeneratorer" ;
  elgitarr_nn_1 = mkN "elgitarr" "elgitarrer" ;
  elimination_nn_1 = mkN "elimination" "eliminationer" ;
  elision_nn_1 = mkN "elision" "elisioner" ;
  elit_nn_1 = mkN "elit" "eliter" ;
  elitfoerband_nn_1 = mkN "elitfцrband" neutrum ;
  elitidrott_nn_1 = mkN "elitidrott" "elitidrotter" ;
  elitidrottsman_nn_1 = mkN "elitidrottsman" "elitidrottsmannen" "elitidrottsmдn" "elitidrottsmдnnen" ;
  elitisk_av_1 = mkA "elitisk" ;
  elitistisk_av_1 = mkA "elitistisk" ;
  elitsoldat_nn_1 = mkN "elitsoldat" "elitsoldater" ;
  elitteori_nn_1 = mkN "elitteori" "elitteorier" ;
  elixir_nn_1 = mkN "elixir" neutrum ;
  eljest_ab_1 = mkAdv "eljest" ;
  elkoppling_nn_1 = mkN "elkoppling" ;
  elkraftsaggregat_nn_1 = mkN "elkraftsaggregat" neutrum ;
  ellande_ab_1 = mkAdv "ellande" ;
  elledning_nn_1 = mkN "elledning" ;
  ellips_nn_1 = mkN "ellips" "ellipser" ;
  ellipsoid_nn_1 = mkN "ellipsoid" "ellipsoider" ;
  elliptisk_av_1 = mkA "elliptisk" ;
  elljusspaar_nn_1 = mkN "elljusspеr" neutrum ;
  ellok_nn_1 = mkN "ellok" neutrum ;
  elmaetare_nn_1 = mkN "elmдtare" "elmдtare" ;
  elmotor_nn_1 = mkN "elmotor" "elmotorer" ;
  elmseld_nn_1 = mkN "elmseld" ;
  elnaet_nn_1 = mkN "elnдt" neutrum ;
  eloge_nn_1 = mkN "eloge" "eloger" ;
  elokvent_av_1 = mkA "elokvent" "elokvent" ;
  elongation_nn_1 = mkN "elongation" "elongationer" ;
  elorgel_nn_1 = mkN "elorgel" ;
  elsevir_nn_1 = mkN "elsevir" "elsevirer" ;
  elspis_nn_1 = mkN "elspis" ;
  elstroem_nn_1 = mkN "elstrцm" "elstrцmmen" "elstrцmmar" "elstrцmmarna" ;
  eluttag_nn_1 = mkN "eluttag" neutrum ;
  eluvial_av_1 = mkA "eluvial" ;
  elvadimensionell_av_1 = mkA "elvadimensionell" ;
  elvamannalag_nn_1 = mkN "elvamannalag" neutrum ;
  elverk_nn_1 = mkN "elverk" neutrum ;
  elyseisk_av_1 = mkA "elyseisk" ;
  elzevier_nn_1 = mkN "elzevier" "elzevierer" ;
  emalj_nn_1 = mkN "emalj" "emaljer" ;
  emaljfaerg_nn_1 = mkN "emaljfдrg" "emaljfдrger" ;
  emaljfyllning_nn_1 = mkN "emaljfyllning" ;
  emaljinlaeggning_nn_1 = mkN "emaljinlдggning" ;
  emaljoega_nn_1 = mkN "emaljцga" "emaljцgat" "emaljцgon" "emaljцgonen" ;
  emaljoer_nn_1 = mkN "emaljцr" "emaljцrer" ;
  emaljplomb_nn_1 = mkN "emaljplomb" "emaljplomber" ;
  emanation_nn_1 = mkN "emanation" "emanationer" ;
  emballage_nn_1 = mkN "emballage" "emballaget" "emballage" "emballagen" ;
  emblem_nn_1 = mkN "emblem" neutrum ;
  emboli_nn_1 = mkN "emboli" "embolier" ;
  embryo_nn_1 = mkN "embryo" "embryot" "embryon" "embryona" ;
  embryolog_nn_1 = mkN "embryolog" "embryologer" ;
  embryonal_av_1 = mkA "embryonal" ;
  embryonisk_av_1 = mkA "embryonisk" ;
  embryosaeck_nn_1 = mkN "embryosдck" ;
  emellan_ab_1 = mkAdv "emellan" ;
  emellanaat_ab_1 = mkAdv "emellanеt" ;
  emellertid_ab_1 = mkAdv "emellertid" ;
  emendation_nn_1 = mkN "emendation" "emendationer" ;
  emeritus_nn_1 = mkN "emeritus" "emeritus" "emeriti" "emeritina" ;
  emfatisk_av_1 = mkA "emfatisk" ;
  emfysem_nn_1 = mkN "emfysem" neutrum ;
  emigrant_nn_1 = mkN "emigrant" "emigranter" ;
  eminens_nn_1 = mkN "eminens" "eminenser" ;
  eminent_av_1 = mkA "eminent" "eminent" ;
  emir_nn_1 = mkN "emir" "emirer" ;
  emissarie_nn_1 = mkN "emissarie" "emissarier" ;
  emission_nn_1 = mkN "emission" "emissioner" ;
  emitter_nn_1 = mkN "emitter" ;
  emot_ab_1 = mkAdv "emot" ;
  emotion_nn_1 = mkN "emotion" "emotioner" ;
  emotionell_av_1 = mkA "emotionell" ;
  emotiv_av_1 = mkA "emotiv" ;
  emotta_vb_1 = mkV "emotta" "emottar" "emotta" "emottog" "emottagit" "emottagen" ;
  empirestil_nn_1 = mkN "empirestil" ;
  empiriker_nn_1 = mkN "empiriker" "empirikern" "empiriker" "empirikerna" ;
  empirisk_av_1 = mkA "empirisk" ;
  empirist_nn_1 = mkN "empirist" "empirister" ;
  empyem_nn_1 = mkN "empyem" neutrum ;
  emu_nn_1 = mkN "emu" "emun" "emuer" "emuerna" ;
  emulsion_nn_1 = mkN "emulsion" "emulsioner" ;
  emulsionsfaerg_nn_1 = mkN "emulsionsfдrg" "emulsionsfдrger" ;
  emulsionsspraengaemne_nn_1 = mkN "emulsionssprдngдmne" ;
  en_ab_1 = mkAdv "en" ;
  en_nn_1 = mkN "en" "enen" "enar" "enarna" ;
  enaeggstvilling_nn_1 = mkN "enдggstvilling" ;
  enahanda_av_1 = mkA "enahanda" ;
  enaktare_nn_1 = mkN "enaktare" "enaktare" ;
  enaraadande_av_1 = mkA "enarеdande" ;
  enarmig_av_1 = mkA "enarmig" ;
  enastaaende_av_1 = mkA "enastеende" ;
  enaxlig_av_1 = mkA "enaxlig" ;
  enbaeddsrum_nn_1 = mkN "enbдddsrum" "enbдddsrummet" "enbдddsrum" "enbдddsrummen" ;
  enbaer_nn_1 = mkN "enbдr" neutrum ;
  enbart_ab_1 = mkAdv "enbart" ;
  enbasisk_av_1 = mkA "enbasisk" ;
  enbent_av_1 = mkA "enbent" "enbent" ;
  enbet_nn_1 = mkN "enbet" neutrum ;
  enbuske_nn_1 = mkN "enbuske" utrum ;
  enbyggare_nn_1 = mkN "enbyggare" "enbyggare" ;
  encefalit_nn_1 = mkN "encefalit" "encefaliter" ;
  encefalografi_nn_1 = mkN "encefalografi" "encefalografier" ;
  encellig_av_1 = mkA "encellig" ;
  encyklopedi_nn_1 = mkN "encyklopedi" "encyklopedier" ;
  encyklopedisk_av_1 = mkA "encyklopedisk" ;
  endast_ab_1 = mkAdv "endast" ;
  endels_ab_1 = mkAdv "endels" ;
  endemi_nn_1 = mkN "endemi" "endemier" ;
  endemisk_av_1 = mkA "endemisk" ;
  endimensionell_av_1 = mkA "endimensionell" ;
  endiv_nn_1 = mkN "endiv" "endiver" ;
  endogen_av_1 = mkA "endogen" ;
  endokrin_av_1 = mkA "endokrin" ;
  endokrinolog_nn_1 = mkN "endokrinolog" "endokrinologer" ;
  endorfin_nn_1 = mkN "endorfin" "endorfinet" "endorfiner" "endorfinerna" ;
  endossat_nn_1 = mkN "endossat" "endossater" ;
  endossement_nn_1 = mkN "endossement" "endossementet" "endossementen" "endossementena" ;
  endossent_nn_1 = mkN "endossent" "endossenter" ;
  endotermisk_av_1 = mkA "endotermisk" ;
  energi_nn_1 = mkN "energi" "energier" ;
  energialternativ_nn_1 = mkN "energialternativ" neutrum ;
  energibehov_nn_1 = mkN "energibehov" neutrum ;
  energifoerlust_nn_1 = mkN "energifцrlust" "energifцrluster" ;
  energiform_nn_1 = mkN "energiform" "energiformer" ;
  energiinnehaall_nn_1 = mkN "energiinnehеll" neutrum ;
  energikoncentration_nn_1 = mkN "energikoncentration" "energikoncentrationer" ;
  energimaengd_nn_1 = mkN "energimдngd" "energimдngder" ;
  energimarknad_nn_1 = mkN "energimarknad" "energimarknader" ;
  energiomsaettning_nn_1 = mkN "energiomsдttning" ;
  energiomvandling_nn_1 = mkN "energiomvandling" ;
  energiomvandlingscentrum_nn_1 = mkN "energiomvandlingscentrum" neutrum ;
  energirik_av_1 = mkA "energirik" ;
  energisk_av_1 = mkA "energisk" ;
  energiskatt_nn_1 = mkN "energiskatt" "energiskatter" ;
  energiskog_nn_1 = mkN "energiskog" ;
  energiteori_nn_1 = mkN "energiteori" "energiteorier" ;
  energitillstaand_nn_1 = mkN "energitillstеnd" neutrum ;
  energiupptagande_av_1 = mkA "energiupptagande" ;
  energiutstraalning_nn_1 = mkN "energiutstrеlning" ;
  energiverk_nn_1 = mkN "energiverk" neutrum ;
  energivinst_nn_1 = mkN "energivinst" "energivinster" ;
  enfaldeligen_ab_1 = mkAdv "enfaldeligen" ;
  enfaldig_av_1 = mkA "enfaldig" ;
  enfamiljshus_nn_1 = mkN "enfamiljshus" neutrum ;
  enfas_av_1 = mkA "enfas" ;
  enfasig_av_1 = mkA "enfasig" ;
  enfoedd_av_1 = mkA "enfцdd" ;
  enfoeraeldersfamilj_nn_1 = mkN "enfцrдldersfamilj" "enfцrдldersfamiljer" ;
  enformig_av_1 = mkA "enformig" ;
  engaang_ab_1 = mkAdv "engеng" ;
  engaangsdos_nn_1 = mkN "engеngsdos" "engеngsdoser" ;
  engaangshandduk_nn_1 = mkN "engеngshandduk" ;
  engaangsnaesduk_nn_1 = mkN "engеngsnдsduk" ;
  engaangsservett_nn_1 = mkN "engеngsservett" "engеngsservetter" ;
  engaangsskatt_nn_1 = mkN "engеngsskatt" "engеngsskatter" ;
  engaangstallrik_nn_1 = mkN "engеngstallrik" ;
  engaangsvaerde_nn_1 = mkN "engеngsvдrde" ;
  engagemang_nn_1 = mkN "engagemang" neutrum ;
  engelsk_av_1 = mkA "engelsk" ;
  engelska_nn_2 = mkN "engelska" ;
  engelsman_nn_1 = mkN "engelsman" "engelsmannen" "engelsmдn" "engelsmдnnen" ;
  englergrad_nn_1 = mkN "englergrad" "englergrader" ;
  engram_nn_1 = mkN "engram" "engrammet" "engram" "engrammen" ;
  engrossist_nn_1 = mkN "engrossist" "engrossister" ;
  enhaellig_av_1 = mkA "enhдllig" ;
  enharmonisk_av_1 = mkA "enharmonisk" ;
  enhet_nn_1 = mkN "enhet" "enheter" ;
  enhetlig_av_1 = mkA "enhetlig" ;
  enhetscirkel_nn_1 = mkN "enhetscirkel" ;
  enhetsflygplan_nn_1 = mkN "enhetsflygplan" neutrum ;
  enhetsfront_nn_1 = mkN "enhetsfront" "enhetsfronter" ;
  enhetsladdning_nn_1 = mkN "enhetsladdning" ;
  enhetslast_nn_1 = mkN "enhetslast" "enhetslaster" ;
  enhetsmaatt_nn_1 = mkN "enhetsmеtt" neutrum ;
  enhetsparti_nn_1 = mkN "enhetsparti" "enhetspartit" "enhetspartier" "enhetspartierna" ;
  enhetspatron_nn_1 = mkN "enhetspatron" "enhetspatroner" ;
  enhetsporto_nn_1 = mkN "enhetsporto" "enhetsportot" "enhetsporton" "enhetsportona" ;
  enhetspris_nn_1 = mkN "enhetspris" neutrum ;
  enhetsvektor_nn_1 = mkN "enhetsvektor" "enhetsvektorer" ;
  enhjaertbladig_av_1 = mkA "enhjдrtbladig" ;
  enhoerning_nn_1 = mkN "enhцrning" ;
  enig_av_1 = mkA "enig" ;
  enighet_nn_1 = mkN "enighet" "enigheter" ;
  enigmatisk_av_1 = mkA "enigmatisk" ;
  enjambemang_nn_1 = mkN "enjambemang" neutrum ;
  enkaet_nn_1 = mkN "enkдt" "enkдter" ;
  enkammarsystem_nn_1 = mkN "enkammarsystem" neutrum ;
  enkannerligen_ab_1 = mkAdv "enkannerligen" ;
  enkel_av_1 = mkA "enkel" "enkelt" "enkla" "enkla" "enklare" "enklast" "enklaste" ;
  enkelbeckasin_nn_1 = mkN "enkelbeckasin" "enkelbeckasiner" ;
  enkelbiff_nn_1 = mkN "enkelbiff" ;
  enkelbiljett_nn_1 = mkN "enkelbiljett" "enkelbiljetter" ;
  enkelbredd_nn_1 = mkN "enkelbredd" "enkelbredder" ;
  enkelhet_nn_1 = mkN "enkelhet" "enkelheter" ;
  enkelkikare_nn_1 = mkN "enkelkikare" "enkelkikare" ;
  enkelknaeppt_av_1 = mkA "enkelknдppt" "enkelknдppt" ;
  enkelkvartett_nn_1 = mkN "enkelkvartett" "enkelkvartetter" ;
  enkelladdare_nn_1 = mkN "enkelladdare" "enkelladdare" ;
  enkelnervig_av_1 = mkA "enkelnervig" ;
  enkelpipig_av_1 = mkA "enkelpipig" ;
  enkelrad_nn_1 = mkN "enkelrad" "enkelrader" ;
  enkelrum_nn_1 = mkN "enkelrum" "enkelrummet" "enkelrum" "enkelrummen" ;
  enkelsaeng_nn_1 = mkN "enkelsдng" ;
  enkelskriva_vb_1 = mkV "enkelskriva" "enkelskrev" "enkelskrivit" ;
  enkelspaarig_av_1 = mkA "enkelspеrig" ;
  enkelspel_nn_1 = mkN "enkelspel" "enkelspelet" "enkelspel" "enkelspelen" ;
  enkeltimme_nn_1 = mkN "enkeltimme" utrum ;
  enklav_nn_1 = mkN "enklav" "enklaver" ;
  enklitisk_av_1 = mkA "enklitisk" ;
  enkom_ab_1 = mkAdv "enkom" ;
  enmanslivbaat_nn_1 = mkN "enmanslivbеt" ;
  enmansshow_nn_1 = mkN "enmansshow" "enmansshower" ;
  enmansvalkrets_nn_1 = mkN "enmansvalkrets" ;
  enoegd_av_1 = mkA "enцgd" "enцgt" ;
  enorm_av_1 = mkA "enorm" ;
  enpartistat_nn_1 = mkN "enpartistat" "enpartistater" ;
  enplanshus_nn_1 = mkN "enplanshus" neutrum ;
  enpolig_av_1 = mkA "enpolig" ;
  enpucklig_av_1 = mkA "enpucklig" ;
  enraadig_av_1 = mkA "enrеdig" ;
  enris_nn_1 = mkN "enris" neutrum ;
  enrisroekt_av_1 = mkA "enrisrцkt" "enrisrцkt" ;
  ens_ab_1 = mkAdv "ens" ;
  ens_av_1 = mkA "ens" ;
  ensak_nn_1 = mkN "ensak" "ensaker" ;
  ensam_av_1 = mkA "ensam" "ensamt" "ensamma" "ensamma" "ensammare" "ensammast" "ensammaste" ;
  ensamfoeraelder_nn_1 = mkN "ensamfцrдlder" ;
  ensamgaard_nn_1 = mkN "ensamgеrd" ;
  ensamhet_nn_1 = mkN "ensamhet" "ensamheter" ;
  ensamraett_nn_1 = mkN "ensamrдtt" "ensamrдtter" ;
  ensamseglare_nn_1 = mkN "ensamseglare" "ensamseglare" ;
  ensamstaaende_av_1 = mkA "ensamstеende" ;
  ense_av_1 = mkA "ense" ;
  ensemble_nn_1 = mkN "ensemble" "ensembler" ;
  ensfyr_nn_1 = mkN "ensfyr" ;
  ensidig_av_1 = mkA "ensidig" ;
  ensittare_nn_1 = mkN "ensittare" "ensittare" ;
  enskild_av_1 = mkA "enskild" "enskilt" ;
  enskildhet_nn_1 = mkN "enskildhet" "enskildheter" ;
  enslig_av_1 = mkA "enslig" ;
  ensling_nn_1 = mkN "ensling" ;
  enslinje_nn_1 = mkN "enslinje" "enslinjer" ;
  enspraakig_av_1 = mkA "ensprеkig" ;
  enstaemmig_av_1 = mkA "enstдmmig" ;
  enstaendig_av_1 = mkA "enstдndig" ;
  enstaka_av_1 = mkA "enstaka" ;
  enstavig_av_1 = mkA "enstavig" ;
  enstensmur_nn_1 = mkN "enstensmur" ;
  enstjaernig_av_1 = mkA "enstjдrnig" ;
  enstoerig_av_1 = mkA "enstцrig" ;
  enstoering_nn_1 = mkN "enstцring" ;
  ental_nn_1 = mkN "ental" "entalet" "entalen" "entalena" ;
  entente_nn_1 = mkN "entente" "ententer" ;
  entertainer_nn_1 = mkN "entertainer" "entertainern" "entertainer" "entertainerna" ;
  entitet_nn_1 = mkN "entitet" "entiteter" ;
  entomolog_nn_1 = mkN "entomolog" "entomologer" ;
  entomologisk_av_1 = mkA "entomologisk" ;
  entonig_av_1 = mkA "entonig" ;
  entraegen_av_1 = mkA "entrдgen" "entrдget" ;
  entre_nn_1 = mkN "entrй" "entrйer" ;
  entrecote_nn_1 = mkN "entrecote" "entrecoter" ;
  entredoerr_nn_1 = mkN "entrйdцrr" ;
  entreprenad_nn_1 = mkN "entreprenad" "entreprenader" ;
  entreprenoer_nn_1 = mkN "entreprenцr" "entreprenцrer" ;
  entresol_nn_1 = mkN "entresol" "entresoler" ;
  entusiast_nn_1 = mkN "entusiast" "entusiaster" ;
  entusiastisk_av_1 = mkA "entusiastisk" ;
  entydig_av_1 = mkA "entydig" ;
  entydighet_nn_1 = mkN "entydighet" "entydigheter" ;
  entypsbaat_nn_1 = mkN "entypsbеt" ;
  enumeration_nn_1 = mkN "enumeration" "enumerationer" ;
  envaaldshaerskare_nn_1 = mkN "envеldshдrskare" "envеldshдrskare" ;
  envaaningshus_nn_1 = mkN "envеningshus" neutrum ;
  envaegskommunikation_nn_1 = mkN "envдgskommunikation" "envдgskommunikationer" ;
  envaeldig_av_1 = mkA "envдldig" ;
  envaerd_av_1 = mkA "envдrd" "envдrt" ;
  enveten_av_1 = mkA "enveten" "envetet" ;
  envig_nn_1 = mkN "envig" ;
  environg_nn_1 = mkN "environg" "environger" ;
  envis_av_1 = mkA "envis" ;
  envoye_nn_1 = mkN "envoyй" "envoyйer" ;
  enzym_nn_1 = mkN "enzym" neutrum ;
  enzymsystem_nn_1 = mkN "enzymsystem" neutrum ;
  enzymtvaettmedel_nn_1 = mkN "enzymtvдttmedel" neutrum ;
  eoler_nn_1 = mkN "eoler" "eolern" "eoler" "eolerna" ;
  eolisk_av_1 = mkA "eolisk" ;
  eon_nn_1 = mkN "eon" "eoner" ;
  eosin_nn_1 = mkN "eosin" "eosiner" ;
  epaalett_nn_1 = mkN "epеlett" "epеletter" ;
  epatraktor_nn_1 = mkN "epatraktor" "epatraktorer" ;
  epicentrum_nn_1 = mkN "epicentrum" neutrum ;
  epidemi_nn_1 = mkN "epidemi" "epidemier" ;
  epidemisk_av_1 = mkA "epidemisk" ;
  epiduralblockad_nn_1 = mkN "epiduralblockad" "epiduralblockader" ;
  epifys_nn_1 = mkN "epifys" "epifyser" ;
  epifyt_nn_1 = mkN "epifyt" "epifyter" ;
  epigon_nn_1 = mkN "epigon" "epigoner" ;
  epigram_nn_1 = mkN "epigram" "epigrammet" "epigram" "epigrammen" ;
  epigrammatisk_av_1 = mkA "epigrammatisk" ;
  epiker_nn_1 = mkN "epiker" "epikern" "epiker" "epikerna" ;
  epikure_nn_1 = mkN "epikurй" "epikurйer" ;
  epikureisk_av_1 = mkA "epikureisk" ;
  epilepsi_nn_1 = mkN "epilepsi" "epilepsier" ;
  epileptiker_nn_1 = mkN "epileptiker" "epileptikern" "epileptiker" "epileptikerna" ;
  epilog_nn_1 = mkN "epilog" "epiloger" ;
  episk_av_1 = mkA "episk" ;
  episkop_nn_1 = mkN "episkop" neutrum ;
  episkopal_av_1 = mkA "episkopal" ;
  episkopat_nn_1 = mkN "episkopat" neutrum ;
  episod_nn_1 = mkN "episod" "episoder" ;
  episodisk_av_1 = mkA "episodisk" ;
  epistel_nn_1 = mkN "epistel" ;
  epistolaer_av_1 = mkA "epistolдr" ;
  epistyl_nn_1 = mkN "epistyl" "epistyler" ;
  epitaf_nn_1 = mkN "epitaf" "epitafet" "epitafer" "epitaferna" ;
  epitafium_nn_1 = mkN "epitafium" "epitafiet" "epitafier" "epitafierna" ;
  epitel_nn_1 = mkN "epitel" "epitelet" "epitel" "epitelen" ;
  epitelcell_nn_1 = mkN "epitelcell" "epitelceller" ;
  epitet_nn_1 = mkN "epitet" neutrum ;
  epizoisk_av_1 = mkA "epizoisk" ;
  epizooti_nn_1 = mkN "epizooti" "epizootier" ;
  epok_nn_1 = mkN "epok" "epoker" ;
  epokgoerande_av_1 = mkA "epokgцrande" ;
  epos_nn_1 = mkN "epos" neutrum ;
  erbarmlig_av_1 = mkA "erbarmlig" ;
  erbjuda_vb_1 = mkV "erbjuda" "erbjцd" "erbjudit" ;
  erbjudande_nn_1 = mkN "erbjudande" ;
  erektion_nn_1 = mkN "erektion" "erektioner" ;
  eremit_nn_1 = mkN "eremit" "eremiter" ;
  eremitage_nn_1 = mkN "eremitage" "eremitaget" "eremitage" "eremitagen" ;
  eremitisk_av_1 = mkA "eremitisk" ;
  erfaren_av_1 = mkA "erfaren" "erfaret" ;
  erfarenhet_nn_1 = mkN "erfarenhet" "erfarenheter" ;
  erfarenhetsmaessig_av_1 = mkA "erfarenhetsmдssig" ;
  erforderlig_av_1 = mkA "erforderlig" ;
  ergo_ab_1 = mkAdv "ergo" ;
  ergometer_nn_1 = mkN "ergometer" ;
  ergonom_nn_1 = mkN "ergonom" "ergonomer" ;
  ergonometrisk_av_1 = mkA "ergonometrisk" ;
  ergonomisk_av_1 = mkA "ergonomisk" ;
  erhaalla_vb_1 = mkV "erhеlla" "erhцll" "erhеllit" ;
  erinnye_nn_1 = mkN "erinnye" "erinnyer" ;
  erinran_nn_1 = mkN "erinran" "erinran" "erinringar" "erinringarna" ;
  erinring_nn_1 = mkN "erinring" ;
  erkaend_av_1 = mkA "erkдnd" ;
  erkaennande_nn_1 = mkN "erkдnnande" ;
  erkaennsam_av_1 = mkA "erkдnnsam" "erkдnnsamt" "erkдnnsamma" "erkдnnsamma" "erkдnnsammare" "erkдnnsammast" "erkдnnsammaste" ;
  eroevrare_nn_1 = mkN "erцvrare" "erцvrare" ;
  eroevring_nn_1 = mkN "erцvring" ;
  erogen_av_1 = mkA "erogen" ;
  erosion_nn_1 = mkN "erosion" "erosioner" ;
  erotiker_nn_1 = mkN "erotiker" "erotikern" "erotiker" "erotikerna" ;
  erotisk_av_1 = mkA "erotisk" ;
  erotogen_av_1 = mkA "erotogen" ;
  erotoman_av_1 = mkA "erotoman" ;
  erotoman_nn_1 = mkN "erotoman" "erotomaner" ;
  errata_nn_1 = mkN "errata" "erratan" "errata" "erratana" ;
  erratisk_av_1 = mkA "erratisk" ;
  ersaettare_nn_1 = mkN "ersдttare" "ersдttare" ;
  ersaettlig_av_1 = mkA "ersдttlig" ;
  ersaettning_nn_1 = mkN "ersдttning" ;
  eruption_nn_1 = mkN "eruption" "eruptioner" ;
  eruptiv_av_1 = mkA "eruptiv" ;
  eruptivbergart_nn_1 = mkN "eruptivbergart" "eruptivbergarter" ;
  escudo_nn_1 = mkN "escudo" "escudon" "escudos" "escudosen" ;
  eselhuvud_nn_1 = mkN "eselhuvud" "eselhuvudet" "eselhuvuden" "eselhuvudena" ;
  eskader_nn_1 = mkN "eskader" ;
  eskapad_nn_1 = mkN "eskapad" "eskapader" ;
  eskarp_nn_1 = mkN "eskarp" "eskarper" ;
  eskatologisk_av_1 = mkA "eskatologisk" ;
  eskimaa_nn_1 = mkN "eskimе" "eskimеer" ;
  eskimaahund_nn_1 = mkN "eskimеhund" ;
  eskort_nn_1 = mkN "eskort" "eskorter" ;
  eskulap_nn_1 = mkN "eskulap" "eskulaper" ;
  esomoftast_ab_1 = mkAdv "esomoftast" ;
  esoterisk_av_1 = mkA "esoterisk" ;
  espadrill_nn_1 = mkN "espadrill" "espadriller" ;
  espagnolett_nn_1 = mkN "espagnolett" "espagnoletter" ;
  esperantist_nn_1 = mkN "esperantist" "esperantister" ;
  esplanad_nn_1 = mkN "esplanad" "esplanader" ;
  espri_nn_2 = mkN "espri" "esprier" ;
  ess_nn_1 = mkN "ess" neutrum ;
  essae_nn_1 = mkN "essд" "essдn" "essдer" "essдerna" ;
  essaefraaga_nn_1 = mkN "essдfrеga" ;
  essaeist_nn_1 = mkN "essдist" "essдister" ;
  essaeistisk_av_1 = mkA "essдistisk" ;
  essaesamling_nn_1 = mkN "essдsamling" ;
  essaeuppgift_nn_1 = mkN "essдuppgift" "essдuppgifter" ;
  essay_nn_1 = mkN "essay" "essayer" ;
  essayist_nn_1 = mkN "essayist" "essayister" ;
  essayistik_nn_1 = mkN "essayistik" "essayistiker" ;
  essayistisk_av_1 = mkA "essayistisk" ;
  essaysamling_nn_1 = mkN "essaysamling" ;
  essens_nn_1 = mkN "essens" "essenser" ;
  essentiell_av_1 = mkA "essentiell" ;
  est_nn_1 = mkN "est" "ester" ;
  ester_nn_1 = mkN "ester" ;
  esterplast_nn_1 = mkN "esterplast" "esterplaster" ;
  estet_nn_1 = mkN "estet" "esteter" ;
  estetiker_nn_1 = mkN "estetiker" "estetikern" "estetiker" "estetikerna" ;
  estetisk_av_1 = mkA "estetisk" ;
  estlaendare_nn_1 = mkN "estlдndare" "estlдndare" ;
  estlaendsk_av_1 = mkA "estlдndsk" ;
  estlaendska_nn_1 = mkN "estlдndska" ;
  estnisk_av_1 = mkA "estnisk" ;
  estniska_nn_2 = mkN "estniska" ;
  estrad_nn_1 = mkN "estrad" "estrader" ;
  estradartist_nn_1 = mkN "estradartist" "estradartister" ;
  estraddebatt_nn_1 = mkN "estraddebatt" "estraddebatter" ;
  estradoer_nn_1 = mkN "estradцr" "estradцrer" ;
  estradsamtal_nn_1 = mkN "estradsamtal" "estradsamtalet" "estradsamtalen" "estradsamtalena" ;
  etablissemang_nn_1 = mkN "etablissemang" neutrum ;
  etagaer_nn_1 = mkN "etagдr" "etagдrer" ;
  etage_nn_1 = mkN "etage" "etager" ;
  etagevaaning_nn_1 = mkN "etagevеning" ;
  etalong_nn_1 = mkN "etalong" "etalonger" ;
  etan_nn_1 = mkN "etan" "etaner" ;
  etapp_nn_1 = mkN "etapp" "etapper" ;
  etapplinje_nn_1 = mkN "etapplinje" "etapplinjer" ;
  etappvis_ab_1 = mkAdv "etappvis" ;
  etcetera_ab_1 = mkAdv "etcetera" ;
  eter_nn_1 = mkN "eter" ;
  eterisering_nn_1 = mkN "eterisering" ;
  eterisk_av_1 = mkA "eterisk" ;
  etermedium_nn_1 = mkN "etermedium" "etermediet" "etermedier" "etermedierna" ;
  eternell_nn_1 = mkN "eternell" "eterneller" ;
  etiker_nn_1 = mkN "etiker" "etikern" "etiker" "etikerna" ;
  etikett_nn_1 = mkN "etikett" "etiketter" ;
  etiologisk_av_1 = mkA "etiologisk" ;
  etiop_nn_1 = mkN "etiop" "etioper" ;
  etiopier_nn_1 = mkN "etiopier" "etiopiern" "etiopier" "etiopierna" ;
  etiopisk_av_1 = mkA "etiopisk" ;
  etiopiska_nn_2 = mkN "etiopiska" ;
  etisk_av_1 = mkA "etisk" ;
  etnisk_av_1 = mkA "etnisk" ;
  etnocentrisk_av_1 = mkA "etnocentrisk" ;
  etnograf_nn_1 = mkN "etnograf" "etnografer" ;
  etnografisk_av_1 = mkA "etnografisk" ;
  etnolog_nn_1 = mkN "etnolog" "etnologer" ;
  etnologisk_av_1 = mkA "etnologisk" ;
  etolog_nn_1 = mkN "etolog" "etologer" ;
  etologisk_av_1 = mkA "etologisk" ;
  etrusk_nn_1 = mkN "etrusk" "etrusker" ;
  etrusker_nn_1 = mkN "etrusker" "etruskern" "etrusker" "etruskerna" ;
  etruskisk_av_1 = mkA "etruskisk" ;
  etruskiska_nn_2 = mkN "etruskiska" ;
  etsmedel_nn_1 = mkN "etsmedel" neutrum ;
  etsning_nn_1 = mkN "etsning" ;
  ettaarig_av_1 = mkA "ettеrig" ;
  ettaaring_nn_1 = mkN "ettеring" ;
  ettoering_nn_1 = mkN "ettцring" ;
  ettrig_av_1 = mkA "ettrig" ;
  ettstruken_av_1 = mkA "ettstruken" "ettstruket" ;
  etui_nn_1 = mkN "etui" "etuiet" "etuier" "etuierna" ;
  etyd_nn_1 = mkN "etyd" "etyder" ;
  etymolog_nn_1 = mkN "etymolog" "etymologer" ;
  etymologi_nn_1 = mkN "etymologi" "etymologier" ;
  etymologisk_av_1 = mkA "etymologisk" ;
  eufemism_nn_1 = mkN "eufemism" "eufemismer" ;
  eufoni_nn_1 = mkN "eufoni" "eufonier" ;
  eufori_nn_1 = mkN "eufori" "euforier" ;
  euforisk_av_1 = mkA "euforisk" ;
  euklidisk_av_1 = mkA "euklidisk" ;
  eumenid_nn_1 = mkN "eumenid" "eumenider" ;
  eunuck_nn_1 = mkN "eunuck" "eunucker" ;
  eurasier_nn_1 = mkN "eurasier" "eurasiern" "eurasier" "eurasierna" ;
  eurasisk_av_1 = mkA "eurasisk" ;
  euro_nn_1 = mkN "euro" "euron" "euro" "eurona" ;
  eurodollar_nn_1 = mkN "eurodollar" "eurodollarn" "eurodollar" "eurodollarna" ;
  europamaestare_nn_1 = mkN "europamдstare" "europamдstare" ;
  europamaesterskap_nn_1 = mkN "europamдsterskap" "europamдsterskapet" "europamдsterskapen" "europamдsterskapena" ;
  europavaeg_nn_1 = mkN "europavдg" ;
  europe_nn_1 = mkN "europй" "europйer" ;
  europeisk_av_1 = mkA "europeisk" ;
  europeiska_nn_1 = mkN "europeiska" ;
  europid_nn_1 = mkN "europid" "europider" ;
  eurytmi_nn_1 = mkN "eurytmi" "eurytmier" ;
  eutrof_av_1 = mkA "eutrof" ;
  evaerdlig_av_1 = mkA "evдrdlig" ;
  evakostym_nn_1 = mkN "evakostym" "evakostymer" ;
  evakuering_nn_1 = mkN "evakuering" ;
  evangeliebok_nn_1 = mkN "evangeliebok" "evangeliebцcker" ;
  evangelisk_av_1 = mkA "evangelisk" ;
  evangelist_nn_1 = mkN "evangelist" "evangelister" ;
  evangelium_nn_1 = mkN "evangelium" "evangeliet" "evangelier" "evangelierna" ;
  evar_ab_1 = mkAdv "evar" ;
  evart_ab_1 = mkAdv "evart" ;
  evenemang_nn_1 = mkN "evenemang" neutrum ;
  eventualitet_nn_1 = mkN "eventualitet" "eventualiteter" ;
  eventuell_av_1 = mkA "eventuell" ;
  evergreen_nn_1 = mkN "evergreen" "evergreenen" "evergreens" "evergreensen" ;
  evertebrat_nn_1 = mkN "evertebrat" "evertebrater" ;
  evident_av_1 = mkA "evident" "evident" ;
  evig_av_1 = mkA "evig" ;
  evighet_nn_1 = mkN "evighet" "evigheter" ;
  evighetskalender_nn_1 = mkN "evighetskalender" ;
  evighetsmaskin_nn_1 = mkN "evighetsmaskin" "evighetsmaskiner" ;
  evinnerlig_av_1 = mkA "evinnerlig" ;
  evinnerligen_ab_1 = mkAdv "evinnerligen" ;
  evolution_nn_1 = mkN "evolution" "evolutioner" ;
  evolutionaer_av_1 = mkA "evolutionдr" ;
  evolutionist_nn_1 = mkN "evolutionist" "evolutionister" ;
  evolutionsbiolog_nn_1 = mkN "evolutionsbiolog" "evolutionsbiologer" ;
  evolutionsforskning_nn_1 = mkN "evolutionsforskning" ;
  evolutionsmekanism_nn_1 = mkN "evolutionsmekanism" "evolutionsmekanismer" ;
  evolutionsteori_nn_1 = mkN "evolutionsteori" "evolutionsteorier" ;
  exakt_av_1 = mkA "exakt" "exakt" ;
  exakthet_nn_1 = mkN "exakthet" "exaktheter" ;
  examen_nn_1 = mkN "examen" "examen" "examina" "examina" ;
  examinand_nn_1 = mkN "examinand" "examinander" ;
  examination_nn_1 = mkN "examination" "examinationer" ;
  examinator_nn_1 = mkN "examinator" "examinatorer" ;
  examinatorium_nn_1 = mkN "examinatorium" "examinatoriumet" "examinatorier" "examinatorierna" ;
  exantem_nn_1 = mkN "exantem" neutrum ;
  excellens_nn_1 = mkN "excellens" "excellenser" ;
  excellent_av_1 = mkA "excellent" "excellent" ;
  excenter_nn_1 = mkN "excenter" ;
  excentricitet_nn_1 = mkN "excentricitet" "excentriciteter" ;
  excentriker_nn_1 = mkN "excentriker" "excentrikern" "excentriker" "excentrikerna" ;
  excentrisk_av_1 = mkA "excentrisk" ;
  exceptionell_av_1 = mkA "exceptionell" ;
  excerpist_nn_1 = mkN "excerpist" "excerpister" ;
  excerpt_nn_1 = mkN "excerpt" "excerpter" ;
  excess_nn_1 = mkN "excess" "excesser" ;
  excision_nn_1 = mkN "excision" "excisioner" ;
  excitation_nn_1 = mkN "excitation" "excitationer" ;
  exeget_nn_1 = mkN "exeget" "exegeter" ;
  exekution_nn_1 = mkN "exekution" "exekutioner" ;
  exekutiv_av_1 = mkA "exekutiv" ;
  exekutiv_nn_1 = mkN "exekutiv" "exekutiver" ;
  exekutoer_nn_1 = mkN "exekutцr" "exekutцrer" ;
  exekutor_nn_1 = mkN "exekutor" "exekutorer" ;
  exekutorisk_av_1 = mkA "exekutorisk" ;
  exempel_nn_1 = mkN "exempel" neutrum ;
  exempelloes_av_1 = mkA "exempellцs" ;
  exempelvis_ab_1 = mkAdv "exempelvis" ;
  exemplar_nn_1 = mkN "exemplar" neutrum ;
  exemplarisk_av_1 = mkA "exemplarisk" ;
  exemplifiering_nn_1 = mkN "exemplifiering" ;
  exemplifikation_nn_1 = mkN "exemplifikation" "exemplifikationer" ;
  exercis_nn_1 = mkN "exercis" "exerciser" ;
  exhibitionist_nn_1 = mkN "exhibitionist" "exhibitionister" ;
  exhustru_nn_1 = mkN "exhustru" "exhustrun" "exhustrur" "exhustrurna" ;
  exigibel_av_1 = mkA "exigibel" "exigibelt" "exigibla" "exigibla" "exigiblare" "exigiblast" "exigiblaste" ;
  existens_nn_1 = mkN "existens" "existenser" ;
  existensminimum_nn_1 = mkN "existensminimum" neutrum ;
  existentiell_av_1 = mkA "existentiell" ;
  exklamation_nn_1 = mkN "exklamation" "exklamationer" ;
  exklamatorisk_av_1 = mkA "exklamatorisk" ;
  exklusiv_av_1 = mkA "exklusiv" ;
  exklusivitet_nn_1 = mkN "exklusivitet" "exklusiviteter" ;
  exkrement_nn_1 = mkN "exkrement" "exkrementet" "exkrementer" "exkrementerna" ;
  exkremental_av_1 = mkA "exkremental" ;
  exkret_nn_1 = mkN "exkret" neutrum ;
  exkretion_nn_1 = mkN "exkretion" "exkretioner" ;
  exkung_nn_1 = mkN "exkung" ;
  exkurs_nn_1 = mkN "exkurs" "exkurser" ;
  exkursion_nn_1 = mkN "exkursion" "exkursioner" ;
  exlibris_nn_1 = mkN "exlibris" neutrum ;
  exogen_av_1 = mkA "exogen" ;
  exorcist_nn_1 = mkN "exorcist" "exorcister" ;
  exoterisk_av_1 = mkA "exoterisk" ;
  exotermisk_av_1 = mkA "exotermisk" ;
  exotisk_av_1 = mkA "exotisk" ;
  expansibel_av_1 = mkA "expansibel" "expansibelt" "expansibla" "expansibla" "expansiblare" "expansiblast" "expansiblaste" ;
  expansionskaerl_nn_1 = mkN "expansionskдrl" neutrum ;
  expansiv_av_1 = mkA "expansiv" ;
  expedit_av_1 = mkA "expedit" "expedit" ;
  expedit_nn_1 = mkN "expedit" "expediter" ;
  expedition_nn_1 = mkN "expedition" "expeditioner" ;
  expeditionskaar_nn_1 = mkN "expeditionskеr" "expeditionskеrer" ;
  expeditionsministaer_nn_1 = mkN "expeditionsministдr" "expeditionsministдrer" ;
  expeditionsregering_nn_1 = mkN "expeditionsregering" ;
  expeditionsvakt_nn_1 = mkN "expeditionsvakt" "expeditionsvakter" ;
  expeditoer_nn_1 = mkN "expeditцr" "expeditцrer" ;
  expektoration_nn_1 = mkN "expektoration" "expektorationer" ;
  experiment_nn_1 = mkN "experiment" neutrum ;
  experimentalfysiker_nn_1 = mkN "experimentalfysiker" "experimentalfysikern" "experimentalfysiker" "experimentalfysikerna" ;
  experimentator_nn_1 = mkN "experimentator" "experimentatorer" ;
  experimentell_av_1 = mkA "experimentell" ;
  experimentgymnasium_nn_1 = mkN "experimentgymnasium" "experimentgymnasiet" "experimentgymnasier" "experimentgymnasierna" ;
  expert_nn_1 = mkN "expert" "experter" ;
  expertgrupp_nn_1 = mkN "expertgrupp" "expertgrupper" ;
  expertkrets_nn_1 = mkN "expertkrets" ;
  expertspraak_nn_1 = mkN "expertsprеk" neutrum ;
  explanativ_av_1 = mkA "explanativ" ;
  explicit_av_1 = mkA "explicit" "explicit" ;
  explikation_nn_1 = mkN "explikation" "explikationer" ;
  exploatering_nn_1 = mkN "exploatering" ;
  exploatoer_nn_1 = mkN "exploatцr" "exploatцrer" ;
  explosion_nn_1 = mkN "explosion" "explosioner" ;
  explosionsfoerlopp_nn_1 = mkN "explosionsfцrlopp" neutrum ;
  explosionshaerd_nn_1 = mkN "explosionshдrd" ;
  explosionsmotor_nn_1 = mkN "explosionsmotor" "explosionsmotorer" ;
  explosionsoegonblick_nn_1 = mkN "explosionsцgonblick" neutrum ;
  explosionssaett_nn_1 = mkN "explosionssдtt" neutrum ;
  explosiv_av_1 = mkA "explosiv" ;
  expo_nn_1 = mkN "expo" "expor" ;
  exponent_nn_1 = mkN "exponent" "exponenter" ;
  exponentiell_av_1 = mkA "exponentiell" ;
  exponering_nn_1 = mkN "exponering" ;
  exponeringsmaetare_nn_1 = mkN "exponeringsmдtare" "exponeringsmдtare" ;
  export_nn_1 = mkN "export" "exporter" ;
  exportinkomst_nn_1 = mkN "exportinkomst" "exportinkomster" ;
  exportmarknad_nn_1 = mkN "exportmarknad" "exportmarknader" ;
  exportoer_nn_1 = mkN "exportцr" "exportцrer" ;
  expose_nn_1 = mkN "exposй" "exposйer" ;
  exposition_nn_1 = mkN "exposition" "expositioner" ;
  express_ab_1 = mkAdv "express" ;
  express_nn_1 = mkN "express" "expresser" ;
  expressbrev_nn_1 = mkN "expressbrev" neutrum ;
  expressbyraa_nn_1 = mkN "expressbyrе" "expressbyrеer" ;
  expressfoersaendelse_nn_1 = mkN "expressfцrsдndelse" "expressfцrsдndelser" ;
  expressionist_nn_1 = mkN "expressionist" "expressionister" ;
  expressiv_av_1 = mkA "expressiv" ;
  expressivitet_nn_1 = mkN "expressivitet" "expressiviteter" ;
  expropriation_nn_1 = mkN "expropriation" "expropriationer" ;
  exsickat_nn_1 = mkN "exsickat" neutrum ;
  exsickator_nn_1 = mkN "exsickator" "exsickatorer" ;
  exsudat_nn_1 = mkN "exsudat" neutrum ;
  extatisk_av_1 = mkA "extatisk" ;
  extempore_ab_1 = mkAdv "extempore" ;
  extension_nn_1 = mkN "extension" "extensioner" ;
  extensiv_av_1 = mkA "extensiv" ;
  exterioer_nn_1 = mkN "exteriцr" "exteriцrer" ;
  extern_av_1 = mkA "extern" ;
  extern_nn_1 = mkN "extern" "externer" ;
  externat_nn_1 = mkN "externat" neutrum ;
  exterritoriell_av_1 = mkA "exterritoriell" ;
  extra_ab_1 = mkAdv "extra" ;
  extra_av_1 = mkA "extra" ;
  extrainkomst_nn_1 = mkN "extrainkomst" "extrainkomster" ;
  extrajudiciell_av_1 = mkA "extrajudiciell" ;
  extraknaeck_nn_1 = mkN "extraknдck" neutrum ;
  extrakontant_av_1 = mkA "extrakontant" "extrakontant" ;
  extrakt_nn_1 = mkN "extrakt" neutrum ;
  extraktion_nn_1 = mkN "extraktion" "extraktioner" ;
  extraktivaemne_nn_1 = mkN "extraktivдmne" ;
  extraktor_nn_1 = mkN "extraktor" "extraktorer" ;
  extramural_av_1 = mkA "extramural" ;
  extraordinaer_av_1 = mkA "extraordinдr" ;
  extraordinarie_av_1 = mkA "extraordinarie" ;
  extraordinarie_nn_1 = mkN "extraordinarie" "extraordinarier" ;
  extrapolation_nn_1 = mkN "extrapolation" "extrapolationer" ;
  extrapris_nn_1 = mkN "extrapris" neutrum ;
  extrasol_nn_1 = mkN "extrasol" ;
  extrauterin_av_1 = mkA "extrauterin" ;
  extravagans_nn_1 = mkN "extravagans" "extravaganser" ;
  extravagant_av_1 = mkA "extravagant" "extravagant" ;
  extrem_av_1 = mkA "extrem" ;
  extrem_nn_1 = mkN "extrem" "extremer" ;
  extremist_nn_1 = mkN "extremist" "extremister" ;
  extremitet_nn_1 = mkN "extremitet" "extremiteter" ;
  extrovert_av_1 = mkA "extrovert" "extrovert" ;
  eye_liner_nn_1 = mkN "eye-liner" "eye-linern" "eye-liners" "eye-linersen" ;
  faa_av_1 = mkA "fе" "fе" "fе" "fдrre" "fдrst" ;
  faafaeng_av_1 = mkA "fеfдng" ;
  faafaenglig_av_1 = mkA "fеfдnglig" ;
  faafaenglighet_nn_1 = mkN "fеfдnglighet" "fеfдngligheter" ;
  faagel_nn_1 = mkN "fеgel" ;
  faagelaegg_nn_1 = mkN "fеgelдgg" neutrum ;
  faagelbad_nn_1 = mkN "fеgelbad" neutrum ;
  faagelbaer_nn_1 = mkN "fеgelbдr" neutrum ;
  faagelbo_nn_1 = mkN "fеgelbo" "fеgelbot" "fеgelbon" "fеgelboen" ;
  faagelbur_nn_1 = mkN "fеgelbur" ;
  faagelfjaeder_nn_1 = mkN "fеgelfjдder" ;
  faagelfot_nn_1 = mkN "fеgelfot" "fеgelfцtter" ;
  faagelfri_av_1 = mkA "fеgelfri" "fеgelfritt" ;
  faagelholk_nn_1 = mkN "fеgelholk" ;
  faagelhund_nn_1 = mkN "fеgelhund" ;
  faageljakt_nn_1 = mkN "fеgeljakt" "fеgeljakter" ;
  faagelperspektiv_nn_1 = mkN "fеgelperspektiv" neutrum ;
  faagelskaadare_nn_1 = mkN "fеgelskеdare" "fеgelskеdare" ;
  faagelskaadning_nn_1 = mkN "fеgelskеdning" ;
  faagelstraeck_nn_1 = mkN "fеgelstrдck" neutrum ;
  faagelunge_nn_1 = mkN "fеgelunge" utrum ;
  faagelvinge_nn_1 = mkN "fеgelvinge" utrum ;
  faakunnig_av_1 = mkA "fеkunnig" ;
  faale_nn_1 = mkN "fеle" utrum ;
  faall_nn_1 = mkN "fеll" ;
  faallbaenk_nn_1 = mkN "fеllbдnk" ;
  faamaeld_av_1 = mkA "fеmдld" "fеmдlt" ;
  faamansfoeretag_nn_1 = mkN "fеmansfцretag" neutrum ;
  faan_nn_1 = mkN "fеn" neutrum ;
  faane_nn_1 = mkN "fеne" utrum ;
  faaneri_nn_1 = mkN "fеneri" "fеnerit" "fеnerier" "fеnerierna" ;
  faang_nn_1 = mkN "fеng" neutrum ;
  faange_nn_1 = mkN "fеnge" utrum ;
  faangen_av_1 = mkA "fеngen" "fеnget" ;
  faangeshandling_nn_1 = mkN "fеngeshandling" ;
  faangesman_nn_1 = mkN "fеngesman" "fеngesmannen" "fеngesmдn" "fеngesmдnnen" ;
  faanglaeger_nn_1 = mkN "fеnglдger" neutrum ;
  faangst_nn_1 = mkN "fеngst" "fеngster" ;
  faangstanordning_nn_1 = mkN "fеngstanordning" ;
  faangstfolk_nn_1 = mkN "fеngstfolk" neutrum ;
  faangstgrop_nn_1 = mkN "fеngstgrop" ;
  faangstkrok_nn_1 = mkN "fеngstkrok" ;
  faangstkultur_nn_1 = mkN "fеngstkultur" "fеngstkulturer" ;
  faangstplats_nn_1 = mkN "fеngstplats" "fеngstplatser" ;
  faangstredskap_nn_1 = mkN "fеngstredskap" "fеngstredskapet" "fеngstredskapen" "fеngstredskapena" ;
  faangvaktare_nn_1 = mkN "fеngvaktare" "fеngvaktare" ;
  faanig_av_1 = mkA "fеnig" ;
  faanskratt_nn_1 = mkN "fеnskratt" neutrum ;
  faantratt_nn_1 = mkN "fеntratt" ;
  faaordig_av_1 = mkA "fеordig" ;
  faar_nn_1 = mkN "fеr" neutrum ;
  faaraktig_av_1 = mkA "fеraktig" ;
  faarbogsaerm_nn_1 = mkN "fеrbogsдrm" ;
  faarfiol_nn_1 = mkN "fеrfiol" "fеrfioler" ;
  faarhund_nn_1 = mkN "fеrhund" ;
  faarost_nn_1 = mkN "fеrost" ;
  faarskalle_nn_1 = mkN "fеrskalle" utrum ;
  faarskinn_nn_1 = mkN "fеrskinn" neutrum ;
  faat_nn_1 = mkN "fеt" "fеter" ;
  faatal_nn_1 = mkN "fеtal" "fеtalet" "fеtalen" "fеtalena" ;
  faatalig_av_1 = mkA "fеtalig" ;
  faatoelj_nn_1 = mkN "fеtцlj" "fеtцljer" ;
  faavitsk_av_1 = mkA "fеvitsk" ;
  fabel_nn_1 = mkN "fabel" "fabeln" "fabler" "fablerna" ;
  fabelaktig_av_1 = mkA "fabelaktig" ;
  fabeldjur_nn_1 = mkN "fabeldjur" neutrum ;
  fabrik_nn_1 = mkN "fabrik" "fabriker" ;
  fabrikant_nn_1 = mkN "fabrikant" "fabrikanter" ;
  fabrikat_nn_1 = mkN "fabrikat" neutrum ;
  fabrikation_nn_1 = mkN "fabrikation" "fabrikationer" ;
  fabrikoer_nn_1 = mkN "fabrikцr" "fabrikцrer" ;
  fabriksmaessig_av_1 = mkA "fabriksmдssig" ;
  fabriksny_av_1 = mkA "fabriksny" "fabriksnytt" ;
  fabrikspris_nn_1 = mkN "fabrikspris" neutrum ;
  fabriksskorsten_nn_1 = mkN "fabriksskorsten" "fabriksskorstenen" "fabriksskorstenar" "fabriksskorstenarna" ;
  fabulering_nn_1 = mkN "fabulering" ;
  fabuloes_av_1 = mkA "fabulцs" ;
  facil_av_1 = mkA "facil" ;
  facilitet_nn_1 = mkN "facilitet" "faciliteter" ;
  fack_nn_1 = mkN "fack" neutrum ;
  fackelblomster_nn_1 = mkN "fackelblomster" neutrum ;
  fackeltaag_nn_1 = mkN "fackeltеg" neutrum ;
  fackfoerbund_nn_1 = mkN "fackfцrbund" neutrum ;
  fackfoerening_nn_1 = mkN "fackfцrening" ;
  fackfoereningsroerelse_nn_1 = mkN "fackfцreningsrцrelse" "fackfцreningsrцrelser" ;
  fackidiot_nn_1 = mkN "fackidiot" "fackidioter" ;
  fackkunnig_av_1 = mkA "fackkunnig" ;
  fackkunskap_nn_1 = mkN "fackkunskap" "fackkunskaper" ;
  fackla_nn_1 = mkN "fackla" ;
  facklig_av_1 = mkA "facklig" ;
  fackmaessig_av_1 = mkA "fackmдssig" ;
  fackman_nn_1 = mkN "fackman" "fackmannen" "fackmдn" "fackmдnnen" ;
  fackminister_nn_1 = mkN "fackminister" ;
  fackordbok_nn_1 = mkN "fackordbok" "fackordbцcker" ;
  fackorgan_nn_1 = mkN "fackorgan" neutrum ;
  fackspraak_nn_1 = mkN "facksprеk" neutrum ;
  fackterm_nn_1 = mkN "fackterm" "facktermer" ;
  facktidskrift_nn_1 = mkN "facktidskrift" "facktidskrifter" ;
  fackutskottsprincip_nn_1 = mkN "fackutskottsprincip" "fackutskottsprinciper" ;
  fackverk_nn_1 = mkN "fackverk" neutrum ;
  fadaes_nn_1 = mkN "fadдs" "fadдser" ;
  fadder_nn_1 = mkN "fadder" ;
  fadderbarn_nn_1 = mkN "fadderbarn" neutrum ;
  fader_nn_1 = mkN "fader" "fadern" "fдder" "fдderna" ;
  faderlig_av_1 = mkA "faderlig" ;
  fadermoerdare_nn_1 = mkN "fadermцrdare" "fadermцrdare" ;
  fadersarv_nn_1 = mkN "fadersarv" neutrum ;
  fadersfigur_nn_1 = mkN "fadersfigur" "fadersfigurer" ;
  fadersgestalt_nn_1 = mkN "fadersgestalt" "fadersgestalter" ;
  fadershus_nn_1 = mkN "fadershus" neutrum ;
  faderskomplex_nn_1 = mkN "faderskomplex" neutrum ;
  fadersnamn_nn_1 = mkN "fadersnamn" neutrum ;
  fadersvaelde_nn_1 = mkN "fadersvдlde" ;
  fadervaar_nn_1 = mkN "fadervеr" neutrum ;
  fae_nn_1 = mkN "fд" "fдet" "fдn" "fдna" ;
  faeaktig_av_1 = mkA "fдaktig" ;
  faebless_nn_1 = mkN "fдbless" "fдblesser" ;
  faebod_nn_1 = mkN "fдbod" ;
  faebodvall_nn_1 = mkN "fдbodvall" ;
  faedernesland_nn_1 = mkN "fдdernesland" neutrum ;
  faegnad_nn_1 = mkN "fдgnad" "fдgnader" ;
  faegnesam_av_1 = mkA "fдgnesam" "fдgnesamt" "fдgnesamma" "fдgnesamma" "fдgnesammare" "fдgnesammast" "fдgnesammaste" ;
  faehund_nn_1 = mkN "fдhund" ;
  faehus_nn_1 = mkN "fдhus" neutrum ;
  faektare_nn_1 = mkN "fдktare" "fдktare" ;
  faektning_nn_1 = mkN "fдktning" ;
  faelg_nn_1 = mkN "fдlg" ;
  faelgkors_nn_1 = mkN "fдlgkors" neutrum ;
  faell_nn_1 = mkN "fдll" ;
  faellbar_av_1 = mkA "fдllbar" ;
  faellkniv_nn_1 = mkN "fдllkniv" ;
  faellkoel_nn_1 = mkN "fдllkцl" ;
  faellning_nn_1 = mkN "fдllning" ;
  faellstol_nn_1 = mkN "fдllstol" ;
  faelt_nn_1 = mkN "fдlt" neutrum ;
  faeltarme_nn_1 = mkN "fдltarmй" "fдltarmйer" ;
  faeltassistent_nn_1 = mkN "fдltassistent" "fдltassistenter" ;
  faeltbiolog_nn_1 = mkN "fдltbiolog" "fдltbiologer" ;
  faeltflygare_nn_1 = mkN "fдltflygare" "fдltflygare" ;
  faeltfoersoek_nn_1 = mkN "fдltfцrsцk" neutrum ;
  faeltgraa_av_1 = mkA "fдltgrе" "fдltgrеtt" ;
  faelthare_nn_1 = mkN "fдlthare" utrum ;
  faeltherre_nn_1 = mkN "fдltherre" utrum ;
  faelthoens_nn_1 = mkN "fдlthцns" neutrum ;
  faeltkikare_nn_1 = mkN "fдltkikare" "fдltkikare" ;
  faeltmaessig_av_1 = mkA "fдltmдssig" ;
  faeltmaetning_nn_1 = mkN "fдltmдtning" ;
  faeltmarskalk_nn_1 = mkN "fдltmarskalk" ;
  faeltpraest_nn_1 = mkN "fдltprдst" "fдltprдster" ;
  faeltrop_nn_1 = mkN "fдltrop" neutrum ;
  faeltskaer_nn_1 = mkN "fдltskдr" "fдltskдrer" ;
  faeltslag_nn_1 = mkN "fдltslag" neutrum ;
  faeltspat_nn_1 = mkN "fдltspat" "fдltspater" ;
  faeltstudium_nn_1 = mkN "fдltstudium" "fдltstudiet" "fдltstudier" "fдltstudierna" ;
  faeltstyrka_nn_1 = mkN "fдltstyrka" ;
  faelttaag_nn_1 = mkN "fдlttеg" neutrum ;
  faelttaagsplan_nn_1 = mkN "fдlttеgsplan" "fдlttеgsplaner" ;
  faelttaevlan_nn_1 = mkN "fдlttдvlan" "fдlttдvlan" "fдlttдvlningar" "fдlttдvlningarna" ;
  faelttecken_nn_1 = mkN "fдlttecken" "fдlttecknet" "fдlttecken" "fдlttecknen" ;
  faelttjaenstgoering_nn_1 = mkN "fдlttjдnstgцring" ;
  faelttjaenstoevning_nn_1 = mkN "fдlttjдnstцvning" ;
  faeltuniform_nn_1 = mkN "fдltuniform" "fдltuniformer" ;
  faenad_nn_1 = mkN "fдnad" "fдnader" ;
  faengelse_nn_1 = mkN "fдngelse" "fдngelset" "fдngelser" "fдngelserna" ;
  faengelsecell_nn_1 = mkN "fдngelsecell" "fдngelseceller" ;
  faengelsefoerhaallande_nn_1 = mkN "fдngelsefцrhеllande" ;
  faengelsekund_nn_1 = mkN "fдngelsekund" "fдngelsekunder" ;
  faengelsestraff_nn_1 = mkN "fдngelsestraff" neutrum ;
  faenghaal_nn_1 = mkN "fдnghеl" neutrum ;
  faengsel_nn_1 = mkN "fдngsel" neutrum ;
  faengslande_av_1 = mkA "fдngslande" ;
  faengslig_av_1 = mkA "fдngslig" ;
  faenrik_nn_1 = mkN "fдnrik" ;
  faerd_nn_1 = mkN "fдrd" "fдrder" ;
  faerdbevis_nn_1 = mkN "fдrdbevis" neutrum ;
  faerdbiljett_nn_1 = mkN "fдrdbiljett" "fдrdbiljetter" ;
  faerdig_av_1 = mkA "fдrdig" ;
  faerdighet_nn_1 = mkN "fдrdighet" "fдrdigheter" ;
  faerdighetsaemne_nn_1 = mkN "fдrdighetsдmne" ;
  faerdighetstraening_nn_1 = mkN "fдrdighetstrдning" ;
  faerdknaepp_nn_1 = mkN "fдrdknдpp" ;
  faerdled_nn_1 = mkN "fдrdled" "fдrdleder" ;
  faerdledare_nn_1 = mkN "fдrdledare" "fдrdledare" ;
  faerdmedel_nn_1 = mkN "fдrdmedel" neutrum ;
  faerdriktning_nn_1 = mkN "fдrdriktning" ;
  faerdskrivare_nn_1 = mkN "fдrdskrivare" "fдrdskrivare" ;
  faerdvaeg_nn_1 = mkN "fдrdvдg" ;
  faerg_nn_1 = mkN "fдrg" "fдrger" ;
  faergaekta_av_1 = mkA "fдrgдkta" ;
  faergaemne_nn_1 = mkN "fдrgдmne" ;
  faergbad_nn_1 = mkN "fдrgbad" neutrum ;
  faergband_nn_1 = mkN "fдrgband" neutrum ;
  faergbestaendig_av_1 = mkA "fдrgbestдndig" ;
  faergbild_nn_1 = mkN "fдrgbild" "fдrgbilder" ;
  faergblandning_nn_1 = mkN "fдrgblandning" ;
  faergblind_av_1 = mkA "fдrgblind" ;
  faergeri_nn_1 = mkN "fдrgeri" "fдrgerit" "fдrgerier" "fдrgerierna" ;
  faergfilter_nn_1 = mkN "fдrgfilter" neutrum ;
  faergfoeraendring_nn_1 = mkN "fдrgfцrдndring" ;
  faergglad_av_1 = mkA "fдrgglad" ;
  faerggrann_av_1 = mkA "fдrggrann" "fдrggrant" ;
  faerghandel_nn_1 = mkN "fдrghandel" ;
  faergkaenslig_av_1 = mkA "fдrgkдnslig" ;
  faergkaenslighet_nn_1 = mkN "fдrgkдnslighet" "fдrgkдnsligheter" ;
  faergklick_nn_1 = mkN "fдrgklick" ;
  faergkontrast_nn_1 = mkN "fдrgkontrast" "fдrgkontraster" ;
  faerglitografi_nn_1 = mkN "fдrglitografi" "fдrglitografier" ;
  faergloes_av_1 = mkA "fдrglцs" ;
  faergmoenster_nn_1 = mkN "fдrgmцnster" neutrum ;
  faergning_nn_1 = mkN "fдrgning" ;
  faergpigment_nn_1 = mkN "fдrgpigment" neutrum ;
  faergreproduktion_nn_1 = mkN "fдrgreproduktion" "fдrgreproduktioner" ;
  faergrik_av_1 = mkA "fдrgrik" ;
  faergrivning_nn_1 = mkN "fдrgrivning" ;
  faergsaettning_nn_1 = mkN "fдrgsдttning" ;
  faergspektrum_nn_1 = mkN "fдrgspektrum" neutrum ;
  faergspel_nn_1 = mkN "fдrgspel" "fдrgspelet" "fдrgspel" "fдrgspelen" ;
  faergsprakande_av_1 = mkA "fдrgsprakande" ;
  faergspridning_nn_1 = mkN "fдrgspridning" ;
  faergstark_av_1 = mkA "fдrgstark" ;
  faergstoff_nn_1 = mkN "fдrgstoff" "fдrgstoffer" ;
  faergtemperatur_nn_1 = mkN "fдrgtemperatur" "fдrgtemperaturer" ;
  faergteve_nn_1 = mkN "fдrgteve" "fдrgteven" "fдrgteve" "fдrgtevena" ;
  faergton_nn_1 = mkN "fдrgton" "fдrgtoner" ;
  faergtryck_nn_1 = mkN "fдrgtryck" neutrum ;
  faering_nn_1 = mkN "fдring" ;
  faerjelaege_nn_1 = mkN "fдrjelдge" ;
  faerm_av_1 = mkA "fдrm" ;
  faermitet_nn_1 = mkN "fдrmitet" "fдrmiteter" ;
  faeroeing_nn_1 = mkN "fдrцing" ;
  faeroeisk_av_1 = mkA "fдrцisk" ;
  faeroeiska_nn_2 = mkN "fдrцiska" ;
  faers_nn_1 = mkN "fдrs" "fдrser" ;
  faersk_av_1 = mkA "fдrsk" ;
  faerskmalm_nn_1 = mkN "fдrskmalm" "fдrskmalmer" ;
  faerskning_nn_1 = mkN "fдrskning" ;
  faerskvatten_nn_1 = mkN "fдrskvatten" "fдrskvattnet" "fдrskvatten" "fдrskvattnen" ;
  faesoer_nn_1 = mkN "fдsцr" "fдsцrer" ;
  faesting_nn_1 = mkN "fдsting" ;
  faestman_nn_1 = mkN "fдstman" "fдstmannen" "fдstmдn" "fдstmдnnen" ;
  faestmoe_nn_1 = mkN "fдstmц" "fдstmцn" "fдstmцr" "fдstmцrna" ;
  faestning_nn_1 = mkN "fдstning" ;
  faestpunkt_nn_1 = mkN "fдstpunkt" "fдstpunkter" ;
  fager_av_1 = mkA "fager" "fagert" "fagra" "fagra" "fagrare" "fagrast" "fagraste" ;
  fagott_nn_1 = mkN "fagott" "fagotter" ;
  faiblesse_nn_1 = mkN "faiblesse" "faiblesser" ;
  fajans_nn_1 = mkN "fajans" "fajanser" ;
  fajt_nn_1 = mkN "fajt" "fajter" ;
  fakir_nn_1 = mkN "fakir" "fakirer" ;
  faksimil_nn_1 = mkN "faksimil" neutrum ;
  faksimile_nn_1 = mkN "faksimile" "faksimiler" ;
  faktafolder_nn_1 = mkN "faktafolder" ;
  fakticitet_nn_1 = mkN "fakticitet" "fakticiteter" ;
  faktisk_av_1 = mkA "faktisk" ;
  faktor_nn_1 = mkN "faktor" "faktorer" ;
  faktoranalys_nn_1 = mkN "faktoranalys" "faktoranalyser" ;
  faktori_nn_1 = mkN "faktori" "faktorit" "faktorier" "faktorierna" ;
  faktotum_nn_1 = mkN "faktotum" neutrum ;
  faktum_nn_1 = mkN "faktum" neutrum ;
  fakultativ_av_1 = mkA "fakultativ" ;
  fakultet_nn_1 = mkN "fakultet" "fakulteter" ;
  fakultetsopponent_nn_1 = mkN "fakultetsopponent" "fakultetsopponenter" ;
  fal_av_1 = mkA "fal" ;
  falang_nn_1 = mkN "falang" "falanger" ;
  falangist_nn_1 = mkN "falangist" "falangister" ;
  falk_nn_1 = mkN "falk" ;
  falkenerare_nn_1 = mkN "falkenerare" "falkenerare" ;
  falkjakt_nn_1 = mkN "falkjakt" "falkjakter" ;
  falkonett_nn_1 = mkN "falkonett" "falkonetter" ;
  fall_nn_1 = mkN "fall" neutrum ;
  falla_vb_1 = mkV "falla" "fцll" "fallit" ;
  fallen_av_1 = mkA "fallen" "fallet" ;
  fallenhet_nn_1 = mkN "fallenhet" "fallenheter" ;
  fallfaerdig_av_1 = mkA "fallfдrdig" ;
  fallfrukt_nn_1 = mkN "fallfrukt" "fallfrukter" ;
  fallgrop_nn_1 = mkN "fallgrop" ;
  fallhammare_nn_1 = mkN "fallhammare" "fallhammaren" "fallhamrar" "fallhamrarna" ;
  fallhoejd_nn_1 = mkN "fallhцjd" "fallhцjder" ;
  fallissemang_nn_1 = mkN "fallissemang" neutrum ;
  fallos_nn_1 = mkN "fallos" ;
  fallrep_nn_1 = mkN "fallrep" neutrum ;
  fallseger_nn_1 = mkN "fallseger" ;
  fallskaerm_nn_1 = mkN "fallskдrm" ;
  fallskaermshoppare_nn_1 = mkN "fallskдrmshoppare" "fallskдrmshoppare" ;
  fallskaermsjaegare_nn_1 = mkN "fallskдrmsjдgare" "fallskдrmsjдgare" ;
  fallskaermstrupp_nn_1 = mkN "fallskдrmstrupp" "fallskдrmstrupper" ;
  fallstudie_nn_1 = mkN "fallstudie" "fallstudier" ;
  fallverk_nn_1 = mkN "fallverk" neutrum ;
  fallvind_nn_1 = mkN "fallvind" ;
  fals_nn_1 = mkN "fals" ;
  falsarium_nn_1 = mkN "falsarium" "falsariet" "falsarier" "falsarierna" ;
  falsifikat_nn_1 = mkN "falsifikat" neutrum ;
  falsk_av_1 = mkA "falsk" ;
  falskeligen_ab_1 = mkAdv "falskeligen" ;
  falskmyntare_nn_1 = mkN "falskmyntare" "falskmyntare" ;
  falskspel_nn_1 = mkN "falskspel" "falskspelet" "falskspel" "falskspelen" ;
  falukorv_nn_1 = mkN "falukorv" ;
  faluroed_av_1 = mkA "falurцd" ;
  familj_nn_1 = mkN "familj" "familjer" ;
  familjaer_av_1 = mkA "familjдr" ;
  familjaritet_nn_1 = mkN "familjaritet" "familjariteter" ;
  familjebidrag_nn_1 = mkN "familjebidrag" neutrum ;
  familjebiljett_nn_1 = mkN "familjebiljett" "familjebiljetter" ;
  familjebolag_nn_1 = mkN "familjebolag" neutrum ;
  familjedaghem_nn_1 = mkN "familjedaghem" "familjedaghemmet" "familjedaghem" "familjedaghemmen" ;
  familjefoeretag_nn_1 = mkN "familjefцretag" neutrum ;
  familjefoersoerjare_nn_1 = mkN "familjefцrsцrjare" "familjefцrsцrjare" ;
  familjehem_nn_1 = mkN "familjehem" "familjehemmet" "familjehem" "familjehemmen" ;
  familjehotell_nn_1 = mkN "familjehotell" neutrum ;
  familjejordbruk_nn_1 = mkN "familjejordbruk" neutrum ;
  familjekrets_nn_1 = mkN "familjekrets" ;
  familjemedlem_nn_1 = mkN "familjemedlem" "familjemedlemmen" "familjemedlemmar" "familjemedlemmarna" ;
  familjenamn_nn_1 = mkN "familjenamn" neutrum ;
  familjepension_nn_1 = mkN "familjepension" "familjepensioner" ;
  familjeplanering_nn_1 = mkN "familjeplanering" ;
  familjeraadgivning_nn_1 = mkN "familjerеdgivning" ;
  familjerabatt_nn_1 = mkN "familjerabatt" "familjerabatter" ;
  famlande_av_1 = mkA "famlande" ;
  famn_nn_1 = mkN "famn" ;
  famntag_nn_1 = mkN "famntag" neutrum ;
  famoes_av_1 = mkA "famцs" ;
  fan_nn_2 = mkN "fan" "fanen" "fans" "fansen" ;
  fan_nn_3 = mkN "fan" neutrum ;
  fanatiker_nn_1 = mkN "fanatiker" "fanatikern" "fanatiker" "fanatikerna" ;
  fanatisk_av_1 = mkA "fanatisk" ;
  fanborg_nn_1 = mkN "fanborg" ;
  fandango_nn_1 = mkN "fandango" "fandangor" ;
  faner_nn_1 = mkN "faner" "faneret" "faner" "faneren" ;
  fanerogam_av_1 = mkA "fanerogam" ;
  fanerogam_nn_1 = mkN "fanerogam" "fanerogamer" ;
  fanfar_nn_1 = mkN "fanfar" "fanfarer" ;
  fanjunkare_nn_1 = mkN "fanjunkare" "fanjunkare" ;
  fanskap_nn_1 = mkN "fanskap" "fanskapet" "fanskapen" "fanskapena" ;
  fanstyg_nn_1 = mkN "fanstyg" neutrum ;
  fantasi_nn_1 = mkN "fantasi" "fantasier" ;
  fantasidjur_nn_1 = mkN "fantasidjur" neutrum ;
  fantasifull_av_1 = mkA "fantasifull" ;
  fantasiloes_av_1 = mkA "fantasilцs" ;
  fantasiprodukt_nn_1 = mkN "fantasiprodukt" "fantasiprodukter" ;
  fantasispel_nn_1 = mkN "fantasispel" "fantasispelet" "fantasispel" "fantasispelen" ;
  fantasivaerld_nn_1 = mkN "fantasivдrld" ;
  fantast_nn_1 = mkN "fantast" "fantaster" ;
  fantasteri_nn_1 = mkN "fantasteri" "fantasterit" "fantasterier" "fantasterierna" ;
  fantastisk_av_1 = mkA "fantastisk" ;
  fantom_nn_1 = mkN "fantom" neutrum ;
  fantom_nn_2 = mkN "fantom" "fantomer" ;
  fantomsnygg_av_1 = mkA "fantomsnygg" ;
  fara_nn_1 = mkN "fara" ;
  fara_vb_1 = mkV "fara" "for" "farit" ;
  farad_nn_1 = mkN "farad" "faraden" "farad" "faraden" ;
  farao_nn_1 = mkN "farao" "farao" "faraoner" "faraonerna" ;
  farbar_av_1 = mkA "farbar" ;
  farbroder_nn_1 = mkN "farbroder" "farbrodern" "farbrцder" "farbrцderna" ;
  farbroderlig_av_1 = mkA "farbroderlig" ;
  farbror_nn_1 = mkN "farbror" "farbrцder" ;
  fardag_nn_1 = mkN "fardag" ;
  farfoeraelder_nn_1 = mkN "farfцrдlder" ;
  fargalt_nn_1 = mkN "fargalt" ;
  farise_nn_1 = mkN "farisй" "farisйer" ;
  fariseisk_av_1 = mkA "fariseisk" ;
  farkost_nn_1 = mkN "farkost" "farkoster" ;
  farled_nn_1 = mkN "farled" "farleder" ;
  farlig_av_1 = mkA "farlig" ;
  farlighet_nn_1 = mkN "farlighet" "farligheter" ;
  farm_nn_1 = mkN "farm" ;
  farmaceut_nn_1 = mkN "farmaceut" "farmaceuter" ;
  farmaceutisk_av_1 = mkA "farmaceutisk" ;
  farmacevt_nn_1 = mkN "farmacevt" "farmacevter" ;
  farmacevtisk_av_1 = mkA "farmacevtisk" ;
  farmacie_av_1 = mkA "farmacie" ;
  farmaka_nn_1 = mkN "farmaka" "farmakan" "farmaka" "farmakana" ;
  farmakolog_nn_1 = mkN "farmakolog" "farmakologer" ;
  farmakologisk_av_1 = mkA "farmakologisk" ;
  farmakope_nn_1 = mkN "farmakopй" "farmakopйer" ;
  farmare_nn_1 = mkN "farmare" "farmare" ;
  farmor_nn_1 = mkN "farmoder" "farmodern" "farmцdrar" "farmцdrarna" ;
  farofylld_av_1 = mkA "farofylld" "farofyllt" ;
  farozon_nn_1 = mkN "farozon" "farozoner" ;
  fars_nn_1 = mkN "fars" "farser" ;
  farsarv_nn_1 = mkN "farsarv" neutrum ;
  farsgubbe_nn_1 = mkN "farsgubbe" utrum ;
  farsot_nn_1 = mkN "farsot" "farsoter" ;
  farstu_nn_1 = mkN "farstu" "farstun" "farstur" "farsturna" ;
  fart_nn_1 = mkN "fart" "farter" ;
  fartblind_av_1 = mkA "fartblind" ;
  fartdaare_nn_1 = mkN "fartdеre" utrum ;
  farthaallare_nn_1 = mkN "farthеllare" "farthеllare" ;
  farthinder_nn_1 = mkN "farthinder" neutrum ;
  fartkamera_nn_1 = mkN "fartkamera" ;
  fartrand_nn_1 = mkN "fartrand" "fartrдnder" ;
  fartyg_nn_1 = mkN "fartyg" neutrum ;
  fartygsbesaettning_nn_1 = mkN "fartygsbesдttning" ;
  fartygsbotten_nn_1 = mkN "fartygsbotten" ;
  fartygsdaeck_nn_1 = mkN "fartygsdдck" neutrum ;
  fartygskurs_nn_1 = mkN "fartygskurs" "fartygskurser" ;
  fartygslast_nn_1 = mkN "fartygslast" "fartygslaster" ;
  fartygssida_nn_1 = mkN "fartygssida" ;
  fartygsskrov_nn_1 = mkN "fartygsskrov" neutrum ;
  fartygstyp_nn_1 = mkN "fartygstyp" "fartygstyper" ;
  farvael_nn_1 = mkN "farvдl" neutrum ;
  farvatten_nn_1 = mkN "farvatten" "farvattnet" "farvatten" "farvattnen" ;
  faryngal_av_1 = mkA "faryngal" ;
  fas_nn_1 = mkN "fas" "faser" ;
  fasa_nn_1 = mkN "fasa" ;
  fasad_nn_1 = mkN "fasad" "fasader" ;
  fasan_nn_1 = mkN "fasan" "fasaner" ;
  fasansfull_av_1 = mkA "fasansfull" ;
  fasavaeckande_av_1 = mkA "fasavдckande" ;
  fascist_nn_1 = mkN "fascist" "fascister" ;
  fascistisk_av_1 = mkA "fascistisk" ;
  fasett_nn_1 = mkN "fasett" "fasetter" ;
  fasettoega_nn_1 = mkN "fasettцga" "fasettцgat" "fasettцgon" "fasettцgonen" ;
  fasfoerskjutning_nn_1 = mkN "fasfцrskjutning" ;
  fashionabel_av_1 = mkA "fashionabel" "fashionabelt" "fashionabla" "fashionabla" "fashionablare" "fashionablast" "fashionablaste" ;
  faskikel_nn_1 = mkN "faskikel" ;
  faskin_nn_1 = mkN "faskin" "faskiner" ;
  faskinkniv_nn_1 = mkN "faskinkniv" ;
  faslig_av_1 = mkA "faslig" ;
  fason_nn_1 = mkN "fason" "fasoner" ;
  fasspaenning_nn_1 = mkN "fasspдnning" ;
  fast_ab_1 = mkAdv "fast" ;
  fast_av_1 = mkA "fast" "fast" ;
  fasta_nn_1 = mkN "fasta" ;
  fastage_nn_1 = mkN "fastage" "fastaget" "fastage" "fastagen" ;
  fastemaanad_nn_1 = mkN "fastemеnad" "fastemеnader" ;
  faster_nn_1 = mkN "faster" ;
  fastfrusen_av_1 = mkA "fastfrusen" "fastfruset" ;
  fasthaalla_vb_1 = mkV "fasthеlla" "fasthцll" "fasthеllit" ;
  fasthaallning_nn_1 = mkN "fasthеllning" ;
  fasthet_nn_1 = mkN "fasthet" "fastheter" ;
  fastighet_nn_1 = mkN "fastighet" "fastigheter" ;
  fastighetsbyraa_nn_1 = mkN "fastighetsbyrе" "fastighetsbyrеer" ;
  fastighetskoep_nn_1 = mkN "fastighetskцp" neutrum ;
  fastighetsmaeklare_nn_1 = mkN "fastighetsmдklare" "fastighetsmдklare" ;
  fastighetsskatt_nn_1 = mkN "fastighetsskatt" "fastighetsskatter" ;
  fastighetsskoetare_nn_1 = mkN "fastighetsskцtare" "fastighetsskцtare" ;
  fastighetstaxering_nn_1 = mkN "fastighetstaxering" ;
  fastlaast_av_1 = mkA "fastlеst" "fastlеst" ;
  fastlaenning_nn_1 = mkN "fastlдnning" ;
  fastlagsbulle_nn_1 = mkN "fastlagsbulle" utrum ;
  fastlagsris_nn_1 = mkN "fastlagsris" neutrum ;
  fastlagssoendag_nn_1 = mkN "fastlagssцndag" ;
  fastmer_ab_1 = mkAdv "fastmer" ;
  fastsaettning_nn_1 = mkN "fastsдttning" ;
  fastta_vb_1 = mkV "fastta" "fasttar" "fastta" "fasttog" "fasttagit" "fasttagen" ;
  fat_nn_1 = mkN "fat" neutrum ;
  fatabur_nn_1 = mkN "fatabur" "fataburer" ;
  fatal_av_1 = mkA "fatal" ;
  fataliedag_nn_1 = mkN "fataliedag" ;
  fatalietid_nn_1 = mkN "fatalietid" "fatalietider" ;
  fatalist_nn_1 = mkN "fatalist" "fatalister" ;
  fatalistisk_av_1 = mkA "fatalistisk" ;
  fatalitet_nn_1 = mkN "fatalitet" "fataliteter" ;
  fatbur_nn_1 = mkN "fatbur" "fatburer" ;
  fatt_ab_1 = mkAdv "fatt" ;
  fatt_av_1 = mkA "fatt" ;
  fattbar_av_1 = mkA "fattbar" ;
  fattbarhet_nn_1 = mkN "fattbarhet" "fattbarheter" ;
  fattig_av_1 = mkA "fattig" ;
  fattigdom_nn_1 = mkN "fattigdom" ;
  fattigdomsbevis_nn_1 = mkN "fattigdomsbevis" neutrum ;
  fattighjon_nn_1 = mkN "fattighjon" neutrum ;
  fattiglapp_nn_1 = mkN "fattiglapp" ;
  fattlig_av_1 = mkA "fattlig" ;
  fattning_nn_1 = mkN "fattning" ;
  faun_nn_1 = mkN "faun" "fauner" ;
  faunist_nn_1 = mkN "faunist" "faunister" ;
  faunistisk_av_1 = mkA "faunistisk" ;
  faute_nn_1 = mkN "faute" "fauter" ;
  favoer_nn_1 = mkN "favцr" "favцrer" ;
  favorit_nn_1 = mkN "favorit" "favoriter" ;
  favoritfoerfattare_nn_1 = mkN "favoritfцrfattare" "favoritfцrfattare" ;
  favoritraett_nn_1 = mkN "favoritrдtt" "favoritrдtter" ;
  favoritrestaurang_nn_1 = mkN "favoritrestaurang" "favoritrestauranger" ;
  fax_nn_1 = mkN "fax" ;
  fax_nn_2 = mkN "fax" neutrum ;
  fe_nn_1 = mkN "fe" "feer" ;
  featureprogram_nn_1 = mkN "featureprogram" "featureprogrammet" "featureprogram" "featureprogrammen" ;
  feber_nn_1 = mkN "feber" ;
  feberanfall_nn_1 = mkN "feberanfall" neutrum ;
  feberfri_av_1 = mkA "feberfri" "feberfritt" ;
  febersjukdom_nn_1 = mkN "febersjukdom" ;
  febertermometer_nn_1 = mkN "febertermometer" ;
  febrig_av_1 = mkA "febrig" ;
  febril_av_1 = mkA "febril" ;
  federal_av_1 = mkA "federal" ;
  federalist_nn_1 = mkN "federalist" "federalister" ;
  federalistisk_av_1 = mkA "federalistisk" ;
  federation_nn_1 = mkN "federation" "federationer" ;
  federativ_av_1 = mkA "federativ" ;
  feeri_nn_1 = mkN "feeri" "feerit" "feerier" "feerierna" ;
  feg_av_1 = mkA "feg" ;
  feghet_nn_1 = mkN "feghet" "fegheter" ;
  fegis_nn_1 = mkN "fegis" ;
  fejd_nn_1 = mkN "fejd" "fejder" ;
  fekal_av_1 = mkA "fekal" ;
  fel_av_1 = mkA "fel" ;
  fel_nn_1 = mkN "fel" neutrum ;
  felaktig_av_1 = mkA "felaktig" ;
  felaktighet_nn_1 = mkN "felaktighet" "felaktigheter" ;
  felbedoemning_nn_1 = mkN "felbedцmning" ;
  felberaekning_nn_1 = mkN "felberдkning" ;
  feldrag_nn_1 = mkN "feldrag" neutrum ;
  felfinnare_nn_1 = mkN "felfinnare" "felfinnare" ;
  felfri_av_1 = mkA "felfri" "felfritt" ;
  felgrepp_nn_1 = mkN "felgrepp" neutrum ;
  felhandling_nn_1 = mkN "felhandling" ;
  felmarginal_nn_1 = mkN "felmarginal" "felmarginaler" ;
  felparkering_nn_1 = mkN "felparkering" ;
  felprocent_nn_1 = mkN "felprocent" "felprocenten" "felprocent" "felprocenten" ;
  felraekningspeng_nn_1 = mkN "felrдkningspeng" ;
  felsaegning_nn_1 = mkN "felsдgning" ;
  felslagen_av_1 = mkA "felslagen" "felslaget" ;
  felslut_nn_1 = mkN "felslut" neutrum ;
  felsteg_nn_1 = mkN "felsteg" neutrum ;
  femaarig_av_1 = mkA "femеrig" ;
  femaarsplan_nn_1 = mkN "femеrsplan" "femеrsplaner" ;
  femaktare_nn_1 = mkN "femaktare" "femaktare" ;
  femdagarsvecka_nn_1 = mkN "femdagarsvecka" ;
  femdygnsprognos_nn_1 = mkN "femdygnsprognos" "femdygnsprognoser" ;
  feminin_av_1 = mkA "feminin" ;
  femininum_nn_1 = mkN "femininum" "femininet" "femininer" "femininerna" ;
  feminist_nn_1 = mkN "feminist" "feminister" ;
  feministisk_av_1 = mkA "feministisk" ;
  femkamp_nn_1 = mkN "femkamp" "femkamper" ;
  femling_nn_1 = mkN "femling" ;
  femoering_nn_1 = mkN "femцring" ;
  femstaemmig_av_1 = mkA "femstдmmig" ;
  femtedel_nn_1 = mkN "femtedel" "femtedelen" "femtedelar" "femtedelarna" ;
  femtekolonn_nn_1 = mkN "femtekolonn" "femtekolonner" ;
  femtekolonnare_nn_1 = mkN "femtekolonnare" "femtekolonnare" ;
  femtiaarsdag_nn_1 = mkN "femtiеrsdag" ;
  femtikronorssedel_nn_1 = mkN "femtikronorssedel" ;
  femtilapp_nn_1 = mkN "femtilapp" ;
  femtioaarsdag_nn_1 = mkN "femtioеrsdag" ;
  femtioering_nn_1 = mkN "femtiцring" ;
  femtiokronorssedel_nn_1 = mkN "femtiokronorssedel" ;
  femtiooering_nn_1 = mkN "femtioцring" ;
  femtiotal_nn_1 = mkN "femtiotal" "femtiotalet" "femtiotalen" "femtiotalena" ;
  femtiotalist_nn_1 = mkN "femtiotalist" "femtiotalister" ;
  femtital_nn_1 = mkN "femtital" "femtitalet" "femtitalen" "femtitalena" ;
  femtitalist_nn_1 = mkN "femtitalist" "femtitalister" ;
  femtonhundrameterslopp_nn_1 = mkN "femtonhundrameterslopp" neutrum ;
  femuddig_av_1 = mkA "femuddig" ;
  fena_av_1 = mkA "fena" ;
  fender_nn_1 = mkN "fender" ;
  fendert_nn_1 = mkN "fendert" ;
  fenedrin_nn_1 = mkN "fenedrin" "fenedriner" ;
  fenicier_nn_1 = mkN "fenicier" "feniciern" "fenicier" "fenicierna" ;
  fenicisk_av_1 = mkA "fenicisk" ;
  fenkoel_nn_1 = mkN "fenkцl" ;
  fenmetralin_nn_1 = mkN "fenmetralin" "fenmetraliner" ;
  fennicism_nn_1 = mkN "fennicism" "fennicismer" ;
  fennoman_nn_1 = mkN "fennoman" "fennomaner" ;
  fenol_nn_1 = mkN "fenol" "fenoler" ;
  fenolftalein_nn_1 = mkN "fenolftalein" "fenolftaleiner" ;
  fenolisk_av_1 = mkA "fenolisk" ;
  fenomen_nn_1 = mkN "fenomen" neutrum ;
  fenomenal_av_1 = mkA "fenomenal" ;
  fenomenologisk_av_1 = mkA "fenomenologisk" ;
  fenoplast_nn_1 = mkN "fenoplast" "fenoplaster" ;
  fenotyp_nn_1 = mkN "fenotyp" "fenotyper" ;
  fenval_nn_1 = mkN "fenval" ;
  feodal_av_1 = mkA "feodal" ;
  ferie_nn_1 = mkN "ferie" "ferier" ;
  ferm_av_1 = mkA "ferm" ;
  fermat_nn_1 = mkN "fermat" neutrum ;
  ferment_nn_1 = mkN "ferment" neutrum ;
  fermitet_nn_1 = mkN "fermitet" "fermiteter" ;
  ferrit_nn_1 = mkN "ferrit" "ferriter" ;
  ferrolegering_nn_1 = mkN "ferrolegering" ;
  fertil_av_1 = mkA "fertil" ;
  fertilitet_nn_1 = mkN "fertilitet" "fertiliteter" ;
  fest_nn_1 = mkN "fest" "fester" ;
  festande_nn_1 = mkN "festande" ;
  festarrangoer_nn_1 = mkN "festarrangцr" "festarrangцrer" ;
  festbord_nn_1 = mkN "festbord" neutrum ;
  festival_nn_1 = mkN "festival" "festivaler" ;
  festivitet_nn_1 = mkN "festivitet" "festiviteter" ;
  festklaenning_nn_1 = mkN "festklдnning" ;
  festkvaell_nn_1 = mkN "festkvдll" ;
  festlig_av_1 = mkA "festlig" ;
  festlighet_nn_1 = mkN "festlighet" "festligheter" ;
  festmaaltid_nn_1 = mkN "festmеltid" "festmеltider" ;
  festmiddag_nn_1 = mkN "festmiddag" ;
  feston_nn_1 = mkN "feston" "festoner" ;
  festong_nn_1 = mkN "festong" "festonger" ;
  festprisse_nn_1 = mkN "festprisse" utrum ;
  festskrift_nn_1 = mkN "festskrift" "festskrifter" ;
  festspel_nn_1 = mkN "festspel" "festspelet" "festspel" "festspelen" ;
  feststaemning_nn_1 = mkN "feststдmning" ;
  festtaag_nn_1 = mkN "festtеg" neutrum ;
  festvaaning_nn_1 = mkN "festvеning" ;
  fet_av_1 = mkA "fet" ;
  fetblad_nn_1 = mkN "fetblad" neutrum ;
  fetisch_nn_1 = mkN "fetisch" "fetischer" ;
  fetischist_nn_1 = mkN "fetischist" "fetischister" ;
  fetknopp_nn_1 = mkN "fetknopp" ;
  fetlagd_av_1 = mkA "fetlagd" "fetlagt" ;
  fets_nn_1 = mkN "fets" "fetser" ;
  fetsill_nn_1 = mkN "fetsill" ;
  fetstil_nn_1 = mkN "fetstil" ;
  fett_nn_1 = mkN "fett" "fettet" "fetter" "fetterna" ;
  fettaemne_nn_1 = mkN "fettдmne" ;
  fetthaerdning_nn_1 = mkN "fetthдrdning" ;
  fetthalt_nn_1 = mkN "fetthalt" "fetthalter" ;
  fetthaltig_av_1 = mkA "fetthaltig" ;
  fettisdag_nn_1 = mkN "fettisdag" ;
  fettisdagsbulle_nn_1 = mkN "fettisdagsbulle" utrum ;
  fettkoertel_nn_1 = mkN "fettkцrtel" ;
  fettlever_nn_1 = mkN "fettlever" ;
  fettloesande_av_1 = mkA "fettlцsande" ;
  fettloeslig_av_1 = mkA "fettlцslig" ;
  fettloeslighet_nn_1 = mkN "fettlцslighet" "fettlцsligheter" ;
  fetto_nn_1 = mkN "fetto" "fettot" "fetton" "fettona" ;
  fettreserv_nn_1 = mkN "fettreserv" "fettreserver" ;
  fettrik_av_1 = mkA "fettrik" ;
  fettsvansfaar_nn_1 = mkN "fettsvansfеr" neutrum ;
  fettvaevnad_nn_1 = mkN "fettvдvnad" "fettvдvnader" ;
  fettvalk_nn_1 = mkN "fettvalk" ;
  fez_nn_1 = mkN "fez" "fezer" ;
  fial_nn_1 = mkN "fial" "fialer" ;
  fiasko_nn_1 = mkN "fiasko" "fiaskot" "fiaskon" "fiaskona" ;
  fibbla_nn_1 = mkN "fibbla" ;
  fiber_nn_1 = mkN "fiber" "fibern" "fibrer" "fibrerna" ;
  fiberrik_av_1 = mkA "fiberrik" ;
  fiberspik_nn_1 = mkN "fiberspik" ;
  fibervaext_nn_1 = mkN "fibervдxt" "fibervдxter" ;
  fibrig_av_1 = mkA "fibrig" ;
  fibrill_nn_1 = mkN "fibrill" "fibriller" ;
  fibrin_nn_1 = mkN "fibrin" neutrum ;
  fickformat_nn_1 = mkN "fickformat" neutrum ;
  fickhandbok_nn_1 = mkN "fickhandbok" "fickhandbцcker" ;
  fickkalkylator_nn_1 = mkN "fickkalkylator" "fickkalkylatorer" ;
  fickkniv_nn_1 = mkN "fickkniv" ;
  fickpeng_nn_1 = mkN "fickpeng" ;
  fickspegel_nn_1 = mkN "fickspegel" ;
  ficktjuv_nn_1 = mkN "ficktjuv" ;
  fickur_nn_1 = mkN "fickur" neutrum ;
  fiction_novell_nn_1 = mkN "fiction-novell" "fiction-noveller" ;
  fideikommiss_nn_1 = mkN "fideikommiss" neutrum ;
  fidjian_nn_1 = mkN "fidjian" "fidjianer" ;
  fidus_nn_1 = mkN "fidus" ;
  fiende_nn_1 = mkN "fiende" "fiender" ;
  fiendskap_nn_1 = mkN "fiendskap" "fiendskaper" ;
  fientlig_av_1 = mkA "fientlig" ;
  fientlighet_nn_1 = mkN "fientlighet" "fientligheter" ;
  fiffig_av_1 = mkA "fiffig" ;
  fifflare_nn_1 = mkN "fifflare" "fifflare" ;
  fight_nn_1 = mkN "fight" "fighter" ;
  fighter_nn_1 = mkN "fighter" "fightern" "fighter" "fighterna" ;
  figur_nn_1 = mkN "figur" "figurer" ;
  figuraakning_nn_1 = mkN "figurеkning" ;
  figurant_nn_1 = mkN "figurant" "figuranter" ;
  figuration_nn_1 = mkN "figuration" "figurationer" ;
  figurativ_av_1 = mkA "figurativ" ;
  figurlig_av_1 = mkA "figurlig" ;
  figursydd_av_1 = mkA "figursydd" "figursydtt" ;
  fijian_nn_1 = mkN "fijian" "fijianer" ;
  fik_nn_1 = mkN "fik" neutrum ;
  fiken_av_1 = mkA "fiken" "fiket" ;
  fikon_nn_1 = mkN "fikon" neutrum ;
  fikonloev_nn_1 = mkN "fikonlцv" neutrum ;
  fikonspraak_nn_1 = mkN "fikonsprеk" neutrum ;
  fikontraed_nn_1 = mkN "fikontrдd" neutrum ;
  fiktion_nn_1 = mkN "fiktion" "fiktioner" ;
  fiktiv_av_1 = mkA "fiktiv" ;
  fikus_nn_1 = mkN "fikus" ;
  fil_nn_1 = mkN "fil" "filer" ;
  fil_nn_2 = mkN "fil" ;
  filantrop_nn_1 = mkN "filantrop" "filantroper" ;
  filantropisk_av_1 = mkA "filantropisk" ;
  filatelist_nn_1 = mkN "filatelist" "filatelister" ;
  filbunke_nn_1 = mkN "filbunke" utrum ;
  file_nn_1 = mkN "filй" "filйer" ;
  filharmoniker_nn_1 = mkN "filharmoniker" "filharmonikern" "filharmoniker" "filharmonikerna" ;
  filharmonisk_av_1 = mkA "filharmonisk" ;
  filial_nn_1 = mkN "filial" "filialer" ;
  filibuster_nn_1 = mkN "filibuster" ;
  filibustring_nn_1 = mkN "filibustring" ;
  filigran_nn_1 = mkN "filigran" neutrum ;
  filipin_nn_1 = mkN "filipin" "filipiner" ;
  filippik_nn_1 = mkN "filippik" "filippiker" ;
  filippinare_nn_1 = mkN "filippinare" "filippinare" ;
  filippinsk_av_1 = mkA "filippinsk" ;
  filiste_nn_1 = mkN "filistй" "filistйer" ;
  filister_nn_1 = mkN "filister" ;
  filistroes_av_1 = mkA "filistrцs" ;
  filklove_nn_1 = mkN "filklove" utrum ;
  filkoerning_nn_1 = mkN "filkцrning" ;
  film_nn_1 = mkN "film" "filmer" ;
  filmare_nn_1 = mkN "filmare" "filmare" ;
  filmatelje_nn_1 = mkN "filmateljй" "filmateljйer" ;
  filmatisk_av_1 = mkA "filmatisk" ;
  filmbild_nn_1 = mkN "filmbild" "filmbilder" ;
  filmexpert_nn_1 = mkN "filmexpert" "filmexperter" ;
  filmfars_nn_1 = mkN "filmfars" "filmfarser" ;
  filmfotograf_nn_1 = mkN "filmfotograf" "filmfotografer" ;
  filmframkallning_nn_1 = mkN "filmframkallning" ;
  filmgranskning_nn_1 = mkN "filmgranskning" ;
  filmhistoria_nn_1 = mkN "filmhistoria" "filmhistorien" "filmhistorier" "filmhistorierna" ;
  filminspelning_nn_1 = mkN "filminspelning" ;
  filmisk_av_1 = mkA "filmisk" ;
  filmkamera_nn_1 = mkN "filmkamera" ;
  filmkomedi_nn_1 = mkN "filmkomedi" "filmkomedier" ;
  filmmanuskript_nn_1 = mkN "filmmanuskript" neutrum ;
  filmning_nn_1 = mkN "filmning" ;
  filmotek_nn_1 = mkN "filmotek" neutrum ;
  filmpremiaer_nn_1 = mkN "filmpremiдr" "filmpremiдrer" ;
  filmregissoer_nn_1 = mkN "filmregissцr" "filmregissцrer" ;
  filmrulle_nn_1 = mkN "filmrulle" utrum ;
  filmscen_nn_1 = mkN "filmscen" "filmscener" ;
  filmskaadespelare_nn_1 = mkN "filmskеdespelare" "filmskеdespelare" ;
  filmskapare_nn_1 = mkN "filmskapare" "filmskapare" ;
  filmstudio_nn_1 = mkN "filmstudio" "filmstudior" ;
  filmtecknare_nn_1 = mkN "filmtecknare" "filmtecknare" ;
  filolog_nn_1 = mkN "filolog" "filologer" ;
  filologi_nn_1 = mkN "filologi" "filologier" ;
  filologisk_av_1 = mkA "filologisk" ;
  filosof_nn_1 = mkN "filosof" "filosofer" ;
  filosofem_nn_1 = mkN "filosofem" neutrum ;
  filosofi_nn_1 = mkN "filosofi" "filosofier" ;
  filosofie_av_1 = mkA "filosofie" ;
  filosofisk_av_1 = mkA "filosofisk" ;
  filspaan_nn_1 = mkN "filspеn" neutrum ;
  filt_nn_1 = mkN "filt" ;
  filter_nn_1 = mkN "filter" neutrum ;
  filtercigarett_nn_1 = mkN "filtercigarett" "filtercigaretter" ;
  filterpaase_nn_1 = mkN "filterpеse" utrum ;
  filtrat_nn_1 = mkN "filtrat" neutrum ;
  filtrerpapper_nn_1 = mkN "filtrerpapper" neutrum ;
  filtspets_nn_1 = mkN "filtspets" ;
  filttoffel_nn_1 = mkN "filttoffel" "filttoffeln" "filttofflor" "filttofflorna" ;
  filur_nn_1 = mkN "filur" "filurer" ;
  fimbulvinter_nn_1 = mkN "fimbulvinter" ;
  fimmelstaang_nn_1 = mkN "fimmelstеng" "fimmelstдnger" ;
  fimp_nn_1 = mkN "fimp" ;
  fin_av_1 = mkA "fin" ;
  final_av_1 = mkA "final" ;
  final_nn_1 = mkN "final" "finaler" ;
  finalist_nn_1 = mkN "finalist" "finalister" ;
  finansdebatt_nn_1 = mkN "finansdebatt" "finansdebatter" ;
  finansdepartement_nn_1 = mkN "finansdepartement" "finansdepartementet" "finansdepartementen" "finansdepartementena" ;
  finansiaer_nn_1 = mkN "finansiдr" "finansiдrer" ;
  finansiell_av_1 = mkA "finansiell" ;
  finansiering_nn_1 = mkN "finansiering" ;
  finansman_nn_1 = mkN "finansman" "finansmannen" "finansmдn" "finansmдnnen" ;
  finansminister_nn_1 = mkN "finansminister" ;
  finansplan_nn_1 = mkN "finansplan" "finansplaner" ;
  finansvalp_nn_1 = mkN "finansvalp" ;
  finemang_ab_1 = mkAdv "finemang" ;
  finess_nn_1 = mkN "finess" "finesser" ;
  finfin_av_1 = mkA "finfin" ;
  finger_nn_1 = mkN "finger" ;
  fingeravtryck_nn_1 = mkN "fingeravtryck" neutrum ;
  fingerboejarmuskel_nn_1 = mkN "fingerbцjarmuskel" "fingerbцjarmuskeln" "fingerbцjarmuskler" "fingerbцjarmusklerna" ;
  fingerborg_nn_1 = mkN "fingerborg" ;
  fingerfaerdig_av_1 = mkA "fingerfдrdig" ;
  fingerfaerg_nn_1 = mkN "fingerfдrg" "fingerfдrger" ;
  fingerhud_nn_1 = mkN "fingerhud" ;
  fingerled_nn_1 = mkN "fingerled" "fingerleder" ;
  fingernerv_nn_1 = mkN "fingernerv" "fingernerver" ;
  fingeroert_nn_1 = mkN "fingerцrt" "fingerцrter" ;
  fingerprov_nn_1 = mkN "fingerprov" neutrum ;
  fingerring_nn_1 = mkN "fingerring" ;
  fingersaettning_nn_1 = mkN "fingersдttning" ;
  fingerstraeckarmuskel_nn_1 = mkN "fingerstrдckarmuskel" "fingerstrдckarmuskeln" "fingerstrдckarmuskler" "fingerstrдckarmusklerna" ;
  fingersvamp_nn_1 = mkN "fingersvamp" ;
  fingertopp_nn_1 = mkN "fingertopp" ;
  fingervante_nn_1 = mkN "fingervante" utrum ;
  fingervisning_nn_1 = mkN "fingervisning" ;
  finhyllt_av_1 = mkA "finhyllt" "finhyllt" ;
  finish_nn_1 = mkN "finish" ;
  finit_av_1 = mkA "finit" "finit" ;
  fink_nn_1 = mkN "fink" ;
  finkaensla_nn_1 = mkN "finkдnsla" ;
  finkaenslig_av_1 = mkA "finkдnslig" ;
  finkaenslighet_nn_1 = mkN "finkдnslighet" "finkдnsligheter" ;
  finkalibrig_av_1 = mkA "finkalibrig" ;
  finkart_nn_1 = mkN "finkart" "finkarter" ;
  finkelolja_nn_1 = mkN "finkelolja" ;
  finkfaagel_nn_1 = mkN "finkfеgel" ;
  finklaedd_av_1 = mkA "finklдdd" "finklдdtt" ;
  finkornig_av_1 = mkA "finkornig" ;
  finkunge_nn_1 = mkN "finkunge" utrum ;
  finlaendare_nn_1 = mkN "finlдndare" "finlдndare" ;
  finlaendsk_av_1 = mkA "finlдndsk" ;
  finlaendska_nn_1 = mkN "finlдndska" ;
  finlandism_nn_1 = mkN "finlandism" "finlandismer" ;
  finlandssvensk_av_1 = mkA "finlandssvensk" ;
  finlandssvensk_nn_1 = mkN "finlandssvensk" ;
  finlandssvenska_nn_2 = mkN "finlandssvenska" ;
  finlek_nn_1 = mkN "finlek" ;
  finmaskig_av_1 = mkA "finmaskig" ;
  finmekaniker_nn_1 = mkN "finmekaniker" "finmekanikern" "finmekaniker" "finmekanikerna" ;
  finmekanisk_av_1 = mkA "finmekanisk" ;
  finna_vb_1 = mkV "finna" "fann" "funnit" ;
  finne_nn_1 = mkN "finne" utrum ;
  finnig_av_1 = mkA "finnig" ;
  finnjolle_nn_1 = mkN "finnjolle" utrum ;
  finnmark_nn_1 = mkN "finnmark" "finnmarker" ;
  finrum_nn_1 = mkN "finrum" "finrummet" "finrum" "finrummen" ;
  finsk_av_1 = mkA "finsk" ;
  finsk_ugrisk_av_1 = mkA "finsk-ugrisk" ;
  finska_nn_2 = mkN "finska" ;
  finskhet_nn_1 = mkN "finskhet" "finskheter" ;
  finsko_nn_1 = mkN "finsko" "finskor" ;
  finsmakare_nn_1 = mkN "finsmakare" "finsmakare" ;
  finsmide_nn_1 = mkN "finsmide" ;
  finsnickare_nn_1 = mkN "finsnickare" "finsnickare" ;
  finsnickeri_nn_1 = mkN "finsnickeri" "finsnickerit" "finsnickerier" "finsnickerierna" ;
  finspunnen_av_1 = mkA "finspunnen" "finspunnet" "finspunna" "finspunna" "finspunnare" "finspunnast" "finspunnaste" ;
  finstaemd_av_1 = mkA "finstдmd" "finstдmt" ;
  finstilt_av_1 = mkA "finstilt" "finstilt" ;
  finstruktur_nn_1 = mkN "finstruktur" "finstrukturer" ;
  fint_nn_1 = mkN "fint" "finter" ;
  fintlig_av_1 = mkA "fintlig" ;
  fintvaett_nn_1 = mkN "fintvдtt" ;
  finurlig_av_1 = mkA "finurlig" ;
  fiol_nn_1 = mkN "fiol" "fioler" ;
  fiolblock_nn_1 = mkN "fiolblock" neutrum ;
  fiolspelare_nn_1 = mkN "fiolspelare" "fiolspelare" ;
  fiolstraeng_nn_1 = mkN "fiolstrдng" ;
  fioritur_nn_1 = mkN "fioritur" "fioriturer" ;
  fipplig_av_1 = mkA "fipplig" ;
  firma_nn_1 = mkN "firma" ;
  firmafest_nn_1 = mkN "firmafest" "firmafester" ;
  firmamaerke_nn_1 = mkN "firmamдrke" ;
  firmanamn_nn_1 = mkN "firmanamn" neutrum ;
  firmatecknare_nn_1 = mkN "firmatecknare" "firmatecknare" ;
  firmateckning_nn_1 = mkN "firmateckning" ;
  firngraens_nn_1 = mkN "firngrдns" "firngrдnser" ;
  firre_nn_1 = mkN "firre" utrum ;
  fis_nn_1 = mkN "fis" ;
  fischy_nn_1 = mkN "fischy" "fischyer" ;
  fisfoernaem_av_1 = mkA "fisfцrnдm" ;
  fisig_av_1 = mkA "fisig" ;
  fisk_nn_1 = mkN "fisk" ;
  fiskaadra_nn_1 = mkN "fiskеdra" ;
  fiskal_av_1 = mkA "fiskal" ;
  fiskalisk_av_1 = mkA "fiskalisk" ;
  fiskare_nn_1 = mkN "fiskare" "fiskare" ;
  fiskart_nn_1 = mkN "fiskart" "fiskarter" ;
  fiskben_nn_1 = mkN "fiskben" neutrum ;
  fiskbensmoenster_nn_1 = mkN "fiskbensmцnster" neutrum ;
  fiskbulle_nn_1 = mkN "fiskbulle" utrum ;
  fiskdamm_nn_1 = mkN "fiskdamm" ;
  fiske_nn_1 = mkN "fiske" ;
  fiskebaat_nn_1 = mkN "fiskebеt" ;
  fiskebank_nn_1 = mkN "fiskebank" ;
  fiskedrag_nn_1 = mkN "fiskedrag" neutrum ;
  fiskefartyg_nn_1 = mkN "fiskefartyg" neutrum ;
  fiskegraens_nn_1 = mkN "fiskegrдns" "fiskegrдnser" ;
  fiskekort_nn_1 = mkN "fiskekort" neutrum ;
  fiskekrok_nn_1 = mkN "fiskekrok" ;
  fiskelaege_nn_1 = mkN "fiskelдge" ;
  fiskelag_nn_1 = mkN "fiskelag" ;
  fiskenaet_nn_1 = mkN "fiskenдt" neutrum ;
  fiskenation_nn_1 = mkN "fiskenation" "fiskenationer" ;
  fiskeredskap_nn_1 = mkN "fiskeredskap" "fiskeredskapet" "fiskeredskapen" "fiskeredskapena" ;
  fiskeri_nn_1 = mkN "fiskeri" "fiskerit" "fiskerier" "fiskerierna" ;
  fiskeristyrelse_nn_1 = mkN "fiskeristyrelse" "fiskeristyrelser" ;
  fiskevatten_nn_1 = mkN "fiskevatten" "fiskevattnet" "fiskevatten" "fiskevattnen" ;
  fiskezon_nn_1 = mkN "fiskezon" "fiskezoner" ;
  fiskfile_nn_1 = mkN "fiskfilй" "fiskfilйer" ;
  fiskgjuse_nn_1 = mkN "fiskgjuse" utrum ;
  fiskhamn_nn_1 = mkN "fiskhamn" ;
  fiskkrok_nn_1 = mkN "fiskkrok" ;
  fiskmaas_nn_1 = mkN "fiskmеs" ;
  fiskmun_nn_1 = mkN "fiskmun" "fiskmunnen" "fiskmunnar" "fiskmunnarna" ;
  fisknaet_nn_1 = mkN "fisknдt" neutrum ;
  fisknot_nn_1 = mkN "fisknot" ;
  fiskodling_nn_1 = mkN "fiskodling" ;
  fiskoega_nn_1 = mkN "fiskцga" "fiskцgat" "fiskцgon" "fiskцgonen" ;
  fiskpinne_nn_1 = mkN "fiskpinne" utrum ;
  fiskpudding_nn_1 = mkN "fiskpudding" ;
  fiskredskap_nn_1 = mkN "fiskredskap" "fiskredskapet" "fiskredskapen" "fiskredskapena" ;
  fiskstim_nn_1 = mkN "fiskstim" "fiskstimmet" "fiskstim" "fiskstimmen" ;
  fisksump_nn_1 = mkN "fisksump" ;
  fisktom_av_1 = mkA "fisktom" "fisktomt" "fisktomma" "fisktomma" "fisktommare" "fisktommast" "fisktommaste" ;
  fiskvandring_nn_1 = mkN "fiskvandring" ;
  fiskyngel_nn_1 = mkN "fiskyngel" neutrum ;
  fissil_av_1 = mkA "fissil" ;
  fission_nn_1 = mkN "fission" "fissioner" ;
  fissur_nn_1 = mkN "fissur" "fissurer" ;
  fistel_nn_1 = mkN "fistel" ;
  fistuloes_av_1 = mkA "fistulцs" ;
  fix_av_1 = mkA "fix" ;
  fixare_nn_1 = mkN "fixare" "fixare" ;
  fixativ_nn_1 = mkN "fixativ" neutrum ;
  fixerbad_nn_1 = mkN "fixerbad" neutrum ;
  fixering_nn_1 = mkN "fixering" ;
  fixeringsbild_nn_1 = mkN "fixeringsbild" "fixeringsbilder" ;
  fixpunkt_nn_1 = mkN "fixpunkt" "fixpunkter" ;
  fixtur_nn_1 = mkN "fixtur" "fixturer" ;
  fjaeder_nn_1 = mkN "fjдder" ;
  fjaederboll_nn_1 = mkN "fjдderboll" ;
  fjaederbuske_nn_1 = mkN "fjдderbuske" utrum ;
  fjaederdraekt_nn_1 = mkN "fjдderdrдkt" "fjдderdrдkter" ;
  fjaederfae_nn_1 = mkN "fjдderfд" "fjдderfдet" "fjдderfдn" "fjдderfдna" ;
  fjaederklaedd_av_1 = mkA "fjдderklдdd" ;
  fjaederlaett_av_1 = mkA "fjдderlдtt" ;
  fjaedermoln_nn_1 = mkN "fjдdermoln" neutrum ;
  fjaederpensel_nn_1 = mkN "fjдderpensel" ;
  fjaederskrud_nn_1 = mkN "fjдderskrud" ;
  fjaedertyp_nn_1 = mkN "fjдdertyp" "fjдdertyper" ;
  fjaedervaag_nn_1 = mkN "fjдdervеg" ;
  fjaedervinge_nn_1 = mkN "fjдdervinge" utrum ;
  fjaedring_nn_1 = mkN "fjдdring" ;
  fjaell_nn_1 = mkN "fjдll" neutrum ;
  fjaellaemmel_nn_1 = mkN "fjдllдmmel" "fjдllдmmeln" "fjдllдmmlar" "fjдllдmmlarna" ;
  fjaellbaeck_nn_1 = mkN "fjдllbдck" ;
  fjaellbjoerk_nn_1 = mkN "fjдllbjцrk" ;
  fjaellbrud_nn_1 = mkN "fjдllbrud" ;
  fjaellig_av_1 = mkA "fjдllig" ;
  fjaellik_av_1 = mkA "fjдllik" ;
  fjaellkedja_nn_1 = mkN "fjдllkedja" ;
  fjaellnaera_av_1 = mkA "fjдllnдra" ;
  fjaellpansar_nn_1 = mkN "fjдllpansar" neutrum ;
  fjaellpipare_nn_1 = mkN "fjдllpipare" "fjдllpipare" ;
  fjaellplataa_nn_1 = mkN "fjдllplatе" "fjдllplatеer" ;
  fjaellraev_nn_1 = mkN "fjдllrдv" ;
  fjaellskivling_nn_1 = mkN "fjдllskivling" ;
  fjaelltrakt_nn_1 = mkN "fjдlltrakt" "fjдlltrakter" ;
  fjaellturist_nn_1 = mkN "fjдllturist" "fjдllturister" ;
  fjaellvaerld_nn_1 = mkN "fjдllvдrld" ;
  fjaellvandrare_nn_1 = mkN "fjдllvandrare" "fjдllvandrare" ;
  fjaellvandring_nn_1 = mkN "fjдllvandring" ;
  fjaellvraak_nn_1 = mkN "fjдllvrеk" ;
  fjaelster_nn_1 = mkN "fjдlster" neutrum ;
  fjaer_av_1 = mkA "fjдr" ;
  fjaerd_nn_1 = mkN "fjдrd" ;
  fjaerdedel_nn_1 = mkN "fjдrdedel" "fjдrdedelen" "fjдrdedelar" "fjдrdedelarna" ;
  fjaerding_nn_1 = mkN "fjдrding" ;
  fjaerdingsman_nn_1 = mkN "fjдrdingsman" "fjдrdingsmannen" "fjдrdingsmдn" "fjдrdingsmдnnen" ;
  fjaerdingsvaeg_nn_1 = mkN "fjдrdingsvдg" "fjдrdingsvдgen" "fjдrdingsvдg" "fjдrdingsvдgen" ;
  fjaeril_nn_1 = mkN "fjдril" ;
  fjaerilsart_nn_1 = mkN "fjдrilsart" "fjдrilsarter" ;
  fjaerran_ab_1 = mkAdv "fjдrran" ;
  fjaerran_av_1 = mkA "fjдrran" ;
  fjaerrblockering_nn_1 = mkN "fjдrrblockering" ;
  fjaerrkontroll_nn_1 = mkN "fjдrrkontroll" "fjдrrkontroller" ;
  fjaerrpunkt_nn_1 = mkN "fjдrrpunkt" "fjдrrpunkter" ;
  fjaerrseende_av_1 = mkA "fjдrrseende" ;
  fjaerrskaadande_av_1 = mkA "fjдrrskеdande" ;
  fjaerrskaadare_nn_1 = mkN "fjдrrskеdare" "fjдrrskеdare" ;
  fjaerrskrivare_nn_1 = mkN "fjдrrskrivare" "fjдrrskrivare" ;
  fjaerrskrivmaskin_nn_1 = mkN "fjдrrskrivmaskin" "fjдrrskrivmaskiner" ;
  fjaerrstyrd_av_1 = mkA "fjдrrstyrd" "fjдrrstyrt" ;
  fjaerrtaag_nn_1 = mkN "fjдrrtеg" neutrum ;
  fjaert_nn_1 = mkN "fjдrt" ;
  fjaesker_nn_1 = mkN "fjдsker" ;
  fjaeskig_av_1 = mkA "fjдskig" ;
  fjaet_nn_1 = mkN "fjдt" neutrum ;
  fjant_nn_1 = mkN "fjant" ;
  fjanteri_nn_1 = mkN "fjanteri" "fjanterit" "fjanterier" "fjanterierna" ;
  fjantig_av_1 = mkA "fjantig" ;
  fjoel_nn_1 = mkN "fjцl" ;
  fjolaar_nn_1 = mkN "fjolеr" neutrum ;
  fjolaarsgraes_nn_1 = mkN "fjolеrsgrдs" neutrum ;
  fjolleri_nn_1 = mkN "fjolleri" "fjollerit" "fjollerier" "fjollerierna" ;
  fjollig_av_1 = mkA "fjollig" ;
  fjomperi_nn_1 = mkN "fjomperi" "fjomperit" "fjomperier" "fjomperierna" ;
  fjompig_av_1 = mkA "fjompig" ;
  fjord_nn_1 = mkN "fjord" ;
  fjordhaest_nn_1 = mkN "fjordhдst" ;
  fjording_nn_1 = mkN "fjording" ;
  fjun_nn_1 = mkN "fjun" neutrum ;
  fjunig_av_1 = mkA "fjunig" ;
  fjuttig_av_1 = mkA "fjuttig" ;
  flaabuse_nn_1 = mkN "flеbuse" utrum ;
  flaasig_av_1 = mkA "flеsig" ;
  flabb_nn_1 = mkN "flabb" ;
  flabb_nn_2 = mkN "flabb" neutrum ;
  flabbig_av_1 = mkA "flabbig" ;
  flack_av_1 = mkA "flack" ;
  flackbanepjaes_nn_1 = mkN "flackbanepjдs" "flackbanepjдser" ;
  fladdermus_nn_1 = mkN "fladdermus" "fladdermusen" "fladdermцss" "fladdermцssen" ;
  fladdrig_av_1 = mkA "fladdrig" ;
  flaeck_nn_1 = mkN "flдck" ;
  flaeckborttagning_nn_1 = mkN "flдckborttagning" ;
  flaeckborttagningsmedel_nn_1 = mkN "flдckborttagningsmedel" neutrum ;
  flaeckfri_av_1 = mkA "flдckfri" "flдckfritt" ;
  flaeckig_av_1 = mkA "flдckig" ;
  flaeckvis_ab_1 = mkAdv "flдckvis" ;
  flaeder_nn_1 = mkN "flдder" ;
  flaederbaer_nn_1 = mkN "flдderbдr" neutrum ;
  flaedermus_nn_1 = mkN "flдdermus" "flдdermusen" "flдdermцss" "flдdermцssen" ;
  flaekt_nn_1 = mkN "flдkt" ;
  flaengig_av_1 = mkA "flдngig" ;
  flaens_nn_1 = mkN "flдns" ;
  flaerdfri_av_1 = mkA "flдrdfri" "flдrdfritt" ;
  flaerdfull_av_1 = mkA "flдrdfull" ;
  flaeskaenger_nn_1 = mkN "flдskдnger" ;
  flaeskfile_nn_1 = mkN "flдskfilй" "flдskfilйer" ;
  flaeskhare_nn_1 = mkN "flдskhare" utrum ;
  flaeskig_av_1 = mkA "flдskig" ;
  flaeskkarre_nn_1 = mkN "flдskkarrй" "flдskkarrйer" ;
  flaeskkorv_nn_1 = mkN "flдskkorv" ;
  flaeskkotlett_nn_1 = mkN "flдskkotlett" "flдskkotletter" ;
  flaesklaegg_nn_1 = mkN "flдsklдgg" ;
  flaesklaepp_nn_1 = mkN "flдsklдpp" ;
  flaesktaerning_nn_1 = mkN "flдsktдrning" ;
  flaetverk_nn_1 = mkN "flдtverk" neutrum ;
  flagell_nn_1 = mkN "flagell" "flageller" ;
  flagellant_nn_1 = mkN "flagellant" "flagellanter" ;
  flagellat_nn_1 = mkN "flagellat" "flagellater" ;
  flageolett_nn_1 = mkN "flageolett" "flageoletter" ;
  flaggdag_nn_1 = mkN "flaggdag" ;
  flaggkapten_nn_1 = mkN "flaggkapten" "flaggkaptener" ;
  flaggman_nn_1 = mkN "flaggman" "flaggmannen" "flaggmдn" "flaggmдnnen" ;
  flaggning_nn_1 = mkN "flaggning" ;
  flaggskepp_nn_1 = mkN "flaggskepp" neutrum ;
  flaggspel_nn_1 = mkN "flaggspel" "flaggspelet" "flaggspel" "flaggspelen" ;
  flaggstaang_nn_1 = mkN "flaggstеng" "flaggstдnger" ;
  flagig_av_1 = mkA "flagig" ;
  flagrant_av_1 = mkA "flagrant" "flagrant" ;
  flak_nn_1 = mkN "flak" neutrum ;
  flakong_nn_1 = mkN "flakong" "flakonger" ;
  flamenco_nn_1 = mkN "flamenco" "flamencor" ;
  flamingo_nn_1 = mkN "flamingo" "flamingor" ;
  flamlaendare_nn_1 = mkN "flamlдndare" "flamlдndare" ;
  flamlaendsk_av_1 = mkA "flamlдndsk" ;
  flamlaendska_nn_2 = mkN "flamlдndska" ;
  flammig_av_1 = mkA "flammig" ;
  flampunkt_nn_1 = mkN "flampunkt" "flampunkter" ;
  flamsig_av_1 = mkA "flamsig" ;
  flamsk_av_1 = mkA "flamsk" ;
  flamskvaevnad_nn_1 = mkN "flamskvдvnad" "flamskvдvnader" ;
  flamskyddsmedel_nn_1 = mkN "flamskyddsmedel" neutrum ;
  flamugn_nn_1 = mkN "flamugn" ;
  flandrisk_av_1 = mkA "flandrisk" ;
  flanell_nn_1 = mkN "flanell" "flaneller" ;
  flanellograf_nn_1 = mkN "flanellograf" "flanellografer" ;
  flank_nn_1 = mkN "flank" "flanker" ;
  flanoer_nn_1 = mkN "flanцr" "flanцrer" ;
  flark_nn_1 = mkN "flark" ;
  flarn_nn_1 = mkN "flarn" neutrum ;
  flaskbarn_nn_1 = mkN "flaskbarn" neutrum ;
  flaskborste_nn_1 = mkN "flaskborste" utrum ;
  flaskhaal_nn_1 = mkN "flaskhеl" neutrum ;
  flaskhals_nn_1 = mkN "flaskhals" ;
  flaskoeppning_nn_1 = mkN "flaskцppning" ;
  flatbroed_nn_1 = mkN "flatbrцd" neutrum ;
  flatfisk_nn_1 = mkN "flatfisk" ;
  flatlus_nn_1 = mkN "flatlus" "flatlusen" "flatlцss" "flatlцssen" ;
  flatskratt_nn_1 = mkN "flatskratt" neutrum ;
  flau_av_1 = mkA "flau" ;
  flaxig_av_1 = mkA "flaxig" ;
  flegmatiker_nn_1 = mkN "flegmatiker" "flegmatikern" "flegmatiker" "flegmatikerna" ;
  flegmatisk_av_1 = mkA "flegmatisk" ;
  flektion_nn_1 = mkN "flektion" "flektioner" ;
  fleraarig_av_1 = mkA "flerеrig" ;
  flerbarnsfamilj_nn_1 = mkN "flerbarnsfamilj" "flerbarnsfamiljer" ;
  flercellig_av_1 = mkA "flercellig" ;
  flerdubbel_av_1 = mkA "flerdubbel" "flerdubbelt" "flerdubbla" "flerdubbla" "flerdubblare" "flerdubblast" "flerdubblaste" ;
  flerfaergstryck_nn_1 = mkN "flerfдrgstryck" neutrum ;
  flerfaldig_av_1 = mkA "flerfaldig" ;
  flerfamiljshus_nn_1 = mkN "flerfamiljshus" neutrum ;
  flermansvalkrets_nn_1 = mkN "flermansvalkrets" ;
  flerpartisystem_nn_1 = mkN "flerpartisystem" neutrum ;
  flerspraakig_av_1 = mkA "flersprеkig" ;
  flerstaedes_ab_1 = mkAdv "flerstдdes" ;
  flerstaemmig_av_1 = mkA "flerstдmmig" ;
  flerstammig_av_1 = mkA "flerstammig" ;
  flertydig_av_1 = mkA "flertydig" ;
  flervaaningshus_nn_1 = mkN "flervеningshus" neutrum ;
  flervalstest_nn_1 = mkN "flervalstest" neutrum ;
  flervalsuppgift_nn_1 = mkN "flervalsuppgift" "flervalsuppgifter" ;
  fles_nn_1 = mkN "fles" ;
  flexibel_av_1 = mkA "flexibel" "flexibelt" "flexibla" "flexibla" "flexiblare" "flexiblast" "flexiblaste" ;
  flexibilitet_nn_1 = mkN "flexibilitet" "flexibiliteter" ;
  flexion_nn_1 = mkN "flexion" "flexioner" ;
  flextid_nn_1 = mkN "flextid" "flextider" ;
  flexur_nn_1 = mkN "flexur" "flexurer" ;
  flickjaegare_nn_1 = mkN "flickjдgare" "flickjдgare" ;
  flicknamn_nn_1 = mkN "flicknamn" neutrum ;
  flickpension_nn_1 = mkN "flickpension" "flickpensioner" ;
  flickvaen_nn_1 = mkN "flickvдn" "flickvдnnen" "flickvдnner" "flickvдnnerna" ;
  flik_nn_1 = mkN "flik" ;
  flikig_av_1 = mkA "flikig" ;
  flimmercell_nn_1 = mkN "flimmercell" "flimmerceller" ;
  flimmerhaar_nn_1 = mkN "flimmerhеr" neutrum ;
  flimrig_av_1 = mkA "flimrig" ;
  flin_nn_1 = mkN "flin" neutrum ;
  flink_av_1 = mkA "flink" ;
  flintlaas_nn_1 = mkN "flintlеs" neutrum ;
  flintlaasgevaer_nn_1 = mkN "flintlеsgevдr" neutrum ;
  flintskalle_nn_1 = mkN "flintskalle" utrum ;
  flintskallig_av_1 = mkA "flintskallig" ;
  flipperspel_nn_1 = mkN "flipperspel" "flipperspelet" "flipperspel" "flipperspelen" ;
  flisig_av_1 = mkA "flisig" ;
  flitig_av_1 = mkA "flitig" ;
  flo_nn_1 = mkN "flo" ;
  flock_nn_1 = mkN "flock" ;
  flockblommig_av_1 = mkA "flockblommig" ;
  flockig_av_1 = mkA "flockig" ;
  flockinstinkt_nn_1 = mkN "flockinstinkt" "flockinstinkter" ;
  flockkamrat_nn_1 = mkN "flockkamrat" "flockkamrater" ;
  flod_nn_1 = mkN "flod" "floder" ;
  flodarm_nn_1 = mkN "flodarm" ;
  flodbaedd_nn_1 = mkN "flodbдdd" ;
  flodbraedd_nn_1 = mkN "flodbrдdd" ;
  floddal_nn_1 = mkN "floddal" ;
  flodhaest_nn_1 = mkN "flodhдst" ;
  flodiller_nn_1 = mkN "flodiller" ;
  flodomraade_nn_1 = mkN "flodomrеde" ;
  flodprofil_nn_1 = mkN "flodprofil" "flodprofiler" ;
  flodslaett_nn_1 = mkN "flodslдtt" "flodslдtter" ;
  flodstrand_nn_1 = mkN "flodstrand" "flodstrдnder" ;
  flodsystem_nn_1 = mkN "flodsystem" neutrum ;
  flodterrass_nn_1 = mkN "flodterrass" "flodterrasser" ;
  floede_nn_1 = mkN "flцde" ;
  floedesdiagram_nn_1 = mkN "flцdesdiagram" "flцdesdiagrammet" "flцdesdiagram" "flцdesdiagrammen" ;
  floedesschema_nn_1 = mkN "flцdesschema" "flцdesschemat" "flцdesscheman" "flцdesschemana" ;
  floej_nn_1 = mkN "flцj" ;
  floejel_nn_1 = mkN "flцjel" ;
  floejt_nn_1 = mkN "flцjt" "flцjter" ;
  floejtist_nn_1 = mkN "flцjtist" "flцjtister" ;
  floejttravaer_nn_1 = mkN "flцjttravдr" "flцjttravдrer" ;
  floert_nn_1 = mkN "flцrt" "flцrter" ;
  floertig_av_1 = mkA "flцrtig" ;
  floets_nn_1 = mkN "flцts" "flцtser" ;
  flogroenn_nn_1 = mkN "flogrцnn" ;
  flop_nn_1 = mkN "flop" "floppen" "floppar" "flopparna" ;
  flor_nn_1 = mkN "flor" neutrum ;
  florentinsk_av_1 = mkA "florentinsk" ;
  florett_nn_1 = mkN "florett" "floretter" ;
  florilegium_nn_1 = mkN "florilegium" "florilegiet" "florilegier" "florilegierna" ;
  florin_nn_1 = mkN "florin" "floriner" ;
  florist_nn_1 = mkN "florist" "florister" ;
  floristisk_av_1 = mkA "floristisk" ;
  floskel_nn_1 = mkN "floskel" "floskeln" "floskler" "flosklerna" ;
  floskuloes_av_1 = mkA "floskulцs" ;
  flott_av_1 = mkA "flott" ;
  flottare_nn_1 = mkN "flottare" "flottare" ;
  flottbas_nn_1 = mkN "flottbas" "flottbaser" ;
  flottbesoek_nn_1 = mkN "flottbesцk" neutrum ;
  flottbro_nn_1 = mkN "flottbro" ;
  flotte_nn_1 = mkN "flotte" utrum ;
  flottflaeck_nn_1 = mkN "flottflдck" ;
  flottig_av_1 = mkA "flottig" ;
  flottilj_nn_1 = mkN "flottilj" "flottiljer" ;
  flottist_nn_1 = mkN "flottist" "flottister" ;
  flottled_nn_1 = mkN "flottled" "flottleder" ;
  flottning_nn_1 = mkN "flottning" ;
  flottningstimmer_nn_1 = mkN "flottningstimmer" neutrum ;
  flottoer_nn_1 = mkN "flottцr" "flottцrer" ;
  flottyr_nn_1 = mkN "flottyr" "flottyrer" ;
  flox_nn_1 = mkN "flox" ;
  fluffig_av_1 = mkA "fluffig" ;
  flugblomster_nn_1 = mkN "flugblomster" neutrum ;
  flugsnappare_nn_1 = mkN "flugsnappare" "flugsnappare" ;
  flugsvamp_nn_1 = mkN "flugsvamp" ;
  fluidum_nn_1 = mkN "fluidum" "fluidet" "fluider" "fluiderna" ;
  flukt_nn_1 = mkN "flukt" ;
  fluktuation_nn_1 = mkN "fluktuation" "fluktuationer" ;
  flummig_av_1 = mkA "flummig" ;
  fluorbehandling_nn_1 = mkN "fluorbehandling" ;
  fluorhalt_nn_1 = mkN "fluorhalt" "fluorhalter" ;
  fluorhaltig_av_1 = mkA "fluorhaltig" ;
  fluorid_nn_1 = mkN "fluorid" "fluorider" ;
  fluss_nn_1 = mkN "fluss" "flusser" ;
  flussmedel_nn_1 = mkN "flussmedel" neutrum ;
  fluster_nn_1 = mkN "fluster" neutrum ;
  fluvial_av_1 = mkA "fluvial" ;
  fly_nn_1 = mkN "fly" "flyt" "flyn" "flyen" ;
  flyg_nn_1 = mkN "flyg" neutrum ;
  flyga_vb_1 = mkV "flyga" "flцg" "flugit" ;
  flyganfall_nn_1 = mkN "flyganfall" neutrum ;
  flygare_nn_1 = mkN "flygare" "flygare" ;
  flygattack_nn_1 = mkN "flygattack" "flygattacker" ;
  flygbaat_nn_1 = mkN "flygbеt" ;
  flygbas_nn_1 = mkN "flygbas" "flygbaser" ;
  flygbild_nn_1 = mkN "flygbild" "flygbilder" ;
  flygbiljett_nn_1 = mkN "flygbiljett" "flygbiljetter" ;
  flygblad_nn_1 = mkN "flygblad" neutrum ;
  flygbolag_nn_1 = mkN "flygbolag" neutrum ;
  flygbomb_nn_1 = mkN "flygbomb" "flygbomber" ;
  flygcertifikat_nn_1 = mkN "flygcertifikat" neutrum ;
  flygekorre_nn_1 = mkN "flygekorre" utrum ;
  flygel_nn_1 = mkN "flygel" ;
  flygfae_nn_1 = mkN "flygfд" "flygfдet" "flygfдn" "flygfдna" ;
  flygfaelt_nn_1 = mkN "flygfдlt" neutrum ;
  flygfaerdig_av_1 = mkA "flygfдrdig" ;
  flygfisk_nn_1 = mkN "flygfisk" ;
  flygfoerband_nn_1 = mkN "flygfцrband" neutrum ;
  flygfoto_nn_1 = mkN "flygfoto" "flygfotot" "flygfoton" "flygfotona" ;
  flygfotografi_nn_1 = mkN "flygfotografi" "flygfotografit" "flygfotografier" "flygfotografierna" ;
  flygg_av_1 = mkA "flygg" ;
  flyghastighet_nn_1 = mkN "flyghastighet" "flyghastigheter" ;
  flyghund_nn_1 = mkN "flyghund" ;
  flygindustri_nn_1 = mkN "flygindustri" "flygindustrier" ;
  flygkaar_nn_1 = mkN "flygkеr" "flygkеrer" ;
  flygkapning_nn_1 = mkN "flygkapning" ;
  flygkapten_nn_1 = mkN "flygkapten" "flygkaptener" ;
  flygkonst_nn_1 = mkN "flygkonst" "flygkonster" ;
  flygkropp_nn_1 = mkN "flygkropp" ;
  flyglarm_nn_1 = mkN "flyglarm" neutrum ;
  flygledare_nn_1 = mkN "flygledare" "flygledare" ;
  flygledes_ab_1 = mkAdv "flygledes" ;
  flygledning_nn_1 = mkN "flygledning" ;
  flyglinje_nn_1 = mkN "flyglinje" "flyglinjer" ;
  flygmaskin_nn_1 = mkN "flygmaskin" "flygmaskiner" ;
  flygning_nn_1 = mkN "flygning" ;
  flygplan_nn_1 = mkN "flygplan" neutrum ;
  flygplanskabin_nn_1 = mkN "flygplanskabin" "flygplanskabiner" ;
  flygplansroder_nn_1 = mkN "flygplansroder" neutrum ;
  flygplansvinge_nn_1 = mkN "flygplansvinge" utrum ;
  flygplats_nn_1 = mkN "flygplats" "flygplatser" ;
  flygroenn_nn_1 = mkN "flygrцnn" ;
  flygtransport_nn_1 = mkN "flygtransport" "flygtransporter" ;
  flygtur_nn_1 = mkN "flygtur" "flygturer" ;
  flygutbildning_nn_1 = mkN "flygutbildning" ;
  flygvaerdinna_nn_1 = mkN "flygvдrdinna" ;
  flygvapen_nn_1 = mkN "flygvapen" "flygvapnet" "flygvapen" "flygvapnen" ;
  flyhaent_av_1 = mkA "flyhдnt" "flyhдnt" ;
  flykt_nn_1 = mkN "flykt" "flykter" ;
  flyktfoersoek_nn_1 = mkN "flyktfцrsцk" neutrum ;
  flyktig_av_1 = mkA "flyktig" ;
  flykting_nn_1 = mkN "flykting" ;
  flyta_vb_1 = mkV "flyta" "flцt" "flutit" ;
  flythjaelp_nn_1 = mkN "flythjдlp" ;
  flytning_nn_1 = mkN "flytning" ;
  flyttbar_av_1 = mkA "flyttbar" ;
  flyttblock_nn_1 = mkN "flyttblock" neutrum ;
  flyttfaagel_nn_1 = mkN "flyttfеgel" ;
  flyttgroet_nn_1 = mkN "flyttgrцt" ;
  flyttkarl_nn_1 = mkN "flyttkarl" ;
  flyttlass_nn_1 = mkN "flyttlass" neutrum ;
  flyttning_nn_1 = mkN "flyttning" ;
  flytvaest_nn_1 = mkN "flytvдst" ;
  fnasig_av_1 = mkA "fnasig" ;
  fnask_nn_1 = mkN "fnask" neutrum ;
  fnasker_nn_1 = mkN "fnasker" ;
  fniss_nn_1 = mkN "fniss" neutrum ;
  fnissig_av_1 = mkA "fnissig" ;
  fnissning_nn_1 = mkN "fnissning" ;
  fnittrig_av_1 = mkA "fnittrig" ;
  fnoesksvamp_nn_1 = mkN "fnцsksvamp" ;
  fnoskig_av_1 = mkA "fnoskig" ;
  foaje_nn_1 = mkN "foajй" "foajйer" ;
  fob_ab_1 = mkAdv "fob" ;
  fobi_nn_1 = mkN "fobi" "fobier" ;
  fobitraening_nn_1 = mkN "fobitrдning" ;
  fock_nn_1 = mkN "fock" ;
  fockmast_nn_1 = mkN "fockmast" "fockmaster" ;
  focus_nn_1 = mkN "focus" ;
  foder_nn_1 = mkN "foder" neutrum ;
  foderblad_nn_1 = mkN "foderblad" neutrum ;
  fodermaengd_nn_1 = mkN "fodermдngd" "fodermдngder" ;
  fodermark_nn_1 = mkN "fodermark" "fodermarker" ;
  foderpaase_nn_1 = mkN "foderpеse" utrum ;
  fodervaerde_nn_1 = mkN "fodervдrde" ;
  fodervaext_nn_1 = mkN "fodervдxt" "fodervдxter" ;
  fodral_nn_1 = mkN "fodral" neutrum ;
  foedd_av_1 = mkA "fцdd" ;
  foedelse_nn_1 = mkN "fцdelse" "fцdelser" ;
  foedelsedag_nn_1 = mkN "fцdelsedag" ;
  foedelsedagsbarn_nn_1 = mkN "fцdelsedagsbarn" neutrum ;
  foedelsehem_nn_1 = mkN "fцdelsehem" "fцdelsehemmet" "fцdelsehem" "fцdelsehemmen" ;
  foedelsekontroll_nn_1 = mkN "fцdelsekontroll" "fцdelsekontroller" ;
  foedelsemaerke_nn_1 = mkN "fцdelsemдrke" ;
  foedelsenummer_nn_1 = mkN "fцdelsenummer" neutrum ;
  foedelsestad_nn_1 = mkN "fцdelsestad" "fцdelsestдder" ;
  foedelsetal_nn_1 = mkN "fцdelsetal" "fцdelsetalet" "fцdelsetalen" "fцdelsetalena" ;
  foedgeni_nn_1 = mkN "fцdgeni" "fцdgeniet" "fцdgenier" "fцdgenierna" ;
  foedkrok_nn_1 = mkN "fцdkrok" ;
  foedoaemne_nn_1 = mkN "fцdoдmne" ;
  foedoorganism_nn_1 = mkN "fцdoorganism" "fцdoorganismer" ;
  foedopartikel_nn_1 = mkN "fцdopartikel" ;
  foedoraad_nn_1 = mkN "fцdorеd" neutrum ;
  foedsel_nn_1 = mkN "fцdsel" ;
  foedsloraett_nn_1 = mkN "fцdslorдtt" "fцdslorдtter" ;
  foega_ab_1 = mkAdv "fцga" ;
  foegderi_nn_1 = mkN "fцgderi" "fцgderit" "fцgderier" "fцgderierna" ;
  foegderifoervaltning_nn_1 = mkN "fцgderifцrvaltning" ;
  foel_nn_1 = mkN "fцl" neutrum ;
  foeljaktligen_ab_1 = mkAdv "fцljaktligen" ;
  foeljande_av_1 = mkA "fцljande" ;
  foeljd_nn_1 = mkN "fцljd" "fцljder" ;
  foeljdenlig_av_1 = mkA "fцljdenlig" ;
  foeljdriktig_av_1 = mkA "fцljdriktig" ;
  foeljdsats_nn_1 = mkN "fцljdsats" "fцljdsatser" ;
  foeljdverkning_nn_1 = mkN "fцljdverkning" ;
  foeljebil_nn_1 = mkN "fцljebil" ;
  foeljebrev_nn_1 = mkN "fцljebrev" neutrum ;
  foeljesedel_nn_1 = mkN "fцljesedel" ;
  foeljeslagare_nn_1 = mkN "fцljeslagare" "fцljeslagare" ;
  foeljeslagarinna_nn_1 = mkN "fцljeslagarinna" ;
  foeljetong_nn_1 = mkN "fцljetong" "fцljetonger" ;
  foeljsam_av_1 = mkA "fцljsam" "fцljsamt" "fцljsamma" "fцljsamma" "fцljsammare" "fцljsammast" "fцljsammaste" ;
  foelsto_nn_1 = mkN "fцlsto" "fцlstoet" "fцlston" "fцlstona" ;
  foen_nn_2 = mkN "fцn" ;
  foenster_nn_1 = mkN "fцnster" neutrum ;
  foensterbaage_nn_1 = mkN "fцnsterbеge" utrum ;
  foensterbaenk_nn_1 = mkN "fцnsterbдnk" ;
  foensterbleck_nn_1 = mkN "fцnsterbleck" neutrum ;
  foensterbord_nn_1 = mkN "fцnsterbord" neutrum ;
  foensterbraede_nn_1 = mkN "fцnsterbrдde" ;
  foensterglas_nn_1 = mkN "fцnsterglas" neutrum ;
  foensterkarm_nn_1 = mkN "fцnsterkarm" ;
  foensterkuvert_nn_1 = mkN "fцnsterkuvert" neutrum ;
  foensterluft_nn_1 = mkN "fцnsterluft" "fцnsterlufter" ;
  foensternisch_nn_1 = mkN "fцnsternisch" "fцnsternischer" ;
  foensterplats_nn_1 = mkN "fцnsterplats" "fцnsterplatser" ;
  foensterputsare_nn_1 = mkN "fцnsterputsare" "fцnsterputsare" ;
  foenstersmyg_nn_1 = mkN "fцnstersmyg" ;
  foenstertittare_nn_1 = mkN "fцnstertittare" "fцnstertittare" ;
  foer_ab_1 = mkAdv "fцr" ;
  foer_nn_1 = mkN "fцr" ;
  foeraedling_nn_1 = mkN "fцrдdling" ;
  foeraektenskaplig_av_1 = mkA "fцrдktenskaplig" ;
  foeraelder_nn_1 = mkN "fцrдlder" ;
  foeraeldrabalk_nn_1 = mkN "fцrдldrabalk" ;
  foeraeldrabesoek_nn_1 = mkN "fцrдldrabesцk" neutrum ;
  foeraeldradag_nn_1 = mkN "fцrдldradag" ;
  foeraeldrafoermaan_nn_1 = mkN "fцrдldrafцrmеn" "fцrдldrafцrmеner" ;
  foeraeldrafoersaekring_nn_1 = mkN "fцrдldrafцrsдkring" ;
  foeraeldrafri_av_1 = mkA "fцrдldrafri" "fцrдldrafritt" ;
  foeraeldrahem_nn_1 = mkN "fцrдldrahem" "fцrдldrahemmet" "fцrдldrahem" "fцrдldrahemmen" ;
  foeraeldraledig_av_1 = mkA "fцrдldraledig" ;
  foeraeldraledighet_nn_1 = mkN "fцrдldraledighet" "fцrдldraledigheter" ;
  foeraeldraloes_av_1 = mkA "fцrдldralцs" ;
  foeraeldratraed_nn_1 = mkN "fцrдldratrдd" neutrum ;
  foeraelskelse_nn_1 = mkN "fцrдlskelse" "fцrдlskelser" ;
  foeraenderlig_av_1 = mkA "fцrдnderlig" ;
  foeraendring_nn_1 = mkN "fцrдndring" ;
  foeraendringstakt_nn_1 = mkN "fцrдndringstakt" "fцrдndringstakter" ;
  foeraeta_vb_1 = mkV "fцrдta" "fцrеt" "fцrдtit" ;
  foeraktfull_av_1 = mkA "fцraktfull" ;
  foeraktlig_av_1 = mkA "fцraktlig" ;
  foeraning_nn_1 = mkN "fцraning" ;
  foerankring_nn_1 = mkN "fцrankring" ;
  foeranmaelning_nn_1 = mkN "fцranmдlning" ;
  foeranstaltning_nn_1 = mkN "fцranstaltning" ;
  foerare_nn_1 = mkN "fцrare" "fцrare" ;
  foerargelsevaeckande_av_1 = mkA "fцrargelsevдckande" ;
  foerarglig_av_1 = mkA "fцrarglig" ;
  foerarhytt_nn_1 = mkN "fцrarhytt" "fцrarhytter" ;
  foerarkabin_nn_1 = mkN "fцrarkabin" "fцrarkabiner" ;
  foerbaalt_ab_1 = mkAdv "fцrbеlt" ;
  foerbaetterlig_av_1 = mkA "fцrbдtterlig" ;
  foerbaettring_nn_1 = mkN "fцrbдttring" ;
  foerbaettringslaan_nn_1 = mkN "fцrbдttringslеn" neutrum ;
  foerband_nn_1 = mkN "fцrband" neutrum ;
  foerbandsplats_nn_1 = mkN "fцrbandsplats" "fцrbandsplatser" ;
  foerbannelse_nn_1 = mkN "fцrbannelse" "fцrbannelser" ;
  foerbehaall_nn_1 = mkN "fцrbehеll" neutrum ;
  foerbehaalla_vb_1 = mkV "fцrbehеlla" "fцrbehцll" "fцrbehеllit" ;
  foerbehaallsam_av_1 = mkA "fцrbehеllsam" "fцrbehеllsamt" "fцrbehеllsamma" "fцrbehеllsamma" "fцrbehеllsammare" "fцrbehеllsammast" "fцrbehеllsammaste" ;
  foerbehaallsamhet_nn_1 = mkN "fцrbehеllsamhet" "fцrbehеllsamheter" ;
  foerbehaallsloes_av_1 = mkA "fцrbehеllslцs" ;
  foerbemaelde_av_1 = mkA "fцrbemдlde" ;
  foerberedande_av_1 = mkA "fцrberedande" ;
  foerberedd_av_1 = mkA "fцrberedd" ;
  foerberedelse_nn_1 = mkN "fцrberedelse" "fцrberedelser" ;
  foerberg_nn_1 = mkN "fцrberg" neutrum ;
  foerbi_ab_1 = mkAdv "fцrbi" ;
  foerbi_av_1 = mkA "fцrbi" ;
  foerbifartsled_nn_1 = mkN "fцrbifartsled" "fцrbifartsleder" ;
  foerbigaa_vb_1 = mkV "fцrbigе" "fцrbigеr" "fцrbigе" "fцrbigick" "fцrbigеtt" "fцrbigеngen" ;
  foerbigaangen_av_1 = mkA "fцrbigеngen" "fцrbigеnget" ;
  foerbinda_vb_1 = mkV "fцrbinda" "fцrband" "fцrbundit" ;
  foerbindelse_nn_1 = mkN "fцrbindelse" "fцrbindelser" ;
  foerbindelsegaang_nn_1 = mkN "fцrbindelsegеng" ;
  foerbindelseled_nn_1 = mkN "fцrbindelseled" "fцrbindelseleder" ;
  foerbindlig_av_1 = mkA "fцrbindlig" ;
  foerbindning_nn_1 = mkN "fцrbindning" ;
  foerbiseende_nn_1 = mkN "fцrbiseende" ;
  foerbjuda_vb_1 = mkV "fцrbjuda" "fцrbjцd" "fцrbjudit" ;
  foerbjuden_av_1 = mkA "fцrbjuden" "fцrbjudet" ;
  foerblivande_av_1 = mkA "fцrblivande" ;
  foerbluffande_av_1 = mkA "fцrbluffande" ;
  foerboen_nn_1 = mkN "fцrbцn" "fцrbцner" ;
  foerbraenningsmotor_nn_1 = mkN "fцrbrдnningsmotor" "fцrbrдnningsmotorer" ;
  foerbraenningsprodukt_nn_1 = mkN "fцrbrдnningsprodukt" "fцrbrдnningsprodukter" ;
  foerbrinna_vb_1 = mkV "fцrbrinna" "fцrbrann" "fцrbrunnit" ;
  foerbroedring_nn_1 = mkN "fцrbrцdring" ;
  foerbrukare_nn_1 = mkN "fцrbrukare" "fцrbrukare" ;
  foerbrukningsartikel_nn_1 = mkN "fцrbrukningsartikel" ;
  foerbrukningsmaterial_nn_1 = mkN "fцrbrukningsmaterial" neutrum ;
  foerbryta_vb_1 = mkV "fцrbryta" "fцrbryter" "fцrbryt" "fцrbrцt" "fцrbrutit" "fцrbrytt" ;
  foerbrytare_nn_1 = mkN "fцrbrytare" "fцrbrytare" ;
  foerbrytelse_nn_1 = mkN "fцrbrytelse" "fцrbrytelser" ;
  foerbud_nn_1 = mkN "fцrbud" neutrum ;
  foerbund_nn_1 = mkN "fцrbund" neutrum ;
  foerbunden_av_1 = mkA "fцrbunden" "fцrbundet" ;
  foerbundsbrev_nn_1 = mkN "fцrbundsbrev" neutrum ;
  foerbundsdag_nn_1 = mkN "fцrbundsdag" ;
  foerbundskansler_nn_1 = mkN "fцrbundskansler" "fцrbundskanslern" "fцrbundskanslerer" "fцrbundskanslererna" ;
  foerbundskapten_nn_1 = mkN "fцrbundskapten" "fцrbundskaptener" ;
  foerbundspresident_nn_1 = mkN "fцrbundspresident" "fцrbundspresidenter" ;
  foerbundsregering_nn_1 = mkN "fцrbundsregering" ;
  foerbundsrepublik_nn_1 = mkN "fцrbundsrepublik" "fцrbundsrepubliker" ;
  foerbundsstat_nn_1 = mkN "fцrbundsstat" "fцrbundsstater" ;
  foerbyggnad_nn_1 = mkN "fцrbyggnad" "fцrbyggnader" ;
  foerdaeck_nn_1 = mkN "fцrdдck" neutrum ;
  foerdaemning_nn_1 = mkN "fцrdдmning" ;
  foerdaervlig_av_1 = mkA "fцrdдrvlig" ;
  foerdel_nn_1 = mkN "fцrdel" "fцrdelen" "fцrdelar" "fцrdelarna" ;
  foerdelaktig_av_1 = mkA "fцrdelaktig" ;
  foerdelare_nn_1 = mkN "fцrdelare" "fцrdelare" ;
  foerdelning_nn_1 = mkN "fцrdelning" ;
  foerdelningspolitisk_av_1 = mkA "fцrdelningspolitisk" ;
  foerdenskull_ab_1 = mkAdv "fцrdenskull" ;
  foerdetta_av_1 = mkA "fцrdetta" ;
  foerdetting_nn_1 = mkN "fцrdetting" ;
  foerdevind_ab_1 = mkAdv "fцrdevind" ;
  foerdjupning_nn_1 = mkN "fцrdjupning" ;
  foerdjupningskurs_nn_1 = mkN "fцrdjupningskurs" "fцrdjupningskurser" ;
  foerdoemd_av_1 = mkA "fцrdцmd" "fцrdцmt" ;
  foerdoemlig_av_1 = mkA "fцrdцmlig" ;
  foerdold_av_1 = mkA "fцrdold" "fцrdolt" ;
  foerdom_nn_1 = mkN "fцrdom" ;
  foerdomsalstrande_av_1 = mkA "fцrdomsalstrande" ;
  foerdomsfri_av_1 = mkA "fцrdomsfri" "fцrdomsfritt" ;
  foerdomsfull_av_1 = mkA "fцrdomsfull" ;
  foerdra_vb_1 = mkV "fцrdra" "fцrdrar" "fцrdra" "fцrdrog" "fцrdragit" "fцrdragen" ;
  foerdrag_nn_1 = mkN "fцrdrag" neutrum ;
  foerdragen_av_1 = mkA "fцrdragen" "fцrdraget" ;
  foerdragsam_av_1 = mkA "fцrdragsam" "fцrdragsamt" "fцrdragsamma" "fцrdragsamma" "fцrdragsammare" "fцrdragsammast" "fцrdragsammaste" ;
  foerdragsamhet_nn_1 = mkN "fцrdragsamhet" "fцrdragsamheter" ;
  foerdriva_vb_1 = mkV "fцrdriva" "fцrdrev" "fцrdrivit" ;
  foerdrivande_nn_1 = mkN "fцrdrivande" ;
  foerdrivning_nn_1 = mkN "fцrdrivning" ;
  foerdroejning_nn_1 = mkN "fцrdrцjning" ;
  foerdroemd_av_1 = mkA "fцrdrцmd" "fцrdrцmt" ;
  foerdubbling_nn_1 = mkN "fцrdubbling" ;
  foere_ab_1 = mkAdv "fцre" ;
  foerebaera_vb_1 = mkV "fцrebдra" "fцrebar" "fцreburit" ;
  foerebaerande_nn_1 = mkN "fцrebдrande" ;
  foerebild_nn_1 = mkN "fцrebild" "fцrebilder" ;
  foerebildlig_av_1 = mkA "fцrebildlig" ;
  foerebraaelse_nn_1 = mkN "fцrebrеelse" "fцrebrеelser" ;
  foerebud_nn_1 = mkN "fцrebud" neutrum ;
  foeredoemlig_av_1 = mkA "fцredцmlig" ;
  foeredra_vb_1 = mkV "fцredra" "fцredrar" "fцredra" "fцredrog" "fцredragit" "fцredragen" ;
  foeredrag_nn_1 = mkN "fцredrag" neutrum ;
  foeredragande_nn_1 = mkN "fцredragande" "fцredraganden" "fцredragande" "fцredragandena" ;
  foeredragning_nn_1 = mkN "fцredragning" ;
  foerefintlig_av_1 = mkA "fцrefintlig" ;
  foeregaa_vb_1 = mkV "fцregе" "fцregеr" "fцregе" "fцregick" "fцregеtt" "fцregеngen" ;
  foeregaaende_av_1 = mkA "fцregеende" ;
  foeregaangare_nn_1 = mkN "fцregеngare" "fцregеngare" ;
  foeregaangsman_nn_1 = mkN "fцregеngsman" "fцregеngsmannen" "fцregеngsmдn" "fцregеngsmдnnen" ;
  foerege_vb_1 = mkV "fцrege" "fцreger" "fцrege" "fцregav" "fцregett" "fцregiven" ;
  foeregivande_nn_1 = mkN "fцregivande" ;
  foeregripa_vb_1 = mkV "fцregripa" "fцregrep" "fцregripit" ;
  foerehaalla_vb_1 = mkV "fцrehеlla" "fцrehцll" "fцrehеllit" ;
  foerehavande_nn_1 = mkN "fцrehavande" ;
  foerekomma_vb_1 = mkV "fцrekomma" "fцrekom" "fцrekommit" ;
  foerekommande_av_1 = mkA "fцrekommande" ;
  foerekomst_nn_1 = mkN "fцrekomst" "fцrekomster" ;
  foerelaeggande_nn_1 = mkN "fцrelдggande" ;
  foerelaesare_nn_1 = mkN "fцrelдsare" "fцrelдsare" ;
  foerelaesning_nn_1 = mkN "fцrelдsning" ;
  foerelaesningssal_nn_1 = mkN "fцrelдsningssal" ;
  foereloepare_nn_1 = mkN "fцrelцpare" "fцrelцpare" ;
  foeremaal_nn_1 = mkN "fцremеl" neutrum ;
  foerening_nn_1 = mkN "fцrening" ;
  foereningsbank_nn_1 = mkN "fцreningsbank" "fцreningsbanker" ;
  foereningsfrihet_nn_1 = mkN "fцreningsfrihet" "fцreningsfriheter" ;
  foereningsmaengd_nn_1 = mkN "fцreningsmдngd" "fцreningsmдngder" ;
  foereningsroerelse_nn_1 = mkN "fцreningsrцrelse" "fцreningsrцrelser" ;
  foerenkling_nn_1 = mkN "fцrenkling" ;
  foerenlig_av_1 = mkA "fцrenlig" ;
  foerenlighet_nn_1 = mkN "fцrenlighet" "fцrenligheter" ;
  foeresats_nn_1 = mkN "fцresats" "fцresatser" ;
  foereskrift_nn_1 = mkN "fцreskrift" "fцreskrifter" ;
  foereskriva_vb_1 = mkV "fцreskriva" "fцreskrev" "fцreskrivit" ;
  foerespegling_nn_1 = mkN "fцrespegling" ;
  foerespraakare_nn_1 = mkN "fцresprеkare" "fцresprеkare" ;
  foerestaaende_av_1 = mkA "fцrestеende" ;
  foerestaandare_nn_1 = mkN "fцrestеndare" "fцrestеndare" ;
  foerestaandarinna_nn_1 = mkN "fцrestеndarinna" ;
  foerestaellande_av_1 = mkA "fцrestдllande" ;
  foerestaellare_nn_1 = mkN "fцrestдllare" "fцrestдllare" ;
  foerestaellning_nn_1 = mkN "fцrestдllning" ;
  foerestaellningsvaerld_nn_1 = mkN "fцrestдllningsvдrld" ;
  foereta_vb_1 = mkV "fцreta" "fцretar" "fцreta" "fцretog" "fцretagit" "fцretagen" ;
  foeretag_nn_1 = mkN "fцretag" neutrum ;
  foeretagare_nn_1 = mkN "fцretagare" "fцretagare" ;
  foeretagsam_av_1 = mkA "fцretagsam" "fцretagsamt" "fцretagsamma" "fцretagsamma" "fцretagsammare" "fцretagsammast" "fцretagsammaste" ;
  foeretagsamhet_nn_1 = mkN "fцretagsamhet" "fцretagsamheter" ;
  foeretagsekonom_nn_1 = mkN "fцretagsekonom" "fцretagsekonomer" ;
  foeretagsekonomisk_av_1 = mkA "fцretagsekonomisk" ;
  foeretagsfilial_nn_1 = mkN "fцretagsfilial" "fцretagsfilialer" ;
  foeretagsledning_nn_1 = mkN "fцretagsledning" ;
  foeretagsnaemnd_nn_1 = mkN "fцretagsnдmnd" "fцretagsnдmnder" ;
  foeretagsvinst_nn_1 = mkN "fцretagsvinst" "fцretagsvinster" ;
  foeretal_nn_1 = mkN "fцretal" "fцretalet" "fцretalen" "fцretalena" ;
  foereteelse_nn_1 = mkN "fцreteelse" "fцreteelser" ;
  foeretraedare_nn_1 = mkN "fцretrдdare" "fцretrдdare" ;
  foeretraede_nn_1 = mkN "fцretrдde" ;
  foeretraedesvis_ab_1 = mkAdv "fцretrдdesvis" ;
  foerevaendning_nn_1 = mkN "fцrevдndning" ;
  foerevarande_av_1 = mkA "fцrevarande" ;
  foerfader_nn_1 = mkN "fцrfader" "fцrfadern" "fцrfдder" "fцrfдderna" ;
  foerfaerlig_av_1 = mkA "fцrfдrlig" ;
  foerfalla_vb_1 = mkV "fцrfalla" "fцrfцll" "fцrfallit" ;
  foerfallen_av_1 = mkA "fцrfallen" "fцrfallet" ;
  foerfallodag_nn_1 = mkN "fцrfallodag" ;
  foerfalskare_nn_1 = mkN "fцrfalskare" "fцrfalskare" ;
  foerfalskning_nn_1 = mkN "fцrfalskning" ;
  foerfarande_nn_1 = mkN "fцrfarande" ;
  foerfaren_av_1 = mkA "fцrfaren" "fцrfaret" ;
  foerfaringssaett_nn_1 = mkN "fцrfaringssдtt" neutrum ;
  foerfattare_nn_1 = mkN "fцrfattare" "fцrfattare" ;
  foerfattarinna_nn_1 = mkN "fцrfattarinna" ;
  foerfattarjag_nn_1 = mkN "fцrfattarjag" neutrum ;
  foerfattning_nn_1 = mkN "fцrfattning" ;
  foerfining_nn_1 = mkN "fцrfining" ;
  foerflugen_av_1 = mkA "fцrflugen" "fцrfluget" ;
  foerfluten_av_1 = mkA "fцrfluten" "fцrflutet" ;
  foerflyta_vb_1 = mkV "fцrflyta" "fцrflцt" "fцrflutit" ;
  foerflyttning_nn_1 = mkN "fцrflyttning" ;
  foerfoeljelse_nn_1 = mkN "fцrfцljelse" "fцrfцljelser" ;
  foerfoeljelsemani_nn_1 = mkN "fцrfцljelsemani" "fцrfцljelsemanier" ;
  foerfoerare_nn_1 = mkN "fцrfцrare" "fцrfцrare" ;
  foerfoerelse_nn_1 = mkN "fцrfцrelse" "fцrfцrelser" ;
  foerfoerisk_av_1 = mkA "fцrfцrisk" ;
  foerfogande_nn_1 = mkN "fцrfogande" ;
  foerfogandelag_nn_1 = mkN "fцrfogandelag" ;
  foerfraagning_nn_1 = mkN "fцrfrеgning" ;
  foerfriskning_nn_1 = mkN "fцrfriskning" ;
  foerfrusen_av_1 = mkA "fцrfrusen" "fцrfruset" ;
  foergaa_vb_1 = mkV "fцrgе" "fцrgеr" "fцrgе" "fцrgick" "fцrgеtt" "fцrgеngen" ;
  foergaard_nn_1 = mkN "fцrgеrd" ;
  foergaenglig_av_1 = mkA "fцrgдnglig" ;
  foergaeta_vb_1 = mkV "fцrgдta" "fцrgat" "fцrgдtit" ;
  foergaetmigej_nn_1 = mkN "fцrgдtmigej" "fцrgдtmigejer" ;
  foergaeves_ab_1 = mkAdv "fцrgдves" ;
  foergasare_nn_1 = mkN "fцrgasare" "fцrgasare" ;
  foergiftning_nn_1 = mkN "fцrgiftning" ;
  foergjord_av_1 = mkA "fцrgjord" "fцrgjort" ;
  foergraaten_av_1 = mkA "fцrgrеten" "fцrgrеtet" ;
  foergraemd_av_1 = mkA "fцrgrдmd" "fцrgrдmt" ;
  foergrening_nn_1 = mkN "fцrgrening" ;
  foergripelse_nn_1 = mkN "fцrgripelse" "fцrgripelser" ;
  foergriplig_av_1 = mkA "fцrgriplig" ;
  foergrund_nn_1 = mkN "fцrgrund" "fцrgrunder" ;
  foergrundsfigur_nn_1 = mkN "fцrgrundsfigur" "fцrgrundsfigurer" ;
  foergrundsgestalt_nn_1 = mkN "fцrgrundsgestalt" "fцrgrundsgestalter" ;
  foergudning_nn_1 = mkN "fцrgudning" ;
  foerhaall_nn_1 = mkN "fцrhеll" neutrum ;
  foerhaallande_nn_1 = mkN "fцrhеllande" ;
  foerhaallandevis_ab_1 = mkAdv "fцrhеllandevis" ;
  foerhaallning_nn_1 = mkN "fцrhеllning" ;
  foerhaallningsorder_nn_1 = mkN "fцrhеllningsorder" ;
  foerhaallningssaett_nn_1 = mkN "fцrhеllningssдtt" neutrum ;
  foerhaardnad_nn_1 = mkN "fцrhеrdnad" "fцrhеrdnader" ;
  foerhaerligande_nn_1 = mkN "fцrhдrligande" ;
  foerhaerskande_av_1 = mkA "fцrhдrskande" ;
  foerhall_nn_1 = mkN "fцrhall" ;
  foerhanden_ab_1 = mkAdv "fцrhanden" ;
  foerhandenvarande_av_1 = mkA "fцrhandenvarande" ;
  foerhandlare_nn_1 = mkN "fцrhandlare" "fцrhandlare" ;
  foerhandling_nn_1 = mkN "fцrhandling" ;
  foerhandlingsbar_av_1 = mkA "fцrhandlingsbar" ;
  foerhandlingsbord_nn_1 = mkN "fцrhandlingsbord" neutrum ;
  foerhandsbukt_nn_1 = mkN "fцrhandsbukt" "fцrhandsbukter" ;
  foerhatlig_av_1 = mkA "fцrhatlig" ;
  foerhinder_nn_1 = mkN "fцrhinder" neutrum ;
  foerhistorisk_av_1 = mkA "fцrhistorisk" ;
  foerhoejning_nn_1 = mkN "fцrhцjning" ;
  foerhoer_nn_1 = mkN "fцrhцr" neutrum ;
  foerhoersledare_nn_1 = mkN "fцrhцrsledare" "fцrhцrsledare" ;
  foerhoersvittne_nn_1 = mkN "fцrhцrsvittne" ;
  foerhoppning_nn_1 = mkN "fцrhoppning" ;
  foerhoppningsfull_av_1 = mkA "fцrhoppningsfull" ;
  foerhoppningsvis_ab_1 = mkAdv "fцrhoppningsvis" ;
  foerhuggning_nn_1 = mkN "fцrhuggning" ;
  foerintande_av_1 = mkA "fцrintande" ;
  foerkaempe_nn_1 = mkN "fцrkдmpe" utrum ;
  foerkaenning_nn_1 = mkN "fцrkдnning" ;
  foerkaensla_nn_1 = mkN "fцrkдnsla" ;
  foerkaerlek_nn_1 = mkN "fцrkдrlek" ;
  foerkalkning_nn_1 = mkN "fцrkalkning" ;
  foerkastelsedom_nn_1 = mkN "fцrkastelsedom" ;
  foerkastlig_av_1 = mkA "fцrkastlig" ;
  foerkastning_nn_1 = mkN "fцrkastning" ;
  foerklae_nn_1 = mkN "fцrklд" "fцrklдt" "fцrklдn" "fцrklдna" ;
  foerklaede_nn_1 = mkN "fцrklдde" ;
  foerklaedeskjol_nn_1 = mkN "fцrklдdeskjol" ;
  foerklaednad_nn_1 = mkN "fцrklдdnad" "fцrklдdnader" ;
  foerklaring_nn_1 = mkN "fцrklaring" ;
  foerklarlig_av_1 = mkA "fцrklarlig" ;
  foerklenande_av_1 = mkA "fцrklenande" ;
  foerklistring_nn_1 = mkN "fцrklistring" ;
  foerklyftning_nn_1 = mkN "fцrklyftning" ;
  foerknippning_nn_1 = mkN "fцrknippning" ;
  foerkoep_nn_1 = mkN "fцrkцp" neutrum ;
  foerkomma_vb_1 = mkV "fцrkomma" "fцrkom" "fцrkommit" ;
  foerkommen_av_1 = mkA "fцrkommen" "fцrkommet" "fцrkomna" "fцrkomna" "fцrkomnare" "fцrkomnast" "fцrkomnaste" ;
  foerkortning_nn_1 = mkN "fцrkortning" ;
  foerkrigstid_nn_1 = mkN "fцrkrigstid" "fцrkrigstider" ;
  foerkristen_av_1 = mkA "fцrkristen" "fцrkristet" ;
  foerkroppning_nn_1 = mkN "fцrkroppning" ;
  foerkrossande_av_1 = mkA "fцrkrossande" ;
  foerkrympt_av_1 = mkA "fцrkrympt" "fцrkrympt" ;
  foerkunnare_nn_1 = mkN "fцrkunnare" "fцrkunnare" ;
  foerkunnelse_nn_1 = mkN "fцrkunnelse" "fцrkunnelser" ;
  foerkyld_av_1 = mkA "fцrkyld" "fцrkylt" ;
  foerkylning_nn_1 = mkN "fцrkylning" ;
  foerlaat_nn_1 = mkN "fцrlеt" "fцrlеter" ;
  foerlaata_vb_1 = mkV "fцrlеta" "fцrlдt" "fцrlеtit" ;
  foerlaatlig_av_1 = mkA "fцrlеtlig" ;
  foerladdning_nn_1 = mkN "fцrladdning" ;
  foerlaegen_av_1 = mkA "fцrlдgen" "fцrlдget" ;
  foerlaegenhet_nn_1 = mkN "fцrlдgenhet" "fцrlдgenheter" ;
  foerlaeggare_nn_1 = mkN "fцrlдggare" "fцrlдggare" ;
  foerlaeggning_nn_1 = mkN "fцrlдggning" ;
  foerlaengning_nn_1 = mkN "fцrlдngning" ;
  foerlaengningssladd_nn_1 = mkN "fцrlдngningssladd" ;
  foerlaening_nn_1 = mkN "fцrlдning" ;
  foerlaest_av_1 = mkA "fцrlдst" "fцrlдst" ;
  foerlag_1_nn_1 = mkN "fцrlag" neutrum ;
  foerlag_2_nn_1 = mkN "fцrlag" neutrum ;
  foerlagsbevis_nn_1 = mkN "fцrlagsbevis" neutrum ;
  foerlagslaan_nn_1 = mkN "fцrlagslеn" neutrum ;
  foerlamning_nn_1 = mkN "fцrlamning" ;
  foerled_nn_1 = mkN "fцrled" neutrum ;
  foerlida_vb_1 = mkV "fцrlida" "fцrled" "fцrlidit" ;
  foerliden_av_1 = mkA "fцrliden" "fцrlidet" ;
  foerlig_av_1 = mkA "fцrlig" ;
  foerlikning_nn_1 = mkN "fцrlikning" ;
  foerlikningskommission_nn_1 = mkN "fцrlikningskommission" "fцrlikningskommissioner" ;
  foerlikningsman_nn_1 = mkN "fцrlikningsman" "fцrlikningsmannen" "fцrlikningsmдn" "fцrlikningsmдnnen" ;
  foerlisning_nn_1 = mkN "fцrlisning" ;
  foerljudande_nn_1 = mkN "fцrljudande" ;
  foerljugen_av_1 = mkA "fцrljugen" "fцrljuget" ;
  foerloepare_nn_1 = mkN "fцrlцpare" "fцrlцpare" ;
  foerloepning_nn_1 = mkN "fцrlцpning" ;
  foerlopp_nn_1 = mkN "fцrlopp" neutrum ;
  foerlorare_nn_1 = mkN "fцrlorare" "fцrlorare" ;
  foerlossning_nn_1 = mkN "fцrlossning" ;
  foerlossningsanstalt_nn_1 = mkN "fцrlossningsanstalt" "fцrlossningsanstalter" ;
  foerlovning_nn_1 = mkN "fцrlovning" ;
  foerlovningsring_nn_1 = mkN "fцrlovningsring" ;
  foerlupen_av_1 = mkA "fцrlupen" "fцrlupet" ;
  foerlust_nn_1 = mkN "fцrlust" "fцrluster" ;
  foerlustbringande_av_1 = mkA "fцrlustbringande" ;
  foerlustelse_nn_1 = mkN "fцrlustelse" "fцrlustelser" ;
  foerlustig_av_1 = mkA "fцrlustig" ;
  foermaan_nn_1 = mkN "fцrmеn" "fцrmеner" ;
  foermaanlig_av_1 = mkA "fцrmеnlig" ;
  foermaanserbjudande_nn_1 = mkN "fцrmеnserbjudande" ;
  foermaanstagare_nn_1 = mkN "fцrmеnstagare" "fцrmеnstagare" ;
  foermaeld_av_1 = mkA "fцrmдld" "fцrmдlt" ;
  foermaeten_av_1 = mkA "fцrmдten" "fцrmдtet" ;
  foermak_nn_1 = mkN "fцrmak" neutrum ;
  foerman_nn_1 = mkN "fцrman" "fцrmannen" "fцrmдn" "fцrmдnnen" ;
  foermaning_nn_1 = mkN "fцrmaning" ;
  foermatch_nn_1 = mkN "fцrmatch" "fцrmatcher" ;
  foermedlande_av_1 = mkA "fцrmedlande" ;
  foermedlare_nn_1 = mkN "fцrmedlare" "fцrmedlare" ;
  foermedling_nn_1 = mkN "fцrmedling" ;
  foermedveten_av_1 = mkA "fцrmedveten" "fцrmedvetet" ;
  foerment_av_1 = mkA "fцrment" "fцrment" ;
  foermer_av_1 = mkA "fцrmer" ;
  foermiddag_nn_1 = mkN "fцrmiddag" ;
  foermildrande_av_1 = mkA "fцrmildrande" ;
  foerminskning_nn_1 = mkN "fцrminskning" ;
  foermodande_nn_1 = mkN "fцrmodande" ;
  foermodligen_ab_1 = mkAdv "fцrmodligen" ;
  foermoegen_av_1 = mkA "fцrmцgen" "fцrmцget" ;
  foermoegenhet_nn_1 = mkN "fцrmцgenhet" "fцrmцgenheter" ;
  foermoegenhetsbrott_nn_1 = mkN "fцrmцgenhetsbrott" neutrum ;
  foermoegenhetsraett_nn_1 = mkN "fцrmцgenhetsrдtt" "fцrmцgenhetsrдtter" ;
  foermoegenhetsskatt_nn_1 = mkN "fцrmцgenhetsskatt" "fцrmцgenhetsskatter" ;
  foermoerkelse_nn_1 = mkN "fцrmцrkelse" "fцrmцrkelser" ;
  foermoerkelsevariabel_nn_1 = mkN "fцrmцrkelsevariabel" "fцrmцrkelsevariabeln" "fцrmцrkelsevariabler" "fцrmцrkelsevariablerna" ;
  foermoerkning_nn_1 = mkN "fцrmцrkning" ;
  foermultning_nn_1 = mkN "fцrmultning" ;
  foermyndaraktig_av_1 = mkA "fцrmyndaraktig" ;
  foermyndare_nn_1 = mkN "fцrmyndare" "fцrmyndare" ;
  foermyndarskap_nn_1 = mkN "fцrmyndarskap" "fцrmyndarskapet" "fцrmyndarskapen" "fцrmyndarskapena" ;
  foernaem_av_1 = mkA "fцrnдm" "fцrnдmare" "fцrnдmst" ;
  foernaemitet_nn_1 = mkN "fцrnдmitet" "fцrnдmiteter" ;
  foernaemlig_av_1 = mkA "fцrnдmlig" ;
  foernaemligen_ab_1 = mkAdv "fцrnдmligen" ;
  foernaer_ab_1 = mkAdv "fцrnдr" ;
  foernaermelse_nn_1 = mkN "fцrnдrmelse" "fцrnдrmelser" ;
  foernamn_nn_1 = mkN "fцrnamn" neutrum ;
  foernekare_nn_1 = mkN "fцrnekare" "fцrnekare" ;
  foernekelse_nn_1 = mkN "fцrnekelse" "fцrnekelser" ;
  foernimbar_av_1 = mkA "fцrnimbar" ;
  foernimma_vb_1 = mkV "fцrnimma" "fцrnam" "fцrnummit" ;
  foernimmelse_nn_1 = mkN "fцrnimmelse" "fцrnimmelser" ;
  foerning_nn_1 = mkN "fцrning" ;
  foernoedenhet_nn_1 = mkN "fцrnцdenhet" "fцrnцdenheter" ;
  foernoejd_av_1 = mkA "fцrnцjd" "fцrnцjt" ;
  foernoejelse_nn_1 = mkN "fцrnцjelse" "fцrnцjelser" ;
  foernoejsam_av_1 = mkA "fцrnцjsam" "fцrnцjsamt" "fцrnцjsamma" "fцrnцjsamma" "fцrnцjsammare" "fцrnцjsammast" "fцrnцjsammaste" ;
  foernuftig_av_1 = mkA "fцrnuftig" ;
  foernuftsskael_nn_1 = mkN "fцrnuftsskдl" neutrum ;
  foernuftsstridig_av_1 = mkA "fцrnuftsstridig" ;
  foernuftsvidrig_av_1 = mkA "fцrnuftsvidrig" ;
  foernumstig_av_1 = mkA "fцrnumstig" ;
  foernumstighet_nn_1 = mkN "fцrnumstighet" "fцrnumstigheter" ;
  foernyare_nn_1 = mkN "fцrnyare" "fцrnyare" ;
  foernybar_av_1 = mkA "fцrnybar" ;
  foernyelse_nn_1 = mkN "fцrnyelse" "fцrnyelser" ;
  foeroedande_av_1 = mkA "fцrцdande" ;
  foeroedelse_nn_1 = mkN "fцrцdelse" "fцrцdelser" ;
  foeroedmjukelse_nn_1 = mkN "fцrцdmjukelse" "fцrцdmjukelser" ;
  foeroekning_nn_1 = mkN "fцrцkning" ;
  foeroevare_nn_1 = mkN "fцrцvare" "fцrцvare" ;
  foeroever_ab_1 = mkAdv "fцrцver" ;
  foeroevning_nn_1 = mkN "fцrцvning" ;
  foeroevrigt_ab_1 = mkAdv "fцrцvrigt" ;
  foerolaempning_nn_1 = mkN "fцrolдmpning" ;
  foerord_nn_1 = mkN "fцrord" neutrum ;
  foerordnande_nn_1 = mkN "fцrordnande" ;
  foerordning_nn_1 = mkN "fцrordning" ;
  foerorening_nn_1 = mkN "fцrorening" ;
  foeroreningsgrad_nn_1 = mkN "fцroreningsgrad" "fцroreningsgrader" ;
  foerort_nn_1 = mkN "fцrort" "fцrorter" ;
  foerpackning_nn_1 = mkN "fцrpackning" ;
  foerpaktare_nn_1 = mkN "fцrpaktare" "fцrpaktare" ;
  foerpassning_nn_1 = mkN "fцrpassning" ;
  foerpatrull_nn_1 = mkN "fцrpatrull" "fцrpatruller" ;
  foerpik_nn_1 = mkN "fцrpik" ;
  foerplaegnad_nn_1 = mkN "fцrplдgnad" "fцrplдgnader" ;
  foerpliktande_av_1 = mkA "fцrpliktande" ;
  foerpliktelse_nn_1 = mkN "fцrpliktelse" "fцrpliktelser" ;
  foerpost_nn_1 = mkN "fцrpost" "fцrposter" ;
  foerpostfaektning_nn_1 = mkN "fцrpostfдktning" ;
  foerpubertet_nn_1 = mkN "fцrpubertet" "fцrpuberteter" ;
  foerpuppning_nn_1 = mkN "fцrpuppning" ;
  foerr_ab_1 = mkAdv "fцrr" ;
  foerraad_nn_1 = mkN "fцrrеd" neutrum ;
  foerraadshus_nn_1 = mkN "fцrrеdshus" neutrum ;
  foerraedare_nn_1 = mkN "fцrrдdare" "fцrrдdare" ;
  foerraederi_nn_1 = mkN "fцrrдderi" "fцrrдderit" "fцrrдderier" "fцrrдderierna" ;
  foerraedisk_av_1 = mkA "fцrrдdisk" ;
  foerraett_nn_1 = mkN "fцrrдtt" "fцrrдtter" ;
  foerraettare_nn_1 = mkN "fцrrдttare" "fцrrдttare" ;
  foerraettning_nn_1 = mkN "fцrrдttning" ;
  foerregling_nn_1 = mkN "fцrregling" ;
  foerresten_ab_1 = mkAdv "fцrresten" ;
  foerrfoerra_av_1 = mkA "fцrrfцrra" ;
  foerrinna_vb_1 = mkV "fцrrinna" "fцrrann" "fцrrunnit" ;
  foerromantisk_av_1 = mkA "fцrromantisk" ;
  foerromersk_av_1 = mkA "fцrromersk" ;
  foerrum_nn_1 = mkN "fцrrum" "fцrrummet" "fцrrum" "fцrrummen" ;
  foerruttnelsegas_nn_1 = mkN "fцrruttnelsegas" "fцrruttnelsegaser" ;
  foerryckt_av_1 = mkA "fцrryckt" "fцrryckt" ;
  foerrymd_av_1 = mkA "fцrrymd" "fцrrymt" ;
  foersaapning_nn_1 = mkN "fцrsеpning" ;
  foersaat_nn_1 = mkN "fцrsеt" neutrum ;
  foersaatlig_av_1 = mkA "fцrsеtlig" ;
  foersaegning_nn_1 = mkN "fцrsдgning" ;
  foersaekran_nn_1 = mkN "fцrsдkran" "fцrsдkran" "fцrsдkringar" "fцrsдkringarna" ;
  foersaekring_nn_1 = mkN "fцrsдkring" ;
  foersaekringsbedraegeri_nn_1 = mkN "fцrsдkringsbedrдgeri" "fцrsдkringsbedrдgerit" "fцrsдkringsbedrдgerier" "fцrsдkringsbedrдgerierna" ;
  foersaekringsbesked_nn_1 = mkN "fцrsдkringsbesked" neutrum ;
  foersaekringsbolag_nn_1 = mkN "fцrsдkringsbolag" neutrum ;
  foersaekringsbrev_nn_1 = mkN "fцrsдkringsbrev" neutrum ;
  foersaekringsgivare_nn_1 = mkN "fцrsдkringsgivare" "fцrsдkringsgivare" ;
  foersaekringsinslag_nn_1 = mkN "fцrsдkringsinslag" neutrum ;
  foersaekringskassa_nn_1 = mkN "fцrsдkringskassa" ;
  foersaekringsmarknad_nn_1 = mkN "fцrsдkringsmarknad" "fцrsдkringsmarknader" ;
  foersaekringspeng_nn_1 = mkN "fцrsдkringspeng" ;
  foersaekringspolis_nn_1 = mkN "fцrsдkringspolis" "fцrsдkringspoliser" ;
  foersaekringspremie_nn_1 = mkN "fцrsдkringspremie" "fцrsдkringspremier" ;
  foersaekringsskydd_nn_1 = mkN "fцrsдkringsskydd" neutrum ;
  foersaekringssystem_nn_1 = mkN "fцrsдkringssystem" neutrum ;
  foersaekringsvillkor_nn_1 = mkN "fцrsдkringsvillkor" neutrum ;
  foersaeljare_nn_1 = mkN "fцrsдljare" "fцrsдljare" ;
  foersaeljning_nn_1 = mkN "fцrsдljning" ;
  foersaeljningsbransch_nn_1 = mkN "fцrsдljningsbransch" "fцrsдljningsbranscher" ;
  foersaeljningschef_nn_1 = mkN "fцrsдljningschef" "fцrsдljningschefer" ;
  foersaeljningsdisk_nn_1 = mkN "fцrsдljningsdisk" ;
  foersaeljningsled_nn_1 = mkN "fцrsдljningsled" neutrum ;
  foersaeljningsort_nn_1 = mkN "fцrsдljningsort" "fцrsдljningsorter" ;
  foersaeljningspris_nn_1 = mkN "fцrsдljningspris" neutrum ;
  foersaeljningsstaand_nn_1 = mkN "fцrsдljningsstеnd" neutrum ;
  foersaeljningsstopp_nn_1 = mkN "fцrsдljningsstopp" neutrum ;
  foersaeljningsvana_nn_1 = mkN "fцrsдljningsvana" ;
  foersaeljningsvinst_nn_1 = mkN "fцrsдljningsvinst" "fцrsдljningsvinster" ;
  foersaemring_nn_1 = mkN "fцrsдmring" ;
  foersaendelse_nn_1 = mkN "fцrsдndelse" "fцrsдndelser" ;
  foersaenkare_nn_1 = mkN "fцrsдnkare" "fцrsдnkare" ;
  foersaenkning_nn_1 = mkN "fцrsдnkning" ;
  foersaettsblad_nn_1 = mkN "fцrsдttsblad" neutrum ;
  foersaettslins_nn_1 = mkN "fцrsдttslins" "fцrsдttslinser" ;
  foersagd_av_1 = mkA "fцrsagd" "fцrsagt" ;
  foersakelse_nn_1 = mkN "fцrsakelse" "fцrsakelser" ;
  foersamling_nn_1 = mkN "fцrsamling" ;
  foersamlingsassistent_nn_1 = mkN "fцrsamlingsassistent" "fцrsamlingsassistenter" ;
  foersamlingsbok_nn_1 = mkN "fцrsamlingsbok" "fцrsamlingsbцcker" ;
  foersamlingsfrihet_nn_1 = mkN "fцrsamlingsfrihet" "fцrsamlingsfriheter" ;
  foersamlingshem_nn_1 = mkN "fцrsamlingshem" "fцrsamlingshemmet" "fцrsamlingshem" "fцrsamlingshemmen" ;
  foersamlingsmedlem_nn_1 = mkN "fцrsamlingsmedlem" "fцrsamlingsmedlemmen" "fцrsamlingsmedlemmar" "fцrsamlingsmedlemmarna" ;
  foersats_nn_1 = mkN "fцrsats" "fцrsatser" ;
  foerseelse_nn_1 = mkN "fцrseelse" "fцrseelser" ;
  foersegel_nn_1 = mkN "fцrsegel" neutrum ;
  foersening_nn_1 = mkN "fцrsening" ;
  foersiggaa_vb_1 = mkV "fцrsiggе" "fцrsiggеr" "fцrsiggе" "fцrsiggick" "fцrsiggеtt" "fцrsiggеngen" ;
  foersigkommen_av_1 = mkA "fцrsigkommen" "fцrsigkommet" "fцrsigkomna" "fцrsigkomna" "fцrsigkomnare" "fцrsigkomnast" "fцrsigkomnaste" ;
  foersiktig_av_1 = mkA "fцrsiktig" ;
  foersiktighet_nn_1 = mkN "fцrsiktighet" "fцrsiktigheter" ;
  foersiktighetsaatgaerd_nn_1 = mkN "fцrsiktighetsеtgдrd" "fцrsiktighetsеtgдrder" ;
  foersiktighetsmaatt_nn_1 = mkN "fцrsiktighetsmеtt" neutrum ;
  foersiktigtvis_ab_1 = mkAdv "fцrsiktigtvis" ;
  foersitta_vb_1 = mkV "fцrsitta" "fцrsatt" "fцrsuttit" ;
  foersjunka_vb_1 = mkV "fцrsjunka" "fцrsjцnk" "fцrsjunkit" ;
  foersjunken_av_1 = mkA "fцrsjunken" "fцrsjunket" ;
  foerskaemd_av_1 = mkA "fцrskдmd" "fцrskдmt" ;
  foerskaemning_nn_1 = mkN "fцrskдmning" ;
  foerskaera_vb_1 = mkV "fцrskдra" "fцrskar" "fцrskurit" ;
  foerskaerare_nn_1 = mkN "fцrskдrare" "fцrskдrare" ;
  foerskaerargaffel_nn_1 = mkN "fцrskдrargaffel" ;
  foerskaerarkniv_nn_1 = mkN "fцrskдrarkniv" ;
  foerskansning_nn_1 = mkN "fцrskansning" ;
  foerskepp_nn_1 = mkN "fцrskepp" neutrum ;
  foerskiffring_nn_1 = mkN "fцrskiffring" ;
  foerskingrare_nn_1 = mkN "fцrskingrare" "fцrskingrare" ;
  foerskingring_nn_1 = mkN "fцrskingring" ;
  foerskinn_nn_1 = mkN "fцrskinn" neutrum ;
  foerskjuta_vb_1 = mkV "fцrskjuta" "fцrskцt" "fцrskjutit" ;
  foerskjutning_nn_1 = mkN "fцrskjutning" ;
  foerskoleaalder_nn_1 = mkN "fцrskoleеlder" ;
  foerskollaerare_nn_1 = mkN "fцrskollдrare" "fцrskollдrare" ;
  foerskott_nn_1 = mkN "fцrskott" neutrum ;
  foerskraeckelse_nn_1 = mkN "fцrskrдckelse" "fцrskrдckelser" ;
  foerskraecklig_av_1 = mkA "fцrskrдcklig" ;
  foerskraeckt_av_1 = mkA "fцrskrдckt" "fцrskrдckt" ;
  foerskraemd_av_1 = mkA "fцrskrдmd" "fцrskrдmt" ;
  foerskriva_vb_1 = mkV "fцrskriva" "fцrskrev" "fцrskrivit" ;
  foerskrivning_nn_1 = mkN "fцrskrivning" ;
  foerslag_1_nn_1 = mkN "fцrslag" neutrum ;
  foerslag_2_nn_1 = mkN "fцrslag" neutrum ;
  foerslagen_av_1 = mkA "fцrslagen" "fцrslaget" ;
  foerslagsrum_nn_1 = mkN "fцrslagsrum" "fцrslagsrummet" "fцrslagsrum" "fцrslagsrummen" ;
  foerslagsvis_ab_1 = mkAdv "fцrslagsvis" ;
  foerslappning_nn_1 = mkN "fцrslappning" ;
  foerslita_vb_1 = mkV "fцrslita" "fцrslet" "fцrslitit" ;
  foerslitning_nn_1 = mkN "fцrslitning" ;
  foersluta_vb_1 = mkV "fцrsluta" "fцrslцt" "fцrslutit" ;
  foerslutning_nn_1 = mkN "fцrslutning" ;
  foersmaedlig_av_1 = mkA "fцrsmдdlig" ;
  foersoek_nn_1 = mkN "fцrsцk" neutrum ;
  foersoeksballong_nn_1 = mkN "fцrsцksballong" "fцrsцksballonger" ;
  foersoeksdamm_nn_1 = mkN "fцrsцksdamm" ;
  foersoeksdjur_nn_1 = mkN "fцrsцksdjur" neutrum ;
  foersoeksgymnasium_nn_1 = mkN "fцrsцksgymnasium" "fцrsцksgymnasiet" "fцrsцksgymnasier" "fцrsцksgymnasierna" ;
  foersoeksheat_nn_1 = mkN "fцrsцksheat" neutrum ;
  foersoekskanin_nn_1 = mkN "fцrsцkskanin" "fцrsцkskaniner" ;
  foersoeksledare_nn_1 = mkN "fцrsцksledare" "fцrsцksledare" ;
  foersoeksobjekt_nn_1 = mkN "fцrsцksobjekt" neutrum ;
  foersoeksperson_nn_1 = mkN "fцrsцksperson" "fцrsцkspersoner" ;
  foersoeksverksamhet_nn_1 = mkN "fцrsцksverksamhet" "fцrsцksverksamheter" ;
  foersoeksvis_ab_1 = mkAdv "fцrsцksvis" ;
  foersoerjare_nn_1 = mkN "fцrsцrjare" "fцrsцrjare" ;
  foersoerjningsboerda_nn_1 = mkN "fцrsцrjningsbцrda" ;
  foersommar_nn_1 = mkN "fцrsommar" "fцrsommarn" "fцrsommrar" "fцrsommrarna" ;
  foersonande_av_1 = mkA "fцrsonande" ;
  foersoning_nn_1 = mkN "fцrsoning" ;
  foersonlig_av_1 = mkA "fцrsonlig" ;
  foersova_vb_1 = mkV "fцrsova" "fцrsov" "fцrsovit" ;
  foerspaend_av_1 = mkA "fцrspдnd" ;
  foerspaenning_nn_1 = mkN "fцrspдnning" ;
  foerspel_nn_1 = mkN "fцrspel" "fцrspelet" "fцrspel" "fцrspelen" ;
  foerst_ab_1 = mkAdv "fцrst" ;
  foerstaaelig_av_1 = mkA "fцrstеelig" ;
  foerstaaende_av_1 = mkA "fцrstеende" ;
  foerstaandig_av_1 = mkA "fцrstеndig" ;
  foerstaandshandikapp_nn_1 = mkN "fцrstеndshandikapp" neutrum ;
  foerstaang_nn_1 = mkN "fцrstеng" "fцrstдnger" ;
  foerstaas_ab_1 = mkAdv "fцrstеs" ;
  foerstaasigpaaare_nn_1 = mkN "fцrstеsigpеare" "fцrstеsigpеare" ;
  foerstad_nn_1 = mkN "fцrstad" "fцrstдder" ;
  foerstadagsbrev_nn_1 = mkN "fцrstadagsbrev" neutrum ;
  foerstadium_nn_1 = mkN "fцrstadium" "fцrstadiet" "fцrstadier" "fцrstadierna" ;
  foerstaemd_av_1 = mkA "fцrstдmd" "fцrstдmt" ;
  foerstaendigande_nn_1 = mkN "fцrstдndigande" ;
  foerstaerkare_nn_1 = mkN "fцrstдrkare" "fцrstдrkare" ;
  foerstaerkning_nn_1 = mkN "fцrstдrkning" ;
  foerstaerkningsord_nn_1 = mkN "fцrstдrkningsord" neutrum ;
  foerstaev_nn_1 = mkN "fцrstдv" ;
  foerstag_nn_1 = mkN "fцrstag" neutrum ;
  foerstagaangsvaeljare_nn_1 = mkN "fцrstagеngsvдljare" "fцrstagеngsvдljare" ;
  foerstagradsekvation_nn_1 = mkN "fцrstagradsekvation" "fцrstagradsekvationer" ;
  foerstahandsuppgift_nn_1 = mkN "fцrstahandsuppgift" "fцrstahandsuppgifter" ;
  foerstaklasshotell_nn_1 = mkN "fцrstaklasshotell" neutrum ;
  foerstamajtaag_nn_1 = mkN "fцrstamajtеg" neutrum ;
  foerstasida_nn_1 = mkN "fцrstasida" ;
  foerstaupplaga_nn_1 = mkN "fцrstaupplaga" ;
  foerstavelse_nn_1 = mkN "fцrstavelse" "fцrstavelser" ;
  foerstbemaelde_av_1 = mkA "fцrstbemдlde" ;
  foersteg_nn_1 = mkN "fцrsteg" neutrum ;
  foerstfoedd_av_1 = mkA "fцrstfцdd" ;
  foerstfoederska_nn_1 = mkN "fцrstfцderska" ;
  foerstklassig_av_1 = mkA "fцrstklassig" ;
  foerstling_nn_1 = mkN "fцrstling" ;
  foerstnaemnd_av_1 = mkA "fцrstnдmnd" ;
  foerstnaemnde_av_1 = mkA "fцrstnдmnde" ;
  foerstoerelse_nn_1 = mkN "fцrstцrelse" "fцrstцrelser" ;
  foerstoppning_nn_1 = mkN "fцrstoppning" ;
  foerstoring_nn_1 = mkN "fцrstoring" ;
  foerstoringsapparat_nn_1 = mkN "fцrstoringsapparat" "fцrstoringsapparater" ;
  foerstoringsglas_nn_1 = mkN "fцrstoringsglas" neutrum ;
  foerstraeckning_nn_1 = mkN "fцrstrдckning" ;
  foerstroedd_av_1 = mkA "fцrstrцdd" "fцrstrцdtt" ;
  foerstroeelse_nn_1 = mkN "fцrstrцelse" "fцrstrцelser" ;
  foerstubro_nn_1 = mkN "fцrstubro" ;
  foerstucken_av_1 = mkA "fцrstucken" "fцrstucket" ;
  foerstudie_nn_1 = mkN "fцrstudie" "fцrstudier" ;
  foerstuga_nn_1 = mkN "fцrstuga" ;
  foerstugubro_nn_1 = mkN "fцrstugubro" ;
  foerstukvist_nn_1 = mkN "fцrstukvist" ;
  foerstulen_av_1 = mkA "fцrstulen" "fцrstulet" ;
  foersumbar_av_1 = mkA "fцrsumbar" ;
  foersumlig_av_1 = mkA "fцrsumlig" ;
  foersumlighet_nn_1 = mkN "fцrsumlighet" "fцrsumligheter" ;
  foersummelse_nn_1 = mkN "fцrsummelse" "fцrsummelser" ;
  foersupen_av_1 = mkA "fцrsupen" "fцrsupet" ;
  foersvaarande_av_1 = mkA "fцrsvеrande" ;
  foersvaerja_vb_1 = mkV "fцrsvдrja" "fцrsvдrj" "fцrsvдrj" "fцrsvorj" "fцrsvurjit" "fцrsvurjen" ;
  foersvarare_nn_1 = mkN "fцrsvarare" "fцrsvarare" ;
  foersvarbar_av_1 = mkA "fцrsvarbar" ;
  foersvarlig_av_1 = mkA "fцrsvarlig" ;
  foersvarsadvokat_nn_1 = mkN "fцrsvarsadvokat" "fцrsvarsadvokater" ;
  foersvarsanlaeggning_nn_1 = mkN "fцrsvarsanlдggning" ;
  foersvarsattache_nn_1 = mkN "fцrsvarsattachй" "fцrsvarsattachйer" ;
  foersvarsgren_nn_1 = mkN "fцrsvarsgren" "fцrsvarsgrenen" "fцrsvarsgrenar" "fцrsvarsgrenarna" ;
  foersvarshemlighet_nn_1 = mkN "fцrsvarshemlighet" "fцrsvarshemligheter" ;
  foersvarskostnad_nn_1 = mkN "fцrsvarskostnad" "fцrsvarskostnader" ;
  foersvarskraft_nn_1 = mkN "fцrsvarskraft" "fцrsvarskrafter" ;
  foersvarslinje_nn_1 = mkN "fцrsvarslinje" "fцrsvarslinjer" ;
  foersvarsloes_av_1 = mkA "fцrsvarslцs" ;
  foersvarsminister_nn_1 = mkN "fцrsvarsminister" ;
  foersvarsomraade_nn_1 = mkN "fцrsvarsomrеde" ;
  foersvarsskrift_nn_1 = mkN "fцrsvarsskrift" "fцrsvarsskrifter" ;
  foersvarsspel_nn_1 = mkN "fцrsvarsspel" "fцrsvarsspelet" "fцrsvarsspel" "fцrsvarsspelen" ;
  foersvarsspelare_nn_1 = mkN "fцrsvarsspelare" "fцrsvarsspelare" ;
  foersvarsstab_nn_1 = mkN "fцrsvarsstab" "fцrsvarsstaber" ;
  foersvarsstaellning_nn_1 = mkN "fцrsvarsstдllning" ;
  foersvarstal_nn_1 = mkN "fцrsvarstal" "fцrsvarstalet" "fцrsvarstalen" "fцrsvarstalena" ;
  foersvarsverk_nn_1 = mkN "fцrsvarsverk" neutrum ;
  foersvinna_vb_1 = mkV "fцrsvinna" "fцrsvann" "fцrsvunnit" ;
  foersvinnande_nn_1 = mkN "fцrsvinnande" ;
  foersynt_av_1 = mkA "fцrsynt" "fцrsynt" ;
  foerta_vb_1 = mkV "fцrta" "fцrtar" "fцrta" "fцrtog" "fцrtagit" "fцrtagen" ;
  foertaeckt_av_1 = mkA "fцrtдckt" "fцrtдckt" ;
  foertaendning_nn_1 = mkN "fцrtдndning" ;
  foertaenksam_av_1 = mkA "fцrtдnksam" "fцrtдnksamt" "fцrtдnksamma" "fцrtдnksamma" "fцrtдnksammare" "fцrtдnksammast" "fцrtдnksammaste" ;
  foertaetning_nn_1 = mkN "fцrtдtning" ;
  foertalskampanj_nn_1 = mkN "fцrtalskampanj" "fцrtalskampanjer" ;
  foertecken_nn_1 = mkN "fцrtecken" "fцrtecknet" "fцrtecken" "fцrtecknen" ;
  foerteckning_nn_1 = mkN "fцrteckning" ;
  foertegen_av_1 = mkA "fцrtegen" "fцrteget" ;
  foertida_av_1 = mkA "fцrtida" ;
  foertidsboerd_nn_1 = mkN "fцrtidsbцrd" "fцrtidsbцrder" ;
  foertidspension_nn_1 = mkN "fцrtidspension" "fцrtidspensioner" ;
  foertimring_nn_1 = mkN "fцrtimring" ;
  foertjaenst_ab_1 = mkAdv "fцrtjдnst" ;
  foertjaenst_nn_1 = mkN "fцrtjдnst" "fцrtjдnster" ;
  foertjaenstfull_av_1 = mkA "fцrtjдnstfull" ;
  foertjaensttecken_nn_1 = mkN "fцrtjдnsttecken" "fцrtjдnsttecknet" "fцrtjдnsttecken" "fцrtjдnsttecknen" ;
  foertjaent_av_1 = mkA "fцrtjдnt" "fцrtjдnt" ;
  foertjusande_av_1 = mkA "fцrtjusande" ;
  foertjust_av_1 = mkA "fцrtjust" "fцrtjust" ;
  foertoejning_nn_1 = mkN "fцrtцjning" ;
  foertoejningsring_nn_1 = mkN "fцrtцjningsring" ;
  foertoning_nn_1 = mkN "fцrtoning" ;
  foertraefflig_av_1 = mkA "fцrtrдfflig" ;
  foertraengning_nn_1 = mkN "fцrtrдngning" ;
  foertretlig_av_1 = mkA "fцrtretlig" ;
  foertretlighet_nn_1 = mkN "fцrtretlighet" "fцrtretligheter" ;
  foertroende_nn_1 = mkN "fцrtroende" ;
  foertroendefraaga_nn_1 = mkN "fцrtroendefrеga" ;
  foertroendefull_av_1 = mkA "fцrtroendefull" ;
  foertroendeingivande_av_1 = mkA "fцrtroendeingivande" ;
  foertroendeman_nn_1 = mkN "fцrtroendeman" "fцrtroendemannen" "fцrtroendemдn" "fцrtroendemдnnen" ;
  foertroenderaad_nn_1 = mkN "fцrtroenderеd" neutrum ;
  foertroendeuppdrag_nn_1 = mkN "fцrtroendeuppdrag" neutrum ;
  foertroendevald_av_1 = mkA "fцrtroendevald" "fцrtroendevalt" ;
  foertroendevotum_nn_1 = mkN "fцrtroendevotum" neutrum ;
  foertrogen_av_1 = mkA "fцrtrogen" "fцrtroget" ;
  foertrogenhet_nn_1 = mkN "fцrtrogenhet" "fцrtrogenheter" ;
  foertrolig_av_1 = mkA "fцrtrolig" ;
  foertrolighet_nn_1 = mkN "fцrtrolighet" "fцrtroligheter" ;
  foertrollande_av_1 = mkA "fцrtrollande" ;
  foertrupp_nn_1 = mkN "fцrtrupp" "fцrtrupper" ;
  foertryckare_nn_1 = mkN "fцrtryckare" "fцrtryckare" ;
  foertrytsam_av_1 = mkA "fцrtrytsam" "fцrtrytsamt" "fцrtrytsamma" "fцrtrytsamma" "fцrtrytsammare" "fцrtrytsammast" "fцrtrytsammaste" ;
  foertunning_nn_1 = mkN "fцrtunning" ;
  foertvaalning_nn_1 = mkN "fцrtvеlning" ;
  foertvaett_nn_1 = mkN "fцrtvдtt" ;
  foerty_ab_1 = mkAdv "fцrty" ;
  foertydligande_nn_1 = mkN "fцrtydligande" ;
  foerunderlig_av_1 = mkA "fцrunderlig" ;
  foerundersoekning_nn_1 = mkN "fцrundersцkning" ;
  foerundransvaerd_av_1 = mkA "fцrundransvдrd" "fцrundransvдrt" ;
  foerut_1_ab_1 = mkAdv "fцrut" ;
  foerut_2_ab_1 = mkAdv "fцrut" ;
  foerutbestaemd_av_1 = mkA "fцrutbestдmd" "fцrutbestдmt" ;
  foerutsaegbar_av_1 = mkA "fцrutsдgbar" ;
  foerutsaegelse_nn_1 = mkN "fцrutsдgelse" "fцrutsдgelser" ;
  foerutsaettning_nn_1 = mkN "fцrutsдttning" ;
  foerutsaettningsloes_av_1 = mkA "fцrutsдttningslцs" ;
  foerutseende_av_1 = mkA "fцrutseende" ;
  foerutvarande_av_1 = mkA "fцrutvarande" ;
  foervaanansvaerd_av_1 = mkA "fцrvеnansvдrd" "fцrvеnansvдrt" ;
  foervaegen_av_1 = mkA "fцrvдgen" "fцrvдget" ;
  foervaeljare_nn_1 = mkN "fцrvдljare" "fцrvдljare" ;
  foervaend_av_1 = mkA "fцrvдnd" ;
  foervaentansfull_av_1 = mkA "fцrvдntansfull" ;
  foervaentning_nn_1 = mkN "fцrvдntning" ;
  foervaermare_nn_1 = mkN "fцrvдrmare" "fцrvдrmare" ;
  foervaerv_nn_1 = mkN "fцrvдrv" neutrum ;
  foervaervsavdrag_nn_1 = mkN "fцrvдrvsavdrag" neutrum ;
  foervaervsverksamhet_nn_1 = mkN "fцrvдrvsverksamhet" "fцrvдrvsverksamheter" ;
  foervaexling_nn_1 = mkN "fцrvдxling" ;
  foervaext_av_1 = mkA "fцrvдxt" "fцrvдxt" ;
  foervaltare_nn_1 = mkN "fцrvaltare" "fцrvaltare" ;
  foervaltarskapsomraade_nn_1 = mkN "fцrvaltarskapsomrеde" ;
  foervaltning_nn_1 = mkN "fцrvaltning" ;
  foervaltningsberaettelse_nn_1 = mkN "fцrvaltningsberдttelse" "fцrvaltningsberдttelser" ;
  foervaltningsbolag_nn_1 = mkN "fцrvaltningsbolag" neutrum ;
  foervaltningsutskott_nn_1 = mkN "fцrvaltningsutskott" neutrum ;
  foervandling_nn_1 = mkN "fцrvandling" ;
  foervandlingskonstnaer_nn_1 = mkN "fцrvandlingskonstnдr" "fцrvandlingskonstnдrer" ;
  foervandlingsnummer_nn_1 = mkN "fцrvandlingsnummer" neutrum ;
  foervandlingsstraff_nn_1 = mkN "fцrvandlingsstraff" neutrum ;
  foervanskning_nn_1 = mkN "fцrvanskning" ;
  foervaring_nn_1 = mkN "fцrvaring" ;
  foervaringshall_nn_1 = mkN "fцrvaringshall" ;
  foervaringsutrymme_nn_1 = mkN "fцrvaringsutrymme" ;
  foervarning_nn_1 = mkN "fцrvarning" ;
  foerveckling_nn_1 = mkN "fцrveckling" ;
  foervedning_nn_1 = mkN "fцrvedning" ;
  foerverkande_nn_1 = mkN "fцrverkande" ;
  foerverkligande_nn_1 = mkN "fцrverkligande" ;
  foerveten_av_1 = mkA "fцrveten" "fцrvetet" ;
  foervillelse_nn_1 = mkN "fцrvillelse" "fцrvillelser" ;
  foervisning_nn_1 = mkN "fцrvisning" ;
  foervisso_ab_1 = mkAdv "fцrvisso" ;
  foervittring_nn_1 = mkN "fцrvittring" ;
  foervraengning_nn_1 = mkN "fцrvrдngning" ;
  foervrida_vb_1 = mkV "fцrvrida" "fцrvred" "fцrvridit" ;
  foervunnen_av_1 = mkA "fцrvunnen" "fцrvunnet" "fцrvunna" "fцrvunna" "fцrvunnare" "fцrvunnast" "fцrvunnaste" ;
  foervuxen_av_1 = mkA "fцrvuxen" "fцrvuxet" ;
  fog_nn_1 = mkN "fog" ;
  fogde_nn_1 = mkN "fogde" utrum ;
  fogeord_nn_1 = mkN "fogeord" neutrum ;
  foglig_av_1 = mkA "foglig" ;
  fogstryka_vb_1 = mkV "fogstryka" "fogstrцk" "fogstrukit" ;
  fogsvans_nn_1 = mkN "fogsvans" ;
  fokal_av_1 = mkA "fokal" ;
  fokaldistans_nn_1 = mkN "fokaldistans" "fokaldistanser" ;
  fokalplan_nn_1 = mkN "fokalplan" neutrum ;
  fokus_nn_1 = mkN "fokus" ;
  folder_nn_1 = mkN "folder" ;
  foliant_nn_1 = mkN "foliant" "folianter" ;
  folie_nn_1 = mkN "folie" "folier" ;
  folioformat_nn_1 = mkN "folioformat" neutrum ;
  folk_nn_1 = mkN "folk" neutrum ;
  folkarme_nn_1 = mkN "folkarmй" "folkarmйer" ;
  folkbaat_nn_1 = mkN "folkbеt" ;
  folkbibliotek_nn_1 = mkN "folkbibliotek" neutrum ;
  folkbokfoering_nn_1 = mkN "folkbokfцring" ;
  folkdans_nn_1 = mkN "folkdans" "folkdanser" ;
  folkdemokrati_nn_1 = mkN "folkdemokrati" "folkdemokratier" ;
  folkdemokratisk_av_1 = mkA "folkdemokratisk" ;
  folkdikt_nn_1 = mkN "folkdikt" "folkdikter" ;
  folkdiktning_nn_1 = mkN "folkdiktning" ;
  folkdjup_nn_1 = mkN "folkdjup" neutrum ;
  folkdomstol_nn_1 = mkN "folkdomstol" ;
  folkdraekt_nn_1 = mkN "folkdrдkt" "folkdrдkter" ;
  folketymologi_nn_1 = mkN "folketymologi" "folketymologier" ;
  folketymologisk_av_1 = mkA "folketymologisk" ;
  folkfest_nn_1 = mkN "folkfest" "folkfester" ;
  folkfoersamling_nn_1 = mkN "folkfцrsamling" ;
  folkfront_nn_1 = mkN "folkfront" "folkfronter" ;
  folkgrupp_nn_1 = mkN "folkgrupp" "folkgrupper" ;
  folkhem_nn_1 = mkN "folkhem" "folkhemmet" "folkhem" "folkhemmen" ;
  folkhemsk_av_1 = mkA "folkhemsk" ;
  folkhjaelte_nn_1 = mkN "folkhjдlte" utrum ;
  folkhop_nn_1 = mkN "folkhop" ;
  folkilsken_av_1 = mkA "folkilsken" "folkilsket" ;
  folkkaer_av_1 = mkA "folkkдr" ;
  folkkommissarie_nn_1 = mkN "folkkommissarie" "folkkommissarier" ;
  folkkommun_nn_1 = mkN "folkkommun" "folkkommuner" ;
  folkkongress_nn_1 = mkN "folkkongress" "folkkongresser" ;
  folklager_nn_1 = mkN "folklager" neutrum ;
  folkledare_nn_1 = mkN "folkledare" "folkledare" ;
  folklek_nn_1 = mkN "folklek" ;
  folklig_av_1 = mkA "folklig" ;
  folklighet_nn_1 = mkN "folklighet" "folkligheter" ;
  folklivsforskare_nn_1 = mkN "folklivsforskare" "folklivsforskare" ;
  folklivsskildring_nn_1 = mkN "folklivsskildring" ;
  folklorist_nn_1 = mkN "folklorist" "folklorister" ;
  folkloristisk_av_1 = mkA "folkloristisk" ;
  folklustspel_nn_1 = mkN "folklustspel" "folklustspelet" "folklustspel" "folklustspelen" ;
  folkmaal_nn_1 = mkN "folkmеl" neutrum ;
  folkmaengd_nn_1 = mkN "folkmдngd" "folkmдngder" ;
  folkmelodi_nn_1 = mkN "folkmelodi" "folkmelodier" ;
  folkminne_nn_1 = mkN "folkminne" ;
  folkmord_nn_1 = mkN "folkmord" neutrum ;
  folknoeje_nn_1 = mkN "folknцje" ;
  folkoel_nn_1 = mkN "folkцl" neutrum ;
  folkomroestning_nn_1 = mkN "folkomrцstning" ;
  folkpark_nn_1 = mkN "folkpark" "folkparker" ;
  folkpartist_nn_1 = mkN "folkpartist" "folkpartister" ;
  folkpension_nn_1 = mkN "folkpension" "folkpensioner" ;
  folkpensionaer_nn_1 = mkN "folkpensionдr" "folkpensionдrer" ;
  folkraekning_nn_1 = mkN "folkrдkning" ;
  folkraettslig_av_1 = mkA "folkrдttslig" ;
  folkrepresentation_nn_1 = mkN "folkrepresentation" "folkrepresentationer" ;
  folkrepublik_nn_1 = mkN "folkrepublik" "folkrepubliker" ;
  folkresning_nn_1 = mkN "folkresning" ;
  folkrik_av_1 = mkA "folkrik" ;
  folkroerelse_nn_1 = mkN "folkrцrelse" "folkrцrelser" ;
  folksaang_nn_1 = mkN "folksеng" "folksеnger" ;
  folksaegen_nn_1 = mkN "folksдgen" "folksдgenn" "folksдgner" "folksдgnerna" ;
  folksaga_nn_1 = mkN "folksaga" ;
  folksamling_nn_1 = mkN "folksamling" ;
  folkskollaerare_nn_1 = mkN "folkskollдrare" "folkskollдrare" ;
  folkskygg_av_1 = mkA "folkskygg" ;
  folkslag_nn_1 = mkN "folkslag" neutrum ;
  folkstam_nn_1 = mkN "folkstam" "folkstammen" "folkstammar" "folkstammarna" ;
  folkstorm_nn_1 = mkN "folkstorm" ;
  folkstyre_nn_1 = mkN "folkstyre" ;
  folktaet_av_1 = mkA "folktдt" ;
  folktaethet_nn_1 = mkN "folktдthet" "folktдtheter" ;
  folkting_nn_1 = mkN "folkting" neutrum ;
  folktom_av_1 = mkA "folktom" "folktomt" "folktomma" "folktomma" "folktommare" "folktommast" "folktommaste" ;
  folktribun_nn_1 = mkN "folktribun" "folktribuner" ;
  folkuniversitet_nn_1 = mkN "folkuniversitet" neutrum ;
  folkvald_av_1 = mkA "folkvald" "folkvalt" ;
  folkvandring_nn_1 = mkN "folkvandring" ;
  folkvilja_nn_1 = mkN "folkvilja" ;
  follikel_nn_1 = mkN "follikel" ;
  follikelstimulerande_av_1 = mkA "follikelstimulerande" ;
  fon_nn_1 = mkN "fon" "foner" ;
  fond_nn_1 = mkN "fond" "fonder" ;
  fondaktie_nn_1 = mkN "fondaktie" "fondaktier" ;
  fondboers_nn_1 = mkN "fondbцrs" "fondbцrser" ;
  fondemission_nn_1 = mkN "fondemission" "fondemissioner" ;
  fondkommissionaer_nn_1 = mkN "fondkommissionдr" "fondkommissionдrer" ;
  fondpapper_nn_1 = mkN "fondpapper" neutrum ;
  fondstaempel_nn_1 = mkN "fondstдmpel" ;
  fondue_nn_1 = mkN "fondue" "fonduer" ;
  fonem_nn_1 = mkN "fonem" neutrum ;
  fonematisk_av_1 = mkA "fonematisk" ;
  fonetiker_nn_1 = mkN "fonetiker" "fonetikern" "fonetiker" "fonetikerna" ;
  fonetisk_av_1 = mkA "fonetisk" ;
  foniater_nn_1 = mkN "foniater" "foniatern" "foniatrer" "foniatrerna" ;
  foniatriker_nn_1 = mkN "foniatriker" "foniatrikern" "foniatriker" "foniatrikerna" ;
  foniatrisk_av_1 = mkA "foniatrisk" ;
  fonograf_nn_1 = mkN "fonograf" "fonografer" ;
  fonogram_nn_1 = mkN "fonogram" "fonogrammet" "fonogram" "fonogrammen" ;
  fonologisk_av_1 = mkA "fonologisk" ;
  fonotek_nn_1 = mkN "fonotek" neutrum ;
  fontaen_nn_1 = mkN "fontдn" "fontдner" ;
  fontanell_nn_1 = mkN "fontanell" "fontaneller" ;
  forcerbar_av_1 = mkA "forcerbar" ;
  forcering_nn_1 = mkN "forcering" ;
  fordom_ab_1 = mkAdv "fordom" ;
  fordon_nn_1 = mkN "fordon" neutrum ;
  fordonsuppstaellning_nn_1 = mkN "fordonsuppstдllning" ;
  fordonsvikt_nn_1 = mkN "fordonsvikt" "fordonsvikter" ;
  fordran_nn_1 = mkN "fordran" "fordran" "fordringar" "fordringarna" ;
  fordrande_av_1 = mkA "fordrande" ;
  fordring_nn_1 = mkN "fordring" ;
  fordringsaegare_nn_1 = mkN "fordringsдgare" "fordringsдgare" ;
  fordringsfull_av_1 = mkA "fordringsfull" ;
  forell_nn_1 = mkN "forell" "foreller" ;
  form_nn_1 = mkN "form" ;
  form_nn_2 = mkN "form" "former" ;
  formaldehyd_nn_1 = mkN "formaldehyd" "formaldehyder" ;
  formalist_nn_1 = mkN "formalist" "formalister" ;
  formaliter_ab_1 = mkAdv "formaliter" ;
  formalitet_nn_1 = mkN "formalitet" "formaliteter" ;
  formant_nn_1 = mkN "formant" "formanter" ;
  format_nn_1 = mkN "format" neutrum ;
  formation_nn_1 = mkN "formation" "formationer" ;
  formbakelse_nn_1 = mkN "formbakelse" "formbakelser" ;
  formbar_av_1 = mkA "formbar" ;
  formbildning_nn_1 = mkN "formbildning" ;
  formbildningsproblem_nn_1 = mkN "formbildningsproblem" neutrum ;
  formbroed_nn_1 = mkN "formbrцd" neutrum ;
  formbunden_av_1 = mkA "formbunden" "formbundet" ;
  formel_nn_1 = mkN "formel" "formeln" "formler" "formlerna" ;
  formelenhet_nn_1 = mkN "formelenhet" "formelenheter" ;
  formell_av_1 = mkA "formell" ;
  formering_nn_1 = mkN "formering" ;
  formfraaga_nn_1 = mkN "formfrеga" ;
  formfranska_nn_1 = mkN "formfranska" ;
  formge_vb_1 = mkV "formge" "formger" "formge" "formgav" "formgett" "formgiven" ;
  formgivare_nn_1 = mkN "formgivare" "formgivare" ;
  formgivning_nn_1 = mkN "formgivning" ;
  formidabel_av_1 = mkA "formidabel" "formidabelt" "formidabla" "formidabla" "formidablare" "formidablast" "formidablaste" ;
  formlaera_nn_1 = mkN "formlдra" ;
  formlig_av_1 = mkA "formlig" ;
  formligen_ab_1 = mkAdv "formligen" ;
  formloes_av_1 = mkA "formlцs" ;
  formord_nn_1 = mkN "formord" neutrum ;
  formpressning_nn_1 = mkN "formpressning" ;
  formrik_av_1 = mkA "formrik" ;
  formrikedom_nn_1 = mkN "formrikedom" ;
  formsak_nn_1 = mkN "formsak" "formsaker" ;
  formspel_nn_1 = mkN "formspel" "formspelet" "formspel" "formspelen" ;
  formspraak_nn_1 = mkN "formsprеk" neutrum ;
  formulaer_nn_1 = mkN "formulдr" neutrum ;
  formulering_nn_1 = mkN "formulering" ;
  forn_av_1 = mkA "forn" ;
  fornborg_nn_1 = mkN "fornborg" ;
  fornegyptisk_av_1 = mkA "fornegyptisk" ;
  fornfolk_nn_1 = mkN "fornfolk" neutrum ;
  fornfynd_nn_1 = mkN "fornfynd" neutrum ;
  forngrekisk_av_1 = mkA "forngrekisk" ;
  fornislaendsk_av_1 = mkA "fornislдndsk" ;
  fornitaliensk_av_1 = mkA "fornitaliensk" ;
  fornkeltisk_av_1 = mkA "fornkeltisk" ;
  fornlaemning_nn_1 = mkN "fornlдmning" ;
  fornminne_nn_1 = mkN "fornminne" ;
  fornnordisk_av_1 = mkA "fornnordisk" ;
  fornromersk_av_1 = mkA "fornromersk" ;
  fornsvensk_av_1 = mkA "fornsvensk" ;
  forntid_nn_1 = mkN "forntid" "forntider" ;
  forntida_av_1 = mkA "forntida" ;
  fors_nn_1 = mkN "fors" ;
  forshuvud_nn_1 = mkN "forshuvud" "forshuvudet" "forshuvuden" "forshuvudena" ;
  forskarassistent_nn_1 = mkN "forskarassistent" "forskarassistenter" ;
  forskare_nn_1 = mkN "forskare" "forskare" ;
  forskargrupp_nn_1 = mkN "forskargrupp" "forskargrupper" ;
  forskarkonspiration_nn_1 = mkN "forskarkonspiration" "forskarkonspirationer" ;
  forskarlag_nn_1 = mkN "forskarlag" neutrum ;
  forskarledighet_nn_1 = mkN "forskarledighet" "forskarledigheter" ;
  forskning_nn_1 = mkN "forskning" ;
  forskningsfaelt_nn_1 = mkN "forskningsfдlt" neutrum ;
  forskningsfartyg_nn_1 = mkN "forskningsfartyg" neutrum ;
  forskningsinstitut_nn_1 = mkN "forskningsinstitut" neutrum ;
  forskningskompetens_nn_1 = mkN "forskningskompetens" "forskningskompetenser" ;
  forskningslaboratorium_nn_1 = mkN "forskningslaboratorium" "forskningslaboratoriet" "forskningslaboratorier" "forskningslaboratorierna" ;
  forskningsomraade_nn_1 = mkN "forskningsomrеde" ;
  forskningsorganisation_nn_1 = mkN "forskningsorganisation" "forskningsorganisationer" ;
  forskningsprojekt_nn_1 = mkN "forskningsprojekt" neutrum ;
  forskningsraad_nn_1 = mkN "forskningsrеd" neutrum ;
  forskningsresande_nn_1 = mkN "forskningsresande" "forskningsresanden" "forskningsresande" "forskningsresandena" ;
  forskningsresultat_nn_1 = mkN "forskningsresultat" neutrum ;
  forskningsroen_nn_1 = mkN "forskningsrцn" neutrum ;
  forskningsstation_nn_1 = mkN "forskningsstation" "forskningsstationer" ;
  forsraenning_nn_1 = mkN "forsrдnning" ;
  fort_ab_1 = mkAdv "fort" ;
  fort_nn_1 = mkN "fort" neutrum ;
  fortbildning_nn_1 = mkN "fortbildning" ;
  forte_ab_1 = mkAdv "forte" ;
  forte_nn_1 = mkN "forte" ;
  fortel_nn_1 = mkN "fortel" ;
  fortepiano_nn_1 = mkN "fortepiano" "fortepianot" "fortepianon" "fortepianona" ;
  fortfaerdig_av_1 = mkA "fortfдrdig" ;
  fortfarande_ab_1 = mkAdv "fortfarande" ;
  fortgaaende_av_1 = mkA "fortgеende" ;
  fortifikation_nn_1 = mkN "fortifikation" "fortifikationer" ;
  fortifikationsfoervaltning_nn_1 = mkN "fortifikationsfцrvaltning" ;
  fortifikationskaar_nn_1 = mkN "fortifikationskеr" "fortifikationskеrer" ;
  fortis_av_1 = mkA "fortis" ;
  fortissimo_ab_1 = mkAdv "fortissimo" ;
  fortissimo_nn_1 = mkN "fortissimo" "fortissimot" "fortissimon" "fortissimona" ;
  fortkoerning_nn_1 = mkN "fortkцrning" ;
  fortkomst_nn_1 = mkN "fortkomst" "fortkomster" ;
  fortloepande_av_1 = mkA "fortlцpande" ;
  fortplantning_nn_1 = mkN "fortplantning" ;
  fortplantningsdrift_nn_1 = mkN "fortplantningsdrift" "fortplantningsdrifter" ;
  fortplantningsorgan_nn_1 = mkN "fortplantningsorgan" neutrum ;
  fortsaettning_nn_1 = mkN "fortsдttning" ;
  fortsaettningsvis_ab_1 = mkAdv "fortsдttningsvis" ;
  fortskaffningsmedel_nn_1 = mkN "fortskaffningsmedel" neutrum ;
  fortskrida_vb_1 = mkV "fortskrida" "fortskred" "fortskridit" ;
  fortskridande_nn_1 = mkN "fortskridande" ;
  forum_nn_1 = mkN "forum" neutrum ;
  forumtidning_nn_1 = mkN "forumtidning" ;
  forward_nn_1 = mkN "forward" ;
  fosfat_nn_1 = mkN "fosfat" neutrum ;
  fosforescent_av_1 = mkA "fosforescent" "fosforescent" ;
  fosforit_nn_1 = mkN "fosforit" "fosforiter" ;
  fosforsyracell_nn_1 = mkN "fosforsyracell" "fosforsyraceller" ;
  fossil_av_1 = mkA "fossil" ;
  fossil_nn_1 = mkN "fossil" neutrum ;
  fossilfri_av_1 = mkA "fossilfri" "fossilfritt" ;
  fossilfynd_nn_1 = mkN "fossilfynd" neutrum ;
  fossilletare_nn_1 = mkN "fossilletare" "fossilletare" ;
  fossilminskning_nn_1 = mkN "fossilminskning" ;
  fossing_nn_1 = mkN "fossing" ;
  fostbroedralag_nn_1 = mkN "fostbrцdralag" neutrum ;
  foster_nn_1 = mkN "foster" neutrum ;
  fosterbarn_nn_1 = mkN "fosterbarn" neutrum ;
  fosterfoeraelder_nn_1 = mkN "fosterfцrдlder" ;
  fosterfoerdrivning_nn_1 = mkN "fosterfцrdrivning" ;
  fosterhem_nn_1 = mkN "fosterhem" "fosterhemmet" "fosterhem" "fosterhemmen" ;
  fosterhinna_nn_1 = mkN "fosterhinna" ;
  fosterlaege_nn_1 = mkN "fosterlдge" ;
  fosterlaendsk_av_1 = mkA "fosterlдndsk" ;
  fosterland_nn_1 = mkN "fosterland" neutrum ;
  fosterljud_nn_1 = mkN "fosterljud" neutrum ;
  fosterutveckling_nn_1 = mkN "fosterutveckling" ;
  fostervatten_nn_1 = mkN "fostervatten" "fostervattnet" "fostervatten" "fostervattnen" ;
  fostrare_nn_1 = mkN "fostrare" "fostrare" ;
  fot_nn_1 = mkN "fot" "fцtter" ;
  fot_nn_2 = mkN "fot" "foten" "fot" "foten" ;
  fotaenda_nn_1 = mkN "fotдnda" "fotдndan" "fotдndar" "fotдndarna" ;
  fotbad_nn_1 = mkN "fotbad" neutrum ;
  fotbjudning_nn_1 = mkN "fotbjudning" ;
  fotblad_nn_1 = mkN "fotblad" neutrum ;
  fotboll_nn_1 = mkN "fotboll" ;
  fotbollsfoerbund_nn_1 = mkN "fotbollsfцrbund" neutrum ;
  fotbollskedja_nn_1 = mkN "fotbollskedja" ;
  fotbollslag_nn_1 = mkN "fotbollslag" neutrum ;
  fotbollsmaal_nn_1 = mkN "fotbollsmеl" neutrum ;
  fotbollsmatch_nn_1 = mkN "fotbollsmatch" "fotbollsmatcher" ;
  fotbollsplan_nn_1 = mkN "fotbollsplan" "fotbollsplaner" ;
  fotbollsspelare_nn_1 = mkN "fotbollsspelare" "fotbollsspelare" ;
  fotbollstips_nn_1 = mkN "fotbollstips" neutrum ;
  fotbroms_nn_1 = mkN "fotbroms" ;
  fotfel_nn_1 = mkN "fotfel" "fotfelet" "fotfel" "fotfelen" ;
  fotgaengare_nn_1 = mkN "fotgдngare" "fotgдngare" ;
  fotino_nn_1 = mkN "fotino" "fotinon" "fotinos" "fotinosen" ;
  fotknoel_nn_1 = mkN "fotknцl" ;
  fotled_nn_1 = mkN "fotled" "fotleder" ;
  fotnot_nn_1 = mkN "fotnot" "fotnoter" ;
  foto_nn_1 = mkN "foto" "fotot" "foton" "fotona" ;
  fotoautomat_nn_1 = mkN "fotoautomat" "fotoautomater" ;
  fotoblixt_nn_1 = mkN "fotoblixt" ;
  fotocell_nn_1 = mkN "fotocell" "fotoceller" ;
  fotoelektricitet_nn_1 = mkN "fotoelektricitet" "fotoelektriciteter" ;
  fotoelektrisk_av_1 = mkA "fotoelektrisk" ;
  fotogenique_av_1 = mkA "fotogenique" ;
  fotogenisk_av_1 = mkA "fotogenisk" ;
  fotogenkoek_nn_1 = mkN "fotogenkцk" neutrum ;
  fotograf_nn_1 = mkN "fotograf" "fotografer" ;
  fotografering_nn_1 = mkN "fotografering" ;
  fotografi_nn_1 = mkN "fotografi" "fotografit" "fotografier" "fotografierna" ;
  fotografiplaat_nn_1 = mkN "fotografiplеt" ;
  fotografisk_av_1 = mkA "fotografisk" ;
  fotogram_nn_1 = mkN "fotogram" "fotogrammet" "fotogram" "fotogrammen" ;
  fotogrammetrisk_av_1 = mkA "fotogrammetrisk" ;
  fotogravyr_nn_1 = mkN "fotogravyr" "fotogravyrer" ;
  fotokemisk_av_1 = mkA "fotokemisk" ;
  fotokopia_nn_1 = mkN "fotokopia" ;
  fotokopiering_nn_1 = mkN "fotokopiering" ;
  fotometer_nn_1 = mkN "fotometer" ;
  fotomodell_nn_1 = mkN "fotomodell" "fotomodeller" ;
  fotomontage_nn_1 = mkN "fotomontage" "fotomontaget" "fotomontage" "fotomontagen" ;
  foton_nn_1 = mkN "foton" "fotoner" ;
  fotoresistor_nn_1 = mkN "fotoresistor" "fotoresistorer" ;
  fotosaettning_nn_1 = mkN "fotosдttning" ;
  fotostatkopia_nn_1 = mkN "fotostatkopia" ;
  fotostatkopiering_nn_1 = mkN "fotostatkopiering" ;
  fotosyntes_nn_1 = mkN "fotosyntes" "fotosynteser" ;
  fotriktig_av_1 = mkA "fotriktig" ;
  fotsack_nn_1 = mkN "fotsack" ;
  fotsid_av_1 = mkA "fotsid" ;
  fotspaar_nn_1 = mkN "fotspеr" neutrum ;
  fotsteg_nn_1 = mkN "fotsteg" neutrum ;
  fotstoed_nn_1 = mkN "fotstцd" neutrum ;
  fotvaenlig_av_1 = mkA "fotvдnlig" ;
  fotvalv_nn_1 = mkN "fotvalv" neutrum ;
  fotvandring_nn_1 = mkN "fotvandring" ;
  foul_nn_1 = mkN "foul" "fouler" ;
  foxterrier_nn_1 = mkN "foxterrier" "foxterriern" "foxterrier" "foxterrierna" ;
  foxtrot_nn_1 = mkN "foxtrot" "foxtroter" ;
  foyer_nn_1 = mkN "foyer" "foyern" "foyerer" "foyererna" ;
  fraaga_nn_1 = mkN "frеga" ;
  fraageform_nn_1 = mkN "frеgeform" "frеgeformer" ;
  fraageformulaer_nn_1 = mkN "frеgeformulдr" neutrum ;
  fraageord_nn_1 = mkN "frеgeord" neutrum ;
  fraagesats_nn_1 = mkN "frеgesats" "frеgesatser" ;
  fraagespalt_nn_1 = mkN "frеgespalt" "frеgespalter" ;
  fraagesport_nn_1 = mkN "frеgesport" "frеgesporter" ;
  fraagestaellare_nn_1 = mkN "frеgestдllare" "frеgestдllare" ;
  fraagestaellning_nn_1 = mkN "frеgestдllning" ;
  fraagestund_nn_1 = mkN "frеgestund" "frеgestunder" ;
  fraagetaevling_nn_1 = mkN "frеgetдvling" ;
  fraagetecken_nn_1 = mkN "frеgetecken" "frеgetecknet" "frеgetecken" "frеgetecknen" ;
  fraagvis_av_1 = mkA "frеgvis" ;
  fraanlandsvind_nn_1 = mkN "frеnlandsvind" ;
  fraansida_nn_1 = mkN "frеnsida" ;
  fraanskild_av_1 = mkA "frеnskild" "frеnskilt" ;
  fraanskiljare_nn_1 = mkN "frеnskiljare" "frеnskiljare" ;
  fraanstoetande_av_1 = mkA "frеnstцtande" ;
  fraanta_vb_1 = mkV "frеnta" "frеntar" "frеnta" "frеntog" "frеntagit" "frеntagen" ;
  fraanvarande_av_1 = mkA "frеnvarande" ;
  frack_nn_1 = mkN "frack" ;
  fradgig_av_1 = mkA "fradgig" ;
  fraeck_av_1 = mkA "frдck" ;
  fraeckhet_nn_1 = mkN "frдckhet" "frдckheter" ;
  fraeckis_nn_1 = mkN "frдckis" ;
  fraeken_nn_1 = mkN "frдken" "frдkenn" "frдknar" "frдknarna" ;
  fraekne_nn_1 = mkN "frдkne" utrum ;
  fraeknig_av_1 = mkA "frдknig" ;
  fraelsare_nn_1 = mkN "frдlsare" "frдlsare" ;
  fraelsarkrans_nn_1 = mkN "frдlsarkrans" ;
  fraelse_av_1 = mkA "frдlse" ;
  fraelsebonde_nn_1 = mkN "frдlsebonde" "frдlsebцnder" ;
  fraelsejord_nn_1 = mkN "frдlsejord" ;
  fraelsningsmoete_nn_1 = mkN "frдlsningsmцte" ;
  fraelsningssoldat_nn_1 = mkN "frдlsningssoldat" "frдlsningssoldater" ;
  fraelst_av_1 = mkA "frдlst" "frдlst" ;
  fraemling_nn_1 = mkN "frдmling" ;
  fraemlingslegion_nn_1 = mkN "frдmlingslegion" "frдmlingslegioner" ;
  fraemlingslegionaer_nn_1 = mkN "frдmlingslegionдr" "frдmlingslegionдrer" ;
  fraemlingspass_nn_1 = mkN "frдmlingspass" neutrum ;
  fraemmande_av_1 = mkA "frдmmande" ;
  fraemmande_nn_1 = mkN "frдmmande" ;
  fraemmat_av_1 = mkA "frдmmat" ;
  fraemre_av_1 = mkA "frдmre" ;
  fraen_av_1 = mkA "frдn" ;
  fraende_nn_1 = mkN "frдnde" "frдnder" ;
  fraendskap_nn_1 = mkN "frдndskap" "frдndskaper" ;
  fraes_nn_1 = mkN "frдs" ;
  fraesch_av_1 = mkA "frдsch" ;
  fraesig_av_1 = mkA "frдsig" ;
  fraesmaskin_nn_1 = mkN "frдsmaskin" "frдsmaskiner" ;
  fragil_av_1 = mkA "fragil" ;
  fragment_nn_1 = mkN "fragment" neutrum ;
  fragmentarisk_av_1 = mkA "fragmentarisk" ;
  frakt_nn_1 = mkN "frakt" "frakter" ;
  fraktal_av_1 = mkA "fraktal" ;
  fraktavtal_nn_1 = mkN "fraktavtal" "fraktavtalet" "fraktavtalen" "fraktavtalena" ;
  fraktion_nn_1 = mkN "fraktion" "fraktioner" ;
  fraktsats_nn_1 = mkN "fraktsats" "fraktsatser" ;
  fraktsedel_nn_1 = mkN "fraktsedel" ;
  fraktur_nn_2 = mkN "fraktur" "frakturer" ;
  fram_ab_1 = mkAdv "fram" ;
  framaat_ab_1 = mkAdv "framеt" ;
  framaenda_nn_1 = mkN "framдnda" "framдndan" "framдndar" "framдndarna" ;
  framaxel_nn_1 = mkN "framaxel" ;
  frambaera_vb_1 = mkV "frambдra" "frambar" "framburit" ;
  framben_nn_1 = mkN "framben" neutrum ;
  frambesvaerja_vb_1 = mkV "frambesvдrja" "frambesvдrjer" "frambesvдrj" "frambesvor" "frambesvurit" "frambesvдrjd" ;
  frambryta_vb_1 = mkV "frambryta" "frambrцt" "frambrutit" ;
  framdel_nn_1 = mkN "framdel" "framdelen" "framdelar" "framdelarna" ;
  framdeles_ab_1 = mkAdv "framdeles" ;
  framdriva_vb_1 = mkV "framdriva" "framdrev" "framdrivit" ;
  framfaerd_nn_1 = mkN "framfдrd" "framfдrder" ;
  framfall_nn_1 = mkN "framfall" neutrum ;
  framfara_vb_1 = mkV "framfara" "framfor" "framfarit" ;
  framfoer_ab_1 = mkAdv "framfцr" ;
  framfoerallt_ab_1 = mkAdv "framfцrallt" ;
  framfoerande_nn_1 = mkN "framfцrande" ;
  framfoerhaallning_nn_1 = mkN "framfцrhеllning" ;
  framfoervarande_av_1 = mkA "framfцrvarande" ;
  framfot_nn_1 = mkN "framfot" "framfцtter" ;
  framfusig_av_1 = mkA "framfusig" ;
  framgaa_vb_1 = mkV "framgе" "framgеr" "framgе" "framgick" "framgеtt" "framgеngen" ;
  framgaang_nn_1 = mkN "framgеng" ;
  framgaangsrik_av_1 = mkA "framgеngsrik" ;
  framgaffel_nn_1 = mkN "framgaffel" ;
  framgent_ab_1 = mkAdv "framgent" ;
  framhaalla_vb_1 = mkV "framhеlla" "framhцll" "framhеllit" ;
  framhjul_nn_1 = mkN "framhjul" neutrum ;
  framhjulsdriven_av_1 = mkA "framhjulsdriven" "framhjulsdrivet" ;
  framifraan_ab_1 = mkAdv "framifrеn" ;
  framkallare_nn_1 = mkN "framkallare" "framkallare" ;
  framkallning_nn_1 = mkN "framkallning" ;
  framkant_nn_1 = mkN "framkant" "framkanter" ;
  framkoerning_nn_1 = mkN "framkцrning" ;
  framkomlig_av_1 = mkA "framkomlig" ;
  framkomlighet_nn_1 = mkN "framkomlighet" "framkomligheter" ;
  framkomma_vb_1 = mkV "framkomma" "framkom" "framkommit" ;
  framladdare_nn_1 = mkN "framladdare" "framladdare" ;
  framladdning_nn_1 = mkN "framladdning" ;
  framlaenges_ab_1 = mkAdv "framlдnges" ;
  framlida_vb_1 = mkV "framlida" "framled" "framlidit" ;
  framliden_av_1 = mkA "framliden" "framlidet" ;
  framlob_nn_1 = mkN "framlob" "framlober" ;
  frammarsch_nn_1 = mkN "frammarsch" "frammarscher" ;
  framme_ab_1 = mkAdv "framme" ;
  framoever_ab_1 = mkAdv "framцver" ;
  frampaa_ab_1 = mkAdv "frampе" ;
  framryckning_nn_1 = mkN "framryckning" ;
  framsaete_nn_1 = mkN "framsдte" ;
  framsida_nn_1 = mkN "framsida" ;
  framskjuta_vb_1 = mkV "framskjuta" "framskцt" "framskjutit" ;
  framskjutande_av_1 = mkA "framskjutande" ;
  framskjuten_av_1 = mkA "framskjuten" "framskjutet" ;
  framskrida_vb_1 = mkV "framskrida" "framskred" "framskridit" ;
  framskriden_av_1 = mkA "framskriden" "framskridet" ;
  framspelare_nn_1 = mkN "framspelare" "framspelare" ;
  framspelning_nn_1 = mkN "framspelning" ;
  framstaaende_av_1 = mkA "framstеende" ;
  framstaellan_nn_1 = mkN "framstдllan" "framstдllan" "framstдllningar" "framstдllningarna" ;
  framstaellning_nn_1 = mkN "framstдllning" ;
  framstam_nn_1 = mkN "framstam" "framstammen" "framstammar" "framstammarna" ;
  framsteg_nn_1 = mkN "framsteg" neutrum ;
  framstegsparti_nn_1 = mkN "framstegsparti" "framstegspartit" "framstegspartier" "framstegspartierna" ;
  framstegsvaenlig_av_1 = mkA "framstegsvдnlig" ;
  framstoet_nn_1 = mkN "framstцt" ;
  framstupa_ab_1 = mkAdv "framstupa" ;
  framsynt_av_1 = mkA "framsynt" "framsynt" ;
  framtand_nn_1 = mkN "framtand" "framtдnder" ;
  framtid_nn_1 = mkN "framtid" "framtider" ;
  framtida_av_1 = mkA "framtida" ;
  framtidsforskning_nn_1 = mkN "framtidsforskning" ;
  framtidsloefte_nn_1 = mkN "framtidslцfte" ;
  framtidsman_nn_1 = mkN "framtidsman" "framtidsmannen" "framtidsmдn" "framtidsmдnnen" ;
  framtidsversion_nn_1 = mkN "framtidsversion" "framtidsversioner" ;
  framtidsvision_nn_1 = mkN "framtidsvision" "framtidsvisioner" ;
  framtidsvy_nn_1 = mkN "framtidsvy" "framtidsvyer" ;
  framtill_ab_1 = mkAdv "framtill" ;
  framtoning_nn_1 = mkN "framtoning" ;
  framtraedande_av_1 = mkA "framtrдdande" ;
  framtraedande_nn_1 = mkN "framtrдdande" ;
  framtraengande_av_1 = mkA "framtrдngande" ;
  framtung_av_1 = mkA "framtung" ;
  framtvinga_vb_1 = mkV "framtvinga" ;
  framvagn_nn_1 = mkN "framvagn" ;
  franc_nn_1 = mkN "franc" "francen" "franc" "francen" ;
  franciskan_nn_1 = mkN "franciskan" "franciskaner" ;
  franciskanerkloster_nn_1 = mkN "franciskanerkloster" neutrum ;
  franciskanermunk_nn_1 = mkN "franciskanermunk" ;
  franciskanerorden_nn_1 = mkN "franciskanerorden" ;
  frank_av_1 = mkA "frank" ;
  frank_nn_1 = mkN "frank" "franker" ;
  franko_ab_1 = mkAdv "franko" ;
  frankostaempel_nn_1 = mkN "frankostдmpel" ;
  frankotecken_nn_1 = mkN "frankotecken" "frankotecknet" "frankotecken" "frankotecknen" ;
  frans_nn_1 = mkN "frans" ;
  fransaes_nn_1 = mkN "fransдs" "fransдser" ;
  fransig_av_1 = mkA "fransig" ;
  fransk_av_1 = mkA "fransk" ;
  franska_nn_2 = mkN "franska" ;
  franskbroed_nn_1 = mkN "franskbrцd" neutrum ;
  franskklassisk_av_1 = mkA "franskklassisk" ;
  fransman_nn_1 = mkN "fransman" "fransmannen" "fransmдn" "fransmдnnen" ;
  fransos_nn_1 = mkN "fransos" "fransoser" ;
  fransyska_nn_1 = mkN "fransyska" ;
  frappant_av_1 = mkA "frappant" "frappant" ;
  frapperande_av_1 = mkA "frapperande" ;
  fras_nn_1 = mkN "fras" "fraser" ;
  fraseologisk_av_1 = mkA "fraseologisk" ;
  frasering_nn_1 = mkN "frasering" ;
  frasig_av_1 = mkA "frasig" ;
  frasliberal_av_1 = mkA "frasliberal" ;
  frasliberal_nn_1 = mkN "frasliberal" "frasliberaler" ;
  frasmakare_nn_1 = mkN "frasmakare" "frasmakare" ;
  frasradikal_av_1 = mkA "frasradikal" ;
  frasradikal_nn_1 = mkN "frasradikal" "frasradikaler" ;
  frasvaaffla_nn_1 = mkN "frasvеffla" ;
  freak_nn_1 = mkN "freak" ;
  fred_nn_1 = mkN "fred" "freder" ;
  fredag_nn_1 = mkN "fredag" ;
  fredagsboers_nn_1 = mkN "fredagsbцrs" "fredagsbцrser" ;
  fredagskvaell_nn_1 = mkN "fredagskvдll" ;
  fredagsmorgon_nn_1 = mkN "fredagsmorgon" "fredagsmorgonen" "fredagsmorgnar" "fredagsmorgnarna" ;
  fredlig_av_1 = mkA "fredlig" ;
  fredloes_av_1 = mkA "fredlцs" ;
  fredsbevarande_av_1 = mkA "fredsbevarande" ;
  fredsdomare_nn_1 = mkN "fredsdomare" "fredsdomare" ;
  fredsdomstol_nn_1 = mkN "fredsdomstol" ;
  fredsfoerdrag_nn_1 = mkN "fredsfцrdrag" neutrum ;
  fredsfoerhandling_nn_1 = mkN "fredsfцrhandling" ;
  fredsforskning_nn_1 = mkN "fredsforskning" ;
  fredskaar_nn_1 = mkN "fredskеr" "fredskеrer" ;
  fredskonferens_nn_1 = mkN "fredskonferens" "fredskonferenser" ;
  fredsmaeklare_nn_1 = mkN "fredsmдklare" "fredsmдklare" ;
  fredspris_nn_1 = mkN "fredspris" neutrum ;
  fredsroerelse_nn_1 = mkN "fredsrцrelse" "fredsrцrelser" ;
  fredsslut_nn_1 = mkN "fredsslut" neutrum ;
  fredsstraevande_nn_1 = mkN "fredsstrдvande" ;
  fredstid_nn_1 = mkN "fredstid" "fredstider" ;
  fredstida_av_1 = mkA "fredstida" ;
  free_style_nn_1 = mkN "free-style" "free-stylen" "free-styles" "free-stylesen" ;
  fregatt_nn_1 = mkN "fregatt" "fregatter" ;
  fregattfaagel_nn_1 = mkN "fregattfеgel" ;
  frejdig_av_1 = mkA "frejdig" ;
  frekvens_nn_1 = mkN "frekvens" "frekvenser" ;
  frekvensband_nn_1 = mkN "frekvensband" neutrum ;
  frekvensmodulering_nn_1 = mkN "frekvensmodulering" ;
  frekvensomraade_nn_1 = mkN "frekvensomrеde" ;
  frekvent_av_1 = mkA "frekvent" "frekvent" ;
  frenetisk_av_1 = mkA "frenetisk" ;
  frenologisk_av_1 = mkA "frenologisk" ;
  freon_nn_1 = mkN "freon" "freoner" ;
  fresk_nn_1 = mkN "fresk" "fresker" ;
  freskomaalning_nn_1 = mkN "freskomеlning" ;
  frestande_av_1 = mkA "frestande" ;
  frestare_nn_1 = mkN "frestare" "frestare" ;
  frestelse_nn_1 = mkN "frestelse" "frestelser" ;
  fri_av_1 = mkA "fri" "fritt" ;
  friaakning_nn_1 = mkN "friеkning" ;
  friare_nn_1 = mkN "friare" "friare" ;
  fribaerande_av_1 = mkA "fribдrande" ;
  fribiljett_nn_1 = mkN "fribiljett" "fribiljetter" ;
  fribladig_av_1 = mkA "fribladig" ;
  fribonde_nn_1 = mkN "fribonde" "fribцnder" ;
  fribord_nn_1 = mkN "fribord" neutrum ;
  friboren_av_1 = mkA "friboren" "friboret" ;
  fribrev_nn_1 = mkN "fribrev" neutrum ;
  fribrottare_nn_1 = mkN "fribrottare" "fribrottare" ;
  fribytare_nn_1 = mkN "fribytare" "fribytare" ;
  fribyteri_nn_1 = mkN "fribyteri" "fribyterit" "fribyterier" "fribyterierna" ;
  fridag_nn_1 = mkN "fridag" ;
  fridfull_av_1 = mkA "fridfull" ;
  fridlysning_nn_1 = mkN "fridlysning" ;
  fridsam_av_1 = mkA "fridsam" "fridsamt" "fridsamma" "fridsamma" "fridsammare" "fridsammast" "fridsammaste" ;
  frieri_nn_1 = mkN "frieri" "frierit" "frierier" "frierierna" ;
  frifraesare_nn_1 = mkN "frifrдsare" "frifrдsare" ;
  frifraesig_av_1 = mkA "frifrдsig" ;
  frigaaende_av_1 = mkA "frigеende" ;
  frige_vb_1 = mkV "frige" "friger" "frige" "frigav" "frigett" "frigiven" ;
  friggebod_nn_1 = mkN "friggebod" ;
  frigiditet_nn_1 = mkN "frigiditet" "frigiditeter" ;
  frigivning_nn_1 = mkN "frigivning" ;
  frigjord_av_1 = mkA "frigjord" "frigjort" ;
  frigjordhet_nn_1 = mkN "frigjordhet" "frigjordheter" ;
  frihamn_nn_1 = mkN "frihamn" ;
  frihandelsomraade_nn_1 = mkN "frihandelsomrеde" ;
  frihandsteckning_nn_1 = mkN "frihandsteckning" ;
  friherre_nn_1 = mkN "friherre" utrum ;
  frihet_nn_1 = mkN "frihet" "friheter" ;
  frihetlig_av_1 = mkA "frihetlig" ;
  frihetsberoevande_nn_1 = mkN "frihetsberцvande" ;
  frihetsgrad_nn_1 = mkN "frihetsgrad" "frihetsgrader" ;
  frihetshjaelte_nn_1 = mkN "frihetshjдlte" utrum ;
  frihetskamp_nn_1 = mkN "frihetskamp" "frihetskamper" ;
  frihetskrig_nn_1 = mkN "frihetskrig" neutrum ;
  frihetsstraff_nn_1 = mkN "frihetsstraff" neutrum ;
  frihjul_nn_1 = mkN "frihjul" neutrum ;
  friholt_nn_1 = mkN "friholt" ;
  friidrott_nn_1 = mkN "friidrott" "friidrotter" ;
  frikaar_nn_1 = mkN "frikеr" "frikеrer" ;
  frikadell_nn_1 = mkN "frikadell" "frikadeller" ;
  frikaennande_nn_1 = mkN "frikдnnande" ;
  frikasse_nn_1 = mkN "frikassй" "frikassйer" ;
  frikast_nn_1 = mkN "frikast" neutrum ;
  frikativ_av_1 = mkA "frikativ" ;
  frikoep_nn_1 = mkN "frikцp" neutrum ;
  frikoppling_nn_1 = mkN "frikoppling" ;
  frikort_nn_1 = mkN "frikort" neutrum ;
  frikostig_av_1 = mkA "frikostig" ;
  frikrets_nn_1 = mkN "frikrets" ;
  friktion_nn_1 = mkN "friktion" "friktioner" ;
  friktionsfri_av_1 = mkA "friktionsfri" "friktionsfritt" ;
  friktionskoefficient_nn_1 = mkN "friktionskoefficient" "friktionskoefficienter" ;
  friktionstal_nn_1 = mkN "friktionstal" "friktionstalet" "friktionstalen" "friktionstalena" ;
  frikyrka_nn_1 = mkN "frikyrka" ;
  frikyrklig_av_1 = mkA "frikyrklig" ;
  frikyrklighet_nn_1 = mkN "frikyrklighet" "frikyrkligheter" ;
  friland_nn_1 = mkN "friland" neutrum ;
  frilans_nn_1 = mkN "frilans" ;
  frilansare_nn_1 = mkN "frilansare" "frilansare" ;
  frilevande_av_1 = mkA "frilevande" ;
  friluftsaendamaal_nn_1 = mkN "friluftsдndamеl" neutrum ;
  friluftsbad_nn_1 = mkN "friluftsbad" neutrum ;
  friluftsdag_nn_1 = mkN "friluftsdag" ;
  friluftsmiljoe_nn_1 = mkN "friluftsmiljц" "friluftsmiljцn" "friluftsmiljцer" "friluftsmiljцerna" ;
  friluftsmuseum_nn_1 = mkN "friluftsmuseum" "friluftsmuseet" "friluftsmuseer" "friluftsmuseerna" ;
  friluftsomraade_nn_1 = mkN "friluftsomrеde" ;
  friluftsskog_nn_1 = mkN "friluftsskog" ;
  friluftsvana_nn_1 = mkN "friluftsvana" ;
  frimaerkssamling_nn_1 = mkN "frimдrkssamling" ;
  frimickel_nn_1 = mkN "frimickel" ;
  frimodig_av_1 = mkA "frimodig" ;
  frimurare_nn_1 = mkN "frimurare" "frimurare" ;
  frimurarloge_nn_1 = mkN "frimurarloge" "frimurarloger" ;
  frimurarorden_nn_1 = mkN "frimurarorden" ;
  fripassagerare_nn_1 = mkN "fripassagerare" "fripassagerare" ;
  friplaat_nn_1 = mkN "friplеt" ;
  frireligioes_av_1 = mkA "frireligiцs" ;
  fris_1_nn_1 = mkN "fris" "friser" ;
  fris_2_nn_1 = mkN "fris" "friser" ;
  frisbee_nn_1 = mkN "frisbee" "frisbeen" "frisbeear" "frisbeearna" ;
  frisedel_nn_1 = mkN "frisedel" ;
  frisersalong_nn_1 = mkN "frisersalong" "frisersalonger" ;
  frisisk_av_1 = mkA "frisisk" ;
  frisiska_nn_2 = mkN "frisiska" ;
  frisk_av_1 = mkA "frisk" ;
  friskhet_nn_1 = mkN "friskhet" "friskheter" ;
  friskintyg_nn_1 = mkN "friskintyg" neutrum ;
  friskluftsintag_nn_1 = mkN "friskluftsintag" neutrum ;
  friskriven_av_1 = mkA "friskriven" "friskrivet" ;
  friskrivning_nn_1 = mkN "friskrivning" ;
  friskskriva_vb_1 = mkV "friskskriva" "friskskrev" "friskskrivit" ;
  friskus_nn_1 = mkN "friskus" ;
  frislag_nn_1 = mkN "frislag" neutrum ;
  frisoer_nn_1 = mkN "frisцr" "frisцrer" ;
  frisoerska_nn_1 = mkN "frisцrska" ;
  frispark_nn_1 = mkN "frispark" ;
  frispraakig_av_1 = mkA "frisprеkig" ;
  frist_nn_1 = mkN "frist" "frister" ;
  fristaaende_av_1 = mkA "fristеende" ;
  fristad_nn_1 = mkN "fristad" "fristдder" ;
  fristat_nn_1 = mkN "fristat" "fristater" ;
  frisyr_nn_1 = mkN "frisyr" "frisyrer" ;
  frisyrgele_nn_1 = mkN "frisyrgelй" "frisyrgelйer" ;
  frita_vb_1 = mkV "frita" "fritar" "frita" "fritog" "fritagit" "fritagen" ;
  fritaenkare_nn_1 = mkN "fritдnkare" "fritдnkare" ;
  fritagning_nn_1 = mkN "fritagning" ;
  fritidsaktivitet_nn_1 = mkN "fritidsaktivitet" "fritidsaktiviteter" ;
  fritidsbaat_nn_1 = mkN "fritidsbеt" ;
  fritidsbebyggelse_nn_1 = mkN "fritidsbebyggelse" "fritidsbebyggelser" ;
  fritidsby_nn_1 = mkN "fritidsby" "fritidsbyn" "fritidsbyar" "fritidsbyarna" ;
  fritidsfoervaltning_nn_1 = mkN "fritidsfцrvaltning" ;
  fritidsgaard_nn_1 = mkN "fritidsgеrd" ;
  fritidshem_nn_1 = mkN "fritidshem" "fritidshemmet" "fritidshem" "fritidshemmen" ;
  fritidshus_nn_1 = mkN "fritidshus" neutrum ;
  fritidsledare_nn_1 = mkN "fritidsledare" "fritidsledare" ;
  fritidslokal_nn_1 = mkN "fritidslokal" "fritidslokaler" ;
  fritidsnaemnd_nn_1 = mkN "fritidsnдmnd" "fritidsnдmnder" ;
  fritidsomraade_nn_1 = mkN "fritidsomrеde" ;
  fritidspedagog_nn_1 = mkN "fritidspedagog" "fritidspedagoger" ;
  fritidsproblem_nn_1 = mkN "fritidsproblem" neutrum ;
  fritidsstuga_nn_1 = mkN "fritidsstuga" ;
  fritidssysselsaettning_nn_1 = mkN "fritidssysselsдttning" ;
  fritis_nn_1 = mkN "fritis" neutrum ;
  frityr_nn_1 = mkN "frityr" "frityrer" ;
  frivakt_nn_1 = mkN "frivakt" "frivakter" ;
  frivillig_av_1 = mkA "frivillig" ;
  frivillighet_nn_1 = mkN "frivillighet" "frivilligheter" ;
  frivol_av_1 = mkA "frivol" ;
  frivolitet_nn_1 = mkN "frivolitet" "frivoliteter" ;
  frivolt_nn_1 = mkN "frivolt" "frivolter" ;
  frodig_av_1 = mkA "frodig" ;
  froe_nn_1 = mkN "frц" "frцet" "frцer" "frцerna" ;
  froeaemne_nn_1 = mkN "frцдmne" ;
  froehus_nn_1 = mkN "frцhus" neutrum ;
  froejd_nn_1 = mkN "frцjd" "frцjder" ;
  froejdefull_av_1 = mkA "frцjdefull" ;
  froeken_nn_1 = mkN "frцken" ;
  froeodling_nn_1 = mkN "frцodling" ;
  froeplantage_nn_1 = mkN "frцplantage" "frцplantager" ;
  froeskal_nn_1 = mkN "frцskal" neutrum ;
  froetraed_nn_1 = mkN "frцtrдd" neutrum ;
  froevaext_nn_1 = mkN "frцvдxt" "frцvдxter" ;
  from_av_1 = mkA "from" "fromt" "fromma" "fromma" "frommare" "frommast" "frommaste" ;
  fromage_nn_1 = mkN "fromage" "fromager" ;
  fromhet_nn_1 = mkN "fromhet" "fromheter" ;
  fromsint_av_1 = mkA "fromsint" "fromsint" ;
  frondoer_nn_1 = mkN "frondцr" "frondцrer" ;
  front_nn_1 = mkN "front" "fronter" ;
  frontal_av_1 = mkA "frontal" ;
  frontalangrepp_nn_1 = mkN "frontalangrepp" neutrum ;
  frontalkrock_nn_1 = mkN "frontalkrock" ;
  frontallob_nn_1 = mkN "frontallob" "frontallober" ;
  frontavsnitt_nn_1 = mkN "frontavsnitt" neutrum ;
  frontbildning_nn_1 = mkN "frontbildning" ;
  frontespis_nn_1 = mkN "frontespis" "frontespiser" ;
  frontfoerbindelse_nn_1 = mkN "frontfцrbindelse" "frontfцrbindelser" ;
  frontlinje_nn_1 = mkN "frontlinje" "frontlinjer" ;
  fronton_nn_1 = mkN "fronton" "frontoner" ;
  frontsoldat_nn_1 = mkN "frontsoldat" "frontsoldater" ;
  frontzon_nn_1 = mkN "frontzon" "frontzoner" ;
  frosch_nn_1 = mkN "frosch" "froscher" ;
  frossare_nn_1 = mkN "frossare" "frossare" ;
  frossbrytning_nn_1 = mkN "frossbrytning" ;
  frostbiten_av_1 = mkA "frostbiten" "frostbitet" ;
  frostfjaeril_nn_1 = mkN "frostfjдril" ;
  frostfri_av_1 = mkA "frostfri" "frostfritt" ;
  frosthaerdig_av_1 = mkA "frosthдrdig" ;
  frosthaerdighet_nn_1 = mkN "frosthдrdighet" "frosthдrdigheter" ;
  frostig_av_1 = mkA "frostig" ;
  frostkaenslig_av_1 = mkA "frostkдnslig" ;
  frostkaenslighet_nn_1 = mkN "frostkдnslighet" "frostkдnsligheter" ;
  frostnatt_nn_1 = mkN "frostnatt" "frostnдtter" ;
  frostskyddsvaetska_nn_1 = mkN "frostskyddsvдtska" ;
  frostspraengning_nn_1 = mkN "frostsprдngning" ;
  frosttaalig_av_1 = mkA "frosttеlig" ;
  frotte_nn_1 = mkN "frottй" "frottйer" ;
  fru_nn_1 = mkN "fru" ;
  frugal_av_1 = mkA "frugal" ;
  frukost_nn_1 = mkN "frukost" ;
  frukostmiddag_nn_1 = mkN "frukostmiddag" ;
  frukostrast_nn_1 = mkN "frukostrast" "frukostraster" ;
  frukt_nn_1 = mkN "frukt" "frukter" ;
  fruktaemne_nn_1 = mkN "fruktдmne" ;
  fruktaffaer_nn_1 = mkN "fruktaffдr" "fruktaffдrer" ;
  fruktansvaerd_av_1 = mkA "fruktansvдrd" "fruktansvдrt" ;
  fruktbaerande_av_1 = mkA "fruktbдrande" ;
  fruktbar_av_1 = mkA "fruktbar" ;
  fruktbarhet_nn_1 = mkN "fruktbarhet" "fruktbarheter" ;
  fruktbarhetsgud_nn_1 = mkN "fruktbarhetsgud" ;
  fruktbringande_av_1 = mkA "fruktbringande" ;
  fruktig_av_1 = mkA "fruktig" ;
  fruktkniv_nn_1 = mkN "fruktkniv" ;
  fruktkompott_nn_1 = mkN "fruktkompott" "fruktkompotter" ;
  fruktliknande_av_1 = mkA "fruktliknande" ;
  fruktloes_av_1 = mkA "fruktlцs" ;
  fruktodlare_nn_1 = mkN "fruktodlare" "fruktodlare" ;
  fruktodling_nn_1 = mkN "fruktodling" ;
  fruktsallad_nn_1 = mkN "fruktsallad" "fruktsallader" ;
  fruktsam_av_1 = mkA "fruktsam" "fruktsamt" "fruktsamma" "fruktsamma" "fruktsammare" "fruktsammast" "fruktsammaste" ;
  fruktsporre_nn_1 = mkN "fruktsporre" utrum ;
  frukttraed_nn_1 = mkN "frukttrдd" neutrum ;
  frukttraedgaard_nn_1 = mkN "frukttrдdgеrd" ;
  fruktvaegg_nn_1 = mkN "fruktvдgg" ;
  fruntimmer_nn_1 = mkN "fruntimmer" neutrum ;
  fruntimmerskarl_nn_1 = mkN "fruntimmerskarl" ;
  frusen_av_1 = mkA "frusen" "fruset" ;
  frustration_nn_1 = mkN "frustration" "frustrationer" ;
  fryntlig_av_1 = mkA "fryntlig" ;
  frys_nn_1 = mkN "frys" ;
  frysbox_nn_1 = mkN "frysbox" ;
  frysdisk_nn_1 = mkN "frysdisk" ;
  fryseri_nn_1 = mkN "fryseri" "fryserit" "fryserier" "fryserierna" ;
  frysfack_nn_1 = mkN "frysfack" neutrum ;
  frysfoersoek_nn_1 = mkN "frysfцrsцk" neutrum ;
  fryspunkt_nn_1 = mkN "fryspunkt" "fryspunkter" ;
  fryst_av_1 = mkA "fryst" "fryst" ;
  frystaalig_av_1 = mkA "frystеlig" ;
  frystest_nn_1 = mkN "frystest" neutrum ;
  fuffens_nn_1 = mkN "fuffens" neutrum ;
  fuktig_av_1 = mkA "fuktig" ;
  fuktighet_nn_1 = mkN "fuktighet" "fuktigheter" ;
  ful_av_1 = mkA "ful" ;
  fuling_nn_1 = mkN "fuling" ;
  full_av_1 = mkA "full" ;
  fullblod_nn_1 = mkN "fullblod" neutrum ;
  fullgaangen_av_1 = mkA "fullgеngen" "fullgеnget" ;
  fullgod_av_1 = mkA "fullgod" ;
  fullkomlig_av_1 = mkA "fullkomlig" ;
  fullkornsbroed_nn_1 = mkN "fullkornsbrцd" neutrum ;
  fullmaane_nn_1 = mkN "fullmеne" utrum ;
  fullmaektig_nn_1 = mkN "fullmдktig" "fullmдktigen" "fullmдktige" "fullmдktigena" ;
  fullmakt_nn_1 = mkN "fullmakt" "fullmakter" ;
  fullmaktslag_nn_1 = mkN "fullmaktslag" ;
  fullmogen_av_1 = mkA "fullmogen" "fullmoget" ;
  fulloedig_av_1 = mkA "fullцdig" ;
  fullriggare_nn_1 = mkN "fullriggare" "fullriggare" ;
  fullsatt_av_1 = mkA "fullsatt" ;
  fullstaemmig_av_1 = mkA "fullstдmmig" ;
  fullstaendig_av_1 = mkA "fullstдndig" ;
  fullstaendighet_nn_1 = mkN "fullstдndighet" "fullstдndigheter" ;
  fulltalig_av_1 = mkA "fulltalig" ;
  fulltonig_av_1 = mkA "fulltonig" ;
  fulltraeff_nn_1 = mkN "fulltrдff" ;
  fullvaerdesfoersaekring_nn_1 = mkN "fullvдrdesfцrsдkring" ;
  fullvaerdig_av_1 = mkA "fullvдrdig" ;
  fullvuxen_av_1 = mkA "fullvuxen" "fullvuxet" ;
  fulsnygg_av_1 = mkA "fulsnygg" ;
  fumlig_av_1 = mkA "fumlig" ;
  fundament_nn_1 = mkN "fundament" neutrum ;
  fundamental_av_1 = mkA "fundamental" ;
  fundamentalist_nn_1 = mkN "fundamentalist" "fundamentalister" ;
  funderare_nn_1 = mkN "funderare" "funderare" ;
  fundering_nn_1 = mkN "fundering" ;
  fundersam_av_1 = mkA "fundersam" "fundersamt" "fundersamma" "fundersamma" "fundersammare" "fundersammast" "fundersammaste" ;
  funktion_nn_1 = mkN "funktion" "funktioner" ;
  funktionaer_nn_1 = mkN "funktionдr" "funktionдrer" ;
  funktionalist_nn_1 = mkN "funktionalist" "funktionalister" ;
  funktionalistisk_av_1 = mkA "funktionalistisk" ;
  funktionell_av_1 = mkA "funktionell" ;
  funktionsduglig_av_1 = mkA "funktionsduglig" ;
  funktionsvaerde_nn_1 = mkN "funktionsvдrde" ;
  furie_nn_1 = mkN "furie" "furier" ;
  furioso_ab_1 = mkAdv "furioso" ;
  furioso_nn_1 = mkN "furioso" "furiosot" "furioson" "furiosona" ;
  furir_nn_1 = mkN "furir" "furirer" ;
  furnissoer_nn_1 = mkN "furnissцr" "furnissцrer" ;
  furstbiskop_nn_1 = mkN "furstbiskop" ;
  furste_nn_1 = mkN "furste" utrum ;
  fursteaett_nn_1 = mkN "fursteдtt" "fursteдtter" ;
  furstlig_av_1 = mkA "furstlig" ;
  furunkel_nn_1 = mkN "furunkel" ;
  fusion_nn_1 = mkN "fusion" "fusioner" ;
  fusklapp_nn_1 = mkN "fusklapp" ;
  fuskverk_nn_1 = mkN "fuskverk" neutrum ;
  futhark_nn_1 = mkN "futhark" "futharker" ;
  futil_av_1 = mkA "futil" ;
  futilitet_nn_1 = mkN "futilitet" "futiliteter" ;
  futt_nn_1 = mkN "futt" ;
  futtig_av_1 = mkA "futtig" ;
  futural_av_1 = mkA "futural" ;
  futurist_nn_1 = mkN "futurist" "futurister" ;
  futuristisk_av_1 = mkA "futuristisk" ;
  futurolog_nn_1 = mkN "futurolog" "futurologer" ;
  futurologisk_av_1 = mkA "futurologisk" ;
  futurum_nn_1 = mkN "futurum" "futurum" "futurer" "futurerna" ;
  fux_nn_1 = mkN "fux" ;
  fylking_nn_1 = mkN "fylking" ;
  fyllbult_nn_1 = mkN "fyllbult" ;
  fylld_av_1 = mkA "fylld" "fyllt" ;
  fyllerist_nn_1 = mkN "fyllerist" "fyllerister" ;
  fyllig_av_1 = mkA "fyllig" ;
  fyllnad_nn_1 = mkN "fyllnad" "fyllnader" ;
  fyllnadstjaenstgoering_nn_1 = mkN "fyllnadstjдnstgцring" ;
  fyllnadsval_nn_1 = mkN "fyllnadsval" neutrum ;
  fyllning_nn_1 = mkN "fyllning" ;
  fyllo_nn_1 = mkN "fyllo" "fyllot" "fyllon" "fyllona" ;
  fylogenetisk_av_1 = mkA "fylogenetisk" ;
  fynd_nn_1 = mkN "fynd" neutrum ;
  fyndig_av_1 = mkA "fyndig" ;
  fyndighet_nn_1 = mkN "fyndighet" "fyndigheter" ;
  fyndort_nn_1 = mkN "fyndort" "fyndorter" ;
  fyndplats_nn_1 = mkN "fyndplats" "fyndplatser" ;
  fyndpris_nn_1 = mkN "fyndpris" neutrum ;
  fyr_nn_1 = mkN "fyr" ;
  fyraaarig_av_1 = mkA "fyraеrig" ;
  fyrbaak_nn_1 = mkN "fyrbеk" ;
  fyrbackslinje_nn_1 = mkN "fyrbackslinje" "fyrbackslinjer" ;
  fyrbent_av_1 = mkA "fyrbent" "fyrbent" ;
  fyrcylindrig_av_1 = mkA "fyrcylindrig" ;
  fyrdubbel_av_1 = mkA "fyrdubbel" "fyrdubbelt" "fyrdubbla" "fyrdubbla" "fyrdubblare" "fyrdubblast" "fyrdubblaste" ;
  fyrfaergstryck_nn_1 = mkN "fyrfдrgstryck" neutrum ;
  fyrfaldig_av_1 = mkA "fyrfaldig" ;
  fyrfalt_ab_1 = mkAdv "fyrfalt" ;
  fyrfota_av_1 = mkA "fyrfota" ;
  fyrfotadjur_nn_1 = mkN "fyrfotadjur" neutrum ;
  fyrfoting_nn_1 = mkN "fyrfoting" ;
  fyrhaendig_av_1 = mkA "fyrhдndig" ;
  fyrhandssaettning_nn_1 = mkN "fyrhandssдttning" ;
  fyrhoerning_nn_1 = mkN "fyrhцrning" ;
  fyrk_nn_1 = mkN "fyrk" ;
  fyrkant_nn_1 = mkN "fyrkant" "fyrkanter" ;
  fyrkantig_av_1 = mkA "fyrkantig" ;
  fyrkaraktaer_nn_1 = mkN "fyrkaraktдr" "fyrkaraktдrer" ;
  fyrling_nn_1 = mkN "fyrling" ;
  fyrljus_nn_1 = mkN "fyrljus" neutrum ;
  fyrmaenning_nn_1 = mkN "fyrmдnning" ;
  fyrmotorig_av_1 = mkA "fyrmotorig" ;
  fyrop_nn_1 = mkN "fyrop" neutrum ;
  fyrsiding_nn_1 = mkN "fyrsiding" ;
  fyrsiffrig_av_1 = mkA "fyrsiffrig" ;
  fyrsitsig_av_1 = mkA "fyrsitsig" ;
  fyrskepp_nn_1 = mkN "fyrskepp" neutrum ;
  fyrspann_nn_1 = mkN "fyrspann" neutrum ;
  fyrtaktare_nn_1 = mkN "fyrtaktare" "fyrtaktare" ;
  fyrtaktsmotor_nn_1 = mkN "fyrtaktsmotor" "fyrtaktsmotorer" ;
  fyrtal_nn_1 = mkN "fyrtal" "fyrtalet" "fyrtalen" "fyrtalena" ;
  fyrtiotalist_nn_1 = mkN "fyrtiotalist" "fyrtiotalister" ;
  fyrtiotimmarsvecka_nn_1 = mkN "fyrtiotimmarsvecka" ;
  fyrtitalism_nn_1 = mkN "fyrtitalism" "fyrtitalismer" ;
  fyrtitalist_nn_1 = mkN "fyrtitalist" "fyrtitalister" ;
  fyrtorn_nn_1 = mkN "fyrtorn" neutrum ;
  fyrvaeldig_av_1 = mkA "fyrvдldig" ;
  fyrvaeppling_nn_1 = mkN "fyrvдppling" ;
  fyrvaktare_nn_1 = mkN "fyrvaktare" "fyrvaktare" ;
  fyrverkare_nn_1 = mkN "fyrverkare" "fyrverkare" ;
  fyrverkeri_nn_1 = mkN "fyrverkeri" "fyrverkerit" "fyrverkerier" "fyrverkerierna" ;
  fyrverkeripjaes_nn_1 = mkN "fyrverkeripjдs" "fyrverkeripjдser" ;
  fysikalisk_av_1 = mkA "fysikalisk" ;
  fysiker_nn_1 = mkN "fysiker" "fysikern" "fysiker" "fysikerna" ;
  fysikforskare_nn_1 = mkN "fysikforskare" "fysikforskare" ;
  fysikforskning_nn_1 = mkN "fysikforskning" ;
  fysikvetenskap_nn_1 = mkN "fysikvetenskap" "fysikvetenskaper" ;
  fysiokrat_nn_1 = mkN "fysiokrat" "fysiokrater" ;
  fysiokratisk_av_1 = mkA "fysiokratisk" ;
  fysiolog_nn_1 = mkN "fysiolog" "fysiologer" ;
  fysiologisk_av_1 = mkA "fysiologisk" ;
  fysionomi_nn_1 = mkN "fysionomi" "fysionomier" ;
  fysisk_av_1 = mkA "fysisk" ;
  fytotron_nn_1 = mkN "fytotron" "fytotroner" ;
  g_draekt_nn_1 = mkN "g-drдkt" "g-drдkter" ;
  g_klav_nn_1 = mkN "g-klav" "g-klaver" ;
  gaa_vb_1 = mkV "gе" "gеr" "gе" "gick" "gеtt" "gеngen" ;
  gaabock_nn_1 = mkN "gеbock" ;
  gaagosse_nn_1 = mkN "gеgosse" utrum ;
  gaang_nn_1 = mkN "gеng" ;
  gaang_nn_2 = mkN "gеng" "gеnger" ;
  gaangare_nn_1 = mkN "gеngare" "gеngare" ;
  gaangart_nn_1 = mkN "gеngart" "gеngarter" ;
  gaangavstaand_nn_1 = mkN "gеngavstеnd" neutrum ;
  gaangbar_av_1 = mkA "gеngbar" ;
  gaangbergart_nn_1 = mkN "gеngbergart" "gеngbergarter" ;
  gaangbord_nn_1 = mkN "gеngbord" neutrum ;
  gaangbro_nn_1 = mkN "gеngbro" ;
  gaangfot_nn_1 = mkN "gеngfot" "gеngfцtter" ;
  gaanggrift_nn_1 = mkN "gеnggrift" "gеnggrifter" ;
  gaangjaern_nn_1 = mkN "gеngjдrn" neutrum ;
  gaanglaat_nn_1 = mkN "gеnglеt" ;
  gaangled_nn_1 = mkN "gеngled" "gеngleder" ;
  gaangspel_nn_1 = mkN "gеngspel" "gеngspelet" "gеngspel" "gеngspelen" ;
  gaangstol_nn_1 = mkN "gеngstol" ;
  gaangvaeg_nn_1 = mkN "gеngvдg" ;
  gaapaaare_nn_1 = mkN "gеpеare" "gеpеare" ;
  gaapaaig_av_1 = mkA "gеpеig" ;
  gaard_nn_1 = mkN "gеrd" ;
  gaardag_nn_1 = mkN "gеrdag" ;
  gaardfarihandlande_nn_1 = mkN "gеrdfarihandlande" "gеrdfarihandlanden" "gеrdfarihandlande" "gеrdfarihandlandena" ;
  gaardfarihandlare_nn_1 = mkN "gеrdfarihandlare" "gеrdfarihandlare" ;
  gaarding_nn_1 = mkN "gеrding" ;
  gaardshus_nn_1 = mkN "gеrdshus" neutrum ;
  gaardskarl_nn_1 = mkN "gеrdskarl" ;
  gaardskulle_nn_1 = mkN "gеrdskulle" utrum ;
  gaardsmusikant_nn_1 = mkN "gеrdsmusikant" "gеrdsmusikanter" ;
  gaardsomraade_nn_1 = mkN "gеrdsomrеde" ;
  gaardsplan_nn_1 = mkN "gеrdsplan" "gеrdsplaner" ;
  gaardsplats_nn_1 = mkN "gеrdsplats" "gеrdsplatser" ;
  gaardsrum_nn_1 = mkN "gеrdsrum" "gеrdsrummet" "gеrdsrum" "gеrdsrummen" ;
  gaardvar_nn_1 = mkN "gеrdvar" ;
  gaas_nn_1 = mkN "gеs" "gеsen" "gдss" "gдssen" ;
  gaasbroest_nn_1 = mkN "gеsbrцst" neutrum ;
  gaase_nn_1 = mkN "gеse" utrum ;
  gaasfjaeder_nn_1 = mkN "gеsfjдder" ;
  gaasfot_nn_1 = mkN "gеsfot" "gеsfцtter" ;
  gaaskarl_nn_1 = mkN "gеskarl" ;
  gaastol_nn_1 = mkN "gеstol" ;
  gaasunge_nn_1 = mkN "gеsunge" utrum ;
  gaat_nn_1 = mkN "gеt" ;
  gaatfull_av_1 = mkA "gеtfull" ;
  gaava_nn_1 = mkN "gеva" ;
  gaavoavtal_nn_1 = mkN "gеvoavtal" "gеvoavtalet" "gеvoavtalen" "gеvoavtalena" ;
  gaavobrev_nn_1 = mkN "gеvobrev" neutrum ;
  gaavohandling_nn_1 = mkN "gеvohandling" ;
  gabon_nn_2 = mkN "gabon" "gaboner" ;
  gabondoerr_nn_1 = mkN "gabondцrr" ;
  gabones_nn_1 = mkN "gabones" "gaboneser" ;
  gabonhuggorm_nn_1 = mkN "gabonhuggorm" ;
  gadd_nn_1 = mkN "gadd" ;
  gaddloes_av_1 = mkA "gaddlцs" ;
  gaddstekel_nn_1 = mkN "gaddstekel" ;
  gaeck_ab_1 = mkAdv "gдck" ;
  gaeckeri_nn_1 = mkN "gдckeri" "gдckerit" "gдckerier" "gдckerierna" ;
  gaeckmast_nn_1 = mkN "gдckmast" "gдckmaster" ;
  gaecksam_av_1 = mkA "gдcksam" "gдcksamt" "gдcksamma" "gдcksamma" "gдcksammare" "gдcksammast" "gдcksammaste" ;
  gaeddsax_nn_1 = mkN "gдddsax" ;
  gael_nn_1 = mkN "gдl" ;
  gael_nn_2 = mkN "gдl" "gдler" ;
  gaelbaage_nn_1 = mkN "gдlbеge" utrum ;
  gaelbgjutare_nn_1 = mkN "gдlbgjutare" "gдlbgjutare" ;
  gaelbgjuteri_nn_1 = mkN "gдlbgjuteri" "gдlbgjuterit" "gдlbgjuterier" "gдlbgjuterierna" ;
  gaelblad_nn_1 = mkN "gдlblad" neutrum ;
  gaelda_vb_1 = mkV "gдlda" ;
  gaeldbunden_av_1 = mkA "gдldbunden" "gдldbundet" ;
  gaeldenaer_nn_1 = mkN "gдldenдr" "gдldenдrer" ;
  gaeldstuga_nn_1 = mkN "gдldstuga" ;
  gaelisk_av_1 = mkA "gaelisk" ;
  gaeliska_nn_2 = mkN "gaeliska" ;
  gaell_av_1 = mkA "gдll" ;
  gaellen_av_1 = mkA "gдllen" "gдllet" ;
  gaems_nn_1 = mkN "gдms" "gдmser" ;
  gaeng_nn_1 = mkN "gдng" neutrum ;
  gaengback_nn_1 = mkN "gдngback" ;
  gaenglig_av_1 = mkA "gдnglig" ;
  gaengning_nn_1 = mkN "gдngning" ;
  gaengse_av_1 = mkA "gдngse" ;
  gaengstaal_nn_1 = mkN "gдngstеl" neutrum ;
  gaengtapp_nn_1 = mkN "gдngtapp" ;
  gaengtolk_nn_1 = mkN "gдngtolk" ;
  gaerd_nn_1 = mkN "gдrd" "gдrder" ;
  gaerde_nn_1 = mkN "gдrde" ;
  gaerdesgaard_nn_1 = mkN "gдrdesgеrd" ;
  gaerdning_nn_1 = mkN "gдrdning" ;
  gaerdsel_nn_1 = mkN "gдrdsel" neutrum ;
  gaerdsgaard_nn_1 = mkN "gдrdsgеrd" ;
  gaerdsgaardsstoer_nn_1 = mkN "gдrdsgеrdsstцr" ;
  gaerdsmyg_nn_1 = mkN "gдrdsmyg" ;
  gaerna_ab_1 = mkAdv "gдrna" ;
  gaerning_nn_1 = mkN "gдrning" ;
  gaerningsman_nn_1 = mkN "gдrningsman" "gдrningsmannen" "gдrningsmдn" "gдrningsmдnnen" ;
  gaerningsort_nn_1 = mkN "gдrningsort" "gдrningsorter" ;
  gaers_nn_1 = mkN "gдrs" ;
  gaesp_nn_1 = mkN "gдsp" neutrum ;
  gaespig_av_1 = mkA "gдspig" ;
  gaespning_nn_1 = mkN "gдspning" ;
  gaessling_nn_1 = mkN "gдssling" ;
  gaest_nn_1 = mkN "gдst" "gдster" ;
  gaestabud_nn_1 = mkN "gдstabud" neutrum ;
  gaestarbetare_nn_1 = mkN "gдstarbetare" "gдstarbetare" ;
  gaestbok_nn_1 = mkN "gдstbok" "gдstbцcker" ;
  gaestfri_av_1 = mkA "gдstfri" "gдstfritt" ;
  gaestgivare_nn_1 = mkN "gдstgivare" "gдstgivare" ;
  gaestgivargaard_nn_1 = mkN "gдstgivargеrd" ;
  gaestgiveri_nn_1 = mkN "gдstgiveri" "gдstgiverit" "gдstgiverier" "gдstgiverierna" ;
  gaesthandduk_nn_1 = mkN "gдsthandduk" ;
  gaestnatt_nn_1 = mkN "gдstnatt" "gдstnдtter" ;
  gaestning_nn_1 = mkN "gдstning" ;
  gaestrike_nn_1 = mkN "gдstrike" utrum ;
  gaestriking_nn_1 = mkN "gдstriking" ;
  gaestriklaendska_nn_1 = mkN "gдstriklдndska" ;
  gaestriklaenning_nn_1 = mkN "gдstriklдnning" ;
  gaestring_nn_1 = mkN "gдstring" ;
  gaestrisk_av_1 = mkA "gдstrisk" ;
  gaestrum_nn_1 = mkN "gдstrum" "gдstrummet" "gдstrum" "gдstrummen" ;
  gaestspel_nn_1 = mkN "gдstspel" "gдstspelet" "gдstspel" "gдstspelen" ;
  gaestvaenlig_av_1 = mkA "gдstvдnlig" ;
  gaff_nn_1 = mkN "gaff" ;
  gaffel_nn_1 = mkN "gaffel" ;
  gaffelantilop_nn_1 = mkN "gaffelantilop" "gaffelantiloper" ;
  gaffelbit_nn_1 = mkN "gaffelbit" ;
  gaffelbock_nn_1 = mkN "gaffelbock" ;
  gaffelhjort_nn_1 = mkN "gaffelhjort" ;
  gaffelklo_nn_1 = mkN "gaffelklo" "gaffelklor" ;
  gaffelrigg_nn_1 = mkN "gaffelrigg" ;
  gaffelsegel_nn_1 = mkN "gaffelsegel" neutrum ;
  gaffeltruck_nn_1 = mkN "gaffeltruck" ;
  gafflan_ab_1 = mkAdv "gafflan" ;
  gag_nn_1 = mkN "gag" neutrum ;
  gagat_nn_1 = mkN "gagat" "gagater" ;
  gagatsvart_av_1 = mkA "gagatsvart" "gagatsvart" ;
  gage_nn_1 = mkN "gage" "gaget" "gage" "gagen" ;
  gaggig_av_1 = mkA "gaggig" ;
  gagnelig_av_1 = mkA "gagnelig" ;
  gagnerik_av_1 = mkA "gagnerik" ;
  gagnloes_av_1 = mkA "gagnlцs" ;
  gagnrik_av_1 = mkA "gagnrik" ;
  gagnvaext_nn_1 = mkN "gagnvдxt" "gagnvдxter" ;
  gaillarde_nn_1 = mkN "gaillarde" "gaillarder" ;
  gaj_nn_1 = mkN "gaj" ;
  galaer_nn_1 = mkN "galдr" "galдrer" ;
  galaerslav_nn_1 = mkN "galдrslav" ;
  galaktisk_av_1 = mkA "galaktisk" ;
  galant_ab_1 = mkAdv "galant" ;
  galant_av_1 = mkA "galant" "galant" ;
  galanteri_nn_1 = mkN "galanteri" "galanterit" "galanterier" "galanterierna" ;
  galat_nn_1 = mkN "galat" "galater" ;
  galavagn_nn_1 = mkN "galavagn" ;
  galax_nn_1 = mkN "galax" "galaxer" ;
  galaxbildning_nn_1 = mkN "galaxbildning" ;
  galaxcentrum_nn_1 = mkN "galaxcentrum" neutrum ;
  galaxhop_nn_1 = mkN "galaxhop" ;
  galaxspektrum_nn_1 = mkN "galaxspektrum" neutrum ;
  galaxvaerld_nn_1 = mkN "galaxvдrld" ;
  galder_nn_1 = mkN "galder" ;
  galeas_nn_1 = mkN "galeas" "galeaser" ;
  galen_av_1 = mkA "galen" "galet" ;
  galenskap_nn_1 = mkN "galenskap" "galenskaper" ;
  galgbacke_nn_1 = mkN "galgbacke" utrum ;
  galge_nn_1 = mkN "galge" utrum ;
  galgfaagel_nn_1 = mkN "galgfеgel" ;
  galicisk_av_1 = mkA "galicisk" ;
  galile_nn_1 = mkN "galilй" "galilйer" ;
  galjon_nn_1 = mkN "galjon" "galjoner" ;
  galjonsbild_nn_1 = mkN "galjonsbild" "galjonsbilder" ;
  galjonsfigur_nn_1 = mkN "galjonsfigur" "galjonsfigurer" ;
  gall_av_1 = mkA "gall" ;
  gall_nn_1 = mkN "gall" "galler" ;
  gallbildning_nn_1 = mkN "gallbildning" ;
  galldrivande_av_1 = mkA "galldrivande" ;
  galler_nn_1 = mkN "galler" neutrum ;
  galler_nn_2 = mkN "galler" "gallern" "galler" "gallerna" ;
  galleri_nn_1 = mkN "galleri" "gallerit" "gallerier" "gallerierna" ;
  galleriskog_nn_1 = mkN "galleriskog" ;
  gallerist_nn_1 = mkN "gallerist" "gallerister" ;
  gallerverk_nn_1 = mkN "gallerverk" neutrum ;
  gallgaang_nn_1 = mkN "gallgеng" ;
  gallicism_nn_1 = mkN "gallicism" "gallicismer" ;
  gallier_nn_1 = mkN "gallier" "galliern" "gallier" "gallierna" ;
  gallion_nn_1 = mkN "gallion" "gallioner" ;
  gallisk_av_1 = mkA "gallisk" ;
  gallko_nn_1 = mkN "gallko" "gallkor" ;
  gallkvalster_nn_1 = mkN "gallkvalster" neutrum ;
  gallon_nn_1 = mkN "gallon" "gallonen" "gallon" "gallonen" ;
  gallring_nn_1 = mkN "gallring" ;
  gallsjuk_av_1 = mkA "gallsjuk" ;
  gallskrik_nn_1 = mkN "gallskrik" neutrum ;
  gallspraengd_av_1 = mkA "gallsprдngd" "gallsprдngt" ;
  gallstekel_nn_1 = mkN "gallstekel" ;
  gallsten_nn_1 = mkN "gallsten" "gallstenen" "gallstenar" "gallstenarna" ;
  galltjut_nn_1 = mkN "galltjut" neutrum ;
  gallup_nn_1 = mkN "gallup" ;
  galning_nn_1 = mkN "galning" ;
  galon_nn_2 = mkN "galon" "galoner" ;
  galopp_nn_1 = mkN "galopp" "galopper" ;
  galoppad_nn_1 = mkN "galoppad" "galoppader" ;
  galopptaevling_nn_1 = mkN "galopptдvling" ;
  galosch_nn_1 = mkN "galosch" "galoscher" ;
  galt_nn_1 = mkN "galt" ;
  galvanisk_av_1 = mkA "galvanisk" ;
  galvanometer_nn_1 = mkN "galvanometer" ;
  galvanoskop_nn_1 = mkN "galvanoskop" neutrum ;
  galvanotyp_nn_1 = mkN "galvanotyp" "galvanotyper" ;
  gam_nn_1 = mkN "gam" ;
  gamaeng_nn_1 = mkN "gamдng" "gamдnger" ;
  gamasch_nn_1 = mkN "gamasch" "gamascher" ;
  gambier_nn_1 = mkN "gambier" "gambiern" "gambier" "gambierna" ;
  gambisk_av_1 = mkA "gambisk" ;
  gambit_nn_1 = mkN "gambit" ;
  game_nn_1 = mkN "game" "gamet" "game" "gamen" ;
  gamet_nn_1 = mkN "gamet" "gameter" ;
  gamling_nn_1 = mkN "gamling" ;
  gamma_nn_1 = mkN "gamma" "gammat" "gamman" "gammana" ;
  gammafly_nn_1 = mkN "gammafly" "gammaflyt" "gammaflyn" "gammaflyen" ;
  gammaglobulin_nn_1 = mkN "gammaglobulin" "gammaglobuliner" ;
  gammakamera_nn_1 = mkN "gammakamera" ;
  gammal_av_1 = mkA "gammal" "gammalt" "gamla" "дldre" "дldst" ;
  gammaldags_av_1 = mkA "gammaldags" ;
  gammaldans_nn_1 = mkN "gammaldans" "gammaldanser" ;
  gammalkommunist_nn_1 = mkN "gammalkommunist" "gammalkommunister" ;
  gammalkristen_av_1 = mkA "gammalkristen" "gammalkristet" ;
  gammalkyrklig_av_1 = mkA "gammalkyrklig" ;
  gammalmodig_av_1 = mkA "gammalmodig" ;
  gammalrosa_av_1 = mkA "gammalrosa" ;
  gammaltestamentlig_av_1 = mkA "gammaltestamentlig" ;
  gammalvals_nn_1 = mkN "gammalvals" "gammalvalser" ;
  gammastraale_nn_1 = mkN "gammastrеle" utrum ;
  gammeldans_nn_1 = mkN "gammeldans" "gammeldanser" ;
  gan_nn_1 = mkN "gan" ;
  ganasch_nn_1 = mkN "ganasch" "ganascher" ;
  ganglie_nn_1 = mkN "ganglie" "ganglier" ;
  gangrenoes_av_1 = mkA "gangrenцs" ;
  gangster_nn_1 = mkN "gangster" ;
  gans_nn_1 = mkN "gans" "ganser" ;
  ganska_ab_1 = mkAdv "ganska" ;
  ganymed_nn_1 = mkN "ganymed" "ganymeder" ;
  gap_nn_1 = mkN "gap" neutrum ;
  gaphals_nn_1 = mkN "gaphals" ;
  gapig_av_1 = mkA "gapig" ;
  gapsax_nn_1 = mkN "gapsax" ;
  gapskratt_nn_1 = mkN "gapskratt" neutrum ;
  gapstock_nn_1 = mkN "gapstock" ;
  garage_nn_1 = mkN "garage" "garaget" "garage" "garagen" ;
  garant_nn_1 = mkN "garant" "garanter" ;
  garanti_nn_1 = mkN "garanti" "garantier" ;
  garantifoerdrag_nn_1 = mkN "garantifцrdrag" neutrum ;
  garantifoersaekring_nn_1 = mkN "garantifцrsдkring" ;
  garantifond_nn_1 = mkN "garantifond" "garantifonder" ;
  garantilaan_nn_1 = mkN "garantilеn" neutrum ;
  gard_nn_1 = mkN "gard" "garder" ;
  garde_nn_1 = mkN "garde" ;
  gardering_nn_1 = mkN "gardering" ;
  garderob_nn_1 = mkN "garderob" "garderober" ;
  garderobiaer_nn_1 = mkN "garderobiдr" "garderobiдrer" ;
  garderobie_nn_1 = mkN "garderobiй" "garderobiйer" ;
  gardian_nn_1 = mkN "gardian" "gardianer" ;
  gardin_nn_1 = mkN "gardin" "gardiner" ;
  gardinband_nn_1 = mkN "gardinband" neutrum ;
  gardinluft_nn_1 = mkN "gardinluft" "gardinlufter" ;
  gardinring_nn_1 = mkN "gardinring" ;
  gardinstaang_nn_1 = mkN "gardinstеng" "gardinstдnger" ;
  gardist_nn_1 = mkN "gardist" "gardister" ;
  gardjaern_nn_1 = mkN "gardjдrn" neutrum ;
  garfaagel_nn_1 = mkN "garfеgel" ;
  garn_nn_1 = mkN "garn" neutrum ;
  garnbom_nn_1 = mkN "garnbom" "garnbommen" "garnbommar" "garnbommarna" ;
  garnering_nn_1 = mkN "garnering" ;
  garnhank_nn_1 = mkN "garnhank" ;
  garnison_nn_1 = mkN "garnison" "garnisoner" ;
  garnityr_nn_1 = mkN "garnityr" neutrum ;
  garnspole_nn_1 = mkN "garnspole" utrum ;
  garson_nn_1 = mkN "garзon" "garзoner" ;
  garsong_nn_1 = mkN "garsong" "garsonger" ;
  gartner_nn_1 = mkN "gartner" "gartnern" "gartner" "gartnerna" ;
  garv_nn_1 = mkN "garv" neutrum ;
  garvaemne_nn_1 = mkN "garvдmne" ;
  garvare_nn_1 = mkN "garvare" "garvare" ;
  garveri_nn_1 = mkN "garveri" "garverit" "garverier" "garverierna" ;
  garvmedel_nn_1 = mkN "garvmedel" neutrum ;
  garvning_nn_1 = mkN "garvning" ;
  gas_nn_1 = mkN "gas" "gaser" ;
  gas_nn_2 = mkN "gas" "gaser" ;
  gasackumulator_nn_1 = mkN "gasackumulator" "gasackumulatorer" ;
  gasblandning_nn_1 = mkN "gasblandning" ;
  gasbraennare_nn_1 = mkN "gasbrдnnare" "gasbrдnnare" ;
  gasbubbla_nn_1 = mkN "gasbubbla" ;
  gascognare_nn_1 = mkN "gascognare" "gascognare" ;
  gasell_nn_1 = mkN "gasell" "gaseller" ;
  gaseruption_nn_1 = mkN "gaseruption" "gaseruptioner" ;
  gasett_nn_1 = mkN "gasett" "gasetter" ;
  gasformig_av_1 = mkA "gasformig" ;
  gasgenerator_nn_1 = mkN "gasgenerator" "gasgeneratorer" ;
  gask_nn_1 = mkN "gask" ;
  gaskammare_nn_1 = mkN "gaskammare" "gaskammaren" "gaskamrar" "gaskamrarna" ;
  gasklot_nn_1 = mkN "gasklot" neutrum ;
  gaskromatograf_nn_1 = mkN "gaskromatograf" "gaskromatografer" ;
  gaskropp_nn_1 = mkN "gaskropp" ;
  gaslaeckage_nn_1 = mkN "gaslдckage" "gaslдckaget" "gaslдckage" "gaslдckagen" ;
  gaslaera_nn_1 = mkN "gaslдra" ;
  gasmask_nn_1 = mkN "gasmask" "gasmasker" ;
  gasmoln_nn_1 = mkN "gasmoln" neutrum ;
  gasolkoek_nn_1 = mkN "gasolkцk" neutrum ;
  gasoltub_nn_1 = mkN "gasoltub" "gasoltuber" ;
  gasometer_nn_1 = mkN "gasometer" ;
  gaspedal_nn_1 = mkN "gaspedal" "gaspedaler" ;
  gassig_av_1 = mkA "gassig" ;
  gasskydd_nn_1 = mkN "gasskydd" neutrum ;
  gasspis_nn_1 = mkN "gasspis" ;
  gasstroem_nn_1 = mkN "gasstrцm" "gasstrцmmen" "gasstrцmmar" "gasstrцmmarna" ;
  gast_nn_1 = mkN "gast" ;
  gastrisk_av_1 = mkA "gastrisk" ;
  gastrit_nn_1 = mkN "gastrit" "gastriter" ;
  gastronom_nn_1 = mkN "gastronom" "gastronomer" ;
  gastronomisk_av_1 = mkA "gastronomisk" ;
  gastroskop_nn_1 = mkN "gastroskop" neutrum ;
  gastroskopi_nn_1 = mkN "gastroskopi" "gastroskopier" ;
  gastryck_nn_1 = mkN "gastryck" neutrum ;
  gasturbin_nn_1 = mkN "gasturbin" "gasturbiner" ;
  gasurladdning_nn_1 = mkN "gasurladdning" ;
  gasventil_nn_1 = mkN "gasventil" "gasventiler" ;
  gasverk_nn_1 = mkN "gasverk" neutrum ;
  gata_nn_1 = mkN "gata" ;
  gathoern_nn_1 = mkN "gathцrn" neutrum ;
  gathus_nn_1 = mkN "gathus" neutrum ;
  gatlaeggning_nn_1 = mkN "gatlдggning" ;
  gatlopp_nn_1 = mkN "gatlopp" neutrum ;
  gatpojke_nn_1 = mkN "gatpojke" utrum ;
  gatsopare_nn_1 = mkN "gatsopare" "gatsopare" ;
  gatsten_nn_1 = mkN "gatsten" "gatstenen" "gatstenar" "gatstenarna" ;
  gatt_nn_1 = mkN "gatt" neutrum ;
  gatubelaeggning_nn_1 = mkN "gatubelдggning" ;
  gatubelysning_nn_1 = mkN "gatubelysning" ;
  gatufoersaeljare_nn_1 = mkN "gatufцrsдljare" "gatufцrsдljare" ;
  gatukoek_nn_1 = mkN "gatukцk" neutrum ;
  gatukors_nn_1 = mkN "gatukors" neutrum ;
  gatukorsning_nn_1 = mkN "gatukorsning" ;
  gatuliv_nn_1 = mkN "gatuliv" neutrum ;
  gatunamn_nn_1 = mkN "gatunamn" neutrum ;
  gatunge_nn_1 = mkN "gatunge" utrum ;
  gatuplan_nn_1 = mkN "gatuplan" neutrum ;
  gaucho_nn_1 = mkN "gaucho" "gauchon" "gauchos" "gauchosen" ;
  gauge_nn_1 = mkN "gauge" "gaugen" "gauge" "gaugena" ;
  gaullist_nn_1 = mkN "gaullist" "gaullister" ;
  gaullistisk_av_1 = mkA "gaullistisk" ;
  gaur_nn_1 = mkN "gaur" "gaurer" ;
  gauss_nn_1 = mkN "gauss" "gaussen" "gauss" "gaussen" ;
  gavel_nn_1 = mkN "gavel" ;
  gavelfaelt_nn_1 = mkN "gavelfдlt" neutrum ;
  gavelhus_nn_1 = mkN "gavelhus" neutrum ;
  gavelroeste_nn_1 = mkN "gavelrцste" ;
  gavial_nn_1 = mkN "gavial" "gavialer" ;
  gavott_nn_1 = mkN "gavott" "gavotter" ;
  gay_av_1 = mkA "gay" ;
  gayal_nn_1 = mkN "gayal" "gayaler" ;
  ge_vb_1 = mkV "ge" "ger" "ge" "gav" "gett" "given" ;
  gebit_nn_1 = mkN "gebit" neutrum ;
  gecko_nn_1 = mkN "gecko" "geckor" ;
  gedigen_av_1 = mkA "gedigen" "gediget" ;
  geg_nn_1 = mkN "geg" "geger" ;
  geggig_av_1 = mkA "geggig" ;
  gehaeng_nn_1 = mkN "gehдng" neutrum ;
  geheimeraad_nn_1 = mkN "geheimerеd" neutrum ;
  geiger_mullerroer_nn_1 = mkN "geiger-mьllerrцr" neutrum ;
  geigermaetare_nn_1 = mkN "geigermдtare" "geigermдtare" ;
  gejd_nn_1 = mkN "gejd" "gejder" ;
  gejser_nn_1 = mkN "gejser" ;
  gel_nn_1 = mkN "gel" "gelet" "geler" "gelerna" ;
  gelaenk_nn_1 = mkN "gelдnk" neutrum ;
  gelatinkapsel_nn_1 = mkN "gelatinkapsel" ;
  gelatinoes_av_1 = mkA "gelatinцs" ;
  gelbgjutare_nn_1 = mkN "gelbgjutare" "gelbgjutare" ;
  gelbgjuteri_nn_1 = mkN "gelbgjuteri" "gelbgjuterit" "gelbgjuterier" "gelbgjuterierna" ;
  gele_nn_1 = mkN "gelй" "gelйer" ;
  gelehallon_nn_1 = mkN "gelйhallon" neutrum ;
  geleig_av_1 = mkA "geleig" ;
  geleklump_nn_1 = mkN "gelйklump" ;
  gelesvamp_nn_1 = mkN "gelйsvamp" ;
  gelike_nn_1 = mkN "gelike" utrum ;
  gem_nn_1 = mkN "gem" "gemmen" "gemmer" "gemmerna" ;
  gem_nn_2 = mkN "gem" neutrum ;
  gemaal_nn_1 = mkN "gemеl" "gemеler" ;
  gemak_nn_1 = mkN "gemak" neutrum ;
  gemen_av_1 = mkA "gemen" ;
  gemenhet_nn_1 = mkN "gemenhet" "gemenheter" ;
  gemenligen_ab_1 = mkAdv "gemenligen" ;
  gemensam_av_1 = mkA "gemensam" "gemensamt" "gemensamma" "gemensamma" "gemensammare" "gemensammast" "gemensammaste" ;
  gemensamhet_nn_1 = mkN "gemensamhet" "gemensamheter" ;
  gemensamhetsgrav_nn_1 = mkN "gemensamhetsgrav" ;
  gemination_nn_1 = mkN "gemination" "geminationer" ;
  geminering_nn_1 = mkN "geminering" ;
  gems_nn_1 = mkN "gems" "gemser" ;
  gemyt_nn_1 = mkN "gemyt" neutrum ;
  gemytlig_av_1 = mkA "gemytlig" ;
  gen_av_1 = mkA "gen" ;
  gen_nn_1 = mkN "gen" "gener" ;
  genant_av_1 = mkA "genant" "genant" ;
  genast_ab_1 = mkAdv "genast" ;
  gendarm_nn_1 = mkN "gendarm" "gendarmer" ;
  gendriva_vb_1 = mkV "gendriva" "gendrev" "gendrivit" ;
  genealog_nn_1 = mkN "genealog" "genealoger" ;
  genealogi_nn_1 = mkN "genealogi" "genealogier" ;
  general_nn_1 = mkN "general" "generaler" ;
  generalagent_nn_1 = mkN "generalagent" "generalagenter" ;
  generaldirektoer_nn_1 = mkN "generaldirektцr" "generaldirektцrer" ;
  generalfoersamling_nn_1 = mkN "generalfцrsamling" ;
  generalguvernoer_nn_1 = mkN "generalguvernцr" "generalguvernцrer" ;
  generalisation_nn_1 = mkN "generalisation" "generalisationer" ;
  generalisering_nn_1 = mkN "generalisering" ;
  generalist_nn_1 = mkN "generalist" "generalister" ;
  generalitet_nn_2 = mkN "generalitet" "generaliteter" ;
  generalkonsul_nn_1 = mkN "generalkonsul" "generalkonsuln" "generalkonsuler" "generalkonsulerna" ;
  generalkonsulat_nn_1 = mkN "generalkonsulat" neutrum ;
  generalloejtnant_nn_1 = mkN "generallцjtnant" "generallцjtnanter" ;
  generalmajor_nn_1 = mkN "generalmajor" "generalmajorer" ;
  generaloeverste_nn_1 = mkN "generalцverste" utrum ;
  generalpaus_nn_1 = mkN "generalpaus" "generalpauser" ;
  generalplan_nn_1 = mkN "generalplan" "generalplaner" ;
  generalrep_nn_1 = mkN "generalrep" neutrum ;
  generalrepetition_nn_1 = mkN "generalrepetition" "generalrepetitioner" ;
  generalsekreterare_nn_1 = mkN "generalsekreterare" "generalsekreterare" ;
  generalsperson_nn_1 = mkN "generalsperson" "generalspersoner" ;
  generalstab_nn_1 = mkN "generalstab" "generalstaber" ;
  generalstrejk_nn_1 = mkN "generalstrejk" "generalstrejker" ;
  generande_av_1 = mkA "generande" ;
  generation_nn_1 = mkN "generation" "generationer" ;
  generationstid_nn_1 = mkN "generationstid" "generationstider" ;
  generationsvaexling_nn_1 = mkN "generationsvдxling" ;
  generativ_av_1 = mkA "generativ" ;
  generator_nn_1 = mkN "generator" "generatorer" ;
  generatris_nn_1 = mkN "generatris" "generatriser" ;
  generell_av_1 = mkA "generell" ;
  generisk_av_1 = mkA "generisk" ;
  generoes_av_1 = mkA "generцs" ;
  generositet_nn_1 = mkN "generositet" "generositeter" ;
  genetiker_nn_1 = mkN "genetiker" "genetikern" "genetiker" "genetikerna" ;
  genetisk_av_1 = mkA "genetisk" ;
  genett_nn_1 = mkN "genett" "genetter" ;
  genfordran_nn_1 = mkN "genfordran" "genfordran" "genfordringar" "genfordringarna" ;
  genfordring_nn_1 = mkN "genfordring" ;
  gengaangare_nn_1 = mkN "gengеngare" "gengеngare" ;
  geni_nn_1 = mkN "geni" "genit" "genier" "genierna" ;
  genial_av_1 = mkA "genial" ;
  genialisk_av_1 = mkA "genialisk" ;
  genialitet_nn_1 = mkN "genialitet" "genialiteter" ;
  genie_nn_1 = mkN "genie" "genier" ;
  genitiv_nn_1 = mkN "genitiv" "genitiver" ;
  genitivattribut_nn_1 = mkN "genitivattribut" neutrum ;
  genkaerande_nn_1 = mkN "genkдrande" "genkдranden" "genkдrande" "genkдrandena" ;
  genmaele_nn_1 = mkN "genmдle" ;
  genmanipulation_nn_1 = mkN "genmanipulation" "genmanipulationer" ;
  genom_ab_1 = mkAdv "genom" ;
  genom_nn_1 = mkN "genom" neutrum ;
  genombloedning_nn_1 = mkN "genomblцdning" ;
  genombloet_av_1 = mkA "genomblцt" ;
  genombrott_nn_1 = mkN "genombrott" neutrum ;
  genombruten_av_1 = mkA "genombruten" "genombrutet" ;
  genombryta_vb_1 = mkV "genombryta" "genombrцt" "genombrutit" ;
  genomdriva_vb_1 = mkV "genomdriva" "genomdrev" "genomdrivit" ;
  genomfara_vb_1 = mkV "genomfara" "genomfor" "genomfarit" ;
  genomfart_nn_1 = mkN "genomfart" "genomfarter" ;
  genomfartsled_nn_1 = mkN "genomfartsled" "genomfartsleder" ;
  genomfoerande_nn_1 = mkN "genomfцrande" ;
  genomfoerbar_av_1 = mkA "genomfцrbar" ;
  genomfoering_nn_1 = mkN "genomfцring" ;
  genomfoerkyld_av_1 = mkA "genomfцrkyld" "genomfцrkylt" ;
  genomgaa_vb_1 = mkV "genomgе" "genomgеr" "genomgе" "genomgick" "genomgеtt" "genomgеngen" ;
  genomgaaende_ab_1 = mkAdv "genomgеende" ;
  genomgaaende_av_1 = mkA "genomgеende" ;
  genomgaang_nn_1 = mkN "genomgеng" ;
  genomgripande_av_1 = mkA "genomgripande" ;
  genomklappning_nn_1 = mkN "genomklappning" ;
  genomkoerare_nn_1 = mkN "genomkцrare" "genomkцrare" ;
  genomlida_vb_1 = mkV "genomlida" "genomled" "genomlidit" ;
  genomlysande_av_1 = mkA "genomlysande" ;
  genomlysning_nn_1 = mkN "genomlysning" ;
  genommoenstring_nn_1 = mkN "genommцnstring" ;
  genomsippring_nn_1 = mkN "genomsippring" ;
  genomskinlig_av_1 = mkA "genomskinlig" ;
  genomslaepplig_av_1 = mkA "genomslдpplig" ;
  genomslaepplighet_nn_1 = mkN "genomslдpplighet" "genomslдppligheter" ;
  genomslag_nn_1 = mkN "genomslag" neutrum ;
  genomslagskopia_nn_1 = mkN "genomslagskopia" ;
  genomslagspapper_nn_1 = mkN "genomslagspapper" neutrum ;
  genomsnitt_nn_1 = mkN "genomsnitt" neutrum ;
  genomsnittlig_av_1 = mkA "genomsnittlig" ;
  genomsnittsinkomst_nn_1 = mkN "genomsnittsinkomst" "genomsnittsinkomster" ;
  genomsnittsskatt_nn_1 = mkN "genomsnittsskatt" "genomsnittsskatter" ;
  genomsnittsvaerde_nn_1 = mkN "genomsnittsvдrde" ;
  genomtaenkt_av_1 = mkA "genomtдnkt" "genomtдnkt" ;
  genomtraengande_av_1 = mkA "genomtrдngande" ;
  genomtraenglig_av_1 = mkA "genomtrдnglig" ;
  genomtraengning_nn_1 = mkN "genomtrдngning" ;
  genomtryckt_av_1 = mkA "genomtryckt" "genomtryckt" ;
  genomvaat_av_1 = mkA "genomvеt" ;
  genomvaevd_av_1 = mkA "genomvдvd" "genomvдvt" ;
  genotyp_nn_1 = mkN "genotyp" "genotyper" ;
  genre_nn_1 = mkN "genre" "genrer" ;
  genrep_nn_1 = mkN "genrep" neutrum ;
  gensaegelse_nn_1 = mkN "gensдgelse" "gensдgelser" ;
  gensaga_nn_1 = mkN "gensaga" ;
  gensare_nn_1 = mkN "gensare" "gensare" ;
  genskjuta_vb_1 = mkV "genskjuta" "genskцt" "genskjutit" ;
  genstaemning_nn_1 = mkN "genstдmning" ;
  genstoertig_av_1 = mkA "genstцrtig" ;
  genstraevig_av_1 = mkA "genstrдvig" ;
  genstridig_av_1 = mkA "genstridig" ;
  genta_vb_1 = mkV "genta" "gentar" "genta" "gentog" "gentagit" "gentagen" ;
  gentil_av_1 = mkA "gentil" ;
  gentjaenst_nn_1 = mkN "gentjдnst" "gentjдnster" ;
  gentleman_nn_1 = mkN "gentleman" "gentlemannen" "gentlemдn" "gentlemдnnen" ;
  genuafock_nn_1 = mkN "genuafock" ;
  genuin_av_1 = mkA "genuin" ;
  genus_nn_1 = mkN "genus" neutrum ;
  genvaeg_nn_1 = mkN "genvдg" ;
  geocentrisk_av_1 = mkA "geocentrisk" ;
  geodet_nn_1 = mkN "geodet" "geodeter" ;
  geodetisk_av_1 = mkA "geodetisk" ;
  geodimeter_nn_1 = mkN "geodimeter" ;
  geograf_nn_1 = mkN "geograf" "geografer" ;
  geografisk_av_1 = mkA "geografisk" ;
  geokemisk_av_1 = mkA "geokemisk" ;
  geokronologisk_av_1 = mkA "geokronologisk" ;
  geolog_nn_1 = mkN "geolog" "geologer" ;
  geologisk_av_1 = mkA "geologisk" ;
  geometri_nn_1 = mkN "geometri" "geometrier" ;
  geometriker_nn_1 = mkN "geometriker" "geometrikern" "geometriker" "geometrikerna" ;
  geometrisk_av_1 = mkA "geometrisk" ;
  geomorfologisk_av_1 = mkA "geomorfologisk" ;
  georgier_nn_1 = mkN "georgier" "georgiern" "georgier" "georgierna" ;
  georgisk_av_1 = mkA "georgisk" ;
  georgiska_nn_2 = mkN "georgiska" ;
  georgskors_nn_1 = mkN "georgskors" neutrum ;
  geostationaer_av_1 = mkA "geostationдr" ;
  geosynklinal_nn_1 = mkN "geosynklinal" "geosynklinaler" ;
  geotermisk_av_1 = mkA "geotermisk" ;
  geovetare_nn_1 = mkN "geovetare" "geovetare" ;
  geovetenskap_nn_1 = mkN "geovetenskap" "geovetenskaper" ;
  geovetenskaplig_av_1 = mkA "geovetenskaplig" ;
  gepard_nn_1 = mkN "gepard" "geparder" ;
  geranium_nn_1 = mkN "geranium" "geranien" "geranier" "geranierna" ;
  geriatrisk_av_1 = mkA "geriatrisk" ;
  geridon_nn_1 = mkN "geridon" "geridoner" ;
  geridong_nn_1 = mkN "geridong" "geridonger" ;
  gerilla_nn_1 = mkN "gerilla" ;
  gerillaledare_nn_1 = mkN "gerillaledare" "gerillaledare" ;
  gering_nn_1 = mkN "gering" ;
  german_nn_1 = mkN "german" "germaner" ;
  germanfolk_nn_1 = mkN "germanfolk" neutrum ;
  germanism_nn_1 = mkN "germanism" "germanismer" ;
  germanist_nn_1 = mkN "germanist" "germanister" ;
  germanistisk_av_1 = mkA "germanistisk" ;
  germankrigare_nn_1 = mkN "germankrigare" "germankrigare" ;
  germansk_av_1 = mkA "germansk" ;
  germanstam_nn_1 = mkN "germanstam" "germanstammen" "germanstammar" "germanstammarna" ;
  gerontologisk_av_1 = mkA "gerontologisk" ;
  gers_nn_1 = mkN "gers" ;
  gerundium_nn_1 = mkN "gerundium" "gerundium" "gerundier" "gerundierna" ;
  gerundivum_nn_1 = mkN "gerundivum" "gerundivum" "gerundiver" "gerundiverna" ;
  gesaell_nn_1 = mkN "gesдll" "gesдller" ;
  gesaellbrev_nn_1 = mkN "gesдllbrev" neutrum ;
  gesaellprov_nn_1 = mkN "gesдllprov" neutrum ;
  gesaellvandring_nn_1 = mkN "gesдllvandring" ;
  gesant_nn_1 = mkN "gesant" "gesanter" ;
  geschaeft_nn_1 = mkN "geschдft" neutrum ;
  geschwint_ab_1 = mkAdv "geschwint" ;
  gesims_nn_1 = mkN "gesims" "gesimser" ;
  gesimsbaage_nn_1 = mkN "gesimsbеge" utrum ;
  gesimslist_nn_1 = mkN "gesimslist" "gesimslister" ;
  gest_nn_1 = mkN "gest" "gester" ;
  gestalt_nn_1 = mkN "gestalt" "gestalter" ;
  gestaltning_nn_1 = mkN "gestaltning" ;
  gestikulation_nn_1 = mkN "gestikulation" "gestikulationer" ;
  get_nn_1 = mkN "get" "getter" ;
  getabock_nn_1 = mkN "getabock" ;
  getapel_nn_1 = mkN "getapel" ;
  getfot_nn_1 = mkN "getfot" ;
  geting_nn_1 = mkN "geting" ;
  getingbo_nn_1 = mkN "getingbo" "getingbot" "getingbon" "getingboen" ;
  getingmidja_nn_1 = mkN "getingmidja" ;
  getingstick_nn_1 = mkN "getingstick" neutrum ;
  getmjoelksost_nn_1 = mkN "getmjцlksost" ;
  getoega_nn_1 = mkN "getцga" "getцgat" "getцgon" "getцgonen" ;
  getost_nn_1 = mkN "getost" ;
  getskaegg_nn_1 = mkN "getskдgg" neutrum ;
  getskinn_nn_1 = mkN "getskinn" neutrum ;
  getto_nn_1 = mkN "getto" "gettot" "getton" "gettona" ;
  getvaeppling_nn_1 = mkN "getvдppling" ;
  gevaer_nn_1 = mkN "gevдr" neutrum ;
  gevaersfaktori_nn_1 = mkN "gevдrsfaktori" "gevдrsfaktorit" "gevдrsfaktorier" "gevдrsfaktorierna" ;
  gevaersgranat_nn_1 = mkN "gevдrsgranat" "gevдrsgranater" ;
  gevaerskolv_nn_1 = mkN "gevдrskolv" ;
  gevaerskompani_nn_1 = mkN "gevдrskompani" "gevдrskompanit" "gevдrskompanier" "gevдrskompanierna" ;
  gevaerspatron_nn_1 = mkN "gevдrspatron" "gevдrspatroner" ;
  gevaerspost_nn_1 = mkN "gevдrspost" "gevдrsposter" ;
  gevaerssmed_nn_1 = mkN "gevдrssmed" "gevдrssmeder" ;
  gevaerssmide_nn_1 = mkN "gevдrssmide" ;
  gevaersstock_nn_1 = mkN "gevдrsstock" ;
  gevaldiger_nn_1 = mkN "gevaldiger" "gevaldigern" "gevaldiger" "gevaldigerna" ;
  ghanan_nn_1 = mkN "ghanan" "ghananer" ;
  ghanansk_av_1 = mkA "ghanansk" ;
  ghanes_nn_1 = mkN "ghanes" "ghaneser" ;
  ghanesisk_av_1 = mkA "ghanesisk" ;
  ghasel_nn_1 = mkN "ghasel" "ghaseler" ;
  ghetto_nn_1 = mkN "ghetto" "ghettot" "ghetton" "ghettona" ;
  ghost_writer_nn_1 = mkN "ghost-writer" "ghost-writern" "ghost-writers" "ghost-writersen" ;
  gibbon_nn_1 = mkN "gibbon" "gibboner" ;
  giffel_nn_1 = mkN "giffel" ;
  gift_av_1 = mkA "gift" "gift" ;
  gift_nn_1 = mkN "gift" "giftet" "gifter" "gifterna" ;
  giftapparat_nn_1 = mkN "giftapparat" "giftapparater" ;
  giftasvuxen_av_1 = mkA "giftasvuxen" "giftasvuxet" ;
  giftavdunstning_nn_1 = mkN "giftavdunstning" ;
  giftbaegare_nn_1 = mkN "giftbдgare" "giftbдgare" ;
  giftblandare_nn_1 = mkN "giftblandare" "giftblandare" ;
  giftbok_nn_1 = mkN "giftbok" "giftbцcker" ;
  giftermaal_nn_1 = mkN "giftermеl" neutrum ;
  giftermaalsbalk_nn_1 = mkN "giftermеlsbalk" ;
  giftfri_av_1 = mkA "giftfri" "giftfritt" ;
  giftgas_nn_1 = mkN "giftgas" "giftgaser" ;
  giftgroen_av_1 = mkA "giftgrцn" ;
  gifthalt_nn_1 = mkN "gifthalt" "gifthalter" ;
  giftig_av_1 = mkA "giftig" ;
  giftighet_nn_1 = mkN "giftighet" "giftigheter" ;
  giftkoertel_nn_1 = mkN "giftkцrtel" ;
  giftmaengd_nn_1 = mkN "giftmдngd" "giftmдngder" ;
  giftmoln_nn_1 = mkN "giftmoln" neutrum ;
  giftmord_nn_1 = mkN "giftmord" neutrum ;
  giftoman_nn_1 = mkN "giftoman" "giftomannen" "giftomдn" "giftomдnnen" ;
  giftorm_nn_1 = mkN "giftorm" ;
  giftstadga_nn_1 = mkN "giftstadga" ;
  gifttagg_nn_1 = mkN "gifttagg" ;
  gifttand_nn_1 = mkN "gifttand" "gifttдnder" ;
  gifttransport_nn_1 = mkN "gifttransport" "gifttransporter" ;
  giftverkan_nn_1 = mkN "giftverkan" "giftverkan" "giftverkningar" "giftverkningarna" ;
  gig_nn_1 = mkN "gig" neutrum ;
  gigant_nn_1 = mkN "gigant" "giganter" ;
  gigantisk_av_1 = mkA "gigantisk" ;
  gigaton_nn_1 = mkN "gigaton" "gigatonnet" "gigaton" "gigatonnen" ;
  gigawatt_nn_1 = mkN "gigawatt" "gigawatten" "gigawatt" "gigawatten" ;
  gigg_nn_1 = mkN "gigg" ;
  gigolo_nn_1 = mkN "gigolo" "gigolon" "gigolos" "gigolosen" ;
  gigue_nn_1 = mkN "gigue" "giguer" ;
  giktbruten_av_1 = mkA "giktbruten" "giktbrutet" ;
  giktring_nn_1 = mkN "giktring" ;
  giljare_nn_1 = mkN "giljare" "giljare" ;
  giljarfaerd_nn_1 = mkN "giljarfдrd" "giljarfдrder" ;
  giljotin_nn_1 = mkN "giljotin" "giljotiner" ;
  gill_av_1 = mkA "gill" ;
  gillande_nn_1 = mkN "gillande" ;
  giller_nn_1 = mkN "giller" neutrum ;
  gillesbroder_nn_1 = mkN "gillesbroder" "gillesbrodern" "gillesbrцder" "gillesbrцderna" ;
  gillessocialism_nn_1 = mkN "gillessocialism" "gillessocialismer" ;
  gillestuga_nn_1 = mkN "gillestuga" ;
  giltig_av_1 = mkA "giltig" ;
  giltighet_nn_1 = mkN "giltighet" "giltigheter" ;
  gimmick_nn_1 = mkN "gimmick" ;
  gin_av_1 = mkA "gin" ;
  ginbalk_nn_1 = mkN "ginbalk" ;
  ginnungagap_nn_1 = mkN "ginnungagap" neutrum ;
  ginst_nn_1 = mkN "ginst" "ginster" ;
  ginstkatt_nn_1 = mkN "ginstkatt" "ginstkatter" ;
  ginvaeg_nn_1 = mkN "ginvдg" ;
  gip_nn_1 = mkN "gip" ;
  gipp_nn_1 = mkN "gipp" ;
  gips_nn_1 = mkN "gips" "gipser" ;
  gipsavgjutning_nn_1 = mkN "gipsavgjutning" ;
  gipsfoerband_nn_1 = mkN "gipsfцrband" neutrum ;
  gipsform_nn_1 = mkN "gipsform" ;
  gipyr_nn_1 = mkN "gipyr" "gipyrer" ;
  gir_nn_1 = mkN "gir" ;
  giraff_nn_1 = mkN "giraff" "giraffer" ;
  giraffliknande_av_1 = mkA "giraffliknande" ;
  girandole_nn_1 = mkN "girandole" "girandoler" ;
  girering_nn_1 = mkN "girering" ;
  girig_av_1 = mkA "girig" ;
  girigbuk_nn_1 = mkN "girigbuk" ;
  girland_nn_1 = mkN "girland" "girlander" ;
  giro_nn_1 = mkN "giro" "girot" "giron" "girona" ;
  girobesked_nn_1 = mkN "girobesked" neutrum ;
  girvaext_av_1 = mkA "girvдxt" "girvдxt" ;
  girvuxen_av_1 = mkA "girvuxen" "girvuxet" ;
  gissel_nn_1 = mkN "gissel" neutrum ;
  gisseldjur_nn_1 = mkN "gisseldjur" neutrum ;
  gisslare_nn_1 = mkN "gisslare" "gisslare" ;
  gissning_nn_1 = mkN "gissning" ;
  gissningsvis_ab_1 = mkAdv "gissningsvis" ;
  gisten_av_1 = mkA "gisten" "gistet" ;
  gistgaard_nn_1 = mkN "gistgеrd" ;
  gitarr_nn_1 = mkN "gitarr" "gitarrer" ;
  gitarrist_nn_1 = mkN "gitarrist" "gitarrister" ;
  gitter_nn_1 = mkN "gitter" neutrum ;
  giv_nn_1 = mkN "giv" ;
  givakt_nn_1 = mkN "givakt" "givakter" ;
  givande_av_1 = mkA "givande" ;
  givare_nn_1 = mkN "givare" "givare" ;
  given_av_1 = mkA "given" "givet" ;
  givetvis_ab_1 = mkAdv "givetvis" ;
  givkort_nn_1 = mkN "givkort" neutrum ;
  givmild_av_1 = mkA "givmild" "givmilt" ;
  givmildhet_nn_1 = mkN "givmildhet" "givmildheter" ;
  givning_nn_1 = mkN "givning" ;
  gjord_nn_1 = mkN "gjord" ;
  gjuse_nn_1 = mkN "gjuse" utrum ;
  gjuta_vb_1 = mkV "gjuta" "gцt" "gjutit" ;
  gjutare_nn_1 = mkN "gjutare" "gjutare" ;
  gjutbar_av_1 = mkA "gjutbar" ;
  gjuteri_nn_1 = mkN "gjuteri" "gjuterit" "gjuterier" "gjuterierna" ;
  gjutform_nn_1 = mkN "gjutform" ;
  gjutmodell_nn_1 = mkN "gjutmodell" "gjutmodeller" ;
  gjutning_nn_1 = mkN "gjutning" ;
  gjutrand_nn_1 = mkN "gjutrand" "gjutrдnder" ;
  glaamig_av_1 = mkA "glеmig" ;
  glaapord_nn_1 = mkN "glеpord" neutrum ;
  glacehandske_nn_1 = mkN "glacйhandske" utrum ;
  glaci_nn_1 = mkN "glaci" "glacier" ;
  glaciaer_nn_1 = mkN "glaciдr" "glaciдrer" ;
  glaciaeraelv_nn_1 = mkN "glaciдrдlv" ;
  glaciaerbrunn_nn_1 = mkN "glaciдrbrunn" ;
  glaciaeris_nn_1 = mkN "glaciдris" ;
  glaciaernisch_nn_1 = mkN "glaciдrnisch" "glaciдrnischer" ;
  glaciaerport_nn_1 = mkN "glaciдrport" ;
  glaciaerraeffla_nn_1 = mkN "glaciдrrдffla" ;
  glacial_av_1 = mkA "glacial" ;
  glacialperiod_nn_1 = mkN "glacialperiod" "glacialperioder" ;
  glacialraeffla_nn_1 = mkN "glacialrдffla" ;
  glacifluvial_av_1 = mkA "glacifluvial" ;
  glaciolog_nn_1 = mkN "glaciolog" "glaciologer" ;
  glaciologisk_av_1 = mkA "glaciologisk" ;
  glad_av_1 = mkA "glad" ;
  glad_nn_1 = mkN "glad" neutrum ;
  gladelig_av_1 = mkA "gladelig" ;
  gladeligen_ab_1 = mkAdv "gladeligen" ;
  gladeligt_ab_1 = mkAdv "gladeligt" ;
  gladiator_nn_1 = mkN "gladiator" "gladiatorer" ;
  gladiatorspel_nn_1 = mkN "gladiatorspel" "gladiatorspelet" "gladiatorspel" "gladiatorspelen" ;
  gladiolus_nn_1 = mkN "gladiolus" ;
  gladlig_av_1 = mkA "gladlig" ;
  gladligen_ab_1 = mkAdv "gladligen" ;
  gladlynt_av_1 = mkA "gladlynt" "gladlynt" ;
  glaedjande_av_1 = mkA "glдdjande" ;
  glaedjeaemne_nn_1 = mkN "glдdjeдmne" ;
  glaedjebetygelse_nn_1 = mkN "glдdjebetygelse" "glдdjebetygelser" ;
  glaedjedoedare_nn_1 = mkN "glдdjedцdare" "glдdjedцdare" ;
  glaedjefylld_av_1 = mkA "glдdjefylld" "glдdjefyllt" ;
  glaedjehus_nn_1 = mkN "glдdjehus" neutrum ;
  glaedjekalkyl_nn_1 = mkN "glдdjekalkyl" "glдdjekalkyler" ;
  glaedjekvarter_nn_1 = mkN "glдdjekvarter" "glдdjekvarteret" "glдdjekvarter" "glдdjekvarteren" ;
  glaedjerus_nn_1 = mkN "glдdjerus" neutrum ;
  glaedjestraalande_av_1 = mkA "glдdjestrеlande" ;
  glaensande_av_1 = mkA "glдnsande" ;
  glaettig_av_1 = mkA "glдttig" ;
  glaettighet_nn_1 = mkN "glдttighet" "glдttigheter" ;
  glaettning_nn_1 = mkN "glдttning" ;
  glaettsten_nn_1 = mkN "glдttsten" "glдttstenen" "glдttstenar" "glдttstenarna" ;
  glagolitisk_av_1 = mkA "glagolitisk" ;
  glamoroes_av_1 = mkA "glamorцs" ;
  glamouroes_av_1 = mkA "glamourцs" ;
  glandel_nn_1 = mkN "glandel" "glandeln" "glandler" "glandlerna" ;
  glanduloes_av_1 = mkA "glandulцs" ;
  glansbagge_nn_1 = mkN "glansbagge" utrum ;
  glansfull_av_1 = mkA "glansfull" ;
  glansig_av_1 = mkA "glansig" ;
  glansk_av_1 = mkA "glansk" ;
  glansloes_av_1 = mkA "glanslцs" ;
  glansnummer_nn_1 = mkN "glansnummer" neutrum ;
  glanspapper_nn_1 = mkN "glanspapper" neutrum ;
  glansperiod_nn_1 = mkN "glansperiod" "glansperioder" ;
  glansroll_nn_1 = mkN "glansroll" "glansroller" ;
  glanstid_nn_1 = mkN "glanstid" "glanstider" ;
  glapp_av_1 = mkA "glapp" ;
  glapp_nn_1 = mkN "glapp" neutrum ;
  glapprum_nn_1 = mkN "glapprum" "glapprummet" "glapprum" "glapprummen" ;
  glas_nn_1 = mkN "glas" neutrum ;
  glasaal_nn_1 = mkN "glasеl" ;
  glasbjoerk_nn_1 = mkN "glasbjцrk" ;
  glasblaasare_nn_1 = mkN "glasblеsare" "glasblеsare" ;
  glasblaaseri_nn_1 = mkN "glasblеseri" "glasblеserit" "glasblеserier" "glasblеserierna" ;
  glasbruk_nn_1 = mkN "glasbruk" neutrum ;
  glasbult_nn_1 = mkN "glasbult" ;
  glasering_nn_1 = mkN "glasering" ;
  glasfiber_nn_1 = mkN "glasfiber" "glasfibern" "glasfibrer" "glasfibrerna" ;
  glasfoeremaal_nn_1 = mkN "glasfцremеl" neutrum ;
  glasframstaellning_nn_1 = mkN "glasframstдllning" ;
  glashal_av_1 = mkA "glashal" ;
  glashandduk_nn_1 = mkN "glashandduk" ;
  glashus_nn_1 = mkN "glashus" neutrum ;
  glashuv_nn_1 = mkN "glashuv" ;
  glasig_av_1 = mkA "glasig" ;
  glasighet_nn_1 = mkN "glasighet" "glasigheter" ;
  glasiglo_nn_1 = mkN "glasiglo" "glasiglor" ;
  glasiologisk_av_1 = mkA "glasiologisk" ;
  glasklar_av_1 = mkA "glasklar" ;
  glaskolv_nn_1 = mkN "glaskolv" ;
  glaskropp_nn_1 = mkN "glaskropp" ;
  glasmaalning_nn_1 = mkN "glasmеlning" ;
  glasmaestardiamant_nn_1 = mkN "glasmдstardiamant" "glasmдstardiamanter" ;
  glasmaestare_nn_1 = mkN "glasmдstare" "glasmдstare" ;
  glasmaesteri_nn_1 = mkN "glasmдsteri" "glasmдsterit" "glasmдsterier" "glasmдsterierna" ;
  glasoega_nn_1 = mkN "glasцga" "glasцgat" "glasцgon" "glasцgonen" ;
  glasoegonbaage_nn_1 = mkN "glasцgonbеge" utrum ;
  glasoegonbjoern_nn_1 = mkN "glasцgonbjцrn" ;
  glasoegonorm_nn_1 = mkN "glasцgonorm" ;
  glasprisma_nn_1 = mkN "glasprisma" ;
  glasroer_nn_1 = mkN "glasrцr" neutrum ;
  glass_nn_1 = mkN "glass" ;
  glassbaegare_nn_1 = mkN "glassbдgare" "glassbдgare" ;
  glassbomb_nn_1 = mkN "glassbomb" "glassbomber" ;
  glassdessert_nn_1 = mkN "glassdessert" "glassdesserter" ;
  glassig_av_1 = mkA "glassig" ;
  glasskaerardiamant_nn_1 = mkN "glasskдrardiamant" "glasskдrardiamanter" ;
  glasskaerare_nn_1 = mkN "glasskдrare" "glasskдrare" ;
  glasslipare_nn_1 = mkN "glasslipare" "glasslipare" ;
  glassmaskin_nn_1 = mkN "glassmaskin" "glassmaskiner" ;
  glasspinne_nn_1 = mkN "glasspinne" utrum ;
  glasstrut_nn_1 = mkN "glasstrut" ;
  glasvakt_nn_1 = mkN "glasvakt" "glasvakter" ;
  glasvar_nn_1 = mkN "glasvar" ;
  glasvingefjaeril_nn_1 = mkN "glasvingefjдril" ;
  glasyr_nn_1 = mkN "glasyr" "glasyrer" ;
  glatt_av_1 = mkA "glatt" ;
  glattmask_nn_1 = mkN "glattmask" ;
  glav_nn_1 = mkN "glav" ;
  gles_av_1 = mkA "gles" ;
  glesbygd_nn_1 = mkN "glesbygd" "glesbygder" ;
  gletscher_nn_1 = mkN "gletscher" ;
  gli_nn_1 = mkN "gli" "glit" "glin" "glien" ;
  glid_nn_1 = mkN "glid" neutrum ;
  glida_vb_1 = mkV "glida" "gled" "glidit" ;
  glidkontakt_nn_1 = mkN "glidkontakt" "glidkontakter" ;
  glidkraem_nn_1 = mkN "glidkrдm" "glidkrдmer" ;
  glidlager_nn_1 = mkN "glidlager" neutrum ;
  glidljud_nn_1 = mkN "glidljud" neutrum ;
  glidmedel_nn_1 = mkN "glidmedel" neutrum ;
  glidning_nn_1 = mkN "glidning" ;
  glidtackling_nn_1 = mkN "glidtackling" ;
  glim_nn_1 = mkN "glim" "glimmen" "glim" "glimmen" ;
  glimt_nn_1 = mkN "glimt" ;
  glimtaendare_nn_1 = mkN "glimtдndare" "glimtдndare" ;
  glimtvis_ab_1 = mkAdv "glimtvis" ;
  glinder_nn_1 = mkN "glinder" neutrum ;
  gliom_nn_1 = mkN "gliom" neutrum ;
  gliring_nn_1 = mkN "gliring" ;
  glis_nn_2 = mkN "glis" ;
  glisoert_nn_1 = mkN "glisцrt" "glisцrter" ;
  glissando_nn_1 = mkN "glissando" "glissandot" "glissandon" "glissandona" ;
  glitterglad_av_1 = mkA "glitterglad" ;
  glittrig_av_1 = mkA "glittrig" ;
  glob_nn_1 = mkN "glob" "glober" ;
  global_av_1 = mkA "global" ;
  globetrotter_nn_1 = mkN "globetrotter" ;
  globulin_nn_1 = mkN "globulin" "globuliner" ;
  gloed_nn_1 = mkN "glцd" "glцder" ;
  gloedbaedd_nn_1 = mkN "glцdbдdd" ;
  gloedhet_av_1 = mkA "glцdhet" ;
  gloedhoeg_nn_1 = mkN "glцdhцg" ;
  gloedkatod_nn_1 = mkN "glцdkatod" "glцdkatoder" ;
  gloedkropp_nn_1 = mkN "glцdkropp" ;
  gloedmjuk_av_1 = mkA "glцdmjuk" ;
  gloedning_nn_1 = mkN "glцdning" ;
  gloedstroem_nn_1 = mkN "glцdstrцm" "glцdstrцmmen" "glцdstrцmmar" "glцdstrцmmarna" ;
  gloedtraad_nn_1 = mkN "glцdtrеd" ;
  gloedvarm_av_1 = mkA "glцdvarm" ;
  gloegg_nn_1 = mkN "glцgg" ;
  gloemsk_av_1 = mkA "glцmsk" ;
  glop_nn_1 = mkN "glop" ;
  glorioes_av_1 = mkA "gloriцs" ;
  glosig_av_1 = mkA "glosig" ;
  glosoegd_av_1 = mkA "glosцgd" "glosцgt" ;
  glossar_nn_1 = mkN "glossar" neutrum ;
  glossarium_nn_1 = mkN "glossarium" "glossariet" "glossarier" "glossarierna" ;
  glossematik_nn_1 = mkN "glossematik" "glossematiker" ;
  glossolali_nn_1 = mkN "glossolali" "glossolalier" ;
  glottisstoet_nn_1 = mkN "glottisstцt" ;
  glugg_nn_1 = mkN "glugg" ;
  glunt_nn_1 = mkN "glunt" ;
  glupande_av_1 = mkA "glupande" ;
  glupsk_av_1 = mkA "glupsk" ;
  glutamat_nn_1 = mkN "glutamat" neutrum ;
  glutenfri_av_1 = mkA "glutenfri" "glutenfritt" ;
  glutinoes_av_1 = mkA "glutinцs" ;
  glycerid_nn_1 = mkN "glycerid" "glycerider" ;
  glycin_nn_1 = mkN "glycin" "glyciner" ;
  glykol_nn_1 = mkN "glykol" "glykoler" ;
  glykopeptid_nn_1 = mkN "glykopeptid" "glykopeptider" ;
  glykos_nn_1 = mkN "glykos" "glykoser" ;
  glyptotek_nn_1 = mkN "glyptotek" neutrum ;
  glytt_nn_1 = mkN "glytt" ;
  glyttig_av_1 = mkA "glyttig" ;
  gnabb_nn_1 = mkN "gnabb" neutrum ;
  gnaellig_av_1 = mkA "gnдllig" ;
  gnaellmaans_nn_1 = mkN "gnдllmеns" ;
  gnaellspik_nn_1 = mkN "gnдllspik" ;
  gnagare_nn_1 = mkN "gnagare" "gnagare" ;
  gnagtand_nn_1 = mkN "gnagtand" "gnagtдnder" ;
  gnatig_av_1 = mkA "gnatig" ;
  gnejs_nn_1 = mkN "gnejs" "gnejser" ;
  gnet_nn_1 = mkN "gnet" "gnetter" ;
  gnet_nn_2 = mkN "gnet" ;
  gnetig_av_1 = mkA "gnetig" ;
  gnida_vb_1 = mkV "gnida" "gned" "gnidit" ;
  gnidare_nn_1 = mkN "gnidare" "gnidare" ;
  gniden_av_1 = mkA "gniden" "gnidet" ;
  gnidig_av_1 = mkA "gnidig" ;
  gnidningselektricitet_nn_1 = mkN "gnidningselektricitet" "gnidningselektriciteter" ;
  gnistfaangare_nn_1 = mkN "gnistfеngare" "gnistfеngare" ;
  gnistgaller_nn_1 = mkN "gnistgaller" neutrum ;
  gnistgap_nn_1 = mkN "gnistgap" neutrum ;
  gnistinduktor_nn_1 = mkN "gnistinduktor" "gnistinduktorer" ;
  gnistkammare_nn_1 = mkN "gnistkammare" "gnistkammaren" "gnistkamrar" "gnistkamrarna" ;
  gnistrig_av_1 = mkA "gnistrig" ;
  gnistsaendare_nn_1 = mkN "gnistsдndare" "gnistsдndare" ;
  gnistskydd_nn_1 = mkN "gnistskydd" neutrum ;
  gniststation_nn_1 = mkN "gniststation" "gniststationer" ;
  gnisttaendning_nn_1 = mkN "gnisttдndning" ;
  gnoding_nn_1 = mkN "gnoding" ;
  gnom_nn_1 = mkN "gnom" "gnomer" ;
  gnomiker_nn_1 = mkN "gnomiker" "gnomikern" "gnomiker" "gnomikerna" ;
  gnostiker_nn_1 = mkN "gnostiker" "gnostikern" "gnostiker" "gnostikerna" ;
  gnu_nn_1 = mkN "gnu" "gnun" "gnuer" "gnuerna" ;
  gnuggbild_nn_1 = mkN "gnuggbild" "gnuggbilder" ;
  go_cart_nn_1 = mkN "go-cart" "go-carten" "go-carts" "go-cartsen" ;
  gobelaeng_nn_1 = mkN "gobelдng" "gobelдnger" ;
  gobelaengbroderi_nn_1 = mkN "gobelдngbroderi" "gobelдngbroderit" "gobelдngbroderier" "gobelдngbroderierna" ;
  god_av_1 = mkA "god" ;
  godbit_nn_1 = mkN "godbit" ;
  goddagspilt_nn_1 = mkN "goddagspilt" ;
  gode_nn_1 = mkN "gode" utrum ;
  godhaellig_av_1 = mkA "godhдllig" ;
  godhet_nn_1 = mkN "godhet" "godheter" ;
  godhetsfull_av_1 = mkA "godhetsfull" ;
  godhjaertenhet_nn_1 = mkN "godhjдrtenhet" "godhjдrtenheter" ;
  goding_nn_1 = mkN "goding" ;
  godis_nn_2 = mkN "godis" ;
  godkaend_av_1 = mkA "godkдnd" ;
  godkaennande_nn_1 = mkN "godkдnnande" ;
  godlynt_av_1 = mkA "godlynt" "godlynt" ;
  godmanskap_nn_1 = mkN "godmanskap" "godmanskapet" "godmanskapen" "godmanskapena" ;
  godmodig_av_1 = mkA "godmodig" ;
  gods_nn_1 = mkN "gods" neutrum ;
  godsaegare_nn_1 = mkN "godsдgare" "godsдgare" ;
  godsak_nn_1 = mkN "godsak" "godsaker" ;
  godsexpedition_nn_1 = mkN "godsexpedition" "godsexpeditioner" ;
  godsherre_nn_1 = mkN "godsherre" utrum ;
  godsint_av_1 = mkA "godsint" "godsint" ;
  godsmottagning_nn_1 = mkN "godsmottagning" ;
  godstaag_nn_1 = mkN "godstеg" neutrum ;
  godsvagn_nn_1 = mkN "godsvagn" ;
  godta_vb_1 = mkV "godta" "godtar" "godta" "godtog" "godtagit" "godtagen" ;
  godtagbar_av_1 = mkA "godtagbar" ;
  godtemplare_nn_1 = mkN "godtemplare" "godtemplare" ;
  godtemplarorden_nn_1 = mkN "godtemplarorden" ;
  godtrogen_av_1 = mkA "godtrogen" "godtroget" ;
  godtrosfoervaerv_nn_1 = mkN "godtrosfцrvдrv" neutrum ;
  godtycklig_av_1 = mkA "godtycklig" ;
  godvikt_nn_1 = mkN "godvikt" "godvikter" ;
  godvillig_av_1 = mkA "godvillig" ;
  goeddjur_nn_1 = mkN "gцddjur" neutrum ;
  goedkyckling_nn_1 = mkN "gцdkyckling" ;
  goedning_nn_1 = mkN "gцdning" ;
  goedningsmedel_nn_1 = mkN "gцdningsmedel" neutrum ;
  goedselmedel_nn_1 = mkN "gцdselmedel" neutrum ;
  goedselspridare_nn_1 = mkN "gцdselspridare" "gцdselspridare" ;
  goedselstack_nn_1 = mkN "gцdselstack" ;
  goedselstad_nn_1 = mkN "gцdselstad" "gцdselstдder" ;
  goedsling_nn_1 = mkN "gцdsling" ;
  goejemaanad_nn_1 = mkN "gцjemеnad" "gцjemеnader" ;
  goek_nn_1 = mkN "gцk" ;
  goekblomster_nn_1 = mkN "gцkblomster" neutrum ;
  goekunge_nn_1 = mkN "gцkunge" utrum ;
  goekur_nn_1 = mkN "gцkur" neutrum ;
  goel_nn_1 = mkN "gцl" ;
  goeling_nn_1 = mkN "gцling" ;
  goemfroeig_av_1 = mkA "gцmfrцig" ;
  goemstaelle_nn_1 = mkN "gцmstдlle" ;
  goepen_nn_1 = mkN "gцpen" "gцpenn" "gцpnar" "gцpnarna" ;
  goerare_nn_1 = mkN "gцrare" "gцrare" ;
  goerdel_nn_1 = mkN "gцrdel" ;
  goerdelbaage_nn_1 = mkN "gцrdelbеge" utrum ;
  goerdeldaeck_nn_1 = mkN "gцrdeldдck" neutrum ;
  goerdelfaestning_nn_1 = mkN "gцrdelfдstning" ;
  goerdelmakare_nn_1 = mkN "gцrdelmakare" "gцrdelmakare" ;
  goerlig_av_1 = mkA "gцrlig" ;
  goeromaal_nn_1 = mkN "gцromеl" neutrum ;
  goes_nn_1 = mkN "gцs" ;
  goesstake_nn_1 = mkN "gцsstake" utrum ;
  goet_nn_1 = mkN "gцt" ;
  goet_nn_2 = mkN "gцt" neutrum ;
  goetamaal_nn_1 = mkN "gцtamеl" neutrum ;
  goete_nn_1 = mkN "gцte" utrum ;
  goeteborgare_nn_1 = mkN "gцteborgare" "gцteborgare" ;
  goeteborgsk_av_1 = mkA "gцteborgsk" ;
  goeteborgska_nn_2 = mkN "gцteborgska" ;
  goeteborgsvits_nn_1 = mkN "gцteborgsvits" ;
  goeticistisk_av_1 = mkA "gцticistisk" ;
  goetisk_av_1 = mkA "gцtisk" ;
  goetvalsverk_nn_1 = mkN "gцtvalsverk" neutrum ;
  gold_digger_nn_1 = mkN "gold-digger" "gold-diggern" "gold-diggers" "gold-diggersen" ;
  golf_nn_2 = mkN "golf" "golfer" ;
  golfare_nn_1 = mkN "golfare" "golfare" ;
  golfspel_nn_1 = mkN "golfspel" "golfspelet" "golfspel" "golfspelen" ;
  golgiapparat_nn_1 = mkN "golgiapparat" "golgiapparater" ;
  golv_nn_1 = mkN "golv" neutrum ;
  golvbelaeggning_nn_1 = mkN "golvbelдggning" ;
  golvbjaelke_nn_1 = mkN "golvbjдlke" utrum ;
  golvbraeda_nn_1 = mkN "golvbrдda" ;
  golvbrunn_nn_1 = mkN "golvbrunn" ;
  golvfast_av_1 = mkA "golvfast" "golvfast" ;
  golvkall_av_1 = mkA "golvkall" ;
  golvlaeggare_nn_1 = mkN "golvlдggare" "golvlдggare" ;
  golvramp_nn_1 = mkN "golvramp" "golvramper" ;
  golvur_nn_1 = mkN "golvur" neutrum ;
  golvvaexel_nn_1 = mkN "golvvдxel" ;
  golvvax_nn_1 = mkN "golvvax" "golvvaxet" "golvvaxer" "golvvaxerna" ;
  gom_nn_1 = mkN "gom" "gommen" "gommar" "gommarna" ;
  gombaage_nn_1 = mkN "gombеge" utrum ;
  gomben_nn_1 = mkN "gomben" neutrum ;
  gomljud_nn_1 = mkN "gomljud" neutrum ;
  gomsegel_nn_1 = mkN "gomsegel" neutrum ;
  gomspene_nn_1 = mkN "gomspene" utrum ;
  gon_nn_1 = mkN "gon" "goner" ;
  gonad_nn_1 = mkN "gonad" "gonader" ;
  gondol_nn_1 = mkN "gondol" "gondoler" ;
  gondoljaer_nn_1 = mkN "gondoljдr" "gondoljдrer" ;
  gonfaloniaer_nn_1 = mkN "gonfaloniдr" "gonfaloniдrer" ;
  gonggong_nn_1 = mkN "gonggong" ;
  gonokock_nn_1 = mkN "gonokock" "gonokocker" ;
  gonorre_nn_1 = mkN "gonorrй" "gonorrйer" ;
  goraa_nn_1 = mkN "gorе" "gorеt" "gorеn" "gorеna" ;
  gordonsetter_nn_1 = mkN "gordonsetter" ;
  gorgon_nn_1 = mkN "gorgon" "gorgoner" ;
  gosig_av_1 = mkA "gosig" ;
  gospel_nn_1 = mkN "gospel" "gospeln" "gospel" "gospelna" ;
  gosse_nn_1 = mkN "gosse" utrum ;
  got_nn_1 = mkN "got" "goter" ;
  goticerande_av_1 = mkA "goticerande" ;
  gotiserande_av_1 = mkA "gotiserande" ;
  gotisk_av_1 = mkA "gotisk" ;
  gotlaendsk_av_1 = mkA "gotlдndsk" ;
  gotlaendska_nn_2 = mkN "gotlдndska" ;
  gotlaenning_nn_1 = mkN "gotlдnning" ;
  gotlandsruss_nn_1 = mkN "gotlandsruss" neutrum ;
  gotsk_av_1 = mkA "gotsk" ;
  gottgoerelse_nn_1 = mkN "gottgцrelse" "gottgцrelser" ;
  gottskriva_vb_1 = mkV "gottskriva" "gottskrev" "gottskrivit" ;
  gouache_nn_1 = mkN "gouache" "gouacher" ;
  gourmand_nn_1 = mkN "gourmand" "gourmander" ;
  gourme_nn_1 = mkN "gourmй" "gourmйer" ;
  gourmet_nn_1 = mkN "gourmet" "gourmeter" ;
  graa_av_1 = mkA "grе" "grеtt" ;
  graaaktig_av_1 = mkA "grеaktig" ;
  graaal_nn_1 = mkN "grеal" ;
  graablaa_av_1 = mkA "grеblе" "grеblеtt" ;
  graablek_av_1 = mkA "grеblek" ;
  graabo_nn_1 = mkN "grеbo" "grеbor" ;
  graabroder_nn_1 = mkN "grеbroder" "grеbrodern" "grеbrцder" "grеbrцderna" ;
  graadaskig_av_1 = mkA "grеdaskig" ;
  graaflaeckig_av_1 = mkA "grеflдckig" ;
  graagaas_nn_1 = mkN "grеgеs" "grеgеsen" "grеgдss" "grеgдssen" ;
  graagosse_nn_1 = mkN "grеgosse" utrum ;
  graagroen_av_1 = mkA "grеgrцn" ;
  graagyllen_nn_1 = mkN "grеgyllen" "grеgyllen" "grеgyllen" "grеgyllena" ;
  graahaarig_av_1 = mkA "grеhеrig" ;
  graahaeger_nn_1 = mkN "grеhдger" ;
  graahund_nn_1 = mkN "grеhund" ;
  graakall_av_1 = mkA "grеkall" ;
  graalax_nn_1 = mkN "grеlax" ;
  graalle_nn_1 = mkN "grеlle" utrum ;
  graames_nn_1 = mkN "grеmes" ;
  graamunk_nn_1 = mkN "grеmunk" ;
  graapaeron_nn_1 = mkN "grеpдron" neutrum ;
  graasael_nn_1 = mkN "grеsдl" ;
  graasej_nn_1 = mkN "grеsej" ;
  graasiska_nn_1 = mkN "grеsiska" ;
  graaskaeckig_av_1 = mkA "grеskдckig" ;
  graaskaegg_nn_1 = mkN "grеskдgg" neutrum ;
  graaskimlig_av_1 = mkA "grеskimlig" ;
  graaskimmel_nn_1 = mkN "grеskimmel" "grеskimmeln" "grеskimmlar" "grеskimmlarna" ;
  graasosse_nn_1 = mkN "grеsosse" utrum ;
  graasparv_nn_1 = mkN "grеsparv" ;
  graaspett_nn_1 = mkN "grеspett" ;
  graaspraengd_av_1 = mkA "grеsprдngd" "grеsprдngt" ;
  graasten_nn_1 = mkN "grеsten" "grеstenen" "grеstenar" "grеstenarna" ;
  graasvart_av_1 = mkA "grеsvart" "grеsvart" ;
  graaterska_nn_1 = mkN "grеterska" ;
  graatfaerdig_av_1 = mkA "grеtfдrdig" ;
  graatmild_av_1 = mkA "grеtmild" "grеtmilt" ;
  graaton_nn_1 = mkN "grеton" "grеtoner" ;
  graatrut_nn_1 = mkN "grеtrut" ;
  grabb_nn_1 = mkN "grabb" ;
  grabbatag_nn_1 = mkN "grabbatag" neutrum ;
  grabbnaeve_nn_1 = mkN "grabbnдve" utrum ;
  grace_nn_1 = mkN "grace" "gracer" ;
  gracil_av_1 = mkA "gracil" ;
  gracioes_av_1 = mkA "graciцs" ;
  grad_nn_1 = mkN "grad" "grader" ;
  gradaeng_nn_1 = mkN "gradдng" "gradдnger" ;
  gradation_nn_1 = mkN "gradation" "gradationer" ;
  gradbeteckning_nn_1 = mkN "gradbeteckning" ;
  gradboejning_nn_1 = mkN "gradbцjning" ;
  graderverk_nn_1 = mkN "graderverk" neutrum ;
  gradient_nn_1 = mkN "gradient" "gradienter" ;
  gradlist_nn_1 = mkN "gradlist" "gradlister" ;
  gradmaetare_nn_1 = mkN "gradmдtare" "gradmдtare" ;
  gradmaetning_nn_1 = mkN "gradmдtning" ;
  gradmejsel_nn_1 = mkN "gradmejsel" ;
  gradnaet_nn_1 = mkN "gradnдt" neutrum ;
  gradsaag_nn_1 = mkN "gradsеg" ;
  gradskillnad_nn_1 = mkN "gradskillnad" "gradskillnader" ;
  gradstreck_nn_1 = mkN "gradstreck" neutrum ;
  gradtal_nn_1 = mkN "gradtal" "gradtalet" "gradtalen" "gradtalena" ;
  gradtapp_nn_1 = mkN "gradtapp" ;
  gradtecken_nn_1 = mkN "gradtecken" "gradtecknet" "gradtecken" "gradtecknen" ;
  gradualavhandling_nn_1 = mkN "gradualavhandling" ;
  gradualpsalm_nn_1 = mkN "gradualpsalm" "gradualpsalmer" ;
  graduell_av_1 = mkA "graduell" ;
  gradvis_ab_1 = mkAdv "gradvis" ;
  gradvis_av_1 = mkA "gradvis" ;
  graeddbakelse_nn_1 = mkN "grдddbakelse" "grдddbakelser" ;
  graeddhalt_nn_1 = mkN "grдddhalt" "grдddhalter" ;
  graeddig_av_1 = mkA "grдddig" ;
  graeddmaetare_nn_1 = mkN "grдddmдtare" "grдddmдtare" ;
  graeddvisp_nn_1 = mkN "grдddvisp" ;
  grael_nn_1 = mkN "grдl" neutrum ;
  graelaktig_av_1 = mkA "grдlaktig" ;
  graelig_av_1 = mkA "grдlig" ;
  graell_av_1 = mkA "grдll" ;
  graelmaans_nn_1 = mkN "grдlmеns" ;
  graelmakare_nn_1 = mkN "grдlmakare" "grдlmakare" ;
  graelsjuk_av_1 = mkA "grдlsjuk" ;
  graemelse_nn_1 = mkN "grдmelse" "grдmelser" ;
  graen_nn_1 = mkN "grдn" neutrum ;
  graend_nn_1 = mkN "grдnd" "grдnder" ;
  graeng_nn_1 = mkN "grдng" "grдnger" ;
  graens_nn_1 = mkN "grдns" "grдnser" ;
  graensbevakning_nn_1 = mkN "grдnsbevakning" ;
  graensbo_nn_1 = mkN "grдnsbo" "grдnsbor" ;
  graensfall_nn_1 = mkN "grдnsfall" neutrum ;
  graensintaekt_nn_1 = mkN "grдnsintдkt" "grдnsintдkter" ;
  graensjaegare_nn_1 = mkN "grдnsjдgare" "grдnsjдgare" ;
  graenskontroll_nn_1 = mkN "grдnskontroll" "grдnskontroller" ;
  graenskostnad_nn_1 = mkN "grдnskostnad" "grдnskostnader" ;
  graensle_ab_1 = mkAdv "grдnsle" ;
  graenslinje_nn_1 = mkN "grдnslinje" "grдnslinjer" ;
  graensloes_av_1 = mkA "grдnslцs" ;
  graensnytta_nn_1 = mkN "grдnsnytta" ;
  graensoeverskridande_av_1 = mkA "grдnsцverskridande" ;
  graensoeverskridande_nn_1 = mkN "grдnsцverskridande" ;
  graensomraade_nn_1 = mkN "grдnsomrеde" ;
  graenspaale_nn_1 = mkN "grдnspеle" utrum ;
  graenspolis_nn_1 = mkN "grдnspolis" "grдnspoliser" ;
  graensskikt_nn_1 = mkN "grдnsskikt" neutrum ;
  graenstrakt_nn_1 = mkN "grдnstrakt" "grдnstrakter" ;
  graensvaerde_nn_1 = mkN "grдnsvдrde" ;
  graes_nn_1 = mkN "grдs" neutrum ;
  graesaenkling_nn_1 = mkN "grдsдnkling" ;
  graesaetare_nn_1 = mkN "grдsдtare" "grдsдtare" ;
  graesand_nn_1 = mkN "grдsand" "grдsдnder" ;
  graesfjaeril_nn_1 = mkN "grдsfjдril" ;
  graesfly_nn_1 = mkN "grдsfly" "grдsflyt" "grдsflyn" "grдsflyen" ;
  graesklippare_nn_1 = mkN "grдsklippare" "grдsklippare" ;
  graeslig_av_1 = mkA "grдslig" ;
  graeslighet_nn_1 = mkN "grдslighet" "grдsligheter" ;
  graesliknande_av_1 = mkA "grдsliknande" ;
  graesmaanad_nn_1 = mkN "grдsmеnad" "grдsmеnader" ;
  graesmask_nn_1 = mkN "grдsmask" ;
  graesplan_nn_1 = mkN "grдsplan" "grдsplaner" ;
  graesrot_nn_1 = mkN "grдsrot" "grдsrцtter" ;
  graesvall_nn_1 = mkN "grдsvall" ;
  graetten_av_1 = mkA "grдtten" "grдttet" ;
  graevling_nn_1 = mkN "grдvling" ;
  graevlingsgryt_nn_1 = mkN "grдvlingsgryt" neutrum ;
  graevlingshund_nn_1 = mkN "grдvlingshund" ;
  graevmaskin_nn_1 = mkN "grдvmaskin" "grдvmaskiner" ;
  graevning_nn_1 = mkN "grдvning" ;
  graevsvin_nn_1 = mkN "grдvsvin" neutrum ;
  graf_nn_1 = mkN "graf" "grafer" ;
  grafem_nn_1 = mkN "grafem" neutrum ;
  grafematisk_av_1 = mkA "grafematisk" ;
  grafiker_nn_1 = mkN "grafiker" "grafikern" "grafiker" "grafikerna" ;
  grafisk_av_1 = mkA "grafisk" ;
  grafit_nn_1 = mkN "grafit" "grafiter" ;
  grafitdegel_nn_1 = mkN "grafitdegel" ;
  grafitgraa_av_1 = mkA "grafitgrе" "grafitgrеtt" ;
  grafolog_nn_1 = mkN "grafolog" "grafologer" ;
  grafonomisk_av_1 = mkA "grafonomisk" ;
  grafteori_nn_1 = mkN "grafteori" "grafteorier" ;
  gram_nn_1 = mkN "gram" "grammet" "gram" "grammen" ;
  gramkalori_nn_1 = mkN "gramkalori" "gramkalorier" ;
  grammatik_nn_1 = mkN "grammatik" "grammatiker" ;
  grammatikalisk_av_1 = mkA "grammatikalisk" ;
  grammatikbok_nn_1 = mkN "grammatikbok" "grammatikbцcker" ;
  grammatiker_nn_1 = mkN "grammatiker" "grammatikern" "grammatiker" "grammatikerna" ;
  grammatikregel_nn_1 = mkN "grammatikregel" "grammatikregeln" "grammatikregler" "grammatikreglerna" ;
  grammatisk_av_1 = mkA "grammatisk" ;
  grammofon_nn_1 = mkN "grammofon" "grammofoner" ;
  grammofonarkiv_nn_1 = mkN "grammofonarkiv" neutrum ;
  grammofonstift_nn_1 = mkN "grammofonstift" neutrum ;
  grammolekyl_nn_1 = mkN "grammolekyl" "grammolekyler" ;
  gramse_av_1 = mkA "gramse" ;
  gran_nn_1 = mkN "gran" ;
  gran_nn_2 = mkN "gran" neutrum ;
  granat_nn_1 = mkN "granat" "granater" ;
  granatgevaer_nn_1 = mkN "granatgevдr" neutrum ;
  granatkartesch_nn_1 = mkN "granatkartesch" "granatkartescher" ;
  granbarrlus_nn_1 = mkN "granbarrlus" "granbarrlusen" "granbarrlцss" "granbarrlцssen" ;
  grand_nn_2 = mkN "grand" "grander" ;
  grandios_av_1 = mkA "grandios" ;
  grandseigneur_nn_1 = mkN "grandseigneur" "grandseigneurer" ;
  granit_nn_1 = mkN "granit" "graniter" ;
  grann_av_1 = mkA "grann" "grant" ;
  granne_nn_1 = mkN "granne" utrum ;
  granneligen_ab_1 = mkAdv "granneligen" ;
  grannlaat_nn_1 = mkN "grannlеt" "grannlеter" ;
  grannlaga_av_1 = mkA "grannlaga" ;
  grannland_nn_1 = mkN "grannland" "grannlandet" "grannlдnder" "grannlдnderna" ;
  grannskap_nn_1 = mkN "grannskap" "grannskapet" "grannskapen" "grannskapena" ;
  grannstat_nn_1 = mkN "grannstat" "grannstater" ;
  grannsynt_av_1 = mkA "grannsynt" "grannsynt" ;
  granntyckt_av_1 = mkA "granntyckt" "granntyckt" ;
  gransaangare_nn_1 = mkN "gransеngare" "gransеngare" ;
  granskare_nn_1 = mkN "granskare" "granskare" ;
  granskning_nn_1 = mkN "granskning" ;
  granskningsexemplar_nn_1 = mkN "granskningsexemplar" neutrum ;
  granskningsman_nn_1 = mkN "granskningsman" "granskningsmannen" "granskningsmдn" "granskningsmдnnen" ;
  granskog_nn_1 = mkN "granskog" ;
  gransort_nn_1 = mkN "gransort" "gransorter" ;
  granulat_nn_1 = mkN "granulat" neutrum ;
  granulation_nn_1 = mkN "granulation" "granulationer" ;
  granulationsvaevnad_nn_1 = mkN "granulationsvдvnad" "granulationsvдvnader" ;
  granulering_nn_1 = mkN "granulering" ;
  granulum_nn_1 = mkN "granulum" "granulum" "granula" "granulana" ;
  grapefrukt_nn_1 = mkN "grapefrukt" "grapefrukter" ;
  grataeng_nn_1 = mkN "gratдng" "gratдnger" ;
  gratial_nn_1 = mkN "gratial" "gratialer" ;
  gratialist_nn_1 = mkN "gratialist" "gratialister" ;
  gratie_nn_1 = mkN "gratie" "gratier" ;
  gratifikation_nn_1 = mkN "gratifikation" "gratifikationer" ;
  gratin_nn_1 = mkN "gratin" "gratiner" ;
  gratis_ab_1 = mkAdv "gratis" ;
  gratis_av_1 = mkA "gratis" ;
  gratisaktie_nn_1 = mkN "gratisaktie" "gratisaktier" ;
  gratispassagerare_nn_1 = mkN "gratispassagerare" "gratispassagerare" ;
  gratulant_nn_1 = mkN "gratulant" "gratulanter" ;
  gratulation_nn_1 = mkN "gratulation" "gratulationer" ;
  grav_av_1 = mkA "grav" ;
  grav_nn_1 = mkN "grav" ;
  gravallvarlig_av_1 = mkA "gravallvarlig" ;
  gravand_nn_1 = mkN "gravand" "gravдnder" ;
  gravation_nn_1 = mkN "gravation" "gravationer" ;
  gravbrev_nn_1 = mkN "gravbrev" neutrum ;
  gravbyggnad_nn_1 = mkN "gravbyggnad" "gravbyggnader" ;
  grave_ab_1 = mkAdv "grave" ;
  gravenstein_nn_1 = mkN "gravenstein" "gravensteiner" ;
  graverande_av_1 = mkA "graverande" ;
  gravering_nn_1 = mkN "gravering" ;
  gravfaelt_nn_1 = mkN "gravfдlt" neutrum ;
  gravfynd_nn_1 = mkN "gravfynd" neutrum ;
  gravgaas_nn_1 = mkN "gravgеs" "gravgеsen" "gravgдss" "gravgдssen" ;
  gravhoeg_nn_1 = mkN "gravhцg" ;
  graviditet_nn_1 = mkN "graviditet" "graviditeter" ;
  graviditetstest_nn_1 = mkN "graviditetstest" neutrum ;
  graviditetsvecka_nn_1 = mkN "graviditetsvecka" ;
  gravimeter_nn_1 = mkN "gravimeter" ;
  gravitationskonstant_nn_1 = mkN "gravitationskonstant" "gravitationskonstanter" ;
  gravitationskraft_nn_1 = mkN "gravitationskraft" "gravitationskrafter" ;
  gravitationslag_nn_1 = mkN "gravitationslag" ;
  gravitationsstraalning_nn_1 = mkN "gravitationsstrеlning" ;
  gravitet_nn_1 = mkN "gravitet" "graviteter" ;
  gravitetisk_av_1 = mkA "gravitetisk" ;
  graviton_nn_1 = mkN "graviton" "gravitoner" ;
  gravkapell_nn_1 = mkN "gravkapell" neutrum ;
  gravkor_nn_1 = mkN "gravkor" neutrum ;
  gravkummel_nn_1 = mkN "gravkummel" "gravkummlet" "gravkummel" "gravkummlen" ;
  gravkyrka_nn_1 = mkN "gravkyrka" ;
  gravlax_nn_1 = mkN "gravlax" ;
  gravlik_av_1 = mkA "gravlik" ;
  gravmaterial_nn_1 = mkN "gravmaterial" neutrum ;
  gravoel_nn_1 = mkN "gravцl" neutrum ;
  gravoeppning_nn_1 = mkN "gravцppning" ;
  gravoer_nn_1 = mkN "gravцr" "gravцrer" ;
  gravplats_nn_1 = mkN "gravplats" "gravplatser" ;
  gravsaettning_nn_1 = mkN "gravsдttning" ;
  gravsed_nn_1 = mkN "gravsed" "gravseder" ;
  gravskaendning_nn_1 = mkN "gravskдndning" ;
  gravskick_nn_1 = mkN "gravskick" neutrum ;
  gravsten_nn_1 = mkN "gravsten" "gravstenen" "gravstenar" "gravstenarna" ;
  gravstickel_nn_1 = mkN "gravstickel" ;
  gravsvepning_nn_1 = mkN "gravsvepning" ;
  gravvaard_nn_1 = mkN "gravvеrd" ;
  gravvalv_nn_1 = mkN "gravvalv" neutrum ;
  gravyr_nn_1 = mkN "gravyr" "gravyrer" ;
  gray_nn_1 = mkN "gray" "grayen" "gray" "grayen" ;
  grecism_nn_1 = mkN "grecism" "grecismer" ;
  gredelin_av_1 = mkA "gredelin" ;
  green_nn_1 = mkN "green" "greener" ;
  gregoriansk_av_1 = mkA "gregoriansk" ;
  grej_nn_1 = mkN "grej" "grejer" ;
  grek_nn_1 = mkN "grek" "greker" ;
  grekcypriot_nn_1 = mkN "grekcypriot" "grekcyprioter" ;
  grekinna_nn_1 = mkN "grekinna" ;
  grekisk_av_1 = mkA "grekisk" ;
  grekisk_katolsk_av_1 = mkA "grekisk-katolsk" ;
  grekisk_ortodox_av_1 = mkA "grekisk-ortodox" ;
  grekisk_romersk_av_1 = mkA "grekisk-romersk" ;
  grekiska_nn_2 = mkN "grekiska" ;
  gren_nn_1 = mkN "gren" "grenen" "grenar" "grenarna" ;
  grenadier_nn_1 = mkN "grenadier" "grenadiern" "grenadier" "grenadierna" ;
  grenadin_nn_1 = mkN "grenadin" "grenadiner" ;
  grenadisk_av_1 = mkA "grenadisk" ;
  grenadjaer_nn_1 = mkN "grenadjдr" "grenadjдrer" ;
  grenhopp_nn_1 = mkN "grenhopp" neutrum ;
  grenig_av_1 = mkA "grenig" ;
  grenledning_nn_1 = mkN "grenledning" ;
  grenljus_nn_1 = mkN "grenljus" neutrum ;
  grensle_ab_1 = mkAdv "grensle" ;
  grenstaaende_av_1 = mkA "grenstеende" ;
  grenuttag_nn_1 = mkN "grenuttag" neutrum ;
  grenveck_nn_1 = mkN "grenveck" neutrum ;
  grenvinkel_nn_1 = mkN "grenvinkel" ;
  grep_nn_1 = mkN "grep" "greper" ;
  grepe_nn_1 = mkN "grepe" utrum ;
  grepp_nn_1 = mkN "grepp" neutrum ;
  greppbraede_nn_1 = mkN "greppbrдde" ;
  greppriktig_av_1 = mkA "greppriktig" ;
  greve_nn_1 = mkN "greve" utrum ;
  grevinna_nn_1 = mkN "grevinna" ;
  grevlig_av_1 = mkA "grevlig" ;
  grevskap_nn_1 = mkN "grevskap" "grevskapet" "grevskapen" "grevskapena" ;
  greyhound_nn_1 = mkN "greyhound" "greyhounden" "greyhounds" "greyhoundsen" ;
  griffel_nn_1 = mkN "griffel" ;
  griffeltavla_nn_1 = mkN "griffeltavla" ;
  grift_nn_1 = mkN "grift" "grifter" ;
  griftetal_nn_1 = mkN "griftetal" "griftetalet" "griftetalen" "griftetalena" ;
  grill_nn_1 = mkN "grill" ;
  grillbar_nn_1 = mkN "grillbar" "grillbarer" ;
  grillfaengeri_nn_1 = mkN "grillfдngeri" "grillfдngerit" "grillfдngerier" "grillfдngerierna" ;
  grilljanne_nn_1 = mkN "grilljanne" utrum ;
  grillspett_nn_1 = mkN "grillspett" neutrum ;
  grimas_nn_1 = mkN "grimas" "grimaser" ;
  grimskaft_nn_1 = mkN "grimskaft" neutrum ;
  grin_nn_1 = mkN "grin" neutrum ;
  grind_nn_1 = mkN "grind" ;
  grindoeppning_nn_1 = mkN "grindцppning" ;
  grindslant_nn_1 = mkN "grindslant" ;
  grindstuga_nn_1 = mkN "grindstuga" ;
  grindval_nn_1 = mkN "grindval" ;
  gringo_nn_1 = mkN "gringo" "gringon" "gringos" "gringosen" ;
  grinig_av_1 = mkA "grinig" ;
  grinolle_nn_1 = mkN "grinolle" utrum ;
  grip_nn_1 = mkN "grip" ;
  gripa_vb_1 = mkV "gripa" "grep" "gripit" ;
  gripande_av_1 = mkA "gripande" ;
  gripbar_av_1 = mkA "gripbar" ;
  gripen_av_1 = mkA "gripen" "gripet" ;
  gripfot_nn_1 = mkN "gripfot" "gripfцtter" ;
  gris_nn_1 = mkN "gris" ;
  grisaille_nn_1 = mkN "grisaille" "grisailler" ;
  griseri_nn_1 = mkN "griseri" "griserit" "griserier" "griserierna" ;
  grisett_nn_1 = mkN "grisett" "grisetter" ;
  grisig_av_1 = mkA "grisig" ;
  grisinsulin_nn_1 = mkN "grisinsulin" "grisinsuliner" ;
  griskulting_nn_1 = mkN "griskulting" ;
  grisning_nn_1 = mkN "grisning" ;
  grisningsbo_nn_1 = mkN "grisningsbo" "grisningsbot" "grisningsbon" "grisningsboen" ;
  grisoega_nn_1 = mkN "grisцga" "grisцgat" "grisцgon" "grisцgonen" ;
  grissel_nn_1 = mkN "grissel" ;
  grissvans_nn_1 = mkN "grissvans" ;
  grisunge_nn_1 = mkN "grisunge" utrum ;
  grizzlybjoern_nn_1 = mkN "grizzlybjцrn" ;
  grobarhet_nn_1 = mkN "grobarhet" "grobarheter" ;
  grobian_nn_1 = mkN "grobian" "grobianer" ;
  groblad_nn_1 = mkN "groblad" neutrum ;
  grodd_nn_1 = mkN "grodd" ;
  groddblad_nn_1 = mkN "groddblad" neutrum ;
  groddjur_nn_1 = mkN "groddjur" neutrum ;
  groddknopp_nn_1 = mkN "groddknopp" ;
  grodfisk_nn_1 = mkN "grodfisk" ;
  grodlaar_nn_1 = mkN "grodlеr" neutrum ;
  grodman_nn_1 = mkN "grodman" "grodmannen" "grodmдn" "grodmдnnen" ;
  groen_av_1 = mkA "grцn" ;
  groenalg_nn_1 = mkN "grцnalg" "grцnalger" ;
  groenblek_av_1 = mkA "grцnblek" ;
  groenblind_av_1 = mkA "grцnblind" ;
  groenfink_nn_1 = mkN "grцnfink" ;
  groengoeling_nn_1 = mkN "grцngцling" ;
  groengul_av_1 = mkA "grцngul" ;
  groening_nn_1 = mkN "grцning" ;
  groenkoepingsmaessig_av_1 = mkA "grцnkцpingsmдssig" ;
  groenlaendare_nn_1 = mkN "grцnlдndare" "grцnlдndare" ;
  groenlaendsk_av_1 = mkA "grцnlдndsk" ;
  groenlaendska_nn_2 = mkN "grцnlдndska" ;
  groenlandsval_nn_1 = mkN "grцnlandsval" ;
  groenling_nn_1 = mkN "grцnling" ;
  groenmoegelost_nn_1 = mkN "grцnmцgelost" ;
  groenmoerk_av_1 = mkA "grцnmцrk" ;
  groenmogen_av_1 = mkA "grцnmogen" "grцnmoget" ;
  groenmognad_nn_1 = mkN "grцnmognad" "grцnmognader" ;
  groenomraade_nn_1 = mkN "grцnomrеde" ;
  groenraett_nn_1 = mkN "grцnrдtt" "grцnrдtter" ;
  groensak_nn_1 = mkN "grцnsak" "grцnsaker" ;
  groensaksblandning_nn_1 = mkN "grцnsaksblandning" ;
  groensakstallrik_nn_1 = mkN "grцnsakstallrik" ;
  groensallad_nn_1 = mkN "grцnsallad" "grцnsallader" ;
  groensiska_nn_1 = mkN "grцnsiska" ;
  groenspett_nn_1 = mkN "grцnspett" ;
  groepning_nn_1 = mkN "grцpning" ;
  groet_nn_1 = mkN "grцt" ;
  groetfrukost_nn_1 = mkN "grцtfrukost" ;
  groetig_av_1 = mkA "grцtig" ;
  groetmyndig_av_1 = mkA "grцtmyndig" ;
  groetomslag_nn_1 = mkN "grцtomslag" neutrum ;
  groetrim_nn_1 = mkN "grцtrim" "grцtrimmet" "grцtrim" "grцtrimmen" ;
  groetrock_nn_1 = mkN "grцtrock" ;
  grogg_nn_1 = mkN "grogg" ;
  groggy_av_1 = mkA "groggy" ;
  grogrund_nn_1 = mkN "grogrund" "grogrunder" ;
  grop_nn_1 = mkN "grop" ;
  gropig_av_1 = mkA "gropig" ;
  groschen_nn_1 = mkN "groschen" "groschenen" "groschen" "groschenen" ;
  gross_nn_1 = mkN "gross" neutrum ;
  grossess_nn_1 = mkN "grossess" "grossesser" ;
  grosshandlare_nn_1 = mkN "grosshandlare" "grosshandlare" ;
  grossist_nn_1 = mkN "grossist" "grossister" ;
  grossistpris_nn_1 = mkN "grossistpris" neutrum ;
  grossoer_nn_1 = mkN "grossцr" "grossцrer" ;
  grotesk_av_1 = mkA "grotesk" ;
  grotesk_nn_1 = mkN "grotesk" "grotesker" ;
  groteskeri_nn_1 = mkN "groteskeri" "groteskerit" "groteskerier" "groteskerierna" ;
  grottbjoern_nn_1 = mkN "grottbjцrn" ;
  grottforskare_nn_1 = mkN "grottforskare" "grottforskare" ;
  grottgaang_nn_1 = mkN "grottgеng" ;
  grottingaang_nn_1 = mkN "grottingеng" ;
  grottinvaanare_nn_1 = mkN "grottinvеnare" "grottinvеnare" ;
  grottmaalning_nn_1 = mkN "grottmеlning" ;
  grottmaenniska_nn_1 = mkN "grottmдnniska" ;
  groupie_nn_1 = mkN "groupie" "groupien" "groupies" "groupiesen" ;
  grov_av_1 = mkA "grov" "grцvre" "grцvst" ;
  grovarbetare_nn_1 = mkN "grovarbetare" "grovarbetare" ;
  grovhet_nn_1 = mkN "grovhet" "grovheter" ;
  grovhuggen_av_1 = mkA "grovhuggen" "grovhugget" ;
  grovkoek_nn_1 = mkN "grovkцk" neutrum ;
  grovkornig_av_1 = mkA "grovkornig" ;
  grovlek_nn_1 = mkN "grovlek" ;
  grovsyssla_nn_1 = mkN "grovsyssla" ;
  grovtarm_nn_1 = mkN "grovtarm" ;
  grubblare_nn_1 = mkN "grubblare" "grubblare" ;
  grubbleri_nn_1 = mkN "grubbleri" "grubblerit" "grubblerier" "grubblerierna" ;
  gruff_nn_1 = mkN "gruff" neutrum ;
  grumlig_av_1 = mkA "grumlig" ;
  grumling_nn_1 = mkN "grumling" ;
  grumsig_av_1 = mkA "grumsig" ;
  grund_av_1 = mkA "grund" ;
  grund_nn_1 = mkN "grund" "grunder" ;
  grund_nn_2 = mkN "grund" neutrum ;
  grundackord_nn_1 = mkN "grundackord" neutrum ;
  grundaemne_nn_1 = mkN "grundдmne" ;
  grundare_nn_1 = mkN "grundare" "grundare" ;
  grundavdrag_nn_1 = mkN "grundavdrag" neutrum ;
  grundavgift_nn_1 = mkN "grundavgift" "grundavgifter" ;
  grundbelopp_nn_1 = mkN "grundbelopp" neutrum ;
  grundbetydelse_nn_1 = mkN "grundbetydelse" "grundbetydelser" ;
  grundbok_nn_1 = mkN "grundbok" "grundbцcker" ;
  grundbrott_nn_1 = mkN "grundbrott" neutrum ;
  grundbult_nn_1 = mkN "grundbult" ;
  grunddrag_nn_1 = mkN "grunddrag" neutrum ;
  grundenhet_nn_1 = mkN "grundenhet" "grundenheter" ;
  grundfaerg_nn_1 = mkN "grundfдrg" "grundfдrger" ;
  grundfalsk_av_1 = mkA "grundfalsk" ;
  grundfoerbaettring_nn_1 = mkN "grundfцrbдttring" ;
  grundform_nn_1 = mkN "grundform" "grundformer" ;
  grundhav_nn_1 = mkN "grundhav" neutrum ;
  grundkaenning_nn_1 = mkN "grundkдnning" ;
  grundkraft_nn_1 = mkN "grundkraft" "grundkrafter" ;
  grundkurs_nn_1 = mkN "grundkurs" "grundkurser" ;
  grundlaeggande_av_1 = mkA "grundlдggande" ;
  grundlaeggare_nn_1 = mkN "grundlдggare" "grundlдggare" ;
  grundlaeggning_nn_1 = mkN "grundlдggning" ;
  grundlag_nn_1 = mkN "grundlag" ;
  grundlag_nn_2 = mkN "grundlag" neutrum ;
  grundlig_av_1 = mkA "grundlig" ;
  grundligen_ab_1 = mkAdv "grundligen" ;
  grundlighet_nn_1 = mkN "grundlighet" "grundligheter" ;
  grundlinje_nn_1 = mkN "grundlinje" "grundlinjer" ;
  grundloen_nn_1 = mkN "grundlцn" "grundlцner" ;
  grundloes_av_1 = mkA "grundlцs" ;
  grundmaatt_nn_1 = mkN "grundmеtt" neutrum ;
  grundning_nn_1 = mkN "grundning" ;
  grundord_nn_1 = mkN "grundord" neutrum ;
  grundorsak_nn_1 = mkN "grundorsak" "grundorsaker" ;
  grundpelare_nn_1 = mkN "grundpelare" "grundpelare" ;
  grundperiod_nn_1 = mkN "grundperiod" "grundperioder" ;
  grundplaat_nn_1 = mkN "grundplеt" ;
  grundsats_nn_1 = mkN "grundsats" "grundsatser" ;
  grundskolelaerare_nn_1 = mkN "grundskolelдrare" "grundskolelдrare" ;
  grundskott_nn_1 = mkN "grundskott" neutrum ;
  grundspraak_nn_1 = mkN "grundsprеk" neutrum ;
  grundstam_nn_1 = mkN "grundstam" "grundstammen" "grundstammar" "grundstammarna" ;
  grundsten_nn_1 = mkN "grundsten" "grundstenen" "grundstenar" "grundstenarna" ;
  grundstoetning_nn_1 = mkN "grundstцtning" ;
  grundtal_nn_1 = mkN "grundtal" "grundtalet" "grundtalen" "grundtalena" ;
  grundtanke_nn_1 = mkN "grundtanke" utrum ;
  grundteori_nn_1 = mkN "grundteori" "grundteorier" ;
  grundton_nn_1 = mkN "grundton" "grundtoner" ;
  grundutbildning_nn_1 = mkN "grundutbildning" ;
  grundval_nn_1 = mkN "grundval" ;
  grundvatten_nn_1 = mkN "grundvatten" "grundvattnet" "grundvatten" "grundvattnen" ;
  grupp_nn_1 = mkN "grupp" "grupper" ;
  gruppbild_nn_1 = mkN "gruppbild" "gruppbilder" ;
  gruppchef_nn_1 = mkN "gruppchef" "gruppchefer" ;
  gruppdynamisk_av_1 = mkA "gruppdynamisk" ;
  gruppering_nn_1 = mkN "gruppering" ;
  gruppfoersaekring_nn_1 = mkN "gruppfцrsдkring" ;
  gruppgenitiv_nn_1 = mkN "gruppgenitiv" "gruppgenitiver" ;
  grupphus_nn_1 = mkN "grupphus" neutrum ;
  gruppkorsband_nn_1 = mkN "gruppkorsband" neutrum ;
  gruppsamtal_nn_1 = mkN "gruppsamtal" "gruppsamtalet" "gruppsamtalen" "gruppsamtalena" ;
  gruppterapi_nn_1 = mkN "gruppterapi" "gruppterapier" ;
  grupptest_nn_1 = mkN "grupptest" neutrum ;
  grusgaang_nn_1 = mkN "grusgеng" ;
  grusgrop_nn_1 = mkN "grusgrop" ;
  grusig_av_1 = mkA "grusig" ;
  grusplan_nn_1 = mkN "grusplan" "grusplaner" ;
  grustaekt_nn_1 = mkN "grustдkt" "grustдkter" ;
  grustag_nn_1 = mkN "grustag" neutrum ;
  grusvaeg_nn_1 = mkN "grusvдg" ;
  gruvbrytning_nn_1 = mkN "gruvbrytning" ;
  gruvdrift_nn_1 = mkN "gruvdrift" "gruvdrifter" ;
  gruvfaelt_nn_1 = mkN "gruvfдlt" neutrum ;
  gruvfogde_nn_1 = mkN "gruvfogde" utrum ;
  gruvgaang_nn_1 = mkN "gruvgеng" ;
  gruvhund_nn_1 = mkN "gruvhund" ;
  gruvkompass_nn_1 = mkN "gruvkompass" "gruvkompasser" ;
  gruvlave_nn_1 = mkN "gruvlave" utrum ;
  gruvlig_av_1 = mkA "gruvlig" ;
  gruvoeppning_nn_1 = mkN "gruvцppning" ;
  gruvsam_av_1 = mkA "gruvsam" "gruvsamt" "gruvsamma" "gruvsamma" "gruvsammare" "gruvsammast" "gruvsammaste" ;
  gruvschakt_nn_1 = mkN "gruvschakt" neutrum ;
  gruvstigare_nn_1 = mkN "gruvstigare" "gruvstigare" ;
  grym_av_1 = mkA "grym" "grymt" "grymma" "grymma" "grymmare" "grymmast" "grymmaste" ;
  grymhet_nn_1 = mkN "grymhet" "grymheter" ;
  grymthastighet_nn_1 = mkN "grymthastighet" "grymthastigheter" ;
  grymtning_nn_1 = mkN "grymtning" ;
  grymtoxe_nn_1 = mkN "grymtoxe" utrum ;
  gryn_nn_1 = mkN "gryn" neutrum ;
  grynig_av_1 = mkA "grynig" ;
  gryning_nn_1 = mkN "gryning" ;
  grynkorv_nn_1 = mkN "grynkorv" ;
  grynpipig_av_1 = mkA "grynpipig" ;
  gryt_nn_1 = mkN "gryt" neutrum ;
  grythund_nn_1 = mkN "grythund" ;
  grytlapp_nn_1 = mkN "grytlapp" ;
  grytskaap_nn_1 = mkN "grytskеp" neutrum ;
  grytstek_nn_1 = mkN "grytstek" ;
  grytvante_nn_1 = mkN "grytvante" utrum ;
  guanin_nn_1 = mkN "guanin" "guaninet" "guaniner" "guaninerna" ;
  guatemalan_nn_1 = mkN "guatemalan" "guatemalaner" ;
  guatemalansk_av_1 = mkA "guatemalansk" ;
  guatemaltek_nn_1 = mkN "guatemaltek" "guatemalteker" ;
  guatemaltekisk_av_1 = mkA "guatemaltekisk" ;
  guayanan_nn_1 = mkN "guayanan" "guayananer" ;
  guayansk_av_1 = mkA "guayansk" ;
  gubbe_nn_1 = mkN "gubbe" utrum ;
  gubbig_av_1 = mkA "gubbig" ;
  gubbsjuk_av_1 = mkA "gubbsjuk" ;
  gubbstrutt_nn_1 = mkN "gubbstrutt" ;
  guckusko_nn_1 = mkN "guckusko" "guckuskor" ;
  gud_nn_1 = mkN "gud" ;
  gudaktig_av_1 = mkA "gudaktig" ;
  gudalaera_nn_1 = mkN "gudalдra" ;
  gudasaend_av_1 = mkA "gudasдnd" ;
  gudasaga_nn_1 = mkN "gudasaga" ;
  gudbarn_nn_1 = mkN "gudbarn" neutrum ;
  guddotter_nn_1 = mkN "guddotter" "guddottern" "guddцttrar" "guddцttrarna" ;
  gudelig_av_1 = mkA "gudelig" ;
  gudfader_nn_1 = mkN "gudfader" "gudfadern" "gudfдder" "gudfдderna" ;
  gudfruktig_av_1 = mkA "gudfruktig" ;
  gudi_ab_1 = mkAdv "gudi" ;
  gudilov_ab_1 = mkAdv "gudilov" ;
  guding_nn_1 = mkN "guding" ;
  gudinna_nn_1 = mkN "gudinna" ;
  gudinog_ab_1 = mkAdv "gudinog" ;
  gudlig_av_1 = mkA "gudlig" ;
  gudloes_av_1 = mkA "gudlцs" ;
  gudmoder_nn_1 = mkN "gudmoder" "gudmodern" "gudmцdrar" "gudmцdrarna" ;
  gudom_nn_1 = mkN "gudom" ;
  gudomlig_av_1 = mkA "gudomlig" ;
  gudsbevis_nn_1 = mkN "gudsbevis" neutrum ;
  gudsdom_nn_1 = mkN "gudsdom" ;
  gudsfoergaeten_av_1 = mkA "gudsfцrgдten" "gudsfцrgдtet" ;
  gudsfoernekare_nn_1 = mkN "gudsfцrnekare" "gudsfцrnekare" ;
  gudsfoernekelse_nn_1 = mkN "gudsfцrnekelse" "gudsfцrnekelser" ;
  gudskelov_ab_1 = mkAdv "gudskelov" ;
  gudslaan_nn_1 = mkN "gudslеn" neutrum ;
  gudsman_nn_1 = mkN "gudsman" "gudsmannen" "gudsmдn" "gudsmдnnen" ;
  gudsnaadelig_av_1 = mkA "gudsnеdelig" ;
  gudson_nn_1 = mkN "gudson" "gudsцner" ;
  gudsord_nn_1 = mkN "gudsord" neutrum ;
  gudstjaenst_nn_1 = mkN "gudstjдnst" "gudstjдnster" ;
  gudstjaenstdag_nn_1 = mkN "gudstjдnstdag" ;
  gudstjaenstritual_nn_1 = mkN "gudstjдnstritual" neutrum ;
  gudunge_nn_1 = mkN "gudunge" utrum ;
  guide_nn_1 = mkN "guide" "guider" ;
  guinea_nn_1 = mkN "guinea" "guinean" "guineas" "guineasen" ;
  guinean_nn_1 = mkN "guinean" "guineaner" ;
  guineansk_av_1 = mkA "guineansk" ;
  gul_av_1 = mkA "gul" ;
  gulasch_nn_2 = mkN "gulasch" "gulascher" ;
  gulaschbaron_nn_1 = mkN "gulaschbaron" "gulaschbaroner" ;
  gulblek_av_1 = mkA "gulblek" ;
  gulblommig_av_1 = mkA "gulblommig" ;
  gulbrun_av_1 = mkA "gulbrun" ;
  guld_nn_1 = mkN "guld" neutrum ;
  guldaalder_nn_1 = mkN "guldеlder" ;
  guldbagge_nn_1 = mkN "guldbagge" utrum ;
  guldbarr_nn_1 = mkN "guldbarr" "guldbarrer" ;
  guldberlock_nn_1 = mkN "guldberlock" "guldberlocker" ;
  guldbroellop_nn_1 = mkN "guldbrцllop" neutrum ;
  gulddrageri_nn_1 = mkN "gulddrageri" "gulddragerit" "gulddragerier" "gulddragerierna" ;
  gulden_nn_1 = mkN "gulden" "guldenen" "gulden" "guldenen" ;
  guldfasan_nn_1 = mkN "guldfasan" "guldfasaner" ;
  guldfisk_nn_1 = mkN "guldfisk" ;
  guldfoeremaal_nn_1 = mkN "guldfцremеl" neutrum ;
  guldfux_nn_1 = mkN "guldfux" ;
  guldfynd_nn_1 = mkN "guldfynd" neutrum ;
  guldgraevare_nn_1 = mkN "guldgrдvare" "guldgrдvare" ;
  guldhalt_nn_1 = mkN "guldhalt" "guldhalter" ;
  guldkalv_nn_1 = mkN "guldkalv" ;
  guldkant_nn_1 = mkN "guldkant" "guldkanter" ;
  guldklimp_nn_1 = mkN "guldklimp" ;
  guldkorn_nn_1 = mkN "guldkorn" neutrum ;
  guldkrog_nn_1 = mkN "guldkrog" ;
  guldlegering_nn_1 = mkN "guldlegering" ;
  guldliknande_av_1 = mkA "guldliknande" ;
  guldmakare_nn_1 = mkN "guldmakare" "guldmakare" ;
  guldmakeri_nn_1 = mkN "guldmakeri" "guldmakerit" "guldmakerier" "guldmakerierna" ;
  guldmakrill_nn_1 = mkN "guldmakrill" ;
  guldmedalj_nn_1 = mkN "guldmedalj" "guldmedaljer" ;
  guldmedaljoer_nn_1 = mkN "guldmedaljцr" "guldmedaljцrer" ;
  guldmynt_nn_1 = mkN "guldmynt" neutrum ;
  guldplants_nn_1 = mkN "guldplants" ;
  guldpressning_nn_1 = mkN "guldpressning" ;
  guldprov_nn_1 = mkN "guldprov" neutrum ;
  guldreserv_nn_1 = mkN "guldreserv" "guldreserver" ;
  guldrush_nn_1 = mkN "guldrush" "guldrusher" ;
  guldslagare_nn_1 = mkN "guldslagare" "guldslagare" ;
  guldslageri_nn_1 = mkN "guldslageri" "guldslagerit" "guldslagerier" "guldslagerierna" ;
  guldsmed_nn_1 = mkN "guldsmed" "guldsmeder" ;
  guldsmidd_av_1 = mkA "guldsmidd" ;
  guldsmide_nn_1 = mkN "guldsmide" ;
  guldsnitt_nn_1 = mkN "guldsnitt" neutrum ;
  guldstaempel_nn_1 = mkN "guldstдmpel" ;
  guldstekel_nn_1 = mkN "guldstekel" ;
  guldtand_nn_1 = mkN "guldtand" "guldtдnder" ;
  guldtraad_nn_1 = mkN "guldtrеd" ;
  guldvaag_nn_1 = mkN "guldvеg" ;
  guldvaskning_nn_1 = mkN "guldvaskning" ;
  gulesaeck_nn_1 = mkN "gulesдck" ;
  gulfaergning_nn_1 = mkN "gulfдrgning" ;
  gulfilter_nn_1 = mkN "gulfilter" neutrum ;
  gulgraa_av_1 = mkA "gulgrе" "gulgrеtt" ;
  guling_nn_1 = mkN "guling" ;
  gulkropp_nn_1 = mkN "gulkropp" ;
  gull_nn_1 = mkN "gull" neutrum ;
  gullegris_nn_1 = mkN "gullegris" ;
  gullgosse_nn_1 = mkN "gullgosse" utrum ;
  gullgris_nn_1 = mkN "gullgris" ;
  gullig_av_1 = mkA "gullig" ;
  gullstol_nn_1 = mkN "gullstol" ;
  gulning_nn_1 = mkN "gulning" ;
  gulroed_av_1 = mkA "gulrцd" ;
  gulsaeck_nn_1 = mkN "gulsдck" ;
  gulsiktig_av_1 = mkA "gulsiktig" ;
  gulsparv_nn_1 = mkN "gulsparv" ;
  gulsporre_nn_1 = mkN "gulsporre" utrum ;
  gulvit_av_1 = mkA "gulvit" ;
  gummering_nn_1 = mkN "gummering" ;
  gummi_nn_1 = mkN "gummi" "gummit" "gummin" "gummina" ;
  gummibaat_nn_1 = mkN "gummibеt" ;
  gummiband_nn_1 = mkN "gummiband" neutrum ;
  gummidaeck_nn_1 = mkN "gummidдck" neutrum ;
  gummiharts_nn_1 = mkN "gummiharts" "gummihartset" "gummihartser" "gummihartserna" ;
  gummimaterial_nn_1 = mkN "gummimaterial" neutrum ;
  gummiparagraf_nn_1 = mkN "gummiparagraf" "gummiparagrafer" ;
  gummisnodd_nn_1 = mkN "gummisnodd" ;
  gummistoevel_nn_1 = mkN "gummistцvel" ;
  gummitraed_nn_1 = mkN "gummitrдd" neutrum ;
  gummoes_av_1 = mkA "gummцs" ;
  gump_nn_1 = mkN "gump" ;
  gumpkoertel_nn_1 = mkN "gumpkцrtel" ;
  gumse_nn_1 = mkN "gumse" utrum ;
  gungbraede_nn_1 = mkN "gungbrдde" ;
  gungfly_nn_1 = mkN "gungfly" "gungflyt" "gungflyn" "gungflyen" ;
  gunghaest_nn_1 = mkN "gunghдst" ;
  gungig_av_1 = mkA "gungig" ;
  gungning_nn_1 = mkN "gungning" ;
  gungstol_nn_1 = mkN "gungstol" ;
  gunrum_nn_1 = mkN "gunrum" "gunrummet" "gunrum" "gunrummen" ;
  gunst_nn_1 = mkN "gunst" "gunster" ;
  gunstbenaegen_av_1 = mkA "gunstbenдgen" "gunstbenдget" ;
  gunstig_av_1 = mkA "gunstig" ;
  gunstling_nn_1 = mkN "gunstling" ;
  gupp_nn_1 = mkN "gupp" neutrum ;
  guppig_av_1 = mkA "guppig" ;
  guppy_nn_1 = mkN "guppy" "guppyn" "guppies" "guppyerna" ;
  gurami_nn_1 = mkN "gurami" "guramin" "guramier" "guramierna" ;
  gurgel_nn_1 = mkN "gurgel" neutrum ;
  gurkha_nn_1 = mkN "gurkha" ;
  gurklist_nn_1 = mkN "gurklist" "gurklister" ;
  gurkvaext_nn_1 = mkN "gurkvдxt" "gurkvдxter" ;
  guru_nn_1 = mkN "guru" "gurun" "guruer" "guruerna" ;
  gustavian_nn_1 = mkN "gustavian" "gustavianer" ;
  gustaviansk_av_1 = mkA "gustaviansk" ;
  gute_nn_1 = mkN "gute" utrum ;
  gutnisk_av_1 = mkA "gutnisk" ;
  guttural_av_1 = mkA "guttural" ;
  guvernant_nn_1 = mkN "guvernant" "guvernanter" ;
  guvernement_nn_1 = mkN "guvernement" "guvernementet" "guvernementen" "guvernementena" ;
  guvernoer_nn_1 = mkN "guvernцr" "guvernцrer" ;
  gyckelbild_nn_1 = mkN "gyckelbild" "gyckelbilder" ;
  gyckelspel_nn_1 = mkN "gyckelspel" "gyckelspelet" "gyckelspel" "gyckelspelen" ;
  gycklare_nn_1 = mkN "gycklare" "gycklare" ;
  gyckleri_nn_1 = mkN "gyckleri" "gycklerit" "gycklerier" "gycklerierna" ;
  gydja_nn_1 = mkN "gydja" ;
  gylf_nn_1 = mkN "gylf" ;
  gyllen_nn_1 = mkN "gyllen" neutrum ;
  gyllen_nn_2 = mkN "gyllen" "gyllenen" "gyllen" "gyllenen" ;
  gyllen_nn_3 = mkN "gyllen" "gyllen" "gyllen" "gyllena" ;
  gyllene_av_1 = mkA "gyllene" ;
  gyllental_nn_1 = mkN "gyllental" neutrum ;
  gylling_nn_1 = mkN "gylling" ;
  gym_nn_1 = mkN "gym" "gymmet" "gym" "gymmen" ;
  gymnasial_av_1 = mkA "gymnasial" ;
  gymnasieekonom_nn_1 = mkN "gymnasieekonom" "gymnasieekonomer" ;
  gymnasieingenjoer_nn_1 = mkN "gymnasieingenjцr" "gymnasieingenjцrer" ;
  gymnasieinspektoer_nn_1 = mkN "gymnasieinspektцr" "gymnasieinspektцrer" ;
  gymnasielinje_nn_1 = mkN "gymnasielinje" "gymnasielinjer" ;
  gymnasist_nn_1 = mkN "gymnasist" "gymnasister" ;
  gymnasium_nn_1 = mkN "gymnasium" "gymnasiet" "gymnasier" "gymnasierna" ;
  gymnast_nn_1 = mkN "gymnast" "gymnaster" ;
  gymnastikdirektoer_nn_1 = mkN "gymnastikdirektцr" "gymnastikdirektцrer" ;
  gymnastikdraekt_nn_1 = mkN "gymnastikdrдkt" "gymnastikdrдkter" ;
  gymnastikhopp_nn_1 = mkN "gymnastikhopp" neutrum ;
  gymnastikredskap_nn_1 = mkN "gymnastikredskap" "gymnastikredskapet" "gymnastikredskapen" "gymnastikredskapena" ;
  gymnastiksko_nn_1 = mkN "gymnastiksko" "gymnastikskor" ;
  gymnastisk_av_1 = mkA "gymnastisk" ;
  gymnisk_av_1 = mkA "gymnisk" ;
  gymnosperm_nn_1 = mkN "gymnosperm" "gymnospermer" ;
  gynekolog_nn_1 = mkN "gynekolog" "gynekologer" ;
  gynekologisk_av_1 = mkA "gynekologisk" ;
  gynnare_nn_1 = mkN "gynnare" "gynnare" ;
  gynnsam_av_1 = mkA "gynnsam" "gynnsamt" "gynnsamma" "gynnsamma" "gynnsammare" "gynnsammast" "gynnsammaste" ;
  gyro_nn_1 = mkN "gyro" "gyrot" "gyron" "gyrona" ;
  gyrohorisont_nn_1 = mkN "gyrohorisont" "gyrohorisonter" ;
  gyrokompass_nn_1 = mkN "gyrokompass" "gyrokompasser" ;
  gyroskop_nn_1 = mkN "gyroskop" neutrum ;
  gyroskopkompass_nn_1 = mkN "gyroskopkompass" "gyroskopkompasser" ;
  gyrostabilisator_nn_1 = mkN "gyrostabilisator" "gyrostabilisatorer" ;
  gyttjebad_nn_1 = mkN "gyttjebad" neutrum ;
  gyttjig_av_1 = mkA "gyttjig" ;
  gyttrig_av_1 = mkA "gyttrig" ;
  gyttring_nn_1 = mkN "gyttring" ;
  haabrand_nn_1 = mkN "hеbrand" ;
  haagkomst_nn_1 = mkN "hеgkomst" "hеgkomster" ;
  haagloes_av_1 = mkA "hеglцs" ;
  haakaering_nn_1 = mkN "hеkдring" ;
  haal_nn_1 = mkN "hеl" neutrum ;
  haalfot_nn_1 = mkN "hеlfot" "hеlfцtter" ;
  haalfotsinlaegg_nn_1 = mkN "hеlfotsinlдgg" neutrum ;
  haalig_av_1 = mkA "hеlig" ;
  haalighet_nn_1 = mkN "hеlighet" "hеligheter" ;
  haalkael_nn_1 = mkN "hеlkдl" ;
  haalkort_nn_1 = mkN "hеlkort" neutrum ;
  haall_nn_1 = mkN "hеll" neutrum ;
  haalla_vb_1 = mkV "hеlla" "hцll" "hеllit" ;
  haallare_nn_1 = mkN "hеllare" "hеllare" ;
  haallbar_av_1 = mkA "hеllbar" ;
  haallbarhet_nn_1 = mkN "hеllbarhet" "hеllbarheter" ;
  haallbarhetsdag_nn_1 = mkN "hеllbarhetsdag" ;
  haalldam_nn_1 = mkN "hеlldam" "hеlldamer" ;
  haallen_av_1 = mkA "hеllen" "hеllet" ;
  haallfast_av_1 = mkA "hеllfast" "hеllfast" ;
  haallfasthet_nn_1 = mkN "hеllfasthet" "hеllfastheter" ;
  haallfasthetsberaekning_nn_1 = mkN "hеllfasthetsberдkning" ;
  haallfasthetslaera_nn_1 = mkN "hеllfasthetslдra" ;
  haallhake_nn_1 = mkN "hеllhake" utrum ;
  haalligaang_nn_1 = mkN "hеlligеng" neutrum ;
  haallning_nn_1 = mkN "hеllning" ;
  haallningsloes_av_1 = mkA "hеllningslцs" ;
  haallplats_nn_1 = mkN "hеllplats" "hеllplatser" ;
  haallpunkt_nn_1 = mkN "hеllpunkt" "hеllpunkter" ;
  haalmoenster_nn_1 = mkN "hеlmцnster" neutrum ;
  haaloegd_av_1 = mkA "hеlцgd" "hеlцgt" ;
  haalrum_nn_1 = mkN "hеlrum" "hеlrummet" "hеlrum" "hеlrummen" ;
  haalslag_nn_1 = mkN "hеlslag" neutrum ;
  haalslagning_nn_1 = mkN "hеlslagning" ;
  haalslev_nn_1 = mkN "hеlslev" ;
  haaltimme_nn_1 = mkN "hеltimme" utrum ;
  haalvaeg_nn_1 = mkN "hеlvдg" ;
  haalven_nn_1 = mkN "hеlven" "hеlvener" ;
  haanfull_av_1 = mkA "hеnfull" ;
  haanskratt_nn_1 = mkN "hеnskratt" neutrum ;
  haar_nn_1 = mkN "hеr" neutrum ;
  haarband_nn_1 = mkN "hеrband" neutrum ;
  haarbeklaednad_nn_1 = mkN "hеrbeklдdnad" "hеrbeklдdnader" ;
  haarbevuxen_av_1 = mkA "hеrbevuxen" "hеrbevuxet" ;
  haarborste_nn_1 = mkN "hеrborste" utrum ;
  haarbotten_nn_1 = mkN "hеrbotten" ;
  haard_av_1 = mkA "hеrd" "hеrt" ;
  haarddata_nn_1 = mkN "hеrddata" "hеrddatan" "hеrddata" "hеrddatana" ;
  haardfoer_av_1 = mkA "hеrdfцr" ;
  haardfrusen_av_1 = mkA "hеrdfrusen" "hеrdfruset" ;
  haardhaent_av_1 = mkA "hеrdhдnt" "hеrdhдnt" ;
  haardhet_nn_1 = mkN "hеrdhet" "hеrdheter" ;
  haarding_nn_1 = mkN "hеrding" ;
  haardkokt_av_1 = mkA "hеrdkokt" "hеrdkokt" ;
  haardmetall_nn_1 = mkN "hеrdmetall" "hеrdmetaller" ;
  haardra_vb_1 = mkV "hеrdra" "hеrdrar" "hеrdra" "hеrdrog" "hеrdragit" "hеrdragen" ;
  haardsmaelt_av_1 = mkA "hеrdsmдlt" "hеrdsmдlt" ;
  haardvaluta_nn_1 = mkN "hеrdvaluta" ;
  haarfaellning_nn_1 = mkN "hеrfдllning" ;
  haarfaerg_nn_1 = mkN "hеrfдrg" "hеrfдrger" ;
  haarfin_av_1 = mkA "hеrfin" ;
  haarfrisoer_nn_1 = mkN "hеrfrisцr" "hеrfrisцrer" ;
  haarfrisoerska_nn_1 = mkN "hеrfrisцrska" ;
  haarig_av_1 = mkA "hеrig" ;
  haarklyveri_nn_1 = mkN "hеrklyveri" "hеrklyverit" "hеrklyverier" "hеrklyverierna" ;
  haarknut_nn_1 = mkN "hеrknut" ;
  haarkors_nn_1 = mkN "hеrkors" neutrum ;
  haarlaeggning_nn_1 = mkN "hеrlдggning" ;
  haarlag_nn_1 = mkN "hеrlag" neutrum ;
  haarliknande_av_1 = mkA "hеrliknande" ;
  haarlock_nn_1 = mkN "hеrlock" ;
  haarloes_av_1 = mkA "hеrlцs" ;
  haarnaal_nn_1 = mkN "hеrnеl" ;
  haarolja_nn_1 = mkN "hеrolja" ;
  haarpensel_nn_1 = mkN "hеrpensel" ;
  haarrem_nn_1 = mkN "hеrrem" "hеrremmen" "hеrremmar" "hеrremmarna" ;
  haarresande_av_1 = mkA "hеrresande" ;
  haarroer_nn_1 = mkN "hеrrцr" neutrum ;
  haarroerskaerl_nn_1 = mkN "hеrrцrskдrl" neutrum ;
  haarrulle_nn_1 = mkN "hеrrulle" utrum ;
  haarsaeck_nn_1 = mkN "hеrsдck" ;
  haarsida_nn_1 = mkN "hеrsida" ;
  haarspaenne_nn_1 = mkN "hеrspдnne" ;
  haarstraa_nn_1 = mkN "hеrstrе" "hеrstrеet" "hеrstrеn" "hеrstrеna" ;
  haarsvall_nn_1 = mkN "hеrsvall" neutrum ;
  haartest_nn_1 = mkN "hеrtest" ;
  haartofs_nn_1 = mkN "hеrtofs" ;
  haartork_nn_1 = mkN "hеrtork" ;
  haartuss_nn_1 = mkN "hеrtuss" ;
  haartvaett_nn_1 = mkN "hеrtvдtt" ;
  haaruppsaettning_nn_1 = mkN "hеruppsдttning" ;
  haarvatten_nn_1 = mkN "hеrvatten" "hеrvattnet" "hеrvatten" "hеrvattnen" ;
  haav_nn_1 = mkN "hеv" ;
  habil_av_1 = mkA "habil" ;
  habilitet_nn_1 = mkN "habilitet" "habiliteter" ;
  habit_nn_1 = mkN "habit" "habiter" ;
  habitue_nn_1 = mkN "habituй" "habituйer" ;
  habituell_av_1 = mkA "habituell" ;
  habitus_nn_1 = mkN "habitus" ;
  habsburgsk_av_1 = mkA "habsburgsk" ;
  hack_nn_1 = mkN "hack" neutrum ;
  hackbraede_nn_1 = mkN "hackbrдde" ;
  hacker_nn_1 = mkN "hacker" ;
  hackig_av_1 = mkA "hackig" ;
  hackkyckling_nn_1 = mkN "hackkyckling" ;
  hackspett_nn_1 = mkN "hackspett" ;
  haeck_nn_1 = mkN "hдck" ;
  haeckfaagel_nn_1 = mkN "hдckfеgel" ;
  haecklare_nn_1 = mkN "hдcklare" "hдcklare" ;
  haeckloepning_nn_1 = mkN "hдcklцpning" ;
  haecklopp_nn_1 = mkN "hдcklopp" neutrum ;
  haeckning_nn_1 = mkN "hдckning" ;
  haedan_ab_1 = mkAdv "hдdan" ;
  haedanefter_ab_1 = mkAdv "hдdanefter" ;
  haedanfaerd_nn_1 = mkN "hдdanfдrd" "hдdanfдrder" ;
  haedangaangen_av_1 = mkA "hдdangеngen" "hдdangеnget" ;
  haedelse_nn_1 = mkN "hдdelse" "hдdelser" ;
  haedisk_av_1 = mkA "hдdisk" ;
  haeftapparat_nn_1 = mkN "hдftapparat" "hдftapparater" ;
  haefte_nn_1 = mkN "hдfte" ;
  haeftig_av_1 = mkA "hдftig" ;
  haeftklammer_nn_1 = mkN "hдftklammer" "hдftklammern" "hдftklammer" "hдftklammerna" ;
  haeftplaaster_nn_1 = mkN "hдftplеster" neutrum ;
  haeftstift_nn_1 = mkN "hдftstift" neutrum ;
  haeger_nn_1 = mkN "hдger" ;
  haegg_nn_1 = mkN "hдgg" ;
  haegnad_nn_1 = mkN "hдgnad" "hдgnader" ;
  haegring_nn_1 = mkN "hдgring" ;
  haekte_nn_1 = mkN "hдkte" ;
  haektning_nn_1 = mkN "hдktning" ;
  hael_nn_1 = mkN "hдl" ;
  haelare_nn_1 = mkN "hдlare" "hдlare" ;
  haelben_nn_1 = mkN "hдlben" neutrum ;
  haeleri_nn_1 = mkN "hдleri" "hдlerit" "hдlerier" "hдlerierna" ;
  haelft_nn_1 = mkN "hдlft" "hдlfter" ;
  haelftenbruk_nn_1 = mkN "hдlftenbruk" neutrum ;
  haelgaangare_nn_1 = mkN "hдlgеngare" "hдlgеngare" ;
  haell_nn_1 = mkN "hдll" ;
  haellmark_nn_1 = mkN "hдllmark" "hдllmarker" ;
  haellregn_nn_1 = mkN "hдllregn" neutrum ;
  haellristning_nn_1 = mkN "hдllristning" ;
  haelsing_nn_1 = mkN "hдlsing" ;
  haelsning_nn_1 = mkN "hдlsning" ;
  haelsningsanfoerande_nn_1 = mkN "hдlsningsanfцrande" ;
  haelsobringande_av_1 = mkA "hдlsobringande" ;
  haelsobrunn_nn_1 = mkN "hдlsobrunn" ;
  haelsocenter_nn_1 = mkN "hдlsocenter" "hдlsocentret" "hдlsocentrer" "hдlsocentrerna" ;
  haelsoeffekt_nn_1 = mkN "hдlsoeffekt" "hдlsoeffekter" ;
  haelsofarlig_av_1 = mkA "hдlsofarlig" ;
  haelsokontroll_nn_1 = mkN "hдlsokontroll" "hдlsokontroller" ;
  haelsokort_nn_1 = mkN "hдlsokort" neutrum ;
  haelsosam_av_1 = mkA "hдlsosam" "hдlsosamt" "hдlsosamma" "hдlsosamma" "hдlsosammare" "hдlsosammast" "hдlsosammaste" ;
  haelsotecken_nn_1 = mkN "hдlsotecken" "hдlsotecknet" "hдlsotecken" "hдlsotecknen" ;
  haelsotek_nn_1 = mkN "hдlsotek" neutrum ;
  haelsovaadlig_av_1 = mkA "hдlsovеdlig" ;
  haelsovaardsnaemnd_nn_1 = mkN "hдlsovеrdsnдmnd" "hдlsovеrdsnдmnder" ;
  haemnare_nn_1 = mkN "hдmnare" "hдmnare" ;
  haemndaktion_nn_1 = mkN "hдmndaktion" "hдmndaktioner" ;
  haemndeande_nn_1 = mkN "hдmndeande" utrum ;
  haemndgirig_av_1 = mkA "hдmndgirig" ;
  haemndgudinna_nn_1 = mkN "hдmndgudinna" ;
  haemndlysten_av_1 = mkA "hдmndlysten" "hдmndlystet" ;
  haemndlystnad_nn_1 = mkN "hдmndlystnad" "hдmndlystnader" ;
  haemning_nn_1 = mkN "hдmning" ;
  haemningsloes_av_1 = mkA "hдmningslцs" ;
  haempling_nn_1 = mkN "hдmpling" ;
  haemsko_nn_1 = mkN "hдmsko" "hдmskor" ;
  haemtning_nn_1 = mkN "hдmtning" ;
  haemtpris_nn_1 = mkN "hдmtpris" neutrum ;
  haen_ab_1 = mkAdv "hдn" ;
  haendelse_nn_1 = mkN "hдndelse" "hдndelser" ;
  haendelsefattig_av_1 = mkA "hдndelsefattig" ;
  haendelsefoerlopp_nn_1 = mkN "hдndelsefцrlopp" neutrum ;
  haendelseloes_av_1 = mkA "hдndelselцs" ;
  haendelserik_av_1 = mkA "hдndelserik" ;
  haendelsevis_ab_1 = mkAdv "hдndelsevis" ;
  haendig_av_1 = mkA "hдndig" ;
  haenfoerande_av_1 = mkA "hдnfцrande" ;
  haenfoerd_av_1 = mkA "hдnfцrd" "hдnfцrt" ;
  haengande_nn_1 = mkN "hдngande" ;
  haengare_nn_1 = mkN "hдngare" "hдngare" ;
  haengavtal_nn_1 = mkN "hдngavtal" "hдngavtalet" "hдngavtalen" "hдngavtalena" ;
  haengbjoerk_nn_1 = mkN "hдngbjцrk" ;
  haengbro_nn_1 = mkN "hдngbro" ;
  haengbroest_nn_1 = mkN "hдngbrцst" neutrum ;
  haengbuk_nn_1 = mkN "hдngbuk" ;
  haengdal_nn_1 = mkN "hдngdal" ;
  haenge_vb_1 = mkV "hдnge" "hдnger" "hдnge" "hдngav" "hдngett" "hдngiven" ;
  haengfaerdig_av_1 = mkA "hдngfдrdig" ;
  haengig_av_1 = mkA "hдngig" ;
  haengiven_av_1 = mkA "hдngiven" "hдngivet" ;
  haenglaas_nn_1 = mkN "hдnglеs" neutrum ;
  haengning_nn_1 = mkN "hдngning" ;
  haengparti_nn_1 = mkN "hдngparti" "hдngpartit" "hдngpartier" "hдngpartierna" ;
  haengsjuk_av_1 = mkA "hдngsjuk" ;
  haengsmycke_nn_1 = mkN "hдngsmycke" ;
  haenryckt_av_1 = mkA "hдnryckt" "hдnryckt" ;
  haenseende_nn_1 = mkN "hдnseende" ;
  haensjunken_av_1 = mkA "hдnsjunken" "hдnsjunket" ;
  haenskjuta_vb_1 = mkV "hдnskjuta" "hдnskцt" "hдnskjutit" ;
  haensoven_av_1 = mkA "hдnsoven" "hдnsovet" ;
  haensyftning_nn_1 = mkN "hдnsyftning" ;
  haensyn_nn_1 = mkN "hдnsyn" "hдnsynen" "hдnsyn" "hдnsynen" ;
  haensynsfull_av_1 = mkA "hдnsynsfull" ;
  haensynsloes_av_1 = mkA "hдnsynslцs" ;
  haensynstagande_nn_1 = mkN "hдnsynstagande" ;
  haentydning_nn_1 = mkN "hдntydning" ;
  haenvaendelse_nn_1 = mkN "hдnvдndelse" "hдnvдndelser" ;
  haenvisning_nn_1 = mkN "hдnvisning" ;
  haepen_av_1 = mkA "hдpen" "hдpet" ;
  haepnad_nn_1 = mkN "hдpnad" "hдpnader" ;
  haepnadsvaeckande_av_1 = mkA "hдpnadsvдckande" ;
  haer_ab_1 = mkAdv "hдr" ;
  haer_nn_1 = mkN "hдr" ;
  haeraat_ab_1 = mkAdv "hдrеt" ;
  haerad_nn_1 = mkN "hдrad" "hдradet" "hдrad" "hдradena" ;
  haeradshoevding_nn_1 = mkN "hдradshцvding" ;
  haeradsraett_nn_1 = mkN "hдradsrдtt" "hдradsrдtter" ;
  haeradsskrivare_nn_1 = mkN "hдradsskrivare" "hдradsskrivare" ;
  haerav_ab_1 = mkAdv "hдrav" ;
  haerd_nn_1 = mkN "hдrd" ;
  haerdig_av_1 = mkA "hдrdig" ;
  haerdighet_nn_1 = mkN "hдrdighet" "hдrdigheter" ;
  haerdighetskrav_nn_1 = mkN "hдrdighetskrav" neutrum ;
  haerdlack_nn_1 = mkN "hдrdlack" "hдrdlacker" ;
  haerdning_nn_1 = mkN "hдrdning" ;
  haerdplast_nn_1 = mkN "hдrdplast" "hдrdplaster" ;
  haerefter_ab_1 = mkAdv "hдrefter" ;
  haeremot_ab_1 = mkAdv "hдremot" ;
  haerfaagel_nn_1 = mkN "hдrfеgel" ;
  haerflyta_vb_1 = mkV "hдrflyta" "hдrflцt" "hдrflutit" ;
  haerfoer_ab_1 = mkAdv "hдrfцr" ;
  haerfoerare_nn_1 = mkN "hдrfцrare" "hдrfцrare" ;
  haerfoerleden_ab_1 = mkAdv "hдrfцrleden" ;
  haeri_ab_1 = mkAdv "hдri" ;
  haerifraan_ab_1 = mkAdv "hдrifrеn" ;
  haerigenom_ab_1 = mkAdv "hдrigenom" ;
  haerjaemte_ab_1 = mkAdv "hдrjдmte" ;
  haerjedaling_nn_1 = mkN "hдrjedaling" ;
  haerjedalsk_av_1 = mkA "hдrjedalsk" ;
  haerjning_nn_1 = mkN "hдrjning" ;
  haerk_nn_1 = mkN "hдrk" ;
  haerledning_nn_1 = mkN "hдrledning" ;
  haerlig_av_1 = mkA "hдrlig" ;
  haerlighet_nn_1 = mkN "hдrlighet" "hдrligheter" ;
  haermask_nn_1 = mkN "hдrmask" ;
  haermed_ab_1 = mkAdv "hдrmed" ;
  haermfaagel_nn_1 = mkN "hдrmfеgel" ;
  haernad_nn_1 = mkN "hдrnad" "hдrnader" ;
  haernaest_ab_1 = mkAdv "hдrnдst" ;
  haerold_nn_1 = mkN "hдrold" "hдrolder" ;
  haerom_ab_1 = mkAdv "hдrom" ;
  haeromaaret_ab_1 = mkAdv "hдromеret" ;
  haeromdagen_ab_1 = mkAdv "hдromdagen" ;
  haeromsistens_ab_1 = mkAdv "hдromsistens" ;
  haerordning_nn_1 = mkN "hдrordning" ;
  haerpaa_ab_1 = mkAdv "hдrpе" ;
  haerskare_nn_1 = mkN "hдrskare" "hдrskare" ;
  haerskarinna_nn_1 = mkN "hдrskarinna" ;
  haerskarklass_nn_1 = mkN "hдrskarklass" "hдrskarklasser" ;
  haersken_av_1 = mkA "hдrsken" "hдrsket" ;
  haersklysten_av_1 = mkA "hдrsklysten" "hдrsklystet" ;
  haerskri_nn_1 = mkN "hдrskri" "hдrskrit" "hдrskrin" "hдrskrien" ;
  haerstaedes_ab_1 = mkAdv "hдrstдdes" ;
  haerstamning_nn_1 = mkN "hдrstamning" ;
  haertagen_av_1 = mkA "hдrtagen" "hдrtaget" ;
  haertill_ab_1 = mkAdv "hдrtill" ;
  haeruppe_ab_1 = mkAdv "hдruppe" ;
  haerutinnan_ab_1 = mkAdv "hдrutinnan" ;
  haerutoever_ab_1 = mkAdv "hдrutцver" ;
  haervel_nn_1 = mkN "hдrvel" ;
  haervid_ab_1 = mkAdv "hдrvid" ;
  haervidlag_ab_1 = mkAdv "hдrvidlag" ;
  haessja_nn_1 = mkN "hдssja" ;
  haest_nn_1 = mkN "hдst" ;
  haestben_nn_1 = mkN "hдstben" neutrum ;
  haestdjur_nn_1 = mkN "hдstdjur" neutrum ;
  haestdragen_av_1 = mkA "hдstdragen" "hдstdraget" ;
  haestdressyr_nn_1 = mkN "hдstdressyr" "hдstdressyrer" ;
  haesthov_nn_1 = mkN "hдsthov" ;
  haesthovsoert_nn_1 = mkN "hдsthovsцrt" "hдsthovsцrter" ;
  haesthuvud_nn_1 = mkN "hдsthuvud" "hдsthuvudet" "hдsthuvuden" "hдsthuvudena" ;
  haestkapploepning_nn_1 = mkN "hдstkapplцpning" ;
  haestkastanj_nn_1 = mkN "hдstkastanj" "hдstkastanjer" ;
  haestkraft_nn_1 = mkN "hдstkraft" "hдstkrafter" ;
  haestkrake_nn_1 = mkN "hдstkrake" utrum ;
  haestkur_nn_1 = mkN "hдstkur" "hдstkurer" ;
  haestlaengd_nn_1 = mkN "hдstlдngd" "hдstlдngder" ;
  haestlass_nn_1 = mkN "hдstlass" neutrum ;
  haestliknande_av_1 = mkA "hдstliknande" ;
  haestrygg_nn_1 = mkN "hдstrygg" ;
  haestskjuts_nn_1 = mkN "hдstskjuts" ;
  haestsko_nn_1 = mkN "hдstsko" "hдstskor" ;
  haestskobaage_nn_1 = mkN "hдstskobеge" utrum ;
  haestskojare_nn_1 = mkN "hдstskojare" "hдstskojare" ;
  haestskomagnet_nn_1 = mkN "hдstskomagnet" "hдstskomagneter" ;
  haestskosoem_nn_1 = mkN "hдstskosцm" "hдstskosцmmet" "hдstskosцm" "hдstskosцmmen" ;
  haestspann_nn_1 = mkN "hдstspann" neutrum ;
  haeststyng_nn_1 = mkN "hдststyng" neutrum ;
  haestsvans_nn_1 = mkN "hдstsvans" ;
  haestvagn_nn_1 = mkN "hдstvagn" ;
  haetsk_av_1 = mkA "hдtsk" ;
  haetskhet_nn_1 = mkN "hдtskhet" "hдtskheter" ;
  haevarm_nn_1 = mkN "hдvarm" ;
  haevd_nn_1 = mkN "hдvd" "hдvder" ;
  haevdatecknare_nn_1 = mkN "hдvdatecknare" "hдvdatecknare" ;
  haevdvunnen_av_1 = mkA "hдvdvunnen" "hдvdvunnet" "hдvdvunna" "hдvdvunna" "hдvdvunnare" "hдvdvunnast" "hдvdvunnaste" ;
  haevel_nn_1 = mkN "hдvel" ;
  haevert_nn_1 = mkN "hдvert" ;
  haevstaang_nn_1 = mkN "hдvstеng" "hдvstдnger" ;
  haevstaangsarm_nn_1 = mkN "hдvstеngsarm" ;
  haexdans_nn_1 = mkN "hдxdans" "hдxdanser" ;
  haexeri_nn_1 = mkN "hдxeri" "hдxerit" "hдxerier" "hдxerierna" ;
  haexjakt_nn_1 = mkN "hдxjakt" "hдxjakter" ;
  haexkittel_nn_1 = mkN "hдxkittel" ;
  haexmaestare_nn_1 = mkN "hдxmдstare" "hдxmдstare" ;
  haexprocess_nn_1 = mkN "hдxprocess" "hдxprocesser" ;
  haexsabbat_nn_1 = mkN "hдxsabbat" "hдxsabbater" ;
  hafsig_av_1 = mkA "hafsig" ;
  hafsverk_nn_1 = mkN "hafsverk" neutrum ;
  hagalen_av_1 = mkA "hagalen" "hagalet" ;
  hage_nn_1 = mkN "hage" utrum ;
  hagel_nn_1 = mkN "hagel" neutrum ;
  hagelgevaer_nn_1 = mkN "hagelgevдr" neutrum ;
  hagelkorn_nn_1 = mkN "hagelkorn" neutrum ;
  hagmark_nn_1 = mkN "hagmark" "hagmarker" ;
  hagtorn_nn_1 = mkN "hagtorn" ;
  haiku_nn_1 = mkN "haiku" "haikun" "haikuer" "haikuerna" ;
  haitier_nn_1 = mkN "haitier" "haitiern" "haitier" "haitierna" ;
  haitisk_av_1 = mkA "haitisk" ;
  haj_av_1 = mkA "haj" ;
  haj_nn_1 = mkN "haj" ;
  hajk_nn_1 = mkN "hajk" ;
  hak_nn_1 = mkN "hak" neutrum ;
  hake_nn_1 = mkN "hake" utrum ;
  hakkors_nn_1 = mkN "hakkors" neutrum ;
  haklapp_nn_1 = mkN "haklapp" ;
  hakning_nn_1 = mkN "hakning" ;
  hakparentes_nn_1 = mkN "hakparentes" "hakparenteser" ;
  hal_av_1 = mkA "hal" ;
  halgatt_nn_1 = mkN "halgatt" neutrum ;
  halkfri_av_1 = mkA "halkfri" "halkfritt" ;
  halkig_av_1 = mkA "halkig" ;
  halkskydd_nn_1 = mkN "halkskydd" neutrum ;
  hall_nn_1 = mkN "hall" ;
  hallaaman_nn_1 = mkN "hallеman" "hallеmannen" "hallеmдn" "hallеmдnnen" ;
  hallaendsk_av_1 = mkA "hallдndsk" ;
  hallaendska_nn_2 = mkN "hallдndska" ;
  hallaenning_nn_1 = mkN "hallдnning" ;
  hallelujamoete_nn_1 = mkN "hallelujamцte" ;
  hallick_nn_1 = mkN "hallick" ;
  halling_nn_1 = mkN "halling" ;
  hallkyrka_nn_1 = mkN "hallkyrka" ;
  hallon_nn_1 = mkN "hallon" neutrum ;
  hallonbuske_nn_1 = mkN "hallonbuske" utrum ;
  hallonmask_nn_1 = mkN "hallonmask" ;
  hallonsaft_nn_1 = mkN "hallonsaft" "hallonsafter" ;
  hallstaempel_nn_1 = mkN "hallstдmpel" ;
  hallucination_nn_1 = mkN "hallucination" "hallucinationer" ;
  hallucinatorisk_av_1 = mkA "hallucinatorisk" ;
  hallucinogen_av_1 = mkA "hallucinogen" ;
  hallucinogen_nn_1 = mkN "hallucinogen" "hallucinogener" ;
  halmhatt_nn_1 = mkN "halmhatt" ;
  halmskakare_nn_1 = mkN "halmskakare" "halmskakare" ;
  halmstack_nn_1 = mkN "halmstack" ;
  halmstraa_nn_1 = mkN "halmstrе" "halmstrеet" "halmstrеn" "halmstrеna" ;
  halo_nn_1 = mkN "halo" "halor" ;
  haloeffekt_nn_1 = mkN "haloeffekt" "haloeffekter" ;
  halofenomen_nn_1 = mkN "halofenomen" neutrum ;
  halogen_nn_1 = mkN "halogen" "halogener" ;
  hals_nn_1 = mkN "hals" ;
  halsband_nn_1 = mkN "halsband" neutrum ;
  halsbloss_nn_1 = mkN "halsbloss" neutrum ;
  halsboeld_nn_1 = mkN "halsbцld" "halsbцlder" ;
  halsbrytande_av_1 = mkA "halsbrytande" ;
  halsduk_nn_1 = mkN "halsduk" ;
  halsfluss_nn_1 = mkN "halsfluss" "halsflusser" ;
  halsgrop_nn_1 = mkN "halsgrop" ;
  halshugga_vb_1 = mkV "halshugga" "halshцgg" "halshuggit" ;
  halskatarr_nn_1 = mkN "halskatarr" "halskatarrer" ;
  halskraas_nn_1 = mkN "halskrеs" neutrum ;
  halsmandel_nn_1 = mkN "halsmandel" ;
  halsring_nn_1 = mkN "halsring" ;
  halsstarrig_av_1 = mkA "halsstarrig" ;
  halstablett_nn_1 = mkN "halstablett" "halstabletter" ;
  halster_nn_1 = mkN "halster" neutrum ;
  halt_av_1 = mkA "halt" "halt" ;
  halt_nn_1 = mkN "halt" "halter" ;
  halv_av_1 = mkA "halv" ;
  halvaar_nn_1 = mkN "halvеr" neutrum ;
  halvaedelsten_nn_1 = mkN "halvдdelsten" "halvдdelstenen" "halvдdelstenar" "halvдdelstenarna" ;
  halvankare_nn_1 = mkN "halvankare" "halvankare" ;
  halvautomatisk_av_1 = mkA "halvautomatisk" ;
  halvback_nn_1 = mkN "halvback" ;
  halvbild_nn_1 = mkN "halvbild" "halvbilder" ;
  halvblod_nn_1 = mkN "halvblod" neutrum ;
  halvbroder_nn_1 = mkN "halvbroder" "halvbrodern" "halvbrцder" "halvbrцderna" ;
  halvbuske_nn_1 = mkN "halvbuske" utrum ;
  halvbutelj_nn_1 = mkN "halvbutelj" "halvbuteljer" ;
  halvcirkel_nn_1 = mkN "halvcirkel" ;
  halvdaeck_nn_1 = mkN "halvdдck" neutrum ;
  halvdaeckare_nn_1 = mkN "halvdдckare" "halvdдckare" ;
  halvdaglig_av_1 = mkA "halvdaglig" ;
  halvdan_av_1 = mkA "halvdan" ;
  halvdoed_av_1 = mkA "halvdцd" ;
  halvdunkel_av_1 = mkA "halvdunkel" "halvdunkelt" "halvdunkla" "halvdunkla" "halvdunklare" "halvdunklast" "halvdunklaste" ;
  halvdussin_nn_1 = mkN "halvdussin" neutrum ;
  halvenskild_av_1 = mkA "halvenskild" "halvenskilt" ;
  halvfabrikat_nn_1 = mkN "halvfabrikat" neutrum ;
  halvfaerdig_av_1 = mkA "halvfдrdig" ;
  halvfet_av_1 = mkA "halvfet" ;
  halvfigur_nn_1 = mkN "halvfigur" "halvfigurer" ;
  halvflytande_av_1 = mkA "halvflytande" ;
  halvfransk_av_1 = mkA "halvfransk" ;
  halvfylld_av_1 = mkA "halvfylld" "halvfyllt" ;
  halvgaangen_av_1 = mkA "halvgеngen" "halvgеnget" ;
  halvgenomskinlig_av_1 = mkA "halvgenomskinlig" ;
  halvgraes_nn_1 = mkN "halvgrдs" neutrum ;
  halvgud_nn_1 = mkN "halvgud" ;
  halvhet_nn_1 = mkN "halvhet" "halvheter" ;
  halvklar_av_1 = mkA "halvklar" ;
  halvklass_nn_1 = mkN "halvklass" "halvklasser" ;
  halvklot_nn_1 = mkN "halvklot" neutrum ;
  halvknop_nn_1 = mkN "halvknop" ;
  halvkolonn_nn_1 = mkN "halvkolonn" "halvkolonner" ;
  halvkonserv_nn_1 = mkN "halvkonserv" "halvkonserver" ;
  halvkvaeden_av_1 = mkA "halvkvдden" "halvkvдdet" ;
  halvkvaevd_av_1 = mkA "halvkvдvd" "halvkvдvt" ;
  halvledardiod_nn_1 = mkN "halvledardiod" "halvledardioder" ;
  halvledare_nn_1 = mkN "halvledare" "halvledare" ;
  halvlek_nn_1 = mkN "halvlek" ;
  halvliter_nn_1 = mkN "halvliter" "halvlitern" "halvliter" "halvliterna" ;
  halvljus_nn_1 = mkN "halvljus" neutrum ;
  halvmaane_nn_1 = mkN "halvmеne" utrum ;
  halvmesyr_nn_1 = mkN "halvmesyr" "halvmesyrer" ;
  halvmetall_nn_1 = mkN "halvmetall" "halvmetaller" ;
  halvmetallisk_av_1 = mkA "halvmetallisk" ;
  halvmeter_nn_1 = mkN "halvmeter" ;
  halvmeterbred_av_1 = mkA "halvmeterbred" ;
  halvmil_nn_1 = mkN "halvmil" "halvmilen" "halvmil" "halvmilen" ;
  halvmodern_av_1 = mkA "halvmodern" ;
  halvnaken_av_1 = mkA "halvnaken" "halvnaket" ;
  halvnot_nn_1 = mkN "halvnot" "halvnoter" ;
  halvoe_nn_1 = mkN "halvц" ;
  halvoeppen_av_1 = mkA "halvцppen" "halvцppet" ;
  halvofficiell_av_1 = mkA "halvofficiell" ;
  halvpart_nn_1 = mkN "halvpart" "halvparter" ;
  halvprofil_nn_1 = mkN "halvprofil" "halvprofiler" ;
  halvrim_nn_1 = mkN "halvrim" "halvrimmet" "halvrim" "halvrimmen" ;
  halvsanning_nn_1 = mkN "halvsanning" ;
  halvsekel_nn_1 = mkN "halvsekel" neutrum ;
  halvslag_nn_1 = mkN "halvslag" neutrum ;
  halvsluten_av_1 = mkA "halvsluten" "halvslutet" ;
  halvsmaelt_av_1 = mkA "halvsmдlt" "halvsmдlt" ;
  halvspraakig_av_1 = mkA "halvsprеkig" ;
  halvstatlig_av_1 = mkA "halvstatlig" ;
  halvstop_nn_1 = mkN "halvstop" neutrum ;
  halvsur_av_1 = mkA "halvsur" ;
  halvsyskon_nn_1 = mkN "halvsyskon" neutrum ;
  halvsyster_nn_1 = mkN "halvsyster" ;
  halvtid_nn_1 = mkN "halvtid" "halvtider" ;
  halvtimme_nn_1 = mkN "halvtimme" utrum ;
  halvton_nn_1 = mkN "halvton" "halvtoner" ;
  halvtorr_av_1 = mkA "halvtorr" ;
  halvtum_nn_1 = mkN "halvtum" "halvtummen" "halvtum" "halvtummen" ;
  halvvaegs_ab_1 = mkAdv "halvvдgs" ;
  halvvaerld_nn_1 = mkN "halvvдrld" ;
  halvvokal_nn_1 = mkN "halvvokal" "halvvokaler" ;
  halvvuxen_av_1 = mkA "halvvuxen" "halvvuxet" ;
  hambo_nn_1 = mkN "hambo" "hambor" ;
  hamburgare_nn_1 = mkN "hamburgare" "hamburgare" ;
  hamburgerbar_nn_1 = mkN "hamburgerbar" "hamburgerbarer" ;
  hamit_nn_1 = mkN "hamit" "hamiter" ;
  hamitisk_av_1 = mkA "hamitisk" ;
  hammarband_nn_1 = mkN "hammarband" neutrum ;
  hammare_nn_1 = mkN "hammare" "hammaren" "hamrar" "hamrarna" ;
  hammarhaj_nn_1 = mkN "hammarhaj" ;
  hammarslag_nn_1 = mkN "hammarslag" neutrum ;
  hammel_nn_1 = mkN "hammel" "hammeln" "hammlar" "hammlarna" ;
  hammelsadel_nn_1 = mkN "hammelsadel" ;
  hammerless_nn_1 = mkN "hammerless" "hammerlessen" "hammerless" "hammerlessen" ;
  hammock_nn_1 = mkN "hammock" ;
  hammondorgel_nn_1 = mkN "hammondorgel" ;
  hamn_nn_1 = mkN "hamn" ;
  hamnarbetare_nn_1 = mkN "hamnarbetare" "hamnarbetare" ;
  hamnbassaeng_nn_1 = mkN "hamnbassдng" "hamnbassдnger" ;
  hamndirektion_nn_1 = mkN "hamndirektion" "hamndirektioner" ;
  hamnfoerhaallande_nn_1 = mkN "hamnfцrhеllande" ;
  hamnkapten_nn_1 = mkN "hamnkapten" "hamnkaptener" ;
  hamnkontor_nn_1 = mkN "hamnkontor" neutrum ;
  hamnkvarter_nn_1 = mkN "hamnkvarter" "hamnkvarteret" "hamnkvarter" "hamnkvarteren" ;
  hamnstad_nn_1 = mkN "hamnstad" "hamnstдder" ;
  hamnstyrelse_nn_1 = mkN "hamnstyrelse" "hamnstyrelser" ;
  hampfroe_nn_1 = mkN "hampfrц" "hampfrцt" "hampfrцn" "hampfrцen" ;
  hamster_nn_1 = mkN "hamster" ;
  hanbjaelke_nn_1 = mkN "hanbjдlke" utrum ;
  hand_nn_1 = mkN "hand" "hдnder" ;
  handalfabet_nn_1 = mkN "handalfabet" neutrum ;
  handbagage_nn_1 = mkN "handbagage" "handbagaget" "handbagage" "handbagagen" ;
  handbok_nn_1 = mkN "handbok" "handbцcker" ;
  handboll_nn_1 = mkN "handboll" ;
  handbrev_nn_1 = mkN "handbrev" neutrum ;
  handbroms_nn_1 = mkN "handbroms" ;
  handduk_nn_1 = mkN "handduk" ;
  handeldvapen_nn_1 = mkN "handeldvapen" "handeldvapnet" "handeldvapen" "handeldvapnen" ;
  handelsavtal_nn_1 = mkN "handelsavtal" "handelsavtalet" "handelsavtalen" "handelsavtalena" ;
  handelsbank_nn_1 = mkN "handelsbank" "handelsbanker" ;
  handelsbod_nn_1 = mkN "handelsbod" ;
  handelsbolag_nn_1 = mkN "handelsbolag" neutrum ;
  handelsdepartement_nn_1 = mkN "handelsdepartement" "handelsdepartementet" "handelsdepartementen" "handelsdepartementena" ;
  handelsfartyg_nn_1 = mkN "handelsfartyg" neutrum ;
  handelsfoeretag_nn_1 = mkN "handelsfцretag" neutrum ;
  handelshus_nn_1 = mkN "handelshus" neutrum ;
  handelskammare_nn_1 = mkN "handelskammare" "handelskammaren" "handelskamrar" "handelskamrarna" ;
  handelskoep_nn_1 = mkN "handelskцp" neutrum ;
  handelskompani_nn_1 = mkN "handelskompani" "handelskompanit" "handelskompanier" "handelskompanierna" ;
  handelsled_nn_1 = mkN "handelsled" "handelsleder" ;
  handelsman_nn_1 = mkN "handelsman" "handelsmannen" "handelsmдn" "handelsmдnnen" ;
  handelsminister_nn_1 = mkN "handelsminister" ;
  handelspolitisk_av_1 = mkA "handelspolitisk" ;
  handelsregister_nn_1 = mkN "handelsregister" neutrum ;
  handelsresande_nn_1 = mkN "handelsresande" "handelsresanden" "handelsresande" "handelsresandena" ;
  handelstraedgaard_nn_1 = mkN "handelstrдdgеrd" ;
  handelsutbyte_nn_1 = mkN "handelsutbyte" ;
  handfallen_av_1 = mkA "handfallen" "handfallet" ;
  handfallenhet_nn_1 = mkN "handfallenhet" "handfallenheter" ;
  handfast_av_1 = mkA "handfast" "handfast" ;
  handfat_nn_1 = mkN "handfat" neutrum ;
  handflikig_av_1 = mkA "handflikig" ;
  handfull_nn_1 = mkN "handfull" ;
  handgaangen_av_1 = mkA "handgеngen" "handgеnget" ;
  handgemaeng_nn_1 = mkN "handgemдng" neutrum ;
  handgjord_av_1 = mkA "handgjord" "handgjort" ;
  handgranat_nn_1 = mkN "handgranat" "handgranater" ;
  handgrepp_nn_1 = mkN "handgrepp" neutrum ;
  handgriplig_av_1 = mkA "handgriplig" ;
  handgripligen_ab_1 = mkAdv "handgripligen" ;
  handgriplighet_nn_1 = mkN "handgriplighet" "handgripligheter" ;
  handikapp_nn_1 = mkN "handikapp" neutrum ;
  handikappvaard_nn_1 = mkN "handikappvеrd" ;
  handjagare_nn_1 = mkN "handjagare" "handjagare" ;
  handjur_nn_1 = mkN "handjur" neutrum ;
  handkassa_nn_1 = mkN "handkassa" ;
  handklappning_nn_1 = mkN "handklappning" ;
  handklaver_nn_1 = mkN "handklaver" "handklaveret" "handklaver" "handklaveren" ;
  handklove_nn_1 = mkN "handklove" utrum ;
  handkyss_nn_1 = mkN "handkyss" ;
  handlaan_nn_1 = mkN "handlеn" neutrum ;
  handlaeggning_nn_1 = mkN "handlдggning" ;
  handlande_nn_1 = mkN "handlande" "handlanden" "handlande" "handlandena" ;
  handlare_nn_1 = mkN "handlare" "handlare" ;
  handled_nn_1 = mkN "handled" "handleder" ;
  handledare_nn_1 = mkN "handledare" "handledare" ;
  handledning_nn_1 = mkN "handledning" ;
  handling_nn_1 = mkN "handling" ;
  handlingsfrihet_nn_1 = mkN "handlingsfrihet" "handlingsfriheter" ;
  handlingskraftig_av_1 = mkA "handlingskraftig" ;
  handlingsmaenniska_nn_1 = mkN "handlingsmдnniska" ;
  handlingsprogram_nn_1 = mkN "handlingsprogram" "handlingsprogrammet" "handlingsprogram" "handlingsprogrammen" ;
  handlingsregel_nn_1 = mkN "handlingsregel" "handlingsregeln" "handlingsregler" "handlingsreglerna" ;
  handlingssaett_nn_1 = mkN "handlingssдtt" neutrum ;
  handloest_ab_1 = mkAdv "handlцst" ;
  handlov_nn_1 = mkN "handlov" ;
  handout_nn_1 = mkN "handout" "handouten" "handouts" "handoutsen" ;
  handpaalaeggning_nn_1 = mkN "handpеlдggning" ;
  handpenning_nn_1 = mkN "handpenning" ;
  handraeckning_nn_1 = mkN "handrдckning" ;
  handrem_nn_1 = mkN "handrem" "handremmen" "handremmar" "handremmarna" ;
  handsaag_nn_1 = mkN "handsеg" ;
  handsbredd_nn_1 = mkN "handsbredd" "handsbredder" ;
  handsekreterare_nn_1 = mkN "handsekreterare" "handsekreterare" ;
  handskakning_nn_1 = mkN "handskakning" ;
  handske_nn_1 = mkN "handske" utrum ;
  handskrift_nn_1 = mkN "handskrift" "handskrifter" ;
  handskriftsrulle_nn_1 = mkN "handskriftsrulle" utrum ;
  handskriftssamling_nn_1 = mkN "handskriftssamling" ;
  handskriven_av_1 = mkA "handskriven" "handskrivet" ;
  handslag_nn_1 = mkN "handslag" neutrum ;
  handstil_nn_1 = mkN "handstil" ;
  handtag_nn_1 = mkN "handtag" neutrum ;
  handtryckning_nn_1 = mkN "handtryckning" ;
  handuppraeckning_nn_1 = mkN "handupprдckning" ;
  handvolt_nn_1 = mkN "handvolt" "handvolter" ;
  hane_nn_1 = mkN "hane" utrum ;
  hanegaell_nn_1 = mkN "hanegдll" neutrum ;
  hang_nn_1 = mkN "hang" neutrum ;
  hangar_nn_1 = mkN "hangar" "hangarer" ;
  hangarfartyg_nn_1 = mkN "hangarfartyg" neutrum ;
  hank_nn_1 = mkN "hank" ;
  hanlig_av_1 = mkA "hanlig" ;
  hanne_nn_1 = mkN "hanne" utrum ;
  hanorgan_nn_1 = mkN "hanorgan" neutrum ;
  hanrej_nn_1 = mkN "hanrej" ;
  hantel_nn_1 = mkN "hantel" ;
  hantering_nn_1 = mkN "hantering" ;
  hanteringskostnad_nn_1 = mkN "hanteringskostnad" "hanteringskostnader" ;
  hanteringsrisk_nn_1 = mkN "hanteringsrisk" "hanteringsrisker" ;
  hanterlig_av_1 = mkA "hanterlig" ;
  hantlangare_nn_1 = mkN "hantlangare" "hantlangare" ;
  hantverk_nn_1 = mkN "hantverk" neutrum ;
  hantverkare_nn_1 = mkN "hantverkare" "hantverkare" ;
  hantverksarbetare_nn_1 = mkN "hantverksarbetare" "hantverksarbetare" ;
  hantverksfoerening_nn_1 = mkN "hantverksfцrening" ;
  hantverksmaessig_av_1 = mkA "hantverksmдssig" ;
  hantverksskicklighet_nn_1 = mkN "hantverksskicklighet" "hantverksskickligheter" ;
  happening_nn_1 = mkN "happening" ;
  haptoglobin_nn_1 = mkN "haptoglobin" "haptoglobiner" ;
  harang_nn_1 = mkN "harang" "haranger" ;
  hardangersoem_nn_1 = mkN "hardangersцm" "hardangersцmmen" "hardangersцmmar" "hardangersцmmarna" ;
  hare_nn_1 = mkN "hare" utrum ;
  harem_nn_1 = mkN "harem" neutrum ;
  harhanne_nn_1 = mkN "harhanne" utrum ;
  harig_av_1 = mkA "harig" ;
  harkling_nn_1 = mkN "harkling" ;
  harkrank_nn_1 = mkN "harkrank" ;
  harlekin_nn_1 = mkN "harlekin" "harlekiner" ;
  harmfull_av_1 = mkA "harmfull" ;
  harmfylld_av_1 = mkA "harmfylld" "harmfyllt" ;
  harmlig_av_1 = mkA "harmlig" ;
  harmloes_av_1 = mkA "harmlцs" ;
  harmoni_nn_1 = mkN "harmoni" "harmonier" ;
  harmonisk_av_1 = mkA "harmonisk" ;
  harmonium_nn_1 = mkN "harmonium" "harmoniet" "harmonier" "harmonierna" ;
  harmsen_av_1 = mkA "harmsen" "harmset" ;
  harmynt_av_1 = mkA "harmynt" "harmynt" ;
  harnesk_nn_1 = mkN "harnesk" neutrum ;
  harpalt_nn_1 = mkN "harpalt" ;
  harpist_nn_1 = mkN "harpist" "harpister" ;
  harpun_nn_1 = mkN "harpun" "harpuner" ;
  harr_nn_1 = mkN "harr" ;
  harskramla_nn_1 = mkN "harskramla" ;
  harspaar_nn_1 = mkN "harspеr" neutrum ;
  harstig_nn_1 = mkN "harstig" ;
  hartass_nn_1 = mkN "hartass" ;
  harts_nn_1 = mkN "harts" "hartset" "hartser" "hartserna" ;
  hartsfiol_nn_1 = mkN "hartsfiol" "hartsfioler" ;
  harv_nn_1 = mkN "harv" ;
  harvaerja_nn_1 = mkN "harvдrja" ;
  has_nn_1 = mkN "has" ;
  hasardspel_nn_1 = mkN "hasardspel" "hasardspelet" "hasardspel" "hasardspelen" ;
  haschcigarett_nn_1 = mkN "haschcigarett" "haschcigaretter" ;
  hasp_nn_1 = mkN "hasp" ;
  haspel_nn_1 = mkN "haspel" ;
  hassel_nn_1 = mkN "hassel" ;
  hasselmus_nn_1 = mkN "hasselmus" "hasselmusen" "hasselmцss" "hasselmцssen" ;
  hasselnoet_nn_1 = mkN "hasselnцt" "hasselnцtter" ;
  hasselsnok_nn_1 = mkN "hasselsnok" ;
  hastig_av_1 = mkA "hastig" ;
  hastighet_nn_1 = mkN "hastighet" "hastigheter" ;
  hastighetsaakning_nn_1 = mkN "hastighetsеkning" ;
  hastighetsgraens_nn_1 = mkN "hastighetsgrдns" "hastighetsgrдnser" ;
  hastighetskontroll_nn_1 = mkN "hastighetskontroll" "hastighetskontroller" ;
  hastighetsmaetare_nn_1 = mkN "hastighetsmдtare" "hastighetsmдtare" ;
  hastighetstaevling_nn_1 = mkN "hastighetstдvling" ;
  hastverk_nn_1 = mkN "hastverk" neutrum ;
  hatfull_av_1 = mkA "hatfull" ;
  hatfylld_av_1 = mkA "hatfylld" "hatfyllt" ;
  hatisk_av_1 = mkA "hatisk" ;
  hatkaerlek_nn_1 = mkN "hatkдrlek" ;
  hatt_nn_1 = mkN "hatt" ;
  hattig_av_1 = mkA "hattig" ;
  hattkulle_nn_1 = mkN "hattkulle" utrum ;
  hattstock_nn_1 = mkN "hattstock" ;
  hattsvamp_nn_1 = mkN "hattsvamp" ;
  haubits_nn_1 = mkN "haubits" ;
  haubitz_nn_1 = mkN "haubitz" ;
  hausse_nn_1 = mkN "hausse" "hausser" ;
  hav_nn_1 = mkN "hav" neutrum ;
  havande_av_1 = mkA "havande" ;
  havandeskap_nn_1 = mkN "havandeskap" "havandeskapet" "havandeskapen" "havandeskapena" ;
  haveri_nn_1 = mkN "haveri" "haverit" "haverier" "haverierna" ;
  haverikommission_nn_1 = mkN "haverikommission" "haverikommissioner" ;
  haverist_nn_1 = mkN "haverist" "haverister" ;
  havreflarn_nn_1 = mkN "havreflarn" neutrum ;
  havregryn_nn_1 = mkN "havregryn" neutrum ;
  havregrynsgroet_nn_1 = mkN "havregrynsgrцt" ;
  havrekorn_nn_1 = mkN "havrekorn" neutrum ;
  havreliknande_av_1 = mkA "havreliknande" ;
  havsabborre_nn_1 = mkN "havsabborre" utrum ;
  havsanemon_nn_1 = mkN "havsanemon" "havsanemoner" ;
  havsbad_nn_1 = mkN "havsbad" neutrum ;
  havsbotten_nn_1 = mkN "havsbotten" ;
  havsbris_nn_1 = mkN "havsbris" ;
  havsdjup_nn_1 = mkN "havsdjup" neutrum ;
  havsfaagel_nn_1 = mkN "havsfеgel" ;
  havsfru_nn_1 = mkN "havsfru" ;
  havsgud_nn_1 = mkN "havsgud" ;
  havsis_nn_1 = mkN "havsis" ;
  havskappsegling_nn_1 = mkN "havskappsegling" ;
  havskatt_nn_1 = mkN "havskatt" "havskatter" ;
  havskraeftstjaert_nn_1 = mkN "havskrдftstjдrt" ;
  havskryssare_nn_1 = mkN "havskryssare" "havskryssare" ;
  havslax_nn_1 = mkN "havslax" ;
  havsmus_nn_1 = mkN "havsmus" ;
  havsnivaa_nn_1 = mkN "havsnivе" "havsnivеer" ;
  havsoern_nn_1 = mkN "havsцrn" ;
  havsomraade_nn_1 = mkN "havsomrеde" ;
  havsstrand_nn_1 = mkN "havsstrand" "havsstrдnder" ;
  havsstroem_nn_1 = mkN "havsstrцm" "havsstrцmmen" "havsstrцmmar" "havsstrцmmarna" ;
  havstrut_nn_1 = mkN "havstrut" ;
  havstulpan_nn_1 = mkN "havstulpan" "havstulpaner" ;
  havsutter_nn_1 = mkN "havsutter" ;
  havsvaext_nn_1 = mkN "havsvдxt" "havsvдxter" ;
  havsvatten_nn_1 = mkN "havsvatten" "havsvattnet" "havsvatten" "havsvattnen" ;
  havsvik_nn_1 = mkN "havsvik" ;
  havtorn_nn_1 = mkN "havtorn" ;
  hawaiiansk_av_1 = mkA "hawaiiansk" ;
  hawaiisk_av_1 = mkA "hawaiisk" ;
  he_man_nn_1 = mkN "he-man" "he-mannen" "he-mдn" "he-mдnnen" ;
  hearing_nn_1 = mkN "hearing" ;
  heat_nn_1 = mkN "heat" neutrum ;
  hebre_nn_1 = mkN "hebrй" "hebrйer" ;
  hebreisk_av_1 = mkA "hebreisk" ;
  hed_nn_1 = mkN "hed" ;
  heden_av_1 = mkA "heden" "hedet" ;
  hedendom_nn_1 = mkN "hedendom" ;
  hederlig_av_1 = mkA "hederlig" ;
  hedersam_av_1 = mkA "hedersam" "hedersamt" "hedersamma" "hedersamma" "hedersammare" "hedersammast" "hedersammaste" ;
  hedersbetygelse_nn_1 = mkN "hedersbetygelse" "hedersbetygelser" ;
  hedersbevisning_nn_1 = mkN "hedersbevisning" ;
  hedersdoktor_nn_1 = mkN "hedersdoktor" "hedersdoktorer" ;
  hedersgaest_nn_1 = mkN "hedersgдst" "hedersgдster" ;
  hedersknyffel_nn_1 = mkN "hedersknyffel" ;
  hederskodex_nn_1 = mkN "hederskodex" ;
  hederskompani_nn_1 = mkN "hederskompani" "hederskompanit" "hederskompanier" "hederskompanierna" ;
  hedersledamot_nn_1 = mkN "hedersledamot" "hedersledamцter" ;
  hedersman_nn_1 = mkN "hedersman" "hedersmannen" "hedersmдn" "hedersmдnnen" ;
  hedersmedlem_nn_1 = mkN "hedersmedlem" "hedersmedlemmen" "hedersmedlemmar" "hedersmedlemmarna" ;
  hedersomnaemnande_nn_1 = mkN "hedersomnдmnande" ;
  hedersord_nn_1 = mkN "hedersord" neutrum ;
  hederspris_nn_1 = mkN "hederspris" neutrum ;
  hederssak_nn_1 = mkN "hederssak" "hederssaker" ;
  hedersskuld_nn_1 = mkN "hedersskuld" "hedersskulder" ;
  hedervaerd_av_1 = mkA "hedervдrd" "hedervдrt" ;
  hedning_nn_1 = mkN "hedning" ;
  hednisk_av_1 = mkA "hednisk" ;
  hedonist_nn_1 = mkN "hedonist" "hedonister" ;
  hedonistisk_av_1 = mkA "hedonistisk" ;
  hedrande_av_1 = mkA "hedrande" ;
  hegemoni_nn_1 = mkN "hegemoni" "hegemonier" ;
  hejaklack_nn_1 = mkN "hejaklack" ;
  hejare_nn_1 = mkN "hejare" "hejare" ;
  hejarklack_nn_1 = mkN "hejarklack" ;
  hejdloes_av_1 = mkA "hejdlцs" ;
  hejduk_nn_1 = mkN "hejduk" ;
  hejdundrande_av_1 = mkA "hejdundrande" ;
  hejig_av_1 = mkA "hejig" ;
  hekatomb_nn_1 = mkN "hekatomb" "hekatomber" ;
  hektar_nn_1 = mkN "hektar" neutrum ;
  hektisk_av_1 = mkA "hektisk" ;
  hekto_nn_1 = mkN "hekto" "hektot" "hekto" "hektona" ;
  hektograf_nn_1 = mkN "hektograf" "hektografer" ;
  hektogram_nn_1 = mkN "hektogram" "hektogrammet" "hektogram" "hektogrammen" ;
  hektoliter_nn_1 = mkN "hektoliter" "hektolitern" "hektoliter" "hektoliterna" ;
  hel_av_1 = mkA "hel" ;
  helaakersbygd_nn_1 = mkN "helеkersbygd" "helеkersbygder" ;
  helafton_nn_1 = mkN "helafton" "helaftonen" "helaftnar" "helaftnarna" ;
  helautomatisk_av_1 = mkA "helautomatisk" ;
  helbild_nn_1 = mkN "helbild" "helbilder" ;
  helbraegda_av_1 = mkA "helbrдgda" ;
  helbraegdagoerelse_nn_1 = mkN "helbrдgdagцrelse" "helbrдgdagцrelser" ;
  heldag_nn_1 = mkN "heldag" ;
  heldaglig_av_1 = mkA "heldaglig" ;
  heldragen_av_1 = mkA "heldragen" "heldraget" ;
  helfabrikat_nn_1 = mkN "helfabrikat" neutrum ;
  helfet_av_1 = mkA "helfet" ;
  helfigur_nn_1 = mkN "helfigur" "helfigurer" ;
  helfoersaekring_nn_1 = mkN "helfцrsдkring" ;
  helfransk_av_1 = mkA "helfransk" ;
  helg_nn_1 = mkN "helg" "helger" ;
  helgdag_nn_1 = mkN "helgdag" ;
  helgedom_nn_1 = mkN "helgedom" ;
  helgeraan_nn_1 = mkN "helgerеn" neutrum ;
  helgfri_av_1 = mkA "helgfri" "helgfritt" ;
  helgjuten_av_1 = mkA "helgjuten" "helgjutet" ;
  helgmaalsringning_nn_1 = mkN "helgmеlsringning" ;
  helgon_nn_1 = mkN "helgon" neutrum ;
  helgonlegend_nn_1 = mkN "helgonlegend" "helgonlegender" ;
  helhet_nn_1 = mkN "helhet" "helheter" ;
  helhetsbild_nn_1 = mkN "helhetsbild" "helhetsbilder" ;
  helhetsintryck_nn_1 = mkN "helhetsintryck" neutrum ;
  helhetssyn_nn_1 = mkN "helhetssyn" "helhetssyner" ;
  helig_av_1 = mkA "helig" ;
  helikon_nn_1 = mkN "helikon" neutrum ;
  helikopter_nn_1 = mkN "helikopter" ;
  helinackordering_nn_1 = mkN "helinackordering" ;
  heliocentrisk_av_1 = mkA "heliocentrisk" ;
  heliofob_av_1 = mkA "heliofob" ;
  heliograf_nn_1 = mkN "heliograf" "heliografer" ;
  heliostat_nn_1 = mkN "heliostat" "heliostater" ;
  heliotrop_nn_1 = mkN "heliotrop" "heliotroper" ;
  helkonserv_nn_1 = mkN "helkonserv" "helkonserver" ;
  helkroppsdos_nn_1 = mkN "helkroppsdos" "helkroppsdoser" ;
  helkvaell_nn_1 = mkN "helkvдll" ;
  hellen_nn_1 = mkN "hellen" "hellener" ;
  hellenistisk_av_1 = mkA "hellenistisk" ;
  hellensk_av_1 = mkA "hellensk" ;
  heller_ab_1 = mkAdv "heller" ;
  helljus_nn_1 = mkN "helljus" neutrum ;
  hellre_ab_1 = mkAdv "hellre" ;
  helnot_nn_1 = mkN "helnot" "helnoter" ;
  helnykter_av_1 = mkA "helnykter" "helnyktert" "helnyktra" "helnyktra" "helnyktrare" "helnyktrast" "helnyktraste" ;
  helomvaendning_nn_1 = mkN "helomvдndning" ;
  helsida_nn_1 = mkN "helsida" ;
  helskaegg_nn_1 = mkN "helskдgg" neutrum ;
  helskaeggsluffare_nn_1 = mkN "helskдggsluffare" "helskдggsluffare" ;
  helst_ab_1 = mkAdv "helst" ;
  helstekt_av_1 = mkA "helstekt" "helstekt" ;
  helsyskon_nn_1 = mkN "helsyskon" neutrum ;
  heltaeckande_av_1 = mkA "heltдckande" ;
  heltal_nn_1 = mkN "heltal" "heltalet" "heltalen" "heltalena" ;
  heltid_nn_1 = mkN "heltid" "heltider" ;
  heltidsloen_nn_1 = mkN "heltidslцn" "heltidslцner" ;
  helton_nn_1 = mkN "helton" "heltoner" ;
  helvete_nn_1 = mkN "helvete" ;
  helvetesmaskin_nn_1 = mkN "helvetesmaskin" "helvetesmaskiner" ;
  helvetisk_av_1 = mkA "helvetisk" ;
  hem_ab_1 = mkAdv "hem" ;
  hem_nn_1 = mkN "hem" "hemmet" "hem" "hemmen" ;
  hemaat_ab_1 = mkAdv "hemеt" ;
  hemarbetande_av_1 = mkA "hemarbetande" ;
  hematit_nn_1 = mkN "hematit" "hematiter" ;
  hembaera_vb_1 = mkV "hembдra" "hembar" "hemburit" ;
  hembageri_nn_1 = mkN "hembageri" "hembagerit" "hembagerier" "hembagerierna" ;
  hembakt_av_1 = mkA "hembakt" "hembakt" ;
  hembesoek_nn_1 = mkN "hembesцk" neutrum ;
  hembitraede_nn_1 = mkN "hembitrдde" ;
  hembjuda_vb_1 = mkV "hembjuda" "hembjцd" "hembjudit" ;
  hembraennare_nn_1 = mkN "hembrдnnare" "hembrдnnare" ;
  hembud_nn_1 = mkN "hembud" neutrum ;
  hembygd_nn_1 = mkN "hembygd" "hembygder" ;
  hembygdsfoerening_nn_1 = mkN "hembygdsfцrening" ;
  hembygdsgaard_nn_1 = mkN "hembygdsgеrd" ;
  hemdator_nn_1 = mkN "hemdator" "hemdatorer" ;
  hemdragande_av_1 = mkA "hemdragande" ;
  hemfalla_vb_1 = mkV "hemfalla" "hemfцll" "hemfallit" ;
  hemfoersaekring_nn_1 = mkN "hemfцrsдkring" ;
  hemfridsbrott_nn_1 = mkN "hemfridsbrott" neutrum ;
  hemgaang_nn_1 = mkN "hemgеng" ;
  hemgalax_nn_1 = mkN "hemgalax" "hemgalaxer" ;
  hemgift_nn_1 = mkN "hemgift" "hemgifter" ;
  hemgjord_av_1 = mkA "hemgjord" "hemgjort" ;
  hemhjaelp_nn_1 = mkN "hemhjдlp" ;
  hemifraan_ab_1 = mkAdv "hemifrеn" ;
  heminredning_nn_1 = mkN "heminredning" ;
  hemisfaer_nn_1 = mkN "hemisfдr" "hemisfдrer" ;
  hemkaer_av_1 = mkA "hemkдr" ;
  hemkonsulent_nn_1 = mkN "hemkonsulent" "hemkonsulenter" ;
  hemlaan_nn_1 = mkN "hemlеn" neutrum ;
  hemland_nn_1 = mkN "hemland" "hemlandet" "hemlдnder" "hemlдnderna" ;
  hemlig_av_1 = mkA "hemlig" ;
  hemligen_ab_1 = mkAdv "hemligen" ;
  hemlighaalla_vb_1 = mkV "hemlighеlla" "hemlighцll" "hemlighеllit" ;
  hemlighet_nn_1 = mkN "hemlighet" "hemligheter" ;
  hemlighetsfull_av_1 = mkA "hemlighetsfull" ;
  hemlighetsmakeri_nn_1 = mkN "hemlighetsmakeri" "hemlighetsmakerit" "hemlighetsmakerier" "hemlighetsmakerierna" ;
  hemlighus_nn_1 = mkN "hemlighus" neutrum ;
  hemligstaempel_nn_1 = mkN "hemligstдmpel" ;
  hemlock_nn_1 = mkN "hemlock" ;
  hemloes_av_1 = mkA "hemlцs" ;
  hemma_ab_1 = mkAdv "hemma" ;
  hemmadotter_nn_1 = mkN "hemmadotter" "hemmadottern" "hemmadцttrar" "hemmadцttrarna" ;
  hemmafru_nn_1 = mkN "hemmafru" ;
  hemmagjord_av_1 = mkA "hemmagjord" "hemmagjort" ;
  hemmahoerande_av_1 = mkA "hemmahцrande" ;
  hemmakvaell_nn_1 = mkN "hemmakvдll" ;
  hemmalag_nn_1 = mkN "hemmalag" neutrum ;
  hemmaman_nn_1 = mkN "hemmaman" "hemmamannen" "hemmamдn" "hemmamдnnen" ;
  hemman_nn_1 = mkN "hemman" neutrum ;
  hemmansaegare_nn_1 = mkN "hemmansдgare" "hemmansдgare" ;
  hemmaplan_nn_1 = mkN "hemmaplan" "hemmaplaner" ;
  hemmarock_nn_1 = mkN "hemmarock" ;
  hemmastadd_av_1 = mkA "hemmastadd" ;
  hemmavid_ab_1 = mkAdv "hemmavid" ;
  hemmiljoe_nn_1 = mkN "hemmiljц" "hemmiljцn" "hemmiljцer" "hemmiljцerna" ;
  hemoglobin_nn_1 = mkN "hemoglobin" "hemoglobiner" ;
  hemort_nn_1 = mkN "hemort" "hemorter" ;
  hemsamarit_nn_1 = mkN "hemsamarit" "hemsamariter" ;
  hemsjukvaardsbidrag_nn_1 = mkN "hemsjukvеrdsbidrag" neutrum ;
  hemsk_av_1 = mkA "hemsk" ;
  hemskillnad_nn_1 = mkN "hemskillnad" "hemskillnader" ;
  hemsoekelse_nn_1 = mkN "hemsцkelse" "hemsцkelser" ;
  hemspraak_nn_1 = mkN "hemsprеk" neutrum ;
  hemstad_nn_1 = mkN "hemstad" "hemstдder" ;
  hemstaellning_nn_1 = mkN "hemstдllning" ;
  hemtam_av_1 = mkA "hemtam" ;
  hemtjaenst_nn_1 = mkN "hemtjдnst" "hemtjдnster" ;
  hemtrakt_nn_1 = mkN "hemtrakt" "hemtrakter" ;
  hemtrevlig_av_1 = mkA "hemtrevlig" ;
  hemtrevnad_nn_1 = mkN "hemtrevnad" "hemtrevnader" ;
  hemulsman_nn_1 = mkN "hemulsman" "hemulsmannen" "hemulsmдn" "hemulsmдnnen" ;
  hemuppgift_nn_1 = mkN "hemuppgift" "hemuppgifter" ;
  hemvaern_nn_1 = mkN "hemvдrn" neutrum ;
  hemvaevd_av_1 = mkA "hemvдvd" "hemvдvt" ;
  hemvist_nn_1 = mkN "hemvist" neutrum ;
  hen_nn_1 = mkN "hen" "henen" "henar" "henarna" ;
  henry_nn_1 = mkN "henry" "henryn" "henry" "henryna" ;
  heparin_nn_1 = mkN "heparin" "hepariner" ;
  hepatit_nn_1 = mkN "hepatit" "hepatiter" ;
  heraldiker_nn_1 = mkN "heraldiker" "heraldikern" "heraldiker" "heraldikerna" ;
  heraldisk_av_1 = mkA "heraldisk" ;
  herbarium_nn_1 = mkN "herbarium" "herbariet" "herbarier" "herbarierna" ;
  herbicid_nn_1 = mkN "herbicid" "herbicider" ;
  herdabrev_nn_1 = mkN "herdabrev" neutrum ;
  herdaminne_nn_1 = mkN "herdaminne" ;
  herde_nn_1 = mkN "herde" utrum ;
  herdedikt_nn_1 = mkN "herdedikt" "herdedikter" ;
  herdefolk_nn_1 = mkN "herdefolk" neutrum ;
  herdestund_nn_1 = mkN "herdestund" "herdestunder" ;
  hereditaer_av_1 = mkA "hereditдr" ;
  heresi_nn_1 = mkN "heresi" "heresier" ;
  heretiker_nn_1 = mkN "heretiker" "heretikern" "heretiker" "heretikerna" ;
  heretisk_av_1 = mkA "heretisk" ;
  herkulisk_av_1 = mkA "herkulisk" ;
  herm_nn_1 = mkN "herm" "hermer" ;
  hermafrodit_nn_1 = mkN "hermafrodit" "hermafroditer" ;
  hermelin_nn_1 = mkN "hermelin" "hermeliner" ;
  hermeneutiker_nn_1 = mkN "hermeneutiker" "hermeneutikern" "hermeneutiker" "hermeneutikerna" ;
  hermeneutisk_av_1 = mkA "hermeneutisk" ;
  hermetisk_av_1 = mkA "hermetisk" ;
  heroin_nn_1 = mkN "heroin" "heroiner" ;
  heroinist_nn_1 = mkN "heroinist" "heroinister" ;
  heroisk_av_1 = mkA "heroisk" ;
  heros_nn_1 = mkN "heros" "heroser" ;
  herostratisk_av_1 = mkA "herostratisk" ;
  herradoeme_nn_1 = mkN "herradцme" ;
  herrcykel_nn_1 = mkN "herrcykel" ;
  herrdubbel_nn_1 = mkN "herrdubbel" ;
  herre_nn_1 = mkN "herre" utrum ;
  herrefolk_nn_1 = mkN "herrefolk" neutrum ;
  herrekipering_nn_1 = mkN "herrekipering" ;
  herreloes_av_1 = mkA "herrelцs" ;
  herresaete_nn_1 = mkN "herresдte" ;
  herrgaard_nn_1 = mkN "herrgеrd" ;
  herrgaardsost_nn_1 = mkN "herrgеrdsost" ;
  herrgaardsvagn_nn_1 = mkN "herrgеrdsvagn" ;
  herrnhutare_nn_1 = mkN "herrnhutare" "herrnhutare" ;
  herrsida_nn_1 = mkN "herrsida" ;
  herrsingel_nn_1 = mkN "herrsingel" ;
  herrskap_nn_1 = mkN "herrskap" "herrskapet" "herrskapen" "herrskapena" ;
  herrtidning_nn_1 = mkN "herrtidning" ;
  hertig_nn_1 = mkN "hertig" ;
  hertigdoeme_nn_1 = mkN "hertigdцme" ;
  hertiginna_nn_1 = mkN "hertiginna" ;
  hertz_nn_1 = mkN "hertz" "hertzen" "hertz" "hertzen" ;
  hes_av_1 = mkA "hes" ;
  heshet_nn_1 = mkN "heshet" "hesheter" ;
  het_av_1 = mkA "het" ;
  hetaer_nn_1 = mkN "hetдr" "hetдrer" ;
  heterodox_av_1 = mkA "heterodox" ;
  heterogen_av_1 = mkA "heterogen" ;
  heteroklis_nn_1 = mkN "heteroklis" "heterokliser" ;
  heteroklitisk_av_1 = mkA "heteroklitisk" ;
  heterosexuell_av_1 = mkA "heterosexuell" ;
  heterotematisk_av_1 = mkA "heterotematisk" ;
  heterozygot_av_1 = mkA "heterozygot" "heterozygot" ;
  heterozygot_nn_1 = mkN "heterozygot" "heterozygoter" ;
  hetman_nn_1 = mkN "hetman" "hetmaner" ;
  hetsig_av_1 = mkA "hetsig" ;
  hetsjakt_nn_1 = mkN "hetsjakt" "hetsjakter" ;
  hetsporre_nn_1 = mkN "hetsporre" utrum ;
  hettit_nn_1 = mkN "hettit" "hettiter" ;
  hettitisk_av_1 = mkA "hettitisk" ;
  hetvatten_nn_1 = mkN "hetvatten" "hetvattnet" "hetvatten" "hetvattnen" ;
  hetvin_nn_1 = mkN "hetvin" "hetvinet" "hetviner" "hetvinerna" ;
  heuristisk_av_1 = mkA "heuristisk" ;
  hexameter_nn_1 = mkN "hexameter" ;
  hibiskus_nn_1 = mkN "hibiskus" ;
  hickning_nn_1 = mkN "hickning" ;
  hierarki_nn_1 = mkN "hierarki" "hierarkier" ;
  hierarkisk_av_1 = mkA "hierarkisk" ;
  hieratisk_av_1 = mkA "hieratisk" ;
  hieroglyf_nn_1 = mkN "hieroglyf" "hieroglyfer" ;
  higgspartikel_nn_1 = mkN "higgspartikel" ;
  hillebard_nn_1 = mkN "hillebard" "hillebarder" ;
  himla_av_1 = mkA "himla" ;
  himlaboren_av_1 = mkA "himlaboren" "himlaboret" ;
  himlakropp_nn_1 = mkN "himlakropp" ;
  himlastege_nn_1 = mkN "himlastege" utrum ;
  himlastormande_av_1 = mkA "himlastormande" ;
  himlastormare_nn_1 = mkN "himlastormare" "himlastormare" ;
  himmel_nn_1 = mkN "himmel" ;
  himmelsblaa_av_1 = mkA "himmelsblе" "himmelsblеtt" ;
  himmelsfaerd_nn_1 = mkN "himmelsfдrd" "himmelsfдrder" ;
  himmelsk_av_1 = mkA "himmelsk" ;
  himmelsobjekt_nn_1 = mkN "himmelsobjekt" neutrum ;
  himmelspol_nn_1 = mkN "himmelspol" "himmelspoler" ;
  himmelssaeng_nn_1 = mkN "himmelssдng" ;
  himmelssfaer_nn_1 = mkN "himmelssfдr" "himmelssfдrer" ;
  himmelsskriande_av_1 = mkA "himmelsskriande" ;
  himmelsvid_av_1 = mkA "himmelsvid" ;
  hind_nn_1 = mkN "hind" ;
  hinder_nn_1 = mkN "hinder" neutrum ;
  hinderbock_nn_1 = mkN "hinderbock" ;
  hinderloepning_nn_1 = mkN "hinderlцpning" ;
  hinderloes_av_1 = mkA "hinderlцs" ;
  hindersam_av_1 = mkA "hindersam" "hindersamt" "hindersamma" "hindersamma" "hindersammare" "hindersammast" "hindersammaste" ;
  hindersproevning_nn_1 = mkN "hindersprцvning" ;
  hindertrick_nn_1 = mkN "hindertrick" neutrum ;
  hindu_nn_1 = mkN "hindu" "hinduer" ;
  hinduisk_av_1 = mkA "hinduisk" ;
  hingst_nn_1 = mkN "hingst" ;
  hink_nn_1 = mkN "hink" ;
  hinkvis_ab_1 = mkAdv "hinkvis" ;
  hinna_vb_1 = mkV "hinna" "hann" "hunnit" ;
  hipp_av_1 = mkA "hipp" ;
  hippie_nn_1 = mkN "hippie" "hippien" "hippies" "hippiesen" ;
  hippodrom_nn_1 = mkN "hippodrom" "hippodromer" ;
  hippolog_nn_1 = mkN "hippolog" "hippologer" ;
  hippologisk_av_1 = mkA "hippologisk" ;
  hird_nn_1 = mkN "hird" "hirder" ;
  hisklig_av_1 = mkA "hisklig" ;
  hispig_av_1 = mkA "hispig" ;
  hiss_nn_1 = mkN "hiss" ;
  hissinstallation_nn_1 = mkN "hissinstallation" "hissinstallationer" ;
  hisskorg_nn_1 = mkN "hisskorg" ;
  histamin_nn_1 = mkN "histamin" "histaminet" "histaminer" "histaminerna" ;
  histolog_nn_1 = mkN "histolog" "histologer" ;
  historia_nn_1 = mkN "historia" "historien" "historier" "historierna" ;
  historiebok_nn_1 = mkN "historiebok" "historiebцcker" ;
  historieloes_av_1 = mkA "historielцs" ;
  historieskrivare_nn_1 = mkN "historieskrivare" "historieskrivare" ;
  historiett_nn_1 = mkN "historiett" "historietter" ;
  historik_nn_1 = mkN "historik" "historiker" ;
  historiker_nn_1 = mkN "historiker" "historikern" "historiker" "historikerna" ;
  historiograf_nn_1 = mkN "historiograf" "historiografer" ;
  historisk_av_1 = mkA "historisk" ;
  histrion_nn_1 = mkN "histrion" "histrioner" ;
  hit_ab_1 = mkAdv "hit" ;
  hit_nn_1 = mkN "hit" "hiten" "hits" "hitsen" ;
  hitaat_ab_1 = mkAdv "hitеt" ;
  hithoerande_av_1 = mkA "hithцrande" ;
  hitintills_ab_1 = mkAdv "hitintills" ;
  hittebarn_nn_1 = mkN "hittebarn" neutrum ;
  hittilldags_ab_1 = mkAdv "hittilldags" ;
  hittills_ab_1 = mkAdv "hittills" ;
  hittillsvarande_av_1 = mkA "hittillsvarande" ;
  hjaelm_nn_1 = mkN "hjдlm" ;
  hjaelmprydnad_nn_1 = mkN "hjдlmprydnad" "hjдlmprydnader" ;
  hjaelp_nn_1 = mkN "hjдlp" ;
  hjaelpare_nn_1 = mkN "hjдlpare" "hjдlpare" ;
  hjaelpbaat_nn_1 = mkN "hjдlpbеt" ;
  hjaelpfartyg_nn_1 = mkN "hjдlpfartyg" neutrum ;
  hjaelpklass_nn_1 = mkN "hjдlpklass" "hjдlpklasser" ;
  hjaelpkryssare_nn_1 = mkN "hjдlpkryssare" "hjдlpkryssare" ;
  hjaelplig_av_1 = mkA "hjдlplig" ;
  hjaelplinje_nn_1 = mkN "hjдlplinje" "hjдlplinjer" ;
  hjaelploes_av_1 = mkA "hjдlplцs" ;
  hjaelpmedel_nn_1 = mkN "hjдlpmedel" neutrum ;
  hjaelpmotor_nn_1 = mkN "hjдlpmotor" "hjдlpmotorer" ;
  hjaelpsaendning_nn_1 = mkN "hjдlpsдndning" ;
  hjaelpsam_av_1 = mkA "hjдlpsam" "hjдlpsamt" "hjдlpsamma" "hjдlpsamma" "hjдlpsammare" "hjдlpsammast" "hjдlpsammaste" ;
  hjaelpsamhet_nn_1 = mkN "hjдlpsamhet" "hjдlpsamheter" ;
  hjaelpspraak_nn_1 = mkN "hjдlpsprеk" neutrum ;
  hjaelpverb_nn_1 = mkN "hjдlpverb" neutrum ;
  hjaelpvetenskap_nn_1 = mkN "hjдlpvetenskap" "hjдlpvetenskaper" ;
  hjaelte_nn_1 = mkN "hjдlte" utrum ;
  hjaeltedaad_nn_1 = mkN "hjдltedеd" neutrum ;
  hjaeltemodig_av_1 = mkA "hjдltemodig" ;
  hjaeltesaga_nn_1 = mkN "hjдltesaga" ;
  hjaernaktivitet_nn_1 = mkN "hjдrnaktivitet" "hjдrnaktiviteter" ;
  hjaernatrofi_nn_1 = mkN "hjдrnatrofi" "hjдrnatrofier" ;
  hjaernbalk_nn_1 = mkN "hjдrnbalk" ;
  hjaernbloedning_nn_1 = mkN "hjдrnblцdning" ;
  hjaernbyte_nn_1 = mkN "hjдrnbyte" ;
  hjaerncell_nn_1 = mkN "hjдrncell" "hjдrnceller" ;
  hjaerndel_nn_1 = mkN "hjдrndel" "hjдrndelen" "hjдrndelar" "hjдrndelarna" ;
  hjaerndoed_av_1 = mkA "hjдrndцd" ;
  hjaernhinna_nn_1 = mkN "hjдrnhinna" ;
  hjaernhinneinflammation_nn_1 = mkN "hjдrnhinneinflammation" "hjдrnhinneinflammationer" ;
  hjaerninflammation_nn_1 = mkN "hjдrninflammation" "hjдrninflammationer" ;
  hjaernoperation_nn_1 = mkN "hjдrnoperation" "hjдrnoperationer" ;
  hjaernsjukdom_nn_1 = mkN "hjдrnsjukdom" ;
  hjaernskaal_nn_1 = mkN "hjдrnskеl" ;
  hjaernskakning_nn_1 = mkN "hjдrnskakning" ;
  hjaernstam_nn_1 = mkN "hjдrnstam" "hjдrnstammen" "hjдrnstammar" "hjдrnstammarna" ;
  hjaernstorm_nn_1 = mkN "hjдrnstorm" ;
  hjaerntrust_nn_1 = mkN "hjдrntrust" "hjдrntruster" ;
  hjaerntumoer_nn_1 = mkN "hjдrntumцr" "hjдrntumцrer" ;
  hjaernvindling_nn_1 = mkN "hjдrnvindling" ;
  hjaertaengslig_av_1 = mkA "hjдrtдngslig" ;
  hjaertaktivitet_nn_1 = mkN "hjдrtaktivitet" "hjдrtaktiviteter" ;
  hjaertans_ab_1 = mkAdv "hjдrtans" ;
  hjaertas_av_1 = mkA "hjдrtas" ;
  hjaertattack_nn_1 = mkN "hjдrtattack" "hjдrtattacker" ;
  hjaertblad_nn_1 = mkN "hjдrtblad" neutrum ;
  hjaerteangelaegenhet_nn_1 = mkN "hjдrteangelдgenhet" "hjдrteangelдgenheter" ;
  hjaertegod_av_1 = mkA "hjдrtegod" ;
  hjaertegryn_nn_1 = mkN "hjдrtegryn" neutrum ;
  hjaertegull_nn_1 = mkN "hjдrtegull" neutrum ;
  hjaertekrossare_nn_1 = mkN "hjдrtekrossare" "hjдrtekrossare" ;
  hjaerter_nn_1 = mkN "hjдrter" "hjдrtern" "hjдrter" "hjдrterna" ;
  hjaertesak_nn_1 = mkN "hjдrtesak" "hjдrtesaker" ;
  hjaertesuck_nn_1 = mkN "hjдrtesuck" ;
  hjaertevaen_nn_1 = mkN "hjдrtevдn" "hjдrtevдnnen" "hjдrtevдnner" "hjдrtevдnnerna" ;
  hjaertfel_nn_1 = mkN "hjдrtfel" "hjдrtfelet" "hjдrtfel" "hjдrtfelen" ;
  hjaertformig_av_1 = mkA "hjдrtformig" ;
  hjaertinfarkt_nn_1 = mkN "hjдrtinfarkt" "hjдrtinfarkter" ;
  hjaertinnerlig_av_1 = mkA "hjдrtinnerlig" ;
  hjaertklaff_nn_1 = mkN "hjдrtklaff" ;
  hjaertklappning_nn_1 = mkN "hjдrtklappning" ;
  hjaertknipande_av_1 = mkA "hjдrtknipande" ;
  hjaertkramp_nn_1 = mkN "hjдrtkramp" "hjдrtkramper" ;
  hjaertlig_av_1 = mkA "hjдrtlig" ;
  hjaertligen_ab_1 = mkAdv "hjдrtligen" ;
  hjaertljud_nn_1 = mkN "hjдrtljud" neutrum ;
  hjaertloes_av_1 = mkA "hjдrtlцs" ;
  hjaertlungmaskin_nn_1 = mkN "hjдrtlungmaskin" "hjдrtlungmaskiner" ;
  hjaertmussla_nn_1 = mkN "hjдrtmussla" ;
  hjaertnupen_av_1 = mkA "hjдrtnupen" "hjдrtnupet" ;
  hjaertoperation_nn_1 = mkN "hjдrtoperation" "hjдrtoperationer" ;
  hjaertpunkt_nn_1 = mkN "hjдrtpunkt" "hjдrtpunkter" ;
  hjaertsaeck_nn_1 = mkN "hjдrtsдck" ;
  hjaertskaerande_av_1 = mkA "hjдrtskдrande" ;
  hjaertslag_nn_1 = mkN "hjдrtslag" neutrum ;
  hjaertslitande_av_1 = mkA "hjдrtslitande" ;
  hjaertstillande_av_1 = mkA "hjдrtstillande" ;
  hjaerttransplantation_nn_1 = mkN "hjдrttransplantation" "hjдrttransplantationer" ;
  hjaertverksamhet_nn_1 = mkN "hjдrtverksamhet" "hjдrtverksamheter" ;
  hjaessbjudning_nn_1 = mkN "hjдssbjudning" ;
  hjon_nn_1 = mkN "hjon" neutrum ;
  hjonelag_nn_1 = mkN "hjonelag" neutrum ;
  hjord_nn_1 = mkN "hjord" ;
  hjort_nn_1 = mkN "hjort" ;
  hjortdjur_nn_1 = mkN "hjortdjur" neutrum ;
  hjortron_nn_1 = mkN "hjortron" neutrum ;
  hjortsadel_nn_1 = mkN "hjortsadel" ;
  hjul_nn_1 = mkN "hjul" neutrum ;
  hjulaangare_nn_1 = mkN "hjulеngare" "hjulеngare" ;
  hjulbas_nn_1 = mkN "hjulbas" "hjulbaser" ;
  hjulbent_av_1 = mkA "hjulbent" "hjulbent" ;
  hjuldjur_nn_1 = mkN "hjuldjur" neutrum ;
  hjulfjaedring_nn_1 = mkN "hjulfjдdring" ;
  hjulfoenster_nn_1 = mkN "hjulfцnster" neutrum ;
  hjulkors_nn_1 = mkN "hjulkors" neutrum ;
  hjullager_nn_1 = mkN "hjullager" neutrum ;
  hjulnav_nn_1 = mkN "hjulnav" neutrum ;
  hjulspaar_nn_1 = mkN "hjulspеr" neutrum ;
  hjulupphaengning_nn_1 = mkN "hjulupphдngning" ;
  ho_nn_1 = mkN "ho" ;
  hobby_nn_1 = mkN "hobby" "hobbyn" "hobbies" "hobbyerna" ;
  hoeft_nn_1 = mkN "hцft" "hцfter" ;
  hoeftben_nn_1 = mkN "hцftben" neutrum ;
  hoefthaallare_nn_1 = mkN "hцfthеllare" "hцfthеllare" ;
  hoeftled_nn_1 = mkN "hцftled" "hцftleder" ;
  hoeftparti_nn_1 = mkN "hцftparti" "hцftpartit" "hцftpartier" "hцftpartierna" ;
  hoeg_av_1 = mkA "hцg" "hцgre" "hцgst" ;
  hoeg_nn_1 = mkN "hцg" ;
  hoegaffel_nn_1 = mkN "hцgaffel" ;
  hoegaktiv_av_1 = mkA "hцgaktiv" ;
  hoegaktningsfull_av_1 = mkA "hцgaktningsfull" ;
  hoegaktuell_av_1 = mkA "hцgaktuell" ;
  hoegaltare_nn_1 = mkN "hцgaltare" "hцgaltaret" "hцgaltaren" "hцgaltarna" ;
  hoegbaenk_nn_1 = mkN "hцgbдnk" ;
  hoegben_nn_1 = mkN "hцgben" neutrum ;
  hoegblad_nn_1 = mkN "hцgblad" neutrum ;
  hoegboren_av_1 = mkA "hцgboren" "hцgboret" ;
  hoegborg_nn_1 = mkN "hцgborg" ;
  hoegborgerlig_av_1 = mkA "hцgborgerlig" ;
  hoegburen_av_1 = mkA "hцgburen" "hцgburet" ;
  hoegdjur_nn_1 = mkN "hцgdjur" neutrum ;
  hoegdragen_av_1 = mkA "hцgdragen" "hцgdraget" ;
  hoegeligen_ab_1 = mkAdv "hцgeligen" ;
  hoegenergikollision_nn_1 = mkN "hцgenergikollision" "hцgenergikollisioner" ;
  hoegerextremistisk_av_1 = mkA "hцgerextremistisk" ;
  hoegerflygel_nn_1 = mkN "hцgerflygel" ;
  hoegerhaent_av_1 = mkA "hцgerhдnt" "hцgerhдnt" ;
  hoegerhand_nn_1 = mkN "hцgerhand" "hцgerhдnder" ;
  hoegerkrok_nn_1 = mkN "hцgerkrok" ;
  hoegerledare_nn_1 = mkN "hцgerledare" "hцgerledare" ;
  hoegerman_nn_1 = mkN "hцgerman" "hцgermannen" "hцgermдn" "hцgermдnnen" ;
  hoegerparti_nn_1 = mkN "hцgerparti" "hцgerpartit" "hцgerpartier" "hцgerpartierna" ;
  hoegervind_nn_1 = mkN "hцgervind" ;
  hoegervridning_nn_1 = mkN "hцgervridning" ;
  hoegexplosiv_av_1 = mkA "hцgexplosiv" ;
  hoegfaerdig_av_1 = mkA "hцgfдrdig" ;
  hoegfjaell_nn_1 = mkN "hцgfjдll" neutrum ;
  hoegfjaellsomraade_nn_1 = mkN "hцgfjдllsomrеde" ;
  hoegfoernaem_av_1 = mkA "hцgfцrnдm" ;
  hoegfoerraedare_nn_1 = mkN "hцgfцrrдdare" "hцgfцrrдdare" ;
  hoegfoerraederi_nn_1 = mkN "hцgfцrrдderi" "hцgfцrrдderit" "hцgfцrrдderier" "hцgfцrrдderierna" ;
  hoegfrekvens_nn_1 = mkN "hцgfrekvens" "hцgfrekvenser" ;
  hoegfrekvent_av_1 = mkA "hцgfrekvent" "hцgfrekvent" ;
  hoeggradig_av_1 = mkA "hцggradig" ;
  hoeghastighetskamera_nn_1 = mkN "hцghastighetskamera" ;
  hoeghet_nn_1 = mkN "hцghet" "hцgheter" ;
  hoeghus_nn_1 = mkN "hцghus" neutrum ;
  hoeginkomsttagare_nn_1 = mkN "hцginkomsttagare" "hцginkomsttagare" ;
  hoegklassig_av_1 = mkA "hцgklassig" ;
  hoegkonjunktur_nn_1 = mkN "hцgkonjunktur" "hцgkonjunkturer" ;
  hoegkultur_nn_1 = mkN "hцgkultur" "hцgkulturer" ;
  hoegkvarter_nn_1 = mkN "hцgkvarter" "hцgkvarteret" "hцgkvarter" "hцgkvarteren" ;
  hoegkyrklig_av_1 = mkA "hцgkyrklig" ;
  hoeglaendare_nn_1 = mkN "hцglдndare" "hцglдndare" ;
  hoegland_nn_1 = mkN "hцgland" "hцglandet" "hцglдnder" "hцglдnderna" ;
  hoegljudd_av_1 = mkA "hцgljudd" ;
  hoegmaalsbrott_nn_1 = mkN "hцgmеlsbrott" neutrum ;
  hoegmodig_av_1 = mkA "hцgmodig" ;
  hoegmolekylaer_av_1 = mkA "hцgmolekylдr" ;
  hoegoensklig_av_1 = mkA "hцgцnsklig" ;
  hoegoktanig_av_1 = mkA "hцgoktanig" ;
  hoegplataa_nn_1 = mkN "hцgplatе" "hцgplatеer" ;
  hoegrest_av_1 = mkA "hцgrest" "hцgrest" ;
  hoegrestaandskultur_nn_1 = mkN "hцgrestеndskultur" "hцgrestеndskulturer" ;
  hoegrev_nn_1 = mkN "hцgrev" neutrum ;
  hoegroed_av_1 = mkA "hцgrцd" ;
  hoegsaesong_nn_1 = mkN "hцgsдsong" "hцgsдsonger" ;
  hoegsaete_nn_1 = mkN "hцgsдte" ;
  hoegsint_av_1 = mkA "hцgsint" "hцgsint" ;
  hoegskoleadjunkt_nn_1 = mkN "hцgskoleadjunkt" "hцgskoleadjunkter" ;
  hoegskolelektor_nn_1 = mkN "hцgskolelektor" "hцgskolelektorer" ;
  hoegslaett_nn_1 = mkN "hцgslдtt" "hцgslдtter" ;
  hoegsommar_nn_1 = mkN "hцgsommar" "hцgsommarn" "hцgsommrar" "hцgsommrarna" ;
  hoegspaend_av_1 = mkA "hцgspдnd" ;
  hoegspaenning_nn_1 = mkN "hцgspдnning" ;
  hoegst_ab_1 = mkAdv "hцgst" ;
  hoegstadium_nn_1 = mkN "hцgstadium" "hцgstadiet" "hцgstadier" "hцgstadierna" ;
  hoegstaemd_av_1 = mkA "hцgstдmd" "hцgstдmt" ;
  hoegstbjudande_av_1 = mkA "hцgstbjudande" ;
  hoegtalare_nn_1 = mkN "hцgtalare" "hцgtalare" ;
  hoegteknologisk_av_1 = mkA "hцgteknologisk" ;
  hoegtflygande_av_1 = mkA "hцgtflygande" ;
  hoegtid_nn_1 = mkN "hцgtid" "hцgtider" ;
  hoegtidlig_av_1 = mkA "hцgtidlig" ;
  hoegtidlighaalla_vb_1 = mkV "hцgtidlighеlla" "hцgtidlighцll" "hцgtidlighеllit" ;
  hoegtidlighet_nn_1 = mkN "hцgtidlighet" "hцgtidligheter" ;
  hoegtidsaar_nn_1 = mkN "hцgtidsеr" neutrum ;
  hoegtidsdag_nn_1 = mkN "hцgtidsdag" ;
  hoegtidsdraekt_nn_1 = mkN "hцgtidsdrдkt" "hцgtidsdrдkter" ;
  hoegtidsstund_nn_1 = mkN "hцgtidsstund" "hцgtidsstunder" ;
  hoegtidstal_nn_1 = mkN "hцgtidstal" "hцgtidstalet" "hцgtidstalen" "hцgtidstalena" ;
  hoegtravande_av_1 = mkA "hцgtravande" ;
  hoegtryck_nn_1 = mkN "hцgtryck" neutrum ;
  hoegtrycksrygg_nn_1 = mkN "hцgtrycksrygg" ;
  hoegtstaaende_av_1 = mkA "hцgtstеende" ;
  hoegtysk_av_1 = mkA "hцgtysk" ;
  hoegvaelboren_av_1 = mkA "hцgvдlboren" "hцgvдlboret" ;
  hoegvaerdig_av_1 = mkA "hцgvдrdig" ;
  hoegvaext_av_1 = mkA "hцgvдxt" "hцgvдxt" ;
  hoegvakt_nn_1 = mkN "hцgvakt" "hцgvakter" ;
  hoegvall_nn_1 = mkN "hцgvall" ;
  hoegvallskloever_nn_1 = mkN "hцgvallsklцver" "hцgvallsklцvern" "hцgvallsklцver" "hцgvallsklцverna" ;
  hoegvatten_nn_1 = mkN "hцgvatten" "hцgvattnet" "hцgvatten" "hцgvattnen" ;
  hoegvoerdig_av_1 = mkA "hцgvцrdig" ;
  hoegvoerdighet_nn_1 = mkN "hцgvцrdighet" "hцgvцrdigheter" ;
  hoegvuxen_av_1 = mkA "hцgvuxen" "hцgvuxet" ;
  hoejd_nn_1 = mkN "hцjd" "hцjder" ;
  hoejdare_nn_1 = mkN "hцjdare" "hцjdare" ;
  hoejdbestaemning_nn_1 = mkN "hцjdbestдmning" ;
  hoejdhopp_nn_1 = mkN "hцjdhopp" neutrum ;
  hoejdhoppare_nn_1 = mkN "hцjdhoppare" "hцjdhoppare" ;
  hoejdhoppstaevling_nn_1 = mkN "hцjdhoppstдvling" ;
  hoejdlaege_nn_1 = mkN "hцjdlдge" ;
  hoejdmaetare_nn_1 = mkN "hцjdmдtare" "hцjdmдtare" ;
  hoejdmaetning_nn_1 = mkN "hцjdmдtning" ;
  hoejdpunkt_nn_1 = mkN "hцjdpunkt" "hцjdpunkter" ;
  hoejdrygg_nn_1 = mkN "hцjdrygg" ;
  hoejdskillnad_nn_1 = mkN "hцjdskillnad" "hцjdskillnader" ;
  hoejdstraeckning_nn_1 = mkN "hцjdstrдckning" ;
  hoejning_nn_1 = mkN "hцjning" ;
  hoek_nn_1 = mkN "hцk" ;
  hoekare_nn_1 = mkN "hцkare" "hцkare" ;
  hoekeri_nn_1 = mkN "hцkeri" "hцkerit" "hцkerier" "hцkerierna" ;
  hoeknatt_nn_1 = mkN "hцknatt" "hцknдtter" ;
  hoelja_nn_1 = mkN "hцlja" ;
  hoelster_nn_1 = mkN "hцlster" neutrum ;
  hoens_nn_1 = mkN "hцns" neutrum ;
  hoensaegg_nn_1 = mkN "hцnsдgg" neutrum ;
  hoensbaer_nn_1 = mkN "hцnsbдr" neutrum ;
  hoenseri_nn_1 = mkN "hцnseri" "hцnserit" "hцnserier" "hцnserierna" ;
  hoensfaagel_nn_1 = mkN "hцnsfеgel" ;
  hoensgaard_nn_1 = mkN "hцnsgеrd" ;
  hoensig_av_1 = mkA "hцnsig" ;
  hoensnaet_nn_1 = mkN "hцnsnдt" neutrum ;
  hoerapparat_nn_1 = mkN "hцrapparat" "hцrapparater" ;
  hoerbar_av_1 = mkA "hцrbar" ;
  hoerbarhet_nn_1 = mkN "hцrbarhet" "hцrbarheter" ;
  hoerbarligen_ab_1 = mkAdv "hцrbarligen" ;
  hoerlur_nn_1 = mkN "hцrlur" ;
  hoern_nn_1 = mkN "hцrn" neutrum ;
  hoernhus_nn_1 = mkN "hцrnhus" neutrum ;
  hoernpelare_nn_1 = mkN "hцrnpelare" "hцrnpelare" ;
  hoernsten_nn_1 = mkN "hцrnsten" "hцrnstenen" "hцrnstenar" "hцrnstenarna" ;
  hoerntand_nn_1 = mkN "hцrntand" "hцrntдnder" ;
  hoersaegen_nn_1 = mkN "hцrsдgen" "hцrsдgenn" "hцrsдgner" "hцrsдgnerna" ;
  hoersaga_nn_1 = mkN "hцrsaga" ;
  hoersal_nn_1 = mkN "hцrsal" ;
  hoersam_av_1 = mkA "hцrsam" "hцrsamt" "hцrsamma" "hцrsamma" "hцrsammare" "hцrsammast" "hцrsammaste" ;
  hoerselben_nn_1 = mkN "hцrselben" neutrum ;
  hoerselklass_nn_1 = mkN "hцrselklass" "hцrselklasser" ;
  hoerselorgan_nn_1 = mkN "hцrselorgan" neutrum ;
  hoerspel_nn_1 = mkN "hцrspel" "hцrspelet" "hцrspel" "hцrspelen" ;
  hoertelefon_nn_1 = mkN "hцrtelefon" "hцrtelefoner" ;
  hoesaate_nn_1 = mkN "hцsеte" utrum ;
  hoesaeck_nn_1 = mkN "hцsдck" ;
  hoeskulle_nn_1 = mkN "hцskulle" utrum ;
  hoest_nn_1 = mkN "hцst" ;
  hoestack_nn_1 = mkN "hцstack" ;
  hoestdagjaemning_nn_1 = mkN "hцstdagjдmning" ;
  hoestlig_av_1 = mkA "hцstlig" ;
  hoestsaesong_nn_1 = mkN "hцstsдsong" "hцstsдsonger" ;
  hoestslakt_nn_1 = mkN "hцstslakt" "hцstslakter" ;
  hoesttermin_nn_1 = mkN "hцsttermin" "hцstterminer" ;
  hoestvaeder_nn_1 = mkN "hцstvдder" neutrum ;
  hoetapp_nn_1 = mkN "hцtapp" ;
  hoetork_nn_1 = mkN "hцtork" ;
  hoevaalm_nn_1 = mkN "hцvеlm" ;
  hoevaendare_nn_1 = mkN "hцvдndare" "hцvдndare" ;
  hoevding_nn_1 = mkN "hцvding" ;
  hoevisk_av_1 = mkA "hцvisk" ;
  hoevitsman_nn_1 = mkN "hцvitsman" "hцvitsmannen" "hцvitsmдn" "hцvitsmдnnen" ;
  hoevlig_av_1 = mkA "hцvlig" ;
  hoevlighet_nn_1 = mkN "hцvlighet" "hцvligheter" ;
  hoevlighetsvisit_nn_1 = mkN "hцvlighetsvisit" "hцvlighetsvisiter" ;
  hoj_nn_1 = mkN "hoj" ;
  holdingbolag_nn_1 = mkN "holdingbolag" neutrum ;
  holistisk_av_1 = mkA "holistisk" ;
  holk_nn_1 = mkN "holk" ;
  hollaendare_nn_1 = mkN "hollдndare" "hollдndare" ;
  hollaendsk_av_1 = mkA "hollдndsk" ;
  hollaendska_nn_2 = mkN "hollдndska" ;
  holme_nn_1 = mkN "holme" utrum ;
  holmgaang_nn_1 = mkN "holmgеng" ;
  hologram_nn_1 = mkN "hologram" "hologrammet" "hologram" "hologrammen" ;
  holt_nn_1 = mkN "holt" neutrum ;
  homeopat_nn_1 = mkN "homeopat" "homeopater" ;
  homeopatisk_av_1 = mkA "homeopatisk" ;
  homerisk_av_1 = mkA "homerisk" ;
  homilet_nn_1 = mkN "homilet" "homileter" ;
  homiletisk_av_1 = mkA "homiletisk" ;
  homofil_nn_1 = mkN "homofil" "homofiler" ;
  homofon_av_1 = mkA "homofon" ;
  homofon_nn_1 = mkN "homofon" "homofoner" ;
  homogen_av_1 = mkA "homogen" ;
  homogenitet_nn_1 = mkN "homogenitet" "homogeniteter" ;
  homograf_av_1 = mkA "homograf" ;
  homograf_nn_1 = mkN "homograf" "homografer" ;
  homolog_av_1 = mkA "homolog" ;
  homonym_av_1 = mkA "homonym" ;
  homonym_nn_1 = mkN "homonym" "homonymer" ;
  homonymi_nn_1 = mkN "homonymi" "homonymier" ;
  homosexualitet_nn_1 = mkN "homosexualitet" "homosexualiteter" ;
  homosexuell_av_1 = mkA "homosexuell" ;
  homozygot_av_1 = mkA "homozygot" "homozygot" ;
  homozygot_nn_1 = mkN "homozygot" "homozygoter" ;
  honduran_nn_1 = mkN "honduran" "honduraner" ;
  honduransk_av_1 = mkA "honduransk" ;
  honlig_av_1 = mkA "honlig" ;
  honnett_av_1 = mkA "honnett" ;
  honnoer_nn_1 = mkN "honnцr" "honnцrer" ;
  honnoersbetyg_nn_1 = mkN "honnцrsbetyg" neutrum ;
  honnoersbord_nn_1 = mkN "honnцrsbord" neutrum ;
  honnoersord_nn_1 = mkN "honnцrsord" neutrum ;
  honnoerspost_nn_1 = mkN "honnцrspost" "honnцrsposter" ;
  honoraer_av_1 = mkA "honorдr" ;
  honorar_nn_1 = mkN "honorar" neutrum ;
  honungslen_av_1 = mkA "honungslen" ;
  honungsmelon_nn_1 = mkN "honungsmelon" "honungsmeloner" ;
  honungsskivling_nn_1 = mkN "honungsskivling" ;
  hop_nn_1 = mkN "hop" ;
  hopbiten_av_1 = mkA "hopbiten" "hopbitet" ;
  hopblandning_nn_1 = mkN "hopblandning" ;
  hopbyggd_av_1 = mkA "hopbyggd" "hopbyggt" ;
  hopdragning_nn_1 = mkN "hopdragning" ;
  hopfaellbar_av_1 = mkA "hopfдllbar" ;
  hopfaelld_av_1 = mkA "hopfдlld" "hopfдllt" ;
  hopklumpning_nn_1 = mkN "hopklumpning" ;
  hopknaeppt_av_1 = mkA "hopknдppt" "hopknдppt" ;
  hopknyta_vb_1 = mkV "hopknyta" "hopknцt" "hopknutit" ;
  hopkok_nn_1 = mkN "hopkok" neutrum ;
  hopkommen_av_1 = mkA "hopkommen" "hopkommet" "hopkomna" "hopkomna" "hopkomnare" "hopkomnast" "hopkomnaste" ;
  hopkoppling_nn_1 = mkN "hopkoppling" ;
  hopkrupen_av_1 = mkA "hopkrupen" "hopkrupet" ;
  hoplit_nn_1 = mkN "hoplit" "hopliter" ;
  hopp_i_landkalle_nn_1 = mkN "hopp-i-landkalle" utrum ;
  hopp_nn_1 = mkN "hopp" neutrum ;
  hoppare_nn_1 = mkN "hoppare" "hoppare" ;
  hoppbacke_nn_1 = mkN "hoppbacke" utrum ;
  hoppeligen_ab_1 = mkAdv "hoppeligen" ;
  hoppfoersoek_nn_1 = mkN "hoppfцrsцk" neutrum ;
  hoppfull_av_1 = mkA "hoppfull" ;
  hoppig_av_1 = mkA "hoppig" ;
  hoppingivande_av_1 = mkA "hoppingivande" ;
  hoppledare_nn_1 = mkN "hoppledare" "hoppledare" ;
  hopploes_av_1 = mkA "hopplцs" ;
  hopploeshet_nn_1 = mkN "hopplцshet" "hopplцsheter" ;
  hopprep_nn_1 = mkN "hopprep" neutrum ;
  hoppstaellning_nn_1 = mkN "hoppstдllning" ;
  hoppstjaert_nn_1 = mkN "hoppstjдrt" ;
  hopptorn_nn_1 = mkN "hopptorn" neutrum ;
  hopptraening_nn_1 = mkN "hopptrдning" ;
  hopsjunken_av_1 = mkA "hopsjunken" "hopsjunket" ;
  hopslagen_av_1 = mkA "hopslagen" "hopslaget" ;
  hopsnodd_av_1 = mkA "hopsnodd" ;
  hopsnoerd_av_1 = mkA "hopsnцrd" "hopsnцrt" ;
  hopsnoerpt_av_1 = mkA "hopsnцrpt" "hopsnцrpt" ;
  hopvaext_av_1 = mkA "hopvдxt" "hopvдxt" ;
  hopvika_vb_1 = mkV "hopvika" "hopvek" "hopvikit" ;
  hopvuxen_av_1 = mkA "hopvuxen" "hopvuxet" ;
  horbock_nn_1 = mkN "horbock" ;
  hord_nn_1 = mkN "hord" "horder" ;
  horhus_nn_1 = mkN "horhus" neutrum ;
  horisont_nn_1 = mkN "horisont" "horisonter" ;
  horisontal_av_1 = mkA "horisontal" ;
  horisontalplan_nn_1 = mkN "horisontalplan" neutrum ;
  horisontell_av_1 = mkA "horisontell" ;
  horisontproblem_nn_1 = mkN "horisontproblem" neutrum ;
  hormon_nn_1 = mkN "hormon" neutrum ;
  hormonbalans_nn_1 = mkN "hormonbalans" "hormonbalanser" ;
  hormonell_av_1 = mkA "hormonell" ;
  hormonfunktion_nn_1 = mkN "hormonfunktion" "hormonfunktioner" ;
  hormonproduktion_nn_1 = mkN "hormonproduktion" "hormonproduktioner" ;
  hormonsystem_nn_1 = mkN "hormonsystem" neutrum ;
  horn_nn_1 = mkN "horn" neutrum ;
  hornbaage_nn_1 = mkN "hornbеge" utrum ;
  hornhinna_nn_1 = mkN "hornhinna" ;
  hornist_nn_1 = mkN "hornist" "hornister" ;
  hornliknande_av_1 = mkA "hornliknande" ;
  hornloes_av_1 = mkA "hornlцs" ;
  horologium_nn_1 = mkN "horologium" "horologiet" "horologier" "horologierna" ;
  horoskop_nn_1 = mkN "horoskop" neutrum ;
  horribel_av_1 = mkA "horribel" "horribelt" "horribla" "horribla" "horriblare" "horriblast" "horriblaste" ;
  horroer_nn_1 = mkN "horrцr" "horrцrer" ;
  horsgoek_nn_1 = mkN "horsgцk" ;
  horst_nn_1 = mkN "horst" ;
  hortonom_nn_1 = mkN "hortonom" "hortonomer" ;
  hospital_nn_1 = mkN "hospital" neutrum ;
  hospits_nn_1 = mkN "hospits" neutrum ;
  hostanfall_nn_1 = mkN "hostanfall" neutrum ;
  hostattack_nn_1 = mkN "hostattack" "hostattacker" ;
  hostig_av_1 = mkA "hostig" ;
  hostning_nn_1 = mkN "hostning" ;
  hot_nn_1 = mkN "hot" neutrum ;
  hotbild_nn_1 = mkN "hotbild" "hotbilder" ;
  hotell_nn_1 = mkN "hotell" neutrum ;
  hotellbrand_nn_1 = mkN "hotellbrand" "hotellbrдnder" ;
  hotellgaest_nn_1 = mkN "hotellgдst" "hotellgдster" ;
  hotellpojke_nn_1 = mkN "hotellpojke" utrum ;
  hotellrum_nn_1 = mkN "hotellrum" "hotellrummet" "hotellrum" "hotellrummen" ;
  hotelse_nn_1 = mkN "hotelse" "hotelser" ;
  hotfull_av_1 = mkA "hotfull" ;
  hottentotsk_av_1 = mkA "hottentotsk" ;
  hottentotska_nn_2 = mkN "hottentotska" ;
  hottentott_nn_1 = mkN "hottentott" "hottentotter" ;
  hov_nn_1 = mkN "hov" ;
  hov_nn_2 = mkN "hov" neutrum ;
  hovbeslag_nn_1 = mkN "hovbeslag" neutrum ;
  hovbetjaent_nn_1 = mkN "hovbetjдnt" "hovbetjдnter" ;
  hovdam_nn_1 = mkN "hovdam" "hovdamer" ;
  hovdjur_nn_1 = mkN "hovdjur" neutrum ;
  hovkapell_nn_1 = mkN "hovkapell" neutrum ;
  hovleverantoer_nn_1 = mkN "hovleverantцr" "hovleverantцrer" ;
  hovmaestare_nn_1 = mkN "hovmдstare" "hovmдstare" ;
  hovman_nn_1 = mkN "hovman" "hovmannen" "hovmдn" "hovmдnnen" ;
  hovmarskalk_nn_1 = mkN "hovmarskalk" ;
  hovnarr_nn_1 = mkN "hovnarr" ;
  hovnigning_nn_1 = mkN "hovnigning" ;
  hovraett_nn_1 = mkN "hovrдtt" "hovrдtter" ;
  hovraettspresident_nn_1 = mkN "hovrдttspresident" "hovrдttspresidenter" ;
  hovraettsraad_nn_1 = mkN "hovrдttsrеd" neutrum ;
  hovsam_av_1 = mkA "hovsam" "hovsamt" "hovsamma" "hovsamma" "hovsammare" "hovsammast" "hovsammaste" ;
  hovslag_nn_1 = mkN "hovslag" neutrum ;
  hovslagare_nn_1 = mkN "hovslagare" "hovslagare" ;
  hovstat_nn_1 = mkN "hovstat" "hovstater" ;
  hovtaang_nn_1 = mkN "hovtеng" "hovtдnger" ;
  hud_nn_1 = mkN "hud" ;
  hudfaerg_nn_1 = mkN "hudfдrg" "hudfдrger" ;
  hudflaeck_nn_1 = mkN "hudflдck" ;
  hudinflammation_nn_1 = mkN "hudinflammation" "hudinflammationer" ;
  hudkraem_nn_1 = mkN "hudkrдm" "hudkrдmer" ;
  hudlager_nn_1 = mkN "hudlager" neutrum ;
  hudloes_av_1 = mkA "hudlцs" ;
  hudmedel_nn_1 = mkN "hudmedel" neutrum ;
  hudnaera_av_1 = mkA "hudnдra" ;
  hudoemsning_nn_1 = mkN "hudцmsning" ;
  hudolja_nn_1 = mkN "hudolja" ;
  hudsjukdom_nn_1 = mkN "hudsjukdom" ;
  hudtransplantation_nn_1 = mkN "hudtransplantation" "hudtransplantationer" ;
  hudutslag_nn_1 = mkN "hudutslag" neutrum ;
  hudvaenlig_av_1 = mkA "hudvдnlig" ;
  hudveck_nn_1 = mkN "hudveck" neutrum ;
  hugenott_nn_1 = mkN "hugenott" "hugenotter" ;
  hugg_nn_1 = mkN "hugg" neutrum ;
  hugga_vb_1 = mkV "hugga" "hцgg" "huggit" ;
  huggare_nn_1 = mkN "huggare" "huggare" ;
  huggkrok_nn_1 = mkN "huggkrok" ;
  huggkubb_nn_1 = mkN "huggkubb" ;
  huggmejsel_nn_1 = mkN "huggmejsel" ;
  huggorm_nn_1 = mkN "huggorm" ;
  huggtand_nn_1 = mkN "huggtand" "huggtдnder" ;
  hugnad_nn_1 = mkN "hugnad" "hugnader" ;
  hugnesam_av_1 = mkA "hugnesam" "hugnesamt" "hugnesamma" "hugnesamma" "hugnesammare" "hugnesammast" "hugnesammaste" ;
  hugskott_nn_1 = mkN "hugskott" neutrum ;
  huld_av_1 = mkA "huld" "hult" ;
  huldra_nn_1 = mkN "huldra" ;
  huligan_nn_1 = mkN "huligan" "huliganer" ;
  hulk_nn_1 = mkN "hulk" ;
  hulling_nn_1 = mkN "hulling" ;
  hult_nn_1 = mkN "hult" ;
  human_av_1 = mkA "human" ;
  humanekologisk_av_1 = mkA "humanekologisk" ;
  humaniora_nn_1 = mkN "humaniora" "humanioran" "humaniora" "humaniorana" ;
  humanist_nn_1 = mkN "humanist" "humanister" ;
  humanistisk_av_1 = mkA "humanistisk" ;
  humanitaer_av_1 = mkA "humanitдr" ;
  humanitet_nn_1 = mkN "humanitet" "humaniteter" ;
  humanvetenskap_nn_1 = mkN "humanvetenskap" "humanvetenskaper" ;
  humbug_nn_1 = mkN "humbug" ;
  humla_nn_1 = mkN "humla" ;
  humleblomster_nn_1 = mkN "humleblomster" neutrum ;
  hummer_nn_1 = mkN "hummer" "hummern" "hummrar" "hummrarna" ;
  humoer_nn_1 = mkN "humцr" neutrum ;
  humoermaenniska_nn_1 = mkN "humцrmдnniska" ;
  humoerspelare_nn_1 = mkN "humцrspelare" "humцrspelare" ;
  humoresk_nn_1 = mkN "humoresk" "humoresker" ;
  humorist_nn_1 = mkN "humorist" "humorister" ;
  humoristisk_av_1 = mkA "humoristisk" ;
  humusaemne_nn_1 = mkN "humusдmne" ;
  humusbunden_av_1 = mkA "humusbunden" "humusbundet" ;
  humusfoerening_nn_1 = mkN "humusfцrening" ;
  humushalt_nn_1 = mkN "humushalt" "humushalter" ;
  humushaltig_av_1 = mkA "humushaltig" ;
  humuskomponent_nn_1 = mkN "humuskomponent" "humuskomponenter" ;
  humuskoncentration_nn_1 = mkN "humuskoncentration" "humuskoncentrationer" ;
  humussubstans_nn_1 = mkN "humussubstans" "humussubstanser" ;
  humusvatten_nn_1 = mkN "humusvatten" "humusvattnet" "humusvatten" "humusvattnen" ;
  hund_nn_1 = mkN "hund" ;
  hundaar_nn_1 = mkN "hundеr" neutrum ;
  hundaexing_nn_1 = mkN "hundдxing" ;
  hundben_nn_1 = mkN "hundben" neutrum ;
  hundblick_nn_1 = mkN "hundblick" ;
  hunddjur_nn_1 = mkN "hunddjur" neutrum ;
  hundhalsband_nn_1 = mkN "hundhalsband" neutrum ;
  hundhuvud_nn_1 = mkN "hundhuvud" "hundhuvudet" "hundhuvuden" "hundhuvudena" ;
  hundhuvudet_ab_1 = mkAdv "hundhuvudet" ;
  hundkaex_nn_2 = mkN "hundkдx" neutrum ;
  hundkapploepning_nn_1 = mkN "hundkapplцpning" ;
  hundkex_nn_1 = mkN "hundkex" neutrum ;
  hundlort_nn_1 = mkN "hundlort" ;
  hundoera_nn_1 = mkN "hundцra" "hundцrat" "hundцron" "hundцronen" ;
  hundradel_nn_1 = mkN "hundradel" "hundradelen" "hundradelar" "hundradelarna" ;
  hundrafalt_ab_1 = mkAdv "hundrafalt" ;
  hundrakronorssedel_nn_1 = mkN "hundrakronorssedel" ;
  hundralapp_nn_1 = mkN "hundralapp" ;
  hundraprocentig_av_1 = mkA "hundraprocentig" ;
  hundras_nn_1 = mkN "hundras" "hundraser" ;
  hundratal_nn_1 = mkN "hundratal" "hundratalet" "hundratalen" "hundratalena" ;
  hundratals_ab_1 = mkAdv "hundratals" ;
  hundratusental_nn_1 = mkN "hundratusental" "hundratusentalet" "hundratusentalen" "hundratusentalena" ;
  hundratusentonnare_nn_1 = mkN "hundratusentonnare" "hundratusentonnare" ;
  hundring_nn_1 = mkN "hundring" ;
  hundskatt_nn_1 = mkN "hundskatt" "hundskatter" ;
  hundslaede_nn_1 = mkN "hundslдde" utrum ;
  hundvakt_nn_1 = mkN "hundvakt" "hundvakter" ;
  hundvalp_nn_1 = mkN "hundvalp" ;
  hungerstrejk_nn_1 = mkN "hungerstrejk" "hungerstrejker" ;
  hungrig_av_1 = mkA "hungrig" ;
  hunner_nn_1 = mkN "hunner" "hunnern" "hunner" "hunnerna" ;
  hur_ab_1 = mkAdv "hur" ;
  hurra_nn_1 = mkN "hurra" "hurrat" "hurra" "hurrana" ;
  hurrarop_nn_1 = mkN "hurrarop" neutrum ;
  hurril_nn_1 = mkN "hurril" ;
  hursomhelst_ab_1 = mkAdv "hursomhelst" ;
  hurtbulle_nn_1 = mkN "hurtbulle" utrum ;
  hurtfrisk_av_1 = mkA "hurtfrisk" ;
  hurtig_av_1 = mkA "hurtig" ;
  hurts_nn_1 = mkN "hurts" ;
  huru_ab_1 = mkAdv "huru" ;
  huruledes_ab_1 = mkAdv "huruledes" ;
  hus_nn_1 = mkN "hus" neutrum ;
  husaegare_nn_1 = mkN "husдgare" "husдgare" ;
  husandakt_nn_1 = mkN "husandakt" "husandakter" ;
  husapotek_nn_1 = mkN "husapotek" neutrum ;
  husar_nn_1 = mkN "husar" "husarer" ;
  husbaat_nn_1 = mkN "husbеt" ;
  husbehov_nn_1 = mkN "husbehov" neutrum ;
  husbil_nn_1 = mkN "husbil" ;
  husbock_nn_1 = mkN "husbock" ;
  husbonde_nn_1 = mkN "husbonde" "husbцnder" ;
  husbygge_nn_1 = mkN "husbygge" ;
  husdjur_nn_1 = mkN "husdjur" neutrum ;
  husesyn_nn_1 = mkN "husesyn" "husesyner" ;
  husfader_nn_1 = mkN "husfader" "husfadern" "husfдder" "husfдderna" ;
  husfoerestaandarinna_nn_1 = mkN "husfцrestеndarinna" ;
  husfoerhoer_nn_1 = mkN "husfцrhцr" neutrum ;
  husfru_nn_1 = mkN "husfru" ;
  husgavel_nn_1 = mkN "husgavel" ;
  husgeraad_nn_1 = mkN "husgerеd" neutrum ;
  husgrund_nn_1 = mkN "husgrund" "husgrunder" ;
  husgud_nn_1 = mkN "husgud" ;
  hushaall_nn_1 = mkN "hushеll" neutrum ;
  hushaallerska_nn_1 = mkN "hushеllerska" ;
  hushaallningssaellskap_nn_1 = mkN "hushеllningssдllskap" "hushеllningssдllskapet" "hushеllningssдllskapen" "hushеllningssдllskapena" ;
  hushaallsassistent_nn_1 = mkN "hushеllsassistent" "hushеllsassistenter" ;
  hushaallsost_nn_1 = mkN "hushеllsost" ;
  hushaallsrulle_nn_1 = mkN "hushеllsrulle" utrum ;
  hushaallsvaag_nn_1 = mkN "hushеllsvеg" ;
  husknut_nn_1 = mkN "husknut" ;
  huskors_nn_1 = mkN "huskors" neutrum ;
  huskropp_nn_1 = mkN "huskropp" ;
  huskur_nn_1 = mkN "huskur" "huskurer" ;
  huslaekare_nn_1 = mkN "huslдkare" "huslдkare" ;
  huslig_av_1 = mkA "huslig" ;
  husmor_nn_1 = mkN "husmoder" "husmodern" "husmцdrar" "husmцdrarna" ;
  husorgan_nn_1 = mkN "husorgan" neutrum ;
  husrannsakning_nn_1 = mkN "husrannsakning" ;
  husse_nn_1 = mkN "husse" utrum ;
  hustimmer_nn_1 = mkN "hustimmer" neutrum ;
  hustomte_nn_1 = mkN "hustomte" utrum ;
  hustru_nn_1 = mkN "hustru" "hustrun" "hustrur" "hustrurna" ;
  hustrutillaegg_nn_1 = mkN "hustrutillдgg" neutrum ;
  hustyrann_nn_1 = mkN "hustyrann" "hustyranner" ;
  husundersoekning_nn_1 = mkN "husundersцkning" ;
  husvagn_nn_1 = mkN "husvagn" ;
  husvill_av_1 = mkA "husvill" ;
  hutch_nn_1 = mkN "hutch" ;
  hutloes_av_1 = mkA "hutlцs" ;
  hutt_nn_1 = mkN "hutt" ;
  huv_nn_1 = mkN "huv" ;
  huvud_nn_1 = mkN "huvud" "huvudet" "huvuden" "huvudena" ;
  huvudaemne_nn_1 = mkN "huvudдmne" ;
  huvudanstalt_nn_1 = mkN "huvudanstalt" "huvudanstalter" ;
  huvudavtal_nn_1 = mkN "huvudavtal" "huvudavtalet" "huvudavtalen" "huvudavtalena" ;
  huvudaxel_nn_1 = mkN "huvudaxel" ;
  huvudbjudning_nn_1 = mkN "huvudbjudning" ;
  huvudbok_nn_1 = mkN "huvudbok" "huvudbцcker" ;
  huvudbonad_nn_1 = mkN "huvudbonad" "huvudbonader" ;
  huvudbyggnad_nn_1 = mkN "huvudbyggnad" "huvudbyggnader" ;
  huvuddel_nn_1 = mkN "huvuddel" "huvuddelen" "huvuddelar" "huvuddelarna" ;
  huvuddrag_nn_1 = mkN "huvuddrag" neutrum ;
  huvudentre_nn_1 = mkN "huvudentrй" "huvudentrйer" ;
  huvudfigur_nn_1 = mkN "huvudfigur" "huvudfigurer" ;
  huvudfoerhandling_nn_1 = mkN "huvudfцrhandling" ;
  huvudform_nn_1 = mkN "huvudform" ;
  huvudfunktion_nn_1 = mkN "huvudfunktion" "huvudfunktioner" ;
  huvudgaerd_nn_1 = mkN "huvudgдrd" "huvudgдrder" ;
  huvudingaang_nn_1 = mkN "huvudingеng" ;
  huvudinkomst_nn_1 = mkN "huvudinkomst" "huvudinkomster" ;
  huvudinnehaall_nn_1 = mkN "huvudinnehеll" neutrum ;
  huvudjaegare_nn_1 = mkN "huvudjдgare" "huvudjдgare" ;
  huvudkontor_nn_1 = mkN "huvudkontor" neutrum ;
  huvudkvarter_nn_1 = mkN "huvudkvarter" "huvudkvarteret" "huvudkvarter" "huvudkvarteren" ;
  huvudlaerare_nn_1 = mkN "huvudlдrare" "huvudlдrare" ;
  huvudlag_nn_1 = mkN "huvudlag" neutrum ;
  huvudled_nn_1 = mkN "huvudled" "huvudleder" ;
  huvudledning_nn_1 = mkN "huvudledning" ;
  huvudlinje_nn_1 = mkN "huvudlinje" "huvudlinjer" ;
  huvudloes_av_1 = mkA "huvudlцs" ;
  huvudman_nn_1 = mkN "huvudman" "huvudmannen" "huvudmдn" "huvudmдnnen" ;
  huvudmoment_nn_1 = mkN "huvudmoment" neutrum ;
  huvudnaering_nn_1 = mkN "huvudnдring" ;
  huvudnyckel_nn_1 = mkN "huvudnyckel" ;
  huvudord_nn_1 = mkN "huvudord" neutrum ;
  huvudorsak_nn_1 = mkN "huvudorsak" "huvudorsaker" ;
  huvudperson_nn_1 = mkN "huvudperson" "huvudpersoner" ;
  huvudpunkt_nn_1 = mkN "huvudpunkt" "huvudpunkter" ;
  huvudraett_nn_1 = mkN "huvudrдtt" "huvudrдtter" ;
  huvudregel_nn_1 = mkN "huvudregel" "huvudregeln" "huvudregler" "huvudreglerna" ;
  huvudroll_nn_1 = mkN "huvudroll" "huvudroller" ;
  huvudrollsinnehavare_nn_1 = mkN "huvudrollsinnehavare" "huvudrollsinnehavare" ;
  huvudsak_nn_1 = mkN "huvudsak" "huvudsaker" ;
  huvudsaklig_av_1 = mkA "huvudsaklig" ;
  huvudsakligen_ab_1 = mkAdv "huvudsakligen" ;
  huvudsats_nn_1 = mkN "huvudsats" "huvudsatser" ;
  huvudskaal_nn_1 = mkN "huvudskеl" ;
  huvudskael_nn_1 = mkN "huvudskдl" neutrum ;
  huvudskakning_nn_1 = mkN "huvudskakning" ;
  huvudstad_nn_1 = mkN "huvudstad" "huvudstдder" ;
  huvudstol_nn_1 = mkN "huvudstol" ;
  huvudstroembrytare_nn_1 = mkN "huvudstrцmbrytare" "huvudstrцmbrytare" ;
  huvudstupa_ab_1 = mkAdv "huvudstupa" ;
  huvudsvaal_nn_1 = mkN "huvudsvеl" ;
  huvudtema_nn_1 = mkN "huvudtema" "huvudtemat" "huvudteman" "huvudtemana" ;
  huvudtitel_nn_1 = mkN "huvudtitel" ;
  huvudton_nn_1 = mkN "huvudton" "huvudtoner" ;
  huvuduppgift_nn_1 = mkN "huvuduppgift" "huvuduppgifter" ;
  huvudverb_nn_1 = mkN "huvudverb" neutrum ;
  huvudvittne_nn_1 = mkN "huvudvittne" ;
  hyacint_nn_1 = mkN "hyacint" "hyacinter" ;
  hybrid_nn_1 = mkN "hybrid" "hybrider" ;
  hycklare_nn_1 = mkN "hycklare" "hycklare" ;
  hyckleri_nn_1 = mkN "hyckleri" "hycklerit" "hycklerier" "hycklerierna" ;
  hydrat_nn_1 = mkN "hydrat" neutrum ;
  hydraulisk_av_1 = mkA "hydraulisk" ;
  hydrodynamisk_av_1 = mkA "hydrodynamisk" ;
  hydrofob_av_1 = mkA "hydrofob" ;
  hydrofon_nn_1 = mkN "hydrofon" "hydrofoner" ;
  hydrofor_nn_1 = mkN "hydrofor" "hydroforen" "hydroforer" "hydroforerna" ;
  hydrofyt_nn_1 = mkN "hydrofyt" "hydrofyter" ;
  hydrokopter_nn_1 = mkN "hydrokopter" ;
  hydrokultur_nn_1 = mkN "hydrokultur" "hydrokulturer" ;
  hydrolog_nn_1 = mkN "hydrolog" "hydrologer" ;
  hydrologisk_av_1 = mkA "hydrologisk" ;
  hydrolys_nn_1 = mkN "hydrolys" "hydrolyser" ;
  hydroplan_nn_1 = mkN "hydroplan" neutrum ;
  hydrostatisk_av_1 = mkA "hydrostatisk" ;
  hydroxid_nn_1 = mkN "hydroxid" "hydroxider" ;
  hydroxidjon_nn_1 = mkN "hydroxidjon" "hydroxidjoner" ;
  hyende_nn_1 = mkN "hyende" ;
  hyf_nn_1 = mkN "hyf" "hyfer" ;
  hygge_nn_1 = mkN "hygge" ;
  hyggesbraenning_nn_1 = mkN "hyggesbrдnning" ;
  hygglig_av_1 = mkA "hygglig" ;
  hygglo_nn_1 = mkN "hygglo" "hygglot" "hygglon" "hygglona" ;
  hygienisk_av_1 = mkA "hygienisk" ;
  hygienist_nn_1 = mkN "hygienist" "hygienister" ;
  hygrograf_nn_1 = mkN "hygrograf" "hygrografer" ;
  hygrometer_nn_1 = mkN "hygrometer" ;
  hygroskopisk_av_1 = mkA "hygroskopisk" ;
  hyllmeter_nn_1 = mkN "hyllmeter" ;
  hyllning_nn_1 = mkN "hyllning" ;
  hyllningsdikt_nn_1 = mkN "hyllningsdikt" "hyllningsdikter" ;
  hyllningssaang_nn_1 = mkN "hyllningssеng" "hyllningssеnger" ;
  hymn_nn_1 = mkN "hymn" "hymner" ;
  hyperbel_nn_1 = mkN "hyperbel" "hyperbeln" "hyperbler" "hyperblerna" ;
  hyperbol_nn_1 = mkN "hyperbol" "hyperboler" ;
  hyperbolisk_av_1 = mkA "hyperbolisk" ;
  hyperbore_nn_1 = mkN "hyperborй" "hyperborйer" ;
  hyperit_nn_1 = mkN "hyperit" "hyperiter" ;
  hyperkaenslig_av_1 = mkA "hyperkдnslig" ;
  hyperkatalektisk_av_1 = mkA "hyperkatalektisk" ;
  hyperkorrekt_av_1 = mkA "hyperkorrekt" "hyperkorrekt" ;
  hypermodern_av_1 = mkA "hypermodern" ;
  hypersvecism_nn_1 = mkN "hypersvecism" "hypersvecismer" ;
  hypertrofi_nn_1 = mkN "hypertrofi" "hypertrofier" ;
  hypnos_nn_1 = mkN "hypnos" "hypnoser" ;
  hypnotisk_av_1 = mkA "hypnotisk" ;
  hypnotisoer_nn_1 = mkN "hypnotisцr" "hypnotisцrer" ;
  hypofys_nn_1 = mkN "hypofys" "hypofyser" ;
  hypofyshormon_nn_1 = mkN "hypofyshormon" neutrum ;
  hypokonder_nn_1 = mkN "hypokonder" "hypokondern" "hypokondrer" "hypokondrerna" ;
  hypokondri_nn_1 = mkN "hypokondri" "hypokondrier" ;
  hypokondriker_nn_1 = mkN "hypokondriker" "hypokondrikern" "hypokondriker" "hypokondrikerna" ;
  hypokondrisk_av_1 = mkA "hypokondrisk" ;
  hypokrit_nn_1 = mkN "hypokrit" "hypokriter" ;
  hypokritisk_av_1 = mkA "hypokritisk" ;
  hypotaktisk_av_1 = mkA "hypotaktisk" ;
  hypotek_nn_1 = mkN "hypotek" neutrum ;
  hypotekslaan_nn_1 = mkN "hypotekslеn" neutrum ;
  hypotes_nn_1 = mkN "hypotes" "hypoteser" ;
  hypotetisk_av_1 = mkA "hypotetisk" ;
  hypsometer_nn_1 = mkN "hypsometer" ;
  hyresgaest_nn_1 = mkN "hyresgдst" "hyresgдster" ;
  hyreshaj_nn_1 = mkN "hyreshaj" ;
  hyreshus_nn_1 = mkN "hyreshus" neutrum ;
  hyreskasern_nn_1 = mkN "hyreskasern" "hyreskaserner" ;
  hyreskontrakt_nn_1 = mkN "hyreskontrakt" neutrum ;
  hyreslaegenhet_nn_1 = mkN "hyreslдgenhet" "hyreslдgenheter" ;
  hyresnaemnd_nn_1 = mkN "hyresnдmnd" "hyresnдmnder" ;
  hyresreglering_nn_1 = mkN "hyresreglering" ;
  hyrestillaegg_nn_1 = mkN "hyrestillдgg" neutrum ;
  hyrestvist_nn_1 = mkN "hyrestvist" "hyrestvister" ;
  hyresvaerd_nn_1 = mkN "hyresvдrd" ;
  hyss_nn_1 = mkN "hyss" neutrum ;
  hysteriker_nn_1 = mkN "hysteriker" "hysterikern" "hysteriker" "hysterikerna" ;
  hysterisk_av_1 = mkA "hysterisk" ;
  hytt_nn_1 = mkN "hytt" "hytter" ;
  hyvel_nn_1 = mkN "hyvel" ;
  hyvelbaenk_nn_1 = mkN "hyvelbдnk" ;
  hyveljaern_nn_1 = mkN "hyveljдrn" neutrum ;
  hyvelspaan_nn_1 = mkN "hyvelspеn" neutrum ;
  hyvelstaal_nn_1 = mkN "hyvelstеl" neutrum ;
  hyvens_av_1 = mkA "hyvens" ;
  i_ab_1 = mkAdv "i" ;
  i_land_nn_1 = mkN "i-land" "i-landet" "i-lдnder" "i-lдnderna" ;
  iaktta_vb_1 = mkV "iaktta" "iakttar" "iaktta" "iakttog" "iakttagit" "iakttagen" ;
  iakttagare_nn_1 = mkN "iakttagare" "iakttagare" ;
  iakttagelse_nn_1 = mkN "iakttagelse" "iakttagelser" ;
  iberisk_av_1 = mkA "iberisk" ;
  ibero_amerikansk_av_1 = mkA "ibero-amerikansk" ;
  ibidem_ab_1 = mkAdv "ibidem" ;
  ibis_nn_1 = mkN "ibis" ;
  ibisfaagel_nn_1 = mkN "ibisfеgel" ;
  ibland_ab_1 = mkAdv "ibland" ;
  icing_nn_1 = mkN "icing" ;
  icke_ab_1 = mkAdv "icke" ;
  icke_angreppspakt_nn_1 = mkN "icke-angreppspakt" "icke-angreppspakter" ;
  icke_darwinistisk_av_1 = mkA "icke-darwinistisk" ;
  icke_euklidisk_av_1 = mkA "icke-euklidisk" ;
  icke_existerande_av_1 = mkA "icke-existerande" ;
  icke_haendelse_nn_1 = mkN "icke-hдndelse" "icke-hдndelser" ;
  icke_individuell_av_1 = mkA "icke-individuell" ;
  icke_kristen_av_1 = mkA "icke-kristen" "icke-kristet" ;
  icke_linjaer_av_1 = mkA "icke-linjдr" ;
  icke_metall_nn_1 = mkN "icke-metall" "icke-metaller" ;
  icke_periodisk_av_1 = mkA "icke-periodisk" ;
  icke_spridningsavtal_nn_1 = mkN "icke-spridningsavtal" "icke-spridningsavtalet" "icke-spridningsavtalen" "icke-spridningsavtalena" ;
  icke_symmetrisk_av_1 = mkA "icke-symmetrisk" ;
  id_nn_1 = mkN "id" ;
  idag_ab_1 = mkAdv "idag" ;
  ide_nn_1 = mkN "idй" "idйer" ;
  ideal_av_1 = mkA "ideal" ;
  ideal_nn_1 = mkN "ideal" neutrum ;
  idealisering_nn_1 = mkN "idealisering" ;
  idealisk_av_1 = mkA "idealisk" ;
  idealist_nn_1 = mkN "idealist" "idealister" ;
  idealistisk_av_1 = mkA "idealistisk" ;
  idealitet_nn_1 = mkN "idealitet" "idealiteter" ;
  idealvaerld_nn_1 = mkN "idealvдrld" ;
  ideassociation_nn_1 = mkN "idйassociation" "idйassociationer" ;
  idedrama_nn_1 = mkN "idйdrama" "idйdramat" "idйdraman" "idйdramana" ;
  ideell_av_1 = mkA "ideell" ;
  idegivare_nn_1 = mkN "idйgivare" "idйgivare" ;
  idegran_nn_1 = mkN "idegran" ;
  ideklaeckning_nn_1 = mkN "idйklдckning" ;
  idel_ab_1 = mkAdv "idel" ;
  idelig_av_1 = mkA "idelig" ;
  ideligen_ab_1 = mkAdv "ideligen" ;
  idemoete_nn_1 = mkN "idйmцte" ;
  identifiering_nn_1 = mkN "identifiering" ;
  identifikation_nn_1 = mkN "identifikation" "identifikationer" ;
  identisk_av_1 = mkA "identisk" ;
  identitet_nn_1 = mkN "identitet" "identiteter" ;
  identitetskort_nn_1 = mkN "identitetskort" neutrum ;
  ideografisk_av_1 = mkA "ideografisk" ;
  ideogram_nn_1 = mkN "ideogram" "ideogrammet" "ideogram" "ideogrammen" ;
  ideolog_nn_1 = mkN "ideolog" "ideologer" ;
  ideologi_nn_1 = mkN "ideologi" "ideologier" ;
  ideologisk_av_1 = mkA "ideologisk" ;
  iderik_av_1 = mkA "idйrik" ;
  idevaerld_nn_1 = mkN "idйvдrld" ;
  idiolekt_nn_1 = mkN "idiolekt" "idiolekter" ;
  idiom_nn_1 = mkN "idiom" neutrum ;
  idiomatisk_av_1 = mkA "idiomatisk" ;
  idiopatisk_av_1 = mkA "idiopatisk" ;
  idiosynkrasi_nn_1 = mkN "idiosynkrasi" "idiosynkrasier" ;
  idiot_nn_1 = mkN "idiot" "idioter" ;
  idioti_nn_1 = mkN "idioti" "idiotier" ;
  idiotisk_av_1 = mkA "idiotisk" ;
  idiotsaeker_av_1 = mkA "idiotsдker" "idiotsдkert" "idiotsдkra" "idiotsдkra" "idiotsдkrare" "idiotsдkrast" "idiotsдkraste" ;
  idisslare_nn_1 = mkN "idisslare" "idisslare" ;
  idkare_nn_1 = mkN "idkare" "idkare" ;
  idog_av_1 = mkA "idog" ;
  idol_nn_1 = mkN "idol" "idoler" ;
  idrott_nn_1 = mkN "idrott" "idrotter" ;
  idrottsdag_nn_1 = mkN "idrottsdag" ;
  idrottsdraekt_nn_1 = mkN "idrottsdrдkt" "idrottsdrдkter" ;
  idrottsfoerening_nn_1 = mkN "idrottsfцrening" ;
  idrottsgren_nn_1 = mkN "idrottsgren" "idrottsgrenen" "idrottsgrenar" "idrottsgrenarna" ;
  idrottsgymnasium_nn_1 = mkN "idrottsgymnasium" "idrottsgymnasiet" "idrottsgymnasier" "idrottsgymnasierna" ;
  idrottshall_nn_1 = mkN "idrottshall" ;
  idrottsklubb_nn_1 = mkN "idrottsklubb" ;
  idrottskompani_nn_1 = mkN "idrottskompani" "idrottskompanit" "idrottskompanier" "idrottskompanierna" ;
  idrottskvinna_nn_1 = mkN "idrottskvinna" ;
  idrottslig_av_1 = mkA "idrottslig" ;
  idrottsman_nn_1 = mkN "idrottsman" "idrottsmannen" "idrottsmдn" "idrottsmдnnen" ;
  idrottsplats_nn_1 = mkN "idrottsplats" "idrottsplatser" ;
  idrottsroerelse_nn_1 = mkN "idrottsrцrelse" "idrottsrцrelser" ;
  idrottssko_nn_1 = mkN "idrottssko" "idrottsskor" ;
  idrottstaevling_nn_1 = mkN "idrottstдvling" ;
  idyll_nn_1 = mkN "idyll" "idyller" ;
  idylliker_nn_1 = mkN "idylliker" "idyllikern" "idylliker" "idyllikerna" ;
  idyllisk_av_1 = mkA "idyllisk" ;
  ifatt_ab_1 = mkAdv "ifatt" ;
  ifjol_ab_1 = mkAdv "ifjol" ;
  ifraaga_ab_1 = mkAdv "ifrеga" ;
  ifraagakomma_vb_1 = mkV "ifrеgakomma" "ifrеgakom" "ifrеgakommit" ;
  ifraagavarande_av_1 = mkA "ifrеgavarande" ;
  ifraan_ab_1 = mkAdv "ifrеn" ;
  ifred_ab_1 = mkAdv "ifred" ;
  ifyllnadsprov_nn_1 = mkN "ifyllnadsprov" neutrum ;
  igaang_ab_1 = mkAdv "igеng" ;
  igaangsaettning_nn_1 = mkN "igеngsдttning" ;
  igaar_ab_1 = mkAdv "igеr" ;
  igel_nn_1 = mkN "igel" ;
  igelkott_nn_1 = mkN "igelkott" ;
  igen_ab_1 = mkAdv "igen" ;
  igengrodd_av_1 = mkA "igengrodd" "igengrodtt" ;
  igenkaennande_av_1 = mkA "igenkдnnande" ;
  igenkaenningstecken_nn_1 = mkN "igenkдnningstecken" "igenkдnningstecknet" "igenkдnningstecken" "igenkдnningstecknen" ;
  igenkaennlig_av_1 = mkA "igenkдnnlig" ;
  igenmulen_av_1 = mkA "igenmulen" "igenmulet" ;
  igenom_ab_1 = mkAdv "igenom" ;
  igenvaext_av_1 = mkA "igenvдxt" "igenvдxt" ;
  igenvuxen_av_1 = mkA "igenvuxen" "igenvuxet" ;
  igloo_nn_1 = mkN "igloo" "igloor" ;
  ignorant_av_1 = mkA "ignorant" "ignorant" ;
  ignorant_nn_1 = mkN "ignorant" "ignoranter" ;
  ihaag_ab_1 = mkAdv "ihеg" ;
  ihaagkomma_vb_1 = mkV "ihеgkomma" "ihеgkom" "ihеgkommit" ;
  ihaalig_av_1 = mkA "ihеlig" ;
  ihaalighet_nn_1 = mkN "ihеlighet" "ihеligheter" ;
  ihaallande_av_1 = mkA "ihеllande" ;
  ihaerdig_av_1 = mkA "ihдrdig" ;
  ihjael_ab_1 = mkAdv "ihjдl" ;
  ihop_ab_1 = mkAdv "ihop" ;
  ikapp_ab_1 = mkAdv "ikapp" ;
  ikon_nn_1 = mkN "ikon" "ikoner" ;
  ikonostas_nn_1 = mkN "ikonostas" "ikonostaser" ;
  ikosaeder_nn_1 = mkN "ikosaeder" ;
  ikraft_ab_1 = mkAdv "ikraft" ;
  iktus_nn_1 = mkN "iktus" "iktusen" "iktus" "iktusen" ;
  iktyolog_nn_1 = mkN "iktyolog" "iktyologer" ;
  iktyologisk_av_1 = mkA "iktyologisk" ;
  ikull_ab_1 = mkAdv "ikull" ;
  ikvaell_ab_1 = mkAdv "ikvдll" ;
  il_nn_1 = mkN "il" ;
  iland_ab_1 = mkAdv "iland" ;
  ilbud_nn_1 = mkN "ilbud" neutrum ;
  ilex_nn_1 = mkN "ilex" ;
  illa_ab_1 = mkAdv "illa" ;
  illaluktande_av_1 = mkA "illaluktande" ;
  illamaaende_av_1 = mkA "illamеende" ;
  illande_ab_1 = mkAdv "illande" ;
  illasmakande_av_1 = mkA "illasmakande" ;
  illavarslande_av_1 = mkA "illavarslande" ;
  illavulen_av_1 = mkA "illavulen" "illavulet" ;
  illbatting_nn_1 = mkN "illbatting" ;
  illdaad_nn_1 = mkN "illdеd" neutrum ;
  illegal_av_1 = mkA "illegal" ;
  illegitim_av_1 = mkA "illegitim" ;
  iller_nn_1 = mkN "iller" ;
  illfundig_av_1 = mkA "illfundig" ;
  illgaerning_nn_1 = mkN "illgдrning" ;
  illistig_av_1 = mkA "illistig" ;
  illitterat_av_1 = mkA "illitterat" "illitterat" ;
  illmarig_av_1 = mkA "illmarig" ;
  illojal_av_1 = mkA "illojal" ;
  illparig_av_1 = mkA "illparig" ;
  illroed_av_1 = mkA "illrцd" ;
  illtjut_nn_1 = mkN "illtjut" neutrum ;
  illumination_nn_1 = mkN "illumination" "illuminationer" ;
  illusion_nn_1 = mkN "illusion" "illusioner" ;
  illusionist_nn_1 = mkN "illusionist" "illusionister" ;
  illusionsfri_av_1 = mkA "illusionsfri" "illusionsfritt" ;
  illusionsloes_av_1 = mkA "illusionslцs" ;
  illusionsnummer_nn_1 = mkN "illusionsnummer" neutrum ;
  illusorisk_av_1 = mkA "illusorisk" ;
  illuster_av_1 = mkA "illuster" "illustert" "illustra" "illustra" "illustrare" "illustrast" "illustraste" ;
  illustration_nn_1 = mkN "illustration" "illustrationer" ;
  illustrativ_av_1 = mkA "illustrativ" ;
  illustratoer_nn_1 = mkN "illustratцr" "illustratцrer" ;
  illvillig_av_1 = mkA "illvillig" ;
  illvraal_nn_1 = mkN "illvrеl" neutrum ;
  illyr_nn_1 = mkN "illyr" "illyrer" ;
  illyrisk_av_1 = mkA "illyrisk" ;
  ilmarsch_nn_1 = mkN "ilmarsch" "ilmarscher" ;
  ilning_nn_1 = mkN "ilning" ;
  ilsamtal_nn_1 = mkN "ilsamtal" "ilsamtalet" "ilsamtalen" "ilsamtalena" ;
  ilsk_av_1 = mkA "ilsk" ;
  ilsken_av_1 = mkA "ilsken" "ilsket" ;
  imaginaer_av_1 = mkA "imaginдr" ;
  imbecill_av_1 = mkA "imbecill" ;
  imitation_nn_1 = mkN "imitation" "imitationer" ;
  imitatoer_nn_1 = mkN "imitatцr" "imitatцrer" ;
  immanent_av_1 = mkA "immanent" "immanent" ;
  immateriell_av_1 = mkA "immateriell" ;
  immatrikulation_nn_1 = mkN "immatrikulation" "immatrikulationer" ;
  immig_av_1 = mkA "immig" ;
  immigrant_nn_1 = mkN "immigrant" "immigranter" ;
  immobil_av_1 = mkA "immobil" ;
  immun_av_1 = mkA "immun" ;
  immunitet_nn_1 = mkN "immunitet" "immuniteter" ;
  immunolog_nn_1 = mkN "immunolog" "immunologer" ;
  immunologisk_av_1 = mkA "immunologisk" ;
  impediment_nn_1 = mkN "impediment" "impedimentet" "impedimenten" "impedimentena" ;
  imperativ_nn_1 = mkN "imperativ" "imperativer" ;
  imperativ_nn_2 = mkN "imperativ" neutrum ;
  imperativisk_av_1 = mkA "imperativisk" ;
  imperator_nn_1 = mkN "imperator" "imperatorer" ;
  imperatorisk_av_1 = mkA "imperatorisk" ;
  imperfektum_nn_1 = mkN "imperfektum" "imperfektet" "imperfekter" "imperfekterna" ;
  imperialformat_nn_1 = mkN "imperialformat" neutrum ;
  imperialist_nn_1 = mkN "imperialist" "imperialister" ;
  imperialistisk_av_1 = mkA "imperialistisk" ;
  imperialoktav_nn_1 = mkN "imperialoktav" "imperialoktaver" ;
  imperialsaeng_nn_1 = mkN "imperialsдng" ;
  imperium_nn_1 = mkN "imperium" "imperiet" "imperier" "imperierna" ;
  impertinens_nn_1 = mkN "impertinens" "impertinenser" ;
  impertinent_av_1 = mkA "impertinent" "impertinent" ;
  implicit_av_1 = mkA "implicit" "implicit" ;
  implikation_nn_1 = mkN "implikation" "implikationer" ;
  implosion_nn_1 = mkN "implosion" "implosioner" ;
  imponderabilia_nn_1 = mkN "imponderabilia" "imponderabilian" "imponderabilia" "imponderabiliana" ;
  imponerande_av_1 = mkA "imponerande" ;
  impopulaer_av_1 = mkA "impopulдr" ;
  impopularitet_nn_1 = mkN "impopularitet" "impopulariteter" ;
  import_nn_1 = mkN "import" "importer" ;
  importavgift_nn_1 = mkN "importavgift" "importavgifter" ;
  importfoerbud_nn_1 = mkN "importfцrbud" neutrum ;
  importkvot_nn_1 = mkN "importkvot" "importkvoter" ;
  importoer_nn_1 = mkN "importцr" "importцrer" ;
  imposant_av_1 = mkA "imposant" "imposant" ;
  impost_nn_1 = mkN "impost" "imposter" ;
  impotent_av_1 = mkA "impotent" "impotent" ;
  impregnering_nn_1 = mkN "impregnering" ;
  impressario_nn_1 = mkN "impressario" "impressarion" "impressarier" "impressarierna" ;
  impressionist_nn_1 = mkN "impressionist" "impressionister" ;
  impressionistisk_av_1 = mkA "impressionistisk" ;
  improduktiv_av_1 = mkA "improduktiv" ;
  impromptu_nn_1 = mkN "impromptu" "impromptut" "impromptun" "impromptuna" ;
  improvisation_nn_1 = mkN "improvisation" "improvisationer" ;
  improvisatoer_nn_1 = mkN "improvisatцr" "improvisatцrer" ;
  improvisatorisk_av_1 = mkA "improvisatorisk" ;
  impuls_nn_1 = mkN "impuls" "impulser" ;
  impulsiv_av_1 = mkA "impulsiv" ;
  impulsivitet_nn_1 = mkN "impulsivitet" "impulsiviteter" ;
  impulskoep_nn_1 = mkN "impulskцp" neutrum ;
  imroer_nn_1 = mkN "imrцr" neutrum ;
  in_ab_1 = mkAdv "in" ;
  inaat_ab_1 = mkAdv "inеt" ;
  inaatvaend_av_1 = mkA "inеtvдnd" ;
  inackordering_nn_1 = mkN "inackordering" ;
  inackorderingshem_nn_1 = mkN "inackorderingshem" "inackorderingshemmet" "inackorderingshem" "inackorderingshemmen" ;
  inadekvat_av_1 = mkA "inadekvat" "inadekvat" ;
  inadvertens_nn_1 = mkN "inadvertens" "inadvertenser" ;
  inaega_nn_1 = mkN "inдga" ;
  inaelvsmask_nn_1 = mkN "inдlvsmask" ;
  inaktiv_av_1 = mkA "inaktiv" ;
  inaktivitet_nn_1 = mkN "inaktivitet" "inaktiviteter" ;
  inaktuell_av_1 = mkA "inaktuell" ;
  inalles_ab_1 = mkAdv "inalles" ;
  inandning_nn_1 = mkN "inandning" ;
  inauguration_nn_1 = mkN "inauguration" "inaugurationer" ;
  inbegrepp_nn_1 = mkN "inbegrepp" neutrum ;
  inbegripa_vb_1 = mkV "inbegripa" "inbegrep" "inbegripit" ;
  inbegripen_av_1 = mkA "inbegripen" "inbegripet" ;
  inbesparing_nn_1 = mkN "inbesparing" ;
  inbetalning_nn_1 = mkN "inbetalning" ;
  inbetalningskort_nn_1 = mkN "inbetalningskort" neutrum ;
  inbillning_nn_1 = mkN "inbillning" ;
  inbillningsfoster_nn_1 = mkN "inbillningsfoster" neutrum ;
  inbillningssjuk_av_1 = mkA "inbillningssjuk" ;
  inbilsk_av_1 = mkA "inbilsk" ;
  inbiten_av_1 = mkA "inbiten" "inbitet" ;
  inbjuda_vb_1 = mkV "inbjuda" "inbjцd" "inbjudit" ;
  inbjudande_av_1 = mkA "inbjudande" ;
  inbjudning_nn_1 = mkN "inbjudning" ;
  inbjudningskort_nn_1 = mkN "inbjudningskort" neutrum ;
  inbjudningsskrift_nn_1 = mkN "inbjudningsskrift" "inbjudningsskrifter" ;
  inblandning_nn_1 = mkN "inblandning" ;
  inblick_nn_1 = mkN "inblick" ;
  inboerdes_av_1 = mkA "inbцrdes" ;
  inboerdeskrig_nn_1 = mkN "inbцrdeskrig" neutrum ;
  inbokning_nn_1 = mkN "inbokning" ;
  inbringande_av_1 = mkA "inbringande" ;
  inbromsning_nn_1 = mkN "inbromsning" ;
  inbrott_nn_1 = mkN "inbrott" neutrum ;
  inbrottstjuv_nn_1 = mkN "inbrottstjuv" ;
  inbrytning_nn_1 = mkN "inbrytning" ;
  inbuktning_nn_1 = mkN "inbuktning" ;
  inbunden_av_1 = mkA "inbunden" "inbundet" ;
  inbyggare_nn_1 = mkN "inbyggare" "inbyggare" ;
  inbyggd_av_1 = mkA "inbyggd" "inbyggt" ;
  inbyte_nn_1 = mkN "inbyte" ;
  incest_nn_1 = mkN "incest" "incester" ;
  incestuoes_av_1 = mkA "incestuцs" ;
  incident_nn_1 = mkN "incident" "incidenter" ;
  incitament_nn_1 = mkN "incitament" "incitamentet" "incitamenten" "incitamentena" ;
  indefinit_av_1 = mkA "indefinit" "indefinit" ;
  indelning_nn_1 = mkN "indelning" ;
  indelningsgrund_nn_1 = mkN "indelningsgrund" "indelningsgrunder" ;
  indelningsverk_nn_1 = mkN "indelningsverk" neutrum ;
  indelt_av_1 = mkA "indelt" "indelt" ;
  independent_nn_1 = mkN "independent" "independenter" ;
  index_nn_1 = mkN "index" neutrum ;
  indexavtal_nn_1 = mkN "indexavtal" "indexavtalet" "indexavtalen" "indexavtalena" ;
  indian_nn_1 = mkN "indian" "indianer" ;
  indianfolk_nn_1 = mkN "indianfolk" neutrum ;
  indianhoevding_nn_1 = mkN "indianhцvding" ;
  indiankvinna_nn_1 = mkN "indiankvinna" ;
  indianreservat_nn_1 = mkN "indianreservat" neutrum ;
  indiansk_av_1 = mkA "indiansk" ;
  indianska_nn_1 = mkN "indianska" ;
  indiansommar_nn_1 = mkN "indiansommar" "indiansommarn" "indiansommrar" "indiansommrarna" ;
  indianstam_nn_1 = mkN "indianstam" "indianstammen" "indianstammar" "indianstammarna" ;
  indiantjut_nn_1 = mkN "indiantjut" neutrum ;
  indicium_nn_1 = mkN "indicium" "indiciet" "indicier" "indicierna" ;
  indier_nn_1 = mkN "indier" "indiern" "indier" "indierna" ;
  indifferent_av_1 = mkA "indifferent" "indifferent" ;
  indifferentism_nn_1 = mkN "indifferentism" "indifferentismer" ;
  indikation_nn_1 = mkN "indikation" "indikationer" ;
  indikativ_av_1 = mkA "indikativ" ;
  indikativ_nn_1 = mkN "indikativ" "indikativer" ;
  indikator_nn_1 = mkN "indikator" "indikatorer" ;
  indikering_nn_1 = mkN "indikering" ;
  indirekt_av_1 = mkA "indirekt" "indirekt" ;
  indisk_av_1 = mkA "indisk" ;
  indiska_nn_1 = mkN "indiska" ;
  indiskret_av_1 = mkA "indiskret" "indiskret" ;
  indiskretion_nn_1 = mkN "indiskretion" "indiskretioner" ;
  indisponibel_av_1 = mkA "indisponibel" "indisponibelt" "indisponibla" "indisponibla" "indisponiblare" "indisponiblast" "indisponiblaste" ;
  individ_nn_1 = mkN "individ" neutrum ;
  individualist_nn_1 = mkN "individualist" "individualister" ;
  individualistisk_av_1 = mkA "individualistisk" ;
  individualitet_nn_1 = mkN "individualitet" "individualiteter" ;
  individuell_av_1 = mkA "individuell" ;
  indoeurope_nn_1 = mkN "indoeuropй" "indoeuropйer" ;
  indoeuropeisk_av_1 = mkA "indoeuropeisk" ;
  indokinesisk_av_1 = mkA "indokinesisk" ;
  indoktrinering_nn_1 = mkN "indoktrinering" ;
  indolent_av_1 = mkA "indolent" "indolent" ;
  indolog_nn_1 = mkN "indolog" "indologer" ;
  indones_nn_1 = mkN "indones" "indoneser" ;
  indonesisk_av_1 = mkA "indonesisk" ;
  indra_vb_1 = mkV "indra" "indrar" "indra" "indrog" "indragit" "indragen" ;
  indraektig_av_1 = mkA "indrдktig" ;
  indrag_nn_1 = mkN "indrag" neutrum ;
  indragning_nn_1 = mkN "indragning" ;
  indriva_vb_1 = mkV "indriva" "indrev" "indrivit" ;
  indrivning_nn_1 = mkN "indrivning" ;
  induktion_nn_1 = mkN "induktion" "induktioner" ;
  induktionsapparat_nn_1 = mkN "induktionsapparat" "induktionsapparater" ;
  induktionsspole_nn_1 = mkN "induktionsspole" utrum ;
  induktiv_av_1 = mkA "induktiv" ;
  induktor_nn_1 = mkN "induktor" "induktorer" ;
  industri_nn_1 = mkN "industri" "industrier" ;
  industriaktie_nn_1 = mkN "industriaktie" "industriaktier" ;
  industrialisering_nn_1 = mkN "industrialisering" ;
  industriarbetare_nn_1 = mkN "industriarbetare" "industriarbetare" ;
  industriell_av_1 = mkA "industriell" ;
  industrifoerbund_nn_1 = mkN "industrifцrbund" neutrum ;
  industriland_nn_1 = mkN "industriland" "industrilandet" "industrilдnder" "industrilдnderna" ;
  industriolja_nn_1 = mkN "industriolja" ;
  industriomraade_nn_1 = mkN "industriomrеde" ;
  industriprodukt_nn_1 = mkN "industriprodukt" "industriprodukter" ;
  industriregion_nn_1 = mkN "industriregion" "industriregioner" ;
  industrirobot_nn_1 = mkN "industrirobot" ;
  industrisemester_nn_1 = mkN "industrisemester" ;
  ineffektiv_av_1 = mkA "ineffektiv" ;
  inexakt_av_1 = mkA "inexakt" "inexakt" ;
  infall_nn_1 = mkN "infall" neutrum ;
  infalla_vb_1 = mkV "infalla" "infцll" "infallit" ;
  infallen_av_1 = mkA "infallen" "infallet" ;
  infallsrik_av_1 = mkA "infallsrik" ;
  infallsvinkel_nn_1 = mkN "infallsvinkel" ;
  infam_av_1 = mkA "infam" ;
  infami_nn_1 = mkN "infami" "infamier" ;
  infant_nn_1 = mkN "infant" "infanter" ;
  infanterikompani_nn_1 = mkN "infanterikompani" "infanterikompanit" "infanterikompanier" "infanterikompanierna" ;
  infanterist_nn_1 = mkN "infanterist" "infanterister" ;
  infantil_av_1 = mkA "infantil" ;
  infantinna_nn_1 = mkN "infantinna" ;
  infarkt_nn_1 = mkN "infarkt" "infarkter" ;
  infart_nn_1 = mkN "infart" "infarter" ;
  infartsled_nn_1 = mkN "infartsled" "infartsleder" ;
  infartsport_nn_1 = mkN "infartsport" ;
  infattning_nn_1 = mkN "infattning" ;
  infektioes_av_1 = mkA "infektiцs" ;
  infektion_nn_1 = mkN "infektion" "infektioner" ;
  infektionshaerd_nn_1 = mkN "infektionshдrd" ;
  infektionssjukdom_nn_1 = mkN "infektionssjukdom" ;
  infernalisk_av_1 = mkA "infernalisk" ;
  inferno_nn_1 = mkN "inferno" "infernot" "infernon" "infernona" ;
  infiltration_nn_1 = mkN "infiltration" "infiltrationer" ;
  infiltratoer_nn_1 = mkN "infiltratцr" "infiltratцrer" ;
  infinit_av_1 = mkA "infinit" "infinit" ;
  infinitiv_nn_1 = mkN "infinitiv" "infinitiver" ;
  infinitivmaerke_nn_1 = mkN "infinitivmдrke" ;
  infinna_vb_1 = mkV "infinna" "infann" "infunnit" ;
  infix_nn_1 = mkN "infix" neutrum ;
  inflammation_nn_1 = mkN "inflammation" "inflammationer" ;
  inflammationshaerd_nn_1 = mkN "inflammationshдrd" ;
  inflammatorisk_av_1 = mkA "inflammatorisk" ;
  inflationistisk_av_1 = mkA "inflationistisk" ;
  inflationsdrivande_av_1 = mkA "inflationsdrivande" ;
  inflationsfas_nn_1 = mkN "inflationsfas" "inflationsfaser" ;
  inflationsmodell_nn_1 = mkN "inflationsmodell" "inflationsmodeller" ;
  inflationsskydd_nn_1 = mkN "inflationsskydd" neutrum ;
  inflationsspiral_nn_1 = mkN "inflationsspiral" "inflationsspiraler" ;
  inflationstakt_nn_1 = mkN "inflationstakt" "inflationstakter" ;
  inflationsteori_nn_1 = mkN "inflationsteori" "inflationsteorier" ;
  inflatorisk_av_1 = mkA "inflatorisk" ;
  influens_nn_1 = mkN "influens" "influenser" ;
  influensmaskin_nn_1 = mkN "influensmaskin" "influensmaskiner" ;
  inflygning_nn_1 = mkN "inflygning" ;
  inflyta_vb_1 = mkV "inflyta" "inflцt" "influtit" ;
  inflytande_nn_1 = mkN "inflytande" ;
  inflytelse_nn_1 = mkN "inflytelse" "inflytelser" ;
  inflytelserik_av_1 = mkA "inflytelserik" ;
  inflyttning_nn_1 = mkN "inflyttning" ;
  infoedd_av_1 = mkA "infцdd" ;
  infoeding_nn_1 = mkN "infцding" ;
  infoerande_nn_1 = mkN "infцrande" ;
  infoerstaadd_av_1 = mkA "infцrstеdd" "infцrstеdtt" ;
  infordring_nn_1 = mkN "infordring" ;
  informant_nn_1 = mkN "informant" "informanter" ;
  information_nn_1 = mkN "information" "informationer" ;
  informationsbehandling_nn_1 = mkN "informationsbehandling" ;
  informationsbyraa_nn_1 = mkN "informationsbyrе" "informationsbyrеer" ;
  informationsrik_av_1 = mkA "informationsrik" ;
  informationssoekning_nn_1 = mkN "informationssцkning" ;
  informativ_av_1 = mkA "informativ" ;
  informatoer_nn_1 = mkN "informatцr" "informatцrer" ;
  informator_nn_1 = mkN "informator" "informatorer" ;
  informell_av_1 = mkA "informell" ;
  infragrill_nn_1 = mkN "infragrill" ;
  infraljud_nn_1 = mkN "infraljud" neutrum ;
  infraroed_av_1 = mkA "infrarцd" ;
  infrastruktur_nn_1 = mkN "infrastruktur" "infrastrukturer" ;
  infrusen_av_1 = mkA "infrusen" "infruset" ;
  infusion_nn_1 = mkN "infusion" "infusioner" ;
  infusionsdjur_nn_1 = mkN "infusionsdjur" neutrum ;
  ingaa_vb_1 = mkV "ingе" "ingеr" "ingе" "ingick" "ingеtt" "ingеngen" ;
  ingaaende_av_1 = mkA "ingеende" ;
  ingaang_nn_1 = mkN "ingеng" ;
  ingaangsmarsch_nn_1 = mkN "ingеngsmarsch" "ingеngsmarscher" ;
  ingaangspsalm_nn_1 = mkN "ingеngspsalm" "ingеngspsalmer" ;
  ingaeld_nn_1 = mkN "ingдld" "ingдlder" ;
  ingalunda_ab_1 = mkAdv "ingalunda" ;
  inge_vb_1 = mkV "inge" "inger" "inge" "ingav" "ingett" "ingiven" ;
  ingefaersvaext_nn_1 = mkN "ingefдrsvдxt" "ingefдrsvдxter" ;
  ingenium_nn_1 = mkN "ingenium" "ingeniet" "ingenier" "ingenierna" ;
  ingenjoer_nn_1 = mkN "ingenjцr" "ingenjцrer" ;
  ingenjoerstrupp_nn_1 = mkN "ingenjцrstrupp" "ingenjцrstrupper" ;
  ingenjoersvetenskap_nn_1 = mkN "ingenjцrsvetenskap" "ingenjцrsvetenskaper" ;
  ingenjoersvetenskapsakademi_nn_1 = mkN "ingenjцrsvetenskapsakademi" "ingenjцrsvetenskapsakademier" ;
  ingenstaedes_ab_1 = mkAdv "ingenstдdes" ;
  ingenstans_ab_1 = mkAdv "ingenstans" ;
  ingenvart_ab_1 = mkAdv "ingenvart" ;
  ingeny_nn_1 = mkN "ingeny" "ingenyer" ;
  ingift_av_1 = mkA "ingift" "ingift" ;
  ingifte_nn_1 = mkN "ingifte" ;
  ingivelse_nn_1 = mkN "ingivelse" "ingivelser" ;
  ingjuta_vb_1 = mkV "ingjuta" "ingцt" "ingjutit" ;
  ingoet_nn_1 = mkN "ingцt" neutrum ;
  ingrediens_nn_1 = mkN "ingrediens" "ingredienser" ;
  ingredierande_av_1 = mkA "ingredierande" ;
  ingrepp_nn_1 = mkN "ingrepp" neutrum ;
  ingress_nn_1 = mkN "ingress" "ingresser" ;
  ingripande_nn_1 = mkN "ingripande" ;
  ingrodd_av_1 = mkA "ingrodd" "ingrodtt" ;
  inhaegnad_nn_1 = mkN "inhдgnad" "inhдgnader" ;
  inhalation_nn_1 = mkN "inhalation" "inhalationer" ;
  inhalator_nn_1 = mkN "inhalator" "inhalatorer" ;
  inhamn_nn_1 = mkN "inhamn" ;
  inhav_nn_1 = mkN "inhav" neutrum ;
  inhemsk_av_1 = mkA "inhemsk" ;
  inherent_av_1 = mkA "inherent" "inherent" ;
  inhibitor_nn_1 = mkN "inhibitor" "inhibitorer" ;
  inhopp_nn_1 = mkN "inhopp" neutrum ;
  inhoppare_nn_1 = mkN "inhoppare" "inhoppare" ;
  inhuman_av_1 = mkA "inhuman" ;
  inhysing_nn_1 = mkN "inhysing" ;
  inifraan_ab_1 = mkAdv "inifrеn" ;
  initial_av_1 = mkA "initial" ;
  initial_nn_1 = mkN "initial" "initialer" ;
  initialord_nn_1 = mkN "initialord" neutrum ;
  initiation_nn_1 = mkN "initiation" "initiationer" ;
  initiationsrit_nn_1 = mkN "initiationsrit" "initiationsriter" ;
  initiativ_nn_1 = mkN "initiativ" neutrum ;
  initiativrik_av_1 = mkA "initiativrik" ;
  initiativtagare_nn_1 = mkN "initiativtagare" "initiativtagare" ;
  injektion_nn_1 = mkN "injektion" "injektioner" ;
  injektor_nn_1 = mkN "injektor" "injektorer" ;
  injurie_nn_1 = mkN "injurie" "injurier" ;
  ink_nn_1 = mkN "ink" ;
  inka_nn_1 = mkN "inka" ;
  inkaennande_av_1 = mkA "inkдnnande" ;
  inkaindian_nn_1 = mkN "inkaindian" "inkaindianer" ;
  inkallelse_nn_1 = mkN "inkallelse" "inkallelser" ;
  inkallelsebrev_nn_1 = mkN "inkallelsebrev" neutrum ;
  inkallelseorder_nn_1 = mkN "inkallelseorder" ;
  inkapabel_av_1 = mkA "inkapabel" "inkapabelt" "inkapabla" "inkapabla" "inkapablare" "inkapablast" "inkapablaste" ;
  inkapsling_nn_1 = mkN "inkapsling" ;
  inkarnation_nn_1 = mkN "inkarnation" "inkarnationer" ;
  inkast_nn_1 = mkN "inkast" neutrum ;
  inkiett_av_1 = mkA "inkiett" ;
  inklination_nn_1 = mkN "inklination" "inklinationer" ;
  inklinationsnaal_nn_1 = mkN "inklinationsnеl" ;
  inkoativ_av_1 = mkA "inkoativ" ;
  inkoep_nn_1 = mkN "inkцp" neutrum ;
  inkoepare_nn_1 = mkN "inkцpare" "inkцpare" ;
  inkoepsavdelning_nn_1 = mkN "inkцpsavdelning" ;
  inkoepspris_nn_1 = mkN "inkцpspris" neutrum ;
  inkoerd_av_1 = mkA "inkцrd" "inkцrt" ;
  inkoerning_nn_1 = mkN "inkцrning" ;
  inkoerningsperiod_nn_1 = mkN "inkцrningsperiod" "inkцrningsperioder" ;
  inkoersport_nn_1 = mkN "inkцrsport" ;
  inkognito_ab_1 = mkAdv "inkognito" ;
  inkomma_vb_1 = mkV "inkomma" "inkom" "inkommit" ;
  inkommensurabel_av_1 = mkA "inkommensurabel" "inkommensurabelt" "inkommensurabla" "inkommensurabla" "inkommensurablare" "inkommensurablast" "inkommensurablaste" ;
  inkompatibel_av_1 = mkA "inkompatibel" "inkompatibelt" "inkompatibla" "inkompatibla" "inkompatiblare" "inkompatiblast" "inkompatiblaste" ;
  inkompetent_av_1 = mkA "inkompetent" "inkompetent" ;
  inkomst_nn_1 = mkN "inkomst" "inkomster" ;
  inkomstbegrepp_nn_1 = mkN "inkomstbegrepp" neutrum ;
  inkomstberoende_av_1 = mkA "inkomstberoende" ;
  inkomstbeskattning_nn_1 = mkN "inkomstbeskattning" ;
  inkomstbortfall_nn_1 = mkN "inkomstbortfall" neutrum ;
  inkomstbringande_av_1 = mkA "inkomstbringande" ;
  inkomstintervall_nn_1 = mkN "inkomstintervall" neutrum ;
  inkomstkort_nn_1 = mkN "inkomstkort" neutrum ;
  inkomstmaatt_nn_1 = mkN "inkomstmеtt" neutrum ;
  inkomstoekning_nn_1 = mkN "inkomstцkning" ;
  inkomstskatt_nn_1 = mkN "inkomstskatt" "inkomstskatter" ;
  inkomstslag_nn_1 = mkN "inkomstslag" neutrum ;
  inkomsttagare_nn_1 = mkN "inkomsttagare" "inkomsttagare" ;
  inkomsttaxering_nn_1 = mkN "inkomsttaxering" ;
  inkongruens_nn_1 = mkN "inkongruens" "inkongruenser" ;
  inkongruent_av_1 = mkA "inkongruent" "inkongruent" ;
  inkonsekvens_nn_1 = mkN "inkonsekvens" "inkonsekvenser" ;
  inkonsekvent_av_1 = mkA "inkonsekvent" "inkonsekvent" ;
  inkontinent_av_1 = mkA "inkontinent" "inkontinent" ;
  inkorrekt_av_1 = mkA "inkorrekt" "inkorrekt" ;
  inkraektare_nn_1 = mkN "inkrдktare" "inkrдktare" ;
  inkroekt_av_1 = mkA "inkrцkt" "inkrцkt" ;
  inkrustation_nn_1 = mkN "inkrustation" "inkrustationer" ;
  inkubationstid_nn_1 = mkN "inkubationstid" "inkubationstider" ;
  inkunabel_nn_1 = mkN "inkunabel" "inkunabeln" "inkunabler" "inkunablerna" ;
  inkurant_av_1 = mkA "inkurant" "inkurant" ;
  inkvartering_nn_1 = mkN "inkvartering" ;
  inkvisitor_nn_1 = mkN "inkvisitor" "inkvisitorer" ;
  inkvisitorisk_av_1 = mkA "inkvisitorisk" ;
  inlaaning_nn_1 = mkN "inlеning" ;
  inlaegg_nn_1 = mkN "inlдgg" neutrum ;
  inlaeggning_nn_1 = mkN "inlдggning" ;
  inlaemning_nn_1 = mkN "inlдmning" ;
  inlaemningsdag_nn_1 = mkN "inlдmningsdag" ;
  inlaendsk_av_1 = mkA "inlдndsk" ;
  inlaerningsplataa_nn_1 = mkN "inlдrningsplatе" "inlдrningsplatеer" ;
  inlaerningsresultat_nn_1 = mkN "inlдrningsresultat" neutrum ;
  inlaerningsstudio_nn_1 = mkN "inlдrningsstudio" "inlдrningsstudior" ;
  inlaesning_nn_1 = mkN "inlдsning" ;
  inlaest_av_1 = mkA "inlдst" "inlдst" ;
  inlagd_av_1 = mkA "inlagd" "inlagt" ;
  inlandsis_nn_1 = mkN "inlandsis" ;
  inledande_av_1 = mkA "inledande" ;
  inledare_nn_1 = mkN "inledare" "inledare" ;
  inledning_nn_1 = mkN "inledning" ;
  inledningsvis_ab_1 = mkAdv "inledningsvis" ;
  inljud_nn_1 = mkN "inljud" neutrum ;
  inlopp_nn_1 = mkN "inlopp" neutrum ;
  inmaetning_nn_1 = mkN "inmдtning" ;
  inmarsch_nn_1 = mkN "inmarsch" "inmarscher" ;
  inmatning_nn_1 = mkN "inmatning" ;
  inmoenstring_nn_1 = mkN "inmцnstring" ;
  inmutning_nn_1 = mkN "inmutning" ;
  innan_ab_1 = mkAdv "innan" ;
  innandoeme_nn_1 = mkN "innandцme" ;
  innanfoer_ab_1 = mkAdv "innanfцr" ;
  innanhav_nn_1 = mkN "innanhav" neutrum ;
  innanlaar_nn_1 = mkN "innanlеr" neutrum ;
  innanlaesning_nn_1 = mkN "innanlдsning" ;
  innanmaete_nn_1 = mkN "innanmдte" ;
  innantill_ab_1 = mkAdv "innantill" ;
  inne_ab_1 = mkAdv "inne" ;
  inne_av_1 = mkA "inne" ;
  inneboende_av_1 = mkA "inneboende" ;
  inneboerd_nn_1 = mkN "innebцrd" "innebцrder" ;
  innebyggare_nn_1 = mkN "innebyggare" "innebyggare" ;
  innegrej_nn_1 = mkN "innegrej" "innegrejer" ;
  innehaall_nn_1 = mkN "innehеll" neutrum ;
  innehaalla_vb_1 = mkV "innehеlla" "innehцll" "innehеllit" ;
  innehaallsanalys_nn_1 = mkN "innehеllsanalys" "innehеllsanalyser" ;
  innehaallsdeklaration_nn_1 = mkN "innehеllsdeklaration" "innehеllsdeklarationer" ;
  innehaallsfoerteckning_nn_1 = mkN "innehеllsfцrteckning" ;
  innehaallslig_av_1 = mkA "innehеllslig" ;
  innehaallsloes_av_1 = mkA "innehеllslцs" ;
  innehaallsobjekt_nn_1 = mkN "innehеllsobjekt" neutrum ;
  innehaallsoeversikt_nn_1 = mkN "innehеllsцversikt" "innehеllsцversikter" ;
  innehaallsrik_av_1 = mkA "innehеllsrik" ;
  innehaallstom_av_1 = mkA "innehеllstom" "innehеllstomt" "innehеllstomma" "innehеllstomma" "innehеllstommare" "innehеllstommast" "innehеllstommaste" ;
  innehav_nn_1 = mkN "innehav" neutrum ;
  innehavare_nn_1 = mkN "innehavare" "innehavare" ;
  innehavarpapper_nn_1 = mkN "innehavarpapper" neutrum ;
  inneliggande_av_1 = mkA "inneliggande" ;
  inner_nn_1 = mkN "inner" ;
  innerdoerr_nn_1 = mkN "innerdцrr" ;
  innerlig_av_1 = mkA "innerlig" ;
  innerligen_ab_1 = mkAdv "innerligen" ;
  inneroera_nn_1 = mkN "innerцra" "innerцrat" "innerцron" "innerцronen" ;
  innerskaer_nn_1 = mkN "innerskдr" neutrum ;
  innerslang_nn_1 = mkN "innerslang" ;
  innerstad_nn_1 = mkN "innerstad" "innerstдder" ;
  innertak_nn_1 = mkN "innertak" neutrum ;
  innervaegg_nn_1 = mkN "innervдgg" ;
  innervation_nn_1 = mkN "innervation" "innervationer" ;
  innesittare_nn_1 = mkN "innesittare" "innesittare" ;
  innesluta_vb_1 = mkV "innesluta" "inneslцt" "inneslutit" ;
  inneslutning_nn_1 = mkN "inneslutning" ;
  innestaaende_av_1 = mkA "innestеende" ;
  innevaanare_nn_1 = mkN "innevеnare" "innevеnare" ;
  innevarande_av_1 = mkA "innevarande" ;
  innoetning_nn_1 = mkN "innцtning" ;
  innovation_nn_1 = mkN "innovation" "innovationer" ;
  innovativ_av_1 = mkA "innovativ" ;
  innovatoer_nn_1 = mkN "innovatцr" "innovatцrer" ;
  inofficiell_av_1 = mkA "inofficiell" ;
  inokulation_nn_1 = mkN "inokulation" "inokulationer" ;
  inombordare_nn_1 = mkN "inombordare" "inombordare" ;
  inombords_ab_1 = mkAdv "inombords" ;
  inombordsmotor_nn_1 = mkN "inombordsmotor" "inombordsmotorer" ;
  inomhus_ab_1 = mkAdv "inomhus" ;
  inomhusforskning_nn_1 = mkN "inomhusforskning" ;
  inomhusgolv_nn_1 = mkN "inomhusgolv" neutrum ;
  inomhusidrott_nn_1 = mkN "inomhusidrott" "inomhusidrotter" ;
  inomhusluft_nn_1 = mkN "inomhusluft" "inomhuslufter" ;
  inomlands_ab_1 = mkAdv "inomlands" ;
  inomskaers_ab_1 = mkAdv "inomskдrs" ;
  inomvetenskaplig_av_1 = mkA "inomvetenskaplig" ;
  inopportun_av_1 = mkA "inopportun" ;
  inpackning_nn_1 = mkN "inpackning" ;
  inpass_nn_1 = mkN "inpass" neutrum ;
  inpetning_nn_1 = mkN "inpetning" ;
  inpiskare_nn_1 = mkN "inpiskare" "inpiskare" ;
  inpyrd_av_1 = mkA "inpyrd" "inpyrt" ;
  inraekning_nn_1 = mkN "inrдkning" ;
  inraettning_nn_1 = mkN "inrдttning" ;
  inramning_nn_1 = mkN "inramning" ;
  inredning_nn_1 = mkN "inredning" ;
  inredningsdetalj_nn_1 = mkN "inredningsdetalj" "inredningsdetaljer" ;
  inremedicinsk_av_1 = mkA "inremedicinsk" ;
  inremission_nn_1 = mkN "inremission" "inremissioner" ;
  inresekretorisk_av_1 = mkA "inresekretorisk" ;
  inresetillstaand_nn_1 = mkN "inresetillstеnd" neutrum ;
  inresevisum_nn_1 = mkN "inresevisum" neutrum ;
  inriggare_nn_1 = mkN "inriggare" "inriggare" ;
  inrikes_ab_1 = mkAdv "inrikes" ;
  inrikes_av_1 = mkA "inrikes" ;
  inrikesdepartement_nn_1 = mkN "inrikesdepartement" "inrikesdepartementet" "inrikesdepartementen" "inrikesdepartementena" ;
  inrikesminister_nn_1 = mkN "inrikesminister" ;
  inrikespolitisk_av_1 = mkA "inrikespolitisk" ;
  inriktning_nn_1 = mkN "inriktning" ;
  inrim_nn_1 = mkN "inrim" "inrimmet" "inrim" "inrimmen" ;
  inristning_nn_1 = mkN "inristning" ;
  inroestning_nn_1 = mkN "inrцstning" ;
  inrop_nn_1 = mkN "inrop" neutrum ;
  inropare_nn_1 = mkN "inropare" "inropare" ;
  inropning_nn_1 = mkN "inropning" ;
  inryckning_nn_1 = mkN "inryckning" ;
  insaendare_nn_1 = mkN "insдndare" "insдndare" ;
  insaettning_nn_1 = mkN "insдttning" ;
  insamling_nn_1 = mkN "insamling" ;
  insats_nn_1 = mkN "insats" "insatser" ;
  insatslaegenhet_nn_1 = mkN "insatslдgenhet" "insatslдgenheter" ;
  inscenering_nn_1 = mkN "inscenering" ;
  insegel_nn_1 = mkN "insegel" neutrum ;
  inseglingsfyr_nn_1 = mkN "inseglingsfyr" ;
  insekt_nn_1 = mkN "insekt" "insekter" ;
  insekticid_nn_1 = mkN "insekticid" "insekticider" ;
  insektsaetande_av_1 = mkA "insektsдtande" ;
  insektsaetare_nn_1 = mkN "insektsдtare" "insektsдtare" ;
  insektsbefruktning_nn_1 = mkN "insektsbefruktning" ;
  insektsbett_nn_1 = mkN "insektsbett" neutrum ;
  insektsgift_nn_1 = mkN "insektsgift" "insektsgiftet" "insektsgifter" "insektsgifterna" ;
  insektsmedel_nn_1 = mkN "insektsmedel" neutrum ;
  insektsnaal_nn_1 = mkN "insektsnеl" ;
  insektssamling_nn_1 = mkN "insektssamling" ;
  insektssax_nn_1 = mkN "insektssax" ;
  insemination_nn_1 = mkN "insemination" "inseminationer" ;
  insida_nn_1 = mkN "insida" ;
  insikt_nn_1 = mkN "insikt" "insikter" ;
  insiktsfull_av_1 = mkA "insiktsfull" ;
  insinuant_av_1 = mkA "insinuant" "insinuant" ;
  insinuation_nn_1 = mkN "insinuation" "insinuationer" ;
  insjoe_nn_1 = mkN "insjц" ;
  insjoefisk_nn_1 = mkN "insjцfisk" ;
  insjungning_nn_1 = mkN "insjungning" ;
  insjunken_av_1 = mkA "insjunken" "insjunket" ;
  inskaerning_nn_1 = mkN "inskдrning" ;
  inskjuta_vb_1 = mkV "inskjuta" "inskцt" "inskjutit" ;
  inskjutning_nn_1 = mkN "inskjutning" ;
  inskolning_nn_1 = mkN "inskolning" ;
  inskott_nn_1 = mkN "inskott" neutrum ;
  inskottsvokal_nn_1 = mkN "inskottsvokal" "inskottsvokaler" ;
  inskraenkning_nn_1 = mkN "inskrдnkning" ;
  inskraenkt_av_1 = mkA "inskrдnkt" "inskrдnkt" ;
  inskrift_nn_1 = mkN "inskrift" "inskrifter" ;
  inskription_nn_1 = mkN "inskription" "inskriptioner" ;
  inskriva_vb_1 = mkV "inskriva" "inskrev" "inskrivit" ;
  inskrivning_nn_1 = mkN "inskrivning" ;
  inskrivningsbok_nn_1 = mkN "inskrivningsbok" "inskrivningsbцcker" ;
  inskrivningsdomare_nn_1 = mkN "inskrivningsdomare" "inskrivningsdomare" ;
  inslaepp_nn_1 = mkN "inslдpp" neutrum ;
  inslag_nn_1 = mkN "inslag" neutrum ;
  inslagen_av_1 = mkA "inslagen" "inslaget" ;
  insmickrande_av_1 = mkA "insmickrande" ;
  insmuggling_nn_1 = mkN "insmuggling" ;
  insmyga_vb_1 = mkV "insmyga" "insmцg" "insmugit" ;
  insnitt_nn_1 = mkN "insnitt" neutrum ;
  insnodd_av_1 = mkA "insnodd" ;
  insoendring_nn_1 = mkN "insцndring" ;
  insolvent_av_1 = mkA "insolvent" "insolvent" ;
  inspark_nn_1 = mkN "inspark" ;
  inspektion_nn_1 = mkN "inspektion" "inspektioner" ;
  inspektoer_nn_1 = mkN "inspektцr" "inspektцrer" ;
  inspektor_nn_1 = mkN "inspektor" "inspektorer" ;
  inspelning_nn_1 = mkN "inspelning" ;
  inspelningsstudio_nn_1 = mkN "inspelningsstudio" "inspelningsstudior" ;
  inspicient_nn_1 = mkN "inspicient" "inspicienter" ;
  inspiration_nn_1 = mkN "inspiration" "inspirationer" ;
  inspiratoer_nn_1 = mkN "inspiratцr" "inspiratцrer" ;
  inspraengd_av_1 = mkA "insprдngd" "insprдngt" ;
  insprutning_nn_1 = mkN "insprutning" ;
  insprutningsmotor_nn_1 = mkN "insprutningsmotor" "insprutningsmotorer" ;
  instabil_av_1 = mkA "instabil" ;
  instaellbar_av_1 = mkA "instдllbar" ;
  instaellelse_nn_1 = mkN "instдllelse" "instдllelser" ;
  instaellning_nn_1 = mkN "instдllning" ;
  instaellsam_av_1 = mkA "instдllsam" "instдllsamt" "instдllsamma" "instдllsamma" "instдllsammare" "instдllsammast" "instдllsammaste" ;
  instaellsamhet_nn_1 = mkN "instдllsamhet" "instдllsamheter" ;
  instaemmande_nn_1 = mkN "instдmmande" ;
  instaengd_av_1 = mkA "instдngd" "instдngt" ;
  installand_nn_1 = mkN "installand" "installander" ;
  installation_nn_1 = mkN "installation" "installationer" ;
  installationsfoerelaesning_nn_1 = mkN "installationsfцrelдsning" ;
  installatoer_nn_1 = mkN "installatцr" "installatцrer" ;
  installator_nn_1 = mkN "installator" "installatorer" ;
  instans_nn_1 = mkN "instans" "instanser" ;
  instiftare_nn_1 = mkN "instiftare" "instiftare" ;
  instiftelse_nn_1 = mkN "instiftelse" "instiftelser" ;
  instinkt_nn_1 = mkN "instinkt" "instinkter" ;
  instinktiv_av_1 = mkA "instinktiv" ;
  institut_nn_1 = mkN "institut" neutrum ;
  institution_nn_1 = mkN "institution" "institutioner" ;
  institutionell_av_1 = mkA "institutionell" ;
  instraalning_nn_1 = mkN "instrеlning" ;
  instroem_nn_1 = mkN "instrцm" "instrцmmen" "instrцmmar" "instrцmmarna" ;
  instruktion_nn_1 = mkN "instruktion" "instruktioner" ;
  instruktiv_av_1 = mkA "instruktiv" ;
  instruktoer_nn_1 = mkN "instruktцr" "instruktцrer" ;
  instrument_nn_1 = mkN "instrument" neutrum ;
  instrumental_av_1 = mkA "instrumental" ;
  instrumentalist_nn_1 = mkN "instrumentalist" "instrumentalister" ;
  instrumentarium_nn_1 = mkN "instrumentarium" "instrumentariet" "instrumentarier" "instrumentarierna" ;
  instrumentation_nn_1 = mkN "instrumentation" "instrumentationer" ;
  instrumentell_av_1 = mkA "instrumentell" ;
  instrumentering_nn_1 = mkN "instrumentering" ;
  instrumentflygning_nn_1 = mkN "instrumentflygning" ;
  instrumentpanel_nn_1 = mkN "instrumentpanel" "instrumentpaneler" ;
  instudering_nn_1 = mkN "instudering" ;
  insufficiens_nn_1 = mkN "insufficiens" "insufficienser" ;
  insuga_vb_1 = mkV "insuga" "insцg" "insugit" ;
  insugningsventil_nn_1 = mkN "insugningsventil" "insugningsventiler" ;
  insulaer_av_1 = mkA "insulдr" ;
  insulin_nn_1 = mkN "insulin" "insuliner" ;
  insulinchock_nn_1 = mkN "insulinchock" "insulinchocker" ;
  insupa_vb_1 = mkV "insupa" "insцp" "insupit" ;
  insurgent_nn_1 = mkN "insurgent" "insurgenter" ;
  insvaengd_av_1 = mkA "insvдngd" "insvдngt" ;
  insvaengning_nn_1 = mkN "insvдngning" ;
  insydd_av_1 = mkA "insydd" ;
  inta_vb_1 = mkV "inta" "intar" "inta" "intog" "intagit" "intagen" ;
  intaag_nn_1 = mkN "intеg" neutrum ;
  intaekt_nn_1 = mkN "intдkt" "intдkter" ;
  intaektschablon_nn_1 = mkN "intдktschablon" "intдktschabloner" ;
  intag_nn_1 = mkN "intag" neutrum ;
  intagande_av_1 = mkA "intagande" ;
  intagen_av_1 = mkA "intagen" "intaget" ;
  intagning_nn_1 = mkN "intagning" ;
  intagsdamm_nn_1 = mkN "intagsdamm" ;
  intakt_av_1 = mkA "intakt" "intakt" ;
  intalan_nn_1 = mkN "intalan" "intalan" "intalanden" "intalandena" ;
  inte_ab_1 = mkAdv "inte" ;
  inteckning_nn_1 = mkN "inteckning" ;
  inteckningslaan_nn_1 = mkN "inteckningslеn" neutrum ;
  integral_nn_1 = mkN "integral" "integraler" ;
  integralkalkyl_nn_1 = mkN "integralkalkyl" "integralkalkyler" ;
  integrand_nn_1 = mkN "integrand" "integrander" ;
  integration_nn_1 = mkN "integration" "integrationer" ;
  integrerande_av_1 = mkA "integrerande" ;
  integrering_nn_1 = mkN "integrering" ;
  integritet_nn_1 = mkN "integritet" "integriteter" ;
  intellekt_nn_1 = mkN "intellekt" neutrum ;
  intellektualist_nn_1 = mkN "intellektualist" "intellektualister" ;
  intellektuell_av_1 = mkA "intellektuell" ;
  intelligens_nn_1 = mkN "intelligens" "intelligenser" ;
  intelligensaalder_nn_1 = mkN "intelligensеlder" ;
  intelligensaristokrat_nn_1 = mkN "intelligensaristokrat" "intelligensaristokrater" ;
  intelligenskvot_nn_1 = mkN "intelligenskvot" "intelligenskvoter" ;
  intelligensmaetning_nn_1 = mkN "intelligensmдtning" ;
  intelligenstest_nn_1 = mkN "intelligenstest" neutrum ;
  intelligent_av_1 = mkA "intelligent" "intelligent" ;
  intendent_nn_1 = mkN "intendent" "intendenter" ;
  intendentur_nn_1 = mkN "intendentur" "intendenturer" ;
  intendenturtjaenst_nn_1 = mkN "intendenturtjдnst" "intendenturtjдnster" ;
  intensitet_nn_1 = mkN "intensitet" "intensiteter" ;
  intensiv_av_1 = mkA "intensiv" ;
  intensiv_nn_1 = mkN "intensiv" "intensiver" ;
  intensivundersoekning_nn_1 = mkN "intensivundersцkning" ;
  intensivvaardsavdelning_nn_1 = mkN "intensivvеrdsavdelning" ;
  intention_nn_1 = mkN "intention" "intentioner" ;
  intentionsdjup_nn_1 = mkN "intentionsdjup" neutrum ;
  interaktion_nn_1 = mkN "interaktion" "interaktioner" ;
  interaktiv_av_1 = mkA "interaktiv" ;
  intercitytaag_nn_1 = mkN "intercitytеg" neutrum ;
  interdental_av_1 = mkA "interdental" ;
  interdental_nn_1 = mkN "interdental" "interdentaler" ;
  interdikt_nn_1 = mkN "interdikt" neutrum ;
  interferens_nn_1 = mkN "interferens" "interferenser" ;
  interferensmoenster_nn_1 = mkN "interferensmцnster" neutrum ;
  interglacial_av_1 = mkA "interglacial" ;
  interglacial_nn_1 = mkN "interglacial" "interglacialer" ;
  interimistisk_av_1 = mkA "interimistisk" ;
  interimsbevis_nn_1 = mkN "interimsbevis" neutrum ;
  interimsregering_nn_1 = mkN "interimsregering" ;
  interimsstyrelse_nn_1 = mkN "interimsstyrelse" "interimsstyrelser" ;
  interioer_nn_1 = mkN "interiцr" "interiцrer" ;
  interjektion_nn_1 = mkN "interjektion" "interjektioner" ;
  interkontinental_av_1 = mkA "interkontinental" ;
  interlokutoer_nn_1 = mkN "interlokutцr" "interlokutцrer" ;
  interludium_nn_1 = mkN "interludium" "interludiet" "interludier" "interludierna" ;
  intermezzo_nn_1 = mkN "intermezzo" "intermezzot" "intermezzon" "intermezzona" ;
  intermittent_av_1 = mkA "intermittent" "intermittent" ;
  intern_av_1 = mkA "intern" ;
  intern_nn_1 = mkN "intern" "interner" ;
  internat_nn_1 = mkN "internat" neutrum ;
  international_nn_1 = mkN "international" "internationaler" ;
  internationalist_nn_1 = mkN "internationalist" "internationalister" ;
  internationell_av_1 = mkA "internationell" ;
  internering_nn_1 = mkN "internering" ;
  interneringslaeger_nn_1 = mkN "interneringslдger" neutrum ;
  internist_nn_1 = mkN "internist" "internister" ;
  internordisk_av_1 = mkA "internordisk" ;
  internutbildning_nn_1 = mkN "internutbildning" ;
  interpellant_nn_1 = mkN "interpellant" "interpellanter" ;
  interpellation_nn_1 = mkN "interpellation" "interpellationer" ;
  interplanetarisk_av_1 = mkA "interplanetarisk" ;
  interpolation_nn_1 = mkN "interpolation" "interpolationer" ;
  interpret_nn_1 = mkN "interpret" "interpreter" ;
  interpretation_nn_1 = mkN "interpretation" "interpretationer" ;
  interregnum_nn_1 = mkN "interregnum" neutrum ;
  interrogativ_av_1 = mkA "interrogativ" ;
  interstellaer_av_1 = mkA "interstellдr" ;
  interurban_av_1 = mkA "interurban" ;
  intervall_nn_1 = mkN "intervall" neutrum ;
  intervention_nn_1 = mkN "intervention" "interventioner" ;
  intervju_nn_1 = mkN "intervju" "intervjun" "intervjuer" "intervjuerna" ;
  intervjuare_nn_1 = mkN "intervjuare" "intervjuare" ;
  intervjuoffer_nn_1 = mkN "intervjuoffer" neutrum ;
  intervjuundersoekning_nn_1 = mkN "intervjuundersцkning" ;
  intervokalisk_av_1 = mkA "intervokalisk" ;
  intestatarv_nn_1 = mkN "intestatarv" neutrum ;
  intetsaegande_av_1 = mkA "intetsдgande" ;
  intig_av_1 = mkA "intig" ;
  intighet_nn_1 = mkN "intighet" "intigheter" ;
  intill_ab_1 = mkAdv "intill" ;
  intilliggande_av_1 = mkA "intilliggande" ;
  intim_av_1 = mkA "intim" ;
  intimist_nn_1 = mkN "intimist" "intimister" ;
  intimitet_nn_1 = mkN "intimitet" "intimiteter" ;
  intjaenandetid_nn_1 = mkN "intjдnandetid" "intjдnandetider" ;
  intolerabel_av_1 = mkA "intolerabel" "intolerabelt" "intolerabla" "intolerabla" "intolerablare" "intolerablast" "intolerablaste" ;
  intolerant_av_1 = mkA "intolerant" "intolerant" ;
  intonation_nn_1 = mkN "intonation" "intonationer" ;
  intorkning_nn_1 = mkN "intorkning" ;
  intoxikation_nn_1 = mkN "intoxikation" "intoxikationer" ;
  intraede_nn_1 = mkN "intrдde" ;
  intraedesavgift_nn_1 = mkN "intrдdesavgift" "intrдdesavgifter" ;
  intraedesprov_nn_1 = mkN "intrдdesprov" neutrum ;
  intraedestal_nn_1 = mkN "intrдdestal" "intrдdestalet" "intrдdestalen" "intrдdestalena" ;
  intraengande_av_1 = mkA "intrдngande" ;
  intraengling_nn_1 = mkN "intrдngling" ;
  intransigent_av_1 = mkA "intransigent" "intransigent" ;
  intransitiv_av_1 = mkA "intransitiv" ;
  intravenoes_av_1 = mkA "intravenцs" ;
  intressant_av_1 = mkA "intressant" "intressant" ;
  intresse_nn_1 = mkN "intresse" ;
  intressegemenskap_nn_1 = mkN "intressegemenskap" "intressegemenskaper" ;
  intressegrupp_nn_1 = mkN "intressegrupp" "intressegrupper" ;
  intressekonflikt_nn_1 = mkN "intressekonflikt" "intressekonflikter" ;
  intresseloes_av_1 = mkA "intresselцs" ;
  intressent_nn_1 = mkN "intressent" "intressenter" ;
  intresseomraade_nn_1 = mkN "intresseomrеde" ;
  intresseorganisation_nn_1 = mkN "intresseorganisation" "intresseorganisationer" ;
  intressesfaer_nn_1 = mkN "intressesfдr" "intressesfдrer" ;
  intressevaeckande_av_1 = mkA "intressevдckande" ;
  intrig_nn_1 = mkN "intrig" "intriger" ;
  intrigant_av_1 = mkA "intrigant" "intrigant" ;
  intrigant_nn_1 = mkN "intrigant" "intriganter" ;
  intrigoer_nn_1 = mkN "intrigцr" "intrigцrer" ;
  intrikat_av_1 = mkA "intrikat" "intrikat" ;
  intrimning_nn_1 = mkN "intrimning" ;
  introduktion_nn_1 = mkN "introduktion" "introduktioner" ;
  introduktionsbrev_nn_1 = mkN "introduktionsbrev" neutrum ;
  introduktionserbjudande_nn_1 = mkN "introduktionserbjudande" ;
  introduktionskurs_nn_1 = mkN "introduktionskurs" "introduktionskurser" ;
  introduktoer_nn_1 = mkN "introduktцr" "introduktцrer" ;
  introspektiv_av_1 = mkA "introspektiv" ;
  introvert_av_1 = mkA "introvert" "introvert" ;
  intryck_nn_1 = mkN "intryck" neutrum ;
  intubation_nn_1 = mkN "intubation" "intubationer" ;
  intuition_nn_1 = mkN "intuition" "intuitioner" ;
  intuitiv_av_1 = mkA "intuitiv" ;
  intumning_nn_1 = mkN "intumning" ;
  intyg_nn_1 = mkN "intyg" neutrum ;
  inuit_nn_1 = mkN "inuit" "inuiter" ;
  inuti_ab_1 = mkAdv "inuti" ;
  invaanare_nn_1 = mkN "invеnare" "invеnare" ;
  invaegning_nn_1 = mkN "invдgning" ;
  invaendig_av_1 = mkA "invдndig" ;
  invaendning_nn_1 = mkN "invдndning" ;
  invaendningsfri_av_1 = mkA "invдndningsfri" "invдndningsfritt" ;
  invaertes_ab_1 = mkAdv "invдrtes" ;
  invaertes_av_1 = mkA "invдrtes" ;
  inval_nn_1 = mkN "inval" neutrum ;
  invalid_nn_1 = mkN "invalid" "invalider" ;
  invaliditet_nn_1 = mkN "invaliditet" "invaliditeter" ;
  invand_av_1 = mkA "invand" ;
  invandrare_nn_1 = mkN "invandrare" "invandrare" ;
  invandrarverk_nn_1 = mkN "invandrarverk" neutrum ;
  invandring_nn_1 = mkN "invandring" ;
  invandringskvot_nn_1 = mkN "invandringskvot" "invandringskvoter" ;
  invariabel_av_1 = mkA "invariabel" "invariabelt" "invariabla" "invariabla" "invariablare" "invariablast" "invariablaste" ;
  invariant_av_1 = mkA "invariant" "invariant" ;
  invasion_nn_1 = mkN "invasion" "invasioner" ;
  invektiv_nn_1 = mkN "invektiv" neutrum ;
  inventariebok_nn_1 = mkN "inventariebok" "inventariebцcker" ;
  inventariefoerteckning_nn_1 = mkN "inventariefцrteckning" ;
  inventarium_nn_1 = mkN "inventarium" "inventariet" "inventarier" "inventarierna" ;
  inventering_nn_1 = mkN "inventering" ;
  inventioes_av_1 = mkA "inventiцs" ;
  inverkning_nn_1 = mkN "inverkning" ;
  invers_nn_1 = mkN "invers" "inverser" ;
  inversion_nn_1 = mkN "inversion" "inversioner" ;
  invertebrat_nn_1 = mkN "invertebrat" "invertebrater" ;
  investerare_nn_1 = mkN "investerare" "investerare" ;
  investering_nn_1 = mkN "investering" ;
  investeringsbank_nn_1 = mkN "investeringsbank" "investeringsbanker" ;
  investeringsfond_nn_1 = mkN "investeringsfond" "investeringsfonder" ;
  investmentbolag_nn_1 = mkN "investmentbolag" neutrum ;
  invigning_nn_1 = mkN "invigning" ;
  invintring_nn_1 = mkN "invintring" ;
  invintringsprocess_nn_1 = mkN "invintringsprocess" "invintringsprocesser" ;
  invit_nn_1 = mkN "invit" "inviter" ;
  invitation_nn_1 = mkN "invitation" "invitationer" ;
  invokation_nn_1 = mkN "invokation" "invokationer" ;
  ioegonenfallande_av_1 = mkA "iцgonenfallande" ;
  ioegonfallande_av_1 = mkA "iцgonfallande" ;
  irakier_nn_1 = mkN "irakier" "irakiern" "irakier" "irakierna" ;
  irakisk_av_1 = mkA "irakisk" ;
  irakiska_nn_1 = mkN "irakiska" ;
  iranier_nn_1 = mkN "iranier" "iraniern" "iranier" "iranierna" ;
  iransk_av_1 = mkA "iransk" ;
  iranska_nn_2 = mkN "iranska" ;
  irer_nn_1 = mkN "irer" "irern" "irer" "irerna" ;
  iridiumlager_nn_1 = mkN "iridiumlager" neutrum ;
  iris_nn_1 = mkN "iris" ;
  irisblaendare_nn_1 = mkN "irisblдndare" "irisblдndare" ;
  irisk_av_1 = mkA "irisk" ;
  iriska_nn_2 = mkN "iriska" ;
  irlaendare_nn_1 = mkN "irlдndare" "irlдndare" ;
  irlaendsk_av_1 = mkA "irlдndsk" ;
  irlaendska_nn_2 = mkN "irlдndska" ;
  ironi_nn_1 = mkN "ironi" "ironier" ;
  ironiker_nn_1 = mkN "ironiker" "ironikern" "ironiker" "ironikerna" ;
  ironisk_av_1 = mkA "ironisk" ;
  irrationell_av_1 = mkA "irrationell" ;
  irrbloss_nn_1 = mkN "irrbloss" neutrum ;
  irreal_av_1 = mkA "irreal" ;
  irreguljaer_av_1 = mkA "irreguljдr" ;
  irrelevant_av_1 = mkA "irrelevant" "irrelevant" ;
  irreparabel_av_1 = mkA "irreparabel" "irreparabelt" "irreparabla" "irreparabla" "irreparablare" "irreparablast" "irreparablaste" ;
  irreversibel_av_1 = mkA "irreversibel" "irreversibelt" "irreversibla" "irreversibla" "irreversiblare" "irreversiblast" "irreversiblaste" ;
  irrfaerd_nn_1 = mkN "irrfдrd" "irrfдrder" ;
  irrgaang_nn_1 = mkN "irrgеng" ;
  irritabel_av_1 = mkA "irritabel" "irritabelt" "irritabla" "irritabla" "irritablare" "irritablast" "irritablaste" ;
  irritament_nn_1 = mkN "irritament" "irritamentet" "irritamenten" "irritamentena" ;
  irritation_nn_1 = mkN "irritation" "irritationer" ;
  irritationsmoment_nn_1 = mkN "irritationsmoment" neutrum ;
  irrlaera_nn_1 = mkN "irrlдra" ;
  irrlaerig_av_1 = mkA "irrlдrig" ;
  is_nn_1 = mkN "is" ;
  isaelv_nn_1 = mkN "isдlv" ;
  isaender_ab_1 = mkAdv "isдnder" ;
  isaer_ab_1 = mkAdv "isдr" ;
  isaettning_nn_1 = mkN "isдttning" ;
  isagogisk_av_1 = mkA "isagogisk" ;
  isbaelte_nn_1 = mkN "isbдlte" ;
  isberg_nn_1 = mkN "isberg" neutrum ;
  isbildning_nn_1 = mkN "isbildning" ;
  isbill_nn_1 = mkN "isbill" ;
  isbit_nn_1 = mkN "isbit" ;
  isbjoern_nn_1 = mkN "isbjцrn" ;
  isblaa_av_1 = mkA "isblе" "isblеtt" ;
  isblock_nn_1 = mkN "isblock" neutrum ;
  isboj_nn_1 = mkN "isboj" ;
  isbrodd_nn_1 = mkN "isbrodd" ;
  isbrytare_nn_1 = mkN "isbrytare" "isbrytare" ;
  isbrytning_nn_1 = mkN "isbrytning" ;
  iscensaettning_nn_1 = mkN "iscensдttning" ;
  ischiasnerv_nn_1 = mkN "ischiasnerv" "ischiasnerver" ;
  ischuri_nn_1 = mkN "ischuri" "ischurier" ;
  isdubb_nn_1 = mkN "isdubb" ;
  isfaagel_nn_1 = mkN "isfеgel" ;
  isflak_nn_1 = mkN "isflak" neutrum ;
  isfoerhaallande_nn_1 = mkN "isfцrhеllande" ;
  isfri_av_1 = mkA "isfri" "isfritt" ;
  isfront_nn_1 = mkN "isfront" "isfronter" ;
  isglass_nn_1 = mkN "isglass" ;
  ishall_nn_1 = mkN "ishall" ;
  ishav_nn_1 = mkN "ishav" neutrum ;
  ishockeyroer_nn_1 = mkN "ishockeyrцr" neutrum ;
  ishockeyspelare_nn_1 = mkN "ishockeyspelare" "ishockeyspelare" ;
  isig_av_1 = mkA "isig" ;
  isjakt_nn_1 = mkN "isjakt" "isjakter" ;
  iskall_av_1 = mkA "iskall" ;
  iskant_nn_1 = mkN "iskant" "iskanter" ;
  iskonvalj_nn_1 = mkN "iskonvalj" "iskonvaljer" ;
  iskorn_nn_1 = mkN "iskorn" neutrum ;
  iskravning_nn_1 = mkN "iskravning" ;
  iskristall_nn_1 = mkN "iskristall" "iskristaller" ;
  islaendare_nn_1 = mkN "islдndare" "islдndare" ;
  islaendsk_av_1 = mkA "islдndsk" ;
  islaendska_nn_2 = mkN "islдndska" ;
  islaenning_nn_1 = mkN "islдnning" ;
  islamisk_av_1 = mkA "islamisk" ;
  islamsk_av_1 = mkA "islamsk" ;
  islandslav_nn_1 = mkN "islandslav" ;
  islandssill_nn_1 = mkN "islandssill" ;
  islossning_nn_1 = mkN "islossning" ;
  ism_nn_1 = mkN "ism" "ismer" ;
  isobar_nn_1 = mkN "isobar" "isobarer" ;
  isogon_nn_1 = mkN "isogon" "isogoner" ;
  isolat_nn_1 = mkN "isolat" neutrum ;
  isolationistisk_av_1 = mkA "isolationistisk" ;
  isolator_nn_1 = mkN "isolator" "isolatorer" ;
  isolerband_nn_1 = mkN "isolerband" neutrum ;
  isolerglas_nn_1 = mkN "isolerglas" neutrum ;
  isolering_nn_1 = mkN "isolering" ;
  isoleringsavdelning_nn_1 = mkN "isoleringsavdelning" ;
  isoleringsband_nn_1 = mkN "isoleringsband" neutrum ;
  isoleringscell_nn_1 = mkN "isoleringscell" "isoleringsceller" ;
  isoleringsmaterial_nn_1 = mkN "isoleringsmaterial" neutrum ;
  isomer_av_1 = mkA "isomer" ;
  isomer_nn_1 = mkN "isomer" "isomerer" ;
  isomeri_nn_1 = mkN "isomeri" "isomerier" ;
  isomorf_av_1 = mkA "isomorf" ;
  isomorfi_nn_1 = mkN "isomorfi" "isomorfier" ;
  isooktan_nn_1 = mkN "isooktan" neutrum ;
  isoterm_nn_1 = mkN "isoterm" "isotermer" ;
  isotop_nn_1 = mkN "isotop" "isotoper" ;
  isperiod_nn_1 = mkN "isperiod" "isperioder" ;
  ispigg_nn_1 = mkN "ispigg" ;
  ispik_nn_1 = mkN "ispik" ;
  israeffla_nn_1 = mkN "isrдffla" ;
  israel_nn_1 = mkN "israel" "israeler" ;
  israelisk_av_1 = mkA "israelisk" ;
  israelit_nn_1 = mkN "israelit" "israeliter" ;
  israelitisk_av_1 = mkA "israelitisk" ;
  isrand_nn_1 = mkN "isrand" "isrдnder" ;
  isranunkel_nn_1 = mkN "isranunkel" ;
  israpport_nn_1 = mkN "israpport" "israpporter" ;
  isrevy_nn_1 = mkN "isrevy" "isrevyer" ;
  issjoe_nn_1 = mkN "issjц" ;
  isskruvning_nn_1 = mkN "isskruvning" ;
  issmaeltning_nn_1 = mkN "issmдltning" ;
  istadig_av_1 = mkA "istadig" ;
  istaecke_nn_1 = mkN "istдcke" ;
  istaeckt_av_1 = mkA "istдckt" "istдckt" ;
  istaellet_ab_1 = mkAdv "istдllet" ;
  istapp_nn_1 = mkN "istapp" ;
  isterband_nn_1 = mkN "isterband" neutrum ;
  isterbuk_nn_1 = mkN "isterbuk" ;
  istid_nn_1 = mkN "istid" "istider" ;
  istidsforskare_nn_1 = mkN "istidsforskare" "istidsforskare" ;
  istryck_nn_1 = mkN "istryck" neutrum ;
  isvak_nn_1 = mkN "isvak" ;
  italer_nn_1 = mkN "italer" "italern" "italer" "italerna" ;
  italienare_nn_1 = mkN "italienare" "italienare" ;
  italiensk_av_1 = mkA "italiensk" ;
  italienska_nn_2 = mkN "italienska" ;
  italiker_nn_1 = mkN "italiker" "italikern" "italiker" "italikerna" ;
  italisk_av_1 = mkA "italisk" ;
  iteration_nn_1 = mkN "iteration" "iterationer" ;
  iterativ_av_1 = mkA "iterativ" ;
  itu_ab_1 = mkAdv "itu" ;
  ity_ab_1 = mkAdv "ity" ;
  ivaeg_ab_1 = mkAdv "ivдg" ;
  ivorian_nn_1 = mkN "ivorian" "ivorianer" ;
  ivoriansk_av_1 = mkA "ivoriansk" ;
  ivrande_nn_1 = mkN "ivrande" ;
  ivrare_nn_1 = mkN "ivrare" "ivrare" ;
  ivrig_av_1 = mkA "ivrig" ;
  ja_nn_1 = mkN "ja" "jaet" "jan" "jana" ;
  jaakk_nn_1 = mkN "jеkk" ;
  jab_nn_1 = mkN "jab" "jabben" "jabbar" "jabbarna" ;
  jabot_nn_1 = mkN "jabot" "jaboter" ;
  jack_nn_1 = mkN "jack" neutrum ;
  jack_nn_2 = mkN "jack" ;
  jackett_nn_1 = mkN "jackett" "jacketter" ;
  jackig_av_1 = mkA "jackig" ;
  jackpot_nn_1 = mkN "jackpot" ;
  jackpropp_nn_1 = mkN "jackpropp" ;
  jackuttag_nn_1 = mkN "jackuttag" neutrum ;
  jadegroen_av_1 = mkA "jadegrцn" ;
  jaedra_av_1 = mkA "jдdra" ;
  jaedrans_av_1 = mkA "jдdrans" ;
  jaegarbiff_nn_1 = mkN "jдgarbiff" ;
  jaegare_nn_1 = mkN "jдgare" "jдgare" ;
  jaegarfolk_nn_1 = mkN "jдgarfolk" neutrum ;
  jaegarhatt_nn_1 = mkN "jдgarhatt" ;
  jaegarhorn_nn_1 = mkN "jдgarhorn" neutrum ;
  jaegmaestare_nn_1 = mkN "jдgmдstare" "jдgmдstare" ;
  jaekel_nn_1 = mkN "jдkel" ;
  jaekelskap_nn_1 = mkN "jдkelskap" "jдkelskaper" ;
  jaekla_av_1 = mkA "jдkla" ;
  jaeklig_av_1 = mkA "jдklig" ;
  jaektig_av_1 = mkA "jдktig" ;
  jaemboerdig_av_1 = mkA "jдmbцrdig" ;
  jaemfoerande_av_1 = mkA "jдmfцrande" ;
  jaemfoerbar_av_1 = mkA "jдmfцrbar" ;
  jaemfoerelse_nn_1 = mkN "jдmfцrelse" "jдmfцrelser" ;
  jaemfoerelsetal_nn_1 = mkN "jдmfцrelsetal" "jдmfцrelsetalet" "jдmfцrelsetalen" "jдmfцrelsetalena" ;
  jaemfoerelsevis_ab_1 = mkAdv "jдmfцrelsevis" ;
  jaemfoerlig_av_1 = mkA "jдmfцrlig" ;
  jaemfoerpris_nn_1 = mkN "jдmfцrpris" neutrum ;
  jaemfota_ab_1 = mkAdv "jдmfota" ;
  jaemgod_av_1 = mkA "jдmgod" ;
  jaemkning_nn_1 = mkN "jдmkning" ;
  jaemlik_av_1 = mkA "jдmlik" ;
  jaemlike_nn_1 = mkN "jдmlike" utrum ;
  jaemlikhet_nn_1 = mkN "jдmlikhet" "jдmlikheter" ;
  jaemmerdal_nn_1 = mkN "jдmmerdal" ;
  jaemmerlig_av_1 = mkA "jдmmerlig" ;
  jaemn_av_1 = mkA "jдmn" ;
  jaemnaarig_av_1 = mkA "jдmnеrig" ;
  jaemngod_av_1 = mkA "jдmngod" ;
  jaemnstark_av_1 = mkA "jдmnstark" ;
  jaemnstor_av_1 = mkA "jдmnstor" ;
  jaemntjock_av_1 = mkA "jдmntjock" ;
  jaemnvarm_av_1 = mkA "jдmnvarm" ;
  jaems_ab_1 = mkAdv "jдms" ;
  jaemsides_ab_1 = mkAdv "jдmsides" ;
  jaemspelt_av_1 = mkA "jдmspelt" "jдmspelt" ;
  jaemstaelld_av_1 = mkA "jдmstдlld" "jдmstдllt" ;
  jaemstaelldhet_nn_1 = mkN "jдmstдlldhet" "jдmstдlldheter" ;
  jaemstark_av_1 = mkA "jдmstark" ;
  jaemt_ab_1 = mkAdv "jдmt" ;
  jaemte_nn_1 = mkN "jдmte" utrum ;
  jaemthund_nn_1 = mkN "jдmthund" ;
  jaemtjock_av_1 = mkA "jдmtjock" ;
  jaemtlaendsk_av_1 = mkA "jдmtlдndsk" ;
  jaemtlaenning_nn_1 = mkN "jдmtlдnning" ;
  jaemtsk_av_1 = mkA "jдmtsk" ;
  jaemvael_ab_1 = mkAdv "jдmvдl" ;
  jaemviktslaege_nn_1 = mkN "jдmviktslдge" ;
  jaemviktsorgan_nn_1 = mkN "jдmviktsorgan" neutrum ;
  jaenkare_nn_1 = mkN "jдnkare" "jдnkare" ;
  jaern_nn_1 = mkN "jдrn" neutrum ;
  jaernaaldersbonde_nn_1 = mkN "jдrnеldersbonde" "jдrnеldersbцnder" ;
  jaernaaldersbygd_nn_1 = mkN "jдrnеldersbygd" "jдrnеldersbygder" ;
  jaernaaldersfiskare_nn_1 = mkN "jдrnеldersfiskare" "jдrnеldersfiskare" ;
  jaernaar_nn_1 = mkN "jдrnеr" neutrum ;
  jaernaffaer_nn_1 = mkN "jдrnaffдr" "jдrnaffдrer" ;
  jaernbakterie_nn_1 = mkN "jдrnbakterie" "jдrnbakterier" ;
  jaernbalk_nn_1 = mkN "jдrnbalk" ;
  jaernbeslag_nn_1 = mkN "jдrnbeslag" neutrum ;
  jaernblad_nn_1 = mkN "jдrnblad" neutrum ;
  jaernbroellop_nn_1 = mkN "jдrnbrцllop" neutrum ;
  jaernbruk_nn_1 = mkN "jдrnbruk" neutrum ;
  jaernek_nn_1 = mkN "jдrnek" ;
  jaernfoeremaal_nn_1 = mkN "jдrnfцremеl" neutrum ;
  jaernframstaellning_nn_1 = mkN "jдrnframstдllning" ;
  jaerngrepp_nn_1 = mkN "jдrngrepp" neutrum ;
  jaernhaard_av_1 = mkA "jдrnhеrd" "jдrnhеrt" ;
  jaernhake_nn_1 = mkN "jдrnhake" utrum ;
  jaernhand_nn_1 = mkN "jдrnhand" "jдrnhдnder" ;
  jaernhandel_nn_1 = mkN "jдrnhandel" ;
  jaernhantering_nn_1 = mkN "jдrnhantering" ;
  jaernindustri_nn_1 = mkN "jдrnindustri" "jдrnindustrier" ;
  jaernjungfru_nn_1 = mkN "jдrnjungfru" "jдrnjungfrun" "jдrnjungfrur" "jдrnjungfrurna" ;
  jaernkatastrof_nn_1 = mkN "jдrnkatastrof" "jдrnkatastrofer" ;
  jaernklump_nn_1 = mkN "jдrnklump" ;
  jaernkors_nn_1 = mkN "jдrnkors" neutrum ;
  jaernlegering_nn_1 = mkN "jдrnlegering" ;
  jaernmalm_nn_1 = mkN "jдrnmalm" "jдrnmalmer" ;
  jaernmanufaktur_nn_1 = mkN "jдrnmanufaktur" "jдrnmanufakturer" ;
  jaernnatt_nn_1 = mkN "jдrnnatt" "jдrnnдtter" ;
  jaernoert_nn_1 = mkN "jдrnцrt" "jдrnцrter" ;
  jaernoxid_nn_1 = mkN "jдrnoxid" "jдrnoxider" ;
  jaernpinne_nn_1 = mkN "jдrnpinne" utrum ;
  jaernplaat_nn_1 = mkN "jдrnplеt" ;
  jaernproduktion_nn_1 = mkN "jдrnproduktion" "jдrnproduktioner" ;
  jaernredskap_nn_1 = mkN "jдrnredskap" "jдrnredskapet" "jдrnredskapen" "jдrnredskapena" ;
  jaernridaa_nn_1 = mkN "jдrnridе" "jдrnridеer" ;
  jaernrik_av_1 = mkA "jдrnrik" ;
  jaernring_nn_1 = mkN "jдrnring" ;
  jaernsalt_nn_1 = mkN "jдrnsalt" "jдrnsaltet" "jдrnsalter" "jдrnsalterna" ;
  jaernsparv_nn_1 = mkN "jдrnsparv" ;
  jaernspis_nn_1 = mkN "jдrnspis" ;
  jaernstaang_nn_1 = mkN "jдrnstеng" "jдrnstдnger" ;
  jaernstag_nn_1 = mkN "jдrnstag" neutrum ;
  jaernsulfid_nn_1 = mkN "jдrnsulfid" "jдrnsulfider" ;
  jaerntillverkning_nn_1 = mkN "jдrntillverkning" ;
  jaerntraad_nn_1 = mkN "jдrntrеd" ;
  jaernvaeg_nn_1 = mkN "jдrnvдg" ;
  jaernvaegare_nn_1 = mkN "jдrnvдgare" "jдrnvдgare" ;
  jaernvaegsbiljett_nn_1 = mkN "jдrnvдgsbiljett" "jдrnvдgsbiljetter" ;
  jaernvaegsknut_nn_1 = mkN "jдrnvдgsknut" ;
  jaernvaegsoevergaang_nn_1 = mkN "jдrnvдgsцvergеng" ;
  jaernvaegsraels_nn_1 = mkN "jдrnvдgsrдls" ;
  jaernvaegssignal_nn_1 = mkN "jдrnvдgssignal" "jдrnvдgssignaler" ;
  jaernvaegsspaar_nn_1 = mkN "jдrnvдgsspеr" neutrum ;
  jaernvaegsstation_nn_1 = mkN "jдrnvдgsstation" "jдrnvдgsstationer" ;
  jaernvaegstjaensteman_nn_1 = mkN "jдrnvдgstjдnsteman" "jдrnvдgstjдnstemannen" "jдrnvдgstjдnstemдn" "jдrnvдgstjдnstemдnnen" ;
  jaernvaegsvagn_nn_1 = mkN "jдrnvдgsvagn" ;
  jaernvapen_nn_1 = mkN "jдrnvapen" "jдrnvapnet" "jдrnvapen" "jдrnvapnen" ;
  jaernvara_nn_1 = mkN "jдrnvara" ;
  jaernvaruaffaer_nn_1 = mkN "jдrnvaruaffдr" "jдrnvaruaffдrer" ;
  jaernverk_nn_1 = mkN "jдrnverk" neutrum ;
  jaerpe_nn_1 = mkN "jдrpe" utrum ;
  jaertecken_nn_1 = mkN "jдrtecken" "jдrtecknet" "jдrtecken" "jдrtecknen" ;
  jaerv_nn_1 = mkN "jдrv" ;
  jaesig_av_1 = mkA "jдsig" ;
  jaesning_nn_1 = mkN "jдsning" ;
  jaestsvamp_nn_1 = mkN "jдstsvamp" ;
  jaette_nn_1 = mkN "jдtte" utrum ;
  jaettebra_av_1 = mkA "jдttebra" ;
  jaettedum_av_1 = mkA "jдttedum" "jдttedumt" "jдttedumma" "jдttedumma" "jдttedummare" "jдttedummast" "jдttedummaste" ;
  jaettekast_nn_1 = mkN "jдttekast" neutrum ;
  jaettelaenge_ab_1 = mkAdv "jдttelдnge" ;
  jaettelik_av_1 = mkA "jдttelik" ;
  jaetteorm_nn_1 = mkN "jдtteorm" ;
  jaettesnaell_av_1 = mkA "jдttesnдll" ;
  jaettesnygg_av_1 = mkA "jдttesnygg" ;
  jaetteval_nn_1 = mkN "jдtteval" ;
  jaettinna_nn_1 = mkN "jдttinna" ;
  jaev_nn_1 = mkN "jдv" neutrum ;
  jaevel_nn_1 = mkN "jдvel" ;
  jaevelskap_nn_1 = mkN "jдvelskap" "jдvelskapet" "jдvelskapen" "jдvelskapena" ;
  jaevig_av_1 = mkA "jдvig" ;
  jaevla_av_1 = mkA "jдvla" ;
  jaevlig_av_1 = mkA "jдvlig" ;
  jag_nn_1 = mkN "jag" neutrum ;
  jagare_nn_1 = mkN "jagare" "jagare" ;
  jagfoerestaellning_nn_1 = mkN "jagfцrestдllning" ;
  jaggernaut_nn_1 = mkN "jaggernaut" ;
  jagisk_av_1 = mkA "jagisk" ;
  jagsvaghet_nn_1 = mkN "jagsvaghet" "jagsvagheter" ;
  jaguar_nn_1 = mkN "jaguar" "jaguarer" ;
  jak_nn_1 = mkN "jak" ;
  jakande_av_1 = mkA "jakande" ;
  jakobin_nn_1 = mkN "jakobin" "jakobiner" ;
  jakobskamp_nn_1 = mkN "jakobskamp" "jakobskamper" ;
  jakobsstege_nn_1 = mkN "jakobsstege" utrum ;
  jakt_nn_1 = mkN "jakt" "jakter" ;
  jaktbar_av_1 = mkA "jaktbar" ;
  jaktbyte_nn_1 = mkN "jaktbyte" ;
  jaktexpedition_nn_1 = mkN "jaktexpedition" "jaktexpeditioner" ;
  jaktfalk_nn_1 = mkN "jaktfalk" ;
  jaktgevaer_nn_1 = mkN "jaktgevдr" neutrum ;
  jakthistoria_nn_1 = mkN "jakthistoria" "jakthistorien" "jakthistorier" "jakthistorierna" ;
  jakthorn_nn_1 = mkN "jakthorn" neutrum ;
  jakthund_nn_1 = mkN "jakthund" ;
  jaktkort_nn_1 = mkN "jaktkort" neutrum ;
  jaktlag_nn_1 = mkN "jaktlag" neutrum ;
  jaktleopard_nn_1 = mkN "jaktleopard" "jaktleoparder" ;
  jaktlig_av_1 = mkA "jaktlig" ;
  jaktlopp_nn_1 = mkN "jaktlopp" neutrum ;
  jaktmark_nn_1 = mkN "jaktmark" "jaktmarker" ;
  jaktplan_nn_1 = mkN "jaktplan" neutrum ;
  jaktprov_nn_1 = mkN "jaktprov" neutrum ;
  jaktridning_nn_1 = mkN "jaktridning" ;
  jaktrobot_nn_1 = mkN "jaktrobot" ;
  jaktsignal_nn_1 = mkN "jaktsignal" "jaktsignaler" ;
  jaktslott_nn_1 = mkN "jaktslott" neutrum ;
  jaktspaar_nn_1 = mkN "jaktspеr" neutrum ;
  jaktspindel_nn_1 = mkN "jaktspindel" ;
  jakttabell_nn_1 = mkN "jakttabell" "jakttabeller" ;
  jakttid_nn_1 = mkN "jakttid" "jakttider" ;
  jakttrofe_nn_1 = mkN "jakttrofй" "jakttrofйer" ;
  jaktvapen_nn_1 = mkN "jaktvapen" "jaktvapnet" "jaktvapen" "jaktvapnen" ;
  jalu_av_1 = mkA "jalu" ;
  jalusi_nn_1 = mkN "jalusi" "jalusier" ;
  jamaican_nn_1 = mkN "jamaican" "jamaicaner" ;
  jamaicansk_av_1 = mkA "jamaicansk" ;
  jamare_nn_1 = mkN "jamare" "jamare" ;
  jamb_nn_1 = mkN "jamb" "jamber" ;
  jambisk_av_1 = mkA "jambisk" ;
  jamboree_nn_1 = mkN "jamboree" "jamboreer" ;
  jan_nn_1 = mkN "jan" ;
  janitsjar_nn_1 = mkN "janitsjar" "janitsjarer" ;
  japan_nn_1 = mkN "japan" "japaner" ;
  japanes_nn_1 = mkN "japanes" "japaneser" ;
  japansk_av_1 = mkA "japansk" ;
  japanska_nn_2 = mkN "japanska" ;
  japroposition_nn_1 = mkN "japroposition" "japropositioner" ;
  jardinjaer_nn_1 = mkN "jardinjдr" "jardinjдrer" ;
  jargong_nn_1 = mkN "jargong" "jargonger" ;
  jarl_nn_1 = mkN "jarl" ;
  jarop_nn_1 = mkN "jarop" neutrum ;
  jasaegare_nn_1 = mkN "jasдgare" "jasдgare" ;
  jasmin_nn_1 = mkN "jasmin" "jasminer" ;
  jaspis_nn_1 = mkN "jaspis" ;
  javan_nn_1 = mkN "javan" "javaner" ;
  javanes_nn_1 = mkN "javanes" "javaneser" ;
  javanesisk_av_1 = mkA "javanesisk" ;
  javansk_av_1 = mkA "javansk" ;
  jazzbalett_nn_1 = mkN "jazzbalett" "jazzbaletter" ;
  jazzig_av_1 = mkA "jazzig" ;
  jazzorkester_nn_1 = mkN "jazzorkester" ;
  jeep_nn_1 = mkN "jeep" ;
  jehu_nn_1 = mkN "jehu" "jehut" "jehun" "jehuna" ;
  jeppe_nn_1 = mkN "jeppe" utrum ;
  jeremiad_nn_1 = mkN "jeremiad" "jeremiader" ;
  jerseyko_nn_1 = mkN "jerseyko" "jerseykor" ;
  jesuit_nn_1 = mkN "jesuit" "jesuiter" ;
  jesuitgeneral_nn_1 = mkN "jesuitgeneral" "jesuitgeneraler" ;
  jesuitisk_av_1 = mkA "jesuitisk" ;
  jesuitorden_nn_1 = mkN "jesuitorden" ;
  jetflygplan_nn_1 = mkN "jetflygplan" neutrum ;
  jetmotor_nn_1 = mkN "jetmotor" "jetmotorer" ;
  jetong_nn_1 = mkN "jetong" "jetonger" ;
  jetplan_nn_1 = mkN "jetplan" neutrum ;
  jetstroem_nn_1 = mkN "jetstrцm" "jetstrцmmen" "jetstrцmmar" "jetstrцmmarna" ;
  jig_nn_1 = mkN "jig" ;
  jigg_nn_1 = mkN "jigg" ;
  jingoism_nn_1 = mkN "jingoism" "jingoismer" ;
  jippo_nn_1 = mkN "jippo" "jippot" "jippon" "jippona" ;
  jobb_nn_1 = mkN "jobb" neutrum ;
  jobbare_nn_1 = mkN "jobbare" "jobbare" ;
  jobberi_nn_1 = mkN "jobberi" "jobberit" "jobberier" "jobberierna" ;
  jobbig_av_1 = mkA "jobbig" ;
  jobspost_nn_1 = mkN "jobspost" "jobsposter" ;
  jockej_nn_1 = mkN "jockej" "jockejer" ;
  jockey_nn_1 = mkN "jockey" ;
  jodtablett_nn_1 = mkN "jodtablett" "jodtabletter" ;
  joekel_nn_1 = mkN "jцkel" ;
  joekelport_nn_1 = mkN "jцkelport" ;
  joens_nn_1 = mkN "jцns" ;
  joensig_av_1 = mkA "jцnsig" ;
  joesse_nn_1 = mkN "jцsse" utrum ;
  johannesoert_nn_1 = mkN "johannesцrt" "johannesцrter" ;
  johannit_nn_1 = mkN "johannit" "johanniter" ;
  johanniterkors_nn_1 = mkN "johanniterkors" neutrum ;
  johanniterorden_nn_1 = mkN "johanniterorden" ;
  joint_nn_1 = mkN "joint" "jointer" ;
  jojk_nn_1 = mkN "jojk" ;
  jojo_nn_1 = mkN "jojo" ;
  joker_nn_1 = mkN "joker" ;
  jokk_nn_1 = mkN "jokk" ;
  jolle_nn_1 = mkN "jolle" utrum ;
  jolmig_av_1 = mkA "jolmig" ;
  jolster_nn_1 = mkN "jolster" ;
  jon_nn_1 = mkN "jon" "joner" ;
  jonbildning_nn_1 = mkN "jonbildning" ;
  jonbindning_nn_1 = mkN "jonbindning" ;
  jonbytare_nn_1 = mkN "jonbytare" "jonbytare" ;
  jonflaeck_nn_1 = mkN "jonflдck" ;
  jonfoerening_nn_1 = mkN "jonfцrening" ;
  jongitter_nn_1 = mkN "jongitter" neutrum ;
  jongloer_nn_1 = mkN "jonglцr" "jonglцrer" ;
  jonier_nn_1 = mkN "jonier" "joniern" "jonier" "jonierna" ;
  jonisation_nn_1 = mkN "jonisation" "jonisationer" ;
  jonisering_nn_1 = mkN "jonisering" ;
  joniseringsenergi_nn_1 = mkN "joniseringsenergi" "joniseringsenergier" ;
  joniseringstendens_nn_1 = mkN "joniseringstendens" "joniseringstendenser" ;
  jonisk_av_1 = mkA "jonisk" ;
  jonkvill_nn_1 = mkN "jonkvill" "jonkviller" ;
  jonstraale_nn_1 = mkN "jonstrеle" utrum ;
  jord_nn_1 = mkN "jord" ;
  jordabalk_nn_1 = mkN "jordabalk" ;
  jordaegare_nn_1 = mkN "jordдgare" "jordдgare" ;
  jordafaerd_nn_1 = mkN "jordafдrd" "jordafдrder" ;
  jordagods_nn_1 = mkN "jordagods" neutrum ;
  jordanalys_nn_1 = mkN "jordanalys" "jordanalyser" ;
  jordande_nn_1 = mkN "jordande" utrum ;
  jordanier_nn_1 = mkN "jordanier" "jordaniern" "jordanier" "jordanierna" ;
  jordansk_av_1 = mkA "jordansk" ;
  jordart_nn_1 = mkN "jordart" "jordarter" ;
  jordartsmetall_nn_1 = mkN "jordartsmetall" "jordartsmetaller" ;
  jordatmosfaer_nn_1 = mkN "jordatmosfдr" "jordatmosfдrer" ;
  jordavsoendring_nn_1 = mkN "jordavsцndring" ;
  jordbaevning_nn_1 = mkN "jordbдvning" ;
  jordbegravning_nn_1 = mkN "jordbegravning" ;
  jordbi_nn_1 = mkN "jordbi" "jordbit" "jordbin" "jordbien" ;
  jordblad_nn_1 = mkN "jordblad" neutrum ;
  jordbruk_nn_1 = mkN "jordbruk" neutrum ;
  jordbrukare_nn_1 = mkN "jordbrukare" "jordbrukare" ;
  jordbruksbebyggelse_nn_1 = mkN "jordbruksbebyggelse" "jordbruksbebyggelser" ;
  jordbruksbefolkning_nn_1 = mkN "jordbruksbefolkning" ;
  jordbruksbygd_nn_1 = mkN "jordbruksbygd" "jordbruksbygder" ;
  jordbrukslandskap_nn_1 = mkN "jordbrukslandskap" "jordbrukslandskapet" "jordbrukslandskapen" "jordbrukslandskapena" ;
  jordbruksmark_nn_1 = mkN "jordbruksmark" "jordbruksmarker" ;
  jordbruksmaskin_nn_1 = mkN "jordbruksmaskin" "jordbruksmaskiner" ;
  jordbruksminister_nn_1 = mkN "jordbruksminister" ;
  jordbruksprodukt_nn_1 = mkN "jordbruksprodukt" "jordbruksprodukter" ;
  jordbruksredskap_nn_1 = mkN "jordbruksredskap" "jordbruksredskapet" "jordbruksredskapen" "jordbruksredskapena" ;
  jordbunden_av_1 = mkA "jordbunden" "jordbundet" ;
  jorddelning_nn_1 = mkN "jorddelning" ;
  jorddrott_nn_1 = mkN "jorddrott" ;
  jordebok_nn_1 = mkN "jordebok" "jordebцcker" ;
  jordegendom_nn_1 = mkN "jordegendom" ;
  jordekorre_nn_1 = mkN "jordekorre" utrum ;
  jorden_runt_seglare_nn_1 = mkN "jorden-runt-seglare" "jorden-runt-seglare" ;
  jordfaerg_nn_1 = mkN "jordfдrg" "jordfдrger" ;
  jordfaergaemne_nn_1 = mkN "jordfдrgдmne" ;
  jordfaestning_nn_1 = mkN "jordfдstning" ;
  jordfast_av_1 = mkA "jordfast" "jordfast" ;
  jordfly_nn_1 = mkN "jordfly" "jordflyt" "jordflyn" "jordflyen" ;
  jordfraes_nn_1 = mkN "jordfrдs" ;
  jordgeting_nn_1 = mkN "jordgeting" ;
  jordglob_nn_1 = mkN "jordglob" "jordglober" ;
  jordgolv_nn_1 = mkN "jordgolv" neutrum ;
  jordgubbe_nn_1 = mkN "jordgubbe" utrum ;
  jordgubbssaft_nn_1 = mkN "jordgubbssaft" "jordgubbssafter" ;
  jordig_av_1 = mkA "jordig" ;
  jordisk_av_1 = mkA "jordisk" ;
  jordkabel_nn_1 = mkN "jordkabel" ;
  jordkaellare_nn_1 = mkN "jordkдllare" "jordkдllare" ;
  jordlager_nn_1 = mkN "jordlager" neutrum ;
  jordledning_nn_1 = mkN "jordledning" ;
  jordlik_av_1 = mkA "jordlik" ;
  jordloepare_nn_1 = mkN "jordlцpare" "jordlцpare" ;
  jordlott_nn_1 = mkN "jordlott" "jordlotter" ;
  jordmateria_nn_1 = mkN "jordmateria" "jordmaterian" "jordmaterier" "jordmaterierna" ;
  jordmaterial_nn_1 = mkN "jordmaterial" neutrum ;
  jordmetall_nn_1 = mkN "jordmetall" "jordmetaller" ;
  jordnaera_av_1 = mkA "jordnдra" ;
  jordnoet_nn_1 = mkN "jordnцt" "jordnцtter" ;
  jordomraade_nn_1 = mkN "jordomrеde" ;
  jordpartikel_nn_1 = mkN "jordpartikel" ;
  jordreform_nn_1 = mkN "jordreform" "jordreformer" ;
  jordregister_nn_1 = mkN "jordregister" neutrum ;
  jordrotation_nn_1 = mkN "jordrotation" "jordrotationer" ;
  jordskalv_nn_1 = mkN "jordskalv" neutrum ;
  jordskott_nn_1 = mkN "jordskott" neutrum ;
  jordskred_nn_1 = mkN "jordskred" neutrum ;
  jordskredsseger_nn_1 = mkN "jordskredsseger" ;
  jordskyld_nn_1 = mkN "jordskyld" "jordskylder" ;
  jordstam_nn_1 = mkN "jordstam" "jordstammen" "jordstammar" "jordstammarna" ;
  jordstoet_nn_1 = mkN "jordstцt" ;
  jordstroem_nn_1 = mkN "jordstrцm" "jordstrцmmen" "jordstrцmmar" "jordstrцmmarna" ;
  jordsvin_nn_1 = mkN "jordsvin" neutrum ;
  jordtaekt_nn_1 = mkN "jordtдkt" "jordtдkter" ;
  jordtag_nn_1 = mkN "jordtag" neutrum ;
  jordtroetthet_nn_1 = mkN "jordtrцtthet" "jordtrцttheter" ;
  jordvaerdestegring_nn_1 = mkN "jordvдrdestegring" ;
  jordvall_nn_1 = mkN "jordvall" ;
  jos_nn_1 = mkN "jos" "joser" ;
  joule_nn_1 = mkN "joule" "joulen" "joule" "joulena" ;
  jour_nn_1 = mkN "jour" "jourer" ;
  jourbutik_nn_1 = mkN "jourbutik" "jourbutiker" ;
  jourhavande_av_1 = mkA "jourhavande" ;
  jourhavande_nn_1 = mkN "jourhavande" "jourhavanden" "jourhavande" "jourhavandena" ;
  journal_nn_1 = mkN "journal" "journaler" ;
  journalfilm_nn_1 = mkN "journalfilm" "journalfilmer" ;
  journalist_nn_1 = mkN "journalist" "journalister" ;
  journalistisk_av_1 = mkA "journalistisk" ;
  jovial_av_1 = mkA "jovial" ;
  jovialisk_av_1 = mkA "jovialisk" ;
  jovialitet_nn_1 = mkN "jovialitet" "jovialiteter" ;
  joxig_av_1 = mkA "joxig" ;
  ju_ab_1 = mkAdv "ju" ;
  jubelaar_nn_1 = mkN "jubelеr" neutrum ;
  jubelaasna_nn_1 = mkN "jubelеsna" ;
  jubeldag_nn_1 = mkN "jubeldag" ;
  jubeldoktor_nn_1 = mkN "jubeldoktor" "jubeldoktorer" ;
  jubelidiot_nn_1 = mkN "jubelidiot" "jubelidioter" ;
  jubilar_nn_1 = mkN "jubilar" "jubilarer" ;
  jubileum_nn_1 = mkN "jubileum" "jubileet" "jubileer" "jubileerna" ;
  jubileumsmynt_nn_1 = mkN "jubileumsmynt" neutrum ;
  jublande_av_1 = mkA "jublande" ;
  judasgaerning_nn_1 = mkN "judasgдrning" ;
  judaskyss_nn_1 = mkN "judaskyss" ;
  judaspeng_nn_1 = mkN "judaspeng" ;
  jude_nn_1 = mkN "jude" utrum ;
  judebroed_nn_1 = mkN "judebrцd" neutrum ;
  judefoerfoeljelse_nn_1 = mkN "judefцrfцljelse" "judefцrfцljelser" ;
  judekristen_av_1 = mkA "judekristen" "judekristet" ;
  judendom_nn_1 = mkN "judendom" ;
  judenhet_nn_1 = mkN "judenhet" "judenheter" ;
  judiciell_av_1 = mkA "judiciell" ;
  judinna_nn_1 = mkN "judinna" ;
  judisk_av_1 = mkA "judisk" ;
  jugoslav_nn_1 = mkN "jugoslav" "jugoslaver" ;
  jugoslavisk_av_1 = mkA "jugoslavisk" ;
  juice_nn_1 = mkN "juice" "juicer" ;
  jukebox_nn_1 = mkN "jukebox" ;
  jul_nn_1 = mkN "jul" ;
  julafton_nn_1 = mkN "julafton" "julaftonen" "julaftnar" "julaftnarna" ;
  julbock_nn_1 = mkN "julbock" ;
  julboen_nn_1 = mkN "julbцn" "julbцner" ;
  julbord_nn_1 = mkN "julbord" neutrum ;
  juldag_nn_1 = mkN "juldag" ;
  juldagsmorgon_nn_1 = mkN "juldagsmorgon" "juldagsmorgonen" "juldagsmorgnar" "juldagsmorgnarna" ;
  julevangelium_nn_1 = mkN "julevangelium" "julevangeliet" "julevangelier" "julevangelierna" ;
  julgran_nn_1 = mkN "julgran" ;
  julgransfot_nn_1 = mkN "julgransfot" "julgransfцtter" ;
  julgranskaramell_nn_1 = mkN "julgranskaramell" "julgranskarameller" ;
  julgransplundring_nn_1 = mkN "julgransplundring" ;
  julgransprydnad_nn_1 = mkN "julgransprydnad" "julgransprydnader" ;
  julgris_nn_1 = mkN "julgris" ;
  julgrupp_nn_1 = mkN "julgrupp" "julgrupper" ;
  julhelg_nn_1 = mkN "julhelg" "julhelger" ;
  juliansk_av_1 = mkA "juliansk" ;
  julkaerve_nn_1 = mkN "julkдrve" utrum ;
  julkaktus_nn_1 = mkN "julkaktus" ;
  julklapp_nn_1 = mkN "julklapp" ;
  julkort_nn_1 = mkN "julkort" neutrum ;
  julle_nn_1 = mkN "julle" utrum ;
  julp_nn_1 = mkN "julp" ;
  julskyltning_nn_1 = mkN "julskyltning" ;
  jultidning_nn_1 = mkN "jultidning" ;
  jultomte_nn_1 = mkN "jultomte" utrum ;
  jumbojet_nn_1 = mkN "jumbojet" ;
  jumper_nn_1 = mkN "jumper" ;
  jungfru_nn_1 = mkN "jungfru" "jungfrun" "jungfrur" "jungfrurna" ;
  jungfrualstring_nn_1 = mkN "jungfrualstring" ;
  jungfruben_nn_1 = mkN "jungfruben" neutrum ;
  jungfruboerd_nn_1 = mkN "jungfrubцrd" "jungfrubцrder" ;
  jungfrubroest_nn_1 = mkN "jungfrubrцst" neutrum ;
  jungfrubur_nn_1 = mkN "jungfrubur" ;
  jungfrudom_nn_1 = mkN "jungfrudom" ;
  jungfrufoedsel_nn_1 = mkN "jungfrufцdsel" ;
  jungfrukammare_nn_1 = mkN "jungfrukammare" "jungfrukammaren" "jungfrukamrar" "jungfrukamrarna" ;
  jungfrulig_av_1 = mkA "jungfrulig" ;
  jungfrustift_nn_1 = mkN "jungfrustift" neutrum ;
  jungfrusvaerm_nn_1 = mkN "jungfrusvдrm" ;
  jungfrutal_nn_1 = mkN "jungfrutal" "jungfrutalet" "jungfrutalen" "jungfrutalena" ;
  jungman_nn_1 = mkN "jungman" "jungmannen" "jungmдn" "jungmдnnen" ;
  junior_av_1 = mkA "junior" ;
  junior_nn_1 = mkN "junior" "junioren" "juniorer" "juniorerna" ;
  junker_nn_1 = mkN "junker" ;
  junonisk_av_1 = mkA "junonisk" ;
  juridisk_av_1 = mkA "juridisk" ;
  juris_av_1 = mkA "juris" ;
  jurist_nn_1 = mkN "jurist" "jurister" ;
  jurt_nn_1 = mkN "jurt" neutrum ;
  jury_nn_1 = mkN "jury" "juryer" ;
  jus_nn_1 = mkN "jus" "juser" ;
  just_ab_1 = mkAdv "just" ;
  just_av_1 = mkA "just" "just" ;
  juste_av_1 = mkA "juste" "justt" ;
  justerare_nn_1 = mkN "justerare" "justerare" ;
  justering_nn_1 = mkN "justering" ;
  justeringsman_nn_1 = mkN "justeringsman" "justeringsmannen" "justeringsmдn" "justeringsmдnnen" ;
  justitiedepartement_nn_1 = mkN "justitiedepartement" "justitiedepartementet" "justitiedepartementen" "justitiedepartementena" ;
  justitieminister_nn_1 = mkN "justitieminister" ;
  justitiemord_nn_1 = mkN "justitiemord" neutrum ;
  justitieombudsman_nn_1 = mkN "justitieombudsman" "justitieombudsmannen" "justitieombudsmдn" "justitieombudsmдnnen" ;
  justitieraad_nn_1 = mkN "justitierеd" neutrum ;
  jute_nn_2 = mkN "jute" utrum ;
  jutlaendsk_av_1 = mkA "jutlдndsk" ;
  jutsk_av_1 = mkA "jutsk" ;
  juvel_nn_1 = mkN "juvel" "juveler" ;
  juvelerare_nn_1 = mkN "juvelerare" "juvelerare" ;
  juvenil_av_1 = mkA "juvenil" ;
  juver_nn_1 = mkN "juver" neutrum ;
  juverinflammation_nn_1 = mkN "juverinflammation" "juverinflammationer" ;
  juvervaevnad_nn_1 = mkN "juvervдvnad" "juvervдvnader" ;
  juxtaposition_nn_1 = mkN "juxtaposition" "juxtapositioner" ;
  jycke_nn_1 = mkN "jycke" utrum ;
  jyllaendsk_av_1 = mkA "jyllдndsk" ;
  jyllaenning_nn_1 = mkN "jyllдnning" ;
  kaadig_av_1 = mkA "kеdig" ;
  kaadrik_av_1 = mkA "kеdrik" ;
  kaak_nn_1 = mkN "kеk" ;
  kaakfarare_nn_1 = mkN "kеkfarare" "kеkfarare" ;
  kaaldolma_nn_1 = mkN "kеldolma" "kеldolman" "kеldolmaar" "kеldolmaarna" ;
  kaalfjaeril_nn_1 = mkN "kеlfjдril" ;
  kaalhuvud_nn_1 = mkN "kеlhuvud" "kеlhuvudet" "kеlhuvuden" "kеlhuvudena" ;
  kaallapp_nn_1 = mkN "kеllapp" ;
  kaalmask_nn_1 = mkN "kеlmask" ;
  kaalrot_nn_1 = mkN "kеlrot" "kеlrцtter" ;
  kaalsupare_nn_1 = mkN "kеlsupare" "kеlsupare" ;
  kaar_nn_1 = mkN "kеr" "kеrer" ;
  kaare_nn_1 = mkN "kеre" utrum ;
  kaarhus_nn_1 = mkN "kеrhus" neutrum ;
  kaarknutte_nn_1 = mkN "kеrknutte" utrum ;
  kaarordfoerande_nn_1 = mkN "kеrordfцrande" "kеrordfцranden" "kеrordfцrande" "kеrordfцrandena" ;
  kaarpamp_nn_1 = mkN "kеrpamp" ;
  kaaseri_nn_1 = mkN "kеseri" "kеserit" "kеserier" "kеserierna" ;
  kaasoer_nn_1 = mkN "kеsцr" "kеsцrer" ;
  kabal_nn_1 = mkN "kabal" "kabaler" ;
  kabare_nn_1 = mkN "kabarй" "kabarйer" ;
  kabareorkester_nn_1 = mkN "kabarйorkester" ;
  kabbalist_nn_1 = mkN "kabbalist" "kabbalister" ;
  kabel_nn_1 = mkN "kabel" ;
  kabelbro_nn_1 = mkN "kabelbro" ;
  kabelbrunn_nn_1 = mkN "kabelbrunn" ;
  kabelgatt_nn_1 = mkN "kabelgatt" neutrum ;
  kabellaengd_nn_1 = mkN "kabellдngd" "kabellдngder" ;
  kabelskaap_nn_1 = mkN "kabelskеp" neutrum ;
  kabelslagen_av_1 = mkA "kabelslagen" "kabelslaget" ;
  kabin_nn_1 = mkN "kabin" "kabiner" ;
  kabinbaat_nn_1 = mkN "kabinbеt" ;
  kabinett_nn_1 = mkN "kabinett" neutrum ;
  kabinettsformat_nn_1 = mkN "kabinettsformat" neutrum ;
  kabinettsfraaga_nn_1 = mkN "kabinettsfrеga" ;
  kabinettskort_nn_1 = mkN "kabinettskort" neutrum ;
  kabinettsorder_nn_1 = mkN "kabinettsorder" ;
  kabinettspass_nn_1 = mkN "kabinettspass" neutrum ;
  kabinettssekreterare_nn_1 = mkN "kabinettssekreterare" "kabinettssekreterare" ;
  kabyl_nn_1 = mkN "kabyl" "kabyler" ;
  kabylisk_av_1 = mkA "kabylisk" ;
  kabyss_nn_1 = mkN "kabyss" "kabysser" ;
  kadaver_nn_1 = mkN "kadaver" neutrum ;
  kadaverlydnad_nn_1 = mkN "kadaverlydnad" "kadaverlydnader" ;
  kadens_nn_1 = mkN "kadens" "kadenser" ;
  kader_nn_1 = mkN "kader" ;
  kaderoevning_nn_1 = mkN "kaderцvning" ;
  kadersystem_nn_1 = mkN "kadersystem" neutrum ;
  kadett_nn_1 = mkN "kadett" "kadetter" ;
  kadettfartyg_nn_1 = mkN "kadettfartyg" neutrum ;
  kadettkaar_nn_1 = mkN "kadettkеr" "kadettkеrer" ;
  kadi_nn_1 = mkN "kadi" "kadin" "kadier" "kadierna" ;
  kadmiumgul_av_1 = mkA "kadmiumgul" ;
  kadmiumjon_nn_1 = mkN "kadmiumjon" "kadmiumjoner" ;
  kadrilj_nn_1 = mkN "kadrilj" "kadriljer" ;
  kaeck_av_1 = mkA "kдck" ;
  kaeft_nn_1 = mkN "kдft" ;
  kaegel_nn_1 = mkN "kдgel" ;
  kaegelformig_av_1 = mkA "kдgelformig" ;
  kaegelsnitt_nn_1 = mkN "kдgelsnitt" neutrum ;
  kaegla_nn_1 = mkN "kдgla" ;
  kaekben_nn_1 = mkN "kдkben" neutrum ;
  kaeke_nn_1 = mkN "kдke" utrum ;
  kaekled_nn_1 = mkN "kдkled" "kдkleder" ;
  kaekrem_nn_1 = mkN "kдkrem" "kдkremmen" "kдkremmar" "kдkremmarna" ;
  kael_nn_1 = mkN "kдl" ;
  kaelkbacke_nn_1 = mkN "kдlkbacke" utrum ;
  kaelkborgare_nn_1 = mkN "kдlkborgare" "kдlkborgare" ;
  kaelke_nn_1 = mkN "kдlke" utrum ;
  kaellaader_nn_1 = mkN "kдllеder" "kдllеdern" "kдllеdror" "kдllеdrorna" ;
  kaellaadra_nn_1 = mkN "kдllеdra" ;
  kaellare_nn_1 = mkN "kдllare" "kдllare" ;
  kaellarhals_nn_1 = mkN "kдllarhals" ;
  kaellarmaestare_nn_1 = mkN "kдllarmдstare" "kдllarmдstare" ;
  kaellarvaaning_nn_1 = mkN "kдllarvеning" ;
  kaelldrag_nn_1 = mkN "kдlldrag" neutrum ;
  kaellfloede_nn_1 = mkN "kдllflцde" ;
  kaellfoerteckning_nn_1 = mkN "kдllfцrteckning" ;
  kaellhaenvisning_nn_1 = mkN "kдllhдnvisning" ;
  kaelling_nn_1 = mkN "kдlling" ;
  kaellmaterial_nn_1 = mkN "kдllmaterial" neutrum ;
  kaellsjoe_nn_1 = mkN "kдllsjц" ;
  kaellskrift_nn_1 = mkN "kдllskrift" "kдllskrifter" ;
  kaellspraang_nn_1 = mkN "kдllsprеng" neutrum ;
  kaellvatten_nn_1 = mkN "kдllvatten" "kдllvattnet" "kдllvatten" "kдllvattnen" ;
  kaemnaersraett_nn_1 = mkN "kдmnдrsrдtt" "kдmnдrsrдtter" ;
  kaempagrav_nn_1 = mkN "kдmpagrav" ;
  kaempalek_nn_1 = mkN "kдmpalek" ;
  kaempalik_av_1 = mkA "kдmpalik" ;
  kaempatag_nn_1 = mkN "kдmpatag" neutrum ;
  kaempe_nn_1 = mkN "kдmpe" utrum ;
  kaempig_av_1 = mkA "kдmpig" ;
  kaend_av_1 = mkA "kдnd" ;
  kaendis_nn_1 = mkN "kдndis" ;
  kaenguru_nn_1 = mkN "kдnguru" "kдngurun" "kдngurur" "kдngururna" ;
  kaengurupung_nn_1 = mkN "kдngurupung" ;
  kaennare_nn_1 = mkN "kдnnare" "kдnnare" ;
  kaennbar_av_1 = mkA "kдnnbar" ;
  kaennedom_nn_1 = mkN "kдnnedom" ;
  kaennemaerke_nn_1 = mkN "kдnnemдrke" ;
  kaennetecken_nn_1 = mkN "kдnnetecken" "kдnnetecknet" "kдnnetecken" "kдnnetecknen" ;
  kaenning_nn_1 = mkN "kдnning" ;
  kaenselhaar_nn_1 = mkN "kдnselhеr" neutrum ;
  kaenselorgan_nn_1 = mkN "kдnselorgan" neutrum ;
  kaenselsproet_nn_1 = mkN "kдnselsprцt" neutrum ;
  kaensla_nn_1 = mkN "kдnsla" ;
  kaenslig_av_1 = mkA "kдnslig" ;
  kaenslighet_nn_1 = mkN "kдnslighet" "kдnsligheter" ;
  kaenslofylld_av_1 = mkA "kдnslofylld" "kдnslofyllt" ;
  kaenslokall_av_1 = mkA "kдnslokall" ;
  kaenslolaege_nn_1 = mkN "kдnslolдge" ;
  kaensloloes_av_1 = mkA "kдnslolцs" ;
  kaenslomaenniska_nn_1 = mkN "kдnslomдnniska" ;
  kaenslomaessig_av_1 = mkA "kдnslomдssig" ;
  kaenslosam_av_1 = mkA "kдnslosam" "kдnslosamt" "kдnslosamma" "kдnslosamma" "kдnslosammare" "kдnslosammast" "kдnslosammaste" ;
  kaenslosamhet_nn_1 = mkN "kдnslosamhet" "kдnslosamheter" ;
  kaenslostraeng_nn_1 = mkN "kдnslostrдng" ;
  kaepp_nn_1 = mkN "kдpp" ;
  kaepphaest_nn_1 = mkN "kдpphдst" ;
  kaeppraett_ab_1 = mkAdv "kдpprдtt" ;
  kaepprak_av_1 = mkA "kдpprak" ;
  kaer_av_1 = mkA "kдr" ;
  kaeraelskelig_av_1 = mkA "kдrдlskelig" ;
  kaerande_nn_1 = mkN "kдrande" "kдranden" "kдrande" "kдrandena" ;
  kaeril_nn_1 = mkN "kдril" neutrum ;
  kaering_nn_1 = mkN "kдring" ;
  kaeringknop_nn_1 = mkN "kдringknop" ;
  kaeringknut_nn_1 = mkN "kдringknut" ;
  kaeringkrok_nn_1 = mkN "kдringkrok" ;
  kaerkommen_av_1 = mkA "kдrkommen" "kдrkommet" "kдrkomna" "kдrkomna" "kдrkomnare" "kдrkomnast" "kдrkomnaste" ;
  kaerl_nn_1 = mkN "kдrl" neutrum ;
  kaerlek_nn_1 = mkN "kдrlek" ;
  kaerleksaffaer_nn_1 = mkN "kдrleksaffдr" "kдrleksaffдrer" ;
  kaerleksakt_nn_1 = mkN "kдrleksakt" "kдrleksakter" ;
  kaerleksbarn_nn_1 = mkN "kдrleksbarn" neutrum ;
  kaerleksbetygelse_nn_1 = mkN "kдrleksbetygelse" "kдrleksbetygelser" ;
  kaerleksbud_nn_1 = mkN "kдrleksbud" neutrum ;
  kaerleksdikt_nn_1 = mkN "kдrleksdikt" "kдrleksdikter" ;
  kaerleksdryck_nn_1 = mkN "kдrleksdryck" "kдrleksdrycker" ;
  kaerleksfoerbindelse_nn_1 = mkN "kдrleksfцrbindelse" "kдrleksfцrbindelser" ;
  kaerleksfoerhaallande_nn_1 = mkN "kдrleksfцrhеllande" ;
  kaerleksfull_av_1 = mkA "kдrleksfull" ;
  kaerleksgud_nn_1 = mkN "kдrleksgud" ;
  kaerlekshistoria_nn_1 = mkN "kдrlekshistoria" "kдrlekshistorien" "kдrlekshistorier" "kдrlekshistorierna" ;
  kaerlekskonflikt_nn_1 = mkN "kдrlekskonflikt" "kдrlekskonflikter" ;
  kaerlekskrank_av_1 = mkA "kдrlekskrank" ;
  kaerlekskval_nn_1 = mkN "kдrlekskval" neutrum ;
  kaerleksloes_av_1 = mkA "kдrlekslцs" ;
  kaerleksmoete_nn_1 = mkN "kдrleksmцte" ;
  kaerlekspar_nn_1 = mkN "kдrlekspar" neutrum ;
  kaerleksrelation_nn_1 = mkN "kдrleksrelation" "kдrleksrelationer" ;
  kaerleksroman_nn_1 = mkN "kдrleksroman" "kдrleksromaner" ;
  kaerlekssaga_nn_1 = mkN "kдrlekssaga" ;
  kaerlig_av_1 = mkA "kдrlig" ;
  kaerligen_ab_1 = mkAdv "kдrligen" ;
  kaerlsjukdom_nn_1 = mkN "kдrlsjukdom" ;
  kaerlsvulst_nn_1 = mkN "kдrlsvulst" "kдrlsvulster" ;
  kaernfamilj_nn_1 = mkN "kдrnfamilj" "kдrnfamiljer" ;
  kaernfoerande_av_1 = mkA "kдrnfцrande" ;
  kaernfri_av_1 = mkA "kдrnfri" "kдrnfritt" ;
  kaernfrisk_av_1 = mkA "kдrnfrisk" ;
  kaernfrukt_nn_1 = mkN "kдrnfrukt" "kдrnfrukter" ;
  kaernfull_av_1 = mkA "kдrnfull" ;
  kaerngubbe_nn_1 = mkN "kдrngubbe" utrum ;
  kaernhus_nn_1 = mkN "kдrnhus" neutrum ;
  kaernkraftinspektion_nn_1 = mkN "kдrnkraftinspektion" "kдrnkraftinspektioner" ;
  kaernkraftsaekerhet_nn_1 = mkN "kдrnkraftsдkerhet" "kдrnkraftsдkerheter" ;
  kaernkraftsoperatoer_nn_1 = mkN "kдrnkraftsoperatцr" "kдrnkraftsoperatцrer" ;
  kaernkraftverk_nn_1 = mkN "kдrnkraftverk" neutrum ;
  kaernladdning_nn_1 = mkN "kдrnladdning" ;
  kaernlinje_nn_1 = mkN "kдrnlinje" "kдrnlinjer" ;
  kaernminne_nn_1 = mkN "kдrnminne" ;
  kaernpartikel_nn_1 = mkN "kдrnpartikel" ;
  kaernpunkt_nn_1 = mkN "kдrnpunkt" "kдrnpunkter" ;
  kaernreaktion_nn_1 = mkN "kдrnreaktion" "kдrnreaktioner" ;
  kaernreaktor_nn_1 = mkN "kдrnreaktor" "kдrnreaktorer" ;
  kaernsoenderfall_nn_1 = mkN "kдrnsцnderfall" neutrum ;
  kaerntrupp_nn_1 = mkN "kдrntrupp" "kдrntrupper" ;
  kaernvapen_nn_1 = mkN "kдrnvapen" "kдrnvapnet" "kдrnvapen" "kдrnvapnen" ;
  kaernvapenarsenal_nn_1 = mkN "kдrnvapenarsenal" "kдrnvapenarsenaler" ;
  kaernvapenbaerande_av_1 = mkA "kдrnvapenbдrande" ;
  kaernvapenexplosion_nn_1 = mkN "kдrnvapenexplosion" "kдrnvapenexplosioner" ;
  kaernvapenfri_av_1 = mkA "kдrnvapenfri" "kдrnvapenfritt" ;
  kaernvapenkrig_nn_1 = mkN "kдrnvapenkrig" neutrum ;
  kaernvapenmakt_nn_1 = mkN "kдrnvapenmakt" "kдrnvapenmakter" ;
  kaernvapenparaply_nn_1 = mkN "kдrnvapenparaply" "kдrnvapenparaplyer" ;
  kaernvapenprov_nn_1 = mkN "kдrnvapenprov" neutrum ;
  kaernvapenstrategi_nn_1 = mkN "kдrnvapenstrategi" "kдrnvapenstrategier" ;
  kaeromaal_nn_1 = mkN "kдromеl" neutrum ;
  kaerr_nn_1 = mkN "kдrr" neutrum ;
  kaerraeng_nn_1 = mkN "kдrrдng" ;
  kaerrhoek_nn_1 = mkN "kдrrhцk" ;
  kaerring_nn_1 = mkN "kдrring" ;
  kaerrvial_nn_1 = mkN "kдrrvial" "kдrrvialer" ;
  kaerv_av_1 = mkA "kдrv" ;
  kaervaenlig_av_1 = mkA "kдrvдnlig" ;
  kaerve_nn_1 = mkN "kдrve" utrum ;
  kaettarbaal_nn_1 = mkN "kдttarbеl" neutrum ;
  kaettare_nn_1 = mkN "kдttare" "kдttare" ;
  kaette_nn_1 = mkN "kдtte" utrum ;
  kaetteri_nn_1 = mkN "kдtteri" "kдtterit" "kдtterier" "kдtterierna" ;
  kaettersk_av_1 = mkA "kдttersk" ;
  kaetting_nn_1 = mkN "kдtting" ;
  kaettjefull_av_1 = mkA "kдttjefull" ;
  kaex_nn_1 = mkN "kдx" neutrum ;
  kafe_nn_1 = mkN "kafй" "kafйt" "kafйer" "kafйerna" ;
  kaferoerelse_nn_1 = mkN "kafйrцrelse" "kafйrцrelser" ;
  kafevagn_nn_1 = mkN "kafйvagn" ;
  kaffeautomat_nn_1 = mkN "kaffeautomat" "kaffeautomater" ;
  kaffebal_nn_1 = mkN "kaffebal" ;
  kaffebord_nn_1 = mkN "kaffebord" neutrum ;
  kaffebrun_av_1 = mkA "kaffebrun" ;
  kaffebryggare_nn_1 = mkN "kaffebryggare" "kaffebryggare" ;
  kaffebuske_nn_1 = mkN "kaffebuske" utrum ;
  kaffedags_ab_1 = mkAdv "kaffedags" ;
  kaffedrickande_nn_1 = mkN "kaffedrickande" ;
  kaffeduk_nn_1 = mkN "kaffeduk" ;
  kaffeersaettning_nn_1 = mkN "kaffeersдttning" ;
  kaffefat_nn_1 = mkN "kaffefat" neutrum ;
  kaffefilter_nn_1 = mkN "kaffefilter" neutrum ;
  kaffegoek_nn_1 = mkN "kaffegцk" ;
  kaffekask_nn_1 = mkN "kaffekask" ;
  kaffekittel_nn_1 = mkN "kaffekittel" ;
  kaffekokare_nn_1 = mkN "kaffekokare" "kaffekokare" ;
  kaffekopp_nn_1 = mkN "kaffekopp" ;
  kaffekvarn_nn_1 = mkN "kaffekvarn" ;
  kaffemoster_nn_1 = mkN "kaffemoster" ;
  kaffepetter_nn_1 = mkN "kaffepetter" ;
  kaffepulver_nn_1 = mkN "kaffepulver" neutrum ;
  kaffer_nn_1 = mkN "kaffer" "kaffern" "kaffrer" "kaffrerna" ;
  kafferast_nn_1 = mkN "kafferast" "kafferaster" ;
  kafferbuffel_nn_1 = mkN "kafferbuffel" ;
  kafferep_nn_1 = mkN "kafferep" neutrum ;
  kafferosteri_nn_1 = mkN "kafferosteri" "kafferosterit" "kafferosterier" "kafferosterierna" ;
  kafferspjut_nn_1 = mkN "kafferspjut" neutrum ;
  kafferspraak_nn_1 = mkN "kaffersprеk" neutrum ;
  kaffeservering_nn_1 = mkN "kaffeservering" ;
  kaffesked_nn_1 = mkN "kaffesked" ;
  kaffetaar_nn_1 = mkN "kaffetеr" ;
  kaffetant_nn_1 = mkN "kaffetant" "kaffetanter" ;
  kaffetraed_nn_1 = mkN "kaffetrдd" neutrum ;
  kaftan_nn_1 = mkN "kaftan" "kaftaner" ;
  kagge_nn_1 = mkN "kagge" utrum ;
  kaj_nn_1 = mkN "kaj" "kajer" ;
  kajak_nn_1 = mkN "kajak" "kajaker" ;
  kajavgift_nn_1 = mkN "kajavgift" "kajavgifter" ;
  kajdjup_nn_1 = mkN "kajdjup" neutrum ;
  kajfritt_ab_1 = mkAdv "kajfritt" ;
  kajman_nn_1 = mkN "kajman" "kajmaner" ;
  kajplats_nn_1 = mkN "kajplats" "kajplatser" ;
  kajskoning_nn_1 = mkN "kajskoning" ;
  kajutdaeck_nn_1 = mkN "kajutdдck" neutrum ;
  kajutpost_nn_1 = mkN "kajutpost" "kajutposter" ;
  kakafoni_nn_1 = mkN "kakafoni" "kakafonier" ;
  kakaolikoer_nn_1 = mkN "kakaolikцr" "kakaolikцrer" ;
  kakaotraed_nn_1 = mkN "kakaotrдd" neutrum ;
  kakbak_nn_1 = mkN "kakbak" neutrum ;
  kakburk_nn_1 = mkN "kakburk" ;
  kakel_nn_1 = mkN "kakel" neutrum ;
  kakelugn_nn_1 = mkN "kakelugn" ;
  kakelugnsmakare_nn_1 = mkN "kakelugnsmakare" "kakelugnsmakare" ;
  kakelugnsnisch_nn_1 = mkN "kakelugnsnisch" "kakelugnsnischer" ;
  kakelugnssaettare_nn_1 = mkN "kakelugnssдttare" "kakelugnssдttare" ;
  kakelugnsventil_nn_1 = mkN "kakelugnsventil" "kakelugnsventiler" ;
  kakfat_nn_1 = mkN "kakfat" neutrum ;
  kakform_nn_1 = mkN "kakform" ;
  kakmaatt_nn_1 = mkN "kakmеtt" neutrum ;
  kakmix_nn_1 = mkN "kakmix" ;
  kakofoni_nn_1 = mkN "kakofoni" "kakofonier" ;
  kaksmet_nn_1 = mkN "kaksmet" "kaksmeter" ;
  kaktaang_nn_1 = mkN "kaktеng" "kaktдnger" ;
  kakte_nn_1 = mkN "kaktй" "kaktйer" ;
  kaktus_nn_1 = mkN "kaktus" ;
  kaktusfikon_nn_1 = mkN "kaktusfikon" neutrum ;
  kakuminal_av_1 = mkA "kakuminal" ;
  kakuminal_nn_1 = mkN "kakuminal" "kakuminaler" ;
  kal_av_1 = mkA "kal" ;
  kalabalik_nn_1 = mkN "kalabalik" "kalabaliker" ;
  kalabass_nn_1 = mkN "kalabass" "kalabasser" ;
  kalaeta_vb_1 = mkV "kalдta" "kalеt" "kalдtit" ;
  kalamitet_nn_1 = mkN "kalamitet" "kalamiteter" ;
  kalander_nn_1 = mkN "kalander" ;
  kalas_nn_1 = mkN "kalas" neutrum ;
  kalaspingla_nn_1 = mkN "kalaspingla" ;
  kalcedon_nn_1 = mkN "kalcedon" "kalcedoner" ;
  kalciumhydroxid_nn_1 = mkN "kalciumhydroxid" "kalciumhydroxider" ;
  kalciumoxid_nn_1 = mkN "kalciumoxid" "kalciumoxider" ;
  kalciumsilikat_nn_1 = mkN "kalciumsilikat" "kalciumsilikater" ;
  kalde_nn_1 = mkN "kaldй" "kaldйer" ;
  kalebass_nn_1 = mkN "kalebass" "kalebasser" ;
  kaledonisk_av_1 = mkA "kaledonisk" ;
  kalejdoskop_nn_1 = mkN "kalejdoskop" neutrum ;
  kalejdoskopisk_av_1 = mkA "kalejdoskopisk" ;
  kalendarisk_av_1 = mkA "kalendarisk" ;
  kalendarium_nn_1 = mkN "kalendarium" "kalendariet" "kalendarier" "kalendarierna" ;
  kalender_nn_1 = mkN "kalender" ;
  kalenderaar_nn_1 = mkN "kalenderеr" neutrum ;
  kalenderbitare_nn_1 = mkN "kalenderbitare" "kalenderbitare" ;
  kalenderdygn_nn_1 = mkN "kalenderdygn" neutrum ;
  kalendermaanad_nn_1 = mkN "kalendermеnad" "kalendermеnader" ;
  kalenderstav_nn_1 = mkN "kalenderstav" ;
  kalendervecka_nn_1 = mkN "kalendervecka" ;
  kalesch_nn_1 = mkN "kalesch" "kalescher" ;
  kalfaktor_nn_1 = mkN "kalfaktor" "kalfaktorer" ;
  kalfjaell_nn_1 = mkN "kalfjдll" neutrum ;
  kalhugga_vb_1 = mkV "kalhugga" "kalhцgg" "kalhuggit" ;
  kalhygge_nn_1 = mkN "kalhygge" ;
  kaliber_nn_1 = mkN "kaliber" ;
  kaliberborr_nn_1 = mkN "kaliberborr" ;
  kalibertolk_nn_1 = mkN "kalibertolk" ;
  kalif_nn_1 = mkN "kalif" "kalifer" ;
  kalifat_nn_1 = mkN "kalifat" neutrum ;
  kalisalt_nn_1 = mkN "kalisalt" "kalisaltet" "kalisalter" "kalisalterna" ;
  kaliumhydroxid_nn_1 = mkN "kaliumhydroxid" "kaliumhydroxider" ;
  kaliumjon_nn_1 = mkN "kaliumjon" "kaliumjoner" ;
  kalk_nn_2 = mkN "kalk" ;
  kalkalg_nn_1 = mkN "kalkalg" "kalkalger" ;
  kalkanhopning_nn_1 = mkN "kalkanhopning" ;
  kalkbraenneri_nn_1 = mkN "kalkbrдnneri" "kalkbrдnnerit" "kalkbrдnnerier" "kalkbrдnnerierna" ;
  kalkbrott_nn_1 = mkN "kalkbrott" neutrum ;
  kalkbruk_nn_1 = mkN "kalkbruk" neutrum ;
  kalkerpapper_nn_1 = mkN "kalkerpapper" neutrum ;
  kalkfaerg_nn_1 = mkN "kalkfдrg" "kalkfдrger" ;
  kalkfattig_av_1 = mkA "kalkfattig" ;
  kalkgrund_nn_1 = mkN "kalkgrund" "kalkgrunder" ;
  kalkhalt_nn_1 = mkN "kalkhalt" "kalkhalter" ;
  kalkhaltig_av_1 = mkA "kalkhaltig" ;
  kalkjon_nn_1 = mkN "kalkjon" "kalkjoner" ;
  kalkmaalning_nn_1 = mkN "kalkmеlning" ;
  kalkomani_nn_1 = mkN "kalkomani" "kalkomanier" ;
  kalkon_nn_1 = mkN "kalkon" "kalkoner" ;
  kalkrest_nn_1 = mkN "kalkrest" "kalkrester" ;
  kalkrik_av_1 = mkA "kalkrik" ;
  kalkskal_nn_1 = mkN "kalkskal" neutrum ;
  kalktuff_nn_1 = mkN "kalktuff" "kalktuffer" ;
  kalkugn_nn_1 = mkN "kalkugn" ;
  kalkyl_nn_1 = mkN "kalkyl" "kalkyler" ;
  kalkylator_nn_1 = mkN "kalkylator" "kalkylatorer" ;
  kalkylerbar_av_1 = mkA "kalkylerbar" ;
  kall_av_1 = mkA "kall" ;
  kall_nn_1 = mkN "kall" neutrum ;
  kallbad_nn_1 = mkN "kallbad" neutrum ;
  kallbaenk_nn_1 = mkN "kallbдnk" ;
  kallblod_nn_1 = mkN "kallblod" neutrum ;
  kallblodig_av_1 = mkA "kallblodig" ;
  kallblodighet_nn_1 = mkN "kallblodighet" "kallblodigheter" ;
  kalldra_vb_1 = mkV "kalldra" "kalldrar" "kalldra" "kalldrog" "kalldragit" "kalldragen" ;
  kalldusch_nn_1 = mkN "kalldusch" ;
  kallelse_nn_1 = mkN "kallelse" "kallelser" ;
  kallelsebeslut_nn_1 = mkN "kallelsebeslut" neutrum ;
  kallelsebrev_nn_1 = mkN "kallelsebrev" neutrum ;
  kallelsefoerslag_nn_1 = mkN "kallelsefцrslag" neutrum ;
  kallelsegaerning_nn_1 = mkN "kallelsegдrning" ;
  kallelsetid_nn_1 = mkN "kallelsetid" "kallelsetider" ;
  kallflytande_av_1 = mkA "kallflytande" ;
  kallfront_nn_1 = mkN "kallfront" "kallfronter" ;
  kallgarage_nn_1 = mkN "kallgarage" "kallgaraget" "kallgarage" "kallgaragen" ;
  kallgrin_nn_1 = mkN "kallgrin" neutrum ;
  kallhus_nn_1 = mkN "kallhus" neutrum ;
  kallmangel_nn_1 = mkN "kallmangel" ;
  kallmur_nn_1 = mkN "kallmur" ;
  kallnaal_nn_1 = mkN "kallnеl" ;
  kallortstillaegg_nn_1 = mkN "kallortstillдgg" neutrum ;
  kallpunkt_nn_1 = mkN "kallpunkt" "kallpunkter" ;
  kallsaag_nn_1 = mkN "kallsеg" ;
  kallsinnig_av_1 = mkA "kallsinnig" ;
  kallskaenk_nn_1 = mkN "kallskдnk" ;
  kallskuren_av_1 = mkA "kallskuren" "kallskuret" ;
  kallstart_nn_1 = mkN "kallstart" "kallstarter" ;
  kallsup_nn_1 = mkN "kallsup" ;
  kallvatten_nn_1 = mkN "kallvatten" "kallvattnet" "kallvatten" "kallvattnen" ;
  kalmark_nn_1 = mkN "kalmark" "kalmarker" ;
  kalmuck_nn_1 = mkN "kalmuck" "kalmucker" ;
  kalori_nn_1 = mkN "kalori" "kalorier" ;
  kaloribehov_nn_1 = mkN "kaloribehov" neutrum ;
  kalorifattig_av_1 = mkA "kalorifattig" ;
  kalorijakt_nn_1 = mkN "kalorijakt" "kalorijakter" ;
  kalorimeter_nn_1 = mkN "kalorimeter" ;
  kaloririk_av_1 = mkA "kaloririk" ;
  kaloritabell_nn_1 = mkN "kaloritabell" "kaloritabeller" ;
  kalorivaerde_nn_1 = mkN "kalorivдrde" ;
  kalott_nn_1 = mkN "kalott" "kalotter" ;
  kalstammig_av_1 = mkA "kalstammig" ;
  kalufs_nn_1 = mkN "kalufs" "kalufser" ;
  kalv_nn_1 = mkN "kalv" ;
  kalvfaerdig_av_1 = mkA "kalvfдrdig" ;
  kalvfrikasse_nn_1 = mkN "kalvfrikassй" "kalvfrikassйer" ;
  kalvill_nn_1 = mkN "kalvill" "kalviller" ;
  kalvinist_nn_1 = mkN "kalvinist" "kalvinister" ;
  kalvinistisk_av_1 = mkA "kalvinistisk" ;
  kalvinsk_av_1 = mkA "kalvinsk" ;
  kalvjaerpe_nn_1 = mkN "kalvjдrpe" utrum ;
  kalvko_nn_1 = mkN "kalvko" "kalvkor" ;
  kalvrulad_nn_1 = mkN "kalvrulad" "kalvrulader" ;
  kalvskinn_nn_1 = mkN "kalvskinn" neutrum ;
  kalvskinnsband_nn_1 = mkN "kalvskinnsband" neutrum ;
  kalvstek_nn_1 = mkN "kalvstek" ;
  kam_nn_1 = mkN "kam" "kammen" "kammar" "kammarna" ;
  kamaxel_nn_1 = mkN "kamaxel" ;
  kambodjan_nn_1 = mkN "kambodjan" "kambodjaner" ;
  kambrisk_av_1 = mkA "kambrisk" ;
  kame_nn_1 = mkN "kamй" "kamйer" ;
  kamel_nn_1 = mkN "kamel" "kameler" ;
  kameldjur_nn_1 = mkN "kameldjur" neutrum ;
  kameleont_nn_1 = mkN "kameleont" "kameleonter" ;
  kamelforskare_nn_1 = mkN "kamelforskare" "kamelforskare" ;
  kamelforskning_nn_1 = mkN "kamelforskning" ;
  kamelforskningsprojekt_nn_1 = mkN "kamelforskningsprojekt" neutrum ;
  kamelherde_nn_1 = mkN "kamelherde" utrum ;
  kamelhjord_nn_1 = mkN "kamelhjord" ;
  kamelmedicin_nn_1 = mkN "kamelmedicin" "kamelmediciner" ;
  kamelopard_nn_1 = mkN "kamelopard" "kameloparder" ;
  kamelpoesi_nn_1 = mkN "kamelpoesi" "kamelpoesier" ;
  kamelsadel_nn_1 = mkN "kamelsadel" ;
  kamelsaeck_nn_1 = mkN "kamelsдck" ;
  kamera_nn_1 = mkN "kamera" ;
  kamerajakt_nn_1 = mkN "kamerajakt" "kamerajakter" ;
  kameral_av_1 = mkA "kameral" ;
  kameraman_nn_1 = mkN "kameraman" "kameramannen" "kameramдn" "kameramдnnen" ;
  kameraobjektiv_nn_1 = mkN "kameraobjektiv" neutrum ;
  kamerunare_nn_1 = mkN "kamerunare" "kamerunare" ;
  kamerunsk_av_1 = mkA "kamerunsk" ;
  kamin_nn_1 = mkN "kamin" "kaminer" ;
  kammanet_nn_1 = mkN "kammanet" "kammaneter" ;
  kammaraaklagare_nn_1 = mkN "kammarеklagare" "kammarеklagare" ;
  kammardressyr_nn_1 = mkN "kammardressyr" "kammardressyrer" ;
  kammare_nn_1 = mkN "kammare" "kammaren" "kamrar" "kamrarna" ;
  kammarherre_nn_1 = mkN "kammarherre" utrum ;
  kammarjungfru_nn_1 = mkN "kammarjungfru" "kammarjungfrun" "kammarjungfrur" "kammarjungfrurna" ;
  kammarjunkare_nn_1 = mkN "kammarjunkare" "kammarjunkare" ;
  kammarlaerd_av_1 = mkA "kammarlдrd" "kammarlдrt" ;
  kammarmusiker_nn_1 = mkN "kammarmusiker" "kammarmusikern" "kammarmusiker" "kammarmusikerna" ;
  kammarorkester_nn_1 = mkN "kammarorkester" ;
  kammarpiano_nn_1 = mkN "kammarpiano" "kammarpianot" "kammarpianon" "kammarpianona" ;
  kammarraett_nn_1 = mkN "kammarrдtt" "kammarrдtter" ;
  kammarskjutning_nn_1 = mkN "kammarskjutning" ;
  kammarskrivare_nn_1 = mkN "kammarskrivare" "kammarskrivare" ;
  kammarskruv_nn_1 = mkN "kammarskruv" ;
  kammarspel_nn_1 = mkN "kammarspel" "kammarspelet" "kammarspel" "kammarspelen" ;
  kammussla_nn_1 = mkN "kammussla" ;
  kamomill_nn_1 = mkN "kamomill" "kamomiller" ;
  kamouflering_nn_1 = mkN "kamouflering" ;
  kamp_nn_1 = mkN "kamp" "kamper" ;
  kamp_nn_2 = mkN "kamp" ;
  kampanil_nn_1 = mkN "kampanil" "kampaniler" ;
  kampanj_nn_1 = mkN "kampanj" "kampanjer" ;
  kampare_nn_1 = mkN "kampare" "kampare" ;
  kampegraes_nn_1 = mkN "kampegrдs" neutrum ;
  kampeschtraed_nn_1 = mkN "kampeschtrдd" neutrum ;
  kamporganisation_nn_1 = mkN "kamporganisation" "kamporganisationer" ;
  kampsaang_nn_1 = mkN "kampsеng" "kampsеnger" ;
  kampsport_nn_1 = mkN "kampsport" "kampsporter" ;
  kampuchean_nn_1 = mkN "kampuchean" "kampucheaner" ;
  kampucheansk_av_1 = mkA "kampucheansk" ;
  kampvilja_nn_1 = mkN "kampvilja" ;
  kamrat_nn_1 = mkN "kamrat" "kamrater" ;
  kamratlig_av_1 = mkA "kamratlig" ;
  kamratpaaverkning_nn_1 = mkN "kamratpеverkning" ;
  kamrer_nn_1 = mkN "kamrer" "kamrerer" ;
  kamrerare_nn_1 = mkN "kamrerare" "kamrerare" ;
  kams_nn_1 = mkN "kams" ;
  kamtsjadal_nn_1 = mkN "kamtsjadal" "kamtsjadaler" ;
  kan_nn_1 = mkN "kan" "kaner" ;
  kanadagaas_nn_1 = mkN "kanadagеs" "kanadagеsen" "kanadagдss" "kanadagдssen" ;
  kanadensare_nn_1 = mkN "kanadensare" "kanadensare" ;
  kanadensisk_av_1 = mkA "kanadensisk" ;
  kanadick_nn_1 = mkN "kanadick" "kanadicker" ;
  kanak_nn_1 = mkN "kanak" "kanaker" ;
  kanal_nn_1 = mkN "kanal" "kanaler" ;
  kanalaangare_nn_1 = mkN "kanalеngare" "kanalеngare" ;
  kanalje_nn_1 = mkN "kanalje" "kanaljer" ;
  kanalkrock_nn_1 = mkN "kanalkrock" ;
  kanalljus_nn_1 = mkN "kanalljus" neutrum ;
  kanalsystem_nn_1 = mkN "kanalsystem" neutrum ;
  kanalvaeljare_nn_1 = mkN "kanalvдljare" "kanalvдljare" ;
  kanane_nn_1 = mkN "kananй" "kananйer" ;
  kanape_nn_1 = mkN "kanapй" "kanapйer" ;
  kanariefaagel_nn_1 = mkN "kanariefеgel" ;
  kanariefroe_nn_1 = mkN "kanariefrц" "kanariefrцt" "kanariefrцn" "kanariefrцen" ;
  kanariegul_av_1 = mkA "kanariegul" ;
  kandar_nn_1 = mkN "kandar" neutrum ;
  kandelaber_nn_1 = mkN "kandelaber" ;
  kandidat_nn_1 = mkN "kandidat" "kandidater" ;
  kandidatur_nn_1 = mkN "kandidatur" "kandidaturer" ;
  kanelbrun_av_1 = mkA "kanelbrun" ;
  kanelstaang_nn_1 = mkN "kanelstеng" "kanelstдnger" ;
  kanfas_nn_1 = mkN "kanfas" "kanfaser" ;
  kanhaenda_ab_1 = mkAdv "kanhдnda" ;
  kanik_nn_1 = mkN "kanik" "kaniker" ;
  kanin_nn_1 = mkN "kanin" "kaniner" ;
  kanister_nn_1 = mkN "kanister" ;
  kanjon_nn_1 = mkN "kanjon" "kanjoner" ;
  kannbrosk_nn_1 = mkN "kannbrosk" neutrum ;
  kannelyr_nn_1 = mkN "kannelyr" "kannelyrer" ;
  kannibal_nn_1 = mkN "kannibal" "kannibaler" ;
  kannibalisk_av_1 = mkA "kannibalisk" ;
  kannstoepare_nn_1 = mkN "kannstцpare" "kannstцpare" ;
  kannstoeperi_nn_1 = mkN "kannstцperi" "kannstцperit" "kannstцperier" "kannstцperierna" ;
  kanon_nn_1 = mkN "kanon" "kanoner" ;
  kanon_nn_2 = mkN "kanon" "kanoner" ;
  kanonad_nn_1 = mkN "kanonad" "kanonader" ;
  kanonbaat_nn_1 = mkN "kanonbеt" ;
  kanonbra_av_1 = mkA "kanonbra" ;
  kanonfotograf_nn_1 = mkN "kanonfotograf" "kanonfotografer" ;
  kanongjuteri_nn_1 = mkN "kanongjuteri" "kanongjuterit" "kanongjuterier" "kanongjuterierna" ;
  kanonisation_nn_1 = mkN "kanonisation" "kanonisationer" ;
  kanonisering_nn_1 = mkN "kanonisering" ;
  kanonisk_av_1 = mkA "kanonisk" ;
  kanonjaer_nn_1 = mkN "kanonjдr" "kanonjдrer" ;
  kanonlock_nn_1 = mkN "kanonlock" ;
  kanonlopp_nn_1 = mkN "kanonlopp" neutrum ;
  kanonport_nn_1 = mkN "kanonport" ;
  kanontorn_nn_1 = mkN "kanontorn" neutrum ;
  kanot_nn_1 = mkN "kanot" "kanoter" ;
  kanotist_nn_1 = mkN "kanotist" "kanotister" ;
  kanske_ab_1 = mkAdv "kanske" ;
  kansler_nn_1 = mkN "kansler" "kanslern" "kanslerer" "kanslererna" ;
  kansli_nn_1 = mkN "kansli" "kanslit" "kanslier" "kanslierna" ;
  kansliraad_nn_1 = mkN "kanslirеd" neutrum ;
  kanslisekreterare_nn_1 = mkN "kanslisekreterare" "kanslisekreterare" ;
  kanslist_nn_1 = mkN "kanslist" "kanslister" ;
  kant_nn_1 = mkN "kant" "kanter" ;
  kantabel_av_1 = mkA "kantabel" "kantabelt" "kantabla" "kantabla" "kantablare" "kantablast" "kantablaste" ;
  kantaenka_ab_1 = mkAdv "kantдnka" ;
  kantarell_nn_1 = mkN "kantarell" "kantareller" ;
  kantat_nn_1 = mkN "kantat" "kantater" ;
  kantband_nn_1 = mkN "kantband" neutrum ;
  kantbeslag_nn_1 = mkN "kantbeslag" neutrum ;
  kantele_nn_1 = mkN "kantele" "kanteler" ;
  kanthugga_vb_1 = mkV "kanthugga" "kanthцgg" "kanthuggit" ;
  kantig_av_1 = mkA "kantig" ;
  kantin_nn_1 = mkN "kantin" "kantiner" ;
  kantnaal_nn_1 = mkN "kantnеl" ;
  kanton_nn_1 = mkN "kanton" "kantoner" ;
  kantor_nn_1 = mkN "kantor" "kantorer" ;
  kantrep_nn_1 = mkN "kantrep" neutrum ;
  kantsoem_nn_1 = mkN "kantsцm" "kantsцmmen" "kantsцmmar" "kantsцmmarna" ;
  kantsten_nn_1 = mkN "kantsten" "kantstenen" "kantstenar" "kantstenarna" ;
  kantstoett_av_1 = mkA "kantstцtt" ;
  kantvaext_nn_1 = mkN "kantvдxt" "kantvдxter" ;
  kanvasband_nn_1 = mkN "kanvasband" neutrum ;
  kanvasduk_nn_1 = mkN "kanvasduk" ;
  kanyl_nn_1 = mkN "kanyl" "kanyler" ;
  kaotisk_av_1 = mkA "kaotisk" ;
  kap_nn_2 = mkN "kap" neutrum ;
  kapabel_av_1 = mkA "kapabel" "kapabelt" "kapabla" "kapabla" "kapablare" "kapablast" "kapablaste" ;
  kapacitet_nn_1 = mkN "kapacitet" "kapaciteter" ;
  kapare_nn_1 = mkN "kapare" "kapare" ;
  kapell_nn_1 = mkN "kapell" neutrum ;
  kapellmaestare_nn_1 = mkN "kapellmдstare" "kapellmдstare" ;
  kaperi_nn_1 = mkN "kaperi" "kaperit" "kaperier" "kaperierna" ;
  kapfaar_nn_1 = mkN "kapfеr" neutrum ;
  kapillaer_av_1 = mkA "kapillдr" ;
  kapillaer_nn_1 = mkN "kapillдr" "kapillдrer" ;
  kapillaerroer_nn_1 = mkN "kapillдrrцr" neutrum ;
  kapillaritet_nn_1 = mkN "kapillaritet" "kapillariteter" ;
  kapitael_nn_1 = mkN "kapitдl" neutrum ;
  kapitael_nn_2 = mkN "kapitдl" "kapitдler" ;
  kapital_av_1 = mkA "kapital" ;
  kapital_nn_1 = mkN "kapital" neutrum ;
  kapitalbeskattning_nn_1 = mkN "kapitalbeskattning" ;
  kapitalbildning_nn_1 = mkN "kapitalbildning" ;
  kapitalbudget_nn_1 = mkN "kapitalbudget" ;
  kapitalfoerlust_nn_1 = mkN "kapitalfцrlust" "kapitalfцrluster" ;
  kapitalfoersaekring_nn_1 = mkN "kapitalfцrsдkring" ;
  kapitalinkomst_nn_1 = mkN "kapitalinkomst" "kapitalinkomster" ;
  kapitalinkomstbeskattning_nn_1 = mkN "kapitalinkomstbeskattning" ;
  kapitalintensiv_av_1 = mkA "kapitalintensiv" ;
  kapitalist_nn_1 = mkN "kapitalist" "kapitalister" ;
  kapitalistisk_av_1 = mkA "kapitalistisk" ;
  kapitalkonto_nn_1 = mkN "kapitalkonto" "kapitalkontot" "kapitalkonton" "kapitalkontona" ;
  kapitalmarknad_nn_1 = mkN "kapitalmarknad" "kapitalmarknader" ;
  kapitalvaerde_nn_1 = mkN "kapitalvдrde" ;
  kapitalvinst_nn_1 = mkN "kapitalvinst" "kapitalvinster" ;
  kapitel_nn_1 = mkN "kapitel" neutrum ;
  kapitelsal_nn_1 = mkN "kapitelsal" ;
  kapitelvis_ab_1 = mkAdv "kapitelvis" ;
  kapitulation_nn_1 = mkN "kapitulation" "kapitulationer" ;
  kaplan_nn_1 = mkN "kaplan" "kaplaner" ;
  kapott_nn_1 = mkN "kapott" "kapotter" ;
  kapp_nn_1 = mkN "kapp" ;
  kappe_nn_1 = mkN "kappe" utrum ;
  kappkoerning_nn_1 = mkN "kappkцrning" ;
  kapploepning_nn_1 = mkN "kapplцpning" ;
  kapprak_av_1 = mkA "kapprak" ;
  kapprock_nn_1 = mkN "kapprock" ;
  kapprum_nn_1 = mkN "kapprum" "kapprummet" "kapprum" "kapprummen" ;
  kapprustning_nn_1 = mkN "kapprustning" ;
  kappsaeck_nn_1 = mkN "kappsдck" ;
  kappseglare_nn_1 = mkN "kappseglare" "kappseglare" ;
  kappsegling_nn_1 = mkN "kappsegling" ;
  kappseglingsbaat_nn_1 = mkN "kappseglingsbеt" ;
  kappsimning_nn_1 = mkN "kappsimning" ;
  kapricioes_av_1 = mkA "kapriciцs" ;
  kaprifol_nn_1 = mkN "kaprifol" "kaprifoler" ;
  kaprifolium_nn_1 = mkN "kaprifolium" "kaprifolien" "kaprifolier" "kaprifolierna" ;
  kapriol_nn_1 = mkN "kapriol" "kaprioler" ;
  kapris_nn_1 = mkN "kapris" "kapriser" ;
  kapsaag_nn_1 = mkN "kapsеg" ;
  kapsel_nn_1 = mkN "kapsel" ;
  kapson_nn_1 = mkN "kapson" "kapsoner" ;
  kapsyl_nn_1 = mkN "kapsyl" "kapsyler" ;
  kapten_nn_1 = mkN "kapten" "kaptener" ;
  kapucin_nn_1 = mkN "kapucin" "kapuciner" ;
  kapucinorden_nn_1 = mkN "kapucinorden" ;
  kapun_nn_1 = mkN "kapun" "kapuner" ;
  kapuschong_nn_1 = mkN "kapuschong" "kapuschonger" ;
  kaputt_av_1 = mkA "kaputt" ;
  kapverdier_nn_1 = mkN "kapverdier" "kapverdiern" "kapverdier" "kapverdierna" ;
  kapverdisk_av_1 = mkA "kapverdisk" ;
  kar_nn_1 = mkN "kar" neutrum ;
  karabinjaer_nn_1 = mkN "karabinjдr" "karabinjдrer" ;
  karaff_nn_1 = mkN "karaff" "karaffer" ;
  karaffin_nn_1 = mkN "karaffin" "karaffiner" ;
  karaktaer_nn_1 = mkN "karaktдr" "karaktдrer" ;
  karaktaeristik_nn_1 = mkN "karaktдristik" "karaktдristiker" ;
  karaktaeristika_nn_2 = mkN "karaktдristika" "karaktдristikan" "karaktдristika" "karaktдristikana" ;
  karaktaeristisk_av_1 = mkA "karaktдristisk" ;
  karaktaersart_nn_1 = mkN "karaktдrsart" "karaktдrsarter" ;
  karaktaersdrag_nn_1 = mkN "karaktдrsdrag" neutrum ;
  karaktaersdrama_nn_1 = mkN "karaktдrsdrama" "karaktдrsdramat" "karaktдrsdraman" "karaktдrsdramana" ;
  karaktaersfast_av_1 = mkA "karaktдrsfast" "karaktдrsfast" ;
  karaktaersfel_nn_1 = mkN "karaktдrsfel" "karaktдrsfelet" "karaktдrsfel" "karaktдrsfelen" ;
  karaktaersroll_nn_1 = mkN "karaktдrsroll" "karaktдrsroller" ;
  karaktaersskaadespelare_nn_1 = mkN "karaktдrsskеdespelare" "karaktдrsskеdespelare" ;
  karaktaerstyp_nn_1 = mkN "karaktдrstyp" "karaktдrstyper" ;
  karakteristik_nn_1 = mkN "karakteristik" "karakteristiker" ;
  karakteristika_nn_2 = mkN "karakteristika" "karakteristikan" "karakteristika" "karakteristikana" ;
  karakteristisk_av_1 = mkA "karakteristisk" ;
  karamboll_nn_1 = mkN "karamboll" "karamboller" ;
  karamell_nn_1 = mkN "karamell" "karameller" ;
  karamellfaerg_nn_1 = mkN "karamellfдrg" "karamellfдrger" ;
  karamellpapper_nn_1 = mkN "karamellpapper" neutrum ;
  karamellpudding_nn_1 = mkN "karamellpudding" ;
  karamellsaas_nn_1 = mkN "karamellsеs" "karamellsеser" ;
  karantaen_nn_1 = mkN "karantдn" "karantдner" ;
  karat_nn_1 = mkN "karat" neutrum ;
  karatering_nn_1 = mkN "karatering" ;
  karatstaempel_nn_1 = mkN "karatstдmpel" ;
  karavan_nn_1 = mkN "karavan" "karavaner" ;
  karavanseraj_nn_1 = mkN "karavanseraj" "karavanserajer" ;
  karavell_nn_1 = mkN "karavell" "karaveller" ;
  karbad_nn_1 = mkN "karbad" neutrum ;
  karbamid_nn_1 = mkN "karbamid" "karbamider" ;
  karbas_nn_1 = mkN "karbas" "karbaser" ;
  karbin_nn_1 = mkN "karbin" "karbiner" ;
  karbinhake_nn_1 = mkN "karbinhake" utrum ;
  karbonat_nn_1 = mkN "karbonat" neutrum ;
  karbonatjon_nn_1 = mkN "karbonatjon" "karbonatjoner" ;
  karbonatsmaeltecell_nn_1 = mkN "karbonatsmдltecell" "karbonatsmдlteceller" ;
  karbonkopia_nn_1 = mkN "karbonkopia" ;
  karbonpapper_nn_1 = mkN "karbonpapper" neutrum ;
  karborundumduk_nn_1 = mkN "karborundumduk" ;
  karbunkel_nn_1 = mkN "karbunkel" ;
  karburator_nn_1 = mkN "karburator" "karburatorer" ;
  karcinogen_av_1 = mkA "karcinogen" ;
  karcinom_nn_1 = mkN "karcinom" neutrum ;
  kardan_nn_1 = mkN "kardan" "kardaner" ;
  kardanaxel_nn_1 = mkN "kardanaxel" ;
  kardanknut_nn_1 = mkN "kardanknut" ;
  kardansk_av_1 = mkA "kardansk" ;
  kardanupphaengning_nn_1 = mkN "kardanupphдngning" ;
  kardborrband_nn_1 = mkN "kardborrband" neutrum ;
  kardborre_nn_1 = mkN "kardborre" utrum ;
  kardborreknaeppning_nn_1 = mkN "kardborreknдppning" ;
  kardel_nn_1 = mkN "kardel" "kardeler" ;
  kardinal_nn_1 = mkN "kardinal" "kardinaler" ;
  kardinalbiskop_nn_1 = mkN "kardinalbiskop" ;
  kardinaldygd_nn_1 = mkN "kardinaldygd" "kardinaldygder" ;
  kardinalfel_nn_1 = mkN "kardinalfel" "kardinalfelet" "kardinalfel" "kardinalfelen" ;
  kardinalstreck_nn_1 = mkN "kardinalstreck" neutrum ;
  kardinaltal_nn_1 = mkN "kardinaltal" "kardinaltalet" "kardinaltalen" "kardinaltalena" ;
  kardiograf_nn_1 = mkN "kardiograf" "kardiografer" ;
  kardiogram_nn_1 = mkN "kardiogram" "kardiogrammet" "kardiogram" "kardiogrammen" ;
  kardiolog_nn_1 = mkN "kardiolog" "kardiologer" ;
  kardnubb_nn_1 = mkN "kardnubb" ;
  kardus_nn_1 = mkN "kardus" "karduser" ;
  karel_nn_1 = mkN "karel" "kareler" ;
  karelare_nn_1 = mkN "karelare" "karelare" ;
  karelsk_av_1 = mkA "karelsk" ;
  karensdag_nn_1 = mkN "karensdag" ;
  karess_nn_1 = mkN "karess" "karesser" ;
  karet_nn_1 = mkN "karet" "kareter" ;
  karg_av_1 = mkA "karg" ;
  karikatyr_nn_1 = mkN "karikatyr" "karikatyrer" ;
  karikatyrtecknare_nn_1 = mkN "karikatyrtecknare" "karikatyrtecknare" ;
  karisma_nn_1 = mkN "karisma" "karisman" "karismer" "karismerna" ;
  karismatisk_av_1 = mkA "karismatisk" ;
  karkas_nn_1 = mkN "karkas" "karkaser" ;
  karl_nn_1 = mkN "karl" ;
  karlakarl_nn_1 = mkN "karlakarl" ;
  karlaktig_av_1 = mkA "karlaktig" ;
  karlatag_nn_1 = mkN "karlatag" neutrum ;
  karlavulen_av_1 = mkA "karlavulen" "karlavulet" ;
  karldagsverke_nn_1 = mkN "karldagsverke" ;
  karled_nn_1 = mkN "karled" "karleder" ;
  karlgalen_av_1 = mkA "karlgalen" "karlgalet" ;
  karljohanssvamp_nn_1 = mkN "karljohanssvamp" ;
  karlsbaderbroed_nn_1 = mkN "karlsbaderbrцd" neutrum ;
  karlslok_nn_1 = mkN "karlslok" ;
  karltokig_av_1 = mkA "karltokig" ;
  karm_nn_1 = mkN "karm" ;
  karmelit_nn_1 = mkN "karmelit" "karmeliter" ;
  karmelitorden_nn_1 = mkN "karmelitorden" ;
  karmstol_nn_1 = mkN "karmstol" ;
  karnap_nn_1 = mkN "karnap" neutrum ;
  karneol_nn_1 = mkN "karneol" "karneoler" ;
  karneval_nn_1 = mkN "karneval" "karnevaler" ;
  karnis_nn_1 = mkN "karnis" "karniser" ;
  karnivor_nn_1 = mkN "karnivor" "karnivoren" "karnivorer" "karnivorerna" ;
  karolin_nn_1 = mkN "karolin" "karoliner" ;
  karoling_nn_1 = mkN "karoling" "karolinger" ;
  karolinsk_av_1 = mkA "karolinsk" ;
  kaross_nn_1 = mkN "kaross" "karosser" ;
  karosseri_nn_1 = mkN "karosseri" "karosserit" "karosserier" "karosserierna" ;
  karotin_nn_1 = mkN "karotin" "karotinet" "karotiner" "karotinerna" ;
  karott_nn_1 = mkN "karott" "karotter" ;
  karottunderlaegg_nn_1 = mkN "karottunderlдgg" neutrum ;
  karp_nn_1 = mkN "karp" ;
  karpfisk_nn_1 = mkN "karpfisk" ;
  karre_nn_1 = mkN "karrй" "karrйer" ;
  karriaer_nn_1 = mkN "karriдr" "karriдrer" ;
  karriaerdiplomat_nn_1 = mkN "karriдrdiplomat" "karriдrdiplomater" ;
  karriaerist_nn_1 = mkN "karriдrist" "karriдrister" ;
  karronad_nn_1 = mkN "karronad" "karronader" ;
  karsk_av_1 = mkA "karsk" ;
  karst_nn_1 = mkN "karst" "karster" ;
  karstbildning_nn_1 = mkN "karstbildning" ;
  kart_nn_1 = mkN "kart" ;
  kartagisk_av_1 = mkA "kartagisk" ;
  kartbild_nn_1 = mkN "kartbild" "kartbilder" ;
  kartbok_nn_1 = mkN "kartbok" "kartbцcker" ;
  kartell_nn_1 = mkN "kartell" "karteller" ;
  kartering_nn_1 = mkN "kartering" ;
  kartesch_nn_1 = mkN "kartesch" "kartescher" ;
  kartig_av_1 = mkA "kartig" ;
  kartlaeggning_nn_1 = mkN "kartlдggning" ;
  kartlaesare_nn_1 = mkN "kartlдsare" "kartlдsare" ;
  kartmaetare_nn_1 = mkN "kartmдtare" "kartmдtare" ;
  kartnagel_nn_1 = mkN "kartnagel" ;
  kartong_nn_1 = mkN "kartong" "kartonger" ;
  kartonist_nn_1 = mkN "kartonist" "kartonister" ;
  kartotek_nn_1 = mkN "kartotek" neutrum ;
  kartprojektion_nn_1 = mkN "kartprojektion" "kartprojektioner" ;
  kartspecial_nn_1 = mkN "kartspecial" "kartspecialer" ;
  karttecken_nn_1 = mkN "karttecken" "karttecknet" "karttecken" "karttecknen" ;
  kartusch_nn_1 = mkN "kartusch" "kartuscher" ;
  kartusian_nn_1 = mkN "kartusian" "kartusianer" ;
  kartusianorden_nn_1 = mkN "kartusianorden" ;
  karusell_nn_1 = mkN "karusell" "karuseller" ;
  karvsnitt_nn_1 = mkN "karvsnitt" neutrum ;
  karvstock_nn_1 = mkN "karvstock" ;
  karyatid_nn_1 = mkN "karyatid" "karyatider" ;
  kas_nn_1 = mkN "kas" ;
  kasack_nn_1 = mkN "kasack" "kasacker" ;
  kaschmirsjal_nn_1 = mkN "kaschmirsjal" ;
  kase_nn_1 = mkN "kase" utrum ;
  kasein_nn_1 = mkN "kasein" "kaseiner" ;
  kasematt_nn_1 = mkN "kasematt" "kasematter" ;
  kasern_nn_1 = mkN "kasern" "kaserner" ;
  kasernfoerbud_nn_1 = mkN "kasernfцrbud" neutrum ;
  kaserngaard_nn_1 = mkN "kaserngеrd" ;
  kashmir_nn_1 = mkN "kashmir" "kashmirer" ;
  kasino_nn_1 = mkN "kasino" "kasinot" "kasinon" "kasinona" ;
  kask_nn_1 = mkN "kask" ;
  kaskad_nn_1 = mkN "kaskad" "kaskader" ;
  kaskelot_nn_1 = mkN "kaskelot" "kaskeloter" ;
  kaskett_nn_1 = mkN "kaskett" "kasketter" ;
  kasko_nn_1 = mkN "kasko" "kaskot" "kaskon" "kaskona" ;
  kaskofoersaekring_nn_1 = mkN "kaskofцrsдkring" ;
  kasperteater_nn_1 = mkN "kasperteater" ;
  kass_av_1 = mkA "kass" ;
  kassa_nn_1 = mkN "kassa" ;
  kassaaffaer_nn_1 = mkN "kassaaffдr" "kassaaffдrer" ;
  kassaapparat_nn_1 = mkN "kassaapparat" "kassaapparater" ;
  kassabel_av_1 = mkA "kassabel" "kassabelt" "kassabla" "kassabla" "kassablare" "kassablast" "kassablaste" ;
  kassabok_nn_1 = mkN "kassabok" "kassabцcker" ;
  kassabrist_nn_1 = mkN "kassabrist" "kassabrister" ;
  kassakoep_nn_1 = mkN "kassakцp" neutrum ;
  kassakontrollapparat_nn_1 = mkN "kassakontrollapparat" "kassakontrollapparater" ;
  kassakreditiv_nn_1 = mkN "kassakreditiv" neutrum ;
  kassakvitto_nn_1 = mkN "kassakvitto" "kassakvittot" "kassakvitton" "kassakvittona" ;
  kassapjaes_nn_1 = mkN "kassapjдs" "kassapjдser" ;
  kassarabatt_nn_1 = mkN "kassarabatt" "kassarabatter" ;
  kassareserv_nn_1 = mkN "kassareserv" "kassareserver" ;
  kassaskaap_nn_1 = mkN "kassaskеp" neutrum ;
  kassaskrin_nn_1 = mkN "kassaskrin" neutrum ;
  kassation_nn_1 = mkN "kassation" "kassationer" ;
  kassationsdomstol_nn_1 = mkN "kassationsdomstol" ;
  kassavalv_nn_1 = mkN "kassavalv" neutrum ;
  kasse_nn_1 = mkN "kasse" utrum ;
  kassett_nn_1 = mkN "kassett" "kassetter" ;
  kassettband_nn_1 = mkN "kassettband" neutrum ;
  kassettbandspelare_nn_1 = mkN "kassettbandspelare" "kassettbandspelare" ;
  kassettdaeck_nn_1 = mkN "kassettdдck" neutrum ;
  kassoer_nn_1 = mkN "kassцr" "kassцrer" ;
  kassoerska_nn_1 = mkN "kassцrska" ;
  kassun_nn_1 = mkN "kassun" "kassuner" ;
  kast_nn_1 = mkN "kast" "kaster" ;
  kast_nn_2 = mkN "kast" neutrum ;
  kastal_nn_1 = mkN "kastal" "kastaler" ;
  kastanj_nn_1 = mkN "kastanj" "kastanjer" ;
  kastanje_nn_1 = mkN "kastanje" "kastanjer" ;
  kastanjebrun_av_1 = mkA "kastanjebrun" ;
  kastanjett_nn_1 = mkN "kastanjett" "kastanjetter" ;
  kastblock_nn_1 = mkN "kastblock" neutrum ;
  kastby_nn_1 = mkN "kastby" "kastbyn" "kastbyar" "kastbyarna" ;
  kastell_nn_1 = mkN "kastell" neutrum ;
  kastellan_nn_1 = mkN "kastellan" "kastellaner" ;
  kastilian_nn_1 = mkN "kastilian" "kastilianer" ;
  kastilianare_nn_1 = mkN "kastilianare" "kastilianare" ;
  kastilianska_nn_2 = mkN "kastilianska" ;
  kastloes_av_1 = mkA "kastlцs" ;
  kastmaerke_nn_1 = mkN "kastmдrke" ;
  kastmaskin_nn_1 = mkN "kastmaskin" "kastmaskiner" ;
  kastpjaes_nn_1 = mkN "kastpjдs" "kastpjдser" ;
  kastrat_nn_1 = mkN "kastrat" "kastrater" ;
  kastratsaangare_nn_1 = mkN "kastratsеngare" "kastratsеngare" ;
  kastrull_nn_1 = mkN "kastrull" "kastruller" ;
  kastsoem_nn_1 = mkN "kastsцm" "kastsцmmen" "kastsцmmar" "kastsцmmarna" ;
  kastspjut_nn_1 = mkN "kastspjut" neutrum ;
  kastspoe_nn_1 = mkN "kastspц" "kastspцet" "kastspцn" "kastspцna" ;
  kaststygn_nn_1 = mkN "kaststygn" neutrum ;
  kasttrae_nn_1 = mkN "kasttrд" "kasttrдet" "kasttrдn" "kasttrдna" ;
  kastvapen_nn_1 = mkN "kastvapen" "kastvapnet" "kastvapen" "kastvapnen" ;
  kastvind_nn_1 = mkN "kastvind" ;
  kasuar_nn_1 = mkN "kasuar" "kasuarer" ;
  kasuell_av_1 = mkA "kasuell" ;
  kasun_nn_1 = mkN "kasun" "kasuner" ;
  kasus_nn_1 = mkN "kasus" neutrum ;
  kasus_nn_2 = mkN "kasus" "kasus" "kasus" "kasusen" ;
  katabatisk_av_1 = mkA "katabatisk" ;
  katafalk_nn_1 = mkN "katafalk" "katafalker" ;
  kataforisk_av_1 = mkA "kataforisk" ;
  katakomb_nn_1 = mkN "katakomb" "katakomber" ;
  katakres_nn_1 = mkN "katakres" "katakreser" ;
  katalan_nn_1 = mkN "katalan" "katalaner" ;
  katalanska_nn_2 = mkN "katalanska" ;
  katalektisk_av_1 = mkA "katalektisk" ;
  katalepsi_nn_1 = mkN "katalepsi" "katalepsier" ;
  katalog_nn_1 = mkN "katalog" "kataloger" ;
  katalognummer_nn_1 = mkN "katalognummer" neutrum ;
  katalogpris_nn_1 = mkN "katalogpris" neutrum ;
  katalysator_nn_1 = mkN "katalysator" "katalysatorer" ;
  katalytisk_av_1 = mkA "katalytisk" ;
  katamaran_nn_1 = mkN "katamaran" "katamaraner" ;
  katapult_nn_1 = mkN "katapult" "katapulter" ;
  katapultstol_nn_1 = mkN "katapultstol" ;
  katarakt_nn_1 = mkN "katarakt" "katarakter" ;
  katarr_nn_1 = mkN "katarr" "katarrer" ;
  katastrof_nn_1 = mkN "katastrof" "katastrofer" ;
  katastrofal_av_1 = mkA "katastrofal" ;
  katastrofteori_nn_1 = mkN "katastrofteori" "katastrofteorier" ;
  kateder_nn_1 = mkN "kateder" ;
  katedral_nn_1 = mkN "katedral" "katedraler" ;
  kategori_nn_1 = mkN "kategori" "kategorier" ;
  kategoriklyvning_nn_1 = mkN "kategoriklyvning" ;
  kategorisk_av_1 = mkA "kategorisk" ;
  katekes_nn_1 = mkN "katekes" "katekeser" ;
  kateket_nn_1 = mkN "kateket" "kateketer" ;
  kateketisk_av_1 = mkA "kateketisk" ;
  katet_nn_1 = mkN "katet" "kateter" ;
  kateter_nn_1 = mkN "kateter" ;
  katig_av_1 = mkA "katig" ;
  katjon_nn_1 = mkN "katjon" "katjoner" ;
  katod_nn_1 = mkN "katod" "katoder" ;
  katodstraale_nn_1 = mkN "katodstrеle" utrum ;
  katodstraaleroer_nn_1 = mkN "katodstrеlerцr" neutrum ;
  katolik_nn_1 = mkN "katolik" "katoliker" ;
  katolsk_av_1 = mkA "katolsk" ;
  katrinplommon_nn_1 = mkN "katrinplommon" neutrum ;
  katse_nn_1 = mkN "katse" utrum ;
  katt_nn_1 = mkN "katt" "katter" ;
  kattaktig_av_1 = mkA "kattaktig" ;
  kattass_nn_1 = mkN "kattass" ;
  kattdjur_nn_1 = mkN "kattdjur" neutrum ;
  kattoega_nn_1 = mkN "kattцga" "kattцgat" "kattцgon" "kattцgonen" ;
  kattras_nn_1 = mkN "kattras" "kattraser" ;
  kattun_nn_1 = mkN "kattun" "kattuner" ;
  kattunge_nn_1 = mkN "kattunge" utrum ;
  kaukasier_nn_1 = mkN "kaukasier" "kaukasiern" "kaukasier" "kaukasierna" ;
  kaukasisk_av_1 = mkA "kaukasisk" ;
  kaukasiska_nn_1 = mkN "kaukasiska" ;
  kauri_nn_1 = mkN "kauri" "kaurin" "kaurier" "kaurierna" ;
  kaus_nn_1 = mkN "kaus" "kauser" ;
  kausal_av_1 = mkA "kausal" ;
  kausalfoerhaallande_nn_1 = mkN "kausalfцrhеllande" ;
  kausalitet_nn_1 = mkN "kausalitet" "kausaliteter" ;
  kausalsats_nn_1 = mkN "kausalsats" "kausalsatser" ;
  kausativ_av_1 = mkA "kausativ" ;
  kaustik_av_1 = mkA "kaustik" ;
  kaution_nn_1 = mkN "kaution" "kautioner" ;
  kautschuk_nn_1 = mkN "kautschuk" ;
  kautschukparagraf_nn_1 = mkN "kautschukparagraf" "kautschukparagrafer" ;
  kautschuktraed_nn_1 = mkN "kautschuktrдd" neutrum ;
  kav_ab_1 = mkAdv "kav" ;
  kavaj_nn_1 = mkN "kavaj" "kavajer" ;
  kavajkrage_nn_1 = mkN "kavajkrage" utrum ;
  kavalett_nn_1 = mkN "kavalett" "kavaletter" ;
  kavaljer_nn_1 = mkN "kavaljer" "kavaljerer" ;
  kavaljersflygel_nn_1 = mkN "kavaljersflygel" ;
  kavalkad_nn_1 = mkN "kavalkad" "kavalkader" ;
  kavall_nn_1 = mkN "kavall" "kavaller" ;
  kavalleri_nn_1 = mkN "kavalleri" "kavallerit" "kavallerier" "kavallerierna" ;
  kavallerichock_nn_1 = mkN "kavallerichock" "kavallerichocker" ;
  kavallerist_nn_1 = mkN "kavallerist" "kavallerister" ;
  kavalleritrupp_nn_1 = mkN "kavalleritrupp" "kavalleritrupper" ;
  kavat_av_1 = mkA "kavat" "kavat" ;
  kavel_nn_1 = mkN "kavel" ;
  kavelbro_nn_1 = mkN "kavelbro" ;
  kavern_nn_1 = mkN "kavern" "kaverner" ;
  kavitet_nn_1 = mkN "kavitet" "kaviteter" ;
  kavitetsdjur_nn_1 = mkN "kavitetsdjur" neutrum ;
  kavle_nn_1 = mkN "kavle" utrum ;
  kavring_nn_1 = mkN "kavring" ;
  kaxe_nn_1 = mkN "kaxe" utrum ;
  kaxig_av_1 = mkA "kaxig" ;
  ked_nn_1 = mkN "ked" "keder" ;
  kediv_nn_1 = mkN "kediv" "kediver" ;
  kedja_nn_1 = mkN "kedja" ;
  kedjebraak_nn_1 = mkN "kedjebrеk" neutrum ;
  kedjebrev_nn_1 = mkN "kedjebrev" neutrum ;
  kedjehjul_nn_1 = mkN "kedjehjul" neutrum ;
  kedjehus_nn_1 = mkN "kedjehus" neutrum ;
  kedjemolekyl_nn_1 = mkN "kedjemolekyl" "kedjemolekyler" ;
  kedjereaktion_nn_1 = mkN "kedjereaktion" "kedjereaktioner" ;
  kedjeskydd_nn_1 = mkN "kedjeskydd" neutrum ;
  kedjesoem_nn_1 = mkN "kedjesцm" "kedjesцmmen" "kedjesцmmar" "kedjesцmmarna" ;
  kedjestygn_nn_1 = mkN "kedjestygn" neutrum ;
  kedjevaexel_nn_1 = mkN "kedjevдxel" ;
  kejsardoeme_nn_1 = mkN "kejsardцme" ;
  kejsare_nn_1 = mkN "kejsare" "kejsare" ;
  kejsarhaer_nn_1 = mkN "kejsarhдr" ;
  kejsarinna_nn_1 = mkN "kejsarinna" ;
  kejsaroern_nn_1 = mkN "kejsarцrn" ;
  kejsarsnitt_nn_1 = mkN "kejsarsnitt" neutrum ;
  kejserlig_av_1 = mkA "kejserlig" ;
  kelen_av_1 = mkA "kelen" "kelet" ;
  kelgris_nn_1 = mkN "kelgris" ;
  kelig_av_1 = mkA "kelig" ;
  kelim_nn_1 = mkN "kelim" "kelimer" ;
  kelsjuk_av_1 = mkA "kelsjuk" ;
  kelt_nn_1 = mkN "kelt" "kelter" ;
  keltisk_av_1 = mkA "keltisk" ;
  keltiska_nn_2 = mkN "keltiska" ;
  kelvin_nn_1 = mkN "kelvin" "kelvinen" "kelvin" "kelvinen" ;
  kemiindustri_nn_1 = mkN "kemiindustri" "kemiindustrier" ;
  kemisk_av_1 = mkA "kemisk" ;
  kemist_nn_1 = mkN "kemist" "kemister" ;
  kemomat_nn_1 = mkN "kemomat" "kemomater" ;
  kemoterapi_nn_1 = mkN "kemoterapi" "kemoterapier" ;
  kemtvaett_nn_1 = mkN "kemtvдtt" ;
  kennel_nn_1 = mkN "kennel" ;
  kenning_nn_1 = mkN "kenning" ;
  kentaur_nn_1 = mkN "kentaur" "kentaurer" ;
  kenyan_nn_1 = mkN "kenyan" "kenyaner" ;
  keps_nn_1 = mkN "keps" ;
  keramiker_nn_1 = mkN "keramiker" "keramikern" "keramiker" "keramikerna" ;
  keramikform_nn_1 = mkN "keramikform" "keramikformer" ;
  kerub_nn_1 = mkN "kerub" "keruber" ;
  ketch_nn_1 = mkN "ketch" "ketcher" ;
  kex_nn_1 = mkN "kex" neutrum ;
  khan_nn_1 = mkN "khan" "khaner" ;
  khmer_nn_1 = mkN "khmer" "khmerer" ;
  kiasm_nn_1 = mkN "kiasm" "kiasmer" ;
  kibbutz_nn_1 = mkN "kibbutz" "kibbutzer" ;
  kick_nn_1 = mkN "kick" ;
  kickstart_nn_1 = mkN "kickstart" "kickstarter" ;
  kid_nn_1 = mkN "kid" neutrum ;
  kidnappare_nn_1 = mkN "kidnappare" "kidnappare" ;
  kikaert_nn_1 = mkN "kikдrt" "kikдrter" ;
  kikare_nn_1 = mkN "kikare" "kikare" ;
  kikhaal_nn_1 = mkN "kikhеl" neutrum ;
  kikkran_nn_1 = mkN "kikkran" ;
  kil_nn_1 = mkN "kil" ;
  kilben_nn_1 = mkN "kilben" neutrum ;
  kilhael_nn_1 = mkN "kilhдl" ;
  kilklack_nn_1 = mkN "kilklack" ;
  kille_nn_1 = mkN "kille" utrum ;
  killespel_nn_1 = mkN "killespel" "killespelet" "killespel" "killespelen" ;
  killig_av_1 = mkA "killig" ;
  killing_nn_1 = mkN "killing" ;
  kilo_nn_1 = mkN "kilo" "kilot" "kilo" "kilona" ;
  kilobyte_nn_1 = mkN "kilobyte" "kilobyten" "kilobyte" "kilobytena" ;
  kilogram_nn_1 = mkN "kilogram" "kilogrammet" "kilogram" "kilogrammen" ;
  kilogrammeter_nn_1 = mkN "kilogrammeter" ;
  kilometer_nn_1 = mkN "kilometer" ;
  kilometertjock_av_1 = mkA "kilometertjock" ;
  kilopond_nn_1 = mkN "kilopond" neutrum ;
  kilopondmeter_nn_1 = mkN "kilopondmeter" "kilopondmetern" "kilopondmeter" "kilopondmeterna" ;
  kilopris_nn_1 = mkN "kilopris" neutrum ;
  kiloton_nn_1 = mkN "kiloton" "kilotonnet" "kiloton" "kilotonnen" ;
  kilowatt_nn_1 = mkN "kilowatt" "kilowatten" "kilowatt" "kilowatten" ;
  kilram_nn_1 = mkN "kilram" ;
  kilt_nn_1 = mkN "kilt" ;
  kimono_nn_1 = mkN "kimono" "kimonon" "kimonos" "kimonosen" ;
  kinaalkaloid_nn_1 = mkN "kinaalkaloid" "kinaalkaloider" ;
  kind_nn_1 = mkN "kind" "kinder" ;
  kindben_nn_1 = mkN "kindben" neutrum ;
  kindkedja_nn_1 = mkN "kindkedja" ;
  kindpaase_nn_1 = mkN "kindpеse" utrum ;
  kindpust_nn_1 = mkN "kindpust" ;
  kindtand_nn_1 = mkN "kindtand" "kindtдnder" ;
  kinematograf_nn_1 = mkN "kinematograf" "kinematografer" ;
  kines_nn_1 = mkN "kines" "kineser" ;
  kineseri_nn_1 = mkN "kineseri" "kineserit" "kineserier" "kineserierna" ;
  kinesisk_av_1 = mkA "kinesisk" ;
  kinesiska_nn_2 = mkN "kinesiska" ;
  kinestetisk_av_1 = mkA "kinestetisk" ;
  kinetisk_av_1 = mkA "kinetisk" ;
  king_size_av_1 = mkA "king-size" ;
  kink_nn_1 = mkN "kink" ;
  kinkig_av_1 = mkA "kinkig" ;
  kiosk_nn_1 = mkN "kiosk" "kiosker" ;
  kip_nn_1 = mkN "kip" ;
  kippsko_nn_1 = mkN "kippsko" "kippskor" ;
  kippskodd_av_1 = mkA "kippskodd" "kippskodtt" ;
  kirgis_nn_1 = mkN "kirgis" "kirgiser" ;
  kiribatier_nn_1 = mkN "kiribatier" "kiribatiern" "kiribatier" "kiribatierna" ;
  kiribatisk_av_1 = mkA "kiribatisk" ;
  kiropraktiker_nn_1 = mkN "kiropraktiker" "kiropraktikern" "kiropraktiker" "kiropraktikerna" ;
  kiropraktor_nn_1 = mkN "kiropraktor" "kiropraktorer" ;
  kirurg_nn_1 = mkN "kirurg" "kirurger" ;
  kirurgisk_av_1 = mkA "kirurgisk" ;
  kis_nn_1 = mkN "kis" "kiser" ;
  kis_nn_2 = mkN "kis" ;
  kiselalg_nn_1 = mkN "kiselalg" "kiselalger" ;
  kiselfoerening_nn_1 = mkN "kiselfцrening" ;
  kiselkristall_nn_1 = mkN "kiselkristall" "kiselkristaller" ;
  kiselsten_nn_1 = mkN "kiselsten" "kiselstenen" "kiselstenar" "kiselstenarna" ;
  kisse_nn_1 = mkN "kisse" utrum ;
  kissekatt_nn_1 = mkN "kissekatt" "kissekatter" ;
  kissemiss_nn_1 = mkN "kissemiss" ;
  kissnoedig_av_1 = mkA "kissnцdig" ;
  kistbotten_nn_1 = mkN "kistbotten" ;
  kistebrev_nn_1 = mkN "kistebrev" neutrum ;
  kiton_nn_1 = mkN "kiton" "kitoner" ;
  kitslig_av_1 = mkA "kitslig" ;
  kittel_nn_1 = mkN "kittel" ;
  kitteldal_nn_1 = mkN "kitteldal" ;
  kittelflickare_nn_1 = mkN "kittelflickare" "kittelflickare" ;
  kittlare_nn_1 = mkN "kittlare" "kittlare" ;
  kittlig_av_1 = mkA "kittlig" ;
  kivi_nn_1 = mkN "kivi" "kivin" "kivier" "kivierna" ;
  kiwi_nn_1 = mkN "kiwi" "kiwin" "kiwier" "kiwierna" ;
  kjol_nn_1 = mkN "kjol" ;
  kjoltyg_nn_1 = mkN "kjoltyg" neutrum ;
  kjortel_nn_1 = mkN "kjortel" ;
  kjortelvaegen_ab_1 = mkAdv "kjortelvдgen" ;
  klaafingrig_av_1 = mkA "klеfingrig" ;
  klaapare_nn_1 = mkN "klеpare" "klеpare" ;
  klabb_nn_1 = mkN "klabb" ;
  klabbe_nn_1 = mkN "klabbe" utrum ;
  klabbskoet_nn_1 = mkN "klabbskцt" ;
  klabbstroemming_nn_1 = mkN "klabbstrцmming" ;
  klack_nn_1 = mkN "klack" ;
  klackbar_nn_1 = mkN "klackbar" "klackbarer" ;
  klackjaern_nn_1 = mkN "klackjдrn" neutrum ;
  klackring_nn_1 = mkN "klackring" ;
  klackspark_nn_1 = mkN "klackspark" ;
  kladd_nn_1 = mkN "kladd" ;
  kladdig_av_1 = mkA "kladdig" ;
  klaedd_av_1 = mkA "klдdd" ;
  klaededraekt_nn_1 = mkN "klдdedrдkt" "klдdedrдkter" ;
  klaedespersedel_nn_1 = mkN "klдdespersedel" ;
  klaedesplagg_nn_1 = mkN "klдdesplagg" neutrum ;
  klaedgalen_av_1 = mkA "klдdgalen" "klдdgalet" ;
  klaedhaengare_nn_1 = mkN "klдdhдngare" "klдdhдngare" ;
  klaedkammare_nn_1 = mkN "klдdkammare" "klдdkammaren" "klдdkamrar" "klдdkamrarna" ;
  klaedkorg_nn_1 = mkN "klдdkorg" ;
  klaedlus_nn_1 = mkN "klдdlus" "klдdlusen" "klдdlцss" "klдdlцssen" ;
  klaedmal_nn_1 = mkN "klдdmal" ;
  klaednad_nn_1 = mkN "klдdnad" "klдdnader" ;
  klaedsam_av_1 = mkA "klдdsam" "klдdsamt" "klдdsamma" "klдdsamma" "klдdsammare" "klдdsammast" "klдdsammaste" ;
  klaedsel_nn_1 = mkN "klдdsel" ;
  klaedskaap_nn_1 = mkN "klдdskеp" neutrum ;
  klaedstreck_nn_1 = mkN "klдdstreck" neutrum ;
  klaedtvaett_nn_1 = mkN "klдdtvдtt" ;
  klaem_nn_1 = mkN "klдm" "klдmmen" "klдmmar" "klдmmarna" ;
  klaemdag_nn_1 = mkN "klдmdag" ;
  klaemmare_nn_1 = mkN "klдmmare" "klдmmare" ;
  klaemmig_av_1 = mkA "klдmmig" ;
  klaemtare_nn_1 = mkN "klдmtare" "klдmtare" ;
  klaengig_av_1 = mkA "klдngig" ;
  klaengvaext_nn_1 = mkN "klдngvдxt" "klдngvдxter" ;
  klaenning_nn_1 = mkN "klдnning" ;
  klaenningsliv_nn_1 = mkN "klдnningsliv" neutrum ;
  klaepp_nn_1 = mkN "klдpp" ;
  klaervoajant_av_1 = mkA "klдrvoajant" "klдrvoajant" ;
  klaett_nn_1 = mkN "klдtt" ;
  klaetterfaagel_nn_1 = mkN "klдtterfеgel" ;
  klaetterfot_nn_1 = mkN "klдtterfot" "klдtterfцtter" ;
  klaetterjaern_nn_1 = mkN "klдtterjдrn" neutrum ;
  klaettersko_nn_1 = mkN "klдttersko" "klдtterskor" ;
  klaetterstaellning_nn_1 = mkN "klдtterstдllning" ;
  klaettervaext_nn_1 = mkN "klдttervдxt" "klдttervдxter" ;
  klaettrare_nn_1 = mkN "klдttrare" "klдttrare" ;
  klaettring_nn_1 = mkN "klдttring" ;
  klaff_nn_1 = mkN "klaff" ;
  klaffbord_nn_1 = mkN "klaffbord" neutrum ;
  klaffbro_nn_1 = mkN "klaffbro" ;
  klaffel_nn_1 = mkN "klaffel" "klaffelet" "klaffel" "klaffelen" ;
  klagande_nn_1 = mkN "klagande" "klaganden" "klagande" "klagandena" ;
  klagomaal_nn_1 = mkN "klagomеl" neutrum ;
  klagomur_nn_1 = mkN "klagomur" ;
  klagorop_nn_1 = mkN "klagorop" neutrum ;
  klagosaang_nn_1 = mkN "klagosеng" "klagosеnger" ;
  klagotid_nn_1 = mkN "klagotid" "klagotider" ;
  klam_nn_1 = mkN "klam" "klammen" "klammar" "klammarna" ;
  klammer_nn_1 = mkN "klammer" "klammern" "klammer" "klammerna" ;
  klammeri_nn_1 = mkN "klammeri" "klammerit" "klammerier" "klammerierna" ;
  klamp_nn_1 = mkN "klamp" ;
  klan_nn_1 = mkN "klan" "klaner" ;
  klanderfri_av_1 = mkA "klanderfri" "klanderfritt" ;
  klandervaerd_av_1 = mkA "klandervдrd" "klandervдrt" ;
  klang_nn_1 = mkN "klang" "klanger" ;
  klangbotten_nn_1 = mkN "klangbotten" ;
  klangfaerg_nn_1 = mkN "klangfдrg" "klangfдrger" ;
  klangfull_av_1 = mkA "klangfull" ;
  klanglig_av_1 = mkA "klanglig" ;
  klangloes_av_1 = mkA "klanglцs" ;
  klant_nn_1 = mkN "klant" ;
  klantig_av_1 = mkA "klantig" ;
  klantskalle_nn_1 = mkN "klantskalle" utrum ;
  klapp_nn_1 = mkN "klapp" ;
  klappbraede_nn_1 = mkN "klappbrдde" ;
  klappersten_nn_1 = mkN "klappersten" "klapperstenen" "klapperstenar" "klapperstenarna" ;
  klapperstenstrand_nn_1 = mkN "klapperstenstrand" "klapperstenstrдnder" ;
  klappjakt_nn_1 = mkN "klappjakt" "klappjakter" ;
  klapptrae_nn_1 = mkN "klapptrд" "klapptrдet" "klapptrдn" "klapptrдna" ;
  klar_av_1 = mkA "klar" ;
  klarbaer_nn_1 = mkN "klarbдr" neutrum ;
  klarblaa_av_1 = mkA "klarblе" "klarblеtt" ;
  klarhet_nn_1 = mkN "klarhet" "klarheter" ;
  klarinett_nn_1 = mkN "klarinett" "klarinetter" ;
  klarligen_ab_1 = mkAdv "klarligen" ;
  klarmedel_nn_1 = mkN "klarmedel" neutrum ;
  klaroegd_av_1 = mkA "klarцgd" "klarцgt" ;
  klarroed_av_1 = mkA "klarrцd" ;
  klarsignal_nn_1 = mkN "klarsignal" "klarsignaler" ;
  klarskinn_nn_1 = mkN "klarskinn" neutrum ;
  klarsynt_av_1 = mkA "klarsynt" "klarsynt" ;
  klartaenkt_av_1 = mkA "klartдnkt" "klartдnkt" ;
  klartecken_nn_1 = mkN "klartecken" "klartecknet" "klartecken" "klartecknen" ;
  klarvaken_av_1 = mkA "klarvaken" "klarvaket" ;
  klase_nn_1 = mkN "klase" utrum ;
  klass_nn_1 = mkN "klass" "klasser" ;
  klassbok_nn_1 = mkN "klassbok" "klassbцcker" ;
  klassfoerestaandare_nn_1 = mkN "klassfцrestеndare" "klassfцrestеndare" ;
  klassicitet_nn_1 = mkN "klassicitet" "klassiciteter" ;
  klassificering_nn_1 = mkN "klassificering" ;
  klassifikation_nn_1 = mkN "klassifikation" "klassifikationer" ;
  klassik_nn_1 = mkN "klassik" "klassiker" ;
  klassiker_nn_1 = mkN "klassiker" "klassikern" "klassiker" "klassikerna" ;
  klassiserande_av_1 = mkA "klassiserande" ;
  klassisk_av_1 = mkA "klassisk" ;
  klasskamp_nn_1 = mkN "klasskamp" "klasskamper" ;
  klasskamrat_nn_1 = mkN "klasskamrat" "klasskamrater" ;
  klasskillnad_nn_1 = mkN "klasskillnad" "klasskillnader" ;
  klasskonferens_nn_1 = mkN "klasskonferens" "klasskonferenser" ;
  klasslaerare_nn_1 = mkN "klasslдrare" "klasslдrare" ;
  klasslag_nn_1 = mkN "klasslag" ;
  klasslag_nn_2 = mkN "klasslag" neutrum ;
  klassloes_av_1 = mkA "klasslцs" ;
  klassmaerke_nn_1 = mkN "klassmдrke" ;
  klassmamma_nn_1 = mkN "klassmamma" ;
  klassmedveten_av_1 = mkA "klassmedveten" "klassmedvetet" ;
  klassmoerj_nn_1 = mkN "klassmцrj" neutrum ;
  klassmotsaettning_nn_1 = mkN "klassmotsдttning" ;
  klasspappa_nn_1 = mkN "klasspappa" ;
  klassrum_nn_1 = mkN "klassrum" "klassrummet" "klassrum" "klassrummen" ;
  klatsch_nn_1 = mkN "klatsch" ;
  klatschig_av_1 = mkA "klatschig" ;
  klausul_nn_1 = mkN "klausul" "klausuler" ;
  klav_nn_1 = mkN "klav" "klaver" ;
  klavbinda_vb_1 = mkV "klavbinda" "klavband" "klavbundit" ;
  klave_nn_1 = mkN "klave" utrum ;
  klavecin_nn_1 = mkN "klavecin" "klaveciner" ;
  klaver_nn_1 = mkN "klaver" "klaveret" "klaver" "klaveren" ;
  klavertramp_nn_1 = mkN "klavertramp" neutrum ;
  klaverutdrag_nn_1 = mkN "klaverutdrag" neutrum ;
  klaviatur_nn_1 = mkN "klaviatur" "klaviaturer" ;
  klavikord_nn_1 = mkN "klavikord" neutrum ;
  klematis_nn_1 = mkN "klematis" ;
  klementin_nn_1 = mkN "klementin" "klementiner" ;
  klemig_av_1 = mkA "klemig" ;
  klen_av_1 = mkA "klen" ;
  klenaet_nn_1 = mkN "klenдt" "klenдter" ;
  klenhus_nn_1 = mkN "klenhus" neutrum ;
  klenod_nn_1 = mkN "klenod" "klenoder" ;
  klensmed_nn_1 = mkN "klensmed" "klensmeder" ;
  klensmide_nn_1 = mkN "klensmide" ;
  klenspaenning_nn_1 = mkN "klenspдnning" ;
  klentrogen_av_1 = mkA "klentrogen" "klentroget" ;
  klenvuxen_av_1 = mkA "klenvuxen" "klenvuxet" ;
  kleptoman_nn_1 = mkN "kleptoman" "kleptomaner" ;
  klerikal_av_1 = mkA "klerikal" ;
  klerk_nn_1 = mkN "klerk" "klerker" ;
  kletig_av_1 = mkA "kletig" ;
  klev_nn_1 = mkN "klev" neutrum ;
  klibbal_nn_1 = mkN "klibbal" ;
  klibbig_av_1 = mkA "klibbig" ;
  kliche_nn_1 = mkN "klichй" "klichйer" ;
  klick_nn_1 = mkN "klick" ;
  klick_nn_2 = mkN "klick" neutrum ;
  klient_nn_1 = mkN "klient" "klienter" ;
  klientel_nn_1 = mkN "klientel" "klientelet" "klientel" "klientelen" ;
  klimat_nn_1 = mkN "klimat" neutrum ;
  klimatfoeraendring_nn_1 = mkN "klimatfцrдndring" ;
  klimatforskare_nn_1 = mkN "klimatforskare" "klimatforskare" ;
  klimatgraens_nn_1 = mkN "klimatgrдns" "klimatgrдnser" ;
  klimatkammare_nn_1 = mkN "klimatkammare" "klimatkammaren" "klimatkamrar" "klimatkamrarna" ;
  klimatmodell_nn_1 = mkN "klimatmodell" "klimatmodeller" ;
  klimatologisk_av_1 = mkA "klimatologisk" ;
  klimatombyte_nn_1 = mkN "klimatombyte" ;
  klimatskael_nn_1 = mkN "klimatskдl" neutrum ;
  klimatsystem_nn_1 = mkN "klimatsystem" neutrum ;
  klimatvariation_nn_1 = mkN "klimatvariation" "klimatvariationer" ;
  klimatzon_nn_1 = mkN "klimatzon" "klimatzoner" ;
  klimax_nn_1 = mkN "klimax" ;
  klimp_nn_1 = mkN "klimp" ;
  klinhus_nn_1 = mkN "klinhus" neutrum ;
  klinik_nn_1 = mkN "klinik" "kliniker" ;
  kliniker_nn_1 = mkN "kliniker" "klinikern" "kliniker" "klinikerna" ;
  klinisk_av_1 = mkA "klinisk" ;
  klinkbyggd_av_1 = mkA "klinkbyggd" "klinkbyggt" ;
  klint_nn_1 = mkN "klint" ;
  klipp_nn_1 = mkN "klipp" neutrum ;
  klippare_nn_1 = mkN "klippare" "klippare" ;
  klippblock_nn_1 = mkN "klippblock" neutrum ;
  klippdass_nn_1 = mkN "klippdass" ;
  klipper_nn_1 = mkN "klipper" ;
  klipperstaev_nn_1 = mkN "klipperstдv" ;
  klippfisk_nn_1 = mkN "klippfisk" ;
  klippformation_nn_1 = mkN "klippformation" "klippformationer" ;
  klippfyr_nn_1 = mkN "klippfyr" ;
  klippgrav_nn_1 = mkN "klippgrav" ;
  klippig_av_1 = mkA "klippig" ;
  klipping_nn_1 = mkN "klipping" ;
  klippkort_nn_1 = mkN "klippkort" neutrum ;
  klippljus_nn_1 = mkN "klippljus" neutrum ;
  klippmaalning_nn_1 = mkN "klippmеlning" ;
  klippmassiv_nn_1 = mkN "klippmassiv" neutrum ;
  klippning_nn_1 = mkN "klippning" ;
  klippotek_nn_1 = mkN "klippotek" neutrum ;
  klippspik_nn_1 = mkN "klippspik" ;
  klipptaang_nn_1 = mkN "klipptеng" "klipptдnger" ;
  klippvaegg_nn_1 = mkN "klippvдgg" ;
  klipsk_av_1 = mkA "klipsk" ;
  klistrig_av_1 = mkA "klistrig" ;
  klitoris_nn_1 = mkN "klitoris" ;
  kliv_nn_1 = mkN "kliv" neutrum ;
  klo_nn_1 = mkN "klo" "klor" ;
  kloak_nn_1 = mkN "kloak" "kloaker" ;
  kloakdjur_nn_1 = mkN "kloakdjur" neutrum ;
  kloasongvaegg_nn_1 = mkN "kloasongvдgg" ;
  klockare_nn_1 = mkN "klockare" "klockare" ;
  klockarkaerlek_nn_1 = mkN "klockarkдrlek" ;
  klockarkatt_nn_1 = mkN "klockarkatt" "klockarkatter" ;
  klockboj_nn_1 = mkN "klockboj" ;
  klockformig_av_1 = mkA "klockformig" ;
  klockkedja_nn_1 = mkN "klockkedja" ;
  klockklaepp_nn_1 = mkN "klockklдpp" ;
  klockren_av_1 = mkA "klockren" ;
  klockringning_nn_1 = mkN "klockringning" ;
  klocksignal_nn_1 = mkN "klocksignal" "klocksignaler" ;
  klockslag_nn_1 = mkN "klockslag" neutrum ;
  klockspel_nn_1 = mkN "klockspel" "klockspelet" "klockspel" "klockspelen" ;
  klockstapel_nn_1 = mkN "klockstapel" ;
  klockstraeng_nn_1 = mkN "klockstrдng" ;
  klocktid_nn_1 = mkN "klocktid" "klocktider" ;
  klocktorn_nn_1 = mkN "klocktorn" neutrum ;
  kloev_nn_1 = mkN "klцv" ;
  kloever_nn_1 = mkN "klцver" "klцvern" "klцver" "klцverna" ;
  kloeverblad_nn_1 = mkN "klцverblad" neutrum ;
  kloeverliknande_av_1 = mkA "klцverliknande" ;
  kloeversnaerja_nn_1 = mkN "klцversnдrja" ;
  kloevertroett_av_1 = mkA "klцvertrцtt" ;
  kloevjeren_nn_1 = mkN "klцvjeren" "klцvjerenen" "klцvjerenar" "klцvjerenarna" ;
  kloevjesadel_nn_1 = mkN "klцvjesadel" ;
  kloevsadel_nn_1 = mkN "klцvsadel" ;
  kloevsadelkyrka_nn_1 = mkN "klцvsadelkyrka" ;
  kloevsadelsbyggnad_nn_1 = mkN "klцvsadelsbyggnad" "klцvsadelsbyggnader" ;
  kloevsadelskyrka_nn_1 = mkN "klцvsadelskyrka" ;
  klok_av_1 = mkA "klok" ;
  klokhuvud_nn_1 = mkN "klokhuvud" "klokhuvudet" "klokhuvuden" "klokhuvudena" ;
  klon_nn_1 = mkN "klon" "kloner" ;
  klonering_nn_1 = mkN "klonering" ;
  klorat_nn_1 = mkN "klorat" neutrum ;
  kloratom_nn_1 = mkN "kloratom" "kloratomer" ;
  klorfenol_nn_1 = mkN "klorfenol" "klorfenoler" ;
  klorid_nn_1 = mkN "klorid" "klorider" ;
  klosett_nn_1 = mkN "klosett" "klosetter" ;
  kloss_ab_1 = mkAdv "kloss" ;
  kloss_nn_1 = mkN "kloss" ;
  klossig_av_1 = mkA "klossig" ;
  kloster_nn_1 = mkN "kloster" neutrum ;
  klosterbroder_nn_1 = mkN "klosterbroder" "klosterbrodern" "klosterbrцder" "klosterbrцderna" ;
  klostercell_nn_1 = mkN "klostercell" "klosterceller" ;
  klosterkyrka_nn_1 = mkN "klosterkyrka" ;
  klosterlikoer_nn_1 = mkN "klosterlikцr" "klosterlikцrer" ;
  klosterorden_nn_1 = mkN "klosterorden" ;
  klosterregel_nn_1 = mkN "klosterregel" "klosterregeln" "klosterregler" "klosterreglerna" ;
  klostersyster_nn_1 = mkN "klostersyster" ;
  klot_nn_1 = mkN "klot" neutrum ;
  klotblixt_nn_1 = mkN "klotblixt" ;
  klotrund_av_1 = mkA "klotrund" ;
  klots_nn_1 = mkN "klots" ;
  klotterplank_nn_1 = mkN "klotterplank" neutrum ;
  klottrig_av_1 = mkA "klottrig" ;
  klove_nn_1 = mkN "klove" utrum ;
  klubb_nn_1 = mkN "klubb" ;
  klubbafton_nn_1 = mkN "klubbafton" "klubbaftonen" "klubbaftnar" "klubbaftnarna" ;
  klubblaengd_nn_1 = mkN "klubblдngd" "klubblдngder" ;
  klubbmaerke_nn_1 = mkN "klubbmдrke" ;
  klubbmaestare_nn_1 = mkN "klubbmдstare" "klubbmдstare" ;
  klubbsandwich_nn_1 = mkN "klubbsandwich" ;
  klubbslag_nn_1 = mkN "klubbslag" neutrum ;
  kludd_nn_2 = mkN "kludd" ;
  klump_nn_1 = mkN "klump" ;
  klumpackord_nn_1 = mkN "klumpackord" neutrum ;
  klumpedump_nn_1 = mkN "klumpedump" ;
  klumpeduns_nn_1 = mkN "klumpeduns" ;
  klumpfisk_nn_1 = mkN "klumpfisk" ;
  klumpig_av_1 = mkA "klumpig" ;
  klumpsoem_nn_1 = mkN "klumpsцm" "klumpsцmmen" "klumpsцmmar" "klumpsцmmarna" ;
  klumpsumma_nn_1 = mkN "klumpsumma" ;
  klumpvis_ab_1 = mkAdv "klumpvis" ;
  klunk_nn_1 = mkN "klunk" ;
  kluns_nn_1 = mkN "kluns" ;
  klunsig_av_1 = mkA "klunsig" ;
  klurig_av_1 = mkA "klurig" ;
  kluring_nn_1 = mkN "kluring" ;
  klusil_nn_1 = mkN "klusil" "klusiler" ;
  klut_nn_1 = mkN "klut" ;
  kluven_av_1 = mkA "kluven" "kluvet" ;
  klyft_nn_1 = mkN "klyft" "klyfter" ;
  klyftig_av_1 = mkA "klyftig" ;
  klys_nn_1 = mkN "klys" neutrum ;
  klyva_vb_1 = mkV "klyva" "klyver" "klyv" "klцv" "kluvit" "klyven" ;
  klyvarbom_nn_1 = mkN "klyvarbom" "klyvarbommen" "klyvarbommar" "klyvarbommarna" ;
  klyvare_nn_1 = mkN "klyvare" "klyvare" ;
  klyvbar_av_1 = mkA "klyvbar" ;
  klyvning_nn_1 = mkN "klyvning" ;
  klyvningsreaktion_nn_1 = mkN "klyvningsreaktion" "klyvningsreaktioner" ;
  klyvoeppning_nn_1 = mkN "klyvцppning" ;
  knack_nn_1 = mkN "knack" neutrum ;
  knackig_av_1 = mkA "knackig" ;
  knackning_nn_1 = mkN "knackning" ;
  knackvurst_nn_1 = mkN "knackvurst" ;
  knae_nn_1 = mkN "knд" "knдet" "knдn" "knдna" ;
  knaeck_nn_1 = mkN "knдck" ;
  knaeck_nn_2 = mkN "knдck" neutrum ;
  knaeckebroed_nn_1 = mkN "knдckebrцd" neutrum ;
  knaeckepil_nn_1 = mkN "knдckepil" ;
  knaeckform_nn_1 = mkN "knдckform" ;
  knaeckfraaga_nn_1 = mkN "knдckfrеga" ;
  knaeckt_av_1 = mkA "knдckt" "knдckt" ;
  knaefalla_vb_1 = mkV "knдfalla" "knдfцll" "knдfallit" ;
  knaehoeg_av_1 = mkA "knдhцg" ;
  knaehund_nn_1 = mkN "knдhund" ;
  knaekort_av_1 = mkA "knдkort" "knдkort" ;
  knaelaang_av_1 = mkA "knдlеng" ;
  knaeled_nn_1 = mkN "knдled" "knдleder" ;
  knaepp_av_1 = mkA "knдpp" ;
  knaepp_nn_1 = mkN "knдpp" ;
  knaeppbagge_nn_1 = mkN "knдppbagge" utrum ;
  knaeppning_nn_1 = mkN "knдppning" ;
  knaeroer_nn_1 = mkN "knдrцr" neutrum ;
  knaeskaal_nn_1 = mkN "knдskеl" ;
  knaeskydd_nn_1 = mkN "knдskydd" neutrum ;
  knaeslut_nn_1 = mkN "knдslut" neutrum ;
  knaesvag_av_1 = mkA "knдsvag" ;
  knaetofs_nn_1 = mkN "knдtofs" ;
  knaeveck_nn_1 = mkN "knдveck" neutrum ;
  knaevelborr_nn_1 = mkN "knдvelborr" ;
  knaevring_nn_1 = mkN "knдvring" ;
  knagg_nn_1 = mkN "knagg" ;
  knagglig_av_1 = mkA "knagglig" ;
  knal_av_1 = mkA "knal" ;
  knall_av_1 = mkA "knall" "knall" ;
  knall_nn_1 = mkN "knall" ;
  knalle_nn_1 = mkN "knalle" utrum ;
  knallhaard_av_1 = mkA "knallhеrd" "knallhеrt" ;
  knallhatt_nn_1 = mkN "knallhatt" ;
  knalltransport_nn_1 = mkN "knalltransport" "knalltransporter" ;
  knap_nn_1 = mkN "knap" ;
  knape_nn_1 = mkN "knape" utrum ;
  knaper_av_1 = mkA "knaper" "knapert" "knapra" "knapra" "knaprare" "knaprast" "knapraste" ;
  knapp_av_1 = mkA "knapp" ;
  knapp_nn_1 = mkN "knapp" ;
  knappast_ab_1 = mkAdv "knappast" ;
  knapphaal_nn_1 = mkN "knapphеl" neutrum ;
  knapphaendig_av_1 = mkA "knapphдndig" ;
  knapphet_nn_1 = mkN "knapphet" "knappheter" ;
  knappnaal_nn_1 = mkN "knappnеl" ;
  knappnaalshuvud_nn_1 = mkN "knappnеlshuvud" "knappnеlshuvudet" "knappnеlshuvuden" "knappnеlshuvudena" ;
  knappt_ab_1 = mkAdv "knappt" ;
  knapptelefon_nn_1 = mkN "knapptelefon" "knapptelefoner" ;
  knaprig_av_1 = mkA "knaprig" ;
  knarkare_nn_1 = mkN "knarkare" "knarkare" ;
  knarkarkvart_nn_1 = mkN "knarkarkvart" ;
  knarr_nn_2 = mkN "knarr" ;
  knarrig_av_1 = mkA "knarrig" ;
  knasig_av_1 = mkA "knasig" ;
  knasprig_av_1 = mkA "knasprig" ;
  knast_nn_1 = mkN "knast" ;
  knaster_nn_2 = mkN "knaster" ;
  knastrig_av_1 = mkA "knastrig" ;
  knatte_nn_1 = mkN "knatte" utrum ;
  knatting_nn_1 = mkN "knatting" ;
  kneg_nn_1 = mkN "kneg" neutrum ;
  knegare_nn_1 = mkN "knegare" "knegare" ;
  knejpkur_nn_1 = mkN "knejpkur" "knejpkurer" ;
  knekt_nn_1 = mkN "knekt" ;
  knep_nn_1 = mkN "knep" neutrum ;
  knepig_av_1 = mkA "knepig" ;
  knick_nn_1 = mkN "knick" ;
  knip_nn_1 = mkN "knip" neutrum ;
  knipa_vb_1 = mkV "knipa" "knep" "knipit" ;
  knipslug_av_1 = mkA "knipslug" ;
  kniptaang_nn_1 = mkN "kniptеng" "kniptдnger" ;
  kniptaangsmanoever_nn_1 = mkN "kniptеngsmanцver" ;
  kniv_nn_1 = mkN "kniv" ;
  knivblad_nn_1 = mkN "knivblad" neutrum ;
  knivbladslik_av_1 = mkA "knivbladslik" ;
  knivhugg_nn_1 = mkN "knivhugg" neutrum ;
  knivig_av_1 = mkA "knivig" ;
  knivkastning_nn_1 = mkN "knivkastning" ;
  knivkontakt_nn_1 = mkN "knivkontakt" "knivkontakter" ;
  knivlaeggare_nn_1 = mkN "knivlдggare" "knivlдggare" ;
  knivrygg_nn_1 = mkN "knivrygg" ;
  knivskaft_nn_1 = mkN "knivskaft" neutrum ;
  knivskarp_av_1 = mkA "knivskarp" ;
  knivskuren_av_1 = mkA "knivskuren" "knivskuret" ;
  knivsrygg_nn_1 = mkN "knivsrygg" ;
  knivsudd_nn_1 = mkN "knivsudd" ;
  knix_nn_1 = mkN "knix" ;
  knockdown_nn_1 = mkN "knockdown" "knockdowner" ;
  knockout_nn_1 = mkN "knockout" "knockouter" ;
  knodd_nn_1 = mkN "knodd" ;
  knoddaen_av_1 = mkA "knoddдn" ;
  knoedel_nn_1 = mkN "knцdel" ;
  knoel_nn_1 = mkN "knцl" ;
  knoelaktig_av_1 = mkA "knцlaktig" ;
  knoelig_av_1 = mkA "knцlig" ;
  knoelpaak_nn_1 = mkN "knцlpеk" ;
  knoelrot_nn_1 = mkN "knцlrot" "knцlrцtter" ;
  knoelstam_nn_1 = mkN "knцlstam" "knцlstammen" "knцlstammar" "knцlstammarna" ;
  knoelsvan_nn_1 = mkN "knцlsvan" ;
  knoes_nn_1 = mkN "knцs" ;
  knog_nn_1 = mkN "knog" neutrum ;
  knoge_nn_1 = mkN "knoge" utrum ;
  knogig_av_1 = mkA "knogig" ;
  knogjaern_nn_1 = mkN "knogjдrn" neutrum ;
  knollrig_av_1 = mkA "knollrig" ;
  knop_nn_1 = mkN "knop" ;
  knop_nn_2 = mkN "knop" "knopen" "knop" "knopen" ;
  knopp_nn_1 = mkN "knopp" ;
  knoppig_av_1 = mkA "knoppig" ;
  knoppsaettning_nn_1 = mkN "knoppsдttning" ;
  knoppsprickning_nn_1 = mkN "knoppsprickning" ;
  knorr_nn_1 = mkN "knorr" ;
  knorrhane_nn_1 = mkN "knorrhane" utrum ;
  knoster_nn_1 = mkN "knoster" neutrum ;
  knot_nn_1 = mkN "knot" ;
  knotig_av_1 = mkA "knotig" ;
  knott_nn_1 = mkN "knott" neutrum ;
  knottrig_av_1 = mkA "knottrig" ;
  knubbig_av_1 = mkA "knubbig" ;
  knubbsael_nn_1 = mkN "knubbsдl" ;
  knuff_nn_1 = mkN "knuff" ;
  knull_nn_1 = mkN "knull" neutrum ;
  knusslig_av_1 = mkA "knusslig" ;
  knut_nn_1 = mkN "knut" ;
  knutbroderi_nn_1 = mkN "knutbroderi" "knutbroderit" "knutbroderier" "knutbroderierna" ;
  knuten_av_1 = mkA "knuten" "knutet" ;
  knutig_av_1 = mkA "knutig" ;
  knutpunkt_nn_1 = mkN "knutpunkt" "knutpunkter" ;
  knutte_nn_1 = mkN "knutte" utrum ;
  knyck_nn_1 = mkN "knyck" ;
  knyckig_av_1 = mkA "knyckig" ;
  knyst_nn_1 = mkN "knyst" neutrum ;
  knyta_vb_1 = mkV "knyta" "knцt" "knutit" ;
  knytkalas_nn_1 = mkN "knytkalas" neutrum ;
  knytnaeve_nn_1 = mkN "knytnдve" utrum ;
  knytnaevsslag_nn_1 = mkN "knytnдvsslag" neutrum ;
  knytskaerp_nn_1 = mkN "knytskдrp" neutrum ;
  ko_nn_1 = mkN "ko" "kor" ;
  koalition_nn_1 = mkN "koalition" "koalitioner" ;
  koalitionsregering_nn_1 = mkN "koalitionsregering" ;
  koaxialkabel_nn_1 = mkN "koaxialkabel" ;
  kobbe_nn_1 = mkN "kobbe" utrum ;
  kobbel_nn_1 = mkN "kobbel" ;
  kobent_av_1 = mkA "kobent" "kobent" ;
  kobolthalt_nn_1 = mkN "kobolthalt" "kobolthalter" ;
  kobolthaltig_av_1 = mkA "kobolthaltig" ;
  koboltkanon_nn_1 = mkN "koboltkanon" "koboltkanoner" ;
  kock_nn_1 = mkN "kock" ;
  kock_nn_2 = mkN "kock" "kocker" ;
  kod_nn_1 = mkN "kod" "koder" ;
  kodex_nn_1 = mkN "kodex" ;
  kodicill_nn_1 = mkN "kodicill" "kodiciller" ;
  kodifikation_nn_1 = mkN "kodifikation" "kodifikationer" ;
  koe_nn_1 = mkN "kц" "kцn" "kцer" "kцerna" ;
  koefficient_nn_1 = mkN "koefficient" "koefficienter" ;
  koek_nn_1 = mkN "kцk" neutrum ;
  koekkenmoedding_nn_1 = mkN "kцkkenmцdding" ;
  koeksbord_nn_1 = mkN "kцksbord" neutrum ;
  koeksflaekt_nn_1 = mkN "kцksflдkt" ;
  koekshandduk_nn_1 = mkN "kцkshandduk" ;
  koeksingaang_nn_1 = mkN "kцksingеng" ;
  koeksmaestare_nn_1 = mkN "kцksmдstare" "kцksmдstare" ;
  koeksmaskin_nn_1 = mkN "kцksmaskin" "kцksmaskiner" ;
  koeksrulle_nn_1 = mkN "kцksrulle" utrum ;
  koekssax_nn_1 = mkN "kцkssax" ;
  koeksspis_nn_1 = mkN "kцksspis" ;
  koekstraedgaard_nn_1 = mkN "kцkstrдdgеrd" ;
  koeksvaext_nn_1 = mkN "kцksvдxt" "kцksvдxter" ;
  koel_nn_1 = mkN "kцl" ;
  koelbaat_nn_1 = mkN "kцlbеt" ;
  koeldbestaendig_av_1 = mkA "kцldbestдndig" ;
  koeldblandning_nn_1 = mkN "kцldblandning" ;
  koeldgrad_nn_1 = mkN "kцldgrad" "kцldgrader" ;
  koeldhaerdig_av_1 = mkA "kцldhдrdig" ;
  koeldknaepp_nn_1 = mkN "kцldknдpp" ;
  koeldpol_nn_1 = mkN "kцldpol" "kцldpoler" ;
  koeldpunkt_nn_1 = mkN "kцldpunkt" "kцldpunkter" ;
  koelsvin_nn_1 = mkN "kцlsvin" neutrum ;
  koen_nn_1 = mkN "kцn" neutrum ;
  koenlig_av_1 = mkA "kцnlig" ;
  koenloes_av_1 = mkA "kцnlцs" ;
  koensakt_nn_1 = mkN "kцnsakt" "kцnsakter" ;
  koensbunden_av_1 = mkA "kцnsbunden" "kцnsbundet" ;
  koensbyte_nn_1 = mkN "kцnsbyte" ;
  koenscell_nn_1 = mkN "kцnscell" "kцnsceller" ;
  koenshormon_nn_1 = mkN "kцnshormon" neutrum ;
  koenskaraktaer_nn_1 = mkN "kцnskaraktдr" "kцnskaraktдrer" ;
  koenskoertel_nn_1 = mkN "kцnskцrtel" ;
  koenslig_av_1 = mkA "kцnslig" ;
  koensmogen_av_1 = mkA "kцnsmogen" "kцnsmoget" ;
  koensmognad_nn_1 = mkN "kцnsmognad" "kцnsmognader" ;
  koensord_nn_1 = mkN "kцnsord" neutrum ;
  koensorgan_nn_1 = mkN "kцnsorgan" neutrum ;
  koensroll_nn_1 = mkN "kцnsroll" "kцnsroller" ;
  koenssjukdom_nn_1 = mkN "kцnssjukdom" ;
  koensumgaenge_nn_1 = mkN "kцnsumgдnge" ;
  koensvarelse_nn_1 = mkN "kцnsvarelse" "kцnsvarelser" ;
  koep_nn_1 = mkN "kцp" neutrum ;
  koepare_nn_1 = mkN "kцpare" "kцpare" ;
  koepcentrum_nn_1 = mkN "kцpcentrum" neutrum ;
  koepebrev_nn_1 = mkN "kцpebrev" neutrum ;
  koepebroed_nn_1 = mkN "kцpebrцd" neutrum ;
  koepekontrakt_nn_1 = mkN "kцpekontrakt" neutrum ;
  koepenickiad_nn_1 = mkN "kцpenickiad" "kцpenickiader" ;
  koepenskap_nn_1 = mkN "kцpenskap" "kцpenskaper" ;
  koepeskilling_nn_1 = mkN "kцpeskilling" ;
  koeping_nn_1 = mkN "kцping" ;
  koepkort_nn_1 = mkN "kцpkort" neutrum ;
  koepkurs_nn_1 = mkN "kцpkurs" "kцpkurser" ;
  koepman_nn_1 = mkN "kцpman" "kцpmannen" "kцpmдn" "kцpmдnnen" ;
  koepslut_nn_1 = mkN "kцpslut" neutrum ;
  koepstad_nn_1 = mkN "kцpstad" "kцpstдder" ;
  koepstark_av_1 = mkA "kцpstark" ;
  koer_nn_1 = mkN "kцr" "kцrer" ;
  koerare_nn_1 = mkN "kцrare" "kцrare" ;
  koerbar_av_1 = mkA "kцrbar" ;
  koeregenskap_nn_1 = mkN "kцregenskap" "kцregenskaper" ;
  koerfaelt_nn_1 = mkN "kцrfдlt" neutrum ;
  koerfoerbud_nn_1 = mkN "kцrfцrbud" neutrum ;
  koerig_av_1 = mkA "kцrig" ;
  koerkarl_nn_1 = mkN "kцrkarl" ;
  koerkort_nn_1 = mkN "kцrkort" neutrum ;
  koerkortsprov_nn_1 = mkN "kцrkortsprov" neutrum ;
  koerledare_nn_1 = mkN "kцrledare" "kцrledare" ;
  koerlektion_nn_1 = mkN "kцrlektion" "kцrlektioner" ;
  koernare_nn_1 = mkN "kцrnare" "kцrnare" ;
  koerning_nn_1 = mkN "kцrning" ;
  koerriktningsvisare_nn_1 = mkN "kцrriktningsvisare" "kцrriktningsvisare" ;
  koersbaer_nn_1 = mkN "kцrsbдr" neutrum ;
  koersbaerstraed_nn_1 = mkN "kцrsbдrstrдd" neutrum ;
  koersnaer_nn_1 = mkN "kцrsnдr" "kцrsnдrer" ;
  koersven_nn_1 = mkN "kцrsven" "kцrsvennen" "kцrsvenner" "kцrsvennerna" ;
  koertel_nn_1 = mkN "kцrtel" ;
  koertelcell_nn_1 = mkN "kцrtelcell" "kцrtelceller" ;
  koerteloeppning_nn_1 = mkN "kцrtelцppning" ;
  koertid_nn_1 = mkN "kцrtid" "kцrtider" ;
  koervaeg_nn_1 = mkN "kцrvдg" ;
  koettaetande_av_1 = mkA "kцttдtande" ;
  koettaetare_nn_1 = mkN "kцttдtare" "kцttдtare" ;
  koettben_nn_1 = mkN "kцttben" neutrum ;
  koettbulle_nn_1 = mkN "kцttbulle" utrum ;
  koetted_nn_1 = mkN "kцtted" "kцtteder" ;
  koettig_av_1 = mkA "kцttig" ;
  koettkvarn_nn_1 = mkN "kцttkvarn" ;
  koettmarknad_nn_1 = mkN "kцttmarknad" "kцttmarknader" ;
  koettsaar_nn_1 = mkN "kцttsеr" neutrum ;
  koettsida_nn_1 = mkN "kцttsida" ;
  koettslig_av_1 = mkA "kцttslig" ;
  kofaangare_nn_1 = mkN "kofеngare" "kofеngare" ;
  koff_nn_1 = mkN "koff" ;
  kofferdamm_nn_1 = mkN "kofferdamm" ;
  kofferdist_nn_1 = mkN "kofferdist" "kofferdister" ;
  koffernagel_nn_1 = mkN "koffernagel" ;
  koffert_nn_1 = mkN "koffert" ;
  koffertfisk_nn_1 = mkN "koffertfisk" ;
  kofot_nn_1 = mkN "kofot" ;
  koger_nn_1 = mkN "koger" neutrum ;
  kogg_nn_1 = mkN "kogg" ;
  kognat_nn_1 = mkN "kognat" "kognater" ;
  kognatisk_av_1 = mkA "kognatisk" ;
  kognitiv_av_1 = mkA "kognitiv" ;
  koherent_av_1 = mkA "koherent" "koherent" ;
  kohort_nn_1 = mkN "kohort" "kohorter" ;
  kohud_nn_1 = mkN "kohud" ;
  koj_nn_1 = mkN "koj" "kojer" ;
  kok_nn_1 = mkN "kok" neutrum ;
  kokapparat_nn_1 = mkN "kokapparat" "kokapparater" ;
  kokard_nn_1 = mkN "kokard" "kokarder" ;
  kokare_nn_1 = mkN "kokare" "kokare" ;
  kokarreaktor_nn_1 = mkN "kokarreaktor" "kokarreaktorer" ;
  kokbok_nn_1 = mkN "kokbok" "kokbцcker" ;
  kokeri_nn_1 = mkN "kokeri" "kokerit" "kokerier" "kokerierna" ;
  kokerska_nn_1 = mkN "kokerska" ;
  kokett_av_1 = mkA "kokett" ;
  kokett_nn_1 = mkN "kokett" "koketter" ;
  koketteri_nn_1 = mkN "koketteri" "koketterit" "koketterier" "koketterierna" ;
  kokgrop_nn_1 = mkN "kokgrop" ;
  kokhet_av_1 = mkA "kokhet" ;
  kokill_nn_1 = mkN "kokill" "kokiller" ;
  kokkaerl_nn_1 = mkN "kokkдrl" neutrum ;
  kokkorv_nn_1 = mkN "kokkorv" ;
  kokong_nn_1 = mkN "kokong" "kokonger" ;
  kokosboll_nn_1 = mkN "kokosboll" ;
  kokosfiber_nn_1 = mkN "kokosfiber" "kokosfibern" "kokosfibrer" "kokosfibrerna" ;
  kokosnoet_nn_1 = mkN "kokosnцt" "kokosnцtter" ;
  kokospalm_nn_1 = mkN "kokospalm" "kokospalmer" ;
  kokott_nn_1 = mkN "kokott" "kokotter" ;
  kokpunkt_nn_1 = mkN "kokpunkt" "kokpunkter" ;
  koktid_nn_1 = mkN "koktid" "koktider" ;
  kokvagn_nn_1 = mkN "kokvagn" ;
  kokvraa_nn_1 = mkN "kokvrе" "kokvrеn" "kokvrеr" "kokvrеrna" ;
  kol_14_laboratorium_nn_1 = mkN "kol-14-laboratorium" "kol-14-laboratoriet" "kol-14-laboratorier" "kol-14-laboratorierna" ;
  kol_nn_1 = mkN "kol" neutrum ;
  kolare_nn_1 = mkN "kolare" "kolare" ;
  kolatom_nn_1 = mkN "kolatom" "kolatomer" ;
  kolatraed_nn_1 = mkN "kolatrдd" neutrum ;
  kolbaerare_nn_1 = mkN "kolbдrare" "kolbдrare" ;
  kolbit_nn_1 = mkN "kolbit" ;
  kolborste_nn_1 = mkN "kolborste" utrum ;
  kolbotten_nn_1 = mkN "kolbotten" ;
  kolbox_nn_1 = mkN "kolbox" ;
  kolbrikett_nn_1 = mkN "kolbrikett" "kolbriketter" ;
  kolbulle_nn_1 = mkN "kolbulle" utrum ;
  kolchos_nn_1 = mkN "kolchos" "kolchoser" ;
  koldioxidfri_av_1 = mkA "koldioxidfri" "koldioxidfritt" ;
  koldioxidkanal_nn_1 = mkN "koldioxidkanal" "koldioxidkanaler" ;
  koldioxidmolekyl_nn_1 = mkN "koldioxidmolekyl" "koldioxidmolekyler" ;
  koleld_nn_1 = mkN "koleld" ;
  kolerabakterie_nn_1 = mkN "kolerabakterie" "kolerabakterier" ;
  kolerakyrkogaard_nn_1 = mkN "kolerakyrkogеrd" ;
  koleriker_nn_1 = mkN "koleriker" "kolerikern" "koleriker" "kolerikerna" ;
  kolerisk_av_1 = mkA "kolerisk" ;
  kolfloets_nn_1 = mkN "kolflцts" "kolflцtser" ;
  kolfoerening_nn_1 = mkN "kolfцrening" ;
  kolhaemtare_nn_1 = mkN "kolhдmtare" "kolhдmtare" ;
  kolhalt_nn_1 = mkN "kolhalt" "kolhalter" ;
  kolhaltig_av_1 = mkA "kolhaltig" ;
  kolhoeg_nn_1 = mkN "kolhцg" ;
  kolhydrat_nn_1 = mkN "kolhydrat" neutrum ;
  kolibakterie_nn_1 = mkN "kolibakterie" "kolibakterier" ;
  kolibri_nn_1 = mkN "kolibri" "kolibrin" "kolibrier" "kolibrierna" ;
  koling_nn_1 = mkN "koling" ;
  kolisotop_nn_1 = mkN "kolisotop" "kolisotoper" ;
  kolje_nn_1 = mkN "koljй" "koljйer" ;
  kolkaellare_nn_1 = mkN "kolkдllare" "kolkдllare" ;
  koll_nn_1 = mkN "koll" ;
  kollaboratoer_nn_1 = mkN "kollaboratцr" "kollaboratцrer" ;
  kollage_nn_1 = mkN "kollage" "kollaget" "kollage" "kollagen" ;
  kollaps_nn_1 = mkN "kollaps" "kollapser" ;
  kollation_nn_1 = mkN "kollation" "kollationer" ;
  kollega_nn_1 = mkN "kollega" ;
  kollegial_av_1 = mkA "kollegial" ;
  kollegialitet_nn_1 = mkN "kollegialitet" "kollegialiteter" ;
  kollegieblock_nn_1 = mkN "kollegieblock" neutrum ;
  kollegium_nn_1 = mkN "kollegium" "kollegiet" "kollegier" "kollegierna" ;
  kollekt_nn_1 = mkN "kollekt" "kollekter" ;
  kollektion_nn_1 = mkN "kollektion" "kollektioner" ;
  kollektiv_av_1 = mkA "kollektiv" ;
  kollektiv_nn_1 = mkN "kollektiv" neutrum ;
  kollektivanslutning_nn_1 = mkN "kollektivanslutning" ;
  kollektivanstaelld_av_1 = mkA "kollektivanstдlld" "kollektivanstдllt" ;
  kollektivanstaellning_nn_1 = mkN "kollektivanstдllning" ;
  kollektivavtal_nn_1 = mkN "kollektivavtal" "kollektivavtalet" "kollektivavtalen" "kollektivavtalena" ;
  kollektivfil_nn_1 = mkN "kollektivfil" "kollektivfiler" ;
  kollektivfoersaekring_nn_1 = mkN "kollektivfцrsдkring" ;
  kollektivhus_nn_1 = mkN "kollektivhus" neutrum ;
  kollektivjordbruk_nn_1 = mkN "kollektivjordbruk" neutrum ;
  kollektivnot_nn_1 = mkN "kollektivnot" "kollektivnoter" ;
  kollektor_nn_1 = mkN "kollektor" "kollektorer" ;
  kolli_nn_1 = mkN "kolli" "kollit" "kolli" "kollina" ;
  kollision_nn_1 = mkN "kollision" "kollisioner" ;
  kollisionskurs_nn_1 = mkN "kollisionskurs" "kollisionskurser" ;
  kollisionsskott_nn_1 = mkN "kollisionsskott" neutrum ;
  kollo_nn_1 = mkN "kollo" "kollot" "kollon" "kollona" ;
  kolloid_nn_1 = mkN "kolloid" "kolloider" ;
  kolloidal_av_1 = mkA "kolloidal" ;
  kollokvium_nn_1 = mkN "kollokvium" "kollokviet" "kollokvier" "kollokvierna" ;
  kollrig_av_1 = mkA "kollrig" ;
  kolmoerk_av_1 = mkA "kolmцrk" ;
  kolning_nn_1 = mkN "kolning" ;
  kolofon_nn_1 = mkN "kolofon" "kolofoner" ;
  kolokvint_nn_1 = mkN "kolokvint" "kolokvinter" ;
  kolon_nn_1 = mkN "kolon" neutrum ;
  kolonat_nn_1 = mkN "kolonat" neutrum ;
  koloni_nn_1 = mkN "koloni" "kolonier" ;
  kolonial_av_1 = mkA "kolonial" ;
  kolonialarme_nn_1 = mkN "kolonialarmй" "kolonialarmйer" ;
  kolonialkrig_nn_1 = mkN "kolonialkrig" neutrum ;
  kolonialmakt_nn_1 = mkN "kolonialmakt" "kolonialmakter" ;
  kolonialvaelde_nn_1 = mkN "kolonialvдlde" ;
  kolonilott_nn_1 = mkN "kolonilott" "kolonilotter" ;
  kolonisation_nn_1 = mkN "kolonisation" "kolonisationer" ;
  kolonisationstid_nn_1 = mkN "kolonisationstid" "kolonisationstider" ;
  kolonisatoer_nn_1 = mkN "kolonisatцr" "kolonisatцrer" ;
  kolonistuga_nn_1 = mkN "kolonistuga" ;
  kolonn_nn_1 = mkN "kolonn" "kolonner" ;
  kolonnad_nn_1 = mkN "kolonnad" "kolonnader" ;
  kolonnett_nn_1 = mkN "kolonnett" "kolonnetter" ;
  kolonnordning_nn_1 = mkN "kolonnordning" ;
  koloradoskalbagge_nn_1 = mkN "koloradoskalbagge" utrum ;
  koloratur_nn_1 = mkN "koloratur" "koloraturer" ;
  koloratursaangerska_nn_1 = mkN "koloratursеngerska" ;
  kolorist_nn_1 = mkN "kolorist" "kolorister" ;
  kolorit_nn_1 = mkN "kolorit" "koloriter" ;
  koloss_nn_1 = mkN "koloss" "kolosser" ;
  kolossal_av_1 = mkA "kolossal" ;
  kolportagemaessig_av_1 = mkA "kolportagemдssig" ;
  kolportoer_nn_1 = mkN "kolportцr" "kolportцrer" ;
  kolryss_nn_1 = mkN "kolryss" ;
  kolstaal_nn_1 = mkN "kolstеl" neutrum ;
  kolstift_nn_1 = mkN "kolstift" neutrum ;
  kolsvart_av_1 = mkA "kolsvart" "kolsvart" ;
  kolsyraassimilation_nn_1 = mkN "kolsyraassimilation" "kolsyraassimilationer" ;
  kolt_nn_1 = mkN "kolt" ;
  koltablett_nn_1 = mkN "koltablett" "koltabletter" ;
  koltavdelning_nn_1 = mkN "koltavdelning" ;
  koltbarn_nn_1 = mkN "koltbarn" neutrum ;
  kolteckning_nn_1 = mkN "kolteckning" ;
  koltraad_nn_1 = mkN "koltrеd" ;
  koltrast_nn_1 = mkN "koltrast" ;
  kolugn_av_1 = mkA "kolugn" ;
  kolumbarium_nn_1 = mkN "kolumbarium" "kolumbariet" "kolumbarier" "kolumbarierna" ;
  kolumn_nn_1 = mkN "kolumn" "kolumner" ;
  kolumnist_nn_1 = mkN "kolumnist" "kolumnister" ;
  kolumntitel_nn_1 = mkN "kolumntitel" ;
  kolv_nn_1 = mkN "kolv" ;
  kolvhals_nn_1 = mkN "kolvhals" ;
  kolvmotor_nn_1 = mkN "kolvmotor" "kolvmotorer" ;
  komatoes_av_1 = mkA "komatцs" ;
  kombattant_nn_1 = mkN "kombattant" "kombattanter" ;
  kombinat_nn_1 = mkN "kombinat" neutrum ;
  kombination_nn_1 = mkN "kombination" "kombinationer" ;
  kombinationslaas_nn_1 = mkN "kombinationslеs" neutrum ;
  kombinationsmaattsats_nn_1 = mkN "kombinationsmеttsats" "kombinationsmеttsatser" ;
  kombinationstaevling_nn_1 = mkN "kombinationstдvling" ;
  kombinatorisk_av_1 = mkA "kombinatorisk" ;
  komedi_nn_1 = mkN "komedi" "komedier" ;
  komediant_nn_1 = mkN "komediant" "komedianter" ;
  komedienn_nn_1 = mkN "komedienn" "komedienner" ;
  komet_nn_1 = mkN "komet" "kometer" ;
  kometmoln_nn_1 = mkN "kometmoln" neutrum ;
  komfortabel_av_1 = mkA "komfortabel" "komfortabelt" "komfortabla" "komfortabla" "komfortablare" "komfortablast" "komfortablaste" ;
  komiker_nn_1 = mkN "komiker" "komikern" "komiker" "komikerna" ;
  komisk_av_1 = mkA "komisk" ;
  komma_nn_1 = mkN "komma" "kommat" "komman" "kommana" ;
  komma_vb_1 = mkV "komma" "kom" "kommit" ;
  kommabacill_nn_1 = mkN "kommabacill" "kommabaciller" ;
  kommande_av_1 = mkA "kommande" ;
  kommanditbolag_nn_1 = mkN "kommanditbolag" neutrum ;
  kommanditdelaegare_nn_1 = mkN "kommanditdelдgare" "kommanditdelдgare" ;
  kommando_nn_1 = mkN "kommando" "kommandot" "kommandon" "kommandona" ;
  kommandomaal_nn_1 = mkN "kommandomеl" neutrum ;
  kommandoord_nn_1 = mkN "kommandoord" neutrum ;
  kommandoroest_nn_1 = mkN "kommandorцst" "kommandorцster" ;
  kommatering_nn_1 = mkN "kommatering" ;
  kommendant_nn_1 = mkN "kommendant" "kommendanter" ;
  kommendantur_nn_1 = mkN "kommendantur" "kommendanturer" ;
  kommendering_nn_1 = mkN "kommendering" ;
  kommendoer_nn_1 = mkN "kommendцr" "kommendцrer" ;
  kommendoerkapten_nn_1 = mkN "kommendцrkapten" "kommendцrkaptener" ;
  kommensurabel_av_1 = mkA "kommensurabel" "kommensurabelt" "kommensurabla" "kommensurabla" "kommensurablare" "kommensurablast" "kommensurablaste" ;
  kommentar_nn_1 = mkN "kommentar" "kommentarer" ;
  kommentator_nn_1 = mkN "kommentator" "kommentatorer" ;
  kommers_nn_1 = mkN "kommers" "kommerser" ;
  kommerseraad_nn_1 = mkN "kommerserеd" neutrum ;
  kommersialisering_nn_1 = mkN "kommersialisering" ;
  kommersiell_av_1 = mkA "kommersiell" ;
  kommerskollegium_nn_1 = mkN "kommerskollegium" "kommerskollegiet" "kommerskollegier" "kommerskollegierna" ;
  komminister_nn_1 = mkN "komminister" ;
  kommissariat_nn_1 = mkN "kommissariat" neutrum ;
  kommissarie_nn_1 = mkN "kommissarie" "kommissarier" ;
  kommission_nn_1 = mkN "kommission" "kommissioner" ;
  kommissionaer_nn_1 = mkN "kommissionдr" "kommissionдrer" ;
  kommitte_nn_1 = mkN "kommittй" "kommittйer" ;
  kommod_nn_1 = mkN "kommod" "kommoder" ;
  kommun_nn_1 = mkN "kommun" "kommuner" ;
  kommunaegd_av_1 = mkA "kommunдgd" "kommunдgt" ;
  kommunal_av_1 = mkA "kommunal" ;
  kommunalfoervaltning_nn_1 = mkN "kommunalfцrvaltning" ;
  kommunalfullmaektig_nn_1 = mkN "kommunalfullmдktig" "kommunalfullmдktigen" "kommunalfullmдktige" "kommunalfullmдktigena" ;
  kommunalhus_nn_1 = mkN "kommunalhus" neutrum ;
  kommunallag_nn_1 = mkN "kommunallag" ;
  kommunalman_nn_1 = mkN "kommunalman" "kommunalmannen" "kommunalmдn" "kommunalmдnnen" ;
  kommunalnaemnd_nn_1 = mkN "kommunalnдmnd" "kommunalnдmnder" ;
  kommunalnaemndsordfoerande_nn_1 = mkN "kommunalnдmndsordfцrande" "kommunalnдmndsordfцranden" "kommunalnдmndsordfцrande" "kommunalnдmndsordfцrandena" ;
  kommunalordfoerande_nn_1 = mkN "kommunalordfцrande" "kommunalordfцranden" "kommunalordfцrande" "kommunalordfцrandena" ;
  kommunalpolitiker_nn_1 = mkN "kommunalpolitiker" "kommunalpolitikern" "kommunalpolitiker" "kommunalpolitikerna" ;
  kommunalpolitisk_av_1 = mkA "kommunalpolitisk" ;
  kommunalraad_nn_1 = mkN "kommunalrеd" neutrum ;
  kommunalskatt_nn_1 = mkN "kommunalskatt" "kommunalskatter" ;
  kommunalstyrelse_nn_1 = mkN "kommunalstyrelse" "kommunalstyrelser" ;
  kommunalval_nn_1 = mkN "kommunalval" neutrum ;
  kommunard_nn_1 = mkN "kommunard" "kommunarder" ;
  kommunblock_nn_1 = mkN "kommunblock" neutrum ;
  kommundel_nn_1 = mkN "kommundel" "kommundelen" "kommundelar" "kommundelarna" ;
  kommundelsraad_nn_1 = mkN "kommundelsrеd" neutrum ;
  kommunfoerbund_nn_1 = mkN "kommunfцrbund" neutrum ;
  kommunfullmaektig_nn_1 = mkN "kommunfullmдktig" "kommunfullmдktigen" "kommunfullmдktige" "kommunfullmдktigena" ;
  kommunikant_nn_1 = mkN "kommunikant" "kommunikanter" ;
  kommunikation_nn_1 = mkN "kommunikation" "kommunikationer" ;
  kommunikationsakt_nn_1 = mkN "kommunikationsakt" "kommunikationsakter" ;
  kommunikationsdepartement_nn_1 = mkN "kommunikationsdepartement" "kommunikationsdepartementet" "kommunikationsdepartementen" "kommunikationsdepartementena" ;
  kommunikationsmedel_nn_1 = mkN "kommunikationsmedel" neutrum ;
  kommunikationsminister_nn_1 = mkN "kommunikationsminister" ;
  kommunikationsnaet_nn_1 = mkN "kommunikationsnдt" neutrum ;
  kommunikationsradio_nn_1 = mkN "kommunikationsradio" "kommunikationsradior" ;
  kommunikationssatellit_nn_1 = mkN "kommunikationssatellit" "kommunikationssatelliter" ;
  kommunikationstabell_nn_1 = mkN "kommunikationstabell" "kommunikationstabeller" ;
  kommunikativ_av_1 = mkA "kommunikativ" ;
  kommunikatoer_nn_1 = mkN "kommunikatцr" "kommunikatцrer" ;
  kommunikator_nn_1 = mkN "kommunikator" "kommunikatorer" ;
  kommunike_nn_1 = mkN "kommunikй" "kommunikйer" ;
  kommuninnevaanare_nn_1 = mkN "kommuninnevеnare" "kommuninnevеnare" ;
  kommuninvaanare_nn_1 = mkN "kommuninvеnare" "kommuninvеnare" ;
  kommunion_nn_1 = mkN "kommunion" "kommunioner" ;
  kommunist_nn_1 = mkN "kommunist" "kommunister" ;
  kommunistisk_av_1 = mkA "kommunistisk" ;
  kommunistland_nn_1 = mkN "kommunistland" "kommunistlandet" "kommunistlдnder" "kommunistlдnderna" ;
  kommunistparti_nn_1 = mkN "kommunistparti" "kommunistpartit" "kommunistpartier" "kommunistpartierna" ;
  kommunistregim_nn_1 = mkN "kommunistregim" "kommunistregimer" ;
  kommunistvaerld_nn_1 = mkN "kommunistvдrld" ;
  kommunpolitiker_nn_1 = mkN "kommunpolitiker" "kommunpolitikern" "kommunpolitiker" "kommunpolitikerna" ;
  kommunsammanslagning_nn_1 = mkN "kommunsammanslagning" ;
  kommunstyrelse_nn_1 = mkN "kommunstyrelse" "kommunstyrelser" ;
  kommutativ_av_1 = mkA "kommutativ" ;
  kommutator_nn_1 = mkN "kommutator" "kommutatorer" ;
  kompakt_av_1 = mkA "kompakt" "kompakt" ;
  kompani_nn_1 = mkN "kompani" "kompanit" "kompanier" "kompanierna" ;
  kompaniadjutant_nn_1 = mkN "kompaniadjutant" "kompaniadjutanter" ;
  kompaniofficer_nn_1 = mkN "kompaniofficer" "kompaniofficern" "kompaniofficerare" "kompaniofficerarna" ;
  kompaniorder_nn_1 = mkN "kompaniorder" ;
  kompanjon_nn_1 = mkN "kompanjon" "kompanjoner" ;
  komparabel_av_1 = mkA "komparabel" "komparabelt" "komparabla" "komparabla" "komparablare" "komparablast" "komparablaste" ;
  komparation_nn_1 = mkN "komparation" "komparationer" ;
  komparativ_av_1 = mkA "komparativ" ;
  komparativ_nn_1 = mkN "komparativ" "komparativer" ;
  kompars_nn_1 = mkN "kompars" "komparser" ;
  kompass_nn_1 = mkN "kompass" "kompasser" ;
  kompasshus_nn_1 = mkN "kompasshus" neutrum ;
  kompasskurs_nn_1 = mkN "kompasskurs" "kompasskurser" ;
  kompassnaal_nn_1 = mkN "kompassnеl" ;
  kompatibel_av_1 = mkA "kompatibel" "kompatibelt" "kompatibla" "kompatibla" "kompatiblare" "kompatiblast" "kompatiblaste" ;
  kompendium_nn_1 = mkN "kompendium" "kompendiet" "kompendier" "kompendierna" ;
  kompensation_nn_1 = mkN "kompensation" "kompensationer" ;
  kompensator_nn_1 = mkN "kompensator" "kompensatorer" ;
  kompensatorisk_av_1 = mkA "kompensatorisk" ;
  kompetens_nn_1 = mkN "kompetens" "kompetenser" ;
  kompetent_av_1 = mkA "kompetent" "kompetent" ;
  kompilat_nn_1 = mkN "kompilat" neutrum ;
  kompilation_nn_1 = mkN "kompilation" "kompilationer" ;
  kompilator_nn_1 = mkN "kompilator" "kompilatorer" ;
  kompis_nn_1 = mkN "kompis" ;
  kompledig_av_1 = mkA "kompledig" ;
  komplement_nn_1 = mkN "komplement" neutrum ;
  komplementaer_av_1 = mkA "komplementдr" ;
  komplementaer_nn_1 = mkN "komplementдr" "komplementдrer" ;
  komplementfaerg_nn_1 = mkN "komplementfдrg" "komplementfдrger" ;
  komplementmaengd_nn_1 = mkN "komplementmдngd" "komplementmдngder" ;
  komplementsystem_nn_1 = mkN "komplementsystem" neutrum ;
  komplementvinkel_nn_1 = mkN "komplementvinkel" ;
  komplett_av_1 = mkA "komplett" ;
  komplettering_nn_1 = mkN "komplettering" ;
  kompletteringstest_nn_1 = mkN "kompletteringstest" neutrum ;
  komplex_av_1 = mkA "komplex" ;
  komplex_nn_1 = mkN "komplex" neutrum ;
  komplexig_av_1 = mkA "komplexig" ;
  komplexitet_nn_1 = mkN "komplexitet" "komplexiteter" ;
  komplikation_nn_1 = mkN "komplikation" "komplikationer" ;
  komplimang_nn_1 = mkN "komplimang" "komplimanger" ;
  komplott_nn_1 = mkN "komplott" "komplotter" ;
  komponent_nn_1 = mkN "komponent" "komponenter" ;
  komponist_nn_1 = mkN "komponist" "komponister" ;
  komposant_nn_1 = mkN "komposant" "komposanter" ;
  komposit_nn_1 = mkN "komposit" "kompositer" ;
  komposition_nn_1 = mkN "komposition" "kompositioner" ;
  kompositoer_nn_1 = mkN "kompositцr" "kompositцrer" ;
  kompositum_nn_1 = mkN "kompositum" "kompositum" "komposita" "kompositerna" ;
  kompost_nn_1 = mkN "kompost" "komposter" ;
  kompott_nn_1 = mkN "kompott" "kompotter" ;
  kompress_nn_1 = mkN "kompress" "kompresser" ;
  kompression_nn_1 = mkN "kompression" "kompressioner" ;
  kompressor_nn_1 = mkN "kompressor" "kompressorer" ;
  komprimator_nn_1 = mkN "komprimator" "komprimatorer" ;
  kompromiss_nn_1 = mkN "kompromiss" "kompromisser" ;
  kompulsiv_av_1 = mkA "kompulsiv" ;
  kon_nn_1 = mkN "kon" "koner" ;
  koncentrat_nn_1 = mkN "koncentrat" neutrum ;
  koncentration_nn_1 = mkN "koncentration" "koncentrationer" ;
  koncentrationsdag_nn_1 = mkN "koncentrationsdag" ;
  koncentrationslaeger_nn_1 = mkN "koncentrationslдger" neutrum ;
  koncentrisk_av_1 = mkA "koncentrisk" ;
  koncept_nn_1 = mkN "koncept" neutrum ;
  koncept_nn_2 = mkN "koncept" neutrum ;
  konception_nn_1 = mkN "konception" "konceptioner" ;
  konceptiv_av_1 = mkA "konceptiv" ;
  konceptpapper_nn_1 = mkN "konceptpapper" neutrum ;
  konceptuell_av_1 = mkA "konceptuell" ;
  koncern_nn_1 = mkN "koncern" "koncerner" ;
  koncession_nn_1 = mkN "koncession" "koncessioner" ;
  koncessiv_av_1 = mkA "koncessiv" ;
  konciliant_av_1 = mkA "konciliant" "konciliant" ;
  koncis_av_1 = mkA "koncis" ;
  kondensat_nn_1 = mkN "kondensat" neutrum ;
  kondensation_nn_1 = mkN "kondensation" "kondensationer" ;
  kondensator_nn_1 = mkN "kondensator" "kondensatorer" ;
  kondensor_nn_1 = mkN "kondensor" "kondensorer" ;
  kondis_nn_1 = mkN "kondis" neutrum ;
  kondition_nn_1 = mkN "kondition" "konditioner" ;
  konditional_av_1 = mkA "konditional" ;
  konditor_nn_1 = mkN "konditor" "konditorer" ;
  konditori_nn_1 = mkN "konditori" "konditorit" "konditorier" "konditorierna" ;
  kondoleans_nn_1 = mkN "kondoleans" "kondoleanser" ;
  kondom_nn_1 = mkN "kondom" "kondomer" ;
  kondor_nn_1 = mkN "kondor" "kondoren" "kondorer" "kondorerna" ;
  kondottiaer_nn_1 = mkN "kondottiдr" "kondottiдrer" ;
  konduktivitet_nn_1 = mkN "konduktivitet" "konduktiviteter" ;
  konduktoer_nn_1 = mkN "konduktцr" "konduktцrer" ;
  konduktor_nn_1 = mkN "konduktor" "konduktorer" ;
  konfederal_av_1 = mkA "konfederal" ;
  konfederation_nn_1 = mkN "konfederation" "konfederationer" ;
  konfektskaal_nn_1 = mkN "konfektskеl" ;
  konferenciaer_nn_1 = mkN "konferenciдr" "konferenciдrer" ;
  konferencier_nn_1 = mkN "konferencier" "konferencierer" ;
  konferens_nn_1 = mkN "konferens" "konferenser" ;
  konfession_nn_1 = mkN "konfession" "konfessioner" ;
  konfessionarie_nn_1 = mkN "konfessionarie" "konfessionarier" ;
  konfessionell_av_1 = mkA "konfessionell" ;
  konfessionsloes_av_1 = mkA "konfessionslцs" ;
  konfidentiell_av_1 = mkA "konfidentiell" ;
  konfiguration_nn_1 = mkN "konfiguration" "konfigurationer" ;
  konfirmand_nn_1 = mkN "konfirmand" "konfirmander" ;
  konfirmation_nn_1 = mkN "konfirmation" "konfirmationer" ;
  konfirmationsbibel_nn_1 = mkN "konfirmationsbibel" ;
  konfirmationsklaenning_nn_1 = mkN "konfirmationsklдnning" ;
  konfirmationspraest_nn_1 = mkN "konfirmationsprдst" "konfirmationsprдster" ;
  konfiskation_nn_1 = mkN "konfiskation" "konfiskationer" ;
  konfiskatorisk_av_1 = mkA "konfiskatorisk" ;
  konflikt_nn_1 = mkN "konflikt" "konflikter" ;
  konfliktvarsel_nn_1 = mkN "konfliktvarsel" neutrum ;
  konform_av_1 = mkA "konform" ;
  konformig_av_1 = mkA "konformig" ;
  konformitet_nn_1 = mkN "konformitet" "konformiteter" ;
  konfrontation_nn_1 = mkN "konfrontation" "konfrontationer" ;
  konfys_av_1 = mkA "konfys" ;
  kongenial_av_1 = mkA "kongenial" ;
  kongenital_av_1 = mkA "kongenital" ;
  konglomerat_nn_1 = mkN "konglomerat" neutrum ;
  kongoles_nn_1 = mkN "kongoles" "kongoleser" ;
  kongregation_nn_1 = mkN "kongregation" "kongregationer" ;
  kongress_nn_1 = mkN "kongress" "kongresser" ;
  kongressman_nn_1 = mkN "kongressman" "kongressmannen" "kongressmдn" "kongressmдnnen" ;
  kongruens_nn_1 = mkN "kongruens" "kongruenser" ;
  kongruensboejning_nn_1 = mkN "kongruensbцjning" ;
  kongruensfall_nn_1 = mkN "kongruensfall" neutrum ;
  kongruent_av_1 = mkA "kongruent" "kongruent" ;
  konicitet_nn_1 = mkN "konicitet" "koniciteter" ;
  konisk_av_1 = mkA "konisk" ;
  konjakskrans_nn_1 = mkN "konjakskrans" ;
  konjektur_nn_1 = mkN "konjektur" "konjekturer" ;
  konjugation_nn_1 = mkN "konjugation" "konjugationer" ;
  konjunktion_nn_1 = mkN "konjunktion" "konjunktioner" ;
  konjunktiv_nn_1 = mkN "konjunktiv" "konjunktiver" ;
  konjunktur_nn_1 = mkN "konjunktur" "konjunkturer" ;
  konjunkturinstitut_nn_1 = mkN "konjunkturinstitut" neutrum ;
  konjunkturomslag_nn_1 = mkN "konjunkturomslag" neutrum ;
  konjunkturraad_nn_1 = mkN "konjunkturrеd" neutrum ;
  konkav_av_1 = mkA "konkav" ;
  konkavkonvex_av_1 = mkA "konkavkonvex" ;
  konklav_nn_1 = mkN "konklav" "konklaver" ;
  konklusion_nn_1 = mkN "konklusion" "konklusioner" ;
  konklusiv_av_1 = mkA "konklusiv" ;
  konkordans_nn_1 = mkN "konkordans" "konkordanser" ;
  konkordat_nn_1 = mkN "konkordat" neutrum ;
  konkrement_nn_1 = mkN "konkrement" neutrum ;
  konkret_av_1 = mkA "konkret" "konkret" ;
  konkretion_nn_1 = mkN "konkretion" "konkretioner" ;
  konkubin_nn_1 = mkN "konkubin" "konkubiner" ;
  konkurrenskraftig_av_1 = mkA "konkurrenskraftig" ;
  konkurrent_nn_1 = mkN "konkurrent" "konkurrenter" ;
  konkurs_nn_1 = mkN "konkurs" "konkurser" ;
  konkursbevakning_nn_1 = mkN "konkursbevakning" ;
  konkursbo_nn_1 = mkN "konkursbo" "konkursbot" "konkursbon" "konkursboen" ;
  konkursdividend_nn_1 = mkN "konkursdividend" "konkursdividender" ;
  konkursfoervaltare_nn_1 = mkN "konkursfцrvaltare" "konkursfцrvaltare" ;
  konkursmaessig_av_1 = mkA "konkursmдssig" ;
  konkursrealisation_nn_1 = mkN "konkursrealisation" "konkursrealisationer" ;
  konnaessans_nn_1 = mkN "konnдssans" "konnдssanser" ;
  konnaessoer_nn_1 = mkN "konnдssцr" "konnдssцrer" ;
  konnotation_nn_1 = mkN "konnotation" "konnotationer" ;
  konnotativ_av_1 = mkA "konnotativ" ;
  konossement_nn_1 = mkN "konossement" "konossementet" "konossementen" "konossementena" ;
  konprick_nn_1 = mkN "konprick" ;
  konsekutiv_av_1 = mkA "konsekutiv" ;
  konsekvens_nn_1 = mkN "konsekvens" "konsekvenser" ;
  konsekvent_av_1 = mkA "konsekvent" "konsekvent" ;
  konselj_nn_1 = mkN "konselj" "konseljer" ;
  konseljpresident_nn_1 = mkN "konseljpresident" "konseljpresidenter" ;
  konsert_nn_1 = mkN "konsert" "konserter" ;
  konserthus_nn_1 = mkN "konserthus" neutrum ;
  konsertmaestare_nn_1 = mkN "konsertmдstare" "konsertmдstare" ;
  konserv_nn_1 = mkN "konserv" "konserver" ;
  konservativ_av_1 = mkA "konservativ" ;
  konservator_nn_1 = mkN "konservator" "konservatorer" ;
  konservatorium_nn_1 = mkN "konservatorium" "konservatoriet" "konservatorier" "konservatorierna" ;
  konservburk_nn_1 = mkN "konservburk" ;
  konservering_nn_1 = mkN "konservering" ;
  konserveringsapparat_nn_1 = mkN "konserveringsapparat" "konserveringsapparater" ;
  konserveringsmedel_nn_1 = mkN "konserveringsmedel" neutrum ;
  konservoeppnare_nn_1 = mkN "konservцppnare" "konservцppnare" ;
  konsideration_nn_1 = mkN "konsideration" "konsiderationer" ;
  konsignation_nn_1 = mkN "konsignation" "konsignationer" ;
  konsilians_nn_1 = mkN "konsilians" "konsilianser" ;
  konsiliant_av_1 = mkA "konsiliant" "konsiliant" ;
  konsilium_nn_1 = mkN "konsilium" "konsiliet" "konsilier" "konsilierna" ;
  konsistens_nn_1 = mkN "konsistens" "konsistenser" ;
  konsistensgivare_nn_1 = mkN "konsistensgivare" "konsistensgivare" ;
  konsistorial_av_1 = mkA "konsistorial" ;
  konsistorium_nn_1 = mkN "konsistorium" "konsistoriet" "konsistorier" "konsistorierna" ;
  konsol_nn_1 = mkN "konsol" "konsoler" ;
  konsolidering_nn_1 = mkN "konsolidering" ;
  konsomme_nn_1 = mkN "konsommй" "konsommйer" ;
  konsonans_nn_1 = mkN "konsonans" "konsonanser" ;
  konsonant_av_1 = mkA "konsonant" "konsonant" ;
  konsonant_nn_1 = mkN "konsonant" "konsonanter" ;
  konsonantstam_nn_1 = mkN "konsonantstam" "konsonantstammen" "konsonantstammar" "konsonantstammarna" ;
  konsonantsystem_nn_1 = mkN "konsonantsystem" neutrum ;
  konsortium_nn_1 = mkN "konsortium" "konsortiet" "konsortier" "konsortierna" ;
  konspiration_nn_1 = mkN "konspiration" "konspirationer" ;
  konspirativ_av_1 = mkA "konspirativ" ;
  konspiratoer_nn_1 = mkN "konspiratцr" "konspiratцrer" ;
  konspiratorisk_av_1 = mkA "konspiratorisk" ;
  konst_nn_1 = mkN "konst" "konster" ;
  konstaakare_nn_1 = mkN "konstеkare" "konstеkare" ;
  konstaelskare_nn_1 = mkN "konstдlskare" "konstдlskare" ;
  konstansfenomen_nn_1 = mkN "konstansfenomen" neutrum ;
  konstant_av_1 = mkA "konstant" "konstant" ;
  konstant_nn_1 = mkN "konstant" "konstanter" ;
  konstapel_nn_1 = mkN "konstapel" ;
  konstart_nn_1 = mkN "konstart" "konstarter" ;
  konstaterande_nn_1 = mkN "konstaterande" ;
  konstberidare_nn_1 = mkN "konstberidare" "konstberidare" ;
  konstbevattning_nn_1 = mkN "konstbevattning" ;
  konstellation_nn_1 = mkN "konstellation" "konstellationer" ;
  konstfaerdig_av_1 = mkA "konstfдrdig" ;
  konstfiber_nn_1 = mkN "konstfiber" "konstfibern" "konstfibrer" "konstfibrerna" ;
  konstflygning_nn_1 = mkN "konstflygning" ;
  konstfoerening_nn_1 = mkN "konstfцrening" ;
  konstfoerfaren_av_1 = mkA "konstfцrfaren" "konstfцrfaret" ;
  konstfoervant_nn_1 = mkN "konstfцrvant" "konstfцrvanter" ;
  konstfrusen_av_1 = mkA "konstfrusen" "konstfruset" ;
  konstfull_av_1 = mkA "konstfull" ;
  konstgalleri_nn_1 = mkN "konstgalleri" "konstgallerit" "konstgallerier" "konstgallerierna" ;
  konstgjord_av_1 = mkA "konstgjord" "konstgjort" ;
  konstgrepp_nn_1 = mkN "konstgrepp" neutrum ;
  konsthall_nn_1 = mkN "konsthall" ;
  konsthantverk_nn_1 = mkN "konsthantverk" neutrum ;
  konstharts_nn_1 = mkN "konstharts" "konsthartset" "konsthartser" "konsthartserna" ;
  konsthistorisk_av_1 = mkA "konsthistorisk" ;
  konstifik_av_1 = mkA "konstifik" ;
  konstig_av_1 = mkA "konstig" ;
  konstindustri_nn_1 = mkN "konstindustri" "konstindustrier" ;
  konstitution_nn_1 = mkN "konstitution" "konstitutioner" ;
  konstitutionell_av_1 = mkA "konstitutionell" ;
  konstitutiv_av_1 = mkA "konstitutiv" ;
  konstitutorial_nn_1 = mkN "konstitutorial" neutrum ;
  konstkritiker_nn_1 = mkN "konstkritiker" "konstkritikern" "konstkritiker" "konstkritikerna" ;
  konstliv_nn_1 = mkN "konstliv" neutrum ;
  konstloes_av_1 = mkA "konstlцs" ;
  konstmaalare_nn_1 = mkN "konstmеlare" "konstmеlare" ;
  konstmaalning_nn_1 = mkN "konstmеlning" ;
  konstmuseum_nn_1 = mkN "konstmuseum" "konstmuseet" "konstmuseer" "konstmuseerna" ;
  konstnaer_nn_1 = mkN "konstnдr" "konstnдrer" ;
  konstnaerlig_av_1 = mkA "konstnдrlig" ;
  konstnaerssjael_nn_1 = mkN "konstnдrssjдl" ;
  konstpaus_nn_1 = mkN "konstpaus" "konstpauser" ;
  konstridning_nn_1 = mkN "konstridning" ;
  konstrik_av_1 = mkA "konstrik" ;
  konstriktning_nn_1 = mkN "konstriktning" ;
  konstruktion_nn_1 = mkN "konstruktion" "konstruktioner" ;
  konstruktionsdetalj_nn_1 = mkN "konstruktionsdetalj" "konstruktionsdetaljer" ;
  konstruktionslexikon_nn_1 = mkN "konstruktionslexikon" neutrum ;
  konstruktionsmaterial_nn_1 = mkN "konstruktionsmaterial" neutrum ;
  konstruktionsritning_nn_1 = mkN "konstruktionsritning" ;
  konstruktiv_av_1 = mkA "konstruktiv" ;
  konstruktoer_nn_1 = mkN "konstruktцr" "konstruktцrer" ;
  konstryttare_nn_1 = mkN "konstryttare" "konstryttare" ;
  konstsalong_nn_1 = mkN "konstsalong" "konstsalonger" ;
  konstskicklig_av_1 = mkA "konstskicklig" ;
  konstskojare_nn_1 = mkN "konstskojare" "konstskojare" ;
  konststil_nn_1 = mkN "konststil" ;
  konstutstaellning_nn_1 = mkN "konstutstдllning" ;
  konstverk_nn_1 = mkN "konstverk" neutrum ;
  konsul_nn_1 = mkN "konsul" "konsuln" "konsuler" "konsulerna" ;
  konsulaer_av_1 = mkA "konsulдr" ;
  konsularjurisdiktion_nn_1 = mkN "konsularjurisdiktion" "konsularjurisdiktioner" ;
  konsulat_nn_1 = mkN "konsulat" neutrum ;
  konsulent_nn_1 = mkN "konsulent" "konsulenter" ;
  konsulinna_nn_1 = mkN "konsulinna" ;
  konsult_nn_1 = mkN "konsult" "konsulter" ;
  konsultation_nn_1 = mkN "konsultation" "konsultationer" ;
  konsultativ_av_1 = mkA "konsultativ" ;
  konsulterande_av_1 = mkA "konsulterande" ;
  konsument_nn_1 = mkN "konsument" "konsumenter" ;
  konsumentfoerening_nn_1 = mkN "konsumentfцrening" ;
  konsumentombudsman_nn_1 = mkN "konsumentombudsman" "konsumentombudsmannen" "konsumentombudsmдn" "konsumentombudsmдnnen" ;
  konsumentpris_nn_1 = mkN "konsumentpris" neutrum ;
  konsumentprisindex_nn_1 = mkN "konsumentprisindex" neutrum ;
  konsumentverk_nn_1 = mkN "konsumentverk" neutrum ;
  konsumtionsmoejlighet_nn_1 = mkN "konsumtionsmцjlighet" "konsumtionsmцjligheter" ;
  konsumtionsskatt_nn_1 = mkN "konsumtionsskatt" "konsumtionsskatter" ;
  konsumtionsskillnad_nn_1 = mkN "konsumtionsskillnad" "konsumtionsskillnader" ;
  kont_nn_1 = mkN "kont" ;
  kontagioes_av_1 = mkA "kontagiцs" ;
  kontakt_nn_1 = mkN "kontakt" "kontakter" ;
  kontaktannons_nn_1 = mkN "kontaktannons" "kontaktannonser" ;
  kontaktborste_nn_1 = mkN "kontaktborste" utrum ;
  kontaktinfektion_nn_1 = mkN "kontaktinfektion" "kontaktinfektioner" ;
  kontaktkopia_nn_1 = mkN "kontaktkopia" ;
  kontaktledning_nn_1 = mkN "kontaktledning" ;
  kontaktlins_nn_1 = mkN "kontaktlins" "kontaktlinser" ;
  kontamination_nn_1 = mkN "kontamination" "kontaminationer" ;
  kontant_av_1 = mkA "kontant" "kontant" ;
  kontemplation_nn_1 = mkN "kontemplation" "kontemplationer" ;
  kontemplativ_av_1 = mkA "kontemplativ" ;
  konteramiral_nn_1 = mkN "konteramiral" "konteramiraler" ;
  konterfej_nn_1 = mkN "konterfej" neutrum ;
  kontext_nn_1 = mkN "kontext" "kontexter" ;
  kontinent_nn_1 = mkN "kontinent" "kontinenter" ;
  kontinental_av_1 = mkA "kontinental" ;
  kontinentalplataa_nn_1 = mkN "kontinentalplatе" "kontinentalplatеer" ;
  kontinentalsockel_nn_1 = mkN "kontinentalsockel" ;
  kontingent_nn_1 = mkN "kontingent" "kontingenter" ;
  kontinuerlig_av_1 = mkA "kontinuerlig" ;
  kontinuitet_nn_1 = mkN "kontinuitet" "kontinuiteter" ;
  kontinuum_nn_1 = mkN "kontinuum" neutrum ;
  konto_nn_1 = mkN "konto" "kontot" "konton" "kontona" ;
  kontoinnehavare_nn_1 = mkN "kontoinnehavare" "kontoinnehavare" ;
  kontokort_nn_1 = mkN "kontokort" neutrum ;
  kontokurant_nn_1 = mkN "kontokurant" "kontokuranter" ;
  kontonummer_nn_1 = mkN "kontonummer" neutrum ;
  kontor_nn_1 = mkN "kontor" neutrum ;
  kontorist_nn_1 = mkN "kontorist" "kontorister" ;
  kontorschef_nn_1 = mkN "kontorschef" "kontorschefer" ;
  kontorshus_nn_1 = mkN "kontorshus" neutrum ;
  kontorslandskap_nn_1 = mkN "kontorslandskap" "kontorslandskapet" "kontorslandskapen" "kontorslandskapena" ;
  kontorsplats_nn_1 = mkN "kontorsplats" "kontorsplatser" ;
  kontorspulpet_nn_1 = mkN "kontorspulpet" "kontorspulpeter" ;
  kontorsrum_nn_1 = mkN "kontorsrum" "kontorsrummet" "kontorsrum" "kontorsrummen" ;
  kontorsslav_nn_1 = mkN "kontorsslav" ;
  kontorsstol_nn_1 = mkN "kontorsstol" ;
  kontorstid_nn_1 = mkN "kontorstid" "kontorstider" ;
  kontorsvana_nn_1 = mkN "kontorsvana" ;
  kontoutdrag_nn_1 = mkN "kontoutdrag" neutrum ;
  kontraalt_nn_1 = mkN "kontraalt" ;
  kontrabas_nn_1 = mkN "kontrabas" ;
  kontrabok_nn_1 = mkN "kontrabok" "kontrabцcker" ;
  kontradans_nn_1 = mkN "kontradans" "kontradanser" ;
  kontradiktion_nn_1 = mkN "kontradiktion" "kontradiktioner" ;
  kontradiktorisk_av_1 = mkA "kontradiktorisk" ;
  kontraer_av_1 = mkA "kontrдr" ;
  kontrahent_nn_1 = mkN "kontrahent" "kontrahenter" ;
  kontraindikation_nn_1 = mkN "kontraindikation" "kontraindikationer" ;
  kontrakt_nn_1 = mkN "kontrakt" neutrum ;
  kontraktil_av_1 = mkA "kontraktil" ;
  kontraktion_nn_1 = mkN "kontraktion" "kontraktioner" ;
  kontraktsbrott_nn_1 = mkN "kontraktsbrott" neutrum ;
  kontraktsenlig_av_1 = mkA "kontraktsenlig" ;
  kontraktsprost_nn_1 = mkN "kontraktsprost" ;
  kontraktstid_nn_1 = mkN "kontraktstid" "kontraktstider" ;
  kontraktsvidrig_av_1 = mkA "kontraktsvidrig" ;
  kontramaerke_nn_1 = mkN "kontramдrke" ;
  kontraorder_nn_1 = mkN "kontraorder" ;
  kontraproposition_nn_1 = mkN "kontraproposition" "kontrapropositioner" ;
  kontrarevolution_nn_1 = mkN "kontrarevolution" "kontrarevolutioner" ;
  kontrast_nn_1 = mkN "kontrast" "kontraster" ;
  kontrastmedel_nn_1 = mkN "kontrastmedel" neutrum ;
  kontribution_nn_1 = mkN "kontribution" "kontributioner" ;
  kontring_nn_1 = mkN "kontring" ;
  kontroll_nn_1 = mkN "kontroll" "kontroller" ;
  kontrollant_nn_1 = mkN "kontrollant" "kontrollanter" ;
  kontrollavgift_nn_1 = mkN "kontrollavgift" "kontrollavgifter" ;
  kontrollbesiktning_nn_1 = mkN "kontrollbesiktning" ;
  kontrollbord_nn_1 = mkN "kontrollbord" neutrum ;
  kontrollgrupp_nn_1 = mkN "kontrollgrupp" "kontrollgrupper" ;
  kontrollinstrument_nn_1 = mkN "kontrollinstrument" neutrum ;
  kontrollmaerke_nn_1 = mkN "kontrollmдrke" ;
  kontrollnummer_nn_1 = mkN "kontrollnummer" neutrum ;
  kontrolloer_nn_1 = mkN "kontrollцr" "kontrollцrer" ;
  kontrollrum_nn_1 = mkN "kontrollrum" "kontrollrummet" "kontrollrum" "kontrollrummen" ;
  kontrollstaempel_nn_1 = mkN "kontrollstдmpel" ;
  kontrolluppgift_nn_1 = mkN "kontrolluppgift" "kontrolluppgifter" ;
  kontrollvaegning_nn_1 = mkN "kontrollvдgning" ;
  kontrovers_nn_1 = mkN "kontrovers" "kontroverser" ;
  kontroversiell_av_1 = mkA "kontroversiell" ;
  kontumaciedom_nn_1 = mkN "kontumaciedom" ;
  kontur_nn_1 = mkN "kontur" "konturer" ;
  konturloes_av_1 = mkA "konturlцs" ;
  konturskarp_av_1 = mkA "konturskarp" ;
  kontusion_nn_1 = mkN "kontusion" "kontusioner" ;
  konung_nn_1 = mkN "konung" ;
  konungaaett_nn_1 = mkN "konungaдtt" "konungaдtter" ;
  konungabok_nn_1 = mkN "konungabok" "konungabцcker" ;
  konungadoeme_nn_1 = mkN "konungadцme" ;
  konungaed_nn_1 = mkN "konungaed" "konungaeder" ;
  konungahus_nn_1 = mkN "konungahus" neutrum ;
  konungalaengd_nn_1 = mkN "konungalдngd" "konungalдngder" ;
  konungarike_nn_1 = mkN "konungarike" ;
  konungasaete_nn_1 = mkN "konungasдte" ;
  konungsk_av_1 = mkA "konungsk" ;
  konungslig_av_1 = mkA "konungslig" ;
  konvalescent_av_1 = mkA "konvalescent" "konvalescent" ;
  konvalescent_nn_1 = mkN "konvalescent" "konvalescenter" ;
  konvalescenthem_nn_1 = mkN "konvalescenthem" "konvalescenthemmet" "konvalescenthem" "konvalescenthemmen" ;
  konvalj_nn_1 = mkN "konvalj" "konvaljer" ;
  konvalje_nn_1 = mkN "konvalje" "konvaljer" ;
  konvenansparti_nn_1 = mkN "konvenansparti" "konvenanspartit" "konvenanspartier" "konvenanspartierna" ;
  konvent_nn_1 = mkN "konvent" neutrum ;
  konventikel_nn_1 = mkN "konventikel" ;
  konvention_nn_1 = mkN "konvention" "konventioner" ;
  konventionell_av_1 = mkA "konventionell" ;
  konvergent_av_1 = mkA "konvergent" "konvergent" ;
  konversabel_av_1 = mkA "konversabel" "konversabelt" "konversabla" "konversabla" "konversablare" "konversablast" "konversablaste" ;
  konversation_nn_1 = mkN "konversation" "konversationer" ;
  konversationslexikon_nn_1 = mkN "konversationslexikon" neutrum ;
  konversion_nn_1 = mkN "konversion" "konversioner" ;
  konversiv_av_1 = mkA "konversiv" ;
  konverter_nn_1 = mkN "konverter" ;
  konvertibel_av_1 = mkA "konvertibel" "konvertibelt" "konvertibla" "konvertibla" "konvertiblare" "konvertiblast" "konvertiblaste" ;
  konvertit_nn_1 = mkN "konvertit" "konvertiter" ;
  konvex_av_1 = mkA "konvex" ;
  konvexkonkav_av_1 = mkA "konvexkonkav" ;
  konviktorium_nn_1 = mkN "konviktorium" "konviktoriet" "konviktorier" "konviktorierna" ;
  konvoj_nn_1 = mkN "konvoj" "konvojer" ;
  konvolut_nn_1 = mkN "konvolut" neutrum ;
  konvulsion_nn_1 = mkN "konvulsion" "konvulsioner" ;
  konvulsivisk_av_1 = mkA "konvulsivisk" ;
  kooega_nn_1 = mkN "koцga" "koцgat" "koцgon" "koцgonen" ;
  kooperativ_av_1 = mkA "kooperativ" ;
  kooperativ_nn_1 = mkN "kooperativ" neutrum ;
  kooperatoer_nn_1 = mkN "kooperatцr" "kooperatцrer" ;
  koordinat_nn_1 = mkN "koordinat" "koordinater" ;
  koordinataxel_nn_1 = mkN "koordinataxel" ;
  koordinator_nn_1 = mkN "koordinator" "koordinatorer" ;
  koordinatsystem_nn_1 = mkN "koordinatsystem" neutrum ;
  kopek_nn_1 = mkN "kopek" "kopeken" "kopek" "kopeken" ;
  kopernikansk_av_1 = mkA "kopernikansk" ;
  kopia_nn_1 = mkN "kopia" ;
  kopiator_nn_1 = mkN "kopiator" "kopiatorer" ;
  kopiepapper_nn_1 = mkN "kopiepapper" neutrum ;
  kopiering_nn_1 = mkN "kopiering" ;
  kopieringsapparat_nn_1 = mkN "kopieringsapparat" "kopieringsapparater" ;
  kopieringsmaskin_nn_1 = mkN "kopieringsmaskin" "kopieringsmaskiner" ;
  kopiesvarv_nn_1 = mkN "kopiesvarv" ;
  kopioes_av_1 = mkA "kopiцs" ;
  kopist_nn_1 = mkN "kopist" "kopister" ;
  kopp_nn_1 = mkN "kopp" ;
  koppaerr_nn_1 = mkN "koppдrr" neutrum ;
  koppaerrig_av_1 = mkA "koppдrrig" ;
  kopparbrun_av_1 = mkA "kopparbrun" ;
  kopparledning_nn_1 = mkN "kopparledning" ;
  kopparmynt_nn_1 = mkN "kopparmynt" neutrum ;
  kopparorm_nn_1 = mkN "kopparorm" ;
  kopparplaat_nn_1 = mkN "kopparplеt" ;
  kopparroed_av_1 = mkA "kopparrцd" ;
  kopparslagare_nn_1 = mkN "kopparslagare" "kopparslagare" ;
  kopparspiral_nn_1 = mkN "kopparspiral" "kopparspiraler" ;
  kopparstick_nn_1 = mkN "kopparstick" neutrum ;
  kopparsulfat_nn_1 = mkN "kopparsulfat" "kopparsulfater" ;
  koppel_nn_1 = mkN "koppel" neutrum ;
  koppelvan_av_1 = mkA "koppelvan" ;
  kopplare_nn_1 = mkN "kopplare" "kopplare" ;
  koppleri_nn_1 = mkN "koppleri" "kopplerit" "kopplerier" "kopplerierna" ;
  koppling_nn_1 = mkN "koppling" ;
  kopplingspedal_nn_1 = mkN "kopplingspedal" "kopplingspedaler" ;
  kopplingsschema_nn_1 = mkN "kopplingsschema" "kopplingsschemat" "kopplingsscheman" "kopplingsschemana" ;
  kopplingston_nn_1 = mkN "kopplingston" "kopplingstoner" ;
  koppympning_nn_1 = mkN "koppympning" ;
  kopter_nn_1 = mkN "kopter" "koptern" "kopter" "kopterna" ;
  koptisk_av_1 = mkA "koptisk" ;
  kopulation_nn_1 = mkN "kopulation" "kopulationer" ;
  kopulativ_av_1 = mkA "kopulativ" ;
  kor_nn_1 = mkN "kor" neutrum ;
  koral_nn_1 = mkN "koral" "koraler" ;
  koralbok_nn_1 = mkN "koralbok" "koralbцcker" ;
  korall_nn_1 = mkN "korall" "koraller" ;
  koralldjur_nn_1 = mkN "koralldjur" neutrum ;
  korallhalsband_nn_1 = mkN "korallhalsband" neutrum ;
  koralloe_nn_1 = mkN "korallц" ;
  korallorm_nn_1 = mkN "korallorm" ;
  korallrev_nn_1 = mkN "korallrev" neutrum ;
  korallroed_av_1 = mkA "korallrцd" ;
  kordial_av_1 = mkA "kordial" ;
  kordong_nn_1 = mkN "kordong" "kordonger" ;
  kordongskruv_nn_1 = mkN "kordongskruv" ;
  korean_nn_1 = mkN "korean" "koreaner" ;
  koreanska_nn_2 = mkN "koreanska" ;
  koreograf_nn_1 = mkN "koreograf" "koreografer" ;
  koreografisk_av_1 = mkA "koreografisk" ;
  korg_nn_1 = mkN "korg" ;
  korgblommig_av_1 = mkA "korgblommig" ;
  korgosse_nn_1 = mkN "korgosse" utrum ;
  korgstol_nn_1 = mkN "korgstol" ;
  korint_nn_1 = mkN "korint" "korinter" ;
  korinter_nn_1 = mkN "korinter" "korintern" "korinter" "korinterna" ;
  korintisk_av_1 = mkA "korintisk" ;
  korist_nn_1 = mkN "korist" "korister" ;
  kork_nn_1 = mkN "kork" ;
  korkcell_nn_1 = mkN "korkcell" "korkceller" ;
  korkek_nn_1 = mkN "korkek" ;
  korkgolv_nn_1 = mkN "korkgolv" neutrum ;
  korklager_nn_1 = mkN "korklager" neutrum ;
  korkpistol_nn_1 = mkN "korkpistol" "korkpistoler" ;
  korkskoerd_nn_1 = mkN "korkskцrd" ;
  korkskruv_nn_1 = mkN "korkskruv" ;
  korkskruvslock_nn_1 = mkN "korkskruvslock" ;
  korksmak_nn_1 = mkN "korksmak" "korksmaker" ;
  korkvaevnad_nn_1 = mkN "korkvдvnad" "korkvдvnader" ;
  kormaestare_nn_1 = mkN "kormдstare" "kormдstare" ;
  kormoran_nn_1 = mkN "kormoran" "kormoraner" ;
  korn_nn_1 = mkN "korn" neutrum ;
  kornaaker_nn_1 = mkN "kornеker" ;
  kornblaa_av_1 = mkA "kornblе" "kornblеtt" ;
  kornblixt_nn_1 = mkN "kornblixt" ;
  kornbod_nn_1 = mkN "kornbod" ;
  kornbroed_nn_1 = mkN "kornbrцd" neutrum ;
  kornett_nn_1 = mkN "kornett" "kornetter" ;
  kornettist_nn_1 = mkN "kornettist" "kornettister" ;
  korngryn_nn_1 = mkN "korngryn" neutrum ;
  korngul_av_1 = mkA "korngul" ;
  kornig_av_1 = mkA "kornig" ;
  kornisch_nn_1 = mkN "kornisch" "kornischer" ;
  kornknarr_nn_1 = mkN "kornknarr" ;
  korollarium_nn_1 = mkN "korollarium" "korollariet" "korollarier" "korollarierna" ;
  korp_nn_1 = mkN "korp" ;
  korporation_nn_1 = mkN "korporation" "korporationer" ;
  korporativ_av_1 = mkA "korporativ" ;
  korpral_nn_1 = mkN "korpral" "korpraler" ;
  korpsvart_av_1 = mkA "korpsvart" "korpsvart" ;
  korpulent_av_1 = mkA "korpulent" "korpulent" ;
  korpus_nn_1 = mkN "korpus" ;
  korpuskel_nn_1 = mkN "korpuskel" "korpuskeln" "korpuskler" "korpusklerna" ;
  korr_nn_1 = mkN "korr" neutrum ;
  korrekt_av_1 = mkA "korrekt" "korrekt" ;
  korrektion_nn_1 = mkN "korrektion" "korrektioner" ;
  korrektionsanstalt_nn_1 = mkN "korrektionsanstalt" "korrektionsanstalter" ;
  korrektiv_nn_1 = mkN "korrektiv" neutrum ;
  korrektur_nn_1 = mkN "korrektur" neutrum ;
  korrekturfel_nn_1 = mkN "korrekturfel" "korrekturfelet" "korrekturfel" "korrekturfelen" ;
  korrekturtecken_nn_1 = mkN "korrekturtecken" "korrekturtecknet" "korrekturtecken" "korrekturtecknen" ;
  korrelat_nn_1 = mkN "korrelat" neutrum ;
  korrelation_nn_1 = mkN "korrelation" "korrelationer" ;
  korrespondens_nn_1 = mkN "korrespondens" "korrespondenser" ;
  korrespondenskort_nn_1 = mkN "korrespondenskort" neutrum ;
  korrespondenskurs_nn_1 = mkN "korrespondenskurs" "korrespondenskurser" ;
  korrespondent_nn_1 = mkN "korrespondent" "korrespondenter" ;
  korridor_nn_1 = mkN "korridor" "korridoren" "korridorer" "korridorerna" ;
  korridorsystem_nn_1 = mkN "korridorsystem" neutrum ;
  korrupt_av_1 = mkA "korrupt" "korrupt" ;
  kors_nn_1 = mkN "kors" neutrum ;
  korsar_nn_1 = mkN "korsar" "korsarer" ;
  korsband_nn_1 = mkN "korsband" neutrum ;
  korsbefruktning_nn_1 = mkN "korsbefruktning" ;
  korsben_nn_1 = mkN "korsben" neutrum ;
  korsblommig_av_1 = mkA "korsblommig" ;
  korselett_nn_1 = mkN "korselett" "korseletter" ;
  korsett_nn_1 = mkN "korsett" "korsetter" ;
  korsettfjaeder_nn_1 = mkN "korsettfjдder" ;
  korsfaestelse_nn_1 = mkN "korsfдstelse" "korsfдstelser" ;
  korsfarare_nn_1 = mkN "korsfarare" "korsfarare" ;
  korsfoerhoer_nn_1 = mkN "korsfцrhцr" neutrum ;
  korsgaang_nn_1 = mkN "korsgеng" ;
  korshaenvisning_nn_1 = mkN "korshдnvisning" ;
  korsikan_nn_1 = mkN "korsikan" "korsikaner" ;
  korsikanare_nn_1 = mkN "korsikanare" "korsikanare" ;
  korskrank_nn_1 = mkN "korskrank" neutrum ;
  korskyrka_nn_1 = mkN "korskyrka" ;
  korsnaebb_nn_1 = mkN "korsnдbb" ;
  korsning_nn_1 = mkN "korsning" ;
  korso_nn_1 = mkN "korso" "korsor" ;
  korsord_nn_1 = mkN "korsord" neutrum ;
  korspollination_nn_1 = mkN "korspollination" "korspollinationer" ;
  korsriddare_nn_1 = mkN "korsriddare" "korsriddare" ;
  korsrygg_nn_1 = mkN "korsrygg" ;
  korsspindel_nn_1 = mkN "korsspindel" ;
  korsstygn_nn_1 = mkN "korsstygn" neutrum ;
  korstaag_nn_1 = mkN "korstеg" neutrum ;
  korstecken_nn_1 = mkN "korstecken" "korstecknet" "korstecken" "korstecknen" ;
  korsvaeg_nn_1 = mkN "korsvдg" ;
  korsvalv_nn_1 = mkN "korsvalv" neutrum ;
  korsvirkeshus_nn_1 = mkN "korsvirkeshus" neutrum ;
  kort_av_1 = mkA "kort" "kort" ;
  kort_nn_1 = mkN "kort" neutrum ;
  kortaenda_nn_1 = mkN "kortдnda" "kortдndan" "kortдndar" "kortдndarna" ;
  kortbent_av_1 = mkA "kortbent" "kortbent" ;
  kortdistans_nn_1 = mkN "kortdistans" "kortdistanser" ;
  kortdistansloepare_nn_1 = mkN "kortdistanslцpare" "kortdistanslцpare" ;
  kortege_nn_1 = mkN "kortege" "korteger" ;
  korteligen_ab_1 = mkAdv "korteligen" ;
  kortfilm_nn_1 = mkN "kortfilm" "kortfilmer" ;
  kortform_nn_1 = mkN "kortform" "kortformer" ;
  kortfristig_av_1 = mkA "kortfristig" ;
  korthet_nn_1 = mkN "korthet" "kortheter" ;
  korthuggen_av_1 = mkA "korthuggen" "korthugget" ;
  korthus_nn_1 = mkN "korthus" neutrum ;
  kortison_nn_1 = mkN "kortison" "kortisoner" ;
  kortkatalog_nn_1 = mkN "kortkatalog" "kortkataloger" ;
  kortklippt_av_1 = mkA "kortklippt" "kortklippt" ;
  kortkonst_nn_1 = mkN "kortkonst" "kortkonster" ;
  kortkort_av_1 = mkA "kortkort" "kortkort" ;
  kortlek_nn_1 = mkN "kortlek" ;
  kortoxe_nn_1 = mkN "kortoxe" utrum ;
  kortpipig_av_1 = mkA "kortpipig" ;
  kortregister_nn_1 = mkN "kortregister" neutrum ;
  kortroman_nn_1 = mkN "kortroman" "kortromaner" ;
  kortsida_nn_1 = mkN "kortsida" ;
  kortsiktig_av_1 = mkA "kortsiktig" ;
  kortskallig_av_1 = mkA "kortskallig" ;
  kortsluta_vb_1 = mkV "kortsluta" "kortslцt" "kortslutit" ;
  kortslutning_nn_1 = mkN "kortslutning" ;
  kortspel_nn_1 = mkN "kortspel" "kortspelet" "kortspel" "kortspelen" ;
  kortspelare_nn_1 = mkN "kortspelare" "kortspelare" ;
  kortsynt_av_1 = mkA "kortsynt" "kortsynt" ;
  korttaenkt_av_1 = mkA "korttдnkt" "korttдnkt" ;
  kortvaagsbehandling_nn_1 = mkN "kortvеgsbehandling" ;
  kortvaagsradio_nn_1 = mkN "kortvеgsradio" "kortvеgsradior" ;
  kortvaegg_nn_1 = mkN "kortvдgg" ;
  kortvaext_av_1 = mkA "kortvдxt" "kortvдxt" ;
  kortvara_nn_1 = mkN "kortvara" ;
  kortvarig_av_1 = mkA "kortvarig" ;
  kortvuxen_av_1 = mkA "kortvuxen" "kortvuxet" ;
  korum_nn_1 = mkN "korum" neutrum ;
  korund_nn_1 = mkN "korund" "korunder" ;
  korus_nn_1 = mkN "korus" neutrum ;
  korv_nn_1 = mkN "korv" ;
  korvett_nn_1 = mkN "korvett" "korvetter" ;
  korvgubbe_nn_1 = mkN "korvgubbe" utrum ;
  korvig_av_1 = mkA "korvig" ;
  korvkiosk_nn_1 = mkN "korvkiosk" "korvkiosker" ;
  korvoere_nn_1 = mkN "korvцre" ;
  korvsjoe_nn_1 = mkN "korvsjц" ;
  korvskinn_nn_1 = mkN "korvskinn" neutrum ;
  korvstaand_nn_1 = mkN "korvstеnd" neutrum ;
  koryfe_nn_1 = mkN "koryfй" "koryfйer" ;
  kosack_nn_1 = mkN "kosack" "kosacker" ;
  kosackdans_nn_1 = mkN "kosackdans" "kosackdanser" ;
  koscher_av_1 = mkA "koscher" ;
  kosmetisk_av_1 = mkA "kosmetisk" ;
  kosmetolog_nn_1 = mkN "kosmetolog" "kosmetologer" ;
  kosmisk_av_1 = mkA "kosmisk" ;
  kosmodrom_nn_1 = mkN "kosmodrom" "kosmodromer" ;
  kosmogoni_nn_1 = mkN "kosmogoni" "kosmogonier" ;
  kosmolog_nn_1 = mkN "kosmolog" "kosmologer" ;
  kosmologi_nn_1 = mkN "kosmologi" "kosmologier" ;
  kosmologisk_av_1 = mkA "kosmologisk" ;
  kosmonaut_nn_1 = mkN "kosmonaut" "kosmonauter" ;
  kosmopolit_nn_1 = mkN "kosmopolit" "kosmopoliter" ;
  kosmopolitisk_av_1 = mkA "kosmopolitisk" ;
  kosmos_nn_1 = mkN "kosmos" neutrum ;
  kostbar_av_1 = mkA "kostbar" ;
  koster_nn_1 = mkN "koster" ;
  kostig_nn_1 = mkN "kostig" ;
  kostlig_av_1 = mkA "kostlig" ;
  kostnad_nn_1 = mkN "kostnad" "kostnader" ;
  kostnadsersaettning_nn_1 = mkN "kostnadsersдttning" ;
  kostnadsfri_av_1 = mkA "kostnadsfri" "kostnadsfritt" ;
  kostnadsram_nn_1 = mkN "kostnadsram" ;
  kostsam_av_1 = mkA "kostsam" "kostsamt" "kostsamma" "kostsamma" "kostsammare" "kostsammast" "kostsammaste" ;
  kostvana_nn_1 = mkN "kostvana" ;
  kostym_nn_1 = mkN "kostym" "kostymer" ;
  kostymbal_nn_1 = mkN "kostymbal" "kostymbaler" ;
  kostymering_nn_1 = mkN "kostymering" ;
  kostympjaes_nn_1 = mkN "kostympjдs" "kostympjдser" ;
  kotben_nn_1 = mkN "kotben" neutrum ;
  kotiljong_nn_1 = mkN "kotiljong" "kotiljonger" ;
  kotknackare_nn_1 = mkN "kotknackare" "kotknackare" ;
  kotled_nn_1 = mkN "kotled" "kotleder" ;
  kotlett_nn_1 = mkN "kotlett" "kotletter" ;
  kotlettfisk_nn_1 = mkN "kotlettfisk" ;
  kotlettrad_nn_1 = mkN "kotlettrad" "kotlettrader" ;
  kotpelare_nn_1 = mkN "kotpelare" "kotpelare" ;
  kotte_nn_1 = mkN "kotte" utrum ;
  kotteri_nn_1 = mkN "kotteri" "kotterit" "kotterier" "kotterierna" ;
  koturn_nn_1 = mkN "koturn" "koturner" ;
  kovaendning_nn_1 = mkN "kovдndning" ;
  kovalent_av_1 = mkA "kovalent" "kovalent" ;
  kovall_nn_1 = mkN "kovall" "kovaller" ;
  kovert_av_1 = mkA "kovert" "kovert" ;
  koyot_nn_1 = mkN "koyot" "koyoter" ;
  kpist_nn_1 = mkN "kpist" ;
  kraakbaer_nn_1 = mkN "krеkbдr" neutrum ;
  kraakfaagel_nn_1 = mkN "krеkfеgel" ;
  kraakliknande_av_1 = mkA "krеkliknande" ;
  kraakslott_nn_1 = mkN "krеkslott" neutrum ;
  kraal_nn_1 = mkN "kraal" "kraaler" ;
  kraangelmakare_nn_1 = mkN "krеngelmakare" "krеngelmakare" ;
  kraanglig_av_1 = mkA "krеnglig" ;
  kraas_nn_2 = mkN "krеs" neutrum ;
  kraasnaal_nn_1 = mkN "krеsnеl" ;
  krabat_nn_1 = mkN "krabat" "krabater" ;
  kraeftbur_nn_1 = mkN "krдftbur" ;
  kraeftdjur_nn_1 = mkN "krдftdjur" neutrum ;
  kraeftsvulst_nn_1 = mkN "krдftsvulst" "krдftsvulster" ;
  kraek_nn_1 = mkN "krдk" neutrum ;
  kraekfaerdig_av_1 = mkA "krдkfдrdig" ;
  kraekmedel_nn_1 = mkN "krдkmedel" neutrum ;
  kraekning_nn_1 = mkN "krдkning" ;
  kraeldjur_nn_1 = mkN "krдldjur" neutrum ;
  kraeldjurstyp_nn_1 = mkN "krдldjurstyp" "krдldjurstyper" ;
  kraem_nn_1 = mkN "krдm" "krдmer" ;
  kraemare_nn_1 = mkN "krдmare" "krдmare" ;
  kraemig_av_1 = mkA "krдmig" ;
  kraengning_nn_1 = mkN "krдngning" ;
  kraengningshaemmare_nn_1 = mkN "krдngningshдmmare" "krдngningshдmmare" ;
  kraengningsprov_nn_1 = mkN "krдngningsprov" neutrum ;
  kraenkande_av_1 = mkA "krдnkande" ;
  kraenkning_nn_1 = mkN "krдnkning" ;
  kraesen_av_1 = mkA "krдsen" "krдset" ;
  kraeslig_av_1 = mkA "krдslig" ;
  kraesligen_ab_1 = mkAdv "krдsligen" ;
  kraevande_av_1 = mkA "krдvande" ;
  krafsig_av_1 = mkA "krafsig" ;
  kraft_nn_1 = mkN "kraft" "krafter" ;
  kraftaatgaerd_nn_1 = mkN "kraftеtgдrd" "kraftеtgдrder" ;
  kraftaggregat_nn_1 = mkN "kraftaggregat" neutrum ;
  kraftanstraengning_nn_1 = mkN "kraftanstrдngning" ;
  kraftbaerare_nn_1 = mkN "kraftbдrare" "kraftbдrare" ;
  kraftbehov_nn_1 = mkN "kraftbehov" neutrum ;
  kraftbolag_nn_1 = mkN "kraftbolag" neutrum ;
  kraftcentral_nn_1 = mkN "kraftcentral" "kraftcentraler" ;
  kraftcentrum_nn_1 = mkN "kraftcentrum" neutrum ;
  kraftekvation_nn_1 = mkN "kraftekvation" "kraftekvationer" ;
  kraftfaelt_nn_1 = mkN "kraftfдlt" neutrum ;
  kraftfoder_nn_1 = mkN "kraftfoder" neutrum ;
  kraftfoeretag_nn_1 = mkN "kraftfцretag" neutrum ;
  kraftfull_av_1 = mkA "kraftfull" ;
  kraftig_av_1 = mkA "kraftig" ;
  kraftkarl_nn_1 = mkN "kraftkarl" ;
  kraftkraevande_av_1 = mkA "kraftkrдvande" ;
  kraftledning_nn_1 = mkN "kraftledning" ;
  kraftlinje_nn_1 = mkN "kraftlinje" "kraftlinjer" ;
  kraftloes_av_1 = mkA "kraftlцs" ;
  kraftloeshet_nn_1 = mkN "kraftlцshet" "kraftlцsheter" ;
  kraftmaetning_nn_1 = mkN "kraftmдtning" ;
  kraftnaet_nn_1 = mkN "kraftnдt" neutrum ;
  kraftoeverfoering_nn_1 = mkN "kraftцverfцring" ;
  kraftord_nn_1 = mkN "kraftord" neutrum ;
  kraftpaket_nn_1 = mkN "kraftpaket" neutrum ;
  kraftparallellogram_nn_1 = mkN "kraftparallellogram" "kraftparallellogrammen" "kraftparallellogrammer" "kraftparallellogrammerna" ;
  kraftpartikel_nn_1 = mkN "kraftpartikel" ;
  kraftprov_nn_1 = mkN "kraftprov" neutrum ;
  kraftsport_nn_1 = mkN "kraftsport" "kraftsporter" ;
  kraftstation_nn_1 = mkN "kraftstation" "kraftstationer" ;
  krafttag_nn_1 = mkN "krafttag" neutrum ;
  kraftuttryck_nn_1 = mkN "kraftuttryck" neutrum ;
  kraftvaermeverk_nn_1 = mkN "kraftvдrmeverk" neutrum ;
  kraftverk_nn_1 = mkN "kraftverk" neutrum ;
  kraftverksbygge_nn_1 = mkN "kraftverksbygge" ;
  kraftvunnen_av_1 = mkA "kraftvunnen" "kraftvunnet" "kraftvunna" "kraftvunna" "kraftvunnare" "kraftvunnast" "kraftvunnaste" ;
  krage_nn_1 = mkN "krage" utrum ;
  kraghandske_nn_1 = mkN "kraghandske" utrum ;
  kragknapp_nn_1 = mkN "kragknapp" ;
  kragloes_av_1 = mkA "kraglцs" ;
  kragsnibb_nn_1 = mkN "kragsnibb" ;
  kragsten_nn_1 = mkN "kragsten" "kragstenen" "kragstenar" "kragstenarna" ;
  kragstoevel_nn_1 = mkN "kragstцvel" ;
  krake_nn_1 = mkN "krake" utrum ;
  krakel_nn_1 = mkN "krakel" "krakelet" "krakel" "krakelen" ;
  krakmandel_nn_1 = mkN "krakmandel" ;
  kral_nn_1 = mkN "kral" "kraler" ;
  kram_av_1 = mkA "kram" ;
  kram_nn_1 = mkN "kram" ;
  kramp_nn_1 = mkN "kramp" "kramper" ;
  krampaktig_av_1 = mkA "krampaktig" ;
  kramploesande_av_1 = mkA "kramplцsande" ;
  krampstillande_av_1 = mkA "krampstillande" ;
  kramsfaagel_nn_1 = mkN "kramsfеgel" ;
  kran_nn_1 = mkN "kran" ;
  kranbalk_nn_1 = mkN "kranbalk" ;
  kranbalksvis_ab_1 = mkAdv "kranbalksvis" ;
  kranium_nn_1 = mkN "kranium" "kraniet" "kranier" "kranierna" ;
  krank_av_1 = mkA "krank" ;
  krankik_nn_1 = mkN "krankik" ;
  krans_nn_1 = mkN "krans" ;
  kransartaer_nn_1 = mkN "kransartдr" "kransartдrer" ;
  kransband_nn_1 = mkN "kransband" neutrum ;
  kranskaerl_nn_1 = mkN "kranskдrl" neutrum ;
  kransnedlaeggning_nn_1 = mkN "kransnedlдggning" ;
  kranvatten_nn_1 = mkN "kranvatten" "kranvattnet" "kranvatten" "kranvattnen" ;
  krasch_nn_2 = mkN "krasch" "krascher" ;
  kraschan_nn_1 = mkN "kraschan" "kraschaner" ;
  krass_av_1 = mkA "krass" ;
  krasslig_av_1 = mkA "krasslig" ;
  krater_nn_1 = mkN "krater" ;
  kraterberg_nn_1 = mkN "kraterberg" neutrum ;
  kratersjoe_nn_1 = mkN "kratersjц" ;
  krats_nn_1 = mkN "krats" ;
  krav_nn_1 = mkN "krav" neutrum ;
  kravall_nn_1 = mkN "kravall" "kravaller" ;
  kravallstaket_nn_1 = mkN "kravallstaket" neutrum ;
  kravatt_nn_1 = mkN "kravatt" "kravatter" ;
  kravattnaal_nn_1 = mkN "kravattnеl" ;
  kravbrev_nn_1 = mkN "kravbrev" neutrum ;
  kravell_nn_1 = mkN "kravell" "kraveller" ;
  kravloes_av_1 = mkA "kravlцs" ;
  krax_nn_1 = mkN "krax" neutrum ;
  kreation_nn_1 = mkN "kreation" "kreationer" ;
  kreativ_av_1 = mkA "kreativ" ;
  kreativitet_nn_1 = mkN "kreativitet" "kreativiteter" ;
  kreatur_nn_1 = mkN "kreatur" neutrum ;
  kreatursbesaettning_nn_1 = mkN "kreatursbesдttning" ;
  kreatursloes_av_1 = mkA "kreaturslцs" ;
  kredit_nn_1 = mkN "kredit" "krediter" ;
  kreditinstitut_nn_1 = mkN "kreditinstitut" neutrum ;
  kreditiv_nn_1 = mkN "kreditiv" neutrum ;
  kreditkort_nn_1 = mkN "kreditkort" neutrum ;
  kreditmarknad_nn_1 = mkN "kreditmarknad" "kreditmarknader" ;
  kreditor_nn_1 = mkN "kreditor" "kreditorer" ;
  kreditupplysning_nn_1 = mkN "kreditupplysning" ;
  krematorium_nn_1 = mkN "krematorium" "krematoriet" "krematorier" "krematorierna" ;
  kremering_nn_1 = mkN "kremering" ;
  kremlolog_nn_1 = mkN "kremlolog" "kremlologer" ;
  krenelering_nn_1 = mkN "krenelering" ;
  kreol_nn_1 = mkN "kreol" "kreoler" ;
  kreolspraak_nn_1 = mkN "kreolsprеk" neutrum ;
  kreosotolja_nn_1 = mkN "kreosotolja" ;
  krestomati_nn_1 = mkN "krestomati" "krestomatier" ;
  kretensare_nn_1 = mkN "kretensare" "kretensare" ;
  kretensisk_av_1 = mkA "kretensisk" ;
  kreter_nn_1 = mkN "kreter" "kretern" "kreter" "kreterna" ;
  kretin_nn_1 = mkN "kretin" "kretiner" ;
  kretisk_av_1 = mkA "kretisk" ;
  kretong_nn_1 = mkN "kretong" "kretonger" ;
  krets_nn_1 = mkN "krets" ;
  kretsgaang_nn_1 = mkN "kretsgеng" ;
  kretskort_nn_1 = mkN "kretskort" neutrum ;
  kretslopp_nn_1 = mkN "kretslopp" neutrum ;
  krevad_nn_1 = mkN "krevad" "krevader" ;
  krig_nn_1 = mkN "krig" neutrum ;
  krigare_nn_1 = mkN "krigare" "krigare" ;
  krigargrav_nn_1 = mkN "krigargrav" ;
  krigfoerande_av_1 = mkA "krigfцrande" ;
  krigfoering_nn_1 = mkN "krigfцring" ;
  krigisk_av_1 = mkA "krigisk" ;
  krigsaar_nn_1 = mkN "krigsеr" neutrum ;
  krigsbarn_nn_1 = mkN "krigsbarn" neutrum ;
  krigsberedskap_nn_1 = mkN "krigsberedskap" "krigsberedskaper" ;
  krigsbuss_nn_1 = mkN "krigsbuss" ;
  krigsbyte_nn_1 = mkN "krigsbyte" ;
  krigsdans_nn_1 = mkN "krigsdans" "krigsdanser" ;
  krigsdekoration_nn_1 = mkN "krigsdekoration" "krigsdekorationer" ;
  krigsfaange_nn_1 = mkN "krigsfеnge" utrum ;
  krigsfartyg_nn_1 = mkN "krigsfartyg" neutrum ;
  krigsfoerbrytare_nn_1 = mkN "krigsfцrbrytare" "krigsfцrbrytare" ;
  krigsfoerbrytelse_nn_1 = mkN "krigsfцrbrytelse" "krigsfцrbrytelser" ;
  krigsfoerklaring_nn_1 = mkN "krigsfцrklaring" ;
  krigsgud_nn_1 = mkN "krigsgud" ;
  krigsherre_nn_1 = mkN "krigsherre" utrum ;
  krigshierarki_nn_1 = mkN "krigshierarki" "krigshierarkier" ;
  krigskorrespondent_nn_1 = mkN "krigskorrespondent" "krigskorrespondenter" ;
  krigsmaalning_nn_1 = mkN "krigsmеlning" ;
  krigsmakt_nn_1 = mkN "krigsmakt" "krigsmakter" ;
  krigsman_nn_1 = mkN "krigsman" "krigsmannen" "krigsmдn" "krigsmдnnen" ;
  krigsmiljoe_nn_1 = mkN "krigsmiljц" "krigsmiljцn" "krigsmiljцer" "krigsmiljцerna" ;
  krigsplacering_nn_1 = mkN "krigsplacering" ;
  krigsraad_nn_1 = mkN "krigsrеd" neutrum ;
  krigsraedd_av_1 = mkA "krigsrдdd" ;
  krigsroman_nn_1 = mkN "krigsroman" "krigsromaner" ;
  krigsskaadeplats_nn_1 = mkN "krigsskеdeplats" "krigsskеdeplatser" ;
  krigsskadestaand_nn_1 = mkN "krigsskadestеnd" neutrum ;
  krigsskepp_nn_1 = mkN "krigsskepp" neutrum ;
  krigsslut_nn_1 = mkN "krigsslut" neutrum ;
  krigsspel_nn_1 = mkN "krigsspel" "krigsspelet" "krigsspel" "krigsspelen" ;
  krigstaag_nn_1 = mkN "krigstеg" neutrum ;
  krigstillstaand_nn_1 = mkN "krigstillstеnd" neutrum ;
  krigstjaenstgoering_nn_1 = mkN "krigstjдnstgцring" ;
  krigsutbrott_nn_1 = mkN "krigsutbrott" neutrum ;
  krikon_nn_1 = mkN "krikon" neutrum ;
  krillaetare_nn_1 = mkN "krillдtare" "krillдtare" ;
  krillstim_nn_1 = mkN "krillstim" "krillstimmet" "krillstim" "krillstimmen" ;
  kriminalare_nn_1 = mkN "kriminalare" "kriminalare" ;
  kriminaldaare_nn_1 = mkN "kriminaldеre" utrum ;
  kriminalitet_nn_1 = mkN "kriminalitet" "kriminaliteter" ;
  kriminalpolis_nn_1 = mkN "kriminalpolis" "kriminalpoliser" ;
  kriminalregister_nn_1 = mkN "kriminalregister" neutrum ;
  kriminalroman_nn_1 = mkN "kriminalroman" "kriminalromaner" ;
  kriminell_av_1 = mkA "kriminell" ;
  kriminologisk_av_1 = mkA "kriminologisk" ;
  kring_ab_1 = mkAdv "kring" ;
  kringboende_av_1 = mkA "kringboende" ;
  kringbyggd_av_1 = mkA "kringbyggd" "kringbyggt" ;
  kringfarande_av_1 = mkA "kringfarande" ;
  kringflackande_av_1 = mkA "kringflackande" ;
  kringgaa_vb_1 = mkV "kringgе" "kringgеr" "kringgе" "kringgick" "kringgеtt" "kringgеngen" ;
  kringla_nn_1 = mkN "kringla" ;
  kringliggande_av_1 = mkA "kringliggande" ;
  kringresande_av_1 = mkA "kringresande" ;
  kringsjuk_av_1 = mkA "kringsjuk" ;
  kringskaera_vb_1 = mkV "kringskдra" "kringskar" "kringskurit" ;
  kringspringande_av_1 = mkA "kringspringande" ;
  kringstaaende_av_1 = mkA "kringstеende" ;
  kringsynt_av_1 = mkA "kringsynt" "kringsynt" ;
  kringutrustning_nn_1 = mkN "kringutrustning" ;
  kringvaervd_av_1 = mkA "kringvдrvd" "kringvдrvt" ;
  kringvandrande_av_1 = mkA "kringvandrande" ;
  krinolin_nn_1 = mkN "krinolin" "krinoliner" ;
  kris_nn_1 = mkN "kris" "kriser" ;
  kris_nn_2 = mkN "kris" ;
  krismedel_nn_1 = mkN "krismedel" neutrum ;
  krispaket_nn_1 = mkN "krispaket" neutrum ;
  kristall_nn_1 = mkN "kristall" "kristaller" ;
  kristallaxel_nn_1 = mkN "kristallaxel" ;
  kristallform_nn_1 = mkN "kristallform" "kristallformer" ;
  kristallglas_nn_1 = mkN "kristallglas" neutrum ;
  kristallin_av_1 = mkA "kristallin" ;
  kristallinisk_av_1 = mkA "kristallinisk" ;
  kristallins_nn_1 = mkN "kristallins" "kristallinser" ;
  kristallisation_nn_1 = mkN "kristallisation" "kristallisationer" ;
  kristallisk_av_1 = mkA "kristallisk" ;
  kristallklar_av_1 = mkA "kristallklar" ;
  kristallmoenster_nn_1 = mkN "kristallmцnster" neutrum ;
  kristallmottagare_nn_1 = mkN "kristallmottagare" "kristallmottagare" ;
  kristallografisk_av_1 = mkA "kristallografisk" ;
  kristallsystem_nn_1 = mkN "kristallsystem" neutrum ;
  kristen_av_1 = mkA "kristen" "kristet" ;
  kristendom_nn_1 = mkN "kristendom" ;
  kristenhet_nn_1 = mkN "kristenhet" "kristenheter" ;
  kristid_nn_1 = mkN "kristid" "kristider" ;
  kristidsfoeretag_nn_1 = mkN "kristidsfцretag" neutrum ;
  kristlig_av_1 = mkA "kristlig" ;
  kristtorn_nn_1 = mkN "kristtorn" ;
  kristtrogen_av_1 = mkA "kristtrogen" "kristtroget" ;
  kristusmonogram_nn_1 = mkN "kristusmonogram" "kristusmonogrammet" "kristusmonogram" "kristusmonogrammen" ;
  kriterium_nn_1 = mkN "kriterium" "kriteriet" "kriterier" "kriterierna" ;
  kritig_av_1 = mkA "kritig" ;
  kritik_nn_1 = mkN "kritik" "kritiker" ;
  kritiker_nn_1 = mkN "kritiker" "kritikern" "kritiker" "kritikerna" ;
  kritikloes_av_1 = mkA "kritiklцs" ;
  kritikstorm_nn_1 = mkN "kritikstorm" ;
  kritisk_av_1 = mkA "kritisk" ;
  kritstreck_nn_1 = mkN "kritstreck" neutrum ;
  kritstrecksrandig_av_1 = mkA "kritstrecksrandig" ;
  kritter_nn_1 = mkN "kritter" neutrum ;
  kritvit_av_1 = mkA "kritvit" ;
  kroat_nn_1 = mkN "kroat" "kroater" ;
  kroatiska_nn_2 = mkN "kroatiska" ;
  krock_nn_1 = mkN "krock" ;
  kroegare_nn_1 = mkN "krцgare" "krцgare" ;
  kroek_nn_1 = mkN "krцk" ;
  kroekning_nn_1 = mkN "krцkning" ;
  kroekt_av_1 = mkA "krцkt" "krцkt" ;
  kroen_nn_1 = mkN "krцn" neutrum ;
  kroenika_nn_1 = mkN "krцnika" ;
  kroenikebok_nn_1 = mkN "krцnikebok" "krцnikebцcker" ;
  kroenikespel_nn_1 = mkN "krцnikespel" "krцnikespelet" "krцnikespel" "krцnikespelen" ;
  kroenikoer_nn_1 = mkN "krцnikцr" "krцnikцrer" ;
  kroening_nn_1 = mkN "krцning" ;
  kroeson_nn_1 = mkN "krцson" neutrum ;
  kroesus_nn_1 = mkN "krцsus" ;
  krog_nn_1 = mkN "krog" ;
  krogkund_nn_1 = mkN "krogkund" "krogkunder" ;
  krogrond_nn_1 = mkN "krogrond" "krogronder" ;
  krogshow_nn_1 = mkN "krogshow" "krogshower" ;
  krogsvaeng_nn_1 = mkN "krogsvдng" ;
  krok_nn_1 = mkN "krok" ;
  krokan_nn_1 = mkN "krokan" "krokaner" ;
  krokben_ab_1 = mkAdv "krokben" ;
  krokett_nn_1 = mkN "krokett" "kroketter" ;
  kroki_nn_1 = mkN "kroki" "krokier" ;
  krokig_av_1 = mkA "krokig" ;
  krokighet_nn_1 = mkN "krokighet" "krokigheter" ;
  kroknaest_av_1 = mkA "kroknдst" "kroknдst" ;
  krokodil_nn_1 = mkN "krokodil" "krokodiler" ;
  krokryggig_av_1 = mkA "krokryggig" ;
  kroksabel_nn_1 = mkN "kroksabel" ;
  krokus_nn_1 = mkN "krokus" ;
  krokvaeg_nn_1 = mkN "krokvдg" ;
  krokvuxen_av_1 = mkA "krokvuxen" "krokvuxet" ;
  kromat_nn_1 = mkN "kromat" neutrum ;
  kromatisk_av_1 = mkA "kromatisk" ;
  kromolitografi_nn_1 = mkN "kromolitografi" "kromolitografier" ;
  kromosom_nn_1 = mkN "kromosom" "kromosomer" ;
  kromosompar_nn_1 = mkN "kromosompar" neutrum ;
  kromosomuppsaettning_nn_1 = mkN "kromosomuppsдttning" ;
  kronblad_nn_1 = mkN "kronblad" neutrum ;
  kronbrud_nn_1 = mkN "kronbrud" ;
  krondike_nn_1 = mkN "krondike" ;
  kronhaest_nn_1 = mkN "kronhдst" ;
  kronhjort_nn_1 = mkN "kronhjort" ;
  kroniker_nn_1 = mkN "kroniker" "kronikern" "kroniker" "kronikerna" ;
  kronikerhem_nn_1 = mkN "kronikerhem" "kronikerhemmet" "kronikerhem" "kronikerhemmen" ;
  kronisk_av_1 = mkA "kronisk" ;
  kronjurist_nn_1 = mkN "kronjurist" "kronjurister" ;
  kronjuvel_nn_1 = mkN "kronjuvel" "kronjuveler" ;
  kronkoloni_nn_1 = mkN "kronkoloni" "kronkolonier" ;
  kronmutter_nn_1 = mkN "kronmutter" ;
  kronofogde_nn_1 = mkN "kronofogde" utrum ;
  kronojaegare_nn_1 = mkN "kronojдgare" "kronojдgare" ;
  kronojord_nn_1 = mkN "kronojord" ;
  kronologi_nn_1 = mkN "kronologi" "kronologier" ;
  kronologisk_av_1 = mkA "kronologisk" ;
  kronometer_nn_1 = mkN "kronometer" ;
  kronopark_nn_1 = mkN "kronopark" "kronoparker" ;
  kronoutskyld_nn_1 = mkN "kronoutskyld" "kronoutskylder" ;
  kronprins_nn_1 = mkN "kronprins" ;
  krontal_nn_1 = mkN "krontal" "krontalet" "krontalen" "krontalena" ;
  kronvittne_nn_1 = mkN "kronvittne" ;
  kronvrak_nn_1 = mkN "kronvrak" neutrum ;
  kropp_nn_1 = mkN "kropp" ;
  kroppaas_nn_1 = mkN "kroppеs" ;
  kroppsarbetare_nn_1 = mkN "kroppsarbetare" "kroppsarbetare" ;
  kroppsbild_nn_1 = mkN "kroppsbild" "kroppsbilder" ;
  kroppsbyggare_nn_1 = mkN "kroppsbyggare" "kroppsbyggare" ;
  kroppsbyggnad_nn_1 = mkN "kroppsbyggnad" "kroppsbyggnader" ;
  kroppscell_nn_1 = mkN "kroppscell" "kroppsceller" ;
  kroppsdel_nn_1 = mkN "kroppsdel" "kroppsdelen" "kroppsdelar" "kroppsdelarna" ;
  kroppsfett_nn_1 = mkN "kroppsfett" "kroppsfettet" "kroppsfetter" "kroppsfetterna" ;
  kroppsform_nn_1 = mkN "kroppsform" "kroppsformer" ;
  kroppsfunktion_nn_1 = mkN "kroppsfunktion" "kroppsfunktioner" ;
  kroppskanal_nn_1 = mkN "kroppskanal" "kroppskanaler" ;
  kroppslig_av_1 = mkA "kroppslig" ;
  kroppsligen_ab_1 = mkAdv "kroppsligen" ;
  kroppsnaera_av_1 = mkA "kroppsnдra" ;
  kroppsoeppning_nn_1 = mkN "kroppsцppning" ;
  kroppsoevning_nn_1 = mkN "kroppsцvning" ;
  kroppsorgan_nn_1 = mkN "kroppsorgan" neutrum ;
  kroppsroerelse_nn_1 = mkN "kroppsrцrelse" "kroppsrцrelser" ;
  kroppsstaellning_nn_1 = mkN "kroppsstдllning" ;
  kroppsstyrka_nn_1 = mkN "kroppsstyrka" ;
  kroppstemperatur_nn_1 = mkN "kroppstemperatur" "kroppstemperaturer" ;
  kroppsvaetska_nn_1 = mkN "kroppsvдtska" ;
  kroppsvaevnad_nn_1 = mkN "kroppsvдvnad" "kroppsvдvnader" ;
  kroppsvikt_nn_1 = mkN "kroppsvikt" "kroppsvikter" ;
  kroppsvisitation_nn_1 = mkN "kroppsvisitation" "kroppsvisitationer" ;
  kross_nn_1 = mkN "kross" ;
  krossaar_nn_1 = mkN "krossеr" neutrum ;
  krossfri_av_1 = mkA "krossfri" "krossfritt" ;
  krossmaskin_nn_1 = mkN "krossmaskin" "krossmaskiner" ;
  krubbitare_nn_1 = mkN "krubbitare" "krubbitare" ;
  krucifix_nn_1 = mkN "krucifix" neutrum ;
  krukgods_nn_1 = mkN "krukgods" neutrum ;
  krukmakare_nn_1 = mkN "krukmakare" "krukmakare" ;
  krukmakeri_nn_1 = mkN "krukmakeri" "krukmakerit" "krukmakerier" "krukmakerierna" ;
  krukvaext_nn_1 = mkN "krukvдxt" "krukvдxter" ;
  krullhaarig_av_1 = mkA "krullhеrig" ;
  krullig_av_1 = mkA "krullig" ;
  krum_av_1 = mkA "krum" "krumt" "krumma" "krumma" "krummare" "krummast" "krummaste" ;
  krumbukt_nn_1 = mkN "krumbukt" "krumbukter" ;
  krumelur_nn_1 = mkN "krumelur" "krumelurer" ;
  krumhorn_nn_1 = mkN "krumhorn" neutrum ;
  krumpen_av_1 = mkA "krumpen" "krumpet" ;
  krumspraang_nn_1 = mkN "krumsprеng" neutrum ;
  krumstav_nn_1 = mkN "krumstav" ;
  krus_nn_1 = mkN "krus" neutrum ;
  krusbaer_nn_1 = mkN "krusbдr" neutrum ;
  krusbaersbuske_nn_1 = mkN "krusbдrsbuske" utrum ;
  kruserlig_av_1 = mkA "kruserlig" ;
  krushaarig_av_1 = mkA "krushеrig" ;
  krusidull_nn_1 = mkN "krusidull" "krusiduller" ;
  krusidullig_av_1 = mkA "krusidullig" ;
  krusig_av_1 = mkA "krusig" ;
  krustaang_nn_1 = mkN "krustеng" "krustдnger" ;
  krustaatel_nn_1 = mkN "krustеtel" ;
  krustad_nn_1 = mkN "krustad" "krustader" ;
  krutdurk_nn_1 = mkN "krutdurk" ;
  krutgas_nn_1 = mkN "krutgas" "krutgaser" ;
  krutgubbe_nn_1 = mkN "krutgubbe" utrum ;
  kruthorn_nn_1 = mkN "kruthorn" neutrum ;
  krutkorn_nn_1 = mkN "krutkorn" neutrum ;
  krutmotor_nn_1 = mkN "krutmotor" "krutmotorer" ;
  krutong_nn_1 = mkN "krutong" "krutonger" ;
  krutsort_nn_1 = mkN "krutsort" "krutsorter" ;
  kruttorr_av_1 = mkA "kruttorr" ;
  krux_nn_1 = mkN "krux" neutrum ;
  kry_av_1 = mkA "kry" "krytt" ;
  kryckig_av_1 = mkA "kryckig" ;
  kryddbod_nn_1 = mkN "kryddbod" ;
  kryddgroensak_nn_1 = mkN "kryddgrцnsak" "kryddgrцnsaker" ;
  kryddoert_nn_1 = mkN "kryddцrt" "kryddцrter" ;
  kryddsaas_nn_1 = mkN "kryddsеs" "kryddsеser" ;
  kryddstark_av_1 = mkA "kryddstark" ;
  kryddvaext_nn_1 = mkN "kryddvдxt" "kryddvдxter" ;
  krympfilm_nn_1 = mkN "krympfilm" "krympfilmer" ;
  krympfri_av_1 = mkA "krympfri" "krympfritt" ;
  krympling_nn_1 = mkN "krympling" ;
  krympmaan_nn_1 = mkN "krympmеn" "krympmеner" ;
  kryogen_av_1 = mkA "kryogen" ;
  kryostat_nn_1 = mkN "kryostat" "kryostater" ;
  kryoteknik_nn_1 = mkN "kryoteknik" "kryotekniker" ;
  kryp_nn_1 = mkN "kryp" neutrum ;
  kryperi_nn_1 = mkN "kryperi" "kryperit" "kryperier" "kryperierna" ;
  krypfil_nn_1 = mkN "krypfil" "krypfiler" ;
  kryphaal_nn_1 = mkN "kryphеl" neutrum ;
  kryphaallfasthet_nn_1 = mkN "kryphеllfasthet" "kryphеllfastheter" ;
  krypin_nn_1 = mkN "krypin" "krypinnet" "krypin" "krypinnen" ;
  krypskytt_nn_1 = mkN "krypskytt" ;
  kryptisk_av_1 = mkA "kryptisk" ;
  krypto_nn_1 = mkN "krypto" "kryptot" "krypton" "kryptona" ;
  kryptofascist_nn_1 = mkN "kryptofascist" "kryptofascister" ;
  kryptogam_av_1 = mkA "kryptogam" ;
  kryptogam_nn_1 = mkN "kryptogam" "kryptogamer" ;
  krysantem_nn_1 = mkN "krysantem" "krysantemer" ;
  krysantemum_nn_1 = mkN "krysantemum" ;
  krysolit_nn_1 = mkN "krysolit" "krysoliter" ;
  krysopras_nn_1 = mkN "krysopras" "krysopraser" ;
  kryss_nn_1 = mkN "kryss" neutrum ;
  kryssare_nn_1 = mkN "kryssare" "kryssare" ;
  kryssfoerband_nn_1 = mkN "kryssfцrband" neutrum ;
  krysshult_nn_1 = mkN "krysshult" ;
  kryssmast_nn_1 = mkN "kryssmast" "kryssmaster" ;
  kryssning_nn_1 = mkN "kryssning" ;
  kryssningsraket_nn_1 = mkN "kryssningsraket" "kryssningsraketer" ;
  kryssningsrobot_nn_1 = mkN "kryssningsrobot" ;
  krysstag_nn_1 = mkN "krysstag" neutrum ;
  kryssvalv_nn_1 = mkN "kryssvalv" neutrum ;
  krystvaerk_nn_1 = mkN "krystvдrk" ;
  kub_nn_1 = mkN "kub" "kuber" ;
  kuban_nn_1 = mkN "kuban" "kubaner" ;
  kubansk_av_1 = mkA "kubansk" ;
  kubb_nn_1 = mkN "kubb" ;
  kubbe_nn_1 = mkN "kubbe" utrum ;
  kubik_nn_1 = mkN "kubik" "kubiken" "kubik" "kubiken" ;
  kubikdecimeter_nn_1 = mkN "kubikdecimeter" ;
  kubikmeter_nn_1 = mkN "kubikmeter" ;
  kubikmillimeter_nn_1 = mkN "kubikmillimeter" ;
  kubikrot_nn_1 = mkN "kubikrot" "kubikrцtter" ;
  kubisk_av_1 = mkA "kubisk" ;
  kubist_nn_1 = mkN "kubist" "kubister" ;
  kubistisk_av_1 = mkA "kubistisk" ;
  kudde_nn_1 = mkN "kudde" utrum ;
  kuddkrig_nn_1 = mkN "kuddkrig" neutrum ;
  kuddvar_nn_1 = mkN "kuddvar" neutrum ;
  kuf_nn_1 = mkN "kuf" ;
  kufisk_av_1 = mkA "kufisk" ;
  kugg_nn_1 = mkN "kugg" ;
  kugge_nn_1 = mkN "kugge" utrum ;
  kuggfraaga_nn_1 = mkN "kuggfrеga" ;
  kugghjul_nn_1 = mkN "kugghjul" neutrum ;
  kuggstaang_nn_1 = mkN "kuggstеng" "kuggstдnger" ;
  kuggvaexel_nn_1 = mkN "kuggvдxel" ;
  kujon_nn_1 = mkN "kujon" "kujoner" ;
  kuk_nn_1 = mkN "kuk" ;
  kul_av_1 = mkA "kul" ;
  kulak_nn_1 = mkN "kulak" "kulaker" ;
  kulen_av_1 = mkA "kulen" "kulet" ;
  kulfaang_nn_1 = mkN "kulfеng" neutrum ;
  kulgevaer_nn_1 = mkN "kulgevдr" neutrum ;
  kulhaal_nn_1 = mkN "kulhеl" neutrum ;
  kuli_nn_1 = mkN "kuli" "kulin" "kulier" "kulierna" ;
  kulig_av_1 = mkA "kulig" ;
  kulinarisk_av_1 = mkA "kulinarisk" ;
  kuling_nn_1 = mkN "kuling" ;
  kuliss_nn_1 = mkN "kuliss" "kulisser" ;
  kulkaerve_nn_1 = mkN "kulkдrve" utrum ;
  kulkvarn_nn_1 = mkN "kulkvarn" ;
  kull_ab_1 = mkAdv "kull" ;
  kull_nn_1 = mkN "kull" ;
  kullager_nn_1 = mkN "kullager" neutrum ;
  kulle_nn_1 = mkN "kulle" utrum ;
  kulled_nn_1 = mkN "kulled" "kulleder" ;
  kullersten_nn_1 = mkN "kullersten" "kullerstenen" "kullerstenar" "kullerstenarna" ;
  kullig_av_1 = mkA "kullig" ;
  kullkamrat_nn_1 = mkN "kullkamrat" "kullkamrater" ;
  kullko_nn_1 = mkN "kullko" "kullkor" ;
  kullrig_av_1 = mkA "kullrig" ;
  kullsyskon_nn_1 = mkN "kullsyskon" neutrum ;
  kulmage_nn_1 = mkN "kulmage" utrum ;
  kulmination_nn_1 = mkN "kulmination" "kulminationer" ;
  kuloer_nn_1 = mkN "kulцr" "kulцrer" ;
  kuloert_av_1 = mkA "kulцrt" "kulцrt" ;
  kuloertvaett_nn_1 = mkN "kulцrtvдtt" ;
  kulram_nn_1 = mkN "kulram" ;
  kulskrivmaskin_nn_1 = mkN "kulskrivmaskin" "kulskrivmaskiner" ;
  kulspel_nn_1 = mkN "kulspel" "kulspelet" "kulspel" "kulspelen" ;
  kulsprutegevaer_nn_1 = mkN "kulsprutegevдr" neutrum ;
  kulsprutepistol_nn_1 = mkN "kulsprutepistol" "kulsprutepistoler" ;
  kulstoetare_nn_1 = mkN "kulstцtare" "kulstцtare" ;
  kulstoetning_nn_1 = mkN "kulstцtning" ;
  kult_nn_1 = mkN "kult" "kulter" ;
  kult_nn_2 = mkN "kult" ;
  kultfoeremaal_nn_1 = mkN "kultfцremеl" neutrum ;
  kulthandling_nn_1 = mkN "kulthandling" ;
  kulting_nn_1 = mkN "kulting" ;
  kultisk_av_1 = mkA "kultisk" ;
  kultivator_nn_1 = mkN "kultivator" "kultivatorer" ;
  kultplats_nn_1 = mkN "kultplats" "kultplatser" ;
  kultur_nn_1 = mkN "kultur" "kulturer" ;
  kulturaktivitet_nn_1 = mkN "kulturaktivitet" "kulturaktiviteter" ;
  kulturarbetare_nn_1 = mkN "kulturarbetare" "kulturarbetare" ;
  kulturartikel_nn_1 = mkN "kulturartikel" ;
  kulturarv_nn_1 = mkN "kulturarv" neutrum ;
  kulturattache_nn_1 = mkN "kulturattachй" "kulturattachйer" ;
  kulturbaerare_nn_1 = mkN "kulturbдrare" "kulturbдrare" ;
  kulturbygd_nn_1 = mkN "kulturbygd" "kulturbygder" ;
  kulturcentrum_nn_1 = mkN "kulturcentrum" neutrum ;
  kulturchock_nn_1 = mkN "kulturchock" "kulturchocker" ;
  kulturdebatt_nn_1 = mkN "kulturdebatt" "kulturdebatter" ;
  kulturell_av_1 = mkA "kulturell" ;
  kulturfientlig_av_1 = mkA "kulturfientlig" ;
  kulturfolk_nn_1 = mkN "kulturfolk" neutrum ;
  kulturform_nn_1 = mkN "kulturform" "kulturformer" ;
  kulturgaerning_nn_1 = mkN "kulturgдrning" ;
  kulturhistorisk_av_1 = mkA "kulturhistorisk" ;
  kulturhus_nn_1 = mkN "kulturhus" neutrum ;
  kulturinstitut_nn_1 = mkN "kulturinstitut" neutrum ;
  kulturknutte_nn_1 = mkN "kulturknutte" utrum ;
  kulturkollision_nn_1 = mkN "kulturkollision" "kulturkollisioner" ;
  kulturkrets_nn_1 = mkN "kulturkrets" ;
  kulturlager_nn_1 = mkN "kulturlager" neutrum ;
  kulturland_nn_1 = mkN "kulturland" "kulturlandet" "kulturlдnder" "kulturlдnderna" ;
  kulturlandskap_nn_1 = mkN "kulturlandskap" "kulturlandskapet" "kulturlandskapen" "kulturlandskapena" ;
  kulturminne_nn_1 = mkN "kulturminne" ;
  kulturminnesmaerke_nn_1 = mkN "kulturminnesmдrke" ;
  kulturminnesvaard_nn_1 = mkN "kulturminnesvеrd" ;
  kulturmoenster_nn_1 = mkN "kulturmцnster" neutrum ;
  kulturperson_nn_1 = mkN "kulturperson" "kulturpersoner" ;
  kulturpersonlighet_nn_1 = mkN "kulturpersonlighet" "kulturpersonligheter" ;
  kulturraad_nn_1 = mkN "kulturrеd" neutrum ;
  kulturradikal_nn_1 = mkN "kulturradikal" "kulturradikaler" ;
  kulturreservat_nn_1 = mkN "kulturreservat" neutrum ;
  kulturrevolution_nn_1 = mkN "kulturrevolution" "kulturrevolutioner" ;
  kultursida_nn_1 = mkN "kultursida" ;
  kulturskribent_nn_1 = mkN "kulturskribent" "kulturskribenter" ;
  kulturutbyte_nn_1 = mkN "kulturutbyte" ;
  kulturvaext_nn_1 = mkN "kulturvдxt" "kulturvдxter" ;
  kulventil_nn_1 = mkN "kulventil" "kulventiler" ;
  kulvert_nn_1 = mkN "kulvert" ;
  kummel_nn_1 = mkN "kummel" "kummlet" "kummel" "kummlen" ;
  kummel_nn_2 = mkN "kummel" "kummeln" "kummlar" "kummlarna" ;
  kumpan_nn_1 = mkN "kumpan" "kumpaner" ;
  kumulativ_av_1 = mkA "kumulativ" ;
  kumulering_nn_1 = mkN "kumulering" ;
  kund_nn_1 = mkN "kund" "kunder" ;
  kundkrets_nn_1 = mkN "kundkrets" ;
  kundvagn_nn_1 = mkN "kundvagn" ;
  kung_nn_1 = mkN "kung" ;
  kungaaett_nn_1 = mkN "kungaдtt" "kungaдtter" ;
  kungadoeme_nn_1 = mkN "kungadцme" ;
  kungaed_nn_1 = mkN "kungaed" "kungaeder" ;
  kungahus_nn_1 = mkN "kungahus" neutrum ;
  kungalaengd_nn_1 = mkN "kungalдngd" "kungalдngder" ;
  kungasaete_nn_1 = mkN "kungasдte" ;
  kungaval_nn_1 = mkN "kungaval" neutrum ;
  kunglig_av_1 = mkA "kunglig" ;
  kunglighet_nn_1 = mkN "kunglighet" "kungligheter" ;
  kungoerelse_nn_1 = mkN "kungцrelse" "kungцrelser" ;
  kungsaadra_nn_1 = mkN "kungsеdra" ;
  kungsaengslilja_nn_1 = mkN "kungsдngslilja" ;
  kungsblaa_av_1 = mkA "kungsblе" "kungsblеtt" ;
  kungsbonde_nn_1 = mkN "kungsbonde" "kungsbцnder" ;
  kungsfaagel_nn_1 = mkN "kungsfеgel" ;
  kungsfiskare_nn_1 = mkN "kungsfiskare" "kungsfiskare" ;
  kungsgaard_nn_1 = mkN "kungsgеrd" ;
  kungsgambit_nn_1 = mkN "kungsgambit" ;
  kungshoeg_nn_1 = mkN "kungshцg" ;
  kungsljus_nn_1 = mkN "kungsljus" neutrum ;
  kungsoern_nn_1 = mkN "kungsцrn" ;
  kungsord_nn_1 = mkN "kungsord" neutrum ;
  kungstanke_nn_1 = mkN "kungstanke" utrum ;
  kungstiger_nn_1 = mkN "kungstiger" ;
  kungsvaeg_nn_1 = mkN "kungsvдg" ;
  kunnig_av_1 = mkA "kunnig" ;
  kunskap_nn_1 = mkN "kunskap" "kunskaper" ;
  kunskapare_nn_1 = mkN "kunskapare" "kunskapare" ;
  kunskapskontroll_nn_1 = mkN "kunskapskontroll" "kunskapskontroller" ;
  kunskapsnivaa_nn_1 = mkN "kunskapsnivе" "kunskapsnivеer" ;
  kunskapsstoff_nn_1 = mkN "kunskapsstoff" neutrum ;
  kupe_nn_1 = mkN "kupй" "kupйer" ;
  kupevaermare_nn_1 = mkN "kupйvдrmare" "kupйvдrmare" ;
  kupidon_nn_1 = mkN "kupidon" "kupidoner" ;
  kupig_av_1 = mkA "kupig" ;
  kuplett_nn_1 = mkN "kuplett" "kupletter" ;
  kupol_nn_1 = mkN "kupol" "kupoler" ;
  kupolformig_av_1 = mkA "kupolformig" ;
  kupolgrav_nn_1 = mkN "kupolgrav" ;
  kupong_nn_1 = mkN "kupong" "kuponger" ;
  kupongklippare_nn_1 = mkN "kupongklippare" "kupongklippare" ;
  kupp_nn_1 = mkN "kupp" "kupper" ;
  kuppfoersoek_nn_1 = mkN "kuppfцrsцk" neutrum ;
  kur_nn_1 = mkN "kur" "kurer" ;
  kur_nn_2 = mkN "kur" ;
  kuranstalt_nn_1 = mkN "kuranstalt" "kuranstalter" ;
  kurant_av_1 = mkA "kurant" "kurant" ;
  kuratel_nn_1 = mkN "kuratel" "kuratelet" "kuratel" "kuratelen" ;
  kurativ_av_1 = mkA "kurativ" ;
  kurator_nn_1 = mkN "kurator" "kuratorer" ;
  kurbits_nn_1 = mkN "kurbits" ;
  kurd_nn_1 = mkN "kurd" "kurder" ;
  kurdiska_nn_2 = mkN "kurdiska" ;
  kurfurste_nn_1 = mkN "kurfurste" utrum ;
  kurhus_nn_1 = mkN "kurhus" neutrum ;
  kurioes_av_1 = mkA "kuriцs" ;
  kuriositet_nn_1 = mkN "kuriositet" "kuriositeter" ;
  kuriosum_nn_1 = mkN "kuriosum" "kuriosum" "kuriosa" "kuriosana" ;
  kurir_nn_1 = mkN "kurir" "kurirer" ;
  kurirpass_nn_1 = mkN "kurirpass" neutrum ;
  kurort_nn_1 = mkN "kurort" "kurorter" ;
  kurr_nn_2 = mkN "kurr" neutrum ;
  kurre_nn_1 = mkN "kurre" utrum ;
  kurs_nn_1 = mkN "kurs" "kurser" ;
  kursare_nn_1 = mkN "kursare" "kursare" ;
  kursiv_av_1 = mkA "kursiv" ;
  kursiv_nn_1 = mkN "kursiv" "kursiver" ;
  kurskamrat_nn_1 = mkN "kurskamrat" "kurskamrater" ;
  kursnotering_nn_1 = mkN "kursnotering" ;
  kursor_nn_1 = mkN "kursor" "kursorer" ;
  kursorisk_av_1 = mkA "kursorisk" ;
  kursstegring_nn_1 = mkN "kursstegring" ;
  kurtage_nn_1 = mkN "kurtage" "kurtaget" "kurtage" "kurtagen" ;
  kurtis_nn_1 = mkN "kurtis" "kurtiser" ;
  kurtisan_nn_1 = mkN "kurtisan" "kurtisaner" ;
  kurtisoer_nn_1 = mkN "kurtisцr" "kurtisцrer" ;
  kurvatur_nn_1 = mkN "kurvatur" "kurvaturer" ;
  kurvig_av_1 = mkA "kurvig" ;
  kurvstabil_av_1 = mkA "kurvstabil" ;
  kurvtagning_nn_1 = mkN "kurvtagning" ;
  kuse_nn_1 = mkN "kuse" utrum ;
  kusin_nn_1 = mkN "kusin" "kusiner" ;
  kusinaektenskap_nn_1 = mkN "kusinдktenskap" "kusinдktenskapet" "kusinдktenskapen" "kusinдktenskapena" ;
  kusk_nn_1 = mkN "kusk" ;
  kuskbock_nn_1 = mkN "kuskbock" ;
  kuslig_av_1 = mkA "kuslig" ;
  kust_nn_1 = mkN "kust" "kuster" ;
  kustbygd_nn_1 = mkN "kustbygd" "kustbygder" ;
  kustfisk_nn_1 = mkN "kustfisk" ;
  kustjaegare_nn_1 = mkN "kustjдgare" "kustjдgare" ;
  kustlinje_nn_1 = mkN "kustlinje" "kustlinjer" ;
  kustod_nn_1 = mkN "kustod" "kustoder" ;
  kustomraade_nn_1 = mkN "kustomrеde" ;
  kustort_nn_1 = mkN "kustort" "kustorter" ;
  kustslaett_nn_1 = mkN "kustslдtt" "kustslдtter" ;
  kut_nn_1 = mkN "kut" ;
  kutig_av_1 = mkA "kutig" ;
  kutryggig_av_1 = mkA "kutryggig" ;
  kutter_nn_2 = mkN "kutter" ;
  kutting_nn_1 = mkN "kutting" ;
  kuttrasju_nn_1 = mkN "kuttrasju" "kuttrasjut" "kuttrasjun" "kuttrasjuna" ;
  kutym_nn_1 = mkN "kutym" "kutymer" ;
  kuvert_nn_1 = mkN "kuvert" neutrum ;
  kuvertavgift_nn_1 = mkN "kuvertavgift" "kuvertavgifter" ;
  kuvertbroed_nn_1 = mkN "kuvertbrцd" neutrum ;
  kuvoes_nn_1 = mkN "kuvцs" "kuvцser" ;
  kuwaitier_nn_1 = mkN "kuwaitier" "kuwaitiern" "kuwaitier" "kuwaitierna" ;
  kuwaitisk_av_1 = mkA "kuwaitisk" ;
  kvackare_nn_1 = mkN "kvackare" "kvackare" ;
  kvacksalvare_nn_1 = mkN "kvacksalvare" "kvacksalvare" ;
  kvacksalveri_nn_1 = mkN "kvacksalveri" "kvacksalverit" "kvacksalverier" "kvacksalverierna" ;
  kvader_nn_1 = mkN "kvader" ;
  kvadrant_nn_1 = mkN "kvadrant" "kvadranter" ;
  kvadrat_nn_1 = mkN "kvadrat" "kvadrater" ;
  kvadratisk_av_1 = mkA "kvadratisk" ;
  kvadratkilometer_nn_1 = mkN "kvadratkilometer" ;
  kvadratmeter_nn_1 = mkN "kvadratmeter" ;
  kvadratrot_nn_1 = mkN "kvadratrot" "kvadratrцtter" ;
  kvadriljon_nn_1 = mkN "kvadriljon" "kvadriljoner" ;
  kvadrupelallians_nn_1 = mkN "kvadrupelallians" "kvadrupelallianser" ;
  kvaeda_vb_1 = mkV "kvдda" "kvad" "kvдdit" ;
  kvaekare_nn_1 = mkN "kvдkare" "kvдkare" ;
  kvaeljning_nn_1 = mkN "kvдljning" ;
  kvaell_nn_1 = mkN "kvдll" ;
  kvaellsbris_nn_1 = mkN "kvдllsbris" ;
  kvaellsignal_nn_1 = mkN "kvдllsignal" "kvдllsignaler" ;
  kvaellskurs_nn_1 = mkN "kvдllskurs" "kvдllskurser" ;
  kvaellslig_av_1 = mkA "kvдllslig" ;
  kvaellsmaaltid_nn_1 = mkN "kvдllsmеltid" "kvдllsmеltider" ;
  kvaellsmaenniska_nn_1 = mkN "kvдllsmдnniska" ;
  kvaellsoeppen_av_1 = mkA "kvдllsцppen" "kvдllsцppet" ;
  kvaellssammankomst_nn_1 = mkN "kvдllssammankomst" "kvдllssammankomster" ;
  kvaellsunderhaallning_nn_1 = mkN "kvдllsunderhеllning" ;
  kvaellsvard_nn_1 = mkN "kvдllsvard" "kvдllsvarder" ;
  kvaevande_av_1 = mkA "kvдvande" ;
  kvaevegoedselmedel_nn_1 = mkN "kvдvegцdselmedel" neutrum ;
  kvaeveoxid_nn_1 = mkN "kvдveoxid" "kvдveoxider" ;
  kval_nn_1 = mkN "kval" neutrum ;
  kvalfull_av_1 = mkA "kvalfull" ;
  kvalfylld_av_1 = mkA "kvalfylld" "kvalfyllt" ;
  kvalificering_nn_1 = mkN "kvalificering" ;
  kvalifikation_nn_1 = mkN "kvalifikation" "kvalifikationer" ;
  kvalifikationsaar_nn_1 = mkN "kvalifikationsеr" neutrum ;
  kvalitativ_av_1 = mkA "kvalitativ" ;
  kvalite_nn_1 = mkN "kvalitй" "kvalitйer" ;
  kvalitet_nn_1 = mkN "kvalitet" "kvaliteter" ;
  kvalitetsauktion_nn_1 = mkN "kvalitetsauktion" "kvalitetsauktioner" ;
  kvalitetskontroll_nn_1 = mkN "kvalitetskontroll" "kvalitetskontroller" ;
  kvalmig_av_1 = mkA "kvalmig" ;
  kvalster_nn_1 = mkN "kvalster" neutrum ;
  kvantitativ_av_1 = mkA "kvantitativ" ;
  kvantitet_nn_1 = mkN "kvantitet" "kvantiteter" ;
  kvanttal_nn_1 = mkN "kvanttal" "kvanttalet" "kvanttalen" "kvanttalena" ;
  kvantum_nn_1 = mkN "kvantum" neutrum ;
  kvar_ab_1 = mkAdv "kvar" ;
  kvargloemd_av_1 = mkA "kvarglцmd" "kvarglцmt" ;
  kvarhaalla_vb_1 = mkV "kvarhеlla" "kvarhцll" "kvarhеllit" ;
  kvark_nn_1 = mkN "kvark" ;
  kvarkklimp_nn_1 = mkN "kvarkklimp" ;
  kvarn_nn_1 = mkN "kvarn" ;
  kvarndamm_nn_1 = mkN "kvarndamm" ;
  kvarnhjul_nn_1 = mkN "kvarnhjul" neutrum ;
  kvarnsten_nn_1 = mkN "kvarnsten" "kvarnstenen" "kvarnstenar" "kvarnstenarna" ;
  kvarnvinge_nn_1 = mkN "kvarnvinge" utrum ;
  kvarsittare_nn_1 = mkN "kvarsittare" "kvarsittare" ;
  kvarskatt_nn_1 = mkN "kvarskatt" "kvarskatter" ;
  kvarstad_nn_1 = mkN "kvarstad" "kvarstader" ;
  kvart_nn_1 = mkN "kvart" ;
  kvart_nn_2 = mkN "kvart" "kvarter" ;
  kvart_nn_3 = mkN "kvart" ;
  kvartal_nn_1 = mkN "kvartal" "kvartalet" "kvartalen" "kvartalena" ;
  kvarter_nn_1 = mkN "kvarter" "kvarteret" "kvarter" "kvarteren" ;
  kvartermaestare_nn_1 = mkN "kvartermдstare" "kvartermдstare" ;
  kvarterspolis_nn_1 = mkN "kvarterspolis" "kvarterspoliser" ;
  kvartett_nn_1 = mkN "kvartett" "kvartetter" ;
  kvartil_nn_1 = mkN "kvartil" "kvartiler" ;
  kvarting_nn_1 = mkN "kvarting" ;
  kvarts_nn_1 = mkN "kvarts" "kvartser" ;
  kvartsbutelj_nn_1 = mkN "kvartsbutelj" "kvartsbuteljer" ;
  kvartsfigur_nn_1 = mkN "kvartsfigur" "kvartsfigurer" ;
  kvartsfinal_nn_1 = mkN "kvartsfinal" "kvartsfinaler" ;
  kvartsit_nn_1 = mkN "kvartsit" "kvartsiter" ;
  kvartskristall_nn_1 = mkN "kvartskristall" "kvartskristaller" ;
  kvartssamtal_nn_1 = mkN "kvartssamtal" "kvartssamtalet" "kvartssamtalen" "kvartssamtalena" ;
  kvartssekel_nn_1 = mkN "kvartssekel" neutrum ;
  kvartston_nn_1 = mkN "kvartston" "kvartstoner" ;
  kvartsur_nn_1 = mkN "kvartsur" neutrum ;
  kvarvarande_av_1 = mkA "kvarvarande" ;
  kvasar_nn_1 = mkN "kvasar" "kvasarer" ;
  kvasikontrakt_nn_1 = mkN "kvasikontrakt" neutrum ;
  kvasikristall_nn_1 = mkN "kvasikristall" "kvasikristaller" ;
  kvass_nn_1 = mkN "kvass" ;
  kvast_nn_1 = mkN "kvast" ;
  kvastfening_nn_1 = mkN "kvastfening" ;
  kvastprick_nn_1 = mkN "kvastprick" ;
  kvastskaft_nn_1 = mkN "kvastskaft" neutrum ;
  kvav_av_1 = mkA "kvav" ;
  kved_nn_1 = mkN "kved" ;
  kverulant_nn_1 = mkN "kverulant" "kverulanter" ;
  kverulantisk_av_1 = mkA "kverulantisk" ;
  kvick_av_1 = mkA "kvick" ;
  kvickhet_nn_1 = mkN "kvickhet" "kvickheter" ;
  kvickhuvud_nn_1 = mkN "kvickhuvud" "kvickhuvudet" "kvickhuvuden" "kvickhuvudena" ;
  kvickoegd_av_1 = mkA "kvickцgd" "kvickцgt" ;
  kvicksilverfoerening_nn_1 = mkN "kvicksilverfцrening" ;
  kvicksilverpelare_nn_1 = mkN "kvicksilverpelare" "kvicksilverpelare" ;
  kvicktaenkt_av_1 = mkA "kvicktдnkt" "kvicktдnkt" ;
  kvidande_nn_1 = mkN "kvidande" ;
  kvidd_nn_1 = mkN "kvidd" "kvidder" ;
  kvigkalv_nn_1 = mkN "kvigkalv" ;
  kvinna_nn_1 = mkN "kvinna" ;
  kvinnfolk_nn_1 = mkN "kvinnfolk" neutrum ;
  kvinnlig_av_1 = mkA "kvinnlig" ;
  kvinnoben_nn_1 = mkN "kvinnoben" neutrum ;
  kvinnobild_nn_1 = mkN "kvinnobild" "kvinnobilder" ;
  kvinnobroest_nn_1 = mkN "kvinnobrцst" neutrum ;
  kvinnodraekt_nn_1 = mkN "kvinnodrдkt" "kvinnodrдkter" ;
  kvinnofaengelse_nn_1 = mkN "kvinnofдngelse" "kvinnofдngelset" "kvinnofдngelser" "kvinnofдngelserna" ;
  kvinnofoerfoerare_nn_1 = mkN "kvinnofцrfцrare" "kvinnofцrfцrare" ;
  kvinnofraaga_nn_1 = mkN "kvinnofrеga" ;
  kvinnofrisyr_nn_1 = mkN "kvinnofrisyr" "kvinnofrisyrer" ;
  kvinnograv_nn_1 = mkN "kvinnograv" ;
  kvinnohus_nn_1 = mkN "kvinnohus" neutrum ;
  kvinnoklinik_nn_1 = mkN "kvinnoklinik" "kvinnokliniker" ;
  kvinnolaeger_nn_1 = mkN "kvinnolдger" neutrum ;
  kvinnolaekare_nn_1 = mkN "kvinnolдkare" "kvinnolдkare" ;
  kvinnonamn_nn_1 = mkN "kvinnonamn" neutrum ;
  kvinnoplagg_nn_1 = mkN "kvinnoplagg" neutrum ;
  kvinnopraest_nn_1 = mkN "kvinnoprдst" "kvinnoprдster" ;
  kvinnoroerelse_nn_1 = mkN "kvinnorцrelse" "kvinnorцrelser" ;
  kvinnoroll_nn_1 = mkN "kvinnoroll" "kvinnoroller" ;
  kvinnorov_nn_1 = mkN "kvinnorov" neutrum ;
  kvinnosakskvinna_nn_1 = mkN "kvinnosakskvinna" ;
  kvinnosjukdom_nn_1 = mkN "kvinnosjukdom" ;
  kvinnoskulptur_nn_1 = mkN "kvinnoskulptur" "kvinnoskulpturer" ;
  kvinnotjusare_nn_1 = mkN "kvinnotjusare" "kvinnotjusare" ;
  kvint_nn_1 = mkN "kvint" "kvinter" ;
  kvintett_nn_1 = mkN "kvintett" "kvintetter" ;
  kvisslig_av_1 = mkA "kvisslig" ;
  kvist_nn_1 = mkN "kvist" ;
  kvistfri_av_1 = mkA "kvistfri" "kvistfritt" ;
  kvisthaal_nn_1 = mkN "kvisthеl" neutrum ;
  kvistig_av_1 = mkA "kvistig" ;
  kvistliknande_av_1 = mkA "kvistliknande" ;
  kvistloes_av_1 = mkA "kvistlцs" ;
  kvitt_ab_1 = mkAdv "kvitt" ;
  kvitt_av_1 = mkA "kvitt" ;
  kvitten_nn_1 = mkN "kvitten" "kvitten" "kvitten" "kvittena" ;
  kvittens_nn_1 = mkN "kvittens" "kvittenser" ;
  kvitteringsmaal_nn_1 = mkN "kvitteringsmеl" neutrum ;
  kvittning_nn_1 = mkN "kvittning" ;
  kvitto_nn_1 = mkN "kvitto" "kvittot" "kvitton" "kvittona" ;
  kvittrig_av_1 = mkA "kvittrig" ;
  kvot_nn_1 = mkN "kvot" "kvoter" ;
  kvotering_nn_1 = mkN "kvotering" ;
  kybernetik_nn_1 = mkN "kybernetik" "kybernetiker" ;
  kybernetisk_av_1 = mkA "kybernetisk" ;
  kyckling_nn_1 = mkN "kyckling" ;
  kycklingmoder_nn_1 = mkN "kycklingmoder" "kycklingmodern" "kycklingmцdrar" "kycklingmцdrarna" ;
  kyffig_av_1 = mkA "kyffig" ;
  kyl_nn_1 = mkN "kyl" ;
  kylare_nn_1 = mkN "kylare" "kylare" ;
  kylargaller_nn_1 = mkN "kylargaller" neutrum ;
  kylargardin_nn_1 = mkN "kylargardin" "kylargardiner" ;
  kyldisk_nn_1 = mkN "kyldisk" ;
  kylhus_nn_1 = mkN "kylhus" neutrum ;
  kylig_av_1 = mkA "kylig" ;
  kylklamp_nn_1 = mkN "kylklamp" ;
  kylkonserv_nn_1 = mkN "kylkonserv" "kylkonserver" ;
  kylledning_nn_1 = mkN "kylledning" ;
  kyller_nn_1 = mkN "kyller" neutrum ;
  kylning_nn_1 = mkN "kylning" ;
  kylsig_av_1 = mkA "kylsig" ;
  kylskaap_nn_1 = mkN "kylskеp" neutrum ;
  kylslagen_av_1 = mkA "kylslagen" "kylslaget" ;
  kylvagn_nn_1 = mkN "kylvagn" ;
  kymation_nn_1 = mkN "kymation" "kymatiet" "kymatier" "kymatierna" ;
  kymig_av_1 = mkA "kymig" ;
  kymograf_nn_1 = mkN "kymograf" "kymografer" ;
  kymrer_nn_1 = mkN "kymrer" "kymrern" "kymrer" "kymrerna" ;
  kyniker_nn_1 = mkN "kyniker" "kynikern" "kyniker" "kynikerna" ;
  kynisk_av_1 = mkA "kynisk" ;
  kynolog_nn_1 = mkN "kynolog" "kynologer" ;
  kyp_nn_1 = mkN "kyp" ;
  kypare_nn_1 = mkN "kypare" "kypare" ;
  kypert_nn_1 = mkN "kypert" ;
  kyrass_nn_1 = mkN "kyrass" "kyrasser" ;
  kyrassiaer_nn_1 = mkN "kyrassiдr" "kyrassiдrer" ;
  kyrillisk_av_1 = mkA "kyrillisk" ;
  kyrka_nn_1 = mkN "kyrka" ;
  kyrkbaat_nn_1 = mkN "kyrkbеt" ;
  kyrkbacke_nn_1 = mkN "kyrkbacke" utrum ;
  kyrkbaenk_nn_1 = mkN "kyrkbдnk" ;
  kyrkbesoek_nn_1 = mkN "kyrkbesцk" neutrum ;
  kyrkbibel_nn_1 = mkN "kyrkbibel" ;
  kyrkbok_nn_1 = mkN "kyrkbok" "kyrkbцcker" ;
  kyrkbroellop_nn_1 = mkN "kyrkbrцllop" neutrum ;
  kyrkby_nn_1 = mkN "kyrkby" "kyrkbyn" "kyrkbyar" "kyrkbyarna" ;
  kyrkfoenster_nn_1 = mkN "kyrkfцnster" neutrum ;
  kyrklig_av_1 = mkA "kyrklig" ;
  kyrkoaar_nn_1 = mkN "kyrkoеr" neutrum ;
  kyrkoadjunkt_nn_1 = mkN "kyrkoadjunkt" "kyrkoadjunkter" ;
  kyrkobesoek_nn_1 = mkN "kyrkobesцk" neutrum ;
  kyrkobesoekare_nn_1 = mkN "kyrkobesцkare" "kyrkobesцkare" ;
  kyrkobok_nn_1 = mkN "kyrkobok" "kyrkobцcker" ;
  kyrkobroder_nn_1 = mkN "kyrkobroder" "kyrkobrodern" "kyrkobrцder" "kyrkobrцderna" ;
  kyrkofader_nn_1 = mkN "kyrkofader" "kyrkofadern" "kyrkofдder" "kyrkofдderna" ;
  kyrkofullmaektig_nn_1 = mkN "kyrkofullmдktig" "kyrkofullmдktigen" "kyrkofullmдktige" "kyrkofullmдktigena" ;
  kyrkogaard_nn_1 = mkN "kyrkogеrd" ;
  kyrkohandbok_nn_1 = mkN "kyrkohandbok" "kyrkohandbцcker" ;
  kyrkoherde_nn_1 = mkN "kyrkoherde" utrum ;
  kyrkoman_nn_1 = mkN "kyrkoman" "kyrkomannen" "kyrkomдn" "kyrkomдnnen" ;
  kyrkomoete_nn_1 = mkN "kyrkomцte" ;
  kyrkomusiker_nn_1 = mkN "kyrkomusiker" "kyrkomusikern" "kyrkomusiker" "kyrkomusikerna" ;
  kyrkoraad_nn_1 = mkN "kyrkorеd" neutrum ;
  kyrkorum_nn_1 = mkN "kyrkorum" "kyrkorummet" "kyrkorum" "kyrkorummen" ;
  kyrkosaang_nn_1 = mkN "kyrkosеng" "kyrkosеnger" ;
  kyrkosamfund_nn_1 = mkN "kyrkosamfund" neutrum ;
  kyrkospraak_nn_1 = mkN "kyrkosprеk" neutrum ;
  kyrkostaemma_nn_1 = mkN "kyrkostдmma" ;
  kyrkoton_nn_1 = mkN "kyrkoton" "kyrkotoner" ;
  kyrkotonart_nn_1 = mkN "kyrkotonart" "kyrkotonarter" ;
  kyrkoverksamhet_nn_1 = mkN "kyrkoverksamhet" "kyrkoverksamheter" ;
  kyrksal_nn_1 = mkN "kyrksal" ;
  kyrksam_av_1 = mkA "kyrksam" "kyrksamt" "kyrksamma" "kyrksamma" "kyrksammare" "kyrksammast" "kyrksammaste" ;
  kyrkskriva_vb_1 = mkV "kyrkskriva" "kyrkskrev" "kyrkskrivit" ;
  kyrksocken_nn_1 = mkN "kyrksocken" "kyrksockenn" "kyrksocknar" "kyrksocknarna" ;
  kyrkstoet_nn_1 = mkN "kyrkstцt" ;
  kyrktagning_nn_1 = mkN "kyrktagning" ;
  kyrktorn_nn_1 = mkN "kyrktorn" neutrum ;
  kyrktupp_nn_1 = mkN "kyrktupp" ;
  kyrkvaerd_nn_1 = mkN "kyrkvдrd" ;
  kyrkvaktmaestare_nn_1 = mkN "kyrkvaktmдstare" "kyrkvaktmдstare" ;
  kysk_av_1 = mkA "kysk" ;
  kyskhet_nn_1 = mkN "kyskhet" "kyskheter" ;
  kyskhetsbaelte_nn_1 = mkN "kyskhetsbдlte" ;
  kyskhetsloefte_nn_1 = mkN "kyskhetslцfte" ;
  kyss_nn_1 = mkN "kyss" ;
  kyssaekta_av_1 = mkA "kyssдkta" ;
  kysstaeck_av_1 = mkA "kysstдck" ;
  kytt_nn_1 = mkN "kytt" neutrum ;
  laadaemne_nn_1 = mkN "lеdдmne" ;
  laadkamera_nn_1 = mkN "lеdkamera" ;
  laadspik_nn_1 = mkN "lеdspik" ;
  laag_av_1 = mkA "lеg" "lдgre" "lдgst" ;
  laagblad_nn_1 = mkN "lеgblad" neutrum ;
  laagfaerg_nn_1 = mkN "lеgfдrg" "lеgfдrger" ;
  laagfjaell_nn_1 = mkN "lеgfjдll" neutrum ;
  laagfrekvens_nn_1 = mkN "lеgfrekvens" "lеgfrekvenser" ;
  laagfrekvent_av_1 = mkA "lеgfrekvent" "lеgfrekvent" ;
  laaghalt_av_1 = mkA "lеghalt" "lеghalt" ;
  laaghet_nn_1 = mkN "lеghet" "lеgheter" ;
  laaghus_nn_1 = mkN "lеghus" neutrum ;
  laaginkomsttagare_nn_1 = mkN "lеginkomsttagare" "lеginkomsttagare" ;
  laagkonjunktur_nn_1 = mkN "lеgkonjunktur" "lеgkonjunkturer" ;
  laagkyrklig_av_1 = mkA "lеgkyrklig" ;
  laaglaent_av_1 = mkA "lеglдnt" "lеglдnt" ;
  laaglandsras_nn_1 = mkN "lеglandsras" "lеglandsraser" ;
  laagloeneprofil_nn_1 = mkN "lеglцneprofil" "lеglцneprofiler" ;
  laagmaeld_av_1 = mkA "lеgmдld" "lеgmдlt" ;
  laagmosse_nn_1 = mkN "lеgmosse" utrum ;
  laagpresterande_av_1 = mkA "lеgpresterande" ;
  laagpris_nn_1 = mkN "lеgpris" neutrum ;
  laagpriskort_nn_1 = mkN "lеgpriskort" neutrum ;
  laagproduktiv_av_1 = mkA "lеgproduktiv" ;
  laagrelief_nn_1 = mkN "lеgrelief" "lеgreliefer" ;
  laagsaesong_nn_1 = mkN "lеgsдsong" "lеgsдsonger" ;
  laagsint_av_1 = mkA "lеgsint" "lеgsint" ;
  laagsko_nn_1 = mkN "lеgsko" "lеgskor" ;
  laagslaett_nn_1 = mkN "lеgslдtt" "lеgslдtter" ;
  laagsniff_nn_1 = mkN "lеgsniff" ;
  laagspaend_av_1 = mkA "lеgspдnd" ;
  laagspaenning_nn_1 = mkN "lеgspдnning" ;
  laagstadium_nn_1 = mkN "lеgstadium" "lеgstadiet" "lеgstadier" "lеgstadierna" ;
  laagsvavlig_av_1 = mkA "lеgsvavlig" ;
  laagtryck_nn_1 = mkN "lеgtryck" neutrum ;
  laagtstaaende_av_1 = mkA "lеgtstеende" ;
  laagtysk_av_1 = mkA "lеgtysk" ;
  laagvaerdig_av_1 = mkA "lеgvдrdig" ;
  laagvaext_av_1 = mkA "lеgvдxt" "lеgvдxt" ;
  laagvatten_nn_1 = mkN "lеgvatten" "lеgvattnet" "lеgvatten" "lеgvattnen" ;
  laagvattenmaerke_nn_1 = mkN "lеgvattenmдrke" ;
  laagvuxen_av_1 = mkA "lеgvuxen" "lеgvuxet" ;
  laan_nn_1 = mkN "lеn" neutrum ;
  laaneansoekning_nn_1 = mkN "lеneansцkning" ;
  laanebibliotek_nn_1 = mkN "lеnebibliotek" neutrum ;
  laaneexpedition_nn_1 = mkN "lеneexpedition" "lеneexpeditioner" ;
  laaneform_nn_1 = mkN "lеneform" "lеneformer" ;
  laanegaranti_nn_1 = mkN "lеnegaranti" "lеnegarantier" ;
  laanekoep_nn_1 = mkN "lеnekцp" neutrum ;
  laanekontor_nn_1 = mkN "lеnekontor" neutrum ;
  laanekort_nn_1 = mkN "lеnekort" neutrum ;
  laanetak_nn_1 = mkN "lеnetak" neutrum ;
  laanfaangen_av_1 = mkA "lеnfеngen" "lеnfеnget" ;
  laang_av_1 = mkA "lеng" "lдngre" "lдngst" ;
  laangbaenk_nn_1 = mkN "lеngbдnk" ;
  laangbent_av_1 = mkA "lеngbent" "lеngbent" ;
  laangboll_nn_1 = mkN "lеngboll" ;
  laangbord_nn_1 = mkN "lеngbord" neutrum ;
  laangdans_nn_1 = mkN "lеngdans" "lеngdanser" ;
  laangdistans_nn_1 = mkN "lеngdistans" "lеngdistanser" ;
  laangdistansloepning_nn_1 = mkN "lеngdistanslцpning" ;
  laangdistansraket_nn_1 = mkN "lеngdistansraket" "lеngdistansraketer" ;
  laangdragen_av_1 = mkA "lеngdragen" "lеngdraget" ;
  laangduk_nn_1 = mkN "lеngduk" ;
  laangeman_nn_1 = mkN "lеngeman" "lеngemannen" "lеngemдn" "lеngemдnnen" ;
  laangfaerd_nn_1 = mkN "lеngfдrd" "lеngfдrder" ;
  laangfarare_nn_1 = mkN "lеngfarare" "lеngfarare" ;
  laangfilm_nn_1 = mkN "lеngfilm" "lеngfilmer" ;
  laangfinger_nn_1 = mkN "lеngfinger" ;
  laangfranska_nn_1 = mkN "lеngfranska" ;
  laangfredag_nn_1 = mkN "lеngfredag" ;
  laangfristig_av_1 = mkA "lеngfristig" ;
  laanggardin_nn_1 = mkN "lеnggardin" "lеnggardiner" ;
  laanggrogg_nn_1 = mkN "lеnggrogg" ;
  laanggrund_av_1 = mkA "lеnggrund" ;
  laanghaarig_av_1 = mkA "lеnghеrig" ;
  laanghelg_nn_1 = mkN "lеnghelg" "lеnghelger" ;
  laanghus_nn_1 = mkN "lеnghus" neutrum ;
  laangivande_av_1 = mkA "lеngivande" ;
  laangivare_nn_1 = mkN "lеngivare" "lеngivare" ;
  laangkoerare_nn_1 = mkN "lеngkцrare" "lеngkцrare" ;
  laangkok_nn_1 = mkN "lеngkok" neutrum ;
  laangledig_av_1 = mkA "lеngledig" ;
  laanglig_av_1 = mkA "lеnglig" ;
  laangliggare_nn_1 = mkN "lеngliggare" "lеngliggare" ;
  laanglopp_nn_1 = mkN "lеnglopp" neutrum ;
  laanglotsning_nn_1 = mkN "lеnglotsning" ;
  laangmodig_av_1 = mkA "lеngmodig" ;
  laangnaebb_nn_1 = mkN "lеngnдbb" ;
  laangnaest_av_1 = mkA "lеngnдst" "lеngnдst" ;
  laangperiodisk_av_1 = mkA "lеngperiodisk" ;
  laangpromenad_nn_1 = mkN "lеngpromenad" "lеngpromenader" ;
  laangrandig_av_1 = mkA "lеngrandig" ;
  laangrev_nn_1 = mkN "lеngrev" ;
  laangsalning_nn_1 = mkN "lеngsalning" ;
  laangsam_av_1 = mkA "lеngsam" "lеngsamt" "lеngsamma" "lеngsamma" "lеngsammare" "lеngsammast" "lеngsammaste" ;
  laangschal_nn_1 = mkN "lеngschal" ;
  laangsida_nn_1 = mkN "lеngsida" ;
  laangsides_ab_1 = mkAdv "lеngsides" ;
  laangsiktig_av_1 = mkA "lеngsiktig" ;
  laangsint_av_1 = mkA "lеngsint" "lеngsint" ;
  laangsjal_nn_1 = mkN "lеngsjal" ;
  laangskallig_av_1 = mkA "lеngskallig" ;
  laangskepp_nn_1 = mkN "lеngskepp" neutrum ;
  laangskepps_ab_1 = mkAdv "lеngskepps" ;
  laangskott_nn_1 = mkN "lеngskott" neutrum ;
  laangsmal_av_1 = mkA "lеngsmal" ;
  laangsoekt_av_1 = mkA "lеngsцkt" "lеngsцkt" ;
  laangspant_nn_1 = mkN "lеngspant" neutrum ;
  laangspel_nn_1 = mkN "lеngspel" "lеngspelet" "lеngspel" "lеngspelen" ;
  laangstraeckt_av_1 = mkA "lеngstrдckt" "lеngstrдckt" ;
  laangsynt_av_1 = mkA "lеngsynt" "lеngsynt" ;
  laangsynthet_nn_1 = mkN "lеngsynthet" "lеngsyntheter" ;
  laangtgaaende_av_1 = mkA "lеngtgеende" ;
  laangtidsparkering_nn_1 = mkN "lеngtidsparkering" ;
  laangtidsprognos_nn_1 = mkN "lеngtidsprognos" "lеngtidsprognoser" ;
  laangtidsvikariat_nn_1 = mkN "lеngtidsvikariat" neutrum ;
  laangtifraan_ab_1 = mkAdv "lеngtifrеn" ;
  laangtraadig_av_1 = mkA "lеngtrеdig" ;
  laangtraakig_av_1 = mkA "lеngtrеkig" ;
  laangtradare_nn_1 = mkN "lеngtradare" "lеngtradare" ;
  laangtradig_av_1 = mkA "lеngtradig" ;
  laangtur_nn_1 = mkN "lеngtur" "lеngturer" ;
  laangvaagig_av_1 = mkA "lеngvеgig" ;
  laangvaega_av_1 = mkA "lеngvдga" ;
  laangvarig_av_1 = mkA "lеngvarig" ;
  laanord_nn_1 = mkN "lеnord" neutrum ;
  laantagare_nn_1 = mkN "lеntagare" "lеntagare" ;
  laar_nn_1 = mkN "lеr" neutrum ;
  laar_nn_2 = mkN "lеr" ;
  laarben_nn_1 = mkN "lеrben" neutrum ;
  laarbensbrott_nn_1 = mkN "lеrbensbrott" neutrum ;
  laarbenshals_nn_1 = mkN "lеrbenshals" ;
  laarding_nn_1 = mkN "lеrding" ;
  laaring_nn_1 = mkN "lеring" ;
  laaringsvind_nn_1 = mkN "lеringsvind" ;
  laas_nn_1 = mkN "lеs" ;
  laaskolv_nn_1 = mkN "lеskolv" ;
  laasmutter_nn_1 = mkN "lеsmutter" ;
  laasning_nn_1 = mkN "lеsning" ;
  laassmed_nn_1 = mkN "lеssmed" "lеssmeder" ;
  laassprint_nn_1 = mkN "lеssprint" ;
  laasvred_nn_1 = mkN "lеsvred" neutrum ;
  laat_nn_1 = mkN "lеt" ;
  laatgaasystem_nn_1 = mkN "lеtgеsystem" neutrum ;
  laatsaslek_nn_1 = mkN "lеtsaslek" ;
  laatsasvaerld_nn_1 = mkN "lеtsasvдrld" ;
  labb_nn_1 = mkN "labb" ;
  labb_nn_2 = mkN "labb" neutrum ;
  labbe_nn_1 = mkN "labbe" utrum ;
  laber_av_1 = mkA "laber" "labert" "labra" "labra" "labrare" "labrast" "labraste" ;
  labial_av_1 = mkA "labial" ;
  labial_nn_1 = mkN "labial" "labialer" ;
  labialstaemma_nn_1 = mkN "labialstдmma" ;
  labil_av_1 = mkA "labil" ;
  labilitet_nn_1 = mkN "labilitet" "labiliteter" ;
  labiodental_av_1 = mkA "labiodental" ;
  labiodental_nn_1 = mkN "labiodental" "labiodentaler" ;
  laborant_nn_1 = mkN "laborant" "laboranter" ;
  laboration_nn_1 = mkN "laboration" "laborationer" ;
  laborativ_av_1 = mkA "laborativ" ;
  laborator_nn_1 = mkN "laborator" "laboratorer" ;
  laboratorieassistent_nn_1 = mkN "laboratorieassistent" "laboratorieassistenter" ;
  laboratorieexperiment_nn_1 = mkN "laboratorieexperiment" neutrum ;
  laboratorieresultat_nn_1 = mkN "laboratorieresultat" neutrum ;
  laboratorierock_nn_1 = mkN "laboratorierock" ;
  laboratorium_nn_1 = mkN "laboratorium" "laboratoriet" "laboratorier" "laboratorierna" ;
  labourregering_nn_1 = mkN "labourregering" ;
  labrador_nn_1 = mkN "labrador" "labradoren" "labradorer" "labradorerna" ;
  labyrint_nn_1 = mkN "labyrint" "labyrinter" ;
  labyrintisk_av_1 = mkA "labyrintisk" ;
  lack_nn_1 = mkN "lack" neutrum ;
  lackering_nn_1 = mkN "lackering" ;
  lackfaerg_nn_1 = mkN "lackfдrg" "lackfдrger" ;
  lacksko_nn_1 = mkN "lacksko" "lackskor" ;
  lackskoeldlus_nn_1 = mkN "lackskцldlus" "lackskцldlusen" "lackskцldlцss" "lackskцldlцssen" ;
  lackviol_nn_1 = mkN "lackviol" "lackvioler" ;
  lad_nn_1 = mkN "lad" neutrum ;
  laddning_nn_1 = mkN "laddning" ;
  laddram_nn_1 = mkN "laddram" ;
  laddstock_nn_1 = mkN "laddstock" ;
  ladugaard_nn_1 = mkN "ladugеrd" ;
  lady_nn_1 = mkN "lady" "ladyn" "ladies" "ladies" ;
  laeck_av_1 = mkA "lдck" ;
  laeckage_nn_1 = mkN "lдckage" "lдckaget" "lдckage" "lдckagen" ;
  laeckageproblem_nn_1 = mkN "lдckageproblem" neutrum ;
  laecker_av_1 = mkA "lдcker" "lдckert" "lдckra" "lдckra" "lдckrare" "lдckrast" "lдckraste" ;
  laeckerbit_nn_1 = mkN "lдckerbit" ;
  laeckergom_nn_1 = mkN "lдckergom" "lдckergommen" "lдckergommar" "lдckergommarna" ;
  laeckerhet_nn_1 = mkN "lдckerhet" "lдckerheter" ;
  laederlapp_nn_1 = mkN "lдderlapp" ;
  laege_nn_1 = mkN "lдge" ;
  laegel_nn_1 = mkN "lдgel" ;
  laegenhet_nn_1 = mkN "lдgenhet" "lдgenheter" ;
  laegenhetsbyte_nn_1 = mkN "lдgenhetsbyte" ;
  laegenhetshotell_nn_1 = mkN "lдgenhetshotell" neutrum ;
  laeger_ab_1 = mkAdv "lдger" ;
  laeger_nn_1 = mkN "lдger" neutrum ;
  laegerbaal_nn_1 = mkN "lдgerbеl" neutrum ;
  laegereld_nn_1 = mkN "lдgereld" ;
  laegesbestaemning_nn_1 = mkN "lдgesbestдmning" ;
  laegesfoeraendring_nn_1 = mkN "lдgesfцrдndring" ;
  laegesrapport_nn_1 = mkN "lдgesrapport" "lдgesrapporter" ;
  laegessinne_nn_1 = mkN "lдgessinne" ;
  laegg_nn_1 = mkN "lдgg" neutrum ;
  laegg_nn_2 = mkN "lдgg" ;
  laeggdags_ab_1 = mkAdv "lдggdags" ;
  laeggning_nn_1 = mkN "lдggning" ;
  laeggspel_nn_1 = mkN "lдggspel" "lдggspelet" "lдggspel" "lдggspelen" ;
  laeglig_av_1 = mkA "lдglig" ;
  laekarbok_nn_1 = mkN "lдkarbok" "lдkarbцcker" ;
  laekarcentral_nn_1 = mkN "lдkarcentral" "lдkarcentraler" ;
  laekare_nn_1 = mkN "lдkare" "lдkare" ;
  laekarhjaelp_nn_1 = mkN "lдkarhjдlp" ;
  laekarhus_nn_1 = mkN "lдkarhus" neutrum ;
  laekarintyg_nn_1 = mkN "lдkarintyg" neutrum ;
  laekarmottagning_nn_1 = mkN "lдkarmottagning" ;
  laekarordination_nn_1 = mkN "lдkarordination" "lдkarordinationer" ;
  laekarrecept_nn_1 = mkN "lдkarrecept" neutrum ;
  laekarrock_nn_1 = mkN "lдkarrock" ;
  laekarsekreterare_nn_1 = mkN "lдkarsekreterare" "lдkarsekreterare" ;
  laekarundersoekning_nn_1 = mkN "lдkarundersцkning" ;
  laekedom_nn_1 = mkN "lдkedom" ;
  laekemedel_nn_1 = mkN "lдkemedel" neutrum ;
  laekemedelskontroll_nn_1 = mkN "lдkemedelskontroll" "lдkemedelskontroller" ;
  laekemedelslag_nn_1 = mkN "lдkemedelslag" ;
  laekevaext_nn_1 = mkN "lдkevдxt" "lдkevдxter" ;
  laekt_nn_1 = mkN "lдkt" "lдkter" ;
  laektare_nn_1 = mkN "lдktare" "lдktare" ;
  laem_nn_1 = mkN "lдm" "lдmmen" "lдmmar" "lдmmarna" ;
  laemmel_nn_1 = mkN "lдmmel" "lдmmeln" "lдmmlar" "lдmmlarna" ;
  laemmelaar_nn_1 = mkN "lдmmelеr" neutrum ;
  laemmeltaag_nn_1 = mkN "lдmmeltеg" neutrum ;
  laemning_nn_1 = mkN "lдmning" ;
  laempare_nn_1 = mkN "lдmpare" "lдmpare" ;
  laemplig_av_1 = mkA "lдmplig" ;
  laempligen_ab_1 = mkAdv "lдmpligen" ;
  laemplighet_nn_1 = mkN "lдmplighet" "lдmpligheter" ;
  laemplighetsintyg_nn_1 = mkN "lдmplighetsintyg" neutrum ;
  laen_nn_1 = mkN "lдn" neutrum ;
  laend_nn_1 = mkN "lдnd" "lдnder" ;
  laenderval_nn_1 = mkN "lдnderval" neutrum ;
  laengd_nn_1 = mkN "lдngd" "lдngder" ;
  laengdaxel_nn_1 = mkN "lдngdaxel" ;
  laengdenhet_nn_1 = mkN "lдngdenhet" "lдngdenheter" ;
  laengdgrad_nn_1 = mkN "lдngdgrad" "lдngdgrader" ;
  laengdhopp_nn_1 = mkN "lдngdhopp" neutrum ;
  laengdhoppare_nn_1 = mkN "lдngdhoppare" "lдngdhoppare" ;
  laengdloepning_nn_1 = mkN "lдngdlцpning" ;
  laengdmaatt_nn_1 = mkN "lдngdmеtt" neutrum ;
  laengdmarkering_nn_1 = mkN "lдngdmarkering" ;
  laengdmeter_nn_1 = mkN "lдngdmeter" "lдngdmetern" "lдngdmeter" "lдngdmeterna" ;
  laengdprofil_nn_1 = mkN "lдngdprofil" "lдngdprofiler" ;
  laengdriktning_nn_1 = mkN "lдngdriktning" ;
  laengdsnitt_nn_1 = mkN "lдngdsnitt" neutrum ;
  laengdstreck_nn_1 = mkN "lдngdstreck" neutrum ;
  laengdtecken_nn_1 = mkN "lдngdtecken" "lдngdtecknet" "lдngdtecken" "lдngdtecknen" ;
  laengdutvidgning_nn_1 = mkN "lдngdutvidgning" ;
  laenge_ab_1 = mkAdv "lдnge" ;
  laengesedan_ab_1 = mkAdv "lдngesedan" ;
  laengs_ab_1 = mkAdv "lдngs" ;
  laengsdal_nn_1 = mkN "lдngsdal" ;
  laengsgaaende_av_1 = mkA "lдngsgеende" ;
  laengstfoerfluten_av_1 = mkA "lдngstfцrfluten" "lдngstfцrflutet" ;
  laengtansfull_av_1 = mkA "lдngtansfull" ;
  laenk_nn_1 = mkN "lдnk" ;
  laenkroerelse_nn_1 = mkN "lдnkrцrelse" "lдnkrцrelser" ;
  laenkstation_nn_1 = mkN "lдnkstation" "lдnkstationer" ;
  laens_av_1 = mkA "lдns" ;
  laens_nn_1 = mkN "lдns" ;
  laensaaklagare_nn_1 = mkN "lдnsеklagare" "lдnsеklagare" ;
  laensarbetsdirektoer_nn_1 = mkN "lдnsarbetsdirektцr" "lдnsarbetsdirektцrer" ;
  laensarbetsnaemnd_nn_1 = mkN "lдnsarbetsnдmnd" "lдnsarbetsnдmnder" ;
  laensarkitekt_nn_1 = mkN "lдnsarkitekt" "lдnsarkitekter" ;
  laensbeteckning_nn_1 = mkN "lдnsbeteckning" ;
  laensbokstav_nn_1 = mkN "lдnsbokstav" "lдnsbokstдver" ;
  laensherre_nn_1 = mkN "lдnsherre" utrum ;
  laenskod_nn_1 = mkN "lдnskod" "lдnskoder" ;
  laenslasarett_nn_1 = mkN "lдnslasarett" neutrum ;
  laensman_nn_1 = mkN "lдnsman" "lдnsmannen" "lдnsmдn" "lдnsmдnnen" ;
  laenspump_nn_1 = mkN "lдnspump" ;
  laensraad_nn_1 = mkN "lдnsrеd" neutrum ;
  laensraett_nn_1 = mkN "lдnsrдtt" "lдnsrдtter" ;
  laensresidens_nn_1 = mkN "lдnsresidens" neutrum ;
  laensskatteraett_nn_1 = mkN "lдnsskatterдtt" "lдnsskatterдtter" ;
  laensskolnaemnd_nn_1 = mkN "lдnsskolnдmnd" "lдnsskolnдmnder" ;
  laensstyrelse_nn_1 = mkN "lдnsstyrelse" "lдnsstyrelser" ;
  laenstol_nn_1 = mkN "lдnstol" ;
  laensvaeg_nn_1 = mkN "lдnsvдg" ;
  laensvis_ab_1 = mkAdv "lдnsvis" ;
  laentagare_nn_1 = mkN "lдntagare" "lдntagare" ;
  laepp_nn_1 = mkN "lдpp" ;
  laeppljud_nn_1 = mkN "lдppljud" neutrum ;
  laepproerelse_nn_1 = mkN "lдpprцrelse" "lдpprцrelser" ;
  laeppsmink_nn_1 = mkN "lдppsmink" "lдppsminket" "lдppsminker" "lдppsminkerna" ;
  laeppsnus_nn_1 = mkN "lдppsnus" "lдppsnuset" "lдppsnuser" "lдppsnuserna" ;
  laeppstift_nn_1 = mkN "lдppstift" neutrum ;
  laera_nn_1 = mkN "lдra" ;
  laeraktig_av_1 = mkA "lдraktig" ;
  laerare_nn_1 = mkN "lдrare" "lдrare" ;
  laerarfortbildning_nn_1 = mkN "lдrarfortbildning" ;
  laerarinna_nn_1 = mkN "lдrarinna" ;
  laerarkandidat_nn_1 = mkN "lдrarkandidat" "lдrarkandidater" ;
  laerarledd_av_1 = mkA "lдrarledd" ;
  laerarlinje_nn_1 = mkN "lдrarlinje" "lдrarlinjer" ;
  laerarloes_av_1 = mkA "lдrarlцs" ;
  laerarroll_nn_1 = mkN "lдrarroll" "lдrarroller" ;
  laerarrum_nn_1 = mkN "lдrarrum" "lдrarrummet" "lдrarrum" "lдrarrummen" ;
  laerd_av_1 = mkA "lдrd" "lдrt" ;
  laerdom_nn_1 = mkN "lдrdom" ;
  laerdomsprov_nn_1 = mkN "lдrdomsprov" neutrum ;
  laerdomsstad_nn_1 = mkN "lдrdomsstad" "lдrdomsstдder" ;
  laerft_nn_1 = mkN "lдrft" "lдrfter" ;
  laerjunge_nn_1 = mkN "lдrjunge" utrum ;
  laerk_nn_1 = mkN "lдrk" ;
  laerkfalk_nn_1 = mkN "lдrkfalk" ;
  laerktraed_nn_1 = mkN "lдrktrдd" neutrum ;
  laerkvinge_nn_1 = mkN "lдrkvinge" utrum ;
  laerling_nn_1 = mkN "lдrling" ;
  laeroaar_nn_1 = mkN "lдroеr" neutrum ;
  laeroaemne_nn_1 = mkN "lдroдmne" ;
  laeroanstalt_nn_1 = mkN "lдroanstalt" "lдroanstalter" ;
  laerobok_nn_1 = mkN "lдrobok" "lдrobцcker" ;
  laeroboksnaemnd_nn_1 = mkN "lдroboksnдmnd" "lдroboksnдmnder" ;
  laerobokssats_nn_1 = mkN "lдrobokssats" "lдrobokssatser" ;
  laerobyggnad_nn_1 = mkN "lдrobyggnad" "lдrobyggnader" ;
  laerodikt_nn_1 = mkN "lдrodikt" "lдrodikter" ;
  laerofader_nn_1 = mkN "lдrofader" "lдrofadern" "lдrofдder" "lдrofдderna" ;
  laeromaestare_nn_1 = mkN "lдromдstare" "lдromдstare" ;
  laeromedel_nn_1 = mkN "lдromedel" neutrum ;
  laeromedelspaket_nn_1 = mkN "lдromedelspaket" neutrum ;
  laeroplan_nn_1 = mkN "lдroplan" "lдroplaner" ;
  laerorik_av_1 = mkA "lдrorik" ;
  laerosaete_nn_1 = mkN "lдrosдte" ;
  laerosal_nn_1 = mkN "lдrosal" ;
  laerosats_nn_1 = mkN "lдrosats" "lдrosatser" ;
  laerospaan_nn_1 = mkN "lдrospеn" neutrum ;
  laerostol_nn_1 = mkN "lдrostol" ;
  laeroverk_nn_1 = mkN "lдroverk" neutrum ;
  laerpeng_nn_1 = mkN "lдrpeng" ;
  laesaar_nn_1 = mkN "lдsеr" neutrum ;
  laesaemne_nn_1 = mkN "lдsдmne" ;
  laesapparat_nn_1 = mkN "lдsapparat" "lдsapparater" ;
  laesare_nn_1 = mkN "lдsare" "lдsare" ;
  laesart_nn_1 = mkN "lдsart" "lдsarter" ;
  laesbar_av_1 = mkA "lдsbar" ;
  laesbarhet_nn_1 = mkN "lдsbarhet" "lдsbarheter" ;
  laesbarhetsindex_nn_1 = mkN "lдsbarhetsindex" neutrum ;
  laesbarn_nn_1 = mkN "lдsbarn" neutrum ;
  laesbegaavning_nn_1 = mkN "lдsbegеvning" ;
  laesdag_nn_1 = mkN "lдsdag" ;
  laesdrama_nn_1 = mkN "lдsdrama" "lдsdramat" "lдsdraman" "lдsdramana" ;
  laesebok_nn_1 = mkN "lдsebok" "lдsebцcker" ;
  laesecirkel_nn_1 = mkN "lдsecirkel" ;
  laesekrets_nn_1 = mkN "lдsekrets" ;
  laesesal_nn_1 = mkN "lдsesal" ;
  laesfaerdighet_nn_1 = mkN "lдsfдrdighet" "lдsfдrdigheter" ;
  laesglas_nn_1 = mkN "lдsglas" neutrum ;
  laeshuvud_nn_1 = mkN "lдshuvud" "lдshuvudet" "lдshuvuden" "lдshuvudena" ;
  laesida_nn_1 = mkN "lдsida" ;
  laesion_nn_1 = mkN "lдsion" "lдsioner" ;
  laesk_nn_1 = mkN "lдsk" "lдsken" "lдsk" "lдsken" ;
  laeskamrat_nn_1 = mkN "lдskamrat" "lдskamrater" ;
  laeskedryck_nn_1 = mkN "lдskedryck" "lдskedrycker" ;
  laeskig_av_1 = mkA "lдskig" ;
  laesklass_nn_1 = mkN "lдsklass" "lдsklasser" ;
  laesklinik_nn_1 = mkN "lдsklinik" "lдskliniker" ;
  laeskpapper_nn_1 = mkN "lдskpapper" neutrum ;
  laeskstaang_nn_1 = mkN "lдskstеng" "lдskstдnger" ;
  laeskunnig_av_1 = mkA "lдskunnig" ;
  laeskunnighet_nn_1 = mkN "lдskunnighet" "lдskunnigheter" ;
  laeslig_av_1 = mkA "lдslig" ;
  laesning_nn_1 = mkN "lдsning" ;
  laespljud_nn_1 = mkN "lдspljud" neutrum ;
  laespraest_nn_1 = mkN "lдsprдst" "lдsprдster" ;
  laesrum_nn_1 = mkN "lдsrum" "lдsrummet" "lдsrum" "lдsrummen" ;
  laessvaarighet_nn_1 = mkN "lдssvеrighet" "lдssvеrigheter" ;
  laessvag_av_1 = mkA "lдssvag" ;
  laest_nn_1 = mkN "lдst" "lдster" ;
  laestadian_nn_1 = mkN "lдstadian" "lдstadianer" ;
  laestadianism_nn_1 = mkN "lдstadianism" "lдstadianismer" ;
  laestblock_nn_1 = mkN "lдstblock" neutrum ;
  laesuttal_nn_1 = mkN "lдsuttal" "lдsuttalet" "lдsuttalen" "lдsuttalena" ;
  laesvaerd_av_1 = mkA "lдsvдrd" "lдsvдrt" ;
  laesvaerde_nn_1 = mkN "lдsvдrde" ;
  laete_nn_1 = mkN "lдte" ;
  laett_av_1 = mkA "lдtt" ;
  laettantaendlig_av_1 = mkA "lдttantдndlig" ;
  laettbegriplig_av_1 = mkA "lдttbegriplig" ;
  laetteligen_ab_1 = mkAdv "lдtteligen" ;
  laettfaangen_av_1 = mkA "lдttfеngen" "lдttfеnget" ;
  laettfaerdig_av_1 = mkA "lдttfдrdig" ;
  laettfattlig_av_1 = mkA "lдttfattlig" ;
  laettflyktig_av_1 = mkA "lдttflyktig" ;
  laettflytande_av_1 = mkA "lдttflytande" ;
  laettfoerklarlig_av_1 = mkA "lдttfцrklarlig" ;
  laettfoerstaaelig_av_1 = mkA "lдttfцrstеelig" ;
  laettfoertjaent_av_1 = mkA "lдttfцrtjдnt" "lдttfцrtjдnt" ;
  laettframkomlig_av_1 = mkA "lдttframkomlig" ;
  laettfunnen_av_1 = mkA "lдttfunnen" "lдttfunnet" "lдttfunna" "lдttfunna" "lдttfunnare" "lдttfunnast" "lдttfunnaste" ;
  laettgrogg_nn_1 = mkN "lдttgrogg" ;
  laetthanterlig_av_1 = mkA "lдtthanterlig" ;
  laetthet_nn_1 = mkN "lдtthet" "lдttheter" ;
  laettillgaenglig_av_1 = mkA "lдttillgдnglig" ;
  laetting_nn_1 = mkN "lдtting" ;
  laettjefull_av_1 = mkA "lдttjefull" ;
  laettjord_nn_1 = mkN "lдttjord" ;
  laettklaedd_av_1 = mkA "lдttklдdd" "lдttklдdtt" ;
  laettkloev_nn_1 = mkN "lдttklцv" ;
  laettkoept_av_1 = mkA "lдttkцpt" "lдttkцpt" ;
  laettkokt_av_1 = mkA "lдttkokt" "lдttkokt" ;
  laettlaest_av_1 = mkA "lдttlдst" "lдttlдst" ;
  laettledd_av_1 = mkA "lдttledd" ;
  laettloeslig_av_1 = mkA "lдttlцslig" ;
  laettloest_av_1 = mkA "lдttlцst" "lдttlцst" ;
  laettmargarin_nn_1 = mkN "lдttmargarin" "lдttmargarinet" "lдttmargariner" "lдttmargarinerna" ;
  laettmatros_nn_1 = mkN "lдttmatros" "lдttmatroser" ;
  laettmetall_nn_1 = mkN "lдttmetall" "lдttmetaller" ;
  laettnad_nn_1 = mkN "lдttnad" "lдttnader" ;
  laettoel_nn_1 = mkN "lдttцl" neutrum ;
  laettoeverskaadlig_av_1 = mkA "lдttцverskеdlig" ;
  laettretlig_av_1 = mkA "lдttretlig" ;
  laettroekt_av_1 = mkA "lдttrцkt" "lдttrцkt" ;
  laettroerd_av_1 = mkA "lдttrцrd" "lдttrцrt" ;
  laettroerlig_av_1 = mkA "lдttrцrlig" ;
  laettrogen_av_1 = mkA "lдttrogen" "lдttroget" ;
  laettsam_av_1 = mkA "lдttsam" "lдttsamt" "lдttsamma" "lдttsamma" "lдttsammare" "lдttsammast" "lдttsammaste" ;
  laettsinnig_av_1 = mkA "lдttsinnig" ;
  laettskoett_av_1 = mkA "lдttskцtt" ;
  laettskraemd_av_1 = mkA "lдttskrдmd" "lдttskrдmt" ;
  laettsmaelt_av_1 = mkA "lдttsmдlt" "lдttsmдlt" ;
  laettstekt_av_1 = mkA "lдttstekt" "lдttstekt" ;
  laettstoett_av_1 = mkA "lдttstцtt" ;
  laettvattenreaktor_nn_1 = mkN "lдttvattenreaktor" "lдttvattenreaktorer" ;
  laettviktare_nn_1 = mkN "lдttviktare" "lдttviktare" ;
  laettviktig_av_1 = mkA "lдttviktig" ;
  laettviktsmotorcykel_nn_1 = mkN "lдttviktsmotorcykel" ;
  laettvin_nn_1 = mkN "lдttvin" "lдttvinet" "lдttviner" "lдttvinerna" ;
  laettvindig_av_1 = mkA "lдttvindig" ;
  laettvunnen_av_1 = mkA "lдttvunnen" "lдttvunnet" "lдttvunna" "lдttvunna" "lдttvunnare" "lдttvunnast" "lдttvunnaste" ;
  laexfoerhoer_nn_1 = mkN "lдxfцrhцr" neutrum ;
  lafsig_av_1 = mkA "lafsig" ;
  lag_nn_1 = mkN "lag" ;
  lag_nn_2 = mkN "lag" neutrum ;
  laga_av_1 = mkA "laga" ;
  lagaard_nn_1 = mkN "lagеrd" ;
  lagbalk_nn_1 = mkN "lagbalk" ;
  lagberedning_nn_1 = mkN "lagberedning" ;
  lagbok_nn_1 = mkN "lagbok" "lagbцcker" ;
  lagbunden_av_1 = mkA "lagbunden" "lagbundet" ;
  lagd_av_1 = mkA "lagd" "lagt" ;
  lagenlig_av_1 = mkA "lagenlig" ;
  lager_nn_1 = mkN "lager" neutrum ;
  lager_nn_2 = mkN "lager" ;
  lager_nn_3 = mkN "lager" "lagern" "lager" "lagerna" ;
  lagerbaersblad_nn_1 = mkN "lagerbдrsblad" neutrum ;
  lagerblad_nn_1 = mkN "lagerblad" neutrum ;
  lagerbok_nn_1 = mkN "lagerbok" "lagerbцcker" ;
  lagerbox_nn_1 = mkN "lagerbox" ;
  lagerfoeljd_nn_1 = mkN "lagerfцljd" "lagerfцljder" ;
  lagergaang_nn_1 = mkN "lagergеng" ;
  lagerkostnad_nn_1 = mkN "lagerkostnad" "lagerkostnader" ;
  lagerkrans_nn_1 = mkN "lagerkrans" ;
  lageroel_nn_1 = mkN "lagerцl" neutrum ;
  lagerserie_nn_1 = mkN "lagerserie" "lagerserier" ;
  lagfaangen_av_1 = mkA "lagfеngen" "lagfеnget" ;
  lagfara_vb_1 = mkV "lagfara" "lagfor" "lagfarit" ;
  lagfaren_av_1 = mkA "lagfaren" "lagfaret" ;
  lagfart_nn_1 = mkN "lagfart" "lagfarter" ;
  lagfoerslag_nn_1 = mkN "lagfцrslag" neutrum ;
  lagg_nn_1 = mkN "lagg" ;
  laggband_nn_1 = mkN "laggband" neutrum ;
  laggdike_nn_1 = mkN "laggdike" ;
  laggkaerl_nn_1 = mkN "laggkдrl" neutrum ;
  lagisk_av_1 = mkA "lagisk" ;
  lagkapp_nn_1 = mkN "lagkapp" "lagkapper" ;
  lagkappsimning_nn_1 = mkN "lagkappsimning" ;
  lagkapten_nn_1 = mkN "lagkapten" "lagkaptener" ;
  lagkarl_nn_1 = mkN "lagkarl" ;
  lagklok_av_1 = mkA "lagklok" ;
  lagledare_nn_1 = mkN "lagledare" "lagledare" ;
  laglig_av_1 = mkA "laglig" ;
  lagligen_ab_1 = mkAdv "lagligen" ;
  lagloes_av_1 = mkA "laglцs" ;
  lagloeshet_nn_1 = mkN "laglцshet" "laglцsheter" ;
  laglott_nn_1 = mkN "laglott" "laglotter" ;
  laglydig_av_1 = mkA "laglydig" ;
  lagman_nn_1 = mkN "lagman" "lagmannen" "lagmдn" "lagmдnnen" ;
  lagn_nn_1 = mkN "lagn" neutrum ;
  lagom_ab_1 = mkAdv "lagom" ;
  lagom_av_1 = mkA "lagom" ;
  lagraad_nn_1 = mkN "lagrеd" neutrum ;
  lagring_nn_1 = mkN "lagring" ;
  lagringsfoerlust_nn_1 = mkN "lagringsfцrlust" "lagringsfцrluster" ;
  lagringskostnad_nn_1 = mkN "lagringskostnad" "lagringskostnader" ;
  lagrum_nn_1 = mkN "lagrum" "lagrummet" "lagrum" "lagrummen" ;
  lagsaga_nn_1 = mkN "lagsaga" ;
  lagskipning_nn_1 = mkN "lagskipning" ;
  lagspel_nn_1 = mkN "lagspel" "lagspelet" "lagspel" "lagspelen" ;
  lagspraak_nn_1 = mkN "lagsprеk" neutrum ;
  lagstiftare_nn_1 = mkN "lagstiftare" "lagstiftare" ;
  lagstiftning_nn_1 = mkN "lagstiftning" ;
  lagstridig_av_1 = mkA "lagstridig" ;
  lagtempo_nn_1 = mkN "lagtempo" "lagtempot" "lagtempon" "lagtempona" ;
  lagtempolopp_nn_1 = mkN "lagtempolopp" neutrum ;
  lagtext_nn_1 = mkN "lagtext" "lagtexter" ;
  lagtima_av_1 = mkA "lagtima" ;
  lagun_nn_1 = mkN "lagun" "laguner" ;
  lagunsjoe_nn_1 = mkN "lagunsjц" ;
  lagutskott_nn_1 = mkN "lagutskott" neutrum ;
  lagvigd_av_1 = mkA "lagvigd" "lagvigt" ;
  lagvraengare_nn_1 = mkN "lagvrдngare" "lagvrдngare" ;
  lagvunnen_av_1 = mkA "lagvunnen" "lagvunnet" "lagvunna" "lagvunna" "lagvunnare" "lagvunnast" "lagvunnaste" ;
  lakan_nn_1 = mkN "lakan" neutrum ;
  lakanspaase_nn_1 = mkN "lakanspеse" utrum ;
  lakansspets_nn_1 = mkN "lakansspets" ;
  lake_nn_1 = mkN "lake" utrum ;
  lakej_nn_1 = mkN "lakej" "lakejer" ;
  lakonisk_av_1 = mkA "lakonisk" ;
  lakonism_nn_1 = mkN "lakonism" "lakonismer" ;
  lakritsrot_nn_1 = mkN "lakritsrot" "lakritsrцtter" ;
  laktalbumin_nn_1 = mkN "laktalbumin" "laktalbuminer" ;
  laktation_nn_1 = mkN "laktation" "laktationer" ;
  laktovegetarian_nn_1 = mkN "laktovegetarian" "laktovegetarianer" ;
  lakun_nn_1 = mkN "lakun" "lakuner" ;
  lam_av_1 = mkA "lam" ;
  lama_nn_3 = mkN "lama" ;
  lamadjur_nn_1 = mkN "lamadjur" neutrum ;
  lame_nn_1 = mkN "lamй" "lamйer" ;
  lamell_nn_1 = mkN "lamell" "lameller" ;
  lamellhus_nn_1 = mkN "lamellhus" neutrum ;
  lamellkoppling_nn_1 = mkN "lamellkoppling" ;
  lamentation_nn_1 = mkN "lamentation" "lamentationer" ;
  laminaer_av_1 = mkA "laminдr" ;
  laminat_nn_1 = mkN "laminat" neutrum ;
  lamm_nn_1 = mkN "lamm" neutrum ;
  lammsadel_nn_1 = mkN "lammsadel" ;
  lammskinn_nn_1 = mkN "lammskinn" neutrum ;
  lammunge_nn_1 = mkN "lammunge" utrum ;
  lampett_nn_1 = mkN "lampett" "lampetter" ;
  lampfot_nn_1 = mkN "lampfot" "lampfцtter" ;
  lamphaallare_nn_1 = mkN "lamphеllare" "lamphеllare" ;
  lampskaerm_nn_1 = mkN "lampskдrm" ;
  lan_nn_1 = mkN "lan" "laner" ;
  land_nn_1 = mkN "land" "landet" "lдnder" "lдnderna" ;
  land_nn_2 = mkN "land" neutrum ;
  landaa_nn_1 = mkN "landе" "landеer" ;
  landamaere_nn_1 = mkN "landamдre" ;
  landbo_nn_1 = mkN "landbo" "landbor" ;
  landborg_nn_1 = mkN "landborg" ;
  landbris_nn_1 = mkN "landbris" ;
  landdriven_av_1 = mkA "landdriven" "landdrivet" ;
  landgaang_nn_1 = mkN "landgеng" ;
  landhoejning_nn_1 = mkN "landhцjning" ;
  landis_nn_1 = mkN "landis" ;
  landkaenning_nn_1 = mkN "landkдnning" ;
  landledes_ab_1 = mkAdv "landledes" ;
  landmaerke_nn_1 = mkN "landmдrke" ;
  landning_nn_1 = mkN "landning" ;
  landningsfoerbud_nn_1 = mkN "landningsfцrbud" neutrum ;
  landningshjul_nn_1 = mkN "landningshjul" neutrum ;
  landningsmaerke_nn_1 = mkN "landningsmдrke" ;
  landningsstaell_nn_1 = mkN "landningsstдll" neutrum ;
  landnot_nn_1 = mkN "landnot" ;
  landomraade_nn_1 = mkN "landomrеde" ;
  landrygg_nn_1 = mkN "landrygg" ;
  landsaenda_nn_1 = mkN "landsдnda" "landsдndan" "landsдndar" "landsдndarna" ;
  landsaettning_nn_1 = mkN "landsдttning" ;
  landsantikvarie_nn_1 = mkN "landsantikvarie" "landsantikvarier" ;
  landsarkiv_nn_1 = mkN "landsarkiv" neutrum ;
  landsarkivarie_nn_1 = mkN "landsarkivarie" "landsarkivarier" ;
  landsdel_nn_1 = mkN "landsdel" "landsdelen" "landsdelar" "landsdelarna" ;
  landsfader_nn_1 = mkN "landsfader" "landsfadern" "landsfдder" "landsfдderna" ;
  landsfiskal_nn_1 = mkN "landsfiskal" "landsfiskaler" ;
  landsflyktig_av_1 = mkA "landsflyktig" ;
  landsfoerraedare_nn_1 = mkN "landsfцrrдdare" "landsfцrrдdare" ;
  landsfoerraederi_nn_1 = mkN "landsfцrrдderi" "landsfцrrдderit" "landsfцrrдderier" "landsfцrrдderierna" ;
  landsfoervisning_nn_1 = mkN "landsfцrvisning" ;
  landsfogde_nn_1 = mkN "landsfogde" utrum ;
  landshoevding_nn_1 = mkN "landshцvding" ;
  landshoevdingehus_nn_1 = mkN "landshцvdingehus" neutrum ;
  landskamp_nn_1 = mkN "landskamp" "landskamper" ;
  landskansli_nn_1 = mkN "landskansli" "landskanslit" "landskanslier" "landskanslierna" ;
  landskap_nn_1 = mkN "landskap" "landskapet" "landskapen" "landskapena" ;
  landskapslag_nn_1 = mkN "landskapslag" ;
  landskapsvapen_nn_1 = mkN "landskapsvapen" "landskapsvapnet" "landskapsvapen" "landskapsvapnen" ;
  landsknekt_nn_1 = mkN "landsknekt" ;
  landskommun_nn_1 = mkN "landskommun" "landskommuner" ;
  landslag_nn_1 = mkN "landslag" neutrum ;
  landslag_nn_2 = mkN "landslag" ;
  landsmaal_nn_1 = mkN "landsmеl" neutrum ;
  landsmaalsalfabet_nn_1 = mkN "landsmеlsalfabet" neutrum ;
  landsman_nn_1 = mkN "landsman" "landsmannen" "landsmдn" "landsmдnnen" ;
  landsnummer_nn_1 = mkN "landsnummer" neutrum ;
  landsomfattande_av_1 = mkA "landsomfattande" ;
  landsortsstad_nn_1 = mkN "landsortsstad" "landsortsstдder" ;
  landsplaaga_nn_1 = mkN "landsplеga" ;
  landssekretariat_nn_1 = mkN "landssekretariat" neutrum ;
  landstiga_vb_1 = mkV "landstiga" "landsteg" "landstigit" ;
  landstigning_nn_1 = mkN "landstigning" ;
  landstigningsbaat_nn_1 = mkN "landstigningsbеt" ;
  landsting_nn_1 = mkN "landsting" neutrum ;
  landstingsdirektoer_nn_1 = mkN "landstingsdirektцr" "landstingsdirektцrer" ;
  landstingsfoerbund_nn_1 = mkN "landstingsfцrbund" neutrum ;
  landstingskatalog_nn_1 = mkN "landstingskatalog" "landstingskataloger" ;
  landstingskommun_nn_1 = mkN "landstingskommun" "landstingskommuner" ;
  landstingsman_nn_1 = mkN "landstingsman" "landstingsmannen" "landstingsmдn" "landstingsmдnnen" ;
  landstingsraad_nn_1 = mkN "landstingsrеd" neutrum ;
  landstrykare_nn_1 = mkN "landstrykare" "landstrykare" ;
  landsvaeg_nn_1 = mkN "landsvдg" ;
  landsvaegsbuss_nn_1 = mkN "landsvдgsbuss" ;
  landsvaegsriddare_nn_1 = mkN "landsvдgsriddare" "landsvдgsriddare" ;
  landtunga_nn_1 = mkN "landtunga" ;
  landvad_nn_1 = mkN "landvad" ;
  landvind_nn_1 = mkN "landvind" ;
  landvinning_nn_1 = mkN "landvinning" ;
  langare_nn_1 = mkN "langare" "langare" ;
  langarn_nn_1 = mkN "langarn" "langarnet" "langarner" "langarnerna" ;
  langett_nn_1 = mkN "langett" "langetter" ;
  langettstygn_nn_1 = mkN "langettstygn" neutrum ;
  langobard_nn_1 = mkN "langobard" "langobarder" ;
  langust_nn_1 = mkN "langust" "languster" ;
  lankes_nn_1 = mkN "lankes" "lankeser" ;
  lans_nn_1 = mkN "lans" ;
  lansett_nn_1 = mkN "lansett" "lansetter" ;
  lansettfisk_nn_1 = mkN "lansettfisk" ;
  lansiaer_nn_1 = mkN "lansiдr" "lansiдrer" ;
  lantarbetare_nn_1 = mkN "lantarbetare" "lantarbetare" ;
  lantbrevbaerare_nn_1 = mkN "lantbrevbдrare" "lantbrevbдrare" ;
  lantbruk_nn_1 = mkN "lantbruk" neutrum ;
  lantbrukare_nn_1 = mkN "lantbrukare" "lantbrukare" ;
  lantbruksdirektoer_nn_1 = mkN "lantbruksdirektцr" "lantbruksdirektцrer" ;
  lantbruksfoerbund_nn_1 = mkN "lantbruksfцrbund" neutrum ;
  lantbrukskonsulent_nn_1 = mkN "lantbrukskonsulent" "lantbrukskonsulenter" ;
  lantbruksnaemnd_nn_1 = mkN "lantbruksnдmnd" "lantbruksnдmnder" ;
  lantbruksstyrelse_nn_1 = mkN "lantbruksstyrelse" "lantbruksstyrelser" ;
  lantbruksuniversitet_nn_1 = mkN "lantbruksuniversitet" neutrum ;
  lantdag_nn_1 = mkN "lantdag" ;
  lantegendom_nn_1 = mkN "lantegendom" ;
  lanternin_nn_1 = mkN "lanternin" "lanterniner" ;
  lantgaard_nn_1 = mkN "lantgеrd" ;
  lantgreve_nn_1 = mkN "lantgreve" utrum ;
  lanthandel_nn_1 = mkN "lanthandel" ;
  lanthushaallning_nn_1 = mkN "lanthushеllning" ;
  lantis_nn_1 = mkN "lantis" ;
  lantjunkare_nn_1 = mkN "lantjunkare" "lantjunkare" ;
  lantlig_av_1 = mkA "lantlig" ;
  lantmaestare_nn_1 = mkN "lantmдstare" "lantmдstare" ;
  lantmaetare_nn_1 = mkN "lantmдtare" "lantmдtare" ;
  lantmaeteri_nn_1 = mkN "lantmдteri" "lantmдterit" "lantmдterier" "lantmдterierna" ;
  lantman_nn_1 = mkN "lantman" "lantmannen" "lantmдn" "lantmдnnen" ;
  lantmarskalk_nn_1 = mkN "lantmarskalk" ;
  lantras_nn_1 = mkN "lantras" "lantraser" ;
  lantrasgris_nn_1 = mkN "lantrasgris" ;
  lantvaern_nn_1 = mkN "lantvдrn" neutrum ;
  lantvin_nn_1 = mkN "lantvin" "lantvinet" "lantviner" "lantvinerna" ;
  laotier_nn_1 = mkN "laotier" "laotiern" "laotier" "laotierna" ;
  laotisk_av_1 = mkA "laotisk" ;
  lapidarisk_av_1 = mkA "lapidarisk" ;
  lapp_nn_1 = mkN "lapp" ;
  lapphund_nn_1 = mkN "lapphund" ;
  lappkast_nn_1 = mkN "lappkast" neutrum ;
  lapplaendsk_av_1 = mkA "lapplдndsk" ;
  lapplaenning_nn_1 = mkN "lapplдnning" ;
  lapplandsgran_nn_1 = mkN "lapplandsgran" ;
  lappskrivning_nn_1 = mkN "lappskrivning" ;
  lappsparv_nn_1 = mkN "lappsparv" ;
  lapptaecke_nn_1 = mkN "lapptдcke" ;
  lappverk_nn_1 = mkN "lappverk" neutrum ;
  lapsk_av_1 = mkA "lapsk" ;
  lapska_nn_2 = mkN "lapska" ;
  lapsus_nn_1 = mkN "lapsus" ;
  largetto_ab_1 = mkAdv "largetto" ;
  largetto_nn_1 = mkN "largetto" "largettot" "largetton" "largettona" ;
  largo_ab_1 = mkAdv "largo" ;
  largo_nn_1 = mkN "largo" "largot" "largon" "largona" ;
  larm_nn_1 = mkN "larm" neutrum ;
  larmfoerlaeggning_nn_1 = mkN "larmfцrlдggning" ;
  larmrapport_nn_1 = mkN "larmrapport" "larmrapporter" ;
  larv_nn_1 = mkN "larv" "larver" ;
  larvband_nn_1 = mkN "larvband" neutrum ;
  larver_nn_1 = mkN "larver" "larveren" "larverar" "larverarna" ;
  larvig_av_1 = mkA "larvig" ;
  larvtraktor_nn_1 = mkN "larvtraktor" "larvtraktorer" ;
  laryngal_av_1 = mkA "laryngal" ;
  laryngal_nn_1 = mkN "laryngal" "laryngaler" ;
  laryngit_nn_1 = mkN "laryngit" "laryngiter" ;
  laryngolog_nn_1 = mkN "laryngolog" "laryngologer" ;
  laryngoskop_nn_1 = mkN "laryngoskop" neutrum ;
  laryngoskopi_nn_1 = mkN "laryngoskopi" "laryngoskopier" ;
  lasarett_nn_1 = mkN "lasarett" neutrum ;
  lasaron_nn_1 = mkN "lasaron" "lasaroner" ;
  lasciv_av_1 = mkA "lasciv" ;
  laser_nn_1 = mkN "laser" ;
  laserfaerg_nn_1 = mkN "laserfдrg" "laserfдrger" ;
  laserkanon_nn_1 = mkN "laserkanon" "laserkanoner" ;
  laserstraalning_nn_1 = mkN "laserstrеlning" ;
  laserstyrd_av_1 = mkA "laserstyrd" "laserstyrt" ;
  laserteknik_nn_1 = mkN "laserteknik" "lasertekniker" ;
  lask_nn_1 = mkN "lask" ;
  laskning_nn_1 = mkN "laskning" ;
  lass_nn_1 = mkN "lass" neutrum ;
  lasso_nn_1 = mkN "lasso" "lassor" ;
  last_nn_1 = mkN "last" "laster" ;
  lastageplats_nn_1 = mkN "lastageplats" "lastageplatser" ;
  lastbar_av_1 = mkA "lastbar" ;
  lastbil_nn_1 = mkN "lastbil" ;
  lastbilstransport_nn_1 = mkN "lastbilstransport" "lastbilstransporter" ;
  lastdjur_nn_1 = mkN "lastdjur" neutrum ;
  lastdryg_av_1 = mkA "lastdryg" ;
  lastelig_av_1 = mkA "lastelig" ;
  lastfartyg_nn_1 = mkN "lastfartyg" neutrum ;
  lastflak_nn_1 = mkN "lastflak" neutrum ;
  lastfull_av_1 = mkA "lastfull" ;
  lastkran_nn_1 = mkN "lastkran" ;
  lastlinje_nn_1 = mkN "lastlinje" "lastlinjer" ;
  lastning_nn_1 = mkN "lastning" ;
  lastpall_nn_1 = mkN "lastpall" ;
  lastport_nn_1 = mkN "lastport" ;
  lastprofil_nn_1 = mkN "lastprofil" "lastprofiler" ;
  lastrum_nn_1 = mkN "lastrum" "lastrummet" "lastrum" "lastrummen" ;
  lastvattenlinje_nn_1 = mkN "lastvattenlinje" "lastvattenlinjer" ;
  lasur_nn_1 = mkN "lasur" "lasurer" ;
  lasyr_nn_1 = mkN "lasyr" "lasyrer" ;
  latenstid_nn_1 = mkN "latenstid" "latenstider" ;
  latent_av_1 = mkA "latent" "latent" ;
  lateral_av_1 = mkA "lateral" ;
  lateral_nn_1 = mkN "lateral" "lateraler" ;
  lathund_nn_1 = mkN "lathund" ;
  latin_amerikansk_av_1 = mkA "latin-amerikansk" ;
  latinamerikansk_av_1 = mkA "latinamerikansk" ;
  latinare_nn_1 = mkN "latinare" "latinare" ;
  latinism_nn_1 = mkN "latinism" "latinismer" ;
  latinlaeroverk_nn_1 = mkN "latinlдroverk" neutrum ;
  latinlinje_nn_1 = mkN "latinlinje" "latinlinjer" ;
  latinsegel_nn_1 = mkN "latinsegel" neutrum ;
  latinsk_av_1 = mkA "latinsk" ;
  latitud_nn_1 = mkN "latitud" "latituder" ;
  latmask_nn_1 = mkN "latmask" ;
  latrin_nn_1 = mkN "latrin" "latriner" ;
  laudatur_nn_1 = mkN "laudatur" neutrum ;
  lav_nn_1 = mkN "lav" ;
  lavasjoe_nn_1 = mkN "lavasjц" ;
  lave_nn_1 = mkN "lave" utrum ;
  lavemang_nn_1 = mkN "lavemang" neutrum ;
  lavendelblaa_av_1 = mkA "lavendelblе" "lavendelblеtt" ;
  lavering_nn_1 = mkN "lavering" ;
  lavett_nn_1 = mkN "lavett" "lavetter" ;
  lavin_nn_1 = mkN "lavin" "laviner" ;
  lavinhund_nn_1 = mkN "lavinhund" ;
  lavoar_nn_1 = mkN "lavoar" "lavoarer" ;
  lavregion_nn_1 = mkN "lavregion" "lavregioner" ;
  lavyr_nn_1 = mkN "lavyr" "lavyrer" ;
  lax_nn_1 = mkN "lax" ;
  laxativ_nn_1 = mkN "laxativ" neutrum ;
  laxermedel_nn_1 = mkN "laxermedel" neutrum ;
  laxfaerg_nn_1 = mkN "laxfдrg" "laxfдrger" ;
  laxfisk_nn_1 = mkN "laxfisk" ;
  laxgaard_nn_1 = mkN "laxgеrd" ;
  laxkar_nn_1 = mkN "laxkar" neutrum ;
  laxoering_nn_1 = mkN "laxцring" ;
  laxstjaert_nn_1 = mkN "laxstjдrt" ;
  laxyngel_nn_1 = mkN "laxyngel" neutrum ;
  layout_nn_1 = mkN "layout" "layouter" ;
  lazzaron_nn_1 = mkN "lazzaron" "lazzaroner" ;
  lealoes_av_1 = mkA "lealцs" ;
  leasing_nn_1 = mkN "leasing" ;
  lebeman_nn_1 = mkN "lebeman" "lebemannen" "lebemдn" "lebemдnnen" ;
  lecitin_nn_1 = mkN "lecitin" "lecitiner" ;
  led_av_1 = mkA "led" ;
  led_nn_1 = mkN "led" "leder" ;
  led_nn_2 = mkN "led" neutrum ;
  led_nn_3 = mkN "led" neutrum ;
  ledamot_nn_1 = mkN "ledamot" "ledamцter" ;
  ledarbegaavning_nn_1 = mkN "ledarbegеvning" ;
  ledare_nn_1 = mkN "ledare" "ledare" ;
  ledarhund_nn_1 = mkN "ledarhund" ;
  ledarkult_nn_1 = mkN "ledarkult" "ledarkulter" ;
  ledarskifte_nn_1 = mkN "ledarskifte" ;
  ledarskikt_nn_1 = mkN "ledarskikt" neutrum ;
  ledarskribent_nn_1 = mkN "ledarskribent" "ledarskribenter" ;
  ledarstick_nn_1 = mkN "ledarstick" neutrum ;
  ledband_nn_1 = mkN "ledband" neutrum ;
  ledbrosk_nn_1 = mkN "ledbrosk" neutrum ;
  ledbruten_av_1 = mkA "ledbruten" "ledbrutet" ;
  ledd_nn_1 = mkN "ledd" "ledder" ;
  leddjur_nn_1 = mkN "leddjur" neutrum ;
  ledfoerslitning_nn_1 = mkN "ledfцrslitning" ;
  ledfyr_nn_1 = mkN "ledfyr" ;
  ledhuvud_nn_1 = mkN "ledhuvud" "ledhuvudet" "ledhuvuden" "ledhuvudena" ;
  ledig_av_1 = mkA "ledig" ;
  ledighet_nn_1 = mkN "ledighet" "ledigheter" ;
  ledighetskommitte_nn_1 = mkN "ledighetskommittй" "ledighetskommittйer" ;
  ledinflammation_nn_1 = mkN "ledinflammation" "ledinflammationer" ;
  ledkapsel_nn_1 = mkN "ledkapsel" ;
  ledkort_nn_1 = mkN "ledkort" neutrum ;
  ledmotiv_nn_1 = mkN "ledmotiv" neutrum ;
  ledning_nn_1 = mkN "ledning" ;
  ledningsmaal_nn_1 = mkN "ledningsmеl" neutrum ;
  ledningsmotstaand_nn_1 = mkN "ledningsmotstеnd" neutrum ;
  ledningsorgan_nn_1 = mkN "ledningsorgan" neutrum ;
  ledningsstolpe_nn_1 = mkN "ledningsstolpe" utrum ;
  ledningsvaevnad_nn_1 = mkN "ledningsvдvnad" "ledningsvдvnader" ;
  ledsagare_nn_1 = mkN "ledsagare" "ledsagare" ;
  ledsam_av_1 = mkA "ledsam" "ledsamt" "ledsamma" "ledsamma" "ledsammare" "ledsammast" "ledsammaste" ;
  ledsamhet_nn_1 = mkN "ledsamhet" "ledsamheter" ;
  ledsegel_nn_1 = mkN "ledsegel" neutrum ;
  ledsen_av_1 = mkA "ledsen" "ledset" ;
  ledskaal_nn_1 = mkN "ledskеl" ;
  ledsnad_nn_1 = mkN "ledsnad" "ledsnader" ;
  ledstaang_nn_1 = mkN "ledstеng" "ledstдnger" ;
  ledtraad_nn_1 = mkN "ledtrеd" ;
  ledungsskepp_nn_1 = mkN "ledungsskepp" neutrum ;
  ledutrymme_nn_1 = mkN "ledutrymme" ;
  leende_nn_1 = mkN "leende" ;
  legaer_av_1 = mkA "legдr" ;
  legal_av_1 = mkA "legal" ;
  legaliter_ab_1 = mkAdv "legaliter" ;
  legalitet_nn_1 = mkN "legalitet" "legaliteter" ;
  legat_nn_1 = mkN "legat" "legater" ;
  legat_nn_2 = mkN "legat" neutrum ;
  legatarie_nn_1 = mkN "legatarie" "legatarier" ;
  legation_nn_1 = mkN "legation" "legationer" ;
  legato_ab_1 = mkAdv "legato" ;
  legato_nn_1 = mkN "legato" "legatot" "legaton" "legatona" ;
  legend_nn_1 = mkN "legend" "legender" ;
  legendar_nn_1 = mkN "legendar" "legendarer" ;
  legendarisk_av_1 = mkA "legendarisk" ;
  legendarium_nn_1 = mkN "legendarium" "legendariet" "legendarier" "legendarierna" ;
  legendomspunnen_av_1 = mkA "legendomspunnen" "legendomspunnet" "legendomspunna" "legendomspunna" "legendomspunnare" "legendomspunnast" "legendomspunnaste" ;
  legering_nn_1 = mkN "legering" ;
  legio_av_1 = mkA "legio" ;
  legion_nn_1 = mkN "legion" "legioner" ;
  legionaer_nn_1 = mkN "legionдr" "legionдrer" ;
  legislativ_av_1 = mkA "legislativ" ;
  legislatur_nn_1 = mkN "legislatur" "legislaturer" ;
  legitim_av_1 = mkA "legitim" ;
  legitimation_nn_1 = mkN "legitimation" "legitimationer" ;
  legitimist_nn_1 = mkN "legitimist" "legitimister" ;
  legitimitet_nn_1 = mkN "legitimitet" "legitimiteter" ;
  lego_nn_1 = mkN "lego" "legot" "legon" "legona" ;
  legoavtal_nn_1 = mkN "legoavtal" "legoavtalet" "legoavtalen" "legoavtalena" ;
  legoknekt_nn_1 = mkN "legoknekt" ;
  legosoldat_nn_1 = mkN "legosoldat" "legosoldater" ;
  legotillverkning_nn_1 = mkN "legotillverkning" ;
  legotrupp_nn_1 = mkN "legotrupp" "legotrupper" ;
  leguan_nn_1 = mkN "leguan" "leguaner" ;
  legymsallad_nn_1 = mkN "legymsallad" "legymsallader" ;
  lejd_nn_1 = mkN "lejd" ;
  lejdare_nn_1 = mkN "lejdare" "lejdare" ;
  lejdbaat_nn_1 = mkN "lejdbеt" ;
  lejdebrev_nn_1 = mkN "lejdebrev" neutrum ;
  lejon_nn_1 = mkN "lejon" neutrum ;
  lejonfot_nn_1 = mkN "lejonfot" "lejonfцtter" ;
  lejongap_nn_1 = mkN "lejongap" neutrum ;
  lejongrop_nn_1 = mkN "lejongrop" ;
  lejoninna_nn_1 = mkN "lejoninna" ;
  lejonklo_nn_1 = mkN "lejonklo" "lejonklor" ;
  lejonklorna_ab_1 = mkAdv "lejonklorna" ;
  lejontaemjare_nn_1 = mkN "lejontдmjare" "lejontдmjare" ;
  lek_av_1 = mkA "lek" ;
  lek_nn_1 = mkN "lek" ;
  lekamlig_av_1 = mkA "lekamlig" ;
  lekamligen_ab_1 = mkAdv "lekamligen" ;
  lekare_nn_1 = mkN "lekare" "lekare" ;
  lekatt_nn_1 = mkN "lekatt" "lekatter" ;
  lekboll_nn_1 = mkN "lekboll" ;
  lekdamm_nn_1 = mkN "lekdamm" ;
  lekdraekt_nn_1 = mkN "lekdrдkt" "lekdrдkter" ;
  lekfaerdig_av_1 = mkA "lekfдrdig" ;
  lekfisk_nn_1 = mkN "lekfisk" ;
  lekfull_av_1 = mkA "lekfull" ;
  lekfullhet_nn_1 = mkN "lekfullhet" "lekfullheter" ;
  lekkamrat_nn_1 = mkN "lekkamrat" "lekkamrater" ;
  lekledare_nn_1 = mkN "lekledare" "lekledare" ;
  leklysten_av_1 = mkA "leklysten" "leklystet" ;
  lekman_nn_1 = mkN "lekman" "lekmannen" "lekmдn" "lekmдnnen" ;
  lekmannabroder_nn_1 = mkN "lekmannabroder" "lekmannabrodern" "lekmannabrцder" "lekmannabrцderna" ;
  lekotek_nn_1 = mkN "lekotek" neutrum ;
  lekpark_nn_1 = mkN "lekpark" "lekparker" ;
  lekplats_nn_1 = mkN "lekplats" "lekplatser" ;
  leksak_nn_1 = mkN "leksak" "leksaker" ;
  leksaksbaat_nn_1 = mkN "leksaksbеt" ;
  leksaksbil_nn_1 = mkN "leksaksbil" ;
  leksaksbjoern_nn_1 = mkN "leksaksbjцrn" ;
  leksaksfigur_nn_1 = mkN "leksaksfigur" "leksaksfigurer" ;
  leksakshaest_nn_1 = mkN "leksakshдst" ;
  leksakspistol_nn_1 = mkN "leksakspistol" "leksakspistoler" ;
  lekstuga_nn_1 = mkN "lekstuga" ;
  lekt_av_1 = mkA "lekt" ;
  lektid_nn_1 = mkN "lektid" "lektider" ;
  lektion_nn_1 = mkN "lektion" "lektioner" ;
  lektionstimme_nn_1 = mkN "lektionstimme" utrum ;
  lektoer_nn_1 = mkN "lektцr" "lektцrer" ;
  lektor_nn_1 = mkN "lektor" "lektorer" ;
  lektorat_nn_1 = mkN "lektorat" neutrum ;
  lektris_nn_1 = mkN "lektris" "lektriser" ;
  lekvandring_nn_1 = mkN "lekvandring" ;
  lekverk_nn_1 = mkN "lekverk" neutrum ;
  lem_nn_1 = mkN "lem" "lemmen" "lemmar" "lemmarna" ;
  lemma_nn_1 = mkN "lemma" "lemmat" "lemman" "lemmana" ;
  lemmalytt_av_1 = mkA "lemmalytt" ;
  lemonad_nn_1 = mkN "lemonad" "lemonader" ;
  len_av_1 = mkA "len" ;
  leninistisk_av_1 = mkA "leninistisk" ;
  lenis_av_1 = mkA "lenis" ;
  leopard_nn_1 = mkN "leopard" "leoparder" ;
  leproes_av_1 = mkA "leprцs" ;
  leptosom_av_1 = mkA "leptosom" ;
  lerbotten_nn_1 = mkN "lerbotten" ;
  lercylinder_nn_1 = mkN "lercylinder" ;
  lergoek_nn_1 = mkN "lergцk" ;
  lerhaerd_nn_1 = mkN "lerhдrd" ;
  lerhalt_nn_1 = mkN "lerhalt" "lerhalter" ;
  lerhaltig_av_1 = mkA "lerhaltig" ;
  lerig_av_1 = mkA "lerig" ;
  lerjord_nn_1 = mkN "lerjord" ;
  lerkaerl_nn_1 = mkN "lerkдrl" neutrum ;
  lerklining_nn_1 = mkN "lerklining" ;
  lerskiffer_nn_1 = mkN "lerskiffer" ;
  lesbisk_av_1 = mkA "lesbisk" ;
  lesion_nn_1 = mkN "lesion" "lesioner" ;
  lesothier_nn_1 = mkN "lesothier" "lesothiern" "lesothier" "lesothierna" ;
  lesothisk_av_1 = mkA "lesothisk" ;
  letal_av_1 = mkA "letal" ;
  letargisk_av_1 = mkA "letargisk" ;
  lett_nn_1 = mkN "lett" "letter" ;
  lettisk_av_1 = mkA "lettisk" ;
  lettiska_nn_2 = mkN "lettiska" ;
  leukemi_nn_1 = mkN "leukemi" "leukemier" ;
  leukocyt_nn_1 = mkN "leukocyt" "leukocyter" ;
  lev_nn_1 = mkN "lev" ;
  leva_nn_1 = mkN "leva" "levan" "leva" "levana" ;
  levande_av_1 = mkA "levande" ;
  levang_nn_1 = mkN "levang" "levanger" ;
  levantin_nn_1 = mkN "levantin" "levantiner" ;
  leve_nn_1 = mkN "leve" ;
  lever_nn_1 = mkN "lever" ;
  leverans_nn_1 = mkN "leverans" "leveranser" ;
  leveransavtal_nn_1 = mkN "leveransavtal" "leveransavtalet" "leveransavtalen" "leveransavtalena" ;
  leveransklar_av_1 = mkA "leveransklar" ;
  leveranstid_nn_1 = mkN "leveranstid" "leveranstider" ;
  leverantoer_nn_1 = mkN "leverantцr" "leverantцrer" ;
  leverbrun_av_1 = mkA "leverbrun" ;
  levercell_nn_1 = mkN "levercell" "leverceller" ;
  leverflaeck_nn_1 = mkN "leverflдck" ;
  leverop_nn_1 = mkN "leverop" neutrum ;
  leverpastej_nn_1 = mkN "leverpastej" "leverpastejer" ;
  leverskrumpning_nn_1 = mkN "leverskrumpning" ;
  levit_nn_1 = mkN "levit" "leviter" ;
  levnad_nn_1 = mkN "levnad" "levnader" ;
  levnadsaalder_nn_1 = mkN "levnadsеlder" ;
  levnadsaar_nn_1 = mkN "levnadsеr" neutrum ;
  levnadsbeskrivning_nn_1 = mkN "levnadsbeskrivning" ;
  levnadsglad_av_1 = mkA "levnadsglad" ;
  levnadskonstnaer_nn_1 = mkN "levnadskonstnдr" "levnadskonstnдrer" ;
  levnadskostnad_nn_1 = mkN "levnadskostnad" "levnadskostnader" ;
  levnadslopp_nn_1 = mkN "levnadslopp" neutrum ;
  levnadsnivaa_nn_1 = mkN "levnadsnivе" "levnadsnivеer" ;
  levnadsoede_nn_1 = mkN "levnadsцde" ;
  levnadsregel_nn_1 = mkN "levnadsregel" "levnadsregeln" "levnadsregler" "levnadsreglerna" ;
  levnadssaett_nn_1 = mkN "levnadssдtt" neutrum ;
  levnadstecknare_nn_1 = mkN "levnadstecknare" "levnadstecknare" ;
  levnadsteckning_nn_1 = mkN "levnadsteckning" ;
  levnadstroett_av_1 = mkA "levnadstrцtt" ;
  levnadsvisdom_nn_1 = mkN "levnadsvisdom" ;
  lexem_nn_1 = mkN "lexem" neutrum ;
  lexikal_av_1 = mkA "lexikal" ;
  lexikalisk_av_1 = mkA "lexikalisk" ;
  lexikograf_nn_1 = mkN "lexikograf" "lexikografer" ;
  lexikografisk_av_1 = mkA "lexikografisk" ;
  lexikolog_nn_1 = mkN "lexikolog" "lexikologer" ;
  lexikologisk_av_1 = mkA "lexikologisk" ;
  lexikon_nn_1 = mkN "lexikon" neutrum ;
  lian_nn_1 = mkN "lian" "lianer" ;
  libanes_nn_1 = mkN "libanes" "libaneser" ;
  libanesisk_av_1 = mkA "libanesisk" ;
  libation_nn_1 = mkN "libation" "libationer" ;
  libell_nn_1 = mkN "libell" "libeller" ;
  liberal_av_1 = mkA "liberal" ;
  liberalisering_nn_1 = mkN "liberalisering" ;
  liberian_nn_1 = mkN "liberian" "liberianer" ;
  liberiansk_av_1 = mkA "liberiansk" ;
  liberier_nn_1 = mkN "liberier" "liberiern" "liberier" "liberierna" ;
  liberisk_av_1 = mkA "liberisk" ;
  libero_nn_1 = mkN "libero" "liberor" ;
  libertin_nn_1 = mkN "libertin" "libertiner" ;
  libration_nn_1 = mkN "libration" "librationer" ;
  librettist_nn_1 = mkN "librettist" "librettister" ;
  libretto_nn_1 = mkN "libretto" "librettor" ;
  libyer_nn_1 = mkN "libyer" "libyern" "libyer" "libyerna" ;
  libysk_av_1 = mkA "libysk" ;
  licens_nn_1 = mkN "licens" "licenser" ;
  licentiat_nn_1 = mkN "licentiat" "licentiater" ;
  lid_nn_1 = mkN "lid" "lider" ;
  lida_vb_1 = mkV "lida" "led" "lidit" ;
  lidande_av_1 = mkA "lidande" ;
  lidande_nn_1 = mkN "lidande" ;
  lidandeshistoria_nn_1 = mkN "lidandeshistoria" "lidandeshistorien" "lidandeshistorier" "lidandeshistorierna" ;
  lidelse_nn_1 = mkN "lidelse" "lidelser" ;
  lidelsefri_av_1 = mkA "lidelsefri" "lidelsefritt" ;
  lidelsefull_av_1 = mkA "lidelsefull" ;
  lider_nn_1 = mkN "lider" neutrum ;
  liderlig_av_1 = mkA "liderlig" ;
  lie_nn_1 = mkN "lie" utrum ;
  liechtensteinare_nn_1 = mkN "liechtensteinare" "liechtensteinare" ;
  liechtensteinsk_av_1 = mkA "liechtensteinsk" ;
  lieknagg_nn_1 = mkN "lieknagg" ;
  lieskaft_nn_1 = mkN "lieskaft" neutrum ;
  lift_nn_1 = mkN "lift" ;
  liftare_nn_1 = mkN "liftare" "liftare" ;
  ligament_nn_1 = mkN "ligament" neutrum ;
  ligatur_nn_1 = mkN "ligatur" "ligaturer" ;
  ligg_nn_1 = mkN "ligg" neutrum ;
  liggare_nn_1 = mkN "liggare" "liggare" ;
  liggdags_ab_1 = mkAdv "liggdags" ;
  liggetid_nn_1 = mkN "liggetid" "liggetider" ;
  liggplats_nn_1 = mkN "liggplats" "liggplatser" ;
  liggriktig_av_1 = mkA "liggriktig" ;
  liggsaar_nn_1 = mkN "liggsеr" neutrum ;
  liggsjuk_av_1 = mkA "liggsjuk" ;
  liggvagn_nn_1 = mkN "liggvagn" ;
  ligist_nn_1 = mkN "ligist" "ligister" ;
  lignin_nn_1 = mkN "lignin" "ligniner" ;
  ligurisk_av_1 = mkA "ligurisk" ;
  liguster_nn_1 = mkN "liguster" ;
  ligusterfjaeril_nn_1 = mkN "ligusterfjдril" ;
  ligustersvaermare_nn_1 = mkN "ligustersvдrmare" "ligustersvдrmare" ;
  lik_av_1 = mkA "lik" ;
  lik_nn_1 = mkN "lik" neutrum ;
  lika_ab_1 = mkAdv "lika" ;
  lika_av_1 = mkA "lika" ;
  likadan_av_1 = mkA "likadan" ;
  likafullt_ab_1 = mkAdv "likafullt" ;
  likaledes_ab_1 = mkAdv "likaledes" ;
  likaloen_nn_1 = mkN "likalцn" "likalцner" ;
  likalydande_av_1 = mkA "likalydande" ;
  likare_nn_1 = mkN "likare" "likare" ;
  likasaa_ab_1 = mkAdv "likasе" ;
  likasaavael_ab_1 = mkAdv "likasеvдl" ;
  likasom_ab_1 = mkAdv "likasom" ;
  likavael_ab_1 = mkAdv "likavдl" ;
  likbent_av_1 = mkA "likbent" "likbent" ;
  likbesiktning_nn_1 = mkN "likbesiktning" ;
  likbjudarmin_nn_1 = mkN "likbjudarmin" "likbjudarminer" ;
  likblaanad_nn_1 = mkN "likblеnad" "likblеnader" ;
  likblek_av_1 = mkA "likblek" ;
  like_nn_1 = mkN "like" utrum ;
  likfaerd_nn_1 = mkN "likfдrd" "likfдrder" ;
  likflaeck_nn_1 = mkN "likflдck" ;
  likfoergiftning_nn_1 = mkN "likfцrgiftning" ;
  likformig_av_1 = mkA "likformig" ;
  likformighet_nn_1 = mkN "likformighet" "likformigheter" ;
  likfynd_nn_1 = mkN "likfynd" neutrum ;
  likgiltig_av_1 = mkA "likgiltig" ;
  likgiltighet_nn_1 = mkN "likgiltighet" "likgiltigheter" ;
  likhet_nn_1 = mkN "likhet" "likheter" ;
  likhetstecken_nn_1 = mkN "likhetstecken" "likhetstecknet" "likhetstecken" "likhetstecknen" ;
  likljudande_av_1 = mkA "likljudande" ;
  likmaetigt_ab_1 = mkAdv "likmдtigt" ;
  liknaemnig_av_1 = mkA "liknдmnig" ;
  liknande_av_1 = mkA "liknande" ;
  liknelse_nn_1 = mkN "liknelse" "liknelser" ;
  liknoejd_av_1 = mkA "liknцjd" "liknцjt" ;
  likoer_nn_1 = mkN "likцr" "likцrer" ;
  likoerglas_nn_1 = mkN "likцrglas" neutrum ;
  likriktare_nn_1 = mkN "likriktare" "likriktare" ;
  liksidig_av_1 = mkA "liksidig" ;
  liksiding_nn_1 = mkN "liksiding" ;
  likskaendare_nn_1 = mkN "likskдndare" "likskдndare" ;
  liksom_ab_1 = mkAdv "liksom" ;
  likspaenning_nn_1 = mkN "likspдnning" ;
  likstaellig_av_1 = mkA "likstдllig" ;
  likstaellighet_nn_1 = mkN "likstдllighet" "likstдlligheter" ;
  likstaemmig_av_1 = mkA "likstдmmig" ;
  likstaemmighet_nn_1 = mkN "likstдmmighet" "likstдmmigheter" ;
  likstelhet_nn_1 = mkN "likstelhet" "likstelheter" ;
  likstroem_nn_1 = mkN "likstrцm" "likstrцmmen" "likstrцmmar" "likstrцmmarna" ;
  liksvamp_nn_1 = mkN "liksvamp" ;
  liksvepning_nn_1 = mkN "liksvepning" ;
  liktor_nn_1 = mkN "liktor" "liktorer" ;
  liktorn_nn_1 = mkN "liktorn" ;
  liktydig_av_1 = mkA "liktydig" ;
  likvael_ab_1 = mkAdv "likvдl" ;
  likvaerd_av_1 = mkA "likvдrd" "likvдrt" ;
  likvaerdig_av_1 = mkA "likvдrdig" ;
  likvid_nn_1 = mkN "likvid" "likvider" ;
  likvidation_nn_1 = mkN "likvidation" "likvidationer" ;
  likvidator_nn_1 = mkN "likvidator" "likvidatorer" ;
  likviditet_nn_1 = mkN "likviditet" "likviditeter" ;
  likvisst_ab_1 = mkAdv "likvisst" ;
  lila_av_1 = mkA "lila" ;
  lilja_nn_1 = mkN "lilja" ;
  liljekonvalje_nn_1 = mkN "liljekonvalje" "liljekonvaljer" ;
  liljevaext_nn_1 = mkN "liljevдxt" "liljevдxter" ;
  liljevit_av_1 = mkA "liljevit" ;
  lillasyster_nn_1 = mkN "lillasyster" ;
  lillaxel_nn_1 = mkN "lillaxel" ;
  lilleputt_nn_1 = mkN "lilleputt" ;
  lillfinger_nn_1 = mkN "lillfinger" ;
  lillsemester_nn_1 = mkN "lillsemester" ;
  lillslam_nn_1 = mkN "lillslam" "lillslammen" "lillslammar" "lillslammarna" ;
  lillstuga_nn_1 = mkN "lillstuga" ;
  lilltaa_nn_1 = mkN "lilltе" "lilltеn" "lilltеr" "lilltеrna" ;
  lillvaerdinna_nn_1 = mkN "lillvдrdinna" ;
  lim_nn_1 = mkN "lim" "limmet" "lim" "limmen" ;
  limaemne_nn_1 = mkN "limдmne" ;
  lime_nn_1 = mkN "lime" "limer" ;
  limerick_nn_1 = mkN "limerick" ;
  limfaerg_nn_1 = mkN "limfдrg" "limfдrger" ;
  limgoerdel_nn_1 = mkN "limgцrdel" ;
  limit_nn_1 = mkN "limit" "limiter" ;
  limitation_nn_1 = mkN "limitation" "limitationer" ;
  limitativ_av_1 = mkA "limitativ" ;
  limkokeri_nn_1 = mkN "limkokeri" "limkokerit" "limkokerier" "limkokerierna" ;
  limning_nn_1 = mkN "limning" ;
  limnisk_av_1 = mkA "limnisk" ;
  limnograf_nn_1 = mkN "limnograf" "limnografer" ;
  limnologisk_av_1 = mkA "limnologisk" ;
  limousine_nn_1 = mkN "limousine" "limousiner" ;
  limpinne_nn_1 = mkN "limpinne" utrum ;
  limring_nn_1 = mkN "limring" ;
  limtillverkning_nn_1 = mkN "limtillverkning" ;
  linaaker_nn_1 = mkN "linеker" ;
  lind_nn_1 = mkN "lind" ;
  lindansare_nn_1 = mkN "lindansare" "lindansare" ;
  lindare_nn_1 = mkN "lindare" "lindare" ;
  linddrag_nn_1 = mkN "linddrag" neutrum ;
  lindebarn_nn_1 = mkN "lindebarn" neutrum ;
  lindning_nn_1 = mkN "lindning" ;
  lindorm_nn_1 = mkN "lindorm" ;
  lindrig_av_1 = mkA "lindrig" ;
  lindring_nn_1 = mkN "lindring" ;
  lineaer_av_1 = mkA "lineдr" ;
  linearritning_nn_1 = mkN "linearritning" ;
  linfroe_nn_1 = mkN "linfrц" "linfrцt" "linfrцn" "linfrцen" ;
  lingarn_nn_1 = mkN "lingarn" neutrum ;
  lingeri_nn_1 = mkN "lingeri" "lingerit" "lingerier" "lingerierna" ;
  lingon_nn_1 = mkN "lingon" neutrum ;
  lingonbuske_nn_1 = mkN "lingonbuske" utrum ;
  lingonpaeron_nn_1 = mkN "lingonpдron" neutrum ;
  lingonsylt_nn_1 = mkN "lingonsylt" "lingonsylter" ;
  lingul_av_1 = mkA "lingul" ;
  lingvist_nn_1 = mkN "lingvist" "lingvister" ;
  lingvistisk_av_1 = mkA "lingvistisk" ;
  linhaarig_av_1 = mkA "linhеrig" ;
  liniment_nn_1 = mkN "liniment" neutrum ;
  linjaer_av_1 = mkA "linjдr" ;
  linjal_nn_1 = mkN "linjal" "linjaler" ;
  linje_nn_1 = mkN "linje" "linjer" ;
  linjeblockering_nn_1 = mkN "linjeblockering" ;
  linjedomare_nn_1 = mkN "linjedomare" "linjedomare" ;
  linjefoering_nn_1 = mkN "linjefцring" ;
  linjelopp_nn_1 = mkN "linjelopp" neutrum ;
  linjeman_nn_1 = mkN "linjeman" "linjemannen" "linjemдn" "linjemдnnen" ;
  linjenaemnd_nn_1 = mkN "linjenдmnd" "linjenдmnder" ;
  linjeren_av_1 = mkA "linjeren" ;
  linjeskepp_nn_1 = mkN "linjeskepp" neutrum ;
  linjespektrum_nn_1 = mkN "linjespektrum" neutrum ;
  linjespel_nn_1 = mkN "linjespel" "linjespelet" "linjespel" "linjespelen" ;
  linjevaeljare_nn_1 = mkN "linjevдljare" "linjevдljare" ;
  linlugg_nn_1 = mkN "linlugg" ;
  linnedamast_nn_1 = mkN "linnedamast" "linnedamaster" ;
  linneduk_nn_1 = mkN "linneduk" ;
  linnefiber_nn_1 = mkN "linnefiber" "linnefibern" "linnefibrer" "linnefibrerna" ;
  linneskaap_nn_1 = mkN "linneskеp" neutrum ;
  linning_nn_1 = mkN "linning" ;
  linoleumsnitt_nn_1 = mkN "linoleumsnitt" neutrum ;
  linolja_nn_1 = mkN "linolja" ;
  lins_nn_1 = mkN "lins" "linser" ;
  linsfel_nn_1 = mkN "linsfel" "linsfelet" "linsfel" "linsfelen" ;
  linslus_nn_1 = mkN "linslus" "linslusen" "linslцss" "linslцssen" ;
  linssystem_nn_1 = mkN "linssystem" neutrum ;
  lintott_nn_1 = mkN "lintott" ;
  lipas_nn_1 = mkN "lipas" "lipaser" ;
  lipid_nn_1 = mkN "lipid" "lipider" ;
  lipig_av_1 = mkA "lipig" ;
  lipom_nn_1 = mkN "lipom" neutrum ;
  lipsill_nn_1 = mkN "lipsill" ;
  lire_nn_1 = mkN "lire" "liren" "lire" "lirena" ;
  lisen_nn_1 = mkN "lisen" "lisener" ;
  lismare_nn_1 = mkN "lismare" "lismare" ;
  lisoes_nn_1 = mkN "lisцs" "lisцser" ;
  lispund_nn_1 = mkN "lispund" neutrum ;
  list_nn_1 = mkN "list" "lister" ;
  listig_av_1 = mkA "listig" ;
  listornament_nn_1 = mkN "listornament" "listornamentet" "listornamenten" "listornamentena" ;
  listprofil_nn_1 = mkN "listprofil" "listprofiler" ;
  listverk_nn_1 = mkN "listverk" neutrum ;
  litauer_nn_1 = mkN "litauer" "litauern" "litauer" "litauerna" ;
  litauisk_av_1 = mkA "litauisk" ;
  litauiska_nn_2 = mkN "litauiska" ;
  lite_ab_1 = mkAdv "lite" ;
  liten_av_1 = mkA "liten" "litet" "lilla" "smе" "mindre" "minst" "minsta" ;
  litenhet_nn_1 = mkN "litenhet" "litenheter" ;
  liter_nn_1 = mkN "liter" ;
  liter_nn_2 = mkN "liter" ;
  litermaatt_nn_1 = mkN "litermеtt" neutrum ;
  litervis_ab_1 = mkAdv "litervis" ;
  litograf_nn_1 = mkN "litograf" "litografer" ;
  litografi_nn_1 = mkN "litografi" "litografier" ;
  litoral_av_1 = mkA "litoral" ;
  litotes_nn_1 = mkN "litotes" "litoteser" ;
  litteraer_av_1 = mkA "litterдr" ;
  litterat_av_1 = mkA "litterat" "litterat" ;
  litteratoer_nn_1 = mkN "litteratцr" "litteratцrer" ;
  litteratur_nn_1 = mkN "litteratur" "litteraturer" ;
  litteraturanmaelan_nn_1 = mkN "litteraturanmдlan" "litteraturanmдlan" "litteraturanmдlningar" "litteraturanmдlningarna" ;
  litteraturanvisning_nn_1 = mkN "litteraturanvisning" ;
  litteraturfoerteckning_nn_1 = mkN "litteraturfцrteckning" ;
  litteraturforskare_nn_1 = mkN "litteraturforskare" "litteraturforskare" ;
  litteraturhaenvisning_nn_1 = mkN "litteraturhдnvisning" ;
  litteraturhistorisk_av_1 = mkA "litteraturhistorisk" ;
  litteraturingenjoer_nn_1 = mkN "litteraturingenjцr" "litteraturingenjцrer" ;
  litteraturkritiker_nn_1 = mkN "litteraturkritiker" "litteraturkritikern" "litteraturkritiker" "litteraturkritikerna" ;
  litteraturprofessor_nn_1 = mkN "litteraturprofessor" "litteraturprofessorer" ;
  litteratursoekning_nn_1 = mkN "litteratursцkning" ;
  litteraturspraak_nn_1 = mkN "litteratursprеk" neutrum ;
  liturg_nn_1 = mkN "liturg" "liturger" ;
  liturgi_nn_1 = mkN "liturgi" "liturgier" ;
  liturgisk_av_1 = mkA "liturgisk" ;
  liv_nn_1 = mkN "liv" neutrum ;
  livaktig_av_1 = mkA "livaktig" ;
  livbaat_nn_1 = mkN "livbеt" ;
  livbaelte_nn_1 = mkN "livbдlte" ;
  livboj_nn_1 = mkN "livboj" ;
  livdjur_nn_1 = mkN "livdjur" neutrum ;
  livdoemd_av_1 = mkA "livdцmd" "livdцmt" ;
  livdrabant_nn_1 = mkN "livdrabant" "livdrabanter" ;
  live_av_1 = mkA "live" ;
  live_show_nn_1 = mkN "live-show" "live-shower" ;
  livegen_av_1 = mkA "livegen" "liveget" ;
  livfoersaekring_nn_1 = mkN "livfцrsдkring" ;
  livfull_av_1 = mkA "livfull" ;
  livgarde_nn_1 = mkN "livgarde" ;
  livgivande_av_1 = mkA "livgivande" ;
  livklaednad_nn_1 = mkN "livklдdnad" "livklдdnader" ;
  livlig_av_1 = mkA "livlig" ;
  livlighet_nn_1 = mkN "livlighet" "livligheter" ;
  livloes_av_1 = mkA "livlцs" ;
  livmedikus_nn_1 = mkN "livmedikus" "livmedikus" "livmedici" "livmedicina" ;
  livmoderframfall_nn_1 = mkN "livmoderframfall" neutrum ;
  livmoderhals_nn_1 = mkN "livmoderhals" ;
  livmodermun_nn_1 = mkN "livmodermun" "livmodermunnen" "livmodermunnar" "livmodermunnarna" ;
  livmodersslemhinna_nn_1 = mkN "livmodersslemhinna" ;
  livraeddare_nn_1 = mkN "livrдddare" "livrдddare" ;
  livraeddning_nn_1 = mkN "livrдddning" ;
  livraett_nn_1 = mkN "livrдtt" "livrдtter" ;
  livre_nn_1 = mkN "livrй" "livrйt" "livrйer" "livrйerna" ;
  livregemente_nn_1 = mkN "livregemente" ;
  livrem_nn_1 = mkN "livrem" "livremmen" "livremmar" "livremmarna" ;
  livrustkammare_nn_1 = mkN "livrustkammare" "livrustkammaren" "livrustkamrar" "livrustkamrarna" ;
  livs_av_1 = mkA "livs" ;
  livsaaskaadning_nn_1 = mkN "livsеskеdning" ;
  livsarvinge_nn_1 = mkN "livsarvinge" utrum ;
  livsavgoerande_av_1 = mkA "livsavgцrande" ;
  livsbefraemjande_av_1 = mkA "livsbefrдmjande" ;
  livsbejakande_av_1 = mkA "livsbejakande" ;
  livsbejakare_nn_1 = mkN "livsbejakare" "livsbejakare" ;
  livsbetingelse_nn_1 = mkN "livsbetingelse" "livsbetingelser" ;
  livsduglig_av_1 = mkA "livsduglig" ;
  livselixir_nn_1 = mkN "livselixir" neutrum ;
  livsfarlig_av_1 = mkA "livsfarlig" ;
  livsfoering_nn_1 = mkN "livsfцring" ;
  livsfoernekelse_nn_1 = mkN "livsfцrnekelse" "livsfцrnekelser" ;
  livsform_nn_1 = mkN "livsform" "livsformer" ;
  livsfraaga_nn_1 = mkN "livsfrеga" ;
  livsgaerning_nn_1 = mkN "livsgдrning" ;
  livshaallning_nn_1 = mkN "livshеllning" ;
  livshotande_av_1 = mkA "livshotande" ;
  livskamrat_nn_1 = mkN "livskamrat" "livskamrater" ;
  livskraftig_av_1 = mkA "livskraftig" ;
  livskvalitet_nn_1 = mkN "livskvalitet" "livskvaliteter" ;
  livslaang_av_1 = mkA "livslеng" ;
  livslaengd_nn_1 = mkN "livslдngd" "livslдngder" ;
  livslag_nn_1 = mkN "livslag" ;
  livslevande_av_1 = mkA "livslevande" ;
  livslinje_nn_1 = mkN "livslinje" "livslinjer" ;
  livsloegn_nn_1 = mkN "livslцgn" "livslцgner" ;
  livslust_nn_1 = mkN "livslust" ;
  livsmedel_nn_1 = mkN "livsmedel" neutrum ;
  livsmedelsaffaer_nn_1 = mkN "livsmedelsaffдr" "livsmedelsaffдrer" ;
  livsmedelsavfall_nn_1 = mkN "livsmedelsavfall" neutrum ;
  livsmedelsbutik_nn_1 = mkN "livsmedelsbutik" "livsmedelsbutiker" ;
  livsmedelsfaerg_nn_1 = mkN "livsmedelsfдrg" "livsmedelsfдrger" ;
  livsmedelslag_nn_1 = mkN "livsmedelslag" ;
  livsmiljoe_nn_1 = mkN "livsmiljц" "livsmiljцn" "livsmiljцer" "livsmiljцerna" ;
  livsnerv_nn_1 = mkN "livsnerv" "livsnerver" ;
  livsnoedvaendig_av_1 = mkA "livsnцdvдndig" ;
  livsprocess_nn_1 = mkN "livsprocess" "livsprocesser" ;
  livsreaktion_nn_1 = mkN "livsreaktion" "livsreaktioner" ;
  livssituation_nn_1 = mkN "livssituation" "livssituationer" ;
  livsslut_nn_1 = mkN "livsslut" neutrum ;
  livsstil_nn_1 = mkN "livsstil" ;
  livssyn_nn_1 = mkN "livssyn" "livssyner" ;
  livstecken_nn_1 = mkN "livstecken" "livstecknet" "livstecken" "livstecknen" ;
  livstraed_nn_1 = mkN "livstrдd" neutrum ;
  livsuppehaallande_av_1 = mkA "livsuppehеllande" ;
  livsuppgift_nn_1 = mkN "livsuppgift" "livsuppgifter" ;
  livsutveckling_nn_1 = mkN "livsutveckling" ;
  livsvaenlig_av_1 = mkA "livsvдnlig" ;
  livsverk_nn_1 = mkN "livsverk" neutrum ;
  livsviktig_av_1 = mkA "livsviktig" ;
  livsvillkor_nn_1 = mkN "livsvillkor" neutrum ;
  livsyttring_nn_1 = mkN "livsyttring" ;
  livtag_nn_1 = mkN "livtag" neutrum ;
  livvakt_nn_1 = mkN "livvakt" "livvakter" ;
  lix_nn_1 = mkN "lix" neutrum ;
  ljud_nn_1 = mkN "ljud" neutrum ;
  ljudaatergivning_nn_1 = mkN "ljudеtergivning" ;
  ljudande_av_1 = mkA "ljudande" ;
  ljudband_nn_1 = mkN "ljudband" neutrum ;
  ljudbang_nn_1 = mkN "ljudbang" ;
  ljudbildband_nn_1 = mkN "ljudbildband" neutrum ;
  ljudboj_nn_1 = mkN "ljudboj" ;
  ljudbrev_nn_1 = mkN "ljudbrev" neutrum ;
  ljuddaempande_av_1 = mkA "ljuddдmpande" ;
  ljuddaempare_nn_1 = mkN "ljuddдmpare" "ljuddдmpare" ;
  ljudenlig_av_1 = mkA "ljudenlig" ;
  ljudfilm_nn_1 = mkN "ljudfilm" "ljudfilmer" ;
  ljudfoeraendring_nn_1 = mkN "ljudfцrдndring" ;
  ljudfoerbindelse_nn_1 = mkN "ljudfцrbindelse" "ljudfцrbindelser" ;
  ljudhaal_nn_1 = mkN "ljudhеl" neutrum ;
  ljudhaermande_av_1 = mkA "ljudhдrmande" ;
  ljudhastighet_nn_1 = mkN "ljudhastighet" "ljudhastigheter" ;
  ljudinspelning_nn_1 = mkN "ljudinspelning" ;
  ljudisolering_nn_1 = mkN "ljudisolering" ;
  ljudkuliss_nn_1 = mkN "ljudkuliss" "ljudkulisser" ;
  ljudkvalitet_nn_1 = mkN "ljudkvalitet" "ljudkvaliteter" ;
  ljudlaera_nn_1 = mkN "ljudlдra" ;
  ljudlag_nn_1 = mkN "ljudlag" ;
  ljudlig_av_1 = mkA "ljudlig" ;
  ljudloes_av_1 = mkA "ljudlцs" ;
  ljudnivaa_nn_1 = mkN "ljudnivе" "ljudnivеer" ;
  ljudoeverfoering_nn_1 = mkN "ljudцverfцring" ;
  ljudsignal_nn_1 = mkN "ljudsignal" "ljudsignaler" ;
  ljudskridning_nn_1 = mkN "ljudskridning" ;
  ljudskrift_nn_1 = mkN "ljudskrift" "ljudskrifter" ;
  ljudstyrka_nn_1 = mkN "ljudstyrka" ;
  ljudsystem_nn_1 = mkN "ljudsystem" neutrum ;
  ljudtekniker_nn_1 = mkN "ljudtekniker" "ljudteknikern" "ljudtekniker" "ljudteknikerna" ;
  ljudvall_nn_1 = mkN "ljudvall" ;
  ljuga_vb_1 = mkV "ljuga" "ljцg" "ljugit" ;
  ljugarbaenk_nn_1 = mkN "ljugarbдnk" ;
  ljum_av_1 = mkA "ljum" "ljumt" "ljumma" "ljumma" "ljummare" "ljummast" "ljummaste" ;
  ljumhet_nn_1 = mkN "ljumhet" "ljumheter" ;
  ljummen_av_1 = mkA "ljummen" "ljummet" "ljumna" "ljumna" "ljumnare" "ljumnast" "ljumnaste" ;
  ljumske_nn_1 = mkN "ljumske" utrum ;
  ljungeld_nn_1 = mkN "ljungeld" ;
  ljungpipare_nn_1 = mkN "ljungpipare" "ljungpipare" ;
  ljungvaext_nn_1 = mkN "ljungvдxt" "ljungvдxter" ;
  ljus_av_1 = mkA "ljus" ;
  ljus_nn_1 = mkN "ljus" neutrum ;
  ljusaar_nn_1 = mkN "ljusеr" neutrum ;
  ljusaekta_av_1 = mkA "ljusдkta" ;
  ljusaelskande_av_1 = mkA "ljusдlskande" ;
  ljusalf_nn_1 = mkN "ljusalf" "ljusalfer" ;
  ljusbaage_nn_1 = mkN "ljusbеge" utrum ;
  ljusbehandling_nn_1 = mkN "ljusbehandling" ;
  ljusbestaendig_av_1 = mkA "ljusbestдndig" ;
  ljusbild_nn_1 = mkN "ljusbild" "ljusbilder" ;
  ljusblaa_av_1 = mkA "ljusblе" "ljusblеtt" ;
  ljusblind_av_1 = mkA "ljusblind" ;
  ljusblixt_nn_1 = mkN "ljusblixt" ;
  ljusbrunn_nn_1 = mkN "ljusbrunn" ;
  ljusbrytning_nn_1 = mkN "ljusbrytning" ;
  ljusfenomen_nn_1 = mkN "ljusfenomen" neutrum ;
  ljusfilter_nn_1 = mkN "ljusfilter" neutrum ;
  ljusfloede_nn_1 = mkN "ljusflцde" ;
  ljusfoerhaallande_nn_1 = mkN "ljusfцrhеllande" ;
  ljusgaard_nn_1 = mkN "ljusgеrd" ;
  ljusgestalt_nn_1 = mkN "ljusgestalt" "ljusgestalter" ;
  ljusglimt_nn_1 = mkN "ljusglimt" ;
  ljusgraa_av_1 = mkA "ljusgrе" "ljusgrеtt" ;
  ljusgroen_av_1 = mkA "ljusgrцn" ;
  ljusgul_av_1 = mkA "ljusgul" ;
  ljushaallare_nn_1 = mkN "ljushеllare" "ljushеllare" ;
  ljushaarig_av_1 = mkA "ljushеrig" ;
  ljushastighet_nn_1 = mkN "ljushastighet" "ljushastigheter" ;
  ljushuggning_nn_1 = mkN "ljushuggning" ;
  ljushuvud_nn_1 = mkN "ljushuvud" "ljushuvudet" "ljushuvuden" "ljushuvudena" ;
  ljushyllt_av_1 = mkA "ljushyllt" "ljushyllt" ;
  ljuskaegla_nn_1 = mkN "ljuskдgla" ;
  ljuskaenslig_av_1 = mkA "ljuskдnslig" ;
  ljuskaenslighet_nn_1 = mkN "ljuskдnslighet" "ljuskдnsligheter" ;
  ljuskopiering_nn_1 = mkN "ljuskopiering" ;
  ljuskvantum_nn_1 = mkN "ljuskvantum" neutrum ;
  ljuslaett_av_1 = mkA "ljuslдtt" ;
  ljuslagd_av_1 = mkA "ljuslagd" "ljuslagt" ;
  ljuslockig_av_1 = mkA "ljuslockig" ;
  ljusmikroskop_nn_1 = mkN "ljusmikroskop" neutrum ;
  ljusning_nn_1 = mkN "ljusning" ;
  ljusorgel_nn_1 = mkN "ljusorgel" ;
  ljuspartikel_nn_1 = mkN "ljuspartikel" ;
  ljuspunkt_nn_1 = mkN "ljuspunkt" "ljuspunkter" ;
  ljusramp_nn_1 = mkN "ljusramp" "ljusramper" ;
  ljusroed_av_1 = mkA "ljusrцd" ;
  ljussaettning_nn_1 = mkN "ljussдttning" ;
  ljussignal_nn_1 = mkN "ljussignal" "ljussignaler" ;
  ljussken_nn_1 = mkN "ljussken" neutrum ;
  ljusskygg_av_1 = mkA "ljusskygg" ;
  ljusskygghet_nn_1 = mkN "ljusskygghet" "ljusskyggheter" ;
  ljusslaeckare_nn_1 = mkN "ljusslдckare" "ljusslдckare" ;
  ljusstake_nn_1 = mkN "ljusstake" utrum ;
  ljusstark_av_1 = mkA "ljusstark" ;
  ljusstraale_nn_1 = mkN "ljusstrеle" utrum ;
  ljusstraalning_nn_1 = mkN "ljusstrеlning" ;
  ljusstyrka_nn_1 = mkN "ljusstyrka" ;
  ljussvag_av_1 = mkA "ljussvag" ;
  ljuster_nn_1 = mkN "ljuster" neutrum ;
  ljustryck_nn_1 = mkN "ljustryck" neutrum ;
  ljusutstraalning_nn_1 = mkN "ljusutstrеlning" ;
  ljuv_av_1 = mkA "ljuv" ;
  ljuvhet_nn_1 = mkN "ljuvhet" "ljuvheter" ;
  ljuvlig_av_1 = mkA "ljuvlig" ;
  ljuvlighet_nn_1 = mkN "ljuvlighet" "ljuvligheter" ;
  lo_nn_1 = mkN "lo" ;
  lob_nn_1 = mkN "lob" "lober" ;
  lobb_nn_1 = mkN "lobb" ;
  lobby_nn_1 = mkN "lobby" "lobbyer" ;
  lobbyverksamhet_nn_1 = mkN "lobbyverksamhet" "lobbyverksamheter" ;
  lobotomi_nn_1 = mkN "lobotomi" "lobotomier" ;
  lock_nn_1 = mkN "lock" ;
  lock_nn_2 = mkN "lock" neutrum ;
  lockbete_nn_1 = mkN "lockbete" ;
  lockdjur_nn_1 = mkN "lockdjur" neutrum ;
  lockelse_nn_1 = mkN "lockelse" "lockelser" ;
  lockfaagel_nn_1 = mkN "lockfеgel" ;
  lockfaerg_nn_1 = mkN "lockfдrg" "lockfдrger" ;
  lockig_av_1 = mkA "lockig" ;
  lockout_nn_1 = mkN "lockout" "lockouter" ;
  lockpris_nn_1 = mkN "lockpris" neutrum ;
  lockrop_nn_1 = mkN "lockrop" neutrum ;
  locktaang_nn_1 = mkN "locktеng" "locktдnger" ;
  loco_ab_1 = mkAdv "loco" ;
  lod_nn_1 = mkN "lod" neutrum ;
  lodare_nn_1 = mkN "lodare" "lodare" ;
  lodbar_av_1 = mkA "lodbar" ;
  lodenrock_nn_1 = mkN "lodenrock" ;
  lodis_nn_1 = mkN "lodis" ;
  lodjur_nn_1 = mkN "lodjur" neutrum ;
  lodlinje_nn_1 = mkN "lodlinje" "lodlinjer" ;
  lodplan_nn_1 = mkN "lodplan" neutrum ;
  lodraet_av_1 = mkA "lodrдt" ;
  lodskott_nn_1 = mkN "lodskott" neutrum ;
  lodstreck_nn_1 = mkN "lodstreck" neutrum ;
  loeddrig_av_1 = mkA "lцddrig" ;
  loedfog_nn_1 = mkN "lцdfog" ;
  loedig_av_1 = mkA "lцdig" ;
  loedkolv_nn_1 = mkN "lцdkolv" ;
  loedmetall_nn_1 = mkN "lцdmetall" "lцdmetaller" ;
  loedning_nn_1 = mkN "lцdning" ;
  loefte_nn_1 = mkN "lцfte" ;
  loeftesman_nn_1 = mkN "lцftesman" "lцftesmannen" "lцftesmдn" "lцftesmдnnen" ;
  loeftesrik_av_1 = mkA "lцftesrik" ;
  loeftesskrift_nn_1 = mkN "lцftesskrift" "lцftesskrifter" ;
  loegn_nn_1 = mkN "lцgn" "lцgner" ;
  loegnaktig_av_1 = mkA "lцgnaktig" ;
  loegnare_nn_1 = mkN "lцgnare" "lцgnare" ;
  loegndetektor_nn_1 = mkN "lцgndetektor" "lцgndetektorer" ;
  loegnhals_nn_1 = mkN "lцgnhals" ;
  loegnkampanj_nn_1 = mkN "lцgnkampanj" "lцgnkampanjer" ;
  loeje_nn_1 = mkN "lцje" ;
  loejevaeckande_av_1 = mkA "lцjevдckande" ;
  loejlig_av_1 = mkA "lцjlig" ;
  loejlighet_nn_1 = mkN "lцjlighet" "lцjligheter" ;
  loejtnant_nn_1 = mkN "lцjtnant" "lцjtnanter" ;
  loek_nn_1 = mkN "lцk" ;
  loekfjaell_nn_1 = mkN "lцkfjдll" neutrum ;
  loekformig_av_1 = mkA "lцkformig" ;
  loekknopp_nn_1 = mkN "lцkknopp" ;
  loekkupol_nn_1 = mkN "lцkkupol" "lцkkupoler" ;
  loeksill_nn_1 = mkN "lцksill" ;
  loekstam_nn_1 = mkN "lцkstam" "lцkstammen" "lцkstammar" "lцkstammarna" ;
  loekvaext_nn_1 = mkN "lцkvдxt" "lцkvдxter" ;
  loemsk_av_1 = mkA "lцmsk" ;
  loen_nn_1 = mkN "lцn" "lцner" ;
  loenande_av_1 = mkA "lцnande" ;
  loeneanspraak_nn_1 = mkN "lцneansprеk" neutrum ;
  loenearbetare_nn_1 = mkN "lцnearbetare" "lцnearbetare" ;
  loeneavdrag_nn_1 = mkN "lцneavdrag" neutrum ;
  loeneavtal_nn_1 = mkN "lцneavtal" "lцneavtalet" "lцneavtalen" "lцneavtalena" ;
  loenebesked_nn_1 = mkN "lцnebesked" neutrum ;
  loenebidrag_nn_1 = mkN "lцnebidrag" neutrum ;
  loenefil_nn_1 = mkN "lцnefil" "lцnefiler" ;
  loenefoerhoejning_nn_1 = mkN "lцnefцrhцjning" ;
  loenefoermaan_nn_1 = mkN "lцnefцrmеn" "lцnefцrmеner" ;
  loenegaranti_nn_1 = mkN "lцnegaranti" "lцnegarantier" ;
  loeneglidning_nn_1 = mkN "lцneglidning" ;
  loenegrad_nn_1 = mkN "lцnegrad" "lцnegrader" ;
  loenehoejning_nn_1 = mkN "lцnehцjning" ;
  loeneklass_nn_1 = mkN "lцneklass" "lцneklasser" ;
  loenekostnad_nn_1 = mkN "lцnekostnad" "lцnekostnader" ;
  loenekuvert_nn_1 = mkN "lцnekuvert" neutrum ;
  loenelaege_nn_1 = mkN "lцnelдge" ;
  loenelyft_nn_1 = mkN "lцnelyft" neutrum ;
  loenenivaa_nn_1 = mkN "lцnenivе" "lцnenivеer" ;
  loeneoekning_nn_1 = mkN "lцneцkning" ;
  loenepaaslag_nn_1 = mkN "lцnepеslag" neutrum ;
  loeneplan_nn_1 = mkN "lцneplan" "lцneplaner" ;
  loeneroerelse_nn_1 = mkN "lцnerцrelse" "lцnerцrelser" ;
  loenesaettning_nn_1 = mkN "lцnesдttning" ;
  loeneslav_nn_1 = mkN "lцneslav" ;
  loenestopp_nn_1 = mkN "lцnestopp" neutrum ;
  loenetak_nn_1 = mkN "lцnetak" neutrum ;
  loenetillaegg_nn_1 = mkN "lцnetillдgg" neutrum ;
  loeneuppgift_nn_1 = mkN "lцneuppgift" "lцneuppgifter" ;
  loeneutveckling_nn_1 = mkN "lцneutveckling" ;
  loening_nn_1 = mkN "lцning" ;
  loenloes_av_1 = mkA "lцnlцs" ;
  loenn_nn_1 = mkN "lцnn" ;
  loennbraenning_nn_1 = mkN "lцnnbrдnning" ;
  loennfack_nn_1 = mkN "lцnnfack" neutrum ;
  loennfet_av_1 = mkA "lцnnfet" ;
  loennkrog_nn_1 = mkN "lцnnkrog" ;
  loennlig_av_1 = mkA "lцnnlig" ;
  loennligen_ab_1 = mkAdv "lцnnligen" ;
  loennmord_nn_1 = mkN "lцnnmord" neutrum ;
  loensam_av_1 = mkA "lцnsam" "lцnsamt" "lцnsamma" "lцnsamma" "lцnsammare" "lцnsammast" "lцnsammaste" ;
  loensamhet_nn_1 = mkN "lцnsamhet" "lцnsamheter" ;
  loenskalaege_nn_1 = mkN "lцnskalдge" ;
  loensparande_nn_1 = mkN "lцnsparande" ;
  loent_av_1 = mkA "lцnt" ;
  loentagare_nn_1 = mkN "lцntagare" "lцntagare" ;
  loentagarfond_nn_1 = mkN "lцntagarfond" "lцntagarfonder" ;
  loep_nn_1 = mkN "lцp" neutrum ;
  loepa_vb_1 = mkV "lцper" ;
  loepande_av_1 = mkA "lцpande" ;
  loepare_nn_1 = mkN "lцpare" "lцpare" ;
  loeparsten_nn_1 = mkN "lцparsten" "lцparstenen" "lцparstenar" "lцparstenarna" ;
  loepeld_nn_1 = mkN "lцpeld" ;
  loepeost_nn_1 = mkN "lцpeost" ;
  loepgrav_nn_1 = mkN "lцpgrav" ;
  loephjul_nn_1 = mkN "lцphjul" neutrum ;
  loepknut_nn_1 = mkN "lцpknut" ;
  loepmage_nn_1 = mkN "lцpmage" utrum ;
  loepmeter_nn_1 = mkN "lцpmeter" "lцpmetern" "lцpmeter" "lцpmeterna" ;
  loepning_nn_1 = mkN "lцpning" ;
  loepord_nn_1 = mkN "lцpord" neutrum ;
  loepost_nn_1 = mkN "lцpost" ;
  loepring_nn_1 = mkN "lцpring" ;
  loepsedel_nn_1 = mkN "lцpsedel" ;
  loepsk_av_1 = mkA "lцpsk" ;
  loepskift_nn_1 = mkN "lцpskift" neutrum ;
  loepsteg_nn_1 = mkN "lцpsteg" neutrum ;
  loepsten_nn_1 = mkN "lцpsten" "lцpstenen" "lцpstenar" "lцpstenarna" ;
  loeptid_nn_1 = mkN "lцptid" "lцptider" ;
  loepvagn_nn_1 = mkN "lцpvagn" ;
  loepvikt_nn_1 = mkN "lцpvikt" "lцpvikter" ;
  loerdag_nn_1 = mkN "lцrdag" ;
  loerdagskvaell_nn_1 = mkN "lцrdagskvдll" ;
  loerdagsmorgon_nn_1 = mkN "lцrdagsmorgon" "lцrdagsmorgonen" "lцrdagsmorgnar" "lцrdagsmorgnarna" ;
  loerdagsoeppen_av_1 = mkA "lцrdagsцppen" "lцrdagsцppet" ;
  loerdagsstaengd_av_1 = mkA "lцrdagsstдngd" "lцrdagsstдngt" ;
  loes_av_1 = mkA "lцs" ;
  loesaktig_av_1 = mkA "lцsaktig" ;
  loesan_av_1 = mkA "lцsan" ;
  loesande_av_1 = mkA "lцsande" ;
  loesbar_av_1 = mkA "lцsbar" ;
  loesbladssystem_nn_1 = mkN "lцsbladssystem" neutrum ;
  loesdrivare_nn_1 = mkN "lцsdrivare" "lцsdrivare" ;
  loesegendom_nn_1 = mkN "lцsegendom" ;
  loesenord_nn_1 = mkN "lцsenord" neutrum ;
  loesepenning_nn_1 = mkN "lцsepenning" ;
  loeseskilling_nn_1 = mkN "lцseskilling" ;
  loesesumma_nn_1 = mkN "lцsesumma" ;
  loesfynd_nn_1 = mkN "lцsfynd" neutrum ;
  loesgaaende_av_1 = mkA "lцsgеende" ;
  loesgom_nn_1 = mkN "lцsgom" "lцsgommen" "lцsgommar" "lцsgommarna" ;
  loeshaar_nn_1 = mkN "lцshеr" neutrum ;
  loeshaest_nn_1 = mkN "lцshдst" ;
  loeskekarl_nn_1 = mkN "lцskekarl" ;
  loeskokt_av_1 = mkA "lцskokt" "lцskokt" ;
  loeslig_av_1 = mkA "lцslig" ;
  loeslighet_nn_1 = mkN "lцslighet" "lцsligheter" ;
  loesmynt_av_1 = mkA "lцsmynt" "lцsmynt" ;
  loesning_nn_1 = mkN "lцsning" ;
  loesningsegenskap_nn_1 = mkN "lцsningsegenskap" "lцsningsegenskaper" ;
  loesningsmedel_nn_1 = mkN "lцsningsmedel" neutrum ;
  loesnummer_nn_1 = mkN "lцsnummer" neutrum ;
  loesoere_nn_1 = mkN "lцsцre" ;
  loesoerekoep_nn_1 = mkN "lцsцrekцp" neutrum ;
  loesryckt_av_1 = mkA "lцsryckt" "lцsryckt" ;
  loesrygg_nn_1 = mkN "lцsrygg" ;
  loessjord_nn_1 = mkN "lцssjord" ;
  loesslaeppt_av_1 = mkA "lцsslдppt" "lцsslдppt" ;
  loestagbar_av_1 = mkA "lцstagbar" ;
  loet_nn_1 = mkN "lцt" ;
  loev_nn_1 = mkN "lцv" neutrum ;
  loevaeng_nn_1 = mkN "lцvдng" ;
  loevbiff_nn_1 = mkN "lцvbiff" ;
  loevblandskog_nn_1 = mkN "lцvblandskog" ;
  loevfaellning_nn_1 = mkN "lцvfдllning" ;
  loevfoder_nn_1 = mkN "lцvfoder" neutrum ;
  loevhyddohoegtid_nn_1 = mkN "lцvhyddohцgtid" "lцvhyddohцgtider" ;
  loevjord_nn_1 = mkN "lцvjord" ;
  loevklaedd_av_1 = mkA "lцvklдdd" "lцvklдdtt" ;
  loevmask_nn_1 = mkN "lцvmask" ;
  loevsaag_nn_1 = mkN "lцvsеg" ;
  loevsaagning_nn_1 = mkN "lцvsеgning" ;
  loevsaangare_nn_1 = mkN "lцvsеngare" "lцvsеngare" ;
  loevsal_nn_1 = mkN "lцvsal" ;
  loevskog_nn_1 = mkN "lцvskog" ;
  loevsmyg_nn_1 = mkN "lцvsmyg" ;
  loevsprickning_nn_1 = mkN "lцvsprickning" ;
  loevtaekt_nn_1 = mkN "lцvtдkt" "lцvtдkter" ;
  loevtraed_nn_1 = mkN "lцvtrдd" neutrum ;
  loevtunn_av_1 = mkA "lцvtunn" "lцvtunt" ;
  loevverk_nn_1 = mkN "lцvverk" neutrum ;
  loft_nn_1 = mkN "loft" neutrum ;
  loftbod_nn_1 = mkN "loftbod" ;
  loftgaang_nn_1 = mkN "loftgеng" ;
  logaritm_nn_1 = mkN "logaritm" "logaritmer" ;
  logaritmisk_av_1 = mkA "logaritmisk" ;
  logaritmsystem_nn_1 = mkN "logaritmsystem" neutrum ;
  loge_nn_1 = mkN "loge" utrum ;
  loge_nn_2 = mkN "loge" "loger" ;
  logement_nn_1 = mkN "logement" "logementet" "logementen" "logementena" ;
  logg_nn_1 = mkN "logg" ;
  loggbok_nn_1 = mkN "loggbok" "loggbцcker" ;
  loggert_nn_1 = mkN "loggert" ;
  loggertsegel_nn_1 = mkN "loggertsegel" neutrum ;
  logglas_nn_1 = mkN "logglas" neutrum ;
  logi_nn_1 = mkN "logi" "logiet" "logier" "logierna" ;
  logiker_nn_1 = mkN "logiker" "logikern" "logiker" "logikerna" ;
  logisk_av_1 = mkA "logisk" ;
  logografisk_av_1 = mkA "logografisk" ;
  logogram_nn_1 = mkN "logogram" "logogrammet" "logogram" "logogrammen" ;
  logoped_nn_1 = mkN "logoped" "logopeder" ;
  logopedisk_av_1 = mkA "logopedisk" ;
  logotyp_nn_1 = mkN "logotyp" "logotyper" ;
  loj_av_1 = mkA "loj" ;
  lojal_av_1 = mkA "lojal" ;
  lojalitet_nn_1 = mkN "lojalitet" "lojaliteter" ;
  lojalitetsfoerklaring_nn_1 = mkN "lojalitetsfцrklaring" ;
  lok_nn_1 = mkN "lok" neutrum ;
  lokal_av_1 = mkA "lokal" ;
  lokal_nn_1 = mkN "lokal" "lokaler" ;
  lokalavdelning_nn_1 = mkN "lokalavdelning" ;
  lokalbedoevning_nn_1 = mkN "lokalbedцvning" ;
  lokalfaerg_nn_1 = mkN "lokalfдrg" "lokalfдrger" ;
  lokalisering_nn_1 = mkN "lokalisering" ;
  lokaliseringsstoed_nn_1 = mkN "lokaliseringsstцd" neutrum ;
  lokalitet_nn_1 = mkN "lokalitet" "lokaliteter" ;
  lokalkaennedom_nn_1 = mkN "lokalkдnnedom" ;
  lokalombud_nn_1 = mkN "lokalombud" neutrum ;
  lokalpatriot_nn_1 = mkN "lokalpatriot" "lokalpatrioter" ;
  lokalredaktoer_nn_1 = mkN "lokalredaktцr" "lokalredaktцrer" ;
  lokalsamtal_nn_1 = mkN "lokalsamtal" "lokalsamtalet" "lokalsamtalen" "lokalsamtalena" ;
  lokaltaag_nn_1 = mkN "lokaltеg" neutrum ;
  lokaltelefon_nn_1 = mkN "lokaltelefon" "lokaltelefoner" ;
  lokaltid_nn_1 = mkN "lokaltid" "lokaltider" ;
  lokalvaardare_nn_1 = mkN "lokalvеrdare" "lokalvеrdare" ;
  lokativ_nn_1 = mkN "lokativ" "lokativer" ;
  lokatt_nn_1 = mkN "lokatt" "lokatter" ;
  lokfoerare_nn_1 = mkN "lokfцrare" "lokfцrare" ;
  loko_ab_1 = mkAdv "loko" ;
  lokomobil_nn_1 = mkN "lokomobil" "lokomobiler" ;
  lokomotiv_nn_1 = mkN "lokomotiv" neutrum ;
  lokomotor_nn_1 = mkN "lokomotor" "lokomotorer" ;
  lokus_nn_1 = mkN "lokus" neutrum ;
  lom_nn_1 = mkN "lom" "lommen" "lommar" "lommarna" ;
  lomhoerd_av_1 = mkA "lomhцrd" "lomhцrt" ;
  longitud_nn_1 = mkN "longitud" "longituder" ;
  longitudinal_av_1 = mkA "longitudinal" ;
  longitudinell_av_1 = mkA "longitudinell" ;
  longoer_nn_1 = mkN "longцr" "longцrer" ;
  look_nn_1 = mkN "look" ;
  loop_nn_1 = mkN "loop" ;
  looping_nn_1 = mkN "looping" ;
  lopp_nn_1 = mkN "lopp" neutrum ;
  loppcirkus_nn_1 = mkN "loppcirkus" ;
  loppmarknad_nn_1 = mkN "loppmarknad" "loppmarknader" ;
  loppspel_nn_1 = mkN "loppspel" "loppspelet" "loppspel" "loppspelen" ;
  lord_nn_1 = mkN "lord" "lorder" ;
  lordkansler_nn_1 = mkN "lordkansler" "lordkanslern" "lordkanslerer" "lordkanslererna" ;
  lornjett_nn_1 = mkN "lornjett" "lornjetter" ;
  lort_nn_1 = mkN "lort" ;
  lortig_av_1 = mkA "lortig" ;
  loss_ab_1 = mkAdv "loss" ;
  lossning_nn_1 = mkN "lossning" ;
  lots_nn_1 = mkN "lots" ;
  lotsdistrikt_nn_1 = mkN "lotsdistrikt" neutrum ;
  lotshjaelp_nn_1 = mkN "lotshjдlp" ;
  lotsled_nn_1 = mkN "lotsled" "lotsleder" ;
  lotsning_nn_1 = mkN "lotsning" ;
  lotsplats_nn_1 = mkN "lotsplats" "lotsplatser" ;
  lotssignal_nn_1 = mkN "lotssignal" "lotssignaler" ;
  lott_nn_1 = mkN "lott" "lotter" ;
  lottakaar_nn_1 = mkN "lottakеr" "lottakеrer" ;
  lottaroerelse_nn_1 = mkN "lottarцrelse" "lottarцrelser" ;
  lottdragning_nn_1 = mkN "lottdragning" ;
  lotteri_nn_1 = mkN "lotteri" "lotterit" "lotterier" "lotterierna" ;
  lottloes_av_1 = mkA "lottlцs" ;
  lottsedel_nn_1 = mkN "lottsedel" ;
  lotus_nn_1 = mkN "lotus" ;
  lov_nn_1 = mkN "lov" ;
  lov_nn_3 = mkN "lov" neutrum ;
  lovande_av_1 = mkA "lovande" ;
  love_nn_1 = mkN "love" utrum ;
  lovgirig_av_1 = mkA "lovgirig" ;
  lovlig_av_1 = mkA "lovlig" ;
  lovord_nn_1 = mkN "lovord" neutrum ;
  lovpsalm_nn_1 = mkN "lovpsalm" "lovpsalmer" ;
  lovsaang_nn_1 = mkN "lovsеng" "lovsеnger" ;
  lovsjunga_vb_1 = mkV "lovsjunga" "lovsjцng" "lovsjungit" ;
  lovtal_nn_1 = mkN "lovtal" "lovtalet" "lovtalen" "lovtalena" ;
  lovvaerd_av_1 = mkA "lovvдrd" "lovvдrt" ;
  loxodrom_nn_1 = mkN "loxodrom" "loxodromer" ;
  lubb_nn_1 = mkN "lubb" ;
  lubrikator_nn_1 = mkN "lubrikator" "lubrikatorer" ;
  luciafest_nn_1 = mkN "luciafest" "luciafester" ;
  luciakrans_nn_1 = mkN "luciakrans" ;
  luciamorgon_nn_1 = mkN "luciamorgon" "luciamorgonen" "luciamorgnar" "luciamorgnarna" ;
  luciasaang_nn_1 = mkN "luciasеng" "luciasеnger" ;
  luciataag_nn_1 = mkN "luciatеg" neutrum ;
  lucker_av_1 = mkA "lucker" "luckert" "luckra" "luckra" "luckrare" "luckrast" "luckraste" ;
  luddig_av_1 = mkA "luddig" ;
  luden_av_1 = mkA "luden" "ludet" ;
  luder_nn_1 = mkN "luder" neutrum ;
  luetisk_av_1 = mkA "luetisk" ;
  luffare_nn_1 = mkN "luffare" "luffare" ;
  lufsig_av_1 = mkA "lufsig" ;
  luft_nn_1 = mkN "luft" "lufter" ;
  luftaffaer_nn_1 = mkN "luftaffдr" "luftaffдrer" ;
  luftakrobat_nn_1 = mkN "luftakrobat" "luftakrobater" ;
  luftande_nn_1 = mkN "luftande" utrum ;
  luftanfall_nn_1 = mkN "luftanfall" neutrum ;
  luftattack_nn_1 = mkN "luftattack" "luftattacker" ;
  luftballong_nn_1 = mkN "luftballong" "luftballonger" ;
  luftbevakning_nn_1 = mkN "luftbevakning" ;
  luftboll_nn_1 = mkN "luftboll" ;
  luftbro_nn_1 = mkN "luftbro" ;
  luftbubbla_nn_1 = mkN "luftbubbla" ;
  luftburen_av_1 = mkA "luftburen" "luftburet" ;
  luftdrag_nn_1 = mkN "luftdrag" neutrum ;
  luftemboli_nn_1 = mkN "luftemboli" "luftembolier" ;
  luftfaerd_nn_1 = mkN "luftfдrd" "luftfдrder" ;
  luftfarkost_nn_1 = mkN "luftfarkost" "luftfarkoster" ;
  luftfartyg_nn_1 = mkN "luftfartyg" neutrum ;
  luftfilter_nn_1 = mkN "luftfilter" neutrum ;
  luftfjaedring_nn_1 = mkN "luftfjдdring" ;
  luftfoerorening_nn_1 = mkN "luftfцrorening" ;
  luftfuktare_nn_1 = mkN "luftfuktare" "luftfuktare" ;
  luftfuktighet_nn_1 = mkN "luftfuktighet" "luftfuktigheter" ;
  luftgap_nn_1 = mkN "luftgap" neutrum ;
  luftgevaer_nn_1 = mkN "luftgevдr" neutrum ;
  luftgrop_nn_1 = mkN "luftgrop" ;
  lufthav_nn_1 = mkN "lufthav" neutrum ;
  luftig_av_1 = mkA "luftig" ;
  luftkonditionering_nn_1 = mkN "luftkonditionering" ;
  luftkub_nn_1 = mkN "luftkub" "luftkuber" ;
  luftkudde_nn_1 = mkN "luftkudde" utrum ;
  luftkuddefarkost_nn_1 = mkN "luftkuddefarkost" "luftkuddefarkoster" ;
  luftkyld_av_1 = mkA "luftkyld" "luftkylt" ;
  luftlager_nn_1 = mkN "luftlager" neutrum ;
  luftled_nn_1 = mkN "luftled" "luftleder" ;
  luftledes_ab_1 = mkAdv "luftledes" ;
  luftledning_nn_1 = mkN "luftledning" ;
  luftmadrass_nn_1 = mkN "luftmadrass" "luftmadrasser" ;
  luftmaengd_nn_1 = mkN "luftmдngd" "luftmдngder" ;
  luftmast_nn_1 = mkN "luftmast" "luftmaster" ;
  luftombyte_nn_1 = mkN "luftombyte" ;
  luftperspektiv_nn_1 = mkN "luftperspektiv" neutrum ;
  luftpistol_nn_1 = mkN "luftpistol" "luftpistoler" ;
  luftpropeller_nn_1 = mkN "luftpropeller" ;
  luftpump_nn_1 = mkN "luftpump" ;
  luftrenare_nn_1 = mkN "luftrenare" "luftrenare" ;
  luftroer_nn_1 = mkN "luftrцr" neutrum ;
  luftroerskatarr_nn_1 = mkN "luftrцrskatarr" "luftrцrskatarrer" ;
  luftrot_nn_1 = mkN "luftrot" "luftrцtter" ;
  luftrum_nn_1 = mkN "luftrum" "luftrummet" "luftrum" "luftrummen" ;
  luftsaeck_nn_1 = mkN "luftsдck" ;
  luftskalle_nn_1 = mkN "luftskalle" utrum ;
  luftskepp_nn_1 = mkN "luftskepp" neutrum ;
  luftskikt_nn_1 = mkN "luftskikt" neutrum ;
  luftslott_nn_1 = mkN "luftslott" neutrum ;
  luftsluss_nn_1 = mkN "luftsluss" ;
  luftspaerr_nn_1 = mkN "luftspдrr" ;
  luftstroem_nn_1 = mkN "luftstrцm" "luftstrцmmen" "luftstrцmmar" "luftstrцmmarna" ;
  luftstrupe_nn_1 = mkN "luftstrupe" utrum ;
  lufttaet_av_1 = mkA "lufttдt" ;
  lufttemperatur_nn_1 = mkN "lufttemperatur" "lufttemperaturer" ;
  lufttom_av_1 = mkA "lufttom" "lufttomt" "lufttomma" "lufttomma" "lufttommare" "lufttommast" "lufttommaste" ;
  lufttryck_nn_1 = mkN "lufttryck" neutrum ;
  luftvaeg_nn_1 = mkN "luftvдg" ;
  luftvaern_nn_1 = mkN "luftvдrn" neutrum ;
  luftvaernskanon_nn_1 = mkN "luftvдrnskanon" "luftvдrnskanoner" ;
  luftvaernsrobot_nn_1 = mkN "luftvдrnsrobot" ;
  luftvaexling_nn_1 = mkN "luftvдxling" ;
  luftventil_nn_1 = mkN "luftventil" "luftventiler" ;
  lugg_nn_1 = mkN "lugg" ;
  luggig_av_1 = mkA "luggig" ;
  luggsliten_av_1 = mkA "luggsliten" "luggslitet" ;
  lugn_av_1 = mkA "lugn" ;
  lugnande_av_1 = mkA "lugnande" ;
  lugnvatten_nn_1 = mkN "lugnvatten" "lugnvattnet" "lugnvatten" "lugnvattnen" ;
  luguber_av_1 = mkA "luguber" "lugubert" "lugubra" "lugubra" "lugubrare" "lugubrast" "lugubraste" ;
  lukrativ_av_1 = mkA "lukrativ" ;
  lukt_nn_1 = mkN "lukt" "lukter" ;
  luktaert_nn_1 = mkN "luktдrt" "luktдrter" ;
  luktfri_av_1 = mkA "luktfri" "luktfritt" ;
  luktnerv_nn_1 = mkN "luktnerv" "luktnerver" ;
  luktsinne_nn_1 = mkN "luktsinne" ;
  luktvatten_nn_1 = mkN "luktvatten" "luktvattnet" "luktvatten" "luktvattnen" ;
  luktvial_nn_1 = mkN "luktvial" "luktvialer" ;
  luktviol_nn_1 = mkN "luktviol" "luktvioler" ;
  lukullisk_av_1 = mkA "lukullisk" ;
  lull_ab_1 = mkAdv "lull" ;
  lullig_av_1 = mkA "lullig" ;
  lumbal_av_1 = mkA "lumbal" ;
  lumbalbedoevning_nn_1 = mkN "lumbalbedцvning" ;
  lumbalpunktion_nn_1 = mkN "lumbalpunktion" "lumbalpunktioner" ;
  lumen_nn_1 = mkN "lumen" "lumenen" "lumen" "lumenen" ;
  lumen_nn_2 = mkN "lumen" neutrum ;
  luminoes_av_1 = mkA "luminцs" ;
  lummervaext_nn_1 = mkN "lummervдxt" "lummervдxter" ;
  lummig_av_1 = mkA "lummig" ;
  lumpen_av_1 = mkA "lumpen" "lumpet" ;
  lumpfisk_nn_1 = mkN "lumpfisk" ;
  lumpig_av_1 = mkA "lumpig" ;
  lunar_av_1 = mkA "lunar" ;
  lunarisk_av_1 = mkA "lunarisk" ;
  lunation_nn_1 = mkN "lunation" "lunationer" ;
  lunch_nn_1 = mkN "lunch" "luncher" ;
  lunchbord_nn_1 = mkN "lunchbord" neutrum ;
  lunchrestaurang_nn_1 = mkN "lunchrestaurang" "lunchrestauranger" ;
  lunchrum_nn_1 = mkN "lunchrum" "lunchrummet" "lunchrum" "lunchrummen" ;
  lund_nn_1 = mkN "lund" ;
  lundensisk_av_1 = mkA "lundensisk" ;
  lungandande_av_1 = mkA "lungandande" ;
  lungbyte_nn_1 = mkN "lungbyte" ;
  lungemboli_nn_1 = mkN "lungemboli" "lungembolier" ;
  lungfisk_nn_1 = mkN "lungfisk" ;
  lunginflammation_nn_1 = mkN "lunginflammation" "lunginflammationer" ;
  lungkatarr_nn_1 = mkN "lungkatarr" "lungkatarrer" ;
  lunglob_nn_1 = mkN "lunglob" "lunglober" ;
  lungoedem_nn_1 = mkN "lungцdem" neutrum ;
  lungoert_nn_1 = mkN "lungцrt" "lungцrter" ;
  lungpulsaader_nn_1 = mkN "lungpulsеder" "lungpulsеdern" "lungpulsеdror" "lungpulsеdrorna" ;
  lungrot_nn_1 = mkN "lungrot" "lungrцtter" ;
  lungsaeck_nn_1 = mkN "lungsдck" ;
  lungsaecksinflammation_nn_1 = mkN "lungsдcksinflammation" "lungsдcksinflammationer" ;
  lungsiktig_av_1 = mkA "lungsiktig" ;
  lungsjukdom_nn_1 = mkN "lungsjukdom" ;
  lunne_nn_1 = mkN "lunne" utrum ;
  lunnefaagel_nn_1 = mkN "lunnefеgel" ;
  lunnkaelke_nn_1 = mkN "lunnkдlke" utrum ;
  luns_nn_1 = mkN "luns" ;
  lunsig_av_1 = mkA "lunsig" ;
  luntlaas_nn_1 = mkN "luntlеs" neutrum ;
  lupin_nn_1 = mkN "lupin" "lupiner" ;
  lupp_nn_1 = mkN "lupp" "lupper" ;
  lur_nn_1 = mkN "lur" ;
  lurendrejare_nn_1 = mkN "lurendrejare" "lurendrejare" ;
  lurendrejeri_nn_1 = mkN "lurendrejeri" "lurendrejerit" "lurendrejerier" "lurendrejerierna" ;
  lurifax_nn_1 = mkN "lurifax" ;
  lurig_av_1 = mkA "lurig" ;
  lurk_nn_1 = mkN "lurk" ;
  lurt_av_1 = mkA "lurt" ;
  lurvig_av_1 = mkA "lurvig" ;
  lus_nn_1 = mkN "lus" "lusen" "lцss" "lцssen" ;
  lusern_nn_1 = mkN "lusern" "luserner" ;
  luserngroenmjoel_nn_1 = mkN "luserngrцnmjцl" neutrum ;
  lusfattig_av_1 = mkA "lusfattig" ;
  lusig_av_1 = mkA "lusig" ;
  luskung_nn_1 = mkN "luskung" ;
  luspank_av_1 = mkA "luspank" ;
  luspudel_nn_1 = mkN "luspudel" ;
  lussefest_nn_1 = mkN "lussefest" "lussefester" ;
  lussekatt_nn_1 = mkN "lussekatt" "lussekatter" ;
  lust_nn_1 = mkN "lust" ;
  lustbarhet_nn_1 = mkN "lustbarhet" "lustbarheter" ;
  lustbehov_nn_1 = mkN "lustbehov" neutrum ;
  lustcentrum_nn_1 = mkN "lustcentrum" neutrum ;
  lustelig_av_1 = mkA "lustelig" ;
  lustfylld_av_1 = mkA "lustfylld" "lustfyllt" ;
  lustgaard_nn_1 = mkN "lustgеrd" ;
  lustgas_nn_1 = mkN "lustgas" "lustgaser" ;
  lusthus_nn_1 = mkN "lusthus" neutrum ;
  lustig_av_1 = mkA "lustig" ;
  lustighet_nn_1 = mkN "lustighet" "lustigheter" ;
  lustigkurre_nn_1 = mkN "lustigkurre" utrum ;
  lustimpuls_nn_1 = mkN "lustimpuls" "lustimpulser" ;
  lustjakt_nn_1 = mkN "lustjakt" "lustjakter" ;
  lustkaensla_nn_1 = mkN "lustkдnsla" ;
  lustloegnare_nn_1 = mkN "lustlцgnare" "lustlцgnare" ;
  lustmoerdare_nn_1 = mkN "lustmцrdare" "lustmцrdare" ;
  lustmord_nn_1 = mkN "lustmord" neutrum ;
  lustslott_nn_1 = mkN "lustslott" neutrum ;
  lustspel_nn_1 = mkN "lustspel" "lustspelet" "lustspel" "lustspelen" ;
  lustupplevelse_nn_1 = mkN "lustupplevelse" "lustupplevelser" ;
  lut_nn_1 = mkN "lut" ;
  lutfisk_nn_1 = mkN "lutfisk" ;
  lutheran_nn_1 = mkN "lutheran" "lutheraner" ;
  lutherdom_nn_1 = mkN "lutherdom" ;
  luthersk_av_1 = mkA "luthersk" ;
  lutning_nn_1 = mkN "lutning" ;
  lutningsmaetare_nn_1 = mkN "lutningsmдtare" "lutningsmдtare" ;
  lutningsstreck_nn_1 = mkN "lutningsstreck" neutrum ;
  lutningsvariation_nn_1 = mkN "lutningsvariation" "lutningsvariationer" ;
  lutsaangare_nn_1 = mkN "lutsеngare" "lutsеngare" ;
  lutter_av_1 = mkA "lutter" ;
  luv_nn_1 = mkN "luv" ;
  lux_nn_1 = mkN "lux" "luxen" "lux" "luxen" ;
  luxation_nn_1 = mkN "luxation" "luxationer" ;
  luxemburgare_nn_1 = mkN "luxemburgare" "luxemburgare" ;
  luxemburgsk_av_1 = mkA "luxemburgsk" ;
  luxmeter_nn_1 = mkN "luxmeter" ;
  luxuoes_av_1 = mkA "luxuцs" ;
  lyceum_nn_1 = mkN "lyceum" "lyceet" "lyceer" "lyceerna" ;
  lycka_nn_2 = mkN "lycka" ;
  lycklig_av_1 = mkA "lycklig" ;
  lyckligen_ab_1 = mkAdv "lyckligen" ;
  lyckligtvis_ab_1 = mkAdv "lyckligtvis" ;
  lyckobringande_av_1 = mkA "lyckobringande" ;
  lyckoenskning_nn_1 = mkN "lyckцnskning" ;
  lyckohjul_nn_1 = mkN "lyckohjul" neutrum ;
  lyckokast_nn_1 = mkN "lyckokast" neutrum ;
  lyckokloever_nn_1 = mkN "lyckoklцver" "lyckoklцvern" "lyckoklцver" "lyckoklцverna" ;
  lyckopiller_nn_1 = mkN "lyckopiller" neutrum ;
  lyckorike_nn_1 = mkN "lyckorike" ;
  lyckorus_nn_1 = mkN "lyckorus" neutrum ;
  lyckosam_av_1 = mkA "lyckosam" "lyckosamt" "lyckosamma" "lyckosamma" "lyckosammare" "lyckosammast" "lyckosammaste" ;
  lyckoslant_nn_1 = mkN "lyckoslant" ;
  lyckotal_nn_1 = mkN "lyckotal" "lyckotalet" "lyckotalen" "lyckotalena" ;
  lycksalig_av_1 = mkA "lycksalig" ;
  lycksoekare_nn_1 = mkN "lycksцkare" "lycksцkare" ;
  lycktraeff_nn_1 = mkN "lycktrдff" ;
  lyda_vb_1 = mkV "lyda" "lydde" "lytt" ;
  lydaktig_av_1 = mkA "lydaktig" ;
  lydelse_nn_1 = mkN "lydelse" "lydelser" ;
  lydfolk_nn_1 = mkN "lydfolk" neutrum ;
  lydig_av_1 = mkA "lydig" ;
  lydkonung_nn_1 = mkN "lydkonung" ;
  lydnad_nn_1 = mkN "lydnad" "lydnader" ;
  lydnadsbrott_nn_1 = mkN "lydnadsbrott" neutrum ;
  lydstat_nn_1 = mkN "lydstat" "lydstater" ;
  lyft_nn_1 = mkN "lyft" neutrum ;
  lyftanordning_nn_1 = mkN "lyftanordning" ;
  lyftarm_nn_1 = mkN "lyftarm" ;
  lyftblock_nn_1 = mkN "lyftblock" neutrum ;
  lyftbro_nn_1 = mkN "lyftbro" ;
  lyftkraft_nn_1 = mkN "lyftkraft" "lyftkrafter" ;
  lyftkran_nn_1 = mkN "lyftkran" ;
  lyftkrok_nn_1 = mkN "lyftkrok" ;
  lyftsax_nn_1 = mkN "lyftsax" ;
  lyftverk_nn_1 = mkN "lyftverk" neutrum ;
  lyhoerd_av_1 = mkA "lyhцrd" "lyhцrt" ;
  lyktbaerare_nn_1 = mkN "lyktbдrare" "lyktbдrare" ;
  lyktgubbe_nn_1 = mkN "lyktgubbe" utrum ;
  lyktrad_nn_1 = mkN "lyktrad" "lyktrader" ;
  lyktstolpe_nn_1 = mkN "lyktstolpe" utrum ;
  lymfatisk_av_1 = mkA "lymfatisk" ;
  lymfkaerl_nn_1 = mkN "lymfkдrl" neutrum ;
  lymfkoertel_nn_1 = mkN "lymfkцrtel" ;
  lymfliknande_av_1 = mkA "lymfliknande" ;
  lymfocyt_nn_1 = mkN "lymfocyt" "lymfocyter" ;
  lymmel_nn_1 = mkN "lymmel" "lymmeln" "lymmlar" "lymmlarna" ;
  lymmelaktig_av_1 = mkA "lymmelaktig" ;
  lynett_nn_1 = mkN "lynett" "lynetter" ;
  lynne_nn_1 = mkN "lynne" ;
  lynnesutbrott_nn_1 = mkN "lynnesutbrott" neutrum ;
  lynnig_av_1 = mkA "lynnig" ;
  lyrfaagel_nn_1 = mkN "lyrfеgel" ;
  lyrikaelskare_nn_1 = mkN "lyrikдlskare" "lyrikдlskare" ;
  lyriker_nn_1 = mkN "lyriker" "lyrikern" "lyriker" "lyrikerna" ;
  lyrisk_av_1 = mkA "lyrisk" ;
  lyrtorsk_nn_1 = mkN "lyrtorsk" ;
  lysaemne_nn_1 = mkN "lysдmne" ;
  lysande_av_1 = mkA "lysande" ;
  lysboj_nn_1 = mkN "lysboj" ;
  lysgas_nn_1 = mkN "lysgas" "lysgaser" ;
  lysin_nn_1 = mkN "lysin" "lysinet" "lysiner" "lysinerna" ;
  lysmask_nn_1 = mkN "lysmask" ;
  lysning_nn_1 = mkN "lysning" ;
  lysosom_nn_1 = mkN "lysosom" "lysosomer" ;
  lysozym_nn_1 = mkN "lysozym" neutrum ;
  lyspatron_nn_1 = mkN "lyspatron" "lyspatroner" ;
  lyspistol_nn_1 = mkN "lyspistol" "lyspistoler" ;
  lysraket_nn_1 = mkN "lysraket" "lysraketer" ;
  lysroer_nn_1 = mkN "lysrцr" neutrum ;
  lyssats_nn_1 = mkN "lyssats" "lyssatser" ;
  lyssnarapparat_nn_1 = mkN "lyssnarapparat" "lyssnarapparater" ;
  lyssnare_nn_1 = mkN "lyssnare" "lyssnare" ;
  lysten_av_1 = mkA "lysten" "lystet" ;
  lyster_nn_1 = mkN "lyster" ;
  lysterfaerg_nn_1 = mkN "lysterfдrg" "lysterfдrger" ;
  lystergarn_nn_1 = mkN "lystergarn" neutrum ;
  lystmaete_nn_1 = mkN "lystmдte" ;
  lystnad_nn_1 = mkN "lystnad" "lystnader" ;
  lyte_nn_1 = mkN "lyte" ;
  lytt_av_1 = mkA "lytt" ;
  lytt_av_2 = mkA "lytt" ;
  lyxartikel_nn_1 = mkN "lyxartikel" ;
  lyxbil_nn_1 = mkN "lyxbil" ;
  lyxfoerpackning_nn_1 = mkN "lyxfцrpackning" ;
  lyxhotell_nn_1 = mkN "lyxhotell" neutrum ;
  lyxhustru_nn_1 = mkN "lyxhustru" "lyxhustrun" "lyxhustrur" "lyxhustrurna" ;
  lyxig_av_1 = mkA "lyxig" ;
  lyxkryssare_nn_1 = mkN "lyxkryssare" "lyxkryssare" ;
  lyxliv_nn_1 = mkN "lyxliv" neutrum ;
  lyxskatt_nn_1 = mkN "lyxskatt" "lyxskatter" ;
  lyxtelegram_nn_1 = mkN "lyxtelegram" "lyxtelegrammet" "lyxtelegram" "lyxtelegrammen" ;
  maabaer_nn_1 = mkN "mеbдr" neutrum ;
  maabaersbuske_nn_1 = mkN "mеbдrsbuske" utrum ;
  maag_nn_1 = mkN "mеg" ;
  maahaenda_ab_1 = mkAdv "mеhдnda" ;
  maakare_nn_1 = mkN "mеkare" "mеkare" ;
  maal_nn_1 = mkN "mеl" neutrum ;
  maalande_av_1 = mkA "mеlande" ;
  maalangivning_nn_1 = mkN "mеlangivning" ;
  maalarbok_nn_1 = mkN "mеlarbok" "mеlarbцcker" ;
  maalarborste_nn_1 = mkN "mеlarborste" utrum ;
  maalarduk_nn_1 = mkN "mеlarduk" ;
  maalare_nn_1 = mkN "mеlare" "mеlare" ;
  maalarfaerg_nn_1 = mkN "mеlarfдrg" "mеlarfдrger" ;
  maalarkludd_nn_1 = mkN "mеlarkludd" ;
  maalarmaestare_nn_1 = mkN "mеlarmдstare" "mеlarmдstare" ;
  maalarrock_nn_1 = mkN "mеlarrock" ;
  maalarstaellning_nn_1 = mkN "mеlarstдllning" ;
  maalbrottsroest_nn_1 = mkN "mеlbrottsrцst" "mеlbrottsrцster" ;
  maalbur_nn_1 = mkN "mеlbur" ;
  maalchans_nn_1 = mkN "mеlchans" "mеlchanser" ;
  maaldomare_nn_1 = mkN "mеldomare" "mеldomare" ;
  maaleri_nn_1 = mkN "mеleri" "mеlerit" "mеlerier" "mеlerierna" ;
  maalerisk_av_1 = mkA "mеlerisk" ;
  maalfarlig_av_1 = mkA "mеlfarlig" ;
  maalfigur_nn_1 = mkN "mеlfigur" "mеlfigurer" ;
  maalforskning_nn_1 = mkN "mеlforskning" ;
  maalfoto_nn_1 = mkN "mеlfoto" "mеlfotot" "mеlfoton" "mеlfotona" ;
  maalgaard_nn_1 = mkN "mеlgеrd" ;
  maalgivande_av_1 = mkA "mеlgivande" ;
  maalgrupp_nn_1 = mkN "mеlgrupp" "mеlgrupper" ;
  maalkamera_nn_1 = mkN "mеlkamera" ;
  maalkvot_nn_1 = mkN "mеlkvot" "mеlkvoter" ;
  maallinje_nn_1 = mkN "mеllinje" "mеllinjer" ;
  maalloes_av_1 = mkA "mеllцs" ;
  maalmedveten_av_1 = mkA "mеlmedveten" "mеlmedvetet" ;
  maalning_nn_1 = mkN "mеlning" ;
  maalomraade_nn_1 = mkN "mеlomrеde" ;
  maalsaegande_nn_1 = mkN "mеlsдgande" "mеlsдganden" "mеlsдgande" "mеlsдgandena" ;
  maalsaegare_nn_1 = mkN "mеlsдgare" "mеlsдgare" ;
  maalsaettning_nn_1 = mkN "mеlsдttning" ;
  maalskillnad_nn_1 = mkN "mеlskillnad" "mеlskillnader" ;
  maalskytt_nn_1 = mkN "mеlskytt" ;
  maalsman_nn_1 = mkN "mеlsman" "mеlsmannen" "mеlsmдn" "mеlsmдnnen" ;
  maalsoekande_av_1 = mkA "mеlsцkande" ;
  maalsoekare_nn_1 = mkN "mеlsцkare" "mеlsцkare" ;
  maalspaning_nn_1 = mkN "mеlspaning" ;
  maalspottare_nn_1 = mkN "mеlspottare" "mеlspottare" ;
  maalspraak_nn_1 = mkN "mеlsprеk" neutrum ;
  maalstaellning_nn_1 = mkN "mеlstдllning" ;
  maalstolpe_nn_1 = mkN "mеlstolpe" utrum ;
  maalstyrning_nn_1 = mkN "mеlstyrning" ;
  maaltavla_nn_1 = mkN "mеltavla" ;
  maaltid_nn_1 = mkN "mеltid" "mеltider" ;
  maaltidsdryck_nn_1 = mkN "mеltidsdryck" "mеltidsdrycker" ;
  maalvakt_nn_1 = mkN "mеlvakt" "mеlvakter" ;
  maan_av_1 = mkA "mеn" ;
  maanaar_nn_1 = mkN "mеnеr" neutrum ;
  maanad_nn_1 = mkN "mеnad" "mеnader" ;
  maanadskort_nn_1 = mkN "mеnadskort" neutrum ;
  maanadsloen_nn_1 = mkN "mеnadslцn" "mеnadslцner" ;
  maanadsrasande_av_1 = mkA "mеnadsrasande" ;
  maanadsskifte_nn_1 = mkN "mеnadsskifte" ;
  maanadssmultron_nn_1 = mkN "mеnadssmultron" neutrum ;
  maanadsvis_ab_1 = mkAdv "mеnadsvis" ;
  maanadtal_nn_1 = mkN "mеnadtal" "mеnadtalet" "mеnadtalen" "mеnadtalena" ;
  maanatlig_av_1 = mkA "mеnatlig" ;
  maanatligen_ab_1 = mkAdv "mеnatligen" ;
  maanbaevning_nn_1 = mkN "mеnbдvning" ;
  maanbelyst_av_1 = mkA "mеnbelyst" "mеnbelyst" ;
  maancykel_nn_1 = mkN "mеncykel" ;
  maandag_nn_1 = mkN "mеndag" ;
  maandagsexemplar_nn_1 = mkN "mеndagsexemplar" neutrum ;
  maandagskvaell_nn_1 = mkN "mеndagskvдll" ;
  maandagsmorgon_nn_1 = mkN "mеndagsmorgon" "mеndagsmorgonen" "mеndagsmorgnar" "mеndagsmorgnarna" ;
  maandistans_nn_1 = mkN "mеndistans" "mеndistanser" ;
  maandygn_nn_1 = mkN "mеndygn" neutrum ;
  maane_nn_1 = mkN "mеne" utrum ;
  maanfas_nn_1 = mkN "mеnfas" "mеnfaser" ;
  maanflod_nn_1 = mkN "mеnflod" "mеnfloder" ;
  maanfoermoerkelse_nn_1 = mkN "mеnfцrmцrkelse" "mеnfцrmцrkelser" ;
  maangaard_nn_1 = mkN "mеngеrd" ;
  maangaarig_av_1 = mkA "mеngеrig" ;
  maangahanda_av_1 = mkA "mеngahanda" ;
  maangbesjungen_av_1 = mkA "mеngbesjungen" "mеngbesjunget" ;
  maangbyggare_nn_1 = mkN "mеngbyggare" "mеngbyggare" ;
  maangdubbel_av_1 = mkA "mеngdubbel" "mеngdubbelt" "mеngdubbla" "mеngdubbla" "mеngdubblare" "mеngdubblast" "mеngdubblaste" ;
  maangenstaedes_ab_1 = mkAdv "mеngenstдdes" ;
  maangfald_nn_1 = mkN "mеngfald" "mеngfalder" ;
  maangfaldig_av_1 = mkA "mеngfaldig" ;
  maangfalt_ab_1 = mkAdv "mеngfalt" ;
  maangformig_av_1 = mkA "mеngformig" ;
  maangformighet_nn_1 = mkN "mеngformighet" "mеngformigheter" ;
  maangfoting_nn_1 = mkN "mеngfoting" ;
  maangfrestande_av_1 = mkA "mеngfrestande" ;
  maangfrestare_nn_1 = mkN "mеngfrestare" "mеngfrestare" ;
  maanghoerning_nn_1 = mkN "mеnghцrning" ;
  maangkamp_nn_1 = mkN "mеngkamp" "mеngkamper" ;
  maangkunnig_av_1 = mkA "mеngkunnig" ;
  maanglare_nn_1 = mkN "mеnglare" "mеnglare" ;
  maangmiljonaer_nn_1 = mkN "mеngmiljonдr" "mеngmiljonдrer" ;
  maangordig_av_1 = mkA "mеngordig" ;
  maangsidig_av_1 = mkA "mеngsidig" ;
  maangsidighet_nn_1 = mkN "mеngsidighet" "mеngsidigheter" ;
  maangsiding_nn_1 = mkN "mеngsiding" ;
  maangskiftande_av_1 = mkA "mеngskiftande" ;
  maangstaemmig_av_1 = mkA "mеngstдmmig" ;
  maangstavig_av_1 = mkA "mеngstavig" ;
  maangsysslare_nn_1 = mkN "mеngsysslare" "mеngsysslare" ;
  maangtydig_av_1 = mkA "mеngtydig" ;
  maangtydighet_nn_1 = mkN "mеngtydighet" "mеngtydigheter" ;
  maangubbe_nn_1 = mkN "mеngubbe" utrum ;
  maangvetenskaplig_av_1 = mkA "mеngvetenskaplig" ;
  maanlandskap_nn_1 = mkN "mеnlandskap" "mеnlandskapet" "mеnlandskapen" "mеnlandskapena" ;
  maanliknande_av_1 = mkA "mеnliknande" ;
  maanljus_av_1 = mkA "mеnljus" ;
  maanne_ab_1 = mkAdv "mеnne" ;
  maanntro_ab_1 = mkAdv "mеnntro" ;
  maanskifte_nn_1 = mkN "mеnskifte" ;
  maansten_nn_1 = mkN "mеnsten" "mеnstenen" "mеnstenar" "mеnstenarna" ;
  maanvarv_nn_1 = mkN "mеnvarv" neutrum ;
  maanviol_nn_1 = mkN "mеnviol" "mеnvioler" ;
  maard_nn_1 = mkN "mеrd" ;
  maarddjur_nn_1 = mkN "mеrddjur" neutrum ;
  maas_nn_1 = mkN "mеs" ;
  maasfaagel_nn_1 = mkN "mеsfеgel" ;
  maatro_ab_1 = mkAdv "mеtro" ;
  maatt_nn_1 = mkN "mеtt" neutrum ;
  maattagning_nn_1 = mkN "mеttagning" ;
  maattband_nn_1 = mkN "mеttband" neutrum ;
  maattbestaelld_av_1 = mkA "mеttbestдlld" "mеttbestдllt" ;
  maattenhet_nn_1 = mkN "mеttenhet" "mеttenheter" ;
  maattfull_av_1 = mkA "mеttfull" ;
  maattlig_av_1 = mkA "mеttlig" ;
  maattlighet_nn_1 = mkN "mеttlighet" "mеttligheter" ;
  maattloes_av_1 = mkA "mеttlцs" ;
  maattsats_nn_1 = mkN "mеttsats" "mеttsatser" ;
  maattsenhet_nn_1 = mkN "mеttsenhet" "mеttsenheter" ;
  maattstock_nn_1 = mkN "mеttstock" ;
  maattsydd_av_1 = mkA "mеttsydd" "mеttsydtt" ;
  maattsystem_nn_1 = mkN "mеttsystem" neutrum ;
  maattverktyg_nn_1 = mkN "mеttverktyg" neutrum ;
  macedonisk_av_1 = mkA "macedonisk" ;
  macedonsk_av_1 = mkA "macedonsk" ;
  macedonska_nn_2 = mkN "macedonska" ;
  mach_nn_1 = mkN "mach" "machen" "mach" "machen" ;
  machete_nn_1 = mkN "machete" "macheter" ;
  machiavellisk_av_1 = mkA "machiavellisk" ;
  machiavellistisk_av_1 = mkA "machiavellistisk" ;
  machtal_nn_1 = mkN "machtal" "machtalet" "machtalen" "machtalena" ;
  machverk_nn_1 = mkN "machverk" neutrum ;
  mack_nn_1 = mkN "mack" ;
  mackapaer_nn_1 = mkN "mackapдr" "mackapдrer" ;
  mad_nn_1 = mkN "mad" "mader" ;
  madagask_nn_1 = mkN "madagask" "madagasker" ;
  madagaskisk_av_1 = mkA "madagaskisk" ;
  madam_nn_1 = mkN "madam" "madammen" "madammer" "madammerna" ;
  madapolam_nn_1 = mkN "madapolam" "madapolamer" ;
  madrass_nn_1 = mkN "madrass" "madrasser" ;
  madrassnaal_nn_1 = mkN "madrassnеl" ;
  madrigal_nn_1 = mkN "madrigal" "madrigaler" ;
  maduska_nn_1 = mkN "maduska" ;
  maehae_nn_1 = mkN "mдhд" "mдhдet" "mдhдn" "mдhдna" ;
  maeklararvode_nn_1 = mkN "mдklararvode" ;
  maeklare_nn_1 = mkN "mдklare" "mдklare" ;
  maekta_ab_1 = mkAdv "mдkta" ;
  maektig_av_1 = mkA "mдktig" ;
  maektighet_nn_1 = mkN "mдktighet" "mдktigheter" ;
  maektighet_nn_2 = mkN "mдktighet" "mдktigheter" ;
  maelarlandskap_nn_1 = mkN "mдlarlandskap" "mдlarlandskapet" "mдlarlandskapen" "mдlarlandskapena" ;
  maeld_nn_1 = mkN "mдld" "mдlder" ;
  maelteri_nn_1 = mkN "mдlteri" "mдlterit" "mдlterier" "mдlterierna" ;
  maengd_nn_1 = mkN "mдngd" "mдngder" ;
  maengddiagram_nn_1 = mkN "mдngddiagram" "mдngddiagrammet" "mдngddiagram" "mдngddiagrammen" ;
  maengdvis_ab_1 = mkAdv "mдngdvis" ;
  maenniska_nn_1 = mkN "mдnniska" ;
  maenniskoaetande_av_1 = mkA "mдnniskoдtande" ;
  maenniskoaetare_nn_1 = mkN "mдnniskoдtare" "mдnniskoдtare" ;
  maenniskobroest_nn_1 = mkN "mдnniskobrцst" neutrum ;
  maenniskofientlig_av_1 = mkA "mдnniskofientlig" ;
  maenniskofigur_nn_1 = mkN "mдnniskofigur" "mдnniskofigurer" ;
  maenniskofoster_nn_1 = mkN "mдnniskofoster" neutrum ;
  maenniskogestalt_nn_1 = mkN "mдnniskogestalt" "mдnniskogestalter" ;
  maenniskohaj_nn_1 = mkN "mдnniskohaj" ;
  maenniskohamn_nn_1 = mkN "mдnniskohamn" ;
  maenniskohand_nn_1 = mkN "mдnniskohand" "mдnniskohдnder" ;
  maenniskohatare_nn_1 = mkN "mдnniskohatare" "mдnniskohatare" ;
  maenniskojakt_nn_1 = mkN "mдnniskojakt" "mдnniskojakter" ;
  maenniskokaennare_nn_1 = mkN "mдnniskokдnnare" "mдnniskokдnnare" ;
  maenniskokaennedom_nn_1 = mkN "mдnniskokдnnedom" ;
  maenniskokaerlek_nn_1 = mkN "mдnniskokдrlek" ;
  maenniskokropp_nn_1 = mkN "mдnniskokropp" ;
  maenniskolik_av_1 = mkA "mдnniskolik" ;
  maenniskolik_nn_1 = mkN "mдnniskolik" neutrum ;
  maenniskoliknande_av_1 = mkA "mдnniskoliknande" ;
  maenniskoliv_nn_1 = mkN "mдnniskoliv" neutrum ;
  maenniskooffer_nn_1 = mkN "mдnniskooffer" neutrum ;
  maenniskorov_nn_1 = mkN "mдnniskorov" neutrum ;
  maenniskoskildring_nn_1 = mkN "mдnniskoskildring" ;
  maenniskospermie_nn_1 = mkN "mдnniskospermie" "mдnniskospermier" ;
  maenniskouppfattning_nn_1 = mkN "mдnniskouppfattning" ;
  maenniskovaen_nn_1 = mkN "mдnniskovдn" "mдnniskovдnnen" "mдnniskovдnner" "mдnniskovдnnerna" ;
  maenniskovaenlig_av_1 = mkA "mдnniskovдnlig" ;
  maenniskovaenlighet_nn_1 = mkN "mдnniskovдnlighet" "mдnniskovдnligheter" ;
  maenniskovaerde_nn_1 = mkN "mдnniskovдrde" ;
  maenniskovaerdig_av_1 = mkA "mдnniskovдrdig" ;
  maenska_nn_1 = mkN "mдnska" ;
  maensklig_av_1 = mkA "mдnsklig" ;
  maensklighet_nn_1 = mkN "mдnsklighet" "mдnskligheter" ;
  maer_nn_1 = mkN "mдr" "mдrer" ;
  maergben_nn_1 = mkN "mдrgben" neutrum ;
  maergelgrav_nn_1 = mkN "mдrgelgrav" ;
  maergelskiffer_nn_1 = mkN "mдrgelskiffer" ;
  maergflaeck_nn_1 = mkN "mдrgflдck" ;
  maergfull_av_1 = mkA "mдrgfull" ;
  maergloes_av_1 = mkA "mдrglцs" ;
  maergstraale_nn_1 = mkN "mдrgstrеle" utrum ;
  maerkband_nn_1 = mkN "mдrkband" neutrum ;
  maerkbar_av_1 = mkA "mдrkbar" ;
  maerkduk_nn_1 = mkN "mдrkduk" ;
  maerke_nn_1 = mkN "mдrke" ;
  maerkesdag_nn_1 = mkN "mдrkesdag" ;
  maerkesman_nn_1 = mkN "mдrkesman" "mдrkesmannen" "mдrkesmдn" "mдrkesmдnnen" ;
  maerkgarn_nn_1 = mkN "mдrkgarn" neutrum ;
  maerkhammare_nn_1 = mkN "mдrkhammare" "mдrkhammaren" "mдrkhamrar" "mдrkhamrarna" ;
  maerklig_av_1 = mkA "mдrklig" ;
  maerklighet_nn_1 = mkN "mдrklighet" "mдrkligheter" ;
  maerkning_nn_1 = mkN "mдrkning" ;
  maerkvaerdig_av_1 = mkA "mдrkvдrdig" ;
  maerling_nn_1 = mkN "mдrling" ;
  maerlspik_nn_1 = mkN "mдrlspik" ;
  maerr_nn_1 = mkN "mдrr" ;
  maers_nn_1 = mkN "mдrs" ;
  maersraa_nn_1 = mkN "mдrsrе" "mдrsrеn" "mдrsrеr" "mдrsrеrna" ;
  maerssegel_nn_1 = mkN "mдrssegel" neutrum ;
  maersstaang_nn_1 = mkN "mдrsstеng" "mдrsstдnger" ;
  maeskning_nn_1 = mkN "mдskning" ;
  maeskprovare_nn_1 = mkN "mдskprovare" "mдskprovare" ;
  maess_nn_1 = mkN "mдss" ;
  maessbok_nn_1 = mkN "mдssbok" "mдssbцcker" ;
  maessdraekt_nn_1 = mkN "mдssdrдkt" "mдssdrдkter" ;
  maessfall_nn_1 = mkN "mдssfall" neutrum ;
  maesshake_nn_1 = mkN "mдsshake" utrum ;
  maesshall_nn_1 = mkN "mдsshall" ;
  maessingblaasinstrument_nn_1 = mkN "mдssingblеsinstrument" neutrum ;
  maessinginstrument_nn_1 = mkN "mдssinginstrument" neutrum ;
  maessingsinstrument_nn_1 = mkN "mдssingsinstrument" neutrum ;
  maessingsspik_nn_1 = mkN "mдssingsspik" ;
  maessingstraad_nn_1 = mkN "mдssingstrеd" ;
  maessoffer_nn_1 = mkN "mдssoffer" neutrum ;
  maesspojke_nn_1 = mkN "mдsspojke" utrum ;
  maestarbrev_nn_1 = mkN "mдstarbrev" neutrum ;
  maestare_nn_1 = mkN "mдstare" "mдstare" ;
  maestarinna_nn_1 = mkN "mдstarinna" ;
  maestarklass_nn_1 = mkN "mдstarklass" "mдstarklasser" ;
  maestarprov_nn_1 = mkN "mдstarprov" neutrum ;
  maesterlig_av_1 = mkA "mдsterlig" ;
  maesterlots_nn_1 = mkN "mдsterlots" ;
  maesterman_nn_1 = mkN "mдsterman" "mдstermannen" "mдstermдn" "mдstermдnnen" ;
  maestersaangare_nn_1 = mkN "mдstersеngare" "mдstersеngare" ;
  maesterskap_nn_1 = mkN "mдsterskap" "mдsterskapet" "mдsterskapen" "mдsterskapena" ;
  maesterskapstitel_nn_1 = mkN "mдsterskapstitel" ;
  maesterverk_nn_1 = mkN "mдsterverk" neutrum ;
  maetapparat_nn_1 = mkN "mдtapparat" "mдtapparater" ;
  maetapparatur_nn_1 = mkN "mдtapparatur" "mдtapparaturer" ;
  maetare_nn_1 = mkN "mдtare" "mдtare" ;
  maetarfjaeril_nn_1 = mkN "mдtarfjдril" ;
  maetarlarv_nn_1 = mkN "mдtarlarv" "mдtarlarver" ;
  maetbar_av_1 = mkA "mдtbar" ;
  maetbord_nn_1 = mkN "mдtbord" neutrum ;
  maetbrev_nn_1 = mkN "mдtbrev" neutrum ;
  maetetal_nn_1 = mkN "mдtetal" "mдtetalet" "mдtetalen" "mдtetalena" ;
  maetglas_nn_1 = mkN "mдtglas" neutrum ;
  maetinstrument_nn_1 = mkN "mдtinstrument" neutrum ;
  maetning_nn_1 = mkN "mдtning" ;
  maetningsfartyg_nn_1 = mkN "mдtningsfartyg" neutrum ;
  maetningsregel_nn_1 = mkN "mдtningsregel" "mдtningsregeln" "mдtningsregler" "mдtningsreglerna" ;
  maetningstal_nn_1 = mkN "mдtningstal" "mдtningstalet" "mдtningstalen" "mдtningstalena" ;
  maetomraade_nn_1 = mkN "mдtomrеde" ;
  maetredskap_nn_1 = mkN "mдtredskap" "mдtredskapet" "mдtredskapen" "mдtredskapena" ;
  maetress_nn_1 = mkN "mдtress" "mдtresser" ;
  maett_av_1 = mkA "mдtt" ;
  maettnad_nn_1 = mkN "mдttnad" "mдttnader" ;
  maettningstryck_nn_1 = mkN "mдttningstryck" neutrum ;
  maettsam_av_1 = mkA "mдttsam" "mдttsamt" "mдttsamma" "mдttsamma" "mдttsammare" "mдttsammast" "mдttsammaste" ;
  maetvaerde_nn_1 = mkN "mдtvдrde" ;
  maetverktyg_nn_1 = mkN "mдtverktyg" neutrum ;
  maffia_nn_1 = mkN "maffia" ;
  maffig_av_1 = mkA "maffig" ;
  magasin_nn_1 = mkN "magasin" neutrum ;
  magbesvaer_nn_1 = mkN "magbesvдr" neutrum ;
  magborstare_nn_1 = mkN "magborstare" "magborstare" ;
  magdans_nn_1 = mkN "magdans" "magdanser" ;
  mage_nn_1 = mkN "mage" utrum ;
  mager_av_1 = mkA "mager" "magert" "magra" "magra" "magrare" "magrast" "magraste" ;
  mager_nn_1 = mkN "mager" "magern" "mager" "magerna" ;
  magerlagd_av_1 = mkA "magerlagd" "magerlagt" ;
  maggoerdel_nn_1 = mkN "maggцrdel" ;
  maggrop_nn_1 = mkN "maggrop" ;
  magiker_nn_1 = mkN "magiker" "magikern" "magiker" "magikerna" ;
  maginnehaall_nn_1 = mkN "maginnehеll" neutrum ;
  magisk_av_1 = mkA "magisk" ;
  magister_nn_1 = mkN "magister" ;
  magistral_av_1 = mkA "magistral" ;
  magistrat_nn_1 = mkN "magistrat" "magistrater" ;
  magkatarr_nn_1 = mkN "magkatarr" "magkatarrer" ;
  magmabergart_nn_1 = mkN "magmabergart" "magmabergarter" ;
  magmakammare_nn_1 = mkN "magmakammare" "magmakammaren" "magmakamrar" "magmakamrarna" ;
  magmedicin_nn_1 = mkN "magmedicin" "magmediciner" ;
  magmun_nn_1 = mkN "magmun" "magmunnen" "magmunnar" "magmunnarna" ;
  magnat_nn_1 = mkN "magnat" "magnater" ;
  magnecyl_nn_1 = mkN "magnecyl" "magnecylen" "magnecyl" "magnecylen" ;
  magnesiumlegering_nn_1 = mkN "magnesiumlegering" ;
  magnesiumsulfat_nn_1 = mkN "magnesiumsulfat" "magnesiumsulfater" ;
  magnet_nn_1 = mkN "magnet" "magneter" ;
  magnetapparat_nn_1 = mkN "magnetapparat" "magnetapparater" ;
  magnetband_nn_1 = mkN "magnetband" neutrum ;
  magnetfaelt_nn_1 = mkN "magnetfдlt" neutrum ;
  magnetisk_av_1 = mkA "magnetisk" ;
  magnetisoer_nn_1 = mkN "magnetisцr" "magnetisцrer" ;
  magnetkompass_nn_1 = mkN "magnetkompass" "magnetkompasser" ;
  magnetnaal_nn_1 = mkN "magnetnеl" ;
  magnetofon_nn_1 = mkN "magnetofon" "magnetofoner" ;
  magnetpol_nn_1 = mkN "magnetpol" "magnetpoler" ;
  magnetron_nn_1 = mkN "magnetron" "magnetroner" ;
  magnettaendning_nn_1 = mkN "magnettдndning" ;
  magnificus_av_1 = mkA "magnificus" ;
  magnifik_av_1 = mkA "magnifik" ;
  magnitud_nn_1 = mkN "magnitud" "magnituder" ;
  magnum_av_1 = mkA "magnum" ;
  magnumbutelj_nn_1 = mkN "magnumbutelj" "magnumbuteljer" ;
  magplask_nn_1 = mkN "magplask" neutrum ;
  magsaar_nn_1 = mkN "magsеr" neutrum ;
  magsaeck_nn_1 = mkN "magsдck" ;
  magsaft_nn_1 = mkN "magsaft" "magsafter" ;
  magstark_av_1 = mkA "magstark" ;
  magsur_av_1 = mkA "magsur" ;
  magyar_nn_1 = mkN "magyar" "magyarer" ;
  maharadja_nn_1 = mkN "maharadja" ;
  mahognyliknande_av_1 = mkA "mahognyliknande" ;
  mail_nn_2 = mkN "mail" neutrum ;
  majbagge_nn_1 = mkN "majbagge" utrum ;
  majbrud_nn_1 = mkN "majbrud" ;
  majestaet_nn_1 = mkN "majestдt" neutrum ;
  majestaetisk_av_1 = mkA "majestдtisk" ;
  majestaetsbrott_nn_1 = mkN "majestдtsbrott" neutrum ;
  majestaetsfoerbrytelse_nn_1 = mkN "majestдtsfцrbrytelse" "majestдtsfцrbrytelser" ;
  majonnaes_nn_1 = mkN "majonnдs" "majonnдser" ;
  majonnaessaas_nn_1 = mkN "majonnдssеs" "majonnдssеser" ;
  major_nn_1 = mkN "major" "majorer" ;
  majoritet_nn_1 = mkN "majoritet" "majoriteter" ;
  majoritetsval_nn_1 = mkN "majoritetsval" neutrum ;
  majsgroet_nn_1 = mkN "majsgrцt" ;
  majskolv_nn_1 = mkN "majskolv" ;
  majskorn_nn_1 = mkN "majskorn" neutrum ;
  majstaang_nn_1 = mkN "majstеng" "majstдnger" ;
  majuskel_nn_1 = mkN "majuskel" "majuskeln" "majuskler" "majusklerna" ;
  makaber_av_1 = mkA "makaber" "makabert" "makabra" "makabra" "makabrare" "makabrast" "makabraste" ;
  makaloes_av_1 = mkA "makalцs" ;
  makassarolja_nn_1 = mkN "makassarolja" ;
  make_nn_1 = mkN "make" utrum ;
  makedonier_nn_1 = mkN "makedonier" "makedoniern" "makedonier" "makedonierna" ;
  makedonisk_av_1 = mkA "makedonisk" ;
  makedonsk_av_1 = mkA "makedonsk" ;
  makedonska_nn_2 = mkN "makedonska" ;
  maklig_av_1 = mkA "maklig" ;
  makrill_nn_1 = mkN "makrill" ;
  makron_nn_1 = mkN "makron" "makroner" ;
  makroskopisk_av_1 = mkA "makroskopisk" ;
  makt_nn_1 = mkN "makt" "makter" ;
  maktanspraak_nn_1 = mkN "maktansprеk" neutrum ;
  maktbalans_nn_1 = mkN "maktbalans" "maktbalanser" ;
  maktbefogenhet_nn_1 = mkN "maktbefogenhet" "maktbefogenheter" ;
  maktblock_nn_1 = mkN "maktblock" neutrum ;
  maktcentrum_nn_1 = mkN "maktcentrum" neutrum ;
  maktfaktor_nn_1 = mkN "maktfaktor" "maktfaktorer" ;
  maktfoerdelning_nn_1 = mkN "maktfцrdelning" ;
  maktfullkomlig_av_1 = mkA "maktfullkomlig" ;
  makthavare_nn_1 = mkN "makthavare" "makthavare" ;
  maktkamp_nn_1 = mkN "maktkamp" "maktkamper" ;
  maktkoncentration_nn_1 = mkN "maktkoncentration" "maktkoncentrationer" ;
  maktloes_av_1 = mkA "maktlцs" ;
  maktlysten_av_1 = mkA "maktlysten" "maktlystet" ;
  maktmedel_nn_1 = mkN "maktmedel" neutrum ;
  maktoevertagande_nn_1 = mkN "maktцvertagande" ;
  maktpaaliggande_av_1 = mkA "maktpеliggande" ;
  maktskifte_nn_1 = mkN "maktskifte" ;
  maktspel_nn_1 = mkN "maktspel" "maktspelet" "maktspel" "maktspelen" ;
  maktsymbol_nn_1 = mkN "maktsymbol" "maktsymboler" ;
  maktutoevare_nn_1 = mkN "maktutцvare" "maktutцvare" ;
  mal_nn_1 = mkN "mal" ;
  malaeten_av_1 = mkA "malдten" "malдtet" ;
  malaj_nn_1 = mkN "malaj" "malajer" ;
  malajisk_av_1 = mkA "malajisk" ;
  malajiska_nn_2 = mkN "malajiska" ;
  malakit_nn_1 = mkN "malakit" "malakiter" ;
  malapropaa_ab_1 = mkAdv "malapropе" ;
  malawier_nn_1 = mkN "malawier" "malawiern" "malawier" "malawierna" ;
  malawisk_av_1 = mkA "malawisk" ;
  malaysier_nn_1 = mkN "malaysier" "malaysiern" "malaysier" "malaysierna" ;
  malaysisk_av_1 = mkA "malaysisk" ;
  maldiver_nn_1 = mkN "maldiver" "maldivern" "maldiver" "maldiverna" ;
  maldivisk_av_1 = mkA "maldivisk" ;
  malicioes_av_1 = mkA "maliciцs" ;
  malier_nn_1 = mkN "malier" "maliern" "malier" "malierna" ;
  malign_av_1 = mkA "malign" ;
  malisk_av_1 = mkA "malisk" ;
  mall_nn_1 = mkN "mall" ;
  mallig_av_1 = mkA "mallig" ;
  malm_nn_1 = mkN "malm" ;
  malm_nn_2 = mkN "malm" "malmer" ;
  malmedel_nn_1 = mkN "malmedel" neutrum ;
  malmfaelt_nn_1 = mkN "malmfдlt" neutrum ;
  malmfoerande_av_1 = mkA "malmfцrande" ;
  malmfyndig_av_1 = mkA "malmfyndig" ;
  malmfyndighet_nn_1 = mkN "malmfyndighet" "malmfyndigheter" ;
  malmhalt_nn_1 = mkN "malmhalt" "malmhalter" ;
  malmkoertel_nn_1 = mkN "malmkцrtel" ;
  malmkropp_nn_1 = mkN "malmkropp" ;
  malmkross_nn_1 = mkN "malmkross" ;
  malmoebo_nn_1 = mkN "malmцbo" "malmцbor" ;
  malmtaekt_nn_1 = mkN "malmtдkt" "malmtдkter" ;
  maloer_nn_1 = mkN "malцr" "malцrer" ;
  malpaase_nn_1 = mkN "malpеse" utrum ;
  malstroem_nn_1 = mkN "malstrцm" "malstrцmmen" "malstrцmmar" "malstrцmmarna" ;
  maltdryck_nn_1 = mkN "maltdryck" "maltdrycker" ;
  maltes_nn_1 = mkN "maltes" "malteser" ;
  maltesare_nn_1 = mkN "maltesare" "maltesare" ;
  malteserhund_nn_1 = mkN "malteserhund" ;
  malteserkors_nn_1 = mkN "malteserkors" neutrum ;
  malteserorden_nn_1 = mkN "malteserorden" ;
  maltesisk_av_1 = mkA "maltesisk" ;
  maltesiska_nn_2 = mkN "maltesiska" ;
  mambo_nn_1 = mkN "mambo" "mambor" ;
  mamma_nn_1 = mkN "mamma" ;
  mammaklaenning_nn_1 = mkN "mammaklдnning" ;
  mammaledig_av_1 = mkA "mammaledig" ;
  mammig_av_1 = mkA "mammig" ;
  mammografi_nn_1 = mkN "mammografi" "mammografier" ;
  mammonstrael_nn_1 = mkN "mammonstrдl" ;
  mammut_nn_1 = mkN "mammut" ;
  mammuttraed_nn_1 = mkN "mammuttrдd" neutrum ;
  mamsell_nn_1 = mkN "mamsell" "mamseller" ;
  man_nn_1 = mkN "man" "mannen" "mдn" "mдnnen" ;
  man_nn_2 = mkN "man" ;
  manaar_nn_1 = mkN "manеr" neutrum ;
  manager_nn_1 = mkN "manager" "managern" "manager" "managerna" ;
  manbar_av_1 = mkA "manbar" ;
  manbyggnad_nn_1 = mkN "manbyggnad" "manbyggnader" ;
  manchu_nn_1 = mkN "manchu" "manchun" "manchuer" "manchuerna" ;
  manchuisk_av_1 = mkA "manchuisk" ;
  manchuiska_nn_2 = mkN "manchuiska" ;
  mandarin_nn_1 = mkN "mandarin" "mandariner" ;
  mandat_nn_1 = mkN "mandat" neutrum ;
  mandatfoerdelning_nn_1 = mkN "mandatfцrdelning" ;
  mandatperiod_nn_1 = mkN "mandatperiod" "mandatperioder" ;
  mandel_nn_1 = mkN "mandel" ;
  mandeloegd_av_1 = mkA "mandelцgd" "mandelцgt" ;
  mandelolja_nn_1 = mkN "mandelolja" ;
  mandelpotatis_nn_1 = mkN "mandelpotatis" ;
  mandibel_nn_1 = mkN "mandibel" "mandibeln" "mandibler" "mandiblerna" ;
  mandolin_nn_1 = mkN "mandolin" "mandoliner" ;
  mandom_nn_1 = mkN "mandom" ;
  mandomsprov_nn_1 = mkN "mandomsprov" neutrum ;
  mandrill_nn_1 = mkN "mandrill" "mandriller" ;
  manege_nn_1 = mkN "manege" "maneger" ;
  maner_nn_1 = mkN "manйr" neutrum ;
  maner_nn_2 = mkN "maner" "maneret" "maner" "maneren" ;
  manet_nn_1 = mkN "manet" "maneter" ;
  manfall_nn_1 = mkN "manfall" neutrum ;
  manfolk_nn_1 = mkN "manfolk" neutrum ;
  mangaardsbyggnad_nn_1 = mkN "mangеrdsbyggnad" "mangеrdsbyggnader" ;
  manganin_nn_1 = mkN "manganin" "manganiner" ;
  mangel_nn_1 = mkN "mangel" ;
  mango_nn_1 = mkN "mango" "mangor" ;
  mangrann_av_1 = mkA "mangrann" "mangrant" ;
  mangrove_nn_1 = mkN "mangrove" "mangrover" ;
  mangrovetraesk_nn_1 = mkN "mangrovetrдsk" neutrum ;
  manhaal_nn_1 = mkN "manhеl" neutrum ;
  manhaftig_av_1 = mkA "manhaftig" ;
  mani_nn_1 = mkN "mani" "manier" ;
  maniakalisk_av_1 = mkA "maniakalisk" ;
  manick_nn_1 = mkN "manick" "manicker" ;
  manierism_nn_1 = mkN "manierism" "manierismer" ;
  manifest_av_1 = mkA "manifest" "manifest" ;
  manifest_nn_1 = mkN "manifest" neutrum ;
  manifestation_nn_1 = mkN "manifestation" "manifestationer" ;
  manike_nn_1 = mkN "manikй" "manikйer" ;
  maniker_nn_1 = mkN "maniker" "manikern" "maniker" "manikerna" ;
  manikur_nn_1 = mkN "manikur" "manikurer" ;
  manikyrist_nn_1 = mkN "manikyrist" "manikyrister" ;
  maning_nn_1 = mkN "maning" ;
  manipulation_nn_1 = mkN "manipulation" "manipulationer" ;
  manisk_av_1 = mkA "manisk" ;
  manisk_depressiv_av_1 = mkA "manisk-depressiv" ;
  manke_nn_1 = mkN "manke" utrum ;
  mankemang_nn_1 = mkN "mankemang" neutrum ;
  mankill_nn_1 = mkN "mankill" "mankiller" ;
  manko_nn_1 = mkN "manko" "mankot" "mankon" "mankona" ;
  mankoen_nn_1 = mkN "mankцn" neutrum ;
  manlig_av_1 = mkA "manlig" ;
  mannaaalder_nn_1 = mkN "mannaеlder" ;
  mannagryn_nn_1 = mkN "mannagryn" neutrum ;
  mannagrynsgroet_nn_1 = mkN "mannagrynsgrцt" ;
  mannalav_nn_1 = mkN "mannalav" ;
  mannekaeng_nn_1 = mkN "mannekдng" "mannekдnger" ;
  manodepressiv_av_1 = mkA "manodepressiv" ;
  manoever_nn_1 = mkN "manцver" ;
  manoeverduglig_av_1 = mkA "manцverduglig" ;
  manoeverkraft_nn_1 = mkN "manцverkraft" "manцverkrafter" ;
  manometer_nn_1 = mkN "manometer" ;
  mansaalder_nn_1 = mkN "mansеlder" ;
  mansard_nn_1 = mkN "mansard" "mansarder" ;
  mansardtak_nn_1 = mkN "mansardtak" neutrum ;
  manschett_nn_1 = mkN "manschett" "manschetter" ;
  manschettyrke_nn_1 = mkN "manschettyrke" ;
  mansgrav_nn_1 = mkN "mansgrav" ;
  mansgris_nn_1 = mkN "mansgris" ;
  manskap_nn_1 = mkN "manskap" "manskapet" "manskapen" "manskapena" ;
  manslaeger_nn_1 = mkN "manslдger" neutrum ;
  manslem_nn_1 = mkN "manslem" "manslemmen" "manslemmar" "manslemmarna" ;
  manslukerska_nn_1 = mkN "manslukerska" ;
  mansperson_nn_1 = mkN "mansperson" "manspersoner" ;
  manssida_nn_1 = mkN "manssida" ;
  manstark_av_1 = mkA "manstark" ;
  mantaag_nn_1 = mkN "mantеg" neutrum ;
  mantal_nn_1 = mkN "mantal" "mantalet" "mantalen" "mantalena" ;
  mantalslaengd_nn_1 = mkN "mantalslдngd" "mantalslдngder" ;
  mantalsskriven_av_1 = mkA "mantalsskriven" "mantalsskrivet" ;
  mantalsskrivning_nn_1 = mkN "mantalsskrivning" ;
  mantel_nn_1 = mkN "mantel" ;
  manteldjur_nn_1 = mkN "manteldjur" neutrum ;
  mantelstyrning_nn_1 = mkN "mantelstyrning" ;
  mantilj_nn_1 = mkN "mantilj" "mantiljer" ;
  manual_nn_1 = mkN "manual" "manualer" ;
  manuell_av_1 = mkA "manuell" ;
  manufaktur_nn_1 = mkN "manufaktur" "manufakturer" ;
  manus_nn_1 = mkN "manus" neutrum ;
  manuskript_nn_1 = mkN "manuskript" neutrum ;
  maori_nn_1 = mkN "maori" "maorin" "maorier" "maorierna" ;
  maorisk_av_1 = mkA "maorisk" ;
  mapp_nn_1 = mkN "mapp" ;
  marabu_nn_1 = mkN "marabu" "marabun" "marabuer" "marabuerna" ;
  maraeng_nn_1 = mkN "marдng" "marдnger" ;
  maraengsviss_nn_1 = mkN "marдngsviss" "marдngsvisser" ;
  maraton_nn_1 = mkN "maraton" neutrum ;
  maratonlopp_nn_1 = mkN "maratonlopp" neutrum ;
  mardroem_nn_1 = mkN "mardrцm" "mardrцmmen" "mardrцmmar" "mardrцmmarna" ;
  marg_nn_1 = mkN "marg" "marger" ;
  margarin_nn_1 = mkN "margarin" "margariner" ;
  margfaldig_av_1 = mkA "margfaldig" ;
  marginal_nn_1 = mkN "marginal" "marginaler" ;
  marginalbeskattning_nn_1 = mkN "marginalbeskattning" ;
  marginaleffekt_nn_1 = mkN "marginaleffekt" "marginaleffekter" ;
  marginalinkomst_nn_1 = mkN "marginalinkomst" "marginalinkomster" ;
  marginalintaekt_nn_1 = mkN "marginalintдkt" "marginalintдkter" ;
  marginalkostnad_nn_1 = mkN "marginalkostnad" "marginalkostnader" ;
  marginalskatt_nn_1 = mkN "marginalskatt" "marginalskatter" ;
  marginalvaeljare_nn_1 = mkN "marginalvдljare" "marginalvдljare" ;
  marginell_av_1 = mkA "marginell" ;
  marig_av_1 = mkA "marig" ;
  marin_av_1 = mkA "marin" ;
  marin_nn_1 = mkN "marin" "mariner" ;
  marinad_nn_1 = mkN "marinad" "marinader" ;
  marinbiolog_nn_1 = mkN "marinbiolog" "marinbiologer" ;
  marinbiologisk_av_1 = mkA "marinbiologisk" ;
  marinblaa_av_1 = mkA "marinblе" "marinblеtt" ;
  marindirektoer_nn_1 = mkN "marindirektцr" "marindirektцrer" ;
  marinkaar_nn_1 = mkN "marinkеr" "marinkеrer" ;
  marinledning_nn_1 = mkN "marinledning" ;
  marinsoldat_nn_1 = mkN "marinsoldat" "marinsoldater" ;
  marionett_nn_1 = mkN "marionett" "marionetter" ;
  maritim_av_1 = mkA "maritim" ;
  mark_nn_1 = mkN "mark" "marker" ;
  mark_nn_2 = mkN "mark" "marken" "mark" "marken" ;
  markaegare_nn_1 = mkN "markдgare" "markдgare" ;
  markant_av_1 = mkA "markant" "markant" ;
  markeffektfarkost_nn_1 = mkN "markeffektfarkost" "markeffektfarkoster" ;
  markegaang_nn_1 = mkN "markegеng" ;
  markering_nn_1 = mkN "markering" ;
  marketentare_nn_1 = mkN "marketentare" "marketentare" ;
  marketenteri_nn_1 = mkN "marketenteri" "marketenterit" "marketenterier" "marketenterierna" ;
  marketeri_nn_1 = mkN "marketeri" "marketerit" "marketerier" "marketerierna" ;
  markgreve_nn_1 = mkN "markgreve" utrum ;
  markis_nn_1 = mkN "markis" "markiser" ;
  marklaera_nn_1 = mkN "marklдra" ;
  marklevande_av_1 = mkA "marklevande" ;
  marknad_nn_1 = mkN "marknad" "marknader" ;
  marknadsekonomi_nn_1 = mkN "marknadsekonomi" "marknadsekonomier" ;
  marknadsekonomisk_av_1 = mkA "marknadsekonomisk" ;
  marknadsfoering_nn_1 = mkN "marknadsfцring" ;
  marknadsgycklare_nn_1 = mkN "marknadsgycklare" "marknadsgycklare" ;
  marknadslaege_nn_1 = mkN "marknadslдge" ;
  marknadspris_nn_1 = mkN "marknadspris" neutrum ;
  marknadsundersoekning_nn_1 = mkN "marknadsundersцkning" ;
  marknadsvaerde_nn_1 = mkN "marknadsvдrde" ;
  marknivaa_nn_1 = mkN "marknivе" "marknivеer" ;
  markoer_nn_1 = mkN "markцr" "markцrer" ;
  markomanner_nn_1 = mkN "markomanner" "markomannern" "markomanner" "markomannerna" ;
  markomraade_nn_1 = mkN "markomrеde" ;
  markorganism_nn_1 = mkN "markorganism" "markorganismer" ;
  marktaeckare_nn_1 = mkN "marktдckare" "marktдckare" ;
  marktjaenst_nn_1 = mkN "marktjдnst" "marktjдnster" ;
  marmelad_nn_1 = mkN "marmelad" "marmelader" ;
  marmorering_nn_1 = mkN "marmorering" ;
  marmorliknande_av_1 = mkA "marmorliknande" ;
  marockan_nn_1 = mkN "marockan" "marockaner" ;
  marockansk_av_1 = mkA "marockansk" ;
  marockanska_nn_1 = mkN "marockanska" ;
  marodoer_nn_1 = mkN "marodцr" "marodцrer" ;
  marsch_nn_1 = mkN "marsch" "marscher" ;
  marschall_nn_1 = mkN "marschall" "marschaller" ;
  marschfart_nn_1 = mkN "marschfart" "marschfarter" ;
  marschlaege_nn_1 = mkN "marschlдge" ;
  marshmallow_nn_1 = mkN "marshmallow" "marshmallower" ;
  marsian_nn_1 = mkN "marsian" "marsianer" ;
  marsk_nn_1 = mkN "marsk" "marsker" ;
  marskalk_nn_1 = mkN "marskalk" ;
  marskalkstav_nn_1 = mkN "marskalkstav" ;
  marsvin_nn_1 = mkN "marsvin" neutrum ;
  martall_nn_1 = mkN "martall" ;
  martasbekymmer_nn_1 = mkN "martasbekymmer" neutrum ;
  martialisk_av_1 = mkA "martialisk" ;
  martini_nn_1 = mkN "martini" "martinin" "martini" "martinina" ;
  martyr_nn_1 = mkN "martyr" "martyrer" ;
  martyrium_nn_1 = mkN "martyrium" "martyriet" "martyrier" "martyrierna" ;
  marulk_nn_1 = mkN "marulk" ;
  marviol_nn_1 = mkN "marviol" "marvioler" ;
  marxist_nn_1 = mkN "marxist" "marxister" ;
  marxistisk_av_1 = mkA "marxistisk" ;
  mas_nn_1 = mkN "mas" ;
  maser_nn_1 = mkN "maser" ;
  masig_av_1 = mkA "masig" ;
  mask_nn_1 = mkN "mask" ;
  mask_nn_2 = mkN "mask" "masker" ;
  maskaeten_av_1 = mkA "maskдten" "maskдtet" ;
  maskerad_nn_1 = mkN "maskerad" "maskerader" ;
  maskeraddraekt_nn_1 = mkN "maskeraddrдkt" "maskeraddrдkter" ;
  maskering_nn_1 = mkN "maskering" ;
  maskformig_av_1 = mkA "maskformig" ;
  maskhaal_nn_1 = mkN "maskhеl" neutrum ;
  maskin_nn_1 = mkN "maskin" "maskiner" ;
  maskindel_nn_1 = mkN "maskindel" "maskindelen" "maskindelar" "maskindelarna" ;
  maskinelement_nn_1 = mkN "maskinelement" neutrum ;
  maskinell_av_1 = mkA "maskinell" ;
  maskineri_nn_1 = mkN "maskineri" "maskinerit" "maskinerier" "maskinerierna" ;
  maskingevaer_nn_1 = mkN "maskingevдr" neutrum ;
  maskinhall_nn_1 = mkN "maskinhall" ;
  maskinhaveri_nn_1 = mkN "maskinhaveri" "maskinhaverit" "maskinhaverier" "maskinhaverierna" ;
  maskinist_nn_1 = mkN "maskinist" "maskinister" ;
  maskinlaesbar_av_1 = mkA "maskinlдsbar" ;
  maskinmaessig_av_1 = mkA "maskinmдssig" ;
  maskinoeversaettning_nn_1 = mkN "maskinцversдttning" ;
  maskinpark_nn_1 = mkN "maskinpark" "maskinparker" ;
  maskinpistol_nn_1 = mkN "maskinpistol" "maskinpistoler" ;
  maskinpress_nn_1 = mkN "maskinpress" ;
  maskinrum_nn_1 = mkN "maskinrum" "maskinrummet" "maskinrum" "maskinrummen" ;
  maskinskriven_av_1 = mkA "maskinskriven" "maskinskrivet" ;
  maskinskrivning_nn_1 = mkN "maskinskrivning" ;
  maskinspraak_nn_1 = mkN "maskinsprеk" neutrum ;
  maskintid_nn_1 = mkN "maskintid" "maskintider" ;
  maskintvaett_nn_1 = mkN "maskintvдtt" ;
  maskning_nn_1 = mkN "maskning" ;
  maskoer_nn_1 = mkN "maskцr" "maskцrer" ;
  maskopi_nn_1 = mkN "maskopi" "maskopier" ;
  maskot_nn_1 = mkN "maskot" ;
  maskspel_nn_1 = mkN "maskspel" "maskspelet" "maskspel" "maskspelen" ;
  maskstungen_av_1 = mkA "maskstungen" "maskstunget" ;
  masktaethet_nn_1 = mkN "masktдthet" "masktдtheter" ;
  maskulin_av_1 = mkA "maskulin" ;
  maskulinum_nn_1 = mkN "maskulinum" "maskulinet" "maskuliner" "maskulinerna" ;
  masochist_nn_1 = mkN "masochist" "masochister" ;
  massa_nn_2 = mkN "massa" ;
  massageinstitut_nn_1 = mkN "massageinstitut" neutrum ;
  massaker_nn_1 = mkN "massaker" "massakern" "massakrer" "massakrerna" ;
  massbjaesse_nn_1 = mkN "massbjдsse" utrum ;
  masscentrum_nn_1 = mkN "masscentrum" neutrum ;
  massdoed_nn_1 = mkN "massdцd" ;
  massfaangst_nn_1 = mkN "massfеngst" "massfеngster" ;
  massiv_av_1 = mkA "massiv" ;
  massiv_nn_1 = mkN "massiv" neutrum ;
  massivitet_nn_1 = mkN "massivitet" "massiviteter" ;
  massjaette_nn_1 = mkN "massjдtte" utrum ;
  masskommunikation_nn_1 = mkN "masskommunikation" "masskommunikationer" ;
  masskonst_nn_1 = mkN "masskonst" "masskonster" ;
  masskorsband_nn_1 = mkN "masskorsband" neutrum ;
  massloes_av_1 = mkA "masslцs" ;
  massmedial_av_1 = mkA "massmedial" ;
  massmedium_nn_1 = mkN "massmedium" "massmediet" "massmedier" "massmedierna" ;
  massmoete_nn_1 = mkN "massmцte" ;
  massmord_nn_1 = mkN "massmord" neutrum ;
  massoer_nn_1 = mkN "massцr" "massцrer" ;
  masspektrum_nn_1 = mkN "masspektrum" neutrum ;
  masspsykos_nn_1 = mkN "masspsykos" "masspsykoser" ;
  masstal_nn_1 = mkN "masstal" "masstalet" "masstalen" "masstalena" ;
  massvis_ab_1 = mkAdv "massvis" ;
  mast_nn_1 = mkN "mast" "master" ;
  master_nn_1 = mkN "master" ;
  mastfisk_nn_1 = mkN "mastfisk" ;
  mastfritt_ab_1 = mkAdv "mastfritt" ;
  masthaal_nn_1 = mkN "masthеl" neutrum ;
  mastig_av_1 = mkA "mastig" ;
  mastkorg_nn_1 = mkN "mastkorg" ;
  mastkrage_nn_1 = mkN "mastkrage" utrum ;
  mastodont_nn_1 = mkN "mastodont" "mastodonter" ;
  mastodontisk_av_1 = mkA "mastodontisk" ;
  masturbation_nn_1 = mkN "masturbation" "masturbationer" ;
  masugn_nn_1 = mkN "masugn" ;
  masurbjoerk_nn_1 = mkN "masurbjцrk" ;
  masverk_nn_1 = mkN "masverk" neutrum ;
  matador_nn_1 = mkN "matador" "matadoren" "matadorer" "matadorerna" ;
  matarbuss_nn_1 = mkN "matarbuss" ;
  matare_nn_1 = mkN "matare" "matare" ;
  matarledning_nn_1 = mkN "matarledning" ;
  matbestick_nn_1 = mkN "matbestick" neutrum ;
  matbit_nn_1 = mkN "matbit" ;
  matbord_nn_1 = mkN "matbord" neutrum ;
  matbroed_nn_1 = mkN "matbrцd" neutrum ;
  match_nn_1 = mkN "match" "matcher" ;
  matchboll_nn_1 = mkN "matchboll" ;
  matematiker_nn_1 = mkN "matematiker" "matematikern" "matematiker" "matematikerna" ;
  matematiklaerare_nn_1 = mkN "matematiklдrare" "matematiklдrare" ;
  matematisk_av_1 = mkA "matematisk" ;
  matematisk_naturvetenskaplig_av_1 = mkA "matematisk-naturvetenskaplig" ;
  materia_nn_1 = mkN "materia" "materian" "materier" "materierna" ;
  material_nn_1 = mkN "material" neutrum ;
  materialisation_nn_1 = mkN "materialisation" "materialisationer" ;
  materialist_nn_1 = mkN "materialist" "materialister" ;
  materialistisk_av_1 = mkA "materialistisk" ;
  materialkonstant_nn_1 = mkN "materialkonstant" "materialkonstanter" ;
  materialproblem_nn_1 = mkN "materialproblem" neutrum ;
  materialsamling_nn_1 = mkN "materialsamling" ;
  materialspelare_nn_1 = mkN "materialspelare" "materialspelare" ;
  materie_nn_1 = mkN "materie" "materier" ;
  materieforskning_nn_1 = mkN "materieforskning" ;
  materiegas_nn_1 = mkN "materiegas" "materiegaser" ;
  materiell_av_1 = mkA "materiell" ;
  materiemoln_nn_1 = mkN "materiemoln" neutrum ;
  materiestroem_nn_1 = mkN "materiestrцm" "materiestrцmmen" "materiestrцmmar" "materiestrцmmarna" ;
  materietransport_nn_1 = mkN "materietransport" "materietransporter" ;
  materieutbyte_nn_1 = mkN "materieutbyte" ;
  matfett_nn_1 = mkN "matfett" "matfettet" "matfetter" "matfetterna" ;
  matfoergiftning_nn_1 = mkN "matfцrgiftning" ;
  matfoerraad_nn_1 = mkN "matfцrrеd" neutrum ;
  matfrisk_av_1 = mkA "matfrisk" ;
  matfrukt_nn_1 = mkN "matfrukt" "matfrukter" ;
  mathaallning_nn_1 = mkN "mathеllning" ;
  matine_nn_1 = mkN "matinй" "matinйer" ;
  matjessill_nn_1 = mkN "matjessill" ;
  matjord_nn_1 = mkN "matjord" ;
  matlag_nn_1 = mkN "matlag" neutrum ;
  matlagning_nn_1 = mkN "matlagning" ;
  matlagningskonst_nn_1 = mkN "matlagningskonst" "matlagningskonster" ;
  matmamma_nn_1 = mkN "matmamma" ;
  matning_nn_1 = mkN "matning" ;
  matnyttig_av_1 = mkA "matnyttig" ;
  matolja_nn_1 = mkN "matolja" ;
  matpotatis_nn_1 = mkN "matpotatis" ;
  matraett_nn_1 = mkN "matrдtt" "matrдtter" ;
  matrest_nn_1 = mkN "matrest" "matrester" ;
  matriarkalisk_av_1 = mkA "matriarkalisk" ;
  matrikel_nn_1 = mkN "matrikel" ;
  matris_nn_1 = mkN "matris" "matriser" ;
  matros_nn_1 = mkN "matros" "matroser" ;
  matroskostym_nn_1 = mkN "matroskostym" "matroskostymer" ;
  matsaeck_nn_1 = mkN "matsдck" ;
  matsal_nn_1 = mkN "matsal" ;
  matsalong_nn_1 = mkN "matsalong" "matsalonger" ;
  matsedel_nn_1 = mkN "matsedel" ;
  matservering_nn_1 = mkN "matservering" ;
  matservis_nn_1 = mkN "matservis" "matserviser" ;
  matsked_nn_1 = mkN "matsked" ;
  matsmaeltning_nn_1 = mkN "matsmдltning" ;
  matsmaeltningskanal_nn_1 = mkN "matsmдltningskanal" "matsmдltningskanaler" ;
  matsmaeltningsorgan_nn_1 = mkN "matsmдltningsorgan" neutrum ;
  matsmaeltningsvaetska_nn_1 = mkN "matsmдltningsvдtska" ;
  matstrupe_nn_1 = mkN "matstrupe" utrum ;
  matsvamp_nn_1 = mkN "matsvamp" ;
  matt_av_1 = mkA "matt" ;
  mattallrik_nn_1 = mkN "mattallrik" ;
  mattdomare_nn_1 = mkN "mattdomare" "mattdomare" ;
  matte_nn_2 = mkN "matte" utrum ;
  matthet_nn_1 = mkN "matthet" "mattheter" ;
  mattighet_nn_1 = mkN "mattighet" "mattigheter" ;
  mattpiskare_nn_1 = mkN "mattpiskare" "mattpiskare" ;
  mattpiskning_nn_1 = mkN "mattpiskning" ;
  mattsopare_nn_1 = mkN "mattsopare" "mattsopare" ;
  matutin_nn_1 = mkN "matutin" "matutiner" ;
  matvana_nn_1 = mkN "matvana" ;
  matvara_nn_1 = mkN "matvara" ;
  matvaruaffaer_nn_1 = mkN "matvaruaffдr" "matvaruaffдrer" ;
  matvaruhall_nn_1 = mkN "matvaruhall" ;
  matvraa_nn_1 = mkN "matvrе" "matvrеn" "matvrеr" "matvrеrna" ;
  matvrak_nn_1 = mkN "matvrak" neutrum ;
  mauretanier_nn_1 = mkN "mauretanier" "mauretaniern" "mauretanier" "mauretanierna" ;
  mauretansk_av_1 = mkA "mauretansk" ;
  mauritier_nn_1 = mkN "mauritier" "mauritiern" "mauritier" "mauritierna" ;
  mauritisk_av_1 = mkA "mauritisk" ;
  mauser_nn_1 = mkN "mauser" "mausern" "mauser" "mauserna" ;
  mausergevaer_nn_1 = mkN "mausergevдr" neutrum ;
  mauserpistol_nn_1 = mkN "mauserpistol" "mauserpistoler" ;
  mausoleum_nn_1 = mkN "mausoleum" "mausoleet" "mausoleer" "mausoleerna" ;
  maxikjol_nn_1 = mkN "maxikjol" ;
  maxill_nn_1 = mkN "maxill" "maxiller" ;
  maxim_nn_1 = mkN "maxim" "maximer" ;
  maximal_av_1 = mkA "maximal" ;
  maximipunkt_nn_1 = mkN "maximipunkt" "maximipunkter" ;
  maximitemperatur_nn_1 = mkN "maximitemperatur" "maximitemperaturer" ;
  maximitermometer_nn_1 = mkN "maximitermometer" ;
  maximum_nn_1 = mkN "maximum" neutrum ;
  mayafolk_nn_1 = mkN "mayafolk" neutrum ;
  mazarin_nn_1 = mkN "mazarin" "mazariner" ;
  meander_nn_1 = mkN "meander" ;
  meccano_nn_1 = mkN "meccano" "meccanot" "meccanon" "meccanona" ;
  mecenat_nn_1 = mkN "mecenat" "mecenater" ;
  med_ab_1 = mkAdv "med" ;
  med_nn_1 = mkN "med" ;
  medalj_nn_1 = mkN "medalj" "medaljer" ;
  medaljoer_nn_1 = mkN "medaljцr" "medaljцrer" ;
  medaljong_nn_1 = mkN "medaljong" "medaljonger" ;
  medansvarig_av_1 = mkA "medansvarig" ;
  medarbetare_nn_1 = mkN "medarbetare" "medarbetare" ;
  medbedoemare_nn_1 = mkN "medbedцmare" "medbedцmare" ;
  medbestaemmandelag_nn_1 = mkN "medbestдmmandelag" ;
  medborgare_nn_1 = mkN "medborgare" "medborgare" ;
  medborgargarde_nn_1 = mkN "medborgargarde" ;
  medborgarhus_nn_1 = mkN "medborgarhus" neutrum ;
  medborgarskap_nn_1 = mkN "medborgarskap" "medborgarskapet" "medborgarskapen" "medborgarskapena" ;
  medborgarvittne_nn_1 = mkN "medborgarvittne" ;
  medborgenaer_nn_1 = mkN "medborgenдr" "medborgenдrer" ;
  medborgerlig_av_1 = mkA "medborgerlig" ;
  medbringare_nn_1 = mkN "medbringare" "medbringare" ;
  medbroder_nn_1 = mkN "medbroder" "medbrodern" "medbrцder" "medbrцderna" ;
  medbrottslig_av_1 = mkA "medbrottslig" ;
  medbrottsling_nn_1 = mkN "medbrottsling" ;
  meddelaktig_av_1 = mkA "meddelaktig" ;
  meddelande_nn_1 = mkN "meddelande" ;
  meddelare_nn_1 = mkN "meddelare" "meddelare" ;
  meddelelsemedel_nn_1 = mkN "meddelelsemedel" neutrum ;
  meddelsam_av_1 = mkA "meddelsam" "meddelsamt" "meddelsamma" "meddelsamma" "meddelsammare" "meddelsammast" "meddelsammaste" ;
  meddetsamma_ab_1 = mkAdv "meddetsamma" ;
  mede_nn_1 = mkN "mede" utrum ;
  medel_nn_1 = mkN "medel" neutrum ;
  medelaalder_nn_1 = mkN "medelеlder" ;
  medelaalders_av_1 = mkA "medelеlders" ;
  medelbar_av_1 = mkA "medelbar" ;
  medeldistans_nn_1 = mkN "medeldistans" "medeldistanser" ;
  medeldistansraket_nn_1 = mkN "medeldistansraket" "medeldistansraketer" ;
  medeldistansrobot_nn_1 = mkN "medeldistansrobot" ;
  medelfel_nn_1 = mkN "medelfel" "medelfelet" "medelfel" "medelfelen" ;
  medelindisk_av_1 = mkA "medelindisk" ;
  medelklass_nn_1 = mkN "medelklass" "medelklasser" ;
  medellaengd_nn_1 = mkN "medellдngd" "medellдngder" ;
  medellivslaengd_nn_1 = mkN "medellivslдngd" "medellivslдngder" ;
  medelloes_av_1 = mkA "medellцs" ;
  medelmaattig_av_1 = mkA "medelmеttig" ;
  medelpadare_nn_1 = mkN "medelpadare" "medelpadare" ;
  medelpadsk_av_1 = mkA "medelpadsk" ;
  medelproportional_nn_1 = mkN "medelproportional" "medelproportionaler" ;
  medelpunkt_nn_1 = mkN "medelpunkt" "medelpunkter" ;
  medelsanvisning_nn_1 = mkN "medelsanvisning" ;
  medelsoltid_nn_1 = mkN "medelsoltid" "medelsoltider" ;
  medelsvensson_nn_1 = mkN "medelsvensson" "medelsvenssцner" ;
  medeltal_nn_1 = mkN "medeltal" "medeltalet" "medeltalen" "medeltalena" ;
  medeltemperatur_nn_1 = mkN "medeltemperatur" "medeltemperaturer" ;
  medeltid_nn_1 = mkN "medeltid" "medeltider" ;
  medeltida_av_1 = mkA "medeltida" ;
  medeltidsmaenniska_nn_1 = mkN "medeltidsmдnniska" ;
  medelvaeg_nn_1 = mkN "medelvдg" ;
  medelvaerde_nn_1 = mkN "medelvдrde" ;
  medelvattenstaand_nn_1 = mkN "medelvattenstеnd" neutrum ;
  medfaren_av_1 = mkA "medfaren" "medfaret" ;
  medfoedd_av_1 = mkA "medfцdd" ;
  medgaang_nn_1 = mkN "medgеng" ;
  medge_vb_1 = mkV "medge" "medger" "medge" "medgav" "medgett" "medgiven" ;
  medgivande_nn_1 = mkN "medgivande" ;
  medgoerlig_av_1 = mkA "medgцrlig" ;
  medhaars_ab_1 = mkAdv "medhеrs" ;
  medhavd_av_1 = mkA "medhavd" "medhavt" ;
  medhjaelpare_nn_1 = mkN "medhjдlpare" "medhjдlpare" ;
  medial_av_1 = mkA "medial" ;
  median_nn_1 = mkN "median" "medianer" ;
  medianvaeljare_nn_1 = mkN "medianvдljare" "medianvдljare" ;
  mediatek_nn_1 = mkN "mediatek" neutrum ;
  medicin_nn_1 = mkN "medicin" "mediciner" ;
  medicinalstyrelse_nn_1 = mkN "medicinalstyrelse" "medicinalstyrelser" ;
  medicinalvaext_nn_1 = mkN "medicinalvдxt" "medicinalvдxter" ;
  medicinare_nn_1 = mkN "medicinare" "medicinare" ;
  medicinboll_nn_1 = mkN "medicinboll" ;
  medicinglas_nn_1 = mkN "medicinglas" neutrum ;
  medicinman_nn_1 = mkN "medicinman" "medicinmannen" "medicinmдn" "medicinmдnnen" ;
  medicinsk_av_1 = mkA "medicinsk" ;
  medieval_nn_1 = mkN "medieval" "medievaler" ;
  medikament_nn_1 = mkN "medikament" neutrum ;
  medikus_nn_1 = mkN "medikus" "medikus" "medici" "medicina" ;
  medioker_av_1 = mkA "medioker" "mediokert" "mediokra" "mediokra" "mediokrare" "mediokrast" "mediokraste" ;
  mediotek_nn_1 = mkN "mediotek" neutrum ;
  medisterkorv_nn_1 = mkN "medisterkorv" ;
  meditation_nn_1 = mkN "meditation" "meditationer" ;
  meditativ_av_1 = mkA "meditativ" ;
  mediterran_av_1 = mkA "mediterran" ;
  medium_nn_1 = mkN "medium" "mediet" "medier" "medierna" ;
  medium_nn_2 = mkN "medium" neutrum ;
  medkaennande_av_1 = mkA "medkдnnande" ;
  medlare_nn_1 = mkN "medlare" "medlare" ;
  medlem_nn_1 = mkN "medlem" "medlemmen" "medlemmar" "medlemmarna" ;
  medlemsantal_nn_1 = mkN "medlemsantal" "medlemsantalet" "medlemsantalen" "medlemsantalena" ;
  medlemsavgift_nn_1 = mkN "medlemsavgift" "medlemsavgifter" ;
  medlemskap_nn_1 = mkN "medlemskap" "medlemskapet" "medlemskapen" "medlemskapena" ;
  medlemskort_nn_1 = mkN "medlemskort" neutrum ;
  medlemsstat_nn_1 = mkN "medlemsstat" "medlemsstater" ;
  medlidsam_av_1 = mkA "medlidsam" "medlidsamt" "medlidsamma" "medlidsamma" "medlidsammare" "medlidsammast" "medlidsammaste" ;
  medling_nn_1 = mkN "medling" ;
  medlingsfoerslag_nn_1 = mkN "medlingsfцrslag" neutrum ;
  medlingskommission_nn_1 = mkN "medlingskommission" "medlingskommissioner" ;
  medljud_nn_1 = mkN "medljud" neutrum ;
  medloeftesman_nn_1 = mkN "medlцftesman" "medlцftesmannen" "medlцftesmдn" "medlцftesmдnnen" ;
  medloepare_nn_1 = mkN "medlцpare" "medlцpare" ;
  medlut_nn_1 = mkN "medlut" neutrum ;
  medmaenniska_nn_1 = mkN "medmдnniska" ;
  medmaensklig_av_1 = mkA "medmдnsklig" ;
  medryckande_av_1 = mkA "medryckande" ;
  medsamma_ab_1 = mkAdv "medsamma" ;
  medskyldig_av_1 = mkA "medskyldig" ;
  medsoekande_nn_1 = mkN "medsцkande" "medsцkanden" "medsцkande" "medsцkandena" ;
  medsols_ab_1 = mkAdv "medsols" ;
  medspelare_nn_1 = mkN "medspelare" "medspelare" ;
  medstroem_nn_1 = mkN "medstrцm" "medstrцmmen" "medstrцmmar" "medstrцmmarna" ;
  medstroems_ab_1 = mkAdv "medstrцms" ;
  medta_vb_1 = mkV "medta" "medtar" "medta" "medtog" "medtagit" "medtagen" ;
  medtaevlare_nn_1 = mkN "medtдvlare" "medtдvlare" ;
  medtagen_av_1 = mkA "medtagen" "medtaget" ;
  medurs_ab_1 = mkAdv "medurs" ;
  medverkande_av_1 = mkA "medverkande" ;
  medveten_av_1 = mkA "medveten" "medvetet" ;
  medvetenhet_nn_1 = mkN "medvetenhet" "medvetenheter" ;
  medvetsloes_av_1 = mkA "medvetslцs" ;
  medvind_nn_1 = mkN "medvind" ;
  medvurst_nn_1 = mkN "medvurst" ;
  mefistofelisk_av_1 = mkA "mefistofelisk" ;
  mefitisk_av_1 = mkA "mefitisk" ;
  megabyte_nn_1 = mkN "megabyte" "megabyten" "megabyte" "megabytena" ;
  megafon_nn_1 = mkN "megafon" "megafoner" ;
  megajoule_nn_1 = mkN "megajoule" "megajoulen" "megajoule" "megajoulena" ;
  megalit_nn_1 = mkN "megalit" "megaliter" ;
  meganewton_nn_1 = mkN "meganewton" "meganewtonen" "meganewton" "meganewtonen" ;
  megaton_nn_1 = mkN "megaton" "megatonnet" "megaton" "megatonnen" ;
  megawatt_nn_1 = mkN "megawatt" "megawatten" "megawatt" "megawatten" ;
  mejeri_nn_1 = mkN "mejeri" "mejerit" "mejerier" "mejerierna" ;
  mejerifoerening_nn_1 = mkN "mejerifцrening" ;
  mejerist_nn_1 = mkN "mejerist" "mejerister" ;
  mejl_nn_2 = mkN "mejl" neutrum ;
  mejsel_nn_1 = mkN "mejsel" ;
  mekaniker_nn_1 = mkN "mekaniker" "mekanikern" "mekaniker" "mekanikerna" ;
  mekanikus_nn_1 = mkN "mekanikus" "mekanikusen" "mekanici" "mekanicina" ;
  mekanisering_nn_1 = mkN "mekanisering" ;
  mekanisk_av_1 = mkA "mekanisk" ;
  mekanism_nn_1 = mkN "mekanism" "mekanismer" ;
  mekanistisk_av_1 = mkA "mekanistisk" ;
  melanesier_nn_1 = mkN "melanesier" "melanesiern" "melanesier" "melanesierna" ;
  melanesisk_av_1 = mkA "melanesisk" ;
  melankoliker_nn_1 = mkN "melankoliker" "melankolikern" "melankoliker" "melankolikerna" ;
  melankolisk_av_1 = mkA "melankolisk" ;
  melioration_nn_1 = mkN "melioration" "meliorationer" ;
  mellanakt_nn_1 = mkN "mellanakt" "mellanakter" ;
  mellanbok_nn_1 = mkN "mellanbok" "mellanbцcker" ;
  mellandaeck_nn_1 = mkN "mellandдck" neutrum ;
  mellandag_nn_1 = mkN "mellandag" ;
  mellanfolklig_av_1 = mkA "mellanfolklig" ;
  mellanform_nn_1 = mkN "mellanform" "mellanformer" ;
  mellangaerde_nn_1 = mkN "mellangдrde" ;
  mellanhand_nn_1 = mkN "mellanhand" "mellanhдnder" ;
  mellanhavande_nn_1 = mkN "mellanhavande" ;
  mellanheat_nn_1 = mkN "mellanheat" neutrum ;
  mellanhopp_nn_1 = mkN "mellanhopp" neutrum ;
  mellankommande_av_1 = mkA "mellankommande" ;
  mellankommunal_av_1 = mkA "mellankommunal" ;
  mellankrigstid_nn_1 = mkN "mellankrigstid" "mellankrigstider" ;
  mellankropp_nn_1 = mkN "mellankropp" ;
  mellankultur_nn_1 = mkN "mellankultur" "mellankulturer" ;
  mellanlaege_nn_1 = mkN "mellanlдge" ;
  mellanlandning_nn_1 = mkN "mellanlandning" ;
  mellanmaal_nn_1 = mkN "mellanmеl" neutrum ;
  mellanoel_nn_1 = mkN "mellanцl" neutrum ;
  mellanoera_nn_1 = mkN "mellanцra" "mellanцrat" "mellanцron" "mellanцronen" ;
  mellanraett_nn_1 = mkN "mellanrдtt" "mellanrдtter" ;
  mellanrev_nn_1 = mkN "mellanrev" neutrum ;
  mellanriksvaeg_nn_1 = mkN "mellanriksvдg" ;
  mellanrum_nn_1 = mkN "mellanrum" "mellanrummet" "mellanrum" "mellanrummen" ;
  mellanskikt_nn_1 = mkN "mellanskikt" neutrum ;
  mellanskillnad_nn_1 = mkN "mellanskillnad" "mellanskillnader" ;
  mellanslag_nn_1 = mkN "mellanslag" neutrum ;
  mellanspel_nn_1 = mkN "mellanspel" "mellanspelet" "mellanspel" "mellanspelen" ;
  mellanspett_nn_1 = mkN "mellanspett" ;
  mellanstadium_nn_1 = mkN "mellanstadium" "mellanstadiet" "mellanstadier" "mellanstadierna" ;
  mellanstatlig_av_1 = mkA "mellanstatlig" ;
  mellanstick_nn_1 = mkN "mellanstick" neutrum ;
  mellansubstans_nn_1 = mkN "mellansubstans" "mellansubstanser" ;
  mellansvensk_av_1 = mkA "mellansvensk" ;
  mellantid_nn_1 = mkN "mellantid" "mellantider" ;
  mellanting_nn_1 = mkN "mellanting" neutrum ;
  mellanvaaning_nn_1 = mkN "mellanvеning" ;
  mellanvaegg_nn_1 = mkN "mellanvдgg" ;
  mellanvaerd_nn_1 = mkN "mellanvдrd" ;
  mellanverk_nn_1 = mkN "mellanverk" neutrum ;
  melodi_nn_1 = mkN "melodi" "melodier" ;
  melodioes_av_1 = mkA "melodiцs" ;
  melodisk_av_1 = mkA "melodisk" ;
  melodistaemma_nn_1 = mkN "melodistдmma" ;
  melodram_nn_1 = mkN "melodram" "melodramer" ;
  melodramatisk_av_1 = mkA "melodramatisk" ;
  melon_nn_1 = mkN "melon" "meloner" ;
  membran_nn_1 = mkN "membran" neutrum ;
  membrum_nn_1 = mkN "membrum" neutrum ;
  memento_nn_1 = mkN "memento" "mementot" "mementon" "mementona" ;
  memorandum_nn_1 = mkN "memorandum" "memorandum" "memoranda" "memorandana" ;
  memorial_nn_1 = mkN "memorial" "memorialer" ;
  memorial_nn_2 = mkN "memorial" neutrum ;
  men_nn_1 = mkN "men" neutrum ;
  menageri_nn_1 = mkN "menageri" "menagerit" "menagerier" "menagerierna" ;
  menande_av_1 = mkA "menande" ;
  mendelistisk_av_1 = mkA "mendelistisk" ;
  mendelsk_av_1 = mkA "mendelsk" ;
  mened_nn_1 = mkN "mened" "meneder" ;
  menedare_nn_1 = mkN "menedare" "menedare" ;
  menig_av_1 = mkA "menig" ;
  menighet_nn_1 = mkN "menighet" "menigheter" ;
  mening_nn_1 = mkN "mening" ;
  meningsbrytning_nn_1 = mkN "meningsbrytning" ;
  meningsbyggnad_nn_1 = mkN "meningsbyggnad" "meningsbyggnader" ;
  meningsbyte_nn_1 = mkN "meningsbyte" ;
  meningsfraende_nn_1 = mkN "meningsfrдnde" "meningsfrдnder" ;
  meningsfull_av_1 = mkA "meningsfull" ;
  meningsfylld_av_1 = mkA "meningsfylld" "meningsfyllt" ;
  meningsloes_av_1 = mkA "meningslцs" ;
  meningsloeshet_nn_1 = mkN "meningslцshet" "meningslцsheter" ;
  meningsmotstaandare_nn_1 = mkN "meningsmotstеndare" "meningsmotstеndare" ;
  meningsriktning_nn_1 = mkN "meningsriktning" ;
  meningsskiljaktighet_nn_1 = mkN "meningsskiljaktighet" "meningsskiljaktigheter" ;
  meningsutbyte_nn_1 = mkN "meningsutbyte" ;
  meningsyttring_nn_1 = mkN "meningsyttring" ;
  menisk_nn_1 = mkN "menisk" "menisker" ;
  menlig_av_1 = mkA "menlig" ;
  menloes_av_1 = mkA "menlцs" ;
  menopaus_nn_1 = mkN "menopaus" "menopauser" ;
  menstruation_nn_1 = mkN "menstruation" "menstruationer" ;
  menstruationscykel_nn_1 = mkN "menstruationscykel" ;
  mensur_nn_1 = mkN "mensur" "mensurer" ;
  mental_av_1 = mkA "mental" ;
  mentalitet_nn_1 = mkN "mentalitet" "mentaliteter" ;
  mentalsjuk_av_1 = mkA "mentalsjuk" ;
  mentalsjukdom_nn_1 = mkN "mentalsjukdom" ;
  mentalsjukhus_nn_1 = mkN "mentalsjukhus" neutrum ;
  mentalvaard_nn_1 = mkN "mentalvеrd" ;
  mentometer_nn_1 = mkN "mentometer" ;
  mentor_nn_1 = mkN "mentor" "mentorer" ;
  menuett_nn_1 = mkN "menuett" "menuetter" ;
  meny_nn_1 = mkN "meny" "menyer" ;
  merbemaeld_av_1 = mkA "merbemдld" "merbemдlt" ;
  merendels_ab_1 = mkAdv "merendels" ;
  meridian_nn_1 = mkN "meridian" "meridianer" ;
  meridiancirkel_nn_1 = mkN "meridiancirkel" ;
  meridianhoejd_nn_1 = mkN "meridianhцjd" "meridianhцjder" ;
  merinofaar_nn_1 = mkN "merinofеr" neutrum ;
  merit_nn_1 = mkN "merit" "meriter" ;
  merkantil_av_1 = mkA "merkantil" ;
  merkantilist_nn_1 = mkN "merkantilist" "merkantilister" ;
  merkantilsystem_nn_1 = mkN "merkantilsystem" neutrum ;
  merkaptan_nn_1 = mkN "merkaptan" "merkaptaner" ;
  merkostnad_nn_1 = mkN "merkostnad" "merkostnader" ;
  mervaerde_nn_1 = mkN "mervдrde" ;
  mervaerdesskatt_nn_1 = mkN "mervдrdesskatt" "mervдrdesskatter" ;
  mes_nn_1 = mkN "mes" ;
  mesaktig_av_1 = mkA "mesaktig" ;
  mesallians_nn_1 = mkN "mesallians" "mesallianser" ;
  mesan_nn_1 = mkN "mesan" "mesaner" ;
  mesanmast_nn_1 = mkN "mesanmast" "mesanmaster" ;
  mesfaagel_nn_1 = mkN "mesfеgel" ;
  mesig_av_1 = mkA "mesig" ;
  meskalin_nn_1 = mkN "meskalin" "meskaliner" ;
  meson_nn_1 = mkN "meson" "mesoner" ;
  mesopotam_nn_1 = mkN "mesopotam" "mesopotamer" ;
  mesopotamisk_av_1 = mkA "mesopotamisk" ;
  mesost_nn_1 = mkN "mesost" ;
  mesozoisk_av_1 = mkA "mesozoisk" ;
  messiansk_av_1 = mkA "messiansk" ;
  messiasrike_nn_1 = mkN "messiasrike" ;
  mestadels_ab_1 = mkAdv "mestadels" ;
  mestgynnadnation_nn_1 = mkN "mestgynnadnation" "mestgynnadnationer" ;
  mestis_nn_1 = mkN "mestis" "mestiser" ;
  metacenterhoejd_nn_1 = mkN "metacenterhцjd" "metacenterhцjder" ;
  metacentrum_nn_1 = mkN "metacentrum" neutrum ;
  metafor_nn_1 = mkN "metafor" "metaforen" "metaforer" "metaforerna" ;
  metaforisk_av_1 = mkA "metaforisk" ;
  metafysiker_nn_1 = mkN "metafysiker" "metafysikern" "metafysiker" "metafysikerna" ;
  metafysisk_av_1 = mkA "metafysisk" ;
  metakoek_nn_1 = mkN "metakцk" neutrum ;
  metall_nn_1 = mkN "metall" "metaller" ;
  metallarbetare_nn_1 = mkN "metallarbetare" "metallarbetare" ;
  metallatom_nn_1 = mkN "metallatom" "metallatomer" ;
  metallbad_nn_1 = mkN "metallbad" neutrum ;
  metallfoeremaal_nn_1 = mkN "metallfцremеl" neutrum ;
  metallfoergiftning_nn_1 = mkN "metallfцrgiftning" ;
  metallgjutning_nn_1 = mkN "metallgjutning" ;
  metallindustri_nn_1 = mkN "metallindustri" "metallindustrier" ;
  metallisk_av_1 = mkA "metallisk" ;
  metallografisk_av_1 = mkA "metallografisk" ;
  metalloid_nn_1 = mkN "metalloid" "metalloider" ;
  metalloxid_nn_1 = mkN "metalloxid" "metalloxider" ;
  metallpulver_nn_1 = mkN "metallpulver" neutrum ;
  metallring_nn_1 = mkN "metallring" ;
  metallsaag_nn_1 = mkN "metallsеg" ;
  metallspaan_nn_1 = mkN "metallspеn" neutrum ;
  metallspiral_nn_1 = mkN "metallspiral" "metallspiraler" ;
  metallsvarv_nn_1 = mkN "metallsvarv" ;
  metalltraad_nn_1 = mkN "metalltrеd" ;
  metallurg_nn_1 = mkN "metallurg" "metallurger" ;
  metallurgisk_av_1 = mkA "metallurgisk" ;
  metallvaerde_nn_1 = mkN "metallvдrde" ;
  metamorf_av_1 = mkA "metamorf" ;
  metamorfos_nn_1 = mkN "metamorfos" "metamorfoser" ;
  metan_nn_1 = mkN "metan" "metaner" ;
  metare_nn_1 = mkN "metare" "metare" ;
  metaspraak_nn_1 = mkN "metasprеk" neutrum ;
  metastas_nn_1 = mkN "metastas" "metastaser" ;
  metastatisk_av_1 = mkA "metastatisk" ;
  metatablett_nn_1 = mkN "metatablett" "metatabletter" ;
  metates_nn_1 = mkN "metates" "metateser" ;
  metazo_nn_1 = mkN "metazo" "metazon" "metazoer" "metazoerna" ;
  mete_nn_1 = mkN "mete" ;
  meteor_nn_1 = mkN "meteor" "meteoren" "meteorer" "meteorerna" ;
  meteorit_nn_1 = mkN "meteorit" "meteoriter" ;
  meteorjaern_nn_1 = mkN "meteorjдrn" neutrum ;
  meteorkrater_nn_1 = mkN "meteorkrater" ;
  meteorolog_nn_1 = mkN "meteorolog" "meteorologer" ;
  meteorologisk_av_1 = mkA "meteorologisk" ;
  meteorsten_nn_1 = mkN "meteorsten" "meteorstenen" "meteorstenar" "meteorstenarna" ;
  meter_nn_1 = mkN "meter" ;
  meter_nn_2 = mkN "meter" ;
  meterlikare_nn_1 = mkN "meterlikare" "meterlikare" ;
  metermaatt_nn_1 = mkN "metermеtt" neutrum ;
  meterprototyp_nn_1 = mkN "meterprototyp" "meterprototyper" ;
  meterstav_nn_1 = mkN "meterstav" ;
  metersystem_nn_1 = mkN "metersystem" neutrum ;
  metervis_ab_1 = mkAdv "metervis" ;
  metkrok_nn_1 = mkN "metkrok" ;
  metod_nn_1 = mkN "metod" "metoder" ;
  metodiker_nn_1 = mkN "metodiker" "metodikern" "metodiker" "metodikerna" ;
  metodiklektor_nn_1 = mkN "metodiklektor" "metodiklektorer" ;
  metodisk_av_1 = mkA "metodisk" ;
  metodist_nn_1 = mkN "metodist" "metodister" ;
  metodlaera_nn_1 = mkN "metodlдra" ;
  metodologi_nn_1 = mkN "metodologi" "metodologier" ;
  metodologisk_av_1 = mkA "metodologisk" ;
  metodsynpunkt_nn_1 = mkN "metodsynpunkt" "metodsynpunkter" ;
  metodvetenskap_nn_1 = mkN "metodvetenskap" "metodvetenskaper" ;
  metonymi_nn_1 = mkN "metonymi" "metonymier" ;
  metrev_nn_1 = mkN "metrev" ;
  metrisk_av_1 = mkA "metrisk" ;
  metrologisk_av_1 = mkA "metrologisk" ;
  metronom_nn_1 = mkN "metronom" "metronomer" ;
  metropol_nn_1 = mkN "metropol" "metropoler" ;
  metropolit_nn_1 = mkN "metropolit" "metropoliter" ;
  metspoe_nn_1 = mkN "metspц" "metspцet" "metspцn" "metspцna" ;
  metvurst_nn_1 = mkN "metvurst" ;
  mexikan_nn_1 = mkN "mexikan" "mexikaner" ;
  mexikansk_av_1 = mkA "mexikansk" ;
  mexikanska_nn_1 = mkN "mexikanska" ;
  mezzanin_nn_1 = mkN "mezzanin" "mezzaniner" ;
  mezzoforte_ab_1 = mkAdv "mezzoforte" ;
  mezzoforte_nn_1 = mkN "mezzoforte" ;
  mezzosopran_nn_1 = mkN "mezzosopran" "mezzosopraner" ;
  mick_nn_1 = mkN "mick" ;
  mickel_nn_1 = mkN "mickel" ;
  micro_nn_1 = mkN "micro" "micror" ;
  microvaagsugn_nn_1 = mkN "microvеgsugn" ;
  middag_nn_1 = mkN "middag" ;
  middagsaetare_nn_1 = mkN "middagsдtare" "middagsдtare" ;
  middagsgaest_nn_1 = mkN "middagsgдst" "middagsgдster" ;
  middagshoejd_nn_1 = mkN "middagshцjd" "middagshцjder" ;
  middagsklaenning_nn_1 = mkN "middagsklдnning" ;
  middagslur_nn_1 = mkN "middagslur" ;
  middagsrast_nn_1 = mkN "middagsrast" "middagsraster" ;
  middagssaellskap_nn_1 = mkN "middagssдllskap" "middagssдllskapet" "middagssдllskapen" "middagssдllskapena" ;
  middagstid_nn_1 = mkN "middagstid" "middagstider" ;
  middagstimma_nn_1 = mkN "middagstimma" "middagstimman" "middagstimmar" "middagstimmarna" ;
  midfastosoendag_nn_1 = mkN "midfastosцndag" ;
  midgetbil_nn_1 = mkN "midgetbil" ;
  midja_nn_1 = mkN "midja" ;
  midjeband_nn_1 = mkN "midjeband" neutrum ;
  midjemaatt_nn_1 = mkN "midjemеtt" neutrum ;
  midnattsblaa_av_1 = mkA "midnattsblе" "midnattsblеtt" ;
  midnattssol_nn_1 = mkN "midnattssol" ;
  midskepps_ab_1 = mkAdv "midskepps" ;
  midskeppssektion_nn_1 = mkN "midskeppssektion" "midskeppssektioner" ;
  midsommar_nn_1 = mkN "midsommar" ;
  midsommarafton_nn_1 = mkN "midsommarafton" "midsommaraftonen" "midsommaraftnar" "midsommaraftnarna" ;
  midsommarblomster_nn_1 = mkN "midsommarblomster" neutrum ;
  midsommardag_nn_1 = mkN "midsommardag" ;
  midsommarnatt_nn_1 = mkN "midsommarnatt" "midsommarnдtter" ;
  midsommarstaang_nn_1 = mkN "midsommarstеng" "midsommarstдnger" ;
  midsommartid_nn_1 = mkN "midsommartid" "midsommartider" ;
  midvattens_ab_1 = mkAdv "midvattens" ;
  midvinter_nn_1 = mkN "midvinter" ;
  midvinterblot_nn_1 = mkN "midvinterblot" neutrum ;
  migration_nn_1 = mkN "migration" "migrationer" ;
  miko_nn_1 = mkN "miko" "mikot" "mikon" "mikona" ;
  mikro_nn_1 = mkN "mikro" "mikror" ;
  mikrob_nn_1 = mkN "mikrob" "mikrober" ;
  mikrobiologisk_av_1 = mkA "mikrobiologisk" ;
  mikrodator_nn_1 = mkN "mikrodator" "mikrodatorer" ;
  mikrofiche_nn_1 = mkN "mikrofiche" "mikroficher" ;
  mikrofilm_nn_1 = mkN "mikrofilm" "mikrofilmer" ;
  mikrofon_nn_1 = mkN "mikrofon" "mikrofoner" ;
  mikrofonteknik_nn_1 = mkN "mikrofonteknik" "mikrofontekniker" ;
  mikrofoto_nn_1 = mkN "mikrofoto" "mikrofotot" "mikrofoton" "mikrofotona" ;
  mikrogram_nn_1 = mkN "mikrogram" "mikrogrammet" "mikrogram" "mikrogrammen" ;
  mikrokort_nn_1 = mkN "mikrokort" neutrum ;
  mikrokosmos_nn_1 = mkN "mikrokosmos" neutrum ;
  mikrometer_nn_1 = mkN "mikrometer" ;
  mikrometer_nn_2 = mkN "mikrometer" ;
  mikron_nn_1 = mkN "mikron" "mikroner" ;
  mikroorganism_nn_1 = mkN "mikroorganism" "mikroorganismer" ;
  mikrosekund_nn_1 = mkN "mikrosekund" "mikrosekunder" ;
  mikroskop_nn_1 = mkN "mikroskop" neutrum ;
  mikroskopisk_av_1 = mkA "mikroskopisk" ;
  mikrotelefon_nn_1 = mkN "mikrotelefon" "mikrotelefoner" ;
  mikrotom_nn_1 = mkN "mikrotom" "mikrotomer" ;
  mikrovaagsugn_nn_1 = mkN "mikrovеgsugn" ;
  mil_nn_1 = mkN "mil" "milen" "mil" "milen" ;
  mild_av_1 = mkA "mild" "milt" ;
  mildoegd_av_1 = mkA "mildцgd" "mildцgt" ;
  mildsint_av_1 = mkA "mildsint" "mildsint" ;
  milis_nn_1 = mkN "milis" "miliser" ;
  militaer_av_1 = mkA "militдr" ;
  militaer_nn_1 = mkN "militдr" "militдrer" ;
  militaerattache_nn_1 = mkN "militдrattachй" "militдrattachйer" ;
  militaerbas_nn_1 = mkN "militдrbas" "militдrbaser" ;
  militaerbefaelhavare_nn_1 = mkN "militдrbefдlhavare" "militдrbefдlhavare" ;
  militaerbudget_nn_1 = mkN "militдrbudget" ;
  militaerdiktatur_nn_1 = mkN "militдrdiktatur" "militдrdiktaturer" ;
  militaerfoervaltning_nn_1 = mkN "militдrfцrvaltning" ;
  militaerfordon_nn_1 = mkN "militдrfordon" neutrum ;
  militaerisk_av_1 = mkA "militдrisk" ;
  militaerlaekare_nn_1 = mkN "militдrlдkare" "militдrlдkare" ;
  militaermakt_nn_1 = mkN "militдrmakt" "militдrmakter" ;
  militaermanoever_nn_1 = mkN "militдrmanцver" ;
  militaermarsch_nn_1 = mkN "militдrmarsch" "militдrmarscher" ;
  militaeroevning_nn_1 = mkN "militдrцvning" ;
  militaeromraade_nn_1 = mkN "militдromrеde" ;
  militaerpolis_nn_1 = mkN "militдrpolis" "militдrpoliser" ;
  militaerpromenad_nn_1 = mkN "militдrpromenad" "militдrpromenader" ;
  militaertjaenstgoering_nn_1 = mkN "militдrtjдnstgцring" ;
  militant_av_1 = mkA "militant" "militant" ;
  militarist_nn_1 = mkN "militarist" "militarister" ;
  militaristisk_av_1 = mkA "militaristisk" ;
  militieombudsman_nn_1 = mkN "militieombudsman" "militieombudsmannen" "militieombudsmдn" "militieombudsmдnnen" ;
  miljard_nn_1 = mkN "miljard" "miljarder" ;
  miljardaer_nn_1 = mkN "miljardдr" "miljardдrer" ;
  miljarddel_nn_1 = mkN "miljarddel" "miljarddelen" "miljarddelar" "miljarddelarna" ;
  miljoe_nn_1 = mkN "miljц" "miljцn" "miljцer" "miljцerna" ;
  miljoefarlig_av_1 = mkA "miljцfarlig" ;
  miljoefoerorening_nn_1 = mkN "miljцfцrorening" ;
  miljoefoersaemring_nn_1 = mkN "miljцfцrsдmring" ;
  miljoefoerstoering_nn_1 = mkN "miljцfцrstцring" ;
  miljoefraaga_nn_1 = mkN "miljцfrеga" ;
  miljoegift_nn_1 = mkN "miljцgift" "miljцgiftet" "miljцgifter" "miljцgifterna" ;
  miljoegiftshalt_nn_1 = mkN "miljцgiftshalt" "miljцgiftshalter" ;
  miljoeproblem_nn_1 = mkN "miljцproblem" neutrum ;
  miljoeskildring_nn_1 = mkN "miljцskildring" ;
  miljoetidskrift_nn_1 = mkN "miljцtidskrift" "miljцtidskrifter" ;
  miljoevaenlig_av_1 = mkA "miljцvдnlig" ;
  miljon_nn_1 = mkN "miljon" "miljoner" ;
  miljonaer_nn_1 = mkN "miljonдr" "miljonдrer" ;
  miljondel_nn_1 = mkN "miljondel" "miljondelen" "miljondelar" "miljondelarna" ;
  miljonklass_nn_1 = mkN "miljonklass" "miljonklasser" ;
  miljonstad_nn_1 = mkN "miljonstad" "miljonstдder" ;
  miljontals_ab_1 = mkAdv "miljontals" ;
  milliard_nn_1 = mkN "milliard" "milliarder" ;
  millibar_nn_1 = mkN "millibar" "millibaren" "millibar" "millibaren" ;
  milligram_nn_1 = mkN "milligram" "milligrammet" "milligram" "milligrammen" ;
  milliliter_nn_1 = mkN "milliliter" "millilitern" "milliliter" "milliliterna" ;
  millimeter_nn_1 = mkN "millimeter" ;
  millimeterpapper_nn_1 = mkN "millimeterpapper" neutrum ;
  million_nn_1 = mkN "million" "millioner" ;
  millisievert_nn_1 = mkN "millisievert" "millisieverten" "millisievert" "millisieverten" ;
  milo_nn_1 = mkN "milo" "milot" "milon" "milona" ;
  milsten_nn_1 = mkN "milsten" "milstenen" "milstenar" "milstenarna" ;
  milstolpe_nn_1 = mkN "milstolpe" utrum ;
  milsvid_av_1 = mkA "milsvid" ;
  miltals_ab_1 = mkAdv "miltals" ;
  mim_nn_1 = mkN "mim" "mimer" ;
  mimiker_nn_1 = mkN "mimiker" "mimikern" "mimiker" "mimikerna" ;
  mimisk_av_1 = mkA "mimisk" ;
  mimosasallad_nn_1 = mkN "mimosasallad" "mimosasallader" ;
  min_nn_1 = mkN "min" "miner" ;
  minaret_nn_1 = mkN "minaret" "minareter" ;
  minbomb_nn_1 = mkN "minbomb" "minbomber" ;
  minderaarig_av_1 = mkA "minderеrig" ;
  mindervaerdeskaensla_nn_1 = mkN "mindervдrdeskдnsla" ;
  mindervaerdeskomplex_nn_1 = mkN "mindervдrdeskomplex" neutrum ;
  mindervaerdig_av_1 = mkA "mindervдrdig" ;
  mindretal_nn_1 = mkN "mindretal" "mindretalet" "mindretalen" "mindretalena" ;
  mineral_nn_1 = mkN "mineral" "mineralet" "mineraler" "mineralerna" ;
  mineralaemne_nn_1 = mkN "mineralдmne" ;
  mineralfaerg_nn_1 = mkN "mineralfдrg" "mineralfдrger" ;
  mineralgaang_nn_1 = mkN "mineralgеng" ;
  mineralhalt_nn_1 = mkN "mineralhalt" "mineralhalter" ;
  mineralhaltig_av_1 = mkA "mineralhaltig" ;
  mineraloeverdrag_nn_1 = mkN "mineralцverdrag" neutrum ;
  mineralog_nn_1 = mkN "mineralog" "mineraloger" ;
  mineralogisk_av_1 = mkA "mineralogisk" ;
  mineralolja_nn_1 = mkN "mineralolja" ;
  mineralprov_nn_1 = mkN "mineralprov" neutrum ;
  mineralsalt_nn_1 = mkN "mineralsalt" "mineralsaltet" "mineralsalter" "mineralsalterna" ;
  mineraltillsats_nn_1 = mkN "mineraltillsats" "mineraltillsatser" ;
  mineralutvinning_nn_1 = mkN "mineralutvinning" ;
  mineralvatten_nn_1 = mkN "mineralvatten" "mineralvattnet" "mineralvatten" "mineralvattnen" ;
  minering_nn_1 = mkN "minering" ;
  minfaelt_nn_1 = mkN "minfдlt" neutrum ;
  miniatyr_nn_1 = mkN "miniatyr" "miniatyrer" ;
  minidator_nn_1 = mkN "minidator" "minidatorer" ;
  minimal_av_1 = mkA "minimal" ;
  minimikapital_nn_1 = mkN "minimikapital" neutrum ;
  minimiloen_nn_1 = mkN "minimilцn" "minimilцner" ;
  minimipunkt_nn_1 = mkN "minimipunkt" "minimipunkter" ;
  minimisiffra_nn_1 = mkN "minimisiffra" ;
  minimitemperatur_nn_1 = mkN "minimitemperatur" "minimitemperaturer" ;
  minimitermometer_nn_1 = mkN "minimitermometer" ;
  minimum_nn_1 = mkN "minimum" neutrum ;
  minior_nn_1 = mkN "minior" "minioren" "miniorer" "miniorerna" ;
  miniraeknare_nn_1 = mkN "minirдknare" "minirдknare" ;
  ministaer_nn_1 = mkN "ministдr" "ministдrer" ;
  minister_nn_1 = mkN "minister" ;
  ministeraembete_nn_1 = mkN "ministerдmbete" ;
  ministeransvarighet_nn_1 = mkN "ministeransvarighet" "ministeransvarigheter" ;
  ministerbaenk_nn_1 = mkN "ministerbдnk" ;
  ministerialbok_nn_1 = mkN "ministerialbok" "ministerialbцcker" ;
  ministeriell_av_1 = mkA "ministeriell" ;
  ministerium_nn_1 = mkN "ministerium" "ministeriet" "ministerier" "ministerierna" ;
  ministerportfoelj_nn_1 = mkN "ministerportfцlj" "ministerportfцljer" ;
  ministerpresident_nn_1 = mkN "ministerpresident" "ministerpresidenter" ;
  ministerraad_nn_1 = mkN "ministerrеd" neutrum ;
  ministerstyrelse_nn_1 = mkN "ministerstyrelse" "ministerstyrelser" ;
  ministertaburett_nn_1 = mkN "ministertaburett" "ministertaburetter" ;
  mink_nn_1 = mkN "mink" ;
  minne_nn_1 = mkN "minne" ;
  minnesaang_nn_1 = mkN "minnesеng" "minnesеnger" ;
  minnesbild_nn_1 = mkN "minnesbild" "minnesbilder" ;
  minnesfoerlust_nn_1 = mkN "minnesfцrlust" "minnesfцrluster" ;
  minnesfond_nn_1 = mkN "minnesfond" "minnesfonder" ;
  minnesgaerd_nn_1 = mkN "minnesgдrd" "minnesgдrder" ;
  minnesgod_av_1 = mkA "minnesgod" ;
  minneskonstnaer_nn_1 = mkN "minneskonstnдr" "minneskonstnдrer" ;
  minneskunskap_nn_1 = mkN "minneskunskap" "minneskunskaper" ;
  minneslund_nn_1 = mkN "minneslund" ;
  minnesmaerke_nn_1 = mkN "minnesmдrke" ;
  minnesregel_nn_1 = mkN "minnesregel" "minnesregeln" "minnesregler" "minnesreglerna" ;
  minnesrik_av_1 = mkA "minnesrik" ;
  minnesskrift_nn_1 = mkN "minnesskrift" "minnesskrifter" ;
  minnesspaar_nn_1 = mkN "minnesspеr" neutrum ;
  minnessten_nn_1 = mkN "minnessten" "minnesstenen" "minnesstenar" "minnesstenarna" ;
  minnestal_nn_1 = mkN "minnestal" "minnestalet" "minnestalen" "minnestalena" ;
  minnesteckning_nn_1 = mkN "minnesteckning" ;
  minnesvaard_nn_1 = mkN "minnesvеrd" ;
  minnesvaerd_av_1 = mkA "minnesvдrd" "minnesvдrt" ;
  minoer_nn_1 = mkN "minцr" "minцrer" ;
  minoisk_av_1 = mkA "minoisk" ;
  minoritet_nn_1 = mkN "minoritet" "minoriteter" ;
  minoritetsregering_nn_1 = mkN "minoritetsregering" ;
  minoritetsskydd_nn_1 = mkN "minoritetsskydd" neutrum ;
  minoritetsstaellning_nn_1 = mkN "minoritetsstдllning" ;
  minoritetsvaelde_nn_1 = mkN "minoritetsvдlde" ;
  minroejning_nn_1 = mkN "minrцjning" ;
  minsann_ab_1 = mkAdv "minsann" ;
  minskning_nn_1 = mkN "minskning" ;
  minsoekare_nn_1 = mkN "minsцkare" "minsцkare" ;
  minspaerr_nn_1 = mkN "minspдrr" ;
  minsting_nn_1 = mkN "minsting" ;
  minsvep_nn_1 = mkN "minsvep" neutrum ;
  minsvepare_nn_1 = mkN "minsvepare" "minsvepare" ;
  minsvepning_nn_1 = mkN "minsvepning" ;
  minuend_nn_1 = mkN "minuend" "minuender" ;
  minusgrad_nn_1 = mkN "minusgrad" "minusgrader" ;
  minuskel_nn_1 = mkN "minuskel" "minuskeln" "minuskler" "minusklerna" ;
  minuspol_nn_1 = mkN "minuspol" "minuspoler" ;
  minussida_nn_1 = mkN "minussida" ;
  minustecken_nn_1 = mkN "minustecken" "minustecknet" "minustecken" "minustecknen" ;
  minut_nn_1 = mkN "minut" "minuter" ;
  minut_nn_2 = mkN "minut" "minuter" ;
  minutioes_av_1 = mkA "minutiцs" ;
  minutvisare_nn_1 = mkN "minutvisare" "minutvisare" ;
  mirabell_nn_1 = mkN "mirabell" "mirabeller" ;
  mirakel_nn_1 = mkN "mirakel" neutrum ;
  mirakelspel_nn_1 = mkN "mirakelspel" "mirakelspelet" "mirakelspel" "mirakelspelen" ;
  mirakuloes_av_1 = mkA "mirakulцs" ;
  misaer_nn_1 = mkN "misдr" "misдrer" ;
  misantrop_nn_1 = mkN "misantrop" "misantroper" ;
  misantropisk_av_1 = mkA "misantropisk" ;
  miserabel_av_1 = mkA "miserabel" "miserabelt" "miserabla" "miserabla" "miserablare" "miserablast" "miserablaste" ;
  mispel_nn_1 = mkN "mispel" ;
  miss_nn_1 = mkN "miss" ;
  miss_nn_2 = mkN "miss" "misser" ;
  missanpassning_nn_1 = mkN "missanpassning" ;
  missbelaaten_av_1 = mkA "missbelеten" "missbelеtet" ;
  missbildning_nn_1 = mkN "missbildning" ;
  missbruk_nn_1 = mkN "missbruk" neutrum ;
  missbrukare_nn_1 = mkN "missbrukare" "missbrukare" ;
  missbruksfraaga_nn_1 = mkN "missbruksfrеga" ;
  missdaad_nn_1 = mkN "missdеd" neutrum ;
  missdaadare_nn_1 = mkN "missdеdare" "missdеdare" ;
  misse_nn_1 = mkN "misse" utrum ;
  missfaergning_nn_1 = mkN "missfдrgning" ;
  missfall_nn_1 = mkN "missfall" neutrum ;
  missfirmelse_nn_1 = mkN "missfirmelse" "missfirmelser" ;
  missfoerhaallande_nn_1 = mkN "missfцrhеllande" ;
  missfoerstaand_nn_1 = mkN "missfцrstеnd" neutrum ;
  missfoster_nn_1 = mkN "missfoster" neutrum ;
  missgaerning_nn_1 = mkN "missgдrning" ;
  missgaerningsbalk_nn_1 = mkN "missgдrningsbalk" ;
  missgaerningsman_nn_1 = mkN "missgдrningsman" "missgдrningsmannen" "missgдrningsmдn" "missgдrningsmдnnen" ;
  missgrepp_nn_1 = mkN "missgrepp" neutrum ;
  misshaellighet_nn_1 = mkN "misshдllighet" "misshдlligheter" ;
  misshaglig_av_1 = mkA "misshaglig" ;
  missil_nn_1 = mkN "missil" "missiler" ;
  mission_nn_1 = mkN "mission" "missioner" ;
  missionaer_nn_1 = mkN "missionдr" "missionдrer" ;
  missionsbokhandel_nn_1 = mkN "missionsbokhandel" ;
  missionsfaelt_nn_1 = mkN "missionsfдlt" neutrum ;
  missionsfoerbund_nn_1 = mkN "missionsfцrbund" neutrum ;
  missionshotell_nn_1 = mkN "missionshotell" neutrum ;
  missionshus_nn_1 = mkN "missionshus" neutrum ;
  missionskyrka_nn_1 = mkN "missionskyrka" ;
  missionsstation_nn_1 = mkN "missionsstation" "missionsstationer" ;
  missiv_nn_1 = mkN "missiv" neutrum ;
  misskaend_av_1 = mkA "misskдnd" ;
  missklaedsam_av_1 = mkA "missklдdsam" "missklдdsamt" "missklдdsamma" "missklдdsamma" "missklдdsammare" "missklдdsammast" "missklдdsammaste" ;
  misskoetsam_av_1 = mkA "misskцtsam" "misskцtsamt" "misskцtsamma" "misskцtsamma" "misskцtsammare" "misskцtsammast" "misskцtsammaste" ;
  misskundsam_av_1 = mkA "misskundsam" "misskundsamt" "misskundsamma" "misskundsamma" "misskundsammare" "misskundsammast" "misskundsammaste" ;
  missledande_av_1 = mkA "missledande" ;
  missljud_nn_1 = mkN "missljud" neutrum ;
  misslyckande_nn_1 = mkN "misslyckande" ;
  misslynt_av_1 = mkA "misslynt" "misslynt" ;
  missmodig_av_1 = mkA "missmodig" ;
  missnoejd_av_1 = mkA "missnцjd" "missnцjt" ;
  missnoejesanmaelan_nn_1 = mkN "missnцjesanmдlan" "missnцjesanmдlan" "missnцjesanmдlningar" "missnцjesanmдlningarna" ;
  missnoejesparti_nn_1 = mkN "missnцjesparti" "missnцjespartit" "missnцjespartier" "missnцjespartierna" ;
  missoede_nn_1 = mkN "missцde" ;
  missraekning_nn_1 = mkN "missrдkning" ;
  missroman_nn_1 = mkN "missroman" "missromaner" ;
  missta_vb_1 = mkV "missta" "misstar" "missta" "misstog" "misstagit" "misstagen" ;
  misstaemning_nn_1 = mkN "misstдmning" ;
  misstaenksam_av_1 = mkA "misstдnksam" "misstдnksamt" "misstдnksamma" "misstдnksamma" "misstдnksammare" "misstдnksammast" "misstдnksammaste" ;
  misstaenksamhet_nn_1 = mkN "misstдnksamhet" "misstдnksamheter" ;
  misstaenkt_av_1 = mkA "misstдnkt" "misstдnkt" ;
  misstag_nn_1 = mkN "misstag" neutrum ;
  misstanke_nn_1 = mkN "misstanke" utrum ;
  misstroendevotum_nn_1 = mkN "misstroendevotum" neutrum ;
  misstrogen_av_1 = mkA "misstrogen" "misstroget" ;
  missunnsam_av_1 = mkA "missunnsam" "missunnsamt" "missunnsamma" "missunnsamma" "missunnsammare" "missunnsammast" "missunnsammaste" ;
  missuppfattning_nn_1 = mkN "missuppfattning" ;
  missvisande_av_1 = mkA "missvisande" ;
  missvisning_nn_1 = mkN "missvisning" ;
  miste_ab_1 = mkAdv "miste" ;
  mistel_nn_1 = mkN "mistel" ;
  mistig_av_1 = mkA "mistig" ;
  mistlur_nn_1 = mkN "mistlur" ;
  mitokondrie_nn_1 = mkN "mitokondrie" "mitokondrier" ;
  mitt_ab_1 = mkAdv "mitt" ;
  mittelgaang_nn_1 = mkN "mittelgеng" ;
  mittemellan_ab_1 = mkAdv "mittemellan" ;
  mittemot_ab_1 = mkAdv "mittemot" ;
  mittenlager_nn_1 = mkN "mittenlager" neutrum ;
  mittenparti_nn_1 = mkN "mittenparti" "mittenpartit" "mittenpartier" "mittenpartierna" ;
  mittfaelt_nn_1 = mkN "mittfдlt" neutrum ;
  mittlinje_nn_1 = mkN "mittlinje" "mittlinjer" ;
  mittparti_nn_1 = mkN "mittparti" "mittpartit" "mittpartier" "mittpartierna" ;
  mittpunkt_nn_1 = mkN "mittpunkt" "mittpunkter" ;
  mittpunktsnormal_nn_1 = mkN "mittpunktsnormal" "mittpunktsnormaler" ;
  mittskepp_nn_1 = mkN "mittskepp" neutrum ;
  mittsunds_ab_1 = mkAdv "mittsunds" ;
  mix_nn_1 = mkN "mix" ;
  mixer_nn_1 = mkN "mixer" ;
  mixtur_nn_1 = mkN "mixtur" "mixturer" ;
  mjaekig_av_1 = mkA "mjдkig" ;
  mjaell_av_1 = mkA "mjдll" ;
  mjaellig_av_1 = mkA "mjдllig" ;
  mjaellschampo_nn_1 = mkN "mjдllschampo" "mjдllschampot" "mjдllschampon" "mjдllschampona" ;
  mjaelte_nn_1 = mkN "mjдlte" utrum ;
  mjaelthugg_nn_1 = mkN "mjдlthugg" neutrum ;
  mjaeltsjuk_av_1 = mkA "mjдltsjuk" ;
  mjaerde_nn_1 = mkN "mjдrde" utrum ;
  mjoel_nn_1 = mkN "mjцl" "mjцlet" "mjцler" "mjцlerna" ;
  mjoelbagge_nn_1 = mkN "mjцlbagge" utrum ;
  mjoelig_av_1 = mkA "mjцlig" ;
  mjoelkaader_nn_1 = mkN "mjцlkеder" "mjцlkеdern" "mjцlkеdror" "mjцlkеdrorna" ;
  mjoelkbar_nn_1 = mkN "mjцlkbar" "mjцlkbarer" ;
  mjoelkbildande_av_1 = mkA "mjцlkbildande" ;
  mjoelkbonde_nn_1 = mkN "mjцlkbonde" "mjцlkbцnder" ;
  mjoelkcell_nn_1 = mkN "mjцlkcell" "mjцlkceller" ;
  mjoelkcentral_nn_1 = mkN "mjцlkcentral" "mjцlkcentraler" ;
  mjoelke_nn_1 = mkN "mjцlke" utrum ;
  mjoelkfloede_nn_1 = mkN "mjцlkflцde" ;
  mjoelkflytning_nn_1 = mkN "mjцlkflytning" ;
  mjoelkfoerpackning_nn_1 = mkN "mjцlkfцrpackning" ;
  mjoelkgaang_nn_1 = mkN "mjцlkgеng" ;
  mjoelkgrymt_nn_1 = mkN "mjцlkgrymt" neutrum ;
  mjoelkgrymtning_nn_1 = mkN "mjцlkgrymtning" ;
  mjoelkig_av_1 = mkA "mjцlkig" ;
  mjoelkkaerl_nn_1 = mkN "mjцlkkдrl" neutrum ;
  mjoelkkanal_nn_1 = mkN "mjцlkkanal" "mjцlkkanaler" ;
  mjoelkko_nn_1 = mkN "mjцlkko" "mjцlkkor" ;
  mjoelkkoertel_nn_1 = mkN "mjцlkkцrtel" ;
  mjoelkoert_nn_1 = mkN "mjцlkцrt" "mjцlkцrter" ;
  mjoelkoeverskott_nn_1 = mkN "mjцlkцverskott" neutrum ;
  mjoelkpaket_nn_1 = mkN "mjцlkpaket" neutrum ;
  mjoelkpall_nn_1 = mkN "mjцlkpall" ;
  mjoelkproducent_nn_1 = mkN "mjцlkproducent" "mjцlkproducenter" ;
  mjoelkprodukt_nn_1 = mkN "mjцlkprodukt" "mjцlkprodukter" ;
  mjoelkproduktion_nn_1 = mkN "mjцlkproduktion" "mjцlkproduktioner" ;
  mjoelkspegel_nn_1 = mkN "mjцlkspegel" ;
  mjoelkstockning_nn_1 = mkN "mjцlkstockning" ;
  mjoelksyrebakterie_nn_1 = mkN "mjцlksyrebakterie" "mjцlksyrebakterier" ;
  mjoelktand_nn_1 = mkN "mjцlktand" "mjцlktдnder" ;
  mjoelnare_nn_1 = mkN "mjцlnare" "mjцlnare" ;
  mjoelon_nn_1 = mkN "mjцlon" neutrum ;
  mjoelskivling_nn_1 = mkN "mjцlskivling" ;
  mjuk_av_1 = mkA "mjuk" ;
  mjukbagge_nn_1 = mkN "mjukbagge" utrum ;
  mjukdata_nn_1 = mkN "mjukdata" "mjukdatan" "mjukdata" "mjukdatana" ;
  mjukdel_nn_1 = mkN "mjukdel" "mjukdelen" "mjukdelar" "mjukdelarna" ;
  mjukdelsbehandling_nn_1 = mkN "mjukdelsbehandling" ;
  mjukhet_nn_1 = mkN "mjukhet" "mjukheter" ;
  mjukningsmedel_nn_1 = mkN "mjukningsmedel" neutrum ;
  mjukost_nn_1 = mkN "mjukost" ;
  mjukskalle_nn_1 = mkN "mjukskalle" utrum ;
  mjukvaevnad_nn_1 = mkN "mjukvдvnad" "mjukvдvnader" ;
  mjukvaluta_nn_1 = mkN "mjukvaluta" ;
  mnemoteknisk_av_1 = mkA "mnemoteknisk" ;
  mo_nn_1 = mkN "mo" ;
  moare_nn_1 = mkN "moarй" "moarйer" ;
  moatje_nn_1 = mkN "moatjй" "moatjйer" ;
  mobil_av_1 = mkA "mobil" ;
  mobil_nn_1 = mkN "mobil" "mobiler" ;
  mobilisering_nn_1 = mkN "mobilisering" ;
  mobilitet_nn_1 = mkN "mobilitet" "mobiliteter" ;
  mobiltelefon_nn_1 = mkN "mobiltelefon" "mobiltelefoner" ;
  mockakopp_nn_1 = mkN "mockakopp" ;
  mockaliknande_av_1 = mkA "mockaliknande" ;
  mockasin_nn_1 = mkN "mockasin" "mockasiner" ;
  mockasked_nn_1 = mkN "mockasked" ;
  modaern_av_1 = mkA "modдrn" ;
  modal_av_1 = mkA "modal" ;
  modalitet_nn_1 = mkN "modalitet" "modaliteter" ;
  moddlare_nn_1 = mkN "moddlare" "moddlare" ;
  modeatelje_nn_1 = mkN "modeateljй" "modeateljйer" ;
  modehus_nn_1 = mkN "modehus" neutrum ;
  modejournal_nn_1 = mkN "modejournal" "modejournaler" ;
  modelejon_nn_1 = mkN "modelejon" neutrum ;
  modell_nn_1 = mkN "modell" "modeller" ;
  modellbygge_nn_1 = mkN "modellbygge" ;
  modellfoersoek_nn_1 = mkN "modellfцrsцk" neutrum ;
  modelljaernvaeg_nn_1 = mkN "modelljдrnvдg" ;
  modellstudie_nn_1 = mkN "modellstudie" "modellstudier" ;
  modem_nn_1 = mkN "modem" neutrum ;
  modenyck_nn_1 = mkN "modenyck" "modenycker" ;
  modeord_nn_1 = mkN "modeord" neutrum ;
  moderat_av_1 = mkA "moderat" "moderat" ;
  moderat_nn_1 = mkN "moderat" "moderater" ;
  moderator_nn_1 = mkN "moderator" "moderatorer" ;
  moderbolag_nn_1 = mkN "moderbolag" neutrum ;
  modercell_nn_1 = mkN "modercell" "moderceller" ;
  moderiktig_av_1 = mkA "moderiktig" ;
  moderland_nn_1 = mkN "moderland" "moderlandet" "moderlдnder" "moderlдnderna" ;
  moderlig_av_1 = mkA "moderlig" ;
  moderliv_nn_1 = mkN "moderliv" neutrum ;
  moderlut_nn_1 = mkN "moderlut" ;
  modermun_nn_1 = mkN "modermun" "modermunnen" "modermunnar" "modermunnarna" ;
  modern_av_1 = mkA "modern" ;
  modernaering_nn_1 = mkN "modernдring" ;
  modernisering_nn_1 = mkN "modernisering" ;
  modernist_nn_1 = mkN "modernist" "modernister" ;
  modernistisk_av_1 = mkA "modernistisk" ;
  modernitet_nn_1 = mkN "modernitet" "moderniteter" ;
  modersfamn_nn_1 = mkN "modersfamn" ;
  modersmaal_nn_1 = mkN "modersmеl" neutrum ;
  modersskoete_nn_1 = mkN "modersskцte" ;
  modeskapare_nn_1 = mkN "modeskapare" "modeskapare" ;
  modest_av_1 = mkA "modest" "modest" ;
  modfaelld_av_1 = mkA "modfдlld" "modfдllt" ;
  modifikation_nn_1 = mkN "modifikation" "modifikationer" ;
  modig_av_1 = mkA "modig" ;
  modist_nn_1 = mkN "modist" "modister" ;
  modloes_av_1 = mkA "modlцs" ;
  mods_nn_1 = mkN "mods" neutrum ;
  modstulen_av_1 = mkA "modstulen" "modstulet" ;
  modul_nn_1 = mkN "modul" "moduler" ;
  modulation_nn_1 = mkN "modulation" "modulationer" ;
  modulator_nn_1 = mkN "modulator" "modulatorer" ;
  modulering_nn_1 = mkN "modulering" ;
  modulsystem_nn_1 = mkN "modulsystem" neutrum ;
  modus_nn_1 = mkN "modus" neutrum ;
  moe_nn_1 = mkN "mц" "mцn" "mцr" "mцrna" ;
  moebel_nn_1 = mkN "mцbel" "mцbeln" "mцbler" "mцblerna" ;
  moebelbuss_nn_1 = mkN "mцbelbuss" ;
  moebelfirma_nn_1 = mkN "mцbelfirma" ;
  moebelfoeretag_nn_1 = mkN "mцbelfцretag" neutrum ;
  moebelfoersaeljning_nn_1 = mkN "mцbelfцrsдljning" ;
  moebelfot_nn_1 = mkN "mцbelfot" "mцbelfцtter" ;
  moebelklaedsel_nn_1 = mkN "mцbelklдdsel" ;
  moebeloeverdrag_nn_1 = mkN "mцbelцverdrag" neutrum ;
  moebelsnickare_nn_1 = mkN "mцbelsnickare" "mцbelsnickare" ;
  moebelsnickeri_nn_1 = mkN "mцbelsnickeri" "mцbelsnickerit" "mцbelsnickerier" "mцbelsnickerierna" ;
  moebelspik_nn_1 = mkN "mцbelspik" ;
  moebelstil_nn_1 = mkN "mцbelstil" ;
  moebeltass_nn_1 = mkN "mцbeltass" ;
  moebeltyg_nn_1 = mkN "mцbeltyg" neutrum ;
  moeblemang_nn_1 = mkN "mцblemang" neutrum ;
  moeblerbar_av_1 = mkA "mцblerbar" ;
  moeblering_nn_1 = mkN "mцblering" ;
  moeda_nn_1 = mkN "mцda" ;
  moedofylld_av_1 = mkA "mцdofylld" "mцdofyllt" ;
  moedom_nn_1 = mkN "mцdom" ;
  moedomshinna_nn_1 = mkN "mцdomshinna" ;
  moedosam_av_1 = mkA "mцdosam" "mцdosamt" "mцdosamma" "mцdosamma" "mцdosammare" "mцdosammast" "mцdosammaste" ;
  moedravaardscentral_nn_1 = mkN "mцdravеrdscentral" "mцdravеrdscentraler" ;
  moegelost_nn_1 = mkN "mцgelost" ;
  moegelsvamp_nn_1 = mkN "mцgelsvamp" ;
  moegeltraad_nn_1 = mkN "mцgeltrеd" ;
  moeglig_av_1 = mkA "mцglig" ;
  moejlig_av_1 = mkA "mцjlig" ;
  moejligen_ab_1 = mkAdv "mцjligen" ;
  moejlighet_nn_1 = mkN "mцjlighet" "mцjligheter" ;
  moejligtvis_ab_1 = mkAdv "mцjligtvis" ;
  moenjefaerg_nn_1 = mkN "mцnjefдrg" "mцnjefдrger" ;
  moenster_nn_1 = mkN "mцnster" neutrum ;
  moensterbok_nn_1 = mkN "mцnsterbok" "mцnsterbцcker" ;
  moensterdjup_nn_1 = mkN "mцnsterdjup" neutrum ;
  moenstergaard_nn_1 = mkN "mцnstergеrd" ;
  moenstergarn_nn_1 = mkN "mцnstergarn" neutrum ;
  moenstergill_av_1 = mkA "mцnstergill" ;
  moenstergosse_nn_1 = mkN "mцnstergosse" utrum ;
  moensterjordbruk_nn_1 = mkN "mцnsterjordbruk" neutrum ;
  moensterskydd_nn_1 = mkN "mцnsterskydd" neutrum ;
  moenstervaevd_av_1 = mkA "mцnstervдvd" "mцnstervдvt" ;
  moenstring_nn_1 = mkN "mцnstring" ;
  moenstringsbevis_nn_1 = mkN "mцnstringsbevis" neutrum ;
  moenstringsliggare_nn_1 = mkN "mцnstringsliggare" "mцnstringsliggare" ;
  moer_av_1 = mkA "mцr" ;
  moerdande_av_1 = mkA "mцrdande" ;
  moerdare_nn_1 = mkN "mцrdare" "mцrdare" ;
  moerdeg_nn_1 = mkN "mцrdeg" ;
  moerjig_av_1 = mkA "mцrjig" ;
  moerk_av_1 = mkA "mцrk" ;
  moerkalf_nn_1 = mkN "mцrkalf" "mцrkalfer" ;
  moerkblaa_av_1 = mkA "mцrkblе" "mцrkblеtt" ;
  moerkblond_av_1 = mkA "mцrkblond" ;
  moerkbrun_av_1 = mkA "mцrkbrun" ;
  moerker_nn_1 = mkN "mцrker" neutrum ;
  moerkerkoerning_nn_1 = mkN "mцrkerkцrning" ;
  moerkgroen_av_1 = mkA "mцrkgrцn" ;
  moerkklaedd_av_1 = mkA "mцrkklдdd" "mцrkklдdtt" ;
  moerklaeggning_nn_1 = mkN "mцrklдggning" ;
  moerklagd_av_1 = mkA "mцrklagd" "mцrklagt" ;
  moerkman_nn_1 = mkN "mцrkman" "mцrkmannen" "mцrkmдn" "mцrkmдnnen" ;
  moerkroed_av_1 = mkA "mцrkrцd" ;
  moerkrum_nn_1 = mkN "mцrkrum" "mцrkrummet" "mцrkrum" "mцrkrummen" ;
  moerksens_av_1 = mkA "mцrksens" ;
  moersare_nn_1 = mkN "mцrsare" "mцrsare" ;
  moert_nn_1 = mkN "mцrt" ;
  moesskapell_nn_1 = mkN "mцsskapell" neutrum ;
  moessoera_nn_1 = mkN "mцssцra" "mцssцrat" "mцssцron" "mцssцronen" ;
  moessrem_nn_1 = mkN "mцssrem" "mцssremmen" "mцssremmar" "mцssremmarna" ;
  moete_nn_1 = mkN "mцte" ;
  moetesfoerbud_nn_1 = mkN "mцtesfцrbud" neutrum ;
  moetesfrihet_nn_1 = mkN "mцtesfrihet" "mцtesfriheter" ;
  moetesordfoerande_nn_1 = mkN "mцtesordfцrande" "mцtesordfцranden" "mцtesordfцrande" "mцtesordfцrandena" ;
  moetesplats_nn_1 = mkN "mцtesplats" "mцtesplatser" ;
  moetespunkt_nn_1 = mkN "mцtespunkt" "mцtespunkter" ;
  moetesspaar_nn_1 = mkN "mцtesspеr" neutrum ;
  moetesstation_nn_1 = mkN "mцtesstation" "mцtesstationer" ;
  mogen_av_1 = mkA "mogen" "moget" ;
  mogenhet_nn_1 = mkN "mogenhet" "mogenheter" ;
  mogenhetsexamen_nn_1 = mkN "mogenhetsexamen" "mogenhetsexamen" "mogenhetsexamina" "mogenhetsexamina" ;
  mognad_nn_1 = mkN "mognad" "mognader" ;
  mogul_nn_1 = mkN "mogul" "moguln" "moguler" "mogulerna" ;
  mohammedan_nn_1 = mkN "mohammedan" "mohammedaner" ;
  mohammedanism_nn_1 = mkN "mohammedanism" "mohammedanismer" ;
  mohammedansk_av_1 = mkA "mohammedansk" ;
  mohikan_nn_1 = mkN "mohikan" "mohikaner" ;
  moj_av_1 = mkA "moj" ;
  moj_nn_2 = mkN "moj" ;
  mojaeng_nn_1 = mkN "mojдng" "mojдnger" ;
  mokare_nn_1 = mkN "mokare" "mokare" ;
  mol_ab_1 = mkAdv "mol" ;
  molar_nn_1 = mkN "molar" "molarer" ;
  molaritet_nn_1 = mkN "molaritet" "molariteter" ;
  molekyl_nn_1 = mkN "molekyl" "molekyler" ;
  molekylaer_av_1 = mkA "molekylдr" ;
  molekylaerbiolog_nn_1 = mkN "molekylдrbiolog" "molekylдrbiologer" ;
  molekylarattraktion_nn_1 = mkN "molekylarattraktion" "molekylarattraktioner" ;
  molekylarkraft_nn_1 = mkN "molekylarkraft" "molekylarkrafter" ;
  molekylkedja_nn_1 = mkN "molekylkedja" ;
  molekylvikt_nn_1 = mkN "molekylvikt" "molekylvikter" ;
  mollstaemd_av_1 = mkA "mollstдmd" "mollstдmt" ;
  mollusk_nn_1 = mkN "mollusk" "mollusker" ;
  moln_nn_1 = mkN "moln" neutrum ;
  molnbank_nn_1 = mkN "molnbank" ;
  molnbildning_nn_1 = mkN "molnbildning" ;
  molnfri_av_1 = mkA "molnfri" "molnfritt" ;
  molngubbe_nn_1 = mkN "molngubbe" utrum ;
  molnhoejd_nn_1 = mkN "molnhцjd" "molnhцjder" ;
  molnhop_nn_1 = mkN "molnhop" ;
  molnig_av_1 = mkA "molnig" ;
  molnighet_nn_1 = mkN "molnighet" "molnigheter" ;
  molnkant_nn_1 = mkN "molnkant" "molnkanter" ;
  molnstod_nn_1 = mkN "molnstod" "molnstoder" ;
  molntapp_nn_1 = mkN "molntapp" ;
  molo_nn_1 = mkN "molo" "molor" ;
  molohamn_nn_1 = mkN "molohamn" ;
  moloken_av_1 = mkA "moloken" "moloket" ;
  moltyst_av_1 = mkA "moltyst" "moltyst" ;
  momang_nn_1 = mkN "momang" "momanger" ;
  moment_nn_1 = mkN "moment" neutrum ;
  momentan_av_1 = mkA "momentan" ;
  momentnyckel_nn_1 = mkN "momentnyckel" ;
  monad_nn_1 = mkN "monad" "monader" ;
  monark_nn_1 = mkN "monark" "monarker" ;
  monarki_nn_1 = mkN "monarki" "monarkier" ;
  monarkisk_av_1 = mkA "monarkisk" ;
  monarkist_nn_1 = mkN "monarkist" "monarkister" ;
  mondaen_av_1 = mkA "mondдn" ;
  mondaenitet_nn_1 = mkN "mondдnitet" "mondдniteter" ;
  mondial_av_1 = mkA "mondial" ;
  monegask_nn_1 = mkN "monegask" "monegasker" ;
  monetaer_av_1 = mkA "monetдr" ;
  mongo_nn_1 = mkN "mongo" "mongot" "mongon" "mongona" ;
  mongol_nn_1 = mkN "mongol" "mongoler" ;
  mongolflaeck_nn_1 = mkN "mongolflдck" ;
  mongolisk_av_1 = mkA "mongolisk" ;
  mongoliska_nn_1 = mkN "mongoliska" ;
  mongolrike_nn_1 = mkN "mongolrike" ;
  monist_nn_1 = mkN "monist" "monister" ;
  monitor_nn_1 = mkN "monitor" "monitorer" ;
  monoaminoxidas_nn_1 = mkN "monoaminoxidas" "monoaminoxidaser" ;
  monoftong_nn_1 = mkN "monoftong" "monoftonger" ;
  monogam_av_1 = mkA "monogam" ;
  monografi_nn_1 = mkN "monografi" "monografier" ;
  monogram_nn_1 = mkN "monogram" "monogrammet" "monogram" "monogrammen" ;
  monokel_nn_1 = mkN "monokel" ;
  monoklin_av_1 = mkA "monoklin" ;
  monokord_nn_1 = mkN "monokord" neutrum ;
  monokotyledon_nn_1 = mkN "monokotyledon" "monokotyledoner" ;
  monokrom_av_1 = mkA "monokrom" ;
  monokromatisk_av_1 = mkA "monokromatisk" ;
  monokultur_nn_1 = mkN "monokultur" "monokulturer" ;
  monolit_nn_1 = mkN "monolit" "monoliter" ;
  monolitisk_av_1 = mkA "monolitisk" ;
  monolog_nn_1 = mkN "monolog" "monologer" ;
  monoman_av_1 = mkA "monoman" ;
  monoplan_nn_1 = mkN "monoplan" neutrum ;
  monopol_nn_1 = mkN "monopol" neutrum ;
  monopolist_nn_1 = mkN "monopolist" "monopolister" ;
  monopolstaellning_nn_1 = mkN "monopolstдllning" ;
  monosackarid_nn_1 = mkN "monosackarid" "monosackarider" ;
  monosyllabisk_av_1 = mkA "monosyllabisk" ;
  monoton_av_1 = mkA "monoton" ;
  monotonitet_nn_1 = mkN "monotonitet" "monotoniteter" ;
  monotoniundvikare_nn_1 = mkN "monotoniundvikare" "monotoniundvikare" ;
  monotype_nn_1 = mkN "monotype" "monotyper" ;
  monseigneur_nn_1 = mkN "monseigneur" "monseigneurer" ;
  monsignore_nn_1 = mkN "monsignore" "monsignorer" ;
  monster_nn_1 = mkN "monster" neutrum ;
  monstrans_nn_1 = mkN "monstrans" "monstranser" ;
  monstruoes_av_1 = mkA "monstruцs" ;
  monstruositet_nn_1 = mkN "monstruositet" "monstruositeter" ;
  monsun_nn_1 = mkN "monsun" "monsuner" ;
  monsunkantring_nn_1 = mkN "monsunkantring" ;
  montage_nn_1 = mkN "montage" "montaget" "montage" "montagen" ;
  monter_nn_1 = mkN "monter" ;
  monterbar_av_1 = mkA "monterbar" ;
  montering_nn_1 = mkN "montering" ;
  monteringsfaerdig_av_1 = mkA "monteringsfдrdig" ;
  montoer_nn_1 = mkN "montцr" "montцrer" ;
  monument_nn_1 = mkN "monument" neutrum ;
  monumental_av_1 = mkA "monumental" ;
  monumentalbyggnad_nn_1 = mkN "monumentalbyggnad" "monumentalbyggnader" ;
  monumentalitet_nn_1 = mkN "monumentalitet" "monumentaliteter" ;
  moped_nn_1 = mkN "moped" "mopeder" ;
  mopedist_nn_1 = mkN "mopedist" "mopedister" ;
  mopp_nn_1 = mkN "mopp" ;
  moppe_nn_1 = mkN "moppe" utrum ;
  mops_nn_1 = mkN "mops" ;
  mopsig_av_1 = mkA "mopsig" ;
  mor_nn_1 = mkN "moder" "modern" "mцdrar" "mцdrarna" ;
  mor_nn_2 = mkN "mor" "moren" "morer" "morerna" ;
  mor_unge_konflikt_nn_1 = mkN "mor-unge-konflikt" "mor-unge-konflikter" ;
  moraen_nn_1 = mkN "morдn" "morдner" ;
  moraenmark_nn_1 = mkN "morдnmark" "morдnmarker" ;
  moraensluttning_nn_1 = mkN "morдnsluttning" ;
  morakniv_nn_1 = mkN "morakniv" ;
  moral_nn_1 = mkN "moral" "moraler" ;
  moralbegrepp_nn_1 = mkN "moralbegrepp" neutrum ;
  moralisk_av_1 = mkA "moralisk" ;
  moralist_nn_1 = mkN "moralist" "moralister" ;
  moralitet_nn_1 = mkN "moralitet" "moraliteter" ;
  moralsed_nn_1 = mkN "moralsed" "moralseder" ;
  moras_nn_1 = mkN "moras" neutrum ;
  moratorium_nn_1 = mkN "moratorium" "moratoriet" "moratorier" "moratorierna" ;
  morbiditet_nn_1 = mkN "morbiditet" "morbiditeter" ;
  morbror_nn_1 = mkN "morbror" "morbrцder" ;
  mord_nn_1 = mkN "mord" neutrum ;
  mordaengel_nn_1 = mkN "mordдngel" ;
  mordbraennare_nn_1 = mkN "mordbrдnnare" "mordbrдnnare" ;
  mordbrand_nn_1 = mkN "mordbrand" "mordbrдnder" ;
  mordisk_av_1 = mkA "mordisk" ;
  mordkommission_nn_1 = mkN "mordkommission" "mordkommissioner" ;
  mordlysten_av_1 = mkA "mordlysten" "mordlystet" ;
  mordlystnad_nn_1 = mkN "mordlystnad" "mordlystnader" ;
  mordmisstaenkt_av_1 = mkA "mordmisstдnkt" "mordmisstдnkt" ;
  mordoffer_nn_1 = mkN "mordoffer" neutrum ;
  mordvapen_nn_1 = mkN "mordvapen" "mordvapnet" "mordvapen" "mordvapnen" ;
  morell_nn_1 = mkN "morell" "moreller" ;
  morfem_nn_1 = mkN "morfem" neutrum ;
  morfemgraens_nn_1 = mkN "morfemgrдns" "morfemgrдnser" ;
  morfinist_nn_1 = mkN "morfinist" "morfinister" ;
  morfoeraelder_nn_1 = mkN "morfцrдlder" ;
  morfogenes_nn_1 = mkN "morfogenes" "morfogeneser" ;
  morfologi_nn_1 = mkN "morfologi" "morfologier" ;
  morfologisk_av_1 = mkA "morfologisk" ;
  morganatisk_av_1 = mkA "morganatisk" ;
  morgon_nn_1 = mkN "morgon" "morgonen" "morgnar" "morgnarna" ;
  morgonandakt_nn_1 = mkN "morgonandakt" "morgonandakter" ;
  morgonboen_nn_1 = mkN "morgonbцn" "morgonbцner" ;
  morgondag_nn_1 = mkN "morgondag" ;
  morgongudstjaenst_nn_1 = mkN "morgongudstjдnst" "morgongudstjдnster" ;
  morgonluft_ab_1 = mkAdv "morgonluft" ;
  morgonmaenniska_nn_1 = mkN "morgonmдnniska" ;
  morgonpigg_av_1 = mkA "morgonpigg" ;
  morgonrock_nn_1 = mkN "morgonrock" ;
  morgonrodnad_nn_1 = mkN "morgonrodnad" "morgonrodnader" ;
  morgonsaang_nn_1 = mkN "morgonsеng" "morgonsеnger" ;
  morgonsamling_nn_1 = mkN "morgonsamling" ;
  morgonstund_nn_1 = mkN "morgonstund" "morgonstunder" ;
  morgontidning_nn_1 = mkN "morgontidning" ;
  morian_nn_1 = mkN "morian" "morianer" ;
  moring_nn_1 = mkN "moring" ;
  moringsankare_nn_1 = mkN "moringsankare" "moringsankaret" "moringsankare" "moringsankarna" ;
  moringsboj_nn_1 = mkN "moringsboj" ;
  morisk_av_1 = mkA "morisk" ;
  morisk_nn_1 = mkN "morisk" "morisker" ;
  morkullsstraeck_nn_1 = mkN "morkullsstrдck" neutrum ;
  mormon_nn_1 = mkN "mormon" "mormoner" ;
  mormonsk_av_1 = mkA "mormonsk" ;
  mormor_nn_1 = mkN "mormoder" "mormodern" "mormцdrar" "mormцdrarna" ;
  mormorsstaang_nn_1 = mkN "mormorsstеng" "mormorsstдnger" ;
  morot_nn_1 = mkN "morot" "morцtter" ;
  morrhaar_nn_1 = mkN "morrhеr" neutrum ;
  morsarv_nn_1 = mkN "morsarv" neutrum ;
  morsefyr_nn_1 = mkN "morsefyr" ;
  morsesignal_nn_1 = mkN "morsesignal" "morsesignaler" ;
  morsgris_nn_1 = mkN "morsgris" ;
  morsk_av_1 = mkA "morsk" ;
  morslott_nn_1 = mkN "morslott" "morslotter" ;
  morssida_nn_1 = mkN "morssida" ;
  mortalitet_nn_1 = mkN "mortalitet" "mortaliteter" ;
  mortel_nn_1 = mkN "mortel" ;
  mortifikation_nn_1 = mkN "mortifikation" "mortifikationer" ;
  mosaik_nn_1 = mkN "mosaik" "mosaiker" ;
  mosaiklandskap_nn_1 = mkN "mosaiklandskap" "mosaiklandskapet" "mosaiklandskapen" "mosaiklandskapena" ;
  mosaikmoenster_nn_1 = mkN "mosaikmцnster" neutrum ;
  mosaiksoem_nn_1 = mkN "mosaiksцm" "mosaiksцmmen" "mosaiksцmmar" "mosaiksцmmarna" ;
  mosaisk_av_1 = mkA "mosaisk" ;
  mosambikier_nn_1 = mkN "moзambikier" "moзambikiern" "moзambikier" "moзambikierna" ;
  mosambikisk_av_1 = mkA "moзambikisk" ;
  moselvin_nn_1 = mkN "moselvin" "moselvinet" "moselviner" "moselvinerna" ;
  mosig_av_1 = mkA "mosig" ;
  moske_nn_1 = mkN "moskй" "moskйer" ;
  moskit_nn_1 = mkN "moskit" "moskiter" ;
  moskitnaet_nn_1 = mkN "moskitnдt" neutrum ;
  moskovit_nn_1 = mkN "moskovit" "moskoviter" ;
  moskovitisk_av_1 = mkA "moskovitisk" ;
  mossbelupen_av_1 = mkA "mossbelupen" "mossbelupet" ;
  mosse_nn_1 = mkN "mosse" utrum ;
  mossfolk_nn_1 = mkN "mossfolk" neutrum ;
  mossfynd_nn_1 = mkN "mossfynd" neutrum ;
  mossgroen_av_1 = mkA "mossgrцn" ;
  mossig_av_1 = mkA "mossig" ;
  mosskultur_nn_1 = mkN "mosskultur" "mosskulturer" ;
  mosslik_nn_1 = mkN "mosslik" neutrum ;
  mossrot_nn_1 = mkN "mossrot" "mossrцtter" ;
  moster_nn_1 = mkN "moster" ;
  mosterlig_av_1 = mkA "mosterlig" ;
  mot_ab_1 = mkAdv "mot" ;
  mot_nn_1 = mkN "mot" neutrum ;
  motaatgaerd_nn_1 = mkN "motеtgдrd" "motеtgдrder" ;
  motanfall_nn_1 = mkN "motanfall" neutrum ;
  motargument_nn_1 = mkN "motargument" neutrum ;
  motbevis_nn_1 = mkN "motbevis" neutrum ;
  motbild_nn_1 = mkN "motbild" "motbilder" ;
  motbjudande_av_1 = mkA "motbjudande" ;
  motbok_nn_1 = mkN "motbok" "motbцcker" ;
  motdrag_nn_1 = mkN "motdrag" neutrum ;
  motell_nn_1 = mkN "motell" neutrum ;
  motett_nn_1 = mkN "motett" "motetter" ;
  motfraaga_nn_1 = mkN "motfrеga" ;
  motgaang_nn_1 = mkN "motgеng" ;
  motgift_nn_1 = mkN "motgift" "motgiftet" "motgifter" "motgifterna" ;
  mothaall_nn_1 = mkN "mothеll" neutrum ;
  mothaars_ab_1 = mkAdv "mothеrs" ;
  mothugg_nn_1 = mkN "mothugg" neutrum ;
  motig_av_1 = mkA "motig" ;
  motighet_nn_1 = mkN "motighet" "motigheter" ;
  motion_nn_1 = mkN "motion" "motioner" ;
  motionaer_nn_1 = mkN "motionдr" "motionдrer" ;
  motionsanlaeggning_nn_1 = mkN "motionsanlдggning" ;
  motionscykel_nn_1 = mkN "motionscykel" ;
  motionsflod_nn_1 = mkN "motionsflod" "motionsfloder" ;
  motionsidrott_nn_1 = mkN "motionsidrott" "motionsidrotter" ;
  motionsspaar_nn_1 = mkN "motionsspеr" neutrum ;
  motionstid_nn_1 = mkN "motionstid" "motionstider" ;
  motiv_nn_1 = mkN "motiv" neutrum ;
  motivation_nn_1 = mkN "motivation" "motivationer" ;
  motivering_nn_1 = mkN "motivering" ;
  motivisk_av_1 = mkA "motivisk" ;
  motivkrets_nn_1 = mkN "motivkrets" ;
  motlut_nn_1 = mkN "motlut" neutrum ;
  motor_nn_1 = mkN "motor" "motorer" ;
  motorbaat_nn_1 = mkN "motorbеt" ;
  motorcykel_nn_1 = mkN "motorcykel" ;
  motorcykeltaevling_nn_1 = mkN "motorcykeltдvling" ;
  motorcyklist_nn_1 = mkN "motorcyklist" "motorcyklister" ;
  motorcylinder_nn_1 = mkN "motorcylinder" ;
  motordriven_av_1 = mkA "motordriven" "motordrivet" ;
  motoreffekt_nn_1 = mkN "motoreffekt" "motoreffekter" ;
  motorfartyg_nn_1 = mkN "motorfartyg" neutrum ;
  motorfordon_nn_1 = mkN "motorfordon" neutrum ;
  motorhotell_nn_1 = mkN "motorhotell" neutrum ;
  motorhuv_nn_1 = mkN "motorhuv" ;
  motorisk_av_1 = mkA "motorisk" ;
  motorist_nn_1 = mkN "motorist" "motorister" ;
  motorkryssare_nn_1 = mkN "motorkryssare" "motorkryssare" ;
  motorman_nn_1 = mkN "motorman" "motormannen" "motormдn" "motormдnnen" ;
  motorseglare_nn_1 = mkN "motorseglare" "motorseglare" ;
  motorstopp_nn_1 = mkN "motorstopp" neutrum ;
  motorstyrka_nn_1 = mkN "motorstyrka" ;
  motortorpedbaat_nn_1 = mkN "motortorpedbеt" ;
  motortrafikled_nn_1 = mkN "motortrafikled" "motortrafikleder" ;
  motorvaeg_nn_1 = mkN "motorvдg" ;
  motorvagn_nn_1 = mkN "motorvagn" ;
  motpart_nn_1 = mkN "motpart" "motparter" ;
  motpol_nn_1 = mkN "motpol" "motpoler" ;
  motprestation_nn_1 = mkN "motprestation" "motprestationer" ;
  motrevolution_nn_1 = mkN "motrevolution" "motrevolutioner" ;
  motsaegelse_nn_1 = mkN "motsдgelse" "motsдgelser" ;
  motsaegelsefull_av_1 = mkA "motsдgelsefull" ;
  motsaettlig_av_1 = mkA "motsдttlig" ;
  motsaettning_nn_1 = mkN "motsдttning" ;
  motsats_nn_1 = mkN "motsats" "motsatser" ;
  motsatsfoerhaallande_nn_1 = mkN "motsatsfцrhеllande" ;
  motsatt_av_1 = mkA "motsatt" ;
  motskott_nn_1 = mkN "motskott" neutrum ;
  motsols_ab_1 = mkAdv "motsols" ;
  motspaenstig_av_1 = mkA "motspдnstig" ;
  motspelare_nn_1 = mkN "motspelare" "motspelare" ;
  motstaaende_av_1 = mkA "motstеende" ;
  motstaand_nn_1 = mkN "motstеnd" neutrum ;
  motstaandare_nn_1 = mkN "motstеndare" "motstеndare" ;
  motstaandskraftig_av_1 = mkA "motstеndskraftig" ;
  motstaandsman_nn_1 = mkN "motstеndsman" "motstеndsmannen" "motstеndsmдn" "motstеndsmдnnen" ;
  motstaandsnaeste_nn_1 = mkN "motstеndsnдste" ;
  motstaandsomraade_nn_1 = mkN "motstеndsomrеde" ;
  motstaandsroerelse_nn_1 = mkN "motstеndsrцrelse" "motstеndsrцrelser" ;
  motstaandssvetsning_nn_1 = mkN "motstеndssvetsning" ;
  motstoet_nn_1 = mkN "motstцt" ;
  motstraevig_av_1 = mkA "motstrдvig" ;
  motstridande_av_1 = mkA "motstridande" ;
  motstridig_av_1 = mkA "motstridig" ;
  motstroem_nn_1 = mkN "motstrцm" "motstrцmmen" "motstrцmmar" "motstrцmmarna" ;
  motstroems_ab_1 = mkAdv "motstrцms" ;
  motstrof_nn_1 = mkN "motstrof" "motstrofer" ;
  motsvarande_av_1 = mkA "motsvarande" ;
  motsvarighet_nn_1 = mkN "motsvarighet" "motsvarigheter" ;
  mott_nn_1 = mkN "mott" neutrum ;
  motta_vb_1 = mkV "motta" "mottar" "motta" "mottog" "mottagit" "mottagen" ;
  mottagande_nn_1 = mkN "mottagande" ;
  mottagare_nn_1 = mkN "mottagare" "mottagare" ;
  mottagarsaeck_nn_1 = mkN "mottagarsдck" ;
  mottaglig_av_1 = mkA "mottaglig" ;
  mottagning_nn_1 = mkN "mottagning" ;
  mottagningsbevis_nn_1 = mkN "mottagningsbevis" neutrum ;
  motti_nn_1 = mkN "motti" "mottin" "motti" "mottina" ;
  motto_nn_1 = mkN "motto" "mottot" "motton" "mottona" ;
  moturs_ab_1 = mkAdv "moturs" ;
  motvikt_nn_1 = mkN "motvikt" "motvikter" ;
  motvillig_av_1 = mkA "motvillig" ;
  motvind_nn_1 = mkN "motvind" ;
  mousse_nn_1 = mkN "mousse" "mousser" ;
  muckare_nn_1 = mkN "muckare" "muckare" ;
  mudd_nn_1 = mkN "mudd" ;
  mudderverk_nn_1 = mkN "mudderverk" neutrum ;
  muddrig_av_1 = mkA "muddrig" ;
  muff_nn_1 = mkN "muff" ;
  muffel_nn_1 = mkN "muffel" ;
  muffelfaerg_nn_1 = mkN "muffelfдrg" "muffelfдrger" ;
  muffelugn_nn_1 = mkN "muffelugn" ;
  muffins_nn_1 = mkN "muffins" "muffinsen" "muffins" "muffinsen" ;
  mufflon_nn_1 = mkN "mufflon" "muffloner" ;
  mufflonfaar_nn_1 = mkN "mufflonfеr" neutrum ;
  mufti_nn_1 = mkN "mufti" "muftin" "muftier" "muftierna" ;
  mugg_nn_1 = mkN "mugg" ;
  muhammedan_nn_1 = mkN "muhammedan" "muhammedaner" ;
  muhammedansk_av_1 = mkA "muhammedansk" ;
  mulaasna_nn_1 = mkN "mulеsna" ;
  mulatt_nn_1 = mkN "mulatt" "mulatter" ;
  mule_nn_1 = mkN "mule" utrum ;
  mulen_av_1 = mkA "mulen" "mulet" ;
  mullbaenk_nn_1 = mkN "mullbдnk" ;
  mullbaer_nn_1 = mkN "mullbдr" neutrum ;
  mullbaersfikon_nn_1 = mkN "mullbдrsfikon" neutrum ;
  mullbaersfikontraed_nn_1 = mkN "mullbдrsfikontrдd" neutrum ;
  mullbaersspinnare_nn_1 = mkN "mullbдrsspinnare" "mullbдrsspinnare" ;
  mullbaerstraed_nn_1 = mkN "mullbдrstrдd" neutrum ;
  mullhalt_nn_1 = mkN "mullhalt" "mullhalter" ;
  mullig_av_1 = mkA "mullig" ;
  mullsork_nn_1 = mkN "mullsork" ;
  mullvad_nn_1 = mkN "mullvad" ;
  mullvadshoeg_nn_1 = mkN "mullvadshцg" ;
  multe_nn_1 = mkN "multe" utrum ;
  multen_av_1 = mkA "multen" "multet" ;
  multihandikapp_nn_1 = mkN "multihandikapp" neutrum ;
  multilateral_av_1 = mkA "multilateral" ;
  multinationell_av_1 = mkA "multinationell" ;
  multipel_av_1 = mkA "multipel" "multipelt" "multipla" "multipla" "multiplare" "multiplast" "multiplaste" ;
  multipeltaag_nn_1 = mkN "multipeltеg" neutrum ;
  multiplikand_nn_1 = mkN "multiplikand" "multiplikander" ;
  multiplikation_nn_1 = mkN "multiplikation" "multiplikationer" ;
  multiplikationstabell_nn_1 = mkN "multiplikationstabell" "multiplikationstabeller" ;
  multiplikationstecken_nn_1 = mkN "multiplikationstecken" "multiplikationstecknet" "multiplikationstecken" "multiplikationstecknen" ;
  multiplikator_nn_1 = mkN "multiplikator" "multiplikatorer" ;
  multituberkulat_nn_1 = mkN "multituberkulat" neutrum ;
  mumie_nn_1 = mkN "mumie" "mumier" ;
  mumrik_nn_1 = mkN "mumrik" ;
  mumsmums_nn_1 = mkN "mumsmums" ;
  mun_nn_1 = mkN "mun" "munnen" "munnar" "munnarna" ;
  munart_nn_1 = mkN "munart" "munarter" ;
  mundering_nn_1 = mkN "mundering" ;
  mungo_nn_1 = mkN "mungo" "mungor" ;
  municipal_av_1 = mkA "municipal" ;
  municipium_nn_1 = mkN "municipium" "municipiet" "municipier" "municipierna" ;
  munk_nn_1 = mkN "munk" ;
  munkavle_nn_1 = mkN "munkavle" utrum ;
  munkcell_nn_1 = mkN "munkcell" "munkceller" ;
  munkfoerband_nn_1 = mkN "munkfцrband" neutrum ;
  munklikoer_nn_1 = mkN "munklikцr" "munklikцrer" ;
  munkorden_nn_1 = mkN "munkorden" ;
  munkorg_nn_1 = mkN "munkorg" ;
  munkorgslag_nn_1 = mkN "munkorgslag" ;
  munkstol_nn_1 = mkN "munkstol" ;
  munlaas_ab_1 = mkAdv "munlеs" ;
  munlaas_nn_1 = mkN "munlеs" neutrum ;
  munlag_nn_1 = mkN "munlag" neutrum ;
  munsbit_nn_1 = mkN "munsbit" ;
  munskaenk_nn_1 = mkN "munskдnk" ;
  munskydd_nn_1 = mkN "munskydd" neutrum ;
  munslemhinna_nn_1 = mkN "munslemhinna" ;
  munspel_nn_1 = mkN "munspel" "munspelet" "munspel" "munspelen" ;
  munter_av_1 = mkA "munter" "muntert" "muntra" "muntra" "muntrare" "muntrast" "muntraste" ;
  muntergoek_nn_1 = mkN "muntergцk" ;
  munterhet_nn_1 = mkN "munterhet" "munterheter" ;
  muntlig_av_1 = mkA "muntlig" ;
  muntligen_ab_1 = mkAdv "muntligen" ;
  muntration_nn_1 = mkN "muntration" "muntrationer" ;
  munvatten_nn_1 = mkN "munvatten" "munvattnet" "munvatten" "munvattnen" ;
  munvig_av_1 = mkA "munvig" ;
  mur_nn_1 = mkN "mur" ;
  mural_av_1 = mkA "mural" ;
  muralmaalning_nn_1 = mkN "muralmеlning" ;
  murankare_nn_1 = mkN "murankare" "murankaret" "murankare" "murankarna" ;
  murare_nn_1 = mkN "murare" "murare" ;
  murband_nn_1 = mkN "murband" neutrum ;
  murfoerband_nn_1 = mkN "murfцrband" neutrum ;
  murfog_nn_1 = mkN "murfog" ;
  murintag_nn_1 = mkN "murintag" neutrum ;
  murken_av_1 = mkA "murken" "murket" ;
  murkla_nn_1 = mkN "murkla" ;
  murkroen_nn_1 = mkN "murkrцn" neutrum ;
  murliv_nn_1 = mkN "murliv" neutrum ;
  murmel_nn_1 = mkN "murmel" ;
  murmeldjur_nn_1 = mkN "murmeldjur" neutrum ;
  murre_nn_1 = mkN "murre" utrum ;
  murrig_av_1 = mkA "murrig" ;
  murskift_nn_1 = mkN "murskift" neutrum ;
  murslev_nn_1 = mkN "murslev" ;
  mursten_nn_1 = mkN "mursten" "murstenen" "murstenar" "murstenarna" ;
  murvel_nn_1 = mkN "murvel" ;
  murverk_nn_1 = mkN "murverk" neutrum ;
  mus_nn_1 = mkN "mus" "musen" "mцss" "mцssen" ;
  mus_nn_2 = mkN "mus" ;
  musa_nn_1 = mkN "musa" ;
  musch_nn_1 = mkN "musch" "muscher" ;
  museal_av_1 = mkA "museal" ;
  museifoeremaal_nn_1 = mkN "museifцremеl" neutrum ;
  museifoerening_nn_1 = mkN "museifцrening" ;
  museimaessig_av_1 = mkA "museimдssig" ;
  muselman_nn_1 = mkN "muselman" "muselmaner" ;
  muselmansk_av_1 = mkA "muselmansk" ;
  musettedragspel_nn_1 = mkN "musettedragspel" "musettedragspelet" "musettedragspel" "musettedragspelen" ;
  museum_nn_1 = mkN "museum" "museet" "museer" "museerna" ;
  musgraa_av_1 = mkA "musgrе" "musgrеtt" ;
  musical_nn_1 = mkN "musical" "musicaler" ;
  musikal_av_1 = mkA "musikal" ;
  musikal_nn_1 = mkN "musikal" "musikaler" ;
  musikalisk_av_1 = mkA "musikalisk" ;
  musikalitet_nn_1 = mkN "musikalitet" "musikaliteter" ;
  musikanlaeggning_nn_1 = mkN "musikanlдggning" ;
  musikant_nn_1 = mkN "musikant" "musikanter" ;
  musikdirektoer_nn_1 = mkN "musikdirektцr" "musikdirektцrer" ;
  musikdrama_nn_1 = mkN "musikdrama" "musikdramat" "musikdraman" "musikdramana" ;
  musikensemble_nn_1 = mkN "musikensemble" "musikensembler" ;
  musiker_nn_1 = mkN "musiker" "musikern" "musiker" "musikerna" ;
  musikfoerlag_nn_1 = mkN "musikfцrlag" neutrum ;
  musikgrupp_nn_1 = mkN "musikgrupp" "musikgrupper" ;
  musikgudstjaenst_nn_1 = mkN "musikgudstjдnst" "musikgudstjдnster" ;
  musikgymnasium_nn_1 = mkN "musikgymnasium" "musikgymnasiet" "musikgymnasier" "musikgymnasierna" ;
  musikinstrument_nn_1 = mkN "musikinstrument" neutrum ;
  musikkaar_nn_1 = mkN "musikkеr" "musikkеrer" ;
  musikkafe_nn_1 = mkN "musikkafй" "musikkafйt" "musikkafйer" "musikkafйerna" ;
  musikkomposition_nn_1 = mkN "musikkomposition" "musikkompositioner" ;
  musikkonservatorium_nn_1 = mkN "musikkonservatorium" "musikkonservatoriet" "musikkonservatorier" "musikkonservatorierna" ;
  musikkvartett_nn_1 = mkN "musikkvartett" "musikkvartetter" ;
  musiklaerare_nn_1 = mkN "musiklдrare" "musiklдrare" ;
  musikliv_nn_1 = mkN "musikliv" neutrum ;
  musikolog_nn_1 = mkN "musikolog" "musikologer" ;
  musikstaemma_nn_1 = mkN "musikstдmma" ;
  musiktecken_nn_1 = mkN "musiktecken" "musiktecknet" "musiktecken" "musiktecknen" ;
  musikverk_nn_1 = mkN "musikverk" neutrum ;
  musikverksamhet_nn_1 = mkN "musikverksamhet" "musikverksamheter" ;
  musikvetenskap_nn_1 = mkN "musikvetenskap" "musikvetenskaper" ;
  musisk_av_1 = mkA "musisk" ;
  musjik_nn_1 = mkN "musjik" "musjiker" ;
  muskedunder_nn_1 = mkN "muskedunder" neutrum ;
  muskel_nn_1 = mkN "muskel" "muskeln" "muskler" "musklerna" ;
  muskelatrofi_nn_1 = mkN "muskelatrofi" "muskelatrofier" ;
  muskelbristning_nn_1 = mkN "muskelbristning" ;
  muskelbyggare_nn_1 = mkN "muskelbyggare" "muskelbyggare" ;
  muskelbyggnad_nn_1 = mkN "muskelbyggnad" "muskelbyggnader" ;
  muskelfiber_nn_1 = mkN "muskelfiber" "muskelfibern" "muskelfibrer" "muskelfibrerna" ;
  muskelfoerlamning_nn_1 = mkN "muskelfцrlamning" ;
  muskelfoertvining_nn_1 = mkN "muskelfцrtvining" ;
  muskelknutte_nn_1 = mkN "muskelknutte" utrum ;
  muskelkraft_nn_1 = mkN "muskelkraft" "muskelkrafter" ;
  muskelkramp_nn_1 = mkN "muskelkramp" "muskelkramper" ;
  muskellaengd_nn_1 = mkN "muskellдngd" "muskellдngder" ;
  muskelmage_nn_1 = mkN "muskelmage" utrum ;
  muskelryckning_nn_1 = mkN "muskelryckning" ;
  muskelsammandragning_nn_1 = mkN "muskelsammandragning" ;
  muskelspaenning_nn_1 = mkN "muskelspдnning" ;
  muskelspole_nn_1 = mkN "muskelspole" utrum ;
  muskelstaerkare_nn_1 = mkN "muskelstдrkare" "muskelstдrkare" ;
  muskelstraeckning_nn_1 = mkN "muskelstrдckning" ;
  muskelstyrka_nn_1 = mkN "muskelstyrka" ;
  muskeltraad_nn_1 = mkN "muskeltrеd" ;
  muskelvaevnad_nn_1 = mkN "muskelvдvnad" "muskelvдvnader" ;
  musketerare_nn_1 = mkN "musketerare" "musketerare" ;
  musketoer_nn_1 = mkN "musketцr" "musketцrer" ;
  muskoet_nn_1 = mkN "muskцt" "muskцter" ;
  muskoetgaffel_nn_1 = mkN "muskцtgaffel" ;
  muskotnoet_nn_1 = mkN "muskotnцt" "muskotnцtter" ;
  muskottraed_nn_1 = mkN "muskottrдd" neutrum ;
  muskulatur_nn_1 = mkN "muskulatur" "muskulaturer" ;
  muskuloes_av_1 = mkA "muskulцs" ;
  muslim_nn_1 = mkN "muslim" "muslimer" ;
  muslimsk_av_1 = mkA "muslimsk" ;
  muslin_nn_1 = mkN "muslin" "musliner" ;
  musmamma_nn_1 = mkN "musmamma" ;
  musoera_nn_1 = mkN "musцra" "musцrat" "musцron" "musцronen" ;
  musselform_nn_1 = mkN "musselform" "musselformer" ;
  musselskal_nn_1 = mkN "musselskal" neutrum ;
  musseron_nn_1 = mkN "musseron" "musseroner" ;
  mussla_nn_1 = mkN "mussla" ;
  must_nn_1 = mkN "must" "muster" ;
  mustang_nn_1 = mkN "mustang" "mustanger" ;
  mustasch_nn_1 = mkN "mustasch" "mustascher" ;
  musteri_nn_1 = mkN "musteri" "musterit" "musterier" "musterierna" ;
  mustig_av_1 = mkA "mustig" ;
  mutagen_av_1 = mkA "mutagen" ;
  mutagen_nn_1 = mkN "mutagen" "mutagener" ;
  mutant_nn_1 = mkN "mutant" "mutanter" ;
  mutation_nn_1 = mkN "mutation" "mutationer" ;
  mutkolv_nn_1 = mkN "mutkolv" ;
  mutsedel_nn_1 = mkN "mutsedel" ;
  mutter_nn_1 = mkN "mutter" ;
  mycelium_nn_1 = mkN "mycelium" "myceliet" "mycelier" "mycelierna" ;
  mycken_av_1 = mkA "mycken" "mycket" "myckna" "mer" "mest" ;
  mycket_ab_1 = mkAdv "mycket" ;
  mygg_nn_1 = mkN "mygg" neutrum ;
  myggbett_nn_1 = mkN "myggbett" neutrum ;
  myggfoenster_nn_1 = mkN "myggfцnster" neutrum ;
  mygglarv_nn_1 = mkN "mygglarv" "mygglarver" ;
  myggmedel_nn_1 = mkN "myggmedel" neutrum ;
  myggnaet_nn_1 = mkN "myggnдt" neutrum ;
  myglare_nn_1 = mkN "myglare" "myglare" ;
  mykolog_nn_1 = mkN "mykolog" "mykologer" ;
  mykologisk_av_1 = mkA "mykologisk" ;
  myling_nn_1 = mkN "myling" ;
  myllig_av_1 = mkA "myllig" ;
  myndig_av_1 = mkA "myndig" ;
  myndighet_nn_1 = mkN "myndighet" "myndigheter" ;
  myndighetsaalder_nn_1 = mkN "myndighetsеlder" ;
  myndighetsfoerklaring_nn_1 = mkN "myndighetsfцrklaring" ;
  myndighetsperson_nn_1 = mkN "myndighetsperson" "myndighetspersoner" ;
  myndling_nn_1 = mkN "myndling" ;
  mynning_nn_1 = mkN "mynning" ;
  mynningsarm_nn_1 = mkN "mynningsarm" ;
  mynningsbroms_nn_1 = mkN "mynningsbroms" ;
  mynningsladdare_nn_1 = mkN "mynningsladdare" "mynningsladdare" ;
  mynt_ab_1 = mkAdv "mynt" ;
  mynt_nn_1 = mkN "mynt" neutrum ;
  myntcirkulation_nn_1 = mkN "myntcirkulation" "myntcirkulationer" ;
  myntenhet_nn_1 = mkN "myntenhet" "myntenheter" ;
  myntmetall_nn_1 = mkN "myntmetall" "myntmetaller" ;
  myntrealisation_nn_1 = mkN "myntrealisation" "myntrealisationer" ;
  myntsystem_nn_1 = mkN "myntsystem" neutrum ;
  mynttecken_nn_1 = mkN "mynttecken" "mynttecknet" "mynttecken" "mynttecknen" ;
  myntunion_nn_1 = mkN "myntunion" "myntunioner" ;
  myntvaloer_nn_1 = mkN "myntvalцr" "myntvalцrer" ;
  myntverk_nn_1 = mkN "myntverk" neutrum ;
  myntvikt_nn_1 = mkN "myntvikt" "myntvikter" ;
  myom_nn_1 = mkN "myom" neutrum ;
  myon_nn_1 = mkN "myon" "myoner" ;
  myopisk_av_1 = mkA "myopisk" ;
  myosin_nn_1 = mkN "myosin" "myosiner" ;
  myr_nn_1 = mkN "myr" ;
  myraegg_nn_1 = mkN "myrдgg" neutrum ;
  myrbagge_nn_1 = mkN "myrbagge" utrum ;
  myrdrottning_nn_1 = mkN "myrdrottning" ;
  myrgaest_nn_1 = mkN "myrgдst" "myrgдster" ;
  myrholme_nn_1 = mkN "myrholme" utrum ;
  myriad_nn_1 = mkN "myriad" "myriader" ;
  myrkant_nn_1 = mkN "myrkant" "myrkanter" ;
  myrkott_nn_1 = mkN "myrkott" ;
  myrkrypning_nn_1 = mkN "myrkrypning" ;
  myrland_nn_1 = mkN "myrland" neutrum ;
  myrlejon_nn_1 = mkN "myrlejon" neutrum ;
  myrlilja_nn_1 = mkN "myrlilja" ;
  myrmalm_nn_1 = mkN "myrmalm" "myrmalmer" ;
  myrmark_nn_1 = mkN "myrmark" "myrmarker" ;
  myrslok_nn_1 = mkN "myrslok" ;
  myrstack_nn_1 = mkN "myrstack" ;
  myrten_nn_1 = mkN "myrten" "myrtenn" "myrtnar" "myrtnarna" ;
  myrvaext_nn_1 = mkN "myrvдxt" "myrvдxter" ;
  mysdress_nn_1 = mkN "mysdress" ;
  mysig_av_1 = mkA "mysig" ;
  myskdjur_nn_1 = mkN "myskdjur" neutrum ;
  myskhjort_nn_1 = mkN "myskhjort" ;
  myskolja_nn_1 = mkN "myskolja" ;
  myskoxe_nn_1 = mkN "myskoxe" utrum ;
  mysteriereligion_nn_1 = mkN "mysteriereligion" "mysteriereligioner" ;
  mysteriespel_nn_1 = mkN "mysteriespel" "mysteriespelet" "mysteriespel" "mysteriespelen" ;
  mysterioes_av_1 = mkA "mysteriцs" ;
  mysterium_nn_1 = mkN "mysterium" "mysteriet" "mysterier" "mysterierna" ;
  mystifik_av_1 = mkA "mystifik" ;
  mystifikation_nn_1 = mkN "mystifikation" "mystifikationer" ;
  mystiker_nn_1 = mkN "mystiker" "mystikern" "mystiker" "mystikerna" ;
  mystisk_av_1 = mkA "mystisk" ;
  myt_nn_1 = mkN "myt" "myter" ;
  mytbildning_nn_1 = mkN "mytbildning" ;
  myteri_nn_1 = mkN "myteri" "myterit" "myterier" "myterierna" ;
  myterist_nn_1 = mkN "myterist" "myterister" ;
  mytisk_av_1 = mkA "mytisk" ;
  mytologi_nn_1 = mkN "mytologi" "mytologier" ;
  mytologisk_av_1 = mkA "mytologisk" ;
  mytoman_nn_1 = mkN "mytoman" "mytomaner" ;
  n_aarig_av_1 = mkA "n-еrig" ;
  n_aaring_nn_1 = mkN "n-еring" ;
  n_procentig_av_1 = mkA "n-procentig" ;
  n_talsbiolog_nn_1 = mkN "n-talsbiolog" "n-talsbiologer" ;
  n_talsforskare_nn_1 = mkN "n-talsforskare" "n-talsforskare" ;
  n_talsfysiker_nn_1 = mkN "n-talsfysiker" "n-talsfysikern" "n-talsfysiker" "n-talsfysikerna" ;
  n_talskonstnaer_nn_1 = mkN "n-talskonstnдr" "n-talskonstnдrer" ;
  naad_nn_2 = mkN "nеd" ;
  naadaar_nn_1 = mkN "nеdеr" neutrum ;
  naadaskott_nn_1 = mkN "nеdaskott" neutrum ;
  naadastoet_nn_1 = mkN "nеdastцt" ;
  naadaval_nn_1 = mkN "nеdaval" neutrum ;
  naadeansoekning_nn_1 = mkN "nеdeansцkning" ;
  naadebevis_nn_1 = mkN "nеdebevis" neutrum ;
  naadebord_nn_1 = mkN "nеdebord" neutrum ;
  naadehjon_nn_1 = mkN "nеdehjon" neutrum ;
  naadelig_av_1 = mkA "nеdelig" ;
  naadeligen_ab_1 = mkAdv "nеdeligen" ;
  naademedel_nn_1 = mkN "nеdemedel" neutrum ;
  naadevedermaele_nn_1 = mkN "nеdevedermдle" ;
  naadig_av_1 = mkA "nеdig" ;
  naagonsin_ab_1 = mkAdv "nеgonsin" ;
  naagonstaedes_ab_1 = mkAdv "nеgonstдdes" ;
  naagonstans_ab_1 = mkAdv "nеgonstans" ;
  naagonvart_ab_1 = mkAdv "nеgonvart" ;
  naagorlunda_ab_1 = mkAdv "nеgorlunda" ;
  naagotsaanaer_ab_1 = mkAdv "nеgotsеnдr" ;
  naal_nn_1 = mkN "nеl" ;
  naalbrev_nn_1 = mkN "nеlbrev" neutrum ;
  naalfil_nn_1 = mkN "nеlfil" ;
  naalfin_av_1 = mkA "nеlfin" ;
  naalkort_nn_1 = mkN "nеlkort" neutrum ;
  naalmikrofon_nn_1 = mkN "nеlmikrofon" "nеlmikrofoner" ;
  naalpeng_nn_1 = mkN "nеlpeng" ;
  naalsoega_nn_1 = mkN "nеlsцga" "nеlsцgat" "nеlsцgon" "nеlsцgonen" ;
  naalspets_nn_1 = mkN "nеlspets" ;
  naalstick_nn_1 = mkN "nеlstick" neutrum ;
  naalsting_nn_1 = mkN "nеlsting" neutrum ;
  naalstygn_nn_1 = mkN "nеlstygn" neutrum ;
  naalventil_nn_1 = mkN "nеlventil" "nеlventiler" ;
  naansin_ab_1 = mkAdv "nеnsin" ;
  naanvart_ab_1 = mkAdv "nеnvart" ;
  naat_nn_1 = mkN "nеt" ;
  naatsaanaer_ab_1 = mkAdv "nеtsеnдr" ;
  nabb_nn_1 = mkN "nabb" ;
  nabbe_nn_1 = mkN "nabbe" utrum ;
  nabo_nn_1 = mkN "nabo" "nabor" ;
  nabob_nn_1 = mkN "nabob" "nabober" ;
  nachspil_nn_1 = mkN "nachspil" neutrum ;
  nackben_nn_1 = mkN "nackben" neutrum ;
  nackbjudning_nn_1 = mkN "nackbjudning" ;
  nackdel_nn_1 = mkN "nackdel" "nackdelen" "nackdelar" "nackdelarna" ;
  nacke_nn_1 = mkN "nacke" utrum ;
  nackknut_nn_1 = mkN "nackknut" ;
  nackman_nn_1 = mkN "nackman" ;
  nackspaerr_nn_1 = mkN "nackspдrr" ;
  nackstyv_av_1 = mkA "nackstyv" ;
  nacksving_nn_1 = mkN "nacksving" neutrum ;
  nacktofs_nn_1 = mkN "nacktofs" ;
  naebb_nn_1 = mkN "nдbb" ;
  naebbdjur_nn_1 = mkN "nдbbdjur" neutrum ;
  naebbig_av_1 = mkA "nдbbig" ;
  naebbknoel_nn_1 = mkN "nдbbknцl" ;
  naebbmus_nn_1 = mkN "nдbbmus" "nдbbmusen" "nдbbmцss" "nдbbmцssen" ;
  naebbsko_nn_1 = mkN "nдbbsko" "nдbbskor" ;
  naebbval_nn_1 = mkN "nдbbval" ;
  naeck_av_1 = mkA "nдck" ;
  naektergal_nn_1 = mkN "nдktergal" ;
  naektergalsslag_nn_1 = mkN "nдktergalsslag" neutrum ;
  naemligen_ab_1 = mkAdv "nдmligen" ;
  naemnare_nn_1 = mkN "nдmnare" "nдmnare" ;
  naemnbar_av_1 = mkA "nдmnbar" ;
  naemnd_nn_1 = mkN "nдmnd" "nдmnder" ;
  naemndeman_nn_1 = mkN "nдmndeman" "nдmndemannen" "nдmndemдn" "nдmndemдnnen" ;
  naemnvaerd_av_1 = mkA "nдmnvдrd" "nдmnvдrt" ;
  naepen_av_1 = mkA "nдpen" "nдpet" ;
  naeppeligen_ab_1 = mkAdv "nдppeligen" ;
  naer_ab_1 = mkAdv "nдr" ;
  naera_ab_1 = mkAdv "nдra" ;
  naera_av_1 = mkA "nдra" "nдra" "nдra" "nдrmare" "nдrmast" ;
  naerande_av_1 = mkA "nдrande" ;
  naerapaa_ab_1 = mkAdv "nдrapе" ;
  naerbelaegen_av_1 = mkA "nдrbelдgen" "nдrbelдget" ;
  naerbild_nn_1 = mkN "nдrbild" "nдrbilder" ;
  naerbutik_nn_1 = mkN "nдrbutik" "nдrbutiker" ;
  naergaangen_av_1 = mkA "nдrgеngen" "nдrgеnget" ;
  naerhet_nn_1 = mkN "nдrhet" "nдrheter" ;
  naerig_av_1 = mkA "nдrig" ;
  naering_nn_1 = mkN "nдring" ;
  naeringsaemne_nn_1 = mkN "nдringsдmne" ;
  naeringsbrist_nn_1 = mkN "nдringsbrist" "nдringsbrister" ;
  naeringsfaang_nn_1 = mkN "nдringsfеng" neutrum ;
  naeringsfattig_av_1 = mkA "nдringsfattig" ;
  naeringsfrihet_nn_1 = mkN "nдringsfrihet" "nдringsfriheter" ;
  naeringsfrihetsombudsman_nn_1 = mkN "nдringsfrihetsombudsman" "nдringsfrihetsombudsmannen" "nдringsfrihetsombudsmдn" "nдringsfrihetsombudsmдnnen" ;
  naeringsfysiologisk_av_1 = mkA "nдringsfysiologisk" ;
  naeringsgren_nn_1 = mkN "nдringsgren" "nдringsgrenen" "nдringsgrenar" "nдringsgrenarna" ;
  naeringsidkare_nn_1 = mkN "nдringsidkare" "nдringsidkare" ;
  naeringskedja_nn_1 = mkN "nдringskedja" ;
  naeringsloesning_nn_1 = mkN "nдringslцsning" ;
  naeringsprocess_nn_1 = mkN "nдringsprocess" "nдringsprocesser" ;
  naeringsrik_av_1 = mkA "nдringsrik" ;
  naeringssalt_nn_1 = mkN "nдringssalt" "nдringssaltet" "nдringssalter" "nдringssalterna" ;
  naeringsvaerde_nn_1 = mkN "nдringsvдrde" ;
  naerkamp_nn_1 = mkN "nдrkamp" "nдrkamper" ;
  naerking_nn_1 = mkN "nдrking" ;
  naerkingsk_av_1 = mkA "nдrkingsk" ;
  naerlagd_av_1 = mkA "nдrlagd" "nдrlagt" ;
  naerliggande_av_1 = mkA "nдrliggande" ;
  naermande_nn_1 = mkN "nдrmande" ;
  naermevaerde_nn_1 = mkN "nдrmevдrde" ;
  naermiljoe_nn_1 = mkN "nдrmiljц" "nдrmiljцn" "nдrmiljцer" "nдrmiljцerna" ;
  naeromraade_nn_1 = mkN "nдromrеde" ;
  naerpassage_nn_1 = mkN "nдrpassage" "nдrpassager" ;
  naerpunkt_nn_1 = mkN "nдrpunkt" "nдrpunkter" ;
  naersalt_nn_1 = mkN "nдrsalt" "nдrsaltet" "nдrsalter" "nдrsalterna" ;
  naerskyld_av_1 = mkA "nдrskyld" "nдrskylt" ;
  naersluta_vb_1 = mkV "nдrsluta" "nдrslцt" "nдrslutit" ;
  naerstaaende_av_1 = mkA "nдrstеende" ;
  naerstrid_nn_1 = mkN "nдrstrid" "nдrstrider" ;
  naerstudium_nn_1 = mkN "nдrstudium" "nдrstudiet" "nдrstudier" "nдrstudierna" ;
  naersynt_av_1 = mkA "nдrsynt" "nдrsynt" ;
  naersynthet_nn_1 = mkN "nдrsynthet" "nдrsyntheter" ;
  naervarande_av_1 = mkA "nдrvarande" ;
  naes_nn_1 = mkN "nдs" neutrum ;
  naesben_nn_1 = mkN "nдsben" neutrum ;
  naesborre_nn_1 = mkN "nдsborre" utrum ;
  naesbrosk_nn_1 = mkN "nдsbrosk" neutrum ;
  naesduk_nn_1 = mkN "nдsduk" ;
  naesgaang_nn_1 = mkN "nдsgеng" ;
  naeskatarr_nn_1 = mkN "nдskatarr" "nдskatarrer" ;
  naesknaepp_nn_1 = mkN "nдsknдpp" ;
  naesljud_nn_1 = mkN "nдsljud" neutrum ;
  naesring_nn_1 = mkN "nдsring" ;
  naesrot_nn_1 = mkN "nдsrot" "nдsrцtter" ;
  naesrygg_nn_1 = mkN "nдsrygg" ;
  naesselcell_nn_1 = mkN "nдsselcell" "nдsselceller" ;
  naesseldjur_nn_1 = mkN "nдsseldjur" neutrum ;
  naesselfiber_nn_1 = mkN "nдsselfiber" "nдsselfibern" "nдsselfibrer" "nдsselfibrerna" ;
  naesselfjaeril_nn_1 = mkN "nдsselfjдril" ;
  naessla_nn_1 = mkN "nдssla" ;
  naesspets_nn_1 = mkN "nдsspets" ;
  naest_ab_1 = mkAdv "nдst" ;
  naest_nn_1 = mkN "nдst" neutrum ;
  naestaegg_nn_1 = mkN "nдstдgg" neutrum ;
  naestan_ab_1 = mkAdv "nдstan" ;
  naestfoeljande_av_1 = mkA "nдstfцljande" ;
  naestgaards_ab_1 = mkAdv "nдstgеrds" ;
  naestintill_ab_1 = mkAdv "nдstintill" ;
  naestipp_nn_1 = mkN "nдstipp" ;
  naestkommande_av_1 = mkA "nдstkommande" ;
  naestkusin_nn_1 = mkN "nдstkusin" "nдstkusiner" ;
  naestliden_av_1 = mkA "nдstliden" "nдstlidet" ;
  naestunge_nn_1 = mkN "nдstunge" utrum ;
  naesvinge_nn_1 = mkN "nдsvinge" utrum ;
  naesvis_av_1 = mkA "nдsvis" ;
  naet_nn_1 = mkN "nдt" neutrum ;
  naetansluten_av_1 = mkA "nдtansluten" "nдtanslutet" ;
  naetboll_nn_1 = mkN "nдtboll" ;
  naetbur_nn_1 = mkN "nдtbur" ;
  naetfoenster_nn_1 = mkN "nдtfцnster" neutrum ;
  naethinna_nn_1 = mkN "nдthinna" ;
  naetmage_nn_1 = mkN "nдtmage" utrum ;
  naetmelon_nn_1 = mkN "nдtmelon" "nдtmeloner" ;
  naetrullare_nn_1 = mkN "nдtrullare" "nдtrullare" ;
  naetsax_nn_1 = mkN "nдtsax" ;
  naetspaenning_nn_1 = mkN "nдtspдnning" ;
  naett_ab_1 = mkAdv "nдtt" ;
  naett_av_1 = mkA "nдtt" ;
  naettelduk_nn_1 = mkN "nдttelduk" ;
  naetting_nn_1 = mkN "nдtting" ;
  naettopp_ab_1 = mkAdv "nдttopp" ;
  naettupp_ab_1 = mkAdv "nдttupp" ;
  naetverk_nn_1 = mkN "nдtverk" neutrum ;
  naetvinge_nn_1 = mkN "nдtvinge" utrum ;
  naeve_nn_1 = mkN "nдve" utrum ;
  naever_nn_1 = mkN "nдver" ;
  naeverbehaallare_nn_1 = mkN "nдverbehеllare" "nдverbehеllare" ;
  naeverflak_nn_1 = mkN "nдverflak" neutrum ;
  naeverkont_nn_1 = mkN "nдverkont" ;
  naeverkorg_nn_1 = mkN "nдverkorg" ;
  naeverlur_nn_1 = mkN "nдverlur" ;
  naeversoem_nn_1 = mkN "nдversцm" "nдversцmmen" "nдversцmmar" "nдversцmmarna" ;
  naevkamp_nn_1 = mkN "nдvkamp" "nдvkamper" ;
  nafs_nn_1 = mkN "nafs" neutrum ;
  nagel_nn_1 = mkN "nagel" ;
  nagelbaedd_nn_1 = mkN "nagelbдdd" ;
  nagelbaenk_nn_1 = mkN "nagelbдnk" ;
  nagelband_nn_1 = mkN "nagelband" neutrum ;
  nagelfara_vb_1 = mkV "nagelfara" "nagelfor" "nagelfarit" ;
  nagelfil_nn_1 = mkN "nagelfil" ;
  nagellack_nn_1 = mkN "nagellack" neutrum ;
  nageloert_nn_1 = mkN "nagelцrt" "nagelцrter" ;
  nagelpetare_nn_1 = mkN "nagelpetare" "nagelpetare" ;
  nagelrot_nn_1 = mkN "nagelrot" "nagelrцtter" ;
  nagelsax_nn_1 = mkN "nagelsax" ;
  nagelsoem_nn_1 = mkN "nagelsцm" "nagelsцmmen" "nagelsцmmar" "nagelsцmmarna" ;
  nagg_nn_1 = mkN "nagg" ;
  nagg_nn_2 = mkN "nagg" neutrum ;
  naggande_ab_1 = mkAdv "naggande" ;
  naiv_av_1 = mkA "naiv" ;
  naivism_nn_1 = mkN "naivism" "naivismer" ;
  naivist_nn_1 = mkN "naivist" "naivister" ;
  naivistisk_av_1 = mkA "naivistisk" ;
  naivitet_nn_1 = mkN "naivitet" "naiviteter" ;
  najad_nn_1 = mkN "najad" "najader" ;
  najoegonstropp_nn_1 = mkN "najцgonstropp" ;
  najtaag_nn_1 = mkN "najtеg" neutrum ;
  naken_av_1 = mkA "naken" "naket" ;
  nakenbad_nn_1 = mkN "nakenbad" neutrum ;
  nakenbild_nn_1 = mkN "nakenbild" "nakenbilder" ;
  nakendans_nn_1 = mkN "nakendans" "nakendanser" ;
  nakendansoes_nn_1 = mkN "nakendansцs" "nakendansцser" ;
  nakenfroeig_av_1 = mkA "nakenfrцig" ;
  nakenhet_nn_1 = mkN "nakenhet" "nakenheter" ;
  nakenkult_nn_1 = mkN "nakenkult" "nakenkulter" ;
  nakenkultur_nn_1 = mkN "nakenkultur" "nakenkulturer" ;
  nakenmodell_nn_1 = mkN "nakenmodell" "nakenmodeller" ;
  nakenscen_nn_1 = mkN "nakenscen" "nakenscener" ;
  naketbild_nn_1 = mkN "naketbild" "naketbilder" ;
  nakterhus_nn_1 = mkN "nakterhus" neutrum ;
  nalle_nn_1 = mkN "nalle" utrum ;
  namibier_nn_1 = mkN "namibier" "namibiern" "namibier" "namibierna" ;
  namibisk_av_1 = mkA "namibisk" ;
  namn_nn_1 = mkN "namn" neutrum ;
  namnaktie_nn_1 = mkN "namnaktie" "namnaktier" ;
  namnanrop_nn_1 = mkN "namnanrop" neutrum ;
  namnberedning_nn_1 = mkN "namnberedning" ;
  namnbyte_nn_1 = mkN "namnbyte" ;
  namnchiffer_nn_1 = mkN "namnchiffer" neutrum ;
  namndikt_nn_1 = mkN "namndikt" "namndikter" ;
  namne_nn_1 = mkN "namne" utrum ;
  namneligen_ab_1 = mkAdv "namneligen" ;
  namnfoerklaring_nn_1 = mkN "namnfцrklaring" ;
  namnge_vb_1 = mkV "namnge" "namnger" "namnge" "namngav" "namngett" "namngiven" ;
  namninsamling_nn_1 = mkN "namninsamling" ;
  namnkredit_nn_1 = mkN "namnkredit" "namnkrediter" ;
  namnkristen_av_1 = mkA "namnkristen" "namnkristet" ;
  namnkunnig_av_1 = mkA "namnkunnig" ;
  namnkunnighet_nn_1 = mkN "namnkunnighet" "namnkunnigheter" ;
  namnlaengd_nn_1 = mkN "namnlдngd" "namnlдngder" ;
  namnlag_nn_1 = mkN "namnlag" ;
  namnloes_av_1 = mkA "namnlцs" ;
  namnplaat_nn_1 = mkN "namnplеt" ;
  namnsaekerhet_nn_1 = mkN "namnsдkerhet" "namnsдkerheter" ;
  namnsdag_nn_1 = mkN "namnsdag" ;
  namnsdagsbarn_nn_1 = mkN "namnsdagsbarn" neutrum ;
  namnsedel_nn_1 = mkN "namnsedel" ;
  namnskydd_nn_1 = mkN "namnskydd" neutrum ;
  namnskylt_nn_1 = mkN "namnskylt" ;
  namnstaempel_nn_1 = mkN "namnstдmpel" ;
  namnstandert_nn_1 = mkN "namnstandert" ;
  namntavla_nn_1 = mkN "namntavla" ;
  namnteckning_nn_1 = mkN "namnteckning" ;
  namnunderskrift_nn_1 = mkN "namnunderskrift" "namnunderskrifter" ;
  namnupprop_nn_1 = mkN "namnupprop" neutrum ;
  namnvaerde_nn_1 = mkN "namnvдrde" ;
  nanogram_nn_1 = mkN "nanogram" "nanogrammet" "nanogram" "nanogrammen" ;
  nanosekund_nn_1 = mkN "nanosekund" "nanosekunder" ;
  napoleonbakelse_nn_1 = mkN "napoleonbakelse" "napoleonbakelser" ;
  napolitanare_nn_1 = mkN "napolitanare" "napolitanare" ;
  napolitansk_av_1 = mkA "napolitansk" ;
  napp_nn_1 = mkN "napp" neutrum ;
  napp_nn_2 = mkN "napp" ;
  nappatag_nn_1 = mkN "nappatag" neutrum ;
  naprapat_nn_1 = mkN "naprapat" "naprapater" ;
  nar_nn_1 = mkN "nar" ;
  narciss_nn_1 = mkN "narciss" "narcisser" ;
  narig_av_1 = mkA "narig" ;
  narighet_nn_1 = mkN "narighet" "narigheter" ;
  narkoanalys_nn_1 = mkN "narkoanalys" "narkoanalyser" ;
  narkoman_nn_1 = mkN "narkoman" "narkomaner" ;
  narkos_nn_1 = mkN "narkos" "narkoser" ;
  narkoslaekare_nn_1 = mkN "narkoslдkare" "narkoslдkare" ;
  narkosmedel_nn_1 = mkN "narkosmedel" neutrum ;
  narkotikafoersaeljning_nn_1 = mkN "narkotikafцrsдljning" ;
  narkotikahaj_nn_1 = mkN "narkotikahaj" ;
  narkotikahund_nn_1 = mkN "narkotikahund" ;
  narkotikaklinik_nn_1 = mkN "narkotikaklinik" "narkotikakliniker" ;
  narkotikum_nn_1 = mkN "narkotikum" "narkotikum" "narkotika" "narkotikana" ;
  narkotisk_av_1 = mkA "narkotisk" ;
  narr_nn_1 = mkN "narr" ;
  narraktig_av_1 = mkA "narraktig" ;
  narrativ_av_1 = mkA "narrativ" ;
  narrdraekt_nn_1 = mkN "narrdrдkt" "narrdrдkter" ;
  narrspegel_nn_1 = mkN "narrspegel" ;
  narrspel_nn_1 = mkN "narrspel" "narrspelet" "narrspel" "narrspelen" ;
  narrstreck_nn_1 = mkN "narrstreck" neutrum ;
  narval_nn_1 = mkN "narval" ;
  narvfel_nn_1 = mkN "narvfel" "narvfelet" "narvfel" "narvfelen" ;
  narvhuggen_av_1 = mkA "narvhuggen" "narvhugget" ;
  narvspalt_nn_1 = mkN "narvspalt" "narvspalter" ;
  nasal_av_1 = mkA "nasal" ;
  nasal_nn_1 = mkN "nasal" "nasaler" ;
  nasare_nn_1 = mkN "nasarй" "nasarйer" ;
  nasir_nn_1 = mkN "nasir" "nasirer" ;
  nasse_nn_1 = mkN "nasse" utrum ;
  nate_nn_1 = mkN "nate" utrum ;
  nation_nn_1 = mkN "nation" "nationer" ;
  nationalbegrepp_nn_1 = mkN "nationalbegrepp" neutrum ;
  nationalbudget_nn_1 = mkN "nationalbudget" ;
  nationaldag_nn_1 = mkN "nationaldag" ;
  nationaldraekt_nn_1 = mkN "nationaldrдkt" "nationaldrдkter" ;
  nationalekonom_nn_1 = mkN "nationalekonom" "nationalekonomer" ;
  nationalekonomisk_av_1 = mkA "nationalekonomisk" ;
  nationalfoerening_nn_1 = mkN "nationalfцrening" ;
  nationalfoermoegenhet_nn_1 = mkN "nationalfцrmцgenhet" "nationalfцrmцgenheter" ;
  nationalfoersamling_nn_1 = mkN "nationalfцrsamling" ;
  nationalgalleri_nn_1 = mkN "nationalgalleri" "nationalgallerit" "nationalgallerier" "nationalgallerierna" ;
  nationalhelgon_nn_1 = mkN "nationalhelgon" neutrum ;
  nationalhjaelte_nn_1 = mkN "nationalhjдlte" utrum ;
  nationalinkomst_nn_1 = mkN "nationalinkomst" "nationalinkomster" ;
  nationalisering_nn_1 = mkN "nationalisering" ;
  nationalist_nn_1 = mkN "nationalist" "nationalister" ;
  nationalistisk_av_1 = mkA "nationalistisk" ;
  nationalistledare_nn_1 = mkN "nationalistledare" "nationalistledare" ;
  nationalitet_nn_1 = mkN "nationalitet" "nationaliteter" ;
  nationalitetsbeteckning_nn_1 = mkN "nationalitetsbeteckning" ;
  nationalitetsbevis_nn_1 = mkN "nationalitetsbevis" neutrum ;
  nationalitetsbokstav_nn_1 = mkN "nationalitetsbokstav" "nationalitetsbokstдver" ;
  nationalitetscertifikat_nn_1 = mkN "nationalitetscertifikat" neutrum ;
  nationalitetshandling_nn_1 = mkN "nationalitetshandling" ;
  nationalitetsintyg_nn_1 = mkN "nationalitetsintyg" neutrum ;
  nationalitetsmaerke_nn_1 = mkN "nationalitetsmдrke" ;
  nationalitetsmatrikel_nn_1 = mkN "nationalitetsmatrikel" ;
  nationalitetsspillra_nn_1 = mkN "nationalitetsspillra" ;
  nationalitetsstraevande_nn_1 = mkN "nationalitetsstrдvande" ;
  nationalkapital_nn_1 = mkN "nationalkapital" neutrum ;
  nationalkaraktaer_nn_1 = mkN "nationalkaraktдr" "nationalkaraktдrer" ;
  nationalkyrka_nn_1 = mkN "nationalkyrka" ;
  nationalmedvetande_nn_1 = mkN "nationalmedvetande" ;
  nationalmuseum_nn_1 = mkN "nationalmuseum" "nationalmuseet" "nationalmuseer" "nationalmuseerna" ;
  nationalpark_nn_1 = mkN "nationalpark" "nationalparker" ;
  nationalprodukt_nn_1 = mkN "nationalprodukt" "nationalprodukter" ;
  nationalraett_nn_1 = mkN "nationalrдtt" "nationalrдtter" ;
  nationalsaang_nn_1 = mkN "nationalsеng" "nationalsеnger" ;
  nationalscen_nn_1 = mkN "nationalscen" "nationalscener" ;
  nationalskald_nn_1 = mkN "nationalskald" "nationalskalder" ;
  nationalsocialist_nn_1 = mkN "nationalsocialist" "nationalsocialister" ;
  nationalsocialistisk_av_1 = mkA "nationalsocialistisk" ;
  nationalsport_nn_1 = mkN "nationalsport" "nationalsporter" ;
  nationalspraak_nn_1 = mkN "nationalsprеk" neutrum ;
  nationalstat_nn_1 = mkN "nationalstat" "nationalstater" ;
  nationalteater_nn_1 = mkN "nationalteater" ;
  nationell_av_1 = mkA "nationell" ;
  nationsavgift_nn_1 = mkN "nationsavgift" "nationsavgifter" ;
  nationsinspektor_nn_1 = mkN "nationsinspektor" "nationsinspektorer" ;
  nationskurator_nn_1 = mkN "nationskurator" "nationskuratorer" ;
  nationsvis_ab_1 = mkAdv "nationsvis" ;
  nativ_av_1 = mkA "nativ" ;
  nativitet_nn_1 = mkN "nativitet" "nativiteter" ;
  natriumhalt_nn_1 = mkN "natriumhalt" "natriumhalter" ;
  natriumhydroxid_nn_1 = mkN "natriumhydroxid" "natriumhydroxider" ;
  natriumnitrat_nn_1 = mkN "natriumnitrat" neutrum ;
  natriumsulfat_nn_1 = mkN "natriumsulfat" neutrum ;
  natriumtiosulfat_nn_1 = mkN "natriumtiosulfat" "natriumtiosulfater" ;
  natronlut_nn_1 = mkN "natronlut" ;
  natt_nn_1 = mkN "natt" "nдtter" ;
  nattaktiv_av_1 = mkA "nattaktiv" ;
  nattblaa_av_1 = mkA "nattblе" "nattblеtt" ;
  nattblind_av_1 = mkA "nattblind" ;
  nattblindhet_nn_1 = mkN "nattblindhet" "nattblindheter" ;
  nattbord_nn_1 = mkN "nattbord" neutrum ;
  nattdjur_nn_1 = mkN "nattdjur" neutrum ;
  nattdraekt_nn_1 = mkN "nattdrдkt" "nattdrдkter" ;
  nattduksbord_nn_1 = mkN "nattduksbord" neutrum ;
  nattetid_ab_1 = mkAdv "nattetid" ;
  nattfaagel_nn_1 = mkN "nattfеgel" ;
  nattfack_nn_1 = mkN "nattfack" neutrum ;
  nattfjaeril_nn_1 = mkN "nattfjдril" ;
  nattfly_nn_1 = mkN "nattfly" "nattflyt" "nattflyn" "nattflyen" ;
  nattfriare_nn_1 = mkN "nattfriare" "nattfriare" ;
  nattfrieri_nn_1 = mkN "nattfrieri" "nattfrierit" "nattfrierier" "nattfrierierna" ;
  nattfrusen_av_1 = mkA "nattfrusen" "nattfruset" ;
  nattgaangen_av_1 = mkA "nattgеngen" "nattgеnget" ;
  nattglim_nn_1 = mkN "nattglim" "nattglimmen" "nattglim" "nattglimmen" ;
  natthamn_nn_1 = mkN "natthamn" ;
  natthimmel_nn_1 = mkN "natthimmel" ;
  nattine_nn_1 = mkN "nattinй" "nattinйer" ;
  nattis_nn_1 = mkN "nattis" ;
  nattjour_nn_1 = mkN "nattjour" "nattjourer" ;
  nattkaerl_nn_1 = mkN "nattkдrl" neutrum ;
  nattkikare_nn_1 = mkN "nattkikare" "nattkikare" ;
  nattklubb_nn_1 = mkN "nattklubb" ;
  nattkraem_nn_1 = mkN "nattkrдm" "nattkrдmer" ;
  nattlaeger_nn_1 = mkN "nattlдger" neutrum ;
  nattlaengd_nn_1 = mkN "nattlдngd" "nattlдngder" ;
  nattlig_av_1 = mkA "nattlig" ;
  nattlik_av_1 = mkA "nattlik" ;
  nattljus_nn_1 = mkN "nattljus" neutrum ;
  nattlogerare_nn_1 = mkN "nattlogerare" "nattlogerare" ;
  nattmangling_nn_1 = mkN "nattmangling" ;
  nattmoln_nn_1 = mkN "nattmoln" neutrum ;
  nattorientering_nn_1 = mkN "nattorientering" ;
  nattraj_nn_1 = mkN "nattraj" neutrum ;
  nattsaeck_nn_1 = mkN "nattsдck" ;
  nattskift_nn_1 = mkN "nattskift" neutrum ;
  nattskoeterska_nn_1 = mkN "nattskцterska" ;
  nattslag_nn_1 = mkN "nattslag" neutrum ;
  nattsmyg_nn_1 = mkN "nattsmyg" ;
  nattspaar_nn_1 = mkN "nattspеr" neutrum ;
  nattstaanden_av_1 = mkA "nattstеnden" "nattstеndet" ;
  nattstaellning_nn_1 = mkN "nattstдllning" ;
  nattstol_nn_1 = mkN "nattstol" ;
  nattsvart_av_1 = mkA "nattsvart" "nattsvart" ;
  nattsyster_nn_1 = mkN "nattsyster" ;
  nattvaekt_nn_1 = mkN "nattvдkt" "nattvдkter" ;
  nattvaektare_nn_1 = mkN "nattvдktare" "nattvдktare" ;
  nattvak_nn_1 = mkN "nattvak" neutrum ;
  nattvakt_nn_1 = mkN "nattvakt" "nattvakter" ;
  nattvard_nn_1 = mkN "nattvard" "nattvarder" ;
  nattvardsbarn_nn_1 = mkN "nattvardsbarn" neutrum ;
  nattvardsberedelse_nn_1 = mkN "nattvardsberedelse" "nattvardsberedelser" ;
  nattvardsbord_nn_1 = mkN "nattvardsbord" neutrum ;
  nattvardsbroed_nn_1 = mkN "nattvardsbrцd" neutrum ;
  nattvardsgaang_nn_1 = mkN "nattvardsgеng" ;
  nattvardsgudstjaenst_nn_1 = mkN "nattvardsgudstjдnst" "nattvardsgudstjдnster" ;
  nattvardskaerl_nn_1 = mkN "nattvardskдrl" neutrum ;
  nattvardskalk_nn_1 = mkN "nattvardskalk" ;
  nattvardsundervisning_nn_1 = mkN "nattvardsundervisning" ;
  nattvardsvin_nn_1 = mkN "nattvardsvin" "nattvardsvinet" "nattvardsviner" "nattvardsvinerna" ;
  nattviol_nn_1 = mkN "nattviol" "nattvioler" ;
  nattygsbord_nn_1 = mkN "nattygsbord" neutrum ;
  natur_nn_1 = mkN "natur" "naturer" ;
  naturaliekabinett_nn_1 = mkN "naturaliekabinett" neutrum ;
  naturalist_nn_1 = mkN "naturalist" "naturalister" ;
  naturalistisk_av_1 = mkA "naturalistisk" ;
  naturaportion_nn_1 = mkN "naturaportion" "naturaportioner" ;
  naturbarn_nn_1 = mkN "naturbarn" neutrum ;
  naturbegaavning_nn_1 = mkN "naturbegеvning" ;
  naturbehov_nn_1 = mkN "naturbehov" neutrum ;
  naturbetingelse_nn_1 = mkN "naturbetingelse" "naturbetingelser" ;
  naturbunden_av_1 = mkA "naturbunden" "naturbundet" ;
  naturell_av_1 = mkA "naturell" ;
  naturelltapet_nn_1 = mkN "naturelltapet" "naturelltapeter" ;
  naturenlig_av_1 = mkA "naturenlig" ;
  naturfaerg_nn_1 = mkN "naturfдrg" "naturfдrger" ;
  naturfenomen_nn_1 = mkN "naturfenomen" neutrum ;
  naturfiber_nn_1 = mkN "naturfiber" "naturfibern" "naturfibrer" "naturfibrerna" ;
  naturfilosof_nn_1 = mkN "naturfilosof" "naturfilosofer" ;
  naturfolk_nn_1 = mkN "naturfolk" neutrum ;
  naturformation_nn_1 = mkN "naturformation" "naturformationer" ;
  naturgas_nn_1 = mkN "naturgas" "naturgaser" ;
  naturhamn_nn_1 = mkN "naturhamn" ;
  naturhistorisk_av_1 = mkA "naturhistorisk" ;
  naturhorn_nn_1 = mkN "naturhorn" neutrum ;
  naturinstinkt_nn_1 = mkN "naturinstinkt" "naturinstinkter" ;
  naturist_nn_1 = mkN "naturist" "naturister" ;
  naturkatastrof_nn_1 = mkN "naturkatastrof" "naturkatastrofer" ;
  naturkonstant_nn_1 = mkN "naturkonstant" "naturkonstanter" ;
  naturkraft_nn_1 = mkN "naturkraft" "naturkrafter" ;
  naturlaekare_nn_1 = mkN "naturlдkare" "naturlдkare" ;
  naturlaekemedel_nn_1 = mkN "naturlдkemedel" neutrum ;
  naturlaekemetod_nn_1 = mkN "naturlдkemetod" "naturlдkemetoder" ;
  naturlag_nn_1 = mkN "naturlag" ;
  naturlig_av_1 = mkA "naturlig" ;
  naturligen_ab_1 = mkAdv "naturligen" ;
  naturligtvis_ab_1 = mkAdv "naturligtvis" ;
  naturmaenniska_nn_1 = mkN "naturmдnniska" ;
  naturmedicin_nn_1 = mkN "naturmedicin" "naturmediciner" ;
  naturmetod_nn_1 = mkN "naturmetod" "naturmetoder" ;
  naturmiljoe_nn_1 = mkN "naturmiljц" "naturmiljцn" "naturmiljцer" "naturmiljцerna" ;
  naturminne_nn_1 = mkN "naturminne" ;
  naturminnesmaerke_nn_1 = mkN "naturminnesmдrke" ;
  naturnaera_av_1 = mkA "naturnдra" ;
  naturnamn_nn_1 = mkN "naturnamn" neutrum ;
  naturnoedvaendig_av_1 = mkA "naturnцdvдndig" ;
  naturnoedvaendighet_nn_1 = mkN "naturnцdvдndighet" "naturnцdvдndigheter" ;
  naturorienterande_av_1 = mkA "naturorienterande" ;
  naturpark_nn_1 = mkN "naturpark" "naturparker" ;
  naturreligion_nn_1 = mkN "naturreligion" "naturreligioner" ;
  naturreservat_nn_1 = mkN "naturreservat" neutrum ;
  naturresurs_nn_1 = mkN "naturresurs" "naturresurser" ;
  naturrikedom_nn_1 = mkN "naturrikedom" ;
  natursaangare_nn_1 = mkN "natursеngare" "natursеngare" ;
  natursceneri_nn_1 = mkN "natursceneri" "naturscenerit" "naturscenerier" "naturscenerierna" ;
  naturskoen_av_1 = mkA "naturskцn" ;
  naturskog_nn_1 = mkN "naturskog" ;
  natursten_nn_1 = mkN "natursten" "naturstenen" "naturstenar" "naturstenarna" ;
  naturstig_nn_1 = mkN "naturstig" ;
  naturstridig_av_1 = mkA "naturstridig" ;
  naturtillgaang_nn_1 = mkN "naturtillgеng" ;
  naturtomt_nn_1 = mkN "naturtomt" "naturtomter" ;
  naturtrogen_av_1 = mkA "naturtrogen" "naturtroget" ;
  naturtyp_nn_1 = mkN "naturtyp" "naturtyper" ;
  naturvaardare_nn_1 = mkN "naturvеrdare" "naturvеrdare" ;
  naturvaen_nn_1 = mkN "naturvдn" "naturvдnnen" "naturvдnner" "naturvдnnerna" ;
  naturvaesen_nn_1 = mkN "naturvдsen" "naturvдsendet" "naturvдsen" "naturvдsena" ;
  naturvetare_nn_1 = mkN "naturvetare" "naturvetare" ;
  naturvetenskap_nn_1 = mkN "naturvetenskap" "naturvetenskaper" ;
  naturvetenskaplig_av_1 = mkA "naturvetenskaplig" ;
  naturvetenskapsman_nn_1 = mkN "naturvetenskapsman" "naturvetenskapsmannen" "naturvetenskapsmдn" "naturvetenskapsmдnnen" ;
  naturvidrig_av_1 = mkA "naturvidrig" ;
  naurisk_av_1 = mkA "naurisk" ;
  nauruer_nn_1 = mkN "nauruer" "nauruern" "nauruer" "nauruerna" ;
  nautiker_nn_1 = mkN "nautiker" "nautikern" "nautiker" "nautikerna" ;
  nautisk_av_1 = mkA "nautisk" ;
  nav_nn_1 = mkN "nav" neutrum ;
  navalmedicinsk_av_1 = mkA "navalmedicinsk" ;
  navarborr_nn_1 = mkN "navarborr" ;
  navare_nn_1 = mkN "navare" "navare" ;
  navel_nn_1 = mkN "navel" ;
  navelband_nn_1 = mkN "navelband" neutrum ;
  navelflaeck_nn_1 = mkN "navelflдck" ;
  navelskaadare_nn_1 = mkN "navelskеdare" "navelskеdare" ;
  navelstraeng_nn_1 = mkN "navelstrдng" ;
  navelsvin_nn_1 = mkN "navelsvin" neutrum ;
  navigabel_av_1 = mkA "navigabel" ;
  navigationssatellit_nn_1 = mkN "navigationssatellit" "navigationssatelliter" ;
  navigationsvarning_nn_1 = mkN "navigationsvarning" ;
  navigatoer_nn_1 = mkN "navigatцr" "navigatцrer" ;
  navigerbar_av_1 = mkA "navigerbar" ;
  navigering_nn_1 = mkN "navigering" ;
  navigeringssystem_nn_1 = mkN "navigeringssystem" neutrum ;
  navkapsel_nn_1 = mkN "navkapsel" ;
  naziarkitektur_nn_1 = mkN "naziarkitektur" "naziarkitekturer" ;
  nazist_nn_1 = mkN "nazist" "nazister" ;
  nazistisk_av_1 = mkA "nazistisk" ;
  neandertalare_nn_1 = mkN "neandertalare" "neandertalare" ;
  neandertalmaenniska_nn_1 = mkN "neandertalmдnniska" ;
  neapolitan_nn_1 = mkN "neapolitan" "neapolitaner" ;
  neapolitansk_av_1 = mkA "neapolitansk" ;
  nebuloes_av_1 = mkA "nebulцs" ;
  nebulosalinje_nn_1 = mkN "nebulosalinje" "nebulosalinjer" ;
  necessaer_nn_1 = mkN "necessдr" "necessдrer" ;
  ned_ab_1 = mkAdv "ned" ;
  nedaat_ab_1 = mkAdv "nedеt" ;
  nedaatgaaende_av_1 = mkA "nedеtgеende" ;
  nedaervd_av_1 = mkA "nedдrvd" "nedдrvt" ;
  nedan_ab_1 = mkAdv "nedan" ;
  nedan_nn_1 = mkN "nedan" neutrum ;
  nedanfoer_ab_1 = mkAdv "nedanfцr" ;
  nedanstaaende_av_1 = mkA "nedanstеende" ;
  nedbruten_av_1 = mkA "nedbruten" "nedbrutet" ;
  nedbryta_vb_1 = mkV "nedbryta" "nedbrцt" "nedbrutit" ;
  nedbrytning_nn_1 = mkN "nedbrytning" ;
  nedbrytningsstation_nn_1 = mkN "nedbrytningsstation" "nedbrytningsstationer" ;
  neddragen_av_1 = mkA "neddragen" "neddraget" ;
  neddragning_nn_1 = mkN "neddragning" ;
  neder_ab_1 = mkAdv "neder" ;
  nederboerdsmaengd_nn_1 = mkN "nederbцrdsmдngd" "nederbцrdsmдngder" ;
  nederboerdsomraade_nn_1 = mkN "nederbцrdsomrеde" ;
  nederdel_nn_1 = mkN "nederdel" "nederdelen" "nederdelar" "nederdelarna" ;
  nederlaendare_nn_1 = mkN "nederlдndare" "nederlдndare" ;
  nederlaendsk_av_1 = mkA "nederlдndsk" ;
  nederlaendska_nn_2 = mkN "nederlдndska" ;
  nederlag_nn_1 = mkN "nederlag" neutrum ;
  nedfall_nn_1 = mkN "nedfall" neutrum ;
  nedfart_nn_1 = mkN "nedfart" "nedfarter" ;
  nedfoer_ab_1 = mkAdv "nedfцr" ;
  nedfoersbacke_nn_1 = mkN "nedfцrsbacke" utrum ;
  nedfrysning_nn_1 = mkN "nedfrysning" ;
  nedgaang_nn_1 = mkN "nedgеng" ;
  nedgaangen_av_1 = mkA "nedgеngen" "nedgеnget" ;
  nedhaengande_av_1 = mkA "nedhдngande" ;
  nedhalare_nn_1 = mkN "nedhalare" "nedhalare" ;
  nedifraan_ab_1 = mkAdv "nedifrеn" ;
  nedkomma_vb_1 = mkV "nedkomma" "nedkom" "nedkommit" ;
  nedlaatande_av_1 = mkA "nedlеtande" ;
  nedlaaten_av_1 = mkA "nedlеten" "nedlеtet" ;
  nedlaatenhet_nn_1 = mkN "nedlеtenhet" "nedlеtenheter" ;
  nedlaeggelse_nn_1 = mkN "nedlдggelse" "nedlдggelser" ;
  nedlaeggning_nn_1 = mkN "nedlдggning" ;
  nedmoerk_av_1 = mkA "nedmцrk" ;
  nedom_ab_1 = mkAdv "nedom" ;
  nedra_av_1 = mkA "nedra" ;
  nedraekning_nn_1 = mkN "nedrдkning" ;
  nedrans_av_1 = mkA "nedrans" ;
  nedrig_av_1 = mkA "nedrig" ;
  nedringd_av_1 = mkA "nedringd" "nedringt" ;
  nedsaettande_av_1 = mkA "nedsдttande" ;
  nedsaettning_nn_1 = mkN "nedsдttning" ;
  nedsaettningsbevis_nn_1 = mkN "nedsдttningsbevis" neutrum ;
  nedsatt_av_1 = mkA "nedsatt" ;
  nedskaelld_av_1 = mkA "nedskдlld" "nedskдllt" ;
  nedskaerning_nn_1 = mkN "nedskдrning" ;
  nedskriva_vb_1 = mkV "nedskriva" "nedskrev" "nedskrivit" ;
  nedslaaende_av_1 = mkA "nedslеende" ;
  nedslaepp_nn_1 = mkN "nedslдpp" neutrum ;
  nedslag_nn_1 = mkN "nedslag" neutrum ;
  nedslagen_av_1 = mkA "nedslagen" "nedslaget" ;
  nedslagskrater_nn_1 = mkN "nedslagskrater" ;
  nedslagsplats_nn_1 = mkN "nedslagsplats" "nedslagsplatser" ;
  nedslagsteori_nn_1 = mkN "nedslagsteori" "nedslagsteorier" ;
  nedslaktning_nn_1 = mkN "nedslaktning" ;
  nedsliten_av_1 = mkA "nedsliten" "nedslitet" ;
  nedsmord_av_1 = mkA "nedsmord" "nedsmort" ;
  nedspilld_av_1 = mkA "nedspilld" "nedspillt" ;
  nedstaemd_av_1 = mkA "nedstдmd" "nedstдmt" ;
  nedstraak_nn_1 = mkN "nedstrеk" neutrum ;
  nedstroems_ab_1 = mkAdv "nedstrцms" ;
  nedstrykning_nn_1 = mkN "nedstrykning" ;
  nedsupen_av_1 = mkA "nedsupen" "nedsupet" ;
  nedsutten_av_1 = mkA "nedsutten" "nedsuttet" ;
  nedsvaertning_nn_1 = mkN "nedsvдrtning" ;
  nedtagning_nn_1 = mkN "nedtagning" ;
  nedtill_ab_1 = mkAdv "nedtill" ;
  nedtoning_nn_1 = mkN "nedtoning" ;
  nedtransformering_nn_1 = mkN "nedtransformering" ;
  nedtransponering_nn_1 = mkN "nedtransponering" ;
  nedtryckt_av_1 = mkA "nedtryckt" "nedtryckt" ;
  nefrit_nn_1 = mkN "nefrit" "nefriter" ;
  nefritisk_av_1 = mkA "nefritisk" ;
  negation_nn_1 = mkN "negation" "negationer" ;
  negativ_av_1 = mkA "negativ" ;
  negativ_nn_1 = mkN "negativ" neutrum ;
  neger_nn_1 = mkN "neger" "negern" "negrer" "negrerna" ;
  negerboll_nn_1 = mkN "negerboll" ;
  neglige_nn_1 = mkN "negligй" "negligйer" ;
  negligeabel_av_1 = mkA "negligeabel" "negligeabelt" "negligeabla" "negligeabla" "negligeablare" "negligeablast" "negligeablaste" ;
  negligibel_av_1 = mkA "negligibel" "negligibelt" "negligibla" "negligibla" "negligiblare" "negligiblast" "negligiblaste" ;
  negress_nn_1 = mkN "negress" "negresser" ;
  negroid_nn_1 = mkN "negroid" "negroider" ;
  nejd_nn_1 = mkN "nejd" "nejder" ;
  nejlikrot_nn_1 = mkN "nejlikrot" "nejlikrцtter" ;
  nejlikvaext_nn_1 = mkN "nejlikvдxt" "nejlikvдxter" ;
  nejonoega_nn_1 = mkN "nejonцga" "nejonцgat" "nejonцgon" "nejonцgonen" ;
  nejsaegare_nn_1 = mkN "nejsдgare" "nejsдgare" ;
  nek_nn_1 = mkN "nek" ;
  nekrofil_nn_1 = mkN "nekrofil" "nekrofiler" ;
  nekrolog_nn_1 = mkN "nekrolog" "nekrologer" ;
  nektardrag_nn_1 = mkN "nektardrag" neutrum ;
  nektarin_nn_1 = mkN "nektarin" "nektariner" ;
  nektarium_nn_1 = mkN "nektarium" "nektariet" "nektarier" "nektarierna" ;
  nematod_nn_1 = mkN "nematod" "nematoder" ;
  nemesistanke_nn_1 = mkN "nemesistanke" utrum ;
  neodym_nn_2 = mkN "neodym" "neodymer" ;
  neodymmagnet_nn_1 = mkN "neodymmagnet" "neodymmagneter" ;
  neokolonialistisk_av_1 = mkA "neokolonialistisk" ;
  neolitisk_av_1 = mkA "neolitisk" ;
  neolog_nn_1 = mkN "neolog" "neologer" ;
  neongas_nn_1 = mkN "neongas" "neongaser" ;
  neonljus_nn_1 = mkN "neonljus" neutrum ;
  neonroer_nn_1 = mkN "neonrцr" neutrum ;
  neonskylt_nn_1 = mkN "neonskylt" ;
  neotektonik_nn_1 = mkN "neotektonik" "neotektoniker" ;
  neotektonisk_av_1 = mkA "neotektonisk" ;
  nepales_nn_1 = mkN "nepales" "nepaleser" ;
  nepalesisk_av_1 = mkA "nepalesisk" ;
  neptunisk_av_1 = mkA "neptunisk" ;
  ner_ab_1 = mkAdv "ner" ;
  neraatgaaende_av_1 = mkA "nerеtgеende" ;
  nerbryta_vb_1 = mkV "nerbryta" "nerbrцt" "nerbrutit" ;
  nere_ab_1 = mkAdv "nere" ;
  nere_av_1 = mkA "nere" ;
  nereid_nn_1 = mkN "nereid" "nereider" ;
  nerfoer_ab_1 = mkAdv "nerfцr" ;
  nerifraan_ab_1 = mkAdv "nerifrеn" ;
  nerium_nn_1 = mkN "nerium" "nerien" "nerier" "nerierna" ;
  nertill_ab_1 = mkAdv "nertill" ;
  nerv_nn_1 = mkN "nerv" "nerver" ;
  nervaenda_nn_1 = mkN "nervдnda" "nervдndan" "nervдndar" "nervдndarna" ;
  nervaktivitet_nn_1 = mkN "nervaktivitet" "nervaktiviteter" ;
  nervattack_nn_1 = mkN "nervattack" "nervattacker" ;
  nervcell_nn_1 = mkN "nervcell" "nervceller" ;
  nervcellsgrupp_nn_1 = mkN "nervcellsgrupp" "nervcellsgrupper" ;
  nervchock_nn_1 = mkN "nervchock" "nervchocker" ;
  nervfoerbindelse_nn_1 = mkN "nervfцrbindelse" "nervfцrbindelser" ;
  nervgas_nn_1 = mkN "nervgas" "nervgaser" ;
  nervgift_nn_1 = mkN "nervgift" "nervgiftet" "nervgifter" "nervgifterna" ;
  nervig_av_1 = mkA "nervig" ;
  nervimpuls_nn_1 = mkN "nervimpuls" "nervimpulser" ;
  nervkittlande_av_1 = mkA "nervkittlande" ;
  nervklen_av_1 = mkA "nervklen" ;
  nervknut_nn_1 = mkN "nervknut" ;
  nervkollaps_nn_1 = mkN "nervkollaps" "nervkollapser" ;
  nervkrig_nn_1 = mkN "nervkrig" neutrum ;
  nervmedicin_nn_1 = mkN "nervmedicin" "nervmediciner" ;
  nervoes_av_1 = mkA "nervцs" ;
  nervositet_nn_1 = mkN "nervositet" "nervositeter" ;
  nervpirrande_av_1 = mkA "nervpirrande" ;
  nervryckning_nn_1 = mkN "nervryckning" ;
  nervsammanbrott_nn_1 = mkN "nervsammanbrott" neutrum ;
  nervsignal_nn_1 = mkN "nervsignal" "nervsignaler" ;
  nervsignalmoenster_nn_1 = mkN "nervsignalmцnster" neutrum ;
  nervsjukdom_nn_1 = mkN "nervsjukdom" ;
  nervstump_nn_1 = mkN "nervstump" ;
  nervsystem_nn_1 = mkN "nervsystem" neutrum ;
  nervtraad_nn_1 = mkN "nervtrеd" ;
  nervvrak_nn_1 = mkN "nervvrak" neutrum ;
  neslig_av_1 = mkA "neslig" ;
  nesligen_ab_1 = mkAdv "nesligen" ;
  nestorian_nn_1 = mkN "nestorian" "nestorianer" ;
  nestoriansk_av_1 = mkA "nestoriansk" ;
  netto_ab_1 = mkAdv "netto" ;
  netto_nn_1 = mkN "netto" "nettot" "netton" "nettona" ;
  nettofoermoegenhet_nn_1 = mkN "nettofцrmцgenhet" "nettofцrmцgenheter" ;
  nettoinkomst_nn_1 = mkN "nettoinkomst" "nettoinkomster" ;
  nettoloen_nn_1 = mkN "nettolцn" "nettolцner" ;
  nettopris_nn_1 = mkN "nettopris" neutrum ;
  nettoregisterton_nn_1 = mkN "nettoregisterton" "nettoregistertonnet" "nettoregisterton" "nettoregistertonnen" ;
  nettoskuld_nn_1 = mkN "nettoskuld" "nettoskulder" ;
  nettosparande_nn_1 = mkN "nettosparande" ;
  nettostudietid_nn_1 = mkN "nettostudietid" "nettostudietider" ;
  nettovinst_nn_1 = mkN "nettovinst" "nettovinster" ;
  neuralgisk_av_1 = mkA "neuralgisk" ;
  neurit_nn_1 = mkN "neurit" "neuriter" ;
  neurofysiolog_nn_1 = mkN "neurofysiolog" "neurofysiologer" ;
  neuroleptika_nn_1 = mkN "neuroleptika" "neuroleptikan" "neuroleptika" "neuroleptikana" ;
  neurolog_nn_1 = mkN "neurolog" "neurologer" ;
  neurologisk_av_1 = mkA "neurologisk" ;
  neurom_nn_1 = mkN "neurom" neutrum ;
  neuron_nn_1 = mkN "neuron" neutrum ;
  neuropat_nn_1 = mkN "neuropat" "neuropater" ;
  neuros_nn_1 = mkN "neuros" "neuroser" ;
  neurotiker_nn_1 = mkN "neurotiker" "neurotikern" "neurotiker" "neurotikerna" ;
  neurotisk_av_1 = mkA "neurotisk" ;
  neutral_av_1 = mkA "neutral" ;
  neutralist_nn_1 = mkN "neutralist" "neutralister" ;
  neutralistisk_av_1 = mkA "neutralistisk" ;
  neutralitet_nn_1 = mkN "neutralitet" "neutraliteter" ;
  neutrallaege_nn_1 = mkN "neutrallдge" ;
  neutrino_nn_1 = mkN "neutrino" "neutrinon" "neutrinos" "neutrinosen" ;
  neutrinofoertaetning_nn_1 = mkN "neutrinofцrtдtning" ;
  neutrinohav_nn_1 = mkN "neutrinohav" neutrum ;
  neutrinomodell_nn_1 = mkN "neutrinomodell" "neutrinomodeller" ;
  neutron_nn_1 = mkN "neutron" "neutroner" ;
  neutronbomb_nn_1 = mkN "neutronbomb" "neutronbomber" ;
  neutronstraalning_nn_1 = mkN "neutronstrеlning" ;
  neutrum_nn_1 = mkN "neutrum" neutrum ;
  nevoe_nn_1 = mkN "nevц" "nevцn" "nevцer" "nevцerna" ;
  newfoundlaendare_nn_1 = mkN "newfoundlдndare" "newfoundlдndare" ;
  newfoundlaendsk_av_1 = mkA "newfoundlдndsk" ;
  newfoundlandshund_nn_1 = mkN "newfoundlandshund" ;
  newton_nn_1 = mkN "newton" "newtonen" "newton" "newtonen" ;
  newtonmeter_nn_1 = mkN "newtonmeter" ;
  ng_ljud_nn_1 = mkN "ng-ljud" neutrum ;
  nicaraguan_nn_1 = mkN "nicaraguan" "nicaraguaner" ;
  nick_nn_1 = mkN "nick" ;
  nickhake_nn_1 = mkN "nickhake" utrum ;
  nickning_nn_1 = mkN "nickning" ;
  nickpump_nn_1 = mkN "nickpump" ;
  nidation_nn_1 = mkN "nidation" "nidationer" ;
  nidbild_nn_1 = mkN "nidbild" "nidbilder" ;
  niddikt_nn_1 = mkN "niddikt" "niddikter" ;
  niding_nn_1 = mkN "niding" ;
  nidingsdaad_nn_1 = mkN "nidingsdеd" neutrum ;
  nidingsverk_nn_1 = mkN "nidingsverk" neutrum ;
  nidsk_av_1 = mkA "nidsk" ;
  nidskrift_nn_1 = mkN "nidskrift" "nidskrifter" ;
  nidstaang_nn_1 = mkN "nidstеng" "nidstдnger" ;
  niece_nn_1 = mkN "niece" "niecer" ;
  niello_nn_1 = mkN "niello" "niellon" "nieller" "niellerna" ;
  nigerer_nn_1 = mkN "nigerer" "nigerern" "nigerer" "nigererna" ;
  nigerian_nn_1 = mkN "nigerian" "nigerianer" ;
  nigeriansk_av_1 = mkA "nigeriansk" ;
  nigerisk_av_1 = mkA "nigerisk" ;
  nigger_nn_1 = mkN "nigger" "niggern" "niggrer" "niggrerna" ;
  nigning_nn_1 = mkN "nigning" ;
  nigsittande_av_1 = mkA "nigsittande" ;
  nigstaaende_av_1 = mkA "nigstеende" ;
  nihilist_nn_1 = mkN "nihilist" "nihilister" ;
  nihilistisk_av_1 = mkA "nihilistisk" ;
  nikotingul_av_1 = mkA "nikotingul" ;
  nikotinist_nn_1 = mkN "nikotinist" "nikotinister" ;
  nimrod_nn_1 = mkN "nimrod" ;
  niondel_nn_1 = mkN "niondel" "niondelen" "niondelar" "niondelarna" ;
  niotillhaallarlaas_nn_1 = mkN "niotillhеllarlеs" neutrum ;
  nipbrant_nn_1 = mkN "nipbrant" "nipbranter" ;
  nipflod_nn_1 = mkN "nipflod" "nipfloder" ;
  nipig_av_1 = mkA "nipig" ;
  nippel_nn_1 = mkN "nippel" ;
  nipprig_av_1 = mkA "nipprig" ;
  nisch_nn_1 = mkN "nisch" "nischer" ;
  nisse_nn_1 = mkN "nisse" utrum ;
  nissoega_nn_1 = mkN "nissцga" "nissцgat" "nissцgon" "nissцgonen" ;
  nit_nn_2 = mkN "nit" ;
  nit_nn_3 = mkN "nit" ;
  nitaelskande_nn_1 = mkN "nitдlskande" ;
  nitfoerband_nn_1 = mkN "nitfцrband" neutrum ;
  nitisk_av_1 = mkA "nitisk" ;
  nitlott_nn_1 = mkN "nitlott" "nitlotter" ;
  nitnagel_nn_1 = mkN "nitnagel" ;
  nitrat_nn_1 = mkN "nitrat" neutrum ;
  nitratbakterie_nn_1 = mkN "nitratbakterie" "nitratbakterier" ;
  nitrit_nn_1 = mkN "nitrit" neutrum ;
  nitritbakterie_nn_1 = mkN "nitritbakterie" "nitritbakterier" ;
  nitroes_av_1 = mkA "nitrцs" ;
  nitrofoerening_nn_1 = mkN "nitrofцrening" ;
  nitroglycerin_nn_1 = mkN "nitroglycerin" "nitroglyceriner" ;
  nitrogrupp_nn_1 = mkN "nitrogrupp" "nitrogrupper" ;
  nitstamp_nn_1 = mkN "nitstamp" ;
  nitstans_nn_1 = mkN "nitstans" ;
  nittiosexprocentig_av_1 = mkA "nittiosexprocentig" ;
  nittiotalist_nn_1 = mkN "nittiotalist" "nittiotalister" ;
  nittisexprocentig_av_1 = mkA "nittisexprocentig" ;
  nittitalism_nn_1 = mkN "nittitalism" "nittitalismer" ;
  nittitalist_nn_1 = mkN "nittitalist" "nittitalister" ;
  nivaa_nn_1 = mkN "nivе" "nivеer" ;
  nivaagruppering_nn_1 = mkN "nivеgruppering" ;
  nivaaskillnad_nn_1 = mkN "nivеskillnad" "nivеskillnader" ;
  nivation_nn_1 = mkN "nivation" "nivationer" ;
  njugg_av_1 = mkA "njugg" ;
  njugghaent_av_1 = mkA "njugghдnt" "njugghдnt" ;
  njurbaecken_nn_1 = mkN "njurbдcken" neutrum ;
  njurbaelte_nn_1 = mkN "njurbдlte" ;
  njure_nn_1 = mkN "njure" utrum ;
  njursten_nn_1 = mkN "njursten" "njurstenen" "njurstenar" "njurstenarna" ;
  njurtransplantation_nn_1 = mkN "njurtransplantation" "njurtransplantationer" ;
  njuta_vb_1 = mkV "njuta" "njцt" "njutit" ;
  njutbar_av_1 = mkA "njutbar" ;
  njutning_nn_1 = mkN "njutning" ;
  njutningslysten_av_1 = mkA "njutningslysten" "njutningslystet" ;
  njutningslystnad_nn_1 = mkN "njutningslystnad" "njutningslystnader" ;
  njutningsmedel_nn_1 = mkN "njutningsmedel" neutrum ;
  noanamn_nn_1 = mkN "noanamn" neutrum ;
  noaord_nn_1 = mkN "noaord" neutrum ;
  nobb_nn_1 = mkN "nobb" ;
  nobel_av_1 = mkA "nobel" "nobelt" "nobla" "nobla" "noblare" "noblast" "noblaste" ;
  nobelpris_nn_1 = mkN "nobelpris" neutrum ;
  nobelpristagare_nn_1 = mkN "nobelpristagare" "nobelpristagare" ;
  nock_nn_1 = mkN "nock" ;
  nocturne_nn_1 = mkN "nocturne" "nocturner" ;
  nod_nn_1 = mkN "nod" "noder" ;
  noedaar_nn_1 = mkN "nцdеr" neutrum ;
  noedanrop_nn_1 = mkN "nцdanrop" neutrum ;
  noedbedd_av_1 = mkA "nцdbedd" "nцdbedtt" ;
  noedbjuden_av_1 = mkA "nцdbjuden" "nцdbjudet" ;
  noedbroms_nn_1 = mkN "nцdbroms" ;
  noedd_av_1 = mkA "nцdd" ;
  noeddop_nn_1 = mkN "nцddop" neutrum ;
  noedfall_nn_1 = mkN "nцdfall" neutrum ;
  noedhamn_nn_1 = mkN "nцdhamn" ;
  noedig_av_1 = mkA "nцdig" ;
  noedlaege_nn_1 = mkN "nцdlдge" ;
  noedlandning_nn_1 = mkN "nцdlandning" ;
  noedlidande_av_1 = mkA "nцdlidande" ;
  noedloegn_nn_1 = mkN "nцdlцgn" "nцdlцgner" ;
  noedloesning_nn_1 = mkN "nцdlцsning" ;
  noedmynt_nn_1 = mkN "nцdmynt" neutrum ;
  noedraket_nn_1 = mkN "nцdraket" "nцdraketer" ;
  noedrim_nn_1 = mkN "nцdrim" "nцdrimmet" "nцdrim" "nцdrimmen" ;
  noedrop_nn_1 = mkN "nцdrop" neutrum ;
  noedsignal_nn_1 = mkN "nцdsignal" "nцdsignaler" ;
  noedsignalering_nn_1 = mkN "nцdsignalering" ;
  noedsituation_nn_1 = mkN "nцdsituation" "nцdsituationer" ;
  noedstaelld_av_1 = mkA "nцdstдlld" "nцdstдllt" ;
  noedtorftig_av_1 = mkA "nцdtorftig" ;
  noedtvungen_av_1 = mkA "nцdtvungen" "nцdtvunget" ;
  noedutgaang_nn_1 = mkN "nцdutgеng" ;
  noedvaendig_av_1 = mkA "nцdvдndig" ;
  noedvaendighet_nn_1 = mkN "nцdvдndighet" "nцdvдndigheter" ;
  noedvaendighetsartikel_nn_1 = mkN "nцdvдndighetsartikel" ;
  noedvaendigtvis_ab_1 = mkAdv "nцdvдndigtvis" ;
  noedvuxen_av_1 = mkA "nцdvuxen" "nцdvuxet" ;
  noejaktig_av_1 = mkA "nцjaktig" ;
  noejd_av_1 = mkA "nцjd" "nцjt" ;
  noejdfoerklaring_nn_1 = mkN "nцjdfцrklaring" ;
  noeje_nn_1 = mkN "nцje" ;
  noejesbaat_nn_1 = mkN "nцjesbеt" ;
  noejesbegaer_nn_1 = mkN "nцjesbegдr" neutrum ;
  noejesetablissemang_nn_1 = mkN "nцjesetablissemang" neutrum ;
  noejesfaelt_nn_1 = mkN "nцjesfдlt" neutrum ;
  noejesfiskare_nn_1 = mkN "nцjesfiskare" "nцjesfiskare" ;
  noejeshall_nn_1 = mkN "nцjeshall" ;
  noejeskoerning_nn_1 = mkN "nцjeskцrning" ;
  noejeslokal_nn_1 = mkN "nцjeslokal" "nцjeslokaler" ;
  noejeslysten_av_1 = mkA "nцjeslysten" "nцjeslystet" ;
  noejespalats_nn_1 = mkN "nцjespalats" neutrum ;
  noejespappa_nn_1 = mkN "nцjespappa" ;
  noejespark_nn_1 = mkN "nцjespark" "nцjesparker" ;
  noejesprogram_nn_1 = mkN "nцjesprogram" "nцjesprogrammet" "nцjesprogram" "nцjesprogrammen" ;
  noejsam_av_1 = mkA "nцjsam" "nцjsamt" "nцjsamma" "nцjsamma" "nцjsammare" "nцjsammast" "nцjsammaste" ;
  noet_nn_1 = mkN "nцt" "nцtter" ;
  noet_nn_2 = mkN "nцt" neutrum ;
  noetbarhet_nn_1 = mkN "nцtbarhet" "nцtbarheter" ;
  noetbrun_av_1 = mkA "nцtbrun" ;
  noetfrukt_nn_1 = mkN "nцtfrukt" "nцtfrukter" ;
  noetknaeckare_nn_1 = mkN "nцtknдckare" "nцtknдckare" ;
  noetknaeppare_nn_1 = mkN "nцtknдppare" "nцtknдppare" ;
  noetkreatur_nn_1 = mkN "nцtkreatur" neutrum ;
  noetliknande_av_1 = mkA "nцtliknande" ;
  noetning_nn_1 = mkN "nцtning" ;
  noetningsbestaendig_av_1 = mkA "nцtningsbestдndig" ;
  noetskal_nn_1 = mkN "nцtskal" neutrum ;
  noetstyng_nn_1 = mkN "nцtstyng" neutrum ;
  noetvivel_nn_1 = mkN "nцtvivel" ;
  nog_ab_1 = mkAdv "nog" ;
  noga_ab_1 = mkAdv "noga" ;
  noga_av_1 = mkA "noga" ;
  nogav_ab_1 = mkAdv "nogav" ;
  noggrann_av_1 = mkA "noggrann" "noggrant" ;
  noggrannhet_nn_1 = mkN "noggrannhet" "noggrannheter" ;
  nogsamt_ab_1 = mkAdv "nogsamt" ;
  nokturn_nn_1 = mkN "nokturn" "nokturner" ;
  nollaege_nn_1 = mkN "nollдge" ;
  nollcirkel_nn_1 = mkN "nollcirkel" ;
  nolledning_nn_1 = mkN "nolledning" ;
  nollkorrektur_nn_1 = mkN "nollkorrektur" neutrum ;
  nollning_nn_1 = mkN "nollning" ;
  nollplan_nn_1 = mkN "nollplan" neutrum ;
  nollpunkt_nn_1 = mkN "nollpunkt" "nollpunkter" ;
  nollspant_nn_1 = mkN "nollspant" neutrum ;
  nolltaxerare_nn_1 = mkN "nolltaxerare" "nolltaxerare" ;
  noltig_av_1 = mkA "noltig" ;
  nomad_nn_1 = mkN "nomad" "nomader" ;
  nomadfamilj_nn_1 = mkN "nomadfamilj" "nomadfamiljer" ;
  nomadfolk_nn_1 = mkN "nomadfolk" neutrum ;
  nomadisk_av_1 = mkA "nomadisk" ;
  nomadsystem_nn_1 = mkN "nomadsystem" neutrum ;
  nomen_nn_1 = mkN "nomen" neutrum ;
  nomenklatur_nn_1 = mkN "nomenklatur" "nomenklaturer" ;
  nominal_av_1 = mkA "nominal" ;
  nominalist_nn_1 = mkN "nominalist" "nominalister" ;
  nominalistisk_av_1 = mkA "nominalistisk" ;
  nominalkatalog_nn_1 = mkN "nominalkatalog" "nominalkataloger" ;
  nominalloen_nn_1 = mkN "nominallцn" "nominallцner" ;
  nominalvaerde_nn_1 = mkN "nominalvдrde" ;
  nominativ_nn_1 = mkN "nominativ" "nominativer" ;
  nominell_av_1 = mkA "nominell" ;
  nominering_nn_1 = mkN "nominering" ;
  nomogram_nn_1 = mkN "nomogram" "nomogrammet" "nomogram" "nomogrammen" ;
  non_iron_av_1 = mkA "non-iron" ;
  nonaggressionsfoerdrag_nn_1 = mkN "nonaggressionsfцrdrag" neutrum ;
  nonchalant_av_1 = mkA "nonchalant" "nonchalant" ;
  nonfigurativ_av_1 = mkA "nonfigurativ" ;
  nonie_nn_1 = mkN "nonie" "nonier" ;
  nonkombattant_nn_1 = mkN "nonkombattant" "nonkombattanter" ;
  nonkonformist_nn_1 = mkN "nonkonformist" "nonkonformister" ;
  nonsensvers_nn_1 = mkN "nonsensvers" "nonsensverser" ;
  nonstop_ab_1 = mkAdv "nonstop" ;
  nopp_nn_1 = mkN "nopp" ;
  noppig_av_1 = mkA "noppig" ;
  nopprig_av_1 = mkA "nopprig" ;
  nor_nn_1 = mkN "nor" neutrum ;
  noradrenalin_nn_1 = mkN "noradrenalin" "noradrenaliner" ;
  nord_sydlig_av_1 = mkA "nord-sydlig" ;
  nordamerikan_nn_1 = mkN "nordamerikan" "nordamerikaner" ;
  nordamerikansk_av_1 = mkA "nordamerikansk" ;
  nordan_ab_1 = mkAdv "nordan" ;
  nordanland_nn_1 = mkN "nordanland" neutrum ;
  nordanvind_nn_1 = mkN "nordanvind" ;
  nordbo_nn_1 = mkN "nordbo" "nordbor" ;
  nordgraens_nn_1 = mkN "nordgrдns" "nordgrдnser" ;
  nordisk_av_1 = mkA "nordisk" ;
  nordist_nn_1 = mkN "nordist" "nordister" ;
  nordkorean_nn_1 = mkN "nordkorean" "nordkoreaner" ;
  nordlig_av_1 = mkA "nordlig" ;
  nordman_nn_1 = mkN "nordman" "nordmannen" "nordmдn" "nordmдnnen" ;
  nordoest_ab_1 = mkAdv "nordцst" ;
  nordost_ab_1 = mkAdv "nordost" ;
  nordpaa_ab_1 = mkAdv "nordpе" ;
  nordpol_nn_1 = mkN "nordpol" "nordpoler" ;
  nordsluttning_nn_1 = mkN "nordsluttning" ;
  nordsvensk_nn_1 = mkN "nordsvensk" ;
  nordtysk_av_1 = mkA "nordtysk" ;
  nordvaest_ab_1 = mkAdv "nordvдst" ;
  nordvaestra_av_1 = mkA "nordvдstra" ;
  nordvart_ab_1 = mkAdv "nordvart" ;
  nordvietnamesisk_av_1 = mkA "nordvietnamesisk" ;
  nordyemenit_nn_1 = mkN "nordyemenit" "nordyemeniter" ;
  norm_nn_1 = mkN "norm" "normer" ;
  normal_av_1 = mkA "normal" ;
  normal_nn_1 = mkN "normal" "normaler" ;
  normalbild_nn_1 = mkN "normalbild" "normalbilder" ;
  normalfaerg_nn_1 = mkN "normalfдrg" "normalfдrger" ;
  normalfilm_nn_1 = mkN "normalfilm" "normalfilmer" ;
  normalfoerdelning_nn_1 = mkN "normalfцrdelning" ;
  normalgaard_nn_1 = mkN "normalgеrd" ;
  normalisering_nn_1 = mkN "normalisering" ;
  normaliter_ab_1 = mkAdv "normaliter" ;
  normalitet_nn_1 = mkN "normalitet" "normaliteter" ;
  normalmaanad_nn_1 = mkN "normalmеnad" "normalmеnader" ;
  normalmaatt_nn_1 = mkN "normalmеtt" neutrum ;
  normalobjektiv_nn_1 = mkN "normalobjektiv" neutrum ;
  normalspaarig_av_1 = mkA "normalspеrig" ;
  normalstudietid_nn_1 = mkN "normalstudietid" "normalstudietider" ;
  normaltid_nn_1 = mkN "normaltid" "normaltider" ;
  normalton_nn_1 = mkN "normalton" "normaltoner" ;
  normand_nn_1 = mkN "normand" "normander" ;
  normandisk_av_1 = mkA "normandisk" ;
  normativ_av_1 = mkA "normativ" ;
  normerande_av_1 = mkA "normerande" ;
  normgivande_av_1 = mkA "normgivande" ;
  normloes_av_1 = mkA "normlцs" ;
  normloeshet_nn_1 = mkN "normlцshet" "normlцsheter" ;
  norr_ab_1 = mkAdv "norr" ;
  norra_av_1 = mkA "norra" ;
  norrbagge_nn_1 = mkN "norrbagge" utrum ;
  norrbottning_nn_1 = mkN "norrbottning" ;
  norrbottnisk_av_1 = mkA "norrbottnisk" ;
  norrgoek_nn_1 = mkN "norrgцk" ;
  norrifraan_ab_1 = mkAdv "norrifrеn" ;
  norrkvint_nn_1 = mkN "norrkvint" ;
  norrlaendsk_av_1 = mkA "norrlдndsk" ;
  norrlaendska_nn_2 = mkN "norrlдndska" ;
  norrlaenning_nn_1 = mkN "norrlдnning" ;
  norrlandsaelv_nn_1 = mkN "norrlandsдlv" ;
  norrlandshaest_nn_1 = mkN "norrlandshдst" ;
  norrman_nn_1 = mkN "norrman" "norrmannen" "norrmдn" "norrmдnnen" ;
  norroen_av_1 = mkA "norrцn" ;
  norroever_ab_1 = mkAdv "norrцver" ;
  norrpaa_ab_1 = mkAdv "norrpе" ;
  norrut_ab_1 = mkAdv "norrut" ;
  nors_nn_1 = mkN "nors" ;
  norsk_av_1 = mkA "norsk" ;
  norska_nn_2 = mkN "norska" ;
  norvagism_nn_1 = mkN "norvagism" "norvagismer" ;
  nos_nn_1 = mkN "nos" ;
  noshjul_nn_1 = mkN "noshjul" neutrum ;
  noshoerning_nn_1 = mkN "noshцrning" ;
  nosig_av_1 = mkA "nosig" ;
  noskig_av_1 = mkA "noskig" ;
  noskon_nn_1 = mkN "noskon" "noskoner" ;
  noskorg_nn_1 = mkN "noskorg" ;
  noslaengd_nn_1 = mkN "noslдngd" "noslдngder" ;
  nosregion_nn_1 = mkN "nosregion" "nosregioner" ;
  nosring_nn_1 = mkN "nosring" ;
  nosspets_nn_1 = mkN "nosspets" ;
  nostalgi_nn_1 = mkN "nostalgi" "nostalgier" ;
  nostalgiker_nn_1 = mkN "nostalgiker" "nostalgikern" "nostalgiker" "nostalgikerna" ;
  nostalgisk_av_1 = mkA "nostalgisk" ;
  not_nn_1 = mkN "not" "noter" ;
  not_nn_2 = mkN "not" ;
  notabel_av_1 = mkA "notabel" "notabelt" "notabla" "notabla" "notablare" "notablast" "notablaste" ;
  notabilitet_nn_1 = mkN "notabilitet" "notabiliteter" ;
  notariat_nn_1 = mkN "notariat" neutrum ;
  notariatavdelning_nn_1 = mkN "notariatavdelning" ;
  notarie_nn_1 = mkN "notarie" "notarier" ;
  notation_nn_1 = mkN "notation" "notationer" ;
  notblad_nn_1 = mkN "notblad" neutrum ;
  notdraekt_nn_1 = mkN "notdrдkt" "notdrдkter" ;
  notering_nn_1 = mkN "notering" ;
  notesblock_nn_1 = mkN "notesblock" neutrum ;
  notfast_av_1 = mkA "notfast" "notfast" ;
  notifikation_nn_1 = mkN "notifikation" "notifikationer" ;
  notis_nn_1 = mkN "notis" "notiser" ;
  notlag_nn_1 = mkN "notlag" neutrum ;
  notlinje_nn_1 = mkN "notlinje" "notlinjer" ;
  notorietet_nn_1 = mkN "notorietet" "notorieteter" ;
  notorisk_av_1 = mkA "notorisk" ;
  nototenioid_nn_1 = mkN "nototenioid" "nototenioider" ;
  notpapper_nn_1 = mkN "notpapper" neutrum ;
  notplan_nn_1 = mkN "notplan" neutrum ;
  notrad_nn_1 = mkN "notrad" "notrader" ;
  notsaeker_av_1 = mkA "notsдker" "notsдkert" "notsдkra" "notsдkra" "notsдkrare" "notsдkrast" "notsдkraste" ;
  notsiffra_nn_1 = mkN "notsiffra" ;
  notskriftstecken_nn_1 = mkN "notskriftstecken" "notskriftstecknet" "notskriftstecken" "notskriftstecknen" ;
  notstaal_nn_1 = mkN "notstеl" neutrum ;
  notstaell_nn_1 = mkN "notstдll" neutrum ;
  notvaendare_nn_1 = mkN "notvдndare" "notvдndare" ;
  notvaexling_nn_1 = mkN "notvдxling" ;
  notvarp_nn_1 = mkN "notvarp" neutrum ;
  nougat_nn_1 = mkN "nougat" "nougater" ;
  novantik_av_1 = mkA "novantik" ;
  novation_nn_1 = mkN "novation" "novationer" ;
  novautbrott_nn_1 = mkN "novautbrott" neutrum ;
  novell_nn_1 = mkN "novell" "noveller" ;
  novellett_nn_1 = mkN "novellett" "novelletter" ;
  novellist_nn_1 = mkN "novellist" "novellister" ;
  novellistisk_av_1 = mkA "novellistisk" ;
  novellsamling_nn_1 = mkN "novellsamling" ;
  novis_nn_1 = mkN "novis" "noviser" ;
  novitet_nn_1 = mkN "novitet" "noviteter" ;
  novitiat_nn_1 = mkN "novitiat" neutrum ;
  nu_ab_1 = mkAdv "nu" ;
  nubb_nn_1 = mkN "nubb" ;
  nubbe_nn_1 = mkN "nubbe" utrum ;
  nubier_nn_1 = mkN "nubier" "nubiern" "nubier" "nubierna" ;
  nubisk_av_1 = mkA "nubisk" ;
  nuckig_av_1 = mkA "nuckig" ;
  nudel_nn_1 = mkN "nudel" ;
  nudist_nn_1 = mkN "nudist" "nudister" ;
  nudistisk_av_1 = mkA "nudistisk" ;
  nuditet_nn_1 = mkN "nuditet" "nuditeter" ;
  nufoertiden_ab_1 = mkAdv "nufцrtiden" ;
  nugat_nn_1 = mkN "nugat" "nugater" ;
  nukleaer_av_1 = mkA "nukleдr" ;
  nukleid_nn_1 = mkN "nukleid" "nukleider" ;
  nuklein_nn_1 = mkN "nuklein" neutrum ;
  nukleon_nn_1 = mkN "nukleon" "nukleoner" ;
  nukleontal_nn_1 = mkN "nukleontal" "nukleontalet" "nukleontalen" "nukleontalena" ;
  nukleotid_nn_1 = mkN "nukleotid" "nukleotider" ;
  nuklid_nn_1 = mkN "nuklid" "nuklider" ;
  nullitet_nn_1 = mkN "nullitet" "nulliteter" ;
  numera_ab_1 = mkAdv "numera" ;
  numeraer_av_1 = mkA "numerдr" ;
  numeraer_nn_1 = mkN "numerдr" "numerдrer" ;
  numerisk_av_1 = mkA "numerisk" ;
  numerus_nn_1 = mkN "numerus" neutrum ;
  numinoes_av_1 = mkA "numinцs" ;
  numismatiker_nn_1 = mkN "numismatiker" "numismatikern" "numismatiker" "numismatikerna" ;
  numismatisk_av_1 = mkA "numismatisk" ;
  nummen_av_1 = mkA "nummen" "nummet" "numna" "numna" "numnare" "numnast" "numnaste" ;
  nummer_nn_1 = mkN "nummer" neutrum ;
  nummerbyraa_nn_1 = mkN "nummerbyrе" "nummerbyrеer" ;
  nummerhaest_nn_1 = mkN "nummerhдst" ;
  nummerkarl_nn_1 = mkN "nummerkarl" ;
  nummerplaat_nn_1 = mkN "nummerplеt" ;
  nummerrevy_nn_1 = mkN "nummerrevy" "nummerrevyer" ;
  nummerskylt_nn_1 = mkN "nummerskylt" ;
  nunatak_nn_1 = mkN "nunatak" "nunataker" ;
  nunnedok_nn_1 = mkN "nunnedok" neutrum ;
  nunneoert_nn_1 = mkN "nunneцrt" "nunneцrter" ;
  nuntiatur_nn_1 = mkN "nuntiatur" "nuntiaturer" ;
  nuntie_nn_1 = mkN "nuntie" "nuntier" ;
  nuspraaklig_av_1 = mkA "nusprеklig" ;
  nusvensk_av_1 = mkA "nusvensk" ;
  nutida_av_1 = mkA "nutida" ;
  nutilldags_ab_1 = mkAdv "nutilldags" ;
  nutritionsorgan_nn_1 = mkN "nutritionsorgan" neutrum ;
  nutritiv_av_1 = mkA "nutritiv" ;
  nuvarande_av_1 = mkA "nuvarande" ;
  nuvig_av_1 = mkA "nuvig" ;
  ny_av_1 = mkA "ny" "nytt" ;
  ny_nn_1 = mkN "ny" neutrum ;
  nyaar_nn_1 = mkN "nyеr" neutrum ;
  nyaarsafton_nn_1 = mkN "nyеrsafton" "nyеrsaftonen" "nyеrsaftnar" "nyеrsaftnarna" ;
  nyaarsboen_nn_1 = mkN "nyеrsbцn" "nyеrsbцner" ;
  nyaarsdag_nn_1 = mkN "nyеrsdag" ;
  nyaarsloefte_nn_1 = mkN "nyеrslцfte" ;
  nyaarsnatt_nn_1 = mkN "nyеrsnatt" "nyеrsnдtter" ;
  nyanlaeggning_nn_1 = mkN "nyanlдggning" ;
  nyans_nn_1 = mkN "nyans" "nyanser" ;
  nyansering_nn_1 = mkN "nyansering" ;
  nyanseringstecken_nn_1 = mkN "nyanseringstecken" "nyanseringstecknet" "nyanseringstecken" "nyanseringstecknen" ;
  nyanskaffning_nn_1 = mkN "nyanskaffning" ;
  nyantik_av_1 = mkA "nyantik" ;
  nybearbetning_nn_1 = mkN "nybearbetning" ;
  nybildning_nn_1 = mkN "nybildning" ;
  nybliven_av_1 = mkA "nybliven" "nyblivet" ;
  nyboerjarbok_nn_1 = mkN "nybцrjarbok" "nybцrjarbцcker" ;
  nyboerjare_nn_1 = mkN "nybцrjare" "nybцrjare" ;
  nybruten_av_1 = mkA "nybruten" "nybrutet" ;
  nyburen_av_1 = mkA "nyburen" "nyburet" ;
  nybyggare_nn_1 = mkN "nybyggare" "nybyggare" ;
  nybyggd_av_1 = mkA "nybyggd" "nybyggt" ;
  nybyggnad_nn_1 = mkN "nybyggnad" "nybyggnader" ;
  nyck_nn_1 = mkN "nyck" "nycker" ;
  nyckel_nn_1 = mkN "nyckel" ;
  nyckelaemne_nn_1 = mkN "nyckelдmne" ;
  nyckelax_nn_1 = mkN "nyckelax" neutrum ;
  nyckelbarn_nn_1 = mkN "nyckelbarn" neutrum ;
  nyckelben_nn_1 = mkN "nyckelben" neutrum ;
  nyckelblomster_nn_1 = mkN "nyckelblomster" neutrum ;
  nyckelfaerdig_av_1 = mkA "nyckelfдrdig" ;
  nyckelfunktion_nn_1 = mkN "nyckelfunktion" "nyckelfunktioner" ;
  nyckelhaal_nn_1 = mkN "nyckelhеl" neutrum ;
  nyckelindustri_nn_1 = mkN "nyckelindustri" "nyckelindustrier" ;
  nyckelman_nn_1 = mkN "nyckelman" "nyckelmannen" "nyckelmдn" "nyckelmдnnen" ;
  nyckelord_nn_1 = mkN "nyckelord" neutrum ;
  nyckelperson_nn_1 = mkN "nyckelperson" "nyckelpersoner" ;
  nyckelposition_nn_1 = mkN "nyckelposition" "nyckelpositioner" ;
  nyckelretning_nn_1 = mkN "nyckelretning" ;
  nyckelroll_nn_1 = mkN "nyckelroll" "nyckelroller" ;
  nyckelroman_nn_1 = mkN "nyckelroman" "nyckelromaner" ;
  nyckelsten_nn_1 = mkN "nyckelsten" "nyckelstenen" "nyckelstenar" "nyckelstenarna" ;
  nyckfull_av_1 = mkA "nyckfull" ;
  nydanare_nn_1 = mkN "nydanare" "nydanare" ;
  nydaning_nn_1 = mkN "nydaning" ;
  nyemission_nn_1 = mkN "nyemission" "nyemissioner" ;
  nyenkel_av_1 = mkA "nyenkel" "nyenkelt" "nyenkla" "nyenkla" "nyenklare" "nyenklast" "nyenklaste" ;
  nyetablering_nn_1 = mkN "nyetablering" ;
  nyfallen_av_1 = mkA "nyfallen" "nyfallet" ;
  nyfiken_av_1 = mkA "nyfiken" "nyfiket" ;
  nyfikenhet_nn_1 = mkN "nyfikenhet" "nyfikenheter" ;
  nyfoedd_av_1 = mkA "nyfцdd" ;
  nyfoervaerv_nn_1 = mkN "nyfцrvдrv" neutrum ;
  nygaangen_av_1 = mkA "nygеngen" "nygеnget" ;
  nygift_av_1 = mkA "nygift" "nygift" ;
  nygrad_nn_1 = mkN "nygrad" "nygrader" ;
  nyhet_nn_1 = mkN "nyhet" "nyheter" ;
  nyhetsbevakning_nn_1 = mkN "nyhetsbevakning" ;
  nyhetsbyraa_nn_1 = mkN "nyhetsbyrе" "nyhetsbyrеer" ;
  nyhetstelegram_nn_1 = mkN "nyhetstelegram" "nyhetstelegrammet" "nyhetstelegram" "nyhetstelegrammen" ;
  nying_nn_1 = mkN "nying" ;
  nyinkoept_av_1 = mkA "nyinkцpt" "nyinkцpt" ;
  nyinredd_av_1 = mkA "nyinredd" ;
  nyintagning_nn_1 = mkN "nyintagning" ;
  nyinvestering_nn_1 = mkN "nyinvestering" ;
  nyklassicistisk_av_1 = mkA "nyklassicistisk" ;
  nyklassiker_nn_1 = mkN "nyklassiker" "nyklassikern" "nyklassiker" "nyklassikerna" ;
  nyklassisk_av_1 = mkA "nyklassisk" ;
  nykolonisation_nn_1 = mkN "nykolonisation" "nykolonisationer" ;
  nykomling_nn_1 = mkN "nykomling" ;
  nykter_av_1 = mkA "nykter" "nyktert" "nyktra" "nyktra" "nyktrare" "nyktrast" "nyktraste" ;
  nykterhet_nn_1 = mkN "nykterhet" "nykterheter" ;
  nykterhetsnaemnd_nn_1 = mkN "nykterhetsnдmnd" "nykterhetsnдmnder" ;
  nykterhetsroerelse_nn_1 = mkN "nykterhetsrцrelse" "nykterhetsrцrelser" ;
  nykterist_nn_1 = mkN "nykterist" "nykterister" ;
  nylaendsk_av_1 = mkA "nylдndsk" ;
  nylaenning_nn_1 = mkN "nylдnning" ;
  nylagd_av_1 = mkA "nylagd" "nylagt" ;
  nyliberal_av_1 = mkA "nyliberal" ;
  nyligen_ab_1 = mkAdv "nyligen" ;
  nymf_nn_1 = mkN "nymf" "nymfer" ;
  nymfoman_nn_1 = mkN "nymfoman" "nymfomaner" ;
  nymodig_av_1 = mkA "nymodig" ;
  nymodighet_nn_1 = mkN "nymodighet" "nymodigheter" ;
  nynazist_nn_1 = mkN "nynazist" "nynazister" ;
  nynorsk_av_1 = mkA "nynorsk" ;
  nyodling_nn_1 = mkN "nyodling" ;
  nyord_nn_1 = mkN "nyord" neutrum ;
  nyordning_nn_1 = mkN "nyordning" ;
  nyorientering_nn_1 = mkN "nyorientering" ;
  nyp_nn_1 = mkN "nyp" neutrum ;
  nypa_vb_1 = mkV "nypa" "nyper" "nyp" "nцp" "nypt" "nypt" ;
  nyplantering_nn_1 = mkN "nyplantering" ;
  nyplatonsk_av_1 = mkA "nyplatonsk" ;
  nypon_nn_1 = mkN "nypon" neutrum ;
  nypremiaer_nn_1 = mkN "nypremiдr" "nypremiдrer" ;
  nyproduktion_nn_1 = mkN "nyproduktion" "nyproduktioner" ;
  nyrik_av_1 = mkA "nyrik" ;
  nys_ab_1 = mkAdv "nys" ;
  nyskapare_nn_1 = mkN "nyskapare" "nyskapare" ;
  nyskapelse_nn_1 = mkN "nyskapelse" "nyskapelser" ;
  nyskott_nn_1 = mkN "nyskott" neutrum ;
  nysning_nn_1 = mkN "nysning" ;
  nysoert_nn_1 = mkN "nysцrt" "nysцrter" ;
  nyss_ab_1 = mkAdv "nyss" ;
  nystan_nn_1 = mkN "nystan" neutrum ;
  nystavare_nn_1 = mkN "nystavare" "nystavare" ;
  nystavning_nn_1 = mkN "nystavning" ;
  nystpinne_nn_1 = mkN "nystpinne" utrum ;
  nysvensk_av_1 = mkA "nysvensk" ;
  nytaend_av_1 = mkA "nytдnd" ;
  nytaendning_nn_1 = mkN "nytдndning" ;
  nyter_av_1 = mkA "nyter" "nytert" "nytra" "nytra" "nytrare" "nytrast" "nytraste" ;
  nytestamentlig_av_1 = mkA "nytestamentlig" ;
  nytillkommen_av_1 = mkA "nytillkommen" "nytillkommet" "nytillkomna" "nytillkomna" "nytillkomnare" "nytillkomnast" "nytillkomnaste" ;
  nytillskott_nn_1 = mkN "nytillskott" neutrum ;
  nytryck_nn_1 = mkN "nytryck" neutrum ;
  nytta_nn_1 = mkN "nytta" ;
  nyttig_av_1 = mkA "nyttig" ;
  nyttighet_nn_1 = mkN "nyttighet" "nyttigheter" ;
  nyttjare_nn_1 = mkN "nyttjare" "nyttjare" ;
  nyttofoeremaal_nn_1 = mkN "nyttofцremеl" neutrum ;
  nyttosynpunkt_nn_1 = mkN "nyttosynpunkt" "nyttosynpunkter" ;
  nyttovaext_nn_1 = mkN "nyttovдxt" "nyttovдxter" ;
  nyuppsaettning_nn_1 = mkN "nyuppsдttning" ;
  nyupptaeckt_av_1 = mkA "nyupptдckt" "nyupptдckt" ;
  nyutkommen_av_1 = mkA "nyutkommen" "nyutkommet" "nyutkomna" "nyutkomna" "nyutkomnare" "nyutkomnast" "nyutkomnaste" ;
  nyutslagen_av_1 = mkA "nyutslagen" "nyutslaget" ;
  nyutsprungen_av_1 = mkA "nyutsprungen" "nyutsprunget" ;
  nyvaerde_nn_1 = mkN "nyvдrde" ;
  nyval_nn_1 = mkN "nyval" neutrum ;
  nyvald_av_1 = mkA "nyvald" "nyvalt" ;
  nyvorden_av_1 = mkA "nyvorden" "nyvordet" ;
  nyvunnen_av_1 = mkA "nyvunnen" "nyvunnet" "nyvunna" "nyvunna" "nyvunnare" "nyvunnast" "nyvunnaste" ;
  nyzeelaendare_nn_1 = mkN "nyzeelдndare" "nyzeelдndare" ;
  nyzeelaendsk_av_1 = mkA "nyzeelдndsk" ;
  nyzeelaendska_nn_1 = mkN "nyzeelдndska" ;
  nyzeelaenning_nn_1 = mkN "nyzeelдnning" ;
  oaaterkallelig_av_1 = mkA "oеterkallelig" ;
  oaatkomlig_av_1 = mkA "oеtkomlig" ;
  oacceptabel_av_1 = mkA "oacceptabel" "oacceptabelt" "oacceptabla" "oacceptabla" "oacceptablare" "oacceptablast" "oacceptablaste" ;
  oaedel_av_1 = mkA "oдdel" ;
  oaekta_av_1 = mkA "oдkta" ;
  oaendlig_av_1 = mkA "oдndlig" ;
  oaendlighet_nn_1 = mkN "oдndlighet" "oдndligheter" ;
  oaerlig_av_1 = mkA "oдrlig" ;
  oaerlighet_nn_1 = mkN "oдrlighet" "oдrligheter" ;
  oaetbar_av_1 = mkA "oдtbar" ;
  oaetlig_av_1 = mkA "oдtlig" ;
  oaeven_av_1 = mkA "oдven" "oдvet" ;
  oaktsam_av_1 = mkA "oaktsam" "oaktsamt" "oaktsamma" "oaktsamma" "oaktsammare" "oaktsammast" "oaktsammaste" ;
  oaktsamhetsbrott_nn_1 = mkN "oaktsamhetsbrott" neutrum ;
  oamerikansk_av_1 = mkA "oamerikansk" ;
  oandlig_av_1 = mkA "oandlig" ;
  oanfraett_av_1 = mkA "oanfrдtt" ;
  oangenaem_av_1 = mkA "oangenдm" ;
  oangripbar_av_1 = mkA "oangripbar" ;
  oangriplig_av_1 = mkA "oangriplig" ;
  oanmaeld_av_1 = mkA "oanmдld" "oanmдlt" ;
  oanmaerkt_av_1 = mkA "oanmдrkt" "oanmдrkt" ;
  oansenlig_av_1 = mkA "oansenlig" ;
  oanstaendig_av_1 = mkA "oanstдndig" ;
  oansvarig_av_1 = mkA "oansvarig" ;
  oantagbar_av_1 = mkA "oantagbar" ;
  oantaglig_av_1 = mkA "oantaglig" ;
  oantastlig_av_1 = mkA "oantastlig" ;
  oantraeffbar_av_1 = mkA "oantrдffbar" ;
  oanvaend_av_1 = mkA "oanvдnd" ;
  oanvaendbar_av_1 = mkA "oanvдndbar" ;
  oaptitlig_av_1 = mkA "oaptitlig" ;
  oart_nn_1 = mkN "oart" "oarter" ;
  oartig_av_1 = mkA "oartig" ;
  oartighet_nn_1 = mkN "oartighet" "oartigheter" ;
  oas_nn_1 = mkN "oas" "oaser" ;
  oavbruten_av_1 = mkA "oavbruten" "oavbrutet" ;
  oavgjord_av_1 = mkA "oavgjord" "oavgjort" ;
  oavhaengig_av_1 = mkA "oavhдngig" ;
  oavhaengighet_nn_1 = mkN "oavhдngighet" "oavhдngigheter" ;
  oavlaatlig_av_1 = mkA "oavlеtlig" ;
  oavlaatligen_ab_1 = mkAdv "oavlеtligen" ;
  oavsaettlig_av_1 = mkA "oavsдttlig" ;
  oavsedd_av_1 = mkA "oavsedd" ;
  oavsiktlig_av_1 = mkA "oavsiktlig" ;
  oavvaend_av_1 = mkA "oavvдnd" ;
  oavvaent_ab_1 = mkAdv "oavvдnt" ;
  oavvisbar_av_1 = mkA "oavvisbar" ;
  oavvislig_av_1 = mkA "oavvislig" ;
  oavytterlig_av_1 = mkA "oavytterlig" ;
  obaendig_av_1 = mkA "obдndig" ;
  obarmhaertig_av_1 = mkA "obarmhдrtig" ;
  obducent_nn_1 = mkN "obducent" "obducenter" ;
  obduktion_nn_1 = mkN "obduktion" "obduktioner" ;
  obebodd_av_1 = mkA "obebodd" "obebodtt" ;
  obeboelig_av_1 = mkA "obeboelig" ;
  obedd_av_1 = mkA "obedd" "obedtt" ;
  obefaren_av_1 = mkA "obefaren" "obefaret" ;
  obefintlig_av_1 = mkA "obefintlig" ;
  obegriplig_av_1 = mkA "obegriplig" ;
  obegriplighet_nn_1 = mkN "obegriplighet" "obegripligheter" ;
  obehag_nn_1 = mkN "obehag" neutrum ;
  obehaglig_av_1 = mkA "obehaglig" ;
  obehindrat_ab_1 = mkAdv "obehindrat" ;
  obehoerig_av_1 = mkA "obehцrig" ;
  obehoevlig_av_1 = mkA "obehцvlig" ;
  obekant_av_1 = mkA "obekant" "obekant" ;
  obekvaem_av_1 = mkA "obekvдm" ;
  obelisk_nn_1 = mkN "obelisk" "obelisker" ;
  obemaerkt_av_1 = mkA "obemдrkt" "obemдrkt" ;
  obemaerkthet_nn_1 = mkN "obemдrkthet" "obemдrktheter" ;
  obenaegen_av_1 = mkA "obenдgen" "obenдget" ;
  oberaeknelig_av_1 = mkA "oberдknelig" ;
  oberoende_av_1 = mkA "oberoende" ;
  oberoerbar_av_1 = mkA "oberцrbar" ;
  oberoerd_av_1 = mkA "oberцrd" "oberцrt" ;
  obesatt_av_1 = mkA "obesatt" ;
  obesedd_av_1 = mkA "obesedd" "obesedtt" ;
  obeskrivbar_av_1 = mkA "obeskrivbar" ;
  obeskrivlig_av_1 = mkA "obeskrivlig" ;
  obeskuren_av_1 = mkA "obeskuren" "obeskuret" ;
  obeslutsam_av_1 = mkA "obeslutsam" "obeslutsamt" "obeslutsamma" "obeslutsamma" "obeslutsammare" "obeslutsammast" "obeslutsammaste" ;
  obestaellbar_av_1 = mkA "obestдllbar" ;
  obestaembar_av_1 = mkA "obestдmbar" ;
  obestaembarhet_nn_1 = mkN "obestдmbarhet" "obestдmbarheter" ;
  obestaemd_av_1 = mkA "obestдmd" "obestдmt" ;
  obestaemdhet_nn_1 = mkN "obestдmdhet" "obestдmdheter" ;
  obestaemdhetsprincip_nn_1 = mkN "obestдmdhetsprincip" "obestдmdhetsprinciper" ;
  obestaendig_av_1 = mkA "obestдndig" ;
  obesticklig_av_1 = mkA "obesticklig" ;
  obestridd_av_1 = mkA "obestridd" ;
  obestridlig_av_1 = mkA "obestridlig" ;
  obestridligen_ab_1 = mkAdv "obestridligen" ;
  obestyrkt_av_1 = mkA "obestyrkt" "obestyrkt" ;
  obetaenksam_av_1 = mkA "obetдnksam" "obetдnksamt" "obetдnksamma" "obetдnksamma" "obetдnksammare" "obetдnksammast" "obetдnksammaste" ;
  obetaenkt_av_1 = mkA "obetдnkt" "obetдnkt" ;
  obetagen_av_1 = mkA "obetagen" "obetaget" ;
  obetalbar_av_1 = mkA "obetalbar" ;
  obetald_av_1 = mkA "obetald" "obetalt" ;
  obetvinglig_av_1 = mkA "obetvinglig" ;
  obetydlig_av_1 = mkA "obetydlig" ;
  obetydligt_ab_1 = mkAdv "obetydligt" ;
  obeveklig_av_1 = mkA "obeveklig" ;
  obildbar_av_1 = mkA "obildbar" ;
  obillig_av_1 = mkA "obillig" ;
  objekt_nn_1 = mkN "objekt" neutrum ;
  objektglas_nn_1 = mkN "objektglas" neutrum ;
  objektiv_av_1 = mkA "objektiv" ;
  objektiv_nn_1 = mkN "objektiv" neutrum ;
  objektivism_nn_1 = mkN "objektivism" "objektivismer" ;
  objektivitet_nn_1 = mkN "objektivitet" "objektiviteter" ;
  objektsform_nn_1 = mkN "objektsform" "objektsformer" ;
  objektspraak_nn_1 = mkN "objektsprеk" neutrum ;
  objuden_av_1 = mkA "objuden" "objudet" ;
  oblat_nn_1 = mkN "oblat" "oblater" ;
  oblekt_av_1 = mkA "oblekt" "oblekt" ;
  oblid_av_1 = mkA "oblid" ;
  oblidkelig_av_1 = mkA "oblidkelig" ;
  obligat_av_1 = mkA "obligat" "obligat" ;
  obligat_nn_1 = mkN "obligat" "obligater" ;
  obligation_nn_1 = mkN "obligation" "obligationer" ;
  obligationslaan_nn_1 = mkN "obligationslеn" neutrum ;
  obligatorisk_av_1 = mkA "obligatorisk" ;
  obligatorium_nn_1 = mkN "obligatorium" "obligatoriet" "obligatorier" "obligatorierna" ;
  oblik_av_1 = mkA "oblik" ;
  oblikvitet_nn_1 = mkN "oblikvitet" "oblikviteter" ;
  oblodig_av_1 = mkA "oblodig" ;
  oblyg_av_1 = mkA "oblyg" ;
  oboe_nn_1 = mkN "oboe" "oboer" ;
  oboejlig_av_1 = mkA "obцjlig" ;
  oboenhoerlig_av_1 = mkA "obцnhцrlig" ;
  oboenhoerligen_ab_1 = mkAdv "obцnhцrligen" ;
  obol_nn_1 = mkN "obol" "oboler" ;
  obotfaerdig_av_1 = mkA "obotfдrdig" ;
  obotlig_av_1 = mkA "obotlig" ;
  obraend_av_1 = mkA "obrдnd" ;
  obrottslig_av_1 = mkA "obrottslig" ;
  obrukbar_av_1 = mkA "obrukbar" ;
  obruklig_av_1 = mkA "obruklig" ;
  obrunnen_av_1 = mkA "obrunnen" "obrunnet" "obrunna" "obrunna" "obrunnare" "obrunnast" "obrunnaste" ;
  obruten_av_1 = mkA "obruten" "obrutet" ;
  obrytbar_av_1 = mkA "obrytbar" ;
  obscen_av_1 = mkA "obscen" ;
  obscenitet_nn_1 = mkN "obscenitet" "obsceniteter" ;
  observandum_nn_1 = mkN "observandum" neutrum ;
  observant_av_1 = mkA "observant" "observant" ;
  observation_nn_1 = mkN "observation" "observationer" ;
  observationsakt_nn_1 = mkN "observationsakt" "observationsakter" ;
  observationsklass_nn_1 = mkN "observationsklass" "observationsklasser" ;
  observationsklinik_nn_1 = mkN "observationsklinik" "observationskliniker" ;
  observationsmaterial_nn_1 = mkN "observationsmaterial" neutrum ;
  observatoer_nn_1 = mkN "observatцr" "observatцrer" ;
  observatorium_nn_1 = mkN "observatorium" "observatoriet" "observatorier" "observatorierna" ;
  observerbar_av_1 = mkA "observerbar" ;
  obsidian_nn_1 = mkN "obsidian" "obsidianer" ;
  obsklass_nn_1 = mkN "obsklass" "obsklasser" ;
  obsklinik_nn_1 = mkN "obsklinik" "obskliniker" ;
  obskur_av_1 = mkA "obskur" ;
  obskurant_av_1 = mkA "obskurant" "obskurant" ;
  obskurant_nn_1 = mkN "obskurant" "obskuranter" ;
  obskurantist_nn_1 = mkN "obskurantist" "obskurantister" ;
  obskyr_av_1 = mkA "obskyr" ;
  obsolet_av_1 = mkA "obsolet" "obsolet" ;
  obstetrisk_av_1 = mkA "obstetrisk" ;
  obstinat_av_1 = mkA "obstinat" "obstinat" ;
  obstruent_nn_1 = mkN "obstruent" "obstruenter" ;
  obstruktion_nn_1 = mkN "obstruktion" "obstruktioner" ;
  obunden_av_1 = mkA "obunden" "obundet" ;
  obygd_nn_1 = mkN "obygd" "obygder" ;
  obytt_av_1 = mkA "obytt" ;
  occasion_nn_1 = mkN "occasion" "occasioner" ;
  occidental_av_1 = mkA "occidental" ;
  occidentalisk_av_1 = mkA "occidentalisk" ;
  ocean_nn_1 = mkN "ocean" "oceaner" ;
  oceanisk_av_1 = mkA "oceanisk" ;
  oceanograf_nn_1 = mkN "oceanograf" "oceanografer" ;
  oceanografisk_av_1 = mkA "oceanografisk" ;
  ock_ab_1 = mkAdv "ock" ;
  ockasion_nn_1 = mkN "ockasion" "ockasioner" ;
  ockasionell_av_1 = mkA "ockasionell" ;
  ocklusion_nn_1 = mkN "ocklusion" "ocklusioner" ;
  ockrare_nn_1 = mkN "ockrare" "ockrare" ;
  ocksaa_ab_1 = mkAdv "ocksе" ;
  ockult_av_1 = mkA "ockult" "ockult" ;
  ockupant_nn_1 = mkN "ockupant" "ockupanter" ;
  ockupation_nn_1 = mkN "ockupation" "ockupationer" ;
  odalisk_nn_1 = mkN "odalisk" "odalisker" ;
  odalman_nn_1 = mkN "odalman" "odalmannen" "odalmдn" "odalmдnnen" ;
  odaterbar_av_1 = mkA "odaterbar" ;
  odds_nn_1 = mkN "odds" neutrum ;
  odefinierbar_av_1 = mkA "odefinierbar" ;
  odelbar_av_1 = mkA "odelbar" ;
  odemokratisk_av_1 = mkA "odemokratisk" ;
  odensfly_nn_1 = mkN "odensfly" "odensflyt" "odensflyn" "odensflyen" ;
  odioes_av_1 = mkA "odiцs" ;
  odiplomatisk_av_1 = mkA "odiplomatisk" ;
  odiskutabel_av_1 = mkA "odiskutabel" "odiskutabelt" "odiskutabla" "odiskutabla" "odiskutablare" "odiskutablast" "odiskutablaste" ;
  odisputabel_av_1 = mkA "odisputabel" "odisputabelt" "odisputabla" "odisputabla" "odisputablare" "odisputablast" "odisputablaste" ;
  odjur_nn_1 = mkN "odjur" neutrum ;
  odlare_nn_1 = mkN "odlare" "odlare" ;
  odling_nn_1 = mkN "odling" ;
  odlingsbar_av_1 = mkA "odlingsbar" ;
  odlingsfoersoek_nn_1 = mkN "odlingsfцrsцk" neutrum ;
  odlingsgraens_nn_1 = mkN "odlingsgrдns" "odlingsgrдnser" ;
  odoedlig_av_1 = mkA "odцdlig" ;
  odoer_nn_1 = mkN "odцr" "odцrer" ;
  odogmatisk_av_1 = mkA "odogmatisk" ;
  odon_nn_1 = mkN "odon" neutrum ;
  odontolog_nn_1 = mkN "odontolog" "odontologer" ;
  odontologie_av_1 = mkA "odontologie" ;
  odontologisk_av_1 = mkA "odontologisk" ;
  odraeglig_av_1 = mkA "odrдglig" ;
  odramatisk_av_1 = mkA "odramatisk" ;
  odriven_av_1 = mkA "odriven" "odrivet" ;
  odryg_av_1 = mkA "odryg" ;
  oduglig_av_1 = mkA "oduglig" ;
  odugling_nn_1 = mkN "odugling" ;
  odygdig_av_1 = mkA "odygdig" ;
  odygdspaase_nn_1 = mkN "odygdspеse" utrum ;
  odysse_nn_1 = mkN "odyssй" "odyssйer" ;
  oe_nn_2 = mkN "ц" ;
  oede_av_1 = mkA "цde" ;
  oede_nn_1 = mkN "цde" ;
  oedebygdsvaeg_nn_1 = mkN "цdebygdsvдg" ;
  oedegaard_nn_1 = mkN "цdegеrd" ;
  oedelaeggelse_nn_1 = mkN "цdelдggelse" "цdelдggelser" ;
  oedem_nn_1 = mkN "цdem" neutrum ;
  oedemark_nn_1 = mkN "цdemark" "цdemarker" ;
  oedemarksomraade_nn_1 = mkN "цdemarksomrеde" ;
  oedematoes_av_1 = mkA "цdematцs" ;
  oedesbestaemd_av_1 = mkA "цdesbestдmd" "цdesbestдmt" ;
  oedesdiger_av_1 = mkA "цdesdiger" "цdesdigert" "цdesdigra" "цdesdigra" "цdesdigrare" "цdesdigrast" "цdesdigraste" ;
  oedesdrama_nn_1 = mkN "цdesdrama" "цdesdramat" "цdesdraman" "цdesdramana" ;
  oedesgudinna_nn_1 = mkN "цdesgudinna" ;
  oedla_nn_1 = mkN "цdla" ;
  oedmjuk_av_1 = mkA "цdmjuk" ;
  oedmjukhet_nn_1 = mkN "цdmjukhet" "цdmjukheter" ;
  oedslig_av_1 = mkA "цdslig" ;
  oeftergivlig_av_1 = mkA "oeftergivlig" ;
  oefterhaermlig_av_1 = mkA "oefterhдrmlig" ;
  oefterraettlig_av_1 = mkA "oefterrдttlig" ;
  oega_nn_1 = mkN "цga" "цgat" "цgon" "цgonen" ;
  oegennytta_nn_1 = mkN "oegennytta" ;
  oegennyttig_av_1 = mkA "oegennyttig" ;
  oegentlig_av_1 = mkA "oegentlig" ;
  oegentlighet_nn_1 = mkN "oegentlighet" "oegentligheter" ;
  oegonaboej_ab_1 = mkAdv "цgonabцj" ;
  oegonakroek_ab_1 = mkAdv "цgonakrцk" ;
  oegonblick_nn_1 = mkN "цgonblick" neutrum ;
  oegonblicklig_av_1 = mkA "цgonblicklig" ;
  oegonblickligen_ab_1 = mkAdv "цgonblickligen" ;
  oegonblicksbild_nn_1 = mkN "цgonblicksbild" "цgonblicksbilder" ;
  oegonbotten_nn_1 = mkN "цgonbotten" ;
  oegonbryn_nn_1 = mkN "цgonbryn" neutrum ;
  oegondropp_nn_1 = mkN "цgondropp" neutrum ;
  oegonfaegnad_nn_1 = mkN "цgonfдgnad" "цgonfдgnader" ;
  oegonfaerg_nn_1 = mkN "цgonfдrg" "цgonfдrger" ;
  oegonfloert_nn_1 = mkN "цgonflцrt" "цgonflцrter" ;
  oegonfrans_nn_1 = mkN "цgonfrans" ;
  oegonfroejd_nn_1 = mkN "цgonfrцjd" "цgonfrцjder" ;
  oegonglob_nn_1 = mkN "цgonglob" "цgonglober" ;
  oegonhaar_nn_1 = mkN "цgonhеr" neutrum ;
  oegonhinna_nn_1 = mkN "цgonhinna" ;
  oegonkast_nn_1 = mkN "цgonkast" neutrum ;
  oegonlock_nn_1 = mkN "цgonlock" neutrum ;
  oegonmaerke_nn_1 = mkN "цgonmдrke" ;
  oegonmuskel_nn_1 = mkN "цgonmuskel" "цgonmuskeln" "цgonmuskler" "цgonmusklerna" ;
  oegonprotes_nn_1 = mkN "цgonprotes" "цgonproteser" ;
  oegonroerelse_nn_1 = mkN "цgonrцrelse" "цgonrцrelser" ;
  oegonsjukdom_nn_1 = mkN "цgonsjukdom" ;
  oegonskenlig_av_1 = mkA "цgonskenlig" ;
  oegonskenligen_ab_1 = mkAdv "цgonskenligen" ;
  oegonspegel_nn_1 = mkN "цgonspegel" ;
  oegonsten_nn_1 = mkN "цgonsten" "цgonstenen" "цgonstenar" "цgonstenarna" ;
  oegontagg_nn_1 = mkN "цgontagg" ;
  oegontand_nn_1 = mkN "цgontand" "цgontдnder" ;
  oegontjaenare_nn_1 = mkN "цgontjдnare" "цgontjдnare" ;
  oegonvidd_nn_1 = mkN "цgonvidd" "цgonvidder" ;
  oegonvinkel_nn_1 = mkN "цgonvinkel" ;
  oegonvittne_nn_1 = mkN "цgonvittne" ;
  oegonvraa_nn_1 = mkN "цgonvrе" "цgonvrеn" "цgonvrеr" "цgonvrеrna" ;
  oegrupp_nn_1 = mkN "цgrupp" "цgrupper" ;
  oek_nn_1 = mkN "цk" neutrum ;
  oekaend_av_1 = mkA "цkдnd" ;
  oeken_nn_1 = mkN "цken" "цkenn" "цknar" "цknarna" ;
  oekenlandskap_nn_1 = mkN "цkenlandskap" "цkenlandskapet" "цkenlandskapen" "цkenlandskapena" ;
  oekenvaext_nn_1 = mkN "цkenvдxt" "цkenvдxter" ;
  oekenvandring_nn_1 = mkN "цkenvandring" ;
  oekenvind_nn_1 = mkN "цkenvind" ;
  oeknamn_nn_1 = mkN "цknamn" neutrum ;
  oekning_nn_1 = mkN "цkning" ;
  oekonomisk_av_1 = mkA "oekonomisk" ;
  oekstock_nn_1 = mkN "цkstock" ;
  oel_nn_1 = mkN "цl" neutrum ;
  oelaendsk_av_1 = mkA "цlдndsk" ;
  oelaendska_nn_2 = mkN "цlдndska" ;
  oelaenning_nn_1 = mkN "цlдnning" ;
  oelandshaest_nn_1 = mkN "цlandshдst" ;
  oelback_nn_1 = mkN "цlback" ;
  oelburk_nn_1 = mkN "цlburk" ;
  oelgubbe_nn_1 = mkN "цlgubbe" utrum ;
  oelhall_nn_1 = mkN "цlhall" ;
  oeljett_nn_1 = mkN "цljett" "цljetter" ;
  oelkafe_nn_1 = mkN "цlkafй" "цlkafйt" "цlkafйer" "цlkafйerna" ;
  oeloeppnare_nn_1 = mkN "цlцppnare" "цlцppnare" ;
  oelraettighet_nn_1 = mkN "цlrдttighet" "цlrдttigheter" ;
  oelservering_nn_1 = mkN "цlservering" ;
  oelstuga_nn_1 = mkN "цlstuga" ;
  oeltillverkning_nn_1 = mkN "цltillverkning" ;
  oelutkoerare_nn_1 = mkN "цlutkцrare" "цlutkцrare" ;
  oem_av_1 = mkA "цm" "цmt" "цmma" "цmma" "цmmare" "цmmast" "цmmaste" ;
  oemhet_nn_1 = mkN "цmhet" "цmheter" ;
  oemkansvaerd_av_1 = mkA "цmkansvдrd" "цmkansvдrt" ;
  oemklig_av_1 = mkA "цmklig" ;
  oemkligen_ab_1 = mkAdv "цmkligen" ;
  oemmande_av_1 = mkA "цmmande" ;
  oemotsaeglig_av_1 = mkA "oemotsдglig" ;
  oemotsagd_av_1 = mkA "oemotsagd" "oemotsagt" ;
  oemotstaandlig_av_1 = mkA "oemotstеndlig" ;
  oemottaglig_av_1 = mkA "oemottaglig" ;
  oemsesidig_av_1 = mkA "цmsesidig" ;
  oemsevis_ab_1 = mkAdv "цmsevis" ;
  oemsint_av_1 = mkA "цmsint" "цmsint" ;
  oemsom_ab_1 = mkAdv "цmsom" ;
  oemtaalig_av_1 = mkA "цmtеlig" ;
  oenig_av_1 = mkA "oenig" ;
  oenighet_nn_1 = mkN "oenighet" "oenigheter" ;
  oense_av_1 = mkA "oense" ;
  oenskedroem_nn_1 = mkN "цnskedrцm" "цnskedrцmmen" "цnskedrцmmar" "цnskedrцmmarna" ;
  oenskemaal_nn_1 = mkN "цnskemеl" neutrum ;
  oenskering_nn_1 = mkN "цnskering" ;
  oenskeroll_nn_1 = mkN "цnskeroll" "цnskeroller" ;
  oenskesats_nn_1 = mkN "цnskesats" "цnskesatser" ;
  oensklig_av_1 = mkA "цnsklig" ;
  oenskning_nn_1 = mkN "цnskning" ;
  oenskvaerd_av_1 = mkA "цnskvдrd" "цnskvдrt" ;
  oeppen_av_1 = mkA "цppen" "цppet" ;
  oeppenhet_nn_1 = mkN "цppenhet" "цppenheter" ;
  oeppenhjaertig_av_1 = mkA "цppenhjдrtig" ;
  oeppnare_nn_1 = mkN "цppnare" "цppnare" ;
  oeppning_nn_1 = mkN "цppning" ;
  oeppningsbud_nn_1 = mkN "цppningsbud" neutrum ;
  oera_nn_1 = mkN "цra" "цrat" "цron" "цronen" ;
  oerclips_nn_1 = mkN "цrclips" neutrum ;
  oere_nn_1 = mkN "цre" ;
  oerfaren_av_1 = mkA "oerfaren" "oerfaret" ;
  oerfil_nn_1 = mkN "цrfil" ;
  oerhoerd_av_1 = mkA "oerhцrd" "oerhцrt" ;
  oerike_nn_1 = mkN "цrike" ;
  oering_nn_1 = mkN "цring" ;
  oerlogsbas_nn_1 = mkN "цrlogsbas" "цrlogsbaser" ;
  oerlogsfartyg_nn_1 = mkN "цrlogsfartyg" neutrum ;
  oerlogsman_nn_1 = mkN "цrlogsman" "цrlogsmannen" "цrlogsmдn" "цrlogsmдnnen" ;
  oerlogsmatros_nn_1 = mkN "цrlogsmatros" "цrlogsmatroser" ;
  oerlogsvarv_nn_1 = mkN "цrlogsvarv" neutrum ;
  oermage_nn_1 = mkN "цrmage" utrum ;
  oern_nn_1 = mkN "цrn" ;
  oernbraeken_nn_1 = mkN "цrnbrдken" ;
  oerngott_nn_1 = mkN "цrngott" neutrum ;
  oeronbedoevande_av_1 = mkA "цronbedцvande" ;
  oeroninflammation_nn_1 = mkN "цroninflammation" "цroninflammationer" ;
  oeronlappsfaatoelj_nn_1 = mkN "цronlappsfеtцlj" "цronlappsfеtцljer" ;
  oeronmussla_nn_1 = mkN "цronmussla" ;
  oeronpropp_nn_1 = mkN "цronpropp" ;
  oeronsnibb_nn_1 = mkN "цronsnibb" ;
  oeronsusning_nn_1 = mkN "цronsusning" ;
  oerontasslare_nn_1 = mkN "цrontasslare" "цrontasslare" ;
  oerontrumpet_nn_1 = mkN "цrontrumpet" "цrontrumpeter" ;
  oersaettlig_av_1 = mkA "oersдttlig" ;
  oersnibb_nn_1 = mkN "цrsnibb" ;
  oert_nn_1 = mkN "цrt" "цrter" ;
  oertagaard_nn_1 = mkN "цrtagеrd" ;
  oertesaeng_nn_1 = mkN "цrtesдng" ;
  oertsaeng_nn_1 = mkN "цrtsдng" ;
  oertug_nn_1 = mkN "цrtug" ;
  oeskar_nn_1 = mkN "цskar" neutrum ;
  oesregn_nn_1 = mkN "цsregn" neutrum ;
  oest_ab_1 = mkAdv "цst" ;
  oest_vaestlig_av_1 = mkA "цst-vдstlig" ;
  oestan_ab_1 = mkAdv "цstan" ;
  oester_ab_1 = mkAdv "цster" ;
  oesterbottning_nn_1 = mkN "цsterbottning" ;
  oesterbottnisk_av_1 = mkA "цsterbottnisk" ;
  oesterifraan_ab_1 = mkAdv "цsterifrеn" ;
  oesterlaendsk_av_1 = mkA "цsterlдndsk" ;
  oesterlaenning_nn_1 = mkN "цsterlдnning" ;
  oesterrikare_nn_1 = mkN "цsterrikare" "цsterrikare" ;
  oesterrikisk_av_1 = mkA "цsterrikisk" ;
  oestersjoefisk_nn_1 = mkN "цstersjцfisk" ;
  oesterut_ab_1 = mkAdv "цsterut" ;
  oestetisk_av_1 = mkA "oestetisk" ;
  oesteuropeisk_av_1 = mkA "цsteuropeisk" ;
  oestgoete_nn_1 = mkN "цstgцte" utrum ;
  oestgoetsk_av_1 = mkA "цstgцtsk" ;
  oestgoetska_nn_2 = mkN "цstgцtska" ;
  oestgot_nn_1 = mkN "цstgot" "цstgoter" ;
  oestgotisk_av_1 = mkA "цstgotisk" ;
  oestkust_nn_1 = mkN "цstkust" "цstkuster" ;
  oestlig_av_1 = mkA "цstlig" ;
  oestoever_ab_1 = mkAdv "цstцver" ;
  oestpaa_ab_1 = mkAdv "цstpе" ;
  oestra_av_1 = mkA "цstra" ;
  oestrogen_nn_1 = mkN "цstrogen" "цstrogenet" "цstrogener" "цstrogenerna" ;
  oeststat_nn_1 = mkN "цststat" "цststater" ;
  oesttysk_av_1 = mkA "цsttysk" ;
  oesttysk_nn_1 = mkN "цsttysk" ;
  oestvart_ab_1 = mkAdv "цstvart" ;
  oevaerld_nn_1 = mkN "цvдrld" ;
  oever_ab_1 = mkAdv "цver" ;
  oeveraarig_av_1 = mkA "цverеrig" ;
  oeveraenda_ab_1 = mkAdv "цverдnda" ;
  oeverallt_ab_1 = mkAdv "цverallt" ;
  oeverambitioes_av_1 = mkA "цverambitiцs" ;
  oeveranstraengning_nn_1 = mkN "цveranstrдngning" ;
  oeverarm_nn_1 = mkN "цverarm" ;
  oeverbaedd_nn_1 = mkN "цverbдdd" ;
  oeverbalansen_ab_1 = mkAdv "цverbalansen" ;
  oeverbefaelhavare_nn_1 = mkN "цverbefдlhavare" "цverbefдlhavare" ;
  oeverbelagd_av_1 = mkA "цverbelagd" "цverbelagt" ;
  oeverbetyg_nn_1 = mkN "цverbetyg" neutrum ;
  oeverbjuda_vb_1 = mkV "цverbjuda" "цverbjцd" "цverbjudit" ;
  oeverblick_nn_1 = mkN "цverblick" ;
  oeverbliven_av_1 = mkA "цverbliven" "цverblivet" ;
  oeverbord_ab_1 = mkAdv "цverbord" ;
  oeverbud_nn_1 = mkN "цverbud" neutrum ;
  oeverbyggnad_nn_1 = mkN "цverbyggnad" "цverbyggnader" ;
  oeverdaad_nn_1 = mkN "цverdеd" neutrum ;
  oeverdaadig_av_1 = mkA "цverdеdig" ;
  oeverdaengare_nn_1 = mkN "цverdдngare" "цverdдngare" ;
  oeverdel_nn_1 = mkN "цverdel" "цverdelen" "цverdelar" "цverdelarna" ;
  oeverdirektoer_nn_1 = mkN "цverdirektцr" "цverdirektцrer" ;
  oeverdoedlighet_nn_1 = mkN "цverdцdlighet" "цverdцdligheter" ;
  oeverdos_nn_1 = mkN "цverdos" "цverdoser" ;
  oeverdra_vb_1 = mkV "цverdra" "цverdrar" "цverdra" "цverdrog" "цverdragit" "цverdragen" ;
  oeverdrag_nn_1 = mkN "цverdrag" neutrum ;
  oeverdragsdraekt_nn_1 = mkN "цverdragsdrдkt" "цverdragsdrдkter" ;
  oeverdrift_nn_1 = mkN "цverdrift" "цverdrifter" ;
  oeverdriva_vb_1 = mkV "цverdriva" "цverdrev" "цverdrivit" ;
  oeverdriven_av_1 = mkA "цverdriven" "цverdrivet" ;
  oeverens_ab_1 = mkAdv "цverens" ;
  oeverens_av_1 = mkA "цverens" ;
  oeverensfyr_nn_1 = mkN "цverensfyr" ;
  oeverenskomma_vb_1 = mkV "цverenskomma" "цverenskom" "цverenskommit" ;
  oeverenskommelse_nn_1 = mkN "цverenskommelse" "цverenskommelser" ;
  oeverensstaemmelse_nn_1 = mkN "цverensstдmmelse" "цverensstдmmelser" ;
  oeverfaangsglas_nn_1 = mkN "цverfеngsglas" neutrum ;
  oeverfaerd_nn_1 = mkN "цverfдrd" "цverfдrder" ;
  oeverfall_nn_1 = mkN "цverfall" neutrum ;
  oeverfalla_vb_1 = mkV "цverfalla" "цverfцll" "цverfallit" ;
  oeverfart_nn_1 = mkN "цverfart" "цverfarter" ;
  oeverfloedig_av_1 = mkA "цverflцdig" ;
  oeverflygning_nn_1 = mkN "цverflygning" ;
  oeverflyttning_nn_1 = mkN "цverflyttning" ;
  oeverfoering_nn_1 = mkN "цverfцring" ;
  oeverfoeringsbild_nn_1 = mkN "цverfцringsbild" "цverfцringsbilder" ;
  oeverfoermyndare_nn_1 = mkN "цverfцrmyndare" "цverfцrmyndare" ;
  oeverfoertjust_av_1 = mkA "цverfцrtjust" "цverfцrtjust" ;
  oeverfull_av_1 = mkA "цverfull" ;
  oeverfurir_nn_1 = mkN "цverfurir" "цverfurirer" ;
  oeverfylld_av_1 = mkA "цverfylld" "цverfyllt" ;
  oevergaaende_av_1 = mkA "цvergеende" ;
  oevergaang_nn_1 = mkN "цvergеng" ;
  oevergaangsaalder_nn_1 = mkN "цvergеngsеlder" ;
  oevergaangsmetall_nn_1 = mkN "цvergеngsmetall" "цvergеngsmetaller" ;
  oevergaangsmiljoe_nn_1 = mkN "цvergеngsmiljц" "цvergеngsmiljцn" "цvergеngsmiljцer" "цvergеngsmiljцerna" ;
  oevergaangsproblem_nn_1 = mkN "цvergеngsproblem" neutrum ;
  oevergaangstid_nn_1 = mkN "цvergеngstid" "цvergеngstider" ;
  oevergaangsverb_nn_1 = mkN "цvergеngsverb" neutrum ;
  oeverge_vb_1 = mkV "цverge" "цverger" "цverge" "цvergav" "цvergett" "цvergiven" ;
  oevergiven_av_1 = mkA "цvergiven" "цvergivet" ;
  oevergrepp_nn_1 = mkN "цvergrepp" neutrum ;
  oevergripande_av_1 = mkA "цvergripande" ;
  oeverhaeng_nn_1 = mkN "цverhдng" neutrum ;
  oeverhaengande_av_1 = mkA "цverhдngande" ;
  oeverhaerdig_av_1 = mkA "цverhдrdig" ;
  oeverhalning_nn_1 = mkN "цverhalning" ;
  oeverhandsknop_nn_1 = mkN "цverhandsknop" ;
  oeverhet_nn_1 = mkN "цverhet" "цverheter" ;
  oeverhetlig_av_1 = mkA "цverhetlig" ;
  oeverhettning_nn_1 = mkN "цverhettning" ;
  oeverhoeghet_nn_1 = mkN "цverhцghet" "цverhцgheter" ;
  oeverhoevan_ab_1 = mkAdv "цverhцvan" ;
  oeverhuvud_ab_1 = mkAdv "цverhuvud" ;
  oeverhuvud_nn_1 = mkN "цverhuvud" "цverhuvudet" "цverhuvuden" "цverhuvudena" ;
  oeverhuvudtaget_ab_1 = mkAdv "цverhuvudtaget" ;
  oeverilning_nn_1 = mkN "цverilning" ;
  oeveringenjoer_nn_1 = mkN "цveringenjцr" "цveringenjцrer" ;
  oeverinlaerning_nn_1 = mkN "цverinlдrning" ;
  oeverintendent_nn_1 = mkN "цverintendent" "цverintendenter" ;
  oeverjaesning_nn_1 = mkN "цverjдsning" ;
  oeverjordisk_av_1 = mkA "цverjordisk" ;
  oeverkaeke_nn_1 = mkN "цverkдke" utrum ;
  oeverkaeksben_nn_1 = mkN "цverkдksben" neutrum ;
  oeverkaenslig_av_1 = mkA "цverkдnslig" ;
  oeverkast_nn_1 = mkN "цverkast" neutrum ;
  oeverklagande_nn_1 = mkN "цverklagande" ;
  oeverklass_nn_1 = mkN "цverklass" "цverklasser" ;
  oeverklassare_nn_1 = mkN "цverklassare" "цverklassare" ;
  oeverklassig_av_1 = mkA "цverklassig" ;
  oeverklassmiljoe_nn_1 = mkN "цverklassmiljц" "цverklassmiljцn" "цverklassmiljцer" "цverklassmiljцerna" ;
  oeverklivning_nn_1 = mkN "цverklivning" ;
  oeverkoerd_av_1 = mkA "цverkцrd" "цverkцrt" ;
  oeverkomlig_av_1 = mkA "цverkomlig" ;
  oeverkragning_nn_1 = mkN "цverkragning" ;
  oeverkropp_nn_1 = mkN "цverkropp" ;
  oeverkucku_nn_1 = mkN "цverkucku" ;
  oeverkurs_nn_1 = mkN "цverkurs" "цverkurser" ;
  oeverlaata_vb_1 = mkV "цverlеta" "цverlдt" "цverlеtit" ;
  oeverlaatelse_nn_1 = mkN "цverlеtelse" "цverlеtelser" ;
  oeverlaege_nn_1 = mkN "цverlдge" ;
  oeverlaeggning_nn_1 = mkN "цverlдggning" ;
  oeverlaegsen_av_1 = mkA "цverlдgsen" "цverlдgset" ;
  oeverlaegsenhet_nn_1 = mkN "цverlдgsenhet" "цverlдgsenheter" ;
  oeverlaekare_nn_1 = mkN "цverlдkare" "цverlдkare" ;
  oeverlaepp_nn_1 = mkN "цverlдpp" ;
  oeverlaerare_nn_1 = mkN "цverlдrare" "цverlдrare" ;
  oeverlag_ab_1 = mkAdv "цverlag" ;
  oeverlagd_av_1 = mkA "цverlagd" "цverlagt" ;
  oeverlakan_nn_1 = mkN "цverlakan" neutrum ;
  oeverlapp_nn_1 = mkN "цverlapp" ;
  oeverlappning_nn_1 = mkN "цverlappning" ;
  oeverlevande_av_1 = mkA "цverlevande" ;
  oeverlevnad_nn_1 = mkN "цverlevnad" "цverlevnader" ;
  oeverlevnadschans_nn_1 = mkN "цverlevnadschans" "цverlevnadschanser" ;
  oeverliggande_av_1 = mkA "цverliggande" ;
  oeverliggare_nn_1 = mkN "цverliggare" "цverliggare" ;
  oeverliv_nn_1 = mkN "цverliv" neutrum ;
  oeverljudsfart_nn_1 = mkN "цverljudsfart" "цverljudsfarter" ;
  oeverljudsplan_nn_1 = mkN "цverljudsplan" neutrum ;
  oeverljutt_ab_1 = mkAdv "цverljutt" ;
  oeverloepare_nn_1 = mkN "цverlцpare" "цverlцpare" ;
  oeverloppsgaerning_nn_1 = mkN "цverloppsgдrning" ;
  oeverlupen_av_1 = mkA "цverlupen" "цverlupet" ;
  oeverlycklig_av_1 = mkA "цverlycklig" ;
  oevermaattan_ab_1 = mkAdv "цvermеttan" ;
  oevermaektig_av_1 = mkA "цvermдktig" ;
  oevermaenniska_nn_1 = mkN "цvermдnniska" ;
  oevermaensklig_av_1 = mkA "цvermдnsklig" ;
  oevermaett_av_1 = mkA "цvermдtt" ;
  oevermaga_av_1 = mkA "цvermaga" ;
  oeverman_nn_1 = mkN "цverman" "цvermannen" "цvermдn" "цvermдnnen" ;
  oevermodig_av_1 = mkA "цvermodig" ;
  oevermogen_av_1 = mkA "цvermogen" "цvermoget" ;
  oevernationell_av_1 = mkA "цvernationell" ;
  oevernattning_nn_1 = mkN "цvernattning" ;
  oevernaturlig_av_1 = mkA "цvernaturlig" ;
  oevernog_ab_1 = mkAdv "цvernog" ;
  oeverord_nn_1 = mkN "цverord" neutrum ;
  oeverplagg_nn_1 = mkN "цverplagg" neutrum ;
  oeverpris_nn_1 = mkN "цverpris" neutrum ;
  oeverproduktion_nn_1 = mkN "цverproduktion" "цverproduktioner" ;
  oeverraett_nn_1 = mkN "цverrдtt" "цverrдtter" ;
  oeverraskning_nn_1 = mkN "цverraskning" ;
  oeverrede_nn_1 = mkN "цverrede" ;
  oeverrock_nn_1 = mkN "цverrock" ;
  oeversaate_nn_1 = mkN "цversеte" utrum ;
  oeversaettare_nn_1 = mkN "цversдttare" "цversдttare" ;
  oeversaettning_nn_1 = mkN "цversдttning" ;
  oeversaettningslaan_nn_1 = mkN "цversдttningslеn" neutrum ;
  oeversaettningsprov_nn_1 = mkN "цversдttningsprov" neutrum ;
  oeverseende_av_1 = mkA "цverseende" ;
  oeversida_nn_1 = mkN "цversida" ;
  oeversiggiven_av_1 = mkA "цversiggiven" "цversiggivet" ;
  oeversikt_nn_1 = mkN "цversikt" "цversikter" ;
  oeversiktlig_av_1 = mkA "цversiktlig" ;
  oeversinnlig_av_1 = mkA "цversinnlig" ;
  oeversittare_nn_1 = mkN "цversittare" "цversittare" ;
  oeversitteri_nn_1 = mkN "цversitteri" "цversitterit" "цversitterier" "цversitterierna" ;
  oeverskaadlig_av_1 = mkA "цverskеdlig" ;
  oeverskaap_nn_1 = mkN "цverskеp" neutrum ;
  oeverskeppningsbaat_nn_1 = mkN "цverskeppningsbеt" ;
  oeverskjutande_av_1 = mkA "цverskjutande" ;
  oeverskoeterska_nn_1 = mkN "цverskцterska" ;
  oeverskott_nn_1 = mkN "цverskott" neutrum ;
  oeverskrida_vb_1 = mkV "цverskrida" "цverskred" "цverskridit" ;
  oeverskrift_nn_1 = mkN "цverskrift" "цverskrifter" ;
  oeverskruv_nn_1 = mkN "цverskruv" ;
  oeverslaetande_av_1 = mkA "цverslдtande" ;
  oeverslag_nn_1 = mkN "цverslag" neutrum ;
  oeverslagsberaekning_nn_1 = mkN "цverslagsberдkning" ;
  oeverspaend_av_1 = mkA "цverspдnd" ;
  oeverspel_nn_1 = mkN "цverspel" "цverspelet" "цverspel" "цverspelen" ;
  oeverstaanden_av_1 = mkA "цverstеnden" "цverstеndet" ;
  oeverstaathaallare_nn_1 = mkN "цverstеthеllare" "цverstеthеllare" ;
  oeverste_nn_1 = mkN "цverste" utrum ;
  oeversteloejtnant_nn_1 = mkN "цverstelцjtnant" "цverstelцjtnanter" ;
  oeverstepraest_nn_1 = mkN "цversteprдst" "цversteprдster" ;
  oeverstiga_vb_1 = mkV "цverstiga" "цversteg" "цverstigit" ;
  oeverstiglig_av_1 = mkA "цverstiglig" ;
  oeverstroemsskydd_nn_1 = mkN "цverstrцmsskydd" neutrum ;
  oeverstrykning_nn_1 = mkN "цverstrykning" ;
  oeverstyrd_av_1 = mkA "цverstyrd" "цverstyrt" ;
  oeversvaemning_nn_1 = mkN "цversvдmning" ;
  oeversvallande_av_1 = mkA "цversvallande" ;
  oeversvinnelig_av_1 = mkA "цversvinnelig" ;
  oeversyn_nn_1 = mkN "цversyn" "цversyner" ;
  oeversynt_av_1 = mkA "цversynt" "цversynt" ;
  oeverta_vb_1 = mkV "цverta" "цvertar" "цverta" "цvertog" "цvertagit" "цvertagen" ;
  oevertaend_av_1 = mkA "цvertдnd" ;
  oevertaenkt_av_1 = mkA "цvertдnkt" "цvertдnkt" ;
  oevertag_nn_1 = mkN "цvertag" neutrum ;
  oevertagande_nn_1 = mkN "цvertagande" ;
  oevertalig_av_1 = mkA "цvertalig" ;
  oevertalning_nn_1 = mkN "цvertalning" ;
  oeverton_nn_1 = mkN "цverton" "цvertoner" ;
  oevertraedelse_nn_1 = mkN "цvertrдdelse" "цvertrдdelser" ;
  oevertramp_nn_1 = mkN "цvertramp" neutrum ;
  oevertydlig_av_1 = mkA "цvertydlig" ;
  oevertygande_av_1 = mkA "цvertygande" ;
  oevertygelse_nn_1 = mkN "цvertygelse" "цvertygelser" ;
  oevervaaning_nn_1 = mkN "цvervеning" ;
  oevervaegande_av_1 = mkA "цvervдgande" ;
  oevervaegande_nn_1 = mkN "цvervдgande" ;
  oevervaeldigande_av_1 = mkA "цvervдldigande" ;
  oevervaexel_nn_1 = mkN "цvervдxel" ;
  oevervakare_nn_1 = mkN "цvervakare" "цvervakare" ;
  oevervattensfartyg_nn_1 = mkN "цvervattensfartyg" neutrum ;
  oevervinna_vb_1 = mkV "цvervinna" "цvervann" "цvervunnit" ;
  oevervuxen_av_1 = mkA "цvervuxen" "цvervuxet" ;
  oevlig_av_1 = mkA "цvlig" ;
  oevning_nn_1 = mkN "цvning" ;
  oevningsaemne_nn_1 = mkN "цvningsдmne" ;
  oevningslaerare_nn_1 = mkN "цvningslдrare" "цvningslдrare" ;
  oevningsskjutning_nn_1 = mkN "цvningsskjutning" ;
  oevrig_av_1 = mkA "цvrig" ;
  ofaerdig_av_1 = mkA "ofдrdig" ;
  ofaerg_nn_1 = mkN "ofдrg" "ofдrger" ;
  ofantlig_av_1 = mkA "ofantlig" ;
  ofarlig_av_1 = mkA "ofarlig" ;
  ofattbar_av_1 = mkA "ofattbar" ;
  ofattlig_av_1 = mkA "ofattlig" ;
  ofelbar_av_1 = mkA "ofelbar" ;
  off_white_av_1 = mkA "off-white" ;
  offensiv_av_1 = mkA "offensiv" ;
  offensiv_nn_1 = mkN "offensiv" "offensiver" ;
  offentlig_av_1 = mkA "offentlig" ;
  offentligen_ab_1 = mkAdv "offentligen" ;
  offentlighet_nn_1 = mkN "offentlighet" "offentligheter" ;
  offer_nn_1 = mkN "offer" neutrum ;
  offerent_nn_1 = mkN "offerent" "offerenter" ;
  offerfest_nn_1 = mkN "offerfest" "offerfester" ;
  offerlamm_nn_1 = mkN "offerlamm" neutrum ;
  offerrit_nn_1 = mkN "offerrit" "offerriter" ;
  offerstock_nn_1 = mkN "offerstock" ;
  offert_nn_1 = mkN "offert" "offerter" ;
  offertorium_nn_1 = mkN "offertorium" "offertoriet" "offertorier" "offertorierna" ;
  officer_nn_1 = mkN "officer" "officern" "officerare" "officerarna" ;
  officerare_nn_1 = mkN "officerare" "officerare" ;
  officersmaess_nn_1 = mkN "officersmдss" ;
  officiant_nn_1 = mkN "officiant" "officianter" ;
  officiell_av_1 = mkA "officiell" ;
  officin_nn_1 = mkN "officin" "officiner" ;
  officinell_av_1 = mkA "officinell" ;
  officioes_av_1 = mkA "officiцs" ;
  offshore_av_1 = mkA "offshore" ;
  offside_ab_1 = mkAdv "offside" ;
  ofin_av_1 = mkA "ofin" ;
  ofoedd_av_1 = mkA "ofцdd" ;
  ofoer_av_1 = mkA "ofцr" ;
  ofoeraenderlig_av_1 = mkA "ofцrдnderlig" ;
  ofoerarglig_av_1 = mkA "ofцrarglig" ;
  ofoerbaetterlig_av_1 = mkA "ofцrbдtterlig" ;
  ofoerbehaallsam_av_1 = mkA "ofцrbehеllsam" "ofцrbehеllsamt" "ofцrbehеllsamma" "ofцrbehеllsamma" "ofцrbehеllsammare" "ofцrbehеllsammast" "ofцrbehеllsammaste" ;
  ofoerberedd_av_1 = mkA "ofцrberedd" ;
  ofoerbraennelig_av_1 = mkA "ofцrbrдnnelig" ;
  ofoerdelaktig_av_1 = mkA "ofцrdelaktig" ;
  ofoerdragsam_av_1 = mkA "ofцrdragsam" "ofцrdragsamt" "ofцrdragsamma" "ofцrdragsamma" "ofцrdragsammare" "ofцrdragsammast" "ofцrdragsammaste" ;
  ofoerdroejligen_ab_1 = mkAdv "ofцrdrцjligen" ;
  ofoerenlig_av_1 = mkA "ofцrenlig" ;
  ofoeretagsam_av_1 = mkA "ofцretagsam" "ofцretagsamt" "ofцretagsamma" "ofцretagsamma" "ofцretagsammare" "ofцretagsammast" "ofцretagsammaste" ;
  ofoergaetlig_av_1 = mkA "ofцrgдtlig" ;
  ofoergloemlig_av_1 = mkA "ofцrglцmlig" ;
  ofoergriplig_av_1 = mkA "ofцrgriplig" ;
  ofoerhappandes_ab_1 = mkAdv "ofцrhappandes" ;
  ofoerklarlig_av_1 = mkA "ofцrklarlig" ;
  ofoerlaatlig_av_1 = mkA "ofцrlеtlig" ;
  ofoerliknelig_av_1 = mkA "ofцrliknelig" ;
  ofoermaerkt_av_1 = mkA "ofцrmдrkt" "ofцrmдrkt" ;
  ofoermoegen_av_1 = mkA "ofцrmцgen" "ofцrmцget" ;
  ofoerneklig_av_1 = mkA "ofцrneklig" ;
  ofoernuftig_av_1 = mkA "ofцrnuftig" ;
  ofoerraett_nn_1 = mkN "ofцrrдtt" "ofцrrдtter" ;
  ofoersiktig_av_1 = mkA "ofцrsiktig" ;
  ofoerskaemd_av_1 = mkA "ofцrskдmd" "ofцrskдmt" ;
  ofoerskaemdhet_nn_1 = mkN "ofцrskдmdhet" "ofцrskдmdheter" ;
  ofoerskraeckt_av_1 = mkA "ofцrskrдckt" "ofцrskrдckt" ;
  ofoerskylld_av_1 = mkA "ofцrskylld" "ofцrskyllt" ;
  ofoersonlig_av_1 = mkA "ofцrsonlig" ;
  ofoerstaaelig_av_1 = mkA "ofцrstеelig" ;
  ofoerstaaende_av_1 = mkA "ofцrstеende" ;
  ofoerstaandig_av_1 = mkA "ofцrstеndig" ;
  ofoerstaelld_av_1 = mkA "ofцrstдlld" "ofцrstдllt" ;
  ofoerstoerbar_av_1 = mkA "ofцrstцrbar" ;
  ofoerstoerd_av_1 = mkA "ofцrstцrd" "ofцrstцrt" ;
  ofoersvarlig_av_1 = mkA "ofцrsvarlig" ;
  ofoersynt_av_1 = mkA "ofцrsynt" "ofцrsynt" ;
  ofoertaeckt_av_1 = mkA "ofцrtдckt" "ofцrtдckt" ;
  ofoertaenkt_av_1 = mkA "ofцrtдnkt" "ofцrtдnkt" ;
  ofoertjaent_av_1 = mkA "ofцrtjдnt" "ofцrtjдnt" ;
  ofoertroettlig_av_1 = mkA "ofцrtrцttlig" ;
  ofoertruten_av_1 = mkA "ofцrtruten" "ofцrtrutet" ;
  ofoertydbar_av_1 = mkA "ofцrtydbar" ;
  ofoerutsaegbar_av_1 = mkA "ofцrutsдgbar" ;
  ofoerutsebar_av_1 = mkA "ofцrutsebar" ;
  ofoerutsedd_av_1 = mkA "ofцrutsedd" "ofцrutsedtt" ;
  ofoervaegen_av_1 = mkA "ofцrvдgen" "ofцrvдget" ;
  ofoervarandes_ab_1 = mkAdv "ofцrvarandes" ;
  ofoervitlig_av_1 = mkA "ofцrvitlig" ;
  ofoerytterlig_av_1 = mkA "ofцrytterlig" ;
  ofog_nn_1 = mkN "ofog" neutrum ;
  oformlig_av_1 = mkA "oformlig" ;
  ofraankomlig_av_1 = mkA "ofrеnkomlig" ;
  ofraelse_av_1 = mkA "ofrдlse" ;
  oframkomlig_av_1 = mkA "oframkomlig" ;
  ofri_av_1 = mkA "ofri" "ofritt" ;
  ofrihet_nn_1 = mkN "ofrihet" "ofriheter" ;
  ofrivillig_av_1 = mkA "ofrivillig" ;
  ofruktbar_av_1 = mkA "ofruktbar" ;
  ofruktsam_av_1 = mkA "ofruktsam" "ofruktsamt" "ofruktsamma" "ofruktsamma" "ofruktsammare" "ofruktsammast" "ofruktsammaste" ;
  ofta_ab_1 = mkAdv "ofta" ;
  oftalmi_nn_1 = mkN "oftalmi" "oftalmier" ;
  oftalmologisk_av_1 = mkA "oftalmologisk" ;
  oftalmoskop_nn_1 = mkN "oftalmoskop" neutrum ;
  ofullgaangen_av_1 = mkA "ofullgеngen" "ofullgеnget" ;
  ofullkomlig_av_1 = mkA "ofullkomlig" ;
  ofullstaendig_av_1 = mkA "ofullstдndig" ;
  ofyndig_av_1 = mkA "ofyndig" ;
  ogaerna_ab_1 = mkAdv "ogдrna" ;
  ogaerning_nn_1 = mkN "ogдrning" ;
  ogaestvaenlig_av_1 = mkA "ogдstvдnlig" ;
  ogemen_av_1 = mkA "ogemen" ;
  ogenomfoerbar_av_1 = mkA "ogenomfцrbar" ;
  ogenomskinlig_av_1 = mkA "ogenomskinlig" ;
  ogenomslaepplig_av_1 = mkA "ogenomslдpplig" ;
  ogenomtaenkt_av_1 = mkA "ogenomtдnkt" "ogenomtдnkt" ;
  ogenomtraenglig_av_1 = mkA "ogenomtrдnglig" ;
  ogensaeglig_av_1 = mkA "ogensдglig" ;
  ogift_av_1 = mkA "ogift" "ogift" ;
  ogiftig_av_1 = mkA "ogiftig" ;
  ogill_ab_1 = mkAdv "ogill" ;
  ogill_av_1 = mkA "ogill" ;
  ogillande_nn_1 = mkN "ogillande" ;
  ogiltig_av_1 = mkA "ogiltig" ;
  ogin_av_1 = mkA "ogin" ;
  ogjord_av_1 = mkA "ogjord" "ogjort" ;
  ogoerlig_av_1 = mkA "ogцrlig" ;
  ograesfisk_nn_1 = mkN "ogrдsfisk" ;
  ogrammatikalisk_av_1 = mkA "ogrammatikalisk" ;
  ogrammatisk_av_1 = mkA "ogrammatisk" ;
  ogripbar_av_1 = mkA "ogripbar" ;
  ogudaktig_av_1 = mkA "ogudaktig" ;
  ogudlig_av_1 = mkA "ogudlig" ;
  ogulden_av_1 = mkA "ogulden" "oguldet" ;
  ogunstig_av_1 = mkA "ogunstig" ;
  ogynnsam_av_1 = mkA "ogynnsam" "ogynnsamt" "ogynnsamma" "ogynnsamma" "ogynnsammare" "ogynnsammast" "ogynnsammaste" ;
  ohaallbar_av_1 = mkA "ohеllbar" ;
  ohaelsosam_av_1 = mkA "ohдlsosam" "ohдlsosamt" "ohдlsosamma" "ohдlsosamma" "ohдlsosammare" "ohдlsosammast" "ohдlsosammaste" ;
  ohaengd_av_1 = mkA "ohдngd" "ohдngt" ;
  ohanterlig_av_1 = mkA "ohanterlig" ;
  ohederlig_av_1 = mkA "ohederlig" ;
  ohederlighet_nn_1 = mkN "ohederlighet" "ohederligheter" ;
  ohelig_av_1 = mkA "ohelig" ;
  ohemul_av_1 = mkA "ohemul" ;
  oherrans_av_1 = mkA "oherrans" ;
  ohistorisk_av_1 = mkA "ohistorisk" ;
  ohjaelplig_av_1 = mkA "ohjдlplig" ;
  ohm_nn_1 = mkN "ohm" "ohmen" "ohm" "ohmen" ;
  ohoeljd_av_1 = mkA "ohцljd" "ohцljt" ;
  ohoerbar_av_1 = mkA "ohцrbar" ;
  ohoerd_av_1 = mkA "ohцrd" "ohцrt" ;
  ohoersam_av_1 = mkA "ohцrsam" "ohцrsamt" "ohцrsamma" "ohцrsamma" "ohцrsammare" "ohцrsammast" "ohцrsammaste" ;
  ohoevlig_av_1 = mkA "ohцvlig" ;
  ohygglig_av_1 = mkA "ohygglig" ;
  ohygienisk_av_1 = mkA "ohygienisk" ;
  oigenkaennlig_av_1 = mkA "oigenkдnnlig" ;
  oigenkaennlighet_nn_1 = mkN "oigenkдnnlighet" "oigenkдnnligheter" ;
  oinbunden_av_1 = mkA "oinbunden" "oinbundet" ;
  oinredd_av_1 = mkA "oinredd" ;
  oinskraenkt_av_1 = mkA "oinskrдnkt" "oinskrдnkt" ;
  ointaglig_av_1 = mkA "ointaglig" ;
  ointelligent_av_1 = mkA "ointelligent" "ointelligent" ;
  ointressant_av_1 = mkA "ointressant" "ointressant" ;
  oinvigd_av_1 = mkA "oinvigd" "oinvigt" ;
  ojaemfoerbar_av_1 = mkA "ojдmfцrbar" ;
  ojaemfoerlig_av_1 = mkA "ojдmfцrlig" ;
  ojaemn_av_1 = mkA "ojдmn" ;
  ojaemnhet_nn_1 = mkN "ojдmnhet" "ojдmnheter" ;
  ojaevig_av_1 = mkA "ojдvig" ;
  ojust_av_1 = mkA "ojust" "ojust" ;
  ok_nn_1 = mkN "ok" neutrum ;
  okaend_av_1 = mkA "okдnd" ;
  okaenslig_av_1 = mkA "okдnslig" ;
  okaer_av_1 = mkA "okдr" ;
  okamratlig_av_1 = mkA "okamratlig" ;
  okapi_nn_1 = mkN "okapi" "okapin" "okapier" "okapierna" ;
  okbaage_nn_1 = mkN "okbеge" utrum ;
  okben_nn_1 = mkN "okben" neutrum ;
  oklaedd_av_1 = mkA "oklдdd" "oklдdtt" ;
  oklanderlig_av_1 = mkA "oklanderlig" ;
  oklar_av_1 = mkA "oklar" ;
  oklarhet_nn_1 = mkN "oklarhet" "oklarheter" ;
  oklippt_av_1 = mkA "oklippt" "oklippt" ;
  oklok_av_1 = mkA "oklok" ;
  okokt_av_1 = mkA "okokt" "okokt" ;
  okontant_av_1 = mkA "okontant" "okontant" ;
  okontroversiell_av_1 = mkA "okontroversiell" ;
  okonventionell_av_1 = mkA "okonventionell" ;
  okraenkbar_av_1 = mkA "okrдnkbar" ;
  okristlig_av_1 = mkA "okristlig" ;
  okritisk_av_1 = mkA "okritisk" ;
  okroent_av_1 = mkA "okrцnt" "okrцnt" ;
  okroppslig_av_1 = mkA "okroppslig" ;
  okrossbar_av_1 = mkA "okrossbar" ;
  oktaeder_nn_1 = mkN "oktaeder" ;
  oktan_nn_1 = mkN "oktan" neutrum ;
  oktanol_nn_1 = mkN "oktanol" "oktanoler" ;
  oktant_nn_1 = mkN "oktant" "oktanter" ;
  oktantal_nn_1 = mkN "oktantal" "oktantalet" "oktantalen" "oktantalena" ;
  oktanvaerde_nn_1 = mkN "oktanvдrde" ;
  oktav_nn_1 = mkN "oktav" "oktaver" ;
  oktett_nn_1 = mkN "oktett" "oktetter" ;
  oktod_nn_1 = mkN "oktod" "oktoder" ;
  oktogon_nn_1 = mkN "oktogon" "oktogoner" ;
  oktroj_nn_1 = mkN "oktroj" "oktrojer" ;
  okulaer_av_1 = mkA "okulдr" ;
  okulage_nn_1 = mkN "okulage" "okulaget" "okulager" "okulagerna" ;
  okular_av_1 = mkA "okular" ;
  okular_nn_1 = mkN "okular" neutrum ;
  okunnig_av_1 = mkA "okunnig" ;
  okunnighet_nn_1 = mkN "okunnighet" "okunnigheter" ;
  okuvlig_av_1 = mkA "okuvlig" ;
  okvaede_nn_1 = mkN "okvдde" ;
  okvaeden_av_1 = mkA "okvдden" "okvдdet" ;
  okvaedinsord_nn_1 = mkN "okvдdinsord" neutrum ;
  okvald_av_1 = mkA "okvald" "okvalt" ;
  okvinnlig_av_1 = mkA "okvinnlig" ;
  okynnesfae_nn_1 = mkN "okynnesfд" "okynnesfдet" "okynnesfдn" "okynnesfдna" ;
  okynneshund_nn_1 = mkN "okynneshund" ;
  okynnesjakt_nn_1 = mkN "okynnesjakt" "okynnesjakter" ;
  okynnig_av_1 = mkA "okynnig" ;
  okyrklig_av_1 = mkA "okyrklig" ;
  okysk_av_1 = mkA "okysk" ;
  okysst_av_1 = mkA "okysst" "okysst" ;
  olaast_av_1 = mkA "olеst" "olеst" ;
  olaegenhet_nn_1 = mkN "olдgenhet" "olдgenheter" ;
  olaeglig_av_1 = mkA "olдglig" ;
  olaeklig_av_1 = mkA "olдklig" ;
  olaemplig_av_1 = mkA "olдmplig" ;
  olaendig_av_1 = mkA "olдndig" ;
  olaerd_av_1 = mkA "olдrd" "olдrt" ;
  olaesbar_av_1 = mkA "olдsbar" ;
  olaeslig_av_1 = mkA "olдslig" ;
  olaga_av_1 = mkA "olaga" ;
  olaglig_av_1 = mkA "olaglig" ;
  olaglighet_nn_1 = mkN "olaglighet" "olagligheter" ;
  olat_nn_1 = mkN "olat" "olater" ;
  oldboy_nn_1 = mkN "oldboy" ;
  oldtimer_nn_1 = mkN "oldtimer" "oldtimern" "oldtimers" "oldtimersen" ;
  oleander_nn_1 = mkN "oleander" ;
  oleat_nn_1 = mkN "oleat" "oleater" ;
  oleat_nn_2 = mkN "oleat" neutrum ;
  oledare_nn_1 = mkN "oledare" "oledare" ;
  olefin_nn_1 = mkN "olefin" "olefiner" ;
  olidlig_av_1 = mkA "olidlig" ;
  oligarki_nn_1 = mkN "oligarki" "oligarkier" ;
  oligofag_av_1 = mkA "oligofag" ;
  oligopol_nn_1 = mkN "oligopol" neutrum ;
  oligotrof_av_1 = mkA "oligotrof" ;
  olik_av_1 = mkA "olik" ;
  olika_ab_1 = mkAdv "olika" ;
  olikhet_nn_1 = mkN "olikhet" "olikheter" ;
  olikstor_av_1 = mkA "olikstor" ;
  oliktaenkande_av_1 = mkA "oliktдnkande" ;
  oliv_nn_1 = mkN "oliv" "oliver" ;
  olivin_nn_1 = mkN "olivin" "oliviner" ;
  olivolja_nn_1 = mkN "olivolja" ;
  olivtraed_nn_1 = mkN "olivtrдd" neutrum ;
  olja_nn_1 = mkN "olja" ;
  oljeaekta_av_1 = mkA "oljeдkta" ;
  oljeaggregat_nn_1 = mkN "oljeaggregat" neutrum ;
  oljebaelte_nn_1 = mkN "oljebдlte" ;
  oljebolag_nn_1 = mkN "oljebolag" neutrum ;
  oljeborrning_nn_1 = mkN "oljeborrning" ;
  oljeborrtorn_nn_1 = mkN "oljeborrtorn" neutrum ;
  oljebraennare_nn_1 = mkN "oljebrдnnare" "oljebrдnnare" ;
  oljebrand_nn_1 = mkN "oljebrand" "oljebrдnder" ;
  oljebrunn_nn_1 = mkN "oljebrunn" ;
  oljebyte_nn_1 = mkN "oljebyte" ;
  oljefaelt_nn_1 = mkN "oljefдlt" neutrum ;
  oljefaerg_nn_1 = mkN "oljefдrg" "oljefдrger" ;
  oljefilter_nn_1 = mkN "oljefilter" neutrum ;
  oljeinpackning_nn_1 = mkN "oljeinpackning" ;
  oljelaas_nn_1 = mkN "oljelеs" neutrum ;
  oljeland_nn_1 = mkN "oljeland" "oljelandet" "oljelдnder" "oljelдnderna" ;
  oljemaalning_nn_1 = mkN "oljemеlning" ;
  oljepalm_nn_1 = mkN "oljepalm" "oljepalmer" ;
  oljepris_nn_1 = mkN "oljepris" neutrum ;
  oljerik_av_1 = mkA "oljerik" ;
  oljering_nn_1 = mkN "oljering" ;
  oljeriven_av_1 = mkA "oljeriven" "oljerivet" ;
  oljesanktion_nn_1 = mkN "oljesanktion" "oljesanktioner" ;
  oljeskiffer_nn_1 = mkN "oljeskiffer" ;
  oljeslageri_nn_1 = mkN "oljeslageri" "oljeslagerit" "oljeslagerier" "oljeslagerierna" ;
  oljestaell_nn_1 = mkN "oljestдll" neutrum ;
  oljestopp_nn_1 = mkN "oljestopp" neutrum ;
  oljestroembrytare_nn_1 = mkN "oljestrцmbrytare" "oljestrцmbrytare" ;
  oljesump_nn_1 = mkN "oljesump" ;
  oljetanker_nn_1 = mkN "oljetanker" ;
  oljetraag_nn_1 = mkN "oljetrеg" neutrum ;
  oljetryck_nn_1 = mkN "oljetryck" neutrum ;
  oljeutslaepp_nn_1 = mkN "oljeutslдpp" neutrum ;
  oljevaev_nn_1 = mkN "oljevдv" ;
  oljevaext_nn_1 = mkN "oljevдxt" "oljevдxter" ;
  oljig_av_1 = mkA "oljig" ;
  oljud_nn_1 = mkN "oljud" neutrum ;
  olle_nn_1 = mkN "olle" utrum ;
  ollon_nn_1 = mkN "ollon" neutrum ;
  ollonborre_nn_1 = mkN "ollonborre" utrum ;
  ollonmask_nn_1 = mkN "ollonmask" ;
  ollonpistol_nn_1 = mkN "ollonpistol" "ollonpistoler" ;
  ollonskog_nn_1 = mkN "ollonskog" ;
  ollonskott_nn_1 = mkN "ollonskott" neutrum ;
  ollonsvin_nn_1 = mkN "ollonsvin" neutrum ;
  ollontraed_nn_1 = mkN "ollontrдd" neutrum ;
  olm_nn_1 = mkN "olm" ;
  oloensam_av_1 = mkA "olцnsam" "olцnsamt" "olцnsamma" "olцnsamma" "olцnsammare" "olцnsammast" "olцnsammaste" ;
  oloent_av_1 = mkA "olцnt" "olцnt" ;
  oloesbar_av_1 = mkA "olцsbar" ;
  oloeslig_av_1 = mkA "olцslig" ;
  oloest_av_1 = mkA "olцst" "olцst" ;
  ologisk_av_1 = mkA "ologisk" ;
  olovandes_ab_1 = mkAdv "olovandes" ;
  olovlig_av_1 = mkA "olovlig" ;
  olovligen_ab_1 = mkAdv "olovligen" ;
  olustig_av_1 = mkA "olustig" ;
  olvon_nn_1 = mkN "olvon" neutrum ;
  olvonvaext_nn_1 = mkN "olvonvдxt" "olvonvдxter" ;
  olycklig_av_1 = mkA "olycklig" ;
  olyckligtvis_ab_1 = mkAdv "olyckligtvis" ;
  olycksalig_av_1 = mkA "olycksalig" ;
  olycksbaadande_av_1 = mkA "olycksbеdande" ;
  olycksbarn_nn_1 = mkN "olycksbarn" neutrum ;
  olycksbringande_av_1 = mkA "olycksbringande" ;
  olycksbroder_nn_1 = mkN "olycksbroder" "olycksbrodern" "olycksbrцder" "olycksbrцderna" ;
  olycksdag_nn_1 = mkN "olycksdag" ;
  olycksdiger_av_1 = mkA "olycksdiger" "olycksdigert" "olycksdigra" "olycksdigra" "olycksdigrare" "olycksdigrast" "olycksdigraste" ;
  olycksfaagel_nn_1 = mkN "olycksfеgel" ;
  olycksfall_nn_1 = mkN "olycksfall" neutrum ;
  olyckshaendelse_nn_1 = mkN "olyckshдndelse" "olyckshдndelser" ;
  olyckskamrat_nn_1 = mkN "olyckskamrat" "olyckskamrater" ;
  olyckskatastrof_nn_1 = mkN "olyckskatastrof" "olyckskatastrofer" ;
  olyckskorp_nn_1 = mkN "olyckskorp" ;
  olycksplats_nn_1 = mkN "olycksplats" "olycksplatser" ;
  olycksstatistik_nn_1 = mkN "olycksstatistik" "olycksstatistiker" ;
  olyckstal_nn_1 = mkN "olyckstal" "olyckstalet" "olyckstalen" "olyckstalena" ;
  olydig_av_1 = mkA "olydig" ;
  olydnad_nn_1 = mkN "olydnad" "olydnader" ;
  olympiad_nn_1 = mkN "olympiad" "olympiader" ;
  olympiasegrare_nn_1 = mkN "olympiasegrare" "olympiasegrare" ;
  olympier_nn_1 = mkN "olympier" "olympiern" "olympier" "olympierna" ;
  olympisk_av_1 = mkA "olympisk" ;
  om_ab_1 = mkAdv "om" ;
  omaattlig_av_1 = mkA "omеttlig" ;
  omaensklig_av_1 = mkA "omдnsklig" ;
  omaerklig_av_1 = mkA "omдrklig" ;
  omaetlig_av_1 = mkA "omдtlig" ;
  omaettlig_av_1 = mkA "omдttlig" ;
  omaka_av_1 = mkA "omaka" ;
  omanier_nn_1 = mkN "omanier" "omaniern" "omanier" "omanierna" ;
  omanlig_av_1 = mkA "omanlig" ;
  omansk_av_1 = mkA "omansk" ;
  omarbetning_nn_1 = mkN "omarbetning" ;
  ombe_vb_1 = mkV "ombe" "ombad" "ombett" ;
  ombedja_vb_1 = mkV "ombedja" "ombedjar" "ombedja" "ombedjad" "ombedjatt" "ombedjadd" ;
  omblad_nn_1 = mkN "omblad" neutrum ;
  omblandning_nn_1 = mkN "omblandning" ;
  omblandningsprocess_nn_1 = mkN "omblandningsprocess" "omblandningsprocesser" ;
  ombord_ab_1 = mkAdv "ombord" ;
  ombordlaeggning_nn_1 = mkN "ombordlдggning" ;
  ombryta_vb_1 = mkV "ombryta" "ombrцt" "ombrutit" ;
  ombud_nn_1 = mkN "ombud" neutrum ;
  ombudsman_nn_1 = mkN "ombudsman" "ombudsmannen" "ombudsmдn" "ombudsmдnnen" ;
  ombyggnad_nn_1 = mkN "ombyggnad" "ombyggnader" ;
  ombyte_nn_1 = mkN "ombyte" ;
  ombytlig_av_1 = mkA "ombytlig" ;
  ombytt_av_1 = mkA "ombytt" ;
  omdaning_nn_1 = mkN "omdaning" ;
  omdoeme_nn_1 = mkN "omdцme" ;
  omdoemesfraaga_nn_1 = mkN "omdцmesfrеga" ;
  omdoemesgill_av_1 = mkA "omdцmesgill" ;
  omdoemesloes_av_1 = mkA "omdцmeslцs" ;
  omedelbar_av_1 = mkA "omedelbar" ;
  omedgoerlig_av_1 = mkA "omedgцrlig" ;
  omedveten_av_1 = mkA "omedveten" "omedvetet" ;
  omedvetenhet_nn_1 = mkN "omedvetenhet" "omedvetenheter" ;
  omega_nn_1 = mkN "omega" "omegat" "omega" "omegana" ;
  omelett_nn_1 = mkN "omelett" "omeletter" ;
  omen_nn_1 = mkN "omen" neutrum ;
  omfaangsrik_av_1 = mkA "omfеngsrik" ;
  omfamning_nn_1 = mkN "omfamning" ;
  omfattande_av_1 = mkA "omfattande" ;
  omfattning_nn_1 = mkN "omfattning" ;
  omfoederska_nn_1 = mkN "omfцderska" ;
  omfoerdelning_nn_1 = mkN "omfцrdelning" ;
  omformare_nn_1 = mkN "omformare" "omformare" ;
  omgaaende_ab_1 = mkAdv "omgеende" ;
  omgaang_nn_1 = mkN "omgеng" ;
  omge_vb_1 = mkV "omge" "omger" "omge" "omgav" "omgett" "omgiven" ;
  omgestaltning_nn_1 = mkN "omgestaltning" ;
  omgift_av_1 = mkA "omgift" "omgift" ;
  omgiv_nn_1 = mkN "omgiv" ;
  omgivning_nn_1 = mkN "omgivning" ;
  omgjord_av_1 = mkA "omgjord" "omgjort" ;
  omhaender_ab_1 = mkAdv "omhдnder" ;
  omhaenderta_vb_1 = mkV "omhдnderta" "omhдndertar" "omhдnderta" "omhдndertog" "omhдndertagit" "omhдndertagen" ;
  omhand_ab_1 = mkAdv "omhand" ;
  omhopp_nn_1 = mkN "omhopp" neutrum ;
  omigen_ab_1 = mkAdv "omigen" ;
  omild_av_1 = mkA "omild" "omilt" ;
  ominoes_av_1 = mkA "ominцs" ;
  omintet_ab_1 = mkAdv "omintet" ;
  omisskaennlig_av_1 = mkA "omisskдnnlig" ;
  omisstaenksam_av_1 = mkA "omisstдnksam" "omisstдnksamt" "omisstдnksamma" "omisstдnksamma" "omisstдnksammare" "omisstдnksammast" "omisstдnksammaste" ;
  omistlig_av_1 = mkA "omistlig" ;
  omkast_nn_1 = mkN "omkast" neutrum ;
  omkastare_nn_1 = mkN "omkastare" "omkastare" ;
  omklaedning_nn_1 = mkN "omklдdning" ;
  omkoep_nn_1 = mkN "omkцp" neutrum ;
  omkoerning_nn_1 = mkN "omkцrning" ;
  omkoerningsfoerbud_nn_1 = mkN "omkцrningsfцrbud" neutrum ;
  omkomma_vb_1 = mkV "omkomma" "omkom" "omkommit" ;
  omkopplare_nn_1 = mkN "omkopplare" "omkopplare" ;
  omkring_ab_1 = mkAdv "omkring" ;
  omkull_ab_1 = mkAdv "omkull" ;
  omlaeggning_nn_1 = mkN "omlдggning" ;
  omljud_nn_1 = mkN "omljud" neutrum ;
  omljudd_av_1 = mkA "omljudd" ;
  omlopp_nn_1 = mkN "omlopp" neutrum ;
  omloppstid_nn_1 = mkN "omloppstid" "omloppstider" ;
  omlott_ab_1 = mkAdv "omlott" ;
  omnaemnande_nn_1 = mkN "omnдmnande" ;
  omnibus_nn_1 = mkN "omnibus" ;
  omnifyr_nn_1 = mkN "omnifyr" ;
  omnivor_nn_1 = mkN "omnivor" "omnivoren" "omnivorer" "omnivorerna" ;
  omodern_av_1 = mkA "omodern" ;
  omoejlig_av_1 = mkA "omцjlig" ;
  omoejligen_ab_1 = mkAdv "omцjligen" ;
  omoejlighet_nn_1 = mkN "omцjlighet" "omцjligheter" ;
  omogen_av_1 = mkA "omogen" "omoget" ;
  omoralisk_av_1 = mkA "omoralisk" ;
  omotsaeglig_av_1 = mkA "omotsдglig" ;
  omotsagd_av_1 = mkA "omotsagd" "omotsagt" ;
  omotstaandlig_av_1 = mkA "omotstеndlig" ;
  omottaglig_av_1 = mkA "omottaglig" ;
  omproevning_nn_1 = mkN "omprцvning" ;
  omraade_nn_1 = mkN "omrеde" ;
  omriktare_nn_1 = mkN "omriktare" "omriktare" ;
  omroerning_nn_1 = mkN "omrцrning" ;
  omroestning_nn_1 = mkN "omrцstning" ;
  omsaettning_nn_1 = mkN "omsдttning" ;
  omsaettningstillgaang_nn_1 = mkN "omsдttningstillgеng" ;
  omsams_ab_1 = mkAdv "omsams" ;
  omsegling_nn_1 = mkN "omsegling" ;
  omsider_ab_1 = mkAdv "omsider" ;
  omskaera_vb_1 = mkV "omskдra" "omskar" "omskurit" ;
  omskaerelse_nn_1 = mkN "omskдrelse" "omskдrelser" ;
  omskakande_av_1 = mkA "omskakande" ;
  omskiftare_nn_1 = mkN "omskiftare" "omskiftare" ;
  omskiftartangent_nn_1 = mkN "omskiftartangent" "omskiftartangenter" ;
  omskolning_nn_1 = mkN "omskolning" ;
  omskriva_vb_1 = mkV "omskriva" "omskrev" "omskrivit" ;
  omskriven_av_1 = mkA "omskriven" "omskrivet" ;
  omskrivning_nn_1 = mkN "omskrivning" ;
  omskruten_av_1 = mkA "omskruten" "omskrutet" ;
  omskulpturering_nn_1 = mkN "omskulpturering" ;
  omslag_nn_1 = mkN "omslag" neutrum ;
  omslagsbild_nn_1 = mkN "omslagsbild" "omslagsbilder" ;
  omslagspapper_nn_1 = mkN "omslagspapper" neutrum ;
  omslagsrevers_nn_1 = mkN "omslagsrevers" "omslagsreverser" ;
  omslut_nn_1 = mkN "omslut" neutrum ;
  omsluta_vb_1 = mkV "omsluta" "omslцt" "omslutit" ;
  omslutning_nn_1 = mkN "omslutning" ;
  omsorg_nn_1 = mkN "omsorg" "omsorger" ;
  omsorgsfull_av_1 = mkA "omsorgsfull" ;
  omspel_nn_1 = mkN "omspel" "omspelet" "omspel" "omspelen" ;
  omspinna_vb_1 = mkV "omspinna" "omspann" "omspunnit" ;
  omstaaende_av_1 = mkA "omstеende" ;
  omstaellning_nn_1 = mkN "omstдllning" ;
  omstaendighet_nn_1 = mkN "omstдndighet" "omstдndigheter" ;
  omstaendlig_av_1 = mkA "omstдndlig" ;
  omstart_nn_1 = mkN "omstart" "omstarter" ;
  omstigning_nn_1 = mkN "omstigning" ;
  omstridd_av_1 = mkA "omstridd" ;
  omstyr_ab_1 = mkAdv "omstyr" ;
  omsvaengning_nn_1 = mkN "omsvдngning" ;
  omsving_nn_1 = mkN "omsving" ;
  omta_vb_1 = mkV "omta" "omtar" "omta" "omtog" "omtagit" "omtagen" ;
  omtaenksam_av_1 = mkA "omtдnksam" "omtдnksamt" "omtдnksamma" "omtдnksamma" "omtдnksammare" "omtдnksammast" "omtдnksammaste" ;
  omtag_nn_1 = mkN "omtag" neutrum ;
  omtagning_nn_1 = mkN "omtagning" ;
  omtal_nn_1 = mkN "omtal" "omtalet" "omtalen" "omtalena" ;
  omtryck_nn_1 = mkN "omtryck" neutrum ;
  omtumlande_av_1 = mkA "omtumlande" ;
  omtyckt_av_1 = mkA "omtyckt" "omtyckt" ;
  omusikalisk_av_1 = mkA "omusikalisk" ;
  omutbar_av_1 = mkA "omutbar" ;
  omutlig_av_1 = mkA "omutlig" ;
  omvaardnad_nn_1 = mkN "omvеrdnad" "omvеrdnader" ;
  omvaeg_nn_1 = mkN "omvдg" ;
  omvaelvning_nn_1 = mkN "omvдlvning" ;
  omvaend_av_1 = mkA "omvдnd" ;
  omvaendbar_av_1 = mkA "omvдndbar" ;
  omvaendelse_nn_1 = mkN "omvдndelse" "omvдndelser" ;
  omvaendning_nn_1 = mkN "omvдndning" ;
  omvaendningsfilm_nn_1 = mkN "omvдndningsfilm" "omvдndningsfilmer" ;
  omvaendningstecken_nn_1 = mkN "omvдndningstecken" "omvдndningstecknet" "omvдndningstecken" "omvдndningstecknen" ;
  omvaerdering_nn_1 = mkN "omvдrdering" ;
  omvaerld_nn_1 = mkN "omvдrld" ;
  omvaexlande_av_1 = mkA "omvдxlande" ;
  omval_nn_1 = mkN "omval" neutrum ;
  omvandlare_nn_1 = mkN "omvandlare" "omvandlare" ;
  omvandling_nn_1 = mkN "omvandling" ;
  omyndig_av_1 = mkA "omyndig" ;
  omyndigfoerklaring_nn_1 = mkN "omyndigfцrklaring" ;
  omyndighetsfoerklaring_nn_1 = mkN "omyndighetsfцrklaring" ;
  onaabar_av_1 = mkA "onеbar" ;
  onaadig_av_1 = mkA "onеdig" ;
  onaemnbar_av_1 = mkA "onдmnbar" ;
  onager_nn_1 = mkN "onager" "onagern" "onagrer" "onagrerna" ;
  onaturlig_av_1 = mkA "onaturlig" ;
  ond_av_1 = mkA "ond" ;
  ondsint_av_1 = mkA "ondsint" "ondsint" ;
  ondskefull_av_1 = mkA "ondskefull" ;
  oneklig_av_1 = mkA "oneklig" ;
  onekligen_ab_1 = mkAdv "onekligen" ;
  onkel_nn_1 = mkN "onkel" ;
  onoedig_av_1 = mkA "onцdig" ;
  onoedigtvis_ab_1 = mkAdv "onцdigtvis" ;
  onoejaktig_av_1 = mkA "onцjaktig" ;
  onomastisk_av_1 = mkA "onomastisk" ;
  onomatopoetisk_av_1 = mkA "onomatopoetisk" ;
  onormal_av_1 = mkA "onormal" ;
  onoslig_av_1 = mkA "onoslig" ;
  onsdag_nn_1 = mkN "onsdag" ;
  onsdagskvaell_nn_1 = mkN "onsdagskvдll" ;
  onsdagsmorgon_nn_1 = mkN "onsdagsmorgon" "onsdagsmorgonen" "onsdagsmorgnar" "onsdagsmorgnarna" ;
  ont_ab_1 = mkAdv "ont" ;
  ontogenetisk_av_1 = mkA "ontogenetisk" ;
  ontologi_nn_1 = mkN "ontologi" "ontologier" ;
  onus_nn_1 = mkN "onus" neutrum ;
  onykter_av_1 = mkA "onykter" "onyktert" "onyktra" "onyktra" "onyktrare" "onyktrast" "onyktraste" ;
  onykterhet_nn_1 = mkN "onykterhet" "onykterheter" ;
  onyttig_av_1 = mkA "onyttig" ;
  onyx_nn_1 = mkN "onyx" ;
  ooem_av_1 = mkA "oцm" "oцmt" "oцmma" "oцmma" "oцmmare" "oцmmast" "oцmmaste" ;
  ooeverbrygglig_av_1 = mkA "oцverbrygglig" ;
  ooeverkomlig_av_1 = mkA "oцverkomlig" ;
  ooeverlagd_av_1 = mkA "oцverlagd" "oцverlagt" ;
  ooeversaettlig_av_1 = mkA "oцversдttlig" ;
  ooeverskaadlig_av_1 = mkA "oцverskеdlig" ;
  ooeverstiglig_av_1 = mkA "oцverstiglig" ;
  ooevertaenkt_av_1 = mkA "oцvertдnkt" "oцvertдnkt" ;
  ooevertraefflig_av_1 = mkA "oцvertrдfflig" ;
  ooevervaegd_av_1 = mkA "oцvervдgd" "oцvervдgt" ;
  ooevervinnelig_av_1 = mkA "oцvervinnelig" ;
  oombedd_av_1 = mkA "oombedd" "oombedtt" ;
  oomkullkastlig_av_1 = mkA "oomkullkastlig" ;
  oomkullrunkelig_av_1 = mkA "oomkullrunkelig" ;
  oomljudd_av_1 = mkA "oomljudd" ;
  oomskuren_av_1 = mkA "oomskuren" "oomskuret" ;
  oomstridd_av_1 = mkA "oomstridd" ;
  oordentlig_av_1 = mkA "oordentlig" ;
  oorganisk_av_1 = mkA "oorganisk" ;
  oortodox_av_1 = mkA "oortodox" ;
  opaalitlig_av_1 = mkA "opеlitlig" ;
  opaatald_av_1 = mkA "opеtald" "opеtalt" ;
  opaaverkbar_av_1 = mkA "opеverkbar" ;
  opacitet_nn_1 = mkN "opacitet" "opaciteter" ;
  opak_av_1 = mkA "opak" ;
  opal_nn_1 = mkN "opal" "opaler" ;
  opaliserande_av_1 = mkA "opaliserande" ;
  oparlamentarisk_av_1 = mkA "oparlamentarisk" ;
  opartisk_av_1 = mkA "opartisk" ;
  opassande_av_1 = mkA "opassande" ;
  opasslig_av_1 = mkA "opasslig" ;
  opedagogisk_av_1 = mkA "opedagogisk" ;
  open_av_1 = mkA "open" ;
  opera_nn_1 = mkN "opera" ;
  operabalett_nn_1 = mkN "operabalett" "operabaletter" ;
  operabel_av_1 = mkA "operabel" "operabelt" "operabla" "operabla" "operablare" "operablast" "operablaste" ;
  operadike_nn_1 = mkN "operadike" ;
  operahus_nn_1 = mkN "operahus" neutrum ;
  operakompositoer_nn_1 = mkN "operakompositцr" "operakompositцrer" ;
  operation_nn_1 = mkN "operation" "operationer" ;
  operationell_av_1 = mkA "operationell" ;
  operationsbas_nn_1 = mkN "operationsbas" "operationsbaser" ;
  operationsbestick_nn_1 = mkN "operationsbestick" neutrum ;
  operationslinje_nn_1 = mkN "operationslinje" "operationslinjer" ;
  operativ_av_1 = mkA "operativ" ;
  operativsystem_nn_1 = mkN "operativsystem" neutrum ;
  operatoer_nn_1 = mkN "operatцr" "operatцrer" ;
  operator_nn_1 = mkN "operator" "operatorer" ;
  operatris_nn_1 = mkN "operatris" "operatriser" ;
  operett_nn_1 = mkN "operett" "operetter" ;
  operetteater_nn_1 = mkN "operetteater" ;
  opersonlig_av_1 = mkA "opersonlig" ;
  opiat_nn_1 = mkN "opiat" neutrum ;
  opinion_nn_1 = mkN "opinion" "opinioner" ;
  opinionsbildare_nn_1 = mkN "opinionsbildare" "opinionsbildare" ;
  opinionsbildning_nn_1 = mkN "opinionsbildning" ;
  opinionsmaetning_nn_1 = mkN "opinionsmдtning" ;
  opinionsnaemnd_nn_1 = mkN "opinionsnдmnd" "opinionsnдmnder" ;
  opinionsundersoekning_nn_1 = mkN "opinionsundersцkning" ;
  opinionsyttring_nn_1 = mkN "opinionsyttring" ;
  opiumliknande_av_1 = mkA "opiumliknande" ;
  opolitisk_av_1 = mkA "opolitisk" ;
  opossum_nn_1 = mkN "opossum" ;
  opp_ab_1 = mkAdv "opp" ;
  oppe_ab_1 = mkAdv "oppe" ;
  opponent_nn_1 = mkN "opponent" "opponenter" ;
  opportun_av_1 = mkA "opportun" ;
  opportunist_nn_1 = mkN "opportunist" "opportunister" ;
  opportunistisk_av_1 = mkA "opportunistisk" ;
  opposition_nn_1 = mkN "opposition" "oppositioner" ;
  oppositionell_av_1 = mkA "oppositionell" ;
  oppositionsledare_nn_1 = mkN "oppositionsledare" "oppositionsledare" ;
  oppositionsparti_nn_1 = mkN "oppositionsparti" "oppositionspartit" "oppositionspartier" "oppositionspartierna" ;
  opraktisk_av_1 = mkA "opraktisk" ;
  oprecis_av_1 = mkA "oprecis" ;
  opretentioes_av_1 = mkA "opretentiцs" ;
  oproportionerlig_av_1 = mkA "oproportionerlig" ;
  opsykologisk_av_1 = mkA "opsykologisk" ;
  optant_nn_1 = mkN "optant" "optanter" ;
  optativ_av_1 = mkA "optativ" ;
  optativ_nn_1 = mkN "optativ" "optativer" ;
  optiker_nn_1 = mkN "optiker" "optikern" "optiker" "optikerna" ;
  optimal_av_1 = mkA "optimal" ;
  optimist_nn_1 = mkN "optimist" "optimister" ;
  optimistisk_av_1 = mkA "optimistisk" ;
  optimistjolle_nn_1 = mkN "optimistjolle" utrum ;
  optimum_nn_1 = mkN "optimum" neutrum ;
  option_nn_1 = mkN "option" "optioner" ;
  optisk_av_1 = mkA "optisk" ;
  opulent_av_1 = mkA "opulent" "opulent" ;
  opus_nn_1 = mkN "opus" neutrum ;
  or_nn_1 = mkN "or" neutrum ;
  oraad_ab_1 = mkAdv "orеd" ;
  oraeknelig_av_1 = mkA "orдknelig" ;
  oraett_av_1 = mkA "orдtt" ;
  oraett_nn_1 = mkN "orдtt" "orдtter" ;
  oraettfaangen_av_1 = mkA "orдttfеngen" "orдttfеnget" ;
  oraettfaerdig_av_1 = mkA "orдttfдrdig" ;
  oraettmaetig_av_1 = mkA "orдttmдtig" ;
  oraettraadig_av_1 = mkA "orдttrеdig" ;
  oraettvis_av_1 = mkA "orдttvis" ;
  orakel_nn_1 = mkN "orakel" neutrum ;
  oral_av_1 = mkA "oral" ;
  orange_av_1 = mkA "orange" ;
  orange_nn_1 = mkN "orange" "oranger" ;
  orangeri_nn_1 = mkN "orangeri" "orangerit" "orangerier" "orangerierna" ;
  orangutang_nn_1 = mkN "orangutang" "orangutanger" ;
  orant_nn_1 = mkN "orant" "oranter" ;
  oration_nn_1 = mkN "oration" "orationer" ;
  orationell_av_1 = mkA "orationell" ;
  orator_nn_1 = mkN "orator" "oratorer" ;
  oratorisk_av_1 = mkA "oratorisk" ;
  oratorium_nn_1 = mkN "oratorium" "oratoriet" "oratorier" "oratorierna" ;
  orbital_nn_1 = mkN "orbital" "orbitaler" ;
  ord_nn_1 = mkN "ord" neutrum ;
  ordaccent_nn_1 = mkN "ordaccent" "ordaccenter" ;
  ordagrann_av_1 = mkA "ordagrann" "ordagrant" ;
  ordal_nn_1 = mkN "ordal" "ordalet" "ordal" "ordalierna" ;
  ordalydelse_nn_1 = mkN "ordalydelse" "ordalydelser" ;
  ordbehandlare_nn_1 = mkN "ordbehandlare" "ordbehandlare" ;
  ordbild_nn_1 = mkN "ordbild" "ordbilder" ;
  ordbildning_nn_1 = mkN "ordbildning" ;
  ordblind_av_1 = mkA "ordblind" ;
  ordblindhet_nn_1 = mkN "ordblindhet" "ordblindheter" ;
  ordboejning_nn_1 = mkN "ordbцjning" ;
  ordbok_nn_1 = mkN "ordbok" "ordbцcker" ;
  ordbyte_nn_1 = mkN "ordbyte" ;
  orddel_nn_1 = mkN "orddel" "orddelen" "orddelar" "orddelarna" ;
  orddoev_av_1 = mkA "orddцv" ;
  orden_nn_1 = mkN "orden" ;
  ordenskapitel_nn_1 = mkN "ordenskapitel" neutrum ;
  ordenssaellskap_nn_1 = mkN "ordenssдllskap" "ordenssдllskapet" "ordenssдllskapen" "ordenssдllskapena" ;
  ordentlig_av_1 = mkA "ordentlig" ;
  order_nn_1 = mkN "order" ;
  orderstock_nn_1 = mkN "orderstock" ;
  ordfattig_av_1 = mkA "ordfattig" ;
  ordfloede_nn_1 = mkN "ordflцde" ;
  ordfoeljd_nn_1 = mkN "ordfцljd" "ordfцljder" ;
  ordfoerande_nn_1 = mkN "ordfцrande" "ordfцranden" "ordfцrande" "ordfцrandena" ;
  ordfoerekomst_nn_1 = mkN "ordfцrekomst" "ordfцrekomster" ;
  ordfoerklaring_nn_1 = mkN "ordfцrklaring" ;
  ordfoerraad_nn_1 = mkN "ordfцrrеd" neutrum ;
  ordfogning_nn_1 = mkN "ordfogning" ;
  ordform_nn_1 = mkN "ordform" ;
  ordfot_nn_1 = mkN "ordfot" "ordfцtter" ;
  ordgrupp_nn_1 = mkN "ordgrupp" "ordgrupper" ;
  ordhaallig_av_1 = mkA "ordhеllig" ;
  ordinaer_av_1 = mkA "ordinдr" ;
  ordinand_nn_1 = mkN "ordinand" "ordinander" ;
  ordinarie_av_1 = mkA "ordinarie" ;
  ordination_nn_1 = mkN "ordination" "ordinationer" ;
  ordklass_nn_1 = mkN "ordklass" "ordklasser" ;
  ordklyveri_nn_1 = mkN "ordklyveri" "ordklyverit" "ordklyverier" "ordklyverierna" ;
  ordknapp_av_1 = mkA "ordknapp" ;
  ordkonstnaer_nn_1 = mkN "ordkonstnдr" "ordkonstnдrer" ;
  ordkonstruktion_nn_1 = mkN "ordkonstruktion" "ordkonstruktioner" ;
  ordlek_nn_1 = mkN "ordlek" ;
  ordloes_av_1 = mkA "ordlцs" ;
  ordning_nn_1 = mkN "ordning" ;
  ordningsam_av_1 = mkA "ordningsam" "ordningsamt" "ordningsamma" "ordningsamma" "ordningsammare" "ordningsammast" "ordningsammaste" ;
  ordningsbestaemmelse_nn_1 = mkN "ordningsbestдmmelse" "ordningsbestдmmelser" ;
  ordningsfoeljd_nn_1 = mkN "ordningsfцljd" "ordningsfцljder" ;
  ordningsfoerseelse_nn_1 = mkN "ordningsfцrseelse" "ordningsfцrseelser" ;
  ordningsfraaga_nn_1 = mkN "ordningsfrеga" ;
  ordningsman_nn_1 = mkN "ordningsman" "ordningsmannen" "ordningsmдn" "ordningsmдnnen" ;
  ordningspolis_nn_1 = mkN "ordningspolis" "ordningspoliser" ;
  ordningsstadga_nn_1 = mkN "ordningsstadga" ;
  ordningstal_nn_1 = mkN "ordningstal" "ordningstalet" "ordningstalen" "ordningstalena" ;
  ordningsvakt_nn_1 = mkN "ordningsvakt" "ordningsvakter" ;
  ordonnans_nn_1 = mkN "ordonnans" "ordonnanser" ;
  ordovicium_nn_1 = mkN "ordovicium" "ordovicium" "ordovicia" "ordoviciana" ;
  ordraett_av_1 = mkA "ordrдtt" ;
  ordrik_av_1 = mkA "ordrik" ;
  ordrot_nn_1 = mkN "ordrot" "ordrцtter" ;
  ordryttare_nn_1 = mkN "ordryttare" "ordryttare" ;
  ordskillnad_nn_1 = mkN "ordskillnad" "ordskillnader" ;
  ordskrift_nn_1 = mkN "ordskrift" "ordskrifter" ;
  ordslut_nn_1 = mkN "ordslut" neutrum ;
  ordspraak_nn_1 = mkN "ordsprеk" neutrum ;
  ordstaev_nn_1 = mkN "ordstдv" neutrum ;
  ordstam_nn_1 = mkN "ordstam" "ordstammen" "ordstammar" "ordstammarna" ;
  ordstum_av_1 = mkA "ordstum" "ordstumt" "ordstumma" "ordstumma" "ordstummare" "ordstummast" "ordstummaste" ;
  ordtrogen_av_1 = mkA "ordtrogen" "ordtroget" ;
  ordvaendning_nn_1 = mkN "ordvдndning" ;
  ordvaexling_nn_1 = mkN "ordvдxling" ;
  ordval_nn_1 = mkN "ordval" neutrum ;
  ordvits_nn_1 = mkN "ordvits" ;
  ordvraengare_nn_1 = mkN "ordvrдngare" "ordvrдngare" ;
  oread_nn_1 = mkN "oread" "oreader" ;
  orealistisk_av_1 = mkA "orealistisk" ;
  oredig_av_1 = mkA "oredig" ;
  oredlig_av_1 = mkA "oredlig" ;
  oredlighet_nn_1 = mkN "oredlighet" "oredligheter" ;
  oregelbunden_av_1 = mkA "oregelbunden" "oregelbundet" ;
  oregelbundenhet_nn_1 = mkN "oregelbundenhet" "oregelbundenheter" ;
  oregelmaessig_av_1 = mkA "oregelmдssig" ;
  oregerlig_av_1 = mkA "oregerlig" ;
  oren_av_1 = mkA "oren" ;
  orenhet_nn_1 = mkN "orenhet" "orenheter" ;
  orenlig_av_1 = mkA "orenlig" ;
  orenlighet_nn_1 = mkN "orenlighet" "orenligheter" ;
  oresonabel_av_1 = mkA "oresonabel" ;
  oresonlig_av_1 = mkA "oresonlig" ;
  orfisk_av_1 = mkA "orfisk" ;
  orfism_nn_1 = mkN "orfism" "orfismer" ;
  organ_nn_1 = mkN "organ" neutrum ;
  organcell_nn_1 = mkN "organcell" "organceller" ;
  organell_nn_1 = mkN "organell" "organeller" ;
  organisation_nn_1 = mkN "organisation" "organisationer" ;
  organisatoer_nn_1 = mkN "organisatцr" "organisatцrer" ;
  organisatorisk_av_1 = mkA "organisatorisk" ;
  organisk_av_1 = mkA "organisk" ;
  organism_nn_1 = mkN "organism" "organismer" ;
  organist_nn_1 = mkN "organist" "organister" ;
  organogen_av_1 = mkA "organogen" ;
  organum_nn_1 = mkN "organum" neutrum ;
  orgasm_nn_1 = mkN "orgasm" "orgasmer" ;
  orgastisk_av_1 = mkA "orgastisk" ;
  orgel_nn_1 = mkN "orgel" ;
  orgelharmonium_nn_1 = mkN "orgelharmonium" "orgelharmoniet" "orgelharmonier" "orgelharmonierna" ;
  orgelliknande_av_1 = mkA "orgelliknande" ;
  orgelregister_nn_1 = mkN "orgelregister" neutrum ;
  orgelstaemma_nn_1 = mkN "orgelstдmma" ;
  orgeltrampare_nn_1 = mkN "orgeltrampare" "orgeltrampare" ;
  orgiastisk_av_1 = mkA "orgiastisk" ;
  orgie_nn_1 = mkN "orgie" "orgier" ;
  oriental_nn_1 = mkN "oriental" "orientaler" ;
  orientalisk_av_1 = mkA "orientalisk" ;
  orientalist_nn_1 = mkN "orientalist" "orientalister" ;
  orienterare_nn_1 = mkN "orienterare" "orienterare" ;
  orientering_nn_1 = mkN "orientering" ;
  orienteringsaemne_nn_1 = mkN "orienteringsдmne" ;
  orienteringspunkt_nn_1 = mkN "orienteringspunkt" "orienteringspunkter" ;
  orienteringstaevling_nn_1 = mkN "orienteringstдvling" ;
  orienteringstavla_nn_1 = mkN "orienteringstavla" ;
  original_nn_1 = mkN "original" neutrum ;
  originalitet_nn_1 = mkN "originalitet" "originaliteter" ;
  originalspraak_nn_1 = mkN "originalsprеk" neutrum ;
  originaltext_nn_1 = mkN "originaltext" "originaltexter" ;
  originell_av_1 = mkA "originell" ;
  oriktig_av_1 = mkA "oriktig" ;
  orimlig_av_1 = mkA "orimlig" ;
  orimlighet_nn_1 = mkN "orimlighet" "orimligheter" ;
  orkan_nn_1 = mkN "orkan" "orkaner" ;
  orkesloes_av_1 = mkA "orkeslцs" ;
  orkester_nn_1 = mkN "orkester" ;
  orkesterdike_nn_1 = mkN "orkesterdike" ;
  orkesterfoerening_nn_1 = mkN "orkesterfцrening" ;
  orkestermedlem_nn_1 = mkN "orkestermedlem" "orkestermedlemmen" "orkestermedlemmar" "orkestermedlemmarna" ;
  orkesterplats_nn_1 = mkN "orkesterplats" "orkesterplatser" ;
  orkestral_av_1 = mkA "orkestral" ;
  orkide_nn_1 = mkN "orkidй" "orkidйer" ;
  orkidevaext_nn_1 = mkN "orkidйvдxt" "orkidйvдxter" ;
  orlovssedel_nn_1 = mkN "orlovssedel" ;
  orm_nn_1 = mkN "orm" ;
  ormbaer_nn_1 = mkN "ormbдr" neutrum ;
  ormbo_nn_1 = mkN "ormbo" "ormbot" "ormbon" "ormboen" ;
  ormbunke_nn_1 = mkN "ormbunke" utrum ;
  ormbunksvaext_nn_1 = mkN "ormbunksvдxt" "ormbunksvдxter" ;
  ormdoedare_nn_1 = mkN "ormdцdare" "ormdцdare" ;
  ormgift_nn_1 = mkN "ormgift" "ormgiftet" "ormgifter" "ormgifterna" ;
  ormgran_nn_1 = mkN "ormgran" ;
  ormgrop_nn_1 = mkN "ormgrop" ;
  ormhaar_nn_1 = mkN "ormhеr" neutrum ;
  ormknut_nn_1 = mkN "ormknut" ;
  ormliknande_av_1 = mkA "ormliknande" ;
  ormmaenniska_nn_1 = mkN "ormmдnniska" ;
  ormoern_nn_1 = mkN "ormцrn" ;
  ormskinn_nn_1 = mkN "ormskinn" neutrum ;
  ormslaa_nn_1 = mkN "ormslе" "ormslеn" "ormslеr" "ormslеrna" ;
  ormtjusare_nn_1 = mkN "ormtjusare" "ormtjusare" ;
  ormtunga_nn_1 = mkN "ormtunga" ;
  ormvraak_nn_1 = mkN "ormvrеk" ;
  ormyngel_nn_1 = mkN "ormyngel" neutrum ;
  ornaesbjoerk_nn_1 = mkN "ornдsbjцrk" ;
  ornament_nn_1 = mkN "ornament" neutrum ;
  ornamental_av_1 = mkA "ornamental" ;
  ornamentering_nn_1 = mkN "ornamentering" ;
  ornamentist_nn_1 = mkN "ornamentist" "ornamentister" ;
  ornat_nn_1 = mkN "ornat" "ornater" ;
  orne_nn_1 = mkN "orne" utrum ;
  ornitolog_nn_1 = mkN "ornitolog" "ornitologer" ;
  ornitologisk_av_1 = mkA "ornitologisk" ;
  oro_nn_2 = mkN "oro" ;
  oroerbar_av_1 = mkA "orцrbar" ;
  oroerd_av_1 = mkA "orцrd" "orцrt" ;
  oroerlig_av_1 = mkA "orцrlig" ;
  orogenetisk_av_1 = mkA "orogenetisk" ;
  orolig_av_1 = mkA "orolig" ;
  orolighet_nn_1 = mkN "orolighet" "oroligheter" ;
  orosaar_nn_1 = mkN "orosеr" neutrum ;
  oroscentrum_nn_1 = mkN "oroscentrum" neutrum ;
  oroshaerd_nn_1 = mkN "oroshдrd" ;
  orosmoln_nn_1 = mkN "orosmoln" neutrum ;
  orosstiftare_nn_1 = mkN "orosstiftare" "orosstiftare" ;
  orovaeckande_av_1 = mkA "orovдckande" ;
  orre_nn_1 = mkN "orre" utrum ;
  orrfaagel_nn_1 = mkN "orrfеgel" ;
  orrspel_nn_1 = mkN "orrspel" "orrspelet" "orrspel" "orrspelen" ;
  orsak_nn_1 = mkN "orsak" "orsaker" ;
  orsaklig_av_1 = mkA "orsaklig" ;
  orsaksbestaemd_av_1 = mkA "orsaksbestдmd" "orsaksbestдmt" ;
  orsakskedja_nn_1 = mkN "orsakskedja" ;
  orsakskomplex_nn_1 = mkN "orsakskomplex" neutrum ;
  orsaksmaessig_av_1 = mkA "orsaksmдssig" ;
  orsakssamband_nn_1 = mkN "orsakssamband" neutrum ;
  orsakssammanhang_nn_1 = mkN "orsakssammanhang" neutrum ;
  ort_nn_1 = mkN "ort" "orter" ;
  ort_nn_2 = mkN "ort" ;
  ort_nn_3 = mkN "ort" neutrum ;
  ortdrivare_nn_1 = mkN "ortdrivare" "ortdrivare" ;
  ortikon_nn_1 = mkN "ortikon" "ortikoner" ;
  ortlig_av_1 = mkA "ortlig" ;
  ortlinje_nn_1 = mkN "ortlinje" "ortlinjer" ;
  ortnamn_nn_1 = mkN "ortnamn" neutrum ;
  ortoceratit_nn_1 = mkN "ortoceratit" "ortoceratiter" ;
  ortodox_av_1 = mkA "ortodox" ;
  ortodoxi_nn_1 = mkN "ortodoxi" "ortodoxier" ;
  ortodoxism_nn_1 = mkN "ortodoxism" "ortodoxismer" ;
  ortodrom_nn_1 = mkN "ortodrom" "ortodromer" ;
  ortogonal_av_1 = mkA "ortogonal" ;
  ortografi_nn_1 = mkN "ortografi" "ortografier" ;
  ortokromatisk_av_1 = mkA "ortokromatisk" ;
  ortolan_nn_1 = mkN "ortolan" "ortolaner" ;
  ortolansparv_nn_1 = mkN "ortolansparv" ;
  ortoped_nn_1 = mkN "ortoped" "ortopeder" ;
  ortoptist_nn_1 = mkN "ortoptist" "ortoptister" ;
  ortoptris_nn_1 = mkN "ortoptris" "ortoptriser" ;
  ortsavdrag_nn_1 = mkN "ortsavdrag" neutrum ;
  ortsgrupp_nn_1 = mkN "ortsgrupp" "ortsgrupper" ;
  ortstid_nn_1 = mkN "ortstid" "ortstider" ;
  ortstillaegg_nn_1 = mkN "ortstillдgg" neutrum ;
  orubblig_av_1 = mkA "orubblig" ;
  orund_av_1 = mkA "orund" ;
  orv_nn_1 = mkN "orv" neutrum ;
  orygglig_av_1 = mkA "orygglig" ;
  orytmisk_av_1 = mkA "orytmisk" ;
  oryx_nn_1 = mkN "oryx" "oryxer" ;
  os_nn_2 = mkN "os" neutrum ;
  osaald_av_1 = mkA "osеld" "osеlt" ;
  osaarbar_av_1 = mkA "osеrbar" ;
  osaegbar_av_1 = mkA "osдgbar" ;
  osaeglig_av_1 = mkA "osдglig" ;
  osaeker_av_1 = mkA "osдker" "osдkert" "osдkra" "osдkra" "osдkrare" "osдkrast" "osдkraste" ;
  osaekerhet_nn_1 = mkN "osдkerhet" "osдkerheter" ;
  osaekerhetsmoment_nn_1 = mkN "osдkerhetsmoment" "osдkerhetsmomentet" "osдkerhetsmomenten" "osдkerhetsmomentena" ;
  osaeljbar_av_1 = mkA "osдljbar" ;
  osaell_av_1 = mkA "osдll" ;
  osaellskaplig_av_1 = mkA "osдllskaplig" ;
  osaenkbar_av_1 = mkA "osдnkbar" ;
  osagd_av_1 = mkA "osagd" "osagt" ;
  osakkunnig_av_1 = mkA "osakkunnig" ;
  osaklig_av_1 = mkA "osaklig" ;
  osalig_av_1 = mkA "osalig" ;
  osammanhaengande_av_1 = mkA "osammanhдngande" ;
  osams_av_1 = mkA "osams" ;
  osann_av_1 = mkA "osann" "osant" ;
  osannfaerdig_av_1 = mkA "osannfдrdig" ;
  osanning_nn_1 = mkN "osanning" ;
  osannolik_av_1 = mkA "osannolik" ;
  oscillation_nn_1 = mkN "oscillation" "oscillationer" ;
  oscillator_nn_1 = mkN "oscillator" "oscillatorer" ;
  oscillograf_nn_1 = mkN "oscillograf" "oscillografer" ;
  oscillogram_nn_1 = mkN "oscillogram" "oscillogrammet" "oscillogram" "oscillogrammen" ;
  oscilloskop_nn_1 = mkN "oscilloskop" neutrum ;
  osed_nn_1 = mkN "osed" "oseder" ;
  osedlig_av_1 = mkA "osedlig" ;
  osedvanlig_av_1 = mkA "osedvanlig" ;
  osentimental_av_1 = mkA "osentimental" ;
  osiktbar_av_1 = mkA "osiktbar" ;
  osiktig_av_1 = mkA "osiktig" ;
  osinlig_av_1 = mkA "osinlig" ;
  osinnlig_av_1 = mkA "osinnlig" ;
  osjaelvisk_av_1 = mkA "osjдlvisk" ;
  osjaelviskhet_nn_1 = mkN "osjдlviskhet" "osjдlviskheter" ;
  osjaelvstaendig_av_1 = mkA "osjдlvstдndig" ;
  oskadd_av_1 = mkA "oskadd" ;
  oskadlig_av_1 = mkA "oskadlig" ;
  oskaelig_av_1 = mkA "oskдlig" ;
  oskaplig_av_1 = mkA "oskaplig" ;
  oskarian_nn_1 = mkN "oskarian" "oskarianer" ;
  oskariansk_av_1 = mkA "oskariansk" ;
  oskarp_av_1 = mkA "oskarp" ;
  oskattbar_av_1 = mkA "oskattbar" ;
  oskick_nn_1 = mkN "oskick" neutrum ;
  oskicklig_av_1 = mkA "oskicklig" ;
  oskiljaktig_av_1 = mkA "oskiljaktig" ;
  oskoen_av_1 = mkA "oskцn" ;
  oskriven_av_1 = mkA "oskriven" "oskrivet" ;
  oskuld_nn_1 = mkN "oskuld" "oskulder" ;
  oskuldsfull_av_1 = mkA "oskuldsfull" ;
  oskyld_1_av_1 = mkA "oskyld" "oskylt" ;
  oskyld_2_av_1 = mkA "oskyld" "oskylt" ;
  oskyldig_av_1 = mkA "oskyldig" ;
  oslaecklig_av_1 = mkA "oslдcklig" ;
  oslaeckt_av_1 = mkA "oslдckt" "oslдckt" ;
  oslagbar_av_1 = mkA "oslagbar" ;
  oslagen_av_1 = mkA "oslagen" "oslaget" ;
  osmaelt_av_1 = mkA "osmдlt" "osmдlt" ;
  osmaeltbar_av_1 = mkA "osmдltbar" ;
  osmaklig_av_1 = mkA "osmaklig" ;
  osmaklighet_nn_1 = mkN "osmaklighet" "osmakligheter" ;
  osman_nn_1 = mkN "osman" "osmaner" ;
  osmansk_av_1 = mkA "osmansk" ;
  osmidbar_av_1 = mkA "osmidbar" ;
  osmidig_av_1 = mkA "osmidig" ;
  osmord_av_1 = mkA "osmord" "osmort" ;
  osmotisk_av_1 = mkA "osmotisk" ;
  osnuten_av_1 = mkA "osnuten" "osnutet" ;
  osnygg_av_1 = mkA "osnygg" ;
  osocial_av_1 = mkA "osocial" ;
  osoekt_ab_1 = mkAdv "osцkt" ;
  osoekt_av_1 = mkA "osцkt" "osцkt" ;
  osolidarisk_av_1 = mkA "osolidarisk" ;
  ospard_av_1 = mkA "ospard" "ospart" ;
  ospelbar_av_1 = mkA "ospelbar" ;
  osportslig_av_1 = mkA "osportslig" ;
  ossuarium_nn_1 = mkN "ossuarium" "ossuariet" "ossuarier" "ossuarierna" ;
  ost_ab_1 = mkAdv "ost" ;
  ost_nn_1 = mkN "ost" ;
  ostadig_av_1 = mkA "ostadig" ;
  ostaemd_av_1 = mkA "ostдmd" "ostдmt" ;
  ostaerkt_av_1 = mkA "ostдrkt" "ostдrkt" ;
  ostanfraan_ab_1 = mkAdv "ostanfrеn" ;
  ostanifraan_ab_1 = mkAdv "ostanifrеn" ;
  ostensiv_av_1 = mkA "ostensiv" ;
  ostentativ_av_1 = mkA "ostentativ" ;
  osteolog_nn_1 = mkN "osteolog" "osteologer" ;
  ostframstaellning_nn_1 = mkN "ostframstдllning" ;
  osthyvel_nn_1 = mkN "osthyvel" ;
  ostig_av_1 = mkA "ostig" ;
  ostinato_nn_1 = mkN "ostinato" "ostinatot" "ostinaton" "ostinatona" ;
  ostindisk_av_1 = mkA "ostindisk" ;
  ostjak_nn_1 = mkN "ostjak" "ostjaker" ;
  ostjakisk_av_1 = mkA "ostjakisk" ;
  ostkant_nn_1 = mkN "ostkant" "ostkanter" ;
  ostkraem_nn_1 = mkN "ostkrдm" "ostkrдmer" ;
  ostkust_nn_1 = mkN "ostkust" "ostkuster" ;
  ostlig_av_1 = mkA "ostlig" ;
  ostliknande_av_1 = mkA "ostliknande" ;
  ostmask_nn_1 = mkN "ostmask" ;
  ostoerd_av_1 = mkA "ostцrd" "ostцrt" ;
  ostrafflig_av_1 = mkA "ostrafflig" ;
  ostrest_nn_1 = mkN "ostrest" "ostrester" ;
  ostridig_av_1 = mkA "ostridig" ;
  ostron_nn_1 = mkN "ostron" neutrum ;
  ostronbank_nn_1 = mkN "ostronbank" ;
  ostronfoergiftning_nn_1 = mkN "ostronfцrgiftning" ;
  ostronkniv_nn_1 = mkN "ostronkniv" ;
  ostruken_av_1 = mkA "ostruken" "ostruket" ;
  ostskaerare_nn_1 = mkN "ostskдrare" "ostskдrare" ;
  ostskalk_nn_1 = mkN "ostskalk" ;
  oststaang_nn_1 = mkN "oststеng" "oststдnger" ;
  ostvart_ab_1 = mkAdv "ostvart" ;
  ostyrig_av_1 = mkA "ostyrig" ;
  ostyrkt_av_1 = mkA "ostyrkt" "ostyrkt" ;
  osund_av_1 = mkA "osund" ;
  osvensk_av_1 = mkA "osvensk" ;
  osviklig_av_1 = mkA "osviklig" ;
  osvuren_av_1 = mkA "osvuren" "osvuret" ;
  osymmetrisk_av_1 = mkA "osymmetrisk" ;
  osympatisk_av_1 = mkA "osympatisk" ;
  osynlig_av_1 = mkA "osynlig" ;
  osystematisk_av_1 = mkA "osystematisk" ;
  otaalig_av_1 = mkA "otеlig" ;
  otacksam_av_1 = mkA "otacksam" "otacksamt" "otacksamma" "otacksamma" "otacksammare" "otacksammast" "otacksammaste" ;
  otadlig_av_1 = mkA "otadlig" ;
  otaeck_av_1 = mkA "otдck" ;
  otaeckhet_nn_1 = mkN "otдckhet" "otдckheter" ;
  otaecking_nn_1 = mkN "otдcking" ;
  otaemd_av_1 = mkA "otдmd" "otдmt" ;
  otaemjbar_av_1 = mkA "otдmjbar" ;
  otaemjd_av_1 = mkA "otдmjd" "otдmjt" ;
  otaend_av_1 = mkA "otдnd" ;
  otaenkbar_av_1 = mkA "otдnkbar" ;
  otaet_av_1 = mkA "otдt" ;
  otalig_av_1 = mkA "otalig" ;
  otalt_av_1 = mkA "otalt" ;
  oteknisk_av_1 = mkA "oteknisk" ;
  otidig_av_1 = mkA "otidig" ;
  otidighet_nn_1 = mkN "otidighet" "otidigheter" ;
  otidsenlig_av_1 = mkA "otidsenlig" ;
  otillaaten_av_1 = mkA "otillеten" "otillеtet" ;
  otillaatlig_av_1 = mkA "otillеtlig" ;
  otillboerlig_av_1 = mkA "otillbцrlig" ;
  otillboerlighet_nn_1 = mkN "otillbцrlighet" "otillbцrligheter" ;
  otillfoerlitlig_av_1 = mkA "otillfцrlitlig" ;
  otillfreds_av_1 = mkA "otillfreds" ;
  otillfredsstaellande_av_1 = mkA "otillfredsstдllande" ;
  otillfredsstaelld_av_1 = mkA "otillfredsstдlld" "otillfredsstдllt" ;
  otillgaenglig_av_1 = mkA "otillgдnglig" ;
  otillraecklig_av_1 = mkA "otillrдcklig" ;
  otillraeknelig_av_1 = mkA "otillrдknelig" ;
  otillstaendig_av_1 = mkA "otillstдndig" ;
  otit_nn_1 = mkN "otit" "otiter" ;
  otjaenlig_av_1 = mkA "otjдnlig" ;
  otjaenst_nn_1 = mkN "otjдnst" "otjдnster" ;
  otoerstig_av_1 = mkA "otцrstig" ;
  otolog_nn_1 = mkN "otolog" "otologer" ;
  otrevlig_av_1 = mkA "otrevlig" ;
  otrevlighet_nn_1 = mkN "otrevlighet" "otrevligheter" ;
  otrivsam_av_1 = mkA "otrivsam" "otrivsamt" "otrivsamma" "otrivsamma" "otrivsammare" "otrivsammast" "otrivsammaste" ;
  otroestlig_av_1 = mkA "otrцstlig" ;
  otroettlig_av_1 = mkA "otrцttlig" ;
  otrogen_av_1 = mkA "otrogen" "otroget" ;
  otrohet_nn_1 = mkN "otrohet" "otroheter" ;
  otrolig_av_1 = mkA "otrolig" ;
  otryckbar_av_1 = mkA "otryckbar" ;
  otryckt_av_1 = mkA "otryckt" "otryckt" ;
  otrygg_av_1 = mkA "otrygg" ;
  otta_nn_1 = mkN "otta" ;
  ottoman_nn_1 = mkN "ottoman" "ottomaner" ;
  ottomansk_av_1 = mkA "ottomansk" ;
  ottomotor_nn_1 = mkN "ottomotor" "ottomotorer" ;
  otuktig_av_1 = mkA "otuktig" ;
  oturlig_av_1 = mkA "oturlig" ;
  otvetydig_av_1 = mkA "otvetydig" ;
  otvivelaktig_av_1 = mkA "otvivelaktig" ;
  otvungen_av_1 = mkA "otvungen" "otvunget" ;
  otydbar_av_1 = mkA "otydbar" ;
  otydlig_av_1 = mkA "otydlig" ;
  otymplig_av_1 = mkA "otymplig" ;
  otypisk_av_1 = mkA "otypisk" ;
  oumbaerlig_av_1 = mkA "oumbдrlig" ;
  oundgaenglig_av_1 = mkA "oundgдnglig" ;
  oundgaengligen_ab_1 = mkAdv "oundgдngligen" ;
  oundviklig_av_1 = mkA "oundviklig" ;
  oundvikligen_ab_1 = mkAdv "oundvikligen" ;
  ouppfattbar_av_1 = mkA "ouppfattbar" ;
  ouppfylld_av_1 = mkA "ouppfylld" "ouppfyllt" ;
  ouppgjord_av_1 = mkA "ouppgjord" "ouppgjort" ;
  oupphinnelig_av_1 = mkA "oupphinnelig" ;
  oupphoerlig_av_1 = mkA "oupphцrlig" ;
  oupphoerligen_ab_1 = mkAdv "oupphцrligen" ;
  oupploeslig_av_1 = mkA "oupplцslig" ;
  oupploesligen_ab_1 = mkAdv "oupplцsligen" ;
  oupplyst_av_1 = mkA "oupplyst" "oupplyst" ;
  ouppmaerksam_av_1 = mkA "ouppmдrksam" "ouppmдrksamt" "ouppmдrksamma" "ouppmдrksamma" "ouppmдrksammare" "ouppmдrksammast" "ouppmдrksammaste" ;
  ouppnaaelig_av_1 = mkA "ouppnеelig" ;
  ouppsaatlig_av_1 = mkA "ouppsеtlig" ;
  ouppsaegbar_av_1 = mkA "ouppsдgbar" ;
  ouppskattbar_av_1 = mkA "ouppskattbar" ;
  ouppskuren_av_1 = mkA "ouppskuren" "ouppskuret" ;
  oupptaeckt_av_1 = mkA "oupptдckt" "oupptдckt" ;
  ouppvaermd_av_1 = mkA "ouppvдrmd" "ouppvдrmt" ;
  oursaektlig_av_1 = mkA "oursдktlig" ;
  outfoerbar_av_1 = mkA "outfцrbar" ;
  outgiven_av_1 = mkA "outgiven" "outgivet" ;
  outgrundlig_av_1 = mkA "outgrundlig" ;
  outhaerdlig_av_1 = mkA "outhдrdlig" ;
  outhyrd_av_1 = mkA "outhyrd" "outhyrt" ;
  outplaanlig_av_1 = mkA "outplеnlig" ;
  outrannsaklig_av_1 = mkA "outrannsaklig" ;
  outrotlig_av_1 = mkA "outrotlig" ;
  outsaegbar_av_1 = mkA "outsдgbar" ;
  outsaeglig_av_1 = mkA "outsдglig" ;
  outsagd_av_1 = mkA "outsagd" "outsagt" ;
  outsider_nn_1 = mkN "outsider" "outsidern" "outsider" "outsiderna" ;
  outsinlig_av_1 = mkA "outsinlig" ;
  outslaecklig_av_1 = mkA "outslдcklig" ;
  outslitlig_av_1 = mkA "outslitlig" ;
  outspaedd_av_1 = mkA "outspдdd" ;
  outstanding_av_1 = mkA "outstanding" ;
  outtalbar_av_1 = mkA "outtalbar" ;
  outtoemlig_av_1 = mkA "outtцmlig" ;
  outtroettlig_av_1 = mkA "outtrцttlig" ;
  outvaext_av_1 = mkA "outvдxt" "outvдxt" ;
  outvuxen_av_1 = mkA "outvuxen" "outvuxet" ;
  ouvertyr_nn_1 = mkN "ouvertyr" "ouvertyrer" ;
  ovaalig_av_1 = mkA "ovеlig" ;
  ovaeder_nn_1 = mkN "ovдder" neutrum ;
  ovaeldig_av_1 = mkA "ovдldig" ;
  ovaelkommen_av_1 = mkA "ovдlkommen" "ovдlkommet" "ovдlkomna" "ovдlkomna" "ovдlkomnare" "ovдlkomnast" "ovдlkomnaste" ;
  ovaen_nn_1 = mkN "ovдn" "ovдnnen" "ovдnner" "ovдnnerna" ;
  ovaenlig_av_1 = mkA "ovдnlig" ;
  ovaenlighet_nn_1 = mkN "ovдnlighet" "ovдnligheter" ;
  ovaenskap_nn_1 = mkN "ovдnskap" "ovдnskaper" ;
  ovaerderlig_av_1 = mkA "ovдrderlig" ;
  ovaerdig_av_1 = mkA "ovдrdig" ;
  ovaerldslig_av_1 = mkA "ovдrldslig" ;
  ovaesentlig_av_1 = mkA "ovдsentlig" ;
  ovaesentlighet_nn_1 = mkN "ovдsentlighet" "ovдsentligheter" ;
  oval_av_1 = mkA "oval" ;
  oval_nn_1 = mkN "oval" "ovaler" ;
  ovan_ab_1 = mkAdv "ovan" ;
  ovan_av_1 = mkA "ovan" ;
  ovana_nn_1 = mkN "ovana" ;
  ovanbords_ab_1 = mkAdv "ovanbords" ;
  ovandel_nn_1 = mkN "ovandel" "ovandelen" "ovandelar" "ovandelarna" ;
  ovanfoer_ab_1 = mkAdv "ovanfцr" ;
  ovanifraan_ab_1 = mkAdv "ovanifrеn" ;
  ovanjordisk_av_1 = mkA "ovanjordisk" ;
  ovanlig_av_1 = mkA "ovanlig" ;
  ovanlighet_nn_1 = mkN "ovanlighet" "ovanligheter" ;
  ovannaemnd_av_1 = mkA "ovannдmnd" ;
  ovanpaa_ab_1 = mkAdv "ovanpе" ;
  ovansida_nn_1 = mkN "ovansida" ;
  ovansklig_av_1 = mkA "ovansklig" ;
  ovanstaaende_av_1 = mkA "ovanstеende" ;
  ovantill_ab_1 = mkAdv "ovantill" ;
  ovanvaaning_nn_1 = mkN "ovanvеning" ;
  ovariotomi_nn_1 = mkN "ovariotomi" "ovariotomier" ;
  ovarium_nn_1 = mkN "ovarium" "ovariet" "ovarier" "ovarierna" ;
  ovarsam_av_1 = mkA "ovarsam" "ovarsamt" "ovarsamma" "ovarsamma" "ovarsammare" "ovarsammast" "ovarsammaste" ;
  ovation_nn_1 = mkN "ovation" "ovationer" ;
  ovederhaeftig_av_1 = mkA "ovederhдftig" ;
  ovederlaegglig_av_1 = mkA "ovederlдgglig" ;
  ovedersaeglig_av_1 = mkA "ovedersдglig" ;
  ovedersaegligen_ab_1 = mkAdv "ovedersдgligen" ;
  overall_nn_1 = mkN "overall" "overaller" ;
  overhead_projektor_nn_1 = mkN "overhead-projektor" "overhead-projektorer" ;
  overheadbild_nn_1 = mkN "overheadbild" "overheadbilder" ;
  overheadprojektor_nn_1 = mkN "overheadprojektor" "overheadprojektorer" ;
  overklig_av_1 = mkA "overklig" ;
  overksam_av_1 = mkA "overksam" "overksamt" "overksamma" "overksamma" "overksammare" "overksammast" "overksammaste" ;
  overksamhet_nn_1 = mkN "overksamhet" "overksamheter" ;
  ovetande_av_1 = mkA "ovetande" ;
  ovetandes_av_1 = mkA "ovetandes" ;
  ovetbar_av_1 = mkA "ovetbar" ;
  oveten_av_1 = mkA "oveten" "ovetet" ;
  ovetenhet_nn_1 = mkN "ovetenhet" "ovetenheter" ;
  ovetenskaplig_av_1 = mkA "ovetenskaplig" ;
  ovettig_av_1 = mkA "ovettig" ;
  ovettighet_nn_1 = mkN "ovettighet" "ovettigheter" ;
  ovidkommande_av_1 = mkA "ovidkommande" ;
  ovig_av_1 = mkA "ovig" ;
  ovigd_av_1 = mkA "ovigd" "ovigt" ;
  oviktig_av_1 = mkA "oviktig" ;
  ovillig_av_1 = mkA "ovillig" ;
  ovillkorlig_av_1 = mkA "ovillkorlig" ;
  ovillkorligen_ab_1 = mkAdv "ovillkorligen" ;
  ovipar_av_1 = mkA "ovipar" ;
  ovis_av_1 = mkA "ovis" ;
  oviss_av_1 = mkA "oviss" ;
  ovisshet_nn_1 = mkN "ovisshet" "ovissheter" ;
  ovulation_nn_1 = mkN "ovulation" "ovulationer" ;
  oxalatsten_nn_1 = mkN "oxalatsten" "oxalatstenen" "oxalatstenar" "oxalatstenarna" ;
  oxbaer_nn_1 = mkN "oxbдr" neutrum ;
  oxblodsroed_av_1 = mkA "oxblodsrцd" ;
  oxdjur_nn_1 = mkN "oxdjur" neutrum ;
  oxe_nn_1 = mkN "oxe" utrum ;
  oxel_nn_1 = mkN "oxel" ;
  oxeltand_nn_1 = mkN "oxeltand" "oxeltдnder" ;
  oxfile_nn_1 = mkN "oxfilй" "oxfilйer" ;
  oxid_nn_1 = mkN "oxid" "oxider" ;
  oxidation_nn_1 = mkN "oxidation" "oxidationer" ;
  oxidationsmedel_nn_1 = mkN "oxidationsmedel" neutrum ;
  oxidationsreaktion_nn_1 = mkN "oxidationsreaktion" "oxidationsreaktioner" ;
  oxidationstal_nn_1 = mkN "oxidationstal" "oxidationstalet" "oxidationstalen" "oxidationstalena" ;
  oxjaerpe_nn_1 = mkN "oxjдrpe" utrum ;
  oxlaegg_nn_1 = mkN "oxlдgg" ;
  oxoega_nn_1 = mkN "oxцga" "oxцgat" "oxцgon" "oxцgonen" ;
  oxroulad_nn_1 = mkN "oxroulad" "oxroulader" ;
  oxstek_nn_1 = mkN "oxstek" ;
  oxstyng_nn_1 = mkN "oxstyng" neutrum ;
  oxtunga_nn_1 = mkN "oxtunga" ;
  oxtungsvamp_nn_1 = mkN "oxtungsvamp" ;
  oxvandring_nn_1 = mkN "oxvandring" ;
  oxvecka_nn_1 = mkN "oxvecka" ;
  oxytocin_nn_1 = mkN "oxytocin" "oxytociner" ;
  ozelot_nn_1 = mkN "ozelot" "ozeloter" ;
  ozonhalt_nn_1 = mkN "ozonhalt" "ozonhalter" ;
  ozonmaengd_nn_1 = mkN "ozonmдngd" "ozonmдngder" ;
  ozonminskning_nn_1 = mkN "ozonminskning" ;
  ozonmolekyl_nn_1 = mkN "ozonmolekyl" "ozonmolekyler" ;
  ozonreduktion_nn_1 = mkN "ozonreduktion" "ozonreduktioner" ;
  ozonskikt_nn_1 = mkN "ozonskikt" neutrum ;
  pH_vaerde_nn_1 = mkN "pH-vдrde" ;
  p_ab_1 = mkAdv "p" ;
  p_piller_nn_1 = mkN "p-piller" neutrum ;
  p_plats_nn_1 = mkN "p-plats" "p-platser" ;
  paa_ab_1 = mkAdv "pе" ;
  paaannons_nn_1 = mkN "pеannons" "pеannonser" ;
  paabackning_nn_1 = mkN "pеbackning" ;
  paabjuda_vb_1 = mkV "pеbjuda" "pеbjцd" "pеbjudit" ;
  paabud_nn_1 = mkN "pеbud" neutrum ;
  paabyggnad_nn_1 = mkN "pеbyggnad" "pеbyggnader" ;
  paadrag_nn_1 = mkN "pеdrag" neutrum ;
  paadrivare_nn_1 = mkN "pеdrivare" "pеdrivare" ;
  paafaagel_nn_1 = mkN "pеfеgel" ;
  paafaagelsoega_nn_1 = mkN "pеfеgelsцga" "pеfеgelsцgat" "pеfеgelsцgon" "pеfеgelsцgonen" ;
  paafallande_av_1 = mkA "pеfallande" ;
  paafart_nn_1 = mkN "pеfart" "pеfarter" ;
  paaflugen_av_1 = mkA "pеflugen" "pеfluget" ;
  paafoeljande_av_1 = mkA "pеfцljande" ;
  paafoeljd_nn_1 = mkN "pеfцljd" "pеfцljder" ;
  paafrestande_av_1 = mkA "pеfrestande" ;
  paafrestning_nn_1 = mkN "pеfrestning" ;
  paafund_nn_1 = mkN "pеfund" neutrum ;
  paafyllnadsfoerpackning_nn_1 = mkN "pеfyllnadsfцrpackning" ;
  paafyllning_nn_1 = mkN "pеfyllning" ;
  paag_nn_1 = mkN "pеg" ;
  paagaaende_av_1 = mkA "pеgеende" ;
  paahaelsning_nn_1 = mkN "pеhдlsning" ;
  paahaengsvagn_nn_1 = mkN "pеhдngsvagn" ;
  paahitt_nn_1 = mkN "pеhitt" neutrum ;
  paahittig_av_1 = mkA "pеhittig" ;
  paahopp_nn_1 = mkN "pеhopp" neutrum ;
  paahugg_nn_1 = mkN "pеhugg" neutrum ;
  paak_nn_1 = mkN "pеk" ;
  paakaenning_nn_1 = mkN "pеkдnning" ;
  paaklaedare_nn_1 = mkN "pеklдdare" "pеklдdare" ;
  paaklaedd_av_1 = mkA "pеklдdd" "pеklдdtt" ;
  paakommen_av_1 = mkA "pеkommen" "pеkommet" "pеkomna" "pеkomna" "pеkomnare" "pеkomnast" "pеkomnaste" ;
  paakostande_av_1 = mkA "pеkostande" ;
  paalaegg_nn_1 = mkN "pеlдgg" neutrum ;
  paalaeggskalv_nn_1 = mkN "pеlдggskalv" ;
  paalandsvind_nn_1 = mkN "pеlandsvind" ;
  paale_nn_1 = mkN "pеle" utrum ;
  paalitlig_av_1 = mkA "pеlitlig" ;
  paalkran_nn_1 = mkN "pеlkran" ;
  paalle_nn_1 = mkN "pеlle" utrum ;
  paalmast_nn_1 = mkN "pеlmast" "pеlmaster" ;
  paalrot_nn_1 = mkN "pеlrot" "pеlrцtter" ;
  paalstek_nn_1 = mkN "pеlstek" neutrum ;
  paaminnelse_nn_1 = mkN "pеminnelse" "pеminnelser" ;
  paaoekt_av_1 = mkA "pецkt" "pецkt" ;
  paapasslig_av_1 = mkA "pеpasslig" ;
  paapekande_nn_1 = mkN "pеpekande" ;
  paaringning_nn_1 = mkN "pеringning" ;
  paarop_nn_1 = mkN "pеrop" neutrum ;
  paase_nn_1 = mkN "pеse" utrum ;
  paasig_av_1 = mkA "pеsig" ;
  paask_nn_1 = mkN "pеsk" ;
  paaskaegg_nn_1 = mkN "pеskдgg" neutrum ;
  paaskafton_nn_1 = mkN "pеskafton" "pеskaftonen" "pеskaftnar" "pеskaftnarna" ;
  paaskalamm_nn_1 = mkN "pеskalamm" neutrum ;
  paaskdag_nn_1 = mkN "pеskdag" ;
  paaskeld_nn_1 = mkN "pеskeld" ;
  paaskhare_nn_1 = mkN "pеskhare" utrum ;
  paaskkaerring_nn_1 = mkN "pеskkдrring" ;
  paasklilja_nn_1 = mkN "pеsklilja" ;
  paaskrift_nn_1 = mkN "pеskrift" "pеskrifter" ;
  paaskrivet_ab_1 = mkAdv "pеskrivet" ;
  paaskrivet_av_1 = mkA "pеskrivet" ;
  paasksmaell_nn_1 = mkN "pеsksmдll" ;
  paaskvecka_nn_1 = mkN "pеskvecka" ;
  paaslag_nn_1 = mkN "pеslag" neutrum ;
  paaslakan_nn_1 = mkN "pеslakan" neutrum ;
  paastaaelig_av_1 = mkA "pеstеelig" ;
  paastaaende_nn_1 = mkN "pеstеende" ;
  paastaaendesats_nn_1 = mkN "pеstеendesats" "pеstеendesatser" ;
  paastoetning_nn_1 = mkN "pеstцtning" ;
  paastridig_av_1 = mkA "pеstridig" ;
  paastruken_av_1 = mkA "pеstruken" "pеstruket" ;
  paata_vb_1 = mkV "pеta" "pеtar" "pеta" "pеtog" "pеtagit" "pеtagen" ;
  paataar_nn_1 = mkN "pеtеr" ;
  paataend_av_1 = mkA "pеtдnd" ;
  paataenkt_av_1 = mkA "pеtдnkt" "pеtдnkt" ;
  paatagbar_av_1 = mkA "pеtagbar" ;
  paataglig_av_1 = mkA "pеtaglig" ;
  paatagning_nn_1 = mkN "pеtagning" ;
  paatraengande_av_1 = mkA "pеtrдngande" ;
  paatryckare_nn_1 = mkN "pеtryckare" "pеtryckare" ;
  paatryckning_nn_1 = mkN "pеtryckning" ;
  paatvinga_vb_1 = mkV "pеtvinga" ;
  paave_nn_1 = mkN "pеve" utrum ;
  paaver_av_1 = mkA "pеver" "pеvert" "pеvra" "pеvra" "pеvrare" "pеvrast" "pеvraste" ;
  paaverkbar_av_1 = mkA "pеverkbar" ;
  paaverkning_nn_1 = mkN "pеverkning" ;
  paavevaerdighet_nn_1 = mkN "pеvevдrdighet" "pеvevдrdigheter" ;
  paavisbar_av_1 = mkA "pеvisbar" ;
  paavisk_av_1 = mkA "pеvisk" ;
  paavlig_av_1 = mkA "pеvlig" ;
  pacemaker_nn_1 = mkN "pacemaker" ;
  pacifist_nn_1 = mkN "pacifist" "pacifister" ;
  pacifistisk_av_1 = mkA "pacifistisk" ;
  packaasna_nn_1 = mkN "packеsna" ;
  packbox_nn_1 = mkN "packbox" ;
  packdjur_nn_1 = mkN "packdjur" neutrum ;
  packe_nn_1 = mkN "packe" utrum ;
  packhus_nn_1 = mkN "packhus" neutrum ;
  packlaar_nn_1 = mkN "packlеr" ;
  packning_nn_1 = mkN "packning" ;
  packsadel_nn_1 = mkN "packsadel" ;
  paddel_nn_1 = mkN "paddel" ;
  paddfot_nn_1 = mkN "paddfot" "paddfцtter" ;
  paddock_nn_1 = mkN "paddock" ;
  paell_nn_1 = mkN "pдll" ;
  paels_nn_1 = mkN "pдls" ;
  paelsaenger_nn_1 = mkN "pдlsдnger" ;
  paelsdjur_nn_1 = mkN "pдlsdjur" neutrum ;
  paelsfarm_nn_1 = mkN "pдlsfarm" ;
  paelsfladdrare_nn_1 = mkN "pдlsfladdrare" "pдlsfladdrare" ;
  paelsjaegare_nn_1 = mkN "pдlsjдgare" "pдlsjдgare" ;
  paelssael_nn_1 = mkN "pдlssдl" ;
  paelsskinn_nn_1 = mkN "pдlsskinn" neutrum ;
  paer_nn_1 = mkN "pдr" "pдrer" ;
  paerlbaat_nn_1 = mkN "pдrlbеt" ;
  paerlband_nn_1 = mkN "pдrlband" neutrum ;
  paerlemorfjaeril_nn_1 = mkN "pдrlemorfjдril" ;
  paerlemormoln_nn_1 = mkN "pдrlemormoln" neutrum ;
  paerlemorskimrande_av_1 = mkA "pдrlemorskimrande" ;
  paerlgraa_av_1 = mkA "pдrlgrе" "pдrlgrеtt" ;
  paerlgryn_nn_1 = mkN "pдrlgryn" neutrum ;
  paerlhyacint_nn_1 = mkN "pдrlhyacint" "pдrlhyacinter" ;
  paerlmussla_nn_1 = mkN "pдrlmussla" ;
  paerlspont_nn_1 = mkN "pдrlspont" ;
  paerlstav_nn_1 = mkN "pдrlstav" ;
  paerlstickning_nn_1 = mkN "pдrlstickning" ;
  paerm_nn_1 = mkN "pдrm" ;
  paermbrev_nn_1 = mkN "pдrmbrev" neutrum ;
  paermkarusell_nn_1 = mkN "pдrmkarusell" "pдrmkaruseller" ;
  paermslukare_nn_1 = mkN "pдrmslukare" "pдrmslukare" ;
  paeron_nn_1 = mkN "pдron" neutrum ;
  paers_nn_1 = mkN "pдrs" ;
  paert_nn_1 = mkN "pдrt" "pдrter" ;
  paesk_nn_1 = mkN "pдsk" ;
  paff_av_1 = mkA "paff" ;
  page_nn_1 = mkN "page" "pager" ;
  pagefrisyr_nn_1 = mkN "pagefrisyr" "pagefrisyrer" ;
  paginering_nn_1 = mkN "paginering" ;
  pagod_nn_1 = mkN "pagod" "pagoder" ;
  paj_av_1 = mkA "paj" ;
  paj_nn_1 = mkN "paj" "pajer" ;
  pajas_nn_1 = mkN "pajas" ;
  pajdeg_nn_1 = mkN "pajdeg" ;
  pajkastning_nn_1 = mkN "pajkastning" ;
  pajsare_nn_1 = mkN "pajsare" "pajsare" ;
  paket_nn_1 = mkN "paket" neutrum ;
  paketauktion_nn_1 = mkN "paketauktion" "paketauktioner" ;
  paketering_nn_1 = mkN "paketering" ;
  paketeringsdisk_nn_1 = mkN "paketeringsdisk" ;
  paketexpedition_nn_1 = mkN "paketexpedition" "paketexpeditioner" ;
  pakethaallare_nn_1 = mkN "pakethеllare" "pakethеllare" ;
  paketinlaemning_nn_1 = mkN "paketinlдmning" ;
  paketloesning_nn_1 = mkN "paketlцsning" ;
  paketutlaemning_nn_1 = mkN "paketutlдmning" ;
  pakistan_nn_1 = mkN "pakistan" "pakistaner" ;
  pakistanare_nn_1 = mkN "pakistanare" "pakistanare" ;
  pakistansk_av_1 = mkA "pakistansk" ;
  pakistanska_nn_1 = mkN "pakistanska" ;
  pakt_nn_1 = mkN "pakt" "pakter" ;
  paktum_nn_1 = mkN "paktum" neutrum ;
  paladin_nn_1 = mkN "paladin" "paladiner" ;
  palae_nn_1 = mkN "palд" "palдt" "palдer" "palдerna" ;
  palatal_av_1 = mkA "palatal" ;
  palatal_nn_1 = mkN "palatal" "palataler" ;
  palats_nn_1 = mkN "palats" neutrum ;
  palatsrevolution_nn_1 = mkN "palatsrevolution" "palatsrevolutioner" ;
  palaver_nn_1 = mkN "palaver" "palavern" "palavrer" "palavrerna" ;
  paleoekologisk_av_1 = mkA "paleoekologisk" ;
  paleograf_nn_1 = mkN "paleograf" "paleografer" ;
  paleolitisk_av_1 = mkA "paleolitisk" ;
  paleontolog_nn_1 = mkN "paleontolog" "paleontologer" ;
  paleontologisk_av_1 = mkA "paleontologisk" ;
  palestinier_nn_1 = mkN "palestinier" "palestiniern" "palestinier" "palestinierna" ;
  palestinsk_av_1 = mkA "palestinsk" ;
  paletaa_nn_1 = mkN "paletе" "paletеer" ;
  palett_nn_1 = mkN "palett" "paletter" ;
  palettkniv_nn_1 = mkN "palettkniv" ;
  palimpsest_nn_1 = mkN "palimpsest" "palimpsester" ;
  palindrom_nn_1 = mkN "palindrom" "palindromer" ;
  palissad_nn_1 = mkN "palissad" "palissader" ;
  paljett_nn_1 = mkN "paljett" "paljetter" ;
  pall_ab_1 = mkAdv "pall" ;
  pall_nn_1 = mkN "pall" ;
  pall_nn_2 = mkN "pall" neutrum ;
  pallasch_nn_1 = mkN "pallasch" "pallascher" ;
  palliativ_av_1 = mkA "palliativ" ;
  palliativ_nn_1 = mkN "palliativ" neutrum ;
  palm_nn_1 = mkN "palm" "palmer" ;
  palmblad_nn_1 = mkN "palmblad" neutrum ;
  palmett_nn_1 = mkN "palmett" "palmetter" ;
  palmhus_nn_1 = mkN "palmhus" neutrum ;
  palmsoendag_nn_1 = mkN "palmsцndag" ;
  palmvin_nn_1 = mkN "palmvin" "palmvinet" "palmviner" "palmvinerna" ;
  palp_nn_1 = mkN "palp" "palper" ;
  palpation_nn_1 = mkN "palpation" "palpationer" ;
  pals_nn_1 = mkN "pals" ;
  palt_nn_1 = mkN "palt" ;
  paltbroed_nn_1 = mkN "paltbrцd" neutrum ;
  paltig_av_1 = mkA "paltig" ;
  pamflett_nn_1 = mkN "pamflett" "pamfletter" ;
  pamflettist_nn_1 = mkN "pamflettist" "pamflettister" ;
  pamp_nn_1 = mkN "pamp" ;
  pampig_av_1 = mkA "pampig" ;
  pampusch_nn_1 = mkN "pampusch" "pampuscher" ;
  panafrikansk_av_1 = mkA "panafrikansk" ;
  panamahatt_nn_1 = mkN "panamahatt" ;
  panaman_nn_1 = mkN "panaman" "panamaner" ;
  panamansk_av_1 = mkA "panamansk" ;
  panamerikansk_av_1 = mkA "panamerikansk" ;
  panarabisk_av_1 = mkA "panarabisk" ;
  panasch_nn_1 = mkN "panasch" "panascher" ;
  panaschering_nn_1 = mkN "panaschering" ;
  pandemi_nn_1 = mkN "pandemi" "pandemier" ;
  panegyrik_nn_1 = mkN "panegyrik" "panegyriker" ;
  panegyrisk_av_1 = mkA "panegyrisk" ;
  panel_nn_1 = mkN "panel" "paneler" ;
  paneldebatt_nn_1 = mkN "paneldebatt" "paneldebatter" ;
  paneldiskussion_nn_1 = mkN "paneldiskussion" "paneldiskussioner" ;
  panering_nn_1 = mkN "panering" ;
  panett_nn_1 = mkN "panett" "panetter" ;
  panfloejt_nn_1 = mkN "panflцjt" "panflцjter" ;
  pang_nn_1 = mkN "pang" neutrum ;
  pang_pangfilm_nn_1 = mkN "pang-pangfilm" "pang-pangfilmer" ;
  panikslagen_av_1 = mkA "panikslagen" "panikslaget" ;
  panikunge_nn_1 = mkN "panikunge" utrum ;
  panisk_av_1 = mkA "panisk" ;
  pank_av_1 = mkA "pank" ;
  pankreaskoertel_nn_1 = mkN "pankreaskцrtel" ;
  pankreatit_nn_1 = mkN "pankreatit" "pankreatiter" ;
  pankromatisk_av_1 = mkA "pankromatisk" ;
  pannaa_nn_1 = mkN "pannе" "pannеer" ;
  pannband_nn_1 = mkN "pannband" neutrum ;
  pannben_nn_1 = mkN "pannben" neutrum ;
  pannbiff_nn_1 = mkN "pannbiff" ;
  pannkaksmoln_nn_1 = mkN "pannkaksmoln" neutrum ;
  pannkakssmet_nn_1 = mkN "pannkakssmet" "pannkakssmeter" ;
  pannkaksteoretiker_nn_1 = mkN "pannkaksteoretiker" "pannkaksteoretikern" "pannkaksteoretiker" "pannkaksteoretikerna" ;
  pannkaksteori_nn_1 = mkN "pannkaksteori" "pannkaksteorier" ;
  pannlob_nn_1 = mkN "pannlob" "pannlober" ;
  pannrum_nn_1 = mkN "pannrum" "pannrummet" "pannrum" "pannrummen" ;
  pannspegel_nn_1 = mkN "pannspegel" ;
  panoptikon_nn_1 = mkN "panoptikon" neutrum ;
  panorama_nn_1 = mkN "panorama" "panoramat" "panoraman" "panoramana" ;
  panoramafoenster_nn_1 = mkN "panoramafцnster" neutrum ;
  panoramakamera_nn_1 = mkN "panoramakamera" ;
  panorering_nn_1 = mkN "panorering" ;
  pansar_nn_1 = mkN "pansar" neutrum ;
  pansarbil_nn_1 = mkN "pansarbil" ;
  pansarbrytande_av_1 = mkA "pansarbrytande" ;
  pansarfordon_nn_1 = mkN "pansarfordon" neutrum ;
  pansargeneral_nn_1 = mkN "pansargeneral" "pansargeneraler" ;
  pansargranat_nn_1 = mkN "pansargranat" "pansargranater" ;
  pansarhinder_nn_1 = mkN "pansarhinder" neutrum ;
  pansarmal_nn_1 = mkN "pansarmal" ;
  pansarroer_nn_1 = mkN "pansarrцr" neutrum ;
  pansarskott_nn_1 = mkN "pansarskott" neutrum ;
  pansartrupp_nn_1 = mkN "pansartrupp" "pansartrupper" ;
  pansarvaern_nn_1 = mkN "pansarvдrn" neutrum ;
  pansarvaernsvapen_nn_1 = mkN "pansarvдrnsvapen" "pansarvдrnsvapnet" "pansarvдrnsvapen" "pansarvдrnsvapnen" ;
  pansarvagn_nn_1 = mkN "pansarvagn" ;
  pant_nn_1 = mkN "pant" "panter" ;
  pantbank_nn_1 = mkN "pantbank" "pantbanker" ;
  pantbrev_nn_1 = mkN "pantbrev" neutrum ;
  panteist_nn_1 = mkN "panteist" "panteister" ;
  panteistisk_av_1 = mkA "panteistisk" ;
  panteon_nn_1 = mkN "panteon" neutrum ;
  panter_nn_1 = mkN "panter" ;
  panterkatt_nn_1 = mkN "panterkatt" "panterkatter" ;
  panterspraang_nn_1 = mkN "pantersprеng" neutrum ;
  pantfoerskriva_vb_1 = mkV "pantfцrskriva" "pantfцrskrev" "pantfцrskrivit" ;
  panthavare_nn_1 = mkN "panthavare" "panthavare" ;
  pantlaan_nn_1 = mkN "pantlеn" neutrum ;
  pantlaanare_nn_1 = mkN "pantlеnare" "pantlеnare" ;
  pantlaaneroerelse_nn_1 = mkN "pantlеnerцrelse" "pantlеnerцrelser" ;
  pantograf_nn_1 = mkN "pantograf" "pantografer" ;
  pantomim_nn_1 = mkN "pantomim" "pantomimer" ;
  pantomimisk_av_1 = mkA "pantomimisk" ;
  pantraett_nn_1 = mkN "pantrдtt" "pantrдtter" ;
  pantsaettare_nn_1 = mkN "pantsдttare" "pantsдttare" ;
  papaverin_nn_1 = mkN "papaverin" neutrum ;
  papegojfisk_nn_1 = mkN "papegojfisk" ;
  papegojliknande_av_1 = mkA "papegojliknande" ;
  papegojtulpan_nn_1 = mkN "papegojtulpan" "papegojtulpaner" ;
  paper_nn_1 = mkN "paper" "paperet" "papers" "paperen" ;
  papeteri_nn_1 = mkN "papeteri" "papeterit" "papeterier" "papeterierna" ;
  papiljott_nn_1 = mkN "papiljott" "papiljotter" ;
  papill_nn_1 = mkN "papill" "papiller" ;
  papillom_nn_1 = mkN "papillom" neutrum ;
  papillon_nn_1 = mkN "papillon" "papilloner" ;
  pappa_nn_1 = mkN "pappa" ;
  pappaledig_av_1 = mkA "pappaledig" ;
  pappband_nn_1 = mkN "pappband" neutrum ;
  pappenheimare_nn_1 = mkN "pappenheimare" "pappenheimare" ;
  papper_nn_1 = mkN "papper" neutrum ;
  pappersark_nn_1 = mkN "pappersark" neutrum ;
  pappersbit_nn_1 = mkN "pappersbit" ;
  pappersbruk_nn_1 = mkN "pappersbruk" neutrum ;
  pappersformat_nn_1 = mkN "pappersformat" neutrum ;
  pappershandduk_nn_1 = mkN "pappershandduk" ;
  pappershandel_nn_1 = mkN "pappershandel" ;
  pappersinsamling_nn_1 = mkN "pappersinsamling" ;
  papperskasse_nn_1 = mkN "papperskasse" utrum ;
  papperskniv_nn_1 = mkN "papperskniv" ;
  papperskorg_nn_1 = mkN "papperskorg" ;
  papperskvarn_nn_1 = mkN "papperskvarn" ;
  papperslapp_nn_1 = mkN "papperslapp" ;
  pappersmaskin_nn_1 = mkN "pappersmaskin" "pappersmaskiner" ;
  pappersnaesduk_nn_1 = mkN "pappersnдsduk" ;
  papperspelle_nn_1 = mkN "papperspelle" utrum ;
  papperspeng_nn_1 = mkN "papperspeng" ;
  papperssax_nn_1 = mkN "papperssax" ;
  pappersservett_nn_1 = mkN "pappersservett" "pappersservetter" ;
  papperstallrik_nn_1 = mkN "papperstallrik" ;
  papperstiger_nn_1 = mkN "papperstiger" ;
  papperstillverkning_nn_1 = mkN "papperstillverkning" ;
  papperstuss_nn_1 = mkN "papperstuss" ;
  pappig_av_1 = mkA "pappig" ;
  pappskalle_nn_1 = mkN "pappskalle" utrum ;
  pappspik_nn_1 = mkN "pappspik" ;
  paprika_nn_1 = mkN "paprika" ;
  papua_nn_1 = mkN "papua" "papuan" "papuas" "papuasen" ;
  papuan_nn_1 = mkN "papuan" "papuaner" ;
  papuansk_av_1 = mkA "papuansk" ;
  papyross_nn_1 = mkN "papyross" "papyrosser" ;
  papyrus_nn_1 = mkN "papyrus" "papyrer" ;
  papyrusrulle_nn_1 = mkN "papyrusrulle" utrum ;
  par_nn_1 = mkN "par" neutrum ;
  parabel_nn_1 = mkN "parabel" "parabeln" "parabler" "parablerna" ;
  parabellum_nn_1 = mkN "parabellum" ;
  parabolantenn_nn_1 = mkN "parabolantenn" "parabolantenner" ;
  parabolisk_av_1 = mkA "parabolisk" ;
  paracervikalblockad_nn_1 = mkN "paracervikalblockad" "paracervikalblockader" ;
  parad_nn_1 = mkN "parad" "parader" ;
  paradentit_nn_1 = mkN "paradentit" "paradentiter" ;
  paradexempel_nn_1 = mkN "paradexempel" neutrum ;
  paradigm_nn_1 = mkN "paradigm" neutrum ;
  paradis_nn_1 = mkN "paradis" neutrum ;
  paradisfaagel_nn_1 = mkN "paradisfеgel" ;
  paradisfroe_nn_1 = mkN "paradisfrц" "paradisfrцt" "paradisfrцn" "paradisfrцen" ;
  paradisisk_av_1 = mkA "paradisisk" ;
  paradiskorn_nn_1 = mkN "paradiskorn" neutrum ;
  paradmaalning_nn_1 = mkN "paradmеlning" ;
  paradmarsch_nn_1 = mkN "paradmarsch" "paradmarscher" ;
  paradnummer_nn_1 = mkN "paradnummer" neutrum ;
  paradox_nn_1 = mkN "paradox" "paradoxer" ;
  paradoxal_av_1 = mkA "paradoxal" ;
  paradoxmakare_nn_1 = mkN "paradoxmakare" "paradoxmakare" ;
  paraduniform_nn_1 = mkN "paraduniform" "paraduniformer" ;
  paraduppstaellning_nn_1 = mkN "paraduppstдllning" ;
  parafasi_nn_1 = mkN "parafasi" "parafasier" ;
  parafras_nn_1 = mkN "parafras" "parafraser" ;
  parafrastisk_av_1 = mkA "parafrastisk" ;
  paragon_nn_1 = mkN "paragon" "paragoner" ;
  paragraf_nn_1 = mkN "paragraf" "paragrafer" ;
  paragrafryttare_nn_1 = mkN "paragrafryttare" "paragrafryttare" ;
  paragraftecken_nn_1 = mkN "paragraftecken" "paragraftecknet" "paragraftecken" "paragraftecknen" ;
  paraguayan_nn_1 = mkN "paraguayan" "paraguayaner" ;
  paraguayansk_av_1 = mkA "paraguayansk" ;
  paraguayare_nn_1 = mkN "paraguayare" "paraguayare" ;
  paraguaysk_av_1 = mkA "paraguaysk" ;
  parallell_av_1 = mkA "parallell" ;
  parallell_nn_1 = mkN "parallell" "paralleller" ;
  parallellcirkel_nn_1 = mkN "parallellcirkel" ;
  parallelldam_nn_1 = mkN "parallelldam" "parallelldamer" ;
  parallellepiped_nn_1 = mkN "parallellepiped" "parallellepipeder" ;
  parallellfall_nn_1 = mkN "parallellfall" neutrum ;
  parallellgrad_nn_1 = mkN "parallellgrad" "parallellgrader" ;
  parallellism_nn_1 = mkN "parallellism" "parallellismer" ;
  parallellitet_nn_1 = mkN "parallellitet" "parallelliteter" ;
  parallellklass_nn_1 = mkN "parallellklass" "parallellklasser" ;
  parallellkoppling_nn_1 = mkN "parallellkoppling" ;
  parallellogram_nn_1 = mkN "parallellogram" "parallellogrammen" "parallellogrammer" "parallellogrammerna" ;
  parallellstag_nn_1 = mkN "parallellstag" neutrum ;
  parallelltrapets_nn_1 = mkN "parallelltrapets" "parallelltrapetset" "parallelltrapetser" "parallelltrapetserna" ;
  paralys_nn_1 = mkN "paralys" "paralyser" ;
  paralytiker_nn_1 = mkN "paralytiker" "paralytikern" "paralytiker" "paralytikerna" ;
  paralytisk_av_1 = mkA "paralytisk" ;
  parameter_nn_1 = mkN "parameter" ;
  paramilitaer_av_1 = mkA "paramilitдr" ;
  paranoet_nn_1 = mkN "paranцt" "paranцtter" ;
  paranoiker_nn_1 = mkN "paranoiker" "paranoikern" "paranoiker" "paranoikerna" ;
  parant_av_1 = mkA "parant" "parant" ;
  parapet_nn_1 = mkN "parapet" "parapeter" ;
  paraply_nn_1 = mkN "paraply" "paraplyer" ;
  paraplyliknande_av_1 = mkA "paraplyliknande" ;
  paraplyorganisation_nn_1 = mkN "paraplyorganisation" "paraplyorganisationer" ;
  paraplytak_nn_1 = mkN "paraplytak" neutrum ;
  parasit_nn_1 = mkN "parasit" "parasiter" ;
  parasitaer_av_1 = mkA "parasitдr" ;
  parasitisk_av_1 = mkA "parasitisk" ;
  parasoll_nn_1 = mkN "parasoll" neutrum ;
  parat_av_1 = mkA "parat" "parat" ;
  parataktisk_av_1 = mkA "parataktisk" ;
  paravan_nn_1 = mkN "paravan" "paravaner" ;
  parbladig_av_1 = mkA "parbladig" ;
  parce_nn_1 = mkN "parce" "parcer" ;
  parcell_nn_1 = mkN "parcell" "parceller" ;
  pardans_nn_1 = mkN "pardans" "pardanser" ;
  parentation_nn_1 = mkN "parentation" "parentationer" ;
  parentator_nn_1 = mkN "parentator" "parentatorer" ;
  parentes_nn_1 = mkN "parentes" "parenteser" ;
  parentestecken_nn_1 = mkN "parentestecken" "parentestecknet" "parentestecken" "parentestecknen" ;
  parentetisk_av_1 = mkA "parentetisk" ;
  parerplaat_nn_1 = mkN "parerplеt" ;
  parerstaang_nn_1 = mkN "parerstеng" "parerstдnger" ;
  pares_nn_1 = mkN "pares" "pareser" ;
  parfait_nn_1 = mkN "parfait" "parfaiter" ;
  parflikig_av_1 = mkA "parflikig" ;
  parfym_nn_1 = mkN "parfym" "parfymer" ;
  parfymaffaer_nn_1 = mkN "parfymaffдr" "parfymaffдrer" ;
  parfymeri_nn_1 = mkN "parfymeri" "parfymerit" "parfymerier" "parfymerierna" ;
  parhaest_nn_1 = mkN "parhдst" ;
  parhus_nn_1 = mkN "parhus" neutrum ;
  paria_nn_1 = mkN "paria" ;
  parig_av_1 = mkA "parig" ;
  pariserhjul_nn_1 = mkN "pariserhjul" neutrum ;
  parisersmoergaas_nn_1 = mkN "parisersmцrgеs" ;
  parisisk_av_1 = mkA "parisisk" ;
  paritet_nn_1 = mkN "paritet" "pariteter" ;
  park_nn_1 = mkN "park" "parker" ;
  parkas_nn_1 = mkN "parkas" ;
  parkering_nn_1 = mkN "parkering" ;
  parkeringsautomat_nn_1 = mkN "parkeringsautomat" "parkeringsautomater" ;
  parkeringsavgift_nn_1 = mkN "parkeringsavgift" "parkeringsavgifter" ;
  parkeringsbot_nn_1 = mkN "parkeringsbot" "parkeringsbцter" ;
  parkeringshus_nn_1 = mkN "parkeringshus" neutrum ;
  parkeringsljus_nn_1 = mkN "parkeringsljus" neutrum ;
  parkeringsplats_nn_1 = mkN "parkeringsplats" "parkeringsplatser" ;
  parkeringsvakt_nn_1 = mkN "parkeringsvakt" "parkeringsvakter" ;
  parkett_nn_1 = mkN "parkett" "parketter" ;
  parkettgolv_nn_1 = mkN "parkettgolv" neutrum ;
  parkettstav_nn_1 = mkN "parkettstav" ;
  parlament_nn_1 = mkN "parlament" "parlamentet" "parlamenten" "parlamentena" ;
  parlamentaer_nn_1 = mkN "parlamentдr" "parlamentдrer" ;
  parlamentariker_nn_1 = mkN "parlamentariker" "parlamentarikern" "parlamentariker" "parlamentarikerna" ;
  parlamentarisk_av_1 = mkA "parlamentarisk" ;
  parlando_ab_1 = mkAdv "parlando" ;
  parlando_nn_1 = mkN "parlando" "parlandot" "parlandon" "parlandona" ;
  parloer_nn_1 = mkN "parlцr" "parlцrer" ;
  parnass_nn_1 = mkN "parnass" "parnasser" ;
  parning_nn_1 = mkN "parning" ;
  parningsdraekt_nn_1 = mkN "parningsdrдkt" "parningsdrдkter" ;
  parningsdrift_nn_1 = mkN "parningsdrift" "parningsdrifter" ;
  parningslek_nn_1 = mkN "parningslek" ;
  parningsorgan_nn_1 = mkN "parningsorgan" neutrum ;
  parodi_nn_1 = mkN "parodi" "parodier" ;
  parodiker_nn_1 = mkN "parodiker" "parodikern" "parodiker" "parodikerna" ;
  parodisk_av_1 = mkA "parodisk" ;
  parodontit_nn_1 = mkN "parodontit" "parodontiter" ;
  paroll_nn_1 = mkN "paroll" "paroller" ;
  paroxysm_nn_1 = mkN "paroxysm" "paroxysmer" ;
  parser_nn_1 = mkN "parser" ;
  parspel_nn_1 = mkN "parspel" "parspelet" "parspel" "parspelen" ;
  parstuga_nn_1 = mkN "parstuga" ;
  part_nn_1 = mkN "part" "parter" ;
  partaaig_av_1 = mkA "partеig" ;
  partaj_nn_1 = mkN "partaj" neutrum ;
  parterr_nn_1 = mkN "parterr" "parterrer" ;
  parti_nn_1 = mkN "parti" "partit" "partier" "partierna" ;
  partialton_nn_1 = mkN "partialton" "partialtoner" ;
  partialtryck_nn_1 = mkN "partialtryck" neutrum ;
  partiapparat_nn_1 = mkN "partiapparat" "partiapparater" ;
  partiblock_nn_1 = mkN "partiblock" neutrum ;
  partichef_nn_1 = mkN "partichef" "partichefer" ;
  particip_nn_1 = mkN "particip" neutrum ;
  participiell_av_1 = mkA "participiell" ;
  partidisciplin_nn_1 = mkN "partidisciplin" "partidiscipliner" ;
  partiell_av_1 = mkA "partiell" ;
  partifaerg_nn_1 = mkN "partifдrg" "partifдrger" ;
  partigaengare_nn_1 = mkN "partigдngare" "partigдngare" ;
  partigrupp_nn_1 = mkN "partigrupp" "partigrupper" ;
  partikamrat_nn_1 = mkN "partikamrat" "partikamrater" ;
  partikel_nn_1 = mkN "partikel" ;
  partikelaccelerator_nn_1 = mkN "partikelaccelerator" "partikelacceleratorer" ;
  partikelegenskap_nn_1 = mkN "partikelegenskap" "partikelegenskaper" ;
  partikelfysiker_nn_1 = mkN "partikelfysiker" "partikelfysikern" "partikelfysiker" "partikelfysikerna" ;
  partikellaboratorium_nn_1 = mkN "partikellaboratorium" "partikellaboratoriet" "partikellaboratorier" "partikellaboratorierna" ;
  partikellock_nn_1 = mkN "partikellock" neutrum ;
  partikelreaktion_nn_1 = mkN "partikelreaktion" "partikelreaktioner" ;
  partikelregn_nn_1 = mkN "partikelregn" neutrum ;
  partikongress_nn_1 = mkN "partikongress" "partikongresser" ;
  partikulaer_av_1 = mkA "partikulдr" ;
  partikuljaer_av_1 = mkA "partikuljдr" ;
  partiledare_nn_1 = mkN "partiledare" "partiledare" ;
  partiledning_nn_1 = mkN "partiledning" ;
  partiloes_av_1 = mkA "partilцs" ;
  partimedlem_nn_1 = mkN "partimedlem" "partimedlemmen" "partimedlemmar" "partimedlemmarna" ;
  partiordfoerande_nn_1 = mkN "partiordfцrande" "partiordfцranden" "partiordfцrande" "partiordfцrandena" ;
  partiorgan_nn_1 = mkN "partiorgan" neutrum ;
  partipolitisk_av_1 = mkA "partipolitisk" ;
  partipris_nn_1 = mkN "partipris" neutrum ;
  partiprogram_nn_1 = mkN "partiprogram" "partiprogrammet" "partiprogram" "partiprogrammen" ;
  partisan_nn_1 = mkN "partisan" "partisaner" ;
  partisekreterare_nn_1 = mkN "partisekreterare" "partisekreterare" ;
  partisk_av_1 = mkA "partisk" ;
  partiskhet_nn_1 = mkN "partiskhet" "partiskheter" ;
  partispaerr_nn_1 = mkN "partispдrr" ;
  partispraengning_nn_1 = mkN "partisprдngning" ;
  partitiv_av_1 = mkA "partitiv" ;
  partitrohet_nn_1 = mkN "partitrohet" "partitroheter" ;
  partitur_nn_1 = mkN "partitur" neutrum ;
  partner_nn_1 = mkN "partner" "partnern" "partner" "partnerna" ;
  partout_ab_1 = mkAdv "partout" ;
  partsbehoerighet_nn_1 = mkN "partsbehцrighet" "partsbehцrigheter" ;
  partsorgan_nn_1 = mkN "partsorgan" neutrum ;
  party_nn_1 = mkN "party" "partyt" "partyn" "partyna" ;
  parvel_nn_1 = mkN "parvel" ;
  parveny_nn_1 = mkN "parveny" "parvenyer" ;
  parvis_ab_1 = mkAdv "parvis" ;
  pascal_nn_1 = mkN "pascal" "pascalen" "pascal" "pascalen" ;
  paskill_nn_1 = mkN "paskill" "paskiller" ;
  pass_nn_1 = mkN "pass" neutrum ;
  passabel_av_1 = mkA "passabel" "passabelt" "passabla" "passabla" "passablare" "passablast" "passablaste" ;
  passad_nn_1 = mkN "passad" "passader" ;
  passadvind_nn_1 = mkN "passadvind" ;
  passage_nn_1 = mkN "passage" "passager" ;
  passagerarbaat_nn_1 = mkN "passagerarbеt" ;
  passagerare_nn_1 = mkN "passagerare" "passagerare" ;
  passagerarflyg_nn_1 = mkN "passagerarflyg" neutrum ;
  passagerarflygplan_nn_1 = mkN "passagerarflygplan" neutrum ;
  passagerarsalong_nn_1 = mkN "passagerarsalong" "passagerarsalonger" ;
  passande_av_1 = mkA "passande" ;
  passare_nn_1 = mkN "passare" "passare" ;
  passbaat_nn_1 = mkN "passbеt" ;
  passbit_nn_1 = mkN "passbit" ;
  passe_av_1 = mkA "passй" ;
  passepartout_nn_1 = mkN "passepartout" "passepartouter" ;
  passering_nn_1 = mkN "passering" ;
  passersedel_nn_1 = mkN "passersedel" ;
  passfoto_nn_1 = mkN "passfoto" "passfotot" "passfoton" "passfotona" ;
  passfrihet_nn_1 = mkN "passfrihet" "passfriheter" ;
  passgaangare_nn_1 = mkN "passgеngare" "passgеngare" ;
  passion_nn_1 = mkN "passion" "passioner" ;
  passionsfrukt_nn_1 = mkN "passionsfrukt" "passionsfrukter" ;
  passionshistoria_nn_1 = mkN "passionshistoria" "passionshistorien" "passionshistorier" "passionshistorierna" ;
  passionsspel_nn_1 = mkN "passionsspel" "passionsspelet" "passionsspel" "passionsspelen" ;
  passiv_av_1 = mkA "passiv" ;
  passiva_nn_1 = mkN "passiva" "passivan" "passiva" "passivana" ;
  passivitet_nn_1 = mkN "passivitet" "passiviteter" ;
  passivum_nn_1 = mkN "passivum" "passivet" "passiver" "passiverna" ;
  passlig_av_1 = mkA "passlig" ;
  passning_nn_1 = mkN "passning" ;
  passopp_nn_1 = mkN "passopp" "passopper" ;
  passpoal_nn_1 = mkN "passpoal" "passpoaler" ;
  passus_nn_1 = mkN "passus" ;
  pastej_nn_1 = mkN "pastej" "pastejer" ;
  pastell_nn_1 = mkN "pastell" "pasteller" ;
  pastellfaerg_nn_1 = mkN "pastellfдrg" "pastellfдrger" ;
  pastellmaalning_nn_1 = mkN "pastellmеlning" ;
  pastill_nn_1 = mkN "pastill" "pastiller" ;
  pastisch_nn_1 = mkN "pastisch" "pastischer" ;
  pastoerisering_nn_1 = mkN "pastцrisering" ;
  pastoes_av_1 = mkA "pastцs" ;
  pastor_nn_1 = mkN "pastor" "pastorer" ;
  pastoral_av_1 = mkA "pastoral" ;
  pastoral_nn_1 = mkN "pastoral" "pastoraler" ;
  pastorat_nn_1 = mkN "pastorat" neutrum ;
  pastoratsadjunkt_nn_1 = mkN "pastoratsadjunkt" "pastoratsadjunkter" ;
  pastorsadjunkt_nn_1 = mkN "pastorsadjunkt" "pastorsadjunkter" ;
  pastorsexpedition_nn_1 = mkN "pastorsexpedition" "pastorsexpeditioner" ;
  pastos_av_1 = mkA "pastos" ;
  pate_nn_1 = mkN "patй" "patйer" ;
  paten_nn_1 = mkN "paten" "patener" ;
  patent_nn_1 = mkN "patent" neutrum ;
  patentlaas_nn_1 = mkN "patentlеs" neutrum ;
  patentmedicin_nn_1 = mkN "patentmedicin" "patentmediciner" ;
  patentsmoergaas_nn_1 = mkN "patentsmцrgеs" ;
  pater_nn_1 = mkN "pater" ;
  paternoster_nn_1 = mkN "paternoster" neutrum ;
  paternosterhiss_nn_1 = mkN "paternosterhiss" ;
  paternosterverk_nn_1 = mkN "paternosterverk" neutrum ;
  patetisk_av_1 = mkA "patetisk" ;
  patiens_nn_1 = mkN "patiens" "patienser" ;
  patient_nn_1 = mkN "patient" "patienter" ;
  patientplaat_nn_1 = mkN "patientplеt" ;
  patogen_av_1 = mkA "patogen" ;
  patolog_nn_1 = mkN "patolog" "patologer" ;
  patologi_nn_1 = mkN "patologi" "patologier" ;
  patologisk_av_1 = mkA "patologisk" ;
  patriark_nn_1 = mkN "patriark" "patriarker" ;
  patriarkalisk_av_1 = mkA "patriarkalisk" ;
  patriarkat_nn_1 = mkN "patriarkat" neutrum ;
  patricier_nn_1 = mkN "patricier" "patriciern" "patricier" "patricierna" ;
  patriot_nn_1 = mkN "patriot" "patrioter" ;
  patriotisk_av_1 = mkA "patriotisk" ;
  patris_nn_1 = mkN "patris" "patriser" ;
  patron_nn_1 = mkN "patron" "patron" "patroner" "patronerna" ;
  patron_nn_2 = mkN "patron" "patroner" ;
  patronbaelte_nn_1 = mkN "patronbдlte" ;
  patronymikon_nn_1 = mkN "patronymikon" neutrum ;
  patrull_nn_1 = mkN "patrull" "patruller" ;
  patrullbaat_nn_1 = mkN "patrullbеt" ;
  patt_nn_1 = mkN "patt" "patter" ;
  patt_nn_2 = mkN "patt" ;
  paulun_nn_1 = mkN "paulun" "pauluner" ;
  paus_nn_1 = mkN "paus" "pauser" ;
  pausfaagel_nn_1 = mkN "pausfеgel" ;
  paussignal_nn_1 = mkN "paussignal" "paussignaler" ;
  paustecken_nn_1 = mkN "paustecken" "paustecknet" "paustecken" "paustecknen" ;
  pavane_nn_1 = mkN "pavane" "pavaner" ;
  paviljong_nn_1 = mkN "paviljong" "paviljonger" ;
  peang_nn_1 = mkN "peang" "peanger" ;
  pedagog_nn_1 = mkN "pedagog" "pedagoger" ;
  pedagogisk_av_1 = mkA "pedagogisk" ;
  pedal_nn_1 = mkN "pedal" "pedaler" ;
  pedant_nn_1 = mkN "pedant" "pedanter" ;
  pedanteri_nn_1 = mkN "pedanteri" "pedanterit" "pedanterier" "pedanterierna" ;
  pedantisk_av_1 = mkA "pedantisk" ;
  pedell_nn_1 = mkN "pedell" "pedeller" ;
  pederast_nn_1 = mkN "pederast" "pederaster" ;
  pediatriker_nn_1 = mkN "pediatriker" "pediatrikern" "pediatriker" "pediatrikerna" ;
  pediatrisk_av_1 = mkA "pediatrisk" ;
  pedikyrist_nn_1 = mkN "pedikyrist" "pedikyrister" ;
  pediment_nn_1 = mkN "pediment" "pedimentet" "pedimenten" "pedimentena" ;
  pegas_nn_1 = mkN "pegas" "pegaser" ;
  pegel_nn_1 = mkN "pegel" ;
  pegmatit_nn_1 = mkN "pegmatit" "pegmatiter" ;
  pejling_nn_1 = mkN "pejling" ;
  pejorativ_av_1 = mkA "pejorativ" ;
  pejorativ_nn_1 = mkN "pejorativ" neutrum ;
  pekannoet_nn_1 = mkN "pekannцt" "pekannцtter" ;
  pekare_nn_1 = mkN "pekare" "pekare" ;
  pekbok_nn_1 = mkN "pekbok" "pekbцcker" ;
  pekfinger_nn_1 = mkN "pekfinger" ;
  pekfingertest_nn_1 = mkN "pekfingertest" neutrum ;
  pekines_nn_1 = mkN "pekines" "pekineser" ;
  pekoral_nn_1 = mkN "pekoral" neutrum ;
  pekoralist_nn_1 = mkN "pekoralist" "pekoralister" ;
  pekoralistisk_av_1 = mkA "pekoralistisk" ;
  pekpinne_nn_1 = mkN "pekpinne" utrum ;
  pektaa_nn_1 = mkN "pektе" "pektеn" "pektеr" "pektеrna" ;
  pektin_nn_1 = mkN "pektin" neutrum ;
  pekuniaer_av_1 = mkA "pekuniдr" ;
  pelagisk_av_1 = mkA "pelagisk" ;
  pelarbord_nn_1 = mkN "pelarbord" neutrum ;
  pelare_nn_1 = mkN "pelare" "pelare" ;
  pelarformig_av_1 = mkA "pelarformig" ;
  pelargaang_nn_1 = mkN "pelargеng" ;
  pelargon_nn_1 = mkN "pelargon" "pelargoner" ;
  pelargonia_nn_1 = mkN "pelargonia" ;
  pelarhall_nn_1 = mkN "pelarhall" ;
  pelarhelgon_nn_1 = mkN "pelarhelgon" neutrum ;
  pelarsal_nn_1 = mkN "pelarsal" ;
  pelerin_nn_1 = mkN "pelerin" "peleriner" ;
  pelikan_nn_1 = mkN "pelikan" "pelikaner" ;
  pellejoens_nn_1 = mkN "pellejцns" ;
  pellet_nn_1 = mkN "pellet" ;
  pen_nn_1 = mkN "pen" "penen" "penar" "penarna" ;
  pendang_nn_1 = mkN "pendang" "pendanger" ;
  pendel_nn_1 = mkN "pendel" ;
  pendelavstaand_nn_1 = mkN "pendelavstеnd" neutrum ;
  pendeltaag_nn_1 = mkN "pendeltеg" neutrum ;
  pendelur_nn_1 = mkN "pendelur" neutrum ;
  pendlare_nn_1 = mkN "pendlare" "pendlare" ;
  pendyl_nn_1 = mkN "pendyl" "pendyler" ;
  penetration_nn_1 = mkN "penetration" "penetrationer" ;
  peng_nn_1 = mkN "peng" ;
  penibel_av_1 = mkA "penibel" "penibelt" "penibla" "penibla" "peniblare" "peniblast" "peniblaste" ;
  penicillin_nn_1 = mkN "penicillin" "penicilliner" ;
  penis_nn_1 = mkN "penis" ;
  penisattrapp_nn_1 = mkN "penisattrapp" "penisattrapper" ;
  penjoar_nn_1 = mkN "penjoar" "penjoarer" ;
  pennalist_nn_1 = mkN "pennalist" "pennalister" ;
  penndrag_nn_1 = mkN "penndrag" neutrum ;
  pennfaektare_nn_1 = mkN "pennfдktare" "pennfдktare" ;
  pennformerare_nn_1 = mkN "pennformerare" "pennformerare" ;
  penni_nn_1 = mkN "penni" "pennin" "penni" "pennina" ;
  penning_nn_1 = mkN "penning" ;
  penningfoersaendelse_nn_1 = mkN "penningfцrsдndelse" "penningfцrsдndelser" ;
  penninglaan_nn_1 = mkN "penninglеn" neutrum ;
  penninglott_nn_1 = mkN "penninglott" "penninglotter" ;
  penningmarknad_nn_1 = mkN "penningmarknad" "penningmarknader" ;
  penningstinn_av_1 = mkA "penningstinn" "penningstint" ;
  penningsumma_nn_1 = mkN "penningsumma" ;
  penningsystem_nn_1 = mkN "penningsystem" neutrum ;
  penningtilldelning_nn_1 = mkN "penningtilldelning" ;
  penningtransaktion_nn_1 = mkN "penningtransaktion" "penningtransaktioner" ;
  pennkniv_nn_1 = mkN "pennkniv" ;
  pennskaft_nn_1 = mkN "pennskaft" neutrum ;
  pennteckning_nn_1 = mkN "pennteckning" ;
  pennvaessare_nn_1 = mkN "pennvдssare" "pennvдssare" ;
  penny_nn_1 = mkN "penny" "pennyn" "pence" "pencen" ;
  pense_nn_1 = mkN "pensй" "pensйer" ;
  pensel_nn_1 = mkN "pensel" ;
  penseldrag_nn_1 = mkN "penseldrag" neutrum ;
  pension_nn_1 = mkN "pension" "pensioner" ;
  pensionaer_nn_1 = mkN "pensionдr" "pensionдrer" ;
  pensionaerslaegenhet_nn_1 = mkN "pensionдrslдgenhet" "pensionдrslдgenheter" ;
  pensionat_nn_1 = mkN "pensionat" neutrum ;
  pensionsaalder_nn_1 = mkN "pensionsеlder" ;
  pensionsbrev_nn_1 = mkN "pensionsbrev" neutrum ;
  pensionsfoersaekring_nn_1 = mkN "pensionsfцrsдkring" ;
  pensionsgrundande_av_1 = mkA "pensionsgrundande" ;
  pensionspoaeng_nn_1 = mkN "pensionspoдng" "pensionspoдngen" "pensionspoдng" "pensionspoдngen" ;
  pensionssparande_nn_1 = mkN "pensionssparande" ;
  pensum_nn_1 = mkN "pensum" neutrum ;
  pentagram_nn_1 = mkN "pentagram" "pentagrammet" "pentagram" "pentagrammen" ;
  pentameter_nn_1 = mkN "pentameter" ;
  pentry_nn_1 = mkN "pentry" "pentryt" "pentryn" "pentryna" ;
  penultima_nn_1 = mkN "penultima" ;
  peon_nn_1 = mkN "peon" "peoner" ;
  pepparkaksgris_nn_1 = mkN "pepparkaksgris" ;
  pepparkaksgubbe_nn_1 = mkN "pepparkaksgubbe" utrum ;
  pepparkakshus_nn_1 = mkN "pepparkakshus" neutrum ;
  pepparkorn_nn_1 = mkN "pepparkorn" neutrum ;
  pepparkvarn_nn_1 = mkN "pepparkvarn" ;
  peptid_nn_1 = mkN "peptid" neutrum ;
  perborat_nn_1 = mkN "perborat" "perboratet" "perborater" "perboraterna" ;
  perception_nn_1 = mkN "perception" "perceptioner" ;
  perceptuell_av_1 = mkA "perceptuell" ;
  peremtorisk_av_1 = mkA "peremtorisk" ;
  perenn_av_1 = mkA "perenn" "perent" ;
  perenn_nn_1 = mkN "perenn" "perenner" ;
  perfekt_av_1 = mkA "perfekt" "perfekt" ;
  perfektionist_nn_1 = mkN "perfektionist" "perfektionister" ;
  perfektiv_av_1 = mkA "perfektiv" ;
  perfektivisk_av_1 = mkA "perfektivisk" ;
  perfektparticip_nn_1 = mkN "perfektparticip" neutrum ;
  perfektum_nn_1 = mkN "perfektum" "perfektet" "perfekter" "perfekterna" ;
  perfiditet_nn_1 = mkN "perfiditet" "perfiditeter" ;
  perforation_nn_1 = mkN "perforation" "perforationer" ;
  perforator_nn_1 = mkN "perforator" "perforatorer" ;
  perforering_nn_1 = mkN "perforering" ;
  pergament_nn_1 = mkN "pergament" neutrum ;
  pergamentband_nn_1 = mkN "pergamentband" neutrum ;
  pergamentbrev_nn_1 = mkN "pergamentbrev" neutrum ;
  pergamentrulle_nn_1 = mkN "pergamentrulle" utrum ;
  perifer_av_1 = mkA "perifer" ;
  periferi_nn_1 = mkN "periferi" "periferier" ;
  perifon_nn_1 = mkN "perifon" "perifoner" ;
  perifras_nn_1 = mkN "perifras" "perifraser" ;
  perifrastisk_av_1 = mkA "perifrastisk" ;
  perimeter_nn_1 = mkN "perimeter" ;
  perinatal_av_1 = mkA "perinatal" ;
  period_nn_1 = mkN "period" "perioder" ;
  periodare_nn_1 = mkN "periodare" "periodare" ;
  periodicitet_nn_1 = mkN "periodicitet" "periodiciteter" ;
  periodisk_av_1 = mkA "periodisk" ;
  periodsupare_nn_1 = mkN "periodsupare" "periodsupare" ;
  periodtal_nn_1 = mkN "periodtal" "periodtalet" "periodtalen" "periodtalena" ;
  periodvis_ab_1 = mkAdv "periodvis" ;
  peripeti_nn_1 = mkN "peripeti" "peripetier" ;
  periskop_nn_1 = mkN "periskop" neutrum ;
  periskopisk_av_1 = mkA "periskopisk" ;
  peristaltisk_av_1 = mkA "peristaltisk" ;
  peristyl_nn_1 = mkN "peristyl" "peristyler" ;
  peritonit_nn_1 = mkN "peritonit" "peritoniter" ;
  perkal_nn_1 = mkN "perkal" "perkaler" ;
  perkolator_nn_1 = mkN "perkolator" "perkolatorer" ;
  perkussion_nn_1 = mkN "perkussion" "perkussioner" ;
  perkussionsinstrument_nn_1 = mkN "perkussionsinstrument" neutrum ;
  perkutan_av_1 = mkA "perkutan" ;
  permanent_av_1 = mkA "permanent" "permanent" ;
  permeabel_av_1 = mkA "permeabel" "permeabelt" "permeabla" "permeabla" "permeablare" "permeablast" "permeablaste" ;
  permeabilitet_nn_1 = mkN "permeabilitet" "permeabiliteter" ;
  permission_nn_1 = mkN "permission" "permissioner" ;
  permittent_nn_1 = mkN "permittent" "permittenter" ;
  permittering_nn_1 = mkN "permittering" ;
  permutation_nn_1 = mkN "permutation" "permutationer" ;
  pernicioes_av_1 = mkA "perniciцs" ;
  peroxid_nn_1 = mkN "peroxid" "peroxider" ;
  perpendikel_nn_1 = mkN "perpendikel" ;
  perpendikulaer_av_1 = mkA "perpendikulдr" ;
  perpetuell_av_1 = mkA "perpetuell" ;
  perplex_av_1 = mkA "perplex" ;
  perrong_nn_1 = mkN "perrong" "perronger" ;
  persedel_nn_1 = mkN "persedel" ;
  perser_nn_1 = mkN "perser" "persern" "perser" "perserna" ;
  persianpaels_nn_1 = mkN "persianpдls" ;
  persienn_nn_1 = mkN "persienn" "persienner" ;
  persimon_nn_1 = mkN "persimon" "persimoner" ;
  persisk_av_1 = mkA "persisk" ;
  persiska_nn_2 = mkN "persiska" ;
  person_nn_1 = mkN "person" "personer" ;
  personage_nn_1 = mkN "personage" "personager" ;
  personal_nn_1 = mkN "personal" "personaler" ;
  personal_nn_2 = mkN "personal" "personaler" ;
  personalavdelning_nn_1 = mkN "personalavdelning" ;
  personalchef_nn_1 = mkN "personalchef" "personalchefer" ;
  personalfraaga_nn_1 = mkN "personalfrеga" ;
  personalia_nn_1 = mkN "personalia" "personalian" "personalia" "personaliana" ;
  personalingaang_nn_1 = mkN "personalingеng" ;
  personallaekare_nn_1 = mkN "personallдkare" "personallдkare" ;
  personalmatsal_nn_1 = mkN "personalmatsal" ;
  personalorganisation_nn_1 = mkN "personalorganisation" "personalorganisationer" ;
  personalrum_nn_1 = mkN "personalrum" "personalrummet" "personalrum" "personalrummen" ;
  personaltidning_nn_1 = mkN "personaltidning" ;
  personalunion_nn_1 = mkN "personalunion" "personalunioner" ;
  personalutbildare_nn_1 = mkN "personalutbildare" "personalutbildare" ;
  personalvaard_nn_1 = mkN "personalvеrd" ;
  personbevis_nn_1 = mkN "personbevis" neutrum ;
  personbil_nn_1 = mkN "personbil" ;
  persondator_nn_1 = mkN "persondator" "persondatorer" ;
  personell_av_1 = mkA "personell" ;
  personfoersaekring_nn_1 = mkN "personfцrsдkring" ;
  personfraaga_nn_1 = mkN "personfrеga" ;
  persongalleri_nn_1 = mkN "persongalleri" "persongallerit" "persongallerier" "persongallerierna" ;
  personhistorisk_av_1 = mkA "personhistorisk" ;
  personifikation_nn_1 = mkN "personifikation" "personifikationer" ;
  personkilometer_nn_1 = mkN "personkilometer" "personkilometern" "personkilometer" "personkilometerna" ;
  personkontakt_nn_1 = mkN "personkontakt" "personkontakter" ;
  personkonto_nn_1 = mkN "personkonto" "personkontot" "personkonton" "personkontona" ;
  personkult_nn_1 = mkN "personkult" "personkulter" ;
  personlig_av_1 = mkA "personlig" ;
  personligen_ab_1 = mkAdv "personligen" ;
  personlighet_nn_1 = mkN "personlighet" "personligheter" ;
  personlighetstyp_nn_1 = mkN "personlighetstyp" "personlighetstyper" ;
  personnamn_nn_1 = mkN "personnamn" neutrum ;
  personnummer_nn_1 = mkN "personnummer" neutrum ;
  personpolitisk_av_1 = mkA "personpolitisk" ;
  personregister_nn_1 = mkN "personregister" neutrum ;
  personsoekare_nn_1 = mkN "personsцkare" "personsцkare" ;
  persontaag_nn_1 = mkN "persontеg" neutrum ;
  personundersoekning_nn_1 = mkN "personundersцkning" ;
  personuppgift_nn_1 = mkN "personuppgift" "personuppgifter" ;
  personvaag_nn_1 = mkN "personvеg" ;
  personvagn_nn_1 = mkN "personvagn" ;
  personval_nn_1 = mkN "personval" neutrum ;
  perspektiv_nn_1 = mkN "perspektiv" neutrum ;
  perspektivbild_nn_1 = mkN "perspektivbild" "perspektivbilder" ;
  perspektivfoenster_nn_1 = mkN "perspektivfцnster" neutrum ;
  perspektivfoerskjutning_nn_1 = mkN "perspektivfцrskjutning" ;
  perspektivisk_av_1 = mkA "perspektivisk" ;
  perspektivloes_av_1 = mkA "perspektivlцs" ;
  perturbation_nn_1 = mkN "perturbation" "perturbationer" ;
  peruan_nn_1 = mkN "peruan" "peruaner" ;
  peruansk_av_1 = mkA "peruansk" ;
  peruanska_nn_1 = mkN "peruanska" ;
  peruk_nn_1 = mkN "peruk" "peruker" ;
  perukmakare_nn_1 = mkN "perukmakare" "perukmakare" ;
  perukstock_nn_1 = mkN "perukstock" ;
  pervers_av_1 = mkA "pervers" ;
  perversion_nn_1 = mkN "perversion" "perversioner" ;
  perversitet_nn_1 = mkN "perversitet" "perversiteter" ;
  peseta_nn_1 = mkN "peseta" "pesetan" "pesetas" "pesetasen" ;
  peso_nn_1 = mkN "peso" "peson" "pesos" "pesosen" ;
  pessar_nn_1 = mkN "pessar" neutrum ;
  pessimist_nn_1 = mkN "pessimist" "pessimister" ;
  pessimistisk_av_1 = mkA "pessimistisk" ;
  pest_nn_1 = mkN "pest" "pester" ;
  pesticid_nn_1 = mkN "pesticid" "pesticider" ;
  pestilens_nn_1 = mkN "pestilens" "pestilenser" ;
  petig_av_1 = mkA "petig" ;
  petimaeter_nn_1 = mkN "petimдter" ;
  petit_chou_nn_1 = mkN "petit-chou" "petit-choun" "petit-chouer" "petit-chouerna" ;
  petitchou_nn_1 = mkN "petitchou" "petitchoun" "petitchouer" "petitchouerna" ;
  petitess_nn_1 = mkN "petitess" "petitesser" ;
  petition_nn_1 = mkN "petition" "petitioner" ;
  petmoj_nn_1 = mkN "petmoj" ;
  petnoga_av_1 = mkA "petnoga" ;
  petrifikat_nn_1 = mkN "petrifikat" neutrum ;
  petrokemisk_av_1 = mkA "petrokemisk" ;
  petsaeker_av_1 = mkA "petsдker" "petsдkert" "petsдkra" "petsдkra" "petsдkrare" "petsдkrast" "petsдkraste" ;
  pfennig_nn_1 = mkN "pfennig" "pfennigen" "pfennig" "pfennigen" ;
  pi_nn_1 = mkN "pi" neutrum ;
  piaff_nn_1 = mkN "piaff" "piaffer" ;
  pianino_nn_1 = mkN "pianino" "pianinot" "pianinon" "pianinona" ;
  pianissimo_ab_1 = mkAdv "pianissimo" ;
  pianissimo_nn_1 = mkN "pianissimo" "pianissimot" "pianissimon" "pianissimona" ;
  pianist_nn_1 = mkN "pianist" "pianister" ;
  piano_ab_1 = mkAdv "piano" ;
  piano_nn_1 = mkN "piano" "pianot" "pianon" "pianona" ;
  pianokonsert_nn_1 = mkN "pianokonsert" "pianokonserter" ;
  pianosonat_nn_1 = mkN "pianosonat" "pianosonater" ;
  pianospel_nn_1 = mkN "pianospel" "pianospelet" "pianospel" "pianospelen" ;
  pianostol_nn_1 = mkN "pianostol" ;
  piassavakvast_nn_1 = mkN "piassavakvast" ;
  piaster_nn_1 = mkN "piaster" ;
  picador_nn_1 = mkN "picador" "picadoren" "picadorer" "picadorerna" ;
  piccolafloejt_nn_1 = mkN "piccolaflцjt" "piccolaflцjter" ;
  piccolo_nn_1 = mkN "piccolo" "piccolor" ;
  picknick_nn_1 = mkN "picknick" ;
  pickup_nn_1 = mkN "pickup" "pickuper" ;
  picot_nn_1 = mkN "picot" "picoter" ;
  pidgin_nn_1 = mkN "pidgin" neutrum ;
  piedestal_nn_1 = mkN "piedestal" "piedestaler" ;
  pierrot_nn_1 = mkN "pierrot" "pierroter" ;
  pietet_nn_1 = mkN "pietet" "pieteter" ;
  pietetsfull_av_1 = mkA "pietetsfull" ;
  pietist_nn_1 = mkN "pietist" "pietister" ;
  piffig_av_1 = mkA "piffig" ;
  pigg_av_1 = mkA "pigg" ;
  pigg_nn_1 = mkN "pigg" ;
  piggelin_av_1 = mkA "piggelin" ;
  pigghaj_nn_1 = mkN "pigghaj" ;
  piggsvin_nn_1 = mkN "piggsvin" neutrum ;
  piggvar_nn_1 = mkN "piggvar" ;
  pigment_nn_1 = mkN "pigment" neutrum ;
  pigroman_nn_1 = mkN "pigroman" "pigromaner" ;
  pigtittare_nn_1 = mkN "pigtittare" "pigtittare" ;
  pigtjusare_nn_1 = mkN "pigtjusare" "pigtjusare" ;
  pik_nn_1 = mkN "pik" ;
  pikador_nn_1 = mkN "pikador" "pikadoren" "pikadorer" "pikadorerna" ;
  pikant_av_1 = mkA "pikant" "pikant" ;
  pikanteri_nn_1 = mkN "pikanteri" "pikanterit" "pikanterier" "pikanterierna" ;
  pikaresk_nn_1 = mkN "pikaresk" "pikaresker" ;
  pikareskroman_nn_1 = mkN "pikareskroman" "pikareskromaner" ;
  pike_nn_1 = mkN "pikй" "pikйer" ;
  piket_nn_1 = mkN "piket" "piketer" ;
  piketbil_nn_1 = mkN "piketbil" ;
  pikoer_nn_1 = mkN "pikцr" "pikцrer" ;
  pikstav_nn_1 = mkN "pikstav" ;
  piktur_nn_1 = mkN "piktur" "pikturer" ;
  pil_nn_1 = mkN "pil" ;
  pilaff_nn_1 = mkN "pilaff" "pilaffer" ;
  pilaster_nn_1 = mkN "pilaster" ;
  pilbaage_nn_1 = mkN "pilbеge" utrum ;
  pilfink_nn_1 = mkN "pilfink" ;
  pilgrim_nn_1 = mkN "pilgrim" "pilgrimer" ;
  pilgrimsfaerd_nn_1 = mkN "pilgrimsfдrd" "pilgrimsfдrder" ;
  pilgrimsfalk_nn_1 = mkN "pilgrimsfalk" ;
  pilgrimsstav_nn_1 = mkN "pilgrimsstav" ;
  pilk_nn_1 = mkN "pilk" ;
  pilkastning_nn_1 = mkN "pilkastning" ;
  pilkoger_nn_1 = mkN "pilkoger" neutrum ;
  pilleknarkare_nn_1 = mkN "pilleknarkare" "pilleknarkare" ;
  pillemarisk_av_1 = mkA "pillemarisk" ;
  piller_nn_1 = mkN "piller" neutrum ;
  pillerbagge_nn_1 = mkN "pillerbagge" utrum ;
  pillerburk_nn_1 = mkN "pillerburk" ;
  pillertrillare_nn_1 = mkN "pillertrillare" "pillertrillare" ;
  pillrig_av_1 = mkA "pillrig" ;
  pilot_nn_1 = mkN "pilot" "piloter" ;
  pilotballong_nn_1 = mkN "pilotballong" "pilotballonger" ;
  pilotstudie_nn_1 = mkN "pilotstudie" "pilotstudier" ;
  pilsk_av_1 = mkA "pilsk" ;
  pilsnabb_av_1 = mkA "pilsnabb" ;
  pilsner_nn_1 = mkN "pilsner" "pilsnern" "pilsner" "pilsnerna" ;
  pilsnerfilm_nn_1 = mkN "pilsnerfilm" "pilsnerfilmer" ;
  pilsnerkorv_nn_1 = mkN "pilsnerkorv" ;
  pilspets_nn_1 = mkN "pilspets" ;
  pilt_nn_1 = mkN "pilt" ;
  piltraed_nn_1 = mkN "piltrдd" neutrum ;
  pimpel_nn_1 = mkN "pimpel" ;
  pimpelspoe_nn_1 = mkN "pimpelspц" "pimpelspцet" "pimpelspцn" "pimpelspцna" ;
  pimpinett_av_1 = mkA "pimpinett" ;
  pin_ab_1 = mkAdv "pin" ;
  pinakotek_nn_1 = mkN "pinakotek" neutrum ;
  pinal_nn_1 = mkN "pinal" "pinaler" ;
  pincene_nn_1 = mkN "pincenй" "pincenйer" ;
  pincett_nn_1 = mkN "pincett" "pincetter" ;
  pingla_nn_1 = mkN "pingla" ;
  pingpongboll_nn_1 = mkN "pingpongboll" ;
  pingst_nn_1 = mkN "pingst" ;
  pingstafton_nn_1 = mkN "pingstafton" "pingstaftonen" "pingstaftnar" "pingstaftnarna" ;
  pingstdag_nn_1 = mkN "pingstdag" ;
  pingsthelg_nn_1 = mkN "pingsthelg" "pingsthelger" ;
  pingstlilja_nn_1 = mkN "pingstlilja" ;
  pingstvaen_nn_1 = mkN "pingstvдn" "pingstvдnnen" "pingstvдnner" "pingstvдnnerna" ;
  pingvin_nn_1 = mkN "pingvin" "pingviner" ;
  pinje_nn_1 = mkN "pinje" "pinjer" ;
  pinjenoet_nn_1 = mkN "pinjenцt" "pinjenцtter" ;
  pinjong_nn_1 = mkN "pinjong" "pinjonger" ;
  pinknoedig_av_1 = mkA "pinknцdig" ;
  pinlig_av_1 = mkA "pinlig" ;
  pinne_nn_1 = mkN "pinne" utrum ;
  pinnhaal_nn_1 = mkN "pinnhеl" neutrum ;
  pinnharv_nn_1 = mkN "pinnharv" ;
  pinnig_av_1 = mkA "pinnig" ;
  pinnstol_nn_1 = mkN "pinnstol" ;
  pinoande_nn_1 = mkN "pinoande" utrum ;
  pinsam_av_1 = mkA "pinsam" "pinsamt" "pinsamma" "pinsamma" "pinsammare" "pinsammast" "pinsammaste" ;
  pinscher_nn_1 = mkN "pinscher" ;
  pion_nn_1 = mkN "pion" "pioner" ;
  pionjaer_nn_1 = mkN "pionjдr" "pionjдrer" ;
  pionroed_av_1 = mkA "pionrцd" ;
  pip_nn_1 = mkN "pip" ;
  pip_nn_2 = mkN "pip" neutrum ;
  pipare_nn_1 = mkN "pipare" "pipare" ;
  pipeline_nn_1 = mkN "pipeline" "pipelinen" "pipelines" "pipelinesen" ;
  pipett_nn_1 = mkN "pipett" "pipetter" ;
  piphuvud_nn_1 = mkN "piphuvud" "piphuvudet" "piphuvuden" "piphuvudena" ;
  pipig_av_1 = mkA "pipig" ;
  pipkrage_nn_1 = mkN "pipkrage" utrum ;
  pippi_nn_1 = mkN "pippi" "pippin" "pippiar" "pippiarna" ;
  pipping_nn_1 = mkN "pipping" ;
  piprensare_nn_1 = mkN "piprensare" "piprensare" ;
  piproekare_nn_1 = mkN "piprцkare" "piprцkare" ;
  pipskaegg_nn_1 = mkN "pipskдgg" neutrum ;
  pipstopp_nn_1 = mkN "pipstopp" ;
  pipstoppare_nn_1 = mkN "pipstoppare" "pipstoppare" ;
  pipsvamp_nn_1 = mkN "pipsvamp" ;
  pir_nn_1 = mkN "pir" ;
  pirat_nn_1 = mkN "pirat" "pirater" ;
  piratsaendare_nn_1 = mkN "piratsдndare" "piratsдndare" ;
  pirhuvud_nn_1 = mkN "pirhuvud" "pirhuvudet" "pirhuvuden" "pirhuvudena" ;
  pirk_nn_1 = mkN "pirk" ;
  pirog_nn_1 = mkN "pirog" "piroger" ;
  pirrig_av_1 = mkA "pirrig" ;
  piruett_nn_1 = mkN "piruett" "piruetter" ;
  pirum_av_1 = mkA "pirum" ;
  piskbalkong_nn_1 = mkN "piskbalkong" "piskbalkonger" ;
  piskklatsch_nn_1 = mkN "piskklatsch" ;
  piskmask_nn_1 = mkN "piskmask" ;
  piskperuk_nn_1 = mkN "piskperuk" "piskperuker" ;
  piskrapp_nn_1 = mkN "piskrapp" neutrum ;
  piskslaeng_nn_1 = mkN "piskslдng" ;
  pisksnaert_nn_1 = mkN "pisksnдrt" ;
  piskstaellning_nn_1 = mkN "piskstдllning" ;
  pissoar_nn_1 = mkN "pissoar" "pissoarer" ;
  pist_nn_1 = mkN "pist" "pister" ;
  pistage_nn_1 = mkN "pistage" "pistager" ;
  pistasch_nn_1 = mkN "pistasch" "pistascher" ;
  pistill_nn_1 = mkN "pistill" "pistiller" ;
  pistol_nn_1 = mkN "pistol" "pistoler" ;
  pistong_nn_1 = mkN "pistong" "pistonger" ;
  pitt_nn_1 = mkN "pitt" ;
  pittoresk_av_1 = mkA "pittoresk" ;
  pivaa_nn_1 = mkN "pivе" "pivеer" ;
  pivot_nn_1 = mkN "pivot" "pivoter" ;
  pivotfoenster_nn_1 = mkN "pivotfцnster" neutrum ;
  pivothaengd_av_1 = mkA "pivothдngd" "pivothдngt" ;
  pivotvagn_nn_1 = mkN "pivotvagn" ;
  pix_nn_1 = mkN "pix" neutrum ;
  pizzicato_ab_1 = mkAdv "pizzicato" ;
  pizzicato_nn_1 = mkN "pizzicato" "pizzicatot" "pizzicaton" "pizzicatona" ;
  pjaakig_av_1 = mkA "pjеkig" ;
  pjaes_nn_1 = mkN "pjдs" "pjдser" ;
  pjatt_nn_1 = mkN "pjatt" ;
  pjoskig_av_1 = mkA "pjoskig" ;
  pjunkig_av_1 = mkA "pjunkig" ;
  plaaga_nn_1 = mkN "plеga" ;
  plaagoande_nn_1 = mkN "plеgoande" utrum ;
  plaagoris_nn_1 = mkN "plеgoris" neutrum ;
  plaagsam_av_1 = mkA "plеgsam" "plеgsamt" "plеgsamma" "plеgsamma" "plеgsammare" "plеgsammast" "plеgsammaste" ;
  plaan_nn_1 = mkN "plеn" neutrum ;
  plaanbok_nn_1 = mkN "plеnbok" "plеnbцcker" ;
  plaaster_nn_1 = mkN "plеster" neutrum ;
  plaat_nn_1 = mkN "plеt" ;
  plaathuv_nn_1 = mkN "plеthuv" ;
  plaatkaerl_nn_1 = mkN "plеtkдrl" neutrum ;
  plaatkant_nn_1 = mkN "plеtkant" "plеtkanter" ;
  plaatmage_nn_1 = mkN "plеtmage" utrum ;
  plaatmynt_nn_1 = mkN "plеtmynt" neutrum ;
  plaatsax_nn_1 = mkN "plеtsax" ;
  plaatschabrak_nn_1 = mkN "plеtschabrak" neutrum ;
  plaatslagare_nn_1 = mkN "plеtslagare" "plеtslagare" ;
  plaatslageri_nn_1 = mkN "plеtslageri" "plеtslagerit" "plеtslagerier" "plеtslagerierna" ;
  placeboeffekt_nn_1 = mkN "placeboeffekt" "placeboeffekter" ;
  placering_nn_1 = mkN "placering" ;
  placeringskort_nn_1 = mkN "placeringskort" neutrum ;
  placeringsobjekt_nn_1 = mkN "placeringsobjekt" neutrum ;
  pladask_ab_1 = mkAdv "pladask" ;
  pladdrig_av_1 = mkA "pladdrig" ;
  plaed_nn_1 = mkN "plдd" ;
  plaedering_nn_1 = mkN "plдdering" ;
  plaedoaje_nn_1 = mkN "plдdoajй" "plдdoajйer" ;
  plaegsed_nn_1 = mkN "plдgsed" "plдgseder" ;
  plaett_nn_1 = mkN "plдtt" ;
  plaettlagg_nn_1 = mkN "plдttlagg" ;
  plafond_nn_1 = mkN "plafond" "plafonder" ;
  plage_nn_1 = mkN "plage" "plager" ;
  plagg_nn_1 = mkN "plagg" neutrum ;
  plagiat_nn_1 = mkN "plagiat" neutrum ;
  plagiator_nn_1 = mkN "plagiator" "plagiatorer" ;
  plaidoyer_nn_1 = mkN "plaidoyer" "plaidoyerer" ;
  plakat_av_1 = mkA "plakat" ;
  plakat_nn_1 = mkN "plakat" neutrum ;
  plakett_nn_1 = mkN "plakett" "plaketter" ;
  plan_av_1 = mkA "plan" ;
  plan_nn_1 = mkN "plan" neutrum ;
  plan_nn_2 = mkN "plan" "planer" ;
  planekonomi_nn_1 = mkN "planekonomi" "planekonomier" ;
  planenlig_av_1 = mkA "planenlig" ;
  planerare_nn_1 = mkN "planerare" "planerare" ;
  planering_nn_1 = mkN "planering" ;
  planeringsorgan_nn_1 = mkN "planeringsorgan" neutrum ;
  planet_nn_1 = mkN "planet" "planeter" ;
  planetarisk_av_1 = mkA "planetarisk" ;
  planetarium_nn_1 = mkN "planetarium" "planetariet" "planetarier" "planetarierna" ;
  planetbildning_nn_1 = mkN "planetbildning" ;
  planetesimal_nn_1 = mkN "planetesimal" "planetesimaler" ;
  planetsystem_nn_1 = mkN "planetsystem" neutrum ;
  plank_nn_2 = mkN "plank" neutrum ;
  plankgaang_nn_1 = mkN "plankgеng" ;
  plankonkav_av_1 = mkA "plankonkav" ;
  plankonvex_av_1 = mkA "plankonvex" ;
  plankorsning_nn_1 = mkN "plankorsning" ;
  plankstrykare_nn_1 = mkN "plankstrykare" "plankstrykare" ;
  plankter_nn_1 = mkN "plankter" "planktern" "plankter" "plankterna" ;
  plankton_nn_1 = mkN "plankton" neutrum ;
  planktondjur_nn_1 = mkN "planktondjur" neutrum ;
  planktonvaext_nn_1 = mkN "planktonvдxt" "planktonvдxter" ;
  planlaeggning_nn_1 = mkN "planlдggning" ;
  planloes_av_1 = mkA "planlцs" ;
  planloesning_nn_1 = mkN "planlцsning" ;
  planmaessig_av_1 = mkA "planmдssig" ;
  planparallell_av_1 = mkA "planparallell" ;
  planritning_nn_1 = mkN "planritning" ;
  plansch_nn_1 = mkN "plansch" "planscher" ;
  planschett_nn_1 = mkN "planschett" "planschetter" ;
  planschverk_nn_1 = mkN "planschverk" neutrum ;
  planskild_av_1 = mkA "planskild" "planskilt" ;
  plantage_nn_1 = mkN "plantage" "plantager" ;
  plantering_nn_1 = mkN "plantering" ;
  plants_nn_1 = mkN "plants" ;
  plaskdamm_nn_1 = mkN "plaskdamm" ;
  plaskvaat_av_1 = mkA "plaskvеt" ;
  plasma_nn_1 = mkN "plasma" "plasmat" "plasmer" "plasmerna" ;
  plast_nn_1 = mkN "plast" "plaster" ;
  plastbindemedel_nn_1 = mkN "plastbindemedel" neutrum ;
  plastbunden_av_1 = mkA "plastbunden" "plastbundet" ;
  plastfolie_nn_1 = mkN "plastfolie" "plastfolier" ;
  plasticitet_nn_1 = mkN "plasticitet" "plasticiteter" ;
  plastikkirurg_nn_1 = mkN "plastikkirurg" "plastikkirurger" ;
  plastindustri_nn_1 = mkN "plastindustri" "plastindustrier" ;
  plastisk_av_1 = mkA "plastisk" ;
  plastkork_nn_1 = mkN "plastkork" ;
  plastlaminat_nn_1 = mkN "plastlaminat" neutrum ;
  plastpaase_nn_1 = mkN "plastpеse" utrum ;
  plastrong_nn_1 = mkN "plastrong" "plastronger" ;
  plastspiral_nn_1 = mkN "plastspiral" "plastspiraler" ;
  plataa_nn_1 = mkN "platе" "platеer" ;
  plataagupp_nn_1 = mkN "platеgupp" neutrum ;
  platan_nn_1 = mkN "platan" "plataner" ;
  platinablond_av_1 = mkA "platinablond" ;
  platoniker_nn_1 = mkN "platoniker" "platonikern" "platoniker" "platonikerna" ;
  platonisk_av_1 = mkA "platonisk" ;
  platonsk_av_1 = mkA "platonsk" ;
  plats_nn_1 = mkN "plats" "platser" ;
  platsansoekning_nn_1 = mkN "platsansцkning" ;
  platsbiljett_nn_1 = mkN "platsbiljett" "platsbiljetter" ;
  platschef_nn_1 = mkN "platschef" "platschefer" ;
  platssiffra_nn_1 = mkN "platssiffra" ;
  platssoekande_av_1 = mkA "platssцkande" ;
  platt_ab_1 = mkAdv "platt" ;
  platt_av_1 = mkA "platt" ;
  platt_teve_nn_1 = mkN "platt-teve" "platt-teven" "platt-teve" "platt-tevena" ;
  plattfisk_nn_1 = mkN "plattfisk" ;
  plattform_nn_1 = mkN "plattform" ;
  platthet_nn_1 = mkN "platthet" "plattheter" ;
  platting_nn_1 = mkN "platting" ;
  plattityd_nn_1 = mkN "plattityd" "plattityder" ;
  plattjaern_nn_1 = mkN "plattjдrn" neutrum ;
  plattlaeggning_nn_1 = mkN "plattlдggning" ;
  plattlaeggningsproblem_nn_1 = mkN "plattlдggningsproblem" neutrum ;
  plattmask_nn_1 = mkN "plattmask" ;
  plattsoem_nn_1 = mkN "plattsцm" "plattsцmmen" "plattsцmmar" "plattsцmmarna" ;
  plattysk_av_1 = mkA "plattysk" ;
  plausibel_av_1 = mkA "plausibel" "plausibelt" "plausibla" "plausibla" "plausiblare" "plausiblast" "plausiblaste" ;
  play_off_nn_1 = mkN "play-off" neutrum ;
  playboy_nn_1 = mkN "playboy" ;
  plebej_nn_1 = mkN "plebej" "plebejer" ;
  plebejisk_av_1 = mkA "plebejisk" ;
  plebiscit_nn_1 = mkN "plebiscit" neutrum ;
  plejad_nn_1 = mkN "plejad" "plejader" ;
  plektrum_nn_1 = mkN "plektrum" neutrum ;
  plenimaal_nn_1 = mkN "plenimеl" neutrum ;
  plenum_nn_1 = mkN "plenum" neutrum ;
  pleonasm_nn_1 = mkN "pleonasm" "pleonasmer" ;
  pleonastisk_av_1 = mkA "pleonastisk" ;
  plesiosaurie_nn_1 = mkN "plesiosaurie" "plesiosaurier" ;
  pleurit_nn_1 = mkN "pleurit" "pleuriter" ;
  pligg_nn_1 = mkN "pligg" ;
  plikt_nn_1 = mkN "plikt" "plikter" ;
  pliktexemplar_nn_1 = mkN "pliktexemplar" neutrum ;
  pliktfoergaeten_av_1 = mkA "pliktfцrgдten" "pliktfцrgдtet" ;
  plikthuggare_nn_1 = mkN "plikthuggare" "plikthuggare" ;
  pliktig_av_1 = mkA "pliktig" ;
  pliktmedveten_av_1 = mkA "pliktmedveten" "pliktmedvetet" ;
  pliktskyldig_av_1 = mkA "pliktskyldig" ;
  plikttrogen_av_1 = mkA "plikttrogen" "plikttroget" ;
  pling_nn_1 = mkN "pling" neutrum ;
  plint_nn_1 = mkN "plint" ;
  plirig_av_1 = mkA "plirig" ;
  plisse_nn_1 = mkN "plissй" "plissйer" ;
  plister_nn_1 = mkN "plister" ;
  plit_nn_2 = mkN "plit" ;
  plockare_nn_1 = mkN "plockare" "plockare" ;
  plockig_av_1 = mkA "plockig" ;
  ploejning_nn_1 = mkN "plцjning" ;
  ploes_nn_1 = mkN "plцs" ;
  ploetslig_av_1 = mkA "plцtslig" ;
  ploetsligen_ab_1 = mkAdv "plцtsligen" ;
  plog_nn_1 = mkN "plog" ;
  plogben_nn_1 = mkN "plogben" neutrum ;
  plogbill_nn_1 = mkN "plogbill" ;
  ploj_nn_1 = mkN "ploj" ;
  plomb_nn_1 = mkN "plomb" "plomber" ;
  plommon_nn_1 = mkN "plommon" neutrum ;
  plommonstop_nn_1 = mkN "plommonstop" neutrum ;
  plottrig_av_1 = mkA "plottrig" ;
  plufsig_av_1 = mkA "plufsig" ;
  plugg_nn_1 = mkN "plugg" neutrum ;
  plugg_nn_2 = mkN "plugg" ;
  pluggaemne_nn_1 = mkN "pluggдmne" ;
  plugghaest_nn_1 = mkN "plugghдst" ;
  pluggskivling_nn_1 = mkN "pluggskivling" ;
  plump_av_1 = mkA "plump" ;
  plump_nn_1 = mkN "plump" ;
  plumpudding_nn_1 = mkN "plumpudding" ;
  plums_nn_1 = mkN "plums" ;
  plundring_nn_1 = mkN "plundring" ;
  plural_av_1 = mkA "plural" ;
  plural_nn_1 = mkN "plural" "pluraler" ;
  pluralistisk_av_1 = mkA "pluralistisk" ;
  pluralitet_nn_1 = mkN "pluralitet" "pluraliteter" ;
  pluring_nn_1 = mkN "pluring" ;
  plusgrad_nn_1 = mkN "plusgrad" "plusgrader" ;
  pluskvamperfektum_nn_1 = mkN "pluskvamperfektum" "pluskvamperfektet" "pluskvamperfekter" "pluskvamperfekterna" ;
  pluspol_nn_1 = mkN "pluspol" "pluspoler" ;
  plussig_av_1 = mkA "plussig" ;
  plustecken_nn_1 = mkN "plustecken" "plustecknet" "plustecken" "plustecknen" ;
  plutokrat_nn_1 = mkN "plutokrat" "plutokrater" ;
  plutokrati_nn_1 = mkN "plutokrati" "plutokratier" ;
  pluton_nn_1 = mkN "pluton" "plutoner" ;
  plutonisk_av_1 = mkA "plutonisk" ;
  plutt_nn_1 = mkN "plutt" ;
  pluttig_av_1 = mkA "pluttig" ;
  pluvial_av_1 = mkA "pluvial" ;
  pluvialperiod_nn_1 = mkN "pluvialperiod" "pluvialperioder" ;
  plym_nn_1 = mkN "plym" "plymer" ;
  plymaa_nn_1 = mkN "plymе" "plymеer" ;
  plymasch_nn_1 = mkN "plymasch" "plymascher" ;
  plysch_nn_1 = mkN "plysch" "plyscher" ;
  plysmaskin_nn_1 = mkN "plysmaskin" "plysmaskiner" ;
  pneumatisk_av_1 = mkA "pneumatisk" ;
  pneumoni_nn_1 = mkN "pneumoni" "pneumonier" ;
  poaeng_nn_1 = mkN "poдng" neutrum ;
  poaeng_nn_2 = mkN "poдng" "poдnger" ;
  poaengloes_av_1 = mkA "poдnglцs" ;
  poaengseger_nn_1 = mkN "poдngseger" ;
  poaengtips_nn_1 = mkN "poдngtips" neutrum ;
  pocket_nn_1 = mkN "pocket" ;
  pocketbok_nn_1 = mkN "pocketbok" "pocketbцcker" ;
  podest_nn_1 = mkN "podest" "podester" ;
  podium_nn_1 = mkN "podium" "podiet" "podier" "podierna" ;
  poel_nn_1 = mkN "pцl" ;
  poelsig_av_1 = mkA "pцlsig" ;
  poem_nn_1 = mkN "poem" neutrum ;
  poes_nn_1 = mkN "pцs" neutrum ;
  poesi_nn_1 = mkN "poesi" "poesier" ;
  poesig_av_1 = mkA "pцsig" ;
  poesmunk_nn_1 = mkN "pцsmunk" ;
  poet_nn_1 = mkN "poet" "poeter" ;
  poetisk_av_1 = mkA "poetisk" ;
  pogrom_nn_1 = mkN "pogrom" "pogromer" ;
  pointer_nn_1 = mkN "pointer" ;
  pojkaktig_av_1 = mkA "pojkaktig" ;
  pojkbok_nn_1 = mkN "pojkbok" "pojkbцcker" ;
  pojkbyting_nn_1 = mkN "pojkbyting" ;
  pojkcykel_nn_1 = mkN "pojkcykel" ;
  pojke_nn_1 = mkN "pojke" utrum ;
  pojkfnasker_nn_1 = mkN "pojkfnasker" ;
  pojknamn_nn_1 = mkN "pojknamn" neutrum ;
  pojkskildring_nn_1 = mkN "pojkskildring" ;
  pojkspoling_nn_1 = mkN "pojkspoling" ;
  pojkstreck_nn_1 = mkN "pojkstreck" neutrum ;
  pojkvaen_nn_1 = mkN "pojkvдn" "pojkvдnnen" "pojkvдnner" "pojkvдnnerna" ;
  pojkvasker_nn_1 = mkN "pojkvasker" "pojkvaskeren" "pojkvaskerar" "pojkvaskerarna" ;
  pokal_nn_1 = mkN "pokal" "pokaler" ;
  pol_nn_1 = mkN "pol" "poler" ;
  polack_nn_1 = mkN "polack" "polacker" ;
  polaer_av_1 = mkA "polдr" ;
  polar_av_1 = mkA "polar" ;
  polare_nn_1 = mkN "polare" "polare" ;
  polarexpedition_nn_1 = mkN "polarexpedition" "polarexpeditioner" ;
  polarflyg_nn_1 = mkN "polarflyg" neutrum ;
  polarforskning_nn_1 = mkN "polarforskning" ;
  polarfront_nn_1 = mkN "polarfront" "polarfronter" ;
  polarhav_nn_1 = mkN "polarhav" neutrum ;
  polarisation_nn_1 = mkN "polarisation" "polarisationer" ;
  polarisationsfilter_nn_1 = mkN "polarisationsfilter" neutrum ;
  polarisator_nn_1 = mkN "polarisator" "polarisatorer" ;
  polarisering_nn_1 = mkN "polarisering" ;
  polaritet_nn_1 = mkN "polaritet" "polariteter" ;
  polarmiljoe_nn_1 = mkN "polarmiljц" "polarmiljцn" "polarmiljцer" "polarmiljцerna" ;
  polaroidfilm_nn_1 = mkN "polaroidfilm" "polaroidfilmer" ;
  polaroidkamera_nn_1 = mkN "polaroidkamera" ;
  polaromraade_nn_1 = mkN "polaromrеde" ;
  polarraev_nn_1 = mkN "polarrдv" ;
  polartrakt_nn_1 = mkN "polartrakt" "polartrakter" ;
  polcirkel_nn_1 = mkN "polcirkel" ;
  polder_nn_1 = mkN "polder" ;
  polemik_nn_1 = mkN "polemik" "polemiker" ;
  polemiker_nn_1 = mkN "polemiker" "polemikern" "polemiker" "polemikerna" ;
  polemisk_av_1 = mkA "polemisk" ;
  polentagryn_nn_1 = mkN "polentagryn" neutrum ;
  polermedel_nn_1 = mkN "polermedel" neutrum ;
  poliklinik_nn_1 = mkN "poliklinik" "polikliniker" ;
  poliklinisk_av_1 = mkA "poliklinisk" ;
  polis_nn_1 = mkN "polis" "poliser" ;
  polisarrest_nn_1 = mkN "polisarrest" "polisarrester" ;
  polisbefael_nn_1 = mkN "polisbefдl" neutrum ;
  polisbevakning_nn_1 = mkN "polisbevakning" ;
  polisbil_nn_1 = mkN "polisbil" ;
  polischef_nn_1 = mkN "polischef" "polischefer" ;
  polischock_nn_1 = mkN "polischock" "polischocker" ;
  polisdistrikt_nn_1 = mkN "polisdistrikt" neutrum ;
  polisfoerhoer_nn_1 = mkN "polisfцrhцr" neutrum ;
  polishund_nn_1 = mkN "polishund" ;
  polisiaer_av_1 = mkA "polisiдr" ;
  polisintendent_nn_1 = mkN "polisintendent" "polisintendenter" ;
  poliskommissarie_nn_1 = mkN "poliskommissarie" "poliskommissarier" ;
  poliskonstapel_nn_1 = mkN "poliskonstapel" ;
  poliskund_nn_1 = mkN "poliskund" "poliskunder" ;
  polismaestare_nn_1 = mkN "polismдstare" "polismдstare" ;
  polisman_nn_1 = mkN "polisman" "polismannen" "polismдn" "polismдnnen" ;
  polisong_nn_1 = mkN "polisong" "polisonger" ;
  polisorganisation_nn_1 = mkN "polisorganisation" "polisorganisationer" ;
  polisstat_nn_1 = mkN "polisstat" "polisstater" ;
  polisstation_nn_1 = mkN "polisstation" "polisstationer" ;
  polisstyrka_nn_1 = mkN "polisstyrka" ;
  polistjaenst_nn_1 = mkN "polistjдnst" "polistjдnster" ;
  polistjaensteman_nn_1 = mkN "polistjдnsteman" "polistjдnstemannen" "polistjдnstemдn" "polistjдnstemдnnen" ;
  polistjaenstgoering_nn_1 = mkN "polistjдnstgцring" ;
  polisundersoekning_nn_1 = mkN "polisundersцkning" ;
  polisvaesende_nn_1 = mkN "polisvдsende" ;
  politbyraa_nn_1 = mkN "politbyrе" "politbyrеer" ;
  politiker_nn_1 = mkN "politiker" "politikern" "politiker" "politikerna" ;
  politikus_nn_1 = mkN "politikus" ;
  politisk_av_1 = mkA "politisk" ;
  politruk_nn_1 = mkN "politruk" "politruker" ;
  polityr_nn_1 = mkN "polityr" "polityrer" ;
  polkagris_nn_1 = mkN "polkagris" ;
  polkett_nn_1 = mkN "polkett" "polketter" ;
  polkropp_nn_1 = mkN "polkropp" ;
  pollare_nn_1 = mkN "pollare" "pollare" ;
  pollenfynd_nn_1 = mkN "pollenfynd" neutrum ;
  pollenkorn_nn_1 = mkN "pollenkorn" neutrum ;
  pollenslang_nn_1 = mkN "pollenslang" ;
  pollett_nn_1 = mkN "pollett" "polletter" ;
  pollettering_nn_1 = mkN "pollettering" ;
  pollination_nn_1 = mkN "pollination" "pollinationer" ;
  pollinering_nn_1 = mkN "pollinering" ;
  pollution_nn_1 = mkN "pollution" "pollutioner" ;
  polokrage_nn_1 = mkN "polokrage" utrum ;
  polonaes_nn_1 = mkN "polonдs" "polonдser" ;
  polsk_av_1 = mkA "polsk" ;
  polsk_fransk_av_1 = mkA "polsk-fransk" ;
  polska_nn_2 = mkN "polska" ;
  polsko_nn_1 = mkN "polsko" "polskor" ;
  polyamid_nn_1 = mkN "polyamid" "polyamider" ;
  polyeder_nn_1 = mkN "polyeder" ;
  polyester_nn_1 = mkN "polyester" ;
  polyeter_nn_1 = mkN "polyeter" ;
  polyfon_av_1 = mkA "polyfon" ;
  polyfoni_nn_1 = mkN "polyfoni" "polyfonier" ;
  polygam_av_1 = mkA "polygam" ;
  polyglott_av_1 = mkA "polyglott" ;
  polyglott_nn_1 = mkN "polyglott" "polyglotter" ;
  polygon_nn_1 = mkN "polygon" "polygoner" ;
  polygraf_nn_1 = mkN "polygraf" "polygrafer" ;
  polyhistor_nn_1 = mkN "polyhistor" "polyhistorer" ;
  polykrom_av_1 = mkA "polykrom" ;
  polymer_nn_1 = mkN "polymer" "polymerer" ;
  polymerisation_nn_1 = mkN "polymerisation" "polymerisationer" ;
  polymorf_av_1 = mkA "polymorf" ;
  polynesier_nn_1 = mkN "polynesier" "polynesiern" "polynesier" "polynesierna" ;
  polynesisk_av_1 = mkA "polynesisk" ;
  polynom_nn_1 = mkN "polynom" neutrum ;
  polyp_nn_1 = mkN "polyp" "polyper" ;
  polysyndes_nn_1 = mkN "polysyndes" "polysyndeser" ;
  polyteknisk_av_1 = mkA "polyteknisk" ;
  pomerans_nn_1 = mkN "pomerans" "pomeranser" ;
  pomeransskal_nn_1 = mkN "pomeransskal" neutrum ;
  pommersk_av_1 = mkA "pommersk" ;
  pomolog_nn_1 = mkN "pomolog" "pomologer" ;
  pompoes_av_1 = mkA "pompцs" ;
  pompong_nn_1 = mkN "pompong" "pomponger" ;
  poncho_nn_1 = mkN "poncho" "ponchon" "ponchos" "ponchosen" ;
  pond_nn_1 = mkN "pond" neutrum ;
  ponderabel_av_1 = mkA "ponderabel" "ponderabelt" "ponderabla" "ponderabla" "ponderablare" "ponderablast" "ponderablaste" ;
  ponny_nn_1 = mkN "ponny" "ponnyn" "ponnies" "ponnyerna" ;
  pontifikat_nn_1 = mkN "pontifikat" neutrum ;
  ponton_nn_1 = mkN "ponton" "pontoner" ;
  pontonbro_nn_1 = mkN "pontonbro" ;
  pontonjaer_nn_1 = mkN "pontonjдr" "pontonjдrer" ;
  pool_nn_1 = mkN "pool" "pooler" ;
  pop_nn_2 = mkN "pop" "poper" ;
  popgrupp_nn_1 = mkN "popgrupp" "popgrupper" ;
  popkonsert_nn_1 = mkN "popkonsert" "popkonserter" ;
  poplin_nn_1 = mkN "poplin" "popliner" ;
  poplinrock_nn_1 = mkN "poplinrock" ;
  poppel_nn_1 = mkN "poppel" ;
  poppig_av_1 = mkA "poppig" ;
  poppis_av_1 = mkA "poppis" ;
  popsaangare_nn_1 = mkN "popsеngare" "popsеngare" ;
  populaer_av_1 = mkA "populдr" ;
  populaerkonsert_nn_1 = mkN "populдrkonsert" "populдrkonserter" ;
  populaervetenskaplig_av_1 = mkA "populдrvetenskaplig" ;
  popularisator_nn_1 = mkN "popularisator" "popularisatorer" ;
  popularitet_nn_1 = mkN "popularitet" "populariteter" ;
  population_nn_1 = mkN "population" "populationer" ;
  populist_nn_1 = mkN "populist" "populister" ;
  por_nn_1 = mkN "por" "poren" "porer" "porerna" ;
  porfyr_nn_1 = mkN "porfyr" "porfyrer" ;
  porig_av_1 = mkA "porig" ;
  pormask_nn_1 = mkN "pormask" ;
  pornografisk_av_1 = mkA "pornografisk" ;
  poroes_av_1 = mkA "porцs" ;
  porositet_nn_1 = mkN "porositet" "porositeter" ;
  porrig_av_1 = mkA "porrig" ;
  porrklubb_nn_1 = mkN "porrklubb" ;
  porrtidning_nn_1 = mkN "porrtidning" ;
  porslin_nn_1 = mkN "porslin" "porslinet" "porsliner" "porslinerna" ;
  porslinsdegel_nn_1 = mkN "porslinsdegel" ;
  porslinsfaerg_nn_1 = mkN "porslinsfдrg" "porslinsfдrger" ;
  porslinsfigur_nn_1 = mkN "porslinsfigur" "porslinsfigurer" ;
  porslinsfilter_nn_1 = mkN "porslinsfilter" neutrum ;
  porslinstillverkning_nn_1 = mkN "porslinstillverkning" ;
  porsvamp_nn_1 = mkN "porsvamp" ;
  port_nn_1 = mkN "port" ;
  portabel_av_1 = mkA "portabel" "portabelt" "portabla" "portabla" "portablare" "portablast" "portablaste" ;
  portal_nn_1 = mkN "portal" "portaler" ;
  portalfigur_nn_1 = mkN "portalfigur" "portalfigurer" ;
  portalgestalt_nn_1 = mkN "portalgestalt" "portalgestalter" ;
  portamento_nn_1 = mkN "portamento" "portamentot" "portamenton" "portamentona" ;
  portativ_av_1 = mkA "portativ" ;
  portepe_nn_1 = mkN "portepй" "portepйer" ;
  porter_nn_1 = mkN "porter" "portern" "porter" "porterna" ;
  portfoelj_nn_1 = mkN "portfцlj" "portfцljer" ;
  portfoerbjuda_vb_1 = mkV "portfцrbjuda" "portfцrbjцd" "portfцrbjudit" ;
  portfoerbud_nn_1 = mkN "portfцrbud" neutrum ;
  portgaang_nn_1 = mkN "portgеng" ;
  portiaer_nn_1 = mkN "portiдr" "portiдrer" ;
  portier_nn_1 = mkN "portier" "portierer" ;
  portik_nn_1 = mkN "portik" "portiker" ;
  portion_nn_1 = mkN "portion" "portioner" ;
  portklapp_nn_1 = mkN "portklapp" ;
  portmonnae_nn_1 = mkN "portmonnд" "portmonnдn" "portmonnдer" "portmonnдerna" ;
  porto_nn_1 = mkN "porto" "portot" "porton" "portona" ;
  portoer_nn_1 = mkN "portцr" "portцrer" ;
  portofri_av_1 = mkA "portofri" "portofritt" ;
  portraett_nn_1 = mkN "portrдtt" neutrum ;
  portraettlik_av_1 = mkA "portrдttlik" ;
  portraettoer_nn_1 = mkN "portrдttцr" "portrдttцrer" ;
  porttelefon_nn_1 = mkN "porttelefon" "porttelefoner" ;
  portugis_nn_1 = mkN "portugis" "portugiser" ;
  portugisisk_av_1 = mkA "portugisisk" ;
  portugisiska_nn_2 = mkN "portugisiska" ;
  portvakt_nn_1 = mkN "portvakt" "portvakter" ;
  portvin_nn_1 = mkN "portvin" "portvinet" "portviner" "portvinerna" ;
  portvinstaa_nn_1 = mkN "portvinstе" "portvinstеn" "portvinstеr" "portvinstеrna" ;
  pose_nn_1 = mkN "pose" "poser" ;
  posering_nn_1 = mkN "posering" ;
  position_nn_1 = mkN "position" "positioner" ;
  positiv_av_1 = mkA "positiv" ;
  positiv_nn_1 = mkN "positiv" neutrum ;
  positiv_nn_2 = mkN "positiv" "positiver" ;
  positivhalare_nn_1 = mkN "positivhalare" "positivhalare" ;
  positivist_nn_1 = mkN "positivist" "positivister" ;
  positivistisk_av_1 = mkA "positivistisk" ;
  positron_nn_1 = mkN "positron" "positroner" ;
  posoer_nn_1 = mkN "posцr" "posцrer" ;
  possession_nn_1 = mkN "possession" "possessioner" ;
  possessionat_nn_1 = mkN "possessionat" "possessionater" ;
  possessiv_av_1 = mkA "possessiv" ;
  post_nn_1 = mkN "post" "poster" ;
  postadress_nn_1 = mkN "postadress" "postadresser" ;
  postal_av_1 = mkA "postal" ;
  postament_nn_1 = mkN "postament" neutrum ;
  postanstalt_nn_1 = mkN "postanstalt" "postanstalter" ;
  postanvisning_nn_1 = mkN "postanvisning" ;
  postbox_nn_1 = mkN "postbox" ;
  poster_nn_1 = mkN "poster" ;
  postering_nn_1 = mkN "postering" ;
  postexpedition_nn_1 = mkN "postexpedition" "postexpeditioner" ;
  postfack_nn_1 = mkN "postfack" neutrum ;
  postfoersaendelse_nn_1 = mkN "postfцrsдndelse" "postfцrsдndelser" ;
  postfoerskott_nn_1 = mkN "postfцrskott" neutrum ;
  postgiro_nn_1 = mkN "postgiro" "postgirot" "postgiron" "postgirona" ;
  postgirokonto_nn_1 = mkN "postgirokonto" "postgirokontot" "postgirokonton" "postgirokontona" ;
  postglacial_av_1 = mkA "postglacial" ;
  postgymnasial_av_1 = mkA "postgymnasial" ;
  posthorn_nn_1 = mkN "posthorn" neutrum ;
  postiljon_nn_1 = mkN "postiljon" "postiljoner" ;
  postindustriell_av_1 = mkA "postindustriell" ;
  postisch_nn_1 = mkN "postisch" "postischer" ;
  postkontor_nn_1 = mkN "postkontor" neutrum ;
  postkort_nn_1 = mkN "postkort" neutrum ;
  postkupe_nn_1 = mkN "postkupй" "postkupйer" ;
  postludium_nn_1 = mkN "postludium" "postludiet" "postludier" "postludierna" ;
  postmaestare_nn_1 = mkN "postmдstare" "postmдstare" ;
  postnatal_av_1 = mkA "postnatal" ;
  postnummer_nn_1 = mkN "postnummer" neutrum ;
  posto_ab_1 = mkAdv "posto" ;
  postorderfoeretag_nn_1 = mkN "postorderfцretag" neutrum ;
  postposition_nn_1 = mkN "postposition" "postpositioner" ;
  postremissvaexel_nn_1 = mkN "postremissvдxel" ;
  postroest_nn_1 = mkN "postrцst" "postrцster" ;
  postseminarium_nn_1 = mkN "postseminarium" "postseminariet" "postseminarier" "postseminarierna" ;
  postskriptum_nn_1 = mkN "postskriptum" neutrum ;
  poststaempel_nn_1 = mkN "poststдmpel" ;
  poststation_nn_1 = mkN "poststation" "poststationer" ;
  posttjaensteman_nn_1 = mkN "posttjдnsteman" "posttjдnstemannen" "posttjдnstemдn" "posttjдnstemдnnen" ;
  postulat_nn_1 = mkN "postulat" neutrum ;
  postum_av_1 = mkA "postum" ;
  postutdelning_nn_1 = mkN "postutdelning" ;
  postvaexel_nn_1 = mkN "postvдxel" ;
  postverk_nn_1 = mkN "postverk" neutrum ;
  potage_nn_1 = mkN "potage" "potager" ;
  potatis_nn_1 = mkN "potatis" ;
  potatisliknande_av_1 = mkA "potatisliknande" ;
  potatispure_nn_1 = mkN "potatispurй" "potatispurйer" ;
  potatissallad_nn_1 = mkN "potatissallad" "potatissallader" ;
  potatisvaext_nn_1 = mkN "potatisvдxt" "potatisvдxter" ;
  potemkinkuliss_nn_1 = mkN "potemkinkuliss" "potemkinkulisser" ;
  potens_nn_1 = mkN "potens" "potenser" ;
  potent_av_1 = mkA "potent" "potent" ;
  potentat_nn_1 = mkN "potentat" "potentater" ;
  potential_nn_1 = mkN "potential" "potentialer" ;
  potentiell_av_1 = mkA "potentiell" ;
  potentiometer_nn_1 = mkN "potentiometer" ;
  potpurri_nn_1 = mkN "potpurri" "potpurrit" "potpurrier" "potpurrierna" ;
  pott_nn_1 = mkN "pott" "potter" ;
  poulard_nn_1 = mkN "poulard" "poularder" ;
  praalig_av_1 = mkA "prеlig" ;
  praam_nn_1 = mkN "prеm" ;
  praang_nn_1 = mkN "prеng" neutrum ;
  praangleri_nn_1 = mkN "prеngleri" "prеnglerit" "prеnglerier" "prеnglerierna" ;
  praegel_nn_1 = mkN "prдgel" ;
  praegelvaerde_nn_1 = mkN "prдgelvдrde" ;
  praegling_nn_1 = mkN "prдgling" ;
  praektig_av_1 = mkA "prдktig" ;
  praelle_nn_1 = mkN "prдlle" utrum ;
  praent_nn_1 = mkN "prдnt" neutrum ;
  praerie_nn_1 = mkN "prдrie" "prдrier" ;
  praeriehund_nn_1 = mkN "prдriehund" ;
  praerievarg_nn_1 = mkN "prдrievarg" ;
  praest_nn_1 = mkN "prдst" "prдster" ;
  praestbetyg_nn_1 = mkN "prдstbetyg" neutrum ;
  praestdraekt_nn_1 = mkN "prдstdrдkt" "prдstdrдkter" ;
  praesterlig_av_1 = mkA "prдsterlig" ;
  praestgaard_nn_1 = mkN "prдstgеrd" ;
  praestgaardslaenstol_nn_1 = mkN "prдstgеrdslдnstol" ;
  praestgaell_nn_1 = mkN "prдstgдll" neutrum ;
  praestinna_nn_1 = mkN "prдstinna" ;
  praestkrage_nn_1 = mkN "prдstkrage" utrum ;
  praestman_nn_1 = mkN "prдstman" "prдstmannen" "prдstmдn" "prдstmдnnen" ;
  praestost_nn_1 = mkN "prдstost" ;
  praestrock_nn_1 = mkN "prдstrock" ;
  praestskrud_nn_1 = mkN "prдstskrud" ;
  praesttillsaettning_nn_1 = mkN "prдsttillsдttning" ;
  praestvaelde_nn_1 = mkN "prдstvдlde" ;
  praestvigning_nn_1 = mkN "prдstvigning" ;
  pragmatiker_nn_1 = mkN "pragmatiker" "pragmatikern" "pragmatiker" "pragmatikerna" ;
  pragmatisk_av_1 = mkA "pragmatisk" ;
  prakrit_nn_1 = mkN "prakrit" "prakriter" ;
  praktbaegare_nn_1 = mkN "praktbдgare" "praktbдgare" ;
  praktbagge_nn_1 = mkN "praktbagge" utrum ;
  praktexempel_nn_1 = mkN "praktexempel" neutrum ;
  praktfull_av_1 = mkA "praktfull" ;
  praktikabel_av_1 = mkA "praktikabel" "praktikabelt" "praktikabla" "praktikabla" "praktikablare" "praktikablast" "praktikablaste" ;
  praktikant_nn_1 = mkN "praktikant" "praktikanter" ;
  praktiker_nn_1 = mkN "praktiker" "praktikern" "praktiker" "praktikerna" ;
  praktiktjaenstgoering_nn_1 = mkN "praktiktjдnstgцring" ;
  praktisk_av_1 = mkA "praktisk" ;
  praktmaalning_nn_1 = mkN "praktmеlning" ;
  praktpjaes_nn_1 = mkN "praktpjдs" "praktpjдser" ;
  praktverk_nn_1 = mkN "praktverk" neutrum ;
  pralin_nn_1 = mkN "pralin" "praliner" ;
  pratbubbla_nn_1 = mkN "pratbubbla" ;
  pratig_av_1 = mkA "pratig" ;
  pratkvarn_nn_1 = mkN "pratkvarn" ;
  pratmakare_nn_1 = mkN "pratmakare" "pratmakare" ;
  pratsam_av_1 = mkA "pratsam" "pratsamt" "pratsamma" "pratsamma" "pratsammare" "pratsammast" "pratsammaste" ;
  pratsjuk_av_1 = mkA "pratsjuk" ;
  prebende_nn_1 = mkN "prebende" ;
  precedensfall_nn_1 = mkN "precedensfall" neutrum ;
  preceptor_nn_1 = mkN "preceptor" "preceptorer" ;
  preceptur_nn_1 = mkN "preceptur" "precepturer" ;
  precioes_av_1 = mkA "preciцs" ;
  preciosa_nn_1 = mkN "preciosa" "preciosan" "preciosa" "preciosana" ;
  preciositet_nn_1 = mkN "preciositet" "preciositeter" ;
  precis_ab_1 = mkAdv "precis" ;
  precisionsroerelse_nn_1 = mkN "precisionsrцrelse" "precisionsrцrelser" ;
  predator_nn_1 = mkN "predator" "predatorer" ;
  predikament_nn_1 = mkN "predikament" neutrum ;
  predikant_nn_1 = mkN "predikant" "predikanter" ;
  predikare_nn_1 = mkN "predikare" "predikare" ;
  predikat_nn_1 = mkN "predikat" neutrum ;
  predikativ_av_1 = mkA "predikativ" ;
  predikativ_nn_1 = mkN "predikativ" neutrum ;
  predikatlogisk_av_1 = mkA "predikatlogisk" ;
  predikatsfyllnad_nn_1 = mkN "predikatsfyllnad" "predikatsfyllnader" ;
  predikning_nn_1 = mkN "predikning" ;
  predikokonst_nn_1 = mkN "predikokonst" "predikokonster" ;
  predikosamling_nn_1 = mkN "predikosamling" ;
  predikotext_nn_1 = mkN "predikotext" "predikotexter" ;
  predikotur_nn_1 = mkN "predikotur" "predikoturer" ;
  predikstol_nn_1 = mkN "predikstol" ;
  prefekt_nn_1 = mkN "prefekt" "prefekter" ;
  prefektur_nn_1 = mkN "prefektur" "prefekturer" ;
  preferens_nn_1 = mkN "preferens" "preferenser" ;
  preferensaktie_nn_1 = mkN "preferensaktie" "preferensaktier" ;
  prefix_nn_1 = mkN "prefix" neutrum ;
  preglacial_av_1 = mkA "preglacial" ;
  pregnant_av_1 = mkA "pregnant" "pregnant" ;
  prehistorisk_av_1 = mkA "prehistorisk" ;
  prejudicerande_av_1 = mkA "prejudicerande" ;
  prejudikat_nn_1 = mkN "prejudikat" neutrum ;
  prekaer_av_1 = mkA "prekдr" ;
  prelat_nn_1 = mkN "prelat" "prelater" ;
  preliminaer_av_1 = mkA "preliminдr" ;
  preludium_nn_1 = mkN "preludium" "preludiet" "preludier" "preludierna" ;
  premiaer_nn_1 = mkN "premiдr" "premiдrer" ;
  premiaerminister_nn_1 = mkN "premiдrminister" ;
  premie_nn_1 = mkN "premie" "premier" ;
  premiebetalare_nn_1 = mkN "premiebetalare" "premiebetalare" ;
  premiegill_av_1 = mkA "premiegill" ;
  premielaan_nn_1 = mkN "premielеn" neutrum ;
  premieobligation_nn_1 = mkN "premieobligation" "premieobligationer" ;
  premiss_nn_1 = mkN "premiss" "premisser" ;
  premium_nn_1 = mkN "premium" "premiet" "premier" "premierna" ;
  premolar_nn_1 = mkN "premolar" "premolarer" ;
  prenatal_av_1 = mkA "prenatal" ;
  prenumerant_nn_1 = mkN "prenumerant" "prenumeranter" ;
  prenumeration_nn_1 = mkN "prenumeration" "prenumerationer" ;
  preparand_nn_1 = mkN "preparand" "preparander" ;
  preparat_nn_1 = mkN "preparat" neutrum ;
  preparation_nn_1 = mkN "preparation" "preparationer" ;
  preparator_nn_1 = mkN "preparator" "preparatorer" ;
  preparatris_nn_1 = mkN "preparatris" "preparatriser" ;
  preposition_nn_1 = mkN "preposition" "prepositioner" ;
  prepositionell_av_1 = mkA "prepositionell" ;
  prepositionskasus_nn_1 = mkN "prepositionskasus" neutrum ;
  prepositionsuttryck_nn_1 = mkN "prepositionsuttryck" neutrum ;
  prerogativ_nn_1 = mkN "prerogativ" neutrum ;
  presbyter_nn_1 = mkN "presbyter" "presbytern" "presbyterer" "presbytererna" ;
  presbyterian_nn_1 = mkN "presbyterian" "presbyterianer" ;
  presenning_nn_1 = mkN "presenning" ;
  presens_nn_1 = mkN "presens" neutrum ;
  presensparticip_nn_1 = mkN "presensparticip" neutrum ;
  present_av_1 = mkA "present" "present" ;
  present_nn_1 = mkN "present" "presenter" ;
  presentabel_av_1 = mkA "presentabel" "presentabelt" "presentabla" "presentabla" "presentablare" "presentablast" "presentablaste" ;
  presentation_nn_1 = mkN "presentation" "presentationer" ;
  presentatoer_nn_1 = mkN "presentatцr" "presentatцrer" ;
  presentkort_nn_1 = mkN "presentkort" neutrum ;
  preservativ_nn_1 = mkN "preservativ" neutrum ;
  preses_nn_1 = mkN "preses" "preses" "presides" "presesarna" ;
  president_nn_1 = mkN "president" "presidenter" ;
  presidentskap_nn_1 = mkN "presidentskap" "presidentskapet" "presidentskapen" "presidentskapena" ;
  presidentur_nn_1 = mkN "presidentur" "presidenturer" ;
  presidentval_nn_1 = mkN "presidentval" neutrum ;
  presidium_nn_1 = mkN "presidium" "presidiet" "presidier" "presidierna" ;
  preskription_nn_1 = mkN "preskription" "preskriptioner" ;
  preskriptionstid_nn_1 = mkN "preskriptionstid" "preskriptionstider" ;
  press_nn_1 = mkN "press" ;
  pressare_nn_1 = mkN "pressare" "pressare" ;
  presschef_nn_1 = mkN "presschef" "presschefer" ;
  presseri_nn_1 = mkN "presseri" "presserit" "presserier" "presserierna" ;
  pressfotograf_nn_1 = mkN "pressfotograf" "pressfotografer" ;
  pressgranne_nn_1 = mkN "pressgranne" utrum ;
  pressjaern_nn_1 = mkN "pressjдrn" neutrum ;
  presskommissarie_nn_1 = mkN "presskommissarie" "presskommissarier" ;
  presskonferens_nn_1 = mkN "presskonferens" "presskonferenser" ;
  presskort_nn_1 = mkN "presskort" neutrum ;
  presslaeggning_nn_1 = mkN "presslдggning" ;
  presslaektare_nn_1 = mkN "presslдktare" "presslдktare" ;
  pressmaskin_nn_1 = mkN "pressmaskin" "pressmaskiner" ;
  pressmottagning_nn_1 = mkN "pressmottagning" ;
  pressning_nn_1 = mkN "pressning" ;
  pressorgan_nn_1 = mkN "pressorgan" neutrum ;
  pressrelease_nn_1 = mkN "pressrelease" "pressreleaser" ;
  pressrevider_nn_1 = mkN "pressrevider" "pressrevideret" "pressrevider" "pressrevideren" ;
  presstopp_nn_1 = mkN "presstopp" neutrum ;
  pressveck_nn_1 = mkN "pressveck" neutrum ;
  prestanda_nn_1 = mkN "prestanda" "prestandan" "prestanda" "prestandana" ;
  prestation_nn_1 = mkN "prestation" "prestationer" ;
  prestav_nn_1 = mkN "prestav" "prestaver" ;
  presto_ab_1 = mkAdv "presto" ;
  presto_nn_1 = mkN "presto" "prestot" "preston" "prestona" ;
  presumtiv_av_1 = mkA "presumtiv" ;
  pretendent_nn_1 = mkN "pretendent" "pretendenter" ;
  pretentioes_av_1 = mkA "pretentiцs" ;
  pretention_nn_1 = mkN "pretention" "pretentioner" ;
  preteritum_nn_1 = mkN "preteritum" "preteritum" "preteriter" "preteriterna" ;
  pretext_nn_1 = mkN "pretext" "pretexter" ;
  pretioes_av_1 = mkA "pretiцs" ;
  pretiosa_nn_1 = mkN "pretiosa" "pretiosan" "pretiosa" "pretiosana" ;
  pretiositet_nn_1 = mkN "pretiositet" "pretiositeter" ;
  pretor_nn_1 = mkN "pretor" "pretorer" ;
  pretorian_nn_1 = mkN "pretorian" "pretorianer" ;
  pretto_nn_1 = mkN "pretto" "prettot" "pretton" "prettona" ;
  preussare_nn_1 = mkN "preussare" "preussare" ;
  preussisk_av_1 = mkA "preussisk" ;
  preventiv_av_1 = mkA "preventiv" ;
  preventivkrig_nn_1 = mkN "preventivkrig" neutrum ;
  preventivmedel_nn_1 = mkN "preventivmedel" neutrum ;
  prick_ab_1 = mkAdv "prick" ;
  prick_nn_1 = mkN "prick" ;
  prickare_nn_1 = mkN "prickare" "prickare" ;
  prickfri_av_1 = mkA "prickfri" "prickfritt" ;
  prickig_av_1 = mkA "prickig" ;
  pricksaeker_av_1 = mkA "pricksдker" "pricksдkert" "pricksдkra" "pricksдkra" "pricksдkrare" "pricksдkrast" "pricksдkraste" ;
  prickskytt_nn_1 = mkN "prickskytt" ;
  prillig_av_1 = mkA "prillig" ;
  prim_nn_1 = mkN "prim" "primer" ;
  prima_av_1 = mkA "prima" ;
  primaer_av_1 = mkA "primдr" ;
  primaergrupp_nn_1 = mkN "primдrgrupp" "primдrgrupper" ;
  primaerkommun_nn_1 = mkN "primдrkommun" "primдrkommuner" ;
  primaerkredit_nn_1 = mkN "primдrkredit" "primдrkrediter" ;
  primaerlaan_nn_1 = mkN "primдrlеn" neutrum ;
  primaerminne_nn_1 = mkN "primдrminne" ;
  primaerval_nn_1 = mkN "primдrval" neutrum ;
  primalskrik_nn_1 = mkN "primalskrik" neutrum ;
  primarie_nn_1 = mkN "primarie" "primarier" ;
  primat_nn_2 = mkN "primat" "primater" ;
  primfaktor_nn_1 = mkN "primfaktor" "primfaktorer" ;
  primitiv_av_1 = mkA "primitiv" ;
  primitivistisk_av_1 = mkA "primitivistisk" ;
  primitivitet_nn_1 = mkN "primitivitet" "primitiviteter" ;
  primoer_nn_1 = mkN "primцr" "primцrer" ;
  primtal_nn_1 = mkN "primtal" "primtalet" "primtalen" "primtalena" ;
  primuskoek_nn_1 = mkN "primuskцk" neutrum ;
  princip_nn_1 = mkN "princip" "principer" ;
  principal_nn_1 = mkN "principal" "principaler" ;
  principfast_av_1 = mkA "principfast" "principfast" ;
  principfoerklaring_nn_1 = mkN "principfцrklaring" ;
  principiell_av_1 = mkA "principiell" ;
  principmaenniska_nn_1 = mkN "principmдnniska" ;
  principprogram_nn_1 = mkN "principprogram" "principprogrammet" "principprogram" "principprogrammen" ;
  principryttare_nn_1 = mkN "principryttare" "principryttare" ;
  prins_nn_1 = mkN "prins" ;
  prinsessklaenning_nn_1 = mkN "prinsessklдnning" ;
  prinsgemaal_nn_1 = mkN "prinsgemеl" "prinsgemеler" ;
  prinskorv_nn_1 = mkN "prinskorv" ;
  prinsregent_nn_1 = mkN "prinsregent" "prinsregenter" ;
  prior_nn_1 = mkN "prior" "priorer" ;
  priorinna_nn_1 = mkN "priorinna" ;
  prioritet_nn_1 = mkN "prioritet" "prioriteter" ;
  pris_nn_1 = mkN "pris" neutrum ;
  pris_nn_3 = mkN "pris" "priser" ;
  pris_nn_4 = mkN "pris" ;
  prisbillig_av_1 = mkA "prisbillig" ;
  prisbomb_nn_1 = mkN "prisbomb" "prisbomber" ;
  prisboxare_nn_1 = mkN "prisboxare" "prisboxare" ;
  prischock_nn_1 = mkN "prischock" "prischocker" ;
  priselasticitet_nn_1 = mkN "priselasticitet" "priselasticiteter" ;
  prisfall_nn_1 = mkN "prisfall" neutrum ;
  prisfoeraendring_nn_1 = mkN "prisfцrдndring" ;
  prisge_vb_1 = mkV "prisge" "prisger" "prisge" "prisgav" "prisgett" "prisgiven" ;
  prishoejning_nn_1 = mkN "prishцjning" ;
  priskrig_nn_1 = mkN "priskrig" neutrum ;
  priskurant_nn_1 = mkN "priskurant" "priskuranter" ;
  prislapp_nn_1 = mkN "prislapp" ;
  prisma_nn_1 = mkN "prisma" ;
  prismakikare_nn_1 = mkN "prismakikare" "prismakikare" ;
  prismatisk_av_1 = mkA "prismatisk" ;
  prismedveten_av_1 = mkA "prismedveten" "prismedvetet" ;
  prisnivaa_nn_1 = mkN "prisnivе" "prisnivеer" ;
  prisoekning_nn_1 = mkN "prisцkning" ;
  prisreglering_nn_1 = mkN "prisreglering" ;
  prissaettning_nn_1 = mkN "prissдttning" ;
  prisse_nn_1 = mkN "prisse" utrum ;
  prissensation_nn_1 = mkN "prissensation" "prissensationer" ;
  prisstegring_nn_1 = mkN "prisstegring" ;
  prisstopp_nn_1 = mkN "prisstopp" neutrum ;
  pristaevling_nn_1 = mkN "pristдvling" ;
  pristagare_nn_1 = mkN "pristagare" "pristagare" ;
  pristak_nn_1 = mkN "pristak" neutrum ;
  prisvaerd_av_1 = mkA "prisvдrd" "prisvдrt" ;
  prisvariation_nn_1 = mkN "prisvariation" "prisvariationer" ;
  privat_av_1 = mkA "privat" "privat" ;
  privataegd_av_1 = mkA "privatдgd" "privatдgt" ;
  privatbank_nn_1 = mkN "privatbank" "privatbanker" ;
  privatbil_nn_1 = mkN "privatbil" ;
  privatdetektiv_nn_1 = mkN "privatdetektiv" "privatdetektiver" ;
  privatdiskontoer_nn_1 = mkN "privatdiskontцr" "privatdiskontцrer" ;
  privatekonomisk_av_1 = mkA "privatekonomisk" ;
  privatim_ab_1 = mkAdv "privatim" ;
  privatist_nn_1 = mkN "privatist" "privatister" ;
  privatkapital_nn_1 = mkN "privatkapital" neutrum ;
  privatlaan_nn_1 = mkN "privatlеn" neutrum ;
  privatlaekare_nn_1 = mkN "privatlдkare" "privatlдkare" ;
  privatlaerare_nn_1 = mkN "privatlдrare" "privatlдrare" ;
  privatlektion_nn_1 = mkN "privatlektion" "privatlektioner" ;
  privatman_nn_1 = mkN "privatman" "privatmannen" "privatmдn" "privatmдnnen" ;
  privatperson_nn_1 = mkN "privatperson" "privatpersoner" ;
  privatpraktiker_nn_1 = mkN "privatpraktiker" "privatpraktikern" "privatpraktiker" "privatpraktikerna" ;
  privatpraktiserande_av_1 = mkA "privatpraktiserande" ;
  privatsak_nn_1 = mkN "privatsak" "privatsaker" ;
  privatsekreterare_nn_1 = mkN "privatsekreterare" "privatsekreterare" ;
  privattryck_nn_1 = mkN "privattryck" neutrum ;
  privilegiebrev_nn_1 = mkN "privilegiebrev" neutrum ;
  privilegium_nn_1 = mkN "privilegium" "privilegiet" "privilegier" "privilegierna" ;
  probabel_av_1 = mkA "probabel" "probabelt" "probabla" "probabla" "probablare" "probablast" "probablaste" ;
  probabilistisk_av_1 = mkA "probabilistisk" ;
  probabilitet_nn_1 = mkN "probabilitet" "probabiliteter" ;
  probat_av_1 = mkA "probat" "probat" ;
  problem_nn_1 = mkN "problem" neutrum ;
  problematisk_av_1 = mkA "problematisk" ;
  problembarn_nn_1 = mkN "problembarn" neutrum ;
  problemfri_av_1 = mkA "problemfri" "problemfritt" ;
  problemstaellning_nn_1 = mkN "problemstдllning" ;
  procedur_nn_1 = mkN "procedur" "procedurer" ;
  procent_nn_1 = mkN "procent" "procenten" "procent" "procenten" ;
  procentare_nn_1 = mkN "procentare" "procentare" ;
  procentenhet_nn_1 = mkN "procentenhet" "procentenheter" ;
  procentisk_av_1 = mkA "procentisk" ;
  procentuell_av_1 = mkA "procentuell" ;
  procentvaerde_nn_1 = mkN "procentvдrde" ;
  process_nn_1 = mkN "process" "processer" ;
  processindustri_nn_1 = mkN "processindustri" "processindustrier" ;
  procession_nn_1 = mkN "procession" "processioner" ;
  processuell_av_1 = mkA "processuell" ;
  producent_nn_1 = mkN "producent" "producenter" ;
  produkt_nn_1 = mkN "produkt" "produkter" ;
  produktion_nn_1 = mkN "produktion" "produktioner" ;
  produktionsapparat_nn_1 = mkN "produktionsapparat" "produktionsapparater" ;
  produktionsfaktor_nn_1 = mkN "produktionsfaktor" "produktionsfaktorer" ;
  produktionsfoerhaallande_nn_1 = mkN "produktionsfцrhеllande" ;
  produktionsmedel_nn_1 = mkN "produktionsmedel" neutrum ;
  produktionsskatt_nn_1 = mkN "produktionsskatt" "produktionsskatter" ;
  produktionsteknik_nn_1 = mkN "produktionsteknik" "produktionstekniker" ;
  produktiv_av_1 = mkA "produktiv" ;
  produktivitet_nn_1 = mkN "produktivitet" "produktiviteter" ;
  produktivkraft_nn_1 = mkN "produktivkraft" "produktivkrafter" ;
  produktmaengd_nn_1 = mkN "produktmдngd" "produktmдngder" ;
  proevande_av_1 = mkA "prцvande" ;
  proevning_nn_1 = mkN "prцvning" ;
  proevostund_nn_1 = mkN "prцvostund" "prцvostunder" ;
  proevotid_nn_1 = mkN "prцvotid" "prцvotider" ;
  profan_av_1 = mkA "profan" ;
  profanation_nn_1 = mkN "profanation" "profanationer" ;
  profession_nn_1 = mkN "profession" "professioner" ;
  professionell_av_1 = mkA "professionell" ;
  professor_nn_1 = mkN "professor" "professorer" ;
  professorlig_av_1 = mkA "professorlig" ;
  professur_nn_1 = mkN "professur" "professurer" ;
  profet_nn_1 = mkN "profet" "profeter" ;
  profetisk_av_1 = mkA "profetisk" ;
  proffs_nn_1 = mkN "proffs" neutrum ;
  proffsig_av_1 = mkA "proffsig" ;
  profil_nn_1 = mkN "profil" "profiler" ;
  profit_nn_1 = mkN "profit" "profiter" ;
  profithaj_nn_1 = mkN "profithaj" ;
  profitoer_nn_1 = mkN "profitцr" "profitцrer" ;
  profoss_nn_1 = mkN "profoss" "profosser" ;
  profylaktisk_av_1 = mkA "profylaktisk" ;
  prognat_av_1 = mkA "prognat" "prognat" ;
  prognos_nn_1 = mkN "prognos" "prognoser" ;
  prognostisk_av_1 = mkA "prognostisk" ;
  program_nn_1 = mkN "program" "programmet" "program" "programmen" ;
  programbudget_nn_1 = mkN "programbudget" ;
  programenlig_av_1 = mkA "programenlig" ;
  programland_nn_1 = mkN "programland" "programlandet" "programlдnder" "programlдnderna" ;
  programledare_nn_1 = mkN "programledare" "programledare" ;
  programmatisk_av_1 = mkA "programmatisk" ;
  programmerare_nn_1 = mkN "programmerare" "programmerare" ;
  programmeringsspraak_nn_1 = mkN "programmeringssprеk" neutrum ;
  programmotek_nn_1 = mkN "programmotek" neutrum ;
  programpunkt_nn_1 = mkN "programpunkt" "programpunkter" ;
  programskrift_nn_1 = mkN "programskrift" "programskrifter" ;
  programspraak_nn_1 = mkN "programsprеk" neutrum ;
  programutgivare_nn_1 = mkN "programutgivare" "programutgivare" ;
  programvaeljare_nn_1 = mkN "programvдljare" "programvдljare" ;
  progression_nn_1 = mkN "progression" "progressioner" ;
  progressiv_av_1 = mkA "progressiv" ;
  progressivitet_nn_1 = mkN "progressivitet" "progressiviteter" ;
  prohibitiv_av_1 = mkA "prohibitiv" ;
  proinsulin_nn_1 = mkN "proinsulin" "proinsuliner" ;
  projekt_nn_1 = mkN "projekt" neutrum ;
  projektil_nn_1 = mkN "projektil" "projektiler" ;
  projektion_nn_1 = mkN "projektion" "projektioner" ;
  projektionsapparat_nn_1 = mkN "projektionsapparat" "projektionsapparater" ;
  projektiv_av_1 = mkA "projektiv" ;
  projektoer_nn_1 = mkN "projektцr" "projektцrer" ;
  projektor_nn_1 = mkN "projektor" "projektorer" ;
  prokansler_nn_1 = mkN "prokansler" "prokanslern" "prokanslerer" "prokanslererna" ;
  proklamation_nn_1 = mkN "proklamation" "proklamationer" ;
  proklitisk_av_1 = mkA "proklitisk" ;
  prokrustesbaedd_nn_1 = mkN "prokrustesbдdd" ;
  prokrustisk_av_1 = mkA "prokrustisk" ;
  prokurator_nn_1 = mkN "prokurator" "prokuratorer" ;
  prokurist_nn_1 = mkN "prokurist" "prokurister" ;
  prolaktin_nn_1 = mkN "prolaktin" "prolaktiner" ;
  prolaps_nn_1 = mkN "prolaps" "prolapser" ;
  proletaer_av_1 = mkA "proletдr" ;
  proletaer_nn_1 = mkN "proletдr" "proletдrer" ;
  prolog_nn_1 = mkN "prolog" "prologer" ;
  prolongation_nn_1 = mkN "prolongation" "prolongationer" ;
  promenad_nn_1 = mkN "promenad" "promenader" ;
  promenadkaepp_nn_1 = mkN "promenadkдpp" ;
  promenadkonsert_nn_1 = mkN "promenadkonsert" "promenadkonserter" ;
  promenadseger_nn_1 = mkN "promenadseger" ;
  promenadstraak_nn_1 = mkN "promenadstrеk" neutrum ;
  promenoar_nn_1 = mkN "promenoar" "promenoarer" ;
  promille_nn_1 = mkN "promille" "promillen" "promille" "promillena" ;
  prominens_nn_1 = mkN "prominens" "prominenser" ;
  prominent_av_1 = mkA "prominent" "prominent" ;
  promiskuitet_nn_1 = mkN "promiskuitet" "promiskuiteter" ;
  promiskuoes_av_1 = mkA "promiskuцs" ;
  promotion_nn_1 = mkN "promotion" "promotioner" ;
  promotor_nn_1 = mkN "promotor" "promotorer" ;
  promovend_nn_1 = mkN "promovend" "promovender" ;
  prompt_ab_1 = mkAdv "prompt" ;
  promulgation_nn_1 = mkN "promulgation" "promulgationer" ;
  pronomen_nn_1 = mkN "pronomen" neutrum ;
  pronominal_av_1 = mkA "pronominal" ;
  pronominell_av_1 = mkA "pronominell" ;
  prononciation_nn_1 = mkN "prononciation" "prononciationer" ;
  propaa_nn_1 = mkN "propе" "propеer" ;
  propagandaminister_nn_1 = mkN "propagandaminister" ;
  propagandist_nn_1 = mkN "propagandist" "propagandister" ;
  propagandistisk_av_1 = mkA "propagandistisk" ;
  propedeutisk_av_1 = mkA "propedeutisk" ;
  propeller_nn_1 = mkN "propeller" ;
  propellerplan_nn_1 = mkN "propellerplan" neutrum ;
  proper_av_1 = mkA "proper" "propert" "propra" "propra" "proprare" "proprast" "propraste" ;
  proponent_nn_1 = mkN "proponent" "proponenter" ;
  proportion_nn_1 = mkN "proportion" "proportioner" ;
  proportional_nn_1 = mkN "proportional" "proportionaler" ;
  proportionalitet_nn_1 = mkN "proportionalitet" "proportionaliteter" ;
  proportionell_av_1 = mkA "proportionell" ;
  proportionerlig_av_1 = mkA "proportionerlig" ;
  proposition_nn_1 = mkN "proposition" "propositioner" ;
  propp_nn_1 = mkN "propp" ;
  proppfull_av_1 = mkA "proppfull" ;
  proppmaett_av_1 = mkA "proppmдtt" ;
  proppsaekring_nn_1 = mkN "proppsдkring" ;
  proprietaer_nn_1 = mkN "proprietдr" "proprietдrer" ;
  propyl_nn_1 = mkN "propyl" "propyler" ;
  propyle_nn_1 = mkN "propylй" "propylйer" ;
  prorektor_nn_1 = mkN "prorektor" "prorektorer" ;
  prorogation_nn_1 = mkN "prorogation" "prorogationer" ;
  prosadikt_nn_1 = mkN "prosadikt" "prosadikter" ;
  prosaisk_av_1 = mkA "prosaisk" ;
  prosaist_nn_1 = mkN "prosaist" "prosaister" ;
  proscenium_nn_1 = mkN "proscenium" "prosceniet" "proscenier" "proscenierna" ;
  prosektor_nn_1 = mkN "prosektor" "prosektorer" ;
  proselyt_nn_1 = mkN "proselyt" "proselyter" ;
  proseminarium_nn_1 = mkN "proseminarium" "proseminariet" "proseminarier" "proseminarierna" ;
  proskription_nn_1 = mkN "proskription" "proskriptioner" ;
  prosodi_nn_1 = mkN "prosodi" "prosodier" ;
  prosodisk_av_1 = mkA "prosodisk" ;
  prospekt_nn_1 = mkN "prospekt" neutrum ;
  prost_nn_1 = mkN "prost" ;
  prostatit_nn_1 = mkN "prostatit" "prostatiter" ;
  prosteri_nn_1 = mkN "prosteri" "prosterit" "prosterier" "prosterierna" ;
  protagonist_nn_1 = mkN "protagonist" "protagonister" ;
  protege_nn_1 = mkN "protegй" "protegйer" ;
  protein_nn_1 = mkN "protein" "proteinet" "proteiner" "proteinerna" ;
  proteinanalys_nn_1 = mkN "proteinanalys" "proteinanalyser" ;
  proteinbehov_nn_1 = mkN "proteinbehov" neutrum ;
  proteinfabrik_nn_1 = mkN "proteinfabrik" "proteinfabriker" ;
  proteinfamilj_nn_1 = mkN "proteinfamilj" "proteinfamiljer" ;
  proteinforskning_nn_1 = mkN "proteinforskning" ;
  proteinkedja_nn_1 = mkN "proteinkedja" ;
  proteinkemist_nn_1 = mkN "proteinkemist" "proteinkemister" ;
  proteinmolekyl_nn_1 = mkN "proteinmolekyl" "proteinmolekyler" ;
  proteinnerbrytande_av_1 = mkA "proteinnerbrytande" ;
  proteinrik_av_1 = mkA "proteinrik" ;
  proteinslag_nn_1 = mkN "proteinslag" neutrum ;
  proteisk_av_1 = mkA "proteisk" ;
  protektionistisk_av_1 = mkA "protektionistisk" ;
  protektor_nn_1 = mkN "protektor" "protektorer" ;
  protektorat_nn_1 = mkN "protektorat" neutrum ;
  protes_nn_1 = mkN "protes" "proteser" ;
  protest_nn_1 = mkN "protest" "protester" ;
  protestaktion_nn_1 = mkN "protestaktion" "protestaktioner" ;
  protestant_nn_1 = mkN "protestant" "protestanter" ;
  protestantisk_av_1 = mkA "protestantisk" ;
  protestroerelse_nn_1 = mkN "protestrцrelse" "protestrцrelser" ;
  protestvilja_nn_1 = mkN "protestvilja" ;
  protokoll_nn_1 = mkN "protokoll" neutrum ;
  protokollaer_av_1 = mkA "protokollдr" ;
  protolys_nn_1 = mkN "protolys" "protolyser" ;
  protolyt_nn_1 = mkN "protolyt" "protolyter" ;
  proton_nn_1 = mkN "proton" "protoner" ;
  protonkniv_nn_1 = mkN "protonkniv" ;
  protonladdning_nn_1 = mkN "protonladdning" ;
  prototyp_nn_1 = mkN "prototyp" "prototyper" ;
  protozo_nn_1 = mkN "protozo" "protozon" "protozoer" "protozoerna" ;
  protuberans_nn_1 = mkN "protuberans" "protuberanser" ;
  prov_nn_1 = mkN "prov" neutrum ;
  prov_nn_2 = mkN "prov" neutrum ;
  provaar_nn_1 = mkN "provеr" neutrum ;
  provare_nn_1 = mkN "provare" "provare" ;
  proveniens_nn_1 = mkN "proveniens" "provenienser" ;
  provensal_nn_1 = mkN "provensal" "provensaler" ;
  provensalsk_av_1 = mkA "provensalsk" ;
  provensalska_nn_2 = mkN "provensalska" ;
  proverb_nn_1 = mkN "proverb" neutrum ;
  provglas_nn_1 = mkN "provglas" neutrum ;
  provie_nn_1 = mkN "provie" "provien" "provies" "proviesen" ;
  provins_nn_1 = mkN "provins" "provinser" ;
  provinsialism_nn_1 = mkN "provinsialism" "provinsialismer" ;
  provinsiallaekare_nn_1 = mkN "provinsiallдkare" "provinsiallдkare" ;
  provinsiell_av_1 = mkA "provinsiell" ;
  provision_nn_1 = mkN "provision" "provisioner" ;
  provisorisk_av_1 = mkA "provisorisk" ;
  provisorium_nn_1 = mkN "provisorium" "provisoriet" "provisorier" "provisorierna" ;
  provkoek_nn_1 = mkN "provkцk" neutrum ;
  provokation_nn_1 = mkN "provokation" "provokationer" ;
  provokativ_av_1 = mkA "provokativ" ;
  provokatoer_nn_1 = mkN "provokatцr" "provokatцrer" ;
  provokatorisk_av_1 = mkA "provokatorisk" ;
  provraekning_nn_1 = mkN "provrдkning" ;
  provroer_nn_1 = mkN "provrцr" neutrum ;
  provroersbarn_nn_1 = mkN "provrцrsbarn" neutrum ;
  provroersbefruktning_nn_1 = mkN "provrцrsbefruktning" ;
  provrum_nn_1 = mkN "provrum" "provrummet" "provrum" "provrummen" ;
  provryttare_nn_1 = mkN "provryttare" "provryttare" ;
  provspraengning_nn_1 = mkN "provsprдngning" ;
  provstopp_nn_1 = mkN "provstopp" neutrum ;
  provtagning_nn_1 = mkN "provtagning" ;
  provuppgift_nn_1 = mkN "provuppgift" "provuppgifter" ;
  proximal_av_1 = mkA "proximal" ;
  prudentlig_av_1 = mkA "prudentlig" ;
  prunell_nn_1 = mkN "prunell" "pruneller" ;
  prutgaas_nn_1 = mkN "prutgеs" "prutgеsen" "prutgдss" "prutgдssen" ;
  prutt_nn_1 = mkN "prutt" ;
  pruttig_av_1 = mkA "pruttig" ;
  pryd_av_1 = mkA "pryd" ;
  prydlig_av_1 = mkA "prydlig" ;
  prydnad_nn_1 = mkN "prydnad" "prydnader" ;
  prydnadsbuske_nn_1 = mkN "prydnadsbuske" utrum ;
  prydnadsdetalj_nn_1 = mkN "prydnadsdetalj" "prydnadsdetaljer" ;
  prydnadsfigur_nn_1 = mkN "prydnadsfigur" "prydnadsfigurer" ;
  prydnadsfjaeder_nn_1 = mkN "prydnadsfjдder" ;
  prydnadsfoeremaal_nn_1 = mkN "prydnadsfцremеl" neutrum ;
  prydnadsgavel_nn_1 = mkN "prydnadsgavel" ;
  prydnadslist_nn_1 = mkN "prydnadslist" "prydnadslister" ;
  prydnadssoem_nn_1 = mkN "prydnadssцm" "prydnadssцmmen" "prydnadssцmmar" "prydnadssцmmarna" ;
  prydnadsvaev_nn_1 = mkN "prydnadsvдv" ;
  prydnadsvaext_nn_1 = mkN "prydnadsvдxt" "prydnadsvдxter" ;
  pryl_nn_1 = mkN "pryl" ;
  pryo_nn_1 = mkN "pryo" "pryor" ;
  pryttel_nn_1 = mkN "pryttel" ;
  psalm_nn_1 = mkN "psalm" "psalmer" ;
  psalmbok_nn_1 = mkN "psalmbok" "psalmbцcker" ;
  psalmdiktare_nn_1 = mkN "psalmdiktare" "psalmdiktare" ;
  psalmist_nn_1 = mkN "psalmist" "psalmister" ;
  psalmnummer_nn_1 = mkN "psalmnummer" neutrum ;
  psalmodi_nn_1 = mkN "psalmodi" "psalmodier" ;
  psalmodikon_nn_1 = mkN "psalmodikon" neutrum ;
  psalmvers_nn_1 = mkN "psalmvers" ;
  psaltare_nn_1 = mkN "psaltare" "psaltare" ;
  pseudohaendelse_nn_1 = mkN "pseudohдndelse" "pseudohдndelser" ;
  pseudonym_nn_1 = mkN "pseudonym" "pseudonymer" ;
  psoriatiker_nn_1 = mkN "psoriatiker" "psoriatikern" "psoriatiker" "psoriatikerna" ;
  psykedelisk_av_1 = mkA "psykedelisk" ;
  psykiater_nn_1 = mkN "psykiater" "psykiatern" "psykiatrer" "psykiatrerna" ;
  psykiatriker_nn_1 = mkN "psykiatriker" "psykiatrikern" "psykiatriker" "psykiatrikerna" ;
  psykiatrisk_av_1 = mkA "psykiatrisk" ;
  psykisk_av_1 = mkA "psykisk" ;
  psykoanalys_nn_1 = mkN "psykoanalys" "psykoanalyser" ;
  psykoanalytiker_nn_1 = mkN "psykoanalytiker" "psykoanalytikern" "psykoanalytiker" "psykoanalytikerna" ;
  psykoanalytisk_av_1 = mkA "psykoanalytisk" ;
  psykofarmaka_nn_1 = mkN "psykofarmaka" "psykofarmakan" "psykofarmaka" "psykofarmakana" ;
  psykogen_av_1 = mkA "psykogen" ;
  psykolog_nn_1 = mkN "psykolog" "psykologer" ;
  psykologiprofessor_nn_1 = mkN "psykologiprofessor" "psykologiprofessorer" ;
  psykologisk_av_1 = mkA "psykologisk" ;
  psykopat_nn_1 = mkN "psykopat" "psykopater" ;
  psykopati_nn_1 = mkN "psykopati" "psykopatier" ;
  psykoprofylaktisk_av_1 = mkA "psykoprofylaktisk" ;
  psykos_nn_1 = mkN "psykos" "psykoser" ;
  psykosocial_av_1 = mkA "psykosocial" ;
  psykosomatisk_av_1 = mkA "psykosomatisk" ;
  psykoterapeut_nn_1 = mkN "psykoterapeut" "psykoterapeuter" ;
  psykoterapi_nn_1 = mkN "psykoterapi" "psykoterapier" ;
  psykotisk_av_1 = mkA "psykotisk" ;
  psykrometer_nn_1 = mkN "psykrometer" ;
  pub_nn_1 = mkN "pub" ;
  pubertet_nn_1 = mkN "pubertet" "puberteter" ;
  publicering_nn_1 = mkN "publicering" ;
  publicist_nn_1 = mkN "publicist" "publicister" ;
  publicistisk_av_1 = mkA "publicistisk" ;
  publicitet_nn_1 = mkN "publicitet" "publiciteter" ;
  publik_av_1 = mkA "publik" ;
  publikan_nn_1 = mkN "publikan" "publikaner" ;
  publikation_nn_1 = mkN "publikation" "publikationer" ;
  publikdragande_av_1 = mkA "publikdragande" ;
  publikfriande_av_1 = mkA "publikfriande" ;
  puck_nn_1 = mkN "puck" ;
  puckare_nn_1 = mkN "puckare" "puckare" ;
  puckel_nn_1 = mkN "puckel" ;
  puckeloxe_nn_1 = mkN "puckeloxe" utrum ;
  puckelpist_nn_1 = mkN "puckelpist" "puckelpister" ;
  puckelrygg_nn_1 = mkN "puckelrygg" ;
  puckelryggig_av_1 = mkA "puckelryggig" ;
  pucklig_av_1 = mkA "pucklig" ;
  pudding_nn_1 = mkN "pudding" ;
  pudel_nn_1 = mkN "pudel" ;
  puderkraem_nn_1 = mkN "puderkrдm" "puderkrдmer" ;
  puderunderlag_nn_1 = mkN "puderunderlag" neutrum ;
  pudrig_av_1 = mkA "pudrig" ;
  pueril_av_1 = mkA "pueril" ;
  puerilitet_nn_1 = mkN "puerilitet" "pueriliteter" ;
  puff_nn_1 = mkN "puff" ;
  puffaerm_nn_1 = mkN "puffдrm" ;
  puffert_nn_1 = mkN "puffert" ;
  pugilist_nn_1 = mkN "pugilist" "pugilister" ;
  puke_nn_1 = mkN "puke" utrum ;
  pullmanvagn_nn_1 = mkN "pullmanvagn" ;
  pullover_nn_1 = mkN "pullover" ;
  pulpet_nn_1 = mkN "pulpet" "pulpeter" ;
  pulpettak_nn_1 = mkN "pulpettak" neutrum ;
  pulpit_nn_1 = mkN "pulpit" ;
  puls_nn_1 = mkN "puls" ;
  puls_nn_2 = mkN "puls" "pulser" ;
  pulsaader_nn_1 = mkN "pulsеder" "pulsеdern" "pulsеdror" "pulsеdrorna" ;
  pulsar_nn_1 = mkN "pulsar" "pulsarer" ;
  pulsslag_nn_1 = mkN "pulsslag" neutrum ;
  pulstaag_nn_1 = mkN "pulstеg" neutrum ;
  pult_nn_1 = mkN "pult" "pulter" ;
  pultron_nn_1 = mkN "pultron" "pultroner" ;
  pulver_nn_1 = mkN "pulver" neutrum ;
  pulverslaeckare_nn_1 = mkN "pulverslдckare" "pulverslдckare" ;
  pump_nn_1 = mkN "pump" ;
  pumpernickel_nn_1 = mkN "pumpernickel" ;
  pumpkolv_nn_1 = mkN "pumpkolv" ;
  pumpstoevel_nn_1 = mkN "pumpstцvel" ;
  punch_nn_1 = mkN "punch" ;
  pund_nn_1 = mkN "pund" neutrum ;
  pundare_nn_1 = mkN "pundare" "pundare" ;
  pundhuvud_nn_1 = mkN "pundhuvud" "pundhuvudet" "pundhuvuden" "pundhuvudena" ;
  pundig_av_1 = mkA "pundig" ;
  pundkris_nn_1 = mkN "pundkris" "pundkriser" ;
  pung_nn_1 = mkN "pung" ;
  pungbjoern_nn_1 = mkN "pungbjцrn" ;
  pungdjur_nn_1 = mkN "pungdjur" neutrum ;
  pungsten_nn_1 = mkN "pungsten" "pungstenen" "pungstenar" "pungstenarna" ;
  punisk_av_1 = mkA "punisk" ;
  punkare_nn_1 = mkN "punkare" "punkare" ;
  punkfrisyr_nn_1 = mkN "punkfrisyr" "punkfrisyrer" ;
  punkt_nn_1 = mkN "punkt" "punkter" ;
  punktering_nn_1 = mkN "punktering" ;
  punkthus_nn_1 = mkN "punkthus" neutrum ;
  punktion_nn_1 = mkN "punktion" "punktioner" ;
  punktlig_av_1 = mkA "punktlig" ;
  punktmaengd_nn_1 = mkN "punktmдngd" "punktmдngder" ;
  punktskatt_nn_1 = mkN "punktskatt" "punktskatter" ;
  punktuell_av_1 = mkA "punktuell" ;
  punktur_nn_1 = mkN "punktur" "punkturer" ;
  punktvis_ab_1 = mkAdv "punktvis" ;
  puns_nn_1 = mkN "puns" ;
  pupill_nn_1 = mkN "pupill" "pupiller" ;
  pupillfoerstorande_av_1 = mkA "pupillfцrstorande" ;
  pur_av_1 = mkA "pur" ;
  pure_nn_1 = mkN "purй" "purйer" ;
  purgativ_nn_1 = mkN "purgativ" neutrum ;
  purin_nn_1 = mkN "purin" "puriner" ;
  purism_nn_1 = mkN "purism" "purismer" ;
  purist_nn_1 = mkN "purist" "purister" ;
  puritan_nn_1 = mkN "puritan" "puritaner" ;
  puritansk_av_1 = mkA "puritansk" ;
  purjoloek_nn_1 = mkN "purjolцk" ;
  purken_av_1 = mkA "purken" "purket" ;
  purser_nn_1 = mkN "purser" ;
  puss_nn_1 = mkN "puss" ;
  pussel_nn_1 = mkN "pussel" neutrum ;
  pusselbit_nn_1 = mkN "pusselbit" ;
  pussig_av_1 = mkA "pussig" ;
  pusskalas_nn_1 = mkN "pusskalas" neutrum ;
  pust_nn_1 = mkN "pust" ;
  pustel_nn_1 = mkN "pustel" "pusteln" "pustler" "pustlerna" ;
  putig_av_1 = mkA "putig" ;
  puts_nn_2 = mkN "puts" neutrum ;
  putsch_nn_1 = mkN "putsch" "putscher" ;
  putslustig_av_1 = mkA "putslustig" ;
  putt_av_1 = mkA "putt" ;
  putt_nn_1 = mkN "putt" ;
  putte_nn_1 = mkN "putte" utrum ;
  puttefnask_nn_1 = mkN "puttefnask" ;
  putting_nn_1 = mkN "putting" ;
  putto_nn_1 = mkN "putto" "putton" "putti" "puttina" ;
  puttrig_av_1 = mkA "puttrig" ;
  puzzle_nn_1 = mkN "puzzle" "puzzlet" "puzzle" "puzzlen" ;
  pyelit_nn_1 = mkN "pyelit" "pyeliter" ;
  pygme_nn_1 = mkN "pygmй" "pygmйer" ;
  pyjamas_nn_1 = mkN "pyjamas" ;
  pykniker_nn_1 = mkN "pykniker" "pyknikern" "pykniker" "pyknikerna" ;
  pyknisk_av_1 = mkA "pyknisk" ;
  pyknometer_nn_1 = mkN "pyknometer" ;
  pylon_nn_1 = mkN "pylon" "pyloner" ;
  pyndare_nn_1 = mkN "pyndare" "pyndare" ;
  pynt_nn_2 = mkN "pynt" ;
  pyramid_nn_1 = mkN "pyramid" "pyramider" ;
  pyramidal_av_1 = mkA "pyramidal" ;
  pyreneisk_av_1 = mkA "pyreneisk" ;
  pyridin_nn_1 = mkN "pyridin" "pyridiner" ;
  pyrit_nn_1 = mkN "pyrit" "pyriter" ;
  pyroman_nn_1 = mkN "pyroman" "pyromaner" ;
  pyrometer_nn_1 = mkN "pyrometer" ;
  pyroteknisk_av_1 = mkA "pyroteknisk" ;
  pyrrusseger_nn_1 = mkN "pyrrusseger" ;
  pys_nn_1 = mkN "pys" ;
  pysslig_av_1 = mkA "pysslig" ;
  pyssling_nn_1 = mkN "pyssling" ;
  pyton_ab_1 = mkAdv "pyton" ;
  pytonorm_nn_1 = mkN "pytonorm" ;
  pyts_nn_1 = mkN "pyts" ;
  pytte_av_1 = mkA "pytte" ;
  qatarier_nn_1 = mkN "qatarier" "qatariern" "qatarier" "qatarierna" ;
  qatarisk_av_1 = mkA "qatarisk" ;
  quenell_nn_1 = mkN "quenell" "queneller" ;
  quisling_nn_1 = mkN "quisling" ;
  raa_av_1 = mkA "rе" "rеtt" ;
  raa_nn_1 = mkN "rе" "rеn" "rеr" "rеrna" ;
  raa_nn_2 = mkN "rе" "rеet" "rеr" "rеrna" ;
  raa_nn_3 = mkN "rе" "rеn" "rеr" "rеrna" ;
  raaaemne_nn_1 = mkN "rедmne" ;
  raaband_nn_1 = mkN "rеband" neutrum ;
  raabandsknop_nn_1 = mkN "rеbandsknop" ;
  raabiff_nn_1 = mkN "rеbiff" ;
  raabock_nn_1 = mkN "rеbock" ;
  raad_nn_1 = mkN "rеd" neutrum ;
  raadande_av_1 = mkA "rеdande" ;
  raaddig_av_1 = mkA "rеddig" ;
  raadfraagning_nn_1 = mkN "rеdfrеgning" ;
  raadgivande_av_1 = mkA "rеdgivande" ;
  raadgivare_nn_1 = mkN "rеdgivare" "rеdgivare" ;
  raadhus_nn_1 = mkN "rеdhus" neutrum ;
  raadhuskaellare_nn_1 = mkN "rеdhuskдllare" "rеdhuskдllare" ;
  raadhusraett_nn_1 = mkN "rеdhusrдtt" "rеdhusrдtter" ;
  raadig_av_1 = mkA "rеdig" ;
  raadjur_nn_1 = mkN "rеdjur" neutrum ;
  raadjurssadel_nn_1 = mkN "rеdjurssadel" ;
  raadlig_av_1 = mkA "rеdlig" ;
  raadloes_av_1 = mkA "rеdlцs" ;
  raadman_nn_1 = mkN "rеdman" "rеdmannen" "rеdmдn" "rеdmдnnen" ;
  raadplaegning_nn_1 = mkN "rеdplдgning" ;
  raadslag_nn_1 = mkN "rеdslag" neutrum ;
  raadsnar_av_1 = mkA "rеdsnar" ;
  raadsrepublik_nn_1 = mkN "rеdsrepublik" "rеdsrepubliker" ;
  raadstuga_nn_1 = mkN "rеdstuga" ;
  raadstuguraett_nn_1 = mkN "rеdstugurдtt" "rеdstugurдtter" ;
  raadvill_av_1 = mkA "rеdvill" ;
  raagaang_nn_1 = mkN "rеgеng" ;
  raagblond_av_1 = mkA "rеgblond" ;
  raagbroed_nn_1 = mkN "rеgbrцd" neutrum ;
  raaget_nn_1 = mkN "rеget" "rеgetter" ;
  raagkorn_nn_1 = mkN "rеgkorn" neutrum ;
  raahet_nn_1 = mkN "rеhet" "rеheter" ;
  raak_nn_1 = mkN "rеk" ;
  raakall_av_1 = mkA "rеkall" ;
  raakopia_nn_1 = mkN "rеkopia" ;
  raakurr_nn_1 = mkN "rеkurr" neutrum ;
  raamaerke_nn_1 = mkN "rеmдrke" ;
  raan_nn_1 = mkN "rеn" neutrum ;
  raanare_nn_1 = mkN "rеnare" "rеnare" ;
  raanmord_nn_1 = mkN "rеnmord" neutrum ;
  raanock_nn_1 = mkN "rеnock" ;
  raaoljemotor_nn_1 = mkN "rеoljemotor" "rеoljemotorer" ;
  raariva_vb_1 = mkV "rеriva" "rеrev" "rеrivit" ;
  raaroerd_av_1 = mkA "rеrцrd" "rеrцrt" ;
  raasegel_nn_1 = mkN "rеsegel" neutrum ;
  raaseglare_nn_1 = mkN "rеseglare" "rеseglare" ;
  raaskinn_nn_1 = mkN "rеskinn" neutrum ;
  raasop_nn_1 = mkN "rеsop" ;
  raattaeten_av_1 = mkA "rеttдten" "rеttдtet" ;
  raattdjur_nn_1 = mkN "rеttdjur" neutrum ;
  raatthaal_nn_1 = mkN "rеtthеl" neutrum ;
  raattsvans_nn_1 = mkN "rеttsvans" ;
  raavara_nn_1 = mkN "rеvara" ;
  rabatt_nn_1 = mkN "rabatt" "rabatter" ;
  rabattfrimaerke_nn_1 = mkN "rabattfrimдrke" ;
  rabatthaefte_nn_1 = mkN "rabatthдfte" ;
  rabattkort_nn_1 = mkN "rabattkort" neutrum ;
  rabattkupong_nn_1 = mkN "rabattkupong" "rabattkuponger" ;
  rabbi_nn_1 = mkN "rabbi" "rabbin" "rabbier" "rabbierna" ;
  rabbin_nn_1 = mkN "rabbin" "rabbiner" ;
  rabbis_nn_1 = mkN "rabbis" ;
  rabiat_av_1 = mkA "rabiat" "rabiat" ;
  rabulist_nn_1 = mkN "rabulist" "rabulister" ;
  rabulistisk_av_1 = mkA "rabulistisk" ;
  racer_nn_1 = mkN "racer" ;
  racerbil_nn_1 = mkN "racerbil" ;
  racercykel_nn_1 = mkN "racercykel" ;
  racerfoerare_nn_1 = mkN "racerfцrare" "racerfцrare" ;
  rack_nn_1 = mkN "rack" ;
  rack_nn_2 = mkN "rack" neutrum ;
  rackaraktig_av_1 = mkA "rackaraktig" ;
  rackare_nn_1 = mkN "rackare" "rackare" ;
  rackarns_av_1 = mkA "rackarns" ;
  rackartyg_nn_1 = mkN "rackartyg" neutrum ;
  rackarunge_nn_1 = mkN "rackarunge" utrum ;
  rackelhane_nn_1 = mkN "rackelhane" utrum ;
  racket_nn_1 = mkN "racket" ;
  racklig_av_1 = mkA "racklig" ;
  rad_nn_1 = mkN "rad" "rader" ;
  rad_nn_2 = mkN "rad" "raden" "rad" "raden" ;
  radannons_nn_1 = mkN "radannons" "radannonser" ;
  radarantenn_nn_1 = mkN "radarantenn" "radarantenner" ;
  radarfyr_nn_1 = mkN "radarfyr" ;
  radarkontroll_nn_1 = mkN "radarkontroll" "radarkontroller" ;
  radarpar_nn_1 = mkN "radarpar" neutrum ;
  radarreflektor_nn_1 = mkN "radarreflektor" "radarreflektorer" ;
  radarskaerm_nn_1 = mkN "radarskдrm" ;
  radavstaand_nn_1 = mkN "radavstеnd" neutrum ;
  radband_nn_1 = mkN "radband" neutrum ;
  radergummi_nn_1 = mkN "radergummi" "radergummit" "radergummin" "radergummina" ;
  raderkniv_nn_1 = mkN "raderkniv" ;
  radhus_nn_1 = mkN "radhus" neutrum ;
  radiakbehandling_nn_1 = mkN "radiakbehandling" ;
  radial_av_1 = mkA "radial" ;
  radialdaeck_nn_1 = mkN "radialdдck" neutrum ;
  radialhastighet_nn_1 = mkN "radialhastighet" "radialhastigheter" ;
  radiallager_nn_1 = mkN "radiallager" neutrum ;
  radian_nn_1 = mkN "radian" "radianer" ;
  radiator_nn_1 = mkN "radiator" "radiatorer" ;
  radie_nn_1 = mkN "radie" "radier" ;
  radiell_av_1 = mkA "radiell" ;
  radikal_av_1 = mkA "radikal" ;
  radikal_nn_1 = mkN "radikal" "radikaler" ;
  radikalisering_nn_1 = mkN "radikalisering" ;
  radikaloperation_nn_1 = mkN "radikaloperation" "radikaloperationer" ;
  radio_nn_1 = mkN "radio" "radior" ;
  radioaktiv_av_1 = mkA "radioaktiv" ;
  radioaktivitet_nn_1 = mkN "radioaktivitet" "radioaktiviteter" ;
  radioamatoer_nn_1 = mkN "radioamatцr" "radioamatцrer" ;
  radioapparat_nn_1 = mkN "radioapparat" "radioapparater" ;
  radioastronomisk_av_1 = mkA "radioastronomisk" ;
  radiobil_nn_1 = mkN "radiobil" ;
  radiofrekvent_av_1 = mkA "radiofrekvent" "radiofrekvent" ;
  radiofyr_nn_1 = mkN "radiofyr" ;
  radiogram_nn_1 = mkN "radiogram" "radiogrammet" "radiogram" "radiogrammen" ;
  radiogrammofon_nn_1 = mkN "radiogrammofon" "radiogrammofoner" ;
  radiohus_nn_1 = mkN "radiohus" neutrum ;
  radioisotop_nn_1 = mkN "radioisotop" "radioisotoper" ;
  radiokanal_nn_1 = mkN "radiokanal" "radiokanaler" ;
  radiolaenk_nn_1 = mkN "radiolдnk" ;
  radiolarie_nn_1 = mkN "radiolarie" "radiolarier" ;
  radiolog_nn_1 = mkN "radiolog" "radiologer" ;
  radioman_nn_1 = mkN "radioman" "radiomannen" "radiomдn" "radiomдnnen" ;
  radiometer_nn_1 = mkN "radiometer" ;
  radiomottagare_nn_1 = mkN "radiomottagare" "radiomottagare" ;
  radionavigeringssystem_nn_1 = mkN "radionavigeringssystem" neutrum ;
  radiopjaes_nn_1 = mkN "radiopjдs" "radiopjдser" ;
  radioprogram_nn_1 = mkN "radioprogram" "radioprogrammet" "radioprogram" "radioprogrammen" ;
  radioroer_nn_1 = mkN "radiorцr" neutrum ;
  radioroest_nn_1 = mkN "radiorцst" "radiorцster" ;
  radiosaendare_nn_1 = mkN "radiosдndare" "radiosдndare" ;
  radiosaendning_nn_1 = mkN "radiosдndning" ;
  radiosignal_nn_1 = mkN "radiosignal" "radiosignaler" ;
  radiosond_nn_1 = mkN "radiosond" "radiosonder" ;
  radiostation_nn_1 = mkN "radiostation" "radiostationer" ;
  radiostoerning_nn_1 = mkN "radiostцrning" ;
  radiostraalning_nn_1 = mkN "radiostrеlning" ;
  radiot_nn_1 = mkN "radiot" "radioter" ;
  radioteknik_nn_1 = mkN "radioteknik" "radiotekniker" ;
  radiotelefon_nn_1 = mkN "radiotelefon" "radiotelefoner" ;
  radiotelegrafist_nn_1 = mkN "radiotelegrafist" "radiotelegrafister" ;
  radioteleskop_nn_1 = mkN "radioteleskop" neutrum ;
  radioutsaendning_nn_1 = mkN "radioutsдndning" ;
  radondotter_nn_1 = mkN "radondotter" "radondottern" "radondцttrar" "radondцttrarna" ;
  radonhus_nn_1 = mkN "radonhus" neutrum ;
  radskiftare_nn_1 = mkN "radskiftare" "radskiftare" ;
  radskrivare_nn_1 = mkN "radskrivare" "radskrivare" ;
  radslutssignal_nn_1 = mkN "radslutssignal" "radslutssignaler" ;
  raeck_nn_1 = mkN "rдck" neutrum ;
  raecke_nn_1 = mkN "rдcke" ;
  raeckverk_nn_1 = mkN "rдckverk" neutrum ;
  raeckvidd_nn_1 = mkN "rдckvidd" "rдckvidder" ;
  raed_nn_1 = mkN "rдd" "rдder" ;
  raeddare_nn_1 = mkN "rдddare" "rдddare" ;
  raeddhaagsen_av_1 = mkA "rдddhеgsen" "rдddhеgset" ;
  raeddning_nn_1 = mkN "rдddning" ;
  raeddningsaktion_nn_1 = mkN "rдddningsaktion" "rдddningsaktioner" ;
  raeddningsloes_av_1 = mkA "rдddningslцs" ;
  raeffla_nn_1 = mkN "rдffla" ;
  raefst_nn_1 = mkN "rдfst" "rдfster" ;
  raejong_nn_1 = mkN "rдjong" "rдjonger" ;
  raekel_nn_1 = mkN "rдkel" ;
  raekenskapsaar_nn_1 = mkN "rдkenskapsеr" neutrum ;
  raeknare_nn_1 = mkN "rдknare" "rдknare" ;
  raekneapparat_nn_1 = mkN "rдkneapparat" "rдkneapparater" ;
  raekneexempel_nn_1 = mkN "rдkneexempel" neutrum ;
  raeknekapacitet_nn_1 = mkN "rдknekapacitet" "rдknekapaciteter" ;
  raeknemaskin_nn_1 = mkN "rдknemaskin" "rдknemaskiner" ;
  raekneord_nn_1 = mkN "rдkneord" neutrum ;
  raeknesaett_nn_1 = mkN "rдknesдtt" neutrum ;
  raeknesnabbhet_nn_1 = mkN "rдknesnabbhet" "rдknesnabbheter" ;
  raekneverk_nn_1 = mkN "rдkneverk" neutrum ;
  raekning_nn_1 = mkN "rдkning" ;
  rael_nn_1 = mkN "rдl" "rдler" ;
  raelig_av_1 = mkA "rдlig" ;
  raels_nn_1 = mkN "rдls" ;
  raelsbuss_nn_1 = mkN "rдlsbuss" ;
  raenksmidare_nn_1 = mkN "rдnksmidare" "rдnksmidare" ;
  raennil_nn_1 = mkN "rдnnil" ;
  raenning_nn_1 = mkN "rдnning" ;
  raennsten_nn_1 = mkN "rдnnsten" "rдnnstenen" "rдnnstenar" "rдnnstenarna" ;
  raennstensunge_nn_1 = mkN "rдnnstensunge" utrum ;
  raensel_nn_1 = mkN "rдnsel" ;
  raentabel_av_1 = mkA "rдntabel" "rдntabelt" "rдntabla" "rдntabla" "rдntablare" "rдntablast" "rдntablaste" ;
  raentabilitet_nn_1 = mkN "rдntabilitet" "rдntabiliteter" ;
  raenteavdrag_nn_1 = mkN "rдnteavdrag" neutrum ;
  raentebesked_nn_1 = mkN "rдntebesked" neutrum ;
  raentemarginal_nn_1 = mkN "rдntemarginal" "rдntemarginaler" ;
  raentesats_nn_1 = mkN "rдntesats" "rдntesatser" ;
  raentetermin_nn_1 = mkN "rдntetermin" "rдnteterminer" ;
  raentmaestare_nn_1 = mkN "rдntmдstare" "rдntmдstare" ;
  raetblock_nn_1 = mkN "rдtblock" neutrum ;
  raetlinjig_av_1 = mkA "rдtlinjig" ;
  raetsida_nn_1 = mkN "rдtsida" ;
  raett_ab_1 = mkAdv "rдtt" ;
  raett_av_1 = mkA "rдtt" ;
  raett_nn_1 = mkN "rдtt" "rдtter" ;
  raettaenkande_av_1 = mkA "rдttдnkande" ;
  raettare_nn_1 = mkN "rдttare" "rдttare" ;
  raettegaang_nn_1 = mkN "rдttegеng" ;
  raettegaangsbitraede_nn_1 = mkN "rдttegеngsbitrдde" ;
  raettegaangsfel_nn_1 = mkN "rдttegеngsfel" "rдttegеngsfelet" "rдttegеngsfel" "rдttegеngsfelen" ;
  raetteligen_ab_1 = mkAdv "rдtteligen" ;
  raettelse_nn_1 = mkN "rдttelse" "rдttelser" ;
  raettfaerdig_av_1 = mkA "rдttfдrdig" ;
  raettfaerdighet_nn_1 = mkN "rдttfдrdighet" "rдttfдrdigheter" ;
  raettfram_av_1 = mkA "rдttfram" "rдttframt" "rдttframma" "rдttframma" "rдttframmare" "rдttframmast" "rдttframmaste" ;
  raettighet_nn_1 = mkN "rдttighet" "rдttigheter" ;
  raettmaetig_av_1 = mkA "rдttmдtig" ;
  raettning_nn_1 = mkN "rдttning" ;
  raettraadig_av_1 = mkA "rдttrеdig" ;
  raettroende_av_1 = mkA "rдttroende" ;
  raettrogen_av_1 = mkA "rдttrogen" "rдttroget" ;
  raettschef_nn_1 = mkN "rдttschef" "rдttschefer" ;
  raettsenlig_av_1 = mkA "rдttsenlig" ;
  raettsfall_nn_1 = mkN "rдttsfall" neutrum ;
  raettshaverist_nn_1 = mkN "rдttshaverist" "rдttshaverister" ;
  raettsinnig_av_1 = mkA "rдttsinnig" ;
  raettskaffens_av_1 = mkA "rдttskaffens" ;
  raettskapacitet_nn_1 = mkN "rдttskapacitet" "rдttskapaciteter" ;
  raettskrivning_nn_1 = mkN "rдttskrivning" ;
  raettslaekare_nn_1 = mkN "rдttslдkare" "rдttslдkare" ;
  raettslig_av_1 = mkA "rдttslig" ;
  raettsloes_av_1 = mkA "rдttslцs" ;
  raettsmedicinsk_av_1 = mkA "rдttsmedicinsk" ;
  raettsordning_nn_1 = mkN "rдttsordning" ;
  raettspaafoeljd_nn_1 = mkN "rдttspеfцljd" "rдttspеfцljder" ;
  raettsprincip_nn_1 = mkN "rдttsprincip" "rдttsprinciper" ;
  raettspsykiatrisk_av_1 = mkA "rдttspsykiatrisk" ;
  raettsregel_nn_1 = mkN "rдttsregel" "rдttsregeln" "rдttsregler" "rдttsreglerna" ;
  raettssaekerhet_nn_1 = mkN "rдttssдkerhet" "rдttssдkerheter" ;
  raettssak_nn_1 = mkN "rдttssak" "rдttssaker" ;
  raettssal_nn_1 = mkN "rдttssal" ;
  raettsstat_nn_1 = mkN "rдttsstat" "rдttsstater" ;
  raettsstridig_av_1 = mkA "rдttsstridig" ;
  raettssubjekt_nn_1 = mkN "rдttssubjekt" neutrum ;
  raettstvist_nn_1 = mkN "rдttstvist" "rдttstvister" ;
  raettsuppfattning_nn_1 = mkN "rдttsuppfattning" ;
  raettsvidrig_av_1 = mkA "rдttsvidrig" ;
  raettvis_av_1 = mkA "rдttvis" ;
  raettvisande_av_1 = mkA "rдttvisande" ;
  raetvinge_nn_1 = mkN "rдtvinge" utrum ;
  raetvinklig_av_1 = mkA "rдtvinklig" ;
  raev_nn_1 = mkN "rдv" ;
  raevfarm_nn_1 = mkN "rдvfarm" ;
  raevhund_nn_1 = mkN "rдvhund" ;
  raevjakt_nn_1 = mkN "rдvjakt" "rдvjakter" ;
  raevsax_nn_1 = mkN "rдvsax" ;
  raevspel_nn_1 = mkN "rдvspel" "rдvspelet" "rдvspel" "rдvspelen" ;
  raevsvans_nn_1 = mkN "rдvsvans" ;
  raffig_av_1 = mkA "raffig" ;
  raffinad_nn_1 = mkN "raffinad" "raffinader" ;
  raffinaderi_nn_1 = mkN "raffinaderi" "raffinaderit" "raffinaderier" "raffinaderierna" ;
  raffinemang_nn_1 = mkN "raffinemang" neutrum ;
  rafflande_av_1 = mkA "rafflande" ;
  rafflig_av_1 = mkA "rafflig" ;
  rafraeschissoer_nn_1 = mkN "rafrдschissцr" "rafrдschissцrer" ;
  raggarbil_nn_1 = mkN "raggarbil" ;
  raggarbrud_nn_1 = mkN "raggarbrud" ;
  raggare_nn_1 = mkN "raggare" "raggare" ;
  raggig_av_1 = mkA "raggig" ;
  raggmunk_nn_1 = mkN "raggmunk" ;
  raglanaerm_nn_1 = mkN "raglanдrm" ;
  ragu_nn_1 = mkN "ragu" "ragun" "raguer" "raguerna" ;
  raid_nn_1 = mkN "raid" "raider" ;
  rajd_nn_1 = mkN "rajd" "rajder" ;
  rak_av_1 = mkA "rak" ;
  rakapparat_nn_1 = mkN "rakapparat" "rakapparater" ;
  rakblad_nn_1 = mkN "rakblad" neutrum ;
  rakborste_nn_1 = mkN "rakborste" utrum ;
  raket_nn_1 = mkN "raket" "raketer" ;
  raketbas_nn_1 = mkN "raketbas" "raketbaser" ;
  raketfaerd_nn_1 = mkN "raketfдrd" "raketfдrder" ;
  raketgevaer_nn_1 = mkN "raketgevдr" neutrum ;
  raketkonstruktoer_nn_1 = mkN "raketkonstruktцr" "raketkonstruktцrer" ;
  raketmotor_nn_1 = mkN "raketmotor" "raketmotorer" ;
  raketsteg_nn_1 = mkN "raketsteg" neutrum ;
  raketvapen_nn_1 = mkN "raketvapen" "raketvapnet" "raketvapen" "raketvapnen" ;
  rakhyvel_nn_1 = mkN "rakhyvel" ;
  rakitisk_av_1 = mkA "rakitisk" ;
  rakkniv_nn_1 = mkN "rakkniv" ;
  raklaang_av_1 = mkA "raklеng" ;
  raklinjig_av_1 = mkA "raklinjig" ;
  rakning_nn_1 = mkN "rakning" ;
  rakspegel_nn_1 = mkN "rakspegel" ;
  rakstrigel_nn_1 = mkN "rakstrigel" ;
  raktvaal_nn_1 = mkN "raktvеl" ;
  rakvatten_nn_1 = mkN "rakvatten" "rakvattnet" "rakvatten" "rakvattnen" ;
  raljant_av_1 = mkA "raljant" "raljant" ;
  raljeri_nn_1 = mkN "raljeri" "raljerit" "raljerier" "raljerierna" ;
  rall_nn_1 = mkN "rall" ;
  rallarbas_nn_1 = mkN "rallarbas" ;
  rallare_nn_1 = mkN "rallare" "rallare" ;
  rallarsving_nn_1 = mkN "rallarsving" ;
  rally_nn_1 = mkN "rally" "rallyt" "rallyn" "rallyna" ;
  ram_nn_1 = mkN "ram" ;
  ramaskri_nn_1 = mkN "ramaskri" "ramaskrit" "ramaskrin" "ramaskrien" ;
  ramavtal_nn_1 = mkN "ramavtal" "ramavtalet" "ramavtalen" "ramavtalena" ;
  ramberaettelse_nn_1 = mkN "ramberдttelse" "ramberдttelser" ;
  rambudget_nn_1 = mkN "rambudget" ;
  ramlare_nn_1 = mkN "ramlare" "ramlare" ;
  ramm_nn_1 = mkN "ramm" ;
  ramp_nn_1 = mkN "ramp" "ramper" ;
  rampris_nn_1 = mkN "rampris" neutrum ;
  ramstark_av_1 = mkA "ramstark" ;
  ramsvart_av_1 = mkA "ramsvart" "ramsvart" ;
  ranch_nn_1 = mkN "ranch" "rancher" ;
  rancune_nn_1 = mkN "rancune" "rancuner" ;
  rand_nn_1 = mkN "rand" "rдnder" ;
  rand_nn_2 = mkN "rand" "randen" "rand" "randen" ;
  randanmaerkning_nn_1 = mkN "randanmдrkning" ;
  randanteckning_nn_1 = mkN "randanteckning" ;
  randberg_nn_1 = mkN "randberg" neutrum ;
  randbildning_nn_1 = mkN "randbildning" ;
  randdelta_nn_1 = mkN "randdelta" "randdeltat" "randdeltan" "randdeltana" ;
  randfenomen_nn_1 = mkN "randfenomen" neutrum ;
  randhav_nn_1 = mkN "randhav" neutrum ;
  randig_av_1 = mkA "randig" ;
  randplataa_nn_1 = mkN "randplatе" "randplatеer" ;
  randsjoe_nn_1 = mkN "randsjц" ;
  randsydd_av_1 = mkA "randsydd" "randsydtt" ;
  ranger_nn_1 = mkN "ranger" "rangern" "rangers" "rangersen" ;
  rangerbangaard_nn_1 = mkN "rangerbangеrd" ;
  ranglig_av_1 = mkA "ranglig" ;
  rangordning_nn_1 = mkN "rangordning" ;
  rangplats_nn_1 = mkN "rangplats" "rangplatser" ;
  rank_av_1 = mkA "rank" ;
  ranka_ab_1 = mkAdv "ranka" ;
  rankfoting_nn_1 = mkN "rankfoting" ;
  rankig_av_1 = mkA "rankig" ;
  rannsakning_nn_1 = mkN "rannsakning" ;
  ranson_nn_1 = mkN "ranson" "ransoner" ;
  ransonering_nn_1 = mkN "ransonering" ;
  ransoneringskort_nn_1 = mkN "ransoneringskort" neutrum ;
  ranunkel_nn_1 = mkN "ranunkel" ;
  ranunkelvaext_nn_1 = mkN "ranunkelvдxt" "ranunkelvдxter" ;
  rap_nn_1 = mkN "rap" neutrum ;
  rapp_av_1 = mkA "rapp" ;
  rapp_nn_1 = mkN "rapp" ;
  rapp_nn_2 = mkN "rapp" neutrum ;
  rappell_nn_1 = mkN "rappell" "rappeller" ;
  rapphoens_nn_1 = mkN "rapphцns" neutrum ;
  rappning_nn_1 = mkN "rappning" ;
  rapport_nn_1 = mkN "rapport" "rapporter" ;
  rapportkarl_nn_1 = mkN "rapportkarl" ;
  rapportoer_nn_1 = mkN "rapportцr" "rapportцrer" ;
  rapsbagge_nn_1 = mkN "rapsbagge" utrum ;
  rapsfroe_nn_1 = mkN "rapsfrц" "rapsfrцet" "rapsfrцer" "rapsfrцerna" ;
  rapsod_nn_1 = mkN "rapsod" "rapsoder" ;
  rapsodi_nn_1 = mkN "rapsodi" "rapsodier" ;
  rapsodisk_av_1 = mkA "rapsodisk" ;
  raptus_nn_1 = mkN "raptus" neutrum ;
  rar_av_1 = mkA "rar" ;
  raring_nn_1 = mkN "raring" ;
  raritet_nn_1 = mkN "raritet" "rariteter" ;
  ras_nn_1 = mkN "ras" "raser" ;
  ras_nn_2 = mkN "ras" neutrum ;
  rasande_av_1 = mkA "rasande" ;
  rasben_nn_1 = mkN "rasben" neutrum ;
  rasdjur_nn_1 = mkN "rasdjur" neutrum ;
  raseriutbrott_nn_1 = mkN "raseriutbrott" neutrum ;
  rasfoerdom_nn_1 = mkN "rasfцrdom" ;
  rasfoerfoeljelse_nn_1 = mkN "rasfцrfцljelse" "rasfцrfцljelser" ;
  rasfraaga_nn_1 = mkN "rasfrеga" ;
  rashetsare_nn_1 = mkN "rashetsare" "rashetsare" ;
  rasist_nn_1 = mkN "rasist" "rasister" ;
  rasistisk_av_1 = mkA "rasistisk" ;
  rask_av_1 = mkA "rask" ;
  rasp_nn_1 = mkN "rasp" ;
  raspande_av_1 = mkA "raspande" ;
  raspig_av_1 = mkA "raspig" ;
  rasren_av_1 = mkA "rasren" ;
  rast_nn_1 = mkN "rast" "raster" ;
  rastafari_nn_1 = mkN "rastafari" "rastafarin" "rastafaris" "rastafarisen" ;
  raster_nn_1 = mkN "raster" neutrum ;
  rastgaard_nn_1 = mkN "rastgеrd" ;
  rastloes_av_1 = mkA "rastlцs" ;
  rastplats_nn_1 = mkN "rastplats" "rastplatser" ;
  rate_nn_1 = mkN "rate" "rater" ;
  ratifikation_nn_1 = mkN "ratifikation" "ratifikationer" ;
  ratifikationsinstrument_nn_1 = mkN "ratifikationsinstrument" neutrum ;
  ration_nn_1 = mkN "ration" "rationer" ;
  rationalisering_nn_1 = mkN "rationalisering" ;
  rationalist_nn_1 = mkN "rationalist" "rationalister" ;
  rationell_av_1 = mkA "rationell" ;
  ratsch_nn_1 = mkN "ratsch" neutrum ;
  ratt_nn_1 = mkN "ratt" ;
  rattfyllerist_nn_1 = mkN "rattfyllerist" "rattfyllerister" ;
  rattkaelke_nn_1 = mkN "rattkдlke" utrum ;
  rattlaas_nn_1 = mkN "rattlеs" neutrum ;
  rattonykterhet_nn_1 = mkN "rattonykterhet" "rattonykterheter" ;
  rattstaang_nn_1 = mkN "rattstеng" "rattstдnger" ;
  rattvaexel_nn_1 = mkN "rattvдxel" ;
  rauk_nn_1 = mkN "rauk" ;
  ravaillac_nn_1 = mkN "ravaillac" ;
  ravelin_nn_1 = mkN "ravelin" "raveliner" ;
  ravin_nn_1 = mkN "ravin" "raviner" ;
  reagens_nn_1 = mkN "reagens" neutrum ;
  reagenspapper_nn_1 = mkN "reagenspapper" neutrum ;
  reaktion_nn_1 = mkN "reaktion" "reaktioner" ;
  reaktionaer_av_1 = mkA "reaktionдr" ;
  reaktionaer_nn_1 = mkN "reaktionдr" "reaktionдrer" ;
  reaktionsbenaegen_av_1 = mkA "reaktionsbenдgen" "reaktionsbenдget" ;
  reaktionsmotor_nn_1 = mkN "reaktionsmotor" "reaktionsmotorer" ;
  reaktionsprodukt_nn_1 = mkN "reaktionsprodukt" "reaktionsprodukter" ;
  reaktionstemperatur_nn_1 = mkN "reaktionstemperatur" "reaktionstemperaturer" ;
  reaktionstid_nn_1 = mkN "reaktionstid" "reaktionstider" ;
  reaktionszon_nn_1 = mkN "reaktionszon" "reaktionszoner" ;
  reaktiv_av_1 = mkA "reaktiv" ;
  reaktor_nn_1 = mkN "reaktor" "reaktorer" ;
  reaktorbyggnad_nn_1 = mkN "reaktorbyggnad" "reaktorbyggnader" ;
  reaktorhaerd_nn_1 = mkN "reaktorhдrd" ;
  reaktorkatastrof_nn_1 = mkN "reaktorkatastrof" "reaktorkatastrofer" ;
  reaktorsaekerhet_nn_1 = mkN "reaktorsдkerhet" "reaktorsдkerheter" ;
  reaktortyp_nn_1 = mkN "reaktortyp" "reaktortyper" ;
  reaktorutslaepp_nn_1 = mkN "reaktorutslдpp" neutrum ;
  real_av_1 = mkA "real" ;
  realexamen_nn_1 = mkN "realexamen" "realexamen" "realexamina" "realexamina" ;
  realia_nn_1 = mkN "realia" "realian" "realia" "realiana" ;
  realindex_nn_1 = mkN "realindex" neutrum ;
  realisation_nn_1 = mkN "realisation" "realisationer" ;
  realisationsvinst_nn_1 = mkN "realisationsvinst" "realisationsvinster" ;
  realiserbar_av_1 = mkA "realiserbar" ;
  realist_nn_1 = mkN "realist" "realister" ;
  realistisk_av_1 = mkA "realistisk" ;
  realiter_ab_1 = mkAdv "realiter" ;
  realitet_nn_1 = mkN "realitet" "realiteter" ;
  realkapital_nn_1 = mkN "realkapital" neutrum ;
  realkatalog_nn_1 = mkN "realkatalog" "realkataloger" ;
  reallinje_nn_1 = mkN "reallinje" "reallinjer" ;
  realloen_nn_1 = mkN "reallцn" "reallцner" ;
  realsaekerhet_nn_1 = mkN "realsдkerhet" "realsдkerheter" ;
  realtidsbearbetning_nn_1 = mkN "realtidsbearbetning" ;
  realvaerde_nn_1 = mkN "realvдrde" ;
  reamotor_nn_1 = mkN "reamotor" "reamotorer" ;
  reaplan_nn_1 = mkN "reaplan" neutrum ;
  reapris_nn_1 = mkN "reapris" neutrum ;
  reassurans_nn_1 = mkN "reassurans" "reassuranser" ;
  rebell_nn_1 = mkN "rebell" "rebeller" ;
  rebellisk_av_1 = mkA "rebellisk" ;
  rebus_nn_1 = mkN "rebus" ;
  receiver_nn_1 = mkN "receiver" ;
  recensent_nn_1 = mkN "recensent" "recensenter" ;
  recension_nn_1 = mkN "recension" "recensioner" ;
  recensionsexemplar_nn_1 = mkN "recensionsexemplar" neutrum ;
  recent_av_1 = mkA "recent" "recent" ;
  recentior_nn_1 = mkN "recentior" "recentiorer" ;
  recept_nn_1 = mkN "recept" neutrum ;
  receptarie_nn_1 = mkN "receptarie" "receptarier" ;
  receptbelagd_av_1 = mkA "receptbelagd" "receptbelagt" ;
  reception_nn_1 = mkN "reception" "receptioner" ;
  receptionist_nn_1 = mkN "receptionist" "receptionister" ;
  receptiv_av_1 = mkA "receptiv" ;
  receptivitet_nn_1 = mkN "receptivitet" "receptiviteter" ;
  receptor_nn_1 = mkN "receptor" "receptorer" ;
  receptur_nn_1 = mkN "receptur" "recepturer" ;
  recess_nn_1 = mkN "recess" "recesser" ;
  recession_nn_1 = mkN "recession" "recessioner" ;
  recessiv_av_1 = mkA "recessiv" ;
  recett_nn_1 = mkN "recett" "recetter" ;
  recherch_nn_1 = mkN "recherch" "rechercher" ;
  recidiv_nn_1 = mkN "recidiv" neutrum ;
  recipiend_nn_1 = mkN "recipiend" "recipiender" ;
  recipient_nn_1 = mkN "recipient" "recipienter" ;
  reciprocitet_nn_1 = mkN "reciprocitet" "reciprociteter" ;
  reciprok_av_1 = mkA "reciprok" ;
  recit_nn_1 = mkN "recit" "reciter" ;
  recitation_nn_1 = mkN "recitation" "recitationer" ;
  recitativ_nn_1 = mkN "recitativ" neutrum ;
  reda_ab_1 = mkAdv "reda" ;
  redaktion_nn_1 = mkN "redaktion" "redaktioner" ;
  redaktionell_av_1 = mkA "redaktionell" ;
  redaktionssekreterare_nn_1 = mkN "redaktionssekreterare" "redaktionssekreterare" ;
  redaktoer_nn_1 = mkN "redaktцr" "redaktцrer" ;
  redan_ab_1 = mkAdv "redan" ;
  redare_nn_1 = mkN "redare" "redare" ;
  redbar_av_1 = mkA "redbar" ;
  redd_nn_1 = mkN "redd" "redder" ;
  rederi_nn_1 = mkN "rederi" "rederit" "rederier" "rederierna" ;
  rederiverksamhet_nn_1 = mkN "rederiverksamhet" "rederiverksamheter" ;
  redig_av_1 = mkA "redig" ;
  redikyl_nn_1 = mkN "redikyl" "redikyler" ;
  redingot_nn_1 = mkN "redingot" "redingoter" ;
  redlig_av_1 = mkA "redlig" ;
  redligen_ab_1 = mkAdv "redligen" ;
  redlighet_nn_1 = mkN "redlighet" "redligheter" ;
  redloes_av_1 = mkA "redlцs" ;
  redning_nn_1 = mkN "redning" ;
  redo_av_1 = mkA "redo" ;
  redobogen_av_1 = mkA "redobogen" "redoboget" ;
  redogoerelse_nn_1 = mkN "redogцrelse" "redogцrelser" ;
  redovisning_nn_1 = mkN "redovisning" ;
  redoxprocess_nn_1 = mkN "redoxprocess" "redoxprocesser" ;
  redskap_nn_1 = mkN "redskap" "redskapet" "redskapen" "redskapena" ;
  redskapsmetall_nn_1 = mkN "redskapsmetall" "redskapsmetaller" ;
  reducering_nn_1 = mkN "reducering" ;
  reduceringsventil_nn_1 = mkN "reduceringsventil" "reduceringsventiler" ;
  reduktion_nn_1 = mkN "reduktion" "reduktioner" ;
  redundant_av_1 = mkA "redundant" "redundant" ;
  reduplikation_nn_1 = mkN "reduplikation" "reduplikationer" ;
  redutt_nn_1 = mkN "redutt" "redutter" ;
  reell_av_1 = mkA "reell" ;
  refektorium_nn_1 = mkN "refektorium" "refektoriet" "refektorier" "refektorierna" ;
  referat_nn_1 = mkN "referat" neutrum ;
  referendum_nn_1 = mkN "referendum" neutrum ;
  referens_nn_1 = mkN "referens" "referenser" ;
  referensbibliotek_nn_1 = mkN "referensbibliotek" neutrum ;
  referensgrupp_nn_1 = mkN "referensgrupp" "referensgrupper" ;
  referensmaterial_nn_1 = mkN "referensmaterial" neutrum ;
  referenspunkt_nn_1 = mkN "referenspunkt" "referenspunkter" ;
  referensram_nn_1 = mkN "referensram" ;
  referenssort_nn_1 = mkN "referenssort" "referenssorter" ;
  referenssystem_nn_1 = mkN "referenssystem" neutrum ;
  referent_nn_1 = mkN "referent" "referenter" ;
  refill_nn_1 = mkN "refill" "refiller" ;
  reflektion_nn_1 = mkN "reflektion" "reflektioner" ;
  reflektor_nn_1 = mkN "reflektor" "reflektorer" ;
  reflex_nn_1 = mkN "reflex" "reflexer" ;
  reflexion_nn_1 = mkN "reflexion" "reflexioner" ;
  reflexiv_av_1 = mkA "reflexiv" ;
  reflexmaessig_av_1 = mkA "reflexmдssig" ;
  reform_nn_1 = mkN "reform" "reformer" ;
  reformation_nn_1 = mkN "reformation" "reformationer" ;
  reformator_nn_1 = mkN "reformator" "reformatorer" ;
  reformering_nn_1 = mkN "reformering" ;
  reformert_av_1 = mkA "reformert" "reformert" ;
  reformist_nn_1 = mkN "reformist" "reformister" ;
  refraeng_nn_1 = mkN "refrдng" "refrдnger" ;
  refraengsaangare_nn_1 = mkN "refrдngsеngare" "refrдngsеngare" ;
  refraktion_nn_1 = mkN "refraktion" "refraktioner" ;
  refraktor_nn_1 = mkN "refraktor" "refraktorer" ;
  refug_nn_1 = mkN "refug" "refuger" ;
  regal_av_1 = mkA "regal" ;
  regal_nn_1 = mkN "regal" "regaler" ;
  regalskepp_nn_1 = mkN "regalskepp" neutrum ;
  regel_nn_1 = mkN "regel" "regeln" "regler" "reglerna" ;
  regel_nn_2 = mkN "regel" ;
  regelbaat_nn_1 = mkN "regelbеt" ;
  regelbrott_nn_1 = mkN "regelbrott" neutrum ;
  regelbunden_av_1 = mkA "regelbunden" "regelbundet" ;
  regelbundenhet_nn_1 = mkN "regelbundenhet" "regelbundenheter" ;
  regelloes_av_1 = mkA "regellцs" ;
  regelraett_av_1 = mkA "regelrдtt" ;
  regelvidrig_av_1 = mkA "regelvidrig" ;
  regementschef_nn_1 = mkN "regementschef" "regementschefer" ;
  regementsofficer_nn_1 = mkN "regementsofficer" "regementsofficern" "regementsofficerare" "regementsofficerarna" ;
  regeneration_nn_1 = mkN "regeneration" "regenerationer" ;
  regenerator_nn_1 = mkN "regenerator" "regeneratorer" ;
  regent_nn_1 = mkN "regent" "regenter" ;
  regentlaengd_nn_1 = mkN "regentlдngd" "regentlдngder" ;
  regering_nn_1 = mkN "regering" ;
  regeringsbaenk_nn_1 = mkN "regeringsbдnk" ;
  regeringsbeslut_nn_1 = mkN "regeringsbeslut" neutrum ;
  regeringschef_nn_1 = mkN "regeringschef" "regeringschefer" ;
  regeringsform_nn_1 = mkN "regeringsform" "regeringsformer" ;
  regeringskansli_nn_1 = mkN "regeringskansli" "regeringskanslit" "regeringskanslier" "regeringskanslierna" ;
  regeringskrets_nn_1 = mkN "regeringskrets" ;
  regeringsmakt_nn_1 = mkN "regeringsmakt" "regeringsmakter" ;
  regeringsmedlem_nn_1 = mkN "regeringsmedlem" "regeringsmedlemmen" "regeringsmedlemmar" "regeringsmedlemmarna" ;
  regeringsorgan_nn_1 = mkN "regeringsorgan" neutrum ;
  regeringsparti_nn_1 = mkN "regeringsparti" "regeringspartit" "regeringspartier" "regeringspartierna" ;
  regeringsproposition_nn_1 = mkN "regeringsproposition" "regeringspropositioner" ;
  regeringsraad_nn_1 = mkN "regeringsrеd" neutrum ;
  regeringsraett_nn_1 = mkN "regeringsrдtt" "regeringsrдtter" ;
  regim_nn_1 = mkN "regim" "regimer" ;
  region_nn_1 = mkN "region" "regioner" ;
  regional_av_1 = mkA "regional" ;
  regionplan_nn_1 = mkN "regionplan" "regionplaner" ;
  regionsjukhus_nn_1 = mkN "regionsjukhus" neutrum ;
  regionstyrelse_nn_1 = mkN "regionstyrelse" "regionstyrelser" ;
  regissoer_nn_1 = mkN "regissцr" "regissцrer" ;
  register_nn_1 = mkN "register" neutrum ;
  registerknapp_nn_1 = mkN "registerknapp" ;
  registerton_nn_1 = mkN "registerton" "registertonnet" "registerton" "registertonnen" ;
  registrator_nn_1 = mkN "registrator" "registratorer" ;
  registratur_nn_1 = mkN "registratur" neutrum ;
  registrering_nn_1 = mkN "registrering" ;
  registreringsnummer_nn_1 = mkN "registreringsnummer" neutrum ;
  registreringsskylt_nn_1 = mkN "registreringsskylt" ;
  reglage_nn_1 = mkN "reglage" "reglaget" "reglage" "reglagen" ;
  reglementarisk_av_1 = mkA "reglementarisk" ;
  reglementsenlig_av_1 = mkA "reglementsenlig" ;
  reglementsvidrig_av_1 = mkA "reglementsvidrig" ;
  reglering_nn_1 = mkN "reglering" ;
  regn_nn_1 = mkN "regn" neutrum ;
  regnande_nn_1 = mkN "regnande" ;
  regnbaage_nn_1 = mkN "regnbеge" utrum ;
  regnbaagshinna_nn_1 = mkN "regnbеgshinna" ;
  regndroppe_nn_1 = mkN "regndroppe" utrum ;
  regnig_av_1 = mkA "regnig" ;
  regnmaetare_nn_1 = mkN "regnmдtare" "regnmдtare" ;
  regnmoln_nn_1 = mkN "regnmoln" neutrum ;
  regnomraade_nn_1 = mkN "regnomrеde" ;
  regnperiod_nn_1 = mkN "regnperiod" "regnperioder" ;
  regnskog_nn_1 = mkN "regnskog" ;
  regntaet_av_1 = mkA "regntдt" ;
  regntid_nn_1 = mkN "regntid" "regntider" ;
  regntung_av_1 = mkA "regntung" ;
  regnvatten_nn_1 = mkN "regnvatten" "regnvattnet" "regnvatten" "regnvattnen" ;
  regress_nn_1 = mkN "regress" "regresser" ;
  regression_nn_1 = mkN "regression" "regressioner" ;
  regressiv_av_1 = mkA "regressiv" ;
  regular_av_1 = mkA "regular" ;
  regularitet_nn_1 = mkN "regularitet" "regulariteter" ;
  regulator_nn_1 = mkN "regulator" "regulatorer" ;
  reguljaer_av_1 = mkA "reguljдr" ;
  rehabilitering_nn_1 = mkN "rehabilitering" ;
  rehabiliteringshem_nn_1 = mkN "rehabiliteringshem" neutrum ;
  reifikation_nn_1 = mkN "reifikation" "reifikationer" ;
  reinkarnation_nn_1 = mkN "reinkarnation" "reinkarnationer" ;
  rejael_av_1 = mkA "rejдl" ;
  rek_nn_1 = mkN "rek" neutrum ;
  rekapitulation_nn_1 = mkN "rekapitulation" "rekapitulationer" ;
  reklam_nn_1 = mkN "reklam" "reklamer" ;
  reklamation_nn_1 = mkN "reklamation" "reklamationer" ;
  reklampeng_nn_1 = mkN "reklampeng" ;
  reklamplakat_nn_1 = mkN "reklamplakat" neutrum ;
  reko_av_1 = mkA "reko" ;
  rekognoscering_nn_1 = mkN "rekognoscering" ;
  rekognosering_nn_1 = mkN "rekognosering" ;
  rekommendabel_av_1 = mkA "rekommendabel" "rekommendabelt" "rekommendabla" "rekommendabla" "rekommendablare" "rekommendablast" "rekommendablaste" ;
  rekommendation_nn_1 = mkN "rekommendation" "rekommendationer" ;
  rekommendationsbrev_nn_1 = mkN "rekommendationsbrev" neutrum ;
  rekonstruktion_nn_1 = mkN "rekonstruktion" "rekonstruktioner" ;
  rekord_nn_1 = mkN "rekord" neutrum ;
  rekorderlig_av_1 = mkA "rekorderlig" ;
  rekreation_nn_1 = mkN "rekreation" "rekreationer" ;
  rekreationsanlaeggning_nn_1 = mkN "rekreationsanlдggning" ;
  rekreationsskog_nn_1 = mkN "rekreationsskog" ;
  rekreativ_av_1 = mkA "rekreativ" ;
  rekryt_nn_1 = mkN "rekryt" "rekryter" ;
  rekrytering_nn_1 = mkN "rekrytering" ;
  rektangel_nn_1 = mkN "rektangel" ;
  rektangulaer_av_1 = mkA "rektangulдr" ;
  rektascension_nn_1 = mkN "rektascension" "rektascensioner" ;
  rektifikation_nn_1 = mkN "rektifikation" "rektifikationer" ;
  rektion_nn_1 = mkN "rektion" "rektioner" ;
  rektor_nn_1 = mkN "rektor" "rektorer" ;
  rektorat_nn_1 = mkN "rektorat" neutrum ;
  rektorsomraade_nn_1 = mkN "rektorsomrеde" ;
  rekurrens_nn_1 = mkN "rekurrens" "rekurrenser" ;
  rekurrensrelation_nn_1 = mkN "rekurrensrelation" "rekurrensrelationer" ;
  rekviem_nn_1 = mkN "rekviem" neutrum ;
  rekvisit_nn_1 = mkN "rekvisit" neutrum ;
  rekvisition_nn_1 = mkN "rekvisition" "rekvisitioner" ;
  rekvisitoer_nn_1 = mkN "rekvisitцr" "rekvisitцrer" ;
  rekyl_nn_1 = mkN "rekyl" "rekyler" ;
  relae_nn_1 = mkN "relд" "relдt" "relдer" "relдerna" ;
  relaestation_nn_1 = mkN "relдstation" "relдstationer" ;
  relation_nn_1 = mkN "relation" "relationer" ;
  relationstal_nn_1 = mkN "relationstal" "relationstalet" "relationstalen" "relationstalena" ;
  relativ_av_1 = mkA "relativ" ;
  relativist_nn_1 = mkN "relativist" "relativister" ;
  relativistisk_av_1 = mkA "relativistisk" ;
  relativitet_nn_1 = mkN "relativitet" "relativiteter" ;
  relativpronomen_nn_1 = mkN "relativpronomen" neutrum ;
  relativsats_nn_1 = mkN "relativsats" "relativsatser" ;
  relativt_ab_1 = mkAdv "relativt" ;
  relaxation_nn_1 = mkN "relaxation" "relaxationer" ;
  release_nn_1 = mkN "release" "releaser" ;
  relevant_av_1 = mkA "relevant" "relevant" ;
  reliabel_av_1 = mkA "reliabel" "reliabelt" "reliabla" "reliabla" "reliablare" "reliablast" "reliablaste" ;
  reliabilitet_nn_1 = mkN "reliabilitet" "reliabiliteter" ;
  relief_nn_1 = mkN "relief" "reliefer" ;
  religioes_av_1 = mkA "religiцs" ;
  religion_nn_1 = mkN "religion" "religioner" ;
  religionsfoerfoeljelse_nn_1 = mkN "religionsfцrfцljelse" "religionsfцrfцljelser" ;
  religionsfrihet_nn_1 = mkN "religionsfrihet" "religionsfriheter" ;
  religionslaera_nn_1 = mkN "religionslдra" ;
  religionsstiftare_nn_1 = mkN "religionsstiftare" "religionsstiftare" ;
  religiositet_nn_1 = mkN "religiositet" "religiositeter" ;
  relik_nn_1 = mkN "relik" "reliker" ;
  relikt_nn_1 = mkN "relikt" "relikter" ;
  reling_nn_1 = mkN "reling" ;
  relingsmanning_nn_1 = mkN "relingsmanning" ;
  rem_nn_1 = mkN "rem" "remmen" "remmar" "remmarna" ;
  rem_nn_2 = mkN "rem" "remen" "rem" "remen" ;
  remarkabel_av_1 = mkA "remarkabel" "remarkabelt" "remarkabla" "remarkabla" "remarkablare" "remarkablast" "remarkablaste" ;
  remburs_nn_1 = mkN "remburs" "remburser" ;
  remedium_nn_1 = mkN "remedium" "remediumet" "remedium" "remedierna" ;
  remi_nn_1 = mkN "remi" "remier" ;
  reminiscens_nn_1 = mkN "reminiscens" "reminiscenser" ;
  remis_nn_2 = mkN "remis" "remiser" ;
  remiss_nn_1 = mkN "remiss" "remisser" ;
  remissdebatt_nn_1 = mkN "remissdebatt" "remissdebatter" ;
  remissvar_nn_1 = mkN "remissvar" neutrum ;
  remissyttrande_nn_1 = mkN "remissyttrande" ;
  remittent_av_1 = mkA "remittent" "remittent" ;
  remittent_nn_1 = mkN "remittent" "remittenter" ;
  remmare_nn_1 = mkN "remmare" "remmare" ;
  remont_nn_1 = mkN "remont" "remonter" ;
  remouladsaas_nn_1 = mkN "remouladsеs" "remouladsеser" ;
  remtyg_nn_1 = mkN "remtyg" neutrum ;
  remuladsaas_nn_1 = mkN "remuladsеs" "remuladsеser" ;
  ren_ab_1 = mkAdv "ren" ;
  ren_av_1 = mkA "ren" ;
  ren_nn_1 = mkN "ren" "renen" "renar" "renarna" ;
  renaessans_nn_1 = mkN "renдssans" "renдssanser" ;
  renaessansmaenniska_nn_1 = mkN "renдssansmдnniska" ;
  renben_nn_1 = mkN "renben" neutrum ;
  rendezvous_nn_1 = mkN "rendezvous" "rendezvouset" "rendezvouser" "rendezvouserna" ;
  renegat_nn_1 = mkN "renegat" "renegater" ;
  renfaell_nn_1 = mkN "renfдll" ;
  rengoering_nn_1 = mkN "rengцring" ;
  rengoeringsmedel_nn_1 = mkN "rengцringsmedel" neutrum ;
  renhaallningsgubbe_nn_1 = mkN "renhеllningsgubbe" utrum ;
  renhaarig_av_1 = mkA "renhеrig" ;
  renhet_nn_1 = mkN "renhet" "renheter" ;
  renhorn_nn_1 = mkN "renhorn" neutrum ;
  rening_nn_1 = mkN "rening" ;
  reningsverk_nn_1 = mkN "reningsverk" neutrum ;
  renjaegare_nn_1 = mkN "renjдgare" "renjдgare" ;
  renjakt_nn_1 = mkN "renjakt" "renjakter" ;
  renko_nn_1 = mkN "renko" "renkor" ;
  renkonter_nn_1 = mkN "renkonter" "renkontern" "renkontrer" "renkontrerna" ;
  renkonterstrid_nn_1 = mkN "renkonterstrid" "renkonterstrider" ;
  renlaerig_av_1 = mkA "renlдrig" ;
  renlaerighet_nn_1 = mkN "renlдrighet" "renlдrigheter" ;
  renlav_nn_1 = mkN "renlav" ;
  renlevnad_nn_1 = mkN "renlevnad" "renlevnader" ;
  renlevnadsman_nn_1 = mkN "renlevnadsman" "renlevnadsmannen" "renlevnadsmдn" "renlevnadsmдnnen" ;
  renlig_av_1 = mkA "renlig" ;
  renlighet_nn_1 = mkN "renlighet" "renligheter" ;
  renmaerke_nn_1 = mkN "renmдrke" ;
  renmage_nn_1 = mkN "renmage" utrum ;
  renons_av_1 = mkA "renons" ;
  renovation_nn_1 = mkN "renovation" "renovationer" ;
  renovering_nn_1 = mkN "renovering" ;
  renoxe_nn_1 = mkN "renoxe" utrum ;
  renrasig_av_1 = mkA "renrasig" ;
  renseri_nn_1 = mkN "renseri" "renserit" "renserier" "renserierna" ;
  renskiljning_nn_1 = mkN "renskiljning" ;
  renskinn_nn_1 = mkN "renskinn" neutrum ;
  renskinnspaels_nn_1 = mkN "renskinnspдls" ;
  renskoetare_nn_1 = mkN "renskцtare" "renskцtare" ;
  renskriva_vb_1 = mkV "renskriva" "renskrev" "renskrivit" ;
  renskrivning_nn_1 = mkN "renskrivning" ;
  rensning_nn_1 = mkN "rensning" ;
  rentav_ab_1 = mkAdv "rentav" ;
  rentier_nn_1 = mkN "rentier" "rentierer" ;
  rentjur_nn_1 = mkN "rentjur" ;
  rentre_nn_1 = mkN "rentrй" "rentrйer" ;
  rentutav_ab_1 = mkAdv "rentutav" ;
  reol_nn_1 = mkN "reol" "reoler" ;
  reostat_nn_1 = mkN "reostat" "reostater" ;
  rep_nn_1 = mkN "rep" neutrum ;
  repaenda_nn_1 = mkN "repдnda" "repдndan" "repдndar" "repдndarna" ;
  reparabel_av_1 = mkA "reparabel" "reparabelt" "reparabla" "reparabla" "reparablare" "reparablast" "reparablaste" ;
  reparation_nn_1 = mkN "reparation" "reparationer" ;
  reparatoer_nn_1 = mkN "reparatцr" "reparatцrer" ;
  repartition_nn_1 = mkN "repartition" "repartitioner" ;
  repertoar_nn_1 = mkN "repertoar" "repertoarer" ;
  repetergevaer_nn_1 = mkN "repetergevдr" neutrum ;
  repetition_nn_1 = mkN "repetition" "repetitioner" ;
  repetitionsoevning_nn_1 = mkN "repetitionsцvning" ;
  repetitoer_nn_1 = mkN "repetitцr" "repetitцrer" ;
  repetitorium_nn_1 = mkN "repetitorium" "repetitoriet" "repetitorier" "repetitorierna" ;
  repig_av_1 = mkA "repig" ;
  replik_nn_1 = mkN "replik" "repliker" ;
  replipunkt_nn_1 = mkN "replipunkt" "replipunkter" ;
  repmaanad_nn_1 = mkN "repmеnad" "repmеnader" ;
  repoevning_nn_1 = mkN "repцvning" ;
  reportage_nn_1 = mkN "reportage" "reportaget" "reportage" "reportagen" ;
  reportagebok_nn_1 = mkN "reportagebok" "reportagebцcker" ;
  reporter_nn_1 = mkN "reporter" ;
  representant_nn_1 = mkN "representant" "representanter" ;
  representation_nn_1 = mkN "representation" "representationer" ;
  representativ_av_1 = mkA "representativ" ;
  repressalie_nn_1 = mkN "repressalie" "repressalier" ;
  repressiv_av_1 = mkA "repressiv" ;
  reprimand_nn_1 = mkN "reprimand" "reprimander" ;
  repris_nn_1 = mkN "repris" "repriser" ;
  repristecken_nn_1 = mkN "repristecken" "repristecknet" "repristecken" "repristecknen" ;
  reproduktion_nn_1 = mkN "reproduktion" "reproduktioner" ;
  repslagare_nn_1 = mkN "repslagare" "repslagare" ;
  repstege_nn_1 = mkN "repstege" utrum ;
  reptil_nn_1 = mkN "reptil" "reptiler" ;
  republik_nn_1 = mkN "republik" "republiker" ;
  republikan_nn_1 = mkN "republikan" "republikaner" ;
  republikansk_av_1 = mkA "republikansk" ;
  repulsion_nn_1 = mkN "repulsion" "repulsioner" ;
  repulsiv_av_1 = mkA "repulsiv" ;
  reputerlig_av_1 = mkA "reputerlig" ;
  resaar_nn_1 = mkN "resеr" "resеrer" ;
  resande_nn_1 = mkN "resande" "resanden" "resande" "resandena" ;
  resandebok_nn_1 = mkN "resandebok" "resandebцcker" ;
  rese_nn_1 = mkN "rese" utrum ;
  resebiljett_nn_1 = mkN "resebiljett" "resebiljetter" ;
  resebyraa_nn_1 = mkN "resebyrе" "resebyrеer" ;
  resecheck_nn_1 = mkN "resecheck" ;
  resefoerbud_nn_1 = mkN "resefцrbud" neutrum ;
  resegrammofon_nn_1 = mkN "resegrammofon" "resegrammofoner" ;
  resekreditiv_nn_1 = mkN "resekreditiv" neutrum ;
  resektion_nn_1 = mkN "resektion" "resektioner" ;
  reseledare_nn_1 = mkN "reseledare" "reseledare" ;
  resenaer_nn_1 = mkN "resenдr" "resenдrer" ;
  reseraekning_nn_1 = mkN "reserдkning" ;
  reserv_nn_1 = mkN "reserv" "reserver" ;
  reservant_nn_1 = mkN "reservant" "reservanter" ;
  reservare_nn_1 = mkN "reservare" "reservare" ;
  reservat_nn_1 = mkN "reservat" neutrum ;
  reservation_nn_1 = mkN "reservation" "reservationer" ;
  reservdel_nn_1 = mkN "reservdel" "reservdelen" "reservdelar" "reservdelarna" ;
  reservlager_nn_1 = mkN "reservlager" neutrum ;
  reservnaering_nn_1 = mkN "reservnдring" ;
  reservoar_nn_1 = mkN "reservoar" "reservoarer" ;
  reservofficer_nn_1 = mkN "reservofficer" "reservofficern" "reservofficerare" "reservofficerarna" ;
  reservspelare_nn_1 = mkN "reservspelare" "reservspelare" ;
  reseskildring_nn_1 = mkN "reseskildring" ;
  residens_nn_1 = mkN "residens" neutrum ;
  residensstad_nn_1 = mkN "residensstad" "residensstдder" ;
  residuum_nn_1 = mkN "residuum" "residuet" "residuer" "residuerna" ;
  resistensomraade_nn_1 = mkN "resistensomrеde" ;
  resistent_av_1 = mkA "resistent" "resistent" ;
  resistivitet_nn_1 = mkN "resistivitet" "resistiviteter" ;
  resistor_nn_1 = mkN "resistor" "resistorer" ;
  resklass_nn_1 = mkN "resklass" "resklasser" ;
  reskript_nn_1 = mkN "reskript" neutrum ;
  reslig_av_1 = mkA "reslig" ;
  resning_nn_1 = mkN "resning" ;
  resolut_av_1 = mkA "resolut" "resolut" ;
  resolution_nn_1 = mkN "resolution" "resolutioner" ;
  resonabel_av_1 = mkA "resonabel" "resonabelt" "resonabla" "resonabla" "resonablare" "resonablast" "resonablaste" ;
  resonansbotten_nn_1 = mkN "resonansbotten" ;
  resonemang_nn_1 = mkN "resonemang" neutrum ;
  resonemangskarusell_nn_1 = mkN "resonemangskarusell" "resonemangskaruseller" ;
  resonemangsparti_nn_1 = mkN "resonemangsparti" "resonemangspartit" "resonemangspartier" "resonemangspartierna" ;
  resonlig_av_1 = mkA "resonlig" ;
  resonoer_nn_1 = mkN "resonцr" "resonцrer" ;
  respass_nn_1 = mkN "respass" neutrum ;
  respektabel_av_1 = mkA "respektabel" "respektabelt" "respektabla" "respektabla" "respektablare" "respektablast" "respektablaste" ;
  respektfull_av_1 = mkA "respektfull" ;
  respektingivande_av_1 = mkA "respektingivande" ;
  respektive_av_1 = mkA "respektive" ;
  respektloes_av_1 = mkA "respektlцs" ;
  respirator_nn_1 = mkN "respirator" "respiratorer" ;
  respiratorisk_av_1 = mkA "respiratorisk" ;
  respit_nn_1 = mkN "respit" "respiter" ;
  respondent_nn_1 = mkN "respondent" "respondenter" ;
  ressentiment_nn_1 = mkN "ressentiment" neutrum ;
  rest_nn_1 = mkN "rest" "rester" ;
  restaurang_nn_1 = mkN "restaurang" "restauranger" ;
  restauranggaest_nn_1 = mkN "restauranggдst" "restauranggдster" ;
  restaurangkoek_nn_1 = mkN "restaurangkцk" neutrum ;
  restaurangvagn_nn_1 = mkN "restaurangvagn" ;
  restauration_nn_1 = mkN "restauration" "restaurationer" ;
  restauratoer_nn_1 = mkN "restauratцr" "restauratцrer" ;
  restaurator_nn_1 = mkN "restaurator" "restauratorer" ;
  restauratris_nn_1 = mkN "restauratris" "restauratriser" ;
  restaurering_nn_1 = mkN "restaurering" ;
  restitution_nn_1 = mkN "restitution" "restitutioner" ;
  restlaengd_nn_1 = mkN "restlдngd" "restlдngder" ;
  restlager_nn_1 = mkN "restlager" neutrum ;
  restloes_av_1 = mkA "restlцs" ;
  restprodukt_nn_1 = mkN "restprodukt" "restprodukter" ;
  restriktion_nn_1 = mkN "restriktion" "restriktioner" ;
  restriktiv_av_1 = mkA "restriktiv" ;
  restskatt_nn_1 = mkN "restskatt" "restskatter" ;
  resultant_nn_1 = mkN "resultant" "resultanter" ;
  resultat_nn_1 = mkN "resultat" neutrum ;
  resultativ_av_1 = mkA "resultativ" ;
  resultatloes_av_1 = mkA "resultatlцs" ;
  resultatraekning_nn_1 = mkN "resultatrдkning" ;
  resultatredovisning_nn_1 = mkN "resultatredovisning" ;
  resume_nn_1 = mkN "resumй" "resumйer" ;
  resurs_nn_1 = mkN "resurs" "resurser" ;
  resvaeg_nn_1 = mkN "resvдg" ;
  retardation_nn_1 = mkN "retardation" "retardationer" ;
  retbarhet_nn_1 = mkN "retbarhet" "retbarheter" ;
  retfull_av_1 = mkA "retfull" ;
  retlig_av_1 = mkA "retlig" ;
  retning_nn_1 = mkN "retning" ;
  retor_nn_1 = mkN "retor" "retorer" ;
  retoriker_nn_1 = mkN "retoriker" "retorikern" "retoriker" "retorikerna" ;
  retorisk_av_1 = mkA "retorisk" ;
  retort_nn_1 = mkN "retort" "retorter" ;
  retraett_nn_1 = mkN "retrдtt" "retrдtter" ;
  retraettplats_nn_1 = mkN "retrдttplats" "retrдttplatser" ;
  retriever_nn_1 = mkN "retriever" ;
  retroaktiv_av_1 = mkA "retroaktiv" ;
  retrospektiv_av_1 = mkA "retrospektiv" ;
  retsam_av_1 = mkA "retsam" "retsamt" "retsamma" "retsamma" "retsammare" "retsammast" "retsammaste" ;
  retsamhet_nn_1 = mkN "retsamhet" "retsamheter" ;
  retur_nn_1 = mkN "retur" "returer" ;
  returglas_nn_1 = mkN "returglas" neutrum ;
  returmatch_nn_1 = mkN "returmatch" "returmatcher" ;
  returporto_nn_1 = mkN "returporto" "returportot" "returporton" "returportona" ;
  retusch_nn_1 = mkN "retusch" "retuscher" ;
  reumatiker_nn_1 = mkN "reumatiker" "reumatikern" "reumatiker" "reumatikerna" ;
  reumatisk_av_1 = mkA "reumatisk" ;
  reumatolog_nn_1 = mkN "reumatolog" "reumatologer" ;
  rev_nn_1 = mkN "rev" neutrum ;
  rev_nn_2 = mkN "rev" ;
  revaer_nn_1 = mkN "revдr" "revдrer" ;
  revansch_nn_1 = mkN "revansch" "revanscher" ;
  revben_nn_1 = mkN "revben" neutrum ;
  revbensspjaell_nn_1 = mkN "revbensspjдll" neutrum ;
  revel_nn_1 = mkN "revel" ;
  revelation_nn_1 = mkN "revelation" "revelationer" ;
  revelj_nn_1 = mkN "revelj" "reveljer" ;
  reveny_nn_1 = mkN "reveny" "revenyer" ;
  reverens_nn_1 = mkN "reverens" "reverenser" ;
  reverenter_ab_1 = mkAdv "reverenter" ;
  revers_nn_1 = mkN "revers" "reverser" ;
  reversal_nn_1 = mkN "reversal" neutrum ;
  reversibel_av_1 = mkA "reversibel" "reversibelt" "reversibla" "reversibla" "reversiblare" "reversiblast" "reversiblaste" ;
  revider_nn_1 = mkN "revider" "revideret" "revider" "revideren" ;
  revir_nn_1 = mkN "revir" neutrum ;
  revision_nn_1 = mkN "revision" "revisioner" ;
  revisionist_nn_1 = mkN "revisionist" "revisionister" ;
  revisionsberaettelse_nn_1 = mkN "revisionsberдttelse" "revisionsberдttelser" ;
  revisionssekreterare_nn_1 = mkN "revisionssekreterare" "revisionssekreterare" ;
  revisor_nn_1 = mkN "revisor" "revisorer" ;
  revning_nn_1 = mkN "revning" ;
  revoke_nn_1 = mkN "revoke" "revoker" ;
  revolt_nn_1 = mkN "revolt" "revolter" ;
  revoltoer_nn_1 = mkN "revoltцr" "revoltцrer" ;
  revolution_nn_1 = mkN "revolution" "revolutioner" ;
  revolutionaer_av_1 = mkA "revolutionдr" ;
  revolutionaer_nn_1 = mkN "revolutionдr" "revolutionдrer" ;
  revolutionerande_av_1 = mkA "revolutionerande" ;
  revolver_nn_1 = mkN "revolver" ;
  revorm_nn_1 = mkN "revorm" ;
  revy_nn_1 = mkN "revy" "revyer" ;
  revyartist_nn_1 = mkN "revyartist" "revyartister" ;
  rh_faktor_nn_1 = mkN "rh-faktor" "rh-faktorer" ;
  rh_negativ_av_1 = mkA "rh-negativ" ;
  rh_positiv_av_1 = mkA "rh-positiv" ;
  rhensk_av_1 = mkA "rhensk" ;
  rhenvin_nn_1 = mkN "rhenvin" "rhenvinet" "rhenviner" "rhenvinerna" ;
  rhizom_nn_1 = mkN "rhizom" "rhizomer" ;
  rhodesier_nn_1 = mkN "rhodesier" "rhodesiern" "rhodesier" "rhodesierna" ;
  rhodesisk_av_1 = mkA "rhodesisk" ;
  rhododendron_nn_1 = mkN "rhododendron" "rhododendronen" "rhododendron" "rhododendrerna" ;
  ri_nn_1 = mkN "ri" "riet" "rin" "rien" ;
  ribbstol_nn_1 = mkN "ribbstol" ;
  ribbvalv_nn_1 = mkN "ribbvalv" neutrum ;
  ribosom_nn_1 = mkN "ribosom" "ribosomer" ;
  ricinbuske_nn_1 = mkN "ricinbuske" utrum ;
  rickettsie_nn_1 = mkN "rickettsie" "rickettsier" ;
  rickig_av_1 = mkA "rickig" ;
  rickshaw_nn_1 = mkN "rickshaw" "rickshawn" "rickshawer" "rickshawerna" ;
  rida_vb_1 = mkV "rida" "red" "ridit" ;
  ridaa_nn_1 = mkN "ridе" "ridеer" ;
  ridaafall_nn_1 = mkN "ridеfall" neutrum ;
  ridborgarmaerke_nn_1 = mkN "ridborgarmдrke" ;
  riddare_nn_1 = mkN "riddare" "riddare" ;
  riddarhus_nn_1 = mkN "riddarhus" neutrum ;
  riddarorden_nn_1 = mkN "riddarorden" ;
  riddarslag_nn_1 = mkN "riddarslag" neutrum ;
  riddarsporre_nn_1 = mkN "riddarsporre" utrum ;
  ridderlig_av_1 = mkA "ridderlig" ;
  riddersman_nn_1 = mkN "riddersman" "riddersmannen" "riddersmдn" "riddersmдnnen" ;
  ridhaest_nn_1 = mkN "ridhдst" ;
  ridhaestdressyr_nn_1 = mkN "ridhдstdressyr" "ridhдstdressyrer" ;
  ridhus_nn_1 = mkN "ridhus" neutrum ;
  ridikyl_nn_1 = mkN "ridikyl" "ridikyler" ;
  ridinstruktoer_nn_1 = mkN "ridinstruktцr" "ridinstruktцrer" ;
  ridkunnig_av_1 = mkA "ridkunnig" ;
  ridkunnighet_nn_1 = mkN "ridkunnighet" "ridkunnigheter" ;
  ridkunnighetsprov_nn_1 = mkN "ridkunnighetsprov" neutrum ;
  ridning_nn_1 = mkN "ridning" ;
  ridsaar_nn_1 = mkN "ridsеr" neutrum ;
  ridspoe_nn_1 = mkN "ridspц" "ridspцet" "ridspцn" "ridspцna" ;
  ridstoevel_nn_1 = mkN "ridstцvel" ;
  ridtaevling_nn_1 = mkN "ridtдvling" ;
  ridtur_nn_1 = mkN "ridtur" "ridturer" ;
  riesenschnauzer_nn_1 = mkN "riesenschnauzer" ;
  riff_nn_1 = mkN "riff" neutrum ;
  rififikupp_nn_1 = mkN "rififikupp" "rififikupper" ;
  rigel_nn_1 = mkN "rigel" ;
  rigg_nn_1 = mkN "rigg" ;
  rigoroes_av_1 = mkA "rigorцs" ;
  rik_av_1 = mkA "rik" ;
  rikedom_nn_1 = mkN "rikedom" ;
  rikeman_nn_1 = mkN "rikeman" "rikemannen" "rikemдn" "rikemдnnen" ;
  rikemansbarn_nn_1 = mkN "rikemansbarn" neutrum ;
  rikhaltig_av_1 = mkA "rikhaltig" ;
  riklig_av_1 = mkA "riklig" ;
  rikligen_ab_1 = mkAdv "rikligen" ;
  rikoschett_nn_1 = mkN "rikoschett" "rikoschetter" ;
  riks_nn_1 = mkN "riks" neutrum ;
  riksaaklagare_nn_1 = mkN "riksеklagare" "riksеklagare" ;
  riksantikvarie_nn_1 = mkN "riksantikvarie" "riksantikvarier" ;
  riksarkiv_nn_1 = mkN "riksarkiv" neutrum ;
  riksarkivarie_nn_1 = mkN "riksarkivarie" "riksarkivarier" ;
  riksbank_nn_1 = mkN "riksbank" "riksbanker" ;
  riksbekant_av_1 = mkA "riksbekant" "riksbekant" ;
  riksbibliotekarie_nn_1 = mkN "riksbibliotekarie" "riksbibliotekarier" ;
  riksbyggare_nn_1 = mkN "riksbyggare" "riksbyggare" ;
  riksdag_nn_1 = mkN "riksdag" ;
  riksdagsgrupp_nn_1 = mkN "riksdagsgrupp" "riksdagsgrupper" ;
  riksdagshus_nn_1 = mkN "riksdagshus" neutrum ;
  riksdagskvinna_nn_1 = mkN "riksdagskvinna" ;
  riksdagsledamot_nn_1 = mkN "riksdagsledamot" "riksdagsledamцter" ;
  riksdagsman_nn_1 = mkN "riksdagsman" "riksdagsmannen" "riksdagsmдn" "riksdagsmдnnen" ;
  riksdagsmandat_nn_1 = mkN "riksdagsmandat" neutrum ;
  riksdagsordning_nn_1 = mkN "riksdagsordning" ;
  riksdagsparti_nn_1 = mkN "riksdagsparti" "riksdagspartit" "riksdagspartier" "riksdagspartierna" ;
  riksdagsprotokoll_nn_1 = mkN "riksdagsprotokoll" neutrum ;
  riksdagssammantraede_nn_1 = mkN "riksdagssammantrдde" ;
  riksdagsval_nn_1 = mkN "riksdagsval" neutrum ;
  riksdaler_nn_1 = mkN "riksdaler" "riksdalern" "riksdaler" "riksdalerna" ;
  riksfoerbund_nn_1 = mkN "riksfцrbund" neutrum ;
  riksfoerestaandare_nn_1 = mkN "riksfцrestеndare" "riksfцrestеndare" ;
  riksgenomsnitt_nn_1 = mkN "riksgenomsnitt" neutrum ;
  riksgraens_nn_1 = mkN "riksgrдns" "riksgrдnser" ;
  rikskansler_nn_1 = mkN "rikskansler" "rikskanslern" "rikskanslerer" "rikskanslererna" ;
  rikslikare_nn_1 = mkN "rikslikare" "rikslikare" ;
  riksmarskalk_nn_1 = mkN "riksmarskalk" ;
  riksmoete_nn_1 = mkN "riksmцte" ;
  riksnaet_nn_1 = mkN "riksnдt" neutrum ;
  riksnyckel_nn_1 = mkN "riksnyckel" ;
  riksomfattande_av_1 = mkA "riksomfattande" ;
  riksorganisation_nn_1 = mkN "riksorganisation" "riksorganisationer" ;
  riksplanering_nn_1 = mkN "riksplanering" ;
  riksprototyp_nn_1 = mkN "riksprototyp" "riksprototyper" ;
  riksraad_nn_1 = mkN "riksrеd" neutrum ;
  riksraett_nn_1 = mkN "riksrдtt" "riksrдtter" ;
  riksroes_nn_1 = mkN "riksrцs" neutrum ;
  rikssamtal_nn_1 = mkN "rikssamtal" "rikssamtalet" "rikssamtalen" "rikssamtalena" ;
  riksspraak_nn_1 = mkN "rikssprеk" neutrum ;
  rikssvensk_av_1 = mkA "rikssvensk" ;
  rikstidning_nn_1 = mkN "rikstidning" ;
  riksvaeg_nn_1 = mkN "riksvдg" ;
  riksvapen_nn_1 = mkN "riksvapen" "riksvapnet" "riksvapen" "riksvapnen" ;
  riksviktig_av_1 = mkA "riksviktig" ;
  riktig_av_1 = mkA "riktig" ;
  riktighet_nn_1 = mkN "riktighet" "riktigheter" ;
  riktinstrument_nn_1 = mkN "riktinstrument" neutrum ;
  riktkarl_nn_1 = mkN "riktkarl" ;
  riktlinje_nn_1 = mkN "riktlinje" "riktlinjer" ;
  riktmaerke_nn_1 = mkN "riktmдrke" ;
  riktmedel_nn_1 = mkN "riktmedel" neutrum ;
  riktning_nn_1 = mkN "riktning" ;
  riktningskoefficient_nn_1 = mkN "riktningskoefficient" "riktningskoefficienter" ;
  riktnummer_nn_1 = mkN "riktnummer" neutrum ;
  riktpris_nn_1 = mkN "riktpris" neutrum ;
  riktpunkt_nn_1 = mkN "riktpunkt" "riktpunkter" ;
  rim_nn_1 = mkN "rim" "rimmet" "rim" "rimmen" ;
  rimlexikon_nn_1 = mkN "rimlexikon" neutrum ;
  rimlig_av_1 = mkA "rimlig" ;
  rimligen_ab_1 = mkAdv "rimligen" ;
  rimlighet_nn_1 = mkN "rimlighet" "rimligheter" ;
  rimligtvis_ab_1 = mkAdv "rimligtvis" ;
  rimsmed_nn_1 = mkN "rimsmed" "rimsmeder" ;
  rimturs_nn_1 = mkN "rimturs" ;
  ring_nn_1 = mkN "ring" ;
  ringa_av_1 = mkA "ringa" ;
  ringaktning_nn_1 = mkN "ringaktning" ;
  ringare_nn_1 = mkN "ringare" "ringare" ;
  ringart_nn_1 = mkN "ringart" "ringarter" ;
  ringberg_nn_1 = mkN "ringberg" neutrum ;
  ringbrosk_nn_1 = mkN "ringbrosk" neutrum ;
  ringbrynja_nn_1 = mkN "ringbrynja" ;
  ringdans_nn_1 = mkN "ringdans" "ringdanser" ;
  ringdomare_nn_1 = mkN "ringdomare" "ringdomare" ;
  ringfinger_nn_1 = mkN "ringfinger" ;
  ringformig_av_1 = mkA "ringformig" ;
  ringhet_nn_1 = mkN "ringhet" "ringheter" ;
  ringlek_nn_1 = mkN "ringlek" ;
  ringmask_nn_1 = mkN "ringmask" ;
  ringmur_nn_1 = mkN "ringmur" ;
  ringning_nn_1 = mkN "ringning" ;
  ringorm_nn_1 = mkN "ringorm" ;
  ringpaerm_nn_1 = mkN "ringpдrm" ;
  ringprydd_av_1 = mkA "ringprydd" ;
  ringraev_nn_1 = mkN "ringrдv" ;
  ringrev_nn_1 = mkN "ringrev" neutrum ;
  ringrostig_av_1 = mkA "ringrostig" ;
  ringstruktur_nn_1 = mkN "ringstruktur" "ringstrukturer" ;
  ringtryck_nn_1 = mkN "ringtryck" neutrum ;
  ringvrak_nn_1 = mkN "ringvrak" neutrum ;
  rink_nn_1 = mkN "rink" ;
  rinna_vb_1 = mkV "rinna" "rann" "runnit" ;
  ripost_nn_1 = mkN "ripost" "riposter" ;
  rippel_nn_1 = mkN "rippel" ;
  rips_nn_1 = mkN "rips" "ripser" ;
  ris_nn_1 = mkN "ris" neutrum ;
  risgryn_nn_1 = mkN "risgryn" neutrum ;
  rishoeg_nn_1 = mkN "rishцg" ;
  risig_av_1 = mkA "risig" ;
  risk_nn_1 = mkN "risk" "risker" ;
  riskabel_av_1 = mkA "riskabel" "riskabelt" "riskabla" "riskabla" "riskablare" "riskablast" "riskablaste" ;
  riskfaktor_nn_1 = mkN "riskfaktor" "riskfaktorer" ;
  riskfylld_av_1 = mkA "riskfylld" "riskfyllt" ;
  riskgrupp_nn_1 = mkN "riskgrupp" "riskgrupper" ;
  riskmodell_nn_1 = mkN "riskmodell" "riskmodeller" ;
  risknivaa_nn_1 = mkN "risknivе" "risknivеer" ;
  riskomraade_nn_1 = mkN "riskomrеde" ;
  risktagare_nn_1 = mkN "risktagare" "risktagare" ;
  risktal_nn_1 = mkN "risktal" "risktalet" "risktalen" "risktalena" ;
  riskuppfattning_nn_1 = mkN "riskuppfattning" ;
  riskvillig_av_1 = mkA "riskvillig" ;
  riskzon_nn_1 = mkN "riskzon" "riskzoner" ;
  risoll_nn_1 = mkN "risoll" "risoller" ;
  risraett_nn_1 = mkN "risrдtt" "risrдtter" ;
  rissel_nn_1 = mkN "rissel" neutrum ;
  ristning_nn_1 = mkN "ristning" ;
  risvase_nn_1 = mkN "risvase" utrum ;
  rit_nn_1 = mkN "rit" "riter" ;
  ritapparat_nn_1 = mkN "ritapparat" "ritapparater" ;
  ritardando_ab_1 = mkAdv "ritardando" ;
  ritardando_nn_1 = mkN "ritardando" "ritardandot" "ritardandon" "ritardandona" ;
  ritare_nn_1 = mkN "ritare" "ritare" ;
  ritbestick_nn_1 = mkN "ritbestick" neutrum ;
  ritblock_nn_1 = mkN "ritblock" neutrum ;
  ritbord_nn_1 = mkN "ritbord" neutrum ;
  ritkol_nn_1 = mkN "ritkol" neutrum ;
  ritning_nn_1 = mkN "ritning" ;
  rits_nn_1 = mkN "rits" ;
  ritt_nn_1 = mkN "ritt" "ritter" ;
  ritual_nn_1 = mkN "ritual" neutrum ;
  ritualism_nn_1 = mkN "ritualism" "ritualismer" ;
  ritualmord_nn_1 = mkN "ritualmord" neutrum ;
  rituell_av_1 = mkA "rituell" ;
  riva_vb_1 = mkV "riva" "rev" "rivit" ;
  rival_nn_1 = mkN "rival" "rivaler" ;
  rivalitet_nn_1 = mkN "rivalitet" "rivaliteter" ;
  rivig_av_1 = mkA "rivig" ;
  rivjaern_nn_1 = mkN "rivjдrn" neutrum ;
  rivning_nn_1 = mkN "rivning" ;
  rivningshus_nn_1 = mkN "rivningshus" neutrum ;
  rivningskaak_nn_1 = mkN "rivningskеk" ;
  rivningskontrakt_nn_1 = mkN "rivningskontrakt" neutrum ;
  rivningslaegenhet_nn_1 = mkN "rivningslдgenhet" "rivningslдgenheter" ;
  rivningstomt_nn_1 = mkN "rivningstomt" "rivningstomter" ;
  rivstart_nn_1 = mkN "rivstart" "rivstarter" ;
  ro_nn_2 = mkN "ro" "ron" "ron" "rona" ;
  ro_ro_fartyg_nn_1 = mkN "ro-ro-fartyg" neutrum ;
  roadie_nn_1 = mkN "roadie" "roadien" "roadies" "roadiesen" ;
  rob_nn_1 = mkN "rob" "rober" ;
  robbert_nn_1 = mkN "robbert" ;
  robe_nn_1 = mkN "robe" "rober" ;
  robinsonad_nn_1 = mkN "robinsonad" "robinsonader" ;
  robot_nn_1 = mkN "robot" ;
  robotvapen_nn_1 = mkN "robotvapen" "robotvapnet" "robotvapen" "robotvapnen" ;
  robust_av_1 = mkA "robust" "robust" ;
  rock_nn_1 = mkN "rock" ;
  rockad_nn_1 = mkN "rockad" "rockader" ;
  rockring_nn_1 = mkN "rockring" ;
  rockslusk_nn_1 = mkN "rockslusk" ;
  rockvaktmaestare_nn_1 = mkN "rockvaktmдstare" "rockvaktmдstare" ;
  rodd_nn_1 = mkN "rodd" "rodder" ;
  roddarbaenk_nn_1 = mkN "roddarbдnk" ;
  roddare_nn_1 = mkN "roddare" "roddare" ;
  roddarmadam_nn_1 = mkN "roddarmadam" "roddarmadammen" "roddarmadammer" "roddarmadammerna" ;
  roddarsaang_nn_1 = mkN "roddarsеng" "roddarsеnger" ;
  roddarslav_nn_1 = mkN "roddarslav" ;
  roddbaat_nn_1 = mkN "roddbеt" ;
  rodel_nn_1 = mkN "rodel" ;
  rodeo_nn_1 = mkN "rodeo" "rodeor" ;
  roder_nn_1 = mkN "roder" neutrum ;
  rodnad_nn_1 = mkN "rodnad" "rodnader" ;
  rododendron_nn_1 = mkN "rododendron" "rododendronen" "rododendron" "rododendrerna" ;
  roe_nn_1 = mkN "rц" "rцt" "rц" "rцna" ;
  roed_av_1 = mkA "rцd" ;
  roedaktig_av_1 = mkA "rцdaktig" ;
  roedblaa_av_1 = mkA "rцdblе" "rцdblеtt" ;
  roedblind_av_1 = mkA "rцdblind" ;
  roedblommig_av_1 = mkA "rцdblommig" ;
  roedblond_av_1 = mkA "rцdblond" ;
  roedbok_nn_1 = mkN "rцdbok" ;
  roedbrokig_av_1 = mkA "rцdbrokig" ;
  roedbrun_av_1 = mkA "rцdbrun" ;
  roedbrusig_av_1 = mkA "rцdbrusig" ;
  roedfilter_nn_1 = mkN "rцdfilter" neutrum ;
  roedflammig_av_1 = mkA "rцdflammig" ;
  roedgraaten_av_1 = mkA "rцdgrеten" "rцdgrеtet" ;
  roedgroenblind_av_1 = mkA "rцdgrцnblind" ;
  roedhaarig_av_1 = mkA "rцdhеrig" ;
  roedhake_nn_1 = mkN "rцdhake" utrum ;
  roedhakesaangare_nn_1 = mkN "rцdhakesеngare" "rцdhakesеngare" ;
  roeding_nn_1 = mkN "rцding" ;
  roedlaett_av_1 = mkA "rцdlдtt" ;
  roedlila_av_1 = mkA "rцdlila" ;
  roedmosig_av_1 = mkA "rцdmosig" ;
  roednaest_av_1 = mkA "rцdnдst" "rцdnдst" ;
  roedraev_nn_1 = mkN "rцdrдv" ;
  roedskinn_nn_1 = mkN "rцdskinn" neutrum ;
  roedspraengd_av_1 = mkA "rцdsprдngd" "rцdsprдngt" ;
  roedstjaert_nn_1 = mkN "rцdstjдrt" ;
  roedtunga_nn_1 = mkN "rцdtunga" ;
  roedvaeppling_nn_1 = mkN "rцdvдppling" ;
  roedvin_nn_1 = mkN "rцdvin" "rцdvinet" "rцdviner" "rцdvinerna" ;
  roejdykare_nn_1 = mkN "rцjdykare" "rцjdykare" ;
  roejel_nn_1 = mkN "rцjel" ;
  roejning_nn_1 = mkN "rцjning" ;
  roek_nn_1 = mkN "rцk" ;
  roekare_nn_1 = mkN "rцkare" "rцkare" ;
  roekbomb_nn_1 = mkN "rцkbomb" "rцkbomber" ;
  roekdetektor_nn_1 = mkN "rцkdetektor" "rцkdetektorer" ;
  roekdykare_nn_1 = mkN "rцkdykare" "rцkdykare" ;
  roekelse_nn_1 = mkN "rцkelse" "rцkelser" ;
  roekelsekar_nn_1 = mkN "rцkelsekar" neutrum ;
  roekeri_nn_1 = mkN "rцkeri" "rцkerit" "rцkerier" "rцkerierna" ;
  roekfaang_nn_1 = mkN "rцkfеng" neutrum ;
  roekgaang_nn_1 = mkN "rцkgеng" ;
  roekgas_nn_1 = mkN "rцkgas" "rцkgaser" ;
  roekig_av_1 = mkA "rцkig" ;
  roekkanal_nn_1 = mkN "rцkkanal" "rцkkanaler" ;
  roekkupe_nn_1 = mkN "rцkkupй" "rцkkupйer" ;
  roekmask_nn_1 = mkN "rцkmask" "rцkmasker" ;
  roekridaa_nn_1 = mkN "rцkridе" "rцkridеer" ;
  roekring_nn_1 = mkN "rцkring" ;
  roekrock_nn_1 = mkN "rцkrock" ;
  roeksvag_av_1 = mkA "rцksvag" ;
  roeksvamp_nn_1 = mkN "rцksvamp" ;
  roektopas_nn_1 = mkN "rцktopas" "rцktopaser" ;
  roen_nn_1 = mkN "rцn" neutrum ;
  roenn_nn_1 = mkN "rцnn" ;
  roennbaer_nn_1 = mkN "rцnnbдr" neutrum ;
  roentgenapparat_nn_1 = mkN "rцntgenapparat" "rцntgenapparater" ;
  roentgenbehandling_nn_1 = mkN "rцntgenbehandling" ;
  roentgenbild_nn_1 = mkN "rцntgenbild" "rцntgenbilder" ;
  roentgenkamera_nn_1 = mkN "rцntgenkamera" ;
  roentgenmikroskop_nn_1 = mkN "rцntgenmikroskop" neutrum ;
  roentgenroer_nn_1 = mkN "rцntgenrцr" neutrum ;
  roentgenstraalande_av_1 = mkA "rцntgenstrеlande" ;
  roentgenundersoekning_nn_1 = mkN "rцntgenundersцkning" ;
  roer_nn_1 = mkN "rцr" neutrum ;
  roerande_av_1 = mkA "rцrande" ;
  roerblad_nn_1 = mkN "rцrblad" neutrum ;
  roerd_av_1 = mkA "rцrd" "rцrt" ;
  roerdrom_nn_1 = mkN "rцrdrom" "rцrdrommen" "rцrdrommar" "rцrdrommarna" ;
  roerelse_nn_1 = mkN "rцrelse" "rцrelser" ;
  roerelsecentrum_nn_1 = mkN "rцrelsecentrum" neutrum ;
  roerelsefrihet_nn_1 = mkN "rцrelsefrihet" "rцrelsefriheter" ;
  roerelseinkomst_nn_1 = mkN "rцrelseinkomst" "rцrelseinkomster" ;
  roerelsekapital_nn_1 = mkN "rцrelsekapital" neutrum ;
  roerelsekommando_nn_1 = mkN "rцrelsekommando" "rцrelsekommandot" "rцrelsekommandon" "rцrelsekommandona" ;
  roerelsemaengd_nn_1 = mkN "rцrelsemдngd" "rцrelsemдngder" ;
  roerelsemaengdsmoment_nn_1 = mkN "rцrelsemдngdsmoment" "rцrelsemдngdsmomentet" "rцrelsemдngdsmomenten" "rцrelsemдngdsmomentena" ;
  roerelsemoenster_nn_1 = mkN "rцrelsemцnster" neutrum ;
  roerelsestoerning_nn_1 = mkN "rцrelsestцrning" ;
  roerig_av_1 = mkA "rцrig" ;
  roering_nn_1 = mkN "rцring" ;
  roerlaeggare_nn_1 = mkN "rцrlдggare" "rцrlдggare" ;
  roerledning_nn_1 = mkN "rцrledning" ;
  roerlig_av_1 = mkA "rцrlig" ;
  roerlighet_nn_1 = mkN "rцrlighet" "rцrligheter" ;
  roermokare_nn_1 = mkN "rцrmokare" "rцrmokare" ;
  roermontoer_nn_1 = mkN "rцrmontцr" "rцrmontцrer" ;
  roersaangare_nn_1 = mkN "rцrsеngare" "rцrsеngare" ;
  roersopp_nn_1 = mkN "rцrsopp" ;
  roersvamp_nn_1 = mkN "rцrsvamp" ;
  roertaang_nn_1 = mkN "rцrtеng" "rцrtдnger" ;
  roes_nn_1 = mkN "rцs" ;
  roest_nn_1 = mkN "rцst" "rцster" ;
  roest_nn_2 = mkN "rцst" neutrum ;
  roestetal_nn_1 = mkN "rцstetal" "rцstetalet" "rцstetalen" "rцstetalena" ;
  roestjaern_nn_1 = mkN "rцstjдrn" neutrum ;
  roestkort_nn_1 = mkN "rцstkort" neutrum ;
  roestlaengd_nn_1 = mkN "rцstlдngd" "rцstlдngder" ;
  roestraettsfraaga_nn_1 = mkN "rцstrдttsfrеga" ;
  roestsedel_nn_1 = mkN "rцstsedel" ;
  roeststyrka_nn_1 = mkN "rцststyrka" ;
  roetaegg_nn_1 = mkN "rцtдgg" neutrum ;
  roetkammare_nn_1 = mkN "rцtkammare" "rцtkammaren" "rцtkamrar" "rцtkamrarna" ;
  roetmaanad_nn_1 = mkN "rцtmеnad" "rцtmеnader" ;
  roev_nn_1 = mkN "rцv" ;
  roevare_nn_1 = mkN "rцvare" "rцvare" ;
  roevarhistoria_nn_1 = mkN "rцvarhistoria" "rцvarhistorien" "rцvarhistorier" "rцvarhistorierna" ;
  roevarpris_nn_1 = mkN "rцvarpris" neutrum ;
  roeveri_nn_1 = mkN "rцveri" "rцverit" "rцverier" "rцverierna" ;
  roevslickare_nn_1 = mkN "rцvslickare" "rцvslickare" ;
  rofylld_av_1 = mkA "rofylld" "rofyllt" ;
  rogivande_av_1 = mkA "rogivande" ;
  rojalist_nn_1 = mkN "rojalist" "rojalister" ;
  rojalistisk_av_1 = mkA "rojalistisk" ;
  rokokodam_nn_1 = mkN "rokokodam" "rokokodamer" ;
  rolig_av_1 = mkA "rolig" ;
  rolighet_nn_1 = mkN "rolighet" "roligheter" ;
  rolighetsminister_nn_1 = mkN "rolighetsminister" ;
  roll_nn_1 = mkN "roll" "roller" ;
  roll_nn_2 = mkN "roll" ;
  roll_on'2Froll_off_fartyg_nn_1 = mkN "roll-on/roll-off-fartyg" neutrum ;
  roll_on_deodorant_nn_1 = mkN "roll-on-deodorant" "roll-on-deodoranter" ;
  roller_nn_1 = mkN "roller" ;
  rollfack_nn_1 = mkN "rollfack" neutrum ;
  rollmops_nn_1 = mkN "rollmops" ;
  rollspel_nn_1 = mkN "rollspel" "rollspelet" "rollspel" "rollspelen" ;
  roloes_av_1 = mkA "rolцs" ;
  roman_nn_1 = mkN "roman" "romaner" ;
  romanesk_av_1 = mkA "romanesk" ;
  romanfoerfattare_nn_1 = mkN "romanfцrfattare" "romanfцrfattare" ;
  romanist_nn_1 = mkN "romanist" "romanister" ;
  romanistik_nn_1 = mkN "romanistik" "romanistiker" ;
  romanistisk_av_1 = mkA "romanistisk" ;
  romans_nn_1 = mkN "romans" "romanser" ;
  romansk_av_1 = mkA "romansk" ;
  romantiker_nn_1 = mkN "romantiker" "romantikern" "romantiker" "romantikerna" ;
  romantisering_nn_1 = mkN "romantisering" ;
  romantisk_av_1 = mkA "romantisk" ;
  romare_nn_1 = mkN "romare" "romare" ;
  romb_nn_1 = mkN "romb" "romber" ;
  rombisk_av_1 = mkA "rombisk" ;
  romboid_nn_1 = mkN "romboid" "romboider" ;
  romersk_av_1 = mkA "romersk" ;
  romersk_katolsk_av_1 = mkA "romersk-katolsk" ;
  rond_nn_1 = mkN "rond" "ronder" ;
  rondell_nn_1 = mkN "rondell" "rondeller" ;
  rondo_nn_1 = mkN "rondo" "rondot" "rondon" "rondona" ;
  rop_nn_1 = mkN "rop" neutrum ;
  roquefortost_nn_1 = mkN "roquefortost" ;
  rorgaengare_nn_1 = mkN "rorgдngare" "rorgдngare" ;
  rorkult_nn_1 = mkN "rorkult" ;
  rorpinne_nn_1 = mkN "rorpinne" utrum ;
  rorschachtest_nn_1 = mkN "rorschachtest" neutrum ;
  rorsman_nn_1 = mkN "rorsman" "rorsmannen" "rorsmдn" "rorsmдnnen" ;
  rosa_av_1 = mkA "rosa" ;
  rosenbroed_nn_1 = mkN "rosenbrцd" neutrum ;
  rosenbuske_nn_1 = mkN "rosenbuske" utrum ;
  rosende_av_1 = mkA "rosende" ;
  rosengaard_nn_1 = mkN "rosengеrd" ;
  rosenkrans_nn_1 = mkN "rosenkrans" ;
  rosenmoln_nn_1 = mkN "rosenmoln" neutrum ;
  rosenmun_nn_1 = mkN "rosenmun" "rosenmunnen" "rosenmunnar" "rosenmunnarna" ;
  rosenrasande_av_1 = mkA "rosenrasande" ;
  rosenroed_av_1 = mkA "rosenrцd" ;
  rosenstock_nn_1 = mkN "rosenstock" ;
  rosett_nn_1 = mkN "rosett" "rosetter" ;
  rosettfoenster_nn_1 = mkN "rosettfцnster" neutrum ;
  rosettmoenster_nn_1 = mkN "rosettmцnster" neutrum ;
  rosettstaelld_av_1 = mkA "rosettstдlld" "rosettstдllt" ;
  rosevin_nn_1 = mkN "rosйvin" "rosйvinet" "rosйviner" "rosйvinerna" ;
  rosig_av_1 = mkA "rosig" ;
  roskarl_nn_1 = mkN "roskarl" ;
  rosling_nn_1 = mkN "rosling" ;
  rosmarin_nn_1 = mkN "rosmarin" "rosmariner" ;
  rospigg_nn_1 = mkN "rospigg" ;
  rosslig_av_1 = mkA "rosslig" ;
  rossling_nn_1 = mkN "rossling" ;
  rostbiff_nn_1 = mkN "rostbiff" ;
  rostfri_av_1 = mkA "rostfri" "rostfritt" ;
  rostig_av_1 = mkA "rostig" ;
  rostroed_av_1 = mkA "rostrцd" ;
  rostskydd_nn_1 = mkN "rostskydd" neutrum ;
  rostskyddsfaerg_nn_1 = mkN "rostskyddsfдrg" "rostskyddsfдrger" ;
  rostskyddsmedel_nn_1 = mkN "rostskyddsmedel" neutrum ;
  rostsvamp_nn_1 = mkN "rostsvamp" ;
  rot_nn_1 = mkN "rot" "rцtter" ;
  rotation_nn_1 = mkN "rotation" "rotationer" ;
  rotationsaxel_nn_1 = mkN "rotationsaxel" ;
  rotationshastighet_nn_1 = mkN "rotationshastighet" "rotationshastigheter" ;
  rotationspress_nn_1 = mkN "rotationspress" ;
  rotborste_nn_1 = mkN "rotborste" utrum ;
  rote_nn_1 = mkN "rote" utrum ;
  rotel_nn_1 = mkN "rotel" ;
  rotfast_av_1 = mkA "rotfast" "rotfast" ;
  rotfrukt_nn_1 = mkN "rotfrukt" "rotfrukter" ;
  rotfyllning_nn_1 = mkN "rotfyllning" ;
  rotgroensak_nn_1 = mkN "rotgrцnsak" "rotgrцnsaker" ;
  rotisseri_nn_1 = mkN "rotisseri" "rotisserit" "rotisserier" "rotisserierna" ;
  rotkanal_nn_1 = mkN "rotkanal" "rotkanaler" ;
  rotknoel_nn_1 = mkN "rotknцl" ;
  rotloes_av_1 = mkA "rotlцs" ;
  rotmaerke_nn_1 = mkN "rotmдrke" ;
  rotogravyr_nn_1 = mkN "rotogravyr" "rotogravyrer" ;
  rotor_nn_1 = mkN "rotor" "rotorer" ;
  rotorblad_nn_1 = mkN "rotorblad" neutrum ;
  rotsak_nn_1 = mkN "rotsak" "rotsaker" ;
  rotstock_nn_1 = mkN "rotstock" ;
  rotsystem_nn_1 = mkN "rotsystem" neutrum ;
  rottecken_nn_1 = mkN "rottecken" "rottecknet" "rottecken" "rottecknen" ;
  rotting_nn_1 = mkN "rotting" ;
  rottraad_nn_1 = mkN "rottrеd" ;
  rottweiler_nn_1 = mkN "rottweiler" "rottweilern" "rottweiler" "rottweilerna" ;
  roue_nn_1 = mkN "rouй" "rouйer" ;
  rough_nn_1 = mkN "rough" "rougher" ;
  roulad_nn_1 = mkN "roulad" "roulader" ;
  roulett_nn_1 = mkN "roulett" "rouletter" ;
  rousseauan_nn_1 = mkN "rousseauan" "rousseauaner" ;
  route_nn_1 = mkN "route" "router" ;
  rov_nn_1 = mkN "rov" neutrum ;
  rovdjur_nn_1 = mkN "rovdjur" neutrum ;
  rovfaagel_nn_1 = mkN "rovfеgel" ;
  rovfisk_nn_1 = mkN "rovfisk" ;
  rovgirig_av_1 = mkA "rovgirig" ;
  rovlysten_av_1 = mkA "rovlysten" "rovlystet" ;
  rovriddare_nn_1 = mkN "rovriddare" "rovriddare" ;
  royalty_nn_1 = mkN "royalty" "royaltyn" "royalties" "royalties" ;
  rubank_nn_1 = mkN "rubank" ;
  rubbning_nn_1 = mkN "rubbning" ;
  rubel_nn_1 = mkN "rubel" "rubeln" "rubel" "rublerna" ;
  rubin_nn_1 = mkN "rubin" "rubiner" ;
  rubinroed_av_1 = mkA "rubinrцd" ;
  rubrik_nn_1 = mkN "rubrik" "rubriker" ;
  ruckel_nn_1 = mkN "ruckel" neutrum ;
  rucklare_nn_1 = mkN "rucklare" "rucklare" ;
  rucklig_av_1 = mkA "rucklig" ;
  ruderatvaext_nn_1 = mkN "ruderatvдxt" "ruderatvдxter" ;
  rudiment_nn_1 = mkN "rudiment" neutrum ;
  rudimentaer_av_1 = mkA "rudimentдr" ;
  rudis_av_1 = mkA "rudis" ;
  ruff_nn_1 = mkN "ruff" ;
  ruffig_av_1 = mkA "ruffig" ;
  rufftak_nn_1 = mkN "rufftak" neutrum ;
  rufsig_av_1 = mkA "rufsig" ;
  rugg_nn_1 = mkN "rugg" ;
  rugge_nn_1 = mkN "rugge" utrum ;
  ruggig_av_1 = mkA "ruggig" ;
  ruin_nn_1 = mkN "ruin" "ruiner" ;
  rulad_nn_1 = mkN "rulad" "rulader" ;
  rulett_nn_1 = mkN "rulett" "ruletter" ;
  rullad_nn_1 = mkN "rullad" "rullader" ;
  rullager_nn_1 = mkN "rullager" neutrum ;
  rullbaelte_nn_1 = mkN "rullbдlte" ;
  rullband_nn_1 = mkN "rullband" neutrum ;
  rullbar_av_1 = mkA "rullbar" ;
  rullbord_nn_1 = mkN "rullbord" neutrum ;
  rullbraede_nn_1 = mkN "rullbrдde" ;
  rulle_nn_1 = mkN "rulle" utrum ;
  rullgardin_nn_1 = mkN "rullgardin" "rullgardiner" ;
  rullrev_nn_1 = mkN "rullrev" neutrum ;
  rullskridsko_nn_1 = mkN "rullskridsko" "rullskridskor" ;
  rullsten_nn_1 = mkN "rullsten" "rullstenen" "rullstenar" "rullstenarna" ;
  rullstensaas_nn_1 = mkN "rullstensеs" ;
  rullstol_nn_1 = mkN "rullstol" ;
  rullstolsbunden_av_1 = mkA "rullstolsbunden" "rullstolsbundet" ;
  rultig_av_1 = mkA "rultig" ;
  rum_ab_1 = mkAdv "rum" ;
  rum_av_1 = mkA "rum" "rumt" "rumma" "rumma" "rummare" "rummast" "rummaste" ;
  rum_nn_1 = mkN "rum" "rummet" "rum" "rummen" ;
  rumaen_nn_1 = mkN "rumдn" "rumдner" ;
  rumaensk_av_1 = mkA "rumдnsk" ;
  rumaensk_fransk_av_1 = mkA "rumдnsk-fransk" ;
  rumaenska_nn_2 = mkN "rumдnska" ;
  rumphugga_vb_1 = mkV "rumphugga" "rumphцgg" "rumphuggit" ;
  rumpstek_nn_1 = mkN "rumpstek" ;
  rumsadverbial_nn_1 = mkN "rumsadverbial" neutrum ;
  rumsbestaellning_nn_1 = mkN "rumsbestдllning" ;
  rumsbredd_nn_1 = mkN "rumsbredd" "rumsbredder" ;
  rumsfoermedling_nn_1 = mkN "rumsfцrmedling" ;
  rumsgranne_nn_1 = mkN "rumsgranne" utrum ;
  rumskamrat_nn_1 = mkN "rumskamrat" "rumskamrater" ;
  rumskroekning_nn_1 = mkN "rumskrцkning" ;
  rumslast_nn_1 = mkN "rumslast" "rumslaster" ;
  rumslig_av_1 = mkA "rumslig" ;
  rumsren_av_1 = mkA "rumsren" ;
  rumstemperatur_nn_1 = mkN "rumstemperatur" "rumstemperaturer" ;
  rund_av_1 = mkA "rund" ;
  rundabordskonferens_nn_1 = mkN "rundabordskonferens" "rundabordskonferenser" ;
  rundbaage_nn_1 = mkN "rundbеge" utrum ;
  rundbrev_nn_1 = mkN "rundbrev" neutrum ;
  rundel_nn_1 = mkN "rundel" ;
  rundflygning_nn_1 = mkN "rundflygning" ;
  rundfoenster_nn_1 = mkN "rundfцnster" neutrum ;
  rundfraaga_nn_1 = mkN "rundfrеga" ;
  rundhaell_nn_1 = mkN "rundhдll" ;
  rundhaent_av_1 = mkA "rundhдnt" "rundhдnt" ;
  rundhorisont_nn_1 = mkN "rundhorisont" "rundhorisonter" ;
  rundhult_nn_1 = mkN "rundhult" ;
  rundhyllt_av_1 = mkA "rundhyllt" "rundhyllt" ;
  rundkullig_av_1 = mkA "rundkullig" ;
  rundkyrka_nn_1 = mkN "rundkyrka" ;
  rundlagd_av_1 = mkA "rundlagd" "rundlagt" ;
  rundlig_av_1 = mkA "rundlig" ;
  rundmaalning_nn_1 = mkN "rundmеlning" ;
  rundmask_nn_1 = mkN "rundmask" ;
  rundmun_nn_1 = mkN "rundmun" "rundmunnen" "rundmunnar" "rundmunnarna" ;
  rundnaett_av_1 = mkA "rundnдtt" ;
  rundning_nn_1 = mkN "rundning" ;
  rundningsmaerke_nn_1 = mkN "rundningsmдrke" ;
  rundskrivelse_nn_1 = mkN "rundskrivelse" "rundskrivelser" ;
  rundsmoerjning_nn_1 = mkN "rundsmцrjning" ;
  rundtoern_nn_1 = mkN "rundtцrn" ;
  rundtur_nn_1 = mkN "rundtur" "rundturer" ;
  rundvandring_nn_1 = mkN "rundvandring" ;
  runnare_nn_1 = mkN "runnare" "runnare" ;
  runolog_nn_1 = mkN "runolog" "runologer" ;
  runometer_nn_1 = mkN "runometer" ;
  runosaang_nn_1 = mkN "runosеng" "runosеnger" ;
  runrad_nn_1 = mkN "runrad" "runrader" ;
  runskrift_nn_1 = mkN "runskrift" "runskrifter" ;
  runstav_nn_1 = mkN "runstav" ;
  runsten_nn_1 = mkN "runsten" "runstenen" "runstenar" "runstenarna" ;
  runt_ab_1 = mkAdv "runt" ;
  runtikring_ab_1 = mkAdv "runtikring" ;
  runtom_ab_1 = mkAdv "runtom" ;
  runtomkring_ab_1 = mkAdv "runtomkring" ;
  rupie_nn_1 = mkN "rupie" "rupier" ;
  ruptur_nn_1 = mkN "ruptur" "rupturer" ;
  rural_av_1 = mkA "rural" ;
  rus_nn_1 = mkN "rus" neutrum ;
  rusch_nn_1 = mkN "rusch" "ruscher" ;
  ruschig_av_1 = mkA "ruschig" ;
  rusdryck_nn_1 = mkN "rusdryck" "rusdrycker" ;
  rush_nn_1 = mkN "rush" "rusher" ;
  rusig_av_1 = mkA "rusig" ;
  ruskig_av_1 = mkA "ruskig" ;
  ruskprick_nn_1 = mkN "ruskprick" ;
  rusning_nn_1 = mkN "rusning" ;
  rusningstid_nn_1 = mkN "rusningstid" "rusningstider" ;
  russ_nn_1 = mkN "russ" neutrum ;
  russin_nn_1 = mkN "russin" neutrum ;
  rusthaall_nn_1 = mkN "rusthеll" neutrum ;
  rusthaallare_nn_1 = mkN "rusthеllare" "rusthеllare" ;
  rustibuss_nn_1 = mkN "rustibuss" ;
  rustik_av_1 = mkA "rustik" ;
  rustkammare_nn_1 = mkN "rustkammare" "rustkammaren" "rustkamrar" "rustkamrarna" ;
  rustmaestare_nn_1 = mkN "rustmдstare" "rustmдstare" ;
  rustning_nn_1 = mkN "rustning" ;
  ruten_nn_1 = mkN "ruten" "rutener" ;
  ruter_nn_1 = mkN "ruter" "rutern" "ruter" "ruterna" ;
  rutig_av_1 = mkA "rutig" ;
  rutin_nn_1 = mkN "rutin" "rutiner" ;
  rutinoperation_nn_1 = mkN "rutinoperation" "rutinoperationer" ;
  rutmoenster_nn_1 = mkN "rutmцnster" neutrum ;
  rutnaet_nn_1 = mkN "rutnдt" neutrum ;
  rutsch_nn_1 = mkN "rutsch" ;
  rutt_nn_1 = mkN "rutt" "rutter" ;
  rutten_av_1 = mkA "rutten" "ruttet" ;
  rwandier_nn_1 = mkN "rwandier" "rwandiern" "rwandier" "rwandierna" ;
  rwandisk_av_1 = mkA "rwandisk" ;
  ryck_nn_1 = mkN "ryck" neutrum ;
  rycken_ab_1 = mkAdv "rycken" ;
  ryckig_av_1 = mkA "ryckig" ;
  ryckning_nn_1 = mkN "ryckning" ;
  ryckvis_ab_1 = mkAdv "ryckvis" ;
  rygg_nn_1 = mkN "rygg" ;
  ryggaasstuga_nn_1 = mkN "ryggеsstuga" ;
  ryggbesvaer_nn_1 = mkN "ryggbesvдr" neutrum ;
  ryggbiff_nn_1 = mkN "ryggbiff" ;
  rygglaege_nn_1 = mkN "rygglдge" ;
  ryggmaergsbedoevning_nn_1 = mkN "ryggmдrgsbedцvning" ;
  ryggmaergsprov_nn_1 = mkN "ryggmдrgsprov" neutrum ;
  ryggornament_nn_1 = mkN "ryggornament" "ryggornamentet" "ryggornamenten" "ryggornamentena" ;
  ryggparti_nn_1 = mkN "ryggparti" "ryggpartit" "ryggpartier" "ryggpartierna" ;
  ryggrad_nn_1 = mkN "ryggrad" "ryggrader" ;
  ryggradsdjur_nn_1 = mkN "ryggradsdjur" neutrum ;
  ryggradsloes_av_1 = mkA "ryggradslцs" ;
  ryggsaeck_nn_1 = mkN "ryggsдck" ;
  ryggskott_nn_1 = mkN "ryggskott" neutrum ;
  ryggslut_nn_1 = mkN "ryggslut" neutrum ;
  ryggstoed_nn_1 = mkN "ryggstцd" neutrum ;
  ryggtavla_nn_1 = mkN "ryggtavla" ;
  rykande_ab_1 = mkAdv "rykande" ;
  ryktbar_av_1 = mkA "ryktbar" ;
  ryktbarhet_nn_1 = mkN "ryktbarhet" "ryktbarheter" ;
  ryktborste_nn_1 = mkN "ryktborste" utrum ;
  rykte_nn_1 = mkN "rykte" ;
  ryktessmidare_nn_1 = mkN "ryktessmidare" "ryktessmidare" ;
  ryktesspridning_nn_1 = mkN "ryktesspridning" ;
  rymd_nn_1 = mkN "rymd" "rymder" ;
  rymddraekt_nn_1 = mkN "rymddrдkt" "rymddrдkter" ;
  rymdfaerd_nn_1 = mkN "rymdfдrd" "rymdfдrder" ;
  rymdfaerja_nn_1 = mkN "rymdfдrja" ;
  rymdfarare_nn_1 = mkN "rymdfarare" "rymdfarare" ;
  rymdfarkost_nn_1 = mkN "rymdfarkost" "rymdfarkoster" ;
  rymdfartsstyrelse_nn_1 = mkN "rymdfartsstyrelse" "rymdfartsstyrelser" ;
  rymdkapsel_nn_1 = mkN "rymdkapsel" ;
  rymdmaatt_nn_1 = mkN "rymdmеtt" neutrum ;
  rymdmateria_nn_1 = mkN "rymdmateria" "rymdmaterian" "rymdmaterier" "rymdmaterierna" ;
  rymdpromenad_nn_1 = mkN "rymdpromenad" "rymdpromenader" ;
  rymdraket_nn_1 = mkN "rymdraket" "rymdraketer" ;
  rymdskepp_nn_1 = mkN "rymdskepp" neutrum ;
  rymdsond_nn_1 = mkN "rymdsond" "rymdsonder" ;
  rymdstation_nn_1 = mkN "rymdstation" "rymdstationer" ;
  rymdstyrelse_nn_1 = mkN "rymdstyrelse" "rymdstyrelser" ;
  rymdvapen_nn_1 = mkN "rymdvapen" "rymdvapnet" "rymdvapen" "rymdvapnen" ;
  rymdvinkel_nn_1 = mkN "rymdvinkel" ;
  rymlig_av_1 = mkA "rymlig" ;
  rymling_nn_1 = mkN "rymling" ;
  rymmare_nn_1 = mkN "rymmare" "rymmare" ;
  rymning_nn_1 = mkN "rymning" ;
  rymningssaeker_av_1 = mkA "rymningssдker" "rymningssдkert" "rymningssдkra" "rymningssдkra" "rymningssдkrare" "rymningssдkrast" "rymningssдkraste" ;
  rynkig_av_1 = mkA "rynkig" ;
  rynkning_nn_1 = mkN "rynkning" ;
  rysansvaerd_av_1 = mkA "rysansvдrd" "rysansvдrt" ;
  rysare_nn_1 = mkN "rysare" "rysare" ;
  rysch_nn_1 = mkN "rysch" neutrum ;
  ryschig_av_1 = mkA "ryschig" ;
  rysk_amerikansk_av_1 = mkA "rysk-amerikansk" ;
  rysk_av_1 = mkA "rysk" ;
  ryska_nn_2 = mkN "ryska" ;
  ryslig_av_1 = mkA "ryslig" ;
  rysning_nn_1 = mkN "rysning" ;
  ryss_nn_1 = mkN "ryss" ;
  ryssgubbe_nn_1 = mkN "ryssgubbe" utrum ;
  ryssja_nn_1 = mkN "ryssja" ;
  rytande_nn_1 = mkN "rytande" ;
  rytm_nn_1 = mkN "rytm" "rytmer" ;
  rytmicitet_nn_1 = mkN "rytmicitet" "rytmiciteter" ;
  rytmisk_av_1 = mkA "rytmisk" ;
  rytmsektion_nn_1 = mkN "rytmsektion" "rytmsektioner" ;
  ryttare_nn_1 = mkN "ryttare" "ryttare" ;
  ryttarfolk_nn_1 = mkN "ryttarfolk" neutrum ;
  ryttargaang_nn_1 = mkN "ryttargеng" ;
  ryttarlek_nn_1 = mkN "ryttarlek" ;
  ryttaruppvisning_nn_1 = mkN "ryttaruppvisning" ;
  ryttmaestare_nn_1 = mkN "ryttmдstare" "ryttmдstare" ;
  saa_ab_1 = mkAdv "sе" ;
  saa_nn_1 = mkN "sе" ;
  saadaer_ab_1 = mkAdv "sеdдr" ;
  saadd_nn_1 = mkN "sеdd" "sеdder" ;
  saadig_av_1 = mkA "sеdig" ;
  saag_nn_1 = mkN "sеg" ;
  saagblad_nn_1 = mkN "sеgblad" neutrum ;
  saagbock_nn_1 = mkN "sеgbock" ;
  saagfisk_nn_1 = mkN "sеgfisk" ;
  saagspaan_nn_1 = mkN "sеgspеn" neutrum ;
  saagtak_nn_1 = mkN "sеgtak" neutrum ;
  saagverk_nn_1 = mkN "sеgverk" neutrum ;
  saagverksarbetare_nn_1 = mkN "sеgverksarbetare" "sеgverksarbetare" ;
  saagverksindustri_nn_1 = mkN "sеgverksindustri" "sеgverksindustrier" ;
  saahaer_ab_1 = mkAdv "sеhдr" ;
  saald_av_1 = mkA "sеld" "sеlt" ;
  saaledes_ab_1 = mkAdv "sеledes" ;
  saall_nn_1 = mkN "sеll" neutrum ;
  saalunda_ab_1 = mkAdv "sеlunda" ;
  saamaskin_nn_1 = mkN "sеmaskin" "sеmaskiner" ;
  saanaer_ab_1 = mkAdv "sеnдr" ;
  saang_nn_1 = mkN "sеng" "sеnger" ;
  saangare_nn_1 = mkN "sеngare" "sеngare" ;
  saangarfaagel_nn_1 = mkN "sеngarfеgel" ;
  saangbar_av_1 = mkA "sеngbar" ;
  saangerska_nn_1 = mkN "sеngerska" ;
  saangfaagel_nn_1 = mkN "sеngfеgel" ;
  saanggudinna_nn_1 = mkN "sеnggudinna" ;
  saanglek_nn_1 = mkN "sеnglek" ;
  saanglig_av_1 = mkA "sеnglig" ;
  saangmoe_nn_1 = mkN "sеngmц" "sеngmцn" "sеngmцr" "sеngmцrna" ;
  saangoevning_nn_1 = mkN "sеngцvning" ;
  saangprov_nn_1 = mkN "sеngprov" neutrum ;
  saangsaett_nn_1 = mkN "sеngsдtt" neutrum ;
  saangspel_nn_1 = mkN "sеngspel" "sеngspelet" "sеngspel" "sеngspelen" ;
  saangsvan_nn_1 = mkN "sеngsvan" ;
  saangteknik_nn_1 = mkN "sеngteknik" "sеngtekniker" ;
  saangtema_nn_1 = mkN "sеngtema" "sеngtemat" "sеngteman" "sеngtemana" ;
  saaningsman_nn_1 = mkN "sеningsman" "sеningsmannen" "sеningsmдn" "sеningsmдnnen" ;
  saapass_ab_1 = mkAdv "sеpass" ;
  saapbubbla_nn_1 = mkN "sеpbubbla" ;
  saaphal_av_1 = mkA "sеphal" ;
  saapopera_nn_1 = mkN "sеpopera" ;
  saapvatten_nn_1 = mkN "sеpvatten" "sеpvattnet" "sеpvatten" "sеpvattnen" ;
  saar_nn_1 = mkN "sеr" neutrum ;
  saarande_av_1 = mkA "sеrande" ;
  saarbar_av_1 = mkA "sеrbar" ;
  saarig_av_1 = mkA "sеrig" ;
  saarinfektion_nn_1 = mkN "sеrinfektion" "sеrinfektioner" ;
  saarmarkoer_nn_1 = mkN "sеrmarkцr" "sеrmarkцrer" ;
  saarnad_nn_1 = mkN "sеrnad" "sеrnader" ;
  saas_nn_1 = mkN "sеs" "sеser" ;
  saasig_av_1 = mkA "sеsig" ;
  saat_nn_1 = mkN "sеt" ;
  saate_nn_1 = mkN "sеte" utrum ;
  saatillvida_ab_1 = mkAdv "sеtillvida" ;
  saavael_ab_1 = mkAdv "sеvдl" ;
  saavitt_ab_1 = mkAdv "sеvitt" ;
  sabadill_nn_1 = mkN "sabadill" "sabadiller" ;
  sabbat_nn_1 = mkN "sabbat" "sabbater" ;
  sabbatsaar_nn_1 = mkN "sabbatsеr" neutrum ;
  sabbatsbrott_nn_1 = mkN "sabbatsbrott" neutrum ;
  sabbatstermin_nn_1 = mkN "sabbatstermin" "sabbatsterminer" ;
  sabbik_nn_1 = mkN "sabbik" ;
  sabel_nn_1 = mkN "sabel" ;
  sabelbajonett_nn_1 = mkN "sabelbajonett" "sabelbajonetter" ;
  sabelbalja_nn_1 = mkN "sabelbalja" ;
  sabelbent_av_1 = mkA "sabelbent" "sabelbent" ;
  sabellilja_nn_1 = mkN "sabellilja" ;
  sabin_nn_1 = mkN "sabin" "sabiner" ;
  sabla_av_1 = mkA "sabla" ;
  sabotage_nn_1 = mkN "sabotage" "sabotaget" "sabotage" "sabotagen" ;
  sabotoer_nn_1 = mkN "sabotцr" "sabotцrer" ;
  sachsare_nn_1 = mkN "sachsare" "sachsare" ;
  sachsisk_av_1 = mkA "sachsisk" ;
  sackarin_nn_1 = mkN "sackarin" "sackariner" ;
  sackett_nn_1 = mkN "sackett" "sacketter" ;
  sadduce_nn_1 = mkN "sadducй" "sadducйer" ;
  sadel_nn_1 = mkN "sadel" ;
  sadelbom_nn_1 = mkN "sadelbom" "sadelbommen" "sadelbommar" "sadelbommarna" ;
  sadelbrott_nn_1 = mkN "sadelbrott" neutrum ;
  sadelbruten_av_1 = mkA "sadelbruten" "sadelbrutet" ;
  sadelfilt_nn_1 = mkN "sadelfilt" ;
  sadelformig_av_1 = mkA "sadelformig" ;
  sadelgjord_nn_1 = mkN "sadelgjord" ;
  sadelknapp_nn_1 = mkN "sadelknapp" ;
  sadelmakare_nn_1 = mkN "sadelmakare" "sadelmakare" ;
  sadelmakarnaal_nn_1 = mkN "sadelmakarnеl" ;
  sadelmakarstift_nn_1 = mkN "sadelmakarstift" neutrum ;
  sadelmakeri_nn_1 = mkN "sadelmakeri" "sadelmakerit" "sadelmakerier" "sadelmakerierna" ;
  sadelplats_nn_1 = mkN "sadelplats" "sadelplatser" ;
  sadelskydd_nn_1 = mkN "sadelskydd" neutrum ;
  sadeltak_nn_1 = mkN "sadeltak" neutrum ;
  sadist_nn_1 = mkN "sadist" "sadister" ;
  sadistisk_av_1 = mkA "sadistisk" ;
  sado_masochistisk_av_1 = mkA "sado-masochistisk" ;
  saeck_nn_1 = mkN "sдck" ;
  saeckig_av_1 = mkA "sдckig" ;
  saeckliknande_av_1 = mkA "sдckliknande" ;
  saecksvamp_nn_1 = mkN "sдcksvamp" ;
  saedescell_nn_1 = mkN "sдdescell" "sдdesceller" ;
  saedeskaerve_nn_1 = mkN "sдdeskдrve" utrum ;
  saedesledare_nn_1 = mkN "sдdesledare" "sдdesledare" ;
  saedesskyl_nn_1 = mkN "sдdesskyl" ;
  saedesslag_nn_1 = mkN "sдdesslag" neutrum ;
  saedestork_nn_1 = mkN "sдdestork" ;
  saedesuttoemning_nn_1 = mkN "sдdesuttцmning" ;
  saedgaas_nn_1 = mkN "sдdgеs" "sдdgеsen" "sдdgдss" "sдdgдssen" ;
  saegen_nn_1 = mkN "sдgen" "sдgenn" "sдgner" "sдgnerna" ;
  saegenomspunnen_av_1 = mkA "sдgenomspunnen" "sдgenomspunnet" "sдgenomspunna" "sдgenomspunna" "sдgenomspunnare" "sдgenomspunnast" "sдgenomspunnaste" ;
  saeker_av_1 = mkA "sдker" "sдkert" "sдkra" "sдkra" "sдkrare" "sдkrast" "sдkraste" ;
  saekerhet_nn_1 = mkN "sдkerhet" "sдkerheter" ;
  saekerhetsbaelte_nn_1 = mkN "sдkerhetsbдlte" ;
  saekerhetsbestaemmelse_nn_1 = mkN "sдkerhetsbestдmmelse" "sдkerhetsbestдmmelser" ;
  saekerhetsfilosofi_nn_1 = mkN "sдkerhetsfilosofi" "sдkerhetsfilosofier" ;
  saekerhetsfoereskrift_nn_1 = mkN "sдkerhetsfцreskrift" "sдkerhetsfцreskrifter" ;
  saekerhetsgrepp_nn_1 = mkN "sдkerhetsgrepp" neutrum ;
  saekerhetskedja_nn_1 = mkN "sдkerhetskedja" ;
  saekerhetsman_nn_1 = mkN "sдkerhetsman" "sдkerhetsmannen" "sдkerhetsmдn" "sдkerhetsmдnnen" ;
  saekerhetsnaal_nn_1 = mkN "sдkerhetsnеl" ;
  saekerhetspolis_nn_1 = mkN "sдkerhetspolis" "sдkerhetspoliser" ;
  saekerhetsproblem_nn_1 = mkN "sдkerhetsproblem" neutrum ;
  saekerhetsrisk_nn_1 = mkN "sдkerhetsrisk" "sдkerhetsrisker" ;
  saekerhetsskael_nn_1 = mkN "sдkerhetsskдl" neutrum ;
  saekerhetssystem_nn_1 = mkN "sдkerhetssystem" neutrum ;
  saekerhetsventil_nn_1 = mkN "sдkerhetsventil" "sдkerhetsventiler" ;
  saekerligen_ab_1 = mkAdv "sдkerligen" ;
  saekring_nn_1 = mkN "sдkring" ;
  sael_nn_1 = mkN "sдl" ;
  saeldjur_nn_1 = mkN "sдldjur" neutrum ;
  saelg_nn_1 = mkN "sдlg" ;
  saeljare_nn_1 = mkN "sдljare" "sдljare" ;
  saeljbar_av_1 = mkA "sдljbar" ;
  saelkut_nn_1 = mkN "sдlkut" ;
  saell_av_1 = mkA "sдll" ;
  saellan_ab_1 = mkAdv "sдllan" ;
  saelle_nn_1 = mkN "sдlle" utrum ;
  saellhet_nn_1 = mkN "sдllhet" "sдllheter" ;
  saellsam_av_1 = mkA "sдllsam" "sдllsamt" "sдllsamma" "sдllsamma" "sдllsammare" "sдllsammast" "sдllsammaste" ;
  saellskap_nn_1 = mkN "sдllskap" "sдllskapet" "sдllskapen" "sдllskapena" ;
  saellskaplig_av_1 = mkA "sдllskaplig" ;
  saellskapsdam_nn_1 = mkN "sдllskapsdam" "sдllskapsdamer" ;
  saellskapsdans_nn_1 = mkN "sдllskapsdans" "sдllskapsdanser" ;
  saellskapsdjur_nn_1 = mkN "sдllskapsdjur" neutrum ;
  saellskapsliv_nn_1 = mkN "sдllskapsliv" neutrum ;
  saellskapsmaenniska_nn_1 = mkN "sдllskapsmдnniska" ;
  saellskapsrum_nn_1 = mkN "sдllskapsrum" "sдllskapsrummet" "sдllskapsrum" "sдllskapsrummen" ;
  saellskapssjuk_av_1 = mkA "sдllskapssjuk" ;
  saellskapsspel_nn_1 = mkN "sдllskapsspel" "sдllskapsspelet" "sдllskapsspel" "sдllskapsspelen" ;
  saellspord_av_1 = mkA "sдllspord" "sдllsport" ;
  saellsynt_av_1 = mkA "sдllsynt" "sдllsynt" ;
  saelltrae_nn_1 = mkN "sдlltrд" "sдlltrдet" "sдlltrдn" "sдlltrдna" ;
  saelunge_nn_1 = mkN "sдlunge" utrum ;
  saemskskinn_nn_1 = mkN "sдmskskinn" neutrum ;
  saendare_nn_1 = mkN "sдndare" "sдndare" ;
  saendebud_nn_1 = mkN "sдndebud" neutrum ;
  saendning_nn_1 = mkN "sдndning" ;
  saeng_nn_1 = mkN "sдng" ;
  saengdags_ab_1 = mkAdv "sдngdags" ;
  saengfoesare_nn_1 = mkN "sдngfцsare" "sдngfцsare" ;
  saengfot_nn_1 = mkN "sдngfot" "sдngfцtter" ;
  saenghimmel_nn_1 = mkN "sдnghimmel" ;
  saengkammare_nn_1 = mkN "sдngkammare" "sдngkammaren" "sдngkamrar" "sдngkamrarna" ;
  saengkant_nn_1 = mkN "sдngkant" "sдngkanter" ;
  saengliggande_av_1 = mkA "sдngliggande" ;
  saengroekare_nn_1 = mkN "sдngrцkare" "sдngrцkare" ;
  saengvaetare_nn_1 = mkN "sдngvдtare" "sдngvдtare" ;
  saenkhaav_nn_1 = mkN "sдnkhеv" ;
  saenkning_nn_1 = mkN "sдnkning" ;
  saenkningstecken_nn_1 = mkN "sдnkningstecken" "sдnkningstecknet" "sдnkningstecken" "sдnkningstecknen" ;
  saenkvaag_nn_1 = mkN "sдnkvеg" ;
  saer_av_1 = mkA "sдr" ;
  saerbo_nn_1 = mkN "sдrbo" "sдrbor" ;
  saerdeles_ab_1 = mkAdv "sдrdeles" ;
  saerdrag_nn_1 = mkN "sдrdrag" neutrum ;
  saeregen_av_1 = mkA "sдregen" "sдreget" ;
  saerfall_nn_1 = mkN "sдrfall" neutrum ;
  saerfraaga_nn_1 = mkN "sдrfrеga" ;
  saerk_nn_1 = mkN "sдrk" ;
  saerklassig_av_1 = mkA "sдrklassig" ;
  saerkullbarn_nn_1 = mkN "sдrkullbarn" neutrum ;
  saerla_ab_1 = mkAdv "sдrla" ;
  saerling_nn_1 = mkN "sдrling" ;
  saermaerke_nn_1 = mkN "sдrmдrke" ;
  saerskild_av_1 = mkA "sдrskild" "sдrskilt" ;
  saerskilt_ab_1 = mkAdv "sдrskilt" ;
  saerstaellning_nn_1 = mkN "sдrstдllning" ;
  saertryck_nn_1 = mkN "sдrtryck" neutrum ;
  saesong_nn_1 = mkN "sдsong" "sдsonger" ;
  saesongsvis_ab_1 = mkAdv "sдsongsvis" ;
  saete_nn_1 = mkN "sдte" ;
  saeter_nn_1 = mkN "sдter" ;
  saeteri_nn_1 = mkN "sдteri" "sдterit" "sдterier" "sдterierna" ;
  saeteritak_nn_1 = mkN "sдteritak" neutrum ;
  saetesgaard_nn_1 = mkN "sдtesgеrd" ;
  saett_nn_1 = mkN "sдtt" neutrum ;
  saettare_nn_1 = mkN "sдttare" "sдttare" ;
  saetteri_nn_1 = mkN "sдtteri" "sдtterit" "sдtterier" "sдtterierna" ;
  saettmaskin_nn_1 = mkN "sдttmaskin" "sдttmaskiner" ;
  saettnaet_nn_1 = mkN "sдttnдt" neutrum ;
  saettning_nn_1 = mkN "sдttning" ;
  saettpotatis_nn_1 = mkN "sдttpotatis" ;
  saettsadverbial_nn_1 = mkN "sдttsadverbial" neutrum ;
  saevlig_av_1 = mkA "sдvlig" ;
  safari_nn_1 = mkN "safari" "safarin" "safarier" "safarierna" ;
  saffransbroed_nn_1 = mkN "saffransbrцd" neutrum ;
  saffransgul_av_1 = mkA "saffransgul" ;
  safir_nn_1 = mkN "safir" "safirer" ;
  safirnaal_nn_1 = mkN "safirnеl" ;
  saft_nn_1 = mkN "saft" "safter" ;
  saftglass_nn_1 = mkN "saftglass" ;
  saftig_av_1 = mkA "saftig" ;
  saftkalas_nn_1 = mkN "saftkalas" neutrum ;
  saftkraem_nn_1 = mkN "saftkrдm" "saftkrдmer" ;
  saftpress_nn_1 = mkN "saftpress" ;
  saftsaas_nn_1 = mkN "saftsеs" "saftsеser" ;
  saftstation_nn_1 = mkN "saftstation" "saftstationer" ;
  saga_nn_1 = mkN "saga" ;
  sagesman_nn_1 = mkN "sagesman" "sagesmannen" "sagesmдn" "sagesmдnnen" ;
  sagoberaettare_nn_1 = mkN "sagoberдttare" "sagoberдttare" ;
  sagobok_nn_1 = mkN "sagobok" "sagobцcker" ;
  sagocykel_nn_1 = mkN "sagocykel" ;
  sagodjur_nn_1 = mkN "sagodjur" neutrum ;
  sagofigur_nn_1 = mkN "sagofigur" "sagofigurer" ;
  sagogryn_nn_1 = mkN "sagogryn" neutrum ;
  sagohjaelte_nn_1 = mkN "sagohjдlte" utrum ;
  sagokrets_nn_1 = mkN "sagokrets" ;
  sagoland_nn_1 = mkN "sagoland" "sagolandet" "sagolдnder" "sagolдnderna" ;
  sagolik_av_1 = mkA "sagolik" ;
  sagopalm_nn_1 = mkN "sagopalm" "sagopalmer" ;
  sagoprins_nn_1 = mkN "sagoprins" ;
  sagosamling_nn_1 = mkN "sagosamling" ;
  sagoskimrande_av_1 = mkA "sagoskimrande" ;
  sagostund_nn_1 = mkN "sagostund" "sagostunder" ;
  sagovaerld_nn_1 = mkN "sagovдrld" ;
  sagovaesen_nn_1 = mkN "sagovдsen" "sagovдsendet" "sagovдsen" "sagovдsena" ;
  sahib_nn_1 = mkN "sahib" "sahiber" ;
  sak_nn_1 = mkN "sak" "saker" ;
  sakaegande_nn_1 = mkN "sakдgande" "sakдganden" "sakдgande" "sakдgandena" ;
  sakaegare_nn_1 = mkN "sakдgare" "sakдgare" ;
  sakdebatt_nn_1 = mkN "sakdebatt" "sakdebatter" ;
  sakdiskussion_nn_1 = mkN "sakdiskussion" "sakdiskussioner" ;
  saker_av_1 = mkA "saker" ;
  sakfel_nn_1 = mkN "sakfel" "sakfelet" "sakfel" "sakfelen" ;
  sakfoerare_nn_1 = mkN "sakfцrare" "sakfцrare" ;
  sakfoerhaallande_nn_1 = mkN "sakfцrhеllande" ;
  sakfoerklaring_nn_1 = mkN "sakfцrklaring" ;
  sakfoersaekring_nn_1 = mkN "sakfцrsдkring" ;
  sakfoerstaandig_av_1 = mkA "sakfцrstеndig" ;
  sakfraaga_nn_1 = mkN "sakfrеga" ;
  sakframstaellning_nn_1 = mkN "sakframstдllning" ;
  sakkaennedom_nn_1 = mkN "sakkдnnedom" ;
  sakkunnig_av_1 = mkA "sakkunnig" ;
  sakkunnigberedning_nn_1 = mkN "sakkunnigberedning" ;
  sakkunnigbetaenkande_nn_1 = mkN "sakkunnigbetдnkande" ;
  sakkunniguppdrag_nn_1 = mkN "sakkunniguppdrag" neutrum ;
  sakkunnigutlaatande_nn_1 = mkN "sakkunnigutlеtande" ;
  saklig_av_1 = mkA "saklig" ;
  saklighet_nn_1 = mkN "saklighet" "sakligheter" ;
  sakloes_av_1 = mkA "saklцs" ;
  sakloest_ab_1 = mkAdv "saklцst" ;
  saknad_nn_1 = mkN "saknad" "saknader" ;
  sakobjekt_nn_1 = mkN "sakobjekt" neutrum ;
  sakoere_nn_1 = mkN "sakцre" ;
  sakoereslaengd_nn_1 = mkN "sakцreslдngd" "sakцreslдngder" ;
  sakord_nn_1 = mkN "sakord" neutrum ;
  sakproevning_nn_1 = mkN "sakprцvning" ;
  sakraettslig_av_1 = mkA "sakrдttslig" ;
  sakral_av_1 = mkA "sakral" ;
  sakrament_nn_1 = mkN "sakrament" "sakramentet" "sakramenten" "sakramentena" ;
  sakramental_av_1 = mkA "sakramental" ;
  sakramentsskaap_nn_1 = mkN "sakramentsskеp" neutrum ;
  sakregister_nn_1 = mkN "sakregister" neutrum ;
  sakrilegium_nn_1 = mkN "sakrilegium" "sakrilegiet" "sakrilegier" "sakrilegierna" ;
  sakrosankt_av_1 = mkA "sakrosankt" "sakrosankt" ;
  sakskael_nn_1 = mkN "sakskдl" neutrum ;
  saksoekande_av_1 = mkA "saksцkande" ;
  sakta_ab_1 = mkAdv "sakta" ;
  sakta_av_1 = mkA "sakta" ;
  sakteliga_ab_1 = mkAdv "sakteliga" ;
  sakteligen_ab_1 = mkAdv "sakteligen" ;
  saktfaerdig_av_1 = mkA "saktfдrdig" ;
  saktmodig_av_1 = mkA "saktmodig" ;
  sakuppgift_nn_1 = mkN "sakuppgift" "sakuppgifter" ;
  sakupplysning_nn_1 = mkN "sakupplysning" ;
  sal_nn_1 = mkN "sal" ;
  saladjaer_nn_1 = mkN "saladjдr" "saladjдrer" ;
  salamander_nn_1 = mkN "salamander" ;
  salband_nn_1 = mkN "salband" neutrum ;
  saldo_nn_1 = mkN "saldo" "saldot" "saldon" "saldona" ;
  salig_av_1 = mkA "salig" ;
  saligen_ab_1 = mkAdv "saligen" ;
  saliggoerande_av_1 = mkA "saliggцrande" ;
  salighet_nn_1 = mkN "salighet" "saligheter" ;
  salighetslaera_nn_1 = mkN "salighetslдra" ;
  salighetsmedel_nn_1 = mkN "salighetsmedel" neutrum ;
  salighetsrus_nn_1 = mkN "salighetsrus" neutrum ;
  salighetsvaeg_nn_1 = mkN "salighetsvдg" ;
  saligprisning_nn_1 = mkN "saligprisning" ;
  salin_nn_1 = mkN "salin" "saliner" ;
  salinitet_nn_1 = mkN "salinitet" "saliniteter" ;
  salisk_av_1 = mkA "salisk" ;
  salivprov_nn_1 = mkN "salivprov" neutrum ;
  salivsug_nn_1 = mkN "salivsug" ;
  sallad_nn_1 = mkN "sallad" "sallader" ;
  salladsbestick_nn_1 = mkN "salladsbestick" neutrum ;
  salladshuvud_nn_1 = mkN "salladshuvud" "salladshuvudet" "salladshuvuden" "salladshuvudena" ;
  salladsskaal_nn_1 = mkN "salladsskеl" ;
  salning_nn_1 = mkN "salning" ;
  salningshorn_nn_1 = mkN "salningshorn" neutrum ;
  salomonisk_av_1 = mkA "salomonisk" ;
  salong_nn_1 = mkN "salong" "salonger" ;
  salongsbaat_nn_1 = mkN "salongsbеt" ;
  salongsbiljett_nn_1 = mkN "salongsbiljett" "salongsbiljetter" ;
  salongsbolsjevik_nn_1 = mkN "salongsbolsjevik" "salongsbolsjeviker" ;
  salongsfaehig_av_1 = mkA "salongsfдhig" ;
  salongsfilosof_nn_1 = mkN "salongsfilosof" "salongsfilosofer" ;
  salongsgevaer_nn_1 = mkN "salongsgevдr" neutrum ;
  salongskomedi_nn_1 = mkN "salongskomedi" "salongskomedier" ;
  salongskommunist_nn_1 = mkN "salongskommunist" "salongskommunister" ;
  salongslejon_nn_1 = mkN "salongslejon" neutrum ;
  salongsorkester_nn_1 = mkN "salongsorkester" ;
  salongsruff_nn_1 = mkN "salongsruff" ;
  salongsuppassare_nn_1 = mkN "salongsuppassare" "salongsuppassare" ;
  salongsvagn_nn_1 = mkN "salongsvagn" ;
  saloon_nn_1 = mkN "saloon" "salooner" ;
  saloondoerr_nn_1 = mkN "saloondцrr" ;
  salpeterbakterie_nn_1 = mkN "salpeterbakterie" "salpeterbakterier" ;
  salpetersjuderi_nn_1 = mkN "salpetersjuderi" "salpetersjuderit" "salpetersjuderier" "salpetersjuderierna" ;
  salpetersyrlighet_nn_1 = mkN "salpetersyrlighet" "salpetersyrligheter" ;
  salpingit_nn_1 = mkN "salpingit" "salpingiter" ;
  salskrake_nn_1 = mkN "salskrake" utrum ;
  salspatient_nn_1 = mkN "salspatient" "salspatienter" ;
  salt_av_1 = mkA "salt" "salt" ;
  salt_nn_1 = mkN "salt" "saltet" "salter" "salterna" ;
  saltaelskande_av_1 = mkA "saltдlskande" ;
  saltaeng_nn_1 = mkN "saltдng" ;
  saltavlagring_nn_1 = mkN "saltavlagring" ;
  saltbad_nn_1 = mkN "saltbad" neutrum ;
  saltbassaeng_nn_1 = mkN "saltbassдng" "saltbassдnger" ;
  saltbehov_nn_1 = mkN "saltbehov" neutrum ;
  saltbemaengd_av_1 = mkA "saltbemдngd" "saltbemдngt" ;
  saltbildare_nn_1 = mkN "saltbildare" "saltbildare" ;
  saltdamm_nn_1 = mkN "saltdamm" ;
  salteri_nn_1 = mkN "salteri" "salterit" "salterier" "salterierna" ;
  saltgrop_nn_1 = mkN "saltgrop" ;
  salthalt_nn_1 = mkN "salthalt" "salthalter" ;
  salthaltig_av_1 = mkA "salthaltig" ;
  saltig_av_1 = mkA "saltig" ;
  saltkar_nn_1 = mkN "saltkar" neutrum ;
  saltkoncentration_nn_1 = mkN "saltkoncentration" "saltkoncentrationer" ;
  saltkristall_nn_1 = mkN "saltkristall" "saltkristaller" ;
  saltloesning_nn_1 = mkN "saltlцsning" ;
  saltoeken_nn_1 = mkN "saltцken" "saltцkenn" "saltцknar" "saltцknarna" ;
  saltoert_nn_1 = mkN "saltцrt" "saltцrter" ;
  saltomortal_nn_1 = mkN "saltomortal" "saltomortaler" ;
  saltprovare_nn_1 = mkN "saltprovare" "saltprovare" ;
  saltsjoe_nn_1 = mkN "saltsjц" ;
  saltstaenkt_av_1 = mkA "saltstдnkt" "saltstдnkt" ;
  saltstod_nn_1 = mkN "saltstod" "saltstoder" ;
  saltstroeare_nn_1 = mkN "saltstrцare" "saltstrцare" ;
  saltutvinning_nn_1 = mkN "saltutvinning" ;
  saltvaext_nn_1 = mkN "saltvдxt" "saltvдxter" ;
  saltvatten_nn_1 = mkN "saltvatten" "saltvattnet" "saltvatten" "saltvattnen" ;
  saltvattensfisk_nn_1 = mkN "saltvattensfisk" ;
  saltverk_nn_1 = mkN "saltverk" neutrum ;
  salubjuda_vb_1 = mkV "salubjuda" "salubjцd" "salubjudit" ;
  saluhall_nn_1 = mkN "saluhall" ;
  salupris_nn_1 = mkN "salupris" neutrum ;
  salustaand_nn_1 = mkN "salustеnd" neutrum ;
  salut_nn_1 = mkN "salut" "saluter" ;
  salutdag_nn_1 = mkN "salutdag" ;
  salutkanon_nn_1 = mkN "salutkanon" "salutkanoner" ;
  salutorg_nn_1 = mkN "salutorg" neutrum ;
  salutskott_nn_1 = mkN "salutskott" neutrum ;
  saluvaerde_nn_1 = mkN "saluvдrde" ;
  salvadoran_nn_1 = mkN "salvadoran" "salvadoraner" ;
  salvationist_nn_1 = mkN "salvationist" "salvationister" ;
  salvelsefull_av_1 = mkA "salvelsefull" ;
  salvkanon_nn_1 = mkN "salvkanon" "salvkanoner" ;
  samarbetsman_nn_1 = mkN "samarbetsman" "samarbetsmannen" "samarbetsmдn" "samarbetsmдnnen" ;
  samarbetsvillig_av_1 = mkA "samarbetsvillig" ;
  samarit_nn_1 = mkN "samarit" "samariter" ;
  samarv_nn_1 = mkN "samarv" neutrum ;
  samarva_av_1 = mkA "samarva" ;
  samband_nn_1 = mkN "samband" neutrum ;
  sambandsofficer_nn_1 = mkN "sambandsofficer" "sambandsofficern" "sambandsofficerare" "sambandsofficerarna" ;
  sambeskattning_nn_1 = mkN "sambeskattning" ;
  sambladig_av_1 = mkA "sambladig" ;
  sambo_nn_1 = mkN "sambo" "sambor" ;
  sambo_nn_2 = mkN "sambo" "sambon" "sambos" "sambosen" ;
  samboende_av_1 = mkA "samboende" ;
  sambord_nn_1 = mkN "sambord" neutrum ;
  sambyggare_nn_1 = mkN "sambyggare" "sambyggare" ;
  same_nn_1 = mkN "same" "samer" ;
  sameby_nn_1 = mkN "sameby" "samebyn" "samebyar" "samebyarna" ;
  samekultur_nn_1 = mkN "samekultur" "samekulturer" ;
  sameland_nn_1 = mkN "sameland" "samelandet" "samelдnder" "samelдnderna" ;
  samfaelld_av_1 = mkA "samfдlld" "samfдllt" ;
  samfaellig_av_1 = mkA "samfдllig" ;
  samfaellighet_nn_1 = mkN "samfдllighet" "samfдlligheter" ;
  samfaerdsled_nn_1 = mkN "samfдrdsled" "samfдrdsleder" ;
  samfaerdsmedel_nn_1 = mkN "samfдrdsmedel" neutrum ;
  samfund_nn_1 = mkN "samfund" neutrum ;
  samhaellelig_av_1 = mkA "samhдllelig" ;
  samhaellsbevarande_av_1 = mkA "samhдllsbevarande" ;
  samhaellsbevarare_nn_1 = mkN "samhдllsbevarare" "samhдllsbevarare" ;
  samhaellsbildande_av_1 = mkA "samhдllsbildande" ;
  samhaellsekonomisk_av_1 = mkA "samhдllsekonomisk" ;
  samhaellsfara_nn_1 = mkN "samhдllsfara" ;
  samhaellsfarlig_av_1 = mkA "samhдllsfarlig" ;
  samhaellsfientlig_av_1 = mkA "samhдllsfientlig" ;
  samhaellsfoerbaettrare_nn_1 = mkN "samhдllsfцrbдttrare" "samhдllsfцrbдttrare" ;
  samhaellsfoerdrag_nn_1 = mkN "samhдllsfцrdrag" neutrum ;
  samhaellsform_nn_1 = mkN "samhдllsform" "samhдllsformer" ;
  samhaellsforskare_nn_1 = mkN "samhдllsforskare" "samhдllsforskare" ;
  samhaellsfraanvaend_av_1 = mkA "samhдllsfrеnvдnd" ;
  samhaellsfunktion_nn_1 = mkN "samhдllsfunktion" "samhдllsfunktioner" ;
  samhaellsgrupp_nn_1 = mkN "samhдllsgrupp" "samhдllsgrupper" ;
  samhaellsingripande_nn_1 = mkN "samhдllsingripande" ;
  samhaellsinsats_nn_1 = mkN "samhдllsinsats" "samhдllsinsatser" ;
  samhaellsklass_nn_1 = mkN "samhдllsklass" "samhдllsklasser" ;
  samhaellskontrakt_nn_1 = mkN "samhдllskontrakt" neutrum ;
  samhaellskostnad_nn_1 = mkN "samhдllskostnad" "samhдllskostnader" ;
  samhaellskritiker_nn_1 = mkN "samhдllskritiker" "samhдllskritikern" "samhдllskritiker" "samhдllskritikerna" ;
  samhaellskritisk_av_1 = mkA "samhдllskritisk" ;
  samhaellskropp_nn_1 = mkN "samhдllskropp" ;
  samhaellsnorm_nn_1 = mkN "samhдllsnorm" "samhдllsnormer" ;
  samhaellsnytta_nn_1 = mkN "samhдllsnytta" ;
  samhaellsnyttig_av_1 = mkA "samhдllsnyttig" ;
  samhaellsomstoertande_av_1 = mkA "samhдllsomstцrtande" ;
  samhaellsomstoertare_nn_1 = mkN "samhдllsomstцrtare" "samhдllsomstцrtare" ;
  samhaellsordning_nn_1 = mkN "samhдllsordning" ;
  samhaellsorgan_nn_1 = mkN "samhдllsorgan" neutrum ;
  samhaellsorienterande_av_1 = mkA "samhдllsorienterande" ;
  samhaellsplanerare_nn_1 = mkN "samhдllsplanerare" "samhдllsplanerare" ;
  samhaellsplanering_nn_1 = mkN "samhдllsplanering" ;
  samhaellsproblem_nn_1 = mkN "samhдllsproblem" neutrum ;
  samhaellspyramid_nn_1 = mkN "samhдllspyramid" "samhдllspyramider" ;
  samhaellsrepresentant_nn_1 = mkN "samhдllsrepresentant" "samhдllsrepresentanter" ;
  samhaellsskick_nn_1 = mkN "samhдllsskick" neutrum ;
  samhaellsskikt_nn_1 = mkN "samhдllsskikt" neutrum ;
  samhaellsskildring_nn_1 = mkN "samhдllsskildring" ;
  samhaellsstaellning_nn_1 = mkN "samhдllsstдllning" ;
  samhaellssyn_nn_1 = mkN "samhдllssyn" "samhдllssyner" ;
  samhaellssystem_nn_1 = mkN "samhдllssystem" neutrum ;
  samhaellstillvaend_av_1 = mkA "samhдllstillvдnd" ;
  samhaellsuppbyggnad_nn_1 = mkN "samhдllsuppbyggnad" "samhдllsuppbyggnader" ;
  samhaellsvarelse_nn_1 = mkN "samhдllsvarelse" "samhдllsvarelser" ;
  samhaellsvetare_nn_1 = mkN "samhдllsvetare" "samhдllsvetare" ;
  samhaellsvetenskap_nn_1 = mkN "samhдllsvetenskap" "samhдllsvetenskaper" ;
  samhaellsvetenskaplig_av_1 = mkA "samhдllsvetenskaplig" ;
  samhoerande_av_1 = mkA "samhцrande" ;
  samhoerig_av_1 = mkA "samhцrig" ;
  samhoerighet_nn_1 = mkN "samhцrighet" "samhцrigheter" ;
  samhoerighetskaensla_nn_1 = mkN "samhцrighetskдnsla" ;
  samisk_av_1 = mkA "samisk" ;
  samizdat_nn_1 = mkN "samizdat" ;
  samkoep_nn_1 = mkN "samkцp" neutrum ;
  samkoerning_nn_1 = mkN "samkцrning" ;
  samkvaem_nn_1 = mkN "samkvдm" neutrum ;
  samlag_nn_1 = mkN "samlag" neutrum ;
  samlagspartner_nn_1 = mkN "samlagspartner" "samlagspartnern" "samlagspartner" "samlagspartnerna" ;
  samlare_nn_1 = mkN "samlare" "samlare" ;
  samlarfoeremaal_nn_1 = mkN "samlarfцremеl" neutrum ;
  samlarfolk_nn_1 = mkN "samlarfolk" neutrum ;
  samlevnad_nn_1 = mkN "samlevnad" "samlevnader" ;
  samling_nn_1 = mkN "samling" ;
  samlingsband_nn_1 = mkN "samlingsband" neutrum ;
  samlingslins_nn_1 = mkN "samlingslins" "samlingslinser" ;
  samlingslokal_nn_1 = mkN "samlingslokal" "samlingslokaler" ;
  samlingsnamn_nn_1 = mkN "samlingsnamn" neutrum ;
  samlingspaerm_nn_1 = mkN "samlingspдrm" ;
  samlingsparti_nn_1 = mkN "samlingsparti" "samlingspartit" "samlingspartier" "samlingspartierna" ;
  samlingsplats_nn_1 = mkN "samlingsplats" "samlingsplatser" ;
  samlingspunkt_nn_1 = mkN "samlingspunkt" "samlingspunkter" ;
  samlingsregering_nn_1 = mkN "samlingsregering" ;
  samlingsrum_nn_1 = mkN "samlingsrum" "samlingsrummet" "samlingsrum" "samlingsrummen" ;
  samlingssal_nn_1 = mkN "samlingssal" ;
  samlingsverk_nn_1 = mkN "samlingsverk" neutrum ;
  sammald_av_1 = mkA "sammald" "sammalt" ;
  sammaledes_ab_1 = mkAdv "sammaledes" ;
  sammalen_av_1 = mkA "sammalen" "sammalet" ;
  sammalunda_ab_1 = mkAdv "sammalunda" ;
  samman_ab_1 = mkAdv "samman" ;
  sammanbinda_vb_1 = mkV "sammanbinda" "sammanband" "sammanbundit" ;
  sammanbindning_nn_1 = mkN "sammanbindning" ;
  sammanbiten_av_1 = mkA "sammanbiten" "sammanbitet" ;
  sammanboende_av_1 = mkA "sammanboende" ;
  sammanbragt_av_1 = mkA "sammanbragt" "sammanbragt" ;
  sammanbrott_nn_1 = mkN "sammanbrott" neutrum ;
  sammandra_vb_1 = mkV "sammandra" "sammandrar" "sammandra" "sammandrog" "sammandragit" "sammandragen" ;
  sammandrabbning_nn_1 = mkN "sammandrabbning" ;
  sammandrag_nn_1 = mkN "sammandrag" neutrum ;
  sammandragning_nn_1 = mkN "sammandragning" ;
  sammanfall_nn_1 = mkN "sammanfall" neutrum ;
  sammanfalla_vb_1 = mkV "sammanfalla" "sammanfцll" "sammanfallit" ;
  sammanfattning_nn_1 = mkN "sammanfattning" ;
  sammanfattningsvis_ab_1 = mkAdv "sammanfattningsvis" ;
  sammanfloede_nn_1 = mkN "sammanflцde" ;
  sammanfogning_nn_1 = mkN "sammanfogning" ;
  sammangaaende_nn_1 = mkN "sammangеende" ;
  sammanhaalla_vb_1 = mkV "sammanhеlla" "sammanhцll" "sammanhеllit" ;
  sammanhaallen_av_1 = mkA "sammanhеllen" "sammanhеllet" ;
  sammanhaallig_av_1 = mkA "sammanhеllig" ;
  sammanhaengande_nn_1 = mkN "sammanhдngande" ;
  sammanhang_nn_1 = mkN "sammanhang" neutrum ;
  sammankallande_av_1 = mkA "sammankallande" ;
  sammankomst_nn_1 = mkN "sammankomst" "sammankomster" ;
  sammanlaeggning_nn_1 = mkN "sammanlдggning" ;
  sammanlaeggningsavhandling_nn_1 = mkN "sammanlдggningsavhandling" ;
  sammanlagd_av_1 = mkA "sammanlagd" "sammanlagt" ;
  sammanraekning_nn_1 = mkN "sammanrдkning" ;
  sammansaettning_nn_1 = mkN "sammansдttning" ;
  sammansaettningsfabrik_nn_1 = mkN "sammansдttningsfabrik" "sammansдttningsfabriker" ;
  sammansaettningsled_nn_1 = mkN "sammansдttningsled" neutrum ;
  sammansatt_av_1 = mkA "sammansatt" ;
  sammanskjuta_vb_1 = mkV "sammanskjuta" "sammanskцt" "sammanskjutit" ;
  sammanskott_nn_1 = mkN "sammanskott" neutrum ;
  sammanskriva_vb_1 = mkV "sammanskriva" "sammanskrev" "sammanskrivit" ;
  sammanslagen_av_1 = mkA "sammanslagen" "sammanslaget" ;
  sammanslagning_nn_1 = mkN "sammanslagning" ;
  sammanslutning_nn_1 = mkN "sammanslutning" ;
  sammansmaeltning_nn_1 = mkN "sammansmдltning" ;
  sammanstaellning_nn_1 = mkN "sammanstдllning" ;
  sammanstoetning_nn_1 = mkN "sammanstцtning" ;
  sammansvaerja_vb_1 = mkV "sammansvдrja" "sammansvдrjer" "sammansvдrj" "sammansvor" "sammansvurit" "sammansvдrjd" ;
  sammansvaerjning_nn_1 = mkN "sammansvдrjning" ;
  sammansvuren_av_1 = mkA "sammansvuren" "sammansvuret" ;
  sammantagen_av_1 = mkA "sammantagen" "sammantaget" ;
  sammantraede_nn_1 = mkN "sammantrдde" ;
  sammantraedesordning_nn_1 = mkN "sammantrдdesordning" ;
  sammantraedesrum_nn_1 = mkN "sammantrдdesrum" "sammantrдdesrummet" "sammantrдdesrum" "sammantrдdesrummen" ;
  sammantraeffande_nn_1 = mkN "sammantrдffande" ;
  sammastaedes_ab_1 = mkAdv "sammastдdes" ;
  sammelband_nn_1 = mkN "sammelband" neutrum ;
  sammelnamn_nn_1 = mkN "sammelnamn" neutrum ;
  sammelplats_nn_1 = mkN "sammelplats" "sammelplatser" ;
  sammelsurium_nn_1 = mkN "sammelsurium" "sammelsuriet" "sammelsurier" "sammelsurierna" ;
  sammetsblomster_nn_1 = mkN "sammetsblomster" neutrum ;
  sammetsmjuk_av_1 = mkA "sammetsmjuk" ;
  samnit_nn_1 = mkN "samnit" "samniter" ;
  samnordisk_av_1 = mkA "samnordisk" ;
  samoan_nn_1 = mkN "samoan" "samoaner" ;
  samojed_nn_1 = mkN "samojed" "samojeder" ;
  samordnare_nn_1 = mkN "samordnare" "samordnare" ;
  samordning_nn_1 = mkN "samordning" ;
  samovar_nn_1 = mkN "samovar" "samovarer" ;
  sampan_nn_1 = mkN "sampan" "sampaner" ;
  sampel_nn_1 = mkN "sampel" neutrum ;
  sampling_nn_1 = mkN "sampling" ;
  samraad_nn_1 = mkN "samrеd" neutrum ;
  sams_av_1 = mkA "sams" ;
  samsaendning_nn_1 = mkN "samsдndning" ;
  samspelt_av_1 = mkA "samspelt" "samspelt" ;
  samstaemd_av_1 = mkA "samstдmd" "samstдmt" ;
  samstaemmig_av_1 = mkA "samstдmmig" ;
  samsyskon_nn_1 = mkN "samsyskon" neutrum ;
  samtal_nn_1 = mkN "samtal" "samtalet" "samtalen" "samtalena" ;
  samtalsaemne_nn_1 = mkN "samtalsдmne" ;
  samtalsavgift_nn_1 = mkN "samtalsavgift" "samtalsavgifter" ;
  samtalsgrupp_nn_1 = mkN "samtalsgrupp" "samtalsgrupper" ;
  samtalsmaetare_nn_1 = mkN "samtalsmдtare" "samtalsmдtare" ;
  samtalsmarkering_nn_1 = mkN "samtalsmarkering" ;
  samtalsperiod_nn_1 = mkN "samtalsperiod" "samtalsperioder" ;
  samtalsraeknare_nn_1 = mkN "samtalsrдknare" "samtalsrдknare" ;
  samtida_av_1 = mkA "samtida" ;
  samtidig_av_1 = mkA "samtidig" ;
  samtidighet_nn_1 = mkN "samtidighet" "samtidigheter" ;
  samtidigt_ab_1 = mkAdv "samtidigt" ;
  samtidsskildring_nn_1 = mkN "samtidsskildring" ;
  samuraj_nn_1 = mkN "samuraj" "samurajer" ;
  samurajsvaerd_nn_1 = mkN "samurajsvдrd" neutrum ;
  samvaelde_nn_1 = mkN "samvдlde" ;
  samvariation_nn_1 = mkN "samvariation" "samvariationer" ;
  samvetsaektenskap_nn_1 = mkN "samvetsдktenskap" "samvetsдktenskapet" "samvetsдktenskapen" "samvetsдktenskapena" ;
  samvetsbetaenklighet_nn_1 = mkN "samvetsbetдnklighet" "samvetsbetдnkligheter" ;
  samvetsfaange_nn_1 = mkN "samvetsfеnge" utrum ;
  samvetsfoerebraaelse_nn_1 = mkN "samvetsfцrebrеelse" "samvetsfцrebrеelser" ;
  samvetsfraaga_nn_1 = mkN "samvetsfrеga" ;
  samvetsfrihet_nn_1 = mkN "samvetsfrihet" "samvetsfriheter" ;
  samvetsgrann_av_1 = mkA "samvetsgrann" "samvetsgrant" ;
  samvetskonflikt_nn_1 = mkN "samvetskonflikt" "samvetskonflikter" ;
  samvetskval_nn_1 = mkN "samvetskval" neutrum ;
  samvetsloes_av_1 = mkA "samvetslцs" ;
  samvetsoem_av_1 = mkA "samvetsцm" "samvetsцmt" "samvetsцmma" "samvetsцmma" "samvetsцmmare" "samvetsцmmast" "samvetsцmmaste" ;
  samvetspeng_nn_1 = mkN "samvetspeng" ;
  samvetssak_nn_1 = mkN "samvetssak" "samvetssaker" ;
  samvetsskael_nn_1 = mkN "samvetsskдl" neutrum ;
  samvetsstyng_nn_1 = mkN "samvetsstyng" neutrum ;
  sanatorium_nn_1 = mkN "sanatorium" "sanatoriet" "sanatorier" "sanatorierna" ;
  sandal_nn_1 = mkN "sandal" "sandaler" ;
  sandalett_nn_1 = mkN "sandalett" "sandaletter" ;
  sandbad_nn_1 = mkN "sandbad" neutrum ;
  sandbakelse_nn_1 = mkN "sandbakelse" "sandbakelser" ;
  sandbank_nn_1 = mkN "sandbank" ;
  sandbindande_av_1 = mkA "sandbindande" ;
  sandbindare_nn_1 = mkN "sandbindare" "sandbindare" ;
  sandblaester_nn_1 = mkN "sandblдster" ;
  sandbotten_nn_1 = mkN "sandbotten" ;
  sanddyn_nn_1 = mkN "sanddyn" "sanddyner" ;
  sandeltraed_nn_1 = mkN "sandeltrдd" neutrum ;
  sandform_nn_1 = mkN "sandform" ;
  sandhed_nn_1 = mkN "sandhed" ;
  sandig_av_1 = mkA "sandig" ;
  sandjaegare_nn_1 = mkN "sandjдgare" "sandjдgare" ;
  sandjord_nn_1 = mkN "sandjord" ;
  sandkorn_nn_1 = mkN "sandkorn" neutrum ;
  sandkrypare_nn_1 = mkN "sandkrypare" "sandkrypare" ;
  sandlilja_nn_1 = mkN "sandlilja" ;
  sandloepare_nn_1 = mkN "sandlцpare" "sandlцpare" ;
  sandmark_nn_1 = mkN "sandmark" "sandmarker" ;
  sandmask_nn_1 = mkN "sandmask" ;
  sandmussla_nn_1 = mkN "sandmussla" ;
  sandoeken_nn_1 = mkN "sandцken" "sandцkenn" "sandцknar" "sandцknarna" ;
  sandpapper_nn_1 = mkN "sandpapper" neutrum ;
  sandrev_nn_1 = mkN "sandrev" neutrum ;
  sandrevel_nn_1 = mkN "sandrevel" ;
  sandroer_nn_1 = mkN "sandrцr" neutrum ;
  sandsaeck_nn_1 = mkN "sandsдck" ;
  sandstorm_nn_1 = mkN "sandstorm" ;
  sandstrand_nn_1 = mkN "sandstrand" "sandstrдnder" ;
  sandsugare_nn_1 = mkN "sandsugare" "sandsugare" ;
  sandtaekt_nn_1 = mkN "sandtдkt" "sandtдkter" ;
  sandtag_nn_1 = mkN "sandtag" neutrum ;
  sandur_nn_1 = mkN "sandur" neutrum ;
  sandvaext_nn_1 = mkN "sandvдxt" "sandvдxter" ;
  sandvikare_nn_1 = mkN "sandvikare" "sandvikare" ;
  sandwich_nn_1 = mkN "sandwich" ;
  sandwichman_nn_1 = mkN "sandwichman" "sandwichmannen" "sandwichmдn" "sandwichmдnnen" ;
  sanering_nn_1 = mkN "sanering" ;
  saneringsfastighet_nn_1 = mkN "saneringsfastighet" "saneringsfastigheter" ;
  saneringsmedel_nn_1 = mkN "saneringsmedel" neutrum ;
  saneringsplan_nn_1 = mkN "saneringsplan" "saneringsplaner" ;
  sang_nn_1 = mkN "sang" "sangen" "sang" "sangen" ;
  sangviniker_nn_1 = mkN "sangviniker" "sangvinikern" "sangviniker" "sangvinikerna" ;
  sangvinisk_av_1 = mkA "sangvinisk" ;
  sanitaer_av_1 = mkA "sanitдr" ;
  sanitet_nn_1 = mkN "sanitet" "saniteter" ;
  sanitetsanstalt_nn_1 = mkN "sanitetsanstalt" "sanitetsanstalter" ;
  sanitetsartikel_nn_1 = mkN "sanitetsartikel" ;
  sanitetshund_nn_1 = mkN "sanitetshund" ;
  sanitetskaerl_nn_1 = mkN "sanitetskдrl" neutrum ;
  sanitetskompani_nn_1 = mkN "sanitetskompani" "sanitetskompanit" "sanitetskompanier" "sanitetskompanierna" ;
  sanitetstekniker_nn_1 = mkN "sanitetstekniker" "sanitetsteknikern" "sanitetstekniker" "sanitetsteknikerna" ;
  sanitetstrupp_nn_1 = mkN "sanitetstrupp" "sanitetstrupper" ;
  sank_av_1 = mkA "sank" ;
  sanktbernhardshund_nn_1 = mkN "sanktbernhardshund" ;
  sanktifikation_nn_1 = mkN "sanktifikation" "sanktifikationer" ;
  sanktion_nn_1 = mkN "sanktion" "sanktioner" ;
  sanktuarium_nn_1 = mkN "sanktuarium" "sanktuariet" "sanktuarier" "sanktuarierna" ;
  sanmarinesare_nn_1 = mkN "sanmarinesare" "sanmarinesare" ;
  sanmarinesisk_av_1 = mkA "sanmarinesisk" ;
  sann_av_1 = mkA "sann" "sant" ;
  sanndroem_nn_1 = mkN "sanndrцm" "sanndrцmmen" "sanndrцmmar" "sanndrцmmarna" ;
  sannerligen_ab_1 = mkAdv "sannerligen" ;
  sannfaerdig_av_1 = mkA "sannfдrdig" ;
  sanning_nn_1 = mkN "sanning" ;
  sanningsdrog_nn_1 = mkN "sanningsdrog" "sanningsdroger" ;
  sanningsenlig_av_1 = mkA "sanningsenlig" ;
  sanningsfoersaekran_nn_1 = mkN "sanningsfцrsдkran" "sanningsfцrsдkran" "sanningsfцrsдkringar" "sanningsfцrsдkringarna" ;
  sanningskorn_nn_1 = mkN "sanningskorn" neutrum ;
  sanningskrav_nn_1 = mkN "sanningskrav" neutrum ;
  sanningsloes_av_1 = mkA "sanningslцs" ;
  sanningssaegare_nn_1 = mkN "sanningssдgare" "sanningssдgare" ;
  sanningssoekare_nn_1 = mkN "sanningssцkare" "sanningssцkare" ;
  sanningsvittne_nn_1 = mkN "sanningsvittne" ;
  sannolik_av_1 = mkA "sannolik" ;
  sannolikhet_nn_1 = mkN "sannolikhet" "sannolikheter" ;
  sannolikhetsbevis_nn_1 = mkN "sannolikhetsbevis" neutrum ;
  sannolikhetskalkyl_nn_1 = mkN "sannolikhetskalkyl" "sannolikhetskalkyler" ;
  sannolikhetsteori_nn_1 = mkN "sannolikhetsteori" "sannolikhetsteorier" ;
  sannsaga_nn_1 = mkN "sannsaga" ;
  sannskyldig_av_1 = mkA "sannskyldig" ;
  sannspaadd_av_1 = mkA "sannspеdd" "sannspеdtt" ;
  sansculotte_nn_1 = mkN "sansculotte" "sansculotter" ;
  sansloes_av_1 = mkA "sanslцs" ;
  sansning_nn_1 = mkN "sansning" ;
  sapfisk_av_1 = mkA "sapfisk" ;
  saponin_nn_1 = mkN "saponin" "saponinet" "saponiner" "saponinerna" ;
  sapp_nn_1 = mkN "sapp" "sapper" ;
  sappoer_nn_1 = mkN "sappцr" "sappцrer" ;
  saprofyt_nn_1 = mkN "saprofyt" "saprofyter" ;
  saprogen_av_1 = mkA "saprogen" ;
  saraband_nn_1 = mkN "saraband" "sarabander" ;
  saracen_nn_1 = mkN "saracen" "saracener" ;
  sarafan_nn_1 = mkN "sarafan" "sarafaner" ;
  sard_nn_1 = mkN "sard" "sarder" ;
  sardell_nn_1 = mkN "sardell" "sardeller" ;
  sardin_nn_1 = mkN "sardin" "sardiner" ;
  sardinare_nn_1 = mkN "sardinare" "sardinare" ;
  sardinisk_av_1 = mkA "sardinisk" ;
  sardiniska_nn_2 = mkN "sardiniska" ;
  sardinsk_av_1 = mkA "sardinsk" ;
  sardinska_nn_2 = mkN "sardinska" ;
  sardisk_av_1 = mkA "sardisk" ;
  sardiska_nn_2 = mkN "sardiska" ;
  sardonisk_av_1 = mkA "sardonisk" ;
  sarg_nn_1 = mkN "sarg" ;
  sari_nn_1 = mkN "sari" "sarin" "sarier" "sarierna" ;
  sarkasm_nn_1 = mkN "sarkasm" "sarkasmer" ;
  sarkastisk_av_1 = mkA "sarkastisk" ;
  sarkofag_nn_1 = mkN "sarkofag" "sarkofager" ;
  sarkom_nn_1 = mkN "sarkom" neutrum ;
  sarong_nn_1 = mkN "sarong" "saronger" ;
  sars_nn_1 = mkN "sars" "sarser" ;
  sarv_nn_1 = mkN "sarv" ;
  sataeng_nn_1 = mkN "satдng" "satдnger" ;
  satanisk_av_1 = mkA "satanisk" ;
  satanist_nn_1 = mkN "satanist" "satanister" ;
  sate_nn_1 = mkN "sate" utrum ;
  satellit_nn_1 = mkN "satellit" "satelliter" ;
  satellitstat_nn_1 = mkN "satellitstat" "satellitstater" ;
  satemspraak_nn_1 = mkN "satemsprеk" neutrum ;
  satin_nn_1 = mkN "satin" "satiner" ;
  satir_nn_1 = mkN "satir" "satirer" ;
  satiriker_nn_1 = mkN "satiriker" "satirikern" "satiriker" "satirikerna" ;
  satirisk_av_1 = mkA "satirisk" ;
  satisfaktion_nn_1 = mkN "satisfaktion" "satisfaktioner" ;
  satkaering_nn_1 = mkN "satkдring" ;
  satrap_nn_1 = mkN "satrap" "satraper" ;
  satrapi_nn_1 = mkN "satrapi" "satrapier" ;
  sats_nn_1 = mkN "sats" "satser" ;
  satsaccent_nn_1 = mkN "satsaccent" "satsaccenter" ;
  satsadverbial_nn_1 = mkN "satsadverbial" neutrum ;
  satsanalys_nn_1 = mkN "satsanalys" "satsanalyser" ;
  satsbindning_nn_1 = mkN "satsbindning" ;
  satsbord_nn_1 = mkN "satsbord" neutrum ;
  satsbraede_nn_1 = mkN "satsbrдde" ;
  satsbyggnad_nn_1 = mkN "satsbyggnad" "satsbyggnader" ;
  satsdel_nn_1 = mkN "satsdel" "satsdelen" "satsdelar" "satsdelarna" ;
  satsfoerkortning_nn_1 = mkN "satsfцrkortning" ;
  satsfogning_nn_1 = mkN "satsfogning" ;
  satskompletteringstest_nn_1 = mkN "satskompletteringstest" neutrum ;
  satskonstruktion_nn_1 = mkN "satskonstruktion" "satskonstruktioner" ;
  satsmelodi_nn_1 = mkN "satsmelodi" "satsmelodier" ;
  satsning_nn_1 = mkN "satsning" ;
  satsuma_nn_1 = mkN "satsuma" "satsuman" "satsumas" "satsumasen" ;
  satt_av_1 = mkA "satt" ;
  sattyg_nn_1 = mkN "sattyg" neutrum ;
  satunge_nn_1 = mkN "satunge" utrum ;
  saturnaliefest_nn_1 = mkN "saturnaliefest" "saturnaliefester" ;
  saturnalisk_av_1 = mkA "saturnalisk" ;
  saturnisk_av_1 = mkA "saturnisk" ;
  satyr_nn_1 = mkN "satyr" "satyrer" ;
  satyrdrama_nn_1 = mkN "satyrdrama" "satyrdramat" "satyrdraman" "satyrdramana" ;
  satyrspel_nn_1 = mkN "satyrspel" "satyrspelet" "satyrspel" "satyrspelen" ;
  saudiarab_nn_1 = mkN "saudiarab" "saudiaraber" ;
  saudiarabisk_av_1 = mkA "saudiarabisk" ;
  saudier_nn_1 = mkN "saudier" "saudiern" "saudier" "saudierna" ;
  saudisk_av_1 = mkA "saudisk" ;
  saute_nn_1 = mkN "sautй" "sautйer" ;
  savann_nn_1 = mkN "savann" "savanner" ;
  savarin_nn_1 = mkN "savarin" "savariner" ;
  savig_av_1 = mkA "savig" ;
  savningstid_nn_1 = mkN "savningstid" "savningstider" ;
  savojard_nn_1 = mkN "savojard" "savojarder" ;
  savtid_nn_1 = mkN "savtid" "savtider" ;
  sax_nn_1 = mkN "sax" ;
  saxare_nn_1 = mkN "saxare" "saxare" ;
  saxarm_nn_1 = mkN "saxarm" ;
  saxblad_nn_1 = mkN "saxblad" neutrum ;
  saxisk_av_1 = mkA "saxisk" ;
  saxkrok_nn_1 = mkN "saxkrok" ;
  saxnaebb_nn_1 = mkN "saxnдbb" ;
  saxofon_nn_1 = mkN "saxofon" "saxofoner" ;
  saxskaenkel_nn_1 = mkN "saxskдnkel" ;
  saxskaer_nn_1 = mkN "saxskдr" neutrum ;
  saxskalm_nn_1 = mkN "saxskalm" ;
  saxsprint_nn_1 = mkN "saxsprint" ;
  sbirr_nn_1 = mkN "sbirr" "sbirrer" ;
  scanner_nn_1 = mkN "scanner" ;
  scanning_nn_1 = mkN "scanning" ;
  scarf_nn_1 = mkN "scarf" ;
  scen_nn_1 = mkN "scen" "scener" ;
  scenanvisning_nn_1 = mkN "scenanvisning" ;
  scenarbetare_nn_1 = mkN "scenarbetare" "scenarbetare" ;
  scenario_nn_1 = mkN "scenario" "scenariot" "scenarion" "scenariona" ;
  scenbearbetning_nn_1 = mkN "scenbearbetning" ;
  scenbild_nn_1 = mkN "scenbild" "scenbilder" ;
  sceneri_nn_1 = mkN "sceneri" "scenerit" "scenerier" "scenerierna" ;
  scenfoeraendring_nn_1 = mkN "scenfцrдndring" ;
  scenframtraedande_nn_1 = mkN "scenframtrдdande" ;
  sceningaang_nn_1 = mkN "sceningеng" ;
  sceninstruktoer_nn_1 = mkN "sceninstruktцr" "sceninstruktцrer" ;
  scenisk_av_1 = mkA "scenisk" ;
  scenoeppning_nn_1 = mkN "scenцppning" ;
  scenograf_nn_1 = mkN "scenograf" "scenografer" ;
  scenuppfoerande_nn_1 = mkN "scenuppfцrande" ;
  scenvaexling_nn_1 = mkN "scenvдxling" ;
  scenvind_nn_1 = mkN "scenvind" ;
  scepter_nn_1 = mkN "scepter" neutrum ;
  schabbel_nn_1 = mkN "schabbel" neutrum ;
  schablon_nn_1 = mkN "schablon" "schabloner" ;
  schablonavdrag_nn_1 = mkN "schablonavdrag" neutrum ;
  schablonbelopp_nn_1 = mkN "schablonbelopp" neutrum ;
  schablonmaessig_av_1 = mkA "schablonmдssig" ;
  schablontillaegg_nn_1 = mkN "schablontillдgg" neutrum ;
  schabrak_nn_1 = mkN "schabrak" neutrum ;
  schack_av_1 = mkA "schack" ;
  schack_nn_2 = mkN "schack" ;
  schackbord_nn_1 = mkN "schackbord" neutrum ;
  schackbraede_nn_1 = mkN "schackbrдde" ;
  schackdrag_nn_1 = mkN "schackdrag" neutrum ;
  schackel_nn_1 = mkN "schackel" ;
  schackmatt_av_1 = mkA "schackmatt" ;
  schackmoenster_nn_1 = mkN "schackmцnster" neutrum ;
  schackningsperiod_nn_1 = mkN "schackningsperiod" "schackningsperioder" ;
  schackparti_nn_1 = mkN "schackparti" "schackpartit" "schackpartier" "schackpartierna" ;
  schackpjaes_nn_1 = mkN "schackpjдs" "schackpjдser" ;
  schackproblem_nn_1 = mkN "schackproblem" neutrum ;
  schackrare_nn_1 = mkN "schackrare" "schackrare" ;
  schackspel_nn_1 = mkN "schackspel" "schackspelet" "schackspel" "schackspelen" ;
  schackspelare_nn_1 = mkN "schackspelare" "schackspelare" ;
  schackturnering_nn_1 = mkN "schackturnering" ;
  schaefer_nn_1 = mkN "schдfer" ;
  schaeferhatt_nn_1 = mkN "schдferhatt" ;
  schaeferhund_nn_1 = mkN "schдferhund" ;
  schaeferi_nn_1 = mkN "schдferi" "schдferit" "schдferier" "schдferierna" ;
  schaes_nn_1 = mkN "schдs" ;
  schaeslong_nn_1 = mkN "schдslong" "schдslonger" ;
  schagg_nn_1 = mkN "schagg" "schagger" ;
  schah_nn_1 = mkN "schah" "schaher" ;
  schajas_nn_1 = mkN "schajas" ;
  schakaa_nn_1 = mkN "schakе" "schakеer" ;
  schakal_nn_1 = mkN "schakal" "schakaler" ;
  schakt_nn_1 = mkN "schakt" neutrum ;
  schaktmaskin_nn_1 = mkN "schaktmaskin" "schaktmaskiner" ;
  schaktugn_nn_1 = mkN "schaktugn" ;
  schal_nn_1 = mkN "schal" ;
  schalett_nn_1 = mkN "schalett" "schaletter" ;
  schalom_nn_1 = mkN "schalom" neutrum ;
  schalottenloek_nn_1 = mkN "schalottenlцk" ;
  schaman_nn_1 = mkN "schaman" "schamaner" ;
  schampo_nn_1 = mkN "schampo" "schampot" "schampon" "schampona" ;
  schangdobel_av_1 = mkA "schangdobel" ;
  schangtil_av_1 = mkA "schangtil" ;
  schapp_nn_1 = mkN "schapp" neutrum ;
  scharner_nn_1 = mkN "scharner" "scharneret" "scharner" "scharneren" ;
  schartauan_nn_1 = mkN "schartauan" "schartauaner" ;
  schartauansk_av_1 = mkA "schartauansk" ;
  schattering_nn_1 = mkN "schattering" ;
  schattersoem_nn_1 = mkN "schattersцm" "schattersцmmen" "schattersцmmar" "schattersцmmarna" ;
  schatull_nn_1 = mkN "schatull" neutrum ;
  schavott_nn_1 = mkN "schavott" "schavotter" ;
  schejk_nn_1 = mkN "schejk" "schejker" ;
  schema_nn_1 = mkN "schema" "schemat" "scheman" "schemana" ;
  schemabunden_av_1 = mkA "schemabunden" "schemabundet" ;
  schemalagd_av_1 = mkA "schemalagd" "schemalagt" ;
  schematisk_av_1 = mkA "schematisk" ;
  schematism_nn_1 = mkN "schematism" "schematismer" ;
  schersmin_nn_1 = mkN "schersmin" "schersminer" ;
  scherzando_ab_1 = mkAdv "scherzando" ;
  scherzo_nn_1 = mkN "scherzo" "scherzot" "scherzon" "scherzona" ;
  schibbolet_nn_1 = mkN "schibbolet" neutrum ;
  schillerkrage_nn_1 = mkN "schillerkrage" utrum ;
  schillerstoevare_nn_1 = mkN "schillerstцvare" "schillerstцvare" ;
  schilling_nn_1 = mkN "schilling" ;
  schimpans_nn_1 = mkN "schimpans" "schimpanser" ;
  schism_nn_1 = mkN "schism" "schismer" ;
  schismatiker_nn_1 = mkN "schismatiker" "schismatikern" "schismatiker" "schismatikerna" ;
  schismatisk_av_1 = mkA "schismatisk" ;
  schizofren_av_1 = mkA "schizofren" ;
  schizofreni_nn_1 = mkN "schizofreni" "schizofrenier" ;
  schizotym_av_1 = mkA "schizotym" ;
  schizzig_av_1 = mkA "schizzig" ;
  schlager_nn_1 = mkN "schlager" ;
  schnauzer_nn_1 = mkN "schnauzer" ;
  schnitzel_nn_1 = mkN "schnitzel" ;
  schottis_nn_1 = mkN "schottis" ;
  schrammelkvartett_nn_1 = mkN "schrammelkvartett" "schrammelkvartetter" ;
  schvungfull_av_1 = mkA "schvungfull" ;
  schvungig_av_1 = mkA "schvungig" ;
  schwa_ljud_nn_1 = mkN "schwa-ljud" neutrum ;
  schweizare_nn_1 = mkN "schweizare" "schweizare" ;
  schweizerfranc_nn_1 = mkN "schweizerfranc" "schweizerfrancen" "schweizerfranc" "schweizerfrancen" ;
  schweizeri_nn_1 = mkN "schweizeri" "schweizerit" "schweizerier" "schweizerierna" ;
  schweizernoet_nn_1 = mkN "schweizernцt" "schweizernцtter" ;
  schweizerost_nn_1 = mkN "schweizerost" ;
  schweizisk_av_1 = mkA "schweizisk" ;
  schysst_av_1 = mkA "schysst" "schysst" ;
  schyst_av_1 = mkA "schyst" "schyst" ;
  scientist_nn_1 = mkN "scientist" "scientister" ;
  scientolog_nn_1 = mkN "scientolog" "scientologer" ;
  scintillation_nn_1 = mkN "scintillation" "scintillationer" ;
  scirocco_nn_1 = mkN "scirocco" "sciroccon" "sciroccos" "sciroccosen" ;
  scone_nn_1 = mkN "scone" "sconen" "scones" "sconesen" ;
  scoop_nn_1 = mkN "scoop" neutrum ;
  scooter_nn_1 = mkN "scooter" ;
  scopolamin_nn_1 = mkN "scopolamin" "scopolaminer" ;
  scout_nn_1 = mkN "scout" "scouter" ;
  scoutjamboree_nn_1 = mkN "scoutjamboree" "scoutjamboreer" ;
  scoutlaeger_nn_1 = mkN "scoutlдger" neutrum ;
  scoutlag_nn_1 = mkN "scoutlag" ;
  scoutpatrull_nn_1 = mkN "scoutpatrull" "scoutpatruller" ;
  scratchman_nn_1 = mkN "scratchman" "scratchmannen" "scratchmдn" "scratchmдnnen" ;
  script_girl_nn_1 = mkN "script-girl" "script-girlen" "script-girls" "script-girlsen" ;
  seans_nn_1 = mkN "seans" "seanser" ;
  sebar_av_1 = mkA "sebar" ;
  seborre_nn_1 = mkN "seborrй" "seborrйer" ;
  sebu_nn_1 = mkN "sebu" "sebun" "sebuer" "sebuerna" ;
  seccomaalning_nn_1 = mkN "seccomеlning" ;
  sed_nn_1 = mkN "sed" "seder" ;
  sedan_ab_1 = mkAdv "sedan" ;
  sedan_nn_1 = mkN "sedan" "sedaner" ;
  sedativ_av_1 = mkA "sedativ" ;
  sedativ_nn_1 = mkN "sedativ" "sedativet" "sedativer" "sedativerna" ;
  sedativum_nn_1 = mkN "sedativum" neutrum ;
  sedebetyg_nn_1 = mkN "sedebetyg" neutrum ;
  sedekomedi_nn_1 = mkN "sedekomedi" "sedekomedier" ;
  sedel_nn_1 = mkN "sedel" ;
  sedelaerande_av_1 = mkA "sedelдrande" ;
  sedelautomat_nn_1 = mkN "sedelautomat" "sedelautomater" ;
  sedelpress_nn_1 = mkN "sedelpress" ;
  sedelreserv_nn_1 = mkN "sedelreserv" "sedelreserver" ;
  sedelstock_nn_1 = mkN "sedelstock" ;
  sedermera_ab_1 = mkAdv "sedermera" ;
  sederoman_nn_1 = mkN "sederoman" "sederomaner" ;
  sedes_nn_1 = mkN "sedes" "sedeser" ;
  sedesam_av_1 = mkA "sedesam" "sedesamt" "sedesamma" "sedesamma" "sedesammare" "sedesammast" "sedesammaste" ;
  sedeskildring_nn_1 = mkN "sedeskildring" ;
  sedesloes_av_1 = mkA "sedeslцs" ;
  sedig_av_1 = mkA "sedig" ;
  sediment_nn_1 = mkN "sediment" neutrum ;
  sedimentaer_av_1 = mkA "sedimentдr" ;
  sedimentering_nn_1 = mkN "sedimentering" ;
  sedimentfoerande_av_1 = mkA "sedimentfцrande" ;
  sedimentlager_nn_1 = mkN "sedimentlager" neutrum ;
  sedimentprov_nn_1 = mkN "sedimentprov" neutrum ;
  sedlig_av_1 = mkA "sedlig" ;
  sedlighet_nn_1 = mkN "sedlighet" "sedligheter" ;
  sedlighetsbrott_nn_1 = mkN "sedlighetsbrott" neutrum ;
  sedlighetssaarande_av_1 = mkA "sedlighetssеrande" ;
  sedvaenja_nn_1 = mkN "sedvдnja" ;
  sedvana_nn_1 = mkN "sedvana" ;
  sedvanlig_av_1 = mkA "sedvanlig" ;
  seende_av_1 = mkA "seende" ;
  sefard_nn_1 = mkN "sefard" "sefarder" ;
  sefyr_nn_1 = mkN "sefyr" "sefyrer" ;
  seg_av_1 = mkA "seg" ;
  segdra_vb_1 = mkV "segdra" "segdrar" "segdra" "segdrog" "segdragit" "segdragen" ;
  segdragen_av_1 = mkA "segdragen" "segdraget" ;
  segel_nn_1 = mkN "segel" neutrum ;
  segelbaat_nn_1 = mkN "segelbеt" ;
  segelbaergning_nn_1 = mkN "segelbдrgning" ;
  segelbar_av_1 = mkA "segelbar" ;
  segelduk_nn_1 = mkN "segelduk" ;
  segelfartyg_nn_1 = mkN "segelfartyg" neutrum ;
  segelflyg_nn_1 = mkN "segelflyg" neutrum ;
  segelflygning_nn_1 = mkN "segelflygning" ;
  segelflygplan_nn_1 = mkN "segelflygplan" neutrum ;
  segelfoering_nn_1 = mkN "segelfцring" ;
  segelfri_av_1 = mkA "segelfri" "segelfritt" ;
  segeljakt_nn_1 = mkN "segeljakt" "segeljakter" ;
  segeljolle_nn_1 = mkN "segeljolle" utrum ;
  segelkanot_nn_1 = mkN "segelkanot" "segelkanoter" ;
  segelkapell_nn_1 = mkN "segelkapell" neutrum ;
  segelled_nn_1 = mkN "segelled" "segelleder" ;
  segelmaerke_nn_1 = mkN "segelmдrke" ;
  segelmakare_nn_1 = mkN "segelmakare" "segelmakare" ;
  segelmakeri_nn_1 = mkN "segelmakeri" "segelmakerit" "segelmakerier" "segelmakerierna" ;
  segelskridsko_nn_1 = mkN "segelskridsko" "segelskridskor" ;
  segelsoemmare_nn_1 = mkN "segelsцmmare" "segelsцmmare" ;
  segelstaell_nn_1 = mkN "segelstдll" neutrum ;
  seger_nn_1 = mkN "seger" ;
  segerherre_nn_1 = mkN "segerherre" utrum ;
  segerkrans_nn_1 = mkN "segerkrans" ;
  segerkroent_av_1 = mkA "segerkrцnt" "segerkrцnt" ;
  segerpalm_nn_1 = mkN "segerpalm" "segerpalmer" ;
  segerpalmen_ab_1 = mkAdv "segerpalmen" ;
  segerrik_av_1 = mkA "segerrik" ;
  segersaell_av_1 = mkA "segersдll" ;
  segertaag_nn_1 = mkN "segertеg" neutrum ;
  segerviss_av_1 = mkA "segerviss" ;
  seghet_nn_1 = mkN "seghet" "segheter" ;
  seglare_nn_1 = mkN "seglare" "seglare" ;
  seglarstoevel_nn_1 = mkN "seglarstцvel" ;
  seglation_nn_1 = mkN "seglation" "seglationer" ;
  seglationsklar_av_1 = mkA "seglationsklar" ;
  seglats_nn_1 = mkN "seglats" "seglatser" ;
  segling_nn_1 = mkN "segling" ;
  seglingsbeskrivning_nn_1 = mkN "seglingsbeskrivning" ;
  seglingsfri_av_1 = mkA "seglingsfri" "seglingsfritt" ;
  segment_nn_1 = mkN "segment" neutrum ;
  segmentbaage_nn_1 = mkN "segmentbеge" utrum ;
  segmentell_av_1 = mkA "segmentell" ;
  segmogen_av_1 = mkA "segmogen" "segmoget" ;
  segrare_nn_1 = mkN "segrare" "segrare" ;
  segregat_nn_1 = mkN "segregat" neutrum ;
  segregation_nn_1 = mkN "segregation" "segregationer" ;
  segring_nn_1 = mkN "segring" ;
  segsliten_av_1 = mkA "segsliten" "segslitet" ;
  seigneur_nn_1 = mkN "seigneur" "seigneurer" ;
  seismisk_av_1 = mkA "seismisk" ;
  seismograf_nn_1 = mkN "seismograf" "seismografer" ;
  seismogram_nn_1 = mkN "seismogram" "seismogrammet" "seismogram" "seismogrammen" ;
  seismometer_nn_1 = mkN "seismometer" ;
  sej_nn_1 = mkN "sej" ;
  sejdare_nn_1 = mkN "sejdare" "sejdare" ;
  sejdel_nn_1 = mkN "sejdel" ;
  sejnfall_nn_1 = mkN "sejnfall" neutrum ;
  sejour_nn_1 = mkN "sejour" "sejourer" ;
  sejsing_nn_1 = mkN "sejsing" ;
  sejsning_nn_1 = mkN "sejsning" ;
  sejte_nn_1 = mkN "sejte" utrum ;
  sekant_nn_1 = mkN "sekant" "sekanter" ;
  sekatoer_nn_1 = mkN "sekatцr" "sekatцrer" ;
  sekel_nn_1 = mkN "sekel" neutrum ;
  sekellaang_av_1 = mkA "sekellеng" ;
  sekin_nn_1 = mkN "sekin" "sekiner" ;
  sekond_nn_1 = mkN "sekond" "sekonder" ;
  sekret_av_1 = mkA "sekret" "sekret" ;
  sekret_nn_1 = mkN "sekret" neutrum ;
  sekretaer_nn_1 = mkN "sekretдr" "sekretдrer" ;
  sekretariat_nn_1 = mkN "sekretariat" neutrum ;
  sekreterare_nn_1 = mkN "sekreterare" "sekreterare" ;
  sekreterarfaagel_nn_1 = mkN "sekreterarfеgel" ;
  sekretion_nn_1 = mkN "sekretion" "sekretioner" ;
  sekretionsrubbning_nn_1 = mkN "sekretionsrubbning" ;
  sekretorisk_av_1 = mkA "sekretorisk" ;
  sekt_nn_1 = mkN "sekt" "sekter" ;
  sekteristisk_av_1 = mkA "sekteristisk" ;
  sektion_nn_1 = mkN "sektion" "sektioner" ;
  sektor_nn_1 = mkN "sektor" "sektorer" ;
  sektorfyr_nn_1 = mkN "sektorfyr" ;
  sektoriell_av_1 = mkA "sektoriell" ;
  sektorport_nn_1 = mkN "sektorport" ;
  sekulaer_av_1 = mkA "sekulдr" ;
  sekularisation_nn_1 = mkN "sekularisation" "sekularisationer" ;
  sekularisering_nn_1 = mkN "sekularisering" ;
  sekularpraest_nn_1 = mkN "sekularprдst" "sekularprдster" ;
  sekund_nn_1 = mkN "sekund" "sekunder" ;
  sekunda_av_1 = mkA "sekunda" ;
  sekundaer_av_1 = mkA "sekundдr" ;
  sekundaergrupp_nn_1 = mkN "sekundдrgrupp" "sekundдrgrupper" ;
  sekundaerinfektion_nn_1 = mkN "sekundдrinfektion" "sekundдrinfektioner" ;
  sekundaerkommun_nn_1 = mkN "sekundдrkommun" "sekundдrkommuner" ;
  sekundaerminne_nn_1 = mkN "sekundдrminne" ;
  sekundaerspole_nn_1 = mkN "sekundдrspole" utrum ;
  sekundaerstadium_nn_1 = mkN "sekundдrstadium" "sekundдrstadiet" "sekundдrstadier" "sekundдrstadierna" ;
  sekundaerstroem_nn_1 = mkN "sekundдrstrцm" "sekundдrstrцmmen" "sekundдrstrцmmar" "sekundдrstrцmmarna" ;
  sekundant_nn_1 = mkN "sekundant" "sekundanter" ;
  sekundchef_nn_1 = mkN "sekundchef" "sekundchefer" ;
  sekundmeter_nn_1 = mkN "sekundmeter" "sekundmetern" "sekundmeter" "sekundmeterna" ;
  sekundvisare_nn_1 = mkN "sekundvisare" "sekundvisare" ;
  sekvens_nn_1 = mkN "sekvens" "sekvenser" ;
  sel_nn_1 = mkN "sel" neutrum ;
  selbrott_nn_1 = mkN "selbrott" neutrum ;
  selbruten_av_1 = mkA "selbruten" "selbrutet" ;
  seldon_nn_1 = mkN "seldon" neutrum ;
  sele_nn_1 = mkN "sele" utrum ;
  selektion_nn_1 = mkN "selektion" "selektioner" ;
  selektiv_av_1 = mkA "selektiv" ;
  selektivitet_nn_1 = mkN "selektivitet" "selektiviteter" ;
  selencell_nn_1 = mkN "selencell" "selenceller" ;
  selfmade_av_1 = mkA "selfmade" ;
  selleribotten_nn_1 = mkN "selleribotten" ;
  selot_nn_1 = mkN "selot" "seloter" ;
  seltersglas_nn_1 = mkN "seltersglas" neutrum ;
  seltyg_nn_1 = mkN "seltyg" neutrum ;
  semafor_nn_1 = mkN "semafor" "semaforen" "semaforer" "semaforerna" ;
  semaforalfabet_nn_1 = mkN "semaforalfabet" neutrum ;
  semantisk_av_1 = mkA "semantisk" ;
  semem_nn_1 = mkN "semem" neutrum ;
  semester_nn_1 = mkN "semester" ;
  semesterarvode_nn_1 = mkN "semesterarvode" ;
  semesterby_nn_1 = mkN "semesterby" "semesterbyn" "semesterbyar" "semesterbyarna" ;
  semesterdag_nn_1 = mkN "semesterdag" ;
  semesterersaettning_nn_1 = mkN "semesterersдttning" ;
  semesterfirare_nn_1 = mkN "semesterfirare" "semesterfirare" ;
  semesterloen_nn_1 = mkN "semesterlцn" "semesterlцner" ;
  semestermaanad_nn_1 = mkN "semestermеnad" "semestermеnader" ;
  semesterpeng_nn_1 = mkN "semesterpeng" ;
  semestertillaegg_nn_1 = mkN "semestertillдgg" neutrum ;
  semifinal_nn_1 = mkN "semifinal" "semifinaler" ;
  semikolon_nn_1 = mkN "semikolon" neutrum ;
  seminarist_nn_1 = mkN "seminarist" "seminarister" ;
  seminarium_nn_1 = mkN "seminarium" "seminariumet" "seminarier" "seminarierna" ;
  seminoer_nn_1 = mkN "seminцr" "seminцrer" ;
  seminstation_nn_1 = mkN "seminstation" "seminstationer" ;
  semiotisk_av_1 = mkA "semiotisk" ;
  semipermeabel_av_1 = mkA "semipermeabel" "semipermeabelt" "semipermeabla" "semipermeabla" "semipermeablare" "semipermeablast" "semipermeablaste" ;
  semit_nn_1 = mkN "semit" "semiter" ;
  semitisk_av_1 = mkA "semitisk" ;
  semitist_nn_1 = mkN "semitist" "semitister" ;
  semitrailer_nn_1 = mkN "semitrailer" ;
  semla_nn_1 = mkN "semla" ;
  semologisk_av_1 = mkA "semologisk" ;
  sen_ab_1 = mkAdv "sen" ;
  sen_av_1 = mkA "sen" ;
  senantik_av_1 = mkA "senantik" ;
  senapsdeg_nn_1 = mkN "senapsdeg" ;
  senar_nn_1 = mkN "senar" "senarer" ;
  senat_nn_1 = mkN "senat" "senater" ;
  senator_nn_1 = mkN "senator" "senatorer" ;
  senegales_nn_1 = mkN "senegales" "senegaleser" ;
  senegalesisk_av_1 = mkA "senegalesisk" ;
  senfaerdig_av_1 = mkA "senfдrdig" ;
  senfoedd_av_1 = mkA "senfцdd" ;
  sengaangaraktig_av_1 = mkA "sengеngaraktig" ;
  sengaangare_nn_1 = mkN "sengеngare" "sengеngare" ;
  senhinna_nn_1 = mkN "senhinna" ;
  senhoest_nn_1 = mkN "senhцst" ;
  senig_av_1 = mkA "senig" ;
  senil_av_1 = mkA "senil" ;
  senilitet_nn_1 = mkN "senilitet" "seniliteter" ;
  senior_av_1 = mkA "senior" ;
  senior_nn_1 = mkN "senior" "senioren" "seniorer" "seniorerna" ;
  senknut_nn_1 = mkN "senknut" ;
  senkommen_av_1 = mkA "senkommen" "senkommet" "senkomna" "senkomna" "senkomnare" "senkomnast" "senkomnaste" ;
  senor_nn_1 = mkN "seсor" "seсoren" "seсorer" "seсorerna" ;
  senorgan_nn_1 = mkN "senorgan" neutrum ;
  sensation_nn_1 = mkN "sensation" "sensationer" ;
  sensationell_av_1 = mkA "sensationell" ;
  sensibel_av_1 = mkA "sensibel" "sensibelt" "sensibla" "sensibla" "sensiblare" "sensiblast" "sensiblaste" ;
  sensibilitet_nn_1 = mkN "sensibilitet" "sensibiliteter" ;
  sensigrupp_nn_1 = mkN "sensigrupp" "sensigrupper" ;
  sensitiv_av_1 = mkA "sensitiv" ;
  sensitivitet_nn_1 = mkN "sensitivitet" "sensitiviteter" ;
  sensmoral_nn_1 = mkN "sensmoral" "sensmoraler" ;
  sensommar_nn_1 = mkN "sensommar" "sensommarn" "sensommrar" "sensommrarna" ;
  sensomotorisk_av_1 = mkA "sensomotorisk" ;
  sensor_nn_1 = mkN "sensor" "sensorer" ;
  sensorisk_av_1 = mkA "sensorisk" ;
  sensualitet_nn_1 = mkN "sensualitet" "sensualiteter" ;
  sensuell_av_1 = mkA "sensuell" ;
  sentens_nn_1 = mkN "sentens" "sentenser" ;
  sententioes_av_1 = mkA "sententiцs" ;
  sentida_av_1 = mkA "sentida" ;
  sentima_av_1 = mkA "sentima" ;
  sentiment_nn_1 = mkN "sentiment" neutrum ;
  sentimental_av_1 = mkA "sentimental" ;
  sentimentalitet_nn_1 = mkN "sentimentalitet" "sentimentaliteter" ;
  senvaar_nn_1 = mkN "senvеr" ;
  senvinter_nn_1 = mkN "senvinter" ;
  separabel_av_1 = mkA "separabel" "separabelt" "separabla" "separabla" "separablare" "separablast" "separablaste" ;
  separat_av_1 = mkA "separat" "separat" ;
  separat_nn_1 = mkN "separat" neutrum ;
  separatfred_nn_1 = mkN "separatfred" "separatfreder" ;
  separatim_ab_1 = mkAdv "separatim" ;
  separation_nn_1 = mkN "separation" "separationer" ;
  separatist_nn_1 = mkN "separatist" "separatister" ;
  separatistisk_av_1 = mkA "separatistisk" ;
  separatistroerelse_nn_1 = mkN "separatistrцrelse" "separatistrцrelser" ;
  separator_nn_1 = mkN "separator" "separatorer" ;
  separatutstaellning_nn_1 = mkN "separatutstдllning" ;
  separering_nn_1 = mkN "separering" ;
  sepoy_nn_1 = mkN "sepoy" "sepoyen" "sepoys" "sepoysen" ;
  septennium_nn_1 = mkN "septennium" "septenniet" "septennier" "septennierna" ;
  septett_nn_1 = mkN "septett" "septetter" ;
  septiktank_nn_1 = mkN "septiktank" ;
  septisk_av_1 = mkA "septisk" ;
  seraf_nn_1 = mkN "seraf" "serafer" ;
  serafimerband_nn_1 = mkN "serafimerband" neutrum ;
  serafisk_av_1 = mkA "serafisk" ;
  seralj_nn_1 = mkN "seralj" "seraljer" ;
  serb_nn_1 = mkN "serb" "serber" ;
  serbisk_av_1 = mkA "serbisk" ;
  serbokroatisk_av_1 = mkA "serbokroatisk" ;
  seren_av_1 = mkA "seren" ;
  serenad_nn_1 = mkN "serenad" "serenader" ;
  serenitet_nn_1 = mkN "serenitet" "sereniteter" ;
  sergeant_nn_1 = mkN "sergeant" "sergeanter" ;
  serie_nn_1 = mkN "serie" "serier" ;
  seriefigur_nn_1 = mkN "seriefigur" "seriefigurer" ;
  seriekoppling_nn_1 = mkN "seriekoppling" ;
  seriekrock_nn_1 = mkN "seriekrock" ;
  seriell_av_1 = mkA "seriell" ;
  seriemagasin_nn_1 = mkN "seriemagasin" neutrum ;
  seriematch_nn_1 = mkN "seriematch" "seriematcher" ;
  seriespel_nn_1 = mkN "seriespel" "seriespelet" "seriespel" "seriespelen" ;
  serietecknare_nn_1 = mkN "serietecknare" "serietecknare" ;
  serietidning_nn_1 = mkN "serietidning" ;
  serietillverkning_nn_1 = mkN "serietillverkning" ;
  seriff_nn_1 = mkN "seriff" "seriffer" ;
  serigrafi_nn_1 = mkN "serigrafi" "serigrafier" ;
  serioes_av_1 = mkA "seriцs" ;
  seriositet_nn_1 = mkN "seriositet" "seriositeter" ;
  seroes_av_1 = mkA "serцs" ;
  serotonin_nn_1 = mkN "serotonin" "serotoniner" ;
  serotoninhoejande_av_1 = mkA "serotoninhцjande" ;
  serpent_nn_1 = mkN "serpent" "serpenter" ;
  serpentin_nn_1 = mkN "serpentin" "serpentiner" ;
  serum_nn_1 = mkN "serum" neutrum ;
  serval_nn_1 = mkN "serval" "servaler" ;
  servboll_nn_1 = mkN "servboll" ;
  serve_nn_1 = mkN "serve" utrum ;
  serveboll_nn_1 = mkN "serveboll" ;
  serveess_nn_1 = mkN "serveess" neutrum ;
  servegame_nn_1 = mkN "servegame" "servegamet" "servegame" "servegamen" ;
  servelinje_nn_1 = mkN "servelinje" "servelinjer" ;
  servering_nn_1 = mkN "servering" ;
  serveringsavgift_nn_1 = mkN "serveringsavgift" "serveringsavgifter" ;
  serveringsbord_nn_1 = mkN "serveringsbord" neutrum ;
  serveringsfat_nn_1 = mkN "serveringsfat" neutrum ;
  serveringsgaang_nn_1 = mkN "serveringsgеng" ;
  serveringskork_nn_1 = mkN "serveringskork" ;
  serveringsrum_nn_1 = mkN "serveringsrum" "serveringsrummet" "serveringsrum" "serveringsrummen" ;
  serveringsvagn_nn_1 = mkN "serveringsvagn" ;
  servett_nn_1 = mkN "servett" "servetter" ;
  servettring_nn_1 = mkN "servettring" ;
  serveuppkast_nn_1 = mkN "serveuppkast" neutrum ;
  servgame_nn_1 = mkN "servgame" "servgamet" "servgame" "servgamen" ;
  servicebil_nn_1 = mkN "servicebil" ;
  servicebostad_nn_1 = mkN "servicebostad" "servicebostдder" ;
  servicebox_nn_1 = mkN "servicebox" ;
  servicebutik_nn_1 = mkN "servicebutik" "servicebutiker" ;
  servicehus_nn_1 = mkN "servicehus" neutrum ;
  servicelaegenhet_nn_1 = mkN "servicelдgenhet" "servicelдgenheter" ;
  serviceman_nn_1 = mkN "serviceman" "servicemannen" "servicemдn" "servicemдnnen" ;
  servicenaering_nn_1 = mkN "servicenдring" ;
  servicepersonal_nn_1 = mkN "servicepersonal" "servicepersonaler" ;
  servicestation_nn_1 = mkN "servicestation" "servicestationer" ;
  serviceyrke_nn_1 = mkN "serviceyrke" ;
  servil_av_1 = mkA "servil" ;
  servilism_nn_1 = mkN "servilism" "servilismer" ;
  servilitet_nn_1 = mkN "servilitet" "serviliteter" ;
  servis_nn_1 = mkN "servis" "serviser" ;
  servisledning_nn_1 = mkN "servisledning" ;
  servitoer_nn_1 = mkN "servitцr" "servitцrer" ;
  servitris_nn_1 = mkN "servitris" "servitriser" ;
  servitut_nn_1 = mkN "servitut" neutrum ;
  servlinje_nn_1 = mkN "servlinje" "servlinjer" ;
  servobroms_nn_1 = mkN "servobroms" ;
  servomotor_nn_1 = mkN "servomotor" "servomotorer" ;
  sesamfroe_nn_1 = mkN "sesamfrц" "sesamfrцt" "sesamfrцn" "sesamfrцen" ;
  session_nn_1 = mkN "session" "sessioner" ;
  set_nn_1 = mkN "set" neutrum ;
  setboll_nn_1 = mkN "setboll" ;
  setter_nn_1 = mkN "setter" ;
  settlement_nn_1 = mkN "settlement" "settlementet" "settlementen" "settlementena" ;
  sevaerd_av_1 = mkA "sevдrd" "sevдrt" ;
  sevaerdhet_nn_1 = mkN "sevдrdhet" "sevдrdheter" ;
  sexaarig_av_1 = mkA "sexеrig" ;
  sexbomb_nn_1 = mkN "sexbomb" "sexbomber" ;
  sexfoting_nn_1 = mkN "sexfoting" ;
  sexig_av_1 = mkA "sexig" ;
  sexkantig_av_1 = mkA "sexkantig" ;
  sexling_nn_1 = mkN "sexling" ;
  sexmaestare_nn_1 = mkN "sexmдstare" "sexmдstare" ;
  sexmord_nn_1 = mkN "sexmord" neutrum ;
  sexpack_nn_1 = mkN "sexpack" ;
  sexpipig_av_1 = mkA "sexpipig" ;
  sexradig_av_1 = mkA "sexradig" ;
  sexsiffrig_av_1 = mkA "sexsiffrig" ;
  sexspann_nn_1 = mkN "sexspann" neutrum ;
  sext_nn_1 = mkN "sext" "sexter" ;
  sextant_nn_1 = mkN "sextant" "sextanter" ;
  sextett_nn_1 = mkN "sextett" "sextetter" ;
  sextiondel_nn_1 = mkN "sextiondel" "sextiondelen" "sextiondelar" "sextiondelarna" ;
  sextol_nn_1 = mkN "sextol" "sextoler" ;
  sexualakt_nn_1 = mkN "sexualakt" "sexualakter" ;
  sexualbrott_nn_1 = mkN "sexualbrott" neutrum ;
  sexualcykel_nn_1 = mkN "sexualcykel" ;
  sexualdrift_nn_1 = mkN "sexualdrift" "sexualdrifter" ;
  sexualia_nn_1 = mkN "sexualia" "sexualian" "sexualia" "sexualiana" ;
  sexualitet_nn_1 = mkN "sexualitet" "sexualiteter" ;
  sexualmord_nn_1 = mkN "sexualmord" neutrum ;
  sexualorgan_nn_1 = mkN "sexualorgan" neutrum ;
  sexuell_av_1 = mkA "sexuell" ;
  seychellier_nn_1 = mkN "seychellier" "seychelliern" "seychellier" "seychellierna" ;
  seychellisk_av_1 = mkA "seychellisk" ;
  sfaer_nn_1 = mkN "sfдr" "sfдrer" ;
  sfaerisk_av_1 = mkA "sfдrisk" ;
  sfaeroid_nn_1 = mkN "sfдroid" "sfдroider" ;
  sfaerometer_nn_1 = mkN "sfдrometer" ;
  sfinx_nn_1 = mkN "sfinx" "sfinxer" ;
  sforzando_ab_1 = mkAdv "sforzando" ;
  shah_nn_1 = mkN "shah" "shaher" ;
  shaker_nn_1 = mkN "shaker" ;
  shaman_nn_1 = mkN "shaman" "shamaner" ;
  shamanism_nn_1 = mkN "shamanism" "shamanismer" ;
  shampoo_nn_1 = mkN "shampoo" "shampoot" "shampoon" "shampoona" ;
  shanty_nn_1 = mkN "shanty" "shantyn" "shanties" "shanties" ;
  shejk_nn_1 = mkN "shejk" "shejker" ;
  shellack_nn_1 = mkN "shellack" neutrum ;
  shelterdaeck_nn_1 = mkN "shelterdдck" neutrum ;
  sheriff_nn_1 = mkN "sheriff" "sheriffer" ;
  sherpa_nn_1 = mkN "sherpa" ;
  shetlaendsk_av_1 = mkA "shetlдndsk" ;
  shetlandsponny_nn_1 = mkN "shetlandsponny" "shetlandsponnyn" "shetlandsponnies" "shetlandsponnyerna" ;
  shiit_nn_1 = mkN "shiit" "shiiter" ;
  shilling_nn_1 = mkN "shilling" "shillingen" "shilling" "shillingen" ;
  shogun_nn_1 = mkN "shogun" "shogun" "shoguner" "shogunerna" ;
  shop_nn_1 = mkN "shop" ;
  shoppingcentrum_nn_1 = mkN "shoppingcentrum" neutrum ;
  shoppingvagn_nn_1 = mkN "shoppingvagn" ;
  show_nn_1 = mkN "show" "shower" ;
  shuffle_board_nn_1 = mkN "shuffle-board" neutrum ;
  shunt_nn_1 = mkN "shunt" ;
  shuntkoppling_nn_1 = mkN "shuntkoppling" ;
  shuntventil_nn_1 = mkN "shuntventil" "shuntventiler" ;
  si_ab_1 = mkAdv "si" ;
  siames_nn_1 = mkN "siames" "siameser" ;
  siamesisk_av_1 = mkA "siamesisk" ;
  siameskatt_nn_1 = mkN "siameskatt" "siameskatter" ;
  siare_nn_1 = mkN "siare" "siare" ;
  sibet_nn_1 = mkN "sibet" "sibeter" ;
  sibetdjur_nn_1 = mkN "sibetdjur" neutrum ;
  sibetkatt_nn_1 = mkN "sibetkatt" "sibetkatter" ;
  sibirier_nn_1 = mkN "sibirier" "sibiriern" "sibirier" "sibirierna" ;
  sibirisk_av_1 = mkA "sibirisk" ;
  sibyllinsk_av_1 = mkA "sibyllinsk" ;
  sic_ab_1 = mkAdv "sic" ;
  sicilian_nn_1 = mkN "sicilian" "sicilianer" ;
  sicilianare_nn_1 = mkN "sicilianare" "sicilianare" ;
  siciliansk_av_1 = mkA "siciliansk" ;
  sicilianska_nn_1 = mkN "sicilianska" ;
  sick_nn_1 = mkN "sick" ;
  sickativ_nn_1 = mkN "sickativ" neutrum ;
  sickel_nn_1 = mkN "sickel" ;
  sicken_av_1 = mkA "sicken" "sicket" ;
  sickling_nn_1 = mkN "sickling" ;
  sid_av_1 = mkA "sid" ;
  sida_nn_1 = mkN "sida" ;
  sidbyte_nn_1 = mkN "sidbyte" ;
  sideboard_nn_1 = mkN "sideboard" neutrum ;
  sidendraperi_nn_1 = mkN "sidendraperi" "sidendraperit" "sidendraperier" "sidendraperierna" ;
  sidenskaerm_nn_1 = mkN "sidenskдrm" ;
  sidensvans_nn_1 = mkN "sidensvans" ;
  sidentyg_nn_1 = mkN "sidentyg" neutrum ;
  siderisk_av_1 = mkA "siderisk" ;
  sidlaend_av_1 = mkA "sidlдnd" ;
  sidlaenges_ab_1 = mkAdv "sidlдnges" ;
  sidlaent_av_1 = mkA "sidlдnt" "sidlдnt" ;
  sidledes_ab_1 = mkAdv "sidledes" ;
  sidlinje_nn_1 = mkN "sidlinje" "sidlinjer" ;
  sidnummer_nn_1 = mkN "sidnummer" neutrum ;
  sidnumrering_nn_1 = mkN "sidnumrering" ;
  sidoaltare_nn_1 = mkN "sidoaltare" "sidoaltaret" "sidoaltaren" "sidoaltarna" ;
  sidoapparat_nn_1 = mkN "sidoapparat" "sidoapparater" ;
  sidoarv_nn_1 = mkN "sidoarv" neutrum ;
  sidoarvinge_nn_1 = mkN "sidoarvinge" utrum ;
  sidobelysning_nn_1 = mkN "sidobelysning" ;
  sidoblick_nn_1 = mkN "sidoblick" ;
  sidobyggnad_nn_1 = mkN "sidobyggnad" "sidobyggnader" ;
  sidodaeck_nn_1 = mkN "sidodдck" neutrum ;
  sidodal_nn_1 = mkN "sidodal" ;
  sidoeffekt_nn_1 = mkN "sidoeffekt" "sidoeffekter" ;
  sidogevaer_nn_1 = mkN "sidogevдr" neutrum ;
  sidoingaang_nn_1 = mkN "sidoingеng" ;
  sidoinkomst_nn_1 = mkN "sidoinkomst" "sidoinkomster" ;
  sidolinje_nn_1 = mkN "sidolinje" "sidolinjer" ;
  sidolinjeorgan_nn_1 = mkN "sidolinjeorgan" neutrum ;
  sidoplan_nn_1 = mkN "sidoplan" neutrum ;
  sidoroder_nn_1 = mkN "sidoroder" neutrum ;
  sidoskepp_nn_1 = mkN "sidoskepp" neutrum ;
  sidoskott_nn_1 = mkN "sidoskott" neutrum ;
  sidospaar_nn_1 = mkN "sidospеr" neutrum ;
  sidospraang_nn_1 = mkN "sidosprеng" neutrum ;
  sidotema_nn_1 = mkN "sidotema" "sidotemat" "sidoteman" "sidotemana" ;
  sidovaeg_nn_1 = mkN "sidovдg" ;
  sidovapen_nn_1 = mkN "sidovapen" "sidovapnet" "sidovapen" "sidovapnen" ;
  sidovinkel_nn_1 = mkN "sidovinkel" ;
  sidroder_nn_1 = mkN "sidroder" neutrum ;
  sidskruv_nn_1 = mkN "sidskruv" ;
  sidvagn_nn_1 = mkN "sidvagn" ;
  sidvall_nn_1 = mkN "sidvall" ;
  sidvoerdnad_nn_1 = mkN "sidvцrdnad" "sidvцrdnader" ;
  siemens_nn_1 = mkN "siemens" "siemensen" "siemens" "siemensen" ;
  sierraleonier_nn_1 = mkN "sierraleonier" "sierraleoniern" "sierraleonier" "sierraleonierna" ;
  sierraleonsk_av_1 = mkA "sierraleonsk" ;
  sierska_nn_1 = mkN "sierska" ;
  sievert_nn_1 = mkN "sievert" "sieverten" "sievert" "sieverten" ;
  sifferbetyg_nn_1 = mkN "sifferbetyg" neutrum ;
  sifferkarl_nn_1 = mkN "sifferkarl" ;
  siffersumma_nn_1 = mkN "siffersumma" ;
  siffertavla_nn_1 = mkN "siffertavla" ;
  sifferuppgift_nn_1 = mkN "sifferuppgift" "sifferuppgifter" ;
  siffra_nn_1 = mkN "siffra" ;
  sifon_nn_1 = mkN "sifon" "sifoner" ;
  sigel_nn_1 = mkN "sigel" "sigeln" "sigler" "siglerna" ;
  sightseeing_nn_1 = mkN "sightseeing" ;
  sigill_nn_1 = mkN "sigill" neutrum ;
  sigillbevarare_nn_1 = mkN "sigillbevarare" "sigillbevarare" ;
  sigillring_nn_1 = mkN "sigillring" ;
  sigillstaempel_nn_1 = mkN "sigillstдmpel" ;
  sigillstamp_nn_1 = mkN "sigillstamp" ;
  signal_nn_1 = mkN "signal" "signaler" ;
  signalbloss_nn_1 = mkN "signalbloss" neutrum ;
  signalbok_nn_1 = mkN "signalbok" "signalbцcker" ;
  signalduk_nn_1 = mkN "signalduk" ;
  signaleld_nn_1 = mkN "signaleld" ;
  signalement_nn_1 = mkN "signalement" "signalementet" "signalementen" "signalementena" ;
  signalering_nn_1 = mkN "signalering" ;
  signalhastighet_nn_1 = mkN "signalhastighet" "signalhastigheter" ;
  signalhorn_nn_1 = mkN "signalhorn" neutrum ;
  signalist_nn_1 = mkN "signalist" "signalister" ;
  signalmoenster_nn_1 = mkN "signalmцnster" neutrum ;
  signalpistol_nn_1 = mkN "signalpistol" "signalpistoler" ;
  signalspade_nn_1 = mkN "signalspade" utrum ;
  signalstaell_nn_1 = mkN "signalstдll" neutrum ;
  signalsubstans_nn_1 = mkN "signalsubstans" "signalsubstanser" ;
  signaltrupp_nn_1 = mkN "signaltrupp" "signaltrupper" ;
  signalur_nn_1 = mkN "signalur" neutrum ;
  signataer_nn_1 = mkN "signatдr" "signatдrer" ;
  signataermakt_nn_1 = mkN "signatдrmakt" "signatдrmakter" ;
  signatur_nn_1 = mkN "signatur" "signaturer" ;
  signaturmelodi_nn_1 = mkN "signaturmelodi" "signaturmelodier" ;
  signelse_nn_1 = mkN "signelse" "signelser" ;
  signeri_nn_1 = mkN "signeri" "signerit" "signerier" "signerierna" ;
  signet_nn_1 = mkN "signet" neutrum ;
  signetring_nn_1 = mkN "signetring" ;
  signifikans_nn_1 = mkN "signifikans" "signifikanser" ;
  signifikant_av_1 = mkA "signifikant" "signifikant" ;
  signifikativ_av_1 = mkA "signifikativ" ;
  signor_nn_1 = mkN "signor" "signoren" "signorer" "signorerna" ;
  signum_nn_1 = mkN "signum" neutrum ;
  sik_nn_1 = mkN "sik" ;
  sikahjort_nn_1 = mkN "sikahjort" ;
  sikel_nn_1 = mkN "sikel" ;
  sikh_nn_1 = mkN "sikh" "sikher" ;
  sikt_nn_2 = mkN "sikt" ;
  siktbar_av_1 = mkA "siktbar" ;
  siktbroed_nn_1 = mkN "siktbrцd" neutrum ;
  siktduk_nn_1 = mkN "siktduk" ;
  siktig_av_1 = mkA "siktig" ;
  siktlinje_nn_1 = mkN "siktlinje" "siktlinjer" ;
  siktram_nn_1 = mkN "siktram" ;
  sil_nn_1 = mkN "sil" ;
  silben_nn_1 = mkN "silben" neutrum ;
  silduk_nn_1 = mkN "silduk" ;
  silen_nn_1 = mkN "silen" "silener" ;
  silhuett_nn_1 = mkN "silhuett" "silhuetter" ;
  silikat_nn_1 = mkN "silikat" neutrum ;
  silikon_nn_1 = mkN "silikon" neutrum ;
  silkegarn_nn_1 = mkN "silkegarn" neutrum ;
  silkepapper_nn_1 = mkN "silkepapper" neutrum ;
  silkesfjaeril_nn_1 = mkN "silkesfjдril" ;
  silkeshare_nn_1 = mkN "silkeshare" utrum ;
  silkeskanin_nn_1 = mkN "silkeskanin" "silkeskaniner" ;
  silkeslarv_nn_1 = mkN "silkeslarv" "silkeslarver" ;
  silkeslen_av_1 = mkA "silkeslen" ;
  silkesmask_nn_1 = mkN "silkesmask" ;
  silkespinnare_nn_1 = mkN "silkespinnare" "silkespinnare" ;
  silkesspinnare_nn_1 = mkN "silkesspinnare" "silkesspinnare" ;
  silkestraad_nn_1 = mkN "silkestrеd" ;
  silkig_av_1 = mkA "silkig" ;
  sill_nn_1 = mkN "sill" ;
  sillavfall_nn_1 = mkN "sillavfall" neutrum ;
  sillbit_nn_1 = mkN "sillbit" ;
  sillblixt_nn_1 = mkN "sillblixt" ;
  sillbulle_nn_1 = mkN "sillbulle" utrum ;
  sillfile_nn_1 = mkN "sillfilй" "sillfilйer" ;
  sillfrukost_nn_1 = mkN "sillfrukost" ;
  sillinlaeggning_nn_1 = mkN "sillinlдggning" ;
  sillkung_nn_1 = mkN "sillkung" ;
  sillmjoelke_nn_1 = mkN "sillmjцlke" utrum ;
  sillperiod_nn_1 = mkN "sillperiod" "sillperioder" ;
  sillpudding_nn_1 = mkN "sillpudding" ;
  sillsallad_nn_1 = mkN "sillsallad" "sillsallader" ;
  sillstrypare_nn_1 = mkN "sillstrypare" "sillstrypare" ;
  silltrut_nn_1 = mkN "silltrut" ;
  sillval_nn_1 = mkN "sillval" ;
  silo_nn_1 = mkN "silo" "silon" "silos" "silosen" ;
  siluett_nn_1 = mkN "siluett" "siluetter" ;
  silver_nn_1 = mkN "silver" neutrum ;
  silverbaegare_nn_1 = mkN "silverbдgare" "silverbдgare" ;
  silverbroellop_nn_1 = mkN "silverbrцllop" neutrum ;
  silverbrudpar_nn_1 = mkN "silverbrudpar" neutrum ;
  silverfasan_nn_1 = mkN "silverfasan" "silverfasaner" ;
  silverfisk_nn_1 = mkN "silverfisk" ;
  silverfoeremaal_nn_1 = mkN "silverfцremеl" neutrum ;
  silverglaensande_av_1 = mkA "silverglдnsande" ;
  silvergran_nn_1 = mkN "silvergran" ;
  silvergrogg_nn_1 = mkN "silvergrogg" ;
  silverhalt_nn_1 = mkN "silverhalt" "silverhalter" ;
  silverhaltig_av_1 = mkA "silverhaltig" ;
  silverklar_av_1 = mkA "silverklar" ;
  silverlejon_nn_1 = mkN "silverlejon" neutrum ;
  silverliknande_av_1 = mkA "silverliknande" ;
  silvermagister_nn_1 = mkN "silvermagister" ;
  silvermedalj_nn_1 = mkN "silvermedalj" "silvermedaljer" ;
  silvermynt_nn_1 = mkN "silvermynt" neutrum ;
  silverne_av_1 = mkA "silverne" ;
  silverpeng_nn_1 = mkN "silverpeng" ;
  silverpenning_nn_1 = mkN "silverpenning" ;
  silverpoppel_nn_1 = mkN "silverpoppel" ;
  silverraev_nn_1 = mkN "silverrдv" ;
  silversalt_nn_1 = mkN "silversalt" "silversaltet" "silversalter" "silversalterna" ;
  silversked_nn_1 = mkN "silversked" ;
  silversmed_nn_1 = mkN "silversmed" "silversmeder" ;
  silversmide_nn_1 = mkN "silversmide" ;
  silverstaempel_nn_1 = mkN "silverstдmpel" ;
  silvertraad_nn_1 = mkN "silvertrеd" ;
  silvrig_av_1 = mkA "silvrig" ;
  simand_nn_1 = mkN "simand" "simдnder" ;
  simbaelte_nn_1 = mkN "simbдlte" ;
  simbassaeng_nn_1 = mkN "simbassдng" "simbassдnger" ;
  simborgarmaerke_nn_1 = mkN "simborgarmдrke" ;
  simdraekt_nn_1 = mkN "simdrдkt" "simdrдkter" ;
  simfaagel_nn_1 = mkN "simfеgel" ;
  simfot_nn_1 = mkN "simfot" "simfцtter" ;
  simhall_nn_1 = mkN "simhall" ;
  simhopp_nn_1 = mkN "simhopp" neutrum ;
  simkandidat_nn_1 = mkN "simkandidat" "simkandidater" ;
  simkunnig_av_1 = mkA "simkunnig" ;
  simlaerare_nn_1 = mkN "simlдrare" "simlдrare" ;
  simma_vb_1 = mkV "simma" ;
  simmaerke_nn_1 = mkN "simmдrke" ;
  simmagister_nn_1 = mkN "simmagister" ;
  simmare_nn_1 = mkN "simmare" "simmare" ;
  simmig_av_1 = mkA "simmig" ;
  simning_nn_1 = mkN "simning" ;
  simorgan_nn_1 = mkN "simorgan" neutrum ;
  simpel_av_1 = mkA "simpel" "simpelt" "simpla" "simpla" "simplare" "simplast" "simplaste" ;
  simplex_nn_1 = mkN "simplex" neutrum ;
  simplexpaale_nn_1 = mkN "simplexpеle" utrum ;
  simpromotion_nn_1 = mkN "simpromotion" "simpromotioner" ;
  simprov_nn_1 = mkN "simprov" neutrum ;
  sims_nn_1 = mkN "sims" "simser" ;
  simsaett_nn_1 = mkN "simsдtt" neutrum ;
  simshyvel_nn_1 = mkN "simshyvel" ;
  simtaevling_nn_1 = mkN "simtдvling" ;
  simtag_nn_1 = mkN "simtag" neutrum ;
  simtraening_nn_1 = mkN "simtrдning" ;
  simtur_nn_1 = mkN "simtur" "simturer" ;
  simulant_nn_1 = mkN "simulant" "simulanter" ;
  simulation_nn_1 = mkN "simulation" "simulationer" ;
  simulator_nn_1 = mkN "simulator" "simulatorer" ;
  simultan_av_1 = mkA "simultan" ;
  simultanism_nn_1 = mkN "simultanism" "simultanismer" ;
  simultanscen_nn_1 = mkN "simultanscen" "simultanscener" ;
  sinder_nn_1 = mkN "sinder" neutrum ;
  sinekur_nn_1 = mkN "sinekur" "sinekurer" ;
  singales_nn_1 = mkN "singales" "singaleser" ;
  singalesisk_av_1 = mkA "singalesisk" ;
  singalesiska_nn_2 = mkN "singalesiska" ;
  singaporian_nn_1 = mkN "singaporian" "singaporianer" ;
  singel_nn_1 = mkN "singel" ;
  singelspel_nn_1 = mkN "singelspel" "singelspelet" "singelspel" "singelspelen" ;
  singular_av_1 = mkA "singular" ;
  singular_nn_1 = mkN "singular" "singularer" ;
  singularitet_nn_1 = mkN "singularitet" "singulariteter" ;
  singuljaer_av_1 = mkA "singuljдr" ;
  sinister_av_1 = mkA "sinister" "sinistert" "sinistra" "sinistra" "sinistrare" "sinistrast" "sinistraste" ;
  sinkadus_nn_1 = mkN "sinkadus" "sinkaduser" ;
  sinne_nn_1 = mkN "sinne" ;
  sinnebild_nn_1 = mkN "sinnebild" "sinnebilder" ;
  sinnesanalogi_nn_1 = mkN "sinnesanalogi" "sinnesanalogier" ;
  sinnescell_nn_1 = mkN "sinnescell" "sinnesceller" ;
  sinnesfoerfattning_nn_1 = mkN "sinnesfцrfattning" ;
  sinnesintryck_nn_1 = mkN "sinnesintryck" neutrum ;
  sinnesnerv_nn_1 = mkN "sinnesnerv" "sinnesnerver" ;
  sinnesorgan_nn_1 = mkN "sinnesorgan" neutrum ;
  sinnesroerelse_nn_1 = mkN "sinnesrцrelse" "sinnesrцrelser" ;
  sinnessjuk_av_1 = mkA "sinnessjuk" ;
  sinnessjukdom_nn_1 = mkN "sinnessjukdom" ;
  sinnessloe_av_1 = mkA "sinnesslц" "sinnesslцtt" ;
  sinnesstaemning_nn_1 = mkN "sinnesstдmning" ;
  sinnessvag_av_1 = mkA "sinnessvag" ;
  sinnesundersoekning_nn_1 = mkN "sinnesundersцkning" ;
  sinnesupplevelse_nn_1 = mkN "sinnesupplevelse" "sinnesupplevelser" ;
  sinnlig_av_1 = mkA "sinnlig" ;
  sinnlighet_nn_1 = mkN "sinnlighet" "sinnligheter" ;
  sinnrik_av_1 = mkA "sinnrik" ;
  sinolog_nn_1 = mkN "sinolog" "sinologer" ;
  sinsemellan_ab_1 = mkAdv "sinsemellan" ;
  sinuit_nn_1 = mkN "sinuit" "sinuiter" ;
  sinus_nn_1 = mkN "sinus" ;
  sinusit_nn_1 = mkN "sinusit" "sinusiter" ;
  sinuston_nn_1 = mkN "sinuston" "sinustoner" ;
  sionist_nn_1 = mkN "sionist" "sionister" ;
  sioux_nn_1 = mkN "sioux" "siouxer" ;
  sipp_av_1 = mkA "sipp" ;
  sirapslen_av_1 = mkA "sirapslen" ;
  sirapsliknande_av_1 = mkA "sirapsliknande" ;
  sirapssoet_av_1 = mkA "sirapssцt" ;
  sirat_nn_1 = mkN "sirat" "sirater" ;
  siratlig_av_1 = mkA "siratlig" ;
  siren_nn_1 = mkN "siren" "sirener" ;
  sirendjur_nn_1 = mkN "sirendjur" neutrum ;
  sirlig_av_1 = mkA "sirlig" ;
  sisaadaer_ab_1 = mkAdv "sisеdдr" ;
  sisel_nn_1 = mkN "sisel" ;
  sist_ab_1 = mkAdv "sist" ;
  sistens_ab_1 = mkAdv "sistens" ;
  sistliden_av_1 = mkA "sistliden" "sistlidet" ;
  sitar_nn_1 = mkN "sitar" "sitarer" ;
  sits_nn_1 = mkN "sits" ;
  sittbadkar_nn_1 = mkN "sittbadkar" neutrum ;
  sittben_nn_1 = mkN "sittben" neutrum ;
  sittbraede_nn_1 = mkN "sittbrдde" ;
  sittbrunn_nn_1 = mkN "sittbrunn" ;
  sitter_nn_1 = mkN "sitter" ;
  sittgrupp_nn_1 = mkN "sittgrupp" "sittgrupper" ;
  sittmoebel_nn_1 = mkN "sittmцbel" "sittmцbeln" "sittmцbler" "sittmцblerna" ;
  sittning_nn_1 = mkN "sittning" ;
  sittopp_nn_1 = mkN "sittopp" ;
  sittpinne_nn_1 = mkN "sittpinne" utrum ;
  sittplats_nn_1 = mkN "sittplats" "sittplatser" ;
  sittriktig_av_1 = mkA "sittriktig" ;
  sittstaang_nn_1 = mkN "sittstеng" "sittstдnger" ;
  sittstrejk_nn_1 = mkN "sittstrejk" "sittstrejker" ;
  sittvagn_nn_1 = mkN "sittvagn" ;
  situation_nn_1 = mkN "situation" "situationer" ;
  situationsbild_nn_1 = mkN "situationsbild" "situationsbilder" ;
  sj_ljud_nn_1 = mkN "sj-ljud" neutrum ;
  sjaaare_nn_1 = mkN "sjеare" "sjеare" ;
  sjaap_nn_1 = mkN "sjеp" neutrum ;
  sjaaperi_nn_1 = mkN "sjеperi" "sjеperit" "sjеperier" "sjеperierna" ;
  sjaapig_av_1 = mkA "sjеpig" ;
  sjabbel_nn_1 = mkN "sjabbel" neutrum ;
  sjabbig_av_1 = mkA "sjabbig" ;
  sjael_nn_1 = mkN "sjдl" ;
  sjaelaglad_av_1 = mkA "sjдlaglad" ;
  sjaelaringning_nn_1 = mkN "sjдlaringning" ;
  sjaelasoerjare_nn_1 = mkN "sjдlasцrjare" "sjдlasцrjare" ;
  sjaelfull_av_1 = mkA "sjдlfull" ;
  sjaelisk_av_1 = mkA "sjдlisk" ;
  sjaelloes_av_1 = mkA "sjдllцs" ;
  sjaelsdoedande_av_1 = mkA "sjдlsdцdande" ;
  sjaelsegenskap_nn_1 = mkN "sjдlsegenskap" "sjдlsegenskaper" ;
  sjaelsfoermoegenhet_nn_1 = mkN "sjдlsfцrmцgenhet" "sjдlsfцrmцgenheter" ;
  sjaelsfraanvarande_av_1 = mkA "sjдlsfrеnvarande" ;
  sjaelsfraende_nn_1 = mkN "sjдlsfrдnde" "sjдlsfrдnder" ;
  sjaelskonflikt_nn_1 = mkN "sjдlskonflikt" "sjдlskonflikter" ;
  sjaelslig_av_1 = mkA "sjдlslig" ;
  sjaelsligen_ab_1 = mkAdv "sjдlsligen" ;
  sjaelssjuk_av_1 = mkA "sjдlssjuk" ;
  sjaelsstrid_nn_1 = mkN "sjдlsstrid" "sjдlsstrider" ;
  sjaelv_av_1 = mkA "sjдlv" ;
  sjaelvaegande_av_1 = mkA "sjдlvдgande" ;
  sjaelvalstring_nn_1 = mkN "sjдlvalstring" ;
  sjaelvanalys_nn_1 = mkN "sjдlvanalys" "sjдlvanalyser" ;
  sjaelvanklagelse_nn_1 = mkN "sjдlvanklagelse" "sjдlvanklagelser" ;
  sjaelvantaendning_nn_1 = mkN "sjдlvantдndning" ;
  sjaelvbedraegeri_nn_1 = mkN "sjдlvbedrдgeri" "sjдlvbedrдgerit" "sjдlvbedrдgerier" "sjдlvbedrдgerierna" ;
  sjaelvbefruktning_nn_1 = mkN "sjдlvbefruktning" ;
  sjaelvbekaennelse_nn_1 = mkN "sjдlvbekдnnelse" "sjдlvbekдnnelser" ;
  sjaelvbelaaten_av_1 = mkA "sjдlvbelеten" "sjдlvbelеtet" ;
  sjaelvbespegling_nn_1 = mkN "sjдlvbespegling" ;
  sjaelvbindare_nn_1 = mkN "sjдlvbindare" "sjдlvbindare" ;
  sjaelvbiografi_nn_1 = mkN "sjдlvbiografi" "sjдlvbiografier" ;
  sjaelvbiografisk_av_1 = mkA "sjдlvbiografisk" ;
  sjaelvdeklaration_nn_1 = mkN "sjдlvdeklaration" "sjдlvdeklarationer" ;
  sjaelvfallen_av_1 = mkA "sjдlvfallen" "sjдlvfallet" ;
  sjaelvfallet_ab_1 = mkAdv "sjдlvfallet" ;
  sjaelvfoergloemmande_av_1 = mkA "sjдlvfцrglцmmande" ;
  sjaelvfoernekelse_nn_1 = mkN "sjдlvfцrnekelse" "sjдlvfцrnekelser" ;
  sjaelvgod_av_1 = mkA "sjдlvgod" ;
  sjaelvgodhet_nn_1 = mkN "sjдlvgodhet" "sjдlvgodheter" ;
  sjaelvhaerlig_av_1 = mkA "sjдlvhдrlig" ;
  sjaelvhaerskare_nn_1 = mkN "sjдlvhдrskare" "sjдlvhдrskare" ;
  sjaelviakttagelse_nn_1 = mkN "sjдlviakttagelse" "sjдlviakttagelser" ;
  sjaelvinstruerande_av_1 = mkA "sjдlvinstruerande" ;
  sjaelvisk_av_1 = mkA "sjдlvisk" ;
  sjaelvkaennedom_nn_1 = mkN "sjдlvkдnnedom" ;
  sjaelvkem_nn_1 = mkN "sjдlvkem" ;
  sjaelvklar_av_1 = mkA "sjдlvklar" ;
  sjaelvklarhet_nn_1 = mkN "sjдlvklarhet" "sjдlvklarheter" ;
  sjaelvkritisk_av_1 = mkA "sjдlvkritisk" ;
  sjaelvlaens_nn_1 = mkN "sjдlvlдns" ;
  sjaelvlaerd_av_1 = mkA "sjдlvlдrd" "sjдlvlдrt" ;
  sjaelvljud_nn_1 = mkN "sjдlvljud" neutrum ;
  sjaelvlysande_av_1 = mkA "sjдlvlysande" ;
  sjaelvmaal_nn_1 = mkN "sjдlvmеl" neutrum ;
  sjaelvmant_ab_1 = mkAdv "sjдlvmant" ;
  sjaelvmedveten_av_1 = mkA "sjдlvmedveten" "sjдlvmedvetet" ;
  sjaelvmoerdare_nn_1 = mkN "sjдlvmцrdare" "sjдlvmцrdare" ;
  sjaelvmord_nn_1 = mkN "sjдlvmord" neutrum ;
  sjaelvmordskandidat_nn_1 = mkN "sjдlvmordskandidat" "sjдlvmordskandidater" ;
  sjaelvmotsaegelse_nn_1 = mkN "sjдlvmotsдgelse" "sjдlvmotsдgelser" ;
  sjaelvpaatagen_av_1 = mkA "sjдlvpеtagen" "sjдlvpеtaget" ;
  sjaelvplaagare_nn_1 = mkN "sjдlvplеgare" "sjдlvplеgare" ;
  sjaelvportraett_nn_1 = mkN "sjдlvportrдtt" neutrum ;
  sjaelvraadig_av_1 = mkA "sjдlvrеdig" ;
  sjaelvraettfaerdig_av_1 = mkA "sjдlvrдttfдrdig" ;
  sjaelvrisk_nn_1 = mkN "sjдlvrisk" "sjдlvrisker" ;
  sjaelvsaeker_av_1 = mkA "sjдlvsдker" "sjдlvsдkert" "sjдlvsдkra" "sjдlvsдkra" "sjдlvsдkrare" "sjдlvsдkrast" "sjдlvsдkraste" ;
  sjaelvsaekerhet_nn_1 = mkN "sjдlvsдkerhet" "sjдlvsдkerheter" ;
  sjaelvservering_nn_1 = mkN "sjдlvservering" ;
  sjaelvskriven_av_1 = mkA "sjдlvskriven" "sjдlvskrivet" ;
  sjaelvspelande_av_1 = mkA "sjдlvspelande" ;
  sjaelvspilling_nn_1 = mkN "sjдlvspilling" ;
  sjaelvstaendig_av_1 = mkA "sjдlvstдndig" ;
  sjaelvstaendighet_nn_1 = mkN "sjдlvstдndighet" "sjдlvstдndigheter" ;
  sjaelvstaendighetsfoerklaring_nn_1 = mkN "sjдlvstдndighetsfцrklaring" ;
  sjaelvstudium_nn_1 = mkN "sjдlvstudium" "sjдlvstudiet" "sjдlvstudier" "sjдlvstudierna" ;
  sjaelvstyrande_av_1 = mkA "sjдlvstyrande" ;
  sjaelvsvaaldig_av_1 = mkA "sjдlvsvеldig" ;
  sjaelvtaendning_nn_1 = mkN "sjдlvtдndning" ;
  sjaelvtillraecklig_av_1 = mkA "sjдlvtillrдcklig" ;
  sjaelvuppfyllande_av_1 = mkA "sjдlvuppfyllande" ;
  sjaelvupplevd_av_1 = mkA "sjдlvupplevd" "sjдlvupplevt" ;
  sjaelvuppoffrande_av_1 = mkA "sjдlvuppoffrande" ;
  sjaelvuppoffring_nn_1 = mkN "sjдlvuppoffring" ;
  sjaelvupptagen_av_1 = mkA "sjдlvupptagen" "sjдlvupptaget" ;
  sjaelvutloesare_nn_1 = mkN "sjдlvutlцsare" "sjдlvutlцsare" ;
  sjaelvutnaemnd_av_1 = mkA "sjдlvutnдmnd" ;
  sjaelvutplaanande_av_1 = mkA "sjдlvutplеnande" ;
  sjaelvvald_av_1 = mkA "sjдlvvald" "sjдlvvalt" ;
  sjaettedel_nn_1 = mkN "sjдttedel" "sjдttedelen" "sjдttedelar" "sjдttedelarna" ;
  sjagg_nn_1 = mkN "sjagg" "sjagger" ;
  sjajas_nn_1 = mkN "sjajas" ;
  sjakal_nn_1 = mkN "sjakal" "sjakaler" ;
  sjal_nn_1 = mkN "sjal" ;
  sjalett_nn_1 = mkN "sjalett" "sjaletter" ;
  sjalkrage_nn_1 = mkN "sjalkrage" utrum ;
  sjangdobel_av_1 = mkA "sjangdobel" "sjangdobelt" "sjangdobla" "sjangdobla" "sjangdoblare" "sjangdoblast" "sjangdoblaste" ;
  sjangtil_av_1 = mkA "sjangtil" ;
  sjapp_nn_1 = mkN "sjapp" neutrum ;
  sjasker_nn_1 = mkN "sjasker" ;
  sjaskig_av_1 = mkA "sjaskig" ;
  sjavig_av_1 = mkA "sjavig" ;
  sjoe_nn_1 = mkN "sjц" ;
  sjoeavlagring_nn_1 = mkN "sjцavlagring" ;
  sjoebjoern_nn_1 = mkN "sjцbjцrn" ;
  sjoebloet_av_1 = mkA "sjцblцt" ;
  sjoebod_nn_1 = mkN "sjцbod" ;
  sjoeborre_nn_1 = mkN "sjцborre" utrum ;
  sjoebotten_nn_1 = mkN "sjцbotten" ;
  sjoebuss_nn_1 = mkN "sjцbuss" ;
  sjoedraenkt_av_1 = mkA "sjцdrдnkt" "sjцdrдnkt" ;
  sjoeduglig_av_1 = mkA "sjцduglig" ;
  sjoeelefant_nn_1 = mkN "sjцelefant" "sjцelefanter" ;
  sjoefaagel_nn_1 = mkN "sjцfеgel" ;
  sjoefaagelsjakt_nn_1 = mkN "sjцfеgelsjakt" "sjцfеgelsjakter" ;
  sjoefaerd_nn_1 = mkN "sjцfдrd" "sjцfдrder" ;
  sjoefarande_av_1 = mkA "sjцfarande" ;
  sjoefarare_nn_1 = mkN "sjцfarare" "sjцfarare" ;
  sjoefartsregel_nn_1 = mkN "sjцfartsregel" "sjцfartsregeln" "sjцfartsregler" "sjцfartsreglerna" ;
  sjoeflygplan_nn_1 = mkN "sjцflygplan" neutrum ;
  sjoefoerhoer_nn_1 = mkN "sjцfцrhцr" neutrum ;
  sjoefoerklaring_nn_1 = mkN "sjцfцrklaring" ;
  sjoefrakt_nn_1 = mkN "sjцfrakt" "sjцfrakter" ;
  sjoefynd_nn_1 = mkN "sjцfynd" neutrum ;
  sjoehaest_nn_1 = mkN "sjцhдst" ;
  sjoejungfru_nn_1 = mkN "sjцjungfru" "sjцjungfrun" "sjцjungfrur" "sjцjungfrurna" ;
  sjoekapten_nn_1 = mkN "sjцkapten" "sjцkaptener" ;
  sjoekaptensbrev_nn_1 = mkN "sjцkaptensbrev" neutrum ;
  sjoeko_nn_1 = mkN "sjцko" "sjцkor" ;
  sjoekort_nn_1 = mkN "sjцkort" neutrum ;
  sjoelaegenhet_nn_1 = mkN "sjцlдgenhet" "sjцlдgenheter" ;
  sjoelejon_nn_1 = mkN "sjцlejon" neutrum ;
  sjoemaerke_nn_1 = mkN "sjцmдrke" ;
  sjoeman_nn_1 = mkN "sjцman" "sjцmannen" "sjцmдn" "sjцmдnnen" ;
  sjoemansblus_nn_1 = mkN "sjцmansblus" ;
  sjoemansfoermedling_nn_1 = mkN "sjцmansfцrmedling" ;
  sjoemanshus_nn_1 = mkN "sjцmanshus" neutrum ;
  sjoemansklaenning_nn_1 = mkN "sjцmansklдnning" ;
  sjoemansknop_nn_1 = mkN "sjцmansknop" ;
  sjoemanskrage_nn_1 = mkN "sjцmanskrage" utrum ;
  sjoemanssaeck_nn_1 = mkN "sjцmanssдck" ;
  sjoemansutbildning_nn_1 = mkN "sjцmansutbildning" ;
  sjoemil_nn_1 = mkN "sjцmil" "sjцmilen" "sjцmil" "sjцmilen" ;
  sjoeodjur_nn_1 = mkN "sjцodjur" neutrum ;
  sjoeofficer_nn_1 = mkN "sjцofficer" "sjцofficern" "sjцofficerare" "sjцofficerarna" ;
  sjoeorm_nn_1 = mkN "sjцorm" ;
  sjoeorre_nn_1 = mkN "sjцorre" utrum ;
  sjoepung_nn_1 = mkN "sjцpung" ;
  sjoerapport_nn_1 = mkN "sjцrapport" "sjцrapporter" ;
  sjoereglering_nn_1 = mkN "sjцreglering" ;
  sjoeroevare_nn_1 = mkN "sjцrцvare" "sjцrцvare" ;
  sjoeroeveri_nn_1 = mkN "sjцrцveri" "sjцrцverit" "sjцrцverier" "sjцrцverierna" ;
  sjoesaeker_av_1 = mkA "sjцsдker" "sjцsдkert" "sjцsдkra" "sjцsдkra" "sjцsдkrare" "sjцsдkrast" "sjцsдkraste" ;
  sjoesaettning_nn_1 = mkN "sjцsдttning" ;
  sjoesediment_nn_1 = mkN "sjцsediment" "sjцsedimentet" "sjцsedimenten" "sjцsedimentena" ;
  sjoesjuk_av_1 = mkA "sjцsjuk" ;
  sjoeslag_nn_1 = mkN "sjцslag" neutrum ;
  sjoestoevel_nn_1 = mkN "sjцstцvel" ;
  sjoestrid_nn_1 = mkN "sjцstrid" "sjцstrider" ;
  sjoetomt_nn_1 = mkN "sjцtomt" "sjцtomter" ;
  sjoetunga_nn_1 = mkN "sjцtunga" ;
  sjoevaegsregel_nn_1 = mkN "sjцvдgsregel" "sjцvдgsregeln" "sjцvдgsregler" "sjцvдgsreglerna" ;
  sjoevaerdig_av_1 = mkA "sjцvдrdig" ;
  sjoevaerdighet_nn_1 = mkN "sjцvдrdighet" "sjцvдrdigheter" ;
  sjoevana_nn_1 = mkN "sjцvana" ;
  sjoevatten_nn_1 = mkN "sjцvatten" "sjцvattnet" "sjцvatten" "sjцvattnen" ;
  sjoevild_av_1 = mkA "sjцvild" "sjцvilt" ;
  sjok_nn_1 = mkN "sjok" neutrum ;
  sjuaarig_av_1 = mkA "sjuеrig" ;
  sjubb_nn_1 = mkN "sjubb" ;
  sjuckert_ab_1 = mkAdv "sjuckert" ;
  sjudagarsvecka_nn_1 = mkN "sjudagarsvecka" ;
  sjudimensionell_av_1 = mkA "sjudimensionell" ;
  sjudundrande_av_1 = mkA "sjudundrande" ;
  sjuglasvagn_nn_1 = mkN "sjuglasvagn" ;
  sjuk_av_1 = mkA "sjuk" ;
  sjukavdrag_nn_1 = mkN "sjukavdrag" neutrum ;
  sjukbaedd_nn_1 = mkN "sjukbдdd" ;
  sjukbaerare_nn_1 = mkN "sjukbдrare" "sjukbдrare" ;
  sjukbesoek_nn_1 = mkN "sjukbesцk" neutrum ;
  sjukbud_nn_1 = mkN "sjukbud" neutrum ;
  sjukdag_nn_1 = mkN "sjukdag" ;
  sjukdom_nn_1 = mkN "sjukdom" ;
  sjukdomsalstrande_av_1 = mkA "sjukdomsalstrande" ;
  sjukdomsbild_nn_1 = mkN "sjukdomsbild" "sjukdomsbilder" ;
  sjukdomshistoria_nn_1 = mkN "sjukdomshistoria" "sjukdomshistorien" "sjukdomshistorier" "sjukdomshistorierna" ;
  sjukdomssymptom_nn_1 = mkN "sjukdomssymptom" neutrum ;
  sjukdomstillstaand_nn_1 = mkN "sjukdomstillstеnd" neutrum ;
  sjukfoersaekring_nn_1 = mkN "sjukfцrsдkring" ;
  sjukgymnast_nn_1 = mkN "sjukgymnast" "sjukgymnaster" ;
  sjukhem_nn_1 = mkN "sjukhem" "sjukhemmet" "sjukhem" "sjukhemmen" ;
  sjukhus_nn_1 = mkN "sjukhus" neutrum ;
  sjukhusavdelning_nn_1 = mkN "sjukhusavdelning" ;
  sjukhusdirektoer_nn_1 = mkN "sjukhusdirektцr" "sjukhusdirektцrer" ;
  sjukhussal_nn_1 = mkN "sjukhussal" ;
  sjukjournal_nn_1 = mkN "sjukjournal" "sjukjournaler" ;
  sjukkassa_nn_1 = mkN "sjukkassa" ;
  sjuklaeger_nn_1 = mkN "sjuklдger" neutrum ;
  sjukledig_av_1 = mkA "sjukledig" ;
  sjuklig_av_1 = mkA "sjuklig" ;
  sjuklighet_nn_1 = mkN "sjuklighet" "sjukligheter" ;
  sjukling_nn_1 = mkN "sjukling" ;
  sjukpension_nn_1 = mkN "sjukpension" "sjukpensioner" ;
  sjukskoetare_nn_1 = mkN "sjukskцtare" "sjukskцtare" ;
  sjukskoeterska_nn_1 = mkN "sjukskцterska" ;
  sjukskriva_vb_1 = mkV "sjukskriva" "sjukskrev" "sjukskrivit" ;
  sjukstuga_nn_1 = mkN "sjukstuga" ;
  sjuksyster_nn_1 = mkN "sjuksyster" ;
  sjukvaardare_nn_1 = mkN "sjukvеrdare" "sjukvеrdare" ;
  sjukvaardsaffaer_nn_1 = mkN "sjukvеrdsaffдr" "sjukvеrdsaffдrer" ;
  sjukvaardsartikel_nn_1 = mkN "sjukvеrdsartikel" ;
  sjukvaardsbitraede_nn_1 = mkN "sjukvеrdsbitrдde" ;
  sjukvaardsutbildning_nn_1 = mkN "sjukvеrdsutbildning" ;
  sjukvaardsutrustning_nn_1 = mkN "sjukvеrdsutrustning" ;
  sjukvikarie_nn_1 = mkN "sjukvikarie" "sjukvikarier" ;
  sjumilakliv_nn_1 = mkN "sjumilakliv" neutrum ;
  sjundedagsadventist_nn_1 = mkN "sjundedagsadventist" "sjundedagsadventister" ;
  sjundedel_nn_1 = mkN "sjundedel" "sjundedelen" "sjundedelar" "sjundedelarna" ;
  sjunga_vb_1 = mkV "sjunga" "sjцng" "sjungit" ;
  sjunka_vb_1 = mkV "sjunka" "sjцnk" "sjunkit" ;
  sjunkbomb_nn_1 = mkN "sjunkbomb" "sjunkbomber" ;
  sjurygg_nn_1 = mkN "sjurygg" ;
  sjusaerdeles_ab_1 = mkAdv "sjusдrdeles" ;
  sjusovare_nn_1 = mkN "sjusovare" "sjusovare" ;
  sjutillhaallarlaas_nn_1 = mkN "sjutillhеllarlеs" neutrum ;
  sjyst_av_1 = mkA "sjyst" "sjyst" ;
  skaademynt_nn_1 = mkN "skеdemynt" neutrum ;
  skaadeplats_nn_1 = mkN "skеdeplats" "skеdeplatser" ;
  skaadeprocess_nn_1 = mkN "skеdeprocess" "skеdeprocesser" ;
  skaadespel_nn_1 = mkN "skеdespel" "skеdespelet" "skеdespel" "skеdespelen" ;
  skaadespelare_nn_1 = mkN "skеdespelare" "skеdespelare" ;
  skaadespelerska_nn_1 = mkN "skеdespelerska" ;
  skaal_nn_1 = mkN "skеl" ;
  skaalformig_av_1 = mkA "skеlformig" ;
  skaalgrop_nn_1 = mkN "skеlgrop" ;
  skaalig_av_1 = mkA "skеlig" ;
  skaalkors_nn_1 = mkN "skеlkors" neutrum ;
  skaallhet_av_1 = mkA "skеllhet" ;
  skaalpund_nn_1 = mkN "skеlpund" neutrum ;
  skaalsvamp_nn_1 = mkN "skеlsvamp" ;
  skaaltom_av_1 = mkA "skеltom" "skеltomt" "skеltomma" "skеltomma" "skеltommare" "skеltommast" "skеltommaste" ;
  skaaning_nn_1 = mkN "skеning" ;
  skaank_nn_1 = mkN "skеnk" ;
  skaansk_av_1 = mkA "skеnsk" ;
  skaanska_nn_2 = mkN "skеnska" ;
  skaap_nn_1 = mkN "skеp" neutrum ;
  skaapbil_nn_1 = mkN "skеpbil" ;
  skaapliknande_av_1 = mkA "skеpliknande" ;
  skaapsaeng_nn_1 = mkN "skеpsдng" ;
  skaapvagn_nn_1 = mkN "skеpvagn" ;
  skaar_nn_1 = mkN "skеr" neutrum ;
  skaare_nn_1 = mkN "skеre" utrum ;
  skabbdjur_nn_1 = mkN "skabbdjur" neutrum ;
  skabbig_av_1 = mkA "skabbig" ;
  skabroes_av_1 = mkA "skabrцs" ;
  skackel_nn_1 = mkN "skackel" ;
  skadedjur_nn_1 = mkN "skadedjur" neutrum ;
  skadeersaettning_nn_1 = mkN "skadeersдttning" ;
  skadeglad_av_1 = mkA "skadeglad" ;
  skadegoerare_nn_1 = mkN "skadegцrare" "skadegцrare" ;
  skadegoerelse_nn_1 = mkN "skadegцrelse" "skadegцrelser" ;
  skadeinsekt_nn_1 = mkN "skadeinsekt" "skadeinsekter" ;
  skadereglering_nn_1 = mkN "skadereglering" ;
  skadesloes_av_1 = mkA "skadeslцs" ;
  skadestaand_nn_1 = mkN "skadestеnd" neutrum ;
  skadeverkning_nn_1 = mkN "skadeverkning" ;
  skadlig_av_1 = mkA "skadlig" ;
  skadskjuta_vb_1 = mkV "skadskjuta" "skadskцt" "skadskjutit" ;
  skaeck_nn_1 = mkN "skдck" ;
  skaeckig_av_1 = mkA "skдckig" ;
  skaeftig_av_1 = mkA "skдftig" ;
  skaegg_nn_1 = mkN "skдgg" neutrum ;
  skaeggbotten_nn_1 = mkN "skдggbotten" ;
  skaeggdopping_nn_1 = mkN "skдggdopping" ;
  skaeggig_av_1 = mkA "skдggig" ;
  skaegglapp_nn_1 = mkN "skдgglapp" ;
  skaeggloes_av_1 = mkA "skдgglцs" ;
  skaeggstraa_nn_1 = mkN "skдggstrе" "skдggstrеt" "skдggstrеn" "skдggstrеna" ;
  skaeggtoem_nn_1 = mkN "skдggtцm" "skдggtцmmen" "skдggtцmmar" "skдggtцmmarna" ;
  skaektetrae_nn_1 = mkN "skдktetrд" "skдktetrдet" "skдktetrдn" "skдktetrдna" ;
  skaektkniv_nn_1 = mkN "skдktkniv" ;
  skaektstol_nn_1 = mkN "skдktstol" ;
  skaekttrae_nn_1 = mkN "skдkttrд" "skдkttrдt" "skдkttrдn" "skдkttrдna" ;
  skael_nn_1 = mkN "skдl" neutrum ;
  skaelig_av_1 = mkA "skдlig" ;
  skaeligen_ab_1 = mkAdv "skдligen" ;
  skaell_av_1 = mkA "skдll" ;
  skaellko_nn_1 = mkN "skдllko" "skдllkor" ;
  skaellning_nn_1 = mkN "skдllning" ;
  skaellsord_nn_1 = mkN "skдllsord" neutrum ;
  skaelm_nn_1 = mkN "skдlm" ;
  skaelmaktig_av_1 = mkA "skдlmaktig" ;
  skaelmroman_nn_1 = mkN "skдlmroman" "skдlmromaner" ;
  skaelmsk_av_1 = mkA "skдlmsk" ;
  skaemd_av_1 = mkA "skдmd" "skдmt" ;
  skaemt_nn_1 = mkN "skдmt" neutrum ;
  skaemtare_nn_1 = mkN "skдmtare" "skдmtare" ;
  skaemtsam_av_1 = mkA "skдmtsam" "skдmtsamt" "skдmtsamma" "skдmtsamma" "skдmtsammare" "skдmtsammast" "skдmtsammaste" ;
  skaemttecknare_nn_1 = mkN "skдmttecknare" "skдmttecknare" ;
  skaemtteckning_nn_1 = mkN "skдmtteckning" ;
  skaendlig_av_1 = mkA "skдndlig" ;
  skaendligen_ab_1 = mkAdv "skдndligen" ;
  skaendlighet_nn_1 = mkN "skдndlighet" "skдndligheter" ;
  skaendning_nn_1 = mkN "skдndning" ;
  skaenk_nn_1 = mkN "skдnk" ;
  skaenk_nn_2 = mkN "skдnk" "skдnker" ;
  skaenkel_nn_1 = mkN "skдnkel" ;
  skaer_av_1 = mkA "skдr" ;
  skaer_nn_1 = mkN "skдr" neutrum ;
  skaera_vb_1 = mkV "skдra" "skar" "skurit" ;
  skaerande_av_1 = mkA "skдrande" ;
  skaerbraede_nn_1 = mkN "skдrbrдde" ;
  skaerbraennare_nn_1 = mkN "skдrbrдnnare" "skдrbrдnnare" ;
  skaergaard_nn_1 = mkN "skдrgеrd" ;
  skaergaardsbo_nn_1 = mkN "skдrgеrdsbo" "skдrgеrdsbor" ;
  skaergaardskryssare_nn_1 = mkN "skдrgеrdskryssare" "skдrgеrdskryssare" ;
  skaergaardsoe_nn_1 = mkN "skдrgеrdsц" ;
  skaergaardsturist_nn_1 = mkN "skдrgеrdsturist" "skдrgеrdsturister" ;
  skaerhaallfasthet_nn_1 = mkN "skдrhеllfasthet" "skдrhеllfastheter" ;
  skaerkarl_nn_1 = mkN "skдrkarl" ;
  skaerkniv_nn_1 = mkN "skдrkniv" ;
  skaerm_nn_1 = mkN "skдrm" ;
  skaermbild_nn_1 = mkN "skдrmbild" "skдrmbilder" ;
  skaermbildsundersoekning_nn_1 = mkN "skдrmbildsundersцkning" ;
  skaermytsel_nn_1 = mkN "skдrmytsel" ;
  skaermytsling_nn_1 = mkN "skдrmytsling" ;
  skaerning_nn_1 = mkN "skдrning" ;
  skaerningspunkt_nn_1 = mkN "skдrningspunkt" "skдrningspunkter" ;
  skaerp_nn_1 = mkN "skдrp" neutrum ;
  skaerpedjup_nn_1 = mkN "skдrpedjup" neutrum ;
  skaerpning_nn_1 = mkN "skдrpning" ;
  skaerpt_av_1 = mkA "skдrpt" "skдrpt" ;
  skaerslipare_nn_1 = mkN "skдrslipare" "skдrslipare" ;
  skaerstock_nn_1 = mkN "skдrstock" ;
  skaertorsdag_nn_1 = mkN "skдrtorsdag" ;
  skaerv_nn_1 = mkN "skдrv" ;
  skaevig_av_1 = mkA "skдvig" ;
  skafferi_nn_1 = mkN "skafferi" "skafferit" "skafferier" "skafferierna" ;
  skaffning_nn_1 = mkN "skaffning" ;
  skaffoettes_ab_1 = mkAdv "skaffцttes" ;
  skafoettes_ab_1 = mkAdv "skafцttes" ;
  skaft_nn_1 = mkN "skaft" neutrum ;
  skak_nn_1 = mkN "skak" neutrum ;
  skakande_av_1 = mkA "skakande" ;
  skakel_nn_1 = mkN "skakel" ;
  skakig_av_1 = mkA "skakig" ;
  skakis_av_1 = mkA "skakis" ;
  skakning_nn_1 = mkN "skakning" ;
  skal_nn_1 = mkN "skal" neutrum ;
  skalaer_av_1 = mkA "skalдr" ;
  skalaer_nn_1 = mkN "skalдr" "skalдrer" ;
  skalbagge_nn_1 = mkN "skalbagge" utrum ;
  skald_nn_1 = mkN "skald" "skalder" ;
  skaldekonst_nn_1 = mkN "skaldekonst" "skaldekonster" ;
  skaldisk_av_1 = mkA "skaldisk" ;
  skaldjur_nn_1 = mkN "skaldjur" neutrum ;
  skalenlig_av_1 = mkA "skalenlig" ;
  skalhus_nn_1 = mkN "skalhus" neutrum ;
  skalk_nn_1 = mkN "skalk" ;
  skalkaktig_av_1 = mkA "skalkaktig" ;
  skalkeskjul_nn_1 = mkN "skalkeskjul" neutrum ;
  skalkorn_nn_1 = mkN "skalkorn" neutrum ;
  skall_nn_1 = mkN "skall" neutrum ;
  skallbas_nn_1 = mkN "skallbas" "skallbaser" ;
  skallben_nn_1 = mkN "skallben" neutrum ;
  skalle_nn_1 = mkN "skalle" utrum ;
  skallerorm_nn_1 = mkN "skallerorm" ;
  skallform_nn_1 = mkN "skallform" "skallformer" ;
  skallgaang_nn_1 = mkN "skallgеng" ;
  skallig_av_1 = mkA "skallig" ;
  skalloes_av_1 = mkA "skallцs" ;
  skallra_nn_1 = mkN "skallra" ;
  skalm_nn_1 = mkN "skalm" ;
  skalp_nn_1 = mkN "skalp" "skalper" ;
  skalpell_nn_1 = mkN "skalpell" "skalpeller" ;
  skalstreck_nn_1 = mkN "skalstreck" neutrum ;
  skalv_nn_1 = mkN "skalv" neutrum ;
  skamflaeck_nn_1 = mkN "skamflдck" ;
  skamgrepp_nn_1 = mkN "skamgrepp" neutrum ;
  skamkaensla_nn_1 = mkN "skamkдnsla" ;
  skamlig_av_1 = mkA "skamlig" ;
  skamligen_ab_1 = mkAdv "skamligen" ;
  skamlighet_nn_1 = mkN "skamlighet" "skamligheter" ;
  skamloes_av_1 = mkA "skamlцs" ;
  skamloeshet_nn_1 = mkN "skamlцshet" "skamlцsheter" ;
  skampaale_nn_1 = mkN "skampеle" utrum ;
  skamsen_av_1 = mkA "skamsen" "skamset" ;
  skamstock_nn_1 = mkN "skamstock" ;
  skandal_nn_1 = mkN "skandal" "skandaler" ;
  skandaloes_av_1 = mkA "skandalцs" ;
  skandalunge_nn_1 = mkN "skandalunge" utrum ;
  skandinav_nn_1 = mkN "skandinav" "skandinaver" ;
  skandinavisk_av_1 = mkA "skandinavisk" ;
  skandinavist_nn_1 = mkN "skandinavist" "skandinavister" ;
  skanism_nn_1 = mkN "skanism" "skanismer" ;
  skank_nn_1 = mkN "skank" ;
  skans_nn_1 = mkN "skans" ;
  skap_nn_1 = mkN "skap" neutrum ;
  skapande_av_1 = mkA "skapande" ;
  skapare_nn_1 = mkN "skapare" "skapare" ;
  skaparkraft_nn_1 = mkN "skaparkraft" "skaparkrafter" ;
  skapelse_nn_1 = mkN "skapelse" "skapelser" ;
  skaplig_av_1 = mkA "skaplig" ;
  skapnad_nn_1 = mkN "skapnad" "skapnader" ;
  skarabe_nn_1 = mkN "skarabй" "skarabйer" ;
  skarf_nn_1 = mkN "skarf" ;
  skarn_nn_1 = mkN "skarn" neutrum ;
  skarndaeck_nn_1 = mkN "skarndдck" neutrum ;
  skarp_av_1 = mkA "skarp" ;
  skarpoegd_av_1 = mkA "skarpцgd" "skarpцgt" ;
  skarpraettare_nn_1 = mkN "skarprдttare" "skarprдttare" ;
  skarpsill_nn_1 = mkN "skarpsill" ;
  skarpskuren_av_1 = mkA "skarpskuren" "skarpskuret" ;
  skarpskytt_nn_1 = mkN "skarpskytt" ;
  skarpsyn_nn_1 = mkN "skarpsyn" "skarpsyner" ;
  skarpsynt_av_1 = mkA "skarpsynt" "skarpsynt" ;
  skarpt_ab_1 = mkAdv "skarpt" ;
  skarv_nn_1 = mkN "skarv" ;
  skarvsladd_nn_1 = mkN "skarvsladd" ;
  skate_nn_1 = mkN "skate" utrum ;
  skateboard_nn_1 = mkN "skateboard" "skateboarden" "skateboard" "skateboarden" ;
  skatt_nn_1 = mkN "skatt" "skatter" ;
  skatteaaterbaering_nn_1 = mkN "skatteеterbдring" ;
  skatteavdrag_nn_1 = mkN "skatteavdrag" neutrum ;
  skattebas_nn_1 = mkN "skattebas" "skattebaser" ;
  skattebelopp_nn_1 = mkN "skattebelopp" neutrum ;
  skattebetalare_nn_1 = mkN "skattebetalare" "skattebetalare" ;
  skattebetalning_nn_1 = mkN "skattebetalning" ;
  skattebonde_nn_1 = mkN "skattebonde" "skattebцnder" ;
  skattebrott_nn_1 = mkN "skattebrott" neutrum ;
  skattefraaga_nn_1 = mkN "skattefrеga" ;
  skattefri_av_1 = mkA "skattefri" "skattefritt" ;
  skattefrihet_nn_1 = mkN "skattefrihet" "skattefriheter" ;
  skattefuskare_nn_1 = mkN "skattefuskare" "skattefuskare" ;
  skattehoejning_nn_1 = mkN "skattehцjning" ;
  skatteingenjoer_nn_1 = mkN "skatteingenjцr" "skatteingenjцrer" ;
  skatteinkomst_nn_1 = mkN "skatteinkomst" "skatteinkomster" ;
  skatteintaekt_nn_1 = mkN "skatteintдkt" "skatteintдkter" ;
  skattekil_nn_1 = mkN "skattekil" ;
  skatteklass_nn_1 = mkN "skatteklass" "skatteklasser" ;
  skattekort_nn_1 = mkN "skattekort" neutrum ;
  skattekraft_nn_1 = mkN "skattekraft" "skattekrafter" ;
  skattelaettnad_nn_1 = mkN "skattelдttnad" "skattelдttnader" ;
  skattelag_nn_1 = mkN "skattelag" ;
  skattemaerke_nn_1 = mkN "skattemдrke" ;
  skattemoral_nn_1 = mkN "skattemoral" "skattemoraler" ;
  skattemyndighet_nn_1 = mkN "skattemyndighet" "skattemyndigheter" ;
  skattenivaa_nn_1 = mkN "skattenivе" "skattenivеer" ;
  skattepliktig_av_1 = mkA "skattepliktig" ;
  skatteprincip_nn_1 = mkN "skatteprincip" "skatteprinciper" ;
  skatteprotest_nn_1 = mkN "skatteprotest" "skatteprotester" ;
  skattereduktion_nn_1 = mkN "skattereduktion" "skattereduktioner" ;
  skattereform_nn_1 = mkN "skattereform" "skattereformer" ;
  skatteregel_nn_1 = mkN "skatteregel" "skatteregeln" "skatteregler" "skattereglerna" ;
  skatterevolt_nn_1 = mkN "skatterevolt" "skatterevolter" ;
  skattesaenkning_nn_1 = mkN "skattesдnkning" ;
  skattesats_nn_1 = mkN "skattesats" "skattesatser" ;
  skattesmitare_nn_1 = mkN "skattesmitare" "skattesmitare" ;
  skattesystem_nn_1 = mkN "skattesystem" neutrum ;
  skattetabell_nn_1 = mkN "skattetabell" "skattetabeller" ;
  skattetak_nn_1 = mkN "skattetak" neutrum ;
  skattetryck_nn_1 = mkN "skattetryck" neutrum ;
  skatteuttag_nn_1 = mkN "skatteuttag" neutrum ;
  skattkammarvaexel_nn_1 = mkN "skattkammarvдxel" ;
  skattmaestare_nn_1 = mkN "skattmдstare" "skattmдstare" ;
  skattmas_nn_1 = mkN "skattmas" ;
  skattsedel_nn_1 = mkN "skattsedel" ;
  skattskriva_vb_1 = mkV "skattskriva" "skattskrev" "skattskrivit" ;
  skattskyldig_av_1 = mkA "skattskyldig" ;
  skattsoekare_nn_1 = mkN "skattsцkare" "skattsцkare" ;
  skavank_nn_1 = mkN "skavank" "skavanker" ;
  skavfoetters_ab_1 = mkAdv "skavfцtters" ;
  skavsaar_nn_1 = mkN "skavsеr" neutrum ;
  skavskydd_nn_1 = mkN "skavskydd" neutrum ;
  sked_nn_1 = mkN "sked" ;
  skedand_nn_1 = mkN "skedand" "skedдnder" ;
  skeddrag_nn_1 = mkN "skeddrag" neutrum ;
  skedstork_nn_1 = mkN "skedstork" ;
  skedvis_ab_1 = mkAdv "skedvis" ;
  skeende_nn_1 = mkN "skeende" ;
  skelett_nn_1 = mkN "skelett" neutrum ;
  skelettmuskel_nn_1 = mkN "skelettmuskel" "skelettmuskeln" "skelettmuskler" "skelettmusklerna" ;
  skeloegd_av_1 = mkA "skelцgd" "skelцgt" ;
  skeloegdhet_nn_1 = mkN "skelцgdhet" "skelцgdheter" ;
  sken_nn_1 = mkN "sken" neutrum ;
  skenbar_av_1 = mkA "skenbar" ;
  skenbarligen_ab_1 = mkAdv "skenbarligen" ;
  skenben_nn_1 = mkN "skenben" neutrum ;
  skenbild_nn_1 = mkN "skenbild" "skenbilder" ;
  skendoed_av_1 = mkA "skendцd" ;
  skenfaektning_nn_1 = mkN "skenfдktning" ;
  skenfrukt_nn_1 = mkN "skenfrukt" "skenfrukter" ;
  skenhaendelse_nn_1 = mkN "skenhдndelse" "skenhдndelser" ;
  skenhelig_av_1 = mkA "skenhelig" ;
  skenraettegaang_nn_1 = mkN "skenrдttegеng" ;
  skenvaerld_nn_1 = mkN "skenvдrld" ;
  skepnad_nn_1 = mkN "skepnad" "skepnader" ;
  skepp_nn_1 = mkN "skepp" neutrum ;
  skepparbrev_nn_1 = mkN "skepparbrev" neutrum ;
  skeppare_nn_1 = mkN "skeppare" "skeppare" ;
  skepparexamen_nn_1 = mkN "skepparexamen" "skepparexamen" "skepparexamina" "skepparexamina" ;
  skepparhistoria_nn_1 = mkN "skepparhistoria" "skepparhistorien" "skepparhistorier" "skepparhistorierna" ;
  skepparkrans_nn_1 = mkN "skepparkrans" ;
  skeppsapotek_nn_1 = mkN "skeppsapotek" neutrum ;
  skeppsbaat_nn_1 = mkN "skeppsbеt" ;
  skeppsbro_nn_1 = mkN "skeppsbro" ;
  skeppsbrott_nn_1 = mkN "skeppsbrott" neutrum ;
  skeppsbruten_av_1 = mkA "skeppsbruten" "skeppsbrutet" ;
  skeppsbyggeri_nn_1 = mkN "skeppsbyggeri" "skeppsbyggerit" "skeppsbyggerier" "skeppsbyggerierna" ;
  skeppsgosse_nn_1 = mkN "skeppsgosse" utrum ;
  skeppsklarerare_nn_1 = mkN "skeppsklarerare" "skeppsklarerare" ;
  skeppslag_nn_1 = mkN "skeppslag" neutrum ;
  skeppsljus_nn_1 = mkN "skeppsljus" neutrum ;
  skeppsmaeklare_nn_1 = mkN "skeppsmдklare" "skeppsmдklare" ;
  skeppsmask_nn_1 = mkN "skeppsmask" ;
  skeppspojke_nn_1 = mkN "skeppspojke" utrum ;
  skeppsredare_nn_1 = mkN "skeppsredare" "skeppsredare" ;
  skeppssaettning_nn_1 = mkN "skeppssдttning" ;
  skeppsvarv_nn_1 = mkN "skeppsvarv" neutrum ;
  skeppund_nn_1 = mkN "skeppund" neutrum ;
  skeptiker_nn_1 = mkN "skeptiker" "skeptikern" "skeptiker" "skeptikerna" ;
  skeptisk_av_1 = mkA "skeptisk" ;
  sketch_nn_1 = mkN "sketch" "sketcher" ;
  sketen_av_1 = mkA "sketen" "sketet" ;
  skev_av_1 = mkA "skev" ;
  skevningsroder_nn_1 = mkN "skevningsroder" neutrum ;
  skevroder_nn_1 = mkN "skevroder" neutrum ;
  skick_nn_1 = mkN "skick" neutrum ;
  skickebud_nn_1 = mkN "skickebud" neutrum ;
  skickelse_nn_1 = mkN "skickelse" "skickelser" ;
  skickelsediger_av_1 = mkA "skickelsediger" "skickelsedigert" "skickelsedigra" "skickelsedigra" "skickelsedigrare" "skickelsedigrast" "skickelsedigraste" ;
  skicklig_av_1 = mkA "skicklig" ;
  skicklighet_nn_1 = mkN "skicklighet" "skickligheter" ;
  skidaakare_nn_1 = mkN "skidеkare" "skidеkare" ;
  skidbacke_nn_1 = mkN "skidbacke" utrum ;
  skidfynd_nn_1 = mkN "skidfynd" neutrum ;
  skidhoppning_nn_1 = mkN "skidhoppning" ;
  skidlift_nn_1 = mkN "skidlift" ;
  skidloepning_nn_1 = mkN "skidlцpning" ;
  skidspaar_nn_1 = mkN "skidspеr" neutrum ;
  skidstav_nn_1 = mkN "skidstav" ;
  skidtaevling_nn_1 = mkN "skidtдvling" ;
  skidtur_nn_1 = mkN "skidtur" "skidturer" ;
  skidtyp_nn_1 = mkN "skidtyp" "skidtyper" ;
  skiffer_nn_1 = mkN "skiffer" ;
  skiffertak_nn_1 = mkN "skiffertak" neutrum ;
  skiffrig_av_1 = mkA "skiffrig" ;
  skift_nn_1 = mkN "skift" neutrum ;
  skifte_nn_1 = mkN "skifte" ;
  skiftning_nn_1 = mkN "skiftning" ;
  skiftnyckel_nn_1 = mkN "skiftnyckel" ;
  skikt_nn_1 = mkN "skikt" neutrum ;
  skiktmoln_nn_1 = mkN "skiktmoln" neutrum ;
  skild_av_1 = mkA "skild" "skilt" ;
  skildring_nn_1 = mkN "skildring" ;
  skiljaktig_av_1 = mkA "skiljaktig" ;
  skiljaktighet_nn_1 = mkN "skiljaktighet" "skiljaktigheter" ;
  skiljbar_av_1 = mkA "skiljbar" ;
  skiljedom_nn_1 = mkN "skiljedom" ;
  skiljedomstol_nn_1 = mkN "skiljedomstol" ;
  skiljefoerfarande_nn_1 = mkN "skiljefцrfarande" ;
  skiljelinje_nn_1 = mkN "skiljelinje" "skiljelinjer" ;
  skiljeman_nn_1 = mkN "skiljeman" "skiljemannen" "skiljemдn" "skiljemдnnen" ;
  skiljemur_nn_1 = mkN "skiljemur" ;
  skiljemynt_nn_1 = mkN "skiljemynt" neutrum ;
  skiljenaemnd_nn_1 = mkN "skiljenдmnd" "skiljenдmnder" ;
  skiljeset_nn_1 = mkN "skiljeset" neutrum ;
  skiljetecken_nn_1 = mkN "skiljetecken" "skiljetecknet" "skiljetecken" "skiljetecknen" ;
  skiljevaeg_nn_1 = mkN "skiljevдg" ;
  skiljevaegg_nn_1 = mkN "skiljevдgg" ;
  skilling_nn_1 = mkN "skilling" ;
  skillingtryck_nn_1 = mkN "skillingtryck" neutrum ;
  skillnad_nn_1 = mkN "skillnad" "skillnader" ;
  skilsmaessa_nn_1 = mkN "skilsmдssa" ;
  skiltvakt_nn_1 = mkN "skiltvakt" "skiltvakter" ;
  skimmel_nn_1 = mkN "skimmel" "skimmeln" "skimmlar" "skimmlarna" ;
  skingringsfoerbud_nn_1 = mkN "skingringsfцrbud" neutrum ;
  skinhead_nn_1 = mkN "skinhead" "skinheadet" "skinheads" "skinheadsen" ;
  skinn_nn_1 = mkN "skinn" neutrum ;
  skinnare_nn_1 = mkN "skinnare" "skinnare" ;
  skinnbagge_nn_1 = mkN "skinnbagge" utrum ;
  skinnband_nn_1 = mkN "skinnband" neutrum ;
  skinnbit_nn_1 = mkN "skinnbit" ;
  skinnerbur_nn_1 = mkN "skinnerbur" ;
  skinnfaell_nn_1 = mkN "skinnfдll" ;
  skinnflaadd_av_1 = mkA "skinnflеdd" "skinnflеdtt" ;
  skinnimitation_nn_1 = mkN "skinnimitation" "skinnimitationer" ;
  skinnkaelke_nn_1 = mkN "skinnkдlke" utrum ;
  skinnklaedd_av_1 = mkA "skinnklдdd" ;
  skinnknutte_nn_1 = mkN "skinnknutte" utrum ;
  skinnpaj_nn_1 = mkN "skinnpaj" ;
  skinntorr_av_1 = mkA "skinntorr" ;
  skioptikon_nn_1 = mkN "skioptikon" neutrum ;
  skir_av_1 = mkA "skir" ;
  skiss_nn_1 = mkN "skiss" "skisser" ;
  skissblock_nn_1 = mkN "skissblock" neutrum ;
  skit_nn_1 = mkN "skit" ;
  skitbra_av_1 = mkA "skitbra" ;
  skitfoernaem_av_1 = mkA "skitfцrnдm" ;
  skitgubbe_nn_1 = mkN "skitgubbe" utrum ;
  skitig_av_1 = mkA "skitig" ;
  skitkul_av_1 = mkA "skitkul" ;
  skitnoedig_av_1 = mkA "skitnцdig" ;
  skitsnygg_av_1 = mkA "skitsnygg" ;
  skitstoevel_nn_1 = mkN "skitstцvel" ;
  skitviktig_av_1 = mkA "skitviktig" ;
  skivaffaer_nn_1 = mkN "skivaffдr" "skivaffдrer" ;
  skivbar_nn_1 = mkN "skivbar" "skivbarer" ;
  skivbroms_nn_1 = mkN "skivbroms" ;
  skivhus_nn_1 = mkN "skivhus" neutrum ;
  skivig_av_1 = mkA "skivig" ;
  skivling_nn_1 = mkN "skivling" ;
  skivminne_nn_1 = mkN "skivminne" ;
  skivpratare_nn_1 = mkN "skivpratare" "skivpratare" ;
  skivspelare_nn_1 = mkN "skivspelare" "skivspelare" ;
  skivstaang_nn_1 = mkN "skivstеng" "skivstдnger" ;
  skivsvamp_nn_1 = mkN "skivsvamp" ;
  skivtallrik_nn_1 = mkN "skivtallrik" ;
  skjortaerm_nn_1 = mkN "skjortдrm" ;
  skjortblus_nn_1 = mkN "skjortblus" ;
  skjortbroest_nn_1 = mkN "skjortbrцst" neutrum ;
  skjortkrage_nn_1 = mkN "skjortkrage" utrum ;
  skjul_nn_1 = mkN "skjul" neutrum ;
  skjut_nn_1 = mkN "skjut" neutrum ;
  skjuta_vb_1 = mkV "skjuta" "skцt" "skjutit" ;
  skjutdoerr_nn_1 = mkN "skjutdцrr" ;
  skjutfaelt_nn_1 = mkN "skjutfдlt" neutrum ;
  skjutfaerdig_av_1 = mkA "skjutfдrdig" ;
  skjutjaern_nn_1 = mkN "skjutjдrn" neutrum ;
  skjutjaernsintervju_nn_1 = mkN "skjutjдrnsintervju" "skjutjдrnsintervjun" "skjutjдrnsintervjuer" "skjutjдrnsintervjuerna" ;
  skjutjaernsjournalist_nn_1 = mkN "skjutjдrnsjournalist" "skjutjдrnsjournalister" ;
  skjutklar_av_1 = mkA "skjutklar" ;
  skjutmaatt_nn_1 = mkN "skjutmеtt" neutrum ;
  skjutning_nn_1 = mkN "skjutning" ;
  skjutriktning_nn_1 = mkN "skjutriktning" ;
  skjuts_nn_1 = mkN "skjuts" ;
  skjutshaall_nn_1 = mkN "skjutshеll" neutrum ;
  skjutskaare_nn_1 = mkN "skjutskеre" utrum ;
  skjututbildning_nn_1 = mkN "skjututbildning" ;
  skjutvapen_nn_1 = mkN "skjutvapen" "skjutvapnet" "skjutvapen" "skjutvapnen" ;
  skjutvinkel_nn_1 = mkN "skjutvinkel" ;
  skleros_nn_1 = mkN "skleros" "skleroser" ;
  sklerotisk_av_1 = mkA "sklerotisk" ;
  sko_nn_1 = mkN "sko" "skor" ;
  skoblock_nn_1 = mkN "skoblock" neutrum ;
  skoborste_nn_1 = mkN "skoborste" utrum ;
  skock_nn_1 = mkN "skock" ;
  skodon_nn_1 = mkN "skodon" neutrum ;
  skoel_nn_1 = mkN "skцl" ;
  skoeld_nn_1 = mkN "skцld" ;
  skoeldborg_nn_1 = mkN "skцldborg" ;
  skoeldebrev_nn_1 = mkN "skцldebrev" neutrum ;
  skoeldemaerke_nn_1 = mkN "skцldemдrke" ;
  skoeldhaallare_nn_1 = mkN "skцldhеllare" "skцldhеllare" ;
  skoeldkoertel_nn_1 = mkN "skцldkцrtel" ;
  skoeldkoertelcancer_nn_1 = mkN "skцldkцrtelcancer" ;
  skoeldkoertelhormon_nn_1 = mkN "skцldkцrtelhormon" neutrum ;
  skoeldlus_nn_1 = mkN "skцldlus" "skцldlusen" "skцldlцss" "skцldlцssen" ;
  skoeldmoe_nn_1 = mkN "skцldmц" "skцldmцn" "skцldmцr" "skцldmцrna" ;
  skoeljkopp_nn_1 = mkN "skцljkopp" ;
  skoelp_nn_1 = mkN "skцlp" ;
  skoen_av_1 = mkA "skцn" ;
  skoenande_nn_1 = mkN "skцnande" utrum ;
  skoenhet_nn_1 = mkN "skцnhet" "skцnheter" ;
  skoenhetsdrottning_nn_1 = mkN "skцnhetsdrottning" ;
  skoenhetsfel_nn_1 = mkN "skцnhetsfel" "skцnhetsfelet" "skцnhetsfel" "skцnhetsfelen" ;
  skoenhetsflaeck_nn_1 = mkN "skцnhetsflдck" ;
  skoenhetsideal_nn_1 = mkN "skцnhetsideal" neutrum ;
  skoenhetsmedel_nn_1 = mkN "skцnhetsmedel" neutrum ;
  skoenhetspris_nn_1 = mkN "skцnhetspris" neutrum ;
  skoenhetstaevling_nn_1 = mkN "skцnhetstдvling" ;
  skoenhetsupplevelse_nn_1 = mkN "skцnhetsupplevelse" "skцnhetsupplevelser" ;
  skoenhetsvaard_nn_1 = mkN "skцnhetsvеrd" ;
  skoenhetsvaerde_nn_1 = mkN "skцnhetsvдrde" ;
  skoenjbar_av_1 = mkA "skцnjbar" ;
  skoenlitteraer_av_1 = mkA "skцnlitterдr" ;
  skoenlockig_av_1 = mkA "skцnlockig" ;
  skoenskrivare_nn_1 = mkN "skцnskrivare" "skцnskrivare" ;
  skoensmaessig_av_1 = mkA "skцnsmдssig" ;
  skoer_av_1 = mkA "skцr" ;
  skoerd_nn_1 = mkN "skцrd" ;
  skoerdeenhet_nn_1 = mkN "skцrdeenhet" "skцrdeenheter" ;
  skoerdemaanad_nn_1 = mkN "skцrdemеnad" "skцrdemеnader" ;
  skoerdemaskin_nn_1 = mkN "skцrdemaskin" "skцrdemaskiner" ;
  skoerdetid_nn_1 = mkN "skцrdetid" "skцrdetider" ;
  skoerdetroeska_nn_1 = mkN "skцrdetrцska" ;
  skoerdeuppskattning_nn_1 = mkN "skцrdeuppskattning" ;
  skoerlevnad_nn_1 = mkN "skцrlevnad" "skцrlevnader" ;
  skoerpil_nn_1 = mkN "skцrpil" ;
  skoert_nn_1 = mkN "skцrt" neutrum ;
  skoet_nn_1 = mkN "skцt" ;
  skoetare_nn_1 = mkN "skцtare" "skцtare" ;
  skoetbord_nn_1 = mkN "skцtbord" neutrum ;
  skoetebarn_nn_1 = mkN "skцtebarn" neutrum ;
  skoeterska_nn_1 = mkN "skцterska" ;
  skoetesynd_nn_1 = mkN "skцtesynd" "skцtesynder" ;
  skoetrum_nn_1 = mkN "skцtrum" "skцtrummet" "skцtrum" "skцtrummen" ;
  skoetsam_av_1 = mkA "skцtsam" "skцtsamt" "skцtsamma" "skцtsamma" "skцtsammare" "skцtsammast" "skцtsammaste" ;
  skoflickare_nn_1 = mkN "skoflickare" "skoflickare" ;
  skog_nn_1 = mkN "skog" ;
  skogbevuxen_av_1 = mkA "skogbevuxen" "skogbevuxet" ;
  skogfattig_av_1 = mkA "skogfattig" ;
  skogig_av_1 = mkA "skogig" ;
  skogklaedd_av_1 = mkA "skogklдdd" "skogklдdtt" ;
  skoglig_av_1 = mkA "skoglig" ;
  skogsarbetare_nn_1 = mkN "skogsarbetare" "skogsarbetare" ;
  skogsavverkning_nn_1 = mkN "skogsavverkning" ;
  skogsbaeck_nn_1 = mkN "skogsbдck" ;
  skogsbagge_nn_1 = mkN "skogsbagge" utrum ;
  skogsbete_nn_1 = mkN "skogsbete" ;
  skogsbolag_nn_1 = mkN "skogsbolag" neutrum ;
  skogsbrand_nn_1 = mkN "skogsbrand" "skogsbrдnder" ;
  skogsdunge_nn_1 = mkN "skogsdunge" utrum ;
  skogsfaagel_nn_1 = mkN "skogsfеgel" ;
  skogsfoerbaettring_nn_1 = mkN "skogsfцrbдttring" ;
  skogsfoervaltning_nn_1 = mkN "skogsfцrvaltning" ;
  skogsfru_nn_1 = mkN "skogsfru" ;
  skogsgenetiker_nn_1 = mkN "skogsgenetiker" "skogsgenetikern" "skogsgenetiker" "skogsgenetikerna" ;
  skogsgenetisk_av_1 = mkA "skogsgenetisk" ;
  skogsgud_nn_1 = mkN "skogsgud" ;
  skogshoens_nn_1 = mkN "skogshцns" neutrum ;
  skogshuggare_nn_1 = mkN "skogshuggare" "skogshuggare" ;
  skogsindustri_nn_1 = mkN "skogsindustri" "skogsindustrier" ;
  skogskovall_nn_1 = mkN "skogskovall" "skogskovaller" ;
  skogslandskap_nn_1 = mkN "skogslandskap" "skogslandskapet" "skogslandskapen" "skogslandskapena" ;
  skogsmaestare_nn_1 = mkN "skogsmдstare" "skogsmдstare" ;
  skogsmark_nn_1 = mkN "skogsmark" "skogsmarker" ;
  skogsmus_nn_1 = mkN "skogsmus" "skogsmusen" "skogsmцss" "skogsmцssen" ;
  skogsomraade_nn_1 = mkN "skogsomrеde" ;
  skogsraa_nn_1 = mkN "skogsrе" "skogsrеet" "skogsrеr" "skogsrеrna" ;
  skogstomt_nn_1 = mkN "skogstomt" "skogstomter" ;
  skogstraed_nn_1 = mkN "skogstrдd" neutrum ;
  skogstraedsfoeraedlare_nn_1 = mkN "skogstrдdsfцrдdlare" "skogstrдdsfцrдdlare" ;
  skogsvaard_nn_1 = mkN "skogsvеrd" ;
  skogsvaeg_nn_1 = mkN "skogsvдg" ;
  skogsvandring_nn_1 = mkN "skogsvandring" ;
  skogvaktare_nn_1 = mkN "skogvaktare" "skogvaktare" ;
  skohorn_nn_1 = mkN "skohorn" neutrum ;
  skoj_av_1 = mkA "skoj" ;
  skoj_nn_1 = mkN "skoj" neutrum ;
  skojare_nn_1 = mkN "skojare" "skojare" ;
  skojeri_nn_1 = mkN "skojeri" "skojerit" "skojerier" "skojerierna" ;
  skojfrisk_av_1 = mkA "skojfrisk" ;
  skojig_av_1 = mkA "skojig" ;
  skoklaedd_av_1 = mkA "skoklдdd" ;
  skokraem_nn_1 = mkN "skokrдm" "skokrдmer" ;
  skolaar_nn_1 = mkN "skolеr" neutrum ;
  skolaemne_nn_1 = mkN "skolдmne" ;
  skolaest_nn_1 = mkN "skolдst" "skolдster" ;
  skolaest_nn_2 = mkN "skolдst" ;
  skolastiker_nn_1 = mkN "skolastiker" "skolastikern" "skolastiker" "skolastikerna" ;
  skolastisk_av_1 = mkA "skolastisk" ;
  skolavgift_nn_1 = mkN "skolavgift" "skolavgifter" ;
  skolavslutning_nn_1 = mkN "skolavslutning" ;
  skolbaenk_nn_1 = mkN "skolbдnk" ;
  skolbarn_nn_1 = mkN "skolbarn" neutrum ;
  skolbildning_nn_1 = mkN "skolbildning" ;
  skolbok_nn_1 = mkN "skolbok" "skolbцcker" ;
  skolbuss_nn_1 = mkN "skolbuss" ;
  skolchef_nn_1 = mkN "skolchef" "skolchefer" ;
  skoldag_nn_1 = mkN "skoldag" ;
  skoldans_nn_1 = mkN "skoldans" "skoldanser" ;
  skoldirektoer_nn_1 = mkN "skoldirektцr" "skoldirektцrer" ;
  skolelev_nn_1 = mkN "skolelev" "skolelever" ;
  skolexempel_nn_1 = mkN "skolexempel" neutrum ;
  skolfartyg_nn_1 = mkN "skolfartyg" neutrum ;
  skolflygplan_nn_1 = mkN "skolflygplan" neutrum ;
  skolfoervaltning_nn_1 = mkN "skolfцrvaltning" ;
  skolform_nn_1 = mkN "skolform" "skolformer" ;
  skolfroeken_nn_1 = mkN "skolfrцken" ;
  skolfux_nn_1 = mkN "skolfux" ;
  skolgaard_nn_1 = mkN "skolgеrd" ;
  skolgrammatik_nn_1 = mkN "skolgrammatik" "skolgrammatiker" ;
  skolhem_nn_1 = mkN "skolhem" "skolhemmet" "skolhem" "skolhemmen" ;
  skolhus_nn_1 = mkN "skolhus" neutrum ;
  skolinspektoer_nn_1 = mkN "skolinspektцr" "skolinspektцrer" ;
  skolkare_nn_1 = mkN "skolkare" "skolkare" ;
  skolklass_nn_1 = mkN "skolklass" "skolklasser" ;
  skolkoek_nn_1 = mkN "skolkцk" neutrum ;
  skolkort_nn_1 = mkN "skolkort" neutrum ;
  skolledare_nn_1 = mkN "skolledare" "skolledare" ;
  skolljus_nn_1 = mkN "skolljus" neutrum ;
  skollov_nn_1 = mkN "skollov" neutrum ;
  skollunch_nn_1 = mkN "skollunch" "skolluncher" ;
  skolmaaltid_nn_1 = mkN "skolmеltid" "skolmеltider" ;
  skolmaestaraktig_av_1 = mkA "skolmдstaraktig" ;
  skolmaestare_nn_1 = mkN "skolmдstare" "skolmдstare" ;
  skolmagister_nn_1 = mkN "skolmagister" ;
  skolmogen_av_1 = mkA "skolmogen" "skolmoget" ;
  skolmognad_nn_1 = mkN "skolmognad" "skolmognader" ;
  skolmognadsklass_nn_1 = mkN "skolmognadsklass" "skolmognadsklasser" ;
  skolmognadsprov_nn_1 = mkN "skolmognadsprov" neutrum ;
  skolnaemnd_nn_1 = mkN "skolnдmnd" "skolnдmnder" ;
  skolning_nn_1 = mkN "skolning" ;
  skolpolis_nn_1 = mkN "skolpolis" "skolpoliser" ;
  skolprov_nn_1 = mkN "skolprov" neutrum ;
  skolraad_nn_1 = mkN "skolrеd" neutrum ;
  skolridning_nn_1 = mkN "skolridning" ;
  skolsal_nn_1 = mkN "skolsal" ;
  skolsjuk_av_1 = mkA "skolsjuk" ;
  skolskepp_nn_1 = mkN "skolskepp" neutrum ;
  skolskjutning_nn_1 = mkN "skolskjutning" ;
  skolskjuts_nn_1 = mkN "skolskjuts" ;
  skolstyrelse_nn_1 = mkN "skolstyrelse" "skolstyrelser" ;
  skolt_nn_1 = mkN "skolt" "skolter" ;
  skoltroett_av_1 = mkA "skoltrцtt" ;
  skolunderbyggnad_nn_1 = mkN "skolunderbyggnad" "skolunderbyggnader" ;
  skolungdom_nn_1 = mkN "skolungdom" ;
  skolungdomsidrott_nn_1 = mkN "skolungdomsidrott" "skolungdomsidrotter" ;
  skoluppsats_nn_1 = mkN "skoluppsats" "skoluppsatser" ;
  skolutbildning_nn_1 = mkN "skolutbildning" ;
  skolvaeg_nn_1 = mkN "skolvдg" ;
  skolvaesende_nn_1 = mkN "skolvдsende" ;
  skomakare_nn_1 = mkN "skomakare" "skomakare" ;
  skomakarverkstad_nn_1 = mkN "skomakarverkstad" "skomakarverkstдder" ;
  skomakeri_nn_1 = mkN "skomakeri" "skomakerit" "skomakerier" "skomakerierna" ;
  skonare_nn_1 = mkN "skonare" "skonare" ;
  skonert_nn_1 = mkN "skonert" "skonerter" ;
  skonertskepp_nn_1 = mkN "skonertskepp" neutrum ;
  skoning_nn_1 = mkN "skoning" ;
  skoningsloes_av_1 = mkA "skoningslцs" ;
  skonsam_av_1 = mkA "skonsam" "skonsamt" "skonsamma" "skonsamma" "skonsammare" "skonsammast" "skonsammaste" ;
  skonummer_nn_1 = mkN "skonummer" neutrum ;
  skopofil_av_1 = mkA "skopofil" ;
  skopofil_nn_1 = mkN "skopofil" "skopofiler" ;
  skopolamin_nn_1 = mkN "skopolamin" "skopolaminer" ;
  skoputsare_nn_1 = mkN "skoputsare" "skoputsare" ;
  skorpion_nn_1 = mkN "skorpion" "skorpioner" ;
  skorsten_nn_1 = mkN "skorsten" "skorstenen" "skorstenar" "skorstenarna" ;
  skorstensfejare_nn_1 = mkN "skorstensfejare" "skorstensfejare" ;
  skorv_nn_2 = mkN "skorv" ;
  skorvig_av_1 = mkA "skorvig" ;
  skosmoerja_nn_1 = mkN "skosmцrja" ;
  skot_nn_1 = mkN "skot" neutrum ;
  skoter_nn_1 = mkN "skoter" ;
  skothorn_nn_1 = mkN "skothorn" neutrum ;
  skotsk_av_1 = mkA "skotsk" ;
  skotska_nn_2 = mkN "skotska" ;
  skotskrutig_av_1 = mkA "skotskrutig" ;
  skotstek_nn_1 = mkN "skotstek" neutrum ;
  skott_nn_1 = mkN "skott" neutrum ;
  skottaar_nn_1 = mkN "skottеr" neutrum ;
  skottavla_nn_1 = mkN "skottavla" ;
  skottdag_nn_1 = mkN "skottdag" ;
  skotte_nn_1 = mkN "skotte" utrum ;
  skottfaelt_nn_1 = mkN "skottfдlt" neutrum ;
  skottglugg_nn_1 = mkN "skottglugg" ;
  skottlinje_nn_1 = mkN "skottlinje" "skottlinjer" ;
  skottpeng_nn_1 = mkN "skottpeng" ;
  skottsaeker_av_1 = mkA "skottsдker" "skottsдkert" "skottsдkra" "skottsдkra" "skottsдkrare" "skottsдkrast" "skottsдkraste" ;
  skottsekund_nn_1 = mkN "skottsekund" "skottsekunder" ;
  skottskog_nn_1 = mkN "skottskog" ;
  skottspole_nn_1 = mkN "skottspole" utrum ;
  skov_nn_1 = mkN "skov" neutrum ;
  skovel_nn_1 = mkN "skovel" ;
  skovelhjul_nn_1 = mkN "skovelhjul" neutrum ;
  skraa_av_1 = mkA "skrе" "skrеtt" ;
  skraa_nn_1 = mkN "skrе" "skrеt" "skrеn" "skrеen" ;
  skraal_nn_1 = mkN "skrеl" neutrum ;
  skraapuk_nn_1 = mkN "skrеpuk" ;
  skrabbig_av_1 = mkA "skrabbig" ;
  skraeckexempel_nn_1 = mkN "skrдckexempel" neutrum ;
  skraeckfilm_nn_1 = mkN "skrдckfilm" "skrдckfilmer" ;
  skraeckinjagande_av_1 = mkA "skrдckinjagande" ;
  skraeckkabinett_nn_1 = mkN "skrдckkabinett" neutrum ;
  skraecknovell_nn_1 = mkN "skrдcknovell" "skrдcknoveller" ;
  skraeckslagen_av_1 = mkA "skrдckslagen" "skrдckslaget" ;
  skraecksyn_nn_1 = mkN "skrдcksyn" "skrдcksyner" ;
  skraeckvision_nn_1 = mkN "skrдckvision" "skrдckvisioner" ;
  skraeddare_nn_1 = mkN "skrдddare" "skrдddare" ;
  skraedderi_nn_1 = mkN "skrдdderi" "skrдdderit" "skrдdderier" "skrдdderierna" ;
  skraell_nn_1 = mkN "skrдll" ;
  skraelldus_nn_1 = mkN "skrдlldus" "skrдllduser" ;
  skraellig_av_1 = mkA "skrдllig" ;
  skraemmande_av_1 = mkA "skrдmmande" ;
  skraemskott_nn_1 = mkN "skrдmskott" neutrum ;
  skraen_nn_1 = mkN "skrдn" neutrum ;
  skraenfock_nn_1 = mkN "skrдnfock" ;
  skraenig_av_1 = mkA "skrдnig" ;
  skraepig_av_1 = mkA "skrдpig" ;
  skraepkultur_nn_1 = mkN "skrдpkultur" "skrдpkulturer" ;
  skraevlare_nn_1 = mkN "skrдvlare" "skrдvlare" ;
  skraevlig_av_1 = mkA "skrдvlig" ;
  skraj_av_1 = mkA "skraj" ;
  skrajsen_av_1 = mkA "skrajsen" "skrajset" ;
  skrak_nn_1 = mkN "skrak" ;
  skrake_nn_1 = mkN "skrake" utrum ;
  skral_av_1 = mkA "skral" ;
  skraltig_av_1 = mkA "skraltig" ;
  skramla_nn_1 = mkN "skramla" ;
  skramlig_av_1 = mkA "skramlig" ;
  skranglig_av_1 = mkA "skranglig" ;
  skrank_nn_1 = mkN "skrank" neutrum ;
  skrapning_nn_1 = mkN "skrapning" ;
  skratt_nn_1 = mkN "skratt" neutrum ;
  skrattare_nn_1 = mkN "skrattare" "skrattare" ;
  skrattgrop_nn_1 = mkN "skrattgrop" ;
  skrattlysten_av_1 = mkA "skrattlysten" "skrattlystet" ;
  skrattmaas_nn_1 = mkN "skrattmеs" ;
  skrattretande_av_1 = mkA "skrattretande" ;
  skrattspegel_nn_1 = mkN "skrattspegel" ;
  skred_nn_1 = mkN "skred" neutrum ;
  skrev_nn_1 = mkN "skrev" neutrum ;
  skri_nn_1 = mkN "skri" "skrit" "skrin" "skrien" ;
  skriande_av_1 = mkA "skriande" ;
  skribent_nn_1 = mkN "skribent" "skribenter" ;
  skrida_vb_1 = mkV "skrida" "skred" "skridit" ;
  skridsko_nn_1 = mkN "skridsko" "skridskor" ;
  skridskoaakare_nn_1 = mkN "skridskoеkare" "skridskoеkare" ;
  skrift_nn_1 = mkN "skrift" "skrifter" ;
  skriftbild_nn_1 = mkN "skriftbild" "skriftbilder" ;
  skriftermaal_nn_1 = mkN "skriftermеl" neutrum ;
  skriftlig_av_1 = mkA "skriftlig" ;
  skriftligen_ab_1 = mkAdv "skriftligen" ;
  skriftspraak_nn_1 = mkN "skriftsprеk" neutrum ;
  skriftspraaklig_av_1 = mkA "skriftsprеklig" ;
  skriftstaellare_nn_1 = mkN "skriftstдllare" "skriftstдllare" ;
  skriftstaelleri_nn_1 = mkN "skriftstдlleri" "skriftstдllerit" "skriftstдllerier" "skriftstдllerierna" ;
  skriftsystem_nn_1 = mkN "skriftsystem" neutrum ;
  skrik_nn_1 = mkN "skrik" neutrum ;
  skrikhals_nn_1 = mkN "skrikhals" ;
  skrikig_av_1 = mkA "skrikig" ;
  skrin_nn_1 = mkN "skrin" neutrum ;
  skrinnare_nn_1 = mkN "skrinnare" "skrinnare" ;
  skriptum_nn_1 = mkN "skriptum" neutrum ;
  skriva_vb_1 = mkV "skriva" "skrev" "skrivit" ;
  skrivare_nn_1 = mkN "skrivare" "skrivare" ;
  skrivblock_nn_1 = mkN "skrivblock" neutrum ;
  skrivbok_nn_1 = mkN "skrivbok" "skrivbцcker" ;
  skrivbord_nn_1 = mkN "skrivbord" neutrum ;
  skrivbyraa_nn_1 = mkN "skrivbyrе" "skrivbyrеer" ;
  skrivelse_nn_1 = mkN "skrivelse" "skrivelser" ;
  skriveri_nn_1 = mkN "skriveri" "skriverit" "skriverier" "skriverierna" ;
  skrivkunnig_av_1 = mkA "skrivkunnig" ;
  skrivmaskin_nn_1 = mkN "skrivmaskin" "skrivmaskiner" ;
  skrivmaskinsbord_nn_1 = mkN "skrivmaskinsbord" neutrum ;
  skrivmaskinsstol_nn_1 = mkN "skrivmaskinsstol" ;
  skrivmaskinstangent_nn_1 = mkN "skrivmaskinstangent" "skrivmaskinstangenter" ;
  skrivning_nn_1 = mkN "skrivning" ;
  skrivoevning_nn_1 = mkN "skrivцvning" ;
  skrivplaan_nn_1 = mkN "skrivplеn" neutrum ;
  skrivplats_nn_1 = mkN "skrivplats" "skrivplatser" ;
  skrivstil_nn_1 = mkN "skrivstil" ;
  skrivtavla_nn_1 = mkN "skrivtavla" ;
  skrivtecken_nn_1 = mkN "skrivtecken" "skrivtecknet" "skrivtecken" "skrivtecknen" ;
  skrodoer_nn_1 = mkN "skrodцr" "skrodцrer" ;
  skroeplig_av_1 = mkA "skrцplig" ;
  skrofuloes_av_1 = mkA "skrofulцs" ;
  skrotbil_nn_1 = mkN "skrotbil" ;
  skrothoeg_nn_1 = mkN "skrothцg" ;
  skrotskulptur_nn_1 = mkN "skrotskulptur" "skrotskulpturer" ;
  skrott_nn_1 = mkN "skrott" ;
  skrotupplag_nn_1 = mkN "skrotupplag" neutrum ;
  skrov_nn_1 = mkN "skrov" neutrum ;
  skrovlig_av_1 = mkA "skrovlig" ;
  skrovmaal_nn_1 = mkN "skrovmеl" neutrum ;
  skrubb_nn_1 = mkN "skrubb" ;
  skrubbsaar_nn_1 = mkN "skrubbsеr" neutrum ;
  skrud_nn_1 = mkN "skrud" ;
  skrumpen_av_1 = mkA "skrumpen" "skrumpet" ;
  skrupel_nn_1 = mkN "skrupel" "skrupeln" "skrupler" "skruplerna" ;
  skrupelfri_av_1 = mkA "skrupelfri" "skrupelfritt" ;
  skrupuloes_av_1 = mkA "skrupulцs" ;
  skrutt_nn_2 = mkN "skrutt" ;
  skruttig_av_1 = mkA "skruttig" ;
  skruv_nn_1 = mkN "skruv" ;
  skruvmejsel_nn_1 = mkN "skruvmejsel" ;
  skruvnyckel_nn_1 = mkN "skruvnyckel" ;
  skruvstaed_nn_1 = mkN "skruvstдd" neutrum ;
  skruvtving_nn_1 = mkN "skruvtving" ;
  skrymmande_av_1 = mkA "skrymmande" ;
  skrymt_nn_1 = mkN "skrymt" neutrum ;
  skrymtare_nn_1 = mkN "skrymtare" "skrymtare" ;
  skrymteri_nn_1 = mkN "skrymteri" "skrymterit" "skrymterier" "skrymterierna" ;
  skrynkelfri_av_1 = mkA "skrynkelfri" "skrynkelfritt" ;
  skrynkelhaerdig_av_1 = mkA "skrynkelhдrdig" ;
  skrynkla_nn_1 = mkN "skrynkla" ;
  skrynklig_av_1 = mkA "skrynklig" ;
  skrytmaans_nn_1 = mkN "skrytmеns" ;
  skrytsam_av_1 = mkA "skrytsam" "skrytsamt" "skrytsamma" "skrytsamma" "skrytsammare" "skrytsammast" "skrytsammaste" ;
  skubb_nn_1 = mkN "skubb" neutrum ;
  skuff_nn_1 = mkN "skuff" ;
  skuggbild_nn_1 = mkN "skuggbild" "skuggbilder" ;
  skuggig_av_1 = mkA "skuggig" ;
  skuggindustri_nn_1 = mkN "skuggindustri" "skuggindustrier" ;
  skuggkabinett_nn_1 = mkN "skuggkabinett" neutrum ;
  skuggloesning_nn_1 = mkN "skugglцsning" ;
  skuggregering_nn_1 = mkN "skuggregering" ;
  skuggsida_nn_1 = mkN "skuggsida" ;
  skuggspelsteater_nn_1 = mkN "skuggspelsteater" ;
  skuld_nn_1 = mkN "skuld" "skulder" ;
  skuldebrev_nn_1 = mkN "skuldebrev" neutrum ;
  skulderblad_nn_1 = mkN "skulderblad" neutrum ;
  skulderled_nn_1 = mkN "skulderled" "skulderleder" ;
  skuldfoerbindelse_nn_1 = mkN "skuldfцrbindelse" "skuldfцrbindelser" ;
  skuldkaensla_nn_1 = mkN "skuldkдnsla" ;
  skuldmedveten_av_1 = mkA "skuldmedveten" "skuldmedvetet" ;
  skuldra_nn_1 = mkN "skuldra" ;
  skuldsatt_av_1 = mkA "skuldsatt" ;
  skulle_nn_1 = mkN "skulle" utrum ;
  skulptoer_nn_1 = mkN "skulptцr" "skulptцrer" ;
  skulptris_nn_1 = mkN "skulptris" "skulptriser" ;
  skulptur_nn_1 = mkN "skulptur" "skulpturer" ;
  skulptural_av_1 = mkA "skulptural" ;
  skult_nn_1 = mkN "skult" ;
  skum_av_1 = mkA "skum" "skumt" "skumma" "skumma" "skummare" "skummast" "skummaste" ;
  skumbad_nn_1 = mkN "skumbad" neutrum ;
  skumbubbla_nn_1 = mkN "skumbubbla" ;
  skummig_av_1 = mkA "skummig" ;
  skummis_nn_1 = mkN "skummis" ;
  skumoegd_av_1 = mkA "skumцgd" "skumцgt" ;
  skumpig_av_1 = mkA "skumpig" ;
  skumraskaffaer_nn_1 = mkN "skumraskaffдr" "skumraskaffдrer" ;
  skumslaeckare_nn_1 = mkN "skumslдckare" "skumslдckare" ;
  skumtvaettning_nn_1 = mkN "skumtvдttning" ;
  skunk_nn_1 = mkN "skunk" ;
  skunkdjur_nn_1 = mkN "skunkdjur" neutrum ;
  skur_nn_1 = mkN "skur" ;
  skurborste_nn_1 = mkN "skurborste" utrum ;
  skurduk_nn_1 = mkN "skurduk" ;
  skurgolv_nn_1 = mkN "skurgolv" neutrum ;
  skurhink_nn_1 = mkN "skurhink" ;
  skurk_nn_1 = mkN "skurk" ;
  skurkstreck_nn_1 = mkN "skurkstreck" neutrum ;
  skurlov_nn_1 = mkN "skurlov" neutrum ;
  skurpulver_nn_1 = mkN "skurpulver" neutrum ;
  skurril_av_1 = mkA "skurril" ;
  skutt_nn_1 = mkN "skutt" neutrum ;
  skvader_nn_1 = mkN "skvader" ;
  skvadron_nn_1 = mkN "skvadron" "skvadroner" ;
  skvaett_nn_1 = mkN "skvдtt" ;
  skvaetta_vb_1 = mkV "skvдtta" "skvдtter" "skvдtt" "skvatt" "skvдtt" "skvдttad" ;
  skvalbank_nn_1 = mkN "skvalbank" ;
  skvalleraktig_av_1 = mkA "skvalleraktig" ;
  skvallerbaer_nn_1 = mkN "skvallerbдr" neutrum ;
  skvallermoster_nn_1 = mkN "skvallermoster" ;
  skvallerspalt_nn_1 = mkN "skvallerspalt" "skvallerspalter" ;
  skvallerspegel_nn_1 = mkN "skvallerspegel" ;
  skvallertant_nn_1 = mkN "skvallertant" "skvallertanter" ;
  skvallertaska_nn_1 = mkN "skvallertaska" ;
  skvallrig_av_1 = mkA "skvallrig" ;
  skvalpig_av_1 = mkA "skvalpig" ;
  skvaltkvarn_nn_1 = mkN "skvaltkvarn" ;
  skvaltorre_nn_1 = mkN "skvaltorre" utrum ;
  skvatt_ab_1 = mkAdv "skvatt" ;
  skvis_nn_1 = mkN "skvis" ;
  sky_nn_1 = mkN "sky" "skyn" "skyar" "skyarna" ;
  skydd_nn_1 = mkN "skydd" neutrum ;
  skyddsaengel_nn_1 = mkN "skyddsдngel" ;
  skyddsande_nn_1 = mkN "skyddsande" utrum ;
  skyddsdraekt_nn_1 = mkN "skyddsdrдkt" "skyddsdrдkter" ;
  skyddsduk_nn_1 = mkN "skyddsduk" ;
  skyddsfaerg_nn_1 = mkN "skyddsfдrg" "skyddsfдrger" ;
  skyddsgrav_nn_1 = mkN "skyddsgrav" ;
  skyddshelgon_nn_1 = mkN "skyddshelgon" neutrum ;
  skyddskonsulent_nn_1 = mkN "skyddskonsulent" "skyddskonsulenter" ;
  skyddskropp_nn_1 = mkN "skyddskropp" ;
  skyddsling_nn_1 = mkN "skyddsling" ;
  skyddsloes_av_1 = mkA "skyddslцs" ;
  skyddsmask_nn_1 = mkN "skyddsmask" "skyddsmasker" ;
  skyddsmedel_nn_1 = mkN "skyddsmedel" neutrum ;
  skyddsmur_nn_1 = mkN "skyddsmur" ;
  skyddsombud_nn_1 = mkN "skyddsombud" neutrum ;
  skyddsomraade_nn_1 = mkN "skyddsomrеde" ;
  skyddspatron_nn_1 = mkN "skyddspatron" "skyddspatroner" ;
  skyddsrock_nn_1 = mkN "skyddsrock" ;
  skyddsrum_nn_1 = mkN "skyddsrum" "skyddsrummet" "skyddsrum" "skyddsrummen" ;
  skyddsstat_nn_1 = mkN "skyddsstat" "skyddsstater" ;
  skyddstak_nn_1 = mkN "skyddstak" neutrum ;
  skyddstull_nn_1 = mkN "skyddstull" ;
  skydrag_nn_1 = mkN "skydrag" neutrum ;
  skyeterrier_nn_1 = mkN "skyeterrier" "skyeterriern" "skyeterrier" "skyeterrierna" ;
  skyfall_nn_1 = mkN "skyfall" neutrum ;
  skyffel_nn_1 = mkN "skyffel" ;
  skygg_av_1 = mkA "skygg" ;
  skygglapp_nn_1 = mkN "skygglapp" ;
  skyhoeg_av_1 = mkA "skyhцg" ;
  skyig_av_1 = mkA "skyig" ;
  skyl_nn_1 = mkN "skyl" ;
  skyld_av_1 = mkA "skyld" "skylt" ;
  skyldig_av_1 = mkA "skyldig" ;
  skyldighet_nn_1 = mkN "skyldighet" "skyldigheter" ;
  skylight_nn_1 = mkN "skylight" neutrum ;
  skyllerkur_nn_1 = mkN "skyllerkur" ;
  skylt_nn_1 = mkN "skylt" ;
  skyltfoenster_nn_1 = mkN "skyltfцnster" neutrum ;
  skyltning_nn_1 = mkN "skyltning" ;
  skyltskaap_nn_1 = mkN "skyltskеp" neutrum ;
  skyltsoendag_nn_1 = mkN "skyltsцndag" ;
  skymf_nn_1 = mkN "skymf" "skymfer" ;
  skymflig_av_1 = mkA "skymflig" ;
  skymford_nn_1 = mkN "skymford" neutrum ;
  skymmel_nn_2 = mkN "skymmel" "skymmeln" "skymmlar" "skymmlarna" ;
  skymning_nn_1 = mkN "skymning" ;
  skymt_nn_1 = mkN "skymt" ;
  skyndsam_av_1 = mkA "skyndsam" "skyndsamt" "skyndsamma" "skyndsamma" "skyndsammare" "skyndsammast" "skyndsammaste" ;
  skyt_nn_1 = mkN "skyt" "skyter" ;
  skytt_nn_1 = mkN "skytt" ;
  skyttegrav_nn_1 = mkN "skyttegrav" ;
  skyttegravskrig_nn_1 = mkN "skyttegravskrig" neutrum ;
  skyttegrop_nn_1 = mkN "skyttegrop" ;
  skyttegrupp_nn_1 = mkN "skyttegrupp" "skyttegrupper" ;
  skyttel_nn_1 = mkN "skyttel" ;
  skyttelinje_nn_1 = mkN "skyttelinje" "skyttelinjer" ;
  skyttevaern_nn_1 = mkN "skyttevдrn" neutrum ;
  slaa_nn_1 = mkN "slе" ;
  slaaende_av_1 = mkA "slеende" ;
  slaanbaer_nn_1 = mkN "slеnbдr" neutrum ;
  slaanbaersbuske_nn_1 = mkN "slеnbдrsbuske" utrum ;
  slaatter_nn_1 = mkN "slеtter" ;
  slaatteraeng_nn_1 = mkN "slеtterдng" ;
  slaatterkniv_nn_1 = mkN "slеtterkniv" ;
  slaattermaskin_nn_1 = mkN "slеttermaskin" "slеttermaskiner" ;
  slaattermyr_nn_1 = mkN "slеttermyr" ;
  slabb_av_1 = mkA "slabb" ;
  slabbig_av_1 = mkA "slabbig" ;
  slack_av_1 = mkA "slack" ;
  sladd_nn_1 = mkN "sladd" ;
  sladdbarn_nn_1 = mkN "sladdbarn" neutrum ;
  sladdig_av_1 = mkA "sladdig" ;
  sladdrig_av_1 = mkA "sladdrig" ;
  slaeddon_nn_1 = mkN "slдddon" neutrum ;
  slaede_nn_1 = mkN "slдde" utrum ;
  slaedhund_nn_1 = mkN "slдdhund" ;
  slaedmed_nn_1 = mkN "slдdmed" ;
  slaedparti_nn_1 = mkN "slдdparti" "slдdpartit" "slдdpartier" "slдdpartierna" ;
  slaegghammare_nn_1 = mkN "slдgghammare" "slдgghammaren" "slдgghamrar" "slдgghamrarna" ;
  slaekt_av_1 = mkA "slдkt" ;
  slaekt_nn_1 = mkN "slдkt" "slдkter" ;
  slaektdrag_nn_1 = mkN "slдktdrag" neutrum ;
  slaektdrift_nn_1 = mkN "slдktdrift" "slдktdrifter" ;
  slaekthistoria_nn_1 = mkN "slдkthistoria" "slдkthistorien" "slдkthistorier" "slдkthistorierna" ;
  slaekting_nn_1 = mkN "slдkting" ;
  slaektled_nn_1 = mkN "slдktled" neutrum ;
  slaektledning_nn_1 = mkN "slдktledning" ;
  slaektlinje_nn_1 = mkN "slдktlinje" "slдktlinjer" ;
  slaektnamn_nn_1 = mkN "slдktnamn" neutrum ;
  slaektportraett_nn_1 = mkN "slдktportrдtt" neutrum ;
  slaektregister_nn_1 = mkN "slдktregister" neutrum ;
  slaektsaga_nn_1 = mkN "slдktsaga" ;
  slaektskapsfoerhaallande_nn_1 = mkN "slдktskapsfцrhеllande" ;
  slaekttraed_nn_1 = mkN "slдkttrдd" neutrum ;
  slaendlarv_nn_1 = mkN "slдndlarv" "slдndlarver" ;
  slaeng_nn_1 = mkN "slдng" ;
  slaengd_av_1 = mkA "slдngd" "slдngt" ;
  slaengig_av_1 = mkA "slдngig" ;
  slaengkaelke_nn_1 = mkN "slдngkдlke" utrum ;
  slaengkyss_nn_1 = mkN "slдngkyss" ;
  slaengpolska_nn_1 = mkN "slдngpolska" ;
  slaengskott_nn_1 = mkN "slдngskott" neutrum ;
  slaent_nn_1 = mkN "slдnt" "slдnter" ;
  slaep_nn_1 = mkN "slдp" neutrum ;
  slaepig_av_1 = mkA "slдpig" ;
  slaepkontakt_nn_1 = mkN "slдpkontakt" "slдpkontakter" ;
  slaeplift_nn_1 = mkN "slдplift" ;
  slaeplogg_nn_1 = mkN "slдplogg" ;
  slaepnot_nn_1 = mkN "slдpnot" ;
  slaepp_nn_1 = mkN "slдpp" neutrum ;
  slaepphaent_av_1 = mkA "slдpphдnt" "slдpphдnt" ;
  slaepring_nn_1 = mkN "slдpring" ;
  slaepsam_av_1 = mkA "slдpsam" "slдpsamt" "slдpsamma" "slдpsamma" "slдpsammare" "slдpsammast" "slдpsammaste" ;
  slaepsko_nn_1 = mkN "slдpsko" "slдpskor" ;
  slaepvad_nn_1 = mkN "slдpvad" ;
  slaepvagn_nn_1 = mkN "slдpvagn" ;
  slaet_av_1 = mkA "slдt" ;
  slaetfog_nn_1 = mkN "slдtfog" ;
  slaethaarig_av_1 = mkA "slдthеrig" ;
  slaetharv_nn_1 = mkN "slдtharv" ;
  slaetprick_nn_1 = mkN "slдtprick" ;
  slaetstruken_av_1 = mkA "slдtstruken" "slдtstruket" ;
  slaetsvamp_nn_1 = mkN "slдtsvamp" ;
  slaett_nn_1 = mkN "slдtt" "slдtter" ;
  slaettbygd_nn_1 = mkN "slдttbygd" "slдttbygder" ;
  slaettmark_nn_1 = mkN "slдttmark" "slдttmarker" ;
  slaetvar_nn_1 = mkN "slдtvar" ;
  slaf_nn_1 = mkN "slaf" ;
  slafs_nn_1 = mkN "slafs" ;
  slafsig_av_1 = mkA "slafsig" ;
  slag_nn_1 = mkN "slag" neutrum ;
  slaganfall_nn_1 = mkN "slaganfall" neutrum ;
  slagbjoern_nn_1 = mkN "slagbjцrn" ;
  slagbom_nn_1 = mkN "slagbom" "slagbommen" "slagbommar" "slagbommarna" ;
  slagbord_nn_1 = mkN "slagbord" neutrum ;
  slagborr_nn_1 = mkN "slagborr" ;
  slagfaelt_nn_1 = mkN "slagfдlt" neutrum ;
  slagfaerdig_av_1 = mkA "slagfдrdig" ;
  slagg_nn_1 = mkN "slagg" "slagger" ;
  slaggig_av_1 = mkA "slaggig" ;
  slaggmaengd_nn_1 = mkN "slaggmдngd" "slaggmдngder" ;
  slaghoek_nn_1 = mkN "slaghцk" ;
  slaginstrument_nn_1 = mkN "slaginstrument" neutrum ;
  slagkraftig_av_1 = mkA "slagkraftig" ;
  slaglaengd_nn_1 = mkN "slaglдngd" "slaglдngder" ;
  slagmask_nn_1 = mkN "slagmask" "slagmasker" ;
  slagnummer_nn_1 = mkN "slagnummer" neutrum ;
  slagord_nn_1 = mkN "slagord" neutrum ;
  slagordning_nn_1 = mkN "slagordning" ;
  slagpaase_nn_1 = mkN "slagpеse" utrum ;
  slagregn_nn_1 = mkN "slagregn" neutrum ;
  slagroerd_av_1 = mkA "slagrцrd" "slagrцrt" ;
  slags_av_1 = mkA "slags" ;
  slagseghet_nn_1 = mkN "slagseghet" "slagsegheter" ;
  slagskaempe_nn_1 = mkN "slagskдmpe" utrum ;
  slagskepp_nn_1 = mkN "slagskepp" neutrum ;
  slagsmaal_nn_1 = mkN "slagsmеl" neutrum ;
  slagsvaerd_nn_1 = mkN "slagsvдrd" neutrum ;
  slagtaalig_av_1 = mkA "slagtеlig" ;
  slagtrae_nn_1 = mkN "slagtrд" "slagtrдet" "slagtrдn" "slagtrдna" ;
  slagvaexling_nn_1 = mkN "slagvдxling" ;
  slagvapen_nn_1 = mkN "slagvapen" "slagvapnet" "slagvapen" "slagvapnen" ;
  slagverk_nn_1 = mkN "slagverk" neutrum ;
  slak_av_1 = mkA "slak" ;
  slakt_nn_1 = mkN "slakt" "slakter" ;
  slaktare_nn_1 = mkN "slaktare" "slaktare" ;
  slaktdjur_nn_1 = mkN "slaktdjur" neutrum ;
  slakteri_nn_1 = mkN "slakteri" "slakterit" "slakterier" "slakterierna" ;
  slakthus_nn_1 = mkN "slakthus" neutrum ;
  slaktmaanad_nn_1 = mkN "slaktmеnad" "slaktmеnader" ;
  slaktmask_nn_1 = mkN "slaktmask" "slaktmasker" ;
  slaktoffer_nn_1 = mkN "slaktoffer" neutrum ;
  slalomaakare_nn_1 = mkN "slalomеkare" "slalomеkare" ;
  slam_nn_2 = mkN "slam" "slammen" "slammar" "slammarna" ;
  slamkrypare_nn_1 = mkN "slamkrypare" "slamkrypare" ;
  slammig_av_1 = mkA "slammig" ;
  slampig_av_1 = mkA "slampig" ;
  slamsig_av_1 = mkA "slamsig" ;
  slamsugning_nn_1 = mkN "slamsugning" ;
  slamsugningsbil_nn_1 = mkN "slamsugningsbil" ;
  slang_nn_1 = mkN "slang" ;
  slangbaage_nn_1 = mkN "slangbеge" utrum ;
  slangkoppling_nn_1 = mkN "slangkoppling" ;
  slangloes_av_1 = mkA "slanglцs" ;
  slank_av_1 = mkA "slank" ;
  slankig_av_1 = mkA "slankig" ;
  slant_nn_1 = mkN "slant" ;
  slantspoe_nn_1 = mkN "slantspц" "slantspцt" "slantspцn" "slantspцna" ;
  slapp_av_1 = mkA "slapp" ;
  slapphaent_av_1 = mkA "slapphдnt" "slapphдnt" ;
  slarver_nn_1 = mkN "slarver" ;
  slarvfel_nn_1 = mkN "slarvfel" "slarvfelet" "slarvfel" "slarvfelen" ;
  slarvig_av_1 = mkA "slarvig" ;
  slas_nn_1 = mkN "slas" ;
  slase_nn_1 = mkN "slase" utrum ;
  slashas_nn_1 = mkN "slashas" ;
  slask_nn_2 = mkN "slask" ;
  slaskig_av_1 = mkA "slaskig" ;
  slaskspalt_nn_1 = mkN "slaskspalt" "slaskspalter" ;
  slasktratt_nn_1 = mkN "slasktratt" ;
  slaskvatten_nn_1 = mkN "slaskvatten" "slaskvattnet" "slaskvatten" "slaskvattnen" ;
  slatt_nn_1 = mkN "slatt" ;
  slattrig_av_1 = mkA "slattrig" ;
  slav_nn_1 = mkN "slav" ;
  slav_nn_2 = mkN "slav" "slaver" ;
  slavdrivare_nn_1 = mkN "slavdrivare" "slavdrivare" ;
  slavhus_nn_1 = mkN "slavhus" neutrum ;
  slavinna_nn_1 = mkN "slavinna" ;
  slavisk_av_1 = mkA "slavisk" ;
  slavism_nn_1 = mkN "slavism" "slavismer" ;
  slavist_nn_1 = mkN "slavist" "slavister" ;
  slavofil_av_1 = mkA "slavofil" ;
  slavsaendare_nn_1 = mkN "slavsдndare" "slavsдndare" ;
  slavstation_nn_1 = mkN "slavstation" "slavstationer" ;
  slavuppror_nn_1 = mkN "slavuppror" neutrum ;
  slejf_nn_1 = mkN "slejf" ;
  slejs_nn_1 = mkN "slejs" ;
  slem_av_1 = mkA "slem" "slemt" "slemma" "slemma" "slemmare" "slemmast" "slemmaste" ;
  slemhinna_nn_1 = mkN "slemhinna" ;
  slemloesande_av_1 = mkA "slemlцsande" ;
  slemmig_av_1 = mkA "slemmig" ;
  slemsaeck_nn_1 = mkN "slemsдck" ;
  slemsvamp_nn_1 = mkN "slemsvamp" ;
  slev_nn_1 = mkN "slev" ;
  slibbig_av_1 = mkA "slibbig" ;
  slice_nn_1 = mkN "slice" utrum ;
  slick_nn_1 = mkN "slick" ;
  slickepinne_nn_1 = mkN "slickepinne" utrum ;
  slickepott_nn_1 = mkN "slickepott" ;
  slicksten_nn_1 = mkN "slicksten" "slickstenen" "slickstenar" "slickstenarna" ;
  slid_nn_1 = mkN "slid" "slider" ;
  sliddrig_av_1 = mkA "sliddrig" ;
  slidhornsdjur_nn_1 = mkN "slidhornsdjur" neutrum ;
  slidkniv_nn_1 = mkN "slidkniv" ;
  slidmotor_nn_1 = mkN "slidmotor" "slidmotorer" ;
  slinder_nn_1 = mkN "slinder" neutrum ;
  sling_nn_1 = mkN "sling" neutrum ;
  slingerbord_nn_1 = mkN "slingerbord" neutrum ;
  slingerbult_nn_1 = mkN "slingerbult" ;
  slingerkoel_nn_1 = mkN "slingerkцl" ;
  slingerkoj_nn_1 = mkN "slingerkoj" "slingerkojer" ;
  slingerskott_nn_1 = mkN "slingerskott" neutrum ;
  slingervaext_nn_1 = mkN "slingervдxt" "slingervдxter" ;
  slingrig_av_1 = mkA "slingrig" ;
  slinkig_av_1 = mkA "slinkig" ;
  slinkled_nn_1 = mkN "slinkled" "slinkleder" ;
  slint_ab_1 = mkAdv "slint" ;
  slip_nn_1 = mkN "slip" ;
  sliper_nn_1 = mkN "sliper" ;
  sliperi_nn_1 = mkN "sliperi" "sliperit" "sliperier" "sliperierna" ;
  slipmaskin_nn_1 = mkN "slipmaskin" "slipmaskiner" ;
  slipmedel_nn_1 = mkN "slipmedel" neutrum ;
  slipover_nn_1 = mkN "slipover" ;
  slipprig_av_1 = mkA "slipprig" ;
  slipprighet_nn_1 = mkN "slipprighet" "slipprigheter" ;
  slipprov_nn_1 = mkN "slipprov" neutrum ;
  slips_nn_1 = mkN "slips" ;
  slipsknut_nn_1 = mkN "slipsknut" ;
  slipsnitt_nn_1 = mkN "slipsnitt" neutrum ;
  slipsten_nn_1 = mkN "slipsten" "slipstenen" "slipstenar" "slipstenarna" ;
  slirig_av_1 = mkA "slirig" ;
  slirskydd_nn_1 = mkN "slirskydd" neutrum ;
  sliskig_av_1 = mkA "sliskig" ;
  slita_vb_1 = mkV "slita" "slet" "slitit" ;
  sliten_av_1 = mkA "sliten" "slitet" ;
  slitig_av_1 = mkA "slitig" ;
  slitning_nn_1 = mkN "slitning" ;
  slits_nn_1 = mkN "slits" ;
  slitsam_av_1 = mkA "slitsam" "slitsamt" "slitsamma" "slitsamma" "slitsammare" "slitsammast" "slitsammaste" ;
  slitskydd_nn_1 = mkN "slitskydd" neutrum ;
  slitstark_av_1 = mkA "slitstark" ;
  slitvarg_nn_1 = mkN "slitvarg" ;
  sloe_av_1 = mkA "slц" "slцtt" ;
  sloefock_nn_1 = mkN "slцfock" ;
  sloejd_nn_1 = mkN "slцjd" "slцjder" ;
  sloejig_av_1 = mkA "slцjig" ;
  sloejliknande_av_1 = mkA "slцjliknande" ;
  sloejmoln_nn_1 = mkN "slцjmoln" neutrum ;
  sloejskivling_nn_1 = mkN "slцjskivling" ;
  sloejstjaert_nn_1 = mkN "slцjstjдrt" ;
  sloer_nn_2 = mkN "slцr" neutrum ;
  sloesaktig_av_1 = mkA "slцsaktig" ;
  sloesande_av_1 = mkA "slцsande" ;
  sloesare_nn_1 = mkN "slцsare" "slцsare" ;
  sloesig_av_1 = mkA "slцsig" ;
  sloesint_av_1 = mkA "slцsint" "slцsint" ;
  slog_nn_1 = mkN "slog" ;
  slogan_nn_1 = mkN "slogan" "slogan" "slogans" "slogansen" ;
  slok_nn_1 = mkN "slok" ;
  slokhatt_nn_1 = mkN "slokhatt" ;
  slokig_av_1 = mkA "slokig" ;
  slom_nn_1 = mkN "slom" "slommen" "slommar" "slommarna" ;
  slopande_nn_1 = mkN "slopande" ;
  slott_nn_1 = mkN "slott" neutrum ;
  slottsfru_nn_1 = mkN "slottsfru" ;
  slottsherre_nn_1 = mkN "slottsherre" utrum ;
  slottsknekt_nn_1 = mkN "slottsknekt" ;
  slottssal_nn_1 = mkN "slottssal" ;
  slottsstek_nn_1 = mkN "slottsstek" ;
  slottsvin_nn_1 = mkN "slottsvin" "slottsvinet" "slottsviner" "slottsvinerna" ;
  slovak_nn_1 = mkN "slovak" "slovaker" ;
  slovakisk_av_1 = mkA "slovakisk" ;
  slovakiska_nn_2 = mkN "slovakiska" ;
  sloven_nn_1 = mkN "sloven" "slovener" ;
  slovensk_av_1 = mkA "slovensk" ;
  slovenska_nn_2 = mkN "slovenska" ;
  slow_fox_nn_1 = mkN "slow-fox" ;
  slubb_nn_1 = mkN "slubb" ;
  sluddrig_av_1 = mkA "sluddrig" ;
  slug_av_1 = mkA "slug" ;
  slugger_nn_1 = mkN "slugger" ;
  slughuvud_nn_1 = mkN "slughuvud" "slughuvudet" "slughuvuden" "slughuvudena" ;
  sluka_vb_1 = mkV "sluka" ;
  slump_nn_1 = mkN "slump" ;
  slumpmaessig_av_1 = mkA "slumpmдssig" ;
  slumptal_nn_1 = mkN "slumptal" "slumptalet" "slumptalen" "slumptalena" ;
  slumpvis_ab_1 = mkAdv "slumpvis" ;
  slumrande_av_1 = mkA "slumrande" ;
  slumsyster_nn_1 = mkN "slumsyster" ;
  slungboll_nn_1 = mkN "slungboll" ;
  slup_nn_1 = mkN "slup" ;
  slurk_nn_1 = mkN "slurk" ;
  slusk_nn_1 = mkN "slusk" ;
  sluskig_av_1 = mkA "sluskig" ;
  sluss_nn_1 = mkN "sluss" ;
  slusshuvud_nn_1 = mkN "slusshuvud" "slusshuvudet" "slusshuvuden" "slusshuvudena" ;
  slussport_nn_1 = mkN "slussport" ;
  slut_av_1 = mkA "slut" ;
  slut_nn_1 = mkN "slut" neutrum ;
  sluta_vb_3 = mkV "sluta" "slцt" "slutit" ;
  slutare_nn_1 = mkN "slutare" "slutare" ;
  slutartikel_nn_1 = mkN "slutartikel" ;
  sluten_av_1 = mkA "sluten" "slutet" ;
  slutfall_nn_1 = mkN "slutfall" neutrum ;
  slutfas_nn_1 = mkN "slutfas" "slutfaser" ;
  slutgiltig_av_1 = mkA "slutgiltig" ;
  slutklaem_nn_1 = mkN "slutklдm" "slutklдmmen" "slutklдmmar" "slutklдmmarna" ;
  slutkoerd_av_1 = mkA "slutkцrd" "slutkцrt" ;
  slutledning_nn_1 = mkN "slutledning" ;
  slutlig_av_1 = mkA "slutlig" ;
  slutligen_ab_1 = mkAdv "slutligen" ;
  slutljud_nn_1 = mkN "slutljud" neutrum ;
  slutloen_nn_1 = mkN "slutlцn" "slutlцner" ;
  slutplaedering_nn_1 = mkN "slutplдdering" ;
  slutprodukt_nn_1 = mkN "slutprodukt" "slutprodukter" ;
  slutpunkt_nn_1 = mkN "slutpunkt" "slutpunkter" ;
  slutresultat_nn_1 = mkN "slutresultat" neutrum ;
  slutrim_nn_1 = mkN "slutrim" "slutrimmet" "slutrim" "slutrimmen" ;
  slutsats_nn_1 = mkN "slutsats" "slutsatser" ;
  slutskede_nn_1 = mkN "slutskede" ;
  slutskrift_nn_1 = mkN "slutskrift" "slutskrifter" ;
  slutspel_nn_1 = mkN "slutspel" "slutspelet" "slutspel" "slutspelen" ;
  slutspurt_nn_1 = mkN "slutspurt" "slutspurter" ;
  slutsteg_nn_1 = mkN "slutsteg" neutrum ;
  slutsten_nn_1 = mkN "slutsten" "slutstenen" "slutstenar" "slutstenarna" ;
  sluttning_nn_1 = mkN "sluttning" ;
  slutvinjett_nn_1 = mkN "slutvinjett" "slutvinjetter" ;
  slutvokal_nn_1 = mkN "slutvokal" "slutvokaler" ;
  sly_nn_1 = mkN "sly" "slyet" "slyn" "slyna" ;
  slyngel_nn_1 = mkN "slyngel" ;
  slynig_av_1 = mkA "slynig" ;
  smaaaktig_av_1 = mkA "smеaktig" ;
  smaaax_nn_1 = mkN "smеax" neutrum ;
  smaabaatshamn_nn_1 = mkN "smеbеtshamn" ;
  smaabarn_nn_1 = mkN "smеbarn" neutrum ;
  smaabarnsbok_nn_1 = mkN "smеbarnsbok" "smеbarnsbцcker" ;
  smaabil_nn_1 = mkN "smеbil" ;
  smaabildskamera_nn_1 = mkN "smеbildskamera" ;
  smaablaasig_av_1 = mkA "smеblеsig" ;
  smaabladig_av_1 = mkA "smеbladig" ;
  smaablommig_av_1 = mkA "smеblommig" ;
  smaabonde_nn_1 = mkN "smеbonde" "smеbцnder" ;
  smaaborgare_nn_1 = mkN "smеborgare" "smеborgare" ;
  smaaborgerlig_av_1 = mkA "smеborgerlig" ;
  smaaborgerlighet_nn_1 = mkN "smеborgerlighet" "smеborgerligheter" ;
  smaabruk_nn_1 = mkN "smеbruk" neutrum ;
  smaabrukare_nn_1 = mkN "smеbrukare" "smеbrukare" ;
  smaadel_nn_1 = mkN "smеdel" "smеdelen" "smеdelar" "smеdelarna" ;
  smaadetalj_nn_1 = mkN "smеdetalj" "smеdetaljer" ;
  smaaelak_av_1 = mkA "smеelak" ;
  smaafaagel_nn_1 = mkN "smеfеgel" ;
  smaafoeretag_nn_1 = mkN "smеfцretag" neutrum ;
  smaafoeretagare_nn_1 = mkN "smеfцretagare" "smеfцretagare" ;
  smaafranska_nn_1 = mkN "smеfranska" ;
  smaagli_nn_1 = mkN "smеgli" "smеglit" "smеglin" "smеglien" ;
  smaagnagare_nn_1 = mkN "smеgnagare" "smеgnagare" ;
  smaagrael_nn_1 = mkN "smеgrдl" neutrum ;
  smaagris_nn_1 = mkN "smеgris" ;
  smaahandlare_nn_1 = mkN "smеhandlare" "smеhandlare" ;
  smaahus_nn_1 = mkN "smеhus" neutrum ;
  smaahusaegare_nn_1 = mkN "smеhusдgare" "smеhusдgare" ;
  smaahuslaan_nn_1 = mkN "smеhuslеn" neutrum ;
  smaajordbruk_nn_1 = mkN "smеjordbruk" neutrum ;
  smaajordbrukare_nn_1 = mkN "smеjordbrukare" "smеjordbrukare" ;
  smaakryp_nn_1 = mkN "smеkryp" neutrum ;
  smaalaendsk_av_1 = mkA "smеlдndsk" ;
  smaalaendska_nn_2 = mkN "smеlдndska" ;
  smaalaenning_nn_1 = mkN "smеlдnning" ;
  smaaleende_av_1 = mkA "smеleende" ;
  smaaleende_nn_1 = mkN "smеleende" ;
  smaamynt_nn_1 = mkN "smеmynt" neutrum ;
  smaaningom_ab_1 = mkAdv "smеningom" ;
  smaaord_nn_1 = mkN "smеord" neutrum ;
  smaaorganism_nn_1 = mkN "smеorganism" "smеorganismer" ;
  smaapaave_nn_1 = mkN "smеpеve" utrum ;
  smaapaket_nn_1 = mkN "smеpaket" neutrum ;
  smaapeng_nn_1 = mkN "smеpeng" ;
  smaapipig_av_1 = mkA "smеpipig" ;
  smaaplanet_nn_1 = mkN "smеplanet" "smеplaneter" ;
  smaarolig_av_1 = mkA "smеrolig" ;
  smaarutig_av_1 = mkA "smеrutig" ;
  smaasak_nn_1 = mkN "smеsak" "smеsaker" ;
  smaasint_av_1 = mkA "smеsint" "smеsint" ;
  smaaskalig_av_1 = mkA "smеskalig" ;
  smaaskog_nn_1 = mkN "smеskog" ;
  smaaskrak_nn_1 = mkN "smеskrak" ;
  smaaskuren_av_1 = mkA "smеskuren" "smеskuret" ;
  smaasparare_nn_1 = mkN "smеsparare" "smеsparare" ;
  smaastad_nn_1 = mkN "smеstad" "smеstдder" ;
  smaasten_nn_1 = mkN "smеsten" "smеstenen" "smеstenar" "smеstenarna" ;
  smaasven_nn_1 = mkN "smеsven" "smеsvennen" "smеsvennar" "smеsvennarna" ;
  smaasyskon_nn_1 = mkN "smеsyskon" neutrum ;
  smaatt_av_1 = mkA "smеtt" ;
  smaatteri_nn_1 = mkN "smеtteri" "smеtterit" "smеtterier" "smеtterierna" ;
  smaattig_av_1 = mkA "smеttig" ;
  smaattighet_nn_1 = mkN "smеttighet" "smеttigheter" ;
  smaatting_nn_1 = mkN "smеtting" ;
  smaatvaett_nn_1 = mkN "smеtvдtt" ;
  smaavaext_av_1 = mkA "smеvдxt" "smеvдxt" ;
  smaavarmt_av_1 = mkA "smеvarmt" ;
  smaaviktig_av_1 = mkA "smеviktig" ;
  smaavuxen_av_1 = mkA "smеvuxen" "smеvuxet" ;
  smack_nn_1 = mkN "smack" ;
  smackning_nn_1 = mkN "smackning" ;
  smaeck_nn_1 = mkN "smдck" ;
  smaecker_av_1 = mkA "smдcker" "smдckert" "smдckra" "smдckra" "smдckrare" "smдckrast" "smдckraste" ;
  smaeckfet_av_1 = mkA "smдckfet" ;
  smaecklaas_nn_1 = mkN "smдcklеs" neutrum ;
  smaedare_nn_1 = mkN "smдdare" "smдdare" ;
  smaedebild_nn_1 = mkN "smдdebild" "smдdebilder" ;
  smaedelse_nn_1 = mkN "smдdelse" "smдdelser" ;
  smaedenamn_nn_1 = mkN "smдdenamn" neutrum ;
  smaedeskrift_nn_1 = mkN "smдdeskrift" "smдdeskrifter" ;
  smaedlig_av_1 = mkA "smдdlig" ;
  smaektande_av_1 = mkA "smдktande" ;
  smaektande_nn_1 = mkN "smдktande" ;
  smaelek_nn_1 = mkN "smдlek" ;
  smaell_nn_1 = mkN "smдll" ;
  smaellare_nn_1 = mkN "smдllare" "smдllare" ;
  smaellglim_nn_1 = mkN "smдllglim" "smдllglimmen" "smдllglim" "smдllglimmen" ;
  smaellkaramell_nn_1 = mkN "smдllkaramell" "smдllkarameller" ;
  smaelta_vb_1 = mkV "smдlta" "smalt" "smultit" ;
  smaeltdegel_nn_1 = mkN "smдltdegel" ;
  smaeltentalpitet_nn_1 = mkN "smдltentalpitet" "smдltentalpiteter" ;
  smaelteri_nn_1 = mkN "smдlteri" "smдlterit" "smдlterier" "smдlterierna" ;
  smaeltost_nn_1 = mkN "smдltost" ;
  smaeltpropp_nn_1 = mkN "smдltpropp" ;
  smaeltpunkt_nn_1 = mkN "smдltpunkt" "smдltpunkter" ;
  smaeltsaekring_nn_1 = mkN "smдltsдkring" ;
  smaeltskydd_nn_1 = mkN "smдltskydd" neutrum ;
  smaeltugn_nn_1 = mkN "smдltugn" ;
  smaeltvatten_nn_1 = mkN "smдltvatten" "smдltvattnet" "smдltvatten" "smдltvattnen" ;
  smaeltverk_nn_1 = mkN "smдltverk" neutrum ;
  smaergelduk_nn_1 = mkN "smдrgelduk" ;
  smaert_av_1 = mkA "smдrt" "smдrt" ;
  smaertfoernimmelse_nn_1 = mkN "smдrtfцrnimmelse" "smдrtfцrnimmelser" ;
  smaertfri_av_1 = mkA "smдrtfri" "smдrtfritt" ;
  smaertlindring_nn_1 = mkN "smдrtlindring" ;
  smaertpunkt_nn_1 = mkN "smдrtpunkt" "smдrtpunkter" ;
  smaertsam_av_1 = mkA "smдrtsam" "smдrtsamt" "smдrtsamma" "smдrtsamma" "smдrtsammare" "smдrtsammast" "smдrtsammaste" ;
  smaertstillande_av_1 = mkA "smдrtstillande" ;
  smaertupplevelse_nn_1 = mkN "smдrtupplevelse" "smдrtupplevelser" ;
  smak_nn_1 = mkN "smak" "smaker" ;
  smakaemne_nn_1 = mkN "smakдmne" ;
  smakbit_nn_1 = mkN "smakbit" ;
  smakdomare_nn_1 = mkN "smakdomare" "smakdomare" ;
  smakfraaga_nn_1 = mkN "smakfrеga" ;
  smakfull_av_1 = mkA "smakfull" ;
  smaklig_av_1 = mkA "smaklig" ;
  smakloek_nn_1 = mkN "smaklцk" ;
  smakloes_av_1 = mkA "smaklцs" ;
  smakloeshet_nn_1 = mkN "smaklцshet" "smaklцsheter" ;
  smakproblem_nn_1 = mkN "smakproblem" neutrum ;
  smakprov_nn_1 = mkN "smakprov" neutrum ;
  smakraad_nn_1 = mkN "smakrеd" neutrum ;
  smaksak_nn_1 = mkN "smaksak" "smaksaker" ;
  smal_av_1 = mkA "smal" ;
  smalaenda_nn_1 = mkN "smalдnda" "smalдndan" "smalдndar" "smalдndarna" ;
  smalben_nn_1 = mkN "smalben" neutrum ;
  smaldjur_nn_1 = mkN "smaldjur" neutrum ;
  smalfilm_nn_1 = mkN "smalfilm" "smalfilmer" ;
  smalspaarig_av_1 = mkA "smalspеrig" ;
  smalvaegg_nn_1 = mkN "smalvдgg" ;
  smaragd_nn_1 = mkN "smaragd" "smaragder" ;
  smart_av_1 = mkA "smart" "smart" ;
  smash_nn_1 = mkN "smash" ;
  smaskens_av_1 = mkA "smaskens" ;
  smaskig_av_1 = mkA "smaskig" ;
  smatt_nn_1 = mkN "smatt" ;
  smed_nn_1 = mkN "smed" "smeder" ;
  smedja_nn_1 = mkN "smedja" ;
  smekmaanad_nn_1 = mkN "smekmеnad" "smekmеnader" ;
  smeknamn_nn_1 = mkN "smeknamn" neutrum ;
  smekning_nn_1 = mkN "smekning" ;
  smekord_nn_1 = mkN "smekord" neutrum ;
  smeksam_av_1 = mkA "smeksam" "smeksamt" "smeksamma" "smeksamma" "smeksammare" "smeksammast" "smeksammaste" ;
  smet_nn_1 = mkN "smet" "smeter" ;
  smetig_av_1 = mkA "smetig" ;
  smickrande_av_1 = mkA "smickrande" ;
  smickrare_nn_1 = mkN "smickrare" "smickrare" ;
  smidare_nn_1 = mkN "smidare" "smidare" ;
  smidbar_av_1 = mkA "smidbar" ;
  smide_nn_1 = mkN "smide" ;
  smideri_nn_1 = mkN "smideri" "smiderit" "smiderier" "smiderierna" ;
  smidespust_nn_1 = mkN "smidespust" ;
  smidig_av_1 = mkA "smidig" ;
  smidjebaelte_nn_1 = mkN "smidjebдlte" ;
  smil_nn_1 = mkN "smil" neutrum ;
  smilare_nn_1 = mkN "smilare" "smilare" ;
  smilfink_nn_1 = mkN "smilfink" ;
  smilgrop_nn_1 = mkN "smilgrop" ;
  smilig_av_1 = mkA "smilig" ;
  smilsk_av_1 = mkA "smilsk" ;
  smink_nn_1 = mkN "smink" "sminket" "sminker" "sminkerna" ;
  sminkare_nn_1 = mkN "sminkare" "sminkare" ;
  sminkerska_nn_1 = mkN "sminkerska" ;
  sminkning_nn_1 = mkN "sminkning" ;
  sminkoer_nn_1 = mkN "sminkцr" "sminkцrer" ;
  sminkoes_nn_1 = mkN "sminkцs" "sminkцser" ;
  smittaemne_nn_1 = mkN "smittдmne" ;
  smittbaerare_nn_1 = mkN "smittbдrare" "smittbдrare" ;
  smitthaerd_nn_1 = mkN "smitthдrd" ;
  smittohaerd_nn_1 = mkN "smittohдrd" ;
  smittsam_av_1 = mkA "smittsam" "smittsamt" "smittsamma" "smittsamma" "smittsammare" "smittsammast" "smittsammaste" ;
  smockfull_av_1 = mkA "smockfull" ;
  smoer_nn_1 = mkN "smцr" "smцret" "smцrer" "smцrerna" ;
  smoerbakelse_nn_1 = mkN "smцrbakelse" "smцrbakelser" ;
  smoerberg_nn_1 = mkN "smцrberg" neutrum ;
  smoerboll_nn_1 = mkN "smцrboll" ;
  smoerbult_nn_1 = mkN "smцrbult" ;
  smoerdegspastej_nn_1 = mkN "smцrdegspastej" "smцrdegspastejer" ;
  smoergaas_nn_1 = mkN "smцrgеs" ;
  smoergaasbord_nn_1 = mkN "smцrgеsbord" neutrum ;
  smoergaasgaffel_nn_1 = mkN "smцrgеsgaffel" ;
  smoergaaskniv_nn_1 = mkN "smцrgеskniv" ;
  smoergaasnisse_nn_1 = mkN "smцrgеsnisse" utrum ;
  smoergaaspaalaegg_nn_1 = mkN "smцrgеspеlдgg" neutrum ;
  smoerig_av_1 = mkA "smцrig" ;
  smoerjanordning_nn_1 = mkN "smцrjanordning" ;
  smoerjelse_nn_1 = mkN "smцrjelse" "smцrjelser" ;
  smoerjgrop_nn_1 = mkN "smцrjgrop" ;
  smoerjhaal_nn_1 = mkN "smцrjhеl" neutrum ;
  smoerjhall_nn_1 = mkN "smцrjhall" ;
  smoerjig_av_1 = mkA "smцrjig" ;
  smoerjmedel_nn_1 = mkN "smцrjmedel" neutrum ;
  smoerjning_nn_1 = mkN "smцrjning" ;
  smoerkniv_nn_1 = mkN "smцrkniv" ;
  smoersopp_nn_1 = mkN "smцrsopp" ;
  smoerspade_nn_1 = mkN "smцrspade" utrum ;
  smoersvamp_nn_1 = mkN "smцrsvamp" ;
  smoertenor_nn_1 = mkN "smцrtenor" "smцrtenoren" "smцrtenorer" "smцrtenorerna" ;
  smoking_nn_1 = mkN "smoking" ;
  smokingklaenning_nn_1 = mkN "smokingklдnning" ;
  smugglare_nn_1 = mkN "smugglare" "smugglare" ;
  smuggleri_nn_1 = mkN "smuggleri" "smugglerit" "smugglerier" "smugglerierna" ;
  smul_av_1 = mkA "smul" ;
  smulgraat_nn_1 = mkN "smulgrеt" ;
  smulig_av_1 = mkA "smulig" ;
  smultron_nn_1 = mkN "smultron" neutrum ;
  smultronstaelle_nn_1 = mkN "smultronstдlle" ;
  smutsavvisande_av_1 = mkA "smutsavvisande" ;
  smutsblad_nn_1 = mkN "smutsblad" neutrum ;
  smutsgraa_av_1 = mkA "smutsgrе" "smutsgrеtt" ;
  smutsgris_nn_1 = mkN "smutsgris" ;
  smutsig_av_1 = mkA "smutsig" ;
  smutspaase_nn_1 = mkN "smutspеse" utrum ;
  smutstitel_nn_1 = mkN "smutstitel" ;
  smutsvatten_nn_1 = mkN "smutsvatten" "smutsvattnet" "smutsvatten" "smutsvattnen" ;
  smutt_nn_1 = mkN "smutt" ;
  smycketyp_nn_1 = mkN "smycketyp" "smycketyper" ;
  smyg_nn_1 = mkN "smyg" ;
  smyga_vb_1 = mkV "smyga" "smцg" "smugit" ;
  smygaeta_vb_1 = mkV "smygдta" "smygеt" "smygдtit" ;
  smyghaal_nn_1 = mkN "smyghеl" neutrum ;
  smygsoem_nn_1 = mkN "smygsцm" "smygsцmmen" "smygsцmmar" "smygsцmmarna" ;
  smygvaeg_nn_1 = mkN "smygvдg" ;
  smygvinkel_nn_1 = mkN "smygvinkel" ;
  snaal_av_1 = mkA "snеl" ;
  snaaljaap_nn_1 = mkN "snеljеp" ;
  snaalmaans_nn_1 = mkN "snеlmеns" ;
  snaalvarg_nn_1 = mkN "snеlvarg" ;
  snaar_nn_1 = mkN "snеr" neutrum ;
  snaarig_av_1 = mkA "snеrig" ;
  snaarskog_nn_1 = mkN "snеrskog" ;
  snabb_av_1 = mkA "snabb" ;
  snabbfoerband_nn_1 = mkN "snabbfцrband" neutrum ;
  snabbfoto_nn_1 = mkN "snabbfoto" "snabbfotot" "snabbfoton" "snabbfotona" ;
  snabbhet_nn_1 = mkN "snabbhet" "snabbheter" ;
  snabbkassa_nn_1 = mkN "snabbkassa" ;
  snabbkoep_nn_1 = mkN "snabbkцp" neutrum ;
  snabbkoepsbutik_nn_1 = mkN "snabbkцpsbutik" "snabbkцpsbutiker" ;
  snabbkoppling_nn_1 = mkN "snabbkoppling" ;
  snabbkurs_nn_1 = mkN "snabbkurs" "snabbkurser" ;
  snabbloeslig_av_1 = mkA "snabblцslig" ;
  snabblunch_nn_1 = mkN "snabblunch" "snabbluncher" ;
  snabbportraett_nn_1 = mkN "snabbportrдtt" neutrum ;
  snabbprotokoll_nn_1 = mkN "snabbprotokoll" neutrum ;
  snabbregulator_nn_1 = mkN "snabbregulator" "snabbregulatorer" ;
  snabbremiss_nn_1 = mkN "snabbremiss" "snabbremisser" ;
  snabbrepris_nn_1 = mkN "snabbrepris" "snabbrepriser" ;
  snabbskiss_nn_1 = mkN "snabbskiss" "snabbskisser" ;
  snabbstopp_nn_1 = mkN "snabbstopp" neutrum ;
  snabbtaag_nn_1 = mkN "snabbtеg" neutrum ;
  snabbtaenkt_av_1 = mkA "snabbtдnkt" "snabbtдnkt" ;
  snabbtelefon_nn_1 = mkN "snabbtelefon" "snabbtelefoner" ;
  snabbuss_nn_1 = mkN "snabbuss" ;
  snabbvaeljare_nn_1 = mkN "snabbvдljare" "snabbvдljare" ;
  snabbvaexande_av_1 = mkA "snabbvдxande" ;
  snabel_nn_1 = mkN "snabel" ;
  snabelliknande_av_1 = mkA "snabelliknande" ;
  snabelsko_nn_1 = mkN "snabelsko" "snabelskor" ;
  snackbar_nn_1 = mkN "snackbar" "snackbarer" ;
  snackesalig_av_1 = mkA "snackesalig" ;
  snacksalig_av_1 = mkA "snacksalig" ;
  snaeckart_nn_1 = mkN "snдckart" "snдckarter" ;
  snaeckdjur_nn_1 = mkN "snдckdjur" neutrum ;
  snaeckhjul_nn_1 = mkN "snдckhjul" neutrum ;
  snaeckhus_nn_1 = mkN "snдckhus" neutrum ;
  snaeckskal_nn_1 = mkN "snдckskal" neutrum ;
  snaeckskruv_nn_1 = mkN "snдckskruv" ;
  snaeckvaexel_nn_1 = mkN "snдckvдxel" ;
  snaell_av_1 = mkA "snдll" ;
  snaellgaaende_av_1 = mkA "snдllgеende" ;
  snaelltaag_nn_1 = mkN "snдlltеg" neutrum ;
  snaepp_nn_1 = mkN "snдpp" neutrum ;
  snaeppfaagel_nn_1 = mkN "snдppfеgel" ;
  snaepplock_nn_1 = mkN "snдpplock" neutrum ;
  snaerj_nn_2 = mkN "snдrj" neutrum ;
  snaerjig_av_1 = mkA "snдrjig" ;
  snaerjvaevnad_nn_1 = mkN "snдrjvдvnad" "snдrjvдvnader" ;
  snaerp_nn_2 = mkN "snдrp" neutrum ;
  snaert_nn_1 = mkN "snдrt" ;
  snaertig_av_1 = mkA "snдrtig" ;
  snaesig_av_1 = mkA "snдsig" ;
  snaev_av_1 = mkA "snдv" ;
  snapphane_nn_1 = mkN "snapphane" utrum ;
  snaps_nn_1 = mkN "snaps" ;
  snapshot_nn_1 = mkN "snapshot" neutrum ;
  snar_av_1 = mkA "snar" ;
  snarare_ab_1 = mkAdv "snarare" ;
  snarast_ab_1 = mkAdv "snarast" ;
  snarfaerdig_av_1 = mkA "snarfдrdig" ;
  snarfager_av_1 = mkA "snarfager" "snarfagert" "snarfagra" "snarfagra" "snarfagrare" "snarfagrast" "snarfagraste" ;
  snarfyndig_av_1 = mkA "snarfyndig" ;
  snarkning_nn_1 = mkN "snarkning" ;
  snarlig_av_1 = mkA "snarlig" ;
  snarliga_ab_1 = mkAdv "snarliga" ;
  snarligen_ab_1 = mkAdv "snarligen" ;
  snarlik_av_1 = mkA "snarlik" ;
  snarstucken_av_1 = mkA "snarstucken" "snarstucket" ;
  snart_ab_1 = mkAdv "snart" ;
  snartaenkt_av_1 = mkA "snartдnkt" "snartдnkt" ;
  snarvacker_av_1 = mkA "snarvacker" "snarvackert" "snarvackra" "snarvackra" "snarvackrare" "snarvackrast" "snarvackraste" ;
  snasker_nn_1 = mkN "snasker" ;
  snaskeri_nn_1 = mkN "snaskeri" "snaskerit" "snaskerier" "snaskerierna" ;
  snaskig_av_1 = mkA "snaskig" ;
  snaskighet_nn_1 = mkN "snaskighet" "snaskigheter" ;
  snatterand_nn_1 = mkN "snatterand" "snatterдnder" ;
  snatteri_nn_1 = mkN "snatteri" "snatterit" "snatterier" "snatterierna" ;
  snattran_ab_1 = mkAdv "snattran" ;
  sned_av_1 = mkA "sned" ;
  snedfoerdelning_nn_1 = mkN "snedfцrdelning" ;
  snedgaangen_av_1 = mkA "snedgеngen" "snedgеnget" ;
  snedhiss_nn_1 = mkN "snedhiss" ;
  snedhoernig_av_1 = mkA "snedhцrnig" ;
  snedig_av_1 = mkA "snedig" ;
  snedoegd_av_1 = mkA "snedцgd" "snedцgt" ;
  snedparkering_nn_1 = mkN "snedparkering" ;
  snedrekrytering_nn_1 = mkN "snedrekrytering" ;
  snedsegel_nn_1 = mkN "snedsegel" neutrum ;
  snedseglare_nn_1 = mkN "snedseglare" "snedseglare" ;
  snedskuren_av_1 = mkA "snedskuren" "snedskuret" ;
  snedslaa_nn_1 = mkN "snedslе" ;
  snedspraang_nn_1 = mkN "snedsprеng" neutrum ;
  snedsteg_nn_1 = mkN "snedsteg" neutrum ;
  snedtaendning_nn_1 = mkN "snedtдndning" ;
  snedtak_nn_1 = mkN "snedtak" neutrum ;
  snedvinklig_av_1 = mkA "snedvinklig" ;
  snedvrida_vb_1 = mkV "snedvrida" "snedvred" "snedvridit" ;
  snedvridning_nn_1 = mkN "snedvridning" ;
  snes_nn_1 = mkN "snes" ;
  snibb_nn_1 = mkN "snibb" ;
  snibbig_av_1 = mkA "snibbig" ;
  snibbskaal_nn_1 = mkN "snibbskеl" ;
  snickarbaenk_nn_1 = mkN "snickarbдnk" ;
  snickare_nn_1 = mkN "snickare" "snickare" ;
  snickeri_nn_1 = mkN "snickeri" "snickerit" "snickerier" "snickerierna" ;
  snidare_nn_1 = mkN "snidare" "snidare" ;
  snideri_nn_1 = mkN "snideri" "sniderit" "sniderier" "sniderierna" ;
  sniff_nn_1 = mkN "sniff" ;
  snigel_nn_1 = mkN "snigel" ;
  snigelhus_nn_1 = mkN "snigelhus" neutrum ;
  sniken_av_1 = mkA "sniken" "sniket" ;
  snilj_nn_1 = mkN "snilj" "sniljer" ;
  snilleblixt_nn_1 = mkN "snilleblixt" ;
  snilledrag_nn_1 = mkN "snilledrag" neutrum ;
  snillefoster_nn_1 = mkN "snillefoster" neutrum ;
  snilleprov_nn_1 = mkN "snilleprov" neutrum ;
  snilleverk_nn_1 = mkN "snilleverk" neutrum ;
  snillrik_av_1 = mkA "snillrik" ;
  snip_nn_1 = mkN "snip" ;
  snipig_av_1 = mkA "snipig" ;
  snirkel_nn_1 = mkN "snirkel" ;
  snirklig_av_1 = mkA "snirklig" ;
  snitsare_nn_1 = mkN "snitsare" "snitsare" ;
  snitsel_nn_1 = mkN "snitsel" ;
  snitsig_av_1 = mkA "snitsig" ;
  snitt_nn_1 = mkN "snitt" neutrum ;
  snitt_nn_2 = mkN "snitt" ;
  snittmaengd_nn_1 = mkN "snittmдngd" "snittmдngder" ;
  snobb_nn_1 = mkN "snobb" ;
  snobberi_nn_1 = mkN "snobberi" "snobberit" "snobberier" "snobberierna" ;
  snobbig_av_1 = mkA "snobbig" ;
  snobbistisk_av_1 = mkA "snobbistisk" ;
  snodd_nn_1 = mkN "snodd" ;
  snoealg_nn_1 = mkN "snцalg" "snцalger" ;
  snoebaer_nn_1 = mkN "snцbдr" neutrum ;
  snoeblind_av_1 = mkA "snцblind" ;
  snoeblindhet_nn_1 = mkN "snцblindhet" "snцblindheter" ;
  snoeboll_nn_1 = mkN "snцboll" ;
  snoebollsbuske_nn_1 = mkN "snцbollsbuske" utrum ;
  snoedjup_nn_1 = mkN "snцdjup" neutrum ;
  snoedraekt_nn_1 = mkN "snцdrдkt" "snцdrдkter" ;
  snoedroppe_nn_1 = mkN "snцdroppe" utrum ;
  snoefall_nn_1 = mkN "snцfall" neutrum ;
  snoefattig_av_1 = mkA "snцfattig" ;
  snoefjaell_nn_1 = mkN "snцfjдll" neutrum ;
  snoegubbe_nn_1 = mkN "snцgubbe" utrum ;
  snoehagel_nn_1 = mkN "snцhagel" neutrum ;
  snoeig_av_1 = mkA "snцig" ;
  snoekanon_nn_1 = mkN "snцkanon" "snцkanoner" ;
  snoekedja_nn_1 = mkN "snцkedja" ;
  snoeklaedd_av_1 = mkA "snцklдdd" "snцklдdtt" ;
  snoekristall_nn_1 = mkN "snцkristall" "snцkristaller" ;
  snoelandskap_nn_1 = mkN "snцlandskap" "snцlandskapet" "snцlandskapen" "snцlandskapena" ;
  snoepare_nn_1 = mkN "snцpare" "snцpare" ;
  snoepegel_nn_1 = mkN "snцpegel" ;
  snoeping_nn_1 = mkN "snцping" ;
  snoeplig_av_1 = mkA "snцplig" ;
  snoeplog_nn_1 = mkN "snцplog" ;
  snoeplogning_nn_1 = mkN "snцplogning" ;
  snoerapport_nn_1 = mkN "snцrapport" "snцrapporter" ;
  snoerik_av_1 = mkA "snцrik" ;
  snoerliv_nn_1 = mkN "snцrliv" neutrum ;
  snoermakare_nn_1 = mkN "snцrmakare" "snцrmakare" ;
  snoermakeri_nn_1 = mkN "snцrmakeri" "snцrmakerit" "snцrmakerier" "snцrmakerierna" ;
  snoerpig_av_1 = mkA "snцrpig" ;
  snoerpvad_nn_1 = mkN "snцrpvad" ;
  snoerraet_av_1 = mkA "snцrrдt" ;
  snoersko_nn_1 = mkN "snцrsko" "snцrskor" ;
  snoervlig_av_1 = mkA "snцrvlig" ;
  snoervling_nn_1 = mkN "snцrvling" ;
  snoesko_nn_1 = mkN "snцsko" "snцskor" ;
  snoeskoter_nn_1 = mkN "snцskoter" ;
  snoeskottare_nn_1 = mkN "snцskottare" "snцskottare" ;
  snoeskred_nn_1 = mkN "snцskred" neutrum ;
  snoesparv_nn_1 = mkN "snцsparv" ;
  snoestaket_nn_1 = mkN "snцstaket" neutrum ;
  snoestorm_nn_1 = mkN "snцstorm" ;
  snoetaeckt_av_1 = mkA "snцtдckt" "snцtдckt" ;
  snoevinter_nn_1 = mkN "snцvinter" ;
  snoevit_av_1 = mkA "snцvit" ;
  snofsig_av_1 = mkA "snofsig" ;
  snok_nn_1 = mkN "snok" ;
  snopen_av_1 = mkA "snopen" "snopet" ;
  snopp_nn_1 = mkN "snopp" ;
  snoppare_nn_1 = mkN "snoppare" "snoppare" ;
  snorgaers_nn_1 = mkN "snorgдrs" ;
  snorig_av_1 = mkA "snorig" ;
  snork_nn_1 = mkN "snork" ;
  snorkel_nn_1 = mkN "snorkel" ;
  snorkig_av_1 = mkA "snorkig" ;
  snorunge_nn_1 = mkN "snorunge" utrum ;
  snorvalp_nn_1 = mkN "snorvalp" ;
  snubbe_nn_1 = mkN "snubbe" utrum ;
  snubbeltraad_nn_1 = mkN "snubbeltrеd" ;
  snubblig_av_1 = mkA "snubblig" ;
  snudd_nn_1 = mkN "snudd" ;
  snudig_av_1 = mkA "snudig" ;
  snultra_nn_1 = mkN "snultra" ;
  snurrevad_nn_1 = mkN "snurrevad" ;
  snurrfaatoelj_nn_1 = mkN "snurrfеtцlj" "snurrfеtцljer" ;
  snurrig_av_1 = mkA "snurrig" ;
  snus_nn_1 = mkN "snus" "snuset" "snuser" "snuserna" ;
  snusbrun_av_1 = mkA "snusbrun" ;
  snusfoernuftig_av_1 = mkA "snusfцrnuftig" ;
  snusgubbe_nn_1 = mkN "snusgubbe" utrum ;
  snusig_av_1 = mkA "snusig" ;
  snusker_nn_1 = mkN "snusker" "snuskeren" "snuskerar" "snuskerarna" ;
  snuskhummer_nn_1 = mkN "snuskhummer" "snuskhummern" "snuskhummrar" "snuskhummrarna" ;
  snuskig_av_1 = mkA "snuskig" ;
  snuskighet_nn_1 = mkN "snuskighet" "snuskigheter" ;
  snuskpelle_nn_1 = mkN "snuskpelle" utrum ;
  snusmumrik_nn_1 = mkN "snusmumrik" ;
  snusnaesduk_nn_1 = mkN "snusnдsduk" ;
  snustorr_av_1 = mkA "snustorr" ;
  snut_nn_1 = mkN "snut" ;
  snutfager_av_1 = mkA "snutfager" "snutfagert" "snutfagra" "snutfagra" "snutfagrare" "snutfagrast" "snutfagraste" ;
  snuthaeck_nn_1 = mkN "snuthдck" ;
  snutt_nn_1 = mkN "snutt" ;
  snuvig_av_1 = mkA "snuvig" ;
  snyft_nn_1 = mkN "snyft" neutrum ;
  snyftande_av_1 = mkA "snyftande" ;
  snyftning_nn_1 = mkN "snyftning" ;
  snyftreportage_nn_1 = mkN "snyftreportage" "snyftreportaget" "snyftreportage" "snyftreportagen" ;
  snyftventil_nn_1 = mkN "snyftventil" "snyftventiler" ;
  snygg_av_1 = mkA "snygg" ;
  snygging_nn_1 = mkN "snygging" ;
  snyltare_nn_1 = mkN "snyltare" "snyltare" ;
  snyltbi_nn_1 = mkN "snyltbi" "snyltbit" "snyltbin" "snyltbien" ;
  snyltgaest_nn_1 = mkN "snyltgдst" "snyltgдster" ;
  snyltvaext_nn_1 = mkN "snyltvдxt" "snyltvдxter" ;
  snyta_vb_1 = mkV "snyta" "snцt" "snutit" ;
  snytbagge_nn_1 = mkN "snytbagge" utrum ;
  snyting_nn_1 = mkN "snyting" ;
  soare_nn_1 = mkN "soarй" "soarйer" ;
  sobel_nn_1 = mkN "sobel" ;
  sober_av_1 = mkA "sober" "sobert" "sobra" "sobra" "sobrare" "sobrast" "sobraste" ;
  social_av_1 = mkA "social" ;
  socialantropolog_nn_1 = mkN "socialantropolog" "socialantropologer" ;
  socialantropologisk_av_1 = mkA "socialantropologisk" ;
  socialarbetare_nn_1 = mkN "socialarbetare" "socialarbetare" ;
  socialassistent_nn_1 = mkN "socialassistent" "socialassistenter" ;
  socialavgift_nn_1 = mkN "socialavgift" "socialavgifter" ;
  socialbidrag_nn_1 = mkN "socialbidrag" neutrum ;
  socialbyraa_nn_1 = mkN "socialbyrе" "socialbyrеer" ;
  socialdemokrat_nn_1 = mkN "socialdemokrat" "socialdemokrater" ;
  socialdemokratisk_av_1 = mkA "socialdemokratisk" ;
  socialdirektoer_nn_1 = mkN "socialdirektцr" "socialdirektцrer" ;
  socialfall_nn_1 = mkN "socialfall" neutrum ;
  socialfoersaekring_nn_1 = mkN "socialfцrsдkring" ;
  socialfoervaltning_nn_1 = mkN "socialfцrvaltning" ;
  socialgrupp_nn_1 = mkN "socialgrupp" "socialgrupper" ;
  socialhjaelpstagare_nn_1 = mkN "socialhjдlpstagare" "socialhjдlpstagare" ;
  socialist_nn_1 = mkN "socialist" "socialister" ;
  socialistisk_av_1 = mkA "socialistisk" ;
  socialitet_nn_1 = mkN "socialitet" "socialiteter" ;
  socialklass_nn_1 = mkN "socialklass" "socialklasser" ;
  sociallaekare_nn_1 = mkN "sociallдkare" "sociallдkare" ;
  socialliberal_av_1 = mkA "socialliberal" ;
  socialliberal_nn_1 = mkN "socialliberal" "socialliberaler" ;
  socialmedicinare_nn_1 = mkN "socialmedicinare" "socialmedicinare" ;
  socialnaemnd_nn_1 = mkN "socialnдmnd" "socialnдmnder" ;
  socialpolitisk_av_1 = mkA "socialpolitisk" ;
  socialpsykolog_nn_1 = mkN "socialpsykolog" "socialpsykologer" ;
  socialregister_nn_1 = mkN "socialregister" neutrum ;
  socialreportage_nn_1 = mkN "socialreportage" "socialreportaget" "socialreportage" "socialreportagen" ;
  socialvetenskap_nn_1 = mkN "socialvetenskap" "socialvetenskaper" ;
  societet_nn_1 = mkN "societet" "societeter" ;
  societetshus_nn_1 = mkN "societetshus" neutrum ;
  societetslejon_nn_1 = mkN "societetslejon" neutrum ;
  socioekonomisk_av_1 = mkA "socioekonomisk" ;
  sociogram_nn_1 = mkN "sociogram" "sociogrammet" "sociogram" "sociogrammen" ;
  sociolekt_nn_1 = mkN "sociolekt" "sociolekter" ;
  sociolog_nn_1 = mkN "sociolog" "sociologer" ;
  sociologisk_av_1 = mkA "sociologisk" ;
  socionom_nn_1 = mkN "socionom" "socionomer" ;
  sociopat_nn_1 = mkN "sociopat" "sociopater" ;
  sockel_nn_1 = mkN "sockel" ;
  socken_nn_1 = mkN "socken" "sockenn" "socknar" "socknarna" ;
  sockenbud_nn_1 = mkN "sockenbud" neutrum ;
  sockendraekt_nn_1 = mkN "sockendrдkt" "sockendrдkter" ;
  sockenstuga_nn_1 = mkN "sockenstuga" ;
  sockerart_nn_1 = mkN "sockerart" "sockerarter" ;
  sockerbagare_nn_1 = mkN "sockerbagare" "sockerbagare" ;
  sockerbageri_nn_1 = mkN "sockerbageri" "sockerbagerit" "sockerbagerier" "sockerbagerierna" ;
  sockerbetssaft_nn_1 = mkN "sockerbetssaft" "sockerbetssafter" ;
  sockerbildning_nn_1 = mkN "sockerbildning" ;
  sockerbindning_nn_1 = mkN "sockerbindning" ;
  sockerbit_nn_1 = mkN "sockerbit" ;
  sockerbruk_nn_1 = mkN "sockerbruk" neutrum ;
  sockerfri_av_1 = mkA "sockerfri" "sockerfritt" ;
  sockerglasyr_nn_1 = mkN "sockerglasyr" "sockerglasyrer" ;
  sockergryn_nn_1 = mkN "sockergryn" neutrum ;
  sockerhalt_nn_1 = mkN "sockerhalt" "sockerhalter" ;
  sockerhaltig_av_1 = mkA "sockerhaltig" ;
  sockerkampanj_nn_1 = mkN "sockerkampanj" "sockerkampanjer" ;
  sockerloenn_nn_1 = mkN "sockerlцnn" ;
  sockermolekyl_nn_1 = mkN "sockermolekyl" "sockermolekyler" ;
  sockeroeverdrag_nn_1 = mkN "sockerцverdrag" neutrum ;
  sockerpiller_nn_1 = mkN "sockerpiller" neutrum ;
  sockerraffinaderi_nn_1 = mkN "sockerraffinaderi" "sockerraffinaderit" "sockerraffinaderier" "sockerraffinaderierna" ;
  sockerrik_av_1 = mkA "sockerrik" ;
  sockerroer_nn_1 = mkN "sockerrцr" neutrum ;
  sockersjuk_av_1 = mkA "sockersjuk" ;
  sockerskaal_nn_1 = mkN "sockerskеl" ;
  sockersoet_av_1 = mkA "sockersцt" ;
  sockerstroeare_nn_1 = mkN "sockerstrцare" "sockerstrцare" ;
  sockertaang_nn_1 = mkN "sockertеng" "sockertдnger" ;
  sockertillverkning_nn_1 = mkN "sockertillverkning" ;
  sockertopp_nn_1 = mkN "sockertopp" ;
  sockrig_av_1 = mkA "sockrig" ;
  sodaglas_nn_1 = mkN "sodaglas" neutrum ;
  sodahalt_nn_1 = mkN "sodahalt" "sodahalter" ;
  sodahaltig_av_1 = mkA "sodahaltig" ;
  sodavatten_nn_1 = mkN "sodavatten" "sodavattnet" "sodavatten" "sodavattnen" ;
  soeckendag_nn_1 = mkN "sцckendag" ;
  soeder_ab_1 = mkAdv "sцder" ;
  soedergoek_nn_1 = mkN "sцdergцk" ;
  soederifraan_ab_1 = mkAdv "sцderifrеn" ;
  soederkis_nn_1 = mkN "sцderkis" ;
  soedermanlaendsk_av_1 = mkA "sцdermanlдndsk" ;
  soedermanlaenning_nn_1 = mkN "sцdermanlдnning" ;
  soederoever_ab_1 = mkAdv "sцderцver" ;
  soederut_ab_1 = mkAdv "sцderut" ;
  soedra_av_1 = mkA "sцdra" ;
  soekande_nn_1 = mkN "sцkande" "sцkanden" "sцkande" "sцkandena" ;
  soekare_nn_1 = mkN "sцkare" "sцkare" ;
  soekarljus_nn_1 = mkN "sцkarljus" neutrum ;
  soekt_av_1 = mkA "sцkt" "sцkt" ;
  soelig_av_1 = mkA "sцlig" ;
  soelkorv_nn_1 = mkN "sцlkorv" ;
  soem_nn_1 = mkN "sцm" "sцmmen" "sцmmar" "sцmmarna" ;
  soem_nn_2 = mkN "sцm" "sцmmet" "sцm" "sцmmen" ;
  soemmare_nn_1 = mkN "sцmmare" "sцmmare" ;
  soemmerska_nn_1 = mkN "sцmmerska" ;
  soemmersketips_nn_1 = mkN "sцmmersketips" neutrum ;
  soemnad_nn_1 = mkN "sцmnad" "sцmnader" ;
  soemndrucken_av_1 = mkA "sцmndrucken" "sцmndrucket" ;
  soemngaangaraktig_av_1 = mkA "sцmngеngaraktig" ;
  soemngaangare_nn_1 = mkN "sцmngеngare" "sцmngеngare" ;
  soemnig_av_1 = mkA "sцmnig" ;
  soemnloes_av_1 = mkA "sцmnlцs" ;
  soemnmedel_nn_1 = mkN "sцmnmedel" neutrum ;
  soemntung_av_1 = mkA "sцmntung" ;
  soemsmaan_nn_1 = mkN "sцmsmеn" "sцmsmеner" ;
  soendag_nn_1 = mkN "sцndag" ;
  soendagsbarn_nn_1 = mkN "sцndagsbarn" neutrum ;
  soendagsbokstav_nn_1 = mkN "sцndagsbokstav" "sцndagsbokstдver" ;
  soendagsjaegare_nn_1 = mkN "sцndagsjдgare" "sцndagsjдgare" ;
  soendagskvaell_nn_1 = mkN "sцndagskvдll" ;
  soendagsmorgon_nn_1 = mkN "sцndagsmorgon" "sцndagsmorgonen" "sцndagsmorgnar" "sцndagsmorgnarna" ;
  soendagspappa_nn_1 = mkN "sцndagspappa" ;
  soender_ab_1 = mkAdv "sцnder" ;
  soenderdelning_nn_1 = mkN "sцnderdelning" ;
  soenderfalla_vb_1 = mkV "sцnderfalla" "sцnderfцll" "sцnderfallit" ;
  soenderriva_vb_1 = mkV "sцnderriva" "sцnderrev" "sцnderrivit" ;
  soenderspraengning_nn_1 = mkN "sцndersprдngning" ;
  soendrig_av_1 = mkA "sцndrig" ;
  soendring_nn_1 = mkN "sцndring" ;
  soergaardsidyll_nn_1 = mkN "sцrgеrdsidyll" "sцrgеrdsidyller" ;
  soerlaendsk_av_1 = mkA "sцrlдndsk" ;
  soerlaenning_nn_1 = mkN "sцrlдnning" ;
  soermlaendsk_av_1 = mkA "sцrmlдndsk" ;
  soermlaenning_nn_1 = mkN "sцrmlдnning" ;
  soet_av_1 = mkA "sцt" ;
  soetaktig_av_1 = mkA "sцtaktig" ;
  soetmandel_nn_1 = mkN "sцtmandel" ;
  soetningsmedel_nn_1 = mkN "sцtningsmedel" neutrum ;
  soetnos_nn_1 = mkN "sцtnos" ;
  soetpotatis_nn_1 = mkN "sцtpotatis" ;
  soetsak_nn_1 = mkN "sцtsak" "sцtsaker" ;
  soetsliskig_av_1 = mkA "sцtsliskig" ;
  soetsur_av_1 = mkA "sцtsur" ;
  soetvatten_nn_1 = mkN "sцtvatten" "sцtvattnet" "sцtvatten" "sцtvattnen" ;
  soetvattensforskare_nn_1 = mkN "sцtvattensforskare" "sцtvattensforskare" ;
  soffbord_nn_1 = mkN "soffbord" neutrum ;
  soffgrupp_nn_1 = mkN "soffgrupp" "soffgrupper" ;
  soffit_nn_1 = mkN "soffit" "soffiter" ;
  soffliggare_nn_1 = mkN "soffliggare" "soffliggare" ;
  sofflock_nn_1 = mkN "sofflock" neutrum ;
  sofism_nn_1 = mkN "sofism" "sofismer" ;
  sofist_nn_1 = mkN "sofist" "sofister" ;
  sofisteri_nn_1 = mkN "sofisteri" "sofisterit" "sofisterier" "sofisterierna" ;
  sojabiff_nn_1 = mkN "sojabiff" ;
  sokratisk_av_1 = mkA "sokratisk" ;
  sol_nn_1 = mkN "sol" ;
  sol_och_vaarare_nn_1 = mkN "sol-och-vеrare" "sol-och-vеrare" ;
  solaar_nn_1 = mkN "solеr" neutrum ;
  solaekta_av_1 = mkA "solдkta" ;
  solaer_av_1 = mkA "solдr" ;
  solanin_nn_1 = mkN "solanin" "solaniner" ;
  solar_av_1 = mkA "solar" ;
  solarisk_av_1 = mkA "solarisk" ;
  solarium_nn_1 = mkN "solarium" "solariet" "solarier" "solarierna" ;
  solavaexel_nn_1 = mkN "solavдxel" ;
  solbad_nn_1 = mkN "solbad" neutrum ;
  solbaenk_nn_1 = mkN "solbдnk" ;
  solbaergning_nn_1 = mkN "solbдrgning" ;
  solbatteri_nn_1 = mkN "solbatteri" "solbatterit" "solbatterier" "solbatterierna" ;
  solbelysning_nn_1 = mkN "solbelysning" ;
  solbelyst_av_1 = mkA "solbelyst" "solbelyst" ;
  solbestraalning_nn_1 = mkN "solbestrеlning" ;
  solblekt_av_1 = mkA "solblekt" "solblekt" ;
  solblind_av_1 = mkA "solblind" ;
  solblindhet_nn_1 = mkN "solblindhet" "solblindheter" ;
  solbraend_av_1 = mkA "solbrдnd" ;
  solcell_nn_1 = mkN "solcell" "solceller" ;
  solcirkel_nn_1 = mkN "solcirkel" ;
  solcykel_nn_1 = mkN "solcykel" ;
  soldag_nn_1 = mkN "soldag" ;
  soldat_nn_1 = mkN "soldat" "soldater" ;
  soldathem_nn_1 = mkN "soldathem" "soldathemmet" "soldathem" "soldathemmen" ;
  soldathop_nn_1 = mkN "soldathop" ;
  soldatnamn_nn_1 = mkN "soldatnamn" neutrum ;
  soldatrock_nn_1 = mkN "soldatrock" ;
  soldattorp_nn_1 = mkN "soldattorp" neutrum ;
  soldenaer_nn_1 = mkN "soldenдr" "soldenдrer" ;
  soldnaer_nn_1 = mkN "soldnдr" "soldnдrer" ;
  soldraekt_nn_1 = mkN "soldrдkt" "soldrдkter" ;
  soldrucken_av_1 = mkA "soldrucken" "soldrucket" ;
  soldygn_nn_1 = mkN "soldygn" neutrum ;
  soldyrkare_nn_1 = mkN "soldyrkare" "soldyrkare" ;
  soleksem_nn_1 = mkN "soleksem" neutrum ;
  solenn_av_1 = mkA "solenn" "solent" ;
  solennitet_nn_1 = mkN "solennitet" "solenniteter" ;
  solfall_nn_1 = mkN "solfall" neutrum ;
  solfatar_nn_1 = mkN "solfatar" "solfatarer" ;
  solfattig_av_1 = mkA "solfattig" ;
  solfjaeder_nn_1 = mkN "solfjдder" ;
  solflaeck_nn_1 = mkN "solflдck" ;
  solflod_nn_1 = mkN "solflod" "solfloder" ;
  solfoermoerkelse_nn_1 = mkN "solfцrmцrkelse" "solfцrmцrkelser" ;
  solgud_nn_1 = mkN "solgud" ;
  solgul_av_1 = mkA "solgul" ;
  solhatt_nn_1 = mkN "solhatt" ;
  solhjul_nn_1 = mkN "solhjul" neutrum ;
  solid_av_1 = mkA "solid" ;
  solidarisk_av_1 = mkA "solidarisk" ;
  solidaritet_nn_1 = mkN "solidaritet" "solidariteter" ;
  soliditet_nn_1 = mkN "soliditet" "soliditeter" ;
  solig_av_1 = mkA "solig" ;
  solinstraalning_nn_1 = mkN "solinstrеlning" ;
  solist_nn_1 = mkN "solist" "solister" ;
  solistisk_av_1 = mkA "solistisk" ;
  solitaer_av_1 = mkA "solitдr" ;
  solitaer_nn_1 = mkN "solitдr" "solitдrer" ;
  solkatt_nn_1 = mkN "solkatt" "solkatter" ;
  solkig_av_1 = mkA "solkig" ;
  solklaenning_nn_1 = mkN "solklдnning" ;
  solklar_av_1 = mkA "solklar" ;
  solkraem_nn_1 = mkN "solkrдm" "solkrдmer" ;
  solliknande_av_1 = mkA "solliknande" ;
  solljus_nn_1 = mkN "solljus" neutrum ;
  solmateria_nn_1 = mkN "solmateria" "solmaterian" "solmaterier" "solmaterierna" ;
  solmogen_av_1 = mkA "solmogen" "solmoget" ;
  solnedgaang_nn_1 = mkN "solnedgеng" ;
  solo_av_1 = mkA "solo" ;
  solo_nn_1 = mkN "solo" "solot" "solon" "solona" ;
  solochvaarare_nn_1 = mkN "solochvеrare" "solochvеrare" ;
  soloega_nn_1 = mkN "solцga" "solцgat" "solцgon" "solцgonen" ;
  solokvist_av_1 = mkA "solokvist" ;
  sololja_nn_1 = mkN "sololja" ;
  solraett_ab_1 = mkAdv "solrдtt" ;
  solreflex_nn_1 = mkN "solreflex" "solreflexer" ;
  solroerelse_nn_1 = mkN "solrцrelse" "solrцrelser" ;
  solsida_nn_1 = mkN "solsida" ;
  solskydd_nn_1 = mkN "solskydd" neutrum ;
  solskyddsmedel_nn_1 = mkN "solskyddsmedel" neutrum ;
  solsnibb_nn_1 = mkN "solsnibb" ;
  solstekt_av_1 = mkA "solstekt" "solstekt" ;
  solstol_nn_1 = mkN "solstol" ;
  solstraale_nn_1 = mkN "solstrеle" utrum ;
  solstraalning_nn_1 = mkN "solstrеlning" ;
  solsystem_nn_1 = mkN "solsystem" neutrum ;
  soltak_nn_1 = mkN "soltak" neutrum ;
  soltimme_nn_1 = mkN "soltimme" utrum ;
  soluppgaang_nn_1 = mkN "soluppgеng" ;
  solur_nn_1 = mkN "solur" neutrum ;
  solution_nn_1 = mkN "solution" "solutioner" ;
  solv_nn_1 = mkN "solv" neutrum ;
  solvarg_nn_1 = mkN "solvarg" ;
  solvarv_nn_1 = mkN "solvarv" neutrum ;
  solvent_av_1 = mkA "solvent" "solvent" ;
  solventil_nn_1 = mkN "solventil" "solventiler" ;
  solvkaepp_nn_1 = mkN "solvkдpp" ;
  som_ab_1 = mkAdv "som" ;
  somalier_nn_1 = mkN "somalier" "somaliern" "somalier" "somalierna" ;
  somalisk_av_1 = mkA "somalisk" ;
  somatiker_nn_1 = mkN "somatiker" "somatikern" "somatiker" "somatikerna" ;
  somatisk_av_1 = mkA "somatisk" ;
  sombrero_nn_1 = mkN "sombrero" "sombreror" ;
  sommar_nn_1 = mkN "sommar" ;
  sommaradress_nn_1 = mkN "sommaradress" "sommaradresser" ;
  sommaraktig_av_1 = mkA "sommaraktig" ;
  sommarbarn_nn_1 = mkN "sommarbarn" neutrum ;
  sommarbostad_nn_1 = mkN "sommarbostad" "sommarbostдder" ;
  sommardaeck_nn_1 = mkN "sommardдck" neutrum ;
  sommardag_nn_1 = mkN "sommardag" ;
  sommarfaagel_nn_1 = mkN "sommarfеgel" ;
  sommargaest_nn_1 = mkN "sommargдst" "sommargдster" ;
  sommargyllen_nn_1 = mkN "sommargyllen" neutrum ;
  sommargylling_nn_1 = mkN "sommargylling" ;
  sommarhalvaar_nn_1 = mkN "sommarhalvеr" neutrum ;
  sommarhatt_nn_1 = mkN "sommarhatt" ;
  sommarhem_nn_1 = mkN "sommarhem" "sommarhemmet" "sommarhem" "sommarhemmen" ;
  sommarhus_nn_1 = mkN "sommarhus" neutrum ;
  sommarjobb_nn_1 = mkN "sommarjobb" neutrum ;
  sommarlaeger_nn_1 = mkN "sommarlдger" neutrum ;
  sommarland_nn_1 = mkN "sommarland" neutrum ;
  sommarlig_av_1 = mkA "sommarlig" ;
  sommarlov_nn_1 = mkN "sommarlov" neutrum ;
  sommarmoln_nn_1 = mkN "sommarmoln" neutrum ;
  sommarnoeje_nn_1 = mkN "sommarnцje" ;
  sommarparadis_nn_1 = mkN "sommarparadis" neutrum ;
  sommarpotatis_nn_1 = mkN "sommarpotatis" ;
  sommarsemester_nn_1 = mkN "sommarsemester" ;
  sommarstuga_nn_1 = mkN "sommarstuga" ;
  sommartorp_nn_1 = mkN "sommartorp" neutrum ;
  sommarvaeder_nn_1 = mkN "sommarvдder" neutrum ;
  sommarvilla_nn_1 = mkN "sommarvilla" ;
  sommarvind_nn_1 = mkN "sommarvind" ;
  sommarvistelse_nn_1 = mkN "sommarvistelse" "sommarvistelser" ;
  somnambul_av_1 = mkA "somnambul" ;
  somnambul_nn_1 = mkN "somnambul" "somnambuler" ;
  somnambulisk_av_1 = mkA "somnambulisk" ;
  son_nn_1 = mkN "son" "sцner" ;
  sonant_nn_1 = mkN "sonant" "sonanter" ;
  sonantisk_av_1 = mkA "sonantisk" ;
  sonat_nn_1 = mkN "sonat" "sonater" ;
  sonatin_nn_1 = mkN "sonatin" "sonatiner" ;
  sond_nn_1 = mkN "sond" "sonder" ;
  sondotter_nn_1 = mkN "sondotter" "sondottern" "sondцttrar" "sondцttrarna" ;
  sonett_nn_1 = mkN "sonett" "sonetter" ;
  sonika_ab_1 = mkAdv "sonika" ;
  sonisk_av_1 = mkA "sonisk" ;
  sonlig_av_1 = mkA "sonlig" ;
  sonnamn_nn_1 = mkN "sonnamn" neutrum ;
  sonor_av_1 = mkA "sonor" ;
  sonoritet_nn_1 = mkN "sonoritet" "sonoriteter" ;
  sonson_nn_1 = mkN "sonson" "sonsцner" ;
  sop_nn_1 = mkN "sop" ;
  sopaakare_nn_1 = mkN "sopеkare" "sopеkare" ;
  sopbacke_nn_1 = mkN "sopbacke" utrum ;
  sopbil_nn_1 = mkN "sopbil" ;
  sopborste_nn_1 = mkN "sopborste" utrum ;
  sopnedkast_nn_1 = mkN "sopnedkast" neutrum ;
  sopp_nn_1 = mkN "sopp" ;
  soppig_av_1 = mkA "soppig" ;
  soppkoek_nn_1 = mkN "soppkцk" neutrum ;
  sopprot_nn_1 = mkN "sopprot" "sopprцtter" ;
  soppskaal_nn_1 = mkN "soppskеl" ;
  soppslev_nn_1 = mkN "soppslev" ;
  sopran_nn_1 = mkN "sopran" "sopraner" ;
  sopskyffel_nn_1 = mkN "sopskyffel" ;
  soptipp_nn_1 = mkN "soptipp" ;
  sorb_nn_1 = mkN "sorb" "sorber" ;
  sordin_nn_1 = mkN "sordin" "sordiner" ;
  sorg_nn_1 = mkN "sorg" "sorger" ;
  sorgband_nn_1 = mkN "sorgband" neutrum ;
  sorgbarn_nn_1 = mkN "sorgbarn" neutrum ;
  sorgbunden_av_1 = mkA "sorgbunden" "sorgbundet" ;
  sorgdraekt_nn_1 = mkN "sorgdrдkt" "sorgdrдkter" ;
  sorgeaar_nn_1 = mkN "sorgeеr" neutrum ;
  sorgeaemne_nn_1 = mkN "sorgeдmne" ;
  sorgeakt_nn_1 = mkN "sorgeakt" "sorgeakter" ;
  sorgebarn_nn_1 = mkN "sorgebarn" neutrum ;
  sorgebud_nn_1 = mkN "sorgebud" neutrum ;
  sorgedag_nn_1 = mkN "sorgedag" ;
  sorgesam_av_1 = mkA "sorgesam" "sorgesamt" "sorgesamma" "sorgesamma" "sorgesammare" "sorgesammast" "sorgesammaste" ;
  sorgespel_nn_1 = mkN "sorgespel" "sorgespelet" "sorgespel" "sorgespelen" ;
  sorgfaellig_av_1 = mkA "sorgfдllig" ;
  sorgfaerg_nn_1 = mkN "sorgfдrg" "sorgfдrger" ;
  sorgflor_nn_1 = mkN "sorgflor" neutrum ;
  sorgfri_av_1 = mkA "sorgfri" "sorgfritt" ;
  sorgkant_nn_1 = mkN "sorgkant" "sorgkanter" ;
  sorgklaedd_av_1 = mkA "sorgklдdd" "sorgklдdtt" ;
  sorglig_av_1 = mkA "sorglig" ;
  sorgloes_av_1 = mkA "sorglцs" ;
  sorglustig_av_1 = mkA "sorglustig" ;
  sorgmantel_nn_1 = mkN "sorgmantel" ;
  sorgmodig_av_1 = mkA "sorgmodig" ;
  sorgpil_nn_1 = mkN "sorgpil" ;
  sorgsen_av_1 = mkA "sorgsen" "sorgset" ;
  sorgsloeja_nn_1 = mkN "sorgslцja" ;
  sorgtyngd_av_1 = mkA "sorgtyngd" "sorgtyngt" ;
  sork_nn_1 = mkN "sork" ;
  sort_nn_1 = mkN "sort" "sorter" ;
  sorterare_nn_1 = mkN "sorterare" "sorterare" ;
  sortering_nn_1 = mkN "sortering" ;
  sorti_nn_1 = mkN "sorti" "sortier" ;
  sortiment_nn_1 = mkN "sortiment" neutrum ;
  sorts_av_1 = mkA "sorts" ;
  sosse_nn_1 = mkN "sosse" utrum ;
  sotare_nn_1 = mkN "sotare" "sotare" ;
  sotarmurre_nn_1 = mkN "sotarmurre" utrum ;
  soteld_nn_1 = mkN "soteld" ;
  sotig_av_1 = mkA "sotig" ;
  sotis_av_1 = mkA "sotis" ;
  sotmoln_nn_1 = mkN "sotmoln" neutrum ;
  sotpartikel_nn_1 = mkN "sotpartikel" ;
  sotskikt_nn_1 = mkN "sotskikt" neutrum ;
  sotsvamp_nn_1 = mkN "sotsvamp" ;
  sottis_nn_1 = mkN "sottis" "sottiser" ;
  soulagemang_nn_1 = mkN "soulagemang" neutrum ;
  sound_nn_1 = mkN "sound" neutrum ;
  sousafon_nn_1 = mkN "sousafon" "sousafoner" ;
  souschef_nn_1 = mkN "souschef" "souschefer" ;
  souterrainvaaning_nn_1 = mkN "souterrainvеning" ;
  souvenir_nn_1 = mkN "souvenir" "souvenirer" ;
  sovchos_nn_1 = mkN "sovchos" "sovchoser" ;
  sovjet_nn_1 = mkN "sovjet" "sovjeter" ;
  sovjetisk_av_1 = mkA "sovjetisk" ;
  sovjetmedborgare_nn_1 = mkN "sovjetmedborgare" "sovjetmedborgare" ;
  sovjetrepublik_nn_1 = mkN "sovjetrepublik" "sovjetrepubliker" ;
  sovjetrysk_av_1 = mkA "sovjetrysk" ;
  sovmorgon_nn_1 = mkN "sovmorgon" "sovmorgonen" "sovmorgnar" "sovmorgnarna" ;
  sovplats_nn_1 = mkN "sovplats" "sovplatser" ;
  sovrum_nn_1 = mkN "sovrum" "sovrummet" "sovrum" "sovrummen" ;
  sovsaeck_nn_1 = mkN "sovsдck" ;
  sovsal_nn_1 = mkN "sovsal" ;
  sovstad_nn_1 = mkN "sovstad" "sovstдder" ;
  sovstaellning_nn_1 = mkN "sovstдllning" ;
  sovvagn_nn_1 = mkN "sovvagn" ;
  spaadom_nn_1 = mkN "spеdom" ;
  spaakvinna_nn_1 = mkN "spеkvinna" ;
  spaaman_nn_1 = mkN "spеman" "spеmannen" "spеmдn" "spеmдnnen" ;
  spaan_nn_1 = mkN "spеn" neutrum ;
  spaanad_nn_1 = mkN "spеnad" "spеnader" ;
  spaang_nn_1 = mkN "spеng" ;
  spaanklaedd_av_1 = mkA "spеnklдdd" ;
  spaankorg_nn_1 = mkN "spеnkorg" ;
  spaant_nn_1 = mkN "spеnt" "spеnter" ;
  spaar_nn_1 = mkN "spеr" neutrum ;
  spaaraemne_nn_1 = mkN "spеrдmne" ;
  spaarelement_nn_1 = mkN "spеrelement" neutrum ;
  spaarhund_nn_1 = mkN "spеrhund" ;
  spaarljus_nn_1 = mkN "spеrljus" neutrum ;
  spaarloes_av_1 = mkA "spеrlцs" ;
  spaarning_nn_1 = mkN "spеrning" ;
  spaarvaeg_nn_1 = mkN "spеrvдg" ;
  spaarvaegschef_nn_1 = mkN "spеrvдgschef" "spеrvдgschefer" ;
  spaarvagn_nn_1 = mkN "spеrvagn" ;
  spaarvidd_nn_1 = mkN "spеrvidd" "spеrvidder" ;
  spackel_nn_2 = mkN "spackel" ;
  spade_nn_1 = mkN "spade" utrum ;
  spader_nn_1 = mkN "spader" "spadern" "spader" "spaderna" ;
  spadtag_nn_1 = mkN "spadtag" neutrum ;
  spaeckhuggare_nn_1 = mkN "spдckhuggare" "spдckhuggare" ;
  spaed_av_1 = mkA "spдd" ;
  spaedbarn_nn_1 = mkN "spдdbarn" neutrum ;
  spaedgris_nn_1 = mkN "spдdgris" ;
  spaend_av_1 = mkA "spдnd" ;
  spaenn_nn_1 = mkN "spдnn" "spдnnen" "spдnn" "spдnnen" ;
  spaennande_av_1 = mkA "spдnnande" ;
  spaennbuckla_nn_1 = mkN "spдnnbuckla" ;
  spaenning_nn_1 = mkN "spдnning" ;
  spaenningsdelare_nn_1 = mkN "spдnningsdelare" "spдnningsdelare" ;
  spaenningsregulator_nn_1 = mkN "spдnningsregulator" "spдnningsregulatorer" ;
  spaenningssoekare_nn_1 = mkN "spдnningssцkare" "spдnningssцkare" ;
  spaennram_nn_1 = mkN "spдnnram" ;
  spaennvidd_nn_1 = mkN "spдnnvidd" "spдnnvidder" ;
  spaens_nn_1 = mkN "spдns" "spдnser" ;
  spaenstig_av_1 = mkA "spдnstig" ;
  spaerr_nn_1 = mkN "spдrr" ;
  spaerrballong_nn_1 = mkN "spдrrballong" "spдrrballonger" ;
  spaerrkonto_nn_1 = mkN "spдrrkonto" "spдrrkontot" "spдrrkonton" "spдrrkontona" ;
  spaerrlinje_nn_1 = mkN "spдrrlinje" "spдrrlinjer" ;
  spaerrvakt_nn_1 = mkN "spдrrvakt" "spдrrvakter" ;
  spak_av_1 = mkA "spak" ;
  spak_nn_1 = mkN "spak" ;
  spalje_nn_1 = mkN "spaljй" "spaljйer" ;
  spalt_nn_1 = mkN "spalt" "spalter" ;
  spaltfyllnad_nn_1 = mkN "spaltfyllnad" "spaltfyllnader" ;
  spaltkorrektur_nn_1 = mkN "spaltkorrektur" neutrum ;
  spanare_nn_1 = mkN "spanare" "spanare" ;
  spaniel_nn_1 = mkN "spaniel" "spanieln" "spanielar" "spanielarna" ;
  spaning_nn_1 = mkN "spaning" ;
  spanjolett_nn_1 = mkN "spanjolett" "spanjoletter" ;
  spanjor_nn_1 = mkN "spanjor" "spanjoren" "spanjorer" "spanjorerna" ;
  spanjorska_nn_1 = mkN "spanjorska" ;
  spann_nn_1 = mkN "spann" ;
  spann_nn_2 = mkN "spann" ;
  spann_nn_3 = mkN "spann" neutrum ;
  spansk_av_1 = mkA "spansk" ;
  spanskroer_nn_1 = mkN "spanskrцr" neutrum ;
  spant_nn_1 = mkN "spant" neutrum ;
  sparagmit_nn_1 = mkN "sparagmit" "sparagmiter" ;
  sparare_nn_1 = mkN "sparare" "sparare" ;
  sparbank_nn_1 = mkN "sparbank" "sparbanker" ;
  spargris_nn_1 = mkN "spargris" ;
  spark_nn_1 = mkN "spark" ;
  sparkassa_nn_1 = mkN "sparkassa" ;
  sparkcykel_nn_1 = mkN "sparkcykel" ;
  sparkdraekt_nn_1 = mkN "sparkdrдkt" "sparkdrдkter" ;
  sparkstoetting_nn_1 = mkN "sparkstцtting" ;
  sparlaan_nn_1 = mkN "sparlеn" neutrum ;
  sparlakan_nn_1 = mkN "sparlakan" neutrum ;
  sparre_nn_1 = mkN "sparre" utrum ;
  sparring_nn_1 = mkN "sparring" ;
  sparringpartner_nn_1 = mkN "sparringpartner" "sparringpartnern" "sparringpartner" "sparringpartnerna" ;
  sparris_nn_1 = mkN "sparris" ;
  sparsam_av_1 = mkA "sparsam" "sparsamt" "sparsamma" "sparsamma" "sparsammare" "sparsammast" "sparsammaste" ;
  sparslant_nn_1 = mkN "sparslant" ;
  spartakist_nn_1 = mkN "spartakist" "spartakister" ;
  spartan_nn_1 = mkN "spartan" "spartaner" ;
  spartansk_av_1 = mkA "spartansk" ;
  sparv_nn_1 = mkN "sparv" ;
  sparvfink_nn_1 = mkN "sparvfink" ;
  sparvhoek_nn_1 = mkN "sparvhцk" ;
  spasm_nn_1 = mkN "spasm" "spasmer" ;
  spasmodisk_av_1 = mkA "spasmodisk" ;
  spasticitet_nn_1 = mkN "spasticitet" "spasticiteter" ;
  spastiker_nn_1 = mkN "spastiker" "spastikern" "spastiker" "spastikerna" ;
  spastisk_av_1 = mkA "spastisk" ;
  spatel_nn_1 = mkN "spatel" ;
  spatial_av_1 = mkA "spatial" ;
  spatioes_av_1 = mkA "spatiцs" ;
  spatium_nn_1 = mkN "spatium" "spatiet" "spatier" "spatierna" ;
  spattig_av_1 = mkA "spattig" ;
  speaker_nn_1 = mkN "speaker" "speakern" "speaker" "speakerna" ;
  speceriaffaer_nn_1 = mkN "speceriaffдr" "speceriaffдrer" ;
  specerihandlare_nn_1 = mkN "specerihandlare" "specerihandlare" ;
  specerist_nn_1 = mkN "specerist" "specerister" ;
  special_nn_1 = mkN "special" "specialer" ;
  specialare_nn_1 = mkN "specialare" "specialare" ;
  specialbegaavning_nn_1 = mkN "specialbegеvning" ;
  specialdomstol_nn_1 = mkN "specialdomstol" ;
  specialist_nn_1 = mkN "specialist" "specialister" ;
  specialitet_nn_1 = mkN "specialitet" "specialiteter" ;
  specialklass_nn_1 = mkN "specialklass" "specialklasser" ;
  speciallaerare_nn_1 = mkN "speciallдrare" "speciallдrare" ;
  specialnummer_nn_1 = mkN "specialnummer" neutrum ;
  specialomraade_nn_1 = mkN "specialomrеde" ;
  specialstudium_nn_1 = mkN "specialstudium" "specialstudiet" "specialstudier" "specialstudierna" ;
  specialstyrka_nn_1 = mkN "specialstyrka" ;
  specie_nn_1 = mkN "specie" "specier" ;
  speciell_av_1 = mkA "speciell" ;
  species_nn_1 = mkN "species" neutrum ;
  specifik_av_1 = mkA "specifik" ;
  specifikation_nn_1 = mkN "specifikation" "specifikationer" ;
  specimen_nn_1 = mkN "specimen" neutrum ;
  spedition_nn_1 = mkN "spedition" "speditioner" ;
  speditoer_nn_1 = mkN "speditцr" "speditцrer" ;
  spefaagel_nn_1 = mkN "spefеgel" ;
  spefull_av_1 = mkA "spefull" ;
  spefylld_av_1 = mkA "spefylld" "spefyllt" ;
  spegel_nn_1 = mkN "spegel" ;
  spegelbild_nn_1 = mkN "spegelbild" "spegelbilder" ;
  spegelfaekteri_nn_1 = mkN "spegelfдkteri" "spegelfдkterit" "spegelfдkterier" "spegelfдkterierna" ;
  spegelfaektning_nn_1 = mkN "spegelfдktning" ;
  spegelglas_nn_1 = mkN "spegelglas" neutrum ;
  spegelmonogram_nn_1 = mkN "spegelmonogram" "spegelmonogrammet" "spegelmonogram" "spegelmonogrammen" ;
  spegelreflexkamera_nn_1 = mkN "spegelreflexkamera" ;
  spegelteleskop_nn_1 = mkN "spegelteleskop" neutrum ;
  spegelvaend_av_1 = mkA "spegelvдnd" ;
  spejare_nn_1 = mkN "spejare" "spejare" ;
  spektakel_nn_1 = mkN "spektakel" neutrum ;
  spektakulaer_av_1 = mkA "spektakulдr" ;
  spektral_av_1 = mkA "spektral" ;
  spektralapparat_nn_1 = mkN "spektralapparat" "spektralapparater" ;
  spektrallinje_nn_1 = mkN "spektrallinje" "spektrallinjer" ;
  spektrograf_nn_1 = mkN "spektrograf" "spektrografer" ;
  spektroskop_nn_1 = mkN "spektroskop" neutrum ;
  spektrum_nn_1 = mkN "spektrum" neutrum ;
  spekulant_nn_1 = mkN "spekulant" "spekulanter" ;
  spekulation_nn_1 = mkN "spekulation" "spekulationer" ;
  spekulativ_av_1 = mkA "spekulativ" ;
  spel_nn_1 = mkN "spel" neutrum ;
  spelaar_nn_1 = mkN "spelеr" neutrum ;
  spelarbyte_nn_1 = mkN "spelarbyte" ;
  spelare_nn_1 = mkN "spelare" "spelare" ;
  spelautomat_nn_1 = mkN "spelautomat" "spelautomater" ;
  spelbar_av_1 = mkA "spelbar" ;
  spelbord_nn_1 = mkN "spelbord" neutrum ;
  speldrama_nn_1 = mkN "speldrama" "speldramat" "speldraman" "speldramana" ;
  speleman_nn_1 = mkN "speleman" "spelemannen" "spelemдn" "spelemдnnen" ;
  speleolog_nn_1 = mkN "speleolog" "speleologer" ;
  spelevink_nn_1 = mkN "spelevink" ;
  spelfilm_nn_1 = mkN "spelfilm" "spelfilmer" ;
  spelkort_nn_1 = mkN "spelkort" neutrum ;
  spelman_nn_1 = mkN "spelman" "spelmannen" "spelmдn" "spelmдnnen" ;
  spelmani_nn_1 = mkN "spelmani" "spelmanier" ;
  spelmansstaemma_nn_1 = mkN "spelmansstдmma" ;
  spelmark_nn_1 = mkN "spelmark" "spelmarker" ;
  spelning_nn_1 = mkN "spelning" ;
  speloeppning_nn_1 = mkN "spelцppning" ;
  spelomgaang_nn_1 = mkN "spelomgеng" ;
  spelplan_nn_1 = mkN "spelplan" "spelplaner" ;
  spelprov_nn_1 = mkN "spelprov" neutrum ;
  spelregel_nn_1 = mkN "spelregel" "spelregeln" "spelregler" "spelreglerna" ;
  spelsugen_av_1 = mkA "spelsugen" "spelsuget" ;
  spelverk_nn_1 = mkN "spelverk" neutrum ;
  spenabarn_nn_1 = mkN "spenabarn" neutrum ;
  spene_nn_1 = mkN "spene" utrum ;
  spenordning_nn_1 = mkN "spenordning" ;
  spens_nn_1 = mkN "spens" "spenser" ;
  spenslig_av_1 = mkA "spenslig" ;
  spermabildning_nn_1 = mkN "spermabildning" ;
  spermadonator_nn_1 = mkN "spermadonator" "spermadonatorer" ;
  spermamottagarsaeck_nn_1 = mkN "spermamottagarsдck" ;
  spermatofor_nn_1 = mkN "spermatofor" "spermatoforen" "spermatoforer" "spermatoforerna" ;
  spermatozo_nn_1 = mkN "spermatozo" "spermatozon" "spermatozoer" "spermatozoerna" ;
  spermatozoid_nn_1 = mkN "spermatozoid" "spermatozoider" ;
  spermie_nn_1 = mkN "spermie" "spermier" ;
  spermiemitokondrie_nn_1 = mkN "spermiemitokondrie" "spermiemitokondrier" ;
  spermiemodercell_nn_1 = mkN "spermiemodercell" "spermiemoderceller" ;
  spetaelsk_av_1 = mkA "spetдlsk" ;
  spetig_av_1 = mkA "spetig" ;
  spets_nn_1 = mkN "spets" ;
  spetsartikel_nn_1 = mkN "spetsartikel" ;
  spetsbaage_nn_1 = mkN "spetsbеge" utrum ;
  spetsborgare_nn_1 = mkN "spetsborgare" "spetsborgare" ;
  spetsbov_nn_1 = mkN "spetsbov" ;
  spetsfundig_av_1 = mkA "spetsfundig" ;
  spetsfundighet_nn_1 = mkN "spetsfundighet" "spetsfundigheter" ;
  spetsglas_nn_1 = mkN "spetsglas" neutrum ;
  spetshund_nn_1 = mkN "spetshund" ;
  spetsig_av_1 = mkA "spetsig" ;
  spetsvinklig_av_1 = mkA "spetsvinklig" ;
  spett_nn_1 = mkN "spett" neutrum ;
  spex_nn_1 = mkN "spex" neutrum ;
  spexig_av_1 = mkA "spexig" ;
  spicken_av_1 = mkA "spicken" "spicket" ;
  spigg_nn_1 = mkN "spigg" ;
  spik_ab_1 = mkAdv "spik" ;
  spik_nn_1 = mkN "spik" ;
  spikning_nn_1 = mkN "spikning" ;
  spikpiano_nn_1 = mkN "spikpiano" "spikpianot" "spikpianon" "spikpianona" ;
  spikpistol_nn_1 = mkN "spikpistol" "spikpistoler" ;
  spikrak_av_1 = mkA "spikrak" ;
  spiksaeker_av_1 = mkA "spiksдker" "spiksдkert" "spiksдkra" "spiksдkra" "spiksдkrare" "spiksдkrast" "spiksдkraste" ;
  spiksko_nn_1 = mkN "spiksko" "spikskor" ;
  spilkum_nn_1 = mkN "spilkum" ;
  spillra_nn_1 = mkN "spillra" ;
  spillvatten_nn_1 = mkN "spillvatten" "spillvattnet" "spillvatten" "spillvattnen" ;
  spin_nn_1 = mkN "spin" "spinnet" "spin" "spinnen" ;
  spin_off_nn_1 = mkN "spin-off" "spin-offer" ;
  spinal_av_1 = mkA "spinal" ;
  spinalanestesi_nn_1 = mkN "spinalanestesi" "spinalanestesier" ;
  spinalganglie_nn_1 = mkN "spinalganglie" "spinalganglier" ;
  spindel_nn_1 = mkN "spindel" ;
  spindelbult_nn_1 = mkN "spindelbult" ;
  spindeldjur_nn_1 = mkN "spindeldjur" neutrum ;
  spindelnaet_nn_1 = mkN "spindelnдt" neutrum ;
  spindeltraad_nn_1 = mkN "spindeltrеd" ;
  spindeltunn_av_1 = mkA "spindeltunn" "spindeltunt" ;
  spindelvaev_nn_1 = mkN "spindelvдv" ;
  spinell_nn_1 = mkN "spinell" "spineller" ;
  spinett_nn_1 = mkN "spinett" "spinetter" ;
  spinkig_av_1 = mkA "spinkig" ;
  spinn_nn_1 = mkN "spinn" neutrum ;
  spinna_vb_1 = mkV "spinna" "spann" "spunnit" ;
  spinnaker_nn_1 = mkN "spinnaker" ;
  spinnakerbom_nn_1 = mkN "spinnakerbom" "spinnakerbommen" "spinnakerbommar" "spinnakerbommarna" ;
  spinnare_nn_1 = mkN "spinnare" "spinnare" ;
  spinnarfjaeril_nn_1 = mkN "spinnarfjдril" ;
  spinneri_nn_1 = mkN "spinneri" "spinnerit" "spinnerier" "spinnerierna" ;
  spinnhus_nn_1 = mkN "spinnhus" neutrum ;
  spinnkvalster_nn_1 = mkN "spinnkvalster" neutrum ;
  spinnrock_nn_1 = mkN "spinnrock" ;
  spinnrulle_nn_1 = mkN "spinnrulle" utrum ;
  spinnspoe_nn_1 = mkN "spinnspц" "spinnspцet" "spinnspцn" "spinnspцna" ;
  spion_nn_1 = mkN "spion" "spioner" ;
  spioneri_nn_1 = mkN "spioneri" "spionerit" "spionerier" "spionerierna" ;
  spionflygning_nn_1 = mkN "spionflygning" ;
  spionkamera_nn_1 = mkN "spionkamera" ;
  spiral_nn_1 = mkN "spiral" "spiraler" ;
  spiralblock_nn_1 = mkN "spiralblock" neutrum ;
  spiralbotten_nn_1 = mkN "spiralbotten" ;
  spiralfjaeder_nn_1 = mkN "spiralfjдder" ;
  spiralgalax_nn_1 = mkN "spiralgalax" "spiralgalaxer" ;
  spirant_nn_1 = mkN "spirant" "spiranter" ;
  spirill_nn_1 = mkN "spirill" "spiriller" ;
  spiritist_nn_1 = mkN "spiritist" "spiritister" ;
  spiritualist_nn_1 = mkN "spiritualist" "spiritualister" ;
  spiritualitet_nn_1 = mkN "spiritualitet" "spiritualiteter" ;
  spirituell_av_1 = mkA "spirituell" ;
  spirituoes_av_1 = mkA "spirituцs" ;
  spiroket_nn_1 = mkN "spiroket" "spiroketer" ;
  spis_nn_1 = mkN "spis" ;
  spisare_nn_1 = mkN "spisare" "spisare" ;
  spisel_nn_1 = mkN "spisel" ;
  spiselhaell_nn_1 = mkN "spiselhдll" ;
  spiselkrans_nn_1 = mkN "spiselkrans" ;
  spiselkrok_nn_1 = mkN "spiselkrok" ;
  spiselvraa_nn_1 = mkN "spiselvrе" "spiselvrеn" "spiselvrеr" "spiselvrеrna" ;
  spishaell_nn_1 = mkN "spishдll" ;
  spiskammare_nn_1 = mkN "spiskammare" "spiskammaren" "spiskamrar" "spiskamrarna" ;
  spiskrans_nn_1 = mkN "spiskrans" ;
  spiskrok_nn_1 = mkN "spiskrok" ;
  spjaele_nn_1 = mkN "spjдle" utrum ;
  spjaell_nn_1 = mkN "spjдll" neutrum ;
  spjaellband_nn_1 = mkN "spjдllband" neutrum ;
  spjaelsaeng_nn_1 = mkN "spjдlsдng" ;
  spjaern_ab_1 = mkAdv "spjдrn" ;
  spjut_nn_1 = mkN "spjut" neutrum ;
  spjutspets_nn_1 = mkN "spjutspets" ;
  spjuver_nn_1 = mkN "spjuver" ;
  splejk_nn_1 = mkN "splejk" ;
  spliss_nn_1 = mkN "spliss" ;
  splits_nn_1 = mkN "splits" ;
  splitt_ab_1 = mkAdv "splitt" ;
  splitter_ab_1 = mkAdv "splitter" ;
  splitter_nn_1 = mkN "splitter" neutrum ;
  splitterbomb_nn_1 = mkN "splitterbomb" "splitterbomber" ;
  splitterny_av_1 = mkA "splitterny" "splitternytt" ;
  splittrare_nn_1 = mkN "splittrare" "splittrare" ;
  splittring_nn_1 = mkN "splittring" ;
  spoe_nn_1 = mkN "spц" "spцet" "spцn" "spцna" ;
  spoekaktig_av_1 = mkA "spцkaktig" ;
  spoekbild_nn_1 = mkN "spцkbild" "spцkbilder" ;
  spoekdjur_nn_1 = mkN "spцkdjur" neutrum ;
  spoekelse_nn_1 = mkN "spцkelse" "spцkelset" "spцkelser" "spцkelserna" ;
  spoekeri_nn_1 = mkN "spцkeri" "spцkerit" "spцkerier" "spцkerierna" ;
  spoekhistoria_nn_1 = mkN "spцkhistoria" "spцkhistorien" "spцkhistorier" "spцkhistorierna" ;
  spoeklik_av_1 = mkA "spцklik" ;
  spoekpartikel_nn_1 = mkN "spцkpartikel" ;
  spoekskrivare_nn_1 = mkN "spцkskrivare" "spцkskrivare" ;
  spoekstad_nn_1 = mkN "spцkstad" "spцkstдder" ;
  spoersmaal_nn_1 = mkN "spцrsmеl" neutrum ;
  spoestraff_nn_1 = mkN "spцstraff" neutrum ;
  spoiler_nn_1 = mkN "spoiler" "spoilern" "spoiler" "spoilerna" ;
  spolarvaetska_nn_1 = mkN "spolarvдtska" ;
  spole_nn_1 = mkN "spole" utrum ;
  spolformig_av_1 = mkA "spolformig" ;
  spoling_nn_1 = mkN "spoling" ;
  spolmask_nn_1 = mkN "spolmask" ;
  sponde_nn_1 = mkN "spondй" "spondйer" ;
  spondylit_nn_1 = mkN "spondylit" "spondyliter" ;
  sponsor_nn_1 = mkN "sponsor" "sponsorer" ;
  spont_nn_1 = mkN "spont" "sponter" ;
  spontan_av_1 = mkA "spontan" ;
  spontanitet_nn_1 = mkN "spontanitet" "spontaniteter" ;
  spor_nn_1 = mkN "spor" "sporen" "sporer" "sporerna" ;
  sporadisk_av_1 = mkA "sporadisk" ;
  sporangium_nn_1 = mkN "sporangium" "sporangiet" "sporangier" "sporangierna" ;
  sporbildande_av_1 = mkA "sporbildande" ;
  spordjur_nn_1 = mkN "spordjur" neutrum ;
  sporkapsel_nn_1 = mkN "sporkapsel" ;
  sporre_nn_1 = mkN "sporre" utrum ;
  sporsaeck_nn_1 = mkN "sporsдck" ;
  sport_nn_1 = mkN "sport" "sporter" ;
  sportaffaer_nn_1 = mkN "sportaffдr" "sportaffдrer" ;
  sportbil_nn_1 = mkN "sportbil" ;
  sportdykning_nn_1 = mkN "sportdykning" ;
  sportfaane_nn_1 = mkN "sportfеne" utrum ;
  sportfiskemetod_nn_1 = mkN "sportfiskemetod" "sportfiskemetoder" ;
  sportflygplan_nn_1 = mkN "sportflygplan" neutrum ;
  sportgren_nn_1 = mkN "sportgren" "sportgrenen" "sportgrenar" "sportgrenarna" ;
  sportig_av_1 = mkA "sportig" ;
  sportklubb_nn_1 = mkN "sportklubb" ;
  sportlov_nn_1 = mkN "sportlov" neutrum ;
  sportmodell_nn_1 = mkN "sportmodell" "sportmodeller" ;
  sportsida_nn_1 = mkN "sportsida" ;
  sportslig_av_1 = mkA "sportslig" ;
  sportsman_nn_1 = mkN "sportsman" "sportsmannen" "sportsmдn" "sportsmдnnen" ;
  sportstuga_nn_1 = mkN "sportstuga" ;
  sportvagn_nn_1 = mkN "sportvagn" ;
  sporvaext_nn_1 = mkN "sporvдxt" "sporvдxter" ;
  spotlight_nn_1 = mkN "spotlight" "spotlighten" "spotlights" "spotlightsen" ;
  spotsk_av_1 = mkA "spotsk" ;
  spottkoertel_nn_1 = mkN "spottkцrtel" ;
  spottstrit_nn_1 = mkN "spottstrit" ;
  spottstyver_nn_1 = mkN "spottstyver" ;
  spov_nn_1 = mkN "spov" ;
  spraak_nn_1 = mkN "sprеk" neutrum ;
  spraakanvaendning_nn_1 = mkN "sprеkanvдndning" ;
  spraakcentrum_nn_1 = mkN "sprеkcentrum" neutrum ;
  spraakdraekt_nn_1 = mkN "sprеkdrдkt" "sprеkdrдkter" ;
  spraakfaerdighet_nn_1 = mkN "sprеkfдrdighet" "sprеkfдrdigheter" ;
  spraakfamilj_nn_1 = mkN "sprеkfamilj" "sprеkfamiljer" ;
  spraakform_nn_1 = mkN "sprеkform" "sprеkformer" ;
  spraakforskare_nn_1 = mkN "sprеkforskare" "sprеkforskare" ;
  spraakgrupp_nn_1 = mkN "sprеkgrupp" "sprеkgrupper" ;
  spraakkunnig_av_1 = mkA "sprеkkunnig" ;
  spraaklaboratorium_nn_1 = mkN "sprеklaboratorium" "sprеklaboratoriet" "sprеklaboratorier" "sprеklaboratorierna" ;
  spraaklaera_nn_1 = mkN "sprеklдra" ;
  spraaklaerare_nn_1 = mkN "sprеklдrare" "sprеklдrare" ;
  spraaklig_av_1 = mkA "sprеklig" ;
  spraakljud_nn_1 = mkN "sprеkljud" neutrum ;
  spraakprov_nn_1 = mkN "sprеkprov" neutrum ;
  spraakriktig_av_1 = mkA "sprеkriktig" ;
  spraakriktighet_nn_1 = mkN "sprеkriktighet" "sprеkriktigheter" ;
  spraakroer_nn_1 = mkN "sprеkrцr" neutrum ;
  spraaksam_av_1 = mkA "sprеksam" "sprеksamt" "sprеksamma" "sprеksamma" "sprеksammare" "sprеksammast" "sprеksammaste" ;
  spraakstam_nn_1 = mkN "sprеkstam" "sprеkstammen" "sprеkstammar" "sprеkstammarna" ;
  spraakstrid_nn_1 = mkN "sprеkstrid" "sprеkstrider" ;
  spraaktecken_nn_1 = mkN "sprеktecken" "sprеktecknet" "sprеktecken" "sprеktecknen" ;
  spraakteori_nn_1 = mkN "sprеkteori" "sprеkteorier" ;
  spraakvaardare_nn_1 = mkN "sprеkvеrdare" "sprеkvеrdare" ;
  spraakvetare_nn_1 = mkN "sprеkvetare" "sprеkvetare" ;
  spraakvetenskap_nn_1 = mkN "sprеkvetenskap" "sprеkvetenskaper" ;
  spraang_nn_1 = mkN "sprеng" neutrum ;
  spraangmarsch_nn_1 = mkN "sprеngmarsch" "sprеngmarscher" ;
  spraangsegel_nn_1 = mkN "sprеngsegel" neutrum ;
  spraangvis_ab_1 = mkAdv "sprеngvis" ;
  spraecklig_av_1 = mkA "sprдcklig" ;
  spraengaemne_nn_1 = mkN "sprдngдmne" ;
  spraengaemnesmolekyl_nn_1 = mkN "sprдngдmnesmolekyl" "sprдngдmnesmolekyler" ;
  spraengaemnespatron_nn_1 = mkN "sprдngдmnespatron" "sprдngдmnespatroner" ;
  spraengarbetsplats_nn_1 = mkN "sprдngarbetsplats" "sprдngarbetsplatser" ;
  spraengfylld_av_1 = mkA "sprдngfylld" "sprдngfyllt" ;
  spraenggas_nn_1 = mkN "sprдnggas" "sprдnggaser" ;
  spraengkapsel_nn_1 = mkN "sprдngkapsel" ;
  spraengladdning_nn_1 = mkN "sprдngladdning" ;
  spraenglaerd_av_1 = mkA "sprдnglдrd" "sprдnglдrt" ;
  spraengning_nn_1 = mkN "sprдngning" ;
  spraengstoff_nn_1 = mkN "sprдngstoff" neutrum ;
  spraett_nn_1 = mkN "sprдtt" ;
  spraettbaage_nn_1 = mkN "sprдttbеge" utrum ;
  spraetthoek_nn_1 = mkN "sprдtthцk" ;
  spraettig_av_1 = mkA "sprдttig" ;
  sprakfaale_nn_1 = mkN "sprakfеle" utrum ;
  sprallig_av_1 = mkA "sprallig" ;
  spratt_nn_1 = mkN "spratt" neutrum ;
  sprattelgubbe_nn_1 = mkN "sprattelgubbe" utrum ;
  spray_nn_1 = mkN "spray" "sprayen" "sprayer" "sprayerna" ;
  sprej_nn_1 = mkN "sprej" "sprejer" ;
  spretig_av_1 = mkA "spretig" ;
  spri_nn_1 = mkN "spri" "sprit" "sprin" "sprien" ;
  spricka_vb_1 = mkV "spricka" "sprack" "spruckit" ;
  sprickbildning_nn_1 = mkN "sprickbildning" ;
  sprickdal_nn_1 = mkN "sprickdal" ;
  sprickfaerdig_av_1 = mkA "sprickfдrdig" ;
  sprickig_av_1 = mkA "sprickig" ;
  sprida_vb_1 = mkV "sprida" "spred" "spritt" ;
  spridare_nn_1 = mkN "spridare" "spridare" ;
  spridd_av_1 = mkA "spridd" ;
  spridning_nn_1 = mkN "spridning" ;
  spridningslins_nn_1 = mkN "spridningslins" "spridningslinser" ;
  spridningsmaatt_nn_1 = mkN "spridningsmеtt" neutrum ;
  spring_nn_2 = mkN "spring" neutrum ;
  springa_vb_1 = mkV "springa" "sprang" "sprungit" ;
  springare_nn_1 = mkN "springare" "springare" ;
  springbock_nn_1 = mkN "springbock" ;
  springbrunn_nn_1 = mkN "springbrunn" ;
  springmask_nn_1 = mkN "springmask" ;
  springpojke_nn_1 = mkN "springpojke" utrum ;
  springschas_nn_1 = mkN "springschas" ;
  springstilett_nn_1 = mkN "springstilett" "springstiletter" ;
  springvatten_nn_1 = mkN "springvatten" "springvattnet" "springvatten" "springvattnen" ;
  springvikarie_nn_1 = mkN "springvikarie" "springvikarier" ;
  sprinkler_nn_1 = mkN "sprinkler" "sprinklern" "sprinkler" "sprinklerna" ;
  sprinkleranlaeggning_nn_1 = mkN "sprinkleranlдggning" ;
  sprinklersystem_nn_1 = mkN "sprinklersystem" neutrum ;
  sprint_nn_1 = mkN "sprint" ;
  sprinter_nn_1 = mkN "sprinter" "sprintern" "sprinter" "sprinterna" ;
  spritdryck_nn_1 = mkN "spritdryck" "spritdrycker" ;
  sprithalt_nn_1 = mkN "sprithalt" "sprithalter" ;
  sprithaltig_av_1 = mkA "sprithaltig" ;
  spritkoek_nn_1 = mkN "spritkцk" neutrum ;
  spritraettighet_nn_1 = mkN "spritrдttighet" "spritrдttigheter" ;
  sprits_nn_1 = mkN "sprits" ;
  spritspion_nn_1 = mkN "spritspion" "spritspioner" ;
  spritt_ab_1 = mkAdv "spritt" ;
  sprittermometer_nn_1 = mkN "sprittermometer" ;
  sproed_av_1 = mkA "sprцd" ;
  sproejs_nn_1 = mkN "sprцjs" ;
  sproet_nn_1 = mkN "sprцt" neutrum ;
  sprund_nn_1 = mkN "sprund" neutrum ;
  sprut_nn_1 = mkN "sprut" neutrum ;
  sprutspets_nn_1 = mkN "sprutspets" ;
  sprygel_nn_1 = mkN "sprygel" ;
  spurt_nn_1 = mkN "spurt" "spurter" ;
  sputnik_nn_1 = mkN "sputnik" ;
  spyboll_nn_1 = mkN "spyboll" ;
  spydig_av_1 = mkA "spydig" ;
  spydighet_nn_1 = mkN "spydighet" "spydigheter" ;
  spygatt_nn_1 = mkN "spygatt" neutrum ;
  squash_nn_2 = mkN "squash" "squasher" ;
  squaw_nn_1 = mkN "squaw" "squawn" "squawer" "squawerna" ;
  srilankes_nn_1 = mkN "srilankes" "srilankeser" ;
  sta_ab_1 = mkAdv "sta" ;
  staaende_av_1 = mkA "stеende" ;
  staal_nn_1 = mkN "stеl" neutrum ;
  staalfjaeder_nn_1 = mkN "stеlfjдder" ;
  staalframstaellning_nn_1 = mkN "stеlframstдllning" ;
  staallegering_nn_1 = mkN "stеllegering" ;
  staalman_nn_1 = mkN "stеlman" "stеlmannen" "stеlmдn" "stеlmдnnen" ;
  staalspik_nn_1 = mkN "stеlspik" ;
  staalstick_nn_1 = mkN "stеlstick" neutrum ;
  staaltryck_nn_1 = mkN "stеltryck" neutrum ;
  staalverk_nn_1 = mkN "stеlverk" neutrum ;
  staalvit_av_1 = mkA "stеlvit" ;
  staand_ab_1 = mkAdv "stеnd" ;
  staand_nn_1 = mkN "stеnd" neutrum ;
  staand_nn_2 = mkN "stеnd" neutrum ;
  staandaktig_av_1 = mkA "stеndaktig" ;
  staandare_nn_1 = mkN "stеndare" "stеndare" ;
  staandkrage_nn_1 = mkN "stеndkrage" utrum ;
  staandkrok_nn_1 = mkN "stеndkrok" ;
  staandman_nn_1 = mkN "stеndman" ;
  staandort_nn_1 = mkN "stеndort" "stеndorter" ;
  staandpunkt_nn_1 = mkN "stеndpunkt" "stеndpunkter" ;
  staandraett_nn_1 = mkN "stеndrдtt" "stеndrдtter" ;
  staandsmaessig_av_1 = mkA "stеndsmдssig" ;
  staandsperson_nn_1 = mkN "stеndsperson" "stеndspersoner" ;
  staang_nn_1 = mkN "stеng" "stдnger" ;
  staanghammare_nn_1 = mkN "stеnghammare" "stеnghammaren" "stеnghamrar" "stеnghamrarna" ;
  staangjaernshammare_nn_1 = mkN "stеngjдrnshammare" "stеngjдrnshammaren" "stеngjдrnshamrar" "stеngjдrnshamrarna" ;
  staangkorv_nn_1 = mkN "stеngkorv" ;
  staangryttare_nn_1 = mkN "stеngryttare" "stеngryttare" ;
  staaplats_nn_1 = mkN "stеplats" "stеplatser" ;
  staathaallare_nn_1 = mkN "stеthеllare" "stеthеllare" ;
  staatlig_av_1 = mkA "stеtlig" ;
  stab_nn_1 = mkN "stab" "staber" ;
  stabbe_nn_1 = mkN "stabbe" utrum ;
  stabbig_av_1 = mkA "stabbig" ;
  stabbur_nn_1 = mkN "stabbur" ;
  stabil_av_1 = mkA "stabil" ;
  stabilisator_nn_1 = mkN "stabilisator" "stabilisatorer" ;
  stabilitet_nn_1 = mkN "stabilitet" "stabiliteter" ;
  stabschef_nn_1 = mkN "stabschef" "stabschefer" ;
  stabsofficer_nn_1 = mkN "stabsofficer" "stabsofficern" "stabsofficerare" "stabsofficerarna" ;
  stack_nn_1 = mkN "stack" ;
  stackare_nn_1 = mkN "stackare" "stackare" ;
  stackars_av_1 = mkA "stackars" ;
  stackato_ab_1 = mkAdv "stackato" ;
  stackato_nn_1 = mkN "stackato" "stackatot" "stackaton" "stackatona" ;
  stackmoln_nn_1 = mkN "stackmoln" neutrum ;
  stad_nn_1 = mkN "stad" "stдder" ;
  stadga_nn_2 = mkN "stadga" ;
  stadig_av_1 = mkA "stadig" ;
  stadigvarande_av_1 = mkA "stadigvarande" ;
  stadion_nn_1 = mkN "stadion" neutrum ;
  stadion_nn_2 = mkN "stadion" "stadiet" "stadier" "stadierna" ;
  stadium_nn_1 = mkN "stadium" "stadiet" "stadier" "stadierna" ;
  stadkant_nn_1 = mkN "stadkant" "stadkanter" ;
  stadsarkitekt_nn_1 = mkN "stadsarkitekt" "stadsarkitekter" ;
  stadsbibliotek_nn_1 = mkN "stadsbibliotek" neutrum ;
  stadsbild_nn_1 = mkN "stadsbild" "stadsbilder" ;
  stadsbud_nn_1 = mkN "stadsbud" neutrum ;
  stadsbuss_nn_1 = mkN "stadsbuss" ;
  stadsdel_nn_1 = mkN "stadsdel" "stadsdelen" "stadsdelar" "stadsdelarna" ;
  stadsfullmaektig_nn_1 = mkN "stadsfullmдktig" "stadsfullmдktigen" "stadsfullmдktige" "stadsfullmдktigena" ;
  stadshotell_nn_1 = mkN "stadshotell" neutrum ;
  stadshus_nn_1 = mkN "stadshus" neutrum ;
  stadsmiljoe_nn_1 = mkN "stadsmiljц" "stadsmiljцn" "stadsmiljцer" "stadsmiljцerna" ;
  stadsmur_nn_1 = mkN "stadsmur" ;
  stadsplan_nn_1 = mkN "stadsplan" "stadsplaner" ;
  stadsplanering_nn_1 = mkN "stadsplanering" ;
  stadsport_nn_1 = mkN "stadsport" ;
  stadssekreterare_nn_1 = mkN "stadssekreterare" "stadssekreterare" ;
  stadsstat_nn_1 = mkN "stadsstat" "stadsstater" ;
  stadsteater_nn_1 = mkN "stadsteater" ;
  staed_nn_1 = mkN "stдd" neutrum ;
  staedare_nn_1 = mkN "stдdare" "stдdare" ;
  staedbolag_nn_1 = mkN "stдdbolag" neutrum ;
  staederska_nn_1 = mkN "stдderska" ;
  staedning_nn_1 = mkN "stдdning" ;
  staedredskap_nn_1 = mkN "stдdredskap" "stдdredskapet" "stдdredskapen" "stдdredskapena" ;
  staedse_ab_1 = mkAdv "stдdse" ;
  staedsel_nn_1 = mkN "stдdsel" neutrum ;
  staedskaap_nn_1 = mkN "stдdskеp" neutrum ;
  staell_nn_1 = mkN "stдll" neutrum ;
  staelld_av_1 = mkA "stдlld" "stдllt" ;
  staellfoeretraedande_av_1 = mkA "stдllfцretrдdande" ;
  staellfoeretraedare_nn_1 = mkN "stдllfцretrдdare" "stдllfцretrдdare" ;
  staellning_nn_1 = mkN "stдllning" ;
  staellningskrig_nn_1 = mkN "stдllningskrig" neutrum ;
  staellningssteg_nn_1 = mkN "stдllningssteg" neutrum ;
  staellningstagande_nn_1 = mkN "stдllningstagande" ;
  staellverk_nn_1 = mkN "stдllverk" neutrum ;
  staemband_nn_1 = mkN "stдmband" neutrum ;
  staemgaffel_nn_1 = mkN "stдmgaffel" ;
  staemjaern_nn_1 = mkN "stдmjдrn" neutrum ;
  staemlaepp_nn_1 = mkN "stдmlдpp" ;
  staemma_nn_1 = mkN "stдmma" ;
  staemning_nn_1 = mkN "stдmning" ;
  staempel_nn_1 = mkN "stдmpel" ;
  staempelavgift_nn_1 = mkN "stдmpelavgift" "stдmpelavgifter" ;
  staempelur_nn_1 = mkN "stдmpelur" neutrum ;
  staempling_nn_1 = mkN "stдmpling" ;
  staendchen_nn_1 = mkN "stдndchen" "stдndchenen" "stдndchen" "stдndchenen" ;
  staendig_av_1 = mkA "stдndig" ;
  staengel_nn_1 = mkN "stдngel" ;
  staengning_nn_1 = mkN "stдngning" ;
  staengsel_nn_1 = mkN "stдngsel" neutrum ;
  staenk_nn_1 = mkN "stдnk" neutrum ;
  staenkskaerm_nn_1 = mkN "stдnkskдrm" ;
  staenkskydd_nn_1 = mkN "stдnkskydd" neutrum ;
  staepp_nn_1 = mkN "stдpp" "stдpper" ;
  staeppantilop_nn_1 = mkN "stдppantilop" "stдppantiloper" ;
  staerbhus_nn_1 = mkN "stдrbhus" neutrum ;
  staerkelserik_av_1 = mkA "stдrkelserik" ;
  staev_nn_1 = mkN "stдv" ;
  staev_nn_2 = mkN "stдv" neutrum ;
  stafett_nn_1 = mkN "stafett" "stafetter" ;
  stafettloepning_nn_1 = mkN "stafettlцpning" ;
  staffagefigur_nn_1 = mkN "staffagefigur" "staffagefigurer" ;
  staffli_nn_1 = mkN "staffli" "staffliet" "stafflier" "stafflierna" ;
  stafflimaalning_nn_1 = mkN "stafflimеlning" ;
  stafylokock_nn_1 = mkN "stafylokock" "stafylokocker" ;
  stag_nn_1 = mkN "stag" neutrum ;
  stagg_nn_1 = mkN "stagg" ;
  stagnation_nn_1 = mkN "stagnation" "stagnationer" ;
  stagsegel_nn_1 = mkN "stagsegel" neutrum ;
  stake_nn_1 = mkN "stake" utrum ;
  staket_nn_1 = mkN "staket" neutrum ;
  stalagmit_nn_1 = mkN "stalagmit" "stalagmiter" ;
  stalaktit_nn_1 = mkN "stalaktit" "stalaktiter" ;
  stalinist_nn_1 = mkN "stalinist" "stalinister" ;
  stalinistisk_av_1 = mkA "stalinistisk" ;
  stall_nn_1 = mkN "stall" neutrum ;
  stall_nn_2 = mkN "stall" neutrum ;
  stall_nn_3 = mkN "stall" ;
  stallbacke_nn_1 = mkN "stallbacke" utrum ;
  stallbroder_nn_1 = mkN "stallbroder" "stallbrodern" "stallbrцder" "stallbrцderna" ;
  stallknekt_nn_1 = mkN "stallknekt" ;
  stalltips_nn_1 = mkN "stalltips" neutrum ;
  stam_nn_1 = mkN "stam" "stammen" "stammar" "stammarna" ;
  stamaktie_nn_1 = mkN "stamaktie" "stamaktier" ;
  stamanstaelld_av_1 = mkA "stamanstдlld" "stamanstдllt" ;
  stambok_nn_1 = mkN "stambok" "stambцcker" ;
  stambord_nn_1 = mkN "stambord" neutrum ;
  stamfader_nn_1 = mkN "stamfader" "stamfadern" "stamfдder" "stamfдderna" ;
  stamgaest_nn_1 = mkN "stamgдst" "stamgдster" ;
  stamhoevding_nn_1 = mkN "stamhцvding" ;
  stamkrigare_nn_1 = mkN "stamkrigare" "stamkrigare" ;
  stamkund_nn_1 = mkN "stamkund" "stamkunder" ;
  stamlinje_nn_1 = mkN "stamlinje" "stamlinjer" ;
  stamlokus_nn_1 = mkN "stamlokus" neutrum ;
  stammare_nn_1 = mkN "stammare" "stammare" ;
  stammoder_nn_1 = mkN "stammoder" "stammodern" "stammцdrar" "stammцdrarna" ;
  stamort_nn_1 = mkN "stamort" "stamorter" ;
  stamp_nn_1 = mkN "stamp" ;
  stampkvarn_nn_1 = mkN "stampkvarn" ;
  stamtavla_nn_1 = mkN "stamtavla" ;
  stamton_nn_1 = mkN "stamton" "stamtoner" ;
  stamtraed_nn_1 = mkN "stamtrдd" neutrum ;
  stand_in_nn_1 = mkN "stand-in" "stand-iner" ;
  standar_nn_1 = mkN "standar" neutrum ;
  standard_nn_1 = mkN "standard" "standarder" ;
  standardavvikelse_nn_1 = mkN "standardavvikelse" "standardavvikelser" ;
  standardhoejning_nn_1 = mkN "standardhцjning" ;
  standardloesning_nn_1 = mkN "standardlцsning" ;
  standardprov_nn_1 = mkN "standardprov" neutrum ;
  standardverk_nn_1 = mkN "standardverk" neutrum ;
  standert_nn_1 = mkN "standert" ;
  stank_nn_1 = mkN "stank" "stanker" ;
  stannfaagel_nn_1 = mkN "stannfеgel" ;
  stanning_nn_1 = mkN "stanning" ;
  stannplan_nn_1 = mkN "stannplan" neutrum ;
  stans_nn_1 = mkN "stans" ;
  stans_nn_2 = mkN "stans" "stanser" ;
  stapel_nn_1 = mkN "stapel" ;
  stapelavloepning_nn_1 = mkN "stapelavlцpning" ;
  stapelbaedd_nn_1 = mkN "stapelbдdd" ;
  stapeldiagram_nn_1 = mkN "stapeldiagram" "stapeldiagrammet" "stapeldiagram" "stapeldiagrammen" ;
  stapelplats_nn_1 = mkN "stapelplats" "stapelplatser" ;
  stapelstad_nn_1 = mkN "stapelstad" "stapelstдder" ;
  starbaat_nn_1 = mkN "starbеt" ;
  stare_nn_1 = mkN "stare" utrum ;
  stark_av_1 = mkA "stark" ;
  starkoel_nn_1 = mkN "starkцl" neutrum ;
  starkstroem_nn_1 = mkN "starkstrцm" "starkstrцmmen" "starkstrцmmar" "starkstrцmmarna" ;
  starkvara_nn_1 = mkN "starkvara" ;
  starkvin_nn_1 = mkN "starkvin" "starkvinet" "starkviner" "starkvinerna" ;
  start_nn_1 = mkN "start" "starter" ;
  startavgift_nn_1 = mkN "startavgift" "startavgifter" ;
  startblock_nn_1 = mkN "startblock" neutrum ;
  starter_nn_1 = mkN "starter" "startern" "starter" "starterna" ;
  startgenerator_nn_1 = mkN "startgenerator" "startgeneratorer" ;
  startgrop_nn_1 = mkN "startgrop" ;
  startlinje_nn_1 = mkN "startlinje" "startlinjer" ;
  startmotor_nn_1 = mkN "startmotor" "startmotorer" ;
  startnyckel_nn_1 = mkN "startnyckel" ;
  startpistol_nn_1 = mkN "startpistol" "startpistoler" ;
  startpunkt_nn_1 = mkN "startpunkt" "startpunkter" ;
  startspjaell_nn_1 = mkN "startspjдll" neutrum ;
  startvev_nn_1 = mkN "startvev" ;
  stas_nn_1 = mkN "stas" "staser" ;
  stat_nn_1 = mkN "stat" "stater" ;
  statare_nn_1 = mkN "statare" "statare" ;
  station_nn_1 = mkN "station" "stationer" ;
  stationaer_av_1 = mkA "stationдr" ;
  stationsinspektor_nn_1 = mkN "stationsinspektor" "stationsinspektorer" ;
  stationsvagn_nn_1 = mkN "stationsvagn" ;
  statisk_av_1 = mkA "statisk" ;
  statist_nn_1 = mkN "statist" "statister" ;
  statistik_nn_1 = mkN "statistik" "statistiker" ;
  statistiker_nn_1 = mkN "statistiker" "statistikern" "statistiker" "statistikerna" ;
  statistisk_av_1 = mkA "statistisk" ;
  stativ_nn_1 = mkN "stativ" neutrum ;
  statlig_av_1 = mkA "statlig" ;
  stator_nn_1 = mkN "stator" "statorer" ;
  statsanslag_nn_1 = mkN "statsanslag" neutrum ;
  statsbaerande_av_1 = mkA "statsbдrande" ;
  statsbegravning_nn_1 = mkN "statsbegravning" ;
  statsbesoek_nn_1 = mkN "statsbesцk" neutrum ;
  statsbidrag_nn_1 = mkN "statsbidrag" neutrum ;
  statsbildning_nn_1 = mkN "statsbildning" ;
  statsbudget_nn_1 = mkN "statsbudget" ;
  statschef_nn_1 = mkN "statschef" "statschefer" ;
  statsdepartement_nn_1 = mkN "statsdepartement" "statsdepartementet" "statsdepartementen" "statsdepartementena" ;
  statsfinansiell_av_1 = mkA "statsfinansiell" ;
  statsfoerfattning_nn_1 = mkN "statsfцrfattning" ;
  statsfru_nn_1 = mkN "statsfru" ;
  statsgeolog_nn_1 = mkN "statsgeolog" "statsgeologer" ;
  statshemlighet_nn_1 = mkN "statshemlighet" "statshemligheter" ;
  statskupp_nn_1 = mkN "statskupp" "statskupper" ;
  statsloes_av_1 = mkA "statslцs" ;
  statsmakt_nn_1 = mkN "statsmakt" "statsmakter" ;
  statsman_nn_1 = mkN "statsman" "statsmannen" "statsmдn" "statsmдnnen" ;
  statsminister_nn_1 = mkN "statsminister" ;
  statsnytta_nn_1 = mkN "statsnytta" ;
  statsoeverhuvud_nn_1 = mkN "statsцverhuvud" "statsцverhuvudet" "statsцverhuvuden" "statsцverhuvudena" ;
  statsraad_nn_1 = mkN "statsrеd" neutrum ;
  statsraadsberedning_nn_1 = mkN "statsrеdsberedning" ;
  statsrevisor_nn_1 = mkN "statsrevisor" "statsrevisorer" ;
  statssekreterare_nn_1 = mkN "statssekreterare" "statssekreterare" ;
  statsskick_nn_1 = mkN "statsskick" neutrum ;
  statsskuld_nn_1 = mkN "statsskuld" "statsskulder" ;
  statstjaensteman_nn_1 = mkN "statstjдnsteman" "statstjдnstemannen" "statstjдnstemдn" "statstjдnstemдnnen" ;
  statsvaelvning_nn_1 = mkN "statsvдlvning" ;
  statsverksproposition_nn_1 = mkN "statsverksproposition" "statsverkspropositioner" ;
  statsvetare_nn_1 = mkN "statsvetare" "statsvetare" ;
  statsvetenskap_nn_1 = mkN "statsvetenskap" "statsvetenskaper" ;
  statuarisk_av_1 = mkA "statuarisk" ;
  statur_nn_1 = mkN "statur" "staturer" ;
  statussymbol_nn_1 = mkN "statussymbol" "statussymboler" ;
  statut_nn_1 = mkN "statut" "statuter" ;
  staty_nn_1 = mkN "staty" "statyer" ;
  statyett_nn_1 = mkN "statyett" "statyetter" ;
  stav_nn_1 = mkN "stav" ;
  stav_nn_2 = mkN "stav" "stдver" ;
  stavelse_nn_1 = mkN "stavelse" "stavelser" ;
  stavelsebildande_av_1 = mkA "stavelsebildande" ;
  stavelseskrift_nn_1 = mkN "stavelseskrift" "stavelseskrifter" ;
  stavhopp_nn_1 = mkN "stavhopp" neutrum ;
  stavkyrka_nn_1 = mkN "stavkyrka" ;
  stavning_nn_1 = mkN "stavning" ;
  stavrim_nn_1 = mkN "stavrim" "stavrimmet" "stavrim" "stavrimmen" ;
  stearinljus_nn_1 = mkN "stearinljus" neutrum ;
  steeplechase_nn_1 = mkN "steeplechase" "steeplechaser" ;
  steg_nn_1 = mkN "steg" neutrum ;
  stegbaat_nn_1 = mkN "stegbеt" ;
  stegbil_nn_1 = mkN "stegbil" ;
  stege_nn_1 = mkN "stege" utrum ;
  stegel_nn_1 = mkN "stegel" neutrum ;
  steglits_nn_1 = mkN "steglits" "steglitser" ;
  stegloes_av_1 = mkA "steglцs" ;
  stegring_nn_1 = mkN "stegring" ;
  stegvis_ab_1 = mkAdv "stegvis" ;
  stek_nn_1 = mkN "stek" ;
  stek_nn_2 = mkN "stek" neutrum ;
  stekburgare_nn_1 = mkN "stekburgare" "stekburgare" ;
  stekel_nn_1 = mkN "stekel" ;
  stekhet_av_1 = mkA "stekhet" ;
  stekhus_nn_1 = mkN "stekhus" neutrum ;
  stekspade_nn_1 = mkN "stekspade" utrum ;
  stekspett_nn_1 = mkN "stekspett" neutrum ;
  stel_av_1 = mkA "stel" ;
  stelbent_av_1 = mkA "stelbent" "stelbent" ;
  stele_nn_1 = mkN "stele" utrum ;
  stelfrusen_av_1 = mkA "stelfrusen" "stelfruset" ;
  stelhet_nn_1 = mkN "stelhet" "stelheter" ;
  stellar_av_1 = mkA "stellar" ;
  stellarisk_av_1 = mkA "stellarisk" ;
  sten_nn_1 = mkN "sten" "stenen" "stenar" "stenarna" ;
  stenaaldersfynd_nn_1 = mkN "stenеldersfynd" neutrum ;
  stenaaldersnivaa_nn_1 = mkN "stenеldersnivе" "stenеldersnivеer" ;
  stenbaer_nn_1 = mkN "stenbдr" neutrum ;
  stenbit_nn_1 = mkN "stenbit" ;
  stenblock_nn_1 = mkN "stenblock" neutrum ;
  stenbock_nn_1 = mkN "stenbock" ;
  stenbotten_nn_1 = mkN "stenbotten" ;
  stenbrott_nn_1 = mkN "stenbrott" neutrum ;
  stenbumling_nn_1 = mkN "stenbumling" ;
  stencil_nn_1 = mkN "stencil" "stenciler" ;
  stendoes_nn_1 = mkN "stendцs" ;
  stendoev_av_1 = mkA "stendцv" ;
  stenfot_nn_1 = mkN "stenfot" ;
  stenfrukt_nn_1 = mkN "stenfrukt" "stenfrukter" ;
  stenget_nn_1 = mkN "stenget" "stengetter" ;
  stenhaell_nn_1 = mkN "stenhдll" ;
  stenhallon_nn_1 = mkN "stenhallon" neutrum ;
  stenhuggare_nn_1 = mkN "stenhuggare" "stenhuggare" ;
  stenhuggeri_nn_1 = mkN "stenhuggeri" "stenhuggerit" "stenhuggerier" "stenhuggerierna" ;
  stenig_av_1 = mkA "stenig" ;
  stenkast_nn_1 = mkN "stenkast" neutrum ;
  stenknaeck_nn_1 = mkN "stenknдck" ;
  stenkol_nn_1 = mkN "stenkol" neutrum ;
  stenkummel_nn_1 = mkN "stenkummel" "stenkummlet" "stenkummel" "stenkummlen" ;
  stenlaeggning_nn_1 = mkN "stenlдggning" ;
  stenlagd_av_1 = mkA "stenlagd" "stenlagt" ;
  stenoeken_nn_1 = mkN "stenцken" "stenцkenn" "stenцknar" "stenцknarna" ;
  stenograf_nn_1 = mkN "stenograf" "stenografer" ;
  stenogram_nn_1 = mkN "stenogram" "stenogrammet" "stenogram" "stenogrammen" ;
  stenos_nn_1 = mkN "stenos" "stenoser" ;
  stenotop_nn_1 = mkN "stenotop" "stenotoper" ;
  stenparti_nn_1 = mkN "stenparti" "stenpartit" "stenpartier" "stenpartierna" ;
  stenrik_av_1 = mkA "stenrik" ;
  stensaettare_nn_1 = mkN "stensдttare" "stensдttare" ;
  stensaettning_nn_1 = mkN "stensдttning" ;
  stensatt_av_1 = mkA "stensatt" ;
  stenskott_nn_1 = mkN "stenskott" neutrum ;
  stensopp_nn_1 = mkN "stensopp" ;
  stentavla_nn_1 = mkN "stentavla" ;
  stentorsroest_nn_1 = mkN "stentorsrцst" "stentorsrцster" ;
  stentorsstaemma_nn_1 = mkN "stentorsstдmma" ;
  steradian_nn_1 = mkN "steradian" "steradianer" ;
  sterbhus_nn_1 = mkN "sterbhus" neutrum ;
  stereoanlaeggning_nn_1 = mkN "stereoanlдggning" ;
  stereobild_nn_1 = mkN "stereobild" "stereobilder" ;
  stereofonisk_av_1 = mkA "stereofonisk" ;
  stereoskop_nn_1 = mkN "stereoskop" neutrum ;
  stereotyp_av_1 = mkA "stereotyp" ;
  stereotyp_nn_1 = mkN "stereotyp" "stereotyper" ;
  stereotypi_nn_1 = mkN "stereotypi" "stereotypier" ;
  steril_av_1 = mkA "steril" ;
  sterilisering_nn_1 = mkN "sterilisering" ;
  sterilitet_nn_1 = mkN "sterilitet" "steriliteter" ;
  sterin_nn_1 = mkN "sterin" "steriner" ;
  sterisk_av_1 = mkA "sterisk" ;
  steroid_nn_1 = mkN "steroid" "steroider" ;
  sterol_nn_1 = mkN "sterol" "steroler" ;
  stetoskop_nn_1 = mkN "stetoskop" neutrum ;
  steward_nn_1 = mkN "steward" ;
  stewart_nn_1 = mkN "stewart" ;
  stick_nn_1 = mkN "stick" neutrum ;
  sticka_vb_1 = mkV "sticka" "stack" "stuckit" ;
  stickel_nn_1 = mkN "stickel" ;
  stickelbaer_nn_1 = mkN "stickelbдr" neutrum ;
  stickelhaarig_av_1 = mkA "stickelhеrig" ;
  stickert_nn_1 = mkN "stickert" ;
  stickig_av_1 = mkA "stickig" ;
  stickkontakt_nn_1 = mkN "stickkontakt" "stickkontakter" ;
  stickling_nn_1 = mkN "stickling" ;
  stickmaskin_nn_1 = mkN "stickmaskin" "stickmaskiner" ;
  stickning_nn_1 = mkN "stickning" ;
  stickord_nn_1 = mkN "stickord" neutrum ;
  stickpropp_nn_1 = mkN "stickpropp" ;
  stickprov_nn_1 = mkN "stickprov" neutrum ;
  stickprovsundersoekning_nn_1 = mkN "stickprovsundersцkning" ;
  stickreplik_nn_1 = mkN "stickreplik" "stickrepliker" ;
  stickspaar_nn_1 = mkN "stickspеr" neutrum ;
  stickvapen_nn_1 = mkN "stickvapen" "stickvapnet" "stickvapen" "stickvapnen" ;
  stift_nn_1 = mkN "stift" neutrum ;
  stiftelse_nn_1 = mkN "stiftelse" "stiftelser" ;
  stiftsfroeken_nn_1 = mkN "stiftsfrцken" ;
  stiftsjungfru_nn_1 = mkN "stiftsjungfru" "stiftsjungfrun" "stiftsjungfrur" "stiftsjungfrurna" ;
  stiftsstad_nn_1 = mkN "stiftsstad" "stiftsstдder" ;
  stifttand_nn_1 = mkN "stifttand" "stifttдnder" ;
  stig_nn_1 = mkN "stig" ;
  stiga_vb_1 = mkV "stiga" "steg" "stigit" ;
  stigarcentral_nn_1 = mkN "stigarcentral" "stigarcentraler" ;
  stigarledning_nn_1 = mkN "stigarledning" ;
  stigbygel_nn_1 = mkN "stigbygel" ;
  stigfinnare_nn_1 = mkN "stigfinnare" "stigfinnare" ;
  stiglaeder_nn_1 = mkN "stiglдder" neutrum ;
  stigloes_av_1 = mkA "stiglцs" ;
  stigma_nn_1 = mkN "stigma" "stigmat" "stigman" "stigmana" ;
  stigman_nn_1 = mkN "stigman" "stigmannen" "stigmдn" "stigmдnnen" ;
  stigning_nn_1 = mkN "stigning" ;
  stigort_nn_1 = mkN "stigort" "stigorter" ;
  stikisk_av_1 = mkA "stikisk" ;
  stil_nn_1 = mkN "stil" ;
  stilart_nn_1 = mkN "stilart" "stilarter" ;
  stilbildande_av_1 = mkA "stilbildande" ;
  stilbildare_nn_1 = mkN "stilbildare" "stilbildare" ;
  stilbrytning_nn_1 = mkN "stilbrytning" ;
  stildrag_nn_1 = mkN "stildrag" neutrum ;
  stilenlig_av_1 = mkA "stilenlig" ;
  stilett_nn_1 = mkN "stilett" "stiletter" ;
  stilettkaepp_nn_1 = mkN "stilettkдpp" ;
  stilfigur_nn_1 = mkN "stilfigur" "stilfigurer" ;
  stilfull_av_1 = mkA "stilfull" ;
  stilig_av_1 = mkA "stilig" ;
  stilisering_nn_1 = mkN "stilisering" ;
  stilist_nn_1 = mkN "stilist" "stilister" ;
  stilistiker_nn_1 = mkN "stilistiker" "stilistikern" "stilistiker" "stilistikerna" ;
  stilistisk_av_1 = mkA "stilistisk" ;
  still_ab_1 = mkAdv "still" ;
  stilla_ab_1 = mkAdv "stilla" ;
  stilla_av_1 = mkA "stilla" ;
  stillasittande_av_1 = mkA "stillasittande" ;
  stillastaaende_av_1 = mkA "stillastеende" ;
  stillatigande_av_1 = mkA "stillatigande" ;
  stillbild_nn_1 = mkN "stillbild" "stillbilder" ;
  stilldrink_nn_1 = mkN "stilldrink" ;
  stilleben_nn_1 = mkN "stilleben" neutrum ;
  stillestaand_nn_1 = mkN "stillestеnd" neutrum ;
  stillfilm_nn_1 = mkN "stillfilm" "stillfilmer" ;
  stillhet_nn_1 = mkN "stillhet" "stillheter" ;
  stillsam_av_1 = mkA "stillsam" "stillsamt" "stillsamma" "stillsamma" "stillsammare" "stillsammast" "stillsammaste" ;
  stillt_av_1 = mkA "stillt" ;
  stilmoebel_nn_1 = mkN "stilmцbel" "stilmцbeln" "stilmцbler" "stilmцblerna" ;
  stilren_av_1 = mkA "stilren" ;
  stilriktning_nn_1 = mkN "stilriktning" ;
  stilsort_nn_1 = mkN "stilsort" "stilsorter" ;
  stilton_nn_1 = mkN "stilton" ;
  stim_nn_1 = mkN "stim" "stimmet" "stim" "stimmen" ;
  stimmig_av_1 = mkA "stimmig" ;
  stimulans_nn_1 = mkN "stimulans" "stimulanser" ;
  stimulantia_nn_1 = mkN "stimulantia" "stimulantian" "stimulantia" "stimulantiana" ;
  stimulator_nn_1 = mkN "stimulator" "stimulatorer" ;
  stimulering_nn_1 = mkN "stimulering" ;
  stimulus_nn_1 = mkN "stimulus" neutrum ;
  sting_nn_1 = mkN "sting" neutrum ;
  stingpinne_nn_1 = mkN "stingpinne" utrum ;
  stingslig_av_1 = mkA "stingslig" ;
  stinkbomb_nn_1 = mkN "stinkbomb" "stinkbomber" ;
  stinkdjur_nn_1 = mkN "stinkdjur" neutrum ;
  stinkfly_nn_1 = mkN "stinkfly" "stinkflyt" "stinkflyn" "stinkflyen" ;
  stinksvamp_nn_1 = mkN "stinksvamp" ;
  stinn_av_1 = mkA "stinn" "stint" ;
  stins_nn_1 = mkN "stins" ;
  stint_ab_1 = mkAdv "stint" ;
  stipel_nn_1 = mkN "stipel" "stipeln" "stipler" "stiplerna" ;
  stipendiat_nn_1 = mkN "stipendiat" "stipendiater" ;
  stipendium_nn_1 = mkN "stipendium" "stipendiet" "stipendier" "stipendierna" ;
  stipulation_nn_1 = mkN "stipulation" "stipulationer" ;
  stirlingmotor_nn_1 = mkN "stirlingmotor" "stirlingmotorer" ;
  stirr_nn_1 = mkN "stirr" ;
  stirrig_av_1 = mkA "stirrig" ;
  stjaela_vb_1 = mkV "stjдla" "stjдl" "stjдl" "stal" "stulit" "stulen" ;
  stjaelk_nn_1 = mkN "stjдlk" ;
  stjaelkstygn_nn_1 = mkN "stjдlkstygn" neutrum ;
  stjaernassociation_nn_1 = mkN "stjдrnassociation" "stjдrnassociationer" ;
  stjaernbetaeckning_nn_1 = mkN "stjдrnbetдckning" ;
  stjaernbild_nn_1 = mkN "stjдrnbild" "stjдrnbilder" ;
  stjaerndygn_nn_1 = mkN "stjдrndygn" neutrum ;
  stjaernevalv_nn_1 = mkN "stjдrnevalv" neutrum ;
  stjaernfall_nn_1 = mkN "stjдrnfall" neutrum ;
  stjaernfigur_nn_1 = mkN "stjдrnfigur" "stjдrnfigurer" ;
  stjaernformig_av_1 = mkA "stjдrnformig" ;
  stjaerngosse_nn_1 = mkN "stjдrngosse" utrum ;
  stjaerngranne_nn_1 = mkN "stjдrngranne" utrum ;
  stjaernhimmel_nn_1 = mkN "stjдrnhimmel" ;
  stjaernhop_nn_1 = mkN "stjдrnhop" ;
  stjaernhus_nn_1 = mkN "stjдrnhus" neutrum ;
  stjaernklar_av_1 = mkA "stjдrnklar" ;
  stjaernkonstellation_nn_1 = mkN "stjдrnkonstellation" "stjдrnkonstellationer" ;
  stjaernkoppling_nn_1 = mkN "stjдrnkoppling" ;
  stjaernlik_av_1 = mkA "stjдrnlik" ;
  stjaernljus_av_1 = mkA "stjдrnljus" ;
  stjaernljus_nn_1 = mkN "stjдrnljus" neutrum ;
  stjaernmotor_nn_1 = mkN "stjдrnmotor" "stjдrnmotorer" ;
  stjaernoegd_av_1 = mkA "stjдrnцgd" "stjдrnцgt" ;
  stjaernpar_nn_1 = mkN "stjдrnpar" neutrum ;
  stjaernskott_nn_1 = mkN "stjдrnskott" neutrum ;
  stjaernsmaell_nn_1 = mkN "stjдrnsmдll" ;
  stjaernsystem_nn_1 = mkN "stjдrnsystem" neutrum ;
  stjaerntriplett_nn_1 = mkN "stjдrntriplett" "stjдrntripletter" ;
  stjaerntydare_nn_1 = mkN "stjдrntydare" "stjдrntydare" ;
  stjaernvalv_nn_1 = mkN "stjдrnvalv" neutrum ;
  stjaert_nn_1 = mkN "stjдrt" ;
  stjaertfjaeder_nn_1 = mkN "stjдrtfjдder" ;
  stjaertgosse_nn_1 = mkN "stjдrtgosse" utrum ;
  stjaertmes_nn_1 = mkN "stjдrtmes" ;
  sto_nn_1 = mkN "sto" "stoet" "ston" "stona" ;
  stock_nn_1 = mkN "stock" ;
  stockankare_nn_1 = mkN "stockankare" "stockankaret" "stockankare" "stockankarna" ;
  stockbaat_nn_1 = mkN "stockbеt" ;
  stockeld_nn_1 = mkN "stockeld" ;
  stockfisk_nn_1 = mkN "stockfisk" ;
  stockholmare_nn_1 = mkN "stockholmare" "stockholmare" ;
  stockholmska_nn_2 = mkN "stockholmska" ;
  stockkonservativ_av_1 = mkA "stockkonservativ" ;
  stockning_nn_1 = mkN "stockning" ;
  stod_nn_1 = mkN "stod" "stoder" ;
  stoed_nn_1 = mkN "stцd" neutrum ;
  stoeddig_av_1 = mkA "stцddig" ;
  stoedhjul_nn_1 = mkN "stцdhjul" neutrum ;
  stoedjecell_nn_1 = mkN "stцdjecell" "stцdjeceller" ;
  stoedjepunkt_nn_1 = mkN "stцdjepunkt" "stцdjepunkter" ;
  stoedjevaevnad_nn_1 = mkN "stцdjevдvnad" "stцdjevдvnader" ;
  stoedjordbruk_nn_1 = mkN "stцdjordbruk" neutrum ;
  stoedomraade_nn_1 = mkN "stцdomrеde" ;
  stoekig_av_1 = mkA "stцkig" ;
  stoeld_nn_1 = mkN "stцld" "stцlder" ;
  stoeldsaeker_av_1 = mkA "stцldsдker" "stцldsдkert" "stцldsдkra" "stцldsдkra" "stцldsдkrare" "stцldsдkrast" "stцldsдkraste" ;
  stoen_nn_1 = mkN "stцn" neutrum ;
  stoenande_nn_1 = mkN "stцnande" ;
  stoepplare_nn_1 = mkN "stцpplare" "stцpplare" ;
  stoer_nn_1 = mkN "stцr" ;
  stoeratom_nn_1 = mkN "stцratom" "stцratomer" ;
  stoerning_nn_1 = mkN "stцrning" ;
  stoert_ab_1 = mkAdv "stцrt" ;
  stoertflod_nn_1 = mkN "stцrtflod" "stцrtfloder" ;
  stoerthjaelm_nn_1 = mkN "stцrthjдlm" ;
  stoertkaer_av_1 = mkA "stцrtkдr" ;
  stoertlopp_nn_1 = mkN "stцrtlopp" neutrum ;
  stoet_nn_1 = mkN "stцt" ;
  stoetdaempare_nn_1 = mkN "stцtdдmpare" "stцtdдmpare" ;
  stoetesten_nn_1 = mkN "stцtesten" "stцtestenen" "stцtestenar" "stцtestenarna" ;
  stoetfaangare_nn_1 = mkN "stцtfеngare" "stцtfеngare" ;
  stoetsida_nn_1 = mkN "stцtsida" ;
  stoetskydd_nn_1 = mkN "stцtskydd" neutrum ;
  stoett_av_1 = mkA "stцtt" ;
  stoettepelare_nn_1 = mkN "stцttepelare" "stцttepelare" ;
  stoetvis_ab_1 = mkAdv "stцtvis" ;
  stoetvis_av_1 = mkA "stцtvis" ;
  stoevare_nn_1 = mkN "stцvare" "stцvare" ;
  stoevel_nn_1 = mkN "stцvel" ;
  stoevelknekt_nn_1 = mkN "stцvelknekt" ;
  stoevlett_nn_1 = mkN "stцvlett" "stцvletter" ;
  stoff_nn_1 = mkN "stoff" neutrum ;
  stofil_nn_1 = mkN "stofil" "stofiler" ;
  stoft_nn_1 = mkN "stoft" neutrum ;
  stoftkorn_nn_1 = mkN "stoftkorn" neutrum ;
  stoftmaengd_nn_1 = mkN "stoftmдngd" "stoftmдngder" ;
  stoftmoln_nn_1 = mkN "stoftmoln" neutrum ;
  stoftpartikel_nn_1 = mkN "stoftpartikel" ;
  stoiker_nn_1 = mkN "stoiker" "stoikern" "stoiker" "stoikerna" ;
  stoisk_av_1 = mkA "stoisk" ;
  stojig_av_1 = mkA "stojig" ;
  stokastisk_av_1 = mkA "stokastisk" ;
  stol_nn_1 = mkN "stol" ;
  stolgaang_nn_1 = mkN "stolgеng" ;
  stoll_nn_1 = mkN "stoll" ;
  stolle_nn_1 = mkN "stolle" utrum ;
  stolleri_nn_1 = mkN "stolleri" "stollerit" "stollerier" "stollerierna" ;
  stollig_av_1 = mkA "stollig" ;
  stolpbod_nn_1 = mkN "stolpbod" ;
  stolpdiagram_nn_1 = mkN "stolpdiagram" "stolpdiagrammet" "stolpdiagram" "stolpdiagrammen" ;
  stolpe_nn_1 = mkN "stolpe" utrum ;
  stolpiller_nn_1 = mkN "stolpiller" neutrum ;
  stolprad_nn_1 = mkN "stolprad" "stolprader" ;
  stolpsko_nn_1 = mkN "stolpsko" "stolpskor" ;
  stolt_av_1 = mkA "stolt" "stolt" ;
  stolthet_nn_1 = mkN "stolthet" "stoltheter" ;
  stolts_av_1 = mkA "stolts" ;
  stomatit_nn_1 = mkN "stomatit" "stomatiter" ;
  stomi_nn_1 = mkN "stomi" "stomier" ;
  stomme_nn_1 = mkN "stomme" utrum ;
  stomp_nn_1 = mkN "stomp" ;
  stop_nn_1 = mkN "stop" neutrum ;
  stopp_nn_1 = mkN "stopp" neutrum ;
  stopp_nn_2 = mkN "stopp" ;
  stoppboll_nn_1 = mkN "stoppboll" ;
  stopper_nn_1 = mkN "stopper" "stoppern" "stoppers" "stoppersen" ;
  stoppljus_nn_1 = mkN "stoppljus" neutrum ;
  stoppnaal_nn_1 = mkN "stoppnеl" ;
  stoppning_nn_1 = mkN "stoppning" ;
  stoppris_nn_1 = mkN "stoppris" neutrum ;
  stoppur_nn_1 = mkN "stoppur" neutrum ;
  stor_av_1 = mkA "stor" "stцrre" "stцrst" ;
  storasyster_nn_1 = mkN "storasyster" ;
  storbaat_nn_1 = mkN "storbеt" ;
  storband_nn_1 = mkN "storband" neutrum ;
  storblommig_av_1 = mkA "storblommig" ;
  storbonde_nn_1 = mkN "storbonde" "storbцnder" ;
  storbritannisk_av_1 = mkA "storbritannisk" ;
  storby_nn_1 = mkN "storby" "storbyn" "storbyar" "storbyarna" ;
  storcirkel_nn_1 = mkN "storcirkel" ;
  storcirkelsegling_nn_1 = mkN "storcirkelsegling" ;
  stordaad_nn_1 = mkN "stordеd" neutrum ;
  stordator_nn_1 = mkN "stordator" "stordatorer" ;
  store_nn_1 = mkN "store" "storer" ;
  storfamilj_nn_1 = mkN "storfamilj" "storfamiljer" ;
  storfamiljshus_nn_1 = mkN "storfamiljshus" neutrum ;
  storfoeretag_nn_1 = mkN "storfцretag" neutrum ;
  storfurste_nn_1 = mkN "storfurste" utrum ;
  storgodsaegare_nn_1 = mkN "storgodsдgare" "storgodsдgare" ;
  storhertig_nn_1 = mkN "storhertig" ;
  storhet_nn_1 = mkN "storhet" "storheter" ;
  storhushaall_nn_1 = mkN "storhushеll" neutrum ;
  storindustri_nn_1 = mkN "storindustri" "storindustrier" ;
  stork_nn_1 = mkN "stork" ;
  storkoek_nn_1 = mkN "storkцk" neutrum ;
  storkommun_nn_1 = mkN "storkommun" "storkommuner" ;
  storkors_nn_1 = mkN "storkors" neutrum ;
  storkrig_nn_1 = mkN "storkrig" neutrum ;
  storlek_nn_1 = mkN "storlek" ;
  storleksnummer_nn_1 = mkN "storleksnummer" neutrum ;
  storleksordning_nn_1 = mkN "storleksordning" ;
  storliga_ab_1 = mkAdv "storliga" ;
  storligen_ab_1 = mkAdv "storligen" ;
  storm_nn_1 = mkN "storm" ;
  stormaestare_nn_1 = mkN "stormдstare" "stormдstare" ;
  stormakt_nn_1 = mkN "stormakt" "stormakter" ;
  stormaktspolitisk_av_1 = mkA "stormaktspolitisk" ;
  storman_nn_1 = mkN "storman" "stormannen" "stormдn" "stormдnnen" ;
  stormarknad_nn_1 = mkN "stormarknad" "stormarknader" ;
  stormast_nn_1 = mkN "stormast" "stormaster" ;
  stormbaat_nn_1 = mkN "stormbеt" ;
  stormfaagel_nn_1 = mkN "stormfеgel" ;
  stormflod_nn_1 = mkN "stormflod" "stormfloder" ;
  stormhatt_nn_1 = mkN "stormhatt" ;
  stormig_av_1 = mkA "stormig" ;
  stormning_nn_1 = mkN "stormning" ;
  stormoete_nn_1 = mkN "stormцte" ;
  stormogul_nn_1 = mkN "stormogul" "stormoguler" ;
  stormufti_nn_1 = mkN "stormufti" "stormuftin" "stormuftier" "stormuftierna" ;
  stormvarning_nn_1 = mkN "stormvarning" ;
  storoegd_av_1 = mkA "storцgd" "storцgt" ;
  storordig_av_1 = mkA "storordig" ;
  storpipig_av_1 = mkA "storpipig" ;
  storpolitisk_av_1 = mkA "storpolitisk" ;
  storrysk_av_1 = mkA "storrysk" ;
  storsegel_nn_1 = mkN "storsegel" neutrum ;
  storsint_av_1 = mkA "storsint" "storsint" ;
  storsjoeodjur_nn_1 = mkN "storsjцodjur" neutrum ;
  storskalig_av_1 = mkA "storskalig" ;
  storskog_nn_1 = mkN "storskog" ;
  storslagen_av_1 = mkA "storslagen" "storslaget" ;
  storslam_nn_1 = mkN "storslam" "storslammen" "storslammar" "storslammarna" ;
  storspov_nn_1 = mkN "storspov" ;
  storstad_nn_1 = mkN "storstad" "storstдder" ;
  storstaedning_nn_1 = mkN "storstдdning" ;
  storstilt_av_1 = mkA "storstilt" "storstilt" ;
  storstrejk_nn_1 = mkN "storstrejk" "storstrejker" ;
  storstuga_nn_1 = mkN "storstuga" ;
  storsvensk_av_1 = mkA "storsvensk" ;
  storsvensk_nn_1 = mkN "storsvensk" ;
  stortaa_nn_1 = mkN "stortе" "stortеn" "stortеr" "stortеrna" ;
  stortopp_nn_1 = mkN "stortopp" ;
  stortroeja_nn_1 = mkN "stortrцja" ;
  storvaest_nn_1 = mkN "storvдst" ;
  storvaext_av_1 = mkA "storvдxt" "storvдxt" ;
  storverk_nn_1 = mkN "storverk" neutrum ;
  storvulen_av_1 = mkA "storvulen" "storvulet" ;
  storvuxen_av_1 = mkA "storvuxen" "storvuxet" ;
  story_nn_1 = mkN "story" "storyer" ;
  straa_nn_1 = mkN "strе" "strеet" "strеn" "strеna" ;
  straabassjukdom_nn_1 = mkN "strеbassjukdom" ;
  straahatt_nn_1 = mkN "strеhatt" ;
  straak_nn_1 = mkN "strеk" neutrum ;
  straakdrag_nn_1 = mkN "strеkdrag" neutrum ;
  straake_nn_1 = mkN "strеke" utrum ;
  straakinstrument_nn_1 = mkN "strеkinstrument" neutrum ;
  straakkvartett_nn_1 = mkN "strеkkvartett" "strеkkvartetter" ;
  straalande_av_1 = mkA "strеlande" ;
  straalbehandling_nn_1 = mkN "strеlbehandling" ;
  straalben_nn_1 = mkN "strеlben" neutrum ;
  straaldjur_nn_1 = mkN "strеldjur" neutrum ;
  straaldos_nn_1 = mkN "strеldos" "strеldoser" ;
  straale_nn_1 = mkN "strеle" utrum ;
  straalfenig_av_1 = mkA "strеlfenig" ;
  straalgaangsmaetare_nn_1 = mkN "strеlgеngsmдtare" "strеlgеngsmдtare" ;
  straalkastare_nn_1 = mkN "strеlkastare" "strеlkastare" ;
  straalkastarljus_nn_1 = mkN "strеlkastarljus" neutrum ;
  straalkniv_nn_1 = mkN "strеlkniv" ;
  straalkropp_nn_1 = mkN "strеlkropp" ;
  straalning_nn_1 = mkN "strеlning" ;
  straalningsbaelte_nn_1 = mkN "strеlningsbдlte" ;
  straalningsdos_nn_1 = mkN "strеlningsdos" "strеlningsdoser" ;
  straalningseffekt_nn_1 = mkN "strеlningseffekt" "strеlningseffekter" ;
  straalningsegenskap_nn_1 = mkN "strеlningsegenskap" "strеlningsegenskaper" ;
  straalningskommitte_nn_1 = mkN "strеlningskommittй" "strеlningskommittйer" ;
  straalningskvantum_nn_1 = mkN "strеlningskvantum" neutrum ;
  straalningsspektrum_nn_1 = mkN "strеlningsspektrum" neutrum ;
  straalrisk_nn_1 = mkN "strеlrisk" "strеlrisker" ;
  straalskyddsinstitut_nn_1 = mkN "strеlskyddsinstitut" neutrum ;
  straatroevare_nn_1 = mkN "strеtrцvare" "strеtrцvare" ;
  stradivarius_nn_1 = mkN "stradivarius" ;
  straeck_nn_1 = mkN "strдck" neutrum ;
  straeckare_nn_1 = mkN "strдckare" "strдckare" ;
  straeckarmuskel_nn_1 = mkN "strдckarmuskel" "strдckarmuskeln" "strдckarmuskler" "strдckarmusklerna" ;
  straeckbaenk_nn_1 = mkN "strдckbдnk" ;
  straeckfoerband_nn_1 = mkN "strдckfцrband" neutrum ;
  straeckning_nn_1 = mkN "strдckning" ;
  straeng_av_1 = mkA "strдng" ;
  straeng_nn_1 = mkN "strдng" ;
  straengeligen_ab_1 = mkAdv "strдngeligen" ;
  straenginstrument_nn_1 = mkN "strдnginstrument" neutrum ;
  straev_av_1 = mkA "strдv" ;
  straevande_nn_1 = mkN "strдvande" ;
  straevbaage_nn_1 = mkN "strдvbеge" utrum ;
  straevhaarig_av_1 = mkA "strдvhеrig" ;
  straevpelare_nn_1 = mkN "strдvpelare" "strдvpelare" ;
  straevsam_av_1 = mkA "strдvsam" "strдvsamt" "strдvsamma" "strдvsamma" "strдvsammare" "strдvsammast" "strдvsammaste" ;
  straff_nn_1 = mkN "straff" neutrum ;
  straff_nn_2 = mkN "straff" ;
  straffaange_nn_1 = mkN "straffеnge" utrum ;
  straffbar_av_1 = mkA "straffbar" ;
  straffdom_nn_1 = mkN "straffdom" ;
  straffkast_nn_1 = mkN "straffkast" neutrum ;
  strafflag_nn_1 = mkN "strafflag" ;
  straffoerelaeggande_nn_1 = mkN "straffцrelдggande" ;
  straffomraade_nn_1 = mkN "straffomrеde" ;
  straffredskap_nn_1 = mkN "straffredskap" "straffredskapet" "straffredskapen" "straffredskapena" ;
  straffregister_nn_1 = mkN "straffregister" neutrum ;
  straffri_av_1 = mkA "straffri" "straffritt" ;
  straight_av_1 = mkA "straight" ;
  strak_av_1 = mkA "strak" ;
  strakbent_av_1 = mkA "strakbent" "strakbent" ;
  stram_av_1 = mkA "stram" ;
  stramalj_nn_1 = mkN "stramalj" "stramaljer" ;
  strand_nn_1 = mkN "strand" "strдnder" ;
  strandflate_nn_1 = mkN "strandflate" utrum ;
  strandfynd_nn_1 = mkN "strandfynd" neutrum ;
  strandhugg_nn_1 = mkN "strandhugg" neutrum ;
  strandkant_nn_1 = mkN "strandkant" "strandkanter" ;
  strandlinje_nn_1 = mkN "strandlinje" "strandlinjer" ;
  strandmiljoe_nn_1 = mkN "strandmiljц" "strandmiljцn" "strandmiljцer" "strandmiljцerna" ;
  strandoert_nn_1 = mkN "strandцrt" "strandцrter" ;
  strandpipare_nn_1 = mkN "strandpipare" "strandpipare" ;
  strandpromenad_nn_1 = mkN "strandpromenad" "strandpromenader" ;
  strandstat_nn_1 = mkN "strandstat" "strandstater" ;
  strandtomt_nn_1 = mkN "strandtomt" "strandtomter" ;
  strandtyp_nn_1 = mkN "strandtyp" "strandtyper" ;
  strandvaext_nn_1 = mkN "strandvдxt" "strandvдxter" ;
  strandvall_nn_1 = mkN "strandvall" ;
  strangulation_nn_1 = mkN "strangulation" "strangulationer" ;
  strapats_nn_1 = mkN "strapats" "strapatser" ;
  strateg_nn_1 = mkN "strateg" "strateger" ;
  strategi_nn_1 = mkN "strategi" "strategier" ;
  strategisk_av_1 = mkA "strategisk" ;
  stratum_nn_1 = mkN "stratum" "stratum" "strata" "stratana" ;
  strax_ab_1 = mkAdv "strax" ;
  streamer_nn_1 = mkN "streamer" "streamern" "streamers" "streamersen" ;
  streber_nn_1 = mkN "streber" ;
  streck_nn_1 = mkN "streck" neutrum ;
  streckgubbe_nn_1 = mkN "streckgubbe" utrum ;
  streckkod_nn_1 = mkN "streckkod" "streckkoder" ;
  strejk_nn_1 = mkN "strejk" "strejker" ;
  strejkbrytare_nn_1 = mkN "strejkbrytare" "strejkbrytare" ;
  strejkvakt_nn_1 = mkN "strejkvakt" "strejkvakter" ;
  streptokock_nn_1 = mkN "streptokock" "streptokocker" ;
  streptomycin_nn_1 = mkN "streptomycin" "streptomyciner" ;
  stressig_av_1 = mkA "stressig" ;
  stretchnylon_nn_1 = mkN "stretchnylon" "stretchnyloner" ;
  stretig_av_1 = mkA "stretig" ;
  strid_av_1 = mkA "strid" ;
  strid_nn_1 = mkN "strid" "strider" ;
  stridbar_av_1 = mkA "stridbar" ;
  stridig_av_1 = mkA "stridig" ;
  stridighet_nn_1 = mkN "stridighet" "stridigheter" ;
  stridsaatgaerd_nn_1 = mkN "stridsеtgдrd" "stridsеtgдrder" ;
  stridsdomare_nn_1 = mkN "stridsdomare" "stridsdomare" ;
  stridsformering_nn_1 = mkN "stridsformering" ;
  stridsfraaga_nn_1 = mkN "stridsfrеga" ;
  stridsgas_nn_1 = mkN "stridsgas" "stridsgaser" ;
  stridsgruppering_nn_1 = mkN "stridsgruppering" ;
  stridshandsken_ab_1 = mkAdv "stridshandsken" ;
  stridslysten_av_1 = mkA "stridslysten" "stridslystet" ;
  stridsmedel_nn_1 = mkN "stridsmedel" neutrum ;
  stridsmundering_nn_1 = mkN "stridsmundering" ;
  stridsplats_nn_1 = mkN "stridsplats" "stridsplatser" ;
  stridsrop_nn_1 = mkN "stridsrop" neutrum ;
  stridssele_nn_1 = mkN "stridssele" utrum ;
  stridsskjutning_nn_1 = mkN "stridsskjutning" ;
  stridsskrift_nn_1 = mkN "stridsskrift" "stridsskrifter" ;
  stridsspets_nn_1 = mkN "stridsspets" ;
  stridsstaellning_nn_1 = mkN "stridsstдllning" ;
  stridstupp_nn_1 = mkN "stridstupp" ;
  stridsuppstaellning_nn_1 = mkN "stridsuppstдllning" ;
  stridsvaern_nn_1 = mkN "stridsvдrn" neutrum ;
  stridsvagn_nn_1 = mkN "stridsvagn" ;
  stridsvana_nn_1 = mkN "stridsvana" ;
  strigel_nn_1 = mkN "strigel" ;
  strike_nn_1 = mkN "strike" utrum ;
  strikt_av_1 = mkA "strikt" "strikt" ;
  stril_nn_1 = mkN "stril" ;
  strimmig_av_1 = mkA "strimmig" ;
  stringent_av_1 = mkA "stringent" "stringent" ;
  stripig_av_1 = mkA "stripig" ;
  strit_nn_1 = mkN "strit" ;
  stroboskop_nn_1 = mkN "stroboskop" neutrum ;
  stroboskopi_nn_1 = mkN "stroboskopi" "stroboskopier" ;
  stroeare_nn_1 = mkN "strцare" "strцare" ;
  stroeg_nn_1 = mkN "strцg" neutrum ;
  stroejobb_nn_1 = mkN "strцjobb" neutrum ;
  stroem_av_1 = mkA "strцm" ;
  stroem_nn_1 = mkN "strцm" "strцmmen" "strцmmar" "strцmmarna" ;
  stroemavtagare_nn_1 = mkN "strцmavtagare" "strцmavtagare" ;
  stroembrytare_nn_1 = mkN "strцmbrytare" "strцmbrytare" ;
  stroemfoerande_av_1 = mkA "strцmfцrande" ;
  stroemfoertraengning_nn_1 = mkN "strцmfцrtrдngning" ;
  stroemhopp_nn_1 = mkN "strцmhopp" neutrum ;
  stroemkantring_nn_1 = mkN "strцmkantring" ;
  stroemkrets_nn_1 = mkN "strцmkrets" ;
  stroemledande_av_1 = mkA "strцmledande" ;
  stroemledning_nn_1 = mkN "strцmledning" ;
  stroemmaetare_nn_1 = mkN "strцmmдtare" "strцmmдtare" ;
  stroemming_nn_1 = mkN "strцmming" ;
  stroemning_nn_1 = mkN "strцmning" ;
  stroemring_nn_1 = mkN "strцmring" ;
  stroemstaellare_nn_1 = mkN "strцmstдllare" "strцmstдllare" ;
  stroemstare_nn_1 = mkN "strцmstare" utrum ;
  stroemstyrka_nn_1 = mkN "strцmstyrka" ;
  stroemuttag_nn_1 = mkN "strцmuttag" neutrum ;
  stroemvirvel_nn_1 = mkN "strцmvirvel" ;
  stroevomraade_nn_1 = mkN "strцvomrеde" ;
  stroevtaag_nn_1 = mkN "strцvtеg" neutrum ;
  strof_nn_1 = mkN "strof" "strofer" ;
  strofisk_av_1 = mkA "strofisk" ;
  strofpar_nn_1 = mkN "strofpar" neutrum ;
  strong_av_1 = mkA "strong" ;
  strontiumfoerening_nn_1 = mkN "strontiumfцrening" ;
  stropp_nn_1 = mkN "stropp" ;
  stroppig_av_1 = mkA "stroppig" ;
  stross_nn_1 = mkN "stross" ;
  strudel_nn_1 = mkN "strudel" ;
  struktur_nn_1 = mkN "struktur" "strukturer" ;
  strukturalist_nn_1 = mkN "strukturalist" "strukturalister" ;
  strukturarbetsloeshet_nn_1 = mkN "strukturarbetslцshet" "strukturarbetslцsheter" ;
  strukturell_av_1 = mkA "strukturell" ;
  strukturfoeraendring_nn_1 = mkN "strukturfцrдndring" ;
  strukturformel_nn_1 = mkN "strukturformel" "strukturformeln" "strukturformler" "strukturformlerna" ;
  strukturrationalisering_nn_1 = mkN "strukturrationalisering" ;
  strulig_av_1 = mkA "strulig" ;
  strumpeband_nn_1 = mkN "strumpeband" neutrum ;
  strumpebandsorden_nn_1 = mkN "strumpebandsorden" ;
  strumpfot_nn_1 = mkN "strumpfot" "strumpfцtter" ;
  strumphael_nn_1 = mkN "strumphдl" ;
  struntfin_av_1 = mkA "struntfin" ;
  struntfoernaem_av_1 = mkA "struntfцrnдm" ;
  struntsumma_nn_1 = mkN "struntsumma" ;
  struntviktig_av_1 = mkA "struntviktig" ;
  strupcancer_nn_1 = mkN "strupcancer" ;
  strupe_nn_1 = mkN "strupe" utrum ;
  struphuvud_nn_1 = mkN "struphuvud" "struphuvudet" "struphuvuden" "struphuvudena" ;
  struplock_nn_1 = mkN "struplock" neutrum ;
  strut_nn_1 = mkN "strut" ;
  struts_nn_1 = mkN "struts" ;
  strutsfjaeder_nn_1 = mkN "strutsfjдder" ;
  strutsmage_nn_1 = mkN "strutsmage" utrum ;
  strutsplym_nn_1 = mkN "strutsplym" "strutsplymer" ;
  struttig_av_1 = mkA "struttig" ;
  stryka_vb_1 = mkV "stryka" "strцk" "strukit" ;
  strykare_nn_1 = mkN "strykare" "strykare" ;
  strykbraede_nn_1 = mkN "strykbrдde" ;
  strykerska_nn_1 = mkN "strykerska" ;
  strykfaagel_nn_1 = mkN "strykfеgel" ;
  strykfri_av_1 = mkA "strykfri" "strykfritt" ;
  strykjaern_nn_1 = mkN "strykjдrn" neutrum ;
  strykning_nn_1 = mkN "strykning" ;
  strykpojke_nn_1 = mkN "strykpojke" utrum ;
  stryktaalig_av_1 = mkA "stryktеlig" ;
  stryktaeck_av_1 = mkA "stryktдck" ;
  stryktvaett_nn_1 = mkN "stryktvдtt" ;
  strypa_vb_1 = mkV "stryper" ;
  strypare_nn_1 = mkN "strypare" "strypare" ;
  strypning_nn_1 = mkN "strypning" ;
  stubb_nn_1 = mkN "stubb" ;
  stubbe_nn_1 = mkN "stubbe" utrum ;
  stubbig_av_1 = mkA "stubbig" ;
  stubin_nn_1 = mkN "stubin" "stubiner" ;
  stuck_nn_1 = mkN "stuck" "stucker" ;
  stuckatoer_nn_1 = mkN "stuckatцr" "stuckatцrer" ;
  stuckatur_nn_1 = mkN "stuckatur" "stuckaturer" ;
  stucken_av_1 = mkA "stucken" "stucket" ;
  student_nn_1 = mkN "student" "studenter" ;
  studentbetyg_nn_1 = mkN "studentbetyg" neutrum ;
  studentexamen_nn_1 = mkN "studentexamen" "studentexamen" "studentexamina" "studentexamina" ;
  studenthem_nn_1 = mkN "studenthem" "studenthemmet" "studenthem" "studenthemmen" ;
  studentikos_av_1 = mkA "studentikos" ;
  studentkaar_nn_1 = mkN "studentkеr" "studentkеrer" ;
  studentnation_nn_1 = mkN "studentnation" "studentnationer" ;
  studentsaang_nn_1 = mkN "studentsеng" "studentsеnger" ;
  studentteater_nn_1 = mkN "studentteater" ;
  studerande_nn_1 = mkN "studerande" "studeranden" "studerande" "studerandena" ;
  studerkammare_nn_1 = mkN "studerkammare" "studerkammaren" "studerkamrar" "studerkamrarna" ;
  studie_nn_1 = mkN "studie" "studier" ;
  studieaar_nn_1 = mkN "studieеr" neutrum ;
  studiebesoek_nn_1 = mkN "studiebesцk" neutrum ;
  studiebidrag_nn_1 = mkN "studiebidrag" neutrum ;
  studiecirkel_nn_1 = mkN "studiecirkel" ;
  studiedag_nn_1 = mkN "studiedag" ;
  studiefoerbund_nn_1 = mkN "studiefцrbund" neutrum ;
  studiegrupp_nn_1 = mkN "studiegrupp" "studiegrupper" ;
  studielaan_nn_1 = mkN "studielеn" neutrum ;
  studiemedel_nn_1 = mkN "studiemedel" neutrum ;
  studieobjekt_nn_1 = mkN "studieobjekt" neutrum ;
  studieorientering_nn_1 = mkN "studieorientering" ;
  studiepenning_nn_1 = mkN "studiepenning" ;
  studierektor_nn_1 = mkN "studierektor" "studierektorer" ;
  studieskuld_nn_1 = mkN "studieskuld" "studieskulder" ;
  studietid_nn_1 = mkN "studietid" "studietider" ;
  studievaegledare_nn_1 = mkN "studievдgledare" "studievдgledare" ;
  studio_nn_1 = mkN "studio" "studior" ;
  studioman_nn_1 = mkN "studioman" "studiomannen" "studiomдn" "studiomдnnen" ;
  studiomusiker_nn_1 = mkN "studiomusiker" "studiomusikern" "studiomusiker" "studiomusikerna" ;
  studiosus_nn_1 = mkN "studiosus" "studiosus" "studiosi" "studiosina" ;
  studium_nn_1 = mkN "studium" "studiet" "studier" "studierna" ;
  studs_nn_1 = mkN "studs" ;
  studsare_nn_1 = mkN "studsare" "studsare" ;
  stuff_nn_1 = mkN "stuff" "stuffer" ;
  stuga_nn_1 = mkN "stuga" ;
  stugby_nn_1 = mkN "stugby" "stugbyn" "stugbyar" "stugbyarna" ;
  stugsittare_nn_1 = mkN "stugsittare" "stugsittare" ;
  stum_av_1 = mkA "stum" "stumt" "stumma" "stumma" "stummare" "stummast" "stummaste" ;
  stumfilm_nn_1 = mkN "stumfilm" "stumfilmer" ;
  stump_nn_1 = mkN "stump" ;
  stund_nn_1 = mkN "stund" "stunder" ;
  stundlig_av_1 = mkA "stundlig" ;
  stundligen_ab_1 = mkAdv "stundligen" ;
  stundom_ab_1 = mkAdv "stundom" ;
  stundtals_ab_1 = mkAdv "stundtals" ;
  stuntman_nn_1 = mkN "stuntman" "stuntmannen" "stuntmдn" "stuntmдnnen" ;
  stup_nn_1 = mkN "stup" neutrum ;
  stupa_vb_1 = mkV "stupa" ;
  stupiditet_nn_1 = mkN "stupiditet" "stupiditeter" ;
  stuproer_nn_1 = mkN "stuprцr" neutrum ;
  stuproersmodell_nn_1 = mkN "stuprцrsmodell" "stuprцrsmodeller" ;
  stupstock_nn_1 = mkN "stupstock" ;
  sturig_av_1 = mkA "sturig" ;
  stursk_av_1 = mkA "stursk" ;
  stuss_nn_1 = mkN "stuss" ;
  stut_nn_1 = mkN "stut" ;
  stuteri_nn_1 = mkN "stuteri" "stuterit" "stuterier" "stuterierna" ;
  stuv_nn_1 = mkN "stuv" ;
  stuvare_nn_1 = mkN "stuvare" "stuvare" ;
  stuvbit_nn_1 = mkN "stuvbit" ;
  stuveri_nn_1 = mkN "stuveri" "stuverit" "stuverier" "stuverierna" ;
  stuveriarbetare_nn_1 = mkN "stuveriarbetare" "stuveriarbetare" ;
  stuvning_nn_1 = mkN "stuvning" ;
  styck_nn_1 = mkN "styck" "stycken" "stycken" "styckena" ;
  styckebruk_nn_1 = mkN "styckebruk" neutrum ;
  styckevis_ab_1 = mkAdv "styckevis" ;
  styckjunkare_nn_1 = mkN "styckjunkare" "styckjunkare" ;
  styckmaestare_nn_1 = mkN "styckmдstare" "styckmдstare" ;
  styckningsschema_nn_1 = mkN "styckningsschema" "styckningsschemat" "styckningsscheman" "styckningsschemana" ;
  styckvis_ab_1 = mkAdv "styckvis" ;
  stygg_av_1 = mkA "stygg" ;
  styggelse_nn_1 = mkN "styggelse" "styggelser" ;
  stygger_nn_1 = mkN "stygger" "styggern" "styggar" "styggarna" ;
  stygging_nn_1 = mkN "stygging" ;
  stygn_nn_1 = mkN "stygn" neutrum ;
  stylit_nn_1 = mkN "stylit" "styliter" ;
  stylobat_nn_1 = mkN "stylobat" "stylobater" ;
  styltrot_nn_1 = mkN "styltrot" "styltrцtter" ;
  stympare_nn_1 = mkN "stympare" "stympare" ;
  styng_nn_1 = mkN "styng" neutrum ;
  styrbar_av_1 = mkA "styrbar" ;
  styrbord_ab_1 = mkAdv "styrbord" ;
  styrcentrum_nn_1 = mkN "styrcentrum" neutrum ;
  styrelse_nn_1 = mkN "styrelse" "styrelser" ;
  styrelseform_nn_1 = mkN "styrelseform" "styrelseformer" ;
  styrelseledamot_nn_1 = mkN "styrelseledamot" "styrelseledamцter" ;
  styresman_nn_1 = mkN "styresman" "styresmannen" "styresmдn" "styresmдnnen" ;
  styrinraettning_nn_1 = mkN "styrinrдttning" ;
  styrka_nn_1 = mkN "styrka" ;
  styrketaar_nn_1 = mkN "styrketеr" ;
  styrlastighet_nn_1 = mkN "styrlastighet" "styrlastigheter" ;
  styrman_nn_1 = mkN "styrman" "styrmannen" "styrmдn" "styrmдnnen" ;
  styrning_nn_1 = mkN "styrning" ;
  styrsignal_nn_1 = mkN "styrsignal" "styrsignaler" ;
  styrstaang_nn_1 = mkN "styrstеng" "styrstдnger" ;
  styrstav_nn_1 = mkN "styrstav" ;
  styrsystem_nn_1 = mkN "styrsystem" neutrum ;
  styrvaexel_nn_1 = mkN "styrvдxel" ;
  styv_av_1 = mkA "styv" ;
  styvbarn_nn_1 = mkN "styvbarn" neutrum ;
  styver_nn_1 = mkN "styver" "styvern" "styver" "styverna" ;
  styvfader_nn_1 = mkN "styvfader" "styvfadern" "styvfдder" "styvfдderna" ;
  styvfoeraelder_nn_1 = mkN "styvfцrдlder" ;
  styvhet_nn_1 = mkN "styvhet" "styvheter" ;
  styvmoderlig_av_1 = mkA "styvmoderlig" ;
  styvmor_nn_1 = mkN "styvmoder" "styvmodern" "styvmцdrar" "styvmцdrarna" ;
  styvmorsviol_nn_1 = mkN "styvmorsviol" "styvmorsvioler" ;
  styvnad_nn_1 = mkN "styvnad" "styvnader" ;
  styvsint_av_1 = mkA "styvsint" "styvsint" ;
  styvsyskon_nn_1 = mkN "styvsyskon" neutrum ;
  subalpin_av_1 = mkA "subalpin" ;
  subaltern_nn_1 = mkN "subaltern" "subalterner" ;
  subantarktisk_av_1 = mkA "subantarktisk" ;
  subarktisk_av_1 = mkA "subarktisk" ;
  subbig_av_1 = mkA "subbig" ;
  subdominant_nn_1 = mkN "subdominant" "subdominanter" ;
  subjekt_nn_1 = mkN "subjekt" neutrum ;
  subjektiv_av_1 = mkA "subjektiv" ;
  subjektivitet_nn_1 = mkN "subjektivitet" "subjektiviteter" ;
  subkontinent_nn_1 = mkN "subkontinent" "subkontinenter" ;
  subkultur_nn_1 = mkN "subkultur" "subkulturer" ;
  subkutan_av_1 = mkA "subkutan" ;
  sublim_av_1 = mkA "sublim" ;
  sublimation_nn_1 = mkN "sublimation" "sublimationer" ;
  subliminal_av_1 = mkA "subliminal" ;
  submarin_av_1 = mkA "submarin" ;
  subrett_nn_1 = mkN "subrett" "subretter" ;
  subsidiaer_av_1 = mkA "subsidiдr" ;
  subskribent_nn_1 = mkN "subskribent" "subskribenter" ;
  substans_nn_1 = mkN "substans" "substanser" ;
  substantiell_av_1 = mkA "substantiell" ;
  substantiv_nn_1 = mkN "substantiv" neutrum ;
  substitut_nn_1 = mkN "substitut" neutrum ;
  substitution_nn_1 = mkN "substitution" "substitutioner" ;
  substrat_nn_1 = mkN "substrat" neutrum ;
  subtil_av_1 = mkA "subtil" ;
  subtilitet_nn_1 = mkN "subtilitet" "subtiliteter" ;
  subtraktion_nn_1 = mkN "subtraktion" "subtraktioner" ;
  subtropisk_av_1 = mkA "subtropisk" ;
  subvention_nn_1 = mkN "subvention" "subventioner" ;
  subversiv_av_1 = mkA "subversiv" ;
  succe_nn_1 = mkN "succй" "succйer" ;
  succees_nn_1 = mkN "succeйs" "succeйser" ;
  succession_nn_1 = mkN "succession" "successioner" ;
  successiv_av_1 = mkA "successiv" ;
  suck_nn_1 = mkN "suck" ;
  suckande_nn_1 = mkN "suckande" ;
  suckulent_av_1 = mkA "suckulent" "suckulent" ;
  suckulent_nn_1 = mkN "suckulent" "suckulenter" ;
  sudanes_nn_1 = mkN "sudanes" "sudaneser" ;
  sudanesisk_av_1 = mkA "sudanesisk" ;
  sudd_nn_1 = mkN "sudd" ;
  suddgummi_nn_1 = mkN "suddgummi" "suddgummit" "suddgummin" "suddgummina" ;
  suddig_av_1 = mkA "suddig" ;
  suffix_nn_1 = mkN "suffix" neutrum ;
  suffle_nn_1 = mkN "sufflй" "sufflйer" ;
  sufflett_nn_1 = mkN "sufflett" "suffletter" ;
  suffloer_nn_1 = mkN "sufflцr" "sufflцrer" ;
  suffloes_nn_1 = mkN "sufflцs" "sufflцser" ;
  suffragett_nn_1 = mkN "suffragett" "suffragetter" ;
  sug_nn_1 = mkN "sug" ;
  suga_vb_1 = mkV "suga" "sцg" "sugit" ;
  sugande_av_1 = mkA "sugande" ;
  sugen_ab_1 = mkAdv "sugen" ;
  sugen_av_1 = mkA "sugen" "suget" ;
  sugfas_nn_1 = mkN "sugfas" "sugfaser" ;
  suggestibel_av_1 = mkA "suggestibel" "suggestibelt" "suggestibla" "suggestibla" "suggestiblare" "suggestiblast" "suggestiblaste" ;
  suggestion_nn_1 = mkN "suggestion" "suggestioner" ;
  suggestiv_av_1 = mkA "suggestiv" ;
  sugroer_nn_1 = mkN "sugrцr" neutrum ;
  suicidal_av_1 = mkA "suicidal" ;
  sujett_nn_1 = mkN "sujett" "sujetter" ;
  sulfat_nn_1 = mkN "sulfat" neutrum ;
  sulfatfabrik_nn_1 = mkN "sulfatfabrik" "sulfatfabriker" ;
  sulfid_nn_1 = mkN "sulfid" "sulfider" ;
  sulfit_nn_1 = mkN "sulfit" neutrum ;
  sulfitfabrik_nn_1 = mkN "sulfitfabrik" "sulfitfabriker" ;
  sulky_nn_1 = mkN "sulky" "sulkyer" ;
  sultan_nn_1 = mkN "sultan" "sultaner" ;
  sultanat_nn_1 = mkN "sultanat" neutrum ;
  sultanrussin_nn_1 = mkN "sultanrussin" neutrum ;
  sumer_nn_1 = mkN "sumer" "sumerer" ;
  sumerer_nn_1 = mkN "sumerer" "sumerern" "sumerer" "sumererna" ;
  sumerisk_av_1 = mkA "sumerisk" ;
  summa_nn_1 = mkN "summa" ;
  summarisk_av_1 = mkA "summarisk" ;
  summer_nn_1 = mkN "summer" "summern" "summrar" "summrarna" ;
  summerton_nn_1 = mkN "summerton" "summertoner" ;
  sumo_nn_2 = mkN "sumo" "sumot" "sumon" "sumona" ;
  sump_nn_2 = mkN "sump" ;
  sumpbaever_nn_1 = mkN "sumpbдver" ;
  sumpig_av_1 = mkA "sumpig" ;
  sumpmark_nn_1 = mkN "sumpmark" "sumpmarker" ;
  sumpomraade_nn_1 = mkN "sumpomrеde" ;
  sumpskog_nn_1 = mkN "sumpskog" ;
  sund_av_1 = mkA "sund" ;
  sund_nn_1 = mkN "sund" neutrum ;
  sundae_nn_1 = mkN "sundae" "sundaer" ;
  sunnit_nn_1 = mkN "sunnit" "sunniter" ;
  suntaelt_nn_1 = mkN "suntдlt" neutrum ;
  sup_nn_1 = mkN "sup" ;
  supa_vb_1 = mkV "supa" "sцp" "supit" ;
  supe_nn_1 = mkN "supй" "supйer" ;
  superb_av_1 = mkA "superb" ;
  superdator_nn_1 = mkN "superdator" "superdatorer" ;
  superellips_nn_1 = mkN "superellips" "superellipser" ;
  superfoerening_nn_1 = mkN "superfцrening" ;
  supergalaxhop_nn_1 = mkN "supergalaxhop" ;
  superhop_nn_1 = mkN "superhop" ;
  superintendent_nn_1 = mkN "superintendent" "superintendenter" ;
  superkarg_nn_1 = mkN "superkarg" ;
  superlativ_av_1 = mkA "superlativ" ;
  superlativ_nn_1 = mkN "superlativ" "superlativer" ;
  supermakt_nn_1 = mkN "supermakt" "supermakter" ;
  supernovaexplosion_nn_1 = mkN "supernovaexplosion" "supernovaexplosioner" ;
  supernovautbrott_nn_1 = mkN "supernovautbrott" neutrum ;
  superposition_nn_1 = mkN "superposition" "superpositioner" ;
  supersnabb_av_1 = mkA "supersnabb" ;
  supersonisk_av_1 = mkA "supersonisk" ;
  superstark_av_1 = mkA "superstark" ;
  supertanker_nn_1 = mkN "supertanker" ;
  supig_av_1 = mkA "supig" ;
  supinum_nn_1 = mkN "supinum" "supinum" "supiner" "supinerna" ;
  suppleant_nn_1 = mkN "suppleant" "suppleanter" ;
  supplement_nn_1 = mkN "supplement" "supplementet" "supplementen" "supplementena" ;
  supplementaer_av_1 = mkA "supplementдr" ;
  supplementvinkel_nn_1 = mkN "supplementvinkel" ;
  supplik_nn_1 = mkN "supplik" "suppliker" ;
  supplikant_nn_1 = mkN "supplikant" "supplikanter" ;
  support_nn_1 = mkN "support" "supporter" ;
  supporter_nn_1 = mkN "supporter" ;
  supposition_nn_1 = mkN "supposition" "suppositioner" ;
  suppositorium_nn_1 = mkN "suppositorium" "suppositoriet" "suppositorier" "suppositorierna" ;
  supradental_av_1 = mkA "supradental" ;
  supradental_nn_1 = mkN "supradental" "supradentaler" ;
  supramarin_av_1 = mkA "supramarin" ;
  suput_nn_1 = mkN "suput" ;
  sur_av_1 = mkA "sur" ;
  surapel_nn_1 = mkN "surapel" ;
  surbrunn_nn_1 = mkN "surbrunn" ;
  surdeg_nn_1 = mkN "surdeg" ;
  surfare_nn_1 = mkN "surfare" "surfare" ;
  surfoder_nn_1 = mkN "surfoder" neutrum ;
  surhet_nn_1 = mkN "surhet" "surheter" ;
  surhetsgrad_nn_1 = mkN "surhetsgrad" "surhetsgrader" ;
  surinames_nn_1 = mkN "surinames" "surinameser" ;
  surinamesisk_av_1 = mkA "surinamesisk" ;
  surkart_nn_1 = mkN "surkart" ;
  surkoersbaer_nn_1 = mkN "surkцrsbдr" neutrum ;
  surmulen_av_1 = mkA "surmulen" "surmulet" ;
  suroegd_av_1 = mkA "surцgd" "surцgt" ;
  surpris_nn_1 = mkN "surpris" "surpriser" ;
  surrealistisk_av_1 = mkA "surrealistisk" ;
  surrogat_nn_1 = mkN "surrogat" neutrum ;
  surstek_nn_1 = mkN "surstek" ;
  surstroemming_nn_1 = mkN "surstrцmming" ;
  susen_ab_1 = mkAdv "susen" ;
  suspekt_av_1 = mkA "suspekt" "suspekt" ;
  suspension_nn_1 = mkN "suspension" "suspensioner" ;
  suspensiv_av_1 = mkA "suspensiv" ;
  suspensoar_nn_1 = mkN "suspensoar" "suspensoarer" ;
  sutan_nn_1 = mkN "sutan" "sutaner" ;
  sutare_nn_1 = mkN "sutare" "sutare" ;
  sutenoer_nn_1 = mkN "sutenцr" "sutenцrer" ;
  suterraengvaaning_nn_1 = mkN "suterrдngvеning" ;
  sutur_nn_1 = mkN "sutur" "suturer" ;
  suvenir_nn_1 = mkN "suvenir" "suvenirer" ;
  suveraen_av_1 = mkA "suverдn" ;
  suveraen_nn_1 = mkN "suverдn" "suverдner" ;
  suveraenitet_nn_1 = mkN "suverдnitet" "suverдniteter" ;
  svaager_nn_1 = mkN "svеger" ;
  svaal_nn_1 = mkN "svеl" ;
  svaangrem_nn_1 = mkN "svеngrem" "svеngremmen" "svеngremmar" "svеngremmarna" ;
  svaar_av_1 = mkA "svеr" ;
  svaara_ab_1 = mkAdv "svеra" ;
  svaarbedoemd_av_1 = mkA "svеrbedцmd" "svеrbedцmt" ;
  svaarbegriplig_av_1 = mkA "svеrbegriplig" ;
  svaarfoerklarlig_av_1 = mkA "svеrfцrklarlig" ;
  svaarframkomlig_av_1 = mkA "svеrframkomlig" ;
  svaarighet_nn_1 = mkN "svеrighet" "svеrigheter" ;
  svaarlaest_av_1 = mkA "svеrlдst" "svеrlдst" ;
  svaarligen_ab_1 = mkAdv "svеrligen" ;
  svaarloest_av_1 = mkA "svеrlцst" "svеrlцst" ;
  svaarmodig_av_1 = mkA "svеrmodig" ;
  svaarpaavisbar_av_1 = mkA "svеrpеvisbar" ;
  svaarsaald_av_1 = mkA "svеrsеld" "svеrsеlt" ;
  svaarsmaelt_av_1 = mkA "svеrsmдlt" "svеrsmдlt" ;
  svaartillgaenglig_av_1 = mkA "svеrtillgдnglig" ;
  svaarupptaeckt_av_1 = mkA "svеrupptдckt" "svеrupptдckt" ;
  svabb_nn_1 = mkN "svabb" ;
  svaegerska_nn_1 = mkN "svдgerska" ;
  svaelta_vb_2 = mkV "svдlta" "svдlter" "svдlt" "svalt" "svultit" "svдlt" ;
  svaeltdoed_nn_1 = mkN "svдltdцd" ;
  svaeltfoedd_av_1 = mkA "svдltfцdd" ;
  svaeltkatastrof_nn_1 = mkN "svдltkatastrof" "svдltkatastrofer" ;
  svaeltkonstnaer_nn_1 = mkN "svдltkonstnдr" "svдltkonstnдrer" ;
  svaeltloen_nn_1 = mkN "svдltlцn" "svдltlцner" ;
  svaeng_nn_1 = mkN "svдng" ;
  svaengbro_nn_1 = mkN "svдngbro" ;
  svaengd_av_1 = mkA "svдngd" "svдngt" ;
  svaengdoerr_nn_1 = mkN "svдngdцrr" ;
  svaengel_nn_1 = mkN "svдngel" ;
  svaenghjul_nn_1 = mkN "svдnghjul" neutrum ;
  svaenghjulsmagnet_nn_1 = mkN "svдnghjulsmagnet" "svдnghjulsmagneter" ;
  svaengig_av_1 = mkA "svдngig" ;
  svaengning_nn_1 = mkN "svдngning" ;
  svaengningskrets_nn_1 = mkN "svдngningskrets" ;
  svaengningsproblem_nn_1 = mkN "svдngningsproblem" neutrum ;
  svaengningstal_nn_1 = mkN "svдngningstal" "svдngningstalet" "svдngningstalen" "svдngningstalena" ;
  svaengom_nn_1 = mkN "svдngom" ;
  svaera_vb_1 = mkV "svдra" "svor" "svurit" ;
  svaerd_nn_1 = mkN "svдrd" neutrum ;
  svaerdbaerare_nn_1 = mkN "svдrdbдrare" "svдrdbдrare" ;
  svaerdfejare_nn_1 = mkN "svдrdfejare" "svдrdfejare" ;
  svaerdfisk_nn_1 = mkN "svдrdfisk" ;
  svaerdlik_av_1 = mkA "svдrdlik" ;
  svaerdotter_nn_1 = mkN "svдrdotter" "svдrdottern" "svдrdцttrar" "svдrdцttrarna" ;
  svaerdsfejare_nn_1 = mkN "svдrdsfejare" "svдrdsfejare" ;
  svaerdslilja_nn_1 = mkN "svдrdslilja" ;
  svaerdsloes_av_1 = mkA "svдrdslцs" ;
  svaerdslukare_nn_1 = mkN "svдrdslukare" "svдrdslukare" ;
  svaerdsslukare_nn_1 = mkN "svдrdsslukare" "svдrdsslukare" ;
  svaerfader_nn_1 = mkN "svдrfader" "svдrfadern" "svдrfдder" "svдrfдderna" ;
  svaerfoeraelder_nn_1 = mkN "svдrfцrдlder" ;
  svaerja_vb_1 = mkV "svдrja" "svдrj" "svдrj" "svorj" "svurjit" "svurjen" ;
  svaerm_nn_1 = mkN "svдrm" ;
  svaermare_nn_1 = mkN "svдrmare" "svдrmare" ;
  svaermeri_nn_1 = mkN "svдrmeri" "svдrmerit" "svдrmerier" "svдrmerierna" ;
  svaermisk_av_1 = mkA "svдrmisk" ;
  svaermor_nn_1 = mkN "svдrmoder" "svдrmodern" "svдrmцdrar" "svдrmцdrarna" ;
  svaermorsdroem_nn_1 = mkN "svдrmorsdrцm" "svдrmorsdrцmmen" "svдrmorsdrцmmar" "svдrmorsdrцmmarna" ;
  svaermorshistoria_nn_1 = mkN "svдrmorshistoria" "svдrmorshistorien" "svдrmorshistorier" "svдrmorshistorierna" ;
  svaerord_nn_1 = mkN "svдrord" neutrum ;
  svaerson_nn_1 = mkN "svдrson" "svдrsцner" ;
  svaevande_av_1 = mkA "svдvande" ;
  svaevare_nn_1 = mkN "svдvare" "svдvare" ;
  svaevfarkost_nn_1 = mkN "svдvfarkost" "svдvfarkoster" ;
  svaevning_nn_1 = mkN "svдvning" ;
  svag_av_1 = mkA "svag" ;
  svaghet_nn_1 = mkN "svaghet" "svagheter" ;
  svaglysande_av_1 = mkA "svaglysande" ;
  svagpresterande_av_1 = mkA "svagpresterande" ;
  svagsint_av_1 = mkA "svagsint" "svagsint" ;
  svagstroem_nn_1 = mkN "svagstrцm" "svagstrцmmen" "svagstrцmmar" "svagstrцmmarna" ;
  svagsynt_av_1 = mkA "svagsynt" "svagsynt" ;
  svagtonig_av_1 = mkA "svagtonig" ;
  svajig_av_1 = mkA "svajig" ;
  svajmast_nn_1 = mkN "svajmast" "svajmaster" ;
  sval_av_1 = mkA "sval" ;
  sval_nn_1 = mkN "sval" ;
  svale_nn_1 = mkN "svale" utrum ;
  svalg_nn_1 = mkN "svalg" neutrum ;
  svalgaang_nn_1 = mkN "svalgеng" ;
  svalgmandel_nn_1 = mkN "svalgmandel" ;
  svall_nn_1 = mkN "svall" neutrum ;
  svalliknande_av_1 = mkA "svalliknande" ;
  svamlig_av_1 = mkA "svamlig" ;
  svamp_nn_1 = mkN "svamp" ;
  svampdjur_nn_1 = mkN "svampdjur" neutrum ;
  svampig_av_1 = mkA "svampig" ;
  svampliknande_av_1 = mkA "svampliknande" ;
  svampmoln_nn_1 = mkN "svampmoln" neutrum ;
  svampparasit_nn_1 = mkN "svampparasit" "svampparasiter" ;
  svampsjukdom_nn_1 = mkN "svampsjukdom" ;
  svampvaext_nn_1 = mkN "svampvдxt" "svampvдxter" ;
  svan_nn_1 = mkN "svan" ;
  svanhals_nn_1 = mkN "svanhals" ;
  svanhopp_nn_1 = mkN "svanhopp" neutrum ;
  svank_nn_1 = mkN "svank" ;
  svankig_av_1 = mkA "svankig" ;
  svankrygg_nn_1 = mkN "svankrygg" ;
  svans_nn_1 = mkN "svans" ;
  svansmotor_nn_1 = mkN "svansmotor" "svansmotorer" ;
  svanstipp_nn_1 = mkN "svanstipp" ;
  svansviftare_nn_1 = mkN "svansviftare" "svansviftare" ;
  svar_nn_1 = mkN "svar" neutrum ;
  svarande_nn_1 = mkN "svarande" "svaranden" "svarande" "svarandena" ;
  svaromaal_nn_1 = mkN "svaromеl" neutrum ;
  svarskupong_nn_1 = mkN "svarskupong" "svarskuponger" ;
  svarsloes_av_1 = mkA "svarslцs" ;
  svart_av_1 = mkA "svart" "svart" ;
  svartaboershaj_nn_1 = mkN "svartabцrshaj" ;
  svartbroder_nn_1 = mkN "svartbroder" "svartbrodern" "svartbrцder" "svartbrцderna" ;
  svartfot_nn_1 = mkN "svartfot" "svartfцtter" ;
  svartglaensande_av_1 = mkA "svartglдnsande" ;
  svarting_nn_1 = mkN "svarting" ;
  svartlistning_nn_1 = mkN "svartlistning" ;
  svartlistningsgraens_nn_1 = mkN "svartlistningsgrдns" "svartlistningsgrдnser" ;
  svartmuskig_av_1 = mkA "svartmuskig" ;
  svartrock_nn_1 = mkN "svartrock" ;
  svartsjuk_av_1 = mkA "svartsjuk" ;
  svartskalle_nn_1 = mkN "svartskalle" utrum ;
  svartvit_av_1 = mkA "svartvit" ;
  svarv_nn_1 = mkN "svarv" ;
  svarvare_nn_1 = mkN "svarvare" "svarvare" ;
  svarvstaal_nn_1 = mkN "svarvstеl" neutrum ;
  svarvstol_nn_1 = mkN "svarvstol" ;
  svavelbakterie_nn_1 = mkN "svavelbakterie" "svavelbakterier" ;
  svavelbindning_nn_1 = mkN "svavelbindning" ;
  svavelfoerening_nn_1 = mkN "svavelfцrening" ;
  svavelhalt_nn_1 = mkN "svavelhalt" "svavelhalter" ;
  svavelomsaettning_nn_1 = mkN "svavelomsдttning" ;
  svavelosande_av_1 = mkA "svavelosande" ;
  svavelpredikant_nn_1 = mkN "svavelpredikant" "svavelpredikanter" ;
  svavelpulver_nn_1 = mkN "svavelpulver" neutrum ;
  svavelroek_nn_1 = mkN "svavelrцk" ;
  svavelsyrlighet_nn_1 = mkN "svavelsyrlighet" "svavelsyrligheter" ;
  sveamaal_nn_1 = mkN "sveamеl" neutrum ;
  svecism_nn_1 = mkN "svecism" "svecismer" ;
  sved_nn_1 = mkN "sved" "sveder" ;
  svedja_nn_1 = mkN "svedja" ;
  svedjeland_nn_1 = mkN "svedjeland" neutrum ;
  svek_nn_1 = mkN "svek" neutrum ;
  svekfull_av_1 = mkA "svekfull" ;
  sveklig_av_1 = mkA "sveklig" ;
  svekloes_av_1 = mkA "sveklцs" ;
  svekoman_nn_1 = mkN "svekoman" "svekomaner" ;
  sven_nn_1 = mkN "sven" "svennen" "svenner" "svennerna" ;
  svendom_nn_1 = mkN "svendom" ;
  svensk_av_1 = mkA "svensk" ;
  svensk_nn_1 = mkN "svensk" ;
  svenska_nn_2 = mkN "svenska" ;
  svenskamerikan_nn_1 = mkN "svenskamerikan" "svenskamerikaner" ;
  svenskbygd_nn_1 = mkN "svenskbygd" "svenskbygder" ;
  svenskfoedd_av_1 = mkA "svenskfцdd" ;
  svenskhet_nn_1 = mkN "svenskhet" "svenskheter" ;
  svenskhetsivrare_nn_1 = mkN "svenskhetsivrare" "svenskhetsivrare" ;
  svenskstoedd_av_1 = mkA "svenskstцdd" ;
  svep_nn_1 = mkN "svep" neutrum ;
  svepande_av_1 = mkA "svepande" ;
  svephammare_nn_1 = mkN "svephammare" "svephammaren" "svephamrar" "svephamrarna" ;
  svepning_nn_1 = mkN "svepning" ;
  svepskael_nn_1 = mkN "svepskдl" neutrum ;
  sverigefinne_nn_1 = mkN "sverigefinne" utrum ;
  svets_nn_1 = mkN "svets" ;
  svetsare_nn_1 = mkN "svetsare" "svetsare" ;
  svetsning_nn_1 = mkN "svetsning" ;
  svett_av_1 = mkA "svett" ;
  svettband_nn_1 = mkN "svettband" neutrum ;
  svettig_av_1 = mkA "svettig" ;
  svettning_nn_1 = mkN "svettning" ;
  svettrem_nn_1 = mkN "svettrem" "svettremmen" "svettremmar" "svettremmarna" ;
  svibel_nn_1 = mkN "svibel" ;
  svid_nn_1 = mkN "svid" ;
  svidknott_nn_1 = mkN "svidknott" neutrum ;
  svika_vb_1 = mkV "svika" "svek" "svikit" ;
  svikare_nn_1 = mkN "svikare" "svikare" ;
  sviklig_av_1 = mkA "sviklig" ;
  svikt_nn_1 = mkN "svikt" ;
  svimning_nn_1 = mkN "svimning" ;
  svin_nn_1 = mkN "svin" neutrum ;
  svinaktig_av_1 = mkA "svinaktig" ;
  svinbesaettning_nn_1 = mkN "svinbesдttning" ;
  svindlande_av_1 = mkA "svindlande" ;
  svindlare_nn_1 = mkN "svindlare" "svindlare" ;
  svindleri_nn_1 = mkN "svindleri" "svindlerit" "svindlerier" "svindlerierna" ;
  svindyr_av_1 = mkA "svindyr" ;
  svineri_nn_1 = mkN "svineri" "svinerit" "svinerier" "svinerierna" ;
  svinfett_nn_1 = mkN "svinfett" "svinfettet" "svinfetter" "svinfetterna" ;
  sving_nn_1 = mkN "sving" ;
  svinkall_av_1 = mkA "svinkall" ;
  svinkoett_nn_1 = mkN "svinkцtt" neutrum ;
  svinliknande_av_1 = mkA "svinliknande" ;
  svinn_nn_1 = mkN "svinn" neutrum ;
  svinna_vb_1 = mkV "svinna" "svann" "svunnit" ;
  svinpaels_nn_1 = mkN "svinpдls" ;
  svinrygg_nn_1 = mkN "svinrygg" ;
  svinstall_nn_1 = mkN "svinstall" neutrum ;
  svinuppfoedning_nn_1 = mkN "svinuppfцdning" ;
  svirvel_nn_1 = mkN "svirvel" ;
  sviskon_nn_1 = mkN "sviskon" neutrum ;
  svit_nn_1 = mkN "svit" "sviter" ;
  svivel_nn_1 = mkN "svivel" ;
  svordom_nn_1 = mkN "svordom" ;
  svullen_av_1 = mkA "svullen" "svullet" ;
  svullnad_nn_1 = mkN "svullnad" "svullnader" ;
  svulst_nn_1 = mkN "svulst" "svulster" ;
  svulstig_av_1 = mkA "svulstig" ;
  svulten_av_1 = mkA "svulten" "svultet" ;
  svuren_av_1 = mkA "svuren" "svuret" ;
  swazilaendare_nn_1 = mkN "swazilдndare" "swazilдndare" ;
  swazilaendsk_av_1 = mkA "swazilдndsk" ;
  sweater_nn_1 = mkN "sweater" ;
  sweatshirt_nn_1 = mkN "sweatshirt" "sweatshirten" "sweatshirts" "sweatshirtsen" ;
  sweet_av_1 = mkA "sweet" ;
  swimmingpool_nn_1 = mkN "swimmingpool" "swimmingpooler" ;
  swingpjatt_nn_1 = mkN "swingpjatt" ;
  sybaage_nn_1 = mkN "sybеge" utrum ;
  sybarit_nn_1 = mkN "sybarit" "sybariter" ;
  sybaritisk_av_1 = mkA "sybaritisk" ;
  sybehoer_nn_1 = mkN "sybehцr" neutrum ;
  syd_ab_1 = mkAdv "syd" ;
  sydafrikan_nn_1 = mkN "sydafrikan" "sydafrikaner" ;
  sydafrikansk_av_1 = mkA "sydafrikansk" ;
  sydamerikansk_av_1 = mkA "sydamerikansk" ;
  sydfrukt_nn_1 = mkN "sydfrukt" "sydfrukter" ;
  sydkorean_nn_1 = mkN "sydkorean" "sydkoreaner" ;
  sydkust_nn_1 = mkN "sydkust" "sydkuster" ;
  sydlaendsk_av_1 = mkA "sydlдndsk" ;
  sydlaenning_nn_1 = mkN "sydlдnning" ;
  sydlig_av_1 = mkA "sydlig" ;
  sydoest_ab_1 = mkAdv "sydцst" ;
  sydoestra_av_1 = mkA "sydцstra" ;
  sydost_ab_1 = mkAdv "sydost" ;
  sydpol_nn_1 = mkN "sydpol" "sydpoler" ;
  sydstat_nn_1 = mkN "sydstat" "sydstater" ;
  sydsvensk_av_1 = mkA "sydsvensk" ;
  sydvaest_ab_1 = mkAdv "sydvдst" ;
  sydvaest_nn_2 = mkN "sydvдst" ;
  sydvart_ab_1 = mkAdv "sydvart" ;
  sydyemenit_nn_1 = mkN "sydyemenit" "sydyemeniter" ;
  syfilitisk_av_1 = mkA "syfilitisk" ;
  syfoerening_nn_1 = mkN "syfцrening" ;
  syfte_nn_1 = mkN "syfte" ;
  sykofant_nn_1 = mkN "sykofant" "sykofanter" ;
  sykomor_nn_1 = mkN "sykomor" "sykomoren" "sykomorer" "sykomorerna" ;
  syl_nn_1 = mkN "syl" ;
  sylf_nn_1 = mkN "sylf" "sylfer" ;
  sylfid_nn_1 = mkN "sylfid" "sylfider" ;
  syll_nn_1 = mkN "syll" ;
  syllabisk_av_1 = mkA "syllabisk" ;
  syllogism_nn_1 = mkN "syllogism" "syllogismer" ;
  sylt_nn_1 = mkN "sylt" "sylter" ;
  syltberedning_nn_1 = mkN "syltberedning" ;
  syltloek_nn_1 = mkN "syltlцk" ;
  syltpaeron_nn_1 = mkN "syltpдron" neutrum ;
  sylvesterbal_nn_1 = mkN "sylvesterbal" "sylvesterbaler" ;
  symaskin_nn_1 = mkN "symaskin" "symaskiner" ;
  symbol_nn_1 = mkN "symbol" "symboler" ;
  symbolisk_av_1 = mkA "symbolisk" ;
  symbolist_nn_1 = mkN "symbolist" "symbolister" ;
  symfoni_nn_1 = mkN "symfoni" "symfonier" ;
  symfoniker_nn_1 = mkN "symfoniker" "symfonikern" "symfoniker" "symfonikerna" ;
  symfoniorkester_nn_1 = mkN "symfoniorkester" ;
  symfonisk_av_1 = mkA "symfonisk" ;
  symfys_nn_1 = mkN "symfys" "symfyser" ;
  symmetri_nn_1 = mkN "symmetri" "symmetrier" ;
  symmetriaxel_nn_1 = mkN "symmetriaxel" ;
  symmetrilinje_nn_1 = mkN "symmetrilinje" "symmetrilinjer" ;
  symmetriplan_nn_1 = mkN "symmetriplan" neutrum ;
  symmetrisk_av_1 = mkA "symmetrisk" ;
  sympatetisk_av_1 = mkA "sympatetisk" ;
  sympati_nn_1 = mkN "sympati" "sympatier" ;
  sympatisk_av_1 = mkA "sympatisk" ;
  sympatisoer_nn_1 = mkN "sympatisцr" "sympatisцrer" ;
  symposium_nn_1 = mkN "symposium" "symposiet" "symposier" "symposierna" ;
  symptom_nn_1 = mkN "symptom" neutrum ;
  symtom_nn_1 = mkN "symtom" neutrum ;
  symtomatisk_av_1 = mkA "symtomatisk" ;
  syn_nn_1 = mkN "syn" "syner" ;
  synaal_nn_1 = mkN "synеl" ;
  synaps_nn_1 = mkN "synaps" "synapser" ;
  synapsbassaeng_nn_1 = mkN "synapsbassдng" "synapsbassдnger" ;
  synare_nn_1 = mkN "synare" "synare" ;
  synbar_av_1 = mkA "synbar" ;
  synbarlig_av_1 = mkA "synbarlig" ;
  synbarligen_ab_1 = mkAdv "synbarligen" ;
  synbild_nn_1 = mkN "synbild" "synbilder" ;
  syncell_nn_1 = mkN "syncell" "synceller" ;
  synd_ab_1 = mkAdv "synd" ;
  synd_nn_1 = mkN "synd" "synder" ;
  syndabekaennelse_nn_1 = mkN "syndabekдnnelse" "syndabekдnnelser" ;
  syndabock_nn_1 = mkN "syndabock" ;
  syndafall_nn_1 = mkN "syndafall" neutrum ;
  syndaflod_nn_1 = mkN "syndaflod" "syndafloder" ;
  syndapeng_nn_1 = mkN "syndapeng" ;
  syndare_nn_1 = mkN "syndare" "syndare" ;
  syndastraff_nn_1 = mkN "syndastraff" neutrum ;
  syndig_av_1 = mkA "syndig" ;
  syndikalist_nn_1 = mkN "syndikalist" "syndikalister" ;
  syndikat_nn_1 = mkN "syndikat" neutrum ;
  syndrom_nn_1 = mkN "syndrom" neutrum ;
  synestesi_nn_1 = mkN "synestesi" "synestesier" ;
  synfaelt_nn_1 = mkN "synfдlt" neutrum ;
  synfel_nn_1 = mkN "synfel" "synfelet" "synfel" "synfelen" ;
  synfoernimmelse_nn_1 = mkN "synfцrnimmelse" "synfцrnimmelser" ;
  synintryck_nn_1 = mkN "synintryck" neutrum ;
  synk_nn_1 = mkN "synk" ;
  synkop_nn_1 = mkN "synkop" "synkoper" ;
  synkopisk_av_1 = mkA "synkopisk" ;
  synkpuls_nn_1 = mkN "synkpuls" "synkpulser" ;
  synkron_av_1 = mkA "synkron" ;
  synkronisering_nn_1 = mkN "synkronisering" ;
  synkronisk_av_1 = mkA "synkronisk" ;
  synkrotron_nn_1 = mkN "synkrotron" "synkrotroner" ;
  synlig_av_1 = mkA "synlig" ;
  synnerlig_av_1 = mkA "synnerlig" ;
  synnerligen_ab_1 = mkAdv "synnerligen" ;
  synod_nn_1 = mkN "synod" "synoder" ;
  synodal_av_1 = mkA "synodal" ;
  synodisk_av_1 = mkA "synodisk" ;
  synonym_av_1 = mkA "synonym" ;
  synonym_nn_1 = mkN "synonym" "synonymer" ;
  synonymi_nn_1 = mkN "synonymi" "synonymier" ;
  synops_nn_1 = mkN "synops" "synopser" ;
  synoptiker_nn_1 = mkN "synoptiker" "synoptikern" "synoptiker" "synoptikerna" ;
  synoptisk_av_1 = mkA "synoptisk" ;
  synorgan_nn_1 = mkN "synorgan" neutrum ;
  synpunkt_nn_1 = mkN "synpunkt" "synpunkter" ;
  synsaett_nn_1 = mkN "synsдtt" neutrum ;
  synsjukdom_nn_1 = mkN "synsjukdom" ;
  synsk_av_1 = mkA "synsk" ;
  synt_nn_1 = mkN "synt" ;
  syntagm_nn_1 = mkN "syntagm" neutrum ;
  syntaktisk_av_1 = mkA "syntaktisk" ;
  syntax_nn_1 = mkN "syntax" "syntaxer" ;
  syntes_nn_1 = mkN "syntes" "synteser" ;
  syntet_nn_1 = mkN "syntet" "synteter" ;
  syntetfiber_nn_1 = mkN "syntetfiber" "syntetfibern" "syntetfibrer" "syntetfibrerna" ;
  syntetisk_av_1 = mkA "syntetisk" ;
  syntetmaterial_nn_1 = mkN "syntetmaterial" neutrum ;
  synthesizer_nn_1 = mkN "synthesizer" ;
  synvinkel_nn_1 = mkN "synvinkel" ;
  syo_nn_1 = mkN "syo" "syor" ;
  syokonsulent_nn_1 = mkN "syokonsulent" "syokonsulenter" ;
  syperb_av_1 = mkA "syperb" ;
  syrafast_av_1 = mkA "syrafast" "syrafast" ;
  syralaeckage_nn_1 = mkN "syralдckage" "syralдckaget" "syralдckage" "syralдckagen" ;
  syreatom_nn_1 = mkN "syreatom" "syreatomer" ;
  syrefaelt_nn_1 = mkN "syrefдlt" neutrum ;
  syrefattig_av_1 = mkA "syrefattig" ;
  syrefordrande_av_1 = mkA "syrefordrande" ;
  syremolekyl_nn_1 = mkN "syremolekyl" "syremolekyler" ;
  syren_nn_1 = mkN "syren" "syrener" ;
  syrerik_av_1 = mkA "syrerik" ;
  syreupptagande_av_1 = mkA "syreupptagande" ;
  syrgasmask_nn_1 = mkN "syrgasmask" "syrgasmasker" ;
  syrgasmolekyl_nn_1 = mkN "syrgasmolekyl" "syrgasmolekyler" ;
  syrier_nn_1 = mkN "syrier" "syriern" "syrier" "syrierna" ;
  syrinx_nn_1 = mkN "syrinx" ;
  syrisk_av_1 = mkA "syrisk" ;
  syriska_nn_2 = mkN "syriska" ;
  syrlig_av_1 = mkA "syrlig" ;
  syrtut_nn_1 = mkN "syrtut" "syrtuter" ;
  syskon_nn_1 = mkN "syskon" neutrum ;
  syskonbaedd_nn_1 = mkN "syskonbдdd" ;
  syskonbarn_nn_1 = mkN "syskonbarn" neutrum ;
  syskongrupp_nn_1 = mkN "syskongrupp" "syskongrupper" ;
  syskonkaerlek_nn_1 = mkN "syskonkдrlek" ;
  syskonlig_av_1 = mkA "syskonlig" ;
  sysselsaettning_nn_1 = mkN "sysselsдttning" ;
  sysselsatt_av_1 = mkA "sysselsatt" ;
  syssla_nn_1 = mkN "syssla" ;
  syssling_nn_1 = mkN "syssling" ;
  syssloloes_av_1 = mkA "sysslolцs" ;
  syssloman_nn_1 = mkN "syssloman" "sysslomannen" "sysslomдn" "sysslomдnnen" ;
  system_nn_1 = mkN "system" neutrum ;
  systematisk_av_1 = mkA "systematisk" ;
  systembolag_nn_1 = mkN "systembolag" neutrum ;
  systemerare_nn_1 = mkN "systemerare" "systemerare" ;
  systemkoe_nn_1 = mkN "systemkц" "systemkцn" "systemkцer" "systemkцerna" ;
  systemman_nn_1 = mkN "systemman" "systemmannen" "systemmдn" "systemmдnnen" ;
  syster_nn_1 = mkN "syster" ;
  systerbarn_nn_1 = mkN "systerbarn" neutrum ;
  systerdotter_nn_1 = mkN "systerdotter" "systerdottern" "systerdцttrar" "systerdцttrarna" ;
  systerfartyg_nn_1 = mkN "systerfartyg" neutrum ;
  systerson_nn_1 = mkN "systerson" "systersцner" ;
  systolisk_av_1 = mkA "systolisk" ;
  sytraad_nn_1 = mkN "sytrеd" ;
  t_shirt_nn_1 = mkN "t-shirt" ;
  ta_vb_1 = mkV "ta" "tar" "ta" "tog" "tagit" "tagen" ;
  taa_nn_1 = mkN "tе" "tеn" "tеr" "tеrna" ;
  taag_nn_1 = mkN "tеg" neutrum ;
  taagaangare_nn_1 = mkN "tеgеngare" "tеgеngare" ;
  taagbiljett_nn_1 = mkN "tеgbiljett" "tеgbiljetter" ;
  taagklarerare_nn_1 = mkN "tеgklarerare" "tеgklarerare" ;
  taagkupe_nn_1 = mkN "tеgkupй" "tеgkupйer" ;
  taagordning_nn_1 = mkN "tеgordning" ;
  taagsaett_nn_1 = mkN "tеgsдtt" neutrum ;
  taagtid_nn_1 = mkN "tеgtid" "tеgtider" ;
  taahaevning_nn_1 = mkN "tеhдvning" ;
  taajaern_nn_1 = mkN "tеjдrn" neutrum ;
  taalamodsproevande_av_1 = mkA "tеlamodsprцvande" ;
  taalig_av_1 = mkA "tеlig" ;
  taalmodig_av_1 = mkA "tеlmodig" ;
  taanagel_nn_1 = mkN "tеnagel" ;
  taang_nn_1 = mkN "tеng" "tдnger" ;
  taangbad_nn_1 = mkN "tеngbad" neutrum ;
  taange_nn_1 = mkN "tеnge" utrum ;
  taanglake_nn_1 = mkN "tеnglake" utrum ;
  taar_nn_1 = mkN "tеr" ;
  taarben_nn_1 = mkN "tеrben" neutrum ;
  taardraenkt_av_1 = mkA "tеrdrдnkt" "tеrdrдnkt" ;
  taardrypande_av_1 = mkA "tеrdrypande" ;
  taaredal_nn_1 = mkN "tеredal" ;
  taarkanal_nn_1 = mkN "tеrkanal" "tеrkanaler" ;
  taarkoertel_nn_1 = mkN "tеrkцrtel" ;
  taaroegd_av_1 = mkA "tеrцgd" "tеrцgt" ;
  taarpil_nn_1 = mkN "tеrpil" ;
  taarsaeck_nn_1 = mkN "tеrsдck" ;
  taartbotten_nn_1 = mkN "tеrtbotten" ;
  taartspade_nn_1 = mkN "tеrtspade" utrum ;
  taaspets_nn_1 = mkN "tеspets" ;
  taat_nn_1 = mkN "tеt" ;
  tabbe_nn_1 = mkN "tabbe" utrum ;
  tabell_nn_1 = mkN "tabell" "tabeller" ;
  tabellarisk_av_1 = mkA "tabellarisk" ;
  tabellhuvud_nn_1 = mkN "tabellhuvud" "tabellhuvudet" "tabellhuvuden" "tabellhuvudena" ;
  tabernakel_nn_1 = mkN "tabernakel" neutrum ;
  tablaa_nn_1 = mkN "tablе" "tablеer" ;
  tablett_nn_1 = mkN "tablett" "tabletter" ;
  tabloid_nn_1 = mkN "tabloid" "tabloider" ;
  tabu_av_1 = mkA "tabu" ;
  tabu_nn_1 = mkN "tabu" "tabut" "tabun" "tabuna" ;
  tabulator_nn_1 = mkN "tabulator" "tabulatorer" ;
  tabulatur_nn_1 = mkN "tabulatur" "tabulaturer" ;
  tabuord_nn_1 = mkN "tabuord" neutrum ;
  taburett_nn_1 = mkN "taburett" "taburetter" ;
  tack_nn_1 = mkN "tack" neutrum ;
  tackel_nn_1 = mkN "tackel" neutrum ;
  tackjaernsblandare_nn_1 = mkN "tackjдrnsblandare" "tackjдrnsblandare" ;
  tackkort_nn_1 = mkN "tackkort" neutrum ;
  tackling_nn_1 = mkN "tackling" ;
  tacknaemlig_av_1 = mkA "tacknдmlig" ;
  tackoffer_nn_1 = mkN "tackoffer" neutrum ;
  tacksaegelse_nn_1 = mkN "tacksдgelse" "tacksдgelser" ;
  tacksaegelsedag_nn_1 = mkN "tacksдgelsedag" ;
  tacksam_av_1 = mkA "tacksam" "tacksamt" "tacksamma" "tacksamma" "tacksammare" "tacksammast" "tacksammaste" ;
  tacksamhet_nn_1 = mkN "tacksamhet" "tacksamheter" ;
  tacktal_nn_1 = mkN "tacktal" "tacktalet" "tacktalen" "tacktalena" ;
  tadelfri_av_1 = mkA "tadelfri" "tadelfritt" ;
  taeck_av_1 = mkA "tдck" ;
  taeckadress_nn_1 = mkN "tдckadress" "tдckadresser" ;
  taeckblad_nn_1 = mkN "tдckblad" neutrum ;
  taeckdike_nn_1 = mkN "tдckdike" ;
  taeckelig_av_1 = mkA "tдckelig" ;
  taeckelse_nn_1 = mkN "tдckelse" "tдckelset" "tдckelser" "tдckelserna" ;
  taeckfaerg_nn_1 = mkN "tдckfдrg" "tдckfдrger" ;
  taeckfoerband_nn_1 = mkN "tдckfцrband" neutrum ;
  taeckglas_nn_1 = mkN "tдckglas" neutrum ;
  taeckhaar_nn_1 = mkN "tдckhеr" neutrum ;
  taeckmantel_nn_1 = mkN "tдckmantel" ;
  taecknamn_nn_1 = mkN "tдcknamn" neutrum ;
  taeckning_nn_1 = mkN "tдckning" ;
  taeckningskoep_nn_1 = mkN "tдckningskцp" neutrum ;
  taeckord_nn_1 = mkN "tдckord" neutrum ;
  taeckorganisation_nn_1 = mkN "tдckorganisation" "tдckorganisationer" ;
  taeckt_av_1 = mkA "tдckt" "tдckt" ;
  taeckvinge_nn_1 = mkN "tдckvinge" utrum ;
  taekt_nn_1 = mkN "tдkt" "tдkter" ;
  taeljare_nn_1 = mkN "tдljare" "tдljare" ;
  taeljkniv_nn_1 = mkN "tдljkniv" ;
  taeljstenskamin_nn_1 = mkN "tдljstenskamin" "tдljstenskaminer" ;
  taelt_nn_1 = mkN "tдlt" neutrum ;
  taeltare_nn_1 = mkN "tдltare" "tдltare" ;
  taeltmoete_nn_1 = mkN "tдltmцte" ;
  taeltpinne_nn_1 = mkN "tдltpinne" utrum ;
  taeltsaeng_nn_1 = mkN "tдltsдng" ;
  taeltstol_nn_1 = mkN "tдltstol" ;
  taelttak_nn_1 = mkN "tдlttak" neutrum ;
  taemlig_av_1 = mkA "tдmlig" ;
  taemligen_ab_1 = mkAdv "tдmligen" ;
  taendaemne_nn_1 = mkN "tдndдmne" ;
  taendare_nn_1 = mkN "tдndare" "tдndare" ;
  taendhatt_nn_1 = mkN "tдndhatt" ;
  taendkulemotor_nn_1 = mkN "tдndkulemotor" "tдndkulemotorer" ;
  taendmedel_nn_1 = mkN "tдndmedel" neutrum ;
  taendning_nn_1 = mkN "tдndning" ;
  taendningslaas_nn_1 = mkN "tдndningslеs" neutrum ;
  taendningsnyckel_nn_1 = mkN "tдndningsnyckel" ;
  taendpatron_nn_1 = mkN "tдndpatron" "tдndpatroner" ;
  taendroer_nn_1 = mkN "tдndrцr" neutrum ;
  taendsats_nn_1 = mkN "tдndsats" "tдndsatser" ;
  taendspole_nn_1 = mkN "tдndspole" utrum ;
  taendsticksask_nn_1 = mkN "tдndsticksask" ;
  taendsticksmoenster_nn_1 = mkN "tдndsticksmцnster" neutrum ;
  taendsticksproblem_nn_1 = mkN "tдndsticksproblem" neutrum ;
  taendstift_nn_1 = mkN "tдndstift" neutrum ;
  taendvaetska_nn_1 = mkN "tдndvдtska" ;
  taenjbar_av_1 = mkA "tдnjbar" ;
  taenjning_nn_1 = mkN "tдnjning" ;
  taenkare_nn_1 = mkN "tдnkare" "tдnkare" ;
  taenkbar_av_1 = mkA "tдnkbar" ;
  taenkebok_nn_1 = mkN "tдnkebok" "tдnkebцcker" ;
  taenkesaett_nn_1 = mkN "tдnkesдtt" neutrum ;
  taenkespraak_nn_1 = mkN "tдnkesprеk" neutrum ;
  taenkvaerd_av_1 = mkA "tдnkvдrd" "tдnkvдrt" ;
  taeppt_av_1 = mkA "tдppt" "tдppt" ;
  taerande_av_1 = mkA "tдrande" ;
  taerd_av_1 = mkA "tдrd" "tдrt" ;
  taerning_nn_1 = mkN "tдrning" ;
  taerningsbaegare_nn_1 = mkN "tдrningsbдgare" "tдrningsbдgare" ;
  taerningskast_nn_1 = mkN "tдrningskast" neutrum ;
  taerningsspel_nn_1 = mkN "tдrningsspel" "tдrningsspelet" "tдrningsspel" "tдrningsspelen" ;
  taerningsspelare_nn_1 = mkN "tдrningsspelare" "tдrningsspelare" ;
  taet_av_1 = mkA "tдt" ;
  taet_nn_1 = mkN "tдt" "tдter" ;
  taetataet_nn_1 = mkN "tдtatдt" "tдtatдter" ;
  taethet_nn_1 = mkN "tдthet" "tдtheter" ;
  taethetstopp_nn_1 = mkN "tдthetstopp" ;
  taethetsvariation_nn_1 = mkN "tдthetsvariation" "tдthetsvariationer" ;
  taetning_nn_1 = mkN "tдtning" ;
  taetningslist_nn_1 = mkN "tдtningslist" "tдtningslister" ;
  taetort_nn_1 = mkN "tдtort" "tдtorter" ;
  taetortsbo_nn_1 = mkN "tдtortsbo" "tдtortsbor" ;
  taetortsnaera_av_1 = mkA "tдtortsnдra" ;
  taetplacering_nn_1 = mkN "tдtplacering" ;
  taetplats_nn_1 = mkN "tдtplats" "tдtplatser" ;
  taettbebyggd_av_1 = mkA "tдttbebyggd" "tдttbebyggt" ;
  taetting_nn_1 = mkN "tдtting" ;
  taettingfaagel_nn_1 = mkN "tдttingfеgel" ;
  taettklippt_av_1 = mkA "tдttklippt" "tдttklippt" ;
  taettsittande_av_1 = mkA "tдttsittande" ;
  taettskriven_av_1 = mkA "tдttskriven" "tдttskrivet" ;
  taettslutande_av_1 = mkA "tдttslutande" ;
  taevling_nn_1 = mkN "tдvling" ;
  taevlingscyklist_nn_1 = mkN "tдvlingscyklist" "tдvlingscyklister" ;
  taevlingshumoer_nn_1 = mkN "tдvlingshumцr" neutrum ;
  taevlingsjury_nn_1 = mkN "tдvlingsjury" "tдvlingsjuryer" ;
  taevlingskamp_nn_1 = mkN "tдvlingskamp" "tдvlingskamper" ;
  taevlingsklass_nn_1 = mkN "tдvlingsklass" "tдvlingsklasser" ;
  taevlingsledare_nn_1 = mkN "tдvlingsledare" "tдvlingsledare" ;
  taevlingsledning_nn_1 = mkN "tдvlingsledning" ;
  taevlingslek_nn_1 = mkN "tдvlingslek" ;
  taevlingsmaenniska_nn_1 = mkN "tдvlingsmдnniska" ;
  taevlingspris_nn_1 = mkN "tдvlingspris" neutrum ;
  taevlingssegling_nn_1 = mkN "tдvlingssegling" ;
  tafatt_av_1 = mkA "tafatt" ;
  taffel_nn_1 = mkN "taffel" ;
  taffelberg_nn_1 = mkN "taffelberg" neutrum ;
  taffeltaeckare_nn_1 = mkN "taffeltдckare" "taffeltдckare" ;
  taffelvaag_nn_1 = mkN "taffelvеg" ;
  tafflig_av_1 = mkA "tafflig" ;
  tafs_nn_1 = mkN "tafs" ;
  tafsig_av_1 = mkA "tafsig" ;
  tag_nn_1 = mkN "tag" neutrum ;
  tagel_nn_1 = mkN "tagel" neutrum ;
  tagelmask_nn_1 = mkN "tagelmask" ;
  tagen_av_1 = mkA "tagen" "taget" ;
  tagetes_nn_1 = mkN "tagetes" ;
  tagg_nn_1 = mkN "tagg" ;
  taggbraeken_nn_1 = mkN "taggbrдken" ;
  taggfenig_av_1 = mkA "taggfenig" ;
  taggfening_nn_1 = mkN "taggfening" ;
  taggfoersedd_av_1 = mkA "taggfцrsedd" ;
  tagghuding_nn_1 = mkN "tagghuding" ;
  taggig_av_1 = mkA "taggig" ;
  taggstraale_nn_1 = mkN "taggstrеle" utrum ;
  taggsvamp_nn_1 = mkN "taggsvamp" ;
  taggtraad_nn_1 = mkN "taggtrеd" ;
  tagning_nn_1 = mkN "tagning" ;
  taiwanes_nn_1 = mkN "taiwanes" "taiwaneser" ;
  tajt_av_1 = mkA "tajt" "tajt" ;
  tak_nn_1 = mkN "tak" neutrum ;
  takaas_nn_1 = mkN "takеs" ;
  takbjaelke_nn_1 = mkN "takbjдlke" utrum ;
  takfall_nn_1 = mkN "takfall" neutrum ;
  takfoenster_nn_1 = mkN "takfцnster" neutrum ;
  takfris_nn_1 = mkN "takfris" "takfriser" ;
  takgesims_nn_1 = mkN "takgesims" "takgesimser" ;
  takhimmel_nn_1 = mkN "takhimmel" ;
  takhoejd_nn_1 = mkN "takhцjd" "takhцjder" ;
  takhuv_nn_1 = mkN "takhuv" ;
  takistoskop_nn_1 = mkN "takistoskop" neutrum ;
  takistoskopi_nn_1 = mkN "takistoskopi" "takistoskopier" ;
  takkam_nn_1 = mkN "takkam" "takkammen" "takkammar" "takkammarna" ;
  taklaekt_nn_1 = mkN "taklдkt" "taklдkter" ;
  taklag_nn_1 = mkN "taklag" neutrum ;
  taklagsfest_nn_1 = mkN "taklagsfest" "taklagsfester" ;
  taklagsoel_nn_1 = mkN "taklagsцl" neutrum ;
  taklist_nn_1 = mkN "taklist" "taklister" ;
  taknock_nn_1 = mkN "taknock" ;
  takometer_nn_1 = mkN "takometer" ;
  takraecke_nn_1 = mkN "takrдcke" ;
  takresning_nn_1 = mkN "takresning" ;
  takrygg_nn_1 = mkN "takrygg" ;
  takryttare_nn_1 = mkN "takryttare" "takryttare" ;
  takskaegg_nn_1 = mkN "takskдgg" neutrum ;
  taksparre_nn_1 = mkN "taksparre" utrum ;
  takspraang_nn_1 = mkN "taksprеng" neutrum ;
  takstol_nn_1 = mkN "takstol" ;
  takt_nn_1 = mkN "takt" "takter" ;
  taktaeckare_nn_1 = mkN "taktдckare" "taktдckare" ;
  taktart_nn_1 = mkN "taktart" "taktarter" ;
  taktbeteckning_nn_1 = mkN "taktbeteckning" ;
  taktdel_nn_1 = mkN "taktdel" "taktdelen" "taktdelar" "taktdelarna" ;
  taktegel_nn_1 = mkN "taktegel" neutrum ;
  taktfast_av_1 = mkA "taktfast" "taktfast" ;
  taktfull_av_1 = mkA "taktfull" ;
  taktik_nn_1 = mkN "taktik" "taktiker" ;
  taktiker_nn_1 = mkN "taktiker" "taktikern" "taktiker" "taktikerna" ;
  taktil_av_1 = mkA "taktil" ;
  taktisk_av_1 = mkA "taktisk" ;
  taktloes_av_1 = mkA "taktlцs" ;
  taktloeshet_nn_1 = mkN "taktlцshet" "taktlцsheter" ;
  taktpinne_nn_1 = mkN "taktpinne" utrum ;
  taktslag_nn_1 = mkN "taktslag" neutrum ;
  taktstreck_nn_1 = mkN "taktstreck" neutrum ;
  takvaaning_nn_1 = mkN "takvеning" ;
  takykardi_nn_1 = mkN "takykardi" "takykardier" ;
  takymeter_nn_1 = mkN "takymeter" ;
  tal_nn_1 = mkN "tal" neutrum ;
  talakt_nn_1 = mkN "talakt" "talakter" ;
  talande_av_1 = mkA "talande" ;
  talang_nn_1 = mkN "talang" "talanger" ;
  talangfull_av_1 = mkA "talangfull" ;
  talangjakt_nn_1 = mkN "talangjakt" "talangjakter" ;
  talangscout_nn_1 = mkN "talangscout" "talangscouter" ;
  talapparat_nn_1 = mkN "talapparat" "talapparater" ;
  talar_nn_1 = mkN "talar" "talarer" ;
  talare_nn_1 = mkN "talare" "talare" ;
  talarstol_nn_1 = mkN "talarstol" ;
  talbok_nn_1 = mkN "talbok" "talbцcker" ;
  talcentrum_nn_1 = mkN "talcentrum" neutrum ;
  talent_nn_1 = mkN "talent" "talenter" ;
  talesaett_nn_1 = mkN "talesдtt" neutrum ;
  talesman_nn_1 = mkN "talesman" "talesmannen" "talesmдn" "talesmдnnen" ;
  talfel_nn_1 = mkN "talfel" "talfelet" "talfel" "talfelen" ;
  talfoeljd_nn_1 = mkN "talfцljd" "talfцljder" ;
  talfoer_av_1 = mkA "talfцr" ;
  talgdank_nn_1 = mkN "talgdank" ;
  talgig_av_1 = mkA "talgig" ;
  talgkoertel_nn_1 = mkN "talgkцrtel" ;
  talgoegd_av_1 = mkA "talgцgd" "talgцgt" ;
  talgoxe_nn_1 = mkN "talgoxe" utrum ;
  talisman_nn_1 = mkN "talisman" "talismaner" ;
  talkig_av_1 = mkA "talkig" ;
  talklinik_nn_1 = mkN "talklinik" "talkliniker" ;
  talkoer_nn_1 = mkN "talkцr" "talkцrer" ;
  tall_nn_1 = mkN "tall" ;
  tallbarr_nn_1 = mkN "tallbarr" neutrum ;
  tallbit_nn_1 = mkN "tallbit" ;
  tallbock_nn_1 = mkN "tallbock" ;
  tallinje_nn_1 = mkN "tallinje" "tallinjer" ;
  tallkottkoertel_nn_1 = mkN "tallkottkцrtel" ;
  tallmaetare_nn_1 = mkN "tallmдtare" "tallmдtare" ;
  talloert_nn_1 = mkN "tallцrt" "tallцrter" ;
  talloes_av_1 = mkA "tallцs" ;
  tallrik_nn_1 = mkN "tallrik" ;
  tallriksharv_nn_1 = mkN "tallriksharv" ;
  tallrikshjul_nn_1 = mkN "tallrikshjul" neutrum ;
  tallriksliknande_av_1 = mkA "tallriksliknande" ;
  tallriksslickare_nn_1 = mkN "tallriksslickare" "tallriksslickare" ;
  tallriksventil_nn_1 = mkN "tallriksventil" "tallriksventiler" ;
  tallskog_nn_1 = mkN "tallskog" ;
  tallsort_nn_1 = mkN "tallsort" "tallsorter" ;
  tallspinnare_nn_1 = mkN "tallspinnare" "tallspinnare" ;
  tallstekel_nn_1 = mkN "tallstekel" ;
  talman_nn_1 = mkN "talman" "talmannen" "talmдn" "talmдnnen" ;
  talmanskonferens_nn_1 = mkN "talmanskonferens" "talmanskonferenser" ;
  talong_nn_1 = mkN "talong" "talonger" ;
  talorgan_nn_1 = mkN "talorgan" neutrum ;
  talpedagog_nn_1 = mkN "talpedagog" "talpedagoger" ;
  talpjaes_nn_1 = mkN "talpjдs" "talpjдser" ;
  talregistreringsapparat_nn_1 = mkN "talregistreringsapparat" "talregistreringsapparater" ;
  talrik_av_1 = mkA "talrik" ;
  talroer_nn_1 = mkN "talrцr" neutrum ;
  talroll_nn_1 = mkN "talroll" "talroller" ;
  talrubbning_nn_1 = mkN "talrubbning" ;
  talscen_nn_1 = mkN "talscen" "talscener" ;
  talspraak_nn_1 = mkN "talsprеk" neutrum ;
  talspraaklig_av_1 = mkA "talsprеklig" ;
  talsvaarighet_nn_1 = mkN "talsvеrighet" "talsvеrigheter" ;
  talsystem_nn_1 = mkN "talsystem" neutrum ;
  taltraengd_av_1 = mkA "taltrдngd" "taltrдngt" ;
  taltrast_nn_1 = mkN "taltrast" ;
  taltratt_nn_1 = mkN "taltratt" ;
  tam_av_1 = mkA "tam" ;
  tamarind_nn_1 = mkN "tamarind" "tamarinder" ;
  tamarisk_nn_1 = mkN "tamarisk" "tamarisker" ;
  tambur_nn_1 = mkN "tambur" "tamburer" ;
  tamburin_nn_1 = mkN "tamburin" "tamburiner" ;
  tamburmajor_nn_1 = mkN "tamburmajor" "tamburmajorer" ;
  tambursoem_nn_1 = mkN "tambursцm" "tambursцmmen" "tambursцmmar" "tambursцmmarna" ;
  tamburvaktmaestare_nn_1 = mkN "tamburvaktmдstare" "tamburvaktmдstare" ;
  tamil_nn_1 = mkN "tamil" "tamiler" ;
  tamp_nn_1 = mkN "tamp" ;
  tampong_nn_1 = mkN "tampong" "tamponger" ;
  tamren_nn_1 = mkN "tamren" "tamrenen" "tamrenar" "tamrenarna" ;
  tamsvin_nn_1 = mkN "tamsvin" neutrum ;
  tamul_nn_1 = mkN "tamul" "tamuler" ;
  tand_nn_1 = mkN "tand" "tдnder" ;
  tandboeld_nn_1 = mkN "tandbцld" "tandbцlder" ;
  tandborr_nn_1 = mkN "tandborr" ;
  tandborrmaskin_nn_1 = mkN "tandborrmaskin" "tandborrmaskiner" ;
  tandborste_nn_1 = mkN "tandborste" utrum ;
  tandborstglas_nn_1 = mkN "tandborstglas" neutrum ;
  tandborstning_nn_1 = mkN "tandborstning" ;
  tandemcykel_nn_1 = mkN "tandemcykel" ;
  tandemmaskin_nn_1 = mkN "tandemmaskin" "tandemmaskiner" ;
  tandemspermie_nn_1 = mkN "tandemspermie" "tandemspermier" ;
  tandfistel_nn_1 = mkN "tandfistel" ;
  tandformel_nn_1 = mkN "tandformel" "tandformeln" "tandformler" "tandformlerna" ;
  tandfyllning_nn_1 = mkN "tandfyllning" ;
  tandgarnityr_nn_1 = mkN "tandgarnityr" neutrum ;
  tandgenombrott_nn_1 = mkN "tandgenombrott" neutrum ;
  tandhaevel_nn_1 = mkN "tandhдvel" ;
  tandhals_nn_1 = mkN "tandhals" ;
  tandhjul_nn_1 = mkN "tandhjul" neutrum ;
  tandhygienist_nn_1 = mkN "tandhygienist" "tandhygienister" ;
  tandhyvel_nn_1 = mkN "tandhyvel" ;
  tandkonstruktion_nn_1 = mkN "tandkonstruktion" "tandkonstruktioner" ;
  tandkraem_nn_1 = mkN "tandkrдm" "tandkrдmer" ;
  tandlaekare_nn_1 = mkN "tandlдkare" "tandlдkare" ;
  tandlaekarpraktik_nn_1 = mkN "tandlдkarpraktik" "tandlдkarpraktiker" ;
  tandlaekarstol_nn_1 = mkN "tandlдkarstol" ;
  tandlagning_nn_1 = mkN "tandlagning" ;
  tandlik_av_1 = mkA "tandlik" ;
  tandlist_nn_1 = mkN "tandlist" "tandlister" ;
  tandloes_av_1 = mkA "tandlцs" ;
  tandning_nn_1 = mkN "tandning" ;
  tandpetare_nn_1 = mkN "tandpetare" "tandpetare" ;
  tandprotes_nn_1 = mkN "tandprotes" "tandproteser" ;
  tandrot_nn_1 = mkN "tandrot" "tandrцtter" ;
  tandskoeterska_nn_1 = mkN "tandskцterska" ;
  tandsnitt_nn_1 = mkN "tandsnitt" neutrum ;
  tandstaellning_nn_1 = mkN "tandstдllning" ;
  tandtekniker_nn_1 = mkN "tandtekniker" "tandteknikern" "tandtekniker" "tandteknikerna" ;
  tanduppsaettning_nn_1 = mkN "tanduppsдttning" ;
  tandutskott_nn_1 = mkN "tandutskott" neutrum ;
  tandvaardsfoersaekring_nn_1 = mkN "tandvеrdsfцrsдkring" ;
  tandvaenlig_av_1 = mkA "tandvдnlig" ;
  tandval_nn_1 = mkN "tandval" ;
  tandvall_nn_1 = mkN "tandvall" ;
  tangent_nn_1 = mkN "tangent" "tangenter" ;
  tangentbord_nn_1 = mkN "tangentbord" neutrum ;
  tangentinstrument_nn_1 = mkN "tangentinstrument" neutrum ;
  tangentplan_nn_1 = mkN "tangentplan" neutrum ;
  tangerin_nn_1 = mkN "tangerin" "tangeriner" ;
  tangering_nn_1 = mkN "tangering" ;
  tangeringspunkt_nn_1 = mkN "tangeringspunkt" "tangeringspunkter" ;
  tango_nn_1 = mkN "tango" "tangor" ;
  tangorabatt_nn_1 = mkN "tangorabatt" "tangorabatter" ;
  tanig_av_1 = mkA "tanig" ;
  tank_nn_1 = mkN "tank" ;
  tank_nn_2 = mkN "tank" ;
  tankbil_nn_1 = mkN "tankbil" ;
  tanke_nn_1 = mkN "tanke" utrum ;
  tankebyggnad_nn_1 = mkN "tankebyggnad" "tankebyggnader" ;
  tankediger_av_1 = mkA "tankediger" "tankedigert" "tankedigra" "tankedigra" "tankedigrare" "tankedigrast" "tankedigraste" ;
  tankedikt_nn_1 = mkN "tankedikt" "tankedikter" ;
  tankeexperiment_nn_1 = mkN "tankeexperiment" neutrum ;
  tankefel_nn_1 = mkN "tankefel" "tankefelet" "tankefel" "tankefelen" ;
  tankefoster_nn_1 = mkN "tankefoster" neutrum ;
  tankefrihet_nn_1 = mkN "tankefrihet" "tankefriheter" ;
  tankegaang_nn_1 = mkN "tankegеng" ;
  tankelaesare_nn_1 = mkN "tankelдsare" "tankelдsare" ;
  tankelag_nn_1 = mkN "tankelag" ;
  tankeled_nn_1 = mkN "tankeled" neutrum ;
  tankelek_nn_1 = mkN "tankelek" ;
  tankemaessig_av_1 = mkA "tankemдssig" ;
  tankemetod_nn_1 = mkN "tankemetod" "tankemetoder" ;
  tankemoeda_nn_1 = mkN "tankemцda" ;
  tanker_nn_1 = mkN "tanker" ;
  tankestaellare_nn_1 = mkN "tankestдllare" "tankestдllare" ;
  tanketradition_nn_1 = mkN "tanketradition" "tanketraditioner" ;
  tankeutbyte_nn_1 = mkN "tankeutbyte" ;
  tankevaeckande_av_1 = mkA "tankevдckande" ;
  tankfartyg_nn_1 = mkN "tankfartyg" neutrum ;
  tankfull_av_1 = mkA "tankfull" ;
  tankgevaer_nn_1 = mkN "tankgevдr" neutrum ;
  tankloes_av_1 = mkA "tanklцs" ;
  tankomat_nn_1 = mkN "tankomat" "tankomater" ;
  tankspridd_av_1 = mkA "tankspridd" ;
  tankstreck_nn_1 = mkN "tankstreck" neutrum ;
  tant_nn_1 = mkN "tant" "tanter" ;
  tantaktig_av_1 = mkA "tantaktig" ;
  tantalikval_nn_1 = mkN "tantalikval" neutrum ;
  tantiem_nn_1 = mkN "tantiem" neutrum ;
  tantig_av_1 = mkA "tantig" ;
  tanzanier_nn_1 = mkN "tanzanier" "tanzaniern" "tanzanier" "tanzanierna" ;
  tanzanisk_av_1 = mkA "tanzanisk" ;
  taoist_nn_1 = mkN "taoist" "taoister" ;
  tape_nn_1 = mkN "tape" utrum ;
  tapet_nn_1 = mkN "tapet" "tapeter" ;
  tapetbaard_nn_1 = mkN "tapetbеrd" "tapetbеrder" ;
  tapetborste_nn_1 = mkN "tapetborste" utrum ;
  tapetdoerr_nn_1 = mkN "tapetdцrr" ;
  tapetserare_nn_1 = mkN "tapetserare" "tapetserare" ;
  tapetserarstift_nn_1 = mkN "tapetserarstift" neutrum ;
  tapetvaad_nn_1 = mkN "tapetvеd" "tapetvеder" ;
  tapir_nn_1 = mkN "tapir" "tapirer" ;
  tapisseri_nn_1 = mkN "tapisseri" "tapisserit" "tapisserier" "tapisserierna" ;
  tapisseriaffaer_nn_1 = mkN "tapisseriaffдr" "tapisseriaffдrer" ;
  tapisserinaal_nn_1 = mkN "tapisserinеl" ;
  tapp_nn_1 = mkN "tapp" ;
  tappborr_nn_1 = mkN "tappborr" ;
  tapper_av_1 = mkA "tapper" "tappert" "tappra" "tappra" "tapprare" "tapprast" "tappraste" ;
  tapperhet_nn_1 = mkN "tapperhet" "tapperheter" ;
  tapperhetsmedalj_nn_1 = mkN "tapperhetsmedalj" "tapperhetsmedaljer" ;
  tapphaal_nn_1 = mkN "tapphеl" neutrum ;
  tappkran_nn_1 = mkN "tappkran" ;
  tapplager_nn_1 = mkN "tapplager" neutrum ;
  tappning_nn_1 = mkN "tappning" ;
  tappstation_nn_1 = mkN "tappstation" "tappstationer" ;
  tappt_ab_1 = mkAdv "tappt" ;
  tappt_nn_1 = mkN "tappt" "tappter" ;
  tapto_nn_1 = mkN "tapto" "taptot" "tapton" "taptona" ;
  tarantel_nn_1 = mkN "tarantel" ;
  tariff_nn_1 = mkN "tariff" "tariffer" ;
  tarm_nn_1 = mkN "tarm" ;
  tarmbakterie_nn_1 = mkN "tarmbakterie" "tarmbakterier" ;
  tarmben_nn_1 = mkN "tarmben" neutrum ;
  tarmfistel_nn_1 = mkN "tarmfistel" ;
  tarmfoertraengning_nn_1 = mkN "tarmfцrtrдngning" ;
  tarmgas_nn_1 = mkN "tarmgas" "tarmgaser" ;
  tarmkaex_nn_1 = mkN "tarmkдx" neutrum ;
  tarmkanal_nn_1 = mkN "tarmkanal" "tarmkanaler" ;
  tarmkatarr_nn_1 = mkN "tarmkatarr" "tarmkatarrer" ;
  tarmroerelse_nn_1 = mkN "tarmrцrelse" "tarmrцrelser" ;
  tarmsaft_nn_1 = mkN "tarmsaft" "tarmsafter" ;
  tarmskoeljning_nn_1 = mkN "tarmskцljning" ;
  tarmsystem_nn_1 = mkN "tarmsystem" neutrum ;
  tarmvred_nn_1 = mkN "tarmvred" neutrum ;
  tars_nn_1 = mkN "tars" "tarser" ;
  tarsalben_nn_1 = mkN "tarsalben" neutrum ;
  tartarbiff_nn_1 = mkN "tartarbiff" ;
  tartarsmoergaas_nn_1 = mkN "tartarsmцrgеs" ;
  tartelett_nn_1 = mkN "tartelett" "tarteletter" ;
  tartrat_nn_1 = mkN "tartrat" "tartrater" ;
  tarvlig_av_1 = mkA "tarvlig" ;
  task_nn_1 = mkN "task" ;
  taskig_av_1 = mkA "taskig" ;
  taskspelare_nn_1 = mkN "taskspelare" "taskspelare" ;
  taskspeleri_nn_1 = mkN "taskspeleri" "taskspelerit" "taskspelerier" "taskspelerierna" ;
  tass_nn_1 = mkN "tass" ;
  tassemark_nn_1 = mkN "tassemark" "tassemarker" ;
  tassfot_nn_1 = mkN "tassfot" "tassfцtter" ;
  tassliknande_av_1 = mkA "tassliknande" ;
  tatar_nn_1 = mkN "tatar" "tatarer" ;
  tattare_nn_1 = mkN "tattare" "tattare" ;
  tatuerare_nn_1 = mkN "tatuerare" "tatuerare" ;
  tatuering_nn_1 = mkN "tatuering" ;
  tautologi_nn_1 = mkN "tautologi" "tautologier" ;
  tavelgalleri_nn_1 = mkN "tavelgalleri" "tavelgallerit" "tavelgallerier" "tavelgallerierna" ;
  tavelsudd_nn_1 = mkN "tavelsudd" ;
  tavla_nn_1 = mkN "tavla" ;
  tax_free_av_1 = mkA "tax-free" ;
  tax_nn_1 = mkN "tax" ;
  taxameter_nn_1 = mkN "taxameter" ;
  taxeomraade_nn_1 = mkN "taxeomrеde" ;
  taxering_nn_1 = mkN "taxering" ;
  taxeringsaar_nn_1 = mkN "taxeringsеr" neutrum ;
  taxeringsassistent_nn_1 = mkN "taxeringsassistent" "taxeringsassistenter" ;
  taxeringsbevis_nn_1 = mkN "taxeringsbevis" neutrum ;
  taxeringsenhet_nn_1 = mkN "taxeringsenhet" "taxeringsenheter" ;
  taxeringsintendent_nn_1 = mkN "taxeringsintendent" "taxeringsintendenter" ;
  taxeringskalender_nn_1 = mkN "taxeringskalender" ;
  taxeringslaengd_nn_1 = mkN "taxeringslдngd" "taxeringslдngder" ;
  taxeringsman_nn_1 = mkN "taxeringsman" "taxeringsmannen" "taxeringsmдn" "taxeringsmдnnen" ;
  taxeringsmyndighet_nn_1 = mkN "taxeringsmyndighet" "taxeringsmyndigheter" ;
  taxeringsnaemnd_nn_1 = mkN "taxeringsnдmnd" "taxeringsnдmnder" ;
  taxeringsvaerde_nn_1 = mkN "taxeringsvдrde" ;
  taxi_nn_1 = mkN "taxi" "taxin" "taxi" "taxina" ;
  taxibil_nn_1 = mkN "taxibil" ;
  taxichauffoer_nn_1 = mkN "taxichauffцr" "taxichauffцrer" ;
  taxistation_nn_1 = mkN "taxistation" "taxistationer" ;
  taxonomi_nn_1 = mkN "taxonomi" "taxonomier" ;
  tazett_nn_1 = mkN "tazett" "tazetter" ;
  tchadier_nn_1 = mkN "tchadier" "tchadiern" "tchadier" "tchadierna" ;
  tchadisk_av_1 = mkA "tchadisk" ;
  te_nn_1 = mkN "te" "tet" "teer" "teerna" ;
  teach_in_nn_1 = mkN "teach-in" "teach-in" "teach-in" "teach-ina" ;
  teaelskande_av_1 = mkA "teдlskande" ;
  teaktraed_nn_1 = mkN "teaktrдd" neutrum ;
  team_nn_1 = mkN "team" neutrum ;
  teamwork_nn_1 = mkN "teamwork" "teamworker" ;
  teater_nn_1 = mkN "teater" ;
  teateranmaelan_nn_1 = mkN "teateranmдlan" "teateranmдlan" "teateranmдlningar" "teateranmдlningarna" ;
  teaterbesoekare_nn_1 = mkN "teaterbesцkare" "teaterbesцkare" ;
  teaterchef_nn_1 = mkN "teaterchef" "teaterchefer" ;
  teaterdebatt_nn_1 = mkN "teaterdebatt" "teaterdebatter" ;
  teaterdekoration_nn_1 = mkN "teaterdekoration" "teaterdekorationer" ;
  teatereffekt_nn_1 = mkN "teatereffekt" "teatereffekter" ;
  teaterfigur_nn_1 = mkN "teaterfigur" "teaterfigurer" ;
  teaterfoerestaellning_nn_1 = mkN "teaterfцrestдllning" ;
  teatergrupp_nn_1 = mkN "teatergrupp" "teatergrupper" ;
  teaterhabitue_nn_1 = mkN "teaterhabituй" "teaterhabituйer" ;
  teaterkikare_nn_1 = mkN "teaterkikare" "teaterkikare" ;
  teaterliv_nn_1 = mkN "teaterliv" neutrum ;
  teaterloge_nn_1 = mkN "teaterloge" "teaterloger" ;
  teatermaskineri_nn_1 = mkN "teatermaskineri" "teatermaskinerit" "teatermaskinerier" "teatermaskinerierna" ;
  teatermaskinist_nn_1 = mkN "teatermaskinist" "teatermaskinister" ;
  teaterpjaes_nn_1 = mkN "teaterpjдs" "teaterpjдser" ;
  teaterroll_nn_1 = mkN "teaterroll" "teaterroller" ;
  teatersaellskap_nn_1 = mkN "teatersдllskap" "teatersдllskapet" "teatersдllskapen" "teatersдllskapena" ;
  teaterscen_nn_1 = mkN "teaterscen" "teaterscener" ;
  teaterviskning_nn_1 = mkN "teaterviskning" ;
  teatral_av_1 = mkA "teatral" ;
  teatralisk_av_1 = mkA "teatralisk" ;
  teblad_nn_1 = mkN "teblad" neutrum ;
  tebuske_nn_1 = mkN "tebuske" utrum ;
  tecken_nn_1 = mkN "tecken" "tecknet" "tecken" "tecknen" ;
  teckenalfabet_nn_1 = mkN "teckenalfabet" neutrum ;
  teckenfoerklaring_nn_1 = mkN "teckenfцrklaring" ;
  teckenskaadare_nn_1 = mkN "teckenskеdare" "teckenskеdare" ;
  teckenspraak_nn_1 = mkN "teckensprеk" neutrum ;
  teckensystem_nn_1 = mkN "teckensystem" neutrum ;
  teckentydare_nn_1 = mkN "teckentydare" "teckentydare" ;
  tecknare_nn_1 = mkN "tecknare" "tecknare" ;
  teckning_nn_1 = mkN "teckning" ;
  teckningsbevis_nn_1 = mkN "teckningsbevis" neutrum ;
  teddybjoern_nn_1 = mkN "teddybjцrn" ;
  tedeum_nn_1 = mkN "tedeum" neutrum ;
  tedrickande_nn_1 = mkN "tedrickande" ;
  tefat_nn_1 = mkN "tefat" neutrum ;
  teg_nn_1 = mkN "teg" ;
  tegel_nn_1 = mkN "tegel" neutrum ;
  tegelbruk_nn_1 = mkN "tegelbruk" neutrum ;
  tegelliknande_av_1 = mkA "tegelliknande" ;
  tegelmaestare_nn_1 = mkN "tegelmдstare" "tegelmдstare" ;
  tegelroed_av_1 = mkA "tegelrцd" ;
  tegelslagare_nn_1 = mkN "tegelslagare" "tegelslagare" ;
  tegelsten_nn_1 = mkN "tegelsten" "tegelstenen" "tegelstenar" "tegelstenarna" ;
  tegelstensroman_nn_1 = mkN "tegelstensroman" "tegelstensromaner" ;
  tegelugn_nn_1 = mkN "tegelugn" ;
  teglas_nn_1 = mkN "teglas" neutrum ;
  tehuv_nn_1 = mkN "tehuv" ;
  tein_nn_1 = mkN "tein" "teiner" ;
  tejp_nn_1 = mkN "tejp" "tejper" ;
  tejst_nn_1 = mkN "tejst" ;
  teknik_nn_1 = mkN "teknik" "tekniker" ;
  teknikalitet_nn_1 = mkN "teknikalitet" "teknikaliteter" ;
  tekniker_nn_1 = mkN "tekniker" "teknikern" "tekniker" "teknikerna" ;
  tekning_nn_1 = mkN "tekning" ;
  teknisk_av_1 = mkA "teknisk" ;
  teknokrat_nn_1 = mkN "teknokrat" "teknokrater" ;
  teknokrati_nn_1 = mkN "teknokrati" "teknokratier" ;
  teknolog_nn_1 = mkN "teknolog" "teknologer" ;
  teknologi_nn_1 = mkN "teknologi" "teknologier" ;
  teknologie_av_1 = mkA "teknologie" ;
  teknologisk_av_1 = mkA "teknologisk" ;
  tekoindustri_nn_1 = mkN "tekoindustri" "tekoindustrier" ;
  tekopp_nn_1 = mkN "tekopp" ;
  teleavgift_nn_1 = mkN "teleavgift" "teleavgifter" ;
  teledata_nn_1 = mkN "teledata" "teledatan" "teledata" "teledatana" ;
  telefoerbindelse_nn_1 = mkN "telefцrbindelse" "telefцrbindelser" ;
  telefon_nn_1 = mkN "telefon" "telefoner" ;
  telefonabonnent_nn_1 = mkN "telefonabonnent" "telefonabonnenter" ;
  telefonanrop_nn_1 = mkN "telefonanrop" neutrum ;
  telefonapparat_nn_1 = mkN "telefonapparat" "telefonapparater" ;
  telefonautomat_nn_1 = mkN "telefonautomat" "telefonautomater" ;
  telefonavlyssning_nn_1 = mkN "telefonavlyssning" ;
  telefonhytt_nn_1 = mkN "telefonhytt" "telefonhytter" ;
  telefonist_nn_1 = mkN "telefonist" "telefonister" ;
  telefonjack_nn_1 = mkN "telefonjack" ;
  telefonkatalog_nn_1 = mkN "telefonkatalog" "telefonkataloger" ;
  telefonkiosk_nn_1 = mkN "telefonkiosk" "telefonkiosker" ;
  telefonkoe_nn_1 = mkN "telefonkц" "telefonkцn" "telefonkцer" "telefonkцerna" ;
  telefonledes_ab_1 = mkAdv "telefonledes" ;
  telefonledning_nn_1 = mkN "telefonledning" ;
  telefonlur_nn_1 = mkN "telefonlur" ;
  telefonnummer_nn_1 = mkN "telefonnummer" neutrum ;
  telefonsamtal_nn_1 = mkN "telefonsamtal" "telefonsamtalet" "telefonsamtalen" "telefonsamtalena" ;
  telefonsignal_nn_1 = mkN "telefonsignal" "telefonsignaler" ;
  telefonsladd_nn_1 = mkN "telefonsladd" ;
  telefonstation_nn_1 = mkN "telefonstation" "telefonstationer" ;
  telefonstolpe_nn_1 = mkN "telefonstolpe" utrum ;
  telefonsvarare_nn_1 = mkN "telefonsvarare" "telefonsvarare" ;
  telefontraad_nn_1 = mkN "telefontrеd" ;
  telefonvaeckning_nn_1 = mkN "telefonvдckning" ;
  telefonvaektare_nn_1 = mkN "telefonvдktare" "telefonvдktare" ;
  telefonvaexel_nn_1 = mkN "telefonvдxel" ;
  telefonvakt_nn_1 = mkN "telefonvakt" "telefonvakter" ;
  telefoto_nn_1 = mkN "telefoto" "telefotot" "telefoton" "telefotona" ;
  telegraf_nn_1 = mkN "telegraf" "telegrafer" ;
  telegrafisk_av_1 = mkA "telegrafisk" ;
  telegrafist_nn_1 = mkN "telegrafist" "telegrafister" ;
  telegrafnyckel_nn_1 = mkN "telegrafnyckel" ;
  telegrafstation_nn_1 = mkN "telegrafstation" "telegrafstationer" ;
  telegram_nn_1 = mkN "telegram" "telegrammet" "telegram" "telegrammen" ;
  telegramadress_nn_1 = mkN "telegramadress" "telegramadresser" ;
  telegrambud_nn_1 = mkN "telegrambud" neutrum ;
  telegrambyraa_nn_1 = mkN "telegrambyrе" "telegrambyrеer" ;
  telekommunikation_nn_1 = mkN "telekommunikation" "telekommunikationer" ;
  telemeter_nn_1 = mkN "telemeter" ;
  telenaet_nn_1 = mkN "telenдt" neutrum ;
  teleobjektiv_nn_1 = mkN "teleobjektiv" neutrum ;
  teleologisk_av_1 = mkA "teleologisk" ;
  telepati_nn_1 = mkN "telepati" "telepatier" ;
  telepatisk_av_1 = mkA "telepatisk" ;
  teleprinter_nn_1 = mkN "teleprinter" ;
  telesatellit_nn_1 = mkN "telesatellit" "telesatelliter" ;
  teleskop_nn_1 = mkN "teleskop" neutrum ;
  teleskopisk_av_1 = mkA "teleskopisk" ;
  teleskopliknande_av_1 = mkA "teleskopliknande" ;
  teleskopoega_nn_1 = mkN "teleskopцga" "teleskopцgat" "teleskopцgon" "teleskopцgonen" ;
  telestation_nn_1 = mkN "telestation" "telestationer" ;
  teleteknisk_av_1 = mkA "teleteknisk" ;
  televerk_nn_1 = mkN "televerk" neutrum ;
  televisionskamera_nn_1 = mkN "televisionskamera" ;
  telex_nn_2 = mkN "telex" neutrum ;
  telfer_nn_1 = mkN "telfer" ;
  tellurisk_av_1 = mkA "tellurisk" ;
  tellurium_nn_1 = mkN "tellurium" "telluriet" "tellurier" "tellurierna" ;
  teln_nn_1 = mkN "teln" ;
  telning_nn_1 = mkN "telning" ;
  tema_nn_1 = mkN "tema" "temat" "teman" "temana" ;
  temadag_nn_1 = mkN "temadag" ;
  temanummer_nn_1 = mkN "temanummer" neutrum ;
  tematisk_av_1 = mkA "tematisk" ;
  temp_nn_1 = mkN "temp" ;
  tempel_nn_1 = mkN "tempel" neutrum ;
  tempelherre_nn_1 = mkN "tempelherre" utrum ;
  tempelherreorden_nn_1 = mkN "tempelherreorden" ;
  temperament_nn_1 = mkN "temperament" "temperamentet" "temperamenten" "temperamentena" ;
  temperamentsfull_av_1 = mkA "temperamentsfull" ;
  temperamentsutbrott_nn_1 = mkN "temperamentsutbrott" neutrum ;
  temperatur_nn_1 = mkN "temperatur" "temperaturer" ;
  temperaturfoeraendring_nn_1 = mkN "temperaturfцrдndring" ;
  temperaturfoerdelning_nn_1 = mkN "temperaturfцrdelning" ;
  temperaturfoerhaallande_nn_1 = mkN "temperaturfцrhеllande" ;
  temperaturkaenslig_av_1 = mkA "temperaturkдnslig" ;
  temperaturomraade_nn_1 = mkN "temperaturomrеde" ;
  temperaturregulator_nn_1 = mkN "temperaturregulator" "temperaturregulatorer" ;
  temperatursaenkning_nn_1 = mkN "temperatursдnkning" ;
  temperaturskillnad_nn_1 = mkN "temperaturskillnad" "temperaturskillnader" ;
  temperatursvaengning_nn_1 = mkN "temperatursvдngning" ;
  temperaturvaexling_nn_1 = mkN "temperaturvдxling" ;
  tempo_nn_1 = mkN "tempo" "tempot" "tempon" "tempona" ;
  tempoarbetare_nn_1 = mkN "tempoarbetare" "tempoarbetare" ;
  tempobeteckning_nn_1 = mkN "tempobeteckning" ;
  tempolopp_nn_1 = mkN "tempolopp" neutrum ;
  temporaer_av_1 = mkA "temporдr" ;
  temporal_av_1 = mkA "temporal" ;
  tempus_nn_1 = mkN "tempus" neutrum ;
  tempusvaexling_nn_1 = mkN "tempusvдxling" ;
  ten_nn_1 = mkN "ten" "tenen" "tenar" "tenarna" ;
  tendens_nn_1 = mkN "tendens" "tendenser" ;
  tendentioes_av_1 = mkA "tendentiцs" ;
  tender_nn_1 = mkN "tender" ;
  tennfolie_nn_1 = mkN "tennfolie" "tennfolier" ;
  tennisboll_nn_1 = mkN "tennisboll" ;
  tennisspelare_nn_1 = mkN "tennisspelare" "tennisspelare" ;
  tennsoldat_nn_1 = mkN "tennsoldat" "tennsoldater" ;
  tenor_nn_1 = mkN "tenor" "tenoren" "tenorer" "tenorerna" ;
  tenorbaryton_nn_1 = mkN "tenorbaryton" "tenorbarytoner" ;
  tenorsaxofon_nn_1 = mkN "tenorsaxofon" "tenorsaxofoner" ;
  tensid_nn_1 = mkN "tensid" "tensider" ;
  tension_nn_1 = mkN "tension" "tensioner" ;
  tentakel_nn_1 = mkN "tentakel" "tentakeln" "tentakler" "tentaklerna" ;
  tentamen_nn_1 = mkN "tentamen" "tentamen" "tentamina" "tentamina" ;
  tentamensbok_nn_1 = mkN "tentamensbok" "tentamensbцcker" ;
  tentamensnervositet_nn_1 = mkN "tentamensnervositet" "tentamensnervositeter" ;
  tentand_nn_1 = mkN "tentand" "tentander" ;
  tentator_nn_1 = mkN "tentator" "tentatorer" ;
  teobromin_nn_1 = mkN "teobromin" "teobrominer" ;
  teocentrisk_av_1 = mkA "teocentrisk" ;
  teodolit_nn_1 = mkN "teodolit" "teodoliter" ;
  teofyllin_nn_1 = mkN "teofyllin" "teofylliner" ;
  teogoni_nn_1 = mkN "teogoni" "teogonier" ;
  teokrati_nn_1 = mkN "teokrati" "teokratier" ;
  teokratisk_av_1 = mkA "teokratisk" ;
  teolog_nn_1 = mkN "teolog" "teologer" ;
  teologie_av_1 = mkA "teologie" ;
  teologisk_av_1 = mkA "teologisk" ;
  teorem_nn_1 = mkN "teorem" neutrum ;
  teoretiker_nn_1 = mkN "teoretiker" "teoretikern" "teoretiker" "teoretikerna" ;
  teoretisk_av_1 = mkA "teoretisk" ;
  teori_nn_1 = mkN "teori" "teorier" ;
  teosof_nn_1 = mkN "teosof" "teosofer" ;
  teosofisk_av_1 = mkA "teosofisk" ;
  tepaase_nn_1 = mkN "tepеse" utrum ;
  terapeut_nn_1 = mkN "terapeut" "terapeuter" ;
  terapeutisk_av_1 = mkA "terapeutisk" ;
  terapi_nn_1 = mkN "terapi" "terapier" ;
  terass_nn_1 = mkN "terass" "terasser" ;
  terawatt_nn_1 = mkN "terawatt" "terawatten" "terawatt" "terawatten" ;
  terebint_nn_1 = mkN "terebint" "terebinter" ;
  term_nn_1 = mkN "term" "termer" ;
  termin_nn_1 = mkN "termin" "terminer" ;
  terminal_nn_1 = mkN "terminal" "terminaler" ;
  terminolog_nn_1 = mkN "terminolog" "terminologer" ;
  terminologi_nn_1 = mkN "terminologi" "terminologier" ;
  terminologisk_av_1 = mkA "terminologisk" ;
  terminsaffaer_nn_1 = mkN "terminsaffдr" "terminsaffдrer" ;
  terminsavgift_nn_1 = mkN "terminsavgift" "terminsavgifter" ;
  termisk_av_1 = mkA "termisk" ;
  termistor_nn_1 = mkN "termistor" "termistorer" ;
  termit_nn_1 = mkN "termit" "termiter" ;
  termodynamisk_av_1 = mkA "termodynamisk" ;
  termoelektricitet_nn_1 = mkN "termoelektricitet" "termoelektriciteter" ;
  termoelement_nn_1 = mkN "termoelement" neutrum ;
  termofil_av_1 = mkA "termofil" ;
  termometer_nn_1 = mkN "termometer" ;
  termonukleaer_av_1 = mkA "termonukleдr" ;
  termoplast_nn_1 = mkN "termoplast" "termoplaster" ;
  termoregulator_nn_1 = mkN "termoregulator" "termoregulatorer" ;
  termos_nn_1 = mkN "termos" ;
  termostapel_nn_1 = mkN "termostapel" ;
  termostat_nn_1 = mkN "termostat" "termostater" ;
  tern_nn_1 = mkN "tern" "terner" ;
  terpen_nn_1 = mkN "terpen" "terpener" ;
  terraeng_nn_1 = mkN "terrдng" "terrдnger" ;
  terraengbil_nn_1 = mkN "terrдngbil" ;
  terraengfoerlust_nn_1 = mkN "terrдngfцrlust" "terrдngfцrluster" ;
  terraenggaaende_av_1 = mkA "terrдnggеende" ;
  terraengkoerning_nn_1 = mkN "terrдngkцrning" ;
  terraengnamn_nn_1 = mkN "terrдngnamn" neutrum ;
  terraengvinkel_nn_1 = mkN "terrдngvinkel" ;
  terraengvinst_nn_1 = mkN "terrдngvinst" "terrдngvinster" ;
  terrarium_nn_1 = mkN "terrarium" "terrariet" "terrarier" "terrarierna" ;
  terrass_nn_1 = mkN "terrass" "terrasser" ;
  terrester_av_1 = mkA "terrester" "terrestert" "terrestra" "terrestra" "terrestrare" "terrestrast" "terrestraste" ;
  terrier_nn_1 = mkN "terrier" "terriern" "terrier" "terrierna" ;
  terrigen_av_1 = mkA "terrigen" ;
  terrin_nn_1 = mkN "terrin" "terriner" ;
  territorialgraens_nn_1 = mkN "territorialgrдns" "territorialgrдnser" ;
  territorialvatten_nn_1 = mkN "territorialvatten" "territorialvattnet" "territorialvatten" "territorialvattnen" ;
  territoriell_av_1 = mkA "territoriell" ;
  territorium_nn_1 = mkN "territorium" "territoriet" "territorier" "territorierna" ;
  terrorbombning_nn_1 = mkN "terrorbombning" ;
  terrorist_nn_1 = mkN "terrorist" "terrorister" ;
  ters_nn_1 = mkN "ters" "terser" ;
  tersett_nn_1 = mkN "tersett" "tersetter" ;
  tertiaer_av_1 = mkA "tertiдr" ;
  terzett_nn_1 = mkN "terzett" "terzetter" ;
  terzin_nn_1 = mkN "terzin" "terziner" ;
  tes_nn_1 = mkN "tes" "teser" ;
  tesaurus_nn_1 = mkN "tesaurus" ;
  tesked_nn_1 = mkN "tesked" ;
  tesla_nn_1 = mkN "tesla" "teslan" "tesla" "teslana" ;
  teslastroem_nn_1 = mkN "teslastrцm" "teslastrцmmen" "teslastrцmmar" "teslastrцmmarna" ;
  test_nn_1 = mkN "test" neutrum ;
  test_nn_2 = mkN "test" ;
  testabel_av_1 = mkA "testabel" "testabelt" "testabla" "testabla" "testablare" "testablast" "testablaste" ;
  testamentarisk_av_1 = mkA "testamentarisk" ;
  testamentsexekutor_nn_1 = mkN "testamentsexekutor" "testamentsexekutorer" ;
  testator_nn_1 = mkN "testator" "testatorer" ;
  testbatteri_nn_1 = mkN "testbatteri" "testbatterit" "testbatterier" "testbatterierna" ;
  testbild_nn_1 = mkN "testbild" "testbilder" ;
  testcykel_nn_1 = mkN "testcykel" ;
  testig_av_1 = mkA "testig" ;
  testikel_nn_1 = mkN "testikel" ;
  testimonium_nn_1 = mkN "testimonium" "testimoniet" "testimonier" "testimonierna" ;
  testuggare_nn_1 = mkN "testuggare" "testuggare" ;
  testvaerde_nn_1 = mkN "testvдrde" ;
  tete_a_tete_nn_1 = mkN "tиte-а-tиte" "tиte-а-tиter" ;
  tetig_av_1 = mkA "tetig" ;
  tetraeder_nn_1 = mkN "tetraeder" ;
  tetragon_nn_1 = mkN "tetragon" "tetragoner" ;
  tetraklorid_nn_1 = mkN "tetraklorid" "tetraklorider" ;
  tetrapak_nn_1 = mkN "tetrapak" neutrum ;
  tetrark_nn_1 = mkN "tetrark" "tetrarker" ;
  teuton_nn_1 = mkN "teuton" "teutoner" ;
  tevagn_nn_1 = mkN "tevagn" ;
  teve_nn_2 = mkN "teve" "teven" "teve" "tevena" ;
  teveapparat_nn_1 = mkN "teveapparat" "teveapparater" ;
  tevetittare_nn_1 = mkN "tevetittare" "tevetittare" ;
  text_nn_1 = mkN "text" "texter" ;
  textbearbetning_nn_1 = mkN "textbearbetning" ;
  textbehandling_nn_1 = mkN "textbehandling" ;
  textbok_nn_1 = mkN "textbok" "textbцcker" ;
  textil_av_1 = mkA "textil" ;
  textil_nn_1 = mkN "textil" "textiler" ;
  textilaetande_av_1 = mkA "textilдtande" ;
  textilarbetare_nn_1 = mkN "textilarbetare" "textilarbetare" ;
  textilfiber_nn_1 = mkN "textilfiber" "textilfibern" "textilfibrer" "textilfibrerna" ;
  textilindustri_nn_1 = mkN "textilindustri" "textilindustrier" ;
  textilkurs_nn_1 = mkN "textilkurs" "textilkurser" ;
  textillaerare_nn_1 = mkN "textillдrare" "textillдrare" ;
  textrad_nn_1 = mkN "textrad" "textrader" ;
  textskaerm_nn_1 = mkN "textskдrm" ;
  texttolkning_nn_1 = mkN "texttolkning" ;
  textur_nn_1 = mkN "textur" "texturer" ;
  thailaendare_nn_1 = mkN "thailдndare" "thailдndare" ;
  thailaendsk_av_1 = mkA "thailдndsk" ;
  thailaendska_nn_1 = mkN "thailдndska" ;
  thaispraak_nn_1 = mkN "thaisprеk" neutrum ;
  thriller_nn_1 = mkN "thriller" ;
  thrillerfilm_nn_1 = mkN "thrillerfilm" "thrillerfilmer" ;
  thyroxin_nn_1 = mkN "thyroxin" "thyroxiner" ;
  tibetan_nn_1 = mkN "tibetan" "tibetaner" ;
  tibetanare_nn_1 = mkN "tibetanare" "tibetanare" ;
  tibetansk_av_1 = mkA "tibetansk" ;
  tibetanska_nn_2 = mkN "tibetanska" ;
  tic_nn_1 = mkN "tic" "ticen" "tics" "ticsen" ;
  tick_nn_1 = mkN "tick" neutrum ;
  tick_tack_nn_1 = mkN "tick-tack" neutrum ;
  tid_nn_1 = mkN "tid" "tider" ;
  tidebok_nn_1 = mkN "tidebok" "tidebцcker" ;
  tidegaerd_nn_1 = mkN "tidegдrd" "tidegдrder" ;
  tidelag_nn_1 = mkN "tidelag" neutrum ;
  tideraekning_nn_1 = mkN "tiderдkning" ;
  tidevarv_nn_1 = mkN "tidevarv" neutrum ;
  tidig_av_1 = mkA "tidig" ;
  tidjordsfenomen_nn_1 = mkN "tidjordsfenomen" neutrum ;
  tidjordsforskning_nn_1 = mkN "tidjordsforskning" ;
  tidjordskraft_nn_1 = mkN "tidjordskraft" "tidjordskrafter" ;
  tidkontrollur_nn_1 = mkN "tidkontrollur" neutrum ;
  tidkort_nn_1 = mkN "tidkort" neutrum ;
  tidlaan_nn_1 = mkN "tidlеn" neutrum ;
  tidlig_av_1 = mkA "tidlig" ;
  tidloes_av_1 = mkA "tidlцs" ;
  tidmaane_nn_1 = mkN "tidmеne" utrum ;
  tidning_nn_1 = mkN "tidning" ;
  tidningsartikel_nn_1 = mkN "tidningsartikel" ;
  tidningsbud_nn_1 = mkN "tidningsbud" neutrum ;
  tidningsledare_nn_1 = mkN "tidningsledare" "tidningsledare" ;
  tidningsman_nn_1 = mkN "tidningsman" "tidningsmannen" "tidningsmдn" "tidningsmдnnen" ;
  tidningsnotis_nn_1 = mkN "tidningsnotis" "tidningsnotiser" ;
  tidningsredaktion_nn_1 = mkN "tidningsredaktion" "tidningsredaktioner" ;
  tidningssida_nn_1 = mkN "tidningssida" ;
  tidningsspalt_nn_1 = mkN "tidningsspalt" "tidningsspalter" ;
  tidningstext_nn_1 = mkN "tidningstext" "tidningstexter" ;
  tidningsuppgift_nn_1 = mkN "tidningsuppgift" "tidningsuppgifter" ;
  tidningsupplaga_nn_1 = mkN "tidningsupplaga" ;
  tidningsutbaerning_nn_1 = mkN "tidningsutbдrning" ;
  tidpunkt_nn_1 = mkN "tidpunkt" "tidpunkter" ;
  tidroer_nn_1 = mkN "tidrцr" neutrum ;
  tidrymd_nn_1 = mkN "tidrymd" "tidrymder" ;
  tidsaalder_nn_1 = mkN "tidsеlder" ;
  tidsadverbial_nn_1 = mkN "tidsadverbial" neutrum ;
  tidsangivelse_nn_1 = mkN "tidsangivelse" "tidsangivelser" ;
  tidsaspekt_nn_1 = mkN "tidsaspekt" "tidsaspekter" ;
  tidsbefraktning_nn_1 = mkN "tidsbefraktning" ;
  tidsbegrepp_nn_1 = mkN "tidsbegrepp" neutrum ;
  tidsbestaellning_nn_1 = mkN "tidsbestдllning" ;
  tidsbild_nn_1 = mkN "tidsbild" "tidsbilder" ;
  tidsbunden_av_1 = mkA "tidsbunden" "tidsbundet" ;
  tidsenhet_nn_1 = mkN "tidsenhet" "tidsenheter" ;
  tidsenlig_av_1 = mkA "tidsenlig" ;
  tidsfaktor_nn_1 = mkN "tidsfaktor" "tidsfaktorer" ;
  tidsfoerdriv_nn_1 = mkN "tidsfцrdriv" neutrum ;
  tidsfoerlust_nn_1 = mkN "tidsfцrlust" "tidsfцrluster" ;
  tidsfoerskjutning_nn_1 = mkN "tidsfцrskjutning" ;
  tidsfraaga_nn_1 = mkN "tidsfrеga" ;
  tidsfrist_nn_1 = mkN "tidsfrist" "tidsfrister" ;
  tidsgraens_nn_1 = mkN "tidsgrдns" "tidsgrдnser" ;
  tidsinstaelld_av_1 = mkA "tidsinstдlld" "tidsinstдllt" ;
  tidsintervall_nn_1 = mkN "tidsintervall" neutrum ;
  tidskrift_nn_1 = mkN "tidskrift" "tidskrifter" ;
  tidskriftsartikel_nn_1 = mkN "tidskriftsartikel" ;
  tidskriftsindex_nn_1 = mkN "tidskriftsindex" neutrum ;
  tidskriftsnummer_nn_1 = mkN "tidskriftsnummer" neutrum ;
  tidslig_av_1 = mkA "tidslig" ;
  tidsmaatt_nn_1 = mkN "tidsmеtt" neutrum ;
  tidsmedveten_av_1 = mkA "tidsmedveten" "tidsmedvetet" ;
  tidsoedande_av_1 = mkA "tidsцdande" ;
  tidsoeverdrag_nn_1 = mkN "tidsцverdrag" neutrum ;
  tidsperiod_nn_1 = mkN "tidsperiod" "tidsperioder" ;
  tidsperspektiv_nn_1 = mkN "tidsperspektiv" neutrum ;
  tidsplan_nn_1 = mkN "tidsplan" "tidsplaner" ;
  tidsplan_nn_2 = mkN "tidsplan" neutrum ;
  tidsrymd_nn_1 = mkN "tidsrymd" "tidsrymder" ;
  tidsschema_nn_1 = mkN "tidsschema" "tidsschemat" "tidsscheman" "tidsschemana" ;
  tidssignal_nn_1 = mkN "tidssignal" "tidssignaler" ;
  tidsskillnad_nn_1 = mkN "tidsskillnad" "tidsskillnader" ;
  tidsstudieman_nn_1 = mkN "tidsstudieman" "tidsstudiemannen" "tidsstudiemдn" "tidsstudiemдnnen" ;
  tidstroemstaellare_nn_1 = mkN "tidstrцmstдllare" "tidstrцmstдllare" ;
  tidstrogen_av_1 = mkA "tidstrogen" "tidstroget" ;
  tidstypisk_av_1 = mkA "tidstypisk" ;
  tidsuppfattning_nn_1 = mkN "tidsuppfattning" ;
  tidtabell_nn_1 = mkN "tidtabell" "tidtabeller" ;
  tidtagare_nn_1 = mkN "tidtagare" "tidtagare" ;
  tidtagarur_nn_1 = mkN "tidtagarur" neutrum ;
  tidtagning_nn_1 = mkN "tidtagning" ;
  tidtals_ab_1 = mkAdv "tidtals" ;
  tidur_nn_1 = mkN "tidur" neutrum ;
  tidvatten_nn_1 = mkN "tidvatten" "tidvattnet" "tidvatten" "tidvattnen" ;
  tidvattenhoejd_nn_1 = mkN "tidvattenhцjd" "tidvattenhцjder" ;
  tidvattenkraft_nn_1 = mkN "tidvattenkraft" "tidvattenkrafter" ;
  tidvattenstroem_nn_1 = mkN "tidvattenstrцm" "tidvattenstrцmmen" "tidvattenstrцmmar" "tidvattenstrцmmarna" ;
  tidvis_ab_1 = mkAdv "tidvis" ;
  tie_break_nn_1 = mkN "tie-break" neutrum ;
  tiger_nn_1 = mkN "tiger" ;
  tigerhaj_nn_1 = mkN "tigerhaj" ;
  tigerkatt_nn_1 = mkN "tigerkatt" "tigerkatter" ;
  tigerlilja_nn_1 = mkN "tigerlilja" ;
  tigerorm_nn_1 = mkN "tigerorm" ;
  tigerrandig_av_1 = mkA "tigerrandig" ;
  tigerspraang_nn_1 = mkN "tigersprеng" neutrum ;
  tigerstrimmig_av_1 = mkA "tigerstrimmig" ;
  tiggarbrev_nn_1 = mkN "tiggarbrev" neutrum ;
  tiggare_nn_1 = mkN "tiggare" "tiggare" ;
  tiggarmunk_nn_1 = mkN "tiggarmunk" ;
  tiggarorden_nn_1 = mkN "tiggarorden" ;
  tiggeri_nn_1 = mkN "tiggeri" "tiggerit" "tiggerier" "tiggerierna" ;
  tik_nn_1 = mkN "tik" ;
  till_ab_1 = mkAdv "till" ;
  tillaata_vb_1 = mkV "tillеta" "tillдt" "tillеtit" ;
  tillaaten_av_1 = mkA "tillеten" "tillеtet" ;
  tillaatlig_av_1 = mkA "tillеtlig" ;
  tillaegg_nn_1 = mkN "tillдgg" neutrum ;
  tillaeggsbelopp_nn_1 = mkN "tillдggsbelopp" neutrum ;
  tillaeggskostnad_nn_1 = mkN "tillдggskostnad" "tillдggskostnader" ;
  tillaeggsmandat_nn_1 = mkN "tillдggsmandat" neutrum ;
  tillaeggspension_nn_1 = mkN "tillдggspension" "tillдggspensioner" ;
  tillaeggsplats_nn_1 = mkN "tillдggsplats" "tillдggsplatser" ;
  tillaemplig_av_1 = mkA "tillдmplig" ;
  tillaempning_nn_1 = mkN "tillдmpning" ;
  tillaempningsfoereskrift_nn_1 = mkN "tillдmpningsfцreskrift" "tillдmpningsfцreskrifter" ;
  tillaenda_ab_1 = mkAdv "tillдnda" ;
  tillaendalupen_av_1 = mkA "tillдndalupen" "tillдndalupet" ;
  tillaeventyrs_ab_1 = mkAdv "tillдventyrs" ;
  tillbaka_ab_1 = mkAdv "tillbaka" ;
  tillbakablick_nn_1 = mkN "tillbakablick" ;
  tillbakadragen_av_1 = mkA "tillbakadragen" "tillbakadraget" ;
  tillbakagaaende_av_1 = mkA "tillbakagеende" ;
  tillbakasatt_av_1 = mkA "tillbakasatt" ;
  tillbakasyftande_av_1 = mkA "tillbakasyftande" ;
  tillbaks_ab_1 = mkAdv "tillbaks" ;
  tillbedja_vb_1 = mkV "tillbedja" "tillbedjar" "tillbedja" "tillbedjad" "tillbedjatt" "tillbedjadd" ;
  tillbedjare_nn_1 = mkN "tillbedjare" "tillbedjare" ;
  tillbehoer_nn_1 = mkN "tillbehцr" neutrum ;
  tillboerlig_av_1 = mkA "tillbцrlig" ;
  tillbringare_nn_1 = mkN "tillbringare" "tillbringare" ;
  tillbud_nn_1 = mkN "tillbud" neutrum ;
  tillbuds_ab_1 = mkAdv "tillbuds" ;
  tillbyggd_av_1 = mkA "tillbyggd" "tillbyggt" ;
  tillbyggnad_nn_1 = mkN "tillbyggnad" "tillbyggnader" ;
  tilldelning_nn_1 = mkN "tilldelning" ;
  tilldels_ab_1 = mkAdv "tilldels" ;
  tilldra_vb_1 = mkV "tilldra" "tilldrar" "tilldra" "tilldrog" "tilldragit" "tilldragen" ;
  tilldragande_av_1 = mkA "tilldragande" ;
  tilldragelse_nn_1 = mkN "tilldragelse" "tilldragelser" ;
  tillfaangata_vb_1 = mkV "tillfеngata" "tillfеngatar" "tillfеngata" "tillfеngatog" "tillfеngatagit" "tillfеngatagen" ;
  tillfaellig_av_1 = mkA "tillfдllig" ;
  tillfaellighet_nn_1 = mkN "tillfдllighet" "tillfдlligheter" ;
  tillfaellighetsdikt_nn_1 = mkN "tillfдllighetsdikt" "tillfдllighetsdikter" ;
  tillfaellighetsfoerbrytare_nn_1 = mkN "tillfдllighetsfцrbrytare" "tillfдllighetsfцrbrytare" ;
  tillfaellighetsvers_nn_1 = mkN "tillfдllighetsvers" ;
  tillfaelligtvis_ab_1 = mkAdv "tillfдlligtvis" ;
  tillfalla_vb_1 = mkV "tillfalla" "tillfцll" "tillfallit" ;
  tillfart_nn_1 = mkN "tillfart" "tillfarter" ;
  tillfartsvaeg_nn_1 = mkN "tillfartsvдg" ;
  tillfinnandes_ab_1 = mkAdv "tillfinnandes" ;
  tillfloede_nn_1 = mkN "tillflцde" ;
  tillflyktsort_nn_1 = mkN "tillflyktsort" "tillflyktsorter" ;
  tillfoerlitlig_av_1 = mkA "tillfцrlitlig" ;
  tillfoerlitlighet_nn_1 = mkN "tillfцrlitlighet" "tillfцrlitligheter" ;
  tillfoerlitlighetstaevling_nn_1 = mkN "tillfцrlitlighetstдvling" ;
  tillfoerne_ab_1 = mkAdv "tillfцrne" ;
  tillfreds_av_1 = mkA "tillfreds" ;
  tillfredsstaellande_av_1 = mkA "tillfredsstдllande" ;
  tillfredsstaelld_av_1 = mkA "tillfredsstдlld" "tillfredsstдllt" ;
  tillfullo_ab_1 = mkAdv "tillfullo" ;
  tillfyllest_ab_1 = mkAdv "tillfyllest" ;
  tillgaang_nn_1 = mkN "tillgеng" ;
  tillgaenglig_av_1 = mkA "tillgдnglig" ;
  tillge_vb_1 = mkV "tillge" "tillger" "tillge" "tillgav" "tillgett" "tillgiven" ;
  tillgiven_av_1 = mkA "tillgiven" "tillgivet" ;
  tillgivenhet_nn_1 = mkN "tillgivenhet" "tillgivenheter" ;
  tillgjord_av_1 = mkA "tillgjord" "tillgjort" ;
  tillgodo_ab_1 = mkAdv "tillgodo" ;
  tillgodohavande_nn_1 = mkN "tillgodohavande" ;
  tillgodokvitto_nn_1 = mkN "tillgodokvitto" "tillgodokvittot" "tillgodokvitton" "tillgodokvittona" ;
  tillgrepp_nn_1 = mkN "tillgrepp" neutrum ;
  tillgripa_vb_1 = mkV "tillgripa" "tillgrep" "tillgripit" ;
  tillhaall_nn_1 = mkN "tillhеll" neutrum ;
  tillhaalla_vb_1 = mkV "tillhеlla" "tillhцll" "tillhеllit" ;
  tillhaallarfjaeder_nn_1 = mkN "tillhеllarfjдder" ;
  tillhanda_ab_1 = mkAdv "tillhanda" ;
  tillhandahaalla_vb_1 = mkV "tillhandahеlla" "tillhandahцll" "tillhandahеllit" ;
  tillhands_ab_1 = mkAdv "tillhands" ;
  tillhoerande_av_1 = mkA "tillhцrande" ;
  tillhoerig_av_1 = mkA "tillhцrig" ;
  tillhoerighet_nn_1 = mkN "tillhцrighet" "tillhцrigheter" ;
  tillhopa_ab_1 = mkAdv "tillhopa" ;
  tillika_ab_1 = mkAdv "tillika" ;
  tillintetgjord_av_1 = mkA "tillintetgjord" "tillintetgjort" ;
  tillintetgoerande_av_1 = mkA "tillintetgцrande" ;
  tillitsfull_av_1 = mkA "tillitsfull" ;
  tillkaenna_ab_1 = mkAdv "tillkдnna" ;
  tillkaennage_vb_1 = mkV "tillkдnnage" "tillkдnnager" "tillkдnnage" "tillkдnnagav" "tillkдnnagett" "tillkдnnagiven" ;
  tillkaennagivande_nn_1 = mkN "tillkдnnagivande" ;
  tillklippt_av_1 = mkA "tillklippt" "tillklippt" ;
  tillknaeppt_av_1 = mkA "tillknдppt" "tillknдppt" ;
  tillkomma_vb_1 = mkV "tillkomma" "tillkom" "tillkommit" ;
  tillkommande_av_1 = mkA "tillkommande" ;
  tillmoetes_ab_1 = mkAdv "tillmцtes" ;
  tillmoetesgaaende_av_1 = mkA "tillmцtesgеende" ;
  tillnaermelsevis_ab_1 = mkAdv "tillnдrmelsevis" ;
  tillnamn_nn_1 = mkN "tillnamn" neutrum ;
  tilloekning_nn_1 = mkN "tillцkning" ;
  tilloenskning_nn_1 = mkN "tillцnskning" ;
  tillopp_nn_1 = mkN "tillopp" neutrum ;
  tillpass_ab_1 = mkAdv "tillpass" ;
  tillplattning_nn_1 = mkN "tillplattning" ;
  tillraadlig_av_1 = mkA "tillrеdlig" ;
  tillraecklig_av_1 = mkA "tillrдcklig" ;
  tillraeknelig_av_1 = mkA "tillrдknelig" ;
  tillraetta_ab_1 = mkAdv "tillrдtta" ;
  tillraettavisning_nn_1 = mkN "tillrдttavisning" ;
  tillreds_ab_1 = mkAdv "tillreds" ;
  tillrop_nn_1 = mkN "tillrop" neutrum ;
  tillsaegelse_nn_1 = mkN "tillsдgelse" "tillsдgelser" ;
  tillsaettning_nn_1 = mkN "tillsдttning" ;
  tillsammans_ab_1 = mkAdv "tillsammans" ;
  tillsammantagen_av_1 = mkA "tillsammantagen" "tillsammantaget" ;
  tillsats_nn_1 = mkN "tillsats" "tillsatser" ;
  tillsatsaemne_nn_1 = mkN "tillsatsдmne" ;
  tillsatslins_nn_1 = mkN "tillsatslins" "tillsatslinser" ;
  tillskaera_vb_1 = mkV "tillskдra" "tillskar" "tillskurit" ;
  tillskaerare_nn_1 = mkN "tillskдrare" "tillskдrare" ;
  tillskaerarkniv_nn_1 = mkN "tillskдrarkniv" ;
  tillskaerning_nn_1 = mkN "tillskдrning" ;
  tillskjuta_vb_1 = mkV "tillskjuta" "tillskцt" "tillskjutit" ;
  tillskott_nn_1 = mkN "tillskott" neutrum ;
  tillskriva_vb_1 = mkV "tillskriva" "tillskrev" "tillskrivit" ;
  tillskyndare_nn_1 = mkN "tillskyndare" "tillskyndare" ;
  tillslag_nn_1 = mkN "tillslag" neutrum ;
  tillslagen_av_1 = mkA "tillslagen" "tillslaget" ;
  tillslagning_nn_1 = mkN "tillslagning" ;
  tillslagningsteknik_nn_1 = mkN "tillslagningsteknik" "tillslagningstekniker" ;
  tillsluta_vb_1 = mkV "tillsluta" "tillslцt" "tillslutit" ;
  tillslutare_nn_1 = mkN "tillslutare" "tillslutare" ;
  tillspillo_ab_1 = mkAdv "tillspillo" ;
  tillspilloge_vb_1 = mkV "tillspilloge" "tillspilloger" "tillspilloge" "tillspillogav" "tillspillogett" "tillspillogiven" ;
  tillspillogiven_av_1 = mkA "tillspillogiven" "tillspillogivet" ;
  tillstaand_nn_1 = mkN "tillstеnd" neutrum ;
  tillstaandsbevis_nn_1 = mkN "tillstеndsbevis" neutrum ;
  tillstaandsgivande_av_1 = mkA "tillstеndsgivande" ;
  tillstaedes_ab_1 = mkAdv "tillstдdes" ;
  tillstaellning_nn_1 = mkN "tillstдllning" ;
  tillstaendig_av_1 = mkA "tillstдndig" ;
  tillstymmelse_nn_1 = mkN "tillstymmelse" "tillstymmelser" ;
  tillstyrkande_nn_1 = mkN "tillstyrkande" ;
  tillsvidare_ab_1 = mkAdv "tillsvidare" ;
  tillsvidarefoerordnande_nn_1 = mkN "tillsvidarefцrordnande" ;
  tillsynes_ab_1 = mkAdv "tillsynes" ;
  tillsyningsman_nn_1 = mkN "tillsyningsman" "tillsyningsmannen" "tillsyningsmдn" "tillsyningsmдnnen" ;
  tillsynslaerare_nn_1 = mkN "tillsynslдrare" "tillsynslдrare" ;
  tillsynsman_nn_1 = mkN "tillsynsman" "tillsynsmannen" "tillsynsmдn" "tillsynsmдnnen" ;
  tillta_vb_1 = mkV "tillta" "tilltar" "tillta" "tilltog" "tilltagit" "tilltagen" ;
  tilltaenkt_av_1 = mkA "tilltдnkt" "tilltдnkt" ;
  tilltaeppning_nn_1 = mkN "tilltдppning" ;
  tilltag_nn_1 = mkN "tilltag" neutrum ;
  tilltagande_av_1 = mkA "tilltagande" ;
  tilltagen_av_1 = mkA "tilltagen" "tilltaget" ;
  tilltagsen_av_1 = mkA "tilltagsen" "tilltagset" ;
  tilltalande_av_1 = mkA "tilltalande" ;
  tilltalsform_nn_1 = mkN "tilltalsform" "tilltalsformer" ;
  tilltalsnamn_nn_1 = mkN "tilltalsnamn" neutrum ;
  tilltalsord_nn_1 = mkN "tilltalsord" neutrum ;
  tilltraede_nn_1 = mkN "tilltrдde" ;
  tillvaega_ab_1 = mkAdv "tillvдga" ;
  tillvaegagaangssaett_nn_1 = mkN "tillvдgagеngssдtt" neutrum ;
  tillvaextaemne_nn_1 = mkN "tillvдxtдmne" ;
  tillvaexthastighet_nn_1 = mkN "tillvдxthastighet" "tillvдxthastigheter" ;
  tillvaexthormon_nn_1 = mkN "tillvдxthormon" neutrum ;
  tillvaextperiod_nn_1 = mkN "tillvдxtperiod" "tillvдxtperioder" ;
  tillval_nn_1 = mkN "tillval" neutrum ;
  tillvalsaemne_nn_1 = mkN "tillvalsдmne" ;
  tillvand_av_1 = mkA "tillvand" ;
  tillvarata_vb_1 = mkV "tillvarata" "tillvaratar" "tillvarata" "tillvaratog" "tillvaratagit" "tillvaratagen" ;
  tillverkare_nn_1 = mkN "tillverkare" "tillverkare" ;
  tillverkning_nn_1 = mkN "tillverkning" ;
  tillverkningsaar_nn_1 = mkN "tillverkningsеr" neutrum ;
  tillviljes_ab_1 = mkAdv "tillviljes" ;
  tillvitelse_nn_1 = mkN "tillvitelse" "tillvitelser" ;
  timarvode_nn_1 = mkN "timarvode" ;
  timbal_nn_1 = mkN "timbal" "timbaler" ;
  timcirkel_nn_1 = mkN "timcirkel" ;
  timglas_nn_1 = mkN "timglas" neutrum ;
  timing_nn_1 = mkN "timing" ;
  timlaerare_nn_1 = mkN "timlдrare" "timlдrare" ;
  timlig_av_1 = mkA "timlig" ;
  timloen_nn_1 = mkN "timlцn" "timlцner" ;
  timma_nn_1 = mkN "timma" "timman" "timmar" "timmarna" ;
  timme_nn_1 = mkN "timme" utrum ;
  timmer_nn_1 = mkN "timmer" neutrum ;
  timmeravlaegg_nn_1 = mkN "timmeravlдgg" neutrum ;
  timmerblaedning_nn_1 = mkN "timmerblдdning" ;
  timmerbroet_nn_1 = mkN "timmerbrцt" ;
  timmerdoning_nn_1 = mkN "timmerdoning" ;
  timmerflotte_nn_1 = mkN "timmerflotte" utrum ;
  timmerflottning_nn_1 = mkN "timmerflottning" ;
  timmerhus_nn_1 = mkN "timmerhus" neutrum ;
  timmerlaens_nn_1 = mkN "timmerlдns" ;
  timmermagasin_nn_1 = mkN "timmermagasin" neutrum ;
  timmerman_nn_1 = mkN "timmerman" "timmermannen" "timmermдn" "timmermдnnen" ;
  timmersax_nn_1 = mkN "timmersax" ;
  timmerslaep_nn_1 = mkN "timmerslдp" neutrum ;
  timmerstek_nn_1 = mkN "timmerstek" neutrum ;
  timmerstock_nn_1 = mkN "timmerstock" ;
  timmerstockar_ab_1 = mkAdv "timmerstockar" ;
  timmersvans_nn_1 = mkN "timmersvans" ;
  timslaang_av_1 = mkA "timslеng" ;
  timslag_nn_1 = mkN "timslag" neutrum ;
  timtals_ab_1 = mkAdv "timtals" ;
  timvisare_nn_1 = mkN "timvisare" "timvisare" ;
  ting_nn_1 = mkN "ting" neutrum ;
  tingest_nn_1 = mkN "tingest" ;
  tingord_nn_1 = mkN "tingord" neutrum ;
  tingshus_nn_1 = mkN "tingshus" neutrum ;
  tingsraett_nn_1 = mkN "tingsrдtt" "tingsrдtter" ;
  tinktur_nn_1 = mkN "tinktur" "tinkturer" ;
  tinne_nn_1 = mkN "tinne" utrum ;
  tinning_nn_1 = mkN "tinning" ;
  tinningben_nn_1 = mkN "tinningben" neutrum ;
  tinninglob_nn_1 = mkN "tinninglob" "tinninglober" ;
  tiodubbel_av_1 = mkA "tiodubbel" "tiodubbelt" "tiodubbla" "tiodubbla" "tiodubblare" "tiodubblast" "tiodubblaste" ;
  tiofaldig_av_1 = mkA "tiofaldig" ;
  tiofalt_ab_1 = mkAdv "tiofalt" ;
  tiofoting_nn_1 = mkN "tiofoting" ;
  tiokamp_nn_1 = mkN "tiokamp" "tiokamper" ;
  tiokronorssedel_nn_1 = mkN "tiokronorssedel" ;
  tiomila_av_1 = mkA "tiomila" ;
  tiominutersrast_nn_1 = mkN "tiominutersrast" "tiominutersraster" ;
  tiondel_nn_1 = mkN "tiondel" "tiondelen" "tiondelar" "tiondelarna" ;
  tiooering_nn_1 = mkN "tioцring" ;
  tiotal_nn_1 = mkN "tiotal" "tiotalet" "tiotalen" "tiotalena" ;
  tiotalist_nn_1 = mkN "tiotalist" "tiotalister" ;
  tiotusental_nn_1 = mkN "tiotusental" "tiotusentalet" "tiotusentalen" "tiotusentalena" ;
  tipp_nn_1 = mkN "tipp" ;
  tippare_nn_1 = mkN "tippare" "tippare" ;
  tippflak_nn_1 = mkN "tippflak" neutrum ;
  tipptopp_av_1 = mkA "tipptopp" ;
  tippvagn_nn_1 = mkN "tippvagn" ;
  tips_nn_1 = mkN "tips" neutrum ;
  tipskupong_nn_1 = mkN "tipskupong" "tipskuponger" ;
  tipspromenad_nn_1 = mkN "tipspromenad" "tipspromenader" ;
  tipsrad_nn_1 = mkN "tipsrad" "tipsrader" ;
  tipstaevling_nn_1 = mkN "tipstдvling" ;
  tiptop_av_1 = mkA "tiptop" ;
  tir_nn_1 = mkN "tir" ;
  tirad_nn_1 = mkN "tirad" "tirader" ;
  tisdag_nn_1 = mkN "tisdag" ;
  tisdagskvaell_nn_1 = mkN "tisdagskvдll" ;
  tisdagsmorgon_nn_1 = mkN "tisdagsmorgon" "tisdagsmorgonen" "tisdagsmorgnar" "tisdagsmorgnarna" ;
  tistel_nn_1 = mkN "tistel" ;
  tistelborre_nn_1 = mkN "tistelborre" utrum ;
  tistelstaang_nn_1 = mkN "tistelstеng" "tistelstдnger" ;
  tistron_nn_1 = mkN "tistron" neutrum ;
  titan_nn_1 = mkN "titan" "titaner" ;
  titanisk_av_1 = mkA "titanisk" ;
  titanskruv_nn_1 = mkN "titanskruv" ;
  titel_nn_1 = mkN "titel" ;
  titelblad_nn_1 = mkN "titelblad" neutrum ;
  titelbortlaeggning_nn_1 = mkN "titelbortlдggning" ;
  titeldikt_nn_1 = mkN "titeldikt" "titeldikter" ;
  titelfoersvarare_nn_1 = mkN "titelfцrsvarare" "titelfцrsvarare" ;
  titelmatch_nn_1 = mkN "titelmatch" "titelmatcher" ;
  titelnovell_nn_1 = mkN "titelnovell" "titelnoveller" ;
  titelroll_nn_1 = mkN "titelroll" "titelroller" ;
  titelsida_nn_1 = mkN "titelsida" ;
  titelsjuk_av_1 = mkA "titelsjuk" ;
  titt_ab_1 = mkAdv "titt" ;
  titt_nn_1 = mkN "titt" ;
  tittare_nn_1 = mkN "tittare" "tittare" ;
  tittarstorm_nn_1 = mkN "tittarstorm" ;
  tittglugg_nn_1 = mkN "tittglugg" ;
  titthaal_nn_1 = mkN "titthеl" neutrum ;
  tittskaap_nn_1 = mkN "tittskеp" neutrum ;
  titulaerkonsul_nn_1 = mkN "titulдrkonsul" "titulдrkonsuln" "titulдrkonsuler" "titulдrkonsulerna" ;
  titulatur_nn_1 = mkN "titulatur" "titulaturer" ;
  tivoli_nn_1 = mkN "tivoli" "tivolit" "tivolin" "tivolina" ;
  tixotrop_av_1 = mkA "tixotrop" ;
  tjack_nn_1 = mkN "tjack" neutrum ;
  tjaeder_nn_1 = mkN "tjдder" ;
  tjaedertupp_nn_1 = mkN "tjдdertupp" ;
  tjaelfrusen_av_1 = mkA "tjдlfrusen" "tjдlfruset" ;
  tjaell_nn_1 = mkN "tjдll" neutrum ;
  tjaelskott_nn_1 = mkN "tjдlskott" neutrum ;
  tjaenare_nn_1 = mkN "tjдnare" "tjдnare" ;
  tjaenarinna_nn_1 = mkN "tjдnarinna" ;
  tjaenis_av_1 = mkA "tjдnis" ;
  tjaenlig_av_1 = mkA "tjдnlig" ;
  tjaenst_nn_1 = mkN "tjдnst" "tjдnster" ;
  tjaenstaktig_av_1 = mkA "tjдnstaktig" ;
  tjaenstbar_av_1 = mkA "tjдnstbar" ;
  tjaenste_ab_1 = mkAdv "tjдnste" ;
  tjaensteaar_nn_1 = mkN "tjдnsteеr" neutrum ;
  tjaensteaerende_nn_1 = mkN "tjдnsteдrende" ;
  tjaensteande_nn_1 = mkN "tjдnsteande" utrum ;
  tjaensteavtal_nn_1 = mkN "tjдnsteavtal" "tjдnsteavtalet" "tjдnsteavtalen" "tjдnsteavtalena" ;
  tjaenstebil_nn_1 = mkN "tjдnstebil" ;
  tjaenstebostad_nn_1 = mkN "tjдnstebostad" "tjдnstebostдder" ;
  tjaenstebrev_nn_1 = mkN "tjдnstebrev" neutrum ;
  tjaenstebrevsraett_nn_1 = mkN "tjдnstebrevsrдtt" "tjдnstebrevsrдtter" ;
  tjaenstefel_nn_1 = mkN "tjдnstefel" "tjдnstefelet" "tjдnstefel" "tjдnstefelen" ;
  tjaenstefoerraettande_av_1 = mkA "tjдnstefцrrдttande" ;
  tjaenstefoerraettare_nn_1 = mkN "tjдnstefцrrдttare" "tjдnstefцrrдttare" ;
  tjaenstefoerraettning_nn_1 = mkN "tjдnstefцrrдttning" ;
  tjaenstefoersaendelse_nn_1 = mkN "tjдnstefцrsдndelse" "tjдnstefцrsдndelser" ;
  tjaenstefoerseelse_nn_1 = mkN "tjдnstefцrseelse" "tjдnstefцrseelser" ;
  tjaenstegrad_nn_1 = mkN "tjдnstegrad" "tjдnstegrader" ;
  tjaenstekvinna_nn_1 = mkN "tjдnstekvinna" ;
  tjaensteman_nn_1 = mkN "tjдnsteman" "tjдnstemannen" "tjдnstemдn" "tjдnstemдnnen" ;
  tjaenstepension_nn_1 = mkN "tjдnstepension" "tjдnstepensioner" ;
  tjaensterum_nn_1 = mkN "tjдnsterum" "tjдnsterummet" "tjдnsterum" "tjдnsterummen" ;
  tjaenstestaellning_nn_1 = mkN "tjдnstestдllning" ;
  tjaenstetid_nn_1 = mkN "tjдnstetid" "tjдnstetider" ;
  tjaenstgoering_nn_1 = mkN "tjдnstgцring" ;
  tjaenstledig_av_1 = mkA "tjдnstledig" ;
  tjaenstledighet_nn_1 = mkN "tjдnstledighet" "tjдnstledigheter" ;
  tjaenstvillig_av_1 = mkA "tjдnstvillig" ;
  tjaerblomster_nn_1 = mkN "tjдrblomster" neutrum ;
  tjaerbloss_nn_1 = mkN "tjдrbloss" neutrum ;
  tjaerdal_nn_1 = mkN "tjдrdal" ;
  tjaerframstaellning_nn_1 = mkN "tjдrframstдllning" ;
  tjaern_nn_1 = mkN "tjдrn" ;
  tjafsig_av_1 = mkA "tjafsig" ;
  tjalk_nn_1 = mkN "tjalk" ;
  tjallare_nn_1 = mkN "tjallare" "tjallare" ;
  tjatig_av_1 = mkA "tjatig" ;
  tjeck_nn_1 = mkN "tjeck" "tjecker" ;
  tjeckisk_av_1 = mkA "tjeckisk" ;
  tjeckiska_nn_2 = mkN "tjeckiska" ;
  tjeckoslovak_nn_1 = mkN "tjeckoslovak" "tjeckoslovaker" ;
  tjeckoslovakisk_av_1 = mkA "tjeckoslovakisk" ;
  tjeckoslovakiska_nn_1 = mkN "tjeckoslovakiska" ;
  tjej_nn_1 = mkN "tjej" "tjejer" ;
  tjock_av_1 = mkA "tjock" ;
  tjockflytande_av_1 = mkA "tjockflytande" ;
  tjockhuding_nn_1 = mkN "tjockhuding" ;
  tjockis_nn_1 = mkN "tjockis" ;
  tjocklek_nn_1 = mkN "tjocklek" ;
  tjockskalle_nn_1 = mkN "tjockskalle" utrum ;
  tjockskallig_av_1 = mkA "tjockskallig" ;
  tjocktarm_nn_1 = mkN "tjocktarm" ;
  tjog_nn_1 = mkN "tjog" neutrum ;
  tjogtals_ab_1 = mkAdv "tjogtals" ;
  tjomme_nn_1 = mkN "tjomme" utrum ;
  tjuder_nn_1 = mkN "tjuder" neutrum ;
  tjugofemoering_nn_1 = mkN "tjugofemцring" ;
  tjugondedag_nn_1 = mkN "tjugondedag" ;
  tjugondel_nn_1 = mkN "tjugondel" "tjugondelen" "tjugondelar" "tjugondelarna" ;
  tjugoplanig_av_1 = mkA "tjugoplanig" ;
  tjugotal_nn_1 = mkN "tjugotal" "tjugotalet" "tjugotalen" "tjugotalena" ;
  tjur_nn_1 = mkN "tjur" ;
  tjurfaektare_nn_1 = mkN "tjurfдktare" "tjurfдktare" ;
  tjurfaektning_nn_1 = mkN "tjurfдktning" ;
  tjurig_av_1 = mkA "tjurig" ;
  tjurnacke_nn_1 = mkN "tjurnacke" utrum ;
  tjurskalle_nn_1 = mkN "tjurskalle" utrum ;
  tjurskallig_av_1 = mkA "tjurskallig" ;
  tjusarlock_nn_1 = mkN "tjusarlock" ;
  tjusig_av_1 = mkA "tjusig" ;
  tjut_nn_1 = mkN "tjut" neutrum ;
  tjuv_nn_1 = mkN "tjuv" ;
  tjuvaktig_av_1 = mkA "tjuvaktig" ;
  tjuvalarm_nn_1 = mkN "tjuvalarm" neutrum ;
  tjuvbagge_nn_1 = mkN "tjuvbagge" utrum ;
  tjuveri_nn_1 = mkN "tjuveri" "tjuverit" "tjuverier" "tjuverierna" ;
  tjuvgoemmare_nn_1 = mkN "tjuvgцmmare" "tjuvgцmmare" ;
  tjuvhaalla_vb_1 = mkV "tjuvhеlla" "tjuvhцll" "tjuvhеllit" ;
  tjuvknep_nn_1 = mkN "tjuvknep" neutrum ;
  tjuvlarm_nn_1 = mkN "tjuvlarm" neutrum ;
  tjuvnad_nn_1 = mkN "tjuvnad" "tjuvnader" ;
  tjuvnyp_nn_1 = mkN "tjuvnyp" neutrum ;
  tjuvpojke_nn_1 = mkN "tjuvpojke" utrum ;
  tjuvpojksglimt_nn_1 = mkN "tjuvpojksglimt" ;
  tjuvskytt_nn_1 = mkN "tjuvskytt" ;
  tjuvstart_nn_1 = mkN "tjuvstart" "tjuvstarter" ;
  tjuvstreck_nn_1 = mkN "tjuvstreck" neutrum ;
  tjuvstryker_nn_1 = mkN "tjuvstryker" ;
  tjuvtitt_nn_1 = mkN "tjuvtitt" ;
  tjuvtjock_av_1 = mkA "tjuvtjock" ;
  tjuvtryck_nn_1 = mkN "tjuvtryck" neutrum ;
  tjyv_nn_1 = mkN "tjyv" ;
  tjyvnyp_nn_1 = mkN "tjyvnyp" neutrum ;
  tjyvtjock_av_1 = mkA "tjyvtjock" ;
  toalett_nn_1 = mkN "toalett" "toaletter" ;
  toalettartikel_nn_1 = mkN "toalettartikel" ;
  toalettbord_nn_1 = mkN "toalettbord" neutrum ;
  toalettskaap_nn_1 = mkN "toalettskеp" neutrum ;
  toalettvaal_nn_1 = mkN "toalettvеl" ;
  tobakist_nn_1 = mkN "tobakist" "tobakister" ;
  tobaksaffaer_nn_1 = mkN "tobaksaffдr" "tobaksaffдrer" ;
  tobakshandlare_nn_1 = mkN "tobakshandlare" "tobakshandlare" ;
  tobaksmonopol_nn_1 = mkN "tobaksmonopol" neutrum ;
  tobaksvara_nn_1 = mkN "tobaksvara" ;
  tobis_nn_1 = mkN "tobis" ;
  tobiskung_nn_1 = mkN "tobiskung" ;
  tocken_av_1 = mkA "tocken" "tocket" ;
  toddy_nn_1 = mkN "toddy" "toddyn" "toddyar" "toddyarna" ;
  toecken_nn_1 = mkN "tцcken" "tцcknet" "tцcken" "tцcknen" ;
  toecknig_av_1 = mkA "tцcknig" ;
  toeig_av_1 = mkA "tцig" ;
  toejbar_av_1 = mkA "tцjbar" ;
  toejbarhet_nn_1 = mkN "tцjbarhet" "tцjbarheter" ;
  toejning_nn_1 = mkN "tцjning" ;
  toejningsmaetare_nn_1 = mkN "tцjningsmдtare" "tцjningsmдtare" ;
  toelp_nn_1 = mkN "tцlp" ;
  toelpaktig_av_1 = mkA "tцlpaktig" ;
  toelpig_av_1 = mkA "tцlpig" ;
  toem_nn_1 = mkN "tцm" "tцmmen" "tцmmar" "tцmmarna" ;
  toemring_nn_1 = mkN "tцmring" ;
  toent_nn_1 = mkN "tцnt" ;
  toentig_av_1 = mkA "tцntig" ;
  toerhaenda_ab_1 = mkAdv "tцrhдnda" ;
  toern_nn_1 = mkN "tцrn" ;
  toernbestroedd_av_1 = mkA "tцrnbestrцdd" "tцrnbestrцdtt" ;
  toernbuske_nn_1 = mkN "tцrnbuske" utrum ;
  toernekroent_av_1 = mkA "tцrnekrцnt" "tцrnekrцnt" ;
  toernig_av_1 = mkA "tцrnig" ;
  toernsaangare_nn_1 = mkN "tцrnsеngare" "tцrnsеngare" ;
  toerntagg_nn_1 = mkN "tцrntagg" ;
  toerstig_av_1 = mkA "tцrstig" ;
  toerstslaeckande_av_1 = mkA "tцrstslдckande" ;
  toes_nn_1 = mkN "tцs" "tцser" ;
  toffel_nn_1 = mkN "toffel" "toffeln" "tofflor" "tofflorna" ;
  toffeldjur_nn_1 = mkN "toffeldjur" neutrum ;
  toffelhjaelte_nn_1 = mkN "toffelhjдlte" utrum ;
  tofs_nn_1 = mkN "tofs" ;
  tofsig_av_1 = mkA "tofsig" ;
  tofsmes_nn_1 = mkN "tofsmes" ;
  tofsoera_nn_1 = mkN "tofsцra" "tofsцrat" "tofsцron" "tofsцronen" ;
  tofsskivling_nn_1 = mkN "tofsskivling" ;
  toft_nn_1 = mkN "toft" "tofter" ;
  toftvaegare_nn_1 = mkN "toftvдgare" "toftvдgare" ;
  togoles_nn_1 = mkN "togoles" "togoleser" ;
  togolesisk_av_1 = mkA "togolesisk" ;
  tok_nn_1 = mkN "tok" ;
  toker_nn_1 = mkN "toker" ;
  tokeri_nn_1 = mkN "tokeri" "tokerit" "tokerier" "tokerierna" ;
  tokig_av_1 = mkA "tokig" ;
  tokrolig_av_1 = mkA "tokrolig" ;
  tokstolle_nn_1 = mkN "tokstolle" utrum ;
  tolerabel_av_1 = mkA "tolerabel" "tolerabelt" "tolerabla" "tolerabla" "tolerablare" "tolerablast" "tolerablaste" ;
  tolerans_nn_1 = mkN "tolerans" "toleranser" ;
  tolerant_av_1 = mkA "tolerant" "tolerant" ;
  tolft_nn_1 = mkN "tolft" "tolfter" ;
  tolftedel_nn_1 = mkN "tolftedel" "tolftedelen" "tolftedelar" "tolftedelarna" ;
  tolk_nn_1 = mkN "tolk" ;
  tolkare_nn_1 = mkN "tolkare" "tolkare" ;
  tolkning_nn_1 = mkN "tolkning" ;
  tolkningsfraaga_nn_1 = mkN "tolkningsfrеga" ;
  tolvfingertarm_nn_1 = mkN "tolvfingertarm" ;
  tolvman_nn_1 = mkN "tolvman" "tolvmannen" "tolvmдn" "tolvmдnnen" ;
  tolvmilsgraens_nn_1 = mkN "tolvmilsgrдns" "tolvmilsgrдnser" ;
  tolvskilling_nn_1 = mkN "tolvskilling" ;
  tom_av_1 = mkA "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ;
  tom_nn_1 = mkN "tom" "tomer" ;
  tomahawk_nn_1 = mkN "tomahawk" "tomahawker" ;
  tomat_nn_1 = mkN "tomat" "tomater" ;
  tombutelj_nn_1 = mkN "tombutelj" "tombuteljer" ;
  tomglas_nn_1 = mkN "tomglas" neutrum ;
  tomhaent_av_1 = mkA "tomhдnt" "tomhдnt" ;
  tomhet_nn_1 = mkN "tomhet" "tomheter" ;
  tomning_ab_1 = mkAdv "tomning" ;
  tomografi_nn_1 = mkN "tomografi" "tomografier" ;
  tomrum_nn_1 = mkN "tomrum" "tomrummet" "tomrum" "tomrummen" ;
  tomt_nn_1 = mkN "tomt" "tomter" ;
  tomte_nn_1 = mkN "tomte" utrum ;
  tomtebisse_nn_1 = mkN "tomtebisse" utrum ;
  tomtebloss_nn_1 = mkN "tomtebloss" neutrum ;
  tomtemask_nn_1 = mkN "tomtemask" "tomtemasker" ;
  tomtenisse_nn_1 = mkN "tomtenisse" utrum ;
  tomtjobbare_nn_1 = mkN "tomtjobbare" "tomtjobbare" ;
  tomtmark_nn_1 = mkN "tomtmark" "tomtmarker" ;
  tomtraettsavgaeld_nn_1 = mkN "tomtrдttsavgдld" "tomtrдttsavgдlder" ;
  ton_nn_1 = mkN "ton" "toner" ;
  ton_nn_2 = mkN "ton" "tonnet" "ton" "tonnen" ;
  tonaarig_av_1 = mkA "tonеrig" ;
  tonaaring_nn_1 = mkN "tonеring" ;
  tonaarsidol_nn_1 = mkN "tonеrsidol" "tonеrsidoler" ;
  tonal_av_1 = mkA "tonal" ;
  tonalitet_nn_1 = mkN "tonalitet" "tonaliteter" ;
  tonande_av_1 = mkA "tonande" ;
  tonarm_nn_1 = mkN "tonarm" ;
  tonart_nn_1 = mkN "tonart" "tonarter" ;
  tonband_nn_1 = mkN "tonband" neutrum ;
  tondoev_av_1 = mkA "tondцv" ;
  tonem_nn_1 = mkN "tonem" neutrum ;
  tonett_nn_1 = mkN "tonett" "tonetter" ;
  tonfall_nn_1 = mkN "tonfall" neutrum ;
  tonfisk_nn_1 = mkN "tonfisk" ;
  tonfoeljd_nn_1 = mkN "tonfцljd" "tonfцljder" ;
  tongan_nn_1 = mkN "tongan" "tonganer" ;
  tongivande_av_1 = mkA "tongivande" ;
  tonhoejd_nn_1 = mkN "tonhцjd" "tonhцjder" ;
  tonikum_nn_1 = mkN "tonikum" neutrum ;
  toning_nn_1 = mkN "toning" ;
  tonisk_av_1 = mkA "tonisk" ;
  tonkilometer_nn_1 = mkN "tonkilometer" "tonkilometern" "tonkilometer" "tonkilometerna" ;
  tonlaege_nn_1 = mkN "tonlдge" ;
  tonloes_av_1 = mkA "tonlцs" ;
  tonmaalning_nn_1 = mkN "tonmеlning" ;
  tonomfaang_nn_1 = mkN "tonomfеng" neutrum ;
  tonomraade_nn_1 = mkN "tonomrеde" ;
  tonsaeker_av_1 = mkA "tonsдker" "tonsдkert" "tonsдkra" "tonsдkra" "tonsдkrare" "tonsдkrast" "tonsдkraste" ;
  tonsaettare_nn_1 = mkN "tonsдttare" "tonsдttare" ;
  tonsaettning_nn_1 = mkN "tonsдttning" ;
  tonsill_nn_1 = mkN "tonsill" "tonsiller" ;
  tonspraak_nn_1 = mkN "tonsprеk" neutrum ;
  tonsteg_nn_1 = mkN "tonsteg" neutrum ;
  tonstyrka_nn_1 = mkN "tonstyrka" ;
  tonsur_nn_1 = mkN "tonsur" "tonsurer" ;
  tonsystem_nn_1 = mkN "tonsystem" neutrum ;
  tontraeffning_nn_1 = mkN "tontrдffning" ;
  tonvis_ab_1 = mkAdv "tonvis" ;
  topas_nn_1 = mkN "topas" "topaser" ;
  topless_av_1 = mkA "topless" ;
  topograf_nn_1 = mkN "topograf" "topografer" ;
  topografisk_av_1 = mkA "topografisk" ;
  topologi_nn_1 = mkN "topologi" "topologier" ;
  topologisk_av_1 = mkA "topologisk" ;
  topp_nn_1 = mkN "topp" ;
  toppbefattning_nn_1 = mkN "toppbefattning" ;
  toppbegaavning_nn_1 = mkN "toppbegеvning" ;
  toppeld_nn_1 = mkN "toppeld" ;
  toppen_av_1 = mkA "toppen" "toppet" ;
  toppenbra_av_1 = mkA "toppenbra" ;
  toppformig_av_1 = mkA "toppformig" ;
  topphugga_vb_1 = mkV "topphugga" "topphцgg" "topphuggit" ;
  toppig_av_1 = mkA "toppig" ;
  toppknopp_nn_1 = mkN "toppknopp" ;
  toppkonferens_nn_1 = mkN "toppkonferens" "toppkonferenser" ;
  toppkraft_nn_1 = mkN "toppkraft" "toppkrafter" ;
  topplaan_nn_1 = mkN "topplеn" neutrum ;
  topplock_nn_1 = mkN "topplock" neutrum ;
  toppman_nn_1 = mkN "toppman" "toppmannen" "toppmдn" "toppmдnnen" ;
  toppmast_nn_1 = mkN "toppmast" "toppmaster" ;
  toppmoete_nn_1 = mkN "toppmцte" ;
  toppmurkla_nn_1 = mkN "toppmurkla" ;
  toppnivaa_nn_1 = mkN "toppnivе" "toppnivеer" ;
  topprida_vb_1 = mkV "topprida" "toppred" "toppridit" ;
  toppsegel_nn_1 = mkN "toppsegel" neutrum ;
  toppstyrd_av_1 = mkA "toppstyrd" "toppstyrt" ;
  toque_nn_1 = mkN "toque" "toquer" ;
  tordmule_nn_1 = mkN "tordmule" utrum ;
  tordoen_nn_1 = mkN "tordцn" neutrum ;
  tordoensroest_nn_1 = mkN "tordцnsrцst" "tordцnsrцster" ;
  tordoensstaemma_nn_1 = mkN "tordцnsstдmma" ;
  tordyvel_nn_1 = mkN "tordyvel" ;
  toreador_nn_1 = mkN "toreador" "toreadoren" "toreadorer" "toreadorerna" ;
  torero_nn_1 = mkN "torero" "toreror" ;
  torftig_av_1 = mkA "torftig" ;
  torg_nn_1 = mkN "torg" neutrum ;
  torgdag_nn_1 = mkN "torgdag" ;
  torgstaand_nn_1 = mkN "torgstеnd" neutrum ;
  tork_nn_1 = mkN "tork" ;
  torkaemne_nn_1 = mkN "torkдmne" ;
  torkarblad_nn_1 = mkN "torkarblad" neutrum ;
  torkeri_nn_1 = mkN "torkeri" "torkerit" "torkerier" "torkerierna" ;
  torkhandduk_nn_1 = mkN "torkhandduk" ;
  torkhuv_nn_1 = mkN "torkhuv" ;
  torkkatastrof_nn_1 = mkN "torkkatastrof" "torkkatastrofer" ;
  torkning_nn_1 = mkN "torkning" ;
  torkperiod_nn_1 = mkN "torkperiod" "torkperioder" ;
  torkrum_nn_1 = mkN "torkrum" "torkrummet" "torkrum" "torkrummen" ;
  torkskaap_nn_1 = mkN "torkskеp" neutrum ;
  torkstaell_nn_1 = mkN "torkstдll" neutrum ;
  torkstreck_nn_1 = mkN "torkstreck" neutrum ;
  torktumlare_nn_1 = mkN "torktumlare" "torktumlare" ;
  torn_nn_1 = mkN "torn" neutrum ;
  torn_nn_2 = mkN "torn" ;
  tornado_nn_1 = mkN "tornado" "tornadon" "tornados" "tornadosen" ;
  tornering_nn_1 = mkN "tornering" ;
  tornerspel_nn_1 = mkN "tornerspel" "tornerspelet" "tornerspel" "tornerspelen" ;
  tornfalk_nn_1 = mkN "tornfalk" ;
  tornister_nn_1 = mkN "tornister" ;
  tornseglare_nn_1 = mkN "tornseglare" "tornseglare" ;
  tornur_nn_1 = mkN "tornur" neutrum ;
  tornvaektare_nn_1 = mkN "tornvдktare" "tornvдktare" ;
  torp_nn_1 = mkN "torp" neutrum ;
  torpare_nn_1 = mkN "torpare" "torpare" ;
  torped_nn_1 = mkN "torped" "torpeder" ;
  torpedbaat_nn_1 = mkN "torpedbеt" ;
  torpedtub_nn_1 = mkN "torpedtub" "torpedtuber" ;
  torr_av_1 = mkA "torr" ;
  torrbatteri_nn_1 = mkN "torrbatteri" "torrbatterit" "torrbatterier" "torrbatterierna" ;
  torrboll_nn_1 = mkN "torrboll" ;
  torrdestillation_nn_1 = mkN "torrdestillation" "torrdestillationer" ;
  torrelement_nn_1 = mkN "torrelement" neutrum ;
  torris_nn_2 = mkN "torris" ;
  torrklosett_nn_1 = mkN "torrklosett" "torrklosetter" ;
  torrnaal_nn_1 = mkN "torrnеl" ;
  torroegd_av_1 = mkA "torrцgd" "torrцgt" ;
  torrolig_av_1 = mkA "torrolig" ;
  torrperiod_nn_1 = mkN "torrperiod" "torrperioder" ;
  torrschampo_nn_1 = mkN "torrschampo" "torrschampot" "torrschampon" "torrschampona" ;
  torrskodd_av_1 = mkA "torrskodd" "torrskodtt" ;
  torrtid_nn_1 = mkN "torrtid" "torrtider" ;
  torsdag_nn_1 = mkN "torsdag" ;
  torsdagskvaell_nn_1 = mkN "torsdagskvдll" ;
  torsdagsmorgon_nn_1 = mkN "torsdagsmorgon" "torsdagsmorgonen" "torsdagsmorgnar" "torsdagsmorgnarna" ;
  torsk_nn_1 = mkN "torsk" ;
  torskfisk_nn_1 = mkN "torskfisk" ;
  torskoega_nn_1 = mkN "torskцga" "torskцgat" "torskцgon" "torskцgonen" ;
  torso_nn_1 = mkN "torso" "torson" "torser" "torserna" ;
  tortyr_nn_1 = mkN "tortyr" "tortyrer" ;
  tortyrkammare_nn_1 = mkN "tortyrkammare" "tortyrkammaren" "tortyrkamrar" "tortyrkamrarna" ;
  tortyrredskap_nn_1 = mkN "tortyrredskap" "tortyrredskapet" "tortyrredskapen" "tortyrredskapena" ;
  torvaktig_av_1 = mkA "torvaktig" ;
  torvdike_nn_1 = mkN "torvdike" ;
  torvgrav_nn_1 = mkN "torvgrav" ;
  torvjord_nn_1 = mkN "torvjord" ;
  torvmosse_nn_1 = mkN "torvmosse" utrum ;
  torvmossfynd_nn_1 = mkN "torvmossfynd" neutrum ;
  torvmullsklosett_nn_1 = mkN "torvmullsklosett" "torvmullsklosetter" ;
  torvspade_nn_1 = mkN "torvspade" utrum ;
  torvtaekt_nn_1 = mkN "torvtдkt" "torvtдkter" ;
  torvtak_nn_1 = mkN "torvtak" neutrum ;
  tory_nn_1 = mkN "tory" "toryn" "tories" "tories" ;
  tosig_av_1 = mkA "tosig" ;
  tosing_nn_1 = mkN "tosing" ;
  tosk_nn_1 = mkN "tosk" "tosker" ;
  toskansk_av_1 = mkA "toskansk" ;
  tossig_av_1 = mkA "tossig" ;
  total_av_1 = mkA "total" ;
  totalfoerbjuda_vb_1 = mkV "totalfцrbjuda" "totalfцrbjцd" "totalfцrbjudit" ;
  totalfoerbud_nn_1 = mkN "totalfцrbud" neutrum ;
  totalfoermoerkelse_nn_1 = mkN "totalfцrmцrkelse" "totalfцrmцrkelser" ;
  totalhaveri_nn_1 = mkN "totalhaveri" "totalhaverit" "totalhaverier" "totalhaverierna" ;
  totalisator_nn_1 = mkN "totalisator" "totalisatorer" ;
  totalitaer_av_1 = mkA "totalitдr" ;
  totaliter_ab_1 = mkAdv "totaliter" ;
  totalitet_nn_1 = mkN "totalitet" "totaliteter" ;
  totalvaerde_nn_1 = mkN "totalvдrde" ;
  totalvikt_nn_1 = mkN "totalvikt" "totalvikter" ;
  totempaale_nn_1 = mkN "totempеle" utrum ;
  totempelare_nn_1 = mkN "totempelare" "totempelare" ;
  toto_nn_1 = mkN "toto" ;
  totospel_nn_1 = mkN "totospel" "totospelet" "totospel" "totospelen" ;
  tott_nn_1 = mkN "tott" ;
  touche_nn_1 = mkN "touche" "toucher" ;
  toujours_av_1 = mkA "toujours" ;
  toupe_nn_1 = mkN "toupй" "toupйer" ;
  tournedos_nn_1 = mkN "tournedos" "tournedoser" ;
  tovig_av_1 = mkA "tovig" ;
  toxafen_nn_1 = mkN "toxafen" "toxafenet" "toxafener" "toxafenerna" ;
  toxicitet_nn_1 = mkN "toxicitet" "toxiciteter" ;
  toxikologisk_av_1 = mkA "toxikologisk" ;
  toxisk_av_1 = mkA "toxisk" ;
  traackelstygn_nn_1 = mkN "trеckelstygn" neutrum ;
  traackeltraad_nn_1 = mkN "trеckeltrеd" ;
  traackling_nn_1 = mkN "trеckling" ;
  traad_nn_1 = mkN "trеd" ;
  traadaemne_nn_1 = mkN "trеdдmne" ;
  traadbindning_nn_1 = mkN "trеdbindning" ;
  traadbuss_nn_1 = mkN "trеdbuss" ;
  traadduk_nn_1 = mkN "trеdduk" ;
  traadig_av_1 = mkA "trеdig" ;
  traadknapp_nn_1 = mkN "trеdknapp" ;
  traadkors_nn_1 = mkN "trеdkors" neutrum ;
  traadliknande_av_1 = mkA "trеdliknande" ;
  traadloes_av_1 = mkA "trеdlцs" ;
  traadmask_nn_1 = mkN "trеdmask" ;
  traadraet_av_1 = mkA "trеdrдt" ;
  traadrulle_nn_1 = mkN "trеdrulle" utrum ;
  traadsax_nn_1 = mkN "trеdsax" ;
  traadskivling_nn_1 = mkN "trеdskivling" ;
  traadsliten_av_1 = mkA "trеdsliten" "trеdslitet" ;
  traadsmal_av_1 = mkA "trеdsmal" ;
  traadspik_nn_1 = mkN "trеdspik" ;
  traag_nn_1 = mkN "trеg" neutrum ;
  traagdal_nn_1 = mkN "trеgdal" ;
  traakig_av_1 = mkA "trеkig" ;
  traakmaans_nn_1 = mkN "trеkmеns" ;
  traakning_nn_1 = mkN "trеkning" ;
  traal_nn_1 = mkN "trеl" ;
  traalare_nn_1 = mkN "trеlare" "trеlare" ;
  traanad_nn_1 = mkN "trеnad" "trеnader" ;
  traang_av_1 = mkA "trеng" ;
  traangbodd_av_1 = mkA "trеngbodd" "trеngbodtt" ;
  traangmaal_nn_1 = mkN "trеngmеl" neutrum ;
  traangsint_av_1 = mkA "trеngsint" "trеngsint" ;
  traangsynt_av_1 = mkA "trеngsynt" "trеngsynt" ;
  traansjuk_av_1 = mkA "trеnsjuk" ;
  trad_nn_1 = mkN "trad" "trader" ;
  tradig_av_1 = mkA "tradig" ;
  tradition_nn_1 = mkN "tradition" "traditioner" ;
  traditionalist_nn_1 = mkN "traditionalist" "traditionalister" ;
  traditionell_av_1 = mkA "traditionell" ;
  traditionsbaerare_nn_1 = mkN "traditionsbдrare" "traditionsbдrare" ;
  traditionsbrott_nn_1 = mkN "traditionsbrott" neutrum ;
  traditionsbunden_av_1 = mkA "traditionsbunden" "traditionsbundet" ;
  traditionsenlig_av_1 = mkA "traditionsenlig" ;
  trae_nn_1 = mkN "trд" "trдet" "trдn" "trдna" ;
  traeaktig_av_1 = mkA "trдaktig" ;
  traeavfall_nn_1 = mkN "trдavfall" neutrum ;
  traeben_nn_1 = mkN "trдben" neutrum ;
  traebit_nn_1 = mkN "trдbit" ;
  traeblaasare_nn_1 = mkN "trдblеsare" "trдblеsare" ;
  traeblaasinstrument_nn_1 = mkN "trдblеsinstrument" neutrum ;
  traebock_nn_1 = mkN "trдbock" ;
  traecell_nn_1 = mkN "trдcell" "trдceller" ;
  traed_nn_1 = mkN "trдd" neutrum ;
  traeddiagram_nn_1 = mkN "trдddiagram" "trдddiagrammet" "trдddiagram" "trдddiagrammen" ;
  traedestillation_nn_1 = mkN "trдdestillation" "trдdestillationer" ;
  traedgaard_nn_1 = mkN "trдdgеrd" ;
  traedgaardsaert_nn_1 = mkN "trдdgеrdsдrt" "trдdgеrdsдrter" ;
  traedgaardsarkitekt_nn_1 = mkN "trдdgеrdsarkitekt" "trдdgеrdsarkitekter" ;
  traedgaardsbuske_nn_1 = mkN "trдdgеrdsbuske" utrum ;
  traedgaardsmaestare_nn_1 = mkN "trдdgеrdsmдstare" "trдdgеrdsmдstare" ;
  traedgaardsmoebel_nn_1 = mkN "trдdgеrdsmцbel" "trдdgеrdsmцbeln" "trдdgеrdsmцbler" "trдdgеrdsmцblerna" ;
  traedgaardsodling_nn_1 = mkN "trдdgеrdsodling" ;
  traedgaardsprydnad_nn_1 = mkN "trдdgеrdsprydnad" "trдdgеrdsprydnader" ;
  traedgaardssaangare_nn_1 = mkN "trдdgеrdssеngare" "trдdgеrdssеngare" ;
  traedgaardssax_nn_1 = mkN "trдdgеrdssax" ;
  traedgraens_nn_1 = mkN "trдdgrдns" "trдdgrдnser" ;
  traedkrypare_nn_1 = mkN "trдdkrypare" "trдdkrypare" ;
  traedliknande_av_1 = mkA "trдdliknande" ;
  traedmogen_av_1 = mkA "trдdmogen" "trдdmoget" ;
  traednaal_nn_1 = mkN "trдdnеl" ;
  traedrot_nn_1 = mkN "trдdrot" "trдdrцtter" ;
  traedslag_nn_1 = mkN "trдdslag" neutrum ;
  traedstam_nn_1 = mkN "trдdstam" "trдdstammen" "trдdstammar" "trдdstammarna" ;
  traedstruktur_nn_1 = mkN "trдdstruktur" "trдdstrukturer" ;
  traedstygn_nn_1 = mkN "trдdstygn" neutrum ;
  traedsvamp_nn_1 = mkN "trдdsvamp" ;
  traedtopp_nn_1 = mkN "trдdtopp" ;
  traefartyg_nn_1 = mkN "trдfartyg" neutrum ;
  traeff_nn_1 = mkN "trдff" ;
  traeffande_av_1 = mkA "trдffande" ;
  traeffbild_nn_1 = mkN "trдffbild" "trдffbilder" ;
  traeffning_nn_1 = mkN "trдffning" ;
  traeffpunkt_nn_1 = mkN "trдffpunkt" "trдffpunkter" ;
  traeffsaeker_av_1 = mkA "trдffsдker" "trдffsдkert" "trдffsдkra" "trдffsдkra" "trдffsдkrare" "trдffsдkrast" "trдffsдkraste" ;
  traeffsaekerhet_nn_1 = mkN "trдffsдkerhet" "trдffsдkerheter" ;
  traefiber_nn_1 = mkN "trдfiber" "trдfibern" "trдfibrer" "trдfibrerna" ;
  traefil_nn_1 = mkN "trдfil" ;
  traefraes_nn_1 = mkN "trдfrдs" ;
  traefri_av_1 = mkA "trдfri" "trдfritt" ;
  traegen_av_1 = mkA "trдgen" "trдget" ;
  traegolv_nn_1 = mkN "trдgolv" neutrum ;
  traegravyr_nn_1 = mkN "trдgravyr" "trдgravyrer" ;
  traehaest_nn_1 = mkN "trдhдst" ;
  traeig_av_1 = mkA "trдig" ;
  traeindustri_nn_1 = mkN "trдindustri" "trдindustrier" ;
  traekarl_nn_1 = mkN "trдkarl" ;
  traekol_nn_1 = mkN "trдkol" neutrum ;
  trael_nn_1 = mkN "trдl" ;
  traelbinda_vb_1 = mkV "trдlbinda" "trдlband" "trдlbundit" ;
  traeldom_nn_1 = mkN "trдldom" ;
  traelig_av_1 = mkA "trдlig" ;
  traemask_nn_1 = mkN "trдmask" ;
  traemortel_nn_1 = mkN "trдmortel" ;
  traenare_nn_1 = mkN "trдnare" "trдnare" ;
  traengande_av_1 = mkA "trдngande" ;
  traengd_av_1 = mkA "trдngd" "trдngt" ;
  traengning_nn_1 = mkN "trдngning" ;
  traengtrupp_nn_1 = mkN "trдngtrupp" "trдngtrupper" ;
  traening_nn_1 = mkN "trдning" ;
  traeningsdraekt_nn_1 = mkN "trдningsdrдkt" "trдningsdrдkter" ;
  traeningslaeger_nn_1 = mkN "trдningslдger" neutrum ;
  traeningsoverall_nn_1 = mkN "trдningsoverall" "trдningsoveraller" ;
  traenjon_nn_1 = mkN "trдnjon" neutrum ;
  traens_nn_1 = mkN "trдns" ;
  traepinne_nn_1 = mkN "trдpinne" utrum ;
  traeprodukt_nn_1 = mkN "trдprodukt" "trдprodukter" ;
  traeram_nn_1 = mkN "trдram" ;
  traesk_nn_1 = mkN "trдsk" neutrum ;
  traeskaal_nn_1 = mkN "trдskеl" ;
  traeskalle_nn_1 = mkN "trдskalle" utrum ;
  traeskallig_av_1 = mkA "trдskallig" ;
  traesked_nn_1 = mkN "trдsked" ;
  traeskfolk_nn_1 = mkN "trдskfolk" neutrum ;
  traeskland_nn_1 = mkN "trдskland" neutrum ;
  traesko_nn_1 = mkN "trдsko" "trдskor" ;
  traeskodans_nn_1 = mkN "trдskodans" "trдskodanser" ;
  traeskostoevel_nn_1 = mkN "trдskostцvel" ;
  traeskruv_nn_1 = mkN "trдskruv" ;
  traeskydd_nn_1 = mkN "trдskydd" neutrum ;
  traeskyddsmedel_nn_1 = mkN "trдskyddsmedel" neutrum ;
  traeslag_nn_1 = mkN "trдslag" neutrum ;
  traeslev_nn_1 = mkN "trдslev" ;
  traeslip_nn_1 = mkN "trдslip" ;
  traeslott_nn_1 = mkN "trдslott" neutrum ;
  traesnidare_nn_1 = mkN "trдsnidare" "trдsnidare" ;
  traesnideri_nn_1 = mkN "trдsnideri" "trдsniderit" "trдsniderier" "trдsniderierna" ;
  traesnitt_nn_1 = mkN "trдsnitt" neutrum ;
  traesnittsstock_nn_1 = mkN "trдsnittsstock" ;
  traestav_nn_1 = mkN "trдstav" ;
  traestick_nn_1 = mkN "trдstick" neutrum ;
  traestift_nn_1 = mkN "trдstift" neutrum ;
  traeteknisk_av_1 = mkA "trдteknisk" ;
  traetgirig_av_1 = mkA "trдtgirig" ;
  traetlysten_av_1 = mkA "trдtlysten" "trдtlystet" ;
  traetobroder_nn_1 = mkN "trдtobroder" "trдtobrodern" "trдtobrцder" "trдtobrцderna" ;
  traetoffel_nn_1 = mkN "trдtoffel" "trдtoffeln" "trдtofflor" "trдtofflorna" ;
  traevit_av_1 = mkA "trдvit" ;
  trafikabel_av_1 = mkA "trafikabel" "trafikabelt" "trafikabla" "trafikabla" "trafikablare" "trafikablast" "trafikablaste" ;
  trafikant_nn_1 = mkN "trafikant" "trafikanter" ;
  trafikdelare_nn_1 = mkN "trafikdelare" "trafikdelare" ;
  trafikfarlig_av_1 = mkA "trafikfarlig" ;
  trafikflygare_nn_1 = mkN "trafikflygare" "trafikflygare" ;
  trafikflygplan_nn_1 = mkN "trafikflygplan" neutrum ;
  trafikfoersaekring_nn_1 = mkN "trafikfцrsдkring" ;
  trafikfyr_nn_1 = mkN "trafikfyr" ;
  trafikkort_nn_1 = mkN "trafikkort" neutrum ;
  trafikled_nn_1 = mkN "trafikled" "trafikleder" ;
  trafikledare_nn_1 = mkN "trafikledare" "trafikledare" ;
  trafikljus_nn_1 = mkN "trafikljus" neutrum ;
  trafikmaerke_nn_1 = mkN "trafikmдrke" ;
  trafikplats_nn_1 = mkN "trafikplats" "trafikplatser" ;
  trafikregel_nn_1 = mkN "trafikregel" "trafikregeln" "trafikregler" "trafikreglerna" ;
  trafikreglering_nn_1 = mkN "trafikreglering" ;
  trafiksaeker_av_1 = mkA "trafiksдker" "trafiksдkert" "trafiksдkra" "trafiksдkra" "trafiksдkrare" "trafiksдkrast" "trafiksдkraste" ;
  trafiksaekerhet_nn_1 = mkN "trafiksдkerhet" "trafiksдkerheter" ;
  trafiksaekerhetsverk_nn_1 = mkN "trafiksдkerhetsverk" neutrum ;
  trafiksignal_nn_1 = mkN "trafiksignal" "trafiksignaler" ;
  trafikstockning_nn_1 = mkN "trafikstockning" ;
  trafiktillstaand_nn_1 = mkN "trafiktillstеnd" neutrum ;
  trafikvakt_nn_1 = mkN "trafikvakt" "trafikvakter" ;
  tragedi_nn_1 = mkN "tragedi" "tragedier" ;
  tragedienn_nn_1 = mkN "tragedienn" "tragedienner" ;
  tragedifoerfattare_nn_1 = mkN "tragedifцrfattare" "tragedifцrfattare" ;
  tragglig_av_1 = mkA "tragglig" ;
  tragiker_nn_1 = mkN "tragiker" "tragikern" "tragiker" "tragikerna" ;
  tragikomedi_nn_1 = mkN "tragikomedi" "tragikomedier" ;
  tragikomisk_av_1 = mkA "tragikomisk" ;
  tragisk_av_1 = mkA "tragisk" ;
  tragoed_nn_1 = mkN "tragцd" "tragцder" ;
  trailer_nn_1 = mkN "trailer" ;
  traj_nn_1 = mkN "traj" neutrum ;
  trakasseri_nn_1 = mkN "trakasseri" "trakasserit" "trakasserier" "trakasserierna" ;
  trake_nn_1 = mkN "trakй" "trakйer" ;
  trakegael_nn_1 = mkN "trakйgдl" ;
  trakom_nn_1 = mkN "trakom" neutrum ;
  trakt_nn_1 = mkN "trakt" "trakter" ;
  traktat_nn_1 = mkN "traktat" "traktater" ;
  traktblaedning_nn_1 = mkN "traktblдdning" ;
  traktering_nn_1 = mkN "traktering" ;
  trakthugga_vb_1 = mkV "trakthugga" "trakthцgg" "trakthuggit" ;
  traktoer_nn_1 = mkN "traktцr" "traktцrer" ;
  traktor_nn_1 = mkN "traktor" "traktorer" ;
  traktordaeck_nn_1 = mkN "traktordдck" neutrum ;
  traktur_nn_1 = mkN "traktur" "trakturer" ;
  trakyt_nn_1 = mkN "trakyt" "trakyter" ;
  trall_nn_1 = mkN "trall" ;
  trall_nn_2 = mkN "trall" ;
  trallvagn_nn_1 = mkN "trallvagn" ;
  trampbaat_nn_1 = mkN "trampbеt" ;
  trampbil_nn_1 = mkN "trampbil" ;
  trampcykel_nn_1 = mkN "trampcykel" ;
  trampfartyg_nn_1 = mkN "trampfartyg" neutrum ;
  tramphjul_nn_1 = mkN "tramphjul" neutrum ;
  trampkvarn_nn_1 = mkN "trampkvarn" ;
  trampoert_nn_1 = mkN "trampцrt" "trampцrter" ;
  trampolin_nn_1 = mkN "trampolin" "trampoliner" ;
  trampsax_nn_1 = mkN "trampsax" ;
  tramsig_av_1 = mkA "tramsig" ;
  tranbaer_nn_1 = mkN "tranbдr" neutrum ;
  tranben_nn_1 = mkN "tranben" neutrum ;
  trance_nn_1 = mkN "trance" "trancer" ;
  tranch_nn_1 = mkN "tranch" "trancher" ;
  trankil_av_1 = mkA "trankil" ;
  trankilitet_nn_1 = mkN "trankilitet" "trankiliteter" ;
  transaktion_nn_1 = mkN "transaktion" "transaktioner" ;
  transaktionsanalys_nn_1 = mkN "transaktionsanalys" "transaktionsanalyser" ;
  transalpin_av_1 = mkA "transalpin" ;
  transalpinsk_av_1 = mkA "transalpinsk" ;
  transatlantisk_av_1 = mkA "transatlantisk" ;
  transcendent_av_1 = mkA "transcendent" "transcendent" ;
  transcendental_av_1 = mkA "transcendental" ;
  transduktor_nn_1 = mkN "transduktor" "transduktorer" ;
  transferering_nn_1 = mkN "transferering" ;
  transfiguration_nn_1 = mkN "transfiguration" "transfigurationer" ;
  transformation_nn_1 = mkN "transformation" "transformationer" ;
  transformator_nn_1 = mkN "transformator" "transformatorer" ;
  transformatorstation_nn_1 = mkN "transformatorstation" "transformatorstationer" ;
  transfusion_nn_1 = mkN "transfusion" "transfusioner" ;
  transgression_nn_1 = mkN "transgression" "transgressioner" ;
  transistor_nn_1 = mkN "transistor" "transistorer" ;
  transitering_nn_1 = mkN "transitering" ;
  transithall_nn_1 = mkN "transithall" ;
  transitiv_av_1 = mkA "transitiv" ;
  transitlast_nn_1 = mkN "transitlast" "transitlaster" ;
  transitohamn_nn_1 = mkN "transitohamn" ;
  transitorisk_av_1 = mkA "transitorisk" ;
  transkontinental_av_1 = mkA "transkontinental" ;
  transkription_nn_1 = mkN "transkription" "transkriptioner" ;
  translator_nn_1 = mkN "translator" "translatorer" ;
  translitteration_nn_1 = mkN "translitteration" "translitterationer" ;
  transmission_nn_1 = mkN "transmission" "transmissioner" ;
  transmitter_nn_1 = mkN "transmitter" ;
  transmutation_nn_1 = mkN "transmutation" "transmutationer" ;
  transocean_av_1 = mkA "transocean" ;
  transoceansk_av_1 = mkA "transoceansk" ;
  transparang_nn_1 = mkN "transparang" "transparanger" ;
  transparent_av_1 = mkA "transparent" "transparent" ;
  transperson_nn_1 = mkN "transperson" "transpersoner" ;
  transplantat_nn_1 = mkN "transplantat" neutrum ;
  transplantation_nn_1 = mkN "transplantation" "transplantationer" ;
  transponder_nn_1 = mkN "transponder" ;
  transponering_nn_1 = mkN "transponering" ;
  transport_nn_1 = mkN "transport" "transporter" ;
  transportabel_av_1 = mkA "transportabel" "transportabelt" "transportabla" "transportabla" "transportablare" "transportablast" "transportablaste" ;
  transportanordning_nn_1 = mkN "transportanordning" ;
  transportarbetare_nn_1 = mkN "transportarbetare" "transportarbetare" ;
  transportavtal_nn_1 = mkN "transportavtal" "transportavtalet" "transportavtalen" "transportavtalena" ;
  transportband_nn_1 = mkN "transportband" neutrum ;
  transportfoerbud_nn_1 = mkN "transportfцrbud" neutrum ;
  transportfoeretag_nn_1 = mkN "transportfцretag" neutrum ;
  transportlaege_nn_1 = mkN "transportlдge" ;
  transportmedel_nn_1 = mkN "transportmedel" neutrum ;
  transportmekanism_nn_1 = mkN "transportmekanism" "transportmekanismer" ;
  transportnaet_nn_1 = mkN "transportnдt" neutrum ;
  transportoer_nn_1 = mkN "transportцr" "transportцrer" ;
  transportprocess_nn_1 = mkN "transportprocess" "transportprocesser" ;
  transportsystem_nn_1 = mkN "transportsystem" neutrum ;
  transposition_nn_1 = mkN "transposition" "transpositioner" ;
  transsexuell_av_1 = mkA "transsexuell" ;
  transsibirisk_av_1 = mkA "transsibirisk" ;
  transsubstantiation_nn_1 = mkN "transsubstantiation" "transsubstantiationer" ;
  transumt_nn_1 = mkN "transumt" neutrum ;
  transuran_nn_1 = mkN "transuran" "transuraner" ;
  transversal_av_1 = mkA "transversal" ;
  transversal_nn_1 = mkN "transversal" "transversaler" ;
  transversalaxel_nn_1 = mkN "transversalaxel" ;
  transversell_av_1 = mkA "transversell" ;
  transvestit_nn_1 = mkN "transvestit" "transvestiter" ;
  trapets_nn_1 = mkN "trapets" "trapetser" ;
  trapets_nn_2 = mkN "trapets" "trapetset" "trapetser" "trapetserna" ;
  trapetsoid_nn_1 = mkN "trapetsoid" "trapetsoider" ;
  trapp_nn_1 = mkN "trapp" ;
  trappavsats_nn_1 = mkN "trappavsats" "trappavsatser" ;
  trapper_nn_1 = mkN "trapper" "trappern" "trapper" "trapperna" ;
  trappgavel_nn_1 = mkN "trappgavel" ;
  trapphus_nn_1 = mkN "trapphus" neutrum ;
  trappliknande_av_1 = mkA "trappliknande" ;
  trappraecke_nn_1 = mkN "trapprдcke" ;
  trappsmyg_nn_1 = mkN "trappsmyg" ;
  trappsteg_nn_1 = mkN "trappsteg" neutrum ;
  trappstege_nn_1 = mkN "trappstege" utrum ;
  trapptorn_nn_1 = mkN "trapptorn" neutrum ;
  trappuppgaang_nn_1 = mkN "trappuppgеng" ;
  traselegant_av_1 = mkA "traselegant" "traselegant" ;
  trasgrann_av_1 = mkA "trasgrann" "trasgrant" ;
  trashank_nn_1 = mkN "trashank" ;
  trasig_av_1 = mkA "trasig" ;
  trassat_nn_1 = mkN "trassat" "trassater" ;
  trasselsudd_nn_1 = mkN "trasselsudd" ;
  trassent_nn_1 = mkN "trassent" "trassenter" ;
  trasslig_av_1 = mkA "trasslig" ;
  trast_nn_1 = mkN "trast" ;
  trastfaagel_nn_1 = mkN "trastfеgel" ;
  trasunge_nn_1 = mkN "trasunge" utrum ;
  tratt_nn_1 = mkN "tratt" ;
  trattformig_av_1 = mkA "trattformig" ;
  trattkantarell_nn_1 = mkN "trattkantarell" "trattkantareller" ;
  trattliknande_av_1 = mkA "trattliknande" ;
  trattprick_nn_1 = mkN "trattprick" ;
  trattskivling_nn_1 = mkN "trattskivling" ;
  trauma_nn_1 = mkN "trauma" "traumat" "trauman" "traumana" ;
  traumatisk_av_1 = mkA "traumatisk" ;
  travare_nn_1 = mkN "travare" "travare" ;
  trave_nn_1 = mkN "trave" utrum ;
  travers_nn_1 = mkN "travers" "traverser" ;
  travesti_nn_1 = mkN "travesti" "travestier" ;
  travhaest_nn_1 = mkN "travhдst" ;
  travtaevling_nn_1 = mkN "travtдvling" ;
  treaarig_av_1 = mkA "treеrig" ;
  treaaring_nn_1 = mkN "treеring" ;
  treaktare_nn_1 = mkN "treaktare" "treaktare" ;
  trebent_av_1 = mkA "trebent" "trebent" ;
  trebetygskurs_nn_1 = mkN "trebetygskurs" "trebetygskurser" ;
  tredelning_nn_1 = mkN "tredelning" ;
  tredimensionell_av_1 = mkA "tredimensionell" ;
  tredjedag_nn_1 = mkN "tredjedag" ;
  tredjedel_nn_1 = mkN "tredjedel" "tredjedelen" "tredjedelar" "tredjedelarna" ;
  tredjegaangstillsaettning_nn_1 = mkN "tredjegеngstillsдttning" ;
  tredjeopponent_nn_1 = mkN "tredjeopponent" "tredjeopponenter" ;
  tredjeplats_nn_1 = mkN "tredjeplats" "tredjeplatser" ;
  tredsk_av_1 = mkA "tredsk" ;
  tredskodom_nn_1 = mkN "tredskodom" ;
  tredubbel_av_1 = mkA "tredubbel" "tredubbelt" "tredubbla" "tredubbla" "tredubblare" "tredubblast" "tredubblaste" ;
  treenig_av_1 = mkA "treenig" ;
  treenighet_nn_1 = mkN "treenighet" "treenigheter" ;
  trefaergstryck_nn_1 = mkN "trefдrgstryck" neutrum ;
  trefald_nn_1 = mkN "trefald" "trefalder" ;
  trefaldig_av_1 = mkA "trefaldig" ;
  trefaldighet_nn_1 = mkN "trefaldighet" "trefaldigheter" ;
  trefalt_ab_1 = mkAdv "trefalt" ;
  trefas_av_1 = mkA "trefas" ;
  trefasig_av_1 = mkA "trefasig" ;
  trefilig_av_1 = mkA "trefilig" ;
  treglasfoenster_nn_1 = mkN "treglasfцnster" neutrum ;
  trehjuling_nn_1 = mkN "trehjuling" ;
  trehoerning_nn_1 = mkN "trehцrning" ;
  trekant_nn_1 = mkN "trekant" "trekanter" ;
  trekantig_av_1 = mkA "trekantig" ;
  trekarlspolska_nn_1 = mkN "trekarlspolska" ;
  treklang_nn_1 = mkN "treklang" "treklanger" ;
  trekvartslaang_av_1 = mkA "trekvartslеng" ;
  trelaekarstation_nn_1 = mkN "trelдkarstation" "trelдkarstationer" ;
  treledarsystem_nn_1 = mkN "treledarsystem" neutrum ;
  trema_nn_1 = mkN "trema" "tremat" "treman" "tremana" ;
  tremaenning_nn_1 = mkN "tremдnning" ;
  tremastare_nn_1 = mkN "tremastare" "tremastare" ;
  tremilsgraens_nn_1 = mkN "tremilsgrдns" "tremilsgrдnser" ;
  tremolo_nn_1 = mkN "tremolo" "tremolot" "tremolon" "tremolona" ;
  tremulant_nn_1 = mkN "tremulant" "tremulanter" ;
  trench_nn_1 = mkN "trench" ;
  trenchcoat_nn_1 = mkN "trenchcoat" ;
  trend_nn_1 = mkN "trend" "trender" ;
  trendig_av_1 = mkA "trendig" ;
  trendnisse_nn_1 = mkN "trendnisse" utrum ;
  trendsaettare_nn_1 = mkN "trendsдttare" "trendsдttare" ;
  trepan_nn_1 = mkN "trepan" "trepaner" ;
  trepanation_nn_1 = mkN "trepanation" "trepanationer" ;
  trepass_nn_1 = mkN "trepass" neutrum ;
  trepunktsbaelte_nn_1 = mkN "trepunktsbдlte" ;
  treradig_av_1 = mkA "treradig" ;
  trerading_nn_1 = mkN "trerading" ;
  trerummare_nn_1 = mkN "trerummare" "trerummare" ;
  trerumslaegenhet_nn_1 = mkN "trerumslдgenhet" "trerumslдgenheter" ;
  tresiffrig_av_1 = mkA "tresiffrig" ;
  tresnibb_nn_1 = mkN "tresnibb" ;
  trespaend_av_1 = mkA "trespдnd" ;
  trespann_nn_1 = mkN "trespann" neutrum ;
  trestavig_av_1 = mkA "trestavig" ;
  trestegshopp_nn_1 = mkN "trestegshopp" neutrum ;
  trestegsraket_nn_1 = mkN "trestegsraket" "trestegsraketer" ;
  trestjaernig_av_1 = mkA "trestjдrnig" ;
  trestruken_av_1 = mkA "trestruken" "trestruket" ;
  tretaar_nn_1 = mkN "tretеr" ;
  tretal_nn_1 = mkN "tretal" "tretalet" "tretalen" "tretalena" ;
  trettiaarig_av_1 = mkA "trettiеrig" ;
  trettioaarig_av_1 = mkA "trettioеrig" ;
  trettiondel_nn_1 = mkN "trettiondel" "trettiondelen" "trettiondelar" "trettiondelarna" ;
  trettiotal_nn_1 = mkN "trettiotal" "trettiotalet" "trettiotalen" "trettiotalena" ;
  trettital_nn_1 = mkN "trettital" "trettitalet" "trettitalen" "trettitalena" ;
  trettondagsafton_nn_1 = mkN "trettondagsafton" "trettondagsaftonen" "trettondagsaftnar" "trettondagsaftnarna" ;
  trettondel_nn_1 = mkN "trettondel" "trettondelen" "trettondelar" "trettondelarna" ;
  tretumsspik_nn_1 = mkN "tretumsspik" ;
  treudd_nn_1 = mkN "treudd" ;
  trevaaningshus_nn_1 = mkN "trevеningshus" neutrum ;
  trevaegskran_nn_1 = mkN "trevдgskran" ;
  trevande_av_1 = mkA "trevande" ;
  trevare_nn_1 = mkN "trevare" "trevare" ;
  treven_av_1 = mkA "treven" "trevet" ;
  trevinklig_av_1 = mkA "trevinklig" ;
  trevlig_av_1 = mkA "trevlig" ;
  trevnad_nn_1 = mkN "trevnad" "trevnader" ;
  triad_nn_1 = mkN "triad" "triader" ;
  triangel_nn_1 = mkN "triangel" ;
  triangelbyte_nn_1 = mkN "triangelbyte" ;
  triangeldrama_nn_1 = mkN "triangeldrama" "triangeldramat" "triangeldraman" "triangeldramana" ;
  triangelkoppling_nn_1 = mkN "triangelkoppling" ;
  triangelmatch_nn_1 = mkN "triangelmatch" "triangelmatcher" ;
  triangelpunkt_nn_1 = mkN "triangelpunkt" "triangelpunkter" ;
  triangelsida_nn_1 = mkN "triangelsida" ;
  triangulaer_av_1 = mkA "triangulдr" ;
  tribad_nn_1 = mkN "tribad" "tribader" ;
  tribadisk_av_1 = mkA "tribadisk" ;
  tribun_nn_1 = mkN "tribun" "tribuner" ;
  tribunal_nn_1 = mkN "tribunal" "tribunaler" ;
  tribunat_nn_1 = mkN "tribunat" neutrum ;
  tribut_nn_1 = mkN "tribut" "tributer" ;
  tricepsmuskel_nn_1 = mkN "tricepsmuskel" "tricepsmuskeln" "tricepsmuskler" "tricepsmusklerna" ;
  trick_nn_1 = mkN "trick" neutrum ;
  trick_nn_2 = mkN "trick" ;
  trickfilm_nn_1 = mkN "trickfilm" "trickfilmer" ;
  tricks_nn_1 = mkN "tricks" neutrum ;
  triennal_nn_1 = mkN "triennal" "triennaler" ;
  triftong_nn_1 = mkN "triftong" "triftonger" ;
  triglyf_nn_1 = mkN "triglyf" "triglyfer" ;
  trigonometrisk_av_1 = mkA "trigonometrisk" ;
  trikaa_nn_1 = mkN "trikе" "trikеer" ;
  trikaavara_nn_1 = mkN "trikеvara" ;
  trikin_nn_1 = mkN "trikin" "trikiner" ;
  trikinoes_av_1 = mkA "trikinцs" ;
  trikolor_nn_1 = mkN "trikolor" "trikoloren" "trikolorer" "trikolorerna" ;
  trilateral_av_1 = mkA "trilateral" ;
  triljon_nn_1 = mkN "triljon" "triljoner" ;
  triljondel_nn_1 = mkN "triljondel" "triljondelen" "triljondelar" "triljondelarna" ;
  trilling_nn_1 = mkN "trilling" ;
  trillingkristall_nn_1 = mkN "trillingkristall" "trillingkristaller" ;
  trillingnerv_nn_1 = mkN "trillingnerv" "trillingnerver" ;
  trillion_nn_1 = mkN "trillion" "trillioner" ;
  trilobit_nn_1 = mkN "trilobit" "trilobiter" ;
  trilogi_nn_1 = mkN "trilogi" "trilogier" ;
  trilsk_av_1 = mkA "trilsk" ;
  trilskande_av_1 = mkA "trilskande" ;
  trilsken_av_1 = mkA "trilsken" "trilsket" ;
  trimeter_nn_1 = mkN "trimeter" ;
  trimtank_nn_1 = mkN "trimtank" ;
  trind_av_1 = mkA "trind" ;
  trindbladig_av_1 = mkA "trindbladig" ;
  trindmask_nn_1 = mkN "trindmask" ;
  trinidadier_nn_1 = mkN "trinidadier" "trinidadiern" "trinidadier" "trinidadierna" ;
  trinidadisk_av_1 = mkA "trinidadisk" ;
  trio_nn_1 = mkN "trio" "trion" "trios" "triosen" ;
  triod_nn_1 = mkN "triod" "trioder" ;
  trioer_nn_1 = mkN "triцr" "triцrer" ;
  triol_nn_1 = mkN "triol" "trioler" ;
  trioxipurin_nn_1 = mkN "trioxipurin" "trioxipuriner" ;
  triplett_nn_1 = mkN "triplett" "tripletter" ;
  tripod_nn_1 = mkN "tripod" "tripoder" ;
  tripp_nn_1 = mkN "tripp" ;
  tripp_nn_2 = mkN "tripp" neutrum ;
  trippel_nn_2 = mkN "trippel" "trippeln" "trippler" "tripplerna" ;
  trippelallians_nn_1 = mkN "trippelallians" "trippelallianser" ;
  trippelkrock_nn_1 = mkN "trippelkrock" ;
  trippelpunkt_nn_1 = mkN "trippelpunkt" "trippelpunkter" ;
  trippelseger_nn_1 = mkN "trippelseger" ;
  trippmaetare_nn_1 = mkN "trippmдtare" "trippmдtare" ;
  trips_nn_1 = mkN "trips" ;
  triptyk_nn_1 = mkN "triptyk" "triptyker" ;
  trist_av_1 = mkA "trist" "trist" ;
  triton_nn_1 = mkN "triton" "tritoner" ;
  triumf_nn_1 = mkN "triumf" "triumfer" ;
  triumfator_nn_1 = mkN "triumfator" "triumfatorer" ;
  triumfatorisk_av_1 = mkA "triumfatorisk" ;
  triumfbaage_nn_1 = mkN "triumfbеge" utrum ;
  triumvir_nn_1 = mkN "triumvir" "triumvirer" ;
  triumvirat_nn_1 = mkN "triumvirat" neutrum ;
  trivial_av_1 = mkA "trivial" ;
  trivialitet_nn_1 = mkN "trivialitet" "trivialiteter" ;
  trivialnamn_nn_1 = mkN "trivialnamn" neutrum ;
  trivsam_av_1 = mkA "trivsam" "trivsamt" "trivsamma" "trivsamma" "trivsammare" "trivsammast" "trivsammaste" ;
  troeg_av_1 = mkA "trцg" ;
  troegbedd_av_1 = mkA "trцgbedd" "trцgbedtt" ;
  troegdjur_nn_1 = mkN "trцgdjur" neutrum ;
  troegflytande_av_1 = mkA "trцgflytande" ;
  troeghet_nn_1 = mkN "trцghet" "trцgheter" ;
  troeghetsnavigering_nn_1 = mkN "trцghetsnavigering" ;
  troeglaest_av_1 = mkA "trцglдst" "trцglдst" ;
  troegtaenkt_av_1 = mkA "trцgtдnkt" "trцgtдnkt" ;
  troende_av_1 = mkA "troende" ;
  troeskel_nn_1 = mkN "trцskel" ;
  troeskelvaerde_nn_1 = mkN "trцskelvдrde" ;
  troeskverk_nn_1 = mkN "trцskverk" neutrum ;
  troest_nn_2 = mkN "trцst" ;
  troestare_nn_1 = mkN "trцstare" "trцstare" ;
  troestegrund_nn_1 = mkN "trцstegrund" "trцstegrunder" ;
  troesterik_av_1 = mkA "trцsterik" ;
  troestloes_av_1 = mkA "trцstlцs" ;
  troestmaal_nn_1 = mkN "trцstmеl" neutrum ;
  troestnapp_nn_1 = mkN "trцstnapp" ;
  troestpris_nn_1 = mkN "trцstpris" neutrum ;
  troett_av_1 = mkA "trцtt" ;
  troetthet_nn_1 = mkN "trцtthet" "trцttheter" ;
  troettkoerd_av_1 = mkA "trцttkцrd" "trцttkцrt" ;
  troettsam_av_1 = mkA "trцttsam" "trцttsamt" "trцttsamma" "trцttsamma" "trцttsammare" "trцttsammast" "trцttsammaste" ;
  trofast_av_1 = mkA "trofast" "trofast" ;
  trofasthet_nn_1 = mkN "trofasthet" "trofastheter" ;
  trofe_nn_1 = mkN "trofй" "trofйer" ;
  trogen_av_1 = mkA "trogen" "troget" ;
  troglodyt_nn_1 = mkN "troglodyt" "troglodyter" ;
  trohet_nn_1 = mkN "trohet" "troheter" ;
  trohetsed_nn_1 = mkN "trohetsed" "trohetseder" ;
  trohjaertenhet_nn_1 = mkN "trohjдrtenhet" "trohjдrtenheter" ;
  trojan_nn_1 = mkN "trojan" "trojaner" ;
  trojansk_av_1 = mkA "trojansk" ;
  trojeborg_nn_1 = mkN "trojeborg" ;
  trokaisk_av_1 = mkA "trokaisk" ;
  troke_nn_1 = mkN "trokй" "trokйer" ;
  trokeisk_av_1 = mkA "trokйisk" ;
  trolig_av_1 = mkA "trolig" ;
  troligen_ab_1 = mkAdv "troligen" ;
  troligtvis_ab_1 = mkAdv "troligtvis" ;
  troll_nn_1 = mkN "troll" neutrum ;
  trollbaer_nn_1 = mkN "trollbдr" neutrum ;
  trollbarn_nn_1 = mkN "trollbarn" neutrum ;
  trollbinda_vb_1 = mkV "trollbinda" "trollband" "trollbundit" ;
  trolldeg_nn_1 = mkN "trolldeg" ;
  trolldom_nn_1 = mkN "trolldom" ;
  trolldomsrit_nn_1 = mkN "trolldomsrit" "trolldomsriter" ;
  trolldryck_nn_1 = mkN "trolldryck" "trolldrycker" ;
  trolleri_nn_1 = mkN "trolleri" "trollerit" "trollerier" "trollerierna" ;
  trollerikonst_nn_1 = mkN "trollerikonst" "trollerikonster" ;
  trolleybuss_nn_1 = mkN "trolleybuss" ;
  trollformel_nn_1 = mkN "trollformel" "trollformeln" "trollformler" "trollformlerna" ;
  trollhare_nn_1 = mkN "trollhare" utrum ;
  trollkaering_nn_1 = mkN "trollkдring" ;
  trollkarl_nn_1 = mkN "trollkarl" ;
  trollkonst_nn_1 = mkN "trollkonst" "trollkonster" ;
  trollkonstnaer_nn_1 = mkN "trollkonstnдr" "trollkonstnдrer" ;
  trollkunnig_av_1 = mkA "trollkunnig" ;
  trollsaang_nn_1 = mkN "trollsеng" "trollsеnger" ;
  trollskott_nn_1 = mkN "trollskott" neutrum ;
  trollslag_nn_1 = mkN "trollslag" neutrum ;
  trollspoe_nn_1 = mkN "trollspц" "trollspцet" "trollspцn" "trollspцna" ;
  trollstav_nn_1 = mkN "trollstav" ;
  troloes_av_1 = mkA "trolцs" ;
  troloeshet_nn_1 = mkN "trolцshet" "trolцsheter" ;
  trolovning_nn_1 = mkN "trolovning" ;
  trolovningsbarn_nn_1 = mkN "trolovningsbarn" neutrum ;
  trolsk_av_1 = mkA "trolsk" ;
  troman_nn_1 = mkN "troman" "tromannen" "tromдn" "tromдnnen" ;
  tromb_nn_1 = mkN "tromb" "tromber" ;
  trombocyt_nn_1 = mkN "trombocyt" "trombocyter" ;
  trombon_nn_1 = mkN "trombon" "tromboner" ;
  trombonist_nn_1 = mkN "trombonist" "trombonister" ;
  trombos_nn_1 = mkN "trombos" "tromboser" ;
  tromla_nn_1 = mkN "tromla" ;
  tron_nn_1 = mkN "tron" "troner" ;
  tronarvinge_nn_1 = mkN "tronarvinge" utrum ;
  tronavsaegelse_nn_1 = mkN "tronavsдgelse" "tronavsдgelser" ;
  tronbestigning_nn_1 = mkN "tronbestigning" ;
  tronfoeljare_nn_1 = mkN "tronfцljare" "tronfцljare" ;
  tronfoeljd_nn_1 = mkN "tronfцljd" "tronfцljder" ;
  tronfoeljerska_nn_1 = mkN "tronfцljerska" ;
  tronhimmel_nn_1 = mkN "tronhimmel" ;
  tronpretendent_nn_1 = mkN "tronpretendent" "tronpretendenter" ;
  tronsal_nn_1 = mkN "tronsal" ;
  tronskifte_nn_1 = mkN "tronskifte" ;
  trontal_nn_1 = mkN "trontal" "trontalet" "trontalen" "trontalena" ;
  trontilltraede_nn_1 = mkN "trontilltrдde" ;
  trop_nn_1 = mkN "trop" "troper" ;
  tropik_nn_1 = mkN "tropik" "tropiker" ;
  tropikfaagel_nn_1 = mkN "tropikfеgel" ;
  tropikhjaelm_nn_1 = mkN "tropikhjдlm" ;
  tropisk_av_1 = mkA "tropisk" ;
  tropism_nn_1 = mkN "tropism" "tropismer" ;
  troposfaer_nn_1 = mkN "troposfдr" "troposfдrer" ;
  tropp_nn_1 = mkN "tropp" ;
  trosartikel_nn_1 = mkN "trosartikel" ;
  trosbekaennare_nn_1 = mkN "trosbekдnnare" "trosbekдnnare" ;
  trosbekaennelse_nn_1 = mkN "trosbekдnnelse" "trosbekдnnelser" ;
  trosfast_av_1 = mkA "trosfast" "trosfast" ;
  trosfraende_nn_1 = mkN "trosfrдnde" "trosfrдnder" ;
  trosfrihet_nn_1 = mkN "trosfrihet" "trosfriheter" ;
  trosgoerdel_nn_1 = mkN "trosgцrdel" ;
  trosivrare_nn_1 = mkN "trosivrare" "trosivrare" ;
  troskyldig_av_1 = mkA "troskyldig" ;
  trosroerelse_nn_1 = mkN "trosrцrelse" "trosrцrelser" ;
  tross_nn_1 = mkN "tross" ;
  trossamfund_nn_1 = mkN "trossamfund" neutrum ;
  trossats_nn_1 = mkN "trossats" "trossatser" ;
  trossbotten_nn_1 = mkN "trossbotten" ;
  trossdaeck_nn_1 = mkN "trossdдck" neutrum ;
  trossfyllning_nn_1 = mkN "trossfyllning" ;
  trosslagen_av_1 = mkA "trosslagen" "trosslaget" ;
  trossning_nn_1 = mkN "trossning" ;
  trosviss_av_1 = mkA "trosviss" ;
  trotjaenare_nn_1 = mkN "trotjдnare" "trotjдnare" ;
  trotsaalder_nn_1 = mkN "trotsеlder" ;
  trotsig_av_1 = mkA "trotsig" ;
  trotskist_nn_1 = mkN "trotskist" "trotskister" ;
  trottoar_nn_1 = mkN "trottoar" "trottoarer" ;
  trottoarbonde_nn_1 = mkN "trottoarbonde" "trottoarbцnder" ;
  trottoarservering_nn_1 = mkN "trottoarservering" ;
  trovaerd_av_1 = mkA "trovдrd" "trovдrt" ;
  trovaerdig_av_1 = mkA "trovдrdig" ;
  trubadur_nn_1 = mkN "trubadur" "trubadurer" ;
  trubbel_nn_1 = mkN "trubbel" neutrum ;
  trubbig_av_1 = mkA "trubbig" ;
  trubbnaest_av_1 = mkA "trubbnдst" "trubbnдst" ;
  trubbnos_nn_1 = mkN "trubbnos" ;
  trubbnosig_av_1 = mkA "trubbnosig" ;
  trubbvinklig_av_1 = mkA "trubbvinklig" ;
  truck_nn_1 = mkN "truck" ;
  trudelutt_nn_1 = mkN "trudelutt" "trudelutter" ;
  truism_nn_1 = mkN "truism" "truismer" ;
  truistisk_av_1 = mkA "truistisk" ;
  trulig_av_1 = mkA "trulig" ;
  truls_nn_1 = mkN "truls" ;
  trulsig_av_1 = mkA "trulsig" ;
  trumf_nn_1 = mkN "trumf" ;
  trumfkort_nn_1 = mkN "trumfkort" neutrum ;
  trumfmatt_av_1 = mkA "trumfmatt" ;
  trumhinna_nn_1 = mkN "trumhinna" ;
  trumminne_nn_1 = mkN "trumminne" ;
  trumpen_av_1 = mkA "trumpen" "trumpet" ;
  trumpet_nn_1 = mkN "trumpet" "trumpeter" ;
  trumpetare_nn_1 = mkN "trumpetare" "trumpetare" ;
  trumpetstoet_nn_1 = mkN "trumpetstцt" ;
  trumpinne_nn_1 = mkN "trumpinne" utrum ;
  trumslagare_nn_1 = mkN "trumslagare" "trumslagare" ;
  trumstock_nn_1 = mkN "trumstock" ;
  trumvirvel_nn_1 = mkN "trumvirvel" ;
  trunk_nn_1 = mkN "trunk" ;
  trunkmaskin_nn_1 = mkN "trunkmaskin" "trunkmaskiner" ;
  trupp_nn_1 = mkN "trupp" "trupper" ;
  truppfoerband_nn_1 = mkN "truppfцrband" neutrum ;
  truppfoerflyttning_nn_1 = mkN "truppfцrflyttning" ;
  trupproerelse_nn_1 = mkN "trupprцrelse" "trupprцrelser" ;
  truppslag_nn_1 = mkN "truppslag" neutrum ;
  truppstyrka_nn_1 = mkN "truppstyrka" ;
  trust_nn_1 = mkN "trust" "truster" ;
  trut_nn_1 = mkN "trut" ;
  tryck_nn_1 = mkN "tryck" neutrum ;
  tryckaar_nn_1 = mkN "tryckеr" neutrum ;
  tryckaccent_nn_1 = mkN "tryckaccent" "tryckaccenter" ;
  tryckalster_nn_1 = mkN "tryckalster" neutrum ;
  tryckande_av_1 = mkA "tryckande" ;
  tryckare_nn_1 = mkN "tryckare" "tryckare" ;
  tryckbar_av_1 = mkA "tryckbar" ;
  tryckbehaallare_nn_1 = mkN "tryckbehеllare" "tryckbehеllare" ;
  tryckbokstav_nn_1 = mkN "tryckbokstav" "tryckbokstдver" ;
  tryckbraennare_nn_1 = mkN "tryckbrдnnare" "tryckbrдnnare" ;
  tryckdraekt_nn_1 = mkN "tryckdrдkt" "tryckdrдkter" ;
  tryckeri_nn_1 = mkN "tryckeri" "tryckerit" "tryckerier" "tryckerierna" ;
  tryckfaerg_nn_1 = mkN "tryckfдrg" "tryckfдrger" ;
  tryckfel_nn_1 = mkN "tryckfel" "tryckfelet" "tryckfel" "tryckfelen" ;
  tryckfelsnisse_nn_1 = mkN "tryckfelsnisse" utrum ;
  tryckfoerband_nn_1 = mkN "tryckfцrband" neutrum ;
  tryckform_nn_1 = mkN "tryckform" ;
  tryckfrihet_nn_1 = mkN "tryckfrihet" "tryckfriheter" ;
  tryckkabin_nn_1 = mkN "tryckkabin" "tryckkabiner" ;
  tryckkaerl_nn_1 = mkN "tryckkдrl" neutrum ;
  tryckkammare_nn_1 = mkN "tryckkammare" "tryckkammaren" "tryckkamrar" "tryckkamrarna" ;
  tryckknapp_nn_1 = mkN "tryckknapp" ;
  tryckkokare_nn_1 = mkN "tryckkokare" "tryckkokare" ;
  tryckkontakt_nn_1 = mkN "tryckkontakt" "tryckkontakter" ;
  tryckluftsapparat_nn_1 = mkN "tryckluftsapparat" "tryckluftsapparater" ;
  tryckmetod_nn_1 = mkN "tryckmetod" "tryckmetoder" ;
  tryckning_nn_1 = mkN "tryckning" ;
  tryckoekning_nn_1 = mkN "tryckцkning" ;
  tryckord_nn_1 = mkN "tryckord" neutrum ;
  tryckort_nn_1 = mkN "tryckort" "tryckorter" ;
  tryckpress_nn_1 = mkN "tryckpress" ;
  tryckpunkt_nn_1 = mkN "tryckpunkt" "tryckpunkter" ;
  trycksaeker_av_1 = mkA "trycksдker" "trycksдkert" "trycksдkra" "trycksдkra" "trycksдkrare" "trycksдkrast" "trycksдkraste" ;
  trycksak_nn_1 = mkN "trycksak" "trycksaker" ;
  trycksats_nn_1 = mkN "trycksats" "trycksatser" ;
  tryckstark_av_1 = mkA "tryckstark" ;
  tryckstil_nn_1 = mkN "tryckstil" ;
  tryckstyrka_nn_1 = mkN "tryckstyrka" ;
  trycksvag_av_1 = mkA "trycksvag" ;
  tryckt_av_1 = mkA "tryckt" "tryckt" ;
  trycktyp_nn_1 = mkN "trycktyp" "trycktyper" ;
  tryckvattenreaktor_nn_1 = mkN "tryckvattenreaktor" "tryckvattenreaktorer" ;
  tryffel_nn_1 = mkN "tryffel" ;
  tryffelsvamp_nn_1 = mkN "tryffelsvamp" ;
  trygg_av_1 = mkA "trygg" ;
  trygghet_nn_1 = mkN "trygghet" "tryggheter" ;
  trygghetsfoersaekring_nn_1 = mkN "trygghetsfцrsдkring" ;
  trygghetsnarkoman_nn_1 = mkN "trygghetsnarkoman" "trygghetsnarkomaner" ;
  trymaa_nn_1 = mkN "trymе" "trymеer" ;
  trypsin_nn_1 = mkN "trypsin" "trypsiner" ;
  tsar_nn_1 = mkN "tsar" "tsarer" ;
  tsardotter_nn_1 = mkN "tsardotter" "tsardottern" "tsardцttrar" "tsardцttrarna" ;
  tsarfamilj_nn_1 = mkN "tsarfamilj" "tsarfamiljer" ;
  tub_nn_1 = mkN "tub" "tuber" ;
  tuberkel_nn_1 = mkN "tuberkel" "tuberkeln" "tuberkler" "tuberklerna" ;
  tuberkelbakterie_nn_1 = mkN "tuberkelbakterie" "tuberkelbakterier" ;
  tuberkulin_nn_1 = mkN "tuberkulin" "tuberkuliner" ;
  tuberkuloes_av_1 = mkA "tuberkulцs" ;
  tubkanon_nn_1 = mkN "tubkanon" "tubkanoner" ;
  tubkikare_nn_1 = mkN "tubkikare" "tubkikare" ;
  tubroer_nn_1 = mkN "tubrцr" neutrum ;
  tudelning_nn_1 = mkN "tudelning" ;
  tuff_av_1 = mkA "tuff" ;
  tuff_nn_1 = mkN "tuff" "tuffer" ;
  tuffing_nn_1 = mkN "tuffing" ;
  tufsig_av_1 = mkA "tufsig" ;
  tuggbuss_nn_1 = mkN "tuggbuss" ;
  tuggmuskel_nn_1 = mkN "tuggmuskel" "tuggmuskeln" "tuggmuskler" "tuggmusklerna" ;
  tuggummi_nn_1 = mkN "tuggummi" "tuggummit" "tuggummin" "tuggummina" ;
  tukthus_nn_1 = mkN "tukthus" neutrum ;
  tuktig_av_1 = mkA "tuktig" ;
  tulkoert_nn_1 = mkN "tulkцrt" "tulkцrter" ;
  tull_nn_1 = mkN "tull" ;
  tullare_nn_1 = mkN "tullare" "tullare" ;
  tullavgift_nn_1 = mkN "tullavgift" "tullavgifter" ;
  tullbesiktning_nn_1 = mkN "tullbesiktning" ;
  tulldeklaration_nn_1 = mkN "tulldeklaration" "tulldeklarationer" ;
  tullfri_av_1 = mkA "tullfri" "tullfritt" ;
  tullmur_nn_1 = mkN "tullmur" ;
  tullnaer_nn_1 = mkN "tullnдr" "tullnдrer" ;
  tullpass_nn_1 = mkN "tullpass" neutrum ;
  tullpliktig_av_1 = mkA "tullpliktig" ;
  tullskydd_nn_1 = mkN "tullskydd" neutrum ;
  tulltjaensteman_nn_1 = mkN "tulltjдnsteman" "tulltjдnstemannen" "tulltjдnstemдn" "tulltjдnstemдnnen" ;
  tullunion_nn_1 = mkN "tullunion" "tullunioner" ;
  tullverk_nn_1 = mkN "tullverk" neutrum ;
  tullvisitation_nn_1 = mkN "tullvisitation" "tullvisitationer" ;
  tulpan_nn_1 = mkN "tulpan" "tulpaner" ;
  tulpanloek_nn_1 = mkN "tulpanlцk" ;
  tulpantraed_nn_1 = mkN "tulpantrдd" neutrum ;
  tum_nn_1 = mkN "tum" "tummen" "tum" "tummen" ;
  tumgrepp_nn_1 = mkN "tumgrepp" neutrum ;
  tumlare_nn_1 = mkN "tumlare" "tumlare" ;
  tumme_nn_1 = mkN "tumme" utrum ;
  tummelplats_nn_1 = mkN "tummelplats" "tummelplatser" ;
  tummetott_nn_1 = mkN "tummetott" ;
  tumoer_nn_1 = mkN "tumцr" "tumцrer" ;
  tumregel_nn_1 = mkN "tumregel" "tumregeln" "tumregler" "tumreglerna" ;
  tumskruv_nn_1 = mkN "tumskruv" ;
  tumstock_nn_1 = mkN "tumstock" ;
  tumsugare_nn_1 = mkN "tumsugare" "tumsugare" ;
  tumult_nn_1 = mkN "tumult" neutrum ;
  tumultuarisk_av_1 = mkA "tumultuarisk" ;
  tumvante_nn_1 = mkN "tumvante" utrum ;
  tumveck_nn_1 = mkN "tumveck" neutrum ;
  tun_nn_1 = mkN "tun" neutrum ;
  tuner_nn_1 = mkN "tuner" "tunern" "tuner" "tunerna" ;
  tung_av_1 = mkA "tung" "tyngre" "tyngst" ;
  tunga_nn_1 = mkN "tunga" ;
  tungband_nn_1 = mkN "tungband" neutrum ;
  tungben_nn_1 = mkN "tungben" neutrum ;
  tungkoerd_av_1 = mkA "tungkцrd" "tungkцrt" ;
  tunglaest_av_1 = mkA "tunglдst" "tunglдst" ;
  tungljud_nn_1 = mkN "tungljud" neutrum ;
  tungmetall_nn_1 = mkN "tungmetall" "tungmetaller" ;
  tungoert_nn_1 = mkN "tungцrt" "tungцrter" ;
  tungomaal_nn_1 = mkN "tungomеl" neutrum ;
  tungomaalstalande_av_1 = mkA "tungomеlstalande" ;
  tungomaalstalare_nn_1 = mkN "tungomеlstalare" "tungomеlstalare" ;
  tungrodd_av_1 = mkA "tungrodd" "tungrodtt" ;
  tungrygg_nn_1 = mkN "tungrygg" ;
  tungsam_av_1 = mkA "tungsam" "tungsamt" "tungsamma" "tungsamma" "tungsammare" "tungsammast" "tungsammaste" ;
  tungsida_nn_1 = mkN "tungsida" ;
  tungsint_av_1 = mkA "tungsint" "tungsint" ;
  tungsinthet_nn_1 = mkN "tungsinthet" "tungsintheter" ;
  tungsoevd_av_1 = mkA "tungsцvd" "tungsцvt" ;
  tungspene_nn_1 = mkN "tungspene" utrum ;
  tungspets_nn_1 = mkN "tungspets" ;
  tungus_nn_1 = mkN "tungus" "tunguser" ;
  tungvattenreaktor_nn_1 = mkN "tungvattenreaktor" "tungvattenreaktorer" ;
  tungviktare_nn_1 = mkN "tungviktare" "tungviktare" ;
  tunik_nn_1 = mkN "tunik" "tuniker" ;
  tunisier_nn_1 = mkN "tunisier" "tunisiern" "tunisier" "tunisierna" ;
  tunisisk_av_1 = mkA "tunisisk" ;
  tunisiska_nn_1 = mkN "tunisiska" ;
  tunn_av_1 = mkA "tunn" "tunt" ;
  tunnband_nn_1 = mkN "tunnband" neutrum ;
  tunnbindare_nn_1 = mkN "tunnbindare" "tunnbindare" ;
  tunnbinderi_nn_1 = mkN "tunnbinderi" "tunnbinderit" "tunnbinderier" "tunnbinderierna" ;
  tunnbladig_av_1 = mkA "tunnbladig" ;
  tunnbroed_nn_1 = mkN "tunnbrцd" neutrum ;
  tunnel_nn_1 = mkN "tunnel" ;
  tunneldiod_nn_1 = mkN "tunneldiod" "tunneldioder" ;
  tunneleffekt_nn_1 = mkN "tunneleffekt" "tunneleffekter" ;
  tunnelugn_nn_1 = mkN "tunnelugn" ;
  tunnhaarig_av_1 = mkA "tunnhеrig" ;
  tunnklaedd_av_1 = mkA "tunnklдdd" "tunnklдdtt" ;
  tunnland_nn_1 = mkN "tunnland" neutrum ;
  tunnsaadd_av_1 = mkA "tunnsеdd" "tunnsеdtt" ;
  tunnsliten_av_1 = mkA "tunnsliten" "tunnslitet" ;
  tunnstav_nn_1 = mkN "tunnstav" ;
  tunntarm_nn_1 = mkN "tunntarm" ;
  tunnvalv_nn_1 = mkN "tunnvalv" neutrum ;
  tupe_nn_1 = mkN "tupй" "tupйer" ;
  tupp_nn_1 = mkN "tupp" ;
  tuppfaektning_nn_1 = mkN "tuppfдktning" ;
  tuppfjaet_nn_1 = mkN "tuppfjдt" neutrum ;
  tuppkam_nn_1 = mkN "tuppkam" "tuppkammen" "tuppkammar" "tuppkammarna" ;
  tuppkyckling_nn_1 = mkN "tuppkyckling" ;
  tupplur_nn_1 = mkN "tupplur" ;
  tur_nn_1 = mkN "tur" "turer" ;
  turban_nn_1 = mkN "turban" "turbaner" ;
  turbin_nn_1 = mkN "turbin" "turbiner" ;
  turbinmotor_nn_1 = mkN "turbinmotor" "turbinmotorer" ;
  turbojetmotor_nn_1 = mkN "turbojetmotor" "turbojetmotorer" ;
  turbojetplan_nn_1 = mkN "turbojetplan" neutrum ;
  turbomotor_nn_1 = mkN "turbomotor" "turbomotorer" ;
  turbopropmotor_nn_1 = mkN "turbopropmotor" "turbopropmotorer" ;
  turbulent_av_1 = mkA "turbulent" "turbulent" ;
  turist_nn_1 = mkN "turist" "turister" ;
  turistbroschyr_nn_1 = mkN "turistbroschyr" "turistbroschyrer" ;
  turistbyraa_nn_1 = mkN "turistbyrе" "turistbyrеer" ;
  turistfoerening_nn_1 = mkN "turistfцrening" ;
  turistinformation_nn_1 = mkN "turistinformation" "turistinformationer" ;
  turistisk_av_1 = mkA "turistisk" ;
  turistklass_nn_1 = mkN "turistklass" "turistklasser" ;
  turistland_nn_1 = mkN "turistland" "turistlandet" "turistlдnder" "turistlдnderna" ;
  turistnaering_nn_1 = mkN "turistnдring" ;
  turistsaeng_nn_1 = mkN "turistsдng" ;
  turiststation_nn_1 = mkN "turiststation" "turiststationer" ;
  turiststroem_nn_1 = mkN "turiststrцm" "turiststrцmmen" "turiststrцmmar" "turiststrцmmarna" ;
  turiststuga_nn_1 = mkN "turiststuga" ;
  turistvaluta_nn_1 = mkN "turistvaluta" ;
  turk_nn_1 = mkN "turk" ;
  turkcypriot_nn_1 = mkN "turkcypriot" "turkcyprioter" ;
  turkfolk_nn_1 = mkN "turkfolk" neutrum ;
  turkisk_av_1 = mkA "turkisk" ;
  turkiska_nn_2 = mkN "turkiska" ;
  turkmen_nn_1 = mkN "turkmen" "turkmener" ;
  turkos_av_1 = mkA "turkos" ;
  turkos_nn_1 = mkN "turkos" "turkoser" ;
  turkosblaa_av_1 = mkA "turkosblе" "turkosblеtt" ;
  turlig_av_1 = mkA "turlig" ;
  turmalin_nn_1 = mkN "turmalin" "turmaliner" ;
  turne_nn_1 = mkN "turnй" "turnйer" ;
  turnering_nn_1 = mkN "turnering" ;
  turnyr_nn_1 = mkN "turnyr" "turnyrer" ;
  turochreturbiljett_nn_1 = mkN "turochreturbiljett" "turochreturbiljetter" ;
  turordning_nn_1 = mkN "turordning" ;
  turs_nn_1 = mkN "turs" ;
  tursam_av_1 = mkA "tursam" "tursamt" "tursamma" "tursamma" "tursammare" "tursammast" "tursammaste" ;
  tuschteckning_nn_1 = mkN "tuschteckning" ;
  tusenaarig_av_1 = mkA "tusenеrig" ;
  tusenaarsrike_nn_1 = mkN "tusenеrsrike" ;
  tusende_nn_1 = mkN "tusende" ;
  tusendel_nn_1 = mkN "tusendel" "tusendelen" "tusendelar" "tusendelarna" ;
  tusenfalt_ab_1 = mkAdv "tusenfalt" ;
  tusenfoting_nn_1 = mkN "tusenfoting" ;
  tusenkonstnaer_nn_1 = mkN "tusenkonstnдr" "tusenkonstnдrer" ;
  tusenkronorssedel_nn_1 = mkN "tusenkronorssedel" ;
  tusenlapp_nn_1 = mkN "tusenlapp" ;
  tusental_nn_1 = mkN "tusental" "tusentalet" "tusentalen" "tusentalena" ;
  tusentals_ab_1 = mkAdv "tusentals" ;
  tuss_nn_1 = mkN "tuss" ;
  tussilago_nn_1 = mkN "tussilago" "tussilagor" ;
  tut_nn_1 = mkN "tut" ;
  tut_nn_2 = mkN "tut" neutrum ;
  tuting_nn_1 = mkN "tuting" ;
  tutt_nn_1 = mkN "tutt" ;
  tutti_nn_1 = mkN "tutti" "tuttit" "tuttin" "tuttina" ;
  tuvaluan_nn_1 = mkN "tuvaluan" "tuvaluaner" ;
  tuvig_av_1 = mkA "tuvig" ;
  tuvtaatel_nn_1 = mkN "tuvtеtel" ;
  tvaaaarig_av_1 = mkA "tvееrig" ;
  tvaaaaring_nn_1 = mkN "tvееring" ;
  tvaaaeggstvilling_nn_1 = mkN "tvедggstvilling" ;
  tvaabent_av_1 = mkA "tvеbent" "tvеbent" ;
  tvaablad_nn_1 = mkN "tvеblad" neutrum ;
  tvaabyggare_nn_1 = mkN "tvеbyggare" "tvеbyggare" ;
  tvaacylindrig_av_1 = mkA "tvеcylindrig" ;
  tvaadimensionell_av_1 = mkA "tvеdimensionell" ;
  tvaaendel_nn_1 = mkN "tvеendel" "tvеendelen" "tvеendelar" "tvеendelarna" ;
  tvaafamiljshus_nn_1 = mkN "tvеfamiljshus" neutrum ;
  tvaaformig_av_1 = mkA "tvеformig" ;
  tvaafrontskrig_nn_1 = mkN "tvеfrontskrig" neutrum ;
  tvaahaendig_av_1 = mkA "tvеhдndig" ;
  tvaahjaertbladig_av_1 = mkA "tvеhjдrtbladig" ;
  tvaahjuling_nn_1 = mkN "tvеhjuling" ;
  tvaal_nn_1 = mkN "tvеl" ;
  tvaalaeppig_av_1 = mkA "tvеlдppig" ;
  tvaalask_nn_1 = mkN "tvеlask" ;
  tvaalfager_av_1 = mkA "tvеlfager" "tvеlfagert" "tvеlfagra" "tvеlfagra" "tvеlfagrare" "tvеlfagrast" "tvеlfagraste" ;
  tvaalig_av_1 = mkA "tvеlig" ;
  tvaalkopp_nn_1 = mkN "tvеlkopp" ;
  tvaalopera_nn_1 = mkN "tvеlopera" ;
  tvaamaenning_nn_1 = mkN "tvеmдnning" ;
  tvaamans_av_1 = mkA "tvеmans" ;
  tvaamastare_nn_1 = mkN "tvеmastare" "tvеmastare" ;
  tvaangsaatgaerd_nn_1 = mkN "tvеngsеtgдrd" "tvеngsеtgдrder" ;
  tvaangsfoerestaellning_nn_1 = mkN "tvеngsfцrestдllning" ;
  tvaangsintagning_nn_1 = mkN "tvеngsintagning" ;
  tvaangslaege_nn_1 = mkN "tvеngslдge" ;
  tvaangslag_nn_1 = mkN "tvеngslag" ;
  tvaangsmaessig_av_1 = mkA "tvеngsmдssig" ;
  tvaangsmedel_nn_1 = mkN "tvеngsmedel" neutrum ;
  tvaangsneuros_nn_1 = mkN "tvеngsneuros" "tvеngsneuroser" ;
  tvaangsrekrytering_nn_1 = mkN "tvеngsrekrytering" ;
  tvaangssituation_nn_1 = mkN "tvеngssituation" "tvеngssituationer" ;
  tvaangstanke_nn_1 = mkN "tvеngstanke" utrum ;
  tvaangstroeja_nn_1 = mkN "tvеngstrцja" ;
  tvaangsvis_ab_1 = mkAdv "tvеngsvis" ;
  tvaaoering_nn_1 = mkN "tvецring" ;
  tvaaondel_nn_1 = mkN "tvеondel" "tvеondelen" "tvеondelar" "tvеondelarna" ;
  tvaarading_nn_1 = mkN "tvеrading" ;
  tvaarummare_nn_1 = mkN "tvеrummare" "tvеrummare" ;
  tvaarumslaegenhet_nn_1 = mkN "tvеrumslдgenhet" "tvеrumslдgenheter" ;
  tvaasamhet_nn_1 = mkN "tvеsamhet" "tvеsamheter" ;
  tvaasiffrig_av_1 = mkA "tvеsiffrig" ;
  tvaaspaend_av_1 = mkA "tvеspдnd" ;
  tvaaspann_nn_1 = mkN "tvеspann" neutrum ;
  tvaaspraakig_av_1 = mkA "tvеsprеkig" ;
  tvaastavig_av_1 = mkA "tvеstavig" ;
  tvaastavighetsaccent_nn_1 = mkN "tvеstavighetsaccent" "tvеstavighetsaccenter" ;
  tvaastruken_av_1 = mkA "tvеstruken" "tvеstruket" ;
  tvaataktare_nn_1 = mkN "tvеtaktare" "tvеtaktare" ;
  tvaataktsmotor_nn_1 = mkN "tvеtaktsmotor" "tvеtaktsmotorer" ;
  tvaavaaningsbuss_nn_1 = mkN "tvеvеningsbuss" ;
  tvaavinge_nn_1 = mkN "tvеvinge" utrum ;
  tvaer_av_1 = mkA "tvдr" ;
  tvaerarg_av_1 = mkA "tvдrarg" ;
  tvaeraxel_nn_1 = mkN "tvдraxel" ;
  tvaerbalk_nn_1 = mkN "tvдrbalk" ;
  tvaerbjaelke_nn_1 = mkN "tvдrbjдlke" utrum ;
  tvaerbrant_av_1 = mkA "tvдrbrant" "tvдrbrant" ;
  tvaerfacklig_av_1 = mkA "tvдrfacklig" ;
  tvaerfloejt_nn_1 = mkN "tvдrflцjt" "tvдrflцjter" ;
  tvaergaaende_av_1 = mkA "tvдrgеende" ;
  tvaerhuggen_av_1 = mkA "tvдrhuggen" "tvдrhugget" ;
  tvaerilsken_av_1 = mkA "tvдrilsken" "tvдrilsket" ;
  tvaermaett_av_1 = mkA "tvдrmдtt" ;
  tvaernit_nn_1 = mkN "tvдrnit" ;
  tvaerpolitisk_av_1 = mkA "tvдrpolitisk" ;
  tvaerrandig_av_1 = mkA "tvдrrandig" ;
  tvaers_ab_1 = mkAdv "tvдrs" ;
  tvaersaeker_av_1 = mkA "tvдrsдker" "tvдrsдkert" "tvдrsдkra" "tvдrsдkra" "tvдrsдkrare" "tvдrsдkrast" "tvдrsдkraste" ;
  tvaersemot_ab_1 = mkAdv "tvдrsemot" ;
  tvaersigenom_ab_1 = mkAdv "tvдrsigenom" ;
  tvaerskepp_nn_1 = mkN "tvдrskepp" neutrum ;
  tvaerskepps_ab_1 = mkAdv "tvдrskepps" ;
  tvaerskuren_av_1 = mkA "tvдrskuren" "tvдrskuret" ;
  tvaerslaa_nn_1 = mkN "tvдrslе" ;
  tvaersnitt_nn_1 = mkN "tvдrsnitt" neutrum ;
  tvaersoever_ab_1 = mkAdv "tvдrsцver" ;
  tvaersom_ab_1 = mkAdv "tvдrsom" ;
  tvaerstopp_nn_1 = mkN "tvдrstopp" neutrum ;
  tvaerstreck_nn_1 = mkN "tvдrstreck" neutrum ;
  tvaerstup_nn_1 = mkN "tvдrstup" neutrum ;
  tvaertemot_ab_1 = mkAdv "tvдrtemot" ;
  tvaertom_ab_1 = mkAdv "tvдrtom" ;
  tvaervetenskap_nn_1 = mkN "tvдrvetenskap" "tvдrvetenskaper" ;
  tvaervetenskaplig_av_1 = mkA "tvдrvetenskaplig" ;
  tvaervigg_nn_1 = mkN "tvдrvigg" ;
  tvaett_nn_1 = mkN "tvдtt" ;
  tvaettaekta_av_1 = mkA "tvдttдkta" ;
  tvaettbar_av_1 = mkA "tvдttbar" ;
  tvaettbar_nn_1 = mkN "tvдttbar" "tvдttbarer" ;
  tvaettbjoern_nn_1 = mkN "tvдttbjцrn" ;
  tvaettbraede_nn_1 = mkN "tvдttbrдde" ;
  tvaetteri_nn_1 = mkN "tvдtteri" "tvдtterit" "tvдtterier" "tvдtterierna" ;
  tvaettfat_nn_1 = mkN "tvдttfat" neutrum ;
  tvaettinraettning_nn_1 = mkN "tvдttinrдttning" ;
  tvaettkorg_nn_1 = mkN "tvдttkorg" ;
  tvaettlapp_nn_1 = mkN "tvдttlapp" ;
  tvaettmaskin_nn_1 = mkN "tvдttmaskin" "tvдttmaskiner" ;
  tvaettmedel_nn_1 = mkN "tvдttmedel" neutrum ;
  tvaettomat_nn_1 = mkN "tvдttomat" "tvдttomater" ;
  tvaettpulver_nn_1 = mkN "tvдttpulver" neutrum ;
  tvaettstaell_nn_1 = mkN "tvдttstдll" neutrum ;
  tvaettstuga_nn_1 = mkN "tvдttstuga" ;
  tvaettsvamp_nn_1 = mkN "tvдttsvamp" ;
  tvaettvatten_nn_1 = mkN "tvдttvatten" "tvдttvattnet" "tvдttvatten" "tvдttvattnen" ;
  tvagning_nn_1 = mkN "tvagning" ;
  tvehaagsen_av_1 = mkA "tvehеgsen" "tvehеgset" ;
  tvekamp_nn_1 = mkN "tvekamp" "tvekamper" ;
  tvekloes_av_1 = mkA "tveklцs" ;
  tveksam_av_1 = mkA "tveksam" "tveksamt" "tveksamma" "tveksamma" "tveksammare" "tveksammast" "tveksammaste" ;
  tveksamhet_nn_1 = mkN "tveksamhet" "tveksamheter" ;
  tvestjaert_nn_1 = mkN "tvestjдrt" ;
  tvetydig_av_1 = mkA "tvetydig" ;
  tvetydighet_nn_1 = mkN "tvetydighet" "tvetydigheter" ;
  tvilling_nn_1 = mkN "tvilling" ;
  tvillingkristall_nn_1 = mkN "tvillingkristall" "tvillingkristaller" ;
  tvillingmaskin_nn_1 = mkN "tvillingmaskin" "tvillingmaskiner" ;
  tvillingvagn_nn_1 = mkN "tvillingvagn" ;
  tving_nn_1 = mkN "tving" ;
  tvinga_vb_1 = mkV "tvinga" ;
  tvingande_av_1 = mkA "tvingande" ;
  tvinsjuk_av_1 = mkA "tvinsjuk" ;
  tvist_nn_1 = mkN "tvist" "tvister" ;
  tvistefraaga_nn_1 = mkN "tvistefrеga" ;
  tvistefroe_nn_1 = mkN "tvistefrц" "tvistefrцt" "tvistefrцn" "tvistefrцen" ;
  tvistemaal_nn_1 = mkN "tvistemеl" neutrum ;
  tvistig_av_1 = mkA "tvistig" ;
  tvistighet_nn_1 = mkN "tvistighet" "tvistigheter" ;
  tvistsoem_nn_1 = mkN "tvistsцm" "tvistsцmmen" "tvistsцmmar" "tvistsцmmarna" ;
  tvivel_nn_1 = mkN "tvivel" neutrum ;
  tvivelaktig_av_1 = mkA "tvivelaktig" ;
  tvivelsam_av_1 = mkA "tvivelsam" "tvivelsamt" "tvivelsamma" "tvivelsamma" "tvivelsammare" "tvivelsammast" "tvivelsammaste" ;
  tvivelsjuk_av_1 = mkA "tvivelsjuk" ;
  tvivelsutan_ab_1 = mkAdv "tvivelsutan" ;
  tvivlare_nn_1 = mkN "tvivlare" "tvivlare" ;
  tvungen_av_1 = mkA "tvungen" "tvunget" ;
  tyckare_nn_1 = mkN "tyckare" "tyckare" ;
  tyckmycken_av_1 = mkA "tyckmycken" "tyckmycket" ;
  tydbar_av_1 = mkA "tydbar" ;
  tydlig_av_1 = mkA "tydlig" ;
  tydligen_ab_1 = mkAdv "tydligen" ;
  tydlighet_nn_1 = mkN "tydlighet" "tydligheter" ;
  tydligtvis_ab_1 = mkAdv "tydligtvis" ;
  tyfoidbakterie_nn_1 = mkN "tyfoidbakterie" "tyfoidbakterier" ;
  tyfoidepidemi_nn_1 = mkN "tyfoidepidemi" "tyfoidepidemier" ;
  tyfon_nn_1 = mkN "tyfon" "tyfoner" ;
  tyg_nn_1 = mkN "tyg" neutrum ;
  tygband_nn_1 = mkN "tygband" neutrum ;
  tygbredd_nn_1 = mkN "tygbredd" "tygbredder" ;
  tygel_nn_1 = mkN "tygel" ;
  tygelloes_av_1 = mkA "tygellцs" ;
  tygkant_nn_1 = mkN "tygkant" "tygkanter" ;
  tyglapp_nn_1 = mkN "tyglapp" ;
  tygprov_nn_1 = mkN "tygprov" neutrum ;
  tygrest_nn_1 = mkN "tygrest" "tygrester" ;
  tygrulle_nn_1 = mkN "tygrulle" utrum ;
  tygsko_nn_1 = mkN "tygsko" "tygskor" ;
  tygtryck_nn_1 = mkN "tygtryck" neutrum ;
  tyken_av_1 = mkA "tyken" "tyket" ;
  tykobrahedag_nn_1 = mkN "tykobrahedag" ;
  tyllschal_nn_1 = mkN "tyllschal" ;
  tympanon_nn_1 = mkN "tympanon" "tympanoner" ;
  tyngd_nn_1 = mkN "tyngd" "tyngder" ;
  tyngdkraftsstoerning_nn_1 = mkN "tyngdkraftsstцrning" ;
  tyngdloes_av_1 = mkA "tyngdlцs" ;
  tyngdlyftare_nn_1 = mkN "tyngdlyftare" "tyngdlyftare" ;
  tyngdpunkt_nn_1 = mkN "tyngdpunkt" "tyngdpunkter" ;
  typ_ab_1 = mkAdv "typ" ;
  typ_nn_1 = mkN "typ" "typer" ;
  typbesiktning_nn_1 = mkN "typbesiktning" ;
  typbildande_av_1 = mkA "typbildande" ;
  typexempel_nn_1 = mkN "typexempel" neutrum ;
  typfall_nn_1 = mkN "typfall" neutrum ;
  typisk_av_1 = mkA "typisk" ;
  typograf_nn_1 = mkN "typograf" "typografer" ;
  typografi_nn_1 = mkN "typografi" "typografier" ;
  typografisk_av_1 = mkA "typografisk" ;
  typologi_nn_1 = mkN "typologi" "typologier" ;
  typsnitt_nn_1 = mkN "typsnitt" neutrum ;
  typvaerde_nn_1 = mkN "typvдrde" ;
  tyrann_nn_1 = mkN "tyrann" "tyranner" ;
  tyrannisk_av_1 = mkA "tyrannisk" ;
  tyristor_nn_1 = mkN "tyristor" "tyristorer" ;
  tyrolare_nn_1 = mkN "tyrolare" "tyrolare" ;
  tyrolerhatt_nn_1 = mkN "tyrolerhatt" ;
  tyrolsk_av_1 = mkA "tyrolsk" ;
  tyrolska_nn_1 = mkN "tyrolska" ;
  tysk_av_1 = mkA "tysk" ;
  tysk_nn_1 = mkN "tysk" ;
  tysk_romersk_av_1 = mkA "tysk-romersk" ;
  tysk_schweizisk_av_1 = mkA "tysk-schweizisk" ;
  tysk_svensk_av_1 = mkA "tysk-svensk" ;
  tyska_nn_2 = mkN "tyska" ;
  tyskhare_nn_1 = mkN "tyskhare" utrum ;
  tyskspraakig_av_1 = mkA "tysksprеkig" ;
  tyst_av_1 = mkA "tyst" "tyst" ;
  tysthet_nn_1 = mkN "tysthet" "tystheter" ;
  tysthetsloefte_nn_1 = mkN "tysthetslцfte" ;
  tystlaaten_av_1 = mkA "tystlеten" "tystlеtet" ;
  tystnad_nn_1 = mkN "tystnad" "tystnader" ;
  tyvaerr_ab_1 = mkAdv "tyvдrr" ;
  u_baat_nn_1 = mkN "u-bеt" ;
  u_formig_av_1 = mkA "u-formig" ;
  u_land_nn_1 = mkN "u-land" "u-landet" "u-lдnder" "u-lдnderna" ;
  ubaat_nn_1 = mkN "ubеt" ;
  ubaatsfoerstoerare_nn_1 = mkN "ubеtsfцrstцrare" "ubеtsfцrstцrare" ;
  ubaatsjagare_nn_1 = mkN "ubеtsjagare" "ubеtsjagare" ;
  ubaatsjakt_nn_1 = mkN "ubеtsjakt" "ubеtsjakter" ;
  ubaatsjaktfartyg_nn_1 = mkN "ubеtsjaktfartyg" neutrum ;
  ubaatsnaet_nn_1 = mkN "ubеtsnдt" neutrum ;
  ubikvist_nn_1 = mkN "ubikvist" "ubikvister" ;
  ubikvitet_nn_1 = mkN "ubikvitet" "ubikviteter" ;
  udd_nn_1 = mkN "udd" ;
  udda_av_1 = mkA "udda" ;
  uddamaal_nn_1 = mkN "uddamеl" neutrum ;
  uddanummer_nn_1 = mkN "uddanummer" neutrum ;
  uddaplagg_nn_1 = mkN "uddaplagg" neutrum ;
  uddataaig_av_1 = mkA "uddatеig" ;
  uddatalsmetod_nn_1 = mkN "uddatalsmetod" "uddatalsmetoder" ;
  uddblad_nn_1 = mkN "uddblad" neutrum ;
  udde_nn_1 = mkN "udde" utrum ;
  uddig_av_1 = mkA "uddig" ;
  uddjaern_nn_1 = mkN "uddjдrn" neutrum ;
  uddljud_nn_1 = mkN "uddljud" neutrum ;
  uddloes_av_1 = mkA "uddlцs" ;
  uddrim_nn_1 = mkN "uddrim" "uddrimmet" "uddrim" "uddrimmen" ;
  ufo_nn_1 = mkN "ufo" "ufot" "ufon" "ufona" ;
  ugandier_nn_1 = mkN "ugandier" "ugandiern" "ugandier" "ugandierna" ;
  ugandisk_av_1 = mkA "ugandisk" ;
  uggla_nn_1 = mkN "uggla" ;
  uggleboll_nn_1 = mkN "uggleboll" ;
  ugn_nn_1 = mkN "ugn" ;
  ugnseldfast_av_1 = mkA "ugnseldfast" "ugnseldfast" ;
  ugnsinfodring_nn_1 = mkN "ugnsinfodring" ;
  ugnskol_nn_1 = mkN "ugnskol" neutrum ;
  ugnskolning_nn_1 = mkN "ugnskolning" ;
  ugnsomelett_nn_1 = mkN "ugnsomelett" "ugnsomeletter" ;
  ugnsplaat_nn_1 = mkN "ugnsplеt" ;
  ugnsspade_nn_1 = mkN "ugnsspade" utrum ;
  ugnstegel_nn_1 = mkN "ugnstegel" neutrum ;
  ugnsvarm_av_1 = mkA "ugnsvarm" ;
  ukas_nn_1 = mkN "ukas" "ukaser" ;
  ukrainare_nn_1 = mkN "ukrainare" "ukrainare" ;
  ukulele_nn_1 = mkN "ukulele" "ukuleler" ;
  ulan_nn_1 = mkN "ulan" "ulaner" ;
  ulceroes_av_1 = mkA "ulcerцs" ;
  ulk_nn_1 = mkN "ulk" ;
  ullhaarig_av_1 = mkA "ullhеrig" ;
  ullig_av_1 = mkA "ullig" ;
  ulliknande_av_1 = mkA "ulliknande" ;
  ulloert_nn_1 = mkN "ullцrt" "ullцrter" ;
  ullolja_nn_1 = mkN "ullolja" ;
  ullsax_nn_1 = mkN "ullsax" ;
  ullsida_nn_1 = mkN "ullsida" ;
  ulltork_nn_1 = mkN "ulltork" ;
  ulltott_nn_1 = mkN "ulltott" ;
  ullus_nn_1 = mkN "ullus" "ullusen" "ullцss" "ullцssen" ;
  ulster_nn_1 = mkN "ulster" ;
  ultima_nn_1 = mkN "ultima" ;
  ultimativ_av_1 = mkA "ultimativ" ;
  ultimatum_nn_1 = mkN "ultimatum" neutrum ;
  ultimo_ab_1 = mkAdv "ultimo" ;
  ultimoaffaer_nn_1 = mkN "ultimoaffдr" "ultimoaffдrer" ;
  ultra_nn_1 = mkN "ultra" "ultran" "ultras" "ultrasen" ;
  ultracentrifug_nn_1 = mkN "ultracentrifug" "ultracentrifuger" ;
  ultrakonservativ_av_1 = mkA "ultrakonservativ" ;
  ultraljud_nn_1 = mkN "ultraljud" neutrum ;
  ultramarin_av_1 = mkA "ultramarin" ;
  ultramontan_av_1 = mkA "ultramontan" ;
  ultrarapidfotografering_nn_1 = mkN "ultrarapidfotografering" ;
  ultraroed_av_1 = mkA "ultrarцd" ;
  ultrasnabb_av_1 = mkA "ultrasnabb" ;
  ultraviolett_av_1 = mkA "ultraviolett" ;
  ulv_nn_1 = mkN "ulv" ;
  umbaerande_nn_1 = mkN "umbдrande" ;
  umbaerlig_av_1 = mkA "umbдrlig" ;
  umbellat_nn_1 = mkN "umbellat" "umbellater" ;
  umgaenge_nn_1 = mkN "umgдnge" ;
  umgaengelse_nn_1 = mkN "umgдngelse" "umgдngelser" ;
  umgaengesform_nn_1 = mkN "umgдngesform" "umgдngesformer" ;
  umgaengeskrets_nn_1 = mkN "umgдngeskrets" ;
  umgaengesnorm_nn_1 = mkN "umgдngesnorm" "umgдngesnormer" ;
  uncial_nn_1 = mkN "uncial" "uncialer" ;
  undan_ab_1 = mkAdv "undan" ;
  undanbe_vb_1 = mkV "undanbe" "undanbad" "undanbett" ;
  undandra_vb_1 = mkV "undandra" "undandrar" "undandra" "undandrog" "undandragit" "undandragen" ;
  undanflykt_nn_1 = mkN "undanflykt" "undanflykter" ;
  undangjord_av_1 = mkA "undangjord" "undangjort" ;
  undanglidande_av_1 = mkA "undanglidande" ;
  undangoemd_av_1 = mkA "undangцmd" "undangцmt" ;
  undanhaalla_vb_1 = mkV "undanhеlla" "undanhцll" "undanhеllit" ;
  undanhaallande_nn_1 = mkN "undanhеllande" ;
  undanlaeggning_nn_1 = mkN "undanlдggning" ;
  undanlagd_av_1 = mkA "undanlagd" "undanlagt" ;
  undanmanoever_nn_1 = mkN "undanmanцver" ;
  undanskymd_av_1 = mkA "undanskymd" "undanskymt" ;
  undansticka_vb_1 = mkV "undansticka" "undanstack" "undanstuckit" ;
  undanta_vb_1 = mkV "undanta" "undantar" "undanta" "undantog" "undantagit" "undantagen" ;
  undantag_nn_1 = mkN "undantag" neutrum ;
  undantagsbestaemmelse_nn_1 = mkN "undantagsbestдmmelse" "undantagsbestдmmelser" ;
  undantagsfall_nn_1 = mkN "undantagsfall" neutrum ;
  undantagsfri_av_1 = mkA "undantagsfri" "undantagsfritt" ;
  undantagslag_nn_1 = mkN "undantagslag" ;
  undantagsloes_av_1 = mkA "undantagslцs" ;
  undantagsmaenniska_nn_1 = mkN "undantagsmдnniska" ;
  undantagsraett_nn_1 = mkN "undantagsrдtt" "undantagsrдtter" ;
  undantagstillstaand_nn_1 = mkN "undantagstillstеnd" neutrum ;
  undantagsvis_ab_1 = mkAdv "undantagsvis" ;
  undanvindsvaendning_nn_1 = mkN "undanvindsvдndning" ;
  under_ab_1 = mkAdv "under" ;
  under_nn_1 = mkN "under" neutrum ;
  underaarig_av_1 = mkA "underеrig" ;
  underarm_nn_1 = mkN "underarm" ;
  underart_nn_1 = mkN "underart" "underarter" ;
  underavdelning_nn_1 = mkN "underavdelning" ;
  underbaedd_nn_1 = mkN "underbдdd" ;
  underbar_av_1 = mkA "underbar" ;
  underbarn_nn_1 = mkN "underbarn" neutrum ;
  underbefael_nn_1 = mkN "underbefдl" neutrum ;
  underben_nn_1 = mkN "underben" neutrum ;
  underbestaand_nn_1 = mkN "underbestеnd" neutrum ;
  underbett_nn_1 = mkN "underbett" neutrum ;
  underbetyg_nn_1 = mkN "underbetyg" neutrum ;
  underbinda_vb_1 = mkV "underbinda" "underband" "underbundit" ;
  underbjuda_vb_1 = mkV "underbjuda" "underbjцd" "underbjudit" ;
  underbud_nn_1 = mkN "underbud" neutrum ;
  underbyggnad_nn_1 = mkN "underbyggnad" "underbyggnader" ;
  underdaanig_av_1 = mkA "underdеnig" ;
  underdaanighet_nn_1 = mkN "underdеnighet" "underdеnigheter" ;
  underdaeck_nn_1 = mkN "underdдck" neutrum ;
  underdel_nn_1 = mkN "underdel" "underdelen" "underdelar" "underdelarna" ;
  underdomstol_nn_1 = mkN "underdomstol" ;
  underdrift_nn_1 = mkN "underdrift" "underdrifter" ;
  underdriva_vb_1 = mkV "underdriva" "underdrev" "underdrivit" ;
  underemission_nn_1 = mkN "underemission" "underemissioner" ;
  underfall_nn_1 = mkN "underfall" neutrum ;
  underfamilj_nn_1 = mkN "underfamilj" "underfamiljer" ;
  underfart_nn_1 = mkN "underfart" "underfarter" ;
  underfoersoerjd_av_1 = mkA "underfцrsцrjd" "underfцrsцrjt" ;
  underfull_av_1 = mkA "underfull" ;
  underfund_ab_1 = mkAdv "underfund" ;
  underfundig_av_1 = mkA "underfundig" ;
  undergaa_vb_1 = mkV "undergе" "undergеr" "undergе" "undergick" "undergеtt" "undergеngen" ;
  undergaang_nn_1 = mkN "undergеng" ;
  undergardin_nn_1 = mkN "undergardin" "undergardiner" ;
  undergiven_av_1 = mkA "undergiven" "undergivet" ;
  undergoerande_av_1 = mkA "undergцrande" ;
  undergoerare_nn_1 = mkN "undergцrare" "undergцrare" ;
  undergrund_nn_1 = mkN "undergrund" "undergrunder" ;
  underhaall_nn_1 = mkN "underhеll" neutrum ;
  underhaalla_vb_1 = mkV "underhеlla" "underhцll" "underhеllit" ;
  underhaallande_av_1 = mkA "underhеllande" ;
  underhaallare_nn_1 = mkN "underhеllare" "underhеllare" ;
  underhaallning_nn_1 = mkN "underhеllning" ;
  underhaallningsorkester_nn_1 = mkN "underhеllningsorkester" ;
  underhaallsbidrag_nn_1 = mkN "underhеllsbidrag" neutrum ;
  underhaallsfoerband_nn_1 = mkN "underhеllsfцrband" neutrum ;
  underhaallsfri_av_1 = mkA "underhеllsfri" "underhеllsfritt" ;
  underhaallstjaenst_nn_1 = mkN "underhеllstjдnst" "underhеllstjдnster" ;
  underhaallstrupp_nn_1 = mkN "underhеllstrupp" "underhеllstrupper" ;
  underhaerdig_av_1 = mkA "underhдrdig" ;
  underhaltig_av_1 = mkA "underhaltig" ;
  underhandling_nn_1 = mkN "underhandling" ;
  underhandsackord_nn_1 = mkN "underhandsackord" neutrum ;
  underhandskontakt_nn_1 = mkN "underhandskontakt" "underhandskontakter" ;
  underhavande_nn_1 = mkN "underhavande" "underhavanden" "underhavande" "underhavandena" ;
  underhuggare_nn_1 = mkN "underhuggare" "underhuggare" ;
  underhus_nn_1 = mkN "underhus" neutrum ;
  underhypotek_nn_1 = mkN "underhypotek" neutrum ;
  underifraan_ab_1 = mkAdv "underifrеn" ;
  underingenjoer_nn_1 = mkN "underingenjцr" "underingenjцrer" ;
  underinstans_nn_1 = mkN "underinstans" "underinstanser" ;
  underjordisk_av_1 = mkA "underjordisk" ;
  underjordsprov_nn_1 = mkN "underjordsprov" neutrum ;
  underkaeke_nn_1 = mkN "underkдke" utrum ;
  underkaend_av_1 = mkA "underkдnd" ;
  underkant_nn_1 = mkN "underkant" "underkanter" ;
  underkjol_nn_1 = mkN "underkjol" ;
  underklaenning_nn_1 = mkN "underklдnning" ;
  underklassare_nn_1 = mkN "underklassare" "underklassare" ;
  underklassig_av_1 = mkA "underklassig" ;
  underkropp_nn_1 = mkN "underkropp" ;
  underkunnig_av_1 = mkA "underkunnig" ;
  underkurs_nn_1 = mkN "underkurs" "underkurser" ;
  underkyld_av_1 = mkA "underkyld" "underkylt" ;
  underlaata_vb_1 = mkV "underlеta" "underlдt" "underlеtit" ;
  underlaatelse_nn_1 = mkN "underlеtelse" "underlеtelser" ;
  underlaatenhet_nn_1 = mkN "underlеtenhet" "underlеtenheter" ;
  underlaatenhetssynd_nn_1 = mkN "underlеtenhetssynd" "underlеtenhetssynder" ;
  underlaegg_nn_1 = mkN "underlдgg" neutrum ;
  underlaegsen_av_1 = mkA "underlдgsen" "underlдgset" ;
  underlaegsenhet_nn_1 = mkN "underlдgsenhet" "underlдgsenheter" ;
  underlaekare_nn_1 = mkN "underlдkare" "underlдkare" ;
  underlag_nn_1 = mkN "underlag" neutrum ;
  underlakan_nn_1 = mkN "underlakan" neutrum ;
  underledare_nn_1 = mkN "underledare" "underledare" ;
  underleverantoer_nn_1 = mkN "underleverantцr" "underleverantцrer" ;
  underlig_av_1 = mkA "underlig" ;
  underliggande_av_1 = mkA "underliggande" ;
  underliv_nn_1 = mkN "underliv" neutrum ;
  underljudsfart_nn_1 = mkN "underljudsfart" "underljudsfarter" ;
  underljudshastighet_nn_1 = mkN "underljudshastighet" "underljudshastigheter" ;
  underlydande_av_1 = mkA "underlydande" ;
  undermaalig_av_1 = mkA "undermеlig" ;
  undermaalning_nn_1 = mkN "undermеlning" ;
  undermaensklig_av_1 = mkA "undermдnsklig" ;
  undermast_nn_1 = mkN "undermast" "undermaster" ;
  undermedveten_av_1 = mkA "undermedveten" "undermedvetet" ;
  undermening_nn_1 = mkN "undermening" ;
  undernaerd_av_1 = mkA "undernдrd" "undernдrt" ;
  underofficer_nn_1 = mkN "underofficer" "underofficern" "underofficerare" "underofficerarna" ;
  underordnande_av_1 = mkA "underordnande" ;
  underordning_nn_1 = mkN "underordning" ;
  underpant_nn_1 = mkN "underpant" "underpanter" ;
  underplagg_nn_1 = mkN "underplagg" neutrum ;
  underpris_nn_1 = mkN "underpris" neutrum ;
  underraa_nn_1 = mkN "underrе" "underrеn" "underrеr" "underrеrna" ;
  underraett_nn_1 = mkN "underrдtt" "underrдtter" ;
  underraettelse_nn_1 = mkN "underrдttelse" "underrдttelser" ;
  underraettelseofficer_nn_1 = mkN "underrдttelseofficer" "underrдttelseofficern" "underrдttelseofficerare" "underrдttelseofficerarna" ;
  underredsbehandling_nn_1 = mkN "underredsbehandling" ;
  underrubrik_nn_1 = mkN "underrubrik" "underrubriker" ;
  undersaate_nn_1 = mkN "undersеte" utrum ;
  undersaatlig_av_1 = mkA "undersеtlig" ;
  undersaetsig_av_1 = mkA "undersдtsig" ;
  undersam_av_1 = mkA "undersam" "undersamt" "undersamma" "undersamma" "undersammare" "undersammast" "undersammaste" ;
  undersats_nn_1 = mkN "undersats" "undersatser" ;
  undersegel_nn_1 = mkN "undersegel" neutrum ;
  undersida_nn_1 = mkN "undersida" ;
  underskaap_nn_1 = mkN "underskеp" neutrum ;
  underskattning_nn_1 = mkN "underskattning" ;
  underskoen_av_1 = mkA "underskцn" ;
  underskoeterska_nn_1 = mkN "underskцterska" ;
  underskott_nn_1 = mkN "underskott" neutrum ;
  underskottsavdrag_nn_1 = mkN "underskottsavdrag" neutrum ;
  underskrida_vb_1 = mkV "underskrida" "underskred" "underskridit" ;
  underskrift_nn_1 = mkN "underskrift" "underskrifter" ;
  underslag_nn_1 = mkN "underslag" neutrum ;
  underslev_nn_1 = mkN "underslev" neutrum ;
  undersoekare_nn_1 = mkN "undersцkare" "undersцkare" ;
  undersoekning_nn_1 = mkN "undersцkning" ;
  undersoekningsdomare_nn_1 = mkN "undersцkningsdomare" "undersцkningsdomare" ;
  undersoekningsfaange_nn_1 = mkN "undersцkningsfеnge" utrum ;
  undersoekningsmetod_nn_1 = mkN "undersцkningsmetod" "undersцkningsmetoder" ;
  undersoekningsrum_nn_1 = mkN "undersцkningsrum" "undersцkningsrummet" "undersцkningsrum" "undersцkningsrummen" ;
  understaaende_av_1 = mkA "understеende" ;
  understaellning_nn_1 = mkN "understдllning" ;
  understaemma_nn_1 = mkN "understдmma" ;
  understag_nn_1 = mkN "understag" neutrum ;
  understatement_nn_1 = mkN "understatement" neutrum ;
  understicka_vb_1 = mkV "understicka" "understack" "understuckit" ;
  understiga_vb_1 = mkV "understiga" "understeg" "understigit" ;
  understoedsfoerening_nn_1 = mkN "understцdsfцrening" ;
  understoedskassa_nn_1 = mkN "understцdskassa" ;
  understoedsnaemnd_nn_1 = mkN "understцdsnдmnd" "understцdsnдmnder" ;
  understoet_nn_1 = mkN "understцt" ;
  understreckare_nn_1 = mkN "understreckare" "understreckare" ;
  understroem_nn_1 = mkN "understrцm" "understrцmmen" "understrцmmar" "understrцmmarna" ;
  understryka_vb_1 = mkV "understryka" "understrцk" "understrukit" ;
  understrykning_nn_1 = mkN "understrykning" ;
  understucken_av_1 = mkA "understucken" "understucket" ;
  understundom_ab_1 = mkAdv "understundom" ;
  understyrd_av_1 = mkA "understyrd" "understyrt" ;
  undersysselsatt_av_1 = mkA "undersysselsatt" ;
  undertak_nn_1 = mkN "undertak" neutrum ;
  undertalig_av_1 = mkA "undertalig" ;
  undertecknare_nn_1 = mkN "undertecknare" "undertecknare" ;
  underterm_nn_1 = mkN "underterm" "undertermer" ;
  undertill_ab_1 = mkAdv "undertill" ;
  undertitel_nn_1 = mkN "undertitel" ;
  underton_nn_1 = mkN "underton" "undertoner" ;
  undertraad_nn_1 = mkN "undertrеd" ;
  undertroeja_nn_1 = mkN "undertrцja" ;
  undervaaning_nn_1 = mkN "undervеning" ;
  undervaegs_ab_1 = mkAdv "undervдgs" ;
  undervattensbaat_nn_1 = mkN "undervattensbеt" ;
  undervattensboelja_nn_1 = mkN "undervattensbцlja" ;
  undervattensfoerbindelse_nn_1 = mkN "undervattensfцrbindelse" "undervattensfцrbindelser" ;
  undervattenskropp_nn_1 = mkN "undervattenskropp" ;
  undervattenstroeskel_nn_1 = mkN "undervattenstrцskel" ;
  underverk_nn_1 = mkN "underverk" neutrum ;
  underviktig_av_1 = mkA "underviktig" ;
  undervisare_nn_1 = mkN "undervisare" "undervisare" ;
  undervisningsaemne_nn_1 = mkN "undervisningsдmne" ;
  undervisningsmaterial_nn_1 = mkN "undervisningsmaterial" neutrum ;
  undervisningspaket_nn_1 = mkN "undervisningspaket" neutrum ;
  undervisningsraad_nn_1 = mkN "undervisningsrеd" neutrum ;
  undervisningssjukhus_nn_1 = mkN "undervisningssjukhus" neutrum ;
  undervisningsskicklighet_nn_1 = mkN "undervisningsskicklighet" "undervisningsskickligheter" ;
  undervisningsskyldighet_nn_1 = mkN "undervisningsskyldighet" "undervisningsskyldigheter" ;
  undervisningsspraak_nn_1 = mkN "undervisningssprеk" neutrum ;
  undervisningsteknologi_nn_1 = mkN "undervisningsteknologi" "undervisningsteknologier" ;
  undervisningstimme_nn_1 = mkN "undervisningstimme" utrum ;
  undfaegnad_nn_1 = mkN "undfдgnad" "undfдgnader" ;
  undfallande_av_1 = mkA "undfallande" ;
  undfallen_av_1 = mkA "undfallen" "undfallet" ;
  undfallenhet_nn_1 = mkN "undfallenhet" "undfallenheter" ;
  undin_nn_1 = mkN "undin" "undiner" ;
  undran_nn_1 = mkN "undran" "undran" "undringar" "undringarna" ;
  undrande_av_1 = mkA "undrande" ;
  undransvaerd_av_1 = mkA "undransvдrd" "undransvдrt" ;
  undring_nn_1 = mkN "undring" ;
  undsaettningsfond_nn_1 = mkN "undsдttningsfond" "undsдttningsfonder" ;
  undskyllning_nn_1 = mkN "undskyllning" ;
  undulat_nn_1 = mkN "undulat" "undulater" ;
  undulation_nn_1 = mkN "undulation" "undulationer" ;
  undulatorisk_av_1 = mkA "undulatorisk" ;
  undvika_vb_1 = mkV "undvika" "undvek" "undvikit" ;
  undvikande_av_1 = mkA "undvikande" ;
  ung_av_1 = mkA "ung" "yngre" "yngst" ;
  ungdjur_nn_1 = mkN "ungdjur" neutrum ;
  ungdom_nn_1 = mkN "ungdom" ;
  ungdomlig_av_1 = mkA "ungdomlig" ;
  ungdomsaar_nn_1 = mkN "ungdomsеr" neutrum ;
  ungdomsanstalt_nn_1 = mkN "ungdomsanstalt" "ungdomsanstalter" ;
  ungdomsarbetsloeshet_nn_1 = mkN "ungdomsarbetslцshet" "ungdomsarbetslцsheter" ;
  ungdomsbok_nn_1 = mkN "ungdomsbok" "ungdomsbцcker" ;
  ungdomsbrottslighet_nn_1 = mkN "ungdomsbrottslighet" "ungdomsbrottsligheter" ;
  ungdomsbrottsling_nn_1 = mkN "ungdomsbrottsling" ;
  ungdomsfaengelse_nn_1 = mkN "ungdomsfдngelse" "ungdomsfдngelset" "ungdomsfдngelser" "ungdomsfдngelserna" ;
  ungdomsfoerbund_nn_1 = mkN "ungdomsfцrbund" neutrum ;
  ungdomsfoermedling_nn_1 = mkN "ungdomsfцrmedling" ;
  ungdomsgaard_nn_1 = mkN "ungdomsgеrd" ;
  ungdomsgrupp_nn_1 = mkN "ungdomsgrupp" "ungdomsgrupper" ;
  ungdomshem_nn_1 = mkN "ungdomshem" "ungdomshemmet" "ungdomshem" "ungdomshemmen" ;
  ungdomskaerlek_nn_1 = mkN "ungdomskдrlek" ;
  ungdomskonsulent_nn_1 = mkN "ungdomskonsulent" "ungdomskonsulenter" ;
  ungdomskultur_nn_1 = mkN "ungdomskultur" "ungdomskulturer" ;
  ungdomsledare_nn_1 = mkN "ungdomsledare" "ungdomsledare" ;
  ungdomsorganisation_nn_1 = mkN "ungdomsorganisation" "ungdomsorganisationer" ;
  ungdomsraad_nn_1 = mkN "ungdomsrеd" neutrum ;
  ungdomsroerelse_nn_1 = mkN "ungdomsrцrelse" "ungdomsrцrelser" ;
  ungdomssvaermeri_nn_1 = mkN "ungdomssvдrmeri" "ungdomssvдrmerit" "ungdomssvдrmerier" "ungdomssvдrmerierna" ;
  ungdomssynd_nn_1 = mkN "ungdomssynd" "ungdomssynder" ;
  ungdomstid_nn_1 = mkN "ungdomstid" "ungdomstider" ;
  ungdomsvaeljare_nn_1 = mkN "ungdomsvдljare" "ungdomsvдljare" ;
  ungdomsvaen_nn_1 = mkN "ungdomsvдn" "ungdomsvдnnen" "ungdomsvдnner" "ungdomsvдnnerna" ;
  ungdomsverk_nn_1 = mkN "ungdomsverk" neutrum ;
  ungdomsverksamhet_nn_1 = mkN "ungdomsverksamhet" "ungdomsverksamheter" ;
  unge_nn_1 = mkN "unge" utrum ;
  ungefaer_ab_1 = mkAdv "ungefдr" ;
  ungefaerlig_av_1 = mkA "ungefдrlig" ;
  ungefaerligen_ab_1 = mkAdv "ungefдrligen" ;
  ungersk_av_1 = mkA "ungersk" ;
  ungerska_nn_2 = mkN "ungerska" ;
  ungersven_nn_1 = mkN "ungersven" "ungersvennen" "ungersvenner" "ungersvennerna" ;
  ungflicksaktig_av_1 = mkA "ungflicksaktig" ;
  unghaest_nn_1 = mkN "unghдst" ;
  ungherre_nn_1 = mkN "ungherre" utrum ;
  ungkarl_nn_1 = mkN "ungkarl" ;
  ungkarlshotell_nn_1 = mkN "ungkarlshotell" neutrum ;
  ungkarlsvana_nn_1 = mkN "ungkarlsvana" ;
  ungkyrklig_av_1 = mkA "ungkyrklig" ;
  ungmoe_nn_1 = mkN "ungmц" "ungmцn" "ungmцr" "ungmцrna" ;
  ungmor_nn_1 = mkN "ungmoder" "ungmodern" "ungmцdrar" "ungmцdrarna" ;
  ungnoet_nn_1 = mkN "ungnцt" neutrum ;
  ungrare_nn_1 = mkN "ungrare" "ungrare" ;
  ungskog_nn_1 = mkN "ungskog" ;
  ungsocialism_nn_1 = mkN "ungsocialism" "ungsocialismer" ;
  ungstadium_nn_1 = mkN "ungstadium" "ungstadiet" "ungstadier" "ungstadierna" ;
  ungsvensk_av_1 = mkA "ungsvensk" ;
  ungsvensk_nn_1 = mkN "ungsvensk" ;
  ungtall_nn_1 = mkN "ungtall" ;
  ungtupp_nn_1 = mkN "ungtupp" ;
  ungturk_nn_1 = mkN "ungturk" ;
  uniform_av_1 = mkA "uniform" ;
  uniform_nn_1 = mkN "uniform" "uniformer" ;
  uniformering_nn_1 = mkN "uniformering" ;
  uniformitet_nn_1 = mkN "uniformitet" "uniformiteter" ;
  uniformshatt_nn_1 = mkN "uniformshatt" ;
  uniformsrock_nn_1 = mkN "uniformsrock" ;
  uniformstecken_nn_1 = mkN "uniformstecken" "uniformstecknet" "uniformstecken" "uniformstecknen" ;
  unik_av_1 = mkA "unik" ;
  unikabox_nn_1 = mkN "unikabox" ;
  unikat_nn_1 = mkN "unikat" neutrum ;
  unikum_nn_1 = mkN "unikum" neutrum ;
  unilateral_av_1 = mkA "unilateral" ;
  union_nn_1 = mkN "union" "unioner" ;
  unionell_av_1 = mkA "unionell" ;
  unionsbrott_nn_1 = mkN "unionsbrott" neutrum ;
  unisex_av_1 = mkA "unisex" ;
  unison_av_1 = mkA "unison" ;
  unitarie_nn_1 = mkN "unitarie" "unitarier" ;
  unitarisk_av_1 = mkA "unitarisk" ;
  unitarist_nn_1 = mkN "unitarist" "unitarister" ;
  universalarvinge_nn_1 = mkN "universalarvinge" utrum ;
  universalbegaavning_nn_1 = mkN "universalbegеvning" ;
  universalbegrepp_nn_1 = mkN "universalbegrepp" neutrum ;
  universalborr_nn_1 = mkN "universalborr" ;
  universalist_nn_1 = mkN "universalist" "universalister" ;
  universalistisk_av_1 = mkA "universalistisk" ;
  universalitet_nn_1 = mkN "universalitet" "universaliteter" ;
  universalkniv_nn_1 = mkN "universalkniv" ;
  universalknut_nn_1 = mkN "universalknut" ;
  universalmedel_nn_1 = mkN "universalmedel" neutrum ;
  universell_av_1 = mkA "universell" ;
  universitet_nn_1 = mkN "universitet" neutrum ;
  universitetsadjunkt_nn_1 = mkN "universitetsadjunkt" "universitetsadjunkter" ;
  universitetsaemne_nn_1 = mkN "universitetsдmne" ;
  universitetsbibliotek_nn_1 = mkN "universitetsbibliotek" neutrum ;
  universitetsbokhandel_nn_1 = mkN "universitetsbokhandel" ;
  universitetsfilial_nn_1 = mkN "universitetsfilial" "universitetsfilialer" ;
  universitetsinstitution_nn_1 = mkN "universitetsinstitution" "universitetsinstitutioner" ;
  universitetskansler_nn_1 = mkN "universitetskansler" "universitetskanslern" "universitetskanslerer" "universitetskanslererna" ;
  universitetslektor_nn_1 = mkN "universitetslektor" "universitetslektorer" ;
  universitetsmatrikel_nn_1 = mkN "universitetsmatrikel" ;
  universitetsrektor_nn_1 = mkN "universitetsrektor" "universitetsrektorer" ;
  universitetssjukhus_nn_1 = mkN "universitetssjukhus" neutrum ;
  universitetsstad_nn_1 = mkN "universitetsstad" "universitetsstдder" ;
  universitetsstuderande_nn_1 = mkN "universitetsstuderande" "universitetsstuderanden" "universitetsstuderande" "universitetsstuderandena" ;
  universum_nn_1 = mkN "universum" neutrum ;
  unken_av_1 = mkA "unken" "unket" ;
  uns_nn_1 = mkN "uns" neutrum ;
  up_to_date_av_1 = mkA "up-to-date" ;
  upp_ab_1 = mkAdv "upp" ;
  uppaat_ab_1 = mkAdv "uppеt" ;
  uppaat_av_1 = mkA "uppеt" ;
  uppaatgaaende_av_1 = mkA "uppеtgеende" ;
  uppaatstigande_av_1 = mkA "uppеtstigande" ;
  uppaatstraevande_av_1 = mkA "uppеtstrдvande" ;
  uppaatstraevare_nn_1 = mkN "uppеtstrдvare" "uppеtstrдvare" ;
  uppaeta_vb_1 = mkV "uppдta" "uppеt" "uppдtit" ;
  uppassare_nn_1 = mkN "uppassare" "uppassare" ;
  uppassningsstaelle_nn_1 = mkN "uppassningsstдlle" ;
  uppbaad_nn_1 = mkN "uppbеd" neutrum ;
  uppbackare_nn_1 = mkN "uppbackare" "uppbackare" ;
  uppbackning_nn_1 = mkN "uppbackning" ;
  uppbaera_vb_1 = mkV "uppbдra" "uppbar" "uppburit" ;
  uppbindning_nn_1 = mkN "uppbindning" ;
  uppbjuda_vb_1 = mkV "uppbjuda" "uppbjцd" "uppbjudit" ;
  uppblaasning_nn_1 = mkN "uppblеsning" ;
  uppblaasningsfas_nn_1 = mkN "uppblеsningsfas" "uppblеsningsfaser" ;
  uppblaast_av_1 = mkA "uppblеst" "uppblеst" ;
  uppbloett_av_1 = mkA "uppblцtt" ;
  uppblossande_av_1 = mkA "uppblossande" ;
  uppboerd_nn_1 = mkN "uppbцrd" "uppbцrder" ;
  uppboerdsaar_nn_1 = mkN "uppbцrdsеr" neutrum ;
  uppboerdsbok_nn_1 = mkN "uppbцrdsbok" "uppbцrdsbцcker" ;
  uppboerdsdag_nn_1 = mkN "uppbцrdsdag" ;
  uppboerdslaengd_nn_1 = mkN "uppbцrdslдngd" "uppbцrdslдngder" ;
  uppboerdsman_nn_1 = mkN "uppbцrdsman" "uppbцrdsmannen" "uppbцrdsmдn" "uppbцrdsmдnnen" ;
  uppboerdstermin_nn_1 = mkN "uppbцrdstermin" "uppbцrdsterminer" ;
  uppbragt_av_1 = mkA "uppbragt" "uppbragt" ;
  uppbrott_nn_1 = mkN "uppbrott" neutrum ;
  uppbrottssignal_nn_1 = mkN "uppbrottssignal" "uppbrottssignaler" ;
  uppbud_nn_1 = mkN "uppbud" neutrum ;
  uppbunden_av_1 = mkA "uppbunden" "uppbundet" ;
  uppburen_av_1 = mkA "uppburen" "uppburet" ;
  uppbyggelsemoete_nn_1 = mkN "uppbyggelsemцte" ;
  uppbygglig_av_1 = mkA "uppbygglig" ;
  uppbyggnad_nn_1 = mkN "uppbyggnad" "uppbyggnader" ;
  uppdaemd_av_1 = mkA "uppdдmd" "uppdдmt" ;
  uppdelning_nn_1 = mkN "uppdelning" ;
  uppdra_vb_1 = mkV "uppdra" "uppdrar" "uppdra" "uppdrog" "uppdragit" "uppdragen" ;
  uppdrag_nn_1 = mkN "uppdrag" neutrum ;
  uppdragsgivare_nn_1 = mkN "uppdragsgivare" "uppdragsgivare" ;
  uppdragstagare_nn_1 = mkN "uppdragstagare" "uppdragstagare" ;
  uppdriva_vb_1 = mkV "uppdriva" "uppdrev" "uppdrivit" ;
  uppdriven_av_1 = mkA "uppdriven" "uppdrivet" ;
  uppdukning_nn_1 = mkN "uppdukning" ;
  uppe_ab_1 = mkAdv "uppe" ;
  uppehaall_nn_1 = mkN "uppehеll" neutrum ;
  uppehaalla_vb_1 = mkV "uppehеlla" "uppehцll" "uppehеllit" ;
  uppehaallsort_nn_1 = mkN "uppehеllsort" "uppehеllsorter" ;
  uppehaallstillstaand_nn_1 = mkN "uppehеllstillstеnd" neutrum ;
  uppemot_ab_1 = mkAdv "uppemot" ;
  uppenbar_av_1 = mkA "uppenbar" ;
  uppenbarelse_nn_1 = mkN "uppenbarelse" "uppenbarelser" ;
  uppenbarelsereligion_nn_1 = mkN "uppenbarelsereligion" "uppenbarelsereligioner" ;
  uppenbarligen_ab_1 = mkAdv "uppenbarligen" ;
  uppercut_nn_1 = mkN "uppercut" "uppercuten" "uppercuts" "uppercutsen" ;
  uppesittare_nn_1 = mkN "uppesittare" "uppesittare" ;
  uppesittarkvaell_nn_1 = mkN "uppesittarkvдll" ;
  uppfaellbar_av_1 = mkA "uppfдllbar" ;
  uppfart_nn_1 = mkN "uppfart" "uppfarter" ;
  uppfartsramp_nn_1 = mkN "uppfartsramp" "uppfartsramper" ;
  uppfattning_nn_1 = mkN "uppfattning" ;
  uppfinna_vb_1 = mkV "uppfinna" "uppfann" "uppfunnit" ;
  uppfinnare_nn_1 = mkN "uppfinnare" "uppfinnare" ;
  uppfinning_nn_1 = mkN "uppfinning" ;
  uppfinningsrik_av_1 = mkA "uppfinningsrik" ;
  uppflaag_nn_1 = mkN "uppflеg" neutrum ;
  uppflammande_av_1 = mkA "uppflammande" ;
  uppflog_nn_1 = mkN "uppflog" neutrum ;
  uppflugen_av_1 = mkA "uppflugen" "uppfluget" ;
  uppfoedare_nn_1 = mkN "uppfцdare" "uppfцdare" ;
  uppfoeljning_nn_1 = mkN "uppfцljning" ;
  uppfoer_ab_1 = mkAdv "uppfцr" ;
  uppfoerande_nn_1 = mkN "uppfцrande" ;
  uppfoersbacke_nn_1 = mkN "uppfцrsbacke" utrum ;
  uppfordring_nn_1 = mkN "uppfordring" ;
  uppfostrare_nn_1 = mkN "uppfostrare" "uppfostrare" ;
  uppfostring_nn_1 = mkN "uppfostring" ;
  uppfostringsanstalt_nn_1 = mkN "uppfostringsanstalt" "uppfostringsanstalter" ;
  uppfostringshem_nn_1 = mkN "uppfostringshem" "uppfostringshemmet" "uppfostringshem" "uppfostringshemmen" ;
  uppfriskande_av_1 = mkA "uppfriskande" ;
  uppgaa_vb_1 = mkV "uppgе" "uppgеr" "uppgе" "uppgick" "uppgеtt" "uppgеngen" ;
  uppgaang_nn_1 = mkN "uppgеng" ;
  uppgaeld_nn_1 = mkN "uppgдld" "uppgдlder" ;
  uppge_vb_1 = mkV "uppge" "uppger" "uppge" "uppgav" "uppgett" "uppgiven" ;
  uppgift_nn_1 = mkN "uppgift" "uppgifter" ;
  uppgiven_av_1 = mkA "uppgiven" "uppgivet" ;
  uppgivenhet_nn_1 = mkN "uppgivenhet" "uppgivenheter" ;
  uppgjord_av_1 = mkA "uppgjord" "uppgjort" ;
  uppgoerelse_nn_1 = mkN "uppgцrelse" "uppgцrelser" ;
  uppgrundning_nn_1 = mkN "uppgrundning" ;
  upphaemtning_nn_1 = mkN "upphдmtning" ;
  upphaengning_nn_1 = mkN "upphдngning" ;
  upphalare_nn_1 = mkN "upphalare" "upphalare" ;
  upphalningsbaedd_nn_1 = mkN "upphalningsbдdd" ;
  upphandlare_nn_1 = mkN "upphandlare" "upphandlare" ;
  upphandling_nn_1 = mkN "upphandling" ;
  upphettning_nn_1 = mkN "upphettning" ;
  upphinnelig_av_1 = mkA "upphinnelig" ;
  upphoejd_av_1 = mkA "upphцjd" "upphцjt" ;
  upphoejdhet_nn_1 = mkN "upphцjdhet" "upphцjdheter" ;
  upphoejelse_nn_1 = mkN "upphцjelse" "upphцjelser" ;
  upphoejning_nn_1 = mkN "upphцjning" ;
  upphopp_nn_1 = mkN "upphopp" neutrum ;
  upphostning_nn_1 = mkN "upphostning" ;
  upphovsman_nn_1 = mkN "upphovsman" "upphovsmannen" "upphovsmдn" "upphovsmдnnen" ;
  uppifraan_ab_1 = mkAdv "uppifrеn" ;
  uppiggande_av_1 = mkA "uppiggande" ;
  uppkaeftig_av_1 = mkA "uppkдftig" ;
  uppkast_nn_1 = mkN "uppkast" neutrum ;
  uppkastning_nn_1 = mkN "uppkastning" ;
  uppklaedd_av_1 = mkA "uppklдdd" "uppklдdtt" ;
  uppklippt_av_1 = mkA "uppklippt" "uppklippt" ;
  uppknaeppt_av_1 = mkA "uppknдppt" "uppknдppt" ;
  uppknuten_av_1 = mkA "uppknuten" "uppknutet" ;
  uppkoep_nn_1 = mkN "uppkцp" neutrum ;
  uppkoepare_nn_1 = mkN "uppkцpare" "uppkцpare" ;
  uppkoerd_av_1 = mkA "uppkцrd" "uppkцrt" ;
  uppkoerning_nn_1 = mkN "uppkцrning" ;
  uppkoersvaeg_nn_1 = mkN "uppkцrsvдg" ;
  uppkok_nn_1 = mkN "uppkok" neutrum ;
  uppkolning_nn_1 = mkN "uppkolning" ;
  uppkomling_nn_1 = mkN "uppkomling" ;
  uppkomma_vb_1 = mkV "uppkomma" "uppkom" "uppkommit" ;
  upplaaning_nn_1 = mkN "upplеning" ;
  upplaata_vb_1 = mkV "upplеta" "upplдt" "upplеtit" ;
  upplaatelse_nn_1 = mkN "upplеtelse" "upplеtelser" ;
  upplaegg_nn_1 = mkN "upplдgg" neutrum ;
  upplaeggning_nn_1 = mkN "upplдggning" ;
  upplaendsk_av_1 = mkA "upplдndsk" ;
  upplaenning_nn_1 = mkN "upplдnning" ;
  upplaesare_nn_1 = mkN "upplдsare" "upplдsare" ;
  upplaesning_nn_1 = mkN "upplдsning" ;
  upplag_nn_1 = mkN "upplag" neutrum ;
  upplaga_nn_1 = mkN "upplaga" ;
  upplagd_av_1 = mkA "upplagd" "upplagt" ;
  upplagesiffra_nn_1 = mkN "upplagesiffra" ;
  upplagringsplats_nn_1 = mkN "upplagringsplats" "upplagringsplatser" ;
  upplagscell_nn_1 = mkN "upplagscell" "upplagsceller" ;
  upplagsplats_nn_1 = mkN "upplagsplats" "upplagsplatser" ;
  uppland_nn_1 = mkN "uppland" neutrum ;
  upplevelse_nn_1 = mkN "upplevelse" "upplevelser" ;
  upplivande_nn_1 = mkN "upplivande" ;
  upplivningsfoersoek_nn_1 = mkN "upplivningsfцrsцk" neutrum ;
  upploesning_nn_1 = mkN "upplцsning" ;
  upploesningsmedel_nn_1 = mkN "upplцsningsmedel" neutrum ;
  upplopp_nn_1 = mkN "upplopp" neutrum ;
  uppluckring_nn_1 = mkN "uppluckring" ;
  upplupen_av_1 = mkA "upplupen" "upplupet" ;
  upplyftande_av_1 = mkA "upplyftande" ;
  upplysning_nn_1 = mkN "upplysning" ;
  upplysningsfilosofi_nn_1 = mkN "upplysningsfilosofi" "upplysningsfilosofier" ;
  upplysningsvis_ab_1 = mkAdv "upplysningsvis" ;
  upplyst_av_1 = mkA "upplyst" "upplyst" ;
  uppmaerksam_av_1 = mkA "uppmдrksam" "uppmдrksamt" "uppmдrksamma" "uppmдrksamma" "uppmдrksammare" "uppmдrksammast" "uppmдrksammaste" ;
  uppmaerksamhet_nn_1 = mkN "uppmдrksamhet" "uppmдrksamheter" ;
  uppmaerksamhetsfaelt_nn_1 = mkN "uppmдrksamhetsfдlt" neutrum ;
  uppmaning_nn_1 = mkN "uppmaning" ;
  uppmaningssats_nn_1 = mkN "uppmaningssats" "uppmaningssatser" ;
  uppmarsch_nn_1 = mkN "uppmarsch" "uppmarscher" ;
  uppmarschomraade_nn_1 = mkN "uppmarschomrеde" ;
  uppmjukning_nn_1 = mkN "uppmjukning" ;
  uppmuntran_nn_1 = mkN "uppmuntran" "uppmuntran" "uppmuntringar" "uppmuntringarna" ;
  uppmuntring_nn_1 = mkN "uppmuntring" ;
  uppnaaelig_av_1 = mkA "uppnеelig" ;
  uppnaest_av_1 = mkA "uppnдst" "uppnдst" ;
  uppnosig_av_1 = mkA "uppnosig" ;
  uppochned_ab_1 = mkAdv "uppochned" ;
  uppochnedvaend_av_1 = mkA "uppochnedvдnd" ;
  uppoffrande_av_1 = mkA "uppoffrande" ;
  uppoffring_nn_1 = mkN "uppoffring" ;
  uppraekning_nn_1 = mkN "upprдkning" ;
  uppraett_av_1 = mkA "upprдtt" ;
  uppraettande_nn_1 = mkN "upprдttande" ;
  uppraettelse_nn_1 = mkN "upprдttelse" "upprдttelser" ;
  uppraetthaalla_vb_1 = mkV "upprдtthеlla" "upprдtthцll" "upprдtthеllit" ;
  uppraettstaaende_av_1 = mkA "upprдttstеende" ;
  upprensning_nn_1 = mkN "upprensning" ;
  upprepning_nn_1 = mkN "upprepning" ;
  upprepningsmoenster_nn_1 = mkN "upprepningsmцnster" neutrum ;
  uppriktig_av_1 = mkA "uppriktig" ;
  uppringning_nn_1 = mkN "uppringning" ;
  upprinnelse_nn_1 = mkN "upprinnelse" "upprinnelser" ;
  upprinning_nn_1 = mkN "upprinning" ;
  uppriva_vb_1 = mkV "uppriva" "upprev" "upprivit" ;
  upprivande_av_1 = mkA "upprivande" ;
  uppriven_av_1 = mkA "uppriven" "upprivet" ;
  upproejning_nn_1 = mkN "upprцjning" ;
  upproerande_av_1 = mkA "upprцrande" ;
  upproerd_av_1 = mkA "upprцrd" "upprцrt" ;
  upprop_nn_1 = mkN "upprop" neutrum ;
  uppror_nn_1 = mkN "uppror" neutrum ;
  upprorisk_av_1 = mkA "upprorisk" ;
  upprorshaerd_nn_1 = mkN "upprorshдrd" ;
  upprorsmakare_nn_1 = mkN "upprorsmakare" "upprorsmakare" ;
  upprorsman_nn_1 = mkN "upprorsman" "upprorsmannen" "upprorsmдn" "upprorsmдnnen" ;
  upprustning_nn_1 = mkN "upprustning" ;
  upprutten_av_1 = mkA "upprutten" "uppruttet" ;
  uppryckning_nn_1 = mkN "uppryckning" ;
  upprymd_av_1 = mkA "upprymd" "upprymt" ;
  upprymmare_nn_1 = mkN "upprymmare" "upprymmare" ;
  upprymningsstaal_nn_1 = mkN "upprymningsstеl" neutrum ;
  uppsaat_nn_1 = mkN "uppsеt" neutrum ;
  uppsaatlig_av_1 = mkA "uppsеtlig" ;
  uppsaatligen_ab_1 = mkAdv "uppsеtligen" ;
  uppsaegelse_nn_1 = mkN "uppsдgelse" "uppsдgelser" ;
  uppsaegning_nn_1 = mkN "uppsдgning" ;
  uppsaegningslaan_nn_1 = mkN "uppsдgningslеn" neutrum ;
  uppsaegningsraekning_nn_1 = mkN "uppsдgningsrдkning" ;
  uppsaegningstermin_nn_1 = mkN "uppsдgningstermin" "uppsдgningsterminer" ;
  uppsaegningstid_nn_1 = mkN "uppsдgningstid" "uppsдgningstider" ;
  uppsaettare_nn_1 = mkN "uppsдttare" "uppsдttare" ;
  uppsaettning_nn_1 = mkN "uppsдttning" ;
  uppsaettningsinstrument_nn_1 = mkN "uppsдttningsinstrument" neutrum ;
  uppsaettningsmaal_nn_1 = mkN "uppsдttningsmеl" neutrum ;
  uppsagd_av_1 = mkA "uppsagd" "uppsagt" ;
  uppsamling_nn_1 = mkN "uppsamling" ;
  uppsamlingslaeger_nn_1 = mkN "uppsamlingslдger" neutrum ;
  uppsats_nn_1 = mkN "uppsats" "uppsatser" ;
  uppsatslag_nn_1 = mkN "uppsatslag" neutrum ;
  uppsatt_av_1 = mkA "uppsatt" ;
  uppseendevaeckande_av_1 = mkA "uppseendevдckande" ;
  uppsittarkvaell_nn_1 = mkN "uppsittarkvдll" ;
  uppsjungning_nn_1 = mkN "uppsjungning" ;
  uppskaerare_nn_1 = mkN "uppskдrare" "uppskдrare" ;
  uppskakande_av_1 = mkA "uppskakande" ;
  uppskattning_nn_1 = mkN "uppskattning" ;
  uppskattningsvis_ab_1 = mkAdv "uppskattningsvis" ;
  uppskjuta_vb_1 = mkV "uppskjuta" "uppskцt" "uppskjutit" ;
  uppskov_nn_1 = mkN "uppskov" neutrum ;
  uppskrivning_nn_1 = mkN "uppskrivning" ;
  uppslag_nn_1 = mkN "uppslag" neutrum ;
  uppslagsaenda_nn_1 = mkN "uppslagsдnda" "uppslagsдndan" "uppslagsдndar" "uppslagsдndarna" ;
  uppslagsbok_nn_1 = mkN "uppslagsbok" "uppslagsbцcker" ;
  uppslagsform_nn_1 = mkN "uppslagsform" "uppslagsformer" ;
  uppslagsord_nn_1 = mkN "uppslagsord" neutrum ;
  uppslagsrik_av_1 = mkA "uppslagsrik" ;
  uppslagsverk_nn_1 = mkN "uppslagsverk" neutrum ;
  uppslitande_av_1 = mkA "uppslitande" ;
  uppsluppen_av_1 = mkA "uppsluppen" "uppsluppet" ;
  uppsoekande_av_1 = mkA "uppsцkande" ;
  uppspaltning_nn_1 = mkN "uppspaltning" ;
  uppspel_nn_1 = mkN "uppspel" "uppspelet" "uppspel" "uppspelen" ;
  uppspelning_nn_1 = mkN "uppspelning" ;
  uppspelt_av_1 = mkA "uppspelt" "uppspelt" ;
  uppsplittring_nn_1 = mkN "uppsplittring" ;
  uppspraang_nn_1 = mkN "uppsprеng" neutrum ;
  uppspricka_vb_1 = mkV "uppspricka" "uppsprack" "uppspruckit" ;
  uppstaaende_av_1 = mkA "uppstеende" ;
  uppstaanden_av_1 = mkA "uppstеnden" "uppstеndet" ;
  uppstad_nn_1 = mkN "uppstad" "uppstдder" ;
  uppstaellning_nn_1 = mkN "uppstдllning" ;
  uppstaellningsplats_nn_1 = mkN "uppstдllningsplats" "uppstдllningsplatser" ;
  uppstaellningssignal_nn_1 = mkN "uppstдllningssignal" "uppstдllningssignaler" ;
  uppstaellningsspaar_nn_1 = mkN "uppstдllningsspеr" neutrum ;
  uppstiga_vb_1 = mkV "uppstiga" "uppsteg" "uppstigit" ;
  uppstoetning_nn_1 = mkN "uppstцtning" ;
  uppstraak_nn_1 = mkN "uppstrеk" neutrum ;
  uppstraeckning_nn_1 = mkN "uppstrдckning" ;
  uppstraeckt_av_1 = mkA "uppstrдckt" "uppstrдckt" ;
  uppstramning_nn_1 = mkN "uppstramning" ;
  uppstroem_nn_1 = mkN "uppstrцm" "uppstrцmmen" "uppstrцmmar" "uppstrцmmarna" ;
  uppstroems_ab_1 = mkAdv "uppstrцms" ;
  uppstudsig_av_1 = mkA "uppstudsig" ;
  uppsuga_vb_1 = mkV "uppsuga" "uppsцg" "uppsugit" ;
  uppsugning_nn_1 = mkN "uppsugning" ;
  uppsvaelld_av_1 = mkA "uppsvдlld" "uppsvдllt" ;
  uppsvensk_av_1 = mkA "uppsvensk" ;
  uppsving_nn_1 = mkN "uppsving" neutrum ;
  uppsvullen_av_1 = mkA "uppsvullen" "uppsvullet" ;
  uppsyn_nn_1 = mkN "uppsyn" "uppsyner" ;
  uppsyningsman_nn_1 = mkN "uppsyningsman" "uppsyningsmannen" "uppsyningsmдn" "uppsyningsmдnnen" ;
  uppta_vb_1 = mkV "uppta" "upptar" "uppta" "upptog" "upptagit" "upptagen" ;
  upptaag_nn_1 = mkN "upptеg" neutrum ;
  upptaagsmakare_nn_1 = mkN "upptеgsmakare" "upptеgsmakare" ;
  upptaeckare_nn_1 = mkN "upptдckare" "upptдckare" ;
  upptaeckt_nn_1 = mkN "upptдckt" "upptдckter" ;
  upptaecktsfaerd_nn_1 = mkN "upptдcktsfдrd" "upptдcktsfдrder" ;
  upptaecktsresande_nn_1 = mkN "upptдcktsresande" "upptдcktsresanden" "upptдcktsresande" "upptдcktsresandena" ;
  upptaend_av_1 = mkA "upptдnd" ;
  upptaenklig_av_1 = mkA "upptдnklig" ;
  upptagen_av_1 = mkA "upptagen" "upptaget" ;
  upptagenhet_nn_1 = mkN "upptagenhet" "upptagenheter" ;
  upptagning_nn_1 = mkN "upptagning" ;
  upptagningsceremoni_nn_1 = mkN "upptagningsceremoni" "upptagningsceremonier" ;
  upptagningshem_nn_1 = mkN "upptagningshem" "upptagningshemmet" "upptagningshem" "upptagningshemmen" ;
  upptagningsomraade_nn_1 = mkN "upptagningsomrеde" ;
  upptakt_nn_1 = mkN "upptakt" "upptakter" ;
  upptecknare_nn_1 = mkN "upptecknare" "upptecknare" ;
  uppteckning_nn_1 = mkN "uppteckning" ;
  upptill_ab_1 = mkAdv "upptill" ;
  upptraedande_nn_1 = mkN "upptrдdande" ;
  upptrappning_nn_1 = mkN "upptrappning" ;
  upptryck_nn_1 = mkN "upptryck" neutrum ;
  upptryckning_nn_1 = mkN "upptryckning" ;
  upptuktelse_nn_1 = mkN "upptuktelse" "upptuktelser" ;
  uppvaeckelse_nn_1 = mkN "uppvдckelse" "uppvдckelser" ;
  uppvaegning_nn_1 = mkN "uppvдgning" ;
  uppvaktning_nn_1 = mkN "uppvaktning" ;
  uppviglare_nn_1 = mkN "uppviglare" "uppviglare" ;
  uppvigling_nn_1 = mkN "uppvigling" ;
  uppvind_nn_1 = mkN "uppvind" ;
  uppvisning_nn_1 = mkN "uppvisning" ;
  uppvuxen_av_1 = mkA "uppvuxen" "uppvuxet" ;
  ur_ab_1 = mkAdv "ur" ;
  ur_nn_1 = mkN "ur" neutrum ;
  ur_nn_2 = mkN "ur" ;
  uraaldrig_av_1 = mkA "urеldrig" ;
  uraktlaata_vb_1 = mkV "uraktlеta" "uraktlдt" "uraktlеtit" ;
  uraktlaatenhet_nn_1 = mkN "uraktlеtenhet" "uraktlеtenheter" ;
  uralisk_av_1 = mkA "uralisk" ;
  uranglas_nn_1 = mkN "uranglas" neutrum ;
  uranstapel_nn_1 = mkN "uranstapel" ;
  urarva_av_1 = mkA "urarva" ;
  urarvabo_nn_1 = mkN "urarvabo" "urarvabot" "urarvabon" "urarvaboen" ;
  urarvakonkurs_nn_1 = mkN "urarvakonkurs" "urarvakonkurser" ;
  urban_av_1 = mkA "urban" ;
  urbanisering_nn_1 = mkN "urbanisering" ;
  urbanistisk_av_1 = mkA "urbanistisk" ;
  urbanitet_nn_1 = mkN "urbanitet" "urbaniteter" ;
  urbefolkning_nn_1 = mkN "urbefolkning" ;
  urbergsplataa_nn_1 = mkN "urbergsplatе" "urbergsplatеer" ;
  urbergsterraeng_nn_1 = mkN "urbergsterrдng" "urbergsterrдnger" ;
  urbild_nn_1 = mkN "urbild" "urbilder" ;
  urblaast_av_1 = mkA "urblеst" "urblеst" ;
  urblekt_av_1 = mkA "urblekt" "urblekt" ;
  urbota_ab_1 = mkAdv "urbota" ;
  urbraenning_nn_1 = mkN "urbrдnning" ;
  urcell_nn_1 = mkN "urcell" "urceller" ;
  urdaalig_av_1 = mkA "urdеlig" ;
  urdjur_nn_1 = mkN "urdjur" neutrum ;
  urdjurscell_nn_1 = mkN "urdjurscell" "urdjursceller" ;
  urdrucken_av_1 = mkA "urdrucken" "urdrucket" ;
  ureas_nn_1 = mkN "ureas" "ureaser" ;
  uretanplast_nn_1 = mkN "uretanplast" "uretanplaster" ;
  urexplosion_nn_1 = mkN "urexplosion" "urexplosioner" ;
  urfaagel_nn_1 = mkN "urfеgel" ;
  urfaanig_av_1 = mkA "urfеnig" ;
  urfaelld_av_1 = mkA "urfдlld" "urfдllt" ;
  urfjaellsjord_nn_1 = mkN "urfjдllsjord" ;
  urfolk_nn_1 = mkN "urfolk" neutrum ;
  urformation_nn_1 = mkN "urformation" "urformationer" ;
  urgammal_av_1 = mkA "urgammal" "urgammalt" "urgamla" "urдldre" "urдldst" ;
  urgermansk_av_1 = mkA "urgermansk" ;
  urgroepning_nn_1 = mkN "urgrцpning" ;
  urgroept_av_1 = mkA "urgrцpt" "urgrцpt" ;
  urhem_nn_1 = mkN "urhem" "urhemmet" "urhem" "urhemmen" ;
  uribag_nn_1 = mkN "uribag" ;
  uridom_nn_1 = mkN "uridom" "uridomer" ;
  uriebrev_nn_1 = mkN "uriebrev" neutrum ;
  urinavsoendring_nn_1 = mkN "urinavsцndring" ;
  urinbrunn_nn_1 = mkN "urinbrunn" ;
  urinbyggare_nn_1 = mkN "urinbyggare" "urinbyggare" ;
  urindoeuropeisk_av_1 = mkA "urindoeuropeisk" ;
  urindrivande_av_1 = mkA "urindrivande" ;
  urinfoergiftning_nn_1 = mkN "urinfцrgiftning" ;
  urinkur_nn_1 = mkN "urinkur" ;
  urinledare_nn_1 = mkN "urinledare" "urinledare" ;
  urinnevaanare_nn_1 = mkN "urinnevеnare" "urinnevеnare" ;
  urinoar_nn_1 = mkN "urinoar" "urinoarer" ;
  urinorgan_nn_1 = mkN "urinorgan" neutrum ;
  urinprov_nn_1 = mkN "urinprov" neutrum ;
  urinroer_nn_1 = mkN "urinrцr" neutrum ;
  urinstinkt_nn_1 = mkN "urinstinkt" "urinstinkter" ;
  urintraengning_nn_1 = mkN "urintrдngning" ;
  urinvaanare_nn_1 = mkN "urinvеnare" "urinvеnare" ;
  urinvaeg_nn_1 = mkN "urinvдg" ;
  urinvaegsinfektion_nn_1 = mkN "urinvдgsinfektion" "urinvдgsinfektioner" ;
  urkalksten_nn_1 = mkN "urkalksten" "urkalkstenen" "urkalkstenar" "urkalkstenarna" ;
  urklipp_nn_1 = mkN "urklipp" neutrum ;
  urkokt_av_1 = mkA "urkokt" "urkokt" ;
  urkristendom_nn_1 = mkN "urkristendom" ;
  urkund_nn_1 = mkN "urkund" "urkunder" ;
  urkundlig_av_1 = mkA "urkundlig" ;
  urkundsforskning_nn_1 = mkN "urkundsforskning" ;
  urladdare_nn_1 = mkN "urladdare" "urladdare" ;
  urladdning_nn_1 = mkN "urladdning" ;
  urladdningsroer_nn_1 = mkN "urladdningsrцr" neutrum ;
  urlastning_nn_1 = mkN "urlastning" ;
  urledvrickning_nn_1 = mkN "urledvrickning" ;
  urledvridning_nn_1 = mkN "urledvridning" ;
  urmaenniska_nn_1 = mkN "urmдnniska" ;
  urmakare_nn_1 = mkN "urmakare" "urmakare" ;
  urmakeri_nn_1 = mkN "urmakeri" "urmakerit" "urmakerier" "urmakerierna" ;
  urminnes_av_1 = mkA "urminnes" ;
  urminneshaevd_nn_1 = mkN "urminneshдvd" "urminneshдvder" ;
  urmodig_av_1 = mkA "urmodig" ;
  urnebrandgrop_nn_1 = mkN "urnebrandgrop" ;
  urnegrav_nn_1 = mkN "urnegrav" ;
  urngrav_nn_1 = mkN "urngrav" ;
  urnkulle_nn_1 = mkN "urnkulle" utrum ;
  urnordisk_av_1 = mkA "urnordisk" ;
  urnupen_av_1 = mkA "urnupen" "urnupet" ;
  urnyckel_nn_1 = mkN "urnyckel" ;
  urocean_nn_1 = mkN "urocean" "uroceaner" ;
  urogenitalapparat_nn_1 = mkN "urogenitalapparat" "urogenitalapparater" ;
  urogenitaloeppning_nn_1 = mkN "urogenitalцppning" ;
  urogenitalorgan_nn_1 = mkN "urogenitalorgan" neutrum ;
  urolog_nn_1 = mkN "urolog" "urologer" ;
  urologisk_av_1 = mkA "urologisk" ;
  urormbunke_nn_1 = mkN "urormbunke" utrum ;
  uroxe_nn_1 = mkN "uroxe" utrum ;
  urpremiaer_nn_1 = mkN "urpremiдr" "urpremiдrer" ;
  urringning_nn_1 = mkN "urringning" ;
  ursaekt_nn_1 = mkN "ursдkt" "ursдkter" ;
  ursaektlig_av_1 = mkA "ursдktlig" ;
  ursame_nn_1 = mkN "ursame" "ursamer" ;
  ursinnig_av_1 = mkA "ursinnig" ;
  urskiljbar_av_1 = mkA "urskiljbar" ;
  urskiljning_nn_1 = mkN "urskiljning" ;
  urskillningsloes_av_1 = mkA "urskillningslцs" ;
  urskog_nn_1 = mkN "urskog" ;
  urskri_nn_1 = mkN "urskri" "urskrit" "urskrin" "urskrien" ;
  urskuldande_nn_1 = mkN "urskuldande" ;
  ursmaell_nn_1 = mkN "ursmдll" ;
  ursmaellsteori_nn_1 = mkN "ursmдllsteori" "ursmдllsteorier" ;
  ursnygg_av_1 = mkA "ursnygg" ;
  urspaarning_nn_1 = mkN "urspеrning" ;
  urspraak_nn_1 = mkN "ursprеk" neutrum ;
  ursprung_nn_1 = mkN "ursprung" neutrum ;
  ursprunglig_av_1 = mkA "ursprunglig" ;
  ursprungligen_ab_1 = mkAdv "ursprungligen" ;
  ursprungsart_nn_1 = mkN "ursprungsart" "ursprungsarter" ;
  ursprungsattest_nn_1 = mkN "ursprungsattest" "ursprungsattester" ;
  ursprungsbeteckning_nn_1 = mkN "ursprungsbeteckning" ;
  ursprungsbevis_nn_1 = mkN "ursprungsbevis" neutrum ;
  ursprungscell_nn_1 = mkN "ursprungscell" "ursprungsceller" ;
  ursprungscertifikat_nn_1 = mkN "ursprungscertifikat" neutrum ;
  ursprungslaege_nn_1 = mkN "ursprungslдge" ;
  ursprungsland_nn_1 = mkN "ursprungsland" "ursprungslandet" "ursprungslдnder" "ursprungslдnderna" ;
  ursprungsort_nn_1 = mkN "ursprungsort" "ursprungsorter" ;
  urstyv_av_1 = mkA "urstyv" ;
  urtag_nn_1 = mkN "urtag" neutrum ;
  urtagbar_av_1 = mkA "urtagbar" ;
  urtagen_av_1 = mkA "urtagen" "urtaget" ;
  urtappning_nn_1 = mkN "urtappning" ;
  urtavla_nn_1 = mkN "urtavla" ;
  urtext_nn_1 = mkN "urtext" "urtexter" ;
  urtida_av_1 = mkA "urtida" ;
  urtillstaand_nn_1 = mkN "urtillstеnd" neutrum ;
  urtima_av_1 = mkA "urtima" ;
  urtjusig_av_1 = mkA "urtjusig" ;
  urtjuva_av_1 = mkA "urtjuva" ;
  urtyp_nn_1 = mkN "urtyp" "urtyper" ;
  uruguayare_nn_1 = mkN "uruguayare" "uruguayare" ;
  uruguaysk_av_1 = mkA "uruguaysk" ;
  uruppfoerande_nn_1 = mkN "uruppfцrande" ;
  urusel_av_1 = mkA "urusel" "uruselt" "urusla" "urusla" "uruslare" "uruslast" "uruslaste" ;
  urvaext_av_1 = mkA "urvдxt" "urvдxt" ;
  urval_nn_1 = mkN "urval" neutrum ;
  urvalsinstrument_nn_1 = mkN "urvalsinstrument" neutrum ;
  urvalsundersoekning_nn_1 = mkN "urvalsundersцkning" ;
  urverk_nn_1 = mkN "urverk" neutrum ;
  urvuxen_av_1 = mkA "urvuxen" "urvuxet" ;
  usans_nn_1 = mkN "usans" "usanser" ;
  uschlig_av_1 = mkA "uschlig" ;
  usel_av_1 = mkA "usel" "uselt" "usla" "usla" "uslare" "uslast" "uslaste" ;
  uslig_av_1 = mkA "uslig" ;
  usling_nn_1 = mkN "usling" ;
  usuell_av_1 = mkA "usuell" ;
  usurpator_nn_1 = mkN "usurpator" "usurpatorer" ;
  ut_ab_1 = mkAdv "ut" ;
  utaat_ab_1 = mkAdv "utеt" ;
  utaatvaend_av_1 = mkA "utеtvдnd" ;
  utaega_nn_1 = mkN "utдga" ;
  utandning_nn_1 = mkN "utandning" ;
  utanfoer_ab_1 = mkAdv "utanfцr" ;
  utanfoerstaaende_av_1 = mkA "utanfцrstеende" ;
  utanpaa_ab_1 = mkAdv "utanpе" ;
  utanskrift_nn_1 = mkN "utanskrift" "utanskrifter" ;
  utantill_ab_1 = mkAdv "utantill" ;
  utanverk_nn_1 = mkN "utanverk" neutrum ;
  utbaerning_nn_1 = mkN "utbдrning" ;
  utbe_vb_1 = mkV "utbe" "utbad" "utbett" ;
  utbedja_vb_1 = mkV "utbedja" "utbedjar" "utbedja" "utbedjad" "utbedjatt" "utbedjadd" ;
  utbekomma_vb_1 = mkV "utbekomma" "utbekom" "utbekommit" ;
  utbetalning_nn_1 = mkN "utbetalning" ;
  utbetalningskort_nn_1 = mkN "utbetalningskort" neutrum ;
  utbetalningsorder_nn_1 = mkN "utbetalningsorder" ;
  utbildning_nn_1 = mkN "utbildning" ;
  utbildningsbidrag_nn_1 = mkN "utbildningsbidrag" neutrum ;
  utbildningsdepartement_nn_1 = mkN "utbildningsdepartement" "utbildningsdepartementet" "utbildningsdepartementen" "utbildningsdepartementena" ;
  utbildningsgap_nn_1 = mkN "utbildningsgap" neutrum ;
  utbildningslinje_nn_1 = mkN "utbildningslinje" "utbildningslinjer" ;
  utbildningstid_nn_1 = mkN "utbildningstid" "utbildningstider" ;
  utbildningsvaeg_nn_1 = mkN "utbildningsvдg" ;
  utbjuda_vb_1 = mkV "utbjuda" "utbjцd" "utbjudit" ;
  utblaasning_nn_1 = mkN "utblеsning" ;
  utblick_nn_1 = mkN "utblick" ;
  utbo_nn_1 = mkN "utbo" "utbor" ;
  utboeling_nn_1 = mkN "utbцling" ;
  utboerding_nn_1 = mkN "utbцrding" ;
  utbordare_nn_1 = mkN "utbordare" "utbordare" ;
  utbraend_av_1 = mkA "utbrдnd" ;
  utbredd_av_1 = mkA "utbredd" "utbredtt" ;
  utbredningscentrum_nn_1 = mkN "utbredningscentrum" neutrum ;
  utbredningsomraade_nn_1 = mkN "utbredningsomrеde" ;
  utbrista_vb_1 = mkV "utbrista" "utbrast" "utbrustit" ;
  utbrott_nn_1 = mkN "utbrott" neutrum ;
  utbrunnen_av_1 = mkA "utbrunnen" "utbrunnet" "utbrunna" "utbrunna" "utbrunnare" "utbrunnast" "utbrunnaste" ;
  utbryta_vb_1 = mkV "utbryta" "utbrцt" "utbrutit" ;
  utbrytare_nn_1 = mkN "utbrytare" "utbrytare" ;
  utbrytarkung_nn_1 = mkN "utbrytarkung" ;
  utbrytarstat_nn_1 = mkN "utbrytarstat" "utbrytarstater" ;
  utbrytning_nn_1 = mkN "utbrytning" ;
  utbud_nn_1 = mkN "utbud" neutrum ;
  utbuktande_av_1 = mkA "utbuktande" ;
  utbuktning_nn_1 = mkN "utbuktning" ;
  utbyggbar_av_1 = mkA "utbyggbar" ;
  utbyggd_av_1 = mkA "utbyggd" "utbyggt" ;
  utbyggnad_nn_1 = mkN "utbyggnad" "utbyggnader" ;
  utbytbar_av_1 = mkA "utbytbar" ;
  utbyte_nn_1 = mkN "utbyte" ;
  utdebitering_nn_1 = mkN "utdebitering" ;
  utdelning_nn_1 = mkN "utdelning" ;
  utdockning_nn_1 = mkN "utdockning" ;
  utdoed_av_1 = mkA "utdцd" ;
  utdra_vb_1 = mkV "utdra" "utdrar" "utdra" "utdrog" "utdragit" "utdragen" ;
  utdrag_nn_1 = mkN "utdrag" neutrum ;
  utdragare_nn_1 = mkN "utdragare" "utdragare" ;
  utdragbar_av_1 = mkA "utdragbar" ;
  utdragen_av_1 = mkA "utdragen" "utdraget" ;
  utdragning_nn_1 = mkN "utdragning" ;
  utdragssoem_nn_1 = mkN "utdragssцm" "utdragssцmmen" "utdragssцmmar" "utdragssцmmarna" ;
  utdriva_vb_1 = mkV "utdriva" "utdrev" "utdrivit" ;
  utdrucken_av_1 = mkA "utdrucken" "utdrucket" ;
  utdunstning_nn_1 = mkN "utdunstning" ;
  utdunstningskaerl_nn_1 = mkN "utdunstningskдrl" neutrum ;
  ute_ab_1 = mkAdv "ute" ;
  ute_av_1 = mkA "ute" ;
  uteaetare_nn_1 = mkN "uteдtare" "uteдtare" ;
  utedass_nn_1 = mkN "utedass" neutrum ;
  utefaar_nn_1 = mkN "utefеr" neutrum ;
  utegaangsfaar_nn_1 = mkN "utegеngsfеr" neutrum ;
  utegaangsfoerbud_nn_1 = mkN "utegеngsfцrbud" neutrum ;
  utegrill_nn_1 = mkN "utegrill" ;
  utekvaell_nn_1 = mkN "utekvдll" ;
  utelaemningstecken_nn_1 = mkN "utelдmningstecken" "utelдmningstecknet" "utelдmningstecken" "utelдmningstecknen" ;
  utelag_nn_1 = mkN "utelag" neutrum ;
  uteliggande_av_1 = mkA "uteliggande" ;
  uteliggare_nn_1 = mkN "uteliggare" "uteliggare" ;
  uteloepande_av_1 = mkA "utelцpande" ;
  utemiljoe_nn_1 = mkN "utemiljц" "utemiljцn" "utemiljцer" "utemiljцerna" ;
  utemoebel_nn_1 = mkN "utemцbel" "utemцbeln" "utemцbler" "utemцblerna" ;
  uteplats_nn_1 = mkN "uteplats" "uteplatser" ;
  uterum_nn_1 = mkN "uterum" "uterummet" "uterum" "uterummen" ;
  uteservering_nn_1 = mkN "uteservering" ;
  utesluta_vb_1 = mkV "utesluta" "uteslцt" "uteslutit" ;
  uteslutande_ab_1 = mkAdv "uteslutande" ;
  uteslutning_nn_1 = mkN "uteslutning" ;
  utespelare_nn_1 = mkN "utespelare" "utespelare" ;
  utestaaende_av_1 = mkA "utestеende" ;
  utetermometer_nn_1 = mkN "utetermometer" ;
  utfaellbar_av_1 = mkA "utfдllbar" ;
  utfaellning_nn_1 = mkN "utfдllning" ;
  utfaerd_nn_1 = mkN "utfдrd" "utfдrder" ;
  utfaestelse_nn_1 = mkN "utfдstelse" "utfдstelser" ;
  utfall_nn_1 = mkN "utfall" neutrum ;
  utfalla_vb_1 = mkV "utfalla" "utfцll" "utfallit" ;
  utfallsdike_nn_1 = mkN "utfallsdike" ;
  utfallsport_nn_1 = mkN "utfallsport" ;
  utfallsprov_nn_1 = mkN "utfallsprov" neutrum ;
  utfart_nn_1 = mkN "utfart" "utfarter" ;
  utfattig_av_1 = mkA "utfattig" ;
  utfloede_nn_1 = mkN "utflцde" ;
  utflugen_av_1 = mkA "utflugen" "utfluget" ;
  utflykt_nn_1 = mkN "utflykt" "utflykter" ;
  utflyttning_nn_1 = mkN "utflyttning" ;
  utflyttningslaen_nn_1 = mkN "utflyttningslдn" neutrum ;
  utflyttningslaengd_nn_1 = mkN "utflyttningslдngd" "utflyttningslдngder" ;
  utfodringsjournal_nn_1 = mkN "utfodringsjournal" "utfodringsjournaler" ;
  utfodringsstat_nn_1 = mkN "utfodringsstat" "utfodringsstater" ;
  utfoer_ab_1 = mkAdv "utfцr" ;
  utfoerande_nn_1 = mkN "utfцrande" ;
  utfoerbar_av_1 = mkA "utfцrbar" ;
  utfoering_nn_1 = mkN "utfцring" ;
  utfoerlig_av_1 = mkA "utfцrlig" ;
  utfoersaakare_nn_1 = mkN "utfцrsеkare" "utfцrsеkare" ;
  utfoersaeljning_nn_1 = mkN "utfцrsдljning" ;
  utfoersbacke_nn_1 = mkN "utfцrsbacke" utrum ;
  utformning_nn_1 = mkN "utformning" ;
  utforskare_nn_1 = mkN "utforskare" "utforskare" ;
  utforskning_nn_1 = mkN "utforskning" ;
  utfraagning_nn_1 = mkN "utfrеgning" ;
  utfrusen_av_1 = mkA "utfrusen" "utfruset" ;
  utfryst_av_1 = mkA "utfryst" "utfryst" ;
  utfyllnad_nn_1 = mkN "utfyllnad" "utfyllnader" ;
  utfyllning_nn_1 = mkN "utfyllning" ;
  utgaa_vb_1 = mkV "utgе" "utgеr" "utgе" "utgick" "utgеtt" "utgеngen" ;
  utgaang_nn_1 = mkN "utgеng" ;
  utgaangshastighet_nn_1 = mkN "utgеngshastighet" "utgеngshastigheter" ;
  utgaangslaege_nn_1 = mkN "utgеngslдge" ;
  utgaangsmarsch_nn_1 = mkN "utgеngsmarsch" "utgеngsmarscher" ;
  utgaangsmaterial_nn_1 = mkN "utgеngsmaterial" neutrum ;
  utgaangspunkt_nn_1 = mkN "utgеngspunkt" "utgеngspunkter" ;
  utgaangsrad_nn_1 = mkN "utgеngsrad" "utgеngsrader" ;
  utgaangsstaellning_nn_1 = mkN "utgеngsstдllning" ;
  utgaard_nn_1 = mkN "utgеrd" ;
  utgallring_nn_1 = mkN "utgallring" ;
  utge_vb_1 = mkV "utge" "utger" "utge" "utgav" "utgett" "utgiven" ;
  utgift_nn_1 = mkN "utgift" "utgifter" ;
  utgiftsbudget_nn_1 = mkN "utgiftsbudget" ;
  utgiftsskatt_nn_1 = mkN "utgiftsskatt" "utgiftsskatter" ;
  utgiftsverifikation_nn_1 = mkN "utgiftsverifikation" "utgiftsverifikationer" ;
  utgivare_nn_1 = mkN "utgivare" "utgivare" ;
  utgivning_nn_1 = mkN "utgivning" ;
  utgivningsbevis_nn_1 = mkN "utgivningsbevis" neutrum ;
  utgjuta_vb_1 = mkV "utgjuta" "utgцt" "utgjutit" ;
  utgjutelse_nn_1 = mkN "utgjutelse" "utgjutelser" ;
  utgjutning_nn_1 = mkN "utgjutning" ;
  utgoedsling_nn_1 = mkN "utgцdsling" ;
  utgraevare_nn_1 = mkN "utgrдvare" "utgrдvare" ;
  utgraevning_nn_1 = mkN "utgrдvning" ;
  uthaallig_av_1 = mkA "uthеllig" ;
  uthaallighet_nn_1 = mkN "uthеllighet" "uthеlligheter" ;
  uthaallighetsloepning_nn_1 = mkN "uthеllighetslцpning" ;
  uthaallighetstaevling_nn_1 = mkN "uthеllighetstдvling" ;
  uthaerdlig_av_1 = mkA "uthдrdlig" ;
  uthalare_nn_1 = mkN "uthalare" "uthalare" ;
  uthamn_nn_1 = mkN "uthamn" ;
  uthopp_nn_1 = mkN "uthopp" neutrum ;
  uthuggning_nn_1 = mkN "uthuggning" ;
  uthus_nn_1 = mkN "uthus" neutrum ;
  uthyrning_nn_1 = mkN "uthyrning" ;
  uthyrningsrum_nn_1 = mkN "uthyrningsrum" "uthyrningsrummet" "uthyrningsrum" "uthyrningsrummen" ;
  utifraan_ab_1 = mkAdv "utifrеn" ;
  utilist_nn_1 = mkN "utilist" "utilister" ;
  utilistisk_av_1 = mkA "utilistisk" ;
  utilitarist_nn_1 = mkN "utilitarist" "utilitarister" ;
  utilitaristisk_av_1 = mkA "utilitaristisk" ;
  utjaemningsmandat_nn_1 = mkN "utjдmningsmandat" neutrum ;
  utkant_nn_1 = mkN "utkant" "utkanter" ;
  utkast_nn_1 = mkN "utkast" neutrum ;
  utkastare_nn_1 = mkN "utkastare" "utkastare" ;
  utkik_nn_1 = mkN "utkik" ;
  utkikspunkt_nn_1 = mkN "utkikspunkt" "utkikspunkter" ;
  utklaedd_av_1 = mkA "utklдdd" "utklдdtt" ;
  utklassning_nn_1 = mkN "utklassning" ;
  utklipp_nn_1 = mkN "utklipp" neutrum ;
  utklyva_vb_1 = mkV "utklyva" "utklцv" "utkluvit" ;
  utkoerare_nn_1 = mkN "utkцrare" "utkцrare" ;
  utkoerd_av_1 = mkA "utkцrd" "utkцrt" ;
  utkoerning_nn_1 = mkN "utkцrning" ;
  utkomma_vb_1 = mkV "utkomma" "utkom" "utkommit" ;
  utkorelse_nn_1 = mkN "utkorelse" "utkorelser" ;
  utkragning_nn_1 = mkN "utkragning" ;
  utkristallisering_nn_1 = mkN "utkristallisering" ;
  utkyld_av_1 = mkA "utkyld" "utkylt" ;
  utlaanare_nn_1 = mkN "utlеnare" "utlеnare" ;
  utlaaning_nn_1 = mkN "utlеning" ;
  utlaatande_nn_1 = mkN "utlеtande" ;
  utlaatelse_nn_1 = mkN "utlеtelse" "utlеtelser" ;
  utlaegg_nn_1 = mkN "utlдgg" neutrum ;
  utlaeggning_nn_1 = mkN "utlдggning" ;
  utlaemning_nn_1 = mkN "utlдmning" ;
  utlaendsk_av_1 = mkA "utlдndsk" ;
  utlaendska_nn_2 = mkN "utlдndska" ;
  utlaenning_nn_1 = mkN "utlдnning" ;
  utlaerd_av_1 = mkA "utlдrd" "utlдrt" ;
  utlandslektor_nn_1 = mkN "utlandslektor" "utlandslektorer" ;
  utlandssvensk_nn_1 = mkN "utlandssvensk" ;
  utled_av_1 = mkA "utled" ;
  utledsen_av_1 = mkA "utledsen" "utledset" ;
  utljud_nn_1 = mkN "utljud" neutrum ;
  utloepare_nn_1 = mkN "utlцpare" "utlцpare" ;
  utloesare_nn_1 = mkN "utlцsare" "utlцsare" ;
  utloesning_nn_1 = mkN "utlцsning" ;
  utlopp_nn_1 = mkN "utlopp" neutrum ;
  utmaal_nn_1 = mkN "utmеl" neutrum ;
  utmaerkande_av_1 = mkA "utmдrkande" ;
  utmaerkelse_nn_1 = mkN "utmдrkelse" "utmдrkelser" ;
  utmaerkning_nn_1 = mkN "utmдrkning" ;
  utmaerkt_av_1 = mkA "utmдrkt" "utmдrkt" ;
  utmaetning_nn_1 = mkN "utmдtning" ;
  utmanande_av_1 = mkA "utmanande" ;
  utmanare_nn_1 = mkN "utmanare" "utmanare" ;
  utmaning_nn_1 = mkN "utmaning" ;
  utmark_nn_1 = mkN "utmark" "utmarker" ;
  utmarsch_nn_1 = mkN "utmarsch" "utmarscher" ;
  utnoetning_nn_1 = mkN "utnцtning" ;
  utnoett_av_1 = mkA "utnцtt" ;
  utnyttjande_nn_1 = mkN "utnyttjande" ;
  utnyttjare_nn_1 = mkN "utnyttjare" "utnyttjare" ;
  utoevare_nn_1 = mkN "utцvare" "utцvare" ;
  utomaektenskaplig_av_1 = mkA "utomдktenskaplig" ;
  utombordare_nn_1 = mkN "utombordare" "utombordare" ;
  utombords_ab_1 = mkAdv "utombords" ;
  utombordsmotor_nn_1 = mkN "utombordsmotor" "utombordsmotorer" ;
  utombys_ab_1 = mkAdv "utombys" ;
  utomeuropeisk_av_1 = mkA "utomeuropeisk" ;
  utomhus_ab_1 = mkAdv "utomhus" ;
  utomhusbad_nn_1 = mkN "utomhusbad" neutrum ;
  utomhuskonsert_nn_1 = mkN "utomhuskonsert" "utomhuskonserter" ;
  utomkvedshavandeskap_nn_1 = mkN "utomkvedshavandeskap" "utomkvedshavandeskapet" "utomkvedshavandeskapen" "utomkvedshavandeskapena" ;
  utomlands_ab_1 = mkAdv "utomlands" ;
  utomordentlig_av_1 = mkA "utomordentlig" ;
  utomparlamentarisk_av_1 = mkA "utomparlamentarisk" ;
  utomskaers_ab_1 = mkAdv "utomskдrs" ;
  utomstaaende_av_1 = mkA "utomstеende" ;
  utopi_nn_1 = mkN "utopi" "utopier" ;
  utopisk_av_1 = mkA "utopisk" ;
  utopist_nn_1 = mkN "utopist" "utopister" ;
  utpost_nn_1 = mkN "utpost" "utposter" ;
  utpressare_nn_1 = mkN "utpressare" "utpressare" ;
  utpressning_nn_1 = mkN "utpressning" ;
  utprickning_nn_1 = mkN "utprickning" ;
  utraekning_nn_1 = mkN "utrдkning" ;
  utredare_nn_1 = mkN "utredare" "utredare" ;
  utredning_nn_1 = mkN "utredning" ;
  utredningsman_nn_1 = mkN "utredningsman" "utredningsmannen" "utredningsmдn" "utredningsmдnnen" ;
  utrensning_nn_1 = mkN "utrensning" ;
  utresefoerbud_nn_1 = mkN "utresefцrbud" neutrum ;
  utresetillstaand_nn_1 = mkN "utresetillstеnd" neutrum ;
  utriggare_nn_1 = mkN "utriggare" "utriggare" ;
  utrikes_ab_1 = mkAdv "utrikes" ;
  utrikes_av_1 = mkA "utrikes" ;
  utrikesdepartement_nn_1 = mkN "utrikesdepartement" "utrikesdepartementet" "utrikesdepartementen" "utrikesdepartementena" ;
  utrikeshandelsminister_nn_1 = mkN "utrikeshandelsminister" ;
  utrikeskorrespondent_nn_1 = mkN "utrikeskorrespondent" "utrikeskorrespondenter" ;
  utrikesminister_nn_1 = mkN "utrikesminister" ;
  utrikespassagerare_nn_1 = mkN "utrikespassagerare" "utrikespassagerare" ;
  utrikespolitisk_av_1 = mkA "utrikespolitisk" ;
  utrikisk_av_1 = mkA "utrikisk" ;
  utrop_nn_1 = mkN "utrop" neutrum ;
  utropare_nn_1 = mkN "utropare" "utropare" ;
  utropsord_nn_1 = mkN "utropsord" neutrum ;
  utropstecken_nn_1 = mkN "utropstecken" "utropstecknet" "utropstecken" "utropstecknen" ;
  utrotning_nn_1 = mkN "utrotning" ;
  utrustning_nn_1 = mkN "utrustning" ;
  utryckning_nn_1 = mkN "utryckning" ;
  utrymme_nn_1 = mkN "utrymme" ;
  utrymmesstandard_nn_1 = mkN "utrymmesstandard" "utrymmesstandarder" ;
  utsaald_av_1 = mkA "utsеld" "utsеlt" ;
  utsaede_nn_1 = mkN "utsдde" ;
  utsaendning_nn_1 = mkN "utsдndning" ;
  utsaga_nn_1 = mkN "utsaga" ;
  utsagd_av_1 = mkA "utsagd" "utsagt" ;
  utsatt_av_1 = mkA "utsatt" ;
  utseende_nn_1 = mkN "utseende" ;
  utsida_nn_1 = mkN "utsida" ;
  utsikt_nn_1 = mkN "utsikt" "utsikter" ;
  utsiktsloes_av_1 = mkA "utsiktslцs" ;
  utsiktspunkt_nn_1 = mkN "utsiktspunkt" "utsiktspunkter" ;
  utskaapning_nn_1 = mkN "utskеpning" ;
  utskaelld_av_1 = mkA "utskдlld" "utskдllt" ;
  utskaellning_nn_1 = mkN "utskдllning" ;
  utskaemd_av_1 = mkA "utskдmd" "utskдmt" ;
  utskick_nn_1 = mkN "utskick" neutrum ;
  utskjutande_av_1 = mkA "utskjutande" ;
  utskott_nn_1 = mkN "utskott" neutrum ;
  utskrift_nn_1 = mkN "utskrift" "utskrifter" ;
  utskriva_vb_1 = mkV "utskriva" "utskrev" "utskrivit" ;
  utskyld_nn_1 = mkN "utskyld" "utskylder" ;
  utslaepp_nn_1 = mkN "utslдpp" neutrum ;
  utslag_nn_1 = mkN "utslag" neutrum ;
  utslagen_av_1 = mkA "utslagen" "utslaget" ;
  utslagsfraaga_nn_1 = mkN "utslagsfrеga" ;
  utslagsgivande_av_1 = mkA "utslagsgivande" ;
  utslagsroest_nn_1 = mkN "utslagsrцst" "utslagsrцster" ;
  utslagstaevling_nn_1 = mkN "utslagstдvling" ;
  utsliten_av_1 = mkA "utsliten" "utslitet" ;
  utslutning_nn_1 = mkN "utslutning" ;
  utsmyckning_nn_1 = mkN "utsmyckning" ;
  utsnitt_nn_1 = mkN "utsnitt" neutrum ;
  utsocknes_ab_1 = mkAdv "utsocknes" ;
  utsocknes_av_1 = mkA "utsocknes" ;
  utsoekning_nn_1 = mkN "utsцkning" ;
  utsoekt_av_1 = mkA "utsцkt" "utsцkt" ;
  utsoendring_nn_1 = mkN "utsцndring" ;
  utsoendringsorgan_nn_1 = mkN "utsцndringsorgan" neutrum ;
  utsoevd_av_1 = mkA "utsцvd" "utsцvt" ;
  utspaedd_av_1 = mkA "utspдdd" ;
  utspark_nn_1 = mkN "utspark" ;
  utspel_nn_1 = mkN "utspel" "utspelet" "utspel" "utspelen" ;
  utspraang_nn_1 = mkN "utsprеng" neutrum ;
  utsprida_vb_1 = mkV "utsprida" "utspred" "utspritt" ;
  utspridd_av_1 = mkA "utspridd" ;
  utspringande_av_1 = mkA "utspringande" ;
  utsprungen_av_1 = mkA "utsprungen" "utsprunget" ;
  utstaaende_av_1 = mkA "utstеende" ;
  utstaanden_av_1 = mkA "utstеnden" "utstеndet" ;
  utstaellare_nn_1 = mkN "utstдllare" "utstдllare" ;
  utstaelld_av_1 = mkA "utstдlld" "utstдllt" ;
  utstaellelse_nn_1 = mkN "utstдllelse" "utstдllelser" ;
  utstaellning_nn_1 = mkN "utstдllning" ;
  utstraalning_nn_1 = mkN "utstrеlning" ;
  utstyrd_av_1 = mkA "utstyrd" "utstyrt" ;
  utstyrsel_nn_1 = mkN "utstyrsel" ;
  utsuga_vb_1 = mkV "utsuga" "utsцg" "utsugit" ;
  utsvaengd_av_1 = mkA "utsvдngd" "utsvдngt" ;
  utsvaevande_av_1 = mkA "utsvдvande" ;
  utsvaevning_nn_1 = mkN "utsvдvning" ;
  utsvulten_av_1 = mkA "utsvulten" "utsvultet" ;
  uttaag_nn_1 = mkN "uttеg" neutrum ;
  uttaenjd_av_1 = mkA "uttдnjd" "uttдnjt" ;
  uttaenjning_nn_1 = mkN "uttдnjning" ;
  uttaenkt_av_1 = mkA "uttдnkt" "uttдnkt" ;
  uttag_nn_1 = mkN "uttag" neutrum ;
  uttagning_nn_1 = mkN "uttagning" ;
  uttal_nn_1 = mkN "uttal" "uttalet" "uttalen" "uttalena" ;
  uttalande_nn_1 = mkN "uttalande" ;
  uttalsbeteckning_nn_1 = mkN "uttalsbeteckning" ;
  uttalsenlig_av_1 = mkA "uttalsenlig" ;
  uttalsfel_nn_1 = mkN "uttalsfel" "uttalsfelet" "uttalsfel" "uttalsfelen" ;
  uttalstecken_nn_1 = mkN "uttalstecken" "uttalstecknet" "uttalstecken" "uttalstecknen" ;
  utter_nn_1 = mkN "utter" ;
  uttjaent_av_1 = mkA "uttjдnt" "uttjдnt" ;
  uttoejd_av_1 = mkA "uttцjd" "uttцjt" ;
  uttoemmande_av_1 = mkA "uttцmmande" ;
  uttraede_nn_1 = mkN "uttrдde" ;
  uttryck_nn_1 = mkN "uttryck" neutrum ;
  uttrycklig_av_1 = mkA "uttrycklig" ;
  uttryckligen_ab_1 = mkAdv "uttryckligen" ;
  uttrycksform_nn_1 = mkN "uttrycksform" "uttrycksformer" ;
  uttrycksfull_av_1 = mkA "uttrycksfull" ;
  uttrycksloes_av_1 = mkA "uttryckslцs" ;
  uttryckssaett_nn_1 = mkN "uttryckssдtt" neutrum ;
  utvaeg_nn_1 = mkN "utvдg" ;
  utvaendig_av_1 = mkA "utvдndig" ;
  utvaerdering_nn_1 = mkN "utvдrdering" ;
  utvaerdshus_nn_1 = mkN "utvдrdshus" neutrum ;
  utvaertes_ab_1 = mkAdv "utvдrtes" ;
  utvaertes_av_1 = mkA "utvдrtes" ;
  utvaext_nn_1 = mkN "utvдxt" "utvдxter" ;
  utvald_av_1 = mkA "utvald" "utvalt" ;
  utvandrare_nn_1 = mkN "utvandrare" "utvandrare" ;
  utveckling_nn_1 = mkN "utveckling" ;
  utvecklingsland_nn_1 = mkN "utvecklingsland" "utvecklingslandet" "utvecklingslдnder" "utvecklingslдnderna" ;
  utvecklingsmaessig_av_1 = mkA "utvecklingsmдssig" ;
  utvecklingsmoejlighet_nn_1 = mkN "utvecklingsmцjlighet" "utvecklingsmцjligheter" ;
  utvecklingsplan_nn_1 = mkN "utvecklingsplan" neutrum ;
  utvecklingsprocess_nn_1 = mkN "utvecklingsprocess" "utvecklingsprocesser" ;
  utvecklingsrubbning_nn_1 = mkN "utvecklingsrubbning" ;
  utvecklingsserie_nn_1 = mkN "utvecklingsserie" "utvecklingsserier" ;
  utvecklingsskede_nn_1 = mkN "utvecklingsskede" ;
  utvecklingsstadium_nn_1 = mkN "utvecklingsstadium" "utvecklingsstadiet" "utvecklingsstadier" "utvecklingsstadierna" ;
  utvecklingsstoerd_av_1 = mkA "utvecklingsstцrd" "utvecklingsstцrt" ;
  utvecklingsstoerning_nn_1 = mkN "utvecklingsstцrning" ;
  utvecklingstraed_nn_1 = mkN "utvecklingstrдd" neutrum ;
  utvidgning_nn_1 = mkN "utvidgning" ;
  utvikning_nn_1 = mkN "utvikning" ;
  utvikningsbild_nn_1 = mkN "utvikningsbild" "utvikningsbilder" ;
  utvikningsbrud_nn_1 = mkN "utvikningsbrud" ;
  utvikningspojke_nn_1 = mkN "utvikningspojke" utrum ;
  utviksblad_nn_1 = mkN "utviksblad" neutrum ;
  utvinna_vb_1 = mkV "utvinna" "utvann" "utvunnit" ;
  utvinning_nn_1 = mkN "utvinning" ;
  utvisning_nn_1 = mkN "utvisning" ;
  utvisningsbaas_nn_1 = mkN "utvisningsbеs" neutrum ;
  uv_nn_1 = mkN "uv" ;
  uvertyr_nn_1 = mkN "uvertyr" "uvertyrer" ;
  uvular_av_1 = mkA "uvular" ;
  uvular_nn_1 = mkN "uvular" "uvularer" ;
  vaad_nn_1 = mkN "vеd" "vеder" ;
  vaada_nn_1 = mkN "vеda" ;
  vaadeld_nn_1 = mkN "vеdeld" ;
  vaadevill_nn_1 = mkN "vеdevill" "vеdeviller" ;
  vaadlig_av_1 = mkA "vеdlig" ;
  vaadligen_ab_1 = mkAdv "vеdligen" ;
  vaaffeljaern_nn_1 = mkN "vеffeljдrn" neutrum ;
  vaaffla_nn_1 = mkN "vеffla" ;
  vaag_nn_2 = mkN "vеg" ;
  vaagbalans_nn_1 = mkN "vеgbalans" "vеgbalanser" ;
  vaagbrytare_nn_1 = mkN "vеgbrytare" "vеgbrytare" ;
  vaagdal_nn_1 = mkN "vеgdal" ;
  vaagfront_nn_1 = mkN "vеgfront" "vеgfronter" ;
  vaaghaal_nn_1 = mkN "vеghеl" neutrum ;
  vaaghals_nn_1 = mkN "vеghals" ;
  vaaghalsig_av_1 = mkA "vеghalsig" ;
  vaaghoejd_nn_1 = mkN "vеghцjd" "vеghцjder" ;
  vaagig_av_1 = mkA "vеgig" ;
  vaagkam_nn_1 = mkN "vеgkam" "vеgkammen" "vеgkammar" "vеgkammarna" ;
  vaaglaengd_nn_1 = mkN "vеglдngd" "vеglдngder" ;
  vaaglinje_nn_1 = mkN "vеglinje" "vеglinjer" ;
  vaagmaestare_nn_1 = mkN "vеgmдstare" "vеgmдstare" ;
  vaagnatur_nn_1 = mkN "vеgnatur" "vеgnaturer" ;
  vaagplan_nn_1 = mkN "vеgplan" neutrum ;
  vaagraet_av_1 = mkA "vеgrдt" ;
  vaagroerelse_nn_1 = mkN "vеgrцrelse" "vеgrцrelser" ;
  vaagsam_av_1 = mkA "vеgsam" "vеgsamt" "vеgsamma" "vеgsamma" "vеgsammare" "vеgsammast" "vеgsammaste" ;
  vaagskaal_nn_1 = mkN "vеgskеl" ;
  vaagspel_nn_1 = mkN "vеgspel" "vеgspelet" "vеgspel" "vеgspelen" ;
  vaagtopp_nn_1 = mkN "vеgtopp" ;
  vaaldsam_av_1 = mkA "vеldsam" "vеldsamt" "vеldsamma" "vеldsamma" "vеldsammare" "vеldsammast" "vеldsammaste" ;
  vaaldsamhet_nn_1 = mkN "vеldsamhet" "vеldsamheter" ;
  vaaldsbrott_nn_1 = mkN "vеldsbrott" neutrum ;
  vaaldshandling_nn_1 = mkN "vеldshandling" ;
  vaaldsman_nn_1 = mkN "vеldsman" "vеldsmannen" "vеldsmдn" "vеldsmдnnen" ;
  vaaldsmentalitet_nn_1 = mkN "vеldsmentalitet" "vеldsmentaliteter" ;
  vaaldsrotel_nn_1 = mkN "vеldsrotel" ;
  vaaldsscen_nn_1 = mkN "vеldsscen" "vеldsscener" ;
  vaaldsverkare_nn_1 = mkN "vеldsverkare" "vеldsverkare" ;
  vaaldta_vb_1 = mkV "vеldta" "vеldtar" "vеldta" "vеldtog" "vеldtagit" "vеldtagen" ;
  vaaldtaekt_nn_1 = mkN "vеldtдkt" "vеldtдkter" ;
  vaale_nn_1 = mkN "vеle" utrum ;
  vaalm_nn_1 = mkN "vеlm" ;
  vaalnad_nn_1 = mkN "vеlnad" "vеlnader" ;
  vaam_nn_1 = mkN "vеm" "vеmmen" "vеmmar" "vеmmarna" ;
  vaang_nn_1 = mkN "vеng" ;
  vaaning_nn_1 = mkN "vеning" ;
  vaaningssaeng_nn_1 = mkN "vеningssдng" ;
  vaap_nn_1 = mkN "vеp" neutrum ;
  vaapig_av_1 = mkA "vеpig" ;
  vaar_nn_1 = mkN "vеr" ;
  vaaradonis_nn_1 = mkN "vеradonis" ;
  vaard_nn_1 = mkN "vеrd" ;
  vaardagjaemning_nn_1 = mkN "vеrdagjдmning" ;
  vaardanstalt_nn_1 = mkN "vеrdanstalt" "vеrdanstalter" ;
  vaardare_nn_1 = mkN "vеrdare" "vеrdare" ;
  vaardarinna_nn_1 = mkN "vеrdarinna" ;
  vaardavdelning_nn_1 = mkN "vеrdavdelning" ;
  vaardbidrag_nn_1 = mkN "vеrdbidrag" neutrum ;
  vaardcentral_nn_1 = mkN "vеrdcentral" "vеrdcentraler" ;
  vaardhem_nn_1 = mkN "vеrdhem" "vеrdhemmet" "vеrdhem" "vеrdhemmen" ;
  vaardintyg_nn_1 = mkN "vеrdintyg" neutrum ;
  vaardkase_nn_1 = mkN "vеrdkase" utrum ;
  vaardlinje_nn_1 = mkN "vеrdlinje" "vеrdlinjer" ;
  vaardnad_nn_1 = mkN "vеrdnad" "vеrdnader" ;
  vaardnadsbidrag_nn_1 = mkN "vеrdnadsbidrag" neutrum ;
  vaardnadshavare_nn_1 = mkN "vеrdnadshavare" "vеrdnadshavare" ;
  vaardplats_nn_1 = mkN "vеrdplats" "vеrdplatser" ;
  vaardsam_av_1 = mkA "vеrdsam" "vеrdsamt" "vеrdsamma" "vеrdsamma" "vеrdsammare" "vеrdsammast" "vеrdsammaste" ;
  vaardsloes_av_1 = mkA "vеrdslцs" ;
  vaardtagare_nn_1 = mkN "vеrdtagare" "vеrdtagare" ;
  vaardtecken_nn_1 = mkN "vеrdtecken" "vеrdtecknet" "vеrdtecken" "vеrdtecknen" ;
  vaardtraed_nn_1 = mkN "vеrdtrдd" neutrum ;
  vaardyrke_nn_1 = mkN "vеrdyrke" ;
  vaarkaensla_nn_1 = mkN "vеrkдnsla" ;
  vaarlig_av_1 = mkA "vеrlig" ;
  vaarloek_nn_1 = mkN "vеrlцk" ;
  vaarmaanad_nn_1 = mkN "vеrmеnad" "vеrmеnader" ;
  vaarsol_nn_1 = mkN "vеrsol" ;
  vaartbitare_nn_1 = mkN "vеrtbitare" "vеrtbitare" ;
  vaartecken_nn_1 = mkN "vеrtecken" "vеrtecknet" "vеrtecken" "vеrtecknen" ;
  vaartermin_nn_1 = mkN "vеrtermin" "vеrterminer" ;
  vaartgaard_nn_1 = mkN "vеrtgеrd" ;
  vaartig_av_1 = mkA "vеrtig" ;
  vaartkaktus_nn_1 = mkN "vеrtkaktus" ;
  vaartmedel_nn_1 = mkN "vеrtmedel" neutrum ;
  vaartroett_av_1 = mkA "vеrtrцtt" ;
  vaartsvets_nn_1 = mkN "vеrtsvets" ;
  vaartsvin_nn_1 = mkN "vеrtsvin" neutrum ;
  vaarvaext_nn_1 = mkN "vеrvдxt" "vеrvдxter" ;
  vaarvial_nn_1 = mkN "vеrvial" "vеrvialer" ;
  vaarvinter_nn_1 = mkN "vеrvinter" ;
  vaat_av_1 = mkA "vеt" ;
  vaatelement_nn_1 = mkN "vеtelement" neutrum ;
  vaatmark_nn_1 = mkN "vеtmark" "vеtmarker" ;
  vaatservett_nn_1 = mkN "vеtservett" "vеtservetter" ;
  vaatstark_av_1 = mkA "vеtstark" ;
  vaatutrymme_nn_1 = mkN "vеtutrymme" ;
  vaatvaermande_av_1 = mkA "vеtvдrmande" ;
  vaatvara_nn_1 = mkN "vеtvara" ;
  vaatvarm_av_1 = mkA "vеtvarm" ;
  vaccin_nn_1 = mkN "vaccin" neutrum ;
  vaccination_nn_1 = mkN "vaccination" "vaccinationer" ;
  vaccinatoer_nn_1 = mkN "vaccinatцr" "vaccinatцrer" ;
  vaccinering_nn_1 = mkN "vaccinering" ;
  vacker_av_1 = mkA "vacker" "vackert" "vackra" "vackra" "vackrare" "vackrast" "vackraste" ;
  vackert_ab_1 = mkAdv "vackert" ;
  vacuum_nn_1 = mkN "vacuum" neutrum ;
  vad_ab_1 = mkAdv "vad" ;
  vad_nn_1 = mkN "vad" neutrum ;
  vad_nn_2 = mkN "vad" "vader" ;
  vad_nn_3 = mkN "vad" ;
  vadaa_ab_1 = mkAdv "vadе" ;
  vadan_ab_1 = mkAdv "vadan" ;
  vadare_nn_1 = mkN "vadare" "vadare" ;
  vadarfaagel_nn_1 = mkN "vadarfеgel" ;
  vadbar_av_1 = mkA "vadbar" ;
  vadd_nn_1 = mkN "vadd" ;
  vaddering_nn_1 = mkN "vaddering" ;
  vadfot_nn_1 = mkN "vadfot" "vadfцtter" ;
  vadhaallare_nn_1 = mkN "vadhеllare" "vadhеllare" ;
  vadhaallning_nn_1 = mkN "vadhеllning" ;
  vadlaang_av_1 = mkA "vadlеng" ;
  vados_av_1 = mkA "vados" ;
  vadslagning_nn_1 = mkN "vadslagning" ;
  vaebel_nn_1 = mkN "vдbel" ;
  vaeck_ab_1 = mkAdv "vдck" ;
  vaeckare_nn_1 = mkN "vдckare" "vдckare" ;
  vaeckelse_nn_1 = mkN "vдckelse" "vдckelser" ;
  vaeckelsemoete_nn_1 = mkN "vдckelsemцte" ;
  vaeckelseroerelse_nn_1 = mkN "vдckelserцrelse" "vдckelserцrelser" ;
  vaeckning_nn_1 = mkN "vдckning" ;
  vaeder_nn_1 = mkN "vдder" neutrum ;
  vaederbestaendig_av_1 = mkA "vдderbestдndig" ;
  vaederbiten_av_1 = mkA "vдderbiten" "vдderbitet" ;
  vaederfoerhaallande_nn_1 = mkN "vдderfцrhеllande" ;
  vaederil_nn_1 = mkN "vдderil" ;
  vaederkvarn_nn_1 = mkN "vдderkvarn" ;
  vaederlek_nn_1 = mkN "vдderlek" ;
  vaederleksrapport_nn_1 = mkN "vдderleksrapport" "vдderleksrapporter" ;
  vaederprognos_nn_1 = mkN "vдderprognos" "vдderprognoser" ;
  vaederrapport_nn_1 = mkN "vдderrapport" "vдderrapporter" ;
  vaedersatellit_nn_1 = mkN "vдdersatellit" "vдdersatelliter" ;
  vaedersegel_nn_1 = mkN "vдdersegel" neutrum ;
  vaederskepp_nn_1 = mkN "vдderskepp" neutrum ;
  vaedersol_nn_1 = mkN "vдdersol" ;
  vaederspaend_av_1 = mkA "vдderspдnd" ;
  vaederspaenning_nn_1 = mkN "vдderspдnning" ;
  vaederstinn_av_1 = mkA "vдderstinn" "vдderstint" ;
  vaederstreck_nn_1 = mkN "vдderstreck" neutrum ;
  vaedertillstaand_nn_1 = mkN "vдdertillstеnd" neutrum ;
  vaedjande_nn_1 = mkN "vдdjande" ;
  vaedur_nn_1 = mkN "vдdur" ;
  vaeg_ab_1 = mkAdv "vдg" ;
  vaeg_nn_1 = mkN "vдg" ;
  vaegare_nn_1 = mkN "vдgare" "vдgare" ;
  vaegbelaeggning_nn_1 = mkN "vдgbelдggning" ;
  vaegbom_nn_1 = mkN "vдgbom" "vдgbommen" "vдgbommar" "vдgbommarna" ;
  vaegbro_nn_1 = mkN "vдgbro" ;
  vaegbrytare_nn_1 = mkN "vдgbrytare" "vдgbrytare" ;
  vaegegenskap_nn_1 = mkN "vдgegenskap" "vдgegenskaper" ;
  vaegfaerja_nn_1 = mkN "vдgfдrja" ;
  vaegfarande_nn_1 = mkN "vдgfarande" "vдgfaranden" "vдgfarande" "vдgfarandena" ;
  vaegfoerbindelse_nn_1 = mkN "vдgfцrbindelse" "vдgfцrbindelser" ;
  vaegfoerening_nn_1 = mkN "vдgfцrening" ;
  vaegfoervaltning_nn_1 = mkN "vдgfцrvaltning" ;
  vaegg_nn_1 = mkN "vдgg" ;
  vaeggband_nn_1 = mkN "vдggband" neutrum ;
  vaeggbonad_nn_1 = mkN "vдggbonad" "vдggbonader" ;
  vaeggfast_av_1 = mkA "vдggfast" "vдggfast" ;
  vaegglus_nn_1 = mkN "vдgglus" "vдgglusen" "vдgglцss" "vдgglцssen" ;
  vaeggmadam_nn_1 = mkN "vдggmadam" "vдggmadammen" "vдggmadammer" "vдggmadammerna" ;
  vaeggpelare_nn_1 = mkN "vдggpelare" "vдggpelare" ;
  vaeggtelefon_nn_1 = mkN "vдggtelefon" "vдggtelefoner" ;
  vaeggtidning_nn_1 = mkN "vдggtidning" ;
  vaegguttag_nn_1 = mkN "vдgguttag" neutrum ;
  vaeghyvel_nn_1 = mkN "vдghyvel" ;
  vaegkant_nn_1 = mkN "vдgkant" "vдgkanter" ;
  vaegkors_nn_1 = mkN "vдgkors" neutrum ;
  vaegkorsning_nn_1 = mkN "vдgkorsning" ;
  vaeglag_nn_1 = mkN "vдglag" neutrum ;
  vaeglag_nn_2 = mkN "vдglag" ;
  vaegledande_av_1 = mkA "vдgledande" ;
  vaegledning_nn_1 = mkN "vдgledning" ;
  vaeglus_nn_1 = mkN "vдglus" "vдglusen" "vдglцss" "vдglцssen" ;
  vaegmaerke_nn_1 = mkN "vдgmдrke" ;
  vaegmaetare_nn_1 = mkN "vдgmдtare" "vдgmдtare" ;
  vaegmaskin_nn_1 = mkN "vдgmaskin" "vдgmaskiner" ;
  vaegnaet_nn_1 = mkN "vдgnдt" neutrum ;
  vaegning_nn_1 = mkN "vдgning" ;
  vaegport_nn_1 = mkN "vдgport" ;
  vaegrare_nn_1 = mkN "vдgrare" "vдgrare" ;
  vaegren_nn_1 = mkN "vдgren" "vдgrenen" "vдgrenar" "vдgrenarna" ;
  vaegroejare_nn_1 = mkN "vдgrцjare" "vдgrцjare" ;
  vaegskael_nn_1 = mkN "vдgskдl" neutrum ;
  vaegskylt_nn_1 = mkN "vдgskylt" ;
  vaegtistel_nn_1 = mkN "vдgtistel" ;
  vaegtorn_nn_1 = mkN "vдgtorn" ;
  vaegtunnel_nn_1 = mkN "vдgtunnel" ;
  vaegvinnande_av_1 = mkA "vдgvinnande" ;
  vaegvisare_nn_1 = mkN "vдgvisare" "vдgvisare" ;
  vaejning_nn_1 = mkN "vдjning" ;
  vaekt_nn_1 = mkN "vдkt" "vдkter" ;
  vaektare_nn_1 = mkN "vдktare" "vдktare" ;
  vael_1_ab_1 = mkAdv "vдl" ;
  vael_2_ab_1 = mkAdv "vдl" ;
  vaelan_ab_1 = mkAdv "vдlan" ;
  vaelavvaegd_av_1 = mkA "vдlavvдgd" "vдlavvдgt" ;
  vaelbegriplig_av_1 = mkA "vдlbegriplig" ;
  vaelbehaallen_av_1 = mkA "vдlbehеllen" "vдlbehеllet" ;
  vaelbehoevlig_av_1 = mkA "vдlbehцvlig" ;
  vaelbekant_av_1 = mkA "vдlbekant" "vдlbekant" ;
  vaelbelaegen_av_1 = mkA "vдlbelдgen" "vдlbelдget" ;
  vaelbesatt_av_1 = mkA "vдlbesatt" ;
  vaelbesoekt_av_1 = mkA "vдlbesцkt" "vдlbesцkt" ;
  vaelbestaelld_av_1 = mkA "vдlbestдlld" "vдlbestдllt" ;
  vaelbetaenkt_av_1 = mkA "vдlbetдnkt" "vдlbetдnkt" ;
  vaelbetald_av_1 = mkA "vдlbetald" "vдlbetalt" ;
  vaelboren_av_1 = mkA "vдlboren" "vдlboret" ;
  vaelbyggd_av_1 = mkA "vдlbyggd" "vдlbyggt" ;
  vaeldeliga_ab_1 = mkAdv "vдldeliga" ;
  vaeldeligen_ab_1 = mkAdv "vдldeligen" ;
  vaeldig_av_1 = mkA "vдldig" ;
  vaeldoftande_av_1 = mkA "vдldoftande" ;
  vaelfaegnad_nn_1 = mkN "vдlfдgnad" "vдlfдgnader" ;
  vaelfaerdskris_nn_1 = mkN "vдlfдrdskris" "vдlfдrdskriser" ;
  vaelfaerdsstat_nn_1 = mkN "vдlfдrdsstat" "vдlfдrdsstater" ;
  vaelfoedd_av_1 = mkA "vдlfцdd" ;
  vaelfoerenlig_av_1 = mkA "vдlfцrenlig" ;
  vaelfoerklarlig_av_1 = mkA "vдlfцrklarlig" ;
  vaelfoersedd_av_1 = mkA "vдlfцrsedd" "vдlfцrsedtt" ;
  vaelfoerstaadd_av_1 = mkA "vдlfцrstеdd" "vдlfцrstеdtt" ;
  vaelfoerstaaelig_av_1 = mkA "vдlfцrstеelig" ;
  vaelfoerstaandig_av_1 = mkA "vдlfцrstеndig" ;
  vaelfoertjaent_av_1 = mkA "vдlfцrtjдnt" "vдlfцrtjдnt" ;
  vaelfunnen_av_1 = mkA "vдlfunnen" "vдlfunnet" "vдlfunna" "vдlfunna" "vдlfunnare" "vдlfunnast" "vдlfunnaste" ;
  vaelfylld_av_1 = mkA "vдlfylld" "vдlfyllt" ;
  vaelgaerning_nn_1 = mkN "vдlgдrning" ;
  vaelgjord_av_1 = mkA "vдlgjord" "vдlgjort" ;
  vaelgoedd_av_1 = mkA "vдlgцdd" ;
  vaelgoerande_av_1 = mkA "vдlgцrande" ;
  vaelgoerare_nn_1 = mkN "vдlgцrare" "vдlgцrare" ;
  vaelgoerenhet_nn_1 = mkN "vдlgцrenhet" "vдlgцrenheter" ;
  vaelgoerenhetsbasar_nn_1 = mkN "vдlgцrenhetsbasar" "vдlgцrenhetsbasarer" ;
  vaelhaallen_av_1 = mkA "vдlhеllen" "vдlhеllet" ;
  vaelhaengd_av_1 = mkA "vдlhдngd" "vдlhдngt" ;
  vaeljarbarometer_nn_1 = mkN "vдljarbarometer" ;
  vaeljare_nn_1 = mkN "vдljare" "vдljare" ;
  vaeljarkaar_nn_1 = mkN "vдljarkеr" "vдljarkеrer" ;
  vaelkaend_av_1 = mkA "vдlkдnd" ;
  vaelklaedd_av_1 = mkA "vдlklдdd" "vдlklдdtt" ;
  vaelklingande_av_1 = mkA "vдlklingande" ;
  vaelkommen_av_1 = mkA "vдlkommen" "vдlkommet" "vдlkomna" "vдlkomna" "vдlkomnare" "vдlkomnast" "vдlkomnaste" ;
  vaelkomstskaal_nn_1 = mkN "vдlkomstskеl" ;
  vaell_nn_1 = mkN "vдll" ;
  vaellevnad_nn_1 = mkN "vдllevnad" "vдllevnader" ;
  vaelling_nn_1 = mkN "vдlling" ;
  vaellingliknande_av_1 = mkA "vдllingliknande" ;
  vaelljaern_nn_1 = mkN "vдlljдrn" neutrum ;
  vaelljudande_av_1 = mkA "vдlljudande" ;
  vaellning_nn_1 = mkN "vдllning" ;
  vaellovlig_av_1 = mkA "vдllovlig" ;
  vaelluktande_av_1 = mkA "vдlluktande" ;
  vaellustig_av_1 = mkA "vдllustig" ;
  vaellusting_nn_1 = mkN "vдllusting" ;
  vaelmaaende_av_1 = mkA "vдlmеende" ;
  vaelmenande_av_1 = mkA "vдlmenande" ;
  vaelment_av_1 = mkA "vдlment" "vдlment" ;
  vaelnaerd_av_1 = mkA "vдlnдrd" "vдlnдrt" ;
  vaelsedd_av_1 = mkA "vдlsedd" "vдlsedtt" ;
  vaelsignelse_nn_1 = mkN "vдlsignelse" "vдlsignelser" ;
  vaelsignelsebringande_av_1 = mkA "vдlsignelsebringande" ;
  vaelsittande_av_1 = mkA "vдlsittande" ;
  vaelsk_av_1 = mkA "vдlsk" ;
  vaelskapt_av_1 = mkA "vдlskapt" "vдlskapt" ;
  vaelskjutande_av_1 = mkA "vдlskjutande" ;
  vaelskoett_av_1 = mkA "vдlskцtt" ;
  vaelskriven_av_1 = mkA "vдlskriven" "vдlskrivet" ;
  vaelskuren_av_1 = mkA "vдlskuren" "vдlskuret" ;
  vaelsmakande_av_1 = mkA "vдlsmakande" ;
  vaelsmord_av_1 = mkA "vдlsmord" "vдlsmort" ;
  vaelstaelld_av_1 = mkA "vдlstдlld" "vдlstдllt" ;
  vaelstekt_av_1 = mkA "vдlstekt" "vдlstekt" ;
  vaelt_nn_1 = mkN "vдlt" ;
  vaeltagen_av_1 = mkA "vдltagen" "vдltaget" ;
  vaeltalare_nn_1 = mkN "vдltalare" "vдltalare" ;
  vaeltalig_av_1 = mkA "vдltalig" ;
  vaeltalighet_nn_1 = mkN "vдltalighet" "vдltaligheter" ;
  vaelvaext_av_1 = mkA "vдlvдxt" "vдlvдxt" ;
  vaelvd_av_1 = mkA "vдlvd" "vдlvt" ;
  vaelvillig_av_1 = mkA "vдlvillig" ;
  vaelvis_av_1 = mkA "vдlvis" ;
  vaelvning_nn_1 = mkN "vдlvning" ;
  vaelvuxen_av_1 = mkA "vдlvuxen" "vдlvuxet" ;
  vaemjelig_av_1 = mkA "vдmjelig" ;
  vaen_av_1 = mkA "vдn" ;
  vaen_nn_1 = mkN "vдn" "vдnnen" "vдnner" "vдnnerna" ;
  vaendbar_av_1 = mkA "vдndbar" ;
  vaendelrot_nn_1 = mkN "vдndelrot" "vдndelrцtter" ;
  vaendkors_nn_1 = mkN "vдndkors" neutrum ;
  vaendkrets_nn_1 = mkN "vдndkrets" ;
  vaendning_nn_1 = mkN "vдndning" ;
  vaendplats_nn_1 = mkN "vдndplats" "vдndplatser" ;
  vaendpunkt_nn_1 = mkN "vдndpunkt" "vдndpunkter" ;
  vaendradie_nn_1 = mkN "vдndradie" "vдndradier" ;
  vaendrostning_nn_1 = mkN "vдndrostning" ;
  vaendsydd_av_1 = mkA "vдndsydd" "vдndsydtt" ;
  vaenfast_av_1 = mkA "vдnfast" "vдnfast" ;
  vaeninna_nn_1 = mkN "vдninna" ;
  vaenkrets_nn_1 = mkN "vдnkrets" ;
  vaenlig_av_1 = mkA "vдnlig" ;
  vaenligen_ab_1 = mkAdv "vдnligen" ;
  vaenlighet_nn_1 = mkN "vдnlighet" "vдnligheter" ;
  vaenort_nn_1 = mkN "vдnort" "vдnorter" ;
  vaenpris_nn_1 = mkN "vдnpris" neutrum ;
  vaensaell_av_1 = mkA "vдnsдll" ;
  vaenskaplig_av_1 = mkA "vдnskaplig" ;
  vaenskapligen_ab_1 = mkAdv "vдnskapligen" ;
  vaenskaplighet_nn_1 = mkN "vдnskaplighet" "vдnskapligheter" ;
  vaenskapsfoerbindelse_nn_1 = mkN "vдnskapsfцrbindelse" "vдnskapsfцrbindelser" ;
  vaenskapsmatch_nn_1 = mkN "vдnskapsmatch" "vдnskapsmatcher" ;
  vaenskapspris_nn_1 = mkN "vдnskapspris" neutrum ;
  vaensterflygel_nn_1 = mkN "vдnsterflygel" ;
  vaensterhaent_av_1 = mkA "vдnsterhдnt" "vдnsterhдnt" ;
  vaensterhand_nn_1 = mkN "vдnsterhand" "vдnsterhдnder" ;
  vaensterhandsspelare_nn_1 = mkN "vдnsterhandsspelare" "vдnsterhandsspelare" ;
  vaensterknaeck_nn_1 = mkN "vдnsterknдck" neutrum ;
  vaensterparti_nn_1 = mkN "vдnsterparti" "vдnsterpartit" "vдnsterpartier" "vдnsterpartierna" ;
  vaensterradikal_av_1 = mkA "vдnsterradikal" ;
  vaensterradikal_nn_1 = mkN "vдnsterradikal" "vдnsterradikaler" ;
  vaenstervriden_av_1 = mkA "vдnstervriden" "vдnstervridet" ;
  vaentetid_nn_1 = mkN "vдntetid" "vдntetider" ;
  vaentevaerde_nn_1 = mkN "vдntevдrde" ;
  vaenthall_nn_1 = mkN "vдnthall" ;
  vaentjaenst_nn_1 = mkN "vдntjдnst" "vдntjдnster" ;
  vaentrum_nn_1 = mkN "vдntrum" "vдntrummet" "vдntrum" "vдntrummen" ;
  vaentsal_nn_1 = mkN "vдntsal" ;
  vaepnare_nn_1 = mkN "vдpnare" "vдpnare" ;
  vaeppling_nn_1 = mkN "vдppling" ;
  vaerd_av_1 = mkA "vдrd" "vдrt" ;
  vaerd_nn_1 = mkN "vдrd" ;
  vaerddjur_nn_1 = mkN "vдrddjur" neutrum ;
  vaerdeanalys_nn_1 = mkN "vдrdeanalys" "vдrdeanalyser" ;
  vaerdebestaendig_av_1 = mkA "vдrdebestдndig" ;
  vaerdebrev_nn_1 = mkN "vдrdebrev" neutrum ;
  vaerdefast_av_1 = mkA "vдrdefast" "vдrdefast" ;
  vaerdefoeremaal_nn_1 = mkN "vдrdefцremеl" neutrum ;
  vaerdefoersaendelse_nn_1 = mkN "vдrdefцrsдndelse" "vдrdefцrsдndelser" ;
  vaerdefull_av_1 = mkA "vдrdefull" ;
  vaerdehandling_nn_1 = mkN "vдrdehandling" ;
  vaerdeloes_av_1 = mkA "vдrdelцs" ;
  vaerdemaengd_nn_1 = mkN "vдrdemдngd" "vдrdemдngder" ;
  vaerdemaessig_av_1 = mkA "vдrdemдssig" ;
  vaerdemaetare_nn_1 = mkN "vдrdemдtare" "vдrdemдtare" ;
  vaerdeminskning_nn_1 = mkN "vдrdeminskning" ;
  vaerdeoekning_nn_1 = mkN "vдrdeцkning" ;
  vaerdepapper_nn_1 = mkN "vдrdepapper" neutrum ;
  vaerderare_nn_1 = mkN "vдrderare" "vдrderare" ;
  vaerdering_nn_1 = mkN "vдrdering" ;
  vaerderingsfri_av_1 = mkA "vдrderingsfri" "vдrderingsfritt" ;
  vaerderingsinstrument_nn_1 = mkN "vдrderingsinstrument" neutrum ;
  vaerderingsman_nn_1 = mkN "vдrderingsman" "vдrderingsmannen" "vдrderingsmдn" "vдrderingsmдnnen" ;
  vaerderingsnorm_nn_1 = mkN "vдrderingsnorm" "vдrderingsnormer" ;
  vaerdesaeker_av_1 = mkA "vдrdesдker" "vдrdesдkert" "vдrdesдkra" "vдrdesдkra" "vдrdesдkrare" "vдrdesдkrast" "vдrdesдkraste" ;
  vaerdesak_nn_1 = mkN "vдrdesak" "vдrdesaker" ;
  vaerdestegring_nn_1 = mkN "vдrdestegring" ;
  vaerdetabell_nn_1 = mkN "vдrdetabell" "vдrdetabeller" ;
  vaerdfamilj_nn_1 = mkN "vдrdfamilj" "vдrdfamiljer" ;
  vaerdfolk_nn_1 = mkN "vдrdfolk" neutrum ;
  vaerdig_av_1 = mkA "vдrdig" ;
  vaerdighet_nn_1 = mkN "vдrdighet" "vдrdigheter" ;
  vaerdinna_nn_1 = mkN "vдrdinna" ;
  vaerdshus_nn_1 = mkN "vдrdshus" neutrum ;
  vaerdvaexling_nn_1 = mkN "vдrdvдxling" ;
  vaerdvaext_nn_1 = mkN "vдrdvдxt" "vдrdvдxter" ;
  vaering_nn_1 = mkN "vдring" ;
  vaerjemaalsed_nn_1 = mkN "vдrjemеlsed" "vдrjemеlseder" ;
  vaerk_nn_1 = mkN "vдrk" ;
  vaerkbruten_av_1 = mkA "vдrkbruten" "vдrkbrutet" ;
  vaerld_nn_1 = mkN "vдrld" ;
  vaerldsaalder_nn_1 = mkN "vдrldsеlder" ;
  vaerldsaaskaadning_nn_1 = mkN "vдrldsеskеdning" ;
  vaerldsartist_nn_1 = mkN "vдrldsartist" "vдrldsartister" ;
  vaerldsatlas_nn_1 = mkN "vдrldsatlas" "vдrldsatlaser" ;
  vaerldsaxel_nn_1 = mkN "vдrldsaxel" ;
  vaerldsbekant_av_1 = mkA "vдrldsbekant" "vдrldsbekant" ;
  vaerldsberoemd_av_1 = mkA "vдrldsberцmd" "vдrldsberцmt" ;
  vaerldsberoemdhet_nn_1 = mkN "vдrldsberцmdhet" "vдrldsberцmdheter" ;
  vaerldsbild_nn_1 = mkN "vдrldsbild" "vдrldsbilder" ;
  vaerldsborgare_nn_1 = mkN "vдrldsborgare" "vдrldsborgare" ;
  vaerldsbrand_nn_1 = mkN "vдrldsbrand" "vдrldsbrдnder" ;
  vaerldsdam_nn_1 = mkN "vдrldsdam" "vдrldsdamer" ;
  vaerldsdel_nn_1 = mkN "vдrldsdel" "vдrldsdelen" "vдrldsdelar" "vдrldsdelarna" ;
  vaerldsfientlig_av_1 = mkA "vдrldsfientlig" ;
  vaerldsfoerbaettrare_nn_1 = mkN "vдrldsfцrbдttrare" "vдrldsfцrbдttrare" ;
  vaerldsfoersakelse_nn_1 = mkN "vдrldsfцrsakelse" "vдrldsfцrsakelser" ;
  vaerldsfraanvaend_av_1 = mkA "vдrldsfrеnvдnd" ;
  vaerldsfraanvarande_av_1 = mkA "vдrldsfrеnvarande" ;
  vaerldsfraemmande_av_1 = mkA "vдrldsfrдmmande" ;
  vaerldshav_nn_1 = mkN "vдrldshav" neutrum ;
  vaerldshistorisk_av_1 = mkA "vдrldshistorisk" ;
  vaerldsklok_av_1 = mkA "vдrldsklok" ;
  vaerldskrig_nn_1 = mkN "vдrldskrig" neutrum ;
  vaerldslig_av_1 = mkA "vдrldslig" ;
  vaerldsmaestare_nn_1 = mkN "vдrldsmдstare" "vдrldsmдstare" ;
  vaerldsmaestarinna_nn_1 = mkN "vдrldsmдstarinna" ;
  vaerldsmaesterskap_nn_1 = mkN "vдrldsmдsterskap" "vдrldsmдsterskapet" "vдrldsmдsterskapen" "vдrldsmдsterskapena" ;
  vaerldsmakt_nn_1 = mkN "vдrldsmakt" "vдrldsmakter" ;
  vaerldsman_nn_1 = mkN "vдrldsman" "vдrldsmannen" "vдrldsmдn" "vдrldsmдnnen" ;
  vaerldsmarknad_nn_1 = mkN "vдrldsmarknad" "vдrldsmarknader" ;
  vaerldsmedborgare_nn_1 = mkN "vдrldsmedborgare" "vдrldsmedborgare" ;
  vaerldsnamn_nn_1 = mkN "vдrldsnamn" neutrum ;
  vaerldsomfattande_av_1 = mkA "vдrldsomfattande" ;
  vaerldsomsegling_nn_1 = mkN "vдrldsomsegling" ;
  vaerldsomstoertande_av_1 = mkA "vдrldsomstцrtande" ;
  vaerldsomvaelvande_av_1 = mkA "vдrldsomvдlvande" ;
  vaerldsorganisation_nn_1 = mkN "vдrldsorganisation" "vдrldsorganisationer" ;
  vaerldsrekord_nn_1 = mkN "vдrldsrekord" neutrum ;
  vaerldsreligion_nn_1 = mkN "vдrldsreligion" "vдrldsreligioner" ;
  vaerldsrevolution_nn_1 = mkN "vдrldsrevolution" "vдrldsrevolutioner" ;
  vaerldsrymd_nn_1 = mkN "vдrldsrymd" "vдrldsrymder" ;
  vaerldsspraak_nn_1 = mkN "vдrldssprеk" neutrum ;
  vaerldsstad_nn_1 = mkN "vдrldsstad" "vдrldsstдder" ;
  vaerldstid_nn_1 = mkN "vдrldstid" "vдrldstider" ;
  vaerldsutstaellning_nn_1 = mkN "vдrldsutstдllning" ;
  vaerldsvan_av_1 = mkA "vдrldsvan" ;
  vaerldsvis_av_1 = mkA "vдrldsvis" ;
  vaermeaaskvaeder_nn_1 = mkN "vдrmeеskvдder" neutrum ;
  vaermeaelskande_av_1 = mkA "vдrmeдlskande" ;
  vaermeanlaeggning_nn_1 = mkN "vдrmeanlдggning" ;
  vaermebehandling_nn_1 = mkN "vдrmebehandling" ;
  vaermebehov_nn_1 = mkN "vдrmebehov" neutrum ;
  vaermebestaendig_av_1 = mkA "vдrmebestдndig" ;
  vaermebild_nn_1 = mkN "vдrmebild" "vдrmebilder" ;
  vaermebildskamera_nn_1 = mkN "vдrmebildskamera" ;
  vaermeboelja_nn_1 = mkN "vдrmebцlja" ;
  vaermecentral_nn_1 = mkN "vдrmecentral" "vдrmecentraler" ;
  vaermeekonomi_nn_1 = mkN "vдrmeekonomi" "vдrmeekonomier" ;
  vaermeelement_nn_1 = mkN "vдrmeelement" neutrum ;
  vaermeenhet_nn_1 = mkN "vдrmeenhet" "vдrmeenheter" ;
  vaermefloede_nn_1 = mkN "vдrmeflцde" ;
  vaermefoerlust_nn_1 = mkN "vдrmefцrlust" "vдrmefцrluster" ;
  vaermegenomgaangstal_nn_1 = mkN "vдrmegenomgеngstal" "vдrmegenomgеngstalet" "vдrmegenomgеngstalen" "vдrmegenomgеngstalena" ;
  vaermegrad_nn_1 = mkN "vдrmegrad" "vдrmegrader" ;
  vaermeisolator_nn_1 = mkN "vдrmeisolator" "vдrmeisolatorer" ;
  vaermeisolerande_av_1 = mkA "vдrmeisolerande" ;
  vaermekamera_nn_1 = mkN "vдrmekamera" ;
  vaermekapacitet_nn_1 = mkN "vдrmekapacitet" "vдrmekapaciteter" ;
  vaermekapacitivitet_nn_1 = mkN "vдrmekapacitivitet" "vдrmekapacitiviteter" ;
  vaermekonduktivitet_nn_1 = mkN "vдrmekonduktivitet" "vдrmekonduktiviteter" ;
  vaermekostnad_nn_1 = mkN "vдrmekostnad" "vдrmekostnader" ;
  vaermekraftverk_nn_1 = mkN "vдrmekraftverk" neutrum ;
  vaermekrus_nn_1 = mkN "vдrmekrus" neutrum ;
  vaermeledare_nn_1 = mkN "vдrmeledare" "vдrmeledare" ;
  vaermeledning_nn_1 = mkN "vдrmeledning" ;
  vaermeledningssystem_nn_1 = mkN "vдrmeledningssystem" neutrum ;
  vaermemaatt_nn_1 = mkN "vдrmemеtt" neutrum ;
  vaermemaengd_nn_1 = mkN "vдrmemдngd" "vдrmemдngder" ;
  vaermemotor_nn_1 = mkN "vдrmemotor" "vдrmemotorer" ;
  vaermepump_nn_1 = mkN "vдrmepump" ;
  vaermeskaap_nn_1 = mkN "vдrmeskеp" neutrum ;
  vaermeskoeld_nn_1 = mkN "vдrmeskцld" ;
  vaermestuga_nn_1 = mkN "vдrmestuga" ;
  vaermetillaegg_nn_1 = mkN "vдrmetillдgg" neutrum ;
  vaermeutbyte_nn_1 = mkN "vдrmeutbyte" ;
  vaermevaexlare_nn_1 = mkN "vдrmevдxlare" "vдrmevдxlare" ;
  vaermeverk_nn_1 = mkN "vдrmeverk" neutrum ;
  vaermlaendsk_av_1 = mkA "vдrmlдndsk" ;
  vaermlaendska_nn_2 = mkN "vдrmlдndska" ;
  vaermlaenning_nn_1 = mkN "vдrmlдnning" ;
  vaern_nn_1 = mkN "vдrn" neutrum ;
  vaernfaagel_nn_1 = mkN "vдrnfеgel" ;
  vaernloes_av_1 = mkA "vдrnlцs" ;
  vaernpliktig_av_1 = mkA "vдrnpliktig" ;
  vaernpliktsriksdag_nn_1 = mkN "vдrnpliktsriksdag" ;
  vaernpliktstjaenstgoering_nn_1 = mkN "vдrnpliktstjдnstgцring" ;
  vaernpliktsvaegrare_nn_1 = mkN "vдrnpliktsvдgrare" "vдrnpliktsvдgrare" ;
  vaersting_nn_1 = mkN "vдrsting" ;
  vaert_av_1 = mkA "vдrt" ;
  vaerv_nn_1 = mkN "vдrv" neutrum ;
  vaervning_nn_1 = mkN "vдrvning" ;
  vaesen_nn_2 = mkN "vдsen" neutrum ;
  vaesende_nn_1 = mkN "vдsende" ;
  vaesentlig_av_1 = mkA "vдsentlig" ;
  vaesentligen_ab_1 = mkAdv "vдsentligen" ;
  vaesentlighet_nn_1 = mkN "vдsentlighet" "vдsentligheter" ;
  vaeskryckare_nn_1 = mkN "vдskryckare" "vдskryckare" ;
  vaesning_nn_1 = mkN "vдsning" ;
  vaest_ab_1 = mkAdv "vдst" ;
  vaest_nn_1 = mkN "vдst" ;
  vaestan_ab_1 = mkAdv "vдstan" ;
  vaestanflaekt_nn_1 = mkN "vдstanflдkt" ;
  vaestanhavs_ab_1 = mkAdv "vдstanhavs" ;
  vaester_ab_1 = mkAdv "vдster" ;
  vaesterbottning_nn_1 = mkN "vдsterbottning" ;
  vaesterbottnisk_av_1 = mkA "vдsterbottnisk" ;
  vaestergoek_nn_1 = mkN "vдstergцk" ;
  vaesterlaendsk_av_1 = mkA "vдsterlдndsk" ;
  vaesterlaenning_nn_1 = mkN "vдsterlдnning" ;
  vaesterut_ab_1 = mkAdv "vдsterut" ;
  vaesteuropeisk_av_1 = mkA "vдsteuropeisk" ;
  vaestgoetaklimax_nn_1 = mkN "vдstgцtaklimax" ;
  vaestgoetaspets_nn_1 = mkN "vдstgцtaspets" ;
  vaestgoete_nn_1 = mkN "vдstgцte" utrum ;
  vaestgoetsk_av_1 = mkA "vдstgцtsk" ;
  vaestgoetska_nn_2 = mkN "vдstgцtska" ;
  vaestgot_nn_1 = mkN "vдstgot" "vдstgoter" ;
  vaestgotisk_av_1 = mkA "vдstgotisk" ;
  vaestindiefarare_nn_1 = mkN "vдstindiefarare" "vдstindiefarare" ;
  vaestindisk_av_1 = mkA "vдstindisk" ;
  vaestklaenning_nn_1 = mkN "vдstklдnning" ;
  vaestkust_nn_1 = mkN "vдstkust" "vдstkuster" ;
  vaestkustsallad_nn_1 = mkN "vдstkustsallad" "vдstkustsallader" ;
  vaestlig_av_1 = mkA "vдstlig" ;
  vaestmakt_nn_1 = mkN "vдstmakt" "vдstmakter" ;
  vaestmanlaendsk_av_1 = mkA "vдstmanlдndsk" ;
  vaestmanlaendska_nn_2 = mkN "vдstmanlдndska" ;
  vaestmanlaenning_nn_1 = mkN "vдstmanlдnning" ;
  vaestoever_ab_1 = mkAdv "vдstцver" ;
  vaestpaa_ab_1 = mkAdv "vдstpе" ;
  vaestra_av_1 = mkA "vдstra" ;
  vaestsamoan_nn_1 = mkN "vдstsamoan" "vдstsamoaner" ;
  vaestslavisk_av_1 = mkA "vдstslavisk" ;
  vaestsvensk_av_1 = mkA "vдstsvensk" ;
  vaesttysk_av_1 = mkA "vдsttysk" ;
  vaesttysk_nn_1 = mkN "vдsttysk" ;
  vaestvart_ab_1 = mkAdv "vдstvart" ;
  vaestvind_nn_1 = mkN "vдstvind" ;
  vaeteatom_nn_1 = mkN "vдteatom" "vдteatomer" ;
  vaetebomb_nn_1 = mkN "vдtebomb" "vдtebomber" ;
  vaetegenerator_nn_1 = mkN "vдtegenerator" "vдtegeneratorer" ;
  vaetejon_nn_1 = mkN "vдtejon" "vдtejoner" ;
  vaetejonkoncentration_nn_1 = mkN "vдtejonkoncentration" "vдtejonkoncentrationer" ;
  vaetekarbonat_nn_1 = mkN "vдtekarbonat" "vдtekarbonater" ;
  vaetekarbonatjon_nn_1 = mkN "vдtekarbonatjon" "vдtekarbonatjoner" ;
  vaetevapen_nn_1 = mkN "vдtevapen" "vдtevapnet" "vдtevapen" "vдtevapnen" ;
  vaetgasmolekyl_nn_1 = mkN "vдtgasmolekyl" "vдtgasmolekyler" ;
  vaetgasrik_av_1 = mkA "vдtgasrik" ;
  vaetmedel_nn_1 = mkN "vдtmedel" neutrum ;
  vaetning_nn_1 = mkN "vдtning" ;
  vaetska_nn_1 = mkN "vдtska" ;
  vaetskeansamling_nn_1 = mkN "vдtskeansamling" ;
  vaetskefoerlust_nn_1 = mkN "vдtskefцrlust" "vдtskefцrluster" ;
  vaetskefylld_av_1 = mkA "vдtskefylld" "vдtskefyllt" ;
  vaetskenivaa_nn_1 = mkN "vдtskenivе" "vдtskenivеer" ;
  vaetsketermometer_nn_1 = mkN "vдtsketermometer" ;
  vaetskig_av_1 = mkA "vдtskig" ;
  vaette_nn_1 = mkN "vдtte" utrum ;
  vaetteljus_nn_1 = mkN "vдtteljus" neutrum ;
  vaetterroeding_nn_1 = mkN "vдtterrцding" ;
  vaev_nn_1 = mkN "vдv" ;
  vaevare_nn_1 = mkN "vдvare" "vдvare" ;
  vaevarfaagel_nn_1 = mkN "vдvarfеgel" ;
  vaevarfink_nn_1 = mkN "vдvarfink" ;
  vaevarstare_nn_1 = mkN "vдvarstare" utrum ;
  vaevburen_av_1 = mkA "vдvburen" "vдvburet" ;
  vaeveri_nn_1 = mkN "vдveri" "vдverit" "vдverier" "vдverierna" ;
  vaeverska_nn_1 = mkN "vдverska" ;
  vaevkaepp_nn_1 = mkN "vдvkдpp" ;
  vaevkam_nn_1 = mkN "vдvkam" "vдvkammen" "vдvkammar" "vдvkammarna" ;
  vaevknut_nn_1 = mkN "vдvknut" ;
  vaevnad_nn_1 = mkN "vдvnad" "vдvnader" ;
  vaevning_nn_1 = mkN "vдvning" ;
  vaevningsmoenster_nn_1 = mkN "vдvningsmцnster" neutrum ;
  vaevplast_nn_1 = mkN "vдvplast" "vдvplaster" ;
  vaevskael_nn_1 = mkN "vдvskдl" neutrum ;
  vaevskaft_nn_1 = mkN "vдvskaft" neutrum ;
  vaevsked_nn_1 = mkN "vдvsked" ;
  vaevskyttel_nn_1 = mkN "vдvskyttel" ;
  vaevspaennare_nn_1 = mkN "vдvspдnnare" "vдvspдnnare" ;
  vaevstol_nn_1 = mkN "vдvstol" ;
  vaevtyngd_nn_1 = mkN "vдvtyngd" "vдvtyngder" ;
  vaexel_nn_1 = mkN "vдxel" ;
  vaexelaccept_nn_1 = mkN "vдxelaccept" "vдxelaccepter" ;
  vaexelaffaer_nn_1 = mkN "vдxelaffдr" "vдxelaffдrer" ;
  vaexelbord_nn_1 = mkN "vдxelbord" neutrum ;
  vaexeldiskont_nn_1 = mkN "vдxeldiskont" "vдxeldiskonter" ;
  vaexeldiskonto_nn_1 = mkN "vдxeldiskonto" "vдxeldiskontot" "vдxeldiskonton" "vдxeldiskontona" ;
  vaexelfoerregling_nn_1 = mkN "vдxelfцrregling" ;
  vaexelfordran_nn_1 = mkN "vдxelfordran" "vдxelfordran" "vдxelfordringar" "vдxelfordringarna" ;
  vaexelgaeldenaer_nn_1 = mkN "vдxelgдldenдr" "vдxelgдldenдrer" ;
  vaexelgivare_nn_1 = mkN "vдxelgivare" "vдxelgivare" ;
  vaexelkassa_nn_1 = mkN "vдxelkassa" ;
  vaexelkontor_nn_1 = mkN "vдxelkontor" neutrum ;
  vaexelkredit_nn_1 = mkN "vдxelkredit" "vдxelkrediter" ;
  vaexelkurs_nn_1 = mkN "vдxelkurs" "vдxelkurser" ;
  vaexellok_nn_1 = mkN "vдxellok" neutrum ;
  vaexelmynt_nn_1 = mkN "vдxelmynt" neutrum ;
  vaexelomsaettning_nn_1 = mkN "vдxelomsдttning" ;
  vaexelryttare_nn_1 = mkN "vдxelryttare" "vдxelryttare" ;
  vaexelsaang_nn_1 = mkN "vдxelsеng" "vдxelsеnger" ;
  vaexelspaar_nn_1 = mkN "vдxelspеr" neutrum ;
  vaexelspaenning_nn_1 = mkN "vдxelspдnning" ;
  vaexelspak_nn_1 = mkN "vдxelspak" ;
  vaexelspel_nn_1 = mkN "vдxelspel" "vдxelspelet" "vдxelspel" "vдxelspelen" ;
  vaexelstaell_nn_1 = mkN "vдxelstдll" neutrum ;
  vaexelstaellverk_nn_1 = mkN "vдxelstдllverk" neutrum ;
  vaexelstroem_nn_1 = mkN "vдxelstrцm" "vдxelstrцmmen" "vдxelstrцmmar" "vдxelstrцmmarna" ;
  vaexeltrassat_nn_1 = mkN "vдxeltrassat" "vдxeltrassater" ;
  vaexeltrassent_nn_1 = mkN "vдxeltrassent" "vдxeltrassenter" ;
  vaexeltunga_nn_1 = mkN "vдxeltunga" ;
  vaexelutstaellare_nn_1 = mkN "vдxelutstдllare" "vдxelutstдllare" ;
  vaexelvarm_av_1 = mkA "vдxelvarm" ;
  vaexelvis_ab_1 = mkAdv "vдxelvis" ;
  vaexlande_av_1 = mkA "vдxlande" ;
  vaexlare_nn_1 = mkN "vдxlare" "vдxlare" ;
  vaexling_nn_1 = mkN "vдxling" ;
  vaexlingslok_nn_1 = mkN "vдxlingslok" neutrum ;
  vaexlingsrik_av_1 = mkA "vдxlingsrik" ;
  vaext_nn_1 = mkN "vдxt" "vдxter" ;
  vaextaemne_nn_1 = mkN "vдxtдmne" ;
  vaextaetande_av_1 = mkA "vдxtдtande" ;
  vaextaetare_nn_1 = mkN "vдxtдtare" "vдxtдtare" ;
  vaextart_nn_1 = mkN "vдxtart" "vдxtarter" ;
  vaextbas_nn_1 = mkN "vдxtbas" "vдxtbaser" ;
  vaextcell_nn_1 = mkN "vдxtcell" "vдxtceller" ;
  vaextdel_nn_1 = mkN "vдxtdel" "vдxtdelen" "vдxtdelar" "vдxtdelarna" ;
  vaextfaerg_nn_1 = mkN "vдxtfдrg" "vдxtfдrger" ;
  vaextfaergning_nn_1 = mkN "vдxtfдrgning" ;
  vaextfamilj_nn_1 = mkN "vдxtfamilj" "vдxtfamiljer" ;
  vaextfett_nn_1 = mkN "vдxtfett" "vдxtfettet" "vдxtfetter" "vдxtfetterna" ;
  vaextfiber_nn_1 = mkN "vдxtfiber" "vдxtfibern" "vдxtfibrer" "vдxtfibrerna" ;
  vaextfoeljd_nn_1 = mkN "vдxtfцljd" "vдxtfцljder" ;
  vaextgift_nn_1 = mkN "vдxtgift" "vдxtgiftet" "vдxtgifter" "vдxtgifterna" ;
  vaextgraens_nn_1 = mkN "vдxtgrдns" "vдxtgrдnser" ;
  vaexthaemmande_av_1 = mkA "vдxthдmmande" ;
  vaexthormon_nn_1 = mkN "vдxthormon" neutrum ;
  vaexthus_nn_1 = mkN "vдxthus" neutrum ;
  vaextkraftig_av_1 = mkA "vдxtkraftig" ;
  vaextlig_av_1 = mkA "vдxtlig" ;
  vaextlighet_nn_1 = mkN "vдxtlighet" "vдxtligheter" ;
  vaextlokal_nn_1 = mkN "vдxtlokal" "vдxtlokaler" ;
  vaextmargarin_nn_1 = mkN "vдxtmargarin" "vдxtmargariner" ;
  vaextperiod_nn_1 = mkN "vдxtperiod" "vдxtperioder" ;
  vaextplankton_nn_1 = mkN "vдxtplankton" neutrum ;
  vaextplats_nn_1 = mkN "vдxtplats" "vдxtplatser" ;
  vaextpress_nn_1 = mkN "vдxtpress" ;
  vaextsaesong_nn_1 = mkN "vдxtsдsong" "vдxtsдsonger" ;
  vaextsaft_nn_1 = mkN "vдxtsaft" "vдxtsafter" ;
  vaextsamlare_nn_1 = mkN "vдxtsamlare" "vдxtsamlare" ;
  vaextsjukdom_nn_1 = mkN "vдxtsjukdom" ;
  vaextskott_nn_1 = mkN "vдxtskott" neutrum ;
  vaextskyddsmedel_nn_1 = mkN "vдxtskyddsmedel" neutrum ;
  vaextstam_nn_1 = mkN "vдxtstam" "vдxtstammen" "vдxtstammar" "vдxtstammarna" ;
  vaextstekel_nn_1 = mkN "vдxtstekel" ;
  vaexttraad_nn_1 = mkN "vдxttrеd" ;
  vaextvaevnad_nn_1 = mkN "vдxtvдvnad" "vдxtvдvnader" ;
  vafalls_ab_1 = mkAdv "vafalls" ;
  vag_av_1 = mkA "vag" ;
  vagabond_nn_1 = mkN "vagabond" "vagabonder" ;
  vagabondnatur_nn_1 = mkN "vagabondnatur" "vagabondnaturer" ;
  vagant_nn_1 = mkN "vagant" "vaganter" ;
  vagel_nn_1 = mkN "vagel" ;
  vaggsaang_nn_1 = mkN "vaggsеng" "vaggsеnger" ;
  vaggtryck_nn_1 = mkN "vaggtryck" neutrum ;
  vaginal_av_1 = mkA "vaginal" ;
  vagn_nn_1 = mkN "vagn" ;
  vagnbjoern_nn_1 = mkN "vagnbjцrn" ;
  vagnborg_nn_1 = mkN "vagnborg" ;
  vagnhall_nn_1 = mkN "vagnhall" ;
  vagnpark_nn_1 = mkN "vagnpark" "vagnparker" ;
  vagnsaett_nn_1 = mkN "vagnsдtt" neutrum ;
  vagnshaeck_nn_1 = mkN "vagnshдck" ;
  vagnskadefoersaekring_nn_1 = mkN "vagnskadefцrsдkring" ;
  vagnskorg_nn_1 = mkN "vagnskorg" ;
  vagnslast_nn_1 = mkN "vagnslast" "vagnslaster" ;
  vagnslider_nn_1 = mkN "vagnslider" neutrum ;
  vajer_nn_1 = mkN "vajer" ;
  vajert_ab_1 = mkAdv "vajert" ;
  vak_nn_1 = mkN "vak" ;
  vakans_nn_1 = mkN "vakans" "vakanser" ;
  vakansfoerordnande_nn_1 = mkN "vakansfцrordnande" ;
  vakansvikarie_nn_1 = mkN "vakansvikarie" "vakansvikarier" ;
  vakant_av_1 = mkA "vakant" "vakant" ;
  vakare_nn_1 = mkN "vakare" "vakare" ;
  vaken_av_1 = mkA "vaken" "vaket" ;
  vakfaagel_nn_1 = mkN "vakfеgel" ;
  vaknatt_nn_1 = mkN "vaknatt" "vaknдtter" ;
  vaksam_av_1 = mkA "vaksam" "vaksamt" "vaksamma" "vaksamma" "vaksammare" "vaksammast" "vaksammaste" ;
  vaksin_nn_1 = mkN "vaksin" neutrum ;
  vaksination_nn_1 = mkN "vaksination" "vaksinationer" ;
  vaksinatoer_nn_1 = mkN "vaksinatцr" "vaksinatцrer" ;
  vakt_nn_1 = mkN "vakt" "vakter" ;
  vaktarrest_nn_1 = mkN "vaktarrest" "vaktarrester" ;
  vaktavloesning_nn_1 = mkN "vaktavlцsning" ;
  vaktel_nn_1 = mkN "vaktel" ;
  vakthaallning_nn_1 = mkN "vakthеllning" ;
  vakthavande_av_1 = mkA "vakthavande" ;
  vakthund_nn_1 = mkN "vakthund" ;
  vaktkur_nn_1 = mkN "vaktkur" ;
  vaktmaestare_nn_1 = mkN "vaktmдstare" "vaktmдstare" ;
  vaktmaesteri_nn_1 = mkN "vaktmдsteri" "vaktmдsterit" "vaktmдsterier" "vaktmдsterierna" ;
  vaktman_nn_1 = mkN "vaktman" "vaktmannen" "vaktmдn" "vaktmдnnen" ;
  vaktparad_nn_1 = mkN "vaktparad" "vaktparader" ;
  vaktpost_nn_1 = mkN "vaktpost" "vaktposter" ;
  vaktstyrka_nn_1 = mkN "vaktstyrka" ;
  vakuum_nn_1 = mkN "vakuum" neutrum ;
  vakuumbroms_nn_1 = mkN "vakuumbroms" ;
  vakuumfoerpackning_nn_1 = mkN "vakuumfцrpackning" ;
  vakuumkammare_nn_1 = mkN "vakuumkammare" "vakuumkammaren" "vakuumkamrar" "vakuumkamrarna" ;
  vakuummateria_nn_1 = mkN "vakuummateria" "vakuummaterian" "vakuummaterier" "vakuummaterierna" ;
  vakuummeter_nn_1 = mkN "vakuummeter" ;
  vakuumpump_nn_1 = mkN "vakuumpump" ;
  vakuumregulator_nn_1 = mkN "vakuumregulator" "vakuumregulatorer" ;
  vakuumsug_nn_1 = mkN "vakuumsug" ;
  vakuumtoalett_nn_1 = mkN "vakuumtoalett" "vakuumtoaletter" ;
  val_nn_1 = mkN "val" neutrum ;
  val_nn_2 = mkN "val" ;
  valack_nn_1 = mkN "valack" "valacker" ;
  valaffisch_nn_1 = mkN "valaffisch" "valaffischer" ;
  valapparat_nn_1 = mkN "valapparat" "valapparater" ;
  valarbetare_nn_1 = mkN "valarbetare" "valarbetare" ;
  valbar_av_1 = mkA "valbar" ;
  valbarometer_nn_1 = mkN "valbarometer" ;
  valberedning_nn_1 = mkN "valberedning" ;
  valbiskop_nn_1 = mkN "valbiskop" ;
  valborgsmaessoafton_nn_1 = mkN "valborgsmдssoafton" "valborgsmдssoaftonen" "valborgsmдssoaftnar" "valborgsmдssoaftnarna" ;
  valbyraa_nn_1 = mkN "valbyrе" "valbyrеer" ;
  valdistrikt_nn_1 = mkN "valdistrikt" neutrum ;
  valen_av_1 = mkA "valen" "valet" ;
  valens_nn_1 = mkN "valens" "valenser" ;
  valenselektron_nn_1 = mkN "valenselektron" "valenselektroner" ;
  valenstal_nn_1 = mkN "valenstal" "valenstalet" "valenstalen" "valenstalena" ;
  valfaangare_nn_1 = mkN "valfеngare" "valfеngare" ;
  valfisk_nn_1 = mkN "valfisk" ;
  valfraendskap_nn_1 = mkN "valfrдndskap" "valfrдndskaper" ;
  valfri_av_1 = mkA "valfri" "valfritt" ;
  valfrihet_nn_1 = mkN "valfrihet" "valfriheter" ;
  valfurste_nn_1 = mkN "valfurste" utrum ;
  valhaent_av_1 = mkA "valhдnt" "valhдnt" ;
  valhaenthet_nn_1 = mkN "valhдnthet" "valhдntheter" ;
  valhemlighet_nn_1 = mkN "valhemlighet" "valhemligheter" ;
  validitet_nn_1 = mkN "validitet" "validiteter" ;
  valium_nn_1 = mkN "valium" neutrum ;
  valk_nn_1 = mkN "valk" ;
  valkampanj_nn_1 = mkN "valkampanj" "valkampanjer" ;
  valkare_nn_1 = mkN "valkare" "valkare" ;
  valkeri_nn_1 = mkN "valkeri" "valkerit" "valkerier" "valkerierna" ;
  valkig_av_1 = mkA "valkig" ;
  valkokeri_nn_1 = mkN "valkokeri" "valkokerit" "valkokerier" "valkokerierna" ;
  valkrets_nn_1 = mkN "valkrets" ;
  valkuvert_nn_1 = mkN "valkuvert" neutrum ;
  vall_nn_1 = mkN "vall" ;
  vallaengd_nn_1 = mkN "vallдngd" "vallдngder" ;
  vallare_nn_1 = mkN "vallare" "vallare" ;
  vallfaerd_nn_1 = mkN "vallfдrd" "vallfдrder" ;
  vallfart_nn_1 = mkN "vallfart" "vallfarter" ;
  vallfartsort_nn_1 = mkN "vallfartsort" "vallfartsorter" ;
  vallgrav_nn_1 = mkN "vallgrav" ;
  vallhorn_nn_1 = mkN "vallhorn" neutrum ;
  vallhund_nn_1 = mkN "vallhund" ;
  vallmo_nn_1 = mkN "vallmo" "vallmor" ;
  vallmofroe_nn_1 = mkN "vallmofrц" "vallmofrцt" "vallmofrцn" "vallmofrцen" ;
  vallmovaext_nn_1 = mkN "vallmovдxt" "vallmovдxter" ;
  vallningstabell_nn_1 = mkN "vallningstabell" "vallningstabeller" ;
  vallokal_nn_1 = mkN "vallokal" "vallokaler" ;
  vallon_nn_1 = mkN "vallon" "valloner" ;
  vallonsk_av_1 = mkA "vallonsk" ;
  vallpojke_nn_1 = mkN "vallpojke" utrum ;
  vallvaext_nn_1 = mkN "vallvдxt" "vallvдxter" ;
  valman_nn_1 = mkN "valman" "valmannen" "valmдn" "valmдnnen" ;
  valmaskineri_nn_1 = mkN "valmaskineri" "valmaskinerit" "valmaskinerier" "valmaskinerierna" ;
  valmoejlighet_nn_1 = mkN "valmцjlighet" "valmцjligheter" ;
  valmoete_nn_1 = mkN "valmцte" ;
  valmtak_nn_1 = mkN "valmtak" neutrum ;
  valnoet_nn_1 = mkN "valnцt" "valnцtter" ;
  valnoetstraed_nn_1 = mkN "valnцtstrдd" neutrum ;
  valoer_nn_1 = mkN "valцr" "valцrer" ;
  valomgaang_nn_1 = mkN "valomgеng" ;
  valp_nn_1 = mkN "valp" ;
  valpaktig_av_1 = mkA "valpaktig" ;
  valpig_av_1 = mkA "valpig" ;
  valplats_nn_1 = mkN "valplats" "valplatser" ;
  valresultat_nn_1 = mkN "valresultat" neutrum ;
  valrike_nn_1 = mkN "valrike" ;
  valroerelse_nn_1 = mkN "valrцrelse" "valrцrelser" ;
  valross_nn_1 = mkN "valross" ;
  valrossmustasch_nn_1 = mkN "valrossmustasch" "valrossmustascher" ;
  vals_nn_1 = mkN "vals" ;
  vals_nn_2 = mkN "vals" "valser" ;
  valsaett_nn_1 = mkN "valsдtt" neutrum ;
  valsedel_nn_1 = mkN "valsedel" ;
  valseger_nn_1 = mkN "valseger" ;
  valsituation_nn_1 = mkN "valsituation" "valsituationer" ;
  valskaerm_nn_1 = mkN "valskдrm" ;
  valsoer_nn_1 = mkN "valsцr" "valsцrer" ;
  valspraak_nn_1 = mkN "valsprеk" neutrum ;
  valsverk_nn_1 = mkN "valsverk" neutrum ;
  valthorn_nn_1 = mkN "valthorn" neutrum ;
  valuta_nn_1 = mkN "valuta" ;
  valutaaffaer_nn_1 = mkN "valutaaffдr" "valutaaffдrer" ;
  valutabrott_nn_1 = mkN "valutabrott" neutrum ;
  valutafond_nn_1 = mkN "valutafond" "valutafonder" ;
  valutaklausul_nn_1 = mkN "valutaklausul" "valutaklausuler" ;
  valutakurs_nn_1 = mkN "valutakurs" "valutakurser" ;
  valutareglering_nn_1 = mkN "valutareglering" ;
  valutareserv_nn_1 = mkN "valutareserv" "valutareserver" ;
  valutasvin_nn_1 = mkN "valutasvin" neutrum ;
  valutgaang_nn_1 = mkN "valutgеng" ;
  valv_nn_1 = mkN "valv" neutrum ;
  valvbaage_nn_1 = mkN "valvbеge" utrum ;
  valvel_nn_1 = mkN "valvel" "valveln" "valvler" "valvlerna" ;
  valvslagning_nn_1 = mkN "valvslagning" ;
  vamp_nn_1 = mkN "vamp" ;
  vampig_av_1 = mkA "vampig" ;
  vampyr_nn_1 = mkN "vampyr" "vampyrer" ;
  van_av_1 = mkA "van" ;
  van_nn_1 = mkN "van" "vaner" ;
  vana_nn_1 = mkN "vana" ;
  vanaerande_av_1 = mkA "vanдrande" ;
  vanartig_av_1 = mkA "vanartig" ;
  vandal_nn_1 = mkN "vandal" "vandaler" ;
  vandalisk_av_1 = mkA "vandalisk" ;
  vandrarcell_nn_1 = mkN "vandrarcell" "vandrarceller" ;
  vandrare_nn_1 = mkN "vandrare" "vandrare" ;
  vandrarfolk_nn_1 = mkN "vandrarfolk" neutrum ;
  vandrarhem_nn_1 = mkN "vandrarhem" "vandrarhemmet" "vandrarhem" "vandrarhemmen" ;
  vandring_nn_1 = mkN "vandring" ;
  vandringsaar_nn_1 = mkN "vandringsеr" neutrum ;
  vandringscell_nn_1 = mkN "vandringscell" "vandringsceller" ;
  vandringsfisk_nn_1 = mkN "vandringsfisk" ;
  vandringsfolk_nn_1 = mkN "vandringsfolk" neutrum ;
  vandringsman_nn_1 = mkN "vandringsman" "vandringsmannen" "vandringsmдn" "vandringsmдnnen" ;
  vandringspokal_nn_1 = mkN "vandringspokal" "vandringspokaler" ;
  vandringspris_nn_1 = mkN "vandringspris" neutrum ;
  vandringsutstaellning_nn_1 = mkN "vandringsutstдllning" ;
  vandringsvaagroer_nn_1 = mkN "vandringsvеgrцr" neutrum ;
  vanebildande_av_1 = mkA "vanebildande" ;
  vanebildning_nn_1 = mkN "vanebildning" ;
  vanedjur_nn_1 = mkN "vanedjur" neutrum ;
  vanedrinkare_nn_1 = mkN "vanedrinkare" "vanedrinkare" ;
  vanekristen_av_1 = mkA "vanekristen" "vanekristet" ;
  vanemaenniska_nn_1 = mkN "vanemдnniska" ;
  vanemaessig_av_1 = mkA "vanemдssig" ;
  vanesak_nn_1 = mkN "vanesak" "vanesaker" ;
  vanfoer_av_1 = mkA "vanfцr" ;
  vanfoerestaellning_nn_1 = mkN "vanfцrestдllning" ;
  vanfoerhet_nn_1 = mkN "vanfцrhet" "vanfцrheter" ;
  vanhederlig_av_1 = mkA "vanhederlig" ;
  vanillin_nn_1 = mkN "vanillin" "vanilliner" ;
  vankant_nn_1 = mkN "vankant" "vankanter" ;
  vankelmodig_av_1 = mkA "vankelmodig" ;
  vanlig_av_1 = mkA "vanlig" ;
  vanligen_ab_1 = mkAdv "vanligen" ;
  vanlighet_nn_1 = mkN "vanlighet" "vanligheter" ;
  vanligtvis_ab_1 = mkAdv "vanligtvis" ;
  vanmaektig_av_1 = mkA "vanmдktig" ;
  vansinneskoerning_nn_1 = mkN "vansinneskцrning" ;
  vansinnig_av_1 = mkA "vansinnig" ;
  vanskaplig_av_1 = mkA "vanskaplig" ;
  vanskapnad_nn_1 = mkN "vanskapnad" "vanskapnader" ;
  vanskapt_av_1 = mkA "vanskapt" "vanskapt" ;
  vanskapthet_nn_1 = mkN "vanskapthet" "vanskaptheter" ;
  vansklig_av_1 = mkA "vansklig" ;
  vanstark_av_1 = mkA "vanstark" ;
  vanstyrd_av_1 = mkA "vanstyrd" "vanstyrt" ;
  vant_nn_1 = mkN "vant" neutrum ;
  vante_nn_1 = mkN "vante" utrum ;
  vantrogen_av_1 = mkA "vantrogen" "vantroget" ;
  vantskruv_nn_1 = mkN "vantskruv" ;
  vantspridare_nn_1 = mkN "vantspridare" "vantspridare" ;
  vanvettig_av_1 = mkA "vanvettig" ;
  vanvoerdig_av_1 = mkA "vanvцrdig" ;
  vanvoerdnad_nn_1 = mkN "vanvцrdnad" "vanvцrdnader" ;
  vapen_nn_1 = mkN "vapen" "vapnet" "vapen" "vapnen" ;
  vapenarsenal_nn_1 = mkN "vapenarsenal" "vapenarsenaler" ;
  vapenbok_nn_1 = mkN "vapenbok" "vapenbцcker" ;
  vapenbroder_nn_1 = mkN "vapenbroder" "vapenbrodern" "vapenbrцder" "vapenbrцderna" ;
  vapendans_nn_1 = mkN "vapendans" "vapendanser" ;
  vapendragare_nn_1 = mkN "vapendragare" "vapendragare" ;
  vapenfabrik_nn_1 = mkN "vapenfabrik" "vapenfabriker" ;
  vapenfoer_av_1 = mkA "vapenfцr" ;
  vapenfri_av_1 = mkA "vapenfri" "vapenfritt" ;
  vapenfynd_nn_1 = mkN "vapenfynd" neutrum ;
  vapengren_nn_1 = mkN "vapengren" "vapengrenen" "vapengrenar" "vapengrenarna" ;
  vapenhus_nn_1 = mkN "vapenhus" neutrum ;
  vapenlek_nn_1 = mkN "vapenlek" ;
  vapenloes_av_1 = mkA "vapenlцs" ;
  vapenrock_nn_1 = mkN "vapenrock" ;
  vapenskoeld_nn_1 = mkN "vapenskцld" ;
  vapenslag_nn_1 = mkN "vapenslag" neutrum ;
  vapensmed_nn_1 = mkN "vapensmed" "vapensmeder" ;
  vapenstillestaand_nn_1 = mkN "vapenstillestеnd" neutrum ;
  vapensystem_nn_1 = mkN "vapensystem" neutrum ;
  vapentyp_nn_1 = mkN "vapentyp" "vapentyper" ;
  vapenvaegrare_nn_1 = mkN "vapenvдgrare" "vapenvдgrare" ;
  vapenvila_nn_1 = mkN "vapenvila" ;
  vapoer_nn_1 = mkN "vapцr" "vapцrer" ;
  var_ab_1 = mkAdv "var" ;
  var_av_1 = mkA "var" ;
  vara_nn_1 = mkN "vara" ;
  varaktig_av_1 = mkA "varaktig" ;
  varan_nn_1 = mkN "varan" "varaner" ;
  varav_ab_1 = mkAdv "varav" ;
  varbildning_nn_1 = mkN "varbildning" ;
  varbygel_nn_1 = mkN "varbygel" ;
  vardag_nn_1 = mkN "vardag" ;
  vardaglig_av_1 = mkA "vardaglig" ;
  vardagsliv_nn_1 = mkN "vardagsliv" neutrum ;
  vardagsrum_nn_1 = mkN "vardagsrum" "vardagsrummet" "vardagsrum" "vardagsrummen" ;
  vardagstaenkande_nn_1 = mkN "vardagstдnkande" ;
  varde_nn_1 = mkN "varde" utrum ;
  varefter_ab_1 = mkAdv "varefter" ;
  varelse_nn_1 = mkN "varelse" "varelser" ;
  varemot_ab_1 = mkAdv "varemot" ;
  varest_ab_1 = mkAdv "varest" ;
  varfaagel_nn_1 = mkN "varfеgel" ;
  varfoer_ab_1 = mkAdv "varfцr" ;
  varfoere_ab_1 = mkAdv "varfцre" ;
  varg_nn_1 = mkN "varg" ;
  vargavinter_nn_1 = mkN "vargavinter" ;
  vargering_nn_1 = mkN "vargering" ;
  varggrop_nn_1 = mkN "varggrop" ;
  varghagel_nn_1 = mkN "varghagel" neutrum ;
  varginna_nn_1 = mkN "varginna" ;
  vargtimme_nn_1 = mkN "vargtimme" utrum ;
  vargunge_nn_1 = mkN "vargunge" utrum ;
  varhaerd_nn_1 = mkN "varhдrd" ;
  varhelst_ab_1 = mkAdv "varhelst" ;
  vari_ab_1 = mkAdv "vari" ;
  varia_nn_1 = mkN "varia" "varian" "varia" "variana" ;
  variabel_av_1 = mkA "variabel" "variabelt" "variabla" "variabla" "variablare" "variablast" "variablaste" ;
  variabel_nn_1 = mkN "variabel" "variabeln" "variabler" "variablerna" ;
  variabilitet_nn_1 = mkN "variabilitet" "variabiliteter" ;
  varians_nn_1 = mkN "varians" "varianser" ;
  variant_nn_1 = mkN "variant" "varianter" ;
  variation_nn_1 = mkN "variation" "variationer" ;
  variationsbredd_nn_1 = mkN "variationsbredd" "variationsbredder" ;
  variationsinstrument_nn_1 = mkN "variationsinstrument" neutrum ;
  variator_nn_1 = mkN "variator" "variatorer" ;
  varibland_ab_1 = mkAdv "varibland" ;
  variete_nn_1 = mkN "varietй" "varietйer" ;
  varieteartist_nn_1 = mkN "varietйartist" "varietйartister" ;
  varietet_nn_1 = mkN "varietet" "varieteter" ;
  varifraan_ab_1 = mkAdv "varifrеn" ;
  varig_av_1 = mkA "varig" ;
  varigenom_ab_1 = mkAdv "varigenom" ;
  variometer_nn_1 = mkN "variometer" ;
  varjaemte_ab_1 = mkAdv "varjдmte" ;
  varjag_nn_1 = mkN "varjag" "varjager" ;
  varjehanda_av_1 = mkA "varjehanda" ;
  varken_ab_1 = mkAdv "varken" ;
  varkunnsam_av_1 = mkA "varkunnsam" "varkunnsamt" "varkunnsamma" "varkunnsamma" "varkunnsammare" "varkunnsammast" "varkunnsammaste" ;
  varlig_av_1 = mkA "varlig" ;
  varliga_ab_1 = mkAdv "varliga" ;
  varligen_ab_1 = mkAdv "varligen" ;
  varm_av_1 = mkA "varm" ;
  varmbad_nn_1 = mkN "varmbad" neutrum ;
  varmblod_nn_1 = mkN "varmblod" neutrum ;
  varmblodig_av_1 = mkA "varmblodig" ;
  varmbraeckt_av_1 = mkA "varmbrдckt" "varmbrдckt" ;
  varmed_ab_1 = mkAdv "varmed" ;
  varmfront_nn_1 = mkN "varmfront" "varmfronter" ;
  varmgarage_nn_1 = mkN "varmgarage" "varmgaraget" "varmgarage" "varmgaragen" ;
  varmhaallning_nn_1 = mkN "varmhеllning" ;
  varmluftsridaa_nn_1 = mkN "varmluftsridе" "varmluftsridеer" ;
  varmluftssystem_nn_1 = mkN "varmluftssystem" neutrum ;
  varmraett_nn_1 = mkN "varmrдtt" "varmrдtter" ;
  varmvatten_nn_1 = mkN "varmvatten" "varmvattnet" "varmvatten" "varmvattnen" ;
  varmvattenberedare_nn_1 = mkN "varmvattenberedare" "varmvattenberedare" ;
  varmvattensystem_nn_1 = mkN "varmvattensystem" neutrum ;
  varning_nn_1 = mkN "varning" ;
  varningsmaerke_nn_1 = mkN "varningsmдrke" ;
  varningssignal_nn_1 = mkN "varningssignal" "varningssignaler" ;
  varningstriangel_nn_1 = mkN "varningstriangel" ;
  varoever_ab_1 = mkAdv "varцver" ;
  varom_ab_1 = mkAdv "varom" ;
  varp_nn_1 = mkN "varp" ;
  varp_nn_2 = mkN "varp" neutrum ;
  varpaa_ab_1 = mkAdv "varpе" ;
  varpbom_nn_1 = mkN "varpbom" "varpbommen" "varpbommar" "varpbommarna" ;
  varpning_nn_1 = mkN "varpning" ;
  varptraad_nn_1 = mkN "varptrеd" ;
  varsam_av_1 = mkA "varsam" "varsamt" "varsamma" "varsamma" "varsammare" "varsammast" "varsammaste" ;
  varse_ab_1 = mkAdv "varse" ;
  varsel_nn_1 = mkN "varsel" neutrum ;
  varsomhelst_ab_1 = mkAdv "varsomhelst" ;
  varstaedes_ab_1 = mkAdv "varstдdes" ;
  vart_ab_1 = mkAdv "vart" ;
  vartaat_ab_1 = mkAdv "vartеt" ;
  vartefter_ab_1 = mkAdv "vartefter" ;
  varthaen_ab_1 = mkAdv "varthдn" ;
  varthelst_ab_1 = mkAdv "varthelst" ;
  vartill_ab_1 = mkAdv "vartill" ;
  vartsomhelst_ab_1 = mkAdv "vartsomhelst" ;
  varubeteckning_nn_1 = mkN "varubeteckning" ;
  varubil_nn_1 = mkN "varubil" ;
  varubud_nn_1 = mkN "varubud" neutrum ;
  varubuss_nn_1 = mkN "varubuss" ;
  varudeklaration_nn_1 = mkN "varudeklaration" "varudeklarationer" ;
  varufakta_nn_1 = mkN "varufakta" "varufaktan" "varufakta" "varufaktana" ;
  varuhavare_nn_1 = mkN "varuhavare" "varuhavare" ;
  varuhus_nn_1 = mkN "varuhus" neutrum ;
  varuintag_nn_1 = mkN "varuintag" neutrum ;
  varulaan_nn_1 = mkN "varulеn" neutrum ;
  varulv_nn_1 = mkN "varulv" ;
  varumaengd_nn_1 = mkN "varumдngd" "varumдngder" ;
  varumaerke_nn_1 = mkN "varumдrke" ;
  varunder_ab_1 = mkAdv "varunder" ;
  varuparti_nn_1 = mkN "varuparti" "varupartit" "varupartier" "varupartierna" ;
  varupris_nn_1 = mkN "varupris" neutrum ;
  varuprov_nn_1 = mkN "varuprov" neutrum ;
  varur_ab_1 = mkAdv "varur" ;
  varuskatt_nn_1 = mkN "varuskatt" "varuskatter" ;
  varuti_ab_1 = mkAdv "varuti" ;
  varutinnan_ab_1 = mkAdv "varutinnan" ;
  varutransport_nn_1 = mkN "varutransport" "varutransporter" ;
  varuvagn_nn_1 = mkN "varuvagn" ;
  varv_nn_1 = mkN "varv" neutrum ;
  varvid_ab_1 = mkAdv "varvid" ;
  varvidlag_ab_1 = mkAdv "varvidlag" ;
  varvig_av_1 = mkA "varvig" ;
  varvmaetare_nn_1 = mkN "varvmдtare" "varvmдtare" ;
  varvraeknare_nn_1 = mkN "varvrдknare" "varvrдknare" ;
  varvsindustri_nn_1 = mkN "varvsindustri" "varvsindustrier" ;
  varvtal_nn_1 = mkN "varvtal" "varvtalet" "varvtalen" "varvtalena" ;
  vas_nn_1 = mkN "vas" "vaser" ;
  vasall_nn_1 = mkN "vasall" "vasaller" ;
  vasallstat_nn_1 = mkN "vasallstat" "vasallstater" ;
  vasaorden_nn_1 = mkN "vasaorden" ;
  vase_nn_1 = mkN "vase" utrum ;
  vasektomi_nn_1 = mkN "vasektomi" "vasektomier" ;
  vask_nn_1 = mkN "vask" ;
  vasker_nn_1 = mkN "vasker" ;
  vaskulaer_av_1 = mkA "vaskulдr" ;
  vasomotorisk_av_1 = mkA "vasomotorisk" ;
  vass_av_1 = mkA "vass" ;
  vass_nn_1 = mkN "vass" ;
  vasslig_av_1 = mkA "vasslig" ;
  vassroer_nn_1 = mkN "vassrцr" neutrum ;
  vassrugge_nn_1 = mkN "vassrugge" utrum ;
  vaterbom_nn_1 = mkN "vaterbom" "vaterbommen" "vaterbommar" "vaterbommarna" ;
  vaterbord_nn_1 = mkN "vaterbord" neutrum ;
  vatikansk_av_1 = mkA "vatikansk" ;
  vattblaa_av_1 = mkA "vattblе" "vattblеtt" ;
  vatten_nn_1 = mkN "vatten" "vattnet" "vatten" "vattnen" ;
  vattenavstoetande_av_1 = mkA "vattenavstцtande" ;
  vattenavvisande_av_1 = mkA "vattenavvisande" ;
  vattenbad_nn_1 = mkN "vattenbad" neutrum ;
  vattenbehaallare_nn_1 = mkN "vattenbehеllare" "vattenbehеllare" ;
  vattenbi_nn_1 = mkN "vattenbi" "vattenbit" "vattenbin" "vattenbien" ;
  vattenblaa_av_1 = mkA "vattenblе" "vattenblеtt" ;
  vattenbrist_nn_1 = mkN "vattenbrist" "vattenbrister" ;
  vattenbruk_nn_1 = mkN "vattenbruk" neutrum ;
  vattenburen_av_1 = mkA "vattenburen" "vattenburet" ;
  vattenbyggnad_nn_1 = mkN "vattenbyggnad" "vattenbyggnader" ;
  vattencykel_nn_1 = mkN "vattencykel" ;
  vattendelare_nn_1 = mkN "vattendelare" "vattendelare" ;
  vattendjup_nn_1 = mkN "vattendjup" neutrum ;
  vattendjur_nn_1 = mkN "vattendjur" neutrum ;
  vattendomstol_nn_1 = mkN "vattendomstol" ;
  vattendrag_nn_1 = mkN "vattendrag" neutrum ;
  vattendrivande_av_1 = mkA "vattendrivande" ;
  vattendriven_av_1 = mkA "vattendriven" "vattendrivet" ;
  vattendroppe_nn_1 = mkN "vattendroppe" utrum ;
  vattenfaagel_nn_1 = mkN "vattenfеgel" ;
  vattenfaerg_nn_1 = mkN "vattenfдrg" "vattenfдrger" ;
  vattenfall_nn_1 = mkN "vattenfall" neutrum ;
  vattenfas_nn_1 = mkN "vattenfas" "vattenfaser" ;
  vattenfast_av_1 = mkA "vattenfast" "vattenfast" ;
  vattenfoerorening_nn_1 = mkN "vattenfцrorening" ;
  vattenfylld_av_1 = mkA "vattenfylld" "vattenfyllt" ;
  vattengel_nn_1 = mkN "vattengel" "vattengelet" "vattengeler" "vattengelerna" ;
  vattenglas_nn_1 = mkN "vattenglas" neutrum ;
  vattenhaal_nn_1 = mkN "vattenhеl" neutrum ;
  vattenhalt_nn_1 = mkN "vattenhalt" "vattenhalter" ;
  vattenhjul_nn_1 = mkN "vattenhjul" neutrum ;
  vattenhyacint_nn_1 = mkN "vattenhyacint" "vattenhyacinter" ;
  vattenkaenslig_av_1 = mkA "vattenkдnslig" ;
  vattenkanon_nn_1 = mkN "vattenkanon" "vattenkanoner" ;
  vattenklosett_nn_1 = mkN "vattenklosett" "vattenklosetter" ;
  vattenkokare_nn_1 = mkN "vattenkokare" "vattenkokare" ;
  vattenkraftverk_nn_1 = mkN "vattenkraftverk" neutrum ;
  vattenkran_nn_1 = mkN "vattenkran" ;
  vattenkultur_nn_1 = mkN "vattenkultur" "vattenkulturer" ;
  vattenkvarn_nn_1 = mkN "vattenkvarn" ;
  vattenkyld_av_1 = mkA "vattenkyld" "vattenkylt" ;
  vattenlaas_nn_1 = mkN "vattenlеs" neutrum ;
  vattenled_nn_1 = mkN "vattenled" "vattenleder" ;
  vattenledning_nn_1 = mkN "vattenledning" ;
  vattenledningsvatten_nn_1 = mkN "vattenledningsvatten" "vattenledningsvattnet" "vattenledningsvatten" "vattenledningsvattnen" ;
  vattenlevande_av_1 = mkA "vattenlevande" ;
  vattenlinje_nn_1 = mkN "vattenlinje" "vattenlinjer" ;
  vattenlist_nn_1 = mkN "vattenlist" "vattenlister" ;
  vattenloepare_nn_1 = mkN "vattenlцpare" "vattenlцpare" ;
  vattenloeslig_av_1 = mkA "vattenlцslig" ;
  vattenloeslighet_nn_1 = mkN "vattenlцslighet" "vattenlцsligheter" ;
  vattenloesning_nn_1 = mkN "vattenlцsning" ;
  vattenmaerke_nn_1 = mkN "vattenmдrke" ;
  vattenmelon_nn_1 = mkN "vattenmelon" "vattenmeloner" ;
  vattennivaa_nn_1 = mkN "vattennivе" "vattennivеer" ;
  vattennymf_nn_1 = mkN "vattennymf" "vattennymfer" ;
  vattenorganism_nn_1 = mkN "vattenorganism" "vattenorganismer" ;
  vattenpass_nn_1 = mkN "vattenpass" neutrum ;
  vattenpelare_nn_1 = mkN "vattenpelare" "vattenpelare" ;
  vattenpistol_nn_1 = mkN "vattenpistol" "vattenpistoler" ;
  vattenpoel_nn_1 = mkN "vattenpцl" ;
  vattenpost_nn_1 = mkN "vattenpost" "vattenposter" ;
  vattenprov_nn_1 = mkN "vattenprov" neutrum ;
  vattenpump_nn_1 = mkN "vattenpump" ;
  vattenpuss_nn_1 = mkN "vattenpuss" ;
  vattenrallare_nn_1 = mkN "vattenrallare" "vattenrallare" ;
  vattenreglering_nn_1 = mkN "vattenreglering" ;
  vattenreningsverk_nn_1 = mkN "vattenreningsverk" neutrum ;
  vattenring_nn_1 = mkN "vattenring" ;
  vattensamling_nn_1 = mkN "vattensamling" ;
  vattensjuk_av_1 = mkA "vattensjuk" ;
  vattenskalle_nn_1 = mkN "vattenskalle" utrum ;
  vattenskinnbagge_nn_1 = mkN "vattenskinnbagge" utrum ;
  vattenskott_nn_1 = mkN "vattenskott" neutrum ;
  vattenslang_nn_1 = mkN "vattenslang" ;
  vattenspindel_nn_1 = mkN "vattenspindel" ;
  vattenspridare_nn_1 = mkN "vattenspridare" "vattenspridare" ;
  vattenstaand_nn_1 = mkN "vattenstеnd" neutrum ;
  vattenstaandsroer_nn_1 = mkN "vattenstеndsrцr" neutrum ;
  vattenstaandsvisare_nn_1 = mkN "vattenstеndsvisare" "vattenstеndsvisare" ;
  vattenstaempel_nn_1 = mkN "vattenstдmpel" ;
  vattenstaenk_nn_1 = mkN "vattenstдnk" neutrum ;
  vattenstraale_nn_1 = mkN "vattenstrеle" utrum ;
  vattenstroem_nn_1 = mkN "vattenstrцm" "vattenstrцmmen" "vattenstrцmmar" "vattenstrцmmarna" ;
  vattensvin_nn_1 = mkN "vattensvin" neutrum ;
  vattentaalig_av_1 = mkA "vattentеlig" ;
  vattentaekt_nn_1 = mkN "vattentдkt" "vattentдkter" ;
  vattentaet_av_1 = mkA "vattentдt" ;
  vattentemperatur_nn_1 = mkN "vattentemperatur" "vattentemperaturer" ;
  vattentorn_nn_1 = mkN "vattentorn" neutrum ;
  vattentroeskel_nn_1 = mkN "vattentrцskel" ;
  vattenturbin_nn_1 = mkN "vattenturbin" "vattenturbiner" ;
  vattenur_nn_1 = mkN "vattenur" neutrum ;
  vattenvaeg_nn_1 = mkN "vattenvдg" ;
  vattenvaerde_nn_1 = mkN "vattenvдrde" ;
  vattenvaermare_nn_1 = mkN "vattenvдrmare" "vattenvдrmare" ;
  vattenvaesen_nn_1 = mkN "vattenvдsen" neutrum ;
  vattenvaext_nn_1 = mkN "vattenvдxt" "vattenvдxter" ;
  vattenverk_nn_1 = mkN "vattenverk" neutrum ;
  vattnare_nn_1 = mkN "vattnare" "vattnare" ;
  vattnig_av_1 = mkA "vattnig" ;
  vattrig_av_1 = mkA "vattrig" ;
  vattring_nn_1 = mkN "vattring" ;
  vaudeville_nn_1 = mkN "vaudeville" "vaudeviller" ;
  vax_nn_1 = mkN "vax" "vaxet" "vaxer" "vaxerna" ;
  vaxavtryck_nn_1 = mkN "vaxavtryck" neutrum ;
  vaxduk_nn_1 = mkN "vaxduk" ;
  vaxkabinett_nn_1 = mkN "vaxkabinett" neutrum ;
  vaxliknande_av_1 = mkA "vaxliknande" ;
  vaxljus_nn_1 = mkN "vaxljus" neutrum ;
  vaxpropp_nn_1 = mkN "vaxpropp" ;
  vaxsigill_nn_1 = mkN "vaxsigill" neutrum ;
  vaxskivling_nn_1 = mkN "vaxskivling" ;
  vaxstapel_nn_1 = mkN "vaxstapel" ;
  vaxtavla_nn_1 = mkN "vaxtavla" ;
  veck_nn_1 = mkN "veck" neutrum ;
  vecka_nn_1 = mkN "vecka" ;
  veckberg_nn_1 = mkN "veckberg" neutrum ;
  veckig_av_1 = mkA "veckig" ;
  vecklare_nn_1 = mkN "vecklare" "vecklare" ;
  veckning_nn_1 = mkN "veckning" ;
  veckoaenda_nn_1 = mkN "veckoдnda" "veckoдndan" "veckoдndar" "veckoдndarna" ;
  veckoavdelning_nn_1 = mkN "veckoavdelning" ;
  veckobiljett_nn_1 = mkN "veckobiljett" "veckobiljetter" ;
  veckodag_nn_1 = mkN "veckodag" ;
  veckohelg_nn_1 = mkN "veckohelg" "veckohelger" ;
  veckopeng_nn_1 = mkN "veckopeng" ;
  veckoslut_nn_1 = mkN "veckoslut" neutrum ;
  veckotidning_nn_1 = mkN "veckotidning" ;
  veckotimme_nn_1 = mkN "veckotimme" utrum ;
  veckovis_ab_1 = mkAdv "veckovis" ;
  vedbacke_nn_1 = mkN "vedbacke" utrum ;
  vedbaerare_nn_1 = mkN "vedbдrare" "vedbдrare" ;
  vedbod_nn_1 = mkN "vedbod" ;
  vedborre_nn_1 = mkN "vedborre" utrum ;
  vedbrand_nn_1 = mkN "vedbrand" "vedbrдnder" ;
  vederboerande_av_1 = mkA "vederbцrande" ;
  vederboerlig_av_1 = mkA "vederbцrlig" ;
  vederboerligen_ab_1 = mkAdv "vederbцrligen" ;
  vederdeloman_nn_1 = mkN "vederdeloman" "vederdelomannen" "vederdelomдn" "vederdelomдnnen" ;
  vederdoepare_nn_1 = mkN "vederdцpare" "vederdцpare" ;
  vederhaeftig_av_1 = mkA "vederhдftig" ;
  vederkvickelse_nn_1 = mkN "vederkvickelse" "vederkvickelser" ;
  vederlag_nn_1 = mkN "vederlag" neutrum ;
  vederlike_nn_1 = mkN "vederlike" utrum ;
  vedermoeda_nn_1 = mkN "vedermцda" ;
  vedernamn_nn_1 = mkN "vedernamn" neutrum ;
  vederpart_nn_1 = mkN "vederpart" "vederparter" ;
  vedersakare_nn_1 = mkN "vedersakare" "vedersakare" ;
  vederstygglig_av_1 = mkA "vederstygglig" ;
  vedertagen_av_1 = mkA "vedertagen" "vedertaget" ;
  vedervaerdig_av_1 = mkA "vedervдrdig" ;
  vedervaerdighet_nn_1 = mkN "vedervдrdighet" "vedervдrdigheter" ;
  vedettbaat_nn_1 = mkN "vedettbеt" ;
  vedfaang_nn_1 = mkN "vedfеng" neutrum ;
  vedhuggare_nn_1 = mkN "vedhuggare" "vedhuggare" ;
  vedhuggning_nn_1 = mkN "vedhuggning" ;
  vedisk_av_1 = mkA "vedisk" ;
  vedkap_nn_1 = mkN "vedkap" ;
  vedlaar_nn_1 = mkN "vedlеr" ;
  vedpinne_nn_1 = mkN "vedpinne" utrum ;
  vedsaag_nn_1 = mkN "vedsеg" ;
  vedspis_nn_1 = mkN "vedspis" ;
  vedstam_nn_1 = mkN "vedstam" "vedstammen" "vedstammar" "vedstammarna" ;
  vedtrae_nn_1 = mkN "vedtrд" "vedtrдet" "vedtrдn" "vedtrдna" ;
  vegan_nn_1 = mkN "vegan" "veganer" ;
  vegetabilisk_av_1 = mkA "vegetabilisk" ;
  vegetarian_nn_1 = mkN "vegetarian" "vegetarianer" ;
  vegetariansk_av_1 = mkA "vegetariansk" ;
  vegetarisk_av_1 = mkA "vegetarisk" ;
  vegetation_nn_1 = mkN "vegetation" "vegetationer" ;
  vegetationsbaelte_nn_1 = mkN "vegetationsbдlte" ;
  vegetationsknopp_nn_1 = mkN "vegetationsknopp" ;
  vegetationsperiod_nn_1 = mkN "vegetationsperiod" "vegetationsperioder" ;
  vegetationszon_nn_1 = mkN "vegetationszon" "vegetationszoner" ;
  vegetativ_av_1 = mkA "vegetativ" ;
  vehikel_nn_1 = mkN "vehikel" ;
  vek_av_1 = mkA "vek" ;
  veke_nn_1 = mkN "veke" utrum ;
  veklig_av_1 = mkA "veklig" ;
  veklighet_nn_1 = mkN "veklighet" "vekligheter" ;
  vekling_nn_1 = mkN "vekling" ;
  vektor_nn_1 = mkN "vektor" "vektorer" ;
  velar_av_1 = mkA "velar" ;
  velar_nn_1 = mkN "velar" "velarer" ;
  vele_nn_1 = mkN "vele" utrum ;
  velig_av_1 = mkA "velig" ;
  veling_nn_1 = mkN "veling" ;
  velociped_nn_1 = mkN "velociped" "velocipeder" ;
  velodrom_nn_1 = mkN "velodrom" "velodromer" ;
  velourpappa_nn_1 = mkN "velourpappa" ;
  vemodig_av_1 = mkA "vemodig" ;
  ven_nn_1 = mkN "ven" "vener" ;
  vend_nn_1 = mkN "vend" "vender" ;
  vendisk_av_1 = mkA "vendisk" ;
  venerabel_av_1 = mkA "venerabel" "venerabelt" "venerabla" "venerabla" "venerablare" "venerablast" "venerablaste" ;
  venereolog_nn_1 = mkN "venereolog" "venereologer" ;
  venereologisk_av_1 = mkA "venereologisk" ;
  venerisk_av_1 = mkA "venerisk" ;
  venetian_nn_1 = mkN "venetian" "venetianer" ;
  venetianare_nn_1 = mkN "venetianare" "venetianare" ;
  venetiansk_av_1 = mkA "venetiansk" ;
  venezuelan_nn_1 = mkN "venezuelan" "venezuelaner" ;
  venoes_av_1 = mkA "venцs" ;
  ventil_nn_1 = mkN "ventil" "ventiler" ;
  ventilation_nn_1 = mkN "ventilation" "ventilationer" ;
  ventilationsflaekt_nn_1 = mkN "ventilationsflдkt" ;
  ventilator_nn_1 = mkN "ventilator" "ventilatorer" ;
  ventilbasun_nn_1 = mkN "ventilbasun" "ventilbasuner" ;
  ventilgummi_nn_1 = mkN "ventilgummi" "ventilgummit" "ventilgummin" "ventilgummina" ;
  ventilhatt_nn_1 = mkN "ventilhatt" ;
  ventilhus_nn_1 = mkN "ventilhus" neutrum ;
  ventrikel_nn_1 = mkN "ventrikel" ;
  venusberg_nn_1 = mkN "venusberg" neutrum ;
  verb_nn_1 = mkN "verb" neutrum ;
  verbaendelse_nn_1 = mkN "verbдndelse" "verbдndelser" ;
  verbal_av_1 = mkA "verbal" ;
  verbalabstrakt_nn_1 = mkN "verbalabstrakt" neutrum ;
  verbalfaktor_nn_1 = mkN "verbalfaktor" "verbalfaktorer" ;
  verbaliter_ab_1 = mkAdv "verbaliter" ;
  verbalitet_nn_1 = mkN "verbalitet" "verbaliteter" ;
  verbalnot_nn_1 = mkN "verbalnot" "verbalnoter" ;
  verbalstam_nn_1 = mkN "verbalstam" "verbalstammen" "verbalstammar" "verbalstammarna" ;
  verbalsubstantiv_nn_1 = mkN "verbalsubstantiv" neutrum ;
  verbform_nn_1 = mkN "verbform" "verbformer" ;
  verbhandling_nn_1 = mkN "verbhandling" ;
  verbsammansaettning_nn_1 = mkN "verbsammansдttning" ;
  verbstam_nn_1 = mkN "verbstam" "verbstammen" "verbstammar" "verbstammarna" ;
  verifikat_nn_1 = mkN "verifikat" neutrum ;
  verifikation_nn_1 = mkN "verifikation" "verifikationer" ;
  veritabel_av_1 = mkA "veritabel" "veritabelt" "veritabla" "veritabla" "veritablare" "veritablast" "veritablaste" ;
  verk_nn_1 = mkN "verk" neutrum ;
  verkbord_nn_1 = mkN "verkbord" neutrum ;
  verkhelig_av_1 = mkA "verkhelig" ;
  verkjaern_nn_1 = mkN "verkjдrn" neutrum ;
  verklig_av_1 = mkA "verklig" ;
  verkligen_ab_1 = mkAdv "verkligen" ;
  verklighet_nn_1 = mkN "verklighet" "verkligheter" ;
  verklighetsbakgrund_nn_1 = mkN "verklighetsbakgrund" "verklighetsbakgrunder" ;
  verklighetsfraemmande_av_1 = mkA "verklighetsfrдmmande" ;
  verklighetsnaera_av_1 = mkA "verklighetsnдra" ;
  verklighetstrogen_av_1 = mkA "verklighetstrogen" "verklighetstroget" ;
  verkmaestare_nn_1 = mkN "verkmдstare" "verkmдstare" ;
  verkning_nn_1 = mkN "verkning" ;
  verkningsfull_av_1 = mkA "verkningsfull" ;
  verkningsgrad_nn_1 = mkN "verkningsgrad" "verkningsgrader" ;
  verkningsloes_av_1 = mkA "verkningslцs" ;
  verksam_av_1 = mkA "verksam" "verksamt" "verksamma" "verksamma" "verksammare" "verksammast" "verksammaste" ;
  verksamhet_nn_1 = mkN "verksamhet" "verksamheter" ;
  verksamhetsaar_nn_1 = mkN "verksamhetsеr" neutrum ;
  verksamhetsbehov_nn_1 = mkN "verksamhetsbehov" neutrum ;
  verksamhetsberaettelse_nn_1 = mkN "verksamhetsberдttelse" "verksamhetsberдttelser" ;
  verksamhetsfaelt_nn_1 = mkN "verksamhetsfдlt" neutrum ;
  verkslaekare_nn_1 = mkN "verkslдkare" "verkslдkare" ;
  verkstad_nn_1 = mkN "verkstad" "verkstдder" ;
  verkstadsarbetare_nn_1 = mkN "verkstadsarbetare" "verkstadsarbetare" ;
  verkstadsfoerening_nn_1 = mkN "verkstadsfцrening" ;
  verkstadshus_nn_1 = mkN "verkstadshus" neutrum ;
  verkstadsindustri_nn_1 = mkN "verkstadsindustri" "verkstadsindustrier" ;
  verkstadsklubb_nn_1 = mkN "verkstadsklubb" ;
  verkstaellande_av_1 = mkA "verkstдllande" ;
  verkstaellighet_nn_1 = mkN "verkstдllighet" "verkstдlligheter" ;
  verksynd_nn_1 = mkN "verksynd" "verksynder" ;
  verktum_nn_1 = mkN "verktum" "verktummen" "verktum" "verktummen" ;
  verktyg_nn_1 = mkN "verktyg" neutrum ;
  verktygsmaskin_nn_1 = mkN "verktygsmaskin" "verktygsmaskiner" ;
  verktygssats_nn_1 = mkN "verktygssats" "verktygssatser" ;
  vernalisering_nn_1 = mkN "vernalisering" ;
  vernissage_nn_1 = mkN "vernissage" "vernissager" ;
  vers_nn_1 = mkN "vers" ;
  versal_nn_1 = mkN "versal" "versaler" ;
  versatil_av_1 = mkA "versatil" ;
  versberaettelse_nn_1 = mkN "versberдttelse" "versberдttelser" ;
  versbindning_nn_1 = mkN "versbindning" ;
  versfot_nn_1 = mkN "versfot" "versfцtter" ;
  versifikation_nn_1 = mkN "versifikation" "versifikationer" ;
  versifikatoer_nn_1 = mkN "versifikatцr" "versifikatцrer" ;
  version_nn_1 = mkN "version" "versioner" ;
  verslaera_nn_1 = mkN "verslдra" ;
  versmaatt_nn_1 = mkN "versmеtt" neutrum ;
  versmakare_nn_1 = mkN "versmakare" "versmakare" ;
  versrad_nn_1 = mkN "versrad" "versrader" ;
  verst_nn_1 = mkN "verst" "versten" "verst" "versten" ;
  vertebrat_nn_1 = mkN "vertebrat" "vertebrater" ;
  vertikal_av_1 = mkA "vertikal" ;
  vertikal_nn_1 = mkN "vertikal" "vertikaler" ;
  vertikalcirkel_nn_1 = mkN "vertikalcirkel" ;
  vertikalplan_nn_1 = mkN "vertikalplan" neutrum ;
  vertikalstroem_nn_1 = mkN "vertikalstrцm" "vertikalstrцmmen" "vertikalstrцmmar" "vertikalstrцmmarna" ;
  vertikalvinkel_nn_1 = mkN "vertikalvinkel" ;
  vesaell_av_1 = mkA "vesдll" ;
  vesir_nn_1 = mkN "vesir" "vesirer" ;
  vesper_nn_1 = mkN "vesper" ;
  vestal_nn_1 = mkN "vestal" "vestaler" ;
  vestalisk_av_1 = mkA "vestalisk" ;
  vestibul_nn_1 = mkN "vestibul" "vestibuler" ;
  vetande_av_1 = mkA "vetande" ;
  vetbar_av_1 = mkA "vetbar" ;
  vetebroed_nn_1 = mkN "vetebrцd" neutrum ;
  vetebulle_nn_1 = mkN "vetebulle" utrum ;
  vetegrodd_nn_1 = mkN "vetegrodd" ;
  vetekorn_nn_1 = mkN "vetekorn" neutrum ;
  vetekrans_nn_1 = mkN "vetekrans" ;
  vetenskap_nn_1 = mkN "vetenskap" "vetenskaper" ;
  vetenskapare_nn_1 = mkN "vetenskapare" "vetenskapare" ;
  vetenskaplig_av_1 = mkA "vetenskaplig" ;
  vetenskapsakademi_nn_1 = mkN "vetenskapsakademi" "vetenskapsakademier" ;
  vetenskapsman_nn_1 = mkN "vetenskapsman" "vetenskapsmannen" "vetenskapsmдn" "vetenskapsmдnnen" ;
  veteran_nn_1 = mkN "veteran" "veteraner" ;
  veteranbil_nn_1 = mkN "veteranbil" ;
  veterinaer_nn_1 = mkN "veterinдr" "veterinдrer" ;
  veterligen_ab_1 = mkAdv "veterligen" ;
  veterligt_ab_1 = mkAdv "veterligt" ;
  vetesort_nn_1 = mkN "vetesort" "vetesorter" ;
  vetgirig_av_1 = mkA "vetgirig" ;
  veto_nn_1 = mkN "veto" "vetot" "veton" "vetona" ;
  vette_nn_1 = mkN "vette" utrum ;
  vettig_av_1 = mkA "vettig" ;
  vettloes_av_1 = mkA "vettlцs" ;
  vettskraemd_av_1 = mkA "vettskrдmd" "vettskrдmt" ;
  vettvillig_av_1 = mkA "vettvillig" ;
  vettvilling_nn_1 = mkN "vettvilling" ;
  vev_nn_1 = mkN "vev" ;
  vevarm_nn_1 = mkN "vevarm" ;
  vevaxel_nn_1 = mkN "vevaxel" ;
  vevhus_nn_1 = mkN "vevhus" neutrum ;
  vevling_nn_1 = mkN "vevling" ;
  vevstaang_nn_1 = mkN "vevstеng" "vevstдnger" ;
  vevstake_nn_1 = mkN "vevstake" utrum ;
  vevtapp_nn_1 = mkN "vevtapp" ;
  vi_ab_1 = mkAdv "vi" ;
  viadukt_nn_1 = mkN "viadukt" "viadukter" ;
  vial_nn_1 = mkN "vial" "vialer" ;
  vibrafon_nn_1 = mkN "vibrafon" "vibrafoner" ;
  vibrant_nn_1 = mkN "vibrant" "vibranter" ;
  vibration_nn_1 = mkN "vibration" "vibrationer" ;
  vibrato_nn_1 = mkN "vibrato" "vibratot" "vibraton" "vibratona" ;
  vibrator_nn_1 = mkN "vibrator" "vibratorer" ;
  vibrion_nn_1 = mkN "vibrion" "vibrioner" ;
  vice_av_1 = mkA "vice" ;
  viceamiral_nn_1 = mkN "viceamiral" "viceamiraler" ;
  vicekonung_nn_1 = mkN "vicekonung" ;
  vicekorpral_nn_1 = mkN "vicekorpral" "vicekorpraler" ;
  vicekung_nn_1 = mkN "vicekung" ;
  vicepresident_nn_1 = mkN "vicepresident" "vicepresidenter" ;
  vicevaerd_nn_1 = mkN "vicevдrd" ;
  vichyvatten_nn_1 = mkN "vichyvatten" "vichyvattnet" "vichyvatten" "vichyvattnen" ;
  vick_nn_1 = mkN "vick" neutrum ;
  vickel_nn_1 = mkN "vickel" ;
  vickig_av_1 = mkA "vickig" ;
  vickning_nn_1 = mkN "vickning" ;
  victoriansk_av_1 = mkA "victoriansk" ;
  vid_ab_1 = mkAdv "vid" ;
  vid_av_1 = mkA "vid" ;
  vida_ab_1 = mkAdv "vida" ;
  vidareutbildning_nn_1 = mkN "vidareutbildning" ;
  vidbraend_av_1 = mkA "vidbrдnd" ;
  vidd_nn_1 = mkN "vidd" "vidder" ;
  video_nn_1 = mkN "video" "videor" ;
  videoband_nn_1 = mkN "videoband" neutrum ;
  videobandspelare_nn_1 = mkN "videobandspelare" "videobandspelare" ;
  videosignal_nn_1 = mkN "videosignal" "videosignaler" ;
  viderboende_nn_1 = mkN "viderboende" "viderboenden" "viderboende" "viderboendena" ;
  vidertryck_nn_1 = mkN "vidertryck" neutrum ;
  videsparv_nn_1 = mkN "videsparv" ;
  vidfilm_nn_1 = mkN "vidfilm" "vidfilmer" ;
  vidhaalla_vb_1 = mkV "vidhеlla" "vidhцll" "vidhеllit" ;
  vidhaeftning_nn_1 = mkN "vidhдftning" ;
  vidi_ab_1 = mkAdv "vidi" ;
  vidimation_nn_1 = mkN "vidimation" "vidimationer" ;
  vidimering_nn_1 = mkN "vidimering" ;
  vidja_nn_1 = mkN "vidja" ;
  vidlyftig_av_1 = mkA "vidlyftig" ;
  vidmakthaalla_vb_1 = mkV "vidmakthеlla" "vidmakthцll" "vidmakthеllit" ;
  vidoeppen_av_1 = mkA "vidцppen" "vidцppet" ;
  vidraekning_nn_1 = mkN "vidrдkning" ;
  vidrig_av_1 = mkA "vidrig" ;
  vidskepelse_nn_1 = mkN "vidskepelse" "vidskepelser" ;
  vidskeplig_av_1 = mkA "vidskeplig" ;
  vidstaaende_av_1 = mkA "vidstеende" ;
  vidstraeckt_av_1 = mkA "vidstrдckt" "vidstrдckt" ;
  vidsynt_av_1 = mkA "vidsynt" "vidsynt" ;
  vidsynthet_nn_1 = mkN "vidsynthet" "vidsyntheter" ;
  vidta_vb_1 = mkV "vidta" "vidtar" "vidta" "vidtog" "vidtagit" "vidtagen" ;
  vidunder_nn_1 = mkN "vidunder" neutrum ;
  vidunderlig_av_1 = mkA "vidunderlig" ;
  vidvinkelobjektiv_nn_1 = mkN "vidvinkelobjektiv" neutrum ;
  vielle_nn_1 = mkN "vielle" "vieller" ;
  vietnames_nn_1 = mkN "vietnames" "vietnameser" ;
  vietnamesisk_av_1 = mkA "vietnamesisk" ;
  vietnamesiska_nn_2 = mkN "vietnamesiska" ;
  vig_av_1 = mkA "vig" ;
  vigg_nn_1 = mkN "vigg" ;
  vigge_nn_1 = mkN "vigge" utrum ;
  vigkvast_nn_1 = mkN "vigkvast" ;
  vigsel_nn_1 = mkN "vigsel" ;
  vigselannons_nn_1 = mkN "vigselannons" "vigselannonser" ;
  vigselbevis_nn_1 = mkN "vigselbevis" neutrum ;
  vigselformulaer_nn_1 = mkN "vigselformulдr" neutrum ;
  vigselring_nn_1 = mkN "vigselring" ;
  vigselrum_nn_1 = mkN "vigselrum" "vigselrummet" "vigselrum" "vigselrummen" ;
  vik_nn_1 = mkN "vik" ;
  vika_ab_1 = mkAdv "vika" ;
  vika_vb_1 = mkV "vika" "vek" "vikit" ;
  vikare_nn_1 = mkN "vikare" "vikare" ;
  vikariat_nn_1 = mkN "vikariat" neutrum ;
  vikarie_nn_1 = mkN "vikarie" "vikarier" ;
  vikarierande_av_1 = mkA "vikarierande" ;
  vikdoerr_nn_1 = mkN "vikdцrr" ;
  viking_nn_1 = mkN "viking" ;
  vikingagrav_nn_1 = mkN "vikingagrav" ;
  vikingaskepp_nn_1 = mkN "vikingaskepp" neutrum ;
  vikingataag_nn_1 = mkN "vikingatеg" neutrum ;
  vikning_nn_1 = mkN "vikning" ;
  vikon_nn_1 = mkN "vikon" neutrum ;
  vikt_nn_1 = mkN "vikt" "vikter" ;
  viktenhet_nn_1 = mkN "viktenhet" "viktenheter" ;
  viktfoerlust_nn_1 = mkN "viktfцrlust" "viktfцrluster" ;
  viktig_av_1 = mkA "viktig" ;
  viktighetsmakare_nn_1 = mkN "viktighetsmakare" "viktighetsmakare" ;
  viktigpetter_nn_1 = mkN "viktigpetter" ;
  viktjusterare_nn_1 = mkN "viktjusterare" "viktjusterare" ;
  viktklass_nn_1 = mkN "viktklass" "viktklasser" ;
  viktloes_av_1 = mkA "viktlцs" ;
  viktminskning_nn_1 = mkN "viktminskning" ;
  viktoriansk_av_1 = mkA "viktoriansk" ;
  viktprocent_nn_1 = mkN "viktprocent" "viktprocenten" "viktprocent" "viktprocenten" ;
  viktskillnad_nn_1 = mkN "viktskillnad" "viktskillnader" ;
  viktsystem_nn_1 = mkN "viktsystem" neutrum ;
  viktualiehandel_nn_1 = mkN "viktualiehandel" ;
  vila_nn_1 = mkN "vila" ;
  vild_av_1 = mkA "vild" "vilt" ;
  vildand_nn_1 = mkN "vildand" "vildдnder" ;
  vildapel_nn_1 = mkN "vildapel" ;
  vildbasare_nn_1 = mkN "vildbasare" "vildbasare" ;
  vilddjur_nn_1 = mkN "vilddjur" neutrum ;
  vilde_nn_1 = mkN "vilde" utrum ;
  vildfaagel_nn_1 = mkN "vildfеgel" ;
  vildgaas_nn_1 = mkN "vildgеs" "vildgеsen" "vildgдss" "vildgдssen" ;
  vildgraes_nn_1 = mkN "vildgrдs" neutrum ;
  vilding_nn_1 = mkN "vilding" ;
  vildkanin_nn_1 = mkN "vildkanin" "vildkaniner" ;
  vildkatt_nn_1 = mkN "vildkatt" "vildkatter" ;
  vildmark_nn_1 = mkN "vildmark" "vildmarker" ;
  vildnad_nn_1 = mkN "vildnad" "vildnader" ;
  vildren_nn_1 = mkN "vildren" "vildrenen" "vildrenar" "vildrenarna" ;
  vildrensjakt_nn_1 = mkN "vildrensjakt" "vildrensjakter" ;
  vildsint_av_1 = mkA "vildsint" "vildsint" ;
  vildskott_nn_1 = mkN "vildskott" neutrum ;
  vildstam_nn_1 = mkN "vildstam" "vildstammen" "vildstammar" "vildstammarna" ;
  vildsvin_nn_1 = mkN "vildsvin" neutrum ;
  vildvuxen_av_1 = mkA "vildvuxen" "vildvuxet" ;
  vilfaatoelj_nn_1 = mkN "vilfеtцlj" "vilfеtцljer" ;
  vilja_nn_1 = mkN "vilja" ;
  viljeakt_nn_1 = mkN "viljeakt" "viljeakter" ;
  viljeanstraengning_nn_1 = mkN "viljeanstrдngning" ;
  viljefoerklaring_nn_1 = mkN "viljefцrklaring" ;
  viljehandling_nn_1 = mkN "viljehandling" ;
  viljeloes_av_1 = mkA "viljelцs" ;
  viljemaenniska_nn_1 = mkN "viljemдnniska" ;
  viljemaessig_av_1 = mkA "viljemдssig" ;
  viljestark_av_1 = mkA "viljestark" ;
  viljesvag_av_1 = mkA "viljesvag" ;
  viljeyttring_nn_1 = mkN "viljeyttring" ;
  vill_ab_1 = mkAdv "vill" ;
  villa_nn_1 = mkN "villa" ;
  villande_av_1 = mkA "villande" ;
  villanell_nn_1 = mkN "villanell" "villaneller" ;
  villaservitut_nn_1 = mkN "villaservitut" neutrum ;
  villebraad_nn_1 = mkN "villebrеd" neutrum ;
  villfara_vb_1 = mkV "villfara" "villfor" "villfarit" ;
  villfarelse_nn_1 = mkN "villfarelse" "villfarelser" ;
  villig_av_1 = mkA "villig" ;
  villkor_nn_1 = mkN "villkor" neutrum ;
  villkorlig_av_1 = mkA "villkorlig" ;
  villkorsbisats_nn_1 = mkN "villkorsbisats" "villkorsbisatser" ;
  villkorskonjunktion_nn_1 = mkN "villkorskonjunktion" "villkorskonjunktioner" ;
  villkorsloes_av_1 = mkA "villkorslцs" ;
  villolaera_nn_1 = mkN "villolдra" ;
  villospaar_nn_1 = mkN "villospеr" neutrum ;
  villovaeg_nn_1 = mkN "villovдg" ;
  villraadig_av_1 = mkA "villrеdig" ;
  villsam_av_1 = mkA "villsam" "villsamt" "villsamma" "villsamma" "villsammare" "villsammast" "villsammaste" ;
  vilodag_nn_1 = mkN "vilodag" ;
  vilohem_nn_1 = mkN "vilohem" "vilohemmet" "vilohem" "vilohemmen" ;
  vilolaege_nn_1 = mkN "vilolдge" ;
  vilolaeger_nn_1 = mkN "vilolдger" neutrum ;
  vilopaus_nn_1 = mkN "vilopaus" "vilopauser" ;
  viloplats_nn_1 = mkN "viloplats" "viloplatser" ;
  vilopunkt_nn_1 = mkN "vilopunkt" "vilopunkter" ;
  vilorum_nn_1 = mkN "vilorum" "vilorummet" "vilorum" "vilorummen" ;
  vilostadium_nn_1 = mkN "vilostadium" "vilostadiet" "vilostadier" "vilostadierna" ;
  vilrum_nn_1 = mkN "vilrum" "vilrummet" "vilrum" "vilrummen" ;
  vilsam_av_1 = mkA "vilsam" "vilsamt" "vilsamma" "vilsamma" "vilsammare" "vilsammast" "vilsammaste" ;
  vilse_ab_1 = mkAdv "vilse" ;
  vilsegaangen_av_1 = mkA "vilsegеngen" "vilsegеnget" ;
  vilsekommen_av_1 = mkA "vilsekommen" "vilsekommet" "vilsekomna" "vilsekomna" "vilsekomnare" "vilsekomnast" "vilsekomnaste" ;
  vilseledande_av_1 = mkA "vilseledande" ;
  vilsen_av_1 = mkA "vilsen" "vilset" ;
  vilstol_nn_1 = mkN "vilstol" ;
  vilthandlare_nn_1 = mkN "vilthandlare" "vilthandlare" ;
  viltplantering_nn_1 = mkN "viltplantering" ;
  viltspegel_nn_1 = mkN "viltspegel" ;
  viltstraak_nn_1 = mkN "viltstrеk" neutrum ;
  vimmelkantig_av_1 = mkA "vimmelkantig" ;
  vimpel_nn_1 = mkN "vimpel" ;
  vimpelprydd_av_1 = mkA "vimpelprydd" ;
  vimperg_nn_1 = mkN "vimperg" "vimperger" ;
  vimsig_av_1 = mkA "vimsig" ;
  vin_nn_1 = mkN "vin" "vinet" "viner" "vinerna" ;
  vinaar_nn_1 = mkN "vinеr" neutrum ;
  vinare_nn_1 = mkN "vinare" "vinare" ;
  vinbaal_nn_1 = mkN "vinbеl" ;
  vinbaer_nn_1 = mkN "vinbдr" neutrum ;
  vinbaersbuske_nn_1 = mkN "vinbдrsbuske" utrum ;
  vind_av_1 = mkA "vind" ;
  vind_nn_1 = mkN "vind" ;
  vind_nn_2 = mkN "vind" ;
  vindaegg_nn_1 = mkN "vindдgg" neutrum ;
  vindaendring_nn_1 = mkN "vindдndring" ;
  vindbaelte_nn_1 = mkN "vindbдlte" ;
  vindboejtel_nn_1 = mkN "vindbцjtel" ;
  vindbro_nn_1 = mkN "vindbro" ;
  vindby_nn_1 = mkN "vindby" "vindbyn" "vindbyar" "vindbyarna" ;
  vinddriven_av_1 = mkA "vinddriven" "vinddrivet" ;
  vindel_nn_1 = mkN "vindel" ;
  vindfaang_nn_1 = mkN "vindfеng" neutrum ;
  vindfloejel_nn_1 = mkN "vindflцjel" ;
  vindfoerhaallande_nn_1 = mkN "vindfцrhеllande" ;
  vindhastighet_nn_1 = mkN "vindhastighet" "vindhastigheter" ;
  vindil_nn_1 = mkN "vindil" ;
  vindkantring_nn_1 = mkN "vindkantring" ;
  vindkraftverk_nn_1 = mkN "vindkraftverk" neutrum ;
  vindling_nn_1 = mkN "vindling" ;
  vindmaetare_nn_1 = mkN "vindmдtare" "vindmдtare" ;
  vindmaetning_nn_1 = mkN "vindmдtning" ;
  vindmaetningsinstrument_nn_1 = mkN "vindmдtningsinstrument" neutrum ;
  vindoega_nn_1 = mkN "vindцga" "vindцgat" "vindцgon" "vindцgonen" ;
  vindoegd_av_1 = mkA "vindцgd" "vindцgt" ;
  vindpollinering_nn_1 = mkN "vindpollinering" ;
  vindraett_ab_1 = mkAdv "vindrдtt" ;
  vindriktning_nn_1 = mkN "vindriktning" ;
  vindruta_nn_1 = mkN "vindruta" ;
  vindrutespolare_nn_1 = mkN "vindrutespolare" "vindrutespolare" ;
  vindrutetorkare_nn_1 = mkN "vindrutetorkare" "vindrutetorkare" ;
  vindsida_nn_1 = mkN "vindsida" ;
  vindskaerm_nn_1 = mkN "vindskдrm" ;
  vindskammare_nn_1 = mkN "vindskammare" "vindskammaren" "vindskamrar" "vindskamrarna" ;
  vindskontor_nn_1 = mkN "vindskontor" neutrum ;
  vindskydd_nn_1 = mkN "vindskydd" neutrum ;
  vindspel_nn_1 = mkN "vindspel" "vindspelet" "vindspel" "vindspelen" ;
  vindstilla_av_1 = mkA "vindstilla" ;
  vindstoet_nn_1 = mkN "vindstцt" ;
  vindstyrka_nn_1 = mkN "vindstyrka" ;
  vindsutrymme_nn_1 = mkN "vindsutrymme" ;
  vindtaet_av_1 = mkA "vindtдt" ;
  vindtunnel_nn_1 = mkN "vindtunnel" ;
  vindvridning_nn_1 = mkN "vindvridning" ;
  ving_nn_1 = mkN "ving" ;
  vingaard_nn_1 = mkN "vingеrd" ;
  vingaardsarbetare_nn_1 = mkN "vingеrdsarbetare" "vingеrdsarbetare" ;
  vingaardsman_nn_1 = mkN "vingеrdsman" "vingеrdsmannen" "vingеrdsmдn" "vingеrdsmдnnen" ;
  vingbredd_nn_1 = mkN "vingbredd" "vingbredder" ;
  vingbruten_av_1 = mkA "vingbruten" "vingbrutet" ;
  vinge_nn_1 = mkN "vinge" utrum ;
  vingelpelle_nn_1 = mkN "vingelpelle" utrum ;
  vingfrukt_nn_1 = mkN "vingfrukt" "vingfrukter" ;
  vingklaff_nn_1 = mkN "vingklaff" ;
  vinglas_nn_1 = mkN "vinglas" neutrum ;
  vinglig_av_1 = mkA "vinglig" ;
  vingloes_av_1 = mkA "vinglцs" ;
  vingmutter_nn_1 = mkN "vingmutter" ;
  vingplog_nn_1 = mkN "vingplog" ;
  vingslag_nn_1 = mkN "vingslag" neutrum ;
  vingspegel_nn_1 = mkN "vingspegel" ;
  vingspets_nn_1 = mkN "vingspets" ;
  vingtaeckare_nn_1 = mkN "vingtдckare" "vingtдckare" ;
  vingteckning_nn_1 = mkN "vingteckning" ;
  vingud_nn_1 = mkN "vingud" ;
  vingummi_nn_1 = mkN "vingummi" "vingummit" "vingummin" "vingummina" ;
  vinjett_nn_1 = mkN "vinjett" "vinjetter" ;
  vink_nn_1 = mkN "vink" ;
  vinkaennare_nn_1 = mkN "vinkдnnare" "vinkдnnare" ;
  vinkel_nn_1 = mkN "vinkel" ;
  vinkelarm_nn_1 = mkN "vinkelarm" ;
  vinkelavstaand_nn_1 = mkN "vinkelavstеnd" neutrum ;
  vinkelben_nn_1 = mkN "vinkelben" neutrum ;
  vinkelborr_nn_1 = mkN "vinkelborr" ;
  vinkelhake_nn_1 = mkN "vinkelhake" utrum ;
  vinkelhastighet_nn_1 = mkN "vinkelhastighet" "vinkelhastigheter" ;
  vinkelhus_nn_1 = mkN "vinkelhus" neutrum ;
  vinkeljaern_nn_1 = mkN "vinkeljдrn" neutrum ;
  vinkelknae_nn_1 = mkN "vinkelknд" "vinkelknдet" "vinkelknдn" "vinkelknдna" ;
  vinkellinjal_nn_1 = mkN "vinkellinjal" "vinkellinjaler" ;
  vinkelmaatt_nn_1 = mkN "vinkelmеtt" neutrum ;
  vinkelpredikant_nn_1 = mkN "vinkelpredikant" "vinkelpredikanter" ;
  vinkelraet_av_1 = mkA "vinkelrдt" ;
  vinkelskillnad_nn_1 = mkN "vinkelskillnad" "vinkelskillnader" ;
  vinkelspets_nn_1 = mkN "vinkelspets" ;
  vinkelsumma_nn_1 = mkN "vinkelsumma" ;
  vinkling_nn_1 = mkN "vinkling" ;
  vinkork_nn_1 = mkN "vinkork" ;
  vinland_nn_1 = mkN "vinland" "vinlandet" "vinlдnder" "vinlдnderna" ;
  vinloev_nn_1 = mkN "vinlцv" neutrum ;
  vinlus_nn_1 = mkN "vinlus" "vinlusen" "vinlцss" "vinlцssen" ;
  vinmaerke_nn_1 = mkN "vinmдrke" ;
  vinn_ab_1 = mkAdv "vinn" ;
  vinna_vb_1 = mkV "vinna" "vann" "vunnit" ;
  vinnande_av_1 = mkA "vinnande" ;
  vinnare_nn_1 = mkN "vinnare" "vinnare" ;
  vinnarhaal_nn_1 = mkN "vinnarhеl" neutrum ;
  vinningslysten_av_1 = mkA "vinningslysten" "vinningslystet" ;
  vinningslystnad_nn_1 = mkN "vinningslystnad" "vinningslystnader" ;
  vinodlare_nn_1 = mkN "vinodlare" "vinodlare" ;
  vinraettighet_nn_1 = mkN "vinrдttighet" "vinrдttigheter" ;
  vinroed_av_1 = mkA "vinrцd" ;
  vinsch_nn_1 = mkN "vinsch" ;
  vinservering_nn_1 = mkN "vinservering" ;
  vinskaenk_nn_1 = mkN "vinskдnk" ;
  vinskoerd_nn_1 = mkN "vinskцrd" ;
  vinsort_nn_1 = mkN "vinsort" "vinsorter" ;
  vinst_nn_1 = mkN "vinst" "vinster" ;
  vinstandel_nn_1 = mkN "vinstandel" "vinstandelen" "vinstandelar" "vinstandelarna" ;
  vinstchans_nn_1 = mkN "vinstchans" "vinstchanser" ;
  vinstdelning_nn_1 = mkN "vinstdelning" ;
  vinstdelningsskatt_nn_1 = mkN "vinstdelningsskatt" "vinstdelningsskatter" ;
  vinstmarginal_nn_1 = mkN "vinstmarginal" "vinstmarginaler" ;
  vinstnummer_nn_1 = mkN "vinstnummer" neutrum ;
  vinstock_nn_1 = mkN "vinstock" ;
  vinstplan_nn_1 = mkN "vinstplan" "vinstplaner" ;
  vinstuga_nn_1 = mkN "vinstuga" ;
  vintagevin_nn_1 = mkN "vintagevin" "vintagevinet" "vintageviner" "vintagevinerna" ;
  vinter_nn_1 = mkN "vinter" ;
  vinterbadare_nn_1 = mkN "vinterbadare" "vinterbadare" ;
  vinterblaa_av_1 = mkA "vinterblе" "vinterblеtt" ;
  vinterbostad_nn_1 = mkN "vinterbostad" "vinterbostдder" ;
  vinterdaeck_nn_1 = mkN "vinterdдck" neutrum ;
  vinterdraekt_nn_1 = mkN "vinterdrдkt" "vinterdrдkter" ;
  vinterfoder_nn_1 = mkN "vinterfoder" neutrum ;
  vinterfrukt_nn_1 = mkN "vinterfrukt" "vinterfrukter" ;
  vintergroen_av_1 = mkA "vintergrцn" ;
  vinterhaerdig_av_1 = mkA "vinterhдrdig" ;
  vinterhalvaar_nn_1 = mkN "vinterhalvеr" neutrum ;
  vinterhimmel_nn_1 = mkN "vinterhimmel" ;
  vinterkvaell_nn_1 = mkN "vinterkvдll" ;
  vinterlandskap_nn_1 = mkN "vinterlandskap" "vinterlandskapet" "vinterlandskapen" "vinterlandskapena" ;
  vinterlig_av_1 = mkA "vinterlig" ;
  vinterliggare_nn_1 = mkN "vinterliggare" "vinterliggare" ;
  vintermaanad_nn_1 = mkN "vintermеnad" "vintermеnader" ;
  vinternatt_nn_1 = mkN "vinternatt" "vinternдtter" ;
  vinterpaeron_nn_1 = mkN "vinterpдron" neutrum ;
  vinterskinn_nn_1 = mkN "vinterskinn" neutrum ;
  vinterspaarvagn_nn_1 = mkN "vinterspеrvagn" ;
  vintersport_nn_1 = mkN "vintersport" "vintersporter" ;
  vinterstaand_nn_1 = mkN "vinterstеnd" neutrum ;
  vintertraedgaard_nn_1 = mkN "vintertrдdgеrd" ;
  vintervaeg_nn_1 = mkN "vintervдg" ;
  vintervaeglag_nn_1 = mkN "vintervдglag" neutrum ;
  vintervila_nn_1 = mkN "vintervila" ;
  vinthund_nn_1 = mkN "vinthund" ;
  vintrig_av_1 = mkA "vintrig" ;
  viol_nn_1 = mkN "viol" "violer" ;
  violblaa_av_1 = mkA "violblе" "violblеtt" ;
  violett_av_1 = mkA "violett" ;
  violin_nn_1 = mkN "violin" "violiner" ;
  violinist_nn_1 = mkN "violinist" "violinister" ;
  violinklav_nn_1 = mkN "violinklav" "violinklaver" ;
  violoncell_nn_1 = mkN "violoncell" "violonceller" ;
  vip_nn_1 = mkN "vip" ;
  vipp_nn_1 = mkN "vipp" ;
  vippbraede_nn_1 = mkN "vippbrдde" ;
  vippig_av_1 = mkA "vippig" ;
  vippkoppling_nn_1 = mkN "vippkoppling" ;
  vippstjaert_nn_1 = mkN "vippstjдrt" ;
  viprum_nn_1 = mkN "viprum" "viprummet" "viprum" "viprummen" ;
  vips_ab_1 = mkAdv "vips" ;
  virginiahjort_nn_1 = mkN "virginiahjort" ;
  viril_av_1 = mkA "viril" ;
  virilitet_nn_1 = mkN "virilitet" "viriliteter" ;
  virkeskvalitet_nn_1 = mkN "virkeskvalitet" "virkeskvaliteter" ;
  virkesmaetning_nn_1 = mkN "virkesmдtning" ;
  virkgarn_nn_1 = mkN "virkgarn" neutrum ;
  virkkrok_nn_1 = mkN "virkkrok" ;
  virknaal_nn_1 = mkN "virknеl" ;
  virkning_nn_1 = mkN "virkning" ;
  virolog_nn_1 = mkN "virolog" "virologer" ;
  virrig_av_1 = mkA "virrig" ;
  virtuell_av_1 = mkA "virtuell" ;
  virtuos_av_1 = mkA "virtuos" ;
  virtuos_nn_1 = mkN "virtuos" "virtuoser" ;
  virtuositet_nn_1 = mkN "virtuositet" "virtuositeter" ;
  virtuosmaessig_av_1 = mkA "virtuosmдssig" ;
  virtuosnummer_nn_1 = mkN "virtuosnummer" neutrum ;
  virulent_av_1 = mkA "virulent" "virulent" ;
  virus_nn_1 = mkN "virus" neutrum ;
  virusinfektion_nn_1 = mkN "virusinfektion" "virusinfektioner" ;
  virussjukdom_nn_1 = mkN "virussjukdom" ;
  virvel_nn_1 = mkN "virvel" ;
  virvelroerelse_nn_1 = mkN "virvelrцrelse" "virvelrцrelser" ;
  virvelstorm_nn_1 = mkN "virvelstorm" ;
  virvelstroem_nn_1 = mkN "virvelstrцm" "virvelstrцmmen" "virvelstrцmmar" "virvelstrцmmarna" ;
  virvelvind_nn_1 = mkN "virvelvind" ;
  vis_av_1 = mkA "vis" ;
  vis_nn_1 = mkN "vis" neutrum ;
  visafton_nn_1 = mkN "visafton" "visaftonen" "visaftnar" "visaftnarna" ;
  visare_nn_1 = mkN "visare" "visare" ;
  visarkiv_nn_1 = mkN "visarkiv" neutrum ;
  visbok_nn_1 = mkN "visbok" "visbцcker" ;
  viscount_nn_1 = mkN "viscount" "viscounter" ;
  visdom_nn_1 = mkN "visdom" ;
  visdomsord_nn_1 = mkN "visdomsord" neutrum ;
  visdomstand_nn_1 = mkN "visdomstand" "visdomstдnder" ;
  vise_nn_1 = mkN "vise" utrum ;
  visefall_nn_1 = mkN "visefall" neutrum ;
  visent_nn_1 = mkN "visent" "visenter" ;
  viseringskort_nn_1 = mkN "viseringskort" neutrum ;
  vishet_nn_1 = mkN "vishet" "visheter" ;
  vishetslaera_nn_1 = mkN "vishetslдra" ;
  visibel_av_1 = mkA "visibel" "visibelt" "visibla" "visibla" "visiblare" "visiblast" "visiblaste" ;
  vision_nn_1 = mkN "vision" "visioner" ;
  visionaer_av_1 = mkA "visionдr" ;
  visir_nn_1 = mkN "visir" neutrum ;
  visit_nn_1 = mkN "visit" "visiter" ;
  visitation_nn_1 = mkN "visitation" "visitationer" ;
  visitator_nn_1 = mkN "visitator" "visitatorer" ;
  visitering_nn_1 = mkN "visitering" ;
  visitkort_nn_1 = mkN "visitkort" neutrum ;
  viskare_nn_1 = mkN "viskare" "viskare" ;
  viskning_nn_1 = mkN "viskning" ;
  viskoes_av_1 = mkA "viskцs" ;
  viskositet_nn_1 = mkN "viskositet" "viskositeter" ;
  vislig_av_1 = mkA "vislig" ;
  visligen_ab_1 = mkAdv "visligen" ;
  visman_nn_1 = mkN "visman" "vismannen" "vismдn" "vismдnnen" ;
  visning_nn_1 = mkN "visning" ;
  visp_nn_1 = mkN "visp" ;
  visper_nn_1 = mkN "visper" "visperen" "visperar" "visperarna" ;
  vispig_av_1 = mkA "vispig" ;
  viss_av_1 = mkA "viss" ;
  vissen_av_1 = mkA "vissen" "visset" ;
  visserligen_ab_1 = mkAdv "visserligen" ;
  visshet_nn_1 = mkN "visshet" "vissheter" ;
  vissla_nn_1 = mkN "vissla" ;
  vissling_nn_1 = mkN "vissling" ;
  visst_ab_1 = mkAdv "visst" ;
  visstidsfoerordnande_nn_1 = mkN "visstidsfцrordnande" ;
  vistelse_nn_1 = mkN "vistelse" "vistelser" ;
  vistelseort_nn_1 = mkN "vistelseort" "vistelseorter" ;
  visthus_nn_1 = mkN "visthus" neutrum ;
  visthusbod_nn_1 = mkN "visthusbod" ;
  visuell_av_1 = mkA "visuell" ;
  visum_nn_1 = mkN "visum" neutrum ;
  vit_av_1 = mkA "vit" ;
  vitaktig_av_1 = mkA "vitaktig" ;
  vital_av_1 = mkA "vital" ;
  vitalbehov_nn_1 = mkN "vitalbehov" neutrum ;
  vitalf_nn_1 = mkN "vitalf" "vitalfer" ;
  vitalfoernimmelse_nn_1 = mkN "vitalfцrnimmelse" "vitalfцrnimmelser" ;
  vitalitet_nn_1 = mkN "vitalitet" "vitaliteter" ;
  vitalkapacitet_nn_1 = mkN "vitalkapacitet" "vitalkapaciteter" ;
  vitalv_nn_1 = mkN "vitalv" "vitalver" ;
  vitamin_nn_1 = mkN "vitamin" "vitaminer" ;
  vitamininjektion_nn_1 = mkN "vitamininjektion" "vitamininjektioner" ;
  vitaminrik_av_1 = mkA "vitaminrik" ;
  vitbok_nn_1 = mkN "vitbok" "vitbцcker" ;
  vitbroderi_nn_1 = mkN "vitbroderi" "vitbroderit" "vitbroderier" "vitbroderierna" ;
  vitfisk_nn_1 = mkN "vitfisk" ;
  vitgloedande_av_1 = mkA "vitglцdande" ;
  vitgroen_av_1 = mkA "vitgrцn" ;
  vithaarig_av_1 = mkA "vithеrig" ;
  vithet_nn_1 = mkN "vithet" "vitheter" ;
  vithyllt_av_1 = mkA "vithyllt" "vithyllt" ;
  vitling_nn_1 = mkN "vitling" ;
  vitloek_nn_1 = mkN "vitlцk" ;
  vitmetall_nn_1 = mkN "vitmetall" "vitmetaller" ;
  vitmoegelost_nn_1 = mkN "vitmцgelost" ;
  vitnos_nn_1 = mkN "vitnos" ;
  vitplister_nn_1 = mkN "vitplister" ;
  vitraev_nn_1 = mkN "vitrдv" ;
  vitrin_nn_1 = mkN "vitrin" "vitriner" ;
  vitrinskaap_nn_1 = mkN "vitrinskеp" neutrum ;
  vitrock_nn_1 = mkN "vitrock" ;
  vitrysk_av_1 = mkA "vitrysk" ;
  vitryska_nn_2 = mkN "vitryska" ;
  vitryss_nn_1 = mkN "vitryss" ;
  vits_nn_1 = mkN "vits" ;
  vitsig_av_1 = mkA "vitsig" ;
  vitsord_nn_1 = mkN "vitsord" neutrum ;
  vitsvanshjort_nn_1 = mkN "vitsvanshjort" ;
  vittbekant_av_1 = mkA "vittbekant" "vittbekant" ;
  vittberest_av_1 = mkA "vittberest" "vittberest" ;
  vittberoemd_av_1 = mkA "vittberцmd" "vittberцmt" ;
  vitter_av_1 = mkA "vitter" "vittert" "vittra" "vittra" "vittrare" "vittrast" "vittraste" ;
  vitterhet_nn_1 = mkN "vitterhet" "vitterheter" ;
  vitterlek_nn_1 = mkN "vitterlek" ;
  vittfamnande_av_1 = mkA "vittfamnande" ;
  vittflygande_av_1 = mkA "vittflygande" ;
  vittgaaende_av_1 = mkA "vittgеende" ;
  vittling_nn_1 = mkN "vittling" ;
  vittne_nn_1 = mkN "vittne" ;
  vittnesbaas_nn_1 = mkN "vittnesbеs" neutrum ;
  vittnesboerd_nn_1 = mkN "vittnesbцrd" neutrum ;
  vittnesed_nn_1 = mkN "vittnesed" "vittneseder" ;
  vittnesgill_av_1 = mkA "vittnesgill" ;
  vittnesmaal_nn_1 = mkN "vittnesmеl" neutrum ;
  vittnesskrank_nn_1 = mkN "vittnesskrank" neutrum ;
  vittnesutsaga_nn_1 = mkN "vittnesutsaga" ;
  vittomfattande_av_1 = mkA "vittomfattande" ;
  vittvin_nn_1 = mkN "vittvin" "vittvinet" "vittviner" "vittvinerna" ;
  vitvara_nn_1 = mkN "vitvara" ;
  vitvin_nn_1 = mkN "vitvin" "vitvinet" "vitviner" "vitvinerna" ;
  viv_nn_1 = mkN "viv" neutrum ;
  vivace_ab_1 = mkAdv "vivace" ;
  vivacitet_nn_1 = mkN "vivacitet" "vivaciteter" ;
  vivel_nn_1 = mkN "vivel" ;
  vivipar_av_1 = mkA "vivipar" ;
  vivisektion_nn_1 = mkN "vivisektion" "vivisektioner" ;
  vivisektoer_nn_1 = mkN "vivisektцr" "vivisektцrer" ;
  vivoer_nn_1 = mkN "vivцr" "vivцrer" ;
  voall_nn_1 = mkN "voall" "voaller" ;
  voerdig_av_1 = mkA "vцrdig" ;
  voerdnad_nn_1 = mkN "vцrdnad" "vцrdnader" ;
  voerdnadsbetygelse_nn_1 = mkN "vцrdnadsbetygelse" "vцrdnadsbetygelser" ;
  voerdnadsbjudande_av_1 = mkA "vцrdnadsbjudande" ;
  voerdnadsfull_av_1 = mkA "vцrdnadsfull" ;
  voerdnadsvaerd_av_1 = mkA "vцrdnadsvдrd" "vцrdnadsvдrt" ;
  voerdsam_av_1 = mkA "vцrdsam" "vцrdsamt" "vцrdsamma" "vцrdsamma" "vцrdsammare" "vцrdsammast" "vцrdsammaste" ;
  voerdsamligen_ab_1 = mkAdv "vцrdsamligen" ;
  voertbroed_nn_1 = mkN "vцrtbrцd" neutrum ;
  voertstyrka_nn_1 = mkN "vцrtstyrka" ;
  voidkoefficient_nn_1 = mkN "voidkoefficient" "voidkoefficienter" ;
  vojlock_nn_1 = mkN "vojlock" ;
  vokabel_nn_1 = mkN "vokabel" "vokabeln" "vokabler" "vokablerna" ;
  vokabelsamling_nn_1 = mkN "vokabelsamling" ;
  vokabulaer_nn_1 = mkN "vokabulдr" "vokabulдrer" ;
  vokal_av_1 = mkA "vokal" ;
  vokal_nn_1 = mkN "vokal" "vokaler" ;
  vokalharmoni_nn_1 = mkN "vokalharmoni" "vokalharmonier" ;
  vokalis_nn_1 = mkN "vokalis" "vokaliser" ;
  vokalisk_av_1 = mkA "vokalisk" ;
  vokalist_nn_1 = mkN "vokalist" "vokalister" ;
  vokalkvalitet_nn_1 = mkN "vokalkvalitet" "vokalkvaliteter" ;
  vokalkvantitet_nn_1 = mkN "vokalkvantitet" "vokalkvantiteter" ;
  vokallaengd_nn_1 = mkN "vokallдngd" "vokallдngder" ;
  vokalmoete_nn_1 = mkN "vokalmцte" ;
  vokalrim_nn_1 = mkN "vokalrim" "vokalrimmet" "vokalrim" "vokalrimmen" ;
  vokalvaexling_nn_1 = mkN "vokalvдxling" ;
  vokativ_nn_1 = mkN "vokativ" "vokativer" ;
  volang_nn_1 = mkN "volang" "volanger" ;
  volauvent_nn_1 = mkN "volauvent" "volauventer" ;
  volframnaal_nn_1 = mkN "volframnеl" ;
  voljaer_nn_1 = mkN "voljдr" "voljдrer" ;
  volm_nn_1 = mkN "volm" ;
  volontaer_nn_1 = mkN "volontдr" "volontдrer" ;
  volt_nn_1 = mkN "volt" "volten" "volt" "volten" ;
  volt_nn_2 = mkN "volt" "volter" ;
  voltan_nn_1 = mkN "voltan" "voltaner" ;
  voltige_nn_1 = mkN "voltige" "voltiger" ;
  voltigoer_nn_1 = mkN "voltigцr" "voltigцrer" ;
  voltmaetare_nn_1 = mkN "voltmдtare" "voltmдtare" ;
  voltmeter_nn_1 = mkN "voltmeter" ;
  volttal_nn_1 = mkN "volttal" "volttalet" "volttalen" "volttalena" ;
  voluminoes_av_1 = mkA "voluminцs" ;
  volut_nn_1 = mkN "volut" "voluter" ;
  volym_nn_1 = mkN "volym" "volymer" ;
  volymenhet_nn_1 = mkN "volymenhet" "volymenheter" ;
  volymmaessig_av_1 = mkA "volymmдssig" ;
  volymprocent_nn_1 = mkN "volymprocent" "volymprocenten" "volymprocent" "volymprocenten" ;
  volymsenhet_nn_1 = mkN "volymsenhet" "volymsenheter" ;
  vom_nn_1 = mkN "vom" "vommen" "vommar" "vommarna" ;
  vomb_nn_1 = mkN "vomb" ;
  vombat_nn_1 = mkN "vombat" "vombater" ;
  vomitiv_nn_1 = mkN "vomitiv" neutrum ;
  vorstehhund_nn_1 = mkN "vorstehhund" ;
  votering_nn_1 = mkN "votering" ;
  votivskepp_nn_1 = mkN "votivskepp" neutrum ;
  votum_nn_1 = mkN "votum" neutrum ;
  voucher_nn_1 = mkN "voucher" "vouchern" "voucher" "voucherna" ;
  vovve_nn_1 = mkN "vovve" utrum ;
  voyeur_nn_1 = mkN "voyeur" "voyeurer" ;
  vraa_nn_1 = mkN "vrе" "vrеn" "vrеr" "vrеrna" ;
  vraak_nn_1 = mkN "vrеk" ;
  vraal_nn_1 = mkN "vrеl" neutrum ;
  vraalaak_nn_1 = mkN "vrеlеk" neutrum ;
  vraalflott_av_1 = mkA "vrеlflott" ;
  vraang_av_1 = mkA "vrеng" ;
  vraangbild_nn_1 = mkN "vrеngbild" "vrеngbilder" ;
  vraanghet_nn_1 = mkN "vrеnghet" "vrеngheter" ;
  vraangvis_av_1 = mkA "vrеngvis" ;
  vraekare_nn_1 = mkN "vrдkare" "vrдkare" ;
  vraekig_av_1 = mkA "vrдkig" ;
  vraekning_nn_1 = mkN "vrдkning" ;
  vrak_nn_1 = mkN "vrak" neutrum ;
  vraklax_nn_1 = mkN "vraklax" ;
  vrakpris_nn_1 = mkN "vrakpris" neutrum ;
  vrakspillra_nn_1 = mkN "vrakspillra" ;
  vred_nn_1 = mkN "vred" neutrum ;
  vrensk_av_1 = mkA "vrensk" ;
  vresig_av_1 = mkA "vresig" ;
  vrestall_nn_1 = mkN "vrestall" ;
  vret_nn_1 = mkN "vret" ;
  vrickning_nn_1 = mkN "vrickning" ;
  vrida_vb_1 = mkV "vrida" "vred" "vridit" ;
  vridbar_av_1 = mkA "vridbar" ;
  vriden_av_1 = mkA "vriden" "vridet" ;
  vridjaernsinstrument_nn_1 = mkN "vridjдrnsinstrument" neutrum ;
  vridmoment_nn_1 = mkN "vridmoment" neutrum ;
  vridning_nn_1 = mkN "vridning" ;
  vridningsaxel_nn_1 = mkN "vridningsaxel" ;
  vridscen_nn_1 = mkN "vridscen" "vridscener" ;
  vridspoleinstrument_nn_1 = mkN "vridspoleinstrument" neutrum ;
  vril_nn_1 = mkN "vril" ;
  vrist_nn_1 = mkN "vrist" "vrister" ;
  vristben_nn_1 = mkN "vristben" neutrum ;
  vulgaer_av_1 = mkA "vulgдr" ;
  vulgaritet_nn_1 = mkN "vulgaritet" "vulgariteter" ;
  vulkan_nn_1 = mkN "vulkan" "vulkaner" ;
  vulkanisator_nn_1 = mkN "vulkanisator" "vulkanisatorer" ;
  vulkanisk_av_1 = mkA "vulkanisk" ;
  vulkanit_nn_1 = mkN "vulkanit" "vulkaniter" ;
  vulkanutbrott_nn_1 = mkN "vulkanutbrott" neutrum ;
  vulkapparat_nn_1 = mkN "vulkapparat" "vulkapparater" ;
  vulst_nn_1 = mkN "vulst" "vulster" ;
  vulstig_av_1 = mkA "vulstig" ;
  vulva_nn_1 = mkN "vulva" ;
  vurm_nn_1 = mkN "vurm" ;
  vurst_nn_1 = mkN "vurst" ;
  vuxen_av_1 = mkA "vuxen" "vuxet" ;
  vy_nn_1 = mkN "vy" "vyer" ;
  vykort_nn_1 = mkN "vykort" neutrum ;
  wafer_nn_1 = mkN "wafer" "wafern" "wafers" "wafersen" ;
  wagon_nn_1 = mkN "wagon" "wagoner" ;
  walesare_nn_1 = mkN "walesare" "walesare" ;
  walesisk_av_1 = mkA "walesisk" ;
  walesiska_nn_2 = mkN "walesiska" ;
  walkie_talkie_nn_1 = mkN "walkie-talkie" "walkie-talkien" "walkie-talkies" "walkie-talkiesen" ;
  wankelmotor_nn_1 = mkN "wankelmotor" "wankelmotorer" ;
  watt_nn_1 = mkN "watt" "watten" "watt" "watten" ;
  wattsekund_nn_1 = mkN "wattsekund" "wattsekunder" ;
  watusi_nn_1 = mkN "watusi" "watusin" "watusi" "watusina" ;
  watussi_nn_1 = mkN "watussi" "watussin" "watussi" "watussina" ;
  weekend_nn_1 = mkN "weekend" "weekenden" "weekends" "weekendsen" ;
  western_nn_1 = mkN "western" "western" "western" "westerna" ;
  westernfilm_nn_1 = mkN "westernfilm" "westernfilmer" ;
  whig_nn_1 = mkN "whig" "whigen" "whigs" "whigsen" ;
  whippet_nn_1 = mkN "whippet" ;
  whiskysprucken_av_1 = mkA "whiskysprucken" "whiskysprucket" ;
  wienerbroed_nn_1 = mkN "wienerbrцd" neutrum ;
  wienerkorv_nn_1 = mkN "wienerkorv" ;
  wienerschnitzel_nn_1 = mkN "wienerschnitzel" ;
  wienervals_nn_1 = mkN "wienervals" "wienervalser" ;
  wigwam_nn_1 = mkN "wigwam" "wigwamer" ;
  wire_nn_1 = mkN "wire" utrum ;
  wobbler_nn_1 = mkN "wobbler" "wobblern" "wobbler" "wobblerna" ;
  worcestersaas_nn_1 = mkN "worcestersеs" "worcestersеser" ;
  x1800_talsmode_nn_1 = mkN "1800-talsmode" ;
  x60_aarsjubileum_nn_1 = mkN "60-еrsjubileum" "60-еrsjubileet" "60-еrsjubileer" "60-еrsjubileerna" ;
  x_axel_nn_1 = mkN "x-axel" ;
  x_koordinat_nn_1 = mkN "x-koordinat" "x-koordinater" ;
  x_kromosom_nn_1 = mkN "x-kromosom" "x-kromosomer" ;
  xylofon_nn_1 = mkN "xylofon" "xylofoner" ;
  xylografi_nn_1 = mkN "xylografi" "xylografier" ;
  y_axel_nn_1 = mkN "y-axel" ;
  y_koordinat_nn_1 = mkN "y-koordinat" "y-koordinater" ;
  y_kromosom_nn_1 = mkN "y-kromosom" "y-kromosomer" ;
  yacht_nn_1 = mkN "yacht" "yachter" ;
  yalelaas_nn_1 = mkN "yalelеs" neutrum ;
  yankee_nn_1 = mkN "yankee" "yankeen" "yankees" "yankeesen" ;
  yankeejib_nn_1 = mkN "yankeejib" "yankeejibben" "yankeejibbar" "yankeejibbarna" ;
  yard_nn_1 = mkN "yard" "yarden" "yard" "yarden" ;
  yawl_nn_1 = mkN "yawl" "yawler" ;
  yen_nn_1 = mkN "yen" "yenen" "yen" "yenen" ;
  yllen_av_1 = mkA "yllen" "yllet" ;
  ylletyg_nn_1 = mkN "ylletyg" neutrum ;
  yllevaevnad_nn_1 = mkN "yllevдvnad" "yllevдvnader" ;
  ymnig_av_1 = mkA "ymnig" ;
  ymnighetshorn_nn_1 = mkN "ymnighetshorn" neutrum ;
  ymp_nn_1 = mkN "ymp" ;
  ympkvist_nn_1 = mkN "ympkvist" ;
  ympning_nn_1 = mkN "ympning" ;
  ympsaar_nn_1 = mkN "ympsеr" neutrum ;
  ympsnitt_nn_1 = mkN "ympsnitt" neutrum ;
  ympstam_nn_1 = mkN "ympstam" "ympstammen" "ympstammar" "ympstammarna" ;
  ymptvaang_nn_1 = mkN "ymptvеng" neutrum ;
  yngel_nn_1 = mkN "yngel" neutrum ;
  yngelcell_nn_1 = mkN "yngelcell" "yngelceller" ;
  yngeldamm_nn_1 = mkN "yngeldamm" ;
  yngelstadium_nn_1 = mkN "yngelstadium" "yngelstadiet" "yngelstadier" "yngelstadierna" ;
  yngeltraag_nn_1 = mkN "yngeltrеg" neutrum ;
  yngling_nn_1 = mkN "yngling" ;
  ynglingasinne_nn_1 = mkN "ynglingasinne" ;
  ynka_av_1 = mkA "ynka" ;
  ynkansvaerd_av_1 = mkA "ynkansvдrd" "ynkansvдrt" ;
  ynkedom_nn_1 = mkN "ynkedom" ;
  ynklig_av_1 = mkA "ynklig" ;
  ynkrygg_nn_1 = mkN "ynkrygg" ;
  ynnestbetygelse_nn_1 = mkN "ynnestbetygelse" "ynnestbetygelser" ;
  yogi_nn_1 = mkN "yogi" "yogin" "yogier" "yogierna" ;
  ypperlig_av_1 = mkA "ypperlig" ;
  yppig_av_1 = mkA "yppig" ;
  yr_av_1 = mkA "yr" ;
  yrkande_nn_1 = mkN "yrkande" ;
  yrke_nn_1 = mkN "yrke" ;
  yrkesarbetande_av_1 = mkA "yrkesarbetande" ;
  yrkesarbetare_nn_1 = mkN "yrkesarbetare" "yrkesarbetare" ;
  yrkesarme_nn_1 = mkN "yrkesarmй" "yrkesarmйer" ;
  yrkesfoerbud_nn_1 = mkN "yrkesfцrbud" neutrum ;
  yrkesfysiker_nn_1 = mkN "yrkesfysiker" "yrkesfysikern" "yrkesfysiker" "yrkesfysikerna" ;
  yrkesgrupp_nn_1 = mkN "yrkesgrupp" "yrkesgrupper" ;
  yrkeshemlighet_nn_1 = mkN "yrkeshemlighet" "yrkeshemligheter" ;
  yrkesinspektion_nn_1 = mkN "yrkesinspektion" "yrkesinspektioner" ;
  yrkeskaar_nn_1 = mkN "yrkeskеr" "yrkeskеrer" ;
  yrkeskvinna_nn_1 = mkN "yrkeskvinna" ;
  yrkeslaerare_nn_1 = mkN "yrkeslдrare" "yrkeslдrare" ;
  yrkesmaessig_av_1 = mkA "yrkesmдssig" ;
  yrkesman_nn_1 = mkN "yrkesman" "yrkesmannen" "yrkesmдn" "yrkesmдnnen" ;
  yrkesorientering_nn_1 = mkN "yrkesorientering" ;
  yrkesregister_nn_1 = mkN "yrkesregister" neutrum ;
  yrkessjukdom_nn_1 = mkN "yrkessjukdom" ;
  yrkesskicklig_av_1 = mkA "yrkesskicklig" ;
  yrkestitel_nn_1 = mkN "yrkestitel" ;
  yrkesutbildning_nn_1 = mkN "yrkesutbildning" ;
  yrkesvaegledare_nn_1 = mkN "yrkesvдgledare" "yrkesvдgledare" ;
  yrkesvaegledning_nn_1 = mkN "yrkesvдgledning" ;
  yrkesval_nn_1 = mkN "yrkesval" neutrum ;
  yrvaeder_nn_1 = mkN "yrvдder" neutrum ;
  yrvaken_av_1 = mkA "yrvaken" "yrvaket" ;
  yster_av_1 = mkA "yster" "ystert" "ystra" "ystra" "ystrare" "ystrast" "ystraste" ;
  ytaktiv_av_1 = mkA "ytaktiv" ;
  ytavvaegning_nn_1 = mkN "ytavvдgning" ;
  ytbergart_nn_1 = mkN "ytbergart" "ytbergarter" ;
  yteffekt_nn_1 = mkN "yteffekt" "yteffekter" ;
  yteld_nn_1 = mkN "yteld" ;
  ytenhet_nn_1 = mkN "ytenhet" "ytenheter" ;
  ytform_nn_1 = mkN "ytform" ;
  ytlager_nn_1 = mkN "ytlager" neutrum ;
  ytledes_ab_1 = mkAdv "ytledes" ;
  ytlig_av_1 = mkA "ytlig" ;
  ytmaatt_nn_1 = mkN "ytmеtt" neutrum ;
  ytmoraen_nn_1 = mkN "ytmorдn" "ytmorдner" ;
  ytskikt_nn_1 = mkN "ytskikt" neutrum ;
  ytspaenning_nn_1 = mkN "ytspдnning" ;
  ytstruktur_nn_1 = mkN "ytstruktur" "ytstrukturer" ;
  ytter_nn_1 = mkN "ytter" ;
  ytterdel_nn_1 = mkN "ytterdel" "ytterdelen" "ytterdelar" "ytterdelarna" ;
  ytterdoerr_nn_1 = mkN "ytterdцrr" ;
  ytterfoder_nn_1 = mkN "ytterfoder" neutrum ;
  ytterkant_nn_1 = mkN "ytterkant" "ytterkanter" ;
  ytterlig_av_1 = mkA "ytterlig" ;
  ytterligare_av_1 = mkA "ytterligare" ;
  ytterlighet_nn_1 = mkN "ytterlighet" "ytterligheter" ;
  ytterlighetsriktning_nn_1 = mkN "ytterlighetsriktning" ;
  yttermarginal_nn_1 = mkN "yttermarginal" "yttermarginaler" ;
  ytteroera_nn_1 = mkN "ytterцra" "ytterцrat" "ytterцron" "ytterцronen" ;
  ytterplagg_nn_1 = mkN "ytterplagg" neutrum ;
  ytterrock_nn_1 = mkN "ytterrock" ;
  ytterskaer_nn_1 = mkN "ytterskдr" neutrum ;
  yttertak_nn_1 = mkN "yttertak" neutrum ;
  yttervaerld_nn_1 = mkN "yttervдrld" ;
  yttervinkel_nn_1 = mkN "yttervinkel" ;
  yttrande_nn_1 = mkN "yttrande" ;
  yttrandefrihet_nn_1 = mkN "yttrandefrihet" "yttrandefriheter" ;
  yttring_nn_1 = mkN "yttring" ;
  yttriumoxid_nn_1 = mkN "yttriumoxid" "yttriumoxider" ;
  yttryck_nn_1 = mkN "yttryck" neutrum ;
  ytvatten_nn_1 = mkN "ytvatten" "ytvattnet" "ytvatten" "ytvattnen" ;
  ytvattenskikt_nn_1 = mkN "ytvattenskikt" neutrum ;
  ytvidd_nn_1 = mkN "ytvidd" "ytvidder" ;
  yverboren_av_1 = mkA "yverboren" "yverboret" ;
  yvig_av_1 = mkA "yvig" ;
  yxaemne_nn_1 = mkN "yxдmne" ;
  yxblad_nn_1 = mkN "yxblad" neutrum ;
  yxhammare_nn_1 = mkN "yxhammare" "yxhammaren" "yxhamrar" "yxhamrarna" ;
  yxhuvud_nn_1 = mkN "yxhuvud" "yxhuvudet" "yxhuvuden" "yxhuvudena" ;
  yxskaft_nn_1 = mkN "yxskaft" neutrum ;
  zairier_nn_1 = mkN "zairier" "zairiern" "zairier" "zairierna" ;
  zairisk_av_1 = mkA "zairisk" ;
  zambier_nn_1 = mkN "zambier" "zambiern" "zambier" "zambierna" ;
  zambisk_av_1 = mkA "zambisk" ;
  zefyr_nn_1 = mkN "zefyr" "zefyrer" ;
  zelot_nn_1 = mkN "zelot" "zeloter" ;
  zenitdistans_nn_1 = mkN "zenitdistans" "zenitdistanser" ;
  zeugma_nn_1 = mkN "zeugma" "zeugmat" "zeugman" "zeugmana" ;
  zigenare_nn_1 = mkN "zigenare" "zigenare" ;
  zigenarkapell_nn_1 = mkN "zigenarkapell" neutrum ;
  zigenarliv_nn_1 = mkN "zigenarliv" neutrum ;
  zigenarspraak_nn_1 = mkN "zigenarsprеk" neutrum ;
  zigensk_av_1 = mkA "zigensk" ;
  zimbabwier_nn_1 = mkN "zimbabwier" "zimbabwiern" "zimbabwier" "zimbabwierna" ;
  zimbabwisk_av_1 = mkA "zimbabwisk" ;
  zinkmalm_nn_1 = mkN "zinkmalm" "zinkmalmer" ;
  zirkon_nn_1 = mkN "zirkon" "zirkoner" ;
  zirkoniumoxid_nn_1 = mkN "zirkoniumoxid" "zirkoniumoxider" ;
  zloty_nn_1 = mkN "zloty" "zlotyn" "zloty" "zlotyna" ;
  zombie_nn_1 = mkN "zombie" "zombien" "zombies" "zombiesen" ;
  zon_nn_1 = mkN "zon" "zoner" ;
  zonroer_nn_1 = mkN "zonrцr" neutrum ;
  zontariff_nn_1 = mkN "zontariff" "zontariffer" ;
  zoo_nn_1 = mkN "zoo" "zoot" "zoon" "zoona" ;
  zoolog_nn_1 = mkN "zoolog" "zoologer" ;
  zoologisk_av_1 = mkA "zoologisk" ;
  zoomobjektiv_nn_1 = mkN "zoomobjektiv" neutrum ;
  zulu_nn_1 = mkN "zulu" "zulun" "zuluer" "zuluerna" ;
  zygot_nn_1 = mkN "zygot" "zygoter" ;
}