-- This dictionary is derived from SALDO, see:
--
--   Borin, Lars, Markus Forsberg and Lennart Lönngren 2008.
--   The hunting of the BLARK - SALDO, a freely available lexical database for 
--   Swedish language technology. Resourceful language technology.
--   Festschrift in honor of Anna Sågvall Hein, ed. by Joakim Nivre, 
--   Mats Dahllöf and Beáta Megyesi. 
--   Acta Universitatis Upsaliensis: Studia Linguistica Upsaliensia 7. 21-32.
--   <http://spraakbanken.gu.se/personal/lars/pblctns/ash-fs-080605.pdf>
--
-- Imported in GF by Krasimir Angelov
--
-- This resource is distributed under the free software license LGPL 3.0 or 
-- Creative Commons Attribution-Share Alike 2.5 Generic. 

abstract DictSweAbs = Cat ** {

fun
  A_vitamin_nn_1 : N ;
  A_vitaminbrist_nn_1 : N ;
  Antarktisfoerdrag_nn_1 : N ;
  Antarktisprojekt_nn_1 : N ;
  Arianeraket_nn_1 : N ;
  B_vitamin_nn_1 : N ;
  B_vitaminbrist_nn_1 : N ;
  C_vitamin_nn_1 : N ;
  Celsius_ab_1 : Adv ;
  DNA_kedja_nn_1 : N ;
  DNA_molekyl_nn_1 : N ;
  DNA_uppsaettning_nn_1 : N ;
  Efta_land_nn_1 : N ;
  Gudi_ab_1 : Adv ;
  Hiroshimabomb_nn_1 : N ;
  ID_kort_nn_1 : N ;
  I_land_nn_1 : N ;
  Jantelag_nn_1 : N ;
  Jupitermaane_nn_1 : N ;
  Koechelnummer_nn_1 : N ;
  Kubakris_nn_1 : N ;
  LO_chef_nn_1 : N ;
  LO_ordfoerande_nn_1 : N ;
  Linkoepingsbo_nn_1 : N ;
  MAO_aktivitet_nn_1 : N ;
  MAO_enzym_nn_1 : N ;
  Medelhavsland_nn_1 : N ;
  Mosebok_nn_1 : N ;
  OECD_land_nn_1 : N ;
  PCB_foerbud_nn_1 : N ;
  PCB_foerening_nn_1 : N ;
  PCB_foergiftning_nn_1 : N ;
  PCB_halt_nn_1 : N ;
  PCB_olja_nn_1 : N ;
  PR_man_nn_1 : N ;
  Papyrusaktie_nn_1 : N ;
  SAP_program_nn_1 : N ;
  SAS_chef_nn_1 : N ;
  SCOPE_rapport_nn_1 : N ;
  Salazar_regim_nn_1 : N ;
  TV_antenn_nn_1 : N ;
  TV_apparat_nn_1 : N ;
  TV_bild_nn_1 : N ;
  TV_chef_nn_1 : N ;
  TV_kamera_nn_1 : N ;
  TV_kanal_nn_1 : N ;
  TV_konferens_nn_1 : N ;
  TV_mottagare_nn_1 : N ;
  TV_producent_nn_1 : N ;
  TV_program_nn_1 : N ;
  TV_reparatoer_nn_1 : N ;
  TV_saendning_nn_1 : N ;
  TV_serie_nn_1 : N ;
  TV_skaerm_nn_1 : N ;
  TV_studio_nn_1 : N ;
  TV_tittare_nn_1 : N ;
  Tjernobylnedfall_nn_1 : N ;
  U_land_nn_1 : N ;
  Vietnamkrig_nn_1 : N ;
  Z_partikel_nn_1 : N ;
  aa_nn_2 : N ;
  aabaekig_av_1 : A ;
  aabo_nn_1 : N ;
  aadaga_ab_1 : Adv ;
  aader_nn_1 : N ;
  aaderbraack_nn_1 : N ;
  aaderhinna_nn_1 : N ;
  aaderlaata_vb_1 : V ;
  aadra_nn_1 : N ;
  aadra_vb_1 : V ;
  aadrig_av_1 : A ;
  aadring_nn_1 : N ;
  aahoerardag_nn_1 : N ;
  aahoerare_nn_1 : N ;
  aahoerarplats_nn_1 : N ;
  aak_nn_1 : N ;
  aakare_nn_1 : N ;
  aakarkamp_nn_1 : N ;
  aakdon_nn_1 : N ;
  aaker_nn_1 : N ;
  aakeraert_nn_1 : N ;
  aakerbaer_nn_1 : N ;
  aakerbit_nn_1 : N ;
  aakerbruk_nn_1 : N ;
  aakerbrukare_nn_1 : N ;
  aakerfaelt_nn_1 : N ;
  aakerfraeken_nn_1 : N ;
  aakergaerde_nn_1 : N ;
  aakeri_nn_1 : N ;
  aakerjord_nn_1 : N ;
  aakerlapp_nn_1 : N ;
  aakermark_nn_1 : N ;
  aakerren_nn_1 : N ;
  aakersork_nn_1 : N ;
  aakerspergel_nn_1 : N ;
  aakerteg_nn_1 : N ;
  aakertistel_nn_1 : N ;
  aakervaext_nn_1 : N ;
  aakervall_nn_1 : N ;
  aaklagare_nn_1 : N ;
  aaklagarmyndighet_nn_1 : N ;
  aakning_nn_1 : N ;
  aakpaase_nn_1 : N ;
  aakroek_nn_1 : N ;
  aaksjuk_av_1 : A ;
  aaktur_nn_1 : N ;
  aal_nn_1 : N ;
  aalaendsk_av_1 : A ;
  aalaendska_nn_2 : N ;
  aalaenning_nn_1 : N ;
  aalandsrot_nn_1 : N ;
  aalder_nn_1 : N ;
  aalderdom_nn_1 : N ;
  aalderdomlig_av_1 : A ;
  aalderdomsfoersaekring_nn_1 : N ;
  aalderdomshem_nn_1 : N ;
  aalderdomspension_nn_1 : N ;
  aalderdomssvag_av_1 : A ;
  aalderman_nn_1 : N ;
  aaldersbestaemning_nn_1 : N ;
  aaldersbetyg_nn_1 : N ;
  aaldersfoeraendring_nn_1 : N ;
  aaldersfoerdelning_nn_1 : N ;
  aaldersgraens_nn_1 : N ;
  aaldersgrupp_nn_1 : N ;
  aaldersklass_nn_1 : N ;
  aalderslaangsynthet_nn_1 : N ;
  aalderspension_nn_1 : N ;
  aalderspresident_nn_1 : N ;
  aaldersskael_nn_1 : N ;
  aaldersskillnad_nn_1 : N ;
  aaldersspaerr_nn_1 : N ;
  aaldersstadium_nn_1 : N ;
  aaldersstruktur_nn_1 : N ;
  aalderssvag_av_1 : A ;
  aalderstecken_nn_1 : N ;
  aalderstigen_av_1 : A ;
  aalderstillaegg_nn_1 : N ;
  aalderstyngd_av_1 : A ;
  aaldfru_nn_1 : N ;
  aaldrig_av_1 : A ;
  aaldring_nn_1 : N ;
  aalfiskare_nn_1 : N ;
  aaliggande_nn_1 : N ;
  aalskinn_nn_1 : N ;
  aam_nn_1 : N ;
  aamig_av_1 : A ;
  aamning_nn_1 : N ;
  aamynning_nn_1 : N ;
  aangackumulator_nn_1 : N ;
  aanganlaeggning_nn_1 : N ;
  aangare_nn_1 : N ;
  aangbaat_nn_1 : N ;
  aangbageri_nn_1 : N ;
  aangblaester_nn_1 : N ;
  aangcentral_nn_1 : N ;
  aangdriven_av_1 : A ;
  aangerfull_av_1 : A ;
  aangerkoept_av_1 : A ;
  aangermanlaendsk_av_1 : A ;
  aangermanlaenning_nn_1 : N ;
  aangervecka_nn_1 : N ;
  aangestfull_av_1 : A ;
  aangestfylld_av_1 : A ;
  aangestneuros_nn_1 : N ;
  aangfartyg_nn_1 : N ;
  aanggenerator_nn_1 : N ;
  aangkoek_nn_1 : N ;
  aangkokare_nn_1 : N ;
  aangkol_nn_1 : N ;
  aangkraftverk_nn_1 : N ;
  aanglok_nn_1 : N ;
  aanglokomotiv_nn_1 : N ;
  aangmaskin_nn_1 : N ;
  aangning_nn_1 : N ;
  aangslup_nn_1 : N ;
  aangstroem_nn_1 : N ;
  aangstrykjaern_nn_1 : N ;
  aangtryck_nn_1 : N ;
  aangturbin_nn_1 : N ;
  aangvaelt_nn_1 : N ;
  aangvinsch_nn_1 : N ;
  aangvissla_nn_1 : N ;
  aanyo_ab_1 : Adv ;
  aapen_av_1 : A ;
  aar_nn_1 : N ;
  aarblad_nn_1 : N ;
  aarbraeckt_av_1 : A ;
  aarder_nn_1 : N ;
  aaretruntbostad_nn_1 : N ;
  aarfot_nn_1 : N ;
  aargaang_nn_1 : N ;
  aargaangsvin_nn_1 : N ;
  aaring_nn_1 : N ;
  aarlig_av_1 : A ;
  aarligen_ab_1 : Adv ;
  aarlom_nn_1 : N ;
  aarmiljon_nn_1 : N ;
  aarpinne_nn_1 : N ;
  aarsavgift_nn_1 : N ;
  aarsbaesta_av_1 : A ;
  aarsbarn_nn_1 : N ;
  aarsberaettelse_nn_1 : N ;
  aarsbok_nn_1 : N ;
  aarsbokstav_nn_1 : N ;
  aarscykel_nn_1 : N ;
  aarsdag_nn_1 : N ;
  aarsdos_nn_1 : N ;
  aarsinkomst_nn_1 : N ;
  aarsklass_nn_1 : N ;
  aarskull_nn_1 : N ;
  aarskurs_nn_1 : N ;
  aarsmedeltemperatur_nn_1 : N ;
  aarsmodell_nn_1 : N ;
  aarsmoete_nn_1 : N ;
  aarsredovisning_nn_1 : N ;
  aarsring_nn_1 : N ;
  aarstid_nn_1 : N ;
  aarstidsvind_nn_1 : N ;
  aarstryck_nn_1 : N ;
  aartag_nn_1 : N ;
  aartal_nn_1 : N ;
  aartionde_nn_1 : N ;
  aartull_nn_1 : N ;
  aartusende_nn_1 : N ;
  aas_nn_1 : N ;
  aasido_ab_1 : Adv ;
  aasikt_nn_1 : N ;
  aasiktsfoerfoeljelse_nn_1 : N ;
  aasiktsfrihet_nn_1 : N ;
  aasiktsmaessig_av_1 : A ;
  aasiktsriktning_nn_1 : N ;
  aasiktsutbyte_nn_1 : N ;
  aaskaadare_nn_1 : N ;
  aaskaadarlaektare_nn_1 : N ;
  aaskaadlig_av_1 : A ;
  aaskaadning_nn_1 : N ;
  aaskby_nn_1 : N ;
  aaskdiger_av_1 : A ;
  aaskfront_nn_1 : N ;
  aaskledare_nn_1 : N ;
  aaskmoln_nn_1 : N ;
  aaskregn_nn_1 : N ;
  aaskvaeder_nn_1 : N ;
  aasna_nn_1 : N ;
  aasnedrivare_nn_1 : N ;
  aasneskri_nn_1 : N ;
  aasnespark_nn_1 : N ;
  aasstaang_nn_1 : N ;
  aastad_ab_1 : Adv ;
  aastadkomma_vb_1 : V ;
  aat_ab_1 : Adv ;
  aata_vb_1 : V ;
  aatagande_nn_1 : N ;
  aatal_nn_1 : N ;
  aatboerd_nn_1 : N ;
  aatel_nn_1 : N ;
  aater_ab_1 : Adv ;
  aateranvaendning_nn_1 : N ;
  aaterbaering_nn_1 : N ;
  aaterbesoek_nn_1 : N ;
  aaterbetalning_nn_1 : N ;
  aaterblick_nn_1 : N ;
  aaterbud_nn_1 : N ;
  aaterfall_nn_1 : N ;
  aaterfalla_vb_1 : V ;
  aaterfinna_vb_1 : V ;
  aaterflyttning_nn_1 : N ;
  aaterfoederska_nn_1 : N ;
  aaterfoerening_nn_1 : N ;
  aaterfoersaekring_nn_1 : N ;
  aaterfoersaeljare_nn_1 : N ;
  aatergaa_vb_1 : V ;
  aaterge_vb_1 : V ;
  aatergivande_nn_1 : N ;
  aatergivning_nn_1 : N ;
  aaterhaalla_vb_1 : V ;
  aaterhaallsam_av_1 : A ;
  aaterigen_ab_1 : Adv ;
  aaterkallelse_nn_1 : N ;
  aaterknyta_vb_1 : V ;
  aaterkoep_nn_1 : N ;
  aaterkomma_vb_1 : V ;
  aaterkoppling_nn_1 : N ;
  aaterrop_nn_1 : N ;
  aatersamling_nn_1 : N ;
  aaterspegling_nn_1 : N ;
  aaterstaellare_nn_1 : N ;
  aaterstaellningstecken_nn_1 : N ;
  aaterstod_nn_1 : N ;
  aaterta_vb_1 : V ;
  aatertaag_nn_1 : N ;
  aatertjaenst_nn_1 : N ;
  aateruppstaandelse_nn_1 : N ;
  aateruppta_vb_1 : V ;
  aatervaendsgraend_nn_1 : N ;
  aaterval_nn_1 : N ;
  aaterverkning_nn_1 : N ;
  aatervinna_vb_1 : V ;
  aatgaa_vb_1 : V ;
  aatgaangen_av_1 : A ;
  aatgaerd_nn_1 : N ;
  aathutning_nn_1 : N ;
  aatkomlig_av_1 : A ;
  aatlyda_vb_1 : V ;
  aatlydnad_nn_1 : N ;
  aatminstone_ab_1 : Adv ;
  aatnjuta_vb_1 : V ;
  aatraavaerd_av_1 : A ;
  aatsida_nn_1 : N ;
  aatsittande_av_1 : A ;
  aatskillig_av_1 : A ;
  aatskillnad_nn_1 : N ;
  aatskils_ab_1 : Adv ;
  aatsmitande_av_1 : A ;
  aatstramning_nn_1 : N ;
  aattahoernig_av_1 : A ;
  aattatimmarsdag_nn_1 : N ;
  aattiondel_nn_1 : N ;
  aattiotalist_nn_1 : N ;
  aattitalism_nn_1 : N ;
  aattitalist_nn_1 : N ;
  aattondel_nn_1 : N ;
  abakus_nn_1 : N ;
  abbe_nn_1 : N ;
  abborre_nn_1 : N ;
  abborrfisk_nn_1 : N ;
  abborrpinne_nn_1 : N ;
  abbot_nn_1 : N ;
  abbreviation_nn_1 : N ;
  abbreviatur_nn_1 : N ;
  abc_bok_nn_1 : N ;
  abderitisk_av_1 : A ;
  abdikation_nn_1 : N ;
  abdomen_nn_1 : N ;
  aber_nn_1 : N ;
  aberration_nn_1 : N ;
  abessinier_nn_1 : N ;
  abessinsk_av_1 : A ;
  abilitet_nn_1 : N ;
  abiturient_nn_1 : N ;
  abiturientexamen_nn_1 : N ;
  ablation_nn_1 : N ;
  ablativ_nn_1 : N ;
  abnorm_av_1 : A ;
  abnormitet_nn_1 : N ;
  abolition_nn_1 : N ;
  abonnemang_nn_1 : N ;
  abonnent_nn_1 : N ;
  aboriginer_nn_1 : N ;
  abort_nn_1 : N ;
  abortiv_av_1 : A ;
  abortoer_nn_1 : N ;
  abrupt_av_1 : A ;
  abscess_nn_1 : N ;
  absens_nn_1 : N ;
  absid_nn_1 : N ;
  absint_nn_1 : N ;
  absolut_av_1 : A ;
  absolutbelopp_nn_1 : N ;
  absolutist_nn_1 : N ;
  absolutistisk_av_1 : A ;
  absorptionslinje_nn_1 : N ;
  abstrakt_av_1 : A ;
  abstrakt_nn_1 : N ;
  abstraktion_nn_1 : N ;
  abstrus_av_1 : A ;
  absurd_av_1 : A ;
  absurditet_nn_1 : N ;
  abundant_av_1 : A ;
  abyssal_av_1 : A ;
  acceleration_nn_1 : N ;
  accelerator_nn_1 : N ;
  acceleratormaskin_nn_1 : N ;
  acceleratorsystem_nn_1 : N ;
  accent_nn_1 : N ;
  accentfoerskjutning_nn_1 : N ;
  accenttecken_nn_1 : N ;
  accept_nn_1 : N ;
  acceptabel_av_1 : A ;
  acceptant_nn_1 : N ;
  accepterande_nn_1 : N ;
  acceptkredit_nn_1 : N ;
  access_nn_1 : N ;
  accession_nn_1 : N ;
  accessionskatalog_nn_1 : N ;
  accessoar_nn_1 : N ;
  accessorisk_av_1 : A ;
  accesstid_nn_1 : N ;
  accidens_nn_1 : N ;
  accidenstryck_nn_1 : N ;
  accidentell_av_1 : A ;
  accis_nn_1 : N ;
  acetaldehyd_nn_1 : N ;
  acetat_nn_1 : N ;
  aciditet_nn_1 : N ;
  ackja_nn_1 : N ;
  acklamation_nn_1 : N ;
  ackommodation_nn_1 : N ;
  ackommodationsvaexel_nn_1 : N ;
  ackompanjatoer_nn_1 : N ;
  ackompanjemang_nn_1 : N ;
  ackord_nn_1 : N ;
  ackordion_nn_1 : N ;
  ackordsloen_nn_1 : N ;
  ackordssaettning_nn_1 : N ;
  ackumulation_nn_1 : N ;
  ackumulator_nn_1 : N ;
  ackurat_ab_1 : Adv ;
  ackurat_av_1 : A ;
  ackusativ_nn_1 : N ;
  ackusativobjekt_nn_1 : N ;
  ackusatorisk_av_1 : A ;
  ackuschoer_nn_1 : N ;
  ackuschoerska_nn_1 : N ;
  ackvisition_nn_1 : N ;
  ackvisitoer_nn_1 : N ;
  actionfilm_nn_1 : N ;
  adagio_ab_1 : Adv ;
  adagio_nn_1 : N ;
  adaptation_nn_1 : N ;
  adapter_nn_1 : N ;
  adaption_nn_1 : N ;
  adaptiv_av_1 : A ;
  addend_nn_1 : N ;
  addenda_nn_1 : N ;
  addiktion_nn_1 : N ;
  additament_nn_1 : N ;
  addition_nn_1 : N ;
  additionstecken_nn_1 : N ;
  additiv_av_1 : A ;
  additiv_nn_1 : N ;
  adduktion_nn_1 : N ;
  adekvat_av_1 : A ;
  adelsaett_nn_1 : N ;
  adelsbrev_nn_1 : N ;
  adelsgods_nn_1 : N ;
  adelshem_nn_1 : N ;
  adelskalender_nn_1 : N ;
  adelsmaerke_nn_1 : N ;
  adelsman_nn_1 : N ;
  adelsprivilegium_nn_1 : N ;
  adenit_nn_1 : N ;
  adept_nn_1 : N ;
  adhesiv_av_1 : A ;
  adiabatisk_av_1 : A ;
  adiafora_nn_1 : N ;
  adjektiv_nn_1 : N ;
  adjektivattribut_nn_1 : N ;
  adjektivisk_av_1 : A ;
  adjoe_nn_1 : N ;
  adjunkt_nn_1 : N ;
  adjunktion_nn_1 : N ;
  adjunktur_nn_1 : N ;
  adjutant_nn_1 : N ;
  adlig_av_1 : A ;
  administration_nn_1 : N ;
  administrativ_av_1 : A ;
  administratoer_nn_1 : N ;
  admonition_nn_1 : N ;
  adonis_nn_1 : N ;
  adoptant_nn_1 : N ;
  adoption_nn_1 : N ;
  adoptiv_av_1 : A ;
  adoptivbarn_nn_1 : N ;
  adoptivfoeraelder_nn_1 : N ;
  adoratoer_nn_1 : N ;
  adrenalin_nn_1 : N ;
  adress_nn_1 : N ;
  adressat_nn_1 : N ;
  adresskort_nn_1 : N ;
  adresslapp_nn_1 : N ;
  adstringerande_av_1 : A ;
  adventist_nn_1 : N ;
  adventiv_av_1 : A ;
  adventsstake_nn_1 : N ;
  adverb_nn_1 : N ;
  adverbial_nn_1 : N ;
  adverbiell_av_1 : A ;
  advers_nn_1 : N ;
  adversativ_av_1 : A ;
  advokat_nn_1 : N ;
  advokatfiskal_nn_1 : N ;
  advokatorisk_av_1 : A ;
  advokatyr_nn_1 : N ;
  aeckel_nn_1 : N ;
  aecklig_av_1 : A ;
  aecklo_nn_1 : N ;
  aedel_av_1 : A ;
  aedelfasan_nn_1 : N ;
  aedelgas_nn_1 : N ;
  aedelgran_nn_1 : N ;
  aedelloevtraed_nn_1 : N ;
  aedelmetall_nn_1 : N ;
  aedelmodig_av_1 : A ;
  aedelost_nn_1 : N ;
  aedelpekoral_nn_1 : N ;
  aedelsmed_nn_1 : N ;
  aedelsten_nn_1 : N ;
  aedling_nn_1 : N ;
  aefsing_nn_1 : N ;
  aega_nn_1 : N ;
  aegande_nn_1 : N ;
  aegare_nn_1 : N ;
  aegarform_nn_1 : N ;
  aegg_nn_1 : N ;
  aeggcell_nn_1 : N ;
  aegghinna_nn_1 : N ;
  aeggklaeckningsmaskin_nn_1 : N ;
  aeggkokare_nn_1 : N ;
  aeggkokning_nn_1 : N ;
  aeggkopp_nn_1 : N ;
  aegglaeggningsroer_nn_1 : N ;
  aeggledare_nn_1 : N ;
  aeggledartratt_nn_1 : N ;
  aeggliknande_av_1 : A ;
  aegglossning_nn_1 : N ;
  aeggost_nn_1 : N ;
  aeggprickare_nn_1 : N ;
  aeggsaeck_nn_1 : N ;
  aeggsjuk_av_1 : A ;
  aeggskal_nn_1 : N ;
  aeggsked_nn_1 : N ;
  aeggsnodd_nn_1 : N ;
  aeggstanning_nn_1 : N ;
  aeggstav_nn_1 : N ;
  aeggstock_nn_1 : N ;
  aeggstocksinflammation_nn_1 : N ;
  aeggsvamp_nn_1 : N ;
  aeggtoddy_nn_1 : N ;
  aeggvaermare_nn_1 : N ;
  aeggviteaemne_nn_1 : N ;
  aeggviteprov_nn_1 : N ;
  aegiljett_nn_1 : N ;
  aegodel_nn_1 : N ;
  aegodelning_nn_1 : N ;
  aegotecken_nn_1 : N ;
  aegrett_nn_1 : N ;
  aegretthaeger_nn_1 : N ;
  aekta_av_1 : A ;
  aektamakekuvert_nn_1 : N ;
  aektenskap_nn_1 : N ;
  aektenskaplig_av_1 : A ;
  aektenskapsbetyg_nn_1 : N ;
  aektenskapsbrott_nn_1 : N ;
  aektenskapsbrytare_nn_1 : N ;
  aektenskapsbyraa_nn_1 : N ;
  aektenskapscertifikat_nn_1 : N ;
  aektenskapsfoerord_nn_1 : N ;
  aektenskapshinder_nn_1 : N ;
  aektenskapsloefte_nn_1 : N ;
  aektenskapsmaeklare_nn_1 : N ;
  aektenskapsskillnad_nn_1 : N ;
  aekthet_nn_1 : N ;
  aektsvensk_av_1 : A ;
  aelg_nn_1 : N ;
  aelgjaegare_nn_1 : N ;
  aelgjakt_nn_1 : N ;
  aelgstudsare_nn_1 : N ;
  aelling_nn_1 : N ;
  aelskare_nn_1 : N ;
  aelskarinna_nn_1 : N ;
  aelsklig_av_1 : A ;
  aelskling_nn_1 : N ;
  aelsklingsraett_nn_1 : N ;
  aelskogskrank_av_1 : A ;
  aelskvaerd_av_1 : A ;
  aelv_nn_1 : N ;
  aelvbaedd_nn_1 : N ;
  aelvbrink_nn_1 : N ;
  aelvdaling_nn_1 : N ;
  aelvkvarn_nn_1 : N ;
  aelvstrand_nn_1 : N ;
  aemabel_av_1 : A ;
  aembar_nn_1 : N ;
  aembetsaaliggande_nn_1 : N ;
  aembetsbrott_nn_1 : N ;
  aembetsexamen_nn_1 : N ;
  aembetsman_nn_1 : N ;
  aembetsmannaregering_nn_1 : N ;
  aembetsperiod_nn_1 : N ;
  aembetsskrud_nn_1 : N ;
  aembetstitel_nn_1 : N ;
  aembetsverk_nn_1 : N ;
  aemne_nn_1 : N ;
  aemnesblock_nn_1 : N ;
  aemnesfoeretraedare_nn_1 : N ;
  aemnesgrupp_nn_1 : N ;
  aemnesjaern_nn_1 : N ;
  aemneskombination_nn_1 : N ;
  aemneskonferens_nn_1 : N ;
  aemneslaerare_nn_1 : N ;
  aemnesnamn_nn_1 : N ;
  aemnesomraade_nn_1 : N ;
  aen_ab_1 : Adv ;
  aenda_ab_1 : Adv ;
  aenda_nn_1 : N ;
  aendaa_ab_1 : Adv ;
  aendamaal_nn_1 : N ;
  aendamaalsenlig_av_1 : A ;
  aendamaalsenlighet_nn_1 : N ;
  aendamaalsloes_av_1 : A ;
  aende_nn_1 : N ;
  aendelse_nn_1 : N ;
  aendlig_av_1 : A ;
  aendloes_av_1 : A ;
  aendmoraen_nn_1 : N ;
  aendock_ab_1 : Adv ;
  aendpunkt_nn_1 : N ;
  aendrim_nn_1 : N ;
  aendring_nn_1 : N ;
  aendstation_nn_1 : N ;
  aendtarm_nn_1 : N ;
  aeng_ljud_nn_1 : N ;
  aeng_nn_1 : N ;
  aengd_nn_1 : N ;
  aengel_nn_1 : N ;
  aenger_nn_1 : N ;
  aenglakoer_nn_1 : N ;
  aenglalik_av_1 : A ;
  aenglamakerska_nn_1 : N ;
  aengsknarr_nn_1 : N ;
  aengslig_av_1 : A ;
  aengsmark_nn_1 : N ;
  aengsvial_nn_1 : N ;
  aenkeaar_nn_1 : N ;
  aenkedok_nn_1 : N ;
  aenkedrottning_nn_1 : N ;
  aenkefru_nn_1 : N ;
  aenkeman_nn_1 : N ;
  aenkenaad_nn_1 : N ;
  aenkepension_nn_1 : N ;
  aenkestoet_nn_1 : N ;
  aenkling_nn_1 : N ;
  aennu_ab_1 : Adv ;
  aenterhake_nn_1 : N ;
  aenterpik_nn_1 : N ;
  aentligen_ab_1 : Adv ;
  aentring_nn_1 : N ;
  aentringsstrid_nn_1 : N ;
  aeppelkart_nn_1 : N ;
  aeppelpraektig_av_1 : A ;
  aeppelskrott_nn_1 : N ;
  aeppeltraed_nn_1 : N ;
  aeppelvecklare_nn_1 : N ;
  aepplekart_nn_1 : N ;
  aeppleliknande_av_1 : A ;
  aeppleskrott_nn_1 : N ;
  aeppletraed_nn_1 : N ;
  aerbar_av_1 : A ;
  aerebetygelse_nn_1 : N ;
  aerefoergaeten_av_1 : A ;
  aeregirig_av_1 : A ;
  aereloes_av_1 : A ;
  aerelysten_av_1 : A ;
  aerelystnad_nn_1 : N ;
  aereminne_nn_1 : N ;
  aerende_nn_1 : N ;
  aereport_nn_1 : N ;
  aereroerig_av_1 : A ;
  aeresak_nn_1 : N ;
  aerevarv_nn_1 : N ;
  aerevoerdig_av_1 : A ;
  aerftlig_av_1 : A ;
  aerftlighet_nn_1 : N ;
  aerftlighetsforskare_nn_1 : N ;
  aerftlighetslag_nn_1 : N ;
  aerggroen_av_1 : A ;
  aergig_av_1 : A ;
  aeril_nn_1 : N ;
  aerjkrok_nn_1 : N ;
  aerkeaengel_nn_1 : N ;
  aerkebiskop_nn_1 : N ;
  aerkefiende_nn_1 : N ;
  aerkehertig_nn_1 : N ;
  aerkenoet_nn_1 : N ;
  aerkestift_nn_1 : N ;
  aerlig_av_1 : A ;
  aerligen_ab_1 : Adv ;
  aerlighet_nn_1 : N ;
  aerm_nn_1 : N ;
  aermbraede_nn_1 : N ;
  aermhaal_nn_1 : N ;
  aermhaallare_nn_1 : N ;
  aermlinning_nn_1 : N ;
  aermloes_av_1 : A ;
  aerob_av_1 : A ;
  aerobisk_av_1 : A ;
  aerodrom_nn_1 : N ;
  aerodynamisk_av_1 : A ;
  aerofull_av_1 : A ;
  aerofylld_av_1 : A ;
  aerogram_nn_1 : N ;
  aeronaut_nn_1 : N ;
  aeroplan_nn_1 : N ;
  aerorik_av_1 : A ;
  aerosol_nn_1 : N ;
  aerr_nn_1 : N ;
  aerrbildning_nn_1 : N ;
  aerrig_av_1 : A ;
  aerrtatuering_nn_1 : N ;
  aert_nn_1 : N ;
  aerta_nn_1 : N ;
  aertig_av_1 : A ;
  aertvaext_nn_1 : N ;
  aertvecklare_nn_1 : N ;
  aeskande_nn_1 : N ;
  aesping_nn_1 : N ;
  aess_nn_1 : N ;
  aeta_vb_1 : V ;
  aetbar_av_1 : A ;
  aetlig_av_1 : A ;
  aetpinne_nn_1 : N ;
  aett_nn_1 : N ;
  aettartavla_nn_1 : N ;
  aettefader_nn_1 : N ;
  aettelaegg_nn_1 : N ;
  aetteled_nn_1 : N ;
  aettetal_nn_1 : N ;
  aettetavla_nn_1 : N ;
  aettiksinlaeggning_nn_1 : N ;
  aettlaengd_nn_1 : N ;
  aettled_nn_1 : N ;
  aettling_nn_1 : N ;
  aettnummer_nn_1 : N ;
  aeven_ab_1 : Adv ;
  aevenledes_ab_1 : Adv ;
  aevensaa_ab_1 : Adv ;
  aeventyr_nn_1 : N ;
  aeventyrare_nn_1 : N ;
  aeventyrlig_av_1 : A ;
  aeventyrsbok_nn_1 : N ;
  aeventyrsfilm_nn_1 : N ;
  aeventyrsroman_nn_1 : N ;
  aexing_nn_1 : N ;
  afasi_nn_1 : N ;
  afasisk_av_1 : A ;
  afatiker_nn_1 : N ;
  afatisk_av_1 : A ;
  afelium_nn_1 : N ;
  affaer_nn_1 : N ;
  affaersavtal_nn_1 : N ;
  affaersbank_nn_1 : N ;
  affaersbegaavning_nn_1 : N ;
  affaersbitraede_nn_1 : N ;
  affaersbrev_nn_1 : N ;
  affaerscentrum_nn_1 : N ;
  affaersdrivande_av_1 : A ;
  affaerskedja_nn_1 : N ;
  affaersliv_nn_1 : N ;
  affaersmaessig_av_1 : A ;
  affaersman_nn_1 : N ;
  affaerstid_nn_1 : N ;
  affaersverk_nn_1 : N ;
  affekt_nn_1 : N ;
  affektion_nn_1 : N ;
  affektionsvaerde_nn_1 : N ;
  affektiv_av_1 : A ;
  affidavit_nn_1 : N ;
  affin_av_1 : A ;
  affinage_nn_1 : N ;
  affinitet_nn_1 : N ;
  affirmativ_av_1 : A ;
  affisch_nn_1 : N ;
  affischering_nn_1 : N ;
  affischnamn_nn_1 : N ;
  affischoer_nn_1 : N ;
  affischpelare_nn_1 : N ;
  affix_nn_1 : N ;
  afghan_nn_1 : N ;
  afghansk_av_1 : A ;
  aforism_nn_1 : N ;
  aforistiker_nn_1 : N ;
  aforistisk_av_1 : A ;
  afrikan_nn_1 : N ;
  afrikansk_av_1 : A ;
  afro_asiatisk_av_1 : A ;
  afroamerikan_nn_1 : N ;
  afroasiatisk_av_1 : A ;
  afrodisiakum_nn_1 : N ;
  afrofrisyr_nn_1 : N ;
  afse_nn_1 : N ;
  afton_nn_1 : N ;
  aftonboen_nn_1 : N ;
  aftondraekt_nn_1 : N ;
  aftongudstjaenst_nn_1 : N ;
  aftonklaenning_nn_1 : N ;
  aftonrodnad_nn_1 : N ;
  aftonsaang_nn_1 : N ;
  aftonvard_nn_1 : N ;
  agat_nn_1 : N ;
  agave_nn_1 : N ;
  agent_nn_1 : N ;
  agentfilm_nn_1 : N ;
  agentur_nn_1 : N ;
  agerande_nn_1 : N ;
  aggande_av_1 : A ;
  agglomerat_nn_1 : N ;
  agglomeration_nn_1 : N ;
  agglutination_nn_1 : N ;
  aggregat_nn_1 : N ;
  aggregation_nn_1 : N ;
  aggregationstillstaand_nn_1 : N ;
  aggression_nn_1 : N ;
  aggressionshaemning_nn_1 : N ;
  aggressiv_av_1 : A ;
  aggressivitet_nn_1 : N ;
  agitation_nn_1 : N ;
  agitator_nn_1 : N ;
  agitatorisk_av_1 : A ;
  agn_nn_1 : N ;
  agnat_nn_1 : N ;
  agnatisk_av_1 : A ;
  agnblommig_av_1 : A ;
  agnborst_nn_1 : N ;
  agnosi_nn_1 : N ;
  agnostiker_nn_1 : N ;
  agnostisk_av_1 : A ;
  agoni_nn_1 : N ;
  agraff_nn_1 : N ;
  agrar_av_1 : A ;
  agrar_nn_1 : N ;
  agreabel_av_1 : A ;
  agremang_nn_1 : N ;
  agrikulturell_av_1 : A ;
  agronom_nn_1 : N ;
  agronomisk_av_1 : A ;
  aha_upplevelse_nn_1 : N ;
  air_nn_1 : N ;
  airdaleterrier_nn_1 : N ;
  akademi_nn_1 : N ;
  akademiker_nn_1 : N ;
  akademisk_av_1 : A ;
  akademist_nn_1 : N ;
  akant_nn_1 : N ;
  akantus_nn_1 : N ;
  akatalektisk_av_1 : A ;
  akilleshael_nn_1 : N ;
  akrobat_nn_1 : N ;
  akrobatisk_av_1 : A ;
  akromatisk_av_1 : A ;
  akromegali_nn_1 : N ;
  akronym_nn_1 : N ;
  akropol_nn_1 : N ;
  akrostikon_nn_1 : N ;
  akt_nn_1 : N ;
  akter_ab_1 : Adv ;
  akter_nn_1 : N ;
  akterdaeck_nn_1 : N ;
  akterdel_nn_1 : N ;
  akterlig_av_1 : A ;
  akterskepp_nn_1 : N ;
  akterspegel_nn_1 : N ;
  aktie_nn_1 : N ;
  aktieaegande_nn_1 : N ;
  aktieaegare_nn_1 : N ;
  aktieboers_nn_1 : N ;
  aktiebolag_nn_1 : N ;
  aktiebrev_nn_1 : N ;
  aktieemission_nn_1 : N ;
  aktiekapital_nn_1 : N ;
  aktiekupong_nn_1 : N ;
  aktiekurs_nn_1 : N ;
  aktiemajoritet_nn_1 : N ;
  aktieportfoelj_nn_1 : N ;
  aktiepost_nn_1 : N ;
  aktiesparklubb_nn_1 : N ;
  aktiestock_nn_1 : N ;
  aktieutdelning_nn_1 : N ;
  aktievinst_nn_1 : N ;
  aktion_nn_1 : N ;
  aktionsart_nn_1 : N ;
  aktionsgrupp_nn_1 : N ;
  aktionsradie_nn_1 : N ;
  aktionssaett_nn_1 : N ;
  aktionsstroem_nn_1 : N ;
  aktionsturbin_nn_1 : N ;
  aktiv_av_1 : A ;
  aktiva_nn_1 : N ;
  aktivist_nn_1 : N ;
  aktivitet_nn_1 : N ;
  aktivum_nn_1 : N ;
  aktningsfull_av_1 : A ;
  aktningsvaerd_av_1 : A ;
  aktoer_nn_1 : N ;
  aktor_nn_1 : N ;
  aktris_nn_1 : N ;
  aktsam_av_1 : A ;
  aktstycke_nn_1 : N ;
  aktualitet_nn_1 : N ;
  aktuarie_nn_1 : N ;
  aktuell_av_1 : A ;
  akustisk_av_1 : A ;
  akut_ab_1 : Adv ;
  akut_av_1 : A ;
  akut_nn_1 : N ;
  akutavdelning_nn_1 : N ;
  akutfall_nn_1 : N ;
  akutmottagning_nn_1 : N ;
  akvakultur_nn_1 : N ;
  akvamarin_nn_1 : N ;
  akvanaut_nn_1 : N ;
  akvaplaning_nn_1 : N ;
  akvarell_nn_1 : N ;
  akvarellfaerg_nn_1 : N ;
  akvarellist_nn_1 : N ;
  akvariefisk_nn_1 : N ;
  akvarium_nn_1 : N ;
  akvatint_nn_1 : N ;
  akvatisk_av_1 : A ;
  akvavit_nn_1 : N ;
  akvedukt_nn_1 : N ;
  al_nn_1 : N ;
  aladaab_nn_1 : N ;
  alagreck_nn_1 : N ;
  alan_nn_1 : N ;
  alanin_nn_1 : N ;
  alant_nn_1 : N ;
  alarm_nn_1 : N ;
  alarmerande_av_1 : A ;
  alban_nn_1 : N ;
  albansk_av_1 : A ;
  albanska_nn_2 : N ;
  albatross_nn_1 : N ;
  albigenser_nn_1 : N ;
  albino_nn_1 : N ;
  album_nn_1 : N ;
  albumin_nn_1 : N ;
  albyl_nn_1 : N ;
  aldehyd_nn_1 : N ;
  aldrig_ab_1 : Adv ;
  alemann_nn_1 : N ;
  alert_av_1 : A ;
  alexandrin_nn_1 : N ;
  alexandrinsk_av_1 : A ;
  alexi_nn_1 : N ;
  alf_nn_1 : N ;
  alfa_nn_1 : N ;
  alfaagel_nn_1 : N ;
  alfabet_nn_1 : N ;
  alfabetisk_av_1 : A ;
  alfametyltyrosin_nn_1 : N ;
  alfanumerisk_av_1 : A ;
  alfapartikel_nn_1 : N ;
  alfastraalning_nn_1 : N ;
  alfkors_nn_1 : N ;
  alfoerraedare_nn_1 : N ;
  alfons_nn_1 : N ;
  alfresko_ab_1 : Adv ;
  alg_nn_1 : N ;
  algebraisk_av_1 : A ;
  algerier_nn_1 : N ;
  algerisk_av_1 : A ;
  algolog_nn_1 : N ;
  algonk_nn_1 : N ;
  algoritm_nn_1 : N ;
  alias_ab_1 : Adv ;
  alibi_nn_1 : N ;
  alienation_nn_1 : N ;
  alifatisk_av_1 : A ;
  alimentaer_av_1 : A ;
  alkaisk_av_1 : A ;
  alkali_nn_1 : N ;
  alkalimetall_nn_1 : N ;
  alkalisk_av_1 : A ;
  alkaloid_nn_1 : N ;
  alkan_nn_1 : N ;
  alkanol_nn_1 : N ;
  alkekung_nn_1 : N ;
  alkemist_nn_1 : N ;
  alkfaagel_nn_1 : N ;
  alkohol_nn_1 : N ;
  alkoholhalt_nn_1 : N ;
  alkoholhaltig_av_1 : A ;
  alkoholisk_av_1 : A ;
  alkoholist_nn_1 : N ;
  alkoholistanstalt_nn_1 : N ;
  alkoholmissbrukare_nn_1 : N ;
  alkoholometer_nn_1 : N ;
  alkoholpsykos_nn_1 : N ;
  alkoholsvag_av_1 : A ;
  alkoholtest_nn_1 : N ;
  alkotest_nn_1 : N ;
  alkotte_nn_1 : N ;
  alkov_nn_1 : N ;
  alkyd_nn_1 : N ;
  alkyl_nn_1 : N ;
  alkyn_nn_1 : N ;
  allaetare_nn_1 : N ;
  allan_ab_1 : Adv ;
  allaredan_ab_1 : Adv ;
  allbekant_av_1 : A ;
  alldaglig_av_1 : A ;
  alldeles_ab_1 : Adv ;
  alle_nn_1 : N ;
  allegat_nn_1 : N ;
  allegori_nn_1 : N ;
  allegorisk_av_1 : A ;
  allegretto_ab_1 : Adv ;
  allegretto_nn_1 : N ;
  allegro_ab_1 : Adv ;
  allegro_nn_1 : N ;
  allehanda_av_1 : A ;
  allemansfond_nn_1 : N ;
  allena_av_1 : A ;
  allenaraadande_av_1 : A ;
  allenast_ab_1 : Adv ;
  allergen_av_1 : A ;
  allergen_nn_1 : N ;
  allergi_nn_1 : N ;
  allergiker_nn_1 : N ;
  allergisk_av_1 : A ;
  allergolog_nn_1 : N ;
  allestaedes_ab_1 : Adv ;
  allfarvaeg_nn_1 : N ;
  allhelgonadag_nn_1 : N ;
  allians_nn_1 : N ;
  alliansfri_av_1 : A ;
  alliansring_nn_1 : N ;
  alligator_nn_1 : N ;
  allitteration_nn_1 : N ;
  allkonstverk_nn_1 : N ;
  allmaen_av_1 : A ;
  allmaenbegaavning_nn_1 : N ;
  allmaenbegrepp_nn_1 : N ;
  allmaenfarlig_av_1 : A ;
  allmaengiltig_av_1 : A ;
  allmaengiltighet_nn_1 : N ;
  allmaenhet_nn_1 : N ;
  allmaenmaensklig_av_1 : A ;
  allmaennelig_av_1 : A ;
  allmaenning_nn_1 : N ;
  allmaennyttig_av_1 : A ;
  allmaenpolitisk_av_1 : A ;
  allmaenpraktiker_nn_1 : N ;
  allmaenpraktiserande_av_1 : A ;
  allmaenpreventiv_av_1 : A ;
  allmogeblaa_av_1 : A ;
  allmogedraekt_nn_1 : N ;
  allmogekultur_nn_1 : N ;
  allmogevaevnad_nn_1 : N ;
  allod_nn_1 : N ;
  allodial_av_1 : A ;
  allodium_nn_1 : N ;
  allofon_nn_1 : N ;
  allograf_nn_1 : N ;
  allokton_av_1 : A ;
  allokution_nn_1 : N ;
  allomfattande_av_1 : A ;
  allomorf_av_1 : A ;
  allomorf_nn_1 : N ;
  allongeperuk_nn_1 : N ;
  allra_ab_1 : Adv ;
  allraheligaste_av_1 : A ;
  allriskfoersaekring_nn_1 : N ;
  allround_av_1 : A ;
  allrum_nn_1 : N ;
  alls_ab_1 : Adv ;
  allsaang_nn_1 : N ;
  allseende_av_1 : A ;
  allshaerjarting_nn_1 : N ;
  allsidig_av_1 : A ;
  allskoens_av_1 : A ;
  allsmaektig_av_1 : A ;
  allstroemsapparat_nn_1 : N ;
  allsvaaldig_av_1 : A ;
  allsvensk_av_1 : A ;
  allt_ab_1 : Adv ;
  alltemellanaat_ab_1 : Adv ;
  alltfoer_ab_1 : Adv ;
  alltfort_ab_1 : Adv ;
  alltiallo_nn_1 : N ;
  alltid_ab_1 : Adv ;
  alltigenom_ab_1 : Adv ;
  allting_nn_1 : N ;
  alltjaemt_ab_1 : Adv ;
  alltmer_ab_1 : Adv ;
  alltmera_ab_1 : Adv ;
  alltnog_ab_1 : Adv ;
  alltomfattande_av_1 : A ;
  alltsaa_ab_1 : Adv ;
  alltsomoftast_ab_1 : Adv ;
  allusion_nn_1 : N ;
  alluvial_av_1 : A ;
  alluvium_nn_1 : N ;
  allvaedersstoevel_nn_1 : N ;
  allvarlig_av_1 : A ;
  allvarligen_ab_1 : Adv ;
  allvarsam_av_1 : A ;
  allvarsord_nn_1 : N ;
  allvarstyngd_av_1 : A ;
  allvetande_av_1 : A ;
  allvetare_nn_1 : N ;
  allvis_av_1 : A ;
  alm_nn_1 : N ;
  almanacksblad_nn_1 : N ;
  aln_nn_1 : N ;
  aloe_nn_1 : N ;
  alp_nn_1 : N ;
  alpari_ab_1 : Adv ;
  alpget_nn_1 : N ;
  alpin_av_1 : A ;
  alpinist_nn_1 : N ;
  alpinsk_av_1 : A ;
  alpjaegare_nn_1 : N ;
  alpviol_nn_1 : N ;
  alster_nn_1 : N ;
  alstring_nn_1 : N ;
  alt_nn_1 : N ;
  altan_nn_1 : N ;
  altarbrun_nn_1 : N ;
  altare_nn_1 : N ;
  altargaang_nn_1 : N ;
  altarprydnad_nn_1 : N ;
  altarring_nn_1 : N ;
  altarrund_nn_1 : N ;
  altarskaap_nn_1 : N ;
  altartavla_nn_1 : N ;
  altartjaenst_nn_1 : N ;
  alteration_nn_1 : N ;
  alternativ_av_1 : A ;
  alternativ_nn_1 : N ;
  alternativfraaga_nn_1 : N ;
  alternativkurs_nn_1 : N ;
  alternatvinkel_nn_1 : N ;
  altfiol_nn_1 : N ;
  altitud_nn_1 : N ;
  altruist_nn_1 : N ;
  altruistisk_av_1 : A ;
  altstaemma_nn_1 : N ;
  altviolin_nn_1 : N ;
  aluminiumjon_nn_1 : N ;
  aluminiumpulver_nn_1 : N ;
  alumn_nn_1 : N ;
  alunskiffer_nn_1 : N ;
  alv_nn_2 : N ;
  alvarsmark_nn_1 : N ;
  alveol_nn_1 : N ;
  alveolar_av_1 : A ;
  alveolar_nn_1 : N ;
  alvplog_nn_1 : N ;
  amalgam_nn_1 : N ;
  amanuens_nn_1 : N ;
  amarant_nn_1 : N ;
  amaryllis_nn_1 : N ;
  amason_nn_1 : N ;
  amatoer_nn_1 : N ;
  amatoerbestaemmelse_nn_1 : N ;
  amatoerforskare_nn_1 : N ;
  amatoeridrott_nn_1 : N ;
  amatoermaessig_av_1 : A ;
  amatoerregel_nn_1 : N ;
  amatoersaendare_nn_1 : N ;
  amatoerteleskop_nn_1 : N ;
  ambassad_nn_1 : N ;
  ambassadoer_nn_1 : N ;
  ambassadraad_nn_1 : N ;
  ambiguitet_nn_1 : N ;
  ambitioes_av_1 : A ;
  ambition_nn_1 : N ;
  ambitionssak_nn_1 : N ;
  ambivalent_av_1 : A ;
  ambrosisk_av_1 : A ;
  ambulans_nn_1 : N ;
  ambulatorisk_av_1 : A ;
  amendemang_nn_1 : N ;
  amerikan_nn_1 : N ;
  amerikanare_nn_1 : N ;
  amerikanism_nn_1 : N ;
  amerikansk_av_1 : A ;
  amerikanska_nn_2 : N ;
  ametist_nn_1 : N ;
  amfetamin_nn_1 : N ;
  amfibie_nn_1 : N ;
  amfibisk_av_1 : A ;
  amfibolit_nn_1 : N ;
  amfiteater_nn_1 : N ;
  amfiteatralisk_av_1 : A ;
  ami_nn_1 : N ;
  amid_nn_1 : N ;
  amin_nn_1 : N ;
  amiral_nn_1 : N ;
  amiralsperson_nn_1 : N ;
  ammonit_nn_1 : N ;
  ammoniumnitrat_nn_1 : N ;
  ammoniumnitratloesning_nn_1 : N ;
  amnesi_nn_1 : N ;
  amnesti_nn_1 : N ;
  amoralisk_av_1 : A ;
  amoralitet_nn_1 : N ;
  amorbaage_nn_1 : N ;
  amorf_av_1 : A ;
  amorfism_nn_1 : N ;
  amorin_nn_1 : N ;
  amoroes_av_1 : A ;
  amortering_nn_1 : N ;
  amorteringsfri_av_1 : A ;
  amorteringsplan_nn_1 : N ;
  ampel_av_1 : A ;
  ampel_nn_1 : N ;
  amper_av_1 : A ;
  ampere_nn_1 : N ;
  amperemeter_nn_1 : N ;
  amperesekund_nn_1 : N ;
  amperevarv_nn_1 : N ;
  amplitud_nn_1 : N ;
  amplitudmodulering_nn_1 : N ;
  ampull_nn_1 : N ;
  amputation_nn_1 : N ;
  amsaga_nn_1 : N ;
  amt_nn_1 : N ;
  amulett_nn_1 : N ;
  amylas_nn_1 : N ;
  amyotrofi_nn_1 : N ;
  an_ab_1 : Adv ;
  anabaptist_nn_1 : N ;
  anabatisk_av_1 : A ;
  anabol_nn_1 : N ;
  anaerob_av_1 : A ;
  anafor_nn_1 : N ;
  anaforisk_av_1 : A ;
  anagram_nn_1 : N ;
  anakolut_nn_1 : N ;
  anakoret_nn_1 : N ;
  anakreontisk_av_1 : A ;
  anakronism_nn_1 : N ;
  anal_av_1 : A ;
  analfabet_nn_1 : N ;
  analgetika_nn_1 : N ;
  analoeppning_nn_1 : N ;
  analog_av_1 : A ;
  analogi_nn_1 : N ;
  analogibevis_nn_1 : N ;
  analogibildning_nn_1 : N ;
  analogisk_av_1 : A ;
  analogislut_nn_1 : N ;
  analys_nn_1 : N ;
  analytiker_nn_1 : N ;
  analytisk_av_1 : A ;
  anamnes_nn_1 : N ;
  ananas_nn_1 : N ;
  anapest_nn_1 : N ;
  anarkisk_av_1 : A ;
  anarkist_nn_1 : N ;
  anarkistisk_av_1 : A ;
  anastas_nn_1 : N ;
  anastatisk_av_1 : A ;
  anastigmatisk_av_1 : A ;
  anatema_nn_1 : N ;
  anatom_nn_1 : N ;
  anatomisk_av_1 : A ;
  anblick_nn_1 : N ;
  anbrott_nn_1 : N ;
  anbud_nn_1 : N ;
  anciennitet_nn_1 : N ;
  and_nn_1 : N ;
  andaektig_av_1 : A ;
  andakt_nn_1 : N ;
  andaktsbok_nn_1 : N ;
  andaktsfull_av_1 : A ;
  andante_ab_1 : Adv ;
  andante_nn_1 : N ;
  ande_nn_1 : N ;
  andebesvaerjare_nn_1 : N ;
  andebesvaerjelse_nn_1 : N ;
  andedrag_nn_1 : N ;
  andefattig_av_1 : A ;
  andefattigdom_nn_1 : N ;
  andel_nn_1 : N ;
  andelsfoerening_nn_1 : N ;
  andemening_nn_1 : N ;
  andeskaadare_nn_1 : N ;
  andetag_nn_1 : N ;
  andevaesen_nn_1 : N ;
  andfaadd_av_1 : A ;
  andfaagel_nn_1 : N ;
  andlig_av_1 : A ;
  andligen_ab_1 : Adv ;
  andloes_av_1 : A ;
  andning_nn_1 : N ;
  andningsapparat_nn_1 : N ;
  andningsenzym_nn_1 : N ;
  andningshaal_nn_1 : N ;
  andningsorgan_nn_1 : N ;
  andningspaus_nn_1 : N ;
  andningsreaktion_nn_1 : N ;
  andningsroer_nn_1 : N ;
  andorran_nn_1 : N ;
  andorransk_av_1 : A ;
  andra_vb_1 : V ;
  andrabas_nn_1 : N ;
  andrabil_nn_1 : N ;
  andrag_nn_1 : N ;
  andragradsekvation_nn_1 : N ;
  andrahandsbutik_nn_1 : N ;
  andrahandsvaerde_nn_1 : N ;
  andrake_nn_1 : N ;
  andraklassbiljett_nn_1 : N ;
  andranamn_nn_1 : N ;
  andraplacering_nn_1 : N ;
  andraplats_nn_1 : N ;
  andratenor_nn_1 : N ;
  andratidning_nn_1 : N ;
  andreaskors_nn_1 : N ;
  andrebas_nn_1 : N ;
  andretenor_nn_1 : N ;
  androgyn_av_1 : A ;
  androgyn_nn_1 : N ;
  andryg_av_1 : A ;
  andstraeck_nn_1 : N ;
  andtaeppt_av_1 : A ;
  andtruten_av_1 : A ;
  andur_nn_1 : N ;
  anekdot_nn_1 : N ;
  anekdotisk_av_1 : A ;
  anemi_nn_1 : N ;
  anemisk_av_1 : A ;
  anemometer_nn_1 : N ;
  anemon_nn_1 : N ;
  aneroidbarometer_nn_1 : N ;
  anestesi_nn_1 : N ;
  anestesiolog_nn_1 : N ;
  anestetika_nn_1 : N ;
  anestetisk_av_1 : A ;
  anfader_nn_1 : N ;
  anfaektelse_nn_1 : N ;
  anfall_nn_1 : N ;
  anfalla_vb_1 : V ;
  anfallare_nn_1 : N ;
  anfallsbas_nn_1 : N ;
  anfallsfront_nn_1 : N ;
  anfallskrig_nn_1 : N ;
  anfallslinje_nn_1 : N ;
  anfallsspel_nn_1 : N ;
  anfallsspelare_nn_1 : N ;
  anfallsvinkel_nn_1 : N ;
  anfang_nn_1 : N ;
  anfart_nn_1 : N ;
  anflog_nn_1 : N ;
  anflygning_nn_1 : N ;
  anfoerande_nn_1 : N ;
  anfoerare_nn_1 : N ;
  anfoering_nn_1 : N ;
  anfoeringstecken_nn_1 : N ;
  anfoeringsverb_nn_1 : N ;
  anfoervant_nn_1 : N ;
  ange_vb_1 : V ;
  angel_nn_1 : N ;
  angelaegen_av_1 : A ;
  angelaegenhet_nn_1 : N ;
  angelsachsare_nn_1 : N ;
  angelsaxare_nn_1 : N ;
  angenaem_av_1 : A ;
  angiosperm_nn_1 : N ;
  angivare_nn_1 : N ;
  angivelse_nn_1 : N ;
  angivelsebrott_nn_1 : N ;
  angiveri_nn_1 : N ;
  anglaes_nn_1 : N ;
  anglicism_nn_1 : N ;
  anglikansk_av_1 : A ;
  anglist_nn_1 : N ;
  anglosaxare_nn_1 : N ;
  anglosaxisk_av_1 : A ;
  angolan_nn_1 : N ;
  angolansk_av_1 : A ;
  angoraget_nn_1 : N ;
  angorakatt_nn_1 : N ;
  angraensande_av_1 : A ;
  angrepp_nn_1 : N ;
  angreppspunkt_nn_1 : N ;
  angreppssaett_nn_1 : N ;
  angripa_vb_1 : V ;
  angripare_nn_1 : N ;
  anhaalla_vb_1 : V ;
  anhaallan_nn_1 : N ;
  anhaallande_nn_1 : N ;
  anhaengare_nn_1 : N ;
  anhaengig_av_1 : A ;
  anhalt_nn_1 : N ;
  anhang_nn_1 : N ;
  anhoerig_av_1 : A ;
  anhopning_nn_1 : N ;
  anilinfaerg_nn_1 : N ;
  animal_av_1 : A ;
  animalisk_av_1 : A ;
  animatoer_nn_1 : N ;
  animistisk_av_1 : A ;
  animositet_nn_1 : N ;
  aning_nn_1 : N ;
  aningsloes_av_1 : A ;
  anisett_nn_1 : N ;
  anjon_nn_1 : N ;
  ankarboj_nn_1 : N ;
  ankare_nn_1 : N ;
  ankarfly_nn_1 : N ;
  ankargrund_nn_1 : N ;
  ankarkabel_nn_1 : N ;
  ankarkaetting_nn_1 : N ;
  ankarlindning_nn_1 : N ;
  ankarspel_nn_1 : N ;
  ankarstock_nn_1 : N ;
  ankbonde_nn_1 : N ;
  ankdamm_nn_1 : N ;
  ankel_nn_1 : N ;
  ankellaang_av_1 : A ;
  anklagelse_nn_1 : N ;
  anklagelseakt_nn_1 : N ;
  anklagelsepunkt_nn_1 : N ;
  anklang_nn_1 : N ;
  anknyta_vb_1 : V ;
  anknytning_nn_1 : N ;
  ankomma_vb_1 : V ;
  ankommen_av_1 : A ;
  ankomst_nn_1 : N ;
  ankring_nn_1 : N ;
  ankunge_nn_1 : N ;
  anlaeggare_nn_1 : N ;
  anlaeggning_nn_1 : N ;
  anlaeggningsarbetare_nn_1 : N ;
  anlaeggningskostnad_nn_1 : N ;
  anlaeggningsplats_nn_1 : N ;
  anlaeggningstillgaang_nn_1 : N ;
  anlag_nn_1 : N ;
  anlagsbaerare_nn_1 : N ;
  anlagstest_nn_1 : N ;
  anledning_nn_1 : N ;
  anletsdrag_nn_1 : N ;
  anlopp_nn_1 : N ;
  anloppshamn_nn_1 : N ;
  anlupen_av_1 : A ;
  anmaelan_nn_2 : N ;
  anmaelare_nn_1 : N ;
  anmaelning_nn_1 : N ;
  anmaelningstid_nn_1 : N ;
  anmaerkning_nn_1 : N ;
  anmaerkningsvaerd_av_1 : A ;
  anmodande_nn_1 : N ;
  anmoder_nn_1 : N ;
  annalist_nn_1 : N ;
  annalkande_av_1 : A ;
  annandag_nn_1 : N ;
  annanstans_ab_1 : Adv ;
  annars_ab_1 : Adv ;
  annektion_nn_1 : N ;
  annex_nn_1 : N ;
  annexfoersamling_nn_1 : N ;
  annexion_nn_1 : N ;
  annihilation_nn_1 : N ;
  annons_nn_1 : N ;
  annonsbyraa_nn_1 : N ;
  annonskampanj_nn_1 : N ;
  annonsoer_nn_1 : N ;
  annonspelare_nn_1 : N ;
  annonsplats_nn_1 : N ;
  annonssvar_nn_1 : N ;
  annorlunda_ab_1 : Adv ;
  annorlunda_av_1 : A ;
  annorstaedes_ab_1 : Adv ;
  annotation_nn_1 : N ;
  annuell_av_1 : A ;
  annuitet_nn_1 : N ;
  annuitetslaan_nn_1 : N ;
  anod_nn_1 : N ;
  anomali_nn_1 : N ;
  anomi_nn_1 : N ;
  anonym_av_1 : A ;
  anonymitet_nn_1 : N ;
  anorak_nn_1 : N ;
  anordning_nn_1 : N ;
  anorexi_nn_1 : N ;
  anormal_av_1 : A ;
  anpassbar_av_1 : A ;
  anpasslig_av_1 : A ;
  anpassling_nn_1 : N ;
  anpassning_nn_1 : N ;
  anpassningsgrupp_nn_1 : N ;
  anpassningsklinik_nn_1 : N ;
  anraettning_nn_1 : N ;
  anrik_av_1 : A ;
  anrikning_nn_1 : N ;
  anrop_nn_1 : N ;
  ansaettningsskruv_nn_1 : N ;
  ansamling_nn_1 : N ;
  ansats_nn_1 : N ;
  ansedd_av_1 : A ;
  ansenlig_av_1 : A ;
  ansiktsbjudning_nn_1 : N ;
  ansiktsdrag_nn_1 : N ;
  ansiktsfaerg_nn_1 : N ;
  ansiktskraem_nn_1 : N ;
  ansiktslyftning_nn_1 : N ;
  ansiktsmask_nn_1 : N ;
  ansiktsmuskel_nn_1 : N ;
  ansiktsnerv_nn_1 : N ;
  ansiktsskydd_nn_1 : N ;
  ansiktsuttryck_nn_1 : N ;
  ansjovis_nn_1 : N ;
  anskaffning_nn_1 : N ;
  anskraemlig_av_1 : A ;
  anskri_nn_1 : N ;
  anskriven_av_1 : A ;
  anslaaende_av_1 : A ;
  anslag_nn_1 : N ;
  anslagsaeskande_nn_1 : N ;
  anslagsbeviljande_av_1 : A ;
  anslagsframstaellning_nn_1 : N ;
  anslagstavla_nn_1 : N ;
  ansluta_vb_1 : V ;
  anslutning_nn_1 : N ;
  ansoekning_nn_1 : N ;
  ansoekningshandling_nn_1 : N ;
  ansoekningstid_nn_1 : N ;
  anspaend_av_1 : A ;
  anspann_nn_1 : N ;
  anspelning_nn_1 : N ;
  anspraak_nn_1 : N ;
  anspraaksfull_av_1 : A ;
  anspraaksloes_av_1 : A ;
  anspraaksloeshet_nn_1 : N ;
  anstaand_nn_1 : N ;
  anstaellning_nn_1 : N ;
  anstaellningsavtal_nn_1 : N ;
  anstaellningsskydd_nn_1 : N ;
  anstaendig_av_1 : A ;
  anstaendighet_nn_1 : N ;
  anstaendigtvis_ab_1 : Adv ;
  anstalt_nn_1 : N ;
  anstiftare_nn_1 : N ;
  anstoetlig_av_1 : A ;
  anstormning_nn_1 : N ;
  anstraengande_av_1 : A ;
  anstraengd_av_1 : A ;
  anstraengning_nn_1 : N ;
  anstruken_av_1 : A ;
  anstryka_vb_1 : V ;
  anstrykare_nn_1 : N ;
  anstrykning_nn_1 : N ;
  anstucken_av_1 : A ;
  ansvaelld_av_1 : A ;
  ansvaellning_nn_1 : N ;
  ansvarig_av_1 : A ;
  ansvarighetsfoersaekring_nn_1 : N ;
  ansvaring_nn_1 : N ;
  ansvarsfoersaekring_nn_1 : N ;
  ansvarsfrihet_nn_1 : N ;
  ansvarsfull_av_1 : A ;
  ansvarskaennande_av_1 : A ;
  ansvarsloes_av_1 : A ;
  ansvarsnaemnd_nn_1 : N ;
  anta_vb_1 : V ;
  antaag_nn_1 : N ;
  antaendning_nn_1 : N ;
  antagande_nn_1 : N ;
  antaglig_av_1 : A ;
  antagligen_ab_1 : Adv ;
  antagning_nn_1 : N ;
  antagonist_nn_1 : N ;
  antagonistisk_av_1 : A ;
  antal_nn_1 : N ;
  antarktisk_av_1 : A ;
  antecedentia_nn_1 : N ;
  antecipation_nn_1 : N ;
  antecipativ_av_1 : A ;
  anteckning_nn_1 : N ;
  anteckningsblock_nn_1 : N ;
  anteckningsbok_nn_1 : N ;
  antediluviansk_av_1 : A ;
  antenn_nn_1 : N ;
  antependium_nn_1 : N ;
  antepenultima_nn_1 : N ;
  antibarbarus_nn_1 : N ;
  antibiotika_nn_1 : N ;
  antibiotikum_nn_1 : N ;
  antibiotisk_av_1 : A ;
  anticyklon_nn_1 : N ;
  antidepressiv_av_1 : A ;
  antidot_nn_1 : N ;
  antifoni_nn_1 : N ;
  antigen_nn_1 : N ;
  antihistamin_nn_1 : N ;
  antihjaelte_nn_1 : N ;
  antiintellektuell_av_1 : A ;
  antik_av_1 : A ;
  antiklerikal_av_1 : A ;
  antiklimax_nn_1 : N ;
  antiklinal_nn_1 : N ;
  antikljus_nn_1 : N ;
  antikonceptionell_av_1 : A ;
  antikropp_nn_1 : N ;
  antikvariat_nn_1 : N ;
  antikvarie_nn_1 : N ;
  antikvarisk_av_1 : A ;
  antikvitet_nn_1 : N ;
  antilop_nn_1 : N ;
  antimakass_nn_1 : N ;
  antimilitarist_nn_1 : N ;
  antimilitaristisk_av_1 : A ;
  antingen_ab_1 : Adv ;
  antinomi_nn_1 : N ;
  antipartikel_nn_1 : N ;
  antipassad_nn_1 : N ;
  antipati_nn_1 : N ;
  antipod_nn_1 : N ;
  antisemit_nn_1 : N ;
  antisemitisk_av_1 : A ;
  antiseptika_nn_1 : N ;
  antiseptisk_av_1 : A ;
  antisionistisk_av_1 : A ;
  antistatisk_av_1 : A ;
  antistatmedel_nn_1 : N ;
  antites_nn_1 : N ;
  antitetisk_av_1 : A ;
  antitoxin_nn_1 : N ;
  antologi_nn_1 : N ;
  antonym_nn_1 : N ;
  antraeffbar_av_1 : A ;
  antropisk_av_1 : A ;
  antropocentrisk_av_1 : A ;
  antropofag_nn_1 : N ;
  antropoid_nn_1 : N ;
  antropolog_nn_1 : N ;
  antropomorf_av_1 : A ;
  antroposof_nn_1 : N ;
  antroposofisk_av_1 : A ;
  antydning_nn_1 : N ;
  antydningsvis_ab_1 : Adv ;
  anvaendande_nn_1 : N ;
  anvaendare_nn_1 : N ;
  anvaendbar_av_1 : A ;
  anvaendbarhet_nn_1 : N ;
  anvaendning_nn_1 : N ;
  anvaendningsomraade_nn_1 : N ;
  anvisning_nn_1 : N ;
  anvisningslaekare_nn_1 : N ;
  aorist_nn_1 : N ;
  apache_nn_1 : N ;
  apanage_nn_1 : N ;
  apart_av_1 : A ;
  apart_nn_1 : N ;
  apati_nn_1 : N ;
  apatisk_av_1 : A ;
  apbroedstraed_nn_1 : N ;
  apekatt_nn_1 : N ;
  apel_nn_1 : N ;
  apelgraa_av_1 : A ;
  apelsin_nn_1 : N ;
  aperitif_nn_1 : N ;
  apertur_nn_1 : N ;
  apetidin_nn_1 : N ;
  aphelium_nn_1 : N ;
  apmaenniska_nn_1 : N ;
  apodiktisk_av_1 : A ;
  apokalyps_nn_1 : N ;
  apokalyptisk_av_1 : A ;
  apokryfisk_av_1 : A ;
  apollinisk_av_1 : A ;
  apollofjaeril_nn_1 : N ;
  apologet_nn_1 : N ;
  apologetisk_av_1 : A ;
  apologi_nn_1 : N ;
  apoplektisk_av_1 : A ;
  apoplexi_nn_1 : N ;
  apostel_nn_1 : N ;
  aposteriorisk_av_1 : A ;
  apostolisk_av_1 : A ;
  apostrof_nn_1 : N ;
  apotek_nn_1 : N ;
  apotekare_nn_1 : N ;
  apoteksvaext_nn_1 : N ;
  apoteos_nn_1 : N ;
  apparans_nn_1 : N ;
  apparat_nn_1 : N ;
  apparatur_nn_1 : N ;
  apparition_nn_1 : N ;
  appell_nn_1 : N ;
  appellant_nn_1 : N ;
  appellationsdomstol_nn_1 : N ;
  appellativ_nn_1 : N ;
  appendicit_nn_1 : N ;
  appendix_nn_1 : N ;
  apperception_nn_1 : N ;
  applaad_nn_1 : N ;
  applikation_nn_1 : N ;
  applikatorisk_av_1 : A ;
  applikatur_nn_1 : N ;
  apposition_nn_1 : N ;
  appreciering_nn_1 : N ;
  appretyr_nn_1 : N ;
  approach_nn_1 : N ;
  approbabel_av_1 : A ;
  approbatur_nn_1 : N ;
  approximation_nn_1 : N ;
  approximationsteori_nn_1 : N ;
  approximativ_av_1 : A ;
  aprikos_nn_1 : N ;
  aprildag_nn_1 : N ;
  aprilskaemt_nn_1 : N ;
  apriorisk_av_1 : A ;
  apropaa_ab_1 : Adv ;
  apropaa_nn_1 : N ;
  apsort_nn_1 : N ;
  apspel_nn_1 : N ;
  aptitlig_av_1 : A ;
  aptitloeshet_nn_1 : N ;
  aptitretande_av_1 : A ;
  aptitretare_nn_1 : N ;
  ar_nn_1 : N ;
  arab_nn_1 : N ;
  arabesk_nn_1 : N ;
  arabisk_av_1 : A ;
  arabiska_nn_2 : N ;
  arabist_nn_1 : N ;
  arbetare_nn_1 : N ;
  arbetarfoerening_nn_1 : N ;
  arbetargrupp_nn_1 : N ;
  arbetarklass_nn_1 : N ;
  arbetarkommun_nn_1 : N ;
  arbetarparti_nn_1 : N ;
  arbetarraad_nn_1 : N ;
  arbetarregering_nn_1 : N ;
  arbetarroerelse_nn_1 : N ;
  arbetarsaang_nn_1 : N ;
  arbetsaar_nn_1 : N ;
  arbetsam_av_1 : A ;
  arbetsanstalt_nn_1 : N ;
  arbetsavtal_nn_1 : N ;
  arbetsbeskrivning_nn_1 : N ;
  arbetsbesparande_av_1 : A ;
  arbetsbi_nn_1 : N ;
  arbetsboerda_nn_1 : N ;
  arbetsbok_nn_1 : N ;
  arbetsbord_nn_1 : N ;
  arbetsbyte_nn_1 : N ;
  arbetsdag_nn_1 : N ;
  arbetsdelning_nn_1 : N ;
  arbetsdomstol_nn_1 : N ;
  arbetsduglig_av_1 : A ;
  arbetsfaelt_nn_1 : N ;
  arbetsfoer_av_1 : A ;
  arbetsfoermedling_nn_1 : N ;
  arbetsfoertjaenst_nn_1 : N ;
  arbetsform_nn_1 : N ;
  arbetsfri_av_1 : A ;
  arbetsgivaravgift_nn_1 : N ;
  arbetsgivare_nn_1 : N ;
  arbetsgivarfoerening_nn_1 : N ;
  arbetsgivarintraede_nn_1 : N ;
  arbetsgrupp_nn_1 : N ;
  arbetshypotes_nn_1 : N ;
  arbetsinkomst_nn_1 : N ;
  arbetsinsats_nn_1 : N ;
  arbetsinstaellelse_nn_1 : N ;
  arbetsintensiv_av_1 : A ;
  arbetskamrat_nn_1 : N ;
  arbetskoepare_nn_1 : N ;
  arbetskonflikt_nn_1 : N ;
  arbetslaeger_nn_1 : N ;
  arbetsledare_nn_1 : N ;
  arbetslivserfarenhet_nn_1 : N ;
  arbetsloes_av_1 : A ;
  arbetsloeshet_nn_1 : N ;
  arbetsmaengd_nn_1 : N ;
  arbetsmaetning_nn_1 : N ;
  arbetsmarknad_nn_1 : N ;
  arbetsmarknadspolitik_nn_1 : N ;
  arbetsmarknadspolitisk_av_1 : A ;
  arbetsmarknadsutbildning_nn_1 : N ;
  arbetsmaskin_nn_1 : N ;
  arbetsmaterial_nn_1 : N ;
  arbetsmiljoe_nn_1 : N ;
  arbetsmoment_nn_1 : N ;
  arbetsmoral_nn_1 : N ;
  arbetsnaemnd_nn_1 : N ;
  arbetsnamn_nn_1 : N ;
  arbetsnarkoman_nn_1 : N ;
  arbetsnedlaeggelse_nn_1 : N ;
  arbetsomraade_nn_1 : N ;
  arbetsordning_nn_1 : N ;
  arbetspass_nn_1 : N ;
  arbetsplats_nn_1 : N ;
  arbetsplenum_nn_1 : N ;
  arbetsprov_nn_1 : N ;
  arbetsredskap_nn_1 : N ;
  arbetsrum_nn_1 : N ;
  arbetssaang_nn_1 : N ;
  arbetssaett_nn_1 : N ;
  arbetsseger_nn_1 : N ;
  arbetsskygg_av_1 : A ;
  arbetssoekande_nn_1 : N ;
  arbetsstudieman_nn_1 : N ;
  arbetstagare_nn_1 : N ;
  arbetstemperatur_nn_1 : N ;
  arbetsterapeut_nn_1 : N ;
  arbetstid_nn_1 : N ;
  arbetstillfaelle_nn_1 : N ;
  arbetstillstaand_nn_1 : N ;
  arbetstvist_nn_1 : N ;
  arbetsuppgift_nn_1 : N ;
  arbetsutskott_nn_1 : N ;
  arbetsvaerdering_nn_1 : N ;
  arbetsvecka_nn_1 : N ;
  arbetsvilja_nn_1 : N ;
  arbetsvillig_av_1 : A ;
  arbitraer_av_1 : A ;
  arboretum_nn_1 : N ;
  arborr_nn_1 : N ;
  ardenner_nn_1 : N ;
  areal_nn_1 : N ;
  arena_nn_1 : N ;
  arenateater_nn_1 : N ;
  areometer_nn_1 : N ;
  areopag_nn_1 : N ;
  arg_av_1 : A ;
  argentinare_nn_1 : N ;
  argentinsk_av_1 : A ;
  argentinska_nn_1 : N ;
  argsint_av_1 : A ;
  argument_nn_1 : N ;
  argumentation_nn_1 : N ;
  argumentering_nn_1 : N ;
  argusoega_nn_1 : N ;
  ariadnetraad_nn_1 : N ;
  arian_nn_1 : N ;
  ariansk_av_1 : A ;
  arier_nn_1 : N ;
  arioso_nn_1 : N ;
  arisk_av_1 : A ;
  aristokrat_nn_1 : N ;
  aristokrati_nn_1 : N ;
  aristokratisk_av_1 : A ;
  aritmetisk_av_1 : A ;
  ark_nn_1 : N ;
  arkad_nn_1 : N ;
  arkadisk_av_1 : A ;
  arkadspel_nn_1 : N ;
  arkaisk_av_1 : A ;
  arkaism_nn_1 : N ;
  arkaistisk_av_1 : A ;
  arkebusering_nn_1 : N ;
  arkeolog_nn_1 : N ;
  arkeologisk_av_1 : A ;
  arketyp_nn_1 : N ;
  arketypisk_av_1 : A ;
  arkiater_nn_1 : N ;
  arkipelag_nn_1 : N ;
  arkitekt_nn_1 : N ;
  arkitektonisk_av_1 : A ;
  arkitektur_nn_1 : N ;
  arkitrav_nn_1 : N ;
  arkiv_nn_1 : N ;
  arkivalisk_av_1 : A ;
  arkivarbetare_nn_1 : N ;
  arkivarie_nn_1 : N ;
  arkivexemplar_nn_1 : N ;
  arksignatur_nn_1 : N ;
  arktisk_av_1 : A ;
  arla_ab_1 : Adv ;
  arm_av_1 : A ;
  arm_nn_1 : N ;
  armatur_nn_1 : N ;
  armbaage_nn_1 : N ;
  armbaagsben_nn_1 : N ;
  armbaagsled_nn_1 : N ;
  armband_nn_1 : N ;
  armbandsur_nn_1 : N ;
  armbindel_nn_1 : N ;
  armboejning_nn_1 : N ;
  armborst_nn_1 : N ;
  armborstpil_nn_1 : N ;
  armbrott_nn_1 : N ;
  armbrytning_nn_1 : N ;
  arme_nn_1 : N ;
  armechef_nn_1 : N ;
  armefoerband_nn_1 : N ;
  armegevaer_nn_1 : N ;
  armehaest_nn_1 : N ;
  armekaar_nn_1 : N ;
  armenier_nn_1 : N ;
  armenisk_av_1 : A ;
  armeniska_nn_2 : N ;
  armering_nn_1 : N ;
  armeringsjaern_nn_1 : N ;
  armfoering_nn_1 : N ;
  armfoting_nn_1 : N ;
  armhaevning_nn_1 : N ;
  armkrok_nn_1 : N ;
  armlaengd_nn_1 : N ;
  armled_nn_1 : N ;
  armmuskel_nn_1 : N ;
  armpolyp_nn_1 : N ;
  armstoed_nn_1 : N ;
  armstyrka_nn_1 : N ;
  armveck_nn_1 : N ;
  arom_nn_1 : N ;
  aromatisk_av_1 : A ;
  aromglas_nn_1 : N ;
  arpeggio_nn_1 : N ;
  arr_nn_1 : N ;
  arrangemang_nn_1 : N ;
  arrangoer_nn_1 : N ;
  arrendator_nn_1 : N ;
  arrende_nn_1 : N ;
  arrest_nn_1 : N ;
  arrestant_nn_1 : N ;
  arrestering_nn_1 : N ;
  arriaergarde_nn_1 : N ;
  arrivist_nn_1 : N ;
  arrogant_av_1 : A ;
  arrowrot_nn_1 : N ;
  arsel_nn_1 : N ;
  arsenal_nn_1 : N ;
  arsenikhalt_nn_1 : N ;
  arsenikhaltig_av_1 : A ;
  arsenikkis_nn_1 : N ;
  art_nn_1 : N ;
  artaer_nn_1 : N ;
  artbildning_nn_1 : N ;
  artbildningsteori_nn_1 : N ;
  artefakt_nn_1 : N ;
  artegen_av_1 : A ;
  arteriell_av_1 : A ;
  artesisk_av_1 : A ;
  artfraemmande_av_1 : A ;
  artificiell_av_1 : A ;
  artig_av_1 : A ;
  artighet_nn_1 : N ;
  artighetsbetygelse_nn_1 : N ;
  artighetsfras_nn_1 : N ;
  artighetsvisit_nn_1 : N ;
  artikel_nn_1 : N ;
  artikelfoerfattare_nn_1 : N ;
  artikelserie_nn_1 : N ;
  artikulation_nn_1 : N ;
  artikulationsbas_nn_1 : N ;
  artikulationsstaelle_nn_1 : N ;
  artilleribeskjutning_nn_1 : N ;
  artillerield_nn_1 : N ;
  artillerigranat_nn_1 : N ;
  artilleripjaes_nn_1 : N ;
  artillerist_nn_1 : N ;
  artillerivapen_nn_1 : N ;
  artist_nn_1 : N ;
  artistframtraedande_nn_1 : N ;
  artistisk_av_1 : A ;
  artistnamn_nn_1 : N ;
  artnamn_nn_1 : N ;
  artotek_nn_1 : N ;
  artrik_av_1 : A ;
  artrit_nn_1 : N ;
  artros_nn_1 : N ;
  artskild_av_1 : A ;
  artskillnad_nn_1 : N ;
  arv_nn_1 : N ;
  arvedel_nn_1 : N ;
  arvfiende_nn_1 : N ;
  arvfoeljd_nn_1 : N ;
  arvfurste_nn_1 : N ;
  arvinge_nn_1 : N ;
  arvlaatare_nn_1 : N ;
  arvloes_av_1 : A ;
  arvode_nn_1 : N ;
  arvord_nn_1 : N ;
  arvsanlag_nn_1 : N ;
  arvsfaktor_nn_1 : N ;
  arvsfoeljd_nn_1 : N ;
  arvsfond_nn_1 : N ;
  arvskatt_nn_1 : N ;
  arvskifte_nn_1 : N ;
  arvslott_nn_1 : N ;
  arvsmolekyl_nn_1 : N ;
  arvsraett_nn_1 : N ;
  arvsskatt_nn_1 : N ;
  arvsynd_nn_1 : N ;
  arvtagare_nn_1 : N ;
  arvtant_nn_1 : N ;
  arytmi_nn_1 : N ;
  as_nn_1 : N ;
  as_nn_2 : N ;
  asaetare_nn_1 : N ;
  asbagge_nn_1 : N ;
  aseptisk_av_1 : A ;
  asexuell_av_1 : A ;
  asfalt_nn_1 : N ;
  asfaltemulsion_nn_1 : N ;
  asfaltlack_nn_1 : N ;
  asfaltmoped_nn_1 : N ;
  asgam_nn_1 : N ;
  asiat_nn_1 : N ;
  asiatisk_av_1 : A ;
  asimut_nn_1 : N ;
  ask_nn_1 : N ;
  askblond_av_1 : A ;
  askenas_nn_1 : N ;
  asket_nn_1 : N ;
  asketisk_av_1 : A ;
  askfat_nn_1 : N ;
  askgraa_av_1 : A ;
  askkopp_nn_1 : N ;
  askonsdag_nn_1 : N ;
  askunge_nn_1 : N ;
  asocial_av_1 : A ;
  asocialitet_nn_1 : N ;
  asp_nn_1 : N ;
  aspdunge_nn_1 : N ;
  aspekt_nn_1 : N ;
  aspirant_nn_1 : N ;
  aspiration_nn_1 : N ;
  aspirin_nn_1 : N ;
  asploev_nn_1 : N ;
  ass_nn_1 : N ;
  assegaj_nn_1 : N ;
  assessor_nn_1 : N ;
  assiett_nn_1 : N ;
  assignant_nn_1 : N ;
  assignation_nn_1 : N ;
  assimilation_nn_1 : N ;
  assist_nn_1 : N ;
  assistans_nn_1 : N ;
  assistent_nn_1 : N ;
  association_nn_1 : N ;
  associationskedja_nn_1 : N ;
  associationslexikon_nn_1 : N ;
  associativ_av_1 : A ;
  assonans_nn_1 : N ;
  assuradoer_nn_1 : N ;
  assurans_nn_1 : N ;
  assyrier_nn_1 : N ;
  assyrisk_av_1 : A ;
  asteni_nn_1 : N ;
  asteniker_nn_1 : N ;
  astenisk_av_1 : A ;
  aster_nn_1 : N ;
  asterisk_nn_1 : N ;
  asteroid_nn_1 : N ;
  astigmatiker_nn_1 : N ;
  astigmatisk_av_1 : A ;
  astmatiker_nn_1 : N ;
  astmatisk_av_1 : A ;
  astrakan_nn_1 : N ;
  astrakan_nn_2 : N ;
  astral_av_1 : A ;
  astralkropp_nn_1 : N ;
  astrofysiker_nn_1 : N ;
  astrolog_nn_1 : N ;
  astronaut_nn_1 : N ;
  astronautik_nn_1 : N ;
  astronom_nn_1 : N ;
  astronomisk_av_1 : A ;
  asyl_nn_1 : N ;
  asymmetri_nn_1 : N ;
  asymmetrisk_av_1 : A ;
  asymptot_nn_1 : N ;
  asyndes_nn_1 : N ;
  asyndetisk_av_1 : A ;
  asyndeton_nn_1 : N ;
  asynja_nn_1 : N ;
  asynkron_av_1 : A ;
  ataktisk_av_1 : A ;
  ataraktika_nn_1 : N ;
  atavism_nn_1 : N ;
  atavistisk_av_1 : A ;
  ataxi_nn_1 : N ;
  ateist_nn_1 : N ;
  ateistisk_av_1 : A ;
  atelje_nn_1 : N ;
  ateljefoenster_nn_1 : N ;
  atenienn_nn_1 : N ;
  atlantisk_av_1 : A ;
  atlas_nn_1 : N ;
  atlasbindning_nn_1 : N ;
  atlasspinnare_nn_1 : N ;
  atlet_nn_1 : N ;
  atletisk_av_1 : A ;
  atmosfaer_nn_1 : N ;
  atmosfaerforskare_nn_1 : N ;
  atmosfaerisk_av_1 : A ;
  atmosfaerkemist_nn_1 : N ;
  atmosfaerstryck_nn_1 : N ;
  atoll_nn_1 : N ;
  atom_nn_1 : N ;
  atomaer_av_1 : A ;
  atombomb_nn_1 : N ;
  atomdriven_av_1 : A ;
  atomenergiorganisation_nn_1 : N ;
  atomgrupp_nn_1 : N ;
  atomistisk_av_1 : A ;
  atomjon_nn_1 : N ;
  atommodell_nn_1 : N ;
  atomnummer_nn_1 : N ;
  atomreaktor_nn_1 : N ;
  atomspektrum_nn_1 : N ;
  atomubaat_nn_1 : N ;
  atomur_nn_1 : N ;
  atomvapen_nn_1 : N ;
  atomvikt_nn_1 : N ;
  atomvinter_nn_1 : N ;
  atonal_av_1 : A ;
  atoni_nn_1 : N ;
  atrium_nn_1 : N ;
  atrofi_nn_1 : N ;
  atrofisk_av_1 : A ;
  att_sats_nn_1 : N ;
  attache_nn_1 : N ;
  attack_nn_1 : N ;
  attackdykare_nn_1 : N ;
  attackplan_nn_1 : N ;
  attentat_nn_1 : N ;
  attentator_nn_1 : N ;
  attentatsman_nn_1 : N ;
  attest_nn_1 : N ;
  attiralj_nn_1 : N ;
  attisk_av_1 : A ;
  attityd_nn_1 : N ;
  attitydundersoekning_nn_1 : N ;
  attraktion_nn_1 : N ;
  attraktiv_av_1 : A ;
  attrapp_nn_1 : N ;
  attribut_nn_1 : N ;
  attribution_nn_1 : N ;
  attributiv_av_1 : A ;
  atypi_nn_1 : N ;
  atypisk_av_1 : A ;
  aubergine_nn_1 : N ;
  audiens_nn_1 : N ;
  audiogram_nn_1 : N ;
  audiometer_nn_1 : N ;
  audiovisuell_av_1 : A ;
  auditiv_av_1 : A ;
  auditoer_nn_1 : N ;
  auditorium_nn_1 : N ;
  audivisuell_av_1 : A ;
  augiasstall_nn_1 : N ;
  augment_nn_1 : N ;
  augur_nn_1 : N ;
  augustipaeron_nn_1 : N ;
  auktion_nn_1 : N ;
  auktionist_nn_1 : N ;
  auktionsfoerraettare_nn_1 : N ;
  auktionskammare_nn_1 : N ;
  auktionsutropare_nn_1 : N ;
  auktionsverk_nn_1 : N ;
  auktor_nn_1 : N ;
  auktorisation_nn_1 : N ;
  auktoritaer_av_1 : A ;
  auktoritativ_av_1 : A ;
  auktoritet_nn_1 : N ;
  auktoritetsbunden_av_1 : A ;
  auskultant_nn_1 : N ;
  auskultation_nn_1 : N ;
  australiensare_nn_1 : N ;
  australier_nn_1 : N ;
  australisk_av_1 : A ;
  autarki_nn_1 : N ;
  autencitet_nn_1 : N ;
  autenticitet_nn_1 : N ;
  autentisk_av_1 : A ;
  auteur_nn_1 : N ;
  autistisk_av_1 : A ;
  autodafe_nn_1 : N ;
  autodidakt_nn_1 : N ;
  autodrom_nn_1 : N ;
  autograf_nn_1 : N ;
  autoklav_nn_1 : N ;
  autokrat_nn_1 : N ;
  autokton_av_1 : A ;
  automat_nn_1 : N ;
  automatgevaer_nn_1 : N ;
  automatisk_av_1 : A ;
  automatkarbin_nn_1 : N ;
  automatvapen_nn_1 : N ;
  automobil_nn_1 : N ;
  autonom_av_1 : A ;
  autopilot_nn_1 : N ;
  autopsi_nn_1 : N ;
  autotypi_nn_1 : N ;
  av_ab_1 : Adv ;
  avaeta_vb_1 : V ;
  avancemang_nn_1 : N ;
  avannons_nn_1 : N ;
  avans_nn_1 : N ;
  avantgardist_nn_1 : N ;
  avantgardistisk_av_1 : A ;
  avantloge_nn_1 : N ;
  avantscen_nn_1 : N ;
  avart_nn_1 : N ;
  avbaerning_nn_1 : N ;
  avbalkning_nn_1 : N ;
  avbasning_nn_1 : N ;
  avbetalning_nn_1 : N ;
  avbetingning_nn_1 : N ;
  avbild_nn_1 : N ;
  avbildning_nn_1 : N ;
  avbildningsfel_nn_1 : N ;
  avbitare_nn_1 : N ;
  avbitartaang_nn_1 : N ;
  avblaasning_nn_1 : N ;
  avboejning_nn_1 : N ;
  avboen_nn_1 : N ;
  avbraeck_nn_1 : N ;
  avbraenning_nn_1 : N ;
  avbroestning_nn_1 : N ;
  avbrott_nn_1 : N ;
  avbryta_vb_1 : V ;
  avbrytare_nn_1 : N ;
  avbytare_nn_1 : N ;
  avdagata_vb_1 : V ;
  avdelning_nn_1 : N ;
  avdelningschef_nn_1 : N ;
  avdelningsdirektoer_nn_1 : N ;
  avdelningsskoeterska_nn_1 : N ;
  avdoed_av_1 : A ;
  avdrag_nn_1 : N ;
  avdragsgill_av_1 : A ;
  avdragsmoejlighet_nn_1 : N ;
  avdriva_vb_1 : V ;
  avdunstning_nn_1 : N ;
  ave_nn_1 : N ;
  avec_nn_1 : N ;
  avelsdjur_nn_1 : N ;
  avelshingst_nn_1 : N ;
  avenbok_nn_1 : N ;
  aveny_nn_1 : N ;
  avers_nn_1 : N ;
  aversion_nn_1 : N ;
  avfaellig_av_1 : A ;
  avfaelling_nn_1 : N ;
  avfaerd_nn_1 : N ;
  avfall_nn_1 : N ;
  avfalla_vb_1 : V ;
  avfallen_av_1 : A ;
  avfallskvarn_nn_1 : N ;
  avfallsupplag_nn_1 : N ;
  avfart_nn_1 : N ;
  avfattning_nn_1 : N ;
  avfloede_nn_1 : N ;
  avflyttningsfoerbud_nn_1 : N ;
  avfoering_nn_1 : N ;
  avfoeringsmedel_nn_1 : N ;
  avfrostning_nn_1 : N ;
  avgaa_vb_1 : V ;
  avgaang_nn_1 : N ;
  avgaangsbetyg_nn_1 : N ;
  avgaangsbidrag_nn_1 : N ;
  avgaangsklass_nn_1 : N ;
  avgaeld_nn_1 : N ;
  avgasroer_nn_1 : N ;
  avge_vb_1 : V ;
  avgift_nn_1 : N ;
  avgjord_av_1 : A ;
  avgjutning_nn_1 : N ;
  avgoerande_av_1 : A ;
  avgoerande_nn_1 : N ;
  avgrund_nn_1 : N ;
  avgrundsande_nn_1 : N ;
  avgrundsdjup_av_1 : A ;
  avgud_nn_1 : N ;
  avgudabild_nn_1 : N ;
  avhaall_nn_1 : N ;
  avhaalla_vb_1 : V ;
  avhaallen_av_1 : A ;
  avhaallsam_av_1 : A ;
  avhaengd_av_1 : A ;
  avhaengig_av_1 : A ;
  avhandling_nn_1 : N ;
  avhopp_nn_1 : N ;
  avhoppare_nn_1 : N ;
  avhyvling_nn_1 : N ;
  avi_nn_1 : N ;
  aviarium_nn_1 : N ;
  aviatisk_av_1 : A ;
  aviatoer_nn_1 : N ;
  avig_av_1 : A ;
  avigsida_nn_1 : N ;
  avisering_nn_1 : N ;
  aviseringsperiod_nn_1 : N ;
  avisofartyg_nn_1 : N ;
  avista_ab_1 : Adv ;
  avitaminos_nn_1 : N ;
  avkaennare_nn_1 : N ;
  avklaedning_nn_1 : N ;
  avklappning_nn_1 : N ;
  avkoerningsramp_nn_1 : N ;
  avkok_nn_1 : N ;
  avkomling_nn_1 : N ;
  avkoppling_nn_1 : N ;
  avkortning_nn_1 : N ;
  avkrok_nn_1 : N ;
  avkylning_nn_1 : N ;
  avlaang_av_1 : A ;
  avlaata_vb_1 : V ;
  avlaeggare_nn_1 : N ;
  avlaegsen_av_1 : A ;
  avlaemning_nn_1 : N ;
  avlaesare_nn_1 : N ;
  avlaesbar_av_1 : A ;
  avlaesning_nn_1 : N ;
  avlagd_av_1 : A ;
  avlagring_nn_1 : N ;
  avlastare_nn_1 : N ;
  avlastning_nn_1 : N ;
  avlastningsplats_nn_1 : N ;
  avlatsbrev_nn_1 : N ;
  avledning_nn_1 : N ;
  avledningsaendelse_nn_1 : N ;
  avlida_vb_1 : V ;
  avliden_av_1 : A ;
  avlinge_nn_1 : N ;
  avljud_nn_1 : N ;
  avloening_nn_1 : N ;
  avloepning_nn_1 : N ;
  avloesning_nn_1 : N ;
  avlopp_nn_1 : N ;
  avloppsdike_nn_1 : N ;
  avloppsledning_nn_1 : N ;
  avloppsvatten_nn_1 : N ;
  avlyssning_nn_1 : N ;
  avlyssningsapparatur_nn_1 : N ;
  avmaetning_nn_1 : N ;
  avmaett_av_1 : A ;
  avmagring_nn_1 : N ;
  avmarsch_nn_1 : N ;
  avmattning_nn_1 : N ;
  avnaemare_nn_1 : N ;
  avnjuta_vb_1 : V ;
  avog_av_1 : A ;
  avokado_nn_1 : N ;
  avraadande_nn_1 : N ;
  avraekning_nn_1 : N ;
  avraettning_nn_1 : N ;
  avredning_nn_1 : N ;
  avringning_nn_1 : N ;
  avrinna_vb_1 : V ;
  avrinning_nn_1 : N ;
  avrivning_nn_1 : N ;
  avrop_nn_1 : N ;
  avsaegelse_nn_1 : N ;
  avsaendare_nn_1 : N ;
  avsaettlig_av_1 : A ;
  avsaettning_nn_1 : N ;
  avsaettningsbassaeng_nn_1 : N ;
  avsaknad_nn_1 : N ;
  avsats_nn_1 : N ;
  avseende_nn_1 : N ;
  avsegling_nn_1 : N ;
  avsevaerd_av_1 : A ;
  avsides_ab_1 : Adv ;
  avsides_av_1 : A ;
  avsigkommen_av_1 : A ;
  avsikt_nn_1 : N ;
  avsiktlig_av_1 : A ;
  avsittning_nn_1 : N ;
  avsjunga_vb_1 : V ;
  avskaera_vb_1 : V ;
  avskaerning_nn_1 : N ;
  avskaffande_nn_1 : N ;
  avsked_nn_1 : N ;
  avskedsdikt_nn_1 : N ;
  avskild_av_1 : A ;
  avskildhet_nn_1 : N ;
  avskjuta_vb_1 : V ;
  avskjutning_nn_1 : N ;
  avskraeckning_nn_1 : N ;
  avskraede_nn_1 : N ;
  avskraedeshoeg_nn_1 : N ;
  avskrift_nn_1 : N ;
  avskriva_vb_1 : V ;
  avskrivning_nn_1 : N ;
  avskrot_nn_1 : N ;
  avskyvaerd_av_1 : A ;
  avslag_nn_1 : N ;
  avslagen_av_1 : A ;
  avslappning_nn_1 : N ;
  avslappningsoevning_nn_1 : N ;
  avslita_vb_1 : V ;
  avsloejande_nn_1 : N ;
  avslut_nn_1 : N ;
  avslutning_nn_1 : N ;
  avslutningsfest_nn_1 : N ;
  avslutningsvis_ab_1 : Adv ;
  avsmaeltning_nn_1 : N ;
  avsnitt_nn_1 : N ;
  avsnoerning_nn_1 : N ;
  avsnoerningsteori_nn_1 : N ;
  avsoekare_nn_1 : N ;
  avsoendring_nn_1 : N ;
  avspaend_av_1 : A ;
  avspaenning_nn_1 : N ;
  avspaerrning_nn_1 : N ;
  avspark_nn_1 : N ;
  avspegling_nn_1 : N ;
  avspelning_nn_1 : N ;
  avspraang_nn_1 : N ;
  avstaand_nn_1 : N ;
  avstaandsinformation_nn_1 : N ;
  avstaandskraft_nn_1 : N ;
  avstaandsmaetning_nn_1 : N ;
  avstaandstagande_nn_1 : N ;
  avstaellning_nn_1 : N ;
  avstaempling_nn_1 : N ;
  avstaengning_nn_1 : N ;
  avstamp_nn_1 : N ;
  avstavning_nn_1 : N ;
  avsteg_nn_1 : N ;
  avstickare_nn_1 : N ;
  avstickning_nn_1 : N ;
  avstigning_nn_1 : N ;
  avstjaelpningsplats_nn_1 : N ;
  avsutten_av_1 : A ;
  avsvaerja_vb_1 : V ;
  avsvalkning_nn_1 : N ;
  avsynare_nn_1 : N ;
  avta_vb_1 : V ;
  avtaag_nn_1 : N ;
  avtaerd_av_1 : A ;
  avtagande_av_1 : A ;
  avtagbar_av_1 : A ;
  avtagsvaeg_nn_1 : N ;
  avtal_nn_1 : N ;
  avtalsenlig_av_1 : A ;
  avtalsfrihet_nn_1 : N ;
  avtalsperiod_nn_1 : N ;
  avtalsroerelse_nn_1 : N ;
  avtalsstridig_av_1 : A ;
  avtappning_nn_1 : N ;
  avtoning_nn_1 : N ;
  avtraede_nn_1 : N ;
  avtraedelse_nn_1 : N ;
  avtryck_nn_1 : N ;
  avtryckare_nn_1 : N ;
  avtvagning_nn_1 : N ;
  avtvinga_vb_1 : V ;
  avundsam_av_1 : A ;
  avundsjuk_av_1 : A ;
  avundsman_nn_1 : N ;
  avundsvaerd_av_1 : A ;
  avvaeg_nn_1 : N ;
  avvaegning_nn_1 : N ;
  avvaegningsinstrument_nn_1 : N ;
  avvaenjning_nn_1 : N ;
  avvaenjningstid_nn_1 : N ;
  avvaepnande_av_1 : A ;
  avveckling_nn_1 : N ;
  avverkning_nn_1 : N ;
  avvika_vb_1 : V ;
  avvikande_av_1 : A ;
  avvikare_nn_1 : N ;
  avvikelse_nn_1 : N ;
  avvinna_vb_1 : V ;
  avvisare_nn_1 : N ;
  avvisning_nn_1 : N ;
  avytterlig_av_1 : A ;
  ax_nn_1 : N ;
  axblommig_av_1 : A ;
  axel_nn_1 : N ;
  axelband_nn_1 : N ;
  axelbred_av_1 : A ;
  axelgehaeng_nn_1 : N ;
  axelhoelster_nn_1 : N ;
  axelklaff_nn_1 : N ;
  axelkoppling_nn_1 : N ;
  axellager_nn_1 : N ;
  axelmuff_nn_1 : N ;
  axelrem_nn_1 : N ;
  axelriktning_nn_1 : N ;
  axelryckning_nn_1 : N ;
  axial_av_1 : A ;
  axiom_nn_1 : N ;
  axiomatisk_av_1 : A ;
  axion_nn_1 : N ;
  axionfoertaetning_nn_1 : N ;
  axplock_nn_1 : N ;
  aztek_nn_1 : N ;
  aztekisk_av_1 : A ;
  azurblaa_av_1 : A ;
  baade_ab_1 : Adv ;
  baade_nn_1 : N ;
  baagbro_nn_1 : N ;
  baage_nn_1 : N ;
  baagfaelt_nn_1 : N ;
  baagfil_nn_1 : N ;
  baagfoenster_nn_1 : N ;
  baagformig_av_1 : A ;
  baagfris_nn_1 : N ;
  baaggaang_nn_1 : N ;
  baagig_av_1 : A ;
  baagminut_nn_1 : N ;
  baagsaag_nn_1 : N ;
  baagsekund_nn_1 : N ;
  baagskytt_nn_1 : N ;
  baak_nn_1 : N ;
  baal_nn_1 : N ;
  baal_nn_2 : N ;
  baald_av_1 : A ;
  baalgeting_nn_1 : N ;
  baalrullning_nn_1 : N ;
  baalvaext_nn_1 : N ;
  baalverk_nn_1 : N ;
  baangstyrig_av_1 : A ;
  baar_nn_1 : N ;
  baarbaerare_nn_1 : N ;
  baard_nn_1 : N ;
  baarhus_nn_1 : N ;
  baas_nn_1 : N ;
  baat_nn_1 : N ;
  baatben_nn_1 : N ;
  baatbyggare_nn_1 : N ;
  baatbyggeri_nn_1 : N ;
  baatformig_av_1 : A ;
  baatgrav_nn_1 : N ;
  baathus_nn_1 : N ;
  baatliknande_av_1 : A ;
  baatmotor_nn_1 : N ;
  baatnad_nn_1 : N ;
  baatplats_nn_1 : N ;
  baatshake_nn_1 : N ;
  baatskjul_nn_1 : N ;
  baatskraa_nn_1 : N ;
  baatsman_nn_1 : N ;
  baatsmansstol_nn_1 : N ;
  baattaevling_nn_1 : N ;
  babblan_ab_1 : Adv ;
  babian_nn_1 : N ;
  babordsvakt_nn_1 : N ;
  baby_nn_1 : N ;
  babydraekt_nn_1 : N ;
  babylonier_nn_1 : N ;
  babylonisk_av_1 : A ;
  babysitter_nn_1 : N ;
  bacill_nn_1 : N ;
  bacillbaerare_nn_1 : N ;
  back_nn_1 : N ;
  backanal_nn_1 : N ;
  backant_nn_1 : N ;
  backe_nn_1 : N ;
  backfisch_nn_1 : N ;
  backhammer_nn_1 : N ;
  backhoppare_nn_1 : N ;
  backhoppning_nn_1 : N ;
  backig_av_1 : A ;
  backkroen_nn_1 : N ;
  backlandskap_nn_1 : N ;
  backslag_nn_1 : N ;
  backspegel_nn_1 : N ;
  backstag_nn_1 : N ;
  backstroem_nn_1 : N ;
  backstuga_nn_1 : N ;
  backstugusittare_nn_1 : N ;
  backvial_nn_1 : N ;
  bad_nn_1 : N ;
  badanlaeggning_nn_1 : N ;
  badbassaeng_nn_1 : N ;
  badborste_nn_1 : N ;
  baddare_nn_1 : N ;
  baddjaevel_nn_1 : N ;
  baddraekt_nn_1 : N ;
  badensare_nn_1 : N ;
  badensisk_av_1 : A ;
  badgaest_nn_1 : N ;
  badhandduk_nn_1 : N ;
  badhus_nn_1 : N ;
  badhytt_nn_1 : N ;
  badkar_nn_1 : N ;
  badkarseffekt_nn_1 : N ;
  badkarskant_nn_1 : N ;
  badlakan_nn_1 : N ;
  badmintonboll_nn_1 : N ;
  badort_nn_1 : N ;
  badrum_nn_1 : N ;
  badsalt_nn_1 : N ;
  badstaelle_nn_1 : N ;
  badstrand_nn_1 : N ;
  badturist_nn_1 : N ;
  badvatten_nn_1 : N ;
  baebis_nn_1 : N ;
  baeck_nn_1 : N ;
  baeckahaest_nn_1 : N ;
  baecken_nn_1 : N ;
  baeckenben_nn_1 : N ;
  baeckenfoertraengning_nn_1 : N ;
  baeckforell_nn_1 : N ;
  baeckoering_nn_1 : N ;
  baeckravin_nn_1 : N ;
  baeckroeding_nn_1 : N ;
  baedd_nn_1 : N ;
  baeddutrustning_nn_1 : N ;
  baegare_nn_1 : N ;
  baegarkorall_nn_1 : N ;
  baegarmanet_nn_1 : N ;
  baegarsvamp_nn_1 : N ;
  baelg_nn_1 : N ;
  baelgkamera_nn_1 : N ;
  baelgliknande_av_1 : A ;
  baelgvante_nn_1 : N ;
  baeltdjur_nn_1 : N ;
  baeltespaennare_nn_1 : N ;
  baendelband_nn_1 : N ;
  baendjaern_nn_1 : N ;
  baendsel_nn_1 : N ;
  baengel_nn_1 : N ;
  baenk_nn_1 : N ;
  baenkgranne_nn_1 : N ;
  baenkkamrat_nn_1 : N ;
  baenknummer_nn_1 : N ;
  baenkrad_nn_1 : N ;
  baenkspis_nn_1 : N ;
  baensel_nn_1 : N ;
  baer_nn_1 : N ;
  baera_vb_1 : V ;
  baerande_av_1 : A ;
  baerare_nn_1 : N ;
  baerbar_av_1 : A ;
  baerbjaelke_nn_1 : N ;
  baerbuske_nn_1 : N ;
  baerfis_nn_1 : N ;
  baerfrekvens_nn_1 : N ;
  baergning_nn_1 : N ;
  baergningsbil_nn_1 : N ;
  baerig_av_1 : A ;
  baering_nn_1 : N ;
  baerkasse_nn_1 : N ;
  baerkotte_nn_1 : N ;
  baerkraftig_av_1 : A ;
  baerlager_nn_1 : N ;
  baerm_nn_1 : N ;
  baermark_nn_1 : N ;
  baerpaase_nn_1 : N ;
  baerplan_nn_1 : N ;
  baerplansbaat_nn_1 : N ;
  baerplockare_nn_1 : N ;
  baers_nn_1 : N ;
  baersaerk_nn_1 : N ;
  baerstol_nn_1 : N ;
  baervidd_nn_1 : N ;
  baesteman_nn_1 : N ;
  baestis_nn_1 : N ;
  baestsaeljare_nn_1 : N ;
  baettring_nn_1 : N ;
  baever_nn_1 : N ;
  baevning_nn_1 : N ;
  bag_nn_1 : N ;
  bagageinlaemning_nn_1 : N ;
  bagageutrymme_nn_1 : N ;
  bagarbarn_nn_1 : N ;
  bagarbod_nn_1 : N ;
  bagare_nn_1 : N ;
  bagatell_nn_1 : N ;
  bagatellmaal_nn_1 : N ;
  bagel_nn_1 : N ;
  bageri_nn_1 : N ;
  bagerimargarin_nn_1 : N ;
  bagg_nn_1 : N ;
  bagge_nn_1 : N ;
  bagis_nn_1 : N ;
  baguette_nn_1 : N ;
  bahaman_nn_1 : N ;
  bahamansk_av_1 : A ;
  bahrainare_nn_1 : N ;
  bahrainsk_av_1 : A ;
  bahytt_nn_1 : N ;
  baisse_nn_1 : N ;
  bajadaer_nn_1 : N ;
  bajersk_av_1 : A ;
  bajonett_nn_1 : N ;
  bajonettbalja_nn_1 : N ;
  bajonettfattning_nn_1 : N ;
  bajrare_nn_1 : N ;
  bajsnoedig_av_1 : A ;
  bak_ab_1 : Adv ;
  bak_nn_1 : N ;
  bak_nn_2 : N ;
  bakaat_ab_1 : Adv ;
  bakaatraeknande_av_1 : A ;
  bakaatstraevande_av_1 : A ;
  bakaatstraevare_nn_1 : N ;
  bakarv_nn_1 : N ;
  bakarvinge_nn_1 : N ;
  bakaxel_nn_1 : N ;
  bakaxelvaexel_nn_1 : N ;
  bakben_nn_1 : N ;
  bakbinda_vb_1 : V ;
  bakblaasare_nn_1 : N ;
  bakdaeck_nn_1 : N ;
  bakdel_nn_1 : N ;
  bakdoerr_nn_1 : N ;
  bakefter_ab_1 : Adv ;
  bakelse_nn_1 : N ;
  bakfot_nn_1 : N ;
  bakfram_ab_1 : Adv ;
  bakfull_av_1 : A ;
  bakgaard_nn_1 : N ;
  bakgrund_nn_1 : N ;
  bakgrundsfigur_nn_1 : N ;
  bakgrundsstraalning_nn_1 : N ;
  bakgrundsvariabel_nn_1 : N ;
  bakhaall_nn_1 : N ;
  bakhal_av_1 : A ;
  bakhas_nn_1 : N ;
  bakhjul_nn_1 : N ;
  bakhuvud_nn_1 : N ;
  baki_ab_1 : Adv ;
  bakifraan_ab_1 : Adv ;
  bakjour_nn_1 : N ;
  bakkropp_nn_1 : N ;
  bakladdare_nn_1 : N ;
  bakladdning_nn_1 : N ;
  baklaenges_ab_1 : Adv ;
  baklaengesordbok_nn_1 : N ;
  bakoever_ab_1 : Adv ;
  bakom_ab_1 : Adv ;
  bakpaa_ab_1 : Adv ;
  bakplaat_nn_1 : N ;
  bakplaatspapper_nn_1 : N ;
  bakprojektion_nn_1 : N ;
  bakpulver_nn_1 : N ;
  bakrus_nn_1 : N ;
  baksaete_nn_1 : N ;
  baksida_nn_1 : N ;
  bakslag_nn_1 : N ;
  bakslagsventil_nn_1 : N ;
  bakslug_av_1 : A ;
  bakspaar_nn_1 : N ;
  bakstraevare_nn_1 : N ;
  bakstroem_nn_1 : N ;
  baktanke_nn_1 : N ;
  baktericid_nn_1 : N ;
  bakterie_nn_1 : N ;
  bakterieart_nn_1 : N ;
  bakteriedoedande_av_1 : A ;
  bakteriehaerd_nn_1 : N ;
  bakteriekultur_nn_1 : N ;
  bakteriofag_nn_1 : N ;
  bakteriolog_nn_1 : N ;
  bakteriologisk_av_1 : A ;
  baktill_ab_1 : Adv ;
  baktung_av_1 : A ;
  bakugn_nn_1 : N ;
  bakut_ab_1 : Adv ;
  bakvaeg_nn_1 : N ;
  bakvaend_av_1 : A ;
  bakvatten_nn_1 : N ;
  bakverk_nn_1 : N ;
  bakvid_ab_1 : Adv ;
  bakvikt_nn_1 : N ;
  bal_nn_1 : N ;
  bal_nn_2 : N ;
  balans_nn_1 : N ;
  balansakt_nn_1 : N ;
  balansering_nn_1 : N ;
  balanserstaang_nn_1 : N ;
  balanshjul_nn_1 : N ;
  balanskonstnaer_nn_1 : N ;
  balanskonto_nn_1 : N ;
  balansplog_nn_1 : N ;
  balansraekning_nn_1 : N ;
  balansroder_nn_1 : N ;
  balansrubbning_nn_1 : N ;
  balansvaag_nn_1 : N ;
  baldakin_nn_1 : N ;
  baldersbraa_nn_1 : N ;
  bale_nn_1 : N ;
  balett_nn_1 : N ;
  balettdans_nn_1 : N ;
  balettdansoes_nn_1 : N ;
  balettmaestare_nn_1 : N ;
  baljvaext_nn_1 : N ;
  balk_nn_1 : N ;
  balkanfolk_nn_1 : N ;
  balkanisering_nn_1 : N ;
  balkknae_nn_1 : N ;
  balkong_nn_1 : N ;
  balkvaegare_nn_1 : N ;
  balkverk_nn_1 : N ;
  ball_av_1 : A ;
  ballad_nn_1 : N ;
  ballast_nn_1 : N ;
  ballong_nn_1 : N ;
  ballongboll_nn_1 : N ;
  ballongdaeck_nn_1 : N ;
  ballonggas_nn_1 : N ;
  ballongprick_nn_1 : N ;
  ballongsegel_nn_1 : N ;
  balloptikon_nn_1 : N ;
  balneolog_nn_1 : N ;
  balsam_nn_1 : N ;
  balsamdoftande_av_1 : A ;
  balsamin_nn_1 : N ;
  balsamisk_av_1 : A ;
  balt_nn_1 : N ;
  baltisk_av_1 : A ;
  baluns_nn_1 : N ;
  baluster_nn_1 : N ;
  balustrad_nn_1 : N ;
  bamburoer_nn_1 : N ;
  ban_nn_1 : N ;
  banal_av_1 : A ;
  banalitet_nn_1 : N ;
  banan_nn_1 : N ;
  banankontakt_nn_1 : N ;
  bananrepublik_nn_1 : N ;
  bananstock_nn_1 : N ;
  banbrytande_av_1 : A ;
  banbrytare_nn_1 : N ;
  band_nn_1 : N ;
  bandage_nn_1 : N ;
  banderoll_nn_1 : N ;
  bandfordon_nn_1 : N ;
  bandgenerator_nn_1 : N ;
  bandhund_nn_1 : N ;
  bandit_nn_1 : N ;
  bandolaer_nn_1 : N ;
  bandotek_nn_1 : N ;
  bandspektrum_nn_1 : N ;
  bandspelare_nn_1 : N ;
  bandstation_nn_1 : N ;
  bandtraktor_nn_1 : N ;
  bandyroer_nn_1 : N ;
  bandyslag_nn_1 : N ;
  baneman_nn_1 : N ;
  baner_nn_1 : N ;
  banerfoerare_nn_1 : N ;
  banesaar_nn_1 : N ;
  bang_av_1 : A ;
  bang_nn_1 : N ;
  bangaard_nn_1 : N ;
  bangladeshare_nn_1 : N ;
  bangladeshisk_av_1 : A ;
  banhall_nn_1 : N ;
  baning_nn_1 : N ;
  banjo_nn_1 : N ;
  bank_nn_1 : N ;
  bank_nn_2 : N ;
  bankbok_nn_1 : N ;
  bankett_nn_1 : N ;
  bankfack_nn_1 : N ;
  bankgiro_nn_1 : N ;
  bankinspektion_nn_1 : N ;
  bankir_nn_1 : N ;
  bankkamrer_nn_1 : N ;
  bankkonto_nn_1 : N ;
  banklaan_nn_1 : N ;
  bankofullmaektig_nn_1 : N ;
  bankomat_nn_1 : N ;
  bankroerelse_nn_1 : N ;
  bankrutt_av_1 : A ;
  bankrutt_nn_1 : N ;
  bankruttoer_nn_1 : N ;
  banksparande_nn_1 : N ;
  bankvaexel_nn_1 : N ;
  banloepning_nn_1 : N ;
  bann_nn_1 : N ;
  bannstraale_nn_1 : N ;
  banrekord_nn_1 : N ;
  banroerelse_nn_1 : N ;
  bantlaer_nn_1 : N ;
  bantufolk_nn_1 : N ;
  bantuspraak_nn_1 : N ;
  banvagn_nn_1 : N ;
  banvall_nn_1 : N ;
  baptist_nn_1 : N ;
  baptisterium_nn_1 : N ;
  bar_av_1 : A ;
  bar_nn_1 : N ;
  bar_nn_2 : N ;
  bara_ab_1 : Adv ;
  barack_nn_1 : N ;
  barbacka_ab_1 : Adv ;
  barbadier_nn_1 : N ;
  barbadisk_av_1 : A ;
  barbar_nn_1 : N ;
  barbarisk_av_1 : A ;
  barbarism_nn_1 : N ;
  barbent_av_1 : A ;
  barberare_nn_1 : N ;
  barbiturat_nn_1 : N ;
  bard_nn_1 : N ;
  bardisan_nn_1 : N ;
  bardisk_nn_1 : N ;
  bardun_nn_1 : N ;
  bardval_nn_1 : N ;
  barett_nn_1 : N ;
  barfota_av_1 : A ;
  barfotalaekare_nn_1 : N ;
  barfotalasse_nn_1 : N ;
  barfotamunk_nn_1 : N ;
  bariton_nn_1 : N ;
  bariumfoerening_nn_1 : N ;
  bariumsalt_nn_1 : N ;
  bariumsulfat_nn_1 : N ;
  bark_nn_2 : N ;
  barkaroll_nn_1 : N ;
  barkass_nn_1 : N ;
  barkbaat_nn_1 : N ;
  barkborre_nn_1 : N ;
  barkbroed_nn_1 : N ;
  barkis_nn_1 : N ;
  barkspade_nn_1 : N ;
  barktaekt_nn_1 : N ;
  barlast_nn_1 : N ;
  barlastkoel_nn_1 : N ;
  barm_nn_1 : N ;
  barmark_nn_1 : N ;
  barmhaertig_av_1 : A ;
  barmhaertighet_nn_1 : N ;
  barmhaertighetsmord_nn_1 : N ;
  barn_nn_1 : N ;
  barnadoedlighet_nn_1 : N ;
  barnafader_nn_1 : N ;
  barnafoederska_nn_1 : N ;
  barnarov_nn_1 : N ;
  barnasinne_nn_1 : N ;
  barnavaard_nn_1 : N ;
  barnavaardscentral_nn_1 : N ;
  barnavaardsman_nn_1 : N ;
  barnavaardsnaemnd_nn_1 : N ;
  barnbarn_nn_1 : N ;
  barnbarnsbarn_nn_1 : N ;
  barnbegraensning_nn_1 : N ;
  barnbespisning_nn_1 : N ;
  barnbidrag_nn_1 : N ;
  barnboerdshus_nn_1 : N ;
  barnbok_nn_1 : N ;
  barncykel_nn_1 : N ;
  barndaghem_nn_1 : N ;
  barndom_nn_1 : N ;
  barndop_nn_1 : N ;
  barnfamilj_nn_1 : N ;
  barnfoedd_av_1 : A ;
  barnfoerbjuden_av_1 : A ;
  barngrupp_nn_1 : N ;
  barnhem_nn_1 : N ;
  barnhuvud_nn_1 : N ;
  barnkaer_av_1 : A ;
  barnkalas_nn_1 : N ;
  barnkoloni_nn_1 : N ;
  barnledig_av_1 : A ;
  barnlek_nn_1 : N ;
  barnloes_av_1 : A ;
  barnmorska_nn_1 : N ;
  barnomsorgskostnad_nn_1 : N ;
  barnparkering_nn_1 : N ;
  barnpassning_nn_1 : N ;
  barnsaeker_av_1 : A ;
  barnsaeng_nn_1 : N ;
  barnsak_nn_1 : N ;
  barnsboerd_nn_1 : N ;
  barnsjukdom_nn_1 : N ;
  barnsko_nn_1 : N ;
  barnskoeterska_nn_1 : N ;
  barnslig_av_1 : A ;
  barnslighet_nn_1 : N ;
  barnstuga_nn_1 : N ;
  barntillaaten_av_1 : A ;
  barnunge_nn_1 : N ;
  barnvagn_nn_1 : N ;
  barnvakt_nn_1 : N ;
  barock_av_1 : A ;
  barockstil_nn_1 : N ;
  barograf_nn_1 : N ;
  barogram_nn_1 : N ;
  barometer_nn_1 : N ;
  barometerfall_nn_1 : N ;
  barometerstaand_nn_1 : N ;
  barometrisk_av_1 : A ;
  baron_nn_1 : N ;
  barospirator_nn_1 : N ;
  barr_nn_1 : N ;
  barr_nn_2 : N ;
  barriaer_nn_1 : N ;
  barrikad_nn_1 : N ;
  barrikadkaempe_nn_1 : N ;
  barrikadstrid_nn_1 : N ;
  barrskog_nn_1 : N ;
  barrskogsgraens_nn_1 : N ;
  barrskogsregion_nn_1 : N ;
  barrtraed_nn_1 : N ;
  barrtraedskotte_nn_1 : N ;
  barrtraedssort_nn_1 : N ;
  barservering_nn_1 : N ;
  barsk_av_1 : A ;
  barskaap_nn_1 : N ;
  barstol_nn_1 : N ;
  bartender_nn_1 : N ;
  barvinter_nn_1 : N ;
  barysfaer_nn_1 : N ;
  baryton_nn_1 : N ;
  bas_nn_1 : N ;
  bas_nn_2 : N ;
  basaar_nn_1 : N ;
  basal_av_1 : A ;
  basar_nn_1 : N ;
  basbelopp_nn_1 : N ;
  basenhet_nn_1 : N ;
  basfaerdighet_nn_1 : N ;
  basfiol_nn_1 : N ;
  basilisk_nn_1 : N ;
  basisk_av_1 : A ;
  basist_nn_1 : N ;
  bask_nn_1 : N ;
  basker_nn_1 : N ;
  basketboll_nn_1 : N ;
  baskisk_av_1 : A ;
  baskiska_nn_2 : N ;
  baslinje_nn_1 : N ;
  basning_nn_1 : N ;
  basorganisation_nn_1 : N ;
  basrelief_nn_1 : N ;
  bassaeng_nn_1 : N ;
  basse_nn_1 : N ;
  basset_nn_1 : N ;
  bast_nn_2 : N ;
  bastant_av_1 : A ;
  bastard_nn_1 : N ;
  bastardform_nn_1 : N ;
  bastardnaektergal_nn_1 : N ;
  bastcell_nn_1 : N ;
  bastfiber_nn_1 : N ;
  bastingering_nn_1 : N ;
  bastion_nn_1 : N ;
  bastonad_nn_1 : N ;
  bastu_nn_1 : N ;
  bastubad_nn_1 : N ;
  basun_nn_1 : N ;
  basunstoet_nn_1 : N ;
  basvaeg_nn_1 : N ;
  basvinkel_nn_1 : N ;
  batalj_nn_1 : N ;
  bataljmaalare_nn_1 : N ;
  bataljmaalning_nn_1 : N ;
  bataljon_nn_1 : N ;
  bataljonschef_nn_1 : N ;
  batat_nn_1 : N ;
  batist_nn_1 : N ;
  batong_nn_1 : N ;
  batteri_nn_1 : N ;
  batteridriven_av_1 : A ;
  batteriprovare_nn_1 : N ;
  batterist_nn_1 : N ;
  batteritaendning_nn_1 : N ;
  batting_nn_1 : N ;
  batysfaer_nn_1 : N ;
  baud_nn_1 : N ;
  bautasten_nn_1 : N ;
  be_vb_1 : V ;
  beagle_nn_1 : N ;
  beaktansvaerd_av_1 : A ;
  bearbetning_nn_1 : N ;
  bearnaisesaas_nn_1 : N ;
  beatnik_nn_1 : N ;
  bebaadelse_nn_1 : N ;
  bebis_nn_1 : N ;
  bebodd_av_1 : A ;
  beboelig_av_1 : A ;
  bebyggelse_nn_1 : N ;
  bebyggelsenamn_nn_1 : N ;
  beckasin_nn_1 : N ;
  beckig_av_1 : A ;
  beckmoerk_av_1 : A ;
  becquerel_nn_1 : N ;
  bedaarande_av_1 : A ;
  bedja_vb_1 : V ;
  bedjande_av_1 : A ;
  bedoemande_nn_1 : N ;
  bedoemare_nn_1 : N ;
  bedoemning_nn_1 : N ;
  bedoevning_nn_1 : N ;
  bedoevningsmedel_nn_1 : N ;
  bedra_vb_1 : V ;
  bedraegeri_nn_1 : N ;
  bedraeglig_av_1 : A ;
  bedragare_nn_1 : N ;
  bedrift_nn_1 : N ;
  bedriva_vb_1 : V ;
  bedroevelse_nn_1 : N ;
  bedroevlig_av_1 : A ;
  beduin_nn_1 : N ;
  befael_nn_1 : N ;
  befaelhavande_av_1 : A ;
  befaelhavare_nn_1 : N ;
  befaelselev_nn_1 : N ;
  befaelsfoering_nn_1 : N ;
  befaelsgrad_nn_1 : N ;
  befaelsstaellning_nn_1 : N ;
  befaelstecken_nn_1 : N ;
  befaengd_av_1 : A ;
  befaestning_nn_1 : N ;
  befaestningsgrav_nn_1 : N ;
  befaestningslinje_nn_1 : N ;
  befaestningsskydd_nn_1 : N ;
  befaestningsverk_nn_1 : N ;
  befallande_av_1 : A ;
  befallning_nn_1 : N ;
  befallningshavande_nn_1 : N ;
  befallningsman_nn_1 : N ;
  befara_vb_2 : V ;
  befaren_av_1 : A ;
  befattning_nn_1 : N ;
  befattningshavare_nn_1 : N ;
  befinna_vb_1 : V ;
  befintlig_av_1 : A ;
  befintlighet_nn_1 : N ;
  befjaedring_nn_1 : N ;
  befogenhet_nn_1 : N ;
  befolkning_nn_1 : N ;
  befolkningsexplosion_nn_1 : N ;
  befolkningsgrupp_nn_1 : N ;
  befolkningsoekning_nn_1 : N ;
  befolkningspyramid_nn_1 : N ;
  befolkningsstatistik_nn_1 : N ;
  befordran_nn_1 : N ;
  befordring_nn_1 : N ;
  befordringsgaang_nn_1 : N ;
  befordringsgrund_nn_1 : N ;
  befraemjare_nn_1 : N ;
  befraktare_nn_1 : N ;
  befraktning_nn_1 : N ;
  befriande_av_1 : A ;
  befrielse_nn_1 : N ;
  befrielsefront_nn_1 : N ;
  befrielsekamp_nn_1 : N ;
  befrielsekrig_nn_1 : N ;
  befrielseroerelse_nn_1 : N ;
  befruktning_nn_1 : N ;
  begaa_vb_1 : V ;
  begaavning_nn_1 : N ;
  begaavningsreserv_nn_1 : N ;
  begaer_nn_1 : N ;
  begaerelse_nn_1 : N ;
  begaerlig_av_1 : A ;
  bege_vb_1 : V ;
  begeistring_nn_1 : N ;
  begineraa_nn_1 : N ;
  begivande_nn_1 : N ;
  begiven_av_1 : A ;
  begivenhet_nn_1 : N ;
  begjuta_vb_1 : V ;
  begraata_vb_1 : V ;
  begraensning_nn_1 : N ;
  begraensningslinje_nn_1 : N ;
  begrava_vb_1 : V ;
  begravning_nn_1 : N ;
  begravningsakt_nn_1 : N ;
  begravningsbok_nn_1 : N ;
  begravningsbyraa_nn_1 : N ;
  begravningsentreprenoer_nn_1 : N ;
  begravningsgaest_nn_1 : N ;
  begravningskassa_nn_1 : N ;
  begravningskrans_nn_1 : N ;
  begravningsmarsch_nn_1 : N ;
  begravningsmin_nn_1 : N ;
  begravningsplats_nn_1 : N ;
  begravningsprocession_nn_1 : N ;
  begravningstaag_nn_1 : N ;
  begrepp_nn_1 : N ;
  begreppsanalys_nn_1 : N ;
  begreppsanalytisk_av_1 : A ;
  begreppsbestaemning_nn_1 : N ;
  begreppsfoervirring_nn_1 : N ;
  begreppslig_av_1 : A ;
  begripa_vb_1 : V ;
  begriplig_av_1 : A ;
  begriplighet_nn_1 : N ;
  begynnelse_nn_1 : N ;
  begynnelsebokstav_nn_1 : N ;
  begynnelsehastighet_nn_1 : N ;
  begynnelseloen_nn_1 : N ;
  begynnelserim_nn_1 : N ;
  begynnelseskede_nn_1 : N ;
  begynnelsespraak_nn_1 : N ;
  begynnelsestadium_nn_1 : N ;
  behaa_nn_1 : N ;
  behaalla_vb_1 : V ;
  behaallare_nn_1 : N ;
  behaallning_nn_1 : N ;
  behaaring_nn_1 : N ;
  behaendig_av_1 : A ;
  behag_nn_1 : N ;
  behagfull_av_1 : A ;
  behaglig_av_1 : A ;
  behagsjuk_av_1 : A ;
  behandling_nn_1 : N ;
  behandlingsbar_av_1 : A ;
  behandlingsenhet_nn_1 : N ;
  behandlingsrum_nn_1 : N ;
  behaviorist_nn_1 : N ;
  behjaelplig_av_1 : A ;
  behjaertansvaerd_av_1 : A ;
  behjaertenhet_nn_1 : N ;
  behoerig_av_1 : A ;
  behoerigen_ab_1 : Adv ;
  behoerighet_nn_1 : N ;
  behoerighetsbevis_nn_1 : N ;
  behoevande_av_1 : A ;
  behoevlig_av_1 : A ;
  behov_nn_1 : N ;
  behovloes_av_1 : A ;
  behovloeshet_nn_1 : N ;
  behovsprincip_nn_1 : N ;
  behovsproevning_nn_1 : N ;
  beige_av_1 : A ;
  beivrande_nn_1 : N ;
  bej_nn_1 : N ;
  bekaempning_nn_1 : N ;
  bekaempningsmedel_nn_1 : N ;
  bekaennare_nn_1 : N ;
  bekaennelse_nn_1 : N ;
  bekaennelsefrihet_nn_1 : N ;
  bekaennelseroman_nn_1 : N ;
  bekaennelseskrift_nn_1 : N ;
  bekant_av_1 : A ;
  bekant_nn_1 : N ;
  bekanting_nn_1 : N ;
  bekantskap_nn_1 : N ;
  bekantskapskrets_nn_1 : N ;
  beklaednad_nn_1 : N ;
  beklaemd_av_1 : A ;
  beklaemmande_av_1 : A ;
  beklagande_nn_1 : N ;
  beklagansvaerd_av_1 : A ;
  beklaglig_av_1 : A ;
  beklagligen_ab_1 : Adv ;
  beklagligtvis_ab_1 : Adv ;
  beknipa_vb_1 : V ;
  bekostnad_nn_1 : N ;
  bekraeftelse_nn_1 : N ;
  bekroening_nn_1 : N ;
  bekvaem_av_1 : A ;
  bekvaemlighet_nn_1 : N ;
  bekvaemlighetsinraettning_nn_1 : N ;
  bekymmer_nn_1 : N ;
  bekymmerfri_av_1 : A ;
  bekymmersam_av_1 : A ;
  bekymmersfri_av_1 : A ;
  bekymmersloes_av_1 : A ;
  belaaning_nn_1 : N ;
  belaaten_av_1 : A ;
  belaatenhet_nn_1 : N ;
  belackare_nn_1 : N ;
  belaegen_av_1 : A ;
  belaegenhet_nn_1 : N ;
  belaegg_nn_1 : N ;
  belaeggning_nn_1 : N ;
  belaeggningsring_nn_1 : N ;
  belaeggningssnoere_nn_1 : N ;
  belaeggningsstaempel_nn_1 : N ;
  belaegring_nn_1 : N ;
  belaegringstillstaand_nn_1 : N ;
  belaesenhet_nn_1 : N ;
  belaest_av_1 : A ;
  belaesthet_nn_1 : N ;
  belag_nn_1 : N ;
  belastning_nn_1 : N ;
  belemnit_nn_1 : N ;
  belevenhet_nn_1 : N ;
  belgare_nn_1 : N ;
  belgier_nn_1 : N ;
  belgisk_av_1 : A ;
  belgiska_nn_1 : N ;
  belizier_nn_1 : N ;
  belizisk_av_1 : A ;
  beljuga_vb_1 : V ;
  belletrist_nn_1 : N ;
  belletristisk_av_1 : A ;
  bellis_nn_1 : N ;
  beloening_nn_1 : N ;
  beloeningssystem_nn_1 : N ;
  belopp_nn_1 : N ;
  belysande_av_1 : A ;
  belysning_nn_1 : N ;
  belysningsarmatur_nn_1 : N ;
  belysningsstroem_nn_1 : N ;
  belysningsstyrka_nn_1 : N ;
  bemaelde_av_1 : A ;
  bemaerkelse_nn_1 : N ;
  bemaerkelsedag_nn_1 : N ;
  bemaerkt_av_1 : A ;
  bemanning_nn_1 : N ;
  bemoedande_nn_1 : N ;
  bemyndigande_nn_1 : N ;
  ben_nn_1 : N ;
  benaadning_nn_1 : N ;
  benaegen_av_1 : A ;
  benaegenhet_nn_1 : N ;
  benaemning_nn_1 : N ;
  benbildning_nn_1 : N ;
  benbrosk_nn_1 : N ;
  benbrott_nn_1 : N ;
  benediktin_nn_1 : N ;
  benediktinerkloster_nn_1 : N ;
  benediktinermunk_nn_1 : N ;
  benediktinerorden_nn_1 : N ;
  beneficium_nn_1 : N ;
  benefik_av_1 : A ;
  benfisk_nn_1 : N ;
  benfri_av_1 : A ;
  bengalisk_av_1 : A ;
  benget_nn_1 : N ;
  benhaard_av_1 : A ;
  benhinna_nn_1 : N ;
  benhinneinflammation_nn_1 : N ;
  benig_av_1 : A ;
  benign_av_1 : A ;
  beninier_nn_1 : N ;
  beninsk_av_1 : A ;
  benling_nn_1 : N ;
  benmuskel_nn_1 : N ;
  benporslin_nn_1 : N ;
  benprotes_nn_1 : N ;
  benrangel_nn_1 : N ;
  benrest_nn_1 : N ;
  bensaar_nn_1 : N ;
  bensinautomat_nn_1 : N ;
  bensinbolag_nn_1 : N ;
  bensindriven_av_1 : A ;
  bensindunk_nn_1 : N ;
  bensinfoerbrukning_nn_1 : N ;
  bensinmack_nn_1 : N ;
  bensinmotor_nn_1 : N ;
  bensinpump_nn_1 : N ;
  bensinskatt_nn_1 : N ;
  bensinsnaal_av_1 : A ;
  bensinstation_nn_1 : N ;
  bensintank_nn_1 : N ;
  bensintillsats_nn_1 : N ;
  benskoer_av_1 : A ;
  benskoerhet_nn_1 : N ;
  benskydd_nn_1 : N ;
  benspets_nn_1 : N ;
  benstamp_nn_1 : N ;
  benstomme_nn_1 : N ;
  benstraale_nn_1 : N ;
  bensubstans_nn_1 : N ;
  bensvulst_nn_1 : N ;
  bentonit_nn_1 : N ;
  benutskott_nn_1 : N ;
  benvaevnad_nn_1 : N ;
  benvit_av_1 : A ;
  bepansring_nn_1 : N ;
  beraeknande_av_1 : A ;
  beraeknelig_av_1 : A ;
  beraekning_nn_1 : N ;
  beraekningsgrund_nn_1 : N ;
  beraekningsmetod_nn_1 : N ;
  beraekningssaett_nn_1 : N ;
  beraettande_av_1 : A ;
  beraettare_nn_1 : N ;
  beraettarjag_nn_1 : N ;
  beraettarkonst_nn_1 : N ;
  beraettartalang_nn_1 : N ;
  beraettarteknik_nn_1 : N ;
  beraettelse_nn_1 : N ;
  berber_nn_1 : N ;
  berceuse_nn_1 : N ;
  beredare_nn_1 : N ;
  beredd_av_1 : A ;
  beredelse_nn_1 : N ;
  beredning_nn_1 : N ;
  beredningsnaemnd_nn_1 : N ;
  beredskap_nn_1 : N ;
  beredskapslager_nn_1 : N ;
  beredskapslagring_nn_1 : N ;
  beredskapsplan_nn_1 : N ;
  beredskapsstat_nn_1 : N ;
  beredskapstjaenst_nn_1 : N ;
  beredvillig_av_1 : A ;
  beredvillighet_nn_1 : N ;
  berest_av_1 : A ;
  berg_nn_1 : N ;
  bergakung_nn_1 : N ;
  bergamott_nn_1 : N ;
  bergart_nn_1 : N ;
  bergartslager_nn_1 : N ;
  bergbestigare_nn_1 : N ;
  bergbestigning_nn_1 : N ;
  bergborr_nn_1 : N ;
  bergborrning_nn_1 : N ;
  bergfast_av_1 : A ;
  bergfin_av_1 : A ;
  bergfink_nn_1 : N ;
  berggrund_nn_1 : N ;
  berghaell_nn_1 : N ;
  bergig_av_1 : A ;
  bergis_av_1 : A ;
  bergis_nn_1 : N ;
  bergkam_nn_1 : N ;
  bergklack_nn_1 : N ;
  bergknalle_nn_1 : N ;
  bergkristall_nn_1 : N ;
  bergkulle_nn_1 : N ;
  bergnymf_nn_1 : N ;
  bergolja_nn_1 : N ;
  bergrum_nn_1 : N ;
  bergrygg_nn_1 : N ;
  bergsaeker_av_1 : A ;
  bergsbestigare_nn_1 : N ;
  bergsbestigning_nn_1 : N ;
  bergsformation_nn_1 : N ;
  bergskedja_nn_1 : N ;
  bergskedjebildning_nn_1 : N ;
  bergsklaettrare_nn_1 : N ;
  bergsklaettring_nn_1 : N ;
  bergskred_nn_1 : N ;
  bergslag_nn_1 : N ;
  bergslager_nn_1 : N ;
  bergsman_nn_1 : N ;
  bergsmassiv_nn_1 : N ;
  bergsomraade_nn_1 : N ;
  bergsrygg_nn_1 : N ;
  bergssida_nn_1 : N ;
  bergstopp_nn_1 : N ;
  bergstrakt_nn_1 : N ;
  bergstup_nn_1 : N ;
  bergtagen_av_1 : A ;
  bergtall_nn_1 : N ;
  bergtopp_nn_1 : N ;
  bergtroll_nn_1 : N ;
  berguv_nn_1 : N ;
  bergvaegg_nn_1 : N ;
  bergvind_nn_1 : N ;
  beridare_nn_1 : N ;
  beriden_av_1 : A ;
  beriktigande_nn_1 : N ;
  berkis_nn_1 : N ;
  berlock_nn_1 : N ;
  bermudarigg_nn_1 : N ;
  beroemd_av_1 : A ;
  beroemdhet_nn_1 : N ;
  beroemlig_av_1 : A ;
  beroemvaerd_av_1 : A ;
  beroende_av_1 : A ;
  beroendeframkallande_av_1 : A ;
  beroerd_av_1 : A ;
  beroering_nn_1 : N ;
  beroeringsassociation_nn_1 : N ;
  beroeringselektricitet_nn_1 : N ;
  beroeringspunkt_nn_1 : N ;
  bersaa_nn_1 : N ;
  bertel_nn_1 : N ;
  berusande_av_1 : A ;
  berusning_nn_1 : N ;
  beryll_nn_1 : N ;
  besaettning_nn_1 : N ;
  besaettningsband_nn_1 : N ;
  besaettningsman_nn_1 : N ;
  besatt_av_1 : A ;
  besegrare_nn_1 : N ;
  besiffring_nn_1 : N ;
  besiktning_nn_1 : N ;
  besiktningsinstrument_nn_1 : N ;
  besiktningsman_nn_1 : N ;
  besinningsfull_av_1 : A ;
  besinningsloes_av_1 : A ;
  besitta_vb_1 : V ;
  besittning_nn_1 : N ;
  besittningshavare_nn_1 : N ;
  besittningsraett_nn_1 : N ;
  besittningsskydd_nn_1 : N ;
  besjunga_vb_1 : V ;
  besk_av_1 : A ;
  besk_nn_1 : N ;
  beskaeftig_av_1 : A ;
  beskaellare_nn_1 : N ;
  beskaenkt_av_1 : A ;
  beskaera_vb_2 : V ;
  beskaerd_av_1 : A ;
  beskaermelse_nn_1 : N ;
  beskaerning_nn_1 : N ;
  beskaffenhet_nn_1 : N ;
  beskattning_nn_1 : N ;
  beskattningsaar_nn_1 : N ;
  beskattningsbar_av_1 : A ;
  beskattningsgrund_nn_1 : N ;
  beskattningsnaemnd_nn_1 : N ;
  beskattningsprincip_nn_1 : N ;
  besked_nn_1 : N ;
  beskedlig_av_1 : A ;
  beskhet_nn_1 : N ;
  beskickning_nn_1 : N ;
  beskickningschef_nn_1 : N ;
  beskjuta_vb_1 : V ;
  beskjutning_nn_1 : N ;
  beskriva_vb_1 : V ;
  beskrivande_av_1 : A ;
  beskrivbar_av_1 : A ;
  beskrivning_nn_1 : N ;
  beskyddare_nn_1 : N ;
  beskyllning_nn_1 : N ;
  beslag_nn_1 : N ;
  beslagare_nn_1 : N ;
  beslagsband_nn_1 : N ;
  beslagssmed_nn_1 : N ;
  beslagssmide_nn_1 : N ;
  beslagta_vb_1 : V ;
  beslut_nn_1 : N ;
  besluta_vb_1 : V ;
  besluten_av_1 : A ;
  beslutenlig_av_1 : A ;
  beslutfattare_nn_1 : N ;
  beslutfoer_av_1 : A ;
  beslutmaessig_av_1 : A ;
  beslutnivaa_nn_1 : N ;
  beslutsam_av_1 : A ;
  beslutsamhet_nn_1 : N ;
  beslutsfattande_av_1 : A ;
  beslutsfattare_nn_1 : N ;
  beslutsfoer_av_1 : A ;
  beslutshierarki_nn_1 : N ;
  beslutsmaessig_av_1 : A ;
  beslutsnivaa_nn_1 : N ;
  besman_nn_1 : N ;
  besmanskrok_nn_1 : N ;
  besmittelse_nn_1 : N ;
  besoek_nn_1 : N ;
  besoekande_nn_1 : N ;
  besoekare_nn_1 : N ;
  besoeksadress_nn_1 : N ;
  besoeksbok_nn_1 : N ;
  besoeksdag_nn_1 : N ;
  besoekstid_nn_1 : N ;
  besparing_nn_1 : N ;
  besparingsskog_nn_1 : N ;
  bespisning_nn_1 : N ;
  bespottelse_nn_1 : N ;
  besprutning_nn_1 : N ;
  besprutningsmedel_nn_1 : N ;
  besprutningsvaetska_nn_1 : N ;
  bessemerblaasning_nn_1 : N ;
  bessemerstaal_nn_1 : N ;
  bessemerugn_nn_1 : N ;
  besserwisser_nn_1 : N ;
  best_nn_1 : N ;
  bestaaende_av_1 : A ;
  bestaand_nn_1 : N ;
  bestaandande_av_1 : A ;
  bestaandsbildande_av_1 : A ;
  bestaandsdel_nn_1 : N ;
  bestaellare_nn_1 : N ;
  bestaellning_nn_1 : N ;
  bestaellningsavgift_nn_1 : N ;
  bestaellningsverk_nn_1 : N ;
  bestaellsam_av_1 : A ;
  bestaellt_av_1 : A ;
  bestaembar_av_1 : A ;
  bestaemd_av_1 : A ;
  bestaemmelse_nn_1 : N ;
  bestaemmelseort_nn_1 : N ;
  bestaemning_nn_1 : N ;
  bestaemningsord_nn_1 : N ;
  bestaendig_av_1 : A ;
  bestaendighet_nn_1 : N ;
  bestialisk_av_1 : A ;
  bestick_nn_1 : N ;
  besticka_vb_1 : V ;
  bestickande_av_1 : A ;
  bestickfoering_nn_1 : N ;
  besticklig_av_1 : A ;
  bestickning_nn_1 : N ;
  bestiga_vb_1 : V ;
  bestigning_nn_1 : N ;
  bestjaela_vb_1 : V ;
  bestoert_av_1 : A ;
  bestraalning_nn_1 : N ;
  bestraffning_nn_1 : N ;
  bestrida_vb_1 : V ;
  bestryka_vb_1 : V ;
  bestrykning_nn_1 : N ;
  bestseller_nn_1 : N ;
  bestsellerfoerfattare_nn_1 : N ;
  bestyckning_nn_1 : N ;
  bestyr_nn_1 : N ;
  besutten_av_1 : A ;
  besvaer_nn_1 : N ;
  besvaerja_vb_1 : V ;
  besvaerjelse_nn_1 : N ;
  besvaerjelseformel_nn_1 : N ;
  besvaerlig_av_1 : A ;
  besvaerlighet_nn_1 : N ;
  besvaersgrund_nn_1 : N ;
  besvaershaenvisning_nn_1 : N ;
  besvaershandling_nn_1 : N ;
  besvaersinstans_nn_1 : N ;
  besvaersmaal_nn_1 : N ;
  besvaersmyndighet_nn_1 : N ;
  besvaersskrift_nn_1 : N ;
  besvaerssubjekt_nn_1 : N ;
  besvaerstid_nn_1 : N ;
  besvikelse_nn_1 : N ;
  besviken_av_1 : A ;
  besynnerlig_av_1 : A ;
  besynnerlighet_nn_1 : N ;
  bet_ab_1 : Adv ;
  bet_nn_1 : N ;
  beta_nn_2 : N ;
  beta_vb_2 : V ;
  betablockerare_nn_1 : N ;
  betaeckning_ab_1 : Adv ;
  betaeckning_nn_1 : N ;
  betaenkande_nn_1 : N ;
  betaenketid_nn_1 : N ;
  betaenklig_av_1 : A ;
  betaenklighet_nn_1 : N ;
  betaenksam_av_1 : A ;
  betaenkt_av_1 : A ;
  betagande_av_1 : A ;
  betagen_av_1 : A ;
  betalbar_av_1 : A ;
  betalkurs_nn_1 : N ;
  betalning_nn_1 : N ;
  betalningsanstaand_nn_1 : N ;
  betalningsavtal_nn_1 : N ;
  betalningsbalans_nn_1 : N ;
  betalningsbevis_nn_1 : N ;
  betalningsfoerelaeggande_nn_1 : N ;
  betalningsfri_av_1 : A ;
  betalningsfrist_nn_1 : N ;
  betalningsgill_av_1 : A ;
  betalningsinstaellelse_nn_1 : N ;
  betalningsmedel_nn_1 : N ;
  betalningsskyldig_av_1 : A ;
  betalningstermin_nn_1 : N ;
  betalningstid_nn_1 : N ;
  betalningsvillkor_nn_1 : N ;
  betapartikel_nn_1 : N ;
  betastraalande_av_1 : A ;
  betastraalning_nn_1 : N ;
  betatron_nn_1 : N ;
  bete_nn_1 : N ;
  bete_nn_2 : N ;
  betecknande_av_1 : A ;
  beteckning_nn_1 : N ;
  beteende_nn_1 : N ;
  beteendeforskning_nn_1 : N ;
  beteendemoenster_nn_1 : N ;
  beteenderubbning_nn_1 : N ;
  beteendevetare_nn_1 : N ;
  beteendevetenskap_nn_1 : N ;
  betelblad_nn_1 : N ;
  betelnoet_nn_1 : N ;
  betelpalm_nn_1 : N ;
  beteltuggare_nn_1 : N ;
  betesgaang_nn_1 : N ;
  betesland_nn_1 : N ;
  betesmark_nn_1 : N ;
  betesomraade_nn_1 : N ;
  betesplats_nn_1 : N ;
  beting_nn_1 : N ;
  beting_nn_2 : N ;
  betingelse_nn_1 : N ;
  betingning_nn_1 : N ;
  betingslaesning_nn_1 : N ;
  betjaening_nn_1 : N ;
  betjaeningsavgift_nn_1 : N ;
  betjaent_av_1 : A ;
  betjaent_nn_1 : N ;
  betkampanj_nn_1 : N ;
  betmedel_nn_1 : N ;
  betning_nn_1 : N ;
  betongbaedd_nn_1 : N ;
  betongblandare_nn_1 : N ;
  betongpaale_nn_1 : N ;
  betoning_nn_1 : N ;
  betraengd_av_1 : A ;
  betraktare_nn_1 : N ;
  betraktelse_nn_1 : N ;
  betraktelsesaett_nn_1 : N ;
  betrodd_av_1 : A ;
  betryckt_av_1 : A ;
  betryggande_av_1 : A ;
  bets_nn_1 : N ;
  betsel_nn_1 : N ;
  betsmedel_nn_1 : N ;
  betsning_nn_1 : N ;
  bett_nn_1 : N ;
  bettel_nn_1 : N ;
  bettlare_nn_1 : N ;
  betungande_av_1 : A ;
  betvinga_vb_1 : V ;
  betvingande_av_1 : A ;
  betydande_av_1 : A ;
  betydelse_nn_1 : N ;
  betydelsebaerande_av_1 : A ;
  betydelsefattig_av_1 : A ;
  betydelsefoeraendring_nn_1 : N ;
  betydelsefoerskjutning_nn_1 : N ;
  betydelsefull_av_1 : A ;
  betydelselaera_nn_1 : N ;
  betydelseloes_av_1 : A ;
  betydelsenyans_nn_1 : N ;
  betydelseutveckling_nn_1 : N ;
  betydenhet_nn_1 : N ;
  betydlig_av_1 : A ;
  betyg_nn_1 : N ;
  betygelse_nn_1 : N ;
  betygsaettning_nn_1 : N ;
  betygsavskrift_nn_1 : N ;
  betygsfri_av_1 : A ;
  betygsgrad_nn_1 : N ;
  betygskatalog_nn_1 : N ;
  betygsnaemnd_nn_1 : N ;
  beundransvaerd_av_1 : A ;
  beundrare_nn_1 : N ;
  beundrarinna_nn_1 : N ;
  bevaagen_av_1 : A ;
  bevaagenhet_nn_1 : N ;
  bevaepning_nn_1 : N ;
  bevaering_nn_1 : N ;
  bevaext_av_1 : A ;
  bevakning_nn_1 : N ;
  bevakningskedja_nn_1 : N ;
  bevakningsomraade_nn_1 : N ;
  bevattning_nn_1 : N ;
  bevekande_av_1 : A ;
  bevekelse_nn_1 : N ;
  bevekelsegrund_nn_1 : N ;
  bevillning_nn_1 : N ;
  bevillningsavgift_nn_1 : N ;
  bevillningsutskott_nn_1 : N ;
  bevis_nn_1 : N ;
  bevisbar_av_1 : A ;
  bevisboerda_nn_1 : N ;
  bevisfoering_nn_1 : N ;
  bevisfoervanskning_nn_1 : N ;
  beviskedja_nn_1 : N ;
  beviskraft_nn_1 : N ;
  beviskraftig_av_1 : A ;
  beviskrav_nn_1 : N ;
  bevislig_av_1 : A ;
  bevisligen_ab_1 : Adv ;
  bevismaterial_nn_1 : N ;
  bevismedel_nn_1 : N ;
  bevisning_nn_1 : N ;
  bevisproevning_nn_1 : N ;
  bevissaekring_nn_1 : N ;
  bevisskyldig_av_1 : A ;
  bevisvaerde_nn_1 : N ;
  bevisvaerdering_nn_1 : N ;
  bevuxen_av_1 : A ;
  bhutanes_nn_1 : N ;
  bhutanesisk_av_1 : A ;
  bi_ab_1 : Adv ;
  bi_nn_1 : N ;
  biaccent_nn_1 : N ;
  biaemne_nn_1 : N ;
  biaetare_nn_1 : N ;
  bias_nn_1 : N ;
  biavsikt_nn_1 : N ;
  bibehaalla_vb_1 : V ;
  bibehaallen_av_1 : A ;
  bibel_nn_1 : N ;
  bibelcitat_nn_1 : N ;
  bibelfoerklaring_nn_1 : N ;
  bibelhandskrift_nn_1 : N ;
  bibelkanon_nn_1 : N ;
  bibelkommission_nn_1 : N ;
  bibelkonkordans_nn_1 : N ;
  bibelkristen_av_1 : A ;
  bibeloeversaettning_nn_1 : N ;
  bibelord_nn_1 : N ;
  bibelsaellskap_nn_1 : N ;
  bibelsamtal_nn_1 : N ;
  bibelspraak_nn_1 : N ;
  bibelspraengd_av_1 : A ;
  bibeltext_nn_1 : N ;
  bibeltrogen_av_1 : A ;
  bibelvers_nn_1 : N ;
  bibetydelse_nn_1 : N ;
  biblicism_nn_1 : N ;
  bibliofil_nn_1 : N ;
  bibliofilupplaga_nn_1 : N ;
  bibliograf_nn_1 : N ;
  bibliografi_nn_1 : N ;
  bibliografisk_av_1 : A ;
  biblioman_nn_1 : N ;
  bibliotek_nn_1 : N ;
  bibliotekarie_nn_1 : N ;
  biblioteksavgift_nn_1 : N ;
  biblioteksband_nn_1 : N ;
  biblioteksbord_nn_1 : N ;
  bibliotekskatalog_nn_1 : N ;
  bibliotekslaan_nn_1 : N ;
  biblisk_av_1 : A ;
  bibroed_nn_1 : N ;
  biceps_nn_1 : N ;
  bicepsmuskel_nn_1 : N ;
  bide_nn_1 : N ;
  bidevind_ab_1 : Adv ;
  bidevindare_nn_1 : N ;
  bidevindsegel_nn_1 : N ;
  bidevindseglare_nn_1 : N ;
  bidra_vb_1 : V ;
  bidrag_nn_1 : N ;
  bidragande_av_1 : A ;
  bidragsdel_nn_1 : N ;
  bidragsfoerskott_nn_1 : N ;
  bidragsgivare_nn_1 : N ;
  bidragsskyldighet_nn_1 : N ;
  bidrottning_nn_1 : N ;
  biedermeierstil_nn_1 : N ;
  bieffekt_nn_1 : N ;
  bienn_av_1 : A ;
  biennal_nn_1 : N ;
  bifall_nn_1 : N ;
  bifalla_vb_1 : V ;
  bifallsrop_nn_1 : N ;
  bifallsstorm_nn_1 : N ;
  bifenyl_nn_1 : N ;
  biff_nn_1 : N ;
  biffdjur_nn_1 : N ;
  biffen_ab_1 : Adv ;
  biffko_nn_1 : N ;
  biffrad_nn_1 : N ;
  biffstek_nn_1 : N ;
  bifigur_nn_1 : N ;
  bifilaer_av_1 : A ;
  biflod_nn_1 : N ;
  bifloede_nn_1 : N ;
  bifokalglas_nn_1 : N ;
  bifurkation_nn_1 : N ;
  bigaard_nn_1 : N ;
  bigamist_nn_1 : N ;
  bigarraa_nn_1 : N ;
  bigift_nn_1 : N ;
  bigott_av_1 : A ;
  bigotteri_nn_1 : N ;
  bihaaleinflammation_nn_1 : N ;
  bihandling_nn_1 : N ;
  bihang_nn_1 : N ;
  bihus_nn_1 : N ;
  bihustru_nn_1 : N ;
  biinkomst_nn_1 : N ;
  bikini_nn_1 : N ;
  bikloev_nn_1 : N ;
  bikonkav_av_1 : A ;
  bikonvex_av_1 : A ;
  bikt_nn_1 : N ;
  biktbarn_nn_1 : N ;
  biktfader_nn_1 : N ;
  biktstol_nn_1 : N ;
  bikvadrat_nn_1 : N ;
  bil_nn_1 : N ;
  bilaakning_nn_1 : N ;
  bilabial_av_1 : A ;
  bilaccis_nn_1 : N ;
  bilaegare_nn_1 : N ;
  bilaeger_nn_1 : N ;
  bilateral_av_1 : A ;
  bilbaelte_nn_1 : N ;
  bilbatteri_nn_1 : N ;
  bilbesiktning_nn_1 : N ;
  bilboke_nn_1 : N ;
  bilburen_av_1 : A ;
  bild_nn_1 : N ;
  bildaeck_nn_1 : N ;
  bildande_av_1 : A ;
  bildband_nn_1 : N ;
  bildbar_av_1 : A ;
  bilderbok_nn_1 : N ;
  bildhaallning_nn_1 : N ;
  bildhuggare_nn_1 : N ;
  bildhuggeri_nn_1 : N ;
  bildkonst_nn_1 : N ;
  bildkryss_nn_1 : N ;
  bildlig_av_1 : A ;
  bildmaessig_av_1 : A ;
  bildmaterial_nn_1 : N ;
  bildmonitor_nn_1 : N ;
  bildning_nn_1 : N ;
  bildningsaristokrat_nn_1 : N ;
  bildningsfel_nn_1 : N ;
  bildningsfoerbund_nn_1 : N ;
  bildningsnivaa_nn_1 : N ;
  bildningsorganisation_nn_1 : N ;
  bildningsroman_nn_1 : N ;
  bildningsverksamhet_nn_1 : N ;
  bildoeverfoering_nn_1 : N ;
  bildredaktoer_nn_1 : N ;
  bildreportage_nn_1 : N ;
  bildroer_nn_1 : N ;
  bildrulle_1_nn_1 : N ;
  bildrulle_2_nn_1 : N ;
  bildsignal_nn_1 : N ;
  bildskaerm_nn_1 : N ;
  bildskoen_av_1 : A ;
  bildskrift_nn_1 : N ;
  bildsnidare_nn_1 : N ;
  bildsnideri_nn_1 : N ;
  bildspraak_nn_1 : N ;
  bildsten_nn_1 : N ;
  bildstod_nn_1 : N ;
  bildstormare_nn_1 : N ;
  bildstrid_nn_1 : N ;
  bildsvit_nn_1 : N ;
  bildtelefon_nn_1 : N ;
  bildtext_nn_1 : N ;
  bildtolkning_nn_1 : N ;
  bildvaevnad_nn_1 : N ;
  bilfaerja_nn_1 : N ;
  bilfoerare_nn_1 : N ;
  bilfoersaekring_nn_1 : N ;
  bilfri_av_1 : A ;
  bilgolv_nn_1 : N ;
  bilindustri_nn_1 : N ;
  bilingual_av_1 : A ;
  bilist_nn_1 : N ;
  biljard_nn_1 : N ;
  biljardboll_nn_1 : N ;
  biljardbord_nn_1 : N ;
  biljardkaepp_nn_1 : N ;
  biljardkoe_nn_1 : N ;
  biljardsalong_nn_1 : N ;
  biljardspel_nn_1 : N ;
  biljett_nn_1 : N ;
  biljettaang_nn_1 : N ;
  biljettautomat_nn_1 : N ;
  biljettbok_nn_1 : N ;
  biljettexpedition_nn_1 : N ;
  biljettfoersaeljare_nn_1 : N ;
  biljettfoersaeljning_nn_1 : N ;
  biljetthaefte_nn_1 : N ;
  biljettinkomst_nn_1 : N ;
  biljettkontor_nn_1 : N ;
  biljettkontroll_nn_1 : N ;
  biljettmaskin_nn_1 : N ;
  biljon_nn_1 : N ;
  biljud_nn_1 : N ;
  bilkaar_nn_1 : N ;
  bilkaarist_nn_1 : N ;
  bilkoe_nn_1 : N ;
  bilkoep_nn_1 : N ;
  bilkoerning_nn_1 : N ;
  bilkrock_nn_1 : N ;
  bilkupe_nn_1 : N ;
  bill_nn_1 : N ;
  bill_nn_2 : N ;
  billaan_nn_1 : N ;
  billast_nn_1 : N ;
  billig_av_1 : A ;
  billighet_nn_1 : N ;
  billighetsupplaga_nn_1 : N ;
  billjus_nn_1 : N ;
  billots_nn_1 : N ;
  bilmaerke_nn_1 : N ;
  bilmekaniker_nn_1 : N ;
  bilmotor_nn_1 : N ;
  bilnummer_nn_1 : N ;
  bilnyckel_nn_1 : N ;
  bilpark_nn_1 : N ;
  bilparkering_nn_1 : N ;
  bilplaat_nn_1 : N ;
  bilprovning_nn_1 : N ;
  bilrally_nn_1 : N ;
  bilratt_nn_1 : N ;
  bilregister_nn_1 : N ;
  bilring_nn_1 : N ;
  bilsaete_nn_1 : N ;
  bilsjuk_av_1 : A ;
  bilskatt_nn_1 : N ;
  bilstoeld_nn_1 : N ;
  biltaevling_nn_1 : N ;
  biltak_nn_1 : N ;
  biltelefon_nn_1 : N ;
  biltog_av_1 : A ;
  biltunnel_nn_1 : N ;
  bilvaeg_nn_1 : N ;
  bilverkstad_nn_1 : N ;
  bimaane_nn_1 : N ;
  bimetall_nn_1 : N ;
  binaer_av_1 : A ;
  binaering_nn_1 : N ;
  binamn_nn_1 : N ;
  bind_nn_1 : N ;
  binda_vb_1 : V ;
  bindaemne_nn_1 : N ;
  bindande_av_1 : A ;
  bindare_nn_1 : N ;
  bindbjaelke_nn_1 : N ;
  bindehinna_nn_1 : N ;
  bindehinneinflammation_nn_1 : N ;
  bindel_nn_1 : N ;
  bindemedel_nn_1 : N ;
  bindenyckel_nn_1 : N ;
  bindeord_nn_1 : N ;
  binderi_nn_1 : N ;
  bindesaeck_nn_1 : N ;
  bindestreck_nn_1 : N ;
  bindesubstans_nn_1 : N ;
  bindevokal_nn_1 : N ;
  bindgalen_av_1 : A ;
  bindgarn_nn_1 : N ;
  bindnaal_nn_1 : N ;
  bindning_nn_1 : N ;
  bindsten_nn_1 : N ;
  bindvaev_nn_1 : N ;
  bindvaevshinna_nn_1 : N ;
  bindvaevskapsel_nn_1 : N ;
  bindvaevssaeck_nn_1 : N ;
  bindvaevstraad_nn_1 : N ;
  binge_nn_1 : N ;
  bingel_nn_1 : N ;
  binjure_nn_1 : N ;
  binnikemask_nn_1 : N ;
  binokel_nn_1 : N ;
  binokulaer_av_1 : A ;
  binom_nn_1 : N ;
  biobesoek_nn_1 : N ;
  biobiljett_nn_1 : N ;
  biobraensle_nn_1 : N ;
  biocid_nn_1 : N ;
  biodlare_nn_1 : N ;
  biodling_nn_1 : N ;
  bioduk_nn_1 : N ;
  biodynamisk_av_1 : A ;
  biofoerestaellning_nn_1 : N ;
  biofysisk_av_1 : A ;
  biogen_av_1 : A ;
  biogenetisk_av_1 : A ;
  biograf_nn_1 : N ;
  biografbyraa_nn_1 : N ;
  biografi_nn_1 : N ;
  biografisk_av_1 : A ;
  biograforgel_nn_1 : N ;
  biografteater_nn_1 : N ;
  biokemisk_av_1 : A ;
  biokemist_nn_1 : N ;
  biolog_nn_1 : N ;
  biologisk_av_1 : A ;
  biomstaendighet_nn_1 : N ;
  biosfaer_nn_1 : N ;
  bioteknik_nn_1 : N ;
  bioteknisk_av_1 : A ;
  biotisk_av_1 : A ;
  biotop_nn_1 : N ;
  biotyp_nn_1 : N ;
  biperson_nn_1 : N ;
  biplan_nn_1 : N ;
  biplanet_nn_1 : N ;
  bipolaer_av_1 : A ;
  bipolaritet_nn_1 : N ;
  biprodukt_nn_1 : N ;
  birem_nn_1 : N ;
  birfilare_nn_1 : N ;
  biroll_nn_1 : N ;
  birot_nn_1 : N ;
  bisaettning_nn_1 : N ;
  bisak_nn_1 : N ;
  bisamhaelle_nn_1 : N ;
  bisamoxe_nn_1 : N ;
  bisamsvin_nn_1 : N ;
  bisarr_av_1 : A ;
  bisarreri_nn_1 : N ;
  bisats_nn_1 : N ;
  bisatsordfoeljd_nn_1 : N ;
  bisektris_nn_1 : N ;
  bisexualitet_nn_1 : N ;
  bisexuell_av_1 : A ;
  bisittare_nn_1 : N ;
  biskoeldkoertel_nn_1 : N ;
  biskop_nn_1 : N ;
  biskoplig_av_1 : A ;
  biskopsdoeme_nn_1 : N ;
  biskopskors_nn_1 : N ;
  biskopsmoete_nn_1 : N ;
  biskopsskrud_nn_1 : N ;
  biskopsstav_nn_1 : N ;
  biskopsvisitation_nn_1 : N ;
  biskvi_nn_1 : N ;
  bismak_nn_1 : N ;
  bisol_nn_1 : N ;
  bisonoxe_nn_1 : N ;
  bisp_nn_1 : N ;
  bispringa_vb_1 : V ;
  bistaandsland_nn_1 : N ;
  bistaandsorgan_nn_1 : N ;
  bistaandsprogram_nn_1 : N ;
  bister_av_1 : A ;
  bistick_nn_1 : N ;
  bisting_nn_1 : N ;
  bistock_nn_1 : N ;
  bistro_nn_1 : N ;
  bisturi_nn_1 : N ;
  bistyng_nn_1 : N ;
  bisvaerm_nn_1 : N ;
  bisyssla_nn_1 : N ;
  bit_nn_1 : N ;
  bit_nn_2 : N ;
  bita_vb_1 : V ;
  bitande_av_1 : A ;
  bitanke_nn_1 : N ;
  bitecken_nn_1 : N ;
  biten_av_1 : A ;
  bitestikel_nn_1 : N ;
  biton_nn_1 : N ;
  bitraedande_av_1 : A ;
  bitraede_nn_1 : N ;
  bitsk_av_1 : A ;
  bitter_av_1 : A ;
  bitterhet_nn_1 : N ;
  bitterkall_av_1 : A ;
  bitterligen_ab_1 : Adv ;
  bitterljuv_av_1 : A ;
  bittermandel_nn_1 : N ;
  bittersalt_av_1 : A ;
  bittersoet_av_1 : A ;
  bittersta_av_1 : A ;
  bittida_ab_1 : Adv ;
  bituminoes_av_1 : A ;
  bitvarg_nn_1 : N ;
  bitvis_ab_1 : Adv ;
  bivack_nn_1 : N ;
  bivaeg_nn_1 : N ;
  bivax_nn_1 : N ;
  biverkning_nn_1 : N ;
  bivraak_nn_1 : N ;
  biyngel_nn_1 : N ;
  bjaebbig_av_1 : A ;
  bjaebbighet_nn_1 : N ;
  bjaelke_nn_1 : N ;
  bjaelkhuvud_nn_1 : N ;
  bjaelklag_nn_1 : N ;
  bjaelkverk_nn_1 : N ;
  bjaellko_nn_1 : N ;
  bjaert_av_1 : A ;
  bjaesse_nn_1 : N ;
  bjoerk_nn_1 : N ;
  bjoerkblad_nn_1 : N ;
  bjoerkloev_nn_1 : N ;
  bjoerknaever_nn_1 : N ;
  bjoerkregion_nn_1 : N ;
  bjoerkris_nn_1 : N ;
  bjoerksopp_nn_1 : N ;
  bjoerktrast_nn_1 : N ;
  bjoern_nn_1 : N ;
  bjoernbaer_nn_1 : N ;
  bjoernbaersbuske_nn_1 : N ;
  bjoernbindsle_nn_1 : N ;
  bjoernhallon_nn_1 : N ;
  bjoernhund_nn_1 : N ;
  bjoerninna_nn_1 : N ;
  bjoernjakt_nn_1 : N ;
  bjoernliknande_av_1 : A ;
  bjoernram_nn_1 : N ;
  bjoernskall_nn_1 : N ;
  bjoernskinn_nn_1 : N ;
  bjoerntjaenst_nn_1 : N ;
  bjuda_vb_1 : V ;
  bjudcigarr_nn_1 : N ;
  bjudning_nn_1 : N ;
  blaa_av_1 : A ;
  blaaaktig_av_1 : A ;
  blaaanlupen_av_1 : A ;
  blaabaer_nn_1 : N ;
  blaabaersris_nn_1 : N ;
  blaablodig_av_1 : A ;
  blaadaare_nn_1 : N ;
  blaafoerskjutning_nn_1 : N ;
  blaafrusen_av_1 : A ;
  blaagroen_av_1 : A ;
  blaagroenalg_nn_1 : N ;
  blaagul_av_1 : A ;
  blaahaj_nn_1 : N ;
  blaahake_nn_1 : N ;
  blaahallon_nn_1 : N ;
  blaahjon_nn_1 : N ;
  blaaklint_nn_1 : N ;
  blaakopia_nn_1 : N ;
  blaalusern_nn_1 : N ;
  blaamaerke_nn_1 : N ;
  blaames_nn_1 : N ;
  blaamusseron_nn_1 : N ;
  blaamussla_nn_1 : N ;
  blaanad_nn_1 : N ;
  blaaoegd_av_1 : A ;
  blaaraev_nn_1 : N ;
  blaaroed_av_1 : A ;
  blaasare_nn_1 : N ;
  blaasbaelg_nn_1 : N ;
  blaasfoting_nn_1 : N ;
  blaashaal_nn_1 : N ;
  blaashals_nn_1 : N ;
  blaasig_av_1 : A ;
  blaasinstrument_nn_1 : N ;
  blaaskatarr_nn_1 : N ;
  blaasljud_nn_1 : N ;
  blaasmask_nn_1 : N ;
  blaasning_nn_1 : N ;
  blaasorkester_nn_1 : N ;
  blaasroer_nn_1 : N ;
  blaassten_nn_1 : N ;
  blaastaell_nn_1 : N ;
  blaasur_av_1 : A ;
  blaaval_nn_1 : N ;
  blaavinge_nn_1 : N ;
  blaaviolett_av_1 : A ;
  blaavit_av_1 : A ;
  blaavitling_nn_1 : N ;
  black_av_1 : A ;
  black_nn_1 : N ;
  blackig_av_1 : A ;
  blackout_nn_1 : N ;
  blad_nn_1 : N ;
  bladbagge_nn_1 : N ;
  bladfot_nn_1 : N ;
  bladfoting_nn_1 : N ;
  bladkrans_nn_1 : N ;
  bladlus_nn_1 : N ;
  bladmage_nn_1 : N ;
  bladminerare_nn_1 : N ;
  bladstaellning_nn_1 : N ;
  bladstekel_nn_1 : N ;
  blaeckfisk_nn_1 : N ;
  blaeckhorn_nn_1 : N ;
  blaeckkoertel_nn_1 : N ;
  blaeckplump_nn_1 : N ;
  blaecksaeck_nn_1 : N ;
  blaecksuddare_nn_1 : N ;
  blaecksvamp_nn_1 : N ;
  blaedderblock_nn_1 : N ;
  blaedderbok_nn_1 : N ;
  blaendare_nn_1 : N ;
  blaende_nn_1 : N ;
  blaendfri_av_1 : A ;
  blaendning_nn_1 : N ;
  blaendskydd_nn_1 : N ;
  blaendverk_nn_1 : N ;
  blaendvit_av_1 : A ;
  blaeng_nn_1 : N ;
  blaenk_nn_1 : N ;
  blaenkare_nn_1 : N ;
  blaenkfyr_nn_1 : N ;
  blaes_nn_1 : N ;
  blaesand_nn_1 : N ;
  blaesbock_nn_1 : N ;
  blaesgaas_nn_1 : N ;
  blaester_nn_1 : N ;
  blaesterroer_nn_1 : N ;
  blaesterugn_nn_1 : N ;
  blam_nn_1 : N ;
  blamage_nn_1 : N ;
  blamant_av_1 : A ;
  blancmange_nn_1 : N ;
  blandaektenskap_nn_1 : N ;
  blandare_nn_1 : N ;
  blandekonomi_nn_1 : N ;
  blandfaerg_nn_1 : N ;
  blandform_nn_1 : N ;
  blandning_nn_1 : N ;
  blandningsfoerhaallande_nn_1 : N ;
  blandningskran_nn_1 : N ;
  blandras_nn_1 : N ;
  blandskog_nn_1 : N ;
  blandspraak_nn_1 : N ;
  blandtyp_nn_1 : N ;
  blank_av_1 : A ;
  blankaal_nn_1 : N ;
  blankborste_nn_1 : N ;
  blankett_nn_1 : N ;
  blankettskaap_nn_1 : N ;
  blanklax_nn_1 : N ;
  blankoaccept_nn_1 : N ;
  blankocheck_nn_1 : N ;
  blankofoersaeljning_nn_1 : N ;
  blankofullmakt_nn_1 : N ;
  blankokredit_nn_1 : N ;
  blankotransport_nn_1 : N ;
  blankovaexel_nn_1 : N ;
  blanksej_nn_1 : N ;
  blanksliten_av_1 : A ;
  blanksmoerja_nn_1 : N ;
  blankvatten_nn_1 : N ;
  blase_av_1 : A ;
  blasfemi_nn_1 : N ;
  blasfemisk_av_1 : A ;
  blaskig_av_1 : A ;
  blasonering_nn_1 : N ;
  blatte_nn_1 : N ;
  blazer_nn_1 : N ;
  bleck_nn_1 : N ;
  bleckblaasinstrument_nn_1 : N ;
  bleckburk_nn_1 : N ;
  bleckplaat_nn_1 : N ;
  bleckslagare_nn_1 : N ;
  bleckslageri_nn_1 : N ;
  blek_av_1 : A ;
  blekeri_nn_1 : N ;
  blekfet_av_1 : A ;
  blekhet_nn_1 : N ;
  bleking_nn_1 : N ;
  blekingsk_av_1 : A ;
  bleklagd_av_1 : A ;
  blekmedel_nn_1 : N ;
  bleknos_nn_1 : N ;
  bleksiktig_av_1 : A ;
  blekvaetska_nn_1 : N ;
  blessyr_nn_1 : N ;
  blick_nn_1 : N ;
  blickfaang_nn_1 : N ;
  blickfaelt_nn_1 : N ;
  blickstilla_av_1 : A ;
  blid_av_1 : A ;
  blidgrad_nn_1 : N ;
  blidvinter_nn_1 : N ;
  blind_av_1 : A ;
  blindalfabet_nn_1 : N ;
  blindbock_nn_1 : N ;
  blindbotten_nn_1 : N ;
  blindbroms_nn_1 : N ;
  blinddoerr_nn_1 : N ;
  blindering_nn_1 : N ;
  blindfoenster_nn_1 : N ;
  blindgaangare_nn_1 : N ;
  blindhund_nn_1 : N ;
  blindlandning_nn_1 : N ;
  blindnaessla_nn_1 : N ;
  blindparti_nn_1 : N ;
  blindpassagerare_nn_1 : N ;
  blindpatron_nn_1 : N ;
  blindpressning_nn_1 : N ;
  blindraa_nn_1 : N ;
  blindrote_nn_1 : N ;
  blindskaer_nn_1 : N ;
  blindspaar_nn_1 : N ;
  blindstyre_nn_1 : N ;
  blindtarm_nn_1 : N ;
  blindtarmsinflammation_nn_1 : N ;
  blindtryck_nn_1 : N ;
  blini_nn_1 : N ;
  blink_nn_1 : N ;
  blinker_nn_1 : N ;
  blinkfyr_nn_1 : N ;
  blinkhinna_nn_1 : N ;
  blinkljus_nn_1 : N ;
  blinning_nn_1 : N ;
  blip_nn_1 : N ;
  blivande_av_1 : A ;
  blixt_nn_1 : N ;
  blixtanfall_nn_1 : N ;
  blixtbesoek_nn_1 : N ;
  blixtfoto_nn_1 : N ;
  blixtfyr_nn_1 : N ;
  blixtkrig_nn_1 : N ;
  blixtlaas_nn_1 : N ;
  blixtnedslag_nn_1 : N ;
  blixtpatron_nn_1 : N ;
  blixtrande_av_1 : A ;
  blixtsamtal_nn_1 : N ;
  blixtsnabb_av_1 : A ;
  blixtvisit_nn_1 : N ;
  block_nn_1 : N ;
  blockad_nn_1 : N ;
  blockadbrott_nn_1 : N ;
  blockadbrytare_nn_1 : N ;
  blockaemne_nn_1 : N ;
  blockbildning_nn_1 : N ;
  blockdiagram_nn_1 : N ;
  blockering_nn_1 : N ;
  blockfloejt_nn_1 : N ;
  blockgraens_nn_1 : N ;
  blockhus_nn_1 : N ;
  blockig_av_1 : A ;
  blocksignal_nn_1 : N ;
  blocksystem_nn_1 : N ;
  blocktalja_nn_1 : N ;
  blocktyg_nn_1 : N ;
  blockvagn_nn_1 : N ;
  blodaader_nn_1 : N ;
  blodapelsin_nn_1 : N ;
  blodbad_nn_1 : N ;
  blodbank_nn_1 : N ;
  blodbok_nn_1 : N ;
  blodcell_nn_1 : N ;
  bloddrypande_av_1 : A ;
  blodfaergaemne_nn_1 : N ;
  blodfattig_av_1 : A ;
  blodflaeck_nn_1 : N ;
  blodfloede_nn_1 : N ;
  blodfoergiftning_nn_1 : N ;
  blodfull_av_1 : A ;
  blodgivare_nn_1 : N ;
  blodgrupp_nn_1 : N ;
  blodhund_nn_1 : N ;
  blodig_av_1 : A ;
  blodigel_nn_1 : N ;
  blodkaerl_nn_1 : N ;
  blodkorv_nn_1 : N ;
  blodkraekning_nn_1 : N ;
  blodkropp_nn_1 : N ;
  blodledare_nn_1 : N ;
  blodloes_av_1 : A ;
  blodoern_ab_1 : Adv ;
  blodoeverfoering_nn_1 : N ;
  blodoeverfyllnad_nn_1 : N ;
  blodpalt_nn_1 : N ;
  blodplaett_nn_1 : N ;
  blodpropp_nn_1 : N ;
  blodprotein_nn_1 : N ;
  blodprov_nn_1 : N ;
  blodpudding_nn_1 : N ;
  blodrand_nn_1 : N ;
  blodroed_av_1 : A ;
  blodsband_nn_1 : N ;
  blodsdaad_nn_1 : N ;
  blodsdroppe_nn_1 : N ;
  blodsjukdom_nn_1 : N ;
  blodspenning_nn_1 : N ;
  blodspottning_nn_1 : N ;
  blodspraengd_av_1 : A ;
  blodstaenkt_av_1 : A ;
  blodstillande_av_1 : A ;
  blodstinn_av_1 : A ;
  blodstoertning_nn_1 : N ;
  blodsugande_av_1 : A ;
  blodsugare_nn_1 : N ;
  blodsutgjutelse_nn_1 : N ;
  blodsvulst_nn_1 : N ;
  blodsystem_nn_1 : N ;
  blodtappning_nn_1 : N ;
  blodtoerstig_av_1 : A ;
  blodtransfusion_nn_1 : N ;
  blodtryck_nn_1 : N ;
  blodtyp_nn_1 : N ;
  blodvaerde_nn_1 : N ;
  blodvallning_nn_1 : N ;
  blodvite_nn_1 : N ;
  bloedare_nn_1 : N ;
  bloedig_av_1 : A ;
  bloedighet_nn_1 : N ;
  bloedning_nn_1 : N ;
  bloejbyte_nn_1 : N ;
  bloet_av_1 : A ;
  bloetdjur_nn_1 : N ;
  bloetlaeggningsmedel_nn_1 : N ;
  blogg_nn_1 : N ;
  bloggare_nn_1 : N ;
  blomaxel_nn_1 : N ;
  blombefruktning_nn_1 : N ;
  blomblad_nn_1 : N ;
  blombord_nn_1 : N ;
  blombotten_nn_1 : N ;
  blombukett_nn_1 : N ;
  blomdoft_nn_1 : N ;
  blomfat_nn_1 : N ;
  blomfjaell_nn_1 : N ;
  blomflock_nn_1 : N ;
  blomfoder_nn_1 : N ;
  blomhoelster_nn_1 : N ;
  blomholk_nn_1 : N ;
  blomhuvud_nn_1 : N ;
  blomkaalshuvud_nn_1 : N ;
  blomkaalsoera_nn_1 : N ;
  blomkaalssvamp_nn_1 : N ;
  blomkaepp_nn_1 : N ;
  blomkalk_nn_1 : N ;
  blomklaedd_av_1 : A ;
  blomklase_nn_1 : N ;
  blomknopp_nn_1 : N ;
  blomkolv_nn_1 : N ;
  blomkorg_nn_1 : N ;
  blomkrans_nn_1 : N ;
  blomkvast_nn_1 : N ;
  blommig_av_1 : A ;
  blommogram_nn_1 : N ;
  blomning_nn_1 : N ;
  blomningstid_nn_1 : N ;
  blomskaft_nn_1 : N ;
  blomstaellning_nn_1 : N ;
  blomster_nn_1 : N ;
  blomsteraeng_nn_1 : N ;
  blomsteraffaer_nn_1 : N ;
  blomsterbord_nn_1 : N ;
  blomsterfoermedling_nn_1 : N ;
  blomsterhandel_nn_1 : N ;
  blomsterhandlare_nn_1 : N ;
  blomsterklaedd_av_1 : A ;
  blomsterkvast_nn_1 : N ;
  blomsterloek_nn_1 : N ;
  blomstermaanad_nn_1 : N ;
  blomstertraedgaard_nn_1 : N ;
  blomsteruppsats_nn_1 : N ;
  blomstervas_nn_1 : N ;
  blomstjaelk_nn_1 : N ;
  blomstringstid_nn_1 : N ;
  blomvaext_nn_1 : N ;
  blomvas_nn_1 : N ;
  blond_av_1 : A ;
  blond_nn_1 : N ;
  blondin_nn_1 : N ;
  bloss_nn_1 : N ;
  blot_nn_1 : N ;
  blott_ab_1 : Adv ;
  blottare_nn_1 : N ;
  blottstaelld_av_1 : A ;
  bluff_nn_1 : N ;
  bluffmakare_nn_1 : N ;
  blunder_nn_1 : N ;
  blus_nn_1 : N ;
  blyacetat_nn_1 : N ;
  blyackumulator_nn_1 : N ;
  blyazid_nn_1 : N ;
  blybatteri_nn_1 : N ;
  blydagg_nn_1 : N ;
  blyerts_nn_1 : N ;
  blyfaerg_nn_1 : N ;
  blyfoerening_nn_1 : N ;
  blyfoergiftning_nn_1 : N ;
  blyfolie_nn_1 : N ;
  blyg_av_1 : A ;
  blygdben_nn_1 : N ;
  blygdlaepp_nn_1 : N ;
  blyghet_nn_1 : N ;
  blygraa_av_1 : A ;
  blygsam_av_1 : A ;
  blygsamhet_nn_1 : N ;
  blyhalt_nn_1 : N ;
  blyhaltig_av_1 : A ;
  blykoel_nn_1 : N ;
  blymantel_nn_1 : N ;
  blyoxid_nn_1 : N ;
  blytung_av_1 : A ;
  bo_nn_1 : N ;
  boaegg_nn_1 : N ;
  boaorm_nn_1 : N ;
  boardingcard_nn_1 : N ;
  bob_nn_1 : N ;
  bobin_nn_1 : N ;
  bobsleigh_nn_1 : N ;
  bock_nn_1 : N ;
  bockbent_av_1 : A ;
  bockblad_nn_1 : N ;
  bockbro_nn_1 : N ;
  bockfot_nn_1 : N ;
  bockhorn_nn_1 : N ;
  bockning_nn_1 : N ;
  bockprov_nn_1 : N ;
  bockskaegg_nn_1 : N ;
  bod_nn_1 : N ;
  bodbetjaent_nn_1 : N ;
  bodelning_nn_1 : N ;
  bodknodd_nn_1 : N ;
  bodmeri_nn_1 : N ;
  boeckling_nn_1 : N ;
  boedel_nn_1 : N ;
  boedelsdraeng_nn_1 : N ;
  boeg_nn_1 : N ;
  boehmare_nn_1 : N ;
  boehmisk_av_1 : A ;
  boej_nn_1 : N ;
  boejare_nn_1 : N ;
  boejarmuskel_nn_1 : N ;
  boejbar_av_1 : A ;
  boejd_av_1 : A ;
  boejelse_nn_1 : N ;
  boejhaallfasthet_nn_1 : N ;
  boejlig_av_1 : A ;
  boejmuskel_nn_1 : N ;
  boejning_nn_1 : N ;
  boejningsaendelse_nn_1 : N ;
  boejningsform_nn_1 : N ;
  boejningsmoenster_nn_1 : N ;
  boejprov_nn_1 : N ;
  boekig_av_1 : A ;
  boeld_nn_1 : N ;
  boelja_nn_1 : N ;
  boeljegaang_nn_1 : N ;
  boeljeslag_nn_1 : N ;
  boeljeslagsmaerke_nn_1 : N ;
  boen_nn_1 : N ;
  boenbok_nn_1 : N ;
  boendag_nn_1 : N ;
  boende_nn_1 : N ;
  boende_nn_2 : N ;
  boendeform_nn_1 : N ;
  boendekostnad_nn_1 : N ;
  boenegudstjaenst_nn_1 : N ;
  boenehus_nn_1 : N ;
  boeneman_nn_1 : N ;
  boenemoete_nn_1 : N ;
  boeneskrift_nn_1 : N ;
  boenfalla_vb_1 : V ;
  boenformig_av_1 : A ;
  boenhas_nn_1 : N ;
  boenhoerelse_nn_1 : N ;
  boenpall_nn_1 : N ;
  boenvaext_nn_1 : N ;
  boer_nn_1 : N ;
  boerda_nn_1 : N ;
  boerdig_av_1 : A ;
  boerdsstolt_av_1 : A ;
  boers_nn_1 : N ;
  boers_nn_2 : N ;
  boersjobbare_nn_1 : N ;
  boerskurs_nn_1 : N ;
  boersmaeklare_nn_1 : N ;
  boersnotering_nn_1 : N ;
  boersspekulant_nn_1 : N ;
  boersspekulation_nn_1 : N ;
  boerting_nn_1 : N ;
  boesshaall_nn_1 : N ;
  boessinsamling_nn_1 : N ;
  boett_nn_1 : N ;
  boevel_nn_1 : N ;
  bofaellig_av_1 : A ;
  bofast_av_1 : A ;
  bofink_nn_1 : N ;
  bog_nn_1 : N ;
  bogankare_nn_1 : N ;
  bogblad_nn_1 : N ;
  bogbruten_av_1 : A ;
  boggi_nn_1 : N ;
  boghalt_av_1 : A ;
  boghoejd_nn_1 : N ;
  bogserare_nn_1 : N ;
  bogserbaat_nn_1 : N ;
  bogsergalge_nn_1 : N ;
  bogsering_nn_1 : N ;
  bogserslaep_nn_1 : N ;
  bogsertross_nn_1 : N ;
  bogsproet_nn_1 : N ;
  bohag_nn_1 : N ;
  bohem_nn_1 : N ;
  bohemisk_av_1 : A ;
  bohuslaenning_nn_1 : N ;
  bohuslaensk_av_1 : A ;
  boj_nn_1 : N ;
  boj_nn_2 : N ;
  bojar_nn_1 : N ;
  bojkott_nn_1 : N ;
  bok_nn_1 : N ;
  bok_nn_2 : N ;
  bokanmaelan_nn_1 : N ;
  bokauktion_nn_1 : N ;
  bokband_nn_1 : N ;
  bokbindare_nn_1 : N ;
  bokbinderi_nn_1 : N ;
  bokbindning_nn_1 : N ;
  bokbuss_nn_1 : N ;
  boken_av_1 : A ;
  bokfilm_nn_1 : N ;
  bokflod_nn_1 : N ;
  bokfoering_nn_1 : N ;
  bokfoeringsaar_nn_1 : N ;
  bokfoeringsmaessig_av_1 : A ;
  bokfoeringsskyldig_av_1 : A ;
  bokfoeringsskyldighet_nn_1 : N ;
  bokfoerlaeggare_nn_1 : N ;
  bokfoerlag_nn_1 : N ;
  bokformat_nn_1 : N ;
  bokhaallare_nn_1 : N ;
  bokhandel_nn_1 : N ;
  bokhandlare_nn_1 : N ;
  bokklubb_nn_1 : N ;
  boklaan_nn_1 : N ;
  boklaerd_av_1 : A ;
  boklig_av_1 : A ;
  bokmaerke_nn_1 : N ;
  bokmagasin_nn_1 : N ;
  bokmal_nn_1 : N ;
  bokmarknad_nn_1 : N ;
  bokollon_nn_1 : N ;
  bokomslag_nn_1 : N ;
  bokrulle_nn_1 : N ;
  bokrygg_nn_1 : N ;
  boksamlare_nn_1 : N ;
  boksamling_nn_1 : N ;
  boksida_nn_1 : N ;
  bokskog_nn_1 : N ;
  bokslut_nn_1 : N ;
  bokstav_nn_1 : N ;
  bokstavlig_av_1 : A ;
  bokstavligen_ab_1 : Adv ;
  bokstavsbeteckning_nn_1 : N ;
  bokstavsfoeljd_nn_1 : N ;
  bokstavsordning_nn_1 : N ;
  bokstavsrim_nn_1 : N ;
  bokstavstecken_nn_1 : N ;
  bokstavstrael_nn_1 : N ;
  bokstavstrogen_av_1 : A ;
  bokstipendium_nn_1 : N ;
  bokstoed_nn_1 : N ;
  boksynt_av_1 : A ;
  boktitel_nn_1 : N ;
  boktorn_nn_1 : N ;
  boktryckare_nn_1 : N ;
  boktryckeri_nn_1 : N ;
  boktrycksstil_nn_1 : N ;
  bokverk_nn_1 : N ;
  bol_nn_1 : N ;
  bolag_nn_1 : N ;
  bolagsman_nn_1 : N ;
  bolagsordning_nn_1 : N ;
  bolagsskog_nn_1 : N ;
  bolagsstaemma_nn_1 : N ;
  bolagsstyrelse_nn_1 : N ;
  bolare_nn_1 : N ;
  bolero_nn_1 : N ;
  bolin_nn_1 : N ;
  bolivian_nn_1 : N ;
  boliviansk_av_1 : A ;
  boll_nn_1 : N ;
  bollkalle_nn_1 : N ;
  bollning_nn_1 : N ;
  bollplan_nn_1 : N ;
  bollpojke_nn_1 : N ;
  bollspel_nn_1 : N ;
  bollspelare_nn_1 : N ;
  bolltrae_nn_1 : N ;
  bolmoertsskivling_nn_1 : N ;
  bolsjevik_nn_1 : N ;
  bolsjevistisk_av_1 : A ;
  bolster_nn_1 : N ;
  bolsterstock_nn_1 : N ;
  bolstervagn_nn_1 : N ;
  bolstervar_nn_1 : N ;
  bom_nn_1 : N ;
  bomaerke_nn_1 : N ;
  bomaterial_nn_1 : N ;
  bomb_nn_1 : N ;
  bombanfall_nn_1 : N ;
  bombardemang_nn_1 : N ;
  bombare_nn_1 : N ;
  bombasm_nn_1 : N ;
  bombastisk_av_1 : A ;
  bombattentat_nn_1 : N ;
  bombering_nn_1 : N ;
  bombfast_av_1 : A ;
  bombkrater_nn_1 : N ;
  bombnedslag_nn_1 : N ;
  bombning_nn_1 : N ;
  bomboffer_nn_1 : N ;
  bombplan_nn_1 : N ;
  bombraed_nn_1 : N ;
  bombsaeker_av_1 : A ;
  bomsadel_nn_1 : N ;
  bomsegel_nn_1 : N ;
  bomullsbal_nn_1 : N ;
  bomullsband_nn_1 : N ;
  bomullsbuske_nn_1 : N ;
  bomullsflanell_nn_1 : N ;
  bomullsfroe_nn_1 : N ;
  bomullsplantage_nn_1 : N ;
  bomullstyg_nn_1 : N ;
  bomullsvaevnad_nn_1 : N ;
  bomullsvaext_nn_1 : N ;
  bonad_nn_1 : N ;
  bonbonjaer_nn_1 : N ;
  bonddraeng_nn_1 : N ;
  bonddryg_av_1 : A ;
  bonde_nn_1 : N ;
  bondearme_nn_1 : N ;
  bondebefolkning_nn_1 : N ;
  bondefred_nn_1 : N ;
  bondehaer_nn_1 : N ;
  bondehemman_nn_1 : N ;
  bondekultur_nn_1 : N ;
  bondeskog_nn_1 : N ;
  bondetaag_nn_1 : N ;
  bondfaangare_nn_1 : N ;
  bondfamilj_nn_1 : N ;
  bondfoersoek_nn_1 : N ;
  bondgaard_nn_1 : N ;
  bondhustru_nn_1 : N ;
  bondkomiker_nn_1 : N ;
  bondpermission_nn_1 : N ;
  bondsk_av_1 : A ;
  bondslug_av_1 : A ;
  bong_nn_1 : N ;
  boning_nn_1 : N ;
  boningshus_nn_1 : N ;
  bonitering_nn_1 : N ;
  bonitet_nn_1 : N ;
  bonjour_nn_1 : N ;
  bonmot_nn_1 : N ;
  bonnett_nn_1 : N ;
  bonus_nn_1 : N ;
  bonusklass_nn_1 : N ;
  bookmaker_nn_1 : N ;
  boom_nn_1 : N ;
  boplats_nn_1 : N ;
  boplatsgraevning_nn_1 : N ;
  bord_nn_1 : N ;
  borddans_nn_1 : N ;
  bordduk_nn_1 : N ;
  bordeaux_nn_1 : N ;
  bordell_nn_1 : N ;
  bordhyvel_nn_1 : N ;
  bordlaeggning_nn_1 : N ;
  bordlaeggningsplenum_nn_1 : N ;
  bordloepare_nn_1 : N ;
  bordsamtal_nn_1 : N ;
  bordsben_nn_1 : N ;
  bordsbestaellning_nn_1 : N ;
  bordsboen_nn_1 : N ;
  bordsdam_nn_1 : N ;
  bordsdryck_nn_1 : N ;
  bordservis_nn_1 : N ;
  bordsfilt_nn_1 : N ;
  bordskant_nn_1 : N ;
  bordskavaljer_nn_1 : N ;
  bordskick_nn_1 : N ;
  bordskniv_nn_1 : N ;
  bordsmargarin_nn_1 : N ;
  bordssamtal_nn_1 : N ;
  bordsservis_nn_1 : N ;
  bordsskick_nn_1 : N ;
  bordsstaell_nn_1 : N ;
  bordsstudsare_nn_1 : N ;
  bordstudsare_nn_1 : N ;
  bordsuppsats_nn_1 : N ;
  bordsvatten_nn_1 : N ;
  bordtennisracket_nn_1 : N ;
  bordvarts_ab_1 : Adv ;
  boreal_av_1 : A ;
  boren_av_1 : A ;
  borg_nn_1 : N ;
  borgarbevaepning_nn_1 : N ;
  borgarbrev_nn_1 : N ;
  borgardoeme_nn_1 : N ;
  borgare_nn_1 : N ;
  borgargarde_nn_1 : N ;
  borgarklass_nn_1 : N ;
  borgarraad_nn_1 : N ;
  borgenaer_nn_1 : N ;
  borgenaersed_nn_1 : N ;
  borgensaatagande_nn_1 : N ;
  borgensfoerbindelse_nn_1 : N ;
  borgenslaan_nn_1 : N ;
  borgensman_nn_1 : N ;
  borgenssumma_nn_1 : N ;
  borgerlig_av_1 : A ;
  borgerlighet_nn_1 : N ;
  borgerskap_nn_1 : N ;
  borgfred_nn_1 : N ;
  borggaard_nn_1 : N ;
  borgmaestare_nn_1 : N ;
  borkarbid_nn_1 : N ;
  borr_nn_1 : N ;
  borrchuck_nn_1 : N ;
  borrhaal_nn_1 : N ;
  borrhaalsvaegg_nn_1 : N ;
  borrjigg_nn_1 : N ;
  borrmaskin_nn_1 : N ;
  borrmussla_nn_1 : N ;
  borrning_nn_1 : N ;
  borrplattform_nn_1 : N ;
  borrspaan_nn_1 : N ;
  borrspindel_nn_1 : N ;
  borrstaal_nn_1 : N ;
  borrsvaeng_nn_1 : N ;
  borrtorn_nn_1 : N ;
  borst_nn_1 : N ;
  borstbindare_nn_1 : N ;
  borstbinderi_nn_1 : N ;
  borste_nn_1 : N ;
  borstgarnityr_nn_1 : N ;
  borstgraes_nn_1 : N ;
  borstig_av_1 : A ;
  borstmask_nn_1 : N ;
  borstsvans_nn_1 : N ;
  borstviskare_nn_1 : N ;
  bort_ab_1 : Adv ;
  borta_ab_1 : Adv ;
  bortaat_ab_1 : Adv ;
  bortafoersaekring_nn_1 : N ;
  bortalag_nn_1 : N ;
  bortamatch_nn_1 : N ;
  bortanfoer_ab_1 : Adv ;
  bortaplan_nn_1 : N ;
  bortaseger_nn_1 : N ;
  bortbjuden_av_1 : A ;
  bortblaast_av_1 : A ;
  bortbyting_nn_1 : N ;
  bortdoeende_av_1 : A ;
  bortdoemning_nn_1 : N ;
  bortdriva_vb_1 : V ;
  bortemot_ab_1 : Adv ;
  bortfall_nn_1 : N ;
  bortfalla_vb_1 : V ;
  bortfoerklaring_nn_1 : N ;
  bortgaa_vb_1 : V ;
  bortgloemd_av_1 : A ;
  bortifraan_ab_1 : Adv ;
  bortigenom_ab_1 : Adv ;
  bortkommen_av_1 : A ;
  bortoever_ab_1 : Adv ;
  bortom_ab_1 : Adv ;
  bortrationalisering_nn_1 : N ;
  bortrest_av_1 : A ;
  bortrinna_vb_1 : V ;
  bortsaettning_nn_1 : N ;
  bortskaemd_av_1 : A ;
  bortskrivning_nn_1 : N ;
  bortsluta_vb_1 : V ;
  bortsprungen_av_1 : A ;
  bortstoetning_nn_1 : N ;
  bortta_vb_1 : V ;
  borttraengning_nn_1 : N ;
  bosaettning_nn_1 : N ;
  bosaettningsaffaer_nn_1 : N ;
  bosaettningslaan_nn_1 : N ;
  bosaettningsort_nn_1 : N ;
  bosatt_av_1 : A ;
  boskapshjord_nn_1 : N ;
  boskapsskoetande_av_1 : A ;
  boskapsskoetare_nn_1 : N ;
  boskapsstaengsel_nn_1 : N ;
  boskapsstock_nn_1 : N ;
  boskifte_nn_1 : N ;
  boskillnad_nn_1 : N ;
  bosnier_nn_1 : N ;
  bosnisk_av_1 : A ;
  boss_nn_1 : N ;
  bossig_av_1 : A ;
  bostad_nn_1 : N ;
  bostadsadress_nn_1 : N ;
  bostadsband_nn_1 : N ;
  bostadsbidrag_nn_1 : N ;
  bostadsbyggande_nn_1 : N ;
  bostadsfoerbaettringslaan_nn_1 : N ;
  bostadsfoeretag_nn_1 : N ;
  bostadsfoermedling_nn_1 : N ;
  bostadshus_nn_1 : N ;
  bostadskoe_nn_1 : N ;
  bostadskooperation_nn_1 : N ;
  bostadskredit_nn_1 : N ;
  bostadslaan_nn_1 : N ;
  bostadslaegenhet_nn_1 : N ;
  bostadsloes_av_1 : A ;
  bostadsmarknad_nn_1 : N ;
  bostadsmiljoe_nn_1 : N ;
  bostadsnaemnd_nn_1 : N ;
  bostadsomraade_nn_1 : N ;
  bostadspolitisk_av_1 : A ;
  bostadsraett_nn_1 : N ;
  bostadsraettsfoerening_nn_1 : N ;
  bostadssoekande_nn_1 : N ;
  bostadsstyrelse_nn_1 : N ;
  bostadstillaegg_nn_1 : N ;
  bostonvals_nn_1 : N ;
  bot_nn_2 : N ;
  botaniker_nn_1 : N ;
  botanikspade_nn_1 : N ;
  botanisk_av_1 : A ;
  botanist_nn_1 : N ;
  botanistspade_nn_1 : N ;
  botdag_nn_1 : N ;
  botemedel_nn_1 : N ;
  botfaerdig_av_1 : A ;
  botgoerare_nn_1 : N ;
  botgoerelse_nn_1 : N ;
  botgoering_nn_1 : N ;
  botlig_av_1 : A ;
  botswanier_nn_1 : N ;
  botswansk_av_1 : A ;
  botten_nn_1 : N ;
  bottenavlagring_nn_1 : N ;
  bottenbjaelke_nn_1 : N ;
  bottendaalig_av_1 : A ;
  bottendjur_nn_1 : N ;
  bottenfaellning_nn_1 : N ;
  bottenfaerg_nn_1 : N ;
  bottenfast_av_1 : A ;
  bottenfock_nn_1 : N ;
  bottengarn_nn_1 : N ;
  bottenhederlig_av_1 : A ;
  bottenkaenning_nn_1 : N ;
  bottenkran_nn_1 : N ;
  bottenkurs_nn_1 : N ;
  bottenlaan_nn_1 : N ;
  bottenlaege_nn_1 : N ;
  bottenlag_nn_1 : N ;
  bottenlevande_av_1 : A ;
  bottenloes_av_1 : A ;
  bottennapp_nn_1 : N ;
  bottenplan_nn_1 : N ;
  bottenrekord_nn_1 : N ;
  bottenrev_nn_1 : N ;
  bottensats_nn_1 : N ;
  bottensediment_nn_1 : N ;
  bottenskikt_nn_1 : N ;
  bottenskvaett_nn_1 : N ;
  bottenstock_nn_1 : N ;
  bottenvaaning_nn_1 : N ;
  bottenvatten_nn_1 : N ;
  bottenventil_nn_1 : N ;
  bottin_nn_1 : N ;
  bottnisk_av_1 : A ;
  boudoir_nn_1 : N ;
  boulevard_nn_1 : N ;
  bouppteckning_nn_1 : N ;
  bouquet_nn_1 : N ;
  bourgogne_nn_1 : N ;
  boutique_nn_1 : N ;
  boutredning_nn_1 : N ;
  bouzouki_nn_1 : N ;
  bov_nn_1 : N ;
  bovaktig_av_1 : A ;
  boveteplaett_nn_1 : N ;
  bovfysionomi_nn_1 : N ;
  bovstreck_nn_1 : N ;
  bowlare_nn_1 : N ;
  bowlinghall_nn_1 : N ;
  bowlingklot_nn_1 : N ;
  box_nn_1 : N ;
  boxare_nn_1 : N ;
  boxboll_nn_1 : N ;
  boxer_nn_1 : N ;
  boxhandske_nn_1 : N ;
  boxning_nn_1 : N ;
  boxningsmatch_nn_1 : N ;
  boxningsring_nn_1 : N ;
  boxningstraening_nn_1 : N ;
  boyscout_nn_1 : N ;
  bra_ab_1 : Adv ;
  bra_av_1 : A ;
  braack_nn_1 : N ;
  braackband_nn_1 : N ;
  braad_av_1 : A ;
  braaddjup_av_1 : A ;
  braadis_ab_1 : Adv ;
  braadmogen_av_1 : A ;
  braadskande_av_1 : A ;
  braak_nn_1 : N ;
  braakdel_nn_1 : N ;
  braakig_av_1 : A ;
  braakmakare_nn_1 : N ;
  braakstake_nn_1 : N ;
  braakstreck_nn_1 : N ;
  braaktal_nn_1 : N ;
  braanad_nn_1 : N ;
  braattom_ab_1 : Adv ;
  brackig_av_1 : A ;
  braeckhammare_nn_1 : N ;
  braeckjaern_nn_1 : N ;
  braeckkorv_nn_1 : N ;
  braecklig_av_1 : A ;
  braeckt_av_1 : A ;
  braeckvatten_nn_1 : N ;
  braeda_nn_1 : N ;
  braedd_nn_1 : N ;
  braeddavlopp_nn_1 : N ;
  braeddfull_av_1 : A ;
  braeddfylld_av_1 : A ;
  braedgaang_nn_1 : N ;
  braedgaard_nn_1 : N ;
  braedspel_nn_1 : N ;
  braekande_nn_1 : N ;
  braeken_nn_1 : N ;
  braem_nn_1 : N ;
  braennaessla_nn_1 : N ;
  braennande_av_1 : A ;
  braennare_nn_1 : N ;
  braennbar_av_1 : A ;
  braenneri_nn_1 : N ;
  braennglas_nn_1 : N ;
  braennhaar_nn_1 : N ;
  braennhet_av_1 : A ;
  braenning_nn_1 : N ;
  braennjaern_nn_1 : N ;
  braennkammare_nn_1 : N ;
  braennmaerke_nn_1 : N ;
  braennmanet_nn_1 : N ;
  braennoffer_nn_1 : N ;
  braennpunkt_nn_1 : N ;
  braennsaar_nn_1 : N ;
  braennvidd_nn_1 : N ;
  braennvin_nn_1 : N ;
  braennvinsadvokat_nn_1 : N ;
  braennvinsbas_nn_1 : N ;
  braennvinsbraenneri_nn_1 : N ;
  braennvinsglas_nn_1 : N ;
  braennvinsprovare_nn_1 : N ;
  braenslecell_nn_1 : N ;
  braenslecellsdriven_av_1 : A ;
  braenslecellskonstruktion_nn_1 : N ;
  braenslecellskraftverk_nn_1 : N ;
  braenslecellstyp_nn_1 : N ;
  braensleelement_nn_1 : N ;
  braenslefaelt_nn_1 : N ;
  braenslefoerraad_nn_1 : N ;
  braenslegas_nn_1 : N ;
  braenslekanal_nn_1 : N ;
  braenslemaetare_nn_1 : N ;
  braensleomvandlare_nn_1 : N ;
  braenslesnaal_av_1 : A ;
  braenslestav_nn_1 : N ;
  braensletank_nn_1 : N ;
  braensletillaegg_nn_1 : N ;
  braesch_nn_1 : N ;
  bragd_nn_1 : N ;
  brageloefte_nn_1 : N ;
  brakfest_nn_1 : N ;
  brakmiddag_nn_1 : N ;
  brakskit_nn_1 : N ;
  braksucce_nn_1 : N ;
  brakteat_nn_1 : N ;
  brakycefal_av_1 : A ;
  brallis_nn_1 : N ;
  braman_nn_1 : N ;
  bramansk_av_1 : A ;
  bramin_nn_1 : N ;
  bramsegel_nn_1 : N ;
  bramstaang_nn_1 : N ;
  brand_nn_1 : N ;
  brandalarm_nn_1 : N ;
  brandartikel_nn_1 : N ;
  brandbefael_nn_1 : N ;
  brandbil_nn_1 : N ;
  brandbomb_nn_1 : N ;
  brandbotten_nn_1 : N ;
  brandchef_nn_1 : N ;
  branddike_nn_1 : N ;
  branddoerr_nn_1 : N ;
  brandfackla_nn_1 : N ;
  brandfarlig_av_1 : A ;
  brandfoersaekringsbolag_nn_1 : N ;
  brandgavel_nn_1 : N ;
  brandgrav_nn_1 : N ;
  brandgul_av_1 : A ;
  brandhaerd_nn_1 : N ;
  brandhaerdig_av_1 : A ;
  brandingenjoer_nn_1 : N ;
  brandinspektion_nn_1 : N ;
  brandinspektoer_nn_1 : N ;
  brandkaar_nn_1 : N ;
  brandkaarsutryckning_nn_1 : N ;
  brandkapten_nn_1 : N ;
  brandlager_nn_1 : N ;
  brandlarm_nn_1 : N ;
  brandman_nn_1 : N ;
  brandmur_nn_1 : N ;
  brandorsak_nn_1 : N ;
  brandpost_nn_1 : N ;
  brandredskap_nn_1 : N ;
  brandrest_nn_1 : N ;
  brandroer_nn_1 : N ;
  brandsaeker_av_1 : A ;
  brandsegel_nn_1 : N ;
  brandskaap_nn_1 : N ;
  brandslaeckare_nn_1 : N ;
  brandslang_nn_1 : N ;
  brandsoldat_nn_1 : N ;
  brandstation_nn_1 : N ;
  brandstege_nn_1 : N ;
  brandstodsbolag_nn_1 : N ;
  brandstyrka_nn_1 : N ;
  brandsvamp_nn_1 : N ;
  brandsyn_nn_1 : N ;
  brandtal_nn_1 : N ;
  brandtorn_nn_1 : N ;
  brandvakt_ab_1 : Adv ;
  brandvakt_nn_1 : N ;
  brandvarnare_nn_1 : N ;
  bransch_nn_1 : N ;
  branschfoerening_nn_1 : N ;
  branschraad_nn_1 : N ;
  brant_av_1 : A ;
  brant_nn_1 : N ;
  brasilian_nn_1 : N ;
  brasilianare_nn_1 : N ;
  brasiliansk_av_1 : A ;
  braskande_av_1 : A ;
  brasklapp_nn_1 : N ;
  brastaendare_nn_1 : N ;
  bravad_nn_1 : N ;
  bravurnummer_nn_1 : N ;
  bravurroll_nn_1 : N ;
  braxen_nn_1 : N ;
  break_nn_1 : N ;
  bred_av_1 : A ;
  bredbar_av_1 : A ;
  bredbent_av_1 : A ;
  bredbladig_av_1 : A ;
  bredbraettig_av_1 : A ;
  bredd_nn_1 : N ;
  breddgrad_nn_1 : N ;
  breddidrott_nn_1 : N ;
  breddning_nn_1 : N ;
  bredmun_nn_1 : N ;
  bredmynt_av_1 : A ;
  bredrandig_av_1 : A ;
  bredsida_nn_1 : N ;
  bredskyggig_av_1 : A ;
  bredspaarig_av_1 : A ;
  bredvid_ab_1 : Adv ;
  bretagnare_nn_1 : N ;
  bretagnisk_av_1 : A ;
  bretagniska_nn_2 : N ;
  breton_nn_1 : N ;
  bretonsk_av_1 : A ;
  bretonska_nn_2 : N ;
  brev_nn_1 : N ;
  brevbaerare_nn_1 : N ;
  brevbomb_nn_1 : N ;
  brevfack_nn_1 : N ;
  brevfoersaendelse_nn_1 : N ;
  brevfraaga_nn_1 : N ;
  brevhemlighet_nn_1 : N ;
  brevhuvud_nn_1 : N ;
  breviarium_nn_1 : N ;
  brevinkast_nn_1 : N ;
  brevkort_nn_1 : N ;
  brevlaadefoeretag_nn_1 : N ;
  brevledes_ab_1 : Adv ;
  brevoeppnare_nn_1 : N ;
  brevpapper_nn_1 : N ;
  brevporto_nn_1 : N ;
  brevpress_nn_1 : N ;
  brevroman_nn_1 : N ;
  brevskoerd_nn_1 : N ;
  brevskrivare_nn_1 : N ;
  brevstaell_nn_1 : N ;
  brevstaellare_nn_1 : N ;
  brevsvar_nn_1 : N ;
  brevtelegram_nn_1 : N ;
  brevvaag_nn_1 : N ;
  brevvaen_nn_1 : N ;
  brevvaexling_nn_1 : N ;
  brickband_nn_1 : N ;
  brickbord_nn_1 : N ;
  brickduk_nn_1 : N ;
  bricklunch_nn_1 : N ;
  brickplockare_nn_1 : N ;
  brickvaevd_av_1 : A ;
  bridgebord_nn_1 : N ;
  bridong_nn_1 : N ;
  bridreaktor_nn_1 : N ;
  brigad_nn_1 : N ;
  brigadgeneral_nn_1 : N ;
  brigadoer_nn_1 : N ;
  brigantin_nn_1 : N ;
  brigg_nn_1 : N ;
  briggsegel_nn_1 : N ;
  brikett_nn_1 : N ;
  brikettpress_nn_1 : N ;
  brikollstoet_nn_1 : N ;
  briljant_av_1 : A ;
  briljant_nn_1 : N ;
  brink_nn_1 : N ;
  brinna_vb_1 : V ;
  brinnande_av_1 : A ;
  bris_nn_1 : N ;
  brisad_nn_1 : N ;
  brisans_nn_1 : N ;
  brisansgranat_nn_1 : N ;
  brisant_av_1 : A ;
  brisant_nn_1 : N ;
  brisken_av_1 : A ;
  brissling_nn_1 : N ;
  brist_nn_1 : N ;
  brista_vb_1 : V ;
  bristande_av_1 : A ;
  bristfaellig_av_1 : A ;
  bristlaege_nn_1 : N ;
  bristning_nn_1 : N ;
  bristsituation_nn_1 : N ;
  bristsjukdom_nn_1 : N ;
  bristyrke_nn_1 : N ;
  britannisk_av_1 : A ;
  brits_nn_1 : N ;
  britt_nn_1 : N ;
  brittisk_av_1 : A ;
  brittsommar_nn_1 : N ;
  bro_nn_1 : N ;
  broavgift_nn_1 : N ;
  brobaenk_nn_1 : N ;
  brobelastning_nn_1 : N ;
  brock_nn_1 : N ;
  brock_nn_2 : N ;
  brockband_nn_1 : N ;
  brockfaagel_nn_1 : N ;
  brodd_nn_1 : N ;
  broder_nn_1 : N ;
  broderbaage_nn_1 : N ;
  broderbok_nn_1 : N ;
  broderfolk_nn_1 : N ;
  broderi_nn_1 : N ;
  brodering_nn_1 : N ;
  broderlig_av_1 : A ;
  brodernaal_nn_1 : N ;
  brodersax_nn_1 : N ;
  broderskaerlek_nn_1 : N ;
  broderskap_nn_1 : N ;
  brodersoem_nn_1 : N ;
  brodyr_nn_1 : N ;
  broed_nn_1 : N ;
  broedbagge_nn_1 : N ;
  broedbak_nn_1 : N ;
  broedbit_nn_1 : N ;
  broedburk_nn_1 : N ;
  broedfat_nn_1 : N ;
  broedfrukt_nn_1 : N ;
  broeding_nn_1 : N ;
  broedkant_nn_1 : N ;
  broedkavel_nn_1 : N ;
  broedkniv_nn_1 : N ;
  broedkorg_nn_1 : N ;
  broedloes_av_1 : A ;
  broednagg_nn_1 : N ;
  broedpudding_nn_1 : N ;
  broedrafolk_nn_1 : N ;
  broedrapar_nn_1 : N ;
  broedraskap_nn_1 : N ;
  broedrost_nn_1 : N ;
  broedsbrytelse_nn_1 : N ;
  broedskriveri_nn_1 : N ;
  broedspade_nn_1 : N ;
  broel_nn_1 : N ;
  broellop_nn_1 : N ;
  broellopsdag_nn_1 : N ;
  broellopsfoto_nn_1 : N ;
  broellopsgaest_nn_1 : N ;
  broellopsmarsch_nn_1 : N ;
  broellopsnatt_nn_1 : N ;
  broellopspar_nn_1 : N ;
  broellopsvittne_nn_1 : N ;
  broest_nn_1 : N ;
  broestarv_nn_1 : N ;
  broestarvinge_nn_1 : N ;
  broestbarn_nn_1 : N ;
  broestben_nn_1 : N ;
  broestbild_nn_1 : N ;
  broestboeld_nn_1 : N ;
  broestcancer_nn_1 : N ;
  broestgaang_nn_1 : N ;
  broestgaenges_ab_1 : Adv ;
  broestkaramell_nn_1 : N ;
  broestkatarr_nn_1 : N ;
  broestkoertel_nn_1 : N ;
  broestkorg_nn_1 : N ;
  broestlapp_nn_1 : N ;
  broestmaatt_nn_1 : N ;
  broestmur_nn_1 : N ;
  broestmuskel_nn_1 : N ;
  broestning_nn_1 : N ;
  broestparti_nn_1 : N ;
  broestpump_nn_1 : N ;
  broestregister_nn_1 : N ;
  broestsimmare_nn_1 : N ;
  broestskydd_nn_1 : N ;
  broestton_nn_1 : N ;
  broestvaern_nn_1 : N ;
  broestvidd_nn_1 : N ;
  broet_nn_1 : N ;
  broethake_nn_1 : N ;
  broetling_nn_1 : N ;
  brohuvud_nn_1 : N ;
  broiler_nn_1 : N ;
  brok_nn_1 : N ;
  brokad_nn_1 : N ;
  brokanal_nn_1 : N ;
  brokar_nn_1 : N ;
  brokbladig_av_1 : A ;
  brokblommig_av_1 : A ;
  brokig_av_1 : A ;
  brokspett_nn_1 : N ;
  bromfoergiftning_nn_1 : N ;
  bromid_nn_1 : N ;
  broms_nn_1 : N ;
  bromsare_nn_1 : N ;
  bromsback_nn_1 : N ;
  bromsband_nn_1 : N ;
  bromsbelaegg_nn_1 : N ;
  bromsblock_nn_1 : N ;
  bromscylinder_nn_1 : N ;
  bromsgaller_nn_1 : N ;
  bromsilverpapper_nn_1 : N ;
  bromsklaff_nn_1 : N ;
  bromskloss_nn_1 : N ;
  bromsljus_nn_1 : N ;
  bromsning_nn_1 : N ;
  bromsolja_nn_1 : N ;
  bromspedal_nn_1 : N ;
  bromsraket_nn_1 : N ;
  bromsskaerm_nn_1 : N ;
  bromssko_nn_1 : N ;
  bromsspaar_nn_1 : N ;
  bromssystem_nn_1 : N ;
  bromsvaetska_nn_1 : N ;
  bromsvagn_nn_1 : N ;
  bronkit_nn_1 : N ;
  bronkografi_nn_1 : N ;
  bronkoskop_nn_1 : N ;
  bronkoskopi_nn_1 : N ;
  brons_nn_1 : N ;
  brons_nn_2 : N ;
  bronsaaldersfynd_nn_1 : N ;
  bronsmaerke_nn_1 : N ;
  bronsmedalj_nn_1 : N ;
  bropelare_nn_1 : N ;
  bropeng_nn_1 : N ;
  bropenning_nn_1 : N ;
  brorsarv_nn_1 : N ;
  brorsbarn_nn_1 : N ;
  brorsdotter_nn_1 : N ;
  brorskaal_nn_1 : N ;
  brorslott_nn_1 : N ;
  brorson_nn_1 : N ;
  brorsskaal_nn_1 : N ;
  brosch_nn_1 : N ;
  broschyr_nn_1 : N ;
  brosk_nn_1 : N ;
  broskfisk_nn_1 : N ;
  broskhinna_nn_1 : N ;
  broskskivling_nn_1 : N ;
  brosksvamp_nn_1 : N ;
  broskvaevnad_nn_1 : N ;
  broskverk_nn_1 : N ;
  broslagning_nn_1 : N ;
  brosme_nn_1 : N ;
  brospann_nn_1 : N ;
  brotsch_nn_1 : N ;
  brott_nn_1 : N ;
  brottare_nn_1 : N ;
  brottmaal_nn_1 : N ;
  brottning_nn_1 : N ;
  brottningsgrepp_nn_1 : N ;
  brottningsmatch_nn_1 : N ;
  brottsfoerebyggande_av_1 : A ;
  brottsjoe_nn_1 : N ;
  brottslig_av_1 : A ;
  brottslighet_nn_1 : N ;
  brottsling_nn_1 : N ;
  brottsplats_nn_1 : N ;
  brottsrekvisit_nn_1 : N ;
  brottsrubricering_nn_1 : N ;
  brottstillfaelle_nn_1 : N ;
  brottsutredning_nn_1 : N ;
  brovalv_nn_1 : N ;
  browning_nn_1 : N ;
  bruckel_nn_1 : N ;
  brud_nn_1 : N ;
  brudand_nn_1 : N ;
  brudbukett_nn_1 : N ;
  brudfoto_nn_1 : N ;
  brudgum_nn_1 : N ;
  brudklaenning_nn_1 : N ;
  brudkoep_nn_1 : N ;
  brudnaebb_nn_1 : N ;
  brudpaell_nn_1 : N ;
  brudpall_nn_1 : N ;
  brudpar_nn_1 : N ;
  brudrov_nn_1 : N ;
  brudsaeng_nn_1 : N ;
  brudsloeja_nn_1 : N ;
  brudsporre_nn_1 : N ;
  brudstol_nn_1 : N ;
  brugd_nn_1 : N ;
  bruk_nn_1 : N ;
  brukare_nn_1 : N ;
  brukbar_av_1 : A ;
  bruklig_av_1 : A ;
  bruklighet_nn_1 : N ;
  brukningsenhet_nn_1 : N ;
  bruksanvisning_nn_1 : N ;
  bruksartikel_nn_1 : N ;
  bruksdisponent_nn_1 : N ;
  bruksdjur_nn_1 : N ;
  bruksfoeremaal_nn_1 : N ;
  brukshund_nn_1 : N ;
  brukslagare_nn_1 : N ;
  brukspatron_nn_1 : N ;
  bruksvaerde_nn_1 : N ;
  brulepudding_nn_1 : N ;
  brumbas_nn_1 : N ;
  brumbjoern_nn_1 : N ;
  brumkoer_nn_1 : N ;
  brummare_nn_1 : N ;
  brun_av_1 : A ;
  brunaktig_av_1 : A ;
  brunalg_nn_1 : N ;
  brunbaer_nn_1 : N ;
  brunbraend_av_1 : A ;
  brunch_nn_1 : N ;
  brunett_av_1 : A ;
  brunhaarig_av_1 : A ;
  brunkol_nn_1 : N ;
  brunn_nn_1 : N ;
  brunnshus_nn_1 : N ;
  brunnskar_nn_1 : N ;
  brunnskur_nn_1 : N ;
  brunnsort_nn_1 : N ;
  brunnssvaengel_nn_1 : N ;
  brunnsvatten_nn_1 : N ;
  brunoegd_av_1 : A ;
  brunoert_nn_1 : N ;
  brunroed_av_1 : A ;
  brunstig_av_1 : A ;
  brunsvart_av_1 : A ;
  brunte_nn_1 : N ;
  brushane_nn_1 : N ;
  brushuvud_nn_1 : N ;
  brustablett_nn_1 : N ;
  brusten_av_1 : A ;
  brutal_av_1 : A ;
  brutalitet_nn_1 : N ;
  brutto_ab_1 : Adv ;
  brutto_nn_1 : N ;
  bruttobehaallning_nn_1 : N ;
  bruttodraektighet_nn_1 : N ;
  bruttoformel_nn_1 : N ;
  bruttoinkomst_nn_1 : N ;
  bruttoloen_nn_1 : N ;
  bruttonationalprodukt_nn_1 : N ;
  bruttopris_nn_1 : N ;
  bruttoregisterton_nn_1 : N ;
  brydd_av_1 : A ;
  bryderi_nn_1 : N ;
  brydsam_av_1 : A ;
  brygd_nn_1 : N ;
  bryggare_nn_1 : N ;
  bryggeri_nn_1 : N ;
  brygghus_nn_1 : N ;
  bryggmald_av_1 : A ;
  bryggmalen_av_1 : A ;
  bryggvaag_nn_1 : N ;
  brylaa_nn_1 : N ;
  brylepudding_nn_1 : N ;
  brylling_nn_1 : N ;
  bryn_nn_1 : N ;
  brynja_nn_1 : N ;
  brynstaal_nn_1 : N ;
  brynsten_nn_1 : N ;
  bryolog_nn_1 : N ;
  brysk_av_1 : A ;
  brysselspets_nn_1 : N ;
  bryta_vb_1 : V ;
  bryte_nn_1 : N ;
  brytning_nn_1 : N ;
  brytningsaar_nn_1 : N ;
  brytningsexponent_nn_1 : N ;
  brytningsfel_nn_1 : N ;
  brytningsindex_nn_1 : N ;
  brytningspunkt_nn_1 : N ;
  brytningstid_nn_1 : N ;
  brytningsvinkel_nn_1 : N ;
  brytpunkt_nn_1 : N ;
  brytvapen_nn_1 : N ;
  bubbelgum_nn_1 : N ;
  bubbelkammare_nn_1 : N ;
  bubbelpool_nn_1 : N ;
  bubbla_nn_1 : N ;
  bubblig_av_1 : A ;
  bubon_nn_1 : N ;
  buckla_nn_1 : N ;
  bucklig_av_1 : A ;
  bud_nn_1 : N ;
  budbaerare_nn_1 : N ;
  budbyraa_nn_1 : N ;
  buddist_nn_1 : N ;
  buddistisk_av_1 : A ;
  budget_nn_1 : N ;
  budgetaar_nn_1 : N ;
  budgetaer_av_1 : A ;
  budgetoeverskott_nn_1 : N ;
  budgetproposition_nn_1 : N ;
  budgetunderskott_nn_1 : N ;
  budgivning_nn_1 : N ;
  budkavel_nn_1 : N ;
  budkavle_nn_1 : N ;
  budoar_nn_1 : N ;
  budord_nn_1 : N ;
  budskap_nn_1 : N ;
  buff_nn_1 : N ;
  buffaopera_nn_1 : N ;
  buffe_nn_1 : N ;
  buffel_nn_1 : N ;
  buffelaktig_av_1 : A ;
  buffelhjord_nn_1 : N ;
  buffert_nn_1 : N ;
  buffertkapacitet_nn_1 : N ;
  buffertlager_nn_1 : N ;
  buffertloesning_nn_1 : N ;
  buffertstat_nn_1 : N ;
  bufflig_av_1 : A ;
  bugning_nn_1 : N ;
  buk_nn_1 : N ;
  bukett_nn_1 : N ;
  bukformig_av_1 : A ;
  bukgjord_nn_1 : N ;
  bukhinna_nn_1 : N ;
  bukhinneinflammation_nn_1 : N ;
  bukig_av_1 : A ;
  bukmuskel_nn_1 : N ;
  bukolisk_av_1 : A ;
  bukspottkoertel_nn_1 : N ;
  bukstinn_av_1 : A ;
  buksvaager_nn_1 : N ;
  bukt_ab_1 : Adv ;
  bukt_nn_1 : N ;
  buktalare_nn_1 : N ;
  buktig_av_1 : A ;
  bukvaegg_nn_1 : N ;
  bulb_nn_1 : N ;
  bulbjaern_nn_1 : N ;
  bulevard_nn_1 : N ;
  bulgar_nn_1 : N ;
  bulgarisk_av_1 : A ;
  bulgariska_nn_2 : N ;
  buljong_nn_1 : N ;
  buljongben_nn_1 : N ;
  buljongtaerning_nn_1 : N ;
  bulkfartyg_nn_1 : N ;
  bulklast_nn_1 : N ;
  bulklastare_nn_1 : N ;
  bulkmedel_nn_1 : N ;
  bulldogg_nn_1 : N ;
  bulldozer_nn_1 : N ;
  bulle_nn_1 : N ;
  buller_nn_1 : N ;
  bullerbas_nn_1 : N ;
  bullerblomster_nn_1 : N ;
  bullersam_av_1 : A ;
  bullersten_nn_1 : N ;
  bulletin_nn_1 : N ;
  bullig_av_1 : A ;
  bullrig_av_1 : A ;
  bulnad_nn_1 : N ;
  bulsig_av_1 : A ;
  bult_nn_1 : N ;
  bultpistol_nn_1 : N ;
  bultsax_nn_1 : N ;
  bulvan_nn_1 : N ;
  bumerang_nn_1 : N ;
  bumling_nn_1 : N ;
  bums_ab_1 : Adv ;
  bunden_av_1 : A ;
  bundsfoervant_nn_1 : N ;
  bungalow_nn_1 : N ;
  bunke_nn_1 : N ;
  bunker_nn_1 : N ;
  bunsenbraennare_nn_1 : N ;
  bunt_nn_1 : N ;
  buntmakare_nn_1 : N ;
  bur_nn_1 : N ;
  burbrev_nn_1 : N ;
  burdus_av_1 : A ;
  burfaagel_nn_1 : N ;
  burgare_nn_1 : N ;
  burgen_av_1 : A ;
  burgunder_nn_1 : N ;
  burk_nn_1 : N ;
  burkoel_nn_1 : N ;
  burkoeppnare_nn_1 : N ;
  burlesk_av_1 : A ;
  burlesk_nn_1 : N ;
  burleskeri_nn_1 : N ;
  burman_nn_1 : N ;
  burmanska_nn_2 : N ;
  burmes_nn_1 : N ;
  burnus_nn_1 : N ;
  burr_nn_1 : N ;
  burrig_av_1 : A ;
  burschikos_av_1 : A ;
  burspraak_nn_1 : N ;
  burundier_nn_1 : N ;
  burundisk_av_1 : A ;
  buse_nn_1 : N ;
  busfason_nn_1 : N ;
  busfroe_nn_1 : N ;
  bushman_nn_1 : N ;
  busig_av_1 : A ;
  business_nn_1 : N ;
  buskablyg_av_1 : A ;
  buskage_nn_1 : N ;
  buske_nn_1 : N ;
  buskig_av_1 : A ;
  buskliknande_av_1 : A ;
  buskoerning_nn_1 : N ;
  busksly_nn_1 : N ;
  buss_nn_1 : N ;
  bussarong_nn_1 : N ;
  busschauffoer_nn_1 : N ;
  bussfoerbindelse_nn_1 : N ;
  busshaallplats_nn_1 : N ;
  bussig_av_1 : A ;
  busskort_nn_1 : N ;
  busslast_nn_1 : N ;
  busslinje_nn_1 : N ;
  bussning_nn_1 : N ;
  busunge_nn_1 : N ;
  busvissling_nn_1 : N ;
  butan_nn_1 : N ;
  butelj_nn_1 : N ;
  buteljborste_nn_1 : N ;
  buteljbotten_nn_1 : N ;
  buteljering_nn_1 : N ;
  buteljgroen_av_1 : A ;
  butik_nn_1 : N ;
  butiksbitraede_nn_1 : N ;
  butikskedja_nn_1 : N ;
  butiksstaengningslag_nn_1 : N ;
  butler_nn_1 : N ;
  butter_av_1 : A ;
  butyl_nn_1 : N ;
  buxbom_nn_1 : N ;
  by_nn_1 : N ;
  byaeldste_nn_1 : N ;
  byalag_nn_1 : N ;
  byamaal_nn_1 : N ;
  byfaane_nn_1 : N ;
  byffe_nn_1 : N ;
  byfogde_nn_1 : N ;
  bygd_nn_1 : N ;
  bygdeborg_nn_1 : N ;
  bygdegaard_nn_1 : N ;
  bygdemaal_nn_1 : N ;
  bygel_nn_1 : N ;
  bygelhaest_nn_1 : N ;
  bygelhorn_nn_1 : N ;
  bygellaas_nn_1 : N ;
  byggarbetare_nn_1 : N ;
  byggare_nn_1 : N ;
  byggelement_nn_1 : N ;
  byggherre_nn_1 : N ;
  byggkloss_nn_1 : N ;
  bygglag_nn_1 : N ;
  bygglekplats_nn_1 : N ;
  bygglov_nn_1 : N ;
  byggmaestare_nn_1 : N ;
  byggmaterial_nn_1 : N ;
  byggnad_nn_1 : N ;
  byggnadsarbetare_nn_1 : N ;
  byggnadsindustri_nn_1 : N ;
  byggnadskonstruktion_nn_1 : N ;
  byggnadskontor_nn_1 : N ;
  byggnadskredit_nn_1 : N ;
  byggnadskreditiv_nn_1 : N ;
  byggnadslaan_nn_1 : N ;
  byggnadslov_nn_1 : N ;
  byggnadsmaterial_nn_1 : N ;
  byggnadsminne_nn_1 : N ;
  byggnadsnaemnd_nn_1 : N ;
  byggnadsplan_nn_1 : N ;
  byggnadssnickare_nn_1 : N ;
  byggnadsstaellning_nn_1 : N ;
  byggnadssten_nn_1 : N ;
  byggnadsstil_nn_1 : N ;
  byggnadsstyrelse_nn_1 : N ;
  byggnadstillstaand_nn_1 : N ;
  byggnadsverk_nn_1 : N ;
  byggning_nn_1 : N ;
  byggsats_nn_1 : N ;
  byggstart_nn_1 : N ;
  byggsten_nn_1 : N ;
  byggstopp_nn_1 : N ;
  byggtork_nn_1 : N ;
  byhus_nn_1 : N ;
  byig_av_1 : A ;
  byk_nn_1 : N ;
  byling_nn_1 : N ;
  bylsig_av_1 : A ;
  bymoln_nn_1 : N ;
  byomraade_nn_1 : N ;
  byordning_nn_1 : N ;
  byraa_nn_1 : N ;
  byraa_nn_2 : N ;
  byraaassistent_nn_1 : N ;
  byraachef_nn_1 : N ;
  byraadirektoer_nn_1 : N ;
  byraakrat_nn_1 : N ;
  byraakrati_nn_1 : N ;
  byraakratisk_av_1 : A ;
  byraasekreterare_nn_1 : N ;
  byrett_nn_1 : N ;
  bysamfaellighet_nn_1 : N ;
  bysantin_nn_1 : N ;
  bysantinsk_av_1 : A ;
  byssja_nn_1 : N ;
  byst_nn_1 : N ;
  bystaemma_nn_1 : N ;
  bystdrottning_nn_1 : N ;
  bysthaallare_nn_1 : N ;
  bystmaatt_nn_1 : N ;
  byte_nn_1 : N ;
  byte_nn_2 : N ;
  bytesaffaer_nn_1 : N ;
  bytesdjur_nn_1 : N ;
  byteslaegenhet_nn_1 : N ;
  bytesmedel_nn_1 : N ;
  bytesobjekt_nn_1 : N ;
  bytesvaerde_nn_1 : N ;
  byting_nn_1 : N ;
  byx_nn_1 : N ;
  byxbak_nn_1 : N ;
  byxben_nn_1 : N ;
  byxdraekt_nn_1 : N ;
  byxdress_nn_1 : N ;
  byxholk_nn_1 : N ;
  byxis_av_1 : A ;
  byxkjol_nn_1 : N ;
  cab_nn_1 : N ;
  cabb_nn_1 : N ;
  cabriolet_nn_1 : N ;
  caddie_nn_1 : N ;
  cafe_nn_1 : N ;
  callgirl_nn_1 : N ;
  calmettevaccinering_nn_1 : N ;
  camouflage_nn_1 : N ;
  camp_av_1 : A ;
  campare_nn_1 : N ;
  camping_nn_1 : N ;
  campingplats_nn_1 : N ;
  campus_nn_1 : N ;
  cancer_nn_1 : N ;
  cancerfall_nn_1 : N ;
  cancerfara_nn_1 : N ;
  cancerform_nn_1 : N ;
  cancerforskare_nn_1 : N ;
  cancerforskning_nn_1 : N ;
  cancerframkallande_av_1 : A ;
  cancerogen_av_1 : A ;
  cancerrisk_nn_1 : N ;
  cancersvulst_nn_1 : N ;
  candela_nn_1 : N ;
  cape_nn_1 : N ;
  cappuccino_nn_1 : N ;
  carcinogen_nn_1 : N ;
  cardigan_nn_1 : N ;
  cash_ab_1 : Adv ;
  cash_nn_1 : N ;
  caterpillar_nn_1 : N ;
  ceder_nn_1 : N ;
  cedilj_nn_1 : N ;
  celeber_av_1 : A ;
  celebritet_nn_1 : N ;
  celest_av_1 : A ;
  celibat_nn_1 : N ;
  cell_nn_1 : N ;
  celldelning_nn_1 : N ;
  cellfaengelse_nn_1 : N ;
  cellgift_nn_1 : N ;
  cellgranne_nn_1 : N ;
  cellist_nn_1 : N ;
  cellkamrat_nn_1 : N ;
  cellmembran_nn_1 : N ;
  cello_nn_1 : N ;
  cellplasma_nn_1 : N ;
  cellsjok_nn_1 : N ;
  cellskikt_nn_1 : N ;
  cellspaenning_nn_1 : N ;
  cellstraff_nn_1 : N ;
  cellstruktur_nn_1 : N ;
  celltraad_nn_1 : N ;
  celltyp_nn_1 : N ;
  cellulaer_av_1 : A ;
  cellulosaindustri_nn_1 : N ;
  cellulosalack_nn_1 : N ;
  cellulosamolekyl_nn_1 : N ;
  cellulosanitrat_nn_1 : N ;
  cellulosaplast_nn_1 : N ;
  cellvaegg_nn_1 : N ;
  celsiusgrad_nn_1 : N ;
  celsiustermometer_nn_1 : N ;
  celt_nn_1 : N ;
  cembalist_nn_1 : N ;
  cembalo_nn_1 : N ;
  cementblandare_nn_1 : N ;
  cementering_nn_1 : N ;
  cenakel_nn_1 : N ;
  cendre_av_1 : A ;
  censor_nn_1 : N ;
  census_nn_1 : N ;
  cent_nn_1 : N ;
  centaur_nn_1 : N ;
  center_nn_1 : N ;
  center_nn_2 : N ;
  centerback_nn_1 : N ;
  centerbord_nn_1 : N ;
  centerforward_nn_1 : N ;
  centerhalv_nn_1 : N ;
  centerparti_nn_1 : N ;
  centerpartist_nn_1 : N ;
  centiliter_nn_1 : N ;
  centilong_nn_1 : N ;
  centimeter_nn_1 : N ;
  centner_nn_1 : N ;
  central_av_1 : A ;
  centralafrikan_nn_1 : N ;
  centralafrikansk_av_1 : A ;
  centralamerikansk_av_1 : A ;
  centralanstalt_nn_1 : N ;
  centralantenn_nn_1 : N ;
  centralbank_nn_1 : N ;
  centralbyggnad_nn_1 : N ;
  centralbyraa_nn_1 : N ;
  centralenhet_nn_1 : N ;
  centraleuropeisk_av_1 : A ;
  centralfoerbund_nn_1 : N ;
  centralfoervaltning_nn_1 : N ;
  centralgestalt_nn_1 : N ;
  centralisering_nn_1 : N ;
  centralistisk_av_1 : A ;
  centralkommitte_nn_1 : N ;
  centralkontor_nn_1 : N ;
  centralkyrka_nn_1 : N ;
  centrallasarett_nn_1 : N ;
  centrallyrisk_av_1 : A ;
  centralmakt_nn_1 : N ;
  centralnaemnd_nn_1 : N ;
  centralorganisation_nn_1 : N ;
  centralort_nn_1 : N ;
  centralregering_nn_1 : N ;
  centralroerelse_nn_1 : N ;
  centralstation_nn_1 : N ;
  centralstimulantia_nn_1 : N ;
  centralstimulerande_av_1 : A ;
  centralstyrd_av_1 : A ;
  centralstyrelse_nn_1 : N ;
  centrifug_nn_1 : N ;
  centrifugal_av_1 : A ;
  centrifugalpump_nn_1 : N ;
  centripetal_av_1 : A ;
  centrisk_av_1 : A ;
  centrum_nn_1 : N ;
  centumspraak_nn_1 : N ;
  cerat_nn_1 : N ;
  cerebral_av_1 : A ;
  cerebrospinal_av_1 : A ;
  ceremoni_nn_1 : N ;
  ceremoniel_nn_1 : N ;
  ceremoniell_av_1 : A ;
  ceremonimaestare_nn_1 : N ;
  ceremonioes_av_1 : A ;
  cerise_av_1 : A ;
  cerise_nn_1 : N ;
  cernering_nn_1 : N ;
  cert_nn_1 : N ;
  certeparti_nn_1 : N ;
  certifikat_nn_1 : N ;
  cesarisk_av_1 : A ;
  cession_nn_1 : N ;
  cesur_nn_1 : N ;
  champagneglas_nn_1 : N ;
  champagnekork_nn_1 : N ;
  champinjon_nn_1 : N ;
  champinjonbaedd_nn_1 : N ;
  champion_nn_1 : N ;
  championat_nn_1 : N ;
  changemang_nn_1 : N ;
  chans_nn_1 : N ;
  chansloes_av_1 : A ;
  chansning_nn_1 : N ;
  chanson_nn_1 : N ;
  chansonett_nn_1 : N ;
  chanstagare_nn_1 : N ;
  chanstagning_nn_1 : N ;
  chapeau_claque_nn_1 : N ;
  char_nn_1 : N ;
  charabang_nn_1 : N ;
  charad_nn_1 : N ;
  charge_d'27affaires_nn_1 : N ;
  charge_nn_1 : N ;
  charkuteri_nn_1 : N ;
  charkuterist_nn_1 : N ;
  charlatan_nn_1 : N ;
  charmant_av_1 : A ;
  charmfull_av_1 : A ;
  charmig_av_1 : A ;
  charmkurs_nn_1 : N ;
  charmloes_av_1 : A ;
  charmoer_nn_1 : N ;
  charmoffensiv_nn_1 : N ;
  charmtroll_nn_1 : N ;
  charner_nn_1 : N ;
  chartreuse_nn_1 : N ;
  chassi_nn_1 : N ;
  chateaubriand_nn_1 : N ;
  chauffoer_nn_1 : N ;
  chausse_nn_1 : N ;
  chauvinist_nn_1 : N ;
  chauvinistisk_av_1 : A ;
  check_nn_1 : N ;
  checkhaefte_nn_1 : N ;
  checkkonto_nn_1 : N ;
  checkkredit_nn_1 : N ;
  checkraekning_nn_1 : N ;
  cheddarost_nn_1 : N ;
  chef_nn_1 : N ;
  chefredaktoer_nn_1 : N ;
  chefsideolog_nn_1 : N ;
  chefstjaensteman_nn_1 : N ;
  chemis_nn_1 : N ;
  chemisett_nn_1 : N ;
  chevaleresk_av_1 : A ;
  chevelyr_nn_1 : N ;
  cheviot_nn_1 : N ;
  chic_av_1 : A ;
  chiffer_nn_1 : N ;
  chiffernyckel_nn_1 : N ;
  chiffong_nn_1 : N ;
  chiffonje_nn_1 : N ;
  chikan_nn_1 : N ;
  chilen_nn_1 : N ;
  chilenare_nn_1 : N ;
  chilensk_av_1 : A ;
  chimaer_nn_1 : N ;
  chinjong_nn_1 : N ;
  chips_nn_1 : N ;
  chock_nn_1 : N ;
  chockbehandling_nn_1 : N ;
  chockrosa_av_1 : A ;
  choke_nn_1 : N ;
  choklad_nn_1 : N ;
  chokladbit_nn_1 : N ;
  chokladpudding_nn_1 : N ;
  chosefri_av_1 : A ;
  chosig_av_1 : A ;
  chuck_nn_1 : N ;
  ciceron_nn_1 : N ;
  cif_ab_1 : Adv ;
  cigarett_nn_1 : N ;
  cigarettaendare_nn_1 : N ;
  cigarettfimp_nn_1 : N ;
  cigarettpaket_nn_1 : N ;
  cigarettroek_nn_1 : N ;
  cigarill_nn_1 : N ;
  cigarr_nn_1 : N ;
  cigarrcigarett_nn_1 : N ;
  cigarrett_nn_1 : N ;
  cigarrettaendare_nn_1 : N ;
  cigarrettfimp_nn_1 : N ;
  cigarrettpaket_nn_1 : N ;
  ciklidfisk_nn_1 : N ;
  ciliarkropp_nn_1 : N ;
  ciliarmuskel_nn_1 : N ;
  cilie_nn_1 : N ;
  cineast_nn_1 : N ;
  cinematek_nn_1 : N ;
  cirka_ab_1 : Adv ;
  cirkapris_nn_1 : N ;
  cirkel_nn_1 : N ;
  cirkelbaage_nn_1 : N ;
  cirkelben_nn_1 : N ;
  cirkelbevis_nn_1 : N ;
  cirkeldefinition_nn_1 : N ;
  cirkelledare_nn_1 : N ;
  cirkelperiferi_nn_1 : N ;
  cirkelprocess_nn_1 : N ;
  cirkelroerelse_nn_1 : N ;
  cirkelrund_av_1 : A ;
  cirkelsaag_nn_1 : N ;
  cirkelsegment_nn_1 : N ;
  cirkelsektor_nn_1 : N ;
  cirkelslut_nn_1 : N ;
  cirkulaer_av_1 : A ;
  cirkulaer_nn_1 : N ;
  cirkulaerledare_nn_1 : N ;
  cirkulationsplats_nn_1 : N ;
  cirkulationspump_nn_1 : N ;
  cirkulationsrubbning_nn_1 : N ;
  cirkumflex_nn_1 : N ;
  cirkumpolaer_av_1 : A ;
  cirkumpolar_av_1 : A ;
  cirkus_nn_1 : N ;
  cirkusarena_nn_1 : N ;
  cirkusartist_nn_1 : N ;
  cirkusdjur_nn_1 : N ;
  cirkusmanege_nn_1 : N ;
  cirkusnummer_nn_1 : N ;
  cirrusmoln_nn_1 : N ;
  cisalpinsk_av_1 : A ;
  ciseloer_nn_1 : N ;
  ciss_nn_1 : N ;
  cissus_nn_1 : N ;
  cisterciens_nn_1 : N ;
  cisterciensorden_nn_1 : N ;
  cistern_nn_1 : N ;
  citadell_nn_1 : N ;
  citat_nn_1 : N ;
  citation_nn_1 : N ;
  citationstecken_nn_1 : N ;
  citatord_nn_1 : N ;
  citrin_nn_1 : N ;
  citron_nn_1 : N ;
  citronfjaeril_nn_1 : N ;
  citrongul_av_1 : A ;
  citronlaesk_nn_1 : N ;
  citronskal_nn_1 : N ;
  citrus_nn_1 : N ;
  citrusfrukt_nn_1 : N ;
  cittra_nn_1 : N ;
  city_nn_1 : N ;
  citydress_nn_1 : N ;
  civil_av_1 : A ;
  civilaektenskap_nn_1 : N ;
  civilbegravning_nn_1 : N ;
  civilekonom_nn_1 : N ;
  civilingenjoer_nn_1 : N ;
  civilisation_nn_1 : N ;
  civilisatorisk_av_1 : A ;
  civilist_nn_1 : N ;
  civilklaedd_av_1 : A ;
  civillag_nn_1 : N ;
  civilmaal_nn_1 : N ;
  civilmilitaer_av_1 : A ;
  civilmilitaer_nn_1 : N ;
  civilprocess_nn_1 : N ;
  civilstaand_nn_1 : N ;
  civilstat_nn_1 : N ;
  clairobscur_nn_1 : N ;
  clairvoyance_nn_1 : N ;
  clairvoyant_av_1 : A ;
  clematis_nn_1 : N ;
  clementin_nn_1 : N ;
  clips_nn_1 : N ;
  clitoris_nn_1 : N ;
  cloisonvaegg_nn_1 : N ;
  cloque_nn_1 : N ;
  clown_nn_1 : N ;
  clowneri_nn_1 : N ;
  club_blazer_nn_1 : N ;
  clubstek_nn_1 : N ;
  coach_nn_1 : N ;
  cockerspaniel_nn_1 : N ;
  cockpit_nn_1 : N ;
  cocktail_nn_1 : N ;
  cocktailbaer_nn_1 : N ;
  cocktailparty_nn_1 : N ;
  codex_nn_1 : N ;
  collage_nn_1 : N ;
  college_nn_1 : N ;
  collie_nn_1 : N ;
  collier_nn_1 : N ;
  colombian_nn_1 : N ;
  colombiansk_av_1 : A ;
  colombianska_nn_1 : N ;
  come_back_nn_1 : N ;
  comeback_nn_1 : N ;
  commando_nn_1 : N ;
  commandotrupp_nn_1 : N ;
  comme_il_faut_ab_1 : Adv ;
  comorier_nn_1 : N ;
  comorisk_av_1 : A ;
  conferencier_nn_1 : N ;
  consomme_nn_1 : N ;
  container_nn_1 : N ;
  contortatall_nn_1 : N ;
  cool_av_1 : A ;
  copywriter_nn_1 : N ;
  cornichon_nn_1 : N ;
  coronacell_nn_1 : N ;
  corps_de_logi_nn_1 : N ;
  corpus_nn_1 : N ;
  cortege_nn_1 : N ;
  cortical_av_1 : A ;
  cortison_nn_1 : N ;
  cosinus_nn_1 : N ;
  costarican_nn_1 : N ;
  costaricansk_av_1 : A ;
  cotangent_nn_1 : N ;
  coulomb_nn_1 : N ;
  coupe_nn_1 : N ;
  cowboy_nn_1 : N ;
  crazy_av_1 : A ;
  credo_nn_1 : N ;
  creme_nn_1 : N ;
  crepe_nn_1 : N ;
  crescendo_ab_1 : Adv ;
  crescendo_nn_1 : N ;
  croissant_nn_1 : N ;
  croquis_nn_1 : N ;
  crosschecking_nn_1 : N ;
  croupier_nn_1 : N ;
  cuban_nn_1 : N ;
  cubansk_av_1 : A ;
  cumulus_nn_1 : N ;
  cumuluscell_nn_1 : N ;
  cumulusmoln_nn_1 : N ;
  cup_nn_1 : N ;
  curie_nn_1 : N ;
  cyanblaa_av_1 : A ;
  cyanid_nn_1 : N ;
  cyanobakterie_nn_1 : N ;
  cybernetisk_av_1 : A ;
  cykel_nn_1 : N ;
  cykel_nn_2 : N ;
  cykeldaeck_nn_1 : N ;
  cykelergometer_nn_1 : N ;
  cykelkedja_nn_1 : N ;
  cykelpump_nn_1 : N ;
  cykelsadel_nn_1 : N ;
  cykelslang_nn_1 : N ;
  cykelstaell_nn_1 : N ;
  cykelstyre_nn_1 : N ;
  cykeltaevling_nn_1 : N ;
  cykeltrupp_nn_1 : N ;
  cykelventil_nn_1 : N ;
  cyklamen_nn_1 : N ;
  cyklisk_av_1 : A ;
  cyklist_nn_1 : N ;
  cykloid_nn_1 : N ;
  cyklometer_nn_1 : N ;
  cyklon_nn_1 : N ;
  cyklonfamilj_nn_1 : N ;
  cyklop_nn_1 : N ;
  cyklop_nn_2 : N ;
  cyklopoega_nn_1 : N ;
  cyklotron_nn_1 : N ;
  cyklotym_av_1 : A ;
  cylinder_nn_1 : N ;
  cylinderblock_nn_1 : N ;
  cylinderhatt_nn_1 : N ;
  cylinderlaas_nn_1 : N ;
  cylinderpress_nn_1 : N ;
  cylindrisk_av_1 : A ;
  cymbal_nn_1 : N ;
  cyniker_nn_1 : N ;
  cynisk_av_1 : A ;
  cynism_nn_1 : N ;
  cypress_nn_1 : N ;
  cypriot_nn_1 : N ;
  cypriotisk_av_1 : A ;
  cystoskop_nn_1 : N ;
  cystoskopi_nn_1 : N ;
  cytologisk_av_1 : A ;
  daa_ab_1 : Adv ;
  daad_nn_1 : N ;
  daadrafroe_nn_1 : N ;
  daafoertiden_ab_1 : Adv ;
  daalig_av_1 : A ;
  daalighet_nn_1 : N ;
  daamera_ab_1 : Adv ;
  daan_nn_1 : N ;
  daandimpen_ab_1 : Adv ;
  daaraktig_av_1 : A ;
  daare_nn_1 : N ;
  daarfink_nn_1 : N ;
  daarhus_nn_1 : N ;
  daarskap_nn_1 : N ;
  daasig_av_1 : A ;
  daasighet_nn_1 : N ;
  daatida_av_1 : A ;
  daavarande_av_1 : A ;
  dadaist_nn_1 : N ;
  dadaistisk_av_1 : A ;
  dadel_nn_1 : N ;
  dadelpalm_nn_1 : N ;
  daeck_nn_1 : N ;
  daeckel_nn_1 : N ;
  daecker_nn_1 : N ;
  daeckslast_nn_1 : N ;
  daecksmanskap_nn_1 : N ;
  daedan_ab_1 : Adv ;
  daeggdjur_nn_1 : N ;
  daeggdjursgrupp_nn_1 : N ;
  daeggdjurstand_nn_1 : N ;
  daeggdjurstyp_nn_1 : N ;
  daeggdjursunge_nn_1 : N ;
  daeld_nn_1 : N ;
  daemmare_nn_1 : N ;
  daemme_nn_1 : N ;
  daemning_nn_1 : N ;
  daempare_nn_1 : N ;
  daempbox_nn_1 : N ;
  daempning_nn_1 : N ;
  daen_ab_1 : Adv ;
  daer_ab_1 : Adv ;
  daeraat_ab_1 : Adv ;
  daerav_ab_1 : Adv ;
  daerborta_ab_1 : Adv ;
  daerefter_ab_1 : Adv ;
  daeremellan_ab_1 : Adv ;
  daeremot_ab_1 : Adv ;
  daerfoer_ab_1 : Adv ;
  daerfoere_ab_1 : Adv ;
  daerfoerinnan_ab_1 : Adv ;
  daerfoerutan_ab_1 : Adv ;
  daerhaen_ab_1 : Adv ;
  daerhemma_ab_1 : Adv ;
  daeri_ab_1 : Adv ;
  daeribland_ab_1 : Adv ;
  daerifraan_ab_1 : Adv ;
  daerigenom_ab_1 : Adv ;
  daerinne_ab_1 : Adv ;
  daerjaemte_ab_1 : Adv ;
  daermed_ab_1 : Adv ;
  daernaest_ab_1 : Adv ;
  daernedanfoer_ab_1 : Adv ;
  daernere_ab_1 : Adv ;
  daeroever_ab_1 : Adv ;
  daerom_ab_1 : Adv ;
  daerpaa_ab_1 : Adv ;
  daerstaedes_ab_1 : Adv ;
  daertill_ab_1 : Adv ;
  daerunder_ab_1 : Adv ;
  daeruppe_ab_1 : Adv ;
  daerutav_ab_1 : Adv ;
  daerute_ab_1 : Adv ;
  daerutinnan_ab_1 : Adv ;
  daerutoever_ab_1 : Adv ;
  daervid_ab_1 : Adv ;
  daervidlag_ab_1 : Adv ;
  daest_av_1 : A ;
  daeven_av_1 : A ;
  daevert_nn_1 : N ;
  daexel_nn_1 : N ;
  dag_nn_1 : N ;
  dagakarl_nn_1 : N ;
  dagaktiv_av_1 : A ;
  dagavdelning_nn_1 : N ;
  dagbarn_nn_1 : N ;
  dagbarnvaardare_nn_1 : N ;
  dagbefael_nn_1 : N ;
  dagblad_nn_1 : N ;
  dagblind_av_1 : A ;
  dagbok_nn_1 : N ;
  dagbraeckning_nn_1 : N ;
  dagbrott_nn_1 : N ;
  dagbrytning_nn_1 : N ;
  dagcentral_nn_1 : N ;
  dagcentrum_nn_1 : N ;
  dagdjur_nn_1 : N ;
  dagdrivare_nn_1 : N ;
  dagdroem_nn_1 : N ;
  dagdroemmare_nn_1 : N ;
  dagdroemmeri_nn_1 : N ;
  dagenefterstaemning_nn_1 : N ;
  dager_nn_1 : N ;
  dagerrotyp_nn_1 : N ;
  dagerrotypi_nn_1 : N ;
  dagfjaeril_nn_1 : N ;
  dagg_nn_2 : N ;
  daggdroppe_nn_1 : N ;
  daggert_nn_1 : N ;
  daggfrisk_av_1 : A ;
  daggig_av_1 : A ;
  daggmask_nn_1 : N ;
  daggpunkt_nn_1 : N ;
  daghavande_av_1 : A ;
  daghavande_nn_1 : N ;
  daghem_nn_1 : N ;
  dagis_nn_1 : N ;
  dagkarl_nn_1 : N ;
  daglig_av_1 : A ;
  dagligdags_ab_1 : Adv ;
  dagligen_ab_1 : Adv ;
  dagligstuga_nn_1 : N ;
  dagloen_nn_1 : N ;
  dagloenare_nn_1 : N ;
  dagmamma_nn_1 : N ;
  dago_nn_1 : N ;
  dagoeppning_nn_1 : N ;
  dagofficer_nn_1 : N ;
  dagorder_nn_1 : N ;
  dagordning_nn_1 : N ;
  dagort_nn_1 : N ;
  dagpenning_nn_1 : N ;
  dagrum_nn_1 : N ;
  dags_ab_1 : Adv ;
  dagsaktuell_av_1 : A ;
  dagsbehov_nn_1 : N ;
  dagsbot_nn_1 : N ;
  dagsedel_nn_1 : N ;
  dagsens_av_1 : A ;
  dagskassa_nn_1 : N ;
  dagsled_nn_1 : N ;
  dagsmarsch_nn_1 : N ;
  dagsranson_nn_1 : N ;
  dagstemperatur_nn_1 : N ;
  dagstidning_nn_1 : N ;
  dagsverkare_nn_1 : N ;
  dagtid_nn_1 : N ;
  dagtraktamente_nn_1 : N ;
  dagvatten_nn_1 : N ;
  dakapo_ab_1 : Adv ;
  dakapo_nn_1 : N ;
  daktyl_nn_1 : N ;
  daktylisk_av_1 : A ;
  dal_nn_1 : N ;
  dalahaest_nn_1 : N ;
  dalbo_nn_1 : N ;
  dalbotten_nn_1 : N ;
  daldans_nn_1 : N ;
  daler_nn_1 : N ;
  dalgaang_nn_1 : N ;
  dalkarl_nn_1 : N ;
  dallring_nn_1 : N ;
  dalmaal_nn_1 : N ;
  dalmaalning_nn_1 : N ;
  dalmas_nn_1 : N ;
  dalmatiner_nn_1 : N ;
  dalprofil_nn_1 : N ;
  dalsk_av_1 : A ;
  dalslaendsk_av_1 : A ;
  dalslaenning_nn_1 : N ;
  dalsluttning_nn_1 : N ;
  dalvind_nn_1 : N ;
  dam_nn_1 : N ;
  damask_nn_1 : N ;
  damast_nn_1 : N ;
  dambesoek_nn_1 : N ;
  dambjudning_nn_1 : N ;
  damcykel_nn_1 : N ;
  damejeanne_nn_1 : N ;
  damfrisering_nn_1 : N ;
  damfrisoer_nn_1 : N ;
  damfrisoerska_nn_1 : N ;
  damgambit_nn_1 : N ;
  damhatt_nn_1 : N ;
  damig_av_1 : A ;
  damkoer_nn_1 : N ;
  damm_nn_1 : N ;
  dammanlaeggning_nn_1 : N ;
  dammbindningsmedel_nn_1 : N ;
  dammfoersoek_nn_1 : N ;
  dammig_av_1 : A ;
  dammkorn_nn_1 : N ;
  dammoln_nn_1 : N ;
  dammport_nn_1 : N ;
  dammsuga_vb_1 : V ;
  dammsugare_nn_1 : N ;
  dammussla_nn_1 : N ;
  damoklessvaerd_nn_1 : N ;
  damrum_nn_1 : N ;
  damsida_nn_1 : N ;
  damspel_nn_1 : N ;
  damtidning_nn_1 : N ;
  dan_av_1 : A ;
  danaarv_nn_1 : N ;
  dandy_nn_1 : N ;
  daning_nn_1 : N ;
  danism_nn_1 : N ;
  dank_ab_1 : Adv ;
  dank_nn_1 : N ;
  danneman_nn_1 : N ;
  dans_nn_1 : N ;
  dansant_av_1 : A ;
  dansare_nn_1 : N ;
  dansgolv_nn_1 : N ;
  danshak_nn_1 : N ;
  dansk_av_1 : A ;
  dansk_nn_1 : N ;
  danska_nn_2 : N ;
  danskonst_nn_1 : N ;
  danslek_nn_1 : N ;
  dansoer_nn_1 : N ;
  dansoes_nn_1 : N ;
  dansrestaurang_nn_1 : N ;
  dansstaelle_nn_1 : N ;
  danssteg_nn_1 : N ;
  danstillstaellning_nn_1 : N ;
  darraal_nn_1 : N ;
  darrhaent_av_1 : A ;
  darrig_av_1 : A ;
  darrning_nn_1 : N ;
  darwinfink_nn_1 : N ;
  darwinist_nn_1 : N ;
  darwinistisk_av_1 : A ;
  daskig_av_1 : A ;
  dass_nn_1 : N ;
  dassig_av_1 : A ;
  dat_nn_1 : N ;
  data_nn_1 : N ;
  dataanlaeggning_nn_1 : N ;
  databank_nn_1 : N ;
  databas_nn_1 : N ;
  databehandling_nn_1 : N ;
  datacentral_nn_1 : N ;
  datafil_nn_1 : N ;
  datakoerning_nn_1 : N ;
  datakommunikation_nn_1 : N ;
  datamaengd_nn_1 : N ;
  datamaskin_nn_1 : N ;
  datamaskinell_av_1 : A ;
  dataminne_nn_1 : N ;
  dataprogram_nn_1 : N ;
  dataregister_nn_1 : N ;
  dataskaerm_nn_1 : N ;
  dataspel_nn_1 : N ;
  datering_nn_1 : N ;
  dativ_nn_1 : N ;
  dativobjekt_nn_1 : N ;
  dator_nn_1 : N ;
  datoranlaeggning_nn_1 : N ;
  datorbehandling_nn_1 : N ;
  datorberaekning_nn_1 : N ;
  datorminne_nn_1 : N ;
  datormodell_nn_1 : N ;
  datorprogrammerare_nn_1 : N ;
  datovaexel_nn_1 : N ;
  datum_nn_1 : N ;
  datumgraens_nn_1 : N ;
  datumparkering_nn_1 : N ;
  debacle_nn_1 : N ;
  debatt_nn_1 : N ;
  debattinlaegg_nn_1 : N ;
  debattoer_nn_1 : N ;
  debetsedel_nn_1 : N ;
  debetsida_nn_1 : N ;
  debil_av_1 : A ;
  debilitet_nn_1 : N ;
  debit_nn_1 : N ;
  debitering_nn_1 : N ;
  debut_nn_1 : N ;
  debutant_nn_1 : N ;
  debutbok_nn_1 : N ;
  debutroman_nn_1 : N ;
  decennium_nn_1 : N ;
  decentralisation_nn_1 : N ;
  decentralisering_nn_1 : N ;
  decharge_nn_1 : N ;
  dechargedebatt_nn_1 : N ;
  decibel_nn_1 : N ;
  deciliter_nn_1 : N ;
  decilitermaatt_nn_1 : N ;
  decimal_nn_1 : N ;
  decimalbraak_nn_1 : N ;
  decimalkomma_nn_1 : N ;
  decimalsystem_nn_1 : N ;
  decimaltal_nn_1 : N ;
  decimeter_nn_1 : N ;
  deckare_nn_1 : N ;
  dedikation_nn_1 : N ;
  dedikationsexemplar_nn_1 : N ;
  deduktion_nn_1 : N ;
  deduktiv_av_1 : A ;
  defaitist_nn_1 : N ;
  defaitistisk_av_1 : A ;
  defekt_av_1 : A ;
  defekt_nn_1 : N ;
  defensiv_av_1 : A ;
  deficit_nn_1 : N ;
  defile_nn_1 : N ;
  defilering_nn_1 : N ;
  definierbar_av_1 : A ;
  definit_av_1 : A ;
  definition_nn_1 : N ;
  definitionsmaengd_nn_1 : N ;
  definitionsmaessig_av_1 : A ;
  definitiv_av_1 : A ;
  deflagration_nn_1 : N ;
  defloration_nn_1 : N ;
  deformation_nn_1 : N ;
  deformering_nn_1 : N ;
  deformitet_nn_1 : N ;
  defroster_nn_1 : N ;
  deg_nn_1 : N ;
  degel_nn_1 : N ;
  degenerativ_av_1 : A ;
  degig_av_1 : A ;
  dego_nn_1 : N ;
  degradation_nn_1 : N ;
  degrand_nn_1 : N ;
  degression_nn_1 : N ;
  deiktisk_av_1 : A ;
  deist_nn_1 : N ;
  deistisk_av_1 : A ;
  dejlig_av_1 : A ;
  dekad_nn_1 : N ;
  dekadent_av_1 : A ;
  dekadisk_av_1 : A ;
  dekal_nn_1 : N ;
  dekan_nn_1 : N ;
  deklamation_nn_1 : N ;
  deklamatoer_nn_1 : N ;
  deklamatorisk_av_1 : A ;
  deklarant_nn_1 : N ;
  deklaration_nn_1 : N ;
  deklarationsblankett_nn_1 : N ;
  deklination_nn_1 : N ;
  deklinationsnaal_nn_1 : N ;
  dekokt_nn_1 : N ;
  dekolletage_nn_1 : N ;
  dekolletering_nn_1 : N ;
  dekor_nn_1 : N ;
  dekoration_nn_1 : N ;
  dekorationslist_nn_1 : N ;
  dekorativ_av_1 : A ;
  dekoratoer_nn_1 : N ;
  dekret_nn_1 : N ;
  del_nn_1 : N ;
  delaegare_nn_1 : N ;
  delaktig_av_1 : A ;
  delaktighet_nn_1 : N ;
  delbar_av_1 : A ;
  delbetalning_nn_1 : N ;
  delegat_nn_1 : N ;
  delegation_nn_1 : N ;
  delegering_nn_1 : N ;
  delfin_nn_1 : N ;
  delge_vb_1 : V ;
  delgivning_nn_1 : N ;
  delicioes_av_1 : A ;
  delikat_av_1 : A ;
  delikatess_nn_1 : N ;
  delikt_nn_1 : N ;
  delinkvent_nn_1 : N ;
  delirant_nn_1 : N ;
  dellikvid_nn_1 : N ;
  delmaengd_nn_1 : N ;
  delning_nn_1 : N ;
  delperiod_nn_1 : N ;
  delprojekt_nn_1 : N ;
  delrepublik_nn_1 : N ;
  dels_ab_1 : Adv ;
  delstat_nn_1 : N ;
  delstreck_nn_1 : N ;
  delta_nn_1 : N ;
  delta_vb_1 : V ;
  deltagande_av_1 : A ;
  deltagare_nn_1 : N ;
  deltamuskel_nn_1 : N ;
  deltavinge_nn_1 : N ;
  deltid_nn_1 : N ;
  deltidare_nn_1 : N ;
  deltidsanstaelld_av_1 : A ;
  delvis_ab_1 : Adv ;
  delvis_av_1 : A ;
  demagog_nn_1 : N ;
  demagogisk_av_1 : A ;
  demarkationslinje_nn_1 : N ;
  demarsch_nn_1 : N ;
  dementi_nn_1 : N ;
  demeriterande_av_1 : A ;
  demimond_nn_1 : N ;
  demission_nn_1 : N ;
  demiurg_nn_1 : N ;
  demografisk_av_1 : A ;
  demoinspelning_nn_1 : N ;
  demokrat_nn_1 : N ;
  demokrati_nn_1 : N ;
  demokratisk_av_1 : A ;
  demon_nn_1 : N ;
  demonisk_av_1 : A ;
  demonregissoer_nn_1 : N ;
  demonstrant_nn_1 : N ;
  demonstration_nn_1 : N ;
  demonstrationsfrihet_nn_1 : N ;
  demonstrationstaag_nn_1 : N ;
  demonstrativ_av_1 : A ;
  demonstratoer_nn_1 : N ;
  demonstratris_nn_1 : N ;
  demontering_nn_1 : N ;
  demotape_nn_1 : N ;
  denar_nn_1 : N ;
  dendrit_nn_1 : N ;
  dendrolog_nn_1 : N ;
  denier_nn_1 : N ;
  dennes_ab_1 : Adv ;
  denotation_nn_1 : N ;
  denotativ_av_1 : A ;
  densitet_nn_1 : N ;
  densitometer_nn_1 : N ;
  densometer_nn_1 : N ;
  dental_av_1 : A ;
  dental_nn_1 : N ;
  dentist_nn_1 : N ;
  denudation_nn_1 : N ;
  denuklearisering_nn_1 : N ;
  deodorant_nn_1 : N ;
  depaa_nn_1 : N ;
  depaafynd_nn_1 : N ;
  departement_nn_1 : N ;
  departemental_av_1 : A ;
  departementsaerende_nn_1 : N ;
  departementschef_nn_1 : N ;
  depens_nn_1 : N ;
  depesch_nn_1 : N ;
  depeschbyraa_nn_1 : N ;
  depolarisator_nn_1 : N ;
  deponens_nn_1 : N ;
  deponent_nn_1 : N ;
  deponentiell_av_1 : A ;
  deportation_nn_1 : N ;
  deportationsort_nn_1 : N ;
  deposition_nn_1 : N ;
  depositionsbevis_nn_1 : N ;
  depositum_nn_1 : N ;
  deppig_av_1 : A ;
  depression_nn_1 : N ;
  depressiv_av_1 : A ;
  deprimerande_av_1 : A ;
  deprivation_nn_1 : N ;
  deputation_nn_1 : N ;
  deputerad_nn_1 : N ;
  derby_nn_1 : N ;
  derivat_nn_1 : N ;
  derivation_nn_1 : N ;
  dermatit_nn_1 : N ;
  dermatolog_nn_1 : N ;
  dermatologisk_av_1 : A ;
  dervisch_nn_1 : N ;
  descendent_nn_1 : N ;
  desegregation_nn_1 : N ;
  desertoer_nn_1 : N ;
  deshabille_nn_1 : N ;
  designer_nn_1 : N ;
  desillusion_nn_1 : N ;
  desinfektion_nn_1 : N ;
  desinfektoer_nn_1 : N ;
  desinformation_nn_1 : N ;
  desintegration_nn_1 : N ;
  deskription_nn_1 : N ;
  deskriptiv_av_1 : A ;
  desperado_nn_1 : N ;
  desperat_av_1 : A ;
  despot_nn_1 : N ;
  despoti_nn_1 : N ;
  despotisk_av_1 : A ;
  dess_ab_1 : Adv ;
  dessaeng_nn_1 : N ;
  dessbaettre_ab_1 : Adv ;
  dessemellan_ab_1 : Adv ;
  dessert_nn_1 : N ;
  dessertgaffel_nn_1 : N ;
  dessertkniv_nn_1 : N ;
  dessertost_nn_1 : N ;
  dessertsaas_nn_1 : N ;
  dessertsked_nn_1 : N ;
  desserttallrik_nn_1 : N ;
  dessertvin_nn_1 : N ;
  dessfoerinnan_ab_1 : Adv ;
  dessfoerutan_ab_1 : Adv ;
  dessinatoer_nn_1 : N ;
  desslikes_ab_1 : Adv ;
  dessutom_ab_1 : Adv ;
  dessvaerre_ab_1 : Adv ;
  destabiliserande_av_1 : A ;
  destillat_nn_1 : N ;
  destillation_nn_1 : N ;
  destillationsapparat_nn_1 : N ;
  destillering_nn_1 : N ;
  destinataer_nn_1 : N ;
  destination_nn_1 : N ;
  destinationsort_nn_1 : N ;
  destinatoer_nn_1 : N ;
  desto_ab_1 : Adv ;
  destruent_nn_1 : N ;
  destruktionsanlaeggning_nn_1 : N ;
  destruktiv_av_1 : A ;
  detachement_nn_1 : N ;
  detachoer_nn_1 : N ;
  detalj_nn_1 : N ;
  detaljanmaerkning_nn_1 : N ;
  detaljfraaga_nn_1 : N ;
  detaljhandlare_nn_1 : N ;
  detaljist_nn_1 : N ;
  detaljkaennedom_nn_1 : N ;
  detaljpris_nn_1 : N ;
  detaljrik_av_1 : A ;
  detaljstudium_nn_1 : N ;
  detaljutfoerande_nn_1 : N ;
  detektiv_av_1 : A ;
  detektiv_nn_1 : N ;
  detektivroman_nn_1 : N ;
  detektor_nn_1 : N ;
  detergent_nn_1 : N ;
  determination_nn_1 : N ;
  determinativ_av_1 : A ;
  determinist_nn_1 : N ;
  deterministisk_av_1 : A ;
  detonation_nn_1 : N ;
  detonationshastighet_nn_1 : N ;
  detonationstryck_nn_1 : N ;
  detonationszon_nn_1 : N ;
  detonator_nn_1 : N ;
  deuce_ab_1 : Adv ;
  deuteron_nn_1 : N ;
  deutron_nn_1 : N ;
  deviation_nn_1 : N ;
  devis_nn_1 : N ;
  devot_av_1 : A ;
  dextran_nn_1 : N ;
  dextrin_nn_1 : N ;
  diabas_nn_1 : N ;
  diabetiker_nn_1 : N ;
  diabild_nn_1 : N ;
  diabolisk_av_1 : A ;
  diadem_nn_1 : N ;
  diafilm_nn_1 : N ;
  diafragma_nn_1 : N ;
  diagnos_nn_1 : N ;
  diagnostiker_nn_1 : N ;
  diagnostisk_av_1 : A ;
  diagonal_av_1 : A ;
  diagonal_nn_1 : N ;
  diagram_nn_1 : N ;
  diakon_nn_1 : N ;
  diakonistyrelse_nn_1 : N ;
  diakritisk_av_1 : A ;
  diakron_av_1 : A ;
  diakronisk_av_1 : A ;
  dialekt_nn_1 : N ;
  dialektal_av_1 : A ;
  dialektgeografisk_av_1 : A ;
  dialektiker_nn_1 : N ;
  dialektisk_av_1 : A ;
  dialektolog_nn_1 : N ;
  dialektologisk_av_1 : A ;
  dialog_nn_1 : N ;
  dialys_nn_1 : N ;
  dialytisk_av_1 : A ;
  diamant_nn_1 : N ;
  diamantborr_nn_1 : N ;
  diamantbroellop_nn_1 : N ;
  diameter_nn_1 : N ;
  diametral_av_1 : A ;
  diapositiv_nn_1 : N ;
  diarienummer_nn_1 : N ;
  diarium_nn_1 : N ;
  diarre_nn_1 : N ;
  diastas_nn_1 : N ;
  diastolisk_av_1 : A ;
  diatonisk_av_1 : A ;
  diatrib_nn_1 : N ;
  dibarn_nn_1 : N ;
  didaktiker_nn_1 : N ;
  didaktisk_av_1 : A ;
  diesel_nn_1 : N ;
  dieselmotor_nn_1 : N ;
  dieselolja_nn_1 : N ;
  diet_nn_1 : N ;
  dietetisk_av_1 : A ;
  dietisk_av_1 : A ;
  dietist_nn_1 : N ;
  differens_nn_1 : N ;
  different_av_1 : A ;
  differential_nn_1 : N ;
  differentialekvation_nn_1 : N ;
  differentialkalkyl_nn_1 : N ;
  differentialspaerr_nn_1 : N ;
  differentialvaexel_nn_1 : N ;
  differentiell_av_1 : A ;
  differentiering_nn_1 : N ;
  diffraktion_nn_1 : N ;
  diffraktionsspektrum_nn_1 : N ;
  diffus_av_1 : A ;
  diftong_nn_1 : N ;
  digel_nn_1 : N ;
  digelpress_nn_1 : N ;
  diger_av_1 : A ;
  digital_av_1 : A ;
  digivning_nn_1 : N ;
  dignitaer_nn_1 : N ;
  dignitet_nn_1 : N ;
  digression_nn_1 : N ;
  dike_nn_1 : N ;
  dikeskoerning_nn_1 : N ;
  dikesren_nn_1 : N ;
  diklin_av_1 : A ;
  diklin_nn_1 : N ;
  dikotomi_nn_1 : N ;
  dikotyledon_av_1 : A ;
  dikotyledon_nn_1 : N ;
  dikt_ab_1 : Adv ;
  dikt_nn_1 : N ;
  diktafon_nn_1 : N ;
  diktamen_nn_1 : N ;
  diktarbegaavning_nn_1 : N ;
  diktare_nn_1 : N ;
  diktargrupp_nn_1 : N ;
  diktat_nn_1 : N ;
  diktator_nn_1 : N ;
  diktatorisk_av_1 : A ;
  diktatur_nn_1 : N ;
  diktcykel_nn_1 : N ;
  dikteringsmaskin_nn_1 : N ;
  diktning_nn_1 : N ;
  diktsamling_nn_1 : N ;
  diktverk_nn_1 : N ;
  dilatation_nn_1 : N ;
  dilatationsfog_nn_1 : N ;
  dildo_nn_1 : N ;
  dilemma_nn_1 : N ;
  dilettant_nn_1 : N ;
  dilettantisk_av_1 : A ;
  dilettantmaessig_av_1 : A ;
  diligens_nn_1 : N ;
  dilleri_nn_1 : N ;
  dillsaas_nn_1 : N ;
  dimbaage_nn_1 : N ;
  dimbank_nn_1 : N ;
  dimbildning_nn_1 : N ;
  dimblaa_av_1 : A ;
  dimension_nn_1 : N ;
  dimensionering_nn_1 : N ;
  dimensionsavverkning_nn_1 : N ;
  dimhoeljd_av_1 : A ;
  diminuendo_ab_1 : Adv ;
  diminuendo_nn_1 : N ;
  diminutiv_av_1 : A ;
  diminutiv_nn_1 : N ;
  dimkammare_nn_1 : N ;
  dimljus_nn_1 : N ;
  dimmig_av_1 : A ;
  dimmoln_nn_1 : N ;
  dimorf_av_1 : A ;
  dimorfi_nn_1 : N ;
  dimridaa_nn_1 : N ;
  dinar_nn_1 : N ;
  dinatriumvaetefosfat_nn_1 : N ;
  dine_nn_1 : N ;
  dinge_nn_1 : N ;
  dingo_nn_1 : N ;
  dinosaur_nn_1 : N ;
  dinosaurie_nn_1 : N ;
  dinosaurieart_nn_1 : N ;
  diod_nn_1 : N ;
  dionysisk_av_1 : A ;
  diopter_nn_1 : N ;
  dioptri_nn_1 : N ;
  dioptrisk_av_1 : A ;
  diorama_nn_1 : N ;
  diorit_nn_1 : N ;
  dioskur_nn_1 : N ;
  dioxin_nn_1 : N ;
  diperiod_nn_1 : N ;
  diplom_nn_1 : N ;
  diplomat_nn_1 : N ;
  diplomatarisk_av_1 : A ;
  diplomatarium_nn_1 : N ;
  diplomatisk_av_1 : A ;
  diplomingenjoer_nn_1 : N ;
  dipol_nn_1 : N ;
  dipsoman_nn_1 : N ;
  diptyk_nn_1 : N ;
  direkt_av_1 : A ;
  direkthet_nn_1 : N ;
  direktinflytande_nn_1 : N ;
  direktinsprutning_nn_1 : N ;
  direktion_nn_1 : N ;
  direktiv_nn_1 : N ;
  direktkontakt_nn_1 : N ;
  direktlinje_nn_1 : N ;
  direktmetod_nn_1 : N ;
  direktoer_nn_1 : N ;
  direktor_nn_1 : N ;
  direktreferat_nn_1 : N ;
  direktris_nn_1 : N ;
  direktsaendning_nn_1 : N ;
  direktskott_nn_1 : N ;
  direktvaexel_nn_1 : N ;
  dirigent_nn_1 : N ;
  dirk_nn_1 : N ;
  dis_nn_2 : N ;
  disackarid_nn_1 : N ;
  discipel_nn_1 : N ;
  disciplin_nn_1 : N ;
  disciplinaer_av_1 : A ;
  disciplinbot_nn_1 : N ;
  disciplinmaal_nn_1 : N ;
  disciplinstraff_nn_1 : N ;
  discjockey_nn_1 : N ;
  disco_nn_1 : N ;
  disharmoni_nn_1 : N ;
  disharmonisk_av_1 : A ;
  disig_av_1 : A ;
  disjunkt_av_1 : A ;
  disjunktion_nn_1 : N ;
  disjunktiv_av_1 : A ;
  disk_nn_1 : N ;
  diskant_nn_1 : N ;
  diskantklav_nn_1 : N ;
  diskare_nn_1 : N ;
  diskbaenk_nn_1 : N ;
  diskbraack_nn_1 : N ;
  diskett_nn_1 : N ;
  diskho_nn_1 : N ;
  diskjockey_nn_1 : N ;
  diskmaskin_nn_1 : N ;
  diskmedel_nn_1 : N ;
  disko_nn_1 : N ;
  diskofil_nn_1 : N ;
  diskontinuerlig_av_1 : A ;
  diskontinuitet_nn_1 : N ;
  diskonto_nn_1 : N ;
  diskontoer_nn_1 : N ;
  diskordans_nn_1 : N ;
  diskordant_av_1 : A ;
  diskotek_nn_1 : N ;
  diskplockare_nn_1 : N ;
  diskrepans_nn_1 : N ;
  diskret_av_1 : A ;
  diskriminering_nn_1 : N ;
  diskstaell_nn_1 : N ;
  disktorkning_nn_1 : N ;
  diskurs_nn_1 : N ;
  diskursiv_av_1 : A ;
  diskus_nn_1 : N ;
  diskuskastning_nn_1 : N ;
  diskussion_nn_1 : N ;
  diskussionsprotokoll_nn_1 : N ;
  diskutabel_av_1 : A ;
  diskvalificering_nn_1 : N ;
  diskvalifikation_nn_1 : N ;
  dislokation_nn_1 : N ;
  disoes_nn_1 : N ;
  disparat_av_1 : A ;
  dispasch_nn_1 : N ;
  dispaschoer_nn_1 : N ;
  dispens_nn_1 : N ;
  dispensaer_nn_1 : N ;
  dispers_av_1 : A ;
  display_nn_1 : N ;
  disponent_nn_1 : N ;
  disponibel_av_1 : A ;
  disponibilitet_nn_1 : N ;
  disposition_nn_1 : N ;
  dispositionsfond_nn_1 : N ;
  dispositiv_av_1 : A ;
  disproportion_nn_1 : N ;
  disproportionerlig_av_1 : A ;
  disputation_nn_1 : N ;
  dispyt_nn_1 : N ;
  dissektion_nn_1 : N ;
  dissenter_nn_1 : N ;
  dissertation_nn_1 : N ;
  dissident_nn_1 : N ;
  dissimilation_nn_1 : N ;
  dissociation_nn_1 : N ;
  dissonans_nn_1 : N ;
  dissonant_av_1 : A ;
  dissonant_nn_1 : N ;
  distans_nn_1 : N ;
  distansflygning_nn_1 : N ;
  distansminut_nn_1 : N ;
  distikon_nn_1 : N ;
  distinkt_av_1 : A ;
  distinktion_nn_1 : N ;
  distorsion_nn_1 : N ;
  distraktion_nn_1 : N ;
  distraktor_nn_1 : N ;
  distribuent_nn_1 : N ;
  distribunal_nn_1 : N ;
  distribution_nn_1 : N ;
  distributionscentral_nn_1 : N ;
  distributiv_av_1 : A ;
  distributoer_nn_1 : N ;
  distrikt_nn_1 : N ;
  distriktslaekare_nn_1 : N ;
  distriktsmaestare_nn_1 : N ;
  distriktsmaesterskap_nn_1 : N ;
  dit_ab_1 : Adv ;
  ditaat_ab_1 : Adv ;
  dithaen_ab_1 : Adv ;
  dithoerande_av_1 : A ;
  ditintills_ab_1 : Adv ;
  dito_av_1 : A ;
  dittills_ab_1 : Adv ;
  dittillsvarande_av_1 : A ;
  dityramb_nn_1 : N ;
  dityrambisk_av_1 : A ;
  divan_nn_1 : N ;
  divergens_nn_1 : N ;
  divergent_av_1 : A ;
  diverse_av_1 : A ;
  diversearbetare_nn_1 : N ;
  diversehandel_nn_1 : N ;
  diversion_nn_1 : N ;
  divertissemang_nn_1 : N ;
  dividend_nn_1 : N ;
  divig_av_1 : A ;
  divinatorisk_av_1 : A ;
  divis_nn_1 : N ;
  division_nn_1 : N ;
  divisor_nn_1 : N ;
  djaekne_nn_1 : N ;
  djaerv_av_1 : A ;
  djaervhet_nn_1 : N ;
  djaevel_nn_1 : N ;
  djaevla_av_1 : A ;
  djaevlig_av_1 : A ;
  djaevul_nn_1 : N ;
  djaevulsk_av_1 : A ;
  djaevulskap_nn_1 : N ;
  djaevulstyg_nn_1 : N ;
  djiboutier_nn_1 : N ;
  djiboutisk_av_1 : A ;
  djonk_nn_1 : N ;
  djungel_nn_1 : N ;
  djup_av_1 : A ;
  djup_nn_1 : N ;
  djupbergart_nn_1 : N ;
  djupbild_nn_1 : N ;
  djupblaa_av_1 : A ;
  djupborrande_av_1 : A ;
  djupborrning_nn_1 : N ;
  djupbrytning_nn_1 : N ;
  djupdimension_nn_1 : N ;
  djupdykning_nn_1 : N ;
  djupgaaende_av_1 : A ;
  djuphavsbotten_nn_1 : N ;
  djuphavsfisk_nn_1 : N ;
  djuphavsvatten_nn_1 : N ;
  djuping_nn_1 : N ;
  djupintervju_nn_1 : N ;
  djuplek_nn_1 : N ;
  djuplod_nn_1 : N ;
  djuplodande_av_1 : A ;
  djupmask_nn_1 : N ;
  djuproed_av_1 : A ;
  djupsinnig_av_1 : A ;
  djupsinnighet_nn_1 : N ;
  djupstruktur_nn_1 : N ;
  djuptaenkt_av_1 : A ;
  djuptryck_nn_1 : N ;
  djupvatten_nn_1 : N ;
  djur_nn_1 : N ;
  djurangrepp_nn_1 : N ;
  djurart_nn_1 : N ;
  djurben_nn_1 : N ;
  djurdel_nn_1 : N ;
  djurfabel_nn_1 : N ;
  djurfoder_nn_1 : N ;
  djurfoersoek_nn_1 : N ;
  djurgaard_nn_1 : N ;
  djurgrupp_nn_1 : N ;
  djurhud_nn_1 : N ;
  djurisk_av_1 : A ;
  djurkropp_nn_1 : N ;
  djurlaekare_nn_1 : N ;
  djurpark_nn_1 : N ;
  djurplaagare_nn_1 : N ;
  djurplankton_nn_1 : N ;
  djursjukhus_nn_1 : N ;
  djurskinn_nn_1 : N ;
  djurskoetare_nn_1 : N ;
  djurslag_nn_1 : N ;
  djurtarm_nn_1 : N ;
  djurutstaellning_nn_1 : N ;
  djurvaen_nn_1 : N ;
  djurvaenlig_av_1 : A ;
  doakoer_nn_1 : N ;
  docent_nn_1 : N ;
  docentur_nn_1 : N ;
  dock_ab_1 : Adv ;
  dockskaap_nn_1 : N ;
  docksoet_av_1 : A ;
  dockteater_nn_1 : N ;
  dodekaeder_nn_1 : N ;
  doebattang_nn_1 : N ;
  doed_av_1 : A ;
  doed_nn_1 : N ;
  doedande_av_1 : A ;
  doedbraend_av_1 : A ;
  doeddansare_nn_1 : N ;
  doedfoedd_av_1 : A ;
  doedfull_av_1 : A ;
  doedgraevare_nn_1 : N ;
  doeding_nn_1 : N ;
  doedlaege_nn_1 : N ;
  doedlig_av_1 : A ;
  doedlighet_nn_1 : N ;
  doedperiod_nn_1 : N ;
  doedsannons_nn_1 : N ;
  doedsattest_nn_1 : N ;
  doedsbaedd_nn_1 : N ;
  doedsbevis_nn_1 : N ;
  doedsblek_av_1 : A ;
  doedsbo_nn_1 : N ;
  doedsdans_nn_1 : N ;
  doedsdoemd_av_1 : A ;
  doedsdom_nn_1 : N ;
  doedsfall_nn_1 : N ;
  doedsfara_nn_1 : N ;
  doedsfas_nn_1 : N ;
  doedsfiende_nn_1 : N ;
  doedsfoeraktande_av_1 : A ;
  doedsfoerskraeckt_av_1 : A ;
  doedskalle_nn_1 : N ;
  doedskallefjaeril_nn_1 : N ;
  doedskamp_nn_1 : N ;
  doedsmaerkt_av_1 : A ;
  doedsmask_nn_1 : N ;
  doedsoffer_nn_1 : N ;
  doedsorsak_nn_1 : N ;
  doedspatrull_nn_1 : N ;
  doedsrike_nn_1 : N ;
  doedssjuk_av_1 : A ;
  doedsstelhet_nn_1 : N ;
  doedsstoet_nn_1 : N ;
  doedsstraff_nn_1 : N ;
  doedssynd_nn_1 : N ;
  doedstroett_av_1 : A ;
  doedstyst_av_1 : A ;
  doedsur_nn_1 : N ;
  doegling_nn_1 : N ;
  doeing_nn_1 : N ;
  doerj_nn_1 : N ;
  doerr_nn_1 : N ;
  doerrfoerhaenge_nn_1 : N ;
  doerrfoersaeljare_nn_1 : N ;
  doerrhandtag_nn_1 : N ;
  doerrkarm_nn_1 : N ;
  doerrkedja_nn_1 : N ;
  doerrknackare_nn_1 : N ;
  doerroeppning_nn_1 : N ;
  doerrpost_nn_1 : N ;
  doerrspegel_nn_1 : N ;
  doerrstaengare_nn_1 : N ;
  does_nn_1 : N ;
  doeskraj_av_1 : A ;
  doev_av_1 : A ;
  doevhet_nn_1 : N ;
  doevstum_av_1 : A ;
  doft_nn_1 : N ;
  doftaemne_nn_1 : N ;
  doftloes_av_1 : A ;
  doftmarkering_nn_1 : N ;
  dogcart_nn_1 : N ;
  doge_nn_1 : N ;
  dogg_nn_1 : N ;
  dogm_nn_1 : N ;
  dogmatiker_nn_1 : N ;
  dogmatisk_av_1 : A ;
  dok_nn_1 : N ;
  doktor_nn_1 : N ;
  doktorand_nn_1 : N ;
  doktorsavhandling_nn_1 : N ;
  doktorsdisputation_nn_1 : N ;
  doktorsexamen_nn_1 : N ;
  doktorsgrad_nn_1 : N ;
  doktorshatt_nn_1 : N ;
  doktorspromotion_nn_1 : N ;
  doktrin_nn_1 : N ;
  doktrinaer_av_1 : A ;
  dokument_nn_1 : N ;
  dokumentaer_av_1 : A ;
  dokumentaer_nn_1 : N ;
  dokumentaerfilm_nn_1 : N ;
  dokumentaerprogram_nn_1 : N ;
  dokumentaerroman_nn_1 : N ;
  dokumentalist_nn_1 : N ;
  dokumentarisk_av_1 : A ;
  dokumentation_nn_1 : N ;
  dokumentkreditiv_nn_1 : N ;
  dokumentportfoelj_nn_1 : N ;
  dokumentsamling_nn_1 : N ;
  dold_av_1 : A ;
  doldis_nn_1 : N ;
  dolikocefal_av_1 : A ;
  dolikocefal_nn_1 : N ;
  dolikocefali_nn_1 : N ;
  dolk_nn_1 : N ;
  dolkstoet_nn_1 : N ;
  dollar_nn_1 : N ;
  dollargrin_nn_1 : N ;
  dollarturist_nn_1 : N ;
  dolma_nn_1 : N ;
  dolomit_nn_1 : N ;
  dolsk_av_1 : A ;
  dom_nn_1 : N ;
  dom_nn_2 : N ;
  domaen_nn_1 : N ;
  domaenverk_nn_1 : N ;
  domare_nn_1 : N ;
  domared_nn_1 : N ;
  domaredans_nn_1 : N ;
  domarring_nn_1 : N ;
  dombok_nn_1 : N ;
  domedagspredikning_nn_1 : N ;
  domedagsprofet_nn_1 : N ;
  domestik_nn_1 : N ;
  domfoer_av_1 : A ;
  domhavande_av_1 : A ;
  domherre_nn_1 : N ;
  domicil_nn_1 : N ;
  dominant_av_1 : A ;
  dominant_nn_1 : N ;
  dominerande_av_1 : A ;
  dominikan_nn_1 : N ;
  dominikanerorden_nn_1 : N ;
  dominikanmunk_nn_1 : N ;
  dominikansk_av_1 : A ;
  dominiker_nn_1 : N ;
  dominikisk_av_1 : A ;
  dominion_nn_1 : N ;
  domino_nn_1 : N ;
  dominoteori_nn_1 : N ;
  domkapitel_nn_1 : N ;
  domkraft_nn_1 : N ;
  domkval_nn_1 : N ;
  domkyrka_nn_1 : N ;
  domprost_nn_1 : N ;
  domptoer_nn_1 : N ;
  domsaga_nn_1 : N ;
  domskael_nn_1 : N ;
  domslut_nn_1 : N ;
  domsoendag_nn_1 : N ;
  domssoendag_nn_1 : N ;
  domstol_nn_1 : N ;
  domstolsmaal_nn_1 : N ;
  domstolsprotokoll_nn_1 : N ;
  domstolsverk_nn_1 : N ;
  don_nn_1 : N ;
  donation_nn_1 : N ;
  donationsbrev_nn_1 : N ;
  donator_nn_1 : N ;
  doning_nn_1 : N ;
  donjuan_nn_1 : N ;
  donlaege_nn_1 : N ;
  dop_nn_1 : N ;
  dopamin_nn_1 : N ;
  dopaminkaenslig_av_1 : A ;
  dopattest_nn_1 : N ;
  dopbassaeng_nn_1 : N ;
  dopfunt_nn_1 : N ;
  dopnamn_nn_1 : N ;
  dopp_nn_1 : N ;
  dopping_nn_1 : N ;
  doppsko_nn_1 : N ;
  doppvaermare_nn_1 : N ;
  dopvittne_nn_1 : N ;
  dorer_nn_1 : N ;
  dorisk_av_1 : A ;
  dormitorium_nn_1 : N ;
  dorn_nn_1 : N ;
  dorsal_av_1 : A ;
  dorsal_nn_1 : N ;
  dorsk_av_1 : A ;
  dos_nn_1 : N ;
  dosbarometer_nn_1 : N ;
  dosekvivalent_nn_1 : N ;
  dosering_nn_1 : N ;
  dosimeter_nn_1 : N ;
  doslibell_nn_1 : N ;
  dosmaetare_nn_1 : N ;
  dossering_nn_1 : N ;
  dossier_nn_1 : N ;
  dotation_nn_1 : N ;
  dotter_nn_1 : N ;
  dotterbolag_nn_1 : N ;
  dottercell_nn_1 : N ;
  dotterdotter_nn_1 : N ;
  dotterfoeretag_nn_1 : N ;
  dotterfoersamling_nn_1 : N ;
  dotterlig_av_1 : A ;
  dotterson_nn_1 : N ;
  dotterspraak_nn_1 : N ;
  dottersvulst_nn_1 : N ;
  dottertumoer_nn_1 : N ;
  double_nn_2 : N ;
  dov_av_1 : A ;
  dovhjort_nn_1 : N ;
  downperiod_nn_1 : N ;
  doyen_nn_1 : N ;
  dra_vb_1 : V ;
  draap_nn_1 : N ;
  draapare_nn_1 : N ;
  draaplig_av_1 : A ;
  draapslag_nn_1 : N ;
  draase_nn_1 : N ;
  drabant_nn_1 : N ;
  drabantstat_nn_1 : N ;
  drabbning_nn_1 : N ;
  draeglig_av_1 : A ;
  draekt_nn_1 : N ;
  draektig_av_1 : A ;
  draektighet_nn_1 : N ;
  draen_nn_1 : N ;
  draenering_nn_1 : N ;
  draeneringsdike_nn_1 : N ;
  draeneringsomraade_nn_1 : N ;
  draeng_nn_1 : N ;
  draengtjaenst_nn_1 : N ;
  draepande_av_1 : A ;
  draetselkammare_nn_1 : N ;
  draett_nn_1 : N ;
  drag_nn_1 : N ;
  dragare_nn_1 : N ;
  dragbaenk_nn_1 : N ;
  dragband_nn_1 : N ;
  dragbasun_nn_1 : N ;
  dragbil_nn_1 : N ;
  dragdjur_nn_1 : N ;
  drage_nn_1 : N ;
  dragen_av_1 : A ;
  dragg_nn_1 : N ;
  draghaallfasthet_nn_1 : N ;
  dragig_av_1 : A ;
  dragkamp_nn_1 : N ;
  dragkedja_nn_1 : N ;
  dragkrok_nn_1 : N ;
  dragnagel_nn_1 : N ;
  dragning_nn_1 : N ;
  dragoman_nn_1 : N ;
  dragon_nn_1 : N ;
  dragplaaster_nn_1 : N ;
  dragpress_nn_1 : N ;
  dragprov_nn_1 : N ;
  dragshow_nn_1 : N ;
  dragskaap_nn_1 : N ;
  dragsko_nn_1 : N ;
  dragspel_nn_1 : N ;
  dragstift_nn_1 : N ;
  drakblodstraed_nn_1 : N ;
  drake_nn_1 : N ;
  drakflygare_nn_1 : N ;
  drakhuvudfisk_nn_1 : N ;
  drakma_nn_1 : N ;
  drakonisk_av_1 : A ;
  draksaadd_nn_1 : N ;
  drakskepp_nn_1 : N ;
  dram_nn_1 : N ;
  drama_nn_1 : N ;
  dramatiker_nn_1 : N ;
  dramatisering_nn_1 : N ;
  dramatisk_av_1 : A ;
  dramaturg_nn_1 : N ;
  draperi_nn_1 : N ;
  drapering_nn_1 : N ;
  drastisk_av_1 : A ;
  drasut_nn_1 : N ;
  dress_nn_1 : N ;
  dressin_nn_1 : N ;
  dressing_nn_1 : N ;
  dressoer_nn_1 : N ;
  dressyr_nn_1 : N ;
  dressyrridning_nn_1 : N ;
  drev_nn_1 : N ;
  drever_nn_1 : N ;
  drevhund_nn_1 : N ;
  drevjakt_nn_1 : N ;
  drevkarl_nn_1 : N ;
  dribbler_nn_1 : N ;
  dribbling_nn_1 : N ;
  dricka_vb_1 : V ;
  drickankare_nn_1 : N ;
  drickbar_av_1 : A ;
  dricksglas_nn_1 : N ;
  drickspeng_nn_1 : N ;
  dricksvatten_nn_1 : N ;
  drift_nn_2 : N ;
  driftbudget_nn_1 : N ;
  driftig_av_1 : A ;
  driftkostnad_nn_1 : N ;
  driftkucku_nn_1 : N ;
  driftsaeker_av_1 : A ;
  driftskostnad_nn_1 : N ;
  driftstopp_nn_1 : N ;
  drill_nn_1 : N ;
  drillborr_nn_1 : N ;
  drilling_nn_1 : N ;
  drink_nn_1 : N ;
  drinkare_nn_1 : N ;
  dristig_av_1 : A ;
  drittel_nn_1 : N ;
  driv_nn_1 : N ;
  driva_vb_1 : V ;
  drivande_av_1 : A ;
  drivankare_nn_1 : N ;
  drivaxel_nn_1 : N ;
  drivbaenk_nn_1 : N ;
  drivband_nn_1 : N ;
  drive_nn_1 : N ;
  driven_av_1 : A ;
  drivfjaeder_nn_1 : N ;
  drivgarn_nn_1 : N ;
  drivhjul_nn_1 : N ;
  drivhus_nn_1 : N ;
  drivkedja_nn_1 : N ;
  drivkraft_nn_1 : N ;
  drivmedel_nn_1 : N ;
  droeg_nn_1 : N ;
  droeglapp_nn_1 : N ;
  droejsmaal_nn_1 : N ;
  droem_nn_1 : N ;
  droembok_nn_1 : N ;
  droemmare_nn_1 : N ;
  droemmeri_nn_1 : N ;
  droemsk_av_1 : A ;
  droemslott_nn_1 : N ;
  droemtydning_nn_1 : N ;
  droemvaerld_nn_1 : N ;
  droenare_nn_1 : N ;
  droes_nn_1 : N ;
  droese_nn_1 : N ;
  drog_nn_1 : N ;
  drogeri_nn_1 : N ;
  droghandel_nn_1 : N ;
  drogmissbruk_nn_1 : N ;
  drogmissbrukare_nn_1 : N ;
  dromedar_nn_1 : N ;
  dront_nn_1 : N ;
  droppe_nn_1 : N ;
  droppglas_nn_1 : N ;
  droppinfektion_nn_1 : N ;
  droppkork_nn_1 : N ;
  droppspets_nn_1 : N ;
  droppsten_nn_1 : N ;
  droppvis_ab_1 : Adv ;
  droskfoerare_nn_1 : N ;
  drossel_nn_1 : N ;
  drots_nn_1 : N ;
  drott_nn_1 : N ;
  drottning_nn_1 : N ;
  drucken_av_1 : A ;
  drufs_nn_1 : N ;
  druid_nn_1 : N ;
  drul_nn_1 : N ;
  drulle_nn_1 : N ;
  drullefoersaekring_nn_1 : N ;
  drullig_av_1 : A ;
  drullputt_nn_1 : N ;
  drumlig_av_1 : A ;
  drummel_nn_1 : N ;
  drummelaktig_av_1 : A ;
  drunkning_nn_1 : N ;
  drus_nn_1 : N ;
  druvblaa_av_1 : A ;
  druvboerd_nn_1 : N ;
  druvflaeder_nn_1 : N ;
  druvhagel_nn_1 : N ;
  druvklase_nn_1 : N ;
  druvrussin_nn_1 : N ;
  dryad_nn_1 : N ;
  dryck_nn_1 : N ;
  dryckesbroder_nn_1 : N ;
  dryckeshorn_nn_1 : N ;
  dryckeskaerl_nn_1 : N ;
  dryckeslag_nn_1 : N ;
  dryckesoffer_nn_1 : N ;
  dryckesservis_nn_1 : N ;
  dryg_av_1 : A ;
  dryghet_nn_1 : N ;
  dualist_nn_1 : N ;
  dualistisk_av_1 : A ;
  dubb_nn_1 : N ;
  dubbdaeck_nn_1 : N ;
  dubbel_av_1 : A ;
  dubbelagent_nn_1 : N ;
  dubbelarbetande_av_1 : A ;
  dubbelbeckasin_nn_1 : N ;
  dubbelbiff_nn_1 : N ;
  dubbelbindning_nn_1 : N ;
  dubbelbluff_nn_1 : N ;
  dubbelbotten_nn_1 : N ;
  dubbelbredd_nn_1 : N ;
  dubbelbroellop_nn_1 : N ;
  dubbelbrytning_nn_1 : N ;
  dubbeldaeckare_nn_1 : N ;
  dubbeldoerr_nn_1 : N ;
  dubbelfel_nn_1 : N ;
  dubbelfoenster_nn_1 : N ;
  dubbelgaangare_nn_1 : N ;
  dubbelgrepp_nn_1 : N ;
  dubbelhet_nn_1 : N ;
  dubbelhytt_nn_1 : N ;
  dubbelkommando_nn_1 : N ;
  dubbelkontakt_nn_1 : N ;
  dubbelmening_nn_1 : N ;
  dubbelmord_nn_1 : N ;
  dubbelnamn_nn_1 : N ;
  dubbelnatur_nn_1 : N ;
  dubbelnoet_nn_1 : N ;
  dubbelpipig_av_1 : A ;
  dubbelrevolution_nn_1 : N ;
  dubbelroer_nn_1 : N ;
  dubbelroll_nn_1 : N ;
  dubbelrum_nn_1 : N ;
  dubbelsaeng_nn_1 : N ;
  dubbelsalt_nn_1 : N ;
  dubbelsidig_av_1 : A ;
  dubbelspel_nn_1 : N ;
  dubbelstjaernsystem_nn_1 : N ;
  dubbeltimme_nn_1 : N ;
  dubbeltraadig_av_1 : A ;
  dubbeltraeff_nn_1 : N ;
  dubbeltydig_av_1 : A ;
  dubble_nn_2 : N ;
  dubblett_nn_1 : N ;
  dubioes_av_1 : A ;
  dublett_nn_1 : N ;
  duchatel_nn_1 : N ;
  duell_nn_1 : N ;
  duellant_nn_1 : N ;
  duett_nn_1 : N ;
  duffel_nn_1 : N ;
  dugande_av_1 : A ;
  duggregn_nn_1 : N ;
  duglig_av_1 : A ;
  duglighet_nn_1 : N ;
  duk_nn_1 : N ;
  dukagaang_nn_1 : N ;
  dukat_nn_1 : N ;
  dukning_nn_1 : N ;
  dukt_nn_1 : N ;
  duktig_av_1 : A ;
  dulcian_nn_1 : N ;
  dum_av_1 : A ;
  dumbom_nn_1 : N ;
  dumdristig_av_1 : A ;
  dumdryg_av_1 : A ;
  dumhet_nn_1 : N ;
  dumhuvud_nn_1 : N ;
  dummerjoens_nn_1 : N ;
  dumming_nn_1 : N ;
  dummy_nn_1 : N ;
  dumper_nn_1 : N ;
  dumskalle_nn_1 : N ;
  dumsnut_nn_1 : N ;
  dun_nn_1 : N ;
  dunboll_nn_1 : N ;
  dunder_nn_1 : N ;
  dunge_nn_1 : N ;
  dunig_av_1 : A ;
  dunk_nn_1 : N ;
  dunkel_av_1 : A ;
  dunkelblaa_av_1 : A ;
  dunlaett_av_1 : A ;
  duns_nn_1 : N ;
  dunst_nn_1 : N ;
  dunstig_av_1 : A ;
  dununge_nn_1 : N ;
  duo_nn_1 : N ;
  duodecimalsystem_nn_1 : N ;
  duodes_nn_1 : N ;
  duplett_nn_1 : N ;
  duplexfaerg_nn_1 : N ;
  duplicering_nn_1 : N ;
  duplik_nn_1 : N ;
  duplikat_nn_1 : N ;
  duplikator_nn_1 : N ;
  durabel_av_1 : A ;
  duralexglas_nn_1 : N ;
  durativ_av_1 : A ;
  dureform_nn_1 : N ;
  durk_nn_1 : N ;
  durkdriven_av_1 : A ;
  durkslag_nn_1 : N ;
  duroplast_nn_1 : N ;
  dus_nn_1 : N ;
  dusch_nn_1 : N ;
  duskaal_nn_1 : N ;
  dusoer_nn_1 : N ;
  dussin_nn_1 : N ;
  dussinmaenniska_nn_1 : N ;
  dussinroman_nn_1 : N ;
  dussintal_nn_1 : N ;
  dussintals_ab_1 : Adv ;
  dussinvis_ab_1 : Adv ;
  dust_nn_1 : N ;
  duvblaa_av_1 : A ;
  duven_av_1 : A ;
  duvfaagel_nn_1 : N ;
  duvhoek_nn_1 : N ;
  duvning_nn_1 : N ;
  duvslag_nn_1 : N ;
  duvunge_nn_1 : N ;
  dvaerg_nn_1 : N ;
  dvaergbjoerk_nn_1 : N ;
  dvaergbrytare_nn_1 : N ;
  dvaergbuske_nn_1 : N ;
  dvaerggalax_nn_1 : N ;
  dvaerghamster_nn_1 : N ;
  dvaerghund_nn_1 : N ;
  dyblad_nn_1 : N ;
  dybloet_av_1 : A ;
  dyborre_nn_1 : N ;
  dyckert_nn_1 : N ;
  dygd_nn_1 : N ;
  dygdemoenster_nn_1 : N ;
  dygdig_av_1 : A ;
  dygn_nn_1 : N ;
  dygnsring_nn_1 : N ;
  dygnsrytm_nn_1 : N ;
  dyig_av_1 : A ;
  dykand_nn_1 : N ;
  dykarbagge_nn_1 : N ;
  dykardraekt_nn_1 : N ;
  dykare_nn_1 : N ;
  dykarutrustning_nn_1 : N ;
  dykdalb_nn_1 : N ;
  dykning_nn_1 : N ;
  dymedelst_ab_1 : Adv ;
  dymling_nn_1 : N ;
  dymmelonsdag_nn_1 : N ;
  dymmelvecka_nn_1 : N ;
  dyn_nn_1 : N ;
  dyn_nn_2 : N ;
  dynamisk_av_1 : A ;
  dynamitard_nn_1 : N ;
  dynamitgubbe_nn_1 : N ;
  dynamo_nn_1 : N ;
  dynamometer_nn_1 : N ;
  dynasti_nn_1 : N ;
  dynastisk_av_1 : A ;
  dyngbagge_nn_1 : N ;
  dyning_nn_1 : N ;
  dyr_av_1 : A ;
  dyrbar_av_1 : A ;
  dyrbarhet_nn_1 : N ;
  dyrgrip_nn_1 : N ;
  dyrk_nn_1 : N ;
  dyrkansvaerd_av_1 : A ;
  dyrkare_nn_1 : N ;
  dyrkfri_av_1 : A ;
  dyrkoept_av_1 : A ;
  dyrort_nn_1 : N ;
  dyrortsgrupp_nn_1 : N ;
  dyrortsgruppering_nn_1 : N ;
  dyrtid_nn_1 : N ;
  dys_nn_1 : N ;
  dyschatell_nn_1 : N ;
  dysenteri_nn_1 : N ;
  dysfori_nn_1 : N ;
  dyslexi_nn_1 : N ;
  dyspepsi_nn_1 : N ;
  dyster_av_1 : A ;
  dystopi_nn_1 : N ;
  dystrof_av_1 : A ;
  dystrofi_nn_1 : N ;
  dyvaat_av_1 : A ;
  e_brev_nn_1 : N ;
  e_mail_nn_2 : N ;
  ebenist_nn_1 : N ;
  ebonitstav_nn_1 : N ;
  echelong_nn_1 : N ;
  ecklesiastik_av_1 : A ;
  ecklesiastikdepartement_nn_1 : N ;
  ecklesiastikminister_nn_1 : N ;
  ecklesiastisk_av_1 : A ;
  ecuadorian_nn_1 : N ;
  ecuadoriansk_av_1 : A ;
  ecuadorianska_nn_1 : N ;
  ed_ab_1 : Adv ;
  ed_nn_1 : N ;
  ed_nn_2 : N ;
  edamerost_nn_1 : N ;
  edgaang_nn_1 : N ;
  edikt_nn_1 : N ;
  edil_nn_1 : N ;
  edition_nn_1 : N ;
  edlig_av_1 : A ;
  edligen_ab_1 : Adv ;
  edsbrott_nn_1 : N ;
  edsvuren_av_1 : A ;
  efedrin_nn_1 : N ;
  efemaer_av_1 : A ;
  efemerid_nn_1 : N ;
  effekt_nn_1 : N ;
  effektfaktor_nn_1 : N ;
  effektfoerstaerkare_nn_1 : N ;
  effektfraanskiljare_nn_1 : N ;
  effektfull_av_1 : A ;
  effektiv_av_1 : A ;
  effektivitet_nn_1 : N ;
  effektoekning_nn_1 : N ;
  effektsoekeri_nn_1 : N ;
  efor_nn_1 : N ;
  eforus_nn_1 : N ;
  efter_ab_1 : Adv ;
  efter_av_1 : A ;
  efteraat_ab_1 : Adv ;
  efteraccept_nn_1 : N ;
  efterbesiktning_nn_1 : N ;
  efterbeskattning_nn_1 : N ;
  efterbestaellning_nn_1 : N ;
  efterbild_nn_1 : N ;
  efterbildning_nn_1 : N ;
  efterbliven_av_1 : A ;
  efterbloedning_nn_1 : N ;
  efterboerd_nn_1 : N ;
  efterboers_nn_1 : N ;
  efterbraennare_nn_1 : N ;
  efterbraennkammare_nn_1 : N ;
  efterdoeme_nn_1 : N ;
  efterdoemlig_av_1 : A ;
  efterdyning_nn_1 : N ;
  efterfoeljansvaerd_av_1 : A ;
  efterfoeljare_nn_1 : N ;
  efterfoeljelse_nn_1 : N ;
  efterforskning_nn_1 : N ;
  efterfraagning_nn_1 : N ;
  efterge_vb_1 : V ;
  eftergift_nn_1 : N ;
  eftergiven_av_1 : A ;
  eftergivenhet_nn_1 : N ;
  eftergivlig_av_1 : A ;
  eftergjord_av_1 : A ;
  eftergranskning_nn_1 : N ;
  eftergymnasial_av_1 : A ;
  efterhaalla_vb_1 : V ;
  efterhaengsen_av_1 : A ;
  efterhaermning_nn_1 : N ;
  efterhand_ab_1 : Adv ;
  efterhandskonstruktion_nn_1 : N ;
  efterhoest_nn_1 : N ;
  efterkaenning_nn_1 : N ;
  efterklang_nn_1 : N ;
  efterklok_av_1 : A ;
  efterkokning_nn_1 : N ;
  efterkomma_vb_1 : V ;
  efterkommande_nn_1 : N ;
  efterkonstruktion_nn_1 : N ;
  efterkontroll_nn_1 : N ;
  efterkrav_nn_1 : N ;
  efterkrigstid_nn_1 : N ;
  efterlaata_vb_1 : V ;
  efterlaaten_av_1 : A ;
  efterled_nn_1 : N ;
  efterlevande_av_1 : A ;
  efterleverska_nn_1 : N ;
  efterlevnad_nn_1 : N ;
  efterliggande_av_1 : A ;
  efterlysning_nn_1 : N ;
  eftermaele_nn_1 : N ;
  eftermiddag_nn_1 : N ;
  efternamn_nn_1 : N ;
  efterproevning_nn_1 : N ;
  efterraekning_nn_1 : N ;
  efterraett_nn_1 : N ;
  efterrationalisering_nn_1 : N ;
  eftersaegare_nn_1 : N ;
  eftersaettsblad_nn_1 : N ;
  eftersats_nn_1 : N ;
  eftersinnande_av_1 : A ;
  eftersits_nn_1 : N ;
  efterskott_nn_1 : N ;
  efterskrift_nn_1 : N ;
  efterslaeng_nn_1 : N ;
  efterslaentrare_nn_1 : N ;
  efterslag_nn_1 : N ;
  eftersoekt_av_1 : A ;
  eftersommar_nn_1 : N ;
  efterspaning_nn_1 : N ;
  efterspel_nn_1 : N ;
  efterst_ab_1 : Adv ;
  efterstaelld_av_1 : A ;
  efterstraevansvaerd_av_1 : A ;
  efterstygn_nn_1 : N ;
  eftertaenksam_av_1 : A ;
  eftertaxering_nn_1 : N ;
  eftertextnot_nn_1 : N ;
  eftertraedare_nn_1 : N ;
  eftertraktansvaerd_av_1 : A ;
  eftertrupp_nn_1 : N ;
  eftertryck_nn_1 : N ;
  eftertrycklig_av_1 : A ;
  eftertryckligen_ab_1 : Adv ;
  efterundersoekning_nn_1 : N ;
  efterutbildning_nn_1 : N ;
  efterverkning_nn_1 : N ;
  eftervinter_nn_1 : N ;
  eftervis_av_1 : A ;
  egal_av_1 : A ;
  egalitaer_av_1 : A ;
  egalitet_nn_1 : N ;
  egeisk_av_1 : A ;
  egen_av_1 : A ;
  egendom_nn_1 : N ;
  egendomlig_av_1 : A ;
  egendomlighet_nn_1 : N ;
  egendomsaffaer_nn_1 : N ;
  egendomsbrott_nn_1 : N ;
  egendomsfoersaeljning_nn_1 : N ;
  egendomsloes_av_1 : A ;
  egenfrekvens_nn_1 : N ;
  egenhaendig_av_1 : A ;
  egenhet_nn_1 : N ;
  egenkaer_av_1 : A ;
  egenkaerlek_nn_1 : N ;
  egenmaektig_av_1 : A ;
  egennamn_nn_1 : N ;
  egennytta_nn_1 : N ;
  egennyttig_av_1 : A ;
  egenraadig_av_1 : A ;
  egenraettfaerdig_av_1 : A ;
  egensinnig_av_1 : A ;
  egenskap_nn_1 : N ;
  egenskapsgenitiv_nn_1 : N ;
  egenskapsord_nn_1 : N ;
  egentlig_av_1 : A ;
  egentligen_ab_1 : Adv ;
  egenvarm_av_1 : A ;
  egg_nn_1 : N ;
  eggelse_nn_1 : N ;
  eggjaern_nn_1 : N ;
  eggvass_av_1 : A ;
  eggverktyg_nn_1 : N ;
  egnahem_nn_1 : N ;
  egocentricitet_nn_1 : N ;
  egocentriker_nn_1 : N ;
  egocentrisk_av_1 : A ;
  egoist_nn_1 : N ;
  egoistisk_av_1 : A ;
  egotripp_nn_1 : N ;
  egypter_nn_1 : N ;
  egyptier_nn_1 : N ;
  egyptisk_av_1 : A ;
  egyptiska_nn_2 : N ;
  egyptolog_nn_1 : N ;
  eidetisk_av_1 : A ;
  einsteinsk_av_1 : A ;
  ej_ab_1 : Adv ;
  ejakulat_nn_1 : N ;
  ejakulation_nn_1 : N ;
  ejder_nn_1 : N ;
  ejderunge_nn_1 : N ;
  ejektor_nn_1 : N ;
  ek_nn_1 : N ;
  ekbock_nn_1 : N ;
  eker_nn_1 : N ;
  ekipage_nn_1 : N ;
  ekipering_nn_1 : N ;
  ekiperingsaffaer_nn_1 : N ;
  ekivok_av_1 : A ;
  eklaerering_nn_1 : N ;
  eklampsi_nn_1 : N ;
  eklatant_av_1 : A ;
  eklatt_av_1 : A ;
  eklektiker_nn_1 : N ;
  eklektisk_av_1 : A ;
  eklips_nn_1 : N ;
  eklog_nn_1 : N ;
  eko_nn_1 : N ;
  ekollon_nn_1 : N ;
  ekolod_nn_1 : N ;
  ekolog_nn_1 : N ;
  ekologisk_av_1 : A ;
  ekonom_nn_1 : N ;
  ekonomexamen_nn_1 : N ;
  ekonomi_nn_1 : N ;
  ekonomibitraede_nn_1 : N ;
  ekonomibrev_nn_1 : N ;
  ekonomibyggnad_nn_1 : N ;
  ekonomie_av_1 : A ;
  ekonomifoerestaandare_nn_1 : N ;
  ekonomifoerpackning_nn_1 : N ;
  ekonomilaera_nn_1 : N ;
  ekonomipaket_nn_1 : N ;
  ekonomisk_av_1 : A ;
  ekoradio_nn_1 : N ;
  ekorrbaer_nn_1 : N ;
  ekorrdjur_nn_1 : N ;
  ekorre_nn_1 : N ;
  ekorrliknande_av_1 : A ;
  ekosystem_nn_1 : N ;
  ekotyp_nn_1 : N ;
  ekoxe_nn_1 : N ;
  eksem_nn_1 : N ;
  ekskog_nn_1 : N ;
  ekspinnare_nn_1 : N ;
  ekstock_nn_1 : N ;
  ektomi_nn_1 : N ;
  ekumenisk_av_1 : A ;
  ekvation_nn_1 : N ;
  ekvatorial_av_1 : A ;
  ekvatorialbaelte_nn_1 : N ;
  ekvatorialguinean_nn_1 : N ;
  ekvatorialguineansk_av_1 : A ;
  ekvatorialstroem_nn_1 : N ;
  ekvatorialzon_nn_1 : N ;
  ekvatoriell_av_1 : A ;
  ekvatorsplan_nn_1 : N ;
  ekvecklare_nn_1 : N ;
  ekvidistant_av_1 : A ;
  ekvilibrist_nn_1 : N ;
  ekvilibristisk_av_1 : A ;
  ekvipotentiallinje_nn_1 : N ;
  ekvivalent_av_1 : A ;
  ekvivalentvikt_nn_1 : N ;
  elaenda_av_1 : A ;
  elaende_nn_1 : N ;
  elaendig_av_1 : A ;
  elak_av_1 : A ;
  elakhet_nn_1 : N ;
  elaking_nn_1 : N ;
  eland_nn_1 : N ;
  elasticitet_nn_1 : N ;
  elasticitetsgraens_nn_1 : N ;
  elastisk_av_1 : A ;
  elbil_nn_1 : N ;
  elborste_nn_1 : N ;
  elchock_nn_1 : N ;
  eld_nn_1 : N ;
  eldare_nn_1 : N ;
  eldavstaand_nn_1 : N ;
  eldbegaengelse_nn_1 : N ;
  eldbrand_nn_1 : N ;
  elddon_nn_1 : N ;
  elddop_nn_1 : N ;
  eldfaengd_av_1 : A ;
  eldfarlig_av_1 : A ;
  eldfast_av_1 : A ;
  eldgaffel_nn_1 : N ;
  eldhaerd_nn_1 : N ;
  eldhaerdig_av_1 : A ;
  eldhandvapen_nn_1 : N ;
  eldhastighet_nn_1 : N ;
  eldhund_nn_1 : N ;
  eldhus_nn_1 : N ;
  eldig_av_1 : A ;
  eldkanal_nn_1 : N ;
  eldkastare_nn_1 : N ;
  eldkommando_nn_1 : N ;
  eldledare_nn_1 : N ;
  eldlinje_nn_1 : N ;
  eldningsolja_nn_1 : N ;
  eldoeverfall_nn_1 : N ;
  eldorado_nn_1 : N ;
  eldprov_nn_1 : N ;
  eldriven_av_1 : A ;
  eldroed_av_1 : A ;
  eldroer_nn_1 : N ;
  eldsaeker_av_1 : A ;
  eldsalamander_nn_1 : N ;
  eldsats_nn_1 : N ;
  eldsignal_nn_1 : N ;
  eldsignalering_nn_1 : N ;
  eldsjael_nn_1 : N ;
  eldsken_nn_1 : N ;
  eldskur_nn_1 : N ;
  eldslaeckare_nn_1 : N ;
  eldslaeckning_nn_1 : N ;
  eldslaendare_nn_1 : N ;
  eldsljus_nn_1 : N ;
  eldslukare_nn_1 : N ;
  eldsmaerke_nn_1 : N ;
  eldstaal_nn_1 : N ;
  eldstad_nn_1 : N ;
  eldstaellning_nn_1 : N ;
  eldstod_nn_1 : N ;
  eldstorm_nn_1 : N ;
  eldstrid_nn_1 : N ;
  eldsvaada_nn_1 : N ;
  eldsvaadeunge_nn_1 : N ;
  eldupphoer_nn_1 : N ;
  eldupphoerorder_nn_1 : N ;
  eldvapen_nn_1 : N ;
  elefant_nn_1 : N ;
  elefantbete_nn_1 : N ;
  elefantinhopp_nn_1 : N ;
  elefantnaebbmus_nn_1 : N ;
  elegant_av_1 : A ;
  elegi_nn_1 : N ;
  elegisk_av_1 : A ;
  elektor_nn_1 : N ;
  elektricitet_nn_1 : N ;
  elektricitetsmaengd_nn_1 : N ;
  elektricitetsverk_nn_1 : N ;
  elektriker_nn_1 : N ;
  elektrisk_av_1 : A ;
  elektrochock_nn_1 : N ;
  elektrod_nn_1 : N ;
  elektroencefalografi_nn_1 : N ;
  elektroencefalogram_nn_1 : N ;
  elektrofilter_nn_1 : N ;
  elektrofor_nn_1 : N ;
  elektroingenjoer_nn_1 : N ;
  elektrokardiografi_nn_1 : N ;
  elektrokardiogram_nn_1 : N ;
  elektrolys_nn_1 : N ;
  elektrolyt_nn_1 : N ;
  elektrolytisk_av_1 : A ;
  elektromagnet_nn_1 : N ;
  elektromagnetisk_av_1 : A ;
  elektromekanisk_av_1 : A ;
  elektrometer_nn_1 : N ;
  elektromotor_nn_1 : N ;
  elektromotorisk_av_1 : A ;
  elektron_nn_1 : N ;
  elektronblixt_nn_1 : N ;
  elektronegativitet_nn_1 : N ;
  elektronisk_av_1 : A ;
  elektronkamera_nn_1 : N ;
  elektronmikroskop_nn_1 : N ;
  elektronmikroskopbild_nn_1 : N ;
  elektronmikroskopi_nn_1 : N ;
  elektronmoln_nn_1 : N ;
  elektronpar_nn_1 : N ;
  elektronparbindning_nn_1 : N ;
  elektronroer_nn_1 : N ;
  elektronroersdiod_nn_1 : N ;
  elektronskal_nn_1 : N ;
  elektronstraale_nn_1 : N ;
  elektronugn_nn_1 : N ;
  elektronvolt_nn_1 : N ;
  elektroskop_nn_1 : N ;
  elektrostatisk_av_1 : A ;
  elektrosvag_av_1 : A ;
  elektrotekniker_nn_1 : N ;
  elektroteknisk_av_1 : A ;
  elektrotyp_nn_1 : N ;
  element_nn_1 : N ;
  elementa_nn_1 : N ;
  elementaer_av_1 : A ;
  elementarande_nn_1 : N ;
  elementarbok_nn_1 : N ;
  elementarpartikel_nn_1 : N ;
  elev_nn_1 : N ;
  elevation_nn_1 : N ;
  elevator_nn_1 : N ;
  elevfartyg_nn_1 : N ;
  elevhem_nn_1 : N ;
  elevraad_nn_1 : N ;
  elevunderlag_nn_1 : N ;
  elfenbenspalm_nn_1 : N ;
  elfenbenstorn_nn_1 : N ;
  elgenerator_nn_1 : N ;
  elgitarr_nn_1 : N ;
  elimination_nn_1 : N ;
  elision_nn_1 : N ;
  elit_nn_1 : N ;
  elitfoerband_nn_1 : N ;
  elitidrott_nn_1 : N ;
  elitidrottsman_nn_1 : N ;
  elitisk_av_1 : A ;
  elitistisk_av_1 : A ;
  elitsoldat_nn_1 : N ;
  elitteori_nn_1 : N ;
  elixir_nn_1 : N ;
  eljest_ab_1 : Adv ;
  elkoppling_nn_1 : N ;
  elkraftsaggregat_nn_1 : N ;
  ellande_ab_1 : Adv ;
  elledning_nn_1 : N ;
  ellips_nn_1 : N ;
  ellipsoid_nn_1 : N ;
  elliptisk_av_1 : A ;
  elljusspaar_nn_1 : N ;
  ellok_nn_1 : N ;
  elmaetare_nn_1 : N ;
  elmotor_nn_1 : N ;
  elmseld_nn_1 : N ;
  elnaet_nn_1 : N ;
  eloge_nn_1 : N ;
  elokvent_av_1 : A ;
  elongation_nn_1 : N ;
  elorgel_nn_1 : N ;
  elsevir_nn_1 : N ;
  elspis_nn_1 : N ;
  elstroem_nn_1 : N ;
  eluttag_nn_1 : N ;
  eluvial_av_1 : A ;
  elvadimensionell_av_1 : A ;
  elvamannalag_nn_1 : N ;
  elverk_nn_1 : N ;
  elyseisk_av_1 : A ;
  elzevier_nn_1 : N ;
  emalj_nn_1 : N ;
  emaljfaerg_nn_1 : N ;
  emaljfyllning_nn_1 : N ;
  emaljinlaeggning_nn_1 : N ;
  emaljoega_nn_1 : N ;
  emaljoer_nn_1 : N ;
  emaljplomb_nn_1 : N ;
  emanation_nn_1 : N ;
  emballage_nn_1 : N ;
  emblem_nn_1 : N ;
  emboli_nn_1 : N ;
  embryo_nn_1 : N ;
  embryolog_nn_1 : N ;
  embryonal_av_1 : A ;
  embryonisk_av_1 : A ;
  embryosaeck_nn_1 : N ;
  emellan_ab_1 : Adv ;
  emellanaat_ab_1 : Adv ;
  emellertid_ab_1 : Adv ;
  emendation_nn_1 : N ;
  emeritus_nn_1 : N ;
  emfatisk_av_1 : A ;
  emfysem_nn_1 : N ;
  emigrant_nn_1 : N ;
  eminens_nn_1 : N ;
  eminent_av_1 : A ;
  emir_nn_1 : N ;
  emissarie_nn_1 : N ;
  emission_nn_1 : N ;
  emitter_nn_1 : N ;
  emot_ab_1 : Adv ;
  emotion_nn_1 : N ;
  emotionell_av_1 : A ;
  emotiv_av_1 : A ;
  emotta_vb_1 : V ;
  empirestil_nn_1 : N ;
  empiriker_nn_1 : N ;
  empirisk_av_1 : A ;
  empirist_nn_1 : N ;
  empyem_nn_1 : N ;
  emu_nn_1 : N ;
  emulsion_nn_1 : N ;
  emulsionsfaerg_nn_1 : N ;
  emulsionsspraengaemne_nn_1 : N ;
  en_ab_1 : Adv ;
  en_nn_1 : N ;
  enaeggstvilling_nn_1 : N ;
  enahanda_av_1 : A ;
  enaktare_nn_1 : N ;
  enaraadande_av_1 : A ;
  enarmig_av_1 : A ;
  enastaaende_av_1 : A ;
  enaxlig_av_1 : A ;
  enbaeddsrum_nn_1 : N ;
  enbaer_nn_1 : N ;
  enbart_ab_1 : Adv ;
  enbasisk_av_1 : A ;
  enbent_av_1 : A ;
  enbet_nn_1 : N ;
  enbuske_nn_1 : N ;
  enbyggare_nn_1 : N ;
  encefalit_nn_1 : N ;
  encefalografi_nn_1 : N ;
  encellig_av_1 : A ;
  encyklopedi_nn_1 : N ;
  encyklopedisk_av_1 : A ;
  endast_ab_1 : Adv ;
  endels_ab_1 : Adv ;
  endemi_nn_1 : N ;
  endemisk_av_1 : A ;
  endimensionell_av_1 : A ;
  endiv_nn_1 : N ;
  endogen_av_1 : A ;
  endokrin_av_1 : A ;
  endokrinolog_nn_1 : N ;
  endorfin_nn_1 : N ;
  endossat_nn_1 : N ;
  endossement_nn_1 : N ;
  endossent_nn_1 : N ;
  endotermisk_av_1 : A ;
  energi_nn_1 : N ;
  energialternativ_nn_1 : N ;
  energibehov_nn_1 : N ;
  energifoerlust_nn_1 : N ;
  energiform_nn_1 : N ;
  energiinnehaall_nn_1 : N ;
  energikoncentration_nn_1 : N ;
  energimaengd_nn_1 : N ;
  energimarknad_nn_1 : N ;
  energiomsaettning_nn_1 : N ;
  energiomvandling_nn_1 : N ;
  energiomvandlingscentrum_nn_1 : N ;
  energirik_av_1 : A ;
  energisk_av_1 : A ;
  energiskatt_nn_1 : N ;
  energiskog_nn_1 : N ;
  energiteori_nn_1 : N ;
  energitillstaand_nn_1 : N ;
  energiupptagande_av_1 : A ;
  energiutstraalning_nn_1 : N ;
  energiverk_nn_1 : N ;
  energivinst_nn_1 : N ;
  enfaldeligen_ab_1 : Adv ;
  enfaldig_av_1 : A ;
  enfamiljshus_nn_1 : N ;
  enfas_av_1 : A ;
  enfasig_av_1 : A ;
  enfoedd_av_1 : A ;
  enfoeraeldersfamilj_nn_1 : N ;
  enformig_av_1 : A ;
  engaang_ab_1 : Adv ;
  engaangsdos_nn_1 : N ;
  engaangshandduk_nn_1 : N ;
  engaangsnaesduk_nn_1 : N ;
  engaangsservett_nn_1 : N ;
  engaangsskatt_nn_1 : N ;
  engaangstallrik_nn_1 : N ;
  engaangsvaerde_nn_1 : N ;
  engagemang_nn_1 : N ;
  engelsk_av_1 : A ;
  engelska_nn_2 : N ;
  engelsman_nn_1 : N ;
  englergrad_nn_1 : N ;
  engram_nn_1 : N ;
  engrossist_nn_1 : N ;
  enhaellig_av_1 : A ;
  enharmonisk_av_1 : A ;
  enhet_nn_1 : N ;
  enhetlig_av_1 : A ;
  enhetscirkel_nn_1 : N ;
  enhetsflygplan_nn_1 : N ;
  enhetsfront_nn_1 : N ;
  enhetsladdning_nn_1 : N ;
  enhetslast_nn_1 : N ;
  enhetsmaatt_nn_1 : N ;
  enhetsparti_nn_1 : N ;
  enhetspatron_nn_1 : N ;
  enhetsporto_nn_1 : N ;
  enhetspris_nn_1 : N ;
  enhetsvektor_nn_1 : N ;
  enhjaertbladig_av_1 : A ;
  enhoerning_nn_1 : N ;
  enig_av_1 : A ;
  enighet_nn_1 : N ;
  enigmatisk_av_1 : A ;
  enjambemang_nn_1 : N ;
  enkaet_nn_1 : N ;
  enkammarsystem_nn_1 : N ;
  enkannerligen_ab_1 : Adv ;
  enkel_av_1 : A ;
  enkelbeckasin_nn_1 : N ;
  enkelbiff_nn_1 : N ;
  enkelbiljett_nn_1 : N ;
  enkelbredd_nn_1 : N ;
  enkelhet_nn_1 : N ;
  enkelkikare_nn_1 : N ;
  enkelknaeppt_av_1 : A ;
  enkelkvartett_nn_1 : N ;
  enkelladdare_nn_1 : N ;
  enkelnervig_av_1 : A ;
  enkelpipig_av_1 : A ;
  enkelrad_nn_1 : N ;
  enkelrum_nn_1 : N ;
  enkelsaeng_nn_1 : N ;
  enkelskriva_vb_1 : V ;
  enkelspaarig_av_1 : A ;
  enkelspel_nn_1 : N ;
  enkeltimme_nn_1 : N ;
  enklav_nn_1 : N ;
  enklitisk_av_1 : A ;
  enkom_ab_1 : Adv ;
  enmanslivbaat_nn_1 : N ;
  enmansshow_nn_1 : N ;
  enmansvalkrets_nn_1 : N ;
  enoegd_av_1 : A ;
  enorm_av_1 : A ;
  enpartistat_nn_1 : N ;
  enplanshus_nn_1 : N ;
  enpolig_av_1 : A ;
  enpucklig_av_1 : A ;
  enraadig_av_1 : A ;
  enris_nn_1 : N ;
  enrisroekt_av_1 : A ;
  ens_ab_1 : Adv ;
  ens_av_1 : A ;
  ensak_nn_1 : N ;
  ensam_av_1 : A ;
  ensamfoeraelder_nn_1 : N ;
  ensamgaard_nn_1 : N ;
  ensamhet_nn_1 : N ;
  ensamraett_nn_1 : N ;
  ensamseglare_nn_1 : N ;
  ensamstaaende_av_1 : A ;
  ense_av_1 : A ;
  ensemble_nn_1 : N ;
  ensfyr_nn_1 : N ;
  ensidig_av_1 : A ;
  ensittare_nn_1 : N ;
  enskild_av_1 : A ;
  enskildhet_nn_1 : N ;
  enslig_av_1 : A ;
  ensling_nn_1 : N ;
  enslinje_nn_1 : N ;
  enspraakig_av_1 : A ;
  enstaemmig_av_1 : A ;
  enstaendig_av_1 : A ;
  enstaka_av_1 : A ;
  enstavig_av_1 : A ;
  enstensmur_nn_1 : N ;
  enstjaernig_av_1 : A ;
  enstoerig_av_1 : A ;
  enstoering_nn_1 : N ;
  ental_nn_1 : N ;
  entente_nn_1 : N ;
  entertainer_nn_1 : N ;
  entitet_nn_1 : N ;
  entomolog_nn_1 : N ;
  entomologisk_av_1 : A ;
  entonig_av_1 : A ;
  entraegen_av_1 : A ;
  entre_nn_1 : N ;
  entrecote_nn_1 : N ;
  entredoerr_nn_1 : N ;
  entreprenad_nn_1 : N ;
  entreprenoer_nn_1 : N ;
  entresol_nn_1 : N ;
  entusiast_nn_1 : N ;
  entusiastisk_av_1 : A ;
  entydig_av_1 : A ;
  entydighet_nn_1 : N ;
  entypsbaat_nn_1 : N ;
  enumeration_nn_1 : N ;
  envaaldshaerskare_nn_1 : N ;
  envaaningshus_nn_1 : N ;
  envaegskommunikation_nn_1 : N ;
  envaeldig_av_1 : A ;
  envaerd_av_1 : A ;
  enveten_av_1 : A ;
  envig_nn_1 : N ;
  environg_nn_1 : N ;
  envis_av_1 : A ;
  envoye_nn_1 : N ;
  enzym_nn_1 : N ;
  enzymsystem_nn_1 : N ;
  enzymtvaettmedel_nn_1 : N ;
  eoler_nn_1 : N ;
  eolisk_av_1 : A ;
  eon_nn_1 : N ;
  eosin_nn_1 : N ;
  epaalett_nn_1 : N ;
  epatraktor_nn_1 : N ;
  epicentrum_nn_1 : N ;
  epidemi_nn_1 : N ;
  epidemisk_av_1 : A ;
  epiduralblockad_nn_1 : N ;
  epifys_nn_1 : N ;
  epifyt_nn_1 : N ;
  epigon_nn_1 : N ;
  epigram_nn_1 : N ;
  epigrammatisk_av_1 : A ;
  epiker_nn_1 : N ;
  epikure_nn_1 : N ;
  epikureisk_av_1 : A ;
  epilepsi_nn_1 : N ;
  epileptiker_nn_1 : N ;
  epilog_nn_1 : N ;
  episk_av_1 : A ;
  episkop_nn_1 : N ;
  episkopal_av_1 : A ;
  episkopat_nn_1 : N ;
  episod_nn_1 : N ;
  episodisk_av_1 : A ;
  epistel_nn_1 : N ;
  epistolaer_av_1 : A ;
  epistyl_nn_1 : N ;
  epitaf_nn_1 : N ;
  epitafium_nn_1 : N ;
  epitel_nn_1 : N ;
  epitelcell_nn_1 : N ;
  epitet_nn_1 : N ;
  epizoisk_av_1 : A ;
  epizooti_nn_1 : N ;
  epok_nn_1 : N ;
  epokgoerande_av_1 : A ;
  epos_nn_1 : N ;
  erbarmlig_av_1 : A ;
  erbjuda_vb_1 : V ;
  erbjudande_nn_1 : N ;
  erektion_nn_1 : N ;
  eremit_nn_1 : N ;
  eremitage_nn_1 : N ;
  eremitisk_av_1 : A ;
  erfaren_av_1 : A ;
  erfarenhet_nn_1 : N ;
  erfarenhetsmaessig_av_1 : A ;
  erforderlig_av_1 : A ;
  ergo_ab_1 : Adv ;
  ergometer_nn_1 : N ;
  ergonom_nn_1 : N ;
  ergonometrisk_av_1 : A ;
  ergonomisk_av_1 : A ;
  erhaalla_vb_1 : V ;
  erinnye_nn_1 : N ;
  erinran_nn_1 : N ;
  erinring_nn_1 : N ;
  erkaend_av_1 : A ;
  erkaennande_nn_1 : N ;
  erkaennsam_av_1 : A ;
  eroevrare_nn_1 : N ;
  eroevring_nn_1 : N ;
  erogen_av_1 : A ;
  erosion_nn_1 : N ;
  erotiker_nn_1 : N ;
  erotisk_av_1 : A ;
  erotogen_av_1 : A ;
  erotoman_av_1 : A ;
  erotoman_nn_1 : N ;
  errata_nn_1 : N ;
  erratisk_av_1 : A ;
  ersaettare_nn_1 : N ;
  ersaettlig_av_1 : A ;
  ersaettning_nn_1 : N ;
  eruption_nn_1 : N ;
  eruptiv_av_1 : A ;
  eruptivbergart_nn_1 : N ;
  escudo_nn_1 : N ;
  eselhuvud_nn_1 : N ;
  eskader_nn_1 : N ;
  eskapad_nn_1 : N ;
  eskarp_nn_1 : N ;
  eskatologisk_av_1 : A ;
  eskimaa_nn_1 : N ;
  eskimaahund_nn_1 : N ;
  eskort_nn_1 : N ;
  eskulap_nn_1 : N ;
  esomoftast_ab_1 : Adv ;
  esoterisk_av_1 : A ;
  espadrill_nn_1 : N ;
  espagnolett_nn_1 : N ;
  esperantist_nn_1 : N ;
  esplanad_nn_1 : N ;
  espri_nn_2 : N ;
  ess_nn_1 : N ;
  essae_nn_1 : N ;
  essaefraaga_nn_1 : N ;
  essaeist_nn_1 : N ;
  essaeistisk_av_1 : A ;
  essaesamling_nn_1 : N ;
  essaeuppgift_nn_1 : N ;
  essay_nn_1 : N ;
  essayist_nn_1 : N ;
  essayistik_nn_1 : N ;
  essayistisk_av_1 : A ;
  essaysamling_nn_1 : N ;
  essens_nn_1 : N ;
  essentiell_av_1 : A ;
  est_nn_1 : N ;
  ester_nn_1 : N ;
  esterplast_nn_1 : N ;
  estet_nn_1 : N ;
  estetiker_nn_1 : N ;
  estetisk_av_1 : A ;
  estlaendare_nn_1 : N ;
  estlaendsk_av_1 : A ;
  estlaendska_nn_1 : N ;
  estnisk_av_1 : A ;
  estniska_nn_2 : N ;
  estrad_nn_1 : N ;
  estradartist_nn_1 : N ;
  estraddebatt_nn_1 : N ;
  estradoer_nn_1 : N ;
  estradsamtal_nn_1 : N ;
  etablissemang_nn_1 : N ;
  etagaer_nn_1 : N ;
  etage_nn_1 : N ;
  etagevaaning_nn_1 : N ;
  etalong_nn_1 : N ;
  etan_nn_1 : N ;
  etapp_nn_1 : N ;
  etapplinje_nn_1 : N ;
  etappvis_ab_1 : Adv ;
  etcetera_ab_1 : Adv ;
  eter_nn_1 : N ;
  eterisering_nn_1 : N ;
  eterisk_av_1 : A ;
  etermedium_nn_1 : N ;
  eternell_nn_1 : N ;
  etiker_nn_1 : N ;
  etikett_nn_1 : N ;
  etiologisk_av_1 : A ;
  etiop_nn_1 : N ;
  etiopier_nn_1 : N ;
  etiopisk_av_1 : A ;
  etiopiska_nn_2 : N ;
  etisk_av_1 : A ;
  etnisk_av_1 : A ;
  etnocentrisk_av_1 : A ;
  etnograf_nn_1 : N ;
  etnografisk_av_1 : A ;
  etnolog_nn_1 : N ;
  etnologisk_av_1 : A ;
  etolog_nn_1 : N ;
  etologisk_av_1 : A ;
  etrusk_nn_1 : N ;
  etrusker_nn_1 : N ;
  etruskisk_av_1 : A ;
  etruskiska_nn_2 : N ;
  etsmedel_nn_1 : N ;
  etsning_nn_1 : N ;
  ettaarig_av_1 : A ;
  ettaaring_nn_1 : N ;
  ettoering_nn_1 : N ;
  ettrig_av_1 : A ;
  ettstruken_av_1 : A ;
  etui_nn_1 : N ;
  etyd_nn_1 : N ;
  etymolog_nn_1 : N ;
  etymologi_nn_1 : N ;
  etymologisk_av_1 : A ;
  eufemism_nn_1 : N ;
  eufoni_nn_1 : N ;
  eufori_nn_1 : N ;
  euforisk_av_1 : A ;
  euklidisk_av_1 : A ;
  eumenid_nn_1 : N ;
  eunuck_nn_1 : N ;
  eurasier_nn_1 : N ;
  eurasisk_av_1 : A ;
  euro_nn_1 : N ;
  eurodollar_nn_1 : N ;
  europamaestare_nn_1 : N ;
  europamaesterskap_nn_1 : N ;
  europavaeg_nn_1 : N ;
  europe_nn_1 : N ;
  europeisk_av_1 : A ;
  europeiska_nn_1 : N ;
  europid_nn_1 : N ;
  eurytmi_nn_1 : N ;
  eutrof_av_1 : A ;
  evaerdlig_av_1 : A ;
  evakostym_nn_1 : N ;
  evakuering_nn_1 : N ;
  evangeliebok_nn_1 : N ;
  evangelisk_av_1 : A ;
  evangelist_nn_1 : N ;
  evangelium_nn_1 : N ;
  evar_ab_1 : Adv ;
  evart_ab_1 : Adv ;
  evenemang_nn_1 : N ;
  eventualitet_nn_1 : N ;
  eventuell_av_1 : A ;
  evergreen_nn_1 : N ;
  evertebrat_nn_1 : N ;
  evident_av_1 : A ;
  evig_av_1 : A ;
  evighet_nn_1 : N ;
  evighetskalender_nn_1 : N ;
  evighetsmaskin_nn_1 : N ;
  evinnerlig_av_1 : A ;
  evinnerligen_ab_1 : Adv ;
  evolution_nn_1 : N ;
  evolutionaer_av_1 : A ;
  evolutionist_nn_1 : N ;
  evolutionsbiolog_nn_1 : N ;
  evolutionsforskning_nn_1 : N ;
  evolutionsmekanism_nn_1 : N ;
  evolutionsteori_nn_1 : N ;
  exakt_av_1 : A ;
  exakthet_nn_1 : N ;
  examen_nn_1 : N ;
  examinand_nn_1 : N ;
  examination_nn_1 : N ;
  examinator_nn_1 : N ;
  examinatorium_nn_1 : N ;
  exantem_nn_1 : N ;
  excellens_nn_1 : N ;
  excellent_av_1 : A ;
  excenter_nn_1 : N ;
  excentricitet_nn_1 : N ;
  excentriker_nn_1 : N ;
  excentrisk_av_1 : A ;
  exceptionell_av_1 : A ;
  excerpist_nn_1 : N ;
  excerpt_nn_1 : N ;
  excess_nn_1 : N ;
  excision_nn_1 : N ;
  excitation_nn_1 : N ;
  exeget_nn_1 : N ;
  exekution_nn_1 : N ;
  exekutiv_av_1 : A ;
  exekutiv_nn_1 : N ;
  exekutoer_nn_1 : N ;
  exekutor_nn_1 : N ;
  exekutorisk_av_1 : A ;
  exempel_nn_1 : N ;
  exempelloes_av_1 : A ;
  exempelvis_ab_1 : Adv ;
  exemplar_nn_1 : N ;
  exemplarisk_av_1 : A ;
  exemplifiering_nn_1 : N ;
  exemplifikation_nn_1 : N ;
  exercis_nn_1 : N ;
  exhibitionist_nn_1 : N ;
  exhustru_nn_1 : N ;
  exigibel_av_1 : A ;
  existens_nn_1 : N ;
  existensminimum_nn_1 : N ;
  existentiell_av_1 : A ;
  exklamation_nn_1 : N ;
  exklamatorisk_av_1 : A ;
  exklusiv_av_1 : A ;
  exklusivitet_nn_1 : N ;
  exkrement_nn_1 : N ;
  exkremental_av_1 : A ;
  exkret_nn_1 : N ;
  exkretion_nn_1 : N ;
  exkung_nn_1 : N ;
  exkurs_nn_1 : N ;
  exkursion_nn_1 : N ;
  exlibris_nn_1 : N ;
  exogen_av_1 : A ;
  exorcist_nn_1 : N ;
  exoterisk_av_1 : A ;
  exotermisk_av_1 : A ;
  exotisk_av_1 : A ;
  expansibel_av_1 : A ;
  expansionskaerl_nn_1 : N ;
  expansiv_av_1 : A ;
  expedit_av_1 : A ;
  expedit_nn_1 : N ;
  expedition_nn_1 : N ;
  expeditionskaar_nn_1 : N ;
  expeditionsministaer_nn_1 : N ;
  expeditionsregering_nn_1 : N ;
  expeditionsvakt_nn_1 : N ;
  expeditoer_nn_1 : N ;
  expektoration_nn_1 : N ;
  experiment_nn_1 : N ;
  experimentalfysiker_nn_1 : N ;
  experimentator_nn_1 : N ;
  experimentell_av_1 : A ;
  experimentgymnasium_nn_1 : N ;
  expert_nn_1 : N ;
  expertgrupp_nn_1 : N ;
  expertkrets_nn_1 : N ;
  expertspraak_nn_1 : N ;
  explanativ_av_1 : A ;
  explicit_av_1 : A ;
  explikation_nn_1 : N ;
  exploatering_nn_1 : N ;
  exploatoer_nn_1 : N ;
  explosion_nn_1 : N ;
  explosionsfoerlopp_nn_1 : N ;
  explosionshaerd_nn_1 : N ;
  explosionsmotor_nn_1 : N ;
  explosionsoegonblick_nn_1 : N ;
  explosionssaett_nn_1 : N ;
  explosiv_av_1 : A ;
  expo_nn_1 : N ;
  exponent_nn_1 : N ;
  exponentiell_av_1 : A ;
  exponering_nn_1 : N ;
  exponeringsmaetare_nn_1 : N ;
  export_nn_1 : N ;
  exportinkomst_nn_1 : N ;
  exportmarknad_nn_1 : N ;
  exportoer_nn_1 : N ;
  expose_nn_1 : N ;
  exposition_nn_1 : N ;
  express_ab_1 : Adv ;
  express_nn_1 : N ;
  expressbrev_nn_1 : N ;
  expressbyraa_nn_1 : N ;
  expressfoersaendelse_nn_1 : N ;
  expressionist_nn_1 : N ;
  expressiv_av_1 : A ;
  expressivitet_nn_1 : N ;
  expropriation_nn_1 : N ;
  exsickat_nn_1 : N ;
  exsickator_nn_1 : N ;
  exsudat_nn_1 : N ;
  extatisk_av_1 : A ;
  extempore_ab_1 : Adv ;
  extension_nn_1 : N ;
  extensiv_av_1 : A ;
  exterioer_nn_1 : N ;
  extern_av_1 : A ;
  extern_nn_1 : N ;
  externat_nn_1 : N ;
  exterritoriell_av_1 : A ;
  extra_ab_1 : Adv ;
  extra_av_1 : A ;
  extrainkomst_nn_1 : N ;
  extrajudiciell_av_1 : A ;
  extraknaeck_nn_1 : N ;
  extrakontant_av_1 : A ;
  extrakt_nn_1 : N ;
  extraktion_nn_1 : N ;
  extraktivaemne_nn_1 : N ;
  extraktor_nn_1 : N ;
  extramural_av_1 : A ;
  extraordinaer_av_1 : A ;
  extraordinarie_av_1 : A ;
  extraordinarie_nn_1 : N ;
  extrapolation_nn_1 : N ;
  extrapris_nn_1 : N ;
  extrasol_nn_1 : N ;
  extrauterin_av_1 : A ;
  extravagans_nn_1 : N ;
  extravagant_av_1 : A ;
  extrem_av_1 : A ;
  extrem_nn_1 : N ;
  extremist_nn_1 : N ;
  extremitet_nn_1 : N ;
  extrovert_av_1 : A ;
  eye_liner_nn_1 : N ;
  faa_av_1 : A ;
  faafaeng_av_1 : A ;
  faafaenglig_av_1 : A ;
  faafaenglighet_nn_1 : N ;
  faagel_nn_1 : N ;
  faagelaegg_nn_1 : N ;
  faagelbad_nn_1 : N ;
  faagelbaer_nn_1 : N ;
  faagelbo_nn_1 : N ;
  faagelbur_nn_1 : N ;
  faagelfjaeder_nn_1 : N ;
  faagelfot_nn_1 : N ;
  faagelfri_av_1 : A ;
  faagelholk_nn_1 : N ;
  faagelhund_nn_1 : N ;
  faageljakt_nn_1 : N ;
  faagelperspektiv_nn_1 : N ;
  faagelskaadare_nn_1 : N ;
  faagelskaadning_nn_1 : N ;
  faagelstraeck_nn_1 : N ;
  faagelunge_nn_1 : N ;
  faagelvinge_nn_1 : N ;
  faakunnig_av_1 : A ;
  faale_nn_1 : N ;
  faall_nn_1 : N ;
  faallbaenk_nn_1 : N ;
  faamaeld_av_1 : A ;
  faamansfoeretag_nn_1 : N ;
  faan_nn_1 : N ;
  faane_nn_1 : N ;
  faaneri_nn_1 : N ;
  faang_nn_1 : N ;
  faange_nn_1 : N ;
  faangen_av_1 : A ;
  faangeshandling_nn_1 : N ;
  faangesman_nn_1 : N ;
  faanglaeger_nn_1 : N ;
  faangst_nn_1 : N ;
  faangstanordning_nn_1 : N ;
  faangstfolk_nn_1 : N ;
  faangstgrop_nn_1 : N ;
  faangstkrok_nn_1 : N ;
  faangstkultur_nn_1 : N ;
  faangstplats_nn_1 : N ;
  faangstredskap_nn_1 : N ;
  faangvaktare_nn_1 : N ;
  faanig_av_1 : A ;
  faanskratt_nn_1 : N ;
  faantratt_nn_1 : N ;
  faaordig_av_1 : A ;
  faar_nn_1 : N ;
  faaraktig_av_1 : A ;
  faarbogsaerm_nn_1 : N ;
  faarfiol_nn_1 : N ;
  faarhund_nn_1 : N ;
  faarost_nn_1 : N ;
  faarskalle_nn_1 : N ;
  faarskinn_nn_1 : N ;
  faat_nn_1 : N ;
  faatal_nn_1 : N ;
  faatalig_av_1 : A ;
  faatoelj_nn_1 : N ;
  faavitsk_av_1 : A ;
  fabel_nn_1 : N ;
  fabelaktig_av_1 : A ;
  fabeldjur_nn_1 : N ;
  fabrik_nn_1 : N ;
  fabrikant_nn_1 : N ;
  fabrikat_nn_1 : N ;
  fabrikation_nn_1 : N ;
  fabrikoer_nn_1 : N ;
  fabriksmaessig_av_1 : A ;
  fabriksny_av_1 : A ;
  fabrikspris_nn_1 : N ;
  fabriksskorsten_nn_1 : N ;
  fabulering_nn_1 : N ;
  fabuloes_av_1 : A ;
  facil_av_1 : A ;
  facilitet_nn_1 : N ;
  fack_nn_1 : N ;
  fackelblomster_nn_1 : N ;
  fackeltaag_nn_1 : N ;
  fackfoerbund_nn_1 : N ;
  fackfoerening_nn_1 : N ;
  fackfoereningsroerelse_nn_1 : N ;
  fackidiot_nn_1 : N ;
  fackkunnig_av_1 : A ;
  fackkunskap_nn_1 : N ;
  fackla_nn_1 : N ;
  facklig_av_1 : A ;
  fackmaessig_av_1 : A ;
  fackman_nn_1 : N ;
  fackminister_nn_1 : N ;
  fackordbok_nn_1 : N ;
  fackorgan_nn_1 : N ;
  fackspraak_nn_1 : N ;
  fackterm_nn_1 : N ;
  facktidskrift_nn_1 : N ;
  fackutskottsprincip_nn_1 : N ;
  fackverk_nn_1 : N ;
  fadaes_nn_1 : N ;
  fadder_nn_1 : N ;
  fadderbarn_nn_1 : N ;
  fader_nn_1 : N ;
  faderlig_av_1 : A ;
  fadermoerdare_nn_1 : N ;
  fadersarv_nn_1 : N ;
  fadersfigur_nn_1 : N ;
  fadersgestalt_nn_1 : N ;
  fadershus_nn_1 : N ;
  faderskomplex_nn_1 : N ;
  fadersnamn_nn_1 : N ;
  fadersvaelde_nn_1 : N ;
  fadervaar_nn_1 : N ;
  fae_nn_1 : N ;
  faeaktig_av_1 : A ;
  faebless_nn_1 : N ;
  faebod_nn_1 : N ;
  faebodvall_nn_1 : N ;
  faedernesland_nn_1 : N ;
  faegnad_nn_1 : N ;
  faegnesam_av_1 : A ;
  faehund_nn_1 : N ;
  faehus_nn_1 : N ;
  faektare_nn_1 : N ;
  faektning_nn_1 : N ;
  faelg_nn_1 : N ;
  faelgkors_nn_1 : N ;
  faell_nn_1 : N ;
  faellbar_av_1 : A ;
  faellkniv_nn_1 : N ;
  faellkoel_nn_1 : N ;
  faellning_nn_1 : N ;
  faellstol_nn_1 : N ;
  faelt_nn_1 : N ;
  faeltarme_nn_1 : N ;
  faeltassistent_nn_1 : N ;
  faeltbiolog_nn_1 : N ;
  faeltflygare_nn_1 : N ;
  faeltfoersoek_nn_1 : N ;
  faeltgraa_av_1 : A ;
  faelthare_nn_1 : N ;
  faeltherre_nn_1 : N ;
  faelthoens_nn_1 : N ;
  faeltkikare_nn_1 : N ;
  faeltmaessig_av_1 : A ;
  faeltmaetning_nn_1 : N ;
  faeltmarskalk_nn_1 : N ;
  faeltpraest_nn_1 : N ;
  faeltrop_nn_1 : N ;
  faeltskaer_nn_1 : N ;
  faeltslag_nn_1 : N ;
  faeltspat_nn_1 : N ;
  faeltstudium_nn_1 : N ;
  faeltstyrka_nn_1 : N ;
  faelttaag_nn_1 : N ;
  faelttaagsplan_nn_1 : N ;
  faelttaevlan_nn_1 : N ;
  faelttecken_nn_1 : N ;
  faelttjaenstgoering_nn_1 : N ;
  faelttjaenstoevning_nn_1 : N ;
  faeltuniform_nn_1 : N ;
  faenad_nn_1 : N ;
  faengelse_nn_1 : N ;
  faengelsecell_nn_1 : N ;
  faengelsefoerhaallande_nn_1 : N ;
  faengelsekund_nn_1 : N ;
  faengelsestraff_nn_1 : N ;
  faenghaal_nn_1 : N ;
  faengsel_nn_1 : N ;
  faengslande_av_1 : A ;
  faengslig_av_1 : A ;
  faenrik_nn_1 : N ;
  faerd_nn_1 : N ;
  faerdbevis_nn_1 : N ;
  faerdbiljett_nn_1 : N ;
  faerdig_av_1 : A ;
  faerdighet_nn_1 : N ;
  faerdighetsaemne_nn_1 : N ;
  faerdighetstraening_nn_1 : N ;
  faerdknaepp_nn_1 : N ;
  faerdled_nn_1 : N ;
  faerdledare_nn_1 : N ;
  faerdmedel_nn_1 : N ;
  faerdriktning_nn_1 : N ;
  faerdskrivare_nn_1 : N ;
  faerdvaeg_nn_1 : N ;
  faerg_nn_1 : N ;
  faergaekta_av_1 : A ;
  faergaemne_nn_1 : N ;
  faergbad_nn_1 : N ;
  faergband_nn_1 : N ;
  faergbestaendig_av_1 : A ;
  faergbild_nn_1 : N ;
  faergblandning_nn_1 : N ;
  faergblind_av_1 : A ;
  faergeri_nn_1 : N ;
  faergfilter_nn_1 : N ;
  faergfoeraendring_nn_1 : N ;
  faergglad_av_1 : A ;
  faerggrann_av_1 : A ;
  faerghandel_nn_1 : N ;
  faergkaenslig_av_1 : A ;
  faergkaenslighet_nn_1 : N ;
  faergklick_nn_1 : N ;
  faergkontrast_nn_1 : N ;
  faerglitografi_nn_1 : N ;
  faergloes_av_1 : A ;
  faergmoenster_nn_1 : N ;
  faergning_nn_1 : N ;
  faergpigment_nn_1 : N ;
  faergreproduktion_nn_1 : N ;
  faergrik_av_1 : A ;
  faergrivning_nn_1 : N ;
  faergsaettning_nn_1 : N ;
  faergspektrum_nn_1 : N ;
  faergspel_nn_1 : N ;
  faergsprakande_av_1 : A ;
  faergspridning_nn_1 : N ;
  faergstark_av_1 : A ;
  faergstoff_nn_1 : N ;
  faergtemperatur_nn_1 : N ;
  faergteve_nn_1 : N ;
  faergton_nn_1 : N ;
  faergtryck_nn_1 : N ;
  faering_nn_1 : N ;
  faerjelaege_nn_1 : N ;
  faerm_av_1 : A ;
  faermitet_nn_1 : N ;
  faeroeing_nn_1 : N ;
  faeroeisk_av_1 : A ;
  faeroeiska_nn_2 : N ;
  faers_nn_1 : N ;
  faersk_av_1 : A ;
  faerskmalm_nn_1 : N ;
  faerskning_nn_1 : N ;
  faerskvatten_nn_1 : N ;
  faesoer_nn_1 : N ;
  faesting_nn_1 : N ;
  faestman_nn_1 : N ;
  faestmoe_nn_1 : N ;
  faestning_nn_1 : N ;
  faestpunkt_nn_1 : N ;
  fager_av_1 : A ;
  fagott_nn_1 : N ;
  faiblesse_nn_1 : N ;
  fajans_nn_1 : N ;
  fajt_nn_1 : N ;
  fakir_nn_1 : N ;
  faksimil_nn_1 : N ;
  faksimile_nn_1 : N ;
  faktafolder_nn_1 : N ;
  fakticitet_nn_1 : N ;
  faktisk_av_1 : A ;
  faktor_nn_1 : N ;
  faktoranalys_nn_1 : N ;
  faktori_nn_1 : N ;
  faktotum_nn_1 : N ;
  faktum_nn_1 : N ;
  fakultativ_av_1 : A ;
  fakultet_nn_1 : N ;
  fakultetsopponent_nn_1 : N ;
  fal_av_1 : A ;
  falang_nn_1 : N ;
  falangist_nn_1 : N ;
  falk_nn_1 : N ;
  falkenerare_nn_1 : N ;
  falkjakt_nn_1 : N ;
  falkonett_nn_1 : N ;
  fall_nn_1 : N ;
  falla_vb_1 : V ;
  fallen_av_1 : A ;
  fallenhet_nn_1 : N ;
  fallfaerdig_av_1 : A ;
  fallfrukt_nn_1 : N ;
  fallgrop_nn_1 : N ;
  fallhammare_nn_1 : N ;
  fallhoejd_nn_1 : N ;
  fallissemang_nn_1 : N ;
  fallos_nn_1 : N ;
  fallrep_nn_1 : N ;
  fallseger_nn_1 : N ;
  fallskaerm_nn_1 : N ;
  fallskaermshoppare_nn_1 : N ;
  fallskaermsjaegare_nn_1 : N ;
  fallskaermstrupp_nn_1 : N ;
  fallstudie_nn_1 : N ;
  fallverk_nn_1 : N ;
  fallvind_nn_1 : N ;
  fals_nn_1 : N ;
  falsarium_nn_1 : N ;
  falsifikat_nn_1 : N ;
  falsk_av_1 : A ;
  falskeligen_ab_1 : Adv ;
  falskmyntare_nn_1 : N ;
  falskspel_nn_1 : N ;
  falukorv_nn_1 : N ;
  faluroed_av_1 : A ;
  familj_nn_1 : N ;
  familjaer_av_1 : A ;
  familjaritet_nn_1 : N ;
  familjebidrag_nn_1 : N ;
  familjebiljett_nn_1 : N ;
  familjebolag_nn_1 : N ;
  familjedaghem_nn_1 : N ;
  familjefoeretag_nn_1 : N ;
  familjefoersoerjare_nn_1 : N ;
  familjehem_nn_1 : N ;
  familjehotell_nn_1 : N ;
  familjejordbruk_nn_1 : N ;
  familjekrets_nn_1 : N ;
  familjemedlem_nn_1 : N ;
  familjenamn_nn_1 : N ;
  familjepension_nn_1 : N ;
  familjeplanering_nn_1 : N ;
  familjeraadgivning_nn_1 : N ;
  familjerabatt_nn_1 : N ;
  famlande_av_1 : A ;
  famn_nn_1 : N ;
  famntag_nn_1 : N ;
  famoes_av_1 : A ;
  fan_nn_2 : N ;
  fan_nn_3 : N ;
  fanatiker_nn_1 : N ;
  fanatisk_av_1 : A ;
  fanborg_nn_1 : N ;
  fandango_nn_1 : N ;
  faner_nn_1 : N ;
  fanerogam_av_1 : A ;
  fanerogam_nn_1 : N ;
  fanfar_nn_1 : N ;
  fanjunkare_nn_1 : N ;
  fanskap_nn_1 : N ;
  fanstyg_nn_1 : N ;
  fantasi_nn_1 : N ;
  fantasidjur_nn_1 : N ;
  fantasifull_av_1 : A ;
  fantasiloes_av_1 : A ;
  fantasiprodukt_nn_1 : N ;
  fantasispel_nn_1 : N ;
  fantasivaerld_nn_1 : N ;
  fantast_nn_1 : N ;
  fantasteri_nn_1 : N ;
  fantastisk_av_1 : A ;
  fantom_nn_1 : N ;
  fantom_nn_2 : N ;
  fantomsnygg_av_1 : A ;
  fara_nn_1 : N ;
  fara_vb_1 : V ;
  farad_nn_1 : N ;
  farao_nn_1 : N ;
  farbar_av_1 : A ;
  farbroder_nn_1 : N ;
  farbroderlig_av_1 : A ;
  farbror_nn_1 : N ;
  fardag_nn_1 : N ;
  farfoeraelder_nn_1 : N ;
  fargalt_nn_1 : N ;
  farise_nn_1 : N ;
  fariseisk_av_1 : A ;
  farkost_nn_1 : N ;
  farled_nn_1 : N ;
  farlig_av_1 : A ;
  farlighet_nn_1 : N ;
  farm_nn_1 : N ;
  farmaceut_nn_1 : N ;
  farmaceutisk_av_1 : A ;
  farmacevt_nn_1 : N ;
  farmacevtisk_av_1 : A ;
  farmacie_av_1 : A ;
  farmaka_nn_1 : N ;
  farmakolog_nn_1 : N ;
  farmakologisk_av_1 : A ;
  farmakope_nn_1 : N ;
  farmare_nn_1 : N ;
  farmor_nn_1 : N ;
  farofylld_av_1 : A ;
  farozon_nn_1 : N ;
  fars_nn_1 : N ;
  farsarv_nn_1 : N ;
  farsgubbe_nn_1 : N ;
  farsot_nn_1 : N ;
  farstu_nn_1 : N ;
  fart_nn_1 : N ;
  fartblind_av_1 : A ;
  fartdaare_nn_1 : N ;
  farthaallare_nn_1 : N ;
  farthinder_nn_1 : N ;
  fartkamera_nn_1 : N ;
  fartrand_nn_1 : N ;
  fartyg_nn_1 : N ;
  fartygsbesaettning_nn_1 : N ;
  fartygsbotten_nn_1 : N ;
  fartygsdaeck_nn_1 : N ;
  fartygskurs_nn_1 : N ;
  fartygslast_nn_1 : N ;
  fartygssida_nn_1 : N ;
  fartygsskrov_nn_1 : N ;
  fartygstyp_nn_1 : N ;
  farvael_nn_1 : N ;
  farvatten_nn_1 : N ;
  faryngal_av_1 : A ;
  fas_nn_1 : N ;
  fasa_nn_1 : N ;
  fasad_nn_1 : N ;
  fasan_nn_1 : N ;
  fasansfull_av_1 : A ;
  fasavaeckande_av_1 : A ;
  fascist_nn_1 : N ;
  fascistisk_av_1 : A ;
  fasett_nn_1 : N ;
  fasettoega_nn_1 : N ;
  fasfoerskjutning_nn_1 : N ;
  fashionabel_av_1 : A ;
  faskikel_nn_1 : N ;
  faskin_nn_1 : N ;
  faskinkniv_nn_1 : N ;
  faslig_av_1 : A ;
  fason_nn_1 : N ;
  fasspaenning_nn_1 : N ;
  fast_ab_1 : Adv ;
  fast_av_1 : A ;
  fasta_nn_1 : N ;
  fastage_nn_1 : N ;
  fastemaanad_nn_1 : N ;
  faster_nn_1 : N ;
  fastfrusen_av_1 : A ;
  fasthaalla_vb_1 : V ;
  fasthaallning_nn_1 : N ;
  fasthet_nn_1 : N ;
  fastighet_nn_1 : N ;
  fastighetsbyraa_nn_1 : N ;
  fastighetskoep_nn_1 : N ;
  fastighetsmaeklare_nn_1 : N ;
  fastighetsskatt_nn_1 : N ;
  fastighetsskoetare_nn_1 : N ;
  fastighetstaxering_nn_1 : N ;
  fastlaast_av_1 : A ;
  fastlaenning_nn_1 : N ;
  fastlagsbulle_nn_1 : N ;
  fastlagsris_nn_1 : N ;
  fastlagssoendag_nn_1 : N ;
  fastmer_ab_1 : Adv ;
  fastsaettning_nn_1 : N ;
  fastta_vb_1 : V ;
  fat_nn_1 : N ;
  fatabur_nn_1 : N ;
  fatal_av_1 : A ;
  fataliedag_nn_1 : N ;
  fatalietid_nn_1 : N ;
  fatalist_nn_1 : N ;
  fatalistisk_av_1 : A ;
  fatalitet_nn_1 : N ;
  fatbur_nn_1 : N ;
  fatt_ab_1 : Adv ;
  fatt_av_1 : A ;
  fattbar_av_1 : A ;
  fattbarhet_nn_1 : N ;
  fattig_av_1 : A ;
  fattigdom_nn_1 : N ;
  fattigdomsbevis_nn_1 : N ;
  fattighjon_nn_1 : N ;
  fattiglapp_nn_1 : N ;
  fattlig_av_1 : A ;
  fattning_nn_1 : N ;
  faun_nn_1 : N ;
  faunist_nn_1 : N ;
  faunistisk_av_1 : A ;
  faute_nn_1 : N ;
  favoer_nn_1 : N ;
  favorit_nn_1 : N ;
  favoritfoerfattare_nn_1 : N ;
  favoritraett_nn_1 : N ;
  favoritrestaurang_nn_1 : N ;
  fax_nn_1 : N ;
  fax_nn_2 : N ;
  fe_nn_1 : N ;
  featureprogram_nn_1 : N ;
  feber_nn_1 : N ;
  feberanfall_nn_1 : N ;
  feberfri_av_1 : A ;
  febersjukdom_nn_1 : N ;
  febertermometer_nn_1 : N ;
  febrig_av_1 : A ;
  febril_av_1 : A ;
  federal_av_1 : A ;
  federalist_nn_1 : N ;
  federalistisk_av_1 : A ;
  federation_nn_1 : N ;
  federativ_av_1 : A ;
  feeri_nn_1 : N ;
  feg_av_1 : A ;
  feghet_nn_1 : N ;
  fegis_nn_1 : N ;
  fejd_nn_1 : N ;
  fekal_av_1 : A ;
  fel_av_1 : A ;
  fel_nn_1 : N ;
  felaktig_av_1 : A ;
  felaktighet_nn_1 : N ;
  felbedoemning_nn_1 : N ;
  felberaekning_nn_1 : N ;
  feldrag_nn_1 : N ;
  felfinnare_nn_1 : N ;
  felfri_av_1 : A ;
  felgrepp_nn_1 : N ;
  felhandling_nn_1 : N ;
  felmarginal_nn_1 : N ;
  felparkering_nn_1 : N ;
  felprocent_nn_1 : N ;
  felraekningspeng_nn_1 : N ;
  felsaegning_nn_1 : N ;
  felslagen_av_1 : A ;
  felslut_nn_1 : N ;
  felsteg_nn_1 : N ;
  femaarig_av_1 : A ;
  femaarsplan_nn_1 : N ;
  femaktare_nn_1 : N ;
  femdagarsvecka_nn_1 : N ;
  femdygnsprognos_nn_1 : N ;
  feminin_av_1 : A ;
  femininum_nn_1 : N ;
  feminist_nn_1 : N ;
  feministisk_av_1 : A ;
  femkamp_nn_1 : N ;
  femling_nn_1 : N ;
  femoering_nn_1 : N ;
  femstaemmig_av_1 : A ;
  femtedel_nn_1 : N ;
  femtekolonn_nn_1 : N ;
  femtekolonnare_nn_1 : N ;
  femtiaarsdag_nn_1 : N ;
  femtikronorssedel_nn_1 : N ;
  femtilapp_nn_1 : N ;
  femtioaarsdag_nn_1 : N ;
  femtioering_nn_1 : N ;
  femtiokronorssedel_nn_1 : N ;
  femtiooering_nn_1 : N ;
  femtiotal_nn_1 : N ;
  femtiotalist_nn_1 : N ;
  femtital_nn_1 : N ;
  femtitalist_nn_1 : N ;
  femtonhundrameterslopp_nn_1 : N ;
  femuddig_av_1 : A ;
  fena_av_1 : A ;
  fender_nn_1 : N ;
  fendert_nn_1 : N ;
  fenedrin_nn_1 : N ;
  fenicier_nn_1 : N ;
  fenicisk_av_1 : A ;
  fenkoel_nn_1 : N ;
  fenmetralin_nn_1 : N ;
  fennicism_nn_1 : N ;
  fennoman_nn_1 : N ;
  fenol_nn_1 : N ;
  fenolftalein_nn_1 : N ;
  fenolisk_av_1 : A ;
  fenomen_nn_1 : N ;
  fenomenal_av_1 : A ;
  fenomenologisk_av_1 : A ;
  fenoplast_nn_1 : N ;
  fenotyp_nn_1 : N ;
  fenval_nn_1 : N ;
  feodal_av_1 : A ;
  ferie_nn_1 : N ;
  ferm_av_1 : A ;
  fermat_nn_1 : N ;
  ferment_nn_1 : N ;
  fermitet_nn_1 : N ;
  ferrit_nn_1 : N ;
  ferrolegering_nn_1 : N ;
  fertil_av_1 : A ;
  fertilitet_nn_1 : N ;
  fest_nn_1 : N ;
  festande_nn_1 : N ;
  festarrangoer_nn_1 : N ;
  festbord_nn_1 : N ;
  festival_nn_1 : N ;
  festivitet_nn_1 : N ;
  festklaenning_nn_1 : N ;
  festkvaell_nn_1 : N ;
  festlig_av_1 : A ;
  festlighet_nn_1 : N ;
  festmaaltid_nn_1 : N ;
  festmiddag_nn_1 : N ;
  feston_nn_1 : N ;
  festong_nn_1 : N ;
  festprisse_nn_1 : N ;
  festskrift_nn_1 : N ;
  festspel_nn_1 : N ;
  feststaemning_nn_1 : N ;
  festtaag_nn_1 : N ;
  festvaaning_nn_1 : N ;
  fet_av_1 : A ;
  fetblad_nn_1 : N ;
  fetisch_nn_1 : N ;
  fetischist_nn_1 : N ;
  fetknopp_nn_1 : N ;
  fetlagd_av_1 : A ;
  fets_nn_1 : N ;
  fetsill_nn_1 : N ;
  fetstil_nn_1 : N ;
  fett_nn_1 : N ;
  fettaemne_nn_1 : N ;
  fetthaerdning_nn_1 : N ;
  fetthalt_nn_1 : N ;
  fetthaltig_av_1 : A ;
  fettisdag_nn_1 : N ;
  fettisdagsbulle_nn_1 : N ;
  fettkoertel_nn_1 : N ;
  fettlever_nn_1 : N ;
  fettloesande_av_1 : A ;
  fettloeslig_av_1 : A ;
  fettloeslighet_nn_1 : N ;
  fetto_nn_1 : N ;
  fettreserv_nn_1 : N ;
  fettrik_av_1 : A ;
  fettsvansfaar_nn_1 : N ;
  fettvaevnad_nn_1 : N ;
  fettvalk_nn_1 : N ;
  fez_nn_1 : N ;
  fial_nn_1 : N ;
  fiasko_nn_1 : N ;
  fibbla_nn_1 : N ;
  fiber_nn_1 : N ;
  fiberrik_av_1 : A ;
  fiberspik_nn_1 : N ;
  fibervaext_nn_1 : N ;
  fibrig_av_1 : A ;
  fibrill_nn_1 : N ;
  fibrin_nn_1 : N ;
  fickformat_nn_1 : N ;
  fickhandbok_nn_1 : N ;
  fickkalkylator_nn_1 : N ;
  fickkniv_nn_1 : N ;
  fickpeng_nn_1 : N ;
  fickspegel_nn_1 : N ;
  ficktjuv_nn_1 : N ;
  fickur_nn_1 : N ;
  fiction_novell_nn_1 : N ;
  fideikommiss_nn_1 : N ;
  fidjian_nn_1 : N ;
  fidus_nn_1 : N ;
  fiende_nn_1 : N ;
  fiendskap_nn_1 : N ;
  fientlig_av_1 : A ;
  fientlighet_nn_1 : N ;
  fiffig_av_1 : A ;
  fifflare_nn_1 : N ;
  fight_nn_1 : N ;
  fighter_nn_1 : N ;
  figur_nn_1 : N ;
  figuraakning_nn_1 : N ;
  figurant_nn_1 : N ;
  figuration_nn_1 : N ;
  figurativ_av_1 : A ;
  figurlig_av_1 : A ;
  figursydd_av_1 : A ;
  fijian_nn_1 : N ;
  fik_nn_1 : N ;
  fiken_av_1 : A ;
  fikon_nn_1 : N ;
  fikonloev_nn_1 : N ;
  fikonspraak_nn_1 : N ;
  fikontraed_nn_1 : N ;
  fiktion_nn_1 : N ;
  fiktiv_av_1 : A ;
  fikus_nn_1 : N ;
  fil_nn_1 : N ;
  fil_nn_2 : N ;
  filantrop_nn_1 : N ;
  filantropisk_av_1 : A ;
  filatelist_nn_1 : N ;
  filbunke_nn_1 : N ;
  file_nn_1 : N ;
  filharmoniker_nn_1 : N ;
  filharmonisk_av_1 : A ;
  filial_nn_1 : N ;
  filibuster_nn_1 : N ;
  filibustring_nn_1 : N ;
  filigran_nn_1 : N ;
  filipin_nn_1 : N ;
  filippik_nn_1 : N ;
  filippinare_nn_1 : N ;
  filippinsk_av_1 : A ;
  filiste_nn_1 : N ;
  filister_nn_1 : N ;
  filistroes_av_1 : A ;
  filklove_nn_1 : N ;
  filkoerning_nn_1 : N ;
  film_nn_1 : N ;
  filmare_nn_1 : N ;
  filmatelje_nn_1 : N ;
  filmatisk_av_1 : A ;
  filmbild_nn_1 : N ;
  filmexpert_nn_1 : N ;
  filmfars_nn_1 : N ;
  filmfotograf_nn_1 : N ;
  filmframkallning_nn_1 : N ;
  filmgranskning_nn_1 : N ;
  filmhistoria_nn_1 : N ;
  filminspelning_nn_1 : N ;
  filmisk_av_1 : A ;
  filmkamera_nn_1 : N ;
  filmkomedi_nn_1 : N ;
  filmmanuskript_nn_1 : N ;
  filmning_nn_1 : N ;
  filmotek_nn_1 : N ;
  filmpremiaer_nn_1 : N ;
  filmregissoer_nn_1 : N ;
  filmrulle_nn_1 : N ;
  filmscen_nn_1 : N ;
  filmskaadespelare_nn_1 : N ;
  filmskapare_nn_1 : N ;
  filmstudio_nn_1 : N ;
  filmtecknare_nn_1 : N ;
  filolog_nn_1 : N ;
  filologi_nn_1 : N ;
  filologisk_av_1 : A ;
  filosof_nn_1 : N ;
  filosofem_nn_1 : N ;
  filosofi_nn_1 : N ;
  filosofie_av_1 : A ;
  filosofisk_av_1 : A ;
  filspaan_nn_1 : N ;
  filt_nn_1 : N ;
  filter_nn_1 : N ;
  filtercigarett_nn_1 : N ;
  filterpaase_nn_1 : N ;
  filtrat_nn_1 : N ;
  filtrerpapper_nn_1 : N ;
  filtspets_nn_1 : N ;
  filttoffel_nn_1 : N ;
  filur_nn_1 : N ;
  fimbulvinter_nn_1 : N ;
  fimmelstaang_nn_1 : N ;
  fimp_nn_1 : N ;
  fin_av_1 : A ;
  final_av_1 : A ;
  final_nn_1 : N ;
  finalist_nn_1 : N ;
  finansdebatt_nn_1 : N ;
  finansdepartement_nn_1 : N ;
  finansiaer_nn_1 : N ;
  finansiell_av_1 : A ;
  finansiering_nn_1 : N ;
  finansman_nn_1 : N ;
  finansminister_nn_1 : N ;
  finansplan_nn_1 : N ;
  finansvalp_nn_1 : N ;
  finemang_ab_1 : Adv ;
  finess_nn_1 : N ;
  finfin_av_1 : A ;
  finger_nn_1 : N ;
  fingeravtryck_nn_1 : N ;
  fingerboejarmuskel_nn_1 : N ;
  fingerborg_nn_1 : N ;
  fingerfaerdig_av_1 : A ;
  fingerfaerg_nn_1 : N ;
  fingerhud_nn_1 : N ;
  fingerled_nn_1 : N ;
  fingernerv_nn_1 : N ;
  fingeroert_nn_1 : N ;
  fingerprov_nn_1 : N ;
  fingerring_nn_1 : N ;
  fingersaettning_nn_1 : N ;
  fingerstraeckarmuskel_nn_1 : N ;
  fingersvamp_nn_1 : N ;
  fingertopp_nn_1 : N ;
  fingervante_nn_1 : N ;
  fingervisning_nn_1 : N ;
  finhyllt_av_1 : A ;
  finish_nn_1 : N ;
  finit_av_1 : A ;
  fink_nn_1 : N ;
  finkaensla_nn_1 : N ;
  finkaenslig_av_1 : A ;
  finkaenslighet_nn_1 : N ;
  finkalibrig_av_1 : A ;
  finkart_nn_1 : N ;
  finkelolja_nn_1 : N ;
  finkfaagel_nn_1 : N ;
  finklaedd_av_1 : A ;
  finkornig_av_1 : A ;
  finkunge_nn_1 : N ;
  finlaendare_nn_1 : N ;
  finlaendsk_av_1 : A ;
  finlaendska_nn_1 : N ;
  finlandism_nn_1 : N ;
  finlandssvensk_av_1 : A ;
  finlandssvensk_nn_1 : N ;
  finlandssvenska_nn_2 : N ;
  finlek_nn_1 : N ;
  finmaskig_av_1 : A ;
  finmekaniker_nn_1 : N ;
  finmekanisk_av_1 : A ;
  finna_vb_1 : V ;
  finne_nn_1 : N ;
  finnig_av_1 : A ;
  finnjolle_nn_1 : N ;
  finnmark_nn_1 : N ;
  finrum_nn_1 : N ;
  finsk_av_1 : A ;
  finsk_ugrisk_av_1 : A ;
  finska_nn_2 : N ;
  finskhet_nn_1 : N ;
  finsko_nn_1 : N ;
  finsmakare_nn_1 : N ;
  finsmide_nn_1 : N ;
  finsnickare_nn_1 : N ;
  finsnickeri_nn_1 : N ;
  finspunnen_av_1 : A ;
  finstaemd_av_1 : A ;
  finstilt_av_1 : A ;
  finstruktur_nn_1 : N ;
  fint_nn_1 : N ;
  fintlig_av_1 : A ;
  fintvaett_nn_1 : N ;
  finurlig_av_1 : A ;
  fiol_nn_1 : N ;
  fiolblock_nn_1 : N ;
  fiolspelare_nn_1 : N ;
  fiolstraeng_nn_1 : N ;
  fioritur_nn_1 : N ;
  fipplig_av_1 : A ;
  firma_nn_1 : N ;
  firmafest_nn_1 : N ;
  firmamaerke_nn_1 : N ;
  firmanamn_nn_1 : N ;
  firmatecknare_nn_1 : N ;
  firmateckning_nn_1 : N ;
  firngraens_nn_1 : N ;
  firre_nn_1 : N ;
  fis_nn_1 : N ;
  fischy_nn_1 : N ;
  fisfoernaem_av_1 : A ;
  fisig_av_1 : A ;
  fisk_nn_1 : N ;
  fiskaadra_nn_1 : N ;
  fiskal_av_1 : A ;
  fiskalisk_av_1 : A ;
  fiskare_nn_1 : N ;
  fiskart_nn_1 : N ;
  fiskben_nn_1 : N ;
  fiskbensmoenster_nn_1 : N ;
  fiskbulle_nn_1 : N ;
  fiskdamm_nn_1 : N ;
  fiske_nn_1 : N ;
  fiskebaat_nn_1 : N ;
  fiskebank_nn_1 : N ;
  fiskedrag_nn_1 : N ;
  fiskefartyg_nn_1 : N ;
  fiskegraens_nn_1 : N ;
  fiskekort_nn_1 : N ;
  fiskekrok_nn_1 : N ;
  fiskelaege_nn_1 : N ;
  fiskelag_nn_1 : N ;
  fiskenaet_nn_1 : N ;
  fiskenation_nn_1 : N ;
  fiskeredskap_nn_1 : N ;
  fiskeri_nn_1 : N ;
  fiskeristyrelse_nn_1 : N ;
  fiskevatten_nn_1 : N ;
  fiskezon_nn_1 : N ;
  fiskfile_nn_1 : N ;
  fiskgjuse_nn_1 : N ;
  fiskhamn_nn_1 : N ;
  fiskkrok_nn_1 : N ;
  fiskmaas_nn_1 : N ;
  fiskmun_nn_1 : N ;
  fisknaet_nn_1 : N ;
  fisknot_nn_1 : N ;
  fiskodling_nn_1 : N ;
  fiskoega_nn_1 : N ;
  fiskpinne_nn_1 : N ;
  fiskpudding_nn_1 : N ;
  fiskredskap_nn_1 : N ;
  fiskstim_nn_1 : N ;
  fisksump_nn_1 : N ;
  fisktom_av_1 : A ;
  fiskvandring_nn_1 : N ;
  fiskyngel_nn_1 : N ;
  fissil_av_1 : A ;
  fission_nn_1 : N ;
  fissur_nn_1 : N ;
  fistel_nn_1 : N ;
  fistuloes_av_1 : A ;
  fix_av_1 : A ;
  fixare_nn_1 : N ;
  fixativ_nn_1 : N ;
  fixerbad_nn_1 : N ;
  fixering_nn_1 : N ;
  fixeringsbild_nn_1 : N ;
  fixpunkt_nn_1 : N ;
  fixtur_nn_1 : N ;
  fjaeder_nn_1 : N ;
  fjaederboll_nn_1 : N ;
  fjaederbuske_nn_1 : N ;
  fjaederdraekt_nn_1 : N ;
  fjaederfae_nn_1 : N ;
  fjaederklaedd_av_1 : A ;
  fjaederlaett_av_1 : A ;
  fjaedermoln_nn_1 : N ;
  fjaederpensel_nn_1 : N ;
  fjaederskrud_nn_1 : N ;
  fjaedertyp_nn_1 : N ;
  fjaedervaag_nn_1 : N ;
  fjaedervinge_nn_1 : N ;
  fjaedring_nn_1 : N ;
  fjaell_nn_1 : N ;
  fjaellaemmel_nn_1 : N ;
  fjaellbaeck_nn_1 : N ;
  fjaellbjoerk_nn_1 : N ;
  fjaellbrud_nn_1 : N ;
  fjaellig_av_1 : A ;
  fjaellik_av_1 : A ;
  fjaellkedja_nn_1 : N ;
  fjaellnaera_av_1 : A ;
  fjaellpansar_nn_1 : N ;
  fjaellpipare_nn_1 : N ;
  fjaellplataa_nn_1 : N ;
  fjaellraev_nn_1 : N ;
  fjaellskivling_nn_1 : N ;
  fjaelltrakt_nn_1 : N ;
  fjaellturist_nn_1 : N ;
  fjaellvaerld_nn_1 : N ;
  fjaellvandrare_nn_1 : N ;
  fjaellvandring_nn_1 : N ;
  fjaellvraak_nn_1 : N ;
  fjaelster_nn_1 : N ;
  fjaer_av_1 : A ;
  fjaerd_nn_1 : N ;
  fjaerdedel_nn_1 : N ;
  fjaerding_nn_1 : N ;
  fjaerdingsman_nn_1 : N ;
  fjaerdingsvaeg_nn_1 : N ;
  fjaeril_nn_1 : N ;
  fjaerilsart_nn_1 : N ;
  fjaerran_ab_1 : Adv ;
  fjaerran_av_1 : A ;
  fjaerrblockering_nn_1 : N ;
  fjaerrkontroll_nn_1 : N ;
  fjaerrpunkt_nn_1 : N ;
  fjaerrseende_av_1 : A ;
  fjaerrskaadande_av_1 : A ;
  fjaerrskaadare_nn_1 : N ;
  fjaerrskrivare_nn_1 : N ;
  fjaerrskrivmaskin_nn_1 : N ;
  fjaerrstyrd_av_1 : A ;
  fjaerrtaag_nn_1 : N ;
  fjaert_nn_1 : N ;
  fjaesker_nn_1 : N ;
  fjaeskig_av_1 : A ;
  fjaet_nn_1 : N ;
  fjant_nn_1 : N ;
  fjanteri_nn_1 : N ;
  fjantig_av_1 : A ;
  fjoel_nn_1 : N ;
  fjolaar_nn_1 : N ;
  fjolaarsgraes_nn_1 : N ;
  fjolleri_nn_1 : N ;
  fjollig_av_1 : A ;
  fjomperi_nn_1 : N ;
  fjompig_av_1 : A ;
  fjord_nn_1 : N ;
  fjordhaest_nn_1 : N ;
  fjording_nn_1 : N ;
  fjun_nn_1 : N ;
  fjunig_av_1 : A ;
  fjuttig_av_1 : A ;
  flaabuse_nn_1 : N ;
  flaasig_av_1 : A ;
  flabb_nn_1 : N ;
  flabb_nn_2 : N ;
  flabbig_av_1 : A ;
  flack_av_1 : A ;
  flackbanepjaes_nn_1 : N ;
  fladdermus_nn_1 : N ;
  fladdrig_av_1 : A ;
  flaeck_nn_1 : N ;
  flaeckborttagning_nn_1 : N ;
  flaeckborttagningsmedel_nn_1 : N ;
  flaeckfri_av_1 : A ;
  flaeckig_av_1 : A ;
  flaeckvis_ab_1 : Adv ;
  flaeder_nn_1 : N ;
  flaederbaer_nn_1 : N ;
  flaedermus_nn_1 : N ;
  flaekt_nn_1 : N ;
  flaengig_av_1 : A ;
  flaens_nn_1 : N ;
  flaerdfri_av_1 : A ;
  flaerdfull_av_1 : A ;
  flaeskaenger_nn_1 : N ;
  flaeskfile_nn_1 : N ;
  flaeskhare_nn_1 : N ;
  flaeskig_av_1 : A ;
  flaeskkarre_nn_1 : N ;
  flaeskkorv_nn_1 : N ;
  flaeskkotlett_nn_1 : N ;
  flaesklaegg_nn_1 : N ;
  flaesklaepp_nn_1 : N ;
  flaesktaerning_nn_1 : N ;
  flaetverk_nn_1 : N ;
  flagell_nn_1 : N ;
  flagellant_nn_1 : N ;
  flagellat_nn_1 : N ;
  flageolett_nn_1 : N ;
  flaggdag_nn_1 : N ;
  flaggkapten_nn_1 : N ;
  flaggman_nn_1 : N ;
  flaggning_nn_1 : N ;
  flaggskepp_nn_1 : N ;
  flaggspel_nn_1 : N ;
  flaggstaang_nn_1 : N ;
  flagig_av_1 : A ;
  flagrant_av_1 : A ;
  flak_nn_1 : N ;
  flakong_nn_1 : N ;
  flamenco_nn_1 : N ;
  flamingo_nn_1 : N ;
  flamlaendare_nn_1 : N ;
  flamlaendsk_av_1 : A ;
  flamlaendska_nn_2 : N ;
  flammig_av_1 : A ;
  flampunkt_nn_1 : N ;
  flamsig_av_1 : A ;
  flamsk_av_1 : A ;
  flamskvaevnad_nn_1 : N ;
  flamskyddsmedel_nn_1 : N ;
  flamugn_nn_1 : N ;
  flandrisk_av_1 : A ;
  flanell_nn_1 : N ;
  flanellograf_nn_1 : N ;
  flank_nn_1 : N ;
  flanoer_nn_1 : N ;
  flark_nn_1 : N ;
  flarn_nn_1 : N ;
  flaskbarn_nn_1 : N ;
  flaskborste_nn_1 : N ;
  flaskhaal_nn_1 : N ;
  flaskhals_nn_1 : N ;
  flaskoeppning_nn_1 : N ;
  flatbroed_nn_1 : N ;
  flatfisk_nn_1 : N ;
  flatlus_nn_1 : N ;
  flatskratt_nn_1 : N ;
  flau_av_1 : A ;
  flaxig_av_1 : A ;
  flegmatiker_nn_1 : N ;
  flegmatisk_av_1 : A ;
  flektion_nn_1 : N ;
  fleraarig_av_1 : A ;
  flerbarnsfamilj_nn_1 : N ;
  flercellig_av_1 : A ;
  flerdubbel_av_1 : A ;
  flerfaergstryck_nn_1 : N ;
  flerfaldig_av_1 : A ;
  flerfamiljshus_nn_1 : N ;
  flermansvalkrets_nn_1 : N ;
  flerpartisystem_nn_1 : N ;
  flerspraakig_av_1 : A ;
  flerstaedes_ab_1 : Adv ;
  flerstaemmig_av_1 : A ;
  flerstammig_av_1 : A ;
  flertydig_av_1 : A ;
  flervaaningshus_nn_1 : N ;
  flervalstest_nn_1 : N ;
  flervalsuppgift_nn_1 : N ;
  fles_nn_1 : N ;
  flexibel_av_1 : A ;
  flexibilitet_nn_1 : N ;
  flexion_nn_1 : N ;
  flextid_nn_1 : N ;
  flexur_nn_1 : N ;
  flickjaegare_nn_1 : N ;
  flicknamn_nn_1 : N ;
  flickpension_nn_1 : N ;
  flickvaen_nn_1 : N ;
  flik_nn_1 : N ;
  flikig_av_1 : A ;
  flimmercell_nn_1 : N ;
  flimmerhaar_nn_1 : N ;
  flimrig_av_1 : A ;
  flin_nn_1 : N ;
  flink_av_1 : A ;
  flintlaas_nn_1 : N ;
  flintlaasgevaer_nn_1 : N ;
  flintskalle_nn_1 : N ;
  flintskallig_av_1 : A ;
  flipperspel_nn_1 : N ;
  flisig_av_1 : A ;
  flitig_av_1 : A ;
  flo_nn_1 : N ;
  flock_nn_1 : N ;
  flockblommig_av_1 : A ;
  flockig_av_1 : A ;
  flockinstinkt_nn_1 : N ;
  flockkamrat_nn_1 : N ;
  flod_nn_1 : N ;
  flodarm_nn_1 : N ;
  flodbaedd_nn_1 : N ;
  flodbraedd_nn_1 : N ;
  floddal_nn_1 : N ;
  flodhaest_nn_1 : N ;
  flodiller_nn_1 : N ;
  flodomraade_nn_1 : N ;
  flodprofil_nn_1 : N ;
  flodslaett_nn_1 : N ;
  flodstrand_nn_1 : N ;
  flodsystem_nn_1 : N ;
  flodterrass_nn_1 : N ;
  floede_nn_1 : N ;
  floedesdiagram_nn_1 : N ;
  floedesschema_nn_1 : N ;
  floej_nn_1 : N ;
  floejel_nn_1 : N ;
  floejt_nn_1 : N ;
  floejtist_nn_1 : N ;
  floejttravaer_nn_1 : N ;
  floert_nn_1 : N ;
  floertig_av_1 : A ;
  floets_nn_1 : N ;
  flogroenn_nn_1 : N ;
  flop_nn_1 : N ;
  flor_nn_1 : N ;
  florentinsk_av_1 : A ;
  florett_nn_1 : N ;
  florilegium_nn_1 : N ;
  florin_nn_1 : N ;
  florist_nn_1 : N ;
  floristisk_av_1 : A ;
  floskel_nn_1 : N ;
  floskuloes_av_1 : A ;
  flott_av_1 : A ;
  flottare_nn_1 : N ;
  flottbas_nn_1 : N ;
  flottbesoek_nn_1 : N ;
  flottbro_nn_1 : N ;
  flotte_nn_1 : N ;
  flottflaeck_nn_1 : N ;
  flottig_av_1 : A ;
  flottilj_nn_1 : N ;
  flottist_nn_1 : N ;
  flottled_nn_1 : N ;
  flottning_nn_1 : N ;
  flottningstimmer_nn_1 : N ;
  flottoer_nn_1 : N ;
  flottyr_nn_1 : N ;
  flox_nn_1 : N ;
  fluffig_av_1 : A ;
  flugblomster_nn_1 : N ;
  flugsnappare_nn_1 : N ;
  flugsvamp_nn_1 : N ;
  fluidum_nn_1 : N ;
  flukt_nn_1 : N ;
  fluktuation_nn_1 : N ;
  flummig_av_1 : A ;
  fluorbehandling_nn_1 : N ;
  fluorhalt_nn_1 : N ;
  fluorhaltig_av_1 : A ;
  fluorid_nn_1 : N ;
  fluss_nn_1 : N ;
  flussmedel_nn_1 : N ;
  fluster_nn_1 : N ;
  fluvial_av_1 : A ;
  fly_nn_1 : N ;
  flyg_nn_1 : N ;
  flyga_vb_1 : V ;
  flyganfall_nn_1 : N ;
  flygare_nn_1 : N ;
  flygattack_nn_1 : N ;
  flygbaat_nn_1 : N ;
  flygbas_nn_1 : N ;
  flygbild_nn_1 : N ;
  flygbiljett_nn_1 : N ;
  flygblad_nn_1 : N ;
  flygbolag_nn_1 : N ;
  flygbomb_nn_1 : N ;
  flygcertifikat_nn_1 : N ;
  flygekorre_nn_1 : N ;
  flygel_nn_1 : N ;
  flygfae_nn_1 : N ;
  flygfaelt_nn_1 : N ;
  flygfaerdig_av_1 : A ;
  flygfisk_nn_1 : N ;
  flygfoerband_nn_1 : N ;
  flygfoto_nn_1 : N ;
  flygfotografi_nn_1 : N ;
  flygg_av_1 : A ;
  flyghastighet_nn_1 : N ;
  flyghund_nn_1 : N ;
  flygindustri_nn_1 : N ;
  flygkaar_nn_1 : N ;
  flygkapning_nn_1 : N ;
  flygkapten_nn_1 : N ;
  flygkonst_nn_1 : N ;
  flygkropp_nn_1 : N ;
  flyglarm_nn_1 : N ;
  flygledare_nn_1 : N ;
  flygledes_ab_1 : Adv ;
  flygledning_nn_1 : N ;
  flyglinje_nn_1 : N ;
  flygmaskin_nn_1 : N ;
  flygning_nn_1 : N ;
  flygplan_nn_1 : N ;
  flygplanskabin_nn_1 : N ;
  flygplansroder_nn_1 : N ;
  flygplansvinge_nn_1 : N ;
  flygplats_nn_1 : N ;
  flygroenn_nn_1 : N ;
  flygtransport_nn_1 : N ;
  flygtur_nn_1 : N ;
  flygutbildning_nn_1 : N ;
  flygvaerdinna_nn_1 : N ;
  flygvapen_nn_1 : N ;
  flyhaent_av_1 : A ;
  flykt_nn_1 : N ;
  flyktfoersoek_nn_1 : N ;
  flyktig_av_1 : A ;
  flykting_nn_1 : N ;
  flyta_vb_1 : V ;
  flythjaelp_nn_1 : N ;
  flytning_nn_1 : N ;
  flyttbar_av_1 : A ;
  flyttblock_nn_1 : N ;
  flyttfaagel_nn_1 : N ;
  flyttgroet_nn_1 : N ;
  flyttkarl_nn_1 : N ;
  flyttlass_nn_1 : N ;
  flyttning_nn_1 : N ;
  flytvaest_nn_1 : N ;
  fnasig_av_1 : A ;
  fnask_nn_1 : N ;
  fnasker_nn_1 : N ;
  fniss_nn_1 : N ;
  fnissig_av_1 : A ;
  fnissning_nn_1 : N ;
  fnittrig_av_1 : A ;
  fnoesksvamp_nn_1 : N ;
  fnoskig_av_1 : A ;
  foaje_nn_1 : N ;
  fob_ab_1 : Adv ;
  fobi_nn_1 : N ;
  fobitraening_nn_1 : N ;
  fock_nn_1 : N ;
  fockmast_nn_1 : N ;
  focus_nn_1 : N ;
  foder_nn_1 : N ;
  foderblad_nn_1 : N ;
  fodermaengd_nn_1 : N ;
  fodermark_nn_1 : N ;
  foderpaase_nn_1 : N ;
  fodervaerde_nn_1 : N ;
  fodervaext_nn_1 : N ;
  fodral_nn_1 : N ;
  foedd_av_1 : A ;
  foedelse_nn_1 : N ;
  foedelsedag_nn_1 : N ;
  foedelsedagsbarn_nn_1 : N ;
  foedelsehem_nn_1 : N ;
  foedelsekontroll_nn_1 : N ;
  foedelsemaerke_nn_1 : N ;
  foedelsenummer_nn_1 : N ;
  foedelsestad_nn_1 : N ;
  foedelsetal_nn_1 : N ;
  foedgeni_nn_1 : N ;
  foedkrok_nn_1 : N ;
  foedoaemne_nn_1 : N ;
  foedoorganism_nn_1 : N ;
  foedopartikel_nn_1 : N ;
  foedoraad_nn_1 : N ;
  foedsel_nn_1 : N ;
  foedsloraett_nn_1 : N ;
  foega_ab_1 : Adv ;
  foegderi_nn_1 : N ;
  foegderifoervaltning_nn_1 : N ;
  foel_nn_1 : N ;
  foeljaktligen_ab_1 : Adv ;
  foeljande_av_1 : A ;
  foeljd_nn_1 : N ;
  foeljdenlig_av_1 : A ;
  foeljdriktig_av_1 : A ;
  foeljdsats_nn_1 : N ;
  foeljdverkning_nn_1 : N ;
  foeljebil_nn_1 : N ;
  foeljebrev_nn_1 : N ;
  foeljesedel_nn_1 : N ;
  foeljeslagare_nn_1 : N ;
  foeljeslagarinna_nn_1 : N ;
  foeljetong_nn_1 : N ;
  foeljsam_av_1 : A ;
  foelsto_nn_1 : N ;
  foen_nn_2 : N ;
  foenster_nn_1 : N ;
  foensterbaage_nn_1 : N ;
  foensterbaenk_nn_1 : N ;
  foensterbleck_nn_1 : N ;
  foensterbord_nn_1 : N ;
  foensterbraede_nn_1 : N ;
  foensterglas_nn_1 : N ;
  foensterkarm_nn_1 : N ;
  foensterkuvert_nn_1 : N ;
  foensterluft_nn_1 : N ;
  foensternisch_nn_1 : N ;
  foensterplats_nn_1 : N ;
  foensterputsare_nn_1 : N ;
  foenstersmyg_nn_1 : N ;
  foenstertittare_nn_1 : N ;
  foer_ab_1 : Adv ;
  foer_nn_1 : N ;
  foeraedling_nn_1 : N ;
  foeraektenskaplig_av_1 : A ;
  foeraelder_nn_1 : N ;
  foeraeldrabalk_nn_1 : N ;
  foeraeldrabesoek_nn_1 : N ;
  foeraeldradag_nn_1 : N ;
  foeraeldrafoermaan_nn_1 : N ;
  foeraeldrafoersaekring_nn_1 : N ;
  foeraeldrafri_av_1 : A ;
  foeraeldrahem_nn_1 : N ;
  foeraeldraledig_av_1 : A ;
  foeraeldraledighet_nn_1 : N ;
  foeraeldraloes_av_1 : A ;
  foeraeldratraed_nn_1 : N ;
  foeraelskelse_nn_1 : N ;
  foeraenderlig_av_1 : A ;
  foeraendring_nn_1 : N ;
  foeraendringstakt_nn_1 : N ;
  foeraeta_vb_1 : V ;
  foeraktfull_av_1 : A ;
  foeraktlig_av_1 : A ;
  foeraning_nn_1 : N ;
  foerankring_nn_1 : N ;
  foeranmaelning_nn_1 : N ;
  foeranstaltning_nn_1 : N ;
  foerare_nn_1 : N ;
  foerargelsevaeckande_av_1 : A ;
  foerarglig_av_1 : A ;
  foerarhytt_nn_1 : N ;
  foerarkabin_nn_1 : N ;
  foerbaalt_ab_1 : Adv ;
  foerbaetterlig_av_1 : A ;
  foerbaettring_nn_1 : N ;
  foerbaettringslaan_nn_1 : N ;
  foerband_nn_1 : N ;
  foerbandsplats_nn_1 : N ;
  foerbannelse_nn_1 : N ;
  foerbehaall_nn_1 : N ;
  foerbehaalla_vb_1 : V ;
  foerbehaallsam_av_1 : A ;
  foerbehaallsamhet_nn_1 : N ;
  foerbehaallsloes_av_1 : A ;
  foerbemaelde_av_1 : A ;
  foerberedande_av_1 : A ;
  foerberedd_av_1 : A ;
  foerberedelse_nn_1 : N ;
  foerberg_nn_1 : N ;
  foerbi_ab_1 : Adv ;
  foerbi_av_1 : A ;
  foerbifartsled_nn_1 : N ;
  foerbigaa_vb_1 : V ;
  foerbigaangen_av_1 : A ;
  foerbinda_vb_1 : V ;
  foerbindelse_nn_1 : N ;
  foerbindelsegaang_nn_1 : N ;
  foerbindelseled_nn_1 : N ;
  foerbindlig_av_1 : A ;
  foerbindning_nn_1 : N ;
  foerbiseende_nn_1 : N ;
  foerbjuda_vb_1 : V ;
  foerbjuden_av_1 : A ;
  foerblivande_av_1 : A ;
  foerbluffande_av_1 : A ;
  foerboen_nn_1 : N ;
  foerbraenningsmotor_nn_1 : N ;
  foerbraenningsprodukt_nn_1 : N ;
  foerbrinna_vb_1 : V ;
  foerbroedring_nn_1 : N ;
  foerbrukare_nn_1 : N ;
  foerbrukningsartikel_nn_1 : N ;
  foerbrukningsmaterial_nn_1 : N ;
  foerbryta_vb_1 : V ;
  foerbrytare_nn_1 : N ;
  foerbrytelse_nn_1 : N ;
  foerbud_nn_1 : N ;
  foerbund_nn_1 : N ;
  foerbunden_av_1 : A ;
  foerbundsbrev_nn_1 : N ;
  foerbundsdag_nn_1 : N ;
  foerbundskansler_nn_1 : N ;
  foerbundskapten_nn_1 : N ;
  foerbundspresident_nn_1 : N ;
  foerbundsregering_nn_1 : N ;
  foerbundsrepublik_nn_1 : N ;
  foerbundsstat_nn_1 : N ;
  foerbyggnad_nn_1 : N ;
  foerdaeck_nn_1 : N ;
  foerdaemning_nn_1 : N ;
  foerdaervlig_av_1 : A ;
  foerdel_nn_1 : N ;
  foerdelaktig_av_1 : A ;
  foerdelare_nn_1 : N ;
  foerdelning_nn_1 : N ;
  foerdelningspolitisk_av_1 : A ;
  foerdenskull_ab_1 : Adv ;
  foerdetta_av_1 : A ;
  foerdetting_nn_1 : N ;
  foerdevind_ab_1 : Adv ;
  foerdjupning_nn_1 : N ;
  foerdjupningskurs_nn_1 : N ;
  foerdoemd_av_1 : A ;
  foerdoemlig_av_1 : A ;
  foerdold_av_1 : A ;
  foerdom_nn_1 : N ;
  foerdomsalstrande_av_1 : A ;
  foerdomsfri_av_1 : A ;
  foerdomsfull_av_1 : A ;
  foerdra_vb_1 : V ;
  foerdrag_nn_1 : N ;
  foerdragen_av_1 : A ;
  foerdragsam_av_1 : A ;
  foerdragsamhet_nn_1 : N ;
  foerdriva_vb_1 : V ;
  foerdrivande_nn_1 : N ;
  foerdrivning_nn_1 : N ;
  foerdroejning_nn_1 : N ;
  foerdroemd_av_1 : A ;
  foerdubbling_nn_1 : N ;
  foere_ab_1 : Adv ;
  foerebaera_vb_1 : V ;
  foerebaerande_nn_1 : N ;
  foerebild_nn_1 : N ;
  foerebildlig_av_1 : A ;
  foerebraaelse_nn_1 : N ;
  foerebud_nn_1 : N ;
  foeredoemlig_av_1 : A ;
  foeredra_vb_1 : V ;
  foeredrag_nn_1 : N ;
  foeredragande_nn_1 : N ;
  foeredragning_nn_1 : N ;
  foerefintlig_av_1 : A ;
  foeregaa_vb_1 : V ;
  foeregaaende_av_1 : A ;
  foeregaangare_nn_1 : N ;
  foeregaangsman_nn_1 : N ;
  foerege_vb_1 : V ;
  foeregivande_nn_1 : N ;
  foeregripa_vb_1 : V ;
  foerehaalla_vb_1 : V ;
  foerehavande_nn_1 : N ;
  foerekomma_vb_1 : V ;
  foerekommande_av_1 : A ;
  foerekomst_nn_1 : N ;
  foerelaeggande_nn_1 : N ;
  foerelaesare_nn_1 : N ;
  foerelaesning_nn_1 : N ;
  foerelaesningssal_nn_1 : N ;
  foereloepare_nn_1 : N ;
  foeremaal_nn_1 : N ;
  foerening_nn_1 : N ;
  foereningsbank_nn_1 : N ;
  foereningsfrihet_nn_1 : N ;
  foereningsmaengd_nn_1 : N ;
  foereningsroerelse_nn_1 : N ;
  foerenkling_nn_1 : N ;
  foerenlig_av_1 : A ;
  foerenlighet_nn_1 : N ;
  foeresats_nn_1 : N ;
  foereskrift_nn_1 : N ;
  foereskriva_vb_1 : V ;
  foerespegling_nn_1 : N ;
  foerespraakare_nn_1 : N ;
  foerestaaende_av_1 : A ;
  foerestaandare_nn_1 : N ;
  foerestaandarinna_nn_1 : N ;
  foerestaellande_av_1 : A ;
  foerestaellare_nn_1 : N ;
  foerestaellning_nn_1 : N ;
  foerestaellningsvaerld_nn_1 : N ;
  foereta_vb_1 : V ;
  foeretag_nn_1 : N ;
  foeretagare_nn_1 : N ;
  foeretagsam_av_1 : A ;
  foeretagsamhet_nn_1 : N ;
  foeretagsekonom_nn_1 : N ;
  foeretagsekonomisk_av_1 : A ;
  foeretagsfilial_nn_1 : N ;
  foeretagsledning_nn_1 : N ;
  foeretagsnaemnd_nn_1 : N ;
  foeretagsvinst_nn_1 : N ;
  foeretal_nn_1 : N ;
  foereteelse_nn_1 : N ;
  foeretraedare_nn_1 : N ;
  foeretraede_nn_1 : N ;
  foeretraedesvis_ab_1 : Adv ;
  foerevaendning_nn_1 : N ;
  foerevarande_av_1 : A ;
  foerfader_nn_1 : N ;
  foerfaerlig_av_1 : A ;
  foerfalla_vb_1 : V ;
  foerfallen_av_1 : A ;
  foerfallodag_nn_1 : N ;
  foerfalskare_nn_1 : N ;
  foerfalskning_nn_1 : N ;
  foerfarande_nn_1 : N ;
  foerfaren_av_1 : A ;
  foerfaringssaett_nn_1 : N ;
  foerfattare_nn_1 : N ;
  foerfattarinna_nn_1 : N ;
  foerfattarjag_nn_1 : N ;
  foerfattning_nn_1 : N ;
  foerfining_nn_1 : N ;
  foerflugen_av_1 : A ;
  foerfluten_av_1 : A ;
  foerflyta_vb_1 : V ;
  foerflyttning_nn_1 : N ;
  foerfoeljelse_nn_1 : N ;
  foerfoeljelsemani_nn_1 : N ;
  foerfoerare_nn_1 : N ;
  foerfoerelse_nn_1 : N ;
  foerfoerisk_av_1 : A ;
  foerfogande_nn_1 : N ;
  foerfogandelag_nn_1 : N ;
  foerfraagning_nn_1 : N ;
  foerfriskning_nn_1 : N ;
  foerfrusen_av_1 : A ;
  foergaa_vb_1 : V ;
  foergaard_nn_1 : N ;
  foergaenglig_av_1 : A ;
  foergaeta_vb_1 : V ;
  foergaetmigej_nn_1 : N ;
  foergaeves_ab_1 : Adv ;
  foergasare_nn_1 : N ;
  foergiftning_nn_1 : N ;
  foergjord_av_1 : A ;
  foergraaten_av_1 : A ;
  foergraemd_av_1 : A ;
  foergrening_nn_1 : N ;
  foergripelse_nn_1 : N ;
  foergriplig_av_1 : A ;
  foergrund_nn_1 : N ;
  foergrundsfigur_nn_1 : N ;
  foergrundsgestalt_nn_1 : N ;
  foergudning_nn_1 : N ;
  foerhaall_nn_1 : N ;
  foerhaallande_nn_1 : N ;
  foerhaallandevis_ab_1 : Adv ;
  foerhaallning_nn_1 : N ;
  foerhaallningsorder_nn_1 : N ;
  foerhaallningssaett_nn_1 : N ;
  foerhaardnad_nn_1 : N ;
  foerhaerligande_nn_1 : N ;
  foerhaerskande_av_1 : A ;
  foerhall_nn_1 : N ;
  foerhanden_ab_1 : Adv ;
  foerhandenvarande_av_1 : A ;
  foerhandlare_nn_1 : N ;
  foerhandling_nn_1 : N ;
  foerhandlingsbar_av_1 : A ;
  foerhandlingsbord_nn_1 : N ;
  foerhandsbukt_nn_1 : N ;
  foerhatlig_av_1 : A ;
  foerhinder_nn_1 : N ;
  foerhistorisk_av_1 : A ;
  foerhoejning_nn_1 : N ;
  foerhoer_nn_1 : N ;
  foerhoersledare_nn_1 : N ;
  foerhoersvittne_nn_1 : N ;
  foerhoppning_nn_1 : N ;
  foerhoppningsfull_av_1 : A ;
  foerhoppningsvis_ab_1 : Adv ;
  foerhuggning_nn_1 : N ;
  foerintande_av_1 : A ;
  foerkaempe_nn_1 : N ;
  foerkaenning_nn_1 : N ;
  foerkaensla_nn_1 : N ;
  foerkaerlek_nn_1 : N ;
  foerkalkning_nn_1 : N ;
  foerkastelsedom_nn_1 : N ;
  foerkastlig_av_1 : A ;
  foerkastning_nn_1 : N ;
  foerklae_nn_1 : N ;
  foerklaede_nn_1 : N ;
  foerklaedeskjol_nn_1 : N ;
  foerklaednad_nn_1 : N ;
  foerklaring_nn_1 : N ;
  foerklarlig_av_1 : A ;
  foerklenande_av_1 : A ;
  foerklistring_nn_1 : N ;
  foerklyftning_nn_1 : N ;
  foerknippning_nn_1 : N ;
  foerkoep_nn_1 : N ;
  foerkomma_vb_1 : V ;
  foerkommen_av_1 : A ;
  foerkortning_nn_1 : N ;
  foerkrigstid_nn_1 : N ;
  foerkristen_av_1 : A ;
  foerkroppning_nn_1 : N ;
  foerkrossande_av_1 : A ;
  foerkrympt_av_1 : A ;
  foerkunnare_nn_1 : N ;
  foerkunnelse_nn_1 : N ;
  foerkyld_av_1 : A ;
  foerkylning_nn_1 : N ;
  foerlaat_nn_1 : N ;
  foerlaata_vb_1 : V ;
  foerlaatlig_av_1 : A ;
  foerladdning_nn_1 : N ;
  foerlaegen_av_1 : A ;
  foerlaegenhet_nn_1 : N ;
  foerlaeggare_nn_1 : N ;
  foerlaeggning_nn_1 : N ;
  foerlaengning_nn_1 : N ;
  foerlaengningssladd_nn_1 : N ;
  foerlaening_nn_1 : N ;
  foerlaest_av_1 : A ;
  foerlag_1_nn_1 : N ;
  foerlag_2_nn_1 : N ;
  foerlagsbevis_nn_1 : N ;
  foerlagslaan_nn_1 : N ;
  foerlamning_nn_1 : N ;
  foerled_nn_1 : N ;
  foerlida_vb_1 : V ;
  foerliden_av_1 : A ;
  foerlig_av_1 : A ;
  foerlikning_nn_1 : N ;
  foerlikningskommission_nn_1 : N ;
  foerlikningsman_nn_1 : N ;
  foerlisning_nn_1 : N ;
  foerljudande_nn_1 : N ;
  foerljugen_av_1 : A ;
  foerloepare_nn_1 : N ;
  foerloepning_nn_1 : N ;
  foerlopp_nn_1 : N ;
  foerlorare_nn_1 : N ;
  foerlossning_nn_1 : N ;
  foerlossningsanstalt_nn_1 : N ;
  foerlovning_nn_1 : N ;
  foerlovningsring_nn_1 : N ;
  foerlupen_av_1 : A ;
  foerlust_nn_1 : N ;
  foerlustbringande_av_1 : A ;
  foerlustelse_nn_1 : N ;
  foerlustig_av_1 : A ;
  foermaan_nn_1 : N ;
  foermaanlig_av_1 : A ;
  foermaanserbjudande_nn_1 : N ;
  foermaanstagare_nn_1 : N ;
  foermaeld_av_1 : A ;
  foermaeten_av_1 : A ;
  foermak_nn_1 : N ;
  foerman_nn_1 : N ;
  foermaning_nn_1 : N ;
  foermatch_nn_1 : N ;
  foermedlande_av_1 : A ;
  foermedlare_nn_1 : N ;
  foermedling_nn_1 : N ;
  foermedveten_av_1 : A ;
  foerment_av_1 : A ;
  foermer_av_1 : A ;
  foermiddag_nn_1 : N ;
  foermildrande_av_1 : A ;
  foerminskning_nn_1 : N ;
  foermodande_nn_1 : N ;
  foermodligen_ab_1 : Adv ;
  foermoegen_av_1 : A ;
  foermoegenhet_nn_1 : N ;
  foermoegenhetsbrott_nn_1 : N ;
  foermoegenhetsraett_nn_1 : N ;
  foermoegenhetsskatt_nn_1 : N ;
  foermoerkelse_nn_1 : N ;
  foermoerkelsevariabel_nn_1 : N ;
  foermoerkning_nn_1 : N ;
  foermultning_nn_1 : N ;
  foermyndaraktig_av_1 : A ;
  foermyndare_nn_1 : N ;
  foermyndarskap_nn_1 : N ;
  foernaem_av_1 : A ;
  foernaemitet_nn_1 : N ;
  foernaemlig_av_1 : A ;
  foernaemligen_ab_1 : Adv ;
  foernaer_ab_1 : Adv ;
  foernaermelse_nn_1 : N ;
  foernamn_nn_1 : N ;
  foernekare_nn_1 : N ;
  foernekelse_nn_1 : N ;
  foernimbar_av_1 : A ;
  foernimma_vb_1 : V ;
  foernimmelse_nn_1 : N ;
  foerning_nn_1 : N ;
  foernoedenhet_nn_1 : N ;
  foernoejd_av_1 : A ;
  foernoejelse_nn_1 : N ;
  foernoejsam_av_1 : A ;
  foernuftig_av_1 : A ;
  foernuftsskael_nn_1 : N ;
  foernuftsstridig_av_1 : A ;
  foernuftsvidrig_av_1 : A ;
  foernumstig_av_1 : A ;
  foernumstighet_nn_1 : N ;
  foernyare_nn_1 : N ;
  foernybar_av_1 : A ;
  foernyelse_nn_1 : N ;
  foeroedande_av_1 : A ;
  foeroedelse_nn_1 : N ;
  foeroedmjukelse_nn_1 : N ;
  foeroekning_nn_1 : N ;
  foeroevare_nn_1 : N ;
  foeroever_ab_1 : Adv ;
  foeroevning_nn_1 : N ;
  foeroevrigt_ab_1 : Adv ;
  foerolaempning_nn_1 : N ;
  foerord_nn_1 : N ;
  foerordnande_nn_1 : N ;
  foerordning_nn_1 : N ;
  foerorening_nn_1 : N ;
  foeroreningsgrad_nn_1 : N ;
  foerort_nn_1 : N ;
  foerpackning_nn_1 : N ;
  foerpaktare_nn_1 : N ;
  foerpassning_nn_1 : N ;
  foerpatrull_nn_1 : N ;
  foerpik_nn_1 : N ;
  foerplaegnad_nn_1 : N ;
  foerpliktande_av_1 : A ;
  foerpliktelse_nn_1 : N ;
  foerpost_nn_1 : N ;
  foerpostfaektning_nn_1 : N ;
  foerpubertet_nn_1 : N ;
  foerpuppning_nn_1 : N ;
  foerr_ab_1 : Adv ;
  foerraad_nn_1 : N ;
  foerraadshus_nn_1 : N ;
  foerraedare_nn_1 : N ;
  foerraederi_nn_1 : N ;
  foerraedisk_av_1 : A ;
  foerraett_nn_1 : N ;
  foerraettare_nn_1 : N ;
  foerraettning_nn_1 : N ;
  foerregling_nn_1 : N ;
  foerresten_ab_1 : Adv ;
  foerrfoerra_av_1 : A ;
  foerrinna_vb_1 : V ;
  foerromantisk_av_1 : A ;
  foerromersk_av_1 : A ;
  foerrum_nn_1 : N ;
  foerruttnelsegas_nn_1 : N ;
  foerryckt_av_1 : A ;
  foerrymd_av_1 : A ;
  foersaapning_nn_1 : N ;
  foersaat_nn_1 : N ;
  foersaatlig_av_1 : A ;
  foersaegning_nn_1 : N ;
  foersaekran_nn_1 : N ;
  foersaekring_nn_1 : N ;
  foersaekringsbedraegeri_nn_1 : N ;
  foersaekringsbesked_nn_1 : N ;
  foersaekringsbolag_nn_1 : N ;
  foersaekringsbrev_nn_1 : N ;
  foersaekringsgivare_nn_1 : N ;
  foersaekringsinslag_nn_1 : N ;
  foersaekringskassa_nn_1 : N ;
  foersaekringsmarknad_nn_1 : N ;
  foersaekringspeng_nn_1 : N ;
  foersaekringspolis_nn_1 : N ;
  foersaekringspremie_nn_1 : N ;
  foersaekringsskydd_nn_1 : N ;
  foersaekringssystem_nn_1 : N ;
  foersaekringsvillkor_nn_1 : N ;
  foersaeljare_nn_1 : N ;
  foersaeljning_nn_1 : N ;
  foersaeljningsbransch_nn_1 : N ;
  foersaeljningschef_nn_1 : N ;
  foersaeljningsdisk_nn_1 : N ;
  foersaeljningsled_nn_1 : N ;
  foersaeljningsort_nn_1 : N ;
  foersaeljningspris_nn_1 : N ;
  foersaeljningsstaand_nn_1 : N ;
  foersaeljningsstopp_nn_1 : N ;
  foersaeljningsvana_nn_1 : N ;
  foersaeljningsvinst_nn_1 : N ;
  foersaemring_nn_1 : N ;
  foersaendelse_nn_1 : N ;
  foersaenkare_nn_1 : N ;
  foersaenkning_nn_1 : N ;
  foersaettsblad_nn_1 : N ;
  foersaettslins_nn_1 : N ;
  foersagd_av_1 : A ;
  foersakelse_nn_1 : N ;
  foersamling_nn_1 : N ;
  foersamlingsassistent_nn_1 : N ;
  foersamlingsbok_nn_1 : N ;
  foersamlingsfrihet_nn_1 : N ;
  foersamlingshem_nn_1 : N ;
  foersamlingsmedlem_nn_1 : N ;
  foersats_nn_1 : N ;
  foerseelse_nn_1 : N ;
  foersegel_nn_1 : N ;
  foersening_nn_1 : N ;
  foersiggaa_vb_1 : V ;
  foersigkommen_av_1 : A ;
  foersiktig_av_1 : A ;
  foersiktighet_nn_1 : N ;
  foersiktighetsaatgaerd_nn_1 : N ;
  foersiktighetsmaatt_nn_1 : N ;
  foersiktigtvis_ab_1 : Adv ;
  foersitta_vb_1 : V ;
  foersjunka_vb_1 : V ;
  foersjunken_av_1 : A ;
  foerskaemd_av_1 : A ;
  foerskaemning_nn_1 : N ;
  foerskaera_vb_1 : V ;
  foerskaerare_nn_1 : N ;
  foerskaerargaffel_nn_1 : N ;
  foerskaerarkniv_nn_1 : N ;
  foerskansning_nn_1 : N ;
  foerskepp_nn_1 : N ;
  foerskiffring_nn_1 : N ;
  foerskingrare_nn_1 : N ;
  foerskingring_nn_1 : N ;
  foerskinn_nn_1 : N ;
  foerskjuta_vb_1 : V ;
  foerskjutning_nn_1 : N ;
  foerskoleaalder_nn_1 : N ;
  foerskollaerare_nn_1 : N ;
  foerskott_nn_1 : N ;
  foerskraeckelse_nn_1 : N ;
  foerskraecklig_av_1 : A ;
  foerskraeckt_av_1 : A ;
  foerskraemd_av_1 : A ;
  foerskriva_vb_1 : V ;
  foerskrivning_nn_1 : N ;
  foerslag_1_nn_1 : N ;
  foerslag_2_nn_1 : N ;
  foerslagen_av_1 : A ;
  foerslagsrum_nn_1 : N ;
  foerslagsvis_ab_1 : Adv ;
  foerslappning_nn_1 : N ;
  foerslita_vb_1 : V ;
  foerslitning_nn_1 : N ;
  foersluta_vb_1 : V ;
  foerslutning_nn_1 : N ;
  foersmaedlig_av_1 : A ;
  foersoek_nn_1 : N ;
  foersoeksballong_nn_1 : N ;
  foersoeksdamm_nn_1 : N ;
  foersoeksdjur_nn_1 : N ;
  foersoeksgymnasium_nn_1 : N ;
  foersoeksheat_nn_1 : N ;
  foersoekskanin_nn_1 : N ;
  foersoeksledare_nn_1 : N ;
  foersoeksobjekt_nn_1 : N ;
  foersoeksperson_nn_1 : N ;
  foersoeksverksamhet_nn_1 : N ;
  foersoeksvis_ab_1 : Adv ;
  foersoerjare_nn_1 : N ;
  foersoerjningsboerda_nn_1 : N ;
  foersommar_nn_1 : N ;
  foersonande_av_1 : A ;
  foersoning_nn_1 : N ;
  foersonlig_av_1 : A ;
  foersova_vb_1 : V ;
  foerspaend_av_1 : A ;
  foerspaenning_nn_1 : N ;
  foerspel_nn_1 : N ;
  foerst_ab_1 : Adv ;
  foerstaaelig_av_1 : A ;
  foerstaaende_av_1 : A ;
  foerstaandig_av_1 : A ;
  foerstaandshandikapp_nn_1 : N ;
  foerstaang_nn_1 : N ;
  foerstaas_ab_1 : Adv ;
  foerstaasigpaaare_nn_1 : N ;
  foerstad_nn_1 : N ;
  foerstadagsbrev_nn_1 : N ;
  foerstadium_nn_1 : N ;
  foerstaemd_av_1 : A ;
  foerstaendigande_nn_1 : N ;
  foerstaerkare_nn_1 : N ;
  foerstaerkning_nn_1 : N ;
  foerstaerkningsord_nn_1 : N ;
  foerstaev_nn_1 : N ;
  foerstag_nn_1 : N ;
  foerstagaangsvaeljare_nn_1 : N ;
  foerstagradsekvation_nn_1 : N ;
  foerstahandsuppgift_nn_1 : N ;
  foerstaklasshotell_nn_1 : N ;
  foerstamajtaag_nn_1 : N ;
  foerstasida_nn_1 : N ;
  foerstaupplaga_nn_1 : N ;
  foerstavelse_nn_1 : N ;
  foerstbemaelde_av_1 : A ;
  foersteg_nn_1 : N ;
  foerstfoedd_av_1 : A ;
  foerstfoederska_nn_1 : N ;
  foerstklassig_av_1 : A ;
  foerstling_nn_1 : N ;
  foerstnaemnd_av_1 : A ;
  foerstnaemnde_av_1 : A ;
  foerstoerelse_nn_1 : N ;
  foerstoppning_nn_1 : N ;
  foerstoring_nn_1 : N ;
  foerstoringsapparat_nn_1 : N ;
  foerstoringsglas_nn_1 : N ;
  foerstraeckning_nn_1 : N ;
  foerstroedd_av_1 : A ;
  foerstroeelse_nn_1 : N ;
  foerstubro_nn_1 : N ;
  foerstucken_av_1 : A ;
  foerstudie_nn_1 : N ;
  foerstuga_nn_1 : N ;
  foerstugubro_nn_1 : N ;
  foerstukvist_nn_1 : N ;
  foerstulen_av_1 : A ;
  foersumbar_av_1 : A ;
  foersumlig_av_1 : A ;
  foersumlighet_nn_1 : N ;
  foersummelse_nn_1 : N ;
  foersupen_av_1 : A ;
  foersvaarande_av_1 : A ;
  foersvaerja_vb_1 : V ;
  foersvarare_nn_1 : N ;
  foersvarbar_av_1 : A ;
  foersvarlig_av_1 : A ;
  foersvarsadvokat_nn_1 : N ;
  foersvarsanlaeggning_nn_1 : N ;
  foersvarsattache_nn_1 : N ;
  foersvarsgren_nn_1 : N ;
  foersvarshemlighet_nn_1 : N ;
  foersvarskostnad_nn_1 : N ;
  foersvarskraft_nn_1 : N ;
  foersvarslinje_nn_1 : N ;
  foersvarsloes_av_1 : A ;
  foersvarsminister_nn_1 : N ;
  foersvarsomraade_nn_1 : N ;
  foersvarsskrift_nn_1 : N ;
  foersvarsspel_nn_1 : N ;
  foersvarsspelare_nn_1 : N ;
  foersvarsstab_nn_1 : N ;
  foersvarsstaellning_nn_1 : N ;
  foersvarstal_nn_1 : N ;
  foersvarsverk_nn_1 : N ;
  foersvinna_vb_1 : V ;
  foersvinnande_nn_1 : N ;
  foersynt_av_1 : A ;
  foerta_vb_1 : V ;
  foertaeckt_av_1 : A ;
  foertaendning_nn_1 : N ;
  foertaenksam_av_1 : A ;
  foertaetning_nn_1 : N ;
  foertalskampanj_nn_1 : N ;
  foertecken_nn_1 : N ;
  foerteckning_nn_1 : N ;
  foertegen_av_1 : A ;
  foertida_av_1 : A ;
  foertidsboerd_nn_1 : N ;
  foertidspension_nn_1 : N ;
  foertimring_nn_1 : N ;
  foertjaenst_ab_1 : Adv ;
  foertjaenst_nn_1 : N ;
  foertjaenstfull_av_1 : A ;
  foertjaensttecken_nn_1 : N ;
  foertjaent_av_1 : A ;
  foertjusande_av_1 : A ;
  foertjust_av_1 : A ;
  foertoejning_nn_1 : N ;
  foertoejningsring_nn_1 : N ;
  foertoning_nn_1 : N ;
  foertraefflig_av_1 : A ;
  foertraengning_nn_1 : N ;
  foertretlig_av_1 : A ;
  foertretlighet_nn_1 : N ;
  foertroende_nn_1 : N ;
  foertroendefraaga_nn_1 : N ;
  foertroendefull_av_1 : A ;
  foertroendeingivande_av_1 : A ;
  foertroendeman_nn_1 : N ;
  foertroenderaad_nn_1 : N ;
  foertroendeuppdrag_nn_1 : N ;
  foertroendevald_av_1 : A ;
  foertroendevotum_nn_1 : N ;
  foertrogen_av_1 : A ;
  foertrogenhet_nn_1 : N ;
  foertrolig_av_1 : A ;
  foertrolighet_nn_1 : N ;
  foertrollande_av_1 : A ;
  foertrupp_nn_1 : N ;
  foertryckare_nn_1 : N ;
  foertrytsam_av_1 : A ;
  foertunning_nn_1 : N ;
  foertvaalning_nn_1 : N ;
  foertvaett_nn_1 : N ;
  foerty_ab_1 : Adv ;
  foertydligande_nn_1 : N ;
  foerunderlig_av_1 : A ;
  foerundersoekning_nn_1 : N ;
  foerundransvaerd_av_1 : A ;
  foerut_1_ab_1 : Adv ;
  foerut_2_ab_1 : Adv ;
  foerutbestaemd_av_1 : A ;
  foerutsaegbar_av_1 : A ;
  foerutsaegelse_nn_1 : N ;
  foerutsaettning_nn_1 : N ;
  foerutsaettningsloes_av_1 : A ;
  foerutseende_av_1 : A ;
  foerutvarande_av_1 : A ;
  foervaanansvaerd_av_1 : A ;
  foervaegen_av_1 : A ;
  foervaeljare_nn_1 : N ;
  foervaend_av_1 : A ;
  foervaentansfull_av_1 : A ;
  foervaentning_nn_1 : N ;
  foervaermare_nn_1 : N ;
  foervaerv_nn_1 : N ;
  foervaervsavdrag_nn_1 : N ;
  foervaervsverksamhet_nn_1 : N ;
  foervaexling_nn_1 : N ;
  foervaext_av_1 : A ;
  foervaltare_nn_1 : N ;
  foervaltarskapsomraade_nn_1 : N ;
  foervaltning_nn_1 : N ;
  foervaltningsberaettelse_nn_1 : N ;
  foervaltningsbolag_nn_1 : N ;
  foervaltningsutskott_nn_1 : N ;
  foervandling_nn_1 : N ;
  foervandlingskonstnaer_nn_1 : N ;
  foervandlingsnummer_nn_1 : N ;
  foervandlingsstraff_nn_1 : N ;
  foervanskning_nn_1 : N ;
  foervaring_nn_1 : N ;
  foervaringshall_nn_1 : N ;
  foervaringsutrymme_nn_1 : N ;
  foervarning_nn_1 : N ;
  foerveckling_nn_1 : N ;
  foervedning_nn_1 : N ;
  foerverkande_nn_1 : N ;
  foerverkligande_nn_1 : N ;
  foerveten_av_1 : A ;
  foervillelse_nn_1 : N ;
  foervisning_nn_1 : N ;
  foervisso_ab_1 : Adv ;
  foervittring_nn_1 : N ;
  foervraengning_nn_1 : N ;
  foervrida_vb_1 : V ;
  foervunnen_av_1 : A ;
  foervuxen_av_1 : A ;
  fog_nn_1 : N ;
  fogde_nn_1 : N ;
  fogeord_nn_1 : N ;
  foglig_av_1 : A ;
  fogstryka_vb_1 : V ;
  fogsvans_nn_1 : N ;
  fokal_av_1 : A ;
  fokaldistans_nn_1 : N ;
  fokalplan_nn_1 : N ;
  fokus_nn_1 : N ;
  folder_nn_1 : N ;
  foliant_nn_1 : N ;
  folie_nn_1 : N ;
  folioformat_nn_1 : N ;
  folk_nn_1 : N ;
  folkarme_nn_1 : N ;
  folkbaat_nn_1 : N ;
  folkbibliotek_nn_1 : N ;
  folkbokfoering_nn_1 : N ;
  folkdans_nn_1 : N ;
  folkdemokrati_nn_1 : N ;
  folkdemokratisk_av_1 : A ;
  folkdikt_nn_1 : N ;
  folkdiktning_nn_1 : N ;
  folkdjup_nn_1 : N ;
  folkdomstol_nn_1 : N ;
  folkdraekt_nn_1 : N ;
  folketymologi_nn_1 : N ;
  folketymologisk_av_1 : A ;
  folkfest_nn_1 : N ;
  folkfoersamling_nn_1 : N ;
  folkfront_nn_1 : N ;
  folkgrupp_nn_1 : N ;
  folkhem_nn_1 : N ;
  folkhemsk_av_1 : A ;
  folkhjaelte_nn_1 : N ;
  folkhop_nn_1 : N ;
  folkilsken_av_1 : A ;
  folkkaer_av_1 : A ;
  folkkommissarie_nn_1 : N ;
  folkkommun_nn_1 : N ;
  folkkongress_nn_1 : N ;
  folklager_nn_1 : N ;
  folkledare_nn_1 : N ;
  folklek_nn_1 : N ;
  folklig_av_1 : A ;
  folklighet_nn_1 : N ;
  folklivsforskare_nn_1 : N ;
  folklivsskildring_nn_1 : N ;
  folklorist_nn_1 : N ;
  folkloristisk_av_1 : A ;
  folklustspel_nn_1 : N ;
  folkmaal_nn_1 : N ;
  folkmaengd_nn_1 : N ;
  folkmelodi_nn_1 : N ;
  folkminne_nn_1 : N ;
  folkmord_nn_1 : N ;
  folknoeje_nn_1 : N ;
  folkoel_nn_1 : N ;
  folkomroestning_nn_1 : N ;
  folkpark_nn_1 : N ;
  folkpartist_nn_1 : N ;
  folkpension_nn_1 : N ;
  folkpensionaer_nn_1 : N ;
  folkraekning_nn_1 : N ;
  folkraettslig_av_1 : A ;
  folkrepresentation_nn_1 : N ;
  folkrepublik_nn_1 : N ;
  folkresning_nn_1 : N ;
  folkrik_av_1 : A ;
  folkroerelse_nn_1 : N ;
  folksaang_nn_1 : N ;
  folksaegen_nn_1 : N ;
  folksaga_nn_1 : N ;
  folksamling_nn_1 : N ;
  folkskollaerare_nn_1 : N ;
  folkskygg_av_1 : A ;
  folkslag_nn_1 : N ;
  folkstam_nn_1 : N ;
  folkstorm_nn_1 : N ;
  folkstyre_nn_1 : N ;
  folktaet_av_1 : A ;
  folktaethet_nn_1 : N ;
  folkting_nn_1 : N ;
  folktom_av_1 : A ;
  folktribun_nn_1 : N ;
  folkuniversitet_nn_1 : N ;
  folkvald_av_1 : A ;
  folkvandring_nn_1 : N ;
  folkvilja_nn_1 : N ;
  follikel_nn_1 : N ;
  follikelstimulerande_av_1 : A ;
  fon_nn_1 : N ;
  fond_nn_1 : N ;
  fondaktie_nn_1 : N ;
  fondboers_nn_1 : N ;
  fondemission_nn_1 : N ;
  fondkommissionaer_nn_1 : N ;
  fondpapper_nn_1 : N ;
  fondstaempel_nn_1 : N ;
  fondue_nn_1 : N ;
  fonem_nn_1 : N ;
  fonematisk_av_1 : A ;
  fonetiker_nn_1 : N ;
  fonetisk_av_1 : A ;
  foniater_nn_1 : N ;
  foniatriker_nn_1 : N ;
  foniatrisk_av_1 : A ;
  fonograf_nn_1 : N ;
  fonogram_nn_1 : N ;
  fonologisk_av_1 : A ;
  fonotek_nn_1 : N ;
  fontaen_nn_1 : N ;
  fontanell_nn_1 : N ;
  forcerbar_av_1 : A ;
  forcering_nn_1 : N ;
  fordom_ab_1 : Adv ;
  fordon_nn_1 : N ;
  fordonsuppstaellning_nn_1 : N ;
  fordonsvikt_nn_1 : N ;
  fordran_nn_1 : N ;
  fordrande_av_1 : A ;
  fordring_nn_1 : N ;
  fordringsaegare_nn_1 : N ;
  fordringsfull_av_1 : A ;
  forell_nn_1 : N ;
  form_nn_1 : N ;
  form_nn_2 : N ;
  formaldehyd_nn_1 : N ;
  formalist_nn_1 : N ;
  formaliter_ab_1 : Adv ;
  formalitet_nn_1 : N ;
  formant_nn_1 : N ;
  format_nn_1 : N ;
  formation_nn_1 : N ;
  formbakelse_nn_1 : N ;
  formbar_av_1 : A ;
  formbildning_nn_1 : N ;
  formbildningsproblem_nn_1 : N ;
  formbroed_nn_1 : N ;
  formbunden_av_1 : A ;
  formel_nn_1 : N ;
  formelenhet_nn_1 : N ;
  formell_av_1 : A ;
  formering_nn_1 : N ;
  formfraaga_nn_1 : N ;
  formfranska_nn_1 : N ;
  formge_vb_1 : V ;
  formgivare_nn_1 : N ;
  formgivning_nn_1 : N ;
  formidabel_av_1 : A ;
  formlaera_nn_1 : N ;
  formlig_av_1 : A ;
  formligen_ab_1 : Adv ;
  formloes_av_1 : A ;
  formord_nn_1 : N ;
  formpressning_nn_1 : N ;
  formrik_av_1 : A ;
  formrikedom_nn_1 : N ;
  formsak_nn_1 : N ;
  formspel_nn_1 : N ;
  formspraak_nn_1 : N ;
  formulaer_nn_1 : N ;
  formulering_nn_1 : N ;
  forn_av_1 : A ;
  fornborg_nn_1 : N ;
  fornegyptisk_av_1 : A ;
  fornfolk_nn_1 : N ;
  fornfynd_nn_1 : N ;
  forngrekisk_av_1 : A ;
  fornislaendsk_av_1 : A ;
  fornitaliensk_av_1 : A ;
  fornkeltisk_av_1 : A ;
  fornlaemning_nn_1 : N ;
  fornminne_nn_1 : N ;
  fornnordisk_av_1 : A ;
  fornromersk_av_1 : A ;
  fornsvensk_av_1 : A ;
  forntid_nn_1 : N ;
  forntida_av_1 : A ;
  fors_nn_1 : N ;
  forshuvud_nn_1 : N ;
  forskarassistent_nn_1 : N ;
  forskare_nn_1 : N ;
  forskargrupp_nn_1 : N ;
  forskarkonspiration_nn_1 : N ;
  forskarlag_nn_1 : N ;
  forskarledighet_nn_1 : N ;
  forskning_nn_1 : N ;
  forskningsfaelt_nn_1 : N ;
  forskningsfartyg_nn_1 : N ;
  forskningsinstitut_nn_1 : N ;
  forskningskompetens_nn_1 : N ;
  forskningslaboratorium_nn_1 : N ;
  forskningsomraade_nn_1 : N ;
  forskningsorganisation_nn_1 : N ;
  forskningsprojekt_nn_1 : N ;
  forskningsraad_nn_1 : N ;
  forskningsresande_nn_1 : N ;
  forskningsresultat_nn_1 : N ;
  forskningsroen_nn_1 : N ;
  forskningsstation_nn_1 : N ;
  forsraenning_nn_1 : N ;
  fort_ab_1 : Adv ;
  fort_nn_1 : N ;
  fortbildning_nn_1 : N ;
  forte_ab_1 : Adv ;
  forte_nn_1 : N ;
  fortel_nn_1 : N ;
  fortepiano_nn_1 : N ;
  fortfaerdig_av_1 : A ;
  fortfarande_ab_1 : Adv ;
  fortgaaende_av_1 : A ;
  fortifikation_nn_1 : N ;
  fortifikationsfoervaltning_nn_1 : N ;
  fortifikationskaar_nn_1 : N ;
  fortis_av_1 : A ;
  fortissimo_ab_1 : Adv ;
  fortissimo_nn_1 : N ;
  fortkoerning_nn_1 : N ;
  fortkomst_nn_1 : N ;
  fortloepande_av_1 : A ;
  fortplantning_nn_1 : N ;
  fortplantningsdrift_nn_1 : N ;
  fortplantningsorgan_nn_1 : N ;
  fortsaettning_nn_1 : N ;
  fortsaettningsvis_ab_1 : Adv ;
  fortskaffningsmedel_nn_1 : N ;
  fortskrida_vb_1 : V ;
  fortskridande_nn_1 : N ;
  forum_nn_1 : N ;
  forumtidning_nn_1 : N ;
  forward_nn_1 : N ;
  fosfat_nn_1 : N ;
  fosforescent_av_1 : A ;
  fosforit_nn_1 : N ;
  fosforsyracell_nn_1 : N ;
  fossil_av_1 : A ;
  fossil_nn_1 : N ;
  fossilfri_av_1 : A ;
  fossilfynd_nn_1 : N ;
  fossilletare_nn_1 : N ;
  fossilminskning_nn_1 : N ;
  fossing_nn_1 : N ;
  fostbroedralag_nn_1 : N ;
  foster_nn_1 : N ;
  fosterbarn_nn_1 : N ;
  fosterfoeraelder_nn_1 : N ;
  fosterfoerdrivning_nn_1 : N ;
  fosterhem_nn_1 : N ;
  fosterhinna_nn_1 : N ;
  fosterlaege_nn_1 : N ;
  fosterlaendsk_av_1 : A ;
  fosterland_nn_1 : N ;
  fosterljud_nn_1 : N ;
  fosterutveckling_nn_1 : N ;
  fostervatten_nn_1 : N ;
  fostrare_nn_1 : N ;
  fot_nn_1 : N ;
  fot_nn_2 : N ;
  fotaenda_nn_1 : N ;
  fotbad_nn_1 : N ;
  fotbjudning_nn_1 : N ;
  fotblad_nn_1 : N ;
  fotboll_nn_1 : N ;
  fotbollsfoerbund_nn_1 : N ;
  fotbollskedja_nn_1 : N ;
  fotbollslag_nn_1 : N ;
  fotbollsmaal_nn_1 : N ;
  fotbollsmatch_nn_1 : N ;
  fotbollsplan_nn_1 : N ;
  fotbollsspelare_nn_1 : N ;
  fotbollstips_nn_1 : N ;
  fotbroms_nn_1 : N ;
  fotfel_nn_1 : N ;
  fotgaengare_nn_1 : N ;
  fotino_nn_1 : N ;
  fotknoel_nn_1 : N ;
  fotled_nn_1 : N ;
  fotnot_nn_1 : N ;
  foto_nn_1 : N ;
  fotoautomat_nn_1 : N ;
  fotoblixt_nn_1 : N ;
  fotocell_nn_1 : N ;
  fotoelektricitet_nn_1 : N ;
  fotoelektrisk_av_1 : A ;
  fotogenique_av_1 : A ;
  fotogenisk_av_1 : A ;
  fotogenkoek_nn_1 : N ;
  fotograf_nn_1 : N ;
  fotografering_nn_1 : N ;
  fotografi_nn_1 : N ;
  fotografiplaat_nn_1 : N ;
  fotografisk_av_1 : A ;
  fotogram_nn_1 : N ;
  fotogrammetrisk_av_1 : A ;
  fotogravyr_nn_1 : N ;
  fotokemisk_av_1 : A ;
  fotokopia_nn_1 : N ;
  fotokopiering_nn_1 : N ;
  fotometer_nn_1 : N ;
  fotomodell_nn_1 : N ;
  fotomontage_nn_1 : N ;
  foton_nn_1 : N ;
  fotoresistor_nn_1 : N ;
  fotosaettning_nn_1 : N ;
  fotostatkopia_nn_1 : N ;
  fotostatkopiering_nn_1 : N ;
  fotosyntes_nn_1 : N ;
  fotriktig_av_1 : A ;
  fotsack_nn_1 : N ;
  fotsid_av_1 : A ;
  fotspaar_nn_1 : N ;
  fotsteg_nn_1 : N ;
  fotstoed_nn_1 : N ;
  fotvaenlig_av_1 : A ;
  fotvalv_nn_1 : N ;
  fotvandring_nn_1 : N ;
  foul_nn_1 : N ;
  foxterrier_nn_1 : N ;
  foxtrot_nn_1 : N ;
  foyer_nn_1 : N ;
  fraaga_nn_1 : N ;
  fraageform_nn_1 : N ;
  fraageformulaer_nn_1 : N ;
  fraageord_nn_1 : N ;
  fraagesats_nn_1 : N ;
  fraagespalt_nn_1 : N ;
  fraagesport_nn_1 : N ;
  fraagestaellare_nn_1 : N ;
  fraagestaellning_nn_1 : N ;
  fraagestund_nn_1 : N ;
  fraagetaevling_nn_1 : N ;
  fraagetecken_nn_1 : N ;
  fraagvis_av_1 : A ;
  fraanlandsvind_nn_1 : N ;
  fraansida_nn_1 : N ;
  fraanskild_av_1 : A ;
  fraanskiljare_nn_1 : N ;
  fraanstoetande_av_1 : A ;
  fraanta_vb_1 : V ;
  fraanvarande_av_1 : A ;
  frack_nn_1 : N ;
  fradgig_av_1 : A ;
  fraeck_av_1 : A ;
  fraeckhet_nn_1 : N ;
  fraeckis_nn_1 : N ;
  fraeken_nn_1 : N ;
  fraekne_nn_1 : N ;
  fraeknig_av_1 : A ;
  fraelsare_nn_1 : N ;
  fraelsarkrans_nn_1 : N ;
  fraelse_av_1 : A ;
  fraelsebonde_nn_1 : N ;
  fraelsejord_nn_1 : N ;
  fraelsningsmoete_nn_1 : N ;
  fraelsningssoldat_nn_1 : N ;
  fraelst_av_1 : A ;
  fraemling_nn_1 : N ;
  fraemlingslegion_nn_1 : N ;
  fraemlingslegionaer_nn_1 : N ;
  fraemlingspass_nn_1 : N ;
  fraemmande_av_1 : A ;
  fraemmande_nn_1 : N ;
  fraemmat_av_1 : A ;
  fraemre_av_1 : A ;
  fraen_av_1 : A ;
  fraende_nn_1 : N ;
  fraendskap_nn_1 : N ;
  fraes_nn_1 : N ;
  fraesch_av_1 : A ;
  fraesig_av_1 : A ;
  fraesmaskin_nn_1 : N ;
  fragil_av_1 : A ;
  fragment_nn_1 : N ;
  fragmentarisk_av_1 : A ;
  frakt_nn_1 : N ;
  fraktal_av_1 : A ;
  fraktavtal_nn_1 : N ;
  fraktion_nn_1 : N ;
  fraktsats_nn_1 : N ;
  fraktsedel_nn_1 : N ;
  fraktur_nn_2 : N ;
  fram_ab_1 : Adv ;
  framaat_ab_1 : Adv ;
  framaenda_nn_1 : N ;
  framaxel_nn_1 : N ;
  frambaera_vb_1 : V ;
  framben_nn_1 : N ;
  frambesvaerja_vb_1 : V ;
  frambryta_vb_1 : V ;
  framdel_nn_1 : N ;
  framdeles_ab_1 : Adv ;
  framdriva_vb_1 : V ;
  framfaerd_nn_1 : N ;
  framfall_nn_1 : N ;
  framfara_vb_1 : V ;
  framfoer_ab_1 : Adv ;
  framfoerallt_ab_1 : Adv ;
  framfoerande_nn_1 : N ;
  framfoerhaallning_nn_1 : N ;
  framfoervarande_av_1 : A ;
  framfot_nn_1 : N ;
  framfusig_av_1 : A ;
  framgaa_vb_1 : V ;
  framgaang_nn_1 : N ;
  framgaangsrik_av_1 : A ;
  framgaffel_nn_1 : N ;
  framgent_ab_1 : Adv ;
  framhaalla_vb_1 : V ;
  framhjul_nn_1 : N ;
  framhjulsdriven_av_1 : A ;
  framifraan_ab_1 : Adv ;
  framkallare_nn_1 : N ;
  framkallning_nn_1 : N ;
  framkant_nn_1 : N ;
  framkoerning_nn_1 : N ;
  framkomlig_av_1 : A ;
  framkomlighet_nn_1 : N ;
  framkomma_vb_1 : V ;
  framladdare_nn_1 : N ;
  framladdning_nn_1 : N ;
  framlaenges_ab_1 : Adv ;
  framlida_vb_1 : V ;
  framliden_av_1 : A ;
  framlob_nn_1 : N ;
  frammarsch_nn_1 : N ;
  framme_ab_1 : Adv ;
  framoever_ab_1 : Adv ;
  frampaa_ab_1 : Adv ;
  framryckning_nn_1 : N ;
  framsaete_nn_1 : N ;
  framsida_nn_1 : N ;
  framskjuta_vb_1 : V ;
  framskjutande_av_1 : A ;
  framskjuten_av_1 : A ;
  framskrida_vb_1 : V ;
  framskriden_av_1 : A ;
  framspelare_nn_1 : N ;
  framspelning_nn_1 : N ;
  framstaaende_av_1 : A ;
  framstaellan_nn_1 : N ;
  framstaellning_nn_1 : N ;
  framstam_nn_1 : N ;
  framsteg_nn_1 : N ;
  framstegsparti_nn_1 : N ;
  framstegsvaenlig_av_1 : A ;
  framstoet_nn_1 : N ;
  framstupa_ab_1 : Adv ;
  framsynt_av_1 : A ;
  framtand_nn_1 : N ;
  framtid_nn_1 : N ;
  framtida_av_1 : A ;
  framtidsforskning_nn_1 : N ;
  framtidsloefte_nn_1 : N ;
  framtidsman_nn_1 : N ;
  framtidsversion_nn_1 : N ;
  framtidsvision_nn_1 : N ;
  framtidsvy_nn_1 : N ;
  framtill_ab_1 : Adv ;
  framtoning_nn_1 : N ;
  framtraedande_av_1 : A ;
  framtraedande_nn_1 : N ;
  framtraengande_av_1 : A ;
  framtung_av_1 : A ;
  framtvinga_vb_1 : V ;
  framvagn_nn_1 : N ;
  franc_nn_1 : N ;
  franciskan_nn_1 : N ;
  franciskanerkloster_nn_1 : N ;
  franciskanermunk_nn_1 : N ;
  franciskanerorden_nn_1 : N ;
  frank_av_1 : A ;
  frank_nn_1 : N ;
  franko_ab_1 : Adv ;
  frankostaempel_nn_1 : N ;
  frankotecken_nn_1 : N ;
  frans_nn_1 : N ;
  fransaes_nn_1 : N ;
  fransig_av_1 : A ;
  fransk_av_1 : A ;
  franska_nn_2 : N ;
  franskbroed_nn_1 : N ;
  franskklassisk_av_1 : A ;
  fransman_nn_1 : N ;
  fransos_nn_1 : N ;
  fransyska_nn_1 : N ;
  frappant_av_1 : A ;
  frapperande_av_1 : A ;
  fras_nn_1 : N ;
  fraseologisk_av_1 : A ;
  frasering_nn_1 : N ;
  frasig_av_1 : A ;
  frasliberal_av_1 : A ;
  frasliberal_nn_1 : N ;
  frasmakare_nn_1 : N ;
  frasradikal_av_1 : A ;
  frasradikal_nn_1 : N ;
  frasvaaffla_nn_1 : N ;
  freak_nn_1 : N ;
  fred_nn_1 : N ;
  fredag_nn_1 : N ;
  fredagsboers_nn_1 : N ;
  fredagskvaell_nn_1 : N ;
  fredagsmorgon_nn_1 : N ;
  fredlig_av_1 : A ;
  fredloes_av_1 : A ;
  fredsbevarande_av_1 : A ;
  fredsdomare_nn_1 : N ;
  fredsdomstol_nn_1 : N ;
  fredsfoerdrag_nn_1 : N ;
  fredsfoerhandling_nn_1 : N ;
  fredsforskning_nn_1 : N ;
  fredskaar_nn_1 : N ;
  fredskonferens_nn_1 : N ;
  fredsmaeklare_nn_1 : N ;
  fredspris_nn_1 : N ;
  fredsroerelse_nn_1 : N ;
  fredsslut_nn_1 : N ;
  fredsstraevande_nn_1 : N ;
  fredstid_nn_1 : N ;
  fredstida_av_1 : A ;
  free_style_nn_1 : N ;
  fregatt_nn_1 : N ;
  fregattfaagel_nn_1 : N ;
  frejdig_av_1 : A ;
  frekvens_nn_1 : N ;
  frekvensband_nn_1 : N ;
  frekvensmodulering_nn_1 : N ;
  frekvensomraade_nn_1 : N ;
  frekvent_av_1 : A ;
  frenetisk_av_1 : A ;
  frenologisk_av_1 : A ;
  freon_nn_1 : N ;
  fresk_nn_1 : N ;
  freskomaalning_nn_1 : N ;
  frestande_av_1 : A ;
  frestare_nn_1 : N ;
  frestelse_nn_1 : N ;
  fri_av_1 : A ;
  friaakning_nn_1 : N ;
  friare_nn_1 : N ;
  fribaerande_av_1 : A ;
  fribiljett_nn_1 : N ;
  fribladig_av_1 : A ;
  fribonde_nn_1 : N ;
  fribord_nn_1 : N ;
  friboren_av_1 : A ;
  fribrev_nn_1 : N ;
  fribrottare_nn_1 : N ;
  fribytare_nn_1 : N ;
  fribyteri_nn_1 : N ;
  fridag_nn_1 : N ;
  fridfull_av_1 : A ;
  fridlysning_nn_1 : N ;
  fridsam_av_1 : A ;
  frieri_nn_1 : N ;
  frifraesare_nn_1 : N ;
  frifraesig_av_1 : A ;
  frigaaende_av_1 : A ;
  frige_vb_1 : V ;
  friggebod_nn_1 : N ;
  frigiditet_nn_1 : N ;
  frigivning_nn_1 : N ;
  frigjord_av_1 : A ;
  frigjordhet_nn_1 : N ;
  frihamn_nn_1 : N ;
  frihandelsomraade_nn_1 : N ;
  frihandsteckning_nn_1 : N ;
  friherre_nn_1 : N ;
  frihet_nn_1 : N ;
  frihetlig_av_1 : A ;
  frihetsberoevande_nn_1 : N ;
  frihetsgrad_nn_1 : N ;
  frihetshjaelte_nn_1 : N ;
  frihetskamp_nn_1 : N ;
  frihetskrig_nn_1 : N ;
  frihetsstraff_nn_1 : N ;
  frihjul_nn_1 : N ;
  friholt_nn_1 : N ;
  friidrott_nn_1 : N ;
  frikaar_nn_1 : N ;
  frikadell_nn_1 : N ;
  frikaennande_nn_1 : N ;
  frikasse_nn_1 : N ;
  frikast_nn_1 : N ;
  frikativ_av_1 : A ;
  frikoep_nn_1 : N ;
  frikoppling_nn_1 : N ;
  frikort_nn_1 : N ;
  frikostig_av_1 : A ;
  frikrets_nn_1 : N ;
  friktion_nn_1 : N ;
  friktionsfri_av_1 : A ;
  friktionskoefficient_nn_1 : N ;
  friktionstal_nn_1 : N ;
  frikyrka_nn_1 : N ;
  frikyrklig_av_1 : A ;
  frikyrklighet_nn_1 : N ;
  friland_nn_1 : N ;
  frilans_nn_1 : N ;
  frilansare_nn_1 : N ;
  frilevande_av_1 : A ;
  friluftsaendamaal_nn_1 : N ;
  friluftsbad_nn_1 : N ;
  friluftsdag_nn_1 : N ;
  friluftsmiljoe_nn_1 : N ;
  friluftsmuseum_nn_1 : N ;
  friluftsomraade_nn_1 : N ;
  friluftsskog_nn_1 : N ;
  friluftsvana_nn_1 : N ;
  frimaerkssamling_nn_1 : N ;
  frimickel_nn_1 : N ;
  frimodig_av_1 : A ;
  frimurare_nn_1 : N ;
  frimurarloge_nn_1 : N ;
  frimurarorden_nn_1 : N ;
  fripassagerare_nn_1 : N ;
  friplaat_nn_1 : N ;
  frireligioes_av_1 : A ;
  fris_1_nn_1 : N ;
  fris_2_nn_1 : N ;
  frisbee_nn_1 : N ;
  frisedel_nn_1 : N ;
  frisersalong_nn_1 : N ;
  frisisk_av_1 : A ;
  frisiska_nn_2 : N ;
  frisk_av_1 : A ;
  friskhet_nn_1 : N ;
  friskintyg_nn_1 : N ;
  friskluftsintag_nn_1 : N ;
  friskriven_av_1 : A ;
  friskrivning_nn_1 : N ;
  friskskriva_vb_1 : V ;
  friskus_nn_1 : N ;
  frislag_nn_1 : N ;
  frisoer_nn_1 : N ;
  frisoerska_nn_1 : N ;
  frispark_nn_1 : N ;
  frispraakig_av_1 : A ;
  frist_nn_1 : N ;
  fristaaende_av_1 : A ;
  fristad_nn_1 : N ;
  fristat_nn_1 : N ;
  frisyr_nn_1 : N ;
  frisyrgele_nn_1 : N ;
  frita_vb_1 : V ;
  fritaenkare_nn_1 : N ;
  fritagning_nn_1 : N ;
  fritidsaktivitet_nn_1 : N ;
  fritidsbaat_nn_1 : N ;
  fritidsbebyggelse_nn_1 : N ;
  fritidsby_nn_1 : N ;
  fritidsfoervaltning_nn_1 : N ;
  fritidsgaard_nn_1 : N ;
  fritidshem_nn_1 : N ;
  fritidshus_nn_1 : N ;
  fritidsledare_nn_1 : N ;
  fritidslokal_nn_1 : N ;
  fritidsnaemnd_nn_1 : N ;
  fritidsomraade_nn_1 : N ;
  fritidspedagog_nn_1 : N ;
  fritidsproblem_nn_1 : N ;
  fritidsstuga_nn_1 : N ;
  fritidssysselsaettning_nn_1 : N ;
  fritis_nn_1 : N ;
  frityr_nn_1 : N ;
  frivakt_nn_1 : N ;
  frivillig_av_1 : A ;
  frivillighet_nn_1 : N ;
  frivol_av_1 : A ;
  frivolitet_nn_1 : N ;
  frivolt_nn_1 : N ;
  frodig_av_1 : A ;
  froe_nn_1 : N ;
  froeaemne_nn_1 : N ;
  froehus_nn_1 : N ;
  froejd_nn_1 : N ;
  froejdefull_av_1 : A ;
  froeken_nn_1 : N ;
  froeodling_nn_1 : N ;
  froeplantage_nn_1 : N ;
  froeskal_nn_1 : N ;
  froetraed_nn_1 : N ;
  froevaext_nn_1 : N ;
  from_av_1 : A ;
  fromage_nn_1 : N ;
  fromhet_nn_1 : N ;
  fromsint_av_1 : A ;
  frondoer_nn_1 : N ;
  front_nn_1 : N ;
  frontal_av_1 : A ;
  frontalangrepp_nn_1 : N ;
  frontalkrock_nn_1 : N ;
  frontallob_nn_1 : N ;
  frontavsnitt_nn_1 : N ;
  frontbildning_nn_1 : N ;
  frontespis_nn_1 : N ;
  frontfoerbindelse_nn_1 : N ;
  frontlinje_nn_1 : N ;
  fronton_nn_1 : N ;
  frontsoldat_nn_1 : N ;
  frontzon_nn_1 : N ;
  frosch_nn_1 : N ;
  frossare_nn_1 : N ;
  frossbrytning_nn_1 : N ;
  frostbiten_av_1 : A ;
  frostfjaeril_nn_1 : N ;
  frostfri_av_1 : A ;
  frosthaerdig_av_1 : A ;
  frosthaerdighet_nn_1 : N ;
  frostig_av_1 : A ;
  frostkaenslig_av_1 : A ;
  frostkaenslighet_nn_1 : N ;
  frostnatt_nn_1 : N ;
  frostskyddsvaetska_nn_1 : N ;
  frostspraengning_nn_1 : N ;
  frosttaalig_av_1 : A ;
  frotte_nn_1 : N ;
  fru_nn_1 : N ;
  frugal_av_1 : A ;
  frukost_nn_1 : N ;
  frukostmiddag_nn_1 : N ;
  frukostrast_nn_1 : N ;
  frukt_nn_1 : N ;
  fruktaemne_nn_1 : N ;
  fruktaffaer_nn_1 : N ;
  fruktansvaerd_av_1 : A ;
  fruktbaerande_av_1 : A ;
  fruktbar_av_1 : A ;
  fruktbarhet_nn_1 : N ;
  fruktbarhetsgud_nn_1 : N ;
  fruktbringande_av_1 : A ;
  fruktig_av_1 : A ;
  fruktkniv_nn_1 : N ;
  fruktkompott_nn_1 : N ;
  fruktliknande_av_1 : A ;
  fruktloes_av_1 : A ;
  fruktodlare_nn_1 : N ;
  fruktodling_nn_1 : N ;
  fruktsallad_nn_1 : N ;
  fruktsam_av_1 : A ;
  fruktsporre_nn_1 : N ;
  frukttraed_nn_1 : N ;
  frukttraedgaard_nn_1 : N ;
  fruktvaegg_nn_1 : N ;
  fruntimmer_nn_1 : N ;
  fruntimmerskarl_nn_1 : N ;
  frusen_av_1 : A ;
  frustration_nn_1 : N ;
  fryntlig_av_1 : A ;
  frys_nn_1 : N ;
  frysbox_nn_1 : N ;
  frysdisk_nn_1 : N ;
  fryseri_nn_1 : N ;
  frysfack_nn_1 : N ;
  frysfoersoek_nn_1 : N ;
  fryspunkt_nn_1 : N ;
  fryst_av_1 : A ;
  frystaalig_av_1 : A ;
  frystest_nn_1 : N ;
  fuffens_nn_1 : N ;
  fuktig_av_1 : A ;
  fuktighet_nn_1 : N ;
  ful_av_1 : A ;
  fuling_nn_1 : N ;
  full_av_1 : A ;
  fullblod_nn_1 : N ;
  fullgaangen_av_1 : A ;
  fullgod_av_1 : A ;
  fullkomlig_av_1 : A ;
  fullkornsbroed_nn_1 : N ;
  fullmaane_nn_1 : N ;
  fullmaektig_nn_1 : N ;
  fullmakt_nn_1 : N ;
  fullmaktslag_nn_1 : N ;
  fullmogen_av_1 : A ;
  fulloedig_av_1 : A ;
  fullriggare_nn_1 : N ;
  fullsatt_av_1 : A ;
  fullstaemmig_av_1 : A ;
  fullstaendig_av_1 : A ;
  fullstaendighet_nn_1 : N ;
  fulltalig_av_1 : A ;
  fulltonig_av_1 : A ;
  fulltraeff_nn_1 : N ;
  fullvaerdesfoersaekring_nn_1 : N ;
  fullvaerdig_av_1 : A ;
  fullvuxen_av_1 : A ;
  fulsnygg_av_1 : A ;
  fumlig_av_1 : A ;
  fundament_nn_1 : N ;
  fundamental_av_1 : A ;
  fundamentalist_nn_1 : N ;
  funderare_nn_1 : N ;
  fundering_nn_1 : N ;
  fundersam_av_1 : A ;
  funktion_nn_1 : N ;
  funktionaer_nn_1 : N ;
  funktionalist_nn_1 : N ;
  funktionalistisk_av_1 : A ;
  funktionell_av_1 : A ;
  funktionsduglig_av_1 : A ;
  funktionsvaerde_nn_1 : N ;
  furie_nn_1 : N ;
  furioso_ab_1 : Adv ;
  furioso_nn_1 : N ;
  furir_nn_1 : N ;
  furnissoer_nn_1 : N ;
  furstbiskop_nn_1 : N ;
  furste_nn_1 : N ;
  fursteaett_nn_1 : N ;
  furstlig_av_1 : A ;
  furunkel_nn_1 : N ;
  fusion_nn_1 : N ;
  fusklapp_nn_1 : N ;
  fuskverk_nn_1 : N ;
  futhark_nn_1 : N ;
  futil_av_1 : A ;
  futilitet_nn_1 : N ;
  futt_nn_1 : N ;
  futtig_av_1 : A ;
  futural_av_1 : A ;
  futurist_nn_1 : N ;
  futuristisk_av_1 : A ;
  futurolog_nn_1 : N ;
  futurologisk_av_1 : A ;
  futurum_nn_1 : N ;
  fux_nn_1 : N ;
  fylking_nn_1 : N ;
  fyllbult_nn_1 : N ;
  fylld_av_1 : A ;
  fyllerist_nn_1 : N ;
  fyllig_av_1 : A ;
  fyllnad_nn_1 : N ;
  fyllnadstjaenstgoering_nn_1 : N ;
  fyllnadsval_nn_1 : N ;
  fyllning_nn_1 : N ;
  fyllo_nn_1 : N ;
  fylogenetisk_av_1 : A ;
  fynd_nn_1 : N ;
  fyndig_av_1 : A ;
  fyndighet_nn_1 : N ;
  fyndort_nn_1 : N ;
  fyndplats_nn_1 : N ;
  fyndpris_nn_1 : N ;
  fyr_nn_1 : N ;
  fyraaarig_av_1 : A ;
  fyrbaak_nn_1 : N ;
  fyrbackslinje_nn_1 : N ;
  fyrbent_av_1 : A ;
  fyrcylindrig_av_1 : A ;
  fyrdubbel_av_1 : A ;
  fyrfaergstryck_nn_1 : N ;
  fyrfaldig_av_1 : A ;
  fyrfalt_ab_1 : Adv ;
  fyrfota_av_1 : A ;
  fyrfotadjur_nn_1 : N ;
  fyrfoting_nn_1 : N ;
  fyrhaendig_av_1 : A ;
  fyrhandssaettning_nn_1 : N ;
  fyrhoerning_nn_1 : N ;
  fyrk_nn_1 : N ;
  fyrkant_nn_1 : N ;
  fyrkantig_av_1 : A ;
  fyrkaraktaer_nn_1 : N ;
  fyrling_nn_1 : N ;
  fyrljus_nn_1 : N ;
  fyrmaenning_nn_1 : N ;
  fyrmotorig_av_1 : A ;
  fyrop_nn_1 : N ;
  fyrsiding_nn_1 : N ;
  fyrsiffrig_av_1 : A ;
  fyrsitsig_av_1 : A ;
  fyrskepp_nn_1 : N ;
  fyrspann_nn_1 : N ;
  fyrtaktare_nn_1 : N ;
  fyrtaktsmotor_nn_1 : N ;
  fyrtal_nn_1 : N ;
  fyrtiotalist_nn_1 : N ;
  fyrtiotimmarsvecka_nn_1 : N ;
  fyrtitalism_nn_1 : N ;
  fyrtitalist_nn_1 : N ;
  fyrtorn_nn_1 : N ;
  fyrvaeldig_av_1 : A ;
  fyrvaeppling_nn_1 : N ;
  fyrvaktare_nn_1 : N ;
  fyrverkare_nn_1 : N ;
  fyrverkeri_nn_1 : N ;
  fyrverkeripjaes_nn_1 : N ;
  fysikalisk_av_1 : A ;
  fysiker_nn_1 : N ;
  fysikforskare_nn_1 : N ;
  fysikforskning_nn_1 : N ;
  fysikvetenskap_nn_1 : N ;
  fysiokrat_nn_1 : N ;
  fysiokratisk_av_1 : A ;
  fysiolog_nn_1 : N ;
  fysiologisk_av_1 : A ;
  fysionomi_nn_1 : N ;
  fysisk_av_1 : A ;
  fytotron_nn_1 : N ;
  g_draekt_nn_1 : N ;
  g_klav_nn_1 : N ;
  gaa_vb_1 : V ;
  gaabock_nn_1 : N ;
  gaagosse_nn_1 : N ;
  gaang_nn_1 : N ;
  gaang_nn_2 : N ;
  gaangare_nn_1 : N ;
  gaangart_nn_1 : N ;
  gaangavstaand_nn_1 : N ;
  gaangbar_av_1 : A ;
  gaangbergart_nn_1 : N ;
  gaangbord_nn_1 : N ;
  gaangbro_nn_1 : N ;
  gaangfot_nn_1 : N ;
  gaanggrift_nn_1 : N ;
  gaangjaern_nn_1 : N ;
  gaanglaat_nn_1 : N ;
  gaangled_nn_1 : N ;
  gaangspel_nn_1 : N ;
  gaangstol_nn_1 : N ;
  gaangvaeg_nn_1 : N ;
  gaapaaare_nn_1 : N ;
  gaapaaig_av_1 : A ;
  gaard_nn_1 : N ;
  gaardag_nn_1 : N ;
  gaardfarihandlande_nn_1 : N ;
  gaardfarihandlare_nn_1 : N ;
  gaarding_nn_1 : N ;
  gaardshus_nn_1 : N ;
  gaardskarl_nn_1 : N ;
  gaardskulle_nn_1 : N ;
  gaardsmusikant_nn_1 : N ;
  gaardsomraade_nn_1 : N ;
  gaardsplan_nn_1 : N ;
  gaardsplats_nn_1 : N ;
  gaardsrum_nn_1 : N ;
  gaardvar_nn_1 : N ;
  gaas_nn_1 : N ;
  gaasbroest_nn_1 : N ;
  gaase_nn_1 : N ;
  gaasfjaeder_nn_1 : N ;
  gaasfot_nn_1 : N ;
  gaaskarl_nn_1 : N ;
  gaastol_nn_1 : N ;
  gaasunge_nn_1 : N ;
  gaat_nn_1 : N ;
  gaatfull_av_1 : A ;
  gaava_nn_1 : N ;
  gaavoavtal_nn_1 : N ;
  gaavobrev_nn_1 : N ;
  gaavohandling_nn_1 : N ;
  gabon_nn_2 : N ;
  gabondoerr_nn_1 : N ;
  gabones_nn_1 : N ;
  gabonhuggorm_nn_1 : N ;
  gadd_nn_1 : N ;
  gaddloes_av_1 : A ;
  gaddstekel_nn_1 : N ;
  gaeck_ab_1 : Adv ;
  gaeckeri_nn_1 : N ;
  gaeckmast_nn_1 : N ;
  gaecksam_av_1 : A ;
  gaeddsax_nn_1 : N ;
  gael_nn_1 : N ;
  gael_nn_2 : N ;
  gaelbaage_nn_1 : N ;
  gaelbgjutare_nn_1 : N ;
  gaelbgjuteri_nn_1 : N ;
  gaelblad_nn_1 : N ;
  gaelda_vb_1 : V ;
  gaeldbunden_av_1 : A ;
  gaeldenaer_nn_1 : N ;
  gaeldstuga_nn_1 : N ;
  gaelisk_av_1 : A ;
  gaeliska_nn_2 : N ;
  gaell_av_1 : A ;
  gaellen_av_1 : A ;
  gaems_nn_1 : N ;
  gaeng_nn_1 : N ;
  gaengback_nn_1 : N ;
  gaenglig_av_1 : A ;
  gaengning_nn_1 : N ;
  gaengse_av_1 : A ;
  gaengstaal_nn_1 : N ;
  gaengtapp_nn_1 : N ;
  gaengtolk_nn_1 : N ;
  gaerd_nn_1 : N ;
  gaerde_nn_1 : N ;
  gaerdesgaard_nn_1 : N ;
  gaerdning_nn_1 : N ;
  gaerdsel_nn_1 : N ;
  gaerdsgaard_nn_1 : N ;
  gaerdsgaardsstoer_nn_1 : N ;
  gaerdsmyg_nn_1 : N ;
  gaerna_ab_1 : Adv ;
  gaerning_nn_1 : N ;
  gaerningsman_nn_1 : N ;
  gaerningsort_nn_1 : N ;
  gaers_nn_1 : N ;
  gaesp_nn_1 : N ;
  gaespig_av_1 : A ;
  gaespning_nn_1 : N ;
  gaessling_nn_1 : N ;
  gaest_nn_1 : N ;
  gaestabud_nn_1 : N ;
  gaestarbetare_nn_1 : N ;
  gaestbok_nn_1 : N ;
  gaestfri_av_1 : A ;
  gaestgivare_nn_1 : N ;
  gaestgivargaard_nn_1 : N ;
  gaestgiveri_nn_1 : N ;
  gaesthandduk_nn_1 : N ;
  gaestnatt_nn_1 : N ;
  gaestning_nn_1 : N ;
  gaestrike_nn_1 : N ;
  gaestriking_nn_1 : N ;
  gaestriklaendska_nn_1 : N ;
  gaestriklaenning_nn_1 : N ;
  gaestring_nn_1 : N ;
  gaestrisk_av_1 : A ;
  gaestrum_nn_1 : N ;
  gaestspel_nn_1 : N ;
  gaestvaenlig_av_1 : A ;
  gaff_nn_1 : N ;
  gaffel_nn_1 : N ;
  gaffelantilop_nn_1 : N ;
  gaffelbit_nn_1 : N ;
  gaffelbock_nn_1 : N ;
  gaffelhjort_nn_1 : N ;
  gaffelklo_nn_1 : N ;
  gaffelrigg_nn_1 : N ;
  gaffelsegel_nn_1 : N ;
  gaffeltruck_nn_1 : N ;
  gafflan_ab_1 : Adv ;
  gag_nn_1 : N ;
  gagat_nn_1 : N ;
  gagatsvart_av_1 : A ;
  gage_nn_1 : N ;
  gaggig_av_1 : A ;
  gagnelig_av_1 : A ;
  gagnerik_av_1 : A ;
  gagnloes_av_1 : A ;
  gagnrik_av_1 : A ;
  gagnvaext_nn_1 : N ;
  gaillarde_nn_1 : N ;
  gaj_nn_1 : N ;
  galaer_nn_1 : N ;
  galaerslav_nn_1 : N ;
  galaktisk_av_1 : A ;
  galant_ab_1 : Adv ;
  galant_av_1 : A ;
  galanteri_nn_1 : N ;
  galat_nn_1 : N ;
  galavagn_nn_1 : N ;
  galax_nn_1 : N ;
  galaxbildning_nn_1 : N ;
  galaxcentrum_nn_1 : N ;
  galaxhop_nn_1 : N ;
  galaxspektrum_nn_1 : N ;
  galaxvaerld_nn_1 : N ;
  galder_nn_1 : N ;
  galeas_nn_1 : N ;
  galen_av_1 : A ;
  galenskap_nn_1 : N ;
  galgbacke_nn_1 : N ;
  galge_nn_1 : N ;
  galgfaagel_nn_1 : N ;
  galicisk_av_1 : A ;
  galile_nn_1 : N ;
  galjon_nn_1 : N ;
  galjonsbild_nn_1 : N ;
  galjonsfigur_nn_1 : N ;
  gall_av_1 : A ;
  gall_nn_1 : N ;
  gallbildning_nn_1 : N ;
  galldrivande_av_1 : A ;
  galler_nn_1 : N ;
  galler_nn_2 : N ;
  galleri_nn_1 : N ;
  galleriskog_nn_1 : N ;
  gallerist_nn_1 : N ;
  gallerverk_nn_1 : N ;
  gallgaang_nn_1 : N ;
  gallicism_nn_1 : N ;
  gallier_nn_1 : N ;
  gallion_nn_1 : N ;
  gallisk_av_1 : A ;
  gallko_nn_1 : N ;
  gallkvalster_nn_1 : N ;
  gallon_nn_1 : N ;
  gallring_nn_1 : N ;
  gallsjuk_av_1 : A ;
  gallskrik_nn_1 : N ;
  gallspraengd_av_1 : A ;
  gallstekel_nn_1 : N ;
  gallsten_nn_1 : N ;
  galltjut_nn_1 : N ;
  gallup_nn_1 : N ;
  galning_nn_1 : N ;
  galon_nn_2 : N ;
  galopp_nn_1 : N ;
  galoppad_nn_1 : N ;
  galopptaevling_nn_1 : N ;
  galosch_nn_1 : N ;
  galt_nn_1 : N ;
  galvanisk_av_1 : A ;
  galvanometer_nn_1 : N ;
  galvanoskop_nn_1 : N ;
  galvanotyp_nn_1 : N ;
  gam_nn_1 : N ;
  gamaeng_nn_1 : N ;
  gamasch_nn_1 : N ;
  gambier_nn_1 : N ;
  gambisk_av_1 : A ;
  gambit_nn_1 : N ;
  game_nn_1 : N ;
  gamet_nn_1 : N ;
  gamling_nn_1 : N ;
  gamma_nn_1 : N ;
  gammafly_nn_1 : N ;
  gammaglobulin_nn_1 : N ;
  gammakamera_nn_1 : N ;
  gammal_av_1 : A ;
  gammaldags_av_1 : A ;
  gammaldans_nn_1 : N ;
  gammalkommunist_nn_1 : N ;
  gammalkristen_av_1 : A ;
  gammalkyrklig_av_1 : A ;
  gammalmodig_av_1 : A ;
  gammalrosa_av_1 : A ;
  gammaltestamentlig_av_1 : A ;
  gammalvals_nn_1 : N ;
  gammastraale_nn_1 : N ;
  gammeldans_nn_1 : N ;
  gan_nn_1 : N ;
  ganasch_nn_1 : N ;
  ganglie_nn_1 : N ;
  gangrenoes_av_1 : A ;
  gangster_nn_1 : N ;
  gans_nn_1 : N ;
  ganska_ab_1 : Adv ;
  ganymed_nn_1 : N ;
  gap_nn_1 : N ;
  gaphals_nn_1 : N ;
  gapig_av_1 : A ;
  gapsax_nn_1 : N ;
  gapskratt_nn_1 : N ;
  gapstock_nn_1 : N ;
  garage_nn_1 : N ;
  garant_nn_1 : N ;
  garanti_nn_1 : N ;
  garantifoerdrag_nn_1 : N ;
  garantifoersaekring_nn_1 : N ;
  garantifond_nn_1 : N ;
  garantilaan_nn_1 : N ;
  gard_nn_1 : N ;
  garde_nn_1 : N ;
  gardering_nn_1 : N ;
  garderob_nn_1 : N ;
  garderobiaer_nn_1 : N ;
  garderobie_nn_1 : N ;
  gardian_nn_1 : N ;
  gardin_nn_1 : N ;
  gardinband_nn_1 : N ;
  gardinluft_nn_1 : N ;
  gardinring_nn_1 : N ;
  gardinstaang_nn_1 : N ;
  gardist_nn_1 : N ;
  gardjaern_nn_1 : N ;
  garfaagel_nn_1 : N ;
  garn_nn_1 : N ;
  garnbom_nn_1 : N ;
  garnering_nn_1 : N ;
  garnhank_nn_1 : N ;
  garnison_nn_1 : N ;
  garnityr_nn_1 : N ;
  garnspole_nn_1 : N ;
  garsong_nn_1 : N ;
  gartner_nn_1 : N ;
  garv_nn_1 : N ;
  garvaemne_nn_1 : N ;
  garvare_nn_1 : N ;
  garveri_nn_1 : N ;
  garvmedel_nn_1 : N ;
  garvning_nn_1 : N ;
  garson_nn_1 : N ;
  gas_nn_1 : N ;
  gas_nn_2 : N ;
  gasackumulator_nn_1 : N ;
  gasblandning_nn_1 : N ;
  gasbraennare_nn_1 : N ;
  gasbubbla_nn_1 : N ;
  gascognare_nn_1 : N ;
  gasell_nn_1 : N ;
  gaseruption_nn_1 : N ;
  gasett_nn_1 : N ;
  gasformig_av_1 : A ;
  gasgenerator_nn_1 : N ;
  gask_nn_1 : N ;
  gaskammare_nn_1 : N ;
  gasklot_nn_1 : N ;
  gaskromatograf_nn_1 : N ;
  gaskropp_nn_1 : N ;
  gaslaeckage_nn_1 : N ;
  gaslaera_nn_1 : N ;
  gasmask_nn_1 : N ;
  gasmoln_nn_1 : N ;
  gasolkoek_nn_1 : N ;
  gasoltub_nn_1 : N ;
  gasometer_nn_1 : N ;
  gaspedal_nn_1 : N ;
  gassig_av_1 : A ;
  gasskydd_nn_1 : N ;
  gasspis_nn_1 : N ;
  gasstroem_nn_1 : N ;
  gast_nn_1 : N ;
  gastrisk_av_1 : A ;
  gastrit_nn_1 : N ;
  gastronom_nn_1 : N ;
  gastronomisk_av_1 : A ;
  gastroskop_nn_1 : N ;
  gastroskopi_nn_1 : N ;
  gastryck_nn_1 : N ;
  gasturbin_nn_1 : N ;
  gasurladdning_nn_1 : N ;
  gasventil_nn_1 : N ;
  gasverk_nn_1 : N ;
  gata_nn_1 : N ;
  gathoern_nn_1 : N ;
  gathus_nn_1 : N ;
  gatlaeggning_nn_1 : N ;
  gatlopp_nn_1 : N ;
  gatpojke_nn_1 : N ;
  gatsopare_nn_1 : N ;
  gatsten_nn_1 : N ;
  gatt_nn_1 : N ;
  gatubelaeggning_nn_1 : N ;
  gatubelysning_nn_1 : N ;
  gatufoersaeljare_nn_1 : N ;
  gatukoek_nn_1 : N ;
  gatukors_nn_1 : N ;
  gatukorsning_nn_1 : N ;
  gatuliv_nn_1 : N ;
  gatunamn_nn_1 : N ;
  gatunge_nn_1 : N ;
  gatuplan_nn_1 : N ;
  gaucho_nn_1 : N ;
  gauge_nn_1 : N ;
  gaullist_nn_1 : N ;
  gaullistisk_av_1 : A ;
  gaur_nn_1 : N ;
  gauss_nn_1 : N ;
  gavel_nn_1 : N ;
  gavelfaelt_nn_1 : N ;
  gavelhus_nn_1 : N ;
  gavelroeste_nn_1 : N ;
  gavial_nn_1 : N ;
  gavott_nn_1 : N ;
  gay_av_1 : A ;
  gayal_nn_1 : N ;
  ge_vb_1 : V ;
  gebit_nn_1 : N ;
  gecko_nn_1 : N ;
  gedigen_av_1 : A ;
  geg_nn_1 : N ;
  geggig_av_1 : A ;
  gehaeng_nn_1 : N ;
  geheimeraad_nn_1 : N ;
  geiger_mullerroer_nn_1 : N ;
  geigermaetare_nn_1 : N ;
  gejd_nn_1 : N ;
  gejser_nn_1 : N ;
  gel_nn_1 : N ;
  gelaenk_nn_1 : N ;
  gelatinkapsel_nn_1 : N ;
  gelatinoes_av_1 : A ;
  gelbgjutare_nn_1 : N ;
  gelbgjuteri_nn_1 : N ;
  gele_nn_1 : N ;
  gelehallon_nn_1 : N ;
  geleig_av_1 : A ;
  geleklump_nn_1 : N ;
  gelesvamp_nn_1 : N ;
  gelike_nn_1 : N ;
  gem_nn_1 : N ;
  gem_nn_2 : N ;
  gemaal_nn_1 : N ;
  gemak_nn_1 : N ;
  gemen_av_1 : A ;
  gemenhet_nn_1 : N ;
  gemenligen_ab_1 : Adv ;
  gemensam_av_1 : A ;
  gemensamhet_nn_1 : N ;
  gemensamhetsgrav_nn_1 : N ;
  gemination_nn_1 : N ;
  geminering_nn_1 : N ;
  gems_nn_1 : N ;
  gemyt_nn_1 : N ;
  gemytlig_av_1 : A ;
  gen_av_1 : A ;
  gen_nn_1 : N ;
  genant_av_1 : A ;
  genast_ab_1 : Adv ;
  gendarm_nn_1 : N ;
  gendriva_vb_1 : V ;
  genealog_nn_1 : N ;
  genealogi_nn_1 : N ;
  general_nn_1 : N ;
  generalagent_nn_1 : N ;
  generaldirektoer_nn_1 : N ;
  generalfoersamling_nn_1 : N ;
  generalguvernoer_nn_1 : N ;
  generalisation_nn_1 : N ;
  generalisering_nn_1 : N ;
  generalist_nn_1 : N ;
  generalitet_nn_2 : N ;
  generalkonsul_nn_1 : N ;
  generalkonsulat_nn_1 : N ;
  generalloejtnant_nn_1 : N ;
  generalmajor_nn_1 : N ;
  generaloeverste_nn_1 : N ;
  generalpaus_nn_1 : N ;
  generalplan_nn_1 : N ;
  generalrep_nn_1 : N ;
  generalrepetition_nn_1 : N ;
  generalsekreterare_nn_1 : N ;
  generalsperson_nn_1 : N ;
  generalstab_nn_1 : N ;
  generalstrejk_nn_1 : N ;
  generande_av_1 : A ;
  generation_nn_1 : N ;
  generationstid_nn_1 : N ;
  generationsvaexling_nn_1 : N ;
  generativ_av_1 : A ;
  generator_nn_1 : N ;
  generatris_nn_1 : N ;
  generell_av_1 : A ;
  generisk_av_1 : A ;
  generoes_av_1 : A ;
  generositet_nn_1 : N ;
  genetiker_nn_1 : N ;
  genetisk_av_1 : A ;
  genett_nn_1 : N ;
  genfordran_nn_1 : N ;
  genfordring_nn_1 : N ;
  gengaangare_nn_1 : N ;
  geni_nn_1 : N ;
  genial_av_1 : A ;
  genialisk_av_1 : A ;
  genialitet_nn_1 : N ;
  genie_nn_1 : N ;
  genitiv_nn_1 : N ;
  genitivattribut_nn_1 : N ;
  genkaerande_nn_1 : N ;
  genmaele_nn_1 : N ;
  genmanipulation_nn_1 : N ;
  genom_ab_1 : Adv ;
  genom_nn_1 : N ;
  genombloedning_nn_1 : N ;
  genombloet_av_1 : A ;
  genombrott_nn_1 : N ;
  genombruten_av_1 : A ;
  genombryta_vb_1 : V ;
  genomdriva_vb_1 : V ;
  genomfara_vb_1 : V ;
  genomfart_nn_1 : N ;
  genomfartsled_nn_1 : N ;
  genomfoerande_nn_1 : N ;
  genomfoerbar_av_1 : A ;
  genomfoering_nn_1 : N ;
  genomfoerkyld_av_1 : A ;
  genomgaa_vb_1 : V ;
  genomgaaende_ab_1 : Adv ;
  genomgaaende_av_1 : A ;
  genomgaang_nn_1 : N ;
  genomgripande_av_1 : A ;
  genomklappning_nn_1 : N ;
  genomkoerare_nn_1 : N ;
  genomlida_vb_1 : V ;
  genomlysande_av_1 : A ;
  genomlysning_nn_1 : N ;
  genommoenstring_nn_1 : N ;
  genomsippring_nn_1 : N ;
  genomskinlig_av_1 : A ;
  genomslaepplig_av_1 : A ;
  genomslaepplighet_nn_1 : N ;
  genomslag_nn_1 : N ;
  genomslagskopia_nn_1 : N ;
  genomslagspapper_nn_1 : N ;
  genomsnitt_nn_1 : N ;
  genomsnittlig_av_1 : A ;
  genomsnittsinkomst_nn_1 : N ;
  genomsnittsskatt_nn_1 : N ;
  genomsnittsvaerde_nn_1 : N ;
  genomtaenkt_av_1 : A ;
  genomtraengande_av_1 : A ;
  genomtraenglig_av_1 : A ;
  genomtraengning_nn_1 : N ;
  genomtryckt_av_1 : A ;
  genomvaat_av_1 : A ;
  genomvaevd_av_1 : A ;
  genotyp_nn_1 : N ;
  genre_nn_1 : N ;
  genrep_nn_1 : N ;
  gensaegelse_nn_1 : N ;
  gensaga_nn_1 : N ;
  gensare_nn_1 : N ;
  genskjuta_vb_1 : V ;
  genstaemning_nn_1 : N ;
  genstoertig_av_1 : A ;
  genstraevig_av_1 : A ;
  genstridig_av_1 : A ;
  genta_vb_1 : V ;
  gentil_av_1 : A ;
  gentjaenst_nn_1 : N ;
  gentleman_nn_1 : N ;
  genuafock_nn_1 : N ;
  genuin_av_1 : A ;
  genus_nn_1 : N ;
  genvaeg_nn_1 : N ;
  geocentrisk_av_1 : A ;
  geodet_nn_1 : N ;
  geodetisk_av_1 : A ;
  geodimeter_nn_1 : N ;
  geograf_nn_1 : N ;
  geografisk_av_1 : A ;
  geokemisk_av_1 : A ;
  geokronologisk_av_1 : A ;
  geolog_nn_1 : N ;
  geologisk_av_1 : A ;
  geometri_nn_1 : N ;
  geometriker_nn_1 : N ;
  geometrisk_av_1 : A ;
  geomorfologisk_av_1 : A ;
  georgier_nn_1 : N ;
  georgisk_av_1 : A ;
  georgiska_nn_2 : N ;
  georgskors_nn_1 : N ;
  geostationaer_av_1 : A ;
  geosynklinal_nn_1 : N ;
  geotermisk_av_1 : A ;
  geovetare_nn_1 : N ;
  geovetenskap_nn_1 : N ;
  geovetenskaplig_av_1 : A ;
  gepard_nn_1 : N ;
  geranium_nn_1 : N ;
  geriatrisk_av_1 : A ;
  geridon_nn_1 : N ;
  geridong_nn_1 : N ;
  gerilla_nn_1 : N ;
  gerillaledare_nn_1 : N ;
  gering_nn_1 : N ;
  german_nn_1 : N ;
  germanfolk_nn_1 : N ;
  germanism_nn_1 : N ;
  germanist_nn_1 : N ;
  germanistisk_av_1 : A ;
  germankrigare_nn_1 : N ;
  germansk_av_1 : A ;
  germanstam_nn_1 : N ;
  gerontologisk_av_1 : A ;
  gers_nn_1 : N ;
  gerundium_nn_1 : N ;
  gerundivum_nn_1 : N ;
  gesaell_nn_1 : N ;
  gesaellbrev_nn_1 : N ;
  gesaellprov_nn_1 : N ;
  gesaellvandring_nn_1 : N ;
  gesant_nn_1 : N ;
  geschaeft_nn_1 : N ;
  geschwint_ab_1 : Adv ;
  gesims_nn_1 : N ;
  gesimsbaage_nn_1 : N ;
  gesimslist_nn_1 : N ;
  gest_nn_1 : N ;
  gestalt_nn_1 : N ;
  gestaltning_nn_1 : N ;
  gestikulation_nn_1 : N ;
  get_nn_1 : N ;
  getabock_nn_1 : N ;
  getapel_nn_1 : N ;
  getfot_nn_1 : N ;
  geting_nn_1 : N ;
  getingbo_nn_1 : N ;
  getingmidja_nn_1 : N ;
  getingstick_nn_1 : N ;
  getmjoelksost_nn_1 : N ;
  getoega_nn_1 : N ;
  getost_nn_1 : N ;
  getskaegg_nn_1 : N ;
  getskinn_nn_1 : N ;
  getto_nn_1 : N ;
  getvaeppling_nn_1 : N ;
  gevaer_nn_1 : N ;
  gevaersfaktori_nn_1 : N ;
  gevaersgranat_nn_1 : N ;
  gevaerskolv_nn_1 : N ;
  gevaerskompani_nn_1 : N ;
  gevaerspatron_nn_1 : N ;
  gevaerspost_nn_1 : N ;
  gevaerssmed_nn_1 : N ;
  gevaerssmide_nn_1 : N ;
  gevaersstock_nn_1 : N ;
  gevaldiger_nn_1 : N ;
  ghanan_nn_1 : N ;
  ghanansk_av_1 : A ;
  ghanes_nn_1 : N ;
  ghanesisk_av_1 : A ;
  ghasel_nn_1 : N ;
  ghetto_nn_1 : N ;
  ghost_writer_nn_1 : N ;
  gibbon_nn_1 : N ;
  giffel_nn_1 : N ;
  gift_av_1 : A ;
  gift_nn_1 : N ;
  giftapparat_nn_1 : N ;
  giftasvuxen_av_1 : A ;
  giftavdunstning_nn_1 : N ;
  giftbaegare_nn_1 : N ;
  giftblandare_nn_1 : N ;
  giftbok_nn_1 : N ;
  giftermaal_nn_1 : N ;
  giftermaalsbalk_nn_1 : N ;
  giftfri_av_1 : A ;
  giftgas_nn_1 : N ;
  giftgroen_av_1 : A ;
  gifthalt_nn_1 : N ;
  giftig_av_1 : A ;
  giftighet_nn_1 : N ;
  giftkoertel_nn_1 : N ;
  giftmaengd_nn_1 : N ;
  giftmoln_nn_1 : N ;
  giftmord_nn_1 : N ;
  giftoman_nn_1 : N ;
  giftorm_nn_1 : N ;
  giftstadga_nn_1 : N ;
  gifttagg_nn_1 : N ;
  gifttand_nn_1 : N ;
  gifttransport_nn_1 : N ;
  giftverkan_nn_1 : N ;
  gig_nn_1 : N ;
  gigant_nn_1 : N ;
  gigantisk_av_1 : A ;
  gigaton_nn_1 : N ;
  gigawatt_nn_1 : N ;
  gigg_nn_1 : N ;
  gigolo_nn_1 : N ;
  gigue_nn_1 : N ;
  giktbruten_av_1 : A ;
  giktring_nn_1 : N ;
  giljare_nn_1 : N ;
  giljarfaerd_nn_1 : N ;
  giljotin_nn_1 : N ;
  gill_av_1 : A ;
  gillande_nn_1 : N ;
  giller_nn_1 : N ;
  gillesbroder_nn_1 : N ;
  gillessocialism_nn_1 : N ;
  gillestuga_nn_1 : N ;
  giltig_av_1 : A ;
  giltighet_nn_1 : N ;
  gimmick_nn_1 : N ;
  gin_av_1 : A ;
  ginbalk_nn_1 : N ;
  ginnungagap_nn_1 : N ;
  ginst_nn_1 : N ;
  ginstkatt_nn_1 : N ;
  ginvaeg_nn_1 : N ;
  gip_nn_1 : N ;
  gipp_nn_1 : N ;
  gips_nn_1 : N ;
  gipsavgjutning_nn_1 : N ;
  gipsfoerband_nn_1 : N ;
  gipsform_nn_1 : N ;
  gipyr_nn_1 : N ;
  gir_nn_1 : N ;
  giraff_nn_1 : N ;
  giraffliknande_av_1 : A ;
  girandole_nn_1 : N ;
  girering_nn_1 : N ;
  girig_av_1 : A ;
  girigbuk_nn_1 : N ;
  girland_nn_1 : N ;
  giro_nn_1 : N ;
  girobesked_nn_1 : N ;
  girvaext_av_1 : A ;
  girvuxen_av_1 : A ;
  gissel_nn_1 : N ;
  gisseldjur_nn_1 : N ;
  gisslare_nn_1 : N ;
  gissning_nn_1 : N ;
  gissningsvis_ab_1 : Adv ;
  gisten_av_1 : A ;
  gistgaard_nn_1 : N ;
  gitarr_nn_1 : N ;
  gitarrist_nn_1 : N ;
  gitter_nn_1 : N ;
  giv_nn_1 : N ;
  givakt_nn_1 : N ;
  givande_av_1 : A ;
  givare_nn_1 : N ;
  given_av_1 : A ;
  givetvis_ab_1 : Adv ;
  givkort_nn_1 : N ;
  givmild_av_1 : A ;
  givmildhet_nn_1 : N ;
  givning_nn_1 : N ;
  gjord_nn_1 : N ;
  gjuse_nn_1 : N ;
  gjuta_vb_1 : V ;
  gjutare_nn_1 : N ;
  gjutbar_av_1 : A ;
  gjuteri_nn_1 : N ;
  gjutform_nn_1 : N ;
  gjutmodell_nn_1 : N ;
  gjutning_nn_1 : N ;
  gjutrand_nn_1 : N ;
  glaamig_av_1 : A ;
  glaapord_nn_1 : N ;
  glacehandske_nn_1 : N ;
  glaci_nn_1 : N ;
  glaciaer_nn_1 : N ;
  glaciaeraelv_nn_1 : N ;
  glaciaerbrunn_nn_1 : N ;
  glaciaeris_nn_1 : N ;
  glaciaernisch_nn_1 : N ;
  glaciaerport_nn_1 : N ;
  glaciaerraeffla_nn_1 : N ;
  glacial_av_1 : A ;
  glacialperiod_nn_1 : N ;
  glacialraeffla_nn_1 : N ;
  glacifluvial_av_1 : A ;
  glaciolog_nn_1 : N ;
  glaciologisk_av_1 : A ;
  glad_av_1 : A ;
  glad_nn_1 : N ;
  gladelig_av_1 : A ;
  gladeligen_ab_1 : Adv ;
  gladeligt_ab_1 : Adv ;
  gladiator_nn_1 : N ;
  gladiatorspel_nn_1 : N ;
  gladiolus_nn_1 : N ;
  gladlig_av_1 : A ;
  gladligen_ab_1 : Adv ;
  gladlynt_av_1 : A ;
  glaedjande_av_1 : A ;
  glaedjeaemne_nn_1 : N ;
  glaedjebetygelse_nn_1 : N ;
  glaedjedoedare_nn_1 : N ;
  glaedjefylld_av_1 : A ;
  glaedjehus_nn_1 : N ;
  glaedjekalkyl_nn_1 : N ;
  glaedjekvarter_nn_1 : N ;
  glaedjerus_nn_1 : N ;
  glaedjestraalande_av_1 : A ;
  glaensande_av_1 : A ;
  glaettig_av_1 : A ;
  glaettighet_nn_1 : N ;
  glaettning_nn_1 : N ;
  glaettsten_nn_1 : N ;
  glagolitisk_av_1 : A ;
  glamoroes_av_1 : A ;
  glamouroes_av_1 : A ;
  glandel_nn_1 : N ;
  glanduloes_av_1 : A ;
  glansbagge_nn_1 : N ;
  glansfull_av_1 : A ;
  glansig_av_1 : A ;
  glansk_av_1 : A ;
  glansloes_av_1 : A ;
  glansnummer_nn_1 : N ;
  glanspapper_nn_1 : N ;
  glansperiod_nn_1 : N ;
  glansroll_nn_1 : N ;
  glanstid_nn_1 : N ;
  glapp_av_1 : A ;
  glapp_nn_1 : N ;
  glapprum_nn_1 : N ;
  glas_nn_1 : N ;
  glasaal_nn_1 : N ;
  glasbjoerk_nn_1 : N ;
  glasblaasare_nn_1 : N ;
  glasblaaseri_nn_1 : N ;
  glasbruk_nn_1 : N ;
  glasbult_nn_1 : N ;
  glasering_nn_1 : N ;
  glasfiber_nn_1 : N ;
  glasfoeremaal_nn_1 : N ;
  glasframstaellning_nn_1 : N ;
  glashal_av_1 : A ;
  glashandduk_nn_1 : N ;
  glashus_nn_1 : N ;
  glashuv_nn_1 : N ;
  glasig_av_1 : A ;
  glasighet_nn_1 : N ;
  glasiglo_nn_1 : N ;
  glasiologisk_av_1 : A ;
  glasklar_av_1 : A ;
  glaskolv_nn_1 : N ;
  glaskropp_nn_1 : N ;
  glasmaalning_nn_1 : N ;
  glasmaestardiamant_nn_1 : N ;
  glasmaestare_nn_1 : N ;
  glasmaesteri_nn_1 : N ;
  glasoega_nn_1 : N ;
  glasoegonbaage_nn_1 : N ;
  glasoegonbjoern_nn_1 : N ;
  glasoegonorm_nn_1 : N ;
  glasprisma_nn_1 : N ;
  glasroer_nn_1 : N ;
  glass_nn_1 : N ;
  glassbaegare_nn_1 : N ;
  glassbomb_nn_1 : N ;
  glassdessert_nn_1 : N ;
  glassig_av_1 : A ;
  glasskaerardiamant_nn_1 : N ;
  glasskaerare_nn_1 : N ;
  glasslipare_nn_1 : N ;
  glassmaskin_nn_1 : N ;
  glasspinne_nn_1 : N ;
  glasstrut_nn_1 : N ;
  glasvakt_nn_1 : N ;
  glasvar_nn_1 : N ;
  glasvingefjaeril_nn_1 : N ;
  glasyr_nn_1 : N ;
  glatt_av_1 : A ;
  glattmask_nn_1 : N ;
  glav_nn_1 : N ;
  gles_av_1 : A ;
  glesbygd_nn_1 : N ;
  gletscher_nn_1 : N ;
  gli_nn_1 : N ;
  glid_nn_1 : N ;
  glida_vb_1 : V ;
  glidkontakt_nn_1 : N ;
  glidkraem_nn_1 : N ;
  glidlager_nn_1 : N ;
  glidljud_nn_1 : N ;
  glidmedel_nn_1 : N ;
  glidning_nn_1 : N ;
  glidtackling_nn_1 : N ;
  glim_nn_1 : N ;
  glimt_nn_1 : N ;
  glimtaendare_nn_1 : N ;
  glimtvis_ab_1 : Adv ;
  glinder_nn_1 : N ;
  gliom_nn_1 : N ;
  gliring_nn_1 : N ;
  glis_nn_2 : N ;
  glisoert_nn_1 : N ;
  glissando_nn_1 : N ;
  glitterglad_av_1 : A ;
  glittrig_av_1 : A ;
  glob_nn_1 : N ;
  global_av_1 : A ;
  globetrotter_nn_1 : N ;
  globulin_nn_1 : N ;
  gloed_nn_1 : N ;
  gloedbaedd_nn_1 : N ;
  gloedhet_av_1 : A ;
  gloedhoeg_nn_1 : N ;
  gloedkatod_nn_1 : N ;
  gloedkropp_nn_1 : N ;
  gloedmjuk_av_1 : A ;
  gloedning_nn_1 : N ;
  gloedstroem_nn_1 : N ;
  gloedtraad_nn_1 : N ;
  gloedvarm_av_1 : A ;
  gloegg_nn_1 : N ;
  gloemsk_av_1 : A ;
  glop_nn_1 : N ;
  glorioes_av_1 : A ;
  glosig_av_1 : A ;
  glosoegd_av_1 : A ;
  glossar_nn_1 : N ;
  glossarium_nn_1 : N ;
  glossematik_nn_1 : N ;
  glossolali_nn_1 : N ;
  glottisstoet_nn_1 : N ;
  glugg_nn_1 : N ;
  glunt_nn_1 : N ;
  glupande_av_1 : A ;
  glupsk_av_1 : A ;
  glutamat_nn_1 : N ;
  glutenfri_av_1 : A ;
  glutinoes_av_1 : A ;
  glycerid_nn_1 : N ;
  glycin_nn_1 : N ;
  glykol_nn_1 : N ;
  glykopeptid_nn_1 : N ;
  glykos_nn_1 : N ;
  glyptotek_nn_1 : N ;
  glytt_nn_1 : N ;
  glyttig_av_1 : A ;
  gnabb_nn_1 : N ;
  gnaellig_av_1 : A ;
  gnaellmaans_nn_1 : N ;
  gnaellspik_nn_1 : N ;
  gnagare_nn_1 : N ;
  gnagtand_nn_1 : N ;
  gnatig_av_1 : A ;
  gnejs_nn_1 : N ;
  gnet_nn_1 : N ;
  gnet_nn_2 : N ;
  gnetig_av_1 : A ;
  gnida_vb_1 : V ;
  gnidare_nn_1 : N ;
  gniden_av_1 : A ;
  gnidig_av_1 : A ;
  gnidningselektricitet_nn_1 : N ;
  gnistfaangare_nn_1 : N ;
  gnistgaller_nn_1 : N ;
  gnistgap_nn_1 : N ;
  gnistinduktor_nn_1 : N ;
  gnistkammare_nn_1 : N ;
  gnistrig_av_1 : A ;
  gnistsaendare_nn_1 : N ;
  gnistskydd_nn_1 : N ;
  gniststation_nn_1 : N ;
  gnisttaendning_nn_1 : N ;
  gnoding_nn_1 : N ;
  gnom_nn_1 : N ;
  gnomiker_nn_1 : N ;
  gnostiker_nn_1 : N ;
  gnu_nn_1 : N ;
  gnuggbild_nn_1 : N ;
  go_cart_nn_1 : N ;
  gobelaeng_nn_1 : N ;
  gobelaengbroderi_nn_1 : N ;
  god_av_1 : A ;
  godbit_nn_1 : N ;
  goddagspilt_nn_1 : N ;
  gode_nn_1 : N ;
  godhaellig_av_1 : A ;
  godhet_nn_1 : N ;
  godhetsfull_av_1 : A ;
  godhjaertenhet_nn_1 : N ;
  goding_nn_1 : N ;
  godis_nn_2 : N ;
  godkaend_av_1 : A ;
  godkaennande_nn_1 : N ;
  godlynt_av_1 : A ;
  godmanskap_nn_1 : N ;
  godmodig_av_1 : A ;
  gods_nn_1 : N ;
  godsaegare_nn_1 : N ;
  godsak_nn_1 : N ;
  godsexpedition_nn_1 : N ;
  godsherre_nn_1 : N ;
  godsint_av_1 : A ;
  godsmottagning_nn_1 : N ;
  godstaag_nn_1 : N ;
  godsvagn_nn_1 : N ;
  godta_vb_1 : V ;
  godtagbar_av_1 : A ;
  godtemplare_nn_1 : N ;
  godtemplarorden_nn_1 : N ;
  godtrogen_av_1 : A ;
  godtrosfoervaerv_nn_1 : N ;
  godtycklig_av_1 : A ;
  godvikt_nn_1 : N ;
  godvillig_av_1 : A ;
  goeddjur_nn_1 : N ;
  goedkyckling_nn_1 : N ;
  goedning_nn_1 : N ;
  goedningsmedel_nn_1 : N ;
  goedselmedel_nn_1 : N ;
  goedselspridare_nn_1 : N ;
  goedselstack_nn_1 : N ;
  goedselstad_nn_1 : N ;
  goedsling_nn_1 : N ;
  goejemaanad_nn_1 : N ;
  goek_nn_1 : N ;
  goekblomster_nn_1 : N ;
  goekunge_nn_1 : N ;
  goekur_nn_1 : N ;
  goel_nn_1 : N ;
  goeling_nn_1 : N ;
  goemfroeig_av_1 : A ;
  goemstaelle_nn_1 : N ;
  goepen_nn_1 : N ;
  goerare_nn_1 : N ;
  goerdel_nn_1 : N ;
  goerdelbaage_nn_1 : N ;
  goerdeldaeck_nn_1 : N ;
  goerdelfaestning_nn_1 : N ;
  goerdelmakare_nn_1 : N ;
  goerlig_av_1 : A ;
  goeromaal_nn_1 : N ;
  goes_nn_1 : N ;
  goesstake_nn_1 : N ;
  goet_nn_1 : N ;
  goet_nn_2 : N ;
  goetamaal_nn_1 : N ;
  goete_nn_1 : N ;
  goeteborgare_nn_1 : N ;
  goeteborgsk_av_1 : A ;
  goeteborgska_nn_2 : N ;
  goeteborgsvits_nn_1 : N ;
  goeticistisk_av_1 : A ;
  goetisk_av_1 : A ;
  goetvalsverk_nn_1 : N ;
  gold_digger_nn_1 : N ;
  golf_nn_2 : N ;
  golfare_nn_1 : N ;
  golfspel_nn_1 : N ;
  golgiapparat_nn_1 : N ;
  golv_nn_1 : N ;
  golvbelaeggning_nn_1 : N ;
  golvbjaelke_nn_1 : N ;
  golvbraeda_nn_1 : N ;
  golvbrunn_nn_1 : N ;
  golvfast_av_1 : A ;
  golvkall_av_1 : A ;
  golvlaeggare_nn_1 : N ;
  golvramp_nn_1 : N ;
  golvur_nn_1 : N ;
  golvvaexel_nn_1 : N ;
  golvvax_nn_1 : N ;
  gom_nn_1 : N ;
  gombaage_nn_1 : N ;
  gomben_nn_1 : N ;
  gomljud_nn_1 : N ;
  gomsegel_nn_1 : N ;
  gomspene_nn_1 : N ;
  gon_nn_1 : N ;
  gonad_nn_1 : N ;
  gondol_nn_1 : N ;
  gondoljaer_nn_1 : N ;
  gonfaloniaer_nn_1 : N ;
  gonggong_nn_1 : N ;
  gonokock_nn_1 : N ;
  gonorre_nn_1 : N ;
  goraa_nn_1 : N ;
  gordonsetter_nn_1 : N ;
  gorgon_nn_1 : N ;
  gosig_av_1 : A ;
  gospel_nn_1 : N ;
  gosse_nn_1 : N ;
  got_nn_1 : N ;
  goticerande_av_1 : A ;
  gotiserande_av_1 : A ;
  gotisk_av_1 : A ;
  gotlaendsk_av_1 : A ;
  gotlaendska_nn_2 : N ;
  gotlaenning_nn_1 : N ;
  gotlandsruss_nn_1 : N ;
  gotsk_av_1 : A ;
  gottgoerelse_nn_1 : N ;
  gottskriva_vb_1 : V ;
  gouache_nn_1 : N ;
  gourmand_nn_1 : N ;
  gourme_nn_1 : N ;
  gourmet_nn_1 : N ;
  graa_av_1 : A ;
  graaaktig_av_1 : A ;
  graaal_nn_1 : N ;
  graablaa_av_1 : A ;
  graablek_av_1 : A ;
  graabo_nn_1 : N ;
  graabroder_nn_1 : N ;
  graadaskig_av_1 : A ;
  graaflaeckig_av_1 : A ;
  graagaas_nn_1 : N ;
  graagosse_nn_1 : N ;
  graagroen_av_1 : A ;
  graagyllen_nn_1 : N ;
  graahaarig_av_1 : A ;
  graahaeger_nn_1 : N ;
  graahund_nn_1 : N ;
  graakall_av_1 : A ;
  graalax_nn_1 : N ;
  graalle_nn_1 : N ;
  graames_nn_1 : N ;
  graamunk_nn_1 : N ;
  graapaeron_nn_1 : N ;
  graasael_nn_1 : N ;
  graasej_nn_1 : N ;
  graasiska_nn_1 : N ;
  graaskaeckig_av_1 : A ;
  graaskaegg_nn_1 : N ;
  graaskimlig_av_1 : A ;
  graaskimmel_nn_1 : N ;
  graasosse_nn_1 : N ;
  graasparv_nn_1 : N ;
  graaspett_nn_1 : N ;
  graaspraengd_av_1 : A ;
  graasten_nn_1 : N ;
  graasvart_av_1 : A ;
  graaterska_nn_1 : N ;
  graatfaerdig_av_1 : A ;
  graatmild_av_1 : A ;
  graaton_nn_1 : N ;
  graatrut_nn_1 : N ;
  grabb_nn_1 : N ;
  grabbatag_nn_1 : N ;
  grabbnaeve_nn_1 : N ;
  grace_nn_1 : N ;
  gracil_av_1 : A ;
  gracioes_av_1 : A ;
  grad_nn_1 : N ;
  gradaeng_nn_1 : N ;
  gradation_nn_1 : N ;
  gradbeteckning_nn_1 : N ;
  gradboejning_nn_1 : N ;
  graderverk_nn_1 : N ;
  gradient_nn_1 : N ;
  gradlist_nn_1 : N ;
  gradmaetare_nn_1 : N ;
  gradmaetning_nn_1 : N ;
  gradmejsel_nn_1 : N ;
  gradnaet_nn_1 : N ;
  gradsaag_nn_1 : N ;
  gradskillnad_nn_1 : N ;
  gradstreck_nn_1 : N ;
  gradtal_nn_1 : N ;
  gradtapp_nn_1 : N ;
  gradtecken_nn_1 : N ;
  gradualavhandling_nn_1 : N ;
  gradualpsalm_nn_1 : N ;
  graduell_av_1 : A ;
  gradvis_ab_1 : Adv ;
  gradvis_av_1 : A ;
  graeddbakelse_nn_1 : N ;
  graeddhalt_nn_1 : N ;
  graeddig_av_1 : A ;
  graeddmaetare_nn_1 : N ;
  graeddvisp_nn_1 : N ;
  grael_nn_1 : N ;
  graelaktig_av_1 : A ;
  graelig_av_1 : A ;
  graell_av_1 : A ;
  graelmaans_nn_1 : N ;
  graelmakare_nn_1 : N ;
  graelsjuk_av_1 : A ;
  graemelse_nn_1 : N ;
  graen_nn_1 : N ;
  graend_nn_1 : N ;
  graeng_nn_1 : N ;
  graens_nn_1 : N ;
  graensbevakning_nn_1 : N ;
  graensbo_nn_1 : N ;
  graensfall_nn_1 : N ;
  graensintaekt_nn_1 : N ;
  graensjaegare_nn_1 : N ;
  graenskontroll_nn_1 : N ;
  graenskostnad_nn_1 : N ;
  graensle_ab_1 : Adv ;
  graenslinje_nn_1 : N ;
  graensloes_av_1 : A ;
  graensnytta_nn_1 : N ;
  graensoeverskridande_av_1 : A ;
  graensoeverskridande_nn_1 : N ;
  graensomraade_nn_1 : N ;
  graenspaale_nn_1 : N ;
  graenspolis_nn_1 : N ;
  graensskikt_nn_1 : N ;
  graenstrakt_nn_1 : N ;
  graensvaerde_nn_1 : N ;
  graes_nn_1 : N ;
  graesaenkling_nn_1 : N ;
  graesaetare_nn_1 : N ;
  graesand_nn_1 : N ;
  graesfjaeril_nn_1 : N ;
  graesfly_nn_1 : N ;
  graesklippare_nn_1 : N ;
  graeslig_av_1 : A ;
  graeslighet_nn_1 : N ;
  graesliknande_av_1 : A ;
  graesmaanad_nn_1 : N ;
  graesmask_nn_1 : N ;
  graesplan_nn_1 : N ;
  graesrot_nn_1 : N ;
  graesvall_nn_1 : N ;
  graetten_av_1 : A ;
  graevling_nn_1 : N ;
  graevlingsgryt_nn_1 : N ;
  graevlingshund_nn_1 : N ;
  graevmaskin_nn_1 : N ;
  graevning_nn_1 : N ;
  graevsvin_nn_1 : N ;
  graf_nn_1 : N ;
  grafem_nn_1 : N ;
  grafematisk_av_1 : A ;
  grafiker_nn_1 : N ;
  grafisk_av_1 : A ;
  grafit_nn_1 : N ;
  grafitdegel_nn_1 : N ;
  grafitgraa_av_1 : A ;
  grafolog_nn_1 : N ;
  grafonomisk_av_1 : A ;
  grafteori_nn_1 : N ;
  gram_nn_1 : N ;
  gramkalori_nn_1 : N ;
  grammatik_nn_1 : N ;
  grammatikalisk_av_1 : A ;
  grammatikbok_nn_1 : N ;
  grammatiker_nn_1 : N ;
  grammatikregel_nn_1 : N ;
  grammatisk_av_1 : A ;
  grammofon_nn_1 : N ;
  grammofonarkiv_nn_1 : N ;
  grammofonstift_nn_1 : N ;
  grammolekyl_nn_1 : N ;
  gramse_av_1 : A ;
  gran_nn_1 : N ;
  gran_nn_2 : N ;
  granat_nn_1 : N ;
  granatgevaer_nn_1 : N ;
  granatkartesch_nn_1 : N ;
  granbarrlus_nn_1 : N ;
  grand_nn_2 : N ;
  grandios_av_1 : A ;
  grandseigneur_nn_1 : N ;
  granit_nn_1 : N ;
  grann_av_1 : A ;
  granne_nn_1 : N ;
  granneligen_ab_1 : Adv ;
  grannlaat_nn_1 : N ;
  grannlaga_av_1 : A ;
  grannland_nn_1 : N ;
  grannskap_nn_1 : N ;
  grannstat_nn_1 : N ;
  grannsynt_av_1 : A ;
  granntyckt_av_1 : A ;
  gransaangare_nn_1 : N ;
  granskare_nn_1 : N ;
  granskning_nn_1 : N ;
  granskningsexemplar_nn_1 : N ;
  granskningsman_nn_1 : N ;
  granskog_nn_1 : N ;
  gransort_nn_1 : N ;
  granulat_nn_1 : N ;
  granulation_nn_1 : N ;
  granulationsvaevnad_nn_1 : N ;
  granulering_nn_1 : N ;
  granulum_nn_1 : N ;
  grapefrukt_nn_1 : N ;
  grataeng_nn_1 : N ;
  gratial_nn_1 : N ;
  gratialist_nn_1 : N ;
  gratie_nn_1 : N ;
  gratifikation_nn_1 : N ;
  gratin_nn_1 : N ;
  gratis_ab_1 : Adv ;
  gratis_av_1 : A ;
  gratisaktie_nn_1 : N ;
  gratispassagerare_nn_1 : N ;
  gratulant_nn_1 : N ;
  gratulation_nn_1 : N ;
  grav_av_1 : A ;
  grav_nn_1 : N ;
  gravallvarlig_av_1 : A ;
  gravand_nn_1 : N ;
  gravation_nn_1 : N ;
  gravbrev_nn_1 : N ;
  gravbyggnad_nn_1 : N ;
  grave_ab_1 : Adv ;
  gravenstein_nn_1 : N ;
  graverande_av_1 : A ;
  gravering_nn_1 : N ;
  gravfaelt_nn_1 : N ;
  gravfynd_nn_1 : N ;
  gravgaas_nn_1 : N ;
  gravhoeg_nn_1 : N ;
  graviditet_nn_1 : N ;
  graviditetstest_nn_1 : N ;
  graviditetsvecka_nn_1 : N ;
  gravimeter_nn_1 : N ;
  gravitationskonstant_nn_1 : N ;
  gravitationskraft_nn_1 : N ;
  gravitationslag_nn_1 : N ;
  gravitationsstraalning_nn_1 : N ;
  gravitet_nn_1 : N ;
  gravitetisk_av_1 : A ;
  graviton_nn_1 : N ;
  gravkapell_nn_1 : N ;
  gravkor_nn_1 : N ;
  gravkummel_nn_1 : N ;
  gravkyrka_nn_1 : N ;
  gravlax_nn_1 : N ;
  gravlik_av_1 : A ;
  gravmaterial_nn_1 : N ;
  gravoel_nn_1 : N ;
  gravoeppning_nn_1 : N ;
  gravoer_nn_1 : N ;
  gravplats_nn_1 : N ;
  gravsaettning_nn_1 : N ;
  gravsed_nn_1 : N ;
  gravskaendning_nn_1 : N ;
  gravskick_nn_1 : N ;
  gravsten_nn_1 : N ;
  gravstickel_nn_1 : N ;
  gravsvepning_nn_1 : N ;
  gravvaard_nn_1 : N ;
  gravvalv_nn_1 : N ;
  gravyr_nn_1 : N ;
  gray_nn_1 : N ;
  grecism_nn_1 : N ;
  gredelin_av_1 : A ;
  green_nn_1 : N ;
  gregoriansk_av_1 : A ;
  grej_nn_1 : N ;
  grek_nn_1 : N ;
  grekcypriot_nn_1 : N ;
  grekinna_nn_1 : N ;
  grekisk_av_1 : A ;
  grekisk_katolsk_av_1 : A ;
  grekisk_ortodox_av_1 : A ;
  grekisk_romersk_av_1 : A ;
  grekiska_nn_2 : N ;
  gren_nn_1 : N ;
  grenadier_nn_1 : N ;
  grenadin_nn_1 : N ;
  grenadisk_av_1 : A ;
  grenadjaer_nn_1 : N ;
  grenhopp_nn_1 : N ;
  grenig_av_1 : A ;
  grenledning_nn_1 : N ;
  grenljus_nn_1 : N ;
  grensle_ab_1 : Adv ;
  grenstaaende_av_1 : A ;
  grenuttag_nn_1 : N ;
  grenveck_nn_1 : N ;
  grenvinkel_nn_1 : N ;
  grep_nn_1 : N ;
  grepe_nn_1 : N ;
  grepp_nn_1 : N ;
  greppbraede_nn_1 : N ;
  greppriktig_av_1 : A ;
  greve_nn_1 : N ;
  grevinna_nn_1 : N ;
  grevlig_av_1 : A ;
  grevskap_nn_1 : N ;
  greyhound_nn_1 : N ;
  griffel_nn_1 : N ;
  griffeltavla_nn_1 : N ;
  grift_nn_1 : N ;
  griftetal_nn_1 : N ;
  grill_nn_1 : N ;
  grillbar_nn_1 : N ;
  grillfaengeri_nn_1 : N ;
  grilljanne_nn_1 : N ;
  grillspett_nn_1 : N ;
  grimas_nn_1 : N ;
  grimskaft_nn_1 : N ;
  grin_nn_1 : N ;
  grind_nn_1 : N ;
  grindoeppning_nn_1 : N ;
  grindslant_nn_1 : N ;
  grindstuga_nn_1 : N ;
  grindval_nn_1 : N ;
  gringo_nn_1 : N ;
  grinig_av_1 : A ;
  grinolle_nn_1 : N ;
  grip_nn_1 : N ;
  gripa_vb_1 : V ;
  gripande_av_1 : A ;
  gripbar_av_1 : A ;
  gripen_av_1 : A ;
  gripfot_nn_1 : N ;
  gris_nn_1 : N ;
  grisaille_nn_1 : N ;
  griseri_nn_1 : N ;
  grisett_nn_1 : N ;
  grisig_av_1 : A ;
  grisinsulin_nn_1 : N ;
  griskulting_nn_1 : N ;
  grisning_nn_1 : N ;
  grisningsbo_nn_1 : N ;
  grisoega_nn_1 : N ;
  grissel_nn_1 : N ;
  grissvans_nn_1 : N ;
  grisunge_nn_1 : N ;
  grizzlybjoern_nn_1 : N ;
  grobarhet_nn_1 : N ;
  grobian_nn_1 : N ;
  groblad_nn_1 : N ;
  grodd_nn_1 : N ;
  groddblad_nn_1 : N ;
  groddjur_nn_1 : N ;
  groddknopp_nn_1 : N ;
  grodfisk_nn_1 : N ;
  grodlaar_nn_1 : N ;
  grodman_nn_1 : N ;
  groen_av_1 : A ;
  groenalg_nn_1 : N ;
  groenblek_av_1 : A ;
  groenblind_av_1 : A ;
  groenfink_nn_1 : N ;
  groengoeling_nn_1 : N ;
  groengul_av_1 : A ;
  groening_nn_1 : N ;
  groenkoepingsmaessig_av_1 : A ;
  groenlaendare_nn_1 : N ;
  groenlaendsk_av_1 : A ;
  groenlaendska_nn_2 : N ;
  groenlandsval_nn_1 : N ;
  groenling_nn_1 : N ;
  groenmoegelost_nn_1 : N ;
  groenmoerk_av_1 : A ;
  groenmogen_av_1 : A ;
  groenmognad_nn_1 : N ;
  groenomraade_nn_1 : N ;
  groenraett_nn_1 : N ;
  groensak_nn_1 : N ;
  groensaksblandning_nn_1 : N ;
  groensakstallrik_nn_1 : N ;
  groensallad_nn_1 : N ;
  groensiska_nn_1 : N ;
  groenspett_nn_1 : N ;
  groepning_nn_1 : N ;
  groet_nn_1 : N ;
  groetfrukost_nn_1 : N ;
  groetig_av_1 : A ;
  groetmyndig_av_1 : A ;
  groetomslag_nn_1 : N ;
  groetrim_nn_1 : N ;
  groetrock_nn_1 : N ;
  grogg_nn_1 : N ;
  groggy_av_1 : A ;
  grogrund_nn_1 : N ;
  grop_nn_1 : N ;
  gropig_av_1 : A ;
  groschen_nn_1 : N ;
  gross_nn_1 : N ;
  grossess_nn_1 : N ;
  grosshandlare_nn_1 : N ;
  grossist_nn_1 : N ;
  grossistpris_nn_1 : N ;
  grossoer_nn_1 : N ;
  grotesk_av_1 : A ;
  grotesk_nn_1 : N ;
  groteskeri_nn_1 : N ;
  grottbjoern_nn_1 : N ;
  grottforskare_nn_1 : N ;
  grottgaang_nn_1 : N ;
  grottingaang_nn_1 : N ;
  grottinvaanare_nn_1 : N ;
  grottmaalning_nn_1 : N ;
  grottmaenniska_nn_1 : N ;
  groupie_nn_1 : N ;
  grov_av_1 : A ;
  grovarbetare_nn_1 : N ;
  grovhet_nn_1 : N ;
  grovhuggen_av_1 : A ;
  grovkoek_nn_1 : N ;
  grovkornig_av_1 : A ;
  grovlek_nn_1 : N ;
  grovsyssla_nn_1 : N ;
  grovtarm_nn_1 : N ;
  grubblare_nn_1 : N ;
  grubbleri_nn_1 : N ;
  gruff_nn_1 : N ;
  grumlig_av_1 : A ;
  grumling_nn_1 : N ;
  grumsig_av_1 : A ;
  grund_av_1 : A ;
  grund_nn_1 : N ;
  grund_nn_2 : N ;
  grundackord_nn_1 : N ;
  grundaemne_nn_1 : N ;
  grundare_nn_1 : N ;
  grundavdrag_nn_1 : N ;
  grundavgift_nn_1 : N ;
  grundbelopp_nn_1 : N ;
  grundbetydelse_nn_1 : N ;
  grundbok_nn_1 : N ;
  grundbrott_nn_1 : N ;
  grundbult_nn_1 : N ;
  grunddrag_nn_1 : N ;
  grundenhet_nn_1 : N ;
  grundfaerg_nn_1 : N ;
  grundfalsk_av_1 : A ;
  grundfoerbaettring_nn_1 : N ;
  grundform_nn_1 : N ;
  grundhav_nn_1 : N ;
  grundkaenning_nn_1 : N ;
  grundkraft_nn_1 : N ;
  grundkurs_nn_1 : N ;
  grundlaeggande_av_1 : A ;
  grundlaeggare_nn_1 : N ;
  grundlaeggning_nn_1 : N ;
  grundlag_nn_1 : N ;
  grundlag_nn_2 : N ;
  grundlig_av_1 : A ;
  grundligen_ab_1 : Adv ;
  grundlighet_nn_1 : N ;
  grundlinje_nn_1 : N ;
  grundloen_nn_1 : N ;
  grundloes_av_1 : A ;
  grundmaatt_nn_1 : N ;
  grundning_nn_1 : N ;
  grundord_nn_1 : N ;
  grundorsak_nn_1 : N ;
  grundpelare_nn_1 : N ;
  grundperiod_nn_1 : N ;
  grundplaat_nn_1 : N ;
  grundsats_nn_1 : N ;
  grundskolelaerare_nn_1 : N ;
  grundskott_nn_1 : N ;
  grundspraak_nn_1 : N ;
  grundstam_nn_1 : N ;
  grundsten_nn_1 : N ;
  grundstoetning_nn_1 : N ;
  grundtal_nn_1 : N ;
  grundtanke_nn_1 : N ;
  grundteori_nn_1 : N ;
  grundton_nn_1 : N ;
  grundutbildning_nn_1 : N ;
  grundval_nn_1 : N ;
  grundvatten_nn_1 : N ;
  grupp_nn_1 : N ;
  gruppbild_nn_1 : N ;
  gruppchef_nn_1 : N ;
  gruppdynamisk_av_1 : A ;
  gruppering_nn_1 : N ;
  gruppfoersaekring_nn_1 : N ;
  gruppgenitiv_nn_1 : N ;
  grupphus_nn_1 : N ;
  gruppkorsband_nn_1 : N ;
  gruppsamtal_nn_1 : N ;
  gruppterapi_nn_1 : N ;
  grupptest_nn_1 : N ;
  grusgaang_nn_1 : N ;
  grusgrop_nn_1 : N ;
  grusig_av_1 : A ;
  grusplan_nn_1 : N ;
  grustaekt_nn_1 : N ;
  grustag_nn_1 : N ;
  grusvaeg_nn_1 : N ;
  gruvbrytning_nn_1 : N ;
  gruvdrift_nn_1 : N ;
  gruvfaelt_nn_1 : N ;
  gruvfogde_nn_1 : N ;
  gruvgaang_nn_1 : N ;
  gruvhund_nn_1 : N ;
  gruvkompass_nn_1 : N ;
  gruvlave_nn_1 : N ;
  gruvlig_av_1 : A ;
  gruvoeppning_nn_1 : N ;
  gruvsam_av_1 : A ;
  gruvschakt_nn_1 : N ;
  gruvstigare_nn_1 : N ;
  grym_av_1 : A ;
  grymhet_nn_1 : N ;
  grymthastighet_nn_1 : N ;
  grymtning_nn_1 : N ;
  grymtoxe_nn_1 : N ;
  gryn_nn_1 : N ;
  grynig_av_1 : A ;
  gryning_nn_1 : N ;
  grynkorv_nn_1 : N ;
  grynpipig_av_1 : A ;
  gryt_nn_1 : N ;
  grythund_nn_1 : N ;
  grytlapp_nn_1 : N ;
  grytskaap_nn_1 : N ;
  grytstek_nn_1 : N ;
  grytvante_nn_1 : N ;
  guanin_nn_1 : N ;
  guatemalan_nn_1 : N ;
  guatemalansk_av_1 : A ;
  guatemaltek_nn_1 : N ;
  guatemaltekisk_av_1 : A ;
  guayanan_nn_1 : N ;
  guayansk_av_1 : A ;
  gubbe_nn_1 : N ;
  gubbig_av_1 : A ;
  gubbsjuk_av_1 : A ;
  gubbstrutt_nn_1 : N ;
  guckusko_nn_1 : N ;
  gud_nn_1 : N ;
  gudaktig_av_1 : A ;
  gudalaera_nn_1 : N ;
  gudasaend_av_1 : A ;
  gudasaga_nn_1 : N ;
  gudbarn_nn_1 : N ;
  guddotter_nn_1 : N ;
  gudelig_av_1 : A ;
  gudfader_nn_1 : N ;
  gudfruktig_av_1 : A ;
  gudi_ab_1 : Adv ;
  gudilov_ab_1 : Adv ;
  guding_nn_1 : N ;
  gudinna_nn_1 : N ;
  gudinog_ab_1 : Adv ;
  gudlig_av_1 : A ;
  gudloes_av_1 : A ;
  gudmoder_nn_1 : N ;
  gudom_nn_1 : N ;
  gudomlig_av_1 : A ;
  gudsbevis_nn_1 : N ;
  gudsdom_nn_1 : N ;
  gudsfoergaeten_av_1 : A ;
  gudsfoernekare_nn_1 : N ;
  gudsfoernekelse_nn_1 : N ;
  gudskelov_ab_1 : Adv ;
  gudslaan_nn_1 : N ;
  gudsman_nn_1 : N ;
  gudsnaadelig_av_1 : A ;
  gudson_nn_1 : N ;
  gudsord_nn_1 : N ;
  gudstjaenst_nn_1 : N ;
  gudstjaenstdag_nn_1 : N ;
  gudstjaenstritual_nn_1 : N ;
  gudunge_nn_1 : N ;
  guide_nn_1 : N ;
  guinea_nn_1 : N ;
  guinean_nn_1 : N ;
  guineansk_av_1 : A ;
  gul_av_1 : A ;
  gulasch_nn_2 : N ;
  gulaschbaron_nn_1 : N ;
  gulblek_av_1 : A ;
  gulblommig_av_1 : A ;
  gulbrun_av_1 : A ;
  guld_nn_1 : N ;
  guldaalder_nn_1 : N ;
  guldbagge_nn_1 : N ;
  guldbarr_nn_1 : N ;
  guldberlock_nn_1 : N ;
  guldbroellop_nn_1 : N ;
  gulddrageri_nn_1 : N ;
  gulden_nn_1 : N ;
  guldfasan_nn_1 : N ;
  guldfisk_nn_1 : N ;
  guldfoeremaal_nn_1 : N ;
  guldfux_nn_1 : N ;
  guldfynd_nn_1 : N ;
  guldgraevare_nn_1 : N ;
  guldhalt_nn_1 : N ;
  guldkalv_nn_1 : N ;
  guldkant_nn_1 : N ;
  guldklimp_nn_1 : N ;
  guldkorn_nn_1 : N ;
  guldkrog_nn_1 : N ;
  guldlegering_nn_1 : N ;
  guldliknande_av_1 : A ;
  guldmakare_nn_1 : N ;
  guldmakeri_nn_1 : N ;
  guldmakrill_nn_1 : N ;
  guldmedalj_nn_1 : N ;
  guldmedaljoer_nn_1 : N ;
  guldmynt_nn_1 : N ;
  guldplants_nn_1 : N ;
  guldpressning_nn_1 : N ;
  guldprov_nn_1 : N ;
  guldreserv_nn_1 : N ;
  guldrush_nn_1 : N ;
  guldslagare_nn_1 : N ;
  guldslageri_nn_1 : N ;
  guldsmed_nn_1 : N ;
  guldsmidd_av_1 : A ;
  guldsmide_nn_1 : N ;
  guldsnitt_nn_1 : N ;
  guldstaempel_nn_1 : N ;
  guldstekel_nn_1 : N ;
  guldtand_nn_1 : N ;
  guldtraad_nn_1 : N ;
  guldvaag_nn_1 : N ;
  guldvaskning_nn_1 : N ;
  gulesaeck_nn_1 : N ;
  gulfaergning_nn_1 : N ;
  gulfilter_nn_1 : N ;
  gulgraa_av_1 : A ;
  guling_nn_1 : N ;
  gulkropp_nn_1 : N ;
  gull_nn_1 : N ;
  gullegris_nn_1 : N ;
  gullgosse_nn_1 : N ;
  gullgris_nn_1 : N ;
  gullig_av_1 : A ;
  gullstol_nn_1 : N ;
  gulning_nn_1 : N ;
  gulroed_av_1 : A ;
  gulsaeck_nn_1 : N ;
  gulsiktig_av_1 : A ;
  gulsparv_nn_1 : N ;
  gulsporre_nn_1 : N ;
  gulvit_av_1 : A ;
  gummering_nn_1 : N ;
  gummi_nn_1 : N ;
  gummibaat_nn_1 : N ;
  gummiband_nn_1 : N ;
  gummidaeck_nn_1 : N ;
  gummiharts_nn_1 : N ;
  gummimaterial_nn_1 : N ;
  gummiparagraf_nn_1 : N ;
  gummisnodd_nn_1 : N ;
  gummistoevel_nn_1 : N ;
  gummitraed_nn_1 : N ;
  gummoes_av_1 : A ;
  gump_nn_1 : N ;
  gumpkoertel_nn_1 : N ;
  gumse_nn_1 : N ;
  gungbraede_nn_1 : N ;
  gungfly_nn_1 : N ;
  gunghaest_nn_1 : N ;
  gungig_av_1 : A ;
  gungning_nn_1 : N ;
  gungstol_nn_1 : N ;
  gunrum_nn_1 : N ;
  gunst_nn_1 : N ;
  gunstbenaegen_av_1 : A ;
  gunstig_av_1 : A ;
  gunstling_nn_1 : N ;
  gupp_nn_1 : N ;
  guppig_av_1 : A ;
  guppy_nn_1 : N ;
  gurami_nn_1 : N ;
  gurgel_nn_1 : N ;
  gurkha_nn_1 : N ;
  gurklist_nn_1 : N ;
  gurkvaext_nn_1 : N ;
  guru_nn_1 : N ;
  gustavian_nn_1 : N ;
  gustaviansk_av_1 : A ;
  gute_nn_1 : N ;
  gutnisk_av_1 : A ;
  guttural_av_1 : A ;
  guvernant_nn_1 : N ;
  guvernement_nn_1 : N ;
  guvernoer_nn_1 : N ;
  gyckelbild_nn_1 : N ;
  gyckelspel_nn_1 : N ;
  gycklare_nn_1 : N ;
  gyckleri_nn_1 : N ;
  gydja_nn_1 : N ;
  gylf_nn_1 : N ;
  gyllen_nn_1 : N ;
  gyllen_nn_2 : N ;
  gyllen_nn_3 : N ;
  gyllene_av_1 : A ;
  gyllental_nn_1 : N ;
  gylling_nn_1 : N ;
  gym_nn_1 : N ;
  gymnasial_av_1 : A ;
  gymnasieekonom_nn_1 : N ;
  gymnasieingenjoer_nn_1 : N ;
  gymnasieinspektoer_nn_1 : N ;
  gymnasielinje_nn_1 : N ;
  gymnasist_nn_1 : N ;
  gymnasium_nn_1 : N ;
  gymnast_nn_1 : N ;
  gymnastikdirektoer_nn_1 : N ;
  gymnastikdraekt_nn_1 : N ;
  gymnastikhopp_nn_1 : N ;
  gymnastikredskap_nn_1 : N ;
  gymnastiksko_nn_1 : N ;
  gymnastisk_av_1 : A ;
  gymnisk_av_1 : A ;
  gymnosperm_nn_1 : N ;
  gynekolog_nn_1 : N ;
  gynekologisk_av_1 : A ;
  gynnare_nn_1 : N ;
  gynnsam_av_1 : A ;
  gyro_nn_1 : N ;
  gyrohorisont_nn_1 : N ;
  gyrokompass_nn_1 : N ;
  gyroskop_nn_1 : N ;
  gyroskopkompass_nn_1 : N ;
  gyrostabilisator_nn_1 : N ;
  gyttjebad_nn_1 : N ;
  gyttjig_av_1 : A ;
  gyttrig_av_1 : A ;
  gyttring_nn_1 : N ;
  haabrand_nn_1 : N ;
  haagkomst_nn_1 : N ;
  haagloes_av_1 : A ;
  haakaering_nn_1 : N ;
  haal_nn_1 : N ;
  haalfot_nn_1 : N ;
  haalfotsinlaegg_nn_1 : N ;
  haalig_av_1 : A ;
  haalighet_nn_1 : N ;
  haalkael_nn_1 : N ;
  haalkort_nn_1 : N ;
  haall_nn_1 : N ;
  haalla_vb_1 : V ;
  haallare_nn_1 : N ;
  haallbar_av_1 : A ;
  haallbarhet_nn_1 : N ;
  haallbarhetsdag_nn_1 : N ;
  haalldam_nn_1 : N ;
  haallen_av_1 : A ;
  haallfast_av_1 : A ;
  haallfasthet_nn_1 : N ;
  haallfasthetsberaekning_nn_1 : N ;
  haallfasthetslaera_nn_1 : N ;
  haallhake_nn_1 : N ;
  haalligaang_nn_1 : N ;
  haallning_nn_1 : N ;
  haallningsloes_av_1 : A ;
  haallplats_nn_1 : N ;
  haallpunkt_nn_1 : N ;
  haalmoenster_nn_1 : N ;
  haaloegd_av_1 : A ;
  haalrum_nn_1 : N ;
  haalslag_nn_1 : N ;
  haalslagning_nn_1 : N ;
  haalslev_nn_1 : N ;
  haaltimme_nn_1 : N ;
  haalvaeg_nn_1 : N ;
  haalven_nn_1 : N ;
  haanfull_av_1 : A ;
  haanskratt_nn_1 : N ;
  haar_nn_1 : N ;
  haarband_nn_1 : N ;
  haarbeklaednad_nn_1 : N ;
  haarbevuxen_av_1 : A ;
  haarborste_nn_1 : N ;
  haarbotten_nn_1 : N ;
  haard_av_1 : A ;
  haarddata_nn_1 : N ;
  haardfoer_av_1 : A ;
  haardfrusen_av_1 : A ;
  haardhaent_av_1 : A ;
  haardhet_nn_1 : N ;
  haarding_nn_1 : N ;
  haardkokt_av_1 : A ;
  haardmetall_nn_1 : N ;
  haardra_vb_1 : V ;
  haardsmaelt_av_1 : A ;
  haardvaluta_nn_1 : N ;
  haarfaellning_nn_1 : N ;
  haarfaerg_nn_1 : N ;
  haarfin_av_1 : A ;
  haarfrisoer_nn_1 : N ;
  haarfrisoerska_nn_1 : N ;
  haarig_av_1 : A ;
  haarklyveri_nn_1 : N ;
  haarknut_nn_1 : N ;
  haarkors_nn_1 : N ;
  haarlaeggning_nn_1 : N ;
  haarlag_nn_1 : N ;
  haarliknande_av_1 : A ;
  haarlock_nn_1 : N ;
  haarloes_av_1 : A ;
  haarnaal_nn_1 : N ;
  haarolja_nn_1 : N ;
  haarpensel_nn_1 : N ;
  haarrem_nn_1 : N ;
  haarresande_av_1 : A ;
  haarroer_nn_1 : N ;
  haarroerskaerl_nn_1 : N ;
  haarrulle_nn_1 : N ;
  haarsaeck_nn_1 : N ;
  haarsida_nn_1 : N ;
  haarspaenne_nn_1 : N ;
  haarstraa_nn_1 : N ;
  haarsvall_nn_1 : N ;
  haartest_nn_1 : N ;
  haartofs_nn_1 : N ;
  haartork_nn_1 : N ;
  haartuss_nn_1 : N ;
  haartvaett_nn_1 : N ;
  haaruppsaettning_nn_1 : N ;
  haarvatten_nn_1 : N ;
  haav_nn_1 : N ;
  habil_av_1 : A ;
  habilitet_nn_1 : N ;
  habit_nn_1 : N ;
  habitue_nn_1 : N ;
  habituell_av_1 : A ;
  habitus_nn_1 : N ;
  habsburgsk_av_1 : A ;
  hack_nn_1 : N ;
  hackbraede_nn_1 : N ;
  hacker_nn_1 : N ;
  hackig_av_1 : A ;
  hackkyckling_nn_1 : N ;
  hackspett_nn_1 : N ;
  haeck_nn_1 : N ;
  haeckfaagel_nn_1 : N ;
  haecklare_nn_1 : N ;
  haeckloepning_nn_1 : N ;
  haecklopp_nn_1 : N ;
  haeckning_nn_1 : N ;
  haedan_ab_1 : Adv ;
  haedanefter_ab_1 : Adv ;
  haedanfaerd_nn_1 : N ;
  haedangaangen_av_1 : A ;
  haedelse_nn_1 : N ;
  haedisk_av_1 : A ;
  haeftapparat_nn_1 : N ;
  haefte_nn_1 : N ;
  haeftig_av_1 : A ;
  haeftklammer_nn_1 : N ;
  haeftplaaster_nn_1 : N ;
  haeftstift_nn_1 : N ;
  haeger_nn_1 : N ;
  haegg_nn_1 : N ;
  haegnad_nn_1 : N ;
  haegring_nn_1 : N ;
  haekte_nn_1 : N ;
  haektning_nn_1 : N ;
  hael_nn_1 : N ;
  haelare_nn_1 : N ;
  haelben_nn_1 : N ;
  haeleri_nn_1 : N ;
  haelft_nn_1 : N ;
  haelftenbruk_nn_1 : N ;
  haelgaangare_nn_1 : N ;
  haell_nn_1 : N ;
  haellmark_nn_1 : N ;
  haellregn_nn_1 : N ;
  haellristning_nn_1 : N ;
  haelsing_nn_1 : N ;
  haelsning_nn_1 : N ;
  haelsningsanfoerande_nn_1 : N ;
  haelsobringande_av_1 : A ;
  haelsobrunn_nn_1 : N ;
  haelsocenter_nn_1 : N ;
  haelsoeffekt_nn_1 : N ;
  haelsofarlig_av_1 : A ;
  haelsokontroll_nn_1 : N ;
  haelsokort_nn_1 : N ;
  haelsosam_av_1 : A ;
  haelsotecken_nn_1 : N ;
  haelsotek_nn_1 : N ;
  haelsovaadlig_av_1 : A ;
  haelsovaardsnaemnd_nn_1 : N ;
  haemnare_nn_1 : N ;
  haemndaktion_nn_1 : N ;
  haemndeande_nn_1 : N ;
  haemndgirig_av_1 : A ;
  haemndgudinna_nn_1 : N ;
  haemndlysten_av_1 : A ;
  haemndlystnad_nn_1 : N ;
  haemning_nn_1 : N ;
  haemningsloes_av_1 : A ;
  haempling_nn_1 : N ;
  haemsko_nn_1 : N ;
  haemtning_nn_1 : N ;
  haemtpris_nn_1 : N ;
  haen_ab_1 : Adv ;
  haendelse_nn_1 : N ;
  haendelsefattig_av_1 : A ;
  haendelsefoerlopp_nn_1 : N ;
  haendelseloes_av_1 : A ;
  haendelserik_av_1 : A ;
  haendelsevis_ab_1 : Adv ;
  haendig_av_1 : A ;
  haenfoerande_av_1 : A ;
  haenfoerd_av_1 : A ;
  haengande_nn_1 : N ;
  haengare_nn_1 : N ;
  haengavtal_nn_1 : N ;
  haengbjoerk_nn_1 : N ;
  haengbro_nn_1 : N ;
  haengbroest_nn_1 : N ;
  haengbuk_nn_1 : N ;
  haengdal_nn_1 : N ;
  haenge_vb_1 : V ;
  haengfaerdig_av_1 : A ;
  haengig_av_1 : A ;
  haengiven_av_1 : A ;
  haenglaas_nn_1 : N ;
  haengning_nn_1 : N ;
  haengparti_nn_1 : N ;
  haengsjuk_av_1 : A ;
  haengsmycke_nn_1 : N ;
  haenryckt_av_1 : A ;
  haenseende_nn_1 : N ;
  haensjunken_av_1 : A ;
  haenskjuta_vb_1 : V ;
  haensoven_av_1 : A ;
  haensyftning_nn_1 : N ;
  haensyn_nn_1 : N ;
  haensynsfull_av_1 : A ;
  haensynsloes_av_1 : A ;
  haensynstagande_nn_1 : N ;
  haentydning_nn_1 : N ;
  haenvaendelse_nn_1 : N ;
  haenvisning_nn_1 : N ;
  haepen_av_1 : A ;
  haepnad_nn_1 : N ;
  haepnadsvaeckande_av_1 : A ;
  haer_ab_1 : Adv ;
  haer_nn_1 : N ;
  haeraat_ab_1 : Adv ;
  haerad_nn_1 : N ;
  haeradshoevding_nn_1 : N ;
  haeradsraett_nn_1 : N ;
  haeradsskrivare_nn_1 : N ;
  haerav_ab_1 : Adv ;
  haerd_nn_1 : N ;
  haerdig_av_1 : A ;
  haerdighet_nn_1 : N ;
  haerdighetskrav_nn_1 : N ;
  haerdlack_nn_1 : N ;
  haerdning_nn_1 : N ;
  haerdplast_nn_1 : N ;
  haerefter_ab_1 : Adv ;
  haeremot_ab_1 : Adv ;
  haerfaagel_nn_1 : N ;
  haerflyta_vb_1 : V ;
  haerfoer_ab_1 : Adv ;
  haerfoerare_nn_1 : N ;
  haerfoerleden_ab_1 : Adv ;
  haeri_ab_1 : Adv ;
  haerifraan_ab_1 : Adv ;
  haerigenom_ab_1 : Adv ;
  haerjaemte_ab_1 : Adv ;
  haerjedaling_nn_1 : N ;
  haerjedalsk_av_1 : A ;
  haerjning_nn_1 : N ;
  haerk_nn_1 : N ;
  haerledning_nn_1 : N ;
  haerlig_av_1 : A ;
  haerlighet_nn_1 : N ;
  haermask_nn_1 : N ;
  haermed_ab_1 : Adv ;
  haermfaagel_nn_1 : N ;
  haernad_nn_1 : N ;
  haernaest_ab_1 : Adv ;
  haerold_nn_1 : N ;
  haerom_ab_1 : Adv ;
  haeromaaret_ab_1 : Adv ;
  haeromdagen_ab_1 : Adv ;
  haeromsistens_ab_1 : Adv ;
  haerordning_nn_1 : N ;
  haerpaa_ab_1 : Adv ;
  haerskare_nn_1 : N ;
  haerskarinna_nn_1 : N ;
  haerskarklass_nn_1 : N ;
  haersken_av_1 : A ;
  haersklysten_av_1 : A ;
  haerskri_nn_1 : N ;
  haerstaedes_ab_1 : Adv ;
  haerstamning_nn_1 : N ;
  haertagen_av_1 : A ;
  haertill_ab_1 : Adv ;
  haeruppe_ab_1 : Adv ;
  haerutinnan_ab_1 : Adv ;
  haerutoever_ab_1 : Adv ;
  haervel_nn_1 : N ;
  haervid_ab_1 : Adv ;
  haervidlag_ab_1 : Adv ;
  haessja_nn_1 : N ;
  haest_nn_1 : N ;
  haestben_nn_1 : N ;
  haestdjur_nn_1 : N ;
  haestdragen_av_1 : A ;
  haestdressyr_nn_1 : N ;
  haesthov_nn_1 : N ;
  haesthovsoert_nn_1 : N ;
  haesthuvud_nn_1 : N ;
  haestkapploepning_nn_1 : N ;
  haestkastanj_nn_1 : N ;
  haestkraft_nn_1 : N ;
  haestkrake_nn_1 : N ;
  haestkur_nn_1 : N ;
  haestlaengd_nn_1 : N ;
  haestlass_nn_1 : N ;
  haestliknande_av_1 : A ;
  haestrygg_nn_1 : N ;
  haestskjuts_nn_1 : N ;
  haestsko_nn_1 : N ;
  haestskobaage_nn_1 : N ;
  haestskojare_nn_1 : N ;
  haestskomagnet_nn_1 : N ;
  haestskosoem_nn_1 : N ;
  haestspann_nn_1 : N ;
  haeststyng_nn_1 : N ;
  haestsvans_nn_1 : N ;
  haestvagn_nn_1 : N ;
  haetsk_av_1 : A ;
  haetskhet_nn_1 : N ;
  haevarm_nn_1 : N ;
  haevd_nn_1 : N ;
  haevdatecknare_nn_1 : N ;
  haevdvunnen_av_1 : A ;
  haevel_nn_1 : N ;
  haevert_nn_1 : N ;
  haevstaang_nn_1 : N ;
  haevstaangsarm_nn_1 : N ;
  haexdans_nn_1 : N ;
  haexeri_nn_1 : N ;
  haexjakt_nn_1 : N ;
  haexkittel_nn_1 : N ;
  haexmaestare_nn_1 : N ;
  haexprocess_nn_1 : N ;
  haexsabbat_nn_1 : N ;
  hafsig_av_1 : A ;
  hafsverk_nn_1 : N ;
  hagalen_av_1 : A ;
  hage_nn_1 : N ;
  hagel_nn_1 : N ;
  hagelgevaer_nn_1 : N ;
  hagelkorn_nn_1 : N ;
  hagmark_nn_1 : N ;
  hagtorn_nn_1 : N ;
  haiku_nn_1 : N ;
  haitier_nn_1 : N ;
  haitisk_av_1 : A ;
  haj_av_1 : A ;
  haj_nn_1 : N ;
  hajk_nn_1 : N ;
  hak_nn_1 : N ;
  hake_nn_1 : N ;
  hakkors_nn_1 : N ;
  haklapp_nn_1 : N ;
  hakning_nn_1 : N ;
  hakparentes_nn_1 : N ;
  hal_av_1 : A ;
  halgatt_nn_1 : N ;
  halkfri_av_1 : A ;
  halkig_av_1 : A ;
  halkskydd_nn_1 : N ;
  hall_nn_1 : N ;
  hallaaman_nn_1 : N ;
  hallaendsk_av_1 : A ;
  hallaendska_nn_2 : N ;
  hallaenning_nn_1 : N ;
  hallelujamoete_nn_1 : N ;
  hallick_nn_1 : N ;
  halling_nn_1 : N ;
  hallkyrka_nn_1 : N ;
  hallon_nn_1 : N ;
  hallonbuske_nn_1 : N ;
  hallonmask_nn_1 : N ;
  hallonsaft_nn_1 : N ;
  hallstaempel_nn_1 : N ;
  hallucination_nn_1 : N ;
  hallucinatorisk_av_1 : A ;
  hallucinogen_av_1 : A ;
  hallucinogen_nn_1 : N ;
  halmhatt_nn_1 : N ;
  halmskakare_nn_1 : N ;
  halmstack_nn_1 : N ;
  halmstraa_nn_1 : N ;
  halo_nn_1 : N ;
  haloeffekt_nn_1 : N ;
  halofenomen_nn_1 : N ;
  halogen_nn_1 : N ;
  hals_nn_1 : N ;
  halsband_nn_1 : N ;
  halsbloss_nn_1 : N ;
  halsboeld_nn_1 : N ;
  halsbrytande_av_1 : A ;
  halsduk_nn_1 : N ;
  halsfluss_nn_1 : N ;
  halsgrop_nn_1 : N ;
  halshugga_vb_1 : V ;
  halskatarr_nn_1 : N ;
  halskraas_nn_1 : N ;
  halsmandel_nn_1 : N ;
  halsring_nn_1 : N ;
  halsstarrig_av_1 : A ;
  halstablett_nn_1 : N ;
  halster_nn_1 : N ;
  halt_av_1 : A ;
  halt_nn_1 : N ;
  halv_av_1 : A ;
  halvaar_nn_1 : N ;
  halvaedelsten_nn_1 : N ;
  halvankare_nn_1 : N ;
  halvautomatisk_av_1 : A ;
  halvback_nn_1 : N ;
  halvbild_nn_1 : N ;
  halvblod_nn_1 : N ;
  halvbroder_nn_1 : N ;
  halvbuske_nn_1 : N ;
  halvbutelj_nn_1 : N ;
  halvcirkel_nn_1 : N ;
  halvdaeck_nn_1 : N ;
  halvdaeckare_nn_1 : N ;
  halvdaglig_av_1 : A ;
  halvdan_av_1 : A ;
  halvdoed_av_1 : A ;
  halvdunkel_av_1 : A ;
  halvdussin_nn_1 : N ;
  halvenskild_av_1 : A ;
  halvfabrikat_nn_1 : N ;
  halvfaerdig_av_1 : A ;
  halvfet_av_1 : A ;
  halvfigur_nn_1 : N ;
  halvflytande_av_1 : A ;
  halvfransk_av_1 : A ;
  halvfylld_av_1 : A ;
  halvgaangen_av_1 : A ;
  halvgenomskinlig_av_1 : A ;
  halvgraes_nn_1 : N ;
  halvgud_nn_1 : N ;
  halvhet_nn_1 : N ;
  halvklar_av_1 : A ;
  halvklass_nn_1 : N ;
  halvklot_nn_1 : N ;
  halvknop_nn_1 : N ;
  halvkolonn_nn_1 : N ;
  halvkonserv_nn_1 : N ;
  halvkvaeden_av_1 : A ;
  halvkvaevd_av_1 : A ;
  halvledardiod_nn_1 : N ;
  halvledare_nn_1 : N ;
  halvlek_nn_1 : N ;
  halvliter_nn_1 : N ;
  halvljus_nn_1 : N ;
  halvmaane_nn_1 : N ;
  halvmesyr_nn_1 : N ;
  halvmetall_nn_1 : N ;
  halvmetallisk_av_1 : A ;
  halvmeter_nn_1 : N ;
  halvmeterbred_av_1 : A ;
  halvmil_nn_1 : N ;
  halvmodern_av_1 : A ;
  halvnaken_av_1 : A ;
  halvnot_nn_1 : N ;
  halvoe_nn_1 : N ;
  halvoeppen_av_1 : A ;
  halvofficiell_av_1 : A ;
  halvpart_nn_1 : N ;
  halvprofil_nn_1 : N ;
  halvrim_nn_1 : N ;
  halvsanning_nn_1 : N ;
  halvsekel_nn_1 : N ;
  halvslag_nn_1 : N ;
  halvsluten_av_1 : A ;
  halvsmaelt_av_1 : A ;
  halvspraakig_av_1 : A ;
  halvstatlig_av_1 : A ;
  halvstop_nn_1 : N ;
  halvsur_av_1 : A ;
  halvsyskon_nn_1 : N ;
  halvsyster_nn_1 : N ;
  halvtid_nn_1 : N ;
  halvtimme_nn_1 : N ;
  halvton_nn_1 : N ;
  halvtorr_av_1 : A ;
  halvtum_nn_1 : N ;
  halvvaegs_ab_1 : Adv ;
  halvvaerld_nn_1 : N ;
  halvvokal_nn_1 : N ;
  halvvuxen_av_1 : A ;
  hambo_nn_1 : N ;
  hamburgare_nn_1 : N ;
  hamburgerbar_nn_1 : N ;
  hamit_nn_1 : N ;
  hamitisk_av_1 : A ;
  hammarband_nn_1 : N ;
  hammare_nn_1 : N ;
  hammarhaj_nn_1 : N ;
  hammarslag_nn_1 : N ;
  hammel_nn_1 : N ;
  hammelsadel_nn_1 : N ;
  hammerless_nn_1 : N ;
  hammock_nn_1 : N ;
  hammondorgel_nn_1 : N ;
  hamn_nn_1 : N ;
  hamnarbetare_nn_1 : N ;
  hamnbassaeng_nn_1 : N ;
  hamndirektion_nn_1 : N ;
  hamnfoerhaallande_nn_1 : N ;
  hamnkapten_nn_1 : N ;
  hamnkontor_nn_1 : N ;
  hamnkvarter_nn_1 : N ;
  hamnstad_nn_1 : N ;
  hamnstyrelse_nn_1 : N ;
  hampfroe_nn_1 : N ;
  hamster_nn_1 : N ;
  hanbjaelke_nn_1 : N ;
  hand_nn_1 : N ;
  handalfabet_nn_1 : N ;
  handbagage_nn_1 : N ;
  handbok_nn_1 : N ;
  handboll_nn_1 : N ;
  handbrev_nn_1 : N ;
  handbroms_nn_1 : N ;
  handduk_nn_1 : N ;
  handeldvapen_nn_1 : N ;
  handelsavtal_nn_1 : N ;
  handelsbank_nn_1 : N ;
  handelsbod_nn_1 : N ;
  handelsbolag_nn_1 : N ;
  handelsdepartement_nn_1 : N ;
  handelsfartyg_nn_1 : N ;
  handelsfoeretag_nn_1 : N ;
  handelshus_nn_1 : N ;
  handelskammare_nn_1 : N ;
  handelskoep_nn_1 : N ;
  handelskompani_nn_1 : N ;
  handelsled_nn_1 : N ;
  handelsman_nn_1 : N ;
  handelsminister_nn_1 : N ;
  handelspolitisk_av_1 : A ;
  handelsregister_nn_1 : N ;
  handelsresande_nn_1 : N ;
  handelstraedgaard_nn_1 : N ;
  handelsutbyte_nn_1 : N ;
  handfallen_av_1 : A ;
  handfallenhet_nn_1 : N ;
  handfast_av_1 : A ;
  handfat_nn_1 : N ;
  handflikig_av_1 : A ;
  handfull_nn_1 : N ;
  handgaangen_av_1 : A ;
  handgemaeng_nn_1 : N ;
  handgjord_av_1 : A ;
  handgranat_nn_1 : N ;
  handgrepp_nn_1 : N ;
  handgriplig_av_1 : A ;
  handgripligen_ab_1 : Adv ;
  handgriplighet_nn_1 : N ;
  handikapp_nn_1 : N ;
  handikappvaard_nn_1 : N ;
  handjagare_nn_1 : N ;
  handjur_nn_1 : N ;
  handkassa_nn_1 : N ;
  handklappning_nn_1 : N ;
  handklaver_nn_1 : N ;
  handklove_nn_1 : N ;
  handkyss_nn_1 : N ;
  handlaan_nn_1 : N ;
  handlaeggning_nn_1 : N ;
  handlande_nn_1 : N ;
  handlare_nn_1 : N ;
  handled_nn_1 : N ;
  handledare_nn_1 : N ;
  handledning_nn_1 : N ;
  handling_nn_1 : N ;
  handlingsfrihet_nn_1 : N ;
  handlingskraftig_av_1 : A ;
  handlingsmaenniska_nn_1 : N ;
  handlingsprogram_nn_1 : N ;
  handlingsregel_nn_1 : N ;
  handlingssaett_nn_1 : N ;
  handloest_ab_1 : Adv ;
  handlov_nn_1 : N ;
  handout_nn_1 : N ;
  handpaalaeggning_nn_1 : N ;
  handpenning_nn_1 : N ;
  handraeckning_nn_1 : N ;
  handrem_nn_1 : N ;
  handsaag_nn_1 : N ;
  handsbredd_nn_1 : N ;
  handsekreterare_nn_1 : N ;
  handskakning_nn_1 : N ;
  handske_nn_1 : N ;
  handskrift_nn_1 : N ;
  handskriftsrulle_nn_1 : N ;
  handskriftssamling_nn_1 : N ;
  handskriven_av_1 : A ;
  handslag_nn_1 : N ;
  handstil_nn_1 : N ;
  handtag_nn_1 : N ;
  handtryckning_nn_1 : N ;
  handuppraeckning_nn_1 : N ;
  handvolt_nn_1 : N ;
  hane_nn_1 : N ;
  hanegaell_nn_1 : N ;
  hang_nn_1 : N ;
  hangar_nn_1 : N ;
  hangarfartyg_nn_1 : N ;
  hank_nn_1 : N ;
  hanlig_av_1 : A ;
  hanne_nn_1 : N ;
  hanorgan_nn_1 : N ;
  hanrej_nn_1 : N ;
  hantel_nn_1 : N ;
  hantering_nn_1 : N ;
  hanteringskostnad_nn_1 : N ;
  hanteringsrisk_nn_1 : N ;
  hanterlig_av_1 : A ;
  hantlangare_nn_1 : N ;
  hantverk_nn_1 : N ;
  hantverkare_nn_1 : N ;
  hantverksarbetare_nn_1 : N ;
  hantverksfoerening_nn_1 : N ;
  hantverksmaessig_av_1 : A ;
  hantverksskicklighet_nn_1 : N ;
  happening_nn_1 : N ;
  haptoglobin_nn_1 : N ;
  harang_nn_1 : N ;
  hardangersoem_nn_1 : N ;
  hare_nn_1 : N ;
  harem_nn_1 : N ;
  harhanne_nn_1 : N ;
  harig_av_1 : A ;
  harkling_nn_1 : N ;
  harkrank_nn_1 : N ;
  harlekin_nn_1 : N ;
  harmfull_av_1 : A ;
  harmfylld_av_1 : A ;
  harmlig_av_1 : A ;
  harmloes_av_1 : A ;
  harmoni_nn_1 : N ;
  harmonisk_av_1 : A ;
  harmonium_nn_1 : N ;
  harmsen_av_1 : A ;
  harmynt_av_1 : A ;
  harnesk_nn_1 : N ;
  harpalt_nn_1 : N ;
  harpist_nn_1 : N ;
  harpun_nn_1 : N ;
  harr_nn_1 : N ;
  harskramla_nn_1 : N ;
  harspaar_nn_1 : N ;
  harstig_nn_1 : N ;
  hartass_nn_1 : N ;
  harts_nn_1 : N ;
  hartsfiol_nn_1 : N ;
  harv_nn_1 : N ;
  harvaerja_nn_1 : N ;
  has_nn_1 : N ;
  hasardspel_nn_1 : N ;
  haschcigarett_nn_1 : N ;
  hasp_nn_1 : N ;
  haspel_nn_1 : N ;
  hassel_nn_1 : N ;
  hasselmus_nn_1 : N ;
  hasselnoet_nn_1 : N ;
  hasselsnok_nn_1 : N ;
  hastig_av_1 : A ;
  hastighet_nn_1 : N ;
  hastighetsaakning_nn_1 : N ;
  hastighetsgraens_nn_1 : N ;
  hastighetskontroll_nn_1 : N ;
  hastighetsmaetare_nn_1 : N ;
  hastighetstaevling_nn_1 : N ;
  hastverk_nn_1 : N ;
  hatfull_av_1 : A ;
  hatfylld_av_1 : A ;
  hatisk_av_1 : A ;
  hatkaerlek_nn_1 : N ;
  hatt_nn_1 : N ;
  hattig_av_1 : A ;
  hattkulle_nn_1 : N ;
  hattstock_nn_1 : N ;
  hattsvamp_nn_1 : N ;
  haubits_nn_1 : N ;
  haubitz_nn_1 : N ;
  hausse_nn_1 : N ;
  hav_nn_1 : N ;
  havande_av_1 : A ;
  havandeskap_nn_1 : N ;
  haveri_nn_1 : N ;
  haverikommission_nn_1 : N ;
  haverist_nn_1 : N ;
  havreflarn_nn_1 : N ;
  havregryn_nn_1 : N ;
  havregrynsgroet_nn_1 : N ;
  havrekorn_nn_1 : N ;
  havreliknande_av_1 : A ;
  havsabborre_nn_1 : N ;
  havsanemon_nn_1 : N ;
  havsbad_nn_1 : N ;
  havsbotten_nn_1 : N ;
  havsbris_nn_1 : N ;
  havsdjup_nn_1 : N ;
  havsfaagel_nn_1 : N ;
  havsfru_nn_1 : N ;
  havsgud_nn_1 : N ;
  havsis_nn_1 : N ;
  havskappsegling_nn_1 : N ;
  havskatt_nn_1 : N ;
  havskraeftstjaert_nn_1 : N ;
  havskryssare_nn_1 : N ;
  havslax_nn_1 : N ;
  havsmus_nn_1 : N ;
  havsnivaa_nn_1 : N ;
  havsoern_nn_1 : N ;
  havsomraade_nn_1 : N ;
  havsstrand_nn_1 : N ;
  havsstroem_nn_1 : N ;
  havstrut_nn_1 : N ;
  havstulpan_nn_1 : N ;
  havsutter_nn_1 : N ;
  havsvaext_nn_1 : N ;
  havsvatten_nn_1 : N ;
  havsvik_nn_1 : N ;
  havtorn_nn_1 : N ;
  hawaiiansk_av_1 : A ;
  hawaiisk_av_1 : A ;
  he_man_nn_1 : N ;
  hearing_nn_1 : N ;
  heat_nn_1 : N ;
  hebre_nn_1 : N ;
  hebreisk_av_1 : A ;
  hed_nn_1 : N ;
  heden_av_1 : A ;
  hedendom_nn_1 : N ;
  hederlig_av_1 : A ;
  hedersam_av_1 : A ;
  hedersbetygelse_nn_1 : N ;
  hedersbevisning_nn_1 : N ;
  hedersdoktor_nn_1 : N ;
  hedersgaest_nn_1 : N ;
  hedersknyffel_nn_1 : N ;
  hederskodex_nn_1 : N ;
  hederskompani_nn_1 : N ;
  hedersledamot_nn_1 : N ;
  hedersman_nn_1 : N ;
  hedersmedlem_nn_1 : N ;
  hedersomnaemnande_nn_1 : N ;
  hedersord_nn_1 : N ;
  hederspris_nn_1 : N ;
  hederssak_nn_1 : N ;
  hedersskuld_nn_1 : N ;
  hedervaerd_av_1 : A ;
  hedning_nn_1 : N ;
  hednisk_av_1 : A ;
  hedonist_nn_1 : N ;
  hedonistisk_av_1 : A ;
  hedrande_av_1 : A ;
  hegemoni_nn_1 : N ;
  hejaklack_nn_1 : N ;
  hejare_nn_1 : N ;
  hejarklack_nn_1 : N ;
  hejdloes_av_1 : A ;
  hejduk_nn_1 : N ;
  hejdundrande_av_1 : A ;
  hejig_av_1 : A ;
  hekatomb_nn_1 : N ;
  hektar_nn_1 : N ;
  hektisk_av_1 : A ;
  hekto_nn_1 : N ;
  hektograf_nn_1 : N ;
  hektogram_nn_1 : N ;
  hektoliter_nn_1 : N ;
  hel_av_1 : A ;
  helaakersbygd_nn_1 : N ;
  helafton_nn_1 : N ;
  helautomatisk_av_1 : A ;
  helbild_nn_1 : N ;
  helbraegda_av_1 : A ;
  helbraegdagoerelse_nn_1 : N ;
  heldag_nn_1 : N ;
  heldaglig_av_1 : A ;
  heldragen_av_1 : A ;
  helfabrikat_nn_1 : N ;
  helfet_av_1 : A ;
  helfigur_nn_1 : N ;
  helfoersaekring_nn_1 : N ;
  helfransk_av_1 : A ;
  helg_nn_1 : N ;
  helgdag_nn_1 : N ;
  helgedom_nn_1 : N ;
  helgeraan_nn_1 : N ;
  helgfri_av_1 : A ;
  helgjuten_av_1 : A ;
  helgmaalsringning_nn_1 : N ;
  helgon_nn_1 : N ;
  helgonlegend_nn_1 : N ;
  helhet_nn_1 : N ;
  helhetsbild_nn_1 : N ;
  helhetsintryck_nn_1 : N ;
  helhetssyn_nn_1 : N ;
  helig_av_1 : A ;
  helikon_nn_1 : N ;
  helikopter_nn_1 : N ;
  helinackordering_nn_1 : N ;
  heliocentrisk_av_1 : A ;
  heliofob_av_1 : A ;
  heliograf_nn_1 : N ;
  heliostat_nn_1 : N ;
  heliotrop_nn_1 : N ;
  helkonserv_nn_1 : N ;
  helkroppsdos_nn_1 : N ;
  helkvaell_nn_1 : N ;
  hellen_nn_1 : N ;
  hellenistisk_av_1 : A ;
  hellensk_av_1 : A ;
  heller_ab_1 : Adv ;
  helljus_nn_1 : N ;
  hellre_ab_1 : Adv ;
  helnot_nn_1 : N ;
  helnykter_av_1 : A ;
  helomvaendning_nn_1 : N ;
  helsida_nn_1 : N ;
  helskaegg_nn_1 : N ;
  helskaeggsluffare_nn_1 : N ;
  helst_ab_1 : Adv ;
  helstekt_av_1 : A ;
  helsyskon_nn_1 : N ;
  heltaeckande_av_1 : A ;
  heltal_nn_1 : N ;
  heltid_nn_1 : N ;
  heltidsloen_nn_1 : N ;
  helton_nn_1 : N ;
  helvete_nn_1 : N ;
  helvetesmaskin_nn_1 : N ;
  helvetisk_av_1 : A ;
  hem_ab_1 : Adv ;
  hem_nn_1 : N ;
  hemaat_ab_1 : Adv ;
  hemarbetande_av_1 : A ;
  hematit_nn_1 : N ;
  hembaera_vb_1 : V ;
  hembageri_nn_1 : N ;
  hembakt_av_1 : A ;
  hembesoek_nn_1 : N ;
  hembitraede_nn_1 : N ;
  hembjuda_vb_1 : V ;
  hembraennare_nn_1 : N ;
  hembud_nn_1 : N ;
  hembygd_nn_1 : N ;
  hembygdsfoerening_nn_1 : N ;
  hembygdsgaard_nn_1 : N ;
  hemdator_nn_1 : N ;
  hemdragande_av_1 : A ;
  hemfalla_vb_1 : V ;
  hemfoersaekring_nn_1 : N ;
  hemfridsbrott_nn_1 : N ;
  hemgaang_nn_1 : N ;
  hemgalax_nn_1 : N ;
  hemgift_nn_1 : N ;
  hemgjord_av_1 : A ;
  hemhjaelp_nn_1 : N ;
  hemifraan_ab_1 : Adv ;
  heminredning_nn_1 : N ;
  hemisfaer_nn_1 : N ;
  hemkaer_av_1 : A ;
  hemkonsulent_nn_1 : N ;
  hemlaan_nn_1 : N ;
  hemland_nn_1 : N ;
  hemlig_av_1 : A ;
  hemligen_ab_1 : Adv ;
  hemlighaalla_vb_1 : V ;
  hemlighet_nn_1 : N ;
  hemlighetsfull_av_1 : A ;
  hemlighetsmakeri_nn_1 : N ;
  hemlighus_nn_1 : N ;
  hemligstaempel_nn_1 : N ;
  hemlock_nn_1 : N ;
  hemloes_av_1 : A ;
  hemma_ab_1 : Adv ;
  hemmadotter_nn_1 : N ;
  hemmafru_nn_1 : N ;
  hemmagjord_av_1 : A ;
  hemmahoerande_av_1 : A ;
  hemmakvaell_nn_1 : N ;
  hemmalag_nn_1 : N ;
  hemmaman_nn_1 : N ;
  hemman_nn_1 : N ;
  hemmansaegare_nn_1 : N ;
  hemmaplan_nn_1 : N ;
  hemmarock_nn_1 : N ;
  hemmastadd_av_1 : A ;
  hemmavid_ab_1 : Adv ;
  hemmiljoe_nn_1 : N ;
  hemoglobin_nn_1 : N ;
  hemort_nn_1 : N ;
  hemsamarit_nn_1 : N ;
  hemsjukvaardsbidrag_nn_1 : N ;
  hemsk_av_1 : A ;
  hemskillnad_nn_1 : N ;
  hemsoekelse_nn_1 : N ;
  hemspraak_nn_1 : N ;
  hemstad_nn_1 : N ;
  hemstaellning_nn_1 : N ;
  hemtam_av_1 : A ;
  hemtjaenst_nn_1 : N ;
  hemtrakt_nn_1 : N ;
  hemtrevlig_av_1 : A ;
  hemtrevnad_nn_1 : N ;
  hemulsman_nn_1 : N ;
  hemuppgift_nn_1 : N ;
  hemvaern_nn_1 : N ;
  hemvaevd_av_1 : A ;
  hemvist_nn_1 : N ;
  hen_nn_1 : N ;
  henry_nn_1 : N ;
  heparin_nn_1 : N ;
  hepatit_nn_1 : N ;
  heraldiker_nn_1 : N ;
  heraldisk_av_1 : A ;
  herbarium_nn_1 : N ;
  herbicid_nn_1 : N ;
  herdabrev_nn_1 : N ;
  herdaminne_nn_1 : N ;
  herde_nn_1 : N ;
  herdedikt_nn_1 : N ;
  herdefolk_nn_1 : N ;
  herdestund_nn_1 : N ;
  hereditaer_av_1 : A ;
  heresi_nn_1 : N ;
  heretiker_nn_1 : N ;
  heretisk_av_1 : A ;
  herkulisk_av_1 : A ;
  herm_nn_1 : N ;
  hermafrodit_nn_1 : N ;
  hermelin_nn_1 : N ;
  hermeneutiker_nn_1 : N ;
  hermeneutisk_av_1 : A ;
  hermetisk_av_1 : A ;
  heroin_nn_1 : N ;
  heroinist_nn_1 : N ;
  heroisk_av_1 : A ;
  heros_nn_1 : N ;
  herostratisk_av_1 : A ;
  herradoeme_nn_1 : N ;
  herrcykel_nn_1 : N ;
  herrdubbel_nn_1 : N ;
  herre_nn_1 : N ;
  herrefolk_nn_1 : N ;
  herrekipering_nn_1 : N ;
  herreloes_av_1 : A ;
  herresaete_nn_1 : N ;
  herrgaard_nn_1 : N ;
  herrgaardsost_nn_1 : N ;
  herrgaardsvagn_nn_1 : N ;
  herrnhutare_nn_1 : N ;
  herrsida_nn_1 : N ;
  herrsingel_nn_1 : N ;
  herrskap_nn_1 : N ;
  herrtidning_nn_1 : N ;
  hertig_nn_1 : N ;
  hertigdoeme_nn_1 : N ;
  hertiginna_nn_1 : N ;
  hertz_nn_1 : N ;
  hes_av_1 : A ;
  heshet_nn_1 : N ;
  het_av_1 : A ;
  hetaer_nn_1 : N ;
  heterodox_av_1 : A ;
  heterogen_av_1 : A ;
  heteroklis_nn_1 : N ;
  heteroklitisk_av_1 : A ;
  heterosexuell_av_1 : A ;
  heterotematisk_av_1 : A ;
  heterozygot_av_1 : A ;
  heterozygot_nn_1 : N ;
  hetman_nn_1 : N ;
  hetsig_av_1 : A ;
  hetsjakt_nn_1 : N ;
  hetsporre_nn_1 : N ;
  hettit_nn_1 : N ;
  hettitisk_av_1 : A ;
  hetvatten_nn_1 : N ;
  hetvin_nn_1 : N ;
  heuristisk_av_1 : A ;
  hexameter_nn_1 : N ;
  hibiskus_nn_1 : N ;
  hickning_nn_1 : N ;
  hierarki_nn_1 : N ;
  hierarkisk_av_1 : A ;
  hieratisk_av_1 : A ;
  hieroglyf_nn_1 : N ;
  higgspartikel_nn_1 : N ;
  hillebard_nn_1 : N ;
  himla_av_1 : A ;
  himlaboren_av_1 : A ;
  himlakropp_nn_1 : N ;
  himlastege_nn_1 : N ;
  himlastormande_av_1 : A ;
  himlastormare_nn_1 : N ;
  himmel_nn_1 : N ;
  himmelsblaa_av_1 : A ;
  himmelsfaerd_nn_1 : N ;
  himmelsk_av_1 : A ;
  himmelsobjekt_nn_1 : N ;
  himmelspol_nn_1 : N ;
  himmelssaeng_nn_1 : N ;
  himmelssfaer_nn_1 : N ;
  himmelsskriande_av_1 : A ;
  himmelsvid_av_1 : A ;
  hind_nn_1 : N ;
  hinder_nn_1 : N ;
  hinderbock_nn_1 : N ;
  hinderloepning_nn_1 : N ;
  hinderloes_av_1 : A ;
  hindersam_av_1 : A ;
  hindersproevning_nn_1 : N ;
  hindertrick_nn_1 : N ;
  hindu_nn_1 : N ;
  hinduisk_av_1 : A ;
  hingst_nn_1 : N ;
  hink_nn_1 : N ;
  hinkvis_ab_1 : Adv ;
  hinna_vb_1 : V ;
  hipp_av_1 : A ;
  hippie_nn_1 : N ;
  hippodrom_nn_1 : N ;
  hippolog_nn_1 : N ;
  hippologisk_av_1 : A ;
  hird_nn_1 : N ;
  hisklig_av_1 : A ;
  hispig_av_1 : A ;
  hiss_nn_1 : N ;
  hissinstallation_nn_1 : N ;
  hisskorg_nn_1 : N ;
  histamin_nn_1 : N ;
  histolog_nn_1 : N ;
  historia_nn_1 : N ;
  historiebok_nn_1 : N ;
  historieloes_av_1 : A ;
  historieskrivare_nn_1 : N ;
  historiett_nn_1 : N ;
  historik_nn_1 : N ;
  historiker_nn_1 : N ;
  historiograf_nn_1 : N ;
  historisk_av_1 : A ;
  histrion_nn_1 : N ;
  hit_ab_1 : Adv ;
  hit_nn_1 : N ;
  hitaat_ab_1 : Adv ;
  hithoerande_av_1 : A ;
  hitintills_ab_1 : Adv ;
  hittebarn_nn_1 : N ;
  hittilldags_ab_1 : Adv ;
  hittills_ab_1 : Adv ;
  hittillsvarande_av_1 : A ;
  hjaelm_nn_1 : N ;
  hjaelmprydnad_nn_1 : N ;
  hjaelp_nn_1 : N ;
  hjaelpare_nn_1 : N ;
  hjaelpbaat_nn_1 : N ;
  hjaelpfartyg_nn_1 : N ;
  hjaelpklass_nn_1 : N ;
  hjaelpkryssare_nn_1 : N ;
  hjaelplig_av_1 : A ;
  hjaelplinje_nn_1 : N ;
  hjaelploes_av_1 : A ;
  hjaelpmedel_nn_1 : N ;
  hjaelpmotor_nn_1 : N ;
  hjaelpsaendning_nn_1 : N ;
  hjaelpsam_av_1 : A ;
  hjaelpsamhet_nn_1 : N ;
  hjaelpspraak_nn_1 : N ;
  hjaelpverb_nn_1 : N ;
  hjaelpvetenskap_nn_1 : N ;
  hjaelte_nn_1 : N ;
  hjaeltedaad_nn_1 : N ;
  hjaeltemodig_av_1 : A ;
  hjaeltesaga_nn_1 : N ;
  hjaernaktivitet_nn_1 : N ;
  hjaernatrofi_nn_1 : N ;
  hjaernbalk_nn_1 : N ;
  hjaernbloedning_nn_1 : N ;
  hjaernbyte_nn_1 : N ;
  hjaerncell_nn_1 : N ;
  hjaerndel_nn_1 : N ;
  hjaerndoed_av_1 : A ;
  hjaernhinna_nn_1 : N ;
  hjaernhinneinflammation_nn_1 : N ;
  hjaerninflammation_nn_1 : N ;
  hjaernoperation_nn_1 : N ;
  hjaernsjukdom_nn_1 : N ;
  hjaernskaal_nn_1 : N ;
  hjaernskakning_nn_1 : N ;
  hjaernstam_nn_1 : N ;
  hjaernstorm_nn_1 : N ;
  hjaerntrust_nn_1 : N ;
  hjaerntumoer_nn_1 : N ;
  hjaernvindling_nn_1 : N ;
  hjaertaengslig_av_1 : A ;
  hjaertaktivitet_nn_1 : N ;
  hjaertans_ab_1 : Adv ;
  hjaertas_av_1 : A ;
  hjaertattack_nn_1 : N ;
  hjaertblad_nn_1 : N ;
  hjaerteangelaegenhet_nn_1 : N ;
  hjaertegod_av_1 : A ;
  hjaertegryn_nn_1 : N ;
  hjaertegull_nn_1 : N ;
  hjaertekrossare_nn_1 : N ;
  hjaerter_nn_1 : N ;
  hjaertesak_nn_1 : N ;
  hjaertesuck_nn_1 : N ;
  hjaertevaen_nn_1 : N ;
  hjaertfel_nn_1 : N ;
  hjaertformig_av_1 : A ;
  hjaertinfarkt_nn_1 : N ;
  hjaertinnerlig_av_1 : A ;
  hjaertklaff_nn_1 : N ;
  hjaertklappning_nn_1 : N ;
  hjaertknipande_av_1 : A ;
  hjaertkramp_nn_1 : N ;
  hjaertlig_av_1 : A ;
  hjaertligen_ab_1 : Adv ;
  hjaertljud_nn_1 : N ;
  hjaertloes_av_1 : A ;
  hjaertlungmaskin_nn_1 : N ;
  hjaertmussla_nn_1 : N ;
  hjaertnupen_av_1 : A ;
  hjaertoperation_nn_1 : N ;
  hjaertpunkt_nn_1 : N ;
  hjaertsaeck_nn_1 : N ;
  hjaertskaerande_av_1 : A ;
  hjaertslag_nn_1 : N ;
  hjaertslitande_av_1 : A ;
  hjaertstillande_av_1 : A ;
  hjaerttransplantation_nn_1 : N ;
  hjaertverksamhet_nn_1 : N ;
  hjaessbjudning_nn_1 : N ;
  hjon_nn_1 : N ;
  hjonelag_nn_1 : N ;
  hjord_nn_1 : N ;
  hjort_nn_1 : N ;
  hjortdjur_nn_1 : N ;
  hjortron_nn_1 : N ;
  hjortsadel_nn_1 : N ;
  hjul_nn_1 : N ;
  hjulaangare_nn_1 : N ;
  hjulbas_nn_1 : N ;
  hjulbent_av_1 : A ;
  hjuldjur_nn_1 : N ;
  hjulfjaedring_nn_1 : N ;
  hjulfoenster_nn_1 : N ;
  hjulkors_nn_1 : N ;
  hjullager_nn_1 : N ;
  hjulnav_nn_1 : N ;
  hjulspaar_nn_1 : N ;
  hjulupphaengning_nn_1 : N ;
  ho_nn_1 : N ;
  hobby_nn_1 : N ;
  hoeft_nn_1 : N ;
  hoeftben_nn_1 : N ;
  hoefthaallare_nn_1 : N ;
  hoeftled_nn_1 : N ;
  hoeftparti_nn_1 : N ;
  hoeg_av_1 : A ;
  hoeg_nn_1 : N ;
  hoegaffel_nn_1 : N ;
  hoegaktiv_av_1 : A ;
  hoegaktningsfull_av_1 : A ;
  hoegaktuell_av_1 : A ;
  hoegaltare_nn_1 : N ;
  hoegbaenk_nn_1 : N ;
  hoegben_nn_1 : N ;
  hoegblad_nn_1 : N ;
  hoegboren_av_1 : A ;
  hoegborg_nn_1 : N ;
  hoegborgerlig_av_1 : A ;
  hoegburen_av_1 : A ;
  hoegdjur_nn_1 : N ;
  hoegdragen_av_1 : A ;
  hoegeligen_ab_1 : Adv ;
  hoegenergikollision_nn_1 : N ;
  hoegerextremistisk_av_1 : A ;
  hoegerflygel_nn_1 : N ;
  hoegerhaent_av_1 : A ;
  hoegerhand_nn_1 : N ;
  hoegerkrok_nn_1 : N ;
  hoegerledare_nn_1 : N ;
  hoegerman_nn_1 : N ;
  hoegerparti_nn_1 : N ;
  hoegervind_nn_1 : N ;
  hoegervridning_nn_1 : N ;
  hoegexplosiv_av_1 : A ;
  hoegfaerdig_av_1 : A ;
  hoegfjaell_nn_1 : N ;
  hoegfjaellsomraade_nn_1 : N ;
  hoegfoernaem_av_1 : A ;
  hoegfoerraedare_nn_1 : N ;
  hoegfoerraederi_nn_1 : N ;
  hoegfrekvens_nn_1 : N ;
  hoegfrekvent_av_1 : A ;
  hoeggradig_av_1 : A ;
  hoeghastighetskamera_nn_1 : N ;
  hoeghet_nn_1 : N ;
  hoeghus_nn_1 : N ;
  hoeginkomsttagare_nn_1 : N ;
  hoegklassig_av_1 : A ;
  hoegkonjunktur_nn_1 : N ;
  hoegkultur_nn_1 : N ;
  hoegkvarter_nn_1 : N ;
  hoegkyrklig_av_1 : A ;
  hoeglaendare_nn_1 : N ;
  hoegland_nn_1 : N ;
  hoegljudd_av_1 : A ;
  hoegmaalsbrott_nn_1 : N ;
  hoegmodig_av_1 : A ;
  hoegmolekylaer_av_1 : A ;
  hoegoensklig_av_1 : A ;
  hoegoktanig_av_1 : A ;
  hoegplataa_nn_1 : N ;
  hoegrest_av_1 : A ;
  hoegrestaandskultur_nn_1 : N ;
  hoegrev_nn_1 : N ;
  hoegroed_av_1 : A ;
  hoegsaesong_nn_1 : N ;
  hoegsaete_nn_1 : N ;
  hoegsint_av_1 : A ;
  hoegskoleadjunkt_nn_1 : N ;
  hoegskolelektor_nn_1 : N ;
  hoegslaett_nn_1 : N ;
  hoegsommar_nn_1 : N ;
  hoegspaend_av_1 : A ;
  hoegspaenning_nn_1 : N ;
  hoegst_ab_1 : Adv ;
  hoegstadium_nn_1 : N ;
  hoegstaemd_av_1 : A ;
  hoegstbjudande_av_1 : A ;
  hoegtalare_nn_1 : N ;
  hoegteknologisk_av_1 : A ;
  hoegtflygande_av_1 : A ;
  hoegtid_nn_1 : N ;
  hoegtidlig_av_1 : A ;
  hoegtidlighaalla_vb_1 : V ;
  hoegtidlighet_nn_1 : N ;
  hoegtidsaar_nn_1 : N ;
  hoegtidsdag_nn_1 : N ;
  hoegtidsdraekt_nn_1 : N ;
  hoegtidsstund_nn_1 : N ;
  hoegtidstal_nn_1 : N ;
  hoegtravande_av_1 : A ;
  hoegtryck_nn_1 : N ;
  hoegtrycksrygg_nn_1 : N ;
  hoegtstaaende_av_1 : A ;
  hoegtysk_av_1 : A ;
  hoegvaelboren_av_1 : A ;
  hoegvaerdig_av_1 : A ;
  hoegvaext_av_1 : A ;
  hoegvakt_nn_1 : N ;
  hoegvall_nn_1 : N ;
  hoegvallskloever_nn_1 : N ;
  hoegvatten_nn_1 : N ;
  hoegvoerdig_av_1 : A ;
  hoegvoerdighet_nn_1 : N ;
  hoegvuxen_av_1 : A ;
  hoejd_nn_1 : N ;
  hoejdare_nn_1 : N ;
  hoejdbestaemning_nn_1 : N ;
  hoejdhopp_nn_1 : N ;
  hoejdhoppare_nn_1 : N ;
  hoejdhoppstaevling_nn_1 : N ;
  hoejdlaege_nn_1 : N ;
  hoejdmaetare_nn_1 : N ;
  hoejdmaetning_nn_1 : N ;
  hoejdpunkt_nn_1 : N ;
  hoejdrygg_nn_1 : N ;
  hoejdskillnad_nn_1 : N ;
  hoejdstraeckning_nn_1 : N ;
  hoejning_nn_1 : N ;
  hoek_nn_1 : N ;
  hoekare_nn_1 : N ;
  hoekeri_nn_1 : N ;
  hoeknatt_nn_1 : N ;
  hoelja_nn_1 : N ;
  hoelster_nn_1 : N ;
  hoens_nn_1 : N ;
  hoensaegg_nn_1 : N ;
  hoensbaer_nn_1 : N ;
  hoenseri_nn_1 : N ;
  hoensfaagel_nn_1 : N ;
  hoensgaard_nn_1 : N ;
  hoensig_av_1 : A ;
  hoensnaet_nn_1 : N ;
  hoerapparat_nn_1 : N ;
  hoerbar_av_1 : A ;
  hoerbarhet_nn_1 : N ;
  hoerbarligen_ab_1 : Adv ;
  hoerlur_nn_1 : N ;
  hoern_nn_1 : N ;
  hoernhus_nn_1 : N ;
  hoernpelare_nn_1 : N ;
  hoernsten_nn_1 : N ;
  hoerntand_nn_1 : N ;
  hoersaegen_nn_1 : N ;
  hoersaga_nn_1 : N ;
  hoersal_nn_1 : N ;
  hoersam_av_1 : A ;
  hoerselben_nn_1 : N ;
  hoerselklass_nn_1 : N ;
  hoerselorgan_nn_1 : N ;
  hoerspel_nn_1 : N ;
  hoertelefon_nn_1 : N ;
  hoesaate_nn_1 : N ;
  hoesaeck_nn_1 : N ;
  hoeskulle_nn_1 : N ;
  hoest_nn_1 : N ;
  hoestack_nn_1 : N ;
  hoestdagjaemning_nn_1 : N ;
  hoestlig_av_1 : A ;
  hoestsaesong_nn_1 : N ;
  hoestslakt_nn_1 : N ;
  hoesttermin_nn_1 : N ;
  hoestvaeder_nn_1 : N ;
  hoetapp_nn_1 : N ;
  hoetork_nn_1 : N ;
  hoevaalm_nn_1 : N ;
  hoevaendare_nn_1 : N ;
  hoevding_nn_1 : N ;
  hoevisk_av_1 : A ;
  hoevitsman_nn_1 : N ;
  hoevlig_av_1 : A ;
  hoevlighet_nn_1 : N ;
  hoevlighetsvisit_nn_1 : N ;
  hoj_nn_1 : N ;
  holdingbolag_nn_1 : N ;
  holistisk_av_1 : A ;
  holk_nn_1 : N ;
  hollaendare_nn_1 : N ;
  hollaendsk_av_1 : A ;
  hollaendska_nn_2 : N ;
  holme_nn_1 : N ;
  holmgaang_nn_1 : N ;
  hologram_nn_1 : N ;
  holt_nn_1 : N ;
  homeopat_nn_1 : N ;
  homeopatisk_av_1 : A ;
  homerisk_av_1 : A ;
  homilet_nn_1 : N ;
  homiletisk_av_1 : A ;
  homofil_nn_1 : N ;
  homofon_av_1 : A ;
  homofon_nn_1 : N ;
  homogen_av_1 : A ;
  homogenitet_nn_1 : N ;
  homograf_av_1 : A ;
  homograf_nn_1 : N ;
  homolog_av_1 : A ;
  homonym_av_1 : A ;
  homonym_nn_1 : N ;
  homonymi_nn_1 : N ;
  homosexualitet_nn_1 : N ;
  homosexuell_av_1 : A ;
  homozygot_av_1 : A ;
  homozygot_nn_1 : N ;
  honduran_nn_1 : N ;
  honduransk_av_1 : A ;
  honlig_av_1 : A ;
  honnett_av_1 : A ;
  honnoer_nn_1 : N ;
  honnoersbetyg_nn_1 : N ;
  honnoersbord_nn_1 : N ;
  honnoersord_nn_1 : N ;
  honnoerspost_nn_1 : N ;
  honoraer_av_1 : A ;
  honorar_nn_1 : N ;
  honungslen_av_1 : A ;
  honungsmelon_nn_1 : N ;
  honungsskivling_nn_1 : N ;
  hop_nn_1 : N ;
  hopbiten_av_1 : A ;
  hopblandning_nn_1 : N ;
  hopbyggd_av_1 : A ;
  hopdragning_nn_1 : N ;
  hopfaellbar_av_1 : A ;
  hopfaelld_av_1 : A ;
  hopklumpning_nn_1 : N ;
  hopknaeppt_av_1 : A ;
  hopknyta_vb_1 : V ;
  hopkok_nn_1 : N ;
  hopkommen_av_1 : A ;
  hopkoppling_nn_1 : N ;
  hopkrupen_av_1 : A ;
  hoplit_nn_1 : N ;
  hopp_i_landkalle_nn_1 : N ;
  hopp_nn_1 : N ;
  hoppare_nn_1 : N ;
  hoppbacke_nn_1 : N ;
  hoppeligen_ab_1 : Adv ;
  hoppfoersoek_nn_1 : N ;
  hoppfull_av_1 : A ;
  hoppig_av_1 : A ;
  hoppingivande_av_1 : A ;
  hoppledare_nn_1 : N ;
  hopploes_av_1 : A ;
  hopploeshet_nn_1 : N ;
  hopprep_nn_1 : N ;
  hoppstaellning_nn_1 : N ;
  hoppstjaert_nn_1 : N ;
  hopptorn_nn_1 : N ;
  hopptraening_nn_1 : N ;
  hopsjunken_av_1 : A ;
  hopslagen_av_1 : A ;
  hopsnodd_av_1 : A ;
  hopsnoerd_av_1 : A ;
  hopsnoerpt_av_1 : A ;
  hopvaext_av_1 : A ;
  hopvika_vb_1 : V ;
  hopvuxen_av_1 : A ;
  horbock_nn_1 : N ;
  hord_nn_1 : N ;
  horhus_nn_1 : N ;
  horisont_nn_1 : N ;
  horisontal_av_1 : A ;
  horisontalplan_nn_1 : N ;
  horisontell_av_1 : A ;
  horisontproblem_nn_1 : N ;
  hormon_nn_1 : N ;
  hormonbalans_nn_1 : N ;
  hormonell_av_1 : A ;
  hormonfunktion_nn_1 : N ;
  hormonproduktion_nn_1 : N ;
  hormonsystem_nn_1 : N ;
  horn_nn_1 : N ;
  hornbaage_nn_1 : N ;
  hornhinna_nn_1 : N ;
  hornist_nn_1 : N ;
  hornliknande_av_1 : A ;
  hornloes_av_1 : A ;
  horologium_nn_1 : N ;
  horoskop_nn_1 : N ;
  horribel_av_1 : A ;
  horroer_nn_1 : N ;
  horsgoek_nn_1 : N ;
  horst_nn_1 : N ;
  hortonom_nn_1 : N ;
  hospital_nn_1 : N ;
  hospits_nn_1 : N ;
  hostanfall_nn_1 : N ;
  hostattack_nn_1 : N ;
  hostig_av_1 : A ;
  hostning_nn_1 : N ;
  hot_nn_1 : N ;
  hotbild_nn_1 : N ;
  hotell_nn_1 : N ;
  hotellbrand_nn_1 : N ;
  hotellgaest_nn_1 : N ;
  hotellpojke_nn_1 : N ;
  hotellrum_nn_1 : N ;
  hotelse_nn_1 : N ;
  hotfull_av_1 : A ;
  hottentotsk_av_1 : A ;
  hottentotska_nn_2 : N ;
  hottentott_nn_1 : N ;
  hov_nn_1 : N ;
  hov_nn_2 : N ;
  hovbeslag_nn_1 : N ;
  hovbetjaent_nn_1 : N ;
  hovdam_nn_1 : N ;
  hovdjur_nn_1 : N ;
  hovkapell_nn_1 : N ;
  hovleverantoer_nn_1 : N ;
  hovmaestare_nn_1 : N ;
  hovman_nn_1 : N ;
  hovmarskalk_nn_1 : N ;
  hovnarr_nn_1 : N ;
  hovnigning_nn_1 : N ;
  hovraett_nn_1 : N ;
  hovraettspresident_nn_1 : N ;
  hovraettsraad_nn_1 : N ;
  hovsam_av_1 : A ;
  hovslag_nn_1 : N ;
  hovslagare_nn_1 : N ;
  hovstat_nn_1 : N ;
  hovtaang_nn_1 : N ;
  hud_nn_1 : N ;
  hudfaerg_nn_1 : N ;
  hudflaeck_nn_1 : N ;
  hudinflammation_nn_1 : N ;
  hudkraem_nn_1 : N ;
  hudlager_nn_1 : N ;
  hudloes_av_1 : A ;
  hudmedel_nn_1 : N ;
  hudnaera_av_1 : A ;
  hudoemsning_nn_1 : N ;
  hudolja_nn_1 : N ;
  hudsjukdom_nn_1 : N ;
  hudtransplantation_nn_1 : N ;
  hudutslag_nn_1 : N ;
  hudvaenlig_av_1 : A ;
  hudveck_nn_1 : N ;
  hugenott_nn_1 : N ;
  hugg_nn_1 : N ;
  hugga_vb_1 : V ;
  huggare_nn_1 : N ;
  huggkrok_nn_1 : N ;
  huggkubb_nn_1 : N ;
  huggmejsel_nn_1 : N ;
  huggorm_nn_1 : N ;
  huggtand_nn_1 : N ;
  hugnad_nn_1 : N ;
  hugnesam_av_1 : A ;
  hugskott_nn_1 : N ;
  huld_av_1 : A ;
  huldra_nn_1 : N ;
  huligan_nn_1 : N ;
  hulk_nn_1 : N ;
  hulling_nn_1 : N ;
  hult_nn_1 : N ;
  human_av_1 : A ;
  humanekologisk_av_1 : A ;
  humaniora_nn_1 : N ;
  humanist_nn_1 : N ;
  humanistisk_av_1 : A ;
  humanitaer_av_1 : A ;
  humanitet_nn_1 : N ;
  humanvetenskap_nn_1 : N ;
  humbug_nn_1 : N ;
  humla_nn_1 : N ;
  humleblomster_nn_1 : N ;
  hummer_nn_1 : N ;
  humoer_nn_1 : N ;
  humoermaenniska_nn_1 : N ;
  humoerspelare_nn_1 : N ;
  humoresk_nn_1 : N ;
  humorist_nn_1 : N ;
  humoristisk_av_1 : A ;
  humusaemne_nn_1 : N ;
  humusbunden_av_1 : A ;
  humusfoerening_nn_1 : N ;
  humushalt_nn_1 : N ;
  humushaltig_av_1 : A ;
  humuskomponent_nn_1 : N ;
  humuskoncentration_nn_1 : N ;
  humussubstans_nn_1 : N ;
  humusvatten_nn_1 : N ;
  hund_nn_1 : N ;
  hundaar_nn_1 : N ;
  hundaexing_nn_1 : N ;
  hundben_nn_1 : N ;
  hundblick_nn_1 : N ;
  hunddjur_nn_1 : N ;
  hundhalsband_nn_1 : N ;
  hundhuvud_nn_1 : N ;
  hundhuvudet_ab_1 : Adv ;
  hundkaex_nn_2 : N ;
  hundkapploepning_nn_1 : N ;
  hundkex_nn_1 : N ;
  hundlort_nn_1 : N ;
  hundoera_nn_1 : N ;
  hundradel_nn_1 : N ;
  hundrafalt_ab_1 : Adv ;
  hundrakronorssedel_nn_1 : N ;
  hundralapp_nn_1 : N ;
  hundraprocentig_av_1 : A ;
  hundras_nn_1 : N ;
  hundratal_nn_1 : N ;
  hundratals_ab_1 : Adv ;
  hundratusental_nn_1 : N ;
  hundratusentonnare_nn_1 : N ;
  hundring_nn_1 : N ;
  hundskatt_nn_1 : N ;
  hundslaede_nn_1 : N ;
  hundvakt_nn_1 : N ;
  hundvalp_nn_1 : N ;
  hungerstrejk_nn_1 : N ;
  hungrig_av_1 : A ;
  hunner_nn_1 : N ;
  hur_ab_1 : Adv ;
  hurra_nn_1 : N ;
  hurrarop_nn_1 : N ;
  hurril_nn_1 : N ;
  hursomhelst_ab_1 : Adv ;
  hurtbulle_nn_1 : N ;
  hurtfrisk_av_1 : A ;
  hurtig_av_1 : A ;
  hurts_nn_1 : N ;
  huru_ab_1 : Adv ;
  huruledes_ab_1 : Adv ;
  hus_nn_1 : N ;
  husaegare_nn_1 : N ;
  husandakt_nn_1 : N ;
  husapotek_nn_1 : N ;
  husar_nn_1 : N ;
  husbaat_nn_1 : N ;
  husbehov_nn_1 : N ;
  husbil_nn_1 : N ;
  husbock_nn_1 : N ;
  husbonde_nn_1 : N ;
  husbygge_nn_1 : N ;
  husdjur_nn_1 : N ;
  husesyn_nn_1 : N ;
  husfader_nn_1 : N ;
  husfoerestaandarinna_nn_1 : N ;
  husfoerhoer_nn_1 : N ;
  husfru_nn_1 : N ;
  husgavel_nn_1 : N ;
  husgeraad_nn_1 : N ;
  husgrund_nn_1 : N ;
  husgud_nn_1 : N ;
  hushaall_nn_1 : N ;
  hushaallerska_nn_1 : N ;
  hushaallningssaellskap_nn_1 : N ;
  hushaallsassistent_nn_1 : N ;
  hushaallsost_nn_1 : N ;
  hushaallsrulle_nn_1 : N ;
  hushaallsvaag_nn_1 : N ;
  husknut_nn_1 : N ;
  huskors_nn_1 : N ;
  huskropp_nn_1 : N ;
  huskur_nn_1 : N ;
  huslaekare_nn_1 : N ;
  huslig_av_1 : A ;
  husmor_nn_1 : N ;
  husorgan_nn_1 : N ;
  husrannsakning_nn_1 : N ;
  husse_nn_1 : N ;
  hustimmer_nn_1 : N ;
  hustomte_nn_1 : N ;
  hustru_nn_1 : N ;
  hustrutillaegg_nn_1 : N ;
  hustyrann_nn_1 : N ;
  husundersoekning_nn_1 : N ;
  husvagn_nn_1 : N ;
  husvill_av_1 : A ;
  hutch_nn_1 : N ;
  hutloes_av_1 : A ;
  hutt_nn_1 : N ;
  huv_nn_1 : N ;
  huvud_nn_1 : N ;
  huvudaemne_nn_1 : N ;
  huvudanstalt_nn_1 : N ;
  huvudavtal_nn_1 : N ;
  huvudaxel_nn_1 : N ;
  huvudbjudning_nn_1 : N ;
  huvudbok_nn_1 : N ;
  huvudbonad_nn_1 : N ;
  huvudbyggnad_nn_1 : N ;
  huvuddel_nn_1 : N ;
  huvuddrag_nn_1 : N ;
  huvudentre_nn_1 : N ;
  huvudfigur_nn_1 : N ;
  huvudfoerhandling_nn_1 : N ;
  huvudform_nn_1 : N ;
  huvudfunktion_nn_1 : N ;
  huvudgaerd_nn_1 : N ;
  huvudingaang_nn_1 : N ;
  huvudinkomst_nn_1 : N ;
  huvudinnehaall_nn_1 : N ;
  huvudjaegare_nn_1 : N ;
  huvudkontor_nn_1 : N ;
  huvudkvarter_nn_1 : N ;
  huvudlaerare_nn_1 : N ;
  huvudlag_nn_1 : N ;
  huvudled_nn_1 : N ;
  huvudledning_nn_1 : N ;
  huvudlinje_nn_1 : N ;
  huvudloes_av_1 : A ;
  huvudman_nn_1 : N ;
  huvudmoment_nn_1 : N ;
  huvudnaering_nn_1 : N ;
  huvudnyckel_nn_1 : N ;
  huvudord_nn_1 : N ;
  huvudorsak_nn_1 : N ;
  huvudperson_nn_1 : N ;
  huvudpunkt_nn_1 : N ;
  huvudraett_nn_1 : N ;
  huvudregel_nn_1 : N ;
  huvudroll_nn_1 : N ;
  huvudrollsinnehavare_nn_1 : N ;
  huvudsak_nn_1 : N ;
  huvudsaklig_av_1 : A ;
  huvudsakligen_ab_1 : Adv ;
  huvudsats_nn_1 : N ;
  huvudskaal_nn_1 : N ;
  huvudskael_nn_1 : N ;
  huvudskakning_nn_1 : N ;
  huvudstad_nn_1 : N ;
  huvudstol_nn_1 : N ;
  huvudstroembrytare_nn_1 : N ;
  huvudstupa_ab_1 : Adv ;
  huvudsvaal_nn_1 : N ;
  huvudtema_nn_1 : N ;
  huvudtitel_nn_1 : N ;
  huvudton_nn_1 : N ;
  huvuduppgift_nn_1 : N ;
  huvudverb_nn_1 : N ;
  huvudvittne_nn_1 : N ;
  hyacint_nn_1 : N ;
  hybrid_nn_1 : N ;
  hycklare_nn_1 : N ;
  hyckleri_nn_1 : N ;
  hydrat_nn_1 : N ;
  hydraulisk_av_1 : A ;
  hydrodynamisk_av_1 : A ;
  hydrofob_av_1 : A ;
  hydrofon_nn_1 : N ;
  hydrofor_nn_1 : N ;
  hydrofyt_nn_1 : N ;
  hydrokopter_nn_1 : N ;
  hydrokultur_nn_1 : N ;
  hydrolog_nn_1 : N ;
  hydrologisk_av_1 : A ;
  hydrolys_nn_1 : N ;
  hydroplan_nn_1 : N ;
  hydrostatisk_av_1 : A ;
  hydroxid_nn_1 : N ;
  hydroxidjon_nn_1 : N ;
  hyende_nn_1 : N ;
  hyf_nn_1 : N ;
  hygge_nn_1 : N ;
  hyggesbraenning_nn_1 : N ;
  hygglig_av_1 : A ;
  hygglo_nn_1 : N ;
  hygienisk_av_1 : A ;
  hygienist_nn_1 : N ;
  hygrograf_nn_1 : N ;
  hygrometer_nn_1 : N ;
  hygroskopisk_av_1 : A ;
  hyllmeter_nn_1 : N ;
  hyllning_nn_1 : N ;
  hyllningsdikt_nn_1 : N ;
  hyllningssaang_nn_1 : N ;
  hymn_nn_1 : N ;
  hyperbel_nn_1 : N ;
  hyperbol_nn_1 : N ;
  hyperbolisk_av_1 : A ;
  hyperbore_nn_1 : N ;
  hyperit_nn_1 : N ;
  hyperkaenslig_av_1 : A ;
  hyperkatalektisk_av_1 : A ;
  hyperkorrekt_av_1 : A ;
  hypermodern_av_1 : A ;
  hypersvecism_nn_1 : N ;
  hypertrofi_nn_1 : N ;
  hypnos_nn_1 : N ;
  hypnotisk_av_1 : A ;
  hypnotisoer_nn_1 : N ;
  hypofys_nn_1 : N ;
  hypofyshormon_nn_1 : N ;
  hypokonder_nn_1 : N ;
  hypokondri_nn_1 : N ;
  hypokondriker_nn_1 : N ;
  hypokondrisk_av_1 : A ;
  hypokrit_nn_1 : N ;
  hypokritisk_av_1 : A ;
  hypotaktisk_av_1 : A ;
  hypotek_nn_1 : N ;
  hypotekslaan_nn_1 : N ;
  hypotes_nn_1 : N ;
  hypotetisk_av_1 : A ;
  hypsometer_nn_1 : N ;
  hyresgaest_nn_1 : N ;
  hyreshaj_nn_1 : N ;
  hyreshus_nn_1 : N ;
  hyreskasern_nn_1 : N ;
  hyreskontrakt_nn_1 : N ;
  hyreslaegenhet_nn_1 : N ;
  hyresnaemnd_nn_1 : N ;
  hyresreglering_nn_1 : N ;
  hyrestillaegg_nn_1 : N ;
  hyrestvist_nn_1 : N ;
  hyresvaerd_nn_1 : N ;
  hyss_nn_1 : N ;
  hysteriker_nn_1 : N ;
  hysterisk_av_1 : A ;
  hytt_nn_1 : N ;
  hyvel_nn_1 : N ;
  hyvelbaenk_nn_1 : N ;
  hyveljaern_nn_1 : N ;
  hyvelspaan_nn_1 : N ;
  hyvelstaal_nn_1 : N ;
  hyvens_av_1 : A ;
  i_ab_1 : Adv ;
  i_land_nn_1 : N ;
  iaktta_vb_1 : V ;
  iakttagare_nn_1 : N ;
  iakttagelse_nn_1 : N ;
  iberisk_av_1 : A ;
  ibero_amerikansk_av_1 : A ;
  ibidem_ab_1 : Adv ;
  ibis_nn_1 : N ;
  ibisfaagel_nn_1 : N ;
  ibland_ab_1 : Adv ;
  icing_nn_1 : N ;
  icke_ab_1 : Adv ;
  icke_angreppspakt_nn_1 : N ;
  icke_darwinistisk_av_1 : A ;
  icke_euklidisk_av_1 : A ;
  icke_existerande_av_1 : A ;
  icke_haendelse_nn_1 : N ;
  icke_individuell_av_1 : A ;
  icke_kristen_av_1 : A ;
  icke_linjaer_av_1 : A ;
  icke_metall_nn_1 : N ;
  icke_periodisk_av_1 : A ;
  icke_spridningsavtal_nn_1 : N ;
  icke_symmetrisk_av_1 : A ;
  id_nn_1 : N ;
  idag_ab_1 : Adv ;
  ide_nn_1 : N ;
  ideal_av_1 : A ;
  ideal_nn_1 : N ;
  idealisering_nn_1 : N ;
  idealisk_av_1 : A ;
  idealist_nn_1 : N ;
  idealistisk_av_1 : A ;
  idealitet_nn_1 : N ;
  idealvaerld_nn_1 : N ;
  ideassociation_nn_1 : N ;
  idedrama_nn_1 : N ;
  ideell_av_1 : A ;
  idegivare_nn_1 : N ;
  idegran_nn_1 : N ;
  ideklaeckning_nn_1 : N ;
  idel_ab_1 : Adv ;
  idelig_av_1 : A ;
  ideligen_ab_1 : Adv ;
  idemoete_nn_1 : N ;
  identifiering_nn_1 : N ;
  identifikation_nn_1 : N ;
  identisk_av_1 : A ;
  identitet_nn_1 : N ;
  identitetskort_nn_1 : N ;
  ideografisk_av_1 : A ;
  ideogram_nn_1 : N ;
  ideolog_nn_1 : N ;
  ideologi_nn_1 : N ;
  ideologisk_av_1 : A ;
  iderik_av_1 : A ;
  idevaerld_nn_1 : N ;
  idiolekt_nn_1 : N ;
  idiom_nn_1 : N ;
  idiomatisk_av_1 : A ;
  idiopatisk_av_1 : A ;
  idiosynkrasi_nn_1 : N ;
  idiot_nn_1 : N ;
  idioti_nn_1 : N ;
  idiotisk_av_1 : A ;
  idiotsaeker_av_1 : A ;
  idisslare_nn_1 : N ;
  idkare_nn_1 : N ;
  idog_av_1 : A ;
  idol_nn_1 : N ;
  idrott_nn_1 : N ;
  idrottsdag_nn_1 : N ;
  idrottsdraekt_nn_1 : N ;
  idrottsfoerening_nn_1 : N ;
  idrottsgren_nn_1 : N ;
  idrottsgymnasium_nn_1 : N ;
  idrottshall_nn_1 : N ;
  idrottsklubb_nn_1 : N ;
  idrottskompani_nn_1 : N ;
  idrottskvinna_nn_1 : N ;
  idrottslig_av_1 : A ;
  idrottsman_nn_1 : N ;
  idrottsplats_nn_1 : N ;
  idrottsroerelse_nn_1 : N ;
  idrottssko_nn_1 : N ;
  idrottstaevling_nn_1 : N ;
  idyll_nn_1 : N ;
  idylliker_nn_1 : N ;
  idyllisk_av_1 : A ;
  ifatt_ab_1 : Adv ;
  ifjol_ab_1 : Adv ;
  ifraaga_ab_1 : Adv ;
  ifraagakomma_vb_1 : V ;
  ifraagavarande_av_1 : A ;
  ifraan_ab_1 : Adv ;
  ifred_ab_1 : Adv ;
  ifyllnadsprov_nn_1 : N ;
  igaang_ab_1 : Adv ;
  igaangsaettning_nn_1 : N ;
  igaar_ab_1 : Adv ;
  igel_nn_1 : N ;
  igelkott_nn_1 : N ;
  igen_ab_1 : Adv ;
  igengrodd_av_1 : A ;
  igenkaennande_av_1 : A ;
  igenkaenningstecken_nn_1 : N ;
  igenkaennlig_av_1 : A ;
  igenmulen_av_1 : A ;
  igenom_ab_1 : Adv ;
  igenvaext_av_1 : A ;
  igenvuxen_av_1 : A ;
  igloo_nn_1 : N ;
  ignorant_av_1 : A ;
  ignorant_nn_1 : N ;
  ihaag_ab_1 : Adv ;
  ihaagkomma_vb_1 : V ;
  ihaalig_av_1 : A ;
  ihaalighet_nn_1 : N ;
  ihaallande_av_1 : A ;
  ihaerdig_av_1 : A ;
  ihjael_ab_1 : Adv ;
  ihop_ab_1 : Adv ;
  ikapp_ab_1 : Adv ;
  ikon_nn_1 : N ;
  ikonostas_nn_1 : N ;
  ikosaeder_nn_1 : N ;
  ikraft_ab_1 : Adv ;
  iktus_nn_1 : N ;
  iktyolog_nn_1 : N ;
  iktyologisk_av_1 : A ;
  ikull_ab_1 : Adv ;
  ikvaell_ab_1 : Adv ;
  il_nn_1 : N ;
  iland_ab_1 : Adv ;
  ilbud_nn_1 : N ;
  ilex_nn_1 : N ;
  illa_ab_1 : Adv ;
  illaluktande_av_1 : A ;
  illamaaende_av_1 : A ;
  illande_ab_1 : Adv ;
  illasmakande_av_1 : A ;
  illavarslande_av_1 : A ;
  illavulen_av_1 : A ;
  illbatting_nn_1 : N ;
  illdaad_nn_1 : N ;
  illegal_av_1 : A ;
  illegitim_av_1 : A ;
  iller_nn_1 : N ;
  illfundig_av_1 : A ;
  illgaerning_nn_1 : N ;
  illistig_av_1 : A ;
  illitterat_av_1 : A ;
  illmarig_av_1 : A ;
  illojal_av_1 : A ;
  illparig_av_1 : A ;
  illroed_av_1 : A ;
  illtjut_nn_1 : N ;
  illumination_nn_1 : N ;
  illusion_nn_1 : N ;
  illusionist_nn_1 : N ;
  illusionsfri_av_1 : A ;
  illusionsloes_av_1 : A ;
  illusionsnummer_nn_1 : N ;
  illusorisk_av_1 : A ;
  illuster_av_1 : A ;
  illustration_nn_1 : N ;
  illustrativ_av_1 : A ;
  illustratoer_nn_1 : N ;
  illvillig_av_1 : A ;
  illvraal_nn_1 : N ;
  illyr_nn_1 : N ;
  illyrisk_av_1 : A ;
  ilmarsch_nn_1 : N ;
  ilning_nn_1 : N ;
  ilsamtal_nn_1 : N ;
  ilsk_av_1 : A ;
  ilsken_av_1 : A ;
  imaginaer_av_1 : A ;
  imbecill_av_1 : A ;
  imitation_nn_1 : N ;
  imitatoer_nn_1 : N ;
  immanent_av_1 : A ;
  immateriell_av_1 : A ;
  immatrikulation_nn_1 : N ;
  immig_av_1 : A ;
  immigrant_nn_1 : N ;
  immobil_av_1 : A ;
  immun_av_1 : A ;
  immunitet_nn_1 : N ;
  immunolog_nn_1 : N ;
  immunologisk_av_1 : A ;
  impediment_nn_1 : N ;
  imperativ_nn_1 : N ;
  imperativ_nn_2 : N ;
  imperativisk_av_1 : A ;
  imperator_nn_1 : N ;
  imperatorisk_av_1 : A ;
  imperfektum_nn_1 : N ;
  imperialformat_nn_1 : N ;
  imperialist_nn_1 : N ;
  imperialistisk_av_1 : A ;
  imperialoktav_nn_1 : N ;
  imperialsaeng_nn_1 : N ;
  imperium_nn_1 : N ;
  impertinens_nn_1 : N ;
  impertinent_av_1 : A ;
  implicit_av_1 : A ;
  implikation_nn_1 : N ;
  implosion_nn_1 : N ;
  imponderabilia_nn_1 : N ;
  imponerande_av_1 : A ;
  impopulaer_av_1 : A ;
  impopularitet_nn_1 : N ;
  import_nn_1 : N ;
  importavgift_nn_1 : N ;
  importfoerbud_nn_1 : N ;
  importkvot_nn_1 : N ;
  importoer_nn_1 : N ;
  imposant_av_1 : A ;
  impost_nn_1 : N ;
  impotent_av_1 : A ;
  impregnering_nn_1 : N ;
  impressario_nn_1 : N ;
  impressionist_nn_1 : N ;
  impressionistisk_av_1 : A ;
  improduktiv_av_1 : A ;
  impromptu_nn_1 : N ;
  improvisation_nn_1 : N ;
  improvisatoer_nn_1 : N ;
  improvisatorisk_av_1 : A ;
  impuls_nn_1 : N ;
  impulsiv_av_1 : A ;
  impulsivitet_nn_1 : N ;
  impulskoep_nn_1 : N ;
  imroer_nn_1 : N ;
  in_ab_1 : Adv ;
  inaat_ab_1 : Adv ;
  inaatvaend_av_1 : A ;
  inackordering_nn_1 : N ;
  inackorderingshem_nn_1 : N ;
  inadekvat_av_1 : A ;
  inadvertens_nn_1 : N ;
  inaega_nn_1 : N ;
  inaelvsmask_nn_1 : N ;
  inaktiv_av_1 : A ;
  inaktivitet_nn_1 : N ;
  inaktuell_av_1 : A ;
  inalles_ab_1 : Adv ;
  inandning_nn_1 : N ;
  inauguration_nn_1 : N ;
  inbegrepp_nn_1 : N ;
  inbegripa_vb_1 : V ;
  inbegripen_av_1 : A ;
  inbesparing_nn_1 : N ;
  inbetalning_nn_1 : N ;
  inbetalningskort_nn_1 : N ;
  inbillning_nn_1 : N ;
  inbillningsfoster_nn_1 : N ;
  inbillningssjuk_av_1 : A ;
  inbilsk_av_1 : A ;
  inbiten_av_1 : A ;
  inbjuda_vb_1 : V ;
  inbjudande_av_1 : A ;
  inbjudning_nn_1 : N ;
  inbjudningskort_nn_1 : N ;
  inbjudningsskrift_nn_1 : N ;
  inblandning_nn_1 : N ;
  inblick_nn_1 : N ;
  inboerdes_av_1 : A ;
  inboerdeskrig_nn_1 : N ;
  inbokning_nn_1 : N ;
  inbringande_av_1 : A ;
  inbromsning_nn_1 : N ;
  inbrott_nn_1 : N ;
  inbrottstjuv_nn_1 : N ;
  inbrytning_nn_1 : N ;
  inbuktning_nn_1 : N ;
  inbunden_av_1 : A ;
  inbyggare_nn_1 : N ;
  inbyggd_av_1 : A ;
  inbyte_nn_1 : N ;
  incest_nn_1 : N ;
  incestuoes_av_1 : A ;
  incident_nn_1 : N ;
  incitament_nn_1 : N ;
  indefinit_av_1 : A ;
  indelning_nn_1 : N ;
  indelningsgrund_nn_1 : N ;
  indelningsverk_nn_1 : N ;
  indelt_av_1 : A ;
  independent_nn_1 : N ;
  index_nn_1 : N ;
  indexavtal_nn_1 : N ;
  indian_nn_1 : N ;
  indianfolk_nn_1 : N ;
  indianhoevding_nn_1 : N ;
  indiankvinna_nn_1 : N ;
  indianreservat_nn_1 : N ;
  indiansk_av_1 : A ;
  indianska_nn_1 : N ;
  indiansommar_nn_1 : N ;
  indianstam_nn_1 : N ;
  indiantjut_nn_1 : N ;
  indicium_nn_1 : N ;
  indier_nn_1 : N ;
  indifferent_av_1 : A ;
  indifferentism_nn_1 : N ;
  indikation_nn_1 : N ;
  indikativ_av_1 : A ;
  indikativ_nn_1 : N ;
  indikator_nn_1 : N ;
  indikering_nn_1 : N ;
  indirekt_av_1 : A ;
  indisk_av_1 : A ;
  indiska_nn_1 : N ;
  indiskret_av_1 : A ;
  indiskretion_nn_1 : N ;
  indisponibel_av_1 : A ;
  individ_nn_1 : N ;
  individualist_nn_1 : N ;
  individualistisk_av_1 : A ;
  individualitet_nn_1 : N ;
  individuell_av_1 : A ;
  indoeurope_nn_1 : N ;
  indoeuropeisk_av_1 : A ;
  indokinesisk_av_1 : A ;
  indoktrinering_nn_1 : N ;
  indolent_av_1 : A ;
  indolog_nn_1 : N ;
  indones_nn_1 : N ;
  indonesisk_av_1 : A ;
  indra_vb_1 : V ;
  indraektig_av_1 : A ;
  indrag_nn_1 : N ;
  indragning_nn_1 : N ;
  indriva_vb_1 : V ;
  indrivning_nn_1 : N ;
  induktion_nn_1 : N ;
  induktionsapparat_nn_1 : N ;
  induktionsspole_nn_1 : N ;
  induktiv_av_1 : A ;
  induktor_nn_1 : N ;
  industri_nn_1 : N ;
  industriaktie_nn_1 : N ;
  industrialisering_nn_1 : N ;
  industriarbetare_nn_1 : N ;
  industriell_av_1 : A ;
  industrifoerbund_nn_1 : N ;
  industriland_nn_1 : N ;
  industriolja_nn_1 : N ;
  industriomraade_nn_1 : N ;
  industriprodukt_nn_1 : N ;
  industriregion_nn_1 : N ;
  industrirobot_nn_1 : N ;
  industrisemester_nn_1 : N ;
  ineffektiv_av_1 : A ;
  inexakt_av_1 : A ;
  infall_nn_1 : N ;
  infalla_vb_1 : V ;
  infallen_av_1 : A ;
  infallsrik_av_1 : A ;
  infallsvinkel_nn_1 : N ;
  infam_av_1 : A ;
  infami_nn_1 : N ;
  infant_nn_1 : N ;
  infanterikompani_nn_1 : N ;
  infanterist_nn_1 : N ;
  infantil_av_1 : A ;
  infantinna_nn_1 : N ;
  infarkt_nn_1 : N ;
  infart_nn_1 : N ;
  infartsled_nn_1 : N ;
  infartsport_nn_1 : N ;
  infattning_nn_1 : N ;
  infektioes_av_1 : A ;
  infektion_nn_1 : N ;
  infektionshaerd_nn_1 : N ;
  infektionssjukdom_nn_1 : N ;
  infernalisk_av_1 : A ;
  inferno_nn_1 : N ;
  infiltration_nn_1 : N ;
  infiltratoer_nn_1 : N ;
  infinit_av_1 : A ;
  infinitiv_nn_1 : N ;
  infinitivmaerke_nn_1 : N ;
  infinna_vb_1 : V ;
  infix_nn_1 : N ;
  inflammation_nn_1 : N ;
  inflammationshaerd_nn_1 : N ;
  inflammatorisk_av_1 : A ;
  inflationistisk_av_1 : A ;
  inflationsdrivande_av_1 : A ;
  inflationsfas_nn_1 : N ;
  inflationsmodell_nn_1 : N ;
  inflationsskydd_nn_1 : N ;
  inflationsspiral_nn_1 : N ;
  inflationstakt_nn_1 : N ;
  inflationsteori_nn_1 : N ;
  inflatorisk_av_1 : A ;
  influens_nn_1 : N ;
  influensmaskin_nn_1 : N ;
  inflygning_nn_1 : N ;
  inflyta_vb_1 : V ;
  inflytande_nn_1 : N ;
  inflytelse_nn_1 : N ;
  inflytelserik_av_1 : A ;
  inflyttning_nn_1 : N ;
  infoedd_av_1 : A ;
  infoeding_nn_1 : N ;
  infoerande_nn_1 : N ;
  infoerstaadd_av_1 : A ;
  infordring_nn_1 : N ;
  informant_nn_1 : N ;
  information_nn_1 : N ;
  informationsbehandling_nn_1 : N ;
  informationsbyraa_nn_1 : N ;
  informationsrik_av_1 : A ;
  informationssoekning_nn_1 : N ;
  informativ_av_1 : A ;
  informatoer_nn_1 : N ;
  informator_nn_1 : N ;
  informell_av_1 : A ;
  infragrill_nn_1 : N ;
  infraljud_nn_1 : N ;
  infraroed_av_1 : A ;
  infrastruktur_nn_1 : N ;
  infrusen_av_1 : A ;
  infusion_nn_1 : N ;
  infusionsdjur_nn_1 : N ;
  ingaa_vb_1 : V ;
  ingaaende_av_1 : A ;
  ingaang_nn_1 : N ;
  ingaangsmarsch_nn_1 : N ;
  ingaangspsalm_nn_1 : N ;
  ingaeld_nn_1 : N ;
  ingalunda_ab_1 : Adv ;
  inge_vb_1 : V ;
  ingefaersvaext_nn_1 : N ;
  ingenium_nn_1 : N ;
  ingenjoer_nn_1 : N ;
  ingenjoerstrupp_nn_1 : N ;
  ingenjoersvetenskap_nn_1 : N ;
  ingenjoersvetenskapsakademi_nn_1 : N ;
  ingenstaedes_ab_1 : Adv ;
  ingenstans_ab_1 : Adv ;
  ingenvart_ab_1 : Adv ;
  ingeny_nn_1 : N ;
  ingift_av_1 : A ;
  ingifte_nn_1 : N ;
  ingivelse_nn_1 : N ;
  ingjuta_vb_1 : V ;
  ingoet_nn_1 : N ;
  ingrediens_nn_1 : N ;
  ingredierande_av_1 : A ;
  ingrepp_nn_1 : N ;
  ingress_nn_1 : N ;
  ingripande_nn_1 : N ;
  ingrodd_av_1 : A ;
  inhaegnad_nn_1 : N ;
  inhalation_nn_1 : N ;
  inhalator_nn_1 : N ;
  inhamn_nn_1 : N ;
  inhav_nn_1 : N ;
  inhemsk_av_1 : A ;
  inherent_av_1 : A ;
  inhibitor_nn_1 : N ;
  inhopp_nn_1 : N ;
  inhoppare_nn_1 : N ;
  inhuman_av_1 : A ;
  inhysing_nn_1 : N ;
  inifraan_ab_1 : Adv ;
  initial_av_1 : A ;
  initial_nn_1 : N ;
  initialord_nn_1 : N ;
  initiation_nn_1 : N ;
  initiationsrit_nn_1 : N ;
  initiativ_nn_1 : N ;
  initiativrik_av_1 : A ;
  initiativtagare_nn_1 : N ;
  injektion_nn_1 : N ;
  injektor_nn_1 : N ;
  injurie_nn_1 : N ;
  ink_nn_1 : N ;
  inka_nn_1 : N ;
  inkaennande_av_1 : A ;
  inkaindian_nn_1 : N ;
  inkallelse_nn_1 : N ;
  inkallelsebrev_nn_1 : N ;
  inkallelseorder_nn_1 : N ;
  inkapabel_av_1 : A ;
  inkapsling_nn_1 : N ;
  inkarnation_nn_1 : N ;
  inkast_nn_1 : N ;
  inkiett_av_1 : A ;
  inklination_nn_1 : N ;
  inklinationsnaal_nn_1 : N ;
  inkoativ_av_1 : A ;
  inkoep_nn_1 : N ;
  inkoepare_nn_1 : N ;
  inkoepsavdelning_nn_1 : N ;
  inkoepspris_nn_1 : N ;
  inkoerd_av_1 : A ;
  inkoerning_nn_1 : N ;
  inkoerningsperiod_nn_1 : N ;
  inkoersport_nn_1 : N ;
  inkognito_ab_1 : Adv ;
  inkomma_vb_1 : V ;
  inkommensurabel_av_1 : A ;
  inkompatibel_av_1 : A ;
  inkompetent_av_1 : A ;
  inkomst_nn_1 : N ;
  inkomstbegrepp_nn_1 : N ;
  inkomstberoende_av_1 : A ;
  inkomstbeskattning_nn_1 : N ;
  inkomstbortfall_nn_1 : N ;
  inkomstbringande_av_1 : A ;
  inkomstintervall_nn_1 : N ;
  inkomstkort_nn_1 : N ;
  inkomstmaatt_nn_1 : N ;
  inkomstoekning_nn_1 : N ;
  inkomstskatt_nn_1 : N ;
  inkomstslag_nn_1 : N ;
  inkomsttagare_nn_1 : N ;
  inkomsttaxering_nn_1 : N ;
  inkongruens_nn_1 : N ;
  inkongruent_av_1 : A ;
  inkonsekvens_nn_1 : N ;
  inkonsekvent_av_1 : A ;
  inkontinent_av_1 : A ;
  inkorrekt_av_1 : A ;
  inkraektare_nn_1 : N ;
  inkroekt_av_1 : A ;
  inkrustation_nn_1 : N ;
  inkubationstid_nn_1 : N ;
  inkunabel_nn_1 : N ;
  inkurant_av_1 : A ;
  inkvartering_nn_1 : N ;
  inkvisitor_nn_1 : N ;
  inkvisitorisk_av_1 : A ;
  inlaaning_nn_1 : N ;
  inlaegg_nn_1 : N ;
  inlaeggning_nn_1 : N ;
  inlaemning_nn_1 : N ;
  inlaemningsdag_nn_1 : N ;
  inlaendsk_av_1 : A ;
  inlaerningsplataa_nn_1 : N ;
  inlaerningsresultat_nn_1 : N ;
  inlaerningsstudio_nn_1 : N ;
  inlaesning_nn_1 : N ;
  inlaest_av_1 : A ;
  inlagd_av_1 : A ;
  inlandsis_nn_1 : N ;
  inledande_av_1 : A ;
  inledare_nn_1 : N ;
  inledning_nn_1 : N ;
  inledningsvis_ab_1 : Adv ;
  inljud_nn_1 : N ;
  inlopp_nn_1 : N ;
  inmaetning_nn_1 : N ;
  inmarsch_nn_1 : N ;
  inmatning_nn_1 : N ;
  inmoenstring_nn_1 : N ;
  inmutning_nn_1 : N ;
  innan_ab_1 : Adv ;
  innandoeme_nn_1 : N ;
  innanfoer_ab_1 : Adv ;
  innanhav_nn_1 : N ;
  innanlaar_nn_1 : N ;
  innanlaesning_nn_1 : N ;
  innanmaete_nn_1 : N ;
  innantill_ab_1 : Adv ;
  inne_ab_1 : Adv ;
  inne_av_1 : A ;
  inneboende_av_1 : A ;
  inneboerd_nn_1 : N ;
  innebyggare_nn_1 : N ;
  innegrej_nn_1 : N ;
  innehaall_nn_1 : N ;
  innehaalla_vb_1 : V ;
  innehaallsanalys_nn_1 : N ;
  innehaallsdeklaration_nn_1 : N ;
  innehaallsfoerteckning_nn_1 : N ;
  innehaallslig_av_1 : A ;
  innehaallsloes_av_1 : A ;
  innehaallsobjekt_nn_1 : N ;
  innehaallsoeversikt_nn_1 : N ;
  innehaallsrik_av_1 : A ;
  innehaallstom_av_1 : A ;
  innehav_nn_1 : N ;
  innehavare_nn_1 : N ;
  innehavarpapper_nn_1 : N ;
  inneliggande_av_1 : A ;
  inner_nn_1 : N ;
  innerdoerr_nn_1 : N ;
  innerlig_av_1 : A ;
  innerligen_ab_1 : Adv ;
  inneroera_nn_1 : N ;
  innerskaer_nn_1 : N ;
  innerslang_nn_1 : N ;
  innerstad_nn_1 : N ;
  innertak_nn_1 : N ;
  innervaegg_nn_1 : N ;
  innervation_nn_1 : N ;
  innesittare_nn_1 : N ;
  innesluta_vb_1 : V ;
  inneslutning_nn_1 : N ;
  innestaaende_av_1 : A ;
  innevaanare_nn_1 : N ;
  innevarande_av_1 : A ;
  innoetning_nn_1 : N ;
  innovation_nn_1 : N ;
  innovativ_av_1 : A ;
  innovatoer_nn_1 : N ;
  inofficiell_av_1 : A ;
  inokulation_nn_1 : N ;
  inombordare_nn_1 : N ;
  inombords_ab_1 : Adv ;
  inombordsmotor_nn_1 : N ;
  inomhus_ab_1 : Adv ;
  inomhusforskning_nn_1 : N ;
  inomhusgolv_nn_1 : N ;
  inomhusidrott_nn_1 : N ;
  inomhusluft_nn_1 : N ;
  inomlands_ab_1 : Adv ;
  inomskaers_ab_1 : Adv ;
  inomvetenskaplig_av_1 : A ;
  inopportun_av_1 : A ;
  inpackning_nn_1 : N ;
  inpass_nn_1 : N ;
  inpetning_nn_1 : N ;
  inpiskare_nn_1 : N ;
  inpyrd_av_1 : A ;
  inraekning_nn_1 : N ;
  inraettning_nn_1 : N ;
  inramning_nn_1 : N ;
  inredning_nn_1 : N ;
  inredningsdetalj_nn_1 : N ;
  inremedicinsk_av_1 : A ;
  inremission_nn_1 : N ;
  inresekretorisk_av_1 : A ;
  inresetillstaand_nn_1 : N ;
  inresevisum_nn_1 : N ;
  inriggare_nn_1 : N ;
  inrikes_ab_1 : Adv ;
  inrikes_av_1 : A ;
  inrikesdepartement_nn_1 : N ;
  inrikesminister_nn_1 : N ;
  inrikespolitisk_av_1 : A ;
  inriktning_nn_1 : N ;
  inrim_nn_1 : N ;
  inristning_nn_1 : N ;
  inroestning_nn_1 : N ;
  inrop_nn_1 : N ;
  inropare_nn_1 : N ;
  inropning_nn_1 : N ;
  inryckning_nn_1 : N ;
  insaendare_nn_1 : N ;
  insaettning_nn_1 : N ;
  insamling_nn_1 : N ;
  insats_nn_1 : N ;
  insatslaegenhet_nn_1 : N ;
  inscenering_nn_1 : N ;
  insegel_nn_1 : N ;
  inseglingsfyr_nn_1 : N ;
  insekt_nn_1 : N ;
  insekticid_nn_1 : N ;
  insektsaetande_av_1 : A ;
  insektsaetare_nn_1 : N ;
  insektsbefruktning_nn_1 : N ;
  insektsbett_nn_1 : N ;
  insektsgift_nn_1 : N ;
  insektsmedel_nn_1 : N ;
  insektsnaal_nn_1 : N ;
  insektssamling_nn_1 : N ;
  insektssax_nn_1 : N ;
  insemination_nn_1 : N ;
  insida_nn_1 : N ;
  insikt_nn_1 : N ;
  insiktsfull_av_1 : A ;
  insinuant_av_1 : A ;
  insinuation_nn_1 : N ;
  insjoe_nn_1 : N ;
  insjoefisk_nn_1 : N ;
  insjungning_nn_1 : N ;
  insjunken_av_1 : A ;
  inskaerning_nn_1 : N ;
  inskjuta_vb_1 : V ;
  inskjutning_nn_1 : N ;
  inskolning_nn_1 : N ;
  inskott_nn_1 : N ;
  inskottsvokal_nn_1 : N ;
  inskraenkning_nn_1 : N ;
  inskraenkt_av_1 : A ;
  inskrift_nn_1 : N ;
  inskription_nn_1 : N ;
  inskriva_vb_1 : V ;
  inskrivning_nn_1 : N ;
  inskrivningsbok_nn_1 : N ;
  inskrivningsdomare_nn_1 : N ;
  inslaepp_nn_1 : N ;
  inslag_nn_1 : N ;
  inslagen_av_1 : A ;
  insmickrande_av_1 : A ;
  insmuggling_nn_1 : N ;
  insmyga_vb_1 : V ;
  insnitt_nn_1 : N ;
  insnodd_av_1 : A ;
  insoendring_nn_1 : N ;
  insolvent_av_1 : A ;
  inspark_nn_1 : N ;
  inspektion_nn_1 : N ;
  inspektoer_nn_1 : N ;
  inspektor_nn_1 : N ;
  inspelning_nn_1 : N ;
  inspelningsstudio_nn_1 : N ;
  inspicient_nn_1 : N ;
  inspiration_nn_1 : N ;
  inspiratoer_nn_1 : N ;
  inspraengd_av_1 : A ;
  insprutning_nn_1 : N ;
  insprutningsmotor_nn_1 : N ;
  instabil_av_1 : A ;
  instaellbar_av_1 : A ;
  instaellelse_nn_1 : N ;
  instaellning_nn_1 : N ;
  instaellsam_av_1 : A ;
  instaellsamhet_nn_1 : N ;
  instaemmande_nn_1 : N ;
  instaengd_av_1 : A ;
  installand_nn_1 : N ;
  installation_nn_1 : N ;
  installationsfoerelaesning_nn_1 : N ;
  installatoer_nn_1 : N ;
  installator_nn_1 : N ;
  instans_nn_1 : N ;
  instiftare_nn_1 : N ;
  instiftelse_nn_1 : N ;
  instinkt_nn_1 : N ;
  instinktiv_av_1 : A ;
  institut_nn_1 : N ;
  institution_nn_1 : N ;
  institutionell_av_1 : A ;
  instraalning_nn_1 : N ;
  instroem_nn_1 : N ;
  instruktion_nn_1 : N ;
  instruktiv_av_1 : A ;
  instruktoer_nn_1 : N ;
  instrument_nn_1 : N ;
  instrumental_av_1 : A ;
  instrumentalist_nn_1 : N ;
  instrumentarium_nn_1 : N ;
  instrumentation_nn_1 : N ;
  instrumentell_av_1 : A ;
  instrumentering_nn_1 : N ;
  instrumentflygning_nn_1 : N ;
  instrumentpanel_nn_1 : N ;
  instudering_nn_1 : N ;
  insufficiens_nn_1 : N ;
  insuga_vb_1 : V ;
  insugningsventil_nn_1 : N ;
  insulaer_av_1 : A ;
  insulin_nn_1 : N ;
  insulinchock_nn_1 : N ;
  insupa_vb_1 : V ;
  insurgent_nn_1 : N ;
  insvaengd_av_1 : A ;
  insvaengning_nn_1 : N ;
  insydd_av_1 : A ;
  inta_vb_1 : V ;
  intaag_nn_1 : N ;
  intaekt_nn_1 : N ;
  intaektschablon_nn_1 : N ;
  intag_nn_1 : N ;
  intagande_av_1 : A ;
  intagen_av_1 : A ;
  intagning_nn_1 : N ;
  intagsdamm_nn_1 : N ;
  intakt_av_1 : A ;
  intalan_nn_1 : N ;
  inte_ab_1 : Adv ;
  inteckning_nn_1 : N ;
  inteckningslaan_nn_1 : N ;
  integral_nn_1 : N ;
  integralkalkyl_nn_1 : N ;
  integrand_nn_1 : N ;
  integration_nn_1 : N ;
  integrerande_av_1 : A ;
  integrering_nn_1 : N ;
  integritet_nn_1 : N ;
  intellekt_nn_1 : N ;
  intellektualist_nn_1 : N ;
  intellektuell_av_1 : A ;
  intelligens_nn_1 : N ;
  intelligensaalder_nn_1 : N ;
  intelligensaristokrat_nn_1 : N ;
  intelligenskvot_nn_1 : N ;
  intelligensmaetning_nn_1 : N ;
  intelligenstest_nn_1 : N ;
  intelligent_av_1 : A ;
  intendent_nn_1 : N ;
  intendentur_nn_1 : N ;
  intendenturtjaenst_nn_1 : N ;
  intensitet_nn_1 : N ;
  intensiv_av_1 : A ;
  intensiv_nn_1 : N ;
  intensivundersoekning_nn_1 : N ;
  intensivvaardsavdelning_nn_1 : N ;
  intention_nn_1 : N ;
  intentionsdjup_nn_1 : N ;
  interaktion_nn_1 : N ;
  interaktiv_av_1 : A ;
  intercitytaag_nn_1 : N ;
  interdental_av_1 : A ;
  interdental_nn_1 : N ;
  interdikt_nn_1 : N ;
  interferens_nn_1 : N ;
  interferensmoenster_nn_1 : N ;
  interglacial_av_1 : A ;
  interglacial_nn_1 : N ;
  interimistisk_av_1 : A ;
  interimsbevis_nn_1 : N ;
  interimsregering_nn_1 : N ;
  interimsstyrelse_nn_1 : N ;
  interioer_nn_1 : N ;
  interjektion_nn_1 : N ;
  interkontinental_av_1 : A ;
  interlokutoer_nn_1 : N ;
  interludium_nn_1 : N ;
  intermezzo_nn_1 : N ;
  intermittent_av_1 : A ;
  intern_av_1 : A ;
  intern_nn_1 : N ;
  internat_nn_1 : N ;
  international_nn_1 : N ;
  internationalist_nn_1 : N ;
  internationell_av_1 : A ;
  internering_nn_1 : N ;
  interneringslaeger_nn_1 : N ;
  internist_nn_1 : N ;
  internordisk_av_1 : A ;
  internutbildning_nn_1 : N ;
  interpellant_nn_1 : N ;
  interpellation_nn_1 : N ;
  interplanetarisk_av_1 : A ;
  interpolation_nn_1 : N ;
  interpret_nn_1 : N ;
  interpretation_nn_1 : N ;
  interregnum_nn_1 : N ;
  interrogativ_av_1 : A ;
  interstellaer_av_1 : A ;
  interurban_av_1 : A ;
  intervall_nn_1 : N ;
  intervention_nn_1 : N ;
  intervju_nn_1 : N ;
  intervjuare_nn_1 : N ;
  intervjuoffer_nn_1 : N ;
  intervjuundersoekning_nn_1 : N ;
  intervokalisk_av_1 : A ;
  intestatarv_nn_1 : N ;
  intetsaegande_av_1 : A ;
  intig_av_1 : A ;
  intighet_nn_1 : N ;
  intill_ab_1 : Adv ;
  intilliggande_av_1 : A ;
  intim_av_1 : A ;
  intimist_nn_1 : N ;
  intimitet_nn_1 : N ;
  intjaenandetid_nn_1 : N ;
  intolerabel_av_1 : A ;
  intolerant_av_1 : A ;
  intonation_nn_1 : N ;
  intorkning_nn_1 : N ;
  intoxikation_nn_1 : N ;
  intraede_nn_1 : N ;
  intraedesavgift_nn_1 : N ;
  intraedesprov_nn_1 : N ;
  intraedestal_nn_1 : N ;
  intraengande_av_1 : A ;
  intraengling_nn_1 : N ;
  intransigent_av_1 : A ;
  intransitiv_av_1 : A ;
  intravenoes_av_1 : A ;
  intressant_av_1 : A ;
  intresse_nn_1 : N ;
  intressegemenskap_nn_1 : N ;
  intressegrupp_nn_1 : N ;
  intressekonflikt_nn_1 : N ;
  intresseloes_av_1 : A ;
  intressent_nn_1 : N ;
  intresseomraade_nn_1 : N ;
  intresseorganisation_nn_1 : N ;
  intressesfaer_nn_1 : N ;
  intressevaeckande_av_1 : A ;
  intrig_nn_1 : N ;
  intrigant_av_1 : A ;
  intrigant_nn_1 : N ;
  intrigoer_nn_1 : N ;
  intrikat_av_1 : A ;
  intrimning_nn_1 : N ;
  introduktion_nn_1 : N ;
  introduktionsbrev_nn_1 : N ;
  introduktionserbjudande_nn_1 : N ;
  introduktionskurs_nn_1 : N ;
  introduktoer_nn_1 : N ;
  introspektiv_av_1 : A ;
  introvert_av_1 : A ;
  intryck_nn_1 : N ;
  intubation_nn_1 : N ;
  intuition_nn_1 : N ;
  intuitiv_av_1 : A ;
  intumning_nn_1 : N ;
  intyg_nn_1 : N ;
  inuit_nn_1 : N ;
  inuti_ab_1 : Adv ;
  invaanare_nn_1 : N ;
  invaegning_nn_1 : N ;
  invaendig_av_1 : A ;
  invaendning_nn_1 : N ;
  invaendningsfri_av_1 : A ;
  invaertes_ab_1 : Adv ;
  invaertes_av_1 : A ;
  inval_nn_1 : N ;
  invalid_nn_1 : N ;
  invaliditet_nn_1 : N ;
  invand_av_1 : A ;
  invandrare_nn_1 : N ;
  invandrarverk_nn_1 : N ;
  invandring_nn_1 : N ;
  invandringskvot_nn_1 : N ;
  invariabel_av_1 : A ;
  invariant_av_1 : A ;
  invasion_nn_1 : N ;
  invektiv_nn_1 : N ;
  inventariebok_nn_1 : N ;
  inventariefoerteckning_nn_1 : N ;
  inventarium_nn_1 : N ;
  inventering_nn_1 : N ;
  inventioes_av_1 : A ;
  inverkning_nn_1 : N ;
  invers_nn_1 : N ;
  inversion_nn_1 : N ;
  invertebrat_nn_1 : N ;
  investerare_nn_1 : N ;
  investering_nn_1 : N ;
  investeringsbank_nn_1 : N ;
  investeringsfond_nn_1 : N ;
  investmentbolag_nn_1 : N ;
  invigning_nn_1 : N ;
  invintring_nn_1 : N ;
  invintringsprocess_nn_1 : N ;
  invit_nn_1 : N ;
  invitation_nn_1 : N ;
  invokation_nn_1 : N ;
  ioegonenfallande_av_1 : A ;
  ioegonfallande_av_1 : A ;
  irakier_nn_1 : N ;
  irakisk_av_1 : A ;
  irakiska_nn_1 : N ;
  iranier_nn_1 : N ;
  iransk_av_1 : A ;
  iranska_nn_2 : N ;
  irer_nn_1 : N ;
  iridiumlager_nn_1 : N ;
  iris_nn_1 : N ;
  irisblaendare_nn_1 : N ;
  irisk_av_1 : A ;
  iriska_nn_2 : N ;
  irlaendare_nn_1 : N ;
  irlaendsk_av_1 : A ;
  irlaendska_nn_2 : N ;
  ironi_nn_1 : N ;
  ironiker_nn_1 : N ;
  ironisk_av_1 : A ;
  irrationell_av_1 : A ;
  irrbloss_nn_1 : N ;
  irreal_av_1 : A ;
  irreguljaer_av_1 : A ;
  irrelevant_av_1 : A ;
  irreparabel_av_1 : A ;
  irreversibel_av_1 : A ;
  irrfaerd_nn_1 : N ;
  irrgaang_nn_1 : N ;
  irritabel_av_1 : A ;
  irritament_nn_1 : N ;
  irritation_nn_1 : N ;
  irritationsmoment_nn_1 : N ;
  irrlaera_nn_1 : N ;
  irrlaerig_av_1 : A ;
  is_nn_1 : N ;
  isaelv_nn_1 : N ;
  isaender_ab_1 : Adv ;
  isaer_ab_1 : Adv ;
  isaettning_nn_1 : N ;
  isagogisk_av_1 : A ;
  isbaelte_nn_1 : N ;
  isberg_nn_1 : N ;
  isbildning_nn_1 : N ;
  isbill_nn_1 : N ;
  isbit_nn_1 : N ;
  isbjoern_nn_1 : N ;
  isblaa_av_1 : A ;
  isblock_nn_1 : N ;
  isboj_nn_1 : N ;
  isbrodd_nn_1 : N ;
  isbrytare_nn_1 : N ;
  isbrytning_nn_1 : N ;
  iscensaettning_nn_1 : N ;
  ischiasnerv_nn_1 : N ;
  ischuri_nn_1 : N ;
  isdubb_nn_1 : N ;
  isfaagel_nn_1 : N ;
  isflak_nn_1 : N ;
  isfoerhaallande_nn_1 : N ;
  isfri_av_1 : A ;
  isfront_nn_1 : N ;
  isglass_nn_1 : N ;
  ishall_nn_1 : N ;
  ishav_nn_1 : N ;
  ishockeyroer_nn_1 : N ;
  ishockeyspelare_nn_1 : N ;
  isig_av_1 : A ;
  isjakt_nn_1 : N ;
  iskall_av_1 : A ;
  iskant_nn_1 : N ;
  iskonvalj_nn_1 : N ;
  iskorn_nn_1 : N ;
  iskravning_nn_1 : N ;
  iskristall_nn_1 : N ;
  islaendare_nn_1 : N ;
  islaendsk_av_1 : A ;
  islaendska_nn_2 : N ;
  islaenning_nn_1 : N ;
  islamisk_av_1 : A ;
  islamsk_av_1 : A ;
  islandslav_nn_1 : N ;
  islandssill_nn_1 : N ;
  islossning_nn_1 : N ;
  ism_nn_1 : N ;
  isobar_nn_1 : N ;
  isogon_nn_1 : N ;
  isolat_nn_1 : N ;
  isolationistisk_av_1 : A ;
  isolator_nn_1 : N ;
  isolerband_nn_1 : N ;
  isolerglas_nn_1 : N ;
  isolering_nn_1 : N ;
  isoleringsavdelning_nn_1 : N ;
  isoleringsband_nn_1 : N ;
  isoleringscell_nn_1 : N ;
  isoleringsmaterial_nn_1 : N ;
  isomer_av_1 : A ;
  isomer_nn_1 : N ;
  isomeri_nn_1 : N ;
  isomorf_av_1 : A ;
  isomorfi_nn_1 : N ;
  isooktan_nn_1 : N ;
  isoterm_nn_1 : N ;
  isotop_nn_1 : N ;
  isperiod_nn_1 : N ;
  ispigg_nn_1 : N ;
  ispik_nn_1 : N ;
  israeffla_nn_1 : N ;
  israel_nn_1 : N ;
  israelisk_av_1 : A ;
  israelit_nn_1 : N ;
  israelitisk_av_1 : A ;
  isrand_nn_1 : N ;
  isranunkel_nn_1 : N ;
  israpport_nn_1 : N ;
  isrevy_nn_1 : N ;
  issjoe_nn_1 : N ;
  isskruvning_nn_1 : N ;
  issmaeltning_nn_1 : N ;
  istadig_av_1 : A ;
  istaecke_nn_1 : N ;
  istaeckt_av_1 : A ;
  istaellet_ab_1 : Adv ;
  istapp_nn_1 : N ;
  isterband_nn_1 : N ;
  isterbuk_nn_1 : N ;
  istid_nn_1 : N ;
  istidsforskare_nn_1 : N ;
  istryck_nn_1 : N ;
  isvak_nn_1 : N ;
  italer_nn_1 : N ;
  italienare_nn_1 : N ;
  italiensk_av_1 : A ;
  italienska_nn_2 : N ;
  italiker_nn_1 : N ;
  italisk_av_1 : A ;
  iteration_nn_1 : N ;
  iterativ_av_1 : A ;
  itu_ab_1 : Adv ;
  ity_ab_1 : Adv ;
  ivaeg_ab_1 : Adv ;
  ivorian_nn_1 : N ;
  ivoriansk_av_1 : A ;
  ivrande_nn_1 : N ;
  ivrare_nn_1 : N ;
  ivrig_av_1 : A ;
  ja_nn_1 : N ;
  jaakk_nn_1 : N ;
  jab_nn_1 : N ;
  jabot_nn_1 : N ;
  jack_nn_1 : N ;
  jack_nn_2 : N ;
  jackett_nn_1 : N ;
  jackig_av_1 : A ;
  jackpot_nn_1 : N ;
  jackpropp_nn_1 : N ;
  jackuttag_nn_1 : N ;
  jadegroen_av_1 : A ;
  jaedra_av_1 : A ;
  jaedrans_av_1 : A ;
  jaegarbiff_nn_1 : N ;
  jaegare_nn_1 : N ;
  jaegarfolk_nn_1 : N ;
  jaegarhatt_nn_1 : N ;
  jaegarhorn_nn_1 : N ;
  jaegmaestare_nn_1 : N ;
  jaekel_nn_1 : N ;
  jaekelskap_nn_1 : N ;
  jaekla_av_1 : A ;
  jaeklig_av_1 : A ;
  jaektig_av_1 : A ;
  jaemboerdig_av_1 : A ;
  jaemfoerande_av_1 : A ;
  jaemfoerbar_av_1 : A ;
  jaemfoerelse_nn_1 : N ;
  jaemfoerelsetal_nn_1 : N ;
  jaemfoerelsevis_ab_1 : Adv ;
  jaemfoerlig_av_1 : A ;
  jaemfoerpris_nn_1 : N ;
  jaemfota_ab_1 : Adv ;
  jaemgod_av_1 : A ;
  jaemkning_nn_1 : N ;
  jaemlik_av_1 : A ;
  jaemlike_nn_1 : N ;
  jaemlikhet_nn_1 : N ;
  jaemmerdal_nn_1 : N ;
  jaemmerlig_av_1 : A ;
  jaemn_av_1 : A ;
  jaemnaarig_av_1 : A ;
  jaemngod_av_1 : A ;
  jaemnstark_av_1 : A ;
  jaemnstor_av_1 : A ;
  jaemntjock_av_1 : A ;
  jaemnvarm_av_1 : A ;
  jaems_ab_1 : Adv ;
  jaemsides_ab_1 : Adv ;
  jaemspelt_av_1 : A ;
  jaemstaelld_av_1 : A ;
  jaemstaelldhet_nn_1 : N ;
  jaemstark_av_1 : A ;
  jaemt_ab_1 : Adv ;
  jaemte_nn_1 : N ;
  jaemthund_nn_1 : N ;
  jaemtjock_av_1 : A ;
  jaemtlaendsk_av_1 : A ;
  jaemtlaenning_nn_1 : N ;
  jaemtsk_av_1 : A ;
  jaemvael_ab_1 : Adv ;
  jaemviktslaege_nn_1 : N ;
  jaemviktsorgan_nn_1 : N ;
  jaenkare_nn_1 : N ;
  jaern_nn_1 : N ;
  jaernaaldersbonde_nn_1 : N ;
  jaernaaldersbygd_nn_1 : N ;
  jaernaaldersfiskare_nn_1 : N ;
  jaernaar_nn_1 : N ;
  jaernaffaer_nn_1 : N ;
  jaernbakterie_nn_1 : N ;
  jaernbalk_nn_1 : N ;
  jaernbeslag_nn_1 : N ;
  jaernblad_nn_1 : N ;
  jaernbroellop_nn_1 : N ;
  jaernbruk_nn_1 : N ;
  jaernek_nn_1 : N ;
  jaernfoeremaal_nn_1 : N ;
  jaernframstaellning_nn_1 : N ;
  jaerngrepp_nn_1 : N ;
  jaernhaard_av_1 : A ;
  jaernhake_nn_1 : N ;
  jaernhand_nn_1 : N ;
  jaernhandel_nn_1 : N ;
  jaernhantering_nn_1 : N ;
  jaernindustri_nn_1 : N ;
  jaernjungfru_nn_1 : N ;
  jaernkatastrof_nn_1 : N ;
  jaernklump_nn_1 : N ;
  jaernkors_nn_1 : N ;
  jaernlegering_nn_1 : N ;
  jaernmalm_nn_1 : N ;
  jaernmanufaktur_nn_1 : N ;
  jaernnatt_nn_1 : N ;
  jaernoert_nn_1 : N ;
  jaernoxid_nn_1 : N ;
  jaernpinne_nn_1 : N ;
  jaernplaat_nn_1 : N ;
  jaernproduktion_nn_1 : N ;
  jaernredskap_nn_1 : N ;
  jaernridaa_nn_1 : N ;
  jaernrik_av_1 : A ;
  jaernring_nn_1 : N ;
  jaernsalt_nn_1 : N ;
  jaernsparv_nn_1 : N ;
  jaernspis_nn_1 : N ;
  jaernstaang_nn_1 : N ;
  jaernstag_nn_1 : N ;
  jaernsulfid_nn_1 : N ;
  jaerntillverkning_nn_1 : N ;
  jaerntraad_nn_1 : N ;
  jaernvaeg_nn_1 : N ;
  jaernvaegare_nn_1 : N ;
  jaernvaegsbiljett_nn_1 : N ;
  jaernvaegsknut_nn_1 : N ;
  jaernvaegsoevergaang_nn_1 : N ;
  jaernvaegsraels_nn_1 : N ;
  jaernvaegssignal_nn_1 : N ;
  jaernvaegsspaar_nn_1 : N ;
  jaernvaegsstation_nn_1 : N ;
  jaernvaegstjaensteman_nn_1 : N ;
  jaernvaegsvagn_nn_1 : N ;
  jaernvapen_nn_1 : N ;
  jaernvara_nn_1 : N ;
  jaernvaruaffaer_nn_1 : N ;
  jaernverk_nn_1 : N ;
  jaerpe_nn_1 : N ;
  jaertecken_nn_1 : N ;
  jaerv_nn_1 : N ;
  jaesig_av_1 : A ;
  jaesning_nn_1 : N ;
  jaestsvamp_nn_1 : N ;
  jaette_nn_1 : N ;
  jaettebra_av_1 : A ;
  jaettedum_av_1 : A ;
  jaettekast_nn_1 : N ;
  jaettelaenge_ab_1 : Adv ;
  jaettelik_av_1 : A ;
  jaetteorm_nn_1 : N ;
  jaettesnaell_av_1 : A ;
  jaettesnygg_av_1 : A ;
  jaetteval_nn_1 : N ;
  jaettinna_nn_1 : N ;
  jaev_nn_1 : N ;
  jaevel_nn_1 : N ;
  jaevelskap_nn_1 : N ;
  jaevig_av_1 : A ;
  jaevla_av_1 : A ;
  jaevlig_av_1 : A ;
  jag_nn_1 : N ;
  jagare_nn_1 : N ;
  jagfoerestaellning_nn_1 : N ;
  jaggernaut_nn_1 : N ;
  jagisk_av_1 : A ;
  jagsvaghet_nn_1 : N ;
  jaguar_nn_1 : N ;
  jak_nn_1 : N ;
  jakande_av_1 : A ;
  jakobin_nn_1 : N ;
  jakobskamp_nn_1 : N ;
  jakobsstege_nn_1 : N ;
  jakt_nn_1 : N ;
  jaktbar_av_1 : A ;
  jaktbyte_nn_1 : N ;
  jaktexpedition_nn_1 : N ;
  jaktfalk_nn_1 : N ;
  jaktgevaer_nn_1 : N ;
  jakthistoria_nn_1 : N ;
  jakthorn_nn_1 : N ;
  jakthund_nn_1 : N ;
  jaktkort_nn_1 : N ;
  jaktlag_nn_1 : N ;
  jaktleopard_nn_1 : N ;
  jaktlig_av_1 : A ;
  jaktlopp_nn_1 : N ;
  jaktmark_nn_1 : N ;
  jaktplan_nn_1 : N ;
  jaktprov_nn_1 : N ;
  jaktridning_nn_1 : N ;
  jaktrobot_nn_1 : N ;
  jaktsignal_nn_1 : N ;
  jaktslott_nn_1 : N ;
  jaktspaar_nn_1 : N ;
  jaktspindel_nn_1 : N ;
  jakttabell_nn_1 : N ;
  jakttid_nn_1 : N ;
  jakttrofe_nn_1 : N ;
  jaktvapen_nn_1 : N ;
  jalu_av_1 : A ;
  jalusi_nn_1 : N ;
  jamaican_nn_1 : N ;
  jamaicansk_av_1 : A ;
  jamare_nn_1 : N ;
  jamb_nn_1 : N ;
  jambisk_av_1 : A ;
  jamboree_nn_1 : N ;
  jan_nn_1 : N ;
  janitsjar_nn_1 : N ;
  japan_nn_1 : N ;
  japanes_nn_1 : N ;
  japansk_av_1 : A ;
  japanska_nn_2 : N ;
  japroposition_nn_1 : N ;
  jardinjaer_nn_1 : N ;
  jargong_nn_1 : N ;
  jarl_nn_1 : N ;
  jarop_nn_1 : N ;
  jasaegare_nn_1 : N ;
  jasmin_nn_1 : N ;
  jaspis_nn_1 : N ;
  javan_nn_1 : N ;
  javanes_nn_1 : N ;
  javanesisk_av_1 : A ;
  javansk_av_1 : A ;
  jazzbalett_nn_1 : N ;
  jazzig_av_1 : A ;
  jazzorkester_nn_1 : N ;
  jeep_nn_1 : N ;
  jehu_nn_1 : N ;
  jeppe_nn_1 : N ;
  jeremiad_nn_1 : N ;
  jerseyko_nn_1 : N ;
  jesuit_nn_1 : N ;
  jesuitgeneral_nn_1 : N ;
  jesuitisk_av_1 : A ;
  jesuitorden_nn_1 : N ;
  jetflygplan_nn_1 : N ;
  jetmotor_nn_1 : N ;
  jetong_nn_1 : N ;
  jetplan_nn_1 : N ;
  jetstroem_nn_1 : N ;
  jig_nn_1 : N ;
  jigg_nn_1 : N ;
  jingoism_nn_1 : N ;
  jippo_nn_1 : N ;
  jobb_nn_1 : N ;
  jobbare_nn_1 : N ;
  jobberi_nn_1 : N ;
  jobbig_av_1 : A ;
  jobspost_nn_1 : N ;
  jockej_nn_1 : N ;
  jockey_nn_1 : N ;
  jodtablett_nn_1 : N ;
  joekel_nn_1 : N ;
  joekelport_nn_1 : N ;
  joens_nn_1 : N ;
  joensig_av_1 : A ;
  joesse_nn_1 : N ;
  johannesoert_nn_1 : N ;
  johannit_nn_1 : N ;
  johanniterkors_nn_1 : N ;
  johanniterorden_nn_1 : N ;
  joint_nn_1 : N ;
  jojk_nn_1 : N ;
  jojo_nn_1 : N ;
  joker_nn_1 : N ;
  jokk_nn_1 : N ;
  jolle_nn_1 : N ;
  jolmig_av_1 : A ;
  jolster_nn_1 : N ;
  jon_nn_1 : N ;
  jonbildning_nn_1 : N ;
  jonbindning_nn_1 : N ;
  jonbytare_nn_1 : N ;
  jonflaeck_nn_1 : N ;
  jonfoerening_nn_1 : N ;
  jongitter_nn_1 : N ;
  jongloer_nn_1 : N ;
  jonier_nn_1 : N ;
  jonisation_nn_1 : N ;
  jonisering_nn_1 : N ;
  joniseringsenergi_nn_1 : N ;
  joniseringstendens_nn_1 : N ;
  jonisk_av_1 : A ;
  jonkvill_nn_1 : N ;
  jonstraale_nn_1 : N ;
  jord_nn_1 : N ;
  jordabalk_nn_1 : N ;
  jordaegare_nn_1 : N ;
  jordafaerd_nn_1 : N ;
  jordagods_nn_1 : N ;
  jordanalys_nn_1 : N ;
  jordande_nn_1 : N ;
  jordanier_nn_1 : N ;
  jordansk_av_1 : A ;
  jordart_nn_1 : N ;
  jordartsmetall_nn_1 : N ;
  jordatmosfaer_nn_1 : N ;
  jordavsoendring_nn_1 : N ;
  jordbaevning_nn_1 : N ;
  jordbegravning_nn_1 : N ;
  jordbi_nn_1 : N ;
  jordblad_nn_1 : N ;
  jordbruk_nn_1 : N ;
  jordbrukare_nn_1 : N ;
  jordbruksbebyggelse_nn_1 : N ;
  jordbruksbefolkning_nn_1 : N ;
  jordbruksbygd_nn_1 : N ;
  jordbrukslandskap_nn_1 : N ;
  jordbruksmark_nn_1 : N ;
  jordbruksmaskin_nn_1 : N ;
  jordbruksminister_nn_1 : N ;
  jordbruksprodukt_nn_1 : N ;
  jordbruksredskap_nn_1 : N ;
  jordbunden_av_1 : A ;
  jorddelning_nn_1 : N ;
  jorddrott_nn_1 : N ;
  jordebok_nn_1 : N ;
  jordegendom_nn_1 : N ;
  jordekorre_nn_1 : N ;
  jorden_runt_seglare_nn_1 : N ;
  jordfaerg_nn_1 : N ;
  jordfaergaemne_nn_1 : N ;
  jordfaestning_nn_1 : N ;
  jordfast_av_1 : A ;
  jordfly_nn_1 : N ;
  jordfraes_nn_1 : N ;
  jordgeting_nn_1 : N ;
  jordglob_nn_1 : N ;
  jordgolv_nn_1 : N ;
  jordgubbe_nn_1 : N ;
  jordgubbssaft_nn_1 : N ;
  jordig_av_1 : A ;
  jordisk_av_1 : A ;
  jordkabel_nn_1 : N ;
  jordkaellare_nn_1 : N ;
  jordlager_nn_1 : N ;
  jordledning_nn_1 : N ;
  jordlik_av_1 : A ;
  jordloepare_nn_1 : N ;
  jordlott_nn_1 : N ;
  jordmateria_nn_1 : N ;
  jordmaterial_nn_1 : N ;
  jordmetall_nn_1 : N ;
  jordnaera_av_1 : A ;
  jordnoet_nn_1 : N ;
  jordomraade_nn_1 : N ;
  jordpartikel_nn_1 : N ;
  jordreform_nn_1 : N ;
  jordregister_nn_1 : N ;
  jordrotation_nn_1 : N ;
  jordskalv_nn_1 : N ;
  jordskott_nn_1 : N ;
  jordskred_nn_1 : N ;
  jordskredsseger_nn_1 : N ;
  jordskyld_nn_1 : N ;
  jordstam_nn_1 : N ;
  jordstoet_nn_1 : N ;
  jordstroem_nn_1 : N ;
  jordsvin_nn_1 : N ;
  jordtaekt_nn_1 : N ;
  jordtag_nn_1 : N ;
  jordtroetthet_nn_1 : N ;
  jordvaerdestegring_nn_1 : N ;
  jordvall_nn_1 : N ;
  jos_nn_1 : N ;
  joule_nn_1 : N ;
  jour_nn_1 : N ;
  jourbutik_nn_1 : N ;
  jourhavande_av_1 : A ;
  jourhavande_nn_1 : N ;
  journal_nn_1 : N ;
  journalfilm_nn_1 : N ;
  journalist_nn_1 : N ;
  journalistisk_av_1 : A ;
  jovial_av_1 : A ;
  jovialisk_av_1 : A ;
  jovialitet_nn_1 : N ;
  joxig_av_1 : A ;
  ju_ab_1 : Adv ;
  jubelaar_nn_1 : N ;
  jubelaasna_nn_1 : N ;
  jubeldag_nn_1 : N ;
  jubeldoktor_nn_1 : N ;
  jubelidiot_nn_1 : N ;
  jubilar_nn_1 : N ;
  jubileum_nn_1 : N ;
  jubileumsmynt_nn_1 : N ;
  jublande_av_1 : A ;
  judasgaerning_nn_1 : N ;
  judaskyss_nn_1 : N ;
  judaspeng_nn_1 : N ;
  jude_nn_1 : N ;
  judebroed_nn_1 : N ;
  judefoerfoeljelse_nn_1 : N ;
  judekristen_av_1 : A ;
  judendom_nn_1 : N ;
  judenhet_nn_1 : N ;
  judiciell_av_1 : A ;
  judinna_nn_1 : N ;
  judisk_av_1 : A ;
  jugoslav_nn_1 : N ;
  jugoslavisk_av_1 : A ;
  juice_nn_1 : N ;
  jukebox_nn_1 : N ;
  jul_nn_1 : N ;
  julafton_nn_1 : N ;
  julbock_nn_1 : N ;
  julboen_nn_1 : N ;
  julbord_nn_1 : N ;
  juldag_nn_1 : N ;
  juldagsmorgon_nn_1 : N ;
  julevangelium_nn_1 : N ;
  julgran_nn_1 : N ;
  julgransfot_nn_1 : N ;
  julgranskaramell_nn_1 : N ;
  julgransplundring_nn_1 : N ;
  julgransprydnad_nn_1 : N ;
  julgris_nn_1 : N ;
  julgrupp_nn_1 : N ;
  julhelg_nn_1 : N ;
  juliansk_av_1 : A ;
  julkaerve_nn_1 : N ;
  julkaktus_nn_1 : N ;
  julklapp_nn_1 : N ;
  julkort_nn_1 : N ;
  julle_nn_1 : N ;
  julp_nn_1 : N ;
  julskyltning_nn_1 : N ;
  jultidning_nn_1 : N ;
  jultomte_nn_1 : N ;
  jumbojet_nn_1 : N ;
  jumper_nn_1 : N ;
  jungfru_nn_1 : N ;
  jungfrualstring_nn_1 : N ;
  jungfruben_nn_1 : N ;
  jungfruboerd_nn_1 : N ;
  jungfrubroest_nn_1 : N ;
  jungfrubur_nn_1 : N ;
  jungfrudom_nn_1 : N ;
  jungfrufoedsel_nn_1 : N ;
  jungfrukammare_nn_1 : N ;
  jungfrulig_av_1 : A ;
  jungfrustift_nn_1 : N ;
  jungfrusvaerm_nn_1 : N ;
  jungfrutal_nn_1 : N ;
  jungman_nn_1 : N ;
  junior_av_1 : A ;
  junior_nn_1 : N ;
  junker_nn_1 : N ;
  junonisk_av_1 : A ;
  juridisk_av_1 : A ;
  juris_av_1 : A ;
  jurist_nn_1 : N ;
  jurt_nn_1 : N ;
  jury_nn_1 : N ;
  jus_nn_1 : N ;
  just_ab_1 : Adv ;
  just_av_1 : A ;
  juste_av_1 : A ;
  justerare_nn_1 : N ;
  justering_nn_1 : N ;
  justeringsman_nn_1 : N ;
  justitiedepartement_nn_1 : N ;
  justitieminister_nn_1 : N ;
  justitiemord_nn_1 : N ;
  justitieombudsman_nn_1 : N ;
  justitieraad_nn_1 : N ;
  jute_nn_2 : N ;
  jutlaendsk_av_1 : A ;
  jutsk_av_1 : A ;
  juvel_nn_1 : N ;
  juvelerare_nn_1 : N ;
  juvenil_av_1 : A ;
  juver_nn_1 : N ;
  juverinflammation_nn_1 : N ;
  juvervaevnad_nn_1 : N ;
  juxtaposition_nn_1 : N ;
  jycke_nn_1 : N ;
  jyllaendsk_av_1 : A ;
  jyllaenning_nn_1 : N ;
  kaadig_av_1 : A ;
  kaadrik_av_1 : A ;
  kaak_nn_1 : N ;
  kaakfarare_nn_1 : N ;
  kaaldolma_nn_1 : N ;
  kaalfjaeril_nn_1 : N ;
  kaalhuvud_nn_1 : N ;
  kaallapp_nn_1 : N ;
  kaalmask_nn_1 : N ;
  kaalrot_nn_1 : N ;
  kaalsupare_nn_1 : N ;
  kaar_nn_1 : N ;
  kaare_nn_1 : N ;
  kaarhus_nn_1 : N ;
  kaarknutte_nn_1 : N ;
  kaarordfoerande_nn_1 : N ;
  kaarpamp_nn_1 : N ;
  kaaseri_nn_1 : N ;
  kaasoer_nn_1 : N ;
  kabal_nn_1 : N ;
  kabare_nn_1 : N ;
  kabareorkester_nn_1 : N ;
  kabbalist_nn_1 : N ;
  kabel_nn_1 : N ;
  kabelbro_nn_1 : N ;
  kabelbrunn_nn_1 : N ;
  kabelgatt_nn_1 : N ;
  kabellaengd_nn_1 : N ;
  kabelskaap_nn_1 : N ;
  kabelslagen_av_1 : A ;
  kabin_nn_1 : N ;
  kabinbaat_nn_1 : N ;
  kabinett_nn_1 : N ;
  kabinettsformat_nn_1 : N ;
  kabinettsfraaga_nn_1 : N ;
  kabinettskort_nn_1 : N ;
  kabinettsorder_nn_1 : N ;
  kabinettspass_nn_1 : N ;
  kabinettssekreterare_nn_1 : N ;
  kabyl_nn_1 : N ;
  kabylisk_av_1 : A ;
  kabyss_nn_1 : N ;
  kadaver_nn_1 : N ;
  kadaverlydnad_nn_1 : N ;
  kadens_nn_1 : N ;
  kader_nn_1 : N ;
  kaderoevning_nn_1 : N ;
  kadersystem_nn_1 : N ;
  kadett_nn_1 : N ;
  kadettfartyg_nn_1 : N ;
  kadettkaar_nn_1 : N ;
  kadi_nn_1 : N ;
  kadmiumgul_av_1 : A ;
  kadmiumjon_nn_1 : N ;
  kadrilj_nn_1 : N ;
  kaeck_av_1 : A ;
  kaeft_nn_1 : N ;
  kaegel_nn_1 : N ;
  kaegelformig_av_1 : A ;
  kaegelsnitt_nn_1 : N ;
  kaegla_nn_1 : N ;
  kaekben_nn_1 : N ;
  kaeke_nn_1 : N ;
  kaekled_nn_1 : N ;
  kaekrem_nn_1 : N ;
  kael_nn_1 : N ;
  kaelkbacke_nn_1 : N ;
  kaelkborgare_nn_1 : N ;
  kaelke_nn_1 : N ;
  kaellaader_nn_1 : N ;
  kaellaadra_nn_1 : N ;
  kaellare_nn_1 : N ;
  kaellarhals_nn_1 : N ;
  kaellarmaestare_nn_1 : N ;
  kaellarvaaning_nn_1 : N ;
  kaelldrag_nn_1 : N ;
  kaellfloede_nn_1 : N ;
  kaellfoerteckning_nn_1 : N ;
  kaellhaenvisning_nn_1 : N ;
  kaelling_nn_1 : N ;
  kaellmaterial_nn_1 : N ;
  kaellsjoe_nn_1 : N ;
  kaellskrift_nn_1 : N ;
  kaellspraang_nn_1 : N ;
  kaellvatten_nn_1 : N ;
  kaemnaersraett_nn_1 : N ;
  kaempagrav_nn_1 : N ;
  kaempalek_nn_1 : N ;
  kaempalik_av_1 : A ;
  kaempatag_nn_1 : N ;
  kaempe_nn_1 : N ;
  kaempig_av_1 : A ;
  kaend_av_1 : A ;
  kaendis_nn_1 : N ;
  kaenguru_nn_1 : N ;
  kaengurupung_nn_1 : N ;
  kaennare_nn_1 : N ;
  kaennbar_av_1 : A ;
  kaennedom_nn_1 : N ;
  kaennemaerke_nn_1 : N ;
  kaennetecken_nn_1 : N ;
  kaenning_nn_1 : N ;
  kaenselhaar_nn_1 : N ;
  kaenselorgan_nn_1 : N ;
  kaenselsproet_nn_1 : N ;
  kaensla_nn_1 : N ;
  kaenslig_av_1 : A ;
  kaenslighet_nn_1 : N ;
  kaenslofylld_av_1 : A ;
  kaenslokall_av_1 : A ;
  kaenslolaege_nn_1 : N ;
  kaensloloes_av_1 : A ;
  kaenslomaenniska_nn_1 : N ;
  kaenslomaessig_av_1 : A ;
  kaenslosam_av_1 : A ;
  kaenslosamhet_nn_1 : N ;
  kaenslostraeng_nn_1 : N ;
  kaepp_nn_1 : N ;
  kaepphaest_nn_1 : N ;
  kaeppraett_ab_1 : Adv ;
  kaepprak_av_1 : A ;
  kaer_av_1 : A ;
  kaeraelskelig_av_1 : A ;
  kaerande_nn_1 : N ;
  kaeril_nn_1 : N ;
  kaering_nn_1 : N ;
  kaeringknop_nn_1 : N ;
  kaeringknut_nn_1 : N ;
  kaeringkrok_nn_1 : N ;
  kaerkommen_av_1 : A ;
  kaerl_nn_1 : N ;
  kaerlek_nn_1 : N ;
  kaerleksaffaer_nn_1 : N ;
  kaerleksakt_nn_1 : N ;
  kaerleksbarn_nn_1 : N ;
  kaerleksbetygelse_nn_1 : N ;
  kaerleksbud_nn_1 : N ;
  kaerleksdikt_nn_1 : N ;
  kaerleksdryck_nn_1 : N ;
  kaerleksfoerbindelse_nn_1 : N ;
  kaerleksfoerhaallande_nn_1 : N ;
  kaerleksfull_av_1 : A ;
  kaerleksgud_nn_1 : N ;
  kaerlekshistoria_nn_1 : N ;
  kaerlekskonflikt_nn_1 : N ;
  kaerlekskrank_av_1 : A ;
  kaerlekskval_nn_1 : N ;
  kaerleksloes_av_1 : A ;
  kaerleksmoete_nn_1 : N ;
  kaerlekspar_nn_1 : N ;
  kaerleksrelation_nn_1 : N ;
  kaerleksroman_nn_1 : N ;
  kaerlekssaga_nn_1 : N ;
  kaerlig_av_1 : A ;
  kaerligen_ab_1 : Adv ;
  kaerlsjukdom_nn_1 : N ;
  kaerlsvulst_nn_1 : N ;
  kaernfamilj_nn_1 : N ;
  kaernfoerande_av_1 : A ;
  kaernfri_av_1 : A ;
  kaernfrisk_av_1 : A ;
  kaernfrukt_nn_1 : N ;
  kaernfull_av_1 : A ;
  kaerngubbe_nn_1 : N ;
  kaernhus_nn_1 : N ;
  kaernkraftinspektion_nn_1 : N ;
  kaernkraftsaekerhet_nn_1 : N ;
  kaernkraftsoperatoer_nn_1 : N ;
  kaernkraftverk_nn_1 : N ;
  kaernladdning_nn_1 : N ;
  kaernlinje_nn_1 : N ;
  kaernminne_nn_1 : N ;
  kaernpartikel_nn_1 : N ;
  kaernpunkt_nn_1 : N ;
  kaernreaktion_nn_1 : N ;
  kaernreaktor_nn_1 : N ;
  kaernsoenderfall_nn_1 : N ;
  kaerntrupp_nn_1 : N ;
  kaernvapen_nn_1 : N ;
  kaernvapenarsenal_nn_1 : N ;
  kaernvapenbaerande_av_1 : A ;
  kaernvapenexplosion_nn_1 : N ;
  kaernvapenfri_av_1 : A ;
  kaernvapenkrig_nn_1 : N ;
  kaernvapenmakt_nn_1 : N ;
  kaernvapenparaply_nn_1 : N ;
  kaernvapenprov_nn_1 : N ;
  kaernvapenstrategi_nn_1 : N ;
  kaeromaal_nn_1 : N ;
  kaerr_nn_1 : N ;
  kaerraeng_nn_1 : N ;
  kaerrhoek_nn_1 : N ;
  kaerring_nn_1 : N ;
  kaerrvial_nn_1 : N ;
  kaerv_av_1 : A ;
  kaervaenlig_av_1 : A ;
  kaerve_nn_1 : N ;
  kaettarbaal_nn_1 : N ;
  kaettare_nn_1 : N ;
  kaette_nn_1 : N ;
  kaetteri_nn_1 : N ;
  kaettersk_av_1 : A ;
  kaetting_nn_1 : N ;
  kaettjefull_av_1 : A ;
  kaex_nn_1 : N ;
  kafe_nn_1 : N ;
  kaferoerelse_nn_1 : N ;
  kafevagn_nn_1 : N ;
  kaffeautomat_nn_1 : N ;
  kaffebal_nn_1 : N ;
  kaffebord_nn_1 : N ;
  kaffebrun_av_1 : A ;
  kaffebryggare_nn_1 : N ;
  kaffebuske_nn_1 : N ;
  kaffedags_ab_1 : Adv ;
  kaffedrickande_nn_1 : N ;
  kaffeduk_nn_1 : N ;
  kaffeersaettning_nn_1 : N ;
  kaffefat_nn_1 : N ;
  kaffefilter_nn_1 : N ;
  kaffegoek_nn_1 : N ;
  kaffekask_nn_1 : N ;
  kaffekittel_nn_1 : N ;
  kaffekokare_nn_1 : N ;
  kaffekopp_nn_1 : N ;
  kaffekvarn_nn_1 : N ;
  kaffemoster_nn_1 : N ;
  kaffepetter_nn_1 : N ;
  kaffepulver_nn_1 : N ;
  kaffer_nn_1 : N ;
  kafferast_nn_1 : N ;
  kafferbuffel_nn_1 : N ;
  kafferep_nn_1 : N ;
  kafferosteri_nn_1 : N ;
  kafferspjut_nn_1 : N ;
  kafferspraak_nn_1 : N ;
  kaffeservering_nn_1 : N ;
  kaffesked_nn_1 : N ;
  kaffetaar_nn_1 : N ;
  kaffetant_nn_1 : N ;
  kaffetraed_nn_1 : N ;
  kaftan_nn_1 : N ;
  kagge_nn_1 : N ;
  kaj_nn_1 : N ;
  kajak_nn_1 : N ;
  kajavgift_nn_1 : N ;
  kajdjup_nn_1 : N ;
  kajfritt_ab_1 : Adv ;
  kajman_nn_1 : N ;
  kajplats_nn_1 : N ;
  kajskoning_nn_1 : N ;
  kajutdaeck_nn_1 : N ;
  kajutpost_nn_1 : N ;
  kakafoni_nn_1 : N ;
  kakaolikoer_nn_1 : N ;
  kakaotraed_nn_1 : N ;
  kakbak_nn_1 : N ;
  kakburk_nn_1 : N ;
  kakel_nn_1 : N ;
  kakelugn_nn_1 : N ;
  kakelugnsmakare_nn_1 : N ;
  kakelugnsnisch_nn_1 : N ;
  kakelugnssaettare_nn_1 : N ;
  kakelugnsventil_nn_1 : N ;
  kakfat_nn_1 : N ;
  kakform_nn_1 : N ;
  kakmaatt_nn_1 : N ;
  kakmix_nn_1 : N ;
  kakofoni_nn_1 : N ;
  kaksmet_nn_1 : N ;
  kaktaang_nn_1 : N ;
  kakte_nn_1 : N ;
  kaktus_nn_1 : N ;
  kaktusfikon_nn_1 : N ;
  kakuminal_av_1 : A ;
  kakuminal_nn_1 : N ;
  kal_av_1 : A ;
  kalabalik_nn_1 : N ;
  kalabass_nn_1 : N ;
  kalaeta_vb_1 : V ;
  kalamitet_nn_1 : N ;
  kalander_nn_1 : N ;
  kalas_nn_1 : N ;
  kalaspingla_nn_1 : N ;
  kalcedon_nn_1 : N ;
  kalciumhydroxid_nn_1 : N ;
  kalciumoxid_nn_1 : N ;
  kalciumsilikat_nn_1 : N ;
  kalde_nn_1 : N ;
  kalebass_nn_1 : N ;
  kaledonisk_av_1 : A ;
  kalejdoskop_nn_1 : N ;
  kalejdoskopisk_av_1 : A ;
  kalendarisk_av_1 : A ;
  kalendarium_nn_1 : N ;
  kalender_nn_1 : N ;
  kalenderaar_nn_1 : N ;
  kalenderbitare_nn_1 : N ;
  kalenderdygn_nn_1 : N ;
  kalendermaanad_nn_1 : N ;
  kalenderstav_nn_1 : N ;
  kalendervecka_nn_1 : N ;
  kalesch_nn_1 : N ;
  kalfaktor_nn_1 : N ;
  kalfjaell_nn_1 : N ;
  kalhugga_vb_1 : V ;
  kalhygge_nn_1 : N ;
  kaliber_nn_1 : N ;
  kaliberborr_nn_1 : N ;
  kalibertolk_nn_1 : N ;
  kalif_nn_1 : N ;
  kalifat_nn_1 : N ;
  kalisalt_nn_1 : N ;
  kaliumhydroxid_nn_1 : N ;
  kaliumjon_nn_1 : N ;
  kalk_nn_2 : N ;
  kalkalg_nn_1 : N ;
  kalkanhopning_nn_1 : N ;
  kalkbraenneri_nn_1 : N ;
  kalkbrott_nn_1 : N ;
  kalkbruk_nn_1 : N ;
  kalkerpapper_nn_1 : N ;
  kalkfaerg_nn_1 : N ;
  kalkfattig_av_1 : A ;
  kalkgrund_nn_1 : N ;
  kalkhalt_nn_1 : N ;
  kalkhaltig_av_1 : A ;
  kalkjon_nn_1 : N ;
  kalkmaalning_nn_1 : N ;
  kalkomani_nn_1 : N ;
  kalkon_nn_1 : N ;
  kalkrest_nn_1 : N ;
  kalkrik_av_1 : A ;
  kalkskal_nn_1 : N ;
  kalktuff_nn_1 : N ;
  kalkugn_nn_1 : N ;
  kalkyl_nn_1 : N ;
  kalkylator_nn_1 : N ;
  kalkylerbar_av_1 : A ;
  kall_av_1 : A ;
  kall_nn_1 : N ;
  kallbad_nn_1 : N ;
  kallbaenk_nn_1 : N ;
  kallblod_nn_1 : N ;
  kallblodig_av_1 : A ;
  kallblodighet_nn_1 : N ;
  kalldra_vb_1 : V ;
  kalldusch_nn_1 : N ;
  kallelse_nn_1 : N ;
  kallelsebeslut_nn_1 : N ;
  kallelsebrev_nn_1 : N ;
  kallelsefoerslag_nn_1 : N ;
  kallelsegaerning_nn_1 : N ;
  kallelsetid_nn_1 : N ;
  kallflytande_av_1 : A ;
  kallfront_nn_1 : N ;
  kallgarage_nn_1 : N ;
  kallgrin_nn_1 : N ;
  kallhus_nn_1 : N ;
  kallmangel_nn_1 : N ;
  kallmur_nn_1 : N ;
  kallnaal_nn_1 : N ;
  kallortstillaegg_nn_1 : N ;
  kallpunkt_nn_1 : N ;
  kallsaag_nn_1 : N ;
  kallsinnig_av_1 : A ;
  kallskaenk_nn_1 : N ;
  kallskuren_av_1 : A ;
  kallstart_nn_1 : N ;
  kallsup_nn_1 : N ;
  kallvatten_nn_1 : N ;
  kalmark_nn_1 : N ;
  kalmuck_nn_1 : N ;
  kalori_nn_1 : N ;
  kaloribehov_nn_1 : N ;
  kalorifattig_av_1 : A ;
  kalorijakt_nn_1 : N ;
  kalorimeter_nn_1 : N ;
  kaloririk_av_1 : A ;
  kaloritabell_nn_1 : N ;
  kalorivaerde_nn_1 : N ;
  kalott_nn_1 : N ;
  kalstammig_av_1 : A ;
  kalufs_nn_1 : N ;
  kalv_nn_1 : N ;
  kalvfaerdig_av_1 : A ;
  kalvfrikasse_nn_1 : N ;
  kalvill_nn_1 : N ;
  kalvinist_nn_1 : N ;
  kalvinistisk_av_1 : A ;
  kalvinsk_av_1 : A ;
  kalvjaerpe_nn_1 : N ;
  kalvko_nn_1 : N ;
  kalvrulad_nn_1 : N ;
  kalvskinn_nn_1 : N ;
  kalvskinnsband_nn_1 : N ;
  kalvstek_nn_1 : N ;
  kam_nn_1 : N ;
  kamaxel_nn_1 : N ;
  kambodjan_nn_1 : N ;
  kambrisk_av_1 : A ;
  kame_nn_1 : N ;
  kamel_nn_1 : N ;
  kameldjur_nn_1 : N ;
  kameleont_nn_1 : N ;
  kamelforskare_nn_1 : N ;
  kamelforskning_nn_1 : N ;
  kamelforskningsprojekt_nn_1 : N ;
  kamelherde_nn_1 : N ;
  kamelhjord_nn_1 : N ;
  kamelmedicin_nn_1 : N ;
  kamelopard_nn_1 : N ;
  kamelpoesi_nn_1 : N ;
  kamelsadel_nn_1 : N ;
  kamelsaeck_nn_1 : N ;
  kamera_nn_1 : N ;
  kamerajakt_nn_1 : N ;
  kameral_av_1 : A ;
  kameraman_nn_1 : N ;
  kameraobjektiv_nn_1 : N ;
  kamerunare_nn_1 : N ;
  kamerunsk_av_1 : A ;
  kamin_nn_1 : N ;
  kammanet_nn_1 : N ;
  kammaraaklagare_nn_1 : N ;
  kammardressyr_nn_1 : N ;
  kammare_nn_1 : N ;
  kammarherre_nn_1 : N ;
  kammarjungfru_nn_1 : N ;
  kammarjunkare_nn_1 : N ;
  kammarlaerd_av_1 : A ;
  kammarmusiker_nn_1 : N ;
  kammarorkester_nn_1 : N ;
  kammarpiano_nn_1 : N ;
  kammarraett_nn_1 : N ;
  kammarskjutning_nn_1 : N ;
  kammarskrivare_nn_1 : N ;
  kammarskruv_nn_1 : N ;
  kammarspel_nn_1 : N ;
  kammussla_nn_1 : N ;
  kamomill_nn_1 : N ;
  kamouflering_nn_1 : N ;
  kamp_nn_1 : N ;
  kamp_nn_2 : N ;
  kampanil_nn_1 : N ;
  kampanj_nn_1 : N ;
  kampare_nn_1 : N ;
  kampegraes_nn_1 : N ;
  kampeschtraed_nn_1 : N ;
  kamporganisation_nn_1 : N ;
  kampsaang_nn_1 : N ;
  kampsport_nn_1 : N ;
  kampuchean_nn_1 : N ;
  kampucheansk_av_1 : A ;
  kampvilja_nn_1 : N ;
  kamrat_nn_1 : N ;
  kamratlig_av_1 : A ;
  kamratpaaverkning_nn_1 : N ;
  kamrer_nn_1 : N ;
  kamrerare_nn_1 : N ;
  kams_nn_1 : N ;
  kamtsjadal_nn_1 : N ;
  kan_nn_1 : N ;
  kanadagaas_nn_1 : N ;
  kanadensare_nn_1 : N ;
  kanadensisk_av_1 : A ;
  kanadick_nn_1 : N ;
  kanak_nn_1 : N ;
  kanal_nn_1 : N ;
  kanalaangare_nn_1 : N ;
  kanalje_nn_1 : N ;
  kanalkrock_nn_1 : N ;
  kanalljus_nn_1 : N ;
  kanalsystem_nn_1 : N ;
  kanalvaeljare_nn_1 : N ;
  kanane_nn_1 : N ;
  kanape_nn_1 : N ;
  kanariefaagel_nn_1 : N ;
  kanariefroe_nn_1 : N ;
  kanariegul_av_1 : A ;
  kandar_nn_1 : N ;
  kandelaber_nn_1 : N ;
  kandidat_nn_1 : N ;
  kandidatur_nn_1 : N ;
  kanelbrun_av_1 : A ;
  kanelstaang_nn_1 : N ;
  kanfas_nn_1 : N ;
  kanhaenda_ab_1 : Adv ;
  kanik_nn_1 : N ;
  kanin_nn_1 : N ;
  kanister_nn_1 : N ;
  kanjon_nn_1 : N ;
  kannbrosk_nn_1 : N ;
  kannelyr_nn_1 : N ;
  kannibal_nn_1 : N ;
  kannibalisk_av_1 : A ;
  kannstoepare_nn_1 : N ;
  kannstoeperi_nn_1 : N ;
  kanon_nn_1 : N ;
  kanon_nn_2 : N ;
  kanonad_nn_1 : N ;
  kanonbaat_nn_1 : N ;
  kanonbra_av_1 : A ;
  kanonfotograf_nn_1 : N ;
  kanongjuteri_nn_1 : N ;
  kanonisation_nn_1 : N ;
  kanonisering_nn_1 : N ;
  kanonisk_av_1 : A ;
  kanonjaer_nn_1 : N ;
  kanonlock_nn_1 : N ;
  kanonlopp_nn_1 : N ;
  kanonport_nn_1 : N ;
  kanontorn_nn_1 : N ;
  kanot_nn_1 : N ;
  kanotist_nn_1 : N ;
  kanske_ab_1 : Adv ;
  kansler_nn_1 : N ;
  kansli_nn_1 : N ;
  kansliraad_nn_1 : N ;
  kanslisekreterare_nn_1 : N ;
  kanslist_nn_1 : N ;
  kant_nn_1 : N ;
  kantabel_av_1 : A ;
  kantaenka_ab_1 : Adv ;
  kantarell_nn_1 : N ;
  kantat_nn_1 : N ;
  kantband_nn_1 : N ;
  kantbeslag_nn_1 : N ;
  kantele_nn_1 : N ;
  kanthugga_vb_1 : V ;
  kantig_av_1 : A ;
  kantin_nn_1 : N ;
  kantnaal_nn_1 : N ;
  kanton_nn_1 : N ;
  kantor_nn_1 : N ;
  kantrep_nn_1 : N ;
  kantsoem_nn_1 : N ;
  kantsten_nn_1 : N ;
  kantstoett_av_1 : A ;
  kantvaext_nn_1 : N ;
  kanvasband_nn_1 : N ;
  kanvasduk_nn_1 : N ;
  kanyl_nn_1 : N ;
  kaotisk_av_1 : A ;
  kap_nn_2 : N ;
  kapabel_av_1 : A ;
  kapacitet_nn_1 : N ;
  kapare_nn_1 : N ;
  kapell_nn_1 : N ;
  kapellmaestare_nn_1 : N ;
  kaperi_nn_1 : N ;
  kapfaar_nn_1 : N ;
  kapillaer_av_1 : A ;
  kapillaer_nn_1 : N ;
  kapillaerroer_nn_1 : N ;
  kapillaritet_nn_1 : N ;
  kapitael_nn_1 : N ;
  kapitael_nn_2 : N ;
  kapital_av_1 : A ;
  kapital_nn_1 : N ;
  kapitalbeskattning_nn_1 : N ;
  kapitalbildning_nn_1 : N ;
  kapitalbudget_nn_1 : N ;
  kapitalfoerlust_nn_1 : N ;
  kapitalfoersaekring_nn_1 : N ;
  kapitalinkomst_nn_1 : N ;
  kapitalinkomstbeskattning_nn_1 : N ;
  kapitalintensiv_av_1 : A ;
  kapitalist_nn_1 : N ;
  kapitalistisk_av_1 : A ;
  kapitalkonto_nn_1 : N ;
  kapitalmarknad_nn_1 : N ;
  kapitalvaerde_nn_1 : N ;
  kapitalvinst_nn_1 : N ;
  kapitel_nn_1 : N ;
  kapitelsal_nn_1 : N ;
  kapitelvis_ab_1 : Adv ;
  kapitulation_nn_1 : N ;
  kaplan_nn_1 : N ;
  kapott_nn_1 : N ;
  kapp_nn_1 : N ;
  kappe_nn_1 : N ;
  kappkoerning_nn_1 : N ;
  kapploepning_nn_1 : N ;
  kapprak_av_1 : A ;
  kapprock_nn_1 : N ;
  kapprum_nn_1 : N ;
  kapprustning_nn_1 : N ;
  kappsaeck_nn_1 : N ;
  kappseglare_nn_1 : N ;
  kappsegling_nn_1 : N ;
  kappseglingsbaat_nn_1 : N ;
  kappsimning_nn_1 : N ;
  kapricioes_av_1 : A ;
  kaprifol_nn_1 : N ;
  kaprifolium_nn_1 : N ;
  kapriol_nn_1 : N ;
  kapris_nn_1 : N ;
  kapsaag_nn_1 : N ;
  kapsel_nn_1 : N ;
  kapson_nn_1 : N ;
  kapsyl_nn_1 : N ;
  kapten_nn_1 : N ;
  kapucin_nn_1 : N ;
  kapucinorden_nn_1 : N ;
  kapun_nn_1 : N ;
  kapuschong_nn_1 : N ;
  kaputt_av_1 : A ;
  kapverdier_nn_1 : N ;
  kapverdisk_av_1 : A ;
  kar_nn_1 : N ;
  karabinjaer_nn_1 : N ;
  karaff_nn_1 : N ;
  karaffin_nn_1 : N ;
  karaktaer_nn_1 : N ;
  karaktaeristik_nn_1 : N ;
  karaktaeristika_nn_2 : N ;
  karaktaeristisk_av_1 : A ;
  karaktaersart_nn_1 : N ;
  karaktaersdrag_nn_1 : N ;
  karaktaersdrama_nn_1 : N ;
  karaktaersfast_av_1 : A ;
  karaktaersfel_nn_1 : N ;
  karaktaersroll_nn_1 : N ;
  karaktaersskaadespelare_nn_1 : N ;
  karaktaerstyp_nn_1 : N ;
  karakteristik_nn_1 : N ;
  karakteristika_nn_2 : N ;
  karakteristisk_av_1 : A ;
  karamboll_nn_1 : N ;
  karamell_nn_1 : N ;
  karamellfaerg_nn_1 : N ;
  karamellpapper_nn_1 : N ;
  karamellpudding_nn_1 : N ;
  karamellsaas_nn_1 : N ;
  karantaen_nn_1 : N ;
  karat_nn_1 : N ;
  karatering_nn_1 : N ;
  karatstaempel_nn_1 : N ;
  karavan_nn_1 : N ;
  karavanseraj_nn_1 : N ;
  karavell_nn_1 : N ;
  karbad_nn_1 : N ;
  karbamid_nn_1 : N ;
  karbas_nn_1 : N ;
  karbin_nn_1 : N ;
  karbinhake_nn_1 : N ;
  karbonat_nn_1 : N ;
  karbonatjon_nn_1 : N ;
  karbonatsmaeltecell_nn_1 : N ;
  karbonkopia_nn_1 : N ;
  karbonpapper_nn_1 : N ;
  karborundumduk_nn_1 : N ;
  karbunkel_nn_1 : N ;
  karburator_nn_1 : N ;
  karcinogen_av_1 : A ;
  karcinom_nn_1 : N ;
  kardan_nn_1 : N ;
  kardanaxel_nn_1 : N ;
  kardanknut_nn_1 : N ;
  kardansk_av_1 : A ;
  kardanupphaengning_nn_1 : N ;
  kardborrband_nn_1 : N ;
  kardborre_nn_1 : N ;
  kardborreknaeppning_nn_1 : N ;
  kardel_nn_1 : N ;
  kardinal_nn_1 : N ;
  kardinalbiskop_nn_1 : N ;
  kardinaldygd_nn_1 : N ;
  kardinalfel_nn_1 : N ;
  kardinalstreck_nn_1 : N ;
  kardinaltal_nn_1 : N ;
  kardiograf_nn_1 : N ;
  kardiogram_nn_1 : N ;
  kardiolog_nn_1 : N ;
  kardnubb_nn_1 : N ;
  kardus_nn_1 : N ;
  karel_nn_1 : N ;
  karelare_nn_1 : N ;
  karelsk_av_1 : A ;
  karensdag_nn_1 : N ;
  karess_nn_1 : N ;
  karet_nn_1 : N ;
  karg_av_1 : A ;
  karikatyr_nn_1 : N ;
  karikatyrtecknare_nn_1 : N ;
  karisma_nn_1 : N ;
  karismatisk_av_1 : A ;
  karkas_nn_1 : N ;
  karl_nn_1 : N ;
  karlakarl_nn_1 : N ;
  karlaktig_av_1 : A ;
  karlatag_nn_1 : N ;
  karlavulen_av_1 : A ;
  karldagsverke_nn_1 : N ;
  karled_nn_1 : N ;
  karlgalen_av_1 : A ;
  karljohanssvamp_nn_1 : N ;
  karlsbaderbroed_nn_1 : N ;
  karlslok_nn_1 : N ;
  karltokig_av_1 : A ;
  karm_nn_1 : N ;
  karmelit_nn_1 : N ;
  karmelitorden_nn_1 : N ;
  karmstol_nn_1 : N ;
  karnap_nn_1 : N ;
  karneol_nn_1 : N ;
  karneval_nn_1 : N ;
  karnis_nn_1 : N ;
  karnivor_nn_1 : N ;
  karolin_nn_1 : N ;
  karoling_nn_1 : N ;
  karolinsk_av_1 : A ;
  kaross_nn_1 : N ;
  karosseri_nn_1 : N ;
  karotin_nn_1 : N ;
  karott_nn_1 : N ;
  karottunderlaegg_nn_1 : N ;
  karp_nn_1 : N ;
  karpfisk_nn_1 : N ;
  karre_nn_1 : N ;
  karriaer_nn_1 : N ;
  karriaerdiplomat_nn_1 : N ;
  karriaerist_nn_1 : N ;
  karronad_nn_1 : N ;
  karsk_av_1 : A ;
  karst_nn_1 : N ;
  karstbildning_nn_1 : N ;
  kart_nn_1 : N ;
  kartagisk_av_1 : A ;
  kartbild_nn_1 : N ;
  kartbok_nn_1 : N ;
  kartell_nn_1 : N ;
  kartering_nn_1 : N ;
  kartesch_nn_1 : N ;
  kartig_av_1 : A ;
  kartlaeggning_nn_1 : N ;
  kartlaesare_nn_1 : N ;
  kartmaetare_nn_1 : N ;
  kartnagel_nn_1 : N ;
  kartong_nn_1 : N ;
  kartonist_nn_1 : N ;
  kartotek_nn_1 : N ;
  kartprojektion_nn_1 : N ;
  kartspecial_nn_1 : N ;
  karttecken_nn_1 : N ;
  kartusch_nn_1 : N ;
  kartusian_nn_1 : N ;
  kartusianorden_nn_1 : N ;
  karusell_nn_1 : N ;
  karvsnitt_nn_1 : N ;
  karvstock_nn_1 : N ;
  karyatid_nn_1 : N ;
  kas_nn_1 : N ;
  kasack_nn_1 : N ;
  kaschmirsjal_nn_1 : N ;
  kase_nn_1 : N ;
  kasein_nn_1 : N ;
  kasematt_nn_1 : N ;
  kasern_nn_1 : N ;
  kasernfoerbud_nn_1 : N ;
  kaserngaard_nn_1 : N ;
  kashmir_nn_1 : N ;
  kasino_nn_1 : N ;
  kask_nn_1 : N ;
  kaskad_nn_1 : N ;
  kaskelot_nn_1 : N ;
  kaskett_nn_1 : N ;
  kasko_nn_1 : N ;
  kaskofoersaekring_nn_1 : N ;
  kasperteater_nn_1 : N ;
  kass_av_1 : A ;
  kassa_nn_1 : N ;
  kassaaffaer_nn_1 : N ;
  kassaapparat_nn_1 : N ;
  kassabel_av_1 : A ;
  kassabok_nn_1 : N ;
  kassabrist_nn_1 : N ;
  kassakoep_nn_1 : N ;
  kassakontrollapparat_nn_1 : N ;
  kassakreditiv_nn_1 : N ;
  kassakvitto_nn_1 : N ;
  kassapjaes_nn_1 : N ;
  kassarabatt_nn_1 : N ;
  kassareserv_nn_1 : N ;
  kassaskaap_nn_1 : N ;
  kassaskrin_nn_1 : N ;
  kassation_nn_1 : N ;
  kassationsdomstol_nn_1 : N ;
  kassavalv_nn_1 : N ;
  kasse_nn_1 : N ;
  kassett_nn_1 : N ;
  kassettband_nn_1 : N ;
  kassettbandspelare_nn_1 : N ;
  kassettdaeck_nn_1 : N ;
  kassoer_nn_1 : N ;
  kassoerska_nn_1 : N ;
  kassun_nn_1 : N ;
  kast_nn_1 : N ;
  kast_nn_2 : N ;
  kastal_nn_1 : N ;
  kastanj_nn_1 : N ;
  kastanje_nn_1 : N ;
  kastanjebrun_av_1 : A ;
  kastanjett_nn_1 : N ;
  kastblock_nn_1 : N ;
  kastby_nn_1 : N ;
  kastell_nn_1 : N ;
  kastellan_nn_1 : N ;
  kastilian_nn_1 : N ;
  kastilianare_nn_1 : N ;
  kastilianska_nn_2 : N ;
  kastloes_av_1 : A ;
  kastmaerke_nn_1 : N ;
  kastmaskin_nn_1 : N ;
  kastpjaes_nn_1 : N ;
  kastrat_nn_1 : N ;
  kastratsaangare_nn_1 : N ;
  kastrull_nn_1 : N ;
  kastsoem_nn_1 : N ;
  kastspjut_nn_1 : N ;
  kastspoe_nn_1 : N ;
  kaststygn_nn_1 : N ;
  kasttrae_nn_1 : N ;
  kastvapen_nn_1 : N ;
  kastvind_nn_1 : N ;
  kasuar_nn_1 : N ;
  kasuell_av_1 : A ;
  kasun_nn_1 : N ;
  kasus_nn_1 : N ;
  kasus_nn_2 : N ;
  katabatisk_av_1 : A ;
  katafalk_nn_1 : N ;
  kataforisk_av_1 : A ;
  katakomb_nn_1 : N ;
  katakres_nn_1 : N ;
  katalan_nn_1 : N ;
  katalanska_nn_2 : N ;
  katalektisk_av_1 : A ;
  katalepsi_nn_1 : N ;
  katalog_nn_1 : N ;
  katalognummer_nn_1 : N ;
  katalogpris_nn_1 : N ;
  katalysator_nn_1 : N ;
  katalytisk_av_1 : A ;
  katamaran_nn_1 : N ;
  katapult_nn_1 : N ;
  katapultstol_nn_1 : N ;
  katarakt_nn_1 : N ;
  katarr_nn_1 : N ;
  katastrof_nn_1 : N ;
  katastrofal_av_1 : A ;
  katastrofteori_nn_1 : N ;
  kateder_nn_1 : N ;
  katedral_nn_1 : N ;
  kategori_nn_1 : N ;
  kategoriklyvning_nn_1 : N ;
  kategorisk_av_1 : A ;
  katekes_nn_1 : N ;
  kateket_nn_1 : N ;
  kateketisk_av_1 : A ;
  katet_nn_1 : N ;
  kateter_nn_1 : N ;
  katig_av_1 : A ;
  katjon_nn_1 : N ;
  katod_nn_1 : N ;
  katodstraale_nn_1 : N ;
  katodstraaleroer_nn_1 : N ;
  katolik_nn_1 : N ;
  katolsk_av_1 : A ;
  katrinplommon_nn_1 : N ;
  katse_nn_1 : N ;
  katt_nn_1 : N ;
  kattaktig_av_1 : A ;
  kattass_nn_1 : N ;
  kattdjur_nn_1 : N ;
  kattoega_nn_1 : N ;
  kattras_nn_1 : N ;
  kattun_nn_1 : N ;
  kattunge_nn_1 : N ;
  kaukasier_nn_1 : N ;
  kaukasisk_av_1 : A ;
  kaukasiska_nn_1 : N ;
  kauri_nn_1 : N ;
  kaus_nn_1 : N ;
  kausal_av_1 : A ;
  kausalfoerhaallande_nn_1 : N ;
  kausalitet_nn_1 : N ;
  kausalsats_nn_1 : N ;
  kausativ_av_1 : A ;
  kaustik_av_1 : A ;
  kaution_nn_1 : N ;
  kautschuk_nn_1 : N ;
  kautschukparagraf_nn_1 : N ;
  kautschuktraed_nn_1 : N ;
  kav_ab_1 : Adv ;
  kavaj_nn_1 : N ;
  kavajkrage_nn_1 : N ;
  kavalett_nn_1 : N ;
  kavaljer_nn_1 : N ;
  kavaljersflygel_nn_1 : N ;
  kavalkad_nn_1 : N ;
  kavall_nn_1 : N ;
  kavalleri_nn_1 : N ;
  kavallerichock_nn_1 : N ;
  kavallerist_nn_1 : N ;
  kavalleritrupp_nn_1 : N ;
  kavat_av_1 : A ;
  kavel_nn_1 : N ;
  kavelbro_nn_1 : N ;
  kavern_nn_1 : N ;
  kavitet_nn_1 : N ;
  kavitetsdjur_nn_1 : N ;
  kavle_nn_1 : N ;
  kavring_nn_1 : N ;
  kaxe_nn_1 : N ;
  kaxig_av_1 : A ;
  ked_nn_1 : N ;
  kediv_nn_1 : N ;
  kedja_nn_1 : N ;
  kedjebraak_nn_1 : N ;
  kedjebrev_nn_1 : N ;
  kedjehjul_nn_1 : N ;
  kedjehus_nn_1 : N ;
  kedjemolekyl_nn_1 : N ;
  kedjereaktion_nn_1 : N ;
  kedjeskydd_nn_1 : N ;
  kedjesoem_nn_1 : N ;
  kedjestygn_nn_1 : N ;
  kedjevaexel_nn_1 : N ;
  kejsardoeme_nn_1 : N ;
  kejsare_nn_1 : N ;
  kejsarhaer_nn_1 : N ;
  kejsarinna_nn_1 : N ;
  kejsaroern_nn_1 : N ;
  kejsarsnitt_nn_1 : N ;
  kejserlig_av_1 : A ;
  kelen_av_1 : A ;
  kelgris_nn_1 : N ;
  kelig_av_1 : A ;
  kelim_nn_1 : N ;
  kelsjuk_av_1 : A ;
  kelt_nn_1 : N ;
  keltisk_av_1 : A ;
  keltiska_nn_2 : N ;
  kelvin_nn_1 : N ;
  kemiindustri_nn_1 : N ;
  kemisk_av_1 : A ;
  kemist_nn_1 : N ;
  kemomat_nn_1 : N ;
  kemoterapi_nn_1 : N ;
  kemtvaett_nn_1 : N ;
  kennel_nn_1 : N ;
  kenning_nn_1 : N ;
  kentaur_nn_1 : N ;
  kenyan_nn_1 : N ;
  keps_nn_1 : N ;
  keramiker_nn_1 : N ;
  keramikform_nn_1 : N ;
  kerub_nn_1 : N ;
  ketch_nn_1 : N ;
  kex_nn_1 : N ;
  khan_nn_1 : N ;
  khmer_nn_1 : N ;
  kiasm_nn_1 : N ;
  kibbutz_nn_1 : N ;
  kick_nn_1 : N ;
  kickstart_nn_1 : N ;
  kid_nn_1 : N ;
  kidnappare_nn_1 : N ;
  kikaert_nn_1 : N ;
  kikare_nn_1 : N ;
  kikhaal_nn_1 : N ;
  kikkran_nn_1 : N ;
  kil_nn_1 : N ;
  kilben_nn_1 : N ;
  kilhael_nn_1 : N ;
  kilklack_nn_1 : N ;
  kille_nn_1 : N ;
  killespel_nn_1 : N ;
  killig_av_1 : A ;
  killing_nn_1 : N ;
  kilo_nn_1 : N ;
  kilobyte_nn_1 : N ;
  kilogram_nn_1 : N ;
  kilogrammeter_nn_1 : N ;
  kilometer_nn_1 : N ;
  kilometertjock_av_1 : A ;
  kilopond_nn_1 : N ;
  kilopondmeter_nn_1 : N ;
  kilopris_nn_1 : N ;
  kiloton_nn_1 : N ;
  kilowatt_nn_1 : N ;
  kilram_nn_1 : N ;
  kilt_nn_1 : N ;
  kimono_nn_1 : N ;
  kinaalkaloid_nn_1 : N ;
  kind_nn_1 : N ;
  kindben_nn_1 : N ;
  kindkedja_nn_1 : N ;
  kindpaase_nn_1 : N ;
  kindpust_nn_1 : N ;
  kindtand_nn_1 : N ;
  kinematograf_nn_1 : N ;
  kines_nn_1 : N ;
  kineseri_nn_1 : N ;
  kinesisk_av_1 : A ;
  kinesiska_nn_2 : N ;
  kinestetisk_av_1 : A ;
  kinetisk_av_1 : A ;
  king_size_av_1 : A ;
  kink_nn_1 : N ;
  kinkig_av_1 : A ;
  kiosk_nn_1 : N ;
  kip_nn_1 : N ;
  kippsko_nn_1 : N ;
  kippskodd_av_1 : A ;
  kirgis_nn_1 : N ;
  kiribatier_nn_1 : N ;
  kiribatisk_av_1 : A ;
  kiropraktiker_nn_1 : N ;
  kiropraktor_nn_1 : N ;
  kirurg_nn_1 : N ;
  kirurgisk_av_1 : A ;
  kis_nn_1 : N ;
  kis_nn_2 : N ;
  kiselalg_nn_1 : N ;
  kiselfoerening_nn_1 : N ;
  kiselkristall_nn_1 : N ;
  kiselsten_nn_1 : N ;
  kisse_nn_1 : N ;
  kissekatt_nn_1 : N ;
  kissemiss_nn_1 : N ;
  kissnoedig_av_1 : A ;
  kistbotten_nn_1 : N ;
  kistebrev_nn_1 : N ;
  kiton_nn_1 : N ;
  kitslig_av_1 : A ;
  kittel_nn_1 : N ;
  kitteldal_nn_1 : N ;
  kittelflickare_nn_1 : N ;
  kittlare_nn_1 : N ;
  kittlig_av_1 : A ;
  kivi_nn_1 : N ;
  kiwi_nn_1 : N ;
  kjol_nn_1 : N ;
  kjoltyg_nn_1 : N ;
  kjortel_nn_1 : N ;
  kjortelvaegen_ab_1 : Adv ;
  klaafingrig_av_1 : A ;
  klaapare_nn_1 : N ;
  klabb_nn_1 : N ;
  klabbe_nn_1 : N ;
  klabbskoet_nn_1 : N ;
  klabbstroemming_nn_1 : N ;
  klack_nn_1 : N ;
  klackbar_nn_1 : N ;
  klackjaern_nn_1 : N ;
  klackring_nn_1 : N ;
  klackspark_nn_1 : N ;
  kladd_nn_1 : N ;
  kladdig_av_1 : A ;
  klaedd_av_1 : A ;
  klaededraekt_nn_1 : N ;
  klaedespersedel_nn_1 : N ;
  klaedesplagg_nn_1 : N ;
  klaedgalen_av_1 : A ;
  klaedhaengare_nn_1 : N ;
  klaedkammare_nn_1 : N ;
  klaedkorg_nn_1 : N ;
  klaedlus_nn_1 : N ;
  klaedmal_nn_1 : N ;
  klaednad_nn_1 : N ;
  klaedsam_av_1 : A ;
  klaedsel_nn_1 : N ;
  klaedskaap_nn_1 : N ;
  klaedstreck_nn_1 : N ;
  klaedtvaett_nn_1 : N ;
  klaem_nn_1 : N ;
  klaemdag_nn_1 : N ;
  klaemmare_nn_1 : N ;
  klaemmig_av_1 : A ;
  klaemtare_nn_1 : N ;
  klaengig_av_1 : A ;
  klaengvaext_nn_1 : N ;
  klaenning_nn_1 : N ;
  klaenningsliv_nn_1 : N ;
  klaepp_nn_1 : N ;
  klaervoajant_av_1 : A ;
  klaett_nn_1 : N ;
  klaetterfaagel_nn_1 : N ;
  klaetterfot_nn_1 : N ;
  klaetterjaern_nn_1 : N ;
  klaettersko_nn_1 : N ;
  klaetterstaellning_nn_1 : N ;
  klaettervaext_nn_1 : N ;
  klaettrare_nn_1 : N ;
  klaettring_nn_1 : N ;
  klaff_nn_1 : N ;
  klaffbord_nn_1 : N ;
  klaffbro_nn_1 : N ;
  klaffel_nn_1 : N ;
  klagande_nn_1 : N ;
  klagomaal_nn_1 : N ;
  klagomur_nn_1 : N ;
  klagorop_nn_1 : N ;
  klagosaang_nn_1 : N ;
  klagotid_nn_1 : N ;
  klam_nn_1 : N ;
  klammer_nn_1 : N ;
  klammeri_nn_1 : N ;
  klamp_nn_1 : N ;
  klan_nn_1 : N ;
  klanderfri_av_1 : A ;
  klandervaerd_av_1 : A ;
  klang_nn_1 : N ;
  klangbotten_nn_1 : N ;
  klangfaerg_nn_1 : N ;
  klangfull_av_1 : A ;
  klanglig_av_1 : A ;
  klangloes_av_1 : A ;
  klant_nn_1 : N ;
  klantig_av_1 : A ;
  klantskalle_nn_1 : N ;
  klapp_nn_1 : N ;
  klappbraede_nn_1 : N ;
  klappersten_nn_1 : N ;
  klapperstenstrand_nn_1 : N ;
  klappjakt_nn_1 : N ;
  klapptrae_nn_1 : N ;
  klar_av_1 : A ;
  klarbaer_nn_1 : N ;
  klarblaa_av_1 : A ;
  klarhet_nn_1 : N ;
  klarinett_nn_1 : N ;
  klarligen_ab_1 : Adv ;
  klarmedel_nn_1 : N ;
  klaroegd_av_1 : A ;
  klarroed_av_1 : A ;
  klarsignal_nn_1 : N ;
  klarskinn_nn_1 : N ;
  klarsynt_av_1 : A ;
  klartaenkt_av_1 : A ;
  klartecken_nn_1 : N ;
  klarvaken_av_1 : A ;
  klase_nn_1 : N ;
  klass_nn_1 : N ;
  klassbok_nn_1 : N ;
  klassfoerestaandare_nn_1 : N ;
  klassicitet_nn_1 : N ;
  klassificering_nn_1 : N ;
  klassifikation_nn_1 : N ;
  klassik_nn_1 : N ;
  klassiker_nn_1 : N ;
  klassiserande_av_1 : A ;
  klassisk_av_1 : A ;
  klasskamp_nn_1 : N ;
  klasskamrat_nn_1 : N ;
  klasskillnad_nn_1 : N ;
  klasskonferens_nn_1 : N ;
  klasslaerare_nn_1 : N ;
  klasslag_nn_1 : N ;
  klasslag_nn_2 : N ;
  klassloes_av_1 : A ;
  klassmaerke_nn_1 : N ;
  klassmamma_nn_1 : N ;
  klassmedveten_av_1 : A ;
  klassmoerj_nn_1 : N ;
  klassmotsaettning_nn_1 : N ;
  klasspappa_nn_1 : N ;
  klassrum_nn_1 : N ;
  klatsch_nn_1 : N ;
  klatschig_av_1 : A ;
  klausul_nn_1 : N ;
  klav_nn_1 : N ;
  klavbinda_vb_1 : V ;
  klave_nn_1 : N ;
  klavecin_nn_1 : N ;
  klaver_nn_1 : N ;
  klavertramp_nn_1 : N ;
  klaverutdrag_nn_1 : N ;
  klaviatur_nn_1 : N ;
  klavikord_nn_1 : N ;
  klematis_nn_1 : N ;
  klementin_nn_1 : N ;
  klemig_av_1 : A ;
  klen_av_1 : A ;
  klenaet_nn_1 : N ;
  klenhus_nn_1 : N ;
  klenod_nn_1 : N ;
  klensmed_nn_1 : N ;
  klensmide_nn_1 : N ;
  klenspaenning_nn_1 : N ;
  klentrogen_av_1 : A ;
  klenvuxen_av_1 : A ;
  kleptoman_nn_1 : N ;
  klerikal_av_1 : A ;
  klerk_nn_1 : N ;
  kletig_av_1 : A ;
  klev_nn_1 : N ;
  klibbal_nn_1 : N ;
  klibbig_av_1 : A ;
  kliche_nn_1 : N ;
  klick_nn_1 : N ;
  klick_nn_2 : N ;
  klient_nn_1 : N ;
  klientel_nn_1 : N ;
  klimat_nn_1 : N ;
  klimatfoeraendring_nn_1 : N ;
  klimatforskare_nn_1 : N ;
  klimatgraens_nn_1 : N ;
  klimatkammare_nn_1 : N ;
  klimatmodell_nn_1 : N ;
  klimatologisk_av_1 : A ;
  klimatombyte_nn_1 : N ;
  klimatskael_nn_1 : N ;
  klimatsystem_nn_1 : N ;
  klimatvariation_nn_1 : N ;
  klimatzon_nn_1 : N ;
  klimax_nn_1 : N ;
  klimp_nn_1 : N ;
  klinhus_nn_1 : N ;
  klinik_nn_1 : N ;
  kliniker_nn_1 : N ;
  klinisk_av_1 : A ;
  klinkbyggd_av_1 : A ;
  klint_nn_1 : N ;
  klipp_nn_1 : N ;
  klippare_nn_1 : N ;
  klippblock_nn_1 : N ;
  klippdass_nn_1 : N ;
  klipper_nn_1 : N ;
  klipperstaev_nn_1 : N ;
  klippfisk_nn_1 : N ;
  klippformation_nn_1 : N ;
  klippfyr_nn_1 : N ;
  klippgrav_nn_1 : N ;
  klippig_av_1 : A ;
  klipping_nn_1 : N ;
  klippkort_nn_1 : N ;
  klippljus_nn_1 : N ;
  klippmaalning_nn_1 : N ;
  klippmassiv_nn_1 : N ;
  klippning_nn_1 : N ;
  klippotek_nn_1 : N ;
  klippspik_nn_1 : N ;
  klipptaang_nn_1 : N ;
  klippvaegg_nn_1 : N ;
  klipsk_av_1 : A ;
  klistrig_av_1 : A ;
  klitoris_nn_1 : N ;
  kliv_nn_1 : N ;
  klo_nn_1 : N ;
  kloak_nn_1 : N ;
  kloakdjur_nn_1 : N ;
  kloasongvaegg_nn_1 : N ;
  klockare_nn_1 : N ;
  klockarkaerlek_nn_1 : N ;
  klockarkatt_nn_1 : N ;
  klockboj_nn_1 : N ;
  klockformig_av_1 : A ;
  klockkedja_nn_1 : N ;
  klockklaepp_nn_1 : N ;
  klockren_av_1 : A ;
  klockringning_nn_1 : N ;
  klocksignal_nn_1 : N ;
  klockslag_nn_1 : N ;
  klockspel_nn_1 : N ;
  klockstapel_nn_1 : N ;
  klockstraeng_nn_1 : N ;
  klocktid_nn_1 : N ;
  klocktorn_nn_1 : N ;
  kloev_nn_1 : N ;
  kloever_nn_1 : N ;
  kloeverblad_nn_1 : N ;
  kloeverliknande_av_1 : A ;
  kloeversnaerja_nn_1 : N ;
  kloevertroett_av_1 : A ;
  kloevjeren_nn_1 : N ;
  kloevjesadel_nn_1 : N ;
  kloevsadel_nn_1 : N ;
  kloevsadelkyrka_nn_1 : N ;
  kloevsadelsbyggnad_nn_1 : N ;
  kloevsadelskyrka_nn_1 : N ;
  klok_av_1 : A ;
  klokhuvud_nn_1 : N ;
  klon_nn_1 : N ;
  klonering_nn_1 : N ;
  klorat_nn_1 : N ;
  kloratom_nn_1 : N ;
  klorfenol_nn_1 : N ;
  klorid_nn_1 : N ;
  klosett_nn_1 : N ;
  kloss_ab_1 : Adv ;
  kloss_nn_1 : N ;
  klossig_av_1 : A ;
  kloster_nn_1 : N ;
  klosterbroder_nn_1 : N ;
  klostercell_nn_1 : N ;
  klosterkyrka_nn_1 : N ;
  klosterlikoer_nn_1 : N ;
  klosterorden_nn_1 : N ;
  klosterregel_nn_1 : N ;
  klostersyster_nn_1 : N ;
  klot_nn_1 : N ;
  klotblixt_nn_1 : N ;
  klotrund_av_1 : A ;
  klots_nn_1 : N ;
  klotterplank_nn_1 : N ;
  klottrig_av_1 : A ;
  klove_nn_1 : N ;
  klubb_nn_1 : N ;
  klubbafton_nn_1 : N ;
  klubblaengd_nn_1 : N ;
  klubbmaerke_nn_1 : N ;
  klubbmaestare_nn_1 : N ;
  klubbsandwich_nn_1 : N ;
  klubbslag_nn_1 : N ;
  kludd_nn_2 : N ;
  klump_nn_1 : N ;
  klumpackord_nn_1 : N ;
  klumpedump_nn_1 : N ;
  klumpeduns_nn_1 : N ;
  klumpfisk_nn_1 : N ;
  klumpig_av_1 : A ;
  klumpsoem_nn_1 : N ;
  klumpsumma_nn_1 : N ;
  klumpvis_ab_1 : Adv ;
  klunk_nn_1 : N ;
  kluns_nn_1 : N ;
  klunsig_av_1 : A ;
  klurig_av_1 : A ;
  kluring_nn_1 : N ;
  klusil_nn_1 : N ;
  klut_nn_1 : N ;
  kluven_av_1 : A ;
  klyft_nn_1 : N ;
  klyftig_av_1 : A ;
  klys_nn_1 : N ;
  klyva_vb_1 : V ;
  klyvarbom_nn_1 : N ;
  klyvare_nn_1 : N ;
  klyvbar_av_1 : A ;
  klyvning_nn_1 : N ;
  klyvningsreaktion_nn_1 : N ;
  klyvoeppning_nn_1 : N ;
  knack_nn_1 : N ;
  knackig_av_1 : A ;
  knackning_nn_1 : N ;
  knackvurst_nn_1 : N ;
  knae_nn_1 : N ;
  knaeck_nn_1 : N ;
  knaeck_nn_2 : N ;
  knaeckebroed_nn_1 : N ;
  knaeckepil_nn_1 : N ;
  knaeckform_nn_1 : N ;
  knaeckfraaga_nn_1 : N ;
  knaeckt_av_1 : A ;
  knaefalla_vb_1 : V ;
  knaehoeg_av_1 : A ;
  knaehund_nn_1 : N ;
  knaekort_av_1 : A ;
  knaelaang_av_1 : A ;
  knaeled_nn_1 : N ;
  knaepp_av_1 : A ;
  knaepp_nn_1 : N ;
  knaeppbagge_nn_1 : N ;
  knaeppning_nn_1 : N ;
  knaeroer_nn_1 : N ;
  knaeskaal_nn_1 : N ;
  knaeskydd_nn_1 : N ;
  knaeslut_nn_1 : N ;
  knaesvag_av_1 : A ;
  knaetofs_nn_1 : N ;
  knaeveck_nn_1 : N ;
  knaevelborr_nn_1 : N ;
  knaevring_nn_1 : N ;
  knagg_nn_1 : N ;
  knagglig_av_1 : A ;
  knal_av_1 : A ;
  knall_av_1 : A ;
  knall_nn_1 : N ;
  knalle_nn_1 : N ;
  knallhaard_av_1 : A ;
  knallhatt_nn_1 : N ;
  knalltransport_nn_1 : N ;
  knap_nn_1 : N ;
  knape_nn_1 : N ;
  knaper_av_1 : A ;
  knapp_av_1 : A ;
  knapp_nn_1 : N ;
  knappast_ab_1 : Adv ;
  knapphaal_nn_1 : N ;
  knapphaendig_av_1 : A ;
  knapphet_nn_1 : N ;
  knappnaal_nn_1 : N ;
  knappnaalshuvud_nn_1 : N ;
  knappt_ab_1 : Adv ;
  knapptelefon_nn_1 : N ;
  knaprig_av_1 : A ;
  knarkare_nn_1 : N ;
  knarkarkvart_nn_1 : N ;
  knarr_nn_2 : N ;
  knarrig_av_1 : A ;
  knasig_av_1 : A ;
  knasprig_av_1 : A ;
  knast_nn_1 : N ;
  knaster_nn_2 : N ;
  knastrig_av_1 : A ;
  knatte_nn_1 : N ;
  knatting_nn_1 : N ;
  kneg_nn_1 : N ;
  knegare_nn_1 : N ;
  knejpkur_nn_1 : N ;
  knekt_nn_1 : N ;
  knep_nn_1 : N ;
  knepig_av_1 : A ;
  knick_nn_1 : N ;
  knip_nn_1 : N ;
  knipa_vb_1 : V ;
  knipslug_av_1 : A ;
  kniptaang_nn_1 : N ;
  kniptaangsmanoever_nn_1 : N ;
  kniv_nn_1 : N ;
  knivblad_nn_1 : N ;
  knivbladslik_av_1 : A ;
  knivhugg_nn_1 : N ;
  knivig_av_1 : A ;
  knivkastning_nn_1 : N ;
  knivkontakt_nn_1 : N ;
  knivlaeggare_nn_1 : N ;
  knivrygg_nn_1 : N ;
  knivskaft_nn_1 : N ;
  knivskarp_av_1 : A ;
  knivskuren_av_1 : A ;
  knivsrygg_nn_1 : N ;
  knivsudd_nn_1 : N ;
  knix_nn_1 : N ;
  knockdown_nn_1 : N ;
  knockout_nn_1 : N ;
  knodd_nn_1 : N ;
  knoddaen_av_1 : A ;
  knoedel_nn_1 : N ;
  knoel_nn_1 : N ;
  knoelaktig_av_1 : A ;
  knoelig_av_1 : A ;
  knoelpaak_nn_1 : N ;
  knoelrot_nn_1 : N ;
  knoelstam_nn_1 : N ;
  knoelsvan_nn_1 : N ;
  knoes_nn_1 : N ;
  knog_nn_1 : N ;
  knoge_nn_1 : N ;
  knogig_av_1 : A ;
  knogjaern_nn_1 : N ;
  knollrig_av_1 : A ;
  knop_nn_1 : N ;
  knop_nn_2 : N ;
  knopp_nn_1 : N ;
  knoppig_av_1 : A ;
  knoppsaettning_nn_1 : N ;
  knoppsprickning_nn_1 : N ;
  knorr_nn_1 : N ;
  knorrhane_nn_1 : N ;
  knoster_nn_1 : N ;
  knot_nn_1 : N ;
  knotig_av_1 : A ;
  knott_nn_1 : N ;
  knottrig_av_1 : A ;
  knubbig_av_1 : A ;
  knubbsael_nn_1 : N ;
  knuff_nn_1 : N ;
  knull_nn_1 : N ;
  knusslig_av_1 : A ;
  knut_nn_1 : N ;
  knutbroderi_nn_1 : N ;
  knuten_av_1 : A ;
  knutig_av_1 : A ;
  knutpunkt_nn_1 : N ;
  knutte_nn_1 : N ;
  knyck_nn_1 : N ;
  knyckig_av_1 : A ;
  knyst_nn_1 : N ;
  knyta_vb_1 : V ;
  knytkalas_nn_1 : N ;
  knytnaeve_nn_1 : N ;
  knytnaevsslag_nn_1 : N ;
  knytskaerp_nn_1 : N ;
  ko_nn_1 : N ;
  koalition_nn_1 : N ;
  koalitionsregering_nn_1 : N ;
  koaxialkabel_nn_1 : N ;
  kobbe_nn_1 : N ;
  kobbel_nn_1 : N ;
  kobent_av_1 : A ;
  kobolthalt_nn_1 : N ;
  kobolthaltig_av_1 : A ;
  koboltkanon_nn_1 : N ;
  kock_nn_1 : N ;
  kock_nn_2 : N ;
  kod_nn_1 : N ;
  kodex_nn_1 : N ;
  kodicill_nn_1 : N ;
  kodifikation_nn_1 : N ;
  koe_nn_1 : N ;
  koefficient_nn_1 : N ;
  koek_nn_1 : N ;
  koekkenmoedding_nn_1 : N ;
  koeksbord_nn_1 : N ;
  koeksflaekt_nn_1 : N ;
  koekshandduk_nn_1 : N ;
  koeksingaang_nn_1 : N ;
  koeksmaestare_nn_1 : N ;
  koeksmaskin_nn_1 : N ;
  koeksrulle_nn_1 : N ;
  koekssax_nn_1 : N ;
  koeksspis_nn_1 : N ;
  koekstraedgaard_nn_1 : N ;
  koeksvaext_nn_1 : N ;
  koel_nn_1 : N ;
  koelbaat_nn_1 : N ;
  koeldbestaendig_av_1 : A ;
  koeldblandning_nn_1 : N ;
  koeldgrad_nn_1 : N ;
  koeldhaerdig_av_1 : A ;
  koeldknaepp_nn_1 : N ;
  koeldpol_nn_1 : N ;
  koeldpunkt_nn_1 : N ;
  koelsvin_nn_1 : N ;
  koen_nn_1 : N ;
  koenlig_av_1 : A ;
  koenloes_av_1 : A ;
  koensakt_nn_1 : N ;
  koensbunden_av_1 : A ;
  koensbyte_nn_1 : N ;
  koenscell_nn_1 : N ;
  koenshormon_nn_1 : N ;
  koenskaraktaer_nn_1 : N ;
  koenskoertel_nn_1 : N ;
  koenslig_av_1 : A ;
  koensmogen_av_1 : A ;
  koensmognad_nn_1 : N ;
  koensord_nn_1 : N ;
  koensorgan_nn_1 : N ;
  koensroll_nn_1 : N ;
  koenssjukdom_nn_1 : N ;
  koensumgaenge_nn_1 : N ;
  koensvarelse_nn_1 : N ;
  koep_nn_1 : N ;
  koepare_nn_1 : N ;
  koepcentrum_nn_1 : N ;
  koepebrev_nn_1 : N ;
  koepebroed_nn_1 : N ;
  koepekontrakt_nn_1 : N ;
  koepenickiad_nn_1 : N ;
  koepenskap_nn_1 : N ;
  koepeskilling_nn_1 : N ;
  koeping_nn_1 : N ;
  koepkort_nn_1 : N ;
  koepkurs_nn_1 : N ;
  koepman_nn_1 : N ;
  koepslut_nn_1 : N ;
  koepstad_nn_1 : N ;
  koepstark_av_1 : A ;
  koer_nn_1 : N ;
  koerare_nn_1 : N ;
  koerbar_av_1 : A ;
  koeregenskap_nn_1 : N ;
  koerfaelt_nn_1 : N ;
  koerfoerbud_nn_1 : N ;
  koerig_av_1 : A ;
  koerkarl_nn_1 : N ;
  koerkort_nn_1 : N ;
  koerkortsprov_nn_1 : N ;
  koerledare_nn_1 : N ;
  koerlektion_nn_1 : N ;
  koernare_nn_1 : N ;
  koerning_nn_1 : N ;
  koerriktningsvisare_nn_1 : N ;
  koersbaer_nn_1 : N ;
  koersbaerstraed_nn_1 : N ;
  koersnaer_nn_1 : N ;
  koersven_nn_1 : N ;
  koertel_nn_1 : N ;
  koertelcell_nn_1 : N ;
  koerteloeppning_nn_1 : N ;
  koertid_nn_1 : N ;
  koervaeg_nn_1 : N ;
  koettaetande_av_1 : A ;
  koettaetare_nn_1 : N ;
  koettben_nn_1 : N ;
  koettbulle_nn_1 : N ;
  koetted_nn_1 : N ;
  koettig_av_1 : A ;
  koettkvarn_nn_1 : N ;
  koettmarknad_nn_1 : N ;
  koettsaar_nn_1 : N ;
  koettsida_nn_1 : N ;
  koettslig_av_1 : A ;
  kofaangare_nn_1 : N ;
  koff_nn_1 : N ;
  kofferdamm_nn_1 : N ;
  kofferdist_nn_1 : N ;
  koffernagel_nn_1 : N ;
  koffert_nn_1 : N ;
  koffertfisk_nn_1 : N ;
  kofot_nn_1 : N ;
  koger_nn_1 : N ;
  kogg_nn_1 : N ;
  kognat_nn_1 : N ;
  kognatisk_av_1 : A ;
  kognitiv_av_1 : A ;
  koherent_av_1 : A ;
  kohort_nn_1 : N ;
  kohud_nn_1 : N ;
  koj_nn_1 : N ;
  kok_nn_1 : N ;
  kokapparat_nn_1 : N ;
  kokard_nn_1 : N ;
  kokare_nn_1 : N ;
  kokarreaktor_nn_1 : N ;
  kokbok_nn_1 : N ;
  kokeri_nn_1 : N ;
  kokerska_nn_1 : N ;
  kokett_av_1 : A ;
  kokett_nn_1 : N ;
  koketteri_nn_1 : N ;
  kokgrop_nn_1 : N ;
  kokhet_av_1 : A ;
  kokill_nn_1 : N ;
  kokkaerl_nn_1 : N ;
  kokkorv_nn_1 : N ;
  kokong_nn_1 : N ;
  kokosboll_nn_1 : N ;
  kokosfiber_nn_1 : N ;
  kokosnoet_nn_1 : N ;
  kokospalm_nn_1 : N ;
  kokott_nn_1 : N ;
  kokpunkt_nn_1 : N ;
  koktid_nn_1 : N ;
  kokvagn_nn_1 : N ;
  kokvraa_nn_1 : N ;
  kol_14_laboratorium_nn_1 : N ;
  kol_nn_1 : N ;
  kolare_nn_1 : N ;
  kolatom_nn_1 : N ;
  kolatraed_nn_1 : N ;
  kolbaerare_nn_1 : N ;
  kolbit_nn_1 : N ;
  kolborste_nn_1 : N ;
  kolbotten_nn_1 : N ;
  kolbox_nn_1 : N ;
  kolbrikett_nn_1 : N ;
  kolbulle_nn_1 : N ;
  kolchos_nn_1 : N ;
  koldioxidfri_av_1 : A ;
  koldioxidkanal_nn_1 : N ;
  koldioxidmolekyl_nn_1 : N ;
  koleld_nn_1 : N ;
  kolerabakterie_nn_1 : N ;
  kolerakyrkogaard_nn_1 : N ;
  koleriker_nn_1 : N ;
  kolerisk_av_1 : A ;
  kolfloets_nn_1 : N ;
  kolfoerening_nn_1 : N ;
  kolhaemtare_nn_1 : N ;
  kolhalt_nn_1 : N ;
  kolhaltig_av_1 : A ;
  kolhoeg_nn_1 : N ;
  kolhydrat_nn_1 : N ;
  kolibakterie_nn_1 : N ;
  kolibri_nn_1 : N ;
  koling_nn_1 : N ;
  kolisotop_nn_1 : N ;
  kolje_nn_1 : N ;
  kolkaellare_nn_1 : N ;
  koll_nn_1 : N ;
  kollaboratoer_nn_1 : N ;
  kollage_nn_1 : N ;
  kollaps_nn_1 : N ;
  kollation_nn_1 : N ;
  kollega_nn_1 : N ;
  kollegial_av_1 : A ;
  kollegialitet_nn_1 : N ;
  kollegieblock_nn_1 : N ;
  kollegium_nn_1 : N ;
  kollekt_nn_1 : N ;
  kollektion_nn_1 : N ;
  kollektiv_av_1 : A ;
  kollektiv_nn_1 : N ;
  kollektivanslutning_nn_1 : N ;
  kollektivanstaelld_av_1 : A ;
  kollektivanstaellning_nn_1 : N ;
  kollektivavtal_nn_1 : N ;
  kollektivfil_nn_1 : N ;
  kollektivfoersaekring_nn_1 : N ;
  kollektivhus_nn_1 : N ;
  kollektivjordbruk_nn_1 : N ;
  kollektivnot_nn_1 : N ;
  kollektor_nn_1 : N ;
  kolli_nn_1 : N ;
  kollision_nn_1 : N ;
  kollisionskurs_nn_1 : N ;
  kollisionsskott_nn_1 : N ;
  kollo_nn_1 : N ;
  kolloid_nn_1 : N ;
  kolloidal_av_1 : A ;
  kollokvium_nn_1 : N ;
  kollrig_av_1 : A ;
  kolmoerk_av_1 : A ;
  kolning_nn_1 : N ;
  kolofon_nn_1 : N ;
  kolokvint_nn_1 : N ;
  kolon_nn_1 : N ;
  kolonat_nn_1 : N ;
  koloni_nn_1 : N ;
  kolonial_av_1 : A ;
  kolonialarme_nn_1 : N ;
  kolonialkrig_nn_1 : N ;
  kolonialmakt_nn_1 : N ;
  kolonialvaelde_nn_1 : N ;
  kolonilott_nn_1 : N ;
  kolonisation_nn_1 : N ;
  kolonisationstid_nn_1 : N ;
  kolonisatoer_nn_1 : N ;
  kolonistuga_nn_1 : N ;
  kolonn_nn_1 : N ;
  kolonnad_nn_1 : N ;
  kolonnett_nn_1 : N ;
  kolonnordning_nn_1 : N ;
  koloradoskalbagge_nn_1 : N ;
  koloratur_nn_1 : N ;
  koloratursaangerska_nn_1 : N ;
  kolorist_nn_1 : N ;
  kolorit_nn_1 : N ;
  koloss_nn_1 : N ;
  kolossal_av_1 : A ;
  kolportagemaessig_av_1 : A ;
  kolportoer_nn_1 : N ;
  kolryss_nn_1 : N ;
  kolstaal_nn_1 : N ;
  kolstift_nn_1 : N ;
  kolsvart_av_1 : A ;
  kolsyraassimilation_nn_1 : N ;
  kolt_nn_1 : N ;
  koltablett_nn_1 : N ;
  koltavdelning_nn_1 : N ;
  koltbarn_nn_1 : N ;
  kolteckning_nn_1 : N ;
  koltraad_nn_1 : N ;
  koltrast_nn_1 : N ;
  kolugn_av_1 : A ;
  kolumbarium_nn_1 : N ;
  kolumn_nn_1 : N ;
  kolumnist_nn_1 : N ;
  kolumntitel_nn_1 : N ;
  kolv_nn_1 : N ;
  kolvhals_nn_1 : N ;
  kolvmotor_nn_1 : N ;
  komatoes_av_1 : A ;
  kombattant_nn_1 : N ;
  kombinat_nn_1 : N ;
  kombination_nn_1 : N ;
  kombinationslaas_nn_1 : N ;
  kombinationsmaattsats_nn_1 : N ;
  kombinationstaevling_nn_1 : N ;
  kombinatorisk_av_1 : A ;
  komedi_nn_1 : N ;
  komediant_nn_1 : N ;
  komedienn_nn_1 : N ;
  komet_nn_1 : N ;
  kometmoln_nn_1 : N ;
  komfortabel_av_1 : A ;
  komiker_nn_1 : N ;
  komisk_av_1 : A ;
  komma_nn_1 : N ;
  komma_vb_1 : V ;
  kommabacill_nn_1 : N ;
  kommande_av_1 : A ;
  kommanditbolag_nn_1 : N ;
  kommanditdelaegare_nn_1 : N ;
  kommando_nn_1 : N ;
  kommandomaal_nn_1 : N ;
  kommandoord_nn_1 : N ;
  kommandoroest_nn_1 : N ;
  kommatering_nn_1 : N ;
  kommendant_nn_1 : N ;
  kommendantur_nn_1 : N ;
  kommendering_nn_1 : N ;
  kommendoer_nn_1 : N ;
  kommendoerkapten_nn_1 : N ;
  kommensurabel_av_1 : A ;
  kommentar_nn_1 : N ;
  kommentator_nn_1 : N ;
  kommers_nn_1 : N ;
  kommerseraad_nn_1 : N ;
  kommersialisering_nn_1 : N ;
  kommersiell_av_1 : A ;
  kommerskollegium_nn_1 : N ;
  komminister_nn_1 : N ;
  kommissariat_nn_1 : N ;
  kommissarie_nn_1 : N ;
  kommission_nn_1 : N ;
  kommissionaer_nn_1 : N ;
  kommitte_nn_1 : N ;
  kommod_nn_1 : N ;
  kommun_nn_1 : N ;
  kommunaegd_av_1 : A ;
  kommunal_av_1 : A ;
  kommunalfoervaltning_nn_1 : N ;
  kommunalfullmaektig_nn_1 : N ;
  kommunalhus_nn_1 : N ;
  kommunallag_nn_1 : N ;
  kommunalman_nn_1 : N ;
  kommunalnaemnd_nn_1 : N ;
  kommunalnaemndsordfoerande_nn_1 : N ;
  kommunalordfoerande_nn_1 : N ;
  kommunalpolitiker_nn_1 : N ;
  kommunalpolitisk_av_1 : A ;
  kommunalraad_nn_1 : N ;
  kommunalskatt_nn_1 : N ;
  kommunalstyrelse_nn_1 : N ;
  kommunalval_nn_1 : N ;
  kommunard_nn_1 : N ;
  kommunblock_nn_1 : N ;
  kommundel_nn_1 : N ;
  kommundelsraad_nn_1 : N ;
  kommunfoerbund_nn_1 : N ;
  kommunfullmaektig_nn_1 : N ;
  kommunikant_nn_1 : N ;
  kommunikation_nn_1 : N ;
  kommunikationsakt_nn_1 : N ;
  kommunikationsdepartement_nn_1 : N ;
  kommunikationsmedel_nn_1 : N ;
  kommunikationsminister_nn_1 : N ;
  kommunikationsnaet_nn_1 : N ;
  kommunikationsradio_nn_1 : N ;
  kommunikationssatellit_nn_1 : N ;
  kommunikationstabell_nn_1 : N ;
  kommunikativ_av_1 : A ;
  kommunikatoer_nn_1 : N ;
  kommunikator_nn_1 : N ;
  kommunike_nn_1 : N ;
  kommuninnevaanare_nn_1 : N ;
  kommuninvaanare_nn_1 : N ;
  kommunion_nn_1 : N ;
  kommunist_nn_1 : N ;
  kommunistisk_av_1 : A ;
  kommunistland_nn_1 : N ;
  kommunistparti_nn_1 : N ;
  kommunistregim_nn_1 : N ;
  kommunistvaerld_nn_1 : N ;
  kommunpolitiker_nn_1 : N ;
  kommunsammanslagning_nn_1 : N ;
  kommunstyrelse_nn_1 : N ;
  kommutativ_av_1 : A ;
  kommutator_nn_1 : N ;
  kompakt_av_1 : A ;
  kompani_nn_1 : N ;
  kompaniadjutant_nn_1 : N ;
  kompaniofficer_nn_1 : N ;
  kompaniorder_nn_1 : N ;
  kompanjon_nn_1 : N ;
  komparabel_av_1 : A ;
  komparation_nn_1 : N ;
  komparativ_av_1 : A ;
  komparativ_nn_1 : N ;
  kompars_nn_1 : N ;
  kompass_nn_1 : N ;
  kompasshus_nn_1 : N ;
  kompasskurs_nn_1 : N ;
  kompassnaal_nn_1 : N ;
  kompatibel_av_1 : A ;
  kompendium_nn_1 : N ;
  kompensation_nn_1 : N ;
  kompensator_nn_1 : N ;
  kompensatorisk_av_1 : A ;
  kompetens_nn_1 : N ;
  kompetent_av_1 : A ;
  kompilat_nn_1 : N ;
  kompilation_nn_1 : N ;
  kompilator_nn_1 : N ;
  kompis_nn_1 : N ;
  kompledig_av_1 : A ;
  komplement_nn_1 : N ;
  komplementaer_av_1 : A ;
  komplementaer_nn_1 : N ;
  komplementfaerg_nn_1 : N ;
  komplementmaengd_nn_1 : N ;
  komplementsystem_nn_1 : N ;
  komplementvinkel_nn_1 : N ;
  komplett_av_1 : A ;
  komplettering_nn_1 : N ;
  kompletteringstest_nn_1 : N ;
  komplex_av_1 : A ;
  komplex_nn_1 : N ;
  komplexig_av_1 : A ;
  komplexitet_nn_1 : N ;
  komplikation_nn_1 : N ;
  komplimang_nn_1 : N ;
  komplott_nn_1 : N ;
  komponent_nn_1 : N ;
  komponist_nn_1 : N ;
  komposant_nn_1 : N ;
  komposit_nn_1 : N ;
  komposition_nn_1 : N ;
  kompositoer_nn_1 : N ;
  kompositum_nn_1 : N ;
  kompost_nn_1 : N ;
  kompott_nn_1 : N ;
  kompress_nn_1 : N ;
  kompression_nn_1 : N ;
  kompressor_nn_1 : N ;
  komprimator_nn_1 : N ;
  kompromiss_nn_1 : N ;
  kompulsiv_av_1 : A ;
  kon_nn_1 : N ;
  koncentrat_nn_1 : N ;
  koncentration_nn_1 : N ;
  koncentrationsdag_nn_1 : N ;
  koncentrationslaeger_nn_1 : N ;
  koncentrisk_av_1 : A ;
  koncept_nn_1 : N ;
  koncept_nn_2 : N ;
  konception_nn_1 : N ;
  konceptiv_av_1 : A ;
  konceptpapper_nn_1 : N ;
  konceptuell_av_1 : A ;
  koncern_nn_1 : N ;
  koncession_nn_1 : N ;
  koncessiv_av_1 : A ;
  konciliant_av_1 : A ;
  koncis_av_1 : A ;
  kondensat_nn_1 : N ;
  kondensation_nn_1 : N ;
  kondensator_nn_1 : N ;
  kondensor_nn_1 : N ;
  kondis_nn_1 : N ;
  kondition_nn_1 : N ;
  konditional_av_1 : A ;
  konditor_nn_1 : N ;
  konditori_nn_1 : N ;
  kondoleans_nn_1 : N ;
  kondom_nn_1 : N ;
  kondor_nn_1 : N ;
  kondottiaer_nn_1 : N ;
  konduktivitet_nn_1 : N ;
  konduktoer_nn_1 : N ;
  konduktor_nn_1 : N ;
  konfederal_av_1 : A ;
  konfederation_nn_1 : N ;
  konfektskaal_nn_1 : N ;
  konferenciaer_nn_1 : N ;
  konferencier_nn_1 : N ;
  konferens_nn_1 : N ;
  konfession_nn_1 : N ;
  konfessionarie_nn_1 : N ;
  konfessionell_av_1 : A ;
  konfessionsloes_av_1 : A ;
  konfidentiell_av_1 : A ;
  konfiguration_nn_1 : N ;
  konfirmand_nn_1 : N ;
  konfirmation_nn_1 : N ;
  konfirmationsbibel_nn_1 : N ;
  konfirmationsklaenning_nn_1 : N ;
  konfirmationspraest_nn_1 : N ;
  konfiskation_nn_1 : N ;
  konfiskatorisk_av_1 : A ;
  konflikt_nn_1 : N ;
  konfliktvarsel_nn_1 : N ;
  konform_av_1 : A ;
  konformig_av_1 : A ;
  konformitet_nn_1 : N ;
  konfrontation_nn_1 : N ;
  konfys_av_1 : A ;
  kongenial_av_1 : A ;
  kongenital_av_1 : A ;
  konglomerat_nn_1 : N ;
  kongoles_nn_1 : N ;
  kongregation_nn_1 : N ;
  kongress_nn_1 : N ;
  kongressman_nn_1 : N ;
  kongruens_nn_1 : N ;
  kongruensboejning_nn_1 : N ;
  kongruensfall_nn_1 : N ;
  kongruent_av_1 : A ;
  konicitet_nn_1 : N ;
  konisk_av_1 : A ;
  konjakskrans_nn_1 : N ;
  konjektur_nn_1 : N ;
  konjugation_nn_1 : N ;
  konjunktion_nn_1 : N ;
  konjunktiv_nn_1 : N ;
  konjunktur_nn_1 : N ;
  konjunkturinstitut_nn_1 : N ;
  konjunkturomslag_nn_1 : N ;
  konjunkturraad_nn_1 : N ;
  konkav_av_1 : A ;
  konkavkonvex_av_1 : A ;
  konklav_nn_1 : N ;
  konklusion_nn_1 : N ;
  konklusiv_av_1 : A ;
  konkordans_nn_1 : N ;
  konkordat_nn_1 : N ;
  konkrement_nn_1 : N ;
  konkret_av_1 : A ;
  konkretion_nn_1 : N ;
  konkubin_nn_1 : N ;
  konkurrenskraftig_av_1 : A ;
  konkurrent_nn_1 : N ;
  konkurs_nn_1 : N ;
  konkursbevakning_nn_1 : N ;
  konkursbo_nn_1 : N ;
  konkursdividend_nn_1 : N ;
  konkursfoervaltare_nn_1 : N ;
  konkursmaessig_av_1 : A ;
  konkursrealisation_nn_1 : N ;
  konnaessans_nn_1 : N ;
  konnaessoer_nn_1 : N ;
  konnotation_nn_1 : N ;
  konnotativ_av_1 : A ;
  konossement_nn_1 : N ;
  konprick_nn_1 : N ;
  konsekutiv_av_1 : A ;
  konsekvens_nn_1 : N ;
  konsekvent_av_1 : A ;
  konselj_nn_1 : N ;
  konseljpresident_nn_1 : N ;
  konsert_nn_1 : N ;
  konserthus_nn_1 : N ;
  konsertmaestare_nn_1 : N ;
  konserv_nn_1 : N ;
  konservativ_av_1 : A ;
  konservator_nn_1 : N ;
  konservatorium_nn_1 : N ;
  konservburk_nn_1 : N ;
  konservering_nn_1 : N ;
  konserveringsapparat_nn_1 : N ;
  konserveringsmedel_nn_1 : N ;
  konservoeppnare_nn_1 : N ;
  konsideration_nn_1 : N ;
  konsignation_nn_1 : N ;
  konsilians_nn_1 : N ;
  konsiliant_av_1 : A ;
  konsilium_nn_1 : N ;
  konsistens_nn_1 : N ;
  konsistensgivare_nn_1 : N ;
  konsistorial_av_1 : A ;
  konsistorium_nn_1 : N ;
  konsol_nn_1 : N ;
  konsolidering_nn_1 : N ;
  konsomme_nn_1 : N ;
  konsonans_nn_1 : N ;
  konsonant_av_1 : A ;
  konsonant_nn_1 : N ;
  konsonantstam_nn_1 : N ;
  konsonantsystem_nn_1 : N ;
  konsortium_nn_1 : N ;
  konspiration_nn_1 : N ;
  konspirativ_av_1 : A ;
  konspiratoer_nn_1 : N ;
  konspiratorisk_av_1 : A ;
  konst_nn_1 : N ;
  konstaakare_nn_1 : N ;
  konstaelskare_nn_1 : N ;
  konstansfenomen_nn_1 : N ;
  konstant_av_1 : A ;
  konstant_nn_1 : N ;
  konstapel_nn_1 : N ;
  konstart_nn_1 : N ;
  konstaterande_nn_1 : N ;
  konstberidare_nn_1 : N ;
  konstbevattning_nn_1 : N ;
  konstellation_nn_1 : N ;
  konstfaerdig_av_1 : A ;
  konstfiber_nn_1 : N ;
  konstflygning_nn_1 : N ;
  konstfoerening_nn_1 : N ;
  konstfoerfaren_av_1 : A ;
  konstfoervant_nn_1 : N ;
  konstfrusen_av_1 : A ;
  konstfull_av_1 : A ;
  konstgalleri_nn_1 : N ;
  konstgjord_av_1 : A ;
  konstgrepp_nn_1 : N ;
  konsthall_nn_1 : N ;
  konsthantverk_nn_1 : N ;
  konstharts_nn_1 : N ;
  konsthistorisk_av_1 : A ;
  konstifik_av_1 : A ;
  konstig_av_1 : A ;
  konstindustri_nn_1 : N ;
  konstitution_nn_1 : N ;
  konstitutionell_av_1 : A ;
  konstitutiv_av_1 : A ;
  konstitutorial_nn_1 : N ;
  konstkritiker_nn_1 : N ;
  konstliv_nn_1 : N ;
  konstloes_av_1 : A ;
  konstmaalare_nn_1 : N ;
  konstmaalning_nn_1 : N ;
  konstmuseum_nn_1 : N ;
  konstnaer_nn_1 : N ;
  konstnaerlig_av_1 : A ;
  konstnaerssjael_nn_1 : N ;
  konstpaus_nn_1 : N ;
  konstridning_nn_1 : N ;
  konstrik_av_1 : A ;
  konstriktning_nn_1 : N ;
  konstruktion_nn_1 : N ;
  konstruktionsdetalj_nn_1 : N ;
  konstruktionslexikon_nn_1 : N ;
  konstruktionsmaterial_nn_1 : N ;
  konstruktionsritning_nn_1 : N ;
  konstruktiv_av_1 : A ;
  konstruktoer_nn_1 : N ;
  konstryttare_nn_1 : N ;
  konstsalong_nn_1 : N ;
  konstskicklig_av_1 : A ;
  konstskojare_nn_1 : N ;
  konststil_nn_1 : N ;
  konstutstaellning_nn_1 : N ;
  konstverk_nn_1 : N ;
  konsul_nn_1 : N ;
  konsulaer_av_1 : A ;
  konsularjurisdiktion_nn_1 : N ;
  konsulat_nn_1 : N ;
  konsulent_nn_1 : N ;
  konsulinna_nn_1 : N ;
  konsult_nn_1 : N ;
  konsultation_nn_1 : N ;
  konsultativ_av_1 : A ;
  konsulterande_av_1 : A ;
  konsument_nn_1 : N ;
  konsumentfoerening_nn_1 : N ;
  konsumentombudsman_nn_1 : N ;
  konsumentpris_nn_1 : N ;
  konsumentprisindex_nn_1 : N ;
  konsumentverk_nn_1 : N ;
  konsumtionsmoejlighet_nn_1 : N ;
  konsumtionsskatt_nn_1 : N ;
  konsumtionsskillnad_nn_1 : N ;
  kont_nn_1 : N ;
  kontagioes_av_1 : A ;
  kontakt_nn_1 : N ;
  kontaktannons_nn_1 : N ;
  kontaktborste_nn_1 : N ;
  kontaktinfektion_nn_1 : N ;
  kontaktkopia_nn_1 : N ;
  kontaktledning_nn_1 : N ;
  kontaktlins_nn_1 : N ;
  kontamination_nn_1 : N ;
  kontant_av_1 : A ;
  kontemplation_nn_1 : N ;
  kontemplativ_av_1 : A ;
  konteramiral_nn_1 : N ;
  konterfej_nn_1 : N ;
  kontext_nn_1 : N ;
  kontinent_nn_1 : N ;
  kontinental_av_1 : A ;
  kontinentalplataa_nn_1 : N ;
  kontinentalsockel_nn_1 : N ;
  kontingent_nn_1 : N ;
  kontinuerlig_av_1 : A ;
  kontinuitet_nn_1 : N ;
  kontinuum_nn_1 : N ;
  konto_nn_1 : N ;
  kontoinnehavare_nn_1 : N ;
  kontokort_nn_1 : N ;
  kontokurant_nn_1 : N ;
  kontonummer_nn_1 : N ;
  kontor_nn_1 : N ;
  kontorist_nn_1 : N ;
  kontorschef_nn_1 : N ;
  kontorshus_nn_1 : N ;
  kontorslandskap_nn_1 : N ;
  kontorsplats_nn_1 : N ;
  kontorspulpet_nn_1 : N ;
  kontorsrum_nn_1 : N ;
  kontorsslav_nn_1 : N ;
  kontorsstol_nn_1 : N ;
  kontorstid_nn_1 : N ;
  kontorsvana_nn_1 : N ;
  kontoutdrag_nn_1 : N ;
  kontraalt_nn_1 : N ;
  kontrabas_nn_1 : N ;
  kontrabok_nn_1 : N ;
  kontradans_nn_1 : N ;
  kontradiktion_nn_1 : N ;
  kontradiktorisk_av_1 : A ;
  kontraer_av_1 : A ;
  kontrahent_nn_1 : N ;
  kontraindikation_nn_1 : N ;
  kontrakt_nn_1 : N ;
  kontraktil_av_1 : A ;
  kontraktion_nn_1 : N ;
  kontraktsbrott_nn_1 : N ;
  kontraktsenlig_av_1 : A ;
  kontraktsprost_nn_1 : N ;
  kontraktstid_nn_1 : N ;
  kontraktsvidrig_av_1 : A ;
  kontramaerke_nn_1 : N ;
  kontraorder_nn_1 : N ;
  kontraproposition_nn_1 : N ;
  kontrarevolution_nn_1 : N ;
  kontrast_nn_1 : N ;
  kontrastmedel_nn_1 : N ;
  kontribution_nn_1 : N ;
  kontring_nn_1 : N ;
  kontroll_nn_1 : N ;
  kontrollant_nn_1 : N ;
  kontrollavgift_nn_1 : N ;
  kontrollbesiktning_nn_1 : N ;
  kontrollbord_nn_1 : N ;
  kontrollgrupp_nn_1 : N ;
  kontrollinstrument_nn_1 : N ;
  kontrollmaerke_nn_1 : N ;
  kontrollnummer_nn_1 : N ;
  kontrolloer_nn_1 : N ;
  kontrollrum_nn_1 : N ;
  kontrollstaempel_nn_1 : N ;
  kontrolluppgift_nn_1 : N ;
  kontrollvaegning_nn_1 : N ;
  kontrovers_nn_1 : N ;
  kontroversiell_av_1 : A ;
  kontumaciedom_nn_1 : N ;
  kontur_nn_1 : N ;
  konturloes_av_1 : A ;
  konturskarp_av_1 : A ;
  kontusion_nn_1 : N ;
  konung_nn_1 : N ;
  konungaaett_nn_1 : N ;
  konungabok_nn_1 : N ;
  konungadoeme_nn_1 : N ;
  konungaed_nn_1 : N ;
  konungahus_nn_1 : N ;
  konungalaengd_nn_1 : N ;
  konungarike_nn_1 : N ;
  konungasaete_nn_1 : N ;
  konungsk_av_1 : A ;
  konungslig_av_1 : A ;
  konvalescent_av_1 : A ;
  konvalescent_nn_1 : N ;
  konvalescenthem_nn_1 : N ;
  konvalj_nn_1 : N ;
  konvalje_nn_1 : N ;
  konvenansparti_nn_1 : N ;
  konvent_nn_1 : N ;
  konventikel_nn_1 : N ;
  konvention_nn_1 : N ;
  konventionell_av_1 : A ;
  konvergent_av_1 : A ;
  konversabel_av_1 : A ;
  konversation_nn_1 : N ;
  konversationslexikon_nn_1 : N ;
  konversion_nn_1 : N ;
  konversiv_av_1 : A ;
  konverter_nn_1 : N ;
  konvertibel_av_1 : A ;
  konvertit_nn_1 : N ;
  konvex_av_1 : A ;
  konvexkonkav_av_1 : A ;
  konviktorium_nn_1 : N ;
  konvoj_nn_1 : N ;
  konvolut_nn_1 : N ;
  konvulsion_nn_1 : N ;
  konvulsivisk_av_1 : A ;
  kooega_nn_1 : N ;
  kooperativ_av_1 : A ;
  kooperativ_nn_1 : N ;
  kooperatoer_nn_1 : N ;
  koordinat_nn_1 : N ;
  koordinataxel_nn_1 : N ;
  koordinator_nn_1 : N ;
  koordinatsystem_nn_1 : N ;
  kopek_nn_1 : N ;
  kopernikansk_av_1 : A ;
  kopia_nn_1 : N ;
  kopiator_nn_1 : N ;
  kopiepapper_nn_1 : N ;
  kopiering_nn_1 : N ;
  kopieringsapparat_nn_1 : N ;
  kopieringsmaskin_nn_1 : N ;
  kopiesvarv_nn_1 : N ;
  kopioes_av_1 : A ;
  kopist_nn_1 : N ;
  kopp_nn_1 : N ;
  koppaerr_nn_1 : N ;
  koppaerrig_av_1 : A ;
  kopparbrun_av_1 : A ;
  kopparledning_nn_1 : N ;
  kopparmynt_nn_1 : N ;
  kopparorm_nn_1 : N ;
  kopparplaat_nn_1 : N ;
  kopparroed_av_1 : A ;
  kopparslagare_nn_1 : N ;
  kopparspiral_nn_1 : N ;
  kopparstick_nn_1 : N ;
  kopparsulfat_nn_1 : N ;
  koppel_nn_1 : N ;
  koppelvan_av_1 : A ;
  kopplare_nn_1 : N ;
  koppleri_nn_1 : N ;
  koppling_nn_1 : N ;
  kopplingspedal_nn_1 : N ;
  kopplingsschema_nn_1 : N ;
  kopplingston_nn_1 : N ;
  koppympning_nn_1 : N ;
  kopter_nn_1 : N ;
  koptisk_av_1 : A ;
  kopulation_nn_1 : N ;
  kopulativ_av_1 : A ;
  kor_nn_1 : N ;
  koral_nn_1 : N ;
  koralbok_nn_1 : N ;
  korall_nn_1 : N ;
  koralldjur_nn_1 : N ;
  korallhalsband_nn_1 : N ;
  koralloe_nn_1 : N ;
  korallorm_nn_1 : N ;
  korallrev_nn_1 : N ;
  korallroed_av_1 : A ;
  kordial_av_1 : A ;
  kordong_nn_1 : N ;
  kordongskruv_nn_1 : N ;
  korean_nn_1 : N ;
  koreanska_nn_2 : N ;
  koreograf_nn_1 : N ;
  koreografisk_av_1 : A ;
  korg_nn_1 : N ;
  korgblommig_av_1 : A ;
  korgosse_nn_1 : N ;
  korgstol_nn_1 : N ;
  korint_nn_1 : N ;
  korinter_nn_1 : N ;
  korintisk_av_1 : A ;
  korist_nn_1 : N ;
  kork_nn_1 : N ;
  korkcell_nn_1 : N ;
  korkek_nn_1 : N ;
  korkgolv_nn_1 : N ;
  korklager_nn_1 : N ;
  korkpistol_nn_1 : N ;
  korkskoerd_nn_1 : N ;
  korkskruv_nn_1 : N ;
  korkskruvslock_nn_1 : N ;
  korksmak_nn_1 : N ;
  korkvaevnad_nn_1 : N ;
  kormaestare_nn_1 : N ;
  kormoran_nn_1 : N ;
  korn_nn_1 : N ;
  kornaaker_nn_1 : N ;
  kornblaa_av_1 : A ;
  kornblixt_nn_1 : N ;
  kornbod_nn_1 : N ;
  kornbroed_nn_1 : N ;
  kornett_nn_1 : N ;
  kornettist_nn_1 : N ;
  korngryn_nn_1 : N ;
  korngul_av_1 : A ;
  kornig_av_1 : A ;
  kornisch_nn_1 : N ;
  kornknarr_nn_1 : N ;
  korollarium_nn_1 : N ;
  korp_nn_1 : N ;
  korporation_nn_1 : N ;
  korporativ_av_1 : A ;
  korpral_nn_1 : N ;
  korpsvart_av_1 : A ;
  korpulent_av_1 : A ;
  korpus_nn_1 : N ;
  korpuskel_nn_1 : N ;
  korr_nn_1 : N ;
  korrekt_av_1 : A ;
  korrektion_nn_1 : N ;
  korrektionsanstalt_nn_1 : N ;
  korrektiv_nn_1 : N ;
  korrektur_nn_1 : N ;
  korrekturfel_nn_1 : N ;
  korrekturtecken_nn_1 : N ;
  korrelat_nn_1 : N ;
  korrelation_nn_1 : N ;
  korrespondens_nn_1 : N ;
  korrespondenskort_nn_1 : N ;
  korrespondenskurs_nn_1 : N ;
  korrespondent_nn_1 : N ;
  korridor_nn_1 : N ;
  korridorsystem_nn_1 : N ;
  korrupt_av_1 : A ;
  kors_nn_1 : N ;
  korsar_nn_1 : N ;
  korsband_nn_1 : N ;
  korsbefruktning_nn_1 : N ;
  korsben_nn_1 : N ;
  korsblommig_av_1 : A ;
  korselett_nn_1 : N ;
  korsett_nn_1 : N ;
  korsettfjaeder_nn_1 : N ;
  korsfaestelse_nn_1 : N ;
  korsfarare_nn_1 : N ;
  korsfoerhoer_nn_1 : N ;
  korsgaang_nn_1 : N ;
  korshaenvisning_nn_1 : N ;
  korsikan_nn_1 : N ;
  korsikanare_nn_1 : N ;
  korskrank_nn_1 : N ;
  korskyrka_nn_1 : N ;
  korsnaebb_nn_1 : N ;
  korsning_nn_1 : N ;
  korso_nn_1 : N ;
  korsord_nn_1 : N ;
  korspollination_nn_1 : N ;
  korsriddare_nn_1 : N ;
  korsrygg_nn_1 : N ;
  korsspindel_nn_1 : N ;
  korsstygn_nn_1 : N ;
  korstaag_nn_1 : N ;
  korstecken_nn_1 : N ;
  korsvaeg_nn_1 : N ;
  korsvalv_nn_1 : N ;
  korsvirkeshus_nn_1 : N ;
  kort_av_1 : A ;
  kort_nn_1 : N ;
  kortaenda_nn_1 : N ;
  kortbent_av_1 : A ;
  kortdistans_nn_1 : N ;
  kortdistansloepare_nn_1 : N ;
  kortege_nn_1 : N ;
  korteligen_ab_1 : Adv ;
  kortfilm_nn_1 : N ;
  kortform_nn_1 : N ;
  kortfristig_av_1 : A ;
  korthet_nn_1 : N ;
  korthuggen_av_1 : A ;
  korthus_nn_1 : N ;
  kortison_nn_1 : N ;
  kortkatalog_nn_1 : N ;
  kortklippt_av_1 : A ;
  kortkonst_nn_1 : N ;
  kortkort_av_1 : A ;
  kortlek_nn_1 : N ;
  kortoxe_nn_1 : N ;
  kortpipig_av_1 : A ;
  kortregister_nn_1 : N ;
  kortroman_nn_1 : N ;
  kortsida_nn_1 : N ;
  kortsiktig_av_1 : A ;
  kortskallig_av_1 : A ;
  kortsluta_vb_1 : V ;
  kortslutning_nn_1 : N ;
  kortspel_nn_1 : N ;
  kortspelare_nn_1 : N ;
  kortsynt_av_1 : A ;
  korttaenkt_av_1 : A ;
  kortvaagsbehandling_nn_1 : N ;
  kortvaagsradio_nn_1 : N ;
  kortvaegg_nn_1 : N ;
  kortvaext_av_1 : A ;
  kortvara_nn_1 : N ;
  kortvarig_av_1 : A ;
  kortvuxen_av_1 : A ;
  korum_nn_1 : N ;
  korund_nn_1 : N ;
  korus_nn_1 : N ;
  korv_nn_1 : N ;
  korvett_nn_1 : N ;
  korvgubbe_nn_1 : N ;
  korvig_av_1 : A ;
  korvkiosk_nn_1 : N ;
  korvoere_nn_1 : N ;
  korvsjoe_nn_1 : N ;
  korvskinn_nn_1 : N ;
  korvstaand_nn_1 : N ;
  koryfe_nn_1 : N ;
  kosack_nn_1 : N ;
  kosackdans_nn_1 : N ;
  koscher_av_1 : A ;
  kosmetisk_av_1 : A ;
  kosmetolog_nn_1 : N ;
  kosmisk_av_1 : A ;
  kosmodrom_nn_1 : N ;
  kosmogoni_nn_1 : N ;
  kosmolog_nn_1 : N ;
  kosmologi_nn_1 : N ;
  kosmologisk_av_1 : A ;
  kosmonaut_nn_1 : N ;
  kosmopolit_nn_1 : N ;
  kosmopolitisk_av_1 : A ;
  kosmos_nn_1 : N ;
  kostbar_av_1 : A ;
  koster_nn_1 : N ;
  kostig_nn_1 : N ;
  kostlig_av_1 : A ;
  kostnad_nn_1 : N ;
  kostnadsersaettning_nn_1 : N ;
  kostnadsfri_av_1 : A ;
  kostnadsram_nn_1 : N ;
  kostsam_av_1 : A ;
  kostvana_nn_1 : N ;
  kostym_nn_1 : N ;
  kostymbal_nn_1 : N ;
  kostymering_nn_1 : N ;
  kostympjaes_nn_1 : N ;
  kotben_nn_1 : N ;
  kotiljong_nn_1 : N ;
  kotknackare_nn_1 : N ;
  kotled_nn_1 : N ;
  kotlett_nn_1 : N ;
  kotlettfisk_nn_1 : N ;
  kotlettrad_nn_1 : N ;
  kotpelare_nn_1 : N ;
  kotte_nn_1 : N ;
  kotteri_nn_1 : N ;
  koturn_nn_1 : N ;
  kovaendning_nn_1 : N ;
  kovalent_av_1 : A ;
  kovall_nn_1 : N ;
  kovert_av_1 : A ;
  koyot_nn_1 : N ;
  kpist_nn_1 : N ;
  kraakbaer_nn_1 : N ;
  kraakfaagel_nn_1 : N ;
  kraakliknande_av_1 : A ;
  kraakslott_nn_1 : N ;
  kraal_nn_1 : N ;
  kraangelmakare_nn_1 : N ;
  kraanglig_av_1 : A ;
  kraas_nn_2 : N ;
  kraasnaal_nn_1 : N ;
  krabat_nn_1 : N ;
  kraeftbur_nn_1 : N ;
  kraeftdjur_nn_1 : N ;
  kraeftsvulst_nn_1 : N ;
  kraek_nn_1 : N ;
  kraekfaerdig_av_1 : A ;
  kraekmedel_nn_1 : N ;
  kraekning_nn_1 : N ;
  kraeldjur_nn_1 : N ;
  kraeldjurstyp_nn_1 : N ;
  kraem_nn_1 : N ;
  kraemare_nn_1 : N ;
  kraemig_av_1 : A ;
  kraengning_nn_1 : N ;
  kraengningshaemmare_nn_1 : N ;
  kraengningsprov_nn_1 : N ;
  kraenkande_av_1 : A ;
  kraenkning_nn_1 : N ;
  kraesen_av_1 : A ;
  kraeslig_av_1 : A ;
  kraesligen_ab_1 : Adv ;
  kraevande_av_1 : A ;
  krafsig_av_1 : A ;
  kraft_nn_1 : N ;
  kraftaatgaerd_nn_1 : N ;
  kraftaggregat_nn_1 : N ;
  kraftanstraengning_nn_1 : N ;
  kraftbaerare_nn_1 : N ;
  kraftbehov_nn_1 : N ;
  kraftbolag_nn_1 : N ;
  kraftcentral_nn_1 : N ;
  kraftcentrum_nn_1 : N ;
  kraftekvation_nn_1 : N ;
  kraftfaelt_nn_1 : N ;
  kraftfoder_nn_1 : N ;
  kraftfoeretag_nn_1 : N ;
  kraftfull_av_1 : A ;
  kraftig_av_1 : A ;
  kraftkarl_nn_1 : N ;
  kraftkraevande_av_1 : A ;
  kraftledning_nn_1 : N ;
  kraftlinje_nn_1 : N ;
  kraftloes_av_1 : A ;
  kraftloeshet_nn_1 : N ;
  kraftmaetning_nn_1 : N ;
  kraftnaet_nn_1 : N ;
  kraftoeverfoering_nn_1 : N ;
  kraftord_nn_1 : N ;
  kraftpaket_nn_1 : N ;
  kraftparallellogram_nn_1 : N ;
  kraftpartikel_nn_1 : N ;
  kraftprov_nn_1 : N ;
  kraftsport_nn_1 : N ;
  kraftstation_nn_1 : N ;
  krafttag_nn_1 : N ;
  kraftuttryck_nn_1 : N ;
  kraftvaermeverk_nn_1 : N ;
  kraftverk_nn_1 : N ;
  kraftverksbygge_nn_1 : N ;
  kraftvunnen_av_1 : A ;
  krage_nn_1 : N ;
  kraghandske_nn_1 : N ;
  kragknapp_nn_1 : N ;
  kragloes_av_1 : A ;
  kragsnibb_nn_1 : N ;
  kragsten_nn_1 : N ;
  kragstoevel_nn_1 : N ;
  krake_nn_1 : N ;
  krakel_nn_1 : N ;
  krakmandel_nn_1 : N ;
  kral_nn_1 : N ;
  kram_av_1 : A ;
  kram_nn_1 : N ;
  kramp_nn_1 : N ;
  krampaktig_av_1 : A ;
  kramploesande_av_1 : A ;
  krampstillande_av_1 : A ;
  kramsfaagel_nn_1 : N ;
  kran_nn_1 : N ;
  kranbalk_nn_1 : N ;
  kranbalksvis_ab_1 : Adv ;
  kranium_nn_1 : N ;
  krank_av_1 : A ;
  krankik_nn_1 : N ;
  krans_nn_1 : N ;
  kransartaer_nn_1 : N ;
  kransband_nn_1 : N ;
  kranskaerl_nn_1 : N ;
  kransnedlaeggning_nn_1 : N ;
  kranvatten_nn_1 : N ;
  krasch_nn_2 : N ;
  kraschan_nn_1 : N ;
  krass_av_1 : A ;
  krasslig_av_1 : A ;
  krater_nn_1 : N ;
  kraterberg_nn_1 : N ;
  kratersjoe_nn_1 : N ;
  krats_nn_1 : N ;
  krav_nn_1 : N ;
  kravall_nn_1 : N ;
  kravallstaket_nn_1 : N ;
  kravatt_nn_1 : N ;
  kravattnaal_nn_1 : N ;
  kravbrev_nn_1 : N ;
  kravell_nn_1 : N ;
  kravloes_av_1 : A ;
  krax_nn_1 : N ;
  kreation_nn_1 : N ;
  kreativ_av_1 : A ;
  kreativitet_nn_1 : N ;
  kreatur_nn_1 : N ;
  kreatursbesaettning_nn_1 : N ;
  kreatursloes_av_1 : A ;
  kredit_nn_1 : N ;
  kreditinstitut_nn_1 : N ;
  kreditiv_nn_1 : N ;
  kreditkort_nn_1 : N ;
  kreditmarknad_nn_1 : N ;
  kreditor_nn_1 : N ;
  kreditupplysning_nn_1 : N ;
  krematorium_nn_1 : N ;
  kremering_nn_1 : N ;
  kremlolog_nn_1 : N ;
  krenelering_nn_1 : N ;
  kreol_nn_1 : N ;
  kreolspraak_nn_1 : N ;
  kreosotolja_nn_1 : N ;
  krestomati_nn_1 : N ;
  kretensare_nn_1 : N ;
  kretensisk_av_1 : A ;
  kreter_nn_1 : N ;
  kretin_nn_1 : N ;
  kretisk_av_1 : A ;
  kretong_nn_1 : N ;
  krets_nn_1 : N ;
  kretsgaang_nn_1 : N ;
  kretskort_nn_1 : N ;
  kretslopp_nn_1 : N ;
  krevad_nn_1 : N ;
  krig_nn_1 : N ;
  krigare_nn_1 : N ;
  krigargrav_nn_1 : N ;
  krigfoerande_av_1 : A ;
  krigfoering_nn_1 : N ;
  krigisk_av_1 : A ;
  krigsaar_nn_1 : N ;
  krigsbarn_nn_1 : N ;
  krigsberedskap_nn_1 : N ;
  krigsbuss_nn_1 : N ;
  krigsbyte_nn_1 : N ;
  krigsdans_nn_1 : N ;
  krigsdekoration_nn_1 : N ;
  krigsfaange_nn_1 : N ;
  krigsfartyg_nn_1 : N ;
  krigsfoerbrytare_nn_1 : N ;
  krigsfoerbrytelse_nn_1 : N ;
  krigsfoerklaring_nn_1 : N ;
  krigsgud_nn_1 : N ;
  krigsherre_nn_1 : N ;
  krigshierarki_nn_1 : N ;
  krigskorrespondent_nn_1 : N ;
  krigsmaalning_nn_1 : N ;
  krigsmakt_nn_1 : N ;
  krigsman_nn_1 : N ;
  krigsmiljoe_nn_1 : N ;
  krigsplacering_nn_1 : N ;
  krigsraad_nn_1 : N ;
  krigsraedd_av_1 : A ;
  krigsroman_nn_1 : N ;
  krigsskaadeplats_nn_1 : N ;
  krigsskadestaand_nn_1 : N ;
  krigsskepp_nn_1 : N ;
  krigsslut_nn_1 : N ;
  krigsspel_nn_1 : N ;
  krigstaag_nn_1 : N ;
  krigstillstaand_nn_1 : N ;
  krigstjaenstgoering_nn_1 : N ;
  krigsutbrott_nn_1 : N ;
  krikon_nn_1 : N ;
  krillaetare_nn_1 : N ;
  krillstim_nn_1 : N ;
  kriminalare_nn_1 : N ;
  kriminaldaare_nn_1 : N ;
  kriminalitet_nn_1 : N ;
  kriminalpolis_nn_1 : N ;
  kriminalregister_nn_1 : N ;
  kriminalroman_nn_1 : N ;
  kriminell_av_1 : A ;
  kriminologisk_av_1 : A ;
  kring_ab_1 : Adv ;
  kringboende_av_1 : A ;
  kringbyggd_av_1 : A ;
  kringfarande_av_1 : A ;
  kringflackande_av_1 : A ;
  kringgaa_vb_1 : V ;
  kringla_nn_1 : N ;
  kringliggande_av_1 : A ;
  kringresande_av_1 : A ;
  kringsjuk_av_1 : A ;
  kringskaera_vb_1 : V ;
  kringspringande_av_1 : A ;
  kringstaaende_av_1 : A ;
  kringsynt_av_1 : A ;
  kringutrustning_nn_1 : N ;
  kringvaervd_av_1 : A ;
  kringvandrande_av_1 : A ;
  krinolin_nn_1 : N ;
  kris_nn_1 : N ;
  kris_nn_2 : N ;
  krismedel_nn_1 : N ;
  krispaket_nn_1 : N ;
  kristall_nn_1 : N ;
  kristallaxel_nn_1 : N ;
  kristallform_nn_1 : N ;
  kristallglas_nn_1 : N ;
  kristallin_av_1 : A ;
  kristallinisk_av_1 : A ;
  kristallins_nn_1 : N ;
  kristallisation_nn_1 : N ;
  kristallisk_av_1 : A ;
  kristallklar_av_1 : A ;
  kristallmoenster_nn_1 : N ;
  kristallmottagare_nn_1 : N ;
  kristallografisk_av_1 : A ;
  kristallsystem_nn_1 : N ;
  kristen_av_1 : A ;
  kristendom_nn_1 : N ;
  kristenhet_nn_1 : N ;
  kristid_nn_1 : N ;
  kristidsfoeretag_nn_1 : N ;
  kristlig_av_1 : A ;
  kristtorn_nn_1 : N ;
  kristtrogen_av_1 : A ;
  kristusmonogram_nn_1 : N ;
  kriterium_nn_1 : N ;
  kritig_av_1 : A ;
  kritik_nn_1 : N ;
  kritiker_nn_1 : N ;
  kritikloes_av_1 : A ;
  kritikstorm_nn_1 : N ;
  kritisk_av_1 : A ;
  kritstreck_nn_1 : N ;
  kritstrecksrandig_av_1 : A ;
  kritter_nn_1 : N ;
  kritvit_av_1 : A ;
  kroat_nn_1 : N ;
  kroatiska_nn_2 : N ;
  krock_nn_1 : N ;
  kroegare_nn_1 : N ;
  kroek_nn_1 : N ;
  kroekning_nn_1 : N ;
  kroekt_av_1 : A ;
  kroen_nn_1 : N ;
  kroenika_nn_1 : N ;
  kroenikebok_nn_1 : N ;
  kroenikespel_nn_1 : N ;
  kroenikoer_nn_1 : N ;
  kroening_nn_1 : N ;
  kroeson_nn_1 : N ;
  kroesus_nn_1 : N ;
  krog_nn_1 : N ;
  krogkund_nn_1 : N ;
  krogrond_nn_1 : N ;
  krogshow_nn_1 : N ;
  krogsvaeng_nn_1 : N ;
  krok_nn_1 : N ;
  krokan_nn_1 : N ;
  krokben_ab_1 : Adv ;
  krokett_nn_1 : N ;
  kroki_nn_1 : N ;
  krokig_av_1 : A ;
  krokighet_nn_1 : N ;
  kroknaest_av_1 : A ;
  krokodil_nn_1 : N ;
  krokryggig_av_1 : A ;
  kroksabel_nn_1 : N ;
  krokus_nn_1 : N ;
  krokvaeg_nn_1 : N ;
  krokvuxen_av_1 : A ;
  kromat_nn_1 : N ;
  kromatisk_av_1 : A ;
  kromolitografi_nn_1 : N ;
  kromosom_nn_1 : N ;
  kromosompar_nn_1 : N ;
  kromosomuppsaettning_nn_1 : N ;
  kronblad_nn_1 : N ;
  kronbrud_nn_1 : N ;
  krondike_nn_1 : N ;
  kronhaest_nn_1 : N ;
  kronhjort_nn_1 : N ;
  kroniker_nn_1 : N ;
  kronikerhem_nn_1 : N ;
  kronisk_av_1 : A ;
  kronjurist_nn_1 : N ;
  kronjuvel_nn_1 : N ;
  kronkoloni_nn_1 : N ;
  kronmutter_nn_1 : N ;
  kronofogde_nn_1 : N ;
  kronojaegare_nn_1 : N ;
  kronojord_nn_1 : N ;
  kronologi_nn_1 : N ;
  kronologisk_av_1 : A ;
  kronometer_nn_1 : N ;
  kronopark_nn_1 : N ;
  kronoutskyld_nn_1 : N ;
  kronprins_nn_1 : N ;
  krontal_nn_1 : N ;
  kronvittne_nn_1 : N ;
  kronvrak_nn_1 : N ;
  kropp_nn_1 : N ;
  kroppaas_nn_1 : N ;
  kroppsarbetare_nn_1 : N ;
  kroppsbild_nn_1 : N ;
  kroppsbyggare_nn_1 : N ;
  kroppsbyggnad_nn_1 : N ;
  kroppscell_nn_1 : N ;
  kroppsdel_nn_1 : N ;
  kroppsfett_nn_1 : N ;
  kroppsform_nn_1 : N ;
  kroppsfunktion_nn_1 : N ;
  kroppskanal_nn_1 : N ;
  kroppslig_av_1 : A ;
  kroppsligen_ab_1 : Adv ;
  kroppsnaera_av_1 : A ;
  kroppsoeppning_nn_1 : N ;
  kroppsoevning_nn_1 : N ;
  kroppsorgan_nn_1 : N ;
  kroppsroerelse_nn_1 : N ;
  kroppsstaellning_nn_1 : N ;
  kroppsstyrka_nn_1 : N ;
  kroppstemperatur_nn_1 : N ;
  kroppsvaetska_nn_1 : N ;
  kroppsvaevnad_nn_1 : N ;
  kroppsvikt_nn_1 : N ;
  kroppsvisitation_nn_1 : N ;
  kross_nn_1 : N ;
  krossaar_nn_1 : N ;
  krossfri_av_1 : A ;
  krossmaskin_nn_1 : N ;
  krubbitare_nn_1 : N ;
  krucifix_nn_1 : N ;
  krukgods_nn_1 : N ;
  krukmakare_nn_1 : N ;
  krukmakeri_nn_1 : N ;
  krukvaext_nn_1 : N ;
  krullhaarig_av_1 : A ;
  krullig_av_1 : A ;
  krum_av_1 : A ;
  krumbukt_nn_1 : N ;
  krumelur_nn_1 : N ;
  krumhorn_nn_1 : N ;
  krumpen_av_1 : A ;
  krumspraang_nn_1 : N ;
  krumstav_nn_1 : N ;
  krus_nn_1 : N ;
  krusbaer_nn_1 : N ;
  krusbaersbuske_nn_1 : N ;
  kruserlig_av_1 : A ;
  krushaarig_av_1 : A ;
  krusidull_nn_1 : N ;
  krusidullig_av_1 : A ;
  krusig_av_1 : A ;
  krustaang_nn_1 : N ;
  krustaatel_nn_1 : N ;
  krustad_nn_1 : N ;
  krutdurk_nn_1 : N ;
  krutgas_nn_1 : N ;
  krutgubbe_nn_1 : N ;
  kruthorn_nn_1 : N ;
  krutkorn_nn_1 : N ;
  krutmotor_nn_1 : N ;
  krutong_nn_1 : N ;
  krutsort_nn_1 : N ;
  kruttorr_av_1 : A ;
  krux_nn_1 : N ;
  kry_av_1 : A ;
  kryckig_av_1 : A ;
  kryddbod_nn_1 : N ;
  kryddgroensak_nn_1 : N ;
  kryddoert_nn_1 : N ;
  kryddsaas_nn_1 : N ;
  kryddstark_av_1 : A ;
  kryddvaext_nn_1 : N ;
  krympfilm_nn_1 : N ;
  krympfri_av_1 : A ;
  krympling_nn_1 : N ;
  krympmaan_nn_1 : N ;
  kryogen_av_1 : A ;
  kryostat_nn_1 : N ;
  kryoteknik_nn_1 : N ;
  kryp_nn_1 : N ;
  kryperi_nn_1 : N ;
  krypfil_nn_1 : N ;
  kryphaal_nn_1 : N ;
  kryphaallfasthet_nn_1 : N ;
  krypin_nn_1 : N ;
  krypskytt_nn_1 : N ;
  kryptisk_av_1 : A ;
  krypto_nn_1 : N ;
  kryptofascist_nn_1 : N ;
  kryptogam_av_1 : A ;
  kryptogam_nn_1 : N ;
  krysantem_nn_1 : N ;
  krysantemum_nn_1 : N ;
  krysolit_nn_1 : N ;
  krysopras_nn_1 : N ;
  kryss_nn_1 : N ;
  kryssare_nn_1 : N ;
  kryssfoerband_nn_1 : N ;
  krysshult_nn_1 : N ;
  kryssmast_nn_1 : N ;
  kryssning_nn_1 : N ;
  kryssningsraket_nn_1 : N ;
  kryssningsrobot_nn_1 : N ;
  krysstag_nn_1 : N ;
  kryssvalv_nn_1 : N ;
  krystvaerk_nn_1 : N ;
  kub_nn_1 : N ;
  kuban_nn_1 : N ;
  kubansk_av_1 : A ;
  kubb_nn_1 : N ;
  kubbe_nn_1 : N ;
  kubik_nn_1 : N ;
  kubikdecimeter_nn_1 : N ;
  kubikmeter_nn_1 : N ;
  kubikmillimeter_nn_1 : N ;
  kubikrot_nn_1 : N ;
  kubisk_av_1 : A ;
  kubist_nn_1 : N ;
  kubistisk_av_1 : A ;
  kudde_nn_1 : N ;
  kuddkrig_nn_1 : N ;
  kuddvar_nn_1 : N ;
  kuf_nn_1 : N ;
  kufisk_av_1 : A ;
  kugg_nn_1 : N ;
  kugge_nn_1 : N ;
  kuggfraaga_nn_1 : N ;
  kugghjul_nn_1 : N ;
  kuggstaang_nn_1 : N ;
  kuggvaexel_nn_1 : N ;
  kujon_nn_1 : N ;
  kuk_nn_1 : N ;
  kul_av_1 : A ;
  kulak_nn_1 : N ;
  kulen_av_1 : A ;
  kulfaang_nn_1 : N ;
  kulgevaer_nn_1 : N ;
  kulhaal_nn_1 : N ;
  kuli_nn_1 : N ;
  kulig_av_1 : A ;
  kulinarisk_av_1 : A ;
  kuling_nn_1 : N ;
  kuliss_nn_1 : N ;
  kulkaerve_nn_1 : N ;
  kulkvarn_nn_1 : N ;
  kull_ab_1 : Adv ;
  kull_nn_1 : N ;
  kullager_nn_1 : N ;
  kulle_nn_1 : N ;
  kulled_nn_1 : N ;
  kullersten_nn_1 : N ;
  kullig_av_1 : A ;
  kullkamrat_nn_1 : N ;
  kullko_nn_1 : N ;
  kullrig_av_1 : A ;
  kullsyskon_nn_1 : N ;
  kulmage_nn_1 : N ;
  kulmination_nn_1 : N ;
  kuloer_nn_1 : N ;
  kuloert_av_1 : A ;
  kuloertvaett_nn_1 : N ;
  kulram_nn_1 : N ;
  kulskrivmaskin_nn_1 : N ;
  kulspel_nn_1 : N ;
  kulsprutegevaer_nn_1 : N ;
  kulsprutepistol_nn_1 : N ;
  kulstoetare_nn_1 : N ;
  kulstoetning_nn_1 : N ;
  kult_nn_1 : N ;
  kult_nn_2 : N ;
  kultfoeremaal_nn_1 : N ;
  kulthandling_nn_1 : N ;
  kulting_nn_1 : N ;
  kultisk_av_1 : A ;
  kultivator_nn_1 : N ;
  kultplats_nn_1 : N ;
  kultur_nn_1 : N ;
  kulturaktivitet_nn_1 : N ;
  kulturarbetare_nn_1 : N ;
  kulturartikel_nn_1 : N ;
  kulturarv_nn_1 : N ;
  kulturattache_nn_1 : N ;
  kulturbaerare_nn_1 : N ;
  kulturbygd_nn_1 : N ;
  kulturcentrum_nn_1 : N ;
  kulturchock_nn_1 : N ;
  kulturdebatt_nn_1 : N ;
  kulturell_av_1 : A ;
  kulturfientlig_av_1 : A ;
  kulturfolk_nn_1 : N ;
  kulturform_nn_1 : N ;
  kulturgaerning_nn_1 : N ;
  kulturhistorisk_av_1 : A ;
  kulturhus_nn_1 : N ;
  kulturinstitut_nn_1 : N ;
  kulturknutte_nn_1 : N ;
  kulturkollision_nn_1 : N ;
  kulturkrets_nn_1 : N ;
  kulturlager_nn_1 : N ;
  kulturland_nn_1 : N ;
  kulturlandskap_nn_1 : N ;
  kulturminne_nn_1 : N ;
  kulturminnesmaerke_nn_1 : N ;
  kulturminnesvaard_nn_1 : N ;
  kulturmoenster_nn_1 : N ;
  kulturperson_nn_1 : N ;
  kulturpersonlighet_nn_1 : N ;
  kulturraad_nn_1 : N ;
  kulturradikal_nn_1 : N ;
  kulturreservat_nn_1 : N ;
  kulturrevolution_nn_1 : N ;
  kultursida_nn_1 : N ;
  kulturskribent_nn_1 : N ;
  kulturutbyte_nn_1 : N ;
  kulturvaext_nn_1 : N ;
  kulventil_nn_1 : N ;
  kulvert_nn_1 : N ;
  kummel_nn_1 : N ;
  kummel_nn_2 : N ;
  kumpan_nn_1 : N ;
  kumulativ_av_1 : A ;
  kumulering_nn_1 : N ;
  kund_nn_1 : N ;
  kundkrets_nn_1 : N ;
  kundvagn_nn_1 : N ;
  kung_nn_1 : N ;
  kungaaett_nn_1 : N ;
  kungadoeme_nn_1 : N ;
  kungaed_nn_1 : N ;
  kungahus_nn_1 : N ;
  kungalaengd_nn_1 : N ;
  kungasaete_nn_1 : N ;
  kungaval_nn_1 : N ;
  kunglig_av_1 : A ;
  kunglighet_nn_1 : N ;
  kungoerelse_nn_1 : N ;
  kungsaadra_nn_1 : N ;
  kungsaengslilja_nn_1 : N ;
  kungsblaa_av_1 : A ;
  kungsbonde_nn_1 : N ;
  kungsfaagel_nn_1 : N ;
  kungsfiskare_nn_1 : N ;
  kungsgaard_nn_1 : N ;
  kungsgambit_nn_1 : N ;
  kungshoeg_nn_1 : N ;
  kungsljus_nn_1 : N ;
  kungsoern_nn_1 : N ;
  kungsord_nn_1 : N ;
  kungstanke_nn_1 : N ;
  kungstiger_nn_1 : N ;
  kungsvaeg_nn_1 : N ;
  kunnig_av_1 : A ;
  kunskap_nn_1 : N ;
  kunskapare_nn_1 : N ;
  kunskapskontroll_nn_1 : N ;
  kunskapsnivaa_nn_1 : N ;
  kunskapsstoff_nn_1 : N ;
  kupe_nn_1 : N ;
  kupevaermare_nn_1 : N ;
  kupidon_nn_1 : N ;
  kupig_av_1 : A ;
  kuplett_nn_1 : N ;
  kupol_nn_1 : N ;
  kupolformig_av_1 : A ;
  kupolgrav_nn_1 : N ;
  kupong_nn_1 : N ;
  kupongklippare_nn_1 : N ;
  kupp_nn_1 : N ;
  kuppfoersoek_nn_1 : N ;
  kur_nn_1 : N ;
  kur_nn_2 : N ;
  kuranstalt_nn_1 : N ;
  kurant_av_1 : A ;
  kuratel_nn_1 : N ;
  kurativ_av_1 : A ;
  kurator_nn_1 : N ;
  kurbits_nn_1 : N ;
  kurd_nn_1 : N ;
  kurdiska_nn_2 : N ;
  kurfurste_nn_1 : N ;
  kurhus_nn_1 : N ;
  kurioes_av_1 : A ;
  kuriositet_nn_1 : N ;
  kuriosum_nn_1 : N ;
  kurir_nn_1 : N ;
  kurirpass_nn_1 : N ;
  kurort_nn_1 : N ;
  kurr_nn_2 : N ;
  kurre_nn_1 : N ;
  kurs_nn_1 : N ;
  kursare_nn_1 : N ;
  kursiv_av_1 : A ;
  kursiv_nn_1 : N ;
  kurskamrat_nn_1 : N ;
  kursnotering_nn_1 : N ;
  kursor_nn_1 : N ;
  kursorisk_av_1 : A ;
  kursstegring_nn_1 : N ;
  kurtage_nn_1 : N ;
  kurtis_nn_1 : N ;
  kurtisan_nn_1 : N ;
  kurtisoer_nn_1 : N ;
  kurvatur_nn_1 : N ;
  kurvig_av_1 : A ;
  kurvstabil_av_1 : A ;
  kurvtagning_nn_1 : N ;
  kuse_nn_1 : N ;
  kusin_nn_1 : N ;
  kusinaektenskap_nn_1 : N ;
  kusk_nn_1 : N ;
  kuskbock_nn_1 : N ;
  kuslig_av_1 : A ;
  kust_nn_1 : N ;
  kustbygd_nn_1 : N ;
  kustfisk_nn_1 : N ;
  kustjaegare_nn_1 : N ;
  kustlinje_nn_1 : N ;
  kustod_nn_1 : N ;
  kustomraade_nn_1 : N ;
  kustort_nn_1 : N ;
  kustslaett_nn_1 : N ;
  kut_nn_1 : N ;
  kutig_av_1 : A ;
  kutryggig_av_1 : A ;
  kutter_nn_2 : N ;
  kutting_nn_1 : N ;
  kuttrasju_nn_1 : N ;
  kutym_nn_1 : N ;
  kuvert_nn_1 : N ;
  kuvertavgift_nn_1 : N ;
  kuvertbroed_nn_1 : N ;
  kuvoes_nn_1 : N ;
  kuwaitier_nn_1 : N ;
  kuwaitisk_av_1 : A ;
  kvackare_nn_1 : N ;
  kvacksalvare_nn_1 : N ;
  kvacksalveri_nn_1 : N ;
  kvader_nn_1 : N ;
  kvadrant_nn_1 : N ;
  kvadrat_nn_1 : N ;
  kvadratisk_av_1 : A ;
  kvadratkilometer_nn_1 : N ;
  kvadratmeter_nn_1 : N ;
  kvadratrot_nn_1 : N ;
  kvadriljon_nn_1 : N ;
  kvadrupelallians_nn_1 : N ;
  kvaeda_vb_1 : V ;
  kvaekare_nn_1 : N ;
  kvaeljning_nn_1 : N ;
  kvaell_nn_1 : N ;
  kvaellsbris_nn_1 : N ;
  kvaellsignal_nn_1 : N ;
  kvaellskurs_nn_1 : N ;
  kvaellslig_av_1 : A ;
  kvaellsmaaltid_nn_1 : N ;
  kvaellsmaenniska_nn_1 : N ;
  kvaellsoeppen_av_1 : A ;
  kvaellssammankomst_nn_1 : N ;
  kvaellsunderhaallning_nn_1 : N ;
  kvaellsvard_nn_1 : N ;
  kvaevande_av_1 : A ;
  kvaevegoedselmedel_nn_1 : N ;
  kvaeveoxid_nn_1 : N ;
  kval_nn_1 : N ;
  kvalfull_av_1 : A ;
  kvalfylld_av_1 : A ;
  kvalificering_nn_1 : N ;
  kvalifikation_nn_1 : N ;
  kvalifikationsaar_nn_1 : N ;
  kvalitativ_av_1 : A ;
  kvalite_nn_1 : N ;
  kvalitet_nn_1 : N ;
  kvalitetsauktion_nn_1 : N ;
  kvalitetskontroll_nn_1 : N ;
  kvalmig_av_1 : A ;
  kvalster_nn_1 : N ;
  kvantitativ_av_1 : A ;
  kvantitet_nn_1 : N ;
  kvanttal_nn_1 : N ;
  kvantum_nn_1 : N ;
  kvar_ab_1 : Adv ;
  kvargloemd_av_1 : A ;
  kvarhaalla_vb_1 : V ;
  kvark_nn_1 : N ;
  kvarkklimp_nn_1 : N ;
  kvarn_nn_1 : N ;
  kvarndamm_nn_1 : N ;
  kvarnhjul_nn_1 : N ;
  kvarnsten_nn_1 : N ;
  kvarnvinge_nn_1 : N ;
  kvarsittare_nn_1 : N ;
  kvarskatt_nn_1 : N ;
  kvarstad_nn_1 : N ;
  kvart_nn_1 : N ;
  kvart_nn_2 : N ;
  kvart_nn_3 : N ;
  kvartal_nn_1 : N ;
  kvarter_nn_1 : N ;
  kvartermaestare_nn_1 : N ;
  kvarterspolis_nn_1 : N ;
  kvartett_nn_1 : N ;
  kvartil_nn_1 : N ;
  kvarting_nn_1 : N ;
  kvarts_nn_1 : N ;
  kvartsbutelj_nn_1 : N ;
  kvartsfigur_nn_1 : N ;
  kvartsfinal_nn_1 : N ;
  kvartsit_nn_1 : N ;
  kvartskristall_nn_1 : N ;
  kvartssamtal_nn_1 : N ;
  kvartssekel_nn_1 : N ;
  kvartston_nn_1 : N ;
  kvartsur_nn_1 : N ;
  kvarvarande_av_1 : A ;
  kvasar_nn_1 : N ;
  kvasikontrakt_nn_1 : N ;
  kvasikristall_nn_1 : N ;
  kvass_nn_1 : N ;
  kvast_nn_1 : N ;
  kvastfening_nn_1 : N ;
  kvastprick_nn_1 : N ;
  kvastskaft_nn_1 : N ;
  kvav_av_1 : A ;
  kved_nn_1 : N ;
  kverulant_nn_1 : N ;
  kverulantisk_av_1 : A ;
  kvick_av_1 : A ;
  kvickhet_nn_1 : N ;
  kvickhuvud_nn_1 : N ;
  kvickoegd_av_1 : A ;
  kvicksilverfoerening_nn_1 : N ;
  kvicksilverpelare_nn_1 : N ;
  kvicktaenkt_av_1 : A ;
  kvidande_nn_1 : N ;
  kvidd_nn_1 : N ;
  kvigkalv_nn_1 : N ;
  kvinna_nn_1 : N ;
  kvinnfolk_nn_1 : N ;
  kvinnlig_av_1 : A ;
  kvinnoben_nn_1 : N ;
  kvinnobild_nn_1 : N ;
  kvinnobroest_nn_1 : N ;
  kvinnodraekt_nn_1 : N ;
  kvinnofaengelse_nn_1 : N ;
  kvinnofoerfoerare_nn_1 : N ;
  kvinnofraaga_nn_1 : N ;
  kvinnofrisyr_nn_1 : N ;
  kvinnograv_nn_1 : N ;
  kvinnohus_nn_1 : N ;
  kvinnoklinik_nn_1 : N ;
  kvinnolaeger_nn_1 : N ;
  kvinnolaekare_nn_1 : N ;
  kvinnonamn_nn_1 : N ;
  kvinnoplagg_nn_1 : N ;
  kvinnopraest_nn_1 : N ;
  kvinnoroerelse_nn_1 : N ;
  kvinnoroll_nn_1 : N ;
  kvinnorov_nn_1 : N ;
  kvinnosakskvinna_nn_1 : N ;
  kvinnosjukdom_nn_1 : N ;
  kvinnoskulptur_nn_1 : N ;
  kvinnotjusare_nn_1 : N ;
  kvint_nn_1 : N ;
  kvintett_nn_1 : N ;
  kvisslig_av_1 : A ;
  kvist_nn_1 : N ;
  kvistfri_av_1 : A ;
  kvisthaal_nn_1 : N ;
  kvistig_av_1 : A ;
  kvistliknande_av_1 : A ;
  kvistloes_av_1 : A ;
  kvitt_ab_1 : Adv ;
  kvitt_av_1 : A ;
  kvitten_nn_1 : N ;
  kvittens_nn_1 : N ;
  kvitteringsmaal_nn_1 : N ;
  kvittning_nn_1 : N ;
  kvitto_nn_1 : N ;
  kvittrig_av_1 : A ;
  kvot_nn_1 : N ;
  kvotering_nn_1 : N ;
  kybernetik_nn_1 : N ;
  kybernetisk_av_1 : A ;
  kyckling_nn_1 : N ;
  kycklingmoder_nn_1 : N ;
  kyffig_av_1 : A ;
  kyl_nn_1 : N ;
  kylare_nn_1 : N ;
  kylargaller_nn_1 : N ;
  kylargardin_nn_1 : N ;
  kyldisk_nn_1 : N ;
  kylhus_nn_1 : N ;
  kylig_av_1 : A ;
  kylklamp_nn_1 : N ;
  kylkonserv_nn_1 : N ;
  kylledning_nn_1 : N ;
  kyller_nn_1 : N ;
  kylning_nn_1 : N ;
  kylsig_av_1 : A ;
  kylskaap_nn_1 : N ;
  kylslagen_av_1 : A ;
  kylvagn_nn_1 : N ;
  kymation_nn_1 : N ;
  kymig_av_1 : A ;
  kymograf_nn_1 : N ;
  kymrer_nn_1 : N ;
  kyniker_nn_1 : N ;
  kynisk_av_1 : A ;
  kynolog_nn_1 : N ;
  kyp_nn_1 : N ;
  kypare_nn_1 : N ;
  kypert_nn_1 : N ;
  kyrass_nn_1 : N ;
  kyrassiaer_nn_1 : N ;
  kyrillisk_av_1 : A ;
  kyrka_nn_1 : N ;
  kyrkbaat_nn_1 : N ;
  kyrkbacke_nn_1 : N ;
  kyrkbaenk_nn_1 : N ;
  kyrkbesoek_nn_1 : N ;
  kyrkbibel_nn_1 : N ;
  kyrkbok_nn_1 : N ;
  kyrkbroellop_nn_1 : N ;
  kyrkby_nn_1 : N ;
  kyrkfoenster_nn_1 : N ;
  kyrklig_av_1 : A ;
  kyrkoaar_nn_1 : N ;
  kyrkoadjunkt_nn_1 : N ;
  kyrkobesoek_nn_1 : N ;
  kyrkobesoekare_nn_1 : N ;
  kyrkobok_nn_1 : N ;
  kyrkobroder_nn_1 : N ;
  kyrkofader_nn_1 : N ;
  kyrkofullmaektig_nn_1 : N ;
  kyrkogaard_nn_1 : N ;
  kyrkohandbok_nn_1 : N ;
  kyrkoherde_nn_1 : N ;
  kyrkoman_nn_1 : N ;
  kyrkomoete_nn_1 : N ;
  kyrkomusiker_nn_1 : N ;
  kyrkoraad_nn_1 : N ;
  kyrkorum_nn_1 : N ;
  kyrkosaang_nn_1 : N ;
  kyrkosamfund_nn_1 : N ;
  kyrkospraak_nn_1 : N ;
  kyrkostaemma_nn_1 : N ;
  kyrkoton_nn_1 : N ;
  kyrkotonart_nn_1 : N ;
  kyrkoverksamhet_nn_1 : N ;
  kyrksal_nn_1 : N ;
  kyrksam_av_1 : A ;
  kyrkskriva_vb_1 : V ;
  kyrksocken_nn_1 : N ;
  kyrkstoet_nn_1 : N ;
  kyrktagning_nn_1 : N ;
  kyrktorn_nn_1 : N ;
  kyrktupp_nn_1 : N ;
  kyrkvaerd_nn_1 : N ;
  kyrkvaktmaestare_nn_1 : N ;
  kysk_av_1 : A ;
  kyskhet_nn_1 : N ;
  kyskhetsbaelte_nn_1 : N ;
  kyskhetsloefte_nn_1 : N ;
  kyss_nn_1 : N ;
  kyssaekta_av_1 : A ;
  kysstaeck_av_1 : A ;
  kytt_nn_1 : N ;
  laadaemne_nn_1 : N ;
  laadkamera_nn_1 : N ;
  laadspik_nn_1 : N ;
  laag_av_1 : A ;
  laagblad_nn_1 : N ;
  laagfaerg_nn_1 : N ;
  laagfjaell_nn_1 : N ;
  laagfrekvens_nn_1 : N ;
  laagfrekvent_av_1 : A ;
  laaghalt_av_1 : A ;
  laaghet_nn_1 : N ;
  laaghus_nn_1 : N ;
  laaginkomsttagare_nn_1 : N ;
  laagkonjunktur_nn_1 : N ;
  laagkyrklig_av_1 : A ;
  laaglaent_av_1 : A ;
  laaglandsras_nn_1 : N ;
  laagloeneprofil_nn_1 : N ;
  laagmaeld_av_1 : A ;
  laagmosse_nn_1 : N ;
  laagpresterande_av_1 : A ;
  laagpris_nn_1 : N ;
  laagpriskort_nn_1 : N ;
  laagproduktiv_av_1 : A ;
  laagrelief_nn_1 : N ;
  laagsaesong_nn_1 : N ;
  laagsint_av_1 : A ;
  laagsko_nn_1 : N ;
  laagslaett_nn_1 : N ;
  laagsniff_nn_1 : N ;
  laagspaend_av_1 : A ;
  laagspaenning_nn_1 : N ;
  laagstadium_nn_1 : N ;
  laagsvavlig_av_1 : A ;
  laagtryck_nn_1 : N ;
  laagtstaaende_av_1 : A ;
  laagtysk_av_1 : A ;
  laagvaerdig_av_1 : A ;
  laagvaext_av_1 : A ;
  laagvatten_nn_1 : N ;
  laagvattenmaerke_nn_1 : N ;
  laagvuxen_av_1 : A ;
  laan_nn_1 : N ;
  laaneansoekning_nn_1 : N ;
  laanebibliotek_nn_1 : N ;
  laaneexpedition_nn_1 : N ;
  laaneform_nn_1 : N ;
  laanegaranti_nn_1 : N ;
  laanekoep_nn_1 : N ;
  laanekontor_nn_1 : N ;
  laanekort_nn_1 : N ;
  laanetak_nn_1 : N ;
  laanfaangen_av_1 : A ;
  laang_av_1 : A ;
  laangbaenk_nn_1 : N ;
  laangbent_av_1 : A ;
  laangboll_nn_1 : N ;
  laangbord_nn_1 : N ;
  laangdans_nn_1 : N ;
  laangdistans_nn_1 : N ;
  laangdistansloepning_nn_1 : N ;
  laangdistansraket_nn_1 : N ;
  laangdragen_av_1 : A ;
  laangduk_nn_1 : N ;
  laangeman_nn_1 : N ;
  laangfaerd_nn_1 : N ;
  laangfarare_nn_1 : N ;
  laangfilm_nn_1 : N ;
  laangfinger_nn_1 : N ;
  laangfranska_nn_1 : N ;
  laangfredag_nn_1 : N ;
  laangfristig_av_1 : A ;
  laanggardin_nn_1 : N ;
  laanggrogg_nn_1 : N ;
  laanggrund_av_1 : A ;
  laanghaarig_av_1 : A ;
  laanghelg_nn_1 : N ;
  laanghus_nn_1 : N ;
  laangivande_av_1 : A ;
  laangivare_nn_1 : N ;
  laangkoerare_nn_1 : N ;
  laangkok_nn_1 : N ;
  laangledig_av_1 : A ;
  laanglig_av_1 : A ;
  laangliggare_nn_1 : N ;
  laanglopp_nn_1 : N ;
  laanglotsning_nn_1 : N ;
  laangmodig_av_1 : A ;
  laangnaebb_nn_1 : N ;
  laangnaest_av_1 : A ;
  laangperiodisk_av_1 : A ;
  laangpromenad_nn_1 : N ;
  laangrandig_av_1 : A ;
  laangrev_nn_1 : N ;
  laangsalning_nn_1 : N ;
  laangsam_av_1 : A ;
  laangschal_nn_1 : N ;
  laangsida_nn_1 : N ;
  laangsides_ab_1 : Adv ;
  laangsiktig_av_1 : A ;
  laangsint_av_1 : A ;
  laangsjal_nn_1 : N ;
  laangskallig_av_1 : A ;
  laangskepp_nn_1 : N ;
  laangskepps_ab_1 : Adv ;
  laangskott_nn_1 : N ;
  laangsmal_av_1 : A ;
  laangsoekt_av_1 : A ;
  laangspant_nn_1 : N ;
  laangspel_nn_1 : N ;
  laangstraeckt_av_1 : A ;
  laangsynt_av_1 : A ;
  laangsynthet_nn_1 : N ;
  laangtgaaende_av_1 : A ;
  laangtidsparkering_nn_1 : N ;
  laangtidsprognos_nn_1 : N ;
  laangtidsvikariat_nn_1 : N ;
  laangtifraan_ab_1 : Adv ;
  laangtraadig_av_1 : A ;
  laangtraakig_av_1 : A ;
  laangtradare_nn_1 : N ;
  laangtradig_av_1 : A ;
  laangtur_nn_1 : N ;
  laangvaagig_av_1 : A ;
  laangvaega_av_1 : A ;
  laangvarig_av_1 : A ;
  laanord_nn_1 : N ;
  laantagare_nn_1 : N ;
  laar_nn_1 : N ;
  laar_nn_2 : N ;
  laarben_nn_1 : N ;
  laarbensbrott_nn_1 : N ;
  laarbenshals_nn_1 : N ;
  laarding_nn_1 : N ;
  laaring_nn_1 : N ;
  laaringsvind_nn_1 : N ;
  laas_nn_1 : N ;
  laaskolv_nn_1 : N ;
  laasmutter_nn_1 : N ;
  laasning_nn_1 : N ;
  laassmed_nn_1 : N ;
  laassprint_nn_1 : N ;
  laasvred_nn_1 : N ;
  laat_nn_1 : N ;
  laatgaasystem_nn_1 : N ;
  laatsaslek_nn_1 : N ;
  laatsasvaerld_nn_1 : N ;
  labb_nn_1 : N ;
  labb_nn_2 : N ;
  labbe_nn_1 : N ;
  laber_av_1 : A ;
  labial_av_1 : A ;
  labial_nn_1 : N ;
  labialstaemma_nn_1 : N ;
  labil_av_1 : A ;
  labilitet_nn_1 : N ;
  labiodental_av_1 : A ;
  labiodental_nn_1 : N ;
  laborant_nn_1 : N ;
  laboration_nn_1 : N ;
  laborativ_av_1 : A ;
  laborator_nn_1 : N ;
  laboratorieassistent_nn_1 : N ;
  laboratorieexperiment_nn_1 : N ;
  laboratorieresultat_nn_1 : N ;
  laboratorierock_nn_1 : N ;
  laboratorium_nn_1 : N ;
  labourregering_nn_1 : N ;
  labrador_nn_1 : N ;
  labyrint_nn_1 : N ;
  labyrintisk_av_1 : A ;
  lack_nn_1 : N ;
  lackering_nn_1 : N ;
  lackfaerg_nn_1 : N ;
  lacksko_nn_1 : N ;
  lackskoeldlus_nn_1 : N ;
  lackviol_nn_1 : N ;
  lad_nn_1 : N ;
  laddning_nn_1 : N ;
  laddram_nn_1 : N ;
  laddstock_nn_1 : N ;
  ladugaard_nn_1 : N ;
  lady_nn_1 : N ;
  laeck_av_1 : A ;
  laeckage_nn_1 : N ;
  laeckageproblem_nn_1 : N ;
  laecker_av_1 : A ;
  laeckerbit_nn_1 : N ;
  laeckergom_nn_1 : N ;
  laeckerhet_nn_1 : N ;
  laederlapp_nn_1 : N ;
  laege_nn_1 : N ;
  laegel_nn_1 : N ;
  laegenhet_nn_1 : N ;
  laegenhetsbyte_nn_1 : N ;
  laegenhetshotell_nn_1 : N ;
  laeger_ab_1 : Adv ;
  laeger_nn_1 : N ;
  laegerbaal_nn_1 : N ;
  laegereld_nn_1 : N ;
  laegesbestaemning_nn_1 : N ;
  laegesfoeraendring_nn_1 : N ;
  laegesrapport_nn_1 : N ;
  laegessinne_nn_1 : N ;
  laegg_nn_1 : N ;
  laegg_nn_2 : N ;
  laeggdags_ab_1 : Adv ;
  laeggning_nn_1 : N ;
  laeggspel_nn_1 : N ;
  laeglig_av_1 : A ;
  laekarbok_nn_1 : N ;
  laekarcentral_nn_1 : N ;
  laekare_nn_1 : N ;
  laekarhjaelp_nn_1 : N ;
  laekarhus_nn_1 : N ;
  laekarintyg_nn_1 : N ;
  laekarmottagning_nn_1 : N ;
  laekarordination_nn_1 : N ;
  laekarrecept_nn_1 : N ;
  laekarrock_nn_1 : N ;
  laekarsekreterare_nn_1 : N ;
  laekarundersoekning_nn_1 : N ;
  laekedom_nn_1 : N ;
  laekemedel_nn_1 : N ;
  laekemedelskontroll_nn_1 : N ;
  laekemedelslag_nn_1 : N ;
  laekevaext_nn_1 : N ;
  laekt_nn_1 : N ;
  laektare_nn_1 : N ;
  laem_nn_1 : N ;
  laemmel_nn_1 : N ;
  laemmelaar_nn_1 : N ;
  laemmeltaag_nn_1 : N ;
  laemning_nn_1 : N ;
  laempare_nn_1 : N ;
  laemplig_av_1 : A ;
  laempligen_ab_1 : Adv ;
  laemplighet_nn_1 : N ;
  laemplighetsintyg_nn_1 : N ;
  laen_nn_1 : N ;
  laend_nn_1 : N ;
  laenderval_nn_1 : N ;
  laengd_nn_1 : N ;
  laengdaxel_nn_1 : N ;
  laengdenhet_nn_1 : N ;
  laengdgrad_nn_1 : N ;
  laengdhopp_nn_1 : N ;
  laengdhoppare_nn_1 : N ;
  laengdloepning_nn_1 : N ;
  laengdmaatt_nn_1 : N ;
  laengdmarkering_nn_1 : N ;
  laengdmeter_nn_1 : N ;
  laengdprofil_nn_1 : N ;
  laengdriktning_nn_1 : N ;
  laengdsnitt_nn_1 : N ;
  laengdstreck_nn_1 : N ;
  laengdtecken_nn_1 : N ;
  laengdutvidgning_nn_1 : N ;
  laenge_ab_1 : Adv ;
  laengesedan_ab_1 : Adv ;
  laengs_ab_1 : Adv ;
  laengsdal_nn_1 : N ;
  laengsgaaende_av_1 : A ;
  laengstfoerfluten_av_1 : A ;
  laengtansfull_av_1 : A ;
  laenk_nn_1 : N ;
  laenkroerelse_nn_1 : N ;
  laenkstation_nn_1 : N ;
  laens_av_1 : A ;
  laens_nn_1 : N ;
  laensaaklagare_nn_1 : N ;
  laensarbetsdirektoer_nn_1 : N ;
  laensarbetsnaemnd_nn_1 : N ;
  laensarkitekt_nn_1 : N ;
  laensbeteckning_nn_1 : N ;
  laensbokstav_nn_1 : N ;
  laensherre_nn_1 : N ;
  laenskod_nn_1 : N ;
  laenslasarett_nn_1 : N ;
  laensman_nn_1 : N ;
  laenspump_nn_1 : N ;
  laensraad_nn_1 : N ;
  laensraett_nn_1 : N ;
  laensresidens_nn_1 : N ;
  laensskatteraett_nn_1 : N ;
  laensskolnaemnd_nn_1 : N ;
  laensstyrelse_nn_1 : N ;
  laenstol_nn_1 : N ;
  laensvaeg_nn_1 : N ;
  laensvis_ab_1 : Adv ;
  laentagare_nn_1 : N ;
  laepp_nn_1 : N ;
  laeppljud_nn_1 : N ;
  laepproerelse_nn_1 : N ;
  laeppsmink_nn_1 : N ;
  laeppsnus_nn_1 : N ;
  laeppstift_nn_1 : N ;
  laera_nn_1 : N ;
  laeraktig_av_1 : A ;
  laerare_nn_1 : N ;
  laerarfortbildning_nn_1 : N ;
  laerarinna_nn_1 : N ;
  laerarkandidat_nn_1 : N ;
  laerarledd_av_1 : A ;
  laerarlinje_nn_1 : N ;
  laerarloes_av_1 : A ;
  laerarroll_nn_1 : N ;
  laerarrum_nn_1 : N ;
  laerd_av_1 : A ;
  laerdom_nn_1 : N ;
  laerdomsprov_nn_1 : N ;
  laerdomsstad_nn_1 : N ;
  laerft_nn_1 : N ;
  laerjunge_nn_1 : N ;
  laerk_nn_1 : N ;
  laerkfalk_nn_1 : N ;
  laerktraed_nn_1 : N ;
  laerkvinge_nn_1 : N ;
  laerling_nn_1 : N ;
  laeroaar_nn_1 : N ;
  laeroaemne_nn_1 : N ;
  laeroanstalt_nn_1 : N ;
  laerobok_nn_1 : N ;
  laeroboksnaemnd_nn_1 : N ;
  laerobokssats_nn_1 : N ;
  laerobyggnad_nn_1 : N ;
  laerodikt_nn_1 : N ;
  laerofader_nn_1 : N ;
  laeromaestare_nn_1 : N ;
  laeromedel_nn_1 : N ;
  laeromedelspaket_nn_1 : N ;
  laeroplan_nn_1 : N ;
  laerorik_av_1 : A ;
  laerosaete_nn_1 : N ;
  laerosal_nn_1 : N ;
  laerosats_nn_1 : N ;
  laerospaan_nn_1 : N ;
  laerostol_nn_1 : N ;
  laeroverk_nn_1 : N ;
  laerpeng_nn_1 : N ;
  laesaar_nn_1 : N ;
  laesaemne_nn_1 : N ;
  laesapparat_nn_1 : N ;
  laesare_nn_1 : N ;
  laesart_nn_1 : N ;
  laesbar_av_1 : A ;
  laesbarhet_nn_1 : N ;
  laesbarhetsindex_nn_1 : N ;
  laesbarn_nn_1 : N ;
  laesbegaavning_nn_1 : N ;
  laesdag_nn_1 : N ;
  laesdrama_nn_1 : N ;
  laesebok_nn_1 : N ;
  laesecirkel_nn_1 : N ;
  laesekrets_nn_1 : N ;
  laesesal_nn_1 : N ;
  laesfaerdighet_nn_1 : N ;
  laesglas_nn_1 : N ;
  laeshuvud_nn_1 : N ;
  laesida_nn_1 : N ;
  laesion_nn_1 : N ;
  laesk_nn_1 : N ;
  laeskamrat_nn_1 : N ;
  laeskedryck_nn_1 : N ;
  laeskig_av_1 : A ;
  laesklass_nn_1 : N ;
  laesklinik_nn_1 : N ;
  laeskpapper_nn_1 : N ;
  laeskstaang_nn_1 : N ;
  laeskunnig_av_1 : A ;
  laeskunnighet_nn_1 : N ;
  laeslig_av_1 : A ;
  laesning_nn_1 : N ;
  laespljud_nn_1 : N ;
  laespraest_nn_1 : N ;
  laesrum_nn_1 : N ;
  laessvaarighet_nn_1 : N ;
  laessvag_av_1 : A ;
  laest_nn_1 : N ;
  laestadian_nn_1 : N ;
  laestadianism_nn_1 : N ;
  laestblock_nn_1 : N ;
  laesuttal_nn_1 : N ;
  laesvaerd_av_1 : A ;
  laesvaerde_nn_1 : N ;
  laete_nn_1 : N ;
  laett_av_1 : A ;
  laettantaendlig_av_1 : A ;
  laettbegriplig_av_1 : A ;
  laetteligen_ab_1 : Adv ;
  laettfaangen_av_1 : A ;
  laettfaerdig_av_1 : A ;
  laettfattlig_av_1 : A ;
  laettflyktig_av_1 : A ;
  laettflytande_av_1 : A ;
  laettfoerklarlig_av_1 : A ;
  laettfoerstaaelig_av_1 : A ;
  laettfoertjaent_av_1 : A ;
  laettframkomlig_av_1 : A ;
  laettfunnen_av_1 : A ;
  laettgrogg_nn_1 : N ;
  laetthanterlig_av_1 : A ;
  laetthet_nn_1 : N ;
  laettillgaenglig_av_1 : A ;
  laetting_nn_1 : N ;
  laettjefull_av_1 : A ;
  laettjord_nn_1 : N ;
  laettklaedd_av_1 : A ;
  laettkloev_nn_1 : N ;
  laettkoept_av_1 : A ;
  laettkokt_av_1 : A ;
  laettlaest_av_1 : A ;
  laettledd_av_1 : A ;
  laettloeslig_av_1 : A ;
  laettloest_av_1 : A ;
  laettmargarin_nn_1 : N ;
  laettmatros_nn_1 : N ;
  laettmetall_nn_1 : N ;
  laettnad_nn_1 : N ;
  laettoel_nn_1 : N ;
  laettoeverskaadlig_av_1 : A ;
  laettretlig_av_1 : A ;
  laettroekt_av_1 : A ;
  laettroerd_av_1 : A ;
  laettroerlig_av_1 : A ;
  laettrogen_av_1 : A ;
  laettsam_av_1 : A ;
  laettsinnig_av_1 : A ;
  laettskoett_av_1 : A ;
  laettskraemd_av_1 : A ;
  laettsmaelt_av_1 : A ;
  laettstekt_av_1 : A ;
  laettstoett_av_1 : A ;
  laettvattenreaktor_nn_1 : N ;
  laettviktare_nn_1 : N ;
  laettviktig_av_1 : A ;
  laettviktsmotorcykel_nn_1 : N ;
  laettvin_nn_1 : N ;
  laettvindig_av_1 : A ;
  laettvunnen_av_1 : A ;
  laexfoerhoer_nn_1 : N ;
  lafsig_av_1 : A ;
  lag_nn_1 : N ;
  lag_nn_2 : N ;
  laga_av_1 : A ;
  lagaard_nn_1 : N ;
  lagbalk_nn_1 : N ;
  lagberedning_nn_1 : N ;
  lagbok_nn_1 : N ;
  lagbunden_av_1 : A ;
  lagd_av_1 : A ;
  lagenlig_av_1 : A ;
  lager_nn_1 : N ;
  lager_nn_2 : N ;
  lager_nn_3 : N ;
  lagerbaersblad_nn_1 : N ;
  lagerblad_nn_1 : N ;
  lagerbok_nn_1 : N ;
  lagerbox_nn_1 : N ;
  lagerfoeljd_nn_1 : N ;
  lagergaang_nn_1 : N ;
  lagerkostnad_nn_1 : N ;
  lagerkrans_nn_1 : N ;
  lageroel_nn_1 : N ;
  lagerserie_nn_1 : N ;
  lagfaangen_av_1 : A ;
  lagfara_vb_1 : V ;
  lagfaren_av_1 : A ;
  lagfart_nn_1 : N ;
  lagfoerslag_nn_1 : N ;
  lagg_nn_1 : N ;
  laggband_nn_1 : N ;
  laggdike_nn_1 : N ;
  laggkaerl_nn_1 : N ;
  lagisk_av_1 : A ;
  lagkapp_nn_1 : N ;
  lagkappsimning_nn_1 : N ;
  lagkapten_nn_1 : N ;
  lagkarl_nn_1 : N ;
  lagklok_av_1 : A ;
  lagledare_nn_1 : N ;
  laglig_av_1 : A ;
  lagligen_ab_1 : Adv ;
  lagloes_av_1 : A ;
  lagloeshet_nn_1 : N ;
  laglott_nn_1 : N ;
  laglydig_av_1 : A ;
  lagman_nn_1 : N ;
  lagn_nn_1 : N ;
  lagom_ab_1 : Adv ;
  lagom_av_1 : A ;
  lagraad_nn_1 : N ;
  lagring_nn_1 : N ;
  lagringsfoerlust_nn_1 : N ;
  lagringskostnad_nn_1 : N ;
  lagrum_nn_1 : N ;
  lagsaga_nn_1 : N ;
  lagskipning_nn_1 : N ;
  lagspel_nn_1 : N ;
  lagspraak_nn_1 : N ;
  lagstiftare_nn_1 : N ;
  lagstiftning_nn_1 : N ;
  lagstridig_av_1 : A ;
  lagtempo_nn_1 : N ;
  lagtempolopp_nn_1 : N ;
  lagtext_nn_1 : N ;
  lagtima_av_1 : A ;
  lagun_nn_1 : N ;
  lagunsjoe_nn_1 : N ;
  lagutskott_nn_1 : N ;
  lagvigd_av_1 : A ;
  lagvraengare_nn_1 : N ;
  lagvunnen_av_1 : A ;
  lakan_nn_1 : N ;
  lakanspaase_nn_1 : N ;
  lakansspets_nn_1 : N ;
  lake_nn_1 : N ;
  lakej_nn_1 : N ;
  lakonisk_av_1 : A ;
  lakonism_nn_1 : N ;
  lakritsrot_nn_1 : N ;
  laktalbumin_nn_1 : N ;
  laktation_nn_1 : N ;
  laktovegetarian_nn_1 : N ;
  lakun_nn_1 : N ;
  lam_av_1 : A ;
  lama_nn_3 : N ;
  lamadjur_nn_1 : N ;
  lame_nn_1 : N ;
  lamell_nn_1 : N ;
  lamellhus_nn_1 : N ;
  lamellkoppling_nn_1 : N ;
  lamentation_nn_1 : N ;
  laminaer_av_1 : A ;
  laminat_nn_1 : N ;
  lamm_nn_1 : N ;
  lammsadel_nn_1 : N ;
  lammskinn_nn_1 : N ;
  lammunge_nn_1 : N ;
  lampett_nn_1 : N ;
  lampfot_nn_1 : N ;
  lamphaallare_nn_1 : N ;
  lampskaerm_nn_1 : N ;
  lan_nn_1 : N ;
  land_nn_1 : N ;
  land_nn_2 : N ;
  landaa_nn_1 : N ;
  landamaere_nn_1 : N ;
  landbo_nn_1 : N ;
  landborg_nn_1 : N ;
  landbris_nn_1 : N ;
  landdriven_av_1 : A ;
  landgaang_nn_1 : N ;
  landhoejning_nn_1 : N ;
  landis_nn_1 : N ;
  landkaenning_nn_1 : N ;
  landledes_ab_1 : Adv ;
  landmaerke_nn_1 : N ;
  landning_nn_1 : N ;
  landningsfoerbud_nn_1 : N ;
  landningshjul_nn_1 : N ;
  landningsmaerke_nn_1 : N ;
  landningsstaell_nn_1 : N ;
  landnot_nn_1 : N ;
  landomraade_nn_1 : N ;
  landrygg_nn_1 : N ;
  landsaenda_nn_1 : N ;
  landsaettning_nn_1 : N ;
  landsantikvarie_nn_1 : N ;
  landsarkiv_nn_1 : N ;
  landsarkivarie_nn_1 : N ;
  landsdel_nn_1 : N ;
  landsfader_nn_1 : N ;
  landsfiskal_nn_1 : N ;
  landsflyktig_av_1 : A ;
  landsfoerraedare_nn_1 : N ;
  landsfoerraederi_nn_1 : N ;
  landsfoervisning_nn_1 : N ;
  landsfogde_nn_1 : N ;
  landshoevding_nn_1 : N ;
  landshoevdingehus_nn_1 : N ;
  landskamp_nn_1 : N ;
  landskansli_nn_1 : N ;
  landskap_nn_1 : N ;
  landskapslag_nn_1 : N ;
  landskapsvapen_nn_1 : N ;
  landsknekt_nn_1 : N ;
  landskommun_nn_1 : N ;
  landslag_nn_1 : N ;
  landslag_nn_2 : N ;
  landsmaal_nn_1 : N ;
  landsmaalsalfabet_nn_1 : N ;
  landsman_nn_1 : N ;
  landsnummer_nn_1 : N ;
  landsomfattande_av_1 : A ;
  landsortsstad_nn_1 : N ;
  landsplaaga_nn_1 : N ;
  landssekretariat_nn_1 : N ;
  landstiga_vb_1 : V ;
  landstigning_nn_1 : N ;
  landstigningsbaat_nn_1 : N ;
  landsting_nn_1 : N ;
  landstingsdirektoer_nn_1 : N ;
  landstingsfoerbund_nn_1 : N ;
  landstingskatalog_nn_1 : N ;
  landstingskommun_nn_1 : N ;
  landstingsman_nn_1 : N ;
  landstingsraad_nn_1 : N ;
  landstrykare_nn_1 : N ;
  landsvaeg_nn_1 : N ;
  landsvaegsbuss_nn_1 : N ;
  landsvaegsriddare_nn_1 : N ;
  landtunga_nn_1 : N ;
  landvad_nn_1 : N ;
  landvind_nn_1 : N ;
  landvinning_nn_1 : N ;
  langare_nn_1 : N ;
  langarn_nn_1 : N ;
  langett_nn_1 : N ;
  langettstygn_nn_1 : N ;
  langobard_nn_1 : N ;
  langust_nn_1 : N ;
  lankes_nn_1 : N ;
  lans_nn_1 : N ;
  lansett_nn_1 : N ;
  lansettfisk_nn_1 : N ;
  lansiaer_nn_1 : N ;
  lantarbetare_nn_1 : N ;
  lantbrevbaerare_nn_1 : N ;
  lantbruk_nn_1 : N ;
  lantbrukare_nn_1 : N ;
  lantbruksdirektoer_nn_1 : N ;
  lantbruksfoerbund_nn_1 : N ;
  lantbrukskonsulent_nn_1 : N ;
  lantbruksnaemnd_nn_1 : N ;
  lantbruksstyrelse_nn_1 : N ;
  lantbruksuniversitet_nn_1 : N ;
  lantdag_nn_1 : N ;
  lantegendom_nn_1 : N ;
  lanternin_nn_1 : N ;
  lantgaard_nn_1 : N ;
  lantgreve_nn_1 : N ;
  lanthandel_nn_1 : N ;
  lanthushaallning_nn_1 : N ;
  lantis_nn_1 : N ;
  lantjunkare_nn_1 : N ;
  lantlig_av_1 : A ;
  lantmaestare_nn_1 : N ;
  lantmaetare_nn_1 : N ;
  lantmaeteri_nn_1 : N ;
  lantman_nn_1 : N ;
  lantmarskalk_nn_1 : N ;
  lantras_nn_1 : N ;
  lantrasgris_nn_1 : N ;
  lantvaern_nn_1 : N ;
  lantvin_nn_1 : N ;
  laotier_nn_1 : N ;
  laotisk_av_1 : A ;
  lapidarisk_av_1 : A ;
  lapp_nn_1 : N ;
  lapphund_nn_1 : N ;
  lappkast_nn_1 : N ;
  lapplaendsk_av_1 : A ;
  lapplaenning_nn_1 : N ;
  lapplandsgran_nn_1 : N ;
  lappskrivning_nn_1 : N ;
  lappsparv_nn_1 : N ;
  lapptaecke_nn_1 : N ;
  lappverk_nn_1 : N ;
  lapsk_av_1 : A ;
  lapska_nn_2 : N ;
  lapsus_nn_1 : N ;
  largetto_ab_1 : Adv ;
  largetto_nn_1 : N ;
  largo_ab_1 : Adv ;
  largo_nn_1 : N ;
  larm_nn_1 : N ;
  larmfoerlaeggning_nn_1 : N ;
  larmrapport_nn_1 : N ;
  larv_nn_1 : N ;
  larvband_nn_1 : N ;
  larver_nn_1 : N ;
  larvig_av_1 : A ;
  larvtraktor_nn_1 : N ;
  laryngal_av_1 : A ;
  laryngal_nn_1 : N ;
  laryngit_nn_1 : N ;
  laryngolog_nn_1 : N ;
  laryngoskop_nn_1 : N ;
  laryngoskopi_nn_1 : N ;
  lasarett_nn_1 : N ;
  lasaron_nn_1 : N ;
  lasciv_av_1 : A ;
  laser_nn_1 : N ;
  laserfaerg_nn_1 : N ;
  laserkanon_nn_1 : N ;
  laserstraalning_nn_1 : N ;
  laserstyrd_av_1 : A ;
  laserteknik_nn_1 : N ;
  lask_nn_1 : N ;
  laskning_nn_1 : N ;
  lass_nn_1 : N ;
  lasso_nn_1 : N ;
  last_nn_1 : N ;
  lastageplats_nn_1 : N ;
  lastbar_av_1 : A ;
  lastbil_nn_1 : N ;
  lastbilstransport_nn_1 : N ;
  lastdjur_nn_1 : N ;
  lastdryg_av_1 : A ;
  lastelig_av_1 : A ;
  lastfartyg_nn_1 : N ;
  lastflak_nn_1 : N ;
  lastfull_av_1 : A ;
  lastkran_nn_1 : N ;
  lastlinje_nn_1 : N ;
  lastning_nn_1 : N ;
  lastpall_nn_1 : N ;
  lastport_nn_1 : N ;
  lastprofil_nn_1 : N ;
  lastrum_nn_1 : N ;
  lastvattenlinje_nn_1 : N ;
  lasur_nn_1 : N ;
  lasyr_nn_1 : N ;
  latenstid_nn_1 : N ;
  latent_av_1 : A ;
  lateral_av_1 : A ;
  lateral_nn_1 : N ;
  lathund_nn_1 : N ;
  latin_amerikansk_av_1 : A ;
  latinamerikansk_av_1 : A ;
  latinare_nn_1 : N ;
  latinism_nn_1 : N ;
  latinlaeroverk_nn_1 : N ;
  latinlinje_nn_1 : N ;
  latinsegel_nn_1 : N ;
  latinsk_av_1 : A ;
  latitud_nn_1 : N ;
  latmask_nn_1 : N ;
  latrin_nn_1 : N ;
  laudatur_nn_1 : N ;
  lav_nn_1 : N ;
  lavasjoe_nn_1 : N ;
  lave_nn_1 : N ;
  lavemang_nn_1 : N ;
  lavendelblaa_av_1 : A ;
  lavering_nn_1 : N ;
  lavett_nn_1 : N ;
  lavin_nn_1 : N ;
  lavinhund_nn_1 : N ;
  lavoar_nn_1 : N ;
  lavregion_nn_1 : N ;
  lavyr_nn_1 : N ;
  lax_nn_1 : N ;
  laxativ_nn_1 : N ;
  laxermedel_nn_1 : N ;
  laxfaerg_nn_1 : N ;
  laxfisk_nn_1 : N ;
  laxgaard_nn_1 : N ;
  laxkar_nn_1 : N ;
  laxoering_nn_1 : N ;
  laxstjaert_nn_1 : N ;
  laxyngel_nn_1 : N ;
  layout_nn_1 : N ;
  lazzaron_nn_1 : N ;
  lealoes_av_1 : A ;
  leasing_nn_1 : N ;
  lebeman_nn_1 : N ;
  lecitin_nn_1 : N ;
  led_av_1 : A ;
  led_nn_1 : N ;
  led_nn_2 : N ;
  led_nn_3 : N ;
  ledamot_nn_1 : N ;
  ledarbegaavning_nn_1 : N ;
  ledare_nn_1 : N ;
  ledarhund_nn_1 : N ;
  ledarkult_nn_1 : N ;
  ledarskifte_nn_1 : N ;
  ledarskikt_nn_1 : N ;
  ledarskribent_nn_1 : N ;
  ledarstick_nn_1 : N ;
  ledband_nn_1 : N ;
  ledbrosk_nn_1 : N ;
  ledbruten_av_1 : A ;
  ledd_nn_1 : N ;
  leddjur_nn_1 : N ;
  ledfoerslitning_nn_1 : N ;
  ledfyr_nn_1 : N ;
  ledhuvud_nn_1 : N ;
  ledig_av_1 : A ;
  ledighet_nn_1 : N ;
  ledighetskommitte_nn_1 : N ;
  ledinflammation_nn_1 : N ;
  ledkapsel_nn_1 : N ;
  ledkort_nn_1 : N ;
  ledmotiv_nn_1 : N ;
  ledning_nn_1 : N ;
  ledningsmaal_nn_1 : N ;
  ledningsmotstaand_nn_1 : N ;
  ledningsorgan_nn_1 : N ;
  ledningsstolpe_nn_1 : N ;
  ledningsvaevnad_nn_1 : N ;
  ledsagare_nn_1 : N ;
  ledsam_av_1 : A ;
  ledsamhet_nn_1 : N ;
  ledsegel_nn_1 : N ;
  ledsen_av_1 : A ;
  ledskaal_nn_1 : N ;
  ledsnad_nn_1 : N ;
  ledstaang_nn_1 : N ;
  ledtraad_nn_1 : N ;
  ledungsskepp_nn_1 : N ;
  ledutrymme_nn_1 : N ;
  leende_nn_1 : N ;
  legaer_av_1 : A ;
  legal_av_1 : A ;
  legaliter_ab_1 : Adv ;
  legalitet_nn_1 : N ;
  legat_nn_1 : N ;
  legat_nn_2 : N ;
  legatarie_nn_1 : N ;
  legation_nn_1 : N ;
  legato_ab_1 : Adv ;
  legato_nn_1 : N ;
  legend_nn_1 : N ;
  legendar_nn_1 : N ;
  legendarisk_av_1 : A ;
  legendarium_nn_1 : N ;
  legendomspunnen_av_1 : A ;
  legering_nn_1 : N ;
  legio_av_1 : A ;
  legion_nn_1 : N ;
  legionaer_nn_1 : N ;
  legislativ_av_1 : A ;
  legislatur_nn_1 : N ;
  legitim_av_1 : A ;
  legitimation_nn_1 : N ;
  legitimist_nn_1 : N ;
  legitimitet_nn_1 : N ;
  lego_nn_1 : N ;
  legoavtal_nn_1 : N ;
  legoknekt_nn_1 : N ;
  legosoldat_nn_1 : N ;
  legotillverkning_nn_1 : N ;
  legotrupp_nn_1 : N ;
  leguan_nn_1 : N ;
  legymsallad_nn_1 : N ;
  lejd_nn_1 : N ;
  lejdare_nn_1 : N ;
  lejdbaat_nn_1 : N ;
  lejdebrev_nn_1 : N ;
  lejon_nn_1 : N ;
  lejonfot_nn_1 : N ;
  lejongap_nn_1 : N ;
  lejongrop_nn_1 : N ;
  lejoninna_nn_1 : N ;
  lejonklo_nn_1 : N ;
  lejonklorna_ab_1 : Adv ;
  lejontaemjare_nn_1 : N ;
  lek_av_1 : A ;
  lek_nn_1 : N ;
  lekamlig_av_1 : A ;
  lekamligen_ab_1 : Adv ;
  lekare_nn_1 : N ;
  lekatt_nn_1 : N ;
  lekboll_nn_1 : N ;
  lekdamm_nn_1 : N ;
  lekdraekt_nn_1 : N ;
  lekfaerdig_av_1 : A ;
  lekfisk_nn_1 : N ;
  lekfull_av_1 : A ;
  lekfullhet_nn_1 : N ;
  lekkamrat_nn_1 : N ;
  lekledare_nn_1 : N ;
  leklysten_av_1 : A ;
  lekman_nn_1 : N ;
  lekmannabroder_nn_1 : N ;
  lekotek_nn_1 : N ;
  lekpark_nn_1 : N ;
  lekplats_nn_1 : N ;
  leksak_nn_1 : N ;
  leksaksbaat_nn_1 : N ;
  leksaksbil_nn_1 : N ;
  leksaksbjoern_nn_1 : N ;
  leksaksfigur_nn_1 : N ;
  leksakshaest_nn_1 : N ;
  leksakspistol_nn_1 : N ;
  lekstuga_nn_1 : N ;
  lekt_av_1 : A ;
  lektid_nn_1 : N ;
  lektion_nn_1 : N ;
  lektionstimme_nn_1 : N ;
  lektoer_nn_1 : N ;
  lektor_nn_1 : N ;
  lektorat_nn_1 : N ;
  lektris_nn_1 : N ;
  lekvandring_nn_1 : N ;
  lekverk_nn_1 : N ;
  lem_nn_1 : N ;
  lemma_nn_1 : N ;
  lemmalytt_av_1 : A ;
  lemonad_nn_1 : N ;
  len_av_1 : A ;
  leninistisk_av_1 : A ;
  lenis_av_1 : A ;
  leopard_nn_1 : N ;
  leproes_av_1 : A ;
  leptosom_av_1 : A ;
  lerbotten_nn_1 : N ;
  lercylinder_nn_1 : N ;
  lergoek_nn_1 : N ;
  lerhaerd_nn_1 : N ;
  lerhalt_nn_1 : N ;
  lerhaltig_av_1 : A ;
  lerig_av_1 : A ;
  lerjord_nn_1 : N ;
  lerkaerl_nn_1 : N ;
  lerklining_nn_1 : N ;
  lerskiffer_nn_1 : N ;
  lesbisk_av_1 : A ;
  lesion_nn_1 : N ;
  lesothier_nn_1 : N ;
  lesothisk_av_1 : A ;
  letal_av_1 : A ;
  letargisk_av_1 : A ;
  lett_nn_1 : N ;
  lettisk_av_1 : A ;
  lettiska_nn_2 : N ;
  leukemi_nn_1 : N ;
  leukocyt_nn_1 : N ;
  lev_nn_1 : N ;
  leva_nn_1 : N ;
  levande_av_1 : A ;
  levang_nn_1 : N ;
  levantin_nn_1 : N ;
  leve_nn_1 : N ;
  lever_nn_1 : N ;
  leverans_nn_1 : N ;
  leveransavtal_nn_1 : N ;
  leveransklar_av_1 : A ;
  leveranstid_nn_1 : N ;
  leverantoer_nn_1 : N ;
  leverbrun_av_1 : A ;
  levercell_nn_1 : N ;
  leverflaeck_nn_1 : N ;
  leverop_nn_1 : N ;
  leverpastej_nn_1 : N ;
  leverskrumpning_nn_1 : N ;
  levit_nn_1 : N ;
  levnad_nn_1 : N ;
  levnadsaalder_nn_1 : N ;
  levnadsaar_nn_1 : N ;
  levnadsbeskrivning_nn_1 : N ;
  levnadsglad_av_1 : A ;
  levnadskonstnaer_nn_1 : N ;
  levnadskostnad_nn_1 : N ;
  levnadslopp_nn_1 : N ;
  levnadsnivaa_nn_1 : N ;
  levnadsoede_nn_1 : N ;
  levnadsregel_nn_1 : N ;
  levnadssaett_nn_1 : N ;
  levnadstecknare_nn_1 : N ;
  levnadsteckning_nn_1 : N ;
  levnadstroett_av_1 : A ;
  levnadsvisdom_nn_1 : N ;
  lexem_nn_1 : N ;
  lexikal_av_1 : A ;
  lexikalisk_av_1 : A ;
  lexikograf_nn_1 : N ;
  lexikografisk_av_1 : A ;
  lexikolog_nn_1 : N ;
  lexikologisk_av_1 : A ;
  lexikon_nn_1 : N ;
  lian_nn_1 : N ;
  libanes_nn_1 : N ;
  libanesisk_av_1 : A ;
  libation_nn_1 : N ;
  libell_nn_1 : N ;
  liberal_av_1 : A ;
  liberalisering_nn_1 : N ;
  liberian_nn_1 : N ;
  liberiansk_av_1 : A ;
  liberier_nn_1 : N ;
  liberisk_av_1 : A ;
  libero_nn_1 : N ;
  libertin_nn_1 : N ;
  libration_nn_1 : N ;
  librettist_nn_1 : N ;
  libretto_nn_1 : N ;
  libyer_nn_1 : N ;
  libysk_av_1 : A ;
  licens_nn_1 : N ;
  licentiat_nn_1 : N ;
  lid_nn_1 : N ;
  lida_vb_1 : V ;
  lidande_av_1 : A ;
  lidande_nn_1 : N ;
  lidandeshistoria_nn_1 : N ;
  lidelse_nn_1 : N ;
  lidelsefri_av_1 : A ;
  lidelsefull_av_1 : A ;
  lider_nn_1 : N ;
  liderlig_av_1 : A ;
  lie_nn_1 : N ;
  liechtensteinare_nn_1 : N ;
  liechtensteinsk_av_1 : A ;
  lieknagg_nn_1 : N ;
  lieskaft_nn_1 : N ;
  lift_nn_1 : N ;
  liftare_nn_1 : N ;
  ligament_nn_1 : N ;
  ligatur_nn_1 : N ;
  ligg_nn_1 : N ;
  liggare_nn_1 : N ;
  liggdags_ab_1 : Adv ;
  liggetid_nn_1 : N ;
  liggplats_nn_1 : N ;
  liggriktig_av_1 : A ;
  liggsaar_nn_1 : N ;
  liggsjuk_av_1 : A ;
  liggvagn_nn_1 : N ;
  ligist_nn_1 : N ;
  lignin_nn_1 : N ;
  ligurisk_av_1 : A ;
  liguster_nn_1 : N ;
  ligusterfjaeril_nn_1 : N ;
  ligustersvaermare_nn_1 : N ;
  lik_av_1 : A ;
  lik_nn_1 : N ;
  lika_ab_1 : Adv ;
  lika_av_1 : A ;
  likadan_av_1 : A ;
  likafullt_ab_1 : Adv ;
  likaledes_ab_1 : Adv ;
  likaloen_nn_1 : N ;
  likalydande_av_1 : A ;
  likare_nn_1 : N ;
  likasaa_ab_1 : Adv ;
  likasaavael_ab_1 : Adv ;
  likasom_ab_1 : Adv ;
  likavael_ab_1 : Adv ;
  likbent_av_1 : A ;
  likbesiktning_nn_1 : N ;
  likbjudarmin_nn_1 : N ;
  likblaanad_nn_1 : N ;
  likblek_av_1 : A ;
  like_nn_1 : N ;
  likfaerd_nn_1 : N ;
  likflaeck_nn_1 : N ;
  likfoergiftning_nn_1 : N ;
  likformig_av_1 : A ;
  likformighet_nn_1 : N ;
  likfynd_nn_1 : N ;
  likgiltig_av_1 : A ;
  likgiltighet_nn_1 : N ;
  likhet_nn_1 : N ;
  likhetstecken_nn_1 : N ;
  likljudande_av_1 : A ;
  likmaetigt_ab_1 : Adv ;
  liknaemnig_av_1 : A ;
  liknande_av_1 : A ;
  liknelse_nn_1 : N ;
  liknoejd_av_1 : A ;
  likoer_nn_1 : N ;
  likoerglas_nn_1 : N ;
  likriktare_nn_1 : N ;
  liksidig_av_1 : A ;
  liksiding_nn_1 : N ;
  likskaendare_nn_1 : N ;
  liksom_ab_1 : Adv ;
  likspaenning_nn_1 : N ;
  likstaellig_av_1 : A ;
  likstaellighet_nn_1 : N ;
  likstaemmig_av_1 : A ;
  likstaemmighet_nn_1 : N ;
  likstelhet_nn_1 : N ;
  likstroem_nn_1 : N ;
  liksvamp_nn_1 : N ;
  liksvepning_nn_1 : N ;
  liktor_nn_1 : N ;
  liktorn_nn_1 : N ;
  liktydig_av_1 : A ;
  likvael_ab_1 : Adv ;
  likvaerd_av_1 : A ;
  likvaerdig_av_1 : A ;
  likvid_nn_1 : N ;
  likvidation_nn_1 : N ;
  likvidator_nn_1 : N ;
  likviditet_nn_1 : N ;
  likvisst_ab_1 : Adv ;
  lila_av_1 : A ;
  lilja_nn_1 : N ;
  liljekonvalje_nn_1 : N ;
  liljevaext_nn_1 : N ;
  liljevit_av_1 : A ;
  lillasyster_nn_1 : N ;
  lillaxel_nn_1 : N ;
  lilleputt_nn_1 : N ;
  lillfinger_nn_1 : N ;
  lillsemester_nn_1 : N ;
  lillslam_nn_1 : N ;
  lillstuga_nn_1 : N ;
  lilltaa_nn_1 : N ;
  lillvaerdinna_nn_1 : N ;
  lim_nn_1 : N ;
  limaemne_nn_1 : N ;
  lime_nn_1 : N ;
  limerick_nn_1 : N ;
  limfaerg_nn_1 : N ;
  limgoerdel_nn_1 : N ;
  limit_nn_1 : N ;
  limitation_nn_1 : N ;
  limitativ_av_1 : A ;
  limkokeri_nn_1 : N ;
  limning_nn_1 : N ;
  limnisk_av_1 : A ;
  limnograf_nn_1 : N ;
  limnologisk_av_1 : A ;
  limousine_nn_1 : N ;
  limpinne_nn_1 : N ;
  limring_nn_1 : N ;
  limtillverkning_nn_1 : N ;
  linaaker_nn_1 : N ;
  lind_nn_1 : N ;
  lindansare_nn_1 : N ;
  lindare_nn_1 : N ;
  linddrag_nn_1 : N ;
  lindebarn_nn_1 : N ;
  lindning_nn_1 : N ;
  lindorm_nn_1 : N ;
  lindrig_av_1 : A ;
  lindring_nn_1 : N ;
  lineaer_av_1 : A ;
  linearritning_nn_1 : N ;
  linfroe_nn_1 : N ;
  lingarn_nn_1 : N ;
  lingeri_nn_1 : N ;
  lingon_nn_1 : N ;
  lingonbuske_nn_1 : N ;
  lingonpaeron_nn_1 : N ;
  lingonsylt_nn_1 : N ;
  lingul_av_1 : A ;
  lingvist_nn_1 : N ;
  lingvistisk_av_1 : A ;
  linhaarig_av_1 : A ;
  liniment_nn_1 : N ;
  linjaer_av_1 : A ;
  linjal_nn_1 : N ;
  linje_nn_1 : N ;
  linjeblockering_nn_1 : N ;
  linjedomare_nn_1 : N ;
  linjefoering_nn_1 : N ;
  linjelopp_nn_1 : N ;
  linjeman_nn_1 : N ;
  linjenaemnd_nn_1 : N ;
  linjeren_av_1 : A ;
  linjeskepp_nn_1 : N ;
  linjespektrum_nn_1 : N ;
  linjespel_nn_1 : N ;
  linjevaeljare_nn_1 : N ;
  linlugg_nn_1 : N ;
  linnedamast_nn_1 : N ;
  linneduk_nn_1 : N ;
  linnefiber_nn_1 : N ;
  linneskaap_nn_1 : N ;
  linning_nn_1 : N ;
  linoleumsnitt_nn_1 : N ;
  linolja_nn_1 : N ;
  lins_nn_1 : N ;
  linsfel_nn_1 : N ;
  linslus_nn_1 : N ;
  linssystem_nn_1 : N ;
  lintott_nn_1 : N ;
  lipas_nn_1 : N ;
  lipid_nn_1 : N ;
  lipig_av_1 : A ;
  lipom_nn_1 : N ;
  lipsill_nn_1 : N ;
  lire_nn_1 : N ;
  lisen_nn_1 : N ;
  lismare_nn_1 : N ;
  lisoes_nn_1 : N ;
  lispund_nn_1 : N ;
  list_nn_1 : N ;
  listig_av_1 : A ;
  listornament_nn_1 : N ;
  listprofil_nn_1 : N ;
  listverk_nn_1 : N ;
  litauer_nn_1 : N ;
  litauisk_av_1 : A ;
  litauiska_nn_2 : N ;
  lite_ab_1 : Adv ;
  liten_av_1 : A ;
  litenhet_nn_1 : N ;
  liter_nn_1 : N ;
  liter_nn_2 : N ;
  litermaatt_nn_1 : N ;
  litervis_ab_1 : Adv ;
  litograf_nn_1 : N ;
  litografi_nn_1 : N ;
  litoral_av_1 : A ;
  litotes_nn_1 : N ;
  litteraer_av_1 : A ;
  litterat_av_1 : A ;
  litteratoer_nn_1 : N ;
  litteratur_nn_1 : N ;
  litteraturanmaelan_nn_1 : N ;
  litteraturanvisning_nn_1 : N ;
  litteraturfoerteckning_nn_1 : N ;
  litteraturforskare_nn_1 : N ;
  litteraturhaenvisning_nn_1 : N ;
  litteraturhistorisk_av_1 : A ;
  litteraturingenjoer_nn_1 : N ;
  litteraturkritiker_nn_1 : N ;
  litteraturprofessor_nn_1 : N ;
  litteratursoekning_nn_1 : N ;
  litteraturspraak_nn_1 : N ;
  liturg_nn_1 : N ;
  liturgi_nn_1 : N ;
  liturgisk_av_1 : A ;
  liv_nn_1 : N ;
  livaktig_av_1 : A ;
  livbaat_nn_1 : N ;
  livbaelte_nn_1 : N ;
  livboj_nn_1 : N ;
  livdjur_nn_1 : N ;
  livdoemd_av_1 : A ;
  livdrabant_nn_1 : N ;
  live_av_1 : A ;
  live_show_nn_1 : N ;
  livegen_av_1 : A ;
  livfoersaekring_nn_1 : N ;
  livfull_av_1 : A ;
  livgarde_nn_1 : N ;
  livgivande_av_1 : A ;
  livklaednad_nn_1 : N ;
  livlig_av_1 : A ;
  livlighet_nn_1 : N ;
  livloes_av_1 : A ;
  livmedikus_nn_1 : N ;
  livmoderframfall_nn_1 : N ;
  livmoderhals_nn_1 : N ;
  livmodermun_nn_1 : N ;
  livmodersslemhinna_nn_1 : N ;
  livraeddare_nn_1 : N ;
  livraeddning_nn_1 : N ;
  livraett_nn_1 : N ;
  livre_nn_1 : N ;
  livregemente_nn_1 : N ;
  livrem_nn_1 : N ;
  livrustkammare_nn_1 : N ;
  livs_av_1 : A ;
  livsaaskaadning_nn_1 : N ;
  livsarvinge_nn_1 : N ;
  livsavgoerande_av_1 : A ;
  livsbefraemjande_av_1 : A ;
  livsbejakande_av_1 : A ;
  livsbejakare_nn_1 : N ;
  livsbetingelse_nn_1 : N ;
  livsduglig_av_1 : A ;
  livselixir_nn_1 : N ;
  livsfarlig_av_1 : A ;
  livsfoering_nn_1 : N ;
  livsfoernekelse_nn_1 : N ;
  livsform_nn_1 : N ;
  livsfraaga_nn_1 : N ;
  livsgaerning_nn_1 : N ;
  livshaallning_nn_1 : N ;
  livshotande_av_1 : A ;
  livskamrat_nn_1 : N ;
  livskraftig_av_1 : A ;
  livskvalitet_nn_1 : N ;
  livslaang_av_1 : A ;
  livslaengd_nn_1 : N ;
  livslag_nn_1 : N ;
  livslevande_av_1 : A ;
  livslinje_nn_1 : N ;
  livsloegn_nn_1 : N ;
  livslust_nn_1 : N ;
  livsmedel_nn_1 : N ;
  livsmedelsaffaer_nn_1 : N ;
  livsmedelsavfall_nn_1 : N ;
  livsmedelsbutik_nn_1 : N ;
  livsmedelsfaerg_nn_1 : N ;
  livsmedelslag_nn_1 : N ;
  livsmiljoe_nn_1 : N ;
  livsnerv_nn_1 : N ;
  livsnoedvaendig_av_1 : A ;
  livsprocess_nn_1 : N ;
  livsreaktion_nn_1 : N ;
  livssituation_nn_1 : N ;
  livsslut_nn_1 : N ;
  livsstil_nn_1 : N ;
  livssyn_nn_1 : N ;
  livstecken_nn_1 : N ;
  livstraed_nn_1 : N ;
  livsuppehaallande_av_1 : A ;
  livsuppgift_nn_1 : N ;
  livsutveckling_nn_1 : N ;
  livsvaenlig_av_1 : A ;
  livsverk_nn_1 : N ;
  livsviktig_av_1 : A ;
  livsvillkor_nn_1 : N ;
  livsyttring_nn_1 : N ;
  livtag_nn_1 : N ;
  livvakt_nn_1 : N ;
  lix_nn_1 : N ;
  ljud_nn_1 : N ;
  ljudaatergivning_nn_1 : N ;
  ljudande_av_1 : A ;
  ljudband_nn_1 : N ;
  ljudbang_nn_1 : N ;
  ljudbildband_nn_1 : N ;
  ljudboj_nn_1 : N ;
  ljudbrev_nn_1 : N ;
  ljuddaempande_av_1 : A ;
  ljuddaempare_nn_1 : N ;
  ljudenlig_av_1 : A ;
  ljudfilm_nn_1 : N ;
  ljudfoeraendring_nn_1 : N ;
  ljudfoerbindelse_nn_1 : N ;
  ljudhaal_nn_1 : N ;
  ljudhaermande_av_1 : A ;
  ljudhastighet_nn_1 : N ;
  ljudinspelning_nn_1 : N ;
  ljudisolering_nn_1 : N ;
  ljudkuliss_nn_1 : N ;
  ljudkvalitet_nn_1 : N ;
  ljudlaera_nn_1 : N ;
  ljudlag_nn_1 : N ;
  ljudlig_av_1 : A ;
  ljudloes_av_1 : A ;
  ljudnivaa_nn_1 : N ;
  ljudoeverfoering_nn_1 : N ;
  ljudsignal_nn_1 : N ;
  ljudskridning_nn_1 : N ;
  ljudskrift_nn_1 : N ;
  ljudstyrka_nn_1 : N ;
  ljudsystem_nn_1 : N ;
  ljudtekniker_nn_1 : N ;
  ljudvall_nn_1 : N ;
  ljuga_vb_1 : V ;
  ljugarbaenk_nn_1 : N ;
  ljum_av_1 : A ;
  ljumhet_nn_1 : N ;
  ljummen_av_1 : A ;
  ljumske_nn_1 : N ;
  ljungeld_nn_1 : N ;
  ljungpipare_nn_1 : N ;
  ljungvaext_nn_1 : N ;
  ljus_av_1 : A ;
  ljus_nn_1 : N ;
  ljusaar_nn_1 : N ;
  ljusaekta_av_1 : A ;
  ljusaelskande_av_1 : A ;
  ljusalf_nn_1 : N ;
  ljusbaage_nn_1 : N ;
  ljusbehandling_nn_1 : N ;
  ljusbestaendig_av_1 : A ;
  ljusbild_nn_1 : N ;
  ljusblaa_av_1 : A ;
  ljusblind_av_1 : A ;
  ljusblixt_nn_1 : N ;
  ljusbrunn_nn_1 : N ;
  ljusbrytning_nn_1 : N ;
  ljusfenomen_nn_1 : N ;
  ljusfilter_nn_1 : N ;
  ljusfloede_nn_1 : N ;
  ljusfoerhaallande_nn_1 : N ;
  ljusgaard_nn_1 : N ;
  ljusgestalt_nn_1 : N ;
  ljusglimt_nn_1 : N ;
  ljusgraa_av_1 : A ;
  ljusgroen_av_1 : A ;
  ljusgul_av_1 : A ;
  ljushaallare_nn_1 : N ;
  ljushaarig_av_1 : A ;
  ljushastighet_nn_1 : N ;
  ljushuggning_nn_1 : N ;
  ljushuvud_nn_1 : N ;
  ljushyllt_av_1 : A ;
  ljuskaegla_nn_1 : N ;
  ljuskaenslig_av_1 : A ;
  ljuskaenslighet_nn_1 : N ;
  ljuskopiering_nn_1 : N ;
  ljuskvantum_nn_1 : N ;
  ljuslaett_av_1 : A ;
  ljuslagd_av_1 : A ;
  ljuslockig_av_1 : A ;
  ljusmikroskop_nn_1 : N ;
  ljusning_nn_1 : N ;
  ljusorgel_nn_1 : N ;
  ljuspartikel_nn_1 : N ;
  ljuspunkt_nn_1 : N ;
  ljusramp_nn_1 : N ;
  ljusroed_av_1 : A ;
  ljussaettning_nn_1 : N ;
  ljussignal_nn_1 : N ;
  ljussken_nn_1 : N ;
  ljusskygg_av_1 : A ;
  ljusskygghet_nn_1 : N ;
  ljusslaeckare_nn_1 : N ;
  ljusstake_nn_1 : N ;
  ljusstark_av_1 : A ;
  ljusstraale_nn_1 : N ;
  ljusstraalning_nn_1 : N ;
  ljusstyrka_nn_1 : N ;
  ljussvag_av_1 : A ;
  ljuster_nn_1 : N ;
  ljustryck_nn_1 : N ;
  ljusutstraalning_nn_1 : N ;
  ljuv_av_1 : A ;
  ljuvhet_nn_1 : N ;
  ljuvlig_av_1 : A ;
  ljuvlighet_nn_1 : N ;
  lo_nn_1 : N ;
  lob_nn_1 : N ;
  lobb_nn_1 : N ;
  lobby_nn_1 : N ;
  lobbyverksamhet_nn_1 : N ;
  lobotomi_nn_1 : N ;
  lock_nn_1 : N ;
  lock_nn_2 : N ;
  lockbete_nn_1 : N ;
  lockdjur_nn_1 : N ;
  lockelse_nn_1 : N ;
  lockfaagel_nn_1 : N ;
  lockfaerg_nn_1 : N ;
  lockig_av_1 : A ;
  lockout_nn_1 : N ;
  lockpris_nn_1 : N ;
  lockrop_nn_1 : N ;
  locktaang_nn_1 : N ;
  loco_ab_1 : Adv ;
  lod_nn_1 : N ;
  lodare_nn_1 : N ;
  lodbar_av_1 : A ;
  lodenrock_nn_1 : N ;
  lodis_nn_1 : N ;
  lodjur_nn_1 : N ;
  lodlinje_nn_1 : N ;
  lodplan_nn_1 : N ;
  lodraet_av_1 : A ;
  lodskott_nn_1 : N ;
  lodstreck_nn_1 : N ;
  loeddrig_av_1 : A ;
  loedfog_nn_1 : N ;
  loedig_av_1 : A ;
  loedkolv_nn_1 : N ;
  loedmetall_nn_1 : N ;
  loedning_nn_1 : N ;
  loefte_nn_1 : N ;
  loeftesman_nn_1 : N ;
  loeftesrik_av_1 : A ;
  loeftesskrift_nn_1 : N ;
  loegn_nn_1 : N ;
  loegnaktig_av_1 : A ;
  loegnare_nn_1 : N ;
  loegndetektor_nn_1 : N ;
  loegnhals_nn_1 : N ;
  loegnkampanj_nn_1 : N ;
  loeje_nn_1 : N ;
  loejevaeckande_av_1 : A ;
  loejlig_av_1 : A ;
  loejlighet_nn_1 : N ;
  loejtnant_nn_1 : N ;
  loek_nn_1 : N ;
  loekfjaell_nn_1 : N ;
  loekformig_av_1 : A ;
  loekknopp_nn_1 : N ;
  loekkupol_nn_1 : N ;
  loeksill_nn_1 : N ;
  loekstam_nn_1 : N ;
  loekvaext_nn_1 : N ;
  loemsk_av_1 : A ;
  loen_nn_1 : N ;
  loenande_av_1 : A ;
  loeneanspraak_nn_1 : N ;
  loenearbetare_nn_1 : N ;
  loeneavdrag_nn_1 : N ;
  loeneavtal_nn_1 : N ;
  loenebesked_nn_1 : N ;
  loenebidrag_nn_1 : N ;
  loenefil_nn_1 : N ;
  loenefoerhoejning_nn_1 : N ;
  loenefoermaan_nn_1 : N ;
  loenegaranti_nn_1 : N ;
  loeneglidning_nn_1 : N ;
  loenegrad_nn_1 : N ;
  loenehoejning_nn_1 : N ;
  loeneklass_nn_1 : N ;
  loenekostnad_nn_1 : N ;
  loenekuvert_nn_1 : N ;
  loenelaege_nn_1 : N ;
  loenelyft_nn_1 : N ;
  loenenivaa_nn_1 : N ;
  loeneoekning_nn_1 : N ;
  loenepaaslag_nn_1 : N ;
  loeneplan_nn_1 : N ;
  loeneroerelse_nn_1 : N ;
  loenesaettning_nn_1 : N ;
  loeneslav_nn_1 : N ;
  loenestopp_nn_1 : N ;
  loenetak_nn_1 : N ;
  loenetillaegg_nn_1 : N ;
  loeneuppgift_nn_1 : N ;
  loeneutveckling_nn_1 : N ;
  loening_nn_1 : N ;
  loenloes_av_1 : A ;
  loenn_nn_1 : N ;
  loennbraenning_nn_1 : N ;
  loennfack_nn_1 : N ;
  loennfet_av_1 : A ;
  loennkrog_nn_1 : N ;
  loennlig_av_1 : A ;
  loennligen_ab_1 : Adv ;
  loennmord_nn_1 : N ;
  loensam_av_1 : A ;
  loensamhet_nn_1 : N ;
  loenskalaege_nn_1 : N ;
  loensparande_nn_1 : N ;
  loent_av_1 : A ;
  loentagare_nn_1 : N ;
  loentagarfond_nn_1 : N ;
  loep_nn_1 : N ;
  loepa_vb_1 : V ;
  loepande_av_1 : A ;
  loepare_nn_1 : N ;
  loeparsten_nn_1 : N ;
  loepeld_nn_1 : N ;
  loepeost_nn_1 : N ;
  loepgrav_nn_1 : N ;
  loephjul_nn_1 : N ;
  loepknut_nn_1 : N ;
  loepmage_nn_1 : N ;
  loepmeter_nn_1 : N ;
  loepning_nn_1 : N ;
  loepord_nn_1 : N ;
  loepost_nn_1 : N ;
  loepring_nn_1 : N ;
  loepsedel_nn_1 : N ;
  loepsk_av_1 : A ;
  loepskift_nn_1 : N ;
  loepsteg_nn_1 : N ;
  loepsten_nn_1 : N ;
  loeptid_nn_1 : N ;
  loepvagn_nn_1 : N ;
  loepvikt_nn_1 : N ;
  loerdag_nn_1 : N ;
  loerdagskvaell_nn_1 : N ;
  loerdagsmorgon_nn_1 : N ;
  loerdagsoeppen_av_1 : A ;
  loerdagsstaengd_av_1 : A ;
  loes_av_1 : A ;
  loesaktig_av_1 : A ;
  loesan_av_1 : A ;
  loesande_av_1 : A ;
  loesbar_av_1 : A ;
  loesbladssystem_nn_1 : N ;
  loesdrivare_nn_1 : N ;
  loesegendom_nn_1 : N ;
  loesenord_nn_1 : N ;
  loesepenning_nn_1 : N ;
  loeseskilling_nn_1 : N ;
  loesesumma_nn_1 : N ;
  loesfynd_nn_1 : N ;
  loesgaaende_av_1 : A ;
  loesgom_nn_1 : N ;
  loeshaar_nn_1 : N ;
  loeshaest_nn_1 : N ;
  loeskekarl_nn_1 : N ;
  loeskokt_av_1 : A ;
  loeslig_av_1 : A ;
  loeslighet_nn_1 : N ;
  loesmynt_av_1 : A ;
  loesning_nn_1 : N ;
  loesningsegenskap_nn_1 : N ;
  loesningsmedel_nn_1 : N ;
  loesnummer_nn_1 : N ;
  loesoere_nn_1 : N ;
  loesoerekoep_nn_1 : N ;
  loesryckt_av_1 : A ;
  loesrygg_nn_1 : N ;
  loessjord_nn_1 : N ;
  loesslaeppt_av_1 : A ;
  loestagbar_av_1 : A ;
  loet_nn_1 : N ;
  loev_nn_1 : N ;
  loevaeng_nn_1 : N ;
  loevbiff_nn_1 : N ;
  loevblandskog_nn_1 : N ;
  loevfaellning_nn_1 : N ;
  loevfoder_nn_1 : N ;
  loevhyddohoegtid_nn_1 : N ;
  loevjord_nn_1 : N ;
  loevklaedd_av_1 : A ;
  loevmask_nn_1 : N ;
  loevsaag_nn_1 : N ;
  loevsaagning_nn_1 : N ;
  loevsaangare_nn_1 : N ;
  loevsal_nn_1 : N ;
  loevskog_nn_1 : N ;
  loevsmyg_nn_1 : N ;
  loevsprickning_nn_1 : N ;
  loevtaekt_nn_1 : N ;
  loevtraed_nn_1 : N ;
  loevtunn_av_1 : A ;
  loevverk_nn_1 : N ;
  loft_nn_1 : N ;
  loftbod_nn_1 : N ;
  loftgaang_nn_1 : N ;
  logaritm_nn_1 : N ;
  logaritmisk_av_1 : A ;
  logaritmsystem_nn_1 : N ;
  loge_nn_1 : N ;
  loge_nn_2 : N ;
  logement_nn_1 : N ;
  logg_nn_1 : N ;
  loggbok_nn_1 : N ;
  loggert_nn_1 : N ;
  loggertsegel_nn_1 : N ;
  logglas_nn_1 : N ;
  logi_nn_1 : N ;
  logiker_nn_1 : N ;
  logisk_av_1 : A ;
  logografisk_av_1 : A ;
  logogram_nn_1 : N ;
  logoped_nn_1 : N ;
  logopedisk_av_1 : A ;
  logotyp_nn_1 : N ;
  loj_av_1 : A ;
  lojal_av_1 : A ;
  lojalitet_nn_1 : N ;
  lojalitetsfoerklaring_nn_1 : N ;
  lok_nn_1 : N ;
  lokal_av_1 : A ;
  lokal_nn_1 : N ;
  lokalavdelning_nn_1 : N ;
  lokalbedoevning_nn_1 : N ;
  lokalfaerg_nn_1 : N ;
  lokalisering_nn_1 : N ;
  lokaliseringsstoed_nn_1 : N ;
  lokalitet_nn_1 : N ;
  lokalkaennedom_nn_1 : N ;
  lokalombud_nn_1 : N ;
  lokalpatriot_nn_1 : N ;
  lokalredaktoer_nn_1 : N ;
  lokalsamtal_nn_1 : N ;
  lokaltaag_nn_1 : N ;
  lokaltelefon_nn_1 : N ;
  lokaltid_nn_1 : N ;
  lokalvaardare_nn_1 : N ;
  lokativ_nn_1 : N ;
  lokatt_nn_1 : N ;
  lokfoerare_nn_1 : N ;
  loko_ab_1 : Adv ;
  lokomobil_nn_1 : N ;
  lokomotiv_nn_1 : N ;
  lokomotor_nn_1 : N ;
  lokus_nn_1 : N ;
  lom_nn_1 : N ;
  lomhoerd_av_1 : A ;
  longitud_nn_1 : N ;
  longitudinal_av_1 : A ;
  longitudinell_av_1 : A ;
  longoer_nn_1 : N ;
  look_nn_1 : N ;
  loop_nn_1 : N ;
  looping_nn_1 : N ;
  lopp_nn_1 : N ;
  loppcirkus_nn_1 : N ;
  loppmarknad_nn_1 : N ;
  loppspel_nn_1 : N ;
  lord_nn_1 : N ;
  lordkansler_nn_1 : N ;
  lornjett_nn_1 : N ;
  lort_nn_1 : N ;
  lortig_av_1 : A ;
  loss_ab_1 : Adv ;
  lossning_nn_1 : N ;
  lots_nn_1 : N ;
  lotsdistrikt_nn_1 : N ;
  lotshjaelp_nn_1 : N ;
  lotsled_nn_1 : N ;
  lotsning_nn_1 : N ;
  lotsplats_nn_1 : N ;
  lotssignal_nn_1 : N ;
  lott_nn_1 : N ;
  lottakaar_nn_1 : N ;
  lottaroerelse_nn_1 : N ;
  lottdragning_nn_1 : N ;
  lotteri_nn_1 : N ;
  lottloes_av_1 : A ;
  lottsedel_nn_1 : N ;
  lotus_nn_1 : N ;
  lov_nn_1 : N ;
  lov_nn_3 : N ;
  lovande_av_1 : A ;
  love_nn_1 : N ;
  lovgirig_av_1 : A ;
  lovlig_av_1 : A ;
  lovord_nn_1 : N ;
  lovpsalm_nn_1 : N ;
  lovsaang_nn_1 : N ;
  lovsjunga_vb_1 : V ;
  lovtal_nn_1 : N ;
  lovvaerd_av_1 : A ;
  loxodrom_nn_1 : N ;
  lubb_nn_1 : N ;
  lubrikator_nn_1 : N ;
  luciafest_nn_1 : N ;
  luciakrans_nn_1 : N ;
  luciamorgon_nn_1 : N ;
  luciasaang_nn_1 : N ;
  luciataag_nn_1 : N ;
  lucker_av_1 : A ;
  luddig_av_1 : A ;
  luden_av_1 : A ;
  luder_nn_1 : N ;
  luetisk_av_1 : A ;
  luffare_nn_1 : N ;
  lufsig_av_1 : A ;
  luft_nn_1 : N ;
  luftaffaer_nn_1 : N ;
  luftakrobat_nn_1 : N ;
  luftande_nn_1 : N ;
  luftanfall_nn_1 : N ;
  luftattack_nn_1 : N ;
  luftballong_nn_1 : N ;
  luftbevakning_nn_1 : N ;
  luftboll_nn_1 : N ;
  luftbro_nn_1 : N ;
  luftbubbla_nn_1 : N ;
  luftburen_av_1 : A ;
  luftdrag_nn_1 : N ;
  luftemboli_nn_1 : N ;
  luftfaerd_nn_1 : N ;
  luftfarkost_nn_1 : N ;
  luftfartyg_nn_1 : N ;
  luftfilter_nn_1 : N ;
  luftfjaedring_nn_1 : N ;
  luftfoerorening_nn_1 : N ;
  luftfuktare_nn_1 : N ;
  luftfuktighet_nn_1 : N ;
  luftgap_nn_1 : N ;
  luftgevaer_nn_1 : N ;
  luftgrop_nn_1 : N ;
  lufthav_nn_1 : N ;
  luftig_av_1 : A ;
  luftkonditionering_nn_1 : N ;
  luftkub_nn_1 : N ;
  luftkudde_nn_1 : N ;
  luftkuddefarkost_nn_1 : N ;
  luftkyld_av_1 : A ;
  luftlager_nn_1 : N ;
  luftled_nn_1 : N ;
  luftledes_ab_1 : Adv ;
  luftledning_nn_1 : N ;
  luftmadrass_nn_1 : N ;
  luftmaengd_nn_1 : N ;
  luftmast_nn_1 : N ;
  luftombyte_nn_1 : N ;
  luftperspektiv_nn_1 : N ;
  luftpistol_nn_1 : N ;
  luftpropeller_nn_1 : N ;
  luftpump_nn_1 : N ;
  luftrenare_nn_1 : N ;
  luftroer_nn_1 : N ;
  luftroerskatarr_nn_1 : N ;
  luftrot_nn_1 : N ;
  luftrum_nn_1 : N ;
  luftsaeck_nn_1 : N ;
  luftskalle_nn_1 : N ;
  luftskepp_nn_1 : N ;
  luftskikt_nn_1 : N ;
  luftslott_nn_1 : N ;
  luftsluss_nn_1 : N ;
  luftspaerr_nn_1 : N ;
  luftstroem_nn_1 : N ;
  luftstrupe_nn_1 : N ;
  lufttaet_av_1 : A ;
  lufttemperatur_nn_1 : N ;
  lufttom_av_1 : A ;
  lufttryck_nn_1 : N ;
  luftvaeg_nn_1 : N ;
  luftvaern_nn_1 : N ;
  luftvaernskanon_nn_1 : N ;
  luftvaernsrobot_nn_1 : N ;
  luftvaexling_nn_1 : N ;
  luftventil_nn_1 : N ;
  lugg_nn_1 : N ;
  luggig_av_1 : A ;
  luggsliten_av_1 : A ;
  lugn_av_1 : A ;
  lugnande_av_1 : A ;
  lugnvatten_nn_1 : N ;
  luguber_av_1 : A ;
  lukrativ_av_1 : A ;
  lukt_nn_1 : N ;
  luktaert_nn_1 : N ;
  luktfri_av_1 : A ;
  luktnerv_nn_1 : N ;
  luktsinne_nn_1 : N ;
  luktvatten_nn_1 : N ;
  luktvial_nn_1 : N ;
  luktviol_nn_1 : N ;
  lukullisk_av_1 : A ;
  lull_ab_1 : Adv ;
  lullig_av_1 : A ;
  lumbal_av_1 : A ;
  lumbalbedoevning_nn_1 : N ;
  lumbalpunktion_nn_1 : N ;
  lumen_nn_1 : N ;
  lumen_nn_2 : N ;
  luminoes_av_1 : A ;
  lummervaext_nn_1 : N ;
  lummig_av_1 : A ;
  lumpen_av_1 : A ;
  lumpfisk_nn_1 : N ;
  lumpig_av_1 : A ;
  lunar_av_1 : A ;
  lunarisk_av_1 : A ;
  lunation_nn_1 : N ;
  lunch_nn_1 : N ;
  lunchbord_nn_1 : N ;
  lunchrestaurang_nn_1 : N ;
  lunchrum_nn_1 : N ;
  lund_nn_1 : N ;
  lundensisk_av_1 : A ;
  lungandande_av_1 : A ;
  lungbyte_nn_1 : N ;
  lungemboli_nn_1 : N ;
  lungfisk_nn_1 : N ;
  lunginflammation_nn_1 : N ;
  lungkatarr_nn_1 : N ;
  lunglob_nn_1 : N ;
  lungoedem_nn_1 : N ;
  lungoert_nn_1 : N ;
  lungpulsaader_nn_1 : N ;
  lungrot_nn_1 : N ;
  lungsaeck_nn_1 : N ;
  lungsaecksinflammation_nn_1 : N ;
  lungsiktig_av_1 : A ;
  lungsjukdom_nn_1 : N ;
  lunne_nn_1 : N ;
  lunnefaagel_nn_1 : N ;
  lunnkaelke_nn_1 : N ;
  luns_nn_1 : N ;
  lunsig_av_1 : A ;
  luntlaas_nn_1 : N ;
  lupin_nn_1 : N ;
  lupp_nn_1 : N ;
  lur_nn_1 : N ;
  lurendrejare_nn_1 : N ;
  lurendrejeri_nn_1 : N ;
  lurifax_nn_1 : N ;
  lurig_av_1 : A ;
  lurk_nn_1 : N ;
  lurt_av_1 : A ;
  lurvig_av_1 : A ;
  lus_nn_1 : N ;
  lusern_nn_1 : N ;
  luserngroenmjoel_nn_1 : N ;
  lusfattig_av_1 : A ;
  lusig_av_1 : A ;
  luskung_nn_1 : N ;
  luspank_av_1 : A ;
  luspudel_nn_1 : N ;
  lussefest_nn_1 : N ;
  lussekatt_nn_1 : N ;
  lust_nn_1 : N ;
  lustbarhet_nn_1 : N ;
  lustbehov_nn_1 : N ;
  lustcentrum_nn_1 : N ;
  lustelig_av_1 : A ;
  lustfylld_av_1 : A ;
  lustgaard_nn_1 : N ;
  lustgas_nn_1 : N ;
  lusthus_nn_1 : N ;
  lustig_av_1 : A ;
  lustighet_nn_1 : N ;
  lustigkurre_nn_1 : N ;
  lustimpuls_nn_1 : N ;
  lustjakt_nn_1 : N ;
  lustkaensla_nn_1 : N ;
  lustloegnare_nn_1 : N ;
  lustmoerdare_nn_1 : N ;
  lustmord_nn_1 : N ;
  lustslott_nn_1 : N ;
  lustspel_nn_1 : N ;
  lustupplevelse_nn_1 : N ;
  lut_nn_1 : N ;
  lutfisk_nn_1 : N ;
  lutheran_nn_1 : N ;
  lutherdom_nn_1 : N ;
  luthersk_av_1 : A ;
  lutning_nn_1 : N ;
  lutningsmaetare_nn_1 : N ;
  lutningsstreck_nn_1 : N ;
  lutningsvariation_nn_1 : N ;
  lutsaangare_nn_1 : N ;
  lutter_av_1 : A ;
  luv_nn_1 : N ;
  lux_nn_1 : N ;
  luxation_nn_1 : N ;
  luxemburgare_nn_1 : N ;
  luxemburgsk_av_1 : A ;
  luxmeter_nn_1 : N ;
  luxuoes_av_1 : A ;
  lyceum_nn_1 : N ;
  lycka_nn_2 : N ;
  lycklig_av_1 : A ;
  lyckligen_ab_1 : Adv ;
  lyckligtvis_ab_1 : Adv ;
  lyckobringande_av_1 : A ;
  lyckoenskning_nn_1 : N ;
  lyckohjul_nn_1 : N ;
  lyckokast_nn_1 : N ;
  lyckokloever_nn_1 : N ;
  lyckopiller_nn_1 : N ;
  lyckorike_nn_1 : N ;
  lyckorus_nn_1 : N ;
  lyckosam_av_1 : A ;
  lyckoslant_nn_1 : N ;
  lyckotal_nn_1 : N ;
  lycksalig_av_1 : A ;
  lycksoekare_nn_1 : N ;
  lycktraeff_nn_1 : N ;
  lyda_vb_1 : V ;
  lydaktig_av_1 : A ;
  lydelse_nn_1 : N ;
  lydfolk_nn_1 : N ;
  lydig_av_1 : A ;
  lydkonung_nn_1 : N ;
  lydnad_nn_1 : N ;
  lydnadsbrott_nn_1 : N ;
  lydstat_nn_1 : N ;
  lyft_nn_1 : N ;
  lyftanordning_nn_1 : N ;
  lyftarm_nn_1 : N ;
  lyftblock_nn_1 : N ;
  lyftbro_nn_1 : N ;
  lyftkraft_nn_1 : N ;
  lyftkran_nn_1 : N ;
  lyftkrok_nn_1 : N ;
  lyftsax_nn_1 : N ;
  lyftverk_nn_1 : N ;
  lyhoerd_av_1 : A ;
  lyktbaerare_nn_1 : N ;
  lyktgubbe_nn_1 : N ;
  lyktrad_nn_1 : N ;
  lyktstolpe_nn_1 : N ;
  lymfatisk_av_1 : A ;
  lymfkaerl_nn_1 : N ;
  lymfkoertel_nn_1 : N ;
  lymfliknande_av_1 : A ;
  lymfocyt_nn_1 : N ;
  lymmel_nn_1 : N ;
  lymmelaktig_av_1 : A ;
  lynett_nn_1 : N ;
  lynne_nn_1 : N ;
  lynnesutbrott_nn_1 : N ;
  lynnig_av_1 : A ;
  lyrfaagel_nn_1 : N ;
  lyrikaelskare_nn_1 : N ;
  lyriker_nn_1 : N ;
  lyrisk_av_1 : A ;
  lyrtorsk_nn_1 : N ;
  lysaemne_nn_1 : N ;
  lysande_av_1 : A ;
  lysboj_nn_1 : N ;
  lysgas_nn_1 : N ;
  lysin_nn_1 : N ;
  lysmask_nn_1 : N ;
  lysning_nn_1 : N ;
  lysosom_nn_1 : N ;
  lysozym_nn_1 : N ;
  lyspatron_nn_1 : N ;
  lyspistol_nn_1 : N ;
  lysraket_nn_1 : N ;
  lysroer_nn_1 : N ;
  lyssats_nn_1 : N ;
  lyssnarapparat_nn_1 : N ;
  lyssnare_nn_1 : N ;
  lysten_av_1 : A ;
  lyster_nn_1 : N ;
  lysterfaerg_nn_1 : N ;
  lystergarn_nn_1 : N ;
  lystmaete_nn_1 : N ;
  lystnad_nn_1 : N ;
  lyte_nn_1 : N ;
  lytt_av_1 : A ;
  lytt_av_2 : A ;
  lyxartikel_nn_1 : N ;
  lyxbil_nn_1 : N ;
  lyxfoerpackning_nn_1 : N ;
  lyxhotell_nn_1 : N ;
  lyxhustru_nn_1 : N ;
  lyxig_av_1 : A ;
  lyxkryssare_nn_1 : N ;
  lyxliv_nn_1 : N ;
  lyxskatt_nn_1 : N ;
  lyxtelegram_nn_1 : N ;
  maabaer_nn_1 : N ;
  maabaersbuske_nn_1 : N ;
  maag_nn_1 : N ;
  maahaenda_ab_1 : Adv ;
  maakare_nn_1 : N ;
  maal_nn_1 : N ;
  maalande_av_1 : A ;
  maalangivning_nn_1 : N ;
  maalarbok_nn_1 : N ;
  maalarborste_nn_1 : N ;
  maalarduk_nn_1 : N ;
  maalare_nn_1 : N ;
  maalarfaerg_nn_1 : N ;
  maalarkludd_nn_1 : N ;
  maalarmaestare_nn_1 : N ;
  maalarrock_nn_1 : N ;
  maalarstaellning_nn_1 : N ;
  maalbrottsroest_nn_1 : N ;
  maalbur_nn_1 : N ;
  maalchans_nn_1 : N ;
  maaldomare_nn_1 : N ;
  maaleri_nn_1 : N ;
  maalerisk_av_1 : A ;
  maalfarlig_av_1 : A ;
  maalfigur_nn_1 : N ;
  maalforskning_nn_1 : N ;
  maalfoto_nn_1 : N ;
  maalgaard_nn_1 : N ;
  maalgivande_av_1 : A ;
  maalgrupp_nn_1 : N ;
  maalkamera_nn_1 : N ;
  maalkvot_nn_1 : N ;
  maallinje_nn_1 : N ;
  maalloes_av_1 : A ;
  maalmedveten_av_1 : A ;
  maalning_nn_1 : N ;
  maalomraade_nn_1 : N ;
  maalsaegande_nn_1 : N ;
  maalsaegare_nn_1 : N ;
  maalsaettning_nn_1 : N ;
  maalskillnad_nn_1 : N ;
  maalskytt_nn_1 : N ;
  maalsman_nn_1 : N ;
  maalsoekande_av_1 : A ;
  maalsoekare_nn_1 : N ;
  maalspaning_nn_1 : N ;
  maalspottare_nn_1 : N ;
  maalspraak_nn_1 : N ;
  maalstaellning_nn_1 : N ;
  maalstolpe_nn_1 : N ;
  maalstyrning_nn_1 : N ;
  maaltavla_nn_1 : N ;
  maaltid_nn_1 : N ;
  maaltidsdryck_nn_1 : N ;
  maalvakt_nn_1 : N ;
  maan_av_1 : A ;
  maanaar_nn_1 : N ;
  maanad_nn_1 : N ;
  maanadskort_nn_1 : N ;
  maanadsloen_nn_1 : N ;
  maanadsrasande_av_1 : A ;
  maanadsskifte_nn_1 : N ;
  maanadssmultron_nn_1 : N ;
  maanadsvis_ab_1 : Adv ;
  maanadtal_nn_1 : N ;
  maanatlig_av_1 : A ;
  maanatligen_ab_1 : Adv ;
  maanbaevning_nn_1 : N ;
  maanbelyst_av_1 : A ;
  maancykel_nn_1 : N ;
  maandag_nn_1 : N ;
  maandagsexemplar_nn_1 : N ;
  maandagskvaell_nn_1 : N ;
  maandagsmorgon_nn_1 : N ;
  maandistans_nn_1 : N ;
  maandygn_nn_1 : N ;
  maane_nn_1 : N ;
  maanfas_nn_1 : N ;
  maanflod_nn_1 : N ;
  maanfoermoerkelse_nn_1 : N ;
  maangaard_nn_1 : N ;
  maangaarig_av_1 : A ;
  maangahanda_av_1 : A ;
  maangbesjungen_av_1 : A ;
  maangbyggare_nn_1 : N ;
  maangdubbel_av_1 : A ;
  maangenstaedes_ab_1 : Adv ;
  maangfald_nn_1 : N ;
  maangfaldig_av_1 : A ;
  maangfalt_ab_1 : Adv ;
  maangformig_av_1 : A ;
  maangformighet_nn_1 : N ;
  maangfoting_nn_1 : N ;
  maangfrestande_av_1 : A ;
  maangfrestare_nn_1 : N ;
  maanghoerning_nn_1 : N ;
  maangkamp_nn_1 : N ;
  maangkunnig_av_1 : A ;
  maanglare_nn_1 : N ;
  maangmiljonaer_nn_1 : N ;
  maangordig_av_1 : A ;
  maangsidig_av_1 : A ;
  maangsidighet_nn_1 : N ;
  maangsiding_nn_1 : N ;
  maangskiftande_av_1 : A ;
  maangstaemmig_av_1 : A ;
  maangstavig_av_1 : A ;
  maangsysslare_nn_1 : N ;
  maangtydig_av_1 : A ;
  maangtydighet_nn_1 : N ;
  maangubbe_nn_1 : N ;
  maangvetenskaplig_av_1 : A ;
  maanlandskap_nn_1 : N ;
  maanliknande_av_1 : A ;
  maanljus_av_1 : A ;
  maanne_ab_1 : Adv ;
  maanntro_ab_1 : Adv ;
  maanskifte_nn_1 : N ;
  maansten_nn_1 : N ;
  maanvarv_nn_1 : N ;
  maanviol_nn_1 : N ;
  maard_nn_1 : N ;
  maarddjur_nn_1 : N ;
  maas_nn_1 : N ;
  maasfaagel_nn_1 : N ;
  maatro_ab_1 : Adv ;
  maatt_nn_1 : N ;
  maattagning_nn_1 : N ;
  maattband_nn_1 : N ;
  maattbestaelld_av_1 : A ;
  maattenhet_nn_1 : N ;
  maattfull_av_1 : A ;
  maattlig_av_1 : A ;
  maattlighet_nn_1 : N ;
  maattloes_av_1 : A ;
  maattsats_nn_1 : N ;
  maattsenhet_nn_1 : N ;
  maattstock_nn_1 : N ;
  maattsydd_av_1 : A ;
  maattsystem_nn_1 : N ;
  maattverktyg_nn_1 : N ;
  macedonisk_av_1 : A ;
  macedonsk_av_1 : A ;
  macedonska_nn_2 : N ;
  mach_nn_1 : N ;
  machete_nn_1 : N ;
  machiavellisk_av_1 : A ;
  machiavellistisk_av_1 : A ;
  machtal_nn_1 : N ;
  machverk_nn_1 : N ;
  mack_nn_1 : N ;
  mackapaer_nn_1 : N ;
  mad_nn_1 : N ;
  madagask_nn_1 : N ;
  madagaskisk_av_1 : A ;
  madam_nn_1 : N ;
  madapolam_nn_1 : N ;
  madrass_nn_1 : N ;
  madrassnaal_nn_1 : N ;
  madrigal_nn_1 : N ;
  maduska_nn_1 : N ;
  maehae_nn_1 : N ;
  maeklararvode_nn_1 : N ;
  maeklare_nn_1 : N ;
  maekta_ab_1 : Adv ;
  maektig_av_1 : A ;
  maektighet_nn_1 : N ;
  maektighet_nn_2 : N ;
  maelarlandskap_nn_1 : N ;
  maeld_nn_1 : N ;
  maelteri_nn_1 : N ;
  maengd_nn_1 : N ;
  maengddiagram_nn_1 : N ;
  maengdvis_ab_1 : Adv ;
  maenniska_nn_1 : N ;
  maenniskoaetande_av_1 : A ;
  maenniskoaetare_nn_1 : N ;
  maenniskobroest_nn_1 : N ;
  maenniskofientlig_av_1 : A ;
  maenniskofigur_nn_1 : N ;
  maenniskofoster_nn_1 : N ;
  maenniskogestalt_nn_1 : N ;
  maenniskohaj_nn_1 : N ;
  maenniskohamn_nn_1 : N ;
  maenniskohand_nn_1 : N ;
  maenniskohatare_nn_1 : N ;
  maenniskojakt_nn_1 : N ;
  maenniskokaennare_nn_1 : N ;
  maenniskokaennedom_nn_1 : N ;
  maenniskokaerlek_nn_1 : N ;
  maenniskokropp_nn_1 : N ;
  maenniskolik_av_1 : A ;
  maenniskolik_nn_1 : N ;
  maenniskoliknande_av_1 : A ;
  maenniskoliv_nn_1 : N ;
  maenniskooffer_nn_1 : N ;
  maenniskorov_nn_1 : N ;
  maenniskoskildring_nn_1 : N ;
  maenniskospermie_nn_1 : N ;
  maenniskouppfattning_nn_1 : N ;
  maenniskovaen_nn_1 : N ;
  maenniskovaenlig_av_1 : A ;
  maenniskovaenlighet_nn_1 : N ;
  maenniskovaerde_nn_1 : N ;
  maenniskovaerdig_av_1 : A ;
  maenska_nn_1 : N ;
  maensklig_av_1 : A ;
  maensklighet_nn_1 : N ;
  maer_nn_1 : N ;
  maergben_nn_1 : N ;
  maergelgrav_nn_1 : N ;
  maergelskiffer_nn_1 : N ;
  maergflaeck_nn_1 : N ;
  maergfull_av_1 : A ;
  maergloes_av_1 : A ;
  maergstraale_nn_1 : N ;
  maerkband_nn_1 : N ;
  maerkbar_av_1 : A ;
  maerkduk_nn_1 : N ;
  maerke_nn_1 : N ;
  maerkesdag_nn_1 : N ;
  maerkesman_nn_1 : N ;
  maerkgarn_nn_1 : N ;
  maerkhammare_nn_1 : N ;
  maerklig_av_1 : A ;
  maerklighet_nn_1 : N ;
  maerkning_nn_1 : N ;
  maerkvaerdig_av_1 : A ;
  maerling_nn_1 : N ;
  maerlspik_nn_1 : N ;
  maerr_nn_1 : N ;
  maers_nn_1 : N ;
  maersraa_nn_1 : N ;
  maerssegel_nn_1 : N ;
  maersstaang_nn_1 : N ;
  maeskning_nn_1 : N ;
  maeskprovare_nn_1 : N ;
  maess_nn_1 : N ;
  maessbok_nn_1 : N ;
  maessdraekt_nn_1 : N ;
  maessfall_nn_1 : N ;
  maesshake_nn_1 : N ;
  maesshall_nn_1 : N ;
  maessingblaasinstrument_nn_1 : N ;
  maessinginstrument_nn_1 : N ;
  maessingsinstrument_nn_1 : N ;
  maessingsspik_nn_1 : N ;
  maessingstraad_nn_1 : N ;
  maessoffer_nn_1 : N ;
  maesspojke_nn_1 : N ;
  maestarbrev_nn_1 : N ;
  maestare_nn_1 : N ;
  maestarinna_nn_1 : N ;
  maestarklass_nn_1 : N ;
  maestarprov_nn_1 : N ;
  maesterlig_av_1 : A ;
  maesterlots_nn_1 : N ;
  maesterman_nn_1 : N ;
  maestersaangare_nn_1 : N ;
  maesterskap_nn_1 : N ;
  maesterskapstitel_nn_1 : N ;
  maesterverk_nn_1 : N ;
  maetapparat_nn_1 : N ;
  maetapparatur_nn_1 : N ;
  maetare_nn_1 : N ;
  maetarfjaeril_nn_1 : N ;
  maetarlarv_nn_1 : N ;
  maetbar_av_1 : A ;
  maetbord_nn_1 : N ;
  maetbrev_nn_1 : N ;
  maetetal_nn_1 : N ;
  maetglas_nn_1 : N ;
  maetinstrument_nn_1 : N ;
  maetning_nn_1 : N ;
  maetningsfartyg_nn_1 : N ;
  maetningsregel_nn_1 : N ;
  maetningstal_nn_1 : N ;
  maetomraade_nn_1 : N ;
  maetredskap_nn_1 : N ;
  maetress_nn_1 : N ;
  maett_av_1 : A ;
  maettnad_nn_1 : N ;
  maettningstryck_nn_1 : N ;
  maettsam_av_1 : A ;
  maetvaerde_nn_1 : N ;
  maetverktyg_nn_1 : N ;
  maffia_nn_1 : N ;
  maffig_av_1 : A ;
  magasin_nn_1 : N ;
  magbesvaer_nn_1 : N ;
  magborstare_nn_1 : N ;
  magdans_nn_1 : N ;
  mage_nn_1 : N ;
  mager_av_1 : A ;
  mager_nn_1 : N ;
  magerlagd_av_1 : A ;
  maggoerdel_nn_1 : N ;
  maggrop_nn_1 : N ;
  magiker_nn_1 : N ;
  maginnehaall_nn_1 : N ;
  magisk_av_1 : A ;
  magister_nn_1 : N ;
  magistral_av_1 : A ;
  magistrat_nn_1 : N ;
  magkatarr_nn_1 : N ;
  magmabergart_nn_1 : N ;
  magmakammare_nn_1 : N ;
  magmedicin_nn_1 : N ;
  magmun_nn_1 : N ;
  magnat_nn_1 : N ;
  magnecyl_nn_1 : N ;
  magnesiumlegering_nn_1 : N ;
  magnesiumsulfat_nn_1 : N ;
  magnet_nn_1 : N ;
  magnetapparat_nn_1 : N ;
  magnetband_nn_1 : N ;
  magnetfaelt_nn_1 : N ;
  magnetisk_av_1 : A ;
  magnetisoer_nn_1 : N ;
  magnetkompass_nn_1 : N ;
  magnetnaal_nn_1 : N ;
  magnetofon_nn_1 : N ;
  magnetpol_nn_1 : N ;
  magnetron_nn_1 : N ;
  magnettaendning_nn_1 : N ;
  magnificus_av_1 : A ;
  magnifik_av_1 : A ;
  magnitud_nn_1 : N ;
  magnum_av_1 : A ;
  magnumbutelj_nn_1 : N ;
  magplask_nn_1 : N ;
  magsaar_nn_1 : N ;
  magsaeck_nn_1 : N ;
  magsaft_nn_1 : N ;
  magstark_av_1 : A ;
  magsur_av_1 : A ;
  magyar_nn_1 : N ;
  maharadja_nn_1 : N ;
  mahognyliknande_av_1 : A ;
  mail_nn_2 : N ;
  majbagge_nn_1 : N ;
  majbrud_nn_1 : N ;
  majestaet_nn_1 : N ;
  majestaetisk_av_1 : A ;
  majestaetsbrott_nn_1 : N ;
  majestaetsfoerbrytelse_nn_1 : N ;
  majonnaes_nn_1 : N ;
  majonnaessaas_nn_1 : N ;
  major_nn_1 : N ;
  majoritet_nn_1 : N ;
  majoritetsval_nn_1 : N ;
  majsgroet_nn_1 : N ;
  majskolv_nn_1 : N ;
  majskorn_nn_1 : N ;
  majstaang_nn_1 : N ;
  majuskel_nn_1 : N ;
  makaber_av_1 : A ;
  makaloes_av_1 : A ;
  makassarolja_nn_1 : N ;
  make_nn_1 : N ;
  makedonier_nn_1 : N ;
  makedonisk_av_1 : A ;
  makedonsk_av_1 : A ;
  makedonska_nn_2 : N ;
  maklig_av_1 : A ;
  makrill_nn_1 : N ;
  makron_nn_1 : N ;
  makroskopisk_av_1 : A ;
  makt_nn_1 : N ;
  maktanspraak_nn_1 : N ;
  maktbalans_nn_1 : N ;
  maktbefogenhet_nn_1 : N ;
  maktblock_nn_1 : N ;
  maktcentrum_nn_1 : N ;
  maktfaktor_nn_1 : N ;
  maktfoerdelning_nn_1 : N ;
  maktfullkomlig_av_1 : A ;
  makthavare_nn_1 : N ;
  maktkamp_nn_1 : N ;
  maktkoncentration_nn_1 : N ;
  maktloes_av_1 : A ;
  maktlysten_av_1 : A ;
  maktmedel_nn_1 : N ;
  maktoevertagande_nn_1 : N ;
  maktpaaliggande_av_1 : A ;
  maktskifte_nn_1 : N ;
  maktspel_nn_1 : N ;
  maktsymbol_nn_1 : N ;
  maktutoevare_nn_1 : N ;
  mal_nn_1 : N ;
  malaeten_av_1 : A ;
  malaj_nn_1 : N ;
  malajisk_av_1 : A ;
  malajiska_nn_2 : N ;
  malakit_nn_1 : N ;
  malapropaa_ab_1 : Adv ;
  malawier_nn_1 : N ;
  malawisk_av_1 : A ;
  malaysier_nn_1 : N ;
  malaysisk_av_1 : A ;
  maldiver_nn_1 : N ;
  maldivisk_av_1 : A ;
  malicioes_av_1 : A ;
  malier_nn_1 : N ;
  malign_av_1 : A ;
  malisk_av_1 : A ;
  mall_nn_1 : N ;
  mallig_av_1 : A ;
  malm_nn_1 : N ;
  malm_nn_2 : N ;
  malmedel_nn_1 : N ;
  malmfaelt_nn_1 : N ;
  malmfoerande_av_1 : A ;
  malmfyndig_av_1 : A ;
  malmfyndighet_nn_1 : N ;
  malmhalt_nn_1 : N ;
  malmkoertel_nn_1 : N ;
  malmkropp_nn_1 : N ;
  malmkross_nn_1 : N ;
  malmoebo_nn_1 : N ;
  malmtaekt_nn_1 : N ;
  maloer_nn_1 : N ;
  malpaase_nn_1 : N ;
  malstroem_nn_1 : N ;
  maltdryck_nn_1 : N ;
  maltes_nn_1 : N ;
  maltesare_nn_1 : N ;
  malteserhund_nn_1 : N ;
  malteserkors_nn_1 : N ;
  malteserorden_nn_1 : N ;
  maltesisk_av_1 : A ;
  maltesiska_nn_2 : N ;
  mambo_nn_1 : N ;
  mamma_nn_1 : N ;
  mammaklaenning_nn_1 : N ;
  mammaledig_av_1 : A ;
  mammig_av_1 : A ;
  mammografi_nn_1 : N ;
  mammonstrael_nn_1 : N ;
  mammut_nn_1 : N ;
  mammuttraed_nn_1 : N ;
  mamsell_nn_1 : N ;
  man_nn_1 : N ;
  man_nn_2 : N ;
  manaar_nn_1 : N ;
  manager_nn_1 : N ;
  manbar_av_1 : A ;
  manbyggnad_nn_1 : N ;
  manchu_nn_1 : N ;
  manchuisk_av_1 : A ;
  manchuiska_nn_2 : N ;
  mandarin_nn_1 : N ;
  mandat_nn_1 : N ;
  mandatfoerdelning_nn_1 : N ;
  mandatperiod_nn_1 : N ;
  mandel_nn_1 : N ;
  mandeloegd_av_1 : A ;
  mandelolja_nn_1 : N ;
  mandelpotatis_nn_1 : N ;
  mandibel_nn_1 : N ;
  mandolin_nn_1 : N ;
  mandom_nn_1 : N ;
  mandomsprov_nn_1 : N ;
  mandrill_nn_1 : N ;
  manege_nn_1 : N ;
  maner_nn_1 : N ;
  maner_nn_2 : N ;
  manet_nn_1 : N ;
  manfall_nn_1 : N ;
  manfolk_nn_1 : N ;
  mangaardsbyggnad_nn_1 : N ;
  manganin_nn_1 : N ;
  mangel_nn_1 : N ;
  mango_nn_1 : N ;
  mangrann_av_1 : A ;
  mangrove_nn_1 : N ;
  mangrovetraesk_nn_1 : N ;
  manhaal_nn_1 : N ;
  manhaftig_av_1 : A ;
  mani_nn_1 : N ;
  maniakalisk_av_1 : A ;
  manick_nn_1 : N ;
  manierism_nn_1 : N ;
  manifest_av_1 : A ;
  manifest_nn_1 : N ;
  manifestation_nn_1 : N ;
  manike_nn_1 : N ;
  maniker_nn_1 : N ;
  manikur_nn_1 : N ;
  manikyrist_nn_1 : N ;
  maning_nn_1 : N ;
  manipulation_nn_1 : N ;
  manisk_av_1 : A ;
  manisk_depressiv_av_1 : A ;
  manke_nn_1 : N ;
  mankemang_nn_1 : N ;
  mankill_nn_1 : N ;
  manko_nn_1 : N ;
  mankoen_nn_1 : N ;
  manlig_av_1 : A ;
  mannaaalder_nn_1 : N ;
  mannagryn_nn_1 : N ;
  mannagrynsgroet_nn_1 : N ;
  mannalav_nn_1 : N ;
  mannekaeng_nn_1 : N ;
  manodepressiv_av_1 : A ;
  manoever_nn_1 : N ;
  manoeverduglig_av_1 : A ;
  manoeverkraft_nn_1 : N ;
  manometer_nn_1 : N ;
  mansaalder_nn_1 : N ;
  mansard_nn_1 : N ;
  mansardtak_nn_1 : N ;
  manschett_nn_1 : N ;
  manschettyrke_nn_1 : N ;
  mansgrav_nn_1 : N ;
  mansgris_nn_1 : N ;
  manskap_nn_1 : N ;
  manslaeger_nn_1 : N ;
  manslem_nn_1 : N ;
  manslukerska_nn_1 : N ;
  mansperson_nn_1 : N ;
  manssida_nn_1 : N ;
  manstark_av_1 : A ;
  mantaag_nn_1 : N ;
  mantal_nn_1 : N ;
  mantalslaengd_nn_1 : N ;
  mantalsskriven_av_1 : A ;
  mantalsskrivning_nn_1 : N ;
  mantel_nn_1 : N ;
  manteldjur_nn_1 : N ;
  mantelstyrning_nn_1 : N ;
  mantilj_nn_1 : N ;
  manual_nn_1 : N ;
  manuell_av_1 : A ;
  manufaktur_nn_1 : N ;
  manus_nn_1 : N ;
  manuskript_nn_1 : N ;
  maori_nn_1 : N ;
  maorisk_av_1 : A ;
  mapp_nn_1 : N ;
  marabu_nn_1 : N ;
  maraeng_nn_1 : N ;
  maraengsviss_nn_1 : N ;
  maraton_nn_1 : N ;
  maratonlopp_nn_1 : N ;
  mardroem_nn_1 : N ;
  marg_nn_1 : N ;
  margarin_nn_1 : N ;
  margfaldig_av_1 : A ;
  marginal_nn_1 : N ;
  marginalbeskattning_nn_1 : N ;
  marginaleffekt_nn_1 : N ;
  marginalinkomst_nn_1 : N ;
  marginalintaekt_nn_1 : N ;
  marginalkostnad_nn_1 : N ;
  marginalskatt_nn_1 : N ;
  marginalvaeljare_nn_1 : N ;
  marginell_av_1 : A ;
  marig_av_1 : A ;
  marin_av_1 : A ;
  marin_nn_1 : N ;
  marinad_nn_1 : N ;
  marinbiolog_nn_1 : N ;
  marinbiologisk_av_1 : A ;
  marinblaa_av_1 : A ;
  marindirektoer_nn_1 : N ;
  marinkaar_nn_1 : N ;
  marinledning_nn_1 : N ;
  marinsoldat_nn_1 : N ;
  marionett_nn_1 : N ;
  maritim_av_1 : A ;
  mark_nn_1 : N ;
  mark_nn_2 : N ;
  markaegare_nn_1 : N ;
  markant_av_1 : A ;
  markeffektfarkost_nn_1 : N ;
  markegaang_nn_1 : N ;
  markering_nn_1 : N ;
  marketentare_nn_1 : N ;
  marketenteri_nn_1 : N ;
  marketeri_nn_1 : N ;
  markgreve_nn_1 : N ;
  markis_nn_1 : N ;
  marklaera_nn_1 : N ;
  marklevande_av_1 : A ;
  marknad_nn_1 : N ;
  marknadsekonomi_nn_1 : N ;
  marknadsekonomisk_av_1 : A ;
  marknadsfoering_nn_1 : N ;
  marknadsgycklare_nn_1 : N ;
  marknadslaege_nn_1 : N ;
  marknadspris_nn_1 : N ;
  marknadsundersoekning_nn_1 : N ;
  marknadsvaerde_nn_1 : N ;
  marknivaa_nn_1 : N ;
  markoer_nn_1 : N ;
  markomanner_nn_1 : N ;
  markomraade_nn_1 : N ;
  markorganism_nn_1 : N ;
  marktaeckare_nn_1 : N ;
  marktjaenst_nn_1 : N ;
  marmelad_nn_1 : N ;
  marmorering_nn_1 : N ;
  marmorliknande_av_1 : A ;
  marockan_nn_1 : N ;
  marockansk_av_1 : A ;
  marockanska_nn_1 : N ;
  marodoer_nn_1 : N ;
  marsch_nn_1 : N ;
  marschall_nn_1 : N ;
  marschfart_nn_1 : N ;
  marschlaege_nn_1 : N ;
  marshmallow_nn_1 : N ;
  marsian_nn_1 : N ;
  marsk_nn_1 : N ;
  marskalk_nn_1 : N ;
  marskalkstav_nn_1 : N ;
  marsvin_nn_1 : N ;
  martall_nn_1 : N ;
  martasbekymmer_nn_1 : N ;
  martialisk_av_1 : A ;
  martini_nn_1 : N ;
  martyr_nn_1 : N ;
  martyrium_nn_1 : N ;
  marulk_nn_1 : N ;
  marviol_nn_1 : N ;
  marxist_nn_1 : N ;
  marxistisk_av_1 : A ;
  mas_nn_1 : N ;
  maser_nn_1 : N ;
  masig_av_1 : A ;
  mask_nn_1 : N ;
  mask_nn_2 : N ;
  maskaeten_av_1 : A ;
  maskerad_nn_1 : N ;
  maskeraddraekt_nn_1 : N ;
  maskering_nn_1 : N ;
  maskformig_av_1 : A ;
  maskhaal_nn_1 : N ;
  maskin_nn_1 : N ;
  maskindel_nn_1 : N ;
  maskinelement_nn_1 : N ;
  maskinell_av_1 : A ;
  maskineri_nn_1 : N ;
  maskingevaer_nn_1 : N ;
  maskinhall_nn_1 : N ;
  maskinhaveri_nn_1 : N ;
  maskinist_nn_1 : N ;
  maskinlaesbar_av_1 : A ;
  maskinmaessig_av_1 : A ;
  maskinoeversaettning_nn_1 : N ;
  maskinpark_nn_1 : N ;
  maskinpistol_nn_1 : N ;
  maskinpress_nn_1 : N ;
  maskinrum_nn_1 : N ;
  maskinskriven_av_1 : A ;
  maskinskrivning_nn_1 : N ;
  maskinspraak_nn_1 : N ;
  maskintid_nn_1 : N ;
  maskintvaett_nn_1 : N ;
  maskning_nn_1 : N ;
  maskoer_nn_1 : N ;
  maskopi_nn_1 : N ;
  maskot_nn_1 : N ;
  maskspel_nn_1 : N ;
  maskstungen_av_1 : A ;
  masktaethet_nn_1 : N ;
  maskulin_av_1 : A ;
  maskulinum_nn_1 : N ;
  masochist_nn_1 : N ;
  massa_nn_2 : N ;
  massageinstitut_nn_1 : N ;
  massaker_nn_1 : N ;
  massbjaesse_nn_1 : N ;
  masscentrum_nn_1 : N ;
  massdoed_nn_1 : N ;
  massfaangst_nn_1 : N ;
  massiv_av_1 : A ;
  massiv_nn_1 : N ;
  massivitet_nn_1 : N ;
  massjaette_nn_1 : N ;
  masskommunikation_nn_1 : N ;
  masskonst_nn_1 : N ;
  masskorsband_nn_1 : N ;
  massloes_av_1 : A ;
  massmedial_av_1 : A ;
  massmedium_nn_1 : N ;
  massmoete_nn_1 : N ;
  massmord_nn_1 : N ;
  massoer_nn_1 : N ;
  masspektrum_nn_1 : N ;
  masspsykos_nn_1 : N ;
  masstal_nn_1 : N ;
  massvis_ab_1 : Adv ;
  mast_nn_1 : N ;
  master_nn_1 : N ;
  mastfisk_nn_1 : N ;
  mastfritt_ab_1 : Adv ;
  masthaal_nn_1 : N ;
  mastig_av_1 : A ;
  mastkorg_nn_1 : N ;
  mastkrage_nn_1 : N ;
  mastodont_nn_1 : N ;
  mastodontisk_av_1 : A ;
  masturbation_nn_1 : N ;
  masugn_nn_1 : N ;
  masurbjoerk_nn_1 : N ;
  masverk_nn_1 : N ;
  matador_nn_1 : N ;
  matarbuss_nn_1 : N ;
  matare_nn_1 : N ;
  matarledning_nn_1 : N ;
  matbestick_nn_1 : N ;
  matbit_nn_1 : N ;
  matbord_nn_1 : N ;
  matbroed_nn_1 : N ;
  match_nn_1 : N ;
  matchboll_nn_1 : N ;
  matematiker_nn_1 : N ;
  matematiklaerare_nn_1 : N ;
  matematisk_av_1 : A ;
  matematisk_naturvetenskaplig_av_1 : A ;
  materia_nn_1 : N ;
  material_nn_1 : N ;
  materialisation_nn_1 : N ;
  materialist_nn_1 : N ;
  materialistisk_av_1 : A ;
  materialkonstant_nn_1 : N ;
  materialproblem_nn_1 : N ;
  materialsamling_nn_1 : N ;
  materialspelare_nn_1 : N ;
  materie_nn_1 : N ;
  materieforskning_nn_1 : N ;
  materiegas_nn_1 : N ;
  materiell_av_1 : A ;
  materiemoln_nn_1 : N ;
  materiestroem_nn_1 : N ;
  materietransport_nn_1 : N ;
  materieutbyte_nn_1 : N ;
  matfett_nn_1 : N ;
  matfoergiftning_nn_1 : N ;
  matfoerraad_nn_1 : N ;
  matfrisk_av_1 : A ;
  matfrukt_nn_1 : N ;
  mathaallning_nn_1 : N ;
  matine_nn_1 : N ;
  matjessill_nn_1 : N ;
  matjord_nn_1 : N ;
  matlag_nn_1 : N ;
  matlagning_nn_1 : N ;
  matlagningskonst_nn_1 : N ;
  matmamma_nn_1 : N ;
  matning_nn_1 : N ;
  matnyttig_av_1 : A ;
  matolja_nn_1 : N ;
  matpotatis_nn_1 : N ;
  matraett_nn_1 : N ;
  matrest_nn_1 : N ;
  matriarkalisk_av_1 : A ;
  matrikel_nn_1 : N ;
  matris_nn_1 : N ;
  matros_nn_1 : N ;
  matroskostym_nn_1 : N ;
  matsaeck_nn_1 : N ;
  matsal_nn_1 : N ;
  matsalong_nn_1 : N ;
  matsedel_nn_1 : N ;
  matservering_nn_1 : N ;
  matservis_nn_1 : N ;
  matsked_nn_1 : N ;
  matsmaeltning_nn_1 : N ;
  matsmaeltningskanal_nn_1 : N ;
  matsmaeltningsorgan_nn_1 : N ;
  matsmaeltningsvaetska_nn_1 : N ;
  matstrupe_nn_1 : N ;
  matsvamp_nn_1 : N ;
  matt_av_1 : A ;
  mattallrik_nn_1 : N ;
  mattdomare_nn_1 : N ;
  matte_nn_2 : N ;
  matthet_nn_1 : N ;
  mattighet_nn_1 : N ;
  mattpiskare_nn_1 : N ;
  mattpiskning_nn_1 : N ;
  mattsopare_nn_1 : N ;
  matutin_nn_1 : N ;
  matvana_nn_1 : N ;
  matvara_nn_1 : N ;
  matvaruaffaer_nn_1 : N ;
  matvaruhall_nn_1 : N ;
  matvraa_nn_1 : N ;
  matvrak_nn_1 : N ;
  mauretanier_nn_1 : N ;
  mauretansk_av_1 : A ;
  mauritier_nn_1 : N ;
  mauritisk_av_1 : A ;
  mauser_nn_1 : N ;
  mausergevaer_nn_1 : N ;
  mauserpistol_nn_1 : N ;
  mausoleum_nn_1 : N ;
  maxikjol_nn_1 : N ;
  maxill_nn_1 : N ;
  maxim_nn_1 : N ;
  maximal_av_1 : A ;
  maximipunkt_nn_1 : N ;
  maximitemperatur_nn_1 : N ;
  maximitermometer_nn_1 : N ;
  maximum_nn_1 : N ;
  mayafolk_nn_1 : N ;
  mazarin_nn_1 : N ;
  meander_nn_1 : N ;
  meccano_nn_1 : N ;
  mecenat_nn_1 : N ;
  med_ab_1 : Adv ;
  med_nn_1 : N ;
  medalj_nn_1 : N ;
  medaljoer_nn_1 : N ;
  medaljong_nn_1 : N ;
  medansvarig_av_1 : A ;
  medarbetare_nn_1 : N ;
  medbedoemare_nn_1 : N ;
  medbestaemmandelag_nn_1 : N ;
  medborgare_nn_1 : N ;
  medborgargarde_nn_1 : N ;
  medborgarhus_nn_1 : N ;
  medborgarskap_nn_1 : N ;
  medborgarvittne_nn_1 : N ;
  medborgenaer_nn_1 : N ;
  medborgerlig_av_1 : A ;
  medbringare_nn_1 : N ;
  medbroder_nn_1 : N ;
  medbrottslig_av_1 : A ;
  medbrottsling_nn_1 : N ;
  meddelaktig_av_1 : A ;
  meddelande_nn_1 : N ;
  meddelare_nn_1 : N ;
  meddelelsemedel_nn_1 : N ;
  meddelsam_av_1 : A ;
  meddetsamma_ab_1 : Adv ;
  mede_nn_1 : N ;
  medel_nn_1 : N ;
  medelaalder_nn_1 : N ;
  medelaalders_av_1 : A ;
  medelbar_av_1 : A ;
  medeldistans_nn_1 : N ;
  medeldistansraket_nn_1 : N ;
  medeldistansrobot_nn_1 : N ;
  medelfel_nn_1 : N ;
  medelindisk_av_1 : A ;
  medelklass_nn_1 : N ;
  medellaengd_nn_1 : N ;
  medellivslaengd_nn_1 : N ;
  medelloes_av_1 : A ;
  medelmaattig_av_1 : A ;
  medelpadare_nn_1 : N ;
  medelpadsk_av_1 : A ;
  medelproportional_nn_1 : N ;
  medelpunkt_nn_1 : N ;
  medelsanvisning_nn_1 : N ;
  medelsoltid_nn_1 : N ;
  medelsvensson_nn_1 : N ;
  medeltal_nn_1 : N ;
  medeltemperatur_nn_1 : N ;
  medeltid_nn_1 : N ;
  medeltida_av_1 : A ;
  medeltidsmaenniska_nn_1 : N ;
  medelvaeg_nn_1 : N ;
  medelvaerde_nn_1 : N ;
  medelvattenstaand_nn_1 : N ;
  medfaren_av_1 : A ;
  medfoedd_av_1 : A ;
  medgaang_nn_1 : N ;
  medge_vb_1 : V ;
  medgivande_nn_1 : N ;
  medgoerlig_av_1 : A ;
  medhaars_ab_1 : Adv ;
  medhavd_av_1 : A ;
  medhjaelpare_nn_1 : N ;
  medial_av_1 : A ;
  median_nn_1 : N ;
  medianvaeljare_nn_1 : N ;
  mediatek_nn_1 : N ;
  medicin_nn_1 : N ;
  medicinalstyrelse_nn_1 : N ;
  medicinalvaext_nn_1 : N ;
  medicinare_nn_1 : N ;
  medicinboll_nn_1 : N ;
  medicinglas_nn_1 : N ;
  medicinman_nn_1 : N ;
  medicinsk_av_1 : A ;
  medieval_nn_1 : N ;
  medikament_nn_1 : N ;
  medikus_nn_1 : N ;
  medioker_av_1 : A ;
  mediotek_nn_1 : N ;
  medisterkorv_nn_1 : N ;
  meditation_nn_1 : N ;
  meditativ_av_1 : A ;
  mediterran_av_1 : A ;
  medium_nn_1 : N ;
  medium_nn_2 : N ;
  medkaennande_av_1 : A ;
  medlare_nn_1 : N ;
  medlem_nn_1 : N ;
  medlemsantal_nn_1 : N ;
  medlemsavgift_nn_1 : N ;
  medlemskap_nn_1 : N ;
  medlemskort_nn_1 : N ;
  medlemsstat_nn_1 : N ;
  medlidsam_av_1 : A ;
  medling_nn_1 : N ;
  medlingsfoerslag_nn_1 : N ;
  medlingskommission_nn_1 : N ;
  medljud_nn_1 : N ;
  medloeftesman_nn_1 : N ;
  medloepare_nn_1 : N ;
  medlut_nn_1 : N ;
  medmaenniska_nn_1 : N ;
  medmaensklig_av_1 : A ;
  medryckande_av_1 : A ;
  medsamma_ab_1 : Adv ;
  medskyldig_av_1 : A ;
  medsoekande_nn_1 : N ;
  medsols_ab_1 : Adv ;
  medspelare_nn_1 : N ;
  medstroem_nn_1 : N ;
  medstroems_ab_1 : Adv ;
  medta_vb_1 : V ;
  medtaevlare_nn_1 : N ;
  medtagen_av_1 : A ;
  medurs_ab_1 : Adv ;
  medverkande_av_1 : A ;
  medveten_av_1 : A ;
  medvetenhet_nn_1 : N ;
  medvetsloes_av_1 : A ;
  medvind_nn_1 : N ;
  medvurst_nn_1 : N ;
  mefistofelisk_av_1 : A ;
  mefitisk_av_1 : A ;
  megabyte_nn_1 : N ;
  megafon_nn_1 : N ;
  megajoule_nn_1 : N ;
  megalit_nn_1 : N ;
  meganewton_nn_1 : N ;
  megaton_nn_1 : N ;
  megawatt_nn_1 : N ;
  mejeri_nn_1 : N ;
  mejerifoerening_nn_1 : N ;
  mejerist_nn_1 : N ;
  mejl_nn_2 : N ;
  mejsel_nn_1 : N ;
  mekaniker_nn_1 : N ;
  mekanikus_nn_1 : N ;
  mekanisering_nn_1 : N ;
  mekanisk_av_1 : A ;
  mekanism_nn_1 : N ;
  mekanistisk_av_1 : A ;
  melanesier_nn_1 : N ;
  melanesisk_av_1 : A ;
  melankoliker_nn_1 : N ;
  melankolisk_av_1 : A ;
  melioration_nn_1 : N ;
  mellanakt_nn_1 : N ;
  mellanbok_nn_1 : N ;
  mellandaeck_nn_1 : N ;
  mellandag_nn_1 : N ;
  mellanfolklig_av_1 : A ;
  mellanform_nn_1 : N ;
  mellangaerde_nn_1 : N ;
  mellanhand_nn_1 : N ;
  mellanhavande_nn_1 : N ;
  mellanheat_nn_1 : N ;
  mellanhopp_nn_1 : N ;
  mellankommande_av_1 : A ;
  mellankommunal_av_1 : A ;
  mellankrigstid_nn_1 : N ;
  mellankropp_nn_1 : N ;
  mellankultur_nn_1 : N ;
  mellanlaege_nn_1 : N ;
  mellanlandning_nn_1 : N ;
  mellanmaal_nn_1 : N ;
  mellanoel_nn_1 : N ;
  mellanoera_nn_1 : N ;
  mellanraett_nn_1 : N ;
  mellanrev_nn_1 : N ;
  mellanriksvaeg_nn_1 : N ;
  mellanrum_nn_1 : N ;
  mellanskikt_nn_1 : N ;
  mellanskillnad_nn_1 : N ;
  mellanslag_nn_1 : N ;
  mellanspel_nn_1 : N ;
  mellanspett_nn_1 : N ;
  mellanstadium_nn_1 : N ;
  mellanstatlig_av_1 : A ;
  mellanstick_nn_1 : N ;
  mellansubstans_nn_1 : N ;
  mellansvensk_av_1 : A ;
  mellantid_nn_1 : N ;
  mellanting_nn_1 : N ;
  mellanvaaning_nn_1 : N ;
  mellanvaegg_nn_1 : N ;
  mellanvaerd_nn_1 : N ;
  mellanverk_nn_1 : N ;
  melodi_nn_1 : N ;
  melodioes_av_1 : A ;
  melodisk_av_1 : A ;
  melodistaemma_nn_1 : N ;
  melodram_nn_1 : N ;
  melodramatisk_av_1 : A ;
  melon_nn_1 : N ;
  membran_nn_1 : N ;
  membrum_nn_1 : N ;
  memento_nn_1 : N ;
  memorandum_nn_1 : N ;
  memorial_nn_1 : N ;
  memorial_nn_2 : N ;
  men_nn_1 : N ;
  menageri_nn_1 : N ;
  menande_av_1 : A ;
  mendelistisk_av_1 : A ;
  mendelsk_av_1 : A ;
  mened_nn_1 : N ;
  menedare_nn_1 : N ;
  menig_av_1 : A ;
  menighet_nn_1 : N ;
  mening_nn_1 : N ;
  meningsbrytning_nn_1 : N ;
  meningsbyggnad_nn_1 : N ;
  meningsbyte_nn_1 : N ;
  meningsfraende_nn_1 : N ;
  meningsfull_av_1 : A ;
  meningsfylld_av_1 : A ;
  meningsloes_av_1 : A ;
  meningsloeshet_nn_1 : N ;
  meningsmotstaandare_nn_1 : N ;
  meningsriktning_nn_1 : N ;
  meningsskiljaktighet_nn_1 : N ;
  meningsutbyte_nn_1 : N ;
  meningsyttring_nn_1 : N ;
  menisk_nn_1 : N ;
  menlig_av_1 : A ;
  menloes_av_1 : A ;
  menopaus_nn_1 : N ;
  menstruation_nn_1 : N ;
  menstruationscykel_nn_1 : N ;
  mensur_nn_1 : N ;
  mental_av_1 : A ;
  mentalitet_nn_1 : N ;
  mentalsjuk_av_1 : A ;
  mentalsjukdom_nn_1 : N ;
  mentalsjukhus_nn_1 : N ;
  mentalvaard_nn_1 : N ;
  mentometer_nn_1 : N ;
  mentor_nn_1 : N ;
  menuett_nn_1 : N ;
  meny_nn_1 : N ;
  merbemaeld_av_1 : A ;
  merendels_ab_1 : Adv ;
  meridian_nn_1 : N ;
  meridiancirkel_nn_1 : N ;
  meridianhoejd_nn_1 : N ;
  merinofaar_nn_1 : N ;
  merit_nn_1 : N ;
  merkantil_av_1 : A ;
  merkantilist_nn_1 : N ;
  merkantilsystem_nn_1 : N ;
  merkaptan_nn_1 : N ;
  merkostnad_nn_1 : N ;
  mervaerde_nn_1 : N ;
  mervaerdesskatt_nn_1 : N ;
  mes_nn_1 : N ;
  mesaktig_av_1 : A ;
  mesallians_nn_1 : N ;
  mesan_nn_1 : N ;
  mesanmast_nn_1 : N ;
  mesfaagel_nn_1 : N ;
  mesig_av_1 : A ;
  meskalin_nn_1 : N ;
  meson_nn_1 : N ;
  mesopotam_nn_1 : N ;
  mesopotamisk_av_1 : A ;
  mesost_nn_1 : N ;
  mesozoisk_av_1 : A ;
  messiansk_av_1 : A ;
  messiasrike_nn_1 : N ;
  mestadels_ab_1 : Adv ;
  mestgynnadnation_nn_1 : N ;
  mestis_nn_1 : N ;
  metacenterhoejd_nn_1 : N ;
  metacentrum_nn_1 : N ;
  metafor_nn_1 : N ;
  metaforisk_av_1 : A ;
  metafysiker_nn_1 : N ;
  metafysisk_av_1 : A ;
  metakoek_nn_1 : N ;
  metall_nn_1 : N ;
  metallarbetare_nn_1 : N ;
  metallatom_nn_1 : N ;
  metallbad_nn_1 : N ;
  metallfoeremaal_nn_1 : N ;
  metallfoergiftning_nn_1 : N ;
  metallgjutning_nn_1 : N ;
  metallindustri_nn_1 : N ;
  metallisk_av_1 : A ;
  metallografisk_av_1 : A ;
  metalloid_nn_1 : N ;
  metalloxid_nn_1 : N ;
  metallpulver_nn_1 : N ;
  metallring_nn_1 : N ;
  metallsaag_nn_1 : N ;
  metallspaan_nn_1 : N ;
  metallspiral_nn_1 : N ;
  metallsvarv_nn_1 : N ;
  metalltraad_nn_1 : N ;
  metallurg_nn_1 : N ;
  metallurgisk_av_1 : A ;
  metallvaerde_nn_1 : N ;
  metamorf_av_1 : A ;
  metamorfos_nn_1 : N ;
  metan_nn_1 : N ;
  metare_nn_1 : N ;
  metaspraak_nn_1 : N ;
  metastas_nn_1 : N ;
  metastatisk_av_1 : A ;
  metatablett_nn_1 : N ;
  metates_nn_1 : N ;
  metazo_nn_1 : N ;
  mete_nn_1 : N ;
  meteor_nn_1 : N ;
  meteorit_nn_1 : N ;
  meteorjaern_nn_1 : N ;
  meteorkrater_nn_1 : N ;
  meteorolog_nn_1 : N ;
  meteorologisk_av_1 : A ;
  meteorsten_nn_1 : N ;
  meter_nn_1 : N ;
  meter_nn_2 : N ;
  meterlikare_nn_1 : N ;
  metermaatt_nn_1 : N ;
  meterprototyp_nn_1 : N ;
  meterstav_nn_1 : N ;
  metersystem_nn_1 : N ;
  metervis_ab_1 : Adv ;
  metkrok_nn_1 : N ;
  metod_nn_1 : N ;
  metodiker_nn_1 : N ;
  metodiklektor_nn_1 : N ;
  metodisk_av_1 : A ;
  metodist_nn_1 : N ;
  metodlaera_nn_1 : N ;
  metodologi_nn_1 : N ;
  metodologisk_av_1 : A ;
  metodsynpunkt_nn_1 : N ;
  metodvetenskap_nn_1 : N ;
  metonymi_nn_1 : N ;
  metrev_nn_1 : N ;
  metrisk_av_1 : A ;
  metrologisk_av_1 : A ;
  metronom_nn_1 : N ;
  metropol_nn_1 : N ;
  metropolit_nn_1 : N ;
  metspoe_nn_1 : N ;
  metvurst_nn_1 : N ;
  mexikan_nn_1 : N ;
  mexikansk_av_1 : A ;
  mexikanska_nn_1 : N ;
  mezzanin_nn_1 : N ;
  mezzoforte_ab_1 : Adv ;
  mezzoforte_nn_1 : N ;
  mezzosopran_nn_1 : N ;
  mick_nn_1 : N ;
  mickel_nn_1 : N ;
  micro_nn_1 : N ;
  microvaagsugn_nn_1 : N ;
  middag_nn_1 : N ;
  middagsaetare_nn_1 : N ;
  middagsgaest_nn_1 : N ;
  middagshoejd_nn_1 : N ;
  middagsklaenning_nn_1 : N ;
  middagslur_nn_1 : N ;
  middagsrast_nn_1 : N ;
  middagssaellskap_nn_1 : N ;
  middagstid_nn_1 : N ;
  middagstimma_nn_1 : N ;
  midfastosoendag_nn_1 : N ;
  midgetbil_nn_1 : N ;
  midja_nn_1 : N ;
  midjeband_nn_1 : N ;
  midjemaatt_nn_1 : N ;
  midnattsblaa_av_1 : A ;
  midnattssol_nn_1 : N ;
  midskepps_ab_1 : Adv ;
  midskeppssektion_nn_1 : N ;
  midsommar_nn_1 : N ;
  midsommarafton_nn_1 : N ;
  midsommarblomster_nn_1 : N ;
  midsommardag_nn_1 : N ;
  midsommarnatt_nn_1 : N ;
  midsommarstaang_nn_1 : N ;
  midsommartid_nn_1 : N ;
  midvattens_ab_1 : Adv ;
  midvinter_nn_1 : N ;
  midvinterblot_nn_1 : N ;
  migration_nn_1 : N ;
  miko_nn_1 : N ;
  mikro_nn_1 : N ;
  mikrob_nn_1 : N ;
  mikrobiologisk_av_1 : A ;
  mikrodator_nn_1 : N ;
  mikrofiche_nn_1 : N ;
  mikrofilm_nn_1 : N ;
  mikrofon_nn_1 : N ;
  mikrofonteknik_nn_1 : N ;
  mikrofoto_nn_1 : N ;
  mikrogram_nn_1 : N ;
  mikrokort_nn_1 : N ;
  mikrokosmos_nn_1 : N ;
  mikrometer_nn_1 : N ;
  mikrometer_nn_2 : N ;
  mikron_nn_1 : N ;
  mikroorganism_nn_1 : N ;
  mikrosekund_nn_1 : N ;
  mikroskop_nn_1 : N ;
  mikroskopisk_av_1 : A ;
  mikrotelefon_nn_1 : N ;
  mikrotom_nn_1 : N ;
  mikrovaagsugn_nn_1 : N ;
  mil_nn_1 : N ;
  mild_av_1 : A ;
  mildoegd_av_1 : A ;
  mildsint_av_1 : A ;
  milis_nn_1 : N ;
  militaer_av_1 : A ;
  militaer_nn_1 : N ;
  militaerattache_nn_1 : N ;
  militaerbas_nn_1 : N ;
  militaerbefaelhavare_nn_1 : N ;
  militaerbudget_nn_1 : N ;
  militaerdiktatur_nn_1 : N ;
  militaerfoervaltning_nn_1 : N ;
  militaerfordon_nn_1 : N ;
  militaerisk_av_1 : A ;
  militaerlaekare_nn_1 : N ;
  militaermakt_nn_1 : N ;
  militaermanoever_nn_1 : N ;
  militaermarsch_nn_1 : N ;
  militaeroevning_nn_1 : N ;
  militaeromraade_nn_1 : N ;
  militaerpolis_nn_1 : N ;
  militaerpromenad_nn_1 : N ;
  militaertjaenstgoering_nn_1 : N ;
  militant_av_1 : A ;
  militarist_nn_1 : N ;
  militaristisk_av_1 : A ;
  militieombudsman_nn_1 : N ;
  miljard_nn_1 : N ;
  miljardaer_nn_1 : N ;
  miljarddel_nn_1 : N ;
  miljoe_nn_1 : N ;
  miljoefarlig_av_1 : A ;
  miljoefoerorening_nn_1 : N ;
  miljoefoersaemring_nn_1 : N ;
  miljoefoerstoering_nn_1 : N ;
  miljoefraaga_nn_1 : N ;
  miljoegift_nn_1 : N ;
  miljoegiftshalt_nn_1 : N ;
  miljoeproblem_nn_1 : N ;
  miljoeskildring_nn_1 : N ;
  miljoetidskrift_nn_1 : N ;
  miljoevaenlig_av_1 : A ;
  miljon_nn_1 : N ;
  miljonaer_nn_1 : N ;
  miljondel_nn_1 : N ;
  miljonklass_nn_1 : N ;
  miljonstad_nn_1 : N ;
  miljontals_ab_1 : Adv ;
  milliard_nn_1 : N ;
  millibar_nn_1 : N ;
  milligram_nn_1 : N ;
  milliliter_nn_1 : N ;
  millimeter_nn_1 : N ;
  millimeterpapper_nn_1 : N ;
  million_nn_1 : N ;
  millisievert_nn_1 : N ;
  milo_nn_1 : N ;
  milsten_nn_1 : N ;
  milstolpe_nn_1 : N ;
  milsvid_av_1 : A ;
  miltals_ab_1 : Adv ;
  mim_nn_1 : N ;
  mimiker_nn_1 : N ;
  mimisk_av_1 : A ;
  mimosasallad_nn_1 : N ;
  min_nn_1 : N ;
  minaret_nn_1 : N ;
  minbomb_nn_1 : N ;
  minderaarig_av_1 : A ;
  mindervaerdeskaensla_nn_1 : N ;
  mindervaerdeskomplex_nn_1 : N ;
  mindervaerdig_av_1 : A ;
  mindretal_nn_1 : N ;
  mineral_nn_1 : N ;
  mineralaemne_nn_1 : N ;
  mineralfaerg_nn_1 : N ;
  mineralgaang_nn_1 : N ;
  mineralhalt_nn_1 : N ;
  mineralhaltig_av_1 : A ;
  mineraloeverdrag_nn_1 : N ;
  mineralog_nn_1 : N ;
  mineralogisk_av_1 : A ;
  mineralolja_nn_1 : N ;
  mineralprov_nn_1 : N ;
  mineralsalt_nn_1 : N ;
  mineraltillsats_nn_1 : N ;
  mineralutvinning_nn_1 : N ;
  mineralvatten_nn_1 : N ;
  minering_nn_1 : N ;
  minfaelt_nn_1 : N ;
  miniatyr_nn_1 : N ;
  minidator_nn_1 : N ;
  minimal_av_1 : A ;
  minimikapital_nn_1 : N ;
  minimiloen_nn_1 : N ;
  minimipunkt_nn_1 : N ;
  minimisiffra_nn_1 : N ;
  minimitemperatur_nn_1 : N ;
  minimitermometer_nn_1 : N ;
  minimum_nn_1 : N ;
  minior_nn_1 : N ;
  miniraeknare_nn_1 : N ;
  ministaer_nn_1 : N ;
  minister_nn_1 : N ;
  ministeraembete_nn_1 : N ;
  ministeransvarighet_nn_1 : N ;
  ministerbaenk_nn_1 : N ;
  ministerialbok_nn_1 : N ;
  ministeriell_av_1 : A ;
  ministerium_nn_1 : N ;
  ministerportfoelj_nn_1 : N ;
  ministerpresident_nn_1 : N ;
  ministerraad_nn_1 : N ;
  ministerstyrelse_nn_1 : N ;
  ministertaburett_nn_1 : N ;
  mink_nn_1 : N ;
  minne_nn_1 : N ;
  minnesaang_nn_1 : N ;
  minnesbild_nn_1 : N ;
  minnesfoerlust_nn_1 : N ;
  minnesfond_nn_1 : N ;
  minnesgaerd_nn_1 : N ;
  minnesgod_av_1 : A ;
  minneskonstnaer_nn_1 : N ;
  minneskunskap_nn_1 : N ;
  minneslund_nn_1 : N ;
  minnesmaerke_nn_1 : N ;
  minnesregel_nn_1 : N ;
  minnesrik_av_1 : A ;
  minnesskrift_nn_1 : N ;
  minnesspaar_nn_1 : N ;
  minnessten_nn_1 : N ;
  minnestal_nn_1 : N ;
  minnesteckning_nn_1 : N ;
  minnesvaard_nn_1 : N ;
  minnesvaerd_av_1 : A ;
  minoer_nn_1 : N ;
  minoisk_av_1 : A ;
  minoritet_nn_1 : N ;
  minoritetsregering_nn_1 : N ;
  minoritetsskydd_nn_1 : N ;
  minoritetsstaellning_nn_1 : N ;
  minoritetsvaelde_nn_1 : N ;
  minroejning_nn_1 : N ;
  minsann_ab_1 : Adv ;
  minskning_nn_1 : N ;
  minsoekare_nn_1 : N ;
  minspaerr_nn_1 : N ;
  minsting_nn_1 : N ;
  minsvep_nn_1 : N ;
  minsvepare_nn_1 : N ;
  minsvepning_nn_1 : N ;
  minuend_nn_1 : N ;
  minusgrad_nn_1 : N ;
  minuskel_nn_1 : N ;
  minuspol_nn_1 : N ;
  minussida_nn_1 : N ;
  minustecken_nn_1 : N ;
  minut_nn_1 : N ;
  minut_nn_2 : N ;
  minutioes_av_1 : A ;
  minutvisare_nn_1 : N ;
  mirabell_nn_1 : N ;
  mirakel_nn_1 : N ;
  mirakelspel_nn_1 : N ;
  mirakuloes_av_1 : A ;
  misaer_nn_1 : N ;
  misantrop_nn_1 : N ;
  misantropisk_av_1 : A ;
  miserabel_av_1 : A ;
  mispel_nn_1 : N ;
  miss_nn_1 : N ;
  miss_nn_2 : N ;
  missanpassning_nn_1 : N ;
  missbelaaten_av_1 : A ;
  missbildning_nn_1 : N ;
  missbruk_nn_1 : N ;
  missbrukare_nn_1 : N ;
  missbruksfraaga_nn_1 : N ;
  missdaad_nn_1 : N ;
  missdaadare_nn_1 : N ;
  misse_nn_1 : N ;
  missfaergning_nn_1 : N ;
  missfall_nn_1 : N ;
  missfirmelse_nn_1 : N ;
  missfoerhaallande_nn_1 : N ;
  missfoerstaand_nn_1 : N ;
  missfoster_nn_1 : N ;
  missgaerning_nn_1 : N ;
  missgaerningsbalk_nn_1 : N ;
  missgaerningsman_nn_1 : N ;
  missgrepp_nn_1 : N ;
  misshaellighet_nn_1 : N ;
  misshaglig_av_1 : A ;
  missil_nn_1 : N ;
  mission_nn_1 : N ;
  missionaer_nn_1 : N ;
  missionsbokhandel_nn_1 : N ;
  missionsfaelt_nn_1 : N ;
  missionsfoerbund_nn_1 : N ;
  missionshotell_nn_1 : N ;
  missionshus_nn_1 : N ;
  missionskyrka_nn_1 : N ;
  missionsstation_nn_1 : N ;
  missiv_nn_1 : N ;
  misskaend_av_1 : A ;
  missklaedsam_av_1 : A ;
  misskoetsam_av_1 : A ;
  misskundsam_av_1 : A ;
  missledande_av_1 : A ;
  missljud_nn_1 : N ;
  misslyckande_nn_1 : N ;
  misslynt_av_1 : A ;
  missmodig_av_1 : A ;
  missnoejd_av_1 : A ;
  missnoejesanmaelan_nn_1 : N ;
  missnoejesparti_nn_1 : N ;
  missoede_nn_1 : N ;
  missraekning_nn_1 : N ;
  missroman_nn_1 : N ;
  missta_vb_1 : V ;
  misstaemning_nn_1 : N ;
  misstaenksam_av_1 : A ;
  misstaenksamhet_nn_1 : N ;
  misstaenkt_av_1 : A ;
  misstag_nn_1 : N ;
  misstanke_nn_1 : N ;
  misstroendevotum_nn_1 : N ;
  misstrogen_av_1 : A ;
  missunnsam_av_1 : A ;
  missuppfattning_nn_1 : N ;
  missvisande_av_1 : A ;
  missvisning_nn_1 : N ;
  miste_ab_1 : Adv ;
  mistel_nn_1 : N ;
  mistig_av_1 : A ;
  mistlur_nn_1 : N ;
  mitokondrie_nn_1 : N ;
  mitt_ab_1 : Adv ;
  mittelgaang_nn_1 : N ;
  mittemellan_ab_1 : Adv ;
  mittemot_ab_1 : Adv ;
  mittenlager_nn_1 : N ;
  mittenparti_nn_1 : N ;
  mittfaelt_nn_1 : N ;
  mittlinje_nn_1 : N ;
  mittparti_nn_1 : N ;
  mittpunkt_nn_1 : N ;
  mittpunktsnormal_nn_1 : N ;
  mittskepp_nn_1 : N ;
  mittsunds_ab_1 : Adv ;
  mix_nn_1 : N ;
  mixer_nn_1 : N ;
  mixtur_nn_1 : N ;
  mjaekig_av_1 : A ;
  mjaell_av_1 : A ;
  mjaellig_av_1 : A ;
  mjaellschampo_nn_1 : N ;
  mjaelte_nn_1 : N ;
  mjaelthugg_nn_1 : N ;
  mjaeltsjuk_av_1 : A ;
  mjaerde_nn_1 : N ;
  mjoel_nn_1 : N ;
  mjoelbagge_nn_1 : N ;
  mjoelig_av_1 : A ;
  mjoelkaader_nn_1 : N ;
  mjoelkbar_nn_1 : N ;
  mjoelkbildande_av_1 : A ;
  mjoelkbonde_nn_1 : N ;
  mjoelkcell_nn_1 : N ;
  mjoelkcentral_nn_1 : N ;
  mjoelke_nn_1 : N ;
  mjoelkfloede_nn_1 : N ;
  mjoelkflytning_nn_1 : N ;
  mjoelkfoerpackning_nn_1 : N ;
  mjoelkgaang_nn_1 : N ;
  mjoelkgrymt_nn_1 : N ;
  mjoelkgrymtning_nn_1 : N ;
  mjoelkig_av_1 : A ;
  mjoelkkaerl_nn_1 : N ;
  mjoelkkanal_nn_1 : N ;
  mjoelkko_nn_1 : N ;
  mjoelkkoertel_nn_1 : N ;
  mjoelkoert_nn_1 : N ;
  mjoelkoeverskott_nn_1 : N ;
  mjoelkpaket_nn_1 : N ;
  mjoelkpall_nn_1 : N ;
  mjoelkproducent_nn_1 : N ;
  mjoelkprodukt_nn_1 : N ;
  mjoelkproduktion_nn_1 : N ;
  mjoelkspegel_nn_1 : N ;
  mjoelkstockning_nn_1 : N ;
  mjoelksyrebakterie_nn_1 : N ;
  mjoelktand_nn_1 : N ;
  mjoelnare_nn_1 : N ;
  mjoelon_nn_1 : N ;
  mjoelskivling_nn_1 : N ;
  mjuk_av_1 : A ;
  mjukbagge_nn_1 : N ;
  mjukdata_nn_1 : N ;
  mjukdel_nn_1 : N ;
  mjukdelsbehandling_nn_1 : N ;
  mjukhet_nn_1 : N ;
  mjukningsmedel_nn_1 : N ;
  mjukost_nn_1 : N ;
  mjukskalle_nn_1 : N ;
  mjukvaevnad_nn_1 : N ;
  mjukvaluta_nn_1 : N ;
  mnemoteknisk_av_1 : A ;
  mo_nn_1 : N ;
  moare_nn_1 : N ;
  moatje_nn_1 : N ;
  mobil_av_1 : A ;
  mobil_nn_1 : N ;
  mobilisering_nn_1 : N ;
  mobilitet_nn_1 : N ;
  mobiltelefon_nn_1 : N ;
  mockakopp_nn_1 : N ;
  mockaliknande_av_1 : A ;
  mockasin_nn_1 : N ;
  mockasked_nn_1 : N ;
  modaern_av_1 : A ;
  modal_av_1 : A ;
  modalitet_nn_1 : N ;
  moddlare_nn_1 : N ;
  modeatelje_nn_1 : N ;
  modehus_nn_1 : N ;
  modejournal_nn_1 : N ;
  modelejon_nn_1 : N ;
  modell_nn_1 : N ;
  modellbygge_nn_1 : N ;
  modellfoersoek_nn_1 : N ;
  modelljaernvaeg_nn_1 : N ;
  modellstudie_nn_1 : N ;
  modem_nn_1 : N ;
  modenyck_nn_1 : N ;
  modeord_nn_1 : N ;
  moderat_av_1 : A ;
  moderat_nn_1 : N ;
  moderator_nn_1 : N ;
  moderbolag_nn_1 : N ;
  modercell_nn_1 : N ;
  moderiktig_av_1 : A ;
  moderland_nn_1 : N ;
  moderlig_av_1 : A ;
  moderliv_nn_1 : N ;
  moderlut_nn_1 : N ;
  modermun_nn_1 : N ;
  modern_av_1 : A ;
  modernaering_nn_1 : N ;
  modernisering_nn_1 : N ;
  modernist_nn_1 : N ;
  modernistisk_av_1 : A ;
  modernitet_nn_1 : N ;
  modersfamn_nn_1 : N ;
  modersmaal_nn_1 : N ;
  modersskoete_nn_1 : N ;
  modeskapare_nn_1 : N ;
  modest_av_1 : A ;
  modfaelld_av_1 : A ;
  modifikation_nn_1 : N ;
  modig_av_1 : A ;
  modist_nn_1 : N ;
  modloes_av_1 : A ;
  mods_nn_1 : N ;
  modstulen_av_1 : A ;
  modul_nn_1 : N ;
  modulation_nn_1 : N ;
  modulator_nn_1 : N ;
  modulering_nn_1 : N ;
  modulsystem_nn_1 : N ;
  modus_nn_1 : N ;
  moe_nn_1 : N ;
  moebel_nn_1 : N ;
  moebelbuss_nn_1 : N ;
  moebelfirma_nn_1 : N ;
  moebelfoeretag_nn_1 : N ;
  moebelfoersaeljning_nn_1 : N ;
  moebelfot_nn_1 : N ;
  moebelklaedsel_nn_1 : N ;
  moebeloeverdrag_nn_1 : N ;
  moebelsnickare_nn_1 : N ;
  moebelsnickeri_nn_1 : N ;
  moebelspik_nn_1 : N ;
  moebelstil_nn_1 : N ;
  moebeltass_nn_1 : N ;
  moebeltyg_nn_1 : N ;
  moeblemang_nn_1 : N ;
  moeblerbar_av_1 : A ;
  moeblering_nn_1 : N ;
  moeda_nn_1 : N ;
  moedofylld_av_1 : A ;
  moedom_nn_1 : N ;
  moedomshinna_nn_1 : N ;
  moedosam_av_1 : A ;
  moedravaardscentral_nn_1 : N ;
  moegelost_nn_1 : N ;
  moegelsvamp_nn_1 : N ;
  moegeltraad_nn_1 : N ;
  moeglig_av_1 : A ;
  moejlig_av_1 : A ;
  moejligen_ab_1 : Adv ;
  moejlighet_nn_1 : N ;
  moejligtvis_ab_1 : Adv ;
  moenjefaerg_nn_1 : N ;
  moenster_nn_1 : N ;
  moensterbok_nn_1 : N ;
  moensterdjup_nn_1 : N ;
  moenstergaard_nn_1 : N ;
  moenstergarn_nn_1 : N ;
  moenstergill_av_1 : A ;
  moenstergosse_nn_1 : N ;
  moensterjordbruk_nn_1 : N ;
  moensterskydd_nn_1 : N ;
  moenstervaevd_av_1 : A ;
  moenstring_nn_1 : N ;
  moenstringsbevis_nn_1 : N ;
  moenstringsliggare_nn_1 : N ;
  moer_av_1 : A ;
  moerdande_av_1 : A ;
  moerdare_nn_1 : N ;
  moerdeg_nn_1 : N ;
  moerjig_av_1 : A ;
  moerk_av_1 : A ;
  moerkalf_nn_1 : N ;
  moerkblaa_av_1 : A ;
  moerkblond_av_1 : A ;
  moerkbrun_av_1 : A ;
  moerker_nn_1 : N ;
  moerkerkoerning_nn_1 : N ;
  moerkgroen_av_1 : A ;
  moerkklaedd_av_1 : A ;
  moerklaeggning_nn_1 : N ;
  moerklagd_av_1 : A ;
  moerkman_nn_1 : N ;
  moerkroed_av_1 : A ;
  moerkrum_nn_1 : N ;
  moerksens_av_1 : A ;
  moersare_nn_1 : N ;
  moert_nn_1 : N ;
  moesskapell_nn_1 : N ;
  moessoera_nn_1 : N ;
  moessrem_nn_1 : N ;
  moete_nn_1 : N ;
  moetesfoerbud_nn_1 : N ;
  moetesfrihet_nn_1 : N ;
  moetesordfoerande_nn_1 : N ;
  moetesplats_nn_1 : N ;
  moetespunkt_nn_1 : N ;
  moetesspaar_nn_1 : N ;
  moetesstation_nn_1 : N ;
  mogen_av_1 : A ;
  mogenhet_nn_1 : N ;
  mogenhetsexamen_nn_1 : N ;
  mognad_nn_1 : N ;
  mogul_nn_1 : N ;
  mohammedan_nn_1 : N ;
  mohammedanism_nn_1 : N ;
  mohammedansk_av_1 : A ;
  mohikan_nn_1 : N ;
  moj_av_1 : A ;
  moj_nn_2 : N ;
  mojaeng_nn_1 : N ;
  mokare_nn_1 : N ;
  mol_ab_1 : Adv ;
  molar_nn_1 : N ;
  molaritet_nn_1 : N ;
  molekyl_nn_1 : N ;
  molekylaer_av_1 : A ;
  molekylaerbiolog_nn_1 : N ;
  molekylarattraktion_nn_1 : N ;
  molekylarkraft_nn_1 : N ;
  molekylkedja_nn_1 : N ;
  molekylvikt_nn_1 : N ;
  mollstaemd_av_1 : A ;
  mollusk_nn_1 : N ;
  moln_nn_1 : N ;
  molnbank_nn_1 : N ;
  molnbildning_nn_1 : N ;
  molnfri_av_1 : A ;
  molngubbe_nn_1 : N ;
  molnhoejd_nn_1 : N ;
  molnhop_nn_1 : N ;
  molnig_av_1 : A ;
  molnighet_nn_1 : N ;
  molnkant_nn_1 : N ;
  molnstod_nn_1 : N ;
  molntapp_nn_1 : N ;
  molo_nn_1 : N ;
  molohamn_nn_1 : N ;
  moloken_av_1 : A ;
  moltyst_av_1 : A ;
  momang_nn_1 : N ;
  moment_nn_1 : N ;
  momentan_av_1 : A ;
  momentnyckel_nn_1 : N ;
  monad_nn_1 : N ;
  monark_nn_1 : N ;
  monarki_nn_1 : N ;
  monarkisk_av_1 : A ;
  monarkist_nn_1 : N ;
  mondaen_av_1 : A ;
  mondaenitet_nn_1 : N ;
  mondial_av_1 : A ;
  monegask_nn_1 : N ;
  monetaer_av_1 : A ;
  mongo_nn_1 : N ;
  mongol_nn_1 : N ;
  mongolflaeck_nn_1 : N ;
  mongolisk_av_1 : A ;
  mongoliska_nn_1 : N ;
  mongolrike_nn_1 : N ;
  monist_nn_1 : N ;
  monitor_nn_1 : N ;
  monoaminoxidas_nn_1 : N ;
  monoftong_nn_1 : N ;
  monogam_av_1 : A ;
  monografi_nn_1 : N ;
  monogram_nn_1 : N ;
  monokel_nn_1 : N ;
  monoklin_av_1 : A ;
  monokord_nn_1 : N ;
  monokotyledon_nn_1 : N ;
  monokrom_av_1 : A ;
  monokromatisk_av_1 : A ;
  monokultur_nn_1 : N ;
  monolit_nn_1 : N ;
  monolitisk_av_1 : A ;
  monolog_nn_1 : N ;
  monoman_av_1 : A ;
  monoplan_nn_1 : N ;
  monopol_nn_1 : N ;
  monopolist_nn_1 : N ;
  monopolstaellning_nn_1 : N ;
  monosackarid_nn_1 : N ;
  monosyllabisk_av_1 : A ;
  monoton_av_1 : A ;
  monotonitet_nn_1 : N ;
  monotoniundvikare_nn_1 : N ;
  monotype_nn_1 : N ;
  monseigneur_nn_1 : N ;
  monsignore_nn_1 : N ;
  monster_nn_1 : N ;
  monstrans_nn_1 : N ;
  monstruoes_av_1 : A ;
  monstruositet_nn_1 : N ;
  monsun_nn_1 : N ;
  monsunkantring_nn_1 : N ;
  montage_nn_1 : N ;
  monter_nn_1 : N ;
  monterbar_av_1 : A ;
  montering_nn_1 : N ;
  monteringsfaerdig_av_1 : A ;
  montoer_nn_1 : N ;
  monument_nn_1 : N ;
  monumental_av_1 : A ;
  monumentalbyggnad_nn_1 : N ;
  monumentalitet_nn_1 : N ;
  moped_nn_1 : N ;
  mopedist_nn_1 : N ;
  mopp_nn_1 : N ;
  moppe_nn_1 : N ;
  mops_nn_1 : N ;
  mopsig_av_1 : A ;
  mor_nn_1 : N ;
  mor_nn_2 : N ;
  mor_unge_konflikt_nn_1 : N ;
  moraen_nn_1 : N ;
  moraenmark_nn_1 : N ;
  moraensluttning_nn_1 : N ;
  morakniv_nn_1 : N ;
  moral_nn_1 : N ;
  moralbegrepp_nn_1 : N ;
  moralisk_av_1 : A ;
  moralist_nn_1 : N ;
  moralitet_nn_1 : N ;
  moralsed_nn_1 : N ;
  moras_nn_1 : N ;
  moratorium_nn_1 : N ;
  morbiditet_nn_1 : N ;
  morbror_nn_1 : N ;
  mord_nn_1 : N ;
  mordaengel_nn_1 : N ;
  mordbraennare_nn_1 : N ;
  mordbrand_nn_1 : N ;
  mordisk_av_1 : A ;
  mordkommission_nn_1 : N ;
  mordlysten_av_1 : A ;
  mordlystnad_nn_1 : N ;
  mordmisstaenkt_av_1 : A ;
  mordoffer_nn_1 : N ;
  mordvapen_nn_1 : N ;
  morell_nn_1 : N ;
  morfem_nn_1 : N ;
  morfemgraens_nn_1 : N ;
  morfinist_nn_1 : N ;
  morfoeraelder_nn_1 : N ;
  morfogenes_nn_1 : N ;
  morfologi_nn_1 : N ;
  morfologisk_av_1 : A ;
  morganatisk_av_1 : A ;
  morgon_nn_1 : N ;
  morgonandakt_nn_1 : N ;
  morgonboen_nn_1 : N ;
  morgondag_nn_1 : N ;
  morgongudstjaenst_nn_1 : N ;
  morgonluft_ab_1 : Adv ;
  morgonmaenniska_nn_1 : N ;
  morgonpigg_av_1 : A ;
  morgonrock_nn_1 : N ;
  morgonrodnad_nn_1 : N ;
  morgonsaang_nn_1 : N ;
  morgonsamling_nn_1 : N ;
  morgonstund_nn_1 : N ;
  morgontidning_nn_1 : N ;
  morian_nn_1 : N ;
  moring_nn_1 : N ;
  moringsankare_nn_1 : N ;
  moringsboj_nn_1 : N ;
  morisk_av_1 : A ;
  morisk_nn_1 : N ;
  morkullsstraeck_nn_1 : N ;
  mormon_nn_1 : N ;
  mormonsk_av_1 : A ;
  mormor_nn_1 : N ;
  mormorsstaang_nn_1 : N ;
  morot_nn_1 : N ;
  morrhaar_nn_1 : N ;
  morsarv_nn_1 : N ;
  morsefyr_nn_1 : N ;
  morsesignal_nn_1 : N ;
  morsgris_nn_1 : N ;
  morsk_av_1 : A ;
  morslott_nn_1 : N ;
  morssida_nn_1 : N ;
  mortalitet_nn_1 : N ;
  mortel_nn_1 : N ;
  mortifikation_nn_1 : N ;
  mosaik_nn_1 : N ;
  mosaiklandskap_nn_1 : N ;
  mosaikmoenster_nn_1 : N ;
  mosaiksoem_nn_1 : N ;
  mosaisk_av_1 : A ;
  moselvin_nn_1 : N ;
  mosig_av_1 : A ;
  moske_nn_1 : N ;
  moskit_nn_1 : N ;
  moskitnaet_nn_1 : N ;
  moskovit_nn_1 : N ;
  moskovitisk_av_1 : A ;
  mossbelupen_av_1 : A ;
  mosse_nn_1 : N ;
  mossfolk_nn_1 : N ;
  mossfynd_nn_1 : N ;
  mossgroen_av_1 : A ;
  mossig_av_1 : A ;
  mosskultur_nn_1 : N ;
  mosslik_nn_1 : N ;
  mossrot_nn_1 : N ;
  moster_nn_1 : N ;
  mosterlig_av_1 : A ;
  mot_ab_1 : Adv ;
  mot_nn_1 : N ;
  motaatgaerd_nn_1 : N ;
  motanfall_nn_1 : N ;
  motargument_nn_1 : N ;
  motbevis_nn_1 : N ;
  motbild_nn_1 : N ;
  motbjudande_av_1 : A ;
  motbok_nn_1 : N ;
  motdrag_nn_1 : N ;
  motell_nn_1 : N ;
  motett_nn_1 : N ;
  motfraaga_nn_1 : N ;
  motgaang_nn_1 : N ;
  motgift_nn_1 : N ;
  mothaall_nn_1 : N ;
  mothaars_ab_1 : Adv ;
  mothugg_nn_1 : N ;
  motig_av_1 : A ;
  motighet_nn_1 : N ;
  motion_nn_1 : N ;
  motionaer_nn_1 : N ;
  motionsanlaeggning_nn_1 : N ;
  motionscykel_nn_1 : N ;
  motionsflod_nn_1 : N ;
  motionsidrott_nn_1 : N ;
  motionsspaar_nn_1 : N ;
  motionstid_nn_1 : N ;
  motiv_nn_1 : N ;
  motivation_nn_1 : N ;
  motivering_nn_1 : N ;
  motivisk_av_1 : A ;
  motivkrets_nn_1 : N ;
  motlut_nn_1 : N ;
  motor_nn_1 : N ;
  motorbaat_nn_1 : N ;
  motorcykel_nn_1 : N ;
  motorcykeltaevling_nn_1 : N ;
  motorcyklist_nn_1 : N ;
  motorcylinder_nn_1 : N ;
  motordriven_av_1 : A ;
  motoreffekt_nn_1 : N ;
  motorfartyg_nn_1 : N ;
  motorfordon_nn_1 : N ;
  motorhotell_nn_1 : N ;
  motorhuv_nn_1 : N ;
  motorisk_av_1 : A ;
  motorist_nn_1 : N ;
  motorkryssare_nn_1 : N ;
  motorman_nn_1 : N ;
  motorseglare_nn_1 : N ;
  motorstopp_nn_1 : N ;
  motorstyrka_nn_1 : N ;
  motortorpedbaat_nn_1 : N ;
  motortrafikled_nn_1 : N ;
  motorvaeg_nn_1 : N ;
  motorvagn_nn_1 : N ;
  motpart_nn_1 : N ;
  motpol_nn_1 : N ;
  motprestation_nn_1 : N ;
  motrevolution_nn_1 : N ;
  motsaegelse_nn_1 : N ;
  motsaegelsefull_av_1 : A ;
  motsaettlig_av_1 : A ;
  motsaettning_nn_1 : N ;
  motsats_nn_1 : N ;
  motsatsfoerhaallande_nn_1 : N ;
  motsatt_av_1 : A ;
  motskott_nn_1 : N ;
  motsols_ab_1 : Adv ;
  motspaenstig_av_1 : A ;
  motspelare_nn_1 : N ;
  motstaaende_av_1 : A ;
  motstaand_nn_1 : N ;
  motstaandare_nn_1 : N ;
  motstaandskraftig_av_1 : A ;
  motstaandsman_nn_1 : N ;
  motstaandsnaeste_nn_1 : N ;
  motstaandsomraade_nn_1 : N ;
  motstaandsroerelse_nn_1 : N ;
  motstaandssvetsning_nn_1 : N ;
  motstoet_nn_1 : N ;
  motstraevig_av_1 : A ;
  motstridande_av_1 : A ;
  motstridig_av_1 : A ;
  motstroem_nn_1 : N ;
  motstroems_ab_1 : Adv ;
  motstrof_nn_1 : N ;
  motsvarande_av_1 : A ;
  motsvarighet_nn_1 : N ;
  mott_nn_1 : N ;
  motta_vb_1 : V ;
  mottagande_nn_1 : N ;
  mottagare_nn_1 : N ;
  mottagarsaeck_nn_1 : N ;
  mottaglig_av_1 : A ;
  mottagning_nn_1 : N ;
  mottagningsbevis_nn_1 : N ;
  motti_nn_1 : N ;
  motto_nn_1 : N ;
  moturs_ab_1 : Adv ;
  motvikt_nn_1 : N ;
  motvillig_av_1 : A ;
  motvind_nn_1 : N ;
  mousse_nn_1 : N ;
  mosambikier_nn_1 : N ;
  mosambikisk_av_1 : A ;
  muckare_nn_1 : N ;
  mudd_nn_1 : N ;
  mudderverk_nn_1 : N ;
  muddrig_av_1 : A ;
  muff_nn_1 : N ;
  muffel_nn_1 : N ;
  muffelfaerg_nn_1 : N ;
  muffelugn_nn_1 : N ;
  muffins_nn_1 : N ;
  mufflon_nn_1 : N ;
  mufflonfaar_nn_1 : N ;
  mufti_nn_1 : N ;
  mugg_nn_1 : N ;
  muhammedan_nn_1 : N ;
  muhammedansk_av_1 : A ;
  mulaasna_nn_1 : N ;
  mulatt_nn_1 : N ;
  mule_nn_1 : N ;
  mulen_av_1 : A ;
  mullbaenk_nn_1 : N ;
  mullbaer_nn_1 : N ;
  mullbaersfikon_nn_1 : N ;
  mullbaersfikontraed_nn_1 : N ;
  mullbaersspinnare_nn_1 : N ;
  mullbaerstraed_nn_1 : N ;
  mullhalt_nn_1 : N ;
  mullig_av_1 : A ;
  mullsork_nn_1 : N ;
  mullvad_nn_1 : N ;
  mullvadshoeg_nn_1 : N ;
  multe_nn_1 : N ;
  multen_av_1 : A ;
  multihandikapp_nn_1 : N ;
  multilateral_av_1 : A ;
  multinationell_av_1 : A ;
  multipel_av_1 : A ;
  multipeltaag_nn_1 : N ;
  multiplikand_nn_1 : N ;
  multiplikation_nn_1 : N ;
  multiplikationstabell_nn_1 : N ;
  multiplikationstecken_nn_1 : N ;
  multiplikator_nn_1 : N ;
  multituberkulat_nn_1 : N ;
  mumie_nn_1 : N ;
  mumrik_nn_1 : N ;
  mumsmums_nn_1 : N ;
  mun_nn_1 : N ;
  munart_nn_1 : N ;
  mundering_nn_1 : N ;
  mungo_nn_1 : N ;
  municipal_av_1 : A ;
  municipium_nn_1 : N ;
  munk_nn_1 : N ;
  munkavle_nn_1 : N ;
  munkcell_nn_1 : N ;
  munkfoerband_nn_1 : N ;
  munklikoer_nn_1 : N ;
  munkorden_nn_1 : N ;
  munkorg_nn_1 : N ;
  munkorgslag_nn_1 : N ;
  munkstol_nn_1 : N ;
  munlaas_ab_1 : Adv ;
  munlaas_nn_1 : N ;
  munlag_nn_1 : N ;
  munsbit_nn_1 : N ;
  munskaenk_nn_1 : N ;
  munskydd_nn_1 : N ;
  munslemhinna_nn_1 : N ;
  munspel_nn_1 : N ;
  munter_av_1 : A ;
  muntergoek_nn_1 : N ;
  munterhet_nn_1 : N ;
  muntlig_av_1 : A ;
  muntligen_ab_1 : Adv ;
  muntration_nn_1 : N ;
  munvatten_nn_1 : N ;
  munvig_av_1 : A ;
  mur_nn_1 : N ;
  mural_av_1 : A ;
  muralmaalning_nn_1 : N ;
  murankare_nn_1 : N ;
  murare_nn_1 : N ;
  murband_nn_1 : N ;
  murfoerband_nn_1 : N ;
  murfog_nn_1 : N ;
  murintag_nn_1 : N ;
  murken_av_1 : A ;
  murkla_nn_1 : N ;
  murkroen_nn_1 : N ;
  murliv_nn_1 : N ;
  murmel_nn_1 : N ;
  murmeldjur_nn_1 : N ;
  murre_nn_1 : N ;
  murrig_av_1 : A ;
  murskift_nn_1 : N ;
  murslev_nn_1 : N ;
  mursten_nn_1 : N ;
  murvel_nn_1 : N ;
  murverk_nn_1 : N ;
  mus_nn_1 : N ;
  mus_nn_2 : N ;
  musa_nn_1 : N ;
  musch_nn_1 : N ;
  museal_av_1 : A ;
  museifoeremaal_nn_1 : N ;
  museifoerening_nn_1 : N ;
  museimaessig_av_1 : A ;
  muselman_nn_1 : N ;
  muselmansk_av_1 : A ;
  musettedragspel_nn_1 : N ;
  museum_nn_1 : N ;
  musgraa_av_1 : A ;
  musical_nn_1 : N ;
  musikal_av_1 : A ;
  musikal_nn_1 : N ;
  musikalisk_av_1 : A ;
  musikalitet_nn_1 : N ;
  musikanlaeggning_nn_1 : N ;
  musikant_nn_1 : N ;
  musikdirektoer_nn_1 : N ;
  musikdrama_nn_1 : N ;
  musikensemble_nn_1 : N ;
  musiker_nn_1 : N ;
  musikfoerlag_nn_1 : N ;
  musikgrupp_nn_1 : N ;
  musikgudstjaenst_nn_1 : N ;
  musikgymnasium_nn_1 : N ;
  musikinstrument_nn_1 : N ;
  musikkaar_nn_1 : N ;
  musikkafe_nn_1 : N ;
  musikkomposition_nn_1 : N ;
  musikkonservatorium_nn_1 : N ;
  musikkvartett_nn_1 : N ;
  musiklaerare_nn_1 : N ;
  musikliv_nn_1 : N ;
  musikolog_nn_1 : N ;
  musikstaemma_nn_1 : N ;
  musiktecken_nn_1 : N ;
  musikverk_nn_1 : N ;
  musikverksamhet_nn_1 : N ;
  musikvetenskap_nn_1 : N ;
  musisk_av_1 : A ;
  musjik_nn_1 : N ;
  muskedunder_nn_1 : N ;
  muskel_nn_1 : N ;
  muskelatrofi_nn_1 : N ;
  muskelbristning_nn_1 : N ;
  muskelbyggare_nn_1 : N ;
  muskelbyggnad_nn_1 : N ;
  muskelfiber_nn_1 : N ;
  muskelfoerlamning_nn_1 : N ;
  muskelfoertvining_nn_1 : N ;
  muskelknutte_nn_1 : N ;
  muskelkraft_nn_1 : N ;
  muskelkramp_nn_1 : N ;
  muskellaengd_nn_1 : N ;
  muskelmage_nn_1 : N ;
  muskelryckning_nn_1 : N ;
  muskelsammandragning_nn_1 : N ;
  muskelspaenning_nn_1 : N ;
  muskelspole_nn_1 : N ;
  muskelstaerkare_nn_1 : N ;
  muskelstraeckning_nn_1 : N ;
  muskelstyrka_nn_1 : N ;
  muskeltraad_nn_1 : N ;
  muskelvaevnad_nn_1 : N ;
  musketerare_nn_1 : N ;
  musketoer_nn_1 : N ;
  muskoet_nn_1 : N ;
  muskoetgaffel_nn_1 : N ;
  muskotnoet_nn_1 : N ;
  muskottraed_nn_1 : N ;
  muskulatur_nn_1 : N ;
  muskuloes_av_1 : A ;
  muslim_nn_1 : N ;
  muslimsk_av_1 : A ;
  muslin_nn_1 : N ;
  musmamma_nn_1 : N ;
  musoera_nn_1 : N ;
  musselform_nn_1 : N ;
  musselskal_nn_1 : N ;
  musseron_nn_1 : N ;
  mussla_nn_1 : N ;
  must_nn_1 : N ;
  mustang_nn_1 : N ;
  mustasch_nn_1 : N ;
  musteri_nn_1 : N ;
  mustig_av_1 : A ;
  mutagen_av_1 : A ;
  mutagen_nn_1 : N ;
  mutant_nn_1 : N ;
  mutation_nn_1 : N ;
  mutkolv_nn_1 : N ;
  mutsedel_nn_1 : N ;
  mutter_nn_1 : N ;
  mycelium_nn_1 : N ;
  mycken_av_1 : A ;
  mycket_ab_1 : Adv ;
  mygg_nn_1 : N ;
  myggbett_nn_1 : N ;
  myggfoenster_nn_1 : N ;
  mygglarv_nn_1 : N ;
  myggmedel_nn_1 : N ;
  myggnaet_nn_1 : N ;
  myglare_nn_1 : N ;
  mykolog_nn_1 : N ;
  mykologisk_av_1 : A ;
  myling_nn_1 : N ;
  myllig_av_1 : A ;
  myndig_av_1 : A ;
  myndighet_nn_1 : N ;
  myndighetsaalder_nn_1 : N ;
  myndighetsfoerklaring_nn_1 : N ;
  myndighetsperson_nn_1 : N ;
  myndling_nn_1 : N ;
  mynning_nn_1 : N ;
  mynningsarm_nn_1 : N ;
  mynningsbroms_nn_1 : N ;
  mynningsladdare_nn_1 : N ;
  mynt_ab_1 : Adv ;
  mynt_nn_1 : N ;
  myntcirkulation_nn_1 : N ;
  myntenhet_nn_1 : N ;
  myntmetall_nn_1 : N ;
  myntrealisation_nn_1 : N ;
  myntsystem_nn_1 : N ;
  mynttecken_nn_1 : N ;
  myntunion_nn_1 : N ;
  myntvaloer_nn_1 : N ;
  myntverk_nn_1 : N ;
  myntvikt_nn_1 : N ;
  myom_nn_1 : N ;
  myon_nn_1 : N ;
  myopisk_av_1 : A ;
  myosin_nn_1 : N ;
  myr_nn_1 : N ;
  myraegg_nn_1 : N ;
  myrbagge_nn_1 : N ;
  myrdrottning_nn_1 : N ;
  myrgaest_nn_1 : N ;
  myrholme_nn_1 : N ;
  myriad_nn_1 : N ;
  myrkant_nn_1 : N ;
  myrkott_nn_1 : N ;
  myrkrypning_nn_1 : N ;
  myrland_nn_1 : N ;
  myrlejon_nn_1 : N ;
  myrlilja_nn_1 : N ;
  myrmalm_nn_1 : N ;
  myrmark_nn_1 : N ;
  myrslok_nn_1 : N ;
  myrstack_nn_1 : N ;
  myrten_nn_1 : N ;
  myrvaext_nn_1 : N ;
  mysdress_nn_1 : N ;
  mysig_av_1 : A ;
  myskdjur_nn_1 : N ;
  myskhjort_nn_1 : N ;
  myskolja_nn_1 : N ;
  myskoxe_nn_1 : N ;
  mysteriereligion_nn_1 : N ;
  mysteriespel_nn_1 : N ;
  mysterioes_av_1 : A ;
  mysterium_nn_1 : N ;
  mystifik_av_1 : A ;
  mystifikation_nn_1 : N ;
  mystiker_nn_1 : N ;
  mystisk_av_1 : A ;
  myt_nn_1 : N ;
  mytbildning_nn_1 : N ;
  myteri_nn_1 : N ;
  myterist_nn_1 : N ;
  mytisk_av_1 : A ;
  mytologi_nn_1 : N ;
  mytologisk_av_1 : A ;
  mytoman_nn_1 : N ;
  n_aarig_av_1 : A ;
  n_aaring_nn_1 : N ;
  n_procentig_av_1 : A ;
  n_talsbiolog_nn_1 : N ;
  n_talsforskare_nn_1 : N ;
  n_talsfysiker_nn_1 : N ;
  n_talskonstnaer_nn_1 : N ;
  naad_nn_2 : N ;
  naadaar_nn_1 : N ;
  naadaskott_nn_1 : N ;
  naadastoet_nn_1 : N ;
  naadaval_nn_1 : N ;
  naadeansoekning_nn_1 : N ;
  naadebevis_nn_1 : N ;
  naadebord_nn_1 : N ;
  naadehjon_nn_1 : N ;
  naadelig_av_1 : A ;
  naadeligen_ab_1 : Adv ;
  naademedel_nn_1 : N ;
  naadevedermaele_nn_1 : N ;
  naadig_av_1 : A ;
  naagonsin_ab_1 : Adv ;
  naagonstaedes_ab_1 : Adv ;
  naagonstans_ab_1 : Adv ;
  naagonvart_ab_1 : Adv ;
  naagorlunda_ab_1 : Adv ;
  naagotsaanaer_ab_1 : Adv ;
  naal_nn_1 : N ;
  naalbrev_nn_1 : N ;
  naalfil_nn_1 : N ;
  naalfin_av_1 : A ;
  naalkort_nn_1 : N ;
  naalmikrofon_nn_1 : N ;
  naalpeng_nn_1 : N ;
  naalsoega_nn_1 : N ;
  naalspets_nn_1 : N ;
  naalstick_nn_1 : N ;
  naalsting_nn_1 : N ;
  naalstygn_nn_1 : N ;
  naalventil_nn_1 : N ;
  naansin_ab_1 : Adv ;
  naanvart_ab_1 : Adv ;
  naat_nn_1 : N ;
  naatsaanaer_ab_1 : Adv ;
  nabb_nn_1 : N ;
  nabbe_nn_1 : N ;
  nabo_nn_1 : N ;
  nabob_nn_1 : N ;
  nachspil_nn_1 : N ;
  nackben_nn_1 : N ;
  nackbjudning_nn_1 : N ;
  nackdel_nn_1 : N ;
  nacke_nn_1 : N ;
  nackknut_nn_1 : N ;
  nackman_nn_1 : N ;
  nackspaerr_nn_1 : N ;
  nackstyv_av_1 : A ;
  nacksving_nn_1 : N ;
  nacktofs_nn_1 : N ;
  naebb_nn_1 : N ;
  naebbdjur_nn_1 : N ;
  naebbig_av_1 : A ;
  naebbknoel_nn_1 : N ;
  naebbmus_nn_1 : N ;
  naebbsko_nn_1 : N ;
  naebbval_nn_1 : N ;
  naeck_av_1 : A ;
  naektergal_nn_1 : N ;
  naektergalsslag_nn_1 : N ;
  naemligen_ab_1 : Adv ;
  naemnare_nn_1 : N ;
  naemnbar_av_1 : A ;
  naemnd_nn_1 : N ;
  naemndeman_nn_1 : N ;
  naemnvaerd_av_1 : A ;
  naepen_av_1 : A ;
  naeppeligen_ab_1 : Adv ;
  naer_ab_1 : Adv ;
  naera_ab_1 : Adv ;
  naera_av_1 : A ;
  naerande_av_1 : A ;
  naerapaa_ab_1 : Adv ;
  naerbelaegen_av_1 : A ;
  naerbild_nn_1 : N ;
  naerbutik_nn_1 : N ;
  naergaangen_av_1 : A ;
  naerhet_nn_1 : N ;
  naerig_av_1 : A ;
  naering_nn_1 : N ;
  naeringsaemne_nn_1 : N ;
  naeringsbrist_nn_1 : N ;
  naeringsfaang_nn_1 : N ;
  naeringsfattig_av_1 : A ;
  naeringsfrihet_nn_1 : N ;
  naeringsfrihetsombudsman_nn_1 : N ;
  naeringsfysiologisk_av_1 : A ;
  naeringsgren_nn_1 : N ;
  naeringsidkare_nn_1 : N ;
  naeringskedja_nn_1 : N ;
  naeringsloesning_nn_1 : N ;
  naeringsprocess_nn_1 : N ;
  naeringsrik_av_1 : A ;
  naeringssalt_nn_1 : N ;
  naeringsvaerde_nn_1 : N ;
  naerkamp_nn_1 : N ;
  naerking_nn_1 : N ;
  naerkingsk_av_1 : A ;
  naerlagd_av_1 : A ;
  naerliggande_av_1 : A ;
  naermande_nn_1 : N ;
  naermevaerde_nn_1 : N ;
  naermiljoe_nn_1 : N ;
  naeromraade_nn_1 : N ;
  naerpassage_nn_1 : N ;
  naerpunkt_nn_1 : N ;
  naersalt_nn_1 : N ;
  naerskyld_av_1 : A ;
  naersluta_vb_1 : V ;
  naerstaaende_av_1 : A ;
  naerstrid_nn_1 : N ;
  naerstudium_nn_1 : N ;
  naersynt_av_1 : A ;
  naersynthet_nn_1 : N ;
  naervarande_av_1 : A ;
  naes_nn_1 : N ;
  naesben_nn_1 : N ;
  naesborre_nn_1 : N ;
  naesbrosk_nn_1 : N ;
  naesduk_nn_1 : N ;
  naesgaang_nn_1 : N ;
  naeskatarr_nn_1 : N ;
  naesknaepp_nn_1 : N ;
  naesljud_nn_1 : N ;
  naesring_nn_1 : N ;
  naesrot_nn_1 : N ;
  naesrygg_nn_1 : N ;
  naesselcell_nn_1 : N ;
  naesseldjur_nn_1 : N ;
  naesselfiber_nn_1 : N ;
  naesselfjaeril_nn_1 : N ;
  naessla_nn_1 : N ;
  naesspets_nn_1 : N ;
  naest_ab_1 : Adv ;
  naest_nn_1 : N ;
  naestaegg_nn_1 : N ;
  naestan_ab_1 : Adv ;
  naestfoeljande_av_1 : A ;
  naestgaards_ab_1 : Adv ;
  naestintill_ab_1 : Adv ;
  naestipp_nn_1 : N ;
  naestkommande_av_1 : A ;
  naestkusin_nn_1 : N ;
  naestliden_av_1 : A ;
  naestunge_nn_1 : N ;
  naesvinge_nn_1 : N ;
  naesvis_av_1 : A ;
  naet_nn_1 : N ;
  naetansluten_av_1 : A ;
  naetboll_nn_1 : N ;
  naetbur_nn_1 : N ;
  naetfoenster_nn_1 : N ;
  naethinna_nn_1 : N ;
  naetmage_nn_1 : N ;
  naetmelon_nn_1 : N ;
  naetrullare_nn_1 : N ;
  naetsax_nn_1 : N ;
  naetspaenning_nn_1 : N ;
  naett_ab_1 : Adv ;
  naett_av_1 : A ;
  naettelduk_nn_1 : N ;
  naetting_nn_1 : N ;
  naettopp_ab_1 : Adv ;
  naettupp_ab_1 : Adv ;
  naetverk_nn_1 : N ;
  naetvinge_nn_1 : N ;
  naeve_nn_1 : N ;
  naever_nn_1 : N ;
  naeverbehaallare_nn_1 : N ;
  naeverflak_nn_1 : N ;
  naeverkont_nn_1 : N ;
  naeverkorg_nn_1 : N ;
  naeverlur_nn_1 : N ;
  naeversoem_nn_1 : N ;
  naevkamp_nn_1 : N ;
  nafs_nn_1 : N ;
  nagel_nn_1 : N ;
  nagelbaedd_nn_1 : N ;
  nagelbaenk_nn_1 : N ;
  nagelband_nn_1 : N ;
  nagelfara_vb_1 : V ;
  nagelfil_nn_1 : N ;
  nagellack_nn_1 : N ;
  nageloert_nn_1 : N ;
  nagelpetare_nn_1 : N ;
  nagelrot_nn_1 : N ;
  nagelsax_nn_1 : N ;
  nagelsoem_nn_1 : N ;
  nagg_nn_1 : N ;
  nagg_nn_2 : N ;
  naggande_ab_1 : Adv ;
  naiv_av_1 : A ;
  naivism_nn_1 : N ;
  naivist_nn_1 : N ;
  naivistisk_av_1 : A ;
  naivitet_nn_1 : N ;
  najad_nn_1 : N ;
  najoegonstropp_nn_1 : N ;
  najtaag_nn_1 : N ;
  naken_av_1 : A ;
  nakenbad_nn_1 : N ;
  nakenbild_nn_1 : N ;
  nakendans_nn_1 : N ;
  nakendansoes_nn_1 : N ;
  nakenfroeig_av_1 : A ;
  nakenhet_nn_1 : N ;
  nakenkult_nn_1 : N ;
  nakenkultur_nn_1 : N ;
  nakenmodell_nn_1 : N ;
  nakenscen_nn_1 : N ;
  naketbild_nn_1 : N ;
  nakterhus_nn_1 : N ;
  nalle_nn_1 : N ;
  namibier_nn_1 : N ;
  namibisk_av_1 : A ;
  namn_nn_1 : N ;
  namnaktie_nn_1 : N ;
  namnanrop_nn_1 : N ;
  namnberedning_nn_1 : N ;
  namnbyte_nn_1 : N ;
  namnchiffer_nn_1 : N ;
  namndikt_nn_1 : N ;
  namne_nn_1 : N ;
  namneligen_ab_1 : Adv ;
  namnfoerklaring_nn_1 : N ;
  namnge_vb_1 : V ;
  namninsamling_nn_1 : N ;
  namnkredit_nn_1 : N ;
  namnkristen_av_1 : A ;
  namnkunnig_av_1 : A ;
  namnkunnighet_nn_1 : N ;
  namnlaengd_nn_1 : N ;
  namnlag_nn_1 : N ;
  namnloes_av_1 : A ;
  namnplaat_nn_1 : N ;
  namnsaekerhet_nn_1 : N ;
  namnsdag_nn_1 : N ;
  namnsdagsbarn_nn_1 : N ;
  namnsedel_nn_1 : N ;
  namnskydd_nn_1 : N ;
  namnskylt_nn_1 : N ;
  namnstaempel_nn_1 : N ;
  namnstandert_nn_1 : N ;
  namntavla_nn_1 : N ;
  namnteckning_nn_1 : N ;
  namnunderskrift_nn_1 : N ;
  namnupprop_nn_1 : N ;
  namnvaerde_nn_1 : N ;
  nanogram_nn_1 : N ;
  nanosekund_nn_1 : N ;
  napoleonbakelse_nn_1 : N ;
  napolitanare_nn_1 : N ;
  napolitansk_av_1 : A ;
  napp_nn_1 : N ;
  napp_nn_2 : N ;
  nappatag_nn_1 : N ;
  naprapat_nn_1 : N ;
  nar_nn_1 : N ;
  narciss_nn_1 : N ;
  narig_av_1 : A ;
  narighet_nn_1 : N ;
  narkoanalys_nn_1 : N ;
  narkoman_nn_1 : N ;
  narkos_nn_1 : N ;
  narkoslaekare_nn_1 : N ;
  narkosmedel_nn_1 : N ;
  narkotikafoersaeljning_nn_1 : N ;
  narkotikahaj_nn_1 : N ;
  narkotikahund_nn_1 : N ;
  narkotikaklinik_nn_1 : N ;
  narkotikum_nn_1 : N ;
  narkotisk_av_1 : A ;
  narr_nn_1 : N ;
  narraktig_av_1 : A ;
  narrativ_av_1 : A ;
  narrdraekt_nn_1 : N ;
  narrspegel_nn_1 : N ;
  narrspel_nn_1 : N ;
  narrstreck_nn_1 : N ;
  narval_nn_1 : N ;
  narvfel_nn_1 : N ;
  narvhuggen_av_1 : A ;
  narvspalt_nn_1 : N ;
  nasal_av_1 : A ;
  nasal_nn_1 : N ;
  nasare_nn_1 : N ;
  nasir_nn_1 : N ;
  nasse_nn_1 : N ;
  nate_nn_1 : N ;
  nation_nn_1 : N ;
  nationalbegrepp_nn_1 : N ;
  nationalbudget_nn_1 : N ;
  nationaldag_nn_1 : N ;
  nationaldraekt_nn_1 : N ;
  nationalekonom_nn_1 : N ;
  nationalekonomisk_av_1 : A ;
  nationalfoerening_nn_1 : N ;
  nationalfoermoegenhet_nn_1 : N ;
  nationalfoersamling_nn_1 : N ;
  nationalgalleri_nn_1 : N ;
  nationalhelgon_nn_1 : N ;
  nationalhjaelte_nn_1 : N ;
  nationalinkomst_nn_1 : N ;
  nationalisering_nn_1 : N ;
  nationalist_nn_1 : N ;
  nationalistisk_av_1 : A ;
  nationalistledare_nn_1 : N ;
  nationalitet_nn_1 : N ;
  nationalitetsbeteckning_nn_1 : N ;
  nationalitetsbevis_nn_1 : N ;
  nationalitetsbokstav_nn_1 : N ;
  nationalitetscertifikat_nn_1 : N ;
  nationalitetshandling_nn_1 : N ;
  nationalitetsintyg_nn_1 : N ;
  nationalitetsmaerke_nn_1 : N ;
  nationalitetsmatrikel_nn_1 : N ;
  nationalitetsspillra_nn_1 : N ;
  nationalitetsstraevande_nn_1 : N ;
  nationalkapital_nn_1 : N ;
  nationalkaraktaer_nn_1 : N ;
  nationalkyrka_nn_1 : N ;
  nationalmedvetande_nn_1 : N ;
  nationalmuseum_nn_1 : N ;
  nationalpark_nn_1 : N ;
  nationalprodukt_nn_1 : N ;
  nationalraett_nn_1 : N ;
  nationalsaang_nn_1 : N ;
  nationalscen_nn_1 : N ;
  nationalskald_nn_1 : N ;
  nationalsocialist_nn_1 : N ;
  nationalsocialistisk_av_1 : A ;
  nationalsport_nn_1 : N ;
  nationalspraak_nn_1 : N ;
  nationalstat_nn_1 : N ;
  nationalteater_nn_1 : N ;
  nationell_av_1 : A ;
  nationsavgift_nn_1 : N ;
  nationsinspektor_nn_1 : N ;
  nationskurator_nn_1 : N ;
  nationsvis_ab_1 : Adv ;
  nativ_av_1 : A ;
  nativitet_nn_1 : N ;
  natriumhalt_nn_1 : N ;
  natriumhydroxid_nn_1 : N ;
  natriumnitrat_nn_1 : N ;
  natriumsulfat_nn_1 : N ;
  natriumtiosulfat_nn_1 : N ;
  natronlut_nn_1 : N ;
  natt_nn_1 : N ;
  nattaktiv_av_1 : A ;
  nattblaa_av_1 : A ;
  nattblind_av_1 : A ;
  nattblindhet_nn_1 : N ;
  nattbord_nn_1 : N ;
  nattdjur_nn_1 : N ;
  nattdraekt_nn_1 : N ;
  nattduksbord_nn_1 : N ;
  nattetid_ab_1 : Adv ;
  nattfaagel_nn_1 : N ;
  nattfack_nn_1 : N ;
  nattfjaeril_nn_1 : N ;
  nattfly_nn_1 : N ;
  nattfriare_nn_1 : N ;
  nattfrieri_nn_1 : N ;
  nattfrusen_av_1 : A ;
  nattgaangen_av_1 : A ;
  nattglim_nn_1 : N ;
  natthamn_nn_1 : N ;
  natthimmel_nn_1 : N ;
  nattine_nn_1 : N ;
  nattis_nn_1 : N ;
  nattjour_nn_1 : N ;
  nattkaerl_nn_1 : N ;
  nattkikare_nn_1 : N ;
  nattklubb_nn_1 : N ;
  nattkraem_nn_1 : N ;
  nattlaeger_nn_1 : N ;
  nattlaengd_nn_1 : N ;
  nattlig_av_1 : A ;
  nattlik_av_1 : A ;
  nattljus_nn_1 : N ;
  nattlogerare_nn_1 : N ;
  nattmangling_nn_1 : N ;
  nattmoln_nn_1 : N ;
  nattorientering_nn_1 : N ;
  nattraj_nn_1 : N ;
  nattsaeck_nn_1 : N ;
  nattskift_nn_1 : N ;
  nattskoeterska_nn_1 : N ;
  nattslag_nn_1 : N ;
  nattsmyg_nn_1 : N ;
  nattspaar_nn_1 : N ;
  nattstaanden_av_1 : A ;
  nattstaellning_nn_1 : N ;
  nattstol_nn_1 : N ;
  nattsvart_av_1 : A ;
  nattsyster_nn_1 : N ;
  nattvaekt_nn_1 : N ;
  nattvaektare_nn_1 : N ;
  nattvak_nn_1 : N ;
  nattvakt_nn_1 : N ;
  nattvard_nn_1 : N ;
  nattvardsbarn_nn_1 : N ;
  nattvardsberedelse_nn_1 : N ;
  nattvardsbord_nn_1 : N ;
  nattvardsbroed_nn_1 : N ;
  nattvardsgaang_nn_1 : N ;
  nattvardsgudstjaenst_nn_1 : N ;
  nattvardskaerl_nn_1 : N ;
  nattvardskalk_nn_1 : N ;
  nattvardsundervisning_nn_1 : N ;
  nattvardsvin_nn_1 : N ;
  nattviol_nn_1 : N ;
  nattygsbord_nn_1 : N ;
  natur_nn_1 : N ;
  naturaliekabinett_nn_1 : N ;
  naturalist_nn_1 : N ;
  naturalistisk_av_1 : A ;
  naturaportion_nn_1 : N ;
  naturbarn_nn_1 : N ;
  naturbegaavning_nn_1 : N ;
  naturbehov_nn_1 : N ;
  naturbetingelse_nn_1 : N ;
  naturbunden_av_1 : A ;
  naturell_av_1 : A ;
  naturelltapet_nn_1 : N ;
  naturenlig_av_1 : A ;
  naturfaerg_nn_1 : N ;
  naturfenomen_nn_1 : N ;
  naturfiber_nn_1 : N ;
  naturfilosof_nn_1 : N ;
  naturfolk_nn_1 : N ;
  naturformation_nn_1 : N ;
  naturgas_nn_1 : N ;
  naturhamn_nn_1 : N ;
  naturhistorisk_av_1 : A ;
  naturhorn_nn_1 : N ;
  naturinstinkt_nn_1 : N ;
  naturist_nn_1 : N ;
  naturkatastrof_nn_1 : N ;
  naturkonstant_nn_1 : N ;
  naturkraft_nn_1 : N ;
  naturlaekare_nn_1 : N ;
  naturlaekemedel_nn_1 : N ;
  naturlaekemetod_nn_1 : N ;
  naturlag_nn_1 : N ;
  naturlig_av_1 : A ;
  naturligen_ab_1 : Adv ;
  naturligtvis_ab_1 : Adv ;
  naturmaenniska_nn_1 : N ;
  naturmedicin_nn_1 : N ;
  naturmetod_nn_1 : N ;
  naturmiljoe_nn_1 : N ;
  naturminne_nn_1 : N ;
  naturminnesmaerke_nn_1 : N ;
  naturnaera_av_1 : A ;
  naturnamn_nn_1 : N ;
  naturnoedvaendig_av_1 : A ;
  naturnoedvaendighet_nn_1 : N ;
  naturorienterande_av_1 : A ;
  naturpark_nn_1 : N ;
  naturreligion_nn_1 : N ;
  naturreservat_nn_1 : N ;
  naturresurs_nn_1 : N ;
  naturrikedom_nn_1 : N ;
  natursaangare_nn_1 : N ;
  natursceneri_nn_1 : N ;
  naturskoen_av_1 : A ;
  naturskog_nn_1 : N ;
  natursten_nn_1 : N ;
  naturstig_nn_1 : N ;
  naturstridig_av_1 : A ;
  naturtillgaang_nn_1 : N ;
  naturtomt_nn_1 : N ;
  naturtrogen_av_1 : A ;
  naturtyp_nn_1 : N ;
  naturvaardare_nn_1 : N ;
  naturvaen_nn_1 : N ;
  naturvaesen_nn_1 : N ;
  naturvetare_nn_1 : N ;
  naturvetenskap_nn_1 : N ;
  naturvetenskaplig_av_1 : A ;
  naturvetenskapsman_nn_1 : N ;
  naturvidrig_av_1 : A ;
  naurisk_av_1 : A ;
  nauruer_nn_1 : N ;
  nautiker_nn_1 : N ;
  nautisk_av_1 : A ;
  nav_nn_1 : N ;
  navalmedicinsk_av_1 : A ;
  navarborr_nn_1 : N ;
  navare_nn_1 : N ;
  navel_nn_1 : N ;
  navelband_nn_1 : N ;
  navelflaeck_nn_1 : N ;
  navelskaadare_nn_1 : N ;
  navelstraeng_nn_1 : N ;
  navelsvin_nn_1 : N ;
  navigabel_av_1 : A ;
  navigationssatellit_nn_1 : N ;
  navigationsvarning_nn_1 : N ;
  navigatoer_nn_1 : N ;
  navigerbar_av_1 : A ;
  navigering_nn_1 : N ;
  navigeringssystem_nn_1 : N ;
  navkapsel_nn_1 : N ;
  naziarkitektur_nn_1 : N ;
  nazist_nn_1 : N ;
  nazistisk_av_1 : A ;
  neandertalare_nn_1 : N ;
  neandertalmaenniska_nn_1 : N ;
  neapolitan_nn_1 : N ;
  neapolitansk_av_1 : A ;
  nebuloes_av_1 : A ;
  nebulosalinje_nn_1 : N ;
  necessaer_nn_1 : N ;
  ned_ab_1 : Adv ;
  nedaat_ab_1 : Adv ;
  nedaatgaaende_av_1 : A ;
  nedaervd_av_1 : A ;
  nedan_ab_1 : Adv ;
  nedan_nn_1 : N ;
  nedanfoer_ab_1 : Adv ;
  nedanstaaende_av_1 : A ;
  nedbruten_av_1 : A ;
  nedbryta_vb_1 : V ;
  nedbrytning_nn_1 : N ;
  nedbrytningsstation_nn_1 : N ;
  neddragen_av_1 : A ;
  neddragning_nn_1 : N ;
  neder_ab_1 : Adv ;
  nederboerdsmaengd_nn_1 : N ;
  nederboerdsomraade_nn_1 : N ;
  nederdel_nn_1 : N ;
  nederlaendare_nn_1 : N ;
  nederlaendsk_av_1 : A ;
  nederlaendska_nn_2 : N ;
  nederlag_nn_1 : N ;
  nedfall_nn_1 : N ;
  nedfart_nn_1 : N ;
  nedfoer_ab_1 : Adv ;
  nedfoersbacke_nn_1 : N ;
  nedfrysning_nn_1 : N ;
  nedgaang_nn_1 : N ;
  nedgaangen_av_1 : A ;
  nedhaengande_av_1 : A ;
  nedhalare_nn_1 : N ;
  nedifraan_ab_1 : Adv ;
  nedkomma_vb_1 : V ;
  nedlaatande_av_1 : A ;
  nedlaaten_av_1 : A ;
  nedlaatenhet_nn_1 : N ;
  nedlaeggelse_nn_1 : N ;
  nedlaeggning_nn_1 : N ;
  nedmoerk_av_1 : A ;
  nedom_ab_1 : Adv ;
  nedra_av_1 : A ;
  nedraekning_nn_1 : N ;
  nedrans_av_1 : A ;
  nedrig_av_1 : A ;
  nedringd_av_1 : A ;
  nedsaettande_av_1 : A ;
  nedsaettning_nn_1 : N ;
  nedsaettningsbevis_nn_1 : N ;
  nedsatt_av_1 : A ;
  nedskaelld_av_1 : A ;
  nedskaerning_nn_1 : N ;
  nedskriva_vb_1 : V ;
  nedslaaende_av_1 : A ;
  nedslaepp_nn_1 : N ;
  nedslag_nn_1 : N ;
  nedslagen_av_1 : A ;
  nedslagskrater_nn_1 : N ;
  nedslagsplats_nn_1 : N ;
  nedslagsteori_nn_1 : N ;
  nedslaktning_nn_1 : N ;
  nedsliten_av_1 : A ;
  nedsmord_av_1 : A ;
  nedspilld_av_1 : A ;
  nedstaemd_av_1 : A ;
  nedstraak_nn_1 : N ;
  nedstroems_ab_1 : Adv ;
  nedstrykning_nn_1 : N ;
  nedsupen_av_1 : A ;
  nedsutten_av_1 : A ;
  nedsvaertning_nn_1 : N ;
  nedtagning_nn_1 : N ;
  nedtill_ab_1 : Adv ;
  nedtoning_nn_1 : N ;
  nedtransformering_nn_1 : N ;
  nedtransponering_nn_1 : N ;
  nedtryckt_av_1 : A ;
  nefrit_nn_1 : N ;
  nefritisk_av_1 : A ;
  negation_nn_1 : N ;
  negativ_av_1 : A ;
  negativ_nn_1 : N ;
  neger_nn_1 : N ;
  negerboll_nn_1 : N ;
  neglige_nn_1 : N ;
  negligeabel_av_1 : A ;
  negligibel_av_1 : A ;
  negress_nn_1 : N ;
  negroid_nn_1 : N ;
  nejd_nn_1 : N ;
  nejlikrot_nn_1 : N ;
  nejlikvaext_nn_1 : N ;
  nejonoega_nn_1 : N ;
  nejsaegare_nn_1 : N ;
  nek_nn_1 : N ;
  nekrofil_nn_1 : N ;
  nekrolog_nn_1 : N ;
  nektardrag_nn_1 : N ;
  nektarin_nn_1 : N ;
  nektarium_nn_1 : N ;
  nematod_nn_1 : N ;
  nemesistanke_nn_1 : N ;
  neodym_nn_2 : N ;
  neodymmagnet_nn_1 : N ;
  neokolonialistisk_av_1 : A ;
  neolitisk_av_1 : A ;
  neolog_nn_1 : N ;
  neongas_nn_1 : N ;
  neonljus_nn_1 : N ;
  neonroer_nn_1 : N ;
  neonskylt_nn_1 : N ;
  neotektonik_nn_1 : N ;
  neotektonisk_av_1 : A ;
  nepales_nn_1 : N ;
  nepalesisk_av_1 : A ;
  neptunisk_av_1 : A ;
  ner_ab_1 : Adv ;
  neraatgaaende_av_1 : A ;
  nerbryta_vb_1 : V ;
  nere_ab_1 : Adv ;
  nere_av_1 : A ;
  nereid_nn_1 : N ;
  nerfoer_ab_1 : Adv ;
  nerifraan_ab_1 : Adv ;
  nerium_nn_1 : N ;
  nertill_ab_1 : Adv ;
  nerv_nn_1 : N ;
  nervaenda_nn_1 : N ;
  nervaktivitet_nn_1 : N ;
  nervattack_nn_1 : N ;
  nervcell_nn_1 : N ;
  nervcellsgrupp_nn_1 : N ;
  nervchock_nn_1 : N ;
  nervfoerbindelse_nn_1 : N ;
  nervgas_nn_1 : N ;
  nervgift_nn_1 : N ;
  nervig_av_1 : A ;
  nervimpuls_nn_1 : N ;
  nervkittlande_av_1 : A ;
  nervklen_av_1 : A ;
  nervknut_nn_1 : N ;
  nervkollaps_nn_1 : N ;
  nervkrig_nn_1 : N ;
  nervmedicin_nn_1 : N ;
  nervoes_av_1 : A ;
  nervositet_nn_1 : N ;
  nervpirrande_av_1 : A ;
  nervryckning_nn_1 : N ;
  nervsammanbrott_nn_1 : N ;
  nervsignal_nn_1 : N ;
  nervsignalmoenster_nn_1 : N ;
  nervsjukdom_nn_1 : N ;
  nervstump_nn_1 : N ;
  nervsystem_nn_1 : N ;
  nervtraad_nn_1 : N ;
  nervvrak_nn_1 : N ;
  neslig_av_1 : A ;
  nesligen_ab_1 : Adv ;
  nestorian_nn_1 : N ;
  nestoriansk_av_1 : A ;
  netto_ab_1 : Adv ;
  netto_nn_1 : N ;
  nettofoermoegenhet_nn_1 : N ;
  nettoinkomst_nn_1 : N ;
  nettoloen_nn_1 : N ;
  nettopris_nn_1 : N ;
  nettoregisterton_nn_1 : N ;
  nettoskuld_nn_1 : N ;
  nettosparande_nn_1 : N ;
  nettostudietid_nn_1 : N ;
  nettovinst_nn_1 : N ;
  neuralgisk_av_1 : A ;
  neurit_nn_1 : N ;
  neurofysiolog_nn_1 : N ;
  neuroleptika_nn_1 : N ;
  neurolog_nn_1 : N ;
  neurologisk_av_1 : A ;
  neurom_nn_1 : N ;
  neuron_nn_1 : N ;
  neuropat_nn_1 : N ;
  neuros_nn_1 : N ;
  neurotiker_nn_1 : N ;
  neurotisk_av_1 : A ;
  neutral_av_1 : A ;
  neutralist_nn_1 : N ;
  neutralistisk_av_1 : A ;
  neutralitet_nn_1 : N ;
  neutrallaege_nn_1 : N ;
  neutrino_nn_1 : N ;
  neutrinofoertaetning_nn_1 : N ;
  neutrinohav_nn_1 : N ;
  neutrinomodell_nn_1 : N ;
  neutron_nn_1 : N ;
  neutronbomb_nn_1 : N ;
  neutronstraalning_nn_1 : N ;
  neutrum_nn_1 : N ;
  nevoe_nn_1 : N ;
  newfoundlaendare_nn_1 : N ;
  newfoundlaendsk_av_1 : A ;
  newfoundlandshund_nn_1 : N ;
  newton_nn_1 : N ;
  newtonmeter_nn_1 : N ;
  ng_ljud_nn_1 : N ;
  nicaraguan_nn_1 : N ;
  nick_nn_1 : N ;
  nickhake_nn_1 : N ;
  nickning_nn_1 : N ;
  nickpump_nn_1 : N ;
  nidation_nn_1 : N ;
  nidbild_nn_1 : N ;
  niddikt_nn_1 : N ;
  niding_nn_1 : N ;
  nidingsdaad_nn_1 : N ;
  nidingsverk_nn_1 : N ;
  nidsk_av_1 : A ;
  nidskrift_nn_1 : N ;
  nidstaang_nn_1 : N ;
  niece_nn_1 : N ;
  niello_nn_1 : N ;
  nigerer_nn_1 : N ;
  nigerian_nn_1 : N ;
  nigeriansk_av_1 : A ;
  nigerisk_av_1 : A ;
  nigger_nn_1 : N ;
  nigning_nn_1 : N ;
  nigsittande_av_1 : A ;
  nigstaaende_av_1 : A ;
  nihilist_nn_1 : N ;
  nihilistisk_av_1 : A ;
  nikotingul_av_1 : A ;
  nikotinist_nn_1 : N ;
  nimrod_nn_1 : N ;
  niondel_nn_1 : N ;
  niotillhaallarlaas_nn_1 : N ;
  nipbrant_nn_1 : N ;
  nipflod_nn_1 : N ;
  nipig_av_1 : A ;
  nippel_nn_1 : N ;
  nipprig_av_1 : A ;
  nisch_nn_1 : N ;
  nisse_nn_1 : N ;
  nissoega_nn_1 : N ;
  nit_nn_2 : N ;
  nit_nn_3 : N ;
  nitaelskande_nn_1 : N ;
  nitfoerband_nn_1 : N ;
  nitisk_av_1 : A ;
  nitlott_nn_1 : N ;
  nitnagel_nn_1 : N ;
  nitrat_nn_1 : N ;
  nitratbakterie_nn_1 : N ;
  nitrit_nn_1 : N ;
  nitritbakterie_nn_1 : N ;
  nitroes_av_1 : A ;
  nitrofoerening_nn_1 : N ;
  nitroglycerin_nn_1 : N ;
  nitrogrupp_nn_1 : N ;
  nitstamp_nn_1 : N ;
  nitstans_nn_1 : N ;
  nittiosexprocentig_av_1 : A ;
  nittiotalist_nn_1 : N ;
  nittisexprocentig_av_1 : A ;
  nittitalism_nn_1 : N ;
  nittitalist_nn_1 : N ;
  nivaa_nn_1 : N ;
  nivaagruppering_nn_1 : N ;
  nivaaskillnad_nn_1 : N ;
  nivation_nn_1 : N ;
  njugg_av_1 : A ;
  njugghaent_av_1 : A ;
  njurbaecken_nn_1 : N ;
  njurbaelte_nn_1 : N ;
  njure_nn_1 : N ;
  njursten_nn_1 : N ;
  njurtransplantation_nn_1 : N ;
  njuta_vb_1 : V ;
  njutbar_av_1 : A ;
  njutning_nn_1 : N ;
  njutningslysten_av_1 : A ;
  njutningslystnad_nn_1 : N ;
  njutningsmedel_nn_1 : N ;
  noanamn_nn_1 : N ;
  noaord_nn_1 : N ;
  nobb_nn_1 : N ;
  nobel_av_1 : A ;
  nobelpris_nn_1 : N ;
  nobelpristagare_nn_1 : N ;
  nock_nn_1 : N ;
  nocturne_nn_1 : N ;
  nod_nn_1 : N ;
  noedaar_nn_1 : N ;
  noedanrop_nn_1 : N ;
  noedbedd_av_1 : A ;
  noedbjuden_av_1 : A ;
  noedbroms_nn_1 : N ;
  noedd_av_1 : A ;
  noeddop_nn_1 : N ;
  noedfall_nn_1 : N ;
  noedhamn_nn_1 : N ;
  noedig_av_1 : A ;
  noedlaege_nn_1 : N ;
  noedlandning_nn_1 : N ;
  noedlidande_av_1 : A ;
  noedloegn_nn_1 : N ;
  noedloesning_nn_1 : N ;
  noedmynt_nn_1 : N ;
  noedraket_nn_1 : N ;
  noedrim_nn_1 : N ;
  noedrop_nn_1 : N ;
  noedsignal_nn_1 : N ;
  noedsignalering_nn_1 : N ;
  noedsituation_nn_1 : N ;
  noedstaelld_av_1 : A ;
  noedtorftig_av_1 : A ;
  noedtvungen_av_1 : A ;
  noedutgaang_nn_1 : N ;
  noedvaendig_av_1 : A ;
  noedvaendighet_nn_1 : N ;
  noedvaendighetsartikel_nn_1 : N ;
  noedvaendigtvis_ab_1 : Adv ;
  noedvuxen_av_1 : A ;
  noejaktig_av_1 : A ;
  noejd_av_1 : A ;
  noejdfoerklaring_nn_1 : N ;
  noeje_nn_1 : N ;
  noejesbaat_nn_1 : N ;
  noejesbegaer_nn_1 : N ;
  noejesetablissemang_nn_1 : N ;
  noejesfaelt_nn_1 : N ;
  noejesfiskare_nn_1 : N ;
  noejeshall_nn_1 : N ;
  noejeskoerning_nn_1 : N ;
  noejeslokal_nn_1 : N ;
  noejeslysten_av_1 : A ;
  noejespalats_nn_1 : N ;
  noejespappa_nn_1 : N ;
  noejespark_nn_1 : N ;
  noejesprogram_nn_1 : N ;
  noejsam_av_1 : A ;
  noet_nn_1 : N ;
  noet_nn_2 : N ;
  noetbarhet_nn_1 : N ;
  noetbrun_av_1 : A ;
  noetfrukt_nn_1 : N ;
  noetknaeckare_nn_1 : N ;
  noetknaeppare_nn_1 : N ;
  noetkreatur_nn_1 : N ;
  noetliknande_av_1 : A ;
  noetning_nn_1 : N ;
  noetningsbestaendig_av_1 : A ;
  noetskal_nn_1 : N ;
  noetstyng_nn_1 : N ;
  noetvivel_nn_1 : N ;
  nog_ab_1 : Adv ;
  noga_ab_1 : Adv ;
  noga_av_1 : A ;
  nogav_ab_1 : Adv ;
  noggrann_av_1 : A ;
  noggrannhet_nn_1 : N ;
  nogsamt_ab_1 : Adv ;
  nokturn_nn_1 : N ;
  nollaege_nn_1 : N ;
  nollcirkel_nn_1 : N ;
  nolledning_nn_1 : N ;
  nollkorrektur_nn_1 : N ;
  nollning_nn_1 : N ;
  nollplan_nn_1 : N ;
  nollpunkt_nn_1 : N ;
  nollspant_nn_1 : N ;
  nolltaxerare_nn_1 : N ;
  noltig_av_1 : A ;
  nomad_nn_1 : N ;
  nomadfamilj_nn_1 : N ;
  nomadfolk_nn_1 : N ;
  nomadisk_av_1 : A ;
  nomadsystem_nn_1 : N ;
  nomen_nn_1 : N ;
  nomenklatur_nn_1 : N ;
  nominal_av_1 : A ;
  nominalist_nn_1 : N ;
  nominalistisk_av_1 : A ;
  nominalkatalog_nn_1 : N ;
  nominalloen_nn_1 : N ;
  nominalvaerde_nn_1 : N ;
  nominativ_nn_1 : N ;
  nominell_av_1 : A ;
  nominering_nn_1 : N ;
  nomogram_nn_1 : N ;
  non_iron_av_1 : A ;
  nonaggressionsfoerdrag_nn_1 : N ;
  nonchalant_av_1 : A ;
  nonfigurativ_av_1 : A ;
  nonie_nn_1 : N ;
  nonkombattant_nn_1 : N ;
  nonkonformist_nn_1 : N ;
  nonsensvers_nn_1 : N ;
  nonstop_ab_1 : Adv ;
  nopp_nn_1 : N ;
  noppig_av_1 : A ;
  nopprig_av_1 : A ;
  nor_nn_1 : N ;
  noradrenalin_nn_1 : N ;
  nord_sydlig_av_1 : A ;
  nordamerikan_nn_1 : N ;
  nordamerikansk_av_1 : A ;
  nordan_ab_1 : Adv ;
  nordanland_nn_1 : N ;
  nordanvind_nn_1 : N ;
  nordbo_nn_1 : N ;
  nordgraens_nn_1 : N ;
  nordisk_av_1 : A ;
  nordist_nn_1 : N ;
  nordkorean_nn_1 : N ;
  nordlig_av_1 : A ;
  nordman_nn_1 : N ;
  nordoest_ab_1 : Adv ;
  nordost_ab_1 : Adv ;
  nordpaa_ab_1 : Adv ;
  nordpol_nn_1 : N ;
  nordsluttning_nn_1 : N ;
  nordsvensk_nn_1 : N ;
  nordtysk_av_1 : A ;
  nordvaest_ab_1 : Adv ;
  nordvaestra_av_1 : A ;
  nordvart_ab_1 : Adv ;
  nordvietnamesisk_av_1 : A ;
  nordyemenit_nn_1 : N ;
  norm_nn_1 : N ;
  normal_av_1 : A ;
  normal_nn_1 : N ;
  normalbild_nn_1 : N ;
  normalfaerg_nn_1 : N ;
  normalfilm_nn_1 : N ;
  normalfoerdelning_nn_1 : N ;
  normalgaard_nn_1 : N ;
  normalisering_nn_1 : N ;
  normaliter_ab_1 : Adv ;
  normalitet_nn_1 : N ;
  normalmaanad_nn_1 : N ;
  normalmaatt_nn_1 : N ;
  normalobjektiv_nn_1 : N ;
  normalspaarig_av_1 : A ;
  normalstudietid_nn_1 : N ;
  normaltid_nn_1 : N ;
  normalton_nn_1 : N ;
  normand_nn_1 : N ;
  normandisk_av_1 : A ;
  normativ_av_1 : A ;
  normerande_av_1 : A ;
  normgivande_av_1 : A ;
  normloes_av_1 : A ;
  normloeshet_nn_1 : N ;
  norr_ab_1 : Adv ;
  norra_av_1 : A ;
  norrbagge_nn_1 : N ;
  norrbottning_nn_1 : N ;
  norrbottnisk_av_1 : A ;
  norrgoek_nn_1 : N ;
  norrifraan_ab_1 : Adv ;
  norrkvint_nn_1 : N ;
  norrlaendsk_av_1 : A ;
  norrlaendska_nn_2 : N ;
  norrlaenning_nn_1 : N ;
  norrlandsaelv_nn_1 : N ;
  norrlandshaest_nn_1 : N ;
  norrman_nn_1 : N ;
  norroen_av_1 : A ;
  norroever_ab_1 : Adv ;
  norrpaa_ab_1 : Adv ;
  norrut_ab_1 : Adv ;
  nors_nn_1 : N ;
  norsk_av_1 : A ;
  norska_nn_2 : N ;
  norvagism_nn_1 : N ;
  nos_nn_1 : N ;
  noshjul_nn_1 : N ;
  noshoerning_nn_1 : N ;
  nosig_av_1 : A ;
  noskig_av_1 : A ;
  noskon_nn_1 : N ;
  noskorg_nn_1 : N ;
  noslaengd_nn_1 : N ;
  nosregion_nn_1 : N ;
  nosring_nn_1 : N ;
  nosspets_nn_1 : N ;
  nostalgi_nn_1 : N ;
  nostalgiker_nn_1 : N ;
  nostalgisk_av_1 : A ;
  not_nn_1 : N ;
  not_nn_2 : N ;
  notabel_av_1 : A ;
  notabilitet_nn_1 : N ;
  notariat_nn_1 : N ;
  notariatavdelning_nn_1 : N ;
  notarie_nn_1 : N ;
  notation_nn_1 : N ;
  notblad_nn_1 : N ;
  notdraekt_nn_1 : N ;
  notering_nn_1 : N ;
  notesblock_nn_1 : N ;
  notfast_av_1 : A ;
  notifikation_nn_1 : N ;
  notis_nn_1 : N ;
  notlag_nn_1 : N ;
  notlinje_nn_1 : N ;
  notorietet_nn_1 : N ;
  notorisk_av_1 : A ;
  nototenioid_nn_1 : N ;
  notpapper_nn_1 : N ;
  notplan_nn_1 : N ;
  notrad_nn_1 : N ;
  notsaeker_av_1 : A ;
  notsiffra_nn_1 : N ;
  notskriftstecken_nn_1 : N ;
  notstaal_nn_1 : N ;
  notstaell_nn_1 : N ;
  notvaendare_nn_1 : N ;
  notvaexling_nn_1 : N ;
  notvarp_nn_1 : N ;
  nougat_nn_1 : N ;
  novantik_av_1 : A ;
  novation_nn_1 : N ;
  novautbrott_nn_1 : N ;
  novell_nn_1 : N ;
  novellett_nn_1 : N ;
  novellist_nn_1 : N ;
  novellistisk_av_1 : A ;
  novellsamling_nn_1 : N ;
  novis_nn_1 : N ;
  novitet_nn_1 : N ;
  novitiat_nn_1 : N ;
  nu_ab_1 : Adv ;
  nubb_nn_1 : N ;
  nubbe_nn_1 : N ;
  nubier_nn_1 : N ;
  nubisk_av_1 : A ;
  nuckig_av_1 : A ;
  nudel_nn_1 : N ;
  nudist_nn_1 : N ;
  nudistisk_av_1 : A ;
  nuditet_nn_1 : N ;
  nufoertiden_ab_1 : Adv ;
  nugat_nn_1 : N ;
  nukleaer_av_1 : A ;
  nukleid_nn_1 : N ;
  nuklein_nn_1 : N ;
  nukleon_nn_1 : N ;
  nukleontal_nn_1 : N ;
  nukleotid_nn_1 : N ;
  nuklid_nn_1 : N ;
  nullitet_nn_1 : N ;
  numera_ab_1 : Adv ;
  numeraer_av_1 : A ;
  numeraer_nn_1 : N ;
  numerisk_av_1 : A ;
  numerus_nn_1 : N ;
  numinoes_av_1 : A ;
  numismatiker_nn_1 : N ;
  numismatisk_av_1 : A ;
  nummen_av_1 : A ;
  nummer_nn_1 : N ;
  nummerbyraa_nn_1 : N ;
  nummerhaest_nn_1 : N ;
  nummerkarl_nn_1 : N ;
  nummerplaat_nn_1 : N ;
  nummerrevy_nn_1 : N ;
  nummerskylt_nn_1 : N ;
  nunatak_nn_1 : N ;
  nunnedok_nn_1 : N ;
  nunneoert_nn_1 : N ;
  nuntiatur_nn_1 : N ;
  nuntie_nn_1 : N ;
  nuspraaklig_av_1 : A ;
  nusvensk_av_1 : A ;
  nutida_av_1 : A ;
  nutilldags_ab_1 : Adv ;
  nutritionsorgan_nn_1 : N ;
  nutritiv_av_1 : A ;
  nuvarande_av_1 : A ;
  nuvig_av_1 : A ;
  ny_av_1 : A ;
  ny_nn_1 : N ;
  nyaar_nn_1 : N ;
  nyaarsafton_nn_1 : N ;
  nyaarsboen_nn_1 : N ;
  nyaarsdag_nn_1 : N ;
  nyaarsloefte_nn_1 : N ;
  nyaarsnatt_nn_1 : N ;
  nyanlaeggning_nn_1 : N ;
  nyans_nn_1 : N ;
  nyansering_nn_1 : N ;
  nyanseringstecken_nn_1 : N ;
  nyanskaffning_nn_1 : N ;
  nyantik_av_1 : A ;
  nybearbetning_nn_1 : N ;
  nybildning_nn_1 : N ;
  nybliven_av_1 : A ;
  nyboerjarbok_nn_1 : N ;
  nyboerjare_nn_1 : N ;
  nybruten_av_1 : A ;
  nyburen_av_1 : A ;
  nybyggare_nn_1 : N ;
  nybyggd_av_1 : A ;
  nybyggnad_nn_1 : N ;
  nyck_nn_1 : N ;
  nyckel_nn_1 : N ;
  nyckelaemne_nn_1 : N ;
  nyckelax_nn_1 : N ;
  nyckelbarn_nn_1 : N ;
  nyckelben_nn_1 : N ;
  nyckelblomster_nn_1 : N ;
  nyckelfaerdig_av_1 : A ;
  nyckelfunktion_nn_1 : N ;
  nyckelhaal_nn_1 : N ;
  nyckelindustri_nn_1 : N ;
  nyckelman_nn_1 : N ;
  nyckelord_nn_1 : N ;
  nyckelperson_nn_1 : N ;
  nyckelposition_nn_1 : N ;
  nyckelretning_nn_1 : N ;
  nyckelroll_nn_1 : N ;
  nyckelroman_nn_1 : N ;
  nyckelsten_nn_1 : N ;
  nyckfull_av_1 : A ;
  nydanare_nn_1 : N ;
  nydaning_nn_1 : N ;
  nyemission_nn_1 : N ;
  nyenkel_av_1 : A ;
  nyetablering_nn_1 : N ;
  nyfallen_av_1 : A ;
  nyfiken_av_1 : A ;
  nyfikenhet_nn_1 : N ;
  nyfoedd_av_1 : A ;
  nyfoervaerv_nn_1 : N ;
  nygaangen_av_1 : A ;
  nygift_av_1 : A ;
  nygrad_nn_1 : N ;
  nyhet_nn_1 : N ;
  nyhetsbevakning_nn_1 : N ;
  nyhetsbyraa_nn_1 : N ;
  nyhetstelegram_nn_1 : N ;
  nying_nn_1 : N ;
  nyinkoept_av_1 : A ;
  nyinredd_av_1 : A ;
  nyintagning_nn_1 : N ;
  nyinvestering_nn_1 : N ;
  nyklassicistisk_av_1 : A ;
  nyklassiker_nn_1 : N ;
  nyklassisk_av_1 : A ;
  nykolonisation_nn_1 : N ;
  nykomling_nn_1 : N ;
  nykter_av_1 : A ;
  nykterhet_nn_1 : N ;
  nykterhetsnaemnd_nn_1 : N ;
  nykterhetsroerelse_nn_1 : N ;
  nykterist_nn_1 : N ;
  nylaendsk_av_1 : A ;
  nylaenning_nn_1 : N ;
  nylagd_av_1 : A ;
  nyliberal_av_1 : A ;
  nyligen_ab_1 : Adv ;
  nymf_nn_1 : N ;
  nymfoman_nn_1 : N ;
  nymodig_av_1 : A ;
  nymodighet_nn_1 : N ;
  nynazist_nn_1 : N ;
  nynorsk_av_1 : A ;
  nyodling_nn_1 : N ;
  nyord_nn_1 : N ;
  nyordning_nn_1 : N ;
  nyorientering_nn_1 : N ;
  nyp_nn_1 : N ;
  nypa_vb_1 : V ;
  nyplantering_nn_1 : N ;
  nyplatonsk_av_1 : A ;
  nypon_nn_1 : N ;
  nypremiaer_nn_1 : N ;
  nyproduktion_nn_1 : N ;
  nyrik_av_1 : A ;
  nys_ab_1 : Adv ;
  nyskapare_nn_1 : N ;
  nyskapelse_nn_1 : N ;
  nyskott_nn_1 : N ;
  nysning_nn_1 : N ;
  nysoert_nn_1 : N ;
  nyss_ab_1 : Adv ;
  nystan_nn_1 : N ;
  nystavare_nn_1 : N ;
  nystavning_nn_1 : N ;
  nystpinne_nn_1 : N ;
  nysvensk_av_1 : A ;
  nytaend_av_1 : A ;
  nytaendning_nn_1 : N ;
  nyter_av_1 : A ;
  nytestamentlig_av_1 : A ;
  nytillkommen_av_1 : A ;
  nytillskott_nn_1 : N ;
  nytryck_nn_1 : N ;
  nytta_nn_1 : N ;
  nyttig_av_1 : A ;
  nyttighet_nn_1 : N ;
  nyttjare_nn_1 : N ;
  nyttofoeremaal_nn_1 : N ;
  nyttosynpunkt_nn_1 : N ;
  nyttovaext_nn_1 : N ;
  nyuppsaettning_nn_1 : N ;
  nyupptaeckt_av_1 : A ;
  nyutkommen_av_1 : A ;
  nyutslagen_av_1 : A ;
  nyutsprungen_av_1 : A ;
  nyvaerde_nn_1 : N ;
  nyval_nn_1 : N ;
  nyvald_av_1 : A ;
  nyvorden_av_1 : A ;
  nyvunnen_av_1 : A ;
  nyzeelaendare_nn_1 : N ;
  nyzeelaendsk_av_1 : A ;
  nyzeelaendska_nn_1 : N ;
  nyzeelaenning_nn_1 : N ;
  oaaterkallelig_av_1 : A ;
  oaatkomlig_av_1 : A ;
  oacceptabel_av_1 : A ;
  oaedel_av_1 : A ;
  oaekta_av_1 : A ;
  oaendlig_av_1 : A ;
  oaendlighet_nn_1 : N ;
  oaerlig_av_1 : A ;
  oaerlighet_nn_1 : N ;
  oaetbar_av_1 : A ;
  oaetlig_av_1 : A ;
  oaeven_av_1 : A ;
  oaktsam_av_1 : A ;
  oaktsamhetsbrott_nn_1 : N ;
  oamerikansk_av_1 : A ;
  oandlig_av_1 : A ;
  oanfraett_av_1 : A ;
  oangenaem_av_1 : A ;
  oangripbar_av_1 : A ;
  oangriplig_av_1 : A ;
  oanmaeld_av_1 : A ;
  oanmaerkt_av_1 : A ;
  oansenlig_av_1 : A ;
  oanstaendig_av_1 : A ;
  oansvarig_av_1 : A ;
  oantagbar_av_1 : A ;
  oantaglig_av_1 : A ;
  oantastlig_av_1 : A ;
  oantraeffbar_av_1 : A ;
  oanvaend_av_1 : A ;
  oanvaendbar_av_1 : A ;
  oaptitlig_av_1 : A ;
  oart_nn_1 : N ;
  oartig_av_1 : A ;
  oartighet_nn_1 : N ;
  oas_nn_1 : N ;
  oavbruten_av_1 : A ;
  oavgjord_av_1 : A ;
  oavhaengig_av_1 : A ;
  oavhaengighet_nn_1 : N ;
  oavlaatlig_av_1 : A ;
  oavlaatligen_ab_1 : Adv ;
  oavsaettlig_av_1 : A ;
  oavsedd_av_1 : A ;
  oavsiktlig_av_1 : A ;
  oavvaend_av_1 : A ;
  oavvaent_ab_1 : Adv ;
  oavvisbar_av_1 : A ;
  oavvislig_av_1 : A ;
  oavytterlig_av_1 : A ;
  obaendig_av_1 : A ;
  obarmhaertig_av_1 : A ;
  obducent_nn_1 : N ;
  obduktion_nn_1 : N ;
  obebodd_av_1 : A ;
  obeboelig_av_1 : A ;
  obedd_av_1 : A ;
  obefaren_av_1 : A ;
  obefintlig_av_1 : A ;
  obegriplig_av_1 : A ;
  obegriplighet_nn_1 : N ;
  obehag_nn_1 : N ;
  obehaglig_av_1 : A ;
  obehindrat_ab_1 : Adv ;
  obehoerig_av_1 : A ;
  obehoevlig_av_1 : A ;
  obekant_av_1 : A ;
  obekvaem_av_1 : A ;
  obelisk_nn_1 : N ;
  obemaerkt_av_1 : A ;
  obemaerkthet_nn_1 : N ;
  obenaegen_av_1 : A ;
  oberaeknelig_av_1 : A ;
  oberoende_av_1 : A ;
  oberoerbar_av_1 : A ;
  oberoerd_av_1 : A ;
  obesatt_av_1 : A ;
  obesedd_av_1 : A ;
  obeskrivbar_av_1 : A ;
  obeskrivlig_av_1 : A ;
  obeskuren_av_1 : A ;
  obeslutsam_av_1 : A ;
  obestaellbar_av_1 : A ;
  obestaembar_av_1 : A ;
  obestaembarhet_nn_1 : N ;
  obestaemd_av_1 : A ;
  obestaemdhet_nn_1 : N ;
  obestaemdhetsprincip_nn_1 : N ;
  obestaendig_av_1 : A ;
  obesticklig_av_1 : A ;
  obestridd_av_1 : A ;
  obestridlig_av_1 : A ;
  obestridligen_ab_1 : Adv ;
  obestyrkt_av_1 : A ;
  obetaenksam_av_1 : A ;
  obetaenkt_av_1 : A ;
  obetagen_av_1 : A ;
  obetalbar_av_1 : A ;
  obetald_av_1 : A ;
  obetvinglig_av_1 : A ;
  obetydlig_av_1 : A ;
  obetydligt_ab_1 : Adv ;
  obeveklig_av_1 : A ;
  obildbar_av_1 : A ;
  obillig_av_1 : A ;
  objekt_nn_1 : N ;
  objektglas_nn_1 : N ;
  objektiv_av_1 : A ;
  objektiv_nn_1 : N ;
  objektivism_nn_1 : N ;
  objektivitet_nn_1 : N ;
  objektsform_nn_1 : N ;
  objektspraak_nn_1 : N ;
  objuden_av_1 : A ;
  oblat_nn_1 : N ;
  oblekt_av_1 : A ;
  oblid_av_1 : A ;
  oblidkelig_av_1 : A ;
  obligat_av_1 : A ;
  obligat_nn_1 : N ;
  obligation_nn_1 : N ;
  obligationslaan_nn_1 : N ;
  obligatorisk_av_1 : A ;
  obligatorium_nn_1 : N ;
  oblik_av_1 : A ;
  oblikvitet_nn_1 : N ;
  oblodig_av_1 : A ;
  oblyg_av_1 : A ;
  oboe_nn_1 : N ;
  oboejlig_av_1 : A ;
  oboenhoerlig_av_1 : A ;
  oboenhoerligen_ab_1 : Adv ;
  obol_nn_1 : N ;
  obotfaerdig_av_1 : A ;
  obotlig_av_1 : A ;
  obraend_av_1 : A ;
  obrottslig_av_1 : A ;
  obrukbar_av_1 : A ;
  obruklig_av_1 : A ;
  obrunnen_av_1 : A ;
  obruten_av_1 : A ;
  obrytbar_av_1 : A ;
  obscen_av_1 : A ;
  obscenitet_nn_1 : N ;
  observandum_nn_1 : N ;
  observant_av_1 : A ;
  observation_nn_1 : N ;
  observationsakt_nn_1 : N ;
  observationsklass_nn_1 : N ;
  observationsklinik_nn_1 : N ;
  observationsmaterial_nn_1 : N ;
  observatoer_nn_1 : N ;
  observatorium_nn_1 : N ;
  observerbar_av_1 : A ;
  obsidian_nn_1 : N ;
  obsklass_nn_1 : N ;
  obsklinik_nn_1 : N ;
  obskur_av_1 : A ;
  obskurant_av_1 : A ;
  obskurant_nn_1 : N ;
  obskurantist_nn_1 : N ;
  obskyr_av_1 : A ;
  obsolet_av_1 : A ;
  obstetrisk_av_1 : A ;
  obstinat_av_1 : A ;
  obstruent_nn_1 : N ;
  obstruktion_nn_1 : N ;
  obunden_av_1 : A ;
  obygd_nn_1 : N ;
  obytt_av_1 : A ;
  occasion_nn_1 : N ;
  occidental_av_1 : A ;
  occidentalisk_av_1 : A ;
  ocean_nn_1 : N ;
  oceanisk_av_1 : A ;
  oceanograf_nn_1 : N ;
  oceanografisk_av_1 : A ;
  ock_ab_1 : Adv ;
  ockasion_nn_1 : N ;
  ockasionell_av_1 : A ;
  ocklusion_nn_1 : N ;
  ockrare_nn_1 : N ;
  ocksaa_ab_1 : Adv ;
  ockult_av_1 : A ;
  ockupant_nn_1 : N ;
  ockupation_nn_1 : N ;
  odalisk_nn_1 : N ;
  odalman_nn_1 : N ;
  odaterbar_av_1 : A ;
  odds_nn_1 : N ;
  odefinierbar_av_1 : A ;
  odelbar_av_1 : A ;
  odemokratisk_av_1 : A ;
  odensfly_nn_1 : N ;
  odioes_av_1 : A ;
  odiplomatisk_av_1 : A ;
  odiskutabel_av_1 : A ;
  odisputabel_av_1 : A ;
  odjur_nn_1 : N ;
  odlare_nn_1 : N ;
  odling_nn_1 : N ;
  odlingsbar_av_1 : A ;
  odlingsfoersoek_nn_1 : N ;
  odlingsgraens_nn_1 : N ;
  odoedlig_av_1 : A ;
  odoer_nn_1 : N ;
  odogmatisk_av_1 : A ;
  odon_nn_1 : N ;
  odontolog_nn_1 : N ;
  odontologie_av_1 : A ;
  odontologisk_av_1 : A ;
  odraeglig_av_1 : A ;
  odramatisk_av_1 : A ;
  odriven_av_1 : A ;
  odryg_av_1 : A ;
  oduglig_av_1 : A ;
  odugling_nn_1 : N ;
  odygdig_av_1 : A ;
  odygdspaase_nn_1 : N ;
  odysse_nn_1 : N ;
  oe_nn_2 : N ;
  oede_av_1 : A ;
  oede_nn_1 : N ;
  oedebygdsvaeg_nn_1 : N ;
  oedegaard_nn_1 : N ;
  oedelaeggelse_nn_1 : N ;
  oedem_nn_1 : N ;
  oedemark_nn_1 : N ;
  oedemarksomraade_nn_1 : N ;
  oedematoes_av_1 : A ;
  oedesbestaemd_av_1 : A ;
  oedesdiger_av_1 : A ;
  oedesdrama_nn_1 : N ;
  oedesgudinna_nn_1 : N ;
  oedla_nn_1 : N ;
  oedmjuk_av_1 : A ;
  oedmjukhet_nn_1 : N ;
  oedslig_av_1 : A ;
  oeftergivlig_av_1 : A ;
  oefterhaermlig_av_1 : A ;
  oefterraettlig_av_1 : A ;
  oega_nn_1 : N ;
  oegennytta_nn_1 : N ;
  oegennyttig_av_1 : A ;
  oegentlig_av_1 : A ;
  oegentlighet_nn_1 : N ;
  oegonaboej_ab_1 : Adv ;
  oegonakroek_ab_1 : Adv ;
  oegonblick_nn_1 : N ;
  oegonblicklig_av_1 : A ;
  oegonblickligen_ab_1 : Adv ;
  oegonblicksbild_nn_1 : N ;
  oegonbotten_nn_1 : N ;
  oegonbryn_nn_1 : N ;
  oegondropp_nn_1 : N ;
  oegonfaegnad_nn_1 : N ;
  oegonfaerg_nn_1 : N ;
  oegonfloert_nn_1 : N ;
  oegonfrans_nn_1 : N ;
  oegonfroejd_nn_1 : N ;
  oegonglob_nn_1 : N ;
  oegonhaar_nn_1 : N ;
  oegonhinna_nn_1 : N ;
  oegonkast_nn_1 : N ;
  oegonlock_nn_1 : N ;
  oegonmaerke_nn_1 : N ;
  oegonmuskel_nn_1 : N ;
  oegonprotes_nn_1 : N ;
  oegonroerelse_nn_1 : N ;
  oegonsjukdom_nn_1 : N ;
  oegonskenlig_av_1 : A ;
  oegonskenligen_ab_1 : Adv ;
  oegonspegel_nn_1 : N ;
  oegonsten_nn_1 : N ;
  oegontagg_nn_1 : N ;
  oegontand_nn_1 : N ;
  oegontjaenare_nn_1 : N ;
  oegonvidd_nn_1 : N ;
  oegonvinkel_nn_1 : N ;
  oegonvittne_nn_1 : N ;
  oegonvraa_nn_1 : N ;
  oegrupp_nn_1 : N ;
  oek_nn_1 : N ;
  oekaend_av_1 : A ;
  oeken_nn_1 : N ;
  oekenlandskap_nn_1 : N ;
  oekenvaext_nn_1 : N ;
  oekenvandring_nn_1 : N ;
  oekenvind_nn_1 : N ;
  oeknamn_nn_1 : N ;
  oekning_nn_1 : N ;
  oekonomisk_av_1 : A ;
  oekstock_nn_1 : N ;
  oel_nn_1 : N ;
  oelaendsk_av_1 : A ;
  oelaendska_nn_2 : N ;
  oelaenning_nn_1 : N ;
  oelandshaest_nn_1 : N ;
  oelback_nn_1 : N ;
  oelburk_nn_1 : N ;
  oelgubbe_nn_1 : N ;
  oelhall_nn_1 : N ;
  oeljett_nn_1 : N ;
  oelkafe_nn_1 : N ;
  oeloeppnare_nn_1 : N ;
  oelraettighet_nn_1 : N ;
  oelservering_nn_1 : N ;
  oelstuga_nn_1 : N ;
  oeltillverkning_nn_1 : N ;
  oelutkoerare_nn_1 : N ;
  oem_av_1 : A ;
  oemhet_nn_1 : N ;
  oemkansvaerd_av_1 : A ;
  oemklig_av_1 : A ;
  oemkligen_ab_1 : Adv ;
  oemmande_av_1 : A ;
  oemotsaeglig_av_1 : A ;
  oemotsagd_av_1 : A ;
  oemotstaandlig_av_1 : A ;
  oemottaglig_av_1 : A ;
  oemsesidig_av_1 : A ;
  oemsevis_ab_1 : Adv ;
  oemsint_av_1 : A ;
  oemsom_ab_1 : Adv ;
  oemtaalig_av_1 : A ;
  oenig_av_1 : A ;
  oenighet_nn_1 : N ;
  oense_av_1 : A ;
  oenskedroem_nn_1 : N ;
  oenskemaal_nn_1 : N ;
  oenskering_nn_1 : N ;
  oenskeroll_nn_1 : N ;
  oenskesats_nn_1 : N ;
  oensklig_av_1 : A ;
  oenskning_nn_1 : N ;
  oenskvaerd_av_1 : A ;
  oeppen_av_1 : A ;
  oeppenhet_nn_1 : N ;
  oeppenhjaertig_av_1 : A ;
  oeppnare_nn_1 : N ;
  oeppning_nn_1 : N ;
  oeppningsbud_nn_1 : N ;
  oera_nn_1 : N ;
  oerclips_nn_1 : N ;
  oere_nn_1 : N ;
  oerfaren_av_1 : A ;
  oerfil_nn_1 : N ;
  oerhoerd_av_1 : A ;
  oerike_nn_1 : N ;
  oering_nn_1 : N ;
  oerlogsbas_nn_1 : N ;
  oerlogsfartyg_nn_1 : N ;
  oerlogsman_nn_1 : N ;
  oerlogsmatros_nn_1 : N ;
  oerlogsvarv_nn_1 : N ;
  oermage_nn_1 : N ;
  oern_nn_1 : N ;
  oernbraeken_nn_1 : N ;
  oerngott_nn_1 : N ;
  oeronbedoevande_av_1 : A ;
  oeroninflammation_nn_1 : N ;
  oeronlappsfaatoelj_nn_1 : N ;
  oeronmussla_nn_1 : N ;
  oeronpropp_nn_1 : N ;
  oeronsnibb_nn_1 : N ;
  oeronsusning_nn_1 : N ;
  oerontasslare_nn_1 : N ;
  oerontrumpet_nn_1 : N ;
  oersaettlig_av_1 : A ;
  oersnibb_nn_1 : N ;
  oert_nn_1 : N ;
  oertagaard_nn_1 : N ;
  oertesaeng_nn_1 : N ;
  oertsaeng_nn_1 : N ;
  oertug_nn_1 : N ;
  oeskar_nn_1 : N ;
  oesregn_nn_1 : N ;
  oest_ab_1 : Adv ;
  oest_vaestlig_av_1 : A ;
  oestan_ab_1 : Adv ;
  oester_ab_1 : Adv ;
  oesterbottning_nn_1 : N ;
  oesterbottnisk_av_1 : A ;
  oesterifraan_ab_1 : Adv ;
  oesterlaendsk_av_1 : A ;
  oesterlaenning_nn_1 : N ;
  oesterrikare_nn_1 : N ;
  oesterrikisk_av_1 : A ;
  oestersjoefisk_nn_1 : N ;
  oesterut_ab_1 : Adv ;
  oestetisk_av_1 : A ;
  oesteuropeisk_av_1 : A ;
  oestgoete_nn_1 : N ;
  oestgoetsk_av_1 : A ;
  oestgoetska_nn_2 : N ;
  oestgot_nn_1 : N ;
  oestgotisk_av_1 : A ;
  oestkust_nn_1 : N ;
  oestlig_av_1 : A ;
  oestoever_ab_1 : Adv ;
  oestpaa_ab_1 : Adv ;
  oestra_av_1 : A ;
  oestrogen_nn_1 : N ;
  oeststat_nn_1 : N ;
  oesttysk_av_1 : A ;
  oesttysk_nn_1 : N ;
  oestvart_ab_1 : Adv ;
  oevaerld_nn_1 : N ;
  oever_ab_1 : Adv ;
  oeveraarig_av_1 : A ;
  oeveraenda_ab_1 : Adv ;
  oeverallt_ab_1 : Adv ;
  oeverambitioes_av_1 : A ;
  oeveranstraengning_nn_1 : N ;
  oeverarm_nn_1 : N ;
  oeverbaedd_nn_1 : N ;
  oeverbalansen_ab_1 : Adv ;
  oeverbefaelhavare_nn_1 : N ;
  oeverbelagd_av_1 : A ;
  oeverbetyg_nn_1 : N ;
  oeverbjuda_vb_1 : V ;
  oeverblick_nn_1 : N ;
  oeverbliven_av_1 : A ;
  oeverbord_ab_1 : Adv ;
  oeverbud_nn_1 : N ;
  oeverbyggnad_nn_1 : N ;
  oeverdaad_nn_1 : N ;
  oeverdaadig_av_1 : A ;
  oeverdaengare_nn_1 : N ;
  oeverdel_nn_1 : N ;
  oeverdirektoer_nn_1 : N ;
  oeverdoedlighet_nn_1 : N ;
  oeverdos_nn_1 : N ;
  oeverdra_vb_1 : V ;
  oeverdrag_nn_1 : N ;
  oeverdragsdraekt_nn_1 : N ;
  oeverdrift_nn_1 : N ;
  oeverdriva_vb_1 : V ;
  oeverdriven_av_1 : A ;
  oeverens_ab_1 : Adv ;
  oeverens_av_1 : A ;
  oeverensfyr_nn_1 : N ;
  oeverenskomma_vb_1 : V ;
  oeverenskommelse_nn_1 : N ;
  oeverensstaemmelse_nn_1 : N ;
  oeverfaangsglas_nn_1 : N ;
  oeverfaerd_nn_1 : N ;
  oeverfall_nn_1 : N ;
  oeverfalla_vb_1 : V ;
  oeverfart_nn_1 : N ;
  oeverfloedig_av_1 : A ;
  oeverflygning_nn_1 : N ;
  oeverflyttning_nn_1 : N ;
  oeverfoering_nn_1 : N ;
  oeverfoeringsbild_nn_1 : N ;
  oeverfoermyndare_nn_1 : N ;
  oeverfoertjust_av_1 : A ;
  oeverfull_av_1 : A ;
  oeverfurir_nn_1 : N ;
  oeverfylld_av_1 : A ;
  oevergaaende_av_1 : A ;
  oevergaang_nn_1 : N ;
  oevergaangsaalder_nn_1 : N ;
  oevergaangsmetall_nn_1 : N ;
  oevergaangsmiljoe_nn_1 : N ;
  oevergaangsproblem_nn_1 : N ;
  oevergaangstid_nn_1 : N ;
  oevergaangsverb_nn_1 : N ;
  oeverge_vb_1 : V ;
  oevergiven_av_1 : A ;
  oevergrepp_nn_1 : N ;
  oevergripande_av_1 : A ;
  oeverhaeng_nn_1 : N ;
  oeverhaengande_av_1 : A ;
  oeverhaerdig_av_1 : A ;
  oeverhalning_nn_1 : N ;
  oeverhandsknop_nn_1 : N ;
  oeverhet_nn_1 : N ;
  oeverhetlig_av_1 : A ;
  oeverhettning_nn_1 : N ;
  oeverhoeghet_nn_1 : N ;
  oeverhoevan_ab_1 : Adv ;
  oeverhuvud_ab_1 : Adv ;
  oeverhuvud_nn_1 : N ;
  oeverhuvudtaget_ab_1 : Adv ;
  oeverilning_nn_1 : N ;
  oeveringenjoer_nn_1 : N ;
  oeverinlaerning_nn_1 : N ;
  oeverintendent_nn_1 : N ;
  oeverjaesning_nn_1 : N ;
  oeverjordisk_av_1 : A ;
  oeverkaeke_nn_1 : N ;
  oeverkaeksben_nn_1 : N ;
  oeverkaenslig_av_1 : A ;
  oeverkast_nn_1 : N ;
  oeverklagande_nn_1 : N ;
  oeverklass_nn_1 : N ;
  oeverklassare_nn_1 : N ;
  oeverklassig_av_1 : A ;
  oeverklassmiljoe_nn_1 : N ;
  oeverklivning_nn_1 : N ;
  oeverkoerd_av_1 : A ;
  oeverkomlig_av_1 : A ;
  oeverkragning_nn_1 : N ;
  oeverkropp_nn_1 : N ;
  oeverkucku_nn_1 : N ;
  oeverkurs_nn_1 : N ;
  oeverlaata_vb_1 : V ;
  oeverlaatelse_nn_1 : N ;
  oeverlaege_nn_1 : N ;
  oeverlaeggning_nn_1 : N ;
  oeverlaegsen_av_1 : A ;
  oeverlaegsenhet_nn_1 : N ;
  oeverlaekare_nn_1 : N ;
  oeverlaepp_nn_1 : N ;
  oeverlaerare_nn_1 : N ;
  oeverlag_ab_1 : Adv ;
  oeverlagd_av_1 : A ;
  oeverlakan_nn_1 : N ;
  oeverlapp_nn_1 : N ;
  oeverlappning_nn_1 : N ;
  oeverlevande_av_1 : A ;
  oeverlevnad_nn_1 : N ;
  oeverlevnadschans_nn_1 : N ;
  oeverliggande_av_1 : A ;
  oeverliggare_nn_1 : N ;
  oeverliv_nn_1 : N ;
  oeverljudsfart_nn_1 : N ;
  oeverljudsplan_nn_1 : N ;
  oeverljutt_ab_1 : Adv ;
  oeverloepare_nn_1 : N ;
  oeverloppsgaerning_nn_1 : N ;
  oeverlupen_av_1 : A ;
  oeverlycklig_av_1 : A ;
  oevermaattan_ab_1 : Adv ;
  oevermaektig_av_1 : A ;
  oevermaenniska_nn_1 : N ;
  oevermaensklig_av_1 : A ;
  oevermaett_av_1 : A ;
  oevermaga_av_1 : A ;
  oeverman_nn_1 : N ;
  oevermodig_av_1 : A ;
  oevermogen_av_1 : A ;
  oevernationell_av_1 : A ;
  oevernattning_nn_1 : N ;
  oevernaturlig_av_1 : A ;
  oevernog_ab_1 : Adv ;
  oeverord_nn_1 : N ;
  oeverplagg_nn_1 : N ;
  oeverpris_nn_1 : N ;
  oeverproduktion_nn_1 : N ;
  oeverraett_nn_1 : N ;
  oeverraskning_nn_1 : N ;
  oeverrede_nn_1 : N ;
  oeverrock_nn_1 : N ;
  oeversaate_nn_1 : N ;
  oeversaettare_nn_1 : N ;
  oeversaettning_nn_1 : N ;
  oeversaettningslaan_nn_1 : N ;
  oeversaettningsprov_nn_1 : N ;
  oeverseende_av_1 : A ;
  oeversida_nn_1 : N ;
  oeversiggiven_av_1 : A ;
  oeversikt_nn_1 : N ;
  oeversiktlig_av_1 : A ;
  oeversinnlig_av_1 : A ;
  oeversittare_nn_1 : N ;
  oeversitteri_nn_1 : N ;
  oeverskaadlig_av_1 : A ;
  oeverskaap_nn_1 : N ;
  oeverskeppningsbaat_nn_1 : N ;
  oeverskjutande_av_1 : A ;
  oeverskoeterska_nn_1 : N ;
  oeverskott_nn_1 : N ;
  oeverskrida_vb_1 : V ;
  oeverskrift_nn_1 : N ;
  oeverskruv_nn_1 : N ;
  oeverslaetande_av_1 : A ;
  oeverslag_nn_1 : N ;
  oeverslagsberaekning_nn_1 : N ;
  oeverspaend_av_1 : A ;
  oeverspel_nn_1 : N ;
  oeverstaanden_av_1 : A ;
  oeverstaathaallare_nn_1 : N ;
  oeverste_nn_1 : N ;
  oeversteloejtnant_nn_1 : N ;
  oeverstepraest_nn_1 : N ;
  oeverstiga_vb_1 : V ;
  oeverstiglig_av_1 : A ;
  oeverstroemsskydd_nn_1 : N ;
  oeverstrykning_nn_1 : N ;
  oeverstyrd_av_1 : A ;
  oeversvaemning_nn_1 : N ;
  oeversvallande_av_1 : A ;
  oeversvinnelig_av_1 : A ;
  oeversyn_nn_1 : N ;
  oeversynt_av_1 : A ;
  oeverta_vb_1 : V ;
  oevertaend_av_1 : A ;
  oevertaenkt_av_1 : A ;
  oevertag_nn_1 : N ;
  oevertagande_nn_1 : N ;
  oevertalig_av_1 : A ;
  oevertalning_nn_1 : N ;
  oeverton_nn_1 : N ;
  oevertraedelse_nn_1 : N ;
  oevertramp_nn_1 : N ;
  oevertydlig_av_1 : A ;
  oevertygande_av_1 : A ;
  oevertygelse_nn_1 : N ;
  oevervaaning_nn_1 : N ;
  oevervaegande_av_1 : A ;
  oevervaegande_nn_1 : N ;
  oevervaeldigande_av_1 : A ;
  oevervaexel_nn_1 : N ;
  oevervakare_nn_1 : N ;
  oevervattensfartyg_nn_1 : N ;
  oevervinna_vb_1 : V ;
  oevervuxen_av_1 : A ;
  oevlig_av_1 : A ;
  oevning_nn_1 : N ;
  oevningsaemne_nn_1 : N ;
  oevningslaerare_nn_1 : N ;
  oevningsskjutning_nn_1 : N ;
  oevrig_av_1 : A ;
  ofaerdig_av_1 : A ;
  ofaerg_nn_1 : N ;
  ofantlig_av_1 : A ;
  ofarlig_av_1 : A ;
  ofattbar_av_1 : A ;
  ofattlig_av_1 : A ;
  ofelbar_av_1 : A ;
  off_white_av_1 : A ;
  offensiv_av_1 : A ;
  offensiv_nn_1 : N ;
  offentlig_av_1 : A ;
  offentligen_ab_1 : Adv ;
  offentlighet_nn_1 : N ;
  offer_nn_1 : N ;
  offerent_nn_1 : N ;
  offerfest_nn_1 : N ;
  offerlamm_nn_1 : N ;
  offerrit_nn_1 : N ;
  offerstock_nn_1 : N ;
  offert_nn_1 : N ;
  offertorium_nn_1 : N ;
  officer_nn_1 : N ;
  officerare_nn_1 : N ;
  officersmaess_nn_1 : N ;
  officiant_nn_1 : N ;
  officiell_av_1 : A ;
  officin_nn_1 : N ;
  officinell_av_1 : A ;
  officioes_av_1 : A ;
  offshore_av_1 : A ;
  offside_ab_1 : Adv ;
  ofin_av_1 : A ;
  ofoedd_av_1 : A ;
  ofoer_av_1 : A ;
  ofoeraenderlig_av_1 : A ;
  ofoerarglig_av_1 : A ;
  ofoerbaetterlig_av_1 : A ;
  ofoerbehaallsam_av_1 : A ;
  ofoerberedd_av_1 : A ;
  ofoerbraennelig_av_1 : A ;
  ofoerdelaktig_av_1 : A ;
  ofoerdragsam_av_1 : A ;
  ofoerdroejligen_ab_1 : Adv ;
  ofoerenlig_av_1 : A ;
  ofoeretagsam_av_1 : A ;
  ofoergaetlig_av_1 : A ;
  ofoergloemlig_av_1 : A ;
  ofoergriplig_av_1 : A ;
  ofoerhappandes_ab_1 : Adv ;
  ofoerklarlig_av_1 : A ;
  ofoerlaatlig_av_1 : A ;
  ofoerliknelig_av_1 : A ;
  ofoermaerkt_av_1 : A ;
  ofoermoegen_av_1 : A ;
  ofoerneklig_av_1 : A ;
  ofoernuftig_av_1 : A ;
  ofoerraett_nn_1 : N ;
  ofoersiktig_av_1 : A ;
  ofoerskaemd_av_1 : A ;
  ofoerskaemdhet_nn_1 : N ;
  ofoerskraeckt_av_1 : A ;
  ofoerskylld_av_1 : A ;
  ofoersonlig_av_1 : A ;
  ofoerstaaelig_av_1 : A ;
  ofoerstaaende_av_1 : A ;
  ofoerstaandig_av_1 : A ;
  ofoerstaelld_av_1 : A ;
  ofoerstoerbar_av_1 : A ;
  ofoerstoerd_av_1 : A ;
  ofoersvarlig_av_1 : A ;
  ofoersynt_av_1 : A ;
  ofoertaeckt_av_1 : A ;
  ofoertaenkt_av_1 : A ;
  ofoertjaent_av_1 : A ;
  ofoertroettlig_av_1 : A ;
  ofoertruten_av_1 : A ;
  ofoertydbar_av_1 : A ;
  ofoerutsaegbar_av_1 : A ;
  ofoerutsebar_av_1 : A ;
  ofoerutsedd_av_1 : A ;
  ofoervaegen_av_1 : A ;
  ofoervarandes_ab_1 : Adv ;
  ofoervitlig_av_1 : A ;
  ofoerytterlig_av_1 : A ;
  ofog_nn_1 : N ;
  oformlig_av_1 : A ;
  ofraankomlig_av_1 : A ;
  ofraelse_av_1 : A ;
  oframkomlig_av_1 : A ;
  ofri_av_1 : A ;
  ofrihet_nn_1 : N ;
  ofrivillig_av_1 : A ;
  ofruktbar_av_1 : A ;
  ofruktsam_av_1 : A ;
  ofta_ab_1 : Adv ;
  oftalmi_nn_1 : N ;
  oftalmologisk_av_1 : A ;
  oftalmoskop_nn_1 : N ;
  ofullgaangen_av_1 : A ;
  ofullkomlig_av_1 : A ;
  ofullstaendig_av_1 : A ;
  ofyndig_av_1 : A ;
  ogaerna_ab_1 : Adv ;
  ogaerning_nn_1 : N ;
  ogaestvaenlig_av_1 : A ;
  ogemen_av_1 : A ;
  ogenomfoerbar_av_1 : A ;
  ogenomskinlig_av_1 : A ;
  ogenomslaepplig_av_1 : A ;
  ogenomtaenkt_av_1 : A ;
  ogenomtraenglig_av_1 : A ;
  ogensaeglig_av_1 : A ;
  ogift_av_1 : A ;
  ogiftig_av_1 : A ;
  ogill_ab_1 : Adv ;
  ogill_av_1 : A ;
  ogillande_nn_1 : N ;
  ogiltig_av_1 : A ;
  ogin_av_1 : A ;
  ogjord_av_1 : A ;
  ogoerlig_av_1 : A ;
  ograesfisk_nn_1 : N ;
  ogrammatikalisk_av_1 : A ;
  ogrammatisk_av_1 : A ;
  ogripbar_av_1 : A ;
  ogudaktig_av_1 : A ;
  ogudlig_av_1 : A ;
  ogulden_av_1 : A ;
  ogunstig_av_1 : A ;
  ogynnsam_av_1 : A ;
  ohaallbar_av_1 : A ;
  ohaelsosam_av_1 : A ;
  ohaengd_av_1 : A ;
  ohanterlig_av_1 : A ;
  ohederlig_av_1 : A ;
  ohederlighet_nn_1 : N ;
  ohelig_av_1 : A ;
  ohemul_av_1 : A ;
  oherrans_av_1 : A ;
  ohistorisk_av_1 : A ;
  ohjaelplig_av_1 : A ;
  ohm_nn_1 : N ;
  ohoeljd_av_1 : A ;
  ohoerbar_av_1 : A ;
  ohoerd_av_1 : A ;
  ohoersam_av_1 : A ;
  ohoevlig_av_1 : A ;
  ohygglig_av_1 : A ;
  ohygienisk_av_1 : A ;
  oigenkaennlig_av_1 : A ;
  oigenkaennlighet_nn_1 : N ;
  oinbunden_av_1 : A ;
  oinredd_av_1 : A ;
  oinskraenkt_av_1 : A ;
  ointaglig_av_1 : A ;
  ointelligent_av_1 : A ;
  ointressant_av_1 : A ;
  oinvigd_av_1 : A ;
  ojaemfoerbar_av_1 : A ;
  ojaemfoerlig_av_1 : A ;
  ojaemn_av_1 : A ;
  ojaemnhet_nn_1 : N ;
  ojaevig_av_1 : A ;
  ojust_av_1 : A ;
  ok_nn_1 : N ;
  okaend_av_1 : A ;
  okaenslig_av_1 : A ;
  okaer_av_1 : A ;
  okamratlig_av_1 : A ;
  okapi_nn_1 : N ;
  okbaage_nn_1 : N ;
  okben_nn_1 : N ;
  oklaedd_av_1 : A ;
  oklanderlig_av_1 : A ;
  oklar_av_1 : A ;
  oklarhet_nn_1 : N ;
  oklippt_av_1 : A ;
  oklok_av_1 : A ;
  okokt_av_1 : A ;
  okontant_av_1 : A ;
  okontroversiell_av_1 : A ;
  okonventionell_av_1 : A ;
  okraenkbar_av_1 : A ;
  okristlig_av_1 : A ;
  okritisk_av_1 : A ;
  okroent_av_1 : A ;
  okroppslig_av_1 : A ;
  okrossbar_av_1 : A ;
  oktaeder_nn_1 : N ;
  oktan_nn_1 : N ;
  oktanol_nn_1 : N ;
  oktant_nn_1 : N ;
  oktantal_nn_1 : N ;
  oktanvaerde_nn_1 : N ;
  oktav_nn_1 : N ;
  oktett_nn_1 : N ;
  oktod_nn_1 : N ;
  oktogon_nn_1 : N ;
  oktroj_nn_1 : N ;
  okulaer_av_1 : A ;
  okulage_nn_1 : N ;
  okular_av_1 : A ;
  okular_nn_1 : N ;
  okunnig_av_1 : A ;
  okunnighet_nn_1 : N ;
  okuvlig_av_1 : A ;
  okvaede_nn_1 : N ;
  okvaeden_av_1 : A ;
  okvaedinsord_nn_1 : N ;
  okvald_av_1 : A ;
  okvinnlig_av_1 : A ;
  okynnesfae_nn_1 : N ;
  okynneshund_nn_1 : N ;
  okynnesjakt_nn_1 : N ;
  okynnig_av_1 : A ;
  okyrklig_av_1 : A ;
  okysk_av_1 : A ;
  okysst_av_1 : A ;
  olaast_av_1 : A ;
  olaegenhet_nn_1 : N ;
  olaeglig_av_1 : A ;
  olaeklig_av_1 : A ;
  olaemplig_av_1 : A ;
  olaendig_av_1 : A ;
  olaerd_av_1 : A ;
  olaesbar_av_1 : A ;
  olaeslig_av_1 : A ;
  olaga_av_1 : A ;
  olaglig_av_1 : A ;
  olaglighet_nn_1 : N ;
  olat_nn_1 : N ;
  oldboy_nn_1 : N ;
  oldtimer_nn_1 : N ;
  oleander_nn_1 : N ;
  oleat_nn_1 : N ;
  oleat_nn_2 : N ;
  oledare_nn_1 : N ;
  olefin_nn_1 : N ;
  olidlig_av_1 : A ;
  oligarki_nn_1 : N ;
  oligofag_av_1 : A ;
  oligopol_nn_1 : N ;
  oligotrof_av_1 : A ;
  olik_av_1 : A ;
  olika_ab_1 : Adv ;
  olikhet_nn_1 : N ;
  olikstor_av_1 : A ;
  oliktaenkande_av_1 : A ;
  oliv_nn_1 : N ;
  olivin_nn_1 : N ;
  olivolja_nn_1 : N ;
  olivtraed_nn_1 : N ;
  olja_nn_1 : N ;
  oljeaekta_av_1 : A ;
  oljeaggregat_nn_1 : N ;
  oljebaelte_nn_1 : N ;
  oljebolag_nn_1 : N ;
  oljeborrning_nn_1 : N ;
  oljeborrtorn_nn_1 : N ;
  oljebraennare_nn_1 : N ;
  oljebrand_nn_1 : N ;
  oljebrunn_nn_1 : N ;
  oljebyte_nn_1 : N ;
  oljefaelt_nn_1 : N ;
  oljefaerg_nn_1 : N ;
  oljefilter_nn_1 : N ;
  oljeinpackning_nn_1 : N ;
  oljelaas_nn_1 : N ;
  oljeland_nn_1 : N ;
  oljemaalning_nn_1 : N ;
  oljepalm_nn_1 : N ;
  oljepris_nn_1 : N ;
  oljerik_av_1 : A ;
  oljering_nn_1 : N ;
  oljeriven_av_1 : A ;
  oljesanktion_nn_1 : N ;
  oljeskiffer_nn_1 : N ;
  oljeslageri_nn_1 : N ;
  oljestaell_nn_1 : N ;
  oljestopp_nn_1 : N ;
  oljestroembrytare_nn_1 : N ;
  oljesump_nn_1 : N ;
  oljetanker_nn_1 : N ;
  oljetraag_nn_1 : N ;
  oljetryck_nn_1 : N ;
  oljeutslaepp_nn_1 : N ;
  oljevaev_nn_1 : N ;
  oljevaext_nn_1 : N ;
  oljig_av_1 : A ;
  oljud_nn_1 : N ;
  olle_nn_1 : N ;
  ollon_nn_1 : N ;
  ollonborre_nn_1 : N ;
  ollonmask_nn_1 : N ;
  ollonpistol_nn_1 : N ;
  ollonskog_nn_1 : N ;
  ollonskott_nn_1 : N ;
  ollonsvin_nn_1 : N ;
  ollontraed_nn_1 : N ;
  olm_nn_1 : N ;
  oloensam_av_1 : A ;
  oloent_av_1 : A ;
  oloesbar_av_1 : A ;
  oloeslig_av_1 : A ;
  oloest_av_1 : A ;
  ologisk_av_1 : A ;
  olovandes_ab_1 : Adv ;
  olovlig_av_1 : A ;
  olovligen_ab_1 : Adv ;
  olustig_av_1 : A ;
  olvon_nn_1 : N ;
  olvonvaext_nn_1 : N ;
  olycklig_av_1 : A ;
  olyckligtvis_ab_1 : Adv ;
  olycksalig_av_1 : A ;
  olycksbaadande_av_1 : A ;
  olycksbarn_nn_1 : N ;
  olycksbringande_av_1 : A ;
  olycksbroder_nn_1 : N ;
  olycksdag_nn_1 : N ;
  olycksdiger_av_1 : A ;
  olycksfaagel_nn_1 : N ;
  olycksfall_nn_1 : N ;
  olyckshaendelse_nn_1 : N ;
  olyckskamrat_nn_1 : N ;
  olyckskatastrof_nn_1 : N ;
  olyckskorp_nn_1 : N ;
  olycksplats_nn_1 : N ;
  olycksstatistik_nn_1 : N ;
  olyckstal_nn_1 : N ;
  olydig_av_1 : A ;
  olydnad_nn_1 : N ;
  olympiad_nn_1 : N ;
  olympiasegrare_nn_1 : N ;
  olympier_nn_1 : N ;
  olympisk_av_1 : A ;
  om_ab_1 : Adv ;
  omaattlig_av_1 : A ;
  omaensklig_av_1 : A ;
  omaerklig_av_1 : A ;
  omaetlig_av_1 : A ;
  omaettlig_av_1 : A ;
  omaka_av_1 : A ;
  omanier_nn_1 : N ;
  omanlig_av_1 : A ;
  omansk_av_1 : A ;
  omarbetning_nn_1 : N ;
  ombe_vb_1 : V ;
  ombedja_vb_1 : V ;
  omblad_nn_1 : N ;
  omblandning_nn_1 : N ;
  omblandningsprocess_nn_1 : N ;
  ombord_ab_1 : Adv ;
  ombordlaeggning_nn_1 : N ;
  ombryta_vb_1 : V ;
  ombud_nn_1 : N ;
  ombudsman_nn_1 : N ;
  ombyggnad_nn_1 : N ;
  ombyte_nn_1 : N ;
  ombytlig_av_1 : A ;
  ombytt_av_1 : A ;
  omdaning_nn_1 : N ;
  omdoeme_nn_1 : N ;
  omdoemesfraaga_nn_1 : N ;
  omdoemesgill_av_1 : A ;
  omdoemesloes_av_1 : A ;
  omedelbar_av_1 : A ;
  omedgoerlig_av_1 : A ;
  omedveten_av_1 : A ;
  omedvetenhet_nn_1 : N ;
  omega_nn_1 : N ;
  omelett_nn_1 : N ;
  omen_nn_1 : N ;
  omfaangsrik_av_1 : A ;
  omfamning_nn_1 : N ;
  omfattande_av_1 : A ;
  omfattning_nn_1 : N ;
  omfoederska_nn_1 : N ;
  omfoerdelning_nn_1 : N ;
  omformare_nn_1 : N ;
  omgaaende_ab_1 : Adv ;
  omgaang_nn_1 : N ;
  omge_vb_1 : V ;
  omgestaltning_nn_1 : N ;
  omgift_av_1 : A ;
  omgiv_nn_1 : N ;
  omgivning_nn_1 : N ;
  omgjord_av_1 : A ;
  omhaender_ab_1 : Adv ;
  omhaenderta_vb_1 : V ;
  omhand_ab_1 : Adv ;
  omhopp_nn_1 : N ;
  omigen_ab_1 : Adv ;
  omild_av_1 : A ;
  ominoes_av_1 : A ;
  omintet_ab_1 : Adv ;
  omisskaennlig_av_1 : A ;
  omisstaenksam_av_1 : A ;
  omistlig_av_1 : A ;
  omkast_nn_1 : N ;
  omkastare_nn_1 : N ;
  omklaedning_nn_1 : N ;
  omkoep_nn_1 : N ;
  omkoerning_nn_1 : N ;
  omkoerningsfoerbud_nn_1 : N ;
  omkomma_vb_1 : V ;
  omkopplare_nn_1 : N ;
  omkring_ab_1 : Adv ;
  omkull_ab_1 : Adv ;
  omlaeggning_nn_1 : N ;
  omljud_nn_1 : N ;
  omljudd_av_1 : A ;
  omlopp_nn_1 : N ;
  omloppstid_nn_1 : N ;
  omlott_ab_1 : Adv ;
  omnaemnande_nn_1 : N ;
  omnibus_nn_1 : N ;
  omnifyr_nn_1 : N ;
  omnivor_nn_1 : N ;
  omodern_av_1 : A ;
  omoejlig_av_1 : A ;
  omoejligen_ab_1 : Adv ;
  omoejlighet_nn_1 : N ;
  omogen_av_1 : A ;
  omoralisk_av_1 : A ;
  omotsaeglig_av_1 : A ;
  omotsagd_av_1 : A ;
  omotstaandlig_av_1 : A ;
  omottaglig_av_1 : A ;
  omproevning_nn_1 : N ;
  omraade_nn_1 : N ;
  omriktare_nn_1 : N ;
  omroerning_nn_1 : N ;
  omroestning_nn_1 : N ;
  omsaettning_nn_1 : N ;
  omsaettningstillgaang_nn_1 : N ;
  omsams_ab_1 : Adv ;
  omsegling_nn_1 : N ;
  omsider_ab_1 : Adv ;
  omskaera_vb_1 : V ;
  omskaerelse_nn_1 : N ;
  omskakande_av_1 : A ;
  omskiftare_nn_1 : N ;
  omskiftartangent_nn_1 : N ;
  omskolning_nn_1 : N ;
  omskriva_vb_1 : V ;
  omskriven_av_1 : A ;
  omskrivning_nn_1 : N ;
  omskruten_av_1 : A ;
  omskulpturering_nn_1 : N ;
  omslag_nn_1 : N ;
  omslagsbild_nn_1 : N ;
  omslagspapper_nn_1 : N ;
  omslagsrevers_nn_1 : N ;
  omslut_nn_1 : N ;
  omsluta_vb_1 : V ;
  omslutning_nn_1 : N ;
  omsorg_nn_1 : N ;
  omsorgsfull_av_1 : A ;
  omspel_nn_1 : N ;
  omspinna_vb_1 : V ;
  omstaaende_av_1 : A ;
  omstaellning_nn_1 : N ;
  omstaendighet_nn_1 : N ;
  omstaendlig_av_1 : A ;
  omstart_nn_1 : N ;
  omstigning_nn_1 : N ;
  omstridd_av_1 : A ;
  omstyr_ab_1 : Adv ;
  omsvaengning_nn_1 : N ;
  omsving_nn_1 : N ;
  omta_vb_1 : V ;
  omtaenksam_av_1 : A ;
  omtag_nn_1 : N ;
  omtagning_nn_1 : N ;
  omtal_nn_1 : N ;
  omtryck_nn_1 : N ;
  omtumlande_av_1 : A ;
  omtyckt_av_1 : A ;
  omusikalisk_av_1 : A ;
  omutbar_av_1 : A ;
  omutlig_av_1 : A ;
  omvaardnad_nn_1 : N ;
  omvaeg_nn_1 : N ;
  omvaelvning_nn_1 : N ;
  omvaend_av_1 : A ;
  omvaendbar_av_1 : A ;
  omvaendelse_nn_1 : N ;
  omvaendning_nn_1 : N ;
  omvaendningsfilm_nn_1 : N ;
  omvaendningstecken_nn_1 : N ;
  omvaerdering_nn_1 : N ;
  omvaerld_nn_1 : N ;
  omvaexlande_av_1 : A ;
  omval_nn_1 : N ;
  omvandlare_nn_1 : N ;
  omvandling_nn_1 : N ;
  omyndig_av_1 : A ;
  omyndigfoerklaring_nn_1 : N ;
  omyndighetsfoerklaring_nn_1 : N ;
  onaabar_av_1 : A ;
  onaadig_av_1 : A ;
  onaemnbar_av_1 : A ;
  onager_nn_1 : N ;
  onaturlig_av_1 : A ;
  ond_av_1 : A ;
  ondsint_av_1 : A ;
  ondskefull_av_1 : A ;
  oneklig_av_1 : A ;
  onekligen_ab_1 : Adv ;
  onkel_nn_1 : N ;
  onoedig_av_1 : A ;
  onoedigtvis_ab_1 : Adv ;
  onoejaktig_av_1 : A ;
  onomastisk_av_1 : A ;
  onomatopoetisk_av_1 : A ;
  onormal_av_1 : A ;
  onoslig_av_1 : A ;
  onsdag_nn_1 : N ;
  onsdagskvaell_nn_1 : N ;
  onsdagsmorgon_nn_1 : N ;
  ont_ab_1 : Adv ;
  ontogenetisk_av_1 : A ;
  ontologi_nn_1 : N ;
  onus_nn_1 : N ;
  onykter_av_1 : A ;
  onykterhet_nn_1 : N ;
  onyttig_av_1 : A ;
  onyx_nn_1 : N ;
  ooem_av_1 : A ;
  ooeverbrygglig_av_1 : A ;
  ooeverkomlig_av_1 : A ;
  ooeverlagd_av_1 : A ;
  ooeversaettlig_av_1 : A ;
  ooeverskaadlig_av_1 : A ;
  ooeverstiglig_av_1 : A ;
  ooevertaenkt_av_1 : A ;
  ooevertraefflig_av_1 : A ;
  ooevervaegd_av_1 : A ;
  ooevervinnelig_av_1 : A ;
  oombedd_av_1 : A ;
  oomkullkastlig_av_1 : A ;
  oomkullrunkelig_av_1 : A ;
  oomljudd_av_1 : A ;
  oomskuren_av_1 : A ;
  oomstridd_av_1 : A ;
  oordentlig_av_1 : A ;
  oorganisk_av_1 : A ;
  oortodox_av_1 : A ;
  opaalitlig_av_1 : A ;
  opaatald_av_1 : A ;
  opaaverkbar_av_1 : A ;
  opacitet_nn_1 : N ;
  opak_av_1 : A ;
  opal_nn_1 : N ;
  opaliserande_av_1 : A ;
  oparlamentarisk_av_1 : A ;
  opartisk_av_1 : A ;
  opassande_av_1 : A ;
  opasslig_av_1 : A ;
  opedagogisk_av_1 : A ;
  open_av_1 : A ;
  opera_nn_1 : N ;
  operabalett_nn_1 : N ;
  operabel_av_1 : A ;
  operadike_nn_1 : N ;
  operahus_nn_1 : N ;
  operakompositoer_nn_1 : N ;
  operation_nn_1 : N ;
  operationell_av_1 : A ;
  operationsbas_nn_1 : N ;
  operationsbestick_nn_1 : N ;
  operationslinje_nn_1 : N ;
  operativ_av_1 : A ;
  operativsystem_nn_1 : N ;
  operatoer_nn_1 : N ;
  operator_nn_1 : N ;
  operatris_nn_1 : N ;
  operett_nn_1 : N ;
  operetteater_nn_1 : N ;
  opersonlig_av_1 : A ;
  opiat_nn_1 : N ;
  opinion_nn_1 : N ;
  opinionsbildare_nn_1 : N ;
  opinionsbildning_nn_1 : N ;
  opinionsmaetning_nn_1 : N ;
  opinionsnaemnd_nn_1 : N ;
  opinionsundersoekning_nn_1 : N ;
  opinionsyttring_nn_1 : N ;
  opiumliknande_av_1 : A ;
  opolitisk_av_1 : A ;
  opossum_nn_1 : N ;
  opp_ab_1 : Adv ;
  oppe_ab_1 : Adv ;
  opponent_nn_1 : N ;
  opportun_av_1 : A ;
  opportunist_nn_1 : N ;
  opportunistisk_av_1 : A ;
  opposition_nn_1 : N ;
  oppositionell_av_1 : A ;
  oppositionsledare_nn_1 : N ;
  oppositionsparti_nn_1 : N ;
  opraktisk_av_1 : A ;
  oprecis_av_1 : A ;
  opretentioes_av_1 : A ;
  oproportionerlig_av_1 : A ;
  opsykologisk_av_1 : A ;
  optant_nn_1 : N ;
  optativ_av_1 : A ;
  optativ_nn_1 : N ;
  optiker_nn_1 : N ;
  optimal_av_1 : A ;
  optimist_nn_1 : N ;
  optimistisk_av_1 : A ;
  optimistjolle_nn_1 : N ;
  optimum_nn_1 : N ;
  option_nn_1 : N ;
  optisk_av_1 : A ;
  opulent_av_1 : A ;
  opus_nn_1 : N ;
  or_nn_1 : N ;
  oraad_ab_1 : Adv ;
  oraeknelig_av_1 : A ;
  oraett_av_1 : A ;
  oraett_nn_1 : N ;
  oraettfaangen_av_1 : A ;
  oraettfaerdig_av_1 : A ;
  oraettmaetig_av_1 : A ;
  oraettraadig_av_1 : A ;
  oraettvis_av_1 : A ;
  orakel_nn_1 : N ;
  oral_av_1 : A ;
  orange_av_1 : A ;
  orange_nn_1 : N ;
  orangeri_nn_1 : N ;
  orangutang_nn_1 : N ;
  orant_nn_1 : N ;
  oration_nn_1 : N ;
  orationell_av_1 : A ;
  orator_nn_1 : N ;
  oratorisk_av_1 : A ;
  oratorium_nn_1 : N ;
  orbital_nn_1 : N ;
  ord_nn_1 : N ;
  ordaccent_nn_1 : N ;
  ordagrann_av_1 : A ;
  ordal_nn_1 : N ;
  ordalydelse_nn_1 : N ;
  ordbehandlare_nn_1 : N ;
  ordbild_nn_1 : N ;
  ordbildning_nn_1 : N ;
  ordblind_av_1 : A ;
  ordblindhet_nn_1 : N ;
  ordboejning_nn_1 : N ;
  ordbok_nn_1 : N ;
  ordbyte_nn_1 : N ;
  orddel_nn_1 : N ;
  orddoev_av_1 : A ;
  orden_nn_1 : N ;
  ordenskapitel_nn_1 : N ;
  ordenssaellskap_nn_1 : N ;
  ordentlig_av_1 : A ;
  order_nn_1 : N ;
  orderstock_nn_1 : N ;
  ordfattig_av_1 : A ;
  ordfloede_nn_1 : N ;
  ordfoeljd_nn_1 : N ;
  ordfoerande_nn_1 : N ;
  ordfoerekomst_nn_1 : N ;
  ordfoerklaring_nn_1 : N ;
  ordfoerraad_nn_1 : N ;
  ordfogning_nn_1 : N ;
  ordform_nn_1 : N ;
  ordfot_nn_1 : N ;
  ordgrupp_nn_1 : N ;
  ordhaallig_av_1 : A ;
  ordinaer_av_1 : A ;
  ordinand_nn_1 : N ;
  ordinarie_av_1 : A ;
  ordination_nn_1 : N ;
  ordklass_nn_1 : N ;
  ordklyveri_nn_1 : N ;
  ordknapp_av_1 : A ;
  ordkonstnaer_nn_1 : N ;
  ordkonstruktion_nn_1 : N ;
  ordlek_nn_1 : N ;
  ordloes_av_1 : A ;
  ordning_nn_1 : N ;
  ordningsam_av_1 : A ;
  ordningsbestaemmelse_nn_1 : N ;
  ordningsfoeljd_nn_1 : N ;
  ordningsfoerseelse_nn_1 : N ;
  ordningsfraaga_nn_1 : N ;
  ordningsman_nn_1 : N ;
  ordningspolis_nn_1 : N ;
  ordningsstadga_nn_1 : N ;
  ordningstal_nn_1 : N ;
  ordningsvakt_nn_1 : N ;
  ordonnans_nn_1 : N ;
  ordovicium_nn_1 : N ;
  ordraett_av_1 : A ;
  ordrik_av_1 : A ;
  ordrot_nn_1 : N ;
  ordryttare_nn_1 : N ;
  ordskillnad_nn_1 : N ;
  ordskrift_nn_1 : N ;
  ordslut_nn_1 : N ;
  ordspraak_nn_1 : N ;
  ordstaev_nn_1 : N ;
  ordstam_nn_1 : N ;
  ordstum_av_1 : A ;
  ordtrogen_av_1 : A ;
  ordvaendning_nn_1 : N ;
  ordvaexling_nn_1 : N ;
  ordval_nn_1 : N ;
  ordvits_nn_1 : N ;
  ordvraengare_nn_1 : N ;
  oread_nn_1 : N ;
  orealistisk_av_1 : A ;
  oredig_av_1 : A ;
  oredlig_av_1 : A ;
  oredlighet_nn_1 : N ;
  oregelbunden_av_1 : A ;
  oregelbundenhet_nn_1 : N ;
  oregelmaessig_av_1 : A ;
  oregerlig_av_1 : A ;
  oren_av_1 : A ;
  orenhet_nn_1 : N ;
  orenlig_av_1 : A ;
  orenlighet_nn_1 : N ;
  oresonabel_av_1 : A ;
  oresonlig_av_1 : A ;
  orfisk_av_1 : A ;
  orfism_nn_1 : N ;
  organ_nn_1 : N ;
  organcell_nn_1 : N ;
  organell_nn_1 : N ;
  organisation_nn_1 : N ;
  organisatoer_nn_1 : N ;
  organisatorisk_av_1 : A ;
  organisk_av_1 : A ;
  organism_nn_1 : N ;
  organist_nn_1 : N ;
  organogen_av_1 : A ;
  organum_nn_1 : N ;
  orgasm_nn_1 : N ;
  orgastisk_av_1 : A ;
  orgel_nn_1 : N ;
  orgelharmonium_nn_1 : N ;
  orgelliknande_av_1 : A ;
  orgelregister_nn_1 : N ;
  orgelstaemma_nn_1 : N ;
  orgeltrampare_nn_1 : N ;
  orgiastisk_av_1 : A ;
  orgie_nn_1 : N ;
  oriental_nn_1 : N ;
  orientalisk_av_1 : A ;
  orientalist_nn_1 : N ;
  orienterare_nn_1 : N ;
  orientering_nn_1 : N ;
  orienteringsaemne_nn_1 : N ;
  orienteringspunkt_nn_1 : N ;
  orienteringstaevling_nn_1 : N ;
  orienteringstavla_nn_1 : N ;
  original_nn_1 : N ;
  originalitet_nn_1 : N ;
  originalspraak_nn_1 : N ;
  originaltext_nn_1 : N ;
  originell_av_1 : A ;
  oriktig_av_1 : A ;
  orimlig_av_1 : A ;
  orimlighet_nn_1 : N ;
  orkan_nn_1 : N ;
  orkesloes_av_1 : A ;
  orkester_nn_1 : N ;
  orkesterdike_nn_1 : N ;
  orkesterfoerening_nn_1 : N ;
  orkestermedlem_nn_1 : N ;
  orkesterplats_nn_1 : N ;
  orkestral_av_1 : A ;
  orkide_nn_1 : N ;
  orkidevaext_nn_1 : N ;
  orlovssedel_nn_1 : N ;
  orm_nn_1 : N ;
  ormbaer_nn_1 : N ;
  ormbo_nn_1 : N ;
  ormbunke_nn_1 : N ;
  ormbunksvaext_nn_1 : N ;
  ormdoedare_nn_1 : N ;
  ormgift_nn_1 : N ;
  ormgran_nn_1 : N ;
  ormgrop_nn_1 : N ;
  ormhaar_nn_1 : N ;
  ormknut_nn_1 : N ;
  ormliknande_av_1 : A ;
  ormmaenniska_nn_1 : N ;
  ormoern_nn_1 : N ;
  ormskinn_nn_1 : N ;
  ormslaa_nn_1 : N ;
  ormtjusare_nn_1 : N ;
  ormtunga_nn_1 : N ;
  ormvraak_nn_1 : N ;
  ormyngel_nn_1 : N ;
  ornaesbjoerk_nn_1 : N ;
  ornament_nn_1 : N ;
  ornamental_av_1 : A ;
  ornamentering_nn_1 : N ;
  ornamentist_nn_1 : N ;
  ornat_nn_1 : N ;
  orne_nn_1 : N ;
  ornitolog_nn_1 : N ;
  ornitologisk_av_1 : A ;
  oro_nn_2 : N ;
  oroerbar_av_1 : A ;
  oroerd_av_1 : A ;
  oroerlig_av_1 : A ;
  orogenetisk_av_1 : A ;
  orolig_av_1 : A ;
  orolighet_nn_1 : N ;
  orosaar_nn_1 : N ;
  oroscentrum_nn_1 : N ;
  oroshaerd_nn_1 : N ;
  orosmoln_nn_1 : N ;
  orosstiftare_nn_1 : N ;
  orovaeckande_av_1 : A ;
  orre_nn_1 : N ;
  orrfaagel_nn_1 : N ;
  orrspel_nn_1 : N ;
  orsak_nn_1 : N ;
  orsaklig_av_1 : A ;
  orsaksbestaemd_av_1 : A ;
  orsakskedja_nn_1 : N ;
  orsakskomplex_nn_1 : N ;
  orsaksmaessig_av_1 : A ;
  orsakssamband_nn_1 : N ;
  orsakssammanhang_nn_1 : N ;
  ort_nn_1 : N ;
  ort_nn_2 : N ;
  ort_nn_3 : N ;
  ortdrivare_nn_1 : N ;
  ortikon_nn_1 : N ;
  ortlig_av_1 : A ;
  ortlinje_nn_1 : N ;
  ortnamn_nn_1 : N ;
  ortoceratit_nn_1 : N ;
  ortodox_av_1 : A ;
  ortodoxi_nn_1 : N ;
  ortodoxism_nn_1 : N ;
  ortodrom_nn_1 : N ;
  ortogonal_av_1 : A ;
  ortografi_nn_1 : N ;
  ortokromatisk_av_1 : A ;
  ortolan_nn_1 : N ;
  ortolansparv_nn_1 : N ;
  ortoped_nn_1 : N ;
  ortoptist_nn_1 : N ;
  ortoptris_nn_1 : N ;
  ortsavdrag_nn_1 : N ;
  ortsgrupp_nn_1 : N ;
  ortstid_nn_1 : N ;
  ortstillaegg_nn_1 : N ;
  orubblig_av_1 : A ;
  orund_av_1 : A ;
  orv_nn_1 : N ;
  orygglig_av_1 : A ;
  orytmisk_av_1 : A ;
  oryx_nn_1 : N ;
  os_nn_2 : N ;
  osaald_av_1 : A ;
  osaarbar_av_1 : A ;
  osaegbar_av_1 : A ;
  osaeglig_av_1 : A ;
  osaeker_av_1 : A ;
  osaekerhet_nn_1 : N ;
  osaekerhetsmoment_nn_1 : N ;
  osaeljbar_av_1 : A ;
  osaell_av_1 : A ;
  osaellskaplig_av_1 : A ;
  osaenkbar_av_1 : A ;
  osagd_av_1 : A ;
  osakkunnig_av_1 : A ;
  osaklig_av_1 : A ;
  osalig_av_1 : A ;
  osammanhaengande_av_1 : A ;
  osams_av_1 : A ;
  osann_av_1 : A ;
  osannfaerdig_av_1 : A ;
  osanning_nn_1 : N ;
  osannolik_av_1 : A ;
  oscillation_nn_1 : N ;
  oscillator_nn_1 : N ;
  oscillograf_nn_1 : N ;
  oscillogram_nn_1 : N ;
  oscilloskop_nn_1 : N ;
  osed_nn_1 : N ;
  osedlig_av_1 : A ;
  osedvanlig_av_1 : A ;
  osentimental_av_1 : A ;
  osiktbar_av_1 : A ;
  osiktig_av_1 : A ;
  osinlig_av_1 : A ;
  osinnlig_av_1 : A ;
  osjaelvisk_av_1 : A ;
  osjaelviskhet_nn_1 : N ;
  osjaelvstaendig_av_1 : A ;
  oskadd_av_1 : A ;
  oskadlig_av_1 : A ;
  oskaelig_av_1 : A ;
  oskaplig_av_1 : A ;
  oskarian_nn_1 : N ;
  oskariansk_av_1 : A ;
  oskarp_av_1 : A ;
  oskattbar_av_1 : A ;
  oskick_nn_1 : N ;
  oskicklig_av_1 : A ;
  oskiljaktig_av_1 : A ;
  oskoen_av_1 : A ;
  oskriven_av_1 : A ;
  oskuld_nn_1 : N ;
  oskuldsfull_av_1 : A ;
  oskyld_1_av_1 : A ;
  oskyld_2_av_1 : A ;
  oskyldig_av_1 : A ;
  oslaecklig_av_1 : A ;
  oslaeckt_av_1 : A ;
  oslagbar_av_1 : A ;
  oslagen_av_1 : A ;
  osmaelt_av_1 : A ;
  osmaeltbar_av_1 : A ;
  osmaklig_av_1 : A ;
  osmaklighet_nn_1 : N ;
  osman_nn_1 : N ;
  osmansk_av_1 : A ;
  osmidbar_av_1 : A ;
  osmidig_av_1 : A ;
  osmord_av_1 : A ;
  osmotisk_av_1 : A ;
  osnuten_av_1 : A ;
  osnygg_av_1 : A ;
  osocial_av_1 : A ;
  osoekt_ab_1 : Adv ;
  osoekt_av_1 : A ;
  osolidarisk_av_1 : A ;
  ospard_av_1 : A ;
  ospelbar_av_1 : A ;
  osportslig_av_1 : A ;
  ossuarium_nn_1 : N ;
  ost_ab_1 : Adv ;
  ost_nn_1 : N ;
  ostadig_av_1 : A ;
  ostaemd_av_1 : A ;
  ostaerkt_av_1 : A ;
  ostanfraan_ab_1 : Adv ;
  ostanifraan_ab_1 : Adv ;
  ostensiv_av_1 : A ;
  ostentativ_av_1 : A ;
  osteolog_nn_1 : N ;
  ostframstaellning_nn_1 : N ;
  osthyvel_nn_1 : N ;
  ostig_av_1 : A ;
  ostinato_nn_1 : N ;
  ostindisk_av_1 : A ;
  ostjak_nn_1 : N ;
  ostjakisk_av_1 : A ;
  ostkant_nn_1 : N ;
  ostkraem_nn_1 : N ;
  ostkust_nn_1 : N ;
  ostlig_av_1 : A ;
  ostliknande_av_1 : A ;
  ostmask_nn_1 : N ;
  ostoerd_av_1 : A ;
  ostrafflig_av_1 : A ;
  ostrest_nn_1 : N ;
  ostridig_av_1 : A ;
  ostron_nn_1 : N ;
  ostronbank_nn_1 : N ;
  ostronfoergiftning_nn_1 : N ;
  ostronkniv_nn_1 : N ;
  ostruken_av_1 : A ;
  ostskaerare_nn_1 : N ;
  ostskalk_nn_1 : N ;
  oststaang_nn_1 : N ;
  ostvart_ab_1 : Adv ;
  ostyrig_av_1 : A ;
  ostyrkt_av_1 : A ;
  osund_av_1 : A ;
  osvensk_av_1 : A ;
  osviklig_av_1 : A ;
  osvuren_av_1 : A ;
  osymmetrisk_av_1 : A ;
  osympatisk_av_1 : A ;
  osynlig_av_1 : A ;
  osystematisk_av_1 : A ;
  otaalig_av_1 : A ;
  otacksam_av_1 : A ;
  otadlig_av_1 : A ;
  otaeck_av_1 : A ;
  otaeckhet_nn_1 : N ;
  otaecking_nn_1 : N ;
  otaemd_av_1 : A ;
  otaemjbar_av_1 : A ;
  otaemjd_av_1 : A ;
  otaend_av_1 : A ;
  otaenkbar_av_1 : A ;
  otaet_av_1 : A ;
  otalig_av_1 : A ;
  otalt_av_1 : A ;
  oteknisk_av_1 : A ;
  otidig_av_1 : A ;
  otidighet_nn_1 : N ;
  otidsenlig_av_1 : A ;
  otillaaten_av_1 : A ;
  otillaatlig_av_1 : A ;
  otillboerlig_av_1 : A ;
  otillboerlighet_nn_1 : N ;
  otillfoerlitlig_av_1 : A ;
  otillfreds_av_1 : A ;
  otillfredsstaellande_av_1 : A ;
  otillfredsstaelld_av_1 : A ;
  otillgaenglig_av_1 : A ;
  otillraecklig_av_1 : A ;
  otillraeknelig_av_1 : A ;
  otillstaendig_av_1 : A ;
  otit_nn_1 : N ;
  otjaenlig_av_1 : A ;
  otjaenst_nn_1 : N ;
  otoerstig_av_1 : A ;
  otolog_nn_1 : N ;
  otrevlig_av_1 : A ;
  otrevlighet_nn_1 : N ;
  otrivsam_av_1 : A ;
  otroestlig_av_1 : A ;
  otroettlig_av_1 : A ;
  otrogen_av_1 : A ;
  otrohet_nn_1 : N ;
  otrolig_av_1 : A ;
  otryckbar_av_1 : A ;
  otryckt_av_1 : A ;
  otrygg_av_1 : A ;
  otta_nn_1 : N ;
  ottoman_nn_1 : N ;
  ottomansk_av_1 : A ;
  ottomotor_nn_1 : N ;
  otuktig_av_1 : A ;
  oturlig_av_1 : A ;
  otvetydig_av_1 : A ;
  otvivelaktig_av_1 : A ;
  otvungen_av_1 : A ;
  otydbar_av_1 : A ;
  otydlig_av_1 : A ;
  otymplig_av_1 : A ;
  otypisk_av_1 : A ;
  oumbaerlig_av_1 : A ;
  oundgaenglig_av_1 : A ;
  oundgaengligen_ab_1 : Adv ;
  oundviklig_av_1 : A ;
  oundvikligen_ab_1 : Adv ;
  ouppfattbar_av_1 : A ;
  ouppfylld_av_1 : A ;
  ouppgjord_av_1 : A ;
  oupphinnelig_av_1 : A ;
  oupphoerlig_av_1 : A ;
  oupphoerligen_ab_1 : Adv ;
  oupploeslig_av_1 : A ;
  oupploesligen_ab_1 : Adv ;
  oupplyst_av_1 : A ;
  ouppmaerksam_av_1 : A ;
  ouppnaaelig_av_1 : A ;
  ouppsaatlig_av_1 : A ;
  ouppsaegbar_av_1 : A ;
  ouppskattbar_av_1 : A ;
  ouppskuren_av_1 : A ;
  oupptaeckt_av_1 : A ;
  ouppvaermd_av_1 : A ;
  oursaektlig_av_1 : A ;
  outfoerbar_av_1 : A ;
  outgiven_av_1 : A ;
  outgrundlig_av_1 : A ;
  outhaerdlig_av_1 : A ;
  outhyrd_av_1 : A ;
  outplaanlig_av_1 : A ;
  outrannsaklig_av_1 : A ;
  outrotlig_av_1 : A ;
  outsaegbar_av_1 : A ;
  outsaeglig_av_1 : A ;
  outsagd_av_1 : A ;
  outsider_nn_1 : N ;
  outsinlig_av_1 : A ;
  outslaecklig_av_1 : A ;
  outslitlig_av_1 : A ;
  outspaedd_av_1 : A ;
  outstanding_av_1 : A ;
  outtalbar_av_1 : A ;
  outtoemlig_av_1 : A ;
  outtroettlig_av_1 : A ;
  outvaext_av_1 : A ;
  outvuxen_av_1 : A ;
  ouvertyr_nn_1 : N ;
  ovaalig_av_1 : A ;
  ovaeder_nn_1 : N ;
  ovaeldig_av_1 : A ;
  ovaelkommen_av_1 : A ;
  ovaen_nn_1 : N ;
  ovaenlig_av_1 : A ;
  ovaenlighet_nn_1 : N ;
  ovaenskap_nn_1 : N ;
  ovaerderlig_av_1 : A ;
  ovaerdig_av_1 : A ;
  ovaerldslig_av_1 : A ;
  ovaesentlig_av_1 : A ;
  ovaesentlighet_nn_1 : N ;
  oval_av_1 : A ;
  oval_nn_1 : N ;
  ovan_ab_1 : Adv ;
  ovan_av_1 : A ;
  ovana_nn_1 : N ;
  ovanbords_ab_1 : Adv ;
  ovandel_nn_1 : N ;
  ovanfoer_ab_1 : Adv ;
  ovanifraan_ab_1 : Adv ;
  ovanjordisk_av_1 : A ;
  ovanlig_av_1 : A ;
  ovanlighet_nn_1 : N ;
  ovannaemnd_av_1 : A ;
  ovanpaa_ab_1 : Adv ;
  ovansida_nn_1 : N ;
  ovansklig_av_1 : A ;
  ovanstaaende_av_1 : A ;
  ovantill_ab_1 : Adv ;
  ovanvaaning_nn_1 : N ;
  ovariotomi_nn_1 : N ;
  ovarium_nn_1 : N ;
  ovarsam_av_1 : A ;
  ovation_nn_1 : N ;
  ovederhaeftig_av_1 : A ;
  ovederlaegglig_av_1 : A ;
  ovedersaeglig_av_1 : A ;
  ovedersaegligen_ab_1 : Adv ;
  overall_nn_1 : N ;
  overhead_projektor_nn_1 : N ;
  overheadbild_nn_1 : N ;
  overheadprojektor_nn_1 : N ;
  overklig_av_1 : A ;
  overksam_av_1 : A ;
  overksamhet_nn_1 : N ;
  ovetande_av_1 : A ;
  ovetandes_av_1 : A ;
  ovetbar_av_1 : A ;
  oveten_av_1 : A ;
  ovetenhet_nn_1 : N ;
  ovetenskaplig_av_1 : A ;
  ovettig_av_1 : A ;
  ovettighet_nn_1 : N ;
  ovidkommande_av_1 : A ;
  ovig_av_1 : A ;
  ovigd_av_1 : A ;
  oviktig_av_1 : A ;
  ovillig_av_1 : A ;
  ovillkorlig_av_1 : A ;
  ovillkorligen_ab_1 : Adv ;
  ovipar_av_1 : A ;
  ovis_av_1 : A ;
  oviss_av_1 : A ;
  ovisshet_nn_1 : N ;
  ovulation_nn_1 : N ;
  oxalatsten_nn_1 : N ;
  oxbaer_nn_1 : N ;
  oxblodsroed_av_1 : A ;
  oxdjur_nn_1 : N ;
  oxe_nn_1 : N ;
  oxel_nn_1 : N ;
  oxeltand_nn_1 : N ;
  oxfile_nn_1 : N ;
  oxid_nn_1 : N ;
  oxidation_nn_1 : N ;
  oxidationsmedel_nn_1 : N ;
  oxidationsreaktion_nn_1 : N ;
  oxidationstal_nn_1 : N ;
  oxjaerpe_nn_1 : N ;
  oxlaegg_nn_1 : N ;
  oxoega_nn_1 : N ;
  oxroulad_nn_1 : N ;
  oxstek_nn_1 : N ;
  oxstyng_nn_1 : N ;
  oxtunga_nn_1 : N ;
  oxtungsvamp_nn_1 : N ;
  oxvandring_nn_1 : N ;
  oxvecka_nn_1 : N ;
  oxytocin_nn_1 : N ;
  ozelot_nn_1 : N ;
  ozonhalt_nn_1 : N ;
  ozonmaengd_nn_1 : N ;
  ozonminskning_nn_1 : N ;
  ozonmolekyl_nn_1 : N ;
  ozonreduktion_nn_1 : N ;
  ozonskikt_nn_1 : N ;
  pH_vaerde_nn_1 : N ;
  p_ab_1 : Adv ;
  p_piller_nn_1 : N ;
  p_plats_nn_1 : N ;
  paa_ab_1 : Adv ;
  paaannons_nn_1 : N ;
  paabackning_nn_1 : N ;
  paabjuda_vb_1 : V ;
  paabud_nn_1 : N ;
  paabyggnad_nn_1 : N ;
  paadrag_nn_1 : N ;
  paadrivare_nn_1 : N ;
  paafaagel_nn_1 : N ;
  paafaagelsoega_nn_1 : N ;
  paafallande_av_1 : A ;
  paafart_nn_1 : N ;
  paaflugen_av_1 : A ;
  paafoeljande_av_1 : A ;
  paafoeljd_nn_1 : N ;
  paafrestande_av_1 : A ;
  paafrestning_nn_1 : N ;
  paafund_nn_1 : N ;
  paafyllnadsfoerpackning_nn_1 : N ;
  paafyllning_nn_1 : N ;
  paag_nn_1 : N ;
  paagaaende_av_1 : A ;
  paahaelsning_nn_1 : N ;
  paahaengsvagn_nn_1 : N ;
  paahitt_nn_1 : N ;
  paahittig_av_1 : A ;
  paahopp_nn_1 : N ;
  paahugg_nn_1 : N ;
  paak_nn_1 : N ;
  paakaenning_nn_1 : N ;
  paaklaedare_nn_1 : N ;
  paaklaedd_av_1 : A ;
  paakommen_av_1 : A ;
  paakostande_av_1 : A ;
  paalaegg_nn_1 : N ;
  paalaeggskalv_nn_1 : N ;
  paalandsvind_nn_1 : N ;
  paale_nn_1 : N ;
  paalitlig_av_1 : A ;
  paalkran_nn_1 : N ;
  paalle_nn_1 : N ;
  paalmast_nn_1 : N ;
  paalrot_nn_1 : N ;
  paalstek_nn_1 : N ;
  paaminnelse_nn_1 : N ;
  paaoekt_av_1 : A ;
  paapasslig_av_1 : A ;
  paapekande_nn_1 : N ;
  paaringning_nn_1 : N ;
  paarop_nn_1 : N ;
  paase_nn_1 : N ;
  paasig_av_1 : A ;
  paask_nn_1 : N ;
  paaskaegg_nn_1 : N ;
  paaskafton_nn_1 : N ;
  paaskalamm_nn_1 : N ;
  paaskdag_nn_1 : N ;
  paaskeld_nn_1 : N ;
  paaskhare_nn_1 : N ;
  paaskkaerring_nn_1 : N ;
  paasklilja_nn_1 : N ;
  paaskrift_nn_1 : N ;
  paaskrivet_ab_1 : Adv ;
  paaskrivet_av_1 : A ;
  paasksmaell_nn_1 : N ;
  paaskvecka_nn_1 : N ;
  paaslag_nn_1 : N ;
  paaslakan_nn_1 : N ;
  paastaaelig_av_1 : A ;
  paastaaende_nn_1 : N ;
  paastaaendesats_nn_1 : N ;
  paastoetning_nn_1 : N ;
  paastridig_av_1 : A ;
  paastruken_av_1 : A ;
  paata_vb_1 : V ;
  paataar_nn_1 : N ;
  paataend_av_1 : A ;
  paataenkt_av_1 : A ;
  paatagbar_av_1 : A ;
  paataglig_av_1 : A ;
  paatagning_nn_1 : N ;
  paatraengande_av_1 : A ;
  paatryckare_nn_1 : N ;
  paatryckning_nn_1 : N ;
  paatvinga_vb_1 : V ;
  paave_nn_1 : N ;
  paaver_av_1 : A ;
  paaverkbar_av_1 : A ;
  paaverkning_nn_1 : N ;
  paavevaerdighet_nn_1 : N ;
  paavisbar_av_1 : A ;
  paavisk_av_1 : A ;
  paavlig_av_1 : A ;
  pacemaker_nn_1 : N ;
  pacifist_nn_1 : N ;
  pacifistisk_av_1 : A ;
  packaasna_nn_1 : N ;
  packbox_nn_1 : N ;
  packdjur_nn_1 : N ;
  packe_nn_1 : N ;
  packhus_nn_1 : N ;
  packlaar_nn_1 : N ;
  packning_nn_1 : N ;
  packsadel_nn_1 : N ;
  paddel_nn_1 : N ;
  paddfot_nn_1 : N ;
  paddock_nn_1 : N ;
  paell_nn_1 : N ;
  paels_nn_1 : N ;
  paelsaenger_nn_1 : N ;
  paelsdjur_nn_1 : N ;
  paelsfarm_nn_1 : N ;
  paelsfladdrare_nn_1 : N ;
  paelsjaegare_nn_1 : N ;
  paelssael_nn_1 : N ;
  paelsskinn_nn_1 : N ;
  paer_nn_1 : N ;
  paerlbaat_nn_1 : N ;
  paerlband_nn_1 : N ;
  paerlemorfjaeril_nn_1 : N ;
  paerlemormoln_nn_1 : N ;
  paerlemorskimrande_av_1 : A ;
  paerlgraa_av_1 : A ;
  paerlgryn_nn_1 : N ;
  paerlhyacint_nn_1 : N ;
  paerlmussla_nn_1 : N ;
  paerlspont_nn_1 : N ;
  paerlstav_nn_1 : N ;
  paerlstickning_nn_1 : N ;
  paerm_nn_1 : N ;
  paermbrev_nn_1 : N ;
  paermkarusell_nn_1 : N ;
  paermslukare_nn_1 : N ;
  paeron_nn_1 : N ;
  paers_nn_1 : N ;
  paert_nn_1 : N ;
  paesk_nn_1 : N ;
  paff_av_1 : A ;
  page_nn_1 : N ;
  pagefrisyr_nn_1 : N ;
  paginering_nn_1 : N ;
  pagod_nn_1 : N ;
  paj_av_1 : A ;
  paj_nn_1 : N ;
  pajas_nn_1 : N ;
  pajdeg_nn_1 : N ;
  pajkastning_nn_1 : N ;
  pajsare_nn_1 : N ;
  paket_nn_1 : N ;
  paketauktion_nn_1 : N ;
  paketering_nn_1 : N ;
  paketeringsdisk_nn_1 : N ;
  paketexpedition_nn_1 : N ;
  pakethaallare_nn_1 : N ;
  paketinlaemning_nn_1 : N ;
  paketloesning_nn_1 : N ;
  paketutlaemning_nn_1 : N ;
  pakistan_nn_1 : N ;
  pakistanare_nn_1 : N ;
  pakistansk_av_1 : A ;
  pakistanska_nn_1 : N ;
  pakt_nn_1 : N ;
  paktum_nn_1 : N ;
  paladin_nn_1 : N ;
  palae_nn_1 : N ;
  palatal_av_1 : A ;
  palatal_nn_1 : N ;
  palats_nn_1 : N ;
  palatsrevolution_nn_1 : N ;
  palaver_nn_1 : N ;
  paleoekologisk_av_1 : A ;
  paleograf_nn_1 : N ;
  paleolitisk_av_1 : A ;
  paleontolog_nn_1 : N ;
  paleontologisk_av_1 : A ;
  palestinier_nn_1 : N ;
  palestinsk_av_1 : A ;
  paletaa_nn_1 : N ;
  palett_nn_1 : N ;
  palettkniv_nn_1 : N ;
  palimpsest_nn_1 : N ;
  palindrom_nn_1 : N ;
  palissad_nn_1 : N ;
  paljett_nn_1 : N ;
  pall_ab_1 : Adv ;
  pall_nn_1 : N ;
  pall_nn_2 : N ;
  pallasch_nn_1 : N ;
  palliativ_av_1 : A ;
  palliativ_nn_1 : N ;
  palm_nn_1 : N ;
  palmblad_nn_1 : N ;
  palmett_nn_1 : N ;
  palmhus_nn_1 : N ;
  palmsoendag_nn_1 : N ;
  palmvin_nn_1 : N ;
  palp_nn_1 : N ;
  palpation_nn_1 : N ;
  pals_nn_1 : N ;
  palt_nn_1 : N ;
  paltbroed_nn_1 : N ;
  paltig_av_1 : A ;
  pamflett_nn_1 : N ;
  pamflettist_nn_1 : N ;
  pamp_nn_1 : N ;
  pampig_av_1 : A ;
  pampusch_nn_1 : N ;
  panafrikansk_av_1 : A ;
  panamahatt_nn_1 : N ;
  panaman_nn_1 : N ;
  panamansk_av_1 : A ;
  panamerikansk_av_1 : A ;
  panarabisk_av_1 : A ;
  panasch_nn_1 : N ;
  panaschering_nn_1 : N ;
  pandemi_nn_1 : N ;
  panegyrik_nn_1 : N ;
  panegyrisk_av_1 : A ;
  panel_nn_1 : N ;
  paneldebatt_nn_1 : N ;
  paneldiskussion_nn_1 : N ;
  panering_nn_1 : N ;
  panett_nn_1 : N ;
  panfloejt_nn_1 : N ;
  pang_nn_1 : N ;
  pang_pangfilm_nn_1 : N ;
  panikslagen_av_1 : A ;
  panikunge_nn_1 : N ;
  panisk_av_1 : A ;
  pank_av_1 : A ;
  pankreaskoertel_nn_1 : N ;
  pankreatit_nn_1 : N ;
  pankromatisk_av_1 : A ;
  pannaa_nn_1 : N ;
  pannband_nn_1 : N ;
  pannben_nn_1 : N ;
  pannbiff_nn_1 : N ;
  pannkaksmoln_nn_1 : N ;
  pannkakssmet_nn_1 : N ;
  pannkaksteoretiker_nn_1 : N ;
  pannkaksteori_nn_1 : N ;
  pannlob_nn_1 : N ;
  pannrum_nn_1 : N ;
  pannspegel_nn_1 : N ;
  panoptikon_nn_1 : N ;
  panorama_nn_1 : N ;
  panoramafoenster_nn_1 : N ;
  panoramakamera_nn_1 : N ;
  panorering_nn_1 : N ;
  pansar_nn_1 : N ;
  pansarbil_nn_1 : N ;
  pansarbrytande_av_1 : A ;
  pansarfordon_nn_1 : N ;
  pansargeneral_nn_1 : N ;
  pansargranat_nn_1 : N ;
  pansarhinder_nn_1 : N ;
  pansarmal_nn_1 : N ;
  pansarroer_nn_1 : N ;
  pansarskott_nn_1 : N ;
  pansartrupp_nn_1 : N ;
  pansarvaern_nn_1 : N ;
  pansarvaernsvapen_nn_1 : N ;
  pansarvagn_nn_1 : N ;
  pant_nn_1 : N ;
  pantbank_nn_1 : N ;
  pantbrev_nn_1 : N ;
  panteist_nn_1 : N ;
  panteistisk_av_1 : A ;
  panteon_nn_1 : N ;
  panter_nn_1 : N ;
  panterkatt_nn_1 : N ;
  panterspraang_nn_1 : N ;
  pantfoerskriva_vb_1 : V ;
  panthavare_nn_1 : N ;
  pantlaan_nn_1 : N ;
  pantlaanare_nn_1 : N ;
  pantlaaneroerelse_nn_1 : N ;
  pantograf_nn_1 : N ;
  pantomim_nn_1 : N ;
  pantomimisk_av_1 : A ;
  pantraett_nn_1 : N ;
  pantsaettare_nn_1 : N ;
  papaverin_nn_1 : N ;
  papegojfisk_nn_1 : N ;
  papegojliknande_av_1 : A ;
  papegojtulpan_nn_1 : N ;
  paper_nn_1 : N ;
  papeteri_nn_1 : N ;
  papiljott_nn_1 : N ;
  papill_nn_1 : N ;
  papillom_nn_1 : N ;
  papillon_nn_1 : N ;
  pappa_nn_1 : N ;
  pappaledig_av_1 : A ;
  pappband_nn_1 : N ;
  pappenheimare_nn_1 : N ;
  papper_nn_1 : N ;
  pappersark_nn_1 : N ;
  pappersbit_nn_1 : N ;
  pappersbruk_nn_1 : N ;
  pappersformat_nn_1 : N ;
  pappershandduk_nn_1 : N ;
  pappershandel_nn_1 : N ;
  pappersinsamling_nn_1 : N ;
  papperskasse_nn_1 : N ;
  papperskniv_nn_1 : N ;
  papperskorg_nn_1 : N ;
  papperskvarn_nn_1 : N ;
  papperslapp_nn_1 : N ;
  pappersmaskin_nn_1 : N ;
  pappersnaesduk_nn_1 : N ;
  papperspelle_nn_1 : N ;
  papperspeng_nn_1 : N ;
  papperssax_nn_1 : N ;
  pappersservett_nn_1 : N ;
  papperstallrik_nn_1 : N ;
  papperstiger_nn_1 : N ;
  papperstillverkning_nn_1 : N ;
  papperstuss_nn_1 : N ;
  pappig_av_1 : A ;
  pappskalle_nn_1 : N ;
  pappspik_nn_1 : N ;
  paprika_nn_1 : N ;
  papua_nn_1 : N ;
  papuan_nn_1 : N ;
  papuansk_av_1 : A ;
  papyross_nn_1 : N ;
  papyrus_nn_1 : N ;
  papyrusrulle_nn_1 : N ;
  par_nn_1 : N ;
  parabel_nn_1 : N ;
  parabellum_nn_1 : N ;
  parabolantenn_nn_1 : N ;
  parabolisk_av_1 : A ;
  paracervikalblockad_nn_1 : N ;
  parad_nn_1 : N ;
  paradentit_nn_1 : N ;
  paradexempel_nn_1 : N ;
  paradigm_nn_1 : N ;
  paradis_nn_1 : N ;
  paradisfaagel_nn_1 : N ;
  paradisfroe_nn_1 : N ;
  paradisisk_av_1 : A ;
  paradiskorn_nn_1 : N ;
  paradmaalning_nn_1 : N ;
  paradmarsch_nn_1 : N ;
  paradnummer_nn_1 : N ;
  paradox_nn_1 : N ;
  paradoxal_av_1 : A ;
  paradoxmakare_nn_1 : N ;
  paraduniform_nn_1 : N ;
  paraduppstaellning_nn_1 : N ;
  parafasi_nn_1 : N ;
  parafras_nn_1 : N ;
  parafrastisk_av_1 : A ;
  paragon_nn_1 : N ;
  paragraf_nn_1 : N ;
  paragrafryttare_nn_1 : N ;
  paragraftecken_nn_1 : N ;
  paraguayan_nn_1 : N ;
  paraguayansk_av_1 : A ;
  paraguayare_nn_1 : N ;
  paraguaysk_av_1 : A ;
  parallell_av_1 : A ;
  parallell_nn_1 : N ;
  parallellcirkel_nn_1 : N ;
  parallelldam_nn_1 : N ;
  parallellepiped_nn_1 : N ;
  parallellfall_nn_1 : N ;
  parallellgrad_nn_1 : N ;
  parallellism_nn_1 : N ;
  parallellitet_nn_1 : N ;
  parallellklass_nn_1 : N ;
  parallellkoppling_nn_1 : N ;
  parallellogram_nn_1 : N ;
  parallellstag_nn_1 : N ;
  parallelltrapets_nn_1 : N ;
  paralys_nn_1 : N ;
  paralytiker_nn_1 : N ;
  paralytisk_av_1 : A ;
  parameter_nn_1 : N ;
  paramilitaer_av_1 : A ;
  paranoet_nn_1 : N ;
  paranoiker_nn_1 : N ;
  parant_av_1 : A ;
  parapet_nn_1 : N ;
  paraply_nn_1 : N ;
  paraplyliknande_av_1 : A ;
  paraplyorganisation_nn_1 : N ;
  paraplytak_nn_1 : N ;
  parasit_nn_1 : N ;
  parasitaer_av_1 : A ;
  parasitisk_av_1 : A ;
  parasoll_nn_1 : N ;
  parat_av_1 : A ;
  parataktisk_av_1 : A ;
  paravan_nn_1 : N ;
  parbladig_av_1 : A ;
  parce_nn_1 : N ;
  parcell_nn_1 : N ;
  pardans_nn_1 : N ;
  parentation_nn_1 : N ;
  parentator_nn_1 : N ;
  parentes_nn_1 : N ;
  parentestecken_nn_1 : N ;
  parentetisk_av_1 : A ;
  parerplaat_nn_1 : N ;
  parerstaang_nn_1 : N ;
  pares_nn_1 : N ;
  parfait_nn_1 : N ;
  parflikig_av_1 : A ;
  parfym_nn_1 : N ;
  parfymaffaer_nn_1 : N ;
  parfymeri_nn_1 : N ;
  parhaest_nn_1 : N ;
  parhus_nn_1 : N ;
  paria_nn_1 : N ;
  parig_av_1 : A ;
  pariserhjul_nn_1 : N ;
  parisersmoergaas_nn_1 : N ;
  parisisk_av_1 : A ;
  paritet_nn_1 : N ;
  park_nn_1 : N ;
  parkas_nn_1 : N ;
  parkering_nn_1 : N ;
  parkeringsautomat_nn_1 : N ;
  parkeringsavgift_nn_1 : N ;
  parkeringsbot_nn_1 : N ;
  parkeringshus_nn_1 : N ;
  parkeringsljus_nn_1 : N ;
  parkeringsplats_nn_1 : N ;
  parkeringsvakt_nn_1 : N ;
  parkett_nn_1 : N ;
  parkettgolv_nn_1 : N ;
  parkettstav_nn_1 : N ;
  parlament_nn_1 : N ;
  parlamentaer_nn_1 : N ;
  parlamentariker_nn_1 : N ;
  parlamentarisk_av_1 : A ;
  parlando_ab_1 : Adv ;
  parlando_nn_1 : N ;
  parloer_nn_1 : N ;
  parnass_nn_1 : N ;
  parning_nn_1 : N ;
  parningsdraekt_nn_1 : N ;
  parningsdrift_nn_1 : N ;
  parningslek_nn_1 : N ;
  parningsorgan_nn_1 : N ;
  parodi_nn_1 : N ;
  parodiker_nn_1 : N ;
  parodisk_av_1 : A ;
  parodontit_nn_1 : N ;
  paroll_nn_1 : N ;
  paroxysm_nn_1 : N ;
  parser_nn_1 : N ;
  parspel_nn_1 : N ;
  parstuga_nn_1 : N ;
  part_nn_1 : N ;
  partaaig_av_1 : A ;
  partaj_nn_1 : N ;
  parterr_nn_1 : N ;
  parti_nn_1 : N ;
  partialton_nn_1 : N ;
  partialtryck_nn_1 : N ;
  partiapparat_nn_1 : N ;
  partiblock_nn_1 : N ;
  partichef_nn_1 : N ;
  particip_nn_1 : N ;
  participiell_av_1 : A ;
  partidisciplin_nn_1 : N ;
  partiell_av_1 : A ;
  partifaerg_nn_1 : N ;
  partigaengare_nn_1 : N ;
  partigrupp_nn_1 : N ;
  partikamrat_nn_1 : N ;
  partikel_nn_1 : N ;
  partikelaccelerator_nn_1 : N ;
  partikelegenskap_nn_1 : N ;
  partikelfysiker_nn_1 : N ;
  partikellaboratorium_nn_1 : N ;
  partikellock_nn_1 : N ;
  partikelreaktion_nn_1 : N ;
  partikelregn_nn_1 : N ;
  partikongress_nn_1 : N ;
  partikulaer_av_1 : A ;
  partikuljaer_av_1 : A ;
  partiledare_nn_1 : N ;
  partiledning_nn_1 : N ;
  partiloes_av_1 : A ;
  partimedlem_nn_1 : N ;
  partiordfoerande_nn_1 : N ;
  partiorgan_nn_1 : N ;
  partipolitisk_av_1 : A ;
  partipris_nn_1 : N ;
  partiprogram_nn_1 : N ;
  partisan_nn_1 : N ;
  partisekreterare_nn_1 : N ;
  partisk_av_1 : A ;
  partiskhet_nn_1 : N ;
  partispaerr_nn_1 : N ;
  partispraengning_nn_1 : N ;
  partitiv_av_1 : A ;
  partitrohet_nn_1 : N ;
  partitur_nn_1 : N ;
  partner_nn_1 : N ;
  partout_ab_1 : Adv ;
  partsbehoerighet_nn_1 : N ;
  partsorgan_nn_1 : N ;
  party_nn_1 : N ;
  parvel_nn_1 : N ;
  parveny_nn_1 : N ;
  parvis_ab_1 : Adv ;
  pascal_nn_1 : N ;
  paskill_nn_1 : N ;
  pass_nn_1 : N ;
  passabel_av_1 : A ;
  passad_nn_1 : N ;
  passadvind_nn_1 : N ;
  passage_nn_1 : N ;
  passagerarbaat_nn_1 : N ;
  passagerare_nn_1 : N ;
  passagerarflyg_nn_1 : N ;
  passagerarflygplan_nn_1 : N ;
  passagerarsalong_nn_1 : N ;
  passande_av_1 : A ;
  passare_nn_1 : N ;
  passbaat_nn_1 : N ;
  passbit_nn_1 : N ;
  passe_av_1 : A ;
  passepartout_nn_1 : N ;
  passering_nn_1 : N ;
  passersedel_nn_1 : N ;
  passfoto_nn_1 : N ;
  passfrihet_nn_1 : N ;
  passgaangare_nn_1 : N ;
  passion_nn_1 : N ;
  passionsfrukt_nn_1 : N ;
  passionshistoria_nn_1 : N ;
  passionsspel_nn_1 : N ;
  passiv_av_1 : A ;
  passiva_nn_1 : N ;
  passivitet_nn_1 : N ;
  passivum_nn_1 : N ;
  passlig_av_1 : A ;
  passning_nn_1 : N ;
  passopp_nn_1 : N ;
  passpoal_nn_1 : N ;
  passus_nn_1 : N ;
  pastej_nn_1 : N ;
  pastell_nn_1 : N ;
  pastellfaerg_nn_1 : N ;
  pastellmaalning_nn_1 : N ;
  pastill_nn_1 : N ;
  pastisch_nn_1 : N ;
  pastoerisering_nn_1 : N ;
  pastoes_av_1 : A ;
  pastor_nn_1 : N ;
  pastoral_av_1 : A ;
  pastoral_nn_1 : N ;
  pastorat_nn_1 : N ;
  pastoratsadjunkt_nn_1 : N ;
  pastorsadjunkt_nn_1 : N ;
  pastorsexpedition_nn_1 : N ;
  pastos_av_1 : A ;
  pate_nn_1 : N ;
  paten_nn_1 : N ;
  patent_nn_1 : N ;
  patentlaas_nn_1 : N ;
  patentmedicin_nn_1 : N ;
  patentsmoergaas_nn_1 : N ;
  pater_nn_1 : N ;
  paternoster_nn_1 : N ;
  paternosterhiss_nn_1 : N ;
  paternosterverk_nn_1 : N ;
  patetisk_av_1 : A ;
  patiens_nn_1 : N ;
  patient_nn_1 : N ;
  patientplaat_nn_1 : N ;
  patogen_av_1 : A ;
  patolog_nn_1 : N ;
  patologi_nn_1 : N ;
  patologisk_av_1 : A ;
  patriark_nn_1 : N ;
  patriarkalisk_av_1 : A ;
  patriarkat_nn_1 : N ;
  patricier_nn_1 : N ;
  patriot_nn_1 : N ;
  patriotisk_av_1 : A ;
  patris_nn_1 : N ;
  patron_nn_1 : N ;
  patron_nn_2 : N ;
  patronbaelte_nn_1 : N ;
  patronymikon_nn_1 : N ;
  patrull_nn_1 : N ;
  patrullbaat_nn_1 : N ;
  patt_nn_1 : N ;
  patt_nn_2 : N ;
  paulun_nn_1 : N ;
  paus_nn_1 : N ;
  pausfaagel_nn_1 : N ;
  paussignal_nn_1 : N ;
  paustecken_nn_1 : N ;
  pavane_nn_1 : N ;
  paviljong_nn_1 : N ;
  peang_nn_1 : N ;
  pedagog_nn_1 : N ;
  pedagogisk_av_1 : A ;
  pedal_nn_1 : N ;
  pedant_nn_1 : N ;
  pedanteri_nn_1 : N ;
  pedantisk_av_1 : A ;
  pedell_nn_1 : N ;
  pederast_nn_1 : N ;
  pediatriker_nn_1 : N ;
  pediatrisk_av_1 : A ;
  pedikyrist_nn_1 : N ;
  pediment_nn_1 : N ;
  pegas_nn_1 : N ;
  pegel_nn_1 : N ;
  pegmatit_nn_1 : N ;
  pejling_nn_1 : N ;
  pejorativ_av_1 : A ;
  pejorativ_nn_1 : N ;
  pekannoet_nn_1 : N ;
  pekare_nn_1 : N ;
  pekbok_nn_1 : N ;
  pekfinger_nn_1 : N ;
  pekfingertest_nn_1 : N ;
  pekines_nn_1 : N ;
  pekoral_nn_1 : N ;
  pekoralist_nn_1 : N ;
  pekoralistisk_av_1 : A ;
  pekpinne_nn_1 : N ;
  pektaa_nn_1 : N ;
  pektin_nn_1 : N ;
  pekuniaer_av_1 : A ;
  pelagisk_av_1 : A ;
  pelarbord_nn_1 : N ;
  pelare_nn_1 : N ;
  pelarformig_av_1 : A ;
  pelargaang_nn_1 : N ;
  pelargon_nn_1 : N ;
  pelargonia_nn_1 : N ;
  pelarhall_nn_1 : N ;
  pelarhelgon_nn_1 : N ;
  pelarsal_nn_1 : N ;
  pelerin_nn_1 : N ;
  pelikan_nn_1 : N ;
  pellejoens_nn_1 : N ;
  pellet_nn_1 : N ;
  pen_nn_1 : N ;
  pendang_nn_1 : N ;
  pendel_nn_1 : N ;
  pendelavstaand_nn_1 : N ;
  pendeltaag_nn_1 : N ;
  pendelur_nn_1 : N ;
  pendlare_nn_1 : N ;
  pendyl_nn_1 : N ;
  penetration_nn_1 : N ;
  peng_nn_1 : N ;
  penibel_av_1 : A ;
  penicillin_nn_1 : N ;
  penis_nn_1 : N ;
  penisattrapp_nn_1 : N ;
  penjoar_nn_1 : N ;
  pennalist_nn_1 : N ;
  penndrag_nn_1 : N ;
  pennfaektare_nn_1 : N ;
  pennformerare_nn_1 : N ;
  penni_nn_1 : N ;
  penning_nn_1 : N ;
  penningfoersaendelse_nn_1 : N ;
  penninglaan_nn_1 : N ;
  penninglott_nn_1 : N ;
  penningmarknad_nn_1 : N ;
  penningstinn_av_1 : A ;
  penningsumma_nn_1 : N ;
  penningsystem_nn_1 : N ;
  penningtilldelning_nn_1 : N ;
  penningtransaktion_nn_1 : N ;
  pennkniv_nn_1 : N ;
  pennskaft_nn_1 : N ;
  pennteckning_nn_1 : N ;
  pennvaessare_nn_1 : N ;
  penny_nn_1 : N ;
  pense_nn_1 : N ;
  pensel_nn_1 : N ;
  penseldrag_nn_1 : N ;
  pension_nn_1 : N ;
  pensionaer_nn_1 : N ;
  pensionaerslaegenhet_nn_1 : N ;
  pensionat_nn_1 : N ;
  pensionsaalder_nn_1 : N ;
  pensionsbrev_nn_1 : N ;
  pensionsfoersaekring_nn_1 : N ;
  pensionsgrundande_av_1 : A ;
  pensionspoaeng_nn_1 : N ;
  pensionssparande_nn_1 : N ;
  pensum_nn_1 : N ;
  pentagram_nn_1 : N ;
  pentameter_nn_1 : N ;
  pentry_nn_1 : N ;
  penultima_nn_1 : N ;
  peon_nn_1 : N ;
  pepparkaksgris_nn_1 : N ;
  pepparkaksgubbe_nn_1 : N ;
  pepparkakshus_nn_1 : N ;
  pepparkorn_nn_1 : N ;
  pepparkvarn_nn_1 : N ;
  peptid_nn_1 : N ;
  perborat_nn_1 : N ;
  perception_nn_1 : N ;
  perceptuell_av_1 : A ;
  peremtorisk_av_1 : A ;
  perenn_av_1 : A ;
  perenn_nn_1 : N ;
  perfekt_av_1 : A ;
  perfektionist_nn_1 : N ;
  perfektiv_av_1 : A ;
  perfektivisk_av_1 : A ;
  perfektparticip_nn_1 : N ;
  perfektum_nn_1 : N ;
  perfiditet_nn_1 : N ;
  perforation_nn_1 : N ;
  perforator_nn_1 : N ;
  perforering_nn_1 : N ;
  pergament_nn_1 : N ;
  pergamentband_nn_1 : N ;
  pergamentbrev_nn_1 : N ;
  pergamentrulle_nn_1 : N ;
  perifer_av_1 : A ;
  periferi_nn_1 : N ;
  perifon_nn_1 : N ;
  perifras_nn_1 : N ;
  perifrastisk_av_1 : A ;
  perimeter_nn_1 : N ;
  perinatal_av_1 : A ;
  period_nn_1 : N ;
  periodare_nn_1 : N ;
  periodicitet_nn_1 : N ;
  periodisk_av_1 : A ;
  periodsupare_nn_1 : N ;
  periodtal_nn_1 : N ;
  periodvis_ab_1 : Adv ;
  peripeti_nn_1 : N ;
  periskop_nn_1 : N ;
  periskopisk_av_1 : A ;
  peristaltisk_av_1 : A ;
  peristyl_nn_1 : N ;
  peritonit_nn_1 : N ;
  perkal_nn_1 : N ;
  perkolator_nn_1 : N ;
  perkussion_nn_1 : N ;
  perkussionsinstrument_nn_1 : N ;
  perkutan_av_1 : A ;
  permanent_av_1 : A ;
  permeabel_av_1 : A ;
  permeabilitet_nn_1 : N ;
  permission_nn_1 : N ;
  permittent_nn_1 : N ;
  permittering_nn_1 : N ;
  permutation_nn_1 : N ;
  pernicioes_av_1 : A ;
  peroxid_nn_1 : N ;
  perpendikel_nn_1 : N ;
  perpendikulaer_av_1 : A ;
  perpetuell_av_1 : A ;
  perplex_av_1 : A ;
  perrong_nn_1 : N ;
  persedel_nn_1 : N ;
  perser_nn_1 : N ;
  persianpaels_nn_1 : N ;
  persienn_nn_1 : N ;
  persimon_nn_1 : N ;
  persisk_av_1 : A ;
  persiska_nn_2 : N ;
  person_nn_1 : N ;
  personage_nn_1 : N ;
  personal_nn_1 : N ;
  personal_nn_2 : N ;
  personalavdelning_nn_1 : N ;
  personalchef_nn_1 : N ;
  personalfraaga_nn_1 : N ;
  personalia_nn_1 : N ;
  personalingaang_nn_1 : N ;
  personallaekare_nn_1 : N ;
  personalmatsal_nn_1 : N ;
  personalorganisation_nn_1 : N ;
  personalrum_nn_1 : N ;
  personaltidning_nn_1 : N ;
  personalunion_nn_1 : N ;
  personalutbildare_nn_1 : N ;
  personalvaard_nn_1 : N ;
  personbevis_nn_1 : N ;
  personbil_nn_1 : N ;
  persondator_nn_1 : N ;
  personell_av_1 : A ;
  personfoersaekring_nn_1 : N ;
  personfraaga_nn_1 : N ;
  persongalleri_nn_1 : N ;
  personhistorisk_av_1 : A ;
  personifikation_nn_1 : N ;
  personkilometer_nn_1 : N ;
  personkontakt_nn_1 : N ;
  personkonto_nn_1 : N ;
  personkult_nn_1 : N ;
  personlig_av_1 : A ;
  personligen_ab_1 : Adv ;
  personlighet_nn_1 : N ;
  personlighetstyp_nn_1 : N ;
  personnamn_nn_1 : N ;
  personnummer_nn_1 : N ;
  personpolitisk_av_1 : A ;
  personregister_nn_1 : N ;
  personsoekare_nn_1 : N ;
  persontaag_nn_1 : N ;
  personundersoekning_nn_1 : N ;
  personuppgift_nn_1 : N ;
  personvaag_nn_1 : N ;
  personvagn_nn_1 : N ;
  personval_nn_1 : N ;
  perspektiv_nn_1 : N ;
  perspektivbild_nn_1 : N ;
  perspektivfoenster_nn_1 : N ;
  perspektivfoerskjutning_nn_1 : N ;
  perspektivisk_av_1 : A ;
  perspektivloes_av_1 : A ;
  perturbation_nn_1 : N ;
  peruan_nn_1 : N ;
  peruansk_av_1 : A ;
  peruanska_nn_1 : N ;
  peruk_nn_1 : N ;
  perukmakare_nn_1 : N ;
  perukstock_nn_1 : N ;
  pervers_av_1 : A ;
  perversion_nn_1 : N ;
  perversitet_nn_1 : N ;
  peseta_nn_1 : N ;
  peso_nn_1 : N ;
  pessar_nn_1 : N ;
  pessimist_nn_1 : N ;
  pessimistisk_av_1 : A ;
  pest_nn_1 : N ;
  pesticid_nn_1 : N ;
  pestilens_nn_1 : N ;
  petig_av_1 : A ;
  petimaeter_nn_1 : N ;
  petit_chou_nn_1 : N ;
  petitchou_nn_1 : N ;
  petitess_nn_1 : N ;
  petition_nn_1 : N ;
  petmoj_nn_1 : N ;
  petnoga_av_1 : A ;
  petrifikat_nn_1 : N ;
  petrokemisk_av_1 : A ;
  petsaeker_av_1 : A ;
  pfennig_nn_1 : N ;
  pi_nn_1 : N ;
  piaff_nn_1 : N ;
  pianino_nn_1 : N ;
  pianissimo_ab_1 : Adv ;
  pianissimo_nn_1 : N ;
  pianist_nn_1 : N ;
  piano_ab_1 : Adv ;
  piano_nn_1 : N ;
  pianokonsert_nn_1 : N ;
  pianosonat_nn_1 : N ;
  pianospel_nn_1 : N ;
  pianostol_nn_1 : N ;
  piassavakvast_nn_1 : N ;
  piaster_nn_1 : N ;
  picador_nn_1 : N ;
  piccolafloejt_nn_1 : N ;
  piccolo_nn_1 : N ;
  picknick_nn_1 : N ;
  pickup_nn_1 : N ;
  picot_nn_1 : N ;
  pidgin_nn_1 : N ;
  piedestal_nn_1 : N ;
  pierrot_nn_1 : N ;
  pietet_nn_1 : N ;
  pietetsfull_av_1 : A ;
  pietist_nn_1 : N ;
  piffig_av_1 : A ;
  pigg_av_1 : A ;
  pigg_nn_1 : N ;
  piggelin_av_1 : A ;
  pigghaj_nn_1 : N ;
  piggsvin_nn_1 : N ;
  piggvar_nn_1 : N ;
  pigment_nn_1 : N ;
  pigroman_nn_1 : N ;
  pigtittare_nn_1 : N ;
  pigtjusare_nn_1 : N ;
  pik_nn_1 : N ;
  pikador_nn_1 : N ;
  pikant_av_1 : A ;
  pikanteri_nn_1 : N ;
  pikaresk_nn_1 : N ;
  pikareskroman_nn_1 : N ;
  pike_nn_1 : N ;
  piket_nn_1 : N ;
  piketbil_nn_1 : N ;
  pikoer_nn_1 : N ;
  pikstav_nn_1 : N ;
  piktur_nn_1 : N ;
  pil_nn_1 : N ;
  pilaff_nn_1 : N ;
  pilaster_nn_1 : N ;
  pilbaage_nn_1 : N ;
  pilfink_nn_1 : N ;
  pilgrim_nn_1 : N ;
  pilgrimsfaerd_nn_1 : N ;
  pilgrimsfalk_nn_1 : N ;
  pilgrimsstav_nn_1 : N ;
  pilk_nn_1 : N ;
  pilkastning_nn_1 : N ;
  pilkoger_nn_1 : N ;
  pilleknarkare_nn_1 : N ;
  pillemarisk_av_1 : A ;
  piller_nn_1 : N ;
  pillerbagge_nn_1 : N ;
  pillerburk_nn_1 : N ;
  pillertrillare_nn_1 : N ;
  pillrig_av_1 : A ;
  pilot_nn_1 : N ;
  pilotballong_nn_1 : N ;
  pilotstudie_nn_1 : N ;
  pilsk_av_1 : A ;
  pilsnabb_av_1 : A ;
  pilsner_nn_1 : N ;
  pilsnerfilm_nn_1 : N ;
  pilsnerkorv_nn_1 : N ;
  pilspets_nn_1 : N ;
  pilt_nn_1 : N ;
  piltraed_nn_1 : N ;
  pimpel_nn_1 : N ;
  pimpelspoe_nn_1 : N ;
  pimpinett_av_1 : A ;
  pin_ab_1 : Adv ;
  pinakotek_nn_1 : N ;
  pinal_nn_1 : N ;
  pincene_nn_1 : N ;
  pincett_nn_1 : N ;
  pingla_nn_1 : N ;
  pingpongboll_nn_1 : N ;
  pingst_nn_1 : N ;
  pingstafton_nn_1 : N ;
  pingstdag_nn_1 : N ;
  pingsthelg_nn_1 : N ;
  pingstlilja_nn_1 : N ;
  pingstvaen_nn_1 : N ;
  pingvin_nn_1 : N ;
  pinje_nn_1 : N ;
  pinjenoet_nn_1 : N ;
  pinjong_nn_1 : N ;
  pinknoedig_av_1 : A ;
  pinlig_av_1 : A ;
  pinne_nn_1 : N ;
  pinnhaal_nn_1 : N ;
  pinnharv_nn_1 : N ;
  pinnig_av_1 : A ;
  pinnstol_nn_1 : N ;
  pinoande_nn_1 : N ;
  pinsam_av_1 : A ;
  pinscher_nn_1 : N ;
  pion_nn_1 : N ;
  pionjaer_nn_1 : N ;
  pionroed_av_1 : A ;
  pip_nn_1 : N ;
  pip_nn_2 : N ;
  pipare_nn_1 : N ;
  pipeline_nn_1 : N ;
  pipett_nn_1 : N ;
  piphuvud_nn_1 : N ;
  pipig_av_1 : A ;
  pipkrage_nn_1 : N ;
  pippi_nn_1 : N ;
  pipping_nn_1 : N ;
  piprensare_nn_1 : N ;
  piproekare_nn_1 : N ;
  pipskaegg_nn_1 : N ;
  pipstopp_nn_1 : N ;
  pipstoppare_nn_1 : N ;
  pipsvamp_nn_1 : N ;
  pir_nn_1 : N ;
  pirat_nn_1 : N ;
  piratsaendare_nn_1 : N ;
  pirhuvud_nn_1 : N ;
  pirk_nn_1 : N ;
  pirog_nn_1 : N ;
  pirrig_av_1 : A ;
  piruett_nn_1 : N ;
  pirum_av_1 : A ;
  piskbalkong_nn_1 : N ;
  piskklatsch_nn_1 : N ;
  piskmask_nn_1 : N ;
  piskperuk_nn_1 : N ;
  piskrapp_nn_1 : N ;
  piskslaeng_nn_1 : N ;
  pisksnaert_nn_1 : N ;
  piskstaellning_nn_1 : N ;
  pissoar_nn_1 : N ;
  pist_nn_1 : N ;
  pistage_nn_1 : N ;
  pistasch_nn_1 : N ;
  pistill_nn_1 : N ;
  pistol_nn_1 : N ;
  pistong_nn_1 : N ;
  pitt_nn_1 : N ;
  pittoresk_av_1 : A ;
  pivaa_nn_1 : N ;
  pivot_nn_1 : N ;
  pivotfoenster_nn_1 : N ;
  pivothaengd_av_1 : A ;
  pivotvagn_nn_1 : N ;
  pix_nn_1 : N ;
  pizzicato_ab_1 : Adv ;
  pizzicato_nn_1 : N ;
  pjaakig_av_1 : A ;
  pjaes_nn_1 : N ;
  pjatt_nn_1 : N ;
  pjoskig_av_1 : A ;
  pjunkig_av_1 : A ;
  plaaga_nn_1 : N ;
  plaagoande_nn_1 : N ;
  plaagoris_nn_1 : N ;
  plaagsam_av_1 : A ;
  plaan_nn_1 : N ;
  plaanbok_nn_1 : N ;
  plaaster_nn_1 : N ;
  plaat_nn_1 : N ;
  plaathuv_nn_1 : N ;
  plaatkaerl_nn_1 : N ;
  plaatkant_nn_1 : N ;
  plaatmage_nn_1 : N ;
  plaatmynt_nn_1 : N ;
  plaatsax_nn_1 : N ;
  plaatschabrak_nn_1 : N ;
  plaatslagare_nn_1 : N ;
  plaatslageri_nn_1 : N ;
  placeboeffekt_nn_1 : N ;
  placering_nn_1 : N ;
  placeringskort_nn_1 : N ;
  placeringsobjekt_nn_1 : N ;
  pladask_ab_1 : Adv ;
  pladdrig_av_1 : A ;
  plaed_nn_1 : N ;
  plaedering_nn_1 : N ;
  plaedoaje_nn_1 : N ;
  plaegsed_nn_1 : N ;
  plaett_nn_1 : N ;
  plaettlagg_nn_1 : N ;
  plafond_nn_1 : N ;
  plage_nn_1 : N ;
  plagg_nn_1 : N ;
  plagiat_nn_1 : N ;
  plagiator_nn_1 : N ;
  plaidoyer_nn_1 : N ;
  plakat_av_1 : A ;
  plakat_nn_1 : N ;
  plakett_nn_1 : N ;
  plan_av_1 : A ;
  plan_nn_1 : N ;
  plan_nn_2 : N ;
  planekonomi_nn_1 : N ;
  planenlig_av_1 : A ;
  planerare_nn_1 : N ;
  planering_nn_1 : N ;
  planeringsorgan_nn_1 : N ;
  planet_nn_1 : N ;
  planetarisk_av_1 : A ;
  planetarium_nn_1 : N ;
  planetbildning_nn_1 : N ;
  planetesimal_nn_1 : N ;
  planetsystem_nn_1 : N ;
  plank_nn_2 : N ;
  plankgaang_nn_1 : N ;
  plankonkav_av_1 : A ;
  plankonvex_av_1 : A ;
  plankorsning_nn_1 : N ;
  plankstrykare_nn_1 : N ;
  plankter_nn_1 : N ;
  plankton_nn_1 : N ;
  planktondjur_nn_1 : N ;
  planktonvaext_nn_1 : N ;
  planlaeggning_nn_1 : N ;
  planloes_av_1 : A ;
  planloesning_nn_1 : N ;
  planmaessig_av_1 : A ;
  planparallell_av_1 : A ;
  planritning_nn_1 : N ;
  plansch_nn_1 : N ;
  planschett_nn_1 : N ;
  planschverk_nn_1 : N ;
  planskild_av_1 : A ;
  plantage_nn_1 : N ;
  plantering_nn_1 : N ;
  plants_nn_1 : N ;
  plaskdamm_nn_1 : N ;
  plaskvaat_av_1 : A ;
  plasma_nn_1 : N ;
  plast_nn_1 : N ;
  plastbindemedel_nn_1 : N ;
  plastbunden_av_1 : A ;
  plastfolie_nn_1 : N ;
  plasticitet_nn_1 : N ;
  plastikkirurg_nn_1 : N ;
  plastindustri_nn_1 : N ;
  plastisk_av_1 : A ;
  plastkork_nn_1 : N ;
  plastlaminat_nn_1 : N ;
  plastpaase_nn_1 : N ;
  plastrong_nn_1 : N ;
  plastspiral_nn_1 : N ;
  plataa_nn_1 : N ;
  plataagupp_nn_1 : N ;
  platan_nn_1 : N ;
  platinablond_av_1 : A ;
  platoniker_nn_1 : N ;
  platonisk_av_1 : A ;
  platonsk_av_1 : A ;
  plats_nn_1 : N ;
  platsansoekning_nn_1 : N ;
  platsbiljett_nn_1 : N ;
  platschef_nn_1 : N ;
  platssiffra_nn_1 : N ;
  platssoekande_av_1 : A ;
  platt_ab_1 : Adv ;
  platt_av_1 : A ;
  platt_teve_nn_1 : N ;
  plattfisk_nn_1 : N ;
  plattform_nn_1 : N ;
  platthet_nn_1 : N ;
  platting_nn_1 : N ;
  plattityd_nn_1 : N ;
  plattjaern_nn_1 : N ;
  plattlaeggning_nn_1 : N ;
  plattlaeggningsproblem_nn_1 : N ;
  plattmask_nn_1 : N ;
  plattsoem_nn_1 : N ;
  plattysk_av_1 : A ;
  plausibel_av_1 : A ;
  play_off_nn_1 : N ;
  playboy_nn_1 : N ;
  plebej_nn_1 : N ;
  plebejisk_av_1 : A ;
  plebiscit_nn_1 : N ;
  plejad_nn_1 : N ;
  plektrum_nn_1 : N ;
  plenimaal_nn_1 : N ;
  plenum_nn_1 : N ;
  pleonasm_nn_1 : N ;
  pleonastisk_av_1 : A ;
  plesiosaurie_nn_1 : N ;
  pleurit_nn_1 : N ;
  pligg_nn_1 : N ;
  plikt_nn_1 : N ;
  pliktexemplar_nn_1 : N ;
  pliktfoergaeten_av_1 : A ;
  plikthuggare_nn_1 : N ;
  pliktig_av_1 : A ;
  pliktmedveten_av_1 : A ;
  pliktskyldig_av_1 : A ;
  plikttrogen_av_1 : A ;
  pling_nn_1 : N ;
  plint_nn_1 : N ;
  plirig_av_1 : A ;
  plisse_nn_1 : N ;
  plister_nn_1 : N ;
  plit_nn_2 : N ;
  plockare_nn_1 : N ;
  plockig_av_1 : A ;
  ploejning_nn_1 : N ;
  ploes_nn_1 : N ;
  ploetslig_av_1 : A ;
  ploetsligen_ab_1 : Adv ;
  plog_nn_1 : N ;
  plogben_nn_1 : N ;
  plogbill_nn_1 : N ;
  ploj_nn_1 : N ;
  plomb_nn_1 : N ;
  plommon_nn_1 : N ;
  plommonstop_nn_1 : N ;
  plottrig_av_1 : A ;
  plufsig_av_1 : A ;
  plugg_nn_1 : N ;
  plugg_nn_2 : N ;
  pluggaemne_nn_1 : N ;
  plugghaest_nn_1 : N ;
  pluggskivling_nn_1 : N ;
  plump_av_1 : A ;
  plump_nn_1 : N ;
  plumpudding_nn_1 : N ;
  plums_nn_1 : N ;
  plundring_nn_1 : N ;
  plural_av_1 : A ;
  plural_nn_1 : N ;
  pluralistisk_av_1 : A ;
  pluralitet_nn_1 : N ;
  pluring_nn_1 : N ;
  plusgrad_nn_1 : N ;
  pluskvamperfektum_nn_1 : N ;
  pluspol_nn_1 : N ;
  plussig_av_1 : A ;
  plustecken_nn_1 : N ;
  plutokrat_nn_1 : N ;
  plutokrati_nn_1 : N ;
  pluton_nn_1 : N ;
  plutonisk_av_1 : A ;
  plutt_nn_1 : N ;
  pluttig_av_1 : A ;
  pluvial_av_1 : A ;
  pluvialperiod_nn_1 : N ;
  plym_nn_1 : N ;
  plymaa_nn_1 : N ;
  plymasch_nn_1 : N ;
  plysch_nn_1 : N ;
  plysmaskin_nn_1 : N ;
  pneumatisk_av_1 : A ;
  pneumoni_nn_1 : N ;
  poaeng_nn_1 : N ;
  poaeng_nn_2 : N ;
  poaengloes_av_1 : A ;
  poaengseger_nn_1 : N ;
  poaengtips_nn_1 : N ;
  pocket_nn_1 : N ;
  pocketbok_nn_1 : N ;
  podest_nn_1 : N ;
  podium_nn_1 : N ;
  poel_nn_1 : N ;
  poelsig_av_1 : A ;
  poem_nn_1 : N ;
  poes_nn_1 : N ;
  poesi_nn_1 : N ;
  poesig_av_1 : A ;
  poesmunk_nn_1 : N ;
  poet_nn_1 : N ;
  poetisk_av_1 : A ;
  pogrom_nn_1 : N ;
  pointer_nn_1 : N ;
  pojkaktig_av_1 : A ;
  pojkbok_nn_1 : N ;
  pojkbyting_nn_1 : N ;
  pojkcykel_nn_1 : N ;
  pojke_nn_1 : N ;
  pojkfnasker_nn_1 : N ;
  pojknamn_nn_1 : N ;
  pojkskildring_nn_1 : N ;
  pojkspoling_nn_1 : N ;
  pojkstreck_nn_1 : N ;
  pojkvaen_nn_1 : N ;
  pojkvasker_nn_1 : N ;
  pokal_nn_1 : N ;
  pol_nn_1 : N ;
  polack_nn_1 : N ;
  polaer_av_1 : A ;
  polar_av_1 : A ;
  polare_nn_1 : N ;
  polarexpedition_nn_1 : N ;
  polarflyg_nn_1 : N ;
  polarforskning_nn_1 : N ;
  polarfront_nn_1 : N ;
  polarhav_nn_1 : N ;
  polarisation_nn_1 : N ;
  polarisationsfilter_nn_1 : N ;
  polarisator_nn_1 : N ;
  polarisering_nn_1 : N ;
  polaritet_nn_1 : N ;
  polarmiljoe_nn_1 : N ;
  polaroidfilm_nn_1 : N ;
  polaroidkamera_nn_1 : N ;
  polaromraade_nn_1 : N ;
  polarraev_nn_1 : N ;
  polartrakt_nn_1 : N ;
  polcirkel_nn_1 : N ;
  polder_nn_1 : N ;
  polemik_nn_1 : N ;
  polemiker_nn_1 : N ;
  polemisk_av_1 : A ;
  polentagryn_nn_1 : N ;
  polermedel_nn_1 : N ;
  poliklinik_nn_1 : N ;
  poliklinisk_av_1 : A ;
  polis_nn_1 : N ;
  polisarrest_nn_1 : N ;
  polisbefael_nn_1 : N ;
  polisbevakning_nn_1 : N ;
  polisbil_nn_1 : N ;
  polischef_nn_1 : N ;
  polischock_nn_1 : N ;
  polisdistrikt_nn_1 : N ;
  polisfoerhoer_nn_1 : N ;
  polishund_nn_1 : N ;
  polisiaer_av_1 : A ;
  polisintendent_nn_1 : N ;
  poliskommissarie_nn_1 : N ;
  poliskonstapel_nn_1 : N ;
  poliskund_nn_1 : N ;
  polismaestare_nn_1 : N ;
  polisman_nn_1 : N ;
  polisong_nn_1 : N ;
  polisorganisation_nn_1 : N ;
  polisstat_nn_1 : N ;
  polisstation_nn_1 : N ;
  polisstyrka_nn_1 : N ;
  polistjaenst_nn_1 : N ;
  polistjaensteman_nn_1 : N ;
  polistjaenstgoering_nn_1 : N ;
  polisundersoekning_nn_1 : N ;
  polisvaesende_nn_1 : N ;
  politbyraa_nn_1 : N ;
  politiker_nn_1 : N ;
  politikus_nn_1 : N ;
  politisk_av_1 : A ;
  politruk_nn_1 : N ;
  polityr_nn_1 : N ;
  polkagris_nn_1 : N ;
  polkett_nn_1 : N ;
  polkropp_nn_1 : N ;
  pollare_nn_1 : N ;
  pollenfynd_nn_1 : N ;
  pollenkorn_nn_1 : N ;
  pollenslang_nn_1 : N ;
  pollett_nn_1 : N ;
  pollettering_nn_1 : N ;
  pollination_nn_1 : N ;
  pollinering_nn_1 : N ;
  pollution_nn_1 : N ;
  polokrage_nn_1 : N ;
  polonaes_nn_1 : N ;
  polsk_av_1 : A ;
  polsk_fransk_av_1 : A ;
  polska_nn_2 : N ;
  polsko_nn_1 : N ;
  polyamid_nn_1 : N ;
  polyeder_nn_1 : N ;
  polyester_nn_1 : N ;
  polyeter_nn_1 : N ;
  polyfon_av_1 : A ;
  polyfoni_nn_1 : N ;
  polygam_av_1 : A ;
  polyglott_av_1 : A ;
  polyglott_nn_1 : N ;
  polygon_nn_1 : N ;
  polygraf_nn_1 : N ;
  polyhistor_nn_1 : N ;
  polykrom_av_1 : A ;
  polymer_nn_1 : N ;
  polymerisation_nn_1 : N ;
  polymorf_av_1 : A ;
  polynesier_nn_1 : N ;
  polynesisk_av_1 : A ;
  polynom_nn_1 : N ;
  polyp_nn_1 : N ;
  polysyndes_nn_1 : N ;
  polyteknisk_av_1 : A ;
  pomerans_nn_1 : N ;
  pomeransskal_nn_1 : N ;
  pommersk_av_1 : A ;
  pomolog_nn_1 : N ;
  pompoes_av_1 : A ;
  pompong_nn_1 : N ;
  poncho_nn_1 : N ;
  pond_nn_1 : N ;
  ponderabel_av_1 : A ;
  ponny_nn_1 : N ;
  pontifikat_nn_1 : N ;
  ponton_nn_1 : N ;
  pontonbro_nn_1 : N ;
  pontonjaer_nn_1 : N ;
  pool_nn_1 : N ;
  pop_nn_2 : N ;
  popgrupp_nn_1 : N ;
  popkonsert_nn_1 : N ;
  poplin_nn_1 : N ;
  poplinrock_nn_1 : N ;
  poppel_nn_1 : N ;
  poppig_av_1 : A ;
  poppis_av_1 : A ;
  popsaangare_nn_1 : N ;
  populaer_av_1 : A ;
  populaerkonsert_nn_1 : N ;
  populaervetenskaplig_av_1 : A ;
  popularisator_nn_1 : N ;
  popularitet_nn_1 : N ;
  population_nn_1 : N ;
  populist_nn_1 : N ;
  por_nn_1 : N ;
  porfyr_nn_1 : N ;
  porig_av_1 : A ;
  pormask_nn_1 : N ;
  pornografisk_av_1 : A ;
  poroes_av_1 : A ;
  porositet_nn_1 : N ;
  porrig_av_1 : A ;
  porrklubb_nn_1 : N ;
  porrtidning_nn_1 : N ;
  porslin_nn_1 : N ;
  porslinsdegel_nn_1 : N ;
  porslinsfaerg_nn_1 : N ;
  porslinsfigur_nn_1 : N ;
  porslinsfilter_nn_1 : N ;
  porslinstillverkning_nn_1 : N ;
  porsvamp_nn_1 : N ;
  port_nn_1 : N ;
  portabel_av_1 : A ;
  portal_nn_1 : N ;
  portalfigur_nn_1 : N ;
  portalgestalt_nn_1 : N ;
  portamento_nn_1 : N ;
  portativ_av_1 : A ;
  portepe_nn_1 : N ;
  porter_nn_1 : N ;
  portfoelj_nn_1 : N ;
  portfoerbjuda_vb_1 : V ;
  portfoerbud_nn_1 : N ;
  portgaang_nn_1 : N ;
  portiaer_nn_1 : N ;
  portier_nn_1 : N ;
  portik_nn_1 : N ;
  portion_nn_1 : N ;
  portklapp_nn_1 : N ;
  portmonnae_nn_1 : N ;
  porto_nn_1 : N ;
  portoer_nn_1 : N ;
  portofri_av_1 : A ;
  portraett_nn_1 : N ;
  portraettlik_av_1 : A ;
  portraettoer_nn_1 : N ;
  porttelefon_nn_1 : N ;
  portugis_nn_1 : N ;
  portugisisk_av_1 : A ;
  portugisiska_nn_2 : N ;
  portvakt_nn_1 : N ;
  portvin_nn_1 : N ;
  portvinstaa_nn_1 : N ;
  pose_nn_1 : N ;
  posering_nn_1 : N ;
  position_nn_1 : N ;
  positiv_av_1 : A ;
  positiv_nn_1 : N ;
  positiv_nn_2 : N ;
  positivhalare_nn_1 : N ;
  positivist_nn_1 : N ;
  positivistisk_av_1 : A ;
  positron_nn_1 : N ;
  posoer_nn_1 : N ;
  possession_nn_1 : N ;
  possessionat_nn_1 : N ;
  possessiv_av_1 : A ;
  post_nn_1 : N ;
  postadress_nn_1 : N ;
  postal_av_1 : A ;
  postament_nn_1 : N ;
  postanstalt_nn_1 : N ;
  postanvisning_nn_1 : N ;
  postbox_nn_1 : N ;
  poster_nn_1 : N ;
  postering_nn_1 : N ;
  postexpedition_nn_1 : N ;
  postfack_nn_1 : N ;
  postfoersaendelse_nn_1 : N ;
  postfoerskott_nn_1 : N ;
  postgiro_nn_1 : N ;
  postgirokonto_nn_1 : N ;
  postglacial_av_1 : A ;
  postgymnasial_av_1 : A ;
  posthorn_nn_1 : N ;
  postiljon_nn_1 : N ;
  postindustriell_av_1 : A ;
  postisch_nn_1 : N ;
  postkontor_nn_1 : N ;
  postkort_nn_1 : N ;
  postkupe_nn_1 : N ;
  postludium_nn_1 : N ;
  postmaestare_nn_1 : N ;
  postnatal_av_1 : A ;
  postnummer_nn_1 : N ;
  posto_ab_1 : Adv ;
  postorderfoeretag_nn_1 : N ;
  postposition_nn_1 : N ;
  postremissvaexel_nn_1 : N ;
  postroest_nn_1 : N ;
  postseminarium_nn_1 : N ;
  postskriptum_nn_1 : N ;
  poststaempel_nn_1 : N ;
  poststation_nn_1 : N ;
  posttjaensteman_nn_1 : N ;
  postulat_nn_1 : N ;
  postum_av_1 : A ;
  postutdelning_nn_1 : N ;
  postvaexel_nn_1 : N ;
  postverk_nn_1 : N ;
  potage_nn_1 : N ;
  potatis_nn_1 : N ;
  potatisliknande_av_1 : A ;
  potatispure_nn_1 : N ;
  potatissallad_nn_1 : N ;
  potatisvaext_nn_1 : N ;
  potemkinkuliss_nn_1 : N ;
  potens_nn_1 : N ;
  potent_av_1 : A ;
  potentat_nn_1 : N ;
  potential_nn_1 : N ;
  potentiell_av_1 : A ;
  potentiometer_nn_1 : N ;
  potpurri_nn_1 : N ;
  pott_nn_1 : N ;
  poulard_nn_1 : N ;
  praalig_av_1 : A ;
  praam_nn_1 : N ;
  praang_nn_1 : N ;
  praangleri_nn_1 : N ;
  praegel_nn_1 : N ;
  praegelvaerde_nn_1 : N ;
  praegling_nn_1 : N ;
  praektig_av_1 : A ;
  praelle_nn_1 : N ;
  praent_nn_1 : N ;
  praerie_nn_1 : N ;
  praeriehund_nn_1 : N ;
  praerievarg_nn_1 : N ;
  praest_nn_1 : N ;
  praestbetyg_nn_1 : N ;
  praestdraekt_nn_1 : N ;
  praesterlig_av_1 : A ;
  praestgaard_nn_1 : N ;
  praestgaardslaenstol_nn_1 : N ;
  praestgaell_nn_1 : N ;
  praestinna_nn_1 : N ;
  praestkrage_nn_1 : N ;
  praestman_nn_1 : N ;
  praestost_nn_1 : N ;
  praestrock_nn_1 : N ;
  praestskrud_nn_1 : N ;
  praesttillsaettning_nn_1 : N ;
  praestvaelde_nn_1 : N ;
  praestvigning_nn_1 : N ;
  pragmatiker_nn_1 : N ;
  pragmatisk_av_1 : A ;
  prakrit_nn_1 : N ;
  praktbaegare_nn_1 : N ;
  praktbagge_nn_1 : N ;
  praktexempel_nn_1 : N ;
  praktfull_av_1 : A ;
  praktikabel_av_1 : A ;
  praktikant_nn_1 : N ;
  praktiker_nn_1 : N ;
  praktiktjaenstgoering_nn_1 : N ;
  praktisk_av_1 : A ;
  praktmaalning_nn_1 : N ;
  praktpjaes_nn_1 : N ;
  praktverk_nn_1 : N ;
  pralin_nn_1 : N ;
  pratbubbla_nn_1 : N ;
  pratig_av_1 : A ;
  pratkvarn_nn_1 : N ;
  pratmakare_nn_1 : N ;
  pratsam_av_1 : A ;
  pratsjuk_av_1 : A ;
  prebende_nn_1 : N ;
  precedensfall_nn_1 : N ;
  preceptor_nn_1 : N ;
  preceptur_nn_1 : N ;
  precioes_av_1 : A ;
  preciosa_nn_1 : N ;
  preciositet_nn_1 : N ;
  precis_ab_1 : Adv ;
  precisionsroerelse_nn_1 : N ;
  predator_nn_1 : N ;
  predikament_nn_1 : N ;
  predikant_nn_1 : N ;
  predikare_nn_1 : N ;
  predikat_nn_1 : N ;
  predikativ_av_1 : A ;
  predikativ_nn_1 : N ;
  predikatlogisk_av_1 : A ;
  predikatsfyllnad_nn_1 : N ;
  predikning_nn_1 : N ;
  predikokonst_nn_1 : N ;
  predikosamling_nn_1 : N ;
  predikotext_nn_1 : N ;
  predikotur_nn_1 : N ;
  predikstol_nn_1 : N ;
  prefekt_nn_1 : N ;
  prefektur_nn_1 : N ;
  preferens_nn_1 : N ;
  preferensaktie_nn_1 : N ;
  prefix_nn_1 : N ;
  preglacial_av_1 : A ;
  pregnant_av_1 : A ;
  prehistorisk_av_1 : A ;
  prejudicerande_av_1 : A ;
  prejudikat_nn_1 : N ;
  prekaer_av_1 : A ;
  prelat_nn_1 : N ;
  preliminaer_av_1 : A ;
  preludium_nn_1 : N ;
  premiaer_nn_1 : N ;
  premiaerminister_nn_1 : N ;
  premie_nn_1 : N ;
  premiebetalare_nn_1 : N ;
  premiegill_av_1 : A ;
  premielaan_nn_1 : N ;
  premieobligation_nn_1 : N ;
  premiss_nn_1 : N ;
  premium_nn_1 : N ;
  premolar_nn_1 : N ;
  prenatal_av_1 : A ;
  prenumerant_nn_1 : N ;
  prenumeration_nn_1 : N ;
  preparand_nn_1 : N ;
  preparat_nn_1 : N ;
  preparation_nn_1 : N ;
  preparator_nn_1 : N ;
  preparatris_nn_1 : N ;
  preposition_nn_1 : N ;
  prepositionell_av_1 : A ;
  prepositionskasus_nn_1 : N ;
  prepositionsuttryck_nn_1 : N ;
  prerogativ_nn_1 : N ;
  presbyter_nn_1 : N ;
  presbyterian_nn_1 : N ;
  presenning_nn_1 : N ;
  presens_nn_1 : N ;
  presensparticip_nn_1 : N ;
  present_av_1 : A ;
  present_nn_1 : N ;
  presentabel_av_1 : A ;
  presentation_nn_1 : N ;
  presentatoer_nn_1 : N ;
  presentkort_nn_1 : N ;
  preservativ_nn_1 : N ;
  preses_nn_1 : N ;
  president_nn_1 : N ;
  presidentskap_nn_1 : N ;
  presidentur_nn_1 : N ;
  presidentval_nn_1 : N ;
  presidium_nn_1 : N ;
  preskription_nn_1 : N ;
  preskriptionstid_nn_1 : N ;
  press_nn_1 : N ;
  pressare_nn_1 : N ;
  presschef_nn_1 : N ;
  presseri_nn_1 : N ;
  pressfotograf_nn_1 : N ;
  pressgranne_nn_1 : N ;
  pressjaern_nn_1 : N ;
  presskommissarie_nn_1 : N ;
  presskonferens_nn_1 : N ;
  presskort_nn_1 : N ;
  presslaeggning_nn_1 : N ;
  presslaektare_nn_1 : N ;
  pressmaskin_nn_1 : N ;
  pressmottagning_nn_1 : N ;
  pressning_nn_1 : N ;
  pressorgan_nn_1 : N ;
  pressrelease_nn_1 : N ;
  pressrevider_nn_1 : N ;
  presstopp_nn_1 : N ;
  pressveck_nn_1 : N ;
  prestanda_nn_1 : N ;
  prestation_nn_1 : N ;
  prestav_nn_1 : N ;
  presto_ab_1 : Adv ;
  presto_nn_1 : N ;
  presumtiv_av_1 : A ;
  pretendent_nn_1 : N ;
  pretentioes_av_1 : A ;
  pretention_nn_1 : N ;
  preteritum_nn_1 : N ;
  pretext_nn_1 : N ;
  pretioes_av_1 : A ;
  pretiosa_nn_1 : N ;
  pretiositet_nn_1 : N ;
  pretor_nn_1 : N ;
  pretorian_nn_1 : N ;
  pretto_nn_1 : N ;
  preussare_nn_1 : N ;
  preussisk_av_1 : A ;
  preventiv_av_1 : A ;
  preventivkrig_nn_1 : N ;
  preventivmedel_nn_1 : N ;
  prick_ab_1 : Adv ;
  prick_nn_1 : N ;
  prickare_nn_1 : N ;
  prickfri_av_1 : A ;
  prickig_av_1 : A ;
  pricksaeker_av_1 : A ;
  prickskytt_nn_1 : N ;
  prillig_av_1 : A ;
  prim_nn_1 : N ;
  prima_av_1 : A ;
  primaer_av_1 : A ;
  primaergrupp_nn_1 : N ;
  primaerkommun_nn_1 : N ;
  primaerkredit_nn_1 : N ;
  primaerlaan_nn_1 : N ;
  primaerminne_nn_1 : N ;
  primaerval_nn_1 : N ;
  primalskrik_nn_1 : N ;
  primarie_nn_1 : N ;
  primat_nn_2 : N ;
  primfaktor_nn_1 : N ;
  primitiv_av_1 : A ;
  primitivistisk_av_1 : A ;
  primitivitet_nn_1 : N ;
  primoer_nn_1 : N ;
  primtal_nn_1 : N ;
  primuskoek_nn_1 : N ;
  princip_nn_1 : N ;
  principal_nn_1 : N ;
  principfast_av_1 : A ;
  principfoerklaring_nn_1 : N ;
  principiell_av_1 : A ;
  principmaenniska_nn_1 : N ;
  principprogram_nn_1 : N ;
  principryttare_nn_1 : N ;
  prins_nn_1 : N ;
  prinsessklaenning_nn_1 : N ;
  prinsgemaal_nn_1 : N ;
  prinskorv_nn_1 : N ;
  prinsregent_nn_1 : N ;
  prior_nn_1 : N ;
  priorinna_nn_1 : N ;
  prioritet_nn_1 : N ;
  pris_nn_1 : N ;
  pris_nn_3 : N ;
  pris_nn_4 : N ;
  prisbillig_av_1 : A ;
  prisbomb_nn_1 : N ;
  prisboxare_nn_1 : N ;
  prischock_nn_1 : N ;
  priselasticitet_nn_1 : N ;
  prisfall_nn_1 : N ;
  prisfoeraendring_nn_1 : N ;
  prisge_vb_1 : V ;
  prishoejning_nn_1 : N ;
  priskrig_nn_1 : N ;
  priskurant_nn_1 : N ;
  prislapp_nn_1 : N ;
  prisma_nn_1 : N ;
  prismakikare_nn_1 : N ;
  prismatisk_av_1 : A ;
  prismedveten_av_1 : A ;
  prisnivaa_nn_1 : N ;
  prisoekning_nn_1 : N ;
  prisreglering_nn_1 : N ;
  prissaettning_nn_1 : N ;
  prisse_nn_1 : N ;
  prissensation_nn_1 : N ;
  prisstegring_nn_1 : N ;
  prisstopp_nn_1 : N ;
  pristaevling_nn_1 : N ;
  pristagare_nn_1 : N ;
  pristak_nn_1 : N ;
  prisvaerd_av_1 : A ;
  prisvariation_nn_1 : N ;
  privat_av_1 : A ;
  privataegd_av_1 : A ;
  privatbank_nn_1 : N ;
  privatbil_nn_1 : N ;
  privatdetektiv_nn_1 : N ;
  privatdiskontoer_nn_1 : N ;
  privatekonomisk_av_1 : A ;
  privatim_ab_1 : Adv ;
  privatist_nn_1 : N ;
  privatkapital_nn_1 : N ;
  privatlaan_nn_1 : N ;
  privatlaekare_nn_1 : N ;
  privatlaerare_nn_1 : N ;
  privatlektion_nn_1 : N ;
  privatman_nn_1 : N ;
  privatperson_nn_1 : N ;
  privatpraktiker_nn_1 : N ;
  privatpraktiserande_av_1 : A ;
  privatsak_nn_1 : N ;
  privatsekreterare_nn_1 : N ;
  privattryck_nn_1 : N ;
  privilegiebrev_nn_1 : N ;
  privilegium_nn_1 : N ;
  probabel_av_1 : A ;
  probabilistisk_av_1 : A ;
  probabilitet_nn_1 : N ;
  probat_av_1 : A ;
  problem_nn_1 : N ;
  problematisk_av_1 : A ;
  problembarn_nn_1 : N ;
  problemfri_av_1 : A ;
  problemstaellning_nn_1 : N ;
  procedur_nn_1 : N ;
  procent_nn_1 : N ;
  procentare_nn_1 : N ;
  procentenhet_nn_1 : N ;
  procentisk_av_1 : A ;
  procentuell_av_1 : A ;
  procentvaerde_nn_1 : N ;
  process_nn_1 : N ;
  processindustri_nn_1 : N ;
  procession_nn_1 : N ;
  processuell_av_1 : A ;
  producent_nn_1 : N ;
  produkt_nn_1 : N ;
  produktion_nn_1 : N ;
  produktionsapparat_nn_1 : N ;
  produktionsfaktor_nn_1 : N ;
  produktionsfoerhaallande_nn_1 : N ;
  produktionsmedel_nn_1 : N ;
  produktionsskatt_nn_1 : N ;
  produktionsteknik_nn_1 : N ;
  produktiv_av_1 : A ;
  produktivitet_nn_1 : N ;
  produktivkraft_nn_1 : N ;
  produktmaengd_nn_1 : N ;
  proevande_av_1 : A ;
  proevning_nn_1 : N ;
  proevostund_nn_1 : N ;
  proevotid_nn_1 : N ;
  profan_av_1 : A ;
  profanation_nn_1 : N ;
  profession_nn_1 : N ;
  professionell_av_1 : A ;
  professor_nn_1 : N ;
  professorlig_av_1 : A ;
  professur_nn_1 : N ;
  profet_nn_1 : N ;
  profetisk_av_1 : A ;
  proffs_nn_1 : N ;
  proffsig_av_1 : A ;
  profil_nn_1 : N ;
  profit_nn_1 : N ;
  profithaj_nn_1 : N ;
  profitoer_nn_1 : N ;
  profoss_nn_1 : N ;
  profylaktisk_av_1 : A ;
  prognat_av_1 : A ;
  prognos_nn_1 : N ;
  prognostisk_av_1 : A ;
  program_nn_1 : N ;
  programbudget_nn_1 : N ;
  programenlig_av_1 : A ;
  programland_nn_1 : N ;
  programledare_nn_1 : N ;
  programmatisk_av_1 : A ;
  programmerare_nn_1 : N ;
  programmeringsspraak_nn_1 : N ;
  programmotek_nn_1 : N ;
  programpunkt_nn_1 : N ;
  programskrift_nn_1 : N ;
  programspraak_nn_1 : N ;
  programutgivare_nn_1 : N ;
  programvaeljare_nn_1 : N ;
  progression_nn_1 : N ;
  progressiv_av_1 : A ;
  progressivitet_nn_1 : N ;
  prohibitiv_av_1 : A ;
  proinsulin_nn_1 : N ;
  projekt_nn_1 : N ;
  projektil_nn_1 : N ;
  projektion_nn_1 : N ;
  projektionsapparat_nn_1 : N ;
  projektiv_av_1 : A ;
  projektoer_nn_1 : N ;
  projektor_nn_1 : N ;
  prokansler_nn_1 : N ;
  proklamation_nn_1 : N ;
  proklitisk_av_1 : A ;
  prokrustesbaedd_nn_1 : N ;
  prokrustisk_av_1 : A ;
  prokurator_nn_1 : N ;
  prokurist_nn_1 : N ;
  prolaktin_nn_1 : N ;
  prolaps_nn_1 : N ;
  proletaer_av_1 : A ;
  proletaer_nn_1 : N ;
  prolog_nn_1 : N ;
  prolongation_nn_1 : N ;
  promenad_nn_1 : N ;
  promenadkaepp_nn_1 : N ;
  promenadkonsert_nn_1 : N ;
  promenadseger_nn_1 : N ;
  promenadstraak_nn_1 : N ;
  promenoar_nn_1 : N ;
  promille_nn_1 : N ;
  prominens_nn_1 : N ;
  prominent_av_1 : A ;
  promiskuitet_nn_1 : N ;
  promiskuoes_av_1 : A ;
  promotion_nn_1 : N ;
  promotor_nn_1 : N ;
  promovend_nn_1 : N ;
  prompt_ab_1 : Adv ;
  promulgation_nn_1 : N ;
  pronomen_nn_1 : N ;
  pronominal_av_1 : A ;
  pronominell_av_1 : A ;
  prononciation_nn_1 : N ;
  propaa_nn_1 : N ;
  propagandaminister_nn_1 : N ;
  propagandist_nn_1 : N ;
  propagandistisk_av_1 : A ;
  propedeutisk_av_1 : A ;
  propeller_nn_1 : N ;
  propellerplan_nn_1 : N ;
  proper_av_1 : A ;
  proponent_nn_1 : N ;
  proportion_nn_1 : N ;
  proportional_nn_1 : N ;
  proportionalitet_nn_1 : N ;
  proportionell_av_1 : A ;
  proportionerlig_av_1 : A ;
  proposition_nn_1 : N ;
  propp_nn_1 : N ;
  proppfull_av_1 : A ;
  proppmaett_av_1 : A ;
  proppsaekring_nn_1 : N ;
  proprietaer_nn_1 : N ;
  propyl_nn_1 : N ;
  propyle_nn_1 : N ;
  prorektor_nn_1 : N ;
  prorogation_nn_1 : N ;
  prosadikt_nn_1 : N ;
  prosaisk_av_1 : A ;
  prosaist_nn_1 : N ;
  proscenium_nn_1 : N ;
  prosektor_nn_1 : N ;
  proselyt_nn_1 : N ;
  proseminarium_nn_1 : N ;
  proskription_nn_1 : N ;
  prosodi_nn_1 : N ;
  prosodisk_av_1 : A ;
  prospekt_nn_1 : N ;
  prost_nn_1 : N ;
  prostatit_nn_1 : N ;
  prosteri_nn_1 : N ;
  protagonist_nn_1 : N ;
  protege_nn_1 : N ;
  protein_nn_1 : N ;
  proteinanalys_nn_1 : N ;
  proteinbehov_nn_1 : N ;
  proteinfabrik_nn_1 : N ;
  proteinfamilj_nn_1 : N ;
  proteinforskning_nn_1 : N ;
  proteinkedja_nn_1 : N ;
  proteinkemist_nn_1 : N ;
  proteinmolekyl_nn_1 : N ;
  proteinnerbrytande_av_1 : A ;
  proteinrik_av_1 : A ;
  proteinslag_nn_1 : N ;
  proteisk_av_1 : A ;
  protektionistisk_av_1 : A ;
  protektor_nn_1 : N ;
  protektorat_nn_1 : N ;
  protes_nn_1 : N ;
  protest_nn_1 : N ;
  protestaktion_nn_1 : N ;
  protestant_nn_1 : N ;
  protestantisk_av_1 : A ;
  protestroerelse_nn_1 : N ;
  protestvilja_nn_1 : N ;
  protokoll_nn_1 : N ;
  protokollaer_av_1 : A ;
  protolys_nn_1 : N ;
  protolyt_nn_1 : N ;
  proton_nn_1 : N ;
  protonkniv_nn_1 : N ;
  protonladdning_nn_1 : N ;
  prototyp_nn_1 : N ;
  protozo_nn_1 : N ;
  protuberans_nn_1 : N ;
  prov_nn_1 : N ;
  prov_nn_2 : N ;
  provaar_nn_1 : N ;
  provare_nn_1 : N ;
  proveniens_nn_1 : N ;
  provensal_nn_1 : N ;
  provensalsk_av_1 : A ;
  provensalska_nn_2 : N ;
  proverb_nn_1 : N ;
  provglas_nn_1 : N ;
  provie_nn_1 : N ;
  provins_nn_1 : N ;
  provinsialism_nn_1 : N ;
  provinsiallaekare_nn_1 : N ;
  provinsiell_av_1 : A ;
  provision_nn_1 : N ;
  provisorisk_av_1 : A ;
  provisorium_nn_1 : N ;
  provkoek_nn_1 : N ;
  provokation_nn_1 : N ;
  provokativ_av_1 : A ;
  provokatoer_nn_1 : N ;
  provokatorisk_av_1 : A ;
  provraekning_nn_1 : N ;
  provroer_nn_1 : N ;
  provroersbarn_nn_1 : N ;
  provroersbefruktning_nn_1 : N ;
  provrum_nn_1 : N ;
  provryttare_nn_1 : N ;
  provspraengning_nn_1 : N ;
  provstopp_nn_1 : N ;
  provtagning_nn_1 : N ;
  provuppgift_nn_1 : N ;
  proximal_av_1 : A ;
  prudentlig_av_1 : A ;
  prunell_nn_1 : N ;
  prutgaas_nn_1 : N ;
  prutt_nn_1 : N ;
  pruttig_av_1 : A ;
  pryd_av_1 : A ;
  prydlig_av_1 : A ;
  prydnad_nn_1 : N ;
  prydnadsbuske_nn_1 : N ;
  prydnadsdetalj_nn_1 : N ;
  prydnadsfigur_nn_1 : N ;
  prydnadsfjaeder_nn_1 : N ;
  prydnadsfoeremaal_nn_1 : N ;
  prydnadsgavel_nn_1 : N ;
  prydnadslist_nn_1 : N ;
  prydnadssoem_nn_1 : N ;
  prydnadsvaev_nn_1 : N ;
  prydnadsvaext_nn_1 : N ;
  pryl_nn_1 : N ;
  pryo_nn_1 : N ;
  pryttel_nn_1 : N ;
  psalm_nn_1 : N ;
  psalmbok_nn_1 : N ;
  psalmdiktare_nn_1 : N ;
  psalmist_nn_1 : N ;
  psalmnummer_nn_1 : N ;
  psalmodi_nn_1 : N ;
  psalmodikon_nn_1 : N ;
  psalmvers_nn_1 : N ;
  psaltare_nn_1 : N ;
  pseudohaendelse_nn_1 : N ;
  pseudonym_nn_1 : N ;
  psoriatiker_nn_1 : N ;
  psykedelisk_av_1 : A ;
  psykiater_nn_1 : N ;
  psykiatriker_nn_1 : N ;
  psykiatrisk_av_1 : A ;
  psykisk_av_1 : A ;
  psykoanalys_nn_1 : N ;
  psykoanalytiker_nn_1 : N ;
  psykoanalytisk_av_1 : A ;
  psykofarmaka_nn_1 : N ;
  psykogen_av_1 : A ;
  psykolog_nn_1 : N ;
  psykologiprofessor_nn_1 : N ;
  psykologisk_av_1 : A ;
  psykopat_nn_1 : N ;
  psykopati_nn_1 : N ;
  psykoprofylaktisk_av_1 : A ;
  psykos_nn_1 : N ;
  psykosocial_av_1 : A ;
  psykosomatisk_av_1 : A ;
  psykoterapeut_nn_1 : N ;
  psykoterapi_nn_1 : N ;
  psykotisk_av_1 : A ;
  psykrometer_nn_1 : N ;
  pub_nn_1 : N ;
  pubertet_nn_1 : N ;
  publicering_nn_1 : N ;
  publicist_nn_1 : N ;
  publicistisk_av_1 : A ;
  publicitet_nn_1 : N ;
  publik_av_1 : A ;
  publikan_nn_1 : N ;
  publikation_nn_1 : N ;
  publikdragande_av_1 : A ;
  publikfriande_av_1 : A ;
  puck_nn_1 : N ;
  puckare_nn_1 : N ;
  puckel_nn_1 : N ;
  puckeloxe_nn_1 : N ;
  puckelpist_nn_1 : N ;
  puckelrygg_nn_1 : N ;
  puckelryggig_av_1 : A ;
  pucklig_av_1 : A ;
  pudding_nn_1 : N ;
  pudel_nn_1 : N ;
  puderkraem_nn_1 : N ;
  puderunderlag_nn_1 : N ;
  pudrig_av_1 : A ;
  pueril_av_1 : A ;
  puerilitet_nn_1 : N ;
  puff_nn_1 : N ;
  puffaerm_nn_1 : N ;
  puffert_nn_1 : N ;
  pugilist_nn_1 : N ;
  puke_nn_1 : N ;
  pullmanvagn_nn_1 : N ;
  pullover_nn_1 : N ;
  pulpet_nn_1 : N ;
  pulpettak_nn_1 : N ;
  pulpit_nn_1 : N ;
  puls_nn_1 : N ;
  puls_nn_2 : N ;
  pulsaader_nn_1 : N ;
  pulsar_nn_1 : N ;
  pulsslag_nn_1 : N ;
  pulstaag_nn_1 : N ;
  pult_nn_1 : N ;
  pultron_nn_1 : N ;
  pulver_nn_1 : N ;
  pulverslaeckare_nn_1 : N ;
  pump_nn_1 : N ;
  pumpernickel_nn_1 : N ;
  pumpkolv_nn_1 : N ;
  pumpstoevel_nn_1 : N ;
  punch_nn_1 : N ;
  pund_nn_1 : N ;
  pundare_nn_1 : N ;
  pundhuvud_nn_1 : N ;
  pundig_av_1 : A ;
  pundkris_nn_1 : N ;
  pung_nn_1 : N ;
  pungbjoern_nn_1 : N ;
  pungdjur_nn_1 : N ;
  pungsten_nn_1 : N ;
  punisk_av_1 : A ;
  punkare_nn_1 : N ;
  punkfrisyr_nn_1 : N ;
  punkt_nn_1 : N ;
  punktering_nn_1 : N ;
  punkthus_nn_1 : N ;
  punktion_nn_1 : N ;
  punktlig_av_1 : A ;
  punktmaengd_nn_1 : N ;
  punktskatt_nn_1 : N ;
  punktuell_av_1 : A ;
  punktur_nn_1 : N ;
  punktvis_ab_1 : Adv ;
  puns_nn_1 : N ;
  pupill_nn_1 : N ;
  pupillfoerstorande_av_1 : A ;
  pur_av_1 : A ;
  pure_nn_1 : N ;
  purgativ_nn_1 : N ;
  purin_nn_1 : N ;
  purism_nn_1 : N ;
  purist_nn_1 : N ;
  puritan_nn_1 : N ;
  puritansk_av_1 : A ;
  purjoloek_nn_1 : N ;
  purken_av_1 : A ;
  purser_nn_1 : N ;
  puss_nn_1 : N ;
  pussel_nn_1 : N ;
  pusselbit_nn_1 : N ;
  pussig_av_1 : A ;
  pusskalas_nn_1 : N ;
  pust_nn_1 : N ;
  pustel_nn_1 : N ;
  putig_av_1 : A ;
  puts_nn_2 : N ;
  putsch_nn_1 : N ;
  putslustig_av_1 : A ;
  putt_av_1 : A ;
  putt_nn_1 : N ;
  putte_nn_1 : N ;
  puttefnask_nn_1 : N ;
  putting_nn_1 : N ;
  putto_nn_1 : N ;
  puttrig_av_1 : A ;
  puzzle_nn_1 : N ;
  pyelit_nn_1 : N ;
  pygme_nn_1 : N ;
  pyjamas_nn_1 : N ;
  pykniker_nn_1 : N ;
  pyknisk_av_1 : A ;
  pyknometer_nn_1 : N ;
  pylon_nn_1 : N ;
  pyndare_nn_1 : N ;
  pynt_nn_2 : N ;
  pyramid_nn_1 : N ;
  pyramidal_av_1 : A ;
  pyreneisk_av_1 : A ;
  pyridin_nn_1 : N ;
  pyrit_nn_1 : N ;
  pyroman_nn_1 : N ;
  pyrometer_nn_1 : N ;
  pyroteknisk_av_1 : A ;
  pyrrusseger_nn_1 : N ;
  pys_nn_1 : N ;
  pysslig_av_1 : A ;
  pyssling_nn_1 : N ;
  pyton_ab_1 : Adv ;
  pytonorm_nn_1 : N ;
  pyts_nn_1 : N ;
  pytte_av_1 : A ;
  qatarier_nn_1 : N ;
  qatarisk_av_1 : A ;
  quenell_nn_1 : N ;
  quisling_nn_1 : N ;
  raa_av_1 : A ;
  raa_nn_1 : N ;
  raa_nn_2 : N ;
  raa_nn_3 : N ;
  raaaemne_nn_1 : N ;
  raaband_nn_1 : N ;
  raabandsknop_nn_1 : N ;
  raabiff_nn_1 : N ;
  raabock_nn_1 : N ;
  raad_nn_1 : N ;
  raadande_av_1 : A ;
  raaddig_av_1 : A ;
  raadfraagning_nn_1 : N ;
  raadgivande_av_1 : A ;
  raadgivare_nn_1 : N ;
  raadhus_nn_1 : N ;
  raadhuskaellare_nn_1 : N ;
  raadhusraett_nn_1 : N ;
  raadig_av_1 : A ;
  raadjur_nn_1 : N ;
  raadjurssadel_nn_1 : N ;
  raadlig_av_1 : A ;
  raadloes_av_1 : A ;
  raadman_nn_1 : N ;
  raadplaegning_nn_1 : N ;
  raadslag_nn_1 : N ;
  raadsnar_av_1 : A ;
  raadsrepublik_nn_1 : N ;
  raadstuga_nn_1 : N ;
  raadstuguraett_nn_1 : N ;
  raadvill_av_1 : A ;
  raagaang_nn_1 : N ;
  raagblond_av_1 : A ;
  raagbroed_nn_1 : N ;
  raaget_nn_1 : N ;
  raagkorn_nn_1 : N ;
  raahet_nn_1 : N ;
  raak_nn_1 : N ;
  raakall_av_1 : A ;
  raakopia_nn_1 : N ;
  raakurr_nn_1 : N ;
  raamaerke_nn_1 : N ;
  raan_nn_1 : N ;
  raanare_nn_1 : N ;
  raanmord_nn_1 : N ;
  raanock_nn_1 : N ;
  raaoljemotor_nn_1 : N ;
  raariva_vb_1 : V ;
  raaroerd_av_1 : A ;
  raasegel_nn_1 : N ;
  raaseglare_nn_1 : N ;
  raaskinn_nn_1 : N ;
  raasop_nn_1 : N ;
  raattaeten_av_1 : A ;
  raattdjur_nn_1 : N ;
  raatthaal_nn_1 : N ;
  raattsvans_nn_1 : N ;
  raavara_nn_1 : N ;
  rabatt_nn_1 : N ;
  rabattfrimaerke_nn_1 : N ;
  rabatthaefte_nn_1 : N ;
  rabattkort_nn_1 : N ;
  rabattkupong_nn_1 : N ;
  rabbi_nn_1 : N ;
  rabbin_nn_1 : N ;
  rabbis_nn_1 : N ;
  rabiat_av_1 : A ;
  rabulist_nn_1 : N ;
  rabulistisk_av_1 : A ;
  racer_nn_1 : N ;
  racerbil_nn_1 : N ;
  racercykel_nn_1 : N ;
  racerfoerare_nn_1 : N ;
  rack_nn_1 : N ;
  rack_nn_2 : N ;
  rackaraktig_av_1 : A ;
  rackare_nn_1 : N ;
  rackarns_av_1 : A ;
  rackartyg_nn_1 : N ;
  rackarunge_nn_1 : N ;
  rackelhane_nn_1 : N ;
  racket_nn_1 : N ;
  racklig_av_1 : A ;
  rad_nn_1 : N ;
  rad_nn_2 : N ;
  radannons_nn_1 : N ;
  radarantenn_nn_1 : N ;
  radarfyr_nn_1 : N ;
  radarkontroll_nn_1 : N ;
  radarpar_nn_1 : N ;
  radarreflektor_nn_1 : N ;
  radarskaerm_nn_1 : N ;
  radavstaand_nn_1 : N ;
  radband_nn_1 : N ;
  radergummi_nn_1 : N ;
  raderkniv_nn_1 : N ;
  radhus_nn_1 : N ;
  radiakbehandling_nn_1 : N ;
  radial_av_1 : A ;
  radialdaeck_nn_1 : N ;
  radialhastighet_nn_1 : N ;
  radiallager_nn_1 : N ;
  radian_nn_1 : N ;
  radiator_nn_1 : N ;
  radie_nn_1 : N ;
  radiell_av_1 : A ;
  radikal_av_1 : A ;
  radikal_nn_1 : N ;
  radikalisering_nn_1 : N ;
  radikaloperation_nn_1 : N ;
  radio_nn_1 : N ;
  radioaktiv_av_1 : A ;
  radioaktivitet_nn_1 : N ;
  radioamatoer_nn_1 : N ;
  radioapparat_nn_1 : N ;
  radioastronomisk_av_1 : A ;
  radiobil_nn_1 : N ;
  radiofrekvent_av_1 : A ;
  radiofyr_nn_1 : N ;
  radiogram_nn_1 : N ;
  radiogrammofon_nn_1 : N ;
  radiohus_nn_1 : N ;
  radioisotop_nn_1 : N ;
  radiokanal_nn_1 : N ;
  radiolaenk_nn_1 : N ;
  radiolarie_nn_1 : N ;
  radiolog_nn_1 : N ;
  radioman_nn_1 : N ;
  radiometer_nn_1 : N ;
  radiomottagare_nn_1 : N ;
  radionavigeringssystem_nn_1 : N ;
  radiopjaes_nn_1 : N ;
  radioprogram_nn_1 : N ;
  radioroer_nn_1 : N ;
  radioroest_nn_1 : N ;
  radiosaendare_nn_1 : N ;
  radiosaendning_nn_1 : N ;
  radiosignal_nn_1 : N ;
  radiosond_nn_1 : N ;
  radiostation_nn_1 : N ;
  radiostoerning_nn_1 : N ;
  radiostraalning_nn_1 : N ;
  radiot_nn_1 : N ;
  radioteknik_nn_1 : N ;
  radiotelefon_nn_1 : N ;
  radiotelegrafist_nn_1 : N ;
  radioteleskop_nn_1 : N ;
  radioutsaendning_nn_1 : N ;
  radondotter_nn_1 : N ;
  radonhus_nn_1 : N ;
  radskiftare_nn_1 : N ;
  radskrivare_nn_1 : N ;
  radslutssignal_nn_1 : N ;
  raeck_nn_1 : N ;
  raecke_nn_1 : N ;
  raeckverk_nn_1 : N ;
  raeckvidd_nn_1 : N ;
  raed_nn_1 : N ;
  raeddare_nn_1 : N ;
  raeddhaagsen_av_1 : A ;
  raeddning_nn_1 : N ;
  raeddningsaktion_nn_1 : N ;
  raeddningsloes_av_1 : A ;
  raeffla_nn_1 : N ;
  raefst_nn_1 : N ;
  raejong_nn_1 : N ;
  raekel_nn_1 : N ;
  raekenskapsaar_nn_1 : N ;
  raeknare_nn_1 : N ;
  raekneapparat_nn_1 : N ;
  raekneexempel_nn_1 : N ;
  raeknekapacitet_nn_1 : N ;
  raeknemaskin_nn_1 : N ;
  raekneord_nn_1 : N ;
  raeknesaett_nn_1 : N ;
  raeknesnabbhet_nn_1 : N ;
  raekneverk_nn_1 : N ;
  raekning_nn_1 : N ;
  rael_nn_1 : N ;
  raelig_av_1 : A ;
  raels_nn_1 : N ;
  raelsbuss_nn_1 : N ;
  raenksmidare_nn_1 : N ;
  raennil_nn_1 : N ;
  raenning_nn_1 : N ;
  raennsten_nn_1 : N ;
  raennstensunge_nn_1 : N ;
  raensel_nn_1 : N ;
  raentabel_av_1 : A ;
  raentabilitet_nn_1 : N ;
  raenteavdrag_nn_1 : N ;
  raentebesked_nn_1 : N ;
  raentemarginal_nn_1 : N ;
  raentesats_nn_1 : N ;
  raentetermin_nn_1 : N ;
  raentmaestare_nn_1 : N ;
  raetblock_nn_1 : N ;
  raetlinjig_av_1 : A ;
  raetsida_nn_1 : N ;
  raett_ab_1 : Adv ;
  raett_av_1 : A ;
  raett_nn_1 : N ;
  raettaenkande_av_1 : A ;
  raettare_nn_1 : N ;
  raettegaang_nn_1 : N ;
  raettegaangsbitraede_nn_1 : N ;
  raettegaangsfel_nn_1 : N ;
  raetteligen_ab_1 : Adv ;
  raettelse_nn_1 : N ;
  raettfaerdig_av_1 : A ;
  raettfaerdighet_nn_1 : N ;
  raettfram_av_1 : A ;
  raettighet_nn_1 : N ;
  raettmaetig_av_1 : A ;
  raettning_nn_1 : N ;
  raettraadig_av_1 : A ;
  raettroende_av_1 : A ;
  raettrogen_av_1 : A ;
  raettschef_nn_1 : N ;
  raettsenlig_av_1 : A ;
  raettsfall_nn_1 : N ;
  raettshaverist_nn_1 : N ;
  raettsinnig_av_1 : A ;
  raettskaffens_av_1 : A ;
  raettskapacitet_nn_1 : N ;
  raettskrivning_nn_1 : N ;
  raettslaekare_nn_1 : N ;
  raettslig_av_1 : A ;
  raettsloes_av_1 : A ;
  raettsmedicinsk_av_1 : A ;
  raettsordning_nn_1 : N ;
  raettspaafoeljd_nn_1 : N ;
  raettsprincip_nn_1 : N ;
  raettspsykiatrisk_av_1 : A ;
  raettsregel_nn_1 : N ;
  raettssaekerhet_nn_1 : N ;
  raettssak_nn_1 : N ;
  raettssal_nn_1 : N ;
  raettsstat_nn_1 : N ;
  raettsstridig_av_1 : A ;
  raettssubjekt_nn_1 : N ;
  raettstvist_nn_1 : N ;
  raettsuppfattning_nn_1 : N ;
  raettsvidrig_av_1 : A ;
  raettvis_av_1 : A ;
  raettvisande_av_1 : A ;
  raetvinge_nn_1 : N ;
  raetvinklig_av_1 : A ;
  raev_nn_1 : N ;
  raevfarm_nn_1 : N ;
  raevhund_nn_1 : N ;
  raevjakt_nn_1 : N ;
  raevsax_nn_1 : N ;
  raevspel_nn_1 : N ;
  raevsvans_nn_1 : N ;
  raffig_av_1 : A ;
  raffinad_nn_1 : N ;
  raffinaderi_nn_1 : N ;
  raffinemang_nn_1 : N ;
  rafflande_av_1 : A ;
  rafflig_av_1 : A ;
  rafraeschissoer_nn_1 : N ;
  raggarbil_nn_1 : N ;
  raggarbrud_nn_1 : N ;
  raggare_nn_1 : N ;
  raggig_av_1 : A ;
  raggmunk_nn_1 : N ;
  raglanaerm_nn_1 : N ;
  ragu_nn_1 : N ;
  raid_nn_1 : N ;
  rajd_nn_1 : N ;
  rak_av_1 : A ;
  rakapparat_nn_1 : N ;
  rakblad_nn_1 : N ;
  rakborste_nn_1 : N ;
  raket_nn_1 : N ;
  raketbas_nn_1 : N ;
  raketfaerd_nn_1 : N ;
  raketgevaer_nn_1 : N ;
  raketkonstruktoer_nn_1 : N ;
  raketmotor_nn_1 : N ;
  raketsteg_nn_1 : N ;
  raketvapen_nn_1 : N ;
  rakhyvel_nn_1 : N ;
  rakitisk_av_1 : A ;
  rakkniv_nn_1 : N ;
  raklaang_av_1 : A ;
  raklinjig_av_1 : A ;
  rakning_nn_1 : N ;
  rakspegel_nn_1 : N ;
  rakstrigel_nn_1 : N ;
  raktvaal_nn_1 : N ;
  rakvatten_nn_1 : N ;
  raljant_av_1 : A ;
  raljeri_nn_1 : N ;
  rall_nn_1 : N ;
  rallarbas_nn_1 : N ;
  rallare_nn_1 : N ;
  rallarsving_nn_1 : N ;
  rally_nn_1 : N ;
  ram_nn_1 : N ;
  ramaskri_nn_1 : N ;
  ramavtal_nn_1 : N ;
  ramberaettelse_nn_1 : N ;
  rambudget_nn_1 : N ;
  ramlare_nn_1 : N ;
  ramm_nn_1 : N ;
  ramp_nn_1 : N ;
  rampris_nn_1 : N ;
  ramstark_av_1 : A ;
  ramsvart_av_1 : A ;
  ranch_nn_1 : N ;
  rancune_nn_1 : N ;
  rand_nn_1 : N ;
  rand_nn_2 : N ;
  randanmaerkning_nn_1 : N ;
  randanteckning_nn_1 : N ;
  randberg_nn_1 : N ;
  randbildning_nn_1 : N ;
  randdelta_nn_1 : N ;
  randfenomen_nn_1 : N ;
  randhav_nn_1 : N ;
  randig_av_1 : A ;
  randplataa_nn_1 : N ;
  randsjoe_nn_1 : N ;
  randsydd_av_1 : A ;
  ranger_nn_1 : N ;
  rangerbangaard_nn_1 : N ;
  ranglig_av_1 : A ;
  rangordning_nn_1 : N ;
  rangplats_nn_1 : N ;
  rank_av_1 : A ;
  ranka_ab_1 : Adv ;
  rankfoting_nn_1 : N ;
  rankig_av_1 : A ;
  rannsakning_nn_1 : N ;
  ranson_nn_1 : N ;
  ransonering_nn_1 : N ;
  ransoneringskort_nn_1 : N ;
  ranunkel_nn_1 : N ;
  ranunkelvaext_nn_1 : N ;
  rap_nn_1 : N ;
  rapp_av_1 : A ;
  rapp_nn_1 : N ;
  rapp_nn_2 : N ;
  rappell_nn_1 : N ;
  rapphoens_nn_1 : N ;
  rappning_nn_1 : N ;
  rapport_nn_1 : N ;
  rapportkarl_nn_1 : N ;
  rapportoer_nn_1 : N ;
  rapsbagge_nn_1 : N ;
  rapsfroe_nn_1 : N ;
  rapsod_nn_1 : N ;
  rapsodi_nn_1 : N ;
  rapsodisk_av_1 : A ;
  raptus_nn_1 : N ;
  rar_av_1 : A ;
  raring_nn_1 : N ;
  raritet_nn_1 : N ;
  ras_nn_1 : N ;
  ras_nn_2 : N ;
  rasande_av_1 : A ;
  rasben_nn_1 : N ;
  rasdjur_nn_1 : N ;
  raseriutbrott_nn_1 : N ;
  rasfoerdom_nn_1 : N ;
  rasfoerfoeljelse_nn_1 : N ;
  rasfraaga_nn_1 : N ;
  rashetsare_nn_1 : N ;
  rasist_nn_1 : N ;
  rasistisk_av_1 : A ;
  rask_av_1 : A ;
  rasp_nn_1 : N ;
  raspande_av_1 : A ;
  raspig_av_1 : A ;
  rasren_av_1 : A ;
  rast_nn_1 : N ;
  rastafari_nn_1 : N ;
  raster_nn_1 : N ;
  rastgaard_nn_1 : N ;
  rastloes_av_1 : A ;
  rastplats_nn_1 : N ;
  rate_nn_1 : N ;
  ratifikation_nn_1 : N ;
  ratifikationsinstrument_nn_1 : N ;
  ration_nn_1 : N ;
  rationalisering_nn_1 : N ;
  rationalist_nn_1 : N ;
  rationell_av_1 : A ;
  ratsch_nn_1 : N ;
  ratt_nn_1 : N ;
  rattfyllerist_nn_1 : N ;
  rattkaelke_nn_1 : N ;
  rattlaas_nn_1 : N ;
  rattonykterhet_nn_1 : N ;
  rattstaang_nn_1 : N ;
  rattvaexel_nn_1 : N ;
  rauk_nn_1 : N ;
  ravaillac_nn_1 : N ;
  ravelin_nn_1 : N ;
  ravin_nn_1 : N ;
  reagens_nn_1 : N ;
  reagenspapper_nn_1 : N ;
  reaktion_nn_1 : N ;
  reaktionaer_av_1 : A ;
  reaktionaer_nn_1 : N ;
  reaktionsbenaegen_av_1 : A ;
  reaktionsmotor_nn_1 : N ;
  reaktionsprodukt_nn_1 : N ;
  reaktionstemperatur_nn_1 : N ;
  reaktionstid_nn_1 : N ;
  reaktionszon_nn_1 : N ;
  reaktiv_av_1 : A ;
  reaktor_nn_1 : N ;
  reaktorbyggnad_nn_1 : N ;
  reaktorhaerd_nn_1 : N ;
  reaktorkatastrof_nn_1 : N ;
  reaktorsaekerhet_nn_1 : N ;
  reaktortyp_nn_1 : N ;
  reaktorutslaepp_nn_1 : N ;
  real_av_1 : A ;
  realexamen_nn_1 : N ;
  realia_nn_1 : N ;
  realindex_nn_1 : N ;
  realisation_nn_1 : N ;
  realisationsvinst_nn_1 : N ;
  realiserbar_av_1 : A ;
  realist_nn_1 : N ;
  realistisk_av_1 : A ;
  realiter_ab_1 : Adv ;
  realitet_nn_1 : N ;
  realkapital_nn_1 : N ;
  realkatalog_nn_1 : N ;
  reallinje_nn_1 : N ;
  realloen_nn_1 : N ;
  realsaekerhet_nn_1 : N ;
  realtidsbearbetning_nn_1 : N ;
  realvaerde_nn_1 : N ;
  reamotor_nn_1 : N ;
  reaplan_nn_1 : N ;
  reapris_nn_1 : N ;
  reassurans_nn_1 : N ;
  rebell_nn_1 : N ;
  rebellisk_av_1 : A ;
  rebus_nn_1 : N ;
  receiver_nn_1 : N ;
  recensent_nn_1 : N ;
  recension_nn_1 : N ;
  recensionsexemplar_nn_1 : N ;
  recent_av_1 : A ;
  recentior_nn_1 : N ;
  recept_nn_1 : N ;
  receptarie_nn_1 : N ;
  receptbelagd_av_1 : A ;
  reception_nn_1 : N ;
  receptionist_nn_1 : N ;
  receptiv_av_1 : A ;
  receptivitet_nn_1 : N ;
  receptor_nn_1 : N ;
  receptur_nn_1 : N ;
  recess_nn_1 : N ;
  recession_nn_1 : N ;
  recessiv_av_1 : A ;
  recett_nn_1 : N ;
  recherch_nn_1 : N ;
  recidiv_nn_1 : N ;
  recipiend_nn_1 : N ;
  recipient_nn_1 : N ;
  reciprocitet_nn_1 : N ;
  reciprok_av_1 : A ;
  recit_nn_1 : N ;
  recitation_nn_1 : N ;
  recitativ_nn_1 : N ;
  reda_ab_1 : Adv ;
  redaktion_nn_1 : N ;
  redaktionell_av_1 : A ;
  redaktionssekreterare_nn_1 : N ;
  redaktoer_nn_1 : N ;
  redan_ab_1 : Adv ;
  redare_nn_1 : N ;
  redbar_av_1 : A ;
  redd_nn_1 : N ;
  rederi_nn_1 : N ;
  rederiverksamhet_nn_1 : N ;
  redig_av_1 : A ;
  redikyl_nn_1 : N ;
  redingot_nn_1 : N ;
  redlig_av_1 : A ;
  redligen_ab_1 : Adv ;
  redlighet_nn_1 : N ;
  redloes_av_1 : A ;
  redning_nn_1 : N ;
  redo_av_1 : A ;
  redobogen_av_1 : A ;
  redogoerelse_nn_1 : N ;
  redovisning_nn_1 : N ;
  redoxprocess_nn_1 : N ;
  redskap_nn_1 : N ;
  redskapsmetall_nn_1 : N ;
  reducering_nn_1 : N ;
  reduceringsventil_nn_1 : N ;
  reduktion_nn_1 : N ;
  redundant_av_1 : A ;
  reduplikation_nn_1 : N ;
  redutt_nn_1 : N ;
  reell_av_1 : A ;
  refektorium_nn_1 : N ;
  referat_nn_1 : N ;
  referendum_nn_1 : N ;
  referens_nn_1 : N ;
  referensbibliotek_nn_1 : N ;
  referensgrupp_nn_1 : N ;
  referensmaterial_nn_1 : N ;
  referenspunkt_nn_1 : N ;
  referensram_nn_1 : N ;
  referenssort_nn_1 : N ;
  referenssystem_nn_1 : N ;
  referent_nn_1 : N ;
  refill_nn_1 : N ;
  reflektion_nn_1 : N ;
  reflektor_nn_1 : N ;
  reflex_nn_1 : N ;
  reflexion_nn_1 : N ;
  reflexiv_av_1 : A ;
  reflexmaessig_av_1 : A ;
  reform_nn_1 : N ;
  reformation_nn_1 : N ;
  reformator_nn_1 : N ;
  reformering_nn_1 : N ;
  reformert_av_1 : A ;
  reformist_nn_1 : N ;
  refraeng_nn_1 : N ;
  refraengsaangare_nn_1 : N ;
  refraktion_nn_1 : N ;
  refraktor_nn_1 : N ;
  refug_nn_1 : N ;
  regal_av_1 : A ;
  regal_nn_1 : N ;
  regalskepp_nn_1 : N ;
  regel_nn_1 : N ;
  regel_nn_2 : N ;
  regelbaat_nn_1 : N ;
  regelbrott_nn_1 : N ;
  regelbunden_av_1 : A ;
  regelbundenhet_nn_1 : N ;
  regelloes_av_1 : A ;
  regelraett_av_1 : A ;
  regelvidrig_av_1 : A ;
  regementschef_nn_1 : N ;
  regementsofficer_nn_1 : N ;
  regeneration_nn_1 : N ;
  regenerator_nn_1 : N ;
  regent_nn_1 : N ;
  regentlaengd_nn_1 : N ;
  regering_nn_1 : N ;
  regeringsbaenk_nn_1 : N ;
  regeringsbeslut_nn_1 : N ;
  regeringschef_nn_1 : N ;
  regeringsform_nn_1 : N ;
  regeringskansli_nn_1 : N ;
  regeringskrets_nn_1 : N ;
  regeringsmakt_nn_1 : N ;
  regeringsmedlem_nn_1 : N ;
  regeringsorgan_nn_1 : N ;
  regeringsparti_nn_1 : N ;
  regeringsproposition_nn_1 : N ;
  regeringsraad_nn_1 : N ;
  regeringsraett_nn_1 : N ;
  regim_nn_1 : N ;
  region_nn_1 : N ;
  regional_av_1 : A ;
  regionplan_nn_1 : N ;
  regionsjukhus_nn_1 : N ;
  regionstyrelse_nn_1 : N ;
  regissoer_nn_1 : N ;
  register_nn_1 : N ;
  registerknapp_nn_1 : N ;
  registerton_nn_1 : N ;
  registrator_nn_1 : N ;
  registratur_nn_1 : N ;
  registrering_nn_1 : N ;
  registreringsnummer_nn_1 : N ;
  registreringsskylt_nn_1 : N ;
  reglage_nn_1 : N ;
  reglementarisk_av_1 : A ;
  reglementsenlig_av_1 : A ;
  reglementsvidrig_av_1 : A ;
  reglering_nn_1 : N ;
  regn_nn_1 : N ;
  regnande_nn_1 : N ;
  regnbaage_nn_1 : N ;
  regnbaagshinna_nn_1 : N ;
  regndroppe_nn_1 : N ;
  regnig_av_1 : A ;
  regnmaetare_nn_1 : N ;
  regnmoln_nn_1 : N ;
  regnomraade_nn_1 : N ;
  regnperiod_nn_1 : N ;
  regnskog_nn_1 : N ;
  regntaet_av_1 : A ;
  regntid_nn_1 : N ;
  regntung_av_1 : A ;
  regnvatten_nn_1 : N ;
  regress_nn_1 : N ;
  regression_nn_1 : N ;
  regressiv_av_1 : A ;
  regular_av_1 : A ;
  regularitet_nn_1 : N ;
  regulator_nn_1 : N ;
  reguljaer_av_1 : A ;
  rehabilitering_nn_1 : N ;
  rehabiliteringshem_nn_1 : N ;
  reifikation_nn_1 : N ;
  reinkarnation_nn_1 : N ;
  rejael_av_1 : A ;
  rek_nn_1 : N ;
  rekapitulation_nn_1 : N ;
  reklam_nn_1 : N ;
  reklamation_nn_1 : N ;
  reklampeng_nn_1 : N ;
  reklamplakat_nn_1 : N ;
  reko_av_1 : A ;
  rekognoscering_nn_1 : N ;
  rekognosering_nn_1 : N ;
  rekommendabel_av_1 : A ;
  rekommendation_nn_1 : N ;
  rekommendationsbrev_nn_1 : N ;
  rekonstruktion_nn_1 : N ;
  rekord_nn_1 : N ;
  rekorderlig_av_1 : A ;
  rekreation_nn_1 : N ;
  rekreationsanlaeggning_nn_1 : N ;
  rekreationsskog_nn_1 : N ;
  rekreativ_av_1 : A ;
  rekryt_nn_1 : N ;
  rekrytering_nn_1 : N ;
  rektangel_nn_1 : N ;
  rektangulaer_av_1 : A ;
  rektascension_nn_1 : N ;
  rektifikation_nn_1 : N ;
  rektion_nn_1 : N ;
  rektor_nn_1 : N ;
  rektorat_nn_1 : N ;
  rektorsomraade_nn_1 : N ;
  rekurrens_nn_1 : N ;
  rekurrensrelation_nn_1 : N ;
  rekviem_nn_1 : N ;
  rekvisit_nn_1 : N ;
  rekvisition_nn_1 : N ;
  rekvisitoer_nn_1 : N ;
  rekyl_nn_1 : N ;
  relae_nn_1 : N ;
  relaestation_nn_1 : N ;
  relation_nn_1 : N ;
  relationstal_nn_1 : N ;
  relativ_av_1 : A ;
  relativist_nn_1 : N ;
  relativistisk_av_1 : A ;
  relativitet_nn_1 : N ;
  relativpronomen_nn_1 : N ;
  relativsats_nn_1 : N ;
  relativt_ab_1 : Adv ;
  relaxation_nn_1 : N ;
  release_nn_1 : N ;
  relevant_av_1 : A ;
  reliabel_av_1 : A ;
  reliabilitet_nn_1 : N ;
  relief_nn_1 : N ;
  religioes_av_1 : A ;
  religion_nn_1 : N ;
  religionsfoerfoeljelse_nn_1 : N ;
  religionsfrihet_nn_1 : N ;
  religionslaera_nn_1 : N ;
  religionsstiftare_nn_1 : N ;
  religiositet_nn_1 : N ;
  relik_nn_1 : N ;
  relikt_nn_1 : N ;
  reling_nn_1 : N ;
  relingsmanning_nn_1 : N ;
  rem_nn_1 : N ;
  rem_nn_2 : N ;
  remarkabel_av_1 : A ;
  remburs_nn_1 : N ;
  remedium_nn_1 : N ;
  remi_nn_1 : N ;
  reminiscens_nn_1 : N ;
  remis_nn_2 : N ;
  remiss_nn_1 : N ;
  remissdebatt_nn_1 : N ;
  remissvar_nn_1 : N ;
  remissyttrande_nn_1 : N ;
  remittent_av_1 : A ;
  remittent_nn_1 : N ;
  remmare_nn_1 : N ;
  remont_nn_1 : N ;
  remouladsaas_nn_1 : N ;
  remtyg_nn_1 : N ;
  remuladsaas_nn_1 : N ;
  ren_ab_1 : Adv ;
  ren_av_1 : A ;
  ren_nn_1 : N ;
  renaessans_nn_1 : N ;
  renaessansmaenniska_nn_1 : N ;
  renben_nn_1 : N ;
  rendezvous_nn_1 : N ;
  renegat_nn_1 : N ;
  renfaell_nn_1 : N ;
  rengoering_nn_1 : N ;
  rengoeringsmedel_nn_1 : N ;
  renhaallningsgubbe_nn_1 : N ;
  renhaarig_av_1 : A ;
  renhet_nn_1 : N ;
  renhorn_nn_1 : N ;
  rening_nn_1 : N ;
  reningsverk_nn_1 : N ;
  renjaegare_nn_1 : N ;
  renjakt_nn_1 : N ;
  renko_nn_1 : N ;
  renkonter_nn_1 : N ;
  renkonterstrid_nn_1 : N ;
  renlaerig_av_1 : A ;
  renlaerighet_nn_1 : N ;
  renlav_nn_1 : N ;
  renlevnad_nn_1 : N ;
  renlevnadsman_nn_1 : N ;
  renlig_av_1 : A ;
  renlighet_nn_1 : N ;
  renmaerke_nn_1 : N ;
  renmage_nn_1 : N ;
  renons_av_1 : A ;
  renovation_nn_1 : N ;
  renovering_nn_1 : N ;
  renoxe_nn_1 : N ;
  renrasig_av_1 : A ;
  renseri_nn_1 : N ;
  renskiljning_nn_1 : N ;
  renskinn_nn_1 : N ;
  renskinnspaels_nn_1 : N ;
  renskoetare_nn_1 : N ;
  renskriva_vb_1 : V ;
  renskrivning_nn_1 : N ;
  rensning_nn_1 : N ;
  rentav_ab_1 : Adv ;
  rentier_nn_1 : N ;
  rentjur_nn_1 : N ;
  rentre_nn_1 : N ;
  rentutav_ab_1 : Adv ;
  reol_nn_1 : N ;
  reostat_nn_1 : N ;
  rep_nn_1 : N ;
  repaenda_nn_1 : N ;
  reparabel_av_1 : A ;
  reparation_nn_1 : N ;
  reparatoer_nn_1 : N ;
  repartition_nn_1 : N ;
  repertoar_nn_1 : N ;
  repetergevaer_nn_1 : N ;
  repetition_nn_1 : N ;
  repetitionsoevning_nn_1 : N ;
  repetitoer_nn_1 : N ;
  repetitorium_nn_1 : N ;
  repig_av_1 : A ;
  replik_nn_1 : N ;
  replipunkt_nn_1 : N ;
  repmaanad_nn_1 : N ;
  repoevning_nn_1 : N ;
  reportage_nn_1 : N ;
  reportagebok_nn_1 : N ;
  reporter_nn_1 : N ;
  representant_nn_1 : N ;
  representation_nn_1 : N ;
  representativ_av_1 : A ;
  repressalie_nn_1 : N ;
  repressiv_av_1 : A ;
  reprimand_nn_1 : N ;
  repris_nn_1 : N ;
  repristecken_nn_1 : N ;
  reproduktion_nn_1 : N ;
  repslagare_nn_1 : N ;
  repstege_nn_1 : N ;
  reptil_nn_1 : N ;
  republik_nn_1 : N ;
  republikan_nn_1 : N ;
  republikansk_av_1 : A ;
  repulsion_nn_1 : N ;
  repulsiv_av_1 : A ;
  reputerlig_av_1 : A ;
  resaar_nn_1 : N ;
  resande_nn_1 : N ;
  resandebok_nn_1 : N ;
  rese_nn_1 : N ;
  resebiljett_nn_1 : N ;
  resebyraa_nn_1 : N ;
  resecheck_nn_1 : N ;
  resefoerbud_nn_1 : N ;
  resegrammofon_nn_1 : N ;
  resekreditiv_nn_1 : N ;
  resektion_nn_1 : N ;
  reseledare_nn_1 : N ;
  resenaer_nn_1 : N ;
  reseraekning_nn_1 : N ;
  reserv_nn_1 : N ;
  reservant_nn_1 : N ;
  reservare_nn_1 : N ;
  reservat_nn_1 : N ;
  reservation_nn_1 : N ;
  reservdel_nn_1 : N ;
  reservlager_nn_1 : N ;
  reservnaering_nn_1 : N ;
  reservoar_nn_1 : N ;
  reservofficer_nn_1 : N ;
  reservspelare_nn_1 : N ;
  reseskildring_nn_1 : N ;
  residens_nn_1 : N ;
  residensstad_nn_1 : N ;
  residuum_nn_1 : N ;
  resistensomraade_nn_1 : N ;
  resistent_av_1 : A ;
  resistivitet_nn_1 : N ;
  resistor_nn_1 : N ;
  resklass_nn_1 : N ;
  reskript_nn_1 : N ;
  reslig_av_1 : A ;
  resning_nn_1 : N ;
  resolut_av_1 : A ;
  resolution_nn_1 : N ;
  resonabel_av_1 : A ;
  resonansbotten_nn_1 : N ;
  resonemang_nn_1 : N ;
  resonemangskarusell_nn_1 : N ;
  resonemangsparti_nn_1 : N ;
  resonlig_av_1 : A ;
  resonoer_nn_1 : N ;
  respass_nn_1 : N ;
  respektabel_av_1 : A ;
  respektfull_av_1 : A ;
  respektingivande_av_1 : A ;
  respektive_av_1 : A ;
  respektloes_av_1 : A ;
  respirator_nn_1 : N ;
  respiratorisk_av_1 : A ;
  respit_nn_1 : N ;
  respondent_nn_1 : N ;
  ressentiment_nn_1 : N ;
  rest_nn_1 : N ;
  restaurang_nn_1 : N ;
  restauranggaest_nn_1 : N ;
  restaurangkoek_nn_1 : N ;
  restaurangvagn_nn_1 : N ;
  restauration_nn_1 : N ;
  restauratoer_nn_1 : N ;
  restaurator_nn_1 : N ;
  restauratris_nn_1 : N ;
  restaurering_nn_1 : N ;
  restitution_nn_1 : N ;
  restlaengd_nn_1 : N ;
  restlager_nn_1 : N ;
  restloes_av_1 : A ;
  restprodukt_nn_1 : N ;
  restriktion_nn_1 : N ;
  restriktiv_av_1 : A ;
  restskatt_nn_1 : N ;
  resultant_nn_1 : N ;
  resultat_nn_1 : N ;
  resultativ_av_1 : A ;
  resultatloes_av_1 : A ;
  resultatraekning_nn_1 : N ;
  resultatredovisning_nn_1 : N ;
  resume_nn_1 : N ;
  resurs_nn_1 : N ;
  resvaeg_nn_1 : N ;
  retardation_nn_1 : N ;
  retbarhet_nn_1 : N ;
  retfull_av_1 : A ;
  retlig_av_1 : A ;
  retning_nn_1 : N ;
  retor_nn_1 : N ;
  retoriker_nn_1 : N ;
  retorisk_av_1 : A ;
  retort_nn_1 : N ;
  retraett_nn_1 : N ;
  retraettplats_nn_1 : N ;
  retriever_nn_1 : N ;
  retroaktiv_av_1 : A ;
  retrospektiv_av_1 : A ;
  retsam_av_1 : A ;
  retsamhet_nn_1 : N ;
  retur_nn_1 : N ;
  returglas_nn_1 : N ;
  returmatch_nn_1 : N ;
  returporto_nn_1 : N ;
  retusch_nn_1 : N ;
  reumatiker_nn_1 : N ;
  reumatisk_av_1 : A ;
  reumatolog_nn_1 : N ;
  rev_nn_1 : N ;
  rev_nn_2 : N ;
  revaer_nn_1 : N ;
  revansch_nn_1 : N ;
  revben_nn_1 : N ;
  revbensspjaell_nn_1 : N ;
  revel_nn_1 : N ;
  revelation_nn_1 : N ;
  revelj_nn_1 : N ;
  reveny_nn_1 : N ;
  reverens_nn_1 : N ;
  reverenter_ab_1 : Adv ;
  revers_nn_1 : N ;
  reversal_nn_1 : N ;
  reversibel_av_1 : A ;
  revider_nn_1 : N ;
  revir_nn_1 : N ;
  revision_nn_1 : N ;
  revisionist_nn_1 : N ;
  revisionsberaettelse_nn_1 : N ;
  revisionssekreterare_nn_1 : N ;
  revisor_nn_1 : N ;
  revning_nn_1 : N ;
  revoke_nn_1 : N ;
  revolt_nn_1 : N ;
  revoltoer_nn_1 : N ;
  revolution_nn_1 : N ;
  revolutionaer_av_1 : A ;
  revolutionaer_nn_1 : N ;
  revolutionerande_av_1 : A ;
  revolver_nn_1 : N ;
  revorm_nn_1 : N ;
  revy_nn_1 : N ;
  revyartist_nn_1 : N ;
  rh_faktor_nn_1 : N ;
  rh_negativ_av_1 : A ;
  rh_positiv_av_1 : A ;
  rhensk_av_1 : A ;
  rhenvin_nn_1 : N ;
  rhizom_nn_1 : N ;
  rhodesier_nn_1 : N ;
  rhodesisk_av_1 : A ;
  rhododendron_nn_1 : N ;
  ri_nn_1 : N ;
  ribbstol_nn_1 : N ;
  ribbvalv_nn_1 : N ;
  ribosom_nn_1 : N ;
  ricinbuske_nn_1 : N ;
  rickettsie_nn_1 : N ;
  rickig_av_1 : A ;
  rickshaw_nn_1 : N ;
  rida_vb_1 : V ;
  ridaa_nn_1 : N ;
  ridaafall_nn_1 : N ;
  ridborgarmaerke_nn_1 : N ;
  riddare_nn_1 : N ;
  riddarhus_nn_1 : N ;
  riddarorden_nn_1 : N ;
  riddarslag_nn_1 : N ;
  riddarsporre_nn_1 : N ;
  ridderlig_av_1 : A ;
  riddersman_nn_1 : N ;
  ridhaest_nn_1 : N ;
  ridhaestdressyr_nn_1 : N ;
  ridhus_nn_1 : N ;
  ridikyl_nn_1 : N ;
  ridinstruktoer_nn_1 : N ;
  ridkunnig_av_1 : A ;
  ridkunnighet_nn_1 : N ;
  ridkunnighetsprov_nn_1 : N ;
  ridning_nn_1 : N ;
  ridsaar_nn_1 : N ;
  ridspoe_nn_1 : N ;
  ridstoevel_nn_1 : N ;
  ridtaevling_nn_1 : N ;
  ridtur_nn_1 : N ;
  riesenschnauzer_nn_1 : N ;
  riff_nn_1 : N ;
  rififikupp_nn_1 : N ;
  rigel_nn_1 : N ;
  rigg_nn_1 : N ;
  rigoroes_av_1 : A ;
  rik_av_1 : A ;
  rikedom_nn_1 : N ;
  rikeman_nn_1 : N ;
  rikemansbarn_nn_1 : N ;
  rikhaltig_av_1 : A ;
  riklig_av_1 : A ;
  rikligen_ab_1 : Adv ;
  rikoschett_nn_1 : N ;
  riks_nn_1 : N ;
  riksaaklagare_nn_1 : N ;
  riksantikvarie_nn_1 : N ;
  riksarkiv_nn_1 : N ;
  riksarkivarie_nn_1 : N ;
  riksbank_nn_1 : N ;
  riksbekant_av_1 : A ;
  riksbibliotekarie_nn_1 : N ;
  riksbyggare_nn_1 : N ;
  riksdag_nn_1 : N ;
  riksdagsgrupp_nn_1 : N ;
  riksdagshus_nn_1 : N ;
  riksdagskvinna_nn_1 : N ;
  riksdagsledamot_nn_1 : N ;
  riksdagsman_nn_1 : N ;
  riksdagsmandat_nn_1 : N ;
  riksdagsordning_nn_1 : N ;
  riksdagsparti_nn_1 : N ;
  riksdagsprotokoll_nn_1 : N ;
  riksdagssammantraede_nn_1 : N ;
  riksdagsval_nn_1 : N ;
  riksdaler_nn_1 : N ;
  riksfoerbund_nn_1 : N ;
  riksfoerestaandare_nn_1 : N ;
  riksgenomsnitt_nn_1 : N ;
  riksgraens_nn_1 : N ;
  rikskansler_nn_1 : N ;
  rikslikare_nn_1 : N ;
  riksmarskalk_nn_1 : N ;
  riksmoete_nn_1 : N ;
  riksnaet_nn_1 : N ;
  riksnyckel_nn_1 : N ;
  riksomfattande_av_1 : A ;
  riksorganisation_nn_1 : N ;
  riksplanering_nn_1 : N ;
  riksprototyp_nn_1 : N ;
  riksraad_nn_1 : N ;
  riksraett_nn_1 : N ;
  riksroes_nn_1 : N ;
  rikssamtal_nn_1 : N ;
  riksspraak_nn_1 : N ;
  rikssvensk_av_1 : A ;
  rikstidning_nn_1 : N ;
  riksvaeg_nn_1 : N ;
  riksvapen_nn_1 : N ;
  riksviktig_av_1 : A ;
  riktig_av_1 : A ;
  riktighet_nn_1 : N ;
  riktinstrument_nn_1 : N ;
  riktkarl_nn_1 : N ;
  riktlinje_nn_1 : N ;
  riktmaerke_nn_1 : N ;
  riktmedel_nn_1 : N ;
  riktning_nn_1 : N ;
  riktningskoefficient_nn_1 : N ;
  riktnummer_nn_1 : N ;
  riktpris_nn_1 : N ;
  riktpunkt_nn_1 : N ;
  rim_nn_1 : N ;
  rimlexikon_nn_1 : N ;
  rimlig_av_1 : A ;
  rimligen_ab_1 : Adv ;
  rimlighet_nn_1 : N ;
  rimligtvis_ab_1 : Adv ;
  rimsmed_nn_1 : N ;
  rimturs_nn_1 : N ;
  ring_nn_1 : N ;
  ringa_av_1 : A ;
  ringaktning_nn_1 : N ;
  ringare_nn_1 : N ;
  ringart_nn_1 : N ;
  ringberg_nn_1 : N ;
  ringbrosk_nn_1 : N ;
  ringbrynja_nn_1 : N ;
  ringdans_nn_1 : N ;
  ringdomare_nn_1 : N ;
  ringfinger_nn_1 : N ;
  ringformig_av_1 : A ;
  ringhet_nn_1 : N ;
  ringlek_nn_1 : N ;
  ringmask_nn_1 : N ;
  ringmur_nn_1 : N ;
  ringning_nn_1 : N ;
  ringorm_nn_1 : N ;
  ringpaerm_nn_1 : N ;
  ringprydd_av_1 : A ;
  ringraev_nn_1 : N ;
  ringrev_nn_1 : N ;
  ringrostig_av_1 : A ;
  ringstruktur_nn_1 : N ;
  ringtryck_nn_1 : N ;
  ringvrak_nn_1 : N ;
  rink_nn_1 : N ;
  rinna_vb_1 : V ;
  ripost_nn_1 : N ;
  rippel_nn_1 : N ;
  rips_nn_1 : N ;
  ris_nn_1 : N ;
  risgryn_nn_1 : N ;
  rishoeg_nn_1 : N ;
  risig_av_1 : A ;
  risk_nn_1 : N ;
  riskabel_av_1 : A ;
  riskfaktor_nn_1 : N ;
  riskfylld_av_1 : A ;
  riskgrupp_nn_1 : N ;
  riskmodell_nn_1 : N ;
  risknivaa_nn_1 : N ;
  riskomraade_nn_1 : N ;
  risktagare_nn_1 : N ;
  risktal_nn_1 : N ;
  riskuppfattning_nn_1 : N ;
  riskvillig_av_1 : A ;
  riskzon_nn_1 : N ;
  risoll_nn_1 : N ;
  risraett_nn_1 : N ;
  rissel_nn_1 : N ;
  ristning_nn_1 : N ;
  risvase_nn_1 : N ;
  rit_nn_1 : N ;
  ritapparat_nn_1 : N ;
  ritardando_ab_1 : Adv ;
  ritardando_nn_1 : N ;
  ritare_nn_1 : N ;
  ritbestick_nn_1 : N ;
  ritblock_nn_1 : N ;
  ritbord_nn_1 : N ;
  ritkol_nn_1 : N ;
  ritning_nn_1 : N ;
  rits_nn_1 : N ;
  ritt_nn_1 : N ;
  ritual_nn_1 : N ;
  ritualism_nn_1 : N ;
  ritualmord_nn_1 : N ;
  rituell_av_1 : A ;
  riva_vb_1 : V ;
  rival_nn_1 : N ;
  rivalitet_nn_1 : N ;
  rivig_av_1 : A ;
  rivjaern_nn_1 : N ;
  rivning_nn_1 : N ;
  rivningshus_nn_1 : N ;
  rivningskaak_nn_1 : N ;
  rivningskontrakt_nn_1 : N ;
  rivningslaegenhet_nn_1 : N ;
  rivningstomt_nn_1 : N ;
  rivstart_nn_1 : N ;
  ro_nn_2 : N ;
  ro_ro_fartyg_nn_1 : N ;
  roadie_nn_1 : N ;
  rob_nn_1 : N ;
  robbert_nn_1 : N ;
  robe_nn_1 : N ;
  robinsonad_nn_1 : N ;
  robot_nn_1 : N ;
  robotvapen_nn_1 : N ;
  robust_av_1 : A ;
  rock_nn_1 : N ;
  rockad_nn_1 : N ;
  rockring_nn_1 : N ;
  rockslusk_nn_1 : N ;
  rockvaktmaestare_nn_1 : N ;
  rodd_nn_1 : N ;
  roddarbaenk_nn_1 : N ;
  roddare_nn_1 : N ;
  roddarmadam_nn_1 : N ;
  roddarsaang_nn_1 : N ;
  roddarslav_nn_1 : N ;
  roddbaat_nn_1 : N ;
  rodel_nn_1 : N ;
  rodeo_nn_1 : N ;
  roder_nn_1 : N ;
  rodnad_nn_1 : N ;
  rododendron_nn_1 : N ;
  roe_nn_1 : N ;
  roed_av_1 : A ;
  roedaktig_av_1 : A ;
  roedblaa_av_1 : A ;
  roedblind_av_1 : A ;
  roedblommig_av_1 : A ;
  roedblond_av_1 : A ;
  roedbok_nn_1 : N ;
  roedbrokig_av_1 : A ;
  roedbrun_av_1 : A ;
  roedbrusig_av_1 : A ;
  roedfilter_nn_1 : N ;
  roedflammig_av_1 : A ;
  roedgraaten_av_1 : A ;
  roedgroenblind_av_1 : A ;
  roedhaarig_av_1 : A ;
  roedhake_nn_1 : N ;
  roedhakesaangare_nn_1 : N ;
  roeding_nn_1 : N ;
  roedlaett_av_1 : A ;
  roedlila_av_1 : A ;
  roedmosig_av_1 : A ;
  roednaest_av_1 : A ;
  roedraev_nn_1 : N ;
  roedskinn_nn_1 : N ;
  roedspraengd_av_1 : A ;
  roedstjaert_nn_1 : N ;
  roedtunga_nn_1 : N ;
  roedvaeppling_nn_1 : N ;
  roedvin_nn_1 : N ;
  roejdykare_nn_1 : N ;
  roejel_nn_1 : N ;
  roejning_nn_1 : N ;
  roek_nn_1 : N ;
  roekare_nn_1 : N ;
  roekbomb_nn_1 : N ;
  roekdetektor_nn_1 : N ;
  roekdykare_nn_1 : N ;
  roekelse_nn_1 : N ;
  roekelsekar_nn_1 : N ;
  roekeri_nn_1 : N ;
  roekfaang_nn_1 : N ;
  roekgaang_nn_1 : N ;
  roekgas_nn_1 : N ;
  roekig_av_1 : A ;
  roekkanal_nn_1 : N ;
  roekkupe_nn_1 : N ;
  roekmask_nn_1 : N ;
  roekridaa_nn_1 : N ;
  roekring_nn_1 : N ;
  roekrock_nn_1 : N ;
  roeksvag_av_1 : A ;
  roeksvamp_nn_1 : N ;
  roektopas_nn_1 : N ;
  roen_nn_1 : N ;
  roenn_nn_1 : N ;
  roennbaer_nn_1 : N ;
  roentgenapparat_nn_1 : N ;
  roentgenbehandling_nn_1 : N ;
  roentgenbild_nn_1 : N ;
  roentgenkamera_nn_1 : N ;
  roentgenmikroskop_nn_1 : N ;
  roentgenroer_nn_1 : N ;
  roentgenstraalande_av_1 : A ;
  roentgenundersoekning_nn_1 : N ;
  roer_nn_1 : N ;
  roerande_av_1 : A ;
  roerblad_nn_1 : N ;
  roerd_av_1 : A ;
  roerdrom_nn_1 : N ;
  roerelse_nn_1 : N ;
  roerelsecentrum_nn_1 : N ;
  roerelsefrihet_nn_1 : N ;
  roerelseinkomst_nn_1 : N ;
  roerelsekapital_nn_1 : N ;
  roerelsekommando_nn_1 : N ;
  roerelsemaengd_nn_1 : N ;
  roerelsemaengdsmoment_nn_1 : N ;
  roerelsemoenster_nn_1 : N ;
  roerelsestoerning_nn_1 : N ;
  roerig_av_1 : A ;
  roering_nn_1 : N ;
  roerlaeggare_nn_1 : N ;
  roerledning_nn_1 : N ;
  roerlig_av_1 : A ;
  roerlighet_nn_1 : N ;
  roermokare_nn_1 : N ;
  roermontoer_nn_1 : N ;
  roersaangare_nn_1 : N ;
  roersopp_nn_1 : N ;
  roersvamp_nn_1 : N ;
  roertaang_nn_1 : N ;
  roes_nn_1 : N ;
  roest_nn_1 : N ;
  roest_nn_2 : N ;
  roestetal_nn_1 : N ;
  roestjaern_nn_1 : N ;
  roestkort_nn_1 : N ;
  roestlaengd_nn_1 : N ;
  roestraettsfraaga_nn_1 : N ;
  roestsedel_nn_1 : N ;
  roeststyrka_nn_1 : N ;
  roetaegg_nn_1 : N ;
  roetkammare_nn_1 : N ;
  roetmaanad_nn_1 : N ;
  roev_nn_1 : N ;
  roevare_nn_1 : N ;
  roevarhistoria_nn_1 : N ;
  roevarpris_nn_1 : N ;
  roeveri_nn_1 : N ;
  roevslickare_nn_1 : N ;
  rofylld_av_1 : A ;
  rogivande_av_1 : A ;
  rojalist_nn_1 : N ;
  rojalistisk_av_1 : A ;
  rokokodam_nn_1 : N ;
  rolig_av_1 : A ;
  rolighet_nn_1 : N ;
  rolighetsminister_nn_1 : N ;
  roll_nn_1 : N ;
  roll_nn_2 : N ;
  roll_on'2Froll_off_fartyg_nn_1 : N ;
  roll_on_deodorant_nn_1 : N ;
  roller_nn_1 : N ;
  rollfack_nn_1 : N ;
  rollmops_nn_1 : N ;
  rollspel_nn_1 : N ;
  roloes_av_1 : A ;
  roman_nn_1 : N ;
  romanesk_av_1 : A ;
  romanfoerfattare_nn_1 : N ;
  romanist_nn_1 : N ;
  romanistik_nn_1 : N ;
  romanistisk_av_1 : A ;
  romans_nn_1 : N ;
  romansk_av_1 : A ;
  romantiker_nn_1 : N ;
  romantisering_nn_1 : N ;
  romantisk_av_1 : A ;
  romare_nn_1 : N ;
  romb_nn_1 : N ;
  rombisk_av_1 : A ;
  romboid_nn_1 : N ;
  romersk_av_1 : A ;
  romersk_katolsk_av_1 : A ;
  rond_nn_1 : N ;
  rondell_nn_1 : N ;
  rondo_nn_1 : N ;
  rop_nn_1 : N ;
  roquefortost_nn_1 : N ;
  rorgaengare_nn_1 : N ;
  rorkult_nn_1 : N ;
  rorpinne_nn_1 : N ;
  rorschachtest_nn_1 : N ;
  rorsman_nn_1 : N ;
  rosa_av_1 : A ;
  rosenbroed_nn_1 : N ;
  rosenbuske_nn_1 : N ;
  rosende_av_1 : A ;
  rosengaard_nn_1 : N ;
  rosenkrans_nn_1 : N ;
  rosenmoln_nn_1 : N ;
  rosenmun_nn_1 : N ;
  rosenrasande_av_1 : A ;
  rosenroed_av_1 : A ;
  rosenstock_nn_1 : N ;
  rosett_nn_1 : N ;
  rosettfoenster_nn_1 : N ;
  rosettmoenster_nn_1 : N ;
  rosettstaelld_av_1 : A ;
  rosevin_nn_1 : N ;
  rosig_av_1 : A ;
  roskarl_nn_1 : N ;
  rosling_nn_1 : N ;
  rosmarin_nn_1 : N ;
  rospigg_nn_1 : N ;
  rosslig_av_1 : A ;
  rossling_nn_1 : N ;
  rostbiff_nn_1 : N ;
  rostfri_av_1 : A ;
  rostig_av_1 : A ;
  rostroed_av_1 : A ;
  rostskydd_nn_1 : N ;
  rostskyddsfaerg_nn_1 : N ;
  rostskyddsmedel_nn_1 : N ;
  rostsvamp_nn_1 : N ;
  rot_nn_1 : N ;
  rotation_nn_1 : N ;
  rotationsaxel_nn_1 : N ;
  rotationshastighet_nn_1 : N ;
  rotationspress_nn_1 : N ;
  rotborste_nn_1 : N ;
  rote_nn_1 : N ;
  rotel_nn_1 : N ;
  rotfast_av_1 : A ;
  rotfrukt_nn_1 : N ;
  rotfyllning_nn_1 : N ;
  rotgroensak_nn_1 : N ;
  rotisseri_nn_1 : N ;
  rotkanal_nn_1 : N ;
  rotknoel_nn_1 : N ;
  rotloes_av_1 : A ;
  rotmaerke_nn_1 : N ;
  rotogravyr_nn_1 : N ;
  rotor_nn_1 : N ;
  rotorblad_nn_1 : N ;
  rotsak_nn_1 : N ;
  rotstock_nn_1 : N ;
  rotsystem_nn_1 : N ;
  rottecken_nn_1 : N ;
  rotting_nn_1 : N ;
  rottraad_nn_1 : N ;
  rottweiler_nn_1 : N ;
  roue_nn_1 : N ;
  rough_nn_1 : N ;
  roulad_nn_1 : N ;
  roulett_nn_1 : N ;
  rousseauan_nn_1 : N ;
  route_nn_1 : N ;
  rov_nn_1 : N ;
  rovdjur_nn_1 : N ;
  rovfaagel_nn_1 : N ;
  rovfisk_nn_1 : N ;
  rovgirig_av_1 : A ;
  rovlysten_av_1 : A ;
  rovriddare_nn_1 : N ;
  royalty_nn_1 : N ;
  rubank_nn_1 : N ;
  rubbning_nn_1 : N ;
  rubel_nn_1 : N ;
  rubin_nn_1 : N ;
  rubinroed_av_1 : A ;
  rubrik_nn_1 : N ;
  ruckel_nn_1 : N ;
  rucklare_nn_1 : N ;
  rucklig_av_1 : A ;
  ruderatvaext_nn_1 : N ;
  rudiment_nn_1 : N ;
  rudimentaer_av_1 : A ;
  rudis_av_1 : A ;
  ruff_nn_1 : N ;
  ruffig_av_1 : A ;
  rufftak_nn_1 : N ;
  rufsig_av_1 : A ;
  rugg_nn_1 : N ;
  rugge_nn_1 : N ;
  ruggig_av_1 : A ;
  ruin_nn_1 : N ;
  rulad_nn_1 : N ;
  rulett_nn_1 : N ;
  rullad_nn_1 : N ;
  rullager_nn_1 : N ;
  rullbaelte_nn_1 : N ;
  rullband_nn_1 : N ;
  rullbar_av_1 : A ;
  rullbord_nn_1 : N ;
  rullbraede_nn_1 : N ;
  rulle_nn_1 : N ;
  rullgardin_nn_1 : N ;
  rullrev_nn_1 : N ;
  rullskridsko_nn_1 : N ;
  rullsten_nn_1 : N ;
  rullstensaas_nn_1 : N ;
  rullstol_nn_1 : N ;
  rullstolsbunden_av_1 : A ;
  rultig_av_1 : A ;
  rum_ab_1 : Adv ;
  rum_av_1 : A ;
  rum_nn_1 : N ;
  rumaen_nn_1 : N ;
  rumaensk_av_1 : A ;
  rumaensk_fransk_av_1 : A ;
  rumaenska_nn_2 : N ;
  rumphugga_vb_1 : V ;
  rumpstek_nn_1 : N ;
  rumsadverbial_nn_1 : N ;
  rumsbestaellning_nn_1 : N ;
  rumsbredd_nn_1 : N ;
  rumsfoermedling_nn_1 : N ;
  rumsgranne_nn_1 : N ;
  rumskamrat_nn_1 : N ;
  rumskroekning_nn_1 : N ;
  rumslast_nn_1 : N ;
  rumslig_av_1 : A ;
  rumsren_av_1 : A ;
  rumstemperatur_nn_1 : N ;
  rund_av_1 : A ;
  rundabordskonferens_nn_1 : N ;
  rundbaage_nn_1 : N ;
  rundbrev_nn_1 : N ;
  rundel_nn_1 : N ;
  rundflygning_nn_1 : N ;
  rundfoenster_nn_1 : N ;
  rundfraaga_nn_1 : N ;
  rundhaell_nn_1 : N ;
  rundhaent_av_1 : A ;
  rundhorisont_nn_1 : N ;
  rundhult_nn_1 : N ;
  rundhyllt_av_1 : A ;
  rundkullig_av_1 : A ;
  rundkyrka_nn_1 : N ;
  rundlagd_av_1 : A ;
  rundlig_av_1 : A ;
  rundmaalning_nn_1 : N ;
  rundmask_nn_1 : N ;
  rundmun_nn_1 : N ;
  rundnaett_av_1 : A ;
  rundning_nn_1 : N ;
  rundningsmaerke_nn_1 : N ;
  rundskrivelse_nn_1 : N ;
  rundsmoerjning_nn_1 : N ;
  rundtoern_nn_1 : N ;
  rundtur_nn_1 : N ;
  rundvandring_nn_1 : N ;
  runnare_nn_1 : N ;
  runolog_nn_1 : N ;
  runometer_nn_1 : N ;
  runosaang_nn_1 : N ;
  runrad_nn_1 : N ;
  runskrift_nn_1 : N ;
  runstav_nn_1 : N ;
  runsten_nn_1 : N ;
  runt_ab_1 : Adv ;
  runtikring_ab_1 : Adv ;
  runtom_ab_1 : Adv ;
  runtomkring_ab_1 : Adv ;
  rupie_nn_1 : N ;
  ruptur_nn_1 : N ;
  rural_av_1 : A ;
  rus_nn_1 : N ;
  rusch_nn_1 : N ;
  ruschig_av_1 : A ;
  rusdryck_nn_1 : N ;
  rush_nn_1 : N ;
  rusig_av_1 : A ;
  ruskig_av_1 : A ;
  ruskprick_nn_1 : N ;
  rusning_nn_1 : N ;
  rusningstid_nn_1 : N ;
  russ_nn_1 : N ;
  russin_nn_1 : N ;
  rusthaall_nn_1 : N ;
  rusthaallare_nn_1 : N ;
  rustibuss_nn_1 : N ;
  rustik_av_1 : A ;
  rustkammare_nn_1 : N ;
  rustmaestare_nn_1 : N ;
  rustning_nn_1 : N ;
  ruten_nn_1 : N ;
  ruter_nn_1 : N ;
  rutig_av_1 : A ;
  rutin_nn_1 : N ;
  rutinoperation_nn_1 : N ;
  rutmoenster_nn_1 : N ;
  rutnaet_nn_1 : N ;
  rutsch_nn_1 : N ;
  rutt_nn_1 : N ;
  rutten_av_1 : A ;
  rwandier_nn_1 : N ;
  rwandisk_av_1 : A ;
  ryck_nn_1 : N ;
  rycken_ab_1 : Adv ;
  ryckig_av_1 : A ;
  ryckning_nn_1 : N ;
  ryckvis_ab_1 : Adv ;
  rygg_nn_1 : N ;
  ryggaasstuga_nn_1 : N ;
  ryggbesvaer_nn_1 : N ;
  ryggbiff_nn_1 : N ;
  rygglaege_nn_1 : N ;
  ryggmaergsbedoevning_nn_1 : N ;
  ryggmaergsprov_nn_1 : N ;
  ryggornament_nn_1 : N ;
  ryggparti_nn_1 : N ;
  ryggrad_nn_1 : N ;
  ryggradsdjur_nn_1 : N ;
  ryggradsloes_av_1 : A ;
  ryggsaeck_nn_1 : N ;
  ryggskott_nn_1 : N ;
  ryggslut_nn_1 : N ;
  ryggstoed_nn_1 : N ;
  ryggtavla_nn_1 : N ;
  rykande_ab_1 : Adv ;
  ryktbar_av_1 : A ;
  ryktbarhet_nn_1 : N ;
  ryktborste_nn_1 : N ;
  rykte_nn_1 : N ;
  ryktessmidare_nn_1 : N ;
  ryktesspridning_nn_1 : N ;
  rymd_nn_1 : N ;
  rymddraekt_nn_1 : N ;
  rymdfaerd_nn_1 : N ;
  rymdfaerja_nn_1 : N ;
  rymdfarare_nn_1 : N ;
  rymdfarkost_nn_1 : N ;
  rymdfartsstyrelse_nn_1 : N ;
  rymdkapsel_nn_1 : N ;
  rymdmaatt_nn_1 : N ;
  rymdmateria_nn_1 : N ;
  rymdpromenad_nn_1 : N ;
  rymdraket_nn_1 : N ;
  rymdskepp_nn_1 : N ;
  rymdsond_nn_1 : N ;
  rymdstation_nn_1 : N ;
  rymdstyrelse_nn_1 : N ;
  rymdvapen_nn_1 : N ;
  rymdvinkel_nn_1 : N ;
  rymlig_av_1 : A ;
  rymling_nn_1 : N ;
  rymmare_nn_1 : N ;
  rymning_nn_1 : N ;
  rymningssaeker_av_1 : A ;
  rynkig_av_1 : A ;
  rynkning_nn_1 : N ;
  rysansvaerd_av_1 : A ;
  rysare_nn_1 : N ;
  rysch_nn_1 : N ;
  ryschig_av_1 : A ;
  rysk_amerikansk_av_1 : A ;
  rysk_av_1 : A ;
  ryska_nn_2 : N ;
  ryslig_av_1 : A ;
  rysning_nn_1 : N ;
  ryss_nn_1 : N ;
  ryssgubbe_nn_1 : N ;
  ryssja_nn_1 : N ;
  rytande_nn_1 : N ;
  rytm_nn_1 : N ;
  rytmicitet_nn_1 : N ;
  rytmisk_av_1 : A ;
  rytmsektion_nn_1 : N ;
  ryttare_nn_1 : N ;
  ryttarfolk_nn_1 : N ;
  ryttargaang_nn_1 : N ;
  ryttarlek_nn_1 : N ;
  ryttaruppvisning_nn_1 : N ;
  ryttmaestare_nn_1 : N ;
  saa_ab_1 : Adv ;
  saa_nn_1 : N ;
  saadaer_ab_1 : Adv ;
  saadd_nn_1 : N ;
  saadig_av_1 : A ;
  saag_nn_1 : N ;
  saagblad_nn_1 : N ;
  saagbock_nn_1 : N ;
  saagfisk_nn_1 : N ;
  saagspaan_nn_1 : N ;
  saagtak_nn_1 : N ;
  saagverk_nn_1 : N ;
  saagverksarbetare_nn_1 : N ;
  saagverksindustri_nn_1 : N ;
  saahaer_ab_1 : Adv ;
  saald_av_1 : A ;
  saaledes_ab_1 : Adv ;
  saall_nn_1 : N ;
  saalunda_ab_1 : Adv ;
  saamaskin_nn_1 : N ;
  saanaer_ab_1 : Adv ;
  saang_nn_1 : N ;
  saangare_nn_1 : N ;
  saangarfaagel_nn_1 : N ;
  saangbar_av_1 : A ;
  saangerska_nn_1 : N ;
  saangfaagel_nn_1 : N ;
  saanggudinna_nn_1 : N ;
  saanglek_nn_1 : N ;
  saanglig_av_1 : A ;
  saangmoe_nn_1 : N ;
  saangoevning_nn_1 : N ;
  saangprov_nn_1 : N ;
  saangsaett_nn_1 : N ;
  saangspel_nn_1 : N ;
  saangsvan_nn_1 : N ;
  saangteknik_nn_1 : N ;
  saangtema_nn_1 : N ;
  saaningsman_nn_1 : N ;
  saapass_ab_1 : Adv ;
  saapbubbla_nn_1 : N ;
  saaphal_av_1 : A ;
  saapopera_nn_1 : N ;
  saapvatten_nn_1 : N ;
  saar_nn_1 : N ;
  saarande_av_1 : A ;
  saarbar_av_1 : A ;
  saarig_av_1 : A ;
  saarinfektion_nn_1 : N ;
  saarmarkoer_nn_1 : N ;
  saarnad_nn_1 : N ;
  saas_nn_1 : N ;
  saasig_av_1 : A ;
  saat_nn_1 : N ;
  saate_nn_1 : N ;
  saatillvida_ab_1 : Adv ;
  saavael_ab_1 : Adv ;
  saavitt_ab_1 : Adv ;
  sabadill_nn_1 : N ;
  sabbat_nn_1 : N ;
  sabbatsaar_nn_1 : N ;
  sabbatsbrott_nn_1 : N ;
  sabbatstermin_nn_1 : N ;
  sabbik_nn_1 : N ;
  sabel_nn_1 : N ;
  sabelbajonett_nn_1 : N ;
  sabelbalja_nn_1 : N ;
  sabelbent_av_1 : A ;
  sabellilja_nn_1 : N ;
  sabin_nn_1 : N ;
  sabla_av_1 : A ;
  sabotage_nn_1 : N ;
  sabotoer_nn_1 : N ;
  sachsare_nn_1 : N ;
  sachsisk_av_1 : A ;
  sackarin_nn_1 : N ;
  sackett_nn_1 : N ;
  sadduce_nn_1 : N ;
  sadel_nn_1 : N ;
  sadelbom_nn_1 : N ;
  sadelbrott_nn_1 : N ;
  sadelbruten_av_1 : A ;
  sadelfilt_nn_1 : N ;
  sadelformig_av_1 : A ;
  sadelgjord_nn_1 : N ;
  sadelknapp_nn_1 : N ;
  sadelmakare_nn_1 : N ;
  sadelmakarnaal_nn_1 : N ;
  sadelmakarstift_nn_1 : N ;
  sadelmakeri_nn_1 : N ;
  sadelplats_nn_1 : N ;
  sadelskydd_nn_1 : N ;
  sadeltak_nn_1 : N ;
  sadist_nn_1 : N ;
  sadistisk_av_1 : A ;
  sado_masochistisk_av_1 : A ;
  saeck_nn_1 : N ;
  saeckig_av_1 : A ;
  saeckliknande_av_1 : A ;
  saecksvamp_nn_1 : N ;
  saedescell_nn_1 : N ;
  saedeskaerve_nn_1 : N ;
  saedesledare_nn_1 : N ;
  saedesskyl_nn_1 : N ;
  saedesslag_nn_1 : N ;
  saedestork_nn_1 : N ;
  saedesuttoemning_nn_1 : N ;
  saedgaas_nn_1 : N ;
  saegen_nn_1 : N ;
  saegenomspunnen_av_1 : A ;
  saeker_av_1 : A ;
  saekerhet_nn_1 : N ;
  saekerhetsbaelte_nn_1 : N ;
  saekerhetsbestaemmelse_nn_1 : N ;
  saekerhetsfilosofi_nn_1 : N ;
  saekerhetsfoereskrift_nn_1 : N ;
  saekerhetsgrepp_nn_1 : N ;
  saekerhetskedja_nn_1 : N ;
  saekerhetsman_nn_1 : N ;
  saekerhetsnaal_nn_1 : N ;
  saekerhetspolis_nn_1 : N ;
  saekerhetsproblem_nn_1 : N ;
  saekerhetsrisk_nn_1 : N ;
  saekerhetsskael_nn_1 : N ;
  saekerhetssystem_nn_1 : N ;
  saekerhetsventil_nn_1 : N ;
  saekerligen_ab_1 : Adv ;
  saekring_nn_1 : N ;
  sael_nn_1 : N ;
  saeldjur_nn_1 : N ;
  saelg_nn_1 : N ;
  saeljare_nn_1 : N ;
  saeljbar_av_1 : A ;
  saelkut_nn_1 : N ;
  saell_av_1 : A ;
  saellan_ab_1 : Adv ;
  saelle_nn_1 : N ;
  saellhet_nn_1 : N ;
  saellsam_av_1 : A ;
  saellskap_nn_1 : N ;
  saellskaplig_av_1 : A ;
  saellskapsdam_nn_1 : N ;
  saellskapsdans_nn_1 : N ;
  saellskapsdjur_nn_1 : N ;
  saellskapsliv_nn_1 : N ;
  saellskapsmaenniska_nn_1 : N ;
  saellskapsrum_nn_1 : N ;
  saellskapssjuk_av_1 : A ;
  saellskapsspel_nn_1 : N ;
  saellspord_av_1 : A ;
  saellsynt_av_1 : A ;
  saelltrae_nn_1 : N ;
  saelunge_nn_1 : N ;
  saemskskinn_nn_1 : N ;
  saendare_nn_1 : N ;
  saendebud_nn_1 : N ;
  saendning_nn_1 : N ;
  saeng_nn_1 : N ;
  saengdags_ab_1 : Adv ;
  saengfoesare_nn_1 : N ;
  saengfot_nn_1 : N ;
  saenghimmel_nn_1 : N ;
  saengkammare_nn_1 : N ;
  saengkant_nn_1 : N ;
  saengliggande_av_1 : A ;
  saengroekare_nn_1 : N ;
  saengvaetare_nn_1 : N ;
  saenkhaav_nn_1 : N ;
  saenkning_nn_1 : N ;
  saenkningstecken_nn_1 : N ;
  saenkvaag_nn_1 : N ;
  saer_av_1 : A ;
  saerbo_nn_1 : N ;
  saerdeles_ab_1 : Adv ;
  saerdrag_nn_1 : N ;
  saeregen_av_1 : A ;
  saerfall_nn_1 : N ;
  saerfraaga_nn_1 : N ;
  saerk_nn_1 : N ;
  saerklassig_av_1 : A ;
  saerkullbarn_nn_1 : N ;
  saerla_ab_1 : Adv ;
  saerling_nn_1 : N ;
  saermaerke_nn_1 : N ;
  saerskild_av_1 : A ;
  saerskilt_ab_1 : Adv ;
  saerstaellning_nn_1 : N ;
  saertryck_nn_1 : N ;
  saesong_nn_1 : N ;
  saesongsvis_ab_1 : Adv ;
  saete_nn_1 : N ;
  saeter_nn_1 : N ;
  saeteri_nn_1 : N ;
  saeteritak_nn_1 : N ;
  saetesgaard_nn_1 : N ;
  saett_nn_1 : N ;
  saettare_nn_1 : N ;
  saetteri_nn_1 : N ;
  saettmaskin_nn_1 : N ;
  saettnaet_nn_1 : N ;
  saettning_nn_1 : N ;
  saettpotatis_nn_1 : N ;
  saettsadverbial_nn_1 : N ;
  saevlig_av_1 : A ;
  safari_nn_1 : N ;
  saffransbroed_nn_1 : N ;
  saffransgul_av_1 : A ;
  safir_nn_1 : N ;
  safirnaal_nn_1 : N ;
  saft_nn_1 : N ;
  saftglass_nn_1 : N ;
  saftig_av_1 : A ;
  saftkalas_nn_1 : N ;
  saftkraem_nn_1 : N ;
  saftpress_nn_1 : N ;
  saftsaas_nn_1 : N ;
  saftstation_nn_1 : N ;
  saga_nn_1 : N ;
  sagesman_nn_1 : N ;
  sagoberaettare_nn_1 : N ;
  sagobok_nn_1 : N ;
  sagocykel_nn_1 : N ;
  sagodjur_nn_1 : N ;
  sagofigur_nn_1 : N ;
  sagogryn_nn_1 : N ;
  sagohjaelte_nn_1 : N ;
  sagokrets_nn_1 : N ;
  sagoland_nn_1 : N ;
  sagolik_av_1 : A ;
  sagopalm_nn_1 : N ;
  sagoprins_nn_1 : N ;
  sagosamling_nn_1 : N ;
  sagoskimrande_av_1 : A ;
  sagostund_nn_1 : N ;
  sagovaerld_nn_1 : N ;
  sagovaesen_nn_1 : N ;
  sahib_nn_1 : N ;
  sak_nn_1 : N ;
  sakaegande_nn_1 : N ;
  sakaegare_nn_1 : N ;
  sakdebatt_nn_1 : N ;
  sakdiskussion_nn_1 : N ;
  saker_av_1 : A ;
  sakfel_nn_1 : N ;
  sakfoerare_nn_1 : N ;
  sakfoerhaallande_nn_1 : N ;
  sakfoerklaring_nn_1 : N ;
  sakfoersaekring_nn_1 : N ;
  sakfoerstaandig_av_1 : A ;
  sakfraaga_nn_1 : N ;
  sakframstaellning_nn_1 : N ;
  sakkaennedom_nn_1 : N ;
  sakkunnig_av_1 : A ;
  sakkunnigberedning_nn_1 : N ;
  sakkunnigbetaenkande_nn_1 : N ;
  sakkunniguppdrag_nn_1 : N ;
  sakkunnigutlaatande_nn_1 : N ;
  saklig_av_1 : A ;
  saklighet_nn_1 : N ;
  sakloes_av_1 : A ;
  sakloest_ab_1 : Adv ;
  saknad_nn_1 : N ;
  sakobjekt_nn_1 : N ;
  sakoere_nn_1 : N ;
  sakoereslaengd_nn_1 : N ;
  sakord_nn_1 : N ;
  sakproevning_nn_1 : N ;
  sakraettslig_av_1 : A ;
  sakral_av_1 : A ;
  sakrament_nn_1 : N ;
  sakramental_av_1 : A ;
  sakramentsskaap_nn_1 : N ;
  sakregister_nn_1 : N ;
  sakrilegium_nn_1 : N ;
  sakrosankt_av_1 : A ;
  sakskael_nn_1 : N ;
  saksoekande_av_1 : A ;
  sakta_ab_1 : Adv ;
  sakta_av_1 : A ;
  sakteliga_ab_1 : Adv ;
  sakteligen_ab_1 : Adv ;
  saktfaerdig_av_1 : A ;
  saktmodig_av_1 : A ;
  sakuppgift_nn_1 : N ;
  sakupplysning_nn_1 : N ;
  sal_nn_1 : N ;
  saladjaer_nn_1 : N ;
  salamander_nn_1 : N ;
  salband_nn_1 : N ;
  saldo_nn_1 : N ;
  salig_av_1 : A ;
  saligen_ab_1 : Adv ;
  saliggoerande_av_1 : A ;
  salighet_nn_1 : N ;
  salighetslaera_nn_1 : N ;
  salighetsmedel_nn_1 : N ;
  salighetsrus_nn_1 : N ;
  salighetsvaeg_nn_1 : N ;
  saligprisning_nn_1 : N ;
  salin_nn_1 : N ;
  salinitet_nn_1 : N ;
  salisk_av_1 : A ;
  salivprov_nn_1 : N ;
  salivsug_nn_1 : N ;
  sallad_nn_1 : N ;
  salladsbestick_nn_1 : N ;
  salladshuvud_nn_1 : N ;
  salladsskaal_nn_1 : N ;
  salning_nn_1 : N ;
  salningshorn_nn_1 : N ;
  salomonisk_av_1 : A ;
  salong_nn_1 : N ;
  salongsbaat_nn_1 : N ;
  salongsbiljett_nn_1 : N ;
  salongsbolsjevik_nn_1 : N ;
  salongsfaehig_av_1 : A ;
  salongsfilosof_nn_1 : N ;
  salongsgevaer_nn_1 : N ;
  salongskomedi_nn_1 : N ;
  salongskommunist_nn_1 : N ;
  salongslejon_nn_1 : N ;
  salongsorkester_nn_1 : N ;
  salongsruff_nn_1 : N ;
  salongsuppassare_nn_1 : N ;
  salongsvagn_nn_1 : N ;
  saloon_nn_1 : N ;
  saloondoerr_nn_1 : N ;
  salpeterbakterie_nn_1 : N ;
  salpetersjuderi_nn_1 : N ;
  salpetersyrlighet_nn_1 : N ;
  salpingit_nn_1 : N ;
  salskrake_nn_1 : N ;
  salspatient_nn_1 : N ;
  salt_av_1 : A ;
  salt_nn_1 : N ;
  saltaelskande_av_1 : A ;
  saltaeng_nn_1 : N ;
  saltavlagring_nn_1 : N ;
  saltbad_nn_1 : N ;
  saltbassaeng_nn_1 : N ;
  saltbehov_nn_1 : N ;
  saltbemaengd_av_1 : A ;
  saltbildare_nn_1 : N ;
  saltdamm_nn_1 : N ;
  salteri_nn_1 : N ;
  saltgrop_nn_1 : N ;
  salthalt_nn_1 : N ;
  salthaltig_av_1 : A ;
  saltig_av_1 : A ;
  saltkar_nn_1 : N ;
  saltkoncentration_nn_1 : N ;
  saltkristall_nn_1 : N ;
  saltloesning_nn_1 : N ;
  saltoeken_nn_1 : N ;
  saltoert_nn_1 : N ;
  saltomortal_nn_1 : N ;
  saltprovare_nn_1 : N ;
  saltsjoe_nn_1 : N ;
  saltstaenkt_av_1 : A ;
  saltstod_nn_1 : N ;
  saltstroeare_nn_1 : N ;
  saltutvinning_nn_1 : N ;
  saltvaext_nn_1 : N ;
  saltvatten_nn_1 : N ;
  saltvattensfisk_nn_1 : N ;
  saltverk_nn_1 : N ;
  salubjuda_vb_1 : V ;
  saluhall_nn_1 : N ;
  salupris_nn_1 : N ;
  salustaand_nn_1 : N ;
  salut_nn_1 : N ;
  salutdag_nn_1 : N ;
  salutkanon_nn_1 : N ;
  salutorg_nn_1 : N ;
  salutskott_nn_1 : N ;
  saluvaerde_nn_1 : N ;
  salvadoran_nn_1 : N ;
  salvationist_nn_1 : N ;
  salvelsefull_av_1 : A ;
  salvkanon_nn_1 : N ;
  samarbetsman_nn_1 : N ;
  samarbetsvillig_av_1 : A ;
  samarit_nn_1 : N ;
  samarv_nn_1 : N ;
  samarva_av_1 : A ;
  samband_nn_1 : N ;
  sambandsofficer_nn_1 : N ;
  sambeskattning_nn_1 : N ;
  sambladig_av_1 : A ;
  sambo_nn_1 : N ;
  sambo_nn_2 : N ;
  samboende_av_1 : A ;
  sambord_nn_1 : N ;
  sambyggare_nn_1 : N ;
  same_nn_1 : N ;
  sameby_nn_1 : N ;
  samekultur_nn_1 : N ;
  sameland_nn_1 : N ;
  samfaelld_av_1 : A ;
  samfaellig_av_1 : A ;
  samfaellighet_nn_1 : N ;
  samfaerdsled_nn_1 : N ;
  samfaerdsmedel_nn_1 : N ;
  samfund_nn_1 : N ;
  samhaellelig_av_1 : A ;
  samhaellsbevarande_av_1 : A ;
  samhaellsbevarare_nn_1 : N ;
  samhaellsbildande_av_1 : A ;
  samhaellsekonomisk_av_1 : A ;
  samhaellsfara_nn_1 : N ;
  samhaellsfarlig_av_1 : A ;
  samhaellsfientlig_av_1 : A ;
  samhaellsfoerbaettrare_nn_1 : N ;
  samhaellsfoerdrag_nn_1 : N ;
  samhaellsform_nn_1 : N ;
  samhaellsforskare_nn_1 : N ;
  samhaellsfraanvaend_av_1 : A ;
  samhaellsfunktion_nn_1 : N ;
  samhaellsgrupp_nn_1 : N ;
  samhaellsingripande_nn_1 : N ;
  samhaellsinsats_nn_1 : N ;
  samhaellsklass_nn_1 : N ;
  samhaellskontrakt_nn_1 : N ;
  samhaellskostnad_nn_1 : N ;
  samhaellskritiker_nn_1 : N ;
  samhaellskritisk_av_1 : A ;
  samhaellskropp_nn_1 : N ;
  samhaellsnorm_nn_1 : N ;
  samhaellsnytta_nn_1 : N ;
  samhaellsnyttig_av_1 : A ;
  samhaellsomstoertande_av_1 : A ;
  samhaellsomstoertare_nn_1 : N ;
  samhaellsordning_nn_1 : N ;
  samhaellsorgan_nn_1 : N ;
  samhaellsorienterande_av_1 : A ;
  samhaellsplanerare_nn_1 : N ;
  samhaellsplanering_nn_1 : N ;
  samhaellsproblem_nn_1 : N ;
  samhaellspyramid_nn_1 : N ;
  samhaellsrepresentant_nn_1 : N ;
  samhaellsskick_nn_1 : N ;
  samhaellsskikt_nn_1 : N ;
  samhaellsskildring_nn_1 : N ;
  samhaellsstaellning_nn_1 : N ;
  samhaellssyn_nn_1 : N ;
  samhaellssystem_nn_1 : N ;
  samhaellstillvaend_av_1 : A ;
  samhaellsuppbyggnad_nn_1 : N ;
  samhaellsvarelse_nn_1 : N ;
  samhaellsvetare_nn_1 : N ;
  samhaellsvetenskap_nn_1 : N ;
  samhaellsvetenskaplig_av_1 : A ;
  samhoerande_av_1 : A ;
  samhoerig_av_1 : A ;
  samhoerighet_nn_1 : N ;
  samhoerighetskaensla_nn_1 : N ;
  samisk_av_1 : A ;
  samizdat_nn_1 : N ;
  samkoep_nn_1 : N ;
  samkoerning_nn_1 : N ;
  samkvaem_nn_1 : N ;
  samlag_nn_1 : N ;
  samlagspartner_nn_1 : N ;
  samlare_nn_1 : N ;
  samlarfoeremaal_nn_1 : N ;
  samlarfolk_nn_1 : N ;
  samlevnad_nn_1 : N ;
  samling_nn_1 : N ;
  samlingsband_nn_1 : N ;
  samlingslins_nn_1 : N ;
  samlingslokal_nn_1 : N ;
  samlingsnamn_nn_1 : N ;
  samlingspaerm_nn_1 : N ;
  samlingsparti_nn_1 : N ;
  samlingsplats_nn_1 : N ;
  samlingspunkt_nn_1 : N ;
  samlingsregering_nn_1 : N ;
  samlingsrum_nn_1 : N ;
  samlingssal_nn_1 : N ;
  samlingsverk_nn_1 : N ;
  sammald_av_1 : A ;
  sammaledes_ab_1 : Adv ;
  sammalen_av_1 : A ;
  sammalunda_ab_1 : Adv ;
  samman_ab_1 : Adv ;
  sammanbinda_vb_1 : V ;
  sammanbindning_nn_1 : N ;
  sammanbiten_av_1 : A ;
  sammanboende_av_1 : A ;
  sammanbragt_av_1 : A ;
  sammanbrott_nn_1 : N ;
  sammandra_vb_1 : V ;
  sammandrabbning_nn_1 : N ;
  sammandrag_nn_1 : N ;
  sammandragning_nn_1 : N ;
  sammanfall_nn_1 : N ;
  sammanfalla_vb_1 : V ;
  sammanfattning_nn_1 : N ;
  sammanfattningsvis_ab_1 : Adv ;
  sammanfloede_nn_1 : N ;
  sammanfogning_nn_1 : N ;
  sammangaaende_nn_1 : N ;
  sammanhaalla_vb_1 : V ;
  sammanhaallen_av_1 : A ;
  sammanhaallig_av_1 : A ;
  sammanhaengande_nn_1 : N ;
  sammanhang_nn_1 : N ;
  sammankallande_av_1 : A ;
  sammankomst_nn_1 : N ;
  sammanlaeggning_nn_1 : N ;
  sammanlaeggningsavhandling_nn_1 : N ;
  sammanlagd_av_1 : A ;
  sammanraekning_nn_1 : N ;
  sammansaettning_nn_1 : N ;
  sammansaettningsfabrik_nn_1 : N ;
  sammansaettningsled_nn_1 : N ;
  sammansatt_av_1 : A ;
  sammanskjuta_vb_1 : V ;
  sammanskott_nn_1 : N ;
  sammanskriva_vb_1 : V ;
  sammanslagen_av_1 : A ;
  sammanslagning_nn_1 : N ;
  sammanslutning_nn_1 : N ;
  sammansmaeltning_nn_1 : N ;
  sammanstaellning_nn_1 : N ;
  sammanstoetning_nn_1 : N ;
  sammansvaerja_vb_1 : V ;
  sammansvaerjning_nn_1 : N ;
  sammansvuren_av_1 : A ;
  sammantagen_av_1 : A ;
  sammantraede_nn_1 : N ;
  sammantraedesordning_nn_1 : N ;
  sammantraedesrum_nn_1 : N ;
  sammantraeffande_nn_1 : N ;
  sammastaedes_ab_1 : Adv ;
  sammelband_nn_1 : N ;
  sammelnamn_nn_1 : N ;
  sammelplats_nn_1 : N ;
  sammelsurium_nn_1 : N ;
  sammetsblomster_nn_1 : N ;
  sammetsmjuk_av_1 : A ;
  samnit_nn_1 : N ;
  samnordisk_av_1 : A ;
  samoan_nn_1 : N ;
  samojed_nn_1 : N ;
  samordnare_nn_1 : N ;
  samordning_nn_1 : N ;
  samovar_nn_1 : N ;
  sampan_nn_1 : N ;
  sampel_nn_1 : N ;
  sampling_nn_1 : N ;
  samraad_nn_1 : N ;
  sams_av_1 : A ;
  samsaendning_nn_1 : N ;
  samspelt_av_1 : A ;
  samstaemd_av_1 : A ;
  samstaemmig_av_1 : A ;
  samsyskon_nn_1 : N ;
  samtal_nn_1 : N ;
  samtalsaemne_nn_1 : N ;
  samtalsavgift_nn_1 : N ;
  samtalsgrupp_nn_1 : N ;
  samtalsmaetare_nn_1 : N ;
  samtalsmarkering_nn_1 : N ;
  samtalsperiod_nn_1 : N ;
  samtalsraeknare_nn_1 : N ;
  samtida_av_1 : A ;
  samtidig_av_1 : A ;
  samtidighet_nn_1 : N ;
  samtidigt_ab_1 : Adv ;
  samtidsskildring_nn_1 : N ;
  samuraj_nn_1 : N ;
  samurajsvaerd_nn_1 : N ;
  samvaelde_nn_1 : N ;
  samvariation_nn_1 : N ;
  samvetsaektenskap_nn_1 : N ;
  samvetsbetaenklighet_nn_1 : N ;
  samvetsfaange_nn_1 : N ;
  samvetsfoerebraaelse_nn_1 : N ;
  samvetsfraaga_nn_1 : N ;
  samvetsfrihet_nn_1 : N ;
  samvetsgrann_av_1 : A ;
  samvetskonflikt_nn_1 : N ;
  samvetskval_nn_1 : N ;
  samvetsloes_av_1 : A ;
  samvetsoem_av_1 : A ;
  samvetspeng_nn_1 : N ;
  samvetssak_nn_1 : N ;
  samvetsskael_nn_1 : N ;
  samvetsstyng_nn_1 : N ;
  sanatorium_nn_1 : N ;
  sandal_nn_1 : N ;
  sandalett_nn_1 : N ;
  sandbad_nn_1 : N ;
  sandbakelse_nn_1 : N ;
  sandbank_nn_1 : N ;
  sandbindande_av_1 : A ;
  sandbindare_nn_1 : N ;
  sandblaester_nn_1 : N ;
  sandbotten_nn_1 : N ;
  sanddyn_nn_1 : N ;
  sandeltraed_nn_1 : N ;
  sandform_nn_1 : N ;
  sandhed_nn_1 : N ;
  sandig_av_1 : A ;
  sandjaegare_nn_1 : N ;
  sandjord_nn_1 : N ;
  sandkorn_nn_1 : N ;
  sandkrypare_nn_1 : N ;
  sandlilja_nn_1 : N ;
  sandloepare_nn_1 : N ;
  sandmark_nn_1 : N ;
  sandmask_nn_1 : N ;
  sandmussla_nn_1 : N ;
  sandoeken_nn_1 : N ;
  sandpapper_nn_1 : N ;
  sandrev_nn_1 : N ;
  sandrevel_nn_1 : N ;
  sandroer_nn_1 : N ;
  sandsaeck_nn_1 : N ;
  sandstorm_nn_1 : N ;
  sandstrand_nn_1 : N ;
  sandsugare_nn_1 : N ;
  sandtaekt_nn_1 : N ;
  sandtag_nn_1 : N ;
  sandur_nn_1 : N ;
  sandvaext_nn_1 : N ;
  sandvikare_nn_1 : N ;
  sandwich_nn_1 : N ;
  sandwichman_nn_1 : N ;
  sanering_nn_1 : N ;
  saneringsfastighet_nn_1 : N ;
  saneringsmedel_nn_1 : N ;
  saneringsplan_nn_1 : N ;
  sang_nn_1 : N ;
  sangviniker_nn_1 : N ;
  sangvinisk_av_1 : A ;
  sanitaer_av_1 : A ;
  sanitet_nn_1 : N ;
  sanitetsanstalt_nn_1 : N ;
  sanitetsartikel_nn_1 : N ;
  sanitetshund_nn_1 : N ;
  sanitetskaerl_nn_1 : N ;
  sanitetskompani_nn_1 : N ;
  sanitetstekniker_nn_1 : N ;
  sanitetstrupp_nn_1 : N ;
  sank_av_1 : A ;
  sanktbernhardshund_nn_1 : N ;
  sanktifikation_nn_1 : N ;
  sanktion_nn_1 : N ;
  sanktuarium_nn_1 : N ;
  sanmarinesare_nn_1 : N ;
  sanmarinesisk_av_1 : A ;
  sann_av_1 : A ;
  sanndroem_nn_1 : N ;
  sannerligen_ab_1 : Adv ;
  sannfaerdig_av_1 : A ;
  sanning_nn_1 : N ;
  sanningsdrog_nn_1 : N ;
  sanningsenlig_av_1 : A ;
  sanningsfoersaekran_nn_1 : N ;
  sanningskorn_nn_1 : N ;
  sanningskrav_nn_1 : N ;
  sanningsloes_av_1 : A ;
  sanningssaegare_nn_1 : N ;
  sanningssoekare_nn_1 : N ;
  sanningsvittne_nn_1 : N ;
  sannolik_av_1 : A ;
  sannolikhet_nn_1 : N ;
  sannolikhetsbevis_nn_1 : N ;
  sannolikhetskalkyl_nn_1 : N ;
  sannolikhetsteori_nn_1 : N ;
  sannsaga_nn_1 : N ;
  sannskyldig_av_1 : A ;
  sannspaadd_av_1 : A ;
  sansculotte_nn_1 : N ;
  sansloes_av_1 : A ;
  sansning_nn_1 : N ;
  sapfisk_av_1 : A ;
  saponin_nn_1 : N ;
  sapp_nn_1 : N ;
  sappoer_nn_1 : N ;
  saprofyt_nn_1 : N ;
  saprogen_av_1 : A ;
  saraband_nn_1 : N ;
  saracen_nn_1 : N ;
  sarafan_nn_1 : N ;
  sard_nn_1 : N ;
  sardell_nn_1 : N ;
  sardin_nn_1 : N ;
  sardinare_nn_1 : N ;
  sardinisk_av_1 : A ;
  sardiniska_nn_2 : N ;
  sardinsk_av_1 : A ;
  sardinska_nn_2 : N ;
  sardisk_av_1 : A ;
  sardiska_nn_2 : N ;
  sardonisk_av_1 : A ;
  sarg_nn_1 : N ;
  sari_nn_1 : N ;
  sarkasm_nn_1 : N ;
  sarkastisk_av_1 : A ;
  sarkofag_nn_1 : N ;
  sarkom_nn_1 : N ;
  sarong_nn_1 : N ;
  sars_nn_1 : N ;
  sarv_nn_1 : N ;
  sataeng_nn_1 : N ;
  satanisk_av_1 : A ;
  satanist_nn_1 : N ;
  sate_nn_1 : N ;
  satellit_nn_1 : N ;
  satellitstat_nn_1 : N ;
  satemspraak_nn_1 : N ;
  satin_nn_1 : N ;
  satir_nn_1 : N ;
  satiriker_nn_1 : N ;
  satirisk_av_1 : A ;
  satisfaktion_nn_1 : N ;
  satkaering_nn_1 : N ;
  satrap_nn_1 : N ;
  satrapi_nn_1 : N ;
  sats_nn_1 : N ;
  satsaccent_nn_1 : N ;
  satsadverbial_nn_1 : N ;
  satsanalys_nn_1 : N ;
  satsbindning_nn_1 : N ;
  satsbord_nn_1 : N ;
  satsbraede_nn_1 : N ;
  satsbyggnad_nn_1 : N ;
  satsdel_nn_1 : N ;
  satsfoerkortning_nn_1 : N ;
  satsfogning_nn_1 : N ;
  satskompletteringstest_nn_1 : N ;
  satskonstruktion_nn_1 : N ;
  satsmelodi_nn_1 : N ;
  satsning_nn_1 : N ;
  satsuma_nn_1 : N ;
  satt_av_1 : A ;
  sattyg_nn_1 : N ;
  satunge_nn_1 : N ;
  saturnaliefest_nn_1 : N ;
  saturnalisk_av_1 : A ;
  saturnisk_av_1 : A ;
  satyr_nn_1 : N ;
  satyrdrama_nn_1 : N ;
  satyrspel_nn_1 : N ;
  saudiarab_nn_1 : N ;
  saudiarabisk_av_1 : A ;
  saudier_nn_1 : N ;
  saudisk_av_1 : A ;
  saute_nn_1 : N ;
  savann_nn_1 : N ;
  savarin_nn_1 : N ;
  savig_av_1 : A ;
  savningstid_nn_1 : N ;
  savojard_nn_1 : N ;
  savtid_nn_1 : N ;
  sax_nn_1 : N ;
  saxare_nn_1 : N ;
  saxarm_nn_1 : N ;
  saxblad_nn_1 : N ;
  saxisk_av_1 : A ;
  saxkrok_nn_1 : N ;
  saxnaebb_nn_1 : N ;
  saxofon_nn_1 : N ;
  saxskaenkel_nn_1 : N ;
  saxskaer_nn_1 : N ;
  saxskalm_nn_1 : N ;
  saxsprint_nn_1 : N ;
  sbirr_nn_1 : N ;
  scanner_nn_1 : N ;
  scanning_nn_1 : N ;
  scarf_nn_1 : N ;
  scen_nn_1 : N ;
  scenanvisning_nn_1 : N ;
  scenarbetare_nn_1 : N ;
  scenario_nn_1 : N ;
  scenbearbetning_nn_1 : N ;
  scenbild_nn_1 : N ;
  sceneri_nn_1 : N ;
  scenfoeraendring_nn_1 : N ;
  scenframtraedande_nn_1 : N ;
  sceningaang_nn_1 : N ;
  sceninstruktoer_nn_1 : N ;
  scenisk_av_1 : A ;
  scenoeppning_nn_1 : N ;
  scenograf_nn_1 : N ;
  scenuppfoerande_nn_1 : N ;
  scenvaexling_nn_1 : N ;
  scenvind_nn_1 : N ;
  scepter_nn_1 : N ;
  schabbel_nn_1 : N ;
  schablon_nn_1 : N ;
  schablonavdrag_nn_1 : N ;
  schablonbelopp_nn_1 : N ;
  schablonmaessig_av_1 : A ;
  schablontillaegg_nn_1 : N ;
  schabrak_nn_1 : N ;
  schack_av_1 : A ;
  schack_nn_2 : N ;
  schackbord_nn_1 : N ;
  schackbraede_nn_1 : N ;
  schackdrag_nn_1 : N ;
  schackel_nn_1 : N ;
  schackmatt_av_1 : A ;
  schackmoenster_nn_1 : N ;
  schackningsperiod_nn_1 : N ;
  schackparti_nn_1 : N ;
  schackpjaes_nn_1 : N ;
  schackproblem_nn_1 : N ;
  schackrare_nn_1 : N ;
  schackspel_nn_1 : N ;
  schackspelare_nn_1 : N ;
  schackturnering_nn_1 : N ;
  schaefer_nn_1 : N ;
  schaeferhatt_nn_1 : N ;
  schaeferhund_nn_1 : N ;
  schaeferi_nn_1 : N ;
  schaes_nn_1 : N ;
  schaeslong_nn_1 : N ;
  schagg_nn_1 : N ;
  schah_nn_1 : N ;
  schajas_nn_1 : N ;
  schakaa_nn_1 : N ;
  schakal_nn_1 : N ;
  schakt_nn_1 : N ;
  schaktmaskin_nn_1 : N ;
  schaktugn_nn_1 : N ;
  schal_nn_1 : N ;
  schalett_nn_1 : N ;
  schalom_nn_1 : N ;
  schalottenloek_nn_1 : N ;
  schaman_nn_1 : N ;
  schampo_nn_1 : N ;
  schangdobel_av_1 : A ;
  schangtil_av_1 : A ;
  schapp_nn_1 : N ;
  scharner_nn_1 : N ;
  schartauan_nn_1 : N ;
  schartauansk_av_1 : A ;
  schattering_nn_1 : N ;
  schattersoem_nn_1 : N ;
  schatull_nn_1 : N ;
  schavott_nn_1 : N ;
  schejk_nn_1 : N ;
  schema_nn_1 : N ;
  schemabunden_av_1 : A ;
  schemalagd_av_1 : A ;
  schematisk_av_1 : A ;
  schematism_nn_1 : N ;
  schersmin_nn_1 : N ;
  scherzando_ab_1 : Adv ;
  scherzo_nn_1 : N ;
  schibbolet_nn_1 : N ;
  schillerkrage_nn_1 : N ;
  schillerstoevare_nn_1 : N ;
  schilling_nn_1 : N ;
  schimpans_nn_1 : N ;
  schism_nn_1 : N ;
  schismatiker_nn_1 : N ;
  schismatisk_av_1 : A ;
  schizofren_av_1 : A ;
  schizofreni_nn_1 : N ;
  schizotym_av_1 : A ;
  schizzig_av_1 : A ;
  schlager_nn_1 : N ;
  schnauzer_nn_1 : N ;
  schnitzel_nn_1 : N ;
  schottis_nn_1 : N ;
  schrammelkvartett_nn_1 : N ;
  schvungfull_av_1 : A ;
  schvungig_av_1 : A ;
  schwa_ljud_nn_1 : N ;
  schweizare_nn_1 : N ;
  schweizerfranc_nn_1 : N ;
  schweizeri_nn_1 : N ;
  schweizernoet_nn_1 : N ;
  schweizerost_nn_1 : N ;
  schweizisk_av_1 : A ;
  schysst_av_1 : A ;
  schyst_av_1 : A ;
  scientist_nn_1 : N ;
  scientolog_nn_1 : N ;
  scintillation_nn_1 : N ;
  scirocco_nn_1 : N ;
  scone_nn_1 : N ;
  scoop_nn_1 : N ;
  scooter_nn_1 : N ;
  scopolamin_nn_1 : N ;
  scout_nn_1 : N ;
  scoutjamboree_nn_1 : N ;
  scoutlaeger_nn_1 : N ;
  scoutlag_nn_1 : N ;
  scoutpatrull_nn_1 : N ;
  scratchman_nn_1 : N ;
  script_girl_nn_1 : N ;
  seans_nn_1 : N ;
  sebar_av_1 : A ;
  seborre_nn_1 : N ;
  sebu_nn_1 : N ;
  seccomaalning_nn_1 : N ;
  sed_nn_1 : N ;
  sedan_ab_1 : Adv ;
  sedan_nn_1 : N ;
  sedativ_av_1 : A ;
  sedativ_nn_1 : N ;
  sedativum_nn_1 : N ;
  sedebetyg_nn_1 : N ;
  sedekomedi_nn_1 : N ;
  sedel_nn_1 : N ;
  sedelaerande_av_1 : A ;
  sedelautomat_nn_1 : N ;
  sedelpress_nn_1 : N ;
  sedelreserv_nn_1 : N ;
  sedelstock_nn_1 : N ;
  sedermera_ab_1 : Adv ;
  sederoman_nn_1 : N ;
  sedes_nn_1 : N ;
  sedesam_av_1 : A ;
  sedeskildring_nn_1 : N ;
  sedesloes_av_1 : A ;
  sedig_av_1 : A ;
  sediment_nn_1 : N ;
  sedimentaer_av_1 : A ;
  sedimentering_nn_1 : N ;
  sedimentfoerande_av_1 : A ;
  sedimentlager_nn_1 : N ;
  sedimentprov_nn_1 : N ;
  sedlig_av_1 : A ;
  sedlighet_nn_1 : N ;
  sedlighetsbrott_nn_1 : N ;
  sedlighetssaarande_av_1 : A ;
  sedvaenja_nn_1 : N ;
  sedvana_nn_1 : N ;
  sedvanlig_av_1 : A ;
  seende_av_1 : A ;
  sefard_nn_1 : N ;
  sefyr_nn_1 : N ;
  seg_av_1 : A ;
  segdra_vb_1 : V ;
  segdragen_av_1 : A ;
  segel_nn_1 : N ;
  segelbaat_nn_1 : N ;
  segelbaergning_nn_1 : N ;
  segelbar_av_1 : A ;
  segelduk_nn_1 : N ;
  segelfartyg_nn_1 : N ;
  segelflyg_nn_1 : N ;
  segelflygning_nn_1 : N ;
  segelflygplan_nn_1 : N ;
  segelfoering_nn_1 : N ;
  segelfri_av_1 : A ;
  segeljakt_nn_1 : N ;
  segeljolle_nn_1 : N ;
  segelkanot_nn_1 : N ;
  segelkapell_nn_1 : N ;
  segelled_nn_1 : N ;
  segelmaerke_nn_1 : N ;
  segelmakare_nn_1 : N ;
  segelmakeri_nn_1 : N ;
  segelskridsko_nn_1 : N ;
  segelsoemmare_nn_1 : N ;
  segelstaell_nn_1 : N ;
  seger_nn_1 : N ;
  segerherre_nn_1 : N ;
  segerkrans_nn_1 : N ;
  segerkroent_av_1 : A ;
  segerpalm_nn_1 : N ;
  segerpalmen_ab_1 : Adv ;
  segerrik_av_1 : A ;
  segersaell_av_1 : A ;
  segertaag_nn_1 : N ;
  segerviss_av_1 : A ;
  seghet_nn_1 : N ;
  seglare_nn_1 : N ;
  seglarstoevel_nn_1 : N ;
  seglation_nn_1 : N ;
  seglationsklar_av_1 : A ;
  seglats_nn_1 : N ;
  segling_nn_1 : N ;
  seglingsbeskrivning_nn_1 : N ;
  seglingsfri_av_1 : A ;
  segment_nn_1 : N ;
  segmentbaage_nn_1 : N ;
  segmentell_av_1 : A ;
  segmogen_av_1 : A ;
  segrare_nn_1 : N ;
  segregat_nn_1 : N ;
  segregation_nn_1 : N ;
  segring_nn_1 : N ;
  segsliten_av_1 : A ;
  seigneur_nn_1 : N ;
  seismisk_av_1 : A ;
  seismograf_nn_1 : N ;
  seismogram_nn_1 : N ;
  seismometer_nn_1 : N ;
  sej_nn_1 : N ;
  sejdare_nn_1 : N ;
  sejdel_nn_1 : N ;
  sejnfall_nn_1 : N ;
  sejour_nn_1 : N ;
  sejsing_nn_1 : N ;
  sejsning_nn_1 : N ;
  sejte_nn_1 : N ;
  sekant_nn_1 : N ;
  sekatoer_nn_1 : N ;
  sekel_nn_1 : N ;
  sekellaang_av_1 : A ;
  sekin_nn_1 : N ;
  sekond_nn_1 : N ;
  sekret_av_1 : A ;
  sekret_nn_1 : N ;
  sekretaer_nn_1 : N ;
  sekretariat_nn_1 : N ;
  sekreterare_nn_1 : N ;
  sekreterarfaagel_nn_1 : N ;
  sekretion_nn_1 : N ;
  sekretionsrubbning_nn_1 : N ;
  sekretorisk_av_1 : A ;
  sekt_nn_1 : N ;
  sekteristisk_av_1 : A ;
  sektion_nn_1 : N ;
  sektor_nn_1 : N ;
  sektorfyr_nn_1 : N ;
  sektoriell_av_1 : A ;
  sektorport_nn_1 : N ;
  sekulaer_av_1 : A ;
  sekularisation_nn_1 : N ;
  sekularisering_nn_1 : N ;
  sekularpraest_nn_1 : N ;
  sekund_nn_1 : N ;
  sekunda_av_1 : A ;
  sekundaer_av_1 : A ;
  sekundaergrupp_nn_1 : N ;
  sekundaerinfektion_nn_1 : N ;
  sekundaerkommun_nn_1 : N ;
  sekundaerminne_nn_1 : N ;
  sekundaerspole_nn_1 : N ;
  sekundaerstadium_nn_1 : N ;
  sekundaerstroem_nn_1 : N ;
  sekundant_nn_1 : N ;
  sekundchef_nn_1 : N ;
  sekundmeter_nn_1 : N ;
  sekundvisare_nn_1 : N ;
  sekvens_nn_1 : N ;
  sel_nn_1 : N ;
  selbrott_nn_1 : N ;
  selbruten_av_1 : A ;
  seldon_nn_1 : N ;
  sele_nn_1 : N ;
  selektion_nn_1 : N ;
  selektiv_av_1 : A ;
  selektivitet_nn_1 : N ;
  selencell_nn_1 : N ;
  selfmade_av_1 : A ;
  selleribotten_nn_1 : N ;
  selot_nn_1 : N ;
  seltersglas_nn_1 : N ;
  seltyg_nn_1 : N ;
  semafor_nn_1 : N ;
  semaforalfabet_nn_1 : N ;
  semantisk_av_1 : A ;
  semem_nn_1 : N ;
  semester_nn_1 : N ;
  semesterarvode_nn_1 : N ;
  semesterby_nn_1 : N ;
  semesterdag_nn_1 : N ;
  semesterersaettning_nn_1 : N ;
  semesterfirare_nn_1 : N ;
  semesterloen_nn_1 : N ;
  semestermaanad_nn_1 : N ;
  semesterpeng_nn_1 : N ;
  semestertillaegg_nn_1 : N ;
  semifinal_nn_1 : N ;
  semikolon_nn_1 : N ;
  seminarist_nn_1 : N ;
  seminarium_nn_1 : N ;
  seminoer_nn_1 : N ;
  seminstation_nn_1 : N ;
  semiotisk_av_1 : A ;
  semipermeabel_av_1 : A ;
  semit_nn_1 : N ;
  semitisk_av_1 : A ;
  semitist_nn_1 : N ;
  semitrailer_nn_1 : N ;
  semla_nn_1 : N ;
  semologisk_av_1 : A ;
  sen_ab_1 : Adv ;
  sen_av_1 : A ;
  senantik_av_1 : A ;
  senapsdeg_nn_1 : N ;
  senar_nn_1 : N ;
  senat_nn_1 : N ;
  senator_nn_1 : N ;
  senegales_nn_1 : N ;
  senegalesisk_av_1 : A ;
  senfaerdig_av_1 : A ;
  senfoedd_av_1 : A ;
  sengaangaraktig_av_1 : A ;
  sengaangare_nn_1 : N ;
  senhinna_nn_1 : N ;
  senhoest_nn_1 : N ;
  senig_av_1 : A ;
  senil_av_1 : A ;
  senilitet_nn_1 : N ;
  senior_av_1 : A ;
  senior_nn_1 : N ;
  senknut_nn_1 : N ;
  senkommen_av_1 : A ;
  senor_nn_1 : N ;
  senorgan_nn_1 : N ;
  sensation_nn_1 : N ;
  sensationell_av_1 : A ;
  sensibel_av_1 : A ;
  sensibilitet_nn_1 : N ;
  sensigrupp_nn_1 : N ;
  sensitiv_av_1 : A ;
  sensitivitet_nn_1 : N ;
  sensmoral_nn_1 : N ;
  sensommar_nn_1 : N ;
  sensomotorisk_av_1 : A ;
  sensor_nn_1 : N ;
  sensorisk_av_1 : A ;
  sensualitet_nn_1 : N ;
  sensuell_av_1 : A ;
  sentens_nn_1 : N ;
  sententioes_av_1 : A ;
  sentida_av_1 : A ;
  sentima_av_1 : A ;
  sentiment_nn_1 : N ;
  sentimental_av_1 : A ;
  sentimentalitet_nn_1 : N ;
  senvaar_nn_1 : N ;
  senvinter_nn_1 : N ;
  separabel_av_1 : A ;
  separat_av_1 : A ;
  separat_nn_1 : N ;
  separatfred_nn_1 : N ;
  separatim_ab_1 : Adv ;
  separation_nn_1 : N ;
  separatist_nn_1 : N ;
  separatistisk_av_1 : A ;
  separatistroerelse_nn_1 : N ;
  separator_nn_1 : N ;
  separatutstaellning_nn_1 : N ;
  separering_nn_1 : N ;
  sepoy_nn_1 : N ;
  septennium_nn_1 : N ;
  septett_nn_1 : N ;
  septiktank_nn_1 : N ;
  septisk_av_1 : A ;
  seraf_nn_1 : N ;
  serafimerband_nn_1 : N ;
  serafisk_av_1 : A ;
  seralj_nn_1 : N ;
  serb_nn_1 : N ;
  serbisk_av_1 : A ;
  serbokroatisk_av_1 : A ;
  seren_av_1 : A ;
  serenad_nn_1 : N ;
  serenitet_nn_1 : N ;
  sergeant_nn_1 : N ;
  serie_nn_1 : N ;
  seriefigur_nn_1 : N ;
  seriekoppling_nn_1 : N ;
  seriekrock_nn_1 : N ;
  seriell_av_1 : A ;
  seriemagasin_nn_1 : N ;
  seriematch_nn_1 : N ;
  seriespel_nn_1 : N ;
  serietecknare_nn_1 : N ;
  serietidning_nn_1 : N ;
  serietillverkning_nn_1 : N ;
  seriff_nn_1 : N ;
  serigrafi_nn_1 : N ;
  serioes_av_1 : A ;
  seriositet_nn_1 : N ;
  seroes_av_1 : A ;
  serotonin_nn_1 : N ;
  serotoninhoejande_av_1 : A ;
  serpent_nn_1 : N ;
  serpentin_nn_1 : N ;
  serum_nn_1 : N ;
  serval_nn_1 : N ;
  servboll_nn_1 : N ;
  serve_nn_1 : N ;
  serveboll_nn_1 : N ;
  serveess_nn_1 : N ;
  servegame_nn_1 : N ;
  servelinje_nn_1 : N ;
  servering_nn_1 : N ;
  serveringsavgift_nn_1 : N ;
  serveringsbord_nn_1 : N ;
  serveringsfat_nn_1 : N ;
  serveringsgaang_nn_1 : N ;
  serveringskork_nn_1 : N ;
  serveringsrum_nn_1 : N ;
  serveringsvagn_nn_1 : N ;
  servett_nn_1 : N ;
  servettring_nn_1 : N ;
  serveuppkast_nn_1 : N ;
  servgame_nn_1 : N ;
  servicebil_nn_1 : N ;
  servicebostad_nn_1 : N ;
  servicebox_nn_1 : N ;
  servicebutik_nn_1 : N ;
  servicehus_nn_1 : N ;
  servicelaegenhet_nn_1 : N ;
  serviceman_nn_1 : N ;
  servicenaering_nn_1 : N ;
  servicepersonal_nn_1 : N ;
  servicestation_nn_1 : N ;
  serviceyrke_nn_1 : N ;
  servil_av_1 : A ;
  servilism_nn_1 : N ;
  servilitet_nn_1 : N ;
  servis_nn_1 : N ;
  servisledning_nn_1 : N ;
  servitoer_nn_1 : N ;
  servitris_nn_1 : N ;
  servitut_nn_1 : N ;
  servlinje_nn_1 : N ;
  servobroms_nn_1 : N ;
  servomotor_nn_1 : N ;
  sesamfroe_nn_1 : N ;
  session_nn_1 : N ;
  set_nn_1 : N ;
  setboll_nn_1 : N ;
  setter_nn_1 : N ;
  settlement_nn_1 : N ;
  sevaerd_av_1 : A ;
  sevaerdhet_nn_1 : N ;
  sexaarig_av_1 : A ;
  sexbomb_nn_1 : N ;
  sexfoting_nn_1 : N ;
  sexig_av_1 : A ;
  sexkantig_av_1 : A ;
  sexling_nn_1 : N ;
  sexmaestare_nn_1 : N ;
  sexmord_nn_1 : N ;
  sexpack_nn_1 : N ;
  sexpipig_av_1 : A ;
  sexradig_av_1 : A ;
  sexsiffrig_av_1 : A ;
  sexspann_nn_1 : N ;
  sext_nn_1 : N ;
  sextant_nn_1 : N ;
  sextett_nn_1 : N ;
  sextiondel_nn_1 : N ;
  sextol_nn_1 : N ;
  sexualakt_nn_1 : N ;
  sexualbrott_nn_1 : N ;
  sexualcykel_nn_1 : N ;
  sexualdrift_nn_1 : N ;
  sexualia_nn_1 : N ;
  sexualitet_nn_1 : N ;
  sexualmord_nn_1 : N ;
  sexualorgan_nn_1 : N ;
  sexuell_av_1 : A ;
  seychellier_nn_1 : N ;
  seychellisk_av_1 : A ;
  sfaer_nn_1 : N ;
  sfaerisk_av_1 : A ;
  sfaeroid_nn_1 : N ;
  sfaerometer_nn_1 : N ;
  sfinx_nn_1 : N ;
  sforzando_ab_1 : Adv ;
  shah_nn_1 : N ;
  shaker_nn_1 : N ;
  shaman_nn_1 : N ;
  shamanism_nn_1 : N ;
  shampoo_nn_1 : N ;
  shanty_nn_1 : N ;
  shejk_nn_1 : N ;
  shellack_nn_1 : N ;
  shelterdaeck_nn_1 : N ;
  sheriff_nn_1 : N ;
  sherpa_nn_1 : N ;
  shetlaendsk_av_1 : A ;
  shetlandsponny_nn_1 : N ;
  shiit_nn_1 : N ;
  shilling_nn_1 : N ;
  shogun_nn_1 : N ;
  shop_nn_1 : N ;
  shoppingcentrum_nn_1 : N ;
  shoppingvagn_nn_1 : N ;
  show_nn_1 : N ;
  shuffle_board_nn_1 : N ;
  shunt_nn_1 : N ;
  shuntkoppling_nn_1 : N ;
  shuntventil_nn_1 : N ;
  si_ab_1 : Adv ;
  siames_nn_1 : N ;
  siamesisk_av_1 : A ;
  siameskatt_nn_1 : N ;
  siare_nn_1 : N ;
  sibet_nn_1 : N ;
  sibetdjur_nn_1 : N ;
  sibetkatt_nn_1 : N ;
  sibirier_nn_1 : N ;
  sibirisk_av_1 : A ;
  sibyllinsk_av_1 : A ;
  sic_ab_1 : Adv ;
  sicilian_nn_1 : N ;
  sicilianare_nn_1 : N ;
  siciliansk_av_1 : A ;
  sicilianska_nn_1 : N ;
  sick_nn_1 : N ;
  sickativ_nn_1 : N ;
  sickel_nn_1 : N ;
  sicken_av_1 : A ;
  sickling_nn_1 : N ;
  sid_av_1 : A ;
  sida_nn_1 : N ;
  sidbyte_nn_1 : N ;
  sideboard_nn_1 : N ;
  sidendraperi_nn_1 : N ;
  sidenskaerm_nn_1 : N ;
  sidensvans_nn_1 : N ;
  sidentyg_nn_1 : N ;
  siderisk_av_1 : A ;
  sidlaend_av_1 : A ;
  sidlaenges_ab_1 : Adv ;
  sidlaent_av_1 : A ;
  sidledes_ab_1 : Adv ;
  sidlinje_nn_1 : N ;
  sidnummer_nn_1 : N ;
  sidnumrering_nn_1 : N ;
  sidoaltare_nn_1 : N ;
  sidoapparat_nn_1 : N ;
  sidoarv_nn_1 : N ;
  sidoarvinge_nn_1 : N ;
  sidobelysning_nn_1 : N ;
  sidoblick_nn_1 : N ;
  sidobyggnad_nn_1 : N ;
  sidodaeck_nn_1 : N ;
  sidodal_nn_1 : N ;
  sidoeffekt_nn_1 : N ;
  sidogevaer_nn_1 : N ;
  sidoingaang_nn_1 : N ;
  sidoinkomst_nn_1 : N ;
  sidolinje_nn_1 : N ;
  sidolinjeorgan_nn_1 : N ;
  sidoplan_nn_1 : N ;
  sidoroder_nn_1 : N ;
  sidoskepp_nn_1 : N ;
  sidoskott_nn_1 : N ;
  sidospaar_nn_1 : N ;
  sidospraang_nn_1 : N ;
  sidotema_nn_1 : N ;
  sidovaeg_nn_1 : N ;
  sidovapen_nn_1 : N ;
  sidovinkel_nn_1 : N ;
  sidroder_nn_1 : N ;
  sidskruv_nn_1 : N ;
  sidvagn_nn_1 : N ;
  sidvall_nn_1 : N ;
  sidvoerdnad_nn_1 : N ;
  siemens_nn_1 : N ;
  sierraleonier_nn_1 : N ;
  sierraleonsk_av_1 : A ;
  sierska_nn_1 : N ;
  sievert_nn_1 : N ;
  sifferbetyg_nn_1 : N ;
  sifferkarl_nn_1 : N ;
  siffersumma_nn_1 : N ;
  siffertavla_nn_1 : N ;
  sifferuppgift_nn_1 : N ;
  siffra_nn_1 : N ;
  sifon_nn_1 : N ;
  sigel_nn_1 : N ;
  sightseeing_nn_1 : N ;
  sigill_nn_1 : N ;
  sigillbevarare_nn_1 : N ;
  sigillring_nn_1 : N ;
  sigillstaempel_nn_1 : N ;
  sigillstamp_nn_1 : N ;
  signal_nn_1 : N ;
  signalbloss_nn_1 : N ;
  signalbok_nn_1 : N ;
  signalduk_nn_1 : N ;
  signaleld_nn_1 : N ;
  signalement_nn_1 : N ;
  signalering_nn_1 : N ;
  signalhastighet_nn_1 : N ;
  signalhorn_nn_1 : N ;
  signalist_nn_1 : N ;
  signalmoenster_nn_1 : N ;
  signalpistol_nn_1 : N ;
  signalspade_nn_1 : N ;
  signalstaell_nn_1 : N ;
  signalsubstans_nn_1 : N ;
  signaltrupp_nn_1 : N ;
  signalur_nn_1 : N ;
  signataer_nn_1 : N ;
  signataermakt_nn_1 : N ;
  signatur_nn_1 : N ;
  signaturmelodi_nn_1 : N ;
  signelse_nn_1 : N ;
  signeri_nn_1 : N ;
  signet_nn_1 : N ;
  signetring_nn_1 : N ;
  signifikans_nn_1 : N ;
  signifikant_av_1 : A ;
  signifikativ_av_1 : A ;
  signor_nn_1 : N ;
  signum_nn_1 : N ;
  sik_nn_1 : N ;
  sikahjort_nn_1 : N ;
  sikel_nn_1 : N ;
  sikh_nn_1 : N ;
  sikt_nn_2 : N ;
  siktbar_av_1 : A ;
  siktbroed_nn_1 : N ;
  siktduk_nn_1 : N ;
  siktig_av_1 : A ;
  siktlinje_nn_1 : N ;
  siktram_nn_1 : N ;
  sil_nn_1 : N ;
  silben_nn_1 : N ;
  silduk_nn_1 : N ;
  silen_nn_1 : N ;
  silhuett_nn_1 : N ;
  silikat_nn_1 : N ;
  silikon_nn_1 : N ;
  silkegarn_nn_1 : N ;
  silkepapper_nn_1 : N ;
  silkesfjaeril_nn_1 : N ;
  silkeshare_nn_1 : N ;
  silkeskanin_nn_1 : N ;
  silkeslarv_nn_1 : N ;
  silkeslen_av_1 : A ;
  silkesmask_nn_1 : N ;
  silkespinnare_nn_1 : N ;
  silkesspinnare_nn_1 : N ;
  silkestraad_nn_1 : N ;
  silkig_av_1 : A ;
  sill_nn_1 : N ;
  sillavfall_nn_1 : N ;
  sillbit_nn_1 : N ;
  sillblixt_nn_1 : N ;
  sillbulle_nn_1 : N ;
  sillfile_nn_1 : N ;
  sillfrukost_nn_1 : N ;
  sillinlaeggning_nn_1 : N ;
  sillkung_nn_1 : N ;
  sillmjoelke_nn_1 : N ;
  sillperiod_nn_1 : N ;
  sillpudding_nn_1 : N ;
  sillsallad_nn_1 : N ;
  sillstrypare_nn_1 : N ;
  silltrut_nn_1 : N ;
  sillval_nn_1 : N ;
  silo_nn_1 : N ;
  siluett_nn_1 : N ;
  silver_nn_1 : N ;
  silverbaegare_nn_1 : N ;
  silverbroellop_nn_1 : N ;
  silverbrudpar_nn_1 : N ;
  silverfasan_nn_1 : N ;
  silverfisk_nn_1 : N ;
  silverfoeremaal_nn_1 : N ;
  silverglaensande_av_1 : A ;
  silvergran_nn_1 : N ;
  silvergrogg_nn_1 : N ;
  silverhalt_nn_1 : N ;
  silverhaltig_av_1 : A ;
  silverklar_av_1 : A ;
  silverlejon_nn_1 : N ;
  silverliknande_av_1 : A ;
  silvermagister_nn_1 : N ;
  silvermedalj_nn_1 : N ;
  silvermynt_nn_1 : N ;
  silverne_av_1 : A ;
  silverpeng_nn_1 : N ;
  silverpenning_nn_1 : N ;
  silverpoppel_nn_1 : N ;
  silverraev_nn_1 : N ;
  silversalt_nn_1 : N ;
  silversked_nn_1 : N ;
  silversmed_nn_1 : N ;
  silversmide_nn_1 : N ;
  silverstaempel_nn_1 : N ;
  silvertraad_nn_1 : N ;
  silvrig_av_1 : A ;
  simand_nn_1 : N ;
  simbaelte_nn_1 : N ;
  simbassaeng_nn_1 : N ;
  simborgarmaerke_nn_1 : N ;
  simdraekt_nn_1 : N ;
  simfaagel_nn_1 : N ;
  simfot_nn_1 : N ;
  simhall_nn_1 : N ;
  simhopp_nn_1 : N ;
  simkandidat_nn_1 : N ;
  simkunnig_av_1 : A ;
  simlaerare_nn_1 : N ;
  simma_vb_1 : V ;
  simmaerke_nn_1 : N ;
  simmagister_nn_1 : N ;
  simmare_nn_1 : N ;
  simmig_av_1 : A ;
  simning_nn_1 : N ;
  simorgan_nn_1 : N ;
  simpel_av_1 : A ;
  simplex_nn_1 : N ;
  simplexpaale_nn_1 : N ;
  simpromotion_nn_1 : N ;
  simprov_nn_1 : N ;
  sims_nn_1 : N ;
  simsaett_nn_1 : N ;
  simshyvel_nn_1 : N ;
  simtaevling_nn_1 : N ;
  simtag_nn_1 : N ;
  simtraening_nn_1 : N ;
  simtur_nn_1 : N ;
  simulant_nn_1 : N ;
  simulation_nn_1 : N ;
  simulator_nn_1 : N ;
  simultan_av_1 : A ;
  simultanism_nn_1 : N ;
  simultanscen_nn_1 : N ;
  sinder_nn_1 : N ;
  sinekur_nn_1 : N ;
  singales_nn_1 : N ;
  singalesisk_av_1 : A ;
  singalesiska_nn_2 : N ;
  singaporian_nn_1 : N ;
  singel_nn_1 : N ;
  singelspel_nn_1 : N ;
  singular_av_1 : A ;
  singular_nn_1 : N ;
  singularitet_nn_1 : N ;
  singuljaer_av_1 : A ;
  sinister_av_1 : A ;
  sinkadus_nn_1 : N ;
  sinne_nn_1 : N ;
  sinnebild_nn_1 : N ;
  sinnesanalogi_nn_1 : N ;
  sinnescell_nn_1 : N ;
  sinnesfoerfattning_nn_1 : N ;
  sinnesintryck_nn_1 : N ;
  sinnesnerv_nn_1 : N ;
  sinnesorgan_nn_1 : N ;
  sinnesroerelse_nn_1 : N ;
  sinnessjuk_av_1 : A ;
  sinnessjukdom_nn_1 : N ;
  sinnessloe_av_1 : A ;
  sinnesstaemning_nn_1 : N ;
  sinnessvag_av_1 : A ;
  sinnesundersoekning_nn_1 : N ;
  sinnesupplevelse_nn_1 : N ;
  sinnlig_av_1 : A ;
  sinnlighet_nn_1 : N ;
  sinnrik_av_1 : A ;
  sinolog_nn_1 : N ;
  sinsemellan_ab_1 : Adv ;
  sinuit_nn_1 : N ;
  sinus_nn_1 : N ;
  sinusit_nn_1 : N ;
  sinuston_nn_1 : N ;
  sionist_nn_1 : N ;
  sioux_nn_1 : N ;
  sipp_av_1 : A ;
  sirapslen_av_1 : A ;
  sirapsliknande_av_1 : A ;
  sirapssoet_av_1 : A ;
  sirat_nn_1 : N ;
  siratlig_av_1 : A ;
  siren_nn_1 : N ;
  sirendjur_nn_1 : N ;
  sirlig_av_1 : A ;
  sisaadaer_ab_1 : Adv ;
  sisel_nn_1 : N ;
  sist_ab_1 : Adv ;
  sistens_ab_1 : Adv ;
  sistliden_av_1 : A ;
  sitar_nn_1 : N ;
  sits_nn_1 : N ;
  sittbadkar_nn_1 : N ;
  sittben_nn_1 : N ;
  sittbraede_nn_1 : N ;
  sittbrunn_nn_1 : N ;
  sitter_nn_1 : N ;
  sittgrupp_nn_1 : N ;
  sittmoebel_nn_1 : N ;
  sittning_nn_1 : N ;
  sittopp_nn_1 : N ;
  sittpinne_nn_1 : N ;
  sittplats_nn_1 : N ;
  sittriktig_av_1 : A ;
  sittstaang_nn_1 : N ;
  sittstrejk_nn_1 : N ;
  sittvagn_nn_1 : N ;
  situation_nn_1 : N ;
  situationsbild_nn_1 : N ;
  sj_ljud_nn_1 : N ;
  sjaaare_nn_1 : N ;
  sjaap_nn_1 : N ;
  sjaaperi_nn_1 : N ;
  sjaapig_av_1 : A ;
  sjabbel_nn_1 : N ;
  sjabbig_av_1 : A ;
  sjael_nn_1 : N ;
  sjaelaglad_av_1 : A ;
  sjaelaringning_nn_1 : N ;
  sjaelasoerjare_nn_1 : N ;
  sjaelfull_av_1 : A ;
  sjaelisk_av_1 : A ;
  sjaelloes_av_1 : A ;
  sjaelsdoedande_av_1 : A ;
  sjaelsegenskap_nn_1 : N ;
  sjaelsfoermoegenhet_nn_1 : N ;
  sjaelsfraanvarande_av_1 : A ;
  sjaelsfraende_nn_1 : N ;
  sjaelskonflikt_nn_1 : N ;
  sjaelslig_av_1 : A ;
  sjaelsligen_ab_1 : Adv ;
  sjaelssjuk_av_1 : A ;
  sjaelsstrid_nn_1 : N ;
  sjaelv_av_1 : A ;
  sjaelvaegande_av_1 : A ;
  sjaelvalstring_nn_1 : N ;
  sjaelvanalys_nn_1 : N ;
  sjaelvanklagelse_nn_1 : N ;
  sjaelvantaendning_nn_1 : N ;
  sjaelvbedraegeri_nn_1 : N ;
  sjaelvbefruktning_nn_1 : N ;
  sjaelvbekaennelse_nn_1 : N ;
  sjaelvbelaaten_av_1 : A ;
  sjaelvbespegling_nn_1 : N ;
  sjaelvbindare_nn_1 : N ;
  sjaelvbiografi_nn_1 : N ;
  sjaelvbiografisk_av_1 : A ;
  sjaelvdeklaration_nn_1 : N ;
  sjaelvfallen_av_1 : A ;
  sjaelvfallet_ab_1 : Adv ;
  sjaelvfoergloemmande_av_1 : A ;
  sjaelvfoernekelse_nn_1 : N ;
  sjaelvgod_av_1 : A ;
  sjaelvgodhet_nn_1 : N ;
  sjaelvhaerlig_av_1 : A ;
  sjaelvhaerskare_nn_1 : N ;
  sjaelviakttagelse_nn_1 : N ;
  sjaelvinstruerande_av_1 : A ;
  sjaelvisk_av_1 : A ;
  sjaelvkaennedom_nn_1 : N ;
  sjaelvkem_nn_1 : N ;
  sjaelvklar_av_1 : A ;
  sjaelvklarhet_nn_1 : N ;
  sjaelvkritisk_av_1 : A ;
  sjaelvlaens_nn_1 : N ;
  sjaelvlaerd_av_1 : A ;
  sjaelvljud_nn_1 : N ;
  sjaelvlysande_av_1 : A ;
  sjaelvmaal_nn_1 : N ;
  sjaelvmant_ab_1 : Adv ;
  sjaelvmedveten_av_1 : A ;
  sjaelvmoerdare_nn_1 : N ;
  sjaelvmord_nn_1 : N ;
  sjaelvmordskandidat_nn_1 : N ;
  sjaelvmotsaegelse_nn_1 : N ;
  sjaelvpaatagen_av_1 : A ;
  sjaelvplaagare_nn_1 : N ;
  sjaelvportraett_nn_1 : N ;
  sjaelvraadig_av_1 : A ;
  sjaelvraettfaerdig_av_1 : A ;
  sjaelvrisk_nn_1 : N ;
  sjaelvsaeker_av_1 : A ;
  sjaelvsaekerhet_nn_1 : N ;
  sjaelvservering_nn_1 : N ;
  sjaelvskriven_av_1 : A ;
  sjaelvspelande_av_1 : A ;
  sjaelvspilling_nn_1 : N ;
  sjaelvstaendig_av_1 : A ;
  sjaelvstaendighet_nn_1 : N ;
  sjaelvstaendighetsfoerklaring_nn_1 : N ;
  sjaelvstudium_nn_1 : N ;
  sjaelvstyrande_av_1 : A ;
  sjaelvsvaaldig_av_1 : A ;
  sjaelvtaendning_nn_1 : N ;
  sjaelvtillraecklig_av_1 : A ;
  sjaelvuppfyllande_av_1 : A ;
  sjaelvupplevd_av_1 : A ;
  sjaelvuppoffrande_av_1 : A ;
  sjaelvuppoffring_nn_1 : N ;
  sjaelvupptagen_av_1 : A ;
  sjaelvutloesare_nn_1 : N ;
  sjaelvutnaemnd_av_1 : A ;
  sjaelvutplaanande_av_1 : A ;
  sjaelvvald_av_1 : A ;
  sjaettedel_nn_1 : N ;
  sjagg_nn_1 : N ;
  sjajas_nn_1 : N ;
  sjakal_nn_1 : N ;
  sjal_nn_1 : N ;
  sjalett_nn_1 : N ;
  sjalkrage_nn_1 : N ;
  sjangdobel_av_1 : A ;
  sjangtil_av_1 : A ;
  sjapp_nn_1 : N ;
  sjasker_nn_1 : N ;
  sjaskig_av_1 : A ;
  sjavig_av_1 : A ;
  sjoe_nn_1 : N ;
  sjoeavlagring_nn_1 : N ;
  sjoebjoern_nn_1 : N ;
  sjoebloet_av_1 : A ;
  sjoebod_nn_1 : N ;
  sjoeborre_nn_1 : N ;
  sjoebotten_nn_1 : N ;
  sjoebuss_nn_1 : N ;
  sjoedraenkt_av_1 : A ;
  sjoeduglig_av_1 : A ;
  sjoeelefant_nn_1 : N ;
  sjoefaagel_nn_1 : N ;
  sjoefaagelsjakt_nn_1 : N ;
  sjoefaerd_nn_1 : N ;
  sjoefarande_av_1 : A ;
  sjoefarare_nn_1 : N ;
  sjoefartsregel_nn_1 : N ;
  sjoeflygplan_nn_1 : N ;
  sjoefoerhoer_nn_1 : N ;
  sjoefoerklaring_nn_1 : N ;
  sjoefrakt_nn_1 : N ;
  sjoefynd_nn_1 : N ;
  sjoehaest_nn_1 : N ;
  sjoejungfru_nn_1 : N ;
  sjoekapten_nn_1 : N ;
  sjoekaptensbrev_nn_1 : N ;
  sjoeko_nn_1 : N ;
  sjoekort_nn_1 : N ;
  sjoelaegenhet_nn_1 : N ;
  sjoelejon_nn_1 : N ;
  sjoemaerke_nn_1 : N ;
  sjoeman_nn_1 : N ;
  sjoemansblus_nn_1 : N ;
  sjoemansfoermedling_nn_1 : N ;
  sjoemanshus_nn_1 : N ;
  sjoemansklaenning_nn_1 : N ;
  sjoemansknop_nn_1 : N ;
  sjoemanskrage_nn_1 : N ;
  sjoemanssaeck_nn_1 : N ;
  sjoemansutbildning_nn_1 : N ;
  sjoemil_nn_1 : N ;
  sjoeodjur_nn_1 : N ;
  sjoeofficer_nn_1 : N ;
  sjoeorm_nn_1 : N ;
  sjoeorre_nn_1 : N ;
  sjoepung_nn_1 : N ;
  sjoerapport_nn_1 : N ;
  sjoereglering_nn_1 : N ;
  sjoeroevare_nn_1 : N ;
  sjoeroeveri_nn_1 : N ;
  sjoesaeker_av_1 : A ;
  sjoesaettning_nn_1 : N ;
  sjoesediment_nn_1 : N ;
  sjoesjuk_av_1 : A ;
  sjoeslag_nn_1 : N ;
  sjoestoevel_nn_1 : N ;
  sjoestrid_nn_1 : N ;
  sjoetomt_nn_1 : N ;
  sjoetunga_nn_1 : N ;
  sjoevaegsregel_nn_1 : N ;
  sjoevaerdig_av_1 : A ;
  sjoevaerdighet_nn_1 : N ;
  sjoevana_nn_1 : N ;
  sjoevatten_nn_1 : N ;
  sjoevild_av_1 : A ;
  sjok_nn_1 : N ;
  sjuaarig_av_1 : A ;
  sjubb_nn_1 : N ;
  sjuckert_ab_1 : Adv ;
  sjudagarsvecka_nn_1 : N ;
  sjudimensionell_av_1 : A ;
  sjudundrande_av_1 : A ;
  sjuglasvagn_nn_1 : N ;
  sjuk_av_1 : A ;
  sjukavdrag_nn_1 : N ;
  sjukbaedd_nn_1 : N ;
  sjukbaerare_nn_1 : N ;
  sjukbesoek_nn_1 : N ;
  sjukbud_nn_1 : N ;
  sjukdag_nn_1 : N ;
  sjukdom_nn_1 : N ;
  sjukdomsalstrande_av_1 : A ;
  sjukdomsbild_nn_1 : N ;
  sjukdomshistoria_nn_1 : N ;
  sjukdomssymptom_nn_1 : N ;
  sjukdomstillstaand_nn_1 : N ;
  sjukfoersaekring_nn_1 : N ;
  sjukgymnast_nn_1 : N ;
  sjukhem_nn_1 : N ;
  sjukhus_nn_1 : N ;
  sjukhusavdelning_nn_1 : N ;
  sjukhusdirektoer_nn_1 : N ;
  sjukhussal_nn_1 : N ;
  sjukjournal_nn_1 : N ;
  sjukkassa_nn_1 : N ;
  sjuklaeger_nn_1 : N ;
  sjukledig_av_1 : A ;
  sjuklig_av_1 : A ;
  sjuklighet_nn_1 : N ;
  sjukling_nn_1 : N ;
  sjukpension_nn_1 : N ;
  sjukskoetare_nn_1 : N ;
  sjukskoeterska_nn_1 : N ;
  sjukskriva_vb_1 : V ;
  sjukstuga_nn_1 : N ;
  sjuksyster_nn_1 : N ;
  sjukvaardare_nn_1 : N ;
  sjukvaardsaffaer_nn_1 : N ;
  sjukvaardsartikel_nn_1 : N ;
  sjukvaardsbitraede_nn_1 : N ;
  sjukvaardsutbildning_nn_1 : N ;
  sjukvaardsutrustning_nn_1 : N ;
  sjukvikarie_nn_1 : N ;
  sjumilakliv_nn_1 : N ;
  sjundedagsadventist_nn_1 : N ;
  sjundedel_nn_1 : N ;
  sjunga_vb_1 : V ;
  sjunka_vb_1 : V ;
  sjunkbomb_nn_1 : N ;
  sjurygg_nn_1 : N ;
  sjusaerdeles_ab_1 : Adv ;
  sjusovare_nn_1 : N ;
  sjutillhaallarlaas_nn_1 : N ;
  sjyst_av_1 : A ;
  skaademynt_nn_1 : N ;
  skaadeplats_nn_1 : N ;
  skaadeprocess_nn_1 : N ;
  skaadespel_nn_1 : N ;
  skaadespelare_nn_1 : N ;
  skaadespelerska_nn_1 : N ;
  skaal_nn_1 : N ;
  skaalformig_av_1 : A ;
  skaalgrop_nn_1 : N ;
  skaalig_av_1 : A ;
  skaalkors_nn_1 : N ;
  skaallhet_av_1 : A ;
  skaalpund_nn_1 : N ;
  skaalsvamp_nn_1 : N ;
  skaaltom_av_1 : A ;
  skaaning_nn_1 : N ;
  skaank_nn_1 : N ;
  skaansk_av_1 : A ;
  skaanska_nn_2 : N ;
  skaap_nn_1 : N ;
  skaapbil_nn_1 : N ;
  skaapliknande_av_1 : A ;
  skaapsaeng_nn_1 : N ;
  skaapvagn_nn_1 : N ;
  skaar_nn_1 : N ;
  skaare_nn_1 : N ;
  skabbdjur_nn_1 : N ;
  skabbig_av_1 : A ;
  skabroes_av_1 : A ;
  skackel_nn_1 : N ;
  skadedjur_nn_1 : N ;
  skadeersaettning_nn_1 : N ;
  skadeglad_av_1 : A ;
  skadegoerare_nn_1 : N ;
  skadegoerelse_nn_1 : N ;
  skadeinsekt_nn_1 : N ;
  skadereglering_nn_1 : N ;
  skadesloes_av_1 : A ;
  skadestaand_nn_1 : N ;
  skadeverkning_nn_1 : N ;
  skadlig_av_1 : A ;
  skadskjuta_vb_1 : V ;
  skaeck_nn_1 : N ;
  skaeckig_av_1 : A ;
  skaeftig_av_1 : A ;
  skaegg_nn_1 : N ;
  skaeggbotten_nn_1 : N ;
  skaeggdopping_nn_1 : N ;
  skaeggig_av_1 : A ;
  skaegglapp_nn_1 : N ;
  skaeggloes_av_1 : A ;
  skaeggstraa_nn_1 : N ;
  skaeggtoem_nn_1 : N ;
  skaektetrae_nn_1 : N ;
  skaektkniv_nn_1 : N ;
  skaektstol_nn_1 : N ;
  skaekttrae_nn_1 : N ;
  skael_nn_1 : N ;
  skaelig_av_1 : A ;
  skaeligen_ab_1 : Adv ;
  skaell_av_1 : A ;
  skaellko_nn_1 : N ;
  skaellning_nn_1 : N ;
  skaellsord_nn_1 : N ;
  skaelm_nn_1 : N ;
  skaelmaktig_av_1 : A ;
  skaelmroman_nn_1 : N ;
  skaelmsk_av_1 : A ;
  skaemd_av_1 : A ;
  skaemt_nn_1 : N ;
  skaemtare_nn_1 : N ;
  skaemtsam_av_1 : A ;
  skaemttecknare_nn_1 : N ;
  skaemtteckning_nn_1 : N ;
  skaendlig_av_1 : A ;
  skaendligen_ab_1 : Adv ;
  skaendlighet_nn_1 : N ;
  skaendning_nn_1 : N ;
  skaenk_nn_1 : N ;
  skaenk_nn_2 : N ;
  skaenkel_nn_1 : N ;
  skaer_av_1 : A ;
  skaer_nn_1 : N ;
  skaera_vb_1 : V ;
  skaerande_av_1 : A ;
  skaerbraede_nn_1 : N ;
  skaerbraennare_nn_1 : N ;
  skaergaard_nn_1 : N ;
  skaergaardsbo_nn_1 : N ;
  skaergaardskryssare_nn_1 : N ;
  skaergaardsoe_nn_1 : N ;
  skaergaardsturist_nn_1 : N ;
  skaerhaallfasthet_nn_1 : N ;
  skaerkarl_nn_1 : N ;
  skaerkniv_nn_1 : N ;
  skaerm_nn_1 : N ;
  skaermbild_nn_1 : N ;
  skaermbildsundersoekning_nn_1 : N ;
  skaermytsel_nn_1 : N ;
  skaermytsling_nn_1 : N ;
  skaerning_nn_1 : N ;
  skaerningspunkt_nn_1 : N ;
  skaerp_nn_1 : N ;
  skaerpedjup_nn_1 : N ;
  skaerpning_nn_1 : N ;
  skaerpt_av_1 : A ;
  skaerslipare_nn_1 : N ;
  skaerstock_nn_1 : N ;
  skaertorsdag_nn_1 : N ;
  skaerv_nn_1 : N ;
  skaevig_av_1 : A ;
  skafferi_nn_1 : N ;
  skaffning_nn_1 : N ;
  skaffoettes_ab_1 : Adv ;
  skafoettes_ab_1 : Adv ;
  skaft_nn_1 : N ;
  skak_nn_1 : N ;
  skakande_av_1 : A ;
  skakel_nn_1 : N ;
  skakig_av_1 : A ;
  skakis_av_1 : A ;
  skakning_nn_1 : N ;
  skal_nn_1 : N ;
  skalaer_av_1 : A ;
  skalaer_nn_1 : N ;
  skalbagge_nn_1 : N ;
  skald_nn_1 : N ;
  skaldekonst_nn_1 : N ;
  skaldisk_av_1 : A ;
  skaldjur_nn_1 : N ;
  skalenlig_av_1 : A ;
  skalhus_nn_1 : N ;
  skalk_nn_1 : N ;
  skalkaktig_av_1 : A ;
  skalkeskjul_nn_1 : N ;
  skalkorn_nn_1 : N ;
  skall_nn_1 : N ;
  skallbas_nn_1 : N ;
  skallben_nn_1 : N ;
  skalle_nn_1 : N ;
  skallerorm_nn_1 : N ;
  skallform_nn_1 : N ;
  skallgaang_nn_1 : N ;
  skallig_av_1 : A ;
  skalloes_av_1 : A ;
  skallra_nn_1 : N ;
  skalm_nn_1 : N ;
  skalp_nn_1 : N ;
  skalpell_nn_1 : N ;
  skalstreck_nn_1 : N ;
  skalv_nn_1 : N ;
  skamflaeck_nn_1 : N ;
  skamgrepp_nn_1 : N ;
  skamkaensla_nn_1 : N ;
  skamlig_av_1 : A ;
  skamligen_ab_1 : Adv ;
  skamlighet_nn_1 : N ;
  skamloes_av_1 : A ;
  skamloeshet_nn_1 : N ;
  skampaale_nn_1 : N ;
  skamsen_av_1 : A ;
  skamstock_nn_1 : N ;
  skandal_nn_1 : N ;
  skandaloes_av_1 : A ;
  skandalunge_nn_1 : N ;
  skandinav_nn_1 : N ;
  skandinavisk_av_1 : A ;
  skandinavist_nn_1 : N ;
  skanism_nn_1 : N ;
  skank_nn_1 : N ;
  skans_nn_1 : N ;
  skap_nn_1 : N ;
  skapande_av_1 : A ;
  skapare_nn_1 : N ;
  skaparkraft_nn_1 : N ;
  skapelse_nn_1 : N ;
  skaplig_av_1 : A ;
  skapnad_nn_1 : N ;
  skarabe_nn_1 : N ;
  skarf_nn_1 : N ;
  skarn_nn_1 : N ;
  skarndaeck_nn_1 : N ;
  skarp_av_1 : A ;
  skarpoegd_av_1 : A ;
  skarpraettare_nn_1 : N ;
  skarpsill_nn_1 : N ;
  skarpskuren_av_1 : A ;
  skarpskytt_nn_1 : N ;
  skarpsyn_nn_1 : N ;
  skarpsynt_av_1 : A ;
  skarpt_ab_1 : Adv ;
  skarv_nn_1 : N ;
  skarvsladd_nn_1 : N ;
  skate_nn_1 : N ;
  skateboard_nn_1 : N ;
  skatt_nn_1 : N ;
  skatteaaterbaering_nn_1 : N ;
  skatteavdrag_nn_1 : N ;
  skattebas_nn_1 : N ;
  skattebelopp_nn_1 : N ;
  skattebetalare_nn_1 : N ;
  skattebetalning_nn_1 : N ;
  skattebonde_nn_1 : N ;
  skattebrott_nn_1 : N ;
  skattefraaga_nn_1 : N ;
  skattefri_av_1 : A ;
  skattefrihet_nn_1 : N ;
  skattefuskare_nn_1 : N ;
  skattehoejning_nn_1 : N ;
  skatteingenjoer_nn_1 : N ;
  skatteinkomst_nn_1 : N ;
  skatteintaekt_nn_1 : N ;
  skattekil_nn_1 : N ;
  skatteklass_nn_1 : N ;
  skattekort_nn_1 : N ;
  skattekraft_nn_1 : N ;
  skattelaettnad_nn_1 : N ;
  skattelag_nn_1 : N ;
  skattemaerke_nn_1 : N ;
  skattemoral_nn_1 : N ;
  skattemyndighet_nn_1 : N ;
  skattenivaa_nn_1 : N ;
  skattepliktig_av_1 : A ;
  skatteprincip_nn_1 : N ;
  skatteprotest_nn_1 : N ;
  skattereduktion_nn_1 : N ;
  skattereform_nn_1 : N ;
  skatteregel_nn_1 : N ;
  skatterevolt_nn_1 : N ;
  skattesaenkning_nn_1 : N ;
  skattesats_nn_1 : N ;
  skattesmitare_nn_1 : N ;
  skattesystem_nn_1 : N ;
  skattetabell_nn_1 : N ;
  skattetak_nn_1 : N ;
  skattetryck_nn_1 : N ;
  skatteuttag_nn_1 : N ;
  skattkammarvaexel_nn_1 : N ;
  skattmaestare_nn_1 : N ;
  skattmas_nn_1 : N ;
  skattsedel_nn_1 : N ;
  skattskriva_vb_1 : V ;
  skattskyldig_av_1 : A ;
  skattsoekare_nn_1 : N ;
  skavank_nn_1 : N ;
  skavfoetters_ab_1 : Adv ;
  skavsaar_nn_1 : N ;
  skavskydd_nn_1 : N ;
  sked_nn_1 : N ;
  skedand_nn_1 : N ;
  skeddrag_nn_1 : N ;
  skedstork_nn_1 : N ;
  skedvis_ab_1 : Adv ;
  skeende_nn_1 : N ;
  skelett_nn_1 : N ;
  skelettmuskel_nn_1 : N ;
  skeloegd_av_1 : A ;
  skeloegdhet_nn_1 : N ;
  sken_nn_1 : N ;
  skenbar_av_1 : A ;
  skenbarligen_ab_1 : Adv ;
  skenben_nn_1 : N ;
  skenbild_nn_1 : N ;
  skendoed_av_1 : A ;
  skenfaektning_nn_1 : N ;
  skenfrukt_nn_1 : N ;
  skenhaendelse_nn_1 : N ;
  skenhelig_av_1 : A ;
  skenraettegaang_nn_1 : N ;
  skenvaerld_nn_1 : N ;
  skepnad_nn_1 : N ;
  skepp_nn_1 : N ;
  skepparbrev_nn_1 : N ;
  skeppare_nn_1 : N ;
  skepparexamen_nn_1 : N ;
  skepparhistoria_nn_1 : N ;
  skepparkrans_nn_1 : N ;
  skeppsapotek_nn_1 : N ;
  skeppsbaat_nn_1 : N ;
  skeppsbro_nn_1 : N ;
  skeppsbrott_nn_1 : N ;
  skeppsbruten_av_1 : A ;
  skeppsbyggeri_nn_1 : N ;
  skeppsgosse_nn_1 : N ;
  skeppsklarerare_nn_1 : N ;
  skeppslag_nn_1 : N ;
  skeppsljus_nn_1 : N ;
  skeppsmaeklare_nn_1 : N ;
  skeppsmask_nn_1 : N ;
  skeppspojke_nn_1 : N ;
  skeppsredare_nn_1 : N ;
  skeppssaettning_nn_1 : N ;
  skeppsvarv_nn_1 : N ;
  skeppund_nn_1 : N ;
  skeptiker_nn_1 : N ;
  skeptisk_av_1 : A ;
  sketch_nn_1 : N ;
  sketen_av_1 : A ;
  skev_av_1 : A ;
  skevningsroder_nn_1 : N ;
  skevroder_nn_1 : N ;
  skick_nn_1 : N ;
  skickebud_nn_1 : N ;
  skickelse_nn_1 : N ;
  skickelsediger_av_1 : A ;
  skicklig_av_1 : A ;
  skicklighet_nn_1 : N ;
  skidaakare_nn_1 : N ;
  skidbacke_nn_1 : N ;
  skidfynd_nn_1 : N ;
  skidhoppning_nn_1 : N ;
  skidlift_nn_1 : N ;
  skidloepning_nn_1 : N ;
  skidspaar_nn_1 : N ;
  skidstav_nn_1 : N ;
  skidtaevling_nn_1 : N ;
  skidtur_nn_1 : N ;
  skidtyp_nn_1 : N ;
  skiffer_nn_1 : N ;
  skiffertak_nn_1 : N ;
  skiffrig_av_1 : A ;
  skift_nn_1 : N ;
  skifte_nn_1 : N ;
  skiftning_nn_1 : N ;
  skiftnyckel_nn_1 : N ;
  skikt_nn_1 : N ;
  skiktmoln_nn_1 : N ;
  skild_av_1 : A ;
  skildring_nn_1 : N ;
  skiljaktig_av_1 : A ;
  skiljaktighet_nn_1 : N ;
  skiljbar_av_1 : A ;
  skiljedom_nn_1 : N ;
  skiljedomstol_nn_1 : N ;
  skiljefoerfarande_nn_1 : N ;
  skiljelinje_nn_1 : N ;
  skiljeman_nn_1 : N ;
  skiljemur_nn_1 : N ;
  skiljemynt_nn_1 : N ;
  skiljenaemnd_nn_1 : N ;
  skiljeset_nn_1 : N ;
  skiljetecken_nn_1 : N ;
  skiljevaeg_nn_1 : N ;
  skiljevaegg_nn_1 : N ;
  skilling_nn_1 : N ;
  skillingtryck_nn_1 : N ;
  skillnad_nn_1 : N ;
  skilsmaessa_nn_1 : N ;
  skiltvakt_nn_1 : N ;
  skimmel_nn_1 : N ;
  skingringsfoerbud_nn_1 : N ;
  skinhead_nn_1 : N ;
  skinn_nn_1 : N ;
  skinnare_nn_1 : N ;
  skinnbagge_nn_1 : N ;
  skinnband_nn_1 : N ;
  skinnbit_nn_1 : N ;
  skinnerbur_nn_1 : N ;
  skinnfaell_nn_1 : N ;
  skinnflaadd_av_1 : A ;
  skinnimitation_nn_1 : N ;
  skinnkaelke_nn_1 : N ;
  skinnklaedd_av_1 : A ;
  skinnknutte_nn_1 : N ;
  skinnpaj_nn_1 : N ;
  skinntorr_av_1 : A ;
  skioptikon_nn_1 : N ;
  skir_av_1 : A ;
  skiss_nn_1 : N ;
  skissblock_nn_1 : N ;
  skit_nn_1 : N ;
  skitbra_av_1 : A ;
  skitfoernaem_av_1 : A ;
  skitgubbe_nn_1 : N ;
  skitig_av_1 : A ;
  skitkul_av_1 : A ;
  skitnoedig_av_1 : A ;
  skitsnygg_av_1 : A ;
  skitstoevel_nn_1 : N ;
  skitviktig_av_1 : A ;
  skivaffaer_nn_1 : N ;
  skivbar_nn_1 : N ;
  skivbroms_nn_1 : N ;
  skivhus_nn_1 : N ;
  skivig_av_1 : A ;
  skivling_nn_1 : N ;
  skivminne_nn_1 : N ;
  skivpratare_nn_1 : N ;
  skivspelare_nn_1 : N ;
  skivstaang_nn_1 : N ;
  skivsvamp_nn_1 : N ;
  skivtallrik_nn_1 : N ;
  skjortaerm_nn_1 : N ;
  skjortblus_nn_1 : N ;
  skjortbroest_nn_1 : N ;
  skjortkrage_nn_1 : N ;
  skjul_nn_1 : N ;
  skjut_nn_1 : N ;
  skjuta_vb_1 : V ;
  skjutdoerr_nn_1 : N ;
  skjutfaelt_nn_1 : N ;
  skjutfaerdig_av_1 : A ;
  skjutjaern_nn_1 : N ;
  skjutjaernsintervju_nn_1 : N ;
  skjutjaernsjournalist_nn_1 : N ;
  skjutklar_av_1 : A ;
  skjutmaatt_nn_1 : N ;
  skjutning_nn_1 : N ;
  skjutriktning_nn_1 : N ;
  skjuts_nn_1 : N ;
  skjutshaall_nn_1 : N ;
  skjutskaare_nn_1 : N ;
  skjututbildning_nn_1 : N ;
  skjutvapen_nn_1 : N ;
  skjutvinkel_nn_1 : N ;
  skleros_nn_1 : N ;
  sklerotisk_av_1 : A ;
  sko_nn_1 : N ;
  skoblock_nn_1 : N ;
  skoborste_nn_1 : N ;
  skock_nn_1 : N ;
  skodon_nn_1 : N ;
  skoel_nn_1 : N ;
  skoeld_nn_1 : N ;
  skoeldborg_nn_1 : N ;
  skoeldebrev_nn_1 : N ;
  skoeldemaerke_nn_1 : N ;
  skoeldhaallare_nn_1 : N ;
  skoeldkoertel_nn_1 : N ;
  skoeldkoertelcancer_nn_1 : N ;
  skoeldkoertelhormon_nn_1 : N ;
  skoeldlus_nn_1 : N ;
  skoeldmoe_nn_1 : N ;
  skoeljkopp_nn_1 : N ;
  skoelp_nn_1 : N ;
  skoen_av_1 : A ;
  skoenande_nn_1 : N ;
  skoenhet_nn_1 : N ;
  skoenhetsdrottning_nn_1 : N ;
  skoenhetsfel_nn_1 : N ;
  skoenhetsflaeck_nn_1 : N ;
  skoenhetsideal_nn_1 : N ;
  skoenhetsmedel_nn_1 : N ;
  skoenhetspris_nn_1 : N ;
  skoenhetstaevling_nn_1 : N ;
  skoenhetsupplevelse_nn_1 : N ;
  skoenhetsvaard_nn_1 : N ;
  skoenhetsvaerde_nn_1 : N ;
  skoenjbar_av_1 : A ;
  skoenlitteraer_av_1 : A ;
  skoenlockig_av_1 : A ;
  skoenskrivare_nn_1 : N ;
  skoensmaessig_av_1 : A ;
  skoer_av_1 : A ;
  skoerd_nn_1 : N ;
  skoerdeenhet_nn_1 : N ;
  skoerdemaanad_nn_1 : N ;
  skoerdemaskin_nn_1 : N ;
  skoerdetid_nn_1 : N ;
  skoerdetroeska_nn_1 : N ;
  skoerdeuppskattning_nn_1 : N ;
  skoerlevnad_nn_1 : N ;
  skoerpil_nn_1 : N ;
  skoert_nn_1 : N ;
  skoet_nn_1 : N ;
  skoetare_nn_1 : N ;
  skoetbord_nn_1 : N ;
  skoetebarn_nn_1 : N ;
  skoeterska_nn_1 : N ;
  skoetesynd_nn_1 : N ;
  skoetrum_nn_1 : N ;
  skoetsam_av_1 : A ;
  skoflickare_nn_1 : N ;
  skog_nn_1 : N ;
  skogbevuxen_av_1 : A ;
  skogfattig_av_1 : A ;
  skogig_av_1 : A ;
  skogklaedd_av_1 : A ;
  skoglig_av_1 : A ;
  skogsarbetare_nn_1 : N ;
  skogsavverkning_nn_1 : N ;
  skogsbaeck_nn_1 : N ;
  skogsbagge_nn_1 : N ;
  skogsbete_nn_1 : N ;
  skogsbolag_nn_1 : N ;
  skogsbrand_nn_1 : N ;
  skogsdunge_nn_1 : N ;
  skogsfaagel_nn_1 : N ;
  skogsfoerbaettring_nn_1 : N ;
  skogsfoervaltning_nn_1 : N ;
  skogsfru_nn_1 : N ;
  skogsgenetiker_nn_1 : N ;
  skogsgenetisk_av_1 : A ;
  skogsgud_nn_1 : N ;
  skogshoens_nn_1 : N ;
  skogshuggare_nn_1 : N ;
  skogsindustri_nn_1 : N ;
  skogskovall_nn_1 : N ;
  skogslandskap_nn_1 : N ;
  skogsmaestare_nn_1 : N ;
  skogsmark_nn_1 : N ;
  skogsmus_nn_1 : N ;
  skogsomraade_nn_1 : N ;
  skogsraa_nn_1 : N ;
  skogstomt_nn_1 : N ;
  skogstraed_nn_1 : N ;
  skogstraedsfoeraedlare_nn_1 : N ;
  skogsvaard_nn_1 : N ;
  skogsvaeg_nn_1 : N ;
  skogsvandring_nn_1 : N ;
  skogvaktare_nn_1 : N ;
  skohorn_nn_1 : N ;
  skoj_av_1 : A ;
  skoj_nn_1 : N ;
  skojare_nn_1 : N ;
  skojeri_nn_1 : N ;
  skojfrisk_av_1 : A ;
  skojig_av_1 : A ;
  skoklaedd_av_1 : A ;
  skokraem_nn_1 : N ;
  skolaar_nn_1 : N ;
  skolaemne_nn_1 : N ;
  skolaest_nn_1 : N ;
  skolaest_nn_2 : N ;
  skolastiker_nn_1 : N ;
  skolastisk_av_1 : A ;
  skolavgift_nn_1 : N ;
  skolavslutning_nn_1 : N ;
  skolbaenk_nn_1 : N ;
  skolbarn_nn_1 : N ;
  skolbildning_nn_1 : N ;
  skolbok_nn_1 : N ;
  skolbuss_nn_1 : N ;
  skolchef_nn_1 : N ;
  skoldag_nn_1 : N ;
  skoldans_nn_1 : N ;
  skoldirektoer_nn_1 : N ;
  skolelev_nn_1 : N ;
  skolexempel_nn_1 : N ;
  skolfartyg_nn_1 : N ;
  skolflygplan_nn_1 : N ;
  skolfoervaltning_nn_1 : N ;
  skolform_nn_1 : N ;
  skolfroeken_nn_1 : N ;
  skolfux_nn_1 : N ;
  skolgaard_nn_1 : N ;
  skolgrammatik_nn_1 : N ;
  skolhem_nn_1 : N ;
  skolhus_nn_1 : N ;
  skolinspektoer_nn_1 : N ;
  skolkare_nn_1 : N ;
  skolklass_nn_1 : N ;
  skolkoek_nn_1 : N ;
  skolkort_nn_1 : N ;
  skolledare_nn_1 : N ;
  skolljus_nn_1 : N ;
  skollov_nn_1 : N ;
  skollunch_nn_1 : N ;
  skolmaaltid_nn_1 : N ;
  skolmaestaraktig_av_1 : A ;
  skolmaestare_nn_1 : N ;
  skolmagister_nn_1 : N ;
  skolmogen_av_1 : A ;
  skolmognad_nn_1 : N ;
  skolmognadsklass_nn_1 : N ;
  skolmognadsprov_nn_1 : N ;
  skolnaemnd_nn_1 : N ;
  skolning_nn_1 : N ;
  skolpolis_nn_1 : N ;
  skolprov_nn_1 : N ;
  skolraad_nn_1 : N ;
  skolridning_nn_1 : N ;
  skolsal_nn_1 : N ;
  skolsjuk_av_1 : A ;
  skolskepp_nn_1 : N ;
  skolskjutning_nn_1 : N ;
  skolskjuts_nn_1 : N ;
  skolstyrelse_nn_1 : N ;
  skolt_nn_1 : N ;
  skoltroett_av_1 : A ;
  skolunderbyggnad_nn_1 : N ;
  skolungdom_nn_1 : N ;
  skolungdomsidrott_nn_1 : N ;
  skoluppsats_nn_1 : N ;
  skolutbildning_nn_1 : N ;
  skolvaeg_nn_1 : N ;
  skolvaesende_nn_1 : N ;
  skomakare_nn_1 : N ;
  skomakarverkstad_nn_1 : N ;
  skomakeri_nn_1 : N ;
  skonare_nn_1 : N ;
  skonert_nn_1 : N ;
  skonertskepp_nn_1 : N ;
  skoning_nn_1 : N ;
  skoningsloes_av_1 : A ;
  skonsam_av_1 : A ;
  skonummer_nn_1 : N ;
  skopofil_av_1 : A ;
  skopofil_nn_1 : N ;
  skopolamin_nn_1 : N ;
  skoputsare_nn_1 : N ;
  skorpion_nn_1 : N ;
  skorsten_nn_1 : N ;
  skorstensfejare_nn_1 : N ;
  skorv_nn_2 : N ;
  skorvig_av_1 : A ;
  skosmoerja_nn_1 : N ;
  skot_nn_1 : N ;
  skoter_nn_1 : N ;
  skothorn_nn_1 : N ;
  skotsk_av_1 : A ;
  skotska_nn_2 : N ;
  skotskrutig_av_1 : A ;
  skotstek_nn_1 : N ;
  skott_nn_1 : N ;
  skottaar_nn_1 : N ;
  skottavla_nn_1 : N ;
  skottdag_nn_1 : N ;
  skotte_nn_1 : N ;
  skottfaelt_nn_1 : N ;
  skottglugg_nn_1 : N ;
  skottlinje_nn_1 : N ;
  skottpeng_nn_1 : N ;
  skottsaeker_av_1 : A ;
  skottsekund_nn_1 : N ;
  skottskog_nn_1 : N ;
  skottspole_nn_1 : N ;
  skov_nn_1 : N ;
  skovel_nn_1 : N ;
  skovelhjul_nn_1 : N ;
  skraa_av_1 : A ;
  skraa_nn_1 : N ;
  skraal_nn_1 : N ;
  skraapuk_nn_1 : N ;
  skrabbig_av_1 : A ;
  skraeckexempel_nn_1 : N ;
  skraeckfilm_nn_1 : N ;
  skraeckinjagande_av_1 : A ;
  skraeckkabinett_nn_1 : N ;
  skraecknovell_nn_1 : N ;
  skraeckslagen_av_1 : A ;
  skraecksyn_nn_1 : N ;
  skraeckvision_nn_1 : N ;
  skraeddare_nn_1 : N ;
  skraedderi_nn_1 : N ;
  skraell_nn_1 : N ;
  skraelldus_nn_1 : N ;
  skraellig_av_1 : A ;
  skraemmande_av_1 : A ;
  skraemskott_nn_1 : N ;
  skraen_nn_1 : N ;
  skraenfock_nn_1 : N ;
  skraenig_av_1 : A ;
  skraepig_av_1 : A ;
  skraepkultur_nn_1 : N ;
  skraevlare_nn_1 : N ;
  skraevlig_av_1 : A ;
  skraj_av_1 : A ;
  skrajsen_av_1 : A ;
  skrak_nn_1 : N ;
  skrake_nn_1 : N ;
  skral_av_1 : A ;
  skraltig_av_1 : A ;
  skramla_nn_1 : N ;
  skramlig_av_1 : A ;
  skranglig_av_1 : A ;
  skrank_nn_1 : N ;
  skrapning_nn_1 : N ;
  skratt_nn_1 : N ;
  skrattare_nn_1 : N ;
  skrattgrop_nn_1 : N ;
  skrattlysten_av_1 : A ;
  skrattmaas_nn_1 : N ;
  skrattretande_av_1 : A ;
  skrattspegel_nn_1 : N ;
  skred_nn_1 : N ;
  skrev_nn_1 : N ;
  skri_nn_1 : N ;
  skriande_av_1 : A ;
  skribent_nn_1 : N ;
  skrida_vb_1 : V ;
  skridsko_nn_1 : N ;
  skridskoaakare_nn_1 : N ;
  skrift_nn_1 : N ;
  skriftbild_nn_1 : N ;
  skriftermaal_nn_1 : N ;
  skriftlig_av_1 : A ;
  skriftligen_ab_1 : Adv ;
  skriftspraak_nn_1 : N ;
  skriftspraaklig_av_1 : A ;
  skriftstaellare_nn_1 : N ;
  skriftstaelleri_nn_1 : N ;
  skriftsystem_nn_1 : N ;
  skrik_nn_1 : N ;
  skrikhals_nn_1 : N ;
  skrikig_av_1 : A ;
  skrin_nn_1 : N ;
  skrinnare_nn_1 : N ;
  skriptum_nn_1 : N ;
  skriva_vb_1 : V ;
  skrivare_nn_1 : N ;
  skrivblock_nn_1 : N ;
  skrivbok_nn_1 : N ;
  skrivbord_nn_1 : N ;
  skrivbyraa_nn_1 : N ;
  skrivelse_nn_1 : N ;
  skriveri_nn_1 : N ;
  skrivkunnig_av_1 : A ;
  skrivmaskin_nn_1 : N ;
  skrivmaskinsbord_nn_1 : N ;
  skrivmaskinsstol_nn_1 : N ;
  skrivmaskinstangent_nn_1 : N ;
  skrivning_nn_1 : N ;
  skrivoevning_nn_1 : N ;
  skrivplaan_nn_1 : N ;
  skrivplats_nn_1 : N ;
  skrivstil_nn_1 : N ;
  skrivtavla_nn_1 : N ;
  skrivtecken_nn_1 : N ;
  skrodoer_nn_1 : N ;
  skroeplig_av_1 : A ;
  skrofuloes_av_1 : A ;
  skrotbil_nn_1 : N ;
  skrothoeg_nn_1 : N ;
  skrotskulptur_nn_1 : N ;
  skrott_nn_1 : N ;
  skrotupplag_nn_1 : N ;
  skrov_nn_1 : N ;
  skrovlig_av_1 : A ;
  skrovmaal_nn_1 : N ;
  skrubb_nn_1 : N ;
  skrubbsaar_nn_1 : N ;
  skrud_nn_1 : N ;
  skrumpen_av_1 : A ;
  skrupel_nn_1 : N ;
  skrupelfri_av_1 : A ;
  skrupuloes_av_1 : A ;
  skrutt_nn_2 : N ;
  skruttig_av_1 : A ;
  skruv_nn_1 : N ;
  skruvmejsel_nn_1 : N ;
  skruvnyckel_nn_1 : N ;
  skruvstaed_nn_1 : N ;
  skruvtving_nn_1 : N ;
  skrymmande_av_1 : A ;
  skrymt_nn_1 : N ;
  skrymtare_nn_1 : N ;
  skrymteri_nn_1 : N ;
  skrynkelfri_av_1 : A ;
  skrynkelhaerdig_av_1 : A ;
  skrynkla_nn_1 : N ;
  skrynklig_av_1 : A ;
  skrytmaans_nn_1 : N ;
  skrytsam_av_1 : A ;
  skubb_nn_1 : N ;
  skuff_nn_1 : N ;
  skuggbild_nn_1 : N ;
  skuggig_av_1 : A ;
  skuggindustri_nn_1 : N ;
  skuggkabinett_nn_1 : N ;
  skuggloesning_nn_1 : N ;
  skuggregering_nn_1 : N ;
  skuggsida_nn_1 : N ;
  skuggspelsteater_nn_1 : N ;
  skuld_nn_1 : N ;
  skuldebrev_nn_1 : N ;
  skulderblad_nn_1 : N ;
  skulderled_nn_1 : N ;
  skuldfoerbindelse_nn_1 : N ;
  skuldkaensla_nn_1 : N ;
  skuldmedveten_av_1 : A ;
  skuldra_nn_1 : N ;
  skuldsatt_av_1 : A ;
  skulle_nn_1 : N ;
  skulptoer_nn_1 : N ;
  skulptris_nn_1 : N ;
  skulptur_nn_1 : N ;
  skulptural_av_1 : A ;
  skult_nn_1 : N ;
  skum_av_1 : A ;
  skumbad_nn_1 : N ;
  skumbubbla_nn_1 : N ;
  skummig_av_1 : A ;
  skummis_nn_1 : N ;
  skumoegd_av_1 : A ;
  skumpig_av_1 : A ;
  skumraskaffaer_nn_1 : N ;
  skumslaeckare_nn_1 : N ;
  skumtvaettning_nn_1 : N ;
  skunk_nn_1 : N ;
  skunkdjur_nn_1 : N ;
  skur_nn_1 : N ;
  skurborste_nn_1 : N ;
  skurduk_nn_1 : N ;
  skurgolv_nn_1 : N ;
  skurhink_nn_1 : N ;
  skurk_nn_1 : N ;
  skurkstreck_nn_1 : N ;
  skurlov_nn_1 : N ;
  skurpulver_nn_1 : N ;
  skurril_av_1 : A ;
  skutt_nn_1 : N ;
  skvader_nn_1 : N ;
  skvadron_nn_1 : N ;
  skvaett_nn_1 : N ;
  skvaetta_vb_1 : V ;
  skvalbank_nn_1 : N ;
  skvalleraktig_av_1 : A ;
  skvallerbaer_nn_1 : N ;
  skvallermoster_nn_1 : N ;
  skvallerspalt_nn_1 : N ;
  skvallerspegel_nn_1 : N ;
  skvallertant_nn_1 : N ;
  skvallertaska_nn_1 : N ;
  skvallrig_av_1 : A ;
  skvalpig_av_1 : A ;
  skvaltkvarn_nn_1 : N ;
  skvaltorre_nn_1 : N ;
  skvatt_ab_1 : Adv ;
  skvis_nn_1 : N ;
  sky_nn_1 : N ;
  skydd_nn_1 : N ;
  skyddsaengel_nn_1 : N ;
  skyddsande_nn_1 : N ;
  skyddsdraekt_nn_1 : N ;
  skyddsduk_nn_1 : N ;
  skyddsfaerg_nn_1 : N ;
  skyddsgrav_nn_1 : N ;
  skyddshelgon_nn_1 : N ;
  skyddskonsulent_nn_1 : N ;
  skyddskropp_nn_1 : N ;
  skyddsling_nn_1 : N ;
  skyddsloes_av_1 : A ;
  skyddsmask_nn_1 : N ;
  skyddsmedel_nn_1 : N ;
  skyddsmur_nn_1 : N ;
  skyddsombud_nn_1 : N ;
  skyddsomraade_nn_1 : N ;
  skyddspatron_nn_1 : N ;
  skyddsrock_nn_1 : N ;
  skyddsrum_nn_1 : N ;
  skyddsstat_nn_1 : N ;
  skyddstak_nn_1 : N ;
  skyddstull_nn_1 : N ;
  skydrag_nn_1 : N ;
  skyeterrier_nn_1 : N ;
  skyfall_nn_1 : N ;
  skyffel_nn_1 : N ;
  skygg_av_1 : A ;
  skygglapp_nn_1 : N ;
  skyhoeg_av_1 : A ;
  skyig_av_1 : A ;
  skyl_nn_1 : N ;
  skyld_av_1 : A ;
  skyldig_av_1 : A ;
  skyldighet_nn_1 : N ;
  skylight_nn_1 : N ;
  skyllerkur_nn_1 : N ;
  skylt_nn_1 : N ;
  skyltfoenster_nn_1 : N ;
  skyltning_nn_1 : N ;
  skyltskaap_nn_1 : N ;
  skyltsoendag_nn_1 : N ;
  skymf_nn_1 : N ;
  skymflig_av_1 : A ;
  skymford_nn_1 : N ;
  skymmel_nn_2 : N ;
  skymning_nn_1 : N ;
  skymt_nn_1 : N ;
  skyndsam_av_1 : A ;
  skyt_nn_1 : N ;
  skytt_nn_1 : N ;
  skyttegrav_nn_1 : N ;
  skyttegravskrig_nn_1 : N ;
  skyttegrop_nn_1 : N ;
  skyttegrupp_nn_1 : N ;
  skyttel_nn_1 : N ;
  skyttelinje_nn_1 : N ;
  skyttevaern_nn_1 : N ;
  slaa_nn_1 : N ;
  slaaende_av_1 : A ;
  slaanbaer_nn_1 : N ;
  slaanbaersbuske_nn_1 : N ;
  slaatter_nn_1 : N ;
  slaatteraeng_nn_1 : N ;
  slaatterkniv_nn_1 : N ;
  slaattermaskin_nn_1 : N ;
  slaattermyr_nn_1 : N ;
  slabb_av_1 : A ;
  slabbig_av_1 : A ;
  slack_av_1 : A ;
  sladd_nn_1 : N ;
  sladdbarn_nn_1 : N ;
  sladdig_av_1 : A ;
  sladdrig_av_1 : A ;
  slaeddon_nn_1 : N ;
  slaede_nn_1 : N ;
  slaedhund_nn_1 : N ;
  slaedmed_nn_1 : N ;
  slaedparti_nn_1 : N ;
  slaegghammare_nn_1 : N ;
  slaekt_av_1 : A ;
  slaekt_nn_1 : N ;
  slaektdrag_nn_1 : N ;
  slaektdrift_nn_1 : N ;
  slaekthistoria_nn_1 : N ;
  slaekting_nn_1 : N ;
  slaektled_nn_1 : N ;
  slaektledning_nn_1 : N ;
  slaektlinje_nn_1 : N ;
  slaektnamn_nn_1 : N ;
  slaektportraett_nn_1 : N ;
  slaektregister_nn_1 : N ;
  slaektsaga_nn_1 : N ;
  slaektskapsfoerhaallande_nn_1 : N ;
  slaekttraed_nn_1 : N ;
  slaendlarv_nn_1 : N ;
  slaeng_nn_1 : N ;
  slaengd_av_1 : A ;
  slaengig_av_1 : A ;
  slaengkaelke_nn_1 : N ;
  slaengkyss_nn_1 : N ;
  slaengpolska_nn_1 : N ;
  slaengskott_nn_1 : N ;
  slaent_nn_1 : N ;
  slaep_nn_1 : N ;
  slaepig_av_1 : A ;
  slaepkontakt_nn_1 : N ;
  slaeplift_nn_1 : N ;
  slaeplogg_nn_1 : N ;
  slaepnot_nn_1 : N ;
  slaepp_nn_1 : N ;
  slaepphaent_av_1 : A ;
  slaepring_nn_1 : N ;
  slaepsam_av_1 : A ;
  slaepsko_nn_1 : N ;
  slaepvad_nn_1 : N ;
  slaepvagn_nn_1 : N ;
  slaet_av_1 : A ;
  slaetfog_nn_1 : N ;
  slaethaarig_av_1 : A ;
  slaetharv_nn_1 : N ;
  slaetprick_nn_1 : N ;
  slaetstruken_av_1 : A ;
  slaetsvamp_nn_1 : N ;
  slaett_nn_1 : N ;
  slaettbygd_nn_1 : N ;
  slaettmark_nn_1 : N ;
  slaetvar_nn_1 : N ;
  slaf_nn_1 : N ;
  slafs_nn_1 : N ;
  slafsig_av_1 : A ;
  slag_nn_1 : N ;
  slaganfall_nn_1 : N ;
  slagbjoern_nn_1 : N ;
  slagbom_nn_1 : N ;
  slagbord_nn_1 : N ;
  slagborr_nn_1 : N ;
  slagfaelt_nn_1 : N ;
  slagfaerdig_av_1 : A ;
  slagg_nn_1 : N ;
  slaggig_av_1 : A ;
  slaggmaengd_nn_1 : N ;
  slaghoek_nn_1 : N ;
  slaginstrument_nn_1 : N ;
  slagkraftig_av_1 : A ;
  slaglaengd_nn_1 : N ;
  slagmask_nn_1 : N ;
  slagnummer_nn_1 : N ;
  slagord_nn_1 : N ;
  slagordning_nn_1 : N ;
  slagpaase_nn_1 : N ;
  slagregn_nn_1 : N ;
  slagroerd_av_1 : A ;
  slags_av_1 : A ;
  slagseghet_nn_1 : N ;
  slagskaempe_nn_1 : N ;
  slagskepp_nn_1 : N ;
  slagsmaal_nn_1 : N ;
  slagsvaerd_nn_1 : N ;
  slagtaalig_av_1 : A ;
  slagtrae_nn_1 : N ;
  slagvaexling_nn_1 : N ;
  slagvapen_nn_1 : N ;
  slagverk_nn_1 : N ;
  slak_av_1 : A ;
  slakt_nn_1 : N ;
  slaktare_nn_1 : N ;
  slaktdjur_nn_1 : N ;
  slakteri_nn_1 : N ;
  slakthus_nn_1 : N ;
  slaktmaanad_nn_1 : N ;
  slaktmask_nn_1 : N ;
  slaktoffer_nn_1 : N ;
  slalomaakare_nn_1 : N ;
  slam_nn_2 : N ;
  slamkrypare_nn_1 : N ;
  slammig_av_1 : A ;
  slampig_av_1 : A ;
  slamsig_av_1 : A ;
  slamsugning_nn_1 : N ;
  slamsugningsbil_nn_1 : N ;
  slang_nn_1 : N ;
  slangbaage_nn_1 : N ;
  slangkoppling_nn_1 : N ;
  slangloes_av_1 : A ;
  slank_av_1 : A ;
  slankig_av_1 : A ;
  slant_nn_1 : N ;
  slantspoe_nn_1 : N ;
  slapp_av_1 : A ;
  slapphaent_av_1 : A ;
  slarver_nn_1 : N ;
  slarvfel_nn_1 : N ;
  slarvig_av_1 : A ;
  slas_nn_1 : N ;
  slase_nn_1 : N ;
  slashas_nn_1 : N ;
  slask_nn_2 : N ;
  slaskig_av_1 : A ;
  slaskspalt_nn_1 : N ;
  slasktratt_nn_1 : N ;
  slaskvatten_nn_1 : N ;
  slatt_nn_1 : N ;
  slattrig_av_1 : A ;
  slav_nn_1 : N ;
  slav_nn_2 : N ;
  slavdrivare_nn_1 : N ;
  slavhus_nn_1 : N ;
  slavinna_nn_1 : N ;
  slavisk_av_1 : A ;
  slavism_nn_1 : N ;
  slavist_nn_1 : N ;
  slavofil_av_1 : A ;
  slavsaendare_nn_1 : N ;
  slavstation_nn_1 : N ;
  slavuppror_nn_1 : N ;
  slejf_nn_1 : N ;
  slejs_nn_1 : N ;
  slem_av_1 : A ;
  slemhinna_nn_1 : N ;
  slemloesande_av_1 : A ;
  slemmig_av_1 : A ;
  slemsaeck_nn_1 : N ;
  slemsvamp_nn_1 : N ;
  slev_nn_1 : N ;
  slibbig_av_1 : A ;
  slice_nn_1 : N ;
  slick_nn_1 : N ;
  slickepinne_nn_1 : N ;
  slickepott_nn_1 : N ;
  slicksten_nn_1 : N ;
  slid_nn_1 : N ;
  sliddrig_av_1 : A ;
  slidhornsdjur_nn_1 : N ;
  slidkniv_nn_1 : N ;
  slidmotor_nn_1 : N ;
  slinder_nn_1 : N ;
  sling_nn_1 : N ;
  slingerbord_nn_1 : N ;
  slingerbult_nn_1 : N ;
  slingerkoel_nn_1 : N ;
  slingerkoj_nn_1 : N ;
  slingerskott_nn_1 : N ;
  slingervaext_nn_1 : N ;
  slingrig_av_1 : A ;
  slinkig_av_1 : A ;
  slinkled_nn_1 : N ;
  slint_ab_1 : Adv ;
  slip_nn_1 : N ;
  sliper_nn_1 : N ;
  sliperi_nn_1 : N ;
  slipmaskin_nn_1 : N ;
  slipmedel_nn_1 : N ;
  slipover_nn_1 : N ;
  slipprig_av_1 : A ;
  slipprighet_nn_1 : N ;
  slipprov_nn_1 : N ;
  slips_nn_1 : N ;
  slipsknut_nn_1 : N ;
  slipsnitt_nn_1 : N ;
  slipsten_nn_1 : N ;
  slirig_av_1 : A ;
  slirskydd_nn_1 : N ;
  sliskig_av_1 : A ;
  slita_vb_1 : V ;
  sliten_av_1 : A ;
  slitig_av_1 : A ;
  slitning_nn_1 : N ;
  slits_nn_1 : N ;
  slitsam_av_1 : A ;
  slitskydd_nn_1 : N ;
  slitstark_av_1 : A ;
  slitvarg_nn_1 : N ;
  sloe_av_1 : A ;
  sloefock_nn_1 : N ;
  sloejd_nn_1 : N ;
  sloejig_av_1 : A ;
  sloejliknande_av_1 : A ;
  sloejmoln_nn_1 : N ;
  sloejskivling_nn_1 : N ;
  sloejstjaert_nn_1 : N ;
  sloer_nn_2 : N ;
  sloesaktig_av_1 : A ;
  sloesande_av_1 : A ;
  sloesare_nn_1 : N ;
  sloesig_av_1 : A ;
  sloesint_av_1 : A ;
  slog_nn_1 : N ;
  slogan_nn_1 : N ;
  slok_nn_1 : N ;
  slokhatt_nn_1 : N ;
  slokig_av_1 : A ;
  slom_nn_1 : N ;
  slopande_nn_1 : N ;
  slott_nn_1 : N ;
  slottsfru_nn_1 : N ;
  slottsherre_nn_1 : N ;
  slottsknekt_nn_1 : N ;
  slottssal_nn_1 : N ;
  slottsstek_nn_1 : N ;
  slottsvin_nn_1 : N ;
  slovak_nn_1 : N ;
  slovakisk_av_1 : A ;
  slovakiska_nn_2 : N ;
  sloven_nn_1 : N ;
  slovensk_av_1 : A ;
  slovenska_nn_2 : N ;
  slow_fox_nn_1 : N ;
  slubb_nn_1 : N ;
  sluddrig_av_1 : A ;
  slug_av_1 : A ;
  slugger_nn_1 : N ;
  slughuvud_nn_1 : N ;
  sluka_vb_1 : V ;
  slump_nn_1 : N ;
  slumpmaessig_av_1 : A ;
  slumptal_nn_1 : N ;
  slumpvis_ab_1 : Adv ;
  slumrande_av_1 : A ;
  slumsyster_nn_1 : N ;
  slungboll_nn_1 : N ;
  slup_nn_1 : N ;
  slurk_nn_1 : N ;
  slusk_nn_1 : N ;
  sluskig_av_1 : A ;
  sluss_nn_1 : N ;
  slusshuvud_nn_1 : N ;
  slussport_nn_1 : N ;
  slut_av_1 : A ;
  slut_nn_1 : N ;
  sluta_vb_3 : V ;
  slutare_nn_1 : N ;
  slutartikel_nn_1 : N ;
  sluten_av_1 : A ;
  slutfall_nn_1 : N ;
  slutfas_nn_1 : N ;
  slutgiltig_av_1 : A ;
  slutklaem_nn_1 : N ;
  slutkoerd_av_1 : A ;
  slutledning_nn_1 : N ;
  slutlig_av_1 : A ;
  slutligen_ab_1 : Adv ;
  slutljud_nn_1 : N ;
  slutloen_nn_1 : N ;
  slutplaedering_nn_1 : N ;
  slutprodukt_nn_1 : N ;
  slutpunkt_nn_1 : N ;
  slutresultat_nn_1 : N ;
  slutrim_nn_1 : N ;
  slutsats_nn_1 : N ;
  slutskede_nn_1 : N ;
  slutskrift_nn_1 : N ;
  slutspel_nn_1 : N ;
  slutspurt_nn_1 : N ;
  slutsteg_nn_1 : N ;
  slutsten_nn_1 : N ;
  sluttning_nn_1 : N ;
  slutvinjett_nn_1 : N ;
  slutvokal_nn_1 : N ;
  sly_nn_1 : N ;
  slyngel_nn_1 : N ;
  slynig_av_1 : A ;
  smaaaktig_av_1 : A ;
  smaaax_nn_1 : N ;
  smaabaatshamn_nn_1 : N ;
  smaabarn_nn_1 : N ;
  smaabarnsbok_nn_1 : N ;
  smaabil_nn_1 : N ;
  smaabildskamera_nn_1 : N ;
  smaablaasig_av_1 : A ;
  smaabladig_av_1 : A ;
  smaablommig_av_1 : A ;
  smaabonde_nn_1 : N ;
  smaaborgare_nn_1 : N ;
  smaaborgerlig_av_1 : A ;
  smaaborgerlighet_nn_1 : N ;
  smaabruk_nn_1 : N ;
  smaabrukare_nn_1 : N ;
  smaadel_nn_1 : N ;
  smaadetalj_nn_1 : N ;
  smaaelak_av_1 : A ;
  smaafaagel_nn_1 : N ;
  smaafoeretag_nn_1 : N ;
  smaafoeretagare_nn_1 : N ;
  smaafranska_nn_1 : N ;
  smaagli_nn_1 : N ;
  smaagnagare_nn_1 : N ;
  smaagrael_nn_1 : N ;
  smaagris_nn_1 : N ;
  smaahandlare_nn_1 : N ;
  smaahus_nn_1 : N ;
  smaahusaegare_nn_1 : N ;
  smaahuslaan_nn_1 : N ;
  smaajordbruk_nn_1 : N ;
  smaajordbrukare_nn_1 : N ;
  smaakryp_nn_1 : N ;
  smaalaendsk_av_1 : A ;
  smaalaendska_nn_2 : N ;
  smaalaenning_nn_1 : N ;
  smaaleende_av_1 : A ;
  smaaleende_nn_1 : N ;
  smaamynt_nn_1 : N ;
  smaaningom_ab_1 : Adv ;
  smaaord_nn_1 : N ;
  smaaorganism_nn_1 : N ;
  smaapaave_nn_1 : N ;
  smaapaket_nn_1 : N ;
  smaapeng_nn_1 : N ;
  smaapipig_av_1 : A ;
  smaaplanet_nn_1 : N ;
  smaarolig_av_1 : A ;
  smaarutig_av_1 : A ;
  smaasak_nn_1 : N ;
  smaasint_av_1 : A ;
  smaaskalig_av_1 : A ;
  smaaskog_nn_1 : N ;
  smaaskrak_nn_1 : N ;
  smaaskuren_av_1 : A ;
  smaasparare_nn_1 : N ;
  smaastad_nn_1 : N ;
  smaasten_nn_1 : N ;
  smaasven_nn_1 : N ;
  smaasyskon_nn_1 : N ;
  smaatt_av_1 : A ;
  smaatteri_nn_1 : N ;
  smaattig_av_1 : A ;
  smaattighet_nn_1 : N ;
  smaatting_nn_1 : N ;
  smaatvaett_nn_1 : N ;
  smaavaext_av_1 : A ;
  smaavarmt_av_1 : A ;
  smaaviktig_av_1 : A ;
  smaavuxen_av_1 : A ;
  smack_nn_1 : N ;
  smackning_nn_1 : N ;
  smaeck_nn_1 : N ;
  smaecker_av_1 : A ;
  smaeckfet_av_1 : A ;
  smaecklaas_nn_1 : N ;
  smaedare_nn_1 : N ;
  smaedebild_nn_1 : N ;
  smaedelse_nn_1 : N ;
  smaedenamn_nn_1 : N ;
  smaedeskrift_nn_1 : N ;
  smaedlig_av_1 : A ;
  smaektande_av_1 : A ;
  smaektande_nn_1 : N ;
  smaelek_nn_1 : N ;
  smaell_nn_1 : N ;
  smaellare_nn_1 : N ;
  smaellglim_nn_1 : N ;
  smaellkaramell_nn_1 : N ;
  smaelta_vb_1 : V ;
  smaeltdegel_nn_1 : N ;
  smaeltentalpitet_nn_1 : N ;
  smaelteri_nn_1 : N ;
  smaeltost_nn_1 : N ;
  smaeltpropp_nn_1 : N ;
  smaeltpunkt_nn_1 : N ;
  smaeltsaekring_nn_1 : N ;
  smaeltskydd_nn_1 : N ;
  smaeltugn_nn_1 : N ;
  smaeltvatten_nn_1 : N ;
  smaeltverk_nn_1 : N ;
  smaergelduk_nn_1 : N ;
  smaert_av_1 : A ;
  smaertfoernimmelse_nn_1 : N ;
  smaertfri_av_1 : A ;
  smaertlindring_nn_1 : N ;
  smaertpunkt_nn_1 : N ;
  smaertsam_av_1 : A ;
  smaertstillande_av_1 : A ;
  smaertupplevelse_nn_1 : N ;
  smak_nn_1 : N ;
  smakaemne_nn_1 : N ;
  smakbit_nn_1 : N ;
  smakdomare_nn_1 : N ;
  smakfraaga_nn_1 : N ;
  smakfull_av_1 : A ;
  smaklig_av_1 : A ;
  smakloek_nn_1 : N ;
  smakloes_av_1 : A ;
  smakloeshet_nn_1 : N ;
  smakproblem_nn_1 : N ;
  smakprov_nn_1 : N ;
  smakraad_nn_1 : N ;
  smaksak_nn_1 : N ;
  smal_av_1 : A ;
  smalaenda_nn_1 : N ;
  smalben_nn_1 : N ;
  smaldjur_nn_1 : N ;
  smalfilm_nn_1 : N ;
  smalspaarig_av_1 : A ;
  smalvaegg_nn_1 : N ;
  smaragd_nn_1 : N ;
  smart_av_1 : A ;
  smash_nn_1 : N ;
  smaskens_av_1 : A ;
  smaskig_av_1 : A ;
  smatt_nn_1 : N ;
  smed_nn_1 : N ;
  smedja_nn_1 : N ;
  smekmaanad_nn_1 : N ;
  smeknamn_nn_1 : N ;
  smekning_nn_1 : N ;
  smekord_nn_1 : N ;
  smeksam_av_1 : A ;
  smet_nn_1 : N ;
  smetig_av_1 : A ;
  smickrande_av_1 : A ;
  smickrare_nn_1 : N ;
  smidare_nn_1 : N ;
  smidbar_av_1 : A ;
  smide_nn_1 : N ;
  smideri_nn_1 : N ;
  smidespust_nn_1 : N ;
  smidig_av_1 : A ;
  smidjebaelte_nn_1 : N ;
  smil_nn_1 : N ;
  smilare_nn_1 : N ;
  smilfink_nn_1 : N ;
  smilgrop_nn_1 : N ;
  smilig_av_1 : A ;
  smilsk_av_1 : A ;
  smink_nn_1 : N ;
  sminkare_nn_1 : N ;
  sminkerska_nn_1 : N ;
  sminkning_nn_1 : N ;
  sminkoer_nn_1 : N ;
  sminkoes_nn_1 : N ;
  smittaemne_nn_1 : N ;
  smittbaerare_nn_1 : N ;
  smitthaerd_nn_1 : N ;
  smittohaerd_nn_1 : N ;
  smittsam_av_1 : A ;
  smockfull_av_1 : A ;
  smoer_nn_1 : N ;
  smoerbakelse_nn_1 : N ;
  smoerberg_nn_1 : N ;
  smoerboll_nn_1 : N ;
  smoerbult_nn_1 : N ;
  smoerdegspastej_nn_1 : N ;
  smoergaas_nn_1 : N ;
  smoergaasbord_nn_1 : N ;
  smoergaasgaffel_nn_1 : N ;
  smoergaaskniv_nn_1 : N ;
  smoergaasnisse_nn_1 : N ;
  smoergaaspaalaegg_nn_1 : N ;
  smoerig_av_1 : A ;
  smoerjanordning_nn_1 : N ;
  smoerjelse_nn_1 : N ;
  smoerjgrop_nn_1 : N ;
  smoerjhaal_nn_1 : N ;
  smoerjhall_nn_1 : N ;
  smoerjig_av_1 : A ;
  smoerjmedel_nn_1 : N ;
  smoerjning_nn_1 : N ;
  smoerkniv_nn_1 : N ;
  smoersopp_nn_1 : N ;
  smoerspade_nn_1 : N ;
  smoersvamp_nn_1 : N ;
  smoertenor_nn_1 : N ;
  smoking_nn_1 : N ;
  smokingklaenning_nn_1 : N ;
  smugglare_nn_1 : N ;
  smuggleri_nn_1 : N ;
  smul_av_1 : A ;
  smulgraat_nn_1 : N ;
  smulig_av_1 : A ;
  smultron_nn_1 : N ;
  smultronstaelle_nn_1 : N ;
  smutsavvisande_av_1 : A ;
  smutsblad_nn_1 : N ;
  smutsgraa_av_1 : A ;
  smutsgris_nn_1 : N ;
  smutsig_av_1 : A ;
  smutspaase_nn_1 : N ;
  smutstitel_nn_1 : N ;
  smutsvatten_nn_1 : N ;
  smutt_nn_1 : N ;
  smycketyp_nn_1 : N ;
  smyg_nn_1 : N ;
  smyga_vb_1 : V ;
  smygaeta_vb_1 : V ;
  smyghaal_nn_1 : N ;
  smygsoem_nn_1 : N ;
  smygvaeg_nn_1 : N ;
  smygvinkel_nn_1 : N ;
  snaal_av_1 : A ;
  snaaljaap_nn_1 : N ;
  snaalmaans_nn_1 : N ;
  snaalvarg_nn_1 : N ;
  snaar_nn_1 : N ;
  snaarig_av_1 : A ;
  snaarskog_nn_1 : N ;
  snabb_av_1 : A ;
  snabbfoerband_nn_1 : N ;
  snabbfoto_nn_1 : N ;
  snabbhet_nn_1 : N ;
  snabbkassa_nn_1 : N ;
  snabbkoep_nn_1 : N ;
  snabbkoepsbutik_nn_1 : N ;
  snabbkoppling_nn_1 : N ;
  snabbkurs_nn_1 : N ;
  snabbloeslig_av_1 : A ;
  snabblunch_nn_1 : N ;
  snabbportraett_nn_1 : N ;
  snabbprotokoll_nn_1 : N ;
  snabbregulator_nn_1 : N ;
  snabbremiss_nn_1 : N ;
  snabbrepris_nn_1 : N ;
  snabbskiss_nn_1 : N ;
  snabbstopp_nn_1 : N ;
  snabbtaag_nn_1 : N ;
  snabbtaenkt_av_1 : A ;
  snabbtelefon_nn_1 : N ;
  snabbuss_nn_1 : N ;
  snabbvaeljare_nn_1 : N ;
  snabbvaexande_av_1 : A ;
  snabel_nn_1 : N ;
  snabelliknande_av_1 : A ;
  snabelsko_nn_1 : N ;
  snackbar_nn_1 : N ;
  snackesalig_av_1 : A ;
  snacksalig_av_1 : A ;
  snaeckart_nn_1 : N ;
  snaeckdjur_nn_1 : N ;
  snaeckhjul_nn_1 : N ;
  snaeckhus_nn_1 : N ;
  snaeckskal_nn_1 : N ;
  snaeckskruv_nn_1 : N ;
  snaeckvaexel_nn_1 : N ;
  snaell_av_1 : A ;
  snaellgaaende_av_1 : A ;
  snaelltaag_nn_1 : N ;
  snaepp_nn_1 : N ;
  snaeppfaagel_nn_1 : N ;
  snaepplock_nn_1 : N ;
  snaerj_nn_2 : N ;
  snaerjig_av_1 : A ;
  snaerjvaevnad_nn_1 : N ;
  snaerp_nn_2 : N ;
  snaert_nn_1 : N ;
  snaertig_av_1 : A ;
  snaesig_av_1 : A ;
  snaev_av_1 : A ;
  snapphane_nn_1 : N ;
  snaps_nn_1 : N ;
  snapshot_nn_1 : N ;
  snar_av_1 : A ;
  snarare_ab_1 : Adv ;
  snarast_ab_1 : Adv ;
  snarfaerdig_av_1 : A ;
  snarfager_av_1 : A ;
  snarfyndig_av_1 : A ;
  snarkning_nn_1 : N ;
  snarlig_av_1 : A ;
  snarliga_ab_1 : Adv ;
  snarligen_ab_1 : Adv ;
  snarlik_av_1 : A ;
  snarstucken_av_1 : A ;
  snart_ab_1 : Adv ;
  snartaenkt_av_1 : A ;
  snarvacker_av_1 : A ;
  snasker_nn_1 : N ;
  snaskeri_nn_1 : N ;
  snaskig_av_1 : A ;
  snaskighet_nn_1 : N ;
  snatterand_nn_1 : N ;
  snatteri_nn_1 : N ;
  snattran_ab_1 : Adv ;
  sned_av_1 : A ;
  snedfoerdelning_nn_1 : N ;
  snedgaangen_av_1 : A ;
  snedhiss_nn_1 : N ;
  snedhoernig_av_1 : A ;
  snedig_av_1 : A ;
  snedoegd_av_1 : A ;
  snedparkering_nn_1 : N ;
  snedrekrytering_nn_1 : N ;
  snedsegel_nn_1 : N ;
  snedseglare_nn_1 : N ;
  snedskuren_av_1 : A ;
  snedslaa_nn_1 : N ;
  snedspraang_nn_1 : N ;
  snedsteg_nn_1 : N ;
  snedtaendning_nn_1 : N ;
  snedtak_nn_1 : N ;
  snedvinklig_av_1 : A ;
  snedvrida_vb_1 : V ;
  snedvridning_nn_1 : N ;
  snes_nn_1 : N ;
  snibb_nn_1 : N ;
  snibbig_av_1 : A ;
  snibbskaal_nn_1 : N ;
  snickarbaenk_nn_1 : N ;
  snickare_nn_1 : N ;
  snickeri_nn_1 : N ;
  snidare_nn_1 : N ;
  snideri_nn_1 : N ;
  sniff_nn_1 : N ;
  snigel_nn_1 : N ;
  snigelhus_nn_1 : N ;
  sniken_av_1 : A ;
  snilj_nn_1 : N ;
  snilleblixt_nn_1 : N ;
  snilledrag_nn_1 : N ;
  snillefoster_nn_1 : N ;
  snilleprov_nn_1 : N ;
  snilleverk_nn_1 : N ;
  snillrik_av_1 : A ;
  snip_nn_1 : N ;
  snipig_av_1 : A ;
  snirkel_nn_1 : N ;
  snirklig_av_1 : A ;
  snitsare_nn_1 : N ;
  snitsel_nn_1 : N ;
  snitsig_av_1 : A ;
  snitt_nn_1 : N ;
  snitt_nn_2 : N ;
  snittmaengd_nn_1 : N ;
  snobb_nn_1 : N ;
  snobberi_nn_1 : N ;
  snobbig_av_1 : A ;
  snobbistisk_av_1 : A ;
  snodd_nn_1 : N ;
  snoealg_nn_1 : N ;
  snoebaer_nn_1 : N ;
  snoeblind_av_1 : A ;
  snoeblindhet_nn_1 : N ;
  snoeboll_nn_1 : N ;
  snoebollsbuske_nn_1 : N ;
  snoedjup_nn_1 : N ;
  snoedraekt_nn_1 : N ;
  snoedroppe_nn_1 : N ;
  snoefall_nn_1 : N ;
  snoefattig_av_1 : A ;
  snoefjaell_nn_1 : N ;
  snoegubbe_nn_1 : N ;
  snoehagel_nn_1 : N ;
  snoeig_av_1 : A ;
  snoekanon_nn_1 : N ;
  snoekedja_nn_1 : N ;
  snoeklaedd_av_1 : A ;
  snoekristall_nn_1 : N ;
  snoelandskap_nn_1 : N ;
  snoepare_nn_1 : N ;
  snoepegel_nn_1 : N ;
  snoeping_nn_1 : N ;
  snoeplig_av_1 : A ;
  snoeplog_nn_1 : N ;
  snoeplogning_nn_1 : N ;
  snoerapport_nn_1 : N ;
  snoerik_av_1 : A ;
  snoerliv_nn_1 : N ;
  snoermakare_nn_1 : N ;
  snoermakeri_nn_1 : N ;
  snoerpig_av_1 : A ;
  snoerpvad_nn_1 : N ;
  snoerraet_av_1 : A ;
  snoersko_nn_1 : N ;
  snoervlig_av_1 : A ;
  snoervling_nn_1 : N ;
  snoesko_nn_1 : N ;
  snoeskoter_nn_1 : N ;
  snoeskottare_nn_1 : N ;
  snoeskred_nn_1 : N ;
  snoesparv_nn_1 : N ;
  snoestaket_nn_1 : N ;
  snoestorm_nn_1 : N ;
  snoetaeckt_av_1 : A ;
  snoevinter_nn_1 : N ;
  snoevit_av_1 : A ;
  snofsig_av_1 : A ;
  snok_nn_1 : N ;
  snopen_av_1 : A ;
  snopp_nn_1 : N ;
  snoppare_nn_1 : N ;
  snorgaers_nn_1 : N ;
  snorig_av_1 : A ;
  snork_nn_1 : N ;
  snorkel_nn_1 : N ;
  snorkig_av_1 : A ;
  snorunge_nn_1 : N ;
  snorvalp_nn_1 : N ;
  snubbe_nn_1 : N ;
  snubbeltraad_nn_1 : N ;
  snubblig_av_1 : A ;
  snudd_nn_1 : N ;
  snudig_av_1 : A ;
  snultra_nn_1 : N ;
  snurrevad_nn_1 : N ;
  snurrfaatoelj_nn_1 : N ;
  snurrig_av_1 : A ;
  snus_nn_1 : N ;
  snusbrun_av_1 : A ;
  snusfoernuftig_av_1 : A ;
  snusgubbe_nn_1 : N ;
  snusig_av_1 : A ;
  snusker_nn_1 : N ;
  snuskhummer_nn_1 : N ;
  snuskig_av_1 : A ;
  snuskighet_nn_1 : N ;
  snuskpelle_nn_1 : N ;
  snusmumrik_nn_1 : N ;
  snusnaesduk_nn_1 : N ;
  snustorr_av_1 : A ;
  snut_nn_1 : N ;
  snutfager_av_1 : A ;
  snuthaeck_nn_1 : N ;
  snutt_nn_1 : N ;
  snuvig_av_1 : A ;
  snyft_nn_1 : N ;
  snyftande_av_1 : A ;
  snyftning_nn_1 : N ;
  snyftreportage_nn_1 : N ;
  snyftventil_nn_1 : N ;
  snygg_av_1 : A ;
  snygging_nn_1 : N ;
  snyltare_nn_1 : N ;
  snyltbi_nn_1 : N ;
  snyltgaest_nn_1 : N ;
  snyltvaext_nn_1 : N ;
  snyta_vb_1 : V ;
  snytbagge_nn_1 : N ;
  snyting_nn_1 : N ;
  soare_nn_1 : N ;
  sobel_nn_1 : N ;
  sober_av_1 : A ;
  social_av_1 : A ;
  socialantropolog_nn_1 : N ;
  socialantropologisk_av_1 : A ;
  socialarbetare_nn_1 : N ;
  socialassistent_nn_1 : N ;
  socialavgift_nn_1 : N ;
  socialbidrag_nn_1 : N ;
  socialbyraa_nn_1 : N ;
  socialdemokrat_nn_1 : N ;
  socialdemokratisk_av_1 : A ;
  socialdirektoer_nn_1 : N ;
  socialfall_nn_1 : N ;
  socialfoersaekring_nn_1 : N ;
  socialfoervaltning_nn_1 : N ;
  socialgrupp_nn_1 : N ;
  socialhjaelpstagare_nn_1 : N ;
  socialist_nn_1 : N ;
  socialistisk_av_1 : A ;
  socialitet_nn_1 : N ;
  socialklass_nn_1 : N ;
  sociallaekare_nn_1 : N ;
  socialliberal_av_1 : A ;
  socialliberal_nn_1 : N ;
  socialmedicinare_nn_1 : N ;
  socialnaemnd_nn_1 : N ;
  socialpolitisk_av_1 : A ;
  socialpsykolog_nn_1 : N ;
  socialregister_nn_1 : N ;
  socialreportage_nn_1 : N ;
  socialvetenskap_nn_1 : N ;
  societet_nn_1 : N ;
  societetshus_nn_1 : N ;
  societetslejon_nn_1 : N ;
  socioekonomisk_av_1 : A ;
  sociogram_nn_1 : N ;
  sociolekt_nn_1 : N ;
  sociolog_nn_1 : N ;
  sociologisk_av_1 : A ;
  socionom_nn_1 : N ;
  sociopat_nn_1 : N ;
  sockel_nn_1 : N ;
  socken_nn_1 : N ;
  sockenbud_nn_1 : N ;
  sockendraekt_nn_1 : N ;
  sockenstuga_nn_1 : N ;
  sockerart_nn_1 : N ;
  sockerbagare_nn_1 : N ;
  sockerbageri_nn_1 : N ;
  sockerbetssaft_nn_1 : N ;
  sockerbildning_nn_1 : N ;
  sockerbindning_nn_1 : N ;
  sockerbit_nn_1 : N ;
  sockerbruk_nn_1 : N ;
  sockerfri_av_1 : A ;
  sockerglasyr_nn_1 : N ;
  sockergryn_nn_1 : N ;
  sockerhalt_nn_1 : N ;
  sockerhaltig_av_1 : A ;
  sockerkampanj_nn_1 : N ;
  sockerloenn_nn_1 : N ;
  sockermolekyl_nn_1 : N ;
  sockeroeverdrag_nn_1 : N ;
  sockerpiller_nn_1 : N ;
  sockerraffinaderi_nn_1 : N ;
  sockerrik_av_1 : A ;
  sockerroer_nn_1 : N ;
  sockersjuk_av_1 : A ;
  sockerskaal_nn_1 : N ;
  sockersoet_av_1 : A ;
  sockerstroeare_nn_1 : N ;
  sockertaang_nn_1 : N ;
  sockertillverkning_nn_1 : N ;
  sockertopp_nn_1 : N ;
  sockrig_av_1 : A ;
  sodaglas_nn_1 : N ;
  sodahalt_nn_1 : N ;
  sodahaltig_av_1 : A ;
  sodavatten_nn_1 : N ;
  soeckendag_nn_1 : N ;
  soeder_ab_1 : Adv ;
  soedergoek_nn_1 : N ;
  soederifraan_ab_1 : Adv ;
  soederkis_nn_1 : N ;
  soedermanlaendsk_av_1 : A ;
  soedermanlaenning_nn_1 : N ;
  soederoever_ab_1 : Adv ;
  soederut_ab_1 : Adv ;
  soedra_av_1 : A ;
  soekande_nn_1 : N ;
  soekare_nn_1 : N ;
  soekarljus_nn_1 : N ;
  soekt_av_1 : A ;
  soelig_av_1 : A ;
  soelkorv_nn_1 : N ;
  soem_nn_1 : N ;
  soem_nn_2 : N ;
  soemmare_nn_1 : N ;
  soemmerska_nn_1 : N ;
  soemmersketips_nn_1 : N ;
  soemnad_nn_1 : N ;
  soemndrucken_av_1 : A ;
  soemngaangaraktig_av_1 : A ;
  soemngaangare_nn_1 : N ;
  soemnig_av_1 : A ;
  soemnloes_av_1 : A ;
  soemnmedel_nn_1 : N ;
  soemntung_av_1 : A ;
  soemsmaan_nn_1 : N ;
  soendag_nn_1 : N ;
  soendagsbarn_nn_1 : N ;
  soendagsbokstav_nn_1 : N ;
  soendagsjaegare_nn_1 : N ;
  soendagskvaell_nn_1 : N ;
  soendagsmorgon_nn_1 : N ;
  soendagspappa_nn_1 : N ;
  soender_ab_1 : Adv ;
  soenderdelning_nn_1 : N ;
  soenderfalla_vb_1 : V ;
  soenderriva_vb_1 : V ;
  soenderspraengning_nn_1 : N ;
  soendrig_av_1 : A ;
  soendring_nn_1 : N ;
  soergaardsidyll_nn_1 : N ;
  soerlaendsk_av_1 : A ;
  soerlaenning_nn_1 : N ;
  soermlaendsk_av_1 : A ;
  soermlaenning_nn_1 : N ;
  soet_av_1 : A ;
  soetaktig_av_1 : A ;
  soetmandel_nn_1 : N ;
  soetningsmedel_nn_1 : N ;
  soetnos_nn_1 : N ;
  soetpotatis_nn_1 : N ;
  soetsak_nn_1 : N ;
  soetsliskig_av_1 : A ;
  soetsur_av_1 : A ;
  soetvatten_nn_1 : N ;
  soetvattensforskare_nn_1 : N ;
  soffbord_nn_1 : N ;
  soffgrupp_nn_1 : N ;
  soffit_nn_1 : N ;
  soffliggare_nn_1 : N ;
  sofflock_nn_1 : N ;
  sofism_nn_1 : N ;
  sofist_nn_1 : N ;
  sofisteri_nn_1 : N ;
  sojabiff_nn_1 : N ;
  sokratisk_av_1 : A ;
  sol_nn_1 : N ;
  sol_och_vaarare_nn_1 : N ;
  solaar_nn_1 : N ;
  solaekta_av_1 : A ;
  solaer_av_1 : A ;
  solanin_nn_1 : N ;
  solar_av_1 : A ;
  solarisk_av_1 : A ;
  solarium_nn_1 : N ;
  solavaexel_nn_1 : N ;
  solbad_nn_1 : N ;
  solbaenk_nn_1 : N ;
  solbaergning_nn_1 : N ;
  solbatteri_nn_1 : N ;
  solbelysning_nn_1 : N ;
  solbelyst_av_1 : A ;
  solbestraalning_nn_1 : N ;
  solblekt_av_1 : A ;
  solblind_av_1 : A ;
  solblindhet_nn_1 : N ;
  solbraend_av_1 : A ;
  solcell_nn_1 : N ;
  solcirkel_nn_1 : N ;
  solcykel_nn_1 : N ;
  soldag_nn_1 : N ;
  soldat_nn_1 : N ;
  soldathem_nn_1 : N ;
  soldathop_nn_1 : N ;
  soldatnamn_nn_1 : N ;
  soldatrock_nn_1 : N ;
  soldattorp_nn_1 : N ;
  soldenaer_nn_1 : N ;
  soldnaer_nn_1 : N ;
  soldraekt_nn_1 : N ;
  soldrucken_av_1 : A ;
  soldygn_nn_1 : N ;
  soldyrkare_nn_1 : N ;
  soleksem_nn_1 : N ;
  solenn_av_1 : A ;
  solennitet_nn_1 : N ;
  solfall_nn_1 : N ;
  solfatar_nn_1 : N ;
  solfattig_av_1 : A ;
  solfjaeder_nn_1 : N ;
  solflaeck_nn_1 : N ;
  solflod_nn_1 : N ;
  solfoermoerkelse_nn_1 : N ;
  solgud_nn_1 : N ;
  solgul_av_1 : A ;
  solhatt_nn_1 : N ;
  solhjul_nn_1 : N ;
  solid_av_1 : A ;
  solidarisk_av_1 : A ;
  solidaritet_nn_1 : N ;
  soliditet_nn_1 : N ;
  solig_av_1 : A ;
  solinstraalning_nn_1 : N ;
  solist_nn_1 : N ;
  solistisk_av_1 : A ;
  solitaer_av_1 : A ;
  solitaer_nn_1 : N ;
  solkatt_nn_1 : N ;
  solkig_av_1 : A ;
  solklaenning_nn_1 : N ;
  solklar_av_1 : A ;
  solkraem_nn_1 : N ;
  solliknande_av_1 : A ;
  solljus_nn_1 : N ;
  solmateria_nn_1 : N ;
  solmogen_av_1 : A ;
  solnedgaang_nn_1 : N ;
  solo_av_1 : A ;
  solo_nn_1 : N ;
  solochvaarare_nn_1 : N ;
  soloega_nn_1 : N ;
  solokvist_av_1 : A ;
  sololja_nn_1 : N ;
  solraett_ab_1 : Adv ;
  solreflex_nn_1 : N ;
  solroerelse_nn_1 : N ;
  solsida_nn_1 : N ;
  solskydd_nn_1 : N ;
  solskyddsmedel_nn_1 : N ;
  solsnibb_nn_1 : N ;
  solstekt_av_1 : A ;
  solstol_nn_1 : N ;
  solstraale_nn_1 : N ;
  solstraalning_nn_1 : N ;
  solsystem_nn_1 : N ;
  soltak_nn_1 : N ;
  soltimme_nn_1 : N ;
  soluppgaang_nn_1 : N ;
  solur_nn_1 : N ;
  solution_nn_1 : N ;
  solv_nn_1 : N ;
  solvarg_nn_1 : N ;
  solvarv_nn_1 : N ;
  solvent_av_1 : A ;
  solventil_nn_1 : N ;
  solvkaepp_nn_1 : N ;
  som_ab_1 : Adv ;
  somalier_nn_1 : N ;
  somalisk_av_1 : A ;
  somatiker_nn_1 : N ;
  somatisk_av_1 : A ;
  sombrero_nn_1 : N ;
  sommar_nn_1 : N ;
  sommaradress_nn_1 : N ;
  sommaraktig_av_1 : A ;
  sommarbarn_nn_1 : N ;
  sommarbostad_nn_1 : N ;
  sommardaeck_nn_1 : N ;
  sommardag_nn_1 : N ;
  sommarfaagel_nn_1 : N ;
  sommargaest_nn_1 : N ;
  sommargyllen_nn_1 : N ;
  sommargylling_nn_1 : N ;
  sommarhalvaar_nn_1 : N ;
  sommarhatt_nn_1 : N ;
  sommarhem_nn_1 : N ;
  sommarhus_nn_1 : N ;
  sommarjobb_nn_1 : N ;
  sommarlaeger_nn_1 : N ;
  sommarland_nn_1 : N ;
  sommarlig_av_1 : A ;
  sommarlov_nn_1 : N ;
  sommarmoln_nn_1 : N ;
  sommarnoeje_nn_1 : N ;
  sommarparadis_nn_1 : N ;
  sommarpotatis_nn_1 : N ;
  sommarsemester_nn_1 : N ;
  sommarstuga_nn_1 : N ;
  sommartorp_nn_1 : N ;
  sommarvaeder_nn_1 : N ;
  sommarvilla_nn_1 : N ;
  sommarvind_nn_1 : N ;
  sommarvistelse_nn_1 : N ;
  somnambul_av_1 : A ;
  somnambul_nn_1 : N ;
  somnambulisk_av_1 : A ;
  son_nn_1 : N ;
  sonant_nn_1 : N ;
  sonantisk_av_1 : A ;
  sonat_nn_1 : N ;
  sonatin_nn_1 : N ;
  sond_nn_1 : N ;
  sondotter_nn_1 : N ;
  sonett_nn_1 : N ;
  sonika_ab_1 : Adv ;
  sonisk_av_1 : A ;
  sonlig_av_1 : A ;
  sonnamn_nn_1 : N ;
  sonor_av_1 : A ;
  sonoritet_nn_1 : N ;
  sonson_nn_1 : N ;
  sop_nn_1 : N ;
  sopaakare_nn_1 : N ;
  sopbacke_nn_1 : N ;
  sopbil_nn_1 : N ;
  sopborste_nn_1 : N ;
  sopnedkast_nn_1 : N ;
  sopp_nn_1 : N ;
  soppig_av_1 : A ;
  soppkoek_nn_1 : N ;
  sopprot_nn_1 : N ;
  soppskaal_nn_1 : N ;
  soppslev_nn_1 : N ;
  sopran_nn_1 : N ;
  sopskyffel_nn_1 : N ;
  soptipp_nn_1 : N ;
  sorb_nn_1 : N ;
  sordin_nn_1 : N ;
  sorg_nn_1 : N ;
  sorgband_nn_1 : N ;
  sorgbarn_nn_1 : N ;
  sorgbunden_av_1 : A ;
  sorgdraekt_nn_1 : N ;
  sorgeaar_nn_1 : N ;
  sorgeaemne_nn_1 : N ;
  sorgeakt_nn_1 : N ;
  sorgebarn_nn_1 : N ;
  sorgebud_nn_1 : N ;
  sorgedag_nn_1 : N ;
  sorgesam_av_1 : A ;
  sorgespel_nn_1 : N ;
  sorgfaellig_av_1 : A ;
  sorgfaerg_nn_1 : N ;
  sorgflor_nn_1 : N ;
  sorgfri_av_1 : A ;
  sorgkant_nn_1 : N ;
  sorgklaedd_av_1 : A ;
  sorglig_av_1 : A ;
  sorgloes_av_1 : A ;
  sorglustig_av_1 : A ;
  sorgmantel_nn_1 : N ;
  sorgmodig_av_1 : A ;
  sorgpil_nn_1 : N ;
  sorgsen_av_1 : A ;
  sorgsloeja_nn_1 : N ;
  sorgtyngd_av_1 : A ;
  sork_nn_1 : N ;
  sort_nn_1 : N ;
  sorterare_nn_1 : N ;
  sortering_nn_1 : N ;
  sorti_nn_1 : N ;
  sortiment_nn_1 : N ;
  sorts_av_1 : A ;
  sosse_nn_1 : N ;
  sotare_nn_1 : N ;
  sotarmurre_nn_1 : N ;
  soteld_nn_1 : N ;
  sotig_av_1 : A ;
  sotis_av_1 : A ;
  sotmoln_nn_1 : N ;
  sotpartikel_nn_1 : N ;
  sotskikt_nn_1 : N ;
  sotsvamp_nn_1 : N ;
  sottis_nn_1 : N ;
  soulagemang_nn_1 : N ;
  sound_nn_1 : N ;
  sousafon_nn_1 : N ;
  souschef_nn_1 : N ;
  souterrainvaaning_nn_1 : N ;
  souvenir_nn_1 : N ;
  sovchos_nn_1 : N ;
  sovjet_nn_1 : N ;
  sovjetisk_av_1 : A ;
  sovjetmedborgare_nn_1 : N ;
  sovjetrepublik_nn_1 : N ;
  sovjetrysk_av_1 : A ;
  sovmorgon_nn_1 : N ;
  sovplats_nn_1 : N ;
  sovrum_nn_1 : N ;
  sovsaeck_nn_1 : N ;
  sovsal_nn_1 : N ;
  sovstad_nn_1 : N ;
  sovstaellning_nn_1 : N ;
  sovvagn_nn_1 : N ;
  spaadom_nn_1 : N ;
  spaakvinna_nn_1 : N ;
  spaaman_nn_1 : N ;
  spaan_nn_1 : N ;
  spaanad_nn_1 : N ;
  spaang_nn_1 : N ;
  spaanklaedd_av_1 : A ;
  spaankorg_nn_1 : N ;
  spaant_nn_1 : N ;
  spaar_nn_1 : N ;
  spaaraemne_nn_1 : N ;
  spaarelement_nn_1 : N ;
  spaarhund_nn_1 : N ;
  spaarljus_nn_1 : N ;
  spaarloes_av_1 : A ;
  spaarning_nn_1 : N ;
  spaarvaeg_nn_1 : N ;
  spaarvaegschef_nn_1 : N ;
  spaarvagn_nn_1 : N ;
  spaarvidd_nn_1 : N ;
  spackel_nn_2 : N ;
  spade_nn_1 : N ;
  spader_nn_1 : N ;
  spadtag_nn_1 : N ;
  spaeckhuggare_nn_1 : N ;
  spaed_av_1 : A ;
  spaedbarn_nn_1 : N ;
  spaedgris_nn_1 : N ;
  spaend_av_1 : A ;
  spaenn_nn_1 : N ;
  spaennande_av_1 : A ;
  spaennbuckla_nn_1 : N ;
  spaenning_nn_1 : N ;
  spaenningsdelare_nn_1 : N ;
  spaenningsregulator_nn_1 : N ;
  spaenningssoekare_nn_1 : N ;
  spaennram_nn_1 : N ;
  spaennvidd_nn_1 : N ;
  spaens_nn_1 : N ;
  spaenstig_av_1 : A ;
  spaerr_nn_1 : N ;
  spaerrballong_nn_1 : N ;
  spaerrkonto_nn_1 : N ;
  spaerrlinje_nn_1 : N ;
  spaerrvakt_nn_1 : N ;
  spak_av_1 : A ;
  spak_nn_1 : N ;
  spalje_nn_1 : N ;
  spalt_nn_1 : N ;
  spaltfyllnad_nn_1 : N ;
  spaltkorrektur_nn_1 : N ;
  spanare_nn_1 : N ;
  spaniel_nn_1 : N ;
  spaning_nn_1 : N ;
  spanjolett_nn_1 : N ;
  spanjor_nn_1 : N ;
  spanjorska_nn_1 : N ;
  spann_nn_1 : N ;
  spann_nn_2 : N ;
  spann_nn_3 : N ;
  spansk_av_1 : A ;
  spanskroer_nn_1 : N ;
  spant_nn_1 : N ;
  sparagmit_nn_1 : N ;
  sparare_nn_1 : N ;
  sparbank_nn_1 : N ;
  spargris_nn_1 : N ;
  spark_nn_1 : N ;
  sparkassa_nn_1 : N ;
  sparkcykel_nn_1 : N ;
  sparkdraekt_nn_1 : N ;
  sparkstoetting_nn_1 : N ;
  sparlaan_nn_1 : N ;
  sparlakan_nn_1 : N ;
  sparre_nn_1 : N ;
  sparring_nn_1 : N ;
  sparringpartner_nn_1 : N ;
  sparris_nn_1 : N ;
  sparsam_av_1 : A ;
  sparslant_nn_1 : N ;
  spartakist_nn_1 : N ;
  spartan_nn_1 : N ;
  spartansk_av_1 : A ;
  sparv_nn_1 : N ;
  sparvfink_nn_1 : N ;
  sparvhoek_nn_1 : N ;
  spasm_nn_1 : N ;
  spasmodisk_av_1 : A ;
  spasticitet_nn_1 : N ;
  spastiker_nn_1 : N ;
  spastisk_av_1 : A ;
  spatel_nn_1 : N ;
  spatial_av_1 : A ;
  spatioes_av_1 : A ;
  spatium_nn_1 : N ;
  spattig_av_1 : A ;
  speaker_nn_1 : N ;
  speceriaffaer_nn_1 : N ;
  specerihandlare_nn_1 : N ;
  specerist_nn_1 : N ;
  special_nn_1 : N ;
  specialare_nn_1 : N ;
  specialbegaavning_nn_1 : N ;
  specialdomstol_nn_1 : N ;
  specialist_nn_1 : N ;
  specialitet_nn_1 : N ;
  specialklass_nn_1 : N ;
  speciallaerare_nn_1 : N ;
  specialnummer_nn_1 : N ;
  specialomraade_nn_1 : N ;
  specialstudium_nn_1 : N ;
  specialstyrka_nn_1 : N ;
  specie_nn_1 : N ;
  speciell_av_1 : A ;
  species_nn_1 : N ;
  specifik_av_1 : A ;
  specifikation_nn_1 : N ;
  specimen_nn_1 : N ;
  spedition_nn_1 : N ;
  speditoer_nn_1 : N ;
  spefaagel_nn_1 : N ;
  spefull_av_1 : A ;
  spefylld_av_1 : A ;
  spegel_nn_1 : N ;
  spegelbild_nn_1 : N ;
  spegelfaekteri_nn_1 : N ;
  spegelfaektning_nn_1 : N ;
  spegelglas_nn_1 : N ;
  spegelmonogram_nn_1 : N ;
  spegelreflexkamera_nn_1 : N ;
  spegelteleskop_nn_1 : N ;
  spegelvaend_av_1 : A ;
  spejare_nn_1 : N ;
  spektakel_nn_1 : N ;
  spektakulaer_av_1 : A ;
  spektral_av_1 : A ;
  spektralapparat_nn_1 : N ;
  spektrallinje_nn_1 : N ;
  spektrograf_nn_1 : N ;
  spektroskop_nn_1 : N ;
  spektrum_nn_1 : N ;
  spekulant_nn_1 : N ;
  spekulation_nn_1 : N ;
  spekulativ_av_1 : A ;
  spel_nn_1 : N ;
  spelaar_nn_1 : N ;
  spelarbyte_nn_1 : N ;
  spelare_nn_1 : N ;
  spelautomat_nn_1 : N ;
  spelbar_av_1 : A ;
  spelbord_nn_1 : N ;
  speldrama_nn_1 : N ;
  speleman_nn_1 : N ;
  speleolog_nn_1 : N ;
  spelevink_nn_1 : N ;
  spelfilm_nn_1 : N ;
  spelkort_nn_1 : N ;
  spelman_nn_1 : N ;
  spelmani_nn_1 : N ;
  spelmansstaemma_nn_1 : N ;
  spelmark_nn_1 : N ;
  spelning_nn_1 : N ;
  speloeppning_nn_1 : N ;
  spelomgaang_nn_1 : N ;
  spelplan_nn_1 : N ;
  spelprov_nn_1 : N ;
  spelregel_nn_1 : N ;
  spelsugen_av_1 : A ;
  spelverk_nn_1 : N ;
  spenabarn_nn_1 : N ;
  spene_nn_1 : N ;
  spenordning_nn_1 : N ;
  spens_nn_1 : N ;
  spenslig_av_1 : A ;
  spermabildning_nn_1 : N ;
  spermadonator_nn_1 : N ;
  spermamottagarsaeck_nn_1 : N ;
  spermatofor_nn_1 : N ;
  spermatozo_nn_1 : N ;
  spermatozoid_nn_1 : N ;
  spermie_nn_1 : N ;
  spermiemitokondrie_nn_1 : N ;
  spermiemodercell_nn_1 : N ;
  spetaelsk_av_1 : A ;
  spetig_av_1 : A ;
  spets_nn_1 : N ;
  spetsartikel_nn_1 : N ;
  spetsbaage_nn_1 : N ;
  spetsborgare_nn_1 : N ;
  spetsbov_nn_1 : N ;
  spetsfundig_av_1 : A ;
  spetsfundighet_nn_1 : N ;
  spetsglas_nn_1 : N ;
  spetshund_nn_1 : N ;
  spetsig_av_1 : A ;
  spetsvinklig_av_1 : A ;
  spett_nn_1 : N ;
  spex_nn_1 : N ;
  spexig_av_1 : A ;
  spicken_av_1 : A ;
  spigg_nn_1 : N ;
  spik_ab_1 : Adv ;
  spik_nn_1 : N ;
  spikning_nn_1 : N ;
  spikpiano_nn_1 : N ;
  spikpistol_nn_1 : N ;
  spikrak_av_1 : A ;
  spiksaeker_av_1 : A ;
  spiksko_nn_1 : N ;
  spilkum_nn_1 : N ;
  spillra_nn_1 : N ;
  spillvatten_nn_1 : N ;
  spin_nn_1 : N ;
  spin_off_nn_1 : N ;
  spinal_av_1 : A ;
  spinalanestesi_nn_1 : N ;
  spinalganglie_nn_1 : N ;
  spindel_nn_1 : N ;
  spindelbult_nn_1 : N ;
  spindeldjur_nn_1 : N ;
  spindelnaet_nn_1 : N ;
  spindeltraad_nn_1 : N ;
  spindeltunn_av_1 : A ;
  spindelvaev_nn_1 : N ;
  spinell_nn_1 : N ;
  spinett_nn_1 : N ;
  spinkig_av_1 : A ;
  spinn_nn_1 : N ;
  spinna_vb_1 : V ;
  spinnaker_nn_1 : N ;
  spinnakerbom_nn_1 : N ;
  spinnare_nn_1 : N ;
  spinnarfjaeril_nn_1 : N ;
  spinneri_nn_1 : N ;
  spinnhus_nn_1 : N ;
  spinnkvalster_nn_1 : N ;
  spinnrock_nn_1 : N ;
  spinnrulle_nn_1 : N ;
  spinnspoe_nn_1 : N ;
  spion_nn_1 : N ;
  spioneri_nn_1 : N ;
  spionflygning_nn_1 : N ;
  spionkamera_nn_1 : N ;
  spiral_nn_1 : N ;
  spiralblock_nn_1 : N ;
  spiralbotten_nn_1 : N ;
  spiralfjaeder_nn_1 : N ;
  spiralgalax_nn_1 : N ;
  spirant_nn_1 : N ;
  spirill_nn_1 : N ;
  spiritist_nn_1 : N ;
  spiritualist_nn_1 : N ;
  spiritualitet_nn_1 : N ;
  spirituell_av_1 : A ;
  spirituoes_av_1 : A ;
  spiroket_nn_1 : N ;
  spis_nn_1 : N ;
  spisare_nn_1 : N ;
  spisel_nn_1 : N ;
  spiselhaell_nn_1 : N ;
  spiselkrans_nn_1 : N ;
  spiselkrok_nn_1 : N ;
  spiselvraa_nn_1 : N ;
  spishaell_nn_1 : N ;
  spiskammare_nn_1 : N ;
  spiskrans_nn_1 : N ;
  spiskrok_nn_1 : N ;
  spjaele_nn_1 : N ;
  spjaell_nn_1 : N ;
  spjaellband_nn_1 : N ;
  spjaelsaeng_nn_1 : N ;
  spjaern_ab_1 : Adv ;
  spjut_nn_1 : N ;
  spjutspets_nn_1 : N ;
  spjuver_nn_1 : N ;
  splejk_nn_1 : N ;
  spliss_nn_1 : N ;
  splits_nn_1 : N ;
  splitt_ab_1 : Adv ;
  splitter_ab_1 : Adv ;
  splitter_nn_1 : N ;
  splitterbomb_nn_1 : N ;
  splitterny_av_1 : A ;
  splittrare_nn_1 : N ;
  splittring_nn_1 : N ;
  spoe_nn_1 : N ;
  spoekaktig_av_1 : A ;
  spoekbild_nn_1 : N ;
  spoekdjur_nn_1 : N ;
  spoekelse_nn_1 : N ;
  spoekeri_nn_1 : N ;
  spoekhistoria_nn_1 : N ;
  spoeklik_av_1 : A ;
  spoekpartikel_nn_1 : N ;
  spoekskrivare_nn_1 : N ;
  spoekstad_nn_1 : N ;
  spoersmaal_nn_1 : N ;
  spoestraff_nn_1 : N ;
  spoiler_nn_1 : N ;
  spolarvaetska_nn_1 : N ;
  spole_nn_1 : N ;
  spolformig_av_1 : A ;
  spoling_nn_1 : N ;
  spolmask_nn_1 : N ;
  sponde_nn_1 : N ;
  spondylit_nn_1 : N ;
  sponsor_nn_1 : N ;
  spont_nn_1 : N ;
  spontan_av_1 : A ;
  spontanitet_nn_1 : N ;
  spor_nn_1 : N ;
  sporadisk_av_1 : A ;
  sporangium_nn_1 : N ;
  sporbildande_av_1 : A ;
  spordjur_nn_1 : N ;
  sporkapsel_nn_1 : N ;
  sporre_nn_1 : N ;
  sporsaeck_nn_1 : N ;
  sport_nn_1 : N ;
  sportaffaer_nn_1 : N ;
  sportbil_nn_1 : N ;
  sportdykning_nn_1 : N ;
  sportfaane_nn_1 : N ;
  sportfiskemetod_nn_1 : N ;
  sportflygplan_nn_1 : N ;
  sportgren_nn_1 : N ;
  sportig_av_1 : A ;
  sportklubb_nn_1 : N ;
  sportlov_nn_1 : N ;
  sportmodell_nn_1 : N ;
  sportsida_nn_1 : N ;
  sportslig_av_1 : A ;
  sportsman_nn_1 : N ;
  sportstuga_nn_1 : N ;
  sportvagn_nn_1 : N ;
  sporvaext_nn_1 : N ;
  spotlight_nn_1 : N ;
  spotsk_av_1 : A ;
  spottkoertel_nn_1 : N ;
  spottstrit_nn_1 : N ;
  spottstyver_nn_1 : N ;
  spov_nn_1 : N ;
  spraak_nn_1 : N ;
  spraakanvaendning_nn_1 : N ;
  spraakcentrum_nn_1 : N ;
  spraakdraekt_nn_1 : N ;
  spraakfaerdighet_nn_1 : N ;
  spraakfamilj_nn_1 : N ;
  spraakform_nn_1 : N ;
  spraakforskare_nn_1 : N ;
  spraakgrupp_nn_1 : N ;
  spraakkunnig_av_1 : A ;
  spraaklaboratorium_nn_1 : N ;
  spraaklaera_nn_1 : N ;
  spraaklaerare_nn_1 : N ;
  spraaklig_av_1 : A ;
  spraakljud_nn_1 : N ;
  spraakprov_nn_1 : N ;
  spraakriktig_av_1 : A ;
  spraakriktighet_nn_1 : N ;
  spraakroer_nn_1 : N ;
  spraaksam_av_1 : A ;
  spraakstam_nn_1 : N ;
  spraakstrid_nn_1 : N ;
  spraaktecken_nn_1 : N ;
  spraakteori_nn_1 : N ;
  spraakvaardare_nn_1 : N ;
  spraakvetare_nn_1 : N ;
  spraakvetenskap_nn_1 : N ;
  spraang_nn_1 : N ;
  spraangmarsch_nn_1 : N ;
  spraangsegel_nn_1 : N ;
  spraangvis_ab_1 : Adv ;
  spraecklig_av_1 : A ;
  spraengaemne_nn_1 : N ;
  spraengaemnesmolekyl_nn_1 : N ;
  spraengaemnespatron_nn_1 : N ;
  spraengarbetsplats_nn_1 : N ;
  spraengfylld_av_1 : A ;
  spraenggas_nn_1 : N ;
  spraengkapsel_nn_1 : N ;
  spraengladdning_nn_1 : N ;
  spraenglaerd_av_1 : A ;
  spraengning_nn_1 : N ;
  spraengstoff_nn_1 : N ;
  spraett_nn_1 : N ;
  spraettbaage_nn_1 : N ;
  spraetthoek_nn_1 : N ;
  spraettig_av_1 : A ;
  sprakfaale_nn_1 : N ;
  sprallig_av_1 : A ;
  spratt_nn_1 : N ;
  sprattelgubbe_nn_1 : N ;
  spray_nn_1 : N ;
  sprej_nn_1 : N ;
  spretig_av_1 : A ;
  spri_nn_1 : N ;
  spricka_vb_1 : V ;
  sprickbildning_nn_1 : N ;
  sprickdal_nn_1 : N ;
  sprickfaerdig_av_1 : A ;
  sprickig_av_1 : A ;
  sprida_vb_1 : V ;
  spridare_nn_1 : N ;
  spridd_av_1 : A ;
  spridning_nn_1 : N ;
  spridningslins_nn_1 : N ;
  spridningsmaatt_nn_1 : N ;
  spring_nn_2 : N ;
  springa_vb_1 : V ;
  springare_nn_1 : N ;
  springbock_nn_1 : N ;
  springbrunn_nn_1 : N ;
  springmask_nn_1 : N ;
  springpojke_nn_1 : N ;
  springschas_nn_1 : N ;
  springstilett_nn_1 : N ;
  springvatten_nn_1 : N ;
  springvikarie_nn_1 : N ;
  sprinkler_nn_1 : N ;
  sprinkleranlaeggning_nn_1 : N ;
  sprinklersystem_nn_1 : N ;
  sprint_nn_1 : N ;
  sprinter_nn_1 : N ;
  spritdryck_nn_1 : N ;
  sprithalt_nn_1 : N ;
  sprithaltig_av_1 : A ;
  spritkoek_nn_1 : N ;
  spritraettighet_nn_1 : N ;
  sprits_nn_1 : N ;
  spritspion_nn_1 : N ;
  spritt_ab_1 : Adv ;
  sprittermometer_nn_1 : N ;
  sproed_av_1 : A ;
  sproejs_nn_1 : N ;
  sproet_nn_1 : N ;
  sprund_nn_1 : N ;
  sprut_nn_1 : N ;
  sprutspets_nn_1 : N ;
  sprygel_nn_1 : N ;
  spurt_nn_1 : N ;
  sputnik_nn_1 : N ;
  spyboll_nn_1 : N ;
  spydig_av_1 : A ;
  spydighet_nn_1 : N ;
  spygatt_nn_1 : N ;
  squash_nn_2 : N ;
  squaw_nn_1 : N ;
  srilankes_nn_1 : N ;
  sta_ab_1 : Adv ;
  staaende_av_1 : A ;
  staal_nn_1 : N ;
  staalfjaeder_nn_1 : N ;
  staalframstaellning_nn_1 : N ;
  staallegering_nn_1 : N ;
  staalman_nn_1 : N ;
  staalspik_nn_1 : N ;
  staalstick_nn_1 : N ;
  staaltryck_nn_1 : N ;
  staalverk_nn_1 : N ;
  staalvit_av_1 : A ;
  staand_ab_1 : Adv ;
  staand_nn_1 : N ;
  staand_nn_2 : N ;
  staandaktig_av_1 : A ;
  staandare_nn_1 : N ;
  staandkrage_nn_1 : N ;
  staandkrok_nn_1 : N ;
  staandman_nn_1 : N ;
  staandort_nn_1 : N ;
  staandpunkt_nn_1 : N ;
  staandraett_nn_1 : N ;
  staandsmaessig_av_1 : A ;
  staandsperson_nn_1 : N ;
  staang_nn_1 : N ;
  staanghammare_nn_1 : N ;
  staangjaernshammare_nn_1 : N ;
  staangkorv_nn_1 : N ;
  staangryttare_nn_1 : N ;
  staaplats_nn_1 : N ;
  staathaallare_nn_1 : N ;
  staatlig_av_1 : A ;
  stab_nn_1 : N ;
  stabbe_nn_1 : N ;
  stabbig_av_1 : A ;
  stabbur_nn_1 : N ;
  stabil_av_1 : A ;
  stabilisator_nn_1 : N ;
  stabilitet_nn_1 : N ;
  stabschef_nn_1 : N ;
  stabsofficer_nn_1 : N ;
  stack_nn_1 : N ;
  stackare_nn_1 : N ;
  stackars_av_1 : A ;
  stackato_ab_1 : Adv ;
  stackato_nn_1 : N ;
  stackmoln_nn_1 : N ;
  stad_nn_1 : N ;
  stadga_nn_2 : N ;
  stadig_av_1 : A ;
  stadigvarande_av_1 : A ;
  stadion_nn_1 : N ;
  stadion_nn_2 : N ;
  stadium_nn_1 : N ;
  stadkant_nn_1 : N ;
  stadsarkitekt_nn_1 : N ;
  stadsbibliotek_nn_1 : N ;
  stadsbild_nn_1 : N ;
  stadsbud_nn_1 : N ;
  stadsbuss_nn_1 : N ;
  stadsdel_nn_1 : N ;
  stadsfullmaektig_nn_1 : N ;
  stadshotell_nn_1 : N ;
  stadshus_nn_1 : N ;
  stadsmiljoe_nn_1 : N ;
  stadsmur_nn_1 : N ;
  stadsplan_nn_1 : N ;
  stadsplanering_nn_1 : N ;
  stadsport_nn_1 : N ;
  stadssekreterare_nn_1 : N ;
  stadsstat_nn_1 : N ;
  stadsteater_nn_1 : N ;
  staed_nn_1 : N ;
  staedare_nn_1 : N ;
  staedbolag_nn_1 : N ;
  staederska_nn_1 : N ;
  staedning_nn_1 : N ;
  staedredskap_nn_1 : N ;
  staedse_ab_1 : Adv ;
  staedsel_nn_1 : N ;
  staedskaap_nn_1 : N ;
  staell_nn_1 : N ;
  staelld_av_1 : A ;
  staellfoeretraedande_av_1 : A ;
  staellfoeretraedare_nn_1 : N ;
  staellning_nn_1 : N ;
  staellningskrig_nn_1 : N ;
  staellningssteg_nn_1 : N ;
  staellningstagande_nn_1 : N ;
  staellverk_nn_1 : N ;
  staemband_nn_1 : N ;
  staemgaffel_nn_1 : N ;
  staemjaern_nn_1 : N ;
  staemlaepp_nn_1 : N ;
  staemma_nn_1 : N ;
  staemning_nn_1 : N ;
  staempel_nn_1 : N ;
  staempelavgift_nn_1 : N ;
  staempelur_nn_1 : N ;
  staempling_nn_1 : N ;
  staendchen_nn_1 : N ;
  staendig_av_1 : A ;
  staengel_nn_1 : N ;
  staengning_nn_1 : N ;
  staengsel_nn_1 : N ;
  staenk_nn_1 : N ;
  staenkskaerm_nn_1 : N ;
  staenkskydd_nn_1 : N ;
  staepp_nn_1 : N ;
  staeppantilop_nn_1 : N ;
  staerbhus_nn_1 : N ;
  staerkelserik_av_1 : A ;
  staev_nn_1 : N ;
  staev_nn_2 : N ;
  stafett_nn_1 : N ;
  stafettloepning_nn_1 : N ;
  staffagefigur_nn_1 : N ;
  staffli_nn_1 : N ;
  stafflimaalning_nn_1 : N ;
  stafylokock_nn_1 : N ;
  stag_nn_1 : N ;
  stagg_nn_1 : N ;
  stagnation_nn_1 : N ;
  stagsegel_nn_1 : N ;
  stake_nn_1 : N ;
  staket_nn_1 : N ;
  stalagmit_nn_1 : N ;
  stalaktit_nn_1 : N ;
  stalinist_nn_1 : N ;
  stalinistisk_av_1 : A ;
  stall_nn_1 : N ;
  stall_nn_2 : N ;
  stall_nn_3 : N ;
  stallbacke_nn_1 : N ;
  stallbroder_nn_1 : N ;
  stallknekt_nn_1 : N ;
  stalltips_nn_1 : N ;
  stam_nn_1 : N ;
  stamaktie_nn_1 : N ;
  stamanstaelld_av_1 : A ;
  stambok_nn_1 : N ;
  stambord_nn_1 : N ;
  stamfader_nn_1 : N ;
  stamgaest_nn_1 : N ;
  stamhoevding_nn_1 : N ;
  stamkrigare_nn_1 : N ;
  stamkund_nn_1 : N ;
  stamlinje_nn_1 : N ;
  stamlokus_nn_1 : N ;
  stammare_nn_1 : N ;
  stammoder_nn_1 : N ;
  stamort_nn_1 : N ;
  stamp_nn_1 : N ;
  stampkvarn_nn_1 : N ;
  stamtavla_nn_1 : N ;
  stamton_nn_1 : N ;
  stamtraed_nn_1 : N ;
  stand_in_nn_1 : N ;
  standar_nn_1 : N ;
  standard_nn_1 : N ;
  standardavvikelse_nn_1 : N ;
  standardhoejning_nn_1 : N ;
  standardloesning_nn_1 : N ;
  standardprov_nn_1 : N ;
  standardverk_nn_1 : N ;
  standert_nn_1 : N ;
  stank_nn_1 : N ;
  stannfaagel_nn_1 : N ;
  stanning_nn_1 : N ;
  stannplan_nn_1 : N ;
  stans_nn_1 : N ;
  stans_nn_2 : N ;
  stapel_nn_1 : N ;
  stapelavloepning_nn_1 : N ;
  stapelbaedd_nn_1 : N ;
  stapeldiagram_nn_1 : N ;
  stapelplats_nn_1 : N ;
  stapelstad_nn_1 : N ;
  starbaat_nn_1 : N ;
  stare_nn_1 : N ;
  stark_av_1 : A ;
  starkoel_nn_1 : N ;
  starkstroem_nn_1 : N ;
  starkvara_nn_1 : N ;
  starkvin_nn_1 : N ;
  start_nn_1 : N ;
  startavgift_nn_1 : N ;
  startblock_nn_1 : N ;
  starter_nn_1 : N ;
  startgenerator_nn_1 : N ;
  startgrop_nn_1 : N ;
  startlinje_nn_1 : N ;
  startmotor_nn_1 : N ;
  startnyckel_nn_1 : N ;
  startpistol_nn_1 : N ;
  startpunkt_nn_1 : N ;
  startspjaell_nn_1 : N ;
  startvev_nn_1 : N ;
  stas_nn_1 : N ;
  stat_nn_1 : N ;
  statare_nn_1 : N ;
  station_nn_1 : N ;
  stationaer_av_1 : A ;
  stationsinspektor_nn_1 : N ;
  stationsvagn_nn_1 : N ;
  statisk_av_1 : A ;
  statist_nn_1 : N ;
  statistik_nn_1 : N ;
  statistiker_nn_1 : N ;
  statistisk_av_1 : A ;
  stativ_nn_1 : N ;
  statlig_av_1 : A ;
  stator_nn_1 : N ;
  statsanslag_nn_1 : N ;
  statsbaerande_av_1 : A ;
  statsbegravning_nn_1 : N ;
  statsbesoek_nn_1 : N ;
  statsbidrag_nn_1 : N ;
  statsbildning_nn_1 : N ;
  statsbudget_nn_1 : N ;
  statschef_nn_1 : N ;
  statsdepartement_nn_1 : N ;
  statsfinansiell_av_1 : A ;
  statsfoerfattning_nn_1 : N ;
  statsfru_nn_1 : N ;
  statsgeolog_nn_1 : N ;
  statshemlighet_nn_1 : N ;
  statskupp_nn_1 : N ;
  statsloes_av_1 : A ;
  statsmakt_nn_1 : N ;
  statsman_nn_1 : N ;
  statsminister_nn_1 : N ;
  statsnytta_nn_1 : N ;
  statsoeverhuvud_nn_1 : N ;
  statsraad_nn_1 : N ;
  statsraadsberedning_nn_1 : N ;
  statsrevisor_nn_1 : N ;
  statssekreterare_nn_1 : N ;
  statsskick_nn_1 : N ;
  statsskuld_nn_1 : N ;
  statstjaensteman_nn_1 : N ;
  statsvaelvning_nn_1 : N ;
  statsverksproposition_nn_1 : N ;
  statsvetare_nn_1 : N ;
  statsvetenskap_nn_1 : N ;
  statuarisk_av_1 : A ;
  statur_nn_1 : N ;
  statussymbol_nn_1 : N ;
  statut_nn_1 : N ;
  staty_nn_1 : N ;
  statyett_nn_1 : N ;
  stav_nn_1 : N ;
  stav_nn_2 : N ;
  stavelse_nn_1 : N ;
  stavelsebildande_av_1 : A ;
  stavelseskrift_nn_1 : N ;
  stavhopp_nn_1 : N ;
  stavkyrka_nn_1 : N ;
  stavning_nn_1 : N ;
  stavrim_nn_1 : N ;
  stearinljus_nn_1 : N ;
  steeplechase_nn_1 : N ;
  steg_nn_1 : N ;
  stegbaat_nn_1 : N ;
  stegbil_nn_1 : N ;
  stege_nn_1 : N ;
  stegel_nn_1 : N ;
  steglits_nn_1 : N ;
  stegloes_av_1 : A ;
  stegring_nn_1 : N ;
  stegvis_ab_1 : Adv ;
  stek_nn_1 : N ;
  stek_nn_2 : N ;
  stekburgare_nn_1 : N ;
  stekel_nn_1 : N ;
  stekhet_av_1 : A ;
  stekhus_nn_1 : N ;
  stekspade_nn_1 : N ;
  stekspett_nn_1 : N ;
  stel_av_1 : A ;
  stelbent_av_1 : A ;
  stele_nn_1 : N ;
  stelfrusen_av_1 : A ;
  stelhet_nn_1 : N ;
  stellar_av_1 : A ;
  stellarisk_av_1 : A ;
  sten_nn_1 : N ;
  stenaaldersfynd_nn_1 : N ;
  stenaaldersnivaa_nn_1 : N ;
  stenbaer_nn_1 : N ;
  stenbit_nn_1 : N ;
  stenblock_nn_1 : N ;
  stenbock_nn_1 : N ;
  stenbotten_nn_1 : N ;
  stenbrott_nn_1 : N ;
  stenbumling_nn_1 : N ;
  stencil_nn_1 : N ;
  stendoes_nn_1 : N ;
  stendoev_av_1 : A ;
  stenfot_nn_1 : N ;
  stenfrukt_nn_1 : N ;
  stenget_nn_1 : N ;
  stenhaell_nn_1 : N ;
  stenhallon_nn_1 : N ;
  stenhuggare_nn_1 : N ;
  stenhuggeri_nn_1 : N ;
  stenig_av_1 : A ;
  stenkast_nn_1 : N ;
  stenknaeck_nn_1 : N ;
  stenkol_nn_1 : N ;
  stenkummel_nn_1 : N ;
  stenlaeggning_nn_1 : N ;
  stenlagd_av_1 : A ;
  stenoeken_nn_1 : N ;
  stenograf_nn_1 : N ;
  stenogram_nn_1 : N ;
  stenos_nn_1 : N ;
  stenotop_nn_1 : N ;
  stenparti_nn_1 : N ;
  stenrik_av_1 : A ;
  stensaettare_nn_1 : N ;
  stensaettning_nn_1 : N ;
  stensatt_av_1 : A ;
  stenskott_nn_1 : N ;
  stensopp_nn_1 : N ;
  stentavla_nn_1 : N ;
  stentorsroest_nn_1 : N ;
  stentorsstaemma_nn_1 : N ;
  steradian_nn_1 : N ;
  sterbhus_nn_1 : N ;
  stereoanlaeggning_nn_1 : N ;
  stereobild_nn_1 : N ;
  stereofonisk_av_1 : A ;
  stereoskop_nn_1 : N ;
  stereotyp_av_1 : A ;
  stereotyp_nn_1 : N ;
  stereotypi_nn_1 : N ;
  steril_av_1 : A ;
  sterilisering_nn_1 : N ;
  sterilitet_nn_1 : N ;
  sterin_nn_1 : N ;
  sterisk_av_1 : A ;
  steroid_nn_1 : N ;
  sterol_nn_1 : N ;
  stetoskop_nn_1 : N ;
  steward_nn_1 : N ;
  stewart_nn_1 : N ;
  stick_nn_1 : N ;
  sticka_vb_1 : V ;
  stickel_nn_1 : N ;
  stickelbaer_nn_1 : N ;
  stickelhaarig_av_1 : A ;
  stickert_nn_1 : N ;
  stickig_av_1 : A ;
  stickkontakt_nn_1 : N ;
  stickling_nn_1 : N ;
  stickmaskin_nn_1 : N ;
  stickning_nn_1 : N ;
  stickord_nn_1 : N ;
  stickpropp_nn_1 : N ;
  stickprov_nn_1 : N ;
  stickprovsundersoekning_nn_1 : N ;
  stickreplik_nn_1 : N ;
  stickspaar_nn_1 : N ;
  stickvapen_nn_1 : N ;
  stift_nn_1 : N ;
  stiftelse_nn_1 : N ;
  stiftsfroeken_nn_1 : N ;
  stiftsjungfru_nn_1 : N ;
  stiftsstad_nn_1 : N ;
  stifttand_nn_1 : N ;
  stig_nn_1 : N ;
  stiga_vb_1 : V ;
  stigarcentral_nn_1 : N ;
  stigarledning_nn_1 : N ;
  stigbygel_nn_1 : N ;
  stigfinnare_nn_1 : N ;
  stiglaeder_nn_1 : N ;
  stigloes_av_1 : A ;
  stigma_nn_1 : N ;
  stigman_nn_1 : N ;
  stigning_nn_1 : N ;
  stigort_nn_1 : N ;
  stikisk_av_1 : A ;
  stil_nn_1 : N ;
  stilart_nn_1 : N ;
  stilbildande_av_1 : A ;
  stilbildare_nn_1 : N ;
  stilbrytning_nn_1 : N ;
  stildrag_nn_1 : N ;
  stilenlig_av_1 : A ;
  stilett_nn_1 : N ;
  stilettkaepp_nn_1 : N ;
  stilfigur_nn_1 : N ;
  stilfull_av_1 : A ;
  stilig_av_1 : A ;
  stilisering_nn_1 : N ;
  stilist_nn_1 : N ;
  stilistiker_nn_1 : N ;
  stilistisk_av_1 : A ;
  still_ab_1 : Adv ;
  stilla_ab_1 : Adv ;
  stilla_av_1 : A ;
  stillasittande_av_1 : A ;
  stillastaaende_av_1 : A ;
  stillatigande_av_1 : A ;
  stillbild_nn_1 : N ;
  stilldrink_nn_1 : N ;
  stilleben_nn_1 : N ;
  stillestaand_nn_1 : N ;
  stillfilm_nn_1 : N ;
  stillhet_nn_1 : N ;
  stillsam_av_1 : A ;
  stillt_av_1 : A ;
  stilmoebel_nn_1 : N ;
  stilren_av_1 : A ;
  stilriktning_nn_1 : N ;
  stilsort_nn_1 : N ;
  stilton_nn_1 : N ;
  stim_nn_1 : N ;
  stimmig_av_1 : A ;
  stimulans_nn_1 : N ;
  stimulantia_nn_1 : N ;
  stimulator_nn_1 : N ;
  stimulering_nn_1 : N ;
  stimulus_nn_1 : N ;
  sting_nn_1 : N ;
  stingpinne_nn_1 : N ;
  stingslig_av_1 : A ;
  stinkbomb_nn_1 : N ;
  stinkdjur_nn_1 : N ;
  stinkfly_nn_1 : N ;
  stinksvamp_nn_1 : N ;
  stinn_av_1 : A ;
  stins_nn_1 : N ;
  stint_ab_1 : Adv ;
  stipel_nn_1 : N ;
  stipendiat_nn_1 : N ;
  stipendium_nn_1 : N ;
  stipulation_nn_1 : N ;
  stirlingmotor_nn_1 : N ;
  stirr_nn_1 : N ;
  stirrig_av_1 : A ;
  stjaela_vb_1 : V ;
  stjaelk_nn_1 : N ;
  stjaelkstygn_nn_1 : N ;
  stjaernassociation_nn_1 : N ;
  stjaernbetaeckning_nn_1 : N ;
  stjaernbild_nn_1 : N ;
  stjaerndygn_nn_1 : N ;
  stjaernevalv_nn_1 : N ;
  stjaernfall_nn_1 : N ;
  stjaernfigur_nn_1 : N ;
  stjaernformig_av_1 : A ;
  stjaerngosse_nn_1 : N ;
  stjaerngranne_nn_1 : N ;
  stjaernhimmel_nn_1 : N ;
  stjaernhop_nn_1 : N ;
  stjaernhus_nn_1 : N ;
  stjaernklar_av_1 : A ;
  stjaernkonstellation_nn_1 : N ;
  stjaernkoppling_nn_1 : N ;
  stjaernlik_av_1 : A ;
  stjaernljus_av_1 : A ;
  stjaernljus_nn_1 : N ;
  stjaernmotor_nn_1 : N ;
  stjaernoegd_av_1 : A ;
  stjaernpar_nn_1 : N ;
  stjaernskott_nn_1 : N ;
  stjaernsmaell_nn_1 : N ;
  stjaernsystem_nn_1 : N ;
  stjaerntriplett_nn_1 : N ;
  stjaerntydare_nn_1 : N ;
  stjaernvalv_nn_1 : N ;
  stjaert_nn_1 : N ;
  stjaertfjaeder_nn_1 : N ;
  stjaertgosse_nn_1 : N ;
  stjaertmes_nn_1 : N ;
  sto_nn_1 : N ;
  stock_nn_1 : N ;
  stockankare_nn_1 : N ;
  stockbaat_nn_1 : N ;
  stockeld_nn_1 : N ;
  stockfisk_nn_1 : N ;
  stockholmare_nn_1 : N ;
  stockholmska_nn_2 : N ;
  stockkonservativ_av_1 : A ;
  stockning_nn_1 : N ;
  stod_nn_1 : N ;
  stoed_nn_1 : N ;
  stoeddig_av_1 : A ;
  stoedhjul_nn_1 : N ;
  stoedjecell_nn_1 : N ;
  stoedjepunkt_nn_1 : N ;
  stoedjevaevnad_nn_1 : N ;
  stoedjordbruk_nn_1 : N ;
  stoedomraade_nn_1 : N ;
  stoekig_av_1 : A ;
  stoeld_nn_1 : N ;
  stoeldsaeker_av_1 : A ;
  stoen_nn_1 : N ;
  stoenande_nn_1 : N ;
  stoepplare_nn_1 : N ;
  stoer_nn_1 : N ;
  stoeratom_nn_1 : N ;
  stoerning_nn_1 : N ;
  stoert_ab_1 : Adv ;
  stoertflod_nn_1 : N ;
  stoerthjaelm_nn_1 : N ;
  stoertkaer_av_1 : A ;
  stoertlopp_nn_1 : N ;
  stoet_nn_1 : N ;
  stoetdaempare_nn_1 : N ;
  stoetesten_nn_1 : N ;
  stoetfaangare_nn_1 : N ;
  stoetsida_nn_1 : N ;
  stoetskydd_nn_1 : N ;
  stoett_av_1 : A ;
  stoettepelare_nn_1 : N ;
  stoetvis_ab_1 : Adv ;
  stoetvis_av_1 : A ;
  stoevare_nn_1 : N ;
  stoevel_nn_1 : N ;
  stoevelknekt_nn_1 : N ;
  stoevlett_nn_1 : N ;
  stoff_nn_1 : N ;
  stofil_nn_1 : N ;
  stoft_nn_1 : N ;
  stoftkorn_nn_1 : N ;
  stoftmaengd_nn_1 : N ;
  stoftmoln_nn_1 : N ;
  stoftpartikel_nn_1 : N ;
  stoiker_nn_1 : N ;
  stoisk_av_1 : A ;
  stojig_av_1 : A ;
  stokastisk_av_1 : A ;
  stol_nn_1 : N ;
  stolgaang_nn_1 : N ;
  stoll_nn_1 : N ;
  stolle_nn_1 : N ;
  stolleri_nn_1 : N ;
  stollig_av_1 : A ;
  stolpbod_nn_1 : N ;
  stolpdiagram_nn_1 : N ;
  stolpe_nn_1 : N ;
  stolpiller_nn_1 : N ;
  stolprad_nn_1 : N ;
  stolpsko_nn_1 : N ;
  stolt_av_1 : A ;
  stolthet_nn_1 : N ;
  stolts_av_1 : A ;
  stomatit_nn_1 : N ;
  stomi_nn_1 : N ;
  stomme_nn_1 : N ;
  stomp_nn_1 : N ;
  stop_nn_1 : N ;
  stopp_nn_1 : N ;
  stopp_nn_2 : N ;
  stoppboll_nn_1 : N ;
  stopper_nn_1 : N ;
  stoppljus_nn_1 : N ;
  stoppnaal_nn_1 : N ;
  stoppning_nn_1 : N ;
  stoppris_nn_1 : N ;
  stoppur_nn_1 : N ;
  stor_av_1 : A ;
  storasyster_nn_1 : N ;
  storbaat_nn_1 : N ;
  storband_nn_1 : N ;
  storblommig_av_1 : A ;
  storbonde_nn_1 : N ;
  storbritannisk_av_1 : A ;
  storby_nn_1 : N ;
  storcirkel_nn_1 : N ;
  storcirkelsegling_nn_1 : N ;
  stordaad_nn_1 : N ;
  stordator_nn_1 : N ;
  store_nn_1 : N ;
  storfamilj_nn_1 : N ;
  storfamiljshus_nn_1 : N ;
  storfoeretag_nn_1 : N ;
  storfurste_nn_1 : N ;
  storgodsaegare_nn_1 : N ;
  storhertig_nn_1 : N ;
  storhet_nn_1 : N ;
  storhushaall_nn_1 : N ;
  storindustri_nn_1 : N ;
  stork_nn_1 : N ;
  storkoek_nn_1 : N ;
  storkommun_nn_1 : N ;
  storkors_nn_1 : N ;
  storkrig_nn_1 : N ;
  storlek_nn_1 : N ;
  storleksnummer_nn_1 : N ;
  storleksordning_nn_1 : N ;
  storliga_ab_1 : Adv ;
  storligen_ab_1 : Adv ;
  storm_nn_1 : N ;
  stormaestare_nn_1 : N ;
  stormakt_nn_1 : N ;
  stormaktspolitisk_av_1 : A ;
  storman_nn_1 : N ;
  stormarknad_nn_1 : N ;
  stormast_nn_1 : N ;
  stormbaat_nn_1 : N ;
  stormfaagel_nn_1 : N ;
  stormflod_nn_1 : N ;
  stormhatt_nn_1 : N ;
  stormig_av_1 : A ;
  stormning_nn_1 : N ;
  stormoete_nn_1 : N ;
  stormogul_nn_1 : N ;
  stormufti_nn_1 : N ;
  stormvarning_nn_1 : N ;
  storoegd_av_1 : A ;
  storordig_av_1 : A ;
  storpipig_av_1 : A ;
  storpolitisk_av_1 : A ;
  storrysk_av_1 : A ;
  storsegel_nn_1 : N ;
  storsint_av_1 : A ;
  storsjoeodjur_nn_1 : N ;
  storskalig_av_1 : A ;
  storskog_nn_1 : N ;
  storslagen_av_1 : A ;
  storslam_nn_1 : N ;
  storspov_nn_1 : N ;
  storstad_nn_1 : N ;
  storstaedning_nn_1 : N ;
  storstilt_av_1 : A ;
  storstrejk_nn_1 : N ;
  storstuga_nn_1 : N ;
  storsvensk_av_1 : A ;
  storsvensk_nn_1 : N ;
  stortaa_nn_1 : N ;
  stortopp_nn_1 : N ;
  stortroeja_nn_1 : N ;
  storvaest_nn_1 : N ;
  storvaext_av_1 : A ;
  storverk_nn_1 : N ;
  storvulen_av_1 : A ;
  storvuxen_av_1 : A ;
  story_nn_1 : N ;
  straa_nn_1 : N ;
  straabassjukdom_nn_1 : N ;
  straahatt_nn_1 : N ;
  straak_nn_1 : N ;
  straakdrag_nn_1 : N ;
  straake_nn_1 : N ;
  straakinstrument_nn_1 : N ;
  straakkvartett_nn_1 : N ;
  straalande_av_1 : A ;
  straalbehandling_nn_1 : N ;
  straalben_nn_1 : N ;
  straaldjur_nn_1 : N ;
  straaldos_nn_1 : N ;
  straale_nn_1 : N ;
  straalfenig_av_1 : A ;
  straalgaangsmaetare_nn_1 : N ;
  straalkastare_nn_1 : N ;
  straalkastarljus_nn_1 : N ;
  straalkniv_nn_1 : N ;
  straalkropp_nn_1 : N ;
  straalning_nn_1 : N ;
  straalningsbaelte_nn_1 : N ;
  straalningsdos_nn_1 : N ;
  straalningseffekt_nn_1 : N ;
  straalningsegenskap_nn_1 : N ;
  straalningskommitte_nn_1 : N ;
  straalningskvantum_nn_1 : N ;
  straalningsspektrum_nn_1 : N ;
  straalrisk_nn_1 : N ;
  straalskyddsinstitut_nn_1 : N ;
  straatroevare_nn_1 : N ;
  stradivarius_nn_1 : N ;
  straeck_nn_1 : N ;
  straeckare_nn_1 : N ;
  straeckarmuskel_nn_1 : N ;
  straeckbaenk_nn_1 : N ;
  straeckfoerband_nn_1 : N ;
  straeckning_nn_1 : N ;
  straeng_av_1 : A ;
  straeng_nn_1 : N ;
  straengeligen_ab_1 : Adv ;
  straenginstrument_nn_1 : N ;
  straev_av_1 : A ;
  straevande_nn_1 : N ;
  straevbaage_nn_1 : N ;
  straevhaarig_av_1 : A ;
  straevpelare_nn_1 : N ;
  straevsam_av_1 : A ;
  straff_nn_1 : N ;
  straff_nn_2 : N ;
  straffaange_nn_1 : N ;
  straffbar_av_1 : A ;
  straffdom_nn_1 : N ;
  straffkast_nn_1 : N ;
  strafflag_nn_1 : N ;
  straffoerelaeggande_nn_1 : N ;
  straffomraade_nn_1 : N ;
  straffredskap_nn_1 : N ;
  straffregister_nn_1 : N ;
  straffri_av_1 : A ;
  straight_av_1 : A ;
  strak_av_1 : A ;
  strakbent_av_1 : A ;
  stram_av_1 : A ;
  stramalj_nn_1 : N ;
  strand_nn_1 : N ;
  strandflate_nn_1 : N ;
  strandfynd_nn_1 : N ;
  strandhugg_nn_1 : N ;
  strandkant_nn_1 : N ;
  strandlinje_nn_1 : N ;
  strandmiljoe_nn_1 : N ;
  strandoert_nn_1 : N ;
  strandpipare_nn_1 : N ;
  strandpromenad_nn_1 : N ;
  strandstat_nn_1 : N ;
  strandtomt_nn_1 : N ;
  strandtyp_nn_1 : N ;
  strandvaext_nn_1 : N ;
  strandvall_nn_1 : N ;
  strangulation_nn_1 : N ;
  strapats_nn_1 : N ;
  strateg_nn_1 : N ;
  strategi_nn_1 : N ;
  strategisk_av_1 : A ;
  stratum_nn_1 : N ;
  strax_ab_1 : Adv ;
  streamer_nn_1 : N ;
  streber_nn_1 : N ;
  streck_nn_1 : N ;
  streckgubbe_nn_1 : N ;
  streckkod_nn_1 : N ;
  strejk_nn_1 : N ;
  strejkbrytare_nn_1 : N ;
  strejkvakt_nn_1 : N ;
  streptokock_nn_1 : N ;
  streptomycin_nn_1 : N ;
  stressig_av_1 : A ;
  stretchnylon_nn_1 : N ;
  stretig_av_1 : A ;
  strid_av_1 : A ;
  strid_nn_1 : N ;
  stridbar_av_1 : A ;
  stridig_av_1 : A ;
  stridighet_nn_1 : N ;
  stridsaatgaerd_nn_1 : N ;
  stridsdomare_nn_1 : N ;
  stridsformering_nn_1 : N ;
  stridsfraaga_nn_1 : N ;
  stridsgas_nn_1 : N ;
  stridsgruppering_nn_1 : N ;
  stridshandsken_ab_1 : Adv ;
  stridslysten_av_1 : A ;
  stridsmedel_nn_1 : N ;
  stridsmundering_nn_1 : N ;
  stridsplats_nn_1 : N ;
  stridsrop_nn_1 : N ;
  stridssele_nn_1 : N ;
  stridsskjutning_nn_1 : N ;
  stridsskrift_nn_1 : N ;
  stridsspets_nn_1 : N ;
  stridsstaellning_nn_1 : N ;
  stridstupp_nn_1 : N ;
  stridsuppstaellning_nn_1 : N ;
  stridsvaern_nn_1 : N ;
  stridsvagn_nn_1 : N ;
  stridsvana_nn_1 : N ;
  strigel_nn_1 : N ;
  strike_nn_1 : N ;
  strikt_av_1 : A ;
  stril_nn_1 : N ;
  strimmig_av_1 : A ;
  stringent_av_1 : A ;
  stripig_av_1 : A ;
  strit_nn_1 : N ;
  stroboskop_nn_1 : N ;
  stroboskopi_nn_1 : N ;
  stroeare_nn_1 : N ;
  stroeg_nn_1 : N ;
  stroejobb_nn_1 : N ;
  stroem_av_1 : A ;
  stroem_nn_1 : N ;
  stroemavtagare_nn_1 : N ;
  stroembrytare_nn_1 : N ;
  stroemfoerande_av_1 : A ;
  stroemfoertraengning_nn_1 : N ;
  stroemhopp_nn_1 : N ;
  stroemkantring_nn_1 : N ;
  stroemkrets_nn_1 : N ;
  stroemledande_av_1 : A ;
  stroemledning_nn_1 : N ;
  stroemmaetare_nn_1 : N ;
  stroemming_nn_1 : N ;
  stroemning_nn_1 : N ;
  stroemring_nn_1 : N ;
  stroemstaellare_nn_1 : N ;
  stroemstare_nn_1 : N ;
  stroemstyrka_nn_1 : N ;
  stroemuttag_nn_1 : N ;
  stroemvirvel_nn_1 : N ;
  stroevomraade_nn_1 : N ;
  stroevtaag_nn_1 : N ;
  strof_nn_1 : N ;
  strofisk_av_1 : A ;
  strofpar_nn_1 : N ;
  strong_av_1 : A ;
  strontiumfoerening_nn_1 : N ;
  stropp_nn_1 : N ;
  stroppig_av_1 : A ;
  stross_nn_1 : N ;
  strudel_nn_1 : N ;
  struktur_nn_1 : N ;
  strukturalist_nn_1 : N ;
  strukturarbetsloeshet_nn_1 : N ;
  strukturell_av_1 : A ;
  strukturfoeraendring_nn_1 : N ;
  strukturformel_nn_1 : N ;
  strukturrationalisering_nn_1 : N ;
  strulig_av_1 : A ;
  strumpeband_nn_1 : N ;
  strumpebandsorden_nn_1 : N ;
  strumpfot_nn_1 : N ;
  strumphael_nn_1 : N ;
  struntfin_av_1 : A ;
  struntfoernaem_av_1 : A ;
  struntsumma_nn_1 : N ;
  struntviktig_av_1 : A ;
  strupcancer_nn_1 : N ;
  strupe_nn_1 : N ;
  struphuvud_nn_1 : N ;
  struplock_nn_1 : N ;
  strut_nn_1 : N ;
  struts_nn_1 : N ;
  strutsfjaeder_nn_1 : N ;
  strutsmage_nn_1 : N ;
  strutsplym_nn_1 : N ;
  struttig_av_1 : A ;
  stryka_vb_1 : V ;
  strykare_nn_1 : N ;
  strykbraede_nn_1 : N ;
  strykerska_nn_1 : N ;
  strykfaagel_nn_1 : N ;
  strykfri_av_1 : A ;
  strykjaern_nn_1 : N ;
  strykning_nn_1 : N ;
  strykpojke_nn_1 : N ;
  stryktaalig_av_1 : A ;
  stryktaeck_av_1 : A ;
  stryktvaett_nn_1 : N ;
  strypa_vb_1 : V ;
  strypare_nn_1 : N ;
  strypning_nn_1 : N ;
  stubb_nn_1 : N ;
  stubbe_nn_1 : N ;
  stubbig_av_1 : A ;
  stubin_nn_1 : N ;
  stuck_nn_1 : N ;
  stuckatoer_nn_1 : N ;
  stuckatur_nn_1 : N ;
  stucken_av_1 : A ;
  student_nn_1 : N ;
  studentbetyg_nn_1 : N ;
  studentexamen_nn_1 : N ;
  studenthem_nn_1 : N ;
  studentikos_av_1 : A ;
  studentkaar_nn_1 : N ;
  studentnation_nn_1 : N ;
  studentsaang_nn_1 : N ;
  studentteater_nn_1 : N ;
  studerande_nn_1 : N ;
  studerkammare_nn_1 : N ;
  studie_nn_1 : N ;
  studieaar_nn_1 : N ;
  studiebesoek_nn_1 : N ;
  studiebidrag_nn_1 : N ;
  studiecirkel_nn_1 : N ;
  studiedag_nn_1 : N ;
  studiefoerbund_nn_1 : N ;
  studiegrupp_nn_1 : N ;
  studielaan_nn_1 : N ;
  studiemedel_nn_1 : N ;
  studieobjekt_nn_1 : N ;
  studieorientering_nn_1 : N ;
  studiepenning_nn_1 : N ;
  studierektor_nn_1 : N ;
  studieskuld_nn_1 : N ;
  studietid_nn_1 : N ;
  studievaegledare_nn_1 : N ;
  studio_nn_1 : N ;
  studioman_nn_1 : N ;
  studiomusiker_nn_1 : N ;
  studiosus_nn_1 : N ;
  studium_nn_1 : N ;
  studs_nn_1 : N ;
  studsare_nn_1 : N ;
  stuff_nn_1 : N ;
  stuga_nn_1 : N ;
  stugby_nn_1 : N ;
  stugsittare_nn_1 : N ;
  stum_av_1 : A ;
  stumfilm_nn_1 : N ;
  stump_nn_1 : N ;
  stund_nn_1 : N ;
  stundlig_av_1 : A ;
  stundligen_ab_1 : Adv ;
  stundom_ab_1 : Adv ;
  stundtals_ab_1 : Adv ;
  stuntman_nn_1 : N ;
  stup_nn_1 : N ;
  stupa_vb_1 : V ;
  stupiditet_nn_1 : N ;
  stuproer_nn_1 : N ;
  stuproersmodell_nn_1 : N ;
  stupstock_nn_1 : N ;
  sturig_av_1 : A ;
  stursk_av_1 : A ;
  stuss_nn_1 : N ;
  stut_nn_1 : N ;
  stuteri_nn_1 : N ;
  stuv_nn_1 : N ;
  stuvare_nn_1 : N ;
  stuvbit_nn_1 : N ;
  stuveri_nn_1 : N ;
  stuveriarbetare_nn_1 : N ;
  stuvning_nn_1 : N ;
  styck_nn_1 : N ;
  styckebruk_nn_1 : N ;
  styckevis_ab_1 : Adv ;
  styckjunkare_nn_1 : N ;
  styckmaestare_nn_1 : N ;
  styckningsschema_nn_1 : N ;
  styckvis_ab_1 : Adv ;
  stygg_av_1 : A ;
  styggelse_nn_1 : N ;
  stygger_nn_1 : N ;
  stygging_nn_1 : N ;
  stygn_nn_1 : N ;
  stylit_nn_1 : N ;
  stylobat_nn_1 : N ;
  styltrot_nn_1 : N ;
  stympare_nn_1 : N ;
  styng_nn_1 : N ;
  styrbar_av_1 : A ;
  styrbord_ab_1 : Adv ;
  styrcentrum_nn_1 : N ;
  styrelse_nn_1 : N ;
  styrelseform_nn_1 : N ;
  styrelseledamot_nn_1 : N ;
  styresman_nn_1 : N ;
  styrinraettning_nn_1 : N ;
  styrka_nn_1 : N ;
  styrketaar_nn_1 : N ;
  styrlastighet_nn_1 : N ;
  styrman_nn_1 : N ;
  styrning_nn_1 : N ;
  styrsignal_nn_1 : N ;
  styrstaang_nn_1 : N ;
  styrstav_nn_1 : N ;
  styrsystem_nn_1 : N ;
  styrvaexel_nn_1 : N ;
  styv_av_1 : A ;
  styvbarn_nn_1 : N ;
  styver_nn_1 : N ;
  styvfader_nn_1 : N ;
  styvfoeraelder_nn_1 : N ;
  styvhet_nn_1 : N ;
  styvmoderlig_av_1 : A ;
  styvmor_nn_1 : N ;
  styvmorsviol_nn_1 : N ;
  styvnad_nn_1 : N ;
  styvsint_av_1 : A ;
  styvsyskon_nn_1 : N ;
  subalpin_av_1 : A ;
  subaltern_nn_1 : N ;
  subantarktisk_av_1 : A ;
  subarktisk_av_1 : A ;
  subbig_av_1 : A ;
  subdominant_nn_1 : N ;
  subjekt_nn_1 : N ;
  subjektiv_av_1 : A ;
  subjektivitet_nn_1 : N ;
  subkontinent_nn_1 : N ;
  subkultur_nn_1 : N ;
  subkutan_av_1 : A ;
  sublim_av_1 : A ;
  sublimation_nn_1 : N ;
  subliminal_av_1 : A ;
  submarin_av_1 : A ;
  subrett_nn_1 : N ;
  subsidiaer_av_1 : A ;
  subskribent_nn_1 : N ;
  substans_nn_1 : N ;
  substantiell_av_1 : A ;
  substantiv_nn_1 : N ;
  substitut_nn_1 : N ;
  substitution_nn_1 : N ;
  substrat_nn_1 : N ;
  subtil_av_1 : A ;
  subtilitet_nn_1 : N ;
  subtraktion_nn_1 : N ;
  subtropisk_av_1 : A ;
  subvention_nn_1 : N ;
  subversiv_av_1 : A ;
  succe_nn_1 : N ;
  succees_nn_1 : N ;
  succession_nn_1 : N ;
  successiv_av_1 : A ;
  suck_nn_1 : N ;
  suckande_nn_1 : N ;
  suckulent_av_1 : A ;
  suckulent_nn_1 : N ;
  sudanes_nn_1 : N ;
  sudanesisk_av_1 : A ;
  sudd_nn_1 : N ;
  suddgummi_nn_1 : N ;
  suddig_av_1 : A ;
  suffix_nn_1 : N ;
  suffle_nn_1 : N ;
  sufflett_nn_1 : N ;
  suffloer_nn_1 : N ;
  suffloes_nn_1 : N ;
  suffragett_nn_1 : N ;
  sug_nn_1 : N ;
  suga_vb_1 : V ;
  sugande_av_1 : A ;
  sugen_ab_1 : Adv ;
  sugen_av_1 : A ;
  sugfas_nn_1 : N ;
  suggestibel_av_1 : A ;
  suggestion_nn_1 : N ;
  suggestiv_av_1 : A ;
  sugroer_nn_1 : N ;
  suicidal_av_1 : A ;
  sujett_nn_1 : N ;
  sulfat_nn_1 : N ;
  sulfatfabrik_nn_1 : N ;
  sulfid_nn_1 : N ;
  sulfit_nn_1 : N ;
  sulfitfabrik_nn_1 : N ;
  sulky_nn_1 : N ;
  sultan_nn_1 : N ;
  sultanat_nn_1 : N ;
  sultanrussin_nn_1 : N ;
  sumer_nn_1 : N ;
  sumerer_nn_1 : N ;
  sumerisk_av_1 : A ;
  summa_nn_1 : N ;
  summarisk_av_1 : A ;
  summer_nn_1 : N ;
  summerton_nn_1 : N ;
  sumo_nn_2 : N ;
  sump_nn_2 : N ;
  sumpbaever_nn_1 : N ;
  sumpig_av_1 : A ;
  sumpmark_nn_1 : N ;
  sumpomraade_nn_1 : N ;
  sumpskog_nn_1 : N ;
  sund_av_1 : A ;
  sund_nn_1 : N ;
  sundae_nn_1 : N ;
  sunnit_nn_1 : N ;
  suntaelt_nn_1 : N ;
  sup_nn_1 : N ;
  supa_vb_1 : V ;
  supe_nn_1 : N ;
  superb_av_1 : A ;
  superdator_nn_1 : N ;
  superellips_nn_1 : N ;
  superfoerening_nn_1 : N ;
  supergalaxhop_nn_1 : N ;
  superhop_nn_1 : N ;
  superintendent_nn_1 : N ;
  superkarg_nn_1 : N ;
  superlativ_av_1 : A ;
  superlativ_nn_1 : N ;
  supermakt_nn_1 : N ;
  supernovaexplosion_nn_1 : N ;
  supernovautbrott_nn_1 : N ;
  superposition_nn_1 : N ;
  supersnabb_av_1 : A ;
  supersonisk_av_1 : A ;
  superstark_av_1 : A ;
  supertanker_nn_1 : N ;
  supig_av_1 : A ;
  supinum_nn_1 : N ;
  suppleant_nn_1 : N ;
  supplement_nn_1 : N ;
  supplementaer_av_1 : A ;
  supplementvinkel_nn_1 : N ;
  supplik_nn_1 : N ;
  supplikant_nn_1 : N ;
  support_nn_1 : N ;
  supporter_nn_1 : N ;
  supposition_nn_1 : N ;
  suppositorium_nn_1 : N ;
  supradental_av_1 : A ;
  supradental_nn_1 : N ;
  supramarin_av_1 : A ;
  suput_nn_1 : N ;
  sur_av_1 : A ;
  surapel_nn_1 : N ;
  surbrunn_nn_1 : N ;
  surdeg_nn_1 : N ;
  surfare_nn_1 : N ;
  surfoder_nn_1 : N ;
  surhet_nn_1 : N ;
  surhetsgrad_nn_1 : N ;
  surinames_nn_1 : N ;
  surinamesisk_av_1 : A ;
  surkart_nn_1 : N ;
  surkoersbaer_nn_1 : N ;
  surmulen_av_1 : A ;
  suroegd_av_1 : A ;
  surpris_nn_1 : N ;
  surrealistisk_av_1 : A ;
  surrogat_nn_1 : N ;
  surstek_nn_1 : N ;
  surstroemming_nn_1 : N ;
  susen_ab_1 : Adv ;
  suspekt_av_1 : A ;
  suspension_nn_1 : N ;
  suspensiv_av_1 : A ;
  suspensoar_nn_1 : N ;
  sutan_nn_1 : N ;
  sutare_nn_1 : N ;
  sutenoer_nn_1 : N ;
  suterraengvaaning_nn_1 : N ;
  sutur_nn_1 : N ;
  suvenir_nn_1 : N ;
  suveraen_av_1 : A ;
  suveraen_nn_1 : N ;
  suveraenitet_nn_1 : N ;
  svaager_nn_1 : N ;
  svaal_nn_1 : N ;
  svaangrem_nn_1 : N ;
  svaar_av_1 : A ;
  svaara_ab_1 : Adv ;
  svaarbedoemd_av_1 : A ;
  svaarbegriplig_av_1 : A ;
  svaarfoerklarlig_av_1 : A ;
  svaarframkomlig_av_1 : A ;
  svaarighet_nn_1 : N ;
  svaarlaest_av_1 : A ;
  svaarligen_ab_1 : Adv ;
  svaarloest_av_1 : A ;
  svaarmodig_av_1 : A ;
  svaarpaavisbar_av_1 : A ;
  svaarsaald_av_1 : A ;
  svaarsmaelt_av_1 : A ;
  svaartillgaenglig_av_1 : A ;
  svaarupptaeckt_av_1 : A ;
  svabb_nn_1 : N ;
  svaegerska_nn_1 : N ;
  svaelta_vb_2 : V ;
  svaeltdoed_nn_1 : N ;
  svaeltfoedd_av_1 : A ;
  svaeltkatastrof_nn_1 : N ;
  svaeltkonstnaer_nn_1 : N ;
  svaeltloen_nn_1 : N ;
  svaeng_nn_1 : N ;
  svaengbro_nn_1 : N ;
  svaengd_av_1 : A ;
  svaengdoerr_nn_1 : N ;
  svaengel_nn_1 : N ;
  svaenghjul_nn_1 : N ;
  svaenghjulsmagnet_nn_1 : N ;
  svaengig_av_1 : A ;
  svaengning_nn_1 : N ;
  svaengningskrets_nn_1 : N ;
  svaengningsproblem_nn_1 : N ;
  svaengningstal_nn_1 : N ;
  svaengom_nn_1 : N ;
  svaera_vb_1 : V ;
  svaerd_nn_1 : N ;
  svaerdbaerare_nn_1 : N ;
  svaerdfejare_nn_1 : N ;
  svaerdfisk_nn_1 : N ;
  svaerdlik_av_1 : A ;
  svaerdotter_nn_1 : N ;
  svaerdsfejare_nn_1 : N ;
  svaerdslilja_nn_1 : N ;
  svaerdsloes_av_1 : A ;
  svaerdslukare_nn_1 : N ;
  svaerdsslukare_nn_1 : N ;
  svaerfader_nn_1 : N ;
  svaerfoeraelder_nn_1 : N ;
  svaerja_vb_1 : V ;
  svaerm_nn_1 : N ;
  svaermare_nn_1 : N ;
  svaermeri_nn_1 : N ;
  svaermisk_av_1 : A ;
  svaermor_nn_1 : N ;
  svaermorsdroem_nn_1 : N ;
  svaermorshistoria_nn_1 : N ;
  svaerord_nn_1 : N ;
  svaerson_nn_1 : N ;
  svaevande_av_1 : A ;
  svaevare_nn_1 : N ;
  svaevfarkost_nn_1 : N ;
  svaevning_nn_1 : N ;
  svag_av_1 : A ;
  svaghet_nn_1 : N ;
  svaglysande_av_1 : A ;
  svagpresterande_av_1 : A ;
  svagsint_av_1 : A ;
  svagstroem_nn_1 : N ;
  svagsynt_av_1 : A ;
  svagtonig_av_1 : A ;
  svajig_av_1 : A ;
  svajmast_nn_1 : N ;
  sval_av_1 : A ;
  sval_nn_1 : N ;
  svale_nn_1 : N ;
  svalg_nn_1 : N ;
  svalgaang_nn_1 : N ;
  svalgmandel_nn_1 : N ;
  svall_nn_1 : N ;
  svalliknande_av_1 : A ;
  svamlig_av_1 : A ;
  svamp_nn_1 : N ;
  svampdjur_nn_1 : N ;
  svampig_av_1 : A ;
  svampliknande_av_1 : A ;
  svampmoln_nn_1 : N ;
  svampparasit_nn_1 : N ;
  svampsjukdom_nn_1 : N ;
  svampvaext_nn_1 : N ;
  svan_nn_1 : N ;
  svanhals_nn_1 : N ;
  svanhopp_nn_1 : N ;
  svank_nn_1 : N ;
  svankig_av_1 : A ;
  svankrygg_nn_1 : N ;
  svans_nn_1 : N ;
  svansmotor_nn_1 : N ;
  svanstipp_nn_1 : N ;
  svansviftare_nn_1 : N ;
  svar_nn_1 : N ;
  svarande_nn_1 : N ;
  svaromaal_nn_1 : N ;
  svarskupong_nn_1 : N ;
  svarsloes_av_1 : A ;
  svart_av_1 : A ;
  svartaboershaj_nn_1 : N ;
  svartbroder_nn_1 : N ;
  svartfot_nn_1 : N ;
  svartglaensande_av_1 : A ;
  svarting_nn_1 : N ;
  svartlistning_nn_1 : N ;
  svartlistningsgraens_nn_1 : N ;
  svartmuskig_av_1 : A ;
  svartrock_nn_1 : N ;
  svartsjuk_av_1 : A ;
  svartskalle_nn_1 : N ;
  svartvit_av_1 : A ;
  svarv_nn_1 : N ;
  svarvare_nn_1 : N ;
  svarvstaal_nn_1 : N ;
  svarvstol_nn_1 : N ;
  svavelbakterie_nn_1 : N ;
  svavelbindning_nn_1 : N ;
  svavelfoerening_nn_1 : N ;
  svavelhalt_nn_1 : N ;
  svavelomsaettning_nn_1 : N ;
  svavelosande_av_1 : A ;
  svavelpredikant_nn_1 : N ;
  svavelpulver_nn_1 : N ;
  svavelroek_nn_1 : N ;
  svavelsyrlighet_nn_1 : N ;
  sveamaal_nn_1 : N ;
  svecism_nn_1 : N ;
  sved_nn_1 : N ;
  svedja_nn_1 : N ;
  svedjeland_nn_1 : N ;
  svek_nn_1 : N ;
  svekfull_av_1 : A ;
  sveklig_av_1 : A ;
  svekloes_av_1 : A ;
  svekoman_nn_1 : N ;
  sven_nn_1 : N ;
  svendom_nn_1 : N ;
  svensk_av_1 : A ;
  svensk_nn_1 : N ;
  svenska_nn_2 : N ;
  svenskamerikan_nn_1 : N ;
  svenskbygd_nn_1 : N ;
  svenskfoedd_av_1 : A ;
  svenskhet_nn_1 : N ;
  svenskhetsivrare_nn_1 : N ;
  svenskstoedd_av_1 : A ;
  svep_nn_1 : N ;
  svepande_av_1 : A ;
  svephammare_nn_1 : N ;
  svepning_nn_1 : N ;
  svepskael_nn_1 : N ;
  sverigefinne_nn_1 : N ;
  svets_nn_1 : N ;
  svetsare_nn_1 : N ;
  svetsning_nn_1 : N ;
  svett_av_1 : A ;
  svettband_nn_1 : N ;
  svettig_av_1 : A ;
  svettning_nn_1 : N ;
  svettrem_nn_1 : N ;
  svibel_nn_1 : N ;
  svid_nn_1 : N ;
  svidknott_nn_1 : N ;
  svika_vb_1 : V ;
  svikare_nn_1 : N ;
  sviklig_av_1 : A ;
  svikt_nn_1 : N ;
  svimning_nn_1 : N ;
  svin_nn_1 : N ;
  svinaktig_av_1 : A ;
  svinbesaettning_nn_1 : N ;
  svindlande_av_1 : A ;
  svindlare_nn_1 : N ;
  svindleri_nn_1 : N ;
  svindyr_av_1 : A ;
  svineri_nn_1 : N ;
  svinfett_nn_1 : N ;
  sving_nn_1 : N ;
  svinkall_av_1 : A ;
  svinkoett_nn_1 : N ;
  svinliknande_av_1 : A ;
  svinn_nn_1 : N ;
  svinna_vb_1 : V ;
  svinpaels_nn_1 : N ;
  svinrygg_nn_1 : N ;
  svinstall_nn_1 : N ;
  svinuppfoedning_nn_1 : N ;
  svirvel_nn_1 : N ;
  sviskon_nn_1 : N ;
  svit_nn_1 : N ;
  svivel_nn_1 : N ;
  svordom_nn_1 : N ;
  svullen_av_1 : A ;
  svullnad_nn_1 : N ;
  svulst_nn_1 : N ;
  svulstig_av_1 : A ;
  svulten_av_1 : A ;
  svuren_av_1 : A ;
  swazilaendare_nn_1 : N ;
  swazilaendsk_av_1 : A ;
  sweater_nn_1 : N ;
  sweatshirt_nn_1 : N ;
  sweet_av_1 : A ;
  swimmingpool_nn_1 : N ;
  swingpjatt_nn_1 : N ;
  sybaage_nn_1 : N ;
  sybarit_nn_1 : N ;
  sybaritisk_av_1 : A ;
  sybehoer_nn_1 : N ;
  syd_ab_1 : Adv ;
  sydafrikan_nn_1 : N ;
  sydafrikansk_av_1 : A ;
  sydamerikansk_av_1 : A ;
  sydfrukt_nn_1 : N ;
  sydkorean_nn_1 : N ;
  sydkust_nn_1 : N ;
  sydlaendsk_av_1 : A ;
  sydlaenning_nn_1 : N ;
  sydlig_av_1 : A ;
  sydoest_ab_1 : Adv ;
  sydoestra_av_1 : A ;
  sydost_ab_1 : Adv ;
  sydpol_nn_1 : N ;
  sydstat_nn_1 : N ;
  sydsvensk_av_1 : A ;
  sydvaest_ab_1 : Adv ;
  sydvaest_nn_2 : N ;
  sydvart_ab_1 : Adv ;
  sydyemenit_nn_1 : N ;
  syfilitisk_av_1 : A ;
  syfoerening_nn_1 : N ;
  syfte_nn_1 : N ;
  sykofant_nn_1 : N ;
  sykomor_nn_1 : N ;
  syl_nn_1 : N ;
  sylf_nn_1 : N ;
  sylfid_nn_1 : N ;
  syll_nn_1 : N ;
  syllabisk_av_1 : A ;
  syllogism_nn_1 : N ;
  sylt_nn_1 : N ;
  syltberedning_nn_1 : N ;
  syltloek_nn_1 : N ;
  syltpaeron_nn_1 : N ;
  sylvesterbal_nn_1 : N ;
  symaskin_nn_1 : N ;
  symbol_nn_1 : N ;
  symbolisk_av_1 : A ;
  symbolist_nn_1 : N ;
  symfoni_nn_1 : N ;
  symfoniker_nn_1 : N ;
  symfoniorkester_nn_1 : N ;
  symfonisk_av_1 : A ;
  symfys_nn_1 : N ;
  symmetri_nn_1 : N ;
  symmetriaxel_nn_1 : N ;
  symmetrilinje_nn_1 : N ;
  symmetriplan_nn_1 : N ;
  symmetrisk_av_1 : A ;
  sympatetisk_av_1 : A ;
  sympati_nn_1 : N ;
  sympatisk_av_1 : A ;
  sympatisoer_nn_1 : N ;
  symposium_nn_1 : N ;
  symptom_nn_1 : N ;
  symtom_nn_1 : N ;
  symtomatisk_av_1 : A ;
  syn_nn_1 : N ;
  synaal_nn_1 : N ;
  synaps_nn_1 : N ;
  synapsbassaeng_nn_1 : N ;
  synare_nn_1 : N ;
  synbar_av_1 : A ;
  synbarlig_av_1 : A ;
  synbarligen_ab_1 : Adv ;
  synbild_nn_1 : N ;
  syncell_nn_1 : N ;
  synd_ab_1 : Adv ;
  synd_nn_1 : N ;
  syndabekaennelse_nn_1 : N ;
  syndabock_nn_1 : N ;
  syndafall_nn_1 : N ;
  syndaflod_nn_1 : N ;
  syndapeng_nn_1 : N ;
  syndare_nn_1 : N ;
  syndastraff_nn_1 : N ;
  syndig_av_1 : A ;
  syndikalist_nn_1 : N ;
  syndikat_nn_1 : N ;
  syndrom_nn_1 : N ;
  synestesi_nn_1 : N ;
  synfaelt_nn_1 : N ;
  synfel_nn_1 : N ;
  synfoernimmelse_nn_1 : N ;
  synintryck_nn_1 : N ;
  synk_nn_1 : N ;
  synkop_nn_1 : N ;
  synkopisk_av_1 : A ;
  synkpuls_nn_1 : N ;
  synkron_av_1 : A ;
  synkronisering_nn_1 : N ;
  synkronisk_av_1 : A ;
  synkrotron_nn_1 : N ;
  synlig_av_1 : A ;
  synnerlig_av_1 : A ;
  synnerligen_ab_1 : Adv ;
  synod_nn_1 : N ;
  synodal_av_1 : A ;
  synodisk_av_1 : A ;
  synonym_av_1 : A ;
  synonym_nn_1 : N ;
  synonymi_nn_1 : N ;
  synops_nn_1 : N ;
  synoptiker_nn_1 : N ;
  synoptisk_av_1 : A ;
  synorgan_nn_1 : N ;
  synpunkt_nn_1 : N ;
  synsaett_nn_1 : N ;
  synsjukdom_nn_1 : N ;
  synsk_av_1 : A ;
  synt_nn_1 : N ;
  syntagm_nn_1 : N ;
  syntaktisk_av_1 : A ;
  syntax_nn_1 : N ;
  syntes_nn_1 : N ;
  syntet_nn_1 : N ;
  syntetfiber_nn_1 : N ;
  syntetisk_av_1 : A ;
  syntetmaterial_nn_1 : N ;
  synthesizer_nn_1 : N ;
  synvinkel_nn_1 : N ;
  syo_nn_1 : N ;
  syokonsulent_nn_1 : N ;
  syperb_av_1 : A ;
  syrafast_av_1 : A ;
  syralaeckage_nn_1 : N ;
  syreatom_nn_1 : N ;
  syrefaelt_nn_1 : N ;
  syrefattig_av_1 : A ;
  syrefordrande_av_1 : A ;
  syremolekyl_nn_1 : N ;
  syren_nn_1 : N ;
  syrerik_av_1 : A ;
  syreupptagande_av_1 : A ;
  syrgasmask_nn_1 : N ;
  syrgasmolekyl_nn_1 : N ;
  syrier_nn_1 : N ;
  syrinx_nn_1 : N ;
  syrisk_av_1 : A ;
  syriska_nn_2 : N ;
  syrlig_av_1 : A ;
  syrtut_nn_1 : N ;
  syskon_nn_1 : N ;
  syskonbaedd_nn_1 : N ;
  syskonbarn_nn_1 : N ;
  syskongrupp_nn_1 : N ;
  syskonkaerlek_nn_1 : N ;
  syskonlig_av_1 : A ;
  sysselsaettning_nn_1 : N ;
  sysselsatt_av_1 : A ;
  syssla_nn_1 : N ;
  syssling_nn_1 : N ;
  syssloloes_av_1 : A ;
  syssloman_nn_1 : N ;
  system_nn_1 : N ;
  systematisk_av_1 : A ;
  systembolag_nn_1 : N ;
  systemerare_nn_1 : N ;
  systemkoe_nn_1 : N ;
  systemman_nn_1 : N ;
  syster_nn_1 : N ;
  systerbarn_nn_1 : N ;
  systerdotter_nn_1 : N ;
  systerfartyg_nn_1 : N ;
  systerson_nn_1 : N ;
  systolisk_av_1 : A ;
  sytraad_nn_1 : N ;
  t_shirt_nn_1 : N ;
  ta_vb_1 : V ;
  taa_nn_1 : N ;
  taag_nn_1 : N ;
  taagaangare_nn_1 : N ;
  taagbiljett_nn_1 : N ;
  taagklarerare_nn_1 : N ;
  taagkupe_nn_1 : N ;
  taagordning_nn_1 : N ;
  taagsaett_nn_1 : N ;
  taagtid_nn_1 : N ;
  taahaevning_nn_1 : N ;
  taajaern_nn_1 : N ;
  taalamodsproevande_av_1 : A ;
  taalig_av_1 : A ;
  taalmodig_av_1 : A ;
  taanagel_nn_1 : N ;
  taang_nn_1 : N ;
  taangbad_nn_1 : N ;
  taange_nn_1 : N ;
  taanglake_nn_1 : N ;
  taar_nn_1 : N ;
  taarben_nn_1 : N ;
  taardraenkt_av_1 : A ;
  taardrypande_av_1 : A ;
  taaredal_nn_1 : N ;
  taarkanal_nn_1 : N ;
  taarkoertel_nn_1 : N ;
  taaroegd_av_1 : A ;
  taarpil_nn_1 : N ;
  taarsaeck_nn_1 : N ;
  taartbotten_nn_1 : N ;
  taartspade_nn_1 : N ;
  taaspets_nn_1 : N ;
  taat_nn_1 : N ;
  tabbe_nn_1 : N ;
  tabell_nn_1 : N ;
  tabellarisk_av_1 : A ;
  tabellhuvud_nn_1 : N ;
  tabernakel_nn_1 : N ;
  tablaa_nn_1 : N ;
  tablett_nn_1 : N ;
  tabloid_nn_1 : N ;
  tabu_av_1 : A ;
  tabu_nn_1 : N ;
  tabulator_nn_1 : N ;
  tabulatur_nn_1 : N ;
  tabuord_nn_1 : N ;
  taburett_nn_1 : N ;
  tack_nn_1 : N ;
  tackel_nn_1 : N ;
  tackjaernsblandare_nn_1 : N ;
  tackkort_nn_1 : N ;
  tackling_nn_1 : N ;
  tacknaemlig_av_1 : A ;
  tackoffer_nn_1 : N ;
  tacksaegelse_nn_1 : N ;
  tacksaegelsedag_nn_1 : N ;
  tacksam_av_1 : A ;
  tacksamhet_nn_1 : N ;
  tacktal_nn_1 : N ;
  tadelfri_av_1 : A ;
  taeck_av_1 : A ;
  taeckadress_nn_1 : N ;
  taeckblad_nn_1 : N ;
  taeckdike_nn_1 : N ;
  taeckelig_av_1 : A ;
  taeckelse_nn_1 : N ;
  taeckfaerg_nn_1 : N ;
  taeckfoerband_nn_1 : N ;
  taeckglas_nn_1 : N ;
  taeckhaar_nn_1 : N ;
  taeckmantel_nn_1 : N ;
  taecknamn_nn_1 : N ;
  taeckning_nn_1 : N ;
  taeckningskoep_nn_1 : N ;
  taeckord_nn_1 : N ;
  taeckorganisation_nn_1 : N ;
  taeckt_av_1 : A ;
  taeckvinge_nn_1 : N ;
  taekt_nn_1 : N ;
  taeljare_nn_1 : N ;
  taeljkniv_nn_1 : N ;
  taeljstenskamin_nn_1 : N ;
  taelt_nn_1 : N ;
  taeltare_nn_1 : N ;
  taeltmoete_nn_1 : N ;
  taeltpinne_nn_1 : N ;
  taeltsaeng_nn_1 : N ;
  taeltstol_nn_1 : N ;
  taelttak_nn_1 : N ;
  taemlig_av_1 : A ;
  taemligen_ab_1 : Adv ;
  taendaemne_nn_1 : N ;
  taendare_nn_1 : N ;
  taendhatt_nn_1 : N ;
  taendkulemotor_nn_1 : N ;
  taendmedel_nn_1 : N ;
  taendning_nn_1 : N ;
  taendningslaas_nn_1 : N ;
  taendningsnyckel_nn_1 : N ;
  taendpatron_nn_1 : N ;
  taendroer_nn_1 : N ;
  taendsats_nn_1 : N ;
  taendspole_nn_1 : N ;
  taendsticksask_nn_1 : N ;
  taendsticksmoenster_nn_1 : N ;
  taendsticksproblem_nn_1 : N ;
  taendstift_nn_1 : N ;
  taendvaetska_nn_1 : N ;
  taenjbar_av_1 : A ;
  taenjning_nn_1 : N ;
  taenkare_nn_1 : N ;
  taenkbar_av_1 : A ;
  taenkebok_nn_1 : N ;
  taenkesaett_nn_1 : N ;
  taenkespraak_nn_1 : N ;
  taenkvaerd_av_1 : A ;
  taeppt_av_1 : A ;
  taerande_av_1 : A ;
  taerd_av_1 : A ;
  taerning_nn_1 : N ;
  taerningsbaegare_nn_1 : N ;
  taerningskast_nn_1 : N ;
  taerningsspel_nn_1 : N ;
  taerningsspelare_nn_1 : N ;
  taet_av_1 : A ;
  taet_nn_1 : N ;
  taetataet_nn_1 : N ;
  taethet_nn_1 : N ;
  taethetstopp_nn_1 : N ;
  taethetsvariation_nn_1 : N ;
  taetning_nn_1 : N ;
  taetningslist_nn_1 : N ;
  taetort_nn_1 : N ;
  taetortsbo_nn_1 : N ;
  taetortsnaera_av_1 : A ;
  taetplacering_nn_1 : N ;
  taetplats_nn_1 : N ;
  taettbebyggd_av_1 : A ;
  taetting_nn_1 : N ;
  taettingfaagel_nn_1 : N ;
  taettklippt_av_1 : A ;
  taettsittande_av_1 : A ;
  taettskriven_av_1 : A ;
  taettslutande_av_1 : A ;
  taevling_nn_1 : N ;
  taevlingscyklist_nn_1 : N ;
  taevlingshumoer_nn_1 : N ;
  taevlingsjury_nn_1 : N ;
  taevlingskamp_nn_1 : N ;
  taevlingsklass_nn_1 : N ;
  taevlingsledare_nn_1 : N ;
  taevlingsledning_nn_1 : N ;
  taevlingslek_nn_1 : N ;
  taevlingsmaenniska_nn_1 : N ;
  taevlingspris_nn_1 : N ;
  taevlingssegling_nn_1 : N ;
  tafatt_av_1 : A ;
  taffel_nn_1 : N ;
  taffelberg_nn_1 : N ;
  taffeltaeckare_nn_1 : N ;
  taffelvaag_nn_1 : N ;
  tafflig_av_1 : A ;
  tafs_nn_1 : N ;
  tafsig_av_1 : A ;
  tag_nn_1 : N ;
  tagel_nn_1 : N ;
  tagelmask_nn_1 : N ;
  tagen_av_1 : A ;
  tagetes_nn_1 : N ;
  tagg_nn_1 : N ;
  taggbraeken_nn_1 : N ;
  taggfenig_av_1 : A ;
  taggfening_nn_1 : N ;
  taggfoersedd_av_1 : A ;
  tagghuding_nn_1 : N ;
  taggig_av_1 : A ;
  taggstraale_nn_1 : N ;
  taggsvamp_nn_1 : N ;
  taggtraad_nn_1 : N ;
  tagning_nn_1 : N ;
  taiwanes_nn_1 : N ;
  tajt_av_1 : A ;
  tak_nn_1 : N ;
  takaas_nn_1 : N ;
  takbjaelke_nn_1 : N ;
  takfall_nn_1 : N ;
  takfoenster_nn_1 : N ;
  takfris_nn_1 : N ;
  takgesims_nn_1 : N ;
  takhimmel_nn_1 : N ;
  takhoejd_nn_1 : N ;
  takhuv_nn_1 : N ;
  takistoskop_nn_1 : N ;
  takistoskopi_nn_1 : N ;
  takkam_nn_1 : N ;
  taklaekt_nn_1 : N ;
  taklag_nn_1 : N ;
  taklagsfest_nn_1 : N ;
  taklagsoel_nn_1 : N ;
  taklist_nn_1 : N ;
  taknock_nn_1 : N ;
  takometer_nn_1 : N ;
  takraecke_nn_1 : N ;
  takresning_nn_1 : N ;
  takrygg_nn_1 : N ;
  takryttare_nn_1 : N ;
  takskaegg_nn_1 : N ;
  taksparre_nn_1 : N ;
  takspraang_nn_1 : N ;
  takstol_nn_1 : N ;
  takt_nn_1 : N ;
  taktaeckare_nn_1 : N ;
  taktart_nn_1 : N ;
  taktbeteckning_nn_1 : N ;
  taktdel_nn_1 : N ;
  taktegel_nn_1 : N ;
  taktfast_av_1 : A ;
  taktfull_av_1 : A ;
  taktik_nn_1 : N ;
  taktiker_nn_1 : N ;
  taktil_av_1 : A ;
  taktisk_av_1 : A ;
  taktloes_av_1 : A ;
  taktloeshet_nn_1 : N ;
  taktpinne_nn_1 : N ;
  taktslag_nn_1 : N ;
  taktstreck_nn_1 : N ;
  takvaaning_nn_1 : N ;
  takykardi_nn_1 : N ;
  takymeter_nn_1 : N ;
  tal_nn_1 : N ;
  talakt_nn_1 : N ;
  talande_av_1 : A ;
  talang_nn_1 : N ;
  talangfull_av_1 : A ;
  talangjakt_nn_1 : N ;
  talangscout_nn_1 : N ;
  talapparat_nn_1 : N ;
  talar_nn_1 : N ;
  talare_nn_1 : N ;
  talarstol_nn_1 : N ;
  talbok_nn_1 : N ;
  talcentrum_nn_1 : N ;
  talent_nn_1 : N ;
  talesaett_nn_1 : N ;
  talesman_nn_1 : N ;
  talfel_nn_1 : N ;
  talfoeljd_nn_1 : N ;
  talfoer_av_1 : A ;
  talgdank_nn_1 : N ;
  talgig_av_1 : A ;
  talgkoertel_nn_1 : N ;
  talgoegd_av_1 : A ;
  talgoxe_nn_1 : N ;
  talisman_nn_1 : N ;
  talkig_av_1 : A ;
  talklinik_nn_1 : N ;
  talkoer_nn_1 : N ;
  tall_nn_1 : N ;
  tallbarr_nn_1 : N ;
  tallbit_nn_1 : N ;
  tallbock_nn_1 : N ;
  tallinje_nn_1 : N ;
  tallkottkoertel_nn_1 : N ;
  tallmaetare_nn_1 : N ;
  talloert_nn_1 : N ;
  talloes_av_1 : A ;
  tallrik_nn_1 : N ;
  tallriksharv_nn_1 : N ;
  tallrikshjul_nn_1 : N ;
  tallriksliknande_av_1 : A ;
  tallriksslickare_nn_1 : N ;
  tallriksventil_nn_1 : N ;
  tallskog_nn_1 : N ;
  tallsort_nn_1 : N ;
  tallspinnare_nn_1 : N ;
  tallstekel_nn_1 : N ;
  talman_nn_1 : N ;
  talmanskonferens_nn_1 : N ;
  talong_nn_1 : N ;
  talorgan_nn_1 : N ;
  talpedagog_nn_1 : N ;
  talpjaes_nn_1 : N ;
  talregistreringsapparat_nn_1 : N ;
  talrik_av_1 : A ;
  talroer_nn_1 : N ;
  talroll_nn_1 : N ;
  talrubbning_nn_1 : N ;
  talscen_nn_1 : N ;
  talspraak_nn_1 : N ;
  talspraaklig_av_1 : A ;
  talsvaarighet_nn_1 : N ;
  talsystem_nn_1 : N ;
  taltraengd_av_1 : A ;
  taltrast_nn_1 : N ;
  taltratt_nn_1 : N ;
  tam_av_1 : A ;
  tamarind_nn_1 : N ;
  tamarisk_nn_1 : N ;
  tambur_nn_1 : N ;
  tamburin_nn_1 : N ;
  tamburmajor_nn_1 : N ;
  tambursoem_nn_1 : N ;
  tamburvaktmaestare_nn_1 : N ;
  tamil_nn_1 : N ;
  tamp_nn_1 : N ;
  tampong_nn_1 : N ;
  tamren_nn_1 : N ;
  tamsvin_nn_1 : N ;
  tamul_nn_1 : N ;
  tand_nn_1 : N ;
  tandboeld_nn_1 : N ;
  tandborr_nn_1 : N ;
  tandborrmaskin_nn_1 : N ;
  tandborste_nn_1 : N ;
  tandborstglas_nn_1 : N ;
  tandborstning_nn_1 : N ;
  tandemcykel_nn_1 : N ;
  tandemmaskin_nn_1 : N ;
  tandemspermie_nn_1 : N ;
  tandfistel_nn_1 : N ;
  tandformel_nn_1 : N ;
  tandfyllning_nn_1 : N ;
  tandgarnityr_nn_1 : N ;
  tandgenombrott_nn_1 : N ;
  tandhaevel_nn_1 : N ;
  tandhals_nn_1 : N ;
  tandhjul_nn_1 : N ;
  tandhygienist_nn_1 : N ;
  tandhyvel_nn_1 : N ;
  tandkonstruktion_nn_1 : N ;
  tandkraem_nn_1 : N ;
  tandlaekare_nn_1 : N ;
  tandlaekarpraktik_nn_1 : N ;
  tandlaekarstol_nn_1 : N ;
  tandlagning_nn_1 : N ;
  tandlik_av_1 : A ;
  tandlist_nn_1 : N ;
  tandloes_av_1 : A ;
  tandning_nn_1 : N ;
  tandpetare_nn_1 : N ;
  tandprotes_nn_1 : N ;
  tandrot_nn_1 : N ;
  tandskoeterska_nn_1 : N ;
  tandsnitt_nn_1 : N ;
  tandstaellning_nn_1 : N ;
  tandtekniker_nn_1 : N ;
  tanduppsaettning_nn_1 : N ;
  tandutskott_nn_1 : N ;
  tandvaardsfoersaekring_nn_1 : N ;
  tandvaenlig_av_1 : A ;
  tandval_nn_1 : N ;
  tandvall_nn_1 : N ;
  tangent_nn_1 : N ;
  tangentbord_nn_1 : N ;
  tangentinstrument_nn_1 : N ;
  tangentplan_nn_1 : N ;
  tangerin_nn_1 : N ;
  tangering_nn_1 : N ;
  tangeringspunkt_nn_1 : N ;
  tango_nn_1 : N ;
  tangorabatt_nn_1 : N ;
  tanig_av_1 : A ;
  tank_nn_1 : N ;
  tank_nn_2 : N ;
  tankbil_nn_1 : N ;
  tanke_nn_1 : N ;
  tankebyggnad_nn_1 : N ;
  tankediger_av_1 : A ;
  tankedikt_nn_1 : N ;
  tankeexperiment_nn_1 : N ;
  tankefel_nn_1 : N ;
  tankefoster_nn_1 : N ;
  tankefrihet_nn_1 : N ;
  tankegaang_nn_1 : N ;
  tankelaesare_nn_1 : N ;
  tankelag_nn_1 : N ;
  tankeled_nn_1 : N ;
  tankelek_nn_1 : N ;
  tankemaessig_av_1 : A ;
  tankemetod_nn_1 : N ;
  tankemoeda_nn_1 : N ;
  tanker_nn_1 : N ;
  tankestaellare_nn_1 : N ;
  tanketradition_nn_1 : N ;
  tankeutbyte_nn_1 : N ;
  tankevaeckande_av_1 : A ;
  tankfartyg_nn_1 : N ;
  tankfull_av_1 : A ;
  tankgevaer_nn_1 : N ;
  tankloes_av_1 : A ;
  tankomat_nn_1 : N ;
  tankspridd_av_1 : A ;
  tankstreck_nn_1 : N ;
  tant_nn_1 : N ;
  tantaktig_av_1 : A ;
  tantalikval_nn_1 : N ;
  tantiem_nn_1 : N ;
  tantig_av_1 : A ;
  tanzanier_nn_1 : N ;
  tanzanisk_av_1 : A ;
  taoist_nn_1 : N ;
  tape_nn_1 : N ;
  tapet_nn_1 : N ;
  tapetbaard_nn_1 : N ;
  tapetborste_nn_1 : N ;
  tapetdoerr_nn_1 : N ;
  tapetserare_nn_1 : N ;
  tapetserarstift_nn_1 : N ;
  tapetvaad_nn_1 : N ;
  tapir_nn_1 : N ;
  tapisseri_nn_1 : N ;
  tapisseriaffaer_nn_1 : N ;
  tapisserinaal_nn_1 : N ;
  tapp_nn_1 : N ;
  tappborr_nn_1 : N ;
  tapper_av_1 : A ;
  tapperhet_nn_1 : N ;
  tapperhetsmedalj_nn_1 : N ;
  tapphaal_nn_1 : N ;
  tappkran_nn_1 : N ;
  tapplager_nn_1 : N ;
  tappning_nn_1 : N ;
  tappstation_nn_1 : N ;
  tappt_ab_1 : Adv ;
  tappt_nn_1 : N ;
  tapto_nn_1 : N ;
  tarantel_nn_1 : N ;
  tariff_nn_1 : N ;
  tarm_nn_1 : N ;
  tarmbakterie_nn_1 : N ;
  tarmben_nn_1 : N ;
  tarmfistel_nn_1 : N ;
  tarmfoertraengning_nn_1 : N ;
  tarmgas_nn_1 : N ;
  tarmkaex_nn_1 : N ;
  tarmkanal_nn_1 : N ;
  tarmkatarr_nn_1 : N ;
  tarmroerelse_nn_1 : N ;
  tarmsaft_nn_1 : N ;
  tarmskoeljning_nn_1 : N ;
  tarmsystem_nn_1 : N ;
  tarmvred_nn_1 : N ;
  tars_nn_1 : N ;
  tarsalben_nn_1 : N ;
  tartarbiff_nn_1 : N ;
  tartarsmoergaas_nn_1 : N ;
  tartelett_nn_1 : N ;
  tartrat_nn_1 : N ;
  tarvlig_av_1 : A ;
  task_nn_1 : N ;
  taskig_av_1 : A ;
  taskspelare_nn_1 : N ;
  taskspeleri_nn_1 : N ;
  tass_nn_1 : N ;
  tassemark_nn_1 : N ;
  tassfot_nn_1 : N ;
  tassliknande_av_1 : A ;
  tatar_nn_1 : N ;
  tattare_nn_1 : N ;
  tatuerare_nn_1 : N ;
  tatuering_nn_1 : N ;
  tautologi_nn_1 : N ;
  tavelgalleri_nn_1 : N ;
  tavelsudd_nn_1 : N ;
  tavla_nn_1 : N ;
  tax_free_av_1 : A ;
  tax_nn_1 : N ;
  taxameter_nn_1 : N ;
  taxeomraade_nn_1 : N ;
  taxering_nn_1 : N ;
  taxeringsaar_nn_1 : N ;
  taxeringsassistent_nn_1 : N ;
  taxeringsbevis_nn_1 : N ;
  taxeringsenhet_nn_1 : N ;
  taxeringsintendent_nn_1 : N ;
  taxeringskalender_nn_1 : N ;
  taxeringslaengd_nn_1 : N ;
  taxeringsman_nn_1 : N ;
  taxeringsmyndighet_nn_1 : N ;
  taxeringsnaemnd_nn_1 : N ;
  taxeringsvaerde_nn_1 : N ;
  taxi_nn_1 : N ;
  taxibil_nn_1 : N ;
  taxichauffoer_nn_1 : N ;
  taxistation_nn_1 : N ;
  taxonomi_nn_1 : N ;
  tazett_nn_1 : N ;
  tchadier_nn_1 : N ;
  tchadisk_av_1 : A ;
  te_nn_1 : N ;
  teach_in_nn_1 : N ;
  teaelskande_av_1 : A ;
  teaktraed_nn_1 : N ;
  team_nn_1 : N ;
  teamwork_nn_1 : N ;
  teater_nn_1 : N ;
  teateranmaelan_nn_1 : N ;
  teaterbesoekare_nn_1 : N ;
  teaterchef_nn_1 : N ;
  teaterdebatt_nn_1 : N ;
  teaterdekoration_nn_1 : N ;
  teatereffekt_nn_1 : N ;
  teaterfigur_nn_1 : N ;
  teaterfoerestaellning_nn_1 : N ;
  teatergrupp_nn_1 : N ;
  teaterhabitue_nn_1 : N ;
  teaterkikare_nn_1 : N ;
  teaterliv_nn_1 : N ;
  teaterloge_nn_1 : N ;
  teatermaskineri_nn_1 : N ;
  teatermaskinist_nn_1 : N ;
  teaterpjaes_nn_1 : N ;
  teaterroll_nn_1 : N ;
  teatersaellskap_nn_1 : N ;
  teaterscen_nn_1 : N ;
  teaterviskning_nn_1 : N ;
  teatral_av_1 : A ;
  teatralisk_av_1 : A ;
  teblad_nn_1 : N ;
  tebuske_nn_1 : N ;
  tecken_nn_1 : N ;
  teckenalfabet_nn_1 : N ;
  teckenfoerklaring_nn_1 : N ;
  teckenskaadare_nn_1 : N ;
  teckenspraak_nn_1 : N ;
  teckensystem_nn_1 : N ;
  teckentydare_nn_1 : N ;
  tecknare_nn_1 : N ;
  teckning_nn_1 : N ;
  teckningsbevis_nn_1 : N ;
  teddybjoern_nn_1 : N ;
  tedeum_nn_1 : N ;
  tedrickande_nn_1 : N ;
  tefat_nn_1 : N ;
  teg_nn_1 : N ;
  tegel_nn_1 : N ;
  tegelbruk_nn_1 : N ;
  tegelliknande_av_1 : A ;
  tegelmaestare_nn_1 : N ;
  tegelroed_av_1 : A ;
  tegelslagare_nn_1 : N ;
  tegelsten_nn_1 : N ;
  tegelstensroman_nn_1 : N ;
  tegelugn_nn_1 : N ;
  teglas_nn_1 : N ;
  tehuv_nn_1 : N ;
  tein_nn_1 : N ;
  tejp_nn_1 : N ;
  tejst_nn_1 : N ;
  teknik_nn_1 : N ;
  teknikalitet_nn_1 : N ;
  tekniker_nn_1 : N ;
  tekning_nn_1 : N ;
  teknisk_av_1 : A ;
  teknokrat_nn_1 : N ;
  teknokrati_nn_1 : N ;
  teknolog_nn_1 : N ;
  teknologi_nn_1 : N ;
  teknologie_av_1 : A ;
  teknologisk_av_1 : A ;
  tekoindustri_nn_1 : N ;
  tekopp_nn_1 : N ;
  teleavgift_nn_1 : N ;
  teledata_nn_1 : N ;
  telefoerbindelse_nn_1 : N ;
  telefon_nn_1 : N ;
  telefonabonnent_nn_1 : N ;
  telefonanrop_nn_1 : N ;
  telefonapparat_nn_1 : N ;
  telefonautomat_nn_1 : N ;
  telefonavlyssning_nn_1 : N ;
  telefonhytt_nn_1 : N ;
  telefonist_nn_1 : N ;
  telefonjack_nn_1 : N ;
  telefonkatalog_nn_1 : N ;
  telefonkiosk_nn_1 : N ;
  telefonkoe_nn_1 : N ;
  telefonledes_ab_1 : Adv ;
  telefonledning_nn_1 : N ;
  telefonlur_nn_1 : N ;
  telefonnummer_nn_1 : N ;
  telefonsamtal_nn_1 : N ;
  telefonsignal_nn_1 : N ;
  telefonsladd_nn_1 : N ;
  telefonstation_nn_1 : N ;
  telefonstolpe_nn_1 : N ;
  telefonsvarare_nn_1 : N ;
  telefontraad_nn_1 : N ;
  telefonvaeckning_nn_1 : N ;
  telefonvaektare_nn_1 : N ;
  telefonvaexel_nn_1 : N ;
  telefonvakt_nn_1 : N ;
  telefoto_nn_1 : N ;
  telegraf_nn_1 : N ;
  telegrafisk_av_1 : A ;
  telegrafist_nn_1 : N ;
  telegrafnyckel_nn_1 : N ;
  telegrafstation_nn_1 : N ;
  telegram_nn_1 : N ;
  telegramadress_nn_1 : N ;
  telegrambud_nn_1 : N ;
  telegrambyraa_nn_1 : N ;
  telekommunikation_nn_1 : N ;
  telemeter_nn_1 : N ;
  telenaet_nn_1 : N ;
  teleobjektiv_nn_1 : N ;
  teleologisk_av_1 : A ;
  telepati_nn_1 : N ;
  telepatisk_av_1 : A ;
  teleprinter_nn_1 : N ;
  telesatellit_nn_1 : N ;
  teleskop_nn_1 : N ;
  teleskopisk_av_1 : A ;
  teleskopliknande_av_1 : A ;
  teleskopoega_nn_1 : N ;
  telestation_nn_1 : N ;
  teleteknisk_av_1 : A ;
  televerk_nn_1 : N ;
  televisionskamera_nn_1 : N ;
  telex_nn_2 : N ;
  telfer_nn_1 : N ;
  tellurisk_av_1 : A ;
  tellurium_nn_1 : N ;
  teln_nn_1 : N ;
  telning_nn_1 : N ;
  tema_nn_1 : N ;
  temadag_nn_1 : N ;
  temanummer_nn_1 : N ;
  tematisk_av_1 : A ;
  temp_nn_1 : N ;
  tempel_nn_1 : N ;
  tempelherre_nn_1 : N ;
  tempelherreorden_nn_1 : N ;
  temperament_nn_1 : N ;
  temperamentsfull_av_1 : A ;
  temperamentsutbrott_nn_1 : N ;
  temperatur_nn_1 : N ;
  temperaturfoeraendring_nn_1 : N ;
  temperaturfoerdelning_nn_1 : N ;
  temperaturfoerhaallande_nn_1 : N ;
  temperaturkaenslig_av_1 : A ;
  temperaturomraade_nn_1 : N ;
  temperaturregulator_nn_1 : N ;
  temperatursaenkning_nn_1 : N ;
  temperaturskillnad_nn_1 : N ;
  temperatursvaengning_nn_1 : N ;
  temperaturvaexling_nn_1 : N ;
  tempo_nn_1 : N ;
  tempoarbetare_nn_1 : N ;
  tempobeteckning_nn_1 : N ;
  tempolopp_nn_1 : N ;
  temporaer_av_1 : A ;
  temporal_av_1 : A ;
  tempus_nn_1 : N ;
  tempusvaexling_nn_1 : N ;
  ten_nn_1 : N ;
  tendens_nn_1 : N ;
  tendentioes_av_1 : A ;
  tender_nn_1 : N ;
  tennfolie_nn_1 : N ;
  tennisboll_nn_1 : N ;
  tennisspelare_nn_1 : N ;
  tennsoldat_nn_1 : N ;
  tenor_nn_1 : N ;
  tenorbaryton_nn_1 : N ;
  tenorsaxofon_nn_1 : N ;
  tensid_nn_1 : N ;
  tension_nn_1 : N ;
  tentakel_nn_1 : N ;
  tentamen_nn_1 : N ;
  tentamensbok_nn_1 : N ;
  tentamensnervositet_nn_1 : N ;
  tentand_nn_1 : N ;
  tentator_nn_1 : N ;
  teobromin_nn_1 : N ;
  teocentrisk_av_1 : A ;
  teodolit_nn_1 : N ;
  teofyllin_nn_1 : N ;
  teogoni_nn_1 : N ;
  teokrati_nn_1 : N ;
  teokratisk_av_1 : A ;
  teolog_nn_1 : N ;
  teologie_av_1 : A ;
  teologisk_av_1 : A ;
  teorem_nn_1 : N ;
  teoretiker_nn_1 : N ;
  teoretisk_av_1 : A ;
  teori_nn_1 : N ;
  teosof_nn_1 : N ;
  teosofisk_av_1 : A ;
  tepaase_nn_1 : N ;
  terapeut_nn_1 : N ;
  terapeutisk_av_1 : A ;
  terapi_nn_1 : N ;
  terass_nn_1 : N ;
  terawatt_nn_1 : N ;
  terebint_nn_1 : N ;
  term_nn_1 : N ;
  termin_nn_1 : N ;
  terminal_nn_1 : N ;
  terminolog_nn_1 : N ;
  terminologi_nn_1 : N ;
  terminologisk_av_1 : A ;
  terminsaffaer_nn_1 : N ;
  terminsavgift_nn_1 : N ;
  termisk_av_1 : A ;
  termistor_nn_1 : N ;
  termit_nn_1 : N ;
  termodynamisk_av_1 : A ;
  termoelektricitet_nn_1 : N ;
  termoelement_nn_1 : N ;
  termofil_av_1 : A ;
  termometer_nn_1 : N ;
  termonukleaer_av_1 : A ;
  termoplast_nn_1 : N ;
  termoregulator_nn_1 : N ;
  termos_nn_1 : N ;
  termostapel_nn_1 : N ;
  termostat_nn_1 : N ;
  tern_nn_1 : N ;
  terpen_nn_1 : N ;
  terraeng_nn_1 : N ;
  terraengbil_nn_1 : N ;
  terraengfoerlust_nn_1 : N ;
  terraenggaaende_av_1 : A ;
  terraengkoerning_nn_1 : N ;
  terraengnamn_nn_1 : N ;
  terraengvinkel_nn_1 : N ;
  terraengvinst_nn_1 : N ;
  terrarium_nn_1 : N ;
  terrass_nn_1 : N ;
  terrester_av_1 : A ;
  terrier_nn_1 : N ;
  terrigen_av_1 : A ;
  terrin_nn_1 : N ;
  territorialgraens_nn_1 : N ;
  territorialvatten_nn_1 : N ;
  territoriell_av_1 : A ;
  territorium_nn_1 : N ;
  terrorbombning_nn_1 : N ;
  terrorist_nn_1 : N ;
  ters_nn_1 : N ;
  tersett_nn_1 : N ;
  tertiaer_av_1 : A ;
  terzett_nn_1 : N ;
  terzin_nn_1 : N ;
  tes_nn_1 : N ;
  tesaurus_nn_1 : N ;
  tesked_nn_1 : N ;
  tesla_nn_1 : N ;
  teslastroem_nn_1 : N ;
  test_nn_1 : N ;
  test_nn_2 : N ;
  testabel_av_1 : A ;
  testamentarisk_av_1 : A ;
  testamentsexekutor_nn_1 : N ;
  testator_nn_1 : N ;
  testbatteri_nn_1 : N ;
  testbild_nn_1 : N ;
  testcykel_nn_1 : N ;
  testig_av_1 : A ;
  testikel_nn_1 : N ;
  testimonium_nn_1 : N ;
  testuggare_nn_1 : N ;
  testvaerde_nn_1 : N ;
  tete_a_tete_nn_1 : N ;
  tetig_av_1 : A ;
  tetraeder_nn_1 : N ;
  tetragon_nn_1 : N ;
  tetraklorid_nn_1 : N ;
  tetrapak_nn_1 : N ;
  tetrark_nn_1 : N ;
  teuton_nn_1 : N ;
  tevagn_nn_1 : N ;
  teve_nn_2 : N ;
  teveapparat_nn_1 : N ;
  tevetittare_nn_1 : N ;
  text_nn_1 : N ;
  textbearbetning_nn_1 : N ;
  textbehandling_nn_1 : N ;
  textbok_nn_1 : N ;
  textil_av_1 : A ;
  textil_nn_1 : N ;
  textilaetande_av_1 : A ;
  textilarbetare_nn_1 : N ;
  textilfiber_nn_1 : N ;
  textilindustri_nn_1 : N ;
  textilkurs_nn_1 : N ;
  textillaerare_nn_1 : N ;
  textrad_nn_1 : N ;
  textskaerm_nn_1 : N ;
  texttolkning_nn_1 : N ;
  textur_nn_1 : N ;
  thailaendare_nn_1 : N ;
  thailaendsk_av_1 : A ;
  thailaendska_nn_1 : N ;
  thaispraak_nn_1 : N ;
  thriller_nn_1 : N ;
  thrillerfilm_nn_1 : N ;
  thyroxin_nn_1 : N ;
  tibetan_nn_1 : N ;
  tibetanare_nn_1 : N ;
  tibetansk_av_1 : A ;
  tibetanska_nn_2 : N ;
  tic_nn_1 : N ;
  tick_nn_1 : N ;
  tick_tack_nn_1 : N ;
  tid_nn_1 : N ;
  tidebok_nn_1 : N ;
  tidegaerd_nn_1 : N ;
  tidelag_nn_1 : N ;
  tideraekning_nn_1 : N ;
  tidevarv_nn_1 : N ;
  tidig_av_1 : A ;
  tidjordsfenomen_nn_1 : N ;
  tidjordsforskning_nn_1 : N ;
  tidjordskraft_nn_1 : N ;
  tidkontrollur_nn_1 : N ;
  tidkort_nn_1 : N ;
  tidlaan_nn_1 : N ;
  tidlig_av_1 : A ;
  tidloes_av_1 : A ;
  tidmaane_nn_1 : N ;
  tidning_nn_1 : N ;
  tidningsartikel_nn_1 : N ;
  tidningsbud_nn_1 : N ;
  tidningsledare_nn_1 : N ;
  tidningsman_nn_1 : N ;
  tidningsnotis_nn_1 : N ;
  tidningsredaktion_nn_1 : N ;
  tidningssida_nn_1 : N ;
  tidningsspalt_nn_1 : N ;
  tidningstext_nn_1 : N ;
  tidningsuppgift_nn_1 : N ;
  tidningsupplaga_nn_1 : N ;
  tidningsutbaerning_nn_1 : N ;
  tidpunkt_nn_1 : N ;
  tidroer_nn_1 : N ;
  tidrymd_nn_1 : N ;
  tidsaalder_nn_1 : N ;
  tidsadverbial_nn_1 : N ;
  tidsangivelse_nn_1 : N ;
  tidsaspekt_nn_1 : N ;
  tidsbefraktning_nn_1 : N ;
  tidsbegrepp_nn_1 : N ;
  tidsbestaellning_nn_1 : N ;
  tidsbild_nn_1 : N ;
  tidsbunden_av_1 : A ;
  tidsenhet_nn_1 : N ;
  tidsenlig_av_1 : A ;
  tidsfaktor_nn_1 : N ;
  tidsfoerdriv_nn_1 : N ;
  tidsfoerlust_nn_1 : N ;
  tidsfoerskjutning_nn_1 : N ;
  tidsfraaga_nn_1 : N ;
  tidsfrist_nn_1 : N ;
  tidsgraens_nn_1 : N ;
  tidsinstaelld_av_1 : A ;
  tidsintervall_nn_1 : N ;
  tidskrift_nn_1 : N ;
  tidskriftsartikel_nn_1 : N ;
  tidskriftsindex_nn_1 : N ;
  tidskriftsnummer_nn_1 : N ;
  tidslig_av_1 : A ;
  tidsmaatt_nn_1 : N ;
  tidsmedveten_av_1 : A ;
  tidsoedande_av_1 : A ;
  tidsoeverdrag_nn_1 : N ;
  tidsperiod_nn_1 : N ;
  tidsperspektiv_nn_1 : N ;
  tidsplan_nn_1 : N ;
  tidsplan_nn_2 : N ;
  tidsrymd_nn_1 : N ;
  tidsschema_nn_1 : N ;
  tidssignal_nn_1 : N ;
  tidsskillnad_nn_1 : N ;
  tidsstudieman_nn_1 : N ;
  tidstroemstaellare_nn_1 : N ;
  tidstrogen_av_1 : A ;
  tidstypisk_av_1 : A ;
  tidsuppfattning_nn_1 : N ;
  tidtabell_nn_1 : N ;
  tidtagare_nn_1 : N ;
  tidtagarur_nn_1 : N ;
  tidtagning_nn_1 : N ;
  tidtals_ab_1 : Adv ;
  tidur_nn_1 : N ;
  tidvatten_nn_1 : N ;
  tidvattenhoejd_nn_1 : N ;
  tidvattenkraft_nn_1 : N ;
  tidvattenstroem_nn_1 : N ;
  tidvis_ab_1 : Adv ;
  tie_break_nn_1 : N ;
  tiger_nn_1 : N ;
  tigerhaj_nn_1 : N ;
  tigerkatt_nn_1 : N ;
  tigerlilja_nn_1 : N ;
  tigerorm_nn_1 : N ;
  tigerrandig_av_1 : A ;
  tigerspraang_nn_1 : N ;
  tigerstrimmig_av_1 : A ;
  tiggarbrev_nn_1 : N ;
  tiggare_nn_1 : N ;
  tiggarmunk_nn_1 : N ;
  tiggarorden_nn_1 : N ;
  tiggeri_nn_1 : N ;
  tik_nn_1 : N ;
  till_ab_1 : Adv ;
  tillaata_vb_1 : V ;
  tillaaten_av_1 : A ;
  tillaatlig_av_1 : A ;
  tillaegg_nn_1 : N ;
  tillaeggsbelopp_nn_1 : N ;
  tillaeggskostnad_nn_1 : N ;
  tillaeggsmandat_nn_1 : N ;
  tillaeggspension_nn_1 : N ;
  tillaeggsplats_nn_1 : N ;
  tillaemplig_av_1 : A ;
  tillaempning_nn_1 : N ;
  tillaempningsfoereskrift_nn_1 : N ;
  tillaenda_ab_1 : Adv ;
  tillaendalupen_av_1 : A ;
  tillaeventyrs_ab_1 : Adv ;
  tillbaka_ab_1 : Adv ;
  tillbakablick_nn_1 : N ;
  tillbakadragen_av_1 : A ;
  tillbakagaaende_av_1 : A ;
  tillbakasatt_av_1 : A ;
  tillbakasyftande_av_1 : A ;
  tillbaks_ab_1 : Adv ;
  tillbedja_vb_1 : V ;
  tillbedjare_nn_1 : N ;
  tillbehoer_nn_1 : N ;
  tillboerlig_av_1 : A ;
  tillbringare_nn_1 : N ;
  tillbud_nn_1 : N ;
  tillbuds_ab_1 : Adv ;
  tillbyggd_av_1 : A ;
  tillbyggnad_nn_1 : N ;
  tilldelning_nn_1 : N ;
  tilldels_ab_1 : Adv ;
  tilldra_vb_1 : V ;
  tilldragande_av_1 : A ;
  tilldragelse_nn_1 : N ;
  tillfaangata_vb_1 : V ;
  tillfaellig_av_1 : A ;
  tillfaellighet_nn_1 : N ;
  tillfaellighetsdikt_nn_1 : N ;
  tillfaellighetsfoerbrytare_nn_1 : N ;
  tillfaellighetsvers_nn_1 : N ;
  tillfaelligtvis_ab_1 : Adv ;
  tillfalla_vb_1 : V ;
  tillfart_nn_1 : N ;
  tillfartsvaeg_nn_1 : N ;
  tillfinnandes_ab_1 : Adv ;
  tillfloede_nn_1 : N ;
  tillflyktsort_nn_1 : N ;
  tillfoerlitlig_av_1 : A ;
  tillfoerlitlighet_nn_1 : N ;
  tillfoerlitlighetstaevling_nn_1 : N ;
  tillfoerne_ab_1 : Adv ;
  tillfreds_av_1 : A ;
  tillfredsstaellande_av_1 : A ;
  tillfredsstaelld_av_1 : A ;
  tillfullo_ab_1 : Adv ;
  tillfyllest_ab_1 : Adv ;
  tillgaang_nn_1 : N ;
  tillgaenglig_av_1 : A ;
  tillge_vb_1 : V ;
  tillgiven_av_1 : A ;
  tillgivenhet_nn_1 : N ;
  tillgjord_av_1 : A ;
  tillgodo_ab_1 : Adv ;
  tillgodohavande_nn_1 : N ;
  tillgodokvitto_nn_1 : N ;
  tillgrepp_nn_1 : N ;
  tillgripa_vb_1 : V ;
  tillhaall_nn_1 : N ;
  tillhaalla_vb_1 : V ;
  tillhaallarfjaeder_nn_1 : N ;
  tillhanda_ab_1 : Adv ;
  tillhandahaalla_vb_1 : V ;
  tillhands_ab_1 : Adv ;
  tillhoerande_av_1 : A ;
  tillhoerig_av_1 : A ;
  tillhoerighet_nn_1 : N ;
  tillhopa_ab_1 : Adv ;
  tillika_ab_1 : Adv ;
  tillintetgjord_av_1 : A ;
  tillintetgoerande_av_1 : A ;
  tillitsfull_av_1 : A ;
  tillkaenna_ab_1 : Adv ;
  tillkaennage_vb_1 : V ;
  tillkaennagivande_nn_1 : N ;
  tillklippt_av_1 : A ;
  tillknaeppt_av_1 : A ;
  tillkomma_vb_1 : V ;
  tillkommande_av_1 : A ;
  tillmoetes_ab_1 : Adv ;
  tillmoetesgaaende_av_1 : A ;
  tillnaermelsevis_ab_1 : Adv ;
  tillnamn_nn_1 : N ;
  tilloekning_nn_1 : N ;
  tilloenskning_nn_1 : N ;
  tillopp_nn_1 : N ;
  tillpass_ab_1 : Adv ;
  tillplattning_nn_1 : N ;
  tillraadlig_av_1 : A ;
  tillraecklig_av_1 : A ;
  tillraeknelig_av_1 : A ;
  tillraetta_ab_1 : Adv ;
  tillraettavisning_nn_1 : N ;
  tillreds_ab_1 : Adv ;
  tillrop_nn_1 : N ;
  tillsaegelse_nn_1 : N ;
  tillsaettning_nn_1 : N ;
  tillsammans_ab_1 : Adv ;
  tillsammantagen_av_1 : A ;
  tillsats_nn_1 : N ;
  tillsatsaemne_nn_1 : N ;
  tillsatslins_nn_1 : N ;
  tillskaera_vb_1 : V ;
  tillskaerare_nn_1 : N ;
  tillskaerarkniv_nn_1 : N ;
  tillskaerning_nn_1 : N ;
  tillskjuta_vb_1 : V ;
  tillskott_nn_1 : N ;
  tillskriva_vb_1 : V ;
  tillskyndare_nn_1 : N ;
  tillslag_nn_1 : N ;
  tillslagen_av_1 : A ;
  tillslagning_nn_1 : N ;
  tillslagningsteknik_nn_1 : N ;
  tillsluta_vb_1 : V ;
  tillslutare_nn_1 : N ;
  tillspillo_ab_1 : Adv ;
  tillspilloge_vb_1 : V ;
  tillspillogiven_av_1 : A ;
  tillstaand_nn_1 : N ;
  tillstaandsbevis_nn_1 : N ;
  tillstaandsgivande_av_1 : A ;
  tillstaedes_ab_1 : Adv ;
  tillstaellning_nn_1 : N ;
  tillstaendig_av_1 : A ;
  tillstymmelse_nn_1 : N ;
  tillstyrkande_nn_1 : N ;
  tillsvidare_ab_1 : Adv ;
  tillsvidarefoerordnande_nn_1 : N ;
  tillsynes_ab_1 : Adv ;
  tillsyningsman_nn_1 : N ;
  tillsynslaerare_nn_1 : N ;
  tillsynsman_nn_1 : N ;
  tillta_vb_1 : V ;
  tilltaenkt_av_1 : A ;
  tilltaeppning_nn_1 : N ;
  tilltag_nn_1 : N ;
  tilltagande_av_1 : A ;
  tilltagen_av_1 : A ;
  tilltagsen_av_1 : A ;
  tilltalande_av_1 : A ;
  tilltalsform_nn_1 : N ;
  tilltalsnamn_nn_1 : N ;
  tilltalsord_nn_1 : N ;
  tilltraede_nn_1 : N ;
  tillvaega_ab_1 : Adv ;
  tillvaegagaangssaett_nn_1 : N ;
  tillvaextaemne_nn_1 : N ;
  tillvaexthastighet_nn_1 : N ;
  tillvaexthormon_nn_1 : N ;
  tillvaextperiod_nn_1 : N ;
  tillval_nn_1 : N ;
  tillvalsaemne_nn_1 : N ;
  tillvand_av_1 : A ;
  tillvarata_vb_1 : V ;
  tillverkare_nn_1 : N ;
  tillverkning_nn_1 : N ;
  tillverkningsaar_nn_1 : N ;
  tillviljes_ab_1 : Adv ;
  tillvitelse_nn_1 : N ;
  timarvode_nn_1 : N ;
  timbal_nn_1 : N ;
  timcirkel_nn_1 : N ;
  timglas_nn_1 : N ;
  timing_nn_1 : N ;
  timlaerare_nn_1 : N ;
  timlig_av_1 : A ;
  timloen_nn_1 : N ;
  timma_nn_1 : N ;
  timme_nn_1 : N ;
  timmer_nn_1 : N ;
  timmeravlaegg_nn_1 : N ;
  timmerblaedning_nn_1 : N ;
  timmerbroet_nn_1 : N ;
  timmerdoning_nn_1 : N ;
  timmerflotte_nn_1 : N ;
  timmerflottning_nn_1 : N ;
  timmerhus_nn_1 : N ;
  timmerlaens_nn_1 : N ;
  timmermagasin_nn_1 : N ;
  timmerman_nn_1 : N ;
  timmersax_nn_1 : N ;
  timmerslaep_nn_1 : N ;
  timmerstek_nn_1 : N ;
  timmerstock_nn_1 : N ;
  timmerstockar_ab_1 : Adv ;
  timmersvans_nn_1 : N ;
  timslaang_av_1 : A ;
  timslag_nn_1 : N ;
  timtals_ab_1 : Adv ;
  timvisare_nn_1 : N ;
  ting_nn_1 : N ;
  tingest_nn_1 : N ;
  tingord_nn_1 : N ;
  tingshus_nn_1 : N ;
  tingsraett_nn_1 : N ;
  tinktur_nn_1 : N ;
  tinne_nn_1 : N ;
  tinning_nn_1 : N ;
  tinningben_nn_1 : N ;
  tinninglob_nn_1 : N ;
  tiodubbel_av_1 : A ;
  tiofaldig_av_1 : A ;
  tiofalt_ab_1 : Adv ;
  tiofoting_nn_1 : N ;
  tiokamp_nn_1 : N ;
  tiokronorssedel_nn_1 : N ;
  tiomila_av_1 : A ;
  tiominutersrast_nn_1 : N ;
  tiondel_nn_1 : N ;
  tiooering_nn_1 : N ;
  tiotal_nn_1 : N ;
  tiotalist_nn_1 : N ;
  tiotusental_nn_1 : N ;
  tipp_nn_1 : N ;
  tippare_nn_1 : N ;
  tippflak_nn_1 : N ;
  tipptopp_av_1 : A ;
  tippvagn_nn_1 : N ;
  tips_nn_1 : N ;
  tipskupong_nn_1 : N ;
  tipspromenad_nn_1 : N ;
  tipsrad_nn_1 : N ;
  tipstaevling_nn_1 : N ;
  tiptop_av_1 : A ;
  tir_nn_1 : N ;
  tirad_nn_1 : N ;
  tisdag_nn_1 : N ;
  tisdagskvaell_nn_1 : N ;
  tisdagsmorgon_nn_1 : N ;
  tistel_nn_1 : N ;
  tistelborre_nn_1 : N ;
  tistelstaang_nn_1 : N ;
  tistron_nn_1 : N ;
  titan_nn_1 : N ;
  titanisk_av_1 : A ;
  titanskruv_nn_1 : N ;
  titel_nn_1 : N ;
  titelblad_nn_1 : N ;
  titelbortlaeggning_nn_1 : N ;
  titeldikt_nn_1 : N ;
  titelfoersvarare_nn_1 : N ;
  titelmatch_nn_1 : N ;
  titelnovell_nn_1 : N ;
  titelroll_nn_1 : N ;
  titelsida_nn_1 : N ;
  titelsjuk_av_1 : A ;
  titt_ab_1 : Adv ;
  titt_nn_1 : N ;
  tittare_nn_1 : N ;
  tittarstorm_nn_1 : N ;
  tittglugg_nn_1 : N ;
  titthaal_nn_1 : N ;
  tittskaap_nn_1 : N ;
  titulaerkonsul_nn_1 : N ;
  titulatur_nn_1 : N ;
  tivoli_nn_1 : N ;
  tixotrop_av_1 : A ;
  tjack_nn_1 : N ;
  tjaeder_nn_1 : N ;
  tjaedertupp_nn_1 : N ;
  tjaelfrusen_av_1 : A ;
  tjaell_nn_1 : N ;
  tjaelskott_nn_1 : N ;
  tjaenare_nn_1 : N ;
  tjaenarinna_nn_1 : N ;
  tjaenis_av_1 : A ;
  tjaenlig_av_1 : A ;
  tjaenst_nn_1 : N ;
  tjaenstaktig_av_1 : A ;
  tjaenstbar_av_1 : A ;
  tjaenste_ab_1 : Adv ;
  tjaensteaar_nn_1 : N ;
  tjaensteaerende_nn_1 : N ;
  tjaensteande_nn_1 : N ;
  tjaensteavtal_nn_1 : N ;
  tjaenstebil_nn_1 : N ;
  tjaenstebostad_nn_1 : N ;
  tjaenstebrev_nn_1 : N ;
  tjaenstebrevsraett_nn_1 : N ;
  tjaenstefel_nn_1 : N ;
  tjaenstefoerraettande_av_1 : A ;
  tjaenstefoerraettare_nn_1 : N ;
  tjaenstefoerraettning_nn_1 : N ;
  tjaenstefoersaendelse_nn_1 : N ;
  tjaenstefoerseelse_nn_1 : N ;
  tjaenstegrad_nn_1 : N ;
  tjaenstekvinna_nn_1 : N ;
  tjaensteman_nn_1 : N ;
  tjaenstepension_nn_1 : N ;
  tjaensterum_nn_1 : N ;
  tjaenstestaellning_nn_1 : N ;
  tjaenstetid_nn_1 : N ;
  tjaenstgoering_nn_1 : N ;
  tjaenstledig_av_1 : A ;
  tjaenstledighet_nn_1 : N ;
  tjaenstvillig_av_1 : A ;
  tjaerblomster_nn_1 : N ;
  tjaerbloss_nn_1 : N ;
  tjaerdal_nn_1 : N ;
  tjaerframstaellning_nn_1 : N ;
  tjaern_nn_1 : N ;
  tjafsig_av_1 : A ;
  tjalk_nn_1 : N ;
  tjallare_nn_1 : N ;
  tjatig_av_1 : A ;
  tjeck_nn_1 : N ;
  tjeckisk_av_1 : A ;
  tjeckiska_nn_2 : N ;
  tjeckoslovak_nn_1 : N ;
  tjeckoslovakisk_av_1 : A ;
  tjeckoslovakiska_nn_1 : N ;
  tjej_nn_1 : N ;
  tjock_av_1 : A ;
  tjockflytande_av_1 : A ;
  tjockhuding_nn_1 : N ;
  tjockis_nn_1 : N ;
  tjocklek_nn_1 : N ;
  tjockskalle_nn_1 : N ;
  tjockskallig_av_1 : A ;
  tjocktarm_nn_1 : N ;
  tjog_nn_1 : N ;
  tjogtals_ab_1 : Adv ;
  tjomme_nn_1 : N ;
  tjuder_nn_1 : N ;
  tjugofemoering_nn_1 : N ;
  tjugondedag_nn_1 : N ;
  tjugondel_nn_1 : N ;
  tjugoplanig_av_1 : A ;
  tjugotal_nn_1 : N ;
  tjur_nn_1 : N ;
  tjurfaektare_nn_1 : N ;
  tjurfaektning_nn_1 : N ;
  tjurig_av_1 : A ;
  tjurnacke_nn_1 : N ;
  tjurskalle_nn_1 : N ;
  tjurskallig_av_1 : A ;
  tjusarlock_nn_1 : N ;
  tjusig_av_1 : A ;
  tjut_nn_1 : N ;
  tjuv_nn_1 : N ;
  tjuvaktig_av_1 : A ;
  tjuvalarm_nn_1 : N ;
  tjuvbagge_nn_1 : N ;
  tjuveri_nn_1 : N ;
  tjuvgoemmare_nn_1 : N ;
  tjuvhaalla_vb_1 : V ;
  tjuvknep_nn_1 : N ;
  tjuvlarm_nn_1 : N ;
  tjuvnad_nn_1 : N ;
  tjuvnyp_nn_1 : N ;
  tjuvpojke_nn_1 : N ;
  tjuvpojksglimt_nn_1 : N ;
  tjuvskytt_nn_1 : N ;
  tjuvstart_nn_1 : N ;
  tjuvstreck_nn_1 : N ;
  tjuvstryker_nn_1 : N ;
  tjuvtitt_nn_1 : N ;
  tjuvtjock_av_1 : A ;
  tjuvtryck_nn_1 : N ;
  tjyv_nn_1 : N ;
  tjyvnyp_nn_1 : N ;
  tjyvtjock_av_1 : A ;
  toalett_nn_1 : N ;
  toalettartikel_nn_1 : N ;
  toalettbord_nn_1 : N ;
  toalettskaap_nn_1 : N ;
  toalettvaal_nn_1 : N ;
  tobakist_nn_1 : N ;
  tobaksaffaer_nn_1 : N ;
  tobakshandlare_nn_1 : N ;
  tobaksmonopol_nn_1 : N ;
  tobaksvara_nn_1 : N ;
  tobis_nn_1 : N ;
  tobiskung_nn_1 : N ;
  tocken_av_1 : A ;
  toddy_nn_1 : N ;
  toecken_nn_1 : N ;
  toecknig_av_1 : A ;
  toeig_av_1 : A ;
  toejbar_av_1 : A ;
  toejbarhet_nn_1 : N ;
  toejning_nn_1 : N ;
  toejningsmaetare_nn_1 : N ;
  toelp_nn_1 : N ;
  toelpaktig_av_1 : A ;
  toelpig_av_1 : A ;
  toem_nn_1 : N ;
  toemring_nn_1 : N ;
  toent_nn_1 : N ;
  toentig_av_1 : A ;
  toerhaenda_ab_1 : Adv ;
  toern_nn_1 : N ;
  toernbestroedd_av_1 : A ;
  toernbuske_nn_1 : N ;
  toernekroent_av_1 : A ;
  toernig_av_1 : A ;
  toernsaangare_nn_1 : N ;
  toerntagg_nn_1 : N ;
  toerstig_av_1 : A ;
  toerstslaeckande_av_1 : A ;
  toes_nn_1 : N ;
  toffel_nn_1 : N ;
  toffeldjur_nn_1 : N ;
  toffelhjaelte_nn_1 : N ;
  tofs_nn_1 : N ;
  tofsig_av_1 : A ;
  tofsmes_nn_1 : N ;
  tofsoera_nn_1 : N ;
  tofsskivling_nn_1 : N ;
  toft_nn_1 : N ;
  toftvaegare_nn_1 : N ;
  togoles_nn_1 : N ;
  togolesisk_av_1 : A ;
  tok_nn_1 : N ;
  toker_nn_1 : N ;
  tokeri_nn_1 : N ;
  tokig_av_1 : A ;
  tokrolig_av_1 : A ;
  tokstolle_nn_1 : N ;
  tolerabel_av_1 : A ;
  tolerans_nn_1 : N ;
  tolerant_av_1 : A ;
  tolft_nn_1 : N ;
  tolftedel_nn_1 : N ;
  tolk_nn_1 : N ;
  tolkare_nn_1 : N ;
  tolkning_nn_1 : N ;
  tolkningsfraaga_nn_1 : N ;
  tolvfingertarm_nn_1 : N ;
  tolvman_nn_1 : N ;
  tolvmilsgraens_nn_1 : N ;
  tolvskilling_nn_1 : N ;
  tom_av_1 : A ;
  tom_nn_1 : N ;
  tomahawk_nn_1 : N ;
  tomat_nn_1 : N ;
  tombutelj_nn_1 : N ;
  tomglas_nn_1 : N ;
  tomhaent_av_1 : A ;
  tomhet_nn_1 : N ;
  tomning_ab_1 : Adv ;
  tomografi_nn_1 : N ;
  tomrum_nn_1 : N ;
  tomt_nn_1 : N ;
  tomte_nn_1 : N ;
  tomtebisse_nn_1 : N ;
  tomtebloss_nn_1 : N ;
  tomtemask_nn_1 : N ;
  tomtenisse_nn_1 : N ;
  tomtjobbare_nn_1 : N ;
  tomtmark_nn_1 : N ;
  tomtraettsavgaeld_nn_1 : N ;
  ton_nn_1 : N ;
  ton_nn_2 : N ;
  tonaarig_av_1 : A ;
  tonaaring_nn_1 : N ;
  tonaarsidol_nn_1 : N ;
  tonal_av_1 : A ;
  tonalitet_nn_1 : N ;
  tonande_av_1 : A ;
  tonarm_nn_1 : N ;
  tonart_nn_1 : N ;
  tonband_nn_1 : N ;
  tondoev_av_1 : A ;
  tonem_nn_1 : N ;
  tonett_nn_1 : N ;
  tonfall_nn_1 : N ;
  tonfisk_nn_1 : N ;
  tonfoeljd_nn_1 : N ;
  tongan_nn_1 : N ;
  tongivande_av_1 : A ;
  tonhoejd_nn_1 : N ;
  tonikum_nn_1 : N ;
  toning_nn_1 : N ;
  tonisk_av_1 : A ;
  tonkilometer_nn_1 : N ;
  tonlaege_nn_1 : N ;
  tonloes_av_1 : A ;
  tonmaalning_nn_1 : N ;
  tonomfaang_nn_1 : N ;
  tonomraade_nn_1 : N ;
  tonsaeker_av_1 : A ;
  tonsaettare_nn_1 : N ;
  tonsaettning_nn_1 : N ;
  tonsill_nn_1 : N ;
  tonspraak_nn_1 : N ;
  tonsteg_nn_1 : N ;
  tonstyrka_nn_1 : N ;
  tonsur_nn_1 : N ;
  tonsystem_nn_1 : N ;
  tontraeffning_nn_1 : N ;
  tonvis_ab_1 : Adv ;
  topas_nn_1 : N ;
  topless_av_1 : A ;
  topograf_nn_1 : N ;
  topografisk_av_1 : A ;
  topologi_nn_1 : N ;
  topologisk_av_1 : A ;
  topp_nn_1 : N ;
  toppbefattning_nn_1 : N ;
  toppbegaavning_nn_1 : N ;
  toppeld_nn_1 : N ;
  toppen_av_1 : A ;
  toppenbra_av_1 : A ;
  toppformig_av_1 : A ;
  topphugga_vb_1 : V ;
  toppig_av_1 : A ;
  toppknopp_nn_1 : N ;
  toppkonferens_nn_1 : N ;
  toppkraft_nn_1 : N ;
  topplaan_nn_1 : N ;
  topplock_nn_1 : N ;
  toppman_nn_1 : N ;
  toppmast_nn_1 : N ;
  toppmoete_nn_1 : N ;
  toppmurkla_nn_1 : N ;
  toppnivaa_nn_1 : N ;
  topprida_vb_1 : V ;
  toppsegel_nn_1 : N ;
  toppstyrd_av_1 : A ;
  toque_nn_1 : N ;
  tordmule_nn_1 : N ;
  tordoen_nn_1 : N ;
  tordoensroest_nn_1 : N ;
  tordoensstaemma_nn_1 : N ;
  tordyvel_nn_1 : N ;
  toreador_nn_1 : N ;
  torero_nn_1 : N ;
  torftig_av_1 : A ;
  torg_nn_1 : N ;
  torgdag_nn_1 : N ;
  torgstaand_nn_1 : N ;
  tork_nn_1 : N ;
  torkaemne_nn_1 : N ;
  torkarblad_nn_1 : N ;
  torkeri_nn_1 : N ;
  torkhandduk_nn_1 : N ;
  torkhuv_nn_1 : N ;
  torkkatastrof_nn_1 : N ;
  torkning_nn_1 : N ;
  torkperiod_nn_1 : N ;
  torkrum_nn_1 : N ;
  torkskaap_nn_1 : N ;
  torkstaell_nn_1 : N ;
  torkstreck_nn_1 : N ;
  torktumlare_nn_1 : N ;
  torn_nn_1 : N ;
  torn_nn_2 : N ;
  tornado_nn_1 : N ;
  tornering_nn_1 : N ;
  tornerspel_nn_1 : N ;
  tornfalk_nn_1 : N ;
  tornister_nn_1 : N ;
  tornseglare_nn_1 : N ;
  tornur_nn_1 : N ;
  tornvaektare_nn_1 : N ;
  torp_nn_1 : N ;
  torpare_nn_1 : N ;
  torped_nn_1 : N ;
  torpedbaat_nn_1 : N ;
  torpedtub_nn_1 : N ;
  torr_av_1 : A ;
  torrbatteri_nn_1 : N ;
  torrboll_nn_1 : N ;
  torrdestillation_nn_1 : N ;
  torrelement_nn_1 : N ;
  torris_nn_2 : N ;
  torrklosett_nn_1 : N ;
  torrnaal_nn_1 : N ;
  torroegd_av_1 : A ;
  torrolig_av_1 : A ;
  torrperiod_nn_1 : N ;
  torrschampo_nn_1 : N ;
  torrskodd_av_1 : A ;
  torrtid_nn_1 : N ;
  torsdag_nn_1 : N ;
  torsdagskvaell_nn_1 : N ;
  torsdagsmorgon_nn_1 : N ;
  torsk_nn_1 : N ;
  torskfisk_nn_1 : N ;
  torskoega_nn_1 : N ;
  torso_nn_1 : N ;
  tortyr_nn_1 : N ;
  tortyrkammare_nn_1 : N ;
  tortyrredskap_nn_1 : N ;
  torvaktig_av_1 : A ;
  torvdike_nn_1 : N ;
  torvgrav_nn_1 : N ;
  torvjord_nn_1 : N ;
  torvmosse_nn_1 : N ;
  torvmossfynd_nn_1 : N ;
  torvmullsklosett_nn_1 : N ;
  torvspade_nn_1 : N ;
  torvtaekt_nn_1 : N ;
  torvtak_nn_1 : N ;
  tory_nn_1 : N ;
  tosig_av_1 : A ;
  tosing_nn_1 : N ;
  tosk_nn_1 : N ;
  toskansk_av_1 : A ;
  tossig_av_1 : A ;
  total_av_1 : A ;
  totalfoerbjuda_vb_1 : V ;
  totalfoerbud_nn_1 : N ;
  totalfoermoerkelse_nn_1 : N ;
  totalhaveri_nn_1 : N ;
  totalisator_nn_1 : N ;
  totalitaer_av_1 : A ;
  totaliter_ab_1 : Adv ;
  totalitet_nn_1 : N ;
  totalvaerde_nn_1 : N ;
  totalvikt_nn_1 : N ;
  totempaale_nn_1 : N ;
  totempelare_nn_1 : N ;
  toto_nn_1 : N ;
  totospel_nn_1 : N ;
  tott_nn_1 : N ;
  touche_nn_1 : N ;
  toujours_av_1 : A ;
  toupe_nn_1 : N ;
  tournedos_nn_1 : N ;
  tovig_av_1 : A ;
  toxafen_nn_1 : N ;
  toxicitet_nn_1 : N ;
  toxikologisk_av_1 : A ;
  toxisk_av_1 : A ;
  traackelstygn_nn_1 : N ;
  traackeltraad_nn_1 : N ;
  traackling_nn_1 : N ;
  traad_nn_1 : N ;
  traadaemne_nn_1 : N ;
  traadbindning_nn_1 : N ;
  traadbuss_nn_1 : N ;
  traadduk_nn_1 : N ;
  traadig_av_1 : A ;
  traadknapp_nn_1 : N ;
  traadkors_nn_1 : N ;
  traadliknande_av_1 : A ;
  traadloes_av_1 : A ;
  traadmask_nn_1 : N ;
  traadraet_av_1 : A ;
  traadrulle_nn_1 : N ;
  traadsax_nn_1 : N ;
  traadskivling_nn_1 : N ;
  traadsliten_av_1 : A ;
  traadsmal_av_1 : A ;
  traadspik_nn_1 : N ;
  traag_nn_1 : N ;
  traagdal_nn_1 : N ;
  traakig_av_1 : A ;
  traakmaans_nn_1 : N ;
  traakning_nn_1 : N ;
  traal_nn_1 : N ;
  traalare_nn_1 : N ;
  traanad_nn_1 : N ;
  traang_av_1 : A ;
  traangbodd_av_1 : A ;
  traangmaal_nn_1 : N ;
  traangsint_av_1 : A ;
  traangsynt_av_1 : A ;
  traansjuk_av_1 : A ;
  trad_nn_1 : N ;
  tradig_av_1 : A ;
  tradition_nn_1 : N ;
  traditionalist_nn_1 : N ;
  traditionell_av_1 : A ;
  traditionsbaerare_nn_1 : N ;
  traditionsbrott_nn_1 : N ;
  traditionsbunden_av_1 : A ;
  traditionsenlig_av_1 : A ;
  trae_nn_1 : N ;
  traeaktig_av_1 : A ;
  traeavfall_nn_1 : N ;
  traeben_nn_1 : N ;
  traebit_nn_1 : N ;
  traeblaasare_nn_1 : N ;
  traeblaasinstrument_nn_1 : N ;
  traebock_nn_1 : N ;
  traecell_nn_1 : N ;
  traed_nn_1 : N ;
  traeddiagram_nn_1 : N ;
  traedestillation_nn_1 : N ;
  traedgaard_nn_1 : N ;
  traedgaardsaert_nn_1 : N ;
  traedgaardsarkitekt_nn_1 : N ;
  traedgaardsbuske_nn_1 : N ;
  traedgaardsmaestare_nn_1 : N ;
  traedgaardsmoebel_nn_1 : N ;
  traedgaardsodling_nn_1 : N ;
  traedgaardsprydnad_nn_1 : N ;
  traedgaardssaangare_nn_1 : N ;
  traedgaardssax_nn_1 : N ;
  traedgraens_nn_1 : N ;
  traedkrypare_nn_1 : N ;
  traedliknande_av_1 : A ;
  traedmogen_av_1 : A ;
  traednaal_nn_1 : N ;
  traedrot_nn_1 : N ;
  traedslag_nn_1 : N ;
  traedstam_nn_1 : N ;
  traedstruktur_nn_1 : N ;
  traedstygn_nn_1 : N ;
  traedsvamp_nn_1 : N ;
  traedtopp_nn_1 : N ;
  traefartyg_nn_1 : N ;
  traeff_nn_1 : N ;
  traeffande_av_1 : A ;
  traeffbild_nn_1 : N ;
  traeffning_nn_1 : N ;
  traeffpunkt_nn_1 : N ;
  traeffsaeker_av_1 : A ;
  traeffsaekerhet_nn_1 : N ;
  traefiber_nn_1 : N ;
  traefil_nn_1 : N ;
  traefraes_nn_1 : N ;
  traefri_av_1 : A ;
  traegen_av_1 : A ;
  traegolv_nn_1 : N ;
  traegravyr_nn_1 : N ;
  traehaest_nn_1 : N ;
  traeig_av_1 : A ;
  traeindustri_nn_1 : N ;
  traekarl_nn_1 : N ;
  traekol_nn_1 : N ;
  trael_nn_1 : N ;
  traelbinda_vb_1 : V ;
  traeldom_nn_1 : N ;
  traelig_av_1 : A ;
  traemask_nn_1 : N ;
  traemortel_nn_1 : N ;
  traenare_nn_1 : N ;
  traengande_av_1 : A ;
  traengd_av_1 : A ;
  traengning_nn_1 : N ;
  traengtrupp_nn_1 : N ;
  traening_nn_1 : N ;
  traeningsdraekt_nn_1 : N ;
  traeningslaeger_nn_1 : N ;
  traeningsoverall_nn_1 : N ;
  traenjon_nn_1 : N ;
  traens_nn_1 : N ;
  traepinne_nn_1 : N ;
  traeprodukt_nn_1 : N ;
  traeram_nn_1 : N ;
  traesk_nn_1 : N ;
  traeskaal_nn_1 : N ;
  traeskalle_nn_1 : N ;
  traeskallig_av_1 : A ;
  traesked_nn_1 : N ;
  traeskfolk_nn_1 : N ;
  traeskland_nn_1 : N ;
  traesko_nn_1 : N ;
  traeskodans_nn_1 : N ;
  traeskostoevel_nn_1 : N ;
  traeskruv_nn_1 : N ;
  traeskydd_nn_1 : N ;
  traeskyddsmedel_nn_1 : N ;
  traeslag_nn_1 : N ;
  traeslev_nn_1 : N ;
  traeslip_nn_1 : N ;
  traeslott_nn_1 : N ;
  traesnidare_nn_1 : N ;
  traesnideri_nn_1 : N ;
  traesnitt_nn_1 : N ;
  traesnittsstock_nn_1 : N ;
  traestav_nn_1 : N ;
  traestick_nn_1 : N ;
  traestift_nn_1 : N ;
  traeteknisk_av_1 : A ;
  traetgirig_av_1 : A ;
  traetlysten_av_1 : A ;
  traetobroder_nn_1 : N ;
  traetoffel_nn_1 : N ;
  traevit_av_1 : A ;
  trafikabel_av_1 : A ;
  trafikant_nn_1 : N ;
  trafikdelare_nn_1 : N ;
  trafikfarlig_av_1 : A ;
  trafikflygare_nn_1 : N ;
  trafikflygplan_nn_1 : N ;
  trafikfoersaekring_nn_1 : N ;
  trafikfyr_nn_1 : N ;
  trafikkort_nn_1 : N ;
  trafikled_nn_1 : N ;
  trafikledare_nn_1 : N ;
  trafikljus_nn_1 : N ;
  trafikmaerke_nn_1 : N ;
  trafikplats_nn_1 : N ;
  trafikregel_nn_1 : N ;
  trafikreglering_nn_1 : N ;
  trafiksaeker_av_1 : A ;
  trafiksaekerhet_nn_1 : N ;
  trafiksaekerhetsverk_nn_1 : N ;
  trafiksignal_nn_1 : N ;
  trafikstockning_nn_1 : N ;
  trafiktillstaand_nn_1 : N ;
  trafikvakt_nn_1 : N ;
  tragedi_nn_1 : N ;
  tragedienn_nn_1 : N ;
  tragedifoerfattare_nn_1 : N ;
  tragglig_av_1 : A ;
  tragiker_nn_1 : N ;
  tragikomedi_nn_1 : N ;
  tragikomisk_av_1 : A ;
  tragisk_av_1 : A ;
  tragoed_nn_1 : N ;
  trailer_nn_1 : N ;
  traj_nn_1 : N ;
  trakasseri_nn_1 : N ;
  trake_nn_1 : N ;
  trakegael_nn_1 : N ;
  trakom_nn_1 : N ;
  trakt_nn_1 : N ;
  traktat_nn_1 : N ;
  traktblaedning_nn_1 : N ;
  traktering_nn_1 : N ;
  trakthugga_vb_1 : V ;
  traktoer_nn_1 : N ;
  traktor_nn_1 : N ;
  traktordaeck_nn_1 : N ;
  traktur_nn_1 : N ;
  trakyt_nn_1 : N ;
  trall_nn_1 : N ;
  trall_nn_2 : N ;
  trallvagn_nn_1 : N ;
  trampbaat_nn_1 : N ;
  trampbil_nn_1 : N ;
  trampcykel_nn_1 : N ;
  trampfartyg_nn_1 : N ;
  tramphjul_nn_1 : N ;
  trampkvarn_nn_1 : N ;
  trampoert_nn_1 : N ;
  trampolin_nn_1 : N ;
  trampsax_nn_1 : N ;
  tramsig_av_1 : A ;
  tranbaer_nn_1 : N ;
  tranben_nn_1 : N ;
  trance_nn_1 : N ;
  tranch_nn_1 : N ;
  trankil_av_1 : A ;
  trankilitet_nn_1 : N ;
  transaktion_nn_1 : N ;
  transaktionsanalys_nn_1 : N ;
  transalpin_av_1 : A ;
  transalpinsk_av_1 : A ;
  transatlantisk_av_1 : A ;
  transcendent_av_1 : A ;
  transcendental_av_1 : A ;
  transduktor_nn_1 : N ;
  transferering_nn_1 : N ;
  transfiguration_nn_1 : N ;
  transformation_nn_1 : N ;
  transformator_nn_1 : N ;
  transformatorstation_nn_1 : N ;
  transfusion_nn_1 : N ;
  transgression_nn_1 : N ;
  transistor_nn_1 : N ;
  transitering_nn_1 : N ;
  transithall_nn_1 : N ;
  transitiv_av_1 : A ;
  transitlast_nn_1 : N ;
  transitohamn_nn_1 : N ;
  transitorisk_av_1 : A ;
  transkontinental_av_1 : A ;
  transkription_nn_1 : N ;
  translator_nn_1 : N ;
  translitteration_nn_1 : N ;
  transmission_nn_1 : N ;
  transmitter_nn_1 : N ;
  transmutation_nn_1 : N ;
  transocean_av_1 : A ;
  transoceansk_av_1 : A ;
  transparang_nn_1 : N ;
  transparent_av_1 : A ;
  transperson_nn_1 : N ;
  transplantat_nn_1 : N ;
  transplantation_nn_1 : N ;
  transponder_nn_1 : N ;
  transponering_nn_1 : N ;
  transport_nn_1 : N ;
  transportabel_av_1 : A ;
  transportanordning_nn_1 : N ;
  transportarbetare_nn_1 : N ;
  transportavtal_nn_1 : N ;
  transportband_nn_1 : N ;
  transportfoerbud_nn_1 : N ;
  transportfoeretag_nn_1 : N ;
  transportlaege_nn_1 : N ;
  transportmedel_nn_1 : N ;
  transportmekanism_nn_1 : N ;
  transportnaet_nn_1 : N ;
  transportoer_nn_1 : N ;
  transportprocess_nn_1 : N ;
  transportsystem_nn_1 : N ;
  transposition_nn_1 : N ;
  transsexuell_av_1 : A ;
  transsibirisk_av_1 : A ;
  transsubstantiation_nn_1 : N ;
  transumt_nn_1 : N ;
  transuran_nn_1 : N ;
  transversal_av_1 : A ;
  transversal_nn_1 : N ;
  transversalaxel_nn_1 : N ;
  transversell_av_1 : A ;
  transvestit_nn_1 : N ;
  trapets_nn_1 : N ;
  trapets_nn_2 : N ;
  trapetsoid_nn_1 : N ;
  trapp_nn_1 : N ;
  trappavsats_nn_1 : N ;
  trapper_nn_1 : N ;
  trappgavel_nn_1 : N ;
  trapphus_nn_1 : N ;
  trappliknande_av_1 : A ;
  trappraecke_nn_1 : N ;
  trappsmyg_nn_1 : N ;
  trappsteg_nn_1 : N ;
  trappstege_nn_1 : N ;
  trapptorn_nn_1 : N ;
  trappuppgaang_nn_1 : N ;
  traselegant_av_1 : A ;
  trasgrann_av_1 : A ;
  trashank_nn_1 : N ;
  trasig_av_1 : A ;
  trassat_nn_1 : N ;
  trasselsudd_nn_1 : N ;
  trassent_nn_1 : N ;
  trasslig_av_1 : A ;
  trast_nn_1 : N ;
  trastfaagel_nn_1 : N ;
  trasunge_nn_1 : N ;
  tratt_nn_1 : N ;
  trattformig_av_1 : A ;
  trattkantarell_nn_1 : N ;
  trattliknande_av_1 : A ;
  trattprick_nn_1 : N ;
  trattskivling_nn_1 : N ;
  trauma_nn_1 : N ;
  traumatisk_av_1 : A ;
  travare_nn_1 : N ;
  trave_nn_1 : N ;
  travers_nn_1 : N ;
  travesti_nn_1 : N ;
  travhaest_nn_1 : N ;
  travtaevling_nn_1 : N ;
  treaarig_av_1 : A ;
  treaaring_nn_1 : N ;
  treaktare_nn_1 : N ;
  trebent_av_1 : A ;
  trebetygskurs_nn_1 : N ;
  tredelning_nn_1 : N ;
  tredimensionell_av_1 : A ;
  tredjedag_nn_1 : N ;
  tredjedel_nn_1 : N ;
  tredjegaangstillsaettning_nn_1 : N ;
  tredjeopponent_nn_1 : N ;
  tredjeplats_nn_1 : N ;
  tredsk_av_1 : A ;
  tredskodom_nn_1 : N ;
  tredubbel_av_1 : A ;
  treenig_av_1 : A ;
  treenighet_nn_1 : N ;
  trefaergstryck_nn_1 : N ;
  trefald_nn_1 : N ;
  trefaldig_av_1 : A ;
  trefaldighet_nn_1 : N ;
  trefalt_ab_1 : Adv ;
  trefas_av_1 : A ;
  trefasig_av_1 : A ;
  trefilig_av_1 : A ;
  treglasfoenster_nn_1 : N ;
  trehjuling_nn_1 : N ;
  trehoerning_nn_1 : N ;
  trekant_nn_1 : N ;
  trekantig_av_1 : A ;
  trekarlspolska_nn_1 : N ;
  treklang_nn_1 : N ;
  trekvartslaang_av_1 : A ;
  trelaekarstation_nn_1 : N ;
  treledarsystem_nn_1 : N ;
  trema_nn_1 : N ;
  tremaenning_nn_1 : N ;
  tremastare_nn_1 : N ;
  tremilsgraens_nn_1 : N ;
  tremolo_nn_1 : N ;
  tremulant_nn_1 : N ;
  trench_nn_1 : N ;
  trenchcoat_nn_1 : N ;
  trend_nn_1 : N ;
  trendig_av_1 : A ;
  trendnisse_nn_1 : N ;
  trendsaettare_nn_1 : N ;
  trepan_nn_1 : N ;
  trepanation_nn_1 : N ;
  trepass_nn_1 : N ;
  trepunktsbaelte_nn_1 : N ;
  treradig_av_1 : A ;
  trerading_nn_1 : N ;
  trerummare_nn_1 : N ;
  trerumslaegenhet_nn_1 : N ;
  tresiffrig_av_1 : A ;
  tresnibb_nn_1 : N ;
  trespaend_av_1 : A ;
  trespann_nn_1 : N ;
  trestavig_av_1 : A ;
  trestegshopp_nn_1 : N ;
  trestegsraket_nn_1 : N ;
  trestjaernig_av_1 : A ;
  trestruken_av_1 : A ;
  tretaar_nn_1 : N ;
  tretal_nn_1 : N ;
  trettiaarig_av_1 : A ;
  trettioaarig_av_1 : A ;
  trettiondel_nn_1 : N ;
  trettiotal_nn_1 : N ;
  trettital_nn_1 : N ;
  trettondagsafton_nn_1 : N ;
  trettondel_nn_1 : N ;
  tretumsspik_nn_1 : N ;
  treudd_nn_1 : N ;
  trevaaningshus_nn_1 : N ;
  trevaegskran_nn_1 : N ;
  trevande_av_1 : A ;
  trevare_nn_1 : N ;
  treven_av_1 : A ;
  trevinklig_av_1 : A ;
  trevlig_av_1 : A ;
  trevnad_nn_1 : N ;
  triad_nn_1 : N ;
  triangel_nn_1 : N ;
  triangelbyte_nn_1 : N ;
  triangeldrama_nn_1 : N ;
  triangelkoppling_nn_1 : N ;
  triangelmatch_nn_1 : N ;
  triangelpunkt_nn_1 : N ;
  triangelsida_nn_1 : N ;
  triangulaer_av_1 : A ;
  tribad_nn_1 : N ;
  tribadisk_av_1 : A ;
  tribun_nn_1 : N ;
  tribunal_nn_1 : N ;
  tribunat_nn_1 : N ;
  tribut_nn_1 : N ;
  tricepsmuskel_nn_1 : N ;
  trick_nn_1 : N ;
  trick_nn_2 : N ;
  trickfilm_nn_1 : N ;
  tricks_nn_1 : N ;
  triennal_nn_1 : N ;
  triftong_nn_1 : N ;
  triglyf_nn_1 : N ;
  trigonometrisk_av_1 : A ;
  trikaa_nn_1 : N ;
  trikaavara_nn_1 : N ;
  trikin_nn_1 : N ;
  trikinoes_av_1 : A ;
  trikolor_nn_1 : N ;
  trilateral_av_1 : A ;
  triljon_nn_1 : N ;
  triljondel_nn_1 : N ;
  trilling_nn_1 : N ;
  trillingkristall_nn_1 : N ;
  trillingnerv_nn_1 : N ;
  trillion_nn_1 : N ;
  trilobit_nn_1 : N ;
  trilogi_nn_1 : N ;
  trilsk_av_1 : A ;
  trilskande_av_1 : A ;
  trilsken_av_1 : A ;
  trimeter_nn_1 : N ;
  trimtank_nn_1 : N ;
  trind_av_1 : A ;
  trindbladig_av_1 : A ;
  trindmask_nn_1 : N ;
  trinidadier_nn_1 : N ;
  trinidadisk_av_1 : A ;
  trio_nn_1 : N ;
  triod_nn_1 : N ;
  trioer_nn_1 : N ;
  triol_nn_1 : N ;
  trioxipurin_nn_1 : N ;
  triplett_nn_1 : N ;
  tripod_nn_1 : N ;
  tripp_nn_1 : N ;
  tripp_nn_2 : N ;
  trippel_nn_2 : N ;
  trippelallians_nn_1 : N ;
  trippelkrock_nn_1 : N ;
  trippelpunkt_nn_1 : N ;
  trippelseger_nn_1 : N ;
  trippmaetare_nn_1 : N ;
  trips_nn_1 : N ;
  triptyk_nn_1 : N ;
  trist_av_1 : A ;
  triton_nn_1 : N ;
  triumf_nn_1 : N ;
  triumfator_nn_1 : N ;
  triumfatorisk_av_1 : A ;
  triumfbaage_nn_1 : N ;
  triumvir_nn_1 : N ;
  triumvirat_nn_1 : N ;
  trivial_av_1 : A ;
  trivialitet_nn_1 : N ;
  trivialnamn_nn_1 : N ;
  trivsam_av_1 : A ;
  troeg_av_1 : A ;
  troegbedd_av_1 : A ;
  troegdjur_nn_1 : N ;
  troegflytande_av_1 : A ;
  troeghet_nn_1 : N ;
  troeghetsnavigering_nn_1 : N ;
  troeglaest_av_1 : A ;
  troegtaenkt_av_1 : A ;
  troende_av_1 : A ;
  troeskel_nn_1 : N ;
  troeskelvaerde_nn_1 : N ;
  troeskverk_nn_1 : N ;
  troest_nn_2 : N ;
  troestare_nn_1 : N ;
  troestegrund_nn_1 : N ;
  troesterik_av_1 : A ;
  troestloes_av_1 : A ;
  troestmaal_nn_1 : N ;
  troestnapp_nn_1 : N ;
  troestpris_nn_1 : N ;
  troett_av_1 : A ;
  troetthet_nn_1 : N ;
  troettkoerd_av_1 : A ;
  troettsam_av_1 : A ;
  trofast_av_1 : A ;
  trofasthet_nn_1 : N ;
  trofe_nn_1 : N ;
  trogen_av_1 : A ;
  troglodyt_nn_1 : N ;
  trohet_nn_1 : N ;
  trohetsed_nn_1 : N ;
  trohjaertenhet_nn_1 : N ;
  trojan_nn_1 : N ;
  trojansk_av_1 : A ;
  trojeborg_nn_1 : N ;
  trokaisk_av_1 : A ;
  troke_nn_1 : N ;
  trokeisk_av_1 : A ;
  trolig_av_1 : A ;
  troligen_ab_1 : Adv ;
  troligtvis_ab_1 : Adv ;
  troll_nn_1 : N ;
  trollbaer_nn_1 : N ;
  trollbarn_nn_1 : N ;
  trollbinda_vb_1 : V ;
  trolldeg_nn_1 : N ;
  trolldom_nn_1 : N ;
  trolldomsrit_nn_1 : N ;
  trolldryck_nn_1 : N ;
  trolleri_nn_1 : N ;
  trollerikonst_nn_1 : N ;
  trolleybuss_nn_1 : N ;
  trollformel_nn_1 : N ;
  trollhare_nn_1 : N ;
  trollkaering_nn_1 : N ;
  trollkarl_nn_1 : N ;
  trollkonst_nn_1 : N ;
  trollkonstnaer_nn_1 : N ;
  trollkunnig_av_1 : A ;
  trollsaang_nn_1 : N ;
  trollskott_nn_1 : N ;
  trollslag_nn_1 : N ;
  trollspoe_nn_1 : N ;
  trollstav_nn_1 : N ;
  troloes_av_1 : A ;
  troloeshet_nn_1 : N ;
  trolovning_nn_1 : N ;
  trolovningsbarn_nn_1 : N ;
  trolsk_av_1 : A ;
  troman_nn_1 : N ;
  tromb_nn_1 : N ;
  trombocyt_nn_1 : N ;
  trombon_nn_1 : N ;
  trombonist_nn_1 : N ;
  trombos_nn_1 : N ;
  tromla_nn_1 : N ;
  tron_nn_1 : N ;
  tronarvinge_nn_1 : N ;
  tronavsaegelse_nn_1 : N ;
  tronbestigning_nn_1 : N ;
  tronfoeljare_nn_1 : N ;
  tronfoeljd_nn_1 : N ;
  tronfoeljerska_nn_1 : N ;
  tronhimmel_nn_1 : N ;
  tronpretendent_nn_1 : N ;
  tronsal_nn_1 : N ;
  tronskifte_nn_1 : N ;
  trontal_nn_1 : N ;
  trontilltraede_nn_1 : N ;
  trop_nn_1 : N ;
  tropik_nn_1 : N ;
  tropikfaagel_nn_1 : N ;
  tropikhjaelm_nn_1 : N ;
  tropisk_av_1 : A ;
  tropism_nn_1 : N ;
  troposfaer_nn_1 : N ;
  tropp_nn_1 : N ;
  trosartikel_nn_1 : N ;
  trosbekaennare_nn_1 : N ;
  trosbekaennelse_nn_1 : N ;
  trosfast_av_1 : A ;
  trosfraende_nn_1 : N ;
  trosfrihet_nn_1 : N ;
  trosgoerdel_nn_1 : N ;
  trosivrare_nn_1 : N ;
  troskyldig_av_1 : A ;
  trosroerelse_nn_1 : N ;
  tross_nn_1 : N ;
  trossamfund_nn_1 : N ;
  trossats_nn_1 : N ;
  trossbotten_nn_1 : N ;
  trossdaeck_nn_1 : N ;
  trossfyllning_nn_1 : N ;
  trosslagen_av_1 : A ;
  trossning_nn_1 : N ;
  trosviss_av_1 : A ;
  trotjaenare_nn_1 : N ;
  trotsaalder_nn_1 : N ;
  trotsig_av_1 : A ;
  trotskist_nn_1 : N ;
  trottoar_nn_1 : N ;
  trottoarbonde_nn_1 : N ;
  trottoarservering_nn_1 : N ;
  trovaerd_av_1 : A ;
  trovaerdig_av_1 : A ;
  trubadur_nn_1 : N ;
  trubbel_nn_1 : N ;
  trubbig_av_1 : A ;
  trubbnaest_av_1 : A ;
  trubbnos_nn_1 : N ;
  trubbnosig_av_1 : A ;
  trubbvinklig_av_1 : A ;
  truck_nn_1 : N ;
  trudelutt_nn_1 : N ;
  truism_nn_1 : N ;
  truistisk_av_1 : A ;
  trulig_av_1 : A ;
  truls_nn_1 : N ;
  trulsig_av_1 : A ;
  trumf_nn_1 : N ;
  trumfkort_nn_1 : N ;
  trumfmatt_av_1 : A ;
  trumhinna_nn_1 : N ;
  trumminne_nn_1 : N ;
  trumpen_av_1 : A ;
  trumpet_nn_1 : N ;
  trumpetare_nn_1 : N ;
  trumpetstoet_nn_1 : N ;
  trumpinne_nn_1 : N ;
  trumslagare_nn_1 : N ;
  trumstock_nn_1 : N ;
  trumvirvel_nn_1 : N ;
  trunk_nn_1 : N ;
  trunkmaskin_nn_1 : N ;
  trupp_nn_1 : N ;
  truppfoerband_nn_1 : N ;
  truppfoerflyttning_nn_1 : N ;
  trupproerelse_nn_1 : N ;
  truppslag_nn_1 : N ;
  truppstyrka_nn_1 : N ;
  trust_nn_1 : N ;
  trut_nn_1 : N ;
  tryck_nn_1 : N ;
  tryckaar_nn_1 : N ;
  tryckaccent_nn_1 : N ;
  tryckalster_nn_1 : N ;
  tryckande_av_1 : A ;
  tryckare_nn_1 : N ;
  tryckbar_av_1 : A ;
  tryckbehaallare_nn_1 : N ;
  tryckbokstav_nn_1 : N ;
  tryckbraennare_nn_1 : N ;
  tryckdraekt_nn_1 : N ;
  tryckeri_nn_1 : N ;
  tryckfaerg_nn_1 : N ;
  tryckfel_nn_1 : N ;
  tryckfelsnisse_nn_1 : N ;
  tryckfoerband_nn_1 : N ;
  tryckform_nn_1 : N ;
  tryckfrihet_nn_1 : N ;
  tryckkabin_nn_1 : N ;
  tryckkaerl_nn_1 : N ;
  tryckkammare_nn_1 : N ;
  tryckknapp_nn_1 : N ;
  tryckkokare_nn_1 : N ;
  tryckkontakt_nn_1 : N ;
  tryckluftsapparat_nn_1 : N ;
  tryckmetod_nn_1 : N ;
  tryckning_nn_1 : N ;
  tryckoekning_nn_1 : N ;
  tryckord_nn_1 : N ;
  tryckort_nn_1 : N ;
  tryckpress_nn_1 : N ;
  tryckpunkt_nn_1 : N ;
  trycksaeker_av_1 : A ;
  trycksak_nn_1 : N ;
  trycksats_nn_1 : N ;
  tryckstark_av_1 : A ;
  tryckstil_nn_1 : N ;
  tryckstyrka_nn_1 : N ;
  trycksvag_av_1 : A ;
  tryckt_av_1 : A ;
  trycktyp_nn_1 : N ;
  tryckvattenreaktor_nn_1 : N ;
  tryffel_nn_1 : N ;
  tryffelsvamp_nn_1 : N ;
  trygg_av_1 : A ;
  trygghet_nn_1 : N ;
  trygghetsfoersaekring_nn_1 : N ;
  trygghetsnarkoman_nn_1 : N ;
  trymaa_nn_1 : N ;
  trypsin_nn_1 : N ;
  tsar_nn_1 : N ;
  tsardotter_nn_1 : N ;
  tsarfamilj_nn_1 : N ;
  tub_nn_1 : N ;
  tuberkel_nn_1 : N ;
  tuberkelbakterie_nn_1 : N ;
  tuberkulin_nn_1 : N ;
  tuberkuloes_av_1 : A ;
  tubkanon_nn_1 : N ;
  tubkikare_nn_1 : N ;
  tubroer_nn_1 : N ;
  tudelning_nn_1 : N ;
  tuff_av_1 : A ;
  tuff_nn_1 : N ;
  tuffing_nn_1 : N ;
  tufsig_av_1 : A ;
  tuggbuss_nn_1 : N ;
  tuggmuskel_nn_1 : N ;
  tuggummi_nn_1 : N ;
  tukthus_nn_1 : N ;
  tuktig_av_1 : A ;
  tulkoert_nn_1 : N ;
  tull_nn_1 : N ;
  tullare_nn_1 : N ;
  tullavgift_nn_1 : N ;
  tullbesiktning_nn_1 : N ;
  tulldeklaration_nn_1 : N ;
  tullfri_av_1 : A ;
  tullmur_nn_1 : N ;
  tullnaer_nn_1 : N ;
  tullpass_nn_1 : N ;
  tullpliktig_av_1 : A ;
  tullskydd_nn_1 : N ;
  tulltjaensteman_nn_1 : N ;
  tullunion_nn_1 : N ;
  tullverk_nn_1 : N ;
  tullvisitation_nn_1 : N ;
  tulpan_nn_1 : N ;
  tulpanloek_nn_1 : N ;
  tulpantraed_nn_1 : N ;
  tum_nn_1 : N ;
  tumgrepp_nn_1 : N ;
  tumlare_nn_1 : N ;
  tumme_nn_1 : N ;
  tummelplats_nn_1 : N ;
  tummetott_nn_1 : N ;
  tumoer_nn_1 : N ;
  tumregel_nn_1 : N ;
  tumskruv_nn_1 : N ;
  tumstock_nn_1 : N ;
  tumsugare_nn_1 : N ;
  tumult_nn_1 : N ;
  tumultuarisk_av_1 : A ;
  tumvante_nn_1 : N ;
  tumveck_nn_1 : N ;
  tun_nn_1 : N ;
  tuner_nn_1 : N ;
  tung_av_1 : A ;
  tunga_nn_1 : N ;
  tungband_nn_1 : N ;
  tungben_nn_1 : N ;
  tungkoerd_av_1 : A ;
  tunglaest_av_1 : A ;
  tungljud_nn_1 : N ;
  tungmetall_nn_1 : N ;
  tungoert_nn_1 : N ;
  tungomaal_nn_1 : N ;
  tungomaalstalande_av_1 : A ;
  tungomaalstalare_nn_1 : N ;
  tungrodd_av_1 : A ;
  tungrygg_nn_1 : N ;
  tungsam_av_1 : A ;
  tungsida_nn_1 : N ;
  tungsint_av_1 : A ;
  tungsinthet_nn_1 : N ;
  tungsoevd_av_1 : A ;
  tungspene_nn_1 : N ;
  tungspets_nn_1 : N ;
  tungus_nn_1 : N ;
  tungvattenreaktor_nn_1 : N ;
  tungviktare_nn_1 : N ;
  tunik_nn_1 : N ;
  tunisier_nn_1 : N ;
  tunisisk_av_1 : A ;
  tunisiska_nn_1 : N ;
  tunn_av_1 : A ;
  tunnband_nn_1 : N ;
  tunnbindare_nn_1 : N ;
  tunnbinderi_nn_1 : N ;
  tunnbladig_av_1 : A ;
  tunnbroed_nn_1 : N ;
  tunnel_nn_1 : N ;
  tunneldiod_nn_1 : N ;
  tunneleffekt_nn_1 : N ;
  tunnelugn_nn_1 : N ;
  tunnhaarig_av_1 : A ;
  tunnklaedd_av_1 : A ;
  tunnland_nn_1 : N ;
  tunnsaadd_av_1 : A ;
  tunnsliten_av_1 : A ;
  tunnstav_nn_1 : N ;
  tunntarm_nn_1 : N ;
  tunnvalv_nn_1 : N ;
  tupe_nn_1 : N ;
  tupp_nn_1 : N ;
  tuppfaektning_nn_1 : N ;
  tuppfjaet_nn_1 : N ;
  tuppkam_nn_1 : N ;
  tuppkyckling_nn_1 : N ;
  tupplur_nn_1 : N ;
  tur_nn_1 : N ;
  turban_nn_1 : N ;
  turbin_nn_1 : N ;
  turbinmotor_nn_1 : N ;
  turbojetmotor_nn_1 : N ;
  turbojetplan_nn_1 : N ;
  turbomotor_nn_1 : N ;
  turbopropmotor_nn_1 : N ;
  turbulent_av_1 : A ;
  turist_nn_1 : N ;
  turistbroschyr_nn_1 : N ;
  turistbyraa_nn_1 : N ;
  turistfoerening_nn_1 : N ;
  turistinformation_nn_1 : N ;
  turistisk_av_1 : A ;
  turistklass_nn_1 : N ;
  turistland_nn_1 : N ;
  turistnaering_nn_1 : N ;
  turistsaeng_nn_1 : N ;
  turiststation_nn_1 : N ;
  turiststroem_nn_1 : N ;
  turiststuga_nn_1 : N ;
  turistvaluta_nn_1 : N ;
  turk_nn_1 : N ;
  turkcypriot_nn_1 : N ;
  turkfolk_nn_1 : N ;
  turkisk_av_1 : A ;
  turkiska_nn_2 : N ;
  turkmen_nn_1 : N ;
  turkos_av_1 : A ;
  turkos_nn_1 : N ;
  turkosblaa_av_1 : A ;
  turlig_av_1 : A ;
  turmalin_nn_1 : N ;
  turne_nn_1 : N ;
  turnering_nn_1 : N ;
  turnyr_nn_1 : N ;
  turochreturbiljett_nn_1 : N ;
  turordning_nn_1 : N ;
  turs_nn_1 : N ;
  tursam_av_1 : A ;
  tuschteckning_nn_1 : N ;
  tusenaarig_av_1 : A ;
  tusenaarsrike_nn_1 : N ;
  tusende_nn_1 : N ;
  tusendel_nn_1 : N ;
  tusenfalt_ab_1 : Adv ;
  tusenfoting_nn_1 : N ;
  tusenkonstnaer_nn_1 : N ;
  tusenkronorssedel_nn_1 : N ;
  tusenlapp_nn_1 : N ;
  tusental_nn_1 : N ;
  tusentals_ab_1 : Adv ;
  tuss_nn_1 : N ;
  tussilago_nn_1 : N ;
  tut_nn_1 : N ;
  tut_nn_2 : N ;
  tuting_nn_1 : N ;
  tutt_nn_1 : N ;
  tutti_nn_1 : N ;
  tuvaluan_nn_1 : N ;
  tuvig_av_1 : A ;
  tuvtaatel_nn_1 : N ;
  tvaaaarig_av_1 : A ;
  tvaaaaring_nn_1 : N ;
  tvaaaeggstvilling_nn_1 : N ;
  tvaabent_av_1 : A ;
  tvaablad_nn_1 : N ;
  tvaabyggare_nn_1 : N ;
  tvaacylindrig_av_1 : A ;
  tvaadimensionell_av_1 : A ;
  tvaaendel_nn_1 : N ;
  tvaafamiljshus_nn_1 : N ;
  tvaaformig_av_1 : A ;
  tvaafrontskrig_nn_1 : N ;
  tvaahaendig_av_1 : A ;
  tvaahjaertbladig_av_1 : A ;
  tvaahjuling_nn_1 : N ;
  tvaal_nn_1 : N ;
  tvaalaeppig_av_1 : A ;
  tvaalask_nn_1 : N ;
  tvaalfager_av_1 : A ;
  tvaalig_av_1 : A ;
  tvaalkopp_nn_1 : N ;
  tvaalopera_nn_1 : N ;
  tvaamaenning_nn_1 : N ;
  tvaamans_av_1 : A ;
  tvaamastare_nn_1 : N ;
  tvaangsaatgaerd_nn_1 : N ;
  tvaangsfoerestaellning_nn_1 : N ;
  tvaangsintagning_nn_1 : N ;
  tvaangslaege_nn_1 : N ;
  tvaangslag_nn_1 : N ;
  tvaangsmaessig_av_1 : A ;
  tvaangsmedel_nn_1 : N ;
  tvaangsneuros_nn_1 : N ;
  tvaangsrekrytering_nn_1 : N ;
  tvaangssituation_nn_1 : N ;
  tvaangstanke_nn_1 : N ;
  tvaangstroeja_nn_1 : N ;
  tvaangsvis_ab_1 : Adv ;
  tvaaoering_nn_1 : N ;
  tvaaondel_nn_1 : N ;
  tvaarading_nn_1 : N ;
  tvaarummare_nn_1 : N ;
  tvaarumslaegenhet_nn_1 : N ;
  tvaasamhet_nn_1 : N ;
  tvaasiffrig_av_1 : A ;
  tvaaspaend_av_1 : A ;
  tvaaspann_nn_1 : N ;
  tvaaspraakig_av_1 : A ;
  tvaastavig_av_1 : A ;
  tvaastavighetsaccent_nn_1 : N ;
  tvaastruken_av_1 : A ;
  tvaataktare_nn_1 : N ;
  tvaataktsmotor_nn_1 : N ;
  tvaavaaningsbuss_nn_1 : N ;
  tvaavinge_nn_1 : N ;
  tvaer_av_1 : A ;
  tvaerarg_av_1 : A ;
  tvaeraxel_nn_1 : N ;
  tvaerbalk_nn_1 : N ;
  tvaerbjaelke_nn_1 : N ;
  tvaerbrant_av_1 : A ;
  tvaerfacklig_av_1 : A ;
  tvaerfloejt_nn_1 : N ;
  tvaergaaende_av_1 : A ;
  tvaerhuggen_av_1 : A ;
  tvaerilsken_av_1 : A ;
  tvaermaett_av_1 : A ;
  tvaernit_nn_1 : N ;
  tvaerpolitisk_av_1 : A ;
  tvaerrandig_av_1 : A ;
  tvaers_ab_1 : Adv ;
  tvaersaeker_av_1 : A ;
  tvaersemot_ab_1 : Adv ;
  tvaersigenom_ab_1 : Adv ;
  tvaerskepp_nn_1 : N ;
  tvaerskepps_ab_1 : Adv ;
  tvaerskuren_av_1 : A ;
  tvaerslaa_nn_1 : N ;
  tvaersnitt_nn_1 : N ;
  tvaersoever_ab_1 : Adv ;
  tvaersom_ab_1 : Adv ;
  tvaerstopp_nn_1 : N ;
  tvaerstreck_nn_1 : N ;
  tvaerstup_nn_1 : N ;
  tvaertemot_ab_1 : Adv ;
  tvaertom_ab_1 : Adv ;
  tvaervetenskap_nn_1 : N ;
  tvaervetenskaplig_av_1 : A ;
  tvaervigg_nn_1 : N ;
  tvaett_nn_1 : N ;
  tvaettaekta_av_1 : A ;
  tvaettbar_av_1 : A ;
  tvaettbar_nn_1 : N ;
  tvaettbjoern_nn_1 : N ;
  tvaettbraede_nn_1 : N ;
  tvaetteri_nn_1 : N ;
  tvaettfat_nn_1 : N ;
  tvaettinraettning_nn_1 : N ;
  tvaettkorg_nn_1 : N ;
  tvaettlapp_nn_1 : N ;
  tvaettmaskin_nn_1 : N ;
  tvaettmedel_nn_1 : N ;
  tvaettomat_nn_1 : N ;
  tvaettpulver_nn_1 : N ;
  tvaettstaell_nn_1 : N ;
  tvaettstuga_nn_1 : N ;
  tvaettsvamp_nn_1 : N ;
  tvaettvatten_nn_1 : N ;
  tvagning_nn_1 : N ;
  tvehaagsen_av_1 : A ;
  tvekamp_nn_1 : N ;
  tvekloes_av_1 : A ;
  tveksam_av_1 : A ;
  tveksamhet_nn_1 : N ;
  tvestjaert_nn_1 : N ;
  tvetydig_av_1 : A ;
  tvetydighet_nn_1 : N ;
  tvilling_nn_1 : N ;
  tvillingkristall_nn_1 : N ;
  tvillingmaskin_nn_1 : N ;
  tvillingvagn_nn_1 : N ;
  tving_nn_1 : N ;
  tvinga_vb_1 : V ;
  tvingande_av_1 : A ;
  tvinsjuk_av_1 : A ;
  tvist_nn_1 : N ;
  tvistefraaga_nn_1 : N ;
  tvistefroe_nn_1 : N ;
  tvistemaal_nn_1 : N ;
  tvistig_av_1 : A ;
  tvistighet_nn_1 : N ;
  tvistsoem_nn_1 : N ;
  tvivel_nn_1 : N ;
  tvivelaktig_av_1 : A ;
  tvivelsam_av_1 : A ;
  tvivelsjuk_av_1 : A ;
  tvivelsutan_ab_1 : Adv ;
  tvivlare_nn_1 : N ;
  tvungen_av_1 : A ;
  tyckare_nn_1 : N ;
  tyckmycken_av_1 : A ;
  tydbar_av_1 : A ;
  tydlig_av_1 : A ;
  tydligen_ab_1 : Adv ;
  tydlighet_nn_1 : N ;
  tydligtvis_ab_1 : Adv ;
  tyfoidbakterie_nn_1 : N ;
  tyfoidepidemi_nn_1 : N ;
  tyfon_nn_1 : N ;
  tyg_nn_1 : N ;
  tygband_nn_1 : N ;
  tygbredd_nn_1 : N ;
  tygel_nn_1 : N ;
  tygelloes_av_1 : A ;
  tygkant_nn_1 : N ;
  tyglapp_nn_1 : N ;
  tygprov_nn_1 : N ;
  tygrest_nn_1 : N ;
  tygrulle_nn_1 : N ;
  tygsko_nn_1 : N ;
  tygtryck_nn_1 : N ;
  tyken_av_1 : A ;
  tykobrahedag_nn_1 : N ;
  tyllschal_nn_1 : N ;
  tympanon_nn_1 : N ;
  tyngd_nn_1 : N ;
  tyngdkraftsstoerning_nn_1 : N ;
  tyngdloes_av_1 : A ;
  tyngdlyftare_nn_1 : N ;
  tyngdpunkt_nn_1 : N ;
  typ_ab_1 : Adv ;
  typ_nn_1 : N ;
  typbesiktning_nn_1 : N ;
  typbildande_av_1 : A ;
  typexempel_nn_1 : N ;
  typfall_nn_1 : N ;
  typisk_av_1 : A ;
  typograf_nn_1 : N ;
  typografi_nn_1 : N ;
  typografisk_av_1 : A ;
  typologi_nn_1 : N ;
  typsnitt_nn_1 : N ;
  typvaerde_nn_1 : N ;
  tyrann_nn_1 : N ;
  tyrannisk_av_1 : A ;
  tyristor_nn_1 : N ;
  tyrolare_nn_1 : N ;
  tyrolerhatt_nn_1 : N ;
  tyrolsk_av_1 : A ;
  tyrolska_nn_1 : N ;
  tysk_av_1 : A ;
  tysk_nn_1 : N ;
  tysk_romersk_av_1 : A ;
  tysk_schweizisk_av_1 : A ;
  tysk_svensk_av_1 : A ;
  tyska_nn_2 : N ;
  tyskhare_nn_1 : N ;
  tyskspraakig_av_1 : A ;
  tyst_av_1 : A ;
  tysthet_nn_1 : N ;
  tysthetsloefte_nn_1 : N ;
  tystlaaten_av_1 : A ;
  tystnad_nn_1 : N ;
  tyvaerr_ab_1 : Adv ;
  u_baat_nn_1 : N ;
  u_formig_av_1 : A ;
  u_land_nn_1 : N ;
  ubaat_nn_1 : N ;
  ubaatsfoerstoerare_nn_1 : N ;
  ubaatsjagare_nn_1 : N ;
  ubaatsjakt_nn_1 : N ;
  ubaatsjaktfartyg_nn_1 : N ;
  ubaatsnaet_nn_1 : N ;
  ubikvist_nn_1 : N ;
  ubikvitet_nn_1 : N ;
  udd_nn_1 : N ;
  udda_av_1 : A ;
  uddamaal_nn_1 : N ;
  uddanummer_nn_1 : N ;
  uddaplagg_nn_1 : N ;
  uddataaig_av_1 : A ;
  uddatalsmetod_nn_1 : N ;
  uddblad_nn_1 : N ;
  udde_nn_1 : N ;
  uddig_av_1 : A ;
  uddjaern_nn_1 : N ;
  uddljud_nn_1 : N ;
  uddloes_av_1 : A ;
  uddrim_nn_1 : N ;
  ufo_nn_1 : N ;
  ugandier_nn_1 : N ;
  ugandisk_av_1 : A ;
  uggla_nn_1 : N ;
  uggleboll_nn_1 : N ;
  ugn_nn_1 : N ;
  ugnseldfast_av_1 : A ;
  ugnsinfodring_nn_1 : N ;
  ugnskol_nn_1 : N ;
  ugnskolning_nn_1 : N ;
  ugnsomelett_nn_1 : N ;
  ugnsplaat_nn_1 : N ;
  ugnsspade_nn_1 : N ;
  ugnstegel_nn_1 : N ;
  ugnsvarm_av_1 : A ;
  ukas_nn_1 : N ;
  ukrainare_nn_1 : N ;
  ukulele_nn_1 : N ;
  ulan_nn_1 : N ;
  ulceroes_av_1 : A ;
  ulk_nn_1 : N ;
  ullhaarig_av_1 : A ;
  ullig_av_1 : A ;
  ulliknande_av_1 : A ;
  ulloert_nn_1 : N ;
  ullolja_nn_1 : N ;
  ullsax_nn_1 : N ;
  ullsida_nn_1 : N ;
  ulltork_nn_1 : N ;
  ulltott_nn_1 : N ;
  ullus_nn_1 : N ;
  ulster_nn_1 : N ;
  ultima_nn_1 : N ;
  ultimativ_av_1 : A ;
  ultimatum_nn_1 : N ;
  ultimo_ab_1 : Adv ;
  ultimoaffaer_nn_1 : N ;
  ultra_nn_1 : N ;
  ultracentrifug_nn_1 : N ;
  ultrakonservativ_av_1 : A ;
  ultraljud_nn_1 : N ;
  ultramarin_av_1 : A ;
  ultramontan_av_1 : A ;
  ultrarapidfotografering_nn_1 : N ;
  ultraroed_av_1 : A ;
  ultrasnabb_av_1 : A ;
  ultraviolett_av_1 : A ;
  ulv_nn_1 : N ;
  umbaerande_nn_1 : N ;
  umbaerlig_av_1 : A ;
  umbellat_nn_1 : N ;
  umgaenge_nn_1 : N ;
  umgaengelse_nn_1 : N ;
  umgaengesform_nn_1 : N ;
  umgaengeskrets_nn_1 : N ;
  umgaengesnorm_nn_1 : N ;
  uncial_nn_1 : N ;
  undan_ab_1 : Adv ;
  undanbe_vb_1 : V ;
  undandra_vb_1 : V ;
  undanflykt_nn_1 : N ;
  undangjord_av_1 : A ;
  undanglidande_av_1 : A ;
  undangoemd_av_1 : A ;
  undanhaalla_vb_1 : V ;
  undanhaallande_nn_1 : N ;
  undanlaeggning_nn_1 : N ;
  undanlagd_av_1 : A ;
  undanmanoever_nn_1 : N ;
  undanskymd_av_1 : A ;
  undansticka_vb_1 : V ;
  undanta_vb_1 : V ;
  undantag_nn_1 : N ;
  undantagsbestaemmelse_nn_1 : N ;
  undantagsfall_nn_1 : N ;
  undantagsfri_av_1 : A ;
  undantagslag_nn_1 : N ;
  undantagsloes_av_1 : A ;
  undantagsmaenniska_nn_1 : N ;
  undantagsraett_nn_1 : N ;
  undantagstillstaand_nn_1 : N ;
  undantagsvis_ab_1 : Adv ;
  undanvindsvaendning_nn_1 : N ;
  under_ab_1 : Adv ;
  under_nn_1 : N ;
  underaarig_av_1 : A ;
  underarm_nn_1 : N ;
  underart_nn_1 : N ;
  underavdelning_nn_1 : N ;
  underbaedd_nn_1 : N ;
  underbar_av_1 : A ;
  underbarn_nn_1 : N ;
  underbefael_nn_1 : N ;
  underben_nn_1 : N ;
  underbestaand_nn_1 : N ;
  underbett_nn_1 : N ;
  underbetyg_nn_1 : N ;
  underbinda_vb_1 : V ;
  underbjuda_vb_1 : V ;
  underbud_nn_1 : N ;
  underbyggnad_nn_1 : N ;
  underdaanig_av_1 : A ;
  underdaanighet_nn_1 : N ;
  underdaeck_nn_1 : N ;
  underdel_nn_1 : N ;
  underdomstol_nn_1 : N ;
  underdrift_nn_1 : N ;
  underdriva_vb_1 : V ;
  underemission_nn_1 : N ;
  underfall_nn_1 : N ;
  underfamilj_nn_1 : N ;
  underfart_nn_1 : N ;
  underfoersoerjd_av_1 : A ;
  underfull_av_1 : A ;
  underfund_ab_1 : Adv ;
  underfundig_av_1 : A ;
  undergaa_vb_1 : V ;
  undergaang_nn_1 : N ;
  undergardin_nn_1 : N ;
  undergiven_av_1 : A ;
  undergoerande_av_1 : A ;
  undergoerare_nn_1 : N ;
  undergrund_nn_1 : N ;
  underhaall_nn_1 : N ;
  underhaalla_vb_1 : V ;
  underhaallande_av_1 : A ;
  underhaallare_nn_1 : N ;
  underhaallning_nn_1 : N ;
  underhaallningsorkester_nn_1 : N ;
  underhaallsbidrag_nn_1 : N ;
  underhaallsfoerband_nn_1 : N ;
  underhaallsfri_av_1 : A ;
  underhaallstjaenst_nn_1 : N ;
  underhaallstrupp_nn_1 : N ;
  underhaerdig_av_1 : A ;
  underhaltig_av_1 : A ;
  underhandling_nn_1 : N ;
  underhandsackord_nn_1 : N ;
  underhandskontakt_nn_1 : N ;
  underhavande_nn_1 : N ;
  underhuggare_nn_1 : N ;
  underhus_nn_1 : N ;
  underhypotek_nn_1 : N ;
  underifraan_ab_1 : Adv ;
  underingenjoer_nn_1 : N ;
  underinstans_nn_1 : N ;
  underjordisk_av_1 : A ;
  underjordsprov_nn_1 : N ;
  underkaeke_nn_1 : N ;
  underkaend_av_1 : A ;
  underkant_nn_1 : N ;
  underkjol_nn_1 : N ;
  underklaenning_nn_1 : N ;
  underklassare_nn_1 : N ;
  underklassig_av_1 : A ;
  underkropp_nn_1 : N ;
  underkunnig_av_1 : A ;
  underkurs_nn_1 : N ;
  underkyld_av_1 : A ;
  underlaata_vb_1 : V ;
  underlaatelse_nn_1 : N ;
  underlaatenhet_nn_1 : N ;
  underlaatenhetssynd_nn_1 : N ;
  underlaegg_nn_1 : N ;
  underlaegsen_av_1 : A ;
  underlaegsenhet_nn_1 : N ;
  underlaekare_nn_1 : N ;
  underlag_nn_1 : N ;
  underlakan_nn_1 : N ;
  underledare_nn_1 : N ;
  underleverantoer_nn_1 : N ;
  underlig_av_1 : A ;
  underliggande_av_1 : A ;
  underliv_nn_1 : N ;
  underljudsfart_nn_1 : N ;
  underljudshastighet_nn_1 : N ;
  underlydande_av_1 : A ;
  undermaalig_av_1 : A ;
  undermaalning_nn_1 : N ;
  undermaensklig_av_1 : A ;
  undermast_nn_1 : N ;
  undermedveten_av_1 : A ;
  undermening_nn_1 : N ;
  undernaerd_av_1 : A ;
  underofficer_nn_1 : N ;
  underordnande_av_1 : A ;
  underordning_nn_1 : N ;
  underpant_nn_1 : N ;
  underplagg_nn_1 : N ;
  underpris_nn_1 : N ;
  underraa_nn_1 : N ;
  underraett_nn_1 : N ;
  underraettelse_nn_1 : N ;
  underraettelseofficer_nn_1 : N ;
  underredsbehandling_nn_1 : N ;
  underrubrik_nn_1 : N ;
  undersaate_nn_1 : N ;
  undersaatlig_av_1 : A ;
  undersaetsig_av_1 : A ;
  undersam_av_1 : A ;
  undersats_nn_1 : N ;
  undersegel_nn_1 : N ;
  undersida_nn_1 : N ;
  underskaap_nn_1 : N ;
  underskattning_nn_1 : N ;
  underskoen_av_1 : A ;
  underskoeterska_nn_1 : N ;
  underskott_nn_1 : N ;
  underskottsavdrag_nn_1 : N ;
  underskrida_vb_1 : V ;
  underskrift_nn_1 : N ;
  underslag_nn_1 : N ;
  underslev_nn_1 : N ;
  undersoekare_nn_1 : N ;
  undersoekning_nn_1 : N ;
  undersoekningsdomare_nn_1 : N ;
  undersoekningsfaange_nn_1 : N ;
  undersoekningsmetod_nn_1 : N ;
  undersoekningsrum_nn_1 : N ;
  understaaende_av_1 : A ;
  understaellning_nn_1 : N ;
  understaemma_nn_1 : N ;
  understag_nn_1 : N ;
  understatement_nn_1 : N ;
  understicka_vb_1 : V ;
  understiga_vb_1 : V ;
  understoedsfoerening_nn_1 : N ;
  understoedskassa_nn_1 : N ;
  understoedsnaemnd_nn_1 : N ;
  understoet_nn_1 : N ;
  understreckare_nn_1 : N ;
  understroem_nn_1 : N ;
  understryka_vb_1 : V ;
  understrykning_nn_1 : N ;
  understucken_av_1 : A ;
  understundom_ab_1 : Adv ;
  understyrd_av_1 : A ;
  undersysselsatt_av_1 : A ;
  undertak_nn_1 : N ;
  undertalig_av_1 : A ;
  undertecknare_nn_1 : N ;
  underterm_nn_1 : N ;
  undertill_ab_1 : Adv ;
  undertitel_nn_1 : N ;
  underton_nn_1 : N ;
  undertraad_nn_1 : N ;
  undertroeja_nn_1 : N ;
  undervaaning_nn_1 : N ;
  undervaegs_ab_1 : Adv ;
  undervattensbaat_nn_1 : N ;
  undervattensboelja_nn_1 : N ;
  undervattensfoerbindelse_nn_1 : N ;
  undervattenskropp_nn_1 : N ;
  undervattenstroeskel_nn_1 : N ;
  underverk_nn_1 : N ;
  underviktig_av_1 : A ;
  undervisare_nn_1 : N ;
  undervisningsaemne_nn_1 : N ;
  undervisningsmaterial_nn_1 : N ;
  undervisningspaket_nn_1 : N ;
  undervisningsraad_nn_1 : N ;
  undervisningssjukhus_nn_1 : N ;
  undervisningsskicklighet_nn_1 : N ;
  undervisningsskyldighet_nn_1 : N ;
  undervisningsspraak_nn_1 : N ;
  undervisningsteknologi_nn_1 : N ;
  undervisningstimme_nn_1 : N ;
  undfaegnad_nn_1 : N ;
  undfallande_av_1 : A ;
  undfallen_av_1 : A ;
  undfallenhet_nn_1 : N ;
  undin_nn_1 : N ;
  undran_nn_1 : N ;
  undrande_av_1 : A ;
  undransvaerd_av_1 : A ;
  undring_nn_1 : N ;
  undsaettningsfond_nn_1 : N ;
  undskyllning_nn_1 : N ;
  undulat_nn_1 : N ;
  undulation_nn_1 : N ;
  undulatorisk_av_1 : A ;
  undvika_vb_1 : V ;
  undvikande_av_1 : A ;
  ung_av_1 : A ;
  ungdjur_nn_1 : N ;
  ungdom_nn_1 : N ;
  ungdomlig_av_1 : A ;
  ungdomsaar_nn_1 : N ;
  ungdomsanstalt_nn_1 : N ;
  ungdomsarbetsloeshet_nn_1 : N ;
  ungdomsbok_nn_1 : N ;
  ungdomsbrottslighet_nn_1 : N ;
  ungdomsbrottsling_nn_1 : N ;
  ungdomsfaengelse_nn_1 : N ;
  ungdomsfoerbund_nn_1 : N ;
  ungdomsfoermedling_nn_1 : N ;
  ungdomsgaard_nn_1 : N ;
  ungdomsgrupp_nn_1 : N ;
  ungdomshem_nn_1 : N ;
  ungdomskaerlek_nn_1 : N ;
  ungdomskonsulent_nn_1 : N ;
  ungdomskultur_nn_1 : N ;
  ungdomsledare_nn_1 : N ;
  ungdomsorganisation_nn_1 : N ;
  ungdomsraad_nn_1 : N ;
  ungdomsroerelse_nn_1 : N ;
  ungdomssvaermeri_nn_1 : N ;
  ungdomssynd_nn_1 : N ;
  ungdomstid_nn_1 : N ;
  ungdomsvaeljare_nn_1 : N ;
  ungdomsvaen_nn_1 : N ;
  ungdomsverk_nn_1 : N ;
  ungdomsverksamhet_nn_1 : N ;
  unge_nn_1 : N ;
  ungefaer_ab_1 : Adv ;
  ungefaerlig_av_1 : A ;
  ungefaerligen_ab_1 : Adv ;
  ungersk_av_1 : A ;
  ungerska_nn_2 : N ;
  ungersven_nn_1 : N ;
  ungflicksaktig_av_1 : A ;
  unghaest_nn_1 : N ;
  ungherre_nn_1 : N ;
  ungkarl_nn_1 : N ;
  ungkarlshotell_nn_1 : N ;
  ungkarlsvana_nn_1 : N ;
  ungkyrklig_av_1 : A ;
  ungmoe_nn_1 : N ;
  ungmor_nn_1 : N ;
  ungnoet_nn_1 : N ;
  ungrare_nn_1 : N ;
  ungskog_nn_1 : N ;
  ungsocialism_nn_1 : N ;
  ungstadium_nn_1 : N ;
  ungsvensk_av_1 : A ;
  ungsvensk_nn_1 : N ;
  ungtall_nn_1 : N ;
  ungtupp_nn_1 : N ;
  ungturk_nn_1 : N ;
  uniform_av_1 : A ;
  uniform_nn_1 : N ;
  uniformering_nn_1 : N ;
  uniformitet_nn_1 : N ;
  uniformshatt_nn_1 : N ;
  uniformsrock_nn_1 : N ;
  uniformstecken_nn_1 : N ;
  unik_av_1 : A ;
  unikabox_nn_1 : N ;
  unikat_nn_1 : N ;
  unikum_nn_1 : N ;
  unilateral_av_1 : A ;
  union_nn_1 : N ;
  unionell_av_1 : A ;
  unionsbrott_nn_1 : N ;
  unisex_av_1 : A ;
  unison_av_1 : A ;
  unitarie_nn_1 : N ;
  unitarisk_av_1 : A ;
  unitarist_nn_1 : N ;
  universalarvinge_nn_1 : N ;
  universalbegaavning_nn_1 : N ;
  universalbegrepp_nn_1 : N ;
  universalborr_nn_1 : N ;
  universalist_nn_1 : N ;
  universalistisk_av_1 : A ;
  universalitet_nn_1 : N ;
  universalkniv_nn_1 : N ;
  universalknut_nn_1 : N ;
  universalmedel_nn_1 : N ;
  universell_av_1 : A ;
  universitet_nn_1 : N ;
  universitetsadjunkt_nn_1 : N ;
  universitetsaemne_nn_1 : N ;
  universitetsbibliotek_nn_1 : N ;
  universitetsbokhandel_nn_1 : N ;
  universitetsfilial_nn_1 : N ;
  universitetsinstitution_nn_1 : N ;
  universitetskansler_nn_1 : N ;
  universitetslektor_nn_1 : N ;
  universitetsmatrikel_nn_1 : N ;
  universitetsrektor_nn_1 : N ;
  universitetssjukhus_nn_1 : N ;
  universitetsstad_nn_1 : N ;
  universitetsstuderande_nn_1 : N ;
  universum_nn_1 : N ;
  unken_av_1 : A ;
  uns_nn_1 : N ;
  up_to_date_av_1 : A ;
  upp_ab_1 : Adv ;
  uppaat_ab_1 : Adv ;
  uppaat_av_1 : A ;
  uppaatgaaende_av_1 : A ;
  uppaatstigande_av_1 : A ;
  uppaatstraevande_av_1 : A ;
  uppaatstraevare_nn_1 : N ;
  uppaeta_vb_1 : V ;
  uppassare_nn_1 : N ;
  uppassningsstaelle_nn_1 : N ;
  uppbaad_nn_1 : N ;
  uppbackare_nn_1 : N ;
  uppbackning_nn_1 : N ;
  uppbaera_vb_1 : V ;
  uppbindning_nn_1 : N ;
  uppbjuda_vb_1 : V ;
  uppblaasning_nn_1 : N ;
  uppblaasningsfas_nn_1 : N ;
  uppblaast_av_1 : A ;
  uppbloett_av_1 : A ;
  uppblossande_av_1 : A ;
  uppboerd_nn_1 : N ;
  uppboerdsaar_nn_1 : N ;
  uppboerdsbok_nn_1 : N ;
  uppboerdsdag_nn_1 : N ;
  uppboerdslaengd_nn_1 : N ;
  uppboerdsman_nn_1 : N ;
  uppboerdstermin_nn_1 : N ;
  uppbragt_av_1 : A ;
  uppbrott_nn_1 : N ;
  uppbrottssignal_nn_1 : N ;
  uppbud_nn_1 : N ;
  uppbunden_av_1 : A ;
  uppburen_av_1 : A ;
  uppbyggelsemoete_nn_1 : N ;
  uppbygglig_av_1 : A ;
  uppbyggnad_nn_1 : N ;
  uppdaemd_av_1 : A ;
  uppdelning_nn_1 : N ;
  uppdra_vb_1 : V ;
  uppdrag_nn_1 : N ;
  uppdragsgivare_nn_1 : N ;
  uppdragstagare_nn_1 : N ;
  uppdriva_vb_1 : V ;
  uppdriven_av_1 : A ;
  uppdukning_nn_1 : N ;
  uppe_ab_1 : Adv ;
  uppehaall_nn_1 : N ;
  uppehaalla_vb_1 : V ;
  uppehaallsort_nn_1 : N ;
  uppehaallstillstaand_nn_1 : N ;
  uppemot_ab_1 : Adv ;
  uppenbar_av_1 : A ;
  uppenbarelse_nn_1 : N ;
  uppenbarelsereligion_nn_1 : N ;
  uppenbarligen_ab_1 : Adv ;
  uppercut_nn_1 : N ;
  uppesittare_nn_1 : N ;
  uppesittarkvaell_nn_1 : N ;
  uppfaellbar_av_1 : A ;
  uppfart_nn_1 : N ;
  uppfartsramp_nn_1 : N ;
  uppfattning_nn_1 : N ;
  uppfinna_vb_1 : V ;
  uppfinnare_nn_1 : N ;
  uppfinning_nn_1 : N ;
  uppfinningsrik_av_1 : A ;
  uppflaag_nn_1 : N ;
  uppflammande_av_1 : A ;
  uppflog_nn_1 : N ;
  uppflugen_av_1 : A ;
  uppfoedare_nn_1 : N ;
  uppfoeljning_nn_1 : N ;
  uppfoer_ab_1 : Adv ;
  uppfoerande_nn_1 : N ;
  uppfoersbacke_nn_1 : N ;
  uppfordring_nn_1 : N ;
  uppfostrare_nn_1 : N ;
  uppfostring_nn_1 : N ;
  uppfostringsanstalt_nn_1 : N ;
  uppfostringshem_nn_1 : N ;
  uppfriskande_av_1 : A ;
  uppgaa_vb_1 : V ;
  uppgaang_nn_1 : N ;
  uppgaeld_nn_1 : N ;
  uppge_vb_1 : V ;
  uppgift_nn_1 : N ;
  uppgiven_av_1 : A ;
  uppgivenhet_nn_1 : N ;
  uppgjord_av_1 : A ;
  uppgoerelse_nn_1 : N ;
  uppgrundning_nn_1 : N ;
  upphaemtning_nn_1 : N ;
  upphaengning_nn_1 : N ;
  upphalare_nn_1 : N ;
  upphalningsbaedd_nn_1 : N ;
  upphandlare_nn_1 : N ;
  upphandling_nn_1 : N ;
  upphettning_nn_1 : N ;
  upphinnelig_av_1 : A ;
  upphoejd_av_1 : A ;
  upphoejdhet_nn_1 : N ;
  upphoejelse_nn_1 : N ;
  upphoejning_nn_1 : N ;
  upphopp_nn_1 : N ;
  upphostning_nn_1 : N ;
  upphovsman_nn_1 : N ;
  uppifraan_ab_1 : Adv ;
  uppiggande_av_1 : A ;
  uppkaeftig_av_1 : A ;
  uppkast_nn_1 : N ;
  uppkastning_nn_1 : N ;
  uppklaedd_av_1 : A ;
  uppklippt_av_1 : A ;
  uppknaeppt_av_1 : A ;
  uppknuten_av_1 : A ;
  uppkoep_nn_1 : N ;
  uppkoepare_nn_1 : N ;
  uppkoerd_av_1 : A ;
  uppkoerning_nn_1 : N ;
  uppkoersvaeg_nn_1 : N ;
  uppkok_nn_1 : N ;
  uppkolning_nn_1 : N ;
  uppkomling_nn_1 : N ;
  uppkomma_vb_1 : V ;
  upplaaning_nn_1 : N ;
  upplaata_vb_1 : V ;
  upplaatelse_nn_1 : N ;
  upplaegg_nn_1 : N ;
  upplaeggning_nn_1 : N ;
  upplaendsk_av_1 : A ;
  upplaenning_nn_1 : N ;
  upplaesare_nn_1 : N ;
  upplaesning_nn_1 : N ;
  upplag_nn_1 : N ;
  upplaga_nn_1 : N ;
  upplagd_av_1 : A ;
  upplagesiffra_nn_1 : N ;
  upplagringsplats_nn_1 : N ;
  upplagscell_nn_1 : N ;
  upplagsplats_nn_1 : N ;
  uppland_nn_1 : N ;
  upplevelse_nn_1 : N ;
  upplivande_nn_1 : N ;
  upplivningsfoersoek_nn_1 : N ;
  upploesning_nn_1 : N ;
  upploesningsmedel_nn_1 : N ;
  upplopp_nn_1 : N ;
  uppluckring_nn_1 : N ;
  upplupen_av_1 : A ;
  upplyftande_av_1 : A ;
  upplysning_nn_1 : N ;
  upplysningsfilosofi_nn_1 : N ;
  upplysningsvis_ab_1 : Adv ;
  upplyst_av_1 : A ;
  uppmaerksam_av_1 : A ;
  uppmaerksamhet_nn_1 : N ;
  uppmaerksamhetsfaelt_nn_1 : N ;
  uppmaning_nn_1 : N ;
  uppmaningssats_nn_1 : N ;
  uppmarsch_nn_1 : N ;
  uppmarschomraade_nn_1 : N ;
  uppmjukning_nn_1 : N ;
  uppmuntran_nn_1 : N ;
  uppmuntring_nn_1 : N ;
  uppnaaelig_av_1 : A ;
  uppnaest_av_1 : A ;
  uppnosig_av_1 : A ;
  uppochned_ab_1 : Adv ;
  uppochnedvaend_av_1 : A ;
  uppoffrande_av_1 : A ;
  uppoffring_nn_1 : N ;
  uppraekning_nn_1 : N ;
  uppraett_av_1 : A ;
  uppraettande_nn_1 : N ;
  uppraettelse_nn_1 : N ;
  uppraetthaalla_vb_1 : V ;
  uppraettstaaende_av_1 : A ;
  upprensning_nn_1 : N ;
  upprepning_nn_1 : N ;
  upprepningsmoenster_nn_1 : N ;
  uppriktig_av_1 : A ;
  uppringning_nn_1 : N ;
  upprinnelse_nn_1 : N ;
  upprinning_nn_1 : N ;
  uppriva_vb_1 : V ;
  upprivande_av_1 : A ;
  uppriven_av_1 : A ;
  upproejning_nn_1 : N ;
  upproerande_av_1 : A ;
  upproerd_av_1 : A ;
  upprop_nn_1 : N ;
  uppror_nn_1 : N ;
  upprorisk_av_1 : A ;
  upprorshaerd_nn_1 : N ;
  upprorsmakare_nn_1 : N ;
  upprorsman_nn_1 : N ;
  upprustning_nn_1 : N ;
  upprutten_av_1 : A ;
  uppryckning_nn_1 : N ;
  upprymd_av_1 : A ;
  upprymmare_nn_1 : N ;
  upprymningsstaal_nn_1 : N ;
  uppsaat_nn_1 : N ;
  uppsaatlig_av_1 : A ;
  uppsaatligen_ab_1 : Adv ;
  uppsaegelse_nn_1 : N ;
  uppsaegning_nn_1 : N ;
  uppsaegningslaan_nn_1 : N ;
  uppsaegningsraekning_nn_1 : N ;
  uppsaegningstermin_nn_1 : N ;
  uppsaegningstid_nn_1 : N ;
  uppsaettare_nn_1 : N ;
  uppsaettning_nn_1 : N ;
  uppsaettningsinstrument_nn_1 : N ;
  uppsaettningsmaal_nn_1 : N ;
  uppsagd_av_1 : A ;
  uppsamling_nn_1 : N ;
  uppsamlingslaeger_nn_1 : N ;
  uppsats_nn_1 : N ;
  uppsatslag_nn_1 : N ;
  uppsatt_av_1 : A ;
  uppseendevaeckande_av_1 : A ;
  uppsittarkvaell_nn_1 : N ;
  uppsjungning_nn_1 : N ;
  uppskaerare_nn_1 : N ;
  uppskakande_av_1 : A ;
  uppskattning_nn_1 : N ;
  uppskattningsvis_ab_1 : Adv ;
  uppskjuta_vb_1 : V ;
  uppskov_nn_1 : N ;
  uppskrivning_nn_1 : N ;
  uppslag_nn_1 : N ;
  uppslagsaenda_nn_1 : N ;
  uppslagsbok_nn_1 : N ;
  uppslagsform_nn_1 : N ;
  uppslagsord_nn_1 : N ;
  uppslagsrik_av_1 : A ;
  uppslagsverk_nn_1 : N ;
  uppslitande_av_1 : A ;
  uppsluppen_av_1 : A ;
  uppsoekande_av_1 : A ;
  uppspaltning_nn_1 : N ;
  uppspel_nn_1 : N ;
  uppspelning_nn_1 : N ;
  uppspelt_av_1 : A ;
  uppsplittring_nn_1 : N ;
  uppspraang_nn_1 : N ;
  uppspricka_vb_1 : V ;
  uppstaaende_av_1 : A ;
  uppstaanden_av_1 : A ;
  uppstad_nn_1 : N ;
  uppstaellning_nn_1 : N ;
  uppstaellningsplats_nn_1 : N ;
  uppstaellningssignal_nn_1 : N ;
  uppstaellningsspaar_nn_1 : N ;
  uppstiga_vb_1 : V ;
  uppstoetning_nn_1 : N ;
  uppstraak_nn_1 : N ;
  uppstraeckning_nn_1 : N ;
  uppstraeckt_av_1 : A ;
  uppstramning_nn_1 : N ;
  uppstroem_nn_1 : N ;
  uppstroems_ab_1 : Adv ;
  uppstudsig_av_1 : A ;
  uppsuga_vb_1 : V ;
  uppsugning_nn_1 : N ;
  uppsvaelld_av_1 : A ;
  uppsvensk_av_1 : A ;
  uppsving_nn_1 : N ;
  uppsvullen_av_1 : A ;
  uppsyn_nn_1 : N ;
  uppsyningsman_nn_1 : N ;
  uppta_vb_1 : V ;
  upptaag_nn_1 : N ;
  upptaagsmakare_nn_1 : N ;
  upptaeckare_nn_1 : N ;
  upptaeckt_nn_1 : N ;
  upptaecktsfaerd_nn_1 : N ;
  upptaecktsresande_nn_1 : N ;
  upptaend_av_1 : A ;
  upptaenklig_av_1 : A ;
  upptagen_av_1 : A ;
  upptagenhet_nn_1 : N ;
  upptagning_nn_1 : N ;
  upptagningsceremoni_nn_1 : N ;
  upptagningshem_nn_1 : N ;
  upptagningsomraade_nn_1 : N ;
  upptakt_nn_1 : N ;
  upptecknare_nn_1 : N ;
  uppteckning_nn_1 : N ;
  upptill_ab_1 : Adv ;
  upptraedande_nn_1 : N ;
  upptrappning_nn_1 : N ;
  upptryck_nn_1 : N ;
  upptryckning_nn_1 : N ;
  upptuktelse_nn_1 : N ;
  uppvaeckelse_nn_1 : N ;
  uppvaegning_nn_1 : N ;
  uppvaktning_nn_1 : N ;
  uppviglare_nn_1 : N ;
  uppvigling_nn_1 : N ;
  uppvind_nn_1 : N ;
  uppvisning_nn_1 : N ;
  uppvuxen_av_1 : A ;
  ur_ab_1 : Adv ;
  ur_nn_1 : N ;
  ur_nn_2 : N ;
  uraaldrig_av_1 : A ;
  uraktlaata_vb_1 : V ;
  uraktlaatenhet_nn_1 : N ;
  uralisk_av_1 : A ;
  uranglas_nn_1 : N ;
  uranstapel_nn_1 : N ;
  urarva_av_1 : A ;
  urarvabo_nn_1 : N ;
  urarvakonkurs_nn_1 : N ;
  urban_av_1 : A ;
  urbanisering_nn_1 : N ;
  urbanistisk_av_1 : A ;
  urbanitet_nn_1 : N ;
  urbefolkning_nn_1 : N ;
  urbergsplataa_nn_1 : N ;
  urbergsterraeng_nn_1 : N ;
  urbild_nn_1 : N ;
  urblaast_av_1 : A ;
  urblekt_av_1 : A ;
  urbota_ab_1 : Adv ;
  urbraenning_nn_1 : N ;
  urcell_nn_1 : N ;
  urdaalig_av_1 : A ;
  urdjur_nn_1 : N ;
  urdjurscell_nn_1 : N ;
  urdrucken_av_1 : A ;
  ureas_nn_1 : N ;
  uretanplast_nn_1 : N ;
  urexplosion_nn_1 : N ;
  urfaagel_nn_1 : N ;
  urfaanig_av_1 : A ;
  urfaelld_av_1 : A ;
  urfjaellsjord_nn_1 : N ;
  urfolk_nn_1 : N ;
  urformation_nn_1 : N ;
  urgammal_av_1 : A ;
  urgermansk_av_1 : A ;
  urgroepning_nn_1 : N ;
  urgroept_av_1 : A ;
  urhem_nn_1 : N ;
  uribag_nn_1 : N ;
  uridom_nn_1 : N ;
  uriebrev_nn_1 : N ;
  urinavsoendring_nn_1 : N ;
  urinbrunn_nn_1 : N ;
  urinbyggare_nn_1 : N ;
  urindoeuropeisk_av_1 : A ;
  urindrivande_av_1 : A ;
  urinfoergiftning_nn_1 : N ;
  urinkur_nn_1 : N ;
  urinledare_nn_1 : N ;
  urinnevaanare_nn_1 : N ;
  urinoar_nn_1 : N ;
  urinorgan_nn_1 : N ;
  urinprov_nn_1 : N ;
  urinroer_nn_1 : N ;
  urinstinkt_nn_1 : N ;
  urintraengning_nn_1 : N ;
  urinvaanare_nn_1 : N ;
  urinvaeg_nn_1 : N ;
  urinvaegsinfektion_nn_1 : N ;
  urkalksten_nn_1 : N ;
  urklipp_nn_1 : N ;
  urkokt_av_1 : A ;
  urkristendom_nn_1 : N ;
  urkund_nn_1 : N ;
  urkundlig_av_1 : A ;
  urkundsforskning_nn_1 : N ;
  urladdare_nn_1 : N ;
  urladdning_nn_1 : N ;
  urladdningsroer_nn_1 : N ;
  urlastning_nn_1 : N ;
  urledvrickning_nn_1 : N ;
  urledvridning_nn_1 : N ;
  urmaenniska_nn_1 : N ;
  urmakare_nn_1 : N ;
  urmakeri_nn_1 : N ;
  urminnes_av_1 : A ;
  urminneshaevd_nn_1 : N ;
  urmodig_av_1 : A ;
  urnebrandgrop_nn_1 : N ;
  urnegrav_nn_1 : N ;
  urngrav_nn_1 : N ;
  urnkulle_nn_1 : N ;
  urnordisk_av_1 : A ;
  urnupen_av_1 : A ;
  urnyckel_nn_1 : N ;
  urocean_nn_1 : N ;
  urogenitalapparat_nn_1 : N ;
  urogenitaloeppning_nn_1 : N ;
  urogenitalorgan_nn_1 : N ;
  urolog_nn_1 : N ;
  urologisk_av_1 : A ;
  urormbunke_nn_1 : N ;
  uroxe_nn_1 : N ;
  urpremiaer_nn_1 : N ;
  urringning_nn_1 : N ;
  ursaekt_nn_1 : N ;
  ursaektlig_av_1 : A ;
  ursame_nn_1 : N ;
  ursinnig_av_1 : A ;
  urskiljbar_av_1 : A ;
  urskiljning_nn_1 : N ;
  urskillningsloes_av_1 : A ;
  urskog_nn_1 : N ;
  urskri_nn_1 : N ;
  urskuldande_nn_1 : N ;
  ursmaell_nn_1 : N ;
  ursmaellsteori_nn_1 : N ;
  ursnygg_av_1 : A ;
  urspaarning_nn_1 : N ;
  urspraak_nn_1 : N ;
  ursprung_nn_1 : N ;
  ursprunglig_av_1 : A ;
  ursprungligen_ab_1 : Adv ;
  ursprungsart_nn_1 : N ;
  ursprungsattest_nn_1 : N ;
  ursprungsbeteckning_nn_1 : N ;
  ursprungsbevis_nn_1 : N ;
  ursprungscell_nn_1 : N ;
  ursprungscertifikat_nn_1 : N ;
  ursprungslaege_nn_1 : N ;
  ursprungsland_nn_1 : N ;
  ursprungsort_nn_1 : N ;
  urstyv_av_1 : A ;
  urtag_nn_1 : N ;
  urtagbar_av_1 : A ;
  urtagen_av_1 : A ;
  urtappning_nn_1 : N ;
  urtavla_nn_1 : N ;
  urtext_nn_1 : N ;
  urtida_av_1 : A ;
  urtillstaand_nn_1 : N ;
  urtima_av_1 : A ;
  urtjusig_av_1 : A ;
  urtjuva_av_1 : A ;
  urtyp_nn_1 : N ;
  uruguayare_nn_1 : N ;
  uruguaysk_av_1 : A ;
  uruppfoerande_nn_1 : N ;
  urusel_av_1 : A ;
  urvaext_av_1 : A ;
  urval_nn_1 : N ;
  urvalsinstrument_nn_1 : N ;
  urvalsundersoekning_nn_1 : N ;
  urverk_nn_1 : N ;
  urvuxen_av_1 : A ;
  usans_nn_1 : N ;
  uschlig_av_1 : A ;
  usel_av_1 : A ;
  uslig_av_1 : A ;
  usling_nn_1 : N ;
  usuell_av_1 : A ;
  usurpator_nn_1 : N ;
  ut_ab_1 : Adv ;
  utaat_ab_1 : Adv ;
  utaatvaend_av_1 : A ;
  utaega_nn_1 : N ;
  utandning_nn_1 : N ;
  utanfoer_ab_1 : Adv ;
  utanfoerstaaende_av_1 : A ;
  utanpaa_ab_1 : Adv ;
  utanskrift_nn_1 : N ;
  utantill_ab_1 : Adv ;
  utanverk_nn_1 : N ;
  utbaerning_nn_1 : N ;
  utbe_vb_1 : V ;
  utbedja_vb_1 : V ;
  utbekomma_vb_1 : V ;
  utbetalning_nn_1 : N ;
  utbetalningskort_nn_1 : N ;
  utbetalningsorder_nn_1 : N ;
  utbildning_nn_1 : N ;
  utbildningsbidrag_nn_1 : N ;
  utbildningsdepartement_nn_1 : N ;
  utbildningsgap_nn_1 : N ;
  utbildningslinje_nn_1 : N ;
  utbildningstid_nn_1 : N ;
  utbildningsvaeg_nn_1 : N ;
  utbjuda_vb_1 : V ;
  utblaasning_nn_1 : N ;
  utblick_nn_1 : N ;
  utbo_nn_1 : N ;
  utboeling_nn_1 : N ;
  utboerding_nn_1 : N ;
  utbordare_nn_1 : N ;
  utbraend_av_1 : A ;
  utbredd_av_1 : A ;
  utbredningscentrum_nn_1 : N ;
  utbredningsomraade_nn_1 : N ;
  utbrista_vb_1 : V ;
  utbrott_nn_1 : N ;
  utbrunnen_av_1 : A ;
  utbryta_vb_1 : V ;
  utbrytare_nn_1 : N ;
  utbrytarkung_nn_1 : N ;
  utbrytarstat_nn_1 : N ;
  utbrytning_nn_1 : N ;
  utbud_nn_1 : N ;
  utbuktande_av_1 : A ;
  utbuktning_nn_1 : N ;
  utbyggbar_av_1 : A ;
  utbyggd_av_1 : A ;
  utbyggnad_nn_1 : N ;
  utbytbar_av_1 : A ;
  utbyte_nn_1 : N ;
  utdebitering_nn_1 : N ;
  utdelning_nn_1 : N ;
  utdockning_nn_1 : N ;
  utdoed_av_1 : A ;
  utdra_vb_1 : V ;
  utdrag_nn_1 : N ;
  utdragare_nn_1 : N ;
  utdragbar_av_1 : A ;
  utdragen_av_1 : A ;
  utdragning_nn_1 : N ;
  utdragssoem_nn_1 : N ;
  utdriva_vb_1 : V ;
  utdrucken_av_1 : A ;
  utdunstning_nn_1 : N ;
  utdunstningskaerl_nn_1 : N ;
  ute_ab_1 : Adv ;
  ute_av_1 : A ;
  uteaetare_nn_1 : N ;
  utedass_nn_1 : N ;
  utefaar_nn_1 : N ;
  utegaangsfaar_nn_1 : N ;
  utegaangsfoerbud_nn_1 : N ;
  utegrill_nn_1 : N ;
  utekvaell_nn_1 : N ;
  utelaemningstecken_nn_1 : N ;
  utelag_nn_1 : N ;
  uteliggande_av_1 : A ;
  uteliggare_nn_1 : N ;
  uteloepande_av_1 : A ;
  utemiljoe_nn_1 : N ;
  utemoebel_nn_1 : N ;
  uteplats_nn_1 : N ;
  uterum_nn_1 : N ;
  uteservering_nn_1 : N ;
  utesluta_vb_1 : V ;
  uteslutande_ab_1 : Adv ;
  uteslutning_nn_1 : N ;
  utespelare_nn_1 : N ;
  utestaaende_av_1 : A ;
  utetermometer_nn_1 : N ;
  utfaellbar_av_1 : A ;
  utfaellning_nn_1 : N ;
  utfaerd_nn_1 : N ;
  utfaestelse_nn_1 : N ;
  utfall_nn_1 : N ;
  utfalla_vb_1 : V ;
  utfallsdike_nn_1 : N ;
  utfallsport_nn_1 : N ;
  utfallsprov_nn_1 : N ;
  utfart_nn_1 : N ;
  utfattig_av_1 : A ;
  utfloede_nn_1 : N ;
  utflugen_av_1 : A ;
  utflykt_nn_1 : N ;
  utflyttning_nn_1 : N ;
  utflyttningslaen_nn_1 : N ;
  utflyttningslaengd_nn_1 : N ;
  utfodringsjournal_nn_1 : N ;
  utfodringsstat_nn_1 : N ;
  utfoer_ab_1 : Adv ;
  utfoerande_nn_1 : N ;
  utfoerbar_av_1 : A ;
  utfoering_nn_1 : N ;
  utfoerlig_av_1 : A ;
  utfoersaakare_nn_1 : N ;
  utfoersaeljning_nn_1 : N ;
  utfoersbacke_nn_1 : N ;
  utformning_nn_1 : N ;
  utforskare_nn_1 : N ;
  utforskning_nn_1 : N ;
  utfraagning_nn_1 : N ;
  utfrusen_av_1 : A ;
  utfryst_av_1 : A ;
  utfyllnad_nn_1 : N ;
  utfyllning_nn_1 : N ;
  utgaa_vb_1 : V ;
  utgaang_nn_1 : N ;
  utgaangshastighet_nn_1 : N ;
  utgaangslaege_nn_1 : N ;
  utgaangsmarsch_nn_1 : N ;
  utgaangsmaterial_nn_1 : N ;
  utgaangspunkt_nn_1 : N ;
  utgaangsrad_nn_1 : N ;
  utgaangsstaellning_nn_1 : N ;
  utgaard_nn_1 : N ;
  utgallring_nn_1 : N ;
  utge_vb_1 : V ;
  utgift_nn_1 : N ;
  utgiftsbudget_nn_1 : N ;
  utgiftsskatt_nn_1 : N ;
  utgiftsverifikation_nn_1 : N ;
  utgivare_nn_1 : N ;
  utgivning_nn_1 : N ;
  utgivningsbevis_nn_1 : N ;
  utgjuta_vb_1 : V ;
  utgjutelse_nn_1 : N ;
  utgjutning_nn_1 : N ;
  utgoedsling_nn_1 : N ;
  utgraevare_nn_1 : N ;
  utgraevning_nn_1 : N ;
  uthaallig_av_1 : A ;
  uthaallighet_nn_1 : N ;
  uthaallighetsloepning_nn_1 : N ;
  uthaallighetstaevling_nn_1 : N ;
  uthaerdlig_av_1 : A ;
  uthalare_nn_1 : N ;
  uthamn_nn_1 : N ;
  uthopp_nn_1 : N ;
  uthuggning_nn_1 : N ;
  uthus_nn_1 : N ;
  uthyrning_nn_1 : N ;
  uthyrningsrum_nn_1 : N ;
  utifraan_ab_1 : Adv ;
  utilist_nn_1 : N ;
  utilistisk_av_1 : A ;
  utilitarist_nn_1 : N ;
  utilitaristisk_av_1 : A ;
  utjaemningsmandat_nn_1 : N ;
  utkant_nn_1 : N ;
  utkast_nn_1 : N ;
  utkastare_nn_1 : N ;
  utkik_nn_1 : N ;
  utkikspunkt_nn_1 : N ;
  utklaedd_av_1 : A ;
  utklassning_nn_1 : N ;
  utklipp_nn_1 : N ;
  utklyva_vb_1 : V ;
  utkoerare_nn_1 : N ;
  utkoerd_av_1 : A ;
  utkoerning_nn_1 : N ;
  utkomma_vb_1 : V ;
  utkorelse_nn_1 : N ;
  utkragning_nn_1 : N ;
  utkristallisering_nn_1 : N ;
  utkyld_av_1 : A ;
  utlaanare_nn_1 : N ;
  utlaaning_nn_1 : N ;
  utlaatande_nn_1 : N ;
  utlaatelse_nn_1 : N ;
  utlaegg_nn_1 : N ;
  utlaeggning_nn_1 : N ;
  utlaemning_nn_1 : N ;
  utlaendsk_av_1 : A ;
  utlaendska_nn_2 : N ;
  utlaenning_nn_1 : N ;
  utlaerd_av_1 : A ;
  utlandslektor_nn_1 : N ;
  utlandssvensk_nn_1 : N ;
  utled_av_1 : A ;
  utledsen_av_1 : A ;
  utljud_nn_1 : N ;
  utloepare_nn_1 : N ;
  utloesare_nn_1 : N ;
  utloesning_nn_1 : N ;
  utlopp_nn_1 : N ;
  utmaal_nn_1 : N ;
  utmaerkande_av_1 : A ;
  utmaerkelse_nn_1 : N ;
  utmaerkning_nn_1 : N ;
  utmaerkt_av_1 : A ;
  utmaetning_nn_1 : N ;
  utmanande_av_1 : A ;
  utmanare_nn_1 : N ;
  utmaning_nn_1 : N ;
  utmark_nn_1 : N ;
  utmarsch_nn_1 : N ;
  utnoetning_nn_1 : N ;
  utnoett_av_1 : A ;
  utnyttjande_nn_1 : N ;
  utnyttjare_nn_1 : N ;
  utoevare_nn_1 : N ;
  utomaektenskaplig_av_1 : A ;
  utombordare_nn_1 : N ;
  utombords_ab_1 : Adv ;
  utombordsmotor_nn_1 : N ;
  utombys_ab_1 : Adv ;
  utomeuropeisk_av_1 : A ;
  utomhus_ab_1 : Adv ;
  utomhusbad_nn_1 : N ;
  utomhuskonsert_nn_1 : N ;
  utomkvedshavandeskap_nn_1 : N ;
  utomlands_ab_1 : Adv ;
  utomordentlig_av_1 : A ;
  utomparlamentarisk_av_1 : A ;
  utomskaers_ab_1 : Adv ;
  utomstaaende_av_1 : A ;
  utopi_nn_1 : N ;
  utopisk_av_1 : A ;
  utopist_nn_1 : N ;
  utpost_nn_1 : N ;
  utpressare_nn_1 : N ;
  utpressning_nn_1 : N ;
  utprickning_nn_1 : N ;
  utraekning_nn_1 : N ;
  utredare_nn_1 : N ;
  utredning_nn_1 : N ;
  utredningsman_nn_1 : N ;
  utrensning_nn_1 : N ;
  utresefoerbud_nn_1 : N ;
  utresetillstaand_nn_1 : N ;
  utriggare_nn_1 : N ;
  utrikes_ab_1 : Adv ;
  utrikes_av_1 : A ;
  utrikesdepartement_nn_1 : N ;
  utrikeshandelsminister_nn_1 : N ;
  utrikeskorrespondent_nn_1 : N ;
  utrikesminister_nn_1 : N ;
  utrikespassagerare_nn_1 : N ;
  utrikespolitisk_av_1 : A ;
  utrikisk_av_1 : A ;
  utrop_nn_1 : N ;
  utropare_nn_1 : N ;
  utropsord_nn_1 : N ;
  utropstecken_nn_1 : N ;
  utrotning_nn_1 : N ;
  utrustning_nn_1 : N ;
  utryckning_nn_1 : N ;
  utrymme_nn_1 : N ;
  utrymmesstandard_nn_1 : N ;
  utsaald_av_1 : A ;
  utsaede_nn_1 : N ;
  utsaendning_nn_1 : N ;
  utsaga_nn_1 : N ;
  utsagd_av_1 : A ;
  utsatt_av_1 : A ;
  utseende_nn_1 : N ;
  utsida_nn_1 : N ;
  utsikt_nn_1 : N ;
  utsiktsloes_av_1 : A ;
  utsiktspunkt_nn_1 : N ;
  utskaapning_nn_1 : N ;
  utskaelld_av_1 : A ;
  utskaellning_nn_1 : N ;
  utskaemd_av_1 : A ;
  utskick_nn_1 : N ;
  utskjutande_av_1 : A ;
  utskott_nn_1 : N ;
  utskrift_nn_1 : N ;
  utskriva_vb_1 : V ;
  utskyld_nn_1 : N ;
  utslaepp_nn_1 : N ;
  utslag_nn_1 : N ;
  utslagen_av_1 : A ;
  utslagsfraaga_nn_1 : N ;
  utslagsgivande_av_1 : A ;
  utslagsroest_nn_1 : N ;
  utslagstaevling_nn_1 : N ;
  utsliten_av_1 : A ;
  utslutning_nn_1 : N ;
  utsmyckning_nn_1 : N ;
  utsnitt_nn_1 : N ;
  utsocknes_ab_1 : Adv ;
  utsocknes_av_1 : A ;
  utsoekning_nn_1 : N ;
  utsoekt_av_1 : A ;
  utsoendring_nn_1 : N ;
  utsoendringsorgan_nn_1 : N ;
  utsoevd_av_1 : A ;
  utspaedd_av_1 : A ;
  utspark_nn_1 : N ;
  utspel_nn_1 : N ;
  utspraang_nn_1 : N ;
  utsprida_vb_1 : V ;
  utspridd_av_1 : A ;
  utspringande_av_1 : A ;
  utsprungen_av_1 : A ;
  utstaaende_av_1 : A ;
  utstaanden_av_1 : A ;
  utstaellare_nn_1 : N ;
  utstaelld_av_1 : A ;
  utstaellelse_nn_1 : N ;
  utstaellning_nn_1 : N ;
  utstraalning_nn_1 : N ;
  utstyrd_av_1 : A ;
  utstyrsel_nn_1 : N ;
  utsuga_vb_1 : V ;
  utsvaengd_av_1 : A ;
  utsvaevande_av_1 : A ;
  utsvaevning_nn_1 : N ;
  utsvulten_av_1 : A ;
  uttaag_nn_1 : N ;
  uttaenjd_av_1 : A ;
  uttaenjning_nn_1 : N ;
  uttaenkt_av_1 : A ;
  uttag_nn_1 : N ;
  uttagning_nn_1 : N ;
  uttal_nn_1 : N ;
  uttalande_nn_1 : N ;
  uttalsbeteckning_nn_1 : N ;
  uttalsenlig_av_1 : A ;
  uttalsfel_nn_1 : N ;
  uttalstecken_nn_1 : N ;
  utter_nn_1 : N ;
  uttjaent_av_1 : A ;
  uttoejd_av_1 : A ;
  uttoemmande_av_1 : A ;
  uttraede_nn_1 : N ;
  uttryck_nn_1 : N ;
  uttrycklig_av_1 : A ;
  uttryckligen_ab_1 : Adv ;
  uttrycksform_nn_1 : N ;
  uttrycksfull_av_1 : A ;
  uttrycksloes_av_1 : A ;
  uttryckssaett_nn_1 : N ;
  utvaeg_nn_1 : N ;
  utvaendig_av_1 : A ;
  utvaerdering_nn_1 : N ;
  utvaerdshus_nn_1 : N ;
  utvaertes_ab_1 : Adv ;
  utvaertes_av_1 : A ;
  utvaext_nn_1 : N ;
  utvald_av_1 : A ;
  utvandrare_nn_1 : N ;
  utveckling_nn_1 : N ;
  utvecklingsland_nn_1 : N ;
  utvecklingsmaessig_av_1 : A ;
  utvecklingsmoejlighet_nn_1 : N ;
  utvecklingsplan_nn_1 : N ;
  utvecklingsprocess_nn_1 : N ;
  utvecklingsrubbning_nn_1 : N ;
  utvecklingsserie_nn_1 : N ;
  utvecklingsskede_nn_1 : N ;
  utvecklingsstadium_nn_1 : N ;
  utvecklingsstoerd_av_1 : A ;
  utvecklingsstoerning_nn_1 : N ;
  utvecklingstraed_nn_1 : N ;
  utvidgning_nn_1 : N ;
  utvikning_nn_1 : N ;
  utvikningsbild_nn_1 : N ;
  utvikningsbrud_nn_1 : N ;
  utvikningspojke_nn_1 : N ;
  utviksblad_nn_1 : N ;
  utvinna_vb_1 : V ;
  utvinning_nn_1 : N ;
  utvisning_nn_1 : N ;
  utvisningsbaas_nn_1 : N ;
  uv_nn_1 : N ;
  uvertyr_nn_1 : N ;
  uvular_av_1 : A ;
  uvular_nn_1 : N ;
  vaad_nn_1 : N ;
  vaada_nn_1 : N ;
  vaadeld_nn_1 : N ;
  vaadevill_nn_1 : N ;
  vaadlig_av_1 : A ;
  vaadligen_ab_1 : Adv ;
  vaaffeljaern_nn_1 : N ;
  vaaffla_nn_1 : N ;
  vaag_nn_2 : N ;
  vaagbalans_nn_1 : N ;
  vaagbrytare_nn_1 : N ;
  vaagdal_nn_1 : N ;
  vaagfront_nn_1 : N ;
  vaaghaal_nn_1 : N ;
  vaaghals_nn_1 : N ;
  vaaghalsig_av_1 : A ;
  vaaghoejd_nn_1 : N ;
  vaagig_av_1 : A ;
  vaagkam_nn_1 : N ;
  vaaglaengd_nn_1 : N ;
  vaaglinje_nn_1 : N ;
  vaagmaestare_nn_1 : N ;
  vaagnatur_nn_1 : N ;
  vaagplan_nn_1 : N ;
  vaagraet_av_1 : A ;
  vaagroerelse_nn_1 : N ;
  vaagsam_av_1 : A ;
  vaagskaal_nn_1 : N ;
  vaagspel_nn_1 : N ;
  vaagtopp_nn_1 : N ;
  vaaldsam_av_1 : A ;
  vaaldsamhet_nn_1 : N ;
  vaaldsbrott_nn_1 : N ;
  vaaldshandling_nn_1 : N ;
  vaaldsman_nn_1 : N ;
  vaaldsmentalitet_nn_1 : N ;
  vaaldsrotel_nn_1 : N ;
  vaaldsscen_nn_1 : N ;
  vaaldsverkare_nn_1 : N ;
  vaaldta_vb_1 : V ;
  vaaldtaekt_nn_1 : N ;
  vaale_nn_1 : N ;
  vaalm_nn_1 : N ;
  vaalnad_nn_1 : N ;
  vaam_nn_1 : N ;
  vaang_nn_1 : N ;
  vaaning_nn_1 : N ;
  vaaningssaeng_nn_1 : N ;
  vaap_nn_1 : N ;
  vaapig_av_1 : A ;
  vaar_nn_1 : N ;
  vaaradonis_nn_1 : N ;
  vaard_nn_1 : N ;
  vaardagjaemning_nn_1 : N ;
  vaardanstalt_nn_1 : N ;
  vaardare_nn_1 : N ;
  vaardarinna_nn_1 : N ;
  vaardavdelning_nn_1 : N ;
  vaardbidrag_nn_1 : N ;
  vaardcentral_nn_1 : N ;
  vaardhem_nn_1 : N ;
  vaardintyg_nn_1 : N ;
  vaardkase_nn_1 : N ;
  vaardlinje_nn_1 : N ;
  vaardnad_nn_1 : N ;
  vaardnadsbidrag_nn_1 : N ;
  vaardnadshavare_nn_1 : N ;
  vaardplats_nn_1 : N ;
  vaardsam_av_1 : A ;
  vaardsloes_av_1 : A ;
  vaardtagare_nn_1 : N ;
  vaardtecken_nn_1 : N ;
  vaardtraed_nn_1 : N ;
  vaardyrke_nn_1 : N ;
  vaarkaensla_nn_1 : N ;
  vaarlig_av_1 : A ;
  vaarloek_nn_1 : N ;
  vaarmaanad_nn_1 : N ;
  vaarsol_nn_1 : N ;
  vaartbitare_nn_1 : N ;
  vaartecken_nn_1 : N ;
  vaartermin_nn_1 : N ;
  vaartgaard_nn_1 : N ;
  vaartig_av_1 : A ;
  vaartkaktus_nn_1 : N ;
  vaartmedel_nn_1 : N ;
  vaartroett_av_1 : A ;
  vaartsvets_nn_1 : N ;
  vaartsvin_nn_1 : N ;
  vaarvaext_nn_1 : N ;
  vaarvial_nn_1 : N ;
  vaarvinter_nn_1 : N ;
  vaat_av_1 : A ;
  vaatelement_nn_1 : N ;
  vaatmark_nn_1 : N ;
  vaatservett_nn_1 : N ;
  vaatstark_av_1 : A ;
  vaatutrymme_nn_1 : N ;
  vaatvaermande_av_1 : A ;
  vaatvara_nn_1 : N ;
  vaatvarm_av_1 : A ;
  vaccin_nn_1 : N ;
  vaccination_nn_1 : N ;
  vaccinatoer_nn_1 : N ;
  vaccinering_nn_1 : N ;
  vacker_av_1 : A ;
  vackert_ab_1 : Adv ;
  vacuum_nn_1 : N ;
  vad_ab_1 : Adv ;
  vad_nn_1 : N ;
  vad_nn_2 : N ;
  vad_nn_3 : N ;
  vadaa_ab_1 : Adv ;
  vadan_ab_1 : Adv ;
  vadare_nn_1 : N ;
  vadarfaagel_nn_1 : N ;
  vadbar_av_1 : A ;
  vadd_nn_1 : N ;
  vaddering_nn_1 : N ;
  vadfot_nn_1 : N ;
  vadhaallare_nn_1 : N ;
  vadhaallning_nn_1 : N ;
  vadlaang_av_1 : A ;
  vados_av_1 : A ;
  vadslagning_nn_1 : N ;
  vaebel_nn_1 : N ;
  vaeck_ab_1 : Adv ;
  vaeckare_nn_1 : N ;
  vaeckelse_nn_1 : N ;
  vaeckelsemoete_nn_1 : N ;
  vaeckelseroerelse_nn_1 : N ;
  vaeckning_nn_1 : N ;
  vaeder_nn_1 : N ;
  vaederbestaendig_av_1 : A ;
  vaederbiten_av_1 : A ;
  vaederfoerhaallande_nn_1 : N ;
  vaederil_nn_1 : N ;
  vaederkvarn_nn_1 : N ;
  vaederlek_nn_1 : N ;
  vaederleksrapport_nn_1 : N ;
  vaederprognos_nn_1 : N ;
  vaederrapport_nn_1 : N ;
  vaedersatellit_nn_1 : N ;
  vaedersegel_nn_1 : N ;
  vaederskepp_nn_1 : N ;
  vaedersol_nn_1 : N ;
  vaederspaend_av_1 : A ;
  vaederspaenning_nn_1 : N ;
  vaederstinn_av_1 : A ;
  vaederstreck_nn_1 : N ;
  vaedertillstaand_nn_1 : N ;
  vaedjande_nn_1 : N ;
  vaedur_nn_1 : N ;
  vaeg_ab_1 : Adv ;
  vaeg_nn_1 : N ;
  vaegare_nn_1 : N ;
  vaegbelaeggning_nn_1 : N ;
  vaegbom_nn_1 : N ;
  vaegbro_nn_1 : N ;
  vaegbrytare_nn_1 : N ;
  vaegegenskap_nn_1 : N ;
  vaegfaerja_nn_1 : N ;
  vaegfarande_nn_1 : N ;
  vaegfoerbindelse_nn_1 : N ;
  vaegfoerening_nn_1 : N ;
  vaegfoervaltning_nn_1 : N ;
  vaegg_nn_1 : N ;
  vaeggband_nn_1 : N ;
  vaeggbonad_nn_1 : N ;
  vaeggfast_av_1 : A ;
  vaegglus_nn_1 : N ;
  vaeggmadam_nn_1 : N ;
  vaeggpelare_nn_1 : N ;
  vaeggtelefon_nn_1 : N ;
  vaeggtidning_nn_1 : N ;
  vaegguttag_nn_1 : N ;
  vaeghyvel_nn_1 : N ;
  vaegkant_nn_1 : N ;
  vaegkors_nn_1 : N ;
  vaegkorsning_nn_1 : N ;
  vaeglag_nn_1 : N ;
  vaeglag_nn_2 : N ;
  vaegledande_av_1 : A ;
  vaegledning_nn_1 : N ;
  vaeglus_nn_1 : N ;
  vaegmaerke_nn_1 : N ;
  vaegmaetare_nn_1 : N ;
  vaegmaskin_nn_1 : N ;
  vaegnaet_nn_1 : N ;
  vaegning_nn_1 : N ;
  vaegport_nn_1 : N ;
  vaegrare_nn_1 : N ;
  vaegren_nn_1 : N ;
  vaegroejare_nn_1 : N ;
  vaegskael_nn_1 : N ;
  vaegskylt_nn_1 : N ;
  vaegtistel_nn_1 : N ;
  vaegtorn_nn_1 : N ;
  vaegtunnel_nn_1 : N ;
  vaegvinnande_av_1 : A ;
  vaegvisare_nn_1 : N ;
  vaejning_nn_1 : N ;
  vaekt_nn_1 : N ;
  vaektare_nn_1 : N ;
  vael_1_ab_1 : Adv ;
  vael_2_ab_1 : Adv ;
  vaelan_ab_1 : Adv ;
  vaelavvaegd_av_1 : A ;
  vaelbegriplig_av_1 : A ;
  vaelbehaallen_av_1 : A ;
  vaelbehoevlig_av_1 : A ;
  vaelbekant_av_1 : A ;
  vaelbelaegen_av_1 : A ;
  vaelbesatt_av_1 : A ;
  vaelbesoekt_av_1 : A ;
  vaelbestaelld_av_1 : A ;
  vaelbetaenkt_av_1 : A ;
  vaelbetald_av_1 : A ;
  vaelboren_av_1 : A ;
  vaelbyggd_av_1 : A ;
  vaeldeliga_ab_1 : Adv ;
  vaeldeligen_ab_1 : Adv ;
  vaeldig_av_1 : A ;
  vaeldoftande_av_1 : A ;
  vaelfaegnad_nn_1 : N ;
  vaelfaerdskris_nn_1 : N ;
  vaelfaerdsstat_nn_1 : N ;
  vaelfoedd_av_1 : A ;
  vaelfoerenlig_av_1 : A ;
  vaelfoerklarlig_av_1 : A ;
  vaelfoersedd_av_1 : A ;
  vaelfoerstaadd_av_1 : A ;
  vaelfoerstaaelig_av_1 : A ;
  vaelfoerstaandig_av_1 : A ;
  vaelfoertjaent_av_1 : A ;
  vaelfunnen_av_1 : A ;
  vaelfylld_av_1 : A ;
  vaelgaerning_nn_1 : N ;
  vaelgjord_av_1 : A ;
  vaelgoedd_av_1 : A ;
  vaelgoerande_av_1 : A ;
  vaelgoerare_nn_1 : N ;
  vaelgoerenhet_nn_1 : N ;
  vaelgoerenhetsbasar_nn_1 : N ;
  vaelhaallen_av_1 : A ;
  vaelhaengd_av_1 : A ;
  vaeljarbarometer_nn_1 : N ;
  vaeljare_nn_1 : N ;
  vaeljarkaar_nn_1 : N ;
  vaelkaend_av_1 : A ;
  vaelklaedd_av_1 : A ;
  vaelklingande_av_1 : A ;
  vaelkommen_av_1 : A ;
  vaelkomstskaal_nn_1 : N ;
  vaell_nn_1 : N ;
  vaellevnad_nn_1 : N ;
  vaelling_nn_1 : N ;
  vaellingliknande_av_1 : A ;
  vaelljaern_nn_1 : N ;
  vaelljudande_av_1 : A ;
  vaellning_nn_1 : N ;
  vaellovlig_av_1 : A ;
  vaelluktande_av_1 : A ;
  vaellustig_av_1 : A ;
  vaellusting_nn_1 : N ;
  vaelmaaende_av_1 : A ;
  vaelmenande_av_1 : A ;
  vaelment_av_1 : A ;
  vaelnaerd_av_1 : A ;
  vaelsedd_av_1 : A ;
  vaelsignelse_nn_1 : N ;
  vaelsignelsebringande_av_1 : A ;
  vaelsittande_av_1 : A ;
  vaelsk_av_1 : A ;
  vaelskapt_av_1 : A ;
  vaelskjutande_av_1 : A ;
  vaelskoett_av_1 : A ;
  vaelskriven_av_1 : A ;
  vaelskuren_av_1 : A ;
  vaelsmakande_av_1 : A ;
  vaelsmord_av_1 : A ;
  vaelstaelld_av_1 : A ;
  vaelstekt_av_1 : A ;
  vaelt_nn_1 : N ;
  vaeltagen_av_1 : A ;
  vaeltalare_nn_1 : N ;
  vaeltalig_av_1 : A ;
  vaeltalighet_nn_1 : N ;
  vaelvaext_av_1 : A ;
  vaelvd_av_1 : A ;
  vaelvillig_av_1 : A ;
  vaelvis_av_1 : A ;
  vaelvning_nn_1 : N ;
  vaelvuxen_av_1 : A ;
  vaemjelig_av_1 : A ;
  vaen_av_1 : A ;
  vaen_nn_1 : N ;
  vaendbar_av_1 : A ;
  vaendelrot_nn_1 : N ;
  vaendkors_nn_1 : N ;
  vaendkrets_nn_1 : N ;
  vaendning_nn_1 : N ;
  vaendplats_nn_1 : N ;
  vaendpunkt_nn_1 : N ;
  vaendradie_nn_1 : N ;
  vaendrostning_nn_1 : N ;
  vaendsydd_av_1 : A ;
  vaenfast_av_1 : A ;
  vaeninna_nn_1 : N ;
  vaenkrets_nn_1 : N ;
  vaenlig_av_1 : A ;
  vaenligen_ab_1 : Adv ;
  vaenlighet_nn_1 : N ;
  vaenort_nn_1 : N ;
  vaenpris_nn_1 : N ;
  vaensaell_av_1 : A ;
  vaenskaplig_av_1 : A ;
  vaenskapligen_ab_1 : Adv ;
  vaenskaplighet_nn_1 : N ;
  vaenskapsfoerbindelse_nn_1 : N ;
  vaenskapsmatch_nn_1 : N ;
  vaenskapspris_nn_1 : N ;
  vaensterflygel_nn_1 : N ;
  vaensterhaent_av_1 : A ;
  vaensterhand_nn_1 : N ;
  vaensterhandsspelare_nn_1 : N ;
  vaensterknaeck_nn_1 : N ;
  vaensterparti_nn_1 : N ;
  vaensterradikal_av_1 : A ;
  vaensterradikal_nn_1 : N ;
  vaenstervriden_av_1 : A ;
  vaentetid_nn_1 : N ;
  vaentevaerde_nn_1 : N ;
  vaenthall_nn_1 : N ;
  vaentjaenst_nn_1 : N ;
  vaentrum_nn_1 : N ;
  vaentsal_nn_1 : N ;
  vaepnare_nn_1 : N ;
  vaeppling_nn_1 : N ;
  vaerd_av_1 : A ;
  vaerd_nn_1 : N ;
  vaerddjur_nn_1 : N ;
  vaerdeanalys_nn_1 : N ;
  vaerdebestaendig_av_1 : A ;
  vaerdebrev_nn_1 : N ;
  vaerdefast_av_1 : A ;
  vaerdefoeremaal_nn_1 : N ;
  vaerdefoersaendelse_nn_1 : N ;
  vaerdefull_av_1 : A ;
  vaerdehandling_nn_1 : N ;
  vaerdeloes_av_1 : A ;
  vaerdemaengd_nn_1 : N ;
  vaerdemaessig_av_1 : A ;
  vaerdemaetare_nn_1 : N ;
  vaerdeminskning_nn_1 : N ;
  vaerdeoekning_nn_1 : N ;
  vaerdepapper_nn_1 : N ;
  vaerderare_nn_1 : N ;
  vaerdering_nn_1 : N ;
  vaerderingsfri_av_1 : A ;
  vaerderingsinstrument_nn_1 : N ;
  vaerderingsman_nn_1 : N ;
  vaerderingsnorm_nn_1 : N ;
  vaerdesaeker_av_1 : A ;
  vaerdesak_nn_1 : N ;
  vaerdestegring_nn_1 : N ;
  vaerdetabell_nn_1 : N ;
  vaerdfamilj_nn_1 : N ;
  vaerdfolk_nn_1 : N ;
  vaerdig_av_1 : A ;
  vaerdighet_nn_1 : N ;
  vaerdinna_nn_1 : N ;
  vaerdshus_nn_1 : N ;
  vaerdvaexling_nn_1 : N ;
  vaerdvaext_nn_1 : N ;
  vaering_nn_1 : N ;
  vaerjemaalsed_nn_1 : N ;
  vaerk_nn_1 : N ;
  vaerkbruten_av_1 : A ;
  vaerld_nn_1 : N ;
  vaerldsaalder_nn_1 : N ;
  vaerldsaaskaadning_nn_1 : N ;
  vaerldsartist_nn_1 : N ;
  vaerldsatlas_nn_1 : N ;
  vaerldsaxel_nn_1 : N ;
  vaerldsbekant_av_1 : A ;
  vaerldsberoemd_av_1 : A ;
  vaerldsberoemdhet_nn_1 : N ;
  vaerldsbild_nn_1 : N ;
  vaerldsborgare_nn_1 : N ;
  vaerldsbrand_nn_1 : N ;
  vaerldsdam_nn_1 : N ;
  vaerldsdel_nn_1 : N ;
  vaerldsfientlig_av_1 : A ;
  vaerldsfoerbaettrare_nn_1 : N ;
  vaerldsfoersakelse_nn_1 : N ;
  vaerldsfraanvaend_av_1 : A ;
  vaerldsfraanvarande_av_1 : A ;
  vaerldsfraemmande_av_1 : A ;
  vaerldshav_nn_1 : N ;
  vaerldshistorisk_av_1 : A ;
  vaerldsklok_av_1 : A ;
  vaerldskrig_nn_1 : N ;
  vaerldslig_av_1 : A ;
  vaerldsmaestare_nn_1 : N ;
  vaerldsmaestarinna_nn_1 : N ;
  vaerldsmaesterskap_nn_1 : N ;
  vaerldsmakt_nn_1 : N ;
  vaerldsman_nn_1 : N ;
  vaerldsmarknad_nn_1 : N ;
  vaerldsmedborgare_nn_1 : N ;
  vaerldsnamn_nn_1 : N ;
  vaerldsomfattande_av_1 : A ;
  vaerldsomsegling_nn_1 : N ;
  vaerldsomstoertande_av_1 : A ;
  vaerldsomvaelvande_av_1 : A ;
  vaerldsorganisation_nn_1 : N ;
  vaerldsrekord_nn_1 : N ;
  vaerldsreligion_nn_1 : N ;
  vaerldsrevolution_nn_1 : N ;
  vaerldsrymd_nn_1 : N ;
  vaerldsspraak_nn_1 : N ;
  vaerldsstad_nn_1 : N ;
  vaerldstid_nn_1 : N ;
  vaerldsutstaellning_nn_1 : N ;
  vaerldsvan_av_1 : A ;
  vaerldsvis_av_1 : A ;
  vaermeaaskvaeder_nn_1 : N ;
  vaermeaelskande_av_1 : A ;
  vaermeanlaeggning_nn_1 : N ;
  vaermebehandling_nn_1 : N ;
  vaermebehov_nn_1 : N ;
  vaermebestaendig_av_1 : A ;
  vaermebild_nn_1 : N ;
  vaermebildskamera_nn_1 : N ;
  vaermeboelja_nn_1 : N ;
  vaermecentral_nn_1 : N ;
  vaermeekonomi_nn_1 : N ;
  vaermeelement_nn_1 : N ;
  vaermeenhet_nn_1 : N ;
  vaermefloede_nn_1 : N ;
  vaermefoerlust_nn_1 : N ;
  vaermegenomgaangstal_nn_1 : N ;
  vaermegrad_nn_1 : N ;
  vaermeisolator_nn_1 : N ;
  vaermeisolerande_av_1 : A ;
  vaermekamera_nn_1 : N ;
  vaermekapacitet_nn_1 : N ;
  vaermekapacitivitet_nn_1 : N ;
  vaermekonduktivitet_nn_1 : N ;
  vaermekostnad_nn_1 : N ;
  vaermekraftverk_nn_1 : N ;
  vaermekrus_nn_1 : N ;
  vaermeledare_nn_1 : N ;
  vaermeledning_nn_1 : N ;
  vaermeledningssystem_nn_1 : N ;
  vaermemaatt_nn_1 : N ;
  vaermemaengd_nn_1 : N ;
  vaermemotor_nn_1 : N ;
  vaermepump_nn_1 : N ;
  vaermeskaap_nn_1 : N ;
  vaermeskoeld_nn_1 : N ;
  vaermestuga_nn_1 : N ;
  vaermetillaegg_nn_1 : N ;
  vaermeutbyte_nn_1 : N ;
  vaermevaexlare_nn_1 : N ;
  vaermeverk_nn_1 : N ;
  vaermlaendsk_av_1 : A ;
  vaermlaendska_nn_2 : N ;
  vaermlaenning_nn_1 : N ;
  vaern_nn_1 : N ;
  vaernfaagel_nn_1 : N ;
  vaernloes_av_1 : A ;
  vaernpliktig_av_1 : A ;
  vaernpliktsriksdag_nn_1 : N ;
  vaernpliktstjaenstgoering_nn_1 : N ;
  vaernpliktsvaegrare_nn_1 : N ;
  vaersting_nn_1 : N ;
  vaert_av_1 : A ;
  vaerv_nn_1 : N ;
  vaervning_nn_1 : N ;
  vaesen_nn_2 : N ;
  vaesende_nn_1 : N ;
  vaesentlig_av_1 : A ;
  vaesentligen_ab_1 : Adv ;
  vaesentlighet_nn_1 : N ;
  vaeskryckare_nn_1 : N ;
  vaesning_nn_1 : N ;
  vaest_ab_1 : Adv ;
  vaest_nn_1 : N ;
  vaestan_ab_1 : Adv ;
  vaestanflaekt_nn_1 : N ;
  vaestanhavs_ab_1 : Adv ;
  vaester_ab_1 : Adv ;
  vaesterbottning_nn_1 : N ;
  vaesterbottnisk_av_1 : A ;
  vaestergoek_nn_1 : N ;
  vaesterlaendsk_av_1 : A ;
  vaesterlaenning_nn_1 : N ;
  vaesterut_ab_1 : Adv ;
  vaesteuropeisk_av_1 : A ;
  vaestgoetaklimax_nn_1 : N ;
  vaestgoetaspets_nn_1 : N ;
  vaestgoete_nn_1 : N ;
  vaestgoetsk_av_1 : A ;
  vaestgoetska_nn_2 : N ;
  vaestgot_nn_1 : N ;
  vaestgotisk_av_1 : A ;
  vaestindiefarare_nn_1 : N ;
  vaestindisk_av_1 : A ;
  vaestklaenning_nn_1 : N ;
  vaestkust_nn_1 : N ;
  vaestkustsallad_nn_1 : N ;
  vaestlig_av_1 : A ;
  vaestmakt_nn_1 : N ;
  vaestmanlaendsk_av_1 : A ;
  vaestmanlaendska_nn_2 : N ;
  vaestmanlaenning_nn_1 : N ;
  vaestoever_ab_1 : Adv ;
  vaestpaa_ab_1 : Adv ;
  vaestra_av_1 : A ;
  vaestsamoan_nn_1 : N ;
  vaestslavisk_av_1 : A ;
  vaestsvensk_av_1 : A ;
  vaesttysk_av_1 : A ;
  vaesttysk_nn_1 : N ;
  vaestvart_ab_1 : Adv ;
  vaestvind_nn_1 : N ;
  vaeteatom_nn_1 : N ;
  vaetebomb_nn_1 : N ;
  vaetegenerator_nn_1 : N ;
  vaetejon_nn_1 : N ;
  vaetejonkoncentration_nn_1 : N ;
  vaetekarbonat_nn_1 : N ;
  vaetekarbonatjon_nn_1 : N ;
  vaetevapen_nn_1 : N ;
  vaetgasmolekyl_nn_1 : N ;
  vaetgasrik_av_1 : A ;
  vaetmedel_nn_1 : N ;
  vaetning_nn_1 : N ;
  vaetska_nn_1 : N ;
  vaetskeansamling_nn_1 : N ;
  vaetskefoerlust_nn_1 : N ;
  vaetskefylld_av_1 : A ;
  vaetskenivaa_nn_1 : N ;
  vaetsketermometer_nn_1 : N ;
  vaetskig_av_1 : A ;
  vaette_nn_1 : N ;
  vaetteljus_nn_1 : N ;
  vaetterroeding_nn_1 : N ;
  vaev_nn_1 : N ;
  vaevare_nn_1 : N ;
  vaevarfaagel_nn_1 : N ;
  vaevarfink_nn_1 : N ;
  vaevarstare_nn_1 : N ;
  vaevburen_av_1 : A ;
  vaeveri_nn_1 : N ;
  vaeverska_nn_1 : N ;
  vaevkaepp_nn_1 : N ;
  vaevkam_nn_1 : N ;
  vaevknut_nn_1 : N ;
  vaevnad_nn_1 : N ;
  vaevning_nn_1 : N ;
  vaevningsmoenster_nn_1 : N ;
  vaevplast_nn_1 : N ;
  vaevskael_nn_1 : N ;
  vaevskaft_nn_1 : N ;
  vaevsked_nn_1 : N ;
  vaevskyttel_nn_1 : N ;
  vaevspaennare_nn_1 : N ;
  vaevstol_nn_1 : N ;
  vaevtyngd_nn_1 : N ;
  vaexel_nn_1 : N ;
  vaexelaccept_nn_1 : N ;
  vaexelaffaer_nn_1 : N ;
  vaexelbord_nn_1 : N ;
  vaexeldiskont_nn_1 : N ;
  vaexeldiskonto_nn_1 : N ;
  vaexelfoerregling_nn_1 : N ;
  vaexelfordran_nn_1 : N ;
  vaexelgaeldenaer_nn_1 : N ;
  vaexelgivare_nn_1 : N ;
  vaexelkassa_nn_1 : N ;
  vaexelkontor_nn_1 : N ;
  vaexelkredit_nn_1 : N ;
  vaexelkurs_nn_1 : N ;
  vaexellok_nn_1 : N ;
  vaexelmynt_nn_1 : N ;
  vaexelomsaettning_nn_1 : N ;
  vaexelryttare_nn_1 : N ;
  vaexelsaang_nn_1 : N ;
  vaexelspaar_nn_1 : N ;
  vaexelspaenning_nn_1 : N ;
  vaexelspak_nn_1 : N ;
  vaexelspel_nn_1 : N ;
  vaexelstaell_nn_1 : N ;
  vaexelstaellverk_nn_1 : N ;
  vaexelstroem_nn_1 : N ;
  vaexeltrassat_nn_1 : N ;
  vaexeltrassent_nn_1 : N ;
  vaexeltunga_nn_1 : N ;
  vaexelutstaellare_nn_1 : N ;
  vaexelvarm_av_1 : A ;
  vaexelvis_ab_1 : Adv ;
  vaexlande_av_1 : A ;
  vaexlare_nn_1 : N ;
  vaexling_nn_1 : N ;
  vaexlingslok_nn_1 : N ;
  vaexlingsrik_av_1 : A ;
  vaext_nn_1 : N ;
  vaextaemne_nn_1 : N ;
  vaextaetande_av_1 : A ;
  vaextaetare_nn_1 : N ;
  vaextart_nn_1 : N ;
  vaextbas_nn_1 : N ;
  vaextcell_nn_1 : N ;
  vaextdel_nn_1 : N ;
  vaextfaerg_nn_1 : N ;
  vaextfaergning_nn_1 : N ;
  vaextfamilj_nn_1 : N ;
  vaextfett_nn_1 : N ;
  vaextfiber_nn_1 : N ;
  vaextfoeljd_nn_1 : N ;
  vaextgift_nn_1 : N ;
  vaextgraens_nn_1 : N ;
  vaexthaemmande_av_1 : A ;
  vaexthormon_nn_1 : N ;
  vaexthus_nn_1 : N ;
  vaextkraftig_av_1 : A ;
  vaextlig_av_1 : A ;
  vaextlighet_nn_1 : N ;
  vaextlokal_nn_1 : N ;
  vaextmargarin_nn_1 : N ;
  vaextperiod_nn_1 : N ;
  vaextplankton_nn_1 : N ;
  vaextplats_nn_1 : N ;
  vaextpress_nn_1 : N ;
  vaextsaesong_nn_1 : N ;
  vaextsaft_nn_1 : N ;
  vaextsamlare_nn_1 : N ;
  vaextsjukdom_nn_1 : N ;
  vaextskott_nn_1 : N ;
  vaextskyddsmedel_nn_1 : N ;
  vaextstam_nn_1 : N ;
  vaextstekel_nn_1 : N ;
  vaexttraad_nn_1 : N ;
  vaextvaevnad_nn_1 : N ;
  vafalls_ab_1 : Adv ;
  vag_av_1 : A ;
  vagabond_nn_1 : N ;
  vagabondnatur_nn_1 : N ;
  vagant_nn_1 : N ;
  vagel_nn_1 : N ;
  vaggsaang_nn_1 : N ;
  vaggtryck_nn_1 : N ;
  vaginal_av_1 : A ;
  vagn_nn_1 : N ;
  vagnbjoern_nn_1 : N ;
  vagnborg_nn_1 : N ;
  vagnhall_nn_1 : N ;
  vagnpark_nn_1 : N ;
  vagnsaett_nn_1 : N ;
  vagnshaeck_nn_1 : N ;
  vagnskadefoersaekring_nn_1 : N ;
  vagnskorg_nn_1 : N ;
  vagnslast_nn_1 : N ;
  vagnslider_nn_1 : N ;
  vajer_nn_1 : N ;
  vajert_ab_1 : Adv ;
  vak_nn_1 : N ;
  vakans_nn_1 : N ;
  vakansfoerordnande_nn_1 : N ;
  vakansvikarie_nn_1 : N ;
  vakant_av_1 : A ;
  vakare_nn_1 : N ;
  vaken_av_1 : A ;
  vakfaagel_nn_1 : N ;
  vaknatt_nn_1 : N ;
  vaksam_av_1 : A ;
  vaksin_nn_1 : N ;
  vaksination_nn_1 : N ;
  vaksinatoer_nn_1 : N ;
  vakt_nn_1 : N ;
  vaktarrest_nn_1 : N ;
  vaktavloesning_nn_1 : N ;
  vaktel_nn_1 : N ;
  vakthaallning_nn_1 : N ;
  vakthavande_av_1 : A ;
  vakthund_nn_1 : N ;
  vaktkur_nn_1 : N ;
  vaktmaestare_nn_1 : N ;
  vaktmaesteri_nn_1 : N ;
  vaktman_nn_1 : N ;
  vaktparad_nn_1 : N ;
  vaktpost_nn_1 : N ;
  vaktstyrka_nn_1 : N ;
  vakuum_nn_1 : N ;
  vakuumbroms_nn_1 : N ;
  vakuumfoerpackning_nn_1 : N ;
  vakuumkammare_nn_1 : N ;
  vakuummateria_nn_1 : N ;
  vakuummeter_nn_1 : N ;
  vakuumpump_nn_1 : N ;
  vakuumregulator_nn_1 : N ;
  vakuumsug_nn_1 : N ;
  vakuumtoalett_nn_1 : N ;
  val_nn_1 : N ;
  val_nn_2 : N ;
  valack_nn_1 : N ;
  valaffisch_nn_1 : N ;
  valapparat_nn_1 : N ;
  valarbetare_nn_1 : N ;
  valbar_av_1 : A ;
  valbarometer_nn_1 : N ;
  valberedning_nn_1 : N ;
  valbiskop_nn_1 : N ;
  valborgsmaessoafton_nn_1 : N ;
  valbyraa_nn_1 : N ;
  valdistrikt_nn_1 : N ;
  valen_av_1 : A ;
  valens_nn_1 : N ;
  valenselektron_nn_1 : N ;
  valenstal_nn_1 : N ;
  valfaangare_nn_1 : N ;
  valfisk_nn_1 : N ;
  valfraendskap_nn_1 : N ;
  valfri_av_1 : A ;
  valfrihet_nn_1 : N ;
  valfurste_nn_1 : N ;
  valhaent_av_1 : A ;
  valhaenthet_nn_1 : N ;
  valhemlighet_nn_1 : N ;
  validitet_nn_1 : N ;
  valium_nn_1 : N ;
  valk_nn_1 : N ;
  valkampanj_nn_1 : N ;
  valkare_nn_1 : N ;
  valkeri_nn_1 : N ;
  valkig_av_1 : A ;
  valkokeri_nn_1 : N ;
  valkrets_nn_1 : N ;
  valkuvert_nn_1 : N ;
  vall_nn_1 : N ;
  vallaengd_nn_1 : N ;
  vallare_nn_1 : N ;
  vallfaerd_nn_1 : N ;
  vallfart_nn_1 : N ;
  vallfartsort_nn_1 : N ;
  vallgrav_nn_1 : N ;
  vallhorn_nn_1 : N ;
  vallhund_nn_1 : N ;
  vallmo_nn_1 : N ;
  vallmofroe_nn_1 : N ;
  vallmovaext_nn_1 : N ;
  vallningstabell_nn_1 : N ;
  vallokal_nn_1 : N ;
  vallon_nn_1 : N ;
  vallonsk_av_1 : A ;
  vallpojke_nn_1 : N ;
  vallvaext_nn_1 : N ;
  valman_nn_1 : N ;
  valmaskineri_nn_1 : N ;
  valmoejlighet_nn_1 : N ;
  valmoete_nn_1 : N ;
  valmtak_nn_1 : N ;
  valnoet_nn_1 : N ;
  valnoetstraed_nn_1 : N ;
  valoer_nn_1 : N ;
  valomgaang_nn_1 : N ;
  valp_nn_1 : N ;
  valpaktig_av_1 : A ;
  valpig_av_1 : A ;
  valplats_nn_1 : N ;
  valresultat_nn_1 : N ;
  valrike_nn_1 : N ;
  valroerelse_nn_1 : N ;
  valross_nn_1 : N ;
  valrossmustasch_nn_1 : N ;
  vals_nn_1 : N ;
  vals_nn_2 : N ;
  valsaett_nn_1 : N ;
  valsedel_nn_1 : N ;
  valseger_nn_1 : N ;
  valsituation_nn_1 : N ;
  valskaerm_nn_1 : N ;
  valsoer_nn_1 : N ;
  valspraak_nn_1 : N ;
  valsverk_nn_1 : N ;
  valthorn_nn_1 : N ;
  valuta_nn_1 : N ;
  valutaaffaer_nn_1 : N ;
  valutabrott_nn_1 : N ;
  valutafond_nn_1 : N ;
  valutaklausul_nn_1 : N ;
  valutakurs_nn_1 : N ;
  valutareglering_nn_1 : N ;
  valutareserv_nn_1 : N ;
  valutasvin_nn_1 : N ;
  valutgaang_nn_1 : N ;
  valv_nn_1 : N ;
  valvbaage_nn_1 : N ;
  valvel_nn_1 : N ;
  valvslagning_nn_1 : N ;
  vamp_nn_1 : N ;
  vampig_av_1 : A ;
  vampyr_nn_1 : N ;
  van_av_1 : A ;
  van_nn_1 : N ;
  vana_nn_1 : N ;
  vanaerande_av_1 : A ;
  vanartig_av_1 : A ;
  vandal_nn_1 : N ;
  vandalisk_av_1 : A ;
  vandrarcell_nn_1 : N ;
  vandrare_nn_1 : N ;
  vandrarfolk_nn_1 : N ;
  vandrarhem_nn_1 : N ;
  vandring_nn_1 : N ;
  vandringsaar_nn_1 : N ;
  vandringscell_nn_1 : N ;
  vandringsfisk_nn_1 : N ;
  vandringsfolk_nn_1 : N ;
  vandringsman_nn_1 : N ;
  vandringspokal_nn_1 : N ;
  vandringspris_nn_1 : N ;
  vandringsutstaellning_nn_1 : N ;
  vandringsvaagroer_nn_1 : N ;
  vanebildande_av_1 : A ;
  vanebildning_nn_1 : N ;
  vanedjur_nn_1 : N ;
  vanedrinkare_nn_1 : N ;
  vanekristen_av_1 : A ;
  vanemaenniska_nn_1 : N ;
  vanemaessig_av_1 : A ;
  vanesak_nn_1 : N ;
  vanfoer_av_1 : A ;
  vanfoerestaellning_nn_1 : N ;
  vanfoerhet_nn_1 : N ;
  vanhederlig_av_1 : A ;
  vanillin_nn_1 : N ;
  vankant_nn_1 : N ;
  vankelmodig_av_1 : A ;
  vanlig_av_1 : A ;
  vanligen_ab_1 : Adv ;
  vanlighet_nn_1 : N ;
  vanligtvis_ab_1 : Adv ;
  vanmaektig_av_1 : A ;
  vansinneskoerning_nn_1 : N ;
  vansinnig_av_1 : A ;
  vanskaplig_av_1 : A ;
  vanskapnad_nn_1 : N ;
  vanskapt_av_1 : A ;
  vanskapthet_nn_1 : N ;
  vansklig_av_1 : A ;
  vanstark_av_1 : A ;
  vanstyrd_av_1 : A ;
  vant_nn_1 : N ;
  vante_nn_1 : N ;
  vantrogen_av_1 : A ;
  vantskruv_nn_1 : N ;
  vantspridare_nn_1 : N ;
  vanvettig_av_1 : A ;
  vanvoerdig_av_1 : A ;
  vanvoerdnad_nn_1 : N ;
  vapen_nn_1 : N ;
  vapenarsenal_nn_1 : N ;
  vapenbok_nn_1 : N ;
  vapenbroder_nn_1 : N ;
  vapendans_nn_1 : N ;
  vapendragare_nn_1 : N ;
  vapenfabrik_nn_1 : N ;
  vapenfoer_av_1 : A ;
  vapenfri_av_1 : A ;
  vapenfynd_nn_1 : N ;
  vapengren_nn_1 : N ;
  vapenhus_nn_1 : N ;
  vapenlek_nn_1 : N ;
  vapenloes_av_1 : A ;
  vapenrock_nn_1 : N ;
  vapenskoeld_nn_1 : N ;
  vapenslag_nn_1 : N ;
  vapensmed_nn_1 : N ;
  vapenstillestaand_nn_1 : N ;
  vapensystem_nn_1 : N ;
  vapentyp_nn_1 : N ;
  vapenvaegrare_nn_1 : N ;
  vapenvila_nn_1 : N ;
  vapoer_nn_1 : N ;
  var_ab_1 : Adv ;
  var_av_1 : A ;
  vara_nn_1 : N ;
  varaktig_av_1 : A ;
  varan_nn_1 : N ;
  varav_ab_1 : Adv ;
  varbildning_nn_1 : N ;
  varbygel_nn_1 : N ;
  vardag_nn_1 : N ;
  vardaglig_av_1 : A ;
  vardagsliv_nn_1 : N ;
  vardagsrum_nn_1 : N ;
  vardagstaenkande_nn_1 : N ;
  varde_nn_1 : N ;
  varefter_ab_1 : Adv ;
  varelse_nn_1 : N ;
  varemot_ab_1 : Adv ;
  varest_ab_1 : Adv ;
  varfaagel_nn_1 : N ;
  varfoer_ab_1 : Adv ;
  varfoere_ab_1 : Adv ;
  varg_nn_1 : N ;
  vargavinter_nn_1 : N ;
  vargering_nn_1 : N ;
  varggrop_nn_1 : N ;
  varghagel_nn_1 : N ;
  varginna_nn_1 : N ;
  vargtimme_nn_1 : N ;
  vargunge_nn_1 : N ;
  varhaerd_nn_1 : N ;
  varhelst_ab_1 : Adv ;
  vari_ab_1 : Adv ;
  varia_nn_1 : N ;
  variabel_av_1 : A ;
  variabel_nn_1 : N ;
  variabilitet_nn_1 : N ;
  varians_nn_1 : N ;
  variant_nn_1 : N ;
  variation_nn_1 : N ;
  variationsbredd_nn_1 : N ;
  variationsinstrument_nn_1 : N ;
  variator_nn_1 : N ;
  varibland_ab_1 : Adv ;
  variete_nn_1 : N ;
  varieteartist_nn_1 : N ;
  varietet_nn_1 : N ;
  varifraan_ab_1 : Adv ;
  varig_av_1 : A ;
  varigenom_ab_1 : Adv ;
  variometer_nn_1 : N ;
  varjaemte_ab_1 : Adv ;
  varjag_nn_1 : N ;
  varjehanda_av_1 : A ;
  varken_ab_1 : Adv ;
  varkunnsam_av_1 : A ;
  varlig_av_1 : A ;
  varliga_ab_1 : Adv ;
  varligen_ab_1 : Adv ;
  varm_av_1 : A ;
  varmbad_nn_1 : N ;
  varmblod_nn_1 : N ;
  varmblodig_av_1 : A ;
  varmbraeckt_av_1 : A ;
  varmed_ab_1 : Adv ;
  varmfront_nn_1 : N ;
  varmgarage_nn_1 : N ;
  varmhaallning_nn_1 : N ;
  varmluftsridaa_nn_1 : N ;
  varmluftssystem_nn_1 : N ;
  varmraett_nn_1 : N ;
  varmvatten_nn_1 : N ;
  varmvattenberedare_nn_1 : N ;
  varmvattensystem_nn_1 : N ;
  varning_nn_1 : N ;
  varningsmaerke_nn_1 : N ;
  varningssignal_nn_1 : N ;
  varningstriangel_nn_1 : N ;
  varoever_ab_1 : Adv ;
  varom_ab_1 : Adv ;
  varp_nn_1 : N ;
  varp_nn_2 : N ;
  varpaa_ab_1 : Adv ;
  varpbom_nn_1 : N ;
  varpning_nn_1 : N ;
  varptraad_nn_1 : N ;
  varsam_av_1 : A ;
  varse_ab_1 : Adv ;
  varsel_nn_1 : N ;
  varsomhelst_ab_1 : Adv ;
  varstaedes_ab_1 : Adv ;
  vart_ab_1 : Adv ;
  vartaat_ab_1 : Adv ;
  vartefter_ab_1 : Adv ;
  varthaen_ab_1 : Adv ;
  varthelst_ab_1 : Adv ;
  vartill_ab_1 : Adv ;
  vartsomhelst_ab_1 : Adv ;
  varubeteckning_nn_1 : N ;
  varubil_nn_1 : N ;
  varubud_nn_1 : N ;
  varubuss_nn_1 : N ;
  varudeklaration_nn_1 : N ;
  varufakta_nn_1 : N ;
  varuhavare_nn_1 : N ;
  varuhus_nn_1 : N ;
  varuintag_nn_1 : N ;
  varulaan_nn_1 : N ;
  varulv_nn_1 : N ;
  varumaengd_nn_1 : N ;
  varumaerke_nn_1 : N ;
  varunder_ab_1 : Adv ;
  varuparti_nn_1 : N ;
  varupris_nn_1 : N ;
  varuprov_nn_1 : N ;
  varur_ab_1 : Adv ;
  varuskatt_nn_1 : N ;
  varuti_ab_1 : Adv ;
  varutinnan_ab_1 : Adv ;
  varutransport_nn_1 : N ;
  varuvagn_nn_1 : N ;
  varv_nn_1 : N ;
  varvid_ab_1 : Adv ;
  varvidlag_ab_1 : Adv ;
  varvig_av_1 : A ;
  varvmaetare_nn_1 : N ;
  varvraeknare_nn_1 : N ;
  varvsindustri_nn_1 : N ;
  varvtal_nn_1 : N ;
  vas_nn_1 : N ;
  vasall_nn_1 : N ;
  vasallstat_nn_1 : N ;
  vasaorden_nn_1 : N ;
  vase_nn_1 : N ;
  vasektomi_nn_1 : N ;
  vask_nn_1 : N ;
  vasker_nn_1 : N ;
  vaskulaer_av_1 : A ;
  vasomotorisk_av_1 : A ;
  vass_av_1 : A ;
  vass_nn_1 : N ;
  vasslig_av_1 : A ;
  vassroer_nn_1 : N ;
  vassrugge_nn_1 : N ;
  vaterbom_nn_1 : N ;
  vaterbord_nn_1 : N ;
  vatikansk_av_1 : A ;
  vattblaa_av_1 : A ;
  vatten_nn_1 : N ;
  vattenavstoetande_av_1 : A ;
  vattenavvisande_av_1 : A ;
  vattenbad_nn_1 : N ;
  vattenbehaallare_nn_1 : N ;
  vattenbi_nn_1 : N ;
  vattenblaa_av_1 : A ;
  vattenbrist_nn_1 : N ;
  vattenbruk_nn_1 : N ;
  vattenburen_av_1 : A ;
  vattenbyggnad_nn_1 : N ;
  vattencykel_nn_1 : N ;
  vattendelare_nn_1 : N ;
  vattendjup_nn_1 : N ;
  vattendjur_nn_1 : N ;
  vattendomstol_nn_1 : N ;
  vattendrag_nn_1 : N ;
  vattendrivande_av_1 : A ;
  vattendriven_av_1 : A ;
  vattendroppe_nn_1 : N ;
  vattenfaagel_nn_1 : N ;
  vattenfaerg_nn_1 : N ;
  vattenfall_nn_1 : N ;
  vattenfas_nn_1 : N ;
  vattenfast_av_1 : A ;
  vattenfoerorening_nn_1 : N ;
  vattenfylld_av_1 : A ;
  vattengel_nn_1 : N ;
  vattenglas_nn_1 : N ;
  vattenhaal_nn_1 : N ;
  vattenhalt_nn_1 : N ;
  vattenhjul_nn_1 : N ;
  vattenhyacint_nn_1 : N ;
  vattenkaenslig_av_1 : A ;
  vattenkanon_nn_1 : N ;
  vattenklosett_nn_1 : N ;
  vattenkokare_nn_1 : N ;
  vattenkraftverk_nn_1 : N ;
  vattenkran_nn_1 : N ;
  vattenkultur_nn_1 : N ;
  vattenkvarn_nn_1 : N ;
  vattenkyld_av_1 : A ;
  vattenlaas_nn_1 : N ;
  vattenled_nn_1 : N ;
  vattenledning_nn_1 : N ;
  vattenledningsvatten_nn_1 : N ;
  vattenlevande_av_1 : A ;
  vattenlinje_nn_1 : N ;
  vattenlist_nn_1 : N ;
  vattenloepare_nn_1 : N ;
  vattenloeslig_av_1 : A ;
  vattenloeslighet_nn_1 : N ;
  vattenloesning_nn_1 : N ;
  vattenmaerke_nn_1 : N ;
  vattenmelon_nn_1 : N ;
  vattennivaa_nn_1 : N ;
  vattennymf_nn_1 : N ;
  vattenorganism_nn_1 : N ;
  vattenpass_nn_1 : N ;
  vattenpelare_nn_1 : N ;
  vattenpistol_nn_1 : N ;
  vattenpoel_nn_1 : N ;
  vattenpost_nn_1 : N ;
  vattenprov_nn_1 : N ;
  vattenpump_nn_1 : N ;
  vattenpuss_nn_1 : N ;
  vattenrallare_nn_1 : N ;
  vattenreglering_nn_1 : N ;
  vattenreningsverk_nn_1 : N ;
  vattenring_nn_1 : N ;
  vattensamling_nn_1 : N ;
  vattensjuk_av_1 : A ;
  vattenskalle_nn_1 : N ;
  vattenskinnbagge_nn_1 : N ;
  vattenskott_nn_1 : N ;
  vattenslang_nn_1 : N ;
  vattenspindel_nn_1 : N ;
  vattenspridare_nn_1 : N ;
  vattenstaand_nn_1 : N ;
  vattenstaandsroer_nn_1 : N ;
  vattenstaandsvisare_nn_1 : N ;
  vattenstaempel_nn_1 : N ;
  vattenstaenk_nn_1 : N ;
  vattenstraale_nn_1 : N ;
  vattenstroem_nn_1 : N ;
  vattensvin_nn_1 : N ;
  vattentaalig_av_1 : A ;
  vattentaekt_nn_1 : N ;
  vattentaet_av_1 : A ;
  vattentemperatur_nn_1 : N ;
  vattentorn_nn_1 : N ;
  vattentroeskel_nn_1 : N ;
  vattenturbin_nn_1 : N ;
  vattenur_nn_1 : N ;
  vattenvaeg_nn_1 : N ;
  vattenvaerde_nn_1 : N ;
  vattenvaermare_nn_1 : N ;
  vattenvaesen_nn_1 : N ;
  vattenvaext_nn_1 : N ;
  vattenverk_nn_1 : N ;
  vattnare_nn_1 : N ;
  vattnig_av_1 : A ;
  vattrig_av_1 : A ;
  vattring_nn_1 : N ;
  vaudeville_nn_1 : N ;
  vax_nn_1 : N ;
  vaxavtryck_nn_1 : N ;
  vaxduk_nn_1 : N ;
  vaxkabinett_nn_1 : N ;
  vaxliknande_av_1 : A ;
  vaxljus_nn_1 : N ;
  vaxpropp_nn_1 : N ;
  vaxsigill_nn_1 : N ;
  vaxskivling_nn_1 : N ;
  vaxstapel_nn_1 : N ;
  vaxtavla_nn_1 : N ;
  veck_nn_1 : N ;
  vecka_nn_1 : N ;
  veckberg_nn_1 : N ;
  veckig_av_1 : A ;
  vecklare_nn_1 : N ;
  veckning_nn_1 : N ;
  veckoaenda_nn_1 : N ;
  veckoavdelning_nn_1 : N ;
  veckobiljett_nn_1 : N ;
  veckodag_nn_1 : N ;
  veckohelg_nn_1 : N ;
  veckopeng_nn_1 : N ;
  veckoslut_nn_1 : N ;
  veckotidning_nn_1 : N ;
  veckotimme_nn_1 : N ;
  veckovis_ab_1 : Adv ;
  vedbacke_nn_1 : N ;
  vedbaerare_nn_1 : N ;
  vedbod_nn_1 : N ;
  vedborre_nn_1 : N ;
  vedbrand_nn_1 : N ;
  vederboerande_av_1 : A ;
  vederboerlig_av_1 : A ;
  vederboerligen_ab_1 : Adv ;
  vederdeloman_nn_1 : N ;
  vederdoepare_nn_1 : N ;
  vederhaeftig_av_1 : A ;
  vederkvickelse_nn_1 : N ;
  vederlag_nn_1 : N ;
  vederlike_nn_1 : N ;
  vedermoeda_nn_1 : N ;
  vedernamn_nn_1 : N ;
  vederpart_nn_1 : N ;
  vedersakare_nn_1 : N ;
  vederstygglig_av_1 : A ;
  vedertagen_av_1 : A ;
  vedervaerdig_av_1 : A ;
  vedervaerdighet_nn_1 : N ;
  vedettbaat_nn_1 : N ;
  vedfaang_nn_1 : N ;
  vedhuggare_nn_1 : N ;
  vedhuggning_nn_1 : N ;
  vedisk_av_1 : A ;
  vedkap_nn_1 : N ;
  vedlaar_nn_1 : N ;
  vedpinne_nn_1 : N ;
  vedsaag_nn_1 : N ;
  vedspis_nn_1 : N ;
  vedstam_nn_1 : N ;
  vedtrae_nn_1 : N ;
  vegan_nn_1 : N ;
  vegetabilisk_av_1 : A ;
  vegetarian_nn_1 : N ;
  vegetariansk_av_1 : A ;
  vegetarisk_av_1 : A ;
  vegetation_nn_1 : N ;
  vegetationsbaelte_nn_1 : N ;
  vegetationsknopp_nn_1 : N ;
  vegetationsperiod_nn_1 : N ;
  vegetationszon_nn_1 : N ;
  vegetativ_av_1 : A ;
  vehikel_nn_1 : N ;
  vek_av_1 : A ;
  veke_nn_1 : N ;
  veklig_av_1 : A ;
  veklighet_nn_1 : N ;
  vekling_nn_1 : N ;
  vektor_nn_1 : N ;
  velar_av_1 : A ;
  velar_nn_1 : N ;
  vele_nn_1 : N ;
  velig_av_1 : A ;
  veling_nn_1 : N ;
  velociped_nn_1 : N ;
  velodrom_nn_1 : N ;
  velourpappa_nn_1 : N ;
  vemodig_av_1 : A ;
  ven_nn_1 : N ;
  vend_nn_1 : N ;
  vendisk_av_1 : A ;
  venerabel_av_1 : A ;
  venereolog_nn_1 : N ;
  venereologisk_av_1 : A ;
  venerisk_av_1 : A ;
  venetian_nn_1 : N ;
  venetianare_nn_1 : N ;
  venetiansk_av_1 : A ;
  venezuelan_nn_1 : N ;
  venoes_av_1 : A ;
  ventil_nn_1 : N ;
  ventilation_nn_1 : N ;
  ventilationsflaekt_nn_1 : N ;
  ventilator_nn_1 : N ;
  ventilbasun_nn_1 : N ;
  ventilgummi_nn_1 : N ;
  ventilhatt_nn_1 : N ;
  ventilhus_nn_1 : N ;
  ventrikel_nn_1 : N ;
  venusberg_nn_1 : N ;
  verb_nn_1 : N ;
  verbaendelse_nn_1 : N ;
  verbal_av_1 : A ;
  verbalabstrakt_nn_1 : N ;
  verbalfaktor_nn_1 : N ;
  verbaliter_ab_1 : Adv ;
  verbalitet_nn_1 : N ;
  verbalnot_nn_1 : N ;
  verbalstam_nn_1 : N ;
  verbalsubstantiv_nn_1 : N ;
  verbform_nn_1 : N ;
  verbhandling_nn_1 : N ;
  verbsammansaettning_nn_1 : N ;
  verbstam_nn_1 : N ;
  verifikat_nn_1 : N ;
  verifikation_nn_1 : N ;
  veritabel_av_1 : A ;
  verk_nn_1 : N ;
  verkbord_nn_1 : N ;
  verkhelig_av_1 : A ;
  verkjaern_nn_1 : N ;
  verklig_av_1 : A ;
  verkligen_ab_1 : Adv ;
  verklighet_nn_1 : N ;
  verklighetsbakgrund_nn_1 : N ;
  verklighetsfraemmande_av_1 : A ;
  verklighetsnaera_av_1 : A ;
  verklighetstrogen_av_1 : A ;
  verkmaestare_nn_1 : N ;
  verkning_nn_1 : N ;
  verkningsfull_av_1 : A ;
  verkningsgrad_nn_1 : N ;
  verkningsloes_av_1 : A ;
  verksam_av_1 : A ;
  verksamhet_nn_1 : N ;
  verksamhetsaar_nn_1 : N ;
  verksamhetsbehov_nn_1 : N ;
  verksamhetsberaettelse_nn_1 : N ;
  verksamhetsfaelt_nn_1 : N ;
  verkslaekare_nn_1 : N ;
  verkstad_nn_1 : N ;
  verkstadsarbetare_nn_1 : N ;
  verkstadsfoerening_nn_1 : N ;
  verkstadshus_nn_1 : N ;
  verkstadsindustri_nn_1 : N ;
  verkstadsklubb_nn_1 : N ;
  verkstaellande_av_1 : A ;
  verkstaellighet_nn_1 : N ;
  verksynd_nn_1 : N ;
  verktum_nn_1 : N ;
  verktyg_nn_1 : N ;
  verktygsmaskin_nn_1 : N ;
  verktygssats_nn_1 : N ;
  vernalisering_nn_1 : N ;
  vernissage_nn_1 : N ;
  vers_nn_1 : N ;
  versal_nn_1 : N ;
  versatil_av_1 : A ;
  versberaettelse_nn_1 : N ;
  versbindning_nn_1 : N ;
  versfot_nn_1 : N ;
  versifikation_nn_1 : N ;
  versifikatoer_nn_1 : N ;
  version_nn_1 : N ;
  verslaera_nn_1 : N ;
  versmaatt_nn_1 : N ;
  versmakare_nn_1 : N ;
  versrad_nn_1 : N ;
  verst_nn_1 : N ;
  vertebrat_nn_1 : N ;
  vertikal_av_1 : A ;
  vertikal_nn_1 : N ;
  vertikalcirkel_nn_1 : N ;
  vertikalplan_nn_1 : N ;
  vertikalstroem_nn_1 : N ;
  vertikalvinkel_nn_1 : N ;
  vesaell_av_1 : A ;
  vesir_nn_1 : N ;
  vesper_nn_1 : N ;
  vestal_nn_1 : N ;
  vestalisk_av_1 : A ;
  vestibul_nn_1 : N ;
  vetande_av_1 : A ;
  vetbar_av_1 : A ;
  vetebroed_nn_1 : N ;
  vetebulle_nn_1 : N ;
  vetegrodd_nn_1 : N ;
  vetekorn_nn_1 : N ;
  vetekrans_nn_1 : N ;
  vetenskap_nn_1 : N ;
  vetenskapare_nn_1 : N ;
  vetenskaplig_av_1 : A ;
  vetenskapsakademi_nn_1 : N ;
  vetenskapsman_nn_1 : N ;
  veteran_nn_1 : N ;
  veteranbil_nn_1 : N ;
  veterinaer_nn_1 : N ;
  veterligen_ab_1 : Adv ;
  veterligt_ab_1 : Adv ;
  vetesort_nn_1 : N ;
  vetgirig_av_1 : A ;
  veto_nn_1 : N ;
  vette_nn_1 : N ;
  vettig_av_1 : A ;
  vettloes_av_1 : A ;
  vettskraemd_av_1 : A ;
  vettvillig_av_1 : A ;
  vettvilling_nn_1 : N ;
  vev_nn_1 : N ;
  vevarm_nn_1 : N ;
  vevaxel_nn_1 : N ;
  vevhus_nn_1 : N ;
  vevling_nn_1 : N ;
  vevstaang_nn_1 : N ;
  vevstake_nn_1 : N ;
  vevtapp_nn_1 : N ;
  vi_ab_1 : Adv ;
  viadukt_nn_1 : N ;
  vial_nn_1 : N ;
  vibrafon_nn_1 : N ;
  vibrant_nn_1 : N ;
  vibration_nn_1 : N ;
  vibrato_nn_1 : N ;
  vibrator_nn_1 : N ;
  vibrion_nn_1 : N ;
  vice_av_1 : A ;
  viceamiral_nn_1 : N ;
  vicekonung_nn_1 : N ;
  vicekorpral_nn_1 : N ;
  vicekung_nn_1 : N ;
  vicepresident_nn_1 : N ;
  vicevaerd_nn_1 : N ;
  vichyvatten_nn_1 : N ;
  vick_nn_1 : N ;
  vickel_nn_1 : N ;
  vickig_av_1 : A ;
  vickning_nn_1 : N ;
  victoriansk_av_1 : A ;
  vid_ab_1 : Adv ;
  vid_av_1 : A ;
  vida_ab_1 : Adv ;
  vidareutbildning_nn_1 : N ;
  vidbraend_av_1 : A ;
  vidd_nn_1 : N ;
  video_nn_1 : N ;
  videoband_nn_1 : N ;
  videobandspelare_nn_1 : N ;
  videosignal_nn_1 : N ;
  viderboende_nn_1 : N ;
  vidertryck_nn_1 : N ;
  videsparv_nn_1 : N ;
  vidfilm_nn_1 : N ;
  vidhaalla_vb_1 : V ;
  vidhaeftning_nn_1 : N ;
  vidi_ab_1 : Adv ;
  vidimation_nn_1 : N ;
  vidimering_nn_1 : N ;
  vidja_nn_1 : N ;
  vidlyftig_av_1 : A ;
  vidmakthaalla_vb_1 : V ;
  vidoeppen_av_1 : A ;
  vidraekning_nn_1 : N ;
  vidrig_av_1 : A ;
  vidskepelse_nn_1 : N ;
  vidskeplig_av_1 : A ;
  vidstaaende_av_1 : A ;
  vidstraeckt_av_1 : A ;
  vidsynt_av_1 : A ;
  vidsynthet_nn_1 : N ;
  vidta_vb_1 : V ;
  vidunder_nn_1 : N ;
  vidunderlig_av_1 : A ;
  vidvinkelobjektiv_nn_1 : N ;
  vielle_nn_1 : N ;
  vietnames_nn_1 : N ;
  vietnamesisk_av_1 : A ;
  vietnamesiska_nn_2 : N ;
  vig_av_1 : A ;
  vigg_nn_1 : N ;
  vigge_nn_1 : N ;
  vigkvast_nn_1 : N ;
  vigsel_nn_1 : N ;
  vigselannons_nn_1 : N ;
  vigselbevis_nn_1 : N ;
  vigselformulaer_nn_1 : N ;
  vigselring_nn_1 : N ;
  vigselrum_nn_1 : N ;
  vik_nn_1 : N ;
  vika_ab_1 : Adv ;
  vika_vb_1 : V ;
  vikare_nn_1 : N ;
  vikariat_nn_1 : N ;
  vikarie_nn_1 : N ;
  vikarierande_av_1 : A ;
  vikdoerr_nn_1 : N ;
  viking_nn_1 : N ;
  vikingagrav_nn_1 : N ;
  vikingaskepp_nn_1 : N ;
  vikingataag_nn_1 : N ;
  vikning_nn_1 : N ;
  vikon_nn_1 : N ;
  vikt_nn_1 : N ;
  viktenhet_nn_1 : N ;
  viktfoerlust_nn_1 : N ;
  viktig_av_1 : A ;
  viktighetsmakare_nn_1 : N ;
  viktigpetter_nn_1 : N ;
  viktjusterare_nn_1 : N ;
  viktklass_nn_1 : N ;
  viktloes_av_1 : A ;
  viktminskning_nn_1 : N ;
  viktoriansk_av_1 : A ;
  viktprocent_nn_1 : N ;
  viktskillnad_nn_1 : N ;
  viktsystem_nn_1 : N ;
  viktualiehandel_nn_1 : N ;
  vila_nn_1 : N ;
  vild_av_1 : A ;
  vildand_nn_1 : N ;
  vildapel_nn_1 : N ;
  vildbasare_nn_1 : N ;
  vilddjur_nn_1 : N ;
  vilde_nn_1 : N ;
  vildfaagel_nn_1 : N ;
  vildgaas_nn_1 : N ;
  vildgraes_nn_1 : N ;
  vilding_nn_1 : N ;
  vildkanin_nn_1 : N ;
  vildkatt_nn_1 : N ;
  vildmark_nn_1 : N ;
  vildnad_nn_1 : N ;
  vildren_nn_1 : N ;
  vildrensjakt_nn_1 : N ;
  vildsint_av_1 : A ;
  vildskott_nn_1 : N ;
  vildstam_nn_1 : N ;
  vildsvin_nn_1 : N ;
  vildvuxen_av_1 : A ;
  vilfaatoelj_nn_1 : N ;
  vilja_nn_1 : N ;
  viljeakt_nn_1 : N ;
  viljeanstraengning_nn_1 : N ;
  viljefoerklaring_nn_1 : N ;
  viljehandling_nn_1 : N ;
  viljeloes_av_1 : A ;
  viljemaenniska_nn_1 : N ;
  viljemaessig_av_1 : A ;
  viljestark_av_1 : A ;
  viljesvag_av_1 : A ;
  viljeyttring_nn_1 : N ;
  vill_ab_1 : Adv ;
  villa_nn_1 : N ;
  villande_av_1 : A ;
  villanell_nn_1 : N ;
  villaservitut_nn_1 : N ;
  villebraad_nn_1 : N ;
  villfara_vb_1 : V ;
  villfarelse_nn_1 : N ;
  villig_av_1 : A ;
  villkor_nn_1 : N ;
  villkorlig_av_1 : A ;
  villkorsbisats_nn_1 : N ;
  villkorskonjunktion_nn_1 : N ;
  villkorsloes_av_1 : A ;
  villolaera_nn_1 : N ;
  villospaar_nn_1 : N ;
  villovaeg_nn_1 : N ;
  villraadig_av_1 : A ;
  villsam_av_1 : A ;
  vilodag_nn_1 : N ;
  vilohem_nn_1 : N ;
  vilolaege_nn_1 : N ;
  vilolaeger_nn_1 : N ;
  vilopaus_nn_1 : N ;
  viloplats_nn_1 : N ;
  vilopunkt_nn_1 : N ;
  vilorum_nn_1 : N ;
  vilostadium_nn_1 : N ;
  vilrum_nn_1 : N ;
  vilsam_av_1 : A ;
  vilse_ab_1 : Adv ;
  vilsegaangen_av_1 : A ;
  vilsekommen_av_1 : A ;
  vilseledande_av_1 : A ;
  vilsen_av_1 : A ;
  vilstol_nn_1 : N ;
  vilthandlare_nn_1 : N ;
  viltplantering_nn_1 : N ;
  viltspegel_nn_1 : N ;
  viltstraak_nn_1 : N ;
  vimmelkantig_av_1 : A ;
  vimpel_nn_1 : N ;
  vimpelprydd_av_1 : A ;
  vimperg_nn_1 : N ;
  vimsig_av_1 : A ;
  vin_nn_1 : N ;
  vinaar_nn_1 : N ;
  vinare_nn_1 : N ;
  vinbaal_nn_1 : N ;
  vinbaer_nn_1 : N ;
  vinbaersbuske_nn_1 : N ;
  vind_av_1 : A ;
  vind_nn_1 : N ;
  vind_nn_2 : N ;
  vindaegg_nn_1 : N ;
  vindaendring_nn_1 : N ;
  vindbaelte_nn_1 : N ;
  vindboejtel_nn_1 : N ;
  vindbro_nn_1 : N ;
  vindby_nn_1 : N ;
  vinddriven_av_1 : A ;
  vindel_nn_1 : N ;
  vindfaang_nn_1 : N ;
  vindfloejel_nn_1 : N ;
  vindfoerhaallande_nn_1 : N ;
  vindhastighet_nn_1 : N ;
  vindil_nn_1 : N ;
  vindkantring_nn_1 : N ;
  vindkraftverk_nn_1 : N ;
  vindling_nn_1 : N ;
  vindmaetare_nn_1 : N ;
  vindmaetning_nn_1 : N ;
  vindmaetningsinstrument_nn_1 : N ;
  vindoega_nn_1 : N ;
  vindoegd_av_1 : A ;
  vindpollinering_nn_1 : N ;
  vindraett_ab_1 : Adv ;
  vindriktning_nn_1 : N ;
  vindruta_nn_1 : N ;
  vindrutespolare_nn_1 : N ;
  vindrutetorkare_nn_1 : N ;
  vindsida_nn_1 : N ;
  vindskaerm_nn_1 : N ;
  vindskammare_nn_1 : N ;
  vindskontor_nn_1 : N ;
  vindskydd_nn_1 : N ;
  vindspel_nn_1 : N ;
  vindstilla_av_1 : A ;
  vindstoet_nn_1 : N ;
  vindstyrka_nn_1 : N ;
  vindsutrymme_nn_1 : N ;
  vindtaet_av_1 : A ;
  vindtunnel_nn_1 : N ;
  vindvridning_nn_1 : N ;
  ving_nn_1 : N ;
  vingaard_nn_1 : N ;
  vingaardsarbetare_nn_1 : N ;
  vingaardsman_nn_1 : N ;
  vingbredd_nn_1 : N ;
  vingbruten_av_1 : A ;
  vinge_nn_1 : N ;
  vingelpelle_nn_1 : N ;
  vingfrukt_nn_1 : N ;
  vingklaff_nn_1 : N ;
  vinglas_nn_1 : N ;
  vinglig_av_1 : A ;
  vingloes_av_1 : A ;
  vingmutter_nn_1 : N ;
  vingplog_nn_1 : N ;
  vingslag_nn_1 : N ;
  vingspegel_nn_1 : N ;
  vingspets_nn_1 : N ;
  vingtaeckare_nn_1 : N ;
  vingteckning_nn_1 : N ;
  vingud_nn_1 : N ;
  vingummi_nn_1 : N ;
  vinjett_nn_1 : N ;
  vink_nn_1 : N ;
  vinkaennare_nn_1 : N ;
  vinkel_nn_1 : N ;
  vinkelarm_nn_1 : N ;
  vinkelavstaand_nn_1 : N ;
  vinkelben_nn_1 : N ;
  vinkelborr_nn_1 : N ;
  vinkelhake_nn_1 : N ;
  vinkelhastighet_nn_1 : N ;
  vinkelhus_nn_1 : N ;
  vinkeljaern_nn_1 : N ;
  vinkelknae_nn_1 : N ;
  vinkellinjal_nn_1 : N ;
  vinkelmaatt_nn_1 : N ;
  vinkelpredikant_nn_1 : N ;
  vinkelraet_av_1 : A ;
  vinkelskillnad_nn_1 : N ;
  vinkelspets_nn_1 : N ;
  vinkelsumma_nn_1 : N ;
  vinkling_nn_1 : N ;
  vinkork_nn_1 : N ;
  vinland_nn_1 : N ;
  vinloev_nn_1 : N ;
  vinlus_nn_1 : N ;
  vinmaerke_nn_1 : N ;
  vinn_ab_1 : Adv ;
  vinna_vb_1 : V ;
  vinnande_av_1 : A ;
  vinnare_nn_1 : N ;
  vinnarhaal_nn_1 : N ;
  vinningslysten_av_1 : A ;
  vinningslystnad_nn_1 : N ;
  vinodlare_nn_1 : N ;
  vinraettighet_nn_1 : N ;
  vinroed_av_1 : A ;
  vinsch_nn_1 : N ;
  vinservering_nn_1 : N ;
  vinskaenk_nn_1 : N ;
  vinskoerd_nn_1 : N ;
  vinsort_nn_1 : N ;
  vinst_nn_1 : N ;
  vinstandel_nn_1 : N ;
  vinstchans_nn_1 : N ;
  vinstdelning_nn_1 : N ;
  vinstdelningsskatt_nn_1 : N ;
  vinstmarginal_nn_1 : N ;
  vinstnummer_nn_1 : N ;
  vinstock_nn_1 : N ;
  vinstplan_nn_1 : N ;
  vinstuga_nn_1 : N ;
  vintagevin_nn_1 : N ;
  vinter_nn_1 : N ;
  vinterbadare_nn_1 : N ;
  vinterblaa_av_1 : A ;
  vinterbostad_nn_1 : N ;
  vinterdaeck_nn_1 : N ;
  vinterdraekt_nn_1 : N ;
  vinterfoder_nn_1 : N ;
  vinterfrukt_nn_1 : N ;
  vintergroen_av_1 : A ;
  vinterhaerdig_av_1 : A ;
  vinterhalvaar_nn_1 : N ;
  vinterhimmel_nn_1 : N ;
  vinterkvaell_nn_1 : N ;
  vinterlandskap_nn_1 : N ;
  vinterlig_av_1 : A ;
  vinterliggare_nn_1 : N ;
  vintermaanad_nn_1 : N ;
  vinternatt_nn_1 : N ;
  vinterpaeron_nn_1 : N ;
  vinterskinn_nn_1 : N ;
  vinterspaarvagn_nn_1 : N ;
  vintersport_nn_1 : N ;
  vinterstaand_nn_1 : N ;
  vintertraedgaard_nn_1 : N ;
  vintervaeg_nn_1 : N ;
  vintervaeglag_nn_1 : N ;
  vintervila_nn_1 : N ;
  vinthund_nn_1 : N ;
  vintrig_av_1 : A ;
  viol_nn_1 : N ;
  violblaa_av_1 : A ;
  violett_av_1 : A ;
  violin_nn_1 : N ;
  violinist_nn_1 : N ;
  violinklav_nn_1 : N ;
  violoncell_nn_1 : N ;
  vip_nn_1 : N ;
  vipp_nn_1 : N ;
  vippbraede_nn_1 : N ;
  vippig_av_1 : A ;
  vippkoppling_nn_1 : N ;
  vippstjaert_nn_1 : N ;
  viprum_nn_1 : N ;
  vips_ab_1 : Adv ;
  virginiahjort_nn_1 : N ;
  viril_av_1 : A ;
  virilitet_nn_1 : N ;
  virkeskvalitet_nn_1 : N ;
  virkesmaetning_nn_1 : N ;
  virkgarn_nn_1 : N ;
  virkkrok_nn_1 : N ;
  virknaal_nn_1 : N ;
  virkning_nn_1 : N ;
  virolog_nn_1 : N ;
  virrig_av_1 : A ;
  virtuell_av_1 : A ;
  virtuos_av_1 : A ;
  virtuos_nn_1 : N ;
  virtuositet_nn_1 : N ;
  virtuosmaessig_av_1 : A ;
  virtuosnummer_nn_1 : N ;
  virulent_av_1 : A ;
  virus_nn_1 : N ;
  virusinfektion_nn_1 : N ;
  virussjukdom_nn_1 : N ;
  virvel_nn_1 : N ;
  virvelroerelse_nn_1 : N ;
  virvelstorm_nn_1 : N ;
  virvelstroem_nn_1 : N ;
  virvelvind_nn_1 : N ;
  vis_av_1 : A ;
  vis_nn_1 : N ;
  visafton_nn_1 : N ;
  visare_nn_1 : N ;
  visarkiv_nn_1 : N ;
  visbok_nn_1 : N ;
  viscount_nn_1 : N ;
  visdom_nn_1 : N ;
  visdomsord_nn_1 : N ;
  visdomstand_nn_1 : N ;
  vise_nn_1 : N ;
  visefall_nn_1 : N ;
  visent_nn_1 : N ;
  viseringskort_nn_1 : N ;
  vishet_nn_1 : N ;
  vishetslaera_nn_1 : N ;
  visibel_av_1 : A ;
  vision_nn_1 : N ;
  visionaer_av_1 : A ;
  visir_nn_1 : N ;
  visit_nn_1 : N ;
  visitation_nn_1 : N ;
  visitator_nn_1 : N ;
  visitering_nn_1 : N ;
  visitkort_nn_1 : N ;
  viskare_nn_1 : N ;
  viskning_nn_1 : N ;
  viskoes_av_1 : A ;
  viskositet_nn_1 : N ;
  vislig_av_1 : A ;
  visligen_ab_1 : Adv ;
  visman_nn_1 : N ;
  visning_nn_1 : N ;
  visp_nn_1 : N ;
  visper_nn_1 : N ;
  vispig_av_1 : A ;
  viss_av_1 : A ;
  vissen_av_1 : A ;
  visserligen_ab_1 : Adv ;
  visshet_nn_1 : N ;
  vissla_nn_1 : N ;
  vissling_nn_1 : N ;
  visst_ab_1 : Adv ;
  visstidsfoerordnande_nn_1 : N ;
  vistelse_nn_1 : N ;
  vistelseort_nn_1 : N ;
  visthus_nn_1 : N ;
  visthusbod_nn_1 : N ;
  visuell_av_1 : A ;
  visum_nn_1 : N ;
  vit_av_1 : A ;
  vitaktig_av_1 : A ;
  vital_av_1 : A ;
  vitalbehov_nn_1 : N ;
  vitalf_nn_1 : N ;
  vitalfoernimmelse_nn_1 : N ;
  vitalitet_nn_1 : N ;
  vitalkapacitet_nn_1 : N ;
  vitalv_nn_1 : N ;
  vitamin_nn_1 : N ;
  vitamininjektion_nn_1 : N ;
  vitaminrik_av_1 : A ;
  vitbok_nn_1 : N ;
  vitbroderi_nn_1 : N ;
  vitfisk_nn_1 : N ;
  vitgloedande_av_1 : A ;
  vitgroen_av_1 : A ;
  vithaarig_av_1 : A ;
  vithet_nn_1 : N ;
  vithyllt_av_1 : A ;
  vitling_nn_1 : N ;
  vitloek_nn_1 : N ;
  vitmetall_nn_1 : N ;
  vitmoegelost_nn_1 : N ;
  vitnos_nn_1 : N ;
  vitplister_nn_1 : N ;
  vitraev_nn_1 : N ;
  vitrin_nn_1 : N ;
  vitrinskaap_nn_1 : N ;
  vitrock_nn_1 : N ;
  vitrysk_av_1 : A ;
  vitryska_nn_2 : N ;
  vitryss_nn_1 : N ;
  vits_nn_1 : N ;
  vitsig_av_1 : A ;
  vitsord_nn_1 : N ;
  vitsvanshjort_nn_1 : N ;
  vittbekant_av_1 : A ;
  vittberest_av_1 : A ;
  vittberoemd_av_1 : A ;
  vitter_av_1 : A ;
  vitterhet_nn_1 : N ;
  vitterlek_nn_1 : N ;
  vittfamnande_av_1 : A ;
  vittflygande_av_1 : A ;
  vittgaaende_av_1 : A ;
  vittling_nn_1 : N ;
  vittne_nn_1 : N ;
  vittnesbaas_nn_1 : N ;
  vittnesboerd_nn_1 : N ;
  vittnesed_nn_1 : N ;
  vittnesgill_av_1 : A ;
  vittnesmaal_nn_1 : N ;
  vittnesskrank_nn_1 : N ;
  vittnesutsaga_nn_1 : N ;
  vittomfattande_av_1 : A ;
  vittvin_nn_1 : N ;
  vitvara_nn_1 : N ;
  vitvin_nn_1 : N ;
  viv_nn_1 : N ;
  vivace_ab_1 : Adv ;
  vivacitet_nn_1 : N ;
  vivel_nn_1 : N ;
  vivipar_av_1 : A ;
  vivisektion_nn_1 : N ;
  vivisektoer_nn_1 : N ;
  vivoer_nn_1 : N ;
  voall_nn_1 : N ;
  voerdig_av_1 : A ;
  voerdnad_nn_1 : N ;
  voerdnadsbetygelse_nn_1 : N ;
  voerdnadsbjudande_av_1 : A ;
  voerdnadsfull_av_1 : A ;
  voerdnadsvaerd_av_1 : A ;
  voerdsam_av_1 : A ;
  voerdsamligen_ab_1 : Adv ;
  voertbroed_nn_1 : N ;
  voertstyrka_nn_1 : N ;
  voidkoefficient_nn_1 : N ;
  vojlock_nn_1 : N ;
  vokabel_nn_1 : N ;
  vokabelsamling_nn_1 : N ;
  vokabulaer_nn_1 : N ;
  vokal_av_1 : A ;
  vokal_nn_1 : N ;
  vokalharmoni_nn_1 : N ;
  vokalis_nn_1 : N ;
  vokalisk_av_1 : A ;
  vokalist_nn_1 : N ;
  vokalkvalitet_nn_1 : N ;
  vokalkvantitet_nn_1 : N ;
  vokallaengd_nn_1 : N ;
  vokalmoete_nn_1 : N ;
  vokalrim_nn_1 : N ;
  vokalvaexling_nn_1 : N ;
  vokativ_nn_1 : N ;
  volang_nn_1 : N ;
  volauvent_nn_1 : N ;
  volframnaal_nn_1 : N ;
  voljaer_nn_1 : N ;
  volm_nn_1 : N ;
  volontaer_nn_1 : N ;
  volt_nn_1 : N ;
  volt_nn_2 : N ;
  voltan_nn_1 : N ;
  voltige_nn_1 : N ;
  voltigoer_nn_1 : N ;
  voltmaetare_nn_1 : N ;
  voltmeter_nn_1 : N ;
  volttal_nn_1 : N ;
  voluminoes_av_1 : A ;
  volut_nn_1 : N ;
  volym_nn_1 : N ;
  volymenhet_nn_1 : N ;
  volymmaessig_av_1 : A ;
  volymprocent_nn_1 : N ;
  volymsenhet_nn_1 : N ;
  vom_nn_1 : N ;
  vomb_nn_1 : N ;
  vombat_nn_1 : N ;
  vomitiv_nn_1 : N ;
  vorstehhund_nn_1 : N ;
  votering_nn_1 : N ;
  votivskepp_nn_1 : N ;
  votum_nn_1 : N ;
  voucher_nn_1 : N ;
  vovve_nn_1 : N ;
  voyeur_nn_1 : N ;
  vraa_nn_1 : N ;
  vraak_nn_1 : N ;
  vraal_nn_1 : N ;
  vraalaak_nn_1 : N ;
  vraalflott_av_1 : A ;
  vraang_av_1 : A ;
  vraangbild_nn_1 : N ;
  vraanghet_nn_1 : N ;
  vraangvis_av_1 : A ;
  vraekare_nn_1 : N ;
  vraekig_av_1 : A ;
  vraekning_nn_1 : N ;
  vrak_nn_1 : N ;
  vraklax_nn_1 : N ;
  vrakpris_nn_1 : N ;
  vrakspillra_nn_1 : N ;
  vred_nn_1 : N ;
  vrensk_av_1 : A ;
  vresig_av_1 : A ;
  vrestall_nn_1 : N ;
  vret_nn_1 : N ;
  vrickning_nn_1 : N ;
  vrida_vb_1 : V ;
  vridbar_av_1 : A ;
  vriden_av_1 : A ;
  vridjaernsinstrument_nn_1 : N ;
  vridmoment_nn_1 : N ;
  vridning_nn_1 : N ;
  vridningsaxel_nn_1 : N ;
  vridscen_nn_1 : N ;
  vridspoleinstrument_nn_1 : N ;
  vril_nn_1 : N ;
  vrist_nn_1 : N ;
  vristben_nn_1 : N ;
  vulgaer_av_1 : A ;
  vulgaritet_nn_1 : N ;
  vulkan_nn_1 : N ;
  vulkanisator_nn_1 : N ;
  vulkanisk_av_1 : A ;
  vulkanit_nn_1 : N ;
  vulkanutbrott_nn_1 : N ;
  vulkapparat_nn_1 : N ;
  vulst_nn_1 : N ;
  vulstig_av_1 : A ;
  vulva_nn_1 : N ;
  vurm_nn_1 : N ;
  vurst_nn_1 : N ;
  vuxen_av_1 : A ;
  vy_nn_1 : N ;
  vykort_nn_1 : N ;
  wafer_nn_1 : N ;
  wagon_nn_1 : N ;
  walesare_nn_1 : N ;
  walesisk_av_1 : A ;
  walesiska_nn_2 : N ;
  walkie_talkie_nn_1 : N ;
  wankelmotor_nn_1 : N ;
  watt_nn_1 : N ;
  wattsekund_nn_1 : N ;
  watusi_nn_1 : N ;
  watussi_nn_1 : N ;
  weekend_nn_1 : N ;
  western_nn_1 : N ;
  westernfilm_nn_1 : N ;
  whig_nn_1 : N ;
  whippet_nn_1 : N ;
  whiskysprucken_av_1 : A ;
  wienerbroed_nn_1 : N ;
  wienerkorv_nn_1 : N ;
  wienerschnitzel_nn_1 : N ;
  wienervals_nn_1 : N ;
  wigwam_nn_1 : N ;
  wire_nn_1 : N ;
  wobbler_nn_1 : N ;
  worcestersaas_nn_1 : N ;
  x1800_talsmode_nn_1 : N ;
  x60_aarsjubileum_nn_1 : N ;
  x_axel_nn_1 : N ;
  x_koordinat_nn_1 : N ;
  x_kromosom_nn_1 : N ;
  xylofon_nn_1 : N ;
  xylografi_nn_1 : N ;
  y_axel_nn_1 : N ;
  y_koordinat_nn_1 : N ;
  y_kromosom_nn_1 : N ;
  yacht_nn_1 : N ;
  yalelaas_nn_1 : N ;
  yankee_nn_1 : N ;
  yankeejib_nn_1 : N ;
  yard_nn_1 : N ;
  yawl_nn_1 : N ;
  yen_nn_1 : N ;
  yllen_av_1 : A ;
  ylletyg_nn_1 : N ;
  yllevaevnad_nn_1 : N ;
  ymnig_av_1 : A ;
  ymnighetshorn_nn_1 : N ;
  ymp_nn_1 : N ;
  ympkvist_nn_1 : N ;
  ympning_nn_1 : N ;
  ympsaar_nn_1 : N ;
  ympsnitt_nn_1 : N ;
  ympstam_nn_1 : N ;
  ymptvaang_nn_1 : N ;
  yngel_nn_1 : N ;
  yngelcell_nn_1 : N ;
  yngeldamm_nn_1 : N ;
  yngelstadium_nn_1 : N ;
  yngeltraag_nn_1 : N ;
  yngling_nn_1 : N ;
  ynglingasinne_nn_1 : N ;
  ynka_av_1 : A ;
  ynkansvaerd_av_1 : A ;
  ynkedom_nn_1 : N ;
  ynklig_av_1 : A ;
  ynkrygg_nn_1 : N ;
  ynnestbetygelse_nn_1 : N ;
  yogi_nn_1 : N ;
  ypperlig_av_1 : A ;
  yppig_av_1 : A ;
  yr_av_1 : A ;
  yrkande_nn_1 : N ;
  yrke_nn_1 : N ;
  yrkesarbetande_av_1 : A ;
  yrkesarbetare_nn_1 : N ;
  yrkesarme_nn_1 : N ;
  yrkesfoerbud_nn_1 : N ;
  yrkesfysiker_nn_1 : N ;
  yrkesgrupp_nn_1 : N ;
  yrkeshemlighet_nn_1 : N ;
  yrkesinspektion_nn_1 : N ;
  yrkeskaar_nn_1 : N ;
  yrkeskvinna_nn_1 : N ;
  yrkeslaerare_nn_1 : N ;
  yrkesmaessig_av_1 : A ;
  yrkesman_nn_1 : N ;
  yrkesorientering_nn_1 : N ;
  yrkesregister_nn_1 : N ;
  yrkessjukdom_nn_1 : N ;
  yrkesskicklig_av_1 : A ;
  yrkestitel_nn_1 : N ;
  yrkesutbildning_nn_1 : N ;
  yrkesvaegledare_nn_1 : N ;
  yrkesvaegledning_nn_1 : N ;
  yrkesval_nn_1 : N ;
  yrvaeder_nn_1 : N ;
  yrvaken_av_1 : A ;
  yster_av_1 : A ;
  ytaktiv_av_1 : A ;
  ytavvaegning_nn_1 : N ;
  ytbergart_nn_1 : N ;
  yteffekt_nn_1 : N ;
  yteld_nn_1 : N ;
  ytenhet_nn_1 : N ;
  ytform_nn_1 : N ;
  ytlager_nn_1 : N ;
  ytledes_ab_1 : Adv ;
  ytlig_av_1 : A ;
  ytmaatt_nn_1 : N ;
  ytmoraen_nn_1 : N ;
  ytskikt_nn_1 : N ;
  ytspaenning_nn_1 : N ;
  ytstruktur_nn_1 : N ;
  ytter_nn_1 : N ;
  ytterdel_nn_1 : N ;
  ytterdoerr_nn_1 : N ;
  ytterfoder_nn_1 : N ;
  ytterkant_nn_1 : N ;
  ytterlig_av_1 : A ;
  ytterligare_av_1 : A ;
  ytterlighet_nn_1 : N ;
  ytterlighetsriktning_nn_1 : N ;
  yttermarginal_nn_1 : N ;
  ytteroera_nn_1 : N ;
  ytterplagg_nn_1 : N ;
  ytterrock_nn_1 : N ;
  ytterskaer_nn_1 : N ;
  yttertak_nn_1 : N ;
  yttervaerld_nn_1 : N ;
  yttervinkel_nn_1 : N ;
  yttrande_nn_1 : N ;
  yttrandefrihet_nn_1 : N ;
  yttring_nn_1 : N ;
  yttriumoxid_nn_1 : N ;
  yttryck_nn_1 : N ;
  ytvatten_nn_1 : N ;
  ytvattenskikt_nn_1 : N ;
  ytvidd_nn_1 : N ;
  yverboren_av_1 : A ;
  yvig_av_1 : A ;
  yxaemne_nn_1 : N ;
  yxblad_nn_1 : N ;
  yxhammare_nn_1 : N ;
  yxhuvud_nn_1 : N ;
  yxskaft_nn_1 : N ;
  zairier_nn_1 : N ;
  zairisk_av_1 : A ;
  zambier_nn_1 : N ;
  zambisk_av_1 : A ;
  zefyr_nn_1 : N ;
  zelot_nn_1 : N ;
  zenitdistans_nn_1 : N ;
  zeugma_nn_1 : N ;
  zigenare_nn_1 : N ;
  zigenarkapell_nn_1 : N ;
  zigenarliv_nn_1 : N ;
  zigenarspraak_nn_1 : N ;
  zigensk_av_1 : A ;
  zimbabwier_nn_1 : N ;
  zimbabwisk_av_1 : A ;
  zinkmalm_nn_1 : N ;
  zirkon_nn_1 : N ;
  zirkoniumoxid_nn_1 : N ;
  zloty_nn_1 : N ;
  zombie_nn_1 : N ;
  zon_nn_1 : N ;
  zonroer_nn_1 : N ;
  zontariff_nn_1 : N ;
  zoo_nn_1 : N ;
  zoolog_nn_1 : N ;
  zoologisk_av_1 : A ;
  zoomobjektiv_nn_1 : N ;
  zulu_nn_1 : N ;
  zygot_nn_1 : N ;
}